#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 9
#define STATE_COUNT 3702
#define SYMBOL_COUNT 297
#define ALIAS_COUNT 6
#define TOKEN_COUNT 131
#define EXTERNAL_TOKEN_COUNT 3
#define MAX_ALIAS_SEQUENCE_LENGTH 8

enum {
  sym_raw_string_literal = 1,
  sym_float_literal = 2,
  sym_block_comment = 3,
  anon_sym_SEMI = 4,
  anon_sym_macro_rules_BANG = 5,
  anon_sym_LPAREN = 6,
  anon_sym_RPAREN = 7,
  anon_sym_LBRACE = 8,
  anon_sym_RBRACE = 9,
  anon_sym_EQ_GT = 10,
  anon_sym_LBRACK = 11,
  anon_sym_RBRACK = 12,
  anon_sym_COLON = 13,
  anon_sym_DOLLAR = 14,
  aux_sym_SLASH_LBRACK_CARET_PLUS_STAR_RBRACK_PLUS_SLASH = 15,
  anon_sym_PLUS = 16,
  anon_sym_STAR = 17,
  anon_sym_ident = 18,
  anon_sym_path = 19,
  anon_sym_expr = 20,
  anon_sym_ty = 21,
  anon_sym_pat = 22,
  anon_sym_stmt = 23,
  anon_sym_block = 24,
  anon_sym_item = 25,
  anon_sym_meta = 26,
  anon_sym_tt = 27,
  anon_sym_COMMA = 28,
  anon_sym_u8 = 29,
  anon_sym_i8 = 30,
  anon_sym_u16 = 31,
  anon_sym_i16 = 32,
  anon_sym_u32 = 33,
  anon_sym_i32 = 34,
  anon_sym_u64 = 35,
  anon_sym_i64 = 36,
  anon_sym_u128 = 37,
  anon_sym_i128 = 38,
  anon_sym_isize = 39,
  anon_sym_usize = 40,
  anon_sym_f32 = 41,
  anon_sym_f64 = 42,
  anon_sym_bool = 43,
  anon_sym_str = 44,
  anon_sym_char = 45,
  anon_sym__ = 46,
  anon_sym_AMP = 47,
  anon_sym_DASH = 48,
  anon_sym_DOT = 49,
  anon_sym_DASH_EQ = 50,
  anon_sym_DASH_GT = 51,
  anon_sym_COLON_COLON = 52,
  anon_sym_BANG = 53,
  anon_sym_BANG_EQ = 54,
  anon_sym_AT = 55,
  anon_sym_STAR_EQ = 56,
  anon_sym_SLASH = 57,
  anon_sym_SLASH_EQ = 58,
  anon_sym_AMP_AMP = 59,
  anon_sym_AMP_EQ = 60,
  anon_sym_POUND = 61,
  anon_sym_PERCENT = 62,
  anon_sym_PERCENT_EQ = 63,
  anon_sym_CARET = 64,
  anon_sym_CARET_EQ = 65,
  anon_sym_PLUS_EQ = 66,
  anon_sym_LT = 67,
  anon_sym_LT_LT = 68,
  anon_sym_LT_LT_EQ = 69,
  anon_sym_LT_EQ = 70,
  anon_sym_EQ = 71,
  anon_sym_EQ_EQ = 72,
  anon_sym_GT = 73,
  anon_sym_GT_EQ = 74,
  anon_sym_GT_GT = 75,
  anon_sym_GT_GT_EQ = 76,
  anon_sym_PIPE = 77,
  anon_sym_PIPE_EQ = 78,
  anon_sym_PIPE_PIPE = 79,
  anon_sym_TILDE = 80,
  anon_sym_QMARK = 81,
  anon_sym_SQUOTE = 82,
  anon_sym_DOT_DOT = 83,
  anon_sym_DOT_DOT_DOT = 84,
  anon_sym_as = 85,
  anon_sym_break = 86,
  anon_sym_const = 87,
  anon_sym_continue = 88,
  anon_sym_default = 89,
  anon_sym_enum = 90,
  anon_sym_fn = 91,
  anon_sym_for = 92,
  anon_sym_if = 93,
  anon_sym_impl = 94,
  anon_sym_let = 95,
  anon_sym_loop = 96,
  anon_sym_match = 97,
  anon_sym_mod = 98,
  anon_sym_pub = 99,
  anon_sym_return = 100,
  anon_sym_static = 101,
  anon_sym_struct = 102,
  anon_sym_trait = 103,
  anon_sym_type = 104,
  anon_sym_union = 105,
  anon_sym_unsafe = 106,
  anon_sym_use = 107,
  anon_sym_where = 108,
  anon_sym_while = 109,
  anon_sym_extern = 110,
  anon_sym_in = 111,
  anon_sym_dyn = 112,
  sym_mutable_specifier = 113,
  anon_sym_else = 114,
  anon_sym_move = 115,
  anon_sym_ref = 116,
  sym_integer_literal = 117,
  aux_sym_SLASHb_QMARK_DQUOTE_SLASH = 118,
  aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_RBRACK_PLUS_SLASH = 119,
  anon_sym_DQUOTE = 120,
  sym_char_literal = 121,
  sym_escape_sequence = 122,
  anon_sym_true = 123,
  anon_sym_false = 124,
  sym_line_comment = 125,
  sym_identifier = 126,
  sym_self = 127,
  sym_super = 128,
  sym_crate = 129,
  sym_metavariable = 130,
  sym_source_file = 131,
  sym__statement = 132,
  sym_empty_statement = 133,
  sym__expression_statement = 134,
  sym_macro_definition = 135,
  sym_macro_rule = 136,
  sym__token_pattern = 137,
  sym_token_tree_pattern = 138,
  sym_token_binding_pattern = 139,
  sym_token_repetition_pattern = 140,
  sym_fragment_specifier = 141,
  sym_token_tree = 142,
  sym_token_repetition = 143,
  sym_attribute_item = 144,
  sym_inner_attribute_item = 145,
  sym_meta_item = 146,
  sym_mod_item = 147,
  sym_foreign_mod_item = 148,
  sym_declaration_list = 149,
  sym_struct_item = 150,
  sym_union_item = 151,
  sym_enum_item = 152,
  sym_enum_variant_list = 153,
  sym_enum_variant = 154,
  sym_field_declaration_list = 155,
  sym_field_declaration = 156,
  sym_ordered_field_declaration_list = 157,
  sym_extern_crate_declaration = 158,
  sym_const_item = 159,
  sym_static_item = 160,
  sym_type_item = 161,
  sym_function_item = 162,
  sym_function_signature_item = 163,
  sym_function_modifiers = 164,
  sym_where_clause = 165,
  sym_where_predicate = 166,
  sym_impl_item = 167,
  sym_trait_item = 168,
  sym_associated_type = 169,
  sym_trait_bounds = 170,
  sym_higher_ranked_trait_bound = 171,
  sym_removed_trait_bound = 172,
  sym_impl_for_clause = 173,
  sym_type_parameters = 174,
  sym_constrained_type_parameter = 175,
  sym_optional_type_parameter = 176,
  sym_let_declaration = 177,
  sym_use_declaration = 178,
  sym__use_clause = 179,
  sym_scoped_use_list = 180,
  sym_use_list = 181,
  sym_use_as_clause = 182,
  sym_use_wildcard = 183,
  sym_parameters = 184,
  sym_self_parameter = 185,
  sym_variadic_parameter = 186,
  sym_parameter = 187,
  sym_extern_modifier = 188,
  sym_visibility_modifier = 189,
  sym__type = 190,
  sym_bracketed_type = 191,
  sym_qualified_type = 192,
  sym_lifetime = 193,
  sym_array_type = 194,
  sym_function_type = 195,
  sym_tuple_type = 196,
  sym_unit_type = 197,
  sym_generic_function = 198,
  sym_generic_type = 199,
  sym_generic_type_with_turbofish = 200,
  sym_bounded_type = 201,
  sym_type_arguments = 202,
  sym_type_binding = 203,
  sym_reference_type = 204,
  sym_pointer_type = 205,
  sym_empty_type = 206,
  sym_abstract_type = 207,
  sym_dynamic_type = 208,
  sym__expression = 209,
  sym_macro_invocation = 210,
  sym_scoped_identifier = 211,
  sym_scoped_type_identifier_in_expression_position = 212,
  sym_scoped_type_identifier = 213,
  sym_range_expression = 214,
  sym_unary_expression = 215,
  sym_try_expression = 216,
  sym_reference_expression = 217,
  sym_binary_expression = 218,
  sym_assignment_expression = 219,
  sym_compound_assignment_expr = 220,
  sym_type_cast_expression = 221,
  sym_return_expression = 222,
  sym_call_expression = 223,
  sym_arguments = 224,
  sym_array_expression = 225,
  sym_parenthesized_expression = 226,
  sym_tuple_expression = 227,
  sym_unit_expression = 228,
  sym_struct_expression = 229,
  sym_field_initializer_list = 230,
  sym_field_initializer = 231,
  sym_base_field_initializer = 232,
  sym_if_expression = 233,
  sym_if_let_expression = 234,
  sym_else_tail = 235,
  sym_match_expression = 236,
  sym_match_arm = 237,
  sym_last_match_arm = 238,
  sym_match_pattern = 239,
  sym_while_expression = 240,
  sym_while_let_expression = 241,
  sym_loop_expression = 242,
  sym_for_expression = 243,
  sym_closure_expression = 244,
  sym_closure_parameters = 245,
  sym_loop_label = 246,
  sym_break_expression = 247,
  sym_continue_expression = 248,
  sym_index_expression = 249,
  sym_field_expression = 250,
  sym_unsafe_block = 251,
  sym_block = 252,
  sym__pattern = 253,
  sym_tuple_pattern = 254,
  sym_tuple_pattern_in_parameter = 255,
  sym_tuple_struct_pattern = 256,
  sym_struct_pattern = 257,
  sym_field_pattern = 258,
  sym_remaining_field_pattern = 259,
  sym_mut_pattern = 260,
  sym_range_pattern = 261,
  sym_ref_pattern = 262,
  sym_captured_pattern = 263,
  sym_reference_pattern = 264,
  sym_reference_pattern_in_parameter = 265,
  sym__literal = 266,
  sym_string_literal = 267,
  sym_boolean_literal = 268,
  aux_sym_source_file_repeat1 = 269,
  aux_sym_macro_definition_repeat1 = 270,
  aux_sym_token_tree_pattern_repeat1 = 271,
  aux_sym_token_tree_repeat1 = 272,
  aux_sym_token_tree_repeat2 = 273,
  aux_sym_meta_item_repeat1 = 274,
  aux_sym_declaration_list_repeat1 = 275,
  aux_sym_enum_variant_list_repeat1 = 276,
  aux_sym_enum_variant_list_repeat2 = 277,
  aux_sym_field_declaration_list_repeat1 = 278,
  aux_sym_ordered_field_declaration_list_repeat1 = 279,
  aux_sym_function_modifiers_repeat1 = 280,
  aux_sym_where_clause_repeat1 = 281,
  aux_sym_trait_bounds_repeat1 = 282,
  aux_sym_type_parameters_repeat1 = 283,
  aux_sym_use_list_repeat1 = 284,
  aux_sym_parameters_repeat1 = 285,
  aux_sym_tuple_type_repeat1 = 286,
  aux_sym_type_arguments_repeat1 = 287,
  aux_sym_tuple_expression_repeat1 = 288,
  aux_sym_field_initializer_list_repeat1 = 289,
  aux_sym_match_expression_repeat1 = 290,
  aux_sym_match_pattern_repeat1 = 291,
  aux_sym_closure_parameters_repeat1 = 292,
  aux_sym_tuple_pattern_repeat1 = 293,
  aux_sym_tuple_pattern_in_parameter_repeat1 = 294,
  aux_sym_struct_pattern_repeat1 = 295,
  aux_sym_string_literal_repeat1 = 296,
  alias_sym_field_identifier = 297,
  alias_sym_generic_type = 298,
  alias_sym_identifier = 299,
  alias_sym_primitive_type = 300,
  alias_sym_shorthand_field_identifier = 301,
  alias_sym_type_identifier = 302,
};

static const char *ts_symbol_names[] = {
  [sym_raw_string_literal] = "raw_string_literal",
  [sym_float_literal] = "float_literal",
  [sym_block_comment] = "block_comment",
  [ts_builtin_sym_end] = "END",
  [anon_sym_SEMI] = ";",
  [anon_sym_macro_rules_BANG] = "macro_rules!",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_COLON] = ":",
  [anon_sym_DOLLAR] = "$",
  [aux_sym_SLASH_LBRACK_CARET_PLUS_STAR_RBRACK_PLUS_SLASH] = "/[^+*]+/",
  [anon_sym_PLUS] = "+",
  [anon_sym_STAR] = "*",
  [anon_sym_ident] = "ident",
  [anon_sym_path] = "path",
  [anon_sym_expr] = "expr",
  [anon_sym_ty] = "ty",
  [anon_sym_pat] = "pat",
  [anon_sym_stmt] = "stmt",
  [anon_sym_block] = "block",
  [anon_sym_item] = "item",
  [anon_sym_meta] = "meta",
  [anon_sym_tt] = "tt",
  [anon_sym_COMMA] = ",",
  [anon_sym_u8] = "u8",
  [anon_sym_i8] = "i8",
  [anon_sym_u16] = "u16",
  [anon_sym_i16] = "i16",
  [anon_sym_u32] = "u32",
  [anon_sym_i32] = "i32",
  [anon_sym_u64] = "u64",
  [anon_sym_i64] = "i64",
  [anon_sym_u128] = "u128",
  [anon_sym_i128] = "i128",
  [anon_sym_isize] = "isize",
  [anon_sym_usize] = "usize",
  [anon_sym_f32] = "f32",
  [anon_sym_f64] = "f64",
  [anon_sym_bool] = "bool",
  [anon_sym_str] = "str",
  [anon_sym_char] = "char",
  [anon_sym__] = "_",
  [anon_sym_AMP] = "&",
  [anon_sym_DASH] = "-",
  [anon_sym_DOT] = ".",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_BANG] = "!",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_AT] = "@",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH] = "/",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_POUND] = "#",
  [anon_sym_PERCENT] = "%",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET] = "^",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_LT] = "<",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ] = "=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_PIPE] = "|",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_TILDE] = "~",
  [anon_sym_QMARK] = "?",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_as] = "as",
  [anon_sym_break] = "break",
  [anon_sym_const] = "const",
  [anon_sym_continue] = "continue",
  [anon_sym_default] = "default",
  [anon_sym_enum] = "enum",
  [anon_sym_fn] = "fn",
  [anon_sym_for] = "for",
  [anon_sym_if] = "if",
  [anon_sym_impl] = "impl",
  [anon_sym_let] = "let",
  [anon_sym_loop] = "loop",
  [anon_sym_match] = "match",
  [anon_sym_mod] = "mod",
  [anon_sym_pub] = "pub",
  [anon_sym_return] = "return",
  [anon_sym_static] = "static",
  [anon_sym_struct] = "struct",
  [anon_sym_trait] = "trait",
  [anon_sym_type] = "type",
  [anon_sym_union] = "union",
  [anon_sym_unsafe] = "unsafe",
  [anon_sym_use] = "use",
  [anon_sym_where] = "where",
  [anon_sym_while] = "while",
  [anon_sym_extern] = "extern",
  [anon_sym_in] = "in",
  [anon_sym_dyn] = "dyn",
  [sym_mutable_specifier] = "mutable_specifier",
  [anon_sym_else] = "else",
  [anon_sym_move] = "move",
  [anon_sym_ref] = "ref",
  [sym_integer_literal] = "integer_literal",
  [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = "\"",
  [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_RBRACK_PLUS_SLASH] = "/[^\\\\\"]+/",
  [anon_sym_DQUOTE] = "\"",
  [sym_char_literal] = "char_literal",
  [sym_escape_sequence] = "escape_sequence",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [sym_line_comment] = "line_comment",
  [sym_identifier] = "identifier",
  [sym_self] = "self",
  [sym_super] = "super",
  [sym_crate] = "crate",
  [sym_metavariable] = "metavariable",
  [sym_source_file] = "source_file",
  [sym__statement] = "_statement",
  [sym_empty_statement] = "empty_statement",
  [sym__expression_statement] = "_expression_statement",
  [sym_macro_definition] = "macro_definition",
  [sym_macro_rule] = "macro_rule",
  [sym__token_pattern] = "_token_pattern",
  [sym_token_tree_pattern] = "token_tree_pattern",
  [sym_token_binding_pattern] = "token_binding_pattern",
  [sym_token_repetition_pattern] = "token_repetition_pattern",
  [sym_fragment_specifier] = "fragment_specifier",
  [sym_token_tree] = "token_tree",
  [sym_token_repetition] = "token_repetition",
  [sym_attribute_item] = "attribute_item",
  [sym_inner_attribute_item] = "inner_attribute_item",
  [sym_meta_item] = "meta_item",
  [sym_mod_item] = "mod_item",
  [sym_foreign_mod_item] = "foreign_mod_item",
  [sym_declaration_list] = "declaration_list",
  [sym_struct_item] = "struct_item",
  [sym_union_item] = "union_item",
  [sym_enum_item] = "enum_item",
  [sym_enum_variant_list] = "enum_variant_list",
  [sym_enum_variant] = "enum_variant",
  [sym_field_declaration_list] = "field_declaration_list",
  [sym_field_declaration] = "field_declaration",
  [sym_ordered_field_declaration_list] = "ordered_field_declaration_list",
  [sym_extern_crate_declaration] = "extern_crate_declaration",
  [sym_const_item] = "const_item",
  [sym_static_item] = "static_item",
  [sym_type_item] = "type_item",
  [sym_function_item] = "function_item",
  [sym_function_signature_item] = "function_signature_item",
  [sym_function_modifiers] = "function_modifiers",
  [sym_where_clause] = "where_clause",
  [sym_where_predicate] = "where_predicate",
  [sym_impl_item] = "impl_item",
  [sym_trait_item] = "trait_item",
  [sym_associated_type] = "associated_type",
  [sym_trait_bounds] = "trait_bounds",
  [sym_higher_ranked_trait_bound] = "higher_ranked_trait_bound",
  [sym_removed_trait_bound] = "removed_trait_bound",
  [sym_impl_for_clause] = "impl_for_clause",
  [sym_type_parameters] = "type_parameters",
  [sym_constrained_type_parameter] = "constrained_type_parameter",
  [sym_optional_type_parameter] = "optional_type_parameter",
  [sym_let_declaration] = "let_declaration",
  [sym_use_declaration] = "use_declaration",
  [sym__use_clause] = "_use_clause",
  [sym_scoped_use_list] = "scoped_use_list",
  [sym_use_list] = "use_list",
  [sym_use_as_clause] = "use_as_clause",
  [sym_use_wildcard] = "use_wildcard",
  [sym_parameters] = "parameters",
  [sym_self_parameter] = "self_parameter",
  [sym_variadic_parameter] = "variadic_parameter",
  [sym_parameter] = "parameter",
  [sym_extern_modifier] = "extern_modifier",
  [sym_visibility_modifier] = "visibility_modifier",
  [sym__type] = "_type",
  [sym_bracketed_type] = "bracketed_type",
  [sym_qualified_type] = "qualified_type",
  [sym_lifetime] = "lifetime",
  [sym_array_type] = "array_type",
  [sym_function_type] = "function_type",
  [sym_tuple_type] = "tuple_type",
  [sym_unit_type] = "unit_type",
  [sym_generic_function] = "generic_function",
  [sym_generic_type] = "generic_type",
  [sym_generic_type_with_turbofish] = "generic_type_with_turbofish",
  [sym_bounded_type] = "bounded_type",
  [sym_type_arguments] = "type_arguments",
  [sym_type_binding] = "type_binding",
  [sym_reference_type] = "reference_type",
  [sym_pointer_type] = "pointer_type",
  [sym_empty_type] = "empty_type",
  [sym_abstract_type] = "abstract_type",
  [sym_dynamic_type] = "dynamic_type",
  [sym__expression] = "_expression",
  [sym_macro_invocation] = "macro_invocation",
  [sym_scoped_identifier] = "scoped_identifier",
  [sym_scoped_type_identifier_in_expression_position] = "scoped_type_identifier",
  [sym_scoped_type_identifier] = "scoped_type_identifier",
  [sym_range_expression] = "range_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_try_expression] = "try_expression",
  [sym_reference_expression] = "reference_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_compound_assignment_expr] = "compound_assignment_expr",
  [sym_type_cast_expression] = "type_cast_expression",
  [sym_return_expression] = "return_expression",
  [sym_call_expression] = "call_expression",
  [sym_arguments] = "arguments",
  [sym_array_expression] = "array_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_tuple_expression] = "tuple_expression",
  [sym_unit_expression] = "unit_expression",
  [sym_struct_expression] = "struct_expression",
  [sym_field_initializer_list] = "field_initializer_list",
  [sym_field_initializer] = "field_initializer",
  [sym_base_field_initializer] = "base_field_initializer",
  [sym_if_expression] = "if_expression",
  [sym_if_let_expression] = "if_let_expression",
  [sym_else_tail] = "else_tail",
  [sym_match_expression] = "match_expression",
  [sym_match_arm] = "match_arm",
  [sym_last_match_arm] = "match_arm",
  [sym_match_pattern] = "match_pattern",
  [sym_while_expression] = "while_expression",
  [sym_while_let_expression] = "while_let_expression",
  [sym_loop_expression] = "loop_expression",
  [sym_for_expression] = "for_expression",
  [sym_closure_expression] = "closure_expression",
  [sym_closure_parameters] = "closure_parameters",
  [sym_loop_label] = "loop_label",
  [sym_break_expression] = "break_expression",
  [sym_continue_expression] = "continue_expression",
  [sym_index_expression] = "index_expression",
  [sym_field_expression] = "field_expression",
  [sym_unsafe_block] = "unsafe_block",
  [sym_block] = "block",
  [sym__pattern] = "_pattern",
  [sym_tuple_pattern] = "tuple_pattern",
  [sym_tuple_pattern_in_parameter] = "tuple_pattern_in_parameter",
  [sym_tuple_struct_pattern] = "tuple_struct_pattern",
  [sym_struct_pattern] = "struct_pattern",
  [sym_field_pattern] = "field_pattern",
  [sym_remaining_field_pattern] = "remaining_field_pattern",
  [sym_mut_pattern] = "mut_pattern",
  [sym_range_pattern] = "range_pattern",
  [sym_ref_pattern] = "ref_pattern",
  [sym_captured_pattern] = "captured_pattern",
  [sym_reference_pattern] = "reference_pattern",
  [sym_reference_pattern_in_parameter] = "reference_pattern",
  [sym__literal] = "_literal",
  [sym_string_literal] = "string_literal",
  [sym_boolean_literal] = "boolean_literal",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_macro_definition_repeat1] = "macro_definition_repeat1",
  [aux_sym_token_tree_pattern_repeat1] = "token_tree_pattern_repeat1",
  [aux_sym_token_tree_repeat1] = "token_tree_repeat1",
  [aux_sym_token_tree_repeat2] = "token_tree_repeat2",
  [aux_sym_meta_item_repeat1] = "meta_item_repeat1",
  [aux_sym_declaration_list_repeat1] = "declaration_list_repeat1",
  [aux_sym_enum_variant_list_repeat1] = "enum_variant_list_repeat1",
  [aux_sym_enum_variant_list_repeat2] = "enum_variant_list_repeat2",
  [aux_sym_field_declaration_list_repeat1] = "field_declaration_list_repeat1",
  [aux_sym_ordered_field_declaration_list_repeat1] = "ordered_field_declaration_list_repeat1",
  [aux_sym_function_modifiers_repeat1] = "function_modifiers_repeat1",
  [aux_sym_where_clause_repeat1] = "where_clause_repeat1",
  [aux_sym_trait_bounds_repeat1] = "trait_bounds_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [aux_sym_use_list_repeat1] = "use_list_repeat1",
  [aux_sym_parameters_repeat1] = "parameters_repeat1",
  [aux_sym_tuple_type_repeat1] = "tuple_type_repeat1",
  [aux_sym_type_arguments_repeat1] = "type_arguments_repeat1",
  [aux_sym_tuple_expression_repeat1] = "tuple_expression_repeat1",
  [aux_sym_field_initializer_list_repeat1] = "field_initializer_list_repeat1",
  [aux_sym_match_expression_repeat1] = "match_expression_repeat1",
  [aux_sym_match_pattern_repeat1] = "match_pattern_repeat1",
  [aux_sym_closure_parameters_repeat1] = "closure_parameters_repeat1",
  [aux_sym_tuple_pattern_repeat1] = "tuple_pattern_repeat1",
  [aux_sym_tuple_pattern_in_parameter_repeat1] = "tuple_pattern_in_parameter_repeat1",
  [aux_sym_struct_pattern_repeat1] = "struct_pattern_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [alias_sym_field_identifier] = "field_identifier",
  [alias_sym_generic_type] = "generic_type",
  [alias_sym_identifier] = "identifier",
  [alias_sym_primitive_type] = "primitive_type",
  [alias_sym_shorthand_field_identifier] = "shorthand_field_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [sym_raw_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_float_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_block_comment] = {
    .visible = true,
    .named = true,
  },
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_macro_rules_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_LBRACK_CARET_PLUS_STAR_RBRACK_PLUS_SLASH] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ident] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_path] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_expr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ty] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_stmt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_block] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_item] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_meta] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_tt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_i8] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u16] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_i16] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u32] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_i32] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u64] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_i64] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u128] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_i128] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_isize] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_usize] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_f32] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_f64] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bool] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_str] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_char] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_impl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_loop] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_match] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mod] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pub] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_trait] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_union] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsafe] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_use] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_where] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dyn] = {
    .visible = true,
    .named = false,
  },
  [sym_mutable_specifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_move] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ref] = {
    .visible = true,
    .named = false,
  },
  [sym_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_RBRACK_PLUS_SLASH] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_char_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_self] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_crate] = {
    .visible = true,
    .named = true,
  },
  [sym_metavariable] = {
    .visible = true,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_macro_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_rule] = {
    .visible = true,
    .named = true,
  },
  [sym__token_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_token_tree_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_token_binding_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_token_repetition_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_fragment_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_token_tree] = {
    .visible = true,
    .named = true,
  },
  [sym_token_repetition] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_item] = {
    .visible = true,
    .named = true,
  },
  [sym_inner_attribute_item] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_item] = {
    .visible = true,
    .named = true,
  },
  [sym_mod_item] = {
    .visible = true,
    .named = true,
  },
  [sym_foreign_mod_item] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_item] = {
    .visible = true,
    .named = true,
  },
  [sym_union_item] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_item] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_variant_list] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_variant] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_ordered_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_extern_crate_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_const_item] = {
    .visible = true,
    .named = true,
  },
  [sym_static_item] = {
    .visible = true,
    .named = true,
  },
  [sym_type_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_modifiers] = {
    .visible = true,
    .named = true,
  },
  [sym_where_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_where_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_impl_item] = {
    .visible = true,
    .named = true,
  },
  [sym_trait_item] = {
    .visible = true,
    .named = true,
  },
  [sym_associated_type] = {
    .visible = true,
    .named = true,
  },
  [sym_trait_bounds] = {
    .visible = true,
    .named = true,
  },
  [sym_higher_ranked_trait_bound] = {
    .visible = true,
    .named = true,
  },
  [sym_removed_trait_bound] = {
    .visible = true,
    .named = true,
  },
  [sym_impl_for_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_constrained_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_let_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_use_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__use_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_scoped_use_list] = {
    .visible = true,
    .named = true,
  },
  [sym_use_list] = {
    .visible = true,
    .named = true,
  },
  [sym_use_as_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_use_wildcard] = {
    .visible = true,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_self_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_extern_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_visibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_bracketed_type] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_type] = {
    .visible = true,
    .named = true,
  },
  [sym_lifetime] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_unit_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type_with_turbofish] = {
    .visible = true,
    .named = true,
  },
  [sym_bounded_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_type_binding] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_type] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_type] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_type] = {
    .visible = true,
    .named = true,
  },
  [sym_dynamic_type] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_macro_invocation] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_type_identifier_in_expression_position] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_range_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_try_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_assignment_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_type_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_return_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_array_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unit_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_base_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_if_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_if_let_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_else_tail] = {
    .visible = true,
    .named = true,
  },
  [sym_match_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_match_arm] = {
    .visible = true,
    .named = true,
  },
  [sym_last_match_arm] = {
    .visible = true,
    .named = true,
  },
  [sym_match_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_while_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_while_let_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_loop_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_for_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_closure_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_closure_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_loop_label] = {
    .visible = true,
    .named = true,
  },
  [sym_break_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unsafe_block] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_tuple_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_pattern_in_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_struct_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_field_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_remaining_field_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_mut_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_range_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_ref_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_captured_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_pattern_in_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_macro_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_token_tree_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_token_tree_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_token_tree_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_meta_item_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_variant_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_variant_list_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_ordered_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_modifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_where_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_trait_bounds_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_use_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_closure_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_pattern_in_parameter_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_primitive_type] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[18][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = alias_sym_identifier,
  },
  [2] = {
    [1] = alias_sym_type_identifier,
  },
  [3] = {
    [0] = alias_sym_primitive_type,
  },
  [4] = {
    [0] = alias_sym_type_identifier,
  },
  [5] = {
    [0] = alias_sym_identifier,
    [2] = alias_sym_type_identifier,
  },
  [6] = {
    [2] = alias_sym_type_identifier,
  },
  [7] = {
    [0] = alias_sym_generic_type,
  },
  [8] = {
    [0] = alias_sym_generic_type,
    [2] = alias_sym_type_identifier,
  },
  [9] = {
    [2] = alias_sym_field_identifier,
  },
  [10] = {
    [0] = alias_sym_shorthand_field_identifier,
  },
  [11] = {
    [1] = alias_sym_identifier,
  },
  [12] = {
    [1] = alias_sym_shorthand_field_identifier,
  },
  [13] = {
    [3] = alias_sym_identifier,
  },
  [14] = {
    [3] = alias_sym_type_identifier,
  },
  [15] = {
    [0] = alias_sym_field_identifier,
  },
  [16] = {
    [2] = alias_sym_shorthand_field_identifier,
  },
  [17] = {
    [1] = alias_sym_field_identifier,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == ')')
        ADVANCE(24);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == '0')
        ADVANCE(39);
      if (lookahead == ':')
        ADVANCE(60);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(67);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '@')
        ADVANCE(75);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == '\\')
        ADVANCE(77);
      if (lookahead == ']')
        ADVANCE(85);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == 'b')
        ADVANCE(88);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'e')
        ADVANCE(108);
      if (lookahead == 'f')
        ADVANCE(114);
      if (lookahead == 'i')
        ADVANCE(120);
      if (lookahead == 'm')
        ADVANCE(122);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == 't')
        ADVANCE(142);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '~')
        ADVANCE(157);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(158);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(59);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=')
        ADVANCE(3);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(7);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(sym_metavariable);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(7);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=')
        ADVANCE(9);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(11);
      if (lookahead == '=')
        ADVANCE(12);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '\\')
        ADVANCE(15);
      if (lookahead != 0)
        ADVANCE(19);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(sym_char_literal);
      END_STATE();
    case 15:
      if (lookahead == 'u')
        ADVANCE(16);
      if (lookahead == 'x')
        ADVANCE(21);
      if (lookahead != 0)
        ADVANCE(19);
      END_STATE();
    case 16:
      if (lookahead == '{')
        ADVANCE(17);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(20);
      END_STATE();
    case 17:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(18);
      END_STATE();
    case 18:
      if (lookahead == '}')
        ADVANCE(19);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(18);
      END_STATE();
    case 19:
      if (lookahead == '\'')
        ADVANCE(14);
      END_STATE();
    case 20:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(21);
      END_STATE();
    case 21:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(22);
      END_STATE();
    case 22:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(19);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=')
        ADVANCE(26);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=')
        ADVANCE(28);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=')
        ADVANCE(31);
      if (lookahead == '>')
        ADVANCE(32);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.')
        ADVANCE(34);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.')
        ADVANCE(35);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/')
        ADVANCE(37);
      if (lookahead == '=')
        ADVANCE(38);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(37);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'b')
        ADVANCE(40);
      if (lookahead == 'f')
        ADVANCE(42);
      if (lookahead == 'i')
        ADVANCE(46);
      if (lookahead == 'o')
        ADVANCE(52);
      if (lookahead == 'u')
        ADVANCE(46);
      if (lookahead == 'x')
        ADVANCE(54);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_')
        ADVANCE(59);
      END_STATE();
    case 40:
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_')
        ADVANCE(41);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'f')
        ADVANCE(42);
      if (lookahead == 'i')
        ADVANCE(46);
      if (lookahead == 'u')
        ADVANCE(46);
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_')
        ADVANCE(41);
      END_STATE();
    case 42:
      if (lookahead == '3')
        ADVANCE(43);
      if (lookahead == '6')
        ADVANCE(45);
      END_STATE();
    case 43:
      if (lookahead == '2')
        ADVANCE(44);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(sym_integer_literal);
      END_STATE();
    case 45:
      if (lookahead == '4')
        ADVANCE(44);
      END_STATE();
    case 46:
      if (lookahead == '1')
        ADVANCE(47);
      if (lookahead == '3')
        ADVANCE(43);
      if (lookahead == '6')
        ADVANCE(45);
      if (lookahead == '8')
        ADVANCE(44);
      if (lookahead == 's')
        ADVANCE(49);
      END_STATE();
    case 47:
      if (lookahead == '2')
        ADVANCE(48);
      if (lookahead == '6')
        ADVANCE(44);
      END_STATE();
    case 48:
      if (lookahead == '8')
        ADVANCE(44);
      END_STATE();
    case 49:
      if (lookahead == 'i')
        ADVANCE(50);
      END_STATE();
    case 50:
      if (lookahead == 'z')
        ADVANCE(51);
      END_STATE();
    case 51:
      if (lookahead == 'e')
        ADVANCE(44);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '7') ||
          lookahead == '_')
        ADVANCE(53);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'f')
        ADVANCE(42);
      if (lookahead == 'i')
        ADVANCE(46);
      if (lookahead == 'u')
        ADVANCE(46);
      if (('0' <= lookahead && lookahead <= '7') ||
          lookahead == '_')
        ADVANCE(53);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(55);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'f')
        ADVANCE(56);
      if (lookahead == 'i')
        ADVANCE(46);
      if (lookahead == 'u')
        ADVANCE(46);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'e'))
        ADVANCE(55);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '3')
        ADVANCE(57);
      if (lookahead == '6')
        ADVANCE(58);
      if (lookahead == 'f')
        ADVANCE(56);
      if (lookahead == 'i')
        ADVANCE(46);
      if (lookahead == 'u')
        ADVANCE(46);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'e'))
        ADVANCE(55);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '2')
        ADVANCE(55);
      if (lookahead == 'f')
        ADVANCE(56);
      if (lookahead == 'i')
        ADVANCE(46);
      if (lookahead == 'u')
        ADVANCE(46);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'e'))
        ADVANCE(55);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '4')
        ADVANCE(55);
      if (lookahead == 'f')
        ADVANCE(56);
      if (lookahead == 'i')
        ADVANCE(46);
      if (lookahead == 'u')
        ADVANCE(46);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'e'))
        ADVANCE(55);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'f')
        ADVANCE(42);
      if (lookahead == 'i')
        ADVANCE(46);
      if (lookahead == 'u')
        ADVANCE(46);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_')
        ADVANCE(59);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':')
        ADVANCE(61);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<')
        ADVANCE(64);
      if (lookahead == '=')
        ADVANCE(66);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=')
        ADVANCE(65);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(68);
      if (lookahead == '>')
        ADVANCE(69);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(71);
      if (lookahead == '>')
        ADVANCE(72);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=')
        ADVANCE(73);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 77:
      if (lookahead == 'u')
        ADVANCE(78);
      if (lookahead == 'x')
        ADVANCE(83);
      if (lookahead != 0)
        ADVANCE(81);
      END_STATE();
    case 78:
      if (lookahead == '{')
        ADVANCE(79);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(82);
      END_STATE();
    case 79:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(80);
      END_STATE();
    case 80:
      if (lookahead == '}')
        ADVANCE(81);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(80);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 82:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(83);
      END_STATE();
    case 83:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(84);
      END_STATE();
    case 84:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(81);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=')
        ADVANCE(87);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\"')
        ADVANCE(89);
      if (lookahead == '\'')
        ADVANCE(90);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(aux_sym_SLASHb_QMARK_DQUOTE_SLASH);
      END_STATE();
    case 90:
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead == '\\')
        ADVANCE(15);
      if (lookahead != 0)
        ADVANCE(19);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(93);
      if (lookahead == 'r')
        ADVANCE(97);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(94);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's')
        ADVANCE(95);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(96);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_const);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(99);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(100);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_crate);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(102);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f')
        ADVANCE(103);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(104);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u')
        ADVANCE(105);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(106);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(107);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_default);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'x')
        ADVANCE(109);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't')
        ADVANCE(110);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(111);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(112);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(113);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_extern);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(115);
      if (lookahead == 'n')
        ADVANCE(119);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(116);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's')
        ADVANCE(117);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(118);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_false);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_fn);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(121);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_in);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(123);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c')
        ADVANCE(124);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(125);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(126);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_')
        ADVANCE(127);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(128);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u')
        ADVANCE(129);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(130);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(131);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's')
        ADVANCE(132);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '!')
        ADVANCE(133);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_macro_rules_BANG);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(135);
      if (lookahead == 'u')
        ADVANCE(138);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l')
        ADVANCE(136);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f')
        ADVANCE(137);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(sym_self);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'p')
        ADVANCE(139);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(140);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(141);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(sym_super);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(143);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u')
        ADVANCE(144);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(145);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_true);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(147);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's')
        ADVANCE(148);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(149);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f')
        ADVANCE(150);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(151);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_unsafe);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=')
        ADVANCE(154);
      if (lookahead == '|')
        ADVANCE(155);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 158:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(89);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == ')')
        ADVANCE(24);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == '0')
        ADVANCE(39);
      if (lookahead == ':')
        ADVANCE(60);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(67);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '@')
        ADVANCE(75);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == ']')
        ADVANCE(85);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == 'b')
        ADVANCE(88);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'e')
        ADVANCE(108);
      if (lookahead == 'f')
        ADVANCE(114);
      if (lookahead == 'i')
        ADVANCE(120);
      if (lookahead == 'm')
        ADVANCE(122);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == 't')
        ADVANCE(142);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '~')
        ADVANCE(157);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(158);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(59);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 159:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(160);
      if (lookahead == '\"')
        ADVANCE(89);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(161);
      if (lookahead == '&')
        ADVANCE(162);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == '*')
        ADVANCE(163);
      if (lookahead == '-')
        ADVANCE(164);
      if (lookahead == '.')
        ADVANCE(165);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == '0')
        ADVANCE(39);
      if (lookahead == ':')
        ADVANCE(168);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(169);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == 'b')
        ADVANCE(88);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'e')
        ADVANCE(108);
      if (lookahead == 'f')
        ADVANCE(114);
      if (lookahead == 'm')
        ADVANCE(122);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == 't')
        ADVANCE(142);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(170);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(159);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(59);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 161:
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(7);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 165:
      if (lookahead == '.')
        ADVANCE(166);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 167:
      if (lookahead == '/')
        ADVANCE(37);
      END_STATE();
    case 168:
      if (lookahead == ':')
        ADVANCE(61);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 171:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(160);
      if (lookahead == '\"')
        ADVANCE(89);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(161);
      if (lookahead == '&')
        ADVANCE(162);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == '*')
        ADVANCE(163);
      if (lookahead == '-')
        ADVANCE(164);
      if (lookahead == '.')
        ADVANCE(165);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == '0')
        ADVANCE(39);
      if (lookahead == ':')
        ADVANCE(168);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(169);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == 'b')
        ADVANCE(88);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'e')
        ADVANCE(108);
      if (lookahead == 'f')
        ADVANCE(114);
      if (lookahead == 'm')
        ADVANCE(122);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == 't')
        ADVANCE(142);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(170);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(171);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(59);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 172:
      if (lookahead == '!')
        ADVANCE(160);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(161);
      if (lookahead == '&')
        ADVANCE(162);
      if (lookahead == '\'')
        ADVANCE(173);
      if (lookahead == '*')
        ADVANCE(163);
      if (lookahead == '+')
        ADVANCE(174);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(175);
      if (lookahead == '.')
        ADVANCE(165);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == '0')
        ADVANCE(39);
      if (lookahead == ':')
        ADVANCE(60);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(169);
      if (lookahead == '=')
        ADVANCE(176);
      if (lookahead == '>')
        ADVANCE(177);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == ']')
        ADVANCE(85);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(170);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(172);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(59);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 175:
      if (lookahead == '>')
        ADVANCE(32);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 178:
      if (lookahead == '!')
        ADVANCE(160);
      if (lookahead == '\"')
        ADVANCE(89);
      if (lookahead == '$')
        ADVANCE(161);
      if (lookahead == '&')
        ADVANCE(162);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == ')')
        ADVANCE(24);
      if (lookahead == '*')
        ADVANCE(163);
      if (lookahead == '+')
        ADVANCE(174);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(164);
      if (lookahead == '.')
        ADVANCE(165);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == '0')
        ADVANCE(39);
      if (lookahead == ':')
        ADVANCE(60);
      if (lookahead == '<')
        ADVANCE(169);
      if (lookahead == '=')
        ADVANCE(176);
      if (lookahead == '>')
        ADVANCE(177);
      if (lookahead == '@')
        ADVANCE(75);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == 'b')
        ADVANCE(88);
      if (lookahead == 'c')
        ADVANCE(179);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'f')
        ADVANCE(180);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == 't')
        ADVANCE(142);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(170);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(178);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(59);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r')
        ADVANCE(97);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a')
        ADVANCE(115);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 181:
      if (lookahead == '!')
        ADVANCE(160);
      if (lookahead == '\"')
        ADVANCE(89);
      if (lookahead == '$')
        ADVANCE(161);
      if (lookahead == '&')
        ADVANCE(162);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == '*')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(164);
      if (lookahead == '.')
        ADVANCE(165);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == '0')
        ADVANCE(39);
      if (lookahead == ':')
        ADVANCE(168);
      if (lookahead == '<')
        ADVANCE(169);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == ']')
        ADVANCE(85);
      if (lookahead == 'b')
        ADVANCE(88);
      if (lookahead == 'c')
        ADVANCE(179);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'f')
        ADVANCE(180);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == 't')
        ADVANCE(142);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(170);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(181);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(59);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 182:
      if (lookahead == '!')
        ADVANCE(160);
      if (lookahead == '\"')
        ADVANCE(89);
      if (lookahead == '$')
        ADVANCE(161);
      if (lookahead == '&')
        ADVANCE(162);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == '*')
        ADVANCE(163);
      if (lookahead == '+')
        ADVANCE(174);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(164);
      if (lookahead == '.')
        ADVANCE(165);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == '0')
        ADVANCE(39);
      if (lookahead == ':')
        ADVANCE(168);
      if (lookahead == '<')
        ADVANCE(169);
      if (lookahead == '=')
        ADVANCE(176);
      if (lookahead == '@')
        ADVANCE(75);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == 'b')
        ADVANCE(88);
      if (lookahead == 'c')
        ADVANCE(179);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'f')
        ADVANCE(180);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == 't')
        ADVANCE(142);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(170);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(182);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(59);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 183:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(173);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == ')')
        ADVANCE(24);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(184);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == ':')
        ADVANCE(168);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(185);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == ']')
        ADVANCE(85);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(183);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=')
        ADVANCE(31);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(68);
      END_STATE();
    case 186:
      if (lookahead == '!')
        ADVANCE(160);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(161);
      if (lookahead == '&')
        ADVANCE(162);
      if (lookahead == '\'')
        ADVANCE(173);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == ')')
        ADVANCE(24);
      if (lookahead == '*')
        ADVANCE(163);
      if (lookahead == '+')
        ADVANCE(174);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(175);
      if (lookahead == '.')
        ADVANCE(187);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == ':')
        ADVANCE(60);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(169);
      if (lookahead == '=')
        ADVANCE(176);
      if (lookahead == '>')
        ADVANCE(177);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '@')
        ADVANCE(75);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'e')
        ADVANCE(108);
      if (lookahead == 'f')
        ADVANCE(189);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(186);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 187:
      if (lookahead == '.')
        ADVANCE(188);
      END_STATE();
    case 188:
      if (lookahead == '.')
        ADVANCE(35);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n')
        ADVANCE(119);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 190:
      if (lookahead == '\"')
        ADVANCE(89);
      if (lookahead == '$')
        ADVANCE(161);
      if (lookahead == '&')
        ADVANCE(162);
      if (lookahead == '\'')
        ADVANCE(90);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == '.')
        ADVANCE(165);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == '0')
        ADVANCE(39);
      if (lookahead == ':')
        ADVANCE(168);
      if (lookahead == '<')
        ADVANCE(169);
      if (lookahead == 'b')
        ADVANCE(88);
      if (lookahead == 'c')
        ADVANCE(179);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'f')
        ADVANCE(180);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == 't')
        ADVANCE(142);
      if (lookahead == '|')
        ADVANCE(170);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(190);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(59);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 191:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(89);
      if (lookahead == '$')
        ADVANCE(161);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == '-')
        ADVANCE(184);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == '0')
        ADVANCE(39);
      if (lookahead == ':')
        ADVANCE(168);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(185);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == 'b')
        ADVANCE(88);
      if (lookahead == 'c')
        ADVANCE(179);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'f')
        ADVANCE(180);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == 't')
        ADVANCE(142);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(191);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(59);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 192:
      if (lookahead == ')')
        ADVANCE(24);
      if (lookahead == '+')
        ADVANCE(174);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(175);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == ':')
        ADVANCE(193);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(169);
      if (lookahead == '=')
        ADVANCE(176);
      if (lookahead == '>')
        ADVANCE(177);
      if (lookahead == 'c')
        ADVANCE(194);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'e')
        ADVANCE(108);
      if (lookahead == 'f')
        ADVANCE(189);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(170);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(192);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o')
        ADVANCE(93);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 195:
      if (lookahead == '!')
        ADVANCE(196);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == '-')
        ADVANCE(184);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(185);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == 'c')
        ADVANCE(194);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'e')
        ADVANCE(108);
      if (lookahead == 'f')
        ADVANCE(189);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(195);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 196:
      if (lookahead == '=')
        ADVANCE(3);
      END_STATE();
    case 197:
      if (lookahead == '\"')
        ADVANCE(89);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(161);
      if (lookahead == '&')
        ADVANCE(162);
      if (lookahead == '\'')
        ADVANCE(90);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == '.')
        ADVANCE(165);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == '0')
        ADVANCE(39);
      if (lookahead == ':')
        ADVANCE(168);
      if (lookahead == '<')
        ADVANCE(169);
      if (lookahead == 'b')
        ADVANCE(88);
      if (lookahead == 'c')
        ADVANCE(179);
      if (lookahead == 'f')
        ADVANCE(180);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == 't')
        ADVANCE(142);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(197);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(59);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 198:
      if (lookahead == '$')
        ADVANCE(161);
      if (lookahead == '&')
        ADVANCE(162);
      if (lookahead == '\'')
        ADVANCE(173);
      if (lookahead == '+')
        ADVANCE(174);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(175);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == ':')
        ADVANCE(168);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(169);
      if (lookahead == '=')
        ADVANCE(199);
      if (lookahead == 'c')
        ADVANCE(179);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(198);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 199:
      if (lookahead == '>')
        ADVANCE(69);
      END_STATE();
    case 200:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(184);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == ':')
        ADVANCE(168);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(185);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(200);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 201:
      if (lookahead == '\"')
        ADVANCE(89);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == ':')
        ADVANCE(193);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '=')
        ADVANCE(176);
      if (lookahead == 'b')
        ADVANCE(202);
      if (lookahead == 'c')
        ADVANCE(203);
      if (lookahead == 'd')
        ADVANCE(212);
      if (lookahead == 'e')
        ADVANCE(219);
      if (lookahead == 'f')
        ADVANCE(225);
      if (lookahead == 's')
        ADVANCE(227);
      if (lookahead == 'u')
        ADVANCE(231);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(201);
      END_STATE();
    case 202:
      if (lookahead == '\"')
        ADVANCE(89);
      END_STATE();
    case 203:
      if (lookahead == 'o')
        ADVANCE(204);
      if (lookahead == 'r')
        ADVANCE(208);
      END_STATE();
    case 204:
      if (lookahead == 'n')
        ADVANCE(205);
      END_STATE();
    case 205:
      if (lookahead == 's')
        ADVANCE(206);
      END_STATE();
    case 206:
      if (lookahead == 't')
        ADVANCE(207);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 208:
      if (lookahead == 'a')
        ADVANCE(209);
      END_STATE();
    case 209:
      if (lookahead == 't')
        ADVANCE(210);
      END_STATE();
    case 210:
      if (lookahead == 'e')
        ADVANCE(211);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(sym_crate);
      END_STATE();
    case 212:
      if (lookahead == 'e')
        ADVANCE(213);
      END_STATE();
    case 213:
      if (lookahead == 'f')
        ADVANCE(214);
      END_STATE();
    case 214:
      if (lookahead == 'a')
        ADVANCE(215);
      END_STATE();
    case 215:
      if (lookahead == 'u')
        ADVANCE(216);
      END_STATE();
    case 216:
      if (lookahead == 'l')
        ADVANCE(217);
      END_STATE();
    case 217:
      if (lookahead == 't')
        ADVANCE(218);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 219:
      if (lookahead == 'x')
        ADVANCE(220);
      END_STATE();
    case 220:
      if (lookahead == 't')
        ADVANCE(221);
      END_STATE();
    case 221:
      if (lookahead == 'e')
        ADVANCE(222);
      END_STATE();
    case 222:
      if (lookahead == 'r')
        ADVANCE(223);
      END_STATE();
    case 223:
      if (lookahead == 'n')
        ADVANCE(224);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(anon_sym_extern);
      END_STATE();
    case 225:
      if (lookahead == 'n')
        ADVANCE(226);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_fn);
      END_STATE();
    case 227:
      if (lookahead == 'e')
        ADVANCE(228);
      END_STATE();
    case 228:
      if (lookahead == 'l')
        ADVANCE(229);
      END_STATE();
    case 229:
      if (lookahead == 'f')
        ADVANCE(230);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(sym_self);
      END_STATE();
    case 231:
      if (lookahead == 'n')
        ADVANCE(232);
      END_STATE();
    case 232:
      if (lookahead == 's')
        ADVANCE(233);
      END_STATE();
    case 233:
      if (lookahead == 'a')
        ADVANCE(234);
      END_STATE();
    case 234:
      if (lookahead == 'f')
        ADVANCE(235);
      END_STATE();
    case 235:
      if (lookahead == 'e')
        ADVANCE(236);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(anon_sym_unsafe);
      END_STATE();
    case 237:
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '/')
        ADVANCE(238);
      if (lookahead == '\\')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(241);
      if (lookahead != 0)
        ADVANCE(240);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_RBRACK_PLUS_SLASH);
      if (lookahead == '/')
        ADVANCE(239);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '\\')
        ADVANCE(240);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_RBRACK_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(240);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '\\')
        ADVANCE(239);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_RBRACK_PLUS_SLASH);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '\\')
        ADVANCE(240);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_RBRACK_PLUS_SLASH);
      if (lookahead == '/')
        ADVANCE(238);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(241);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '\\')
        ADVANCE(240);
      END_STATE();
    case 242:
      if (lookahead == '!')
        ADVANCE(196);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == ')')
        ADVANCE(24);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(184);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(185);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == ']')
        ADVANCE(85);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == 'i')
        ADVANCE(120);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(242);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 243:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(243);
      END_STATE();
    case 244:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(89);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(161);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == '-')
        ADVANCE(184);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == '0')
        ADVANCE(39);
      if (lookahead == ':')
        ADVANCE(168);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(185);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == 'b')
        ADVANCE(88);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'e')
        ADVANCE(108);
      if (lookahead == 'f')
        ADVANCE(114);
      if (lookahead == 'm')
        ADVANCE(122);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == 't')
        ADVANCE(142);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(244);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(59);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 245:
      if (lookahead == '!')
        ADVANCE(160);
      if (lookahead == '\"')
        ADVANCE(89);
      if (lookahead == '$')
        ADVANCE(161);
      if (lookahead == '&')
        ADVANCE(162);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == '*')
        ADVANCE(163);
      if (lookahead == '-')
        ADVANCE(246);
      if (lookahead == '.')
        ADVANCE(165);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == '0')
        ADVANCE(39);
      if (lookahead == ':')
        ADVANCE(168);
      if (lookahead == '<')
        ADVANCE(169);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == 'b')
        ADVANCE(88);
      if (lookahead == 'c')
        ADVANCE(179);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'f')
        ADVANCE(180);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == 't')
        ADVANCE(142);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(170);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(245);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(59);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>')
        ADVANCE(32);
      END_STATE();
    case 247:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(89);
      if (lookahead == '$')
        ADVANCE(161);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == ')')
        ADVANCE(24);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(184);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == '0')
        ADVANCE(39);
      if (lookahead == ':')
        ADVANCE(168);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(185);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == 'b')
        ADVANCE(88);
      if (lookahead == 'c')
        ADVANCE(179);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'f')
        ADVANCE(180);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == 't')
        ADVANCE(142);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(247);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(59);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 248:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == ')')
        ADVANCE(24);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(184);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == ':')
        ADVANCE(168);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(185);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(248);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 249:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(89);
      if (lookahead == '$')
        ADVANCE(161);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(184);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == '0')
        ADVANCE(39);
      if (lookahead == ':')
        ADVANCE(168);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(185);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == ']')
        ADVANCE(85);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == 'b')
        ADVANCE(88);
      if (lookahead == 'c')
        ADVANCE(179);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'f')
        ADVANCE(180);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == 't')
        ADVANCE(142);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(249);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(59);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 250:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(184);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == ':')
        ADVANCE(168);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(185);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == ']')
        ADVANCE(85);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(250);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 251:
      if (lookahead == ')')
        ADVANCE(24);
      if (lookahead == '+')
        ADVANCE(174);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == ':')
        ADVANCE(60);
      if (lookahead == 'c')
        ADVANCE(194);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(251);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 252:
      if (lookahead == '!')
        ADVANCE(160);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == ')')
        ADVANCE(24);
      if (lookahead == '+')
        ADVANCE(174);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == ':')
        ADVANCE(60);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(169);
      if (lookahead == '=')
        ADVANCE(176);
      if (lookahead == '>')
        ADVANCE(177);
      if (lookahead == ']')
        ADVANCE(85);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(170);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(252);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 253:
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == ')')
        ADVANCE(24);
      if (lookahead == '+')
        ADVANCE(174);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(175);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == ':')
        ADVANCE(193);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(169);
      if (lookahead == '=')
        ADVANCE(176);
      if (lookahead == '>')
        ADVANCE(177);
      if (lookahead == ']')
        ADVANCE(85);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(170);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(253);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 254:
      if (lookahead == '\"')
        ADVANCE(89);
      if (lookahead == '$')
        ADVANCE(161);
      if (lookahead == ')')
        ADVANCE(24);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == ':')
        ADVANCE(168);
      if (lookahead == '<')
        ADVANCE(169);
      if (lookahead == ']')
        ADVANCE(85);
      if (lookahead == 'b')
        ADVANCE(255);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'e')
        ADVANCE(108);
      if (lookahead == 'f')
        ADVANCE(189);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(254);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\"')
        ADVANCE(89);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 256:
      if (lookahead == '$')
        ADVANCE(161);
      if (lookahead == ')')
        ADVANCE(24);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == ':')
        ADVANCE(168);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(169);
      if (lookahead == 'c')
        ADVANCE(179);
      if (lookahead == 'f')
        ADVANCE(189);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(256);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 257:
      if (lookahead == '$')
        ADVANCE(161);
      if (lookahead == '.')
        ADVANCE(187);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == ':')
        ADVANCE(60);
      if (lookahead == '<')
        ADVANCE(169);
      if (lookahead == '=')
        ADVANCE(199);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'e')
        ADVANCE(108);
      if (lookahead == 'f')
        ADVANCE(189);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '|')
        ADVANCE(170);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(257);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 258:
      if (lookahead == '\"')
        ADVANCE(89);
      if (lookahead == '$')
        ADVANCE(161);
      if (lookahead == '&')
        ADVANCE(162);
      if (lookahead == '\'')
        ADVANCE(90);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == ')')
        ADVANCE(24);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(165);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == '0')
        ADVANCE(39);
      if (lookahead == ':')
        ADVANCE(168);
      if (lookahead == '<')
        ADVANCE(169);
      if (lookahead == 'b')
        ADVANCE(88);
      if (lookahead == 'c')
        ADVANCE(179);
      if (lookahead == 'f')
        ADVANCE(180);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == 't')
        ADVANCE(142);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(258);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(59);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 259:
      if (lookahead == ')')
        ADVANCE(24);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == ':')
        ADVANCE(193);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '=')
        ADVANCE(176);
      if (lookahead == 'i')
        ADVANCE(260);
      if (lookahead == '|')
        ADVANCE(170);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(259);
      END_STATE();
    case 260:
      if (lookahead == 'n')
        ADVANCE(261);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 262:
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == ')')
        ADVANCE(24);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == ':')
        ADVANCE(60);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(169);
      if (lookahead == '=')
        ADVANCE(176);
      if (lookahead == 'i')
        ADVANCE(260);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(170);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(262);
      END_STATE();
    case 263:
      if (lookahead == '!')
        ADVANCE(196);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == ')')
        ADVANCE(24);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(184);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == ':')
        ADVANCE(193);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(185);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == ']')
        ADVANCE(85);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(263);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 264:
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == ':')
        ADVANCE(168);
      if (lookahead == '<')
        ADVANCE(169);
      if (lookahead == '@')
        ADVANCE(75);
      if (lookahead == 'i')
        ADVANCE(260);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(264);
      END_STATE();
    case 265:
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == 'c')
        ADVANCE(266);
      if (lookahead == 'i')
        ADVANCE(260);
      if (lookahead == 's')
        ADVANCE(267);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(265);
      END_STATE();
    case 266:
      if (lookahead == 'r')
        ADVANCE(208);
      END_STATE();
    case 267:
      if (lookahead == 'e')
        ADVANCE(228);
      if (lookahead == 'u')
        ADVANCE(268);
      END_STATE();
    case 268:
      if (lookahead == 'p')
        ADVANCE(269);
      END_STATE();
    case 269:
      if (lookahead == 'e')
        ADVANCE(270);
      END_STATE();
    case 270:
      if (lookahead == 'r')
        ADVANCE(271);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 272:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(89);
      if (lookahead == '$')
        ADVANCE(161);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(184);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == '0')
        ADVANCE(39);
      if (lookahead == ':')
        ADVANCE(168);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(185);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == 'b')
        ADVANCE(88);
      if (lookahead == 'c')
        ADVANCE(179);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'f')
        ADVANCE(180);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == 't')
        ADVANCE(142);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(272);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(59);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 273:
      if (lookahead == '!')
        ADVANCE(196);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == ')')
        ADVANCE(24);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(184);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(185);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == ']')
        ADVANCE(85);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == 'c')
        ADVANCE(194);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'e')
        ADVANCE(108);
      if (lookahead == 'f')
        ADVANCE(189);
      if (lookahead == 'i')
        ADVANCE(120);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(273);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 274:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(165);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == ':')
        ADVANCE(168);
      if (lookahead == '=')
        ADVANCE(199);
      if (lookahead == '|')
        ADVANCE(170);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(274);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 275:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '=')
        ADVANCE(176);
      if (lookahead == 'c')
        ADVANCE(194);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'e')
        ADVANCE(108);
      if (lookahead == 'f')
        ADVANCE(189);
      if (lookahead == 'm')
        ADVANCE(122);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(275);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 276:
      if (lookahead == '!')
        ADVANCE(196);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == ')')
        ADVANCE(24);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(184);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(185);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == ']')
        ADVANCE(85);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == 'c')
        ADVANCE(194);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'e')
        ADVANCE(108);
      if (lookahead == 'f')
        ADVANCE(189);
      if (lookahead == 'm')
        ADVANCE(122);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(276);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 277:
      if (lookahead == '$')
        ADVANCE(161);
      if (lookahead == '&')
        ADVANCE(162);
      if (lookahead == '\'')
        ADVANCE(173);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == ')')
        ADVANCE(24);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == ':')
        ADVANCE(168);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(169);
      if (lookahead == '=')
        ADVANCE(176);
      if (lookahead == ']')
        ADVANCE(85);
      if (lookahead == 'c')
        ADVANCE(179);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(277);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 278:
      if (lookahead == '!')
        ADVANCE(160);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == '+')
        ADVANCE(174);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == ':')
        ADVANCE(168);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(169);
      if (lookahead == '=')
        ADVANCE(199);
      if (lookahead == '@')
        ADVANCE(75);
      if (lookahead == ']')
        ADVANCE(85);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(170);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(278);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 279:
      if (lookahead == '!')
        ADVANCE(160);
      if (lookahead == '$')
        ADVANCE(161);
      if (lookahead == '&')
        ADVANCE(162);
      if (lookahead == '\'')
        ADVANCE(173);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == ')')
        ADVANCE(24);
      if (lookahead == '*')
        ADVANCE(163);
      if (lookahead == '+')
        ADVANCE(174);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == ':')
        ADVANCE(168);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(169);
      if (lookahead == '=')
        ADVANCE(176);
      if (lookahead == '>')
        ADVANCE(177);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == ']')
        ADVANCE(85);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'e')
        ADVANCE(108);
      if (lookahead == 'f')
        ADVANCE(189);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(170);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(279);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 280:
      if (lookahead == '!')
        ADVANCE(196);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == ')')
        ADVANCE(24);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(184);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == ':')
        ADVANCE(168);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(185);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(280);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 281:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(89);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(161);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == '-')
        ADVANCE(184);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == '0')
        ADVANCE(39);
      if (lookahead == ':')
        ADVANCE(168);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(185);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == 'b')
        ADVANCE(88);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'e')
        ADVANCE(108);
      if (lookahead == 'f')
        ADVANCE(114);
      if (lookahead == 'm')
        ADVANCE(122);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == 't')
        ADVANCE(142);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(281);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(59);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 282:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(89);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == ')')
        ADVANCE(24);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == '0')
        ADVANCE(39);
      if (lookahead == ':')
        ADVANCE(60);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(67);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '@')
        ADVANCE(75);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == 'b')
        ADVANCE(88);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'f')
        ADVANCE(114);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == 't')
        ADVANCE(142);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '~')
        ADVANCE(157);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(282);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(59);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 283:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(89);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == '0')
        ADVANCE(39);
      if (lookahead == ':')
        ADVANCE(60);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(67);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '@')
        ADVANCE(75);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == 'b')
        ADVANCE(88);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'e')
        ADVANCE(108);
      if (lookahead == 'f')
        ADVANCE(114);
      if (lookahead == 'm')
        ADVANCE(122);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == 't')
        ADVANCE(142);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '~')
        ADVANCE(157);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(283);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(59);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 284:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(89);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == '0')
        ADVANCE(39);
      if (lookahead == ':')
        ADVANCE(60);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(67);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '@')
        ADVANCE(75);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == ']')
        ADVANCE(85);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == 'b')
        ADVANCE(88);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'f')
        ADVANCE(114);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == 't')
        ADVANCE(142);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '~')
        ADVANCE(157);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(284);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(59);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 285:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(89);
      if (lookahead == '$')
        ADVANCE(161);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(184);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == '0')
        ADVANCE(39);
      if (lookahead == ':')
        ADVANCE(168);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(185);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == ']')
        ADVANCE(85);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == 'b')
        ADVANCE(88);
      if (lookahead == 'c')
        ADVANCE(179);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'f')
        ADVANCE(180);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == 't')
        ADVANCE(142);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(285);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(59);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 286:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(89);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == '0')
        ADVANCE(39);
      if (lookahead == ':')
        ADVANCE(60);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(67);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '@')
        ADVANCE(75);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == 'b')
        ADVANCE(88);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'f')
        ADVANCE(114);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == 't')
        ADVANCE(142);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '~')
        ADVANCE(157);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(286);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(59);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 287:
      if (lookahead == '&')
        ADVANCE(162);
      if (lookahead == ')')
        ADVANCE(24);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(187);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == '=')
        ADVANCE(199);
      if (lookahead == '|')
        ADVANCE(170);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(287);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 288:
      if (lookahead == '\"')
        ADVANCE(89);
      if (lookahead == '\'')
        ADVANCE(90);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == '0')
        ADVANCE(39);
      if (lookahead == 'b')
        ADVANCE(289);
      if (lookahead == 'f')
        ADVANCE(290);
      if (lookahead == 't')
        ADVANCE(295);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(288);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(59);
      END_STATE();
    case 289:
      if (lookahead == '\"')
        ADVANCE(89);
      if (lookahead == '\'')
        ADVANCE(90);
      END_STATE();
    case 290:
      if (lookahead == 'a')
        ADVANCE(291);
      END_STATE();
    case 291:
      if (lookahead == 'l')
        ADVANCE(292);
      END_STATE();
    case 292:
      if (lookahead == 's')
        ADVANCE(293);
      END_STATE();
    case 293:
      if (lookahead == 'e')
        ADVANCE(294);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 295:
      if (lookahead == 'r')
        ADVANCE(296);
      END_STATE();
    case 296:
      if (lookahead == 'u')
        ADVANCE(297);
      END_STATE();
    case 297:
      if (lookahead == 'e')
        ADVANCE(298);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 299:
      if (lookahead == '&')
        ADVANCE(162);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 's')
        ADVANCE(300);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(299);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e')
        ADVANCE(135);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 301:
      if (lookahead == '+')
        ADVANCE(174);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == ':')
        ADVANCE(193);
      if (lookahead == '>')
        ADVANCE(177);
      if (lookahead == 's')
        ADVANCE(300);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(301);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 302:
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '/')
        ADVANCE(167);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '=')
        ADVANCE(176);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(302);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 303:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(89);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == ')')
        ADVANCE(24);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == '0')
        ADVANCE(39);
      if (lookahead == ':')
        ADVANCE(60);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(67);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '@')
        ADVANCE(75);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == ']')
        ADVANCE(85);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == 'b')
        ADVANCE(88);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'f')
        ADVANCE(114);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == 't')
        ADVANCE(142);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '~')
        ADVANCE(157);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(303);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(59);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 304:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(89);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == ')')
        ADVANCE(24);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == '0')
        ADVANCE(39);
      if (lookahead == ':')
        ADVANCE(60);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(67);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '@')
        ADVANCE(75);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == ']')
        ADVANCE(85);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == 'b')
        ADVANCE(88);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'e')
        ADVANCE(108);
      if (lookahead == 'f')
        ADVANCE(114);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == 't')
        ADVANCE(142);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '~')
        ADVANCE(157);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(304);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(59);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 305:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(89);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == ')')
        ADVANCE(24);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == '0')
        ADVANCE(39);
      if (lookahead == ':')
        ADVANCE(60);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(67);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '@')
        ADVANCE(75);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == ']')
        ADVANCE(85);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == 'b')
        ADVANCE(88);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'f')
        ADVANCE(114);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == 't')
        ADVANCE(142);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '~')
        ADVANCE(157);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(305);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(59);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 306:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(89);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(6);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == '0')
        ADVANCE(39);
      if (lookahead == ':')
        ADVANCE(60);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(67);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '@')
        ADVANCE(75);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == 'b')
        ADVANCE(88);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'e')
        ADVANCE(108);
      if (lookahead == 'f')
        ADVANCE(114);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == 't')
        ADVANCE(142);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '~')
        ADVANCE(157);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(306);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(59);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 307:
      if (lookahead == '!')
        ADVANCE(196);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == ')')
        ADVANCE(24);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(185);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(307);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 308:
      if (lookahead == '!')
        ADVANCE(196);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(185);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(308);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 309:
      if (lookahead == '!')
        ADVANCE(196);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(185);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == ']')
        ADVANCE(85);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(309);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 310:
      if (lookahead == '!')
        ADVANCE(196);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == ')')
        ADVANCE(24);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == ';')
        ADVANCE(62);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(185);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == ']')
        ADVANCE(85);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(310);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 311:
      if (lookahead == '!')
        ADVANCE(196);
      if (lookahead == '\"')
        ADVANCE(89);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(161);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(90);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(184);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == '0')
        ADVANCE(39);
      if (lookahead == ':')
        ADVANCE(168);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(185);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == 'b')
        ADVANCE(88);
      if (lookahead == 'c')
        ADVANCE(179);
      if (lookahead == 'f')
        ADVANCE(180);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == 't')
        ADVANCE(142);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '}')
        ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(311);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(59);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 312:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(173);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == '-')
        ADVANCE(184);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == ':')
        ADVANCE(168);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(67);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(312);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 313:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(89);
      if (lookahead == '$')
        ADVANCE(161);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == '-')
        ADVANCE(184);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == '0')
        ADVANCE(39);
      if (lookahead == ':')
        ADVANCE(168);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(67);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == 'b')
        ADVANCE(88);
      if (lookahead == 'c')
        ADVANCE(179);
      if (lookahead == 'd')
        ADVANCE(101);
      if (lookahead == 'f')
        ADVANCE(180);
      if (lookahead == 's')
        ADVANCE(134);
      if (lookahead == 't')
        ADVANCE(142);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '{')
        ADVANCE(152);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(313);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(59);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    case 314:
      if (lookahead == '*')
        ADVANCE(163);
      if (lookahead == '+')
        ADVANCE(174);
      if (lookahead == '/')
        ADVANCE(315);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(318);
      if (lookahead != 0)
        ADVANCE(317);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_PLUS_STAR_RBRACK_PLUS_SLASH);
      if (lookahead == '/')
        ADVANCE(316);
      if (lookahead != 0 &&
          lookahead != '*' &&
          lookahead != '+')
        ADVANCE(317);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_PLUS_STAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(317);
      if (lookahead == '*' ||
          lookahead == '+')
        ADVANCE(37);
      if (lookahead != 0)
        ADVANCE(316);
      END_STATE();
    case 317:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_PLUS_STAR_RBRACK_PLUS_SLASH);
      if (lookahead != 0 &&
          lookahead != '*' &&
          lookahead != '+')
        ADVANCE(317);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_PLUS_STAR_RBRACK_PLUS_SLASH);
      if (lookahead == '/')
        ADVANCE(315);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(318);
      if (lookahead != 0 &&
          lookahead != '*' &&
          lookahead != '+')
        ADVANCE(317);
      END_STATE();
    case 319:
      if (lookahead == '!')
        ADVANCE(196);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '(')
        ADVANCE(23);
      if (lookahead == '*')
        ADVANCE(25);
      if (lookahead == '+')
        ADVANCE(27);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == '<')
        ADVANCE(63);
      if (lookahead == '=')
        ADVANCE(67);
      if (lookahead == '>')
        ADVANCE(70);
      if (lookahead == '?')
        ADVANCE(74);
      if (lookahead == '[')
        ADVANCE(76);
      if (lookahead == '^')
        ADVANCE(86);
      if (lookahead == '|')
        ADVANCE(153);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(319);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(91);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == '_')
        ADVANCE(1);
      if (lookahead == 'a')
        ADVANCE(2);
      if (lookahead == 'b')
        ADVANCE(4);
      if (lookahead == 'c')
        ADVANCE(16);
      if (lookahead == 'd')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(30);
      if (lookahead == 'f')
        ADVANCE(40);
      if (lookahead == 'i')
        ADVANCE(47);
      if (lookahead == 'l')
        ADVANCE(72);
      if (lookahead == 'm')
        ADVANCE(78);
      if (lookahead == 'p')
        ADVANCE(92);
      if (lookahead == 'r')
        ADVANCE(98);
      if (lookahead == 's')
        ADVANCE(105);
      if (lookahead == 't')
        ADVANCE(117);
      if (lookahead == 'u')
        ADVANCE(126);
      if (lookahead == 'w')
        ADVANCE(145);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(anon_sym__);
      END_STATE();
    case 2:
      if (lookahead == 's')
        ADVANCE(3);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_as);
      END_STATE();
    case 4:
      if (lookahead == 'l')
        ADVANCE(5);
      if (lookahead == 'o')
        ADVANCE(9);
      if (lookahead == 'r')
        ADVANCE(12);
      END_STATE();
    case 5:
      if (lookahead == 'o')
        ADVANCE(6);
      END_STATE();
    case 6:
      if (lookahead == 'c')
        ADVANCE(7);
      END_STATE();
    case 7:
      if (lookahead == 'k')
        ADVANCE(8);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(anon_sym_block);
      END_STATE();
    case 9:
      if (lookahead == 'o')
        ADVANCE(10);
      END_STATE();
    case 10:
      if (lookahead == 'l')
        ADVANCE(11);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_bool);
      END_STATE();
    case 12:
      if (lookahead == 'e')
        ADVANCE(13);
      END_STATE();
    case 13:
      if (lookahead == 'a')
        ADVANCE(14);
      END_STATE();
    case 14:
      if (lookahead == 'k')
        ADVANCE(15);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 16:
      if (lookahead == 'h')
        ADVANCE(17);
      if (lookahead == 'o')
        ADVANCE(20);
      END_STATE();
    case 17:
      if (lookahead == 'a')
        ADVANCE(18);
      END_STATE();
    case 18:
      if (lookahead == 'r')
        ADVANCE(19);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_char);
      END_STATE();
    case 20:
      if (lookahead == 'n')
        ADVANCE(21);
      END_STATE();
    case 21:
      if (lookahead == 't')
        ADVANCE(22);
      END_STATE();
    case 22:
      if (lookahead == 'i')
        ADVANCE(23);
      END_STATE();
    case 23:
      if (lookahead == 'n')
        ADVANCE(24);
      END_STATE();
    case 24:
      if (lookahead == 'u')
        ADVANCE(25);
      END_STATE();
    case 25:
      if (lookahead == 'e')
        ADVANCE(26);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 27:
      if (lookahead == 'y')
        ADVANCE(28);
      END_STATE();
    case 28:
      if (lookahead == 'n')
        ADVANCE(29);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_dyn);
      END_STATE();
    case 30:
      if (lookahead == 'l')
        ADVANCE(31);
      if (lookahead == 'n')
        ADVANCE(34);
      if (lookahead == 'x')
        ADVANCE(37);
      END_STATE();
    case 31:
      if (lookahead == 's')
        ADVANCE(32);
      END_STATE();
    case 32:
      if (lookahead == 'e')
        ADVANCE(33);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 34:
      if (lookahead == 'u')
        ADVANCE(35);
      END_STATE();
    case 35:
      if (lookahead == 'm')
        ADVANCE(36);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 37:
      if (lookahead == 'p')
        ADVANCE(38);
      END_STATE();
    case 38:
      if (lookahead == 'r')
        ADVANCE(39);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_expr);
      END_STATE();
    case 40:
      if (lookahead == '3')
        ADVANCE(41);
      if (lookahead == '6')
        ADVANCE(43);
      if (lookahead == 'o')
        ADVANCE(45);
      END_STATE();
    case 41:
      if (lookahead == '2')
        ADVANCE(42);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_f32);
      END_STATE();
    case 43:
      if (lookahead == '4')
        ADVANCE(44);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_f64);
      END_STATE();
    case 45:
      if (lookahead == 'r')
        ADVANCE(46);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 47:
      if (lookahead == '1')
        ADVANCE(48);
      if (lookahead == '3')
        ADVANCE(52);
      if (lookahead == '6')
        ADVANCE(54);
      if (lookahead == '8')
        ADVANCE(56);
      if (lookahead == 'd')
        ADVANCE(57);
      if (lookahead == 'f')
        ADVANCE(61);
      if (lookahead == 'm')
        ADVANCE(62);
      if (lookahead == 's')
        ADVANCE(65);
      if (lookahead == 't')
        ADVANCE(69);
      END_STATE();
    case 48:
      if (lookahead == '2')
        ADVANCE(49);
      if (lookahead == '6')
        ADVANCE(51);
      END_STATE();
    case 49:
      if (lookahead == '8')
        ADVANCE(50);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_i128);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_i16);
      END_STATE();
    case 52:
      if (lookahead == '2')
        ADVANCE(53);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_i32);
      END_STATE();
    case 54:
      if (lookahead == '4')
        ADVANCE(55);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_i64);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_i8);
      END_STATE();
    case 57:
      if (lookahead == 'e')
        ADVANCE(58);
      END_STATE();
    case 58:
      if (lookahead == 'n')
        ADVANCE(59);
      END_STATE();
    case 59:
      if (lookahead == 't')
        ADVANCE(60);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_ident);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 62:
      if (lookahead == 'p')
        ADVANCE(63);
      END_STATE();
    case 63:
      if (lookahead == 'l')
        ADVANCE(64);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_impl);
      END_STATE();
    case 65:
      if (lookahead == 'i')
        ADVANCE(66);
      END_STATE();
    case 66:
      if (lookahead == 'z')
        ADVANCE(67);
      END_STATE();
    case 67:
      if (lookahead == 'e')
        ADVANCE(68);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_isize);
      END_STATE();
    case 69:
      if (lookahead == 'e')
        ADVANCE(70);
      END_STATE();
    case 70:
      if (lookahead == 'm')
        ADVANCE(71);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_item);
      END_STATE();
    case 72:
      if (lookahead == 'e')
        ADVANCE(73);
      if (lookahead == 'o')
        ADVANCE(75);
      END_STATE();
    case 73:
      if (lookahead == 't')
        ADVANCE(74);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 75:
      if (lookahead == 'o')
        ADVANCE(76);
      END_STATE();
    case 76:
      if (lookahead == 'p')
        ADVANCE(77);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_loop);
      END_STATE();
    case 78:
      if (lookahead == 'a')
        ADVANCE(79);
      if (lookahead == 'e')
        ADVANCE(83);
      if (lookahead == 'o')
        ADVANCE(86);
      if (lookahead == 'u')
        ADVANCE(90);
      END_STATE();
    case 79:
      if (lookahead == 't')
        ADVANCE(80);
      END_STATE();
    case 80:
      if (lookahead == 'c')
        ADVANCE(81);
      END_STATE();
    case 81:
      if (lookahead == 'h')
        ADVANCE(82);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_match);
      END_STATE();
    case 83:
      if (lookahead == 't')
        ADVANCE(84);
      END_STATE();
    case 84:
      if (lookahead == 'a')
        ADVANCE(85);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_meta);
      END_STATE();
    case 86:
      if (lookahead == 'd')
        ADVANCE(87);
      if (lookahead == 'v')
        ADVANCE(88);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_mod);
      END_STATE();
    case 88:
      if (lookahead == 'e')
        ADVANCE(89);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_move);
      END_STATE();
    case 90:
      if (lookahead == 't')
        ADVANCE(91);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_mutable_specifier);
      END_STATE();
    case 92:
      if (lookahead == 'a')
        ADVANCE(93);
      if (lookahead == 'u')
        ADVANCE(96);
      END_STATE();
    case 93:
      if (lookahead == 't')
        ADVANCE(94);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_pat);
      if (lookahead == 'h')
        ADVANCE(95);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_path);
      END_STATE();
    case 96:
      if (lookahead == 'b')
        ADVANCE(97);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_pub);
      END_STATE();
    case 98:
      if (lookahead == 'e')
        ADVANCE(99);
      END_STATE();
    case 99:
      if (lookahead == 'f')
        ADVANCE(100);
      if (lookahead == 't')
        ADVANCE(101);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_ref);
      END_STATE();
    case 101:
      if (lookahead == 'u')
        ADVANCE(102);
      END_STATE();
    case 102:
      if (lookahead == 'r')
        ADVANCE(103);
      END_STATE();
    case 103:
      if (lookahead == 'n')
        ADVANCE(104);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 105:
      if (lookahead == 't')
        ADVANCE(106);
      END_STATE();
    case 106:
      if (lookahead == 'a')
        ADVANCE(107);
      if (lookahead == 'm')
        ADVANCE(111);
      if (lookahead == 'r')
        ADVANCE(113);
      END_STATE();
    case 107:
      if (lookahead == 't')
        ADVANCE(108);
      END_STATE();
    case 108:
      if (lookahead == 'i')
        ADVANCE(109);
      END_STATE();
    case 109:
      if (lookahead == 'c')
        ADVANCE(110);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 111:
      if (lookahead == 't')
        ADVANCE(112);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_stmt);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_str);
      if (lookahead == 'u')
        ADVANCE(114);
      END_STATE();
    case 114:
      if (lookahead == 'c')
        ADVANCE(115);
      END_STATE();
    case 115:
      if (lookahead == 't')
        ADVANCE(116);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 117:
      if (lookahead == 'r')
        ADVANCE(118);
      if (lookahead == 't')
        ADVANCE(122);
      if (lookahead == 'y')
        ADVANCE(123);
      END_STATE();
    case 118:
      if (lookahead == 'a')
        ADVANCE(119);
      END_STATE();
    case 119:
      if (lookahead == 'i')
        ADVANCE(120);
      END_STATE();
    case 120:
      if (lookahead == 't')
        ADVANCE(121);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_trait);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_tt);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_ty);
      if (lookahead == 'p')
        ADVANCE(124);
      END_STATE();
    case 124:
      if (lookahead == 'e')
        ADVANCE(125);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 126:
      if (lookahead == '1')
        ADVANCE(127);
      if (lookahead == '3')
        ADVANCE(131);
      if (lookahead == '6')
        ADVANCE(133);
      if (lookahead == '8')
        ADVANCE(135);
      if (lookahead == 'n')
        ADVANCE(136);
      if (lookahead == 's')
        ADVANCE(140);
      END_STATE();
    case 127:
      if (lookahead == '2')
        ADVANCE(128);
      if (lookahead == '6')
        ADVANCE(130);
      END_STATE();
    case 128:
      if (lookahead == '8')
        ADVANCE(129);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_u128);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_u16);
      END_STATE();
    case 131:
      if (lookahead == '2')
        ADVANCE(132);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_u32);
      END_STATE();
    case 133:
      if (lookahead == '4')
        ADVANCE(134);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_u64);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_u8);
      END_STATE();
    case 136:
      if (lookahead == 'i')
        ADVANCE(137);
      END_STATE();
    case 137:
      if (lookahead == 'o')
        ADVANCE(138);
      END_STATE();
    case 138:
      if (lookahead == 'n')
        ADVANCE(139);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_union);
      END_STATE();
    case 140:
      if (lookahead == 'e')
        ADVANCE(141);
      if (lookahead == 'i')
        ADVANCE(142);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_use);
      END_STATE();
    case 142:
      if (lookahead == 'z')
        ADVANCE(143);
      END_STATE();
    case 143:
      if (lookahead == 'e')
        ADVANCE(144);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_usize);
      END_STATE();
    case 145:
      if (lookahead == 'h')
        ADVANCE(146);
      END_STATE();
    case 146:
      if (lookahead == 'e')
        ADVANCE(147);
      if (lookahead == 'i')
        ADVANCE(150);
      END_STATE();
    case 147:
      if (lookahead == 'r')
        ADVANCE(148);
      END_STATE();
    case 148:
      if (lookahead == 'e')
        ADVANCE(149);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_where);
      END_STATE();
    case 150:
      if (lookahead == 'l')
        ADVANCE(151);
      END_STATE();
    case 151:
      if (lookahead == 'e')
        ADVANCE(152);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 159, .external_lex_state = 1},
  [2] = {.lex_state = 171, .external_lex_state = 1},
  [3] = {.lex_state = 172, .external_lex_state = 2},
  [4] = {.lex_state = 178, .external_lex_state = 1},
  [5] = {.lex_state = 171, .external_lex_state = 1},
  [6] = {.lex_state = 181, .external_lex_state = 1},
  [7] = {.lex_state = 182, .external_lex_state = 1},
  [8] = {.lex_state = 183, .external_lex_state = 2},
  [9] = {.lex_state = 182, .external_lex_state = 1},
  [10] = {.lex_state = 172, .external_lex_state = 2},
  [11] = {.lex_state = 172, .external_lex_state = 2},
  [12] = {.lex_state = 186, .external_lex_state = 2},
  [13] = {.lex_state = 190, .external_lex_state = 1},
  [14] = {.lex_state = 172, .external_lex_state = 2},
  [15] = {.lex_state = 191, .external_lex_state = 1},
  [16] = {.lex_state = 183, .external_lex_state = 2},
  [17] = {.lex_state = 192, .external_lex_state = 2},
  [18] = {.lex_state = 183, .external_lex_state = 2},
  [19] = {.lex_state = 195, .external_lex_state = 2},
  [20] = {.lex_state = 172, .external_lex_state = 2},
  [21] = {.lex_state = 172, .external_lex_state = 2},
  [22] = {.lex_state = 197, .external_lex_state = 1},
  [23] = {.lex_state = 182, .external_lex_state = 1},
  [24] = {.lex_state = 198, .external_lex_state = 2},
  [25] = {.lex_state = 197, .external_lex_state = 1},
  [26] = {.lex_state = 172, .external_lex_state = 2},
  [27] = {.lex_state = 182, .external_lex_state = 1},
  [28] = {.lex_state = 172, .external_lex_state = 2},
  [29] = {.lex_state = 195, .external_lex_state = 2},
  [30] = {.lex_state = 191, .external_lex_state = 1},
  [31] = {.lex_state = 172, .external_lex_state = 2},
  [32] = {.lex_state = 172, .external_lex_state = 2},
  [33] = {.lex_state = 172, .external_lex_state = 2},
  [34] = {.lex_state = 172, .external_lex_state = 2},
  [35] = {.lex_state = 200, .external_lex_state = 2},
  [36] = {.lex_state = 192, .external_lex_state = 2},
  [37] = {.lex_state = 198, .external_lex_state = 2},
  [38] = {.lex_state = 182, .external_lex_state = 1},
  [39] = {.lex_state = 201, .external_lex_state = 2},
  [40] = {.lex_state = 172, .external_lex_state = 2},
  [41] = {.lex_state = 237, .external_lex_state = 2},
  [42] = {.lex_state = 242, .external_lex_state = 2},
  [43] = {.lex_state = 200, .external_lex_state = 2},
  [44] = {.lex_state = 183, .external_lex_state = 2},
  [45] = {.lex_state = 172, .external_lex_state = 2},
  [46] = {.lex_state = 243, .external_lex_state = 2},
  [47] = {.lex_state = 201, .external_lex_state = 2},
  [48] = {.lex_state = 201, .external_lex_state = 2},
  [49] = {.lex_state = 192, .external_lex_state = 2},
  [50] = {.lex_state = 172, .external_lex_state = 2},
  [51] = {.lex_state = 172, .external_lex_state = 2},
  [52] = {.lex_state = 183, .external_lex_state = 2},
  [53] = {.lex_state = 244, .external_lex_state = 1},
  [54] = {.lex_state = 183, .external_lex_state = 2},
  [55] = {.lex_state = 172, .external_lex_state = 2},
  [56] = {.lex_state = 183, .external_lex_state = 2},
  [57] = {.lex_state = 244, .external_lex_state = 1},
  [58] = {.lex_state = 245, .external_lex_state = 1},
  [59] = {.lex_state = 192, .external_lex_state = 2},
  [60] = {.lex_state = 183, .external_lex_state = 2},
  [61] = {.lex_state = 159, .external_lex_state = 1},
  [62] = {.lex_state = 201, .external_lex_state = 2},
  [63] = {.lex_state = 159, .external_lex_state = 2},
  [64] = {.lex_state = 183, .external_lex_state = 2},
  [65] = {.lex_state = 171, .external_lex_state = 1},
  [66] = {.lex_state = 182, .external_lex_state = 1},
  [67] = {.lex_state = 182, .external_lex_state = 1},
  [68] = {.lex_state = 247, .external_lex_state = 1},
  [69] = {.lex_state = 183, .external_lex_state = 2},
  [70] = {.lex_state = 197, .external_lex_state = 1},
  [71] = {.lex_state = 182, .external_lex_state = 1},
  [72] = {.lex_state = 172, .external_lex_state = 2},
  [73] = {.lex_state = 182, .external_lex_state = 1},
  [74] = {.lex_state = 247, .external_lex_state = 1},
  [75] = {.lex_state = 172, .external_lex_state = 2},
  [76] = {.lex_state = 182, .external_lex_state = 1},
  [77] = {.lex_state = 172, .external_lex_state = 2},
  [78] = {.lex_state = 183, .external_lex_state = 2},
  [79] = {.lex_state = 248, .external_lex_state = 2},
  [80] = {.lex_state = 245, .external_lex_state = 1},
  [81] = {.lex_state = 192, .external_lex_state = 2},
  [82] = {.lex_state = 244, .external_lex_state = 1},
  [83] = {.lex_state = 182, .external_lex_state = 1},
  [84] = {.lex_state = 182, .external_lex_state = 1},
  [85] = {.lex_state = 191, .external_lex_state = 1},
  [86] = {.lex_state = 182, .external_lex_state = 1},
  [87] = {.lex_state = 191, .external_lex_state = 1},
  [88] = {.lex_state = 172, .external_lex_state = 2},
  [89] = {.lex_state = 200, .external_lex_state = 2},
  [90] = {.lex_state = 245, .external_lex_state = 1},
  [91] = {.lex_state = 171, .external_lex_state = 1},
  [92] = {.lex_state = 183, .external_lex_state = 2},
  [93] = {.lex_state = 182, .external_lex_state = 1},
  [94] = {.lex_state = 172, .external_lex_state = 2},
  [95] = {.lex_state = 182, .external_lex_state = 1},
  [96] = {.lex_state = 249, .external_lex_state = 1},
  [97] = {.lex_state = 182, .external_lex_state = 1},
  [98] = {.lex_state = 249, .external_lex_state = 1},
  [99] = {.lex_state = 172, .external_lex_state = 2},
  [100] = {.lex_state = 250, .external_lex_state = 2},
  [101] = {.lex_state = 245, .external_lex_state = 1},
  [102] = {.lex_state = 182, .external_lex_state = 1},
  [103] = {.lex_state = 183, .external_lex_state = 2},
  [104] = {.lex_state = 172, .external_lex_state = 2},
  [105] = {.lex_state = 182, .external_lex_state = 1},
  [106] = {.lex_state = 183, .external_lex_state = 2},
  [107] = {.lex_state = 183, .external_lex_state = 2},
  [108] = {.lex_state = 172, .external_lex_state = 2},
  [109] = {.lex_state = 172, .external_lex_state = 2},
  [110] = {.lex_state = 186, .external_lex_state = 2},
  [111] = {.lex_state = 186, .external_lex_state = 2},
  [112] = {.lex_state = 251, .external_lex_state = 2},
  [113] = {.lex_state = 252, .external_lex_state = 2},
  [114] = {.lex_state = 186, .external_lex_state = 2},
  [115] = {.lex_state = 172, .external_lex_state = 2},
  [116] = {.lex_state = 253, .external_lex_state = 2},
  [117] = {.lex_state = 172, .external_lex_state = 2},
  [118] = {.lex_state = 159, .external_lex_state = 2},
  [119] = {.lex_state = 254, .external_lex_state = 2},
  [120] = {.lex_state = 198, .external_lex_state = 2},
  [121] = {.lex_state = 252, .external_lex_state = 2},
  [122] = {.lex_state = 172, .external_lex_state = 2},
  [123] = {.lex_state = 252, .external_lex_state = 2},
  [124] = {.lex_state = 256, .external_lex_state = 2},
  [125] = {.lex_state = 172, .external_lex_state = 2},
  [126] = {.lex_state = 172, .external_lex_state = 2},
  [127] = {.lex_state = 172, .external_lex_state = 2},
  [128] = {.lex_state = 252, .external_lex_state = 2},
  [129] = {.lex_state = 172, .external_lex_state = 2},
  [130] = {.lex_state = 172, .external_lex_state = 2},
  [131] = {.lex_state = 252, .external_lex_state = 2},
  [132] = {.lex_state = 257, .external_lex_state = 2},
  [133] = {.lex_state = 258, .external_lex_state = 1},
  [134] = {.lex_state = 172, .external_lex_state = 2},
  [135] = {.lex_state = 192, .external_lex_state = 2},
  [136] = {.lex_state = 197, .external_lex_state = 1},
  [137] = {.lex_state = 172, .external_lex_state = 2},
  [138] = {.lex_state = 245, .external_lex_state = 1},
  [139] = {.lex_state = 259, .external_lex_state = 2},
  [140] = {.lex_state = 192, .external_lex_state = 2},
  [141] = {.lex_state = 190, .external_lex_state = 1},
  [142] = {.lex_state = 197, .external_lex_state = 1},
  [143] = {.lex_state = 237, .external_lex_state = 2},
  [144] = {.lex_state = 192, .external_lex_state = 2},
  [145] = {.lex_state = 178, .external_lex_state = 2},
  [146] = {.lex_state = 172, .external_lex_state = 2},
  [147] = {.lex_state = 172, .external_lex_state = 2},
  [148] = {.lex_state = 172, .external_lex_state = 2},
  [149] = {.lex_state = 172, .external_lex_state = 2},
  [150] = {.lex_state = 172, .external_lex_state = 2},
  [151] = {.lex_state = 262, .external_lex_state = 2},
  [152] = {.lex_state = 172, .external_lex_state = 2},
  [153] = {.lex_state = 192, .external_lex_state = 2},
  [154] = {.lex_state = 263, .external_lex_state = 2},
  [155] = {.lex_state = 183, .external_lex_state = 2},
  [156] = {.lex_state = 183, .external_lex_state = 2},
  [157] = {.lex_state = 192, .external_lex_state = 2},
  [158] = {.lex_state = 183, .external_lex_state = 2},
  [159] = {.lex_state = 172, .external_lex_state = 2},
  [160] = {.lex_state = 159, .external_lex_state = 2},
  [161] = {.lex_state = 172, .external_lex_state = 2},
  [162] = {.lex_state = 197, .external_lex_state = 1},
  [163] = {.lex_state = 197, .external_lex_state = 1},
  [164] = {.lex_state = 197, .external_lex_state = 1},
  [165] = {.lex_state = 264, .external_lex_state = 2},
  [166] = {.lex_state = 265, .external_lex_state = 2},
  [167] = {.lex_state = 182, .external_lex_state = 1},
  [168] = {.lex_state = 183, .external_lex_state = 2},
  [169] = {.lex_state = 182, .external_lex_state = 1},
  [170] = {.lex_state = 172, .external_lex_state = 2},
  [171] = {.lex_state = 272, .external_lex_state = 1},
  [172] = {.lex_state = 182, .external_lex_state = 1},
  [173] = {.lex_state = 197, .external_lex_state = 1},
  [174] = {.lex_state = 272, .external_lex_state = 1},
  [175] = {.lex_state = 172, .external_lex_state = 2},
  [176] = {.lex_state = 183, .external_lex_state = 2},
  [177] = {.lex_state = 183, .external_lex_state = 2},
  [178] = {.lex_state = 172, .external_lex_state = 2},
  [179] = {.lex_state = 172, .external_lex_state = 2},
  [180] = {.lex_state = 183, .external_lex_state = 2},
  [181] = {.lex_state = 183, .external_lex_state = 2},
  [182] = {.lex_state = 245, .external_lex_state = 1},
  [183] = {.lex_state = 172, .external_lex_state = 2},
  [184] = {.lex_state = 186, .external_lex_state = 2},
  [185] = {.lex_state = 172, .external_lex_state = 2},
  [186] = {.lex_state = 198, .external_lex_state = 2},
  [187] = {.lex_state = 172, .external_lex_state = 2},
  [188] = {.lex_state = 197, .external_lex_state = 1},
  [189] = {.lex_state = 197, .external_lex_state = 1},
  [190] = {.lex_state = 197, .external_lex_state = 1},
  [191] = {.lex_state = 186, .external_lex_state = 2},
  [192] = {.lex_state = 192, .external_lex_state = 2},
  [193] = {.lex_state = 244, .external_lex_state = 1},
  [194] = {.lex_state = 183, .external_lex_state = 2},
  [195] = {.lex_state = 172, .external_lex_state = 2},
  [196] = {.lex_state = 265, .external_lex_state = 2},
  [197] = {.lex_state = 183, .external_lex_state = 2},
  [198] = {.lex_state = 172, .external_lex_state = 2},
  [199] = {.lex_state = 192, .external_lex_state = 2},
  [200] = {.lex_state = 252, .external_lex_state = 2},
  [201] = {.lex_state = 192, .external_lex_state = 2},
  [202] = {.lex_state = 192, .external_lex_state = 2},
  [203] = {.lex_state = 252, .external_lex_state = 2},
  [204] = {.lex_state = 198, .external_lex_state = 2},
  [205] = {.lex_state = 244, .external_lex_state = 1},
  [206] = {.lex_state = 198, .external_lex_state = 2},
  [207] = {.lex_state = 172, .external_lex_state = 2},
  [208] = {.lex_state = 172, .external_lex_state = 2},
  [209] = {.lex_state = 172, .external_lex_state = 2},
  [210] = {.lex_state = 172, .external_lex_state = 2},
  [211] = {.lex_state = 172, .external_lex_state = 2},
  [212] = {.lex_state = 172, .external_lex_state = 2},
  [213] = {.lex_state = 172, .external_lex_state = 2},
  [214] = {.lex_state = 197, .external_lex_state = 1},
  [215] = {.lex_state = 183, .external_lex_state = 2},
  [216] = {.lex_state = 172, .external_lex_state = 2},
  [217] = {.lex_state = 201, .external_lex_state = 2},
  [218] = {.lex_state = 245, .external_lex_state = 1},
  [219] = {.lex_state = 273, .external_lex_state = 2},
  [220] = {.lex_state = 237, .external_lex_state = 2},
  [221] = {.lex_state = 274, .external_lex_state = 2},
  [222] = {.lex_state = 172, .external_lex_state = 2},
  [223] = {.lex_state = 159, .external_lex_state = 2},
  [224] = {.lex_state = 183, .external_lex_state = 2},
  [225] = {.lex_state = 172, .external_lex_state = 2},
  [226] = {.lex_state = 172, .external_lex_state = 2},
  [227] = {.lex_state = 171, .external_lex_state = 1},
  [228] = {.lex_state = 275, .external_lex_state = 2},
  [229] = {.lex_state = 192, .external_lex_state = 2},
  [230] = {.lex_state = 172, .external_lex_state = 2},
  [231] = {.lex_state = 172, .external_lex_state = 2},
  [232] = {.lex_state = 172, .external_lex_state = 2},
  [233] = {.lex_state = 172, .external_lex_state = 2},
  [234] = {.lex_state = 172, .external_lex_state = 2},
  [235] = {.lex_state = 172, .external_lex_state = 2},
  [236] = {.lex_state = 172, .external_lex_state = 2},
  [237] = {.lex_state = 198, .external_lex_state = 2},
  [238] = {.lex_state = 201, .external_lex_state = 2},
  [239] = {.lex_state = 201, .external_lex_state = 2},
  [240] = {.lex_state = 201, .external_lex_state = 2},
  [241] = {.lex_state = 172, .external_lex_state = 2},
  [242] = {.lex_state = 172, .external_lex_state = 2},
  [243] = {.lex_state = 183, .external_lex_state = 2},
  [244] = {.lex_state = 171, .external_lex_state = 1},
  [245] = {.lex_state = 178, .external_lex_state = 1},
  [246] = {.lex_state = 182, .external_lex_state = 1},
  [247] = {.lex_state = 182, .external_lex_state = 1},
  [248] = {.lex_state = 182, .external_lex_state = 1},
  [249] = {.lex_state = 182, .external_lex_state = 1},
  [250] = {.lex_state = 172, .external_lex_state = 2},
  [251] = {.lex_state = 182, .external_lex_state = 1},
  [252] = {.lex_state = 182, .external_lex_state = 1},
  [253] = {.lex_state = 182, .external_lex_state = 1},
  [254] = {.lex_state = 182, .external_lex_state = 1},
  [255] = {.lex_state = 182, .external_lex_state = 1},
  [256] = {.lex_state = 182, .external_lex_state = 1},
  [257] = {.lex_state = 182, .external_lex_state = 1},
  [258] = {.lex_state = 182, .external_lex_state = 1},
  [259] = {.lex_state = 183, .external_lex_state = 2},
  [260] = {.lex_state = 191, .external_lex_state = 1},
  [261] = {.lex_state = 182, .external_lex_state = 1},
  [262] = {.lex_state = 186, .external_lex_state = 2},
  [263] = {.lex_state = 183, .external_lex_state = 2},
  [264] = {.lex_state = 172, .external_lex_state = 2},
  [265] = {.lex_state = 186, .external_lex_state = 2},
  [266] = {.lex_state = 183, .external_lex_state = 2},
  [267] = {.lex_state = 172, .external_lex_state = 2},
  [268] = {.lex_state = 172, .external_lex_state = 2},
  [269] = {.lex_state = 159, .external_lex_state = 1},
  [270] = {.lex_state = 201, .external_lex_state = 2},
  [271] = {.lex_state = 201, .external_lex_state = 2},
  [272] = {.lex_state = 178, .external_lex_state = 2},
  [273] = {.lex_state = 171, .external_lex_state = 2},
  [274] = {.lex_state = 276, .external_lex_state = 2},
  [275] = {.lex_state = 200, .external_lex_state = 2},
  [276] = {.lex_state = 171, .external_lex_state = 1},
  [277] = {.lex_state = 182, .external_lex_state = 1},
  [278] = {.lex_state = 248, .external_lex_state = 2},
  [279] = {.lex_state = 265, .external_lex_state = 2},
  [280] = {.lex_state = 197, .external_lex_state = 1},
  [281] = {.lex_state = 183, .external_lex_state = 2},
  [282] = {.lex_state = 183, .external_lex_state = 2},
  [283] = {.lex_state = 183, .external_lex_state = 2},
  [284] = {.lex_state = 248, .external_lex_state = 2},
  [285] = {.lex_state = 183, .external_lex_state = 2},
  [286] = {.lex_state = 197, .external_lex_state = 1},
  [287] = {.lex_state = 183, .external_lex_state = 2},
  [288] = {.lex_state = 245, .external_lex_state = 1},
  [289] = {.lex_state = 159, .external_lex_state = 2},
  [290] = {.lex_state = 183, .external_lex_state = 2},
  [291] = {.lex_state = 182, .external_lex_state = 1},
  [292] = {.lex_state = 182, .external_lex_state = 1},
  [293] = {.lex_state = 178, .external_lex_state = 1},
  [294] = {.lex_state = 182, .external_lex_state = 1},
  [295] = {.lex_state = 182, .external_lex_state = 1},
  [296] = {.lex_state = 182, .external_lex_state = 1},
  [297] = {.lex_state = 182, .external_lex_state = 1},
  [298] = {.lex_state = 182, .external_lex_state = 1},
  [299] = {.lex_state = 182, .external_lex_state = 1},
  [300] = {.lex_state = 182, .external_lex_state = 1},
  [301] = {.lex_state = 182, .external_lex_state = 1},
  [302] = {.lex_state = 182, .external_lex_state = 1},
  [303] = {.lex_state = 247, .external_lex_state = 1},
  [304] = {.lex_state = 182, .external_lex_state = 1},
  [305] = {.lex_state = 186, .external_lex_state = 2},
  [306] = {.lex_state = 248, .external_lex_state = 2},
  [307] = {.lex_state = 172, .external_lex_state = 2},
  [308] = {.lex_state = 182, .external_lex_state = 1},
  [309] = {.lex_state = 182, .external_lex_state = 1},
  [310] = {.lex_state = 200, .external_lex_state = 2},
  [311] = {.lex_state = 197, .external_lex_state = 1},
  [312] = {.lex_state = 183, .external_lex_state = 2},
  [313] = {.lex_state = 200, .external_lex_state = 2},
  [314] = {.lex_state = 245, .external_lex_state = 1},
  [315] = {.lex_state = 244, .external_lex_state = 1},
  [316] = {.lex_state = 182, .external_lex_state = 1},
  [317] = {.lex_state = 182, .external_lex_state = 1},
  [318] = {.lex_state = 182, .external_lex_state = 1},
  [319] = {.lex_state = 182, .external_lex_state = 1},
  [320] = {.lex_state = 182, .external_lex_state = 1},
  [321] = {.lex_state = 182, .external_lex_state = 1},
  [322] = {.lex_state = 182, .external_lex_state = 1},
  [323] = {.lex_state = 182, .external_lex_state = 1},
  [324] = {.lex_state = 182, .external_lex_state = 1},
  [325] = {.lex_state = 182, .external_lex_state = 1},
  [326] = {.lex_state = 182, .external_lex_state = 1},
  [327] = {.lex_state = 191, .external_lex_state = 1},
  [328] = {.lex_state = 182, .external_lex_state = 1},
  [329] = {.lex_state = 186, .external_lex_state = 2},
  [330] = {.lex_state = 200, .external_lex_state = 2},
  [331] = {.lex_state = 200, .external_lex_state = 2},
  [332] = {.lex_state = 171, .external_lex_state = 1},
  [333] = {.lex_state = 183, .external_lex_state = 2},
  [334] = {.lex_state = 182, .external_lex_state = 1},
  [335] = {.lex_state = 250, .external_lex_state = 2},
  [336] = {.lex_state = 197, .external_lex_state = 1},
  [337] = {.lex_state = 183, .external_lex_state = 2},
  [338] = {.lex_state = 250, .external_lex_state = 2},
  [339] = {.lex_state = 245, .external_lex_state = 1},
  [340] = {.lex_state = 182, .external_lex_state = 1},
  [341] = {.lex_state = 182, .external_lex_state = 1},
  [342] = {.lex_state = 182, .external_lex_state = 1},
  [343] = {.lex_state = 181, .external_lex_state = 1},
  [344] = {.lex_state = 182, .external_lex_state = 1},
  [345] = {.lex_state = 182, .external_lex_state = 1},
  [346] = {.lex_state = 182, .external_lex_state = 1},
  [347] = {.lex_state = 182, .external_lex_state = 1},
  [348] = {.lex_state = 182, .external_lex_state = 1},
  [349] = {.lex_state = 182, .external_lex_state = 1},
  [350] = {.lex_state = 182, .external_lex_state = 1},
  [351] = {.lex_state = 182, .external_lex_state = 1},
  [352] = {.lex_state = 182, .external_lex_state = 1},
  [353] = {.lex_state = 249, .external_lex_state = 1},
  [354] = {.lex_state = 182, .external_lex_state = 1},
  [355] = {.lex_state = 186, .external_lex_state = 2},
  [356] = {.lex_state = 172, .external_lex_state = 2},
  [357] = {.lex_state = 250, .external_lex_state = 2},
  [358] = {.lex_state = 197, .external_lex_state = 1},
  [359] = {.lex_state = 183, .external_lex_state = 2},
  [360] = {.lex_state = 183, .external_lex_state = 2},
  [361] = {.lex_state = 183, .external_lex_state = 2},
  [362] = {.lex_state = 277, .external_lex_state = 2},
  [363] = {.lex_state = 172, .external_lex_state = 2},
  [364] = {.lex_state = 172, .external_lex_state = 2},
  [365] = {.lex_state = 253, .external_lex_state = 2},
  [366] = {.lex_state = 251, .external_lex_state = 2},
  [367] = {.lex_state = 186, .external_lex_state = 2},
  [368] = {.lex_state = 159, .external_lex_state = 2},
  [369] = {.lex_state = 178, .external_lex_state = 2},
  [370] = {.lex_state = 256, .external_lex_state = 2},
  [371] = {.lex_state = 192, .external_lex_state = 2},
  [372] = {.lex_state = 172, .external_lex_state = 2},
  [373] = {.lex_state = 178, .external_lex_state = 2},
  [374] = {.lex_state = 251, .external_lex_state = 2},
  [375] = {.lex_state = 186, .external_lex_state = 2},
  [376] = {.lex_state = 159, .external_lex_state = 2},
  [377] = {.lex_state = 278, .external_lex_state = 2},
  [378] = {.lex_state = 256, .external_lex_state = 2},
  [379] = {.lex_state = 172, .external_lex_state = 2},
  [380] = {.lex_state = 172, .external_lex_state = 2},
  [381] = {.lex_state = 278, .external_lex_state = 2},
  [382] = {.lex_state = 186, .external_lex_state = 2},
  [383] = {.lex_state = 172, .external_lex_state = 2},
  [384] = {.lex_state = 186, .external_lex_state = 2},
  [385] = {.lex_state = 253, .external_lex_state = 2},
  [386] = {.lex_state = 186, .external_lex_state = 2},
  [387] = {.lex_state = 252, .external_lex_state = 2},
  [388] = {.lex_state = 279, .external_lex_state = 2},
  [389] = {.lex_state = 186, .external_lex_state = 2},
  [390] = {.lex_state = 172, .external_lex_state = 2},
  [391] = {.lex_state = 237, .external_lex_state = 2},
  [392] = {.lex_state = 257, .external_lex_state = 2},
  [393] = {.lex_state = 252, .external_lex_state = 2},
  [394] = {.lex_state = 252, .external_lex_state = 2},
  [395] = {.lex_state = 253, .external_lex_state = 2},
  [396] = {.lex_state = 172, .external_lex_state = 2},
  [397] = {.lex_state = 159, .external_lex_state = 2},
  [398] = {.lex_state = 186, .external_lex_state = 2},
  [399] = {.lex_state = 172, .external_lex_state = 2},
  [400] = {.lex_state = 252, .external_lex_state = 2},
  [401] = {.lex_state = 172, .external_lex_state = 2},
  [402] = {.lex_state = 159, .external_lex_state = 2},
  [403] = {.lex_state = 159, .external_lex_state = 2},
  [404] = {.lex_state = 159, .external_lex_state = 2},
  [405] = {.lex_state = 186, .external_lex_state = 2},
  [406] = {.lex_state = 172, .external_lex_state = 2},
  [407] = {.lex_state = 186, .external_lex_state = 2},
  [408] = {.lex_state = 186, .external_lex_state = 2},
  [409] = {.lex_state = 172, .external_lex_state = 2},
  [410] = {.lex_state = 172, .external_lex_state = 2},
  [411] = {.lex_state = 172, .external_lex_state = 2},
  [412] = {.lex_state = 252, .external_lex_state = 2},
  [413] = {.lex_state = 257, .external_lex_state = 2},
  [414] = {.lex_state = 259, .external_lex_state = 2},
  [415] = {.lex_state = 192, .external_lex_state = 2},
  [416] = {.lex_state = 197, .external_lex_state = 1},
  [417] = {.lex_state = 197, .external_lex_state = 1},
  [418] = {.lex_state = 197, .external_lex_state = 1},
  [419] = {.lex_state = 178, .external_lex_state = 2},
  [420] = {.lex_state = 192, .external_lex_state = 2},
  [421] = {.lex_state = 186, .external_lex_state = 2},
  [422] = {.lex_state = 172, .external_lex_state = 2},
  [423] = {.lex_state = 186, .external_lex_state = 2},
  [424] = {.lex_state = 258, .external_lex_state = 1},
  [425] = {.lex_state = 197, .external_lex_state = 1},
  [426] = {.lex_state = 197, .external_lex_state = 1},
  [427] = {.lex_state = 178, .external_lex_state = 2},
  [428] = {.lex_state = 259, .external_lex_state = 2},
  [429] = {.lex_state = 192, .external_lex_state = 2},
  [430] = {.lex_state = 262, .external_lex_state = 2},
  [431] = {.lex_state = 172, .external_lex_state = 2},
  [432] = {.lex_state = 192, .external_lex_state = 2},
  [433] = {.lex_state = 197, .external_lex_state = 1},
  [434] = {.lex_state = 192, .external_lex_state = 2},
  [435] = {.lex_state = 197, .external_lex_state = 1},
  [436] = {.lex_state = 178, .external_lex_state = 2},
  [437] = {.lex_state = 172, .external_lex_state = 2},
  [438] = {.lex_state = 259, .external_lex_state = 2},
  [439] = {.lex_state = 192, .external_lex_state = 2},
  [440] = {.lex_state = 178, .external_lex_state = 2},
  [441] = {.lex_state = 259, .external_lex_state = 2},
  [442] = {.lex_state = 192, .external_lex_state = 2},
  [443] = {.lex_state = 237, .external_lex_state = 2},
  [444] = {.lex_state = 258, .external_lex_state = 1},
  [445] = {.lex_state = 274, .external_lex_state = 2},
  [446] = {.lex_state = 172, .external_lex_state = 2},
  [447] = {.lex_state = 197, .external_lex_state = 1},
  [448] = {.lex_state = 172, .external_lex_state = 2},
  [449] = {.lex_state = 190, .external_lex_state = 1},
  [450] = {.lex_state = 245, .external_lex_state = 1},
  [451] = {.lex_state = 172, .external_lex_state = 2},
  [452] = {.lex_state = 172, .external_lex_state = 2},
  [453] = {.lex_state = 172, .external_lex_state = 2},
  [454] = {.lex_state = 274, .external_lex_state = 2},
  [455] = {.lex_state = 186, .external_lex_state = 2},
  [456] = {.lex_state = 274, .external_lex_state = 2},
  [457] = {.lex_state = 172, .external_lex_state = 2},
  [458] = {.lex_state = 198, .external_lex_state = 2},
  [459] = {.lex_state = 171, .external_lex_state = 1},
  [460] = {.lex_state = 172, .external_lex_state = 2},
  [461] = {.lex_state = 172, .external_lex_state = 2},
  [462] = {.lex_state = 159, .external_lex_state = 2},
  [463] = {.lex_state = 172, .external_lex_state = 2},
  [464] = {.lex_state = 197, .external_lex_state = 1},
  [465] = {.lex_state = 197, .external_lex_state = 1},
  [466] = {.lex_state = 182, .external_lex_state = 1},
  [467] = {.lex_state = 172, .external_lex_state = 2},
  [468] = {.lex_state = 182, .external_lex_state = 1},
  [469] = {.lex_state = 280, .external_lex_state = 2},
  [470] = {.lex_state = 183, .external_lex_state = 2},
  [471] = {.lex_state = 197, .external_lex_state = 1},
  [472] = {.lex_state = 183, .external_lex_state = 2},
  [473] = {.lex_state = 197, .external_lex_state = 1},
  [474] = {.lex_state = 197, .external_lex_state = 1},
  [475] = {.lex_state = 197, .external_lex_state = 1},
  [476] = {.lex_state = 178, .external_lex_state = 2},
  [477] = {.lex_state = 172, .external_lex_state = 2},
  [478] = {.lex_state = 183, .external_lex_state = 2},
  [479] = {.lex_state = 245, .external_lex_state = 1},
  [480] = {.lex_state = 172, .external_lex_state = 2},
  [481] = {.lex_state = 172, .external_lex_state = 2},
  [482] = {.lex_state = 172, .external_lex_state = 2},
  [483] = {.lex_state = 182, .external_lex_state = 1},
  [484] = {.lex_state = 182, .external_lex_state = 1},
  [485] = {.lex_state = 182, .external_lex_state = 1},
  [486] = {.lex_state = 182, .external_lex_state = 1},
  [487] = {.lex_state = 182, .external_lex_state = 1},
  [488] = {.lex_state = 182, .external_lex_state = 1},
  [489] = {.lex_state = 182, .external_lex_state = 1},
  [490] = {.lex_state = 182, .external_lex_state = 1},
  [491] = {.lex_state = 182, .external_lex_state = 1},
  [492] = {.lex_state = 182, .external_lex_state = 1},
  [493] = {.lex_state = 182, .external_lex_state = 1},
  [494] = {.lex_state = 272, .external_lex_state = 1},
  [495] = {.lex_state = 182, .external_lex_state = 1},
  [496] = {.lex_state = 186, .external_lex_state = 2},
  [497] = {.lex_state = 281, .external_lex_state = 1},
  [498] = {.lex_state = 172, .external_lex_state = 2},
  [499] = {.lex_state = 183, .external_lex_state = 2},
  [500] = {.lex_state = 172, .external_lex_state = 2},
  [501] = {.lex_state = 252, .external_lex_state = 2},
  [502] = {.lex_state = 172, .external_lex_state = 2},
  [503] = {.lex_state = 172, .external_lex_state = 2},
  [504] = {.lex_state = 172, .external_lex_state = 2},
  [505] = {.lex_state = 192, .external_lex_state = 2},
  [506] = {.lex_state = 186, .external_lex_state = 2},
  [507] = {.lex_state = 171, .external_lex_state = 1},
  [508] = {.lex_state = 172, .external_lex_state = 2},
  [509] = {.lex_state = 172, .external_lex_state = 2},
  [510] = {.lex_state = 172, .external_lex_state = 2},
  [511] = {.lex_state = 172, .external_lex_state = 2},
  [512] = {.lex_state = 172, .external_lex_state = 2},
  [513] = {.lex_state = 171, .external_lex_state = 1},
  [514] = {.lex_state = 172, .external_lex_state = 2},
  [515] = {.lex_state = 172, .external_lex_state = 2},
  [516] = {.lex_state = 172, .external_lex_state = 2},
  [517] = {.lex_state = 197, .external_lex_state = 1},
  [518] = {.lex_state = 197, .external_lex_state = 1},
  [519] = {.lex_state = 192, .external_lex_state = 2},
  [520] = {.lex_state = 197, .external_lex_state = 1},
  [521] = {.lex_state = 171, .external_lex_state = 1},
  [522] = {.lex_state = 186, .external_lex_state = 2},
  [523] = {.lex_state = 182, .external_lex_state = 1},
  [524] = {.lex_state = 197, .external_lex_state = 1},
  [525] = {.lex_state = 171, .external_lex_state = 1},
  [526] = {.lex_state = 198, .external_lex_state = 2},
  [527] = {.lex_state = 192, .external_lex_state = 2},
  [528] = {.lex_state = 192, .external_lex_state = 2},
  [529] = {.lex_state = 186, .external_lex_state = 2},
  [530] = {.lex_state = 171, .external_lex_state = 1},
  [531] = {.lex_state = 186, .external_lex_state = 2},
  [532] = {.lex_state = 274, .external_lex_state = 2},
  [533] = {.lex_state = 198, .external_lex_state = 2},
  [534] = {.lex_state = 172, .external_lex_state = 2},
  [535] = {.lex_state = 159, .external_lex_state = 2},
  [536] = {.lex_state = 183, .external_lex_state = 2},
  [537] = {.lex_state = 186, .external_lex_state = 2},
  [538] = {.lex_state = 172, .external_lex_state = 2},
  [539] = {.lex_state = 171, .external_lex_state = 1},
  [540] = {.lex_state = 172, .external_lex_state = 2},
  [541] = {.lex_state = 192, .external_lex_state = 2},
  [542] = {.lex_state = 171, .external_lex_state = 1},
  [543] = {.lex_state = 186, .external_lex_state = 2},
  [544] = {.lex_state = 186, .external_lex_state = 2},
  [545] = {.lex_state = 172, .external_lex_state = 2},
  [546] = {.lex_state = 172, .external_lex_state = 2},
  [547] = {.lex_state = 171, .external_lex_state = 1},
  [548] = {.lex_state = 172, .external_lex_state = 2},
  [549] = {.lex_state = 159, .external_lex_state = 2},
  [550] = {.lex_state = 183, .external_lex_state = 2},
  [551] = {.lex_state = 198, .external_lex_state = 2},
  [552] = {.lex_state = 198, .external_lex_state = 2},
  [553] = {.lex_state = 198, .external_lex_state = 2},
  [554] = {.lex_state = 274, .external_lex_state = 2},
  [555] = {.lex_state = 172, .external_lex_state = 2},
  [556] = {.lex_state = 274, .external_lex_state = 2},
  [557] = {.lex_state = 274, .external_lex_state = 2},
  [558] = {.lex_state = 198, .external_lex_state = 2},
  [559] = {.lex_state = 274, .external_lex_state = 2},
  [560] = {.lex_state = 172, .external_lex_state = 2},
  [561] = {.lex_state = 172, .external_lex_state = 2},
  [562] = {.lex_state = 172, .external_lex_state = 2},
  [563] = {.lex_state = 172, .external_lex_state = 2},
  [564] = {.lex_state = 172, .external_lex_state = 2},
  [565] = {.lex_state = 172, .external_lex_state = 2},
  [566] = {.lex_state = 171, .external_lex_state = 1},
  [567] = {.lex_state = 172, .external_lex_state = 2},
  [568] = {.lex_state = 172, .external_lex_state = 2},
  [569] = {.lex_state = 172, .external_lex_state = 2},
  [570] = {.lex_state = 244, .external_lex_state = 1},
  [571] = {.lex_state = 172, .external_lex_state = 2},
  [572] = {.lex_state = 186, .external_lex_state = 2},
  [573] = {.lex_state = 183, .external_lex_state = 2},
  [574] = {.lex_state = 273, .external_lex_state = 2},
  [575] = {.lex_state = 237, .external_lex_state = 2},
  [576] = {.lex_state = 183, .external_lex_state = 2},
  [577] = {.lex_state = 198, .external_lex_state = 2},
  [578] = {.lex_state = 172, .external_lex_state = 2},
  [579] = {.lex_state = 182, .external_lex_state = 1},
  [580] = {.lex_state = 201, .external_lex_state = 2},
  [581] = {.lex_state = 198, .external_lex_state = 2},
  [582] = {.lex_state = 172, .external_lex_state = 2},
  [583] = {.lex_state = 186, .external_lex_state = 2},
  [584] = {.lex_state = 183, .external_lex_state = 2},
  [585] = {.lex_state = 183, .external_lex_state = 2},
  [586] = {.lex_state = 282, .external_lex_state = 1},
  [587] = {.lex_state = 283, .external_lex_state = 1},
  [588] = {.lex_state = 284, .external_lex_state = 1},
  [589] = {.lex_state = 244, .external_lex_state = 1},
  [590] = {.lex_state = 159, .external_lex_state = 2},
  [591] = {.lex_state = 275, .external_lex_state = 2},
  [592] = {.lex_state = 172, .external_lex_state = 2},
  [593] = {.lex_state = 171, .external_lex_state = 1},
  [594] = {.lex_state = 172, .external_lex_state = 2},
  [595] = {.lex_state = 192, .external_lex_state = 2},
  [596] = {.lex_state = 172, .external_lex_state = 2},
  [597] = {.lex_state = 172, .external_lex_state = 2},
  [598] = {.lex_state = 198, .external_lex_state = 2},
  [599] = {.lex_state = 197, .external_lex_state = 1},
  [600] = {.lex_state = 172, .external_lex_state = 2},
  [601] = {.lex_state = 172, .external_lex_state = 2},
  [602] = {.lex_state = 172, .external_lex_state = 2},
  [603] = {.lex_state = 172, .external_lex_state = 2},
  [604] = {.lex_state = 172, .external_lex_state = 2},
  [605] = {.lex_state = 172, .external_lex_state = 2},
  [606] = {.lex_state = 192, .external_lex_state = 2},
  [607] = {.lex_state = 198, .external_lex_state = 2},
  [608] = {.lex_state = 201, .external_lex_state = 2},
  [609] = {.lex_state = 172, .external_lex_state = 2},
  [610] = {.lex_state = 201, .external_lex_state = 2},
  [611] = {.lex_state = 201, .external_lex_state = 2},
  [612] = {.lex_state = 192, .external_lex_state = 2},
  [613] = {.lex_state = 275, .external_lex_state = 2},
  [614] = {.lex_state = 192, .external_lex_state = 2},
  [615] = {.lex_state = 172, .external_lex_state = 2},
  [616] = {.lex_state = 172, .external_lex_state = 2},
  [617] = {.lex_state = 172, .external_lex_state = 2},
  [618] = {.lex_state = 252, .external_lex_state = 2},
  [619] = {.lex_state = 192, .external_lex_state = 2},
  [620] = {.lex_state = 172, .external_lex_state = 2},
  [621] = {.lex_state = 252, .external_lex_state = 2},
  [622] = {.lex_state = 172, .external_lex_state = 2},
  [623] = {.lex_state = 172, .external_lex_state = 2},
  [624] = {.lex_state = 172, .external_lex_state = 2},
  [625] = {.lex_state = 171, .external_lex_state = 1},
  [626] = {.lex_state = 183, .external_lex_state = 2},
  [627] = {.lex_state = 183, .external_lex_state = 2},
  [628] = {.lex_state = 183, .external_lex_state = 2},
  [629] = {.lex_state = 192, .external_lex_state = 2},
  [630] = {.lex_state = 248, .external_lex_state = 2},
  [631] = {.lex_state = 182, .external_lex_state = 1},
  [632] = {.lex_state = 182, .external_lex_state = 1},
  [633] = {.lex_state = 285, .external_lex_state = 1},
  [634] = {.lex_state = 182, .external_lex_state = 1},
  [635] = {.lex_state = 285, .external_lex_state = 1},
  [636] = {.lex_state = 172, .external_lex_state = 2},
  [637] = {.lex_state = 250, .external_lex_state = 2},
  [638] = {.lex_state = 245, .external_lex_state = 1},
  [639] = {.lex_state = 183, .external_lex_state = 2},
  [640] = {.lex_state = 183, .external_lex_state = 2},
  [641] = {.lex_state = 183, .external_lex_state = 2},
  [642] = {.lex_state = 183, .external_lex_state = 2},
  [643] = {.lex_state = 183, .external_lex_state = 2},
  [644] = {.lex_state = 183, .external_lex_state = 2},
  [645] = {.lex_state = 183, .external_lex_state = 2},
  [646] = {.lex_state = 183, .external_lex_state = 2},
  [647] = {.lex_state = 183, .external_lex_state = 2},
  [648] = {.lex_state = 183, .external_lex_state = 2},
  [649] = {.lex_state = 183, .external_lex_state = 2},
  [650] = {.lex_state = 183, .external_lex_state = 2},
  [651] = {.lex_state = 183, .external_lex_state = 2},
  [652] = {.lex_state = 183, .external_lex_state = 2},
  [653] = {.lex_state = 186, .external_lex_state = 2},
  [654] = {.lex_state = 186, .external_lex_state = 2},
  [655] = {.lex_state = 251, .external_lex_state = 2},
  [656] = {.lex_state = 183, .external_lex_state = 2},
  [657] = {.lex_state = 186, .external_lex_state = 2},
  [658] = {.lex_state = 172, .external_lex_state = 2},
  [659] = {.lex_state = 183, .external_lex_state = 2},
  [660] = {.lex_state = 159, .external_lex_state = 2},
  [661] = {.lex_state = 198, .external_lex_state = 2},
  [662] = {.lex_state = 183, .external_lex_state = 2},
  [663] = {.lex_state = 172, .external_lex_state = 2},
  [664] = {.lex_state = 183, .external_lex_state = 2},
  [665] = {.lex_state = 256, .external_lex_state = 2},
  [666] = {.lex_state = 183, .external_lex_state = 2},
  [667] = {.lex_state = 172, .external_lex_state = 2},
  [668] = {.lex_state = 183, .external_lex_state = 2},
  [669] = {.lex_state = 172, .external_lex_state = 2},
  [670] = {.lex_state = 172, .external_lex_state = 2},
  [671] = {.lex_state = 183, .external_lex_state = 2},
  [672] = {.lex_state = 183, .external_lex_state = 2},
  [673] = {.lex_state = 251, .external_lex_state = 2},
  [674] = {.lex_state = 186, .external_lex_state = 2},
  [675] = {.lex_state = 159, .external_lex_state = 2},
  [676] = {.lex_state = 178, .external_lex_state = 2},
  [677] = {.lex_state = 256, .external_lex_state = 2},
  [678] = {.lex_state = 172, .external_lex_state = 2},
  [679] = {.lex_state = 172, .external_lex_state = 2},
  [680] = {.lex_state = 178, .external_lex_state = 2},
  [681] = {.lex_state = 197, .external_lex_state = 1},
  [682] = {.lex_state = 172, .external_lex_state = 2},
  [683] = {.lex_state = 182, .external_lex_state = 1},
  [684] = {.lex_state = 183, .external_lex_state = 2},
  [685] = {.lex_state = 282, .external_lex_state = 1},
  [686] = {.lex_state = 172, .external_lex_state = 2},
  [687] = {.lex_state = 286, .external_lex_state = 1},
  [688] = {.lex_state = 284, .external_lex_state = 1},
  [689] = {.lex_state = 192, .external_lex_state = 2},
  [690] = {.lex_state = 198, .external_lex_state = 2},
  [691] = {.lex_state = 178, .external_lex_state = 2},
  [692] = {.lex_state = 171, .external_lex_state = 1},
  [693] = {.lex_state = 198, .external_lex_state = 2},
  [694] = {.lex_state = 171, .external_lex_state = 2},
  [695] = {.lex_state = 276, .external_lex_state = 2},
  [696] = {.lex_state = 200, .external_lex_state = 2},
  [697] = {.lex_state = 182, .external_lex_state = 1},
  [698] = {.lex_state = 172, .external_lex_state = 2},
  [699] = {.lex_state = 248, .external_lex_state = 2},
  [700] = {.lex_state = 197, .external_lex_state = 1},
  [701] = {.lex_state = 172, .external_lex_state = 2},
  [702] = {.lex_state = 183, .external_lex_state = 2},
  [703] = {.lex_state = 248, .external_lex_state = 2},
  [704] = {.lex_state = 282, .external_lex_state = 1},
  [705] = {.lex_state = 283, .external_lex_state = 1},
  [706] = {.lex_state = 284, .external_lex_state = 1},
  [707] = {.lex_state = 276, .external_lex_state = 2},
  [708] = {.lex_state = 248, .external_lex_state = 2},
  [709] = {.lex_state = 183, .external_lex_state = 2},
  [710] = {.lex_state = 248, .external_lex_state = 2},
  [711] = {.lex_state = 178, .external_lex_state = 1},
  [712] = {.lex_state = 248, .external_lex_state = 2},
  [713] = {.lex_state = 248, .external_lex_state = 2},
  [714] = {.lex_state = 248, .external_lex_state = 2},
  [715] = {.lex_state = 248, .external_lex_state = 2},
  [716] = {.lex_state = 248, .external_lex_state = 2},
  [717] = {.lex_state = 248, .external_lex_state = 2},
  [718] = {.lex_state = 248, .external_lex_state = 2},
  [719] = {.lex_state = 248, .external_lex_state = 2},
  [720] = {.lex_state = 248, .external_lex_state = 2},
  [721] = {.lex_state = 248, .external_lex_state = 2},
  [722] = {.lex_state = 251, .external_lex_state = 2},
  [723] = {.lex_state = 186, .external_lex_state = 2},
  [724] = {.lex_state = 159, .external_lex_state = 2},
  [725] = {.lex_state = 248, .external_lex_state = 2},
  [726] = {.lex_state = 256, .external_lex_state = 2},
  [727] = {.lex_state = 172, .external_lex_state = 2},
  [728] = {.lex_state = 248, .external_lex_state = 2},
  [729] = {.lex_state = 197, .external_lex_state = 1},
  [730] = {.lex_state = 172, .external_lex_state = 2},
  [731] = {.lex_state = 182, .external_lex_state = 1},
  [732] = {.lex_state = 197, .external_lex_state = 1},
  [733] = {.lex_state = 183, .external_lex_state = 2},
  [734] = {.lex_state = 172, .external_lex_state = 2},
  [735] = {.lex_state = 244, .external_lex_state = 1},
  [736] = {.lex_state = 200, .external_lex_state = 2},
  [737] = {.lex_state = 200, .external_lex_state = 2},
  [738] = {.lex_state = 200, .external_lex_state = 2},
  [739] = {.lex_state = 200, .external_lex_state = 2},
  [740] = {.lex_state = 200, .external_lex_state = 2},
  [741] = {.lex_state = 200, .external_lex_state = 2},
  [742] = {.lex_state = 200, .external_lex_state = 2},
  [743] = {.lex_state = 200, .external_lex_state = 2},
  [744] = {.lex_state = 200, .external_lex_state = 2},
  [745] = {.lex_state = 200, .external_lex_state = 2},
  [746] = {.lex_state = 200, .external_lex_state = 2},
  [747] = {.lex_state = 200, .external_lex_state = 2},
  [748] = {.lex_state = 251, .external_lex_state = 2},
  [749] = {.lex_state = 186, .external_lex_state = 2},
  [750] = {.lex_state = 159, .external_lex_state = 2},
  [751] = {.lex_state = 200, .external_lex_state = 2},
  [752] = {.lex_state = 256, .external_lex_state = 2},
  [753] = {.lex_state = 172, .external_lex_state = 2},
  [754] = {.lex_state = 200, .external_lex_state = 2},
  [755] = {.lex_state = 244, .external_lex_state = 1},
  [756] = {.lex_state = 244, .external_lex_state = 1},
  [757] = {.lex_state = 172, .external_lex_state = 2},
  [758] = {.lex_state = 250, .external_lex_state = 2},
  [759] = {.lex_state = 250, .external_lex_state = 2},
  [760] = {.lex_state = 250, .external_lex_state = 2},
  [761] = {.lex_state = 250, .external_lex_state = 2},
  [762] = {.lex_state = 183, .external_lex_state = 2},
  [763] = {.lex_state = 182, .external_lex_state = 1},
  [764] = {.lex_state = 182, .external_lex_state = 1},
  [765] = {.lex_state = 285, .external_lex_state = 1},
  [766] = {.lex_state = 182, .external_lex_state = 1},
  [767] = {.lex_state = 285, .external_lex_state = 1},
  [768] = {.lex_state = 172, .external_lex_state = 2},
  [769] = {.lex_state = 250, .external_lex_state = 2},
  [770] = {.lex_state = 245, .external_lex_state = 1},
  [771] = {.lex_state = 250, .external_lex_state = 2},
  [772] = {.lex_state = 250, .external_lex_state = 2},
  [773] = {.lex_state = 250, .external_lex_state = 2},
  [774] = {.lex_state = 250, .external_lex_state = 2},
  [775] = {.lex_state = 250, .external_lex_state = 2},
  [776] = {.lex_state = 250, .external_lex_state = 2},
  [777] = {.lex_state = 250, .external_lex_state = 2},
  [778] = {.lex_state = 250, .external_lex_state = 2},
  [779] = {.lex_state = 250, .external_lex_state = 2},
  [780] = {.lex_state = 250, .external_lex_state = 2},
  [781] = {.lex_state = 251, .external_lex_state = 2},
  [782] = {.lex_state = 186, .external_lex_state = 2},
  [783] = {.lex_state = 159, .external_lex_state = 2},
  [784] = {.lex_state = 250, .external_lex_state = 2},
  [785] = {.lex_state = 256, .external_lex_state = 2},
  [786] = {.lex_state = 172, .external_lex_state = 2},
  [787] = {.lex_state = 250, .external_lex_state = 2},
  [788] = {.lex_state = 181, .external_lex_state = 1},
  [789] = {.lex_state = 172, .external_lex_state = 2},
  [790] = {.lex_state = 172, .external_lex_state = 2},
  [791] = {.lex_state = 183, .external_lex_state = 2},
  [792] = {.lex_state = 287, .external_lex_state = 2},
  [793] = {.lex_state = 288, .external_lex_state = 1},
  [794] = {.lex_state = 171, .external_lex_state = 1},
  [795] = {.lex_state = 172, .external_lex_state = 2},
  [796] = {.lex_state = 186, .external_lex_state = 2},
  [797] = {.lex_state = 186, .external_lex_state = 2},
  [798] = {.lex_state = 186, .external_lex_state = 2},
  [799] = {.lex_state = 192, .external_lex_state = 2},
  [800] = {.lex_state = 192, .external_lex_state = 2},
  [801] = {.lex_state = 159, .external_lex_state = 2},
  [802] = {.lex_state = 159, .external_lex_state = 2},
  [803] = {.lex_state = 159, .external_lex_state = 2},
  [804] = {.lex_state = 253, .external_lex_state = 2},
  [805] = {.lex_state = 186, .external_lex_state = 2},
  [806] = {.lex_state = 186, .external_lex_state = 2},
  [807] = {.lex_state = 192, .external_lex_state = 2},
  [808] = {.lex_state = 186, .external_lex_state = 2},
  [809] = {.lex_state = 186, .external_lex_state = 2},
  [810] = {.lex_state = 186, .external_lex_state = 2},
  [811] = {.lex_state = 186, .external_lex_state = 2},
  [812] = {.lex_state = 172, .external_lex_state = 2},
  [813] = {.lex_state = 172, .external_lex_state = 2},
  [814] = {.lex_state = 159, .external_lex_state = 2},
  [815] = {.lex_state = 159, .external_lex_state = 2},
  [816] = {.lex_state = 159, .external_lex_state = 2},
  [817] = {.lex_state = 182, .external_lex_state = 1},
  [818] = {.lex_state = 253, .external_lex_state = 2},
  [819] = {.lex_state = 186, .external_lex_state = 2},
  [820] = {.lex_state = 186, .external_lex_state = 2},
  [821] = {.lex_state = 253, .external_lex_state = 2},
  [822] = {.lex_state = 252, .external_lex_state = 2},
  [823] = {.lex_state = 253, .external_lex_state = 2},
  [824] = {.lex_state = 186, .external_lex_state = 2},
  [825] = {.lex_state = 253, .external_lex_state = 2},
  [826] = {.lex_state = 192, .external_lex_state = 2},
  [827] = {.lex_state = 251, .external_lex_state = 2},
  [828] = {.lex_state = 192, .external_lex_state = 2},
  [829] = {.lex_state = 186, .external_lex_state = 2},
  [830] = {.lex_state = 192, .external_lex_state = 2},
  [831] = {.lex_state = 257, .external_lex_state = 2},
  [832] = {.lex_state = 198, .external_lex_state = 2},
  [833] = {.lex_state = 192, .external_lex_state = 2},
  [834] = {.lex_state = 299, .external_lex_state = 2},
  [835] = {.lex_state = 178, .external_lex_state = 2},
  [836] = {.lex_state = 251, .external_lex_state = 2},
  [837] = {.lex_state = 192, .external_lex_state = 2},
  [838] = {.lex_state = 192, .external_lex_state = 2},
  [839] = {.lex_state = 301, .external_lex_state = 2},
  [840] = {.lex_state = 192, .external_lex_state = 2},
  [841] = {.lex_state = 186, .external_lex_state = 2},
  [842] = {.lex_state = 257, .external_lex_state = 2},
  [843] = {.lex_state = 237, .external_lex_state = 2},
  [844] = {.lex_state = 252, .external_lex_state = 2},
  [845] = {.lex_state = 172, .external_lex_state = 2},
  [846] = {.lex_state = 282, .external_lex_state = 1},
  [847] = {.lex_state = 283, .external_lex_state = 1},
  [848] = {.lex_state = 284, .external_lex_state = 1},
  [849] = {.lex_state = 253, .external_lex_state = 2},
  [850] = {.lex_state = 251, .external_lex_state = 2},
  [851] = {.lex_state = 186, .external_lex_state = 2},
  [852] = {.lex_state = 159, .external_lex_state = 2},
  [853] = {.lex_state = 178, .external_lex_state = 2},
  [854] = {.lex_state = 256, .external_lex_state = 2},
  [855] = {.lex_state = 172, .external_lex_state = 2},
  [856] = {.lex_state = 172, .external_lex_state = 2},
  [857] = {.lex_state = 172, .external_lex_state = 2},
  [858] = {.lex_state = 178, .external_lex_state = 2},
  [859] = {.lex_state = 186, .external_lex_state = 2},
  [860] = {.lex_state = 172, .external_lex_state = 2},
  [861] = {.lex_state = 172, .external_lex_state = 2},
  [862] = {.lex_state = 253, .external_lex_state = 2},
  [863] = {.lex_state = 251, .external_lex_state = 2},
  [864] = {.lex_state = 186, .external_lex_state = 2},
  [865] = {.lex_state = 159, .external_lex_state = 2},
  [866] = {.lex_state = 178, .external_lex_state = 2},
  [867] = {.lex_state = 256, .external_lex_state = 2},
  [868] = {.lex_state = 172, .external_lex_state = 2},
  [869] = {.lex_state = 172, .external_lex_state = 2},
  [870] = {.lex_state = 178, .external_lex_state = 2},
  [871] = {.lex_state = 253, .external_lex_state = 2},
  [872] = {.lex_state = 252, .external_lex_state = 2},
  [873] = {.lex_state = 172, .external_lex_state = 2},
  [874] = {.lex_state = 259, .external_lex_state = 2},
  [875] = {.lex_state = 197, .external_lex_state = 1},
  [876] = {.lex_state = 197, .external_lex_state = 1},
  [877] = {.lex_state = 258, .external_lex_state = 1},
  [878] = {.lex_state = 192, .external_lex_state = 2},
  [879] = {.lex_state = 251, .external_lex_state = 2},
  [880] = {.lex_state = 186, .external_lex_state = 2},
  [881] = {.lex_state = 159, .external_lex_state = 2},
  [882] = {.lex_state = 178, .external_lex_state = 2},
  [883] = {.lex_state = 256, .external_lex_state = 2},
  [884] = {.lex_state = 172, .external_lex_state = 2},
  [885] = {.lex_state = 172, .external_lex_state = 2},
  [886] = {.lex_state = 192, .external_lex_state = 2},
  [887] = {.lex_state = 178, .external_lex_state = 2},
  [888] = {.lex_state = 262, .external_lex_state = 2},
  [889] = {.lex_state = 172, .external_lex_state = 2},
  [890] = {.lex_state = 192, .external_lex_state = 2},
  [891] = {.lex_state = 192, .external_lex_state = 2},
  [892] = {.lex_state = 192, .external_lex_state = 2},
  [893] = {.lex_state = 197, .external_lex_state = 1},
  [894] = {.lex_state = 178, .external_lex_state = 2},
  [895] = {.lex_state = 192, .external_lex_state = 2},
  [896] = {.lex_state = 197, .external_lex_state = 1},
  [897] = {.lex_state = 178, .external_lex_state = 2},
  [898] = {.lex_state = 259, .external_lex_state = 2},
  [899] = {.lex_state = 192, .external_lex_state = 2},
  [900] = {.lex_state = 186, .external_lex_state = 2},
  [901] = {.lex_state = 186, .external_lex_state = 2},
  [902] = {.lex_state = 258, .external_lex_state = 1},
  [903] = {.lex_state = 197, .external_lex_state = 1},
  [904] = {.lex_state = 178, .external_lex_state = 2},
  [905] = {.lex_state = 192, .external_lex_state = 2},
  [906] = {.lex_state = 259, .external_lex_state = 2},
  [907] = {.lex_state = 192, .external_lex_state = 2},
  [908] = {.lex_state = 192, .external_lex_state = 2},
  [909] = {.lex_state = 259, .external_lex_state = 2},
  [910] = {.lex_state = 198, .external_lex_state = 2},
  [911] = {.lex_state = 172, .external_lex_state = 2},
  [912] = {.lex_state = 172, .external_lex_state = 2},
  [913] = {.lex_state = 201, .external_lex_state = 2},
  [914] = {.lex_state = 198, .external_lex_state = 2},
  [915] = {.lex_state = 262, .external_lex_state = 2},
  [916] = {.lex_state = 259, .external_lex_state = 2},
  [917] = {.lex_state = 172, .external_lex_state = 2},
  [918] = {.lex_state = 192, .external_lex_state = 2},
  [919] = {.lex_state = 245, .external_lex_state = 1},
  [920] = {.lex_state = 172, .external_lex_state = 2},
  [921] = {.lex_state = 262, .external_lex_state = 2},
  [922] = {.lex_state = 259, .external_lex_state = 2},
  [923] = {.lex_state = 198, .external_lex_state = 2},
  [924] = {.lex_state = 198, .external_lex_state = 2},
  [925] = {.lex_state = 251, .external_lex_state = 2},
  [926] = {.lex_state = 186, .external_lex_state = 2},
  [927] = {.lex_state = 159, .external_lex_state = 2},
  [928] = {.lex_state = 178, .external_lex_state = 2},
  [929] = {.lex_state = 256, .external_lex_state = 2},
  [930] = {.lex_state = 172, .external_lex_state = 2},
  [931] = {.lex_state = 172, .external_lex_state = 2},
  [932] = {.lex_state = 178, .external_lex_state = 2},
  [933] = {.lex_state = 171, .external_lex_state = 1},
  [934] = {.lex_state = 198, .external_lex_state = 2},
  [935] = {.lex_state = 183, .external_lex_state = 2},
  [936] = {.lex_state = 182, .external_lex_state = 2},
  [937] = {.lex_state = 198, .external_lex_state = 2},
  [938] = {.lex_state = 172, .external_lex_state = 2},
  [939] = {.lex_state = 172, .external_lex_state = 2},
  [940] = {.lex_state = 192, .external_lex_state = 2},
  [941] = {.lex_state = 192, .external_lex_state = 2},
  [942] = {.lex_state = 186, .external_lex_state = 2},
  [943] = {.lex_state = 172, .external_lex_state = 2},
  [944] = {.lex_state = 172, .external_lex_state = 2},
  [945] = {.lex_state = 192, .external_lex_state = 2},
  [946] = {.lex_state = 172, .external_lex_state = 2},
  [947] = {.lex_state = 192, .external_lex_state = 2},
  [948] = {.lex_state = 171, .external_lex_state = 1},
  [949] = {.lex_state = 172, .external_lex_state = 2},
  [950] = {.lex_state = 172, .external_lex_state = 2},
  [951] = {.lex_state = 171, .external_lex_state = 1},
  [952] = {.lex_state = 171, .external_lex_state = 1},
  [953] = {.lex_state = 186, .external_lex_state = 2},
  [954] = {.lex_state = 198, .external_lex_state = 2},
  [955] = {.lex_state = 172, .external_lex_state = 2},
  [956] = {.lex_state = 171, .external_lex_state = 1},
  [957] = {.lex_state = 183, .external_lex_state = 2},
  [958] = {.lex_state = 280, .external_lex_state = 2},
  [959] = {.lex_state = 172, .external_lex_state = 2},
  [960] = {.lex_state = 183, .external_lex_state = 2},
  [961] = {.lex_state = 197, .external_lex_state = 1},
  [962] = {.lex_state = 197, .external_lex_state = 1},
  [963] = {.lex_state = 182, .external_lex_state = 1},
  [964] = {.lex_state = 183, .external_lex_state = 2},
  [965] = {.lex_state = 183, .external_lex_state = 2},
  [966] = {.lex_state = 280, .external_lex_state = 2},
  [967] = {.lex_state = 183, .external_lex_state = 2},
  [968] = {.lex_state = 183, .external_lex_state = 2},
  [969] = {.lex_state = 183, .external_lex_state = 2},
  [970] = {.lex_state = 183, .external_lex_state = 2},
  [971] = {.lex_state = 183, .external_lex_state = 2},
  [972] = {.lex_state = 183, .external_lex_state = 2},
  [973] = {.lex_state = 183, .external_lex_state = 2},
  [974] = {.lex_state = 183, .external_lex_state = 2},
  [975] = {.lex_state = 183, .external_lex_state = 2},
  [976] = {.lex_state = 183, .external_lex_state = 2},
  [977] = {.lex_state = 183, .external_lex_state = 2},
  [978] = {.lex_state = 251, .external_lex_state = 2},
  [979] = {.lex_state = 186, .external_lex_state = 2},
  [980] = {.lex_state = 159, .external_lex_state = 2},
  [981] = {.lex_state = 183, .external_lex_state = 2},
  [982] = {.lex_state = 256, .external_lex_state = 2},
  [983] = {.lex_state = 172, .external_lex_state = 2},
  [984] = {.lex_state = 183, .external_lex_state = 2},
  [985] = {.lex_state = 172, .external_lex_state = 2},
  [986] = {.lex_state = 244, .external_lex_state = 1},
  [987] = {.lex_state = 183, .external_lex_state = 2},
  [988] = {.lex_state = 301, .external_lex_state = 2},
  [989] = {.lex_state = 186, .external_lex_state = 2},
  [990] = {.lex_state = 172, .external_lex_state = 2},
  [991] = {.lex_state = 186, .external_lex_state = 2},
  [992] = {.lex_state = 277, .external_lex_state = 2},
  [993] = {.lex_state = 172, .external_lex_state = 2},
  [994] = {.lex_state = 172, .external_lex_state = 2},
  [995] = {.lex_state = 277, .external_lex_state = 2},
  [996] = {.lex_state = 172, .external_lex_state = 2},
  [997] = {.lex_state = 186, .external_lex_state = 2},
  [998] = {.lex_state = 172, .external_lex_state = 2},
  [999] = {.lex_state = 251, .external_lex_state = 2},
  [1000] = {.lex_state = 186, .external_lex_state = 2},
  [1001] = {.lex_state = 159, .external_lex_state = 2},
  [1002] = {.lex_state = 252, .external_lex_state = 2},
  [1003] = {.lex_state = 256, .external_lex_state = 2},
  [1004] = {.lex_state = 172, .external_lex_state = 2},
  [1005] = {.lex_state = 172, .external_lex_state = 2},
  [1006] = {.lex_state = 252, .external_lex_state = 2},
  [1007] = {.lex_state = 171, .external_lex_state = 1},
  [1008] = {.lex_state = 172, .external_lex_state = 2},
  [1009] = {.lex_state = 172, .external_lex_state = 2},
  [1010] = {.lex_state = 171, .external_lex_state = 1},
  [1011] = {.lex_state = 172, .external_lex_state = 2},
  [1012] = {.lex_state = 172, .external_lex_state = 2},
  [1013] = {.lex_state = 172, .external_lex_state = 2},
  [1014] = {.lex_state = 171, .external_lex_state = 1},
  [1015] = {.lex_state = 172, .external_lex_state = 2},
  [1016] = {.lex_state = 172, .external_lex_state = 2},
  [1017] = {.lex_state = 172, .external_lex_state = 2},
  [1018] = {.lex_state = 171, .external_lex_state = 1},
  [1019] = {.lex_state = 186, .external_lex_state = 2},
  [1020] = {.lex_state = 182, .external_lex_state = 1},
  [1021] = {.lex_state = 251, .external_lex_state = 2},
  [1022] = {.lex_state = 186, .external_lex_state = 2},
  [1023] = {.lex_state = 159, .external_lex_state = 2},
  [1024] = {.lex_state = 186, .external_lex_state = 2},
  [1025] = {.lex_state = 256, .external_lex_state = 2},
  [1026] = {.lex_state = 172, .external_lex_state = 2},
  [1027] = {.lex_state = 172, .external_lex_state = 2},
  [1028] = {.lex_state = 186, .external_lex_state = 2},
  [1029] = {.lex_state = 183, .external_lex_state = 2},
  [1030] = {.lex_state = 258, .external_lex_state = 1},
  [1031] = {.lex_state = 244, .external_lex_state = 1},
  [1032] = {.lex_state = 172, .external_lex_state = 2},
  [1033] = {.lex_state = 197, .external_lex_state = 1},
  [1034] = {.lex_state = 172, .external_lex_state = 2},
  [1035] = {.lex_state = 172, .external_lex_state = 2},
  [1036] = {.lex_state = 274, .external_lex_state = 2},
  [1037] = {.lex_state = 197, .external_lex_state = 1},
  [1038] = {.lex_state = 197, .external_lex_state = 1},
  [1039] = {.lex_state = 287, .external_lex_state = 2},
  [1040] = {.lex_state = 278, .external_lex_state = 2},
  [1041] = {.lex_state = 172, .external_lex_state = 2},
  [1042] = {.lex_state = 172, .external_lex_state = 2},
  [1043] = {.lex_state = 278, .external_lex_state = 2},
  [1044] = {.lex_state = 172, .external_lex_state = 2},
  [1045] = {.lex_state = 198, .external_lex_state = 2},
  [1046] = {.lex_state = 198, .external_lex_state = 2},
  [1047] = {.lex_state = 274, .external_lex_state = 2},
  [1048] = {.lex_state = 287, .external_lex_state = 2},
  [1049] = {.lex_state = 197, .external_lex_state = 1},
  [1050] = {.lex_state = 197, .external_lex_state = 1},
  [1051] = {.lex_state = 251, .external_lex_state = 2},
  [1052] = {.lex_state = 251, .external_lex_state = 2},
  [1053] = {.lex_state = 251, .external_lex_state = 2},
  [1054] = {.lex_state = 251, .external_lex_state = 2},
  [1055] = {.lex_state = 192, .external_lex_state = 2},
  [1056] = {.lex_state = 186, .external_lex_state = 2},
  [1057] = {.lex_state = 172, .external_lex_state = 2},
  [1058] = {.lex_state = 302, .external_lex_state = 2},
  [1059] = {.lex_state = 192, .external_lex_state = 2},
  [1060] = {.lex_state = 172, .external_lex_state = 2},
  [1061] = {.lex_state = 186, .external_lex_state = 2},
  [1062] = {.lex_state = 186, .external_lex_state = 2},
  [1063] = {.lex_state = 192, .external_lex_state = 2},
  [1064] = {.lex_state = 186, .external_lex_state = 2},
  [1065] = {.lex_state = 171, .external_lex_state = 1},
  [1066] = {.lex_state = 198, .external_lex_state = 2},
  [1067] = {.lex_state = 192, .external_lex_state = 2},
  [1068] = {.lex_state = 198, .external_lex_state = 2},
  [1069] = {.lex_state = 172, .external_lex_state = 2},
  [1070] = {.lex_state = 172, .external_lex_state = 2},
  [1071] = {.lex_state = 172, .external_lex_state = 2},
  [1072] = {.lex_state = 183, .external_lex_state = 2},
  [1073] = {.lex_state = 192, .external_lex_state = 2},
  [1074] = {.lex_state = 172, .external_lex_state = 2},
  [1075] = {.lex_state = 192, .external_lex_state = 2},
  [1076] = {.lex_state = 171, .external_lex_state = 1},
  [1077] = {.lex_state = 198, .external_lex_state = 2},
  [1078] = {.lex_state = 172, .external_lex_state = 2},
  [1079] = {.lex_state = 172, .external_lex_state = 2},
  [1080] = {.lex_state = 159, .external_lex_state = 2},
  [1081] = {.lex_state = 186, .external_lex_state = 2},
  [1082] = {.lex_state = 172, .external_lex_state = 2},
  [1083] = {.lex_state = 172, .external_lex_state = 2},
  [1084] = {.lex_state = 172, .external_lex_state = 2},
  [1085] = {.lex_state = 192, .external_lex_state = 2},
  [1086] = {.lex_state = 172, .external_lex_state = 2},
  [1087] = {.lex_state = 172, .external_lex_state = 2},
  [1088] = {.lex_state = 192, .external_lex_state = 2},
  [1089] = {.lex_state = 171, .external_lex_state = 1},
  [1090] = {.lex_state = 172, .external_lex_state = 2},
  [1091] = {.lex_state = 251, .external_lex_state = 2},
  [1092] = {.lex_state = 186, .external_lex_state = 2},
  [1093] = {.lex_state = 186, .external_lex_state = 2},
  [1094] = {.lex_state = 159, .external_lex_state = 2},
  [1095] = {.lex_state = 172, .external_lex_state = 2},
  [1096] = {.lex_state = 186, .external_lex_state = 2},
  [1097] = {.lex_state = 256, .external_lex_state = 2},
  [1098] = {.lex_state = 172, .external_lex_state = 2},
  [1099] = {.lex_state = 172, .external_lex_state = 2},
  [1100] = {.lex_state = 186, .external_lex_state = 2},
  [1101] = {.lex_state = 172, .external_lex_state = 2},
  [1102] = {.lex_state = 172, .external_lex_state = 2},
  [1103] = {.lex_state = 171, .external_lex_state = 1},
  [1104] = {.lex_state = 186, .external_lex_state = 2},
  [1105] = {.lex_state = 171, .external_lex_state = 1},
  [1106] = {.lex_state = 172, .external_lex_state = 2},
  [1107] = {.lex_state = 159, .external_lex_state = 2},
  [1108] = {.lex_state = 172, .external_lex_state = 2},
  [1109] = {.lex_state = 172, .external_lex_state = 2},
  [1110] = {.lex_state = 198, .external_lex_state = 2},
  [1111] = {.lex_state = 198, .external_lex_state = 2},
  [1112] = {.lex_state = 198, .external_lex_state = 2},
  [1113] = {.lex_state = 172, .external_lex_state = 2},
  [1114] = {.lex_state = 198, .external_lex_state = 2},
  [1115] = {.lex_state = 198, .external_lex_state = 2},
  [1116] = {.lex_state = 172, .external_lex_state = 2},
  [1117] = {.lex_state = 198, .external_lex_state = 2},
  [1118] = {.lex_state = 172, .external_lex_state = 2},
  [1119] = {.lex_state = 172, .external_lex_state = 2},
  [1120] = {.lex_state = 172, .external_lex_state = 2},
  [1121] = {.lex_state = 198, .external_lex_state = 2},
  [1122] = {.lex_state = 172, .external_lex_state = 2},
  [1123] = {.lex_state = 172, .external_lex_state = 2},
  [1124] = {.lex_state = 198, .external_lex_state = 2},
  [1125] = {.lex_state = 182, .external_lex_state = 1},
  [1126] = {.lex_state = 171, .external_lex_state = 1},
  [1127] = {.lex_state = 172, .external_lex_state = 2},
  [1128] = {.lex_state = 172, .external_lex_state = 2},
  [1129] = {.lex_state = 183, .external_lex_state = 2},
  [1130] = {.lex_state = 172, .external_lex_state = 2},
  [1131] = {.lex_state = 182, .external_lex_state = 1},
  [1132] = {.lex_state = 182, .external_lex_state = 1},
  [1133] = {.lex_state = 272, .external_lex_state = 1},
  [1134] = {.lex_state = 182, .external_lex_state = 1},
  [1135] = {.lex_state = 272, .external_lex_state = 1},
  [1136] = {.lex_state = 172, .external_lex_state = 2},
  [1137] = {.lex_state = 200, .external_lex_state = 2},
  [1138] = {.lex_state = 245, .external_lex_state = 1},
  [1139] = {.lex_state = 183, .external_lex_state = 2},
  [1140] = {.lex_state = 182, .external_lex_state = 1},
  [1141] = {.lex_state = 274, .external_lex_state = 2},
  [1142] = {.lex_state = 198, .external_lex_state = 2},
  [1143] = {.lex_state = 274, .external_lex_state = 2},
  [1144] = {.lex_state = 198, .external_lex_state = 2},
  [1145] = {.lex_state = 192, .external_lex_state = 2},
  [1146] = {.lex_state = 172, .external_lex_state = 2},
  [1147] = {.lex_state = 172, .external_lex_state = 2},
  [1148] = {.lex_state = 172, .external_lex_state = 2},
  [1149] = {.lex_state = 172, .external_lex_state = 2},
  [1150] = {.lex_state = 282, .external_lex_state = 1},
  [1151] = {.lex_state = 244, .external_lex_state = 1},
  [1152] = {.lex_state = 283, .external_lex_state = 1},
  [1153] = {.lex_state = 284, .external_lex_state = 1},
  [1154] = {.lex_state = 159, .external_lex_state = 2},
  [1155] = {.lex_state = 282, .external_lex_state = 1},
  [1156] = {.lex_state = 303, .external_lex_state = 1},
  [1157] = {.lex_state = 282, .external_lex_state = 1},
  [1158] = {.lex_state = 282, .external_lex_state = 1},
  [1159] = {.lex_state = 304, .external_lex_state = 1},
  [1160] = {.lex_state = 305, .external_lex_state = 1},
  [1161] = {.lex_state = 305, .external_lex_state = 1},
  [1162] = {.lex_state = 282, .external_lex_state = 1},
  [1163] = {.lex_state = 303, .external_lex_state = 1},
  [1164] = {.lex_state = 303, .external_lex_state = 1},
  [1165] = {.lex_state = 303, .external_lex_state = 1},
  [1166] = {.lex_state = 303, .external_lex_state = 1},
  [1167] = {.lex_state = 282, .external_lex_state = 1},
  [1168] = {.lex_state = 303, .external_lex_state = 1},
  [1169] = {.lex_state = 303, .external_lex_state = 1},
  [1170] = {.lex_state = 282, .external_lex_state = 1},
  [1171] = {.lex_state = 303, .external_lex_state = 1},
  [1172] = {.lex_state = 303, .external_lex_state = 1},
  [1173] = {.lex_state = 237, .external_lex_state = 2},
  [1174] = {.lex_state = 305, .external_lex_state = 1},
  [1175] = {.lex_state = 303, .external_lex_state = 1},
  [1176] = {.lex_state = 303, .external_lex_state = 1},
  [1177] = {.lex_state = 248, .external_lex_state = 2},
  [1178] = {.lex_state = 303, .external_lex_state = 1},
  [1179] = {.lex_state = 282, .external_lex_state = 1},
  [1180] = {.lex_state = 283, .external_lex_state = 1},
  [1181] = {.lex_state = 282, .external_lex_state = 1},
  [1182] = {.lex_state = 283, .external_lex_state = 1},
  [1183] = {.lex_state = 284, .external_lex_state = 1},
  [1184] = {.lex_state = 286, .external_lex_state = 1},
  [1185] = {.lex_state = 286, .external_lex_state = 1},
  [1186] = {.lex_state = 286, .external_lex_state = 1},
  [1187] = {.lex_state = 286, .external_lex_state = 1},
  [1188] = {.lex_state = 286, .external_lex_state = 1},
  [1189] = {.lex_state = 286, .external_lex_state = 1},
  [1190] = {.lex_state = 286, .external_lex_state = 1},
  [1191] = {.lex_state = 306, .external_lex_state = 1},
  [1192] = {.lex_state = 286, .external_lex_state = 1},
  [1193] = {.lex_state = 306, .external_lex_state = 1},
  [1194] = {.lex_state = 286, .external_lex_state = 1},
  [1195] = {.lex_state = 286, .external_lex_state = 1},
  [1196] = {.lex_state = 286, .external_lex_state = 1},
  [1197] = {.lex_state = 286, .external_lex_state = 1},
  [1198] = {.lex_state = 286, .external_lex_state = 1},
  [1199] = {.lex_state = 286, .external_lex_state = 1},
  [1200] = {.lex_state = 286, .external_lex_state = 1},
  [1201] = {.lex_state = 286, .external_lex_state = 1},
  [1202] = {.lex_state = 286, .external_lex_state = 1},
  [1203] = {.lex_state = 306, .external_lex_state = 1},
  [1204] = {.lex_state = 286, .external_lex_state = 1},
  [1205] = {.lex_state = 286, .external_lex_state = 1},
  [1206] = {.lex_state = 286, .external_lex_state = 1},
  [1207] = {.lex_state = 286, .external_lex_state = 1},
  [1208] = {.lex_state = 286, .external_lex_state = 1},
  [1209] = {.lex_state = 286, .external_lex_state = 1},
  [1210] = {.lex_state = 306, .external_lex_state = 1},
  [1211] = {.lex_state = 286, .external_lex_state = 1},
  [1212] = {.lex_state = 286, .external_lex_state = 1},
  [1213] = {.lex_state = 286, .external_lex_state = 1},
  [1214] = {.lex_state = 286, .external_lex_state = 1},
  [1215] = {.lex_state = 200, .external_lex_state = 2},
  [1216] = {.lex_state = 286, .external_lex_state = 1},
  [1217] = {.lex_state = 171, .external_lex_state = 1},
  [1218] = {.lex_state = 286, .external_lex_state = 1},
  [1219] = {.lex_state = 284, .external_lex_state = 1},
  [1220] = {.lex_state = 284, .external_lex_state = 1},
  [1221] = {.lex_state = 284, .external_lex_state = 1},
  [1222] = {.lex_state = 284, .external_lex_state = 1},
  [1223] = {.lex_state = 284, .external_lex_state = 1},
  [1224] = {.lex_state = 284, .external_lex_state = 1},
  [1225] = {.lex_state = 250, .external_lex_state = 2},
  [1226] = {.lex_state = 284, .external_lex_state = 1},
  [1227] = {.lex_state = 159, .external_lex_state = 2},
  [1228] = {.lex_state = 159, .external_lex_state = 2},
  [1229] = {.lex_state = 172, .external_lex_state = 2},
  [1230] = {.lex_state = 172, .external_lex_state = 2},
  [1231] = {.lex_state = 192, .external_lex_state = 2},
  [1232] = {.lex_state = 172, .external_lex_state = 2},
  [1233] = {.lex_state = 159, .external_lex_state = 2},
  [1234] = {.lex_state = 172, .external_lex_state = 2},
  [1235] = {.lex_state = 198, .external_lex_state = 2},
  [1236] = {.lex_state = 172, .external_lex_state = 2},
  [1237] = {.lex_state = 197, .external_lex_state = 1},
  [1238] = {.lex_state = 192, .external_lex_state = 2},
  [1239] = {.lex_state = 172, .external_lex_state = 2},
  [1240] = {.lex_state = 172, .external_lex_state = 2},
  [1241] = {.lex_state = 192, .external_lex_state = 2},
  [1242] = {.lex_state = 252, .external_lex_state = 2},
  [1243] = {.lex_state = 192, .external_lex_state = 2},
  [1244] = {.lex_state = 192, .external_lex_state = 2},
  [1245] = {.lex_state = 252, .external_lex_state = 2},
  [1246] = {.lex_state = 198, .external_lex_state = 2},
  [1247] = {.lex_state = 172, .external_lex_state = 2},
  [1248] = {.lex_state = 172, .external_lex_state = 2},
  [1249] = {.lex_state = 172, .external_lex_state = 2},
  [1250] = {.lex_state = 275, .external_lex_state = 2},
  [1251] = {.lex_state = 275, .external_lex_state = 2},
  [1252] = {.lex_state = 192, .external_lex_state = 2},
  [1253] = {.lex_state = 172, .external_lex_state = 2},
  [1254] = {.lex_state = 172, .external_lex_state = 2},
  [1255] = {.lex_state = 172, .external_lex_state = 2},
  [1256] = {.lex_state = 172, .external_lex_state = 2},
  [1257] = {.lex_state = 172, .external_lex_state = 2},
  [1258] = {.lex_state = 172, .external_lex_state = 2},
  [1259] = {.lex_state = 172, .external_lex_state = 2},
  [1260] = {.lex_state = 198, .external_lex_state = 2},
  [1261] = {.lex_state = 201, .external_lex_state = 2},
  [1262] = {.lex_state = 201, .external_lex_state = 2},
  [1263] = {.lex_state = 201, .external_lex_state = 2},
  [1264] = {.lex_state = 171, .external_lex_state = 1},
  [1265] = {.lex_state = 275, .external_lex_state = 2},
  [1266] = {.lex_state = 186, .external_lex_state = 2},
  [1267] = {.lex_state = 171, .external_lex_state = 1},
  [1268] = {.lex_state = 172, .external_lex_state = 2},
  [1269] = {.lex_state = 172, .external_lex_state = 2},
  [1270] = {.lex_state = 171, .external_lex_state = 1},
  [1271] = {.lex_state = 192, .external_lex_state = 2},
  [1272] = {.lex_state = 171, .external_lex_state = 1},
  [1273] = {.lex_state = 172, .external_lex_state = 2},
  [1274] = {.lex_state = 159, .external_lex_state = 2},
  [1275] = {.lex_state = 183, .external_lex_state = 2},
  [1276] = {.lex_state = 171, .external_lex_state = 1},
  [1277] = {.lex_state = 172, .external_lex_state = 2},
  [1278] = {.lex_state = 192, .external_lex_state = 2},
  [1279] = {.lex_state = 186, .external_lex_state = 2},
  [1280] = {.lex_state = 172, .external_lex_state = 2},
  [1281] = {.lex_state = 171, .external_lex_state = 1},
  [1282] = {.lex_state = 172, .external_lex_state = 2},
  [1283] = {.lex_state = 159, .external_lex_state = 2},
  [1284] = {.lex_state = 183, .external_lex_state = 2},
  [1285] = {.lex_state = 171, .external_lex_state = 1},
  [1286] = {.lex_state = 172, .external_lex_state = 2},
  [1287] = {.lex_state = 159, .external_lex_state = 2},
  [1288] = {.lex_state = 183, .external_lex_state = 2},
  [1289] = {.lex_state = 178, .external_lex_state = 1},
  [1290] = {.lex_state = 192, .external_lex_state = 2},
  [1291] = {.lex_state = 182, .external_lex_state = 1},
  [1292] = {.lex_state = 250, .external_lex_state = 2},
  [1293] = {.lex_state = 197, .external_lex_state = 1},
  [1294] = {.lex_state = 183, .external_lex_state = 2},
  [1295] = {.lex_state = 250, .external_lex_state = 2},
  [1296] = {.lex_state = 245, .external_lex_state = 1},
  [1297] = {.lex_state = 183, .external_lex_state = 2},
  [1298] = {.lex_state = 182, .external_lex_state = 1},
  [1299] = {.lex_state = 182, .external_lex_state = 1},
  [1300] = {.lex_state = 182, .external_lex_state = 1},
  [1301] = {.lex_state = 182, .external_lex_state = 1},
  [1302] = {.lex_state = 182, .external_lex_state = 1},
  [1303] = {.lex_state = 182, .external_lex_state = 1},
  [1304] = {.lex_state = 182, .external_lex_state = 1},
  [1305] = {.lex_state = 182, .external_lex_state = 1},
  [1306] = {.lex_state = 182, .external_lex_state = 1},
  [1307] = {.lex_state = 182, .external_lex_state = 1},
  [1308] = {.lex_state = 182, .external_lex_state = 1},
  [1309] = {.lex_state = 285, .external_lex_state = 1},
  [1310] = {.lex_state = 182, .external_lex_state = 1},
  [1311] = {.lex_state = 186, .external_lex_state = 2},
  [1312] = {.lex_state = 250, .external_lex_state = 2},
  [1313] = {.lex_state = 183, .external_lex_state = 2},
  [1314] = {.lex_state = 192, .external_lex_state = 2},
  [1315] = {.lex_state = 172, .external_lex_state = 2},
  [1316] = {.lex_state = 186, .external_lex_state = 2},
  [1317] = {.lex_state = 172, .external_lex_state = 2},
  [1318] = {.lex_state = 186, .external_lex_state = 2},
  [1319] = {.lex_state = 183, .external_lex_state = 2},
  [1320] = {.lex_state = 186, .external_lex_state = 2},
  [1321] = {.lex_state = 183, .external_lex_state = 2},
  [1322] = {.lex_state = 186, .external_lex_state = 2},
  [1323] = {.lex_state = 307, .external_lex_state = 2},
  [1324] = {.lex_state = 172, .external_lex_state = 2},
  [1325] = {.lex_state = 183, .external_lex_state = 2},
  [1326] = {.lex_state = 183, .external_lex_state = 2},
  [1327] = {.lex_state = 183, .external_lex_state = 2},
  [1328] = {.lex_state = 172, .external_lex_state = 2},
  [1329] = {.lex_state = 307, .external_lex_state = 2},
  [1330] = {.lex_state = 183, .external_lex_state = 2},
  [1331] = {.lex_state = 172, .external_lex_state = 2},
  [1332] = {.lex_state = 159, .external_lex_state = 2},
  [1333] = {.lex_state = 159, .external_lex_state = 2},
  [1334] = {.lex_state = 159, .external_lex_state = 2},
  [1335] = {.lex_state = 186, .external_lex_state = 2},
  [1336] = {.lex_state = 186, .external_lex_state = 2},
  [1337] = {.lex_state = 172, .external_lex_state = 2},
  [1338] = {.lex_state = 172, .external_lex_state = 2},
  [1339] = {.lex_state = 172, .external_lex_state = 2},
  [1340] = {.lex_state = 183, .external_lex_state = 2},
  [1341] = {.lex_state = 186, .external_lex_state = 2},
  [1342] = {.lex_state = 186, .external_lex_state = 2},
  [1343] = {.lex_state = 186, .external_lex_state = 2},
  [1344] = {.lex_state = 172, .external_lex_state = 2},
  [1345] = {.lex_state = 172, .external_lex_state = 2},
  [1346] = {.lex_state = 159, .external_lex_state = 2},
  [1347] = {.lex_state = 159, .external_lex_state = 2},
  [1348] = {.lex_state = 159, .external_lex_state = 2},
  [1349] = {.lex_state = 186, .external_lex_state = 2},
  [1350] = {.lex_state = 183, .external_lex_state = 2},
  [1351] = {.lex_state = 186, .external_lex_state = 2},
  [1352] = {.lex_state = 265, .external_lex_state = 2},
  [1353] = {.lex_state = 244, .external_lex_state = 1},
  [1354] = {.lex_state = 197, .external_lex_state = 1},
  [1355] = {.lex_state = 183, .external_lex_state = 2},
  [1356] = {.lex_state = 282, .external_lex_state = 1},
  [1357] = {.lex_state = 198, .external_lex_state = 2},
  [1358] = {.lex_state = 286, .external_lex_state = 1},
  [1359] = {.lex_state = 284, .external_lex_state = 1},
  [1360] = {.lex_state = 159, .external_lex_state = 2},
  [1361] = {.lex_state = 305, .external_lex_state = 1},
  [1362] = {.lex_state = 305, .external_lex_state = 1},
  [1363] = {.lex_state = 282, .external_lex_state = 1},
  [1364] = {.lex_state = 171, .external_lex_state = 1},
  [1365] = {.lex_state = 286, .external_lex_state = 1},
  [1366] = {.lex_state = 284, .external_lex_state = 1},
  [1367] = {.lex_state = 280, .external_lex_state = 2},
  [1368] = {.lex_state = 172, .external_lex_state = 2},
  [1369] = {.lex_state = 159, .external_lex_state = 2},
  [1370] = {.lex_state = 192, .external_lex_state = 2},
  [1371] = {.lex_state = 178, .external_lex_state = 2},
  [1372] = {.lex_state = 198, .external_lex_state = 2},
  [1373] = {.lex_state = 171, .external_lex_state = 2},
  [1374] = {.lex_state = 276, .external_lex_state = 2},
  [1375] = {.lex_state = 183, .external_lex_state = 2},
  [1376] = {.lex_state = 182, .external_lex_state = 1},
  [1377] = {.lex_state = 172, .external_lex_state = 2},
  [1378] = {.lex_state = 183, .external_lex_state = 2},
  [1379] = {.lex_state = 183, .external_lex_state = 2},
  [1380] = {.lex_state = 198, .external_lex_state = 2},
  [1381] = {.lex_state = 197, .external_lex_state = 1},
  [1382] = {.lex_state = 182, .external_lex_state = 1},
  [1383] = {.lex_state = 276, .external_lex_state = 2},
  [1384] = {.lex_state = 248, .external_lex_state = 2},
  [1385] = {.lex_state = 282, .external_lex_state = 1},
  [1386] = {.lex_state = 200, .external_lex_state = 2},
  [1387] = {.lex_state = 171, .external_lex_state = 1},
  [1388] = {.lex_state = 286, .external_lex_state = 1},
  [1389] = {.lex_state = 250, .external_lex_state = 2},
  [1390] = {.lex_state = 284, .external_lex_state = 1},
  [1391] = {.lex_state = 183, .external_lex_state = 2},
  [1392] = {.lex_state = 178, .external_lex_state = 1},
  [1393] = {.lex_state = 248, .external_lex_state = 2},
  [1394] = {.lex_state = 178, .external_lex_state = 1},
  [1395] = {.lex_state = 186, .external_lex_state = 2},
  [1396] = {.lex_state = 186, .external_lex_state = 2},
  [1397] = {.lex_state = 186, .external_lex_state = 2},
  [1398] = {.lex_state = 307, .external_lex_state = 2},
  [1399] = {.lex_state = 307, .external_lex_state = 2},
  [1400] = {.lex_state = 159, .external_lex_state = 2},
  [1401] = {.lex_state = 159, .external_lex_state = 2},
  [1402] = {.lex_state = 159, .external_lex_state = 2},
  [1403] = {.lex_state = 186, .external_lex_state = 2},
  [1404] = {.lex_state = 186, .external_lex_state = 2},
  [1405] = {.lex_state = 265, .external_lex_state = 2},
  [1406] = {.lex_state = 183, .external_lex_state = 2},
  [1407] = {.lex_state = 197, .external_lex_state = 1},
  [1408] = {.lex_state = 183, .external_lex_state = 2},
  [1409] = {.lex_state = 172, .external_lex_state = 2},
  [1410] = {.lex_state = 200, .external_lex_state = 2},
  [1411] = {.lex_state = 182, .external_lex_state = 1},
  [1412] = {.lex_state = 172, .external_lex_state = 2},
  [1413] = {.lex_state = 186, .external_lex_state = 2},
  [1414] = {.lex_state = 186, .external_lex_state = 2},
  [1415] = {.lex_state = 186, .external_lex_state = 2},
  [1416] = {.lex_state = 308, .external_lex_state = 2},
  [1417] = {.lex_state = 308, .external_lex_state = 2},
  [1418] = {.lex_state = 159, .external_lex_state = 2},
  [1419] = {.lex_state = 159, .external_lex_state = 2},
  [1420] = {.lex_state = 159, .external_lex_state = 2},
  [1421] = {.lex_state = 186, .external_lex_state = 2},
  [1422] = {.lex_state = 186, .external_lex_state = 2},
  [1423] = {.lex_state = 182, .external_lex_state = 1},
  [1424] = {.lex_state = 172, .external_lex_state = 2},
  [1425] = {.lex_state = 183, .external_lex_state = 2},
  [1426] = {.lex_state = 182, .external_lex_state = 1},
  [1427] = {.lex_state = 250, .external_lex_state = 2},
  [1428] = {.lex_state = 197, .external_lex_state = 1},
  [1429] = {.lex_state = 183, .external_lex_state = 2},
  [1430] = {.lex_state = 250, .external_lex_state = 2},
  [1431] = {.lex_state = 245, .external_lex_state = 1},
  [1432] = {.lex_state = 182, .external_lex_state = 1},
  [1433] = {.lex_state = 182, .external_lex_state = 1},
  [1434] = {.lex_state = 182, .external_lex_state = 1},
  [1435] = {.lex_state = 182, .external_lex_state = 1},
  [1436] = {.lex_state = 182, .external_lex_state = 1},
  [1437] = {.lex_state = 182, .external_lex_state = 1},
  [1438] = {.lex_state = 182, .external_lex_state = 1},
  [1439] = {.lex_state = 182, .external_lex_state = 1},
  [1440] = {.lex_state = 182, .external_lex_state = 1},
  [1441] = {.lex_state = 182, .external_lex_state = 1},
  [1442] = {.lex_state = 182, .external_lex_state = 1},
  [1443] = {.lex_state = 285, .external_lex_state = 1},
  [1444] = {.lex_state = 182, .external_lex_state = 1},
  [1445] = {.lex_state = 186, .external_lex_state = 2},
  [1446] = {.lex_state = 250, .external_lex_state = 2},
  [1447] = {.lex_state = 186, .external_lex_state = 2},
  [1448] = {.lex_state = 186, .external_lex_state = 2},
  [1449] = {.lex_state = 186, .external_lex_state = 2},
  [1450] = {.lex_state = 309, .external_lex_state = 2},
  [1451] = {.lex_state = 309, .external_lex_state = 2},
  [1452] = {.lex_state = 159, .external_lex_state = 2},
  [1453] = {.lex_state = 159, .external_lex_state = 2},
  [1454] = {.lex_state = 159, .external_lex_state = 2},
  [1455] = {.lex_state = 186, .external_lex_state = 2},
  [1456] = {.lex_state = 186, .external_lex_state = 2},
  [1457] = {.lex_state = 182, .external_lex_state = 1},
  [1458] = {.lex_state = 182, .external_lex_state = 1},
  [1459] = {.lex_state = 172, .external_lex_state = 2},
  [1460] = {.lex_state = 254, .external_lex_state = 2},
  [1461] = {.lex_state = 192, .external_lex_state = 2},
  [1462] = {.lex_state = 192, .external_lex_state = 2},
  [1463] = {.lex_state = 171, .external_lex_state = 1},
  [1464] = {.lex_state = 186, .external_lex_state = 2},
  [1465] = {.lex_state = 186, .external_lex_state = 2},
  [1466] = {.lex_state = 186, .external_lex_state = 2},
  [1467] = {.lex_state = 192, .external_lex_state = 2},
  [1468] = {.lex_state = 192, .external_lex_state = 2},
  [1469] = {.lex_state = 253, .external_lex_state = 2},
  [1470] = {.lex_state = 192, .external_lex_state = 2},
  [1471] = {.lex_state = 186, .external_lex_state = 2},
  [1472] = {.lex_state = 192, .external_lex_state = 2},
  [1473] = {.lex_state = 186, .external_lex_state = 2},
  [1474] = {.lex_state = 186, .external_lex_state = 2},
  [1475] = {.lex_state = 186, .external_lex_state = 2},
  [1476] = {.lex_state = 172, .external_lex_state = 2},
  [1477] = {.lex_state = 172, .external_lex_state = 2},
  [1478] = {.lex_state = 250, .external_lex_state = 2},
  [1479] = {.lex_state = 253, .external_lex_state = 2},
  [1480] = {.lex_state = 253, .external_lex_state = 2},
  [1481] = {.lex_state = 186, .external_lex_state = 2},
  [1482] = {.lex_state = 186, .external_lex_state = 2},
  [1483] = {.lex_state = 186, .external_lex_state = 2},
  [1484] = {.lex_state = 192, .external_lex_state = 2},
  [1485] = {.lex_state = 186, .external_lex_state = 2},
  [1486] = {.lex_state = 186, .external_lex_state = 2},
  [1487] = {.lex_state = 178, .external_lex_state = 2},
  [1488] = {.lex_state = 251, .external_lex_state = 2},
  [1489] = {.lex_state = 186, .external_lex_state = 2},
  [1490] = {.lex_state = 252, .external_lex_state = 2},
  [1491] = {.lex_state = 252, .external_lex_state = 2},
  [1492] = {.lex_state = 253, .external_lex_state = 2},
  [1493] = {.lex_state = 192, .external_lex_state = 2},
  [1494] = {.lex_state = 192, .external_lex_state = 2},
  [1495] = {.lex_state = 183, .external_lex_state = 2},
  [1496] = {.lex_state = 192, .external_lex_state = 2},
  [1497] = {.lex_state = 201, .external_lex_state = 2},
  [1498] = {.lex_state = 192, .external_lex_state = 2},
  [1499] = {.lex_state = 253, .external_lex_state = 2},
  [1500] = {.lex_state = 253, .external_lex_state = 2},
  [1501] = {.lex_state = 257, .external_lex_state = 2},
  [1502] = {.lex_state = 253, .external_lex_state = 2},
  [1503] = {.lex_state = 248, .external_lex_state = 2},
  [1504] = {.lex_state = 282, .external_lex_state = 1},
  [1505] = {.lex_state = 200, .external_lex_state = 2},
  [1506] = {.lex_state = 171, .external_lex_state = 1},
  [1507] = {.lex_state = 286, .external_lex_state = 1},
  [1508] = {.lex_state = 250, .external_lex_state = 2},
  [1509] = {.lex_state = 284, .external_lex_state = 1},
  [1510] = {.lex_state = 186, .external_lex_state = 2},
  [1511] = {.lex_state = 186, .external_lex_state = 2},
  [1512] = {.lex_state = 178, .external_lex_state = 2},
  [1513] = {.lex_state = 186, .external_lex_state = 2},
  [1514] = {.lex_state = 172, .external_lex_state = 2},
  [1515] = {.lex_state = 186, .external_lex_state = 2},
  [1516] = {.lex_state = 172, .external_lex_state = 2},
  [1517] = {.lex_state = 159, .external_lex_state = 2},
  [1518] = {.lex_state = 159, .external_lex_state = 2},
  [1519] = {.lex_state = 159, .external_lex_state = 2},
  [1520] = {.lex_state = 186, .external_lex_state = 2},
  [1521] = {.lex_state = 186, .external_lex_state = 2},
  [1522] = {.lex_state = 252, .external_lex_state = 2},
  [1523] = {.lex_state = 172, .external_lex_state = 2},
  [1524] = {.lex_state = 186, .external_lex_state = 2},
  [1525] = {.lex_state = 253, .external_lex_state = 2},
  [1526] = {.lex_state = 253, .external_lex_state = 2},
  [1527] = {.lex_state = 186, .external_lex_state = 2},
  [1528] = {.lex_state = 186, .external_lex_state = 2},
  [1529] = {.lex_state = 186, .external_lex_state = 2},
  [1530] = {.lex_state = 186, .external_lex_state = 2},
  [1531] = {.lex_state = 186, .external_lex_state = 2},
  [1532] = {.lex_state = 172, .external_lex_state = 2},
  [1533] = {.lex_state = 172, .external_lex_state = 2},
  [1534] = {.lex_state = 159, .external_lex_state = 2},
  [1535] = {.lex_state = 159, .external_lex_state = 2},
  [1536] = {.lex_state = 159, .external_lex_state = 2},
  [1537] = {.lex_state = 186, .external_lex_state = 2},
  [1538] = {.lex_state = 186, .external_lex_state = 2},
  [1539] = {.lex_state = 259, .external_lex_state = 2},
  [1540] = {.lex_state = 192, .external_lex_state = 2},
  [1541] = {.lex_state = 258, .external_lex_state = 1},
  [1542] = {.lex_state = 192, .external_lex_state = 2},
  [1543] = {.lex_state = 186, .external_lex_state = 2},
  [1544] = {.lex_state = 186, .external_lex_state = 2},
  [1545] = {.lex_state = 186, .external_lex_state = 2},
  [1546] = {.lex_state = 172, .external_lex_state = 2},
  [1547] = {.lex_state = 172, .external_lex_state = 2},
  [1548] = {.lex_state = 159, .external_lex_state = 2},
  [1549] = {.lex_state = 159, .external_lex_state = 2},
  [1550] = {.lex_state = 159, .external_lex_state = 2},
  [1551] = {.lex_state = 186, .external_lex_state = 2},
  [1552] = {.lex_state = 186, .external_lex_state = 2},
  [1553] = {.lex_state = 192, .external_lex_state = 2},
  [1554] = {.lex_state = 197, .external_lex_state = 1},
  [1555] = {.lex_state = 178, .external_lex_state = 2},
  [1556] = {.lex_state = 287, .external_lex_state = 2},
  [1557] = {.lex_state = 192, .external_lex_state = 2},
  [1558] = {.lex_state = 172, .external_lex_state = 2},
  [1559] = {.lex_state = 192, .external_lex_state = 2},
  [1560] = {.lex_state = 172, .external_lex_state = 2},
  [1561] = {.lex_state = 192, .external_lex_state = 2},
  [1562] = {.lex_state = 192, .external_lex_state = 2},
  [1563] = {.lex_state = 192, .external_lex_state = 2},
  [1564] = {.lex_state = 178, .external_lex_state = 2},
  [1565] = {.lex_state = 259, .external_lex_state = 2},
  [1566] = {.lex_state = 258, .external_lex_state = 1},
  [1567] = {.lex_state = 192, .external_lex_state = 2},
  [1568] = {.lex_state = 259, .external_lex_state = 2},
  [1569] = {.lex_state = 201, .external_lex_state = 2},
  [1570] = {.lex_state = 172, .external_lex_state = 2},
  [1571] = {.lex_state = 197, .external_lex_state = 1},
  [1572] = {.lex_state = 274, .external_lex_state = 2},
  [1573] = {.lex_state = 198, .external_lex_state = 2},
  [1574] = {.lex_state = 259, .external_lex_state = 2},
  [1575] = {.lex_state = 274, .external_lex_state = 2},
  [1576] = {.lex_state = 198, .external_lex_state = 2},
  [1577] = {.lex_state = 186, .external_lex_state = 2},
  [1578] = {.lex_state = 186, .external_lex_state = 2},
  [1579] = {.lex_state = 186, .external_lex_state = 2},
  [1580] = {.lex_state = 172, .external_lex_state = 2},
  [1581] = {.lex_state = 172, .external_lex_state = 2},
  [1582] = {.lex_state = 159, .external_lex_state = 2},
  [1583] = {.lex_state = 159, .external_lex_state = 2},
  [1584] = {.lex_state = 159, .external_lex_state = 2},
  [1585] = {.lex_state = 186, .external_lex_state = 2},
  [1586] = {.lex_state = 182, .external_lex_state = 1},
  [1587] = {.lex_state = 186, .external_lex_state = 2},
  [1588] = {.lex_state = 171, .external_lex_state = 1},
  [1589] = {.lex_state = 265, .external_lex_state = 2},
  [1590] = {.lex_state = 274, .external_lex_state = 2},
  [1591] = {.lex_state = 182, .external_lex_state = 1},
  [1592] = {.lex_state = 201, .external_lex_state = 2},
  [1593] = {.lex_state = 274, .external_lex_state = 2},
  [1594] = {.lex_state = 198, .external_lex_state = 2},
  [1595] = {.lex_state = 182, .external_lex_state = 2},
  [1596] = {.lex_state = 198, .external_lex_state = 2},
  [1597] = {.lex_state = 172, .external_lex_state = 2},
  [1598] = {.lex_state = 251, .external_lex_state = 2},
  [1599] = {.lex_state = 186, .external_lex_state = 2},
  [1600] = {.lex_state = 159, .external_lex_state = 2},
  [1601] = {.lex_state = 186, .external_lex_state = 2},
  [1602] = {.lex_state = 178, .external_lex_state = 2},
  [1603] = {.lex_state = 256, .external_lex_state = 2},
  [1604] = {.lex_state = 192, .external_lex_state = 2},
  [1605] = {.lex_state = 186, .external_lex_state = 2},
  [1606] = {.lex_state = 253, .external_lex_state = 2},
  [1607] = {.lex_state = 186, .external_lex_state = 2},
  [1608] = {.lex_state = 183, .external_lex_state = 2},
  [1609] = {.lex_state = 198, .external_lex_state = 2},
  [1610] = {.lex_state = 172, .external_lex_state = 2},
  [1611] = {.lex_state = 183, .external_lex_state = 2},
  [1612] = {.lex_state = 171, .external_lex_state = 1},
  [1613] = {.lex_state = 171, .external_lex_state = 1},
  [1614] = {.lex_state = 186, .external_lex_state = 2},
  [1615] = {.lex_state = 172, .external_lex_state = 2},
  [1616] = {.lex_state = 171, .external_lex_state = 1},
  [1617] = {.lex_state = 171, .external_lex_state = 1},
  [1618] = {.lex_state = 200, .external_lex_state = 2},
  [1619] = {.lex_state = 171, .external_lex_state = 1},
  [1620] = {.lex_state = 251, .external_lex_state = 2},
  [1621] = {.lex_state = 186, .external_lex_state = 2},
  [1622] = {.lex_state = 159, .external_lex_state = 2},
  [1623] = {.lex_state = 252, .external_lex_state = 2},
  [1624] = {.lex_state = 256, .external_lex_state = 2},
  [1625] = {.lex_state = 172, .external_lex_state = 2},
  [1626] = {.lex_state = 172, .external_lex_state = 2},
  [1627] = {.lex_state = 172, .external_lex_state = 2},
  [1628] = {.lex_state = 252, .external_lex_state = 2},
  [1629] = {.lex_state = 172, .external_lex_state = 2},
  [1630] = {.lex_state = 172, .external_lex_state = 2},
  [1631] = {.lex_state = 192, .external_lex_state = 2},
  [1632] = {.lex_state = 172, .external_lex_state = 2},
  [1633] = {.lex_state = 192, .external_lex_state = 2},
  [1634] = {.lex_state = 244, .external_lex_state = 1},
  [1635] = {.lex_state = 182, .external_lex_state = 1},
  [1636] = {.lex_state = 172, .external_lex_state = 2},
  [1637] = {.lex_state = 183, .external_lex_state = 2},
  [1638] = {.lex_state = 186, .external_lex_state = 2},
  [1639] = {.lex_state = 186, .external_lex_state = 2},
  [1640] = {.lex_state = 186, .external_lex_state = 2},
  [1641] = {.lex_state = 307, .external_lex_state = 2},
  [1642] = {.lex_state = 307, .external_lex_state = 2},
  [1643] = {.lex_state = 159, .external_lex_state = 2},
  [1644] = {.lex_state = 159, .external_lex_state = 2},
  [1645] = {.lex_state = 159, .external_lex_state = 2},
  [1646] = {.lex_state = 186, .external_lex_state = 2},
  [1647] = {.lex_state = 186, .external_lex_state = 2},
  [1648] = {.lex_state = 244, .external_lex_state = 1},
  [1649] = {.lex_state = 251, .external_lex_state = 2},
  [1650] = {.lex_state = 186, .external_lex_state = 2},
  [1651] = {.lex_state = 186, .external_lex_state = 2},
  [1652] = {.lex_state = 159, .external_lex_state = 2},
  [1653] = {.lex_state = 172, .external_lex_state = 2},
  [1654] = {.lex_state = 178, .external_lex_state = 2},
  [1655] = {.lex_state = 256, .external_lex_state = 2},
  [1656] = {.lex_state = 172, .external_lex_state = 2},
  [1657] = {.lex_state = 172, .external_lex_state = 2},
  [1658] = {.lex_state = 178, .external_lex_state = 2},
  [1659] = {.lex_state = 192, .external_lex_state = 2},
  [1660] = {.lex_state = 172, .external_lex_state = 2},
  [1661] = {.lex_state = 172, .external_lex_state = 2},
  [1662] = {.lex_state = 192, .external_lex_state = 2},
  [1663] = {.lex_state = 172, .external_lex_state = 2},
  [1664] = {.lex_state = 172, .external_lex_state = 2},
  [1665] = {.lex_state = 277, .external_lex_state = 2},
  [1666] = {.lex_state = 172, .external_lex_state = 2},
  [1667] = {.lex_state = 277, .external_lex_state = 2},
  [1668] = {.lex_state = 172, .external_lex_state = 2},
  [1669] = {.lex_state = 186, .external_lex_state = 2},
  [1670] = {.lex_state = 186, .external_lex_state = 2},
  [1671] = {.lex_state = 186, .external_lex_state = 2},
  [1672] = {.lex_state = 172, .external_lex_state = 2},
  [1673] = {.lex_state = 172, .external_lex_state = 2},
  [1674] = {.lex_state = 159, .external_lex_state = 2},
  [1675] = {.lex_state = 159, .external_lex_state = 2},
  [1676] = {.lex_state = 159, .external_lex_state = 2},
  [1677] = {.lex_state = 186, .external_lex_state = 2},
  [1678] = {.lex_state = 186, .external_lex_state = 2},
  [1679] = {.lex_state = 171, .external_lex_state = 1},
  [1680] = {.lex_state = 172, .external_lex_state = 2},
  [1681] = {.lex_state = 171, .external_lex_state = 1},
  [1682] = {.lex_state = 172, .external_lex_state = 2},
  [1683] = {.lex_state = 172, .external_lex_state = 2},
  [1684] = {.lex_state = 171, .external_lex_state = 1},
  [1685] = {.lex_state = 172, .external_lex_state = 2},
  [1686] = {.lex_state = 172, .external_lex_state = 2},
  [1687] = {.lex_state = 172, .external_lex_state = 2},
  [1688] = {.lex_state = 183, .external_lex_state = 2},
  [1689] = {.lex_state = 186, .external_lex_state = 2},
  [1690] = {.lex_state = 186, .external_lex_state = 2},
  [1691] = {.lex_state = 186, .external_lex_state = 2},
  [1692] = {.lex_state = 172, .external_lex_state = 2},
  [1693] = {.lex_state = 172, .external_lex_state = 2},
  [1694] = {.lex_state = 159, .external_lex_state = 2},
  [1695] = {.lex_state = 159, .external_lex_state = 2},
  [1696] = {.lex_state = 159, .external_lex_state = 2},
  [1697] = {.lex_state = 171, .external_lex_state = 1},
  [1698] = {.lex_state = 186, .external_lex_state = 2},
  [1699] = {.lex_state = 182, .external_lex_state = 1},
  [1700] = {.lex_state = 186, .external_lex_state = 2},
  [1701] = {.lex_state = 274, .external_lex_state = 2},
  [1702] = {.lex_state = 192, .external_lex_state = 2},
  [1703] = {.lex_state = 192, .external_lex_state = 2},
  [1704] = {.lex_state = 172, .external_lex_state = 2},
  [1705] = {.lex_state = 197, .external_lex_state = 1},
  [1706] = {.lex_state = 274, .external_lex_state = 2},
  [1707] = {.lex_state = 278, .external_lex_state = 2},
  [1708] = {.lex_state = 172, .external_lex_state = 2},
  [1709] = {.lex_state = 274, .external_lex_state = 2},
  [1710] = {.lex_state = 274, .external_lex_state = 2},
  [1711] = {.lex_state = 258, .external_lex_state = 1},
  [1712] = {.lex_state = 274, .external_lex_state = 2},
  [1713] = {.lex_state = 172, .external_lex_state = 2},
  [1714] = {.lex_state = 197, .external_lex_state = 1},
  [1715] = {.lex_state = 172, .external_lex_state = 2},
  [1716] = {.lex_state = 172, .external_lex_state = 2},
  [1717] = {.lex_state = 172, .external_lex_state = 2},
  [1718] = {.lex_state = 274, .external_lex_state = 2},
  [1719] = {.lex_state = 244, .external_lex_state = 1},
  [1720] = {.lex_state = 182, .external_lex_state = 1},
  [1721] = {.lex_state = 197, .external_lex_state = 1},
  [1722] = {.lex_state = 182, .external_lex_state = 1},
  [1723] = {.lex_state = 274, .external_lex_state = 2},
  [1724] = {.lex_state = 288, .external_lex_state = 1},
  [1725] = {.lex_state = 198, .external_lex_state = 2},
  [1726] = {.lex_state = 197, .external_lex_state = 1},
  [1727] = {.lex_state = 198, .external_lex_state = 2},
  [1728] = {.lex_state = 197, .external_lex_state = 1},
  [1729] = {.lex_state = 192, .external_lex_state = 2},
  [1730] = {.lex_state = 192, .external_lex_state = 2},
  [1731] = {.lex_state = 172, .external_lex_state = 2},
  [1732] = {.lex_state = 171, .external_lex_state = 1},
  [1733] = {.lex_state = 182, .external_lex_state = 1},
  [1734] = {.lex_state = 302, .external_lex_state = 2},
  [1735] = {.lex_state = 172, .external_lex_state = 2},
  [1736] = {.lex_state = 265, .external_lex_state = 2},
  [1737] = {.lex_state = 192, .external_lex_state = 2},
  [1738] = {.lex_state = 186, .external_lex_state = 2},
  [1739] = {.lex_state = 192, .external_lex_state = 2},
  [1740] = {.lex_state = 186, .external_lex_state = 2},
  [1741] = {.lex_state = 186, .external_lex_state = 2},
  [1742] = {.lex_state = 171, .external_lex_state = 1},
  [1743] = {.lex_state = 186, .external_lex_state = 2},
  [1744] = {.lex_state = 274, .external_lex_state = 2},
  [1745] = {.lex_state = 198, .external_lex_state = 2},
  [1746] = {.lex_state = 192, .external_lex_state = 2},
  [1747] = {.lex_state = 198, .external_lex_state = 2},
  [1748] = {.lex_state = 186, .external_lex_state = 2},
  [1749] = {.lex_state = 277, .external_lex_state = 2},
  [1750] = {.lex_state = 183, .external_lex_state = 2},
  [1751] = {.lex_state = 172, .external_lex_state = 2},
  [1752] = {.lex_state = 172, .external_lex_state = 2},
  [1753] = {.lex_state = 192, .external_lex_state = 2},
  [1754] = {.lex_state = 172, .external_lex_state = 2},
  [1755] = {.lex_state = 192, .external_lex_state = 2},
  [1756] = {.lex_state = 171, .external_lex_state = 1},
  [1757] = {.lex_state = 172, .external_lex_state = 2},
  [1758] = {.lex_state = 172, .external_lex_state = 2},
  [1759] = {.lex_state = 186, .external_lex_state = 2},
  [1760] = {.lex_state = 172, .external_lex_state = 2},
  [1761] = {.lex_state = 186, .external_lex_state = 2},
  [1762] = {.lex_state = 186, .external_lex_state = 2},
  [1763] = {.lex_state = 172, .external_lex_state = 2},
  [1764] = {.lex_state = 186, .external_lex_state = 2},
  [1765] = {.lex_state = 192, .external_lex_state = 2},
  [1766] = {.lex_state = 172, .external_lex_state = 2},
  [1767] = {.lex_state = 192, .external_lex_state = 2},
  [1768] = {.lex_state = 172, .external_lex_state = 2},
  [1769] = {.lex_state = 171, .external_lex_state = 1},
  [1770] = {.lex_state = 186, .external_lex_state = 2},
  [1771] = {.lex_state = 186, .external_lex_state = 2},
  [1772] = {.lex_state = 186, .external_lex_state = 2},
  [1773] = {.lex_state = 172, .external_lex_state = 2},
  [1774] = {.lex_state = 186, .external_lex_state = 2},
  [1775] = {.lex_state = 172, .external_lex_state = 2},
  [1776] = {.lex_state = 159, .external_lex_state = 2},
  [1777] = {.lex_state = 159, .external_lex_state = 2},
  [1778] = {.lex_state = 159, .external_lex_state = 2},
  [1779] = {.lex_state = 186, .external_lex_state = 2},
  [1780] = {.lex_state = 172, .external_lex_state = 2},
  [1781] = {.lex_state = 186, .external_lex_state = 2},
  [1782] = {.lex_state = 171, .external_lex_state = 1},
  [1783] = {.lex_state = 186, .external_lex_state = 2},
  [1784] = {.lex_state = 186, .external_lex_state = 2},
  [1785] = {.lex_state = 172, .external_lex_state = 2},
  [1786] = {.lex_state = 171, .external_lex_state = 1},
  [1787] = {.lex_state = 172, .external_lex_state = 2},
  [1788] = {.lex_state = 171, .external_lex_state = 1},
  [1789] = {.lex_state = 172, .external_lex_state = 2},
  [1790] = {.lex_state = 172, .external_lex_state = 2},
  [1791] = {.lex_state = 172, .external_lex_state = 2},
  [1792] = {.lex_state = 172, .external_lex_state = 2},
  [1793] = {.lex_state = 198, .external_lex_state = 2},
  [1794] = {.lex_state = 274, .external_lex_state = 2},
  [1795] = {.lex_state = 274, .external_lex_state = 2},
  [1796] = {.lex_state = 274, .external_lex_state = 2},
  [1797] = {.lex_state = 198, .external_lex_state = 2},
  [1798] = {.lex_state = 274, .external_lex_state = 2},
  [1799] = {.lex_state = 198, .external_lex_state = 2},
  [1800] = {.lex_state = 198, .external_lex_state = 2},
  [1801] = {.lex_state = 198, .external_lex_state = 2},
  [1802] = {.lex_state = 198, .external_lex_state = 2},
  [1803] = {.lex_state = 183, .external_lex_state = 2},
  [1804] = {.lex_state = 172, .external_lex_state = 2},
  [1805] = {.lex_state = 183, .external_lex_state = 2},
  [1806] = {.lex_state = 172, .external_lex_state = 2},
  [1807] = {.lex_state = 182, .external_lex_state = 1},
  [1808] = {.lex_state = 200, .external_lex_state = 2},
  [1809] = {.lex_state = 197, .external_lex_state = 1},
  [1810] = {.lex_state = 183, .external_lex_state = 2},
  [1811] = {.lex_state = 200, .external_lex_state = 2},
  [1812] = {.lex_state = 245, .external_lex_state = 1},
  [1813] = {.lex_state = 182, .external_lex_state = 1},
  [1814] = {.lex_state = 182, .external_lex_state = 1},
  [1815] = {.lex_state = 182, .external_lex_state = 1},
  [1816] = {.lex_state = 182, .external_lex_state = 1},
  [1817] = {.lex_state = 182, .external_lex_state = 1},
  [1818] = {.lex_state = 182, .external_lex_state = 1},
  [1819] = {.lex_state = 182, .external_lex_state = 1},
  [1820] = {.lex_state = 182, .external_lex_state = 1},
  [1821] = {.lex_state = 182, .external_lex_state = 1},
  [1822] = {.lex_state = 182, .external_lex_state = 1},
  [1823] = {.lex_state = 182, .external_lex_state = 1},
  [1824] = {.lex_state = 272, .external_lex_state = 1},
  [1825] = {.lex_state = 182, .external_lex_state = 1},
  [1826] = {.lex_state = 186, .external_lex_state = 2},
  [1827] = {.lex_state = 200, .external_lex_state = 2},
  [1828] = {.lex_state = 200, .external_lex_state = 2},
  [1829] = {.lex_state = 183, .external_lex_state = 2},
  [1830] = {.lex_state = 201, .external_lex_state = 2},
  [1831] = {.lex_state = 198, .external_lex_state = 2},
  [1832] = {.lex_state = 274, .external_lex_state = 2},
  [1833] = {.lex_state = 198, .external_lex_state = 2},
  [1834] = {.lex_state = 183, .external_lex_state = 2},
  [1835] = {.lex_state = 274, .external_lex_state = 2},
  [1836] = {.lex_state = 182, .external_lex_state = 1},
  [1837] = {.lex_state = 186, .external_lex_state = 2},
  [1838] = {.lex_state = 183, .external_lex_state = 2},
  [1839] = {.lex_state = 172, .external_lex_state = 2},
  [1840] = {.lex_state = 303, .external_lex_state = 1},
  [1841] = {.lex_state = 248, .external_lex_state = 2},
  [1842] = {.lex_state = 282, .external_lex_state = 1},
  [1843] = {.lex_state = 303, .external_lex_state = 1},
  [1844] = {.lex_state = 200, .external_lex_state = 2},
  [1845] = {.lex_state = 171, .external_lex_state = 1},
  [1846] = {.lex_state = 286, .external_lex_state = 1},
  [1847] = {.lex_state = 282, .external_lex_state = 1},
  [1848] = {.lex_state = 283, .external_lex_state = 1},
  [1849] = {.lex_state = 284, .external_lex_state = 1},
  [1850] = {.lex_state = 303, .external_lex_state = 1},
  [1851] = {.lex_state = 284, .external_lex_state = 1},
  [1852] = {.lex_state = 284, .external_lex_state = 1},
  [1853] = {.lex_state = 284, .external_lex_state = 1},
  [1854] = {.lex_state = 284, .external_lex_state = 1},
  [1855] = {.lex_state = 284, .external_lex_state = 1},
  [1856] = {.lex_state = 284, .external_lex_state = 1},
  [1857] = {.lex_state = 284, .external_lex_state = 1},
  [1858] = {.lex_state = 284, .external_lex_state = 1},
  [1859] = {.lex_state = 284, .external_lex_state = 1},
  [1860] = {.lex_state = 284, .external_lex_state = 1},
  [1861] = {.lex_state = 284, .external_lex_state = 1},
  [1862] = {.lex_state = 284, .external_lex_state = 1},
  [1863] = {.lex_state = 284, .external_lex_state = 1},
  [1864] = {.lex_state = 250, .external_lex_state = 2},
  [1865] = {.lex_state = 284, .external_lex_state = 1},
  [1866] = {.lex_state = 284, .external_lex_state = 1},
  [1867] = {.lex_state = 282, .external_lex_state = 1},
  [1868] = {.lex_state = 305, .external_lex_state = 1},
  [1869] = {.lex_state = 237, .external_lex_state = 2},
  [1870] = {.lex_state = 244, .external_lex_state = 1},
  [1871] = {.lex_state = 178, .external_lex_state = 1},
  [1872] = {.lex_state = 192, .external_lex_state = 2},
  [1873] = {.lex_state = 282, .external_lex_state = 1},
  [1874] = {.lex_state = 244, .external_lex_state = 1},
  [1875] = {.lex_state = 283, .external_lex_state = 1},
  [1876] = {.lex_state = 284, .external_lex_state = 1},
  [1877] = {.lex_state = 305, .external_lex_state = 1},
  [1878] = {.lex_state = 282, .external_lex_state = 1},
  [1879] = {.lex_state = 286, .external_lex_state = 1},
  [1880] = {.lex_state = 248, .external_lex_state = 2},
  [1881] = {.lex_state = 283, .external_lex_state = 1},
  [1882] = {.lex_state = 200, .external_lex_state = 2},
  [1883] = {.lex_state = 171, .external_lex_state = 1},
  [1884] = {.lex_state = 286, .external_lex_state = 1},
  [1885] = {.lex_state = 250, .external_lex_state = 2},
  [1886] = {.lex_state = 200, .external_lex_state = 2},
  [1887] = {.lex_state = 286, .external_lex_state = 1},
  [1888] = {.lex_state = 181, .external_lex_state = 1},
  [1889] = {.lex_state = 172, .external_lex_state = 2},
  [1890] = {.lex_state = 284, .external_lex_state = 1},
  [1891] = {.lex_state = 172, .external_lex_state = 2},
  [1892] = {.lex_state = 178, .external_lex_state = 2},
  [1893] = {.lex_state = 171, .external_lex_state = 2},
  [1894] = {.lex_state = 172, .external_lex_state = 2},
  [1895] = {.lex_state = 172, .external_lex_state = 2},
  [1896] = {.lex_state = 186, .external_lex_state = 2},
  [1897] = {.lex_state = 274, .external_lex_state = 2},
  [1898] = {.lex_state = 275, .external_lex_state = 2},
  [1899] = {.lex_state = 172, .external_lex_state = 2},
  [1900] = {.lex_state = 172, .external_lex_state = 2},
  [1901] = {.lex_state = 159, .external_lex_state = 2},
  [1902] = {.lex_state = 172, .external_lex_state = 2},
  [1903] = {.lex_state = 275, .external_lex_state = 2},
  [1904] = {.lex_state = 172, .external_lex_state = 2},
  [1905] = {.lex_state = 172, .external_lex_state = 2},
  [1906] = {.lex_state = 172, .external_lex_state = 2},
  [1907] = {.lex_state = 172, .external_lex_state = 2},
  [1908] = {.lex_state = 172, .external_lex_state = 2},
  [1909] = {.lex_state = 275, .external_lex_state = 2},
  [1910] = {.lex_state = 172, .external_lex_state = 2},
  [1911] = {.lex_state = 172, .external_lex_state = 2},
  [1912] = {.lex_state = 172, .external_lex_state = 2},
  [1913] = {.lex_state = 192, .external_lex_state = 2},
  [1914] = {.lex_state = 275, .external_lex_state = 2},
  [1915] = {.lex_state = 186, .external_lex_state = 2},
  [1916] = {.lex_state = 182, .external_lex_state = 1},
  [1917] = {.lex_state = 275, .external_lex_state = 2},
  [1918] = {.lex_state = 192, .external_lex_state = 2},
  [1919] = {.lex_state = 186, .external_lex_state = 2},
  [1920] = {.lex_state = 275, .external_lex_state = 2},
  [1921] = {.lex_state = 172, .external_lex_state = 2},
  [1922] = {.lex_state = 159, .external_lex_state = 2},
  [1923] = {.lex_state = 183, .external_lex_state = 2},
  [1924] = {.lex_state = 275, .external_lex_state = 2},
  [1925] = {.lex_state = 172, .external_lex_state = 2},
  [1926] = {.lex_state = 192, .external_lex_state = 2},
  [1927] = {.lex_state = 275, .external_lex_state = 2},
  [1928] = {.lex_state = 186, .external_lex_state = 2},
  [1929] = {.lex_state = 172, .external_lex_state = 2},
  [1930] = {.lex_state = 172, .external_lex_state = 2},
  [1931] = {.lex_state = 275, .external_lex_state = 2},
  [1932] = {.lex_state = 172, .external_lex_state = 2},
  [1933] = {.lex_state = 159, .external_lex_state = 2},
  [1934] = {.lex_state = 183, .external_lex_state = 2},
  [1935] = {.lex_state = 198, .external_lex_state = 2},
  [1936] = {.lex_state = 275, .external_lex_state = 2},
  [1937] = {.lex_state = 172, .external_lex_state = 2},
  [1938] = {.lex_state = 159, .external_lex_state = 2},
  [1939] = {.lex_state = 275, .external_lex_state = 2},
  [1940] = {.lex_state = 275, .external_lex_state = 2},
  [1941] = {.lex_state = 192, .external_lex_state = 2},
  [1942] = {.lex_state = 172, .external_lex_state = 2},
  [1943] = {.lex_state = 172, .external_lex_state = 2},
  [1944] = {.lex_state = 172, .external_lex_state = 2},
  [1945] = {.lex_state = 252, .external_lex_state = 2},
  [1946] = {.lex_state = 192, .external_lex_state = 2},
  [1947] = {.lex_state = 172, .external_lex_state = 2},
  [1948] = {.lex_state = 252, .external_lex_state = 2},
  [1949] = {.lex_state = 172, .external_lex_state = 2},
  [1950] = {.lex_state = 172, .external_lex_state = 2},
  [1951] = {.lex_state = 172, .external_lex_state = 2},
  [1952] = {.lex_state = 275, .external_lex_state = 2},
  [1953] = {.lex_state = 172, .external_lex_state = 2},
  [1954] = {.lex_state = 171, .external_lex_state = 1},
  [1955] = {.lex_state = 172, .external_lex_state = 2},
  [1956] = {.lex_state = 186, .external_lex_state = 2},
  [1957] = {.lex_state = 171, .external_lex_state = 1},
  [1958] = {.lex_state = 172, .external_lex_state = 2},
  [1959] = {.lex_state = 172, .external_lex_state = 2},
  [1960] = {.lex_state = 159, .external_lex_state = 2},
  [1961] = {.lex_state = 171, .external_lex_state = 1},
  [1962] = {.lex_state = 172, .external_lex_state = 2},
  [1963] = {.lex_state = 172, .external_lex_state = 2},
  [1964] = {.lex_state = 186, .external_lex_state = 2},
  [1965] = {.lex_state = 171, .external_lex_state = 1},
  [1966] = {.lex_state = 172, .external_lex_state = 2},
  [1967] = {.lex_state = 159, .external_lex_state = 2},
  [1968] = {.lex_state = 171, .external_lex_state = 1},
  [1969] = {.lex_state = 172, .external_lex_state = 2},
  [1970] = {.lex_state = 159, .external_lex_state = 2},
  [1971] = {.lex_state = 183, .external_lex_state = 2},
  [1972] = {.lex_state = 248, .external_lex_state = 2},
  [1973] = {.lex_state = 178, .external_lex_state = 1},
  [1974] = {.lex_state = 192, .external_lex_state = 2},
  [1975] = {.lex_state = 172, .external_lex_state = 2},
  [1976] = {.lex_state = 250, .external_lex_state = 2},
  [1977] = {.lex_state = 250, .external_lex_state = 2},
  [1978] = {.lex_state = 250, .external_lex_state = 2},
  [1979] = {.lex_state = 250, .external_lex_state = 2},
  [1980] = {.lex_state = 250, .external_lex_state = 2},
  [1981] = {.lex_state = 250, .external_lex_state = 2},
  [1982] = {.lex_state = 250, .external_lex_state = 2},
  [1983] = {.lex_state = 250, .external_lex_state = 2},
  [1984] = {.lex_state = 250, .external_lex_state = 2},
  [1985] = {.lex_state = 250, .external_lex_state = 2},
  [1986] = {.lex_state = 250, .external_lex_state = 2},
  [1987] = {.lex_state = 250, .external_lex_state = 2},
  [1988] = {.lex_state = 250, .external_lex_state = 2},
  [1989] = {.lex_state = 251, .external_lex_state = 2},
  [1990] = {.lex_state = 186, .external_lex_state = 2},
  [1991] = {.lex_state = 159, .external_lex_state = 2},
  [1992] = {.lex_state = 250, .external_lex_state = 2},
  [1993] = {.lex_state = 256, .external_lex_state = 2},
  [1994] = {.lex_state = 172, .external_lex_state = 2},
  [1995] = {.lex_state = 250, .external_lex_state = 2},
  [1996] = {.lex_state = 183, .external_lex_state = 2},
  [1997] = {.lex_state = 186, .external_lex_state = 2},
  [1998] = {.lex_state = 192, .external_lex_state = 2},
  [1999] = {.lex_state = 182, .external_lex_state = 1},
  [2000] = {.lex_state = 183, .external_lex_state = 2},
  [2001] = {.lex_state = 183, .external_lex_state = 2},
  [2002] = {.lex_state = 183, .external_lex_state = 2},
  [2003] = {.lex_state = 183, .external_lex_state = 2},
  [2004] = {.lex_state = 186, .external_lex_state = 2},
  [2005] = {.lex_state = 310, .external_lex_state = 2},
  [2006] = {.lex_state = 192, .external_lex_state = 2},
  [2007] = {.lex_state = 192, .external_lex_state = 2},
  [2008] = {.lex_state = 192, .external_lex_state = 2},
  [2009] = {.lex_state = 192, .external_lex_state = 2},
  [2010] = {.lex_state = 186, .external_lex_state = 2},
  [2011] = {.lex_state = 183, .external_lex_state = 2},
  [2012] = {.lex_state = 186, .external_lex_state = 2},
  [2013] = {.lex_state = 307, .external_lex_state = 2},
  [2014] = {.lex_state = 307, .external_lex_state = 2},
  [2015] = {.lex_state = 172, .external_lex_state = 2},
  [2016] = {.lex_state = 183, .external_lex_state = 2},
  [2017] = {.lex_state = 183, .external_lex_state = 2},
  [2018] = {.lex_state = 183, .external_lex_state = 2},
  [2019] = {.lex_state = 186, .external_lex_state = 2},
  [2020] = {.lex_state = 186, .external_lex_state = 2},
  [2021] = {.lex_state = 186, .external_lex_state = 2},
  [2022] = {.lex_state = 172, .external_lex_state = 2},
  [2023] = {.lex_state = 172, .external_lex_state = 2},
  [2024] = {.lex_state = 182, .external_lex_state = 1},
  [2025] = {.lex_state = 172, .external_lex_state = 2},
  [2026] = {.lex_state = 244, .external_lex_state = 1},
  [2027] = {.lex_state = 305, .external_lex_state = 1},
  [2028] = {.lex_state = 282, .external_lex_state = 1},
  [2029] = {.lex_state = 286, .external_lex_state = 1},
  [2030] = {.lex_state = 284, .external_lex_state = 1},
  [2031] = {.lex_state = 282, .external_lex_state = 1},
  [2032] = {.lex_state = 172, .external_lex_state = 2},
  [2033] = {.lex_state = 198, .external_lex_state = 2},
  [2034] = {.lex_state = 282, .external_lex_state = 1},
  [2035] = {.lex_state = 286, .external_lex_state = 1},
  [2036] = {.lex_state = 284, .external_lex_state = 1},
  [2037] = {.lex_state = 171, .external_lex_state = 1},
  [2038] = {.lex_state = 256, .external_lex_state = 2},
  [2039] = {.lex_state = 172, .external_lex_state = 2},
  [2040] = {.lex_state = 172, .external_lex_state = 2},
  [2041] = {.lex_state = 183, .external_lex_state = 2},
  [2042] = {.lex_state = 183, .external_lex_state = 2},
  [2043] = {.lex_state = 183, .external_lex_state = 2},
  [2044] = {.lex_state = 183, .external_lex_state = 2},
  [2045] = {.lex_state = 198, .external_lex_state = 2},
  [2046] = {.lex_state = 183, .external_lex_state = 2},
  [2047] = {.lex_state = 276, .external_lex_state = 2},
  [2048] = {.lex_state = 178, .external_lex_state = 1},
  [2049] = {.lex_state = 192, .external_lex_state = 2},
  [2050] = {.lex_state = 276, .external_lex_state = 2},
  [2051] = {.lex_state = 200, .external_lex_state = 2},
  [2052] = {.lex_state = 181, .external_lex_state = 1},
  [2053] = {.lex_state = 172, .external_lex_state = 2},
  [2054] = {.lex_state = 183, .external_lex_state = 2},
  [2055] = {.lex_state = 182, .external_lex_state = 1},
  [2056] = {.lex_state = 182, .external_lex_state = 1},
  [2057] = {.lex_state = 272, .external_lex_state = 1},
  [2058] = {.lex_state = 182, .external_lex_state = 1},
  [2059] = {.lex_state = 272, .external_lex_state = 1},
  [2060] = {.lex_state = 172, .external_lex_state = 2},
  [2061] = {.lex_state = 183, .external_lex_state = 2},
  [2062] = {.lex_state = 245, .external_lex_state = 1},
  [2063] = {.lex_state = 186, .external_lex_state = 2},
  [2064] = {.lex_state = 186, .external_lex_state = 2},
  [2065] = {.lex_state = 186, .external_lex_state = 2},
  [2066] = {.lex_state = 307, .external_lex_state = 2},
  [2067] = {.lex_state = 307, .external_lex_state = 2},
  [2068] = {.lex_state = 182, .external_lex_state = 1},
  [2069] = {.lex_state = 172, .external_lex_state = 2},
  [2070] = {.lex_state = 183, .external_lex_state = 2},
  [2071] = {.lex_state = 182, .external_lex_state = 1},
  [2072] = {.lex_state = 172, .external_lex_state = 2},
  [2073] = {.lex_state = 183, .external_lex_state = 2},
  [2074] = {.lex_state = 186, .external_lex_state = 2},
  [2075] = {.lex_state = 186, .external_lex_state = 2},
  [2076] = {.lex_state = 186, .external_lex_state = 2},
  [2077] = {.lex_state = 308, .external_lex_state = 2},
  [2078] = {.lex_state = 308, .external_lex_state = 2},
  [2079] = {.lex_state = 183, .external_lex_state = 2},
  [2080] = {.lex_state = 172, .external_lex_state = 2},
  [2081] = {.lex_state = 250, .external_lex_state = 2},
  [2082] = {.lex_state = 250, .external_lex_state = 2},
  [2083] = {.lex_state = 250, .external_lex_state = 2},
  [2084] = {.lex_state = 250, .external_lex_state = 2},
  [2085] = {.lex_state = 250, .external_lex_state = 2},
  [2086] = {.lex_state = 250, .external_lex_state = 2},
  [2087] = {.lex_state = 250, .external_lex_state = 2},
  [2088] = {.lex_state = 250, .external_lex_state = 2},
  [2089] = {.lex_state = 250, .external_lex_state = 2},
  [2090] = {.lex_state = 250, .external_lex_state = 2},
  [2091] = {.lex_state = 250, .external_lex_state = 2},
  [2092] = {.lex_state = 250, .external_lex_state = 2},
  [2093] = {.lex_state = 250, .external_lex_state = 2},
  [2094] = {.lex_state = 251, .external_lex_state = 2},
  [2095] = {.lex_state = 186, .external_lex_state = 2},
  [2096] = {.lex_state = 159, .external_lex_state = 2},
  [2097] = {.lex_state = 250, .external_lex_state = 2},
  [2098] = {.lex_state = 256, .external_lex_state = 2},
  [2099] = {.lex_state = 172, .external_lex_state = 2},
  [2100] = {.lex_state = 250, .external_lex_state = 2},
  [2101] = {.lex_state = 186, .external_lex_state = 2},
  [2102] = {.lex_state = 186, .external_lex_state = 2},
  [2103] = {.lex_state = 186, .external_lex_state = 2},
  [2104] = {.lex_state = 309, .external_lex_state = 2},
  [2105] = {.lex_state = 309, .external_lex_state = 2},
  [2106] = {.lex_state = 183, .external_lex_state = 2},
  [2107] = {.lex_state = 254, .external_lex_state = 2},
  [2108] = {.lex_state = 287, .external_lex_state = 2},
  [2109] = {.lex_state = 192, .external_lex_state = 2},
  [2110] = {.lex_state = 186, .external_lex_state = 2},
  [2111] = {.lex_state = 186, .external_lex_state = 2},
  [2112] = {.lex_state = 253, .external_lex_state = 2},
  [2113] = {.lex_state = 186, .external_lex_state = 2},
  [2114] = {.lex_state = 186, .external_lex_state = 2},
  [2115] = {.lex_state = 186, .external_lex_state = 2},
  [2116] = {.lex_state = 253, .external_lex_state = 2},
  [2117] = {.lex_state = 192, .external_lex_state = 2},
  [2118] = {.lex_state = 192, .external_lex_state = 2},
  [2119] = {.lex_state = 253, .external_lex_state = 2},
  [2120] = {.lex_state = 192, .external_lex_state = 2},
  [2121] = {.lex_state = 192, .external_lex_state = 2},
  [2122] = {.lex_state = 192, .external_lex_state = 2},
  [2123] = {.lex_state = 186, .external_lex_state = 2},
  [2124] = {.lex_state = 192, .external_lex_state = 2},
  [2125] = {.lex_state = 192, .external_lex_state = 2},
  [2126] = {.lex_state = 192, .external_lex_state = 2},
  [2127] = {.lex_state = 186, .external_lex_state = 2},
  [2128] = {.lex_state = 178, .external_lex_state = 2},
  [2129] = {.lex_state = 178, .external_lex_state = 2},
  [2130] = {.lex_state = 251, .external_lex_state = 2},
  [2131] = {.lex_state = 186, .external_lex_state = 2},
  [2132] = {.lex_state = 186, .external_lex_state = 2},
  [2133] = {.lex_state = 186, .external_lex_state = 2},
  [2134] = {.lex_state = 287, .external_lex_state = 2},
  [2135] = {.lex_state = 183, .external_lex_state = 2},
  [2136] = {.lex_state = 192, .external_lex_state = 2},
  [2137] = {.lex_state = 253, .external_lex_state = 2},
  [2138] = {.lex_state = 178, .external_lex_state = 1},
  [2139] = {.lex_state = 192, .external_lex_state = 2},
  [2140] = {.lex_state = 253, .external_lex_state = 2},
  [2141] = {.lex_state = 200, .external_lex_state = 2},
  [2142] = {.lex_state = 181, .external_lex_state = 1},
  [2143] = {.lex_state = 172, .external_lex_state = 2},
  [2144] = {.lex_state = 186, .external_lex_state = 2},
  [2145] = {.lex_state = 186, .external_lex_state = 2},
  [2146] = {.lex_state = 172, .external_lex_state = 2},
  [2147] = {.lex_state = 186, .external_lex_state = 2},
  [2148] = {.lex_state = 172, .external_lex_state = 2},
  [2149] = {.lex_state = 172, .external_lex_state = 2},
  [2150] = {.lex_state = 252, .external_lex_state = 2},
  [2151] = {.lex_state = 172, .external_lex_state = 2},
  [2152] = {.lex_state = 172, .external_lex_state = 2},
  [2153] = {.lex_state = 172, .external_lex_state = 2},
  [2154] = {.lex_state = 186, .external_lex_state = 2},
  [2155] = {.lex_state = 172, .external_lex_state = 2},
  [2156] = {.lex_state = 253, .external_lex_state = 2},
  [2157] = {.lex_state = 253, .external_lex_state = 2},
  [2158] = {.lex_state = 253, .external_lex_state = 2},
  [2159] = {.lex_state = 253, .external_lex_state = 2},
  [2160] = {.lex_state = 186, .external_lex_state = 2},
  [2161] = {.lex_state = 186, .external_lex_state = 2},
  [2162] = {.lex_state = 186, .external_lex_state = 2},
  [2163] = {.lex_state = 172, .external_lex_state = 2},
  [2164] = {.lex_state = 172, .external_lex_state = 2},
  [2165] = {.lex_state = 259, .external_lex_state = 2},
  [2166] = {.lex_state = 197, .external_lex_state = 1},
  [2167] = {.lex_state = 186, .external_lex_state = 2},
  [2168] = {.lex_state = 186, .external_lex_state = 2},
  [2169] = {.lex_state = 186, .external_lex_state = 2},
  [2170] = {.lex_state = 172, .external_lex_state = 2},
  [2171] = {.lex_state = 172, .external_lex_state = 2},
  [2172] = {.lex_state = 178, .external_lex_state = 2},
  [2173] = {.lex_state = 192, .external_lex_state = 2},
  [2174] = {.lex_state = 192, .external_lex_state = 2},
  [2175] = {.lex_state = 287, .external_lex_state = 2},
  [2176] = {.lex_state = 192, .external_lex_state = 2},
  [2177] = {.lex_state = 192, .external_lex_state = 2},
  [2178] = {.lex_state = 259, .external_lex_state = 2},
  [2179] = {.lex_state = 258, .external_lex_state = 1},
  [2180] = {.lex_state = 197, .external_lex_state = 1},
  [2181] = {.lex_state = 201, .external_lex_state = 2},
  [2182] = {.lex_state = 197, .external_lex_state = 1},
  [2183] = {.lex_state = 197, .external_lex_state = 1},
  [2184] = {.lex_state = 197, .external_lex_state = 1},
  [2185] = {.lex_state = 182, .external_lex_state = 2},
  [2186] = {.lex_state = 198, .external_lex_state = 2},
  [2187] = {.lex_state = 259, .external_lex_state = 2},
  [2188] = {.lex_state = 198, .external_lex_state = 2},
  [2189] = {.lex_state = 274, .external_lex_state = 2},
  [2190] = {.lex_state = 198, .external_lex_state = 2},
  [2191] = {.lex_state = 259, .external_lex_state = 2},
  [2192] = {.lex_state = 274, .external_lex_state = 2},
  [2193] = {.lex_state = 186, .external_lex_state = 2},
  [2194] = {.lex_state = 186, .external_lex_state = 2},
  [2195] = {.lex_state = 186, .external_lex_state = 2},
  [2196] = {.lex_state = 172, .external_lex_state = 2},
  [2197] = {.lex_state = 172, .external_lex_state = 2},
  [2198] = {.lex_state = 183, .external_lex_state = 2},
  [2199] = {.lex_state = 198, .external_lex_state = 2},
  [2200] = {.lex_state = 192, .external_lex_state = 2},
  [2201] = {.lex_state = 275, .external_lex_state = 2},
  [2202] = {.lex_state = 198, .external_lex_state = 2},
  [2203] = {.lex_state = 198, .external_lex_state = 2},
  [2204] = {.lex_state = 172, .external_lex_state = 2},
  [2205] = {.lex_state = 200, .external_lex_state = 2},
  [2206] = {.lex_state = 182, .external_lex_state = 1},
  [2207] = {.lex_state = 171, .external_lex_state = 1},
  [2208] = {.lex_state = 198, .external_lex_state = 2},
  [2209] = {.lex_state = 172, .external_lex_state = 2},
  [2210] = {.lex_state = 274, .external_lex_state = 2},
  [2211] = {.lex_state = 198, .external_lex_state = 2},
  [2212] = {.lex_state = 201, .external_lex_state = 2},
  [2213] = {.lex_state = 198, .external_lex_state = 2},
  [2214] = {.lex_state = 186, .external_lex_state = 2},
  [2215] = {.lex_state = 186, .external_lex_state = 2},
  [2216] = {.lex_state = 186, .external_lex_state = 2},
  [2217] = {.lex_state = 192, .external_lex_state = 2},
  [2218] = {.lex_state = 192, .external_lex_state = 2},
  [2219] = {.lex_state = 172, .external_lex_state = 2},
  [2220] = {.lex_state = 192, .external_lex_state = 2},
  [2221] = {.lex_state = 159, .external_lex_state = 2},
  [2222] = {.lex_state = 159, .external_lex_state = 2},
  [2223] = {.lex_state = 159, .external_lex_state = 2},
  [2224] = {.lex_state = 186, .external_lex_state = 2},
  [2225] = {.lex_state = 186, .external_lex_state = 2},
  [2226] = {.lex_state = 186, .external_lex_state = 2},
  [2227] = {.lex_state = 251, .external_lex_state = 2},
  [2228] = {.lex_state = 186, .external_lex_state = 2},
  [2229] = {.lex_state = 186, .external_lex_state = 2},
  [2230] = {.lex_state = 159, .external_lex_state = 2},
  [2231] = {.lex_state = 172, .external_lex_state = 2},
  [2232] = {.lex_state = 178, .external_lex_state = 2},
  [2233] = {.lex_state = 256, .external_lex_state = 2},
  [2234] = {.lex_state = 172, .external_lex_state = 2},
  [2235] = {.lex_state = 172, .external_lex_state = 2},
  [2236] = {.lex_state = 178, .external_lex_state = 2},
  [2237] = {.lex_state = 183, .external_lex_state = 2},
  [2238] = {.lex_state = 198, .external_lex_state = 2},
  [2239] = {.lex_state = 172, .external_lex_state = 2},
  [2240] = {.lex_state = 172, .external_lex_state = 2},
  [2241] = {.lex_state = 172, .external_lex_state = 2},
  [2242] = {.lex_state = 171, .external_lex_state = 1},
  [2243] = {.lex_state = 171, .external_lex_state = 1},
  [2244] = {.lex_state = 171, .external_lex_state = 1},
  [2245] = {.lex_state = 200, .external_lex_state = 2},
  [2246] = {.lex_state = 186, .external_lex_state = 2},
  [2247] = {.lex_state = 186, .external_lex_state = 2},
  [2248] = {.lex_state = 186, .external_lex_state = 2},
  [2249] = {.lex_state = 172, .external_lex_state = 2},
  [2250] = {.lex_state = 172, .external_lex_state = 2},
  [2251] = {.lex_state = 159, .external_lex_state = 2},
  [2252] = {.lex_state = 159, .external_lex_state = 2},
  [2253] = {.lex_state = 159, .external_lex_state = 2},
  [2254] = {.lex_state = 186, .external_lex_state = 2},
  [2255] = {.lex_state = 172, .external_lex_state = 2},
  [2256] = {.lex_state = 186, .external_lex_state = 2},
  [2257] = {.lex_state = 186, .external_lex_state = 2},
  [2258] = {.lex_state = 198, .external_lex_state = 2},
  [2259] = {.lex_state = 172, .external_lex_state = 2},
  [2260] = {.lex_state = 183, .external_lex_state = 2},
  [2261] = {.lex_state = 281, .external_lex_state = 1},
  [2262] = {.lex_state = 186, .external_lex_state = 2},
  [2263] = {.lex_state = 186, .external_lex_state = 2},
  [2264] = {.lex_state = 186, .external_lex_state = 2},
  [2265] = {.lex_state = 307, .external_lex_state = 2},
  [2266] = {.lex_state = 307, .external_lex_state = 2},
  [2267] = {.lex_state = 186, .external_lex_state = 2},
  [2268] = {.lex_state = 186, .external_lex_state = 2},
  [2269] = {.lex_state = 186, .external_lex_state = 2},
  [2270] = {.lex_state = 172, .external_lex_state = 2},
  [2271] = {.lex_state = 172, .external_lex_state = 2},
  [2272] = {.lex_state = 186, .external_lex_state = 2},
  [2273] = {.lex_state = 172, .external_lex_state = 2},
  [2274] = {.lex_state = 159, .external_lex_state = 2},
  [2275] = {.lex_state = 159, .external_lex_state = 2},
  [2276] = {.lex_state = 159, .external_lex_state = 2},
  [2277] = {.lex_state = 186, .external_lex_state = 2},
  [2278] = {.lex_state = 172, .external_lex_state = 2},
  [2279] = {.lex_state = 186, .external_lex_state = 2},
  [2280] = {.lex_state = 186, .external_lex_state = 2},
  [2281] = {.lex_state = 186, .external_lex_state = 2},
  [2282] = {.lex_state = 186, .external_lex_state = 2},
  [2283] = {.lex_state = 172, .external_lex_state = 2},
  [2284] = {.lex_state = 172, .external_lex_state = 2},
  [2285] = {.lex_state = 171, .external_lex_state = 1},
  [2286] = {.lex_state = 171, .external_lex_state = 1},
  [2287] = {.lex_state = 172, .external_lex_state = 2},
  [2288] = {.lex_state = 171, .external_lex_state = 1},
  [2289] = {.lex_state = 172, .external_lex_state = 2},
  [2290] = {.lex_state = 171, .external_lex_state = 1},
  [2291] = {.lex_state = 182, .external_lex_state = 1},
  [2292] = {.lex_state = 186, .external_lex_state = 2},
  [2293] = {.lex_state = 186, .external_lex_state = 2},
  [2294] = {.lex_state = 186, .external_lex_state = 2},
  [2295] = {.lex_state = 172, .external_lex_state = 2},
  [2296] = {.lex_state = 172, .external_lex_state = 2},
  [2297] = {.lex_state = 183, .external_lex_state = 2},
  [2298] = {.lex_state = 274, .external_lex_state = 2},
  [2299] = {.lex_state = 258, .external_lex_state = 1},
  [2300] = {.lex_state = 192, .external_lex_state = 2},
  [2301] = {.lex_state = 278, .external_lex_state = 2},
  [2302] = {.lex_state = 274, .external_lex_state = 2},
  [2303] = {.lex_state = 172, .external_lex_state = 2},
  [2304] = {.lex_state = 274, .external_lex_state = 2},
  [2305] = {.lex_state = 192, .external_lex_state = 2},
  [2306] = {.lex_state = 192, .external_lex_state = 2},
  [2307] = {.lex_state = 274, .external_lex_state = 2},
  [2308] = {.lex_state = 198, .external_lex_state = 2},
  [2309] = {.lex_state = 198, .external_lex_state = 2},
  [2310] = {.lex_state = 278, .external_lex_state = 2},
  [2311] = {.lex_state = 274, .external_lex_state = 2},
  [2312] = {.lex_state = 278, .external_lex_state = 2},
  [2313] = {.lex_state = 274, .external_lex_state = 2},
  [2314] = {.lex_state = 198, .external_lex_state = 2},
  [2315] = {.lex_state = 198, .external_lex_state = 2},
  [2316] = {.lex_state = 171, .external_lex_state = 1},
  [2317] = {.lex_state = 197, .external_lex_state = 1},
  [2318] = {.lex_state = 182, .external_lex_state = 1},
  [2319] = {.lex_state = 172, .external_lex_state = 2},
  [2320] = {.lex_state = 182, .external_lex_state = 1},
  [2321] = {.lex_state = 172, .external_lex_state = 2},
  [2322] = {.lex_state = 182, .external_lex_state = 1},
  [2323] = {.lex_state = 200, .external_lex_state = 2},
  [2324] = {.lex_state = 311, .external_lex_state = 1},
  [2325] = {.lex_state = 192, .external_lex_state = 2},
  [2326] = {.lex_state = 274, .external_lex_state = 2},
  [2327] = {.lex_state = 178, .external_lex_state = 1},
  [2328] = {.lex_state = 171, .external_lex_state = 1},
  [2329] = {.lex_state = 181, .external_lex_state = 1},
  [2330] = {.lex_state = 182, .external_lex_state = 1},
  [2331] = {.lex_state = 312, .external_lex_state = 2},
  [2332] = {.lex_state = 182, .external_lex_state = 1},
  [2333] = {.lex_state = 172, .external_lex_state = 2},
  [2334] = {.lex_state = 313, .external_lex_state = 1},
  [2335] = {.lex_state = 312, .external_lex_state = 2},
  [2336] = {.lex_state = 312, .external_lex_state = 2},
  [2337] = {.lex_state = 312, .external_lex_state = 2},
  [2338] = {.lex_state = 197, .external_lex_state = 1},
  [2339] = {.lex_state = 182, .external_lex_state = 1},
  [2340] = {.lex_state = 172, .external_lex_state = 2},
  [2341] = {.lex_state = 182, .external_lex_state = 1},
  [2342] = {.lex_state = 313, .external_lex_state = 1},
  [2343] = {.lex_state = 172, .external_lex_state = 2},
  [2344] = {.lex_state = 182, .external_lex_state = 1},
  [2345] = {.lex_state = 172, .external_lex_state = 2},
  [2346] = {.lex_state = 237, .external_lex_state = 2},
  [2347] = {.lex_state = 312, .external_lex_state = 2},
  [2348] = {.lex_state = 312, .external_lex_state = 2},
  [2349] = {.lex_state = 312, .external_lex_state = 2},
  [2350] = {.lex_state = 172, .external_lex_state = 2},
  [2351] = {.lex_state = 172, .external_lex_state = 2},
  [2352] = {.lex_state = 172, .external_lex_state = 2},
  [2353] = {.lex_state = 312, .external_lex_state = 2},
  [2354] = {.lex_state = 312, .external_lex_state = 2},
  [2355] = {.lex_state = 172, .external_lex_state = 2},
  [2356] = {.lex_state = 312, .external_lex_state = 2},
  [2357] = {.lex_state = 245, .external_lex_state = 1},
  [2358] = {.lex_state = 192, .external_lex_state = 2},
  [2359] = {.lex_state = 312, .external_lex_state = 2},
  [2360] = {.lex_state = 182, .external_lex_state = 1},
  [2361] = {.lex_state = 274, .external_lex_state = 2},
  [2362] = {.lex_state = 274, .external_lex_state = 2},
  [2363] = {.lex_state = 182, .external_lex_state = 1},
  [2364] = {.lex_state = 244, .external_lex_state = 1},
  [2365] = {.lex_state = 198, .external_lex_state = 2},
  [2366] = {.lex_state = 197, .external_lex_state = 1},
  [2367] = {.lex_state = 171, .external_lex_state = 1},
  [2368] = {.lex_state = 182, .external_lex_state = 1},
  [2369] = {.lex_state = 183, .external_lex_state = 2},
  [2370] = {.lex_state = 172, .external_lex_state = 2},
  [2371] = {.lex_state = 198, .external_lex_state = 2},
  [2372] = {.lex_state = 192, .external_lex_state = 2},
  [2373] = {.lex_state = 302, .external_lex_state = 2},
  [2374] = {.lex_state = 186, .external_lex_state = 2},
  [2375] = {.lex_state = 192, .external_lex_state = 2},
  [2376] = {.lex_state = 186, .external_lex_state = 2},
  [2377] = {.lex_state = 192, .external_lex_state = 2},
  [2378] = {.lex_state = 186, .external_lex_state = 2},
  [2379] = {.lex_state = 192, .external_lex_state = 2},
  [2380] = {.lex_state = 192, .external_lex_state = 2},
  [2381] = {.lex_state = 251, .external_lex_state = 2},
  [2382] = {.lex_state = 186, .external_lex_state = 2},
  [2383] = {.lex_state = 159, .external_lex_state = 2},
  [2384] = {.lex_state = 182, .external_lex_state = 2},
  [2385] = {.lex_state = 256, .external_lex_state = 2},
  [2386] = {.lex_state = 198, .external_lex_state = 2},
  [2387] = {.lex_state = 172, .external_lex_state = 2},
  [2388] = {.lex_state = 182, .external_lex_state = 2},
  [2389] = {.lex_state = 171, .external_lex_state = 1},
  [2390] = {.lex_state = 198, .external_lex_state = 2},
  [2391] = {.lex_state = 172, .external_lex_state = 2},
  [2392] = {.lex_state = 274, .external_lex_state = 2},
  [2393] = {.lex_state = 198, .external_lex_state = 2},
  [2394] = {.lex_state = 186, .external_lex_state = 2},
  [2395] = {.lex_state = 198, .external_lex_state = 2},
  [2396] = {.lex_state = 251, .external_lex_state = 2},
  [2397] = {.lex_state = 186, .external_lex_state = 2},
  [2398] = {.lex_state = 186, .external_lex_state = 2},
  [2399] = {.lex_state = 159, .external_lex_state = 2},
  [2400] = {.lex_state = 172, .external_lex_state = 2},
  [2401] = {.lex_state = 186, .external_lex_state = 2},
  [2402] = {.lex_state = 256, .external_lex_state = 2},
  [2403] = {.lex_state = 186, .external_lex_state = 2},
  [2404] = {.lex_state = 186, .external_lex_state = 2},
  [2405] = {.lex_state = 186, .external_lex_state = 2},
  [2406] = {.lex_state = 277, .external_lex_state = 2},
  [2407] = {.lex_state = 183, .external_lex_state = 2},
  [2408] = {.lex_state = 186, .external_lex_state = 2},
  [2409] = {.lex_state = 198, .external_lex_state = 2},
  [2410] = {.lex_state = 172, .external_lex_state = 2},
  [2411] = {.lex_state = 171, .external_lex_state = 1},
  [2412] = {.lex_state = 172, .external_lex_state = 2},
  [2413] = {.lex_state = 192, .external_lex_state = 2},
  [2414] = {.lex_state = 172, .external_lex_state = 2},
  [2415] = {.lex_state = 172, .external_lex_state = 2},
  [2416] = {.lex_state = 192, .external_lex_state = 2},
  [2417] = {.lex_state = 186, .external_lex_state = 2},
  [2418] = {.lex_state = 186, .external_lex_state = 2},
  [2419] = {.lex_state = 186, .external_lex_state = 2},
  [2420] = {.lex_state = 172, .external_lex_state = 2},
  [2421] = {.lex_state = 192, .external_lex_state = 2},
  [2422] = {.lex_state = 192, .external_lex_state = 2},
  [2423] = {.lex_state = 186, .external_lex_state = 2},
  [2424] = {.lex_state = 186, .external_lex_state = 2},
  [2425] = {.lex_state = 186, .external_lex_state = 2},
  [2426] = {.lex_state = 172, .external_lex_state = 2},
  [2427] = {.lex_state = 172, .external_lex_state = 2},
  [2428] = {.lex_state = 172, .external_lex_state = 2},
  [2429] = {.lex_state = 171, .external_lex_state = 1},
  [2430] = {.lex_state = 171, .external_lex_state = 1},
  [2431] = {.lex_state = 171, .external_lex_state = 1},
  [2432] = {.lex_state = 172, .external_lex_state = 2},
  [2433] = {.lex_state = 172, .external_lex_state = 2},
  [2434] = {.lex_state = 172, .external_lex_state = 2},
  [2435] = {.lex_state = 198, .external_lex_state = 2},
  [2436] = {.lex_state = 198, .external_lex_state = 2},
  [2437] = {.lex_state = 198, .external_lex_state = 2},
  [2438] = {.lex_state = 244, .external_lex_state = 1},
  [2439] = {.lex_state = 171, .external_lex_state = 1},
  [2440] = {.lex_state = 172, .external_lex_state = 2},
  [2441] = {.lex_state = 172, .external_lex_state = 2},
  [2442] = {.lex_state = 200, .external_lex_state = 2},
  [2443] = {.lex_state = 200, .external_lex_state = 2},
  [2444] = {.lex_state = 200, .external_lex_state = 2},
  [2445] = {.lex_state = 200, .external_lex_state = 2},
  [2446] = {.lex_state = 200, .external_lex_state = 2},
  [2447] = {.lex_state = 200, .external_lex_state = 2},
  [2448] = {.lex_state = 200, .external_lex_state = 2},
  [2449] = {.lex_state = 200, .external_lex_state = 2},
  [2450] = {.lex_state = 200, .external_lex_state = 2},
  [2451] = {.lex_state = 200, .external_lex_state = 2},
  [2452] = {.lex_state = 200, .external_lex_state = 2},
  [2453] = {.lex_state = 200, .external_lex_state = 2},
  [2454] = {.lex_state = 200, .external_lex_state = 2},
  [2455] = {.lex_state = 251, .external_lex_state = 2},
  [2456] = {.lex_state = 186, .external_lex_state = 2},
  [2457] = {.lex_state = 159, .external_lex_state = 2},
  [2458] = {.lex_state = 200, .external_lex_state = 2},
  [2459] = {.lex_state = 256, .external_lex_state = 2},
  [2460] = {.lex_state = 172, .external_lex_state = 2},
  [2461] = {.lex_state = 200, .external_lex_state = 2},
  [2462] = {.lex_state = 183, .external_lex_state = 2},
  [2463] = {.lex_state = 172, .external_lex_state = 2},
  [2464] = {.lex_state = 183, .external_lex_state = 2},
  [2465] = {.lex_state = 200, .external_lex_state = 2},
  [2466] = {.lex_state = 183, .external_lex_state = 2},
  [2467] = {.lex_state = 186, .external_lex_state = 2},
  [2468] = {.lex_state = 303, .external_lex_state = 1},
  [2469] = {.lex_state = 178, .external_lex_state = 1},
  [2470] = {.lex_state = 192, .external_lex_state = 2},
  [2471] = {.lex_state = 305, .external_lex_state = 1},
  [2472] = {.lex_state = 303, .external_lex_state = 1},
  [2473] = {.lex_state = 200, .external_lex_state = 2},
  [2474] = {.lex_state = 284, .external_lex_state = 1},
  [2475] = {.lex_state = 248, .external_lex_state = 2},
  [2476] = {.lex_state = 284, .external_lex_state = 1},
  [2477] = {.lex_state = 200, .external_lex_state = 2},
  [2478] = {.lex_state = 171, .external_lex_state = 1},
  [2479] = {.lex_state = 284, .external_lex_state = 1},
  [2480] = {.lex_state = 250, .external_lex_state = 2},
  [2481] = {.lex_state = 303, .external_lex_state = 1},
  [2482] = {.lex_state = 181, .external_lex_state = 1},
  [2483] = {.lex_state = 172, .external_lex_state = 2},
  [2484] = {.lex_state = 314, .external_lex_state = 2},
  [2485] = {.lex_state = 282, .external_lex_state = 1},
  [2486] = {.lex_state = 305, .external_lex_state = 1},
  [2487] = {.lex_state = 244, .external_lex_state = 1},
  [2488] = {.lex_state = 178, .external_lex_state = 1},
  [2489] = {.lex_state = 305, .external_lex_state = 1},
  [2490] = {.lex_state = 248, .external_lex_state = 2},
  [2491] = {.lex_state = 200, .external_lex_state = 2},
  [2492] = {.lex_state = 171, .external_lex_state = 1},
  [2493] = {.lex_state = 250, .external_lex_state = 2},
  [2494] = {.lex_state = 286, .external_lex_state = 1},
  [2495] = {.lex_state = 178, .external_lex_state = 1},
  [2496] = {.lex_state = 283, .external_lex_state = 1},
  [2497] = {.lex_state = 200, .external_lex_state = 2},
  [2498] = {.lex_state = 286, .external_lex_state = 1},
  [2499] = {.lex_state = 181, .external_lex_state = 1},
  [2500] = {.lex_state = 172, .external_lex_state = 2},
  [2501] = {.lex_state = 181, .external_lex_state = 1},
  [2502] = {.lex_state = 186, .external_lex_state = 2},
  [2503] = {.lex_state = 172, .external_lex_state = 2},
  [2504] = {.lex_state = 192, .external_lex_state = 2},
  [2505] = {.lex_state = 178, .external_lex_state = 2},
  [2506] = {.lex_state = 275, .external_lex_state = 2},
  [2507] = {.lex_state = 198, .external_lex_state = 2},
  [2508] = {.lex_state = 171, .external_lex_state = 2},
  [2509] = {.lex_state = 275, .external_lex_state = 2},
  [2510] = {.lex_state = 172, .external_lex_state = 2},
  [2511] = {.lex_state = 172, .external_lex_state = 2},
  [2512] = {.lex_state = 275, .external_lex_state = 2},
  [2513] = {.lex_state = 198, .external_lex_state = 2},
  [2514] = {.lex_state = 198, .external_lex_state = 2},
  [2515] = {.lex_state = 172, .external_lex_state = 2},
  [2516] = {.lex_state = 275, .external_lex_state = 2},
  [2517] = {.lex_state = 172, .external_lex_state = 2},
  [2518] = {.lex_state = 172, .external_lex_state = 2},
  [2519] = {.lex_state = 275, .external_lex_state = 2},
  [2520] = {.lex_state = 186, .external_lex_state = 2},
  [2521] = {.lex_state = 172, .external_lex_state = 2},
  [2522] = {.lex_state = 275, .external_lex_state = 2},
  [2523] = {.lex_state = 275, .external_lex_state = 2},
  [2524] = {.lex_state = 172, .external_lex_state = 2},
  [2525] = {.lex_state = 172, .external_lex_state = 2},
  [2526] = {.lex_state = 275, .external_lex_state = 2},
  [2527] = {.lex_state = 172, .external_lex_state = 2},
  [2528] = {.lex_state = 172, .external_lex_state = 2},
  [2529] = {.lex_state = 172, .external_lex_state = 2},
  [2530] = {.lex_state = 275, .external_lex_state = 2},
  [2531] = {.lex_state = 172, .external_lex_state = 2},
  [2532] = {.lex_state = 172, .external_lex_state = 2},
  [2533] = {.lex_state = 172, .external_lex_state = 2},
  [2534] = {.lex_state = 275, .external_lex_state = 2},
  [2535] = {.lex_state = 186, .external_lex_state = 2},
  [2536] = {.lex_state = 182, .external_lex_state = 1},
  [2537] = {.lex_state = 172, .external_lex_state = 2},
  [2538] = {.lex_state = 183, .external_lex_state = 2},
  [2539] = {.lex_state = 186, .external_lex_state = 2},
  [2540] = {.lex_state = 172, .external_lex_state = 2},
  [2541] = {.lex_state = 275, .external_lex_state = 2},
  [2542] = {.lex_state = 172, .external_lex_state = 2},
  [2543] = {.lex_state = 172, .external_lex_state = 2},
  [2544] = {.lex_state = 159, .external_lex_state = 2},
  [2545] = {.lex_state = 275, .external_lex_state = 2},
  [2546] = {.lex_state = 172, .external_lex_state = 2},
  [2547] = {.lex_state = 172, .external_lex_state = 2},
  [2548] = {.lex_state = 275, .external_lex_state = 2},
  [2549] = {.lex_state = 186, .external_lex_state = 2},
  [2550] = {.lex_state = 275, .external_lex_state = 2},
  [2551] = {.lex_state = 172, .external_lex_state = 2},
  [2552] = {.lex_state = 159, .external_lex_state = 2},
  [2553] = {.lex_state = 172, .external_lex_state = 2},
  [2554] = {.lex_state = 172, .external_lex_state = 2},
  [2555] = {.lex_state = 275, .external_lex_state = 2},
  [2556] = {.lex_state = 172, .external_lex_state = 2},
  [2557] = {.lex_state = 159, .external_lex_state = 2},
  [2558] = {.lex_state = 275, .external_lex_state = 2},
  [2559] = {.lex_state = 186, .external_lex_state = 2},
  [2560] = {.lex_state = 275, .external_lex_state = 2},
  [2561] = {.lex_state = 172, .external_lex_state = 2},
  [2562] = {.lex_state = 172, .external_lex_state = 2},
  [2563] = {.lex_state = 275, .external_lex_state = 2},
  [2564] = {.lex_state = 192, .external_lex_state = 2},
  [2565] = {.lex_state = 275, .external_lex_state = 2},
  [2566] = {.lex_state = 172, .external_lex_state = 2},
  [2567] = {.lex_state = 159, .external_lex_state = 2},
  [2568] = {.lex_state = 183, .external_lex_state = 2},
  [2569] = {.lex_state = 275, .external_lex_state = 2},
  [2570] = {.lex_state = 172, .external_lex_state = 2},
  [2571] = {.lex_state = 192, .external_lex_state = 2},
  [2572] = {.lex_state = 186, .external_lex_state = 2},
  [2573] = {.lex_state = 172, .external_lex_state = 2},
  [2574] = {.lex_state = 275, .external_lex_state = 2},
  [2575] = {.lex_state = 172, .external_lex_state = 2},
  [2576] = {.lex_state = 159, .external_lex_state = 2},
  [2577] = {.lex_state = 183, .external_lex_state = 2},
  [2578] = {.lex_state = 275, .external_lex_state = 2},
  [2579] = {.lex_state = 172, .external_lex_state = 2},
  [2580] = {.lex_state = 159, .external_lex_state = 2},
  [2581] = {.lex_state = 182, .external_lex_state = 1},
  [2582] = {.lex_state = 171, .external_lex_state = 1},
  [2583] = {.lex_state = 172, .external_lex_state = 2},
  [2584] = {.lex_state = 171, .external_lex_state = 1},
  [2585] = {.lex_state = 172, .external_lex_state = 2},
  [2586] = {.lex_state = 172, .external_lex_state = 2},
  [2587] = {.lex_state = 171, .external_lex_state = 1},
  [2588] = {.lex_state = 171, .external_lex_state = 1},
  [2589] = {.lex_state = 172, .external_lex_state = 2},
  [2590] = {.lex_state = 171, .external_lex_state = 1},
  [2591] = {.lex_state = 172, .external_lex_state = 2},
  [2592] = {.lex_state = 172, .external_lex_state = 2},
  [2593] = {.lex_state = 172, .external_lex_state = 2},
  [2594] = {.lex_state = 183, .external_lex_state = 2},
  [2595] = {.lex_state = 182, .external_lex_state = 1},
  [2596] = {.lex_state = 182, .external_lex_state = 1},
  [2597] = {.lex_state = 172, .external_lex_state = 2},
  [2598] = {.lex_state = 186, .external_lex_state = 2},
  [2599] = {.lex_state = 186, .external_lex_state = 2},
  [2600] = {.lex_state = 186, .external_lex_state = 2},
  [2601] = {.lex_state = 309, .external_lex_state = 2},
  [2602] = {.lex_state = 309, .external_lex_state = 2},
  [2603] = {.lex_state = 159, .external_lex_state = 2},
  [2604] = {.lex_state = 159, .external_lex_state = 2},
  [2605] = {.lex_state = 159, .external_lex_state = 2},
  [2606] = {.lex_state = 186, .external_lex_state = 2},
  [2607] = {.lex_state = 186, .external_lex_state = 2},
  [2608] = {.lex_state = 183, .external_lex_state = 2},
  [2609] = {.lex_state = 186, .external_lex_state = 2},
  [2610] = {.lex_state = 250, .external_lex_state = 2},
  [2611] = {.lex_state = 183, .external_lex_state = 2},
  [2612] = {.lex_state = 310, .external_lex_state = 2},
  [2613] = {.lex_state = 186, .external_lex_state = 2},
  [2614] = {.lex_state = 192, .external_lex_state = 2},
  [2615] = {.lex_state = 198, .external_lex_state = 2},
  [2616] = {.lex_state = 183, .external_lex_state = 2},
  [2617] = {.lex_state = 183, .external_lex_state = 2},
  [2618] = {.lex_state = 183, .external_lex_state = 2},
  [2619] = {.lex_state = 183, .external_lex_state = 2},
  [2620] = {.lex_state = 186, .external_lex_state = 2},
  [2621] = {.lex_state = 186, .external_lex_state = 2},
  [2622] = {.lex_state = 183, .external_lex_state = 2},
  [2623] = {.lex_state = 186, .external_lex_state = 2},
  [2624] = {.lex_state = 186, .external_lex_state = 2},
  [2625] = {.lex_state = 183, .external_lex_state = 2},
  [2626] = {.lex_state = 182, .external_lex_state = 1},
  [2627] = {.lex_state = 305, .external_lex_state = 1},
  [2628] = {.lex_state = 314, .external_lex_state = 2},
  [2629] = {.lex_state = 282, .external_lex_state = 1},
  [2630] = {.lex_state = 305, .external_lex_state = 1},
  [2631] = {.lex_state = 305, .external_lex_state = 1},
  [2632] = {.lex_state = 171, .external_lex_state = 1},
  [2633] = {.lex_state = 248, .external_lex_state = 2},
  [2634] = {.lex_state = 183, .external_lex_state = 2},
  [2635] = {.lex_state = 183, .external_lex_state = 2},
  [2636] = {.lex_state = 276, .external_lex_state = 2},
  [2637] = {.lex_state = 178, .external_lex_state = 1},
  [2638] = {.lex_state = 181, .external_lex_state = 1},
  [2639] = {.lex_state = 182, .external_lex_state = 1},
  [2640] = {.lex_state = 183, .external_lex_state = 2},
  [2641] = {.lex_state = 197, .external_lex_state = 1},
  [2642] = {.lex_state = 183, .external_lex_state = 2},
  [2643] = {.lex_state = 183, .external_lex_state = 2},
  [2644] = {.lex_state = 245, .external_lex_state = 1},
  [2645] = {.lex_state = 182, .external_lex_state = 1},
  [2646] = {.lex_state = 182, .external_lex_state = 1},
  [2647] = {.lex_state = 182, .external_lex_state = 1},
  [2648] = {.lex_state = 182, .external_lex_state = 1},
  [2649] = {.lex_state = 182, .external_lex_state = 1},
  [2650] = {.lex_state = 182, .external_lex_state = 1},
  [2651] = {.lex_state = 182, .external_lex_state = 1},
  [2652] = {.lex_state = 182, .external_lex_state = 1},
  [2653] = {.lex_state = 182, .external_lex_state = 1},
  [2654] = {.lex_state = 182, .external_lex_state = 1},
  [2655] = {.lex_state = 182, .external_lex_state = 1},
  [2656] = {.lex_state = 272, .external_lex_state = 1},
  [2657] = {.lex_state = 182, .external_lex_state = 1},
  [2658] = {.lex_state = 186, .external_lex_state = 2},
  [2659] = {.lex_state = 183, .external_lex_state = 2},
  [2660] = {.lex_state = 186, .external_lex_state = 2},
  [2661] = {.lex_state = 186, .external_lex_state = 2},
  [2662] = {.lex_state = 183, .external_lex_state = 2},
  [2663] = {.lex_state = 182, .external_lex_state = 1},
  [2664] = {.lex_state = 183, .external_lex_state = 2},
  [2665] = {.lex_state = 244, .external_lex_state = 1},
  [2666] = {.lex_state = 186, .external_lex_state = 2},
  [2667] = {.lex_state = 186, .external_lex_state = 2},
  [2668] = {.lex_state = 250, .external_lex_state = 2},
  [2669] = {.lex_state = 182, .external_lex_state = 1},
  [2670] = {.lex_state = 172, .external_lex_state = 2},
  [2671] = {.lex_state = 186, .external_lex_state = 2},
  [2672] = {.lex_state = 186, .external_lex_state = 2},
  [2673] = {.lex_state = 186, .external_lex_state = 2},
  [2674] = {.lex_state = 309, .external_lex_state = 2},
  [2675] = {.lex_state = 309, .external_lex_state = 2},
  [2676] = {.lex_state = 159, .external_lex_state = 2},
  [2677] = {.lex_state = 159, .external_lex_state = 2},
  [2678] = {.lex_state = 159, .external_lex_state = 2},
  [2679] = {.lex_state = 186, .external_lex_state = 2},
  [2680] = {.lex_state = 186, .external_lex_state = 2},
  [2681] = {.lex_state = 186, .external_lex_state = 2},
  [2682] = {.lex_state = 186, .external_lex_state = 2},
  [2683] = {.lex_state = 183, .external_lex_state = 2},
  [2684] = {.lex_state = 254, .external_lex_state = 2},
  [2685] = {.lex_state = 192, .external_lex_state = 2},
  [2686] = {.lex_state = 287, .external_lex_state = 2},
  [2687] = {.lex_state = 192, .external_lex_state = 2},
  [2688] = {.lex_state = 253, .external_lex_state = 2},
  [2689] = {.lex_state = 186, .external_lex_state = 2},
  [2690] = {.lex_state = 186, .external_lex_state = 2},
  [2691] = {.lex_state = 186, .external_lex_state = 2},
  [2692] = {.lex_state = 178, .external_lex_state = 2},
  [2693] = {.lex_state = 251, .external_lex_state = 2},
  [2694] = {.lex_state = 192, .external_lex_state = 2},
  [2695] = {.lex_state = 192, .external_lex_state = 2},
  [2696] = {.lex_state = 253, .external_lex_state = 2},
  [2697] = {.lex_state = 178, .external_lex_state = 1},
  [2698] = {.lex_state = 181, .external_lex_state = 1},
  [2699] = {.lex_state = 186, .external_lex_state = 2},
  [2700] = {.lex_state = 186, .external_lex_state = 2},
  [2701] = {.lex_state = 252, .external_lex_state = 2},
  [2702] = {.lex_state = 186, .external_lex_state = 2},
  [2703] = {.lex_state = 186, .external_lex_state = 2},
  [2704] = {.lex_state = 186, .external_lex_state = 2},
  [2705] = {.lex_state = 186, .external_lex_state = 2},
  [2706] = {.lex_state = 186, .external_lex_state = 2},
  [2707] = {.lex_state = 192, .external_lex_state = 2},
  [2708] = {.lex_state = 172, .external_lex_state = 2},
  [2709] = {.lex_state = 259, .external_lex_state = 2},
  [2710] = {.lex_state = 198, .external_lex_state = 2},
  [2711] = {.lex_state = 197, .external_lex_state = 1},
  [2712] = {.lex_state = 197, .external_lex_state = 1},
  [2713] = {.lex_state = 197, .external_lex_state = 1},
  [2714] = {.lex_state = 259, .external_lex_state = 2},
  [2715] = {.lex_state = 172, .external_lex_state = 2},
  [2716] = {.lex_state = 259, .external_lex_state = 2},
  [2717] = {.lex_state = 186, .external_lex_state = 2},
  [2718] = {.lex_state = 186, .external_lex_state = 2},
  [2719] = {.lex_state = 171, .external_lex_state = 1},
  [2720] = {.lex_state = 251, .external_lex_state = 2},
  [2721] = {.lex_state = 251, .external_lex_state = 2},
  [2722] = {.lex_state = 251, .external_lex_state = 2},
  [2723] = {.lex_state = 251, .external_lex_state = 2},
  [2724] = {.lex_state = 172, .external_lex_state = 2},
  [2725] = {.lex_state = 275, .external_lex_state = 2},
  [2726] = {.lex_state = 274, .external_lex_state = 2},
  [2727] = {.lex_state = 198, .external_lex_state = 2},
  [2728] = {.lex_state = 198, .external_lex_state = 2},
  [2729] = {.lex_state = 200, .external_lex_state = 2},
  [2730] = {.lex_state = 198, .external_lex_state = 2},
  [2731] = {.lex_state = 171, .external_lex_state = 1},
  [2732] = {.lex_state = 172, .external_lex_state = 2},
  [2733] = {.lex_state = 182, .external_lex_state = 1},
  [2734] = {.lex_state = 274, .external_lex_state = 2},
  [2735] = {.lex_state = 186, .external_lex_state = 2},
  [2736] = {.lex_state = 186, .external_lex_state = 2},
  [2737] = {.lex_state = 186, .external_lex_state = 2},
  [2738] = {.lex_state = 192, .external_lex_state = 2},
  [2739] = {.lex_state = 192, .external_lex_state = 2},
  [2740] = {.lex_state = 192, .external_lex_state = 2},
  [2741] = {.lex_state = 186, .external_lex_state = 2},
  [2742] = {.lex_state = 186, .external_lex_state = 2},
  [2743] = {.lex_state = 186, .external_lex_state = 2},
  [2744] = {.lex_state = 172, .external_lex_state = 2},
  [2745] = {.lex_state = 172, .external_lex_state = 2},
  [2746] = {.lex_state = 186, .external_lex_state = 2},
  [2747] = {.lex_state = 172, .external_lex_state = 2},
  [2748] = {.lex_state = 159, .external_lex_state = 2},
  [2749] = {.lex_state = 159, .external_lex_state = 2},
  [2750] = {.lex_state = 159, .external_lex_state = 2},
  [2751] = {.lex_state = 186, .external_lex_state = 2},
  [2752] = {.lex_state = 172, .external_lex_state = 2},
  [2753] = {.lex_state = 186, .external_lex_state = 2},
  [2754] = {.lex_state = 198, .external_lex_state = 2},
  [2755] = {.lex_state = 171, .external_lex_state = 1},
  [2756] = {.lex_state = 172, .external_lex_state = 2},
  [2757] = {.lex_state = 171, .external_lex_state = 1},
  [2758] = {.lex_state = 171, .external_lex_state = 1},
  [2759] = {.lex_state = 186, .external_lex_state = 2},
  [2760] = {.lex_state = 186, .external_lex_state = 2},
  [2761] = {.lex_state = 186, .external_lex_state = 2},
  [2762] = {.lex_state = 172, .external_lex_state = 2},
  [2763] = {.lex_state = 172, .external_lex_state = 2},
  [2764] = {.lex_state = 251, .external_lex_state = 2},
  [2765] = {.lex_state = 186, .external_lex_state = 2},
  [2766] = {.lex_state = 186, .external_lex_state = 2},
  [2767] = {.lex_state = 159, .external_lex_state = 2},
  [2768] = {.lex_state = 172, .external_lex_state = 2},
  [2769] = {.lex_state = 186, .external_lex_state = 2},
  [2770] = {.lex_state = 256, .external_lex_state = 2},
  [2771] = {.lex_state = 172, .external_lex_state = 2},
  [2772] = {.lex_state = 172, .external_lex_state = 2},
  [2773] = {.lex_state = 186, .external_lex_state = 2},
  [2774] = {.lex_state = 198, .external_lex_state = 2},
  [2775] = {.lex_state = 172, .external_lex_state = 2},
  [2776] = {.lex_state = 183, .external_lex_state = 2},
  [2777] = {.lex_state = 244, .external_lex_state = 1},
  [2778] = {.lex_state = 186, .external_lex_state = 2},
  [2779] = {.lex_state = 186, .external_lex_state = 2},
  [2780] = {.lex_state = 186, .external_lex_state = 2},
  [2781] = {.lex_state = 186, .external_lex_state = 2},
  [2782] = {.lex_state = 186, .external_lex_state = 2},
  [2783] = {.lex_state = 186, .external_lex_state = 2},
  [2784] = {.lex_state = 186, .external_lex_state = 2},
  [2785] = {.lex_state = 172, .external_lex_state = 2},
  [2786] = {.lex_state = 172, .external_lex_state = 2},
  [2787] = {.lex_state = 172, .external_lex_state = 2},
  [2788] = {.lex_state = 186, .external_lex_state = 2},
  [2789] = {.lex_state = 186, .external_lex_state = 2},
  [2790] = {.lex_state = 171, .external_lex_state = 1},
  [2791] = {.lex_state = 171, .external_lex_state = 1},
  [2792] = {.lex_state = 183, .external_lex_state = 2},
  [2793] = {.lex_state = 186, .external_lex_state = 2},
  [2794] = {.lex_state = 186, .external_lex_state = 2},
  [2795] = {.lex_state = 171, .external_lex_state = 1},
  [2796] = {.lex_state = 274, .external_lex_state = 2},
  [2797] = {.lex_state = 258, .external_lex_state = 1},
  [2798] = {.lex_state = 197, .external_lex_state = 1},
  [2799] = {.lex_state = 274, .external_lex_state = 2},
  [2800] = {.lex_state = 258, .external_lex_state = 1},
  [2801] = {.lex_state = 192, .external_lex_state = 2},
  [2802] = {.lex_state = 274, .external_lex_state = 2},
  [2803] = {.lex_state = 274, .external_lex_state = 2},
  [2804] = {.lex_state = 198, .external_lex_state = 2},
  [2805] = {.lex_state = 274, .external_lex_state = 2},
  [2806] = {.lex_state = 274, .external_lex_state = 2},
  [2807] = {.lex_state = 198, .external_lex_state = 2},
  [2808] = {.lex_state = 311, .external_lex_state = 1},
  [2809] = {.lex_state = 200, .external_lex_state = 2},
  [2810] = {.lex_state = 171, .external_lex_state = 1},
  [2811] = {.lex_state = 265, .external_lex_state = 2},
  [2812] = {.lex_state = 197, .external_lex_state = 1},
  [2813] = {.lex_state = 183, .external_lex_state = 2},
  [2814] = {.lex_state = 311, .external_lex_state = 1},
  [2815] = {.lex_state = 183, .external_lex_state = 2},
  [2816] = {.lex_state = 311, .external_lex_state = 1},
  [2817] = {.lex_state = 197, .external_lex_state = 1},
  [2818] = {.lex_state = 183, .external_lex_state = 2},
  [2819] = {.lex_state = 197, .external_lex_state = 1},
  [2820] = {.lex_state = 172, .external_lex_state = 2},
  [2821] = {.lex_state = 312, .external_lex_state = 2},
  [2822] = {.lex_state = 248, .external_lex_state = 2},
  [2823] = {.lex_state = 312, .external_lex_state = 2},
  [2824] = {.lex_state = 200, .external_lex_state = 2},
  [2825] = {.lex_state = 171, .external_lex_state = 1},
  [2826] = {.lex_state = 312, .external_lex_state = 2},
  [2827] = {.lex_state = 172, .external_lex_state = 2},
  [2828] = {.lex_state = 250, .external_lex_state = 2},
  [2829] = {.lex_state = 312, .external_lex_state = 2},
  [2830] = {.lex_state = 172, .external_lex_state = 2},
  [2831] = {.lex_state = 182, .external_lex_state = 1},
  [2832] = {.lex_state = 312, .external_lex_state = 2},
  [2833] = {.lex_state = 312, .external_lex_state = 2},
  [2834] = {.lex_state = 312, .external_lex_state = 2},
  [2835] = {.lex_state = 172, .external_lex_state = 2},
  [2836] = {.lex_state = 312, .external_lex_state = 2},
  [2837] = {.lex_state = 312, .external_lex_state = 2},
  [2838] = {.lex_state = 265, .external_lex_state = 2},
  [2839] = {.lex_state = 197, .external_lex_state = 1},
  [2840] = {.lex_state = 183, .external_lex_state = 2},
  [2841] = {.lex_state = 312, .external_lex_state = 2},
  [2842] = {.lex_state = 183, .external_lex_state = 2},
  [2843] = {.lex_state = 312, .external_lex_state = 2},
  [2844] = {.lex_state = 312, .external_lex_state = 2},
  [2845] = {.lex_state = 197, .external_lex_state = 1},
  [2846] = {.lex_state = 183, .external_lex_state = 2},
  [2847] = {.lex_state = 245, .external_lex_state = 1},
  [2848] = {.lex_state = 312, .external_lex_state = 2},
  [2849] = {.lex_state = 237, .external_lex_state = 2},
  [2850] = {.lex_state = 274, .external_lex_state = 2},
  [2851] = {.lex_state = 172, .external_lex_state = 2},
  [2852] = {.lex_state = 159, .external_lex_state = 2},
  [2853] = {.lex_state = 312, .external_lex_state = 2},
  [2854] = {.lex_state = 172, .external_lex_state = 2},
  [2855] = {.lex_state = 172, .external_lex_state = 2},
  [2856] = {.lex_state = 172, .external_lex_state = 2},
  [2857] = {.lex_state = 312, .external_lex_state = 2},
  [2858] = {.lex_state = 178, .external_lex_state = 1},
  [2859] = {.lex_state = 182, .external_lex_state = 1},
  [2860] = {.lex_state = 182, .external_lex_state = 1},
  [2861] = {.lex_state = 182, .external_lex_state = 1},
  [2862] = {.lex_state = 182, .external_lex_state = 1},
  [2863] = {.lex_state = 172, .external_lex_state = 2},
  [2864] = {.lex_state = 182, .external_lex_state = 1},
  [2865] = {.lex_state = 182, .external_lex_state = 1},
  [2866] = {.lex_state = 182, .external_lex_state = 1},
  [2867] = {.lex_state = 182, .external_lex_state = 1},
  [2868] = {.lex_state = 182, .external_lex_state = 1},
  [2869] = {.lex_state = 182, .external_lex_state = 1},
  [2870] = {.lex_state = 182, .external_lex_state = 1},
  [2871] = {.lex_state = 182, .external_lex_state = 1},
  [2872] = {.lex_state = 312, .external_lex_state = 2},
  [2873] = {.lex_state = 313, .external_lex_state = 1},
  [2874] = {.lex_state = 182, .external_lex_state = 1},
  [2875] = {.lex_state = 186, .external_lex_state = 2},
  [2876] = {.lex_state = 312, .external_lex_state = 2},
  [2877] = {.lex_state = 172, .external_lex_state = 2},
  [2878] = {.lex_state = 186, .external_lex_state = 2},
  [2879] = {.lex_state = 312, .external_lex_state = 2},
  [2880] = {.lex_state = 172, .external_lex_state = 2},
  [2881] = {.lex_state = 172, .external_lex_state = 2},
  [2882] = {.lex_state = 312, .external_lex_state = 2},
  [2883] = {.lex_state = 200, .external_lex_state = 2},
  [2884] = {.lex_state = 311, .external_lex_state = 1},
  [2885] = {.lex_state = 182, .external_lex_state = 1},
  [2886] = {.lex_state = 198, .external_lex_state = 2},
  [2887] = {.lex_state = 183, .external_lex_state = 2},
  [2888] = {.lex_state = 171, .external_lex_state = 1},
  [2889] = {.lex_state = 186, .external_lex_state = 2},
  [2890] = {.lex_state = 251, .external_lex_state = 2},
  [2891] = {.lex_state = 251, .external_lex_state = 2},
  [2892] = {.lex_state = 251, .external_lex_state = 2},
  [2893] = {.lex_state = 251, .external_lex_state = 2},
  [2894] = {.lex_state = 186, .external_lex_state = 2},
  [2895] = {.lex_state = 302, .external_lex_state = 2},
  [2896] = {.lex_state = 186, .external_lex_state = 2},
  [2897] = {.lex_state = 192, .external_lex_state = 2},
  [2898] = {.lex_state = 186, .external_lex_state = 2},
  [2899] = {.lex_state = 186, .external_lex_state = 2},
  [2900] = {.lex_state = 192, .external_lex_state = 2},
  [2901] = {.lex_state = 186, .external_lex_state = 2},
  [2902] = {.lex_state = 186, .external_lex_state = 2},
  [2903] = {.lex_state = 186, .external_lex_state = 2},
  [2904] = {.lex_state = 198, .external_lex_state = 2},
  [2905] = {.lex_state = 198, .external_lex_state = 2},
  [2906] = {.lex_state = 159, .external_lex_state = 2},
  [2907] = {.lex_state = 159, .external_lex_state = 2},
  [2908] = {.lex_state = 159, .external_lex_state = 2},
  [2909] = {.lex_state = 186, .external_lex_state = 2},
  [2910] = {.lex_state = 186, .external_lex_state = 2},
  [2911] = {.lex_state = 198, .external_lex_state = 2},
  [2912] = {.lex_state = 171, .external_lex_state = 1},
  [2913] = {.lex_state = 172, .external_lex_state = 2},
  [2914] = {.lex_state = 198, .external_lex_state = 2},
  [2915] = {.lex_state = 274, .external_lex_state = 2},
  [2916] = {.lex_state = 186, .external_lex_state = 2},
  [2917] = {.lex_state = 186, .external_lex_state = 2},
  [2918] = {.lex_state = 186, .external_lex_state = 2},
  [2919] = {.lex_state = 172, .external_lex_state = 2},
  [2920] = {.lex_state = 186, .external_lex_state = 2},
  [2921] = {.lex_state = 186, .external_lex_state = 2},
  [2922] = {.lex_state = 186, .external_lex_state = 2},
  [2923] = {.lex_state = 159, .external_lex_state = 2},
  [2924] = {.lex_state = 159, .external_lex_state = 2},
  [2925] = {.lex_state = 159, .external_lex_state = 2},
  [2926] = {.lex_state = 186, .external_lex_state = 2},
  [2927] = {.lex_state = 186, .external_lex_state = 2},
  [2928] = {.lex_state = 186, .external_lex_state = 2},
  [2929] = {.lex_state = 198, .external_lex_state = 2},
  [2930] = {.lex_state = 251, .external_lex_state = 2},
  [2931] = {.lex_state = 186, .external_lex_state = 2},
  [2932] = {.lex_state = 186, .external_lex_state = 2},
  [2933] = {.lex_state = 159, .external_lex_state = 2},
  [2934] = {.lex_state = 172, .external_lex_state = 2},
  [2935] = {.lex_state = 186, .external_lex_state = 2},
  [2936] = {.lex_state = 256, .external_lex_state = 2},
  [2937] = {.lex_state = 172, .external_lex_state = 2},
  [2938] = {.lex_state = 172, .external_lex_state = 2},
  [2939] = {.lex_state = 186, .external_lex_state = 2},
  [2940] = {.lex_state = 198, .external_lex_state = 2},
  [2941] = {.lex_state = 172, .external_lex_state = 2},
  [2942] = {.lex_state = 171, .external_lex_state = 1},
  [2943] = {.lex_state = 186, .external_lex_state = 2},
  [2944] = {.lex_state = 172, .external_lex_state = 2},
  [2945] = {.lex_state = 186, .external_lex_state = 2},
  [2946] = {.lex_state = 172, .external_lex_state = 2},
  [2947] = {.lex_state = 186, .external_lex_state = 2},
  [2948] = {.lex_state = 186, .external_lex_state = 2},
  [2949] = {.lex_state = 171, .external_lex_state = 1},
  [2950] = {.lex_state = 172, .external_lex_state = 2},
  [2951] = {.lex_state = 172, .external_lex_state = 2},
  [2952] = {.lex_state = 182, .external_lex_state = 1},
  [2953] = {.lex_state = 172, .external_lex_state = 2},
  [2954] = {.lex_state = 186, .external_lex_state = 2},
  [2955] = {.lex_state = 186, .external_lex_state = 2},
  [2956] = {.lex_state = 186, .external_lex_state = 2},
  [2957] = {.lex_state = 308, .external_lex_state = 2},
  [2958] = {.lex_state = 308, .external_lex_state = 2},
  [2959] = {.lex_state = 159, .external_lex_state = 2},
  [2960] = {.lex_state = 159, .external_lex_state = 2},
  [2961] = {.lex_state = 159, .external_lex_state = 2},
  [2962] = {.lex_state = 186, .external_lex_state = 2},
  [2963] = {.lex_state = 186, .external_lex_state = 2},
  [2964] = {.lex_state = 183, .external_lex_state = 2},
  [2965] = {.lex_state = 303, .external_lex_state = 1},
  [2966] = {.lex_state = 248, .external_lex_state = 2},
  [2967] = {.lex_state = 305, .external_lex_state = 1},
  [2968] = {.lex_state = 178, .external_lex_state = 1},
  [2969] = {.lex_state = 303, .external_lex_state = 1},
  [2970] = {.lex_state = 284, .external_lex_state = 1},
  [2971] = {.lex_state = 178, .external_lex_state = 1},
  [2972] = {.lex_state = 284, .external_lex_state = 1},
  [2973] = {.lex_state = 200, .external_lex_state = 2},
  [2974] = {.lex_state = 284, .external_lex_state = 1},
  [2975] = {.lex_state = 181, .external_lex_state = 1},
  [2976] = {.lex_state = 172, .external_lex_state = 2},
  [2977] = {.lex_state = 303, .external_lex_state = 1},
  [2978] = {.lex_state = 181, .external_lex_state = 1},
  [2979] = {.lex_state = 172, .external_lex_state = 2},
  [2980] = {.lex_state = 305, .external_lex_state = 1},
  [2981] = {.lex_state = 314, .external_lex_state = 2},
  [2982] = {.lex_state = 244, .external_lex_state = 1},
  [2983] = {.lex_state = 305, .external_lex_state = 1},
  [2984] = {.lex_state = 178, .external_lex_state = 1},
  [2985] = {.lex_state = 200, .external_lex_state = 2},
  [2986] = {.lex_state = 181, .external_lex_state = 1},
  [2987] = {.lex_state = 172, .external_lex_state = 2},
  [2988] = {.lex_state = 286, .external_lex_state = 1},
  [2989] = {.lex_state = 283, .external_lex_state = 1},
  [2990] = {.lex_state = 286, .external_lex_state = 1},
  [2991] = {.lex_state = 181, .external_lex_state = 1},
  [2992] = {.lex_state = 172, .external_lex_state = 2},
  [2993] = {.lex_state = 172, .external_lex_state = 2},
  [2994] = {.lex_state = 275, .external_lex_state = 2},
  [2995] = {.lex_state = 172, .external_lex_state = 2},
  [2996] = {.lex_state = 192, .external_lex_state = 2},
  [2997] = {.lex_state = 198, .external_lex_state = 2},
  [2998] = {.lex_state = 275, .external_lex_state = 2},
  [2999] = {.lex_state = 182, .external_lex_state = 1},
  [3000] = {.lex_state = 275, .external_lex_state = 2},
  [3001] = {.lex_state = 274, .external_lex_state = 2},
  [3002] = {.lex_state = 198, .external_lex_state = 2},
  [3003] = {.lex_state = 198, .external_lex_state = 2},
  [3004] = {.lex_state = 275, .external_lex_state = 2},
  [3005] = {.lex_state = 275, .external_lex_state = 2},
  [3006] = {.lex_state = 186, .external_lex_state = 2},
  [3007] = {.lex_state = 172, .external_lex_state = 2},
  [3008] = {.lex_state = 275, .external_lex_state = 2},
  [3009] = {.lex_state = 172, .external_lex_state = 2},
  [3010] = {.lex_state = 172, .external_lex_state = 2},
  [3011] = {.lex_state = 275, .external_lex_state = 2},
  [3012] = {.lex_state = 172, .external_lex_state = 2},
  [3013] = {.lex_state = 275, .external_lex_state = 2},
  [3014] = {.lex_state = 172, .external_lex_state = 2},
  [3015] = {.lex_state = 172, .external_lex_state = 2},
  [3016] = {.lex_state = 275, .external_lex_state = 2},
  [3017] = {.lex_state = 172, .external_lex_state = 2},
  [3018] = {.lex_state = 172, .external_lex_state = 2},
  [3019] = {.lex_state = 172, .external_lex_state = 2},
  [3020] = {.lex_state = 183, .external_lex_state = 2},
  [3021] = {.lex_state = 275, .external_lex_state = 2},
  [3022] = {.lex_state = 182, .external_lex_state = 1},
  [3023] = {.lex_state = 172, .external_lex_state = 2},
  [3024] = {.lex_state = 275, .external_lex_state = 2},
  [3025] = {.lex_state = 182, .external_lex_state = 1},
  [3026] = {.lex_state = 275, .external_lex_state = 2},
  [3027] = {.lex_state = 172, .external_lex_state = 2},
  [3028] = {.lex_state = 172, .external_lex_state = 2},
  [3029] = {.lex_state = 275, .external_lex_state = 2},
  [3030] = {.lex_state = 275, .external_lex_state = 2},
  [3031] = {.lex_state = 172, .external_lex_state = 2},
  [3032] = {.lex_state = 275, .external_lex_state = 2},
  [3033] = {.lex_state = 172, .external_lex_state = 2},
  [3034] = {.lex_state = 275, .external_lex_state = 2},
  [3035] = {.lex_state = 172, .external_lex_state = 2},
  [3036] = {.lex_state = 172, .external_lex_state = 2},
  [3037] = {.lex_state = 172, .external_lex_state = 2},
  [3038] = {.lex_state = 172, .external_lex_state = 2},
  [3039] = {.lex_state = 172, .external_lex_state = 2},
  [3040] = {.lex_state = 172, .external_lex_state = 2},
  [3041] = {.lex_state = 172, .external_lex_state = 2},
  [3042] = {.lex_state = 275, .external_lex_state = 2},
  [3043] = {.lex_state = 172, .external_lex_state = 2},
  [3044] = {.lex_state = 186, .external_lex_state = 2},
  [3045] = {.lex_state = 275, .external_lex_state = 2},
  [3046] = {.lex_state = 172, .external_lex_state = 2},
  [3047] = {.lex_state = 172, .external_lex_state = 2},
  [3048] = {.lex_state = 159, .external_lex_state = 2},
  [3049] = {.lex_state = 275, .external_lex_state = 2},
  [3050] = {.lex_state = 172, .external_lex_state = 2},
  [3051] = {.lex_state = 172, .external_lex_state = 2},
  [3052] = {.lex_state = 186, .external_lex_state = 2},
  [3053] = {.lex_state = 275, .external_lex_state = 2},
  [3054] = {.lex_state = 172, .external_lex_state = 2},
  [3055] = {.lex_state = 159, .external_lex_state = 2},
  [3056] = {.lex_state = 275, .external_lex_state = 2},
  [3057] = {.lex_state = 172, .external_lex_state = 2},
  [3058] = {.lex_state = 159, .external_lex_state = 2},
  [3059] = {.lex_state = 183, .external_lex_state = 2},
  [3060] = {.lex_state = 182, .external_lex_state = 1},
  [3061] = {.lex_state = 171, .external_lex_state = 1},
  [3062] = {.lex_state = 172, .external_lex_state = 2},
  [3063] = {.lex_state = 171, .external_lex_state = 1},
  [3064] = {.lex_state = 171, .external_lex_state = 1},
  [3065] = {.lex_state = 171, .external_lex_state = 1},
  [3066] = {.lex_state = 186, .external_lex_state = 2},
  [3067] = {.lex_state = 183, .external_lex_state = 2},
  [3068] = {.lex_state = 186, .external_lex_state = 2},
  [3069] = {.lex_state = 186, .external_lex_state = 2},
  [3070] = {.lex_state = 186, .external_lex_state = 2},
  [3071] = {.lex_state = 309, .external_lex_state = 2},
  [3072] = {.lex_state = 309, .external_lex_state = 2},
  [3073] = {.lex_state = 183, .external_lex_state = 2},
  [3074] = {.lex_state = 183, .external_lex_state = 2},
  [3075] = {.lex_state = 310, .external_lex_state = 2},
  [3076] = {.lex_state = 186, .external_lex_state = 2},
  [3077] = {.lex_state = 183, .external_lex_state = 2},
  [3078] = {.lex_state = 183, .external_lex_state = 2},
  [3079] = {.lex_state = 183, .external_lex_state = 2},
  [3080] = {.lex_state = 183, .external_lex_state = 2},
  [3081] = {.lex_state = 183, .external_lex_state = 2},
  [3082] = {.lex_state = 183, .external_lex_state = 2},
  [3083] = {.lex_state = 183, .external_lex_state = 2},
  [3084] = {.lex_state = 244, .external_lex_state = 1},
  [3085] = {.lex_state = 183, .external_lex_state = 2},
  [3086] = {.lex_state = 172, .external_lex_state = 2},
  [3087] = {.lex_state = 305, .external_lex_state = 1},
  [3088] = {.lex_state = 314, .external_lex_state = 2},
  [3089] = {.lex_state = 183, .external_lex_state = 2},
  [3090] = {.lex_state = 276, .external_lex_state = 2},
  [3091] = {.lex_state = 172, .external_lex_state = 2},
  [3092] = {.lex_state = 183, .external_lex_state = 2},
  [3093] = {.lex_state = 183, .external_lex_state = 2},
  [3094] = {.lex_state = 183, .external_lex_state = 2},
  [3095] = {.lex_state = 183, .external_lex_state = 2},
  [3096] = {.lex_state = 183, .external_lex_state = 2},
  [3097] = {.lex_state = 183, .external_lex_state = 2},
  [3098] = {.lex_state = 183, .external_lex_state = 2},
  [3099] = {.lex_state = 183, .external_lex_state = 2},
  [3100] = {.lex_state = 183, .external_lex_state = 2},
  [3101] = {.lex_state = 183, .external_lex_state = 2},
  [3102] = {.lex_state = 183, .external_lex_state = 2},
  [3103] = {.lex_state = 183, .external_lex_state = 2},
  [3104] = {.lex_state = 183, .external_lex_state = 2},
  [3105] = {.lex_state = 251, .external_lex_state = 2},
  [3106] = {.lex_state = 186, .external_lex_state = 2},
  [3107] = {.lex_state = 159, .external_lex_state = 2},
  [3108] = {.lex_state = 183, .external_lex_state = 2},
  [3109] = {.lex_state = 256, .external_lex_state = 2},
  [3110] = {.lex_state = 172, .external_lex_state = 2},
  [3111] = {.lex_state = 183, .external_lex_state = 2},
  [3112] = {.lex_state = 183, .external_lex_state = 2},
  [3113] = {.lex_state = 183, .external_lex_state = 2},
  [3114] = {.lex_state = 200, .external_lex_state = 2},
  [3115] = {.lex_state = 183, .external_lex_state = 2},
  [3116] = {.lex_state = 186, .external_lex_state = 2},
  [3117] = {.lex_state = 186, .external_lex_state = 2},
  [3118] = {.lex_state = 186, .external_lex_state = 2},
  [3119] = {.lex_state = 309, .external_lex_state = 2},
  [3120] = {.lex_state = 309, .external_lex_state = 2},
  [3121] = {.lex_state = 254, .external_lex_state = 2},
  [3122] = {.lex_state = 172, .external_lex_state = 2},
  [3123] = {.lex_state = 192, .external_lex_state = 2},
  [3124] = {.lex_state = 178, .external_lex_state = 2},
  [3125] = {.lex_state = 253, .external_lex_state = 2},
  [3126] = {.lex_state = 198, .external_lex_state = 2},
  [3127] = {.lex_state = 172, .external_lex_state = 2},
  [3128] = {.lex_state = 172, .external_lex_state = 2},
  [3129] = {.lex_state = 275, .external_lex_state = 2},
  [3130] = {.lex_state = 274, .external_lex_state = 2},
  [3131] = {.lex_state = 198, .external_lex_state = 2},
  [3132] = {.lex_state = 200, .external_lex_state = 2},
  [3133] = {.lex_state = 171, .external_lex_state = 1},
  [3134] = {.lex_state = 186, .external_lex_state = 2},
  [3135] = {.lex_state = 186, .external_lex_state = 2},
  [3136] = {.lex_state = 186, .external_lex_state = 2},
  [3137] = {.lex_state = 186, .external_lex_state = 2},
  [3138] = {.lex_state = 186, .external_lex_state = 2},
  [3139] = {.lex_state = 186, .external_lex_state = 2},
  [3140] = {.lex_state = 186, .external_lex_state = 2},
  [3141] = {.lex_state = 172, .external_lex_state = 2},
  [3142] = {.lex_state = 172, .external_lex_state = 2},
  [3143] = {.lex_state = 172, .external_lex_state = 2},
  [3144] = {.lex_state = 171, .external_lex_state = 1},
  [3145] = {.lex_state = 171, .external_lex_state = 1},
  [3146] = {.lex_state = 186, .external_lex_state = 2},
  [3147] = {.lex_state = 186, .external_lex_state = 2},
  [3148] = {.lex_state = 186, .external_lex_state = 2},
  [3149] = {.lex_state = 186, .external_lex_state = 2},
  [3150] = {.lex_state = 186, .external_lex_state = 2},
  [3151] = {.lex_state = 172, .external_lex_state = 2},
  [3152] = {.lex_state = 172, .external_lex_state = 2},
  [3153] = {.lex_state = 186, .external_lex_state = 2},
  [3154] = {.lex_state = 172, .external_lex_state = 2},
  [3155] = {.lex_state = 159, .external_lex_state = 2},
  [3156] = {.lex_state = 159, .external_lex_state = 2},
  [3157] = {.lex_state = 159, .external_lex_state = 2},
  [3158] = {.lex_state = 186, .external_lex_state = 2},
  [3159] = {.lex_state = 172, .external_lex_state = 2},
  [3160] = {.lex_state = 186, .external_lex_state = 2},
  [3161] = {.lex_state = 198, .external_lex_state = 2},
  [3162] = {.lex_state = 186, .external_lex_state = 2},
  [3163] = {.lex_state = 186, .external_lex_state = 2},
  [3164] = {.lex_state = 171, .external_lex_state = 1},
  [3165] = {.lex_state = 274, .external_lex_state = 2},
  [3166] = {.lex_state = 274, .external_lex_state = 2},
  [3167] = {.lex_state = 258, .external_lex_state = 1},
  [3168] = {.lex_state = 274, .external_lex_state = 2},
  [3169] = {.lex_state = 274, .external_lex_state = 2},
  [3170] = {.lex_state = 274, .external_lex_state = 2},
  [3171] = {.lex_state = 274, .external_lex_state = 2},
  [3172] = {.lex_state = 311, .external_lex_state = 1},
  [3173] = {.lex_state = 200, .external_lex_state = 2},
  [3174] = {.lex_state = 182, .external_lex_state = 1},
  [3175] = {.lex_state = 172, .external_lex_state = 2},
  [3176] = {.lex_state = 311, .external_lex_state = 1},
  [3177] = {.lex_state = 197, .external_lex_state = 1},
  [3178] = {.lex_state = 172, .external_lex_state = 2},
  [3179] = {.lex_state = 311, .external_lex_state = 1},
  [3180] = {.lex_state = 197, .external_lex_state = 1},
  [3181] = {.lex_state = 172, .external_lex_state = 2},
  [3182] = {.lex_state = 182, .external_lex_state = 1},
  [3183] = {.lex_state = 312, .external_lex_state = 2},
  [3184] = {.lex_state = 178, .external_lex_state = 1},
  [3185] = {.lex_state = 312, .external_lex_state = 2},
  [3186] = {.lex_state = 200, .external_lex_state = 2},
  [3187] = {.lex_state = 312, .external_lex_state = 2},
  [3188] = {.lex_state = 182, .external_lex_state = 1},
  [3189] = {.lex_state = 181, .external_lex_state = 1},
  [3190] = {.lex_state = 172, .external_lex_state = 2},
  [3191] = {.lex_state = 312, .external_lex_state = 2},
  [3192] = {.lex_state = 312, .external_lex_state = 2},
  [3193] = {.lex_state = 312, .external_lex_state = 2},
  [3194] = {.lex_state = 182, .external_lex_state = 1},
  [3195] = {.lex_state = 172, .external_lex_state = 2},
  [3196] = {.lex_state = 312, .external_lex_state = 2},
  [3197] = {.lex_state = 197, .external_lex_state = 1},
  [3198] = {.lex_state = 172, .external_lex_state = 2},
  [3199] = {.lex_state = 312, .external_lex_state = 2},
  [3200] = {.lex_state = 186, .external_lex_state = 2},
  [3201] = {.lex_state = 312, .external_lex_state = 2},
  [3202] = {.lex_state = 312, .external_lex_state = 2},
  [3203] = {.lex_state = 312, .external_lex_state = 2},
  [3204] = {.lex_state = 198, .external_lex_state = 2},
  [3205] = {.lex_state = 201, .external_lex_state = 2},
  [3206] = {.lex_state = 198, .external_lex_state = 2},
  [3207] = {.lex_state = 186, .external_lex_state = 2},
  [3208] = {.lex_state = 312, .external_lex_state = 2},
  [3209] = {.lex_state = 312, .external_lex_state = 2},
  [3210] = {.lex_state = 282, .external_lex_state = 1},
  [3211] = {.lex_state = 283, .external_lex_state = 1},
  [3212] = {.lex_state = 284, .external_lex_state = 1},
  [3213] = {.lex_state = 312, .external_lex_state = 2},
  [3214] = {.lex_state = 312, .external_lex_state = 2},
  [3215] = {.lex_state = 312, .external_lex_state = 2},
  [3216] = {.lex_state = 312, .external_lex_state = 2},
  [3217] = {.lex_state = 192, .external_lex_state = 2},
  [3218] = {.lex_state = 248, .external_lex_state = 2},
  [3219] = {.lex_state = 250, .external_lex_state = 2},
  [3220] = {.lex_state = 312, .external_lex_state = 2},
  [3221] = {.lex_state = 312, .external_lex_state = 2},
  [3222] = {.lex_state = 312, .external_lex_state = 2},
  [3223] = {.lex_state = 312, .external_lex_state = 2},
  [3224] = {.lex_state = 312, .external_lex_state = 2},
  [3225] = {.lex_state = 312, .external_lex_state = 2},
  [3226] = {.lex_state = 312, .external_lex_state = 2},
  [3227] = {.lex_state = 312, .external_lex_state = 2},
  [3228] = {.lex_state = 312, .external_lex_state = 2},
  [3229] = {.lex_state = 312, .external_lex_state = 2},
  [3230] = {.lex_state = 312, .external_lex_state = 2},
  [3231] = {.lex_state = 312, .external_lex_state = 2},
  [3232] = {.lex_state = 312, .external_lex_state = 2},
  [3233] = {.lex_state = 312, .external_lex_state = 2},
  [3234] = {.lex_state = 186, .external_lex_state = 2},
  [3235] = {.lex_state = 186, .external_lex_state = 2},
  [3236] = {.lex_state = 251, .external_lex_state = 2},
  [3237] = {.lex_state = 312, .external_lex_state = 2},
  [3238] = {.lex_state = 186, .external_lex_state = 2},
  [3239] = {.lex_state = 172, .external_lex_state = 2},
  [3240] = {.lex_state = 312, .external_lex_state = 2},
  [3241] = {.lex_state = 159, .external_lex_state = 2},
  [3242] = {.lex_state = 198, .external_lex_state = 2},
  [3243] = {.lex_state = 312, .external_lex_state = 2},
  [3244] = {.lex_state = 172, .external_lex_state = 2},
  [3245] = {.lex_state = 312, .external_lex_state = 2},
  [3246] = {.lex_state = 256, .external_lex_state = 2},
  [3247] = {.lex_state = 312, .external_lex_state = 2},
  [3248] = {.lex_state = 172, .external_lex_state = 2},
  [3249] = {.lex_state = 312, .external_lex_state = 2},
  [3250] = {.lex_state = 172, .external_lex_state = 2},
  [3251] = {.lex_state = 172, .external_lex_state = 2},
  [3252] = {.lex_state = 312, .external_lex_state = 2},
  [3253] = {.lex_state = 312, .external_lex_state = 2},
  [3254] = {.lex_state = 172, .external_lex_state = 2},
  [3255] = {.lex_state = 197, .external_lex_state = 1},
  [3256] = {.lex_state = 172, .external_lex_state = 2},
  [3257] = {.lex_state = 182, .external_lex_state = 1},
  [3258] = {.lex_state = 312, .external_lex_state = 2},
  [3259] = {.lex_state = 197, .external_lex_state = 1},
  [3260] = {.lex_state = 182, .external_lex_state = 1},
  [3261] = {.lex_state = 183, .external_lex_state = 2},
  [3262] = {.lex_state = 182, .external_lex_state = 1},
  [3263] = {.lex_state = 171, .external_lex_state = 1},
  [3264] = {.lex_state = 186, .external_lex_state = 2},
  [3265] = {.lex_state = 186, .external_lex_state = 2},
  [3266] = {.lex_state = 302, .external_lex_state = 2},
  [3267] = {.lex_state = 192, .external_lex_state = 2},
  [3268] = {.lex_state = 186, .external_lex_state = 2},
  [3269] = {.lex_state = 186, .external_lex_state = 2},
  [3270] = {.lex_state = 186, .external_lex_state = 2},
  [3271] = {.lex_state = 186, .external_lex_state = 2},
  [3272] = {.lex_state = 198, .external_lex_state = 2},
  [3273] = {.lex_state = 198, .external_lex_state = 2},
  [3274] = {.lex_state = 171, .external_lex_state = 1},
  [3275] = {.lex_state = 186, .external_lex_state = 2},
  [3276] = {.lex_state = 186, .external_lex_state = 2},
  [3277] = {.lex_state = 186, .external_lex_state = 2},
  [3278] = {.lex_state = 186, .external_lex_state = 2},
  [3279] = {.lex_state = 186, .external_lex_state = 2},
  [3280] = {.lex_state = 186, .external_lex_state = 2},
  [3281] = {.lex_state = 186, .external_lex_state = 2},
  [3282] = {.lex_state = 186, .external_lex_state = 2},
  [3283] = {.lex_state = 186, .external_lex_state = 2},
  [3284] = {.lex_state = 186, .external_lex_state = 2},
  [3285] = {.lex_state = 186, .external_lex_state = 2},
  [3286] = {.lex_state = 172, .external_lex_state = 2},
  [3287] = {.lex_state = 172, .external_lex_state = 2},
  [3288] = {.lex_state = 186, .external_lex_state = 2},
  [3289] = {.lex_state = 172, .external_lex_state = 2},
  [3290] = {.lex_state = 159, .external_lex_state = 2},
  [3291] = {.lex_state = 159, .external_lex_state = 2},
  [3292] = {.lex_state = 159, .external_lex_state = 2},
  [3293] = {.lex_state = 186, .external_lex_state = 2},
  [3294] = {.lex_state = 172, .external_lex_state = 2},
  [3295] = {.lex_state = 186, .external_lex_state = 2},
  [3296] = {.lex_state = 198, .external_lex_state = 2},
  [3297] = {.lex_state = 186, .external_lex_state = 2},
  [3298] = {.lex_state = 186, .external_lex_state = 2},
  [3299] = {.lex_state = 171, .external_lex_state = 1},
  [3300] = {.lex_state = 171, .external_lex_state = 1},
  [3301] = {.lex_state = 183, .external_lex_state = 2},
  [3302] = {.lex_state = 186, .external_lex_state = 2},
  [3303] = {.lex_state = 186, .external_lex_state = 2},
  [3304] = {.lex_state = 186, .external_lex_state = 2},
  [3305] = {.lex_state = 308, .external_lex_state = 2},
  [3306] = {.lex_state = 308, .external_lex_state = 2},
  [3307] = {.lex_state = 305, .external_lex_state = 1},
  [3308] = {.lex_state = 284, .external_lex_state = 1},
  [3309] = {.lex_state = 284, .external_lex_state = 1},
  [3310] = {.lex_state = 284, .external_lex_state = 1},
  [3311] = {.lex_state = 181, .external_lex_state = 1},
  [3312] = {.lex_state = 303, .external_lex_state = 1},
  [3313] = {.lex_state = 305, .external_lex_state = 1},
  [3314] = {.lex_state = 172, .external_lex_state = 2},
  [3315] = {.lex_state = 181, .external_lex_state = 1},
  [3316] = {.lex_state = 286, .external_lex_state = 1},
  [3317] = {.lex_state = 172, .external_lex_state = 2},
  [3318] = {.lex_state = 275, .external_lex_state = 2},
  [3319] = {.lex_state = 172, .external_lex_state = 2},
  [3320] = {.lex_state = 183, .external_lex_state = 2},
  [3321] = {.lex_state = 275, .external_lex_state = 2},
  [3322] = {.lex_state = 274, .external_lex_state = 2},
  [3323] = {.lex_state = 198, .external_lex_state = 2},
  [3324] = {.lex_state = 172, .external_lex_state = 2},
  [3325] = {.lex_state = 172, .external_lex_state = 2},
  [3326] = {.lex_state = 275, .external_lex_state = 2},
  [3327] = {.lex_state = 275, .external_lex_state = 2},
  [3328] = {.lex_state = 172, .external_lex_state = 2},
  [3329] = {.lex_state = 275, .external_lex_state = 2},
  [3330] = {.lex_state = 275, .external_lex_state = 2},
  [3331] = {.lex_state = 172, .external_lex_state = 2},
  [3332] = {.lex_state = 275, .external_lex_state = 2},
  [3333] = {.lex_state = 172, .external_lex_state = 2},
  [3334] = {.lex_state = 275, .external_lex_state = 2},
  [3335] = {.lex_state = 182, .external_lex_state = 1},
  [3336] = {.lex_state = 183, .external_lex_state = 2},
  [3337] = {.lex_state = 275, .external_lex_state = 2},
  [3338] = {.lex_state = 182, .external_lex_state = 1},
  [3339] = {.lex_state = 183, .external_lex_state = 2},
  [3340] = {.lex_state = 275, .external_lex_state = 2},
  [3341] = {.lex_state = 172, .external_lex_state = 2},
  [3342] = {.lex_state = 275, .external_lex_state = 2},
  [3343] = {.lex_state = 275, .external_lex_state = 2},
  [3344] = {.lex_state = 275, .external_lex_state = 2},
  [3345] = {.lex_state = 172, .external_lex_state = 2},
  [3346] = {.lex_state = 172, .external_lex_state = 2},
  [3347] = {.lex_state = 172, .external_lex_state = 2},
  [3348] = {.lex_state = 275, .external_lex_state = 2},
  [3349] = {.lex_state = 186, .external_lex_state = 2},
  [3350] = {.lex_state = 182, .external_lex_state = 1},
  [3351] = {.lex_state = 275, .external_lex_state = 2},
  [3352] = {.lex_state = 172, .external_lex_state = 2},
  [3353] = {.lex_state = 275, .external_lex_state = 2},
  [3354] = {.lex_state = 172, .external_lex_state = 2},
  [3355] = {.lex_state = 172, .external_lex_state = 2},
  [3356] = {.lex_state = 275, .external_lex_state = 2},
  [3357] = {.lex_state = 275, .external_lex_state = 2},
  [3358] = {.lex_state = 172, .external_lex_state = 2},
  [3359] = {.lex_state = 275, .external_lex_state = 2},
  [3360] = {.lex_state = 172, .external_lex_state = 2},
  [3361] = {.lex_state = 172, .external_lex_state = 2},
  [3362] = {.lex_state = 172, .external_lex_state = 2},
  [3363] = {.lex_state = 171, .external_lex_state = 1},
  [3364] = {.lex_state = 183, .external_lex_state = 2},
  [3365] = {.lex_state = 171, .external_lex_state = 1},
  [3366] = {.lex_state = 172, .external_lex_state = 2},
  [3367] = {.lex_state = 172, .external_lex_state = 2},
  [3368] = {.lex_state = 250, .external_lex_state = 2},
  [3369] = {.lex_state = 186, .external_lex_state = 2},
  [3370] = {.lex_state = 186, .external_lex_state = 2},
  [3371] = {.lex_state = 310, .external_lex_state = 2},
  [3372] = {.lex_state = 244, .external_lex_state = 1},
  [3373] = {.lex_state = 305, .external_lex_state = 1},
  [3374] = {.lex_state = 172, .external_lex_state = 2},
  [3375] = {.lex_state = 182, .external_lex_state = 1},
  [3376] = {.lex_state = 172, .external_lex_state = 2},
  [3377] = {.lex_state = 186, .external_lex_state = 2},
  [3378] = {.lex_state = 186, .external_lex_state = 2},
  [3379] = {.lex_state = 186, .external_lex_state = 2},
  [3380] = {.lex_state = 307, .external_lex_state = 2},
  [3381] = {.lex_state = 307, .external_lex_state = 2},
  [3382] = {.lex_state = 159, .external_lex_state = 2},
  [3383] = {.lex_state = 159, .external_lex_state = 2},
  [3384] = {.lex_state = 159, .external_lex_state = 2},
  [3385] = {.lex_state = 186, .external_lex_state = 2},
  [3386] = {.lex_state = 186, .external_lex_state = 2},
  [3387] = {.lex_state = 183, .external_lex_state = 2},
  [3388] = {.lex_state = 250, .external_lex_state = 2},
  [3389] = {.lex_state = 186, .external_lex_state = 2},
  [3390] = {.lex_state = 186, .external_lex_state = 2},
  [3391] = {.lex_state = 275, .external_lex_state = 2},
  [3392] = {.lex_state = 274, .external_lex_state = 2},
  [3393] = {.lex_state = 186, .external_lex_state = 2},
  [3394] = {.lex_state = 186, .external_lex_state = 2},
  [3395] = {.lex_state = 186, .external_lex_state = 2},
  [3396] = {.lex_state = 186, .external_lex_state = 2},
  [3397] = {.lex_state = 186, .external_lex_state = 2},
  [3398] = {.lex_state = 186, .external_lex_state = 2},
  [3399] = {.lex_state = 186, .external_lex_state = 2},
  [3400] = {.lex_state = 172, .external_lex_state = 2},
  [3401] = {.lex_state = 172, .external_lex_state = 2},
  [3402] = {.lex_state = 172, .external_lex_state = 2},
  [3403] = {.lex_state = 274, .external_lex_state = 2},
  [3404] = {.lex_state = 274, .external_lex_state = 2},
  [3405] = {.lex_state = 274, .external_lex_state = 2},
  [3406] = {.lex_state = 311, .external_lex_state = 1},
  [3407] = {.lex_state = 183, .external_lex_state = 2},
  [3408] = {.lex_state = 182, .external_lex_state = 1},
  [3409] = {.lex_state = 172, .external_lex_state = 2},
  [3410] = {.lex_state = 311, .external_lex_state = 1},
  [3411] = {.lex_state = 311, .external_lex_state = 1},
  [3412] = {.lex_state = 198, .external_lex_state = 2},
  [3413] = {.lex_state = 197, .external_lex_state = 1},
  [3414] = {.lex_state = 182, .external_lex_state = 1},
  [3415] = {.lex_state = 265, .external_lex_state = 2},
  [3416] = {.lex_state = 311, .external_lex_state = 1},
  [3417] = {.lex_state = 197, .external_lex_state = 1},
  [3418] = {.lex_state = 183, .external_lex_state = 2},
  [3419] = {.lex_state = 312, .external_lex_state = 2},
  [3420] = {.lex_state = 248, .external_lex_state = 2},
  [3421] = {.lex_state = 178, .external_lex_state = 1},
  [3422] = {.lex_state = 312, .external_lex_state = 2},
  [3423] = {.lex_state = 250, .external_lex_state = 2},
  [3424] = {.lex_state = 312, .external_lex_state = 2},
  [3425] = {.lex_state = 181, .external_lex_state = 1},
  [3426] = {.lex_state = 183, .external_lex_state = 2},
  [3427] = {.lex_state = 182, .external_lex_state = 1},
  [3428] = {.lex_state = 172, .external_lex_state = 2},
  [3429] = {.lex_state = 312, .external_lex_state = 2},
  [3430] = {.lex_state = 312, .external_lex_state = 2},
  [3431] = {.lex_state = 198, .external_lex_state = 2},
  [3432] = {.lex_state = 197, .external_lex_state = 1},
  [3433] = {.lex_state = 182, .external_lex_state = 1},
  [3434] = {.lex_state = 172, .external_lex_state = 2},
  [3435] = {.lex_state = 312, .external_lex_state = 2},
  [3436] = {.lex_state = 312, .external_lex_state = 2},
  [3437] = {.lex_state = 274, .external_lex_state = 2},
  [3438] = {.lex_state = 198, .external_lex_state = 2},
  [3439] = {.lex_state = 274, .external_lex_state = 2},
  [3440] = {.lex_state = 198, .external_lex_state = 2},
  [3441] = {.lex_state = 172, .external_lex_state = 2},
  [3442] = {.lex_state = 172, .external_lex_state = 2},
  [3443] = {.lex_state = 172, .external_lex_state = 2},
  [3444] = {.lex_state = 312, .external_lex_state = 2},
  [3445] = {.lex_state = 248, .external_lex_state = 2},
  [3446] = {.lex_state = 282, .external_lex_state = 1},
  [3447] = {.lex_state = 200, .external_lex_state = 2},
  [3448] = {.lex_state = 171, .external_lex_state = 1},
  [3449] = {.lex_state = 286, .external_lex_state = 1},
  [3450] = {.lex_state = 250, .external_lex_state = 2},
  [3451] = {.lex_state = 284, .external_lex_state = 1},
  [3452] = {.lex_state = 312, .external_lex_state = 2},
  [3453] = {.lex_state = 178, .external_lex_state = 1},
  [3454] = {.lex_state = 192, .external_lex_state = 2},
  [3455] = {.lex_state = 312, .external_lex_state = 2},
  [3456] = {.lex_state = 312, .external_lex_state = 2},
  [3457] = {.lex_state = 192, .external_lex_state = 2},
  [3458] = {.lex_state = 172, .external_lex_state = 2},
  [3459] = {.lex_state = 186, .external_lex_state = 2},
  [3460] = {.lex_state = 172, .external_lex_state = 2},
  [3461] = {.lex_state = 186, .external_lex_state = 2},
  [3462] = {.lex_state = 312, .external_lex_state = 2},
  [3463] = {.lex_state = 186, .external_lex_state = 2},
  [3464] = {.lex_state = 312, .external_lex_state = 2},
  [3465] = {.lex_state = 186, .external_lex_state = 2},
  [3466] = {.lex_state = 319, .external_lex_state = 2},
  [3467] = {.lex_state = 172, .external_lex_state = 2},
  [3468] = {.lex_state = 312, .external_lex_state = 2},
  [3469] = {.lex_state = 312, .external_lex_state = 2},
  [3470] = {.lex_state = 312, .external_lex_state = 2},
  [3471] = {.lex_state = 172, .external_lex_state = 2},
  [3472] = {.lex_state = 319, .external_lex_state = 2},
  [3473] = {.lex_state = 312, .external_lex_state = 2},
  [3474] = {.lex_state = 172, .external_lex_state = 2},
  [3475] = {.lex_state = 159, .external_lex_state = 2},
  [3476] = {.lex_state = 159, .external_lex_state = 2},
  [3477] = {.lex_state = 159, .external_lex_state = 2},
  [3478] = {.lex_state = 186, .external_lex_state = 2},
  [3479] = {.lex_state = 186, .external_lex_state = 2},
  [3480] = {.lex_state = 172, .external_lex_state = 2},
  [3481] = {.lex_state = 172, .external_lex_state = 2},
  [3482] = {.lex_state = 172, .external_lex_state = 2},
  [3483] = {.lex_state = 312, .external_lex_state = 2},
  [3484] = {.lex_state = 312, .external_lex_state = 2},
  [3485] = {.lex_state = 265, .external_lex_state = 2},
  [3486] = {.lex_state = 312, .external_lex_state = 2},
  [3487] = {.lex_state = 197, .external_lex_state = 1},
  [3488] = {.lex_state = 183, .external_lex_state = 2},
  [3489] = {.lex_state = 197, .external_lex_state = 1},
  [3490] = {.lex_state = 183, .external_lex_state = 2},
  [3491] = {.lex_state = 197, .external_lex_state = 1},
  [3492] = {.lex_state = 183, .external_lex_state = 2},
  [3493] = {.lex_state = 302, .external_lex_state = 2},
  [3494] = {.lex_state = 186, .external_lex_state = 2},
  [3495] = {.lex_state = 186, .external_lex_state = 2},
  [3496] = {.lex_state = 186, .external_lex_state = 2},
  [3497] = {.lex_state = 186, .external_lex_state = 2},
  [3498] = {.lex_state = 186, .external_lex_state = 2},
  [3499] = {.lex_state = 186, .external_lex_state = 2},
  [3500] = {.lex_state = 186, .external_lex_state = 2},
  [3501] = {.lex_state = 186, .external_lex_state = 2},
  [3502] = {.lex_state = 186, .external_lex_state = 2},
  [3503] = {.lex_state = 172, .external_lex_state = 2},
  [3504] = {.lex_state = 172, .external_lex_state = 2},
  [3505] = {.lex_state = 172, .external_lex_state = 2},
  [3506] = {.lex_state = 200, .external_lex_state = 2},
  [3507] = {.lex_state = 186, .external_lex_state = 2},
  [3508] = {.lex_state = 186, .external_lex_state = 2},
  [3509] = {.lex_state = 284, .external_lex_state = 1},
  [3510] = {.lex_state = 305, .external_lex_state = 1},
  [3511] = {.lex_state = 171, .external_lex_state = 1},
  [3512] = {.lex_state = 171, .external_lex_state = 1},
  [3513] = {.lex_state = 275, .external_lex_state = 2},
  [3514] = {.lex_state = 275, .external_lex_state = 2},
  [3515] = {.lex_state = 275, .external_lex_state = 2},
  [3516] = {.lex_state = 274, .external_lex_state = 2},
  [3517] = {.lex_state = 275, .external_lex_state = 2},
  [3518] = {.lex_state = 172, .external_lex_state = 2},
  [3519] = {.lex_state = 275, .external_lex_state = 2},
  [3520] = {.lex_state = 275, .external_lex_state = 2},
  [3521] = {.lex_state = 275, .external_lex_state = 2},
  [3522] = {.lex_state = 183, .external_lex_state = 2},
  [3523] = {.lex_state = 275, .external_lex_state = 2},
  [3524] = {.lex_state = 183, .external_lex_state = 2},
  [3525] = {.lex_state = 275, .external_lex_state = 2},
  [3526] = {.lex_state = 275, .external_lex_state = 2},
  [3527] = {.lex_state = 275, .external_lex_state = 2},
  [3528] = {.lex_state = 172, .external_lex_state = 2},
  [3529] = {.lex_state = 172, .external_lex_state = 2},
  [3530] = {.lex_state = 172, .external_lex_state = 2},
  [3531] = {.lex_state = 172, .external_lex_state = 2},
  [3532] = {.lex_state = 183, .external_lex_state = 2},
  [3533] = {.lex_state = 182, .external_lex_state = 1},
  [3534] = {.lex_state = 275, .external_lex_state = 2},
  [3535] = {.lex_state = 172, .external_lex_state = 2},
  [3536] = {.lex_state = 275, .external_lex_state = 2},
  [3537] = {.lex_state = 275, .external_lex_state = 2},
  [3538] = {.lex_state = 275, .external_lex_state = 2},
  [3539] = {.lex_state = 186, .external_lex_state = 2},
  [3540] = {.lex_state = 171, .external_lex_state = 1},
  [3541] = {.lex_state = 172, .external_lex_state = 2},
  [3542] = {.lex_state = 305, .external_lex_state = 1},
  [3543] = {.lex_state = 183, .external_lex_state = 2},
  [3544] = {.lex_state = 186, .external_lex_state = 2},
  [3545] = {.lex_state = 186, .external_lex_state = 2},
  [3546] = {.lex_state = 186, .external_lex_state = 2},
  [3547] = {.lex_state = 307, .external_lex_state = 2},
  [3548] = {.lex_state = 307, .external_lex_state = 2},
  [3549] = {.lex_state = 275, .external_lex_state = 2},
  [3550] = {.lex_state = 186, .external_lex_state = 2},
  [3551] = {.lex_state = 186, .external_lex_state = 2},
  [3552] = {.lex_state = 311, .external_lex_state = 1},
  [3553] = {.lex_state = 183, .external_lex_state = 2},
  [3554] = {.lex_state = 311, .external_lex_state = 1},
  [3555] = {.lex_state = 311, .external_lex_state = 1},
  [3556] = {.lex_state = 198, .external_lex_state = 2},
  [3557] = {.lex_state = 183, .external_lex_state = 2},
  [3558] = {.lex_state = 182, .external_lex_state = 1},
  [3559] = {.lex_state = 172, .external_lex_state = 2},
  [3560] = {.lex_state = 311, .external_lex_state = 1},
  [3561] = {.lex_state = 312, .external_lex_state = 2},
  [3562] = {.lex_state = 248, .external_lex_state = 2},
  [3563] = {.lex_state = 312, .external_lex_state = 2},
  [3564] = {.lex_state = 312, .external_lex_state = 2},
  [3565] = {.lex_state = 183, .external_lex_state = 2},
  [3566] = {.lex_state = 312, .external_lex_state = 2},
  [3567] = {.lex_state = 312, .external_lex_state = 2},
  [3568] = {.lex_state = 198, .external_lex_state = 2},
  [3569] = {.lex_state = 183, .external_lex_state = 2},
  [3570] = {.lex_state = 312, .external_lex_state = 2},
  [3571] = {.lex_state = 312, .external_lex_state = 2},
  [3572] = {.lex_state = 274, .external_lex_state = 2},
  [3573] = {.lex_state = 312, .external_lex_state = 2},
  [3574] = {.lex_state = 274, .external_lex_state = 2},
  [3575] = {.lex_state = 186, .external_lex_state = 2},
  [3576] = {.lex_state = 312, .external_lex_state = 2},
  [3577] = {.lex_state = 172, .external_lex_state = 2},
  [3578] = {.lex_state = 312, .external_lex_state = 2},
  [3579] = {.lex_state = 178, .external_lex_state = 1},
  [3580] = {.lex_state = 192, .external_lex_state = 2},
  [3581] = {.lex_state = 312, .external_lex_state = 2},
  [3582] = {.lex_state = 200, .external_lex_state = 2},
  [3583] = {.lex_state = 181, .external_lex_state = 1},
  [3584] = {.lex_state = 172, .external_lex_state = 2},
  [3585] = {.lex_state = 312, .external_lex_state = 2},
  [3586] = {.lex_state = 178, .external_lex_state = 1},
  [3587] = {.lex_state = 312, .external_lex_state = 2},
  [3588] = {.lex_state = 186, .external_lex_state = 2},
  [3589] = {.lex_state = 192, .external_lex_state = 2},
  [3590] = {.lex_state = 182, .external_lex_state = 1},
  [3591] = {.lex_state = 312, .external_lex_state = 2},
  [3592] = {.lex_state = 312, .external_lex_state = 2},
  [3593] = {.lex_state = 312, .external_lex_state = 2},
  [3594] = {.lex_state = 312, .external_lex_state = 2},
  [3595] = {.lex_state = 186, .external_lex_state = 2},
  [3596] = {.lex_state = 319, .external_lex_state = 2},
  [3597] = {.lex_state = 192, .external_lex_state = 2},
  [3598] = {.lex_state = 192, .external_lex_state = 2},
  [3599] = {.lex_state = 192, .external_lex_state = 2},
  [3600] = {.lex_state = 192, .external_lex_state = 2},
  [3601] = {.lex_state = 186, .external_lex_state = 2},
  [3602] = {.lex_state = 312, .external_lex_state = 2},
  [3603] = {.lex_state = 186, .external_lex_state = 2},
  [3604] = {.lex_state = 319, .external_lex_state = 2},
  [3605] = {.lex_state = 319, .external_lex_state = 2},
  [3606] = {.lex_state = 172, .external_lex_state = 2},
  [3607] = {.lex_state = 312, .external_lex_state = 2},
  [3608] = {.lex_state = 312, .external_lex_state = 2},
  [3609] = {.lex_state = 312, .external_lex_state = 2},
  [3610] = {.lex_state = 182, .external_lex_state = 1},
  [3611] = {.lex_state = 172, .external_lex_state = 2},
  [3612] = {.lex_state = 312, .external_lex_state = 2},
  [3613] = {.lex_state = 172, .external_lex_state = 2},
  [3614] = {.lex_state = 311, .external_lex_state = 1},
  [3615] = {.lex_state = 197, .external_lex_state = 1},
  [3616] = {.lex_state = 186, .external_lex_state = 2},
  [3617] = {.lex_state = 186, .external_lex_state = 2},
  [3618] = {.lex_state = 275, .external_lex_state = 2},
  [3619] = {.lex_state = 275, .external_lex_state = 2},
  [3620] = {.lex_state = 275, .external_lex_state = 2},
  [3621] = {.lex_state = 275, .external_lex_state = 2},
  [3622] = {.lex_state = 275, .external_lex_state = 2},
  [3623] = {.lex_state = 275, .external_lex_state = 2},
  [3624] = {.lex_state = 275, .external_lex_state = 2},
  [3625] = {.lex_state = 172, .external_lex_state = 2},
  [3626] = {.lex_state = 275, .external_lex_state = 2},
  [3627] = {.lex_state = 183, .external_lex_state = 2},
  [3628] = {.lex_state = 275, .external_lex_state = 2},
  [3629] = {.lex_state = 172, .external_lex_state = 2},
  [3630] = {.lex_state = 172, .external_lex_state = 2},
  [3631] = {.lex_state = 171, .external_lex_state = 1},
  [3632] = {.lex_state = 171, .external_lex_state = 1},
  [3633] = {.lex_state = 183, .external_lex_state = 2},
  [3634] = {.lex_state = 186, .external_lex_state = 2},
  [3635] = {.lex_state = 186, .external_lex_state = 2},
  [3636] = {.lex_state = 311, .external_lex_state = 1},
  [3637] = {.lex_state = 311, .external_lex_state = 1},
  [3638] = {.lex_state = 311, .external_lex_state = 1},
  [3639] = {.lex_state = 183, .external_lex_state = 2},
  [3640] = {.lex_state = 182, .external_lex_state = 1},
  [3641] = {.lex_state = 312, .external_lex_state = 2},
  [3642] = {.lex_state = 312, .external_lex_state = 2},
  [3643] = {.lex_state = 312, .external_lex_state = 2},
  [3644] = {.lex_state = 312, .external_lex_state = 2},
  [3645] = {.lex_state = 312, .external_lex_state = 2},
  [3646] = {.lex_state = 312, .external_lex_state = 2},
  [3647] = {.lex_state = 312, .external_lex_state = 2},
  [3648] = {.lex_state = 186, .external_lex_state = 2},
  [3649] = {.lex_state = 312, .external_lex_state = 2},
  [3650] = {.lex_state = 178, .external_lex_state = 1},
  [3651] = {.lex_state = 181, .external_lex_state = 1},
  [3652] = {.lex_state = 312, .external_lex_state = 2},
  [3653] = {.lex_state = 312, .external_lex_state = 2},
  [3654] = {.lex_state = 186, .external_lex_state = 2},
  [3655] = {.lex_state = 250, .external_lex_state = 2},
  [3656] = {.lex_state = 312, .external_lex_state = 2},
  [3657] = {.lex_state = 319, .external_lex_state = 2},
  [3658] = {.lex_state = 186, .external_lex_state = 2},
  [3659] = {.lex_state = 192, .external_lex_state = 2},
  [3660] = {.lex_state = 198, .external_lex_state = 2},
  [3661] = {.lex_state = 312, .external_lex_state = 2},
  [3662] = {.lex_state = 312, .external_lex_state = 2},
  [3663] = {.lex_state = 312, .external_lex_state = 2},
  [3664] = {.lex_state = 312, .external_lex_state = 2},
  [3665] = {.lex_state = 186, .external_lex_state = 2},
  [3666] = {.lex_state = 186, .external_lex_state = 2},
  [3667] = {.lex_state = 312, .external_lex_state = 2},
  [3668] = {.lex_state = 183, .external_lex_state = 2},
  [3669] = {.lex_state = 182, .external_lex_state = 1},
  [3670] = {.lex_state = 182, .external_lex_state = 1},
  [3671] = {.lex_state = 172, .external_lex_state = 2},
  [3672] = {.lex_state = 275, .external_lex_state = 2},
  [3673] = {.lex_state = 275, .external_lex_state = 2},
  [3674] = {.lex_state = 275, .external_lex_state = 2},
  [3675] = {.lex_state = 172, .external_lex_state = 2},
  [3676] = {.lex_state = 311, .external_lex_state = 1},
  [3677] = {.lex_state = 311, .external_lex_state = 1},
  [3678] = {.lex_state = 183, .external_lex_state = 2},
  [3679] = {.lex_state = 312, .external_lex_state = 2},
  [3680] = {.lex_state = 312, .external_lex_state = 2},
  [3681] = {.lex_state = 312, .external_lex_state = 2},
  [3682] = {.lex_state = 312, .external_lex_state = 2},
  [3683] = {.lex_state = 312, .external_lex_state = 2},
  [3684] = {.lex_state = 319, .external_lex_state = 2},
  [3685] = {.lex_state = 186, .external_lex_state = 2},
  [3686] = {.lex_state = 312, .external_lex_state = 2},
  [3687] = {.lex_state = 312, .external_lex_state = 2},
  [3688] = {.lex_state = 312, .external_lex_state = 2},
  [3689] = {.lex_state = 312, .external_lex_state = 2},
  [3690] = {.lex_state = 312, .external_lex_state = 2},
  [3691] = {.lex_state = 312, .external_lex_state = 2},
  [3692] = {.lex_state = 312, .external_lex_state = 2},
  [3693] = {.lex_state = 312, .external_lex_state = 2},
  [3694] = {.lex_state = 183, .external_lex_state = 2},
  [3695] = {.lex_state = 183, .external_lex_state = 2},
  [3696] = {.lex_state = 275, .external_lex_state = 2},
  [3697] = {.lex_state = 275, .external_lex_state = 2},
  [3698] = {.lex_state = 311, .external_lex_state = 1},
  [3699] = {.lex_state = 319, .external_lex_state = 2},
  [3700] = {.lex_state = 312, .external_lex_state = 2},
  [3701] = {.lex_state = 311, .external_lex_state = 1},
};

enum {
  ts_external_token_raw_string_literal,
  ts_external_token_float_literal,
  ts_external_token_block_comment,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_raw_string_literal] = sym_raw_string_literal,
  [ts_external_token_float_literal] = sym_float_literal,
  [ts_external_token_block_comment] = sym_block_comment,
};

static bool ts_external_scanner_states[3][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_raw_string_literal] = true,
    [ts_external_token_float_literal] = true,
    [ts_external_token_block_comment] = true,
  },
  [2] = {
    [ts_external_token_block_comment] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_raw_string_literal] = ACTIONS(1),
    [sym_float_literal] = ACTIONS(1),
    [sym_block_comment] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_macro_rules_BANG] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(3),
    [anon_sym_DOLLAR] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(3),
    [anon_sym_STAR] = ACTIONS(3),
    [anon_sym_ident] = ACTIONS(1),
    [anon_sym_path] = ACTIONS(1),
    [anon_sym_expr] = ACTIONS(1),
    [anon_sym_ty] = ACTIONS(3),
    [anon_sym_pat] = ACTIONS(3),
    [anon_sym_stmt] = ACTIONS(1),
    [anon_sym_block] = ACTIONS(1),
    [anon_sym_item] = ACTIONS(1),
    [anon_sym_meta] = ACTIONS(1),
    [anon_sym_tt] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_u8] = ACTIONS(1),
    [anon_sym_i8] = ACTIONS(1),
    [anon_sym_u16] = ACTIONS(1),
    [anon_sym_i16] = ACTIONS(1),
    [anon_sym_u32] = ACTIONS(1),
    [anon_sym_i32] = ACTIONS(1),
    [anon_sym_u64] = ACTIONS(1),
    [anon_sym_i64] = ACTIONS(1),
    [anon_sym_u128] = ACTIONS(1),
    [anon_sym_i128] = ACTIONS(1),
    [anon_sym_isize] = ACTIONS(1),
    [anon_sym_usize] = ACTIONS(1),
    [anon_sym_f32] = ACTIONS(1),
    [anon_sym_f64] = ACTIONS(1),
    [anon_sym_bool] = ACTIONS(1),
    [anon_sym_str] = ACTIONS(3),
    [anon_sym_char] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(3),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(3),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(3),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(3),
    [anon_sym_LT_LT] = ACTIONS(3),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(3),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(3),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(3),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(3),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(3),
    [anon_sym_DOT_DOT] = ACTIONS(3),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_fn] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_impl] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_loop] = ACTIONS(1),
    [anon_sym_match] = ACTIONS(1),
    [anon_sym_mod] = ACTIONS(1),
    [anon_sym_pub] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_trait] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_union] = ACTIONS(1),
    [anon_sym_unsafe] = ACTIONS(1),
    [anon_sym_use] = ACTIONS(1),
    [anon_sym_where] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_extern] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_dyn] = ACTIONS(1),
    [sym_mutable_specifier] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_move] = ACTIONS(1),
    [anon_sym_ref] = ACTIONS(1),
    [sym_integer_literal] = ACTIONS(1),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_char_literal] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [sym_line_comment] = ACTIONS(1),
    [sym_self] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_crate] = ACTIONS(1),
    [sym_metavariable] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(46),
    [sym__statement] = STATE(61),
    [sym_empty_statement] = STATE(61),
    [sym__expression_statement] = STATE(61),
    [sym_macro_definition] = STATE(61),
    [sym_attribute_item] = STATE(61),
    [sym_inner_attribute_item] = STATE(61),
    [sym_mod_item] = STATE(61),
    [sym_foreign_mod_item] = STATE(61),
    [sym_struct_item] = STATE(61),
    [sym_union_item] = STATE(61),
    [sym_enum_item] = STATE(61),
    [sym_extern_crate_declaration] = STATE(61),
    [sym_const_item] = STATE(61),
    [sym_static_item] = STATE(61),
    [sym_type_item] = STATE(61),
    [sym_function_item] = STATE(61),
    [sym_function_signature_item] = STATE(61),
    [sym_function_modifiers] = STATE(47),
    [sym_impl_item] = STATE(61),
    [sym_trait_item] = STATE(61),
    [sym_associated_type] = STATE(61),
    [sym_let_declaration] = STATE(61),
    [sym_use_declaration] = STATE(61),
    [sym_extern_modifier] = STATE(48),
    [sym_visibility_modifier] = STATE(49),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(52),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(52),
    [sym_macro_invocation] = STATE(53),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(52),
    [sym_unary_expression] = STATE(52),
    [sym_try_expression] = STATE(52),
    [sym_reference_expression] = STATE(52),
    [sym_binary_expression] = STATE(52),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(52),
    [sym_call_expression] = STATE(52),
    [sym_array_expression] = STATE(52),
    [sym_parenthesized_expression] = STATE(52),
    [sym_tuple_expression] = STATE(52),
    [sym_unit_expression] = STATE(52),
    [sym_struct_expression] = STATE(52),
    [sym_if_expression] = STATE(57),
    [sym_if_let_expression] = STATE(57),
    [sym_match_expression] = STATE(57),
    [sym_while_expression] = STATE(57),
    [sym_while_let_expression] = STATE(57),
    [sym_loop_expression] = STATE(57),
    [sym_for_expression] = STATE(57),
    [sym_closure_expression] = STATE(52),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(59),
    [sym_break_expression] = STATE(52),
    [sym_continue_expression] = STATE(52),
    [sym_index_expression] = STATE(52),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(57),
    [sym_block] = STATE(57),
    [sym__literal] = STATE(52),
    [sym_string_literal] = STATE(52),
    [sym_boolean_literal] = STATE(52),
    [aux_sym_source_file_repeat1] = STATE(61),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_raw_string_literal] = ACTIONS(5),
    [sym_float_literal] = ACTIONS(5),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(9),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_POUND] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(5),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(5),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(93),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2] = {
    [sym_raw_string_literal] = ACTIONS(101),
    [sym_float_literal] = ACTIONS(101),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(101),
    [anon_sym_macro_rules_BANG] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_u8] = ACTIONS(103),
    [anon_sym_i8] = ACTIONS(103),
    [anon_sym_u16] = ACTIONS(103),
    [anon_sym_i16] = ACTIONS(103),
    [anon_sym_u32] = ACTIONS(103),
    [anon_sym_i32] = ACTIONS(103),
    [anon_sym_u64] = ACTIONS(103),
    [anon_sym_i64] = ACTIONS(103),
    [anon_sym_u128] = ACTIONS(103),
    [anon_sym_i128] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_str] = ACTIONS(103),
    [anon_sym_char] = ACTIONS(103),
    [anon_sym_AMP] = ACTIONS(101),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_BANG] = ACTIONS(101),
    [anon_sym_POUND] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(101),
    [anon_sym_PIPE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(101),
    [anon_sym_break] = ACTIONS(103),
    [anon_sym_const] = ACTIONS(103),
    [anon_sym_continue] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(103),
    [anon_sym_fn] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(103),
    [anon_sym_impl] = ACTIONS(103),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_loop] = ACTIONS(103),
    [anon_sym_match] = ACTIONS(103),
    [anon_sym_mod] = ACTIONS(103),
    [anon_sym_pub] = ACTIONS(103),
    [anon_sym_return] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(103),
    [anon_sym_struct] = ACTIONS(103),
    [anon_sym_trait] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_union] = ACTIONS(103),
    [anon_sym_unsafe] = ACTIONS(103),
    [anon_sym_use] = ACTIONS(103),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_extern] = ACTIONS(103),
    [anon_sym_move] = ACTIONS(103),
    [sym_integer_literal] = ACTIONS(101),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(101),
    [sym_char_literal] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(103),
    [sym_self] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_crate] = ACTIONS(103),
    [sym_metavariable] = ACTIONS(101),
  },
  [3] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(105),
  },
  [4] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(79),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(79),
    [sym_macro_invocation] = STATE(79),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(79),
    [sym_unary_expression] = STATE(79),
    [sym_try_expression] = STATE(79),
    [sym_reference_expression] = STATE(79),
    [sym_binary_expression] = STATE(79),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(79),
    [sym_call_expression] = STATE(79),
    [sym_array_expression] = STATE(79),
    [sym_parenthesized_expression] = STATE(79),
    [sym_tuple_expression] = STATE(79),
    [sym_unit_expression] = STATE(79),
    [sym_struct_expression] = STATE(79),
    [sym_if_expression] = STATE(79),
    [sym_if_let_expression] = STATE(79),
    [sym_match_expression] = STATE(79),
    [sym_while_expression] = STATE(79),
    [sym_while_let_expression] = STATE(79),
    [sym_loop_expression] = STATE(79),
    [sym_for_expression] = STATE(79),
    [sym_closure_expression] = STATE(79),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(79),
    [sym_continue_expression] = STATE(79),
    [sym_index_expression] = STATE(79),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(79),
    [sym_block] = STATE(79),
    [sym__literal] = STATE(79),
    [sym_string_literal] = STATE(79),
    [sym_boolean_literal] = STATE(79),
    [sym_raw_string_literal] = ACTIONS(107),
    [sym_float_literal] = ACTIONS(107),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(107),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(107),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [5] = {
    [sym__statement] = STATE(91),
    [sym_empty_statement] = STATE(91),
    [sym__expression_statement] = STATE(91),
    [sym_macro_definition] = STATE(91),
    [sym_attribute_item] = STATE(91),
    [sym_inner_attribute_item] = STATE(91),
    [sym_mod_item] = STATE(91),
    [sym_foreign_mod_item] = STATE(91),
    [sym_struct_item] = STATE(91),
    [sym_union_item] = STATE(91),
    [sym_enum_item] = STATE(91),
    [sym_extern_crate_declaration] = STATE(91),
    [sym_const_item] = STATE(91),
    [sym_static_item] = STATE(91),
    [sym_type_item] = STATE(91),
    [sym_function_item] = STATE(91),
    [sym_function_signature_item] = STATE(91),
    [sym_function_modifiers] = STATE(47),
    [sym_impl_item] = STATE(91),
    [sym_trait_item] = STATE(91),
    [sym_associated_type] = STATE(91),
    [sym_let_declaration] = STATE(91),
    [sym_use_declaration] = STATE(91),
    [sym_extern_modifier] = STATE(48),
    [sym_visibility_modifier] = STATE(49),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(89),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(89),
    [sym_macro_invocation] = STATE(53),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(89),
    [sym_unary_expression] = STATE(89),
    [sym_try_expression] = STATE(89),
    [sym_reference_expression] = STATE(89),
    [sym_binary_expression] = STATE(89),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(89),
    [sym_call_expression] = STATE(89),
    [sym_array_expression] = STATE(89),
    [sym_parenthesized_expression] = STATE(89),
    [sym_tuple_expression] = STATE(89),
    [sym_unit_expression] = STATE(89),
    [sym_struct_expression] = STATE(89),
    [sym_if_expression] = STATE(57),
    [sym_if_let_expression] = STATE(57),
    [sym_match_expression] = STATE(57),
    [sym_while_expression] = STATE(57),
    [sym_while_let_expression] = STATE(57),
    [sym_loop_expression] = STATE(57),
    [sym_for_expression] = STATE(57),
    [sym_closure_expression] = STATE(89),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(59),
    [sym_break_expression] = STATE(89),
    [sym_continue_expression] = STATE(89),
    [sym_index_expression] = STATE(89),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(57),
    [sym_block] = STATE(57),
    [sym__literal] = STATE(89),
    [sym_string_literal] = STATE(89),
    [sym_boolean_literal] = STATE(89),
    [aux_sym_source_file_repeat1] = STATE(91),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_raw_string_literal] = ACTIONS(139),
    [sym_float_literal] = ACTIONS(139),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(141),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_POUND] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(139),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(139),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(93),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [6] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(100),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(100),
    [sym_macro_invocation] = STATE(100),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(100),
    [sym_unary_expression] = STATE(100),
    [sym_try_expression] = STATE(100),
    [sym_reference_expression] = STATE(100),
    [sym_binary_expression] = STATE(100),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(100),
    [sym_call_expression] = STATE(100),
    [sym_array_expression] = STATE(100),
    [sym_parenthesized_expression] = STATE(100),
    [sym_tuple_expression] = STATE(100),
    [sym_unit_expression] = STATE(100),
    [sym_struct_expression] = STATE(100),
    [sym_if_expression] = STATE(100),
    [sym_if_let_expression] = STATE(100),
    [sym_match_expression] = STATE(100),
    [sym_while_expression] = STATE(100),
    [sym_while_let_expression] = STATE(100),
    [sym_loop_expression] = STATE(100),
    [sym_for_expression] = STATE(100),
    [sym_closure_expression] = STATE(100),
    [sym_closure_parameters] = STATE(101),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(100),
    [sym_continue_expression] = STATE(100),
    [sym_index_expression] = STATE(100),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(100),
    [sym_block] = STATE(100),
    [sym__literal] = STATE(100),
    [sym_string_literal] = STATE(100),
    [sym_boolean_literal] = STATE(100),
    [sym_raw_string_literal] = ACTIONS(155),
    [sym_float_literal] = ACTIONS(155),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_RBRACK] = ACTIONS(157),
    [anon_sym_STAR] = ACTIONS(159),
    [anon_sym_COMMA] = ACTIONS(161),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(159),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(171),
    [sym_integer_literal] = ACTIONS(155),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(155),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [7] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(103),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(103),
    [sym_macro_invocation] = STATE(103),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(103),
    [sym_unary_expression] = STATE(103),
    [sym_try_expression] = STATE(103),
    [sym_reference_expression] = STATE(103),
    [sym_binary_expression] = STATE(103),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(103),
    [sym_call_expression] = STATE(103),
    [sym_array_expression] = STATE(103),
    [sym_parenthesized_expression] = STATE(103),
    [sym_tuple_expression] = STATE(103),
    [sym_unit_expression] = STATE(103),
    [sym_struct_expression] = STATE(103),
    [sym_if_expression] = STATE(103),
    [sym_if_let_expression] = STATE(103),
    [sym_match_expression] = STATE(103),
    [sym_while_expression] = STATE(103),
    [sym_while_let_expression] = STATE(103),
    [sym_loop_expression] = STATE(103),
    [sym_for_expression] = STATE(103),
    [sym_closure_expression] = STATE(103),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(103),
    [sym_continue_expression] = STATE(103),
    [sym_index_expression] = STATE(103),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(103),
    [sym_block] = STATE(103),
    [sym__literal] = STATE(103),
    [sym_string_literal] = STATE(103),
    [sym_boolean_literal] = STATE(103),
    [sym_raw_string_literal] = ACTIONS(173),
    [sym_float_literal] = ACTIONS(173),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(173),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(173),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [8] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(177),
    [anon_sym_RPAREN] = ACTIONS(177),
    [anon_sym_RBRACE] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(177),
    [anon_sym_RBRACK] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_DASH] = ACTIONS(179),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_COLON_COLON] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ] = ACTIONS(177),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(177),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(177),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_as] = ACTIONS(177),
    [sym_line_comment] = ACTIONS(7),
  },
  [9] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(106),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(106),
    [sym_macro_invocation] = STATE(106),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(106),
    [sym_unary_expression] = STATE(106),
    [sym_try_expression] = STATE(106),
    [sym_reference_expression] = STATE(106),
    [sym_binary_expression] = STATE(106),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(106),
    [sym_call_expression] = STATE(106),
    [sym_array_expression] = STATE(106),
    [sym_parenthesized_expression] = STATE(106),
    [sym_tuple_expression] = STATE(106),
    [sym_unit_expression] = STATE(106),
    [sym_struct_expression] = STATE(106),
    [sym_if_expression] = STATE(106),
    [sym_if_let_expression] = STATE(106),
    [sym_match_expression] = STATE(106),
    [sym_while_expression] = STATE(106),
    [sym_while_let_expression] = STATE(106),
    [sym_loop_expression] = STATE(106),
    [sym_for_expression] = STATE(106),
    [sym_closure_expression] = STATE(106),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(106),
    [sym_continue_expression] = STATE(106),
    [sym_index_expression] = STATE(106),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(106),
    [sym_block] = STATE(106),
    [sym__literal] = STATE(106),
    [sym_string_literal] = STATE(106),
    [sym_boolean_literal] = STATE(106),
    [sym_raw_string_literal] = ACTIONS(183),
    [sym_float_literal] = ACTIONS(183),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [sym_mutable_specifier] = ACTIONS(185),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(183),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(183),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [10] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(187),
  },
  [11] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACK] = ACTIONS(189),
    [anon_sym_BANG] = ACTIONS(191),
    [sym_line_comment] = ACTIONS(7),
  },
  [12] = {
    [sym_function_modifiers] = STATE(124),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(125),
    [sym_bracketed_type] = STATE(122),
    [sym_qualified_type] = STATE(126),
    [sym_lifetime] = STATE(127),
    [sym_array_type] = STATE(125),
    [sym_function_type] = STATE(125),
    [sym_tuple_type] = STATE(125),
    [sym_unit_type] = STATE(125),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(125),
    [sym_reference_type] = STATE(125),
    [sym_pointer_type] = STATE(125),
    [sym_empty_type] = STATE(125),
    [sym_dynamic_type] = STATE(125),
    [sym_macro_invocation] = STATE(125),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(131),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(197),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(201),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(211),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(217),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [13] = {
    [sym_parameter] = STATE(148),
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(148),
    [sym_tuple_pattern] = STATE(148),
    [sym_tuple_struct_pattern] = STATE(148),
    [sym_struct_pattern] = STATE(148),
    [sym_remaining_field_pattern] = STATE(148),
    [sym_mut_pattern] = STATE(148),
    [sym_ref_pattern] = STATE(148),
    [sym_captured_pattern] = STATE(148),
    [sym_reference_pattern] = STATE(148),
    [sym_reference_pattern_in_parameter] = STATE(153),
    [sym__literal] = STATE(148),
    [sym_string_literal] = STATE(148),
    [sym_boolean_literal] = STATE(148),
    [sym_raw_string_literal] = ACTIONS(223),
    [sym_float_literal] = ACTIONS(223),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(227),
    [anon_sym_i8] = ACTIONS(227),
    [anon_sym_u16] = ACTIONS(227),
    [anon_sym_i16] = ACTIONS(227),
    [anon_sym_u32] = ACTIONS(227),
    [anon_sym_i32] = ACTIONS(227),
    [anon_sym_u64] = ACTIONS(227),
    [anon_sym_i64] = ACTIONS(227),
    [anon_sym_u128] = ACTIONS(227),
    [anon_sym_i128] = ACTIONS(227),
    [anon_sym_isize] = ACTIONS(227),
    [anon_sym_usize] = ACTIONS(227),
    [anon_sym_f32] = ACTIONS(227),
    [anon_sym_f64] = ACTIONS(227),
    [anon_sym_bool] = ACTIONS(227),
    [anon_sym_str] = ACTIONS(227),
    [anon_sym_char] = ACTIONS(227),
    [anon_sym__] = ACTIONS(229),
    [anon_sym_AMP] = ACTIONS(231),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [anon_sym_default] = ACTIONS(239),
    [anon_sym_union] = ACTIONS(239),
    [sym_mutable_specifier] = ACTIONS(241),
    [anon_sym_ref] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(223),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(223),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(249),
    [sym_self] = ACTIONS(251),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [14] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(257),
  },
  [15] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(155),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(155),
    [sym_macro_invocation] = STATE(155),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(155),
    [sym_unary_expression] = STATE(155),
    [sym_try_expression] = STATE(155),
    [sym_reference_expression] = STATE(155),
    [sym_binary_expression] = STATE(155),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(155),
    [sym_call_expression] = STATE(155),
    [sym_array_expression] = STATE(155),
    [sym_parenthesized_expression] = STATE(155),
    [sym_tuple_expression] = STATE(155),
    [sym_unit_expression] = STATE(155),
    [sym_struct_expression] = STATE(155),
    [sym_if_expression] = STATE(155),
    [sym_if_let_expression] = STATE(155),
    [sym_match_expression] = STATE(155),
    [sym_while_expression] = STATE(155),
    [sym_while_let_expression] = STATE(155),
    [sym_loop_expression] = STATE(155),
    [sym_for_expression] = STATE(155),
    [sym_closure_expression] = STATE(155),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(155),
    [sym_continue_expression] = STATE(155),
    [sym_index_expression] = STATE(155),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(155),
    [sym_block] = STATE(155),
    [sym__literal] = STATE(155),
    [sym_string_literal] = STATE(155),
    [sym_boolean_literal] = STATE(155),
    [sym_raw_string_literal] = ACTIONS(259),
    [sym_float_literal] = ACTIONS(259),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(261),
    [anon_sym_LPAREN] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_PLUS] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(263),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(263),
    [anon_sym_DASH] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(263),
    [anon_sym_DASH_EQ] = ACTIONS(261),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_BANG_EQ] = ACTIONS(261),
    [anon_sym_STAR_EQ] = ACTIONS(261),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_SLASH_EQ] = ACTIONS(261),
    [anon_sym_AMP_AMP] = ACTIONS(261),
    [anon_sym_AMP_EQ] = ACTIONS(261),
    [anon_sym_PERCENT] = ACTIONS(263),
    [anon_sym_PERCENT_EQ] = ACTIONS(261),
    [anon_sym_CARET] = ACTIONS(263),
    [anon_sym_CARET_EQ] = ACTIONS(261),
    [anon_sym_PLUS_EQ] = ACTIONS(261),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_EQ] = ACTIONS(261),
    [anon_sym_LT_EQ] = ACTIONS(261),
    [anon_sym_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(261),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_EQ] = ACTIONS(261),
    [anon_sym_GT_GT] = ACTIONS(263),
    [anon_sym_GT_GT_EQ] = ACTIONS(261),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_PIPE_EQ] = ACTIONS(261),
    [anon_sym_PIPE_PIPE] = ACTIONS(261),
    [anon_sym_QMARK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(263),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(261),
    [anon_sym_as] = ACTIONS(263),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(259),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(259),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [16] = {
    [sym_loop_label] = STATE(156),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(267),
    [anon_sym_LPAREN] = ACTIONS(267),
    [anon_sym_RPAREN] = ACTIONS(267),
    [anon_sym_LBRACE] = ACTIONS(267),
    [anon_sym_RBRACE] = ACTIONS(267),
    [anon_sym_LBRACK] = ACTIONS(267),
    [anon_sym_RBRACK] = ACTIONS(267),
    [anon_sym_PLUS] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(269),
    [anon_sym_COMMA] = ACTIONS(267),
    [anon_sym_AMP] = ACTIONS(269),
    [anon_sym_DASH] = ACTIONS(269),
    [anon_sym_DOT] = ACTIONS(269),
    [anon_sym_DASH_EQ] = ACTIONS(267),
    [anon_sym_BANG_EQ] = ACTIONS(267),
    [anon_sym_STAR_EQ] = ACTIONS(267),
    [anon_sym_SLASH] = ACTIONS(269),
    [anon_sym_SLASH_EQ] = ACTIONS(267),
    [anon_sym_AMP_AMP] = ACTIONS(267),
    [anon_sym_AMP_EQ] = ACTIONS(267),
    [anon_sym_PERCENT] = ACTIONS(269),
    [anon_sym_PERCENT_EQ] = ACTIONS(267),
    [anon_sym_CARET] = ACTIONS(269),
    [anon_sym_CARET_EQ] = ACTIONS(267),
    [anon_sym_PLUS_EQ] = ACTIONS(267),
    [anon_sym_LT] = ACTIONS(269),
    [anon_sym_LT_LT] = ACTIONS(269),
    [anon_sym_LT_LT_EQ] = ACTIONS(267),
    [anon_sym_LT_EQ] = ACTIONS(267),
    [anon_sym_EQ] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(267),
    [anon_sym_GT] = ACTIONS(269),
    [anon_sym_GT_EQ] = ACTIONS(267),
    [anon_sym_GT_GT] = ACTIONS(269),
    [anon_sym_GT_GT_EQ] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(267),
    [anon_sym_PIPE_PIPE] = ACTIONS(267),
    [anon_sym_QMARK] = ACTIONS(267),
    [anon_sym_SQUOTE] = ACTIONS(271),
    [anon_sym_DOT_DOT] = ACTIONS(269),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(267),
    [anon_sym_as] = ACTIONS(267),
    [sym_line_comment] = ACTIONS(7),
  },
  [17] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(273),
    [anon_sym_default] = ACTIONS(273),
    [anon_sym_fn] = ACTIONS(273),
    [anon_sym_unsafe] = ACTIONS(273),
    [anon_sym_extern] = ACTIONS(273),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(275),
  },
  [18] = {
    [sym_loop_label] = STATE(158),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_RPAREN] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(277),
    [anon_sym_RBRACE] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(277),
    [anon_sym_PLUS] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(279),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(279),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_DASH_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_STAR_EQ] = ACTIONS(277),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_SLASH_EQ] = ACTIONS(277),
    [anon_sym_AMP_AMP] = ACTIONS(277),
    [anon_sym_AMP_EQ] = ACTIONS(277),
    [anon_sym_PERCENT] = ACTIONS(279),
    [anon_sym_PERCENT_EQ] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(279),
    [anon_sym_CARET_EQ] = ACTIONS(277),
    [anon_sym_PLUS_EQ] = ACTIONS(277),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(279),
    [anon_sym_LT_LT_EQ] = ACTIONS(277),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ] = ACTIONS(279),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT_GT] = ACTIONS(279),
    [anon_sym_GT_GT_EQ] = ACTIONS(277),
    [anon_sym_PIPE] = ACTIONS(279),
    [anon_sym_PIPE_EQ] = ACTIONS(277),
    [anon_sym_PIPE_PIPE] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(277),
    [anon_sym_SQUOTE] = ACTIONS(271),
    [anon_sym_DOT_DOT] = ACTIONS(279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(277),
    [sym_line_comment] = ACTIONS(7),
  },
  [19] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(177),
    [anon_sym_RBRACE] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(179),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_DASH] = ACTIONS(179),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ] = ACTIONS(177),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(177),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(177),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_as] = ACTIONS(177),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_default] = ACTIONS(281),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_unsafe] = ACTIONS(281),
    [anon_sym_extern] = ACTIONS(281),
    [sym_line_comment] = ACTIONS(7),
  },
  [20] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(283),
  },
  [21] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(285),
    [sym_metavariable] = ACTIONS(285),
  },
  [22] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(166),
    [sym_tuple_pattern] = STATE(166),
    [sym_tuple_struct_pattern] = STATE(166),
    [sym_struct_pattern] = STATE(166),
    [sym_remaining_field_pattern] = STATE(166),
    [sym_mut_pattern] = STATE(166),
    [sym_ref_pattern] = STATE(166),
    [sym_captured_pattern] = STATE(166),
    [sym_reference_pattern] = STATE(166),
    [sym__literal] = STATE(166),
    [sym_string_literal] = STATE(166),
    [sym_boolean_literal] = STATE(166),
    [sym_raw_string_literal] = ACTIONS(287),
    [sym_float_literal] = ACTIONS(287),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(291),
    [anon_sym_AMP] = ACTIONS(293),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(295),
    [anon_sym_ref] = ACTIONS(297),
    [sym_integer_literal] = ACTIONS(287),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(287),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(299),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [23] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(180),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(180),
    [sym_macro_invocation] = STATE(180),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(180),
    [sym_unary_expression] = STATE(180),
    [sym_try_expression] = STATE(180),
    [sym_reference_expression] = STATE(180),
    [sym_binary_expression] = STATE(180),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(180),
    [sym_call_expression] = STATE(180),
    [sym_array_expression] = STATE(180),
    [sym_parenthesized_expression] = STATE(180),
    [sym_tuple_expression] = STATE(180),
    [sym_unit_expression] = STATE(180),
    [sym_struct_expression] = STATE(180),
    [sym_if_expression] = STATE(180),
    [sym_if_let_expression] = STATE(180),
    [sym_match_expression] = STATE(180),
    [sym_while_expression] = STATE(180),
    [sym_while_let_expression] = STATE(180),
    [sym_loop_expression] = STATE(180),
    [sym_for_expression] = STATE(180),
    [sym_closure_expression] = STATE(180),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(180),
    [sym_continue_expression] = STATE(180),
    [sym_index_expression] = STATE(180),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(180),
    [sym_block] = STATE(180),
    [sym__literal] = STATE(180),
    [sym_string_literal] = STATE(180),
    [sym_boolean_literal] = STATE(180),
    [sym_raw_string_literal] = ACTIONS(301),
    [sym_float_literal] = ACTIONS(301),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_let] = ACTIONS(315),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(301),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(301),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [24] = {
    [sym_type_parameters] = STATE(186),
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(187),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(331),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(333),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [25] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(192),
    [sym_tuple_pattern] = STATE(192),
    [sym_tuple_struct_pattern] = STATE(192),
    [sym_struct_pattern] = STATE(192),
    [sym_remaining_field_pattern] = STATE(192),
    [sym_mut_pattern] = STATE(192),
    [sym_ref_pattern] = STATE(192),
    [sym_captured_pattern] = STATE(192),
    [sym_reference_pattern] = STATE(192),
    [sym__literal] = STATE(192),
    [sym_string_literal] = STATE(192),
    [sym_boolean_literal] = STATE(192),
    [sym_raw_string_literal] = ACTIONS(337),
    [sym_float_literal] = ACTIONS(337),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(339),
    [anon_sym_AMP] = ACTIONS(341),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(343),
    [anon_sym_ref] = ACTIONS(345),
    [sym_integer_literal] = ACTIONS(337),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(337),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(347),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [26] = {
    [sym_block] = STATE(193),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(17),
    [sym_line_comment] = ACTIONS(7),
  },
  [27] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(194),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(194),
    [sym_macro_invocation] = STATE(194),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(194),
    [sym_unary_expression] = STATE(194),
    [sym_try_expression] = STATE(194),
    [sym_reference_expression] = STATE(194),
    [sym_binary_expression] = STATE(194),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(194),
    [sym_call_expression] = STATE(194),
    [sym_array_expression] = STATE(194),
    [sym_parenthesized_expression] = STATE(194),
    [sym_tuple_expression] = STATE(194),
    [sym_unit_expression] = STATE(194),
    [sym_struct_expression] = STATE(194),
    [sym_if_expression] = STATE(194),
    [sym_if_let_expression] = STATE(194),
    [sym_match_expression] = STATE(194),
    [sym_while_expression] = STATE(194),
    [sym_while_let_expression] = STATE(194),
    [sym_loop_expression] = STATE(194),
    [sym_for_expression] = STATE(194),
    [sym_closure_expression] = STATE(194),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(194),
    [sym_continue_expression] = STATE(194),
    [sym_index_expression] = STATE(194),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(194),
    [sym_block] = STATE(194),
    [sym__literal] = STATE(194),
    [sym_string_literal] = STATE(194),
    [sym_boolean_literal] = STATE(194),
    [sym_raw_string_literal] = ACTIONS(349),
    [sym_float_literal] = ACTIONS(349),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(349),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(349),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [28] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(351),
  },
  [29] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(353),
    [anon_sym_const] = ACTIONS(355),
    [anon_sym_default] = ACTIONS(355),
    [anon_sym_enum] = ACTIONS(355),
    [anon_sym_fn] = ACTIONS(355),
    [anon_sym_mod] = ACTIONS(355),
    [anon_sym_static] = ACTIONS(355),
    [anon_sym_struct] = ACTIONS(355),
    [anon_sym_trait] = ACTIONS(355),
    [anon_sym_type] = ACTIONS(355),
    [anon_sym_union] = ACTIONS(355),
    [anon_sym_unsafe] = ACTIONS(355),
    [anon_sym_use] = ACTIONS(355),
    [anon_sym_extern] = ACTIONS(355),
    [sym_line_comment] = ACTIONS(7),
  },
  [30] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(197),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(197),
    [sym_macro_invocation] = STATE(197),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(197),
    [sym_unary_expression] = STATE(197),
    [sym_try_expression] = STATE(197),
    [sym_reference_expression] = STATE(197),
    [sym_binary_expression] = STATE(197),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(197),
    [sym_call_expression] = STATE(197),
    [sym_array_expression] = STATE(197),
    [sym_parenthesized_expression] = STATE(197),
    [sym_tuple_expression] = STATE(197),
    [sym_unit_expression] = STATE(197),
    [sym_struct_expression] = STATE(197),
    [sym_if_expression] = STATE(197),
    [sym_if_let_expression] = STATE(197),
    [sym_match_expression] = STATE(197),
    [sym_while_expression] = STATE(197),
    [sym_while_let_expression] = STATE(197),
    [sym_loop_expression] = STATE(197),
    [sym_for_expression] = STATE(197),
    [sym_closure_expression] = STATE(197),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(197),
    [sym_continue_expression] = STATE(197),
    [sym_index_expression] = STATE(197),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(197),
    [sym_block] = STATE(197),
    [sym__literal] = STATE(197),
    [sym_string_literal] = STATE(197),
    [sym_boolean_literal] = STATE(197),
    [sym_raw_string_literal] = ACTIONS(357),
    [sym_float_literal] = ACTIONS(357),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(359),
    [anon_sym_LPAREN] = ACTIONS(359),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(361),
    [anon_sym_STAR] = ACTIONS(361),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(361),
    [anon_sym_DASH_EQ] = ACTIONS(359),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_BANG_EQ] = ACTIONS(359),
    [anon_sym_STAR_EQ] = ACTIONS(359),
    [anon_sym_SLASH] = ACTIONS(361),
    [anon_sym_SLASH_EQ] = ACTIONS(359),
    [anon_sym_AMP_AMP] = ACTIONS(359),
    [anon_sym_AMP_EQ] = ACTIONS(359),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_PERCENT_EQ] = ACTIONS(359),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_CARET_EQ] = ACTIONS(359),
    [anon_sym_PLUS_EQ] = ACTIONS(359),
    [anon_sym_LT] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_LT_LT_EQ] = ACTIONS(359),
    [anon_sym_LT_EQ] = ACTIONS(359),
    [anon_sym_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(359),
    [anon_sym_GT] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(359),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_GT_GT_EQ] = ACTIONS(359),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_PIPE_EQ] = ACTIONS(359),
    [anon_sym_PIPE_PIPE] = ACTIONS(359),
    [anon_sym_QMARK] = ACTIONS(359),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(361),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(359),
    [anon_sym_as] = ACTIONS(361),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(357),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [31] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_mutable_specifier] = ACTIONS(363),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(365),
  },
  [32] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(367),
  },
  [33] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(369),
  },
  [34] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(371),
  },
  [35] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(177),
    [anon_sym_RBRACE] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(179),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_DASH] = ACTIONS(179),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ] = ACTIONS(177),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(177),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(177),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_as] = ACTIONS(179),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(373),
  },
  [36] = {
    [sym_block] = STATE(205),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_default] = ACTIONS(281),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_impl] = ACTIONS(375),
    [anon_sym_unsafe] = ACTIONS(281),
    [anon_sym_extern] = ACTIONS(281),
    [sym_line_comment] = ACTIONS(7),
  },
  [37] = {
    [sym__use_clause] = STATE(211),
    [sym_scoped_use_list] = STATE(211),
    [sym_use_list] = STATE(211),
    [sym_use_as_clause] = STATE(211),
    [sym_use_wildcard] = STATE(211),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_type_with_turbofish] = STATE(212),
    [sym_scoped_identifier] = STATE(213),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(377),
    [anon_sym_u8] = ACTIONS(379),
    [anon_sym_i8] = ACTIONS(379),
    [anon_sym_u16] = ACTIONS(379),
    [anon_sym_i16] = ACTIONS(379),
    [anon_sym_u32] = ACTIONS(379),
    [anon_sym_i32] = ACTIONS(379),
    [anon_sym_u64] = ACTIONS(379),
    [anon_sym_i64] = ACTIONS(379),
    [anon_sym_u128] = ACTIONS(379),
    [anon_sym_i128] = ACTIONS(379),
    [anon_sym_isize] = ACTIONS(379),
    [anon_sym_usize] = ACTIONS(379),
    [anon_sym_f32] = ACTIONS(379),
    [anon_sym_f64] = ACTIONS(379),
    [anon_sym_bool] = ACTIONS(379),
    [anon_sym_str] = ACTIONS(379),
    [anon_sym_char] = ACTIONS(379),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_LT] = ACTIONS(31),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(383),
    [sym_self] = ACTIONS(385),
    [sym_super] = ACTIONS(385),
    [sym_crate] = ACTIONS(385),
    [sym_metavariable] = ACTIONS(387),
  },
  [38] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(215),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(215),
    [sym_macro_invocation] = STATE(215),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(215),
    [sym_unary_expression] = STATE(215),
    [sym_try_expression] = STATE(215),
    [sym_reference_expression] = STATE(215),
    [sym_binary_expression] = STATE(215),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(215),
    [sym_call_expression] = STATE(215),
    [sym_array_expression] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple_expression] = STATE(215),
    [sym_unit_expression] = STATE(215),
    [sym_struct_expression] = STATE(215),
    [sym_if_expression] = STATE(215),
    [sym_if_let_expression] = STATE(215),
    [sym_match_expression] = STATE(215),
    [sym_while_expression] = STATE(215),
    [sym_while_let_expression] = STATE(215),
    [sym_loop_expression] = STATE(215),
    [sym_for_expression] = STATE(215),
    [sym_closure_expression] = STATE(215),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(215),
    [sym_continue_expression] = STATE(215),
    [sym_index_expression] = STATE(215),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(215),
    [sym_block] = STATE(215),
    [sym__literal] = STATE(215),
    [sym_string_literal] = STATE(215),
    [sym_boolean_literal] = STATE(215),
    [sym_raw_string_literal] = ACTIONS(389),
    [sym_float_literal] = ACTIONS(389),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(389),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(389),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [39] = {
    [sym_string_literal] = STATE(217),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_const] = ACTIONS(393),
    [anon_sym_default] = ACTIONS(393),
    [anon_sym_fn] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(393),
    [anon_sym_extern] = ACTIONS(393),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(7),
    [sym_crate] = ACTIONS(395),
  },
  [40] = {
    [sym_closure_parameters] = STATE(218),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(7),
  },
  [41] = {
    [aux_sym_string_literal_repeat1] = STATE(220),
    [sym_block_comment] = ACTIONS(7),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_RBRACK_PLUS_SLASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [sym_escape_sequence] = ACTIONS(397),
    [sym_line_comment] = ACTIONS(401),
  },
  [42] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_LPAREN] = ACTIONS(403),
    [anon_sym_RPAREN] = ACTIONS(403),
    [anon_sym_LBRACE] = ACTIONS(403),
    [anon_sym_RBRACE] = ACTIONS(403),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_RBRACK] = ACTIONS(403),
    [anon_sym_PLUS] = ACTIONS(405),
    [anon_sym_STAR] = ACTIONS(405),
    [anon_sym_COMMA] = ACTIONS(403),
    [anon_sym_AMP] = ACTIONS(405),
    [anon_sym_DASH] = ACTIONS(405),
    [anon_sym_DOT] = ACTIONS(405),
    [anon_sym_DASH_EQ] = ACTIONS(403),
    [anon_sym_BANG_EQ] = ACTIONS(403),
    [anon_sym_STAR_EQ] = ACTIONS(403),
    [anon_sym_SLASH] = ACTIONS(405),
    [anon_sym_SLASH_EQ] = ACTIONS(403),
    [anon_sym_AMP_AMP] = ACTIONS(403),
    [anon_sym_AMP_EQ] = ACTIONS(403),
    [anon_sym_PERCENT] = ACTIONS(405),
    [anon_sym_PERCENT_EQ] = ACTIONS(403),
    [anon_sym_CARET] = ACTIONS(405),
    [anon_sym_CARET_EQ] = ACTIONS(403),
    [anon_sym_PLUS_EQ] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(405),
    [anon_sym_LT_LT] = ACTIONS(405),
    [anon_sym_LT_LT_EQ] = ACTIONS(403),
    [anon_sym_LT_EQ] = ACTIONS(403),
    [anon_sym_EQ] = ACTIONS(405),
    [anon_sym_EQ_EQ] = ACTIONS(403),
    [anon_sym_GT] = ACTIONS(405),
    [anon_sym_GT_EQ] = ACTIONS(403),
    [anon_sym_GT_GT] = ACTIONS(405),
    [anon_sym_GT_GT_EQ] = ACTIONS(403),
    [anon_sym_PIPE] = ACTIONS(405),
    [anon_sym_PIPE_EQ] = ACTIONS(403),
    [anon_sym_PIPE_PIPE] = ACTIONS(403),
    [anon_sym_QMARK] = ACTIONS(403),
    [anon_sym_DOT_DOT] = ACTIONS(405),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(403),
    [anon_sym_as] = ACTIONS(403),
    [anon_sym_in] = ACTIONS(403),
    [sym_line_comment] = ACTIONS(7),
  },
  [43] = {
    [sym_field_initializer_list] = STATE(224),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(407),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_LBRACE] = ACTIONS(409),
    [anon_sym_RBRACE] = ACTIONS(407),
    [anon_sym_LBRACK] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(411),
    [anon_sym_AMP] = ACTIONS(411),
    [anon_sym_DASH] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(411),
    [anon_sym_DASH_EQ] = ACTIONS(407),
    [anon_sym_COLON_COLON] = ACTIONS(413),
    [anon_sym_BANG] = ACTIONS(415),
    [anon_sym_BANG_EQ] = ACTIONS(407),
    [anon_sym_STAR_EQ] = ACTIONS(407),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_SLASH_EQ] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(407),
    [anon_sym_AMP_EQ] = ACTIONS(407),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_PERCENT_EQ] = ACTIONS(407),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_CARET_EQ] = ACTIONS(407),
    [anon_sym_PLUS_EQ] = ACTIONS(407),
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_LT_LT_EQ] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(407),
    [anon_sym_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(407),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_GT_EQ] = ACTIONS(407),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_EQ] = ACTIONS(407),
    [anon_sym_PIPE] = ACTIONS(411),
    [anon_sym_PIPE_EQ] = ACTIONS(407),
    [anon_sym_PIPE_PIPE] = ACTIONS(407),
    [anon_sym_QMARK] = ACTIONS(407),
    [anon_sym_DOT_DOT] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(407),
    [anon_sym_as] = ACTIONS(407),
    [sym_line_comment] = ACTIONS(7),
  },
  [44] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(407),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_RPAREN] = ACTIONS(407),
    [anon_sym_RBRACE] = ACTIONS(407),
    [anon_sym_LBRACK] = ACTIONS(407),
    [anon_sym_RBRACK] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(411),
    [anon_sym_COMMA] = ACTIONS(407),
    [anon_sym_AMP] = ACTIONS(411),
    [anon_sym_DASH] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(411),
    [anon_sym_DASH_EQ] = ACTIONS(407),
    [anon_sym_COLON_COLON] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(407),
    [anon_sym_STAR_EQ] = ACTIONS(407),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_SLASH_EQ] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(407),
    [anon_sym_AMP_EQ] = ACTIONS(407),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_PERCENT_EQ] = ACTIONS(407),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_CARET_EQ] = ACTIONS(407),
    [anon_sym_PLUS_EQ] = ACTIONS(407),
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_LT_LT_EQ] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(407),
    [anon_sym_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(407),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_GT_EQ] = ACTIONS(407),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_EQ] = ACTIONS(407),
    [anon_sym_PIPE] = ACTIONS(411),
    [anon_sym_PIPE_EQ] = ACTIONS(407),
    [anon_sym_PIPE_PIPE] = ACTIONS(407),
    [anon_sym_QMARK] = ACTIONS(407),
    [anon_sym_DOT_DOT] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(407),
    [anon_sym_as] = ACTIONS(407),
    [sym_line_comment] = ACTIONS(7),
  },
  [45] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON_COLON] = ACTIONS(417),
    [sym_line_comment] = ACTIONS(7),
  },
  [46] = {
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(419),
    [sym_line_comment] = ACTIONS(7),
  },
  [47] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_fn] = ACTIONS(421),
    [sym_line_comment] = ACTIONS(7),
  },
  [48] = {
    [sym_declaration_list] = STATE(227),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_default] = ACTIONS(281),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_unsafe] = ACTIONS(281),
    [anon_sym_extern] = ACTIONS(281),
    [sym_line_comment] = ACTIONS(7),
  },
  [49] = {
    [sym_function_modifiers] = STATE(239),
    [sym_extern_modifier] = STATE(240),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(427),
    [anon_sym_default] = ACTIONS(429),
    [anon_sym_enum] = ACTIONS(431),
    [anon_sym_fn] = ACTIONS(421),
    [anon_sym_mod] = ACTIONS(433),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_struct] = ACTIONS(437),
    [anon_sym_trait] = ACTIONS(439),
    [anon_sym_type] = ACTIONS(441),
    [anon_sym_union] = ACTIONS(443),
    [anon_sym_unsafe] = ACTIONS(429),
    [anon_sym_use] = ACTIONS(445),
    [anon_sym_extern] = ACTIONS(447),
    [sym_line_comment] = ACTIONS(7),
  },
  [50] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON_COLON] = ACTIONS(449),
    [sym_line_comment] = ACTIONS(7),
  },
  [51] = {
    [sym_field_initializer_list] = STATE(243),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(409),
    [anon_sym_COLON_COLON] = ACTIONS(451),
    [sym_line_comment] = ACTIONS(7),
  },
  [52] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(467),
    [anon_sym_BANG_EQ] = ACTIONS(469),
    [anon_sym_STAR_EQ] = ACTIONS(467),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(467),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_AMP_EQ] = ACTIONS(467),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(467),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_CARET_EQ] = ACTIONS(467),
    [anon_sym_PLUS_EQ] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT_LT_EQ] = ACTIONS(467),
    [anon_sym_LT_EQ] = ACTIONS(469),
    [anon_sym_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_EQ] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_PIPE_EQ] = ACTIONS(467),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(489),
    [anon_sym_as] = ACTIONS(491),
    [sym_line_comment] = ACTIONS(7),
  },
  [53] = {
    [sym_raw_string_literal] = ACTIONS(493),
    [sym_float_literal] = ACTIONS(493),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(407),
    [anon_sym_macro_rules_BANG] = ACTIONS(493),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_LBRACE] = ACTIONS(493),
    [anon_sym_RBRACE] = ACTIONS(407),
    [anon_sym_LBRACK] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(411),
    [anon_sym_u8] = ACTIONS(495),
    [anon_sym_i8] = ACTIONS(495),
    [anon_sym_u16] = ACTIONS(495),
    [anon_sym_i16] = ACTIONS(495),
    [anon_sym_u32] = ACTIONS(495),
    [anon_sym_i32] = ACTIONS(495),
    [anon_sym_u64] = ACTIONS(495),
    [anon_sym_i64] = ACTIONS(495),
    [anon_sym_u128] = ACTIONS(495),
    [anon_sym_i128] = ACTIONS(495),
    [anon_sym_isize] = ACTIONS(495),
    [anon_sym_usize] = ACTIONS(495),
    [anon_sym_f32] = ACTIONS(495),
    [anon_sym_f64] = ACTIONS(495),
    [anon_sym_bool] = ACTIONS(495),
    [anon_sym_str] = ACTIONS(495),
    [anon_sym_char] = ACTIONS(495),
    [anon_sym_AMP] = ACTIONS(411),
    [anon_sym_DASH] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(411),
    [anon_sym_DASH_EQ] = ACTIONS(407),
    [anon_sym_COLON_COLON] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(407),
    [anon_sym_STAR_EQ] = ACTIONS(407),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_SLASH_EQ] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(407),
    [anon_sym_AMP_EQ] = ACTIONS(407),
    [anon_sym_POUND] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_PERCENT_EQ] = ACTIONS(407),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_CARET_EQ] = ACTIONS(407),
    [anon_sym_PLUS_EQ] = ACTIONS(407),
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_LT_LT_EQ] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(407),
    [anon_sym_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(407),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_GT_EQ] = ACTIONS(407),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_EQ] = ACTIONS(407),
    [anon_sym_PIPE] = ACTIONS(411),
    [anon_sym_PIPE_EQ] = ACTIONS(407),
    [anon_sym_PIPE_PIPE] = ACTIONS(407),
    [anon_sym_QMARK] = ACTIONS(407),
    [anon_sym_SQUOTE] = ACTIONS(495),
    [anon_sym_DOT_DOT] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(407),
    [anon_sym_as] = ACTIONS(411),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_const] = ACTIONS(495),
    [anon_sym_continue] = ACTIONS(495),
    [anon_sym_default] = ACTIONS(495),
    [anon_sym_enum] = ACTIONS(495),
    [anon_sym_fn] = ACTIONS(495),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(495),
    [anon_sym_impl] = ACTIONS(495),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_loop] = ACTIONS(495),
    [anon_sym_match] = ACTIONS(495),
    [anon_sym_mod] = ACTIONS(495),
    [anon_sym_pub] = ACTIONS(495),
    [anon_sym_return] = ACTIONS(495),
    [anon_sym_static] = ACTIONS(495),
    [anon_sym_struct] = ACTIONS(495),
    [anon_sym_trait] = ACTIONS(495),
    [anon_sym_type] = ACTIONS(495),
    [anon_sym_union] = ACTIONS(495),
    [anon_sym_unsafe] = ACTIONS(495),
    [anon_sym_use] = ACTIONS(495),
    [anon_sym_while] = ACTIONS(495),
    [anon_sym_extern] = ACTIONS(495),
    [anon_sym_move] = ACTIONS(495),
    [sym_integer_literal] = ACTIONS(493),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(493),
    [sym_char_literal] = ACTIONS(493),
    [anon_sym_true] = ACTIONS(495),
    [anon_sym_false] = ACTIONS(495),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(495),
    [sym_self] = ACTIONS(495),
    [sym_super] = ACTIONS(495),
    [sym_crate] = ACTIONS(495),
    [sym_metavariable] = ACTIONS(493),
  },
  [54] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(407),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_RPAREN] = ACTIONS(407),
    [anon_sym_RBRACE] = ACTIONS(407),
    [anon_sym_LBRACK] = ACTIONS(407),
    [anon_sym_RBRACK] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(411),
    [anon_sym_COMMA] = ACTIONS(407),
    [anon_sym_AMP] = ACTIONS(411),
    [anon_sym_DASH] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(411),
    [anon_sym_DASH_EQ] = ACTIONS(407),
    [anon_sym_COLON_COLON] = ACTIONS(497),
    [anon_sym_BANG_EQ] = ACTIONS(407),
    [anon_sym_STAR_EQ] = ACTIONS(407),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_SLASH_EQ] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(407),
    [anon_sym_AMP_EQ] = ACTIONS(407),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_PERCENT_EQ] = ACTIONS(407),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_CARET_EQ] = ACTIONS(407),
    [anon_sym_PLUS_EQ] = ACTIONS(407),
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_LT_LT_EQ] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(407),
    [anon_sym_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(407),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_GT_EQ] = ACTIONS(407),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_EQ] = ACTIONS(407),
    [anon_sym_PIPE] = ACTIONS(411),
    [anon_sym_PIPE_EQ] = ACTIONS(407),
    [anon_sym_PIPE_PIPE] = ACTIONS(407),
    [anon_sym_QMARK] = ACTIONS(407),
    [anon_sym_DOT_DOT] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(407),
    [anon_sym_as] = ACTIONS(407),
    [sym_line_comment] = ACTIONS(7),
  },
  [55] = {
    [sym_field_initializer_list] = STATE(243),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(409),
    [sym_line_comment] = ACTIONS(7),
  },
  [56] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(499),
    [anon_sym_RPAREN] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(499),
    [anon_sym_RBRACK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(499),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_DASH_EQ] = ACTIONS(499),
    [anon_sym_BANG_EQ] = ACTIONS(499),
    [anon_sym_STAR_EQ] = ACTIONS(499),
    [anon_sym_SLASH] = ACTIONS(501),
    [anon_sym_SLASH_EQ] = ACTIONS(499),
    [anon_sym_AMP_AMP] = ACTIONS(499),
    [anon_sym_AMP_EQ] = ACTIONS(499),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_PERCENT_EQ] = ACTIONS(499),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_CARET_EQ] = ACTIONS(499),
    [anon_sym_PLUS_EQ] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_LT_LT] = ACTIONS(501),
    [anon_sym_LT_LT_EQ] = ACTIONS(499),
    [anon_sym_LT_EQ] = ACTIONS(499),
    [anon_sym_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(499),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(499),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_GT_GT_EQ] = ACTIONS(499),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_PIPE_EQ] = ACTIONS(499),
    [anon_sym_PIPE_PIPE] = ACTIONS(499),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(499),
    [anon_sym_as] = ACTIONS(499),
    [sym_line_comment] = ACTIONS(7),
  },
  [57] = {
    [sym_raw_string_literal] = ACTIONS(503),
    [sym_float_literal] = ACTIONS(503),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(503),
    [anon_sym_SEMI] = ACTIONS(503),
    [anon_sym_macro_rules_BANG] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(503),
    [anon_sym_LBRACE] = ACTIONS(503),
    [anon_sym_RBRACE] = ACTIONS(503),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(505),
    [anon_sym_u8] = ACTIONS(505),
    [anon_sym_i8] = ACTIONS(505),
    [anon_sym_u16] = ACTIONS(505),
    [anon_sym_i16] = ACTIONS(505),
    [anon_sym_u32] = ACTIONS(505),
    [anon_sym_i32] = ACTIONS(505),
    [anon_sym_u64] = ACTIONS(505),
    [anon_sym_i64] = ACTIONS(505),
    [anon_sym_u128] = ACTIONS(505),
    [anon_sym_i128] = ACTIONS(505),
    [anon_sym_isize] = ACTIONS(505),
    [anon_sym_usize] = ACTIONS(505),
    [anon_sym_f32] = ACTIONS(505),
    [anon_sym_f64] = ACTIONS(505),
    [anon_sym_bool] = ACTIONS(505),
    [anon_sym_str] = ACTIONS(505),
    [anon_sym_char] = ACTIONS(505),
    [anon_sym_AMP] = ACTIONS(505),
    [anon_sym_DASH] = ACTIONS(505),
    [anon_sym_DOT] = ACTIONS(411),
    [anon_sym_DASH_EQ] = ACTIONS(407),
    [anon_sym_COLON_COLON] = ACTIONS(503),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_BANG_EQ] = ACTIONS(407),
    [anon_sym_STAR_EQ] = ACTIONS(407),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_SLASH_EQ] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(407),
    [anon_sym_AMP_EQ] = ACTIONS(407),
    [anon_sym_POUND] = ACTIONS(503),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_PERCENT_EQ] = ACTIONS(407),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_CARET_EQ] = ACTIONS(407),
    [anon_sym_PLUS_EQ] = ACTIONS(407),
    [anon_sym_LT] = ACTIONS(505),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_LT_LT_EQ] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(407),
    [anon_sym_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(407),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_GT_EQ] = ACTIONS(407),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_EQ] = ACTIONS(407),
    [anon_sym_PIPE] = ACTIONS(505),
    [anon_sym_PIPE_EQ] = ACTIONS(407),
    [anon_sym_PIPE_PIPE] = ACTIONS(407),
    [anon_sym_QMARK] = ACTIONS(407),
    [anon_sym_SQUOTE] = ACTIONS(505),
    [anon_sym_DOT_DOT] = ACTIONS(505),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(407),
    [anon_sym_as] = ACTIONS(411),
    [anon_sym_break] = ACTIONS(505),
    [anon_sym_const] = ACTIONS(505),
    [anon_sym_continue] = ACTIONS(505),
    [anon_sym_default] = ACTIONS(505),
    [anon_sym_enum] = ACTIONS(505),
    [anon_sym_fn] = ACTIONS(505),
    [anon_sym_for] = ACTIONS(505),
    [anon_sym_if] = ACTIONS(505),
    [anon_sym_impl] = ACTIONS(505),
    [anon_sym_let] = ACTIONS(505),
    [anon_sym_loop] = ACTIONS(505),
    [anon_sym_match] = ACTIONS(505),
    [anon_sym_mod] = ACTIONS(505),
    [anon_sym_pub] = ACTIONS(505),
    [anon_sym_return] = ACTIONS(505),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_struct] = ACTIONS(505),
    [anon_sym_trait] = ACTIONS(505),
    [anon_sym_type] = ACTIONS(505),
    [anon_sym_union] = ACTIONS(505),
    [anon_sym_unsafe] = ACTIONS(505),
    [anon_sym_use] = ACTIONS(505),
    [anon_sym_while] = ACTIONS(505),
    [anon_sym_extern] = ACTIONS(505),
    [anon_sym_move] = ACTIONS(505),
    [sym_integer_literal] = ACTIONS(503),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(503),
    [sym_char_literal] = ACTIONS(503),
    [anon_sym_true] = ACTIONS(505),
    [anon_sym_false] = ACTIONS(505),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(505),
    [sym_self] = ACTIONS(505),
    [sym_super] = ACTIONS(505),
    [sym_crate] = ACTIONS(505),
    [sym_metavariable] = ACTIONS(503),
  },
  [58] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(266),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(266),
    [sym_macro_invocation] = STATE(266),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(266),
    [sym_unary_expression] = STATE(266),
    [sym_try_expression] = STATE(266),
    [sym_reference_expression] = STATE(266),
    [sym_binary_expression] = STATE(266),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(266),
    [sym_call_expression] = STATE(266),
    [sym_array_expression] = STATE(266),
    [sym_parenthesized_expression] = STATE(266),
    [sym_tuple_expression] = STATE(266),
    [sym_unit_expression] = STATE(266),
    [sym_struct_expression] = STATE(266),
    [sym_if_expression] = STATE(266),
    [sym_if_let_expression] = STATE(266),
    [sym_match_expression] = STATE(266),
    [sym_while_expression] = STATE(266),
    [sym_while_let_expression] = STATE(266),
    [sym_loop_expression] = STATE(266),
    [sym_for_expression] = STATE(266),
    [sym_closure_expression] = STATE(266),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(266),
    [sym_continue_expression] = STATE(266),
    [sym_index_expression] = STATE(266),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(266),
    [sym_block] = STATE(266),
    [sym__literal] = STATE(266),
    [sym_string_literal] = STATE(266),
    [sym_boolean_literal] = STATE(266),
    [sym_raw_string_literal] = ACTIONS(507),
    [sym_float_literal] = ACTIONS(507),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_DASH_GT] = ACTIONS(509),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(507),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(507),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [59] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(511),
    [sym_line_comment] = ACTIONS(7),
  },
  [60] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(407),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_RPAREN] = ACTIONS(407),
    [anon_sym_LBRACE] = ACTIONS(407),
    [anon_sym_RBRACE] = ACTIONS(407),
    [anon_sym_LBRACK] = ACTIONS(407),
    [anon_sym_RBRACK] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(411),
    [anon_sym_COMMA] = ACTIONS(407),
    [anon_sym_AMP] = ACTIONS(411),
    [anon_sym_DASH] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(411),
    [anon_sym_DASH_EQ] = ACTIONS(407),
    [anon_sym_COLON_COLON] = ACTIONS(513),
    [anon_sym_BANG_EQ] = ACTIONS(407),
    [anon_sym_STAR_EQ] = ACTIONS(407),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_SLASH_EQ] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(407),
    [anon_sym_AMP_EQ] = ACTIONS(407),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_PERCENT_EQ] = ACTIONS(407),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_CARET_EQ] = ACTIONS(407),
    [anon_sym_PLUS_EQ] = ACTIONS(407),
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_LT_LT_EQ] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(407),
    [anon_sym_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(407),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_GT_EQ] = ACTIONS(407),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_EQ] = ACTIONS(407),
    [anon_sym_PIPE] = ACTIONS(411),
    [anon_sym_PIPE_EQ] = ACTIONS(407),
    [anon_sym_PIPE_PIPE] = ACTIONS(407),
    [anon_sym_QMARK] = ACTIONS(407),
    [anon_sym_DOT_DOT] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(407),
    [anon_sym_as] = ACTIONS(407),
    [sym_line_comment] = ACTIONS(7),
  },
  [61] = {
    [sym__statement] = STATE(269),
    [sym_empty_statement] = STATE(269),
    [sym__expression_statement] = STATE(269),
    [sym_macro_definition] = STATE(269),
    [sym_attribute_item] = STATE(269),
    [sym_inner_attribute_item] = STATE(269),
    [sym_mod_item] = STATE(269),
    [sym_foreign_mod_item] = STATE(269),
    [sym_struct_item] = STATE(269),
    [sym_union_item] = STATE(269),
    [sym_enum_item] = STATE(269),
    [sym_extern_crate_declaration] = STATE(269),
    [sym_const_item] = STATE(269),
    [sym_static_item] = STATE(269),
    [sym_type_item] = STATE(269),
    [sym_function_item] = STATE(269),
    [sym_function_signature_item] = STATE(269),
    [sym_function_modifiers] = STATE(47),
    [sym_impl_item] = STATE(269),
    [sym_trait_item] = STATE(269),
    [sym_associated_type] = STATE(269),
    [sym_let_declaration] = STATE(269),
    [sym_use_declaration] = STATE(269),
    [sym_extern_modifier] = STATE(48),
    [sym_visibility_modifier] = STATE(49),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(52),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(52),
    [sym_macro_invocation] = STATE(53),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(52),
    [sym_unary_expression] = STATE(52),
    [sym_try_expression] = STATE(52),
    [sym_reference_expression] = STATE(52),
    [sym_binary_expression] = STATE(52),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(52),
    [sym_call_expression] = STATE(52),
    [sym_array_expression] = STATE(52),
    [sym_parenthesized_expression] = STATE(52),
    [sym_tuple_expression] = STATE(52),
    [sym_unit_expression] = STATE(52),
    [sym_struct_expression] = STATE(52),
    [sym_if_expression] = STATE(57),
    [sym_if_let_expression] = STATE(57),
    [sym_match_expression] = STATE(57),
    [sym_while_expression] = STATE(57),
    [sym_while_let_expression] = STATE(57),
    [sym_loop_expression] = STATE(57),
    [sym_for_expression] = STATE(57),
    [sym_closure_expression] = STATE(52),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(59),
    [sym_break_expression] = STATE(52),
    [sym_continue_expression] = STATE(52),
    [sym_index_expression] = STATE(52),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(57),
    [sym_block] = STATE(57),
    [sym__literal] = STATE(52),
    [sym_string_literal] = STATE(52),
    [sym_boolean_literal] = STATE(52),
    [aux_sym_source_file_repeat1] = STATE(269),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_raw_string_literal] = ACTIONS(5),
    [sym_float_literal] = ACTIONS(5),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(515),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_POUND] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(5),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(5),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(93),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [62] = {
    [sym_extern_modifier] = STATE(271),
    [aux_sym_function_modifiers_repeat1] = STATE(271),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(517),
    [anon_sym_default] = ACTIONS(517),
    [anon_sym_fn] = ACTIONS(519),
    [anon_sym_unsafe] = ACTIONS(517),
    [anon_sym_extern] = ACTIONS(521),
    [sym_line_comment] = ACTIONS(7),
  },
  [63] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(523),
    [anon_sym_LBRACE] = ACTIONS(525),
    [sym_line_comment] = ACTIONS(7),
  },
  [64] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(527),
    [anon_sym_RPAREN] = ACTIONS(527),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_RBRACE] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(527),
    [anon_sym_RBRACK] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_STAR] = ACTIONS(529),
    [anon_sym_COMMA] = ACTIONS(527),
    [anon_sym_AMP] = ACTIONS(529),
    [anon_sym_DASH] = ACTIONS(529),
    [anon_sym_DOT] = ACTIONS(529),
    [anon_sym_DASH_EQ] = ACTIONS(527),
    [anon_sym_BANG_EQ] = ACTIONS(527),
    [anon_sym_STAR_EQ] = ACTIONS(527),
    [anon_sym_SLASH] = ACTIONS(529),
    [anon_sym_SLASH_EQ] = ACTIONS(527),
    [anon_sym_AMP_AMP] = ACTIONS(527),
    [anon_sym_AMP_EQ] = ACTIONS(527),
    [anon_sym_PERCENT] = ACTIONS(529),
    [anon_sym_PERCENT_EQ] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(529),
    [anon_sym_CARET_EQ] = ACTIONS(527),
    [anon_sym_PLUS_EQ] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(529),
    [anon_sym_LT_LT] = ACTIONS(529),
    [anon_sym_LT_LT_EQ] = ACTIONS(527),
    [anon_sym_LT_EQ] = ACTIONS(527),
    [anon_sym_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(527),
    [anon_sym_GT] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(527),
    [anon_sym_GT_GT] = ACTIONS(529),
    [anon_sym_GT_GT_EQ] = ACTIONS(527),
    [anon_sym_PIPE] = ACTIONS(529),
    [anon_sym_PIPE_EQ] = ACTIONS(527),
    [anon_sym_PIPE_PIPE] = ACTIONS(527),
    [anon_sym_QMARK] = ACTIONS(527),
    [anon_sym_DOT_DOT] = ACTIONS(529),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(527),
    [anon_sym_as] = ACTIONS(527),
    [sym_line_comment] = ACTIONS(7),
  },
  [65] = {
    [sym__statement] = STATE(276),
    [sym_empty_statement] = STATE(276),
    [sym__expression_statement] = STATE(276),
    [sym_macro_definition] = STATE(276),
    [sym_attribute_item] = STATE(276),
    [sym_inner_attribute_item] = STATE(276),
    [sym_mod_item] = STATE(276),
    [sym_foreign_mod_item] = STATE(276),
    [sym_struct_item] = STATE(276),
    [sym_union_item] = STATE(276),
    [sym_enum_item] = STATE(276),
    [sym_extern_crate_declaration] = STATE(276),
    [sym_const_item] = STATE(276),
    [sym_static_item] = STATE(276),
    [sym_type_item] = STATE(276),
    [sym_function_item] = STATE(276),
    [sym_function_signature_item] = STATE(276),
    [sym_function_modifiers] = STATE(47),
    [sym_impl_item] = STATE(276),
    [sym_trait_item] = STATE(276),
    [sym_associated_type] = STATE(276),
    [sym_let_declaration] = STATE(276),
    [sym_use_declaration] = STATE(276),
    [sym_extern_modifier] = STATE(48),
    [sym_visibility_modifier] = STATE(49),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(275),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(275),
    [sym_macro_invocation] = STATE(53),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(275),
    [sym_unary_expression] = STATE(275),
    [sym_try_expression] = STATE(275),
    [sym_reference_expression] = STATE(275),
    [sym_binary_expression] = STATE(275),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(275),
    [sym_call_expression] = STATE(275),
    [sym_array_expression] = STATE(275),
    [sym_parenthesized_expression] = STATE(275),
    [sym_tuple_expression] = STATE(275),
    [sym_unit_expression] = STATE(275),
    [sym_struct_expression] = STATE(275),
    [sym_if_expression] = STATE(57),
    [sym_if_let_expression] = STATE(57),
    [sym_match_expression] = STATE(57),
    [sym_while_expression] = STATE(57),
    [sym_while_let_expression] = STATE(57),
    [sym_loop_expression] = STATE(57),
    [sym_for_expression] = STATE(57),
    [sym_closure_expression] = STATE(275),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(59),
    [sym_break_expression] = STATE(275),
    [sym_continue_expression] = STATE(275),
    [sym_index_expression] = STATE(275),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(57),
    [sym_block] = STATE(57),
    [sym__literal] = STATE(275),
    [sym_string_literal] = STATE(275),
    [sym_boolean_literal] = STATE(275),
    [aux_sym_source_file_repeat1] = STATE(276),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_raw_string_literal] = ACTIONS(531),
    [sym_float_literal] = ACTIONS(531),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_POUND] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(531),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(531),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(93),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [66] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(103),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(103),
    [sym_macro_invocation] = STATE(103),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(103),
    [sym_unary_expression] = STATE(103),
    [sym_try_expression] = STATE(103),
    [sym_reference_expression] = STATE(103),
    [sym_binary_expression] = STATE(103),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(103),
    [sym_call_expression] = STATE(103),
    [sym_array_expression] = STATE(103),
    [sym_parenthesized_expression] = STATE(103),
    [sym_tuple_expression] = STATE(103),
    [sym_unit_expression] = STATE(103),
    [sym_struct_expression] = STATE(103),
    [sym_if_expression] = STATE(103),
    [sym_if_let_expression] = STATE(103),
    [sym_match_expression] = STATE(103),
    [sym_while_expression] = STATE(103),
    [sym_while_let_expression] = STATE(103),
    [sym_loop_expression] = STATE(103),
    [sym_for_expression] = STATE(103),
    [sym_closure_expression] = STATE(103),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(103),
    [sym_continue_expression] = STATE(103),
    [sym_index_expression] = STATE(103),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(103),
    [sym_block] = STATE(103),
    [sym__literal] = STATE(103),
    [sym_string_literal] = STATE(103),
    [sym_boolean_literal] = STATE(103),
    [sym_raw_string_literal] = ACTIONS(173),
    [sym_float_literal] = ACTIONS(173),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(173),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(173),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [67] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(106),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(106),
    [sym_macro_invocation] = STATE(106),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(106),
    [sym_unary_expression] = STATE(106),
    [sym_try_expression] = STATE(106),
    [sym_reference_expression] = STATE(106),
    [sym_binary_expression] = STATE(106),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(106),
    [sym_call_expression] = STATE(106),
    [sym_array_expression] = STATE(106),
    [sym_parenthesized_expression] = STATE(106),
    [sym_tuple_expression] = STATE(106),
    [sym_unit_expression] = STATE(106),
    [sym_struct_expression] = STATE(106),
    [sym_if_expression] = STATE(106),
    [sym_if_let_expression] = STATE(106),
    [sym_match_expression] = STATE(106),
    [sym_while_expression] = STATE(106),
    [sym_while_let_expression] = STATE(106),
    [sym_loop_expression] = STATE(106),
    [sym_for_expression] = STATE(106),
    [sym_closure_expression] = STATE(106),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(106),
    [sym_continue_expression] = STATE(106),
    [sym_index_expression] = STATE(106),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(106),
    [sym_block] = STATE(106),
    [sym__literal] = STATE(106),
    [sym_string_literal] = STATE(106),
    [sym_boolean_literal] = STATE(106),
    [sym_raw_string_literal] = ACTIONS(183),
    [sym_float_literal] = ACTIONS(183),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [sym_mutable_specifier] = ACTIONS(535),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(183),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(183),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [68] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(278),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(278),
    [sym_macro_invocation] = STATE(278),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(278),
    [sym_unary_expression] = STATE(278),
    [sym_try_expression] = STATE(278),
    [sym_reference_expression] = STATE(278),
    [sym_binary_expression] = STATE(278),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_array_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_tuple_expression] = STATE(278),
    [sym_unit_expression] = STATE(278),
    [sym_struct_expression] = STATE(278),
    [sym_if_expression] = STATE(278),
    [sym_if_let_expression] = STATE(278),
    [sym_match_expression] = STATE(278),
    [sym_while_expression] = STATE(278),
    [sym_while_let_expression] = STATE(278),
    [sym_loop_expression] = STATE(278),
    [sym_for_expression] = STATE(278),
    [sym_closure_expression] = STATE(278),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(278),
    [sym_continue_expression] = STATE(278),
    [sym_index_expression] = STATE(278),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(278),
    [sym_block] = STATE(278),
    [sym__literal] = STATE(278),
    [sym_string_literal] = STATE(278),
    [sym_boolean_literal] = STATE(278),
    [sym_raw_string_literal] = ACTIONS(537),
    [sym_float_literal] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(261),
    [anon_sym_RPAREN] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_PLUS] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(263),
    [anon_sym_COMMA] = ACTIONS(261),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(263),
    [anon_sym_DASH] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(263),
    [anon_sym_DASH_EQ] = ACTIONS(261),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_BANG_EQ] = ACTIONS(261),
    [anon_sym_STAR_EQ] = ACTIONS(261),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_SLASH_EQ] = ACTIONS(261),
    [anon_sym_AMP_AMP] = ACTIONS(261),
    [anon_sym_AMP_EQ] = ACTIONS(261),
    [anon_sym_PERCENT] = ACTIONS(263),
    [anon_sym_PERCENT_EQ] = ACTIONS(261),
    [anon_sym_CARET] = ACTIONS(263),
    [anon_sym_CARET_EQ] = ACTIONS(261),
    [anon_sym_PLUS_EQ] = ACTIONS(261),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_EQ] = ACTIONS(261),
    [anon_sym_LT_EQ] = ACTIONS(261),
    [anon_sym_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(261),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_EQ] = ACTIONS(261),
    [anon_sym_GT_GT] = ACTIONS(263),
    [anon_sym_GT_GT_EQ] = ACTIONS(261),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_PIPE_EQ] = ACTIONS(261),
    [anon_sym_PIPE_PIPE] = ACTIONS(261),
    [anon_sym_QMARK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(263),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(261),
    [anon_sym_as] = ACTIONS(263),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(537),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [69] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(177),
    [anon_sym_RPAREN] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_RBRACE] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(177),
    [anon_sym_RBRACK] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_DASH] = ACTIONS(179),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ] = ACTIONS(177),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(177),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(177),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_as] = ACTIONS(177),
    [sym_line_comment] = ACTIONS(7),
  },
  [70] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(279),
    [sym_tuple_pattern] = STATE(279),
    [sym_tuple_struct_pattern] = STATE(279),
    [sym_struct_pattern] = STATE(279),
    [sym_remaining_field_pattern] = STATE(279),
    [sym_mut_pattern] = STATE(279),
    [sym_ref_pattern] = STATE(279),
    [sym_captured_pattern] = STATE(279),
    [sym_reference_pattern] = STATE(279),
    [sym__literal] = STATE(279),
    [sym_string_literal] = STATE(279),
    [sym_boolean_literal] = STATE(279),
    [sym_raw_string_literal] = ACTIONS(541),
    [sym_float_literal] = ACTIONS(541),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(293),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(295),
    [anon_sym_ref] = ACTIONS(297),
    [sym_integer_literal] = ACTIONS(541),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(541),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(299),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [71] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(281),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(281),
    [sym_macro_invocation] = STATE(281),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(281),
    [sym_unary_expression] = STATE(281),
    [sym_try_expression] = STATE(281),
    [sym_reference_expression] = STATE(281),
    [sym_binary_expression] = STATE(281),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(281),
    [sym_call_expression] = STATE(281),
    [sym_array_expression] = STATE(281),
    [sym_parenthesized_expression] = STATE(281),
    [sym_tuple_expression] = STATE(281),
    [sym_unit_expression] = STATE(281),
    [sym_struct_expression] = STATE(281),
    [sym_if_expression] = STATE(281),
    [sym_if_let_expression] = STATE(281),
    [sym_match_expression] = STATE(281),
    [sym_while_expression] = STATE(281),
    [sym_while_let_expression] = STATE(281),
    [sym_loop_expression] = STATE(281),
    [sym_for_expression] = STATE(281),
    [sym_closure_expression] = STATE(281),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(281),
    [sym_continue_expression] = STATE(281),
    [sym_index_expression] = STATE(281),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(281),
    [sym_block] = STATE(281),
    [sym__literal] = STATE(281),
    [sym_string_literal] = STATE(281),
    [sym_boolean_literal] = STATE(281),
    [sym_raw_string_literal] = ACTIONS(545),
    [sym_float_literal] = ACTIONS(545),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_let] = ACTIONS(547),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(545),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(545),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [72] = {
    [sym_block] = STATE(282),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(111),
    [sym_line_comment] = ACTIONS(7),
  },
  [73] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(283),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(283),
    [sym_macro_invocation] = STATE(283),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(283),
    [sym_unary_expression] = STATE(283),
    [sym_try_expression] = STATE(283),
    [sym_reference_expression] = STATE(283),
    [sym_binary_expression] = STATE(283),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(283),
    [sym_call_expression] = STATE(283),
    [sym_array_expression] = STATE(283),
    [sym_parenthesized_expression] = STATE(283),
    [sym_tuple_expression] = STATE(283),
    [sym_unit_expression] = STATE(283),
    [sym_struct_expression] = STATE(283),
    [sym_if_expression] = STATE(283),
    [sym_if_let_expression] = STATE(283),
    [sym_match_expression] = STATE(283),
    [sym_while_expression] = STATE(283),
    [sym_while_let_expression] = STATE(283),
    [sym_loop_expression] = STATE(283),
    [sym_for_expression] = STATE(283),
    [sym_closure_expression] = STATE(283),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(283),
    [sym_continue_expression] = STATE(283),
    [sym_index_expression] = STATE(283),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(283),
    [sym_block] = STATE(283),
    [sym__literal] = STATE(283),
    [sym_string_literal] = STATE(283),
    [sym_boolean_literal] = STATE(283),
    [sym_raw_string_literal] = ACTIONS(549),
    [sym_float_literal] = ACTIONS(549),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(549),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(549),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [74] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(284),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(284),
    [sym_macro_invocation] = STATE(284),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(284),
    [sym_unary_expression] = STATE(284),
    [sym_try_expression] = STATE(284),
    [sym_reference_expression] = STATE(284),
    [sym_binary_expression] = STATE(284),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(284),
    [sym_call_expression] = STATE(284),
    [sym_array_expression] = STATE(284),
    [sym_parenthesized_expression] = STATE(284),
    [sym_tuple_expression] = STATE(284),
    [sym_unit_expression] = STATE(284),
    [sym_struct_expression] = STATE(284),
    [sym_if_expression] = STATE(284),
    [sym_if_let_expression] = STATE(284),
    [sym_match_expression] = STATE(284),
    [sym_while_expression] = STATE(284),
    [sym_while_let_expression] = STATE(284),
    [sym_loop_expression] = STATE(284),
    [sym_for_expression] = STATE(284),
    [sym_closure_expression] = STATE(284),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(284),
    [sym_continue_expression] = STATE(284),
    [sym_index_expression] = STATE(284),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(284),
    [sym_block] = STATE(284),
    [sym__literal] = STATE(284),
    [sym_string_literal] = STATE(284),
    [sym_boolean_literal] = STATE(284),
    [sym_raw_string_literal] = ACTIONS(551),
    [sym_float_literal] = ACTIONS(551),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(359),
    [anon_sym_RPAREN] = ACTIONS(359),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(361),
    [anon_sym_STAR] = ACTIONS(361),
    [anon_sym_COMMA] = ACTIONS(359),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(361),
    [anon_sym_DASH_EQ] = ACTIONS(359),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_BANG_EQ] = ACTIONS(359),
    [anon_sym_STAR_EQ] = ACTIONS(359),
    [anon_sym_SLASH] = ACTIONS(361),
    [anon_sym_SLASH_EQ] = ACTIONS(359),
    [anon_sym_AMP_AMP] = ACTIONS(359),
    [anon_sym_AMP_EQ] = ACTIONS(359),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_PERCENT_EQ] = ACTIONS(359),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_CARET_EQ] = ACTIONS(359),
    [anon_sym_PLUS_EQ] = ACTIONS(359),
    [anon_sym_LT] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_LT_LT_EQ] = ACTIONS(359),
    [anon_sym_LT_EQ] = ACTIONS(359),
    [anon_sym_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(359),
    [anon_sym_GT] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(359),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_GT_GT_EQ] = ACTIONS(359),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_PIPE_EQ] = ACTIONS(359),
    [anon_sym_PIPE_PIPE] = ACTIONS(359),
    [anon_sym_QMARK] = ACTIONS(359),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(361),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(359),
    [anon_sym_as] = ACTIONS(361),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(551),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(551),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [75] = {
    [sym_block] = STATE(285),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(111),
    [sym_line_comment] = ACTIONS(7),
  },
  [76] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(287),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(287),
    [sym_macro_invocation] = STATE(287),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(287),
    [sym_unary_expression] = STATE(287),
    [sym_try_expression] = STATE(287),
    [sym_reference_expression] = STATE(287),
    [sym_binary_expression] = STATE(287),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(287),
    [sym_call_expression] = STATE(287),
    [sym_array_expression] = STATE(287),
    [sym_parenthesized_expression] = STATE(287),
    [sym_tuple_expression] = STATE(287),
    [sym_unit_expression] = STATE(287),
    [sym_struct_expression] = STATE(287),
    [sym_if_expression] = STATE(287),
    [sym_if_let_expression] = STATE(287),
    [sym_match_expression] = STATE(287),
    [sym_while_expression] = STATE(287),
    [sym_while_let_expression] = STATE(287),
    [sym_loop_expression] = STATE(287),
    [sym_for_expression] = STATE(287),
    [sym_closure_expression] = STATE(287),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(287),
    [sym_continue_expression] = STATE(287),
    [sym_index_expression] = STATE(287),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(287),
    [sym_block] = STATE(287),
    [sym__literal] = STATE(287),
    [sym_string_literal] = STATE(287),
    [sym_boolean_literal] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(553),
    [sym_float_literal] = ACTIONS(553),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(553),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(553),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [77] = {
    [sym_closure_parameters] = STATE(288),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(7),
  },
  [78] = {
    [sym_field_initializer_list] = STATE(224),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(407),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_RPAREN] = ACTIONS(407),
    [anon_sym_LBRACE] = ACTIONS(409),
    [anon_sym_RBRACE] = ACTIONS(407),
    [anon_sym_LBRACK] = ACTIONS(407),
    [anon_sym_RBRACK] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(411),
    [anon_sym_COMMA] = ACTIONS(407),
    [anon_sym_AMP] = ACTIONS(411),
    [anon_sym_DASH] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(411),
    [anon_sym_DASH_EQ] = ACTIONS(407),
    [anon_sym_COLON_COLON] = ACTIONS(413),
    [anon_sym_BANG] = ACTIONS(557),
    [anon_sym_BANG_EQ] = ACTIONS(407),
    [anon_sym_STAR_EQ] = ACTIONS(407),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_SLASH_EQ] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(407),
    [anon_sym_AMP_EQ] = ACTIONS(407),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_PERCENT_EQ] = ACTIONS(407),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_CARET_EQ] = ACTIONS(407),
    [anon_sym_PLUS_EQ] = ACTIONS(407),
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_LT_LT_EQ] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(407),
    [anon_sym_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(407),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_GT_EQ] = ACTIONS(407),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_EQ] = ACTIONS(407),
    [anon_sym_PIPE] = ACTIONS(411),
    [anon_sym_PIPE_EQ] = ACTIONS(407),
    [anon_sym_PIPE_PIPE] = ACTIONS(407),
    [anon_sym_QMARK] = ACTIONS(407),
    [anon_sym_DOT_DOT] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(407),
    [anon_sym_as] = ACTIONS(407),
    [sym_line_comment] = ACTIONS(7),
  },
  [79] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_BANG_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH] = ACTIONS(563),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(563),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_LT] = ACTIONS(577),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(581),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(577),
    [anon_sym_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(589),
    [anon_sym_as] = ACTIONS(591),
    [sym_line_comment] = ACTIONS(7),
  },
  [80] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(306),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(306),
    [sym_macro_invocation] = STATE(306),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(306),
    [sym_unary_expression] = STATE(306),
    [sym_try_expression] = STATE(306),
    [sym_reference_expression] = STATE(306),
    [sym_binary_expression] = STATE(306),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(306),
    [sym_call_expression] = STATE(306),
    [sym_array_expression] = STATE(306),
    [sym_parenthesized_expression] = STATE(306),
    [sym_tuple_expression] = STATE(306),
    [sym_unit_expression] = STATE(306),
    [sym_struct_expression] = STATE(306),
    [sym_if_expression] = STATE(306),
    [sym_if_let_expression] = STATE(306),
    [sym_match_expression] = STATE(306),
    [sym_while_expression] = STATE(306),
    [sym_while_let_expression] = STATE(306),
    [sym_loop_expression] = STATE(306),
    [sym_for_expression] = STATE(306),
    [sym_closure_expression] = STATE(306),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(306),
    [sym_continue_expression] = STATE(306),
    [sym_index_expression] = STATE(306),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(306),
    [sym_block] = STATE(306),
    [sym__literal] = STATE(306),
    [sym_string_literal] = STATE(306),
    [sym_boolean_literal] = STATE(306),
    [sym_raw_string_literal] = ACTIONS(593),
    [sym_float_literal] = ACTIONS(593),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(539),
    [anon_sym_DASH_GT] = ACTIONS(509),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(593),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(593),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [81] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(595),
    [sym_line_comment] = ACTIONS(7),
  },
  [82] = {
    [sym_raw_string_literal] = ACTIONS(597),
    [sym_float_literal] = ACTIONS(597),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(597),
    [anon_sym_SEMI] = ACTIONS(597),
    [anon_sym_macro_rules_BANG] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(597),
    [anon_sym_RBRACE] = ACTIONS(597),
    [anon_sym_LBRACK] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(599),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_u8] = ACTIONS(599),
    [anon_sym_i8] = ACTIONS(599),
    [anon_sym_u16] = ACTIONS(599),
    [anon_sym_i16] = ACTIONS(599),
    [anon_sym_u32] = ACTIONS(599),
    [anon_sym_i32] = ACTIONS(599),
    [anon_sym_u64] = ACTIONS(599),
    [anon_sym_i64] = ACTIONS(599),
    [anon_sym_u128] = ACTIONS(599),
    [anon_sym_i128] = ACTIONS(599),
    [anon_sym_isize] = ACTIONS(599),
    [anon_sym_usize] = ACTIONS(599),
    [anon_sym_f32] = ACTIONS(599),
    [anon_sym_f64] = ACTIONS(599),
    [anon_sym_bool] = ACTIONS(599),
    [anon_sym_str] = ACTIONS(599),
    [anon_sym_char] = ACTIONS(599),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_DASH] = ACTIONS(599),
    [anon_sym_DOT] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(597),
    [anon_sym_COLON_COLON] = ACTIONS(597),
    [anon_sym_BANG] = ACTIONS(599),
    [anon_sym_BANG_EQ] = ACTIONS(597),
    [anon_sym_STAR_EQ] = ACTIONS(597),
    [anon_sym_SLASH] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(597),
    [anon_sym_AMP_AMP] = ACTIONS(597),
    [anon_sym_AMP_EQ] = ACTIONS(597),
    [anon_sym_POUND] = ACTIONS(597),
    [anon_sym_PERCENT] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(597),
    [anon_sym_CARET] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(597),
    [anon_sym_PLUS_EQ] = ACTIONS(597),
    [anon_sym_LT] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(597),
    [anon_sym_LT_EQ] = ACTIONS(597),
    [anon_sym_EQ] = ACTIONS(599),
    [anon_sym_EQ_EQ] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(599),
    [anon_sym_GT_EQ] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(597),
    [anon_sym_PIPE] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(597),
    [anon_sym_PIPE_PIPE] = ACTIONS(597),
    [anon_sym_QMARK] = ACTIONS(597),
    [anon_sym_SQUOTE] = ACTIONS(599),
    [anon_sym_DOT_DOT] = ACTIONS(599),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(597),
    [anon_sym_as] = ACTIONS(599),
    [anon_sym_break] = ACTIONS(599),
    [anon_sym_const] = ACTIONS(599),
    [anon_sym_continue] = ACTIONS(599),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_enum] = ACTIONS(599),
    [anon_sym_fn] = ACTIONS(599),
    [anon_sym_for] = ACTIONS(599),
    [anon_sym_if] = ACTIONS(599),
    [anon_sym_impl] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(599),
    [anon_sym_loop] = ACTIONS(599),
    [anon_sym_match] = ACTIONS(599),
    [anon_sym_mod] = ACTIONS(599),
    [anon_sym_pub] = ACTIONS(599),
    [anon_sym_return] = ACTIONS(599),
    [anon_sym_static] = ACTIONS(599),
    [anon_sym_struct] = ACTIONS(599),
    [anon_sym_trait] = ACTIONS(599),
    [anon_sym_type] = ACTIONS(599),
    [anon_sym_union] = ACTIONS(599),
    [anon_sym_unsafe] = ACTIONS(599),
    [anon_sym_use] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(599),
    [anon_sym_extern] = ACTIONS(599),
    [anon_sym_else] = ACTIONS(599),
    [anon_sym_move] = ACTIONS(599),
    [sym_integer_literal] = ACTIONS(597),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(597),
    [sym_char_literal] = ACTIONS(597),
    [anon_sym_true] = ACTIONS(599),
    [anon_sym_false] = ACTIONS(599),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(599),
    [sym_self] = ACTIONS(599),
    [sym_super] = ACTIONS(599),
    [sym_crate] = ACTIONS(599),
    [sym_metavariable] = ACTIONS(597),
  },
  [83] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(103),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(103),
    [sym_macro_invocation] = STATE(103),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(103),
    [sym_unary_expression] = STATE(103),
    [sym_try_expression] = STATE(103),
    [sym_reference_expression] = STATE(103),
    [sym_binary_expression] = STATE(103),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(103),
    [sym_call_expression] = STATE(103),
    [sym_array_expression] = STATE(103),
    [sym_parenthesized_expression] = STATE(103),
    [sym_tuple_expression] = STATE(103),
    [sym_unit_expression] = STATE(103),
    [sym_struct_expression] = STATE(103),
    [sym_if_expression] = STATE(103),
    [sym_if_let_expression] = STATE(103),
    [sym_match_expression] = STATE(103),
    [sym_while_expression] = STATE(103),
    [sym_while_let_expression] = STATE(103),
    [sym_loop_expression] = STATE(103),
    [sym_for_expression] = STATE(103),
    [sym_closure_expression] = STATE(103),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(103),
    [sym_continue_expression] = STATE(103),
    [sym_index_expression] = STATE(103),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(103),
    [sym_block] = STATE(103),
    [sym__literal] = STATE(103),
    [sym_string_literal] = STATE(103),
    [sym_boolean_literal] = STATE(103),
    [sym_raw_string_literal] = ACTIONS(173),
    [sym_float_literal] = ACTIONS(173),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(601),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(173),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(173),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [84] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(106),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(106),
    [sym_macro_invocation] = STATE(106),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(106),
    [sym_unary_expression] = STATE(106),
    [sym_try_expression] = STATE(106),
    [sym_reference_expression] = STATE(106),
    [sym_binary_expression] = STATE(106),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(106),
    [sym_call_expression] = STATE(106),
    [sym_array_expression] = STATE(106),
    [sym_parenthesized_expression] = STATE(106),
    [sym_tuple_expression] = STATE(106),
    [sym_unit_expression] = STATE(106),
    [sym_struct_expression] = STATE(106),
    [sym_if_expression] = STATE(106),
    [sym_if_let_expression] = STATE(106),
    [sym_match_expression] = STATE(106),
    [sym_while_expression] = STATE(106),
    [sym_while_let_expression] = STATE(106),
    [sym_loop_expression] = STATE(106),
    [sym_for_expression] = STATE(106),
    [sym_closure_expression] = STATE(106),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(106),
    [sym_continue_expression] = STATE(106),
    [sym_index_expression] = STATE(106),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(106),
    [sym_block] = STATE(106),
    [sym__literal] = STATE(106),
    [sym_string_literal] = STATE(106),
    [sym_boolean_literal] = STATE(106),
    [sym_raw_string_literal] = ACTIONS(183),
    [sym_float_literal] = ACTIONS(183),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(601),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [sym_mutable_specifier] = ACTIONS(603),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(183),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(183),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [85] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(310),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(310),
    [sym_macro_invocation] = STATE(310),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(310),
    [sym_unary_expression] = STATE(310),
    [sym_try_expression] = STATE(310),
    [sym_reference_expression] = STATE(310),
    [sym_binary_expression] = STATE(310),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(310),
    [sym_call_expression] = STATE(310),
    [sym_array_expression] = STATE(310),
    [sym_parenthesized_expression] = STATE(310),
    [sym_tuple_expression] = STATE(310),
    [sym_unit_expression] = STATE(310),
    [sym_struct_expression] = STATE(310),
    [sym_if_expression] = STATE(310),
    [sym_if_let_expression] = STATE(310),
    [sym_match_expression] = STATE(310),
    [sym_while_expression] = STATE(310),
    [sym_while_let_expression] = STATE(310),
    [sym_loop_expression] = STATE(310),
    [sym_for_expression] = STATE(310),
    [sym_closure_expression] = STATE(310),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(310),
    [sym_continue_expression] = STATE(310),
    [sym_index_expression] = STATE(310),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(310),
    [sym_block] = STATE(310),
    [sym__literal] = STATE(310),
    [sym_string_literal] = STATE(310),
    [sym_boolean_literal] = STATE(310),
    [sym_raw_string_literal] = ACTIONS(605),
    [sym_float_literal] = ACTIONS(605),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(261),
    [anon_sym_LPAREN] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(261),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_PLUS] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(263),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(263),
    [anon_sym_DASH] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(263),
    [anon_sym_DASH_EQ] = ACTIONS(261),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_BANG_EQ] = ACTIONS(261),
    [anon_sym_STAR_EQ] = ACTIONS(261),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_SLASH_EQ] = ACTIONS(261),
    [anon_sym_AMP_AMP] = ACTIONS(261),
    [anon_sym_AMP_EQ] = ACTIONS(261),
    [anon_sym_PERCENT] = ACTIONS(263),
    [anon_sym_PERCENT_EQ] = ACTIONS(261),
    [anon_sym_CARET] = ACTIONS(263),
    [anon_sym_CARET_EQ] = ACTIONS(261),
    [anon_sym_PLUS_EQ] = ACTIONS(261),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_EQ] = ACTIONS(261),
    [anon_sym_LT_EQ] = ACTIONS(261),
    [anon_sym_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(261),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_EQ] = ACTIONS(261),
    [anon_sym_GT_GT] = ACTIONS(263),
    [anon_sym_GT_GT_EQ] = ACTIONS(261),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_PIPE_EQ] = ACTIONS(261),
    [anon_sym_PIPE_PIPE] = ACTIONS(261),
    [anon_sym_QMARK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(263),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(261),
    [anon_sym_as] = ACTIONS(263),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(601),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(605),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(605),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [86] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(312),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(312),
    [sym_macro_invocation] = STATE(312),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(312),
    [sym_unary_expression] = STATE(312),
    [sym_try_expression] = STATE(312),
    [sym_reference_expression] = STATE(312),
    [sym_binary_expression] = STATE(312),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(312),
    [sym_call_expression] = STATE(312),
    [sym_array_expression] = STATE(312),
    [sym_parenthesized_expression] = STATE(312),
    [sym_tuple_expression] = STATE(312),
    [sym_unit_expression] = STATE(312),
    [sym_struct_expression] = STATE(312),
    [sym_if_expression] = STATE(312),
    [sym_if_let_expression] = STATE(312),
    [sym_match_expression] = STATE(312),
    [sym_while_expression] = STATE(312),
    [sym_while_let_expression] = STATE(312),
    [sym_loop_expression] = STATE(312),
    [sym_for_expression] = STATE(312),
    [sym_closure_expression] = STATE(312),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(312),
    [sym_continue_expression] = STATE(312),
    [sym_index_expression] = STATE(312),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(312),
    [sym_block] = STATE(312),
    [sym__literal] = STATE(312),
    [sym_string_literal] = STATE(312),
    [sym_boolean_literal] = STATE(312),
    [sym_raw_string_literal] = ACTIONS(609),
    [sym_float_literal] = ACTIONS(609),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_let] = ACTIONS(611),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(609),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(609),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [87] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(313),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(313),
    [sym_macro_invocation] = STATE(313),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(313),
    [sym_unary_expression] = STATE(313),
    [sym_try_expression] = STATE(313),
    [sym_reference_expression] = STATE(313),
    [sym_binary_expression] = STATE(313),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(313),
    [sym_call_expression] = STATE(313),
    [sym_array_expression] = STATE(313),
    [sym_parenthesized_expression] = STATE(313),
    [sym_tuple_expression] = STATE(313),
    [sym_unit_expression] = STATE(313),
    [sym_struct_expression] = STATE(313),
    [sym_if_expression] = STATE(313),
    [sym_if_let_expression] = STATE(313),
    [sym_match_expression] = STATE(313),
    [sym_while_expression] = STATE(313),
    [sym_while_let_expression] = STATE(313),
    [sym_loop_expression] = STATE(313),
    [sym_for_expression] = STATE(313),
    [sym_closure_expression] = STATE(313),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(313),
    [sym_continue_expression] = STATE(313),
    [sym_index_expression] = STATE(313),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(313),
    [sym_block] = STATE(313),
    [sym__literal] = STATE(313),
    [sym_string_literal] = STATE(313),
    [sym_boolean_literal] = STATE(313),
    [sym_raw_string_literal] = ACTIONS(613),
    [sym_float_literal] = ACTIONS(613),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(359),
    [anon_sym_LPAREN] = ACTIONS(359),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(359),
    [anon_sym_LBRACK] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(361),
    [anon_sym_STAR] = ACTIONS(361),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(361),
    [anon_sym_DASH_EQ] = ACTIONS(359),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_BANG_EQ] = ACTIONS(359),
    [anon_sym_STAR_EQ] = ACTIONS(359),
    [anon_sym_SLASH] = ACTIONS(361),
    [anon_sym_SLASH_EQ] = ACTIONS(359),
    [anon_sym_AMP_AMP] = ACTIONS(359),
    [anon_sym_AMP_EQ] = ACTIONS(359),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_PERCENT_EQ] = ACTIONS(359),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_CARET_EQ] = ACTIONS(359),
    [anon_sym_PLUS_EQ] = ACTIONS(359),
    [anon_sym_LT] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_LT_LT_EQ] = ACTIONS(359),
    [anon_sym_LT_EQ] = ACTIONS(359),
    [anon_sym_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(359),
    [anon_sym_GT] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(359),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_GT_GT_EQ] = ACTIONS(359),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_PIPE_EQ] = ACTIONS(359),
    [anon_sym_PIPE_PIPE] = ACTIONS(359),
    [anon_sym_QMARK] = ACTIONS(359),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(361),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(359),
    [anon_sym_as] = ACTIONS(361),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(601),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(613),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(613),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [88] = {
    [sym_closure_parameters] = STATE(314),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(7),
  },
  [89] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(615),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(623),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(623),
    [anon_sym_PLUS_EQ] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(623),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(643),
    [anon_sym_as] = ACTIONS(645),
    [sym_line_comment] = ACTIONS(7),
  },
  [90] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(330),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(330),
    [sym_macro_invocation] = STATE(330),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(330),
    [sym_unary_expression] = STATE(330),
    [sym_try_expression] = STATE(330),
    [sym_reference_expression] = STATE(330),
    [sym_binary_expression] = STATE(330),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(330),
    [sym_call_expression] = STATE(330),
    [sym_array_expression] = STATE(330),
    [sym_parenthesized_expression] = STATE(330),
    [sym_tuple_expression] = STATE(330),
    [sym_unit_expression] = STATE(330),
    [sym_struct_expression] = STATE(330),
    [sym_if_expression] = STATE(330),
    [sym_if_let_expression] = STATE(330),
    [sym_match_expression] = STATE(330),
    [sym_while_expression] = STATE(330),
    [sym_while_let_expression] = STATE(330),
    [sym_loop_expression] = STATE(330),
    [sym_for_expression] = STATE(330),
    [sym_closure_expression] = STATE(330),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(330),
    [sym_continue_expression] = STATE(330),
    [sym_index_expression] = STATE(330),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(330),
    [sym_block] = STATE(330),
    [sym__literal] = STATE(330),
    [sym_string_literal] = STATE(330),
    [sym_boolean_literal] = STATE(330),
    [sym_raw_string_literal] = ACTIONS(647),
    [sym_float_literal] = ACTIONS(647),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(607),
    [anon_sym_DASH_GT] = ACTIONS(509),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(601),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(647),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(647),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [91] = {
    [sym__statement] = STATE(332),
    [sym_empty_statement] = STATE(332),
    [sym__expression_statement] = STATE(332),
    [sym_macro_definition] = STATE(332),
    [sym_attribute_item] = STATE(332),
    [sym_inner_attribute_item] = STATE(332),
    [sym_mod_item] = STATE(332),
    [sym_foreign_mod_item] = STATE(332),
    [sym_struct_item] = STATE(332),
    [sym_union_item] = STATE(332),
    [sym_enum_item] = STATE(332),
    [sym_extern_crate_declaration] = STATE(332),
    [sym_const_item] = STATE(332),
    [sym_static_item] = STATE(332),
    [sym_type_item] = STATE(332),
    [sym_function_item] = STATE(332),
    [sym_function_signature_item] = STATE(332),
    [sym_function_modifiers] = STATE(47),
    [sym_impl_item] = STATE(332),
    [sym_trait_item] = STATE(332),
    [sym_associated_type] = STATE(332),
    [sym_let_declaration] = STATE(332),
    [sym_use_declaration] = STATE(332),
    [sym_extern_modifier] = STATE(48),
    [sym_visibility_modifier] = STATE(49),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(331),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(331),
    [sym_macro_invocation] = STATE(53),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(331),
    [sym_unary_expression] = STATE(331),
    [sym_try_expression] = STATE(331),
    [sym_reference_expression] = STATE(331),
    [sym_binary_expression] = STATE(331),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(331),
    [sym_call_expression] = STATE(331),
    [sym_array_expression] = STATE(331),
    [sym_parenthesized_expression] = STATE(331),
    [sym_tuple_expression] = STATE(331),
    [sym_unit_expression] = STATE(331),
    [sym_struct_expression] = STATE(331),
    [sym_if_expression] = STATE(57),
    [sym_if_let_expression] = STATE(57),
    [sym_match_expression] = STATE(57),
    [sym_while_expression] = STATE(57),
    [sym_while_let_expression] = STATE(57),
    [sym_loop_expression] = STATE(57),
    [sym_for_expression] = STATE(57),
    [sym_closure_expression] = STATE(331),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(59),
    [sym_break_expression] = STATE(331),
    [sym_continue_expression] = STATE(331),
    [sym_index_expression] = STATE(331),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(57),
    [sym_block] = STATE(57),
    [sym__literal] = STATE(331),
    [sym_string_literal] = STATE(331),
    [sym_boolean_literal] = STATE(331),
    [aux_sym_source_file_repeat1] = STATE(332),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_raw_string_literal] = ACTIONS(649),
    [sym_float_literal] = ACTIONS(649),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(615),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_POUND] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(649),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(649),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(93),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [92] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(651),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_LBRACE] = ACTIONS(651),
    [anon_sym_RBRACE] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_RBRACK] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_AMP] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_DOT] = ACTIONS(653),
    [anon_sym_DASH_EQ] = ACTIONS(651),
    [anon_sym_BANG_EQ] = ACTIONS(651),
    [anon_sym_STAR_EQ] = ACTIONS(651),
    [anon_sym_SLASH] = ACTIONS(653),
    [anon_sym_SLASH_EQ] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(651),
    [anon_sym_AMP_EQ] = ACTIONS(651),
    [anon_sym_PERCENT] = ACTIONS(653),
    [anon_sym_PERCENT_EQ] = ACTIONS(651),
    [anon_sym_CARET] = ACTIONS(653),
    [anon_sym_CARET_EQ] = ACTIONS(651),
    [anon_sym_PLUS_EQ] = ACTIONS(651),
    [anon_sym_LT] = ACTIONS(653),
    [anon_sym_LT_LT] = ACTIONS(653),
    [anon_sym_LT_LT_EQ] = ACTIONS(651),
    [anon_sym_LT_EQ] = ACTIONS(651),
    [anon_sym_EQ] = ACTIONS(653),
    [anon_sym_EQ_EQ] = ACTIONS(651),
    [anon_sym_GT] = ACTIONS(653),
    [anon_sym_GT_EQ] = ACTIONS(651),
    [anon_sym_GT_GT] = ACTIONS(653),
    [anon_sym_GT_GT_EQ] = ACTIONS(651),
    [anon_sym_PIPE] = ACTIONS(653),
    [anon_sym_PIPE_EQ] = ACTIONS(651),
    [anon_sym_PIPE_PIPE] = ACTIONS(651),
    [anon_sym_QMARK] = ACTIONS(651),
    [anon_sym_DOT_DOT] = ACTIONS(653),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(651),
    [anon_sym_as] = ACTIONS(651),
    [sym_line_comment] = ACTIONS(7),
  },
  [93] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(103),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(103),
    [sym_macro_invocation] = STATE(103),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(103),
    [sym_unary_expression] = STATE(103),
    [sym_try_expression] = STATE(103),
    [sym_reference_expression] = STATE(103),
    [sym_binary_expression] = STATE(103),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(103),
    [sym_call_expression] = STATE(103),
    [sym_array_expression] = STATE(103),
    [sym_parenthesized_expression] = STATE(103),
    [sym_tuple_expression] = STATE(103),
    [sym_unit_expression] = STATE(103),
    [sym_struct_expression] = STATE(103),
    [sym_if_expression] = STATE(103),
    [sym_if_let_expression] = STATE(103),
    [sym_match_expression] = STATE(103),
    [sym_while_expression] = STATE(103),
    [sym_while_let_expression] = STATE(103),
    [sym_loop_expression] = STATE(103),
    [sym_for_expression] = STATE(103),
    [sym_closure_expression] = STATE(103),
    [sym_closure_parameters] = STATE(101),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(103),
    [sym_continue_expression] = STATE(103),
    [sym_index_expression] = STATE(103),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(103),
    [sym_block] = STATE(103),
    [sym__literal] = STATE(103),
    [sym_string_literal] = STATE(103),
    [sym_boolean_literal] = STATE(103),
    [sym_raw_string_literal] = ACTIONS(173),
    [sym_float_literal] = ACTIONS(173),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(159),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(159),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(171),
    [sym_integer_literal] = ACTIONS(173),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(173),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [94] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACK] = ACTIONS(655),
    [sym_line_comment] = ACTIONS(7),
  },
  [95] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(106),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(106),
    [sym_macro_invocation] = STATE(106),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(106),
    [sym_unary_expression] = STATE(106),
    [sym_try_expression] = STATE(106),
    [sym_reference_expression] = STATE(106),
    [sym_binary_expression] = STATE(106),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(106),
    [sym_call_expression] = STATE(106),
    [sym_array_expression] = STATE(106),
    [sym_parenthesized_expression] = STATE(106),
    [sym_tuple_expression] = STATE(106),
    [sym_unit_expression] = STATE(106),
    [sym_struct_expression] = STATE(106),
    [sym_if_expression] = STATE(106),
    [sym_if_let_expression] = STATE(106),
    [sym_match_expression] = STATE(106),
    [sym_while_expression] = STATE(106),
    [sym_while_let_expression] = STATE(106),
    [sym_loop_expression] = STATE(106),
    [sym_for_expression] = STATE(106),
    [sym_closure_expression] = STATE(106),
    [sym_closure_parameters] = STATE(101),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(106),
    [sym_continue_expression] = STATE(106),
    [sym_index_expression] = STATE(106),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(106),
    [sym_block] = STATE(106),
    [sym__literal] = STATE(106),
    [sym_string_literal] = STATE(106),
    [sym_boolean_literal] = STATE(106),
    [sym_raw_string_literal] = ACTIONS(183),
    [sym_float_literal] = ACTIONS(183),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(159),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(159),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [sym_mutable_specifier] = ACTIONS(657),
    [anon_sym_move] = ACTIONS(171),
    [sym_integer_literal] = ACTIONS(183),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(183),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [96] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(335),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(335),
    [sym_macro_invocation] = STATE(335),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(335),
    [sym_unary_expression] = STATE(335),
    [sym_try_expression] = STATE(335),
    [sym_reference_expression] = STATE(335),
    [sym_binary_expression] = STATE(335),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(335),
    [sym_call_expression] = STATE(335),
    [sym_array_expression] = STATE(335),
    [sym_parenthesized_expression] = STATE(335),
    [sym_tuple_expression] = STATE(335),
    [sym_unit_expression] = STATE(335),
    [sym_struct_expression] = STATE(335),
    [sym_if_expression] = STATE(335),
    [sym_if_let_expression] = STATE(335),
    [sym_match_expression] = STATE(335),
    [sym_while_expression] = STATE(335),
    [sym_while_let_expression] = STATE(335),
    [sym_loop_expression] = STATE(335),
    [sym_for_expression] = STATE(335),
    [sym_closure_expression] = STATE(335),
    [sym_closure_parameters] = STATE(101),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(335),
    [sym_continue_expression] = STATE(335),
    [sym_index_expression] = STATE(335),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(335),
    [sym_block] = STATE(335),
    [sym__literal] = STATE(335),
    [sym_string_literal] = STATE(335),
    [sym_boolean_literal] = STATE(335),
    [sym_raw_string_literal] = ACTIONS(659),
    [sym_float_literal] = ACTIONS(659),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(261),
    [anon_sym_LPAREN] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_RBRACK] = ACTIONS(261),
    [anon_sym_PLUS] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(263),
    [anon_sym_COMMA] = ACTIONS(261),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(263),
    [anon_sym_DASH] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(263),
    [anon_sym_DASH_EQ] = ACTIONS(261),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_BANG_EQ] = ACTIONS(261),
    [anon_sym_STAR_EQ] = ACTIONS(261),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_SLASH_EQ] = ACTIONS(261),
    [anon_sym_AMP_AMP] = ACTIONS(261),
    [anon_sym_AMP_EQ] = ACTIONS(261),
    [anon_sym_PERCENT] = ACTIONS(263),
    [anon_sym_PERCENT_EQ] = ACTIONS(261),
    [anon_sym_CARET] = ACTIONS(263),
    [anon_sym_CARET_EQ] = ACTIONS(261),
    [anon_sym_PLUS_EQ] = ACTIONS(261),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_EQ] = ACTIONS(261),
    [anon_sym_LT_EQ] = ACTIONS(261),
    [anon_sym_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(261),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_EQ] = ACTIONS(261),
    [anon_sym_GT_GT] = ACTIONS(263),
    [anon_sym_GT_GT_EQ] = ACTIONS(261),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_PIPE_EQ] = ACTIONS(261),
    [anon_sym_PIPE_PIPE] = ACTIONS(261),
    [anon_sym_QMARK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(263),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(261),
    [anon_sym_as] = ACTIONS(263),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(171),
    [sym_integer_literal] = ACTIONS(659),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(659),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [97] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(337),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(337),
    [sym_macro_invocation] = STATE(337),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(337),
    [sym_unary_expression] = STATE(337),
    [sym_try_expression] = STATE(337),
    [sym_reference_expression] = STATE(337),
    [sym_binary_expression] = STATE(337),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(337),
    [sym_call_expression] = STATE(337),
    [sym_array_expression] = STATE(337),
    [sym_parenthesized_expression] = STATE(337),
    [sym_tuple_expression] = STATE(337),
    [sym_unit_expression] = STATE(337),
    [sym_struct_expression] = STATE(337),
    [sym_if_expression] = STATE(337),
    [sym_if_let_expression] = STATE(337),
    [sym_match_expression] = STATE(337),
    [sym_while_expression] = STATE(337),
    [sym_while_let_expression] = STATE(337),
    [sym_loop_expression] = STATE(337),
    [sym_for_expression] = STATE(337),
    [sym_closure_expression] = STATE(337),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(337),
    [sym_continue_expression] = STATE(337),
    [sym_index_expression] = STATE(337),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(337),
    [sym_block] = STATE(337),
    [sym__literal] = STATE(337),
    [sym_string_literal] = STATE(337),
    [sym_boolean_literal] = STATE(337),
    [sym_raw_string_literal] = ACTIONS(663),
    [sym_float_literal] = ACTIONS(663),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_let] = ACTIONS(665),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(663),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(663),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [98] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(338),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(338),
    [sym_macro_invocation] = STATE(338),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(338),
    [sym_unary_expression] = STATE(338),
    [sym_try_expression] = STATE(338),
    [sym_reference_expression] = STATE(338),
    [sym_binary_expression] = STATE(338),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(338),
    [sym_call_expression] = STATE(338),
    [sym_array_expression] = STATE(338),
    [sym_parenthesized_expression] = STATE(338),
    [sym_tuple_expression] = STATE(338),
    [sym_unit_expression] = STATE(338),
    [sym_struct_expression] = STATE(338),
    [sym_if_expression] = STATE(338),
    [sym_if_let_expression] = STATE(338),
    [sym_match_expression] = STATE(338),
    [sym_while_expression] = STATE(338),
    [sym_while_let_expression] = STATE(338),
    [sym_loop_expression] = STATE(338),
    [sym_for_expression] = STATE(338),
    [sym_closure_expression] = STATE(338),
    [sym_closure_parameters] = STATE(101),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(338),
    [sym_continue_expression] = STATE(338),
    [sym_index_expression] = STATE(338),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(338),
    [sym_block] = STATE(338),
    [sym__literal] = STATE(338),
    [sym_string_literal] = STATE(338),
    [sym_boolean_literal] = STATE(338),
    [sym_raw_string_literal] = ACTIONS(667),
    [sym_float_literal] = ACTIONS(667),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(359),
    [anon_sym_LPAREN] = ACTIONS(359),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(359),
    [anon_sym_RBRACK] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(361),
    [anon_sym_STAR] = ACTIONS(361),
    [anon_sym_COMMA] = ACTIONS(359),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(361),
    [anon_sym_DASH_EQ] = ACTIONS(359),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_BANG_EQ] = ACTIONS(359),
    [anon_sym_STAR_EQ] = ACTIONS(359),
    [anon_sym_SLASH] = ACTIONS(361),
    [anon_sym_SLASH_EQ] = ACTIONS(359),
    [anon_sym_AMP_AMP] = ACTIONS(359),
    [anon_sym_AMP_EQ] = ACTIONS(359),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_PERCENT_EQ] = ACTIONS(359),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_CARET_EQ] = ACTIONS(359),
    [anon_sym_PLUS_EQ] = ACTIONS(359),
    [anon_sym_LT] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_LT_LT_EQ] = ACTIONS(359),
    [anon_sym_LT_EQ] = ACTIONS(359),
    [anon_sym_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(359),
    [anon_sym_GT] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(359),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_GT_GT_EQ] = ACTIONS(359),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_PIPE_EQ] = ACTIONS(359),
    [anon_sym_PIPE_PIPE] = ACTIONS(359),
    [anon_sym_QMARK] = ACTIONS(359),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(361),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(359),
    [anon_sym_as] = ACTIONS(361),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(171),
    [sym_integer_literal] = ACTIONS(667),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(667),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [99] = {
    [sym_closure_parameters] = STATE(339),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(7),
  },
  [100] = {
    [sym_arguments] = STATE(263),
    [aux_sym_token_tree_repeat2] = STATE(356),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(655),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_COMMA] = ACTIONS(675),
    [anon_sym_AMP] = ACTIONS(677),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(679),
    [anon_sym_BANG_EQ] = ACTIONS(681),
    [anon_sym_STAR_EQ] = ACTIONS(679),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_SLASH_EQ] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(683),
    [anon_sym_AMP_EQ] = ACTIONS(679),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_PERCENT_EQ] = ACTIONS(679),
    [anon_sym_CARET] = ACTIONS(685),
    [anon_sym_CARET_EQ] = ACTIONS(679),
    [anon_sym_PLUS_EQ] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_LT_LT] = ACTIONS(689),
    [anon_sym_LT_LT_EQ] = ACTIONS(679),
    [anon_sym_LT_EQ] = ACTIONS(681),
    [anon_sym_EQ] = ACTIONS(691),
    [anon_sym_EQ_EQ] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(689),
    [anon_sym_GT_GT_EQ] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(693),
    [anon_sym_PIPE_EQ] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(697),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(699),
    [anon_sym_as] = ACTIONS(701),
    [sym_line_comment] = ACTIONS(7),
  },
  [101] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(357),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(357),
    [sym_macro_invocation] = STATE(357),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(357),
    [sym_unary_expression] = STATE(357),
    [sym_try_expression] = STATE(357),
    [sym_reference_expression] = STATE(357),
    [sym_binary_expression] = STATE(357),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(357),
    [sym_call_expression] = STATE(357),
    [sym_array_expression] = STATE(357),
    [sym_parenthesized_expression] = STATE(357),
    [sym_tuple_expression] = STATE(357),
    [sym_unit_expression] = STATE(357),
    [sym_struct_expression] = STATE(357),
    [sym_if_expression] = STATE(357),
    [sym_if_let_expression] = STATE(357),
    [sym_match_expression] = STATE(357),
    [sym_while_expression] = STATE(357),
    [sym_while_let_expression] = STATE(357),
    [sym_loop_expression] = STATE(357),
    [sym_for_expression] = STATE(357),
    [sym_closure_expression] = STATE(357),
    [sym_closure_parameters] = STATE(101),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(357),
    [sym_continue_expression] = STATE(357),
    [sym_index_expression] = STATE(357),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(357),
    [sym_block] = STATE(357),
    [sym__literal] = STATE(357),
    [sym_string_literal] = STATE(357),
    [sym_boolean_literal] = STATE(357),
    [sym_raw_string_literal] = ACTIONS(703),
    [sym_float_literal] = ACTIONS(703),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(159),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(661),
    [anon_sym_DASH_GT] = ACTIONS(509),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(159),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(171),
    [sym_integer_literal] = ACTIONS(703),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(703),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [102] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(359),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(359),
    [sym_macro_invocation] = STATE(359),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(359),
    [sym_unary_expression] = STATE(359),
    [sym_try_expression] = STATE(359),
    [sym_reference_expression] = STATE(359),
    [sym_binary_expression] = STATE(359),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(359),
    [sym_call_expression] = STATE(359),
    [sym_array_expression] = STATE(359),
    [sym_parenthesized_expression] = STATE(359),
    [sym_tuple_expression] = STATE(359),
    [sym_unit_expression] = STATE(359),
    [sym_struct_expression] = STATE(359),
    [sym_if_expression] = STATE(359),
    [sym_if_let_expression] = STATE(359),
    [sym_match_expression] = STATE(359),
    [sym_while_expression] = STATE(359),
    [sym_while_let_expression] = STATE(359),
    [sym_loop_expression] = STATE(359),
    [sym_for_expression] = STATE(359),
    [sym_closure_expression] = STATE(359),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(359),
    [sym_continue_expression] = STATE(359),
    [sym_index_expression] = STATE(359),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(359),
    [sym_block] = STATE(359),
    [sym__literal] = STATE(359),
    [sym_string_literal] = STATE(359),
    [sym_boolean_literal] = STATE(359),
    [sym_raw_string_literal] = ACTIONS(705),
    [sym_float_literal] = ACTIONS(705),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_let] = ACTIONS(707),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(705),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(705),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [103] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(709),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(709),
    [anon_sym_LBRACE] = ACTIONS(709),
    [anon_sym_RBRACE] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(709),
    [anon_sym_PLUS] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(711),
    [anon_sym_COMMA] = ACTIONS(709),
    [anon_sym_AMP] = ACTIONS(711),
    [anon_sym_DASH] = ACTIONS(711),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(709),
    [anon_sym_BANG_EQ] = ACTIONS(709),
    [anon_sym_STAR_EQ] = ACTIONS(709),
    [anon_sym_SLASH] = ACTIONS(711),
    [anon_sym_SLASH_EQ] = ACTIONS(709),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_AMP_EQ] = ACTIONS(709),
    [anon_sym_PERCENT] = ACTIONS(711),
    [anon_sym_PERCENT_EQ] = ACTIONS(709),
    [anon_sym_CARET] = ACTIONS(711),
    [anon_sym_CARET_EQ] = ACTIONS(709),
    [anon_sym_PLUS_EQ] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_LT] = ACTIONS(711),
    [anon_sym_LT_LT_EQ] = ACTIONS(709),
    [anon_sym_LT_EQ] = ACTIONS(709),
    [anon_sym_EQ] = ACTIONS(711),
    [anon_sym_EQ_EQ] = ACTIONS(709),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(709),
    [anon_sym_GT_GT] = ACTIONS(711),
    [anon_sym_GT_GT_EQ] = ACTIONS(709),
    [anon_sym_PIPE] = ACTIONS(711),
    [anon_sym_PIPE_EQ] = ACTIONS(709),
    [anon_sym_PIPE_PIPE] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_DOT_DOT] = ACTIONS(711),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(709),
    [anon_sym_as] = ACTIONS(709),
    [sym_line_comment] = ACTIONS(7),
  },
  [104] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(713),
  },
  [105] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(361),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(361),
    [sym_macro_invocation] = STATE(361),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(361),
    [sym_unary_expression] = STATE(361),
    [sym_try_expression] = STATE(361),
    [sym_reference_expression] = STATE(361),
    [sym_binary_expression] = STATE(361),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(361),
    [sym_call_expression] = STATE(361),
    [sym_array_expression] = STATE(361),
    [sym_parenthesized_expression] = STATE(361),
    [sym_tuple_expression] = STATE(361),
    [sym_unit_expression] = STATE(361),
    [sym_struct_expression] = STATE(361),
    [sym_if_expression] = STATE(361),
    [sym_if_let_expression] = STATE(361),
    [sym_match_expression] = STATE(361),
    [sym_while_expression] = STATE(361),
    [sym_while_let_expression] = STATE(361),
    [sym_loop_expression] = STATE(361),
    [sym_for_expression] = STATE(361),
    [sym_closure_expression] = STATE(361),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(361),
    [sym_continue_expression] = STATE(361),
    [sym_index_expression] = STATE(361),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(361),
    [sym_block] = STATE(361),
    [sym__literal] = STATE(361),
    [sym_string_literal] = STATE(361),
    [sym_boolean_literal] = STATE(361),
    [sym_raw_string_literal] = ACTIONS(715),
    [sym_float_literal] = ACTIONS(715),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(715),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(715),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [106] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(717),
    [anon_sym_LBRACE] = ACTIONS(717),
    [anon_sym_RBRACE] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(719),
    [anon_sym_COMMA] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(717),
    [anon_sym_BANG_EQ] = ACTIONS(717),
    [anon_sym_STAR_EQ] = ACTIONS(717),
    [anon_sym_SLASH] = ACTIONS(719),
    [anon_sym_SLASH_EQ] = ACTIONS(717),
    [anon_sym_AMP_AMP] = ACTIONS(717),
    [anon_sym_AMP_EQ] = ACTIONS(717),
    [anon_sym_PERCENT] = ACTIONS(719),
    [anon_sym_PERCENT_EQ] = ACTIONS(717),
    [anon_sym_CARET] = ACTIONS(719),
    [anon_sym_CARET_EQ] = ACTIONS(717),
    [anon_sym_PLUS_EQ] = ACTIONS(717),
    [anon_sym_LT] = ACTIONS(719),
    [anon_sym_LT_LT] = ACTIONS(719),
    [anon_sym_LT_LT_EQ] = ACTIONS(717),
    [anon_sym_LT_EQ] = ACTIONS(717),
    [anon_sym_EQ] = ACTIONS(719),
    [anon_sym_EQ_EQ] = ACTIONS(717),
    [anon_sym_GT] = ACTIONS(719),
    [anon_sym_GT_EQ] = ACTIONS(717),
    [anon_sym_GT_GT] = ACTIONS(719),
    [anon_sym_GT_GT_EQ] = ACTIONS(717),
    [anon_sym_PIPE] = ACTIONS(719),
    [anon_sym_PIPE_EQ] = ACTIONS(717),
    [anon_sym_PIPE_PIPE] = ACTIONS(717),
    [anon_sym_QMARK] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(717),
    [anon_sym_as] = ACTIONS(717),
    [sym_line_comment] = ACTIONS(7),
  },
  [107] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(721),
    [anon_sym_LPAREN] = ACTIONS(721),
    [anon_sym_RPAREN] = ACTIONS(721),
    [anon_sym_LBRACE] = ACTIONS(723),
    [anon_sym_RBRACE] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(721),
    [anon_sym_RBRACK] = ACTIONS(721),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(721),
    [anon_sym_AMP] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(721),
    [anon_sym_COLON_COLON] = ACTIONS(721),
    [anon_sym_BANG_EQ] = ACTIONS(721),
    [anon_sym_STAR_EQ] = ACTIONS(721),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(721),
    [anon_sym_AMP_AMP] = ACTIONS(721),
    [anon_sym_AMP_EQ] = ACTIONS(721),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(721),
    [anon_sym_PLUS_EQ] = ACTIONS(721),
    [anon_sym_LT] = ACTIONS(725),
    [anon_sym_LT_LT] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(721),
    [anon_sym_LT_EQ] = ACTIONS(721),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_EQ_EQ] = ACTIONS(721),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(721),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(721),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(721),
    [anon_sym_PIPE_PIPE] = ACTIONS(721),
    [anon_sym_QMARK] = ACTIONS(721),
    [anon_sym_DOT_DOT] = ACTIONS(725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(721),
    [anon_sym_as] = ACTIONS(721),
    [sym_line_comment] = ACTIONS(7),
  },
  [108] = {
    [sym_meta_item] = STATE(363),
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(727),
  },
  [109] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACK] = ACTIONS(729),
    [sym_line_comment] = ACTIONS(7),
  },
  [110] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(371),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(371),
    [sym_function_type] = STATE(371),
    [sym_tuple_type] = STATE(371),
    [sym_unit_type] = STATE(371),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(371),
    [sym_reference_type] = STATE(371),
    [sym_pointer_type] = STATE(371),
    [sym_empty_type] = STATE(371),
    [sym_dynamic_type] = STATE(371),
    [sym_macro_invocation] = STATE(371),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_RPAREN] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [111] = {
    [sym_function_modifiers] = STATE(378),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(379),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(380),
    [sym_array_type] = STATE(379),
    [sym_function_type] = STATE(379),
    [sym_tuple_type] = STATE(379),
    [sym_unit_type] = STATE(379),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(379),
    [sym_reference_type] = STATE(379),
    [sym_pointer_type] = STATE(379),
    [sym_empty_type] = STATE(379),
    [sym_dynamic_type] = STATE(379),
    [sym_macro_invocation] = STATE(379),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(381),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(741),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(745),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(747),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [112] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(749),
    [sym_mutable_specifier] = ACTIONS(749),
    [sym_line_comment] = ACTIONS(7),
  },
  [113] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_RBRACE] = ACTIONS(751),
    [anon_sym_RBRACK] = ACTIONS(751),
    [anon_sym_COLON] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(755),
    [anon_sym_EQ] = ACTIONS(751),
    [anon_sym_GT] = ACTIONS(751),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_as] = ACTIONS(751),
    [anon_sym_where] = ACTIONS(751),
    [sym_line_comment] = ACTIONS(7),
  },
  [114] = {
    [sym_function_modifiers] = STATE(124),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(385),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(386),
    [sym_array_type] = STATE(385),
    [sym_function_type] = STATE(385),
    [sym_tuple_type] = STATE(385),
    [sym_unit_type] = STATE(385),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(385),
    [sym_reference_type] = STATE(385),
    [sym_pointer_type] = STATE(385),
    [sym_empty_type] = STATE(385),
    [sym_dynamic_type] = STATE(385),
    [sym_macro_invocation] = STATE(385),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(131),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(197),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(201),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(211),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(757),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(217),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [115] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(759),
  },
  [116] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(761),
    [anon_sym_LPAREN] = ACTIONS(761),
    [anon_sym_RPAREN] = ACTIONS(761),
    [anon_sym_LBRACE] = ACTIONS(761),
    [anon_sym_RBRACE] = ACTIONS(761),
    [anon_sym_RBRACK] = ACTIONS(761),
    [anon_sym_COLON] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(761),
    [anon_sym_COMMA] = ACTIONS(761),
    [anon_sym_EQ] = ACTIONS(761),
    [anon_sym_GT] = ACTIONS(761),
    [anon_sym_PIPE] = ACTIONS(761),
    [anon_sym_as] = ACTIONS(761),
    [anon_sym_where] = ACTIONS(761),
    [sym_line_comment] = ACTIONS(7),
  },
  [117] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(763),
  },
  [118] = {
    [sym_parameters] = STATE(390),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [119] = {
    [sym_string_literal] = STATE(392),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(767),
    [anon_sym_i8] = ACTIONS(767),
    [anon_sym_u16] = ACTIONS(767),
    [anon_sym_i16] = ACTIONS(767),
    [anon_sym_u32] = ACTIONS(767),
    [anon_sym_i32] = ACTIONS(767),
    [anon_sym_u64] = ACTIONS(767),
    [anon_sym_i64] = ACTIONS(767),
    [anon_sym_u128] = ACTIONS(767),
    [anon_sym_i128] = ACTIONS(767),
    [anon_sym_isize] = ACTIONS(767),
    [anon_sym_usize] = ACTIONS(767),
    [anon_sym_f32] = ACTIONS(767),
    [anon_sym_f64] = ACTIONS(767),
    [anon_sym_bool] = ACTIONS(767),
    [anon_sym_str] = ACTIONS(767),
    [anon_sym_char] = ACTIONS(767),
    [anon_sym_COLON_COLON] = ACTIONS(393),
    [anon_sym_LT] = ACTIONS(393),
    [anon_sym_const] = ACTIONS(767),
    [anon_sym_default] = ACTIONS(767),
    [anon_sym_fn] = ACTIONS(767),
    [anon_sym_unsafe] = ACTIONS(767),
    [anon_sym_extern] = ACTIONS(767),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(769),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(767),
    [sym_self] = ACTIONS(767),
    [sym_super] = ACTIONS(767),
    [sym_crate] = ACTIONS(767),
    [sym_metavariable] = ACTIONS(393),
  },
  [120] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(394),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(395),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(771),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [121] = {
    [sym_parameters] = STATE(399),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_BANG] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_GT] = ACTIONS(773),
    [anon_sym_as] = ACTIONS(773),
    [sym_line_comment] = ACTIONS(7),
  },
  [122] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON_COLON] = ACTIONS(781),
    [sym_line_comment] = ACTIONS(7),
  },
  [123] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(783),
    [anon_sym_LPAREN] = ACTIONS(783),
    [anon_sym_RPAREN] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(783),
    [anon_sym_RBRACE] = ACTIONS(783),
    [anon_sym_RBRACK] = ACTIONS(783),
    [anon_sym_COLON] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(783),
    [anon_sym_COMMA] = ACTIONS(783),
    [anon_sym_COLON_COLON] = ACTIONS(781),
    [anon_sym_EQ] = ACTIONS(783),
    [anon_sym_GT] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(783),
    [anon_sym_as] = ACTIONS(783),
    [anon_sym_where] = ACTIONS(783),
    [sym_line_comment] = ACTIONS(7),
  },
  [124] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(404),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_fn] = ACTIONS(787),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(789),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [125] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_GT] = ACTIONS(793),
    [anon_sym_as] = ACTIONS(795),
    [sym_line_comment] = ACTIONS(7),
  },
  [126] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_GT] = ACTIONS(793),
    [sym_line_comment] = ACTIONS(7),
  },
  [127] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(797),
    [sym_line_comment] = ACTIONS(7),
  },
  [128] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(783),
    [anon_sym_LPAREN] = ACTIONS(783),
    [anon_sym_RPAREN] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(783),
    [anon_sym_RBRACE] = ACTIONS(783),
    [anon_sym_RBRACK] = ACTIONS(783),
    [anon_sym_COLON] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(783),
    [anon_sym_COMMA] = ACTIONS(783),
    [anon_sym_COLON_COLON] = ACTIONS(799),
    [anon_sym_EQ] = ACTIONS(783),
    [anon_sym_GT] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(783),
    [anon_sym_as] = ACTIONS(783),
    [anon_sym_where] = ACTIONS(783),
    [sym_line_comment] = ACTIONS(7),
  },
  [129] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON_COLON] = ACTIONS(801),
    [sym_line_comment] = ACTIONS(7),
  },
  [130] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON_COLON] = ACTIONS(803),
    [sym_line_comment] = ACTIONS(7),
  },
  [131] = {
    [sym_parameters] = STATE(390),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_GT] = ACTIONS(783),
    [anon_sym_as] = ACTIONS(783),
    [sym_line_comment] = ACTIONS(7),
  },
  [132] = {
    [sym_extern_modifier] = STATE(413),
    [aux_sym_function_modifiers_repeat1] = STATE(413),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(805),
    [anon_sym_i8] = ACTIONS(805),
    [anon_sym_u16] = ACTIONS(805),
    [anon_sym_i16] = ACTIONS(805),
    [anon_sym_u32] = ACTIONS(805),
    [anon_sym_i32] = ACTIONS(805),
    [anon_sym_u64] = ACTIONS(805),
    [anon_sym_i64] = ACTIONS(805),
    [anon_sym_u128] = ACTIONS(805),
    [anon_sym_i128] = ACTIONS(805),
    [anon_sym_isize] = ACTIONS(805),
    [anon_sym_usize] = ACTIONS(805),
    [anon_sym_f32] = ACTIONS(805),
    [anon_sym_f64] = ACTIONS(805),
    [anon_sym_bool] = ACTIONS(805),
    [anon_sym_str] = ACTIONS(805),
    [anon_sym_char] = ACTIONS(805),
    [anon_sym_COLON_COLON] = ACTIONS(519),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_const] = ACTIONS(807),
    [anon_sym_default] = ACTIONS(807),
    [anon_sym_fn] = ACTIONS(805),
    [anon_sym_unsafe] = ACTIONS(807),
    [anon_sym_extern] = ACTIONS(213),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(805),
    [sym_self] = ACTIONS(805),
    [sym_super] = ACTIONS(805),
    [sym_crate] = ACTIONS(805),
    [sym_metavariable] = ACTIONS(519),
  },
  [133] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(420),
    [sym_tuple_pattern] = STATE(420),
    [sym_tuple_struct_pattern] = STATE(420),
    [sym_struct_pattern] = STATE(420),
    [sym_remaining_field_pattern] = STATE(420),
    [sym_mut_pattern] = STATE(420),
    [sym_ref_pattern] = STATE(420),
    [sym_captured_pattern] = STATE(420),
    [sym_reference_pattern] = STATE(420),
    [sym__literal] = STATE(420),
    [sym_string_literal] = STATE(420),
    [sym_boolean_literal] = STATE(420),
    [sym_raw_string_literal] = ACTIONS(809),
    [sym_float_literal] = ACTIONS(809),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_RPAREN] = ACTIONS(811),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(815),
    [anon_sym_AMP] = ACTIONS(817),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(819),
    [anon_sym_ref] = ACTIONS(821),
    [sym_integer_literal] = ACTIONS(809),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(809),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(823),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [134] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(825),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [sym_line_comment] = ACTIONS(7),
  },
  [135] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(829),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(831),
    [sym_line_comment] = ACTIONS(7),
  },
  [136] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(428),
    [sym_tuple_pattern] = STATE(428),
    [sym_tuple_pattern_in_parameter] = STATE(429),
    [sym_tuple_struct_pattern] = STATE(428),
    [sym_struct_pattern] = STATE(428),
    [sym_remaining_field_pattern] = STATE(428),
    [sym_mut_pattern] = STATE(428),
    [sym_ref_pattern] = STATE(428),
    [sym_captured_pattern] = STATE(428),
    [sym_reference_pattern] = STATE(428),
    [sym__literal] = STATE(428),
    [sym_string_literal] = STATE(428),
    [sym_boolean_literal] = STATE(428),
    [sym_raw_string_literal] = ACTIONS(833),
    [sym_float_literal] = ACTIONS(833),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(835),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(839),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(841),
    [anon_sym_ref] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(833),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(833),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(843),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [137] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(845),
  },
  [138] = {
    [sym_raw_string_literal] = ACTIONS(847),
    [sym_float_literal] = ACTIONS(847),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(847),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(847),
    [anon_sym_u8] = ACTIONS(849),
    [anon_sym_i8] = ACTIONS(849),
    [anon_sym_u16] = ACTIONS(849),
    [anon_sym_i16] = ACTIONS(849),
    [anon_sym_u32] = ACTIONS(849),
    [anon_sym_i32] = ACTIONS(849),
    [anon_sym_u64] = ACTIONS(849),
    [anon_sym_i64] = ACTIONS(849),
    [anon_sym_u128] = ACTIONS(849),
    [anon_sym_i128] = ACTIONS(849),
    [anon_sym_isize] = ACTIONS(849),
    [anon_sym_usize] = ACTIONS(849),
    [anon_sym_f32] = ACTIONS(849),
    [anon_sym_f64] = ACTIONS(849),
    [anon_sym_bool] = ACTIONS(849),
    [anon_sym_str] = ACTIONS(849),
    [anon_sym_char] = ACTIONS(849),
    [anon_sym_AMP] = ACTIONS(847),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_DASH_GT] = ACTIONS(847),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_BANG] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(847),
    [anon_sym_PIPE] = ACTIONS(847),
    [anon_sym_SQUOTE] = ACTIONS(849),
    [anon_sym_DOT_DOT] = ACTIONS(847),
    [anon_sym_break] = ACTIONS(849),
    [anon_sym_continue] = ACTIONS(849),
    [anon_sym_default] = ACTIONS(849),
    [anon_sym_for] = ACTIONS(849),
    [anon_sym_if] = ACTIONS(849),
    [anon_sym_loop] = ACTIONS(849),
    [anon_sym_match] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_union] = ACTIONS(849),
    [anon_sym_unsafe] = ACTIONS(849),
    [anon_sym_while] = ACTIONS(849),
    [anon_sym_move] = ACTIONS(849),
    [sym_integer_literal] = ACTIONS(847),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(847),
    [sym_char_literal] = ACTIONS(847),
    [anon_sym_true] = ACTIONS(849),
    [anon_sym_false] = ACTIONS(849),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(849),
    [sym_self] = ACTIONS(849),
    [sym_super] = ACTIONS(849),
    [sym_crate] = ACTIONS(849),
    [sym_metavariable] = ACTIONS(847),
  },
  [139] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(851),
    [anon_sym_RPAREN] = ACTIONS(851),
    [anon_sym_RBRACE] = ACTIONS(851),
    [anon_sym_COLON] = ACTIONS(851),
    [anon_sym_COMMA] = ACTIONS(851),
    [anon_sym_EQ] = ACTIONS(851),
    [anon_sym_PIPE] = ACTIONS(851),
    [anon_sym_in] = ACTIONS(851),
    [sym_line_comment] = ACTIONS(7),
  },
  [140] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(853),
    [sym_line_comment] = ACTIONS(7),
  },
  [141] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(438),
    [sym_tuple_pattern] = STATE(438),
    [sym_tuple_struct_pattern] = STATE(438),
    [sym_struct_pattern] = STATE(438),
    [sym_remaining_field_pattern] = STATE(438),
    [sym_mut_pattern] = STATE(438),
    [sym_ref_pattern] = STATE(438),
    [sym_captured_pattern] = STATE(438),
    [sym_reference_pattern] = STATE(438),
    [sym_reference_pattern_in_parameter] = STATE(439),
    [sym__literal] = STATE(438),
    [sym_string_literal] = STATE(438),
    [sym_boolean_literal] = STATE(438),
    [sym_raw_string_literal] = ACTIONS(855),
    [sym_float_literal] = ACTIONS(855),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(857),
    [anon_sym_i8] = ACTIONS(857),
    [anon_sym_u16] = ACTIONS(857),
    [anon_sym_i16] = ACTIONS(857),
    [anon_sym_u32] = ACTIONS(857),
    [anon_sym_i32] = ACTIONS(857),
    [anon_sym_u64] = ACTIONS(857),
    [anon_sym_i64] = ACTIONS(857),
    [anon_sym_u128] = ACTIONS(857),
    [anon_sym_i128] = ACTIONS(857),
    [anon_sym_isize] = ACTIONS(857),
    [anon_sym_usize] = ACTIONS(857),
    [anon_sym_f32] = ACTIONS(857),
    [anon_sym_f64] = ACTIONS(857),
    [anon_sym_bool] = ACTIONS(857),
    [anon_sym_str] = ACTIONS(857),
    [anon_sym_char] = ACTIONS(857),
    [anon_sym__] = ACTIONS(859),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [anon_sym_default] = ACTIONS(863),
    [anon_sym_union] = ACTIONS(863),
    [sym_mutable_specifier] = ACTIONS(865),
    [anon_sym_ref] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(855),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(855),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(867),
    [sym_self] = ACTIONS(869),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [142] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(441),
    [sym_tuple_pattern] = STATE(441),
    [sym_tuple_struct_pattern] = STATE(441),
    [sym_struct_pattern] = STATE(441),
    [sym_remaining_field_pattern] = STATE(441),
    [sym_mut_pattern] = STATE(441),
    [sym_ref_pattern] = STATE(441),
    [sym_captured_pattern] = STATE(441),
    [sym_reference_pattern] = STATE(441),
    [sym__literal] = STATE(441),
    [sym_string_literal] = STATE(441),
    [sym_boolean_literal] = STATE(441),
    [sym_raw_string_literal] = ACTIONS(871),
    [sym_float_literal] = ACTIONS(871),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(873),
    [anon_sym_AMP] = ACTIONS(839),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(865),
    [anon_sym_ref] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(871),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(875),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [143] = {
    [aux_sym_string_literal_repeat1] = STATE(443),
    [sym_block_comment] = ACTIONS(7),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_RBRACK_PLUS_SLASH] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(879),
    [sym_escape_sequence] = ACTIONS(877),
    [sym_line_comment] = ACTIONS(401),
  },
  [144] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_COLON] = ACTIONS(403),
    [anon_sym_COMMA] = ACTIONS(403),
    [anon_sym_EQ] = ACTIONS(403),
    [anon_sym_PIPE] = ACTIONS(403),
    [sym_line_comment] = ACTIONS(7),
  },
  [145] = {
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(883),
    [anon_sym_COLON] = ACTIONS(885),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_COLON_COLON] = ACTIONS(887),
    [anon_sym_AT] = ACTIONS(889),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_PIPE] = ACTIONS(831),
    [sym_line_comment] = ACTIONS(7),
  },
  [146] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(885),
    [anon_sym_COLON_COLON] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(7),
  },
  [147] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON_COLON] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(7),
  },
  [148] = {
    [aux_sym_closure_parameters_repeat1] = STATE(451),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_PIPE] = ACTIONS(895),
    [sym_line_comment] = ACTIONS(7),
  },
  [149] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON_COLON] = ACTIONS(799),
    [sym_line_comment] = ACTIONS(7),
  },
  [150] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON_COLON] = ACTIONS(897),
    [sym_line_comment] = ACTIONS(7),
  },
  [151] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(831),
    [anon_sym_LPAREN] = ACTIONS(881),
    [anon_sym_RPAREN] = ACTIONS(831),
    [anon_sym_RBRACE] = ACTIONS(831),
    [anon_sym_COLON] = ACTIONS(899),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_COLON_COLON] = ACTIONS(901),
    [anon_sym_EQ] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(831),
    [anon_sym_in] = ACTIONS(831),
    [sym_line_comment] = ACTIONS(7),
  },
  [152] = {
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [153] = {
    [aux_sym_closure_parameters_repeat1] = STATE(451),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(829),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_PIPE] = ACTIONS(895),
    [sym_line_comment] = ACTIONS(7),
  },
  [154] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(905),
    [anon_sym_RBRACE] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_RBRACK] = ACTIONS(905),
    [anon_sym_COLON] = ACTIONS(905),
    [anon_sym_PLUS] = ACTIONS(907),
    [anon_sym_STAR] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_DASH] = ACTIONS(907),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_BANG_EQ] = ACTIONS(905),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH] = ACTIONS(907),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_AMP_AMP] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_PERCENT] = ACTIONS(907),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_CARET] = ACTIONS(907),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(907),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_LT_EQ] = ACTIONS(905),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_EQ_EQ] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(907),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_PIPE_PIPE] = ACTIONS(905),
    [anon_sym_QMARK] = ACTIONS(905),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(905),
    [anon_sym_as] = ACTIONS(905),
    [sym_line_comment] = ACTIONS(7),
  },
  [155] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_BANG_EQ] = ACTIONS(469),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(469),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_EQ_EQ] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_as] = ACTIONS(909),
    [sym_line_comment] = ACTIONS(7),
  },
  [156] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(913),
    [anon_sym_LPAREN] = ACTIONS(913),
    [anon_sym_RPAREN] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(913),
    [anon_sym_LBRACK] = ACTIONS(913),
    [anon_sym_RBRACK] = ACTIONS(913),
    [anon_sym_PLUS] = ACTIONS(915),
    [anon_sym_STAR] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(913),
    [anon_sym_AMP] = ACTIONS(915),
    [anon_sym_DASH] = ACTIONS(915),
    [anon_sym_DOT] = ACTIONS(915),
    [anon_sym_DASH_EQ] = ACTIONS(913),
    [anon_sym_BANG_EQ] = ACTIONS(913),
    [anon_sym_STAR_EQ] = ACTIONS(913),
    [anon_sym_SLASH] = ACTIONS(915),
    [anon_sym_SLASH_EQ] = ACTIONS(913),
    [anon_sym_AMP_AMP] = ACTIONS(913),
    [anon_sym_AMP_EQ] = ACTIONS(913),
    [anon_sym_PERCENT] = ACTIONS(915),
    [anon_sym_PERCENT_EQ] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_CARET_EQ] = ACTIONS(913),
    [anon_sym_PLUS_EQ] = ACTIONS(913),
    [anon_sym_LT] = ACTIONS(915),
    [anon_sym_LT_LT] = ACTIONS(915),
    [anon_sym_LT_LT_EQ] = ACTIONS(913),
    [anon_sym_LT_EQ] = ACTIONS(913),
    [anon_sym_EQ] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(913),
    [anon_sym_GT] = ACTIONS(915),
    [anon_sym_GT_EQ] = ACTIONS(913),
    [anon_sym_GT_GT] = ACTIONS(915),
    [anon_sym_GT_GT_EQ] = ACTIONS(913),
    [anon_sym_PIPE] = ACTIONS(915),
    [anon_sym_PIPE_EQ] = ACTIONS(913),
    [anon_sym_PIPE_PIPE] = ACTIONS(913),
    [anon_sym_QMARK] = ACTIONS(913),
    [anon_sym_DOT_DOT] = ACTIONS(915),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_as] = ACTIONS(913),
    [sym_line_comment] = ACTIONS(7),
  },
  [157] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(917),
    [sym_line_comment] = ACTIONS(7),
  },
  [158] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_RPAREN] = ACTIONS(919),
    [anon_sym_LBRACE] = ACTIONS(919),
    [anon_sym_RBRACE] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_RBRACK] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_STAR] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_DASH_EQ] = ACTIONS(919),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_STAR_EQ] = ACTIONS(919),
    [anon_sym_SLASH] = ACTIONS(921),
    [anon_sym_SLASH_EQ] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_AMP_EQ] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(921),
    [anon_sym_PERCENT_EQ] = ACTIONS(919),
    [anon_sym_CARET] = ACTIONS(921),
    [anon_sym_CARET_EQ] = ACTIONS(919),
    [anon_sym_PLUS_EQ] = ACTIONS(919),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(921),
    [anon_sym_LT_LT_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(919),
    [anon_sym_EQ] = ACTIONS(921),
    [anon_sym_EQ_EQ] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(921),
    [anon_sym_GT_GT_EQ] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_PIPE_EQ] = ACTIONS(919),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(919),
    [anon_sym_DOT_DOT] = ACTIONS(921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(919),
    [anon_sym_as] = ACTIONS(919),
    [sym_line_comment] = ACTIONS(7),
  },
  [159] = {
    [sym_enum_variant_list] = STATE(459),
    [sym_where_clause] = STATE(460),
    [sym_type_parameters] = STATE(461),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [160] = {
    [sym_type_parameters] = STATE(462),
    [sym_parameters] = STATE(463),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(925),
    [sym_line_comment] = ACTIONS(7),
  },
  [161] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [sym_line_comment] = ACTIONS(7),
  },
  [162] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(428),
    [sym_tuple_pattern] = STATE(428),
    [sym_tuple_struct_pattern] = STATE(428),
    [sym_struct_pattern] = STATE(428),
    [sym_remaining_field_pattern] = STATE(428),
    [sym_mut_pattern] = STATE(428),
    [sym_ref_pattern] = STATE(428),
    [sym_captured_pattern] = STATE(428),
    [sym_reference_pattern] = STATE(428),
    [sym__literal] = STATE(428),
    [sym_string_literal] = STATE(428),
    [sym_boolean_literal] = STATE(428),
    [sym_raw_string_literal] = ACTIONS(833),
    [sym_float_literal] = ACTIONS(833),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(293),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(929),
    [anon_sym_ref] = ACTIONS(297),
    [sym_integer_literal] = ACTIONS(833),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(833),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(299),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [163] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(438),
    [sym_tuple_pattern] = STATE(438),
    [sym_tuple_struct_pattern] = STATE(438),
    [sym_struct_pattern] = STATE(438),
    [sym_remaining_field_pattern] = STATE(438),
    [sym_mut_pattern] = STATE(438),
    [sym_ref_pattern] = STATE(438),
    [sym_captured_pattern] = STATE(438),
    [sym_reference_pattern] = STATE(438),
    [sym__literal] = STATE(438),
    [sym_string_literal] = STATE(438),
    [sym_boolean_literal] = STATE(438),
    [sym_raw_string_literal] = ACTIONS(855),
    [sym_float_literal] = ACTIONS(855),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(931),
    [anon_sym_AMP] = ACTIONS(293),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(295),
    [anon_sym_ref] = ACTIONS(297),
    [sym_integer_literal] = ACTIONS(855),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(855),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(299),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [164] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(441),
    [sym_tuple_pattern] = STATE(441),
    [sym_tuple_struct_pattern] = STATE(441),
    [sym_struct_pattern] = STATE(441),
    [sym_remaining_field_pattern] = STATE(441),
    [sym_mut_pattern] = STATE(441),
    [sym_ref_pattern] = STATE(441),
    [sym_captured_pattern] = STATE(441),
    [sym_reference_pattern] = STATE(441),
    [sym__literal] = STATE(441),
    [sym_string_literal] = STATE(441),
    [sym_boolean_literal] = STATE(441),
    [sym_raw_string_literal] = ACTIONS(871),
    [sym_float_literal] = ACTIONS(871),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(873),
    [anon_sym_AMP] = ACTIONS(293),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(295),
    [anon_sym_ref] = ACTIONS(297),
    [sym_integer_literal] = ACTIONS(871),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(299),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [165] = {
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(883),
    [anon_sym_COLON_COLON] = ACTIONS(887),
    [anon_sym_AT] = ACTIONS(933),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_in] = ACTIONS(831),
    [sym_line_comment] = ACTIONS(7),
  },
  [166] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_in] = ACTIONS(935),
    [sym_line_comment] = ACTIONS(7),
  },
  [167] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(103),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(103),
    [sym_macro_invocation] = STATE(103),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(103),
    [sym_unary_expression] = STATE(103),
    [sym_try_expression] = STATE(103),
    [sym_reference_expression] = STATE(103),
    [sym_binary_expression] = STATE(103),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(103),
    [sym_call_expression] = STATE(103),
    [sym_array_expression] = STATE(103),
    [sym_parenthesized_expression] = STATE(103),
    [sym_tuple_expression] = STATE(103),
    [sym_unit_expression] = STATE(103),
    [sym_struct_expression] = STATE(103),
    [sym_if_expression] = STATE(103),
    [sym_if_let_expression] = STATE(103),
    [sym_match_expression] = STATE(103),
    [sym_while_expression] = STATE(103),
    [sym_while_let_expression] = STATE(103),
    [sym_loop_expression] = STATE(103),
    [sym_for_expression] = STATE(103),
    [sym_closure_expression] = STATE(103),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(103),
    [sym_continue_expression] = STATE(103),
    [sym_index_expression] = STATE(103),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(103),
    [sym_block] = STATE(103),
    [sym__literal] = STATE(103),
    [sym_string_literal] = STATE(103),
    [sym_boolean_literal] = STATE(103),
    [sym_raw_string_literal] = ACTIONS(173),
    [sym_float_literal] = ACTIONS(173),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(173),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(173),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [168] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(179),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_DASH] = ACTIONS(179),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_COLON_COLON] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ] = ACTIONS(177),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(177),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(177),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_as] = ACTIONS(177),
    [sym_line_comment] = ACTIONS(7),
  },
  [169] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(106),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(106),
    [sym_macro_invocation] = STATE(106),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(106),
    [sym_unary_expression] = STATE(106),
    [sym_try_expression] = STATE(106),
    [sym_reference_expression] = STATE(106),
    [sym_binary_expression] = STATE(106),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(106),
    [sym_call_expression] = STATE(106),
    [sym_array_expression] = STATE(106),
    [sym_parenthesized_expression] = STATE(106),
    [sym_tuple_expression] = STATE(106),
    [sym_unit_expression] = STATE(106),
    [sym_struct_expression] = STATE(106),
    [sym_if_expression] = STATE(106),
    [sym_if_let_expression] = STATE(106),
    [sym_match_expression] = STATE(106),
    [sym_while_expression] = STATE(106),
    [sym_while_let_expression] = STATE(106),
    [sym_loop_expression] = STATE(106),
    [sym_for_expression] = STATE(106),
    [sym_closure_expression] = STATE(106),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(106),
    [sym_continue_expression] = STATE(106),
    [sym_index_expression] = STATE(106),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(106),
    [sym_block] = STATE(106),
    [sym__literal] = STATE(106),
    [sym_string_literal] = STATE(106),
    [sym_boolean_literal] = STATE(106),
    [sym_raw_string_literal] = ACTIONS(183),
    [sym_float_literal] = ACTIONS(183),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [sym_mutable_specifier] = ACTIONS(939),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(183),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(183),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [170] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(941),
  },
  [171] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(470),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(470),
    [sym_macro_invocation] = STATE(470),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(470),
    [sym_unary_expression] = STATE(470),
    [sym_try_expression] = STATE(470),
    [sym_reference_expression] = STATE(470),
    [sym_binary_expression] = STATE(470),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(470),
    [sym_call_expression] = STATE(470),
    [sym_array_expression] = STATE(470),
    [sym_parenthesized_expression] = STATE(470),
    [sym_tuple_expression] = STATE(470),
    [sym_unit_expression] = STATE(470),
    [sym_struct_expression] = STATE(470),
    [sym_if_expression] = STATE(470),
    [sym_if_let_expression] = STATE(470),
    [sym_match_expression] = STATE(470),
    [sym_while_expression] = STATE(470),
    [sym_while_let_expression] = STATE(470),
    [sym_loop_expression] = STATE(470),
    [sym_for_expression] = STATE(470),
    [sym_closure_expression] = STATE(470),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(470),
    [sym_continue_expression] = STATE(470),
    [sym_index_expression] = STATE(470),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(470),
    [sym_block] = STATE(470),
    [sym__literal] = STATE(470),
    [sym_string_literal] = STATE(470),
    [sym_boolean_literal] = STATE(470),
    [sym_raw_string_literal] = ACTIONS(943),
    [sym_float_literal] = ACTIONS(943),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(261),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_PLUS] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(263),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(263),
    [anon_sym_DASH] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(263),
    [anon_sym_DASH_EQ] = ACTIONS(261),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(945),
    [anon_sym_BANG_EQ] = ACTIONS(261),
    [anon_sym_STAR_EQ] = ACTIONS(261),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_SLASH_EQ] = ACTIONS(261),
    [anon_sym_AMP_AMP] = ACTIONS(261),
    [anon_sym_AMP_EQ] = ACTIONS(261),
    [anon_sym_PERCENT] = ACTIONS(263),
    [anon_sym_PERCENT_EQ] = ACTIONS(261),
    [anon_sym_CARET] = ACTIONS(263),
    [anon_sym_CARET_EQ] = ACTIONS(261),
    [anon_sym_PLUS_EQ] = ACTIONS(261),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_EQ] = ACTIONS(261),
    [anon_sym_LT_EQ] = ACTIONS(261),
    [anon_sym_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(261),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_EQ] = ACTIONS(261),
    [anon_sym_GT_GT] = ACTIONS(263),
    [anon_sym_GT_GT_EQ] = ACTIONS(261),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_PIPE_EQ] = ACTIONS(261),
    [anon_sym_PIPE_PIPE] = ACTIONS(261),
    [anon_sym_QMARK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(263),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(261),
    [anon_sym_as] = ACTIONS(263),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(943),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(943),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [172] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(472),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(472),
    [sym_macro_invocation] = STATE(472),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(472),
    [sym_unary_expression] = STATE(472),
    [sym_try_expression] = STATE(472),
    [sym_reference_expression] = STATE(472),
    [sym_binary_expression] = STATE(472),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(472),
    [sym_call_expression] = STATE(472),
    [sym_array_expression] = STATE(472),
    [sym_parenthesized_expression] = STATE(472),
    [sym_tuple_expression] = STATE(472),
    [sym_unit_expression] = STATE(472),
    [sym_struct_expression] = STATE(472),
    [sym_if_expression] = STATE(472),
    [sym_if_let_expression] = STATE(472),
    [sym_match_expression] = STATE(472),
    [sym_while_expression] = STATE(472),
    [sym_while_let_expression] = STATE(472),
    [sym_loop_expression] = STATE(472),
    [sym_for_expression] = STATE(472),
    [sym_closure_expression] = STATE(472),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(472),
    [sym_continue_expression] = STATE(472),
    [sym_index_expression] = STATE(472),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(472),
    [sym_block] = STATE(472),
    [sym__literal] = STATE(472),
    [sym_string_literal] = STATE(472),
    [sym_boolean_literal] = STATE(472),
    [sym_raw_string_literal] = ACTIONS(947),
    [sym_float_literal] = ACTIONS(947),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_let] = ACTIONS(949),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(947),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(947),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [173] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(477),
    [sym_tuple_pattern] = STATE(477),
    [sym_tuple_struct_pattern] = STATE(477),
    [sym_struct_pattern] = STATE(477),
    [sym_remaining_field_pattern] = STATE(477),
    [sym_mut_pattern] = STATE(477),
    [sym_ref_pattern] = STATE(477),
    [sym_captured_pattern] = STATE(477),
    [sym_reference_pattern] = STATE(477),
    [sym__literal] = STATE(477),
    [sym_string_literal] = STATE(477),
    [sym_boolean_literal] = STATE(477),
    [sym_raw_string_literal] = ACTIONS(951),
    [sym_float_literal] = ACTIONS(951),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(953),
    [anon_sym_AMP] = ACTIONS(955),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(957),
    [anon_sym_ref] = ACTIONS(959),
    [sym_integer_literal] = ACTIONS(951),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(951),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(961),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [174] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(478),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(478),
    [sym_macro_invocation] = STATE(478),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(478),
    [sym_unary_expression] = STATE(478),
    [sym_try_expression] = STATE(478),
    [sym_reference_expression] = STATE(478),
    [sym_binary_expression] = STATE(478),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(478),
    [sym_call_expression] = STATE(478),
    [sym_array_expression] = STATE(478),
    [sym_parenthesized_expression] = STATE(478),
    [sym_tuple_expression] = STATE(478),
    [sym_unit_expression] = STATE(478),
    [sym_struct_expression] = STATE(478),
    [sym_if_expression] = STATE(478),
    [sym_if_let_expression] = STATE(478),
    [sym_match_expression] = STATE(478),
    [sym_while_expression] = STATE(478),
    [sym_while_let_expression] = STATE(478),
    [sym_loop_expression] = STATE(478),
    [sym_for_expression] = STATE(478),
    [sym_closure_expression] = STATE(478),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(478),
    [sym_continue_expression] = STATE(478),
    [sym_index_expression] = STATE(478),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(478),
    [sym_block] = STATE(478),
    [sym__literal] = STATE(478),
    [sym_string_literal] = STATE(478),
    [sym_boolean_literal] = STATE(478),
    [sym_raw_string_literal] = ACTIONS(963),
    [sym_float_literal] = ACTIONS(963),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(359),
    [anon_sym_LBRACE] = ACTIONS(359),
    [anon_sym_LBRACK] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(361),
    [anon_sym_STAR] = ACTIONS(361),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(361),
    [anon_sym_DASH_EQ] = ACTIONS(359),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(945),
    [anon_sym_BANG_EQ] = ACTIONS(359),
    [anon_sym_STAR_EQ] = ACTIONS(359),
    [anon_sym_SLASH] = ACTIONS(361),
    [anon_sym_SLASH_EQ] = ACTIONS(359),
    [anon_sym_AMP_AMP] = ACTIONS(359),
    [anon_sym_AMP_EQ] = ACTIONS(359),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_PERCENT_EQ] = ACTIONS(359),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_CARET_EQ] = ACTIONS(359),
    [anon_sym_PLUS_EQ] = ACTIONS(359),
    [anon_sym_LT] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_LT_LT_EQ] = ACTIONS(359),
    [anon_sym_LT_EQ] = ACTIONS(359),
    [anon_sym_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(359),
    [anon_sym_GT] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(359),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_GT_GT_EQ] = ACTIONS(359),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_PIPE_EQ] = ACTIONS(359),
    [anon_sym_PIPE_PIPE] = ACTIONS(359),
    [anon_sym_QMARK] = ACTIONS(359),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(361),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(359),
    [anon_sym_as] = ACTIONS(361),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(963),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(963),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [175] = {
    [sym_closure_parameters] = STATE(479),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(7),
  },
  [176] = {
    [sym_field_initializer_list] = STATE(224),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_LBRACE] = ACTIONS(407),
    [anon_sym_LBRACK] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(411),
    [anon_sym_AMP] = ACTIONS(411),
    [anon_sym_DASH] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(411),
    [anon_sym_DASH_EQ] = ACTIONS(407),
    [anon_sym_COLON_COLON] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(557),
    [anon_sym_BANG_EQ] = ACTIONS(407),
    [anon_sym_STAR_EQ] = ACTIONS(407),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_SLASH_EQ] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(407),
    [anon_sym_AMP_EQ] = ACTIONS(407),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_PERCENT_EQ] = ACTIONS(407),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_CARET_EQ] = ACTIONS(407),
    [anon_sym_PLUS_EQ] = ACTIONS(407),
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_LT_LT_EQ] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(407),
    [anon_sym_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(407),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_GT_EQ] = ACTIONS(407),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_EQ] = ACTIONS(407),
    [anon_sym_PIPE] = ACTIONS(411),
    [anon_sym_PIPE_EQ] = ACTIONS(407),
    [anon_sym_PIPE_PIPE] = ACTIONS(407),
    [anon_sym_QMARK] = ACTIONS(407),
    [anon_sym_DOT_DOT] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(407),
    [anon_sym_as] = ACTIONS(407),
    [sym_line_comment] = ACTIONS(7),
  },
  [177] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_LBRACE] = ACTIONS(407),
    [anon_sym_LBRACK] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(411),
    [anon_sym_AMP] = ACTIONS(411),
    [anon_sym_DASH] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(411),
    [anon_sym_DASH_EQ] = ACTIONS(407),
    [anon_sym_COLON_COLON] = ACTIONS(967),
    [anon_sym_BANG_EQ] = ACTIONS(407),
    [anon_sym_STAR_EQ] = ACTIONS(407),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_SLASH_EQ] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(407),
    [anon_sym_AMP_EQ] = ACTIONS(407),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_PERCENT_EQ] = ACTIONS(407),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_CARET_EQ] = ACTIONS(407),
    [anon_sym_PLUS_EQ] = ACTIONS(407),
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_LT_LT_EQ] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(407),
    [anon_sym_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(407),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_GT_EQ] = ACTIONS(407),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_EQ] = ACTIONS(407),
    [anon_sym_PIPE] = ACTIONS(411),
    [anon_sym_PIPE_EQ] = ACTIONS(407),
    [anon_sym_PIPE_PIPE] = ACTIONS(407),
    [anon_sym_QMARK] = ACTIONS(407),
    [anon_sym_DOT_DOT] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(407),
    [anon_sym_as] = ACTIONS(407),
    [sym_line_comment] = ACTIONS(7),
  },
  [178] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON_COLON] = ACTIONS(967),
    [sym_line_comment] = ACTIONS(7),
  },
  [179] = {
    [sym_field_initializer_list] = STATE(243),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(409),
    [anon_sym_COLON_COLON] = ACTIONS(969),
    [sym_line_comment] = ACTIONS(7),
  },
  [180] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(497),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [181] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_LBRACE] = ACTIONS(407),
    [anon_sym_LBRACK] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(411),
    [anon_sym_AMP] = ACTIONS(411),
    [anon_sym_DASH] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(411),
    [anon_sym_DASH_EQ] = ACTIONS(407),
    [anon_sym_COLON_COLON] = ACTIONS(1001),
    [anon_sym_BANG_EQ] = ACTIONS(407),
    [anon_sym_STAR_EQ] = ACTIONS(407),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_SLASH_EQ] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(407),
    [anon_sym_AMP_EQ] = ACTIONS(407),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_PERCENT_EQ] = ACTIONS(407),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_CARET_EQ] = ACTIONS(407),
    [anon_sym_PLUS_EQ] = ACTIONS(407),
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_LT_LT_EQ] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(407),
    [anon_sym_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(407),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_GT_EQ] = ACTIONS(407),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_EQ] = ACTIONS(407),
    [anon_sym_PIPE] = ACTIONS(411),
    [anon_sym_PIPE_EQ] = ACTIONS(407),
    [anon_sym_PIPE_PIPE] = ACTIONS(407),
    [anon_sym_QMARK] = ACTIONS(407),
    [anon_sym_DOT_DOT] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(407),
    [anon_sym_as] = ACTIONS(407),
    [sym_line_comment] = ACTIONS(7),
  },
  [182] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(499),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(499),
    [sym_macro_invocation] = STATE(499),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(499),
    [sym_unary_expression] = STATE(499),
    [sym_try_expression] = STATE(499),
    [sym_reference_expression] = STATE(499),
    [sym_binary_expression] = STATE(499),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(499),
    [sym_call_expression] = STATE(499),
    [sym_array_expression] = STATE(499),
    [sym_parenthesized_expression] = STATE(499),
    [sym_tuple_expression] = STATE(499),
    [sym_unit_expression] = STATE(499),
    [sym_struct_expression] = STATE(499),
    [sym_if_expression] = STATE(499),
    [sym_if_let_expression] = STATE(499),
    [sym_match_expression] = STATE(499),
    [sym_while_expression] = STATE(499),
    [sym_while_let_expression] = STATE(499),
    [sym_loop_expression] = STATE(499),
    [sym_for_expression] = STATE(499),
    [sym_closure_expression] = STATE(499),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(499),
    [sym_continue_expression] = STATE(499),
    [sym_index_expression] = STATE(499),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(499),
    [sym_block] = STATE(499),
    [sym__literal] = STATE(499),
    [sym_string_literal] = STATE(499),
    [sym_boolean_literal] = STATE(499),
    [sym_raw_string_literal] = ACTIONS(1003),
    [sym_float_literal] = ACTIONS(1003),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(945),
    [anon_sym_DASH_GT] = ACTIONS(509),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(1003),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1003),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [183] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON_COLON] = ACTIONS(755),
    [sym_line_comment] = ACTIONS(7),
  },
  [184] = {
    [sym_function_modifiers] = STATE(124),
    [sym_constrained_type_parameter] = STATE(503),
    [sym_optional_type_parameter] = STATE(504),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(125),
    [sym_bracketed_type] = STATE(122),
    [sym_qualified_type] = STATE(126),
    [sym_lifetime] = STATE(505),
    [sym_array_type] = STATE(125),
    [sym_function_type] = STATE(125),
    [sym_tuple_type] = STATE(125),
    [sym_unit_type] = STATE(125),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(125),
    [sym_reference_type] = STATE(125),
    [sym_pointer_type] = STATE(125),
    [sym_empty_type] = STATE(125),
    [sym_dynamic_type] = STATE(125),
    [sym_macro_invocation] = STATE(125),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(131),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(197),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(201),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(211),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1007),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(1009),
  },
  [185] = {
    [sym_declaration_list] = STATE(507),
    [sym_where_clause] = STATE(508),
    [sym_impl_for_clause] = STATE(509),
    [sym_type_arguments] = STATE(510),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [186] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(512),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1013),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [187] = {
    [sym_declaration_list] = STATE(513),
    [sym_where_clause] = STATE(514),
    [sym_impl_for_clause] = STATE(515),
    [sym_type_arguments] = STATE(516),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [188] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(428),
    [sym_tuple_pattern] = STATE(428),
    [sym_tuple_struct_pattern] = STATE(428),
    [sym_struct_pattern] = STATE(428),
    [sym_remaining_field_pattern] = STATE(428),
    [sym_mut_pattern] = STATE(428),
    [sym_ref_pattern] = STATE(428),
    [sym_captured_pattern] = STATE(428),
    [sym_reference_pattern] = STATE(428),
    [sym__literal] = STATE(428),
    [sym_string_literal] = STATE(428),
    [sym_boolean_literal] = STATE(428),
    [sym_raw_string_literal] = ACTIONS(833),
    [sym_float_literal] = ACTIONS(833),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(341),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(345),
    [sym_integer_literal] = ACTIONS(833),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(833),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(347),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [189] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(519),
    [sym_tuple_pattern] = STATE(519),
    [sym_tuple_struct_pattern] = STATE(519),
    [sym_struct_pattern] = STATE(519),
    [sym_remaining_field_pattern] = STATE(519),
    [sym_mut_pattern] = STATE(519),
    [sym_ref_pattern] = STATE(519),
    [sym_captured_pattern] = STATE(519),
    [sym_reference_pattern] = STATE(519),
    [sym__literal] = STATE(519),
    [sym_string_literal] = STATE(519),
    [sym_boolean_literal] = STATE(519),
    [sym_raw_string_literal] = ACTIONS(1017),
    [sym_float_literal] = ACTIONS(1017),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(341),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(1021),
    [anon_sym_ref] = ACTIONS(345),
    [sym_integer_literal] = ACTIONS(1017),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(1017),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(347),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [190] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(441),
    [sym_tuple_pattern] = STATE(441),
    [sym_tuple_struct_pattern] = STATE(441),
    [sym_struct_pattern] = STATE(441),
    [sym_remaining_field_pattern] = STATE(441),
    [sym_mut_pattern] = STATE(441),
    [sym_ref_pattern] = STATE(441),
    [sym_captured_pattern] = STATE(441),
    [sym_reference_pattern] = STATE(441),
    [sym__literal] = STATE(441),
    [sym_string_literal] = STATE(441),
    [sym_boolean_literal] = STATE(441),
    [sym_raw_string_literal] = ACTIONS(871),
    [sym_float_literal] = ACTIONS(871),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(873),
    [anon_sym_AMP] = ACTIONS(341),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(1021),
    [anon_sym_ref] = ACTIONS(345),
    [sym_integer_literal] = ACTIONS(871),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(347),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [191] = {
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(831),
    [anon_sym_LPAREN] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(883),
    [anon_sym_COLON] = ACTIONS(899),
    [anon_sym_COLON_COLON] = ACTIONS(887),
    [anon_sym_AT] = ACTIONS(1023),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_EQ] = ACTIONS(831),
    [sym_line_comment] = ACTIONS(7),
  },
  [192] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1025),
    [anon_sym_COLON] = ACTIONS(1027),
    [anon_sym_EQ] = ACTIONS(1029),
    [sym_line_comment] = ACTIONS(7),
  },
  [193] = {
    [sym_raw_string_literal] = ACTIONS(1031),
    [sym_float_literal] = ACTIONS(1031),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(1031),
    [anon_sym_SEMI] = ACTIONS(1031),
    [anon_sym_macro_rules_BANG] = ACTIONS(1031),
    [anon_sym_LPAREN] = ACTIONS(1031),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_RBRACE] = ACTIONS(1031),
    [anon_sym_LBRACK] = ACTIONS(1031),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_STAR] = ACTIONS(1033),
    [anon_sym_u8] = ACTIONS(1033),
    [anon_sym_i8] = ACTIONS(1033),
    [anon_sym_u16] = ACTIONS(1033),
    [anon_sym_i16] = ACTIONS(1033),
    [anon_sym_u32] = ACTIONS(1033),
    [anon_sym_i32] = ACTIONS(1033),
    [anon_sym_u64] = ACTIONS(1033),
    [anon_sym_i64] = ACTIONS(1033),
    [anon_sym_u128] = ACTIONS(1033),
    [anon_sym_i128] = ACTIONS(1033),
    [anon_sym_isize] = ACTIONS(1033),
    [anon_sym_usize] = ACTIONS(1033),
    [anon_sym_f32] = ACTIONS(1033),
    [anon_sym_f64] = ACTIONS(1033),
    [anon_sym_bool] = ACTIONS(1033),
    [anon_sym_str] = ACTIONS(1033),
    [anon_sym_char] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_DOT] = ACTIONS(1033),
    [anon_sym_DASH_EQ] = ACTIONS(1031),
    [anon_sym_COLON_COLON] = ACTIONS(1031),
    [anon_sym_BANG] = ACTIONS(1033),
    [anon_sym_BANG_EQ] = ACTIONS(1031),
    [anon_sym_STAR_EQ] = ACTIONS(1031),
    [anon_sym_SLASH] = ACTIONS(1033),
    [anon_sym_SLASH_EQ] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(1031),
    [anon_sym_AMP_EQ] = ACTIONS(1031),
    [anon_sym_POUND] = ACTIONS(1031),
    [anon_sym_PERCENT] = ACTIONS(1033),
    [anon_sym_PERCENT_EQ] = ACTIONS(1031),
    [anon_sym_CARET] = ACTIONS(1033),
    [anon_sym_CARET_EQ] = ACTIONS(1031),
    [anon_sym_PLUS_EQ] = ACTIONS(1031),
    [anon_sym_LT] = ACTIONS(1033),
    [anon_sym_LT_LT] = ACTIONS(1033),
    [anon_sym_LT_LT_EQ] = ACTIONS(1031),
    [anon_sym_LT_EQ] = ACTIONS(1031),
    [anon_sym_EQ] = ACTIONS(1033),
    [anon_sym_EQ_EQ] = ACTIONS(1031),
    [anon_sym_GT] = ACTIONS(1033),
    [anon_sym_GT_EQ] = ACTIONS(1031),
    [anon_sym_GT_GT] = ACTIONS(1033),
    [anon_sym_GT_GT_EQ] = ACTIONS(1031),
    [anon_sym_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_EQ] = ACTIONS(1031),
    [anon_sym_PIPE_PIPE] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1031),
    [anon_sym_SQUOTE] = ACTIONS(1033),
    [anon_sym_DOT_DOT] = ACTIONS(1033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1031),
    [anon_sym_as] = ACTIONS(1033),
    [anon_sym_break] = ACTIONS(1033),
    [anon_sym_const] = ACTIONS(1033),
    [anon_sym_continue] = ACTIONS(1033),
    [anon_sym_default] = ACTIONS(1033),
    [anon_sym_enum] = ACTIONS(1033),
    [anon_sym_fn] = ACTIONS(1033),
    [anon_sym_for] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1033),
    [anon_sym_impl] = ACTIONS(1033),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_loop] = ACTIONS(1033),
    [anon_sym_match] = ACTIONS(1033),
    [anon_sym_mod] = ACTIONS(1033),
    [anon_sym_pub] = ACTIONS(1033),
    [anon_sym_return] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(1033),
    [anon_sym_struct] = ACTIONS(1033),
    [anon_sym_trait] = ACTIONS(1033),
    [anon_sym_type] = ACTIONS(1033),
    [anon_sym_union] = ACTIONS(1033),
    [anon_sym_unsafe] = ACTIONS(1033),
    [anon_sym_use] = ACTIONS(1033),
    [anon_sym_while] = ACTIONS(1033),
    [anon_sym_extern] = ACTIONS(1033),
    [anon_sym_move] = ACTIONS(1033),
    [sym_integer_literal] = ACTIONS(1031),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(1031),
    [sym_char_literal] = ACTIONS(1031),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1033),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1033),
    [sym_self] = ACTIONS(1033),
    [sym_super] = ACTIONS(1033),
    [sym_crate] = ACTIONS(1033),
    [sym_metavariable] = ACTIONS(1031),
  },
  [194] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(1035),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [195] = {
    [sym_declaration_list] = STATE(525),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1037),
    [anon_sym_LBRACE] = ACTIONS(425),
    [sym_line_comment] = ACTIONS(7),
  },
  [196] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_in] = ACTIONS(1039),
    [sym_line_comment] = ACTIONS(7),
    [sym_self] = ACTIONS(1041),
    [sym_super] = ACTIONS(1041),
    [sym_crate] = ACTIONS(1041),
  },
  [197] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(1043),
    [anon_sym_BANG_EQ] = ACTIONS(469),
    [anon_sym_STAR_EQ] = ACTIONS(1043),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(1043),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_AMP_EQ] = ACTIONS(1043),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(1043),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_CARET_EQ] = ACTIONS(1043),
    [anon_sym_PLUS_EQ] = ACTIONS(1043),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT_LT_EQ] = ACTIONS(1043),
    [anon_sym_LT_EQ] = ACTIONS(469),
    [anon_sym_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_EQ] = ACTIONS(1043),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_PIPE_EQ] = ACTIONS(1043),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(489),
    [anon_sym_as] = ACTIONS(1043),
    [sym_line_comment] = ACTIONS(7),
  },
  [198] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1047),
  },
  [199] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1049),
    [sym_line_comment] = ACTIONS(7),
  },
  [200] = {
    [sym_field_declaration_list] = STATE(530),
    [sym_ordered_field_declaration_list] = STATE(534),
    [sym_where_clause] = STATE(535),
    [sym_type_parameters] = STATE(536),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_where] = ACTIONS(1057),
    [sym_line_comment] = ACTIONS(7),
  },
  [201] = {
    [sym_declaration_list] = STATE(539),
    [sym_trait_bounds] = STATE(540),
    [sym_type_parameters] = STATE(541),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_COLON] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [sym_line_comment] = ACTIONS(7),
  },
  [202] = {
    [sym_trait_bounds] = STATE(545),
    [sym_type_parameters] = STATE(546),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_COLON] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(1067),
    [sym_line_comment] = ACTIONS(7),
  },
  [203] = {
    [sym_field_declaration_list] = STATE(547),
    [sym_ordered_field_declaration_list] = STATE(548),
    [sym_where_clause] = STATE(549),
    [sym_type_parameters] = STATE(550),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_where] = ACTIONS(1057),
    [sym_line_comment] = ACTIONS(7),
  },
  [204] = {
    [sym_type_parameters] = STATE(551),
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(512),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(331),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1013),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [205] = {
    [sym_raw_string_literal] = ACTIONS(1071),
    [sym_float_literal] = ACTIONS(1071),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1071),
    [anon_sym_macro_rules_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1073),
    [anon_sym_STAR] = ACTIONS(1073),
    [anon_sym_u8] = ACTIONS(1073),
    [anon_sym_i8] = ACTIONS(1073),
    [anon_sym_u16] = ACTIONS(1073),
    [anon_sym_i16] = ACTIONS(1073),
    [anon_sym_u32] = ACTIONS(1073),
    [anon_sym_i32] = ACTIONS(1073),
    [anon_sym_u64] = ACTIONS(1073),
    [anon_sym_i64] = ACTIONS(1073),
    [anon_sym_u128] = ACTIONS(1073),
    [anon_sym_i128] = ACTIONS(1073),
    [anon_sym_isize] = ACTIONS(1073),
    [anon_sym_usize] = ACTIONS(1073),
    [anon_sym_f32] = ACTIONS(1073),
    [anon_sym_f64] = ACTIONS(1073),
    [anon_sym_bool] = ACTIONS(1073),
    [anon_sym_str] = ACTIONS(1073),
    [anon_sym_char] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_DASH] = ACTIONS(1073),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_DASH_EQ] = ACTIONS(1071),
    [anon_sym_COLON_COLON] = ACTIONS(1071),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_BANG_EQ] = ACTIONS(1071),
    [anon_sym_STAR_EQ] = ACTIONS(1071),
    [anon_sym_SLASH] = ACTIONS(1073),
    [anon_sym_SLASH_EQ] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_AMP_EQ] = ACTIONS(1071),
    [anon_sym_POUND] = ACTIONS(1071),
    [anon_sym_PERCENT] = ACTIONS(1073),
    [anon_sym_PERCENT_EQ] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1073),
    [anon_sym_CARET_EQ] = ACTIONS(1071),
    [anon_sym_PLUS_EQ] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_LT_LT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(1071),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_GT_GT_EQ] = ACTIONS(1071),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_PIPE_EQ] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_QMARK] = ACTIONS(1071),
    [anon_sym_SQUOTE] = ACTIONS(1073),
    [anon_sym_DOT_DOT] = ACTIONS(1073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1071),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_break] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1073),
    [anon_sym_continue] = ACTIONS(1073),
    [anon_sym_default] = ACTIONS(1073),
    [anon_sym_enum] = ACTIONS(1073),
    [anon_sym_fn] = ACTIONS(1073),
    [anon_sym_for] = ACTIONS(1073),
    [anon_sym_if] = ACTIONS(1073),
    [anon_sym_impl] = ACTIONS(1073),
    [anon_sym_let] = ACTIONS(1073),
    [anon_sym_loop] = ACTIONS(1073),
    [anon_sym_match] = ACTIONS(1073),
    [anon_sym_mod] = ACTIONS(1073),
    [anon_sym_pub] = ACTIONS(1073),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_static] = ACTIONS(1073),
    [anon_sym_struct] = ACTIONS(1073),
    [anon_sym_trait] = ACTIONS(1073),
    [anon_sym_type] = ACTIONS(1073),
    [anon_sym_union] = ACTIONS(1073),
    [anon_sym_unsafe] = ACTIONS(1073),
    [anon_sym_use] = ACTIONS(1073),
    [anon_sym_while] = ACTIONS(1073),
    [anon_sym_extern] = ACTIONS(1073),
    [anon_sym_move] = ACTIONS(1073),
    [sym_integer_literal] = ACTIONS(1071),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(1071),
    [sym_char_literal] = ACTIONS(1071),
    [anon_sym_true] = ACTIONS(1073),
    [anon_sym_false] = ACTIONS(1073),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1073),
    [sym_self] = ACTIONS(1073),
    [sym_super] = ACTIONS(1073),
    [sym_crate] = ACTIONS(1073),
    [sym_metavariable] = ACTIONS(1071),
  },
  [206] = {
    [sym_use_list] = STATE(558),
    [sym_use_as_clause] = STATE(558),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_type_with_turbofish] = STATE(212),
    [sym_scoped_identifier] = STATE(559),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(377),
    [anon_sym_RBRACE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1077),
    [anon_sym_u8] = ACTIONS(1079),
    [anon_sym_i8] = ACTIONS(1079),
    [anon_sym_u16] = ACTIONS(1079),
    [anon_sym_i16] = ACTIONS(1079),
    [anon_sym_u32] = ACTIONS(1079),
    [anon_sym_i32] = ACTIONS(1079),
    [anon_sym_u64] = ACTIONS(1079),
    [anon_sym_i64] = ACTIONS(1079),
    [anon_sym_u128] = ACTIONS(1079),
    [anon_sym_i128] = ACTIONS(1079),
    [anon_sym_isize] = ACTIONS(1079),
    [anon_sym_usize] = ACTIONS(1079),
    [anon_sym_f32] = ACTIONS(1079),
    [anon_sym_f64] = ACTIONS(1079),
    [anon_sym_bool] = ACTIONS(1079),
    [anon_sym_str] = ACTIONS(1079),
    [anon_sym_char] = ACTIONS(1079),
    [anon_sym_COLON_COLON] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(31),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1083),
    [sym_self] = ACTIONS(1085),
    [sym_super] = ACTIONS(1085),
    [sym_crate] = ACTIONS(1085),
    [sym_metavariable] = ACTIONS(1087),
  },
  [207] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_as] = ACTIONS(1093),
    [sym_line_comment] = ACTIONS(7),
  },
  [208] = {
    [sym_use_list] = STATE(562),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(377),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(941),
  },
  [209] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1097),
    [anon_sym_as] = ACTIONS(1099),
    [sym_line_comment] = ACTIONS(7),
  },
  [210] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1101),
    [anon_sym_as] = ACTIONS(1099),
    [sym_line_comment] = ACTIONS(7),
  },
  [211] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1103),
    [sym_line_comment] = ACTIONS(7),
  },
  [212] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON_COLON] = ACTIONS(1105),
    [sym_line_comment] = ACTIONS(7),
  },
  [213] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(1099),
    [sym_line_comment] = ACTIONS(7),
  },
  [214] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(569),
    [sym_tuple_pattern] = STATE(569),
    [sym_tuple_struct_pattern] = STATE(569),
    [sym_struct_pattern] = STATE(569),
    [sym_remaining_field_pattern] = STATE(569),
    [sym_mut_pattern] = STATE(569),
    [sym_ref_pattern] = STATE(569),
    [sym_captured_pattern] = STATE(569),
    [sym_reference_pattern] = STATE(569),
    [sym__literal] = STATE(569),
    [sym_string_literal] = STATE(569),
    [sym_boolean_literal] = STATE(569),
    [sym_raw_string_literal] = ACTIONS(1109),
    [sym_float_literal] = ACTIONS(1109),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(1111),
    [anon_sym_AMP] = ACTIONS(955),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(957),
    [anon_sym_ref] = ACTIONS(959),
    [sym_integer_literal] = ACTIONS(1109),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(1109),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(961),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [215] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(570),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [216] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1113),
  },
  [217] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1115),
    [anon_sym_LBRACE] = ACTIONS(1115),
    [anon_sym_const] = ACTIONS(1115),
    [anon_sym_default] = ACTIONS(1115),
    [anon_sym_fn] = ACTIONS(1115),
    [anon_sym_unsafe] = ACTIONS(1115),
    [anon_sym_extern] = ACTIONS(1115),
    [sym_line_comment] = ACTIONS(7),
  },
  [218] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(573),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(573),
    [sym_macro_invocation] = STATE(573),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(573),
    [sym_unary_expression] = STATE(573),
    [sym_try_expression] = STATE(573),
    [sym_reference_expression] = STATE(573),
    [sym_binary_expression] = STATE(573),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(573),
    [sym_call_expression] = STATE(573),
    [sym_array_expression] = STATE(573),
    [sym_parenthesized_expression] = STATE(573),
    [sym_tuple_expression] = STATE(573),
    [sym_unit_expression] = STATE(573),
    [sym_struct_expression] = STATE(573),
    [sym_if_expression] = STATE(573),
    [sym_if_let_expression] = STATE(573),
    [sym_match_expression] = STATE(573),
    [sym_while_expression] = STATE(573),
    [sym_while_let_expression] = STATE(573),
    [sym_loop_expression] = STATE(573),
    [sym_for_expression] = STATE(573),
    [sym_closure_expression] = STATE(573),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(573),
    [sym_continue_expression] = STATE(573),
    [sym_index_expression] = STATE(573),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(573),
    [sym_block] = STATE(573),
    [sym__literal] = STATE(573),
    [sym_string_literal] = STATE(573),
    [sym_boolean_literal] = STATE(573),
    [sym_raw_string_literal] = ACTIONS(1117),
    [sym_float_literal] = ACTIONS(1117),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_DASH_GT] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(1117),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1117),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [219] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1121),
    [anon_sym_LPAREN] = ACTIONS(1121),
    [anon_sym_RPAREN] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1121),
    [anon_sym_RBRACE] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_RBRACK] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_DASH_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_STAR_EQ] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1123),
    [anon_sym_SLASH_EQ] = ACTIONS(1121),
    [anon_sym_AMP_AMP] = ACTIONS(1121),
    [anon_sym_AMP_EQ] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_PERCENT_EQ] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_CARET_EQ] = ACTIONS(1121),
    [anon_sym_PLUS_EQ] = ACTIONS(1121),
    [anon_sym_LT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_LT_LT_EQ] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1121),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_GT_GT_EQ] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1123),
    [anon_sym_PIPE_EQ] = ACTIONS(1121),
    [anon_sym_PIPE_PIPE] = ACTIONS(1121),
    [anon_sym_QMARK] = ACTIONS(1121),
    [anon_sym_DOT_DOT] = ACTIONS(1123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1121),
    [anon_sym_const] = ACTIONS(1121),
    [anon_sym_default] = ACTIONS(1121),
    [anon_sym_fn] = ACTIONS(1121),
    [anon_sym_unsafe] = ACTIONS(1121),
    [anon_sym_extern] = ACTIONS(1121),
    [anon_sym_in] = ACTIONS(1121),
    [sym_line_comment] = ACTIONS(7),
  },
  [220] = {
    [aux_sym_string_literal_repeat1] = STATE(575),
    [sym_block_comment] = ACTIONS(7),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_RBRACK_PLUS_SLASH] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [sym_escape_sequence] = ACTIONS(1125),
    [sym_line_comment] = ACTIONS(401),
  },
  [221] = {
    [sym_attribute_item] = STATE(582),
    [sym_field_initializer] = STATE(581),
    [sym_base_field_initializer] = STATE(581),
    [aux_sym_enum_variant_list_repeat1] = STATE(582),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(1129),
    [anon_sym_COMMA] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_DOT_DOT] = ACTIONS(1135),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1137),
  },
  [222] = {
    [sym_type_arguments] = STATE(585),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(1139),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1141),
  },
  [223] = {
    [sym_token_tree] = STATE(589),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_LBRACE] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [sym_line_comment] = ACTIONS(7),
  },
  [224] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1149),
    [anon_sym_LPAREN] = ACTIONS(1149),
    [anon_sym_RPAREN] = ACTIONS(1149),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_RBRACE] = ACTIONS(1149),
    [anon_sym_LBRACK] = ACTIONS(1149),
    [anon_sym_RBRACK] = ACTIONS(1149),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1151),
    [anon_sym_COMMA] = ACTIONS(1149),
    [anon_sym_AMP] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_DASH_EQ] = ACTIONS(1149),
    [anon_sym_BANG_EQ] = ACTIONS(1149),
    [anon_sym_STAR_EQ] = ACTIONS(1149),
    [anon_sym_SLASH] = ACTIONS(1151),
    [anon_sym_SLASH_EQ] = ACTIONS(1149),
    [anon_sym_AMP_AMP] = ACTIONS(1149),
    [anon_sym_AMP_EQ] = ACTIONS(1149),
    [anon_sym_PERCENT] = ACTIONS(1151),
    [anon_sym_PERCENT_EQ] = ACTIONS(1149),
    [anon_sym_CARET] = ACTIONS(1151),
    [anon_sym_CARET_EQ] = ACTIONS(1149),
    [anon_sym_PLUS_EQ] = ACTIONS(1149),
    [anon_sym_LT] = ACTIONS(1151),
    [anon_sym_LT_LT] = ACTIONS(1151),
    [anon_sym_LT_LT_EQ] = ACTIONS(1149),
    [anon_sym_LT_EQ] = ACTIONS(1149),
    [anon_sym_EQ] = ACTIONS(1151),
    [anon_sym_EQ_EQ] = ACTIONS(1149),
    [anon_sym_GT] = ACTIONS(1151),
    [anon_sym_GT_EQ] = ACTIONS(1149),
    [anon_sym_GT_GT] = ACTIONS(1151),
    [anon_sym_GT_GT_EQ] = ACTIONS(1149),
    [anon_sym_PIPE] = ACTIONS(1151),
    [anon_sym_PIPE_EQ] = ACTIONS(1149),
    [anon_sym_PIPE_PIPE] = ACTIONS(1149),
    [anon_sym_QMARK] = ACTIONS(1149),
    [anon_sym_DOT_DOT] = ACTIONS(1151),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1149),
    [anon_sym_as] = ACTIONS(1149),
    [sym_line_comment] = ACTIONS(7),
  },
  [225] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1141),
  },
  [226] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1153),
    [sym_metavariable] = ACTIONS(1153),
  },
  [227] = {
    [sym_raw_string_literal] = ACTIONS(1155),
    [sym_float_literal] = ACTIONS(1155),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(1155),
    [anon_sym_SEMI] = ACTIONS(1155),
    [anon_sym_macro_rules_BANG] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_LBRACE] = ACTIONS(1155),
    [anon_sym_RBRACE] = ACTIONS(1155),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(1155),
    [anon_sym_u8] = ACTIONS(1157),
    [anon_sym_i8] = ACTIONS(1157),
    [anon_sym_u16] = ACTIONS(1157),
    [anon_sym_i16] = ACTIONS(1157),
    [anon_sym_u32] = ACTIONS(1157),
    [anon_sym_i32] = ACTIONS(1157),
    [anon_sym_u64] = ACTIONS(1157),
    [anon_sym_i64] = ACTIONS(1157),
    [anon_sym_u128] = ACTIONS(1157),
    [anon_sym_i128] = ACTIONS(1157),
    [anon_sym_isize] = ACTIONS(1157),
    [anon_sym_usize] = ACTIONS(1157),
    [anon_sym_f32] = ACTIONS(1157),
    [anon_sym_f64] = ACTIONS(1157),
    [anon_sym_bool] = ACTIONS(1157),
    [anon_sym_str] = ACTIONS(1157),
    [anon_sym_char] = ACTIONS(1157),
    [anon_sym_AMP] = ACTIONS(1155),
    [anon_sym_DASH] = ACTIONS(1155),
    [anon_sym_COLON_COLON] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1155),
    [anon_sym_POUND] = ACTIONS(1155),
    [anon_sym_LT] = ACTIONS(1155),
    [anon_sym_PIPE] = ACTIONS(1155),
    [anon_sym_SQUOTE] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(1155),
    [anon_sym_break] = ACTIONS(1157),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_continue] = ACTIONS(1157),
    [anon_sym_default] = ACTIONS(1157),
    [anon_sym_enum] = ACTIONS(1157),
    [anon_sym_fn] = ACTIONS(1157),
    [anon_sym_for] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1157),
    [anon_sym_impl] = ACTIONS(1157),
    [anon_sym_let] = ACTIONS(1157),
    [anon_sym_loop] = ACTIONS(1157),
    [anon_sym_match] = ACTIONS(1157),
    [anon_sym_mod] = ACTIONS(1157),
    [anon_sym_pub] = ACTIONS(1157),
    [anon_sym_return] = ACTIONS(1157),
    [anon_sym_static] = ACTIONS(1157),
    [anon_sym_struct] = ACTIONS(1157),
    [anon_sym_trait] = ACTIONS(1157),
    [anon_sym_type] = ACTIONS(1157),
    [anon_sym_union] = ACTIONS(1157),
    [anon_sym_unsafe] = ACTIONS(1157),
    [anon_sym_use] = ACTIONS(1157),
    [anon_sym_while] = ACTIONS(1157),
    [anon_sym_extern] = ACTIONS(1157),
    [anon_sym_move] = ACTIONS(1157),
    [sym_integer_literal] = ACTIONS(1155),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(1155),
    [sym_char_literal] = ACTIONS(1155),
    [anon_sym_true] = ACTIONS(1157),
    [anon_sym_false] = ACTIONS(1157),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1157),
    [sym_self] = ACTIONS(1157),
    [sym_super] = ACTIONS(1157),
    [sym_crate] = ACTIONS(1157),
    [sym_metavariable] = ACTIONS(1155),
  },
  [228] = {
    [sym_empty_statement] = STATE(613),
    [sym_macro_definition] = STATE(613),
    [sym_attribute_item] = STATE(613),
    [sym_inner_attribute_item] = STATE(613),
    [sym_mod_item] = STATE(613),
    [sym_foreign_mod_item] = STATE(613),
    [sym_struct_item] = STATE(613),
    [sym_union_item] = STATE(613),
    [sym_enum_item] = STATE(613),
    [sym_extern_crate_declaration] = STATE(613),
    [sym_const_item] = STATE(613),
    [sym_static_item] = STATE(613),
    [sym_type_item] = STATE(613),
    [sym_function_item] = STATE(613),
    [sym_function_signature_item] = STATE(613),
    [sym_function_modifiers] = STATE(610),
    [sym_impl_item] = STATE(613),
    [sym_trait_item] = STATE(613),
    [sym_associated_type] = STATE(613),
    [sym_let_declaration] = STATE(613),
    [sym_use_declaration] = STATE(613),
    [sym_extern_modifier] = STATE(611),
    [sym_visibility_modifier] = STATE(612),
    [sym_macro_invocation] = STATE(613),
    [aux_sym_declaration_list_repeat1] = STATE(613),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1159),
    [anon_sym_macro_rules_BANG] = ACTIONS(1161),
    [anon_sym_RBRACE] = ACTIONS(1163),
    [anon_sym_POUND] = ACTIONS(1165),
    [anon_sym_const] = ACTIONS(1167),
    [anon_sym_default] = ACTIONS(1169),
    [anon_sym_enum] = ACTIONS(1171),
    [anon_sym_fn] = ACTIONS(1173),
    [anon_sym_impl] = ACTIONS(1175),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_mod] = ACTIONS(1179),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_struct] = ACTIONS(1183),
    [anon_sym_trait] = ACTIONS(1185),
    [anon_sym_type] = ACTIONS(1187),
    [anon_sym_union] = ACTIONS(1189),
    [anon_sym_unsafe] = ACTIONS(1191),
    [anon_sym_use] = ACTIONS(1193),
    [anon_sym_extern] = ACTIONS(1195),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1197),
  },
  [229] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(273),
    [anon_sym_default] = ACTIONS(273),
    [anon_sym_fn] = ACTIONS(273),
    [anon_sym_unsafe] = ACTIONS(273),
    [anon_sym_extern] = ACTIONS(273),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1199),
  },
  [230] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1201),
  },
  [231] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1203),
  },
  [232] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_mutable_specifier] = ACTIONS(1205),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1207),
  },
  [233] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1209),
  },
  [234] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1211),
  },
  [235] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1213),
  },
  [236] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1215),
  },
  [237] = {
    [sym__use_clause] = STATE(622),
    [sym_scoped_use_list] = STATE(622),
    [sym_use_list] = STATE(622),
    [sym_use_as_clause] = STATE(622),
    [sym_use_wildcard] = STATE(622),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_type_with_turbofish] = STATE(212),
    [sym_scoped_identifier] = STATE(213),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(377),
    [anon_sym_u8] = ACTIONS(379),
    [anon_sym_i8] = ACTIONS(379),
    [anon_sym_u16] = ACTIONS(379),
    [anon_sym_i16] = ACTIONS(379),
    [anon_sym_u32] = ACTIONS(379),
    [anon_sym_i32] = ACTIONS(379),
    [anon_sym_u64] = ACTIONS(379),
    [anon_sym_i64] = ACTIONS(379),
    [anon_sym_u128] = ACTIONS(379),
    [anon_sym_i128] = ACTIONS(379),
    [anon_sym_isize] = ACTIONS(379),
    [anon_sym_usize] = ACTIONS(379),
    [anon_sym_f32] = ACTIONS(379),
    [anon_sym_f64] = ACTIONS(379),
    [anon_sym_bool] = ACTIONS(379),
    [anon_sym_str] = ACTIONS(379),
    [anon_sym_char] = ACTIONS(379),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_LT] = ACTIONS(31),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(383),
    [sym_self] = ACTIONS(385),
    [sym_super] = ACTIONS(385),
    [sym_crate] = ACTIONS(385),
    [sym_metavariable] = ACTIONS(387),
  },
  [238] = {
    [sym_string_literal] = STATE(217),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_const] = ACTIONS(393),
    [anon_sym_default] = ACTIONS(393),
    [anon_sym_fn] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(393),
    [anon_sym_extern] = ACTIONS(393),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(7),
    [sym_crate] = ACTIONS(1217),
  },
  [239] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_fn] = ACTIONS(1219),
    [sym_line_comment] = ACTIONS(7),
  },
  [240] = {
    [sym_declaration_list] = STATE(625),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_default] = ACTIONS(281),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_unsafe] = ACTIONS(281),
    [anon_sym_extern] = ACTIONS(281),
    [sym_line_comment] = ACTIONS(7),
  },
  [241] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1223),
  },
  [242] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1225),
  },
  [243] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1227),
    [anon_sym_LPAREN] = ACTIONS(1227),
    [anon_sym_RPAREN] = ACTIONS(1227),
    [anon_sym_LBRACE] = ACTIONS(1227),
    [anon_sym_RBRACE] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_RBRACK] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1229),
    [anon_sym_STAR] = ACTIONS(1229),
    [anon_sym_COMMA] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1229),
    [anon_sym_DASH] = ACTIONS(1229),
    [anon_sym_DOT] = ACTIONS(1229),
    [anon_sym_DASH_EQ] = ACTIONS(1227),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_STAR_EQ] = ACTIONS(1227),
    [anon_sym_SLASH] = ACTIONS(1229),
    [anon_sym_SLASH_EQ] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1227),
    [anon_sym_AMP_EQ] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_PERCENT_EQ] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1229),
    [anon_sym_CARET_EQ] = ACTIONS(1227),
    [anon_sym_PLUS_EQ] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(1229),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_LT_LT_EQ] = ACTIONS(1227),
    [anon_sym_LT_EQ] = ACTIONS(1227),
    [anon_sym_EQ] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1227),
    [anon_sym_GT_GT] = ACTIONS(1229),
    [anon_sym_GT_GT_EQ] = ACTIONS(1227),
    [anon_sym_PIPE] = ACTIONS(1229),
    [anon_sym_PIPE_EQ] = ACTIONS(1227),
    [anon_sym_PIPE_PIPE] = ACTIONS(1227),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_DOT_DOT] = ACTIONS(1229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1227),
    [anon_sym_as] = ACTIONS(1227),
    [sym_line_comment] = ACTIONS(7),
  },
  [244] = {
    [sym_raw_string_literal] = ACTIONS(1231),
    [sym_float_literal] = ACTIONS(1231),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(1231),
    [anon_sym_SEMI] = ACTIONS(1231),
    [anon_sym_macro_rules_BANG] = ACTIONS(1231),
    [anon_sym_LPAREN] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1231),
    [anon_sym_RBRACE] = ACTIONS(1231),
    [anon_sym_LBRACK] = ACTIONS(1231),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_u8] = ACTIONS(1233),
    [anon_sym_i8] = ACTIONS(1233),
    [anon_sym_u16] = ACTIONS(1233),
    [anon_sym_i16] = ACTIONS(1233),
    [anon_sym_u32] = ACTIONS(1233),
    [anon_sym_i32] = ACTIONS(1233),
    [anon_sym_u64] = ACTIONS(1233),
    [anon_sym_i64] = ACTIONS(1233),
    [anon_sym_u128] = ACTIONS(1233),
    [anon_sym_i128] = ACTIONS(1233),
    [anon_sym_isize] = ACTIONS(1233),
    [anon_sym_usize] = ACTIONS(1233),
    [anon_sym_f32] = ACTIONS(1233),
    [anon_sym_f64] = ACTIONS(1233),
    [anon_sym_bool] = ACTIONS(1233),
    [anon_sym_str] = ACTIONS(1233),
    [anon_sym_char] = ACTIONS(1233),
    [anon_sym_AMP] = ACTIONS(1231),
    [anon_sym_DASH] = ACTIONS(1231),
    [anon_sym_COLON_COLON] = ACTIONS(1231),
    [anon_sym_BANG] = ACTIONS(1231),
    [anon_sym_POUND] = ACTIONS(1231),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_SQUOTE] = ACTIONS(1233),
    [anon_sym_DOT_DOT] = ACTIONS(1231),
    [anon_sym_break] = ACTIONS(1233),
    [anon_sym_const] = ACTIONS(1233),
    [anon_sym_continue] = ACTIONS(1233),
    [anon_sym_default] = ACTIONS(1233),
    [anon_sym_enum] = ACTIONS(1233),
    [anon_sym_fn] = ACTIONS(1233),
    [anon_sym_for] = ACTIONS(1233),
    [anon_sym_if] = ACTIONS(1233),
    [anon_sym_impl] = ACTIONS(1233),
    [anon_sym_let] = ACTIONS(1233),
    [anon_sym_loop] = ACTIONS(1233),
    [anon_sym_match] = ACTIONS(1233),
    [anon_sym_mod] = ACTIONS(1233),
    [anon_sym_pub] = ACTIONS(1233),
    [anon_sym_return] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(1233),
    [anon_sym_struct] = ACTIONS(1233),
    [anon_sym_trait] = ACTIONS(1233),
    [anon_sym_type] = ACTIONS(1233),
    [anon_sym_union] = ACTIONS(1233),
    [anon_sym_unsafe] = ACTIONS(1233),
    [anon_sym_use] = ACTIONS(1233),
    [anon_sym_while] = ACTIONS(1233),
    [anon_sym_extern] = ACTIONS(1233),
    [anon_sym_move] = ACTIONS(1233),
    [sym_integer_literal] = ACTIONS(1231),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(1231),
    [sym_char_literal] = ACTIONS(1231),
    [anon_sym_true] = ACTIONS(1233),
    [anon_sym_false] = ACTIONS(1233),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1233),
    [sym_self] = ACTIONS(1233),
    [sym_super] = ACTIONS(1233),
    [sym_crate] = ACTIONS(1233),
    [sym_metavariable] = ACTIONS(1231),
  },
  [245] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(630),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(630),
    [sym_macro_invocation] = STATE(630),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(630),
    [sym_unary_expression] = STATE(630),
    [sym_try_expression] = STATE(630),
    [sym_reference_expression] = STATE(630),
    [sym_binary_expression] = STATE(630),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(630),
    [sym_call_expression] = STATE(630),
    [sym_array_expression] = STATE(630),
    [sym_parenthesized_expression] = STATE(630),
    [sym_tuple_expression] = STATE(630),
    [sym_unit_expression] = STATE(630),
    [sym_struct_expression] = STATE(630),
    [sym_if_expression] = STATE(630),
    [sym_if_let_expression] = STATE(630),
    [sym_match_expression] = STATE(630),
    [sym_while_expression] = STATE(630),
    [sym_while_let_expression] = STATE(630),
    [sym_loop_expression] = STATE(630),
    [sym_for_expression] = STATE(630),
    [sym_closure_expression] = STATE(630),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(630),
    [sym_continue_expression] = STATE(630),
    [sym_index_expression] = STATE(630),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(630),
    [sym_block] = STATE(630),
    [sym__literal] = STATE(630),
    [sym_string_literal] = STATE(630),
    [sym_boolean_literal] = STATE(630),
    [sym_raw_string_literal] = ACTIONS(1235),
    [sym_float_literal] = ACTIONS(1235),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1237),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(1239),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(1235),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [246] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(637),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(637),
    [sym_macro_invocation] = STATE(637),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(637),
    [sym_unary_expression] = STATE(637),
    [sym_try_expression] = STATE(637),
    [sym_reference_expression] = STATE(637),
    [sym_binary_expression] = STATE(637),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(637),
    [sym_call_expression] = STATE(637),
    [sym_array_expression] = STATE(637),
    [sym_parenthesized_expression] = STATE(637),
    [sym_tuple_expression] = STATE(637),
    [sym_unit_expression] = STATE(637),
    [sym_struct_expression] = STATE(637),
    [sym_if_expression] = STATE(637),
    [sym_if_let_expression] = STATE(637),
    [sym_match_expression] = STATE(637),
    [sym_while_expression] = STATE(637),
    [sym_while_let_expression] = STATE(637),
    [sym_loop_expression] = STATE(637),
    [sym_for_expression] = STATE(637),
    [sym_closure_expression] = STATE(637),
    [sym_closure_parameters] = STATE(638),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(637),
    [sym_continue_expression] = STATE(637),
    [sym_index_expression] = STATE(637),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(637),
    [sym_block] = STATE(637),
    [sym__literal] = STATE(637),
    [sym_string_literal] = STATE(637),
    [sym_boolean_literal] = STATE(637),
    [sym_raw_string_literal] = ACTIONS(1241),
    [sym_float_literal] = ACTIONS(1241),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1245),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1247),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1251),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1253),
    [sym_integer_literal] = ACTIONS(1241),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1241),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [247] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(639),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(639),
    [sym_macro_invocation] = STATE(639),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(639),
    [sym_unary_expression] = STATE(639),
    [sym_try_expression] = STATE(639),
    [sym_reference_expression] = STATE(639),
    [sym_binary_expression] = STATE(639),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(639),
    [sym_call_expression] = STATE(639),
    [sym_array_expression] = STATE(639),
    [sym_parenthesized_expression] = STATE(639),
    [sym_tuple_expression] = STATE(639),
    [sym_unit_expression] = STATE(639),
    [sym_struct_expression] = STATE(639),
    [sym_if_expression] = STATE(639),
    [sym_if_let_expression] = STATE(639),
    [sym_match_expression] = STATE(639),
    [sym_while_expression] = STATE(639),
    [sym_while_let_expression] = STATE(639),
    [sym_loop_expression] = STATE(639),
    [sym_for_expression] = STATE(639),
    [sym_closure_expression] = STATE(639),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(639),
    [sym_continue_expression] = STATE(639),
    [sym_index_expression] = STATE(639),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(639),
    [sym_block] = STATE(639),
    [sym__literal] = STATE(639),
    [sym_string_literal] = STATE(639),
    [sym_boolean_literal] = STATE(639),
    [sym_raw_string_literal] = ACTIONS(1255),
    [sym_float_literal] = ACTIONS(1255),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(1255),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1255),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [248] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(640),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(640),
    [sym_macro_invocation] = STATE(640),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(640),
    [sym_unary_expression] = STATE(640),
    [sym_try_expression] = STATE(640),
    [sym_reference_expression] = STATE(640),
    [sym_binary_expression] = STATE(640),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(640),
    [sym_call_expression] = STATE(640),
    [sym_array_expression] = STATE(640),
    [sym_parenthesized_expression] = STATE(640),
    [sym_tuple_expression] = STATE(640),
    [sym_unit_expression] = STATE(640),
    [sym_struct_expression] = STATE(640),
    [sym_if_expression] = STATE(640),
    [sym_if_let_expression] = STATE(640),
    [sym_match_expression] = STATE(640),
    [sym_while_expression] = STATE(640),
    [sym_while_let_expression] = STATE(640),
    [sym_loop_expression] = STATE(640),
    [sym_for_expression] = STATE(640),
    [sym_closure_expression] = STATE(640),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(640),
    [sym_continue_expression] = STATE(640),
    [sym_index_expression] = STATE(640),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(640),
    [sym_block] = STATE(640),
    [sym__literal] = STATE(640),
    [sym_string_literal] = STATE(640),
    [sym_boolean_literal] = STATE(640),
    [sym_raw_string_literal] = ACTIONS(1257),
    [sym_float_literal] = ACTIONS(1257),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(1257),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1257),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [249] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(641),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(641),
    [sym_macro_invocation] = STATE(641),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(641),
    [sym_unary_expression] = STATE(641),
    [sym_try_expression] = STATE(641),
    [sym_reference_expression] = STATE(641),
    [sym_binary_expression] = STATE(641),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(641),
    [sym_call_expression] = STATE(641),
    [sym_array_expression] = STATE(641),
    [sym_parenthesized_expression] = STATE(641),
    [sym_tuple_expression] = STATE(641),
    [sym_unit_expression] = STATE(641),
    [sym_struct_expression] = STATE(641),
    [sym_if_expression] = STATE(641),
    [sym_if_let_expression] = STATE(641),
    [sym_match_expression] = STATE(641),
    [sym_while_expression] = STATE(641),
    [sym_while_let_expression] = STATE(641),
    [sym_loop_expression] = STATE(641),
    [sym_for_expression] = STATE(641),
    [sym_closure_expression] = STATE(641),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(641),
    [sym_continue_expression] = STATE(641),
    [sym_index_expression] = STATE(641),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(641),
    [sym_block] = STATE(641),
    [sym__literal] = STATE(641),
    [sym_string_literal] = STATE(641),
    [sym_boolean_literal] = STATE(641),
    [sym_raw_string_literal] = ACTIONS(1259),
    [sym_float_literal] = ACTIONS(1259),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(1259),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [250] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_integer_literal] = ACTIONS(1261),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1263),
  },
  [251] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(644),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(644),
    [sym_macro_invocation] = STATE(644),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(644),
    [sym_unary_expression] = STATE(644),
    [sym_try_expression] = STATE(644),
    [sym_reference_expression] = STATE(644),
    [sym_binary_expression] = STATE(644),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(644),
    [sym_call_expression] = STATE(644),
    [sym_array_expression] = STATE(644),
    [sym_parenthesized_expression] = STATE(644),
    [sym_tuple_expression] = STATE(644),
    [sym_unit_expression] = STATE(644),
    [sym_struct_expression] = STATE(644),
    [sym_if_expression] = STATE(644),
    [sym_if_let_expression] = STATE(644),
    [sym_match_expression] = STATE(644),
    [sym_while_expression] = STATE(644),
    [sym_while_let_expression] = STATE(644),
    [sym_loop_expression] = STATE(644),
    [sym_for_expression] = STATE(644),
    [sym_closure_expression] = STATE(644),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(644),
    [sym_continue_expression] = STATE(644),
    [sym_index_expression] = STATE(644),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(644),
    [sym_block] = STATE(644),
    [sym__literal] = STATE(644),
    [sym_string_literal] = STATE(644),
    [sym_boolean_literal] = STATE(644),
    [sym_raw_string_literal] = ACTIONS(1265),
    [sym_float_literal] = ACTIONS(1265),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(1265),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1265),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [252] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(645),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(645),
    [sym_macro_invocation] = STATE(645),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(645),
    [sym_unary_expression] = STATE(645),
    [sym_try_expression] = STATE(645),
    [sym_reference_expression] = STATE(645),
    [sym_binary_expression] = STATE(645),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(645),
    [sym_call_expression] = STATE(645),
    [sym_array_expression] = STATE(645),
    [sym_parenthesized_expression] = STATE(645),
    [sym_tuple_expression] = STATE(645),
    [sym_unit_expression] = STATE(645),
    [sym_struct_expression] = STATE(645),
    [sym_if_expression] = STATE(645),
    [sym_if_let_expression] = STATE(645),
    [sym_match_expression] = STATE(645),
    [sym_while_expression] = STATE(645),
    [sym_while_let_expression] = STATE(645),
    [sym_loop_expression] = STATE(645),
    [sym_for_expression] = STATE(645),
    [sym_closure_expression] = STATE(645),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(645),
    [sym_continue_expression] = STATE(645),
    [sym_index_expression] = STATE(645),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(645),
    [sym_block] = STATE(645),
    [sym__literal] = STATE(645),
    [sym_string_literal] = STATE(645),
    [sym_boolean_literal] = STATE(645),
    [sym_raw_string_literal] = ACTIONS(1267),
    [sym_float_literal] = ACTIONS(1267),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(1267),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [253] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(646),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(646),
    [sym_macro_invocation] = STATE(646),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(646),
    [sym_unary_expression] = STATE(646),
    [sym_try_expression] = STATE(646),
    [sym_reference_expression] = STATE(646),
    [sym_binary_expression] = STATE(646),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(646),
    [sym_call_expression] = STATE(646),
    [sym_array_expression] = STATE(646),
    [sym_parenthesized_expression] = STATE(646),
    [sym_tuple_expression] = STATE(646),
    [sym_unit_expression] = STATE(646),
    [sym_struct_expression] = STATE(646),
    [sym_if_expression] = STATE(646),
    [sym_if_let_expression] = STATE(646),
    [sym_match_expression] = STATE(646),
    [sym_while_expression] = STATE(646),
    [sym_while_let_expression] = STATE(646),
    [sym_loop_expression] = STATE(646),
    [sym_for_expression] = STATE(646),
    [sym_closure_expression] = STATE(646),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(646),
    [sym_continue_expression] = STATE(646),
    [sym_index_expression] = STATE(646),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(646),
    [sym_block] = STATE(646),
    [sym__literal] = STATE(646),
    [sym_string_literal] = STATE(646),
    [sym_boolean_literal] = STATE(646),
    [sym_raw_string_literal] = ACTIONS(1269),
    [sym_float_literal] = ACTIONS(1269),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(1269),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [254] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(647),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(647),
    [sym_macro_invocation] = STATE(647),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(647),
    [sym_unary_expression] = STATE(647),
    [sym_try_expression] = STATE(647),
    [sym_reference_expression] = STATE(647),
    [sym_binary_expression] = STATE(647),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(647),
    [sym_call_expression] = STATE(647),
    [sym_array_expression] = STATE(647),
    [sym_parenthesized_expression] = STATE(647),
    [sym_tuple_expression] = STATE(647),
    [sym_unit_expression] = STATE(647),
    [sym_struct_expression] = STATE(647),
    [sym_if_expression] = STATE(647),
    [sym_if_let_expression] = STATE(647),
    [sym_match_expression] = STATE(647),
    [sym_while_expression] = STATE(647),
    [sym_while_let_expression] = STATE(647),
    [sym_loop_expression] = STATE(647),
    [sym_for_expression] = STATE(647),
    [sym_closure_expression] = STATE(647),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(647),
    [sym_continue_expression] = STATE(647),
    [sym_index_expression] = STATE(647),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(647),
    [sym_block] = STATE(647),
    [sym__literal] = STATE(647),
    [sym_string_literal] = STATE(647),
    [sym_boolean_literal] = STATE(647),
    [sym_raw_string_literal] = ACTIONS(1271),
    [sym_float_literal] = ACTIONS(1271),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(1271),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1271),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [255] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(648),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(648),
    [sym_macro_invocation] = STATE(648),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(648),
    [sym_unary_expression] = STATE(648),
    [sym_try_expression] = STATE(648),
    [sym_reference_expression] = STATE(648),
    [sym_binary_expression] = STATE(648),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(648),
    [sym_call_expression] = STATE(648),
    [sym_array_expression] = STATE(648),
    [sym_parenthesized_expression] = STATE(648),
    [sym_tuple_expression] = STATE(648),
    [sym_unit_expression] = STATE(648),
    [sym_struct_expression] = STATE(648),
    [sym_if_expression] = STATE(648),
    [sym_if_let_expression] = STATE(648),
    [sym_match_expression] = STATE(648),
    [sym_while_expression] = STATE(648),
    [sym_while_let_expression] = STATE(648),
    [sym_loop_expression] = STATE(648),
    [sym_for_expression] = STATE(648),
    [sym_closure_expression] = STATE(648),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(648),
    [sym_continue_expression] = STATE(648),
    [sym_index_expression] = STATE(648),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(648),
    [sym_block] = STATE(648),
    [sym__literal] = STATE(648),
    [sym_string_literal] = STATE(648),
    [sym_boolean_literal] = STATE(648),
    [sym_raw_string_literal] = ACTIONS(1273),
    [sym_float_literal] = ACTIONS(1273),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(1273),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1273),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [256] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(649),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(649),
    [sym_macro_invocation] = STATE(649),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(649),
    [sym_unary_expression] = STATE(649),
    [sym_try_expression] = STATE(649),
    [sym_reference_expression] = STATE(649),
    [sym_binary_expression] = STATE(649),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(649),
    [sym_call_expression] = STATE(649),
    [sym_array_expression] = STATE(649),
    [sym_parenthesized_expression] = STATE(649),
    [sym_tuple_expression] = STATE(649),
    [sym_unit_expression] = STATE(649),
    [sym_struct_expression] = STATE(649),
    [sym_if_expression] = STATE(649),
    [sym_if_let_expression] = STATE(649),
    [sym_match_expression] = STATE(649),
    [sym_while_expression] = STATE(649),
    [sym_while_let_expression] = STATE(649),
    [sym_loop_expression] = STATE(649),
    [sym_for_expression] = STATE(649),
    [sym_closure_expression] = STATE(649),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(649),
    [sym_continue_expression] = STATE(649),
    [sym_index_expression] = STATE(649),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(649),
    [sym_block] = STATE(649),
    [sym__literal] = STATE(649),
    [sym_string_literal] = STATE(649),
    [sym_boolean_literal] = STATE(649),
    [sym_raw_string_literal] = ACTIONS(1275),
    [sym_float_literal] = ACTIONS(1275),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(1275),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1275),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [257] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(650),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(650),
    [sym_macro_invocation] = STATE(650),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(650),
    [sym_unary_expression] = STATE(650),
    [sym_try_expression] = STATE(650),
    [sym_reference_expression] = STATE(650),
    [sym_binary_expression] = STATE(650),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(650),
    [sym_call_expression] = STATE(650),
    [sym_array_expression] = STATE(650),
    [sym_parenthesized_expression] = STATE(650),
    [sym_tuple_expression] = STATE(650),
    [sym_unit_expression] = STATE(650),
    [sym_struct_expression] = STATE(650),
    [sym_if_expression] = STATE(650),
    [sym_if_let_expression] = STATE(650),
    [sym_match_expression] = STATE(650),
    [sym_while_expression] = STATE(650),
    [sym_while_let_expression] = STATE(650),
    [sym_loop_expression] = STATE(650),
    [sym_for_expression] = STATE(650),
    [sym_closure_expression] = STATE(650),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(650),
    [sym_continue_expression] = STATE(650),
    [sym_index_expression] = STATE(650),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(650),
    [sym_block] = STATE(650),
    [sym__literal] = STATE(650),
    [sym_string_literal] = STATE(650),
    [sym_boolean_literal] = STATE(650),
    [sym_raw_string_literal] = ACTIONS(1277),
    [sym_float_literal] = ACTIONS(1277),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(1277),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1277),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [258] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(651),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(651),
    [sym_macro_invocation] = STATE(651),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(651),
    [sym_unary_expression] = STATE(651),
    [sym_try_expression] = STATE(651),
    [sym_reference_expression] = STATE(651),
    [sym_binary_expression] = STATE(651),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(651),
    [sym_call_expression] = STATE(651),
    [sym_array_expression] = STATE(651),
    [sym_parenthesized_expression] = STATE(651),
    [sym_tuple_expression] = STATE(651),
    [sym_unit_expression] = STATE(651),
    [sym_struct_expression] = STATE(651),
    [sym_if_expression] = STATE(651),
    [sym_if_let_expression] = STATE(651),
    [sym_match_expression] = STATE(651),
    [sym_while_expression] = STATE(651),
    [sym_while_let_expression] = STATE(651),
    [sym_loop_expression] = STATE(651),
    [sym_for_expression] = STATE(651),
    [sym_closure_expression] = STATE(651),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(651),
    [sym_continue_expression] = STATE(651),
    [sym_index_expression] = STATE(651),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(651),
    [sym_block] = STATE(651),
    [sym__literal] = STATE(651),
    [sym_string_literal] = STATE(651),
    [sym_boolean_literal] = STATE(651),
    [sym_raw_string_literal] = ACTIONS(1279),
    [sym_float_literal] = ACTIONS(1279),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(1279),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1279),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [259] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1281),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_RPAREN] = ACTIONS(1281),
    [anon_sym_LBRACE] = ACTIONS(1281),
    [anon_sym_RBRACE] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_RBRACK] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_COMMA] = ACTIONS(1281),
    [anon_sym_AMP] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DOT] = ACTIONS(1283),
    [anon_sym_DASH_EQ] = ACTIONS(1281),
    [anon_sym_BANG_EQ] = ACTIONS(1281),
    [anon_sym_STAR_EQ] = ACTIONS(1281),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_SLASH_EQ] = ACTIONS(1281),
    [anon_sym_AMP_AMP] = ACTIONS(1281),
    [anon_sym_AMP_EQ] = ACTIONS(1281),
    [anon_sym_PERCENT] = ACTIONS(1283),
    [anon_sym_PERCENT_EQ] = ACTIONS(1281),
    [anon_sym_CARET] = ACTIONS(1283),
    [anon_sym_CARET_EQ] = ACTIONS(1281),
    [anon_sym_PLUS_EQ] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_LT_LT] = ACTIONS(1283),
    [anon_sym_LT_LT_EQ] = ACTIONS(1281),
    [anon_sym_LT_EQ] = ACTIONS(1281),
    [anon_sym_EQ] = ACTIONS(1283),
    [anon_sym_EQ_EQ] = ACTIONS(1281),
    [anon_sym_GT] = ACTIONS(1283),
    [anon_sym_GT_EQ] = ACTIONS(1281),
    [anon_sym_GT_GT] = ACTIONS(1283),
    [anon_sym_GT_GT_EQ] = ACTIONS(1281),
    [anon_sym_PIPE] = ACTIONS(1283),
    [anon_sym_PIPE_EQ] = ACTIONS(1281),
    [anon_sym_PIPE_PIPE] = ACTIONS(1281),
    [anon_sym_QMARK] = ACTIONS(1281),
    [anon_sym_DOT_DOT] = ACTIONS(1283),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1281),
    [anon_sym_as] = ACTIONS(1281),
    [sym_line_comment] = ACTIONS(7),
  },
  [260] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(652),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(652),
    [sym_macro_invocation] = STATE(652),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(652),
    [sym_unary_expression] = STATE(652),
    [sym_try_expression] = STATE(652),
    [sym_reference_expression] = STATE(652),
    [sym_binary_expression] = STATE(652),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(652),
    [sym_call_expression] = STATE(652),
    [sym_array_expression] = STATE(652),
    [sym_parenthesized_expression] = STATE(652),
    [sym_tuple_expression] = STATE(652),
    [sym_unit_expression] = STATE(652),
    [sym_struct_expression] = STATE(652),
    [sym_if_expression] = STATE(652),
    [sym_if_let_expression] = STATE(652),
    [sym_match_expression] = STATE(652),
    [sym_while_expression] = STATE(652),
    [sym_while_let_expression] = STATE(652),
    [sym_loop_expression] = STATE(652),
    [sym_for_expression] = STATE(652),
    [sym_closure_expression] = STATE(652),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(652),
    [sym_continue_expression] = STATE(652),
    [sym_index_expression] = STATE(652),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(652),
    [sym_block] = STATE(652),
    [sym__literal] = STATE(652),
    [sym_string_literal] = STATE(652),
    [sym_boolean_literal] = STATE(652),
    [sym_raw_string_literal] = ACTIONS(1285),
    [sym_float_literal] = ACTIONS(1285),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(909),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(911),
    [anon_sym_STAR] = ACTIONS(911),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_DASH] = ACTIONS(911),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(911),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(911),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_LT_LT] = ACTIONS(911),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(909),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_EQ_EQ] = ACTIONS(909),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(911),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_as] = ACTIONS(911),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(1285),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1285),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [261] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(652),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(652),
    [sym_macro_invocation] = STATE(652),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(652),
    [sym_unary_expression] = STATE(652),
    [sym_try_expression] = STATE(652),
    [sym_reference_expression] = STATE(652),
    [sym_binary_expression] = STATE(652),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(652),
    [sym_call_expression] = STATE(652),
    [sym_array_expression] = STATE(652),
    [sym_parenthesized_expression] = STATE(652),
    [sym_tuple_expression] = STATE(652),
    [sym_unit_expression] = STATE(652),
    [sym_struct_expression] = STATE(652),
    [sym_if_expression] = STATE(652),
    [sym_if_let_expression] = STATE(652),
    [sym_match_expression] = STATE(652),
    [sym_while_expression] = STATE(652),
    [sym_while_let_expression] = STATE(652),
    [sym_loop_expression] = STATE(652),
    [sym_for_expression] = STATE(652),
    [sym_closure_expression] = STATE(652),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(652),
    [sym_continue_expression] = STATE(652),
    [sym_index_expression] = STATE(652),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(652),
    [sym_block] = STATE(652),
    [sym__literal] = STATE(652),
    [sym_string_literal] = STATE(652),
    [sym_boolean_literal] = STATE(652),
    [sym_raw_string_literal] = ACTIONS(1285),
    [sym_float_literal] = ACTIONS(1285),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(1285),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1285),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [262] = {
    [sym_function_modifiers] = STATE(665),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(666),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(667),
    [sym_array_type] = STATE(666),
    [sym_function_type] = STATE(666),
    [sym_tuple_type] = STATE(666),
    [sym_unit_type] = STATE(666),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(666),
    [sym_reference_type] = STATE(666),
    [sym_pointer_type] = STATE(666),
    [sym_empty_type] = STATE(666),
    [sym_dynamic_type] = STATE(666),
    [sym_macro_invocation] = STATE(666),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(671),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1291),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1295),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1301),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1305),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [263] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1311),
    [anon_sym_RPAREN] = ACTIONS(1311),
    [anon_sym_LBRACE] = ACTIONS(1311),
    [anon_sym_RBRACE] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_RBRACK] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_STAR] = ACTIONS(1313),
    [anon_sym_COMMA] = ACTIONS(1311),
    [anon_sym_AMP] = ACTIONS(1313),
    [anon_sym_DASH] = ACTIONS(1313),
    [anon_sym_DOT] = ACTIONS(1313),
    [anon_sym_DASH_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(1311),
    [anon_sym_STAR_EQ] = ACTIONS(1311),
    [anon_sym_SLASH] = ACTIONS(1313),
    [anon_sym_SLASH_EQ] = ACTIONS(1311),
    [anon_sym_AMP_AMP] = ACTIONS(1311),
    [anon_sym_AMP_EQ] = ACTIONS(1311),
    [anon_sym_PERCENT] = ACTIONS(1313),
    [anon_sym_PERCENT_EQ] = ACTIONS(1311),
    [anon_sym_CARET] = ACTIONS(1313),
    [anon_sym_CARET_EQ] = ACTIONS(1311),
    [anon_sym_PLUS_EQ] = ACTIONS(1311),
    [anon_sym_LT] = ACTIONS(1313),
    [anon_sym_LT_LT] = ACTIONS(1313),
    [anon_sym_LT_LT_EQ] = ACTIONS(1311),
    [anon_sym_LT_EQ] = ACTIONS(1311),
    [anon_sym_EQ] = ACTIONS(1313),
    [anon_sym_EQ_EQ] = ACTIONS(1311),
    [anon_sym_GT] = ACTIONS(1313),
    [anon_sym_GT_EQ] = ACTIONS(1311),
    [anon_sym_GT_GT] = ACTIONS(1313),
    [anon_sym_GT_GT_EQ] = ACTIONS(1311),
    [anon_sym_PIPE] = ACTIONS(1313),
    [anon_sym_PIPE_EQ] = ACTIONS(1311),
    [anon_sym_PIPE_PIPE] = ACTIONS(1311),
    [anon_sym_QMARK] = ACTIONS(1311),
    [anon_sym_DOT_DOT] = ACTIONS(1313),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1311),
    [anon_sym_as] = ACTIONS(1311),
    [sym_line_comment] = ACTIONS(7),
  },
  [264] = {
    [sym_type_arguments] = STATE(672),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(1139),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1141),
  },
  [265] = {
    [sym_function_modifiers] = STATE(677),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(678),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(679),
    [sym_array_type] = STATE(678),
    [sym_function_type] = STATE(678),
    [sym_tuple_type] = STATE(678),
    [sym_unit_type] = STATE(678),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(678),
    [sym_reference_type] = STATE(678),
    [sym_pointer_type] = STATE(678),
    [sym_empty_type] = STATE(678),
    [sym_dynamic_type] = STATE(678),
    [sym_macro_invocation] = STATE(678),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(680),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1315),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1317),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1319),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1321),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [266] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1323),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(467),
    [anon_sym_BANG_EQ] = ACTIONS(469),
    [anon_sym_STAR_EQ] = ACTIONS(467),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(467),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_AMP_EQ] = ACTIONS(467),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(467),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_CARET_EQ] = ACTIONS(467),
    [anon_sym_PLUS_EQ] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT_LT_EQ] = ACTIONS(467),
    [anon_sym_LT_EQ] = ACTIONS(469),
    [anon_sym_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_EQ] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_PIPE_EQ] = ACTIONS(467),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(489),
    [anon_sym_as] = ACTIONS(491),
    [sym_line_comment] = ACTIONS(7),
  },
  [267] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(1325),
    [anon_sym_loop] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(7),
  },
  [268] = {
    [sym_type_arguments] = STATE(684),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(1139),
    [sym_line_comment] = ACTIONS(7),
  },
  [269] = {
    [sym__statement] = STATE(269),
    [sym_empty_statement] = STATE(269),
    [sym__expression_statement] = STATE(269),
    [sym_macro_definition] = STATE(269),
    [sym_attribute_item] = STATE(269),
    [sym_inner_attribute_item] = STATE(269),
    [sym_mod_item] = STATE(269),
    [sym_foreign_mod_item] = STATE(269),
    [sym_struct_item] = STATE(269),
    [sym_union_item] = STATE(269),
    [sym_enum_item] = STATE(269),
    [sym_extern_crate_declaration] = STATE(269),
    [sym_const_item] = STATE(269),
    [sym_static_item] = STATE(269),
    [sym_type_item] = STATE(269),
    [sym_function_item] = STATE(269),
    [sym_function_signature_item] = STATE(269),
    [sym_function_modifiers] = STATE(47),
    [sym_impl_item] = STATE(269),
    [sym_trait_item] = STATE(269),
    [sym_associated_type] = STATE(269),
    [sym_let_declaration] = STATE(269),
    [sym_use_declaration] = STATE(269),
    [sym_extern_modifier] = STATE(48),
    [sym_visibility_modifier] = STATE(49),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(52),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(52),
    [sym_macro_invocation] = STATE(53),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(52),
    [sym_unary_expression] = STATE(52),
    [sym_try_expression] = STATE(52),
    [sym_reference_expression] = STATE(52),
    [sym_binary_expression] = STATE(52),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(52),
    [sym_call_expression] = STATE(52),
    [sym_array_expression] = STATE(52),
    [sym_parenthesized_expression] = STATE(52),
    [sym_tuple_expression] = STATE(52),
    [sym_unit_expression] = STATE(52),
    [sym_struct_expression] = STATE(52),
    [sym_if_expression] = STATE(57),
    [sym_if_let_expression] = STATE(57),
    [sym_match_expression] = STATE(57),
    [sym_while_expression] = STATE(57),
    [sym_while_let_expression] = STATE(57),
    [sym_loop_expression] = STATE(57),
    [sym_for_expression] = STATE(57),
    [sym_closure_expression] = STATE(52),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(59),
    [sym_break_expression] = STATE(52),
    [sym_continue_expression] = STATE(52),
    [sym_index_expression] = STATE(52),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(57),
    [sym_block] = STATE(57),
    [sym__literal] = STATE(52),
    [sym_string_literal] = STATE(52),
    [sym_boolean_literal] = STATE(52),
    [aux_sym_source_file_repeat1] = STATE(269),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_raw_string_literal] = ACTIONS(1331),
    [sym_float_literal] = ACTIONS(1331),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(1334),
    [anon_sym_SEMI] = ACTIONS(1336),
    [anon_sym_macro_rules_BANG] = ACTIONS(1339),
    [anon_sym_LPAREN] = ACTIONS(1342),
    [anon_sym_LBRACE] = ACTIONS(1345),
    [anon_sym_LBRACK] = ACTIONS(1348),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_u8] = ACTIONS(1354),
    [anon_sym_i8] = ACTIONS(1354),
    [anon_sym_u16] = ACTIONS(1354),
    [anon_sym_i16] = ACTIONS(1354),
    [anon_sym_u32] = ACTIONS(1354),
    [anon_sym_i32] = ACTIONS(1354),
    [anon_sym_u64] = ACTIONS(1354),
    [anon_sym_i64] = ACTIONS(1354),
    [anon_sym_u128] = ACTIONS(1354),
    [anon_sym_i128] = ACTIONS(1354),
    [anon_sym_isize] = ACTIONS(1354),
    [anon_sym_usize] = ACTIONS(1354),
    [anon_sym_f32] = ACTIONS(1354),
    [anon_sym_f64] = ACTIONS(1354),
    [anon_sym_bool] = ACTIONS(1354),
    [anon_sym_str] = ACTIONS(1354),
    [anon_sym_char] = ACTIONS(1354),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_DASH] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1360),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_POUND] = ACTIONS(1363),
    [anon_sym_LT] = ACTIONS(1366),
    [anon_sym_PIPE] = ACTIONS(1369),
    [anon_sym_SQUOTE] = ACTIONS(1372),
    [anon_sym_DOT_DOT] = ACTIONS(1375),
    [anon_sym_break] = ACTIONS(1378),
    [anon_sym_const] = ACTIONS(1381),
    [anon_sym_continue] = ACTIONS(1384),
    [anon_sym_default] = ACTIONS(1387),
    [anon_sym_enum] = ACTIONS(1390),
    [anon_sym_fn] = ACTIONS(1393),
    [anon_sym_for] = ACTIONS(1396),
    [anon_sym_if] = ACTIONS(1399),
    [anon_sym_impl] = ACTIONS(1402),
    [anon_sym_let] = ACTIONS(1405),
    [anon_sym_loop] = ACTIONS(1408),
    [anon_sym_match] = ACTIONS(1411),
    [anon_sym_mod] = ACTIONS(1414),
    [anon_sym_pub] = ACTIONS(1417),
    [anon_sym_return] = ACTIONS(1420),
    [anon_sym_static] = ACTIONS(1423),
    [anon_sym_struct] = ACTIONS(1426),
    [anon_sym_trait] = ACTIONS(1429),
    [anon_sym_type] = ACTIONS(1432),
    [anon_sym_union] = ACTIONS(1435),
    [anon_sym_unsafe] = ACTIONS(1438),
    [anon_sym_use] = ACTIONS(1441),
    [anon_sym_while] = ACTIONS(1444),
    [anon_sym_extern] = ACTIONS(1447),
    [anon_sym_move] = ACTIONS(1450),
    [sym_integer_literal] = ACTIONS(1331),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(1453),
    [sym_char_literal] = ACTIONS(1331),
    [anon_sym_true] = ACTIONS(1456),
    [anon_sym_false] = ACTIONS(1456),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1459),
    [sym_self] = ACTIONS(1462),
    [sym_super] = ACTIONS(1465),
    [sym_crate] = ACTIONS(1465),
    [sym_metavariable] = ACTIONS(1468),
  },
  [270] = {
    [sym_string_literal] = STATE(217),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(393),
    [anon_sym_default] = ACTIONS(393),
    [anon_sym_fn] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(393),
    [anon_sym_extern] = ACTIONS(393),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(7),
  },
  [271] = {
    [sym_extern_modifier] = STATE(271),
    [aux_sym_function_modifiers_repeat1] = STATE(271),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(1471),
    [anon_sym_default] = ACTIONS(1471),
    [anon_sym_fn] = ACTIONS(1474),
    [anon_sym_unsafe] = ACTIONS(1471),
    [anon_sym_extern] = ACTIONS(1476),
    [sym_line_comment] = ACTIONS(7),
  },
  [272] = {
    [sym_macro_rule] = STATE(689),
    [sym_token_tree_pattern] = STATE(690),
    [aux_sym_macro_definition_repeat1] = STATE(691),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_RPAREN] = ACTIONS(1481),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_LBRACK] = ACTIONS(1485),
    [sym_line_comment] = ACTIONS(7),
  },
  [273] = {
    [sym_macro_rule] = STATE(693),
    [sym_token_tree_pattern] = STATE(690),
    [aux_sym_macro_definition_repeat1] = STATE(694),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_RBRACE] = ACTIONS(1487),
    [anon_sym_LBRACK] = ACTIONS(1485),
    [sym_line_comment] = ACTIONS(7),
  },
  [274] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(597),
    [anon_sym_macro_rules_BANG] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_RPAREN] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(597),
    [anon_sym_RBRACE] = ACTIONS(597),
    [anon_sym_LBRACK] = ACTIONS(597),
    [anon_sym_RBRACK] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(599),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_COMMA] = ACTIONS(597),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_DASH] = ACTIONS(599),
    [anon_sym_DOT] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(597),
    [anon_sym_BANG_EQ] = ACTIONS(597),
    [anon_sym_STAR_EQ] = ACTIONS(597),
    [anon_sym_SLASH] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(597),
    [anon_sym_AMP_AMP] = ACTIONS(597),
    [anon_sym_AMP_EQ] = ACTIONS(597),
    [anon_sym_POUND] = ACTIONS(597),
    [anon_sym_PERCENT] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(597),
    [anon_sym_CARET] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(597),
    [anon_sym_PLUS_EQ] = ACTIONS(597),
    [anon_sym_LT] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(597),
    [anon_sym_LT_EQ] = ACTIONS(597),
    [anon_sym_EQ] = ACTIONS(599),
    [anon_sym_EQ_EQ] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(599),
    [anon_sym_GT_EQ] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(597),
    [anon_sym_PIPE] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(597),
    [anon_sym_PIPE_PIPE] = ACTIONS(597),
    [anon_sym_QMARK] = ACTIONS(597),
    [anon_sym_DOT_DOT] = ACTIONS(599),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(597),
    [anon_sym_as] = ACTIONS(599),
    [anon_sym_const] = ACTIONS(599),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_enum] = ACTIONS(599),
    [anon_sym_fn] = ACTIONS(599),
    [anon_sym_impl] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(599),
    [anon_sym_mod] = ACTIONS(599),
    [anon_sym_pub] = ACTIONS(599),
    [anon_sym_static] = ACTIONS(599),
    [anon_sym_struct] = ACTIONS(599),
    [anon_sym_trait] = ACTIONS(599),
    [anon_sym_type] = ACTIONS(599),
    [anon_sym_union] = ACTIONS(599),
    [anon_sym_unsafe] = ACTIONS(599),
    [anon_sym_use] = ACTIONS(599),
    [anon_sym_extern] = ACTIONS(599),
    [anon_sym_else] = ACTIONS(599),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(599),
  },
  [275] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(1489),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(623),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(623),
    [anon_sym_PLUS_EQ] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(623),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(643),
    [anon_sym_as] = ACTIONS(645),
    [sym_line_comment] = ACTIONS(7),
  },
  [276] = {
    [sym__statement] = STATE(332),
    [sym_empty_statement] = STATE(332),
    [sym__expression_statement] = STATE(332),
    [sym_macro_definition] = STATE(332),
    [sym_attribute_item] = STATE(332),
    [sym_inner_attribute_item] = STATE(332),
    [sym_mod_item] = STATE(332),
    [sym_foreign_mod_item] = STATE(332),
    [sym_struct_item] = STATE(332),
    [sym_union_item] = STATE(332),
    [sym_enum_item] = STATE(332),
    [sym_extern_crate_declaration] = STATE(332),
    [sym_const_item] = STATE(332),
    [sym_static_item] = STATE(332),
    [sym_type_item] = STATE(332),
    [sym_function_item] = STATE(332),
    [sym_function_signature_item] = STATE(332),
    [sym_function_modifiers] = STATE(47),
    [sym_impl_item] = STATE(332),
    [sym_trait_item] = STATE(332),
    [sym_associated_type] = STATE(332),
    [sym_let_declaration] = STATE(332),
    [sym_use_declaration] = STATE(332),
    [sym_extern_modifier] = STATE(48),
    [sym_visibility_modifier] = STATE(49),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(696),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(696),
    [sym_macro_invocation] = STATE(53),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(696),
    [sym_unary_expression] = STATE(696),
    [sym_try_expression] = STATE(696),
    [sym_reference_expression] = STATE(696),
    [sym_binary_expression] = STATE(696),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(696),
    [sym_call_expression] = STATE(696),
    [sym_array_expression] = STATE(696),
    [sym_parenthesized_expression] = STATE(696),
    [sym_tuple_expression] = STATE(696),
    [sym_unit_expression] = STATE(696),
    [sym_struct_expression] = STATE(696),
    [sym_if_expression] = STATE(57),
    [sym_if_let_expression] = STATE(57),
    [sym_match_expression] = STATE(57),
    [sym_while_expression] = STATE(57),
    [sym_while_let_expression] = STATE(57),
    [sym_loop_expression] = STATE(57),
    [sym_for_expression] = STATE(57),
    [sym_closure_expression] = STATE(696),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(59),
    [sym_break_expression] = STATE(696),
    [sym_continue_expression] = STATE(696),
    [sym_index_expression] = STATE(696),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(57),
    [sym_block] = STATE(57),
    [sym__literal] = STATE(696),
    [sym_string_literal] = STATE(696),
    [sym_boolean_literal] = STATE(696),
    [aux_sym_source_file_repeat1] = STATE(332),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_raw_string_literal] = ACTIONS(1491),
    [sym_float_literal] = ACTIONS(1491),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1489),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_POUND] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(1491),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(93),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [277] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(361),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(361),
    [sym_macro_invocation] = STATE(361),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(361),
    [sym_unary_expression] = STATE(361),
    [sym_try_expression] = STATE(361),
    [sym_reference_expression] = STATE(361),
    [sym_binary_expression] = STATE(361),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(361),
    [sym_call_expression] = STATE(361),
    [sym_array_expression] = STATE(361),
    [sym_parenthesized_expression] = STATE(361),
    [sym_tuple_expression] = STATE(361),
    [sym_unit_expression] = STATE(361),
    [sym_struct_expression] = STATE(361),
    [sym_if_expression] = STATE(361),
    [sym_if_let_expression] = STATE(361),
    [sym_match_expression] = STATE(361),
    [sym_while_expression] = STATE(361),
    [sym_while_let_expression] = STATE(361),
    [sym_loop_expression] = STATE(361),
    [sym_for_expression] = STATE(361),
    [sym_closure_expression] = STATE(361),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(361),
    [sym_continue_expression] = STATE(361),
    [sym_index_expression] = STATE(361),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(361),
    [sym_block] = STATE(361),
    [sym__literal] = STATE(361),
    [sym_string_literal] = STATE(361),
    [sym_boolean_literal] = STATE(361),
    [sym_raw_string_literal] = ACTIONS(715),
    [sym_float_literal] = ACTIONS(715),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(715),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(715),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [278] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_BANG_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH] = ACTIONS(563),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(563),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(577),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(577),
    [anon_sym_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_as] = ACTIONS(909),
    [sym_line_comment] = ACTIONS(7),
  },
  [279] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_in] = ACTIONS(1493),
    [sym_line_comment] = ACTIONS(7),
  },
  [280] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(698),
    [sym_tuple_pattern] = STATE(698),
    [sym_tuple_struct_pattern] = STATE(698),
    [sym_struct_pattern] = STATE(698),
    [sym_remaining_field_pattern] = STATE(698),
    [sym_mut_pattern] = STATE(698),
    [sym_ref_pattern] = STATE(698),
    [sym_captured_pattern] = STATE(698),
    [sym_reference_pattern] = STATE(698),
    [sym__literal] = STATE(698),
    [sym_string_literal] = STATE(698),
    [sym_boolean_literal] = STATE(698),
    [sym_raw_string_literal] = ACTIONS(1495),
    [sym_float_literal] = ACTIONS(1495),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(1497),
    [anon_sym_AMP] = ACTIONS(955),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(957),
    [anon_sym_ref] = ACTIONS(959),
    [sym_integer_literal] = ACTIONS(1495),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(1495),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(961),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [281] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(699),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [282] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1031),
    [anon_sym_LPAREN] = ACTIONS(1031),
    [anon_sym_RPAREN] = ACTIONS(1031),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_RBRACE] = ACTIONS(1031),
    [anon_sym_LBRACK] = ACTIONS(1031),
    [anon_sym_RBRACK] = ACTIONS(1031),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_STAR] = ACTIONS(1033),
    [anon_sym_COMMA] = ACTIONS(1031),
    [anon_sym_AMP] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_DOT] = ACTIONS(1033),
    [anon_sym_DASH_EQ] = ACTIONS(1031),
    [anon_sym_BANG_EQ] = ACTIONS(1031),
    [anon_sym_STAR_EQ] = ACTIONS(1031),
    [anon_sym_SLASH] = ACTIONS(1033),
    [anon_sym_SLASH_EQ] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(1031),
    [anon_sym_AMP_EQ] = ACTIONS(1031),
    [anon_sym_PERCENT] = ACTIONS(1033),
    [anon_sym_PERCENT_EQ] = ACTIONS(1031),
    [anon_sym_CARET] = ACTIONS(1033),
    [anon_sym_CARET_EQ] = ACTIONS(1031),
    [anon_sym_PLUS_EQ] = ACTIONS(1031),
    [anon_sym_LT] = ACTIONS(1033),
    [anon_sym_LT_LT] = ACTIONS(1033),
    [anon_sym_LT_LT_EQ] = ACTIONS(1031),
    [anon_sym_LT_EQ] = ACTIONS(1031),
    [anon_sym_EQ] = ACTIONS(1033),
    [anon_sym_EQ_EQ] = ACTIONS(1031),
    [anon_sym_GT] = ACTIONS(1033),
    [anon_sym_GT_EQ] = ACTIONS(1031),
    [anon_sym_GT_GT] = ACTIONS(1033),
    [anon_sym_GT_GT_EQ] = ACTIONS(1031),
    [anon_sym_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_EQ] = ACTIONS(1031),
    [anon_sym_PIPE_PIPE] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1031),
    [anon_sym_DOT_DOT] = ACTIONS(1033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1031),
    [anon_sym_as] = ACTIONS(1031),
    [sym_line_comment] = ACTIONS(7),
  },
  [283] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(1499),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [284] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(1043),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(1043),
    [anon_sym_BANG_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(1043),
    [anon_sym_SLASH] = ACTIONS(563),
    [anon_sym_SLASH_EQ] = ACTIONS(1043),
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(1043),
    [anon_sym_PERCENT] = ACTIONS(563),
    [anon_sym_PERCENT_EQ] = ACTIONS(1043),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_CARET_EQ] = ACTIONS(1043),
    [anon_sym_PLUS_EQ] = ACTIONS(1043),
    [anon_sym_LT] = ACTIONS(577),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_EQ] = ACTIONS(1043),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(577),
    [anon_sym_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_GT_GT_EQ] = ACTIONS(1043),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_PIPE_EQ] = ACTIONS(1043),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(589),
    [anon_sym_as] = ACTIONS(1043),
    [sym_line_comment] = ACTIONS(7),
  },
  [285] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1071),
    [anon_sym_RPAREN] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(1071),
    [anon_sym_RBRACK] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1073),
    [anon_sym_STAR] = ACTIONS(1073),
    [anon_sym_COMMA] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_DASH] = ACTIONS(1073),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_DASH_EQ] = ACTIONS(1071),
    [anon_sym_BANG_EQ] = ACTIONS(1071),
    [anon_sym_STAR_EQ] = ACTIONS(1071),
    [anon_sym_SLASH] = ACTIONS(1073),
    [anon_sym_SLASH_EQ] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_AMP_EQ] = ACTIONS(1071),
    [anon_sym_PERCENT] = ACTIONS(1073),
    [anon_sym_PERCENT_EQ] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1073),
    [anon_sym_CARET_EQ] = ACTIONS(1071),
    [anon_sym_PLUS_EQ] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_LT_LT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(1071),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_GT_GT_EQ] = ACTIONS(1071),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_PIPE_EQ] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_QMARK] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(1073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1071),
    [anon_sym_as] = ACTIONS(1071),
    [sym_line_comment] = ACTIONS(7),
  },
  [286] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(701),
    [sym_tuple_pattern] = STATE(701),
    [sym_tuple_struct_pattern] = STATE(701),
    [sym_struct_pattern] = STATE(701),
    [sym_remaining_field_pattern] = STATE(701),
    [sym_mut_pattern] = STATE(701),
    [sym_ref_pattern] = STATE(701),
    [sym_captured_pattern] = STATE(701),
    [sym_reference_pattern] = STATE(701),
    [sym__literal] = STATE(701),
    [sym_string_literal] = STATE(701),
    [sym_boolean_literal] = STATE(701),
    [sym_raw_string_literal] = ACTIONS(1501),
    [sym_float_literal] = ACTIONS(1501),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(1503),
    [anon_sym_AMP] = ACTIONS(955),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(957),
    [anon_sym_ref] = ACTIONS(959),
    [sym_integer_literal] = ACTIONS(1501),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(1501),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(961),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [287] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(702),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [288] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(703),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(703),
    [sym_macro_invocation] = STATE(703),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(703),
    [sym_unary_expression] = STATE(703),
    [sym_try_expression] = STATE(703),
    [sym_reference_expression] = STATE(703),
    [sym_binary_expression] = STATE(703),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(703),
    [sym_call_expression] = STATE(703),
    [sym_array_expression] = STATE(703),
    [sym_parenthesized_expression] = STATE(703),
    [sym_tuple_expression] = STATE(703),
    [sym_unit_expression] = STATE(703),
    [sym_struct_expression] = STATE(703),
    [sym_if_expression] = STATE(703),
    [sym_if_let_expression] = STATE(703),
    [sym_match_expression] = STATE(703),
    [sym_while_expression] = STATE(703),
    [sym_while_let_expression] = STATE(703),
    [sym_loop_expression] = STATE(703),
    [sym_for_expression] = STATE(703),
    [sym_closure_expression] = STATE(703),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(703),
    [sym_continue_expression] = STATE(703),
    [sym_index_expression] = STATE(703),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(703),
    [sym_block] = STATE(703),
    [sym__literal] = STATE(703),
    [sym_string_literal] = STATE(703),
    [sym_boolean_literal] = STATE(703),
    [sym_raw_string_literal] = ACTIONS(1505),
    [sym_float_literal] = ACTIONS(1505),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(539),
    [anon_sym_DASH_GT] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(1505),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1505),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [289] = {
    [sym_token_tree] = STATE(707),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1507),
    [anon_sym_LBRACE] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_line_comment] = ACTIONS(7),
  },
  [290] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1513),
    [anon_sym_LPAREN] = ACTIONS(1513),
    [anon_sym_RPAREN] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1513),
    [anon_sym_RBRACE] = ACTIONS(1513),
    [anon_sym_LBRACK] = ACTIONS(1513),
    [anon_sym_RBRACK] = ACTIONS(1513),
    [anon_sym_PLUS] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(1515),
    [anon_sym_COMMA] = ACTIONS(1513),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_DASH] = ACTIONS(1515),
    [anon_sym_DOT] = ACTIONS(1515),
    [anon_sym_DASH_EQ] = ACTIONS(1513),
    [anon_sym_BANG_EQ] = ACTIONS(1513),
    [anon_sym_STAR_EQ] = ACTIONS(1513),
    [anon_sym_SLASH] = ACTIONS(1515),
    [anon_sym_SLASH_EQ] = ACTIONS(1513),
    [anon_sym_AMP_AMP] = ACTIONS(1513),
    [anon_sym_AMP_EQ] = ACTIONS(1513),
    [anon_sym_PERCENT] = ACTIONS(1515),
    [anon_sym_PERCENT_EQ] = ACTIONS(1513),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_CARET_EQ] = ACTIONS(1513),
    [anon_sym_PLUS_EQ] = ACTIONS(1513),
    [anon_sym_LT] = ACTIONS(1515),
    [anon_sym_LT_LT] = ACTIONS(1515),
    [anon_sym_LT_LT_EQ] = ACTIONS(1513),
    [anon_sym_LT_EQ] = ACTIONS(1513),
    [anon_sym_EQ] = ACTIONS(1515),
    [anon_sym_EQ_EQ] = ACTIONS(1513),
    [anon_sym_GT] = ACTIONS(1515),
    [anon_sym_GT_EQ] = ACTIONS(1513),
    [anon_sym_GT_GT] = ACTIONS(1515),
    [anon_sym_GT_GT_EQ] = ACTIONS(1513),
    [anon_sym_PIPE] = ACTIONS(1515),
    [anon_sym_PIPE_EQ] = ACTIONS(1513),
    [anon_sym_PIPE_PIPE] = ACTIONS(1513),
    [anon_sym_QMARK] = ACTIONS(1513),
    [anon_sym_DOT_DOT] = ACTIONS(1515),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1513),
    [anon_sym_as] = ACTIONS(1513),
    [sym_line_comment] = ACTIONS(7),
  },
  [291] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(708),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(708),
    [sym_macro_invocation] = STATE(708),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(708),
    [sym_unary_expression] = STATE(708),
    [sym_try_expression] = STATE(708),
    [sym_reference_expression] = STATE(708),
    [sym_binary_expression] = STATE(708),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(708),
    [sym_call_expression] = STATE(708),
    [sym_array_expression] = STATE(708),
    [sym_parenthesized_expression] = STATE(708),
    [sym_tuple_expression] = STATE(708),
    [sym_unit_expression] = STATE(708),
    [sym_struct_expression] = STATE(708),
    [sym_if_expression] = STATE(708),
    [sym_if_let_expression] = STATE(708),
    [sym_match_expression] = STATE(708),
    [sym_while_expression] = STATE(708),
    [sym_while_let_expression] = STATE(708),
    [sym_loop_expression] = STATE(708),
    [sym_for_expression] = STATE(708),
    [sym_closure_expression] = STATE(708),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(708),
    [sym_continue_expression] = STATE(708),
    [sym_index_expression] = STATE(708),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(708),
    [sym_block] = STATE(708),
    [sym__literal] = STATE(708),
    [sym_string_literal] = STATE(708),
    [sym_boolean_literal] = STATE(708),
    [sym_raw_string_literal] = ACTIONS(1517),
    [sym_float_literal] = ACTIONS(1517),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(1517),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1517),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [292] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(640),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(640),
    [sym_macro_invocation] = STATE(640),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(640),
    [sym_unary_expression] = STATE(640),
    [sym_try_expression] = STATE(640),
    [sym_reference_expression] = STATE(640),
    [sym_binary_expression] = STATE(640),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(640),
    [sym_call_expression] = STATE(640),
    [sym_array_expression] = STATE(640),
    [sym_parenthesized_expression] = STATE(640),
    [sym_tuple_expression] = STATE(640),
    [sym_unit_expression] = STATE(640),
    [sym_struct_expression] = STATE(640),
    [sym_if_expression] = STATE(640),
    [sym_if_let_expression] = STATE(640),
    [sym_match_expression] = STATE(640),
    [sym_while_expression] = STATE(640),
    [sym_while_let_expression] = STATE(640),
    [sym_loop_expression] = STATE(640),
    [sym_for_expression] = STATE(640),
    [sym_closure_expression] = STATE(640),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(640),
    [sym_continue_expression] = STATE(640),
    [sym_index_expression] = STATE(640),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(640),
    [sym_block] = STATE(640),
    [sym__literal] = STATE(640),
    [sym_string_literal] = STATE(640),
    [sym_boolean_literal] = STATE(640),
    [sym_raw_string_literal] = ACTIONS(1257),
    [sym_float_literal] = ACTIONS(1257),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(1257),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1257),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [293] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(710),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(710),
    [sym_macro_invocation] = STATE(710),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(710),
    [sym_unary_expression] = STATE(710),
    [sym_try_expression] = STATE(710),
    [sym_reference_expression] = STATE(710),
    [sym_binary_expression] = STATE(710),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(710),
    [sym_call_expression] = STATE(710),
    [sym_array_expression] = STATE(710),
    [sym_parenthesized_expression] = STATE(710),
    [sym_tuple_expression] = STATE(710),
    [sym_unit_expression] = STATE(710),
    [sym_struct_expression] = STATE(710),
    [sym_if_expression] = STATE(710),
    [sym_if_let_expression] = STATE(710),
    [sym_match_expression] = STATE(710),
    [sym_while_expression] = STATE(710),
    [sym_while_let_expression] = STATE(710),
    [sym_loop_expression] = STATE(710),
    [sym_for_expression] = STATE(710),
    [sym_closure_expression] = STATE(710),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(710),
    [sym_continue_expression] = STATE(710),
    [sym_index_expression] = STATE(710),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(710),
    [sym_block] = STATE(710),
    [sym__literal] = STATE(710),
    [sym_string_literal] = STATE(710),
    [sym_boolean_literal] = STATE(710),
    [aux_sym_tuple_expression_repeat1] = STATE(711),
    [sym_raw_string_literal] = ACTIONS(1519),
    [sym_float_literal] = ACTIONS(1519),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(1519),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1519),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [294] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(712),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(712),
    [sym_macro_invocation] = STATE(712),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(712),
    [sym_unary_expression] = STATE(712),
    [sym_try_expression] = STATE(712),
    [sym_reference_expression] = STATE(712),
    [sym_binary_expression] = STATE(712),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(712),
    [sym_call_expression] = STATE(712),
    [sym_array_expression] = STATE(712),
    [sym_parenthesized_expression] = STATE(712),
    [sym_tuple_expression] = STATE(712),
    [sym_unit_expression] = STATE(712),
    [sym_struct_expression] = STATE(712),
    [sym_if_expression] = STATE(712),
    [sym_if_let_expression] = STATE(712),
    [sym_match_expression] = STATE(712),
    [sym_while_expression] = STATE(712),
    [sym_while_let_expression] = STATE(712),
    [sym_loop_expression] = STATE(712),
    [sym_for_expression] = STATE(712),
    [sym_closure_expression] = STATE(712),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(712),
    [sym_continue_expression] = STATE(712),
    [sym_index_expression] = STATE(712),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(712),
    [sym_block] = STATE(712),
    [sym__literal] = STATE(712),
    [sym_string_literal] = STATE(712),
    [sym_boolean_literal] = STATE(712),
    [sym_raw_string_literal] = ACTIONS(1523),
    [sym_float_literal] = ACTIONS(1523),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(1523),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1523),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [295] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(713),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(713),
    [sym_macro_invocation] = STATE(713),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(713),
    [sym_unary_expression] = STATE(713),
    [sym_try_expression] = STATE(713),
    [sym_reference_expression] = STATE(713),
    [sym_binary_expression] = STATE(713),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(713),
    [sym_call_expression] = STATE(713),
    [sym_array_expression] = STATE(713),
    [sym_parenthesized_expression] = STATE(713),
    [sym_tuple_expression] = STATE(713),
    [sym_unit_expression] = STATE(713),
    [sym_struct_expression] = STATE(713),
    [sym_if_expression] = STATE(713),
    [sym_if_let_expression] = STATE(713),
    [sym_match_expression] = STATE(713),
    [sym_while_expression] = STATE(713),
    [sym_while_let_expression] = STATE(713),
    [sym_loop_expression] = STATE(713),
    [sym_for_expression] = STATE(713),
    [sym_closure_expression] = STATE(713),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(713),
    [sym_continue_expression] = STATE(713),
    [sym_index_expression] = STATE(713),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(713),
    [sym_block] = STATE(713),
    [sym__literal] = STATE(713),
    [sym_string_literal] = STATE(713),
    [sym_boolean_literal] = STATE(713),
    [sym_raw_string_literal] = ACTIONS(1525),
    [sym_float_literal] = ACTIONS(1525),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(1525),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1525),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [296] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(714),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(714),
    [sym_macro_invocation] = STATE(714),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(714),
    [sym_unary_expression] = STATE(714),
    [sym_try_expression] = STATE(714),
    [sym_reference_expression] = STATE(714),
    [sym_binary_expression] = STATE(714),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(714),
    [sym_call_expression] = STATE(714),
    [sym_array_expression] = STATE(714),
    [sym_parenthesized_expression] = STATE(714),
    [sym_tuple_expression] = STATE(714),
    [sym_unit_expression] = STATE(714),
    [sym_struct_expression] = STATE(714),
    [sym_if_expression] = STATE(714),
    [sym_if_let_expression] = STATE(714),
    [sym_match_expression] = STATE(714),
    [sym_while_expression] = STATE(714),
    [sym_while_let_expression] = STATE(714),
    [sym_loop_expression] = STATE(714),
    [sym_for_expression] = STATE(714),
    [sym_closure_expression] = STATE(714),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(714),
    [sym_continue_expression] = STATE(714),
    [sym_index_expression] = STATE(714),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(714),
    [sym_block] = STATE(714),
    [sym__literal] = STATE(714),
    [sym_string_literal] = STATE(714),
    [sym_boolean_literal] = STATE(714),
    [sym_raw_string_literal] = ACTIONS(1527),
    [sym_float_literal] = ACTIONS(1527),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(1527),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [297] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(715),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(715),
    [sym_macro_invocation] = STATE(715),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(715),
    [sym_unary_expression] = STATE(715),
    [sym_try_expression] = STATE(715),
    [sym_reference_expression] = STATE(715),
    [sym_binary_expression] = STATE(715),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(715),
    [sym_call_expression] = STATE(715),
    [sym_array_expression] = STATE(715),
    [sym_parenthesized_expression] = STATE(715),
    [sym_tuple_expression] = STATE(715),
    [sym_unit_expression] = STATE(715),
    [sym_struct_expression] = STATE(715),
    [sym_if_expression] = STATE(715),
    [sym_if_let_expression] = STATE(715),
    [sym_match_expression] = STATE(715),
    [sym_while_expression] = STATE(715),
    [sym_while_let_expression] = STATE(715),
    [sym_loop_expression] = STATE(715),
    [sym_for_expression] = STATE(715),
    [sym_closure_expression] = STATE(715),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(715),
    [sym_continue_expression] = STATE(715),
    [sym_index_expression] = STATE(715),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(715),
    [sym_block] = STATE(715),
    [sym__literal] = STATE(715),
    [sym_string_literal] = STATE(715),
    [sym_boolean_literal] = STATE(715),
    [sym_raw_string_literal] = ACTIONS(1529),
    [sym_float_literal] = ACTIONS(1529),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(1529),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1529),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [298] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(716),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(716),
    [sym_macro_invocation] = STATE(716),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(716),
    [sym_unary_expression] = STATE(716),
    [sym_try_expression] = STATE(716),
    [sym_reference_expression] = STATE(716),
    [sym_binary_expression] = STATE(716),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(716),
    [sym_call_expression] = STATE(716),
    [sym_array_expression] = STATE(716),
    [sym_parenthesized_expression] = STATE(716),
    [sym_tuple_expression] = STATE(716),
    [sym_unit_expression] = STATE(716),
    [sym_struct_expression] = STATE(716),
    [sym_if_expression] = STATE(716),
    [sym_if_let_expression] = STATE(716),
    [sym_match_expression] = STATE(716),
    [sym_while_expression] = STATE(716),
    [sym_while_let_expression] = STATE(716),
    [sym_loop_expression] = STATE(716),
    [sym_for_expression] = STATE(716),
    [sym_closure_expression] = STATE(716),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(716),
    [sym_continue_expression] = STATE(716),
    [sym_index_expression] = STATE(716),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(716),
    [sym_block] = STATE(716),
    [sym__literal] = STATE(716),
    [sym_string_literal] = STATE(716),
    [sym_boolean_literal] = STATE(716),
    [sym_raw_string_literal] = ACTIONS(1531),
    [sym_float_literal] = ACTIONS(1531),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(1531),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1531),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [299] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(717),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(717),
    [sym_macro_invocation] = STATE(717),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(717),
    [sym_unary_expression] = STATE(717),
    [sym_try_expression] = STATE(717),
    [sym_reference_expression] = STATE(717),
    [sym_binary_expression] = STATE(717),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(717),
    [sym_call_expression] = STATE(717),
    [sym_array_expression] = STATE(717),
    [sym_parenthesized_expression] = STATE(717),
    [sym_tuple_expression] = STATE(717),
    [sym_unit_expression] = STATE(717),
    [sym_struct_expression] = STATE(717),
    [sym_if_expression] = STATE(717),
    [sym_if_let_expression] = STATE(717),
    [sym_match_expression] = STATE(717),
    [sym_while_expression] = STATE(717),
    [sym_while_let_expression] = STATE(717),
    [sym_loop_expression] = STATE(717),
    [sym_for_expression] = STATE(717),
    [sym_closure_expression] = STATE(717),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(717),
    [sym_continue_expression] = STATE(717),
    [sym_index_expression] = STATE(717),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(717),
    [sym_block] = STATE(717),
    [sym__literal] = STATE(717),
    [sym_string_literal] = STATE(717),
    [sym_boolean_literal] = STATE(717),
    [sym_raw_string_literal] = ACTIONS(1533),
    [sym_float_literal] = ACTIONS(1533),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(1533),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [300] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(718),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(718),
    [sym_macro_invocation] = STATE(718),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(718),
    [sym_unary_expression] = STATE(718),
    [sym_try_expression] = STATE(718),
    [sym_reference_expression] = STATE(718),
    [sym_binary_expression] = STATE(718),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_array_expression] = STATE(718),
    [sym_parenthesized_expression] = STATE(718),
    [sym_tuple_expression] = STATE(718),
    [sym_unit_expression] = STATE(718),
    [sym_struct_expression] = STATE(718),
    [sym_if_expression] = STATE(718),
    [sym_if_let_expression] = STATE(718),
    [sym_match_expression] = STATE(718),
    [sym_while_expression] = STATE(718),
    [sym_while_let_expression] = STATE(718),
    [sym_loop_expression] = STATE(718),
    [sym_for_expression] = STATE(718),
    [sym_closure_expression] = STATE(718),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(718),
    [sym_continue_expression] = STATE(718),
    [sym_index_expression] = STATE(718),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(718),
    [sym_block] = STATE(718),
    [sym__literal] = STATE(718),
    [sym_string_literal] = STATE(718),
    [sym_boolean_literal] = STATE(718),
    [sym_raw_string_literal] = ACTIONS(1535),
    [sym_float_literal] = ACTIONS(1535),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(1535),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [301] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(719),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(719),
    [sym_macro_invocation] = STATE(719),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(719),
    [sym_unary_expression] = STATE(719),
    [sym_try_expression] = STATE(719),
    [sym_reference_expression] = STATE(719),
    [sym_binary_expression] = STATE(719),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(719),
    [sym_call_expression] = STATE(719),
    [sym_array_expression] = STATE(719),
    [sym_parenthesized_expression] = STATE(719),
    [sym_tuple_expression] = STATE(719),
    [sym_unit_expression] = STATE(719),
    [sym_struct_expression] = STATE(719),
    [sym_if_expression] = STATE(719),
    [sym_if_let_expression] = STATE(719),
    [sym_match_expression] = STATE(719),
    [sym_while_expression] = STATE(719),
    [sym_while_let_expression] = STATE(719),
    [sym_loop_expression] = STATE(719),
    [sym_for_expression] = STATE(719),
    [sym_closure_expression] = STATE(719),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(719),
    [sym_continue_expression] = STATE(719),
    [sym_index_expression] = STATE(719),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(719),
    [sym_block] = STATE(719),
    [sym__literal] = STATE(719),
    [sym_string_literal] = STATE(719),
    [sym_boolean_literal] = STATE(719),
    [sym_raw_string_literal] = ACTIONS(1537),
    [sym_float_literal] = ACTIONS(1537),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(1537),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [302] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(720),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(720),
    [sym_macro_invocation] = STATE(720),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(720),
    [sym_unary_expression] = STATE(720),
    [sym_try_expression] = STATE(720),
    [sym_reference_expression] = STATE(720),
    [sym_binary_expression] = STATE(720),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(720),
    [sym_call_expression] = STATE(720),
    [sym_array_expression] = STATE(720),
    [sym_parenthesized_expression] = STATE(720),
    [sym_tuple_expression] = STATE(720),
    [sym_unit_expression] = STATE(720),
    [sym_struct_expression] = STATE(720),
    [sym_if_expression] = STATE(720),
    [sym_if_let_expression] = STATE(720),
    [sym_match_expression] = STATE(720),
    [sym_while_expression] = STATE(720),
    [sym_while_let_expression] = STATE(720),
    [sym_loop_expression] = STATE(720),
    [sym_for_expression] = STATE(720),
    [sym_closure_expression] = STATE(720),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(720),
    [sym_continue_expression] = STATE(720),
    [sym_index_expression] = STATE(720),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(720),
    [sym_block] = STATE(720),
    [sym__literal] = STATE(720),
    [sym_string_literal] = STATE(720),
    [sym_boolean_literal] = STATE(720),
    [sym_raw_string_literal] = ACTIONS(1539),
    [sym_float_literal] = ACTIONS(1539),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(1539),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1539),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [303] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(721),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(721),
    [sym_macro_invocation] = STATE(721),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(721),
    [sym_unary_expression] = STATE(721),
    [sym_try_expression] = STATE(721),
    [sym_reference_expression] = STATE(721),
    [sym_binary_expression] = STATE(721),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(721),
    [sym_call_expression] = STATE(721),
    [sym_array_expression] = STATE(721),
    [sym_parenthesized_expression] = STATE(721),
    [sym_tuple_expression] = STATE(721),
    [sym_unit_expression] = STATE(721),
    [sym_struct_expression] = STATE(721),
    [sym_if_expression] = STATE(721),
    [sym_if_let_expression] = STATE(721),
    [sym_match_expression] = STATE(721),
    [sym_while_expression] = STATE(721),
    [sym_while_let_expression] = STATE(721),
    [sym_loop_expression] = STATE(721),
    [sym_for_expression] = STATE(721),
    [sym_closure_expression] = STATE(721),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(721),
    [sym_continue_expression] = STATE(721),
    [sym_index_expression] = STATE(721),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(721),
    [sym_block] = STATE(721),
    [sym__literal] = STATE(721),
    [sym_string_literal] = STATE(721),
    [sym_boolean_literal] = STATE(721),
    [sym_raw_string_literal] = ACTIONS(1541),
    [sym_float_literal] = ACTIONS(1541),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(909),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(911),
    [anon_sym_STAR] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_DASH] = ACTIONS(911),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(911),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(911),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_LT_LT] = ACTIONS(911),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(909),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_EQ_EQ] = ACTIONS(909),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(911),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_as] = ACTIONS(911),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(1541),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1541),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [304] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(721),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(721),
    [sym_macro_invocation] = STATE(721),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(721),
    [sym_unary_expression] = STATE(721),
    [sym_try_expression] = STATE(721),
    [sym_reference_expression] = STATE(721),
    [sym_binary_expression] = STATE(721),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(721),
    [sym_call_expression] = STATE(721),
    [sym_array_expression] = STATE(721),
    [sym_parenthesized_expression] = STATE(721),
    [sym_tuple_expression] = STATE(721),
    [sym_unit_expression] = STATE(721),
    [sym_struct_expression] = STATE(721),
    [sym_if_expression] = STATE(721),
    [sym_if_let_expression] = STATE(721),
    [sym_match_expression] = STATE(721),
    [sym_while_expression] = STATE(721),
    [sym_while_let_expression] = STATE(721),
    [sym_loop_expression] = STATE(721),
    [sym_for_expression] = STATE(721),
    [sym_closure_expression] = STATE(721),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(721),
    [sym_continue_expression] = STATE(721),
    [sym_index_expression] = STATE(721),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(721),
    [sym_block] = STATE(721),
    [sym__literal] = STATE(721),
    [sym_string_literal] = STATE(721),
    [sym_boolean_literal] = STATE(721),
    [sym_raw_string_literal] = ACTIONS(1541),
    [sym_float_literal] = ACTIONS(1541),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(1541),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1541),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [305] = {
    [sym_function_modifiers] = STATE(726),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(666),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(727),
    [sym_array_type] = STATE(666),
    [sym_function_type] = STATE(666),
    [sym_tuple_type] = STATE(666),
    [sym_unit_type] = STATE(666),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(666),
    [sym_reference_type] = STATE(666),
    [sym_pointer_type] = STATE(666),
    [sym_empty_type] = STATE(666),
    [sym_dynamic_type] = STATE(666),
    [sym_macro_invocation] = STATE(666),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(728),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1543),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1547),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1549),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [306] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(1323),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(1323),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_BANG_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH] = ACTIONS(563),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(563),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_LT] = ACTIONS(577),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(581),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(577),
    [anon_sym_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(589),
    [anon_sym_as] = ACTIONS(591),
    [sym_line_comment] = ACTIONS(7),
  },
  [307] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(1551),
    [anon_sym_loop] = ACTIONS(1553),
    [anon_sym_while] = ACTIONS(1555),
    [sym_line_comment] = ACTIONS(7),
  },
  [308] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(733),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(733),
    [sym_macro_invocation] = STATE(733),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(733),
    [sym_unary_expression] = STATE(733),
    [sym_try_expression] = STATE(733),
    [sym_reference_expression] = STATE(733),
    [sym_binary_expression] = STATE(733),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(733),
    [sym_call_expression] = STATE(733),
    [sym_array_expression] = STATE(733),
    [sym_parenthesized_expression] = STATE(733),
    [sym_tuple_expression] = STATE(733),
    [sym_unit_expression] = STATE(733),
    [sym_struct_expression] = STATE(733),
    [sym_if_expression] = STATE(733),
    [sym_if_let_expression] = STATE(733),
    [sym_match_expression] = STATE(733),
    [sym_while_expression] = STATE(733),
    [sym_while_let_expression] = STATE(733),
    [sym_loop_expression] = STATE(733),
    [sym_for_expression] = STATE(733),
    [sym_closure_expression] = STATE(733),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(733),
    [sym_continue_expression] = STATE(733),
    [sym_index_expression] = STATE(733),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(733),
    [sym_block] = STATE(733),
    [sym__literal] = STATE(733),
    [sym_string_literal] = STATE(733),
    [sym_boolean_literal] = STATE(733),
    [sym_raw_string_literal] = ACTIONS(1557),
    [sym_float_literal] = ACTIONS(1557),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_let] = ACTIONS(1559),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(1557),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1557),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [309] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(361),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(361),
    [sym_macro_invocation] = STATE(361),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(361),
    [sym_unary_expression] = STATE(361),
    [sym_try_expression] = STATE(361),
    [sym_reference_expression] = STATE(361),
    [sym_binary_expression] = STATE(361),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(361),
    [sym_call_expression] = STATE(361),
    [sym_array_expression] = STATE(361),
    [sym_parenthesized_expression] = STATE(361),
    [sym_tuple_expression] = STATE(361),
    [sym_unit_expression] = STATE(361),
    [sym_struct_expression] = STATE(361),
    [sym_if_expression] = STATE(361),
    [sym_if_let_expression] = STATE(361),
    [sym_match_expression] = STATE(361),
    [sym_while_expression] = STATE(361),
    [sym_while_let_expression] = STATE(361),
    [sym_loop_expression] = STATE(361),
    [sym_for_expression] = STATE(361),
    [sym_closure_expression] = STATE(361),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(361),
    [sym_continue_expression] = STATE(361),
    [sym_index_expression] = STATE(361),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(361),
    [sym_block] = STATE(361),
    [sym__literal] = STATE(361),
    [sym_string_literal] = STATE(361),
    [sym_boolean_literal] = STATE(361),
    [sym_raw_string_literal] = ACTIONS(715),
    [sym_float_literal] = ACTIONS(715),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(601),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(715),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(715),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [310] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_as] = ACTIONS(909),
    [sym_line_comment] = ACTIONS(7),
  },
  [311] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(734),
    [sym_tuple_pattern] = STATE(734),
    [sym_tuple_struct_pattern] = STATE(734),
    [sym_struct_pattern] = STATE(734),
    [sym_remaining_field_pattern] = STATE(734),
    [sym_mut_pattern] = STATE(734),
    [sym_ref_pattern] = STATE(734),
    [sym_captured_pattern] = STATE(734),
    [sym_reference_pattern] = STATE(734),
    [sym__literal] = STATE(734),
    [sym_string_literal] = STATE(734),
    [sym_boolean_literal] = STATE(734),
    [sym_raw_string_literal] = ACTIONS(1561),
    [sym_float_literal] = ACTIONS(1561),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(955),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(957),
    [anon_sym_ref] = ACTIONS(959),
    [sym_integer_literal] = ACTIONS(1561),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(1561),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(961),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [312] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(735),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [313] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(1043),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(1043),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(1043),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(1043),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(1043),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(1043),
    [anon_sym_PLUS_EQ] = ACTIONS(1043),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(1043),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(1043),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(1043),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(643),
    [anon_sym_as] = ACTIONS(1043),
    [sym_line_comment] = ACTIONS(7),
  },
  [314] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(736),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(736),
    [sym_macro_invocation] = STATE(736),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(736),
    [sym_unary_expression] = STATE(736),
    [sym_try_expression] = STATE(736),
    [sym_reference_expression] = STATE(736),
    [sym_binary_expression] = STATE(736),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(736),
    [sym_call_expression] = STATE(736),
    [sym_array_expression] = STATE(736),
    [sym_parenthesized_expression] = STATE(736),
    [sym_tuple_expression] = STATE(736),
    [sym_unit_expression] = STATE(736),
    [sym_struct_expression] = STATE(736),
    [sym_if_expression] = STATE(736),
    [sym_if_let_expression] = STATE(736),
    [sym_match_expression] = STATE(736),
    [sym_while_expression] = STATE(736),
    [sym_while_let_expression] = STATE(736),
    [sym_loop_expression] = STATE(736),
    [sym_for_expression] = STATE(736),
    [sym_closure_expression] = STATE(736),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(736),
    [sym_continue_expression] = STATE(736),
    [sym_index_expression] = STATE(736),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(736),
    [sym_block] = STATE(736),
    [sym__literal] = STATE(736),
    [sym_string_literal] = STATE(736),
    [sym_boolean_literal] = STATE(736),
    [sym_raw_string_literal] = ACTIONS(1565),
    [sym_float_literal] = ACTIONS(1565),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(607),
    [anon_sym_DASH_GT] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(601),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(1565),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1565),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [315] = {
    [sym_raw_string_literal] = ACTIONS(1567),
    [sym_float_literal] = ACTIONS(1567),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(1567),
    [anon_sym_SEMI] = ACTIONS(1567),
    [anon_sym_macro_rules_BANG] = ACTIONS(1567),
    [anon_sym_LPAREN] = ACTIONS(1567),
    [anon_sym_LBRACE] = ACTIONS(1567),
    [anon_sym_RBRACE] = ACTIONS(1567),
    [anon_sym_LBRACK] = ACTIONS(1567),
    [anon_sym_PLUS] = ACTIONS(1569),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_u8] = ACTIONS(1569),
    [anon_sym_i8] = ACTIONS(1569),
    [anon_sym_u16] = ACTIONS(1569),
    [anon_sym_i16] = ACTIONS(1569),
    [anon_sym_u32] = ACTIONS(1569),
    [anon_sym_i32] = ACTIONS(1569),
    [anon_sym_u64] = ACTIONS(1569),
    [anon_sym_i64] = ACTIONS(1569),
    [anon_sym_u128] = ACTIONS(1569),
    [anon_sym_i128] = ACTIONS(1569),
    [anon_sym_isize] = ACTIONS(1569),
    [anon_sym_usize] = ACTIONS(1569),
    [anon_sym_f32] = ACTIONS(1569),
    [anon_sym_f64] = ACTIONS(1569),
    [anon_sym_bool] = ACTIONS(1569),
    [anon_sym_str] = ACTIONS(1569),
    [anon_sym_char] = ACTIONS(1569),
    [anon_sym_AMP] = ACTIONS(1569),
    [anon_sym_DASH] = ACTIONS(1569),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_DASH_EQ] = ACTIONS(1567),
    [anon_sym_COLON_COLON] = ACTIONS(1567),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_BANG_EQ] = ACTIONS(1567),
    [anon_sym_STAR_EQ] = ACTIONS(1567),
    [anon_sym_SLASH] = ACTIONS(1569),
    [anon_sym_SLASH_EQ] = ACTIONS(1567),
    [anon_sym_AMP_AMP] = ACTIONS(1567),
    [anon_sym_AMP_EQ] = ACTIONS(1567),
    [anon_sym_POUND] = ACTIONS(1567),
    [anon_sym_PERCENT] = ACTIONS(1569),
    [anon_sym_PERCENT_EQ] = ACTIONS(1567),
    [anon_sym_CARET] = ACTIONS(1569),
    [anon_sym_CARET_EQ] = ACTIONS(1567),
    [anon_sym_PLUS_EQ] = ACTIONS(1567),
    [anon_sym_LT] = ACTIONS(1569),
    [anon_sym_LT_LT] = ACTIONS(1569),
    [anon_sym_LT_LT_EQ] = ACTIONS(1567),
    [anon_sym_LT_EQ] = ACTIONS(1567),
    [anon_sym_EQ] = ACTIONS(1569),
    [anon_sym_EQ_EQ] = ACTIONS(1567),
    [anon_sym_GT] = ACTIONS(1569),
    [anon_sym_GT_EQ] = ACTIONS(1567),
    [anon_sym_GT_GT] = ACTIONS(1569),
    [anon_sym_GT_GT_EQ] = ACTIONS(1567),
    [anon_sym_PIPE] = ACTIONS(1569),
    [anon_sym_PIPE_EQ] = ACTIONS(1567),
    [anon_sym_PIPE_PIPE] = ACTIONS(1567),
    [anon_sym_QMARK] = ACTIONS(1567),
    [anon_sym_SQUOTE] = ACTIONS(1569),
    [anon_sym_DOT_DOT] = ACTIONS(1569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1567),
    [anon_sym_as] = ACTIONS(1569),
    [anon_sym_break] = ACTIONS(1569),
    [anon_sym_const] = ACTIONS(1569),
    [anon_sym_continue] = ACTIONS(1569),
    [anon_sym_default] = ACTIONS(1569),
    [anon_sym_enum] = ACTIONS(1569),
    [anon_sym_fn] = ACTIONS(1569),
    [anon_sym_for] = ACTIONS(1569),
    [anon_sym_if] = ACTIONS(1569),
    [anon_sym_impl] = ACTIONS(1569),
    [anon_sym_let] = ACTIONS(1569),
    [anon_sym_loop] = ACTIONS(1569),
    [anon_sym_match] = ACTIONS(1569),
    [anon_sym_mod] = ACTIONS(1569),
    [anon_sym_pub] = ACTIONS(1569),
    [anon_sym_return] = ACTIONS(1569),
    [anon_sym_static] = ACTIONS(1569),
    [anon_sym_struct] = ACTIONS(1569),
    [anon_sym_trait] = ACTIONS(1569),
    [anon_sym_type] = ACTIONS(1569),
    [anon_sym_union] = ACTIONS(1569),
    [anon_sym_unsafe] = ACTIONS(1569),
    [anon_sym_use] = ACTIONS(1569),
    [anon_sym_while] = ACTIONS(1569),
    [anon_sym_extern] = ACTIONS(1569),
    [anon_sym_else] = ACTIONS(1569),
    [anon_sym_move] = ACTIONS(1569),
    [sym_integer_literal] = ACTIONS(1567),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(1567),
    [sym_char_literal] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1569),
    [anon_sym_false] = ACTIONS(1569),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1569),
    [sym_self] = ACTIONS(1569),
    [sym_super] = ACTIONS(1569),
    [sym_crate] = ACTIONS(1569),
    [sym_metavariable] = ACTIONS(1567),
  },
  [316] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(737),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(737),
    [sym_macro_invocation] = STATE(737),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(737),
    [sym_unary_expression] = STATE(737),
    [sym_try_expression] = STATE(737),
    [sym_reference_expression] = STATE(737),
    [sym_binary_expression] = STATE(737),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(737),
    [sym_call_expression] = STATE(737),
    [sym_array_expression] = STATE(737),
    [sym_parenthesized_expression] = STATE(737),
    [sym_tuple_expression] = STATE(737),
    [sym_unit_expression] = STATE(737),
    [sym_struct_expression] = STATE(737),
    [sym_if_expression] = STATE(737),
    [sym_if_let_expression] = STATE(737),
    [sym_match_expression] = STATE(737),
    [sym_while_expression] = STATE(737),
    [sym_while_let_expression] = STATE(737),
    [sym_loop_expression] = STATE(737),
    [sym_for_expression] = STATE(737),
    [sym_closure_expression] = STATE(737),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(737),
    [sym_continue_expression] = STATE(737),
    [sym_index_expression] = STATE(737),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(737),
    [sym_block] = STATE(737),
    [sym__literal] = STATE(737),
    [sym_string_literal] = STATE(737),
    [sym_boolean_literal] = STATE(737),
    [sym_raw_string_literal] = ACTIONS(1571),
    [sym_float_literal] = ACTIONS(1571),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(601),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(1571),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [317] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(640),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(640),
    [sym_macro_invocation] = STATE(640),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(640),
    [sym_unary_expression] = STATE(640),
    [sym_try_expression] = STATE(640),
    [sym_reference_expression] = STATE(640),
    [sym_binary_expression] = STATE(640),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(640),
    [sym_call_expression] = STATE(640),
    [sym_array_expression] = STATE(640),
    [sym_parenthesized_expression] = STATE(640),
    [sym_tuple_expression] = STATE(640),
    [sym_unit_expression] = STATE(640),
    [sym_struct_expression] = STATE(640),
    [sym_if_expression] = STATE(640),
    [sym_if_let_expression] = STATE(640),
    [sym_match_expression] = STATE(640),
    [sym_while_expression] = STATE(640),
    [sym_while_let_expression] = STATE(640),
    [sym_loop_expression] = STATE(640),
    [sym_for_expression] = STATE(640),
    [sym_closure_expression] = STATE(640),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(640),
    [sym_continue_expression] = STATE(640),
    [sym_index_expression] = STATE(640),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(640),
    [sym_block] = STATE(640),
    [sym__literal] = STATE(640),
    [sym_string_literal] = STATE(640),
    [sym_boolean_literal] = STATE(640),
    [sym_raw_string_literal] = ACTIONS(1257),
    [sym_float_literal] = ACTIONS(1257),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(601),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(1257),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1257),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [318] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(738),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(738),
    [sym_macro_invocation] = STATE(738),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(738),
    [sym_unary_expression] = STATE(738),
    [sym_try_expression] = STATE(738),
    [sym_reference_expression] = STATE(738),
    [sym_binary_expression] = STATE(738),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(738),
    [sym_call_expression] = STATE(738),
    [sym_array_expression] = STATE(738),
    [sym_parenthesized_expression] = STATE(738),
    [sym_tuple_expression] = STATE(738),
    [sym_unit_expression] = STATE(738),
    [sym_struct_expression] = STATE(738),
    [sym_if_expression] = STATE(738),
    [sym_if_let_expression] = STATE(738),
    [sym_match_expression] = STATE(738),
    [sym_while_expression] = STATE(738),
    [sym_while_let_expression] = STATE(738),
    [sym_loop_expression] = STATE(738),
    [sym_for_expression] = STATE(738),
    [sym_closure_expression] = STATE(738),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(738),
    [sym_continue_expression] = STATE(738),
    [sym_index_expression] = STATE(738),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(738),
    [sym_block] = STATE(738),
    [sym__literal] = STATE(738),
    [sym_string_literal] = STATE(738),
    [sym_boolean_literal] = STATE(738),
    [sym_raw_string_literal] = ACTIONS(1573),
    [sym_float_literal] = ACTIONS(1573),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(601),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(1573),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1573),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [319] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(739),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(739),
    [sym_macro_invocation] = STATE(739),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(739),
    [sym_unary_expression] = STATE(739),
    [sym_try_expression] = STATE(739),
    [sym_reference_expression] = STATE(739),
    [sym_binary_expression] = STATE(739),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(739),
    [sym_call_expression] = STATE(739),
    [sym_array_expression] = STATE(739),
    [sym_parenthesized_expression] = STATE(739),
    [sym_tuple_expression] = STATE(739),
    [sym_unit_expression] = STATE(739),
    [sym_struct_expression] = STATE(739),
    [sym_if_expression] = STATE(739),
    [sym_if_let_expression] = STATE(739),
    [sym_match_expression] = STATE(739),
    [sym_while_expression] = STATE(739),
    [sym_while_let_expression] = STATE(739),
    [sym_loop_expression] = STATE(739),
    [sym_for_expression] = STATE(739),
    [sym_closure_expression] = STATE(739),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(739),
    [sym_continue_expression] = STATE(739),
    [sym_index_expression] = STATE(739),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(739),
    [sym_block] = STATE(739),
    [sym__literal] = STATE(739),
    [sym_string_literal] = STATE(739),
    [sym_boolean_literal] = STATE(739),
    [sym_raw_string_literal] = ACTIONS(1575),
    [sym_float_literal] = ACTIONS(1575),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(601),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(1575),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1575),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [320] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(740),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(740),
    [sym_macro_invocation] = STATE(740),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(740),
    [sym_unary_expression] = STATE(740),
    [sym_try_expression] = STATE(740),
    [sym_reference_expression] = STATE(740),
    [sym_binary_expression] = STATE(740),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(740),
    [sym_call_expression] = STATE(740),
    [sym_array_expression] = STATE(740),
    [sym_parenthesized_expression] = STATE(740),
    [sym_tuple_expression] = STATE(740),
    [sym_unit_expression] = STATE(740),
    [sym_struct_expression] = STATE(740),
    [sym_if_expression] = STATE(740),
    [sym_if_let_expression] = STATE(740),
    [sym_match_expression] = STATE(740),
    [sym_while_expression] = STATE(740),
    [sym_while_let_expression] = STATE(740),
    [sym_loop_expression] = STATE(740),
    [sym_for_expression] = STATE(740),
    [sym_closure_expression] = STATE(740),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(740),
    [sym_continue_expression] = STATE(740),
    [sym_index_expression] = STATE(740),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(740),
    [sym_block] = STATE(740),
    [sym__literal] = STATE(740),
    [sym_string_literal] = STATE(740),
    [sym_boolean_literal] = STATE(740),
    [sym_raw_string_literal] = ACTIONS(1577),
    [sym_float_literal] = ACTIONS(1577),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(601),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(1577),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [321] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(741),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(741),
    [sym_macro_invocation] = STATE(741),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(741),
    [sym_unary_expression] = STATE(741),
    [sym_try_expression] = STATE(741),
    [sym_reference_expression] = STATE(741),
    [sym_binary_expression] = STATE(741),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(741),
    [sym_call_expression] = STATE(741),
    [sym_array_expression] = STATE(741),
    [sym_parenthesized_expression] = STATE(741),
    [sym_tuple_expression] = STATE(741),
    [sym_unit_expression] = STATE(741),
    [sym_struct_expression] = STATE(741),
    [sym_if_expression] = STATE(741),
    [sym_if_let_expression] = STATE(741),
    [sym_match_expression] = STATE(741),
    [sym_while_expression] = STATE(741),
    [sym_while_let_expression] = STATE(741),
    [sym_loop_expression] = STATE(741),
    [sym_for_expression] = STATE(741),
    [sym_closure_expression] = STATE(741),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(741),
    [sym_continue_expression] = STATE(741),
    [sym_index_expression] = STATE(741),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(741),
    [sym_block] = STATE(741),
    [sym__literal] = STATE(741),
    [sym_string_literal] = STATE(741),
    [sym_boolean_literal] = STATE(741),
    [sym_raw_string_literal] = ACTIONS(1579),
    [sym_float_literal] = ACTIONS(1579),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(601),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(1579),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1579),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [322] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(742),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(742),
    [sym_macro_invocation] = STATE(742),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(742),
    [sym_unary_expression] = STATE(742),
    [sym_try_expression] = STATE(742),
    [sym_reference_expression] = STATE(742),
    [sym_binary_expression] = STATE(742),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(742),
    [sym_call_expression] = STATE(742),
    [sym_array_expression] = STATE(742),
    [sym_parenthesized_expression] = STATE(742),
    [sym_tuple_expression] = STATE(742),
    [sym_unit_expression] = STATE(742),
    [sym_struct_expression] = STATE(742),
    [sym_if_expression] = STATE(742),
    [sym_if_let_expression] = STATE(742),
    [sym_match_expression] = STATE(742),
    [sym_while_expression] = STATE(742),
    [sym_while_let_expression] = STATE(742),
    [sym_loop_expression] = STATE(742),
    [sym_for_expression] = STATE(742),
    [sym_closure_expression] = STATE(742),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(742),
    [sym_continue_expression] = STATE(742),
    [sym_index_expression] = STATE(742),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(742),
    [sym_block] = STATE(742),
    [sym__literal] = STATE(742),
    [sym_string_literal] = STATE(742),
    [sym_boolean_literal] = STATE(742),
    [sym_raw_string_literal] = ACTIONS(1581),
    [sym_float_literal] = ACTIONS(1581),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(601),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(1581),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1581),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [323] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(743),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(743),
    [sym_macro_invocation] = STATE(743),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(743),
    [sym_unary_expression] = STATE(743),
    [sym_try_expression] = STATE(743),
    [sym_reference_expression] = STATE(743),
    [sym_binary_expression] = STATE(743),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(743),
    [sym_call_expression] = STATE(743),
    [sym_array_expression] = STATE(743),
    [sym_parenthesized_expression] = STATE(743),
    [sym_tuple_expression] = STATE(743),
    [sym_unit_expression] = STATE(743),
    [sym_struct_expression] = STATE(743),
    [sym_if_expression] = STATE(743),
    [sym_if_let_expression] = STATE(743),
    [sym_match_expression] = STATE(743),
    [sym_while_expression] = STATE(743),
    [sym_while_let_expression] = STATE(743),
    [sym_loop_expression] = STATE(743),
    [sym_for_expression] = STATE(743),
    [sym_closure_expression] = STATE(743),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(743),
    [sym_continue_expression] = STATE(743),
    [sym_index_expression] = STATE(743),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(743),
    [sym_block] = STATE(743),
    [sym__literal] = STATE(743),
    [sym_string_literal] = STATE(743),
    [sym_boolean_literal] = STATE(743),
    [sym_raw_string_literal] = ACTIONS(1583),
    [sym_float_literal] = ACTIONS(1583),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(601),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(1583),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1583),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [324] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(744),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(744),
    [sym_macro_invocation] = STATE(744),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(744),
    [sym_unary_expression] = STATE(744),
    [sym_try_expression] = STATE(744),
    [sym_reference_expression] = STATE(744),
    [sym_binary_expression] = STATE(744),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(744),
    [sym_call_expression] = STATE(744),
    [sym_array_expression] = STATE(744),
    [sym_parenthesized_expression] = STATE(744),
    [sym_tuple_expression] = STATE(744),
    [sym_unit_expression] = STATE(744),
    [sym_struct_expression] = STATE(744),
    [sym_if_expression] = STATE(744),
    [sym_if_let_expression] = STATE(744),
    [sym_match_expression] = STATE(744),
    [sym_while_expression] = STATE(744),
    [sym_while_let_expression] = STATE(744),
    [sym_loop_expression] = STATE(744),
    [sym_for_expression] = STATE(744),
    [sym_closure_expression] = STATE(744),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(744),
    [sym_continue_expression] = STATE(744),
    [sym_index_expression] = STATE(744),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(744),
    [sym_block] = STATE(744),
    [sym__literal] = STATE(744),
    [sym_string_literal] = STATE(744),
    [sym_boolean_literal] = STATE(744),
    [sym_raw_string_literal] = ACTIONS(1585),
    [sym_float_literal] = ACTIONS(1585),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(601),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(1585),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1585),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [325] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(745),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(745),
    [sym_macro_invocation] = STATE(745),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(745),
    [sym_unary_expression] = STATE(745),
    [sym_try_expression] = STATE(745),
    [sym_reference_expression] = STATE(745),
    [sym_binary_expression] = STATE(745),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(745),
    [sym_call_expression] = STATE(745),
    [sym_array_expression] = STATE(745),
    [sym_parenthesized_expression] = STATE(745),
    [sym_tuple_expression] = STATE(745),
    [sym_unit_expression] = STATE(745),
    [sym_struct_expression] = STATE(745),
    [sym_if_expression] = STATE(745),
    [sym_if_let_expression] = STATE(745),
    [sym_match_expression] = STATE(745),
    [sym_while_expression] = STATE(745),
    [sym_while_let_expression] = STATE(745),
    [sym_loop_expression] = STATE(745),
    [sym_for_expression] = STATE(745),
    [sym_closure_expression] = STATE(745),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(745),
    [sym_continue_expression] = STATE(745),
    [sym_index_expression] = STATE(745),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(745),
    [sym_block] = STATE(745),
    [sym__literal] = STATE(745),
    [sym_string_literal] = STATE(745),
    [sym_boolean_literal] = STATE(745),
    [sym_raw_string_literal] = ACTIONS(1587),
    [sym_float_literal] = ACTIONS(1587),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(601),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(1587),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [326] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(746),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(746),
    [sym_macro_invocation] = STATE(746),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(746),
    [sym_unary_expression] = STATE(746),
    [sym_try_expression] = STATE(746),
    [sym_reference_expression] = STATE(746),
    [sym_binary_expression] = STATE(746),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(746),
    [sym_call_expression] = STATE(746),
    [sym_array_expression] = STATE(746),
    [sym_parenthesized_expression] = STATE(746),
    [sym_tuple_expression] = STATE(746),
    [sym_unit_expression] = STATE(746),
    [sym_struct_expression] = STATE(746),
    [sym_if_expression] = STATE(746),
    [sym_if_let_expression] = STATE(746),
    [sym_match_expression] = STATE(746),
    [sym_while_expression] = STATE(746),
    [sym_while_let_expression] = STATE(746),
    [sym_loop_expression] = STATE(746),
    [sym_for_expression] = STATE(746),
    [sym_closure_expression] = STATE(746),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(746),
    [sym_continue_expression] = STATE(746),
    [sym_index_expression] = STATE(746),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(746),
    [sym_block] = STATE(746),
    [sym__literal] = STATE(746),
    [sym_string_literal] = STATE(746),
    [sym_boolean_literal] = STATE(746),
    [sym_raw_string_literal] = ACTIONS(1589),
    [sym_float_literal] = ACTIONS(1589),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(601),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(1589),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1589),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [327] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(747),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(747),
    [sym_macro_invocation] = STATE(747),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(747),
    [sym_unary_expression] = STATE(747),
    [sym_try_expression] = STATE(747),
    [sym_reference_expression] = STATE(747),
    [sym_binary_expression] = STATE(747),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(747),
    [sym_call_expression] = STATE(747),
    [sym_array_expression] = STATE(747),
    [sym_parenthesized_expression] = STATE(747),
    [sym_tuple_expression] = STATE(747),
    [sym_unit_expression] = STATE(747),
    [sym_struct_expression] = STATE(747),
    [sym_if_expression] = STATE(747),
    [sym_if_let_expression] = STATE(747),
    [sym_match_expression] = STATE(747),
    [sym_while_expression] = STATE(747),
    [sym_while_let_expression] = STATE(747),
    [sym_loop_expression] = STATE(747),
    [sym_for_expression] = STATE(747),
    [sym_closure_expression] = STATE(747),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(747),
    [sym_continue_expression] = STATE(747),
    [sym_index_expression] = STATE(747),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(747),
    [sym_block] = STATE(747),
    [sym__literal] = STATE(747),
    [sym_string_literal] = STATE(747),
    [sym_boolean_literal] = STATE(747),
    [sym_raw_string_literal] = ACTIONS(1591),
    [sym_float_literal] = ACTIONS(1591),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(909),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(911),
    [anon_sym_STAR] = ACTIONS(911),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_DASH] = ACTIONS(911),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(911),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(911),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_LT_LT] = ACTIONS(911),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(909),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_EQ_EQ] = ACTIONS(909),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(911),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_as] = ACTIONS(911),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(601),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(1591),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1591),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [328] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(747),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(747),
    [sym_macro_invocation] = STATE(747),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(747),
    [sym_unary_expression] = STATE(747),
    [sym_try_expression] = STATE(747),
    [sym_reference_expression] = STATE(747),
    [sym_binary_expression] = STATE(747),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(747),
    [sym_call_expression] = STATE(747),
    [sym_array_expression] = STATE(747),
    [sym_parenthesized_expression] = STATE(747),
    [sym_tuple_expression] = STATE(747),
    [sym_unit_expression] = STATE(747),
    [sym_struct_expression] = STATE(747),
    [sym_if_expression] = STATE(747),
    [sym_if_let_expression] = STATE(747),
    [sym_match_expression] = STATE(747),
    [sym_while_expression] = STATE(747),
    [sym_while_let_expression] = STATE(747),
    [sym_loop_expression] = STATE(747),
    [sym_for_expression] = STATE(747),
    [sym_closure_expression] = STATE(747),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(747),
    [sym_continue_expression] = STATE(747),
    [sym_index_expression] = STATE(747),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(747),
    [sym_block] = STATE(747),
    [sym__literal] = STATE(747),
    [sym_string_literal] = STATE(747),
    [sym_boolean_literal] = STATE(747),
    [sym_raw_string_literal] = ACTIONS(1591),
    [sym_float_literal] = ACTIONS(1591),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(601),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(1591),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1591),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [329] = {
    [sym_function_modifiers] = STATE(752),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(666),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(753),
    [sym_array_type] = STATE(666),
    [sym_function_type] = STATE(666),
    [sym_tuple_type] = STATE(666),
    [sym_unit_type] = STATE(666),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(666),
    [sym_reference_type] = STATE(666),
    [sym_pointer_type] = STATE(666),
    [sym_empty_type] = STATE(666),
    [sym_dynamic_type] = STATE(666),
    [sym_macro_invocation] = STATE(666),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(754),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1593),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1597),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1599),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [330] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1323),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(1323),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(623),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(623),
    [anon_sym_PLUS_EQ] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(623),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(643),
    [anon_sym_as] = ACTIONS(645),
    [sym_line_comment] = ACTIONS(7),
  },
  [331] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(1601),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(623),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(623),
    [anon_sym_PLUS_EQ] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(623),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(643),
    [anon_sym_as] = ACTIONS(645),
    [sym_line_comment] = ACTIONS(7),
  },
  [332] = {
    [sym__statement] = STATE(332),
    [sym_empty_statement] = STATE(332),
    [sym__expression_statement] = STATE(332),
    [sym_macro_definition] = STATE(332),
    [sym_attribute_item] = STATE(332),
    [sym_inner_attribute_item] = STATE(332),
    [sym_mod_item] = STATE(332),
    [sym_foreign_mod_item] = STATE(332),
    [sym_struct_item] = STATE(332),
    [sym_union_item] = STATE(332),
    [sym_enum_item] = STATE(332),
    [sym_extern_crate_declaration] = STATE(332),
    [sym_const_item] = STATE(332),
    [sym_static_item] = STATE(332),
    [sym_type_item] = STATE(332),
    [sym_function_item] = STATE(332),
    [sym_function_signature_item] = STATE(332),
    [sym_function_modifiers] = STATE(47),
    [sym_impl_item] = STATE(332),
    [sym_trait_item] = STATE(332),
    [sym_associated_type] = STATE(332),
    [sym_let_declaration] = STATE(332),
    [sym_use_declaration] = STATE(332),
    [sym_extern_modifier] = STATE(48),
    [sym_visibility_modifier] = STATE(49),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(52),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(52),
    [sym_macro_invocation] = STATE(756),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(52),
    [sym_unary_expression] = STATE(52),
    [sym_try_expression] = STATE(52),
    [sym_reference_expression] = STATE(52),
    [sym_binary_expression] = STATE(52),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(52),
    [sym_call_expression] = STATE(52),
    [sym_array_expression] = STATE(52),
    [sym_parenthesized_expression] = STATE(52),
    [sym_tuple_expression] = STATE(52),
    [sym_unit_expression] = STATE(52),
    [sym_struct_expression] = STATE(52),
    [sym_if_expression] = STATE(57),
    [sym_if_let_expression] = STATE(57),
    [sym_match_expression] = STATE(57),
    [sym_while_expression] = STATE(57),
    [sym_while_let_expression] = STATE(57),
    [sym_loop_expression] = STATE(57),
    [sym_for_expression] = STATE(57),
    [sym_closure_expression] = STATE(52),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(59),
    [sym_break_expression] = STATE(52),
    [sym_continue_expression] = STATE(52),
    [sym_index_expression] = STATE(52),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(57),
    [sym_block] = STATE(57),
    [sym__literal] = STATE(52),
    [sym_string_literal] = STATE(52),
    [sym_boolean_literal] = STATE(52),
    [aux_sym_source_file_repeat1] = STATE(332),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_raw_string_literal] = ACTIONS(1331),
    [sym_float_literal] = ACTIONS(1331),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1336),
    [anon_sym_macro_rules_BANG] = ACTIONS(1339),
    [anon_sym_LPAREN] = ACTIONS(1342),
    [anon_sym_LBRACE] = ACTIONS(1345),
    [anon_sym_RBRACE] = ACTIONS(1334),
    [anon_sym_LBRACK] = ACTIONS(1348),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_u8] = ACTIONS(1354),
    [anon_sym_i8] = ACTIONS(1354),
    [anon_sym_u16] = ACTIONS(1354),
    [anon_sym_i16] = ACTIONS(1354),
    [anon_sym_u32] = ACTIONS(1354),
    [anon_sym_i32] = ACTIONS(1354),
    [anon_sym_u64] = ACTIONS(1354),
    [anon_sym_i64] = ACTIONS(1354),
    [anon_sym_u128] = ACTIONS(1354),
    [anon_sym_i128] = ACTIONS(1354),
    [anon_sym_isize] = ACTIONS(1354),
    [anon_sym_usize] = ACTIONS(1354),
    [anon_sym_f32] = ACTIONS(1354),
    [anon_sym_f64] = ACTIONS(1354),
    [anon_sym_bool] = ACTIONS(1354),
    [anon_sym_str] = ACTIONS(1354),
    [anon_sym_char] = ACTIONS(1354),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_DASH] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1360),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_POUND] = ACTIONS(1363),
    [anon_sym_LT] = ACTIONS(1366),
    [anon_sym_PIPE] = ACTIONS(1369),
    [anon_sym_SQUOTE] = ACTIONS(1372),
    [anon_sym_DOT_DOT] = ACTIONS(1375),
    [anon_sym_break] = ACTIONS(1378),
    [anon_sym_const] = ACTIONS(1381),
    [anon_sym_continue] = ACTIONS(1384),
    [anon_sym_default] = ACTIONS(1387),
    [anon_sym_enum] = ACTIONS(1390),
    [anon_sym_fn] = ACTIONS(1393),
    [anon_sym_for] = ACTIONS(1396),
    [anon_sym_if] = ACTIONS(1603),
    [anon_sym_impl] = ACTIONS(1402),
    [anon_sym_let] = ACTIONS(1405),
    [anon_sym_loop] = ACTIONS(1408),
    [anon_sym_match] = ACTIONS(1411),
    [anon_sym_mod] = ACTIONS(1414),
    [anon_sym_pub] = ACTIONS(1417),
    [anon_sym_return] = ACTIONS(1420),
    [anon_sym_static] = ACTIONS(1423),
    [anon_sym_struct] = ACTIONS(1426),
    [anon_sym_trait] = ACTIONS(1429),
    [anon_sym_type] = ACTIONS(1432),
    [anon_sym_union] = ACTIONS(1435),
    [anon_sym_unsafe] = ACTIONS(1438),
    [anon_sym_use] = ACTIONS(1441),
    [anon_sym_while] = ACTIONS(1444),
    [anon_sym_extern] = ACTIONS(1447),
    [anon_sym_move] = ACTIONS(1450),
    [sym_integer_literal] = ACTIONS(1331),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(1453),
    [sym_char_literal] = ACTIONS(1331),
    [anon_sym_true] = ACTIONS(1456),
    [anon_sym_false] = ACTIONS(1456),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1459),
    [sym_self] = ACTIONS(1462),
    [sym_super] = ACTIONS(1465),
    [sym_crate] = ACTIONS(1465),
    [sym_metavariable] = ACTIONS(1468),
  },
  [333] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1606),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_RPAREN] = ACTIONS(1606),
    [anon_sym_LBRACE] = ACTIONS(1606),
    [anon_sym_RBRACE] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1606),
    [anon_sym_RBRACK] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_STAR] = ACTIONS(1608),
    [anon_sym_COMMA] = ACTIONS(1606),
    [anon_sym_AMP] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_DOT] = ACTIONS(1608),
    [anon_sym_DASH_EQ] = ACTIONS(1606),
    [anon_sym_BANG_EQ] = ACTIONS(1606),
    [anon_sym_STAR_EQ] = ACTIONS(1606),
    [anon_sym_SLASH] = ACTIONS(1608),
    [anon_sym_SLASH_EQ] = ACTIONS(1606),
    [anon_sym_AMP_AMP] = ACTIONS(1606),
    [anon_sym_AMP_EQ] = ACTIONS(1606),
    [anon_sym_PERCENT] = ACTIONS(1608),
    [anon_sym_PERCENT_EQ] = ACTIONS(1606),
    [anon_sym_CARET] = ACTIONS(1608),
    [anon_sym_CARET_EQ] = ACTIONS(1606),
    [anon_sym_PLUS_EQ] = ACTIONS(1606),
    [anon_sym_LT] = ACTIONS(1608),
    [anon_sym_LT_LT] = ACTIONS(1608),
    [anon_sym_LT_LT_EQ] = ACTIONS(1606),
    [anon_sym_LT_EQ] = ACTIONS(1606),
    [anon_sym_EQ] = ACTIONS(1608),
    [anon_sym_EQ_EQ] = ACTIONS(1606),
    [anon_sym_GT] = ACTIONS(1608),
    [anon_sym_GT_EQ] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1608),
    [anon_sym_GT_GT_EQ] = ACTIONS(1606),
    [anon_sym_PIPE] = ACTIONS(1608),
    [anon_sym_PIPE_EQ] = ACTIONS(1606),
    [anon_sym_PIPE_PIPE] = ACTIONS(1606),
    [anon_sym_QMARK] = ACTIONS(1606),
    [anon_sym_DOT_DOT] = ACTIONS(1608),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1606),
    [anon_sym_as] = ACTIONS(1606),
    [sym_line_comment] = ACTIONS(7),
  },
  [334] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(361),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(361),
    [sym_macro_invocation] = STATE(361),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(361),
    [sym_unary_expression] = STATE(361),
    [sym_try_expression] = STATE(361),
    [sym_reference_expression] = STATE(361),
    [sym_binary_expression] = STATE(361),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(361),
    [sym_call_expression] = STATE(361),
    [sym_array_expression] = STATE(361),
    [sym_parenthesized_expression] = STATE(361),
    [sym_tuple_expression] = STATE(361),
    [sym_unit_expression] = STATE(361),
    [sym_struct_expression] = STATE(361),
    [sym_if_expression] = STATE(361),
    [sym_if_let_expression] = STATE(361),
    [sym_match_expression] = STATE(361),
    [sym_while_expression] = STATE(361),
    [sym_while_let_expression] = STATE(361),
    [sym_loop_expression] = STATE(361),
    [sym_for_expression] = STATE(361),
    [sym_closure_expression] = STATE(361),
    [sym_closure_parameters] = STATE(101),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(361),
    [sym_continue_expression] = STATE(361),
    [sym_index_expression] = STATE(361),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(361),
    [sym_block] = STATE(361),
    [sym__literal] = STATE(361),
    [sym_string_literal] = STATE(361),
    [sym_boolean_literal] = STATE(361),
    [sym_raw_string_literal] = ACTIONS(715),
    [sym_float_literal] = ACTIONS(715),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(159),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(159),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(171),
    [sym_integer_literal] = ACTIONS(715),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(715),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [335] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_AMP] = ACTIONS(677),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_BANG_EQ] = ACTIONS(681),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(683),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(685),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_LT_LT] = ACTIONS(689),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(681),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_EQ_EQ] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(689),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(693),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_as] = ACTIONS(909),
    [sym_line_comment] = ACTIONS(7),
  },
  [336] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(757),
    [sym_tuple_pattern] = STATE(757),
    [sym_tuple_struct_pattern] = STATE(757),
    [sym_struct_pattern] = STATE(757),
    [sym_remaining_field_pattern] = STATE(757),
    [sym_mut_pattern] = STATE(757),
    [sym_ref_pattern] = STATE(757),
    [sym_captured_pattern] = STATE(757),
    [sym_reference_pattern] = STATE(757),
    [sym__literal] = STATE(757),
    [sym_string_literal] = STATE(757),
    [sym_boolean_literal] = STATE(757),
    [sym_raw_string_literal] = ACTIONS(1610),
    [sym_float_literal] = ACTIONS(1610),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(1612),
    [anon_sym_AMP] = ACTIONS(955),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(957),
    [anon_sym_ref] = ACTIONS(959),
    [sym_integer_literal] = ACTIONS(1610),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(1610),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(961),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [337] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(758),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [338] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(1043),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_COMMA] = ACTIONS(1043),
    [anon_sym_AMP] = ACTIONS(677),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(1043),
    [anon_sym_BANG_EQ] = ACTIONS(681),
    [anon_sym_STAR_EQ] = ACTIONS(1043),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_SLASH_EQ] = ACTIONS(1043),
    [anon_sym_AMP_AMP] = ACTIONS(683),
    [anon_sym_AMP_EQ] = ACTIONS(1043),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_PERCENT_EQ] = ACTIONS(1043),
    [anon_sym_CARET] = ACTIONS(685),
    [anon_sym_CARET_EQ] = ACTIONS(1043),
    [anon_sym_PLUS_EQ] = ACTIONS(1043),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_LT_LT] = ACTIONS(689),
    [anon_sym_LT_LT_EQ] = ACTIONS(1043),
    [anon_sym_LT_EQ] = ACTIONS(681),
    [anon_sym_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(689),
    [anon_sym_GT_GT_EQ] = ACTIONS(1043),
    [anon_sym_PIPE] = ACTIONS(693),
    [anon_sym_PIPE_EQ] = ACTIONS(1043),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(697),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(699),
    [anon_sym_as] = ACTIONS(1043),
    [sym_line_comment] = ACTIONS(7),
  },
  [339] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(759),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(759),
    [sym_macro_invocation] = STATE(759),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(759),
    [sym_unary_expression] = STATE(759),
    [sym_try_expression] = STATE(759),
    [sym_reference_expression] = STATE(759),
    [sym_binary_expression] = STATE(759),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(759),
    [sym_call_expression] = STATE(759),
    [sym_array_expression] = STATE(759),
    [sym_parenthesized_expression] = STATE(759),
    [sym_tuple_expression] = STATE(759),
    [sym_unit_expression] = STATE(759),
    [sym_struct_expression] = STATE(759),
    [sym_if_expression] = STATE(759),
    [sym_if_let_expression] = STATE(759),
    [sym_match_expression] = STATE(759),
    [sym_while_expression] = STATE(759),
    [sym_while_let_expression] = STATE(759),
    [sym_loop_expression] = STATE(759),
    [sym_for_expression] = STATE(759),
    [sym_closure_expression] = STATE(759),
    [sym_closure_parameters] = STATE(101),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(759),
    [sym_continue_expression] = STATE(759),
    [sym_index_expression] = STATE(759),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(759),
    [sym_block] = STATE(759),
    [sym__literal] = STATE(759),
    [sym_string_literal] = STATE(759),
    [sym_boolean_literal] = STATE(759),
    [sym_raw_string_literal] = ACTIONS(1614),
    [sym_float_literal] = ACTIONS(1614),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(159),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(661),
    [anon_sym_DASH_GT] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(159),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(171),
    [sym_integer_literal] = ACTIONS(1614),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1614),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [340] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(760),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(760),
    [sym_macro_invocation] = STATE(760),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(760),
    [sym_unary_expression] = STATE(760),
    [sym_try_expression] = STATE(760),
    [sym_reference_expression] = STATE(760),
    [sym_binary_expression] = STATE(760),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(760),
    [sym_call_expression] = STATE(760),
    [sym_array_expression] = STATE(760),
    [sym_parenthesized_expression] = STATE(760),
    [sym_tuple_expression] = STATE(760),
    [sym_unit_expression] = STATE(760),
    [sym_struct_expression] = STATE(760),
    [sym_if_expression] = STATE(760),
    [sym_if_let_expression] = STATE(760),
    [sym_match_expression] = STATE(760),
    [sym_while_expression] = STATE(760),
    [sym_while_let_expression] = STATE(760),
    [sym_loop_expression] = STATE(760),
    [sym_for_expression] = STATE(760),
    [sym_closure_expression] = STATE(760),
    [sym_closure_parameters] = STATE(638),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(760),
    [sym_continue_expression] = STATE(760),
    [sym_index_expression] = STATE(760),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(760),
    [sym_block] = STATE(760),
    [sym__literal] = STATE(760),
    [sym_string_literal] = STATE(760),
    [sym_boolean_literal] = STATE(760),
    [sym_raw_string_literal] = ACTIONS(1616),
    [sym_float_literal] = ACTIONS(1616),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1245),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1247),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1251),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1253),
    [sym_integer_literal] = ACTIONS(1616),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1616),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [341] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(761),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(761),
    [sym_macro_invocation] = STATE(761),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(761),
    [sym_unary_expression] = STATE(761),
    [sym_try_expression] = STATE(761),
    [sym_reference_expression] = STATE(761),
    [sym_binary_expression] = STATE(761),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(761),
    [sym_call_expression] = STATE(761),
    [sym_array_expression] = STATE(761),
    [sym_parenthesized_expression] = STATE(761),
    [sym_tuple_expression] = STATE(761),
    [sym_unit_expression] = STATE(761),
    [sym_struct_expression] = STATE(761),
    [sym_if_expression] = STATE(761),
    [sym_if_let_expression] = STATE(761),
    [sym_match_expression] = STATE(761),
    [sym_while_expression] = STATE(761),
    [sym_while_let_expression] = STATE(761),
    [sym_loop_expression] = STATE(761),
    [sym_for_expression] = STATE(761),
    [sym_closure_expression] = STATE(761),
    [sym_closure_parameters] = STATE(101),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(761),
    [sym_continue_expression] = STATE(761),
    [sym_index_expression] = STATE(761),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(761),
    [sym_block] = STATE(761),
    [sym__literal] = STATE(761),
    [sym_string_literal] = STATE(761),
    [sym_boolean_literal] = STATE(761),
    [sym_raw_string_literal] = ACTIONS(1618),
    [sym_float_literal] = ACTIONS(1618),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(159),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(159),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(171),
    [sym_integer_literal] = ACTIONS(1618),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1618),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [342] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(640),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(640),
    [sym_macro_invocation] = STATE(640),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(640),
    [sym_unary_expression] = STATE(640),
    [sym_try_expression] = STATE(640),
    [sym_reference_expression] = STATE(640),
    [sym_binary_expression] = STATE(640),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(640),
    [sym_call_expression] = STATE(640),
    [sym_array_expression] = STATE(640),
    [sym_parenthesized_expression] = STATE(640),
    [sym_tuple_expression] = STATE(640),
    [sym_unit_expression] = STATE(640),
    [sym_struct_expression] = STATE(640),
    [sym_if_expression] = STATE(640),
    [sym_if_let_expression] = STATE(640),
    [sym_match_expression] = STATE(640),
    [sym_while_expression] = STATE(640),
    [sym_while_let_expression] = STATE(640),
    [sym_loop_expression] = STATE(640),
    [sym_for_expression] = STATE(640),
    [sym_closure_expression] = STATE(640),
    [sym_closure_parameters] = STATE(101),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(640),
    [sym_continue_expression] = STATE(640),
    [sym_index_expression] = STATE(640),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(640),
    [sym_block] = STATE(640),
    [sym__literal] = STATE(640),
    [sym_string_literal] = STATE(640),
    [sym_boolean_literal] = STATE(640),
    [sym_raw_string_literal] = ACTIONS(1257),
    [sym_float_literal] = ACTIONS(1257),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(159),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(159),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(171),
    [sym_integer_literal] = ACTIONS(1257),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1257),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [343] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(769),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(769),
    [sym_macro_invocation] = STATE(769),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(769),
    [sym_unary_expression] = STATE(769),
    [sym_try_expression] = STATE(769),
    [sym_reference_expression] = STATE(769),
    [sym_binary_expression] = STATE(769),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(769),
    [sym_call_expression] = STATE(769),
    [sym_array_expression] = STATE(769),
    [sym_parenthesized_expression] = STATE(769),
    [sym_tuple_expression] = STATE(769),
    [sym_unit_expression] = STATE(769),
    [sym_struct_expression] = STATE(769),
    [sym_if_expression] = STATE(769),
    [sym_if_let_expression] = STATE(769),
    [sym_match_expression] = STATE(769),
    [sym_while_expression] = STATE(769),
    [sym_while_let_expression] = STATE(769),
    [sym_loop_expression] = STATE(769),
    [sym_for_expression] = STATE(769),
    [sym_closure_expression] = STATE(769),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(769),
    [sym_continue_expression] = STATE(769),
    [sym_index_expression] = STATE(769),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(769),
    [sym_block] = STATE(769),
    [sym__literal] = STATE(769),
    [sym_string_literal] = STATE(769),
    [sym_boolean_literal] = STATE(769),
    [sym_raw_string_literal] = ACTIONS(1620),
    [sym_float_literal] = ACTIONS(1620),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_RBRACK] = ACTIONS(1622),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1620),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1620),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [344] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(771),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(771),
    [sym_macro_invocation] = STATE(771),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(771),
    [sym_unary_expression] = STATE(771),
    [sym_try_expression] = STATE(771),
    [sym_reference_expression] = STATE(771),
    [sym_binary_expression] = STATE(771),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(771),
    [sym_call_expression] = STATE(771),
    [sym_array_expression] = STATE(771),
    [sym_parenthesized_expression] = STATE(771),
    [sym_tuple_expression] = STATE(771),
    [sym_unit_expression] = STATE(771),
    [sym_struct_expression] = STATE(771),
    [sym_if_expression] = STATE(771),
    [sym_if_let_expression] = STATE(771),
    [sym_match_expression] = STATE(771),
    [sym_while_expression] = STATE(771),
    [sym_while_let_expression] = STATE(771),
    [sym_loop_expression] = STATE(771),
    [sym_for_expression] = STATE(771),
    [sym_closure_expression] = STATE(771),
    [sym_closure_parameters] = STATE(101),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(771),
    [sym_continue_expression] = STATE(771),
    [sym_index_expression] = STATE(771),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(771),
    [sym_block] = STATE(771),
    [sym__literal] = STATE(771),
    [sym_string_literal] = STATE(771),
    [sym_boolean_literal] = STATE(771),
    [sym_raw_string_literal] = ACTIONS(1636),
    [sym_float_literal] = ACTIONS(1636),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(159),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(159),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(171),
    [sym_integer_literal] = ACTIONS(1636),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1636),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [345] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(772),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(772),
    [sym_macro_invocation] = STATE(772),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(772),
    [sym_unary_expression] = STATE(772),
    [sym_try_expression] = STATE(772),
    [sym_reference_expression] = STATE(772),
    [sym_binary_expression] = STATE(772),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(772),
    [sym_call_expression] = STATE(772),
    [sym_array_expression] = STATE(772),
    [sym_parenthesized_expression] = STATE(772),
    [sym_tuple_expression] = STATE(772),
    [sym_unit_expression] = STATE(772),
    [sym_struct_expression] = STATE(772),
    [sym_if_expression] = STATE(772),
    [sym_if_let_expression] = STATE(772),
    [sym_match_expression] = STATE(772),
    [sym_while_expression] = STATE(772),
    [sym_while_let_expression] = STATE(772),
    [sym_loop_expression] = STATE(772),
    [sym_for_expression] = STATE(772),
    [sym_closure_expression] = STATE(772),
    [sym_closure_parameters] = STATE(101),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(772),
    [sym_continue_expression] = STATE(772),
    [sym_index_expression] = STATE(772),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(772),
    [sym_block] = STATE(772),
    [sym__literal] = STATE(772),
    [sym_string_literal] = STATE(772),
    [sym_boolean_literal] = STATE(772),
    [sym_raw_string_literal] = ACTIONS(1638),
    [sym_float_literal] = ACTIONS(1638),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(159),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(159),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(171),
    [sym_integer_literal] = ACTIONS(1638),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1638),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [346] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(773),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(773),
    [sym_macro_invocation] = STATE(773),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(773),
    [sym_unary_expression] = STATE(773),
    [sym_try_expression] = STATE(773),
    [sym_reference_expression] = STATE(773),
    [sym_binary_expression] = STATE(773),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(773),
    [sym_call_expression] = STATE(773),
    [sym_array_expression] = STATE(773),
    [sym_parenthesized_expression] = STATE(773),
    [sym_tuple_expression] = STATE(773),
    [sym_unit_expression] = STATE(773),
    [sym_struct_expression] = STATE(773),
    [sym_if_expression] = STATE(773),
    [sym_if_let_expression] = STATE(773),
    [sym_match_expression] = STATE(773),
    [sym_while_expression] = STATE(773),
    [sym_while_let_expression] = STATE(773),
    [sym_loop_expression] = STATE(773),
    [sym_for_expression] = STATE(773),
    [sym_closure_expression] = STATE(773),
    [sym_closure_parameters] = STATE(101),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(773),
    [sym_continue_expression] = STATE(773),
    [sym_index_expression] = STATE(773),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(773),
    [sym_block] = STATE(773),
    [sym__literal] = STATE(773),
    [sym_string_literal] = STATE(773),
    [sym_boolean_literal] = STATE(773),
    [sym_raw_string_literal] = ACTIONS(1640),
    [sym_float_literal] = ACTIONS(1640),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(159),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(159),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(171),
    [sym_integer_literal] = ACTIONS(1640),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1640),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [347] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(774),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(774),
    [sym_macro_invocation] = STATE(774),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(774),
    [sym_unary_expression] = STATE(774),
    [sym_try_expression] = STATE(774),
    [sym_reference_expression] = STATE(774),
    [sym_binary_expression] = STATE(774),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(774),
    [sym_call_expression] = STATE(774),
    [sym_array_expression] = STATE(774),
    [sym_parenthesized_expression] = STATE(774),
    [sym_tuple_expression] = STATE(774),
    [sym_unit_expression] = STATE(774),
    [sym_struct_expression] = STATE(774),
    [sym_if_expression] = STATE(774),
    [sym_if_let_expression] = STATE(774),
    [sym_match_expression] = STATE(774),
    [sym_while_expression] = STATE(774),
    [sym_while_let_expression] = STATE(774),
    [sym_loop_expression] = STATE(774),
    [sym_for_expression] = STATE(774),
    [sym_closure_expression] = STATE(774),
    [sym_closure_parameters] = STATE(101),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(774),
    [sym_continue_expression] = STATE(774),
    [sym_index_expression] = STATE(774),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(774),
    [sym_block] = STATE(774),
    [sym__literal] = STATE(774),
    [sym_string_literal] = STATE(774),
    [sym_boolean_literal] = STATE(774),
    [sym_raw_string_literal] = ACTIONS(1642),
    [sym_float_literal] = ACTIONS(1642),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(159),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(159),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(171),
    [sym_integer_literal] = ACTIONS(1642),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1642),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [348] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(775),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(775),
    [sym_macro_invocation] = STATE(775),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(775),
    [sym_unary_expression] = STATE(775),
    [sym_try_expression] = STATE(775),
    [sym_reference_expression] = STATE(775),
    [sym_binary_expression] = STATE(775),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(775),
    [sym_call_expression] = STATE(775),
    [sym_array_expression] = STATE(775),
    [sym_parenthesized_expression] = STATE(775),
    [sym_tuple_expression] = STATE(775),
    [sym_unit_expression] = STATE(775),
    [sym_struct_expression] = STATE(775),
    [sym_if_expression] = STATE(775),
    [sym_if_let_expression] = STATE(775),
    [sym_match_expression] = STATE(775),
    [sym_while_expression] = STATE(775),
    [sym_while_let_expression] = STATE(775),
    [sym_loop_expression] = STATE(775),
    [sym_for_expression] = STATE(775),
    [sym_closure_expression] = STATE(775),
    [sym_closure_parameters] = STATE(101),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(775),
    [sym_continue_expression] = STATE(775),
    [sym_index_expression] = STATE(775),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(775),
    [sym_block] = STATE(775),
    [sym__literal] = STATE(775),
    [sym_string_literal] = STATE(775),
    [sym_boolean_literal] = STATE(775),
    [sym_raw_string_literal] = ACTIONS(1644),
    [sym_float_literal] = ACTIONS(1644),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(159),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(159),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(171),
    [sym_integer_literal] = ACTIONS(1644),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1644),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [349] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(776),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(776),
    [sym_macro_invocation] = STATE(776),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(776),
    [sym_unary_expression] = STATE(776),
    [sym_try_expression] = STATE(776),
    [sym_reference_expression] = STATE(776),
    [sym_binary_expression] = STATE(776),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(776),
    [sym_call_expression] = STATE(776),
    [sym_array_expression] = STATE(776),
    [sym_parenthesized_expression] = STATE(776),
    [sym_tuple_expression] = STATE(776),
    [sym_unit_expression] = STATE(776),
    [sym_struct_expression] = STATE(776),
    [sym_if_expression] = STATE(776),
    [sym_if_let_expression] = STATE(776),
    [sym_match_expression] = STATE(776),
    [sym_while_expression] = STATE(776),
    [sym_while_let_expression] = STATE(776),
    [sym_loop_expression] = STATE(776),
    [sym_for_expression] = STATE(776),
    [sym_closure_expression] = STATE(776),
    [sym_closure_parameters] = STATE(101),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(776),
    [sym_continue_expression] = STATE(776),
    [sym_index_expression] = STATE(776),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(776),
    [sym_block] = STATE(776),
    [sym__literal] = STATE(776),
    [sym_string_literal] = STATE(776),
    [sym_boolean_literal] = STATE(776),
    [sym_raw_string_literal] = ACTIONS(1646),
    [sym_float_literal] = ACTIONS(1646),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(159),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(159),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(171),
    [sym_integer_literal] = ACTIONS(1646),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1646),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [350] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(777),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(777),
    [sym_macro_invocation] = STATE(777),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(777),
    [sym_unary_expression] = STATE(777),
    [sym_try_expression] = STATE(777),
    [sym_reference_expression] = STATE(777),
    [sym_binary_expression] = STATE(777),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(777),
    [sym_call_expression] = STATE(777),
    [sym_array_expression] = STATE(777),
    [sym_parenthesized_expression] = STATE(777),
    [sym_tuple_expression] = STATE(777),
    [sym_unit_expression] = STATE(777),
    [sym_struct_expression] = STATE(777),
    [sym_if_expression] = STATE(777),
    [sym_if_let_expression] = STATE(777),
    [sym_match_expression] = STATE(777),
    [sym_while_expression] = STATE(777),
    [sym_while_let_expression] = STATE(777),
    [sym_loop_expression] = STATE(777),
    [sym_for_expression] = STATE(777),
    [sym_closure_expression] = STATE(777),
    [sym_closure_parameters] = STATE(101),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(777),
    [sym_continue_expression] = STATE(777),
    [sym_index_expression] = STATE(777),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(777),
    [sym_block] = STATE(777),
    [sym__literal] = STATE(777),
    [sym_string_literal] = STATE(777),
    [sym_boolean_literal] = STATE(777),
    [sym_raw_string_literal] = ACTIONS(1648),
    [sym_float_literal] = ACTIONS(1648),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(159),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(159),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(171),
    [sym_integer_literal] = ACTIONS(1648),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1648),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [351] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(778),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(778),
    [sym_macro_invocation] = STATE(778),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(778),
    [sym_unary_expression] = STATE(778),
    [sym_try_expression] = STATE(778),
    [sym_reference_expression] = STATE(778),
    [sym_binary_expression] = STATE(778),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(778),
    [sym_call_expression] = STATE(778),
    [sym_array_expression] = STATE(778),
    [sym_parenthesized_expression] = STATE(778),
    [sym_tuple_expression] = STATE(778),
    [sym_unit_expression] = STATE(778),
    [sym_struct_expression] = STATE(778),
    [sym_if_expression] = STATE(778),
    [sym_if_let_expression] = STATE(778),
    [sym_match_expression] = STATE(778),
    [sym_while_expression] = STATE(778),
    [sym_while_let_expression] = STATE(778),
    [sym_loop_expression] = STATE(778),
    [sym_for_expression] = STATE(778),
    [sym_closure_expression] = STATE(778),
    [sym_closure_parameters] = STATE(101),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(778),
    [sym_continue_expression] = STATE(778),
    [sym_index_expression] = STATE(778),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(778),
    [sym_block] = STATE(778),
    [sym__literal] = STATE(778),
    [sym_string_literal] = STATE(778),
    [sym_boolean_literal] = STATE(778),
    [sym_raw_string_literal] = ACTIONS(1650),
    [sym_float_literal] = ACTIONS(1650),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(159),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(159),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(171),
    [sym_integer_literal] = ACTIONS(1650),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1650),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [352] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(779),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(779),
    [sym_macro_invocation] = STATE(779),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(779),
    [sym_unary_expression] = STATE(779),
    [sym_try_expression] = STATE(779),
    [sym_reference_expression] = STATE(779),
    [sym_binary_expression] = STATE(779),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(779),
    [sym_call_expression] = STATE(779),
    [sym_array_expression] = STATE(779),
    [sym_parenthesized_expression] = STATE(779),
    [sym_tuple_expression] = STATE(779),
    [sym_unit_expression] = STATE(779),
    [sym_struct_expression] = STATE(779),
    [sym_if_expression] = STATE(779),
    [sym_if_let_expression] = STATE(779),
    [sym_match_expression] = STATE(779),
    [sym_while_expression] = STATE(779),
    [sym_while_let_expression] = STATE(779),
    [sym_loop_expression] = STATE(779),
    [sym_for_expression] = STATE(779),
    [sym_closure_expression] = STATE(779),
    [sym_closure_parameters] = STATE(101),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(779),
    [sym_continue_expression] = STATE(779),
    [sym_index_expression] = STATE(779),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(779),
    [sym_block] = STATE(779),
    [sym__literal] = STATE(779),
    [sym_string_literal] = STATE(779),
    [sym_boolean_literal] = STATE(779),
    [sym_raw_string_literal] = ACTIONS(1652),
    [sym_float_literal] = ACTIONS(1652),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(159),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(159),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(171),
    [sym_integer_literal] = ACTIONS(1652),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1652),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [353] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(780),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(780),
    [sym_macro_invocation] = STATE(780),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(780),
    [sym_unary_expression] = STATE(780),
    [sym_try_expression] = STATE(780),
    [sym_reference_expression] = STATE(780),
    [sym_binary_expression] = STATE(780),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_array_expression] = STATE(780),
    [sym_parenthesized_expression] = STATE(780),
    [sym_tuple_expression] = STATE(780),
    [sym_unit_expression] = STATE(780),
    [sym_struct_expression] = STATE(780),
    [sym_if_expression] = STATE(780),
    [sym_if_let_expression] = STATE(780),
    [sym_match_expression] = STATE(780),
    [sym_while_expression] = STATE(780),
    [sym_while_let_expression] = STATE(780),
    [sym_loop_expression] = STATE(780),
    [sym_for_expression] = STATE(780),
    [sym_closure_expression] = STATE(780),
    [sym_closure_parameters] = STATE(101),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(780),
    [sym_continue_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(780),
    [sym_block] = STATE(780),
    [sym__literal] = STATE(780),
    [sym_string_literal] = STATE(780),
    [sym_boolean_literal] = STATE(780),
    [sym_raw_string_literal] = ACTIONS(1654),
    [sym_float_literal] = ACTIONS(1654),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(909),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(911),
    [anon_sym_STAR] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_DASH] = ACTIONS(911),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(911),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(911),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_LT_LT] = ACTIONS(911),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(909),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_EQ_EQ] = ACTIONS(909),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(911),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_as] = ACTIONS(911),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(171),
    [sym_integer_literal] = ACTIONS(1654),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1654),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [354] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(780),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(780),
    [sym_macro_invocation] = STATE(780),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(780),
    [sym_unary_expression] = STATE(780),
    [sym_try_expression] = STATE(780),
    [sym_reference_expression] = STATE(780),
    [sym_binary_expression] = STATE(780),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_array_expression] = STATE(780),
    [sym_parenthesized_expression] = STATE(780),
    [sym_tuple_expression] = STATE(780),
    [sym_unit_expression] = STATE(780),
    [sym_struct_expression] = STATE(780),
    [sym_if_expression] = STATE(780),
    [sym_if_let_expression] = STATE(780),
    [sym_match_expression] = STATE(780),
    [sym_while_expression] = STATE(780),
    [sym_while_let_expression] = STATE(780),
    [sym_loop_expression] = STATE(780),
    [sym_for_expression] = STATE(780),
    [sym_closure_expression] = STATE(780),
    [sym_closure_parameters] = STATE(101),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(780),
    [sym_continue_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(780),
    [sym_block] = STATE(780),
    [sym__literal] = STATE(780),
    [sym_string_literal] = STATE(780),
    [sym_boolean_literal] = STATE(780),
    [sym_raw_string_literal] = ACTIONS(1654),
    [sym_float_literal] = ACTIONS(1654),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(159),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(159),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(171),
    [sym_integer_literal] = ACTIONS(1654),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1654),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [355] = {
    [sym_function_modifiers] = STATE(785),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(666),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(786),
    [sym_array_type] = STATE(666),
    [sym_function_type] = STATE(666),
    [sym_tuple_type] = STATE(666),
    [sym_unit_type] = STATE(666),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(666),
    [sym_reference_type] = STATE(666),
    [sym_pointer_type] = STATE(666),
    [sym_empty_type] = STATE(666),
    [sym_dynamic_type] = STATE(666),
    [sym_macro_invocation] = STATE(666),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(787),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1656),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1658),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1660),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1662),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [356] = {
    [aux_sym_token_tree_repeat2] = STATE(789),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACK] = ACTIONS(1622),
    [anon_sym_COMMA] = ACTIONS(1664),
    [sym_line_comment] = ACTIONS(7),
  },
  [357] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1323),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(1323),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_COMMA] = ACTIONS(1323),
    [anon_sym_AMP] = ACTIONS(677),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(679),
    [anon_sym_BANG_EQ] = ACTIONS(681),
    [anon_sym_STAR_EQ] = ACTIONS(679),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_SLASH_EQ] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(683),
    [anon_sym_AMP_EQ] = ACTIONS(679),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_PERCENT_EQ] = ACTIONS(679),
    [anon_sym_CARET] = ACTIONS(685),
    [anon_sym_CARET_EQ] = ACTIONS(679),
    [anon_sym_PLUS_EQ] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_LT_LT] = ACTIONS(689),
    [anon_sym_LT_LT_EQ] = ACTIONS(679),
    [anon_sym_LT_EQ] = ACTIONS(681),
    [anon_sym_EQ] = ACTIONS(691),
    [anon_sym_EQ_EQ] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(689),
    [anon_sym_GT_GT_EQ] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(693),
    [anon_sym_PIPE_EQ] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(697),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(699),
    [anon_sym_as] = ACTIONS(701),
    [sym_line_comment] = ACTIONS(7),
  },
  [358] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(790),
    [sym_tuple_pattern] = STATE(790),
    [sym_tuple_struct_pattern] = STATE(790),
    [sym_struct_pattern] = STATE(790),
    [sym_remaining_field_pattern] = STATE(790),
    [sym_mut_pattern] = STATE(790),
    [sym_ref_pattern] = STATE(790),
    [sym_captured_pattern] = STATE(790),
    [sym_reference_pattern] = STATE(790),
    [sym__literal] = STATE(790),
    [sym_string_literal] = STATE(790),
    [sym_boolean_literal] = STATE(790),
    [sym_raw_string_literal] = ACTIONS(1666),
    [sym_float_literal] = ACTIONS(1666),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(1668),
    [anon_sym_AMP] = ACTIONS(955),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(957),
    [anon_sym_ref] = ACTIONS(959),
    [sym_integer_literal] = ACTIONS(1666),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(1666),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(961),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [359] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(791),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [360] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1670),
    [anon_sym_LPAREN] = ACTIONS(1670),
    [anon_sym_RPAREN] = ACTIONS(1670),
    [anon_sym_LBRACE] = ACTIONS(1672),
    [anon_sym_RBRACE] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(1670),
    [anon_sym_RBRACK] = ACTIONS(1670),
    [anon_sym_PLUS] = ACTIONS(1674),
    [anon_sym_STAR] = ACTIONS(1674),
    [anon_sym_COMMA] = ACTIONS(1670),
    [anon_sym_AMP] = ACTIONS(1674),
    [anon_sym_DASH] = ACTIONS(1674),
    [anon_sym_DOT] = ACTIONS(1674),
    [anon_sym_DASH_EQ] = ACTIONS(1670),
    [anon_sym_COLON_COLON] = ACTIONS(1670),
    [anon_sym_BANG_EQ] = ACTIONS(1670),
    [anon_sym_STAR_EQ] = ACTIONS(1670),
    [anon_sym_SLASH] = ACTIONS(1674),
    [anon_sym_SLASH_EQ] = ACTIONS(1670),
    [anon_sym_AMP_AMP] = ACTIONS(1670),
    [anon_sym_AMP_EQ] = ACTIONS(1670),
    [anon_sym_PERCENT] = ACTIONS(1674),
    [anon_sym_PERCENT_EQ] = ACTIONS(1670),
    [anon_sym_CARET] = ACTIONS(1674),
    [anon_sym_CARET_EQ] = ACTIONS(1670),
    [anon_sym_PLUS_EQ] = ACTIONS(1670),
    [anon_sym_LT] = ACTIONS(1674),
    [anon_sym_LT_LT] = ACTIONS(1674),
    [anon_sym_LT_LT_EQ] = ACTIONS(1670),
    [anon_sym_LT_EQ] = ACTIONS(1670),
    [anon_sym_EQ] = ACTIONS(1674),
    [anon_sym_EQ_EQ] = ACTIONS(1670),
    [anon_sym_GT] = ACTIONS(1674),
    [anon_sym_GT_EQ] = ACTIONS(1670),
    [anon_sym_GT_GT] = ACTIONS(1674),
    [anon_sym_GT_GT_EQ] = ACTIONS(1670),
    [anon_sym_PIPE] = ACTIONS(1674),
    [anon_sym_PIPE_EQ] = ACTIONS(1670),
    [anon_sym_PIPE_PIPE] = ACTIONS(1670),
    [anon_sym_QMARK] = ACTIONS(1670),
    [anon_sym_DOT_DOT] = ACTIONS(1674),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1670),
    [anon_sym_as] = ACTIONS(1670),
    [sym_line_comment] = ACTIONS(7),
  },
  [361] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1676),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(1676),
    [anon_sym_LBRACE] = ACTIONS(1676),
    [anon_sym_RBRACE] = ACTIONS(1676),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(1676),
    [anon_sym_PLUS] = ACTIONS(1678),
    [anon_sym_STAR] = ACTIONS(1678),
    [anon_sym_COMMA] = ACTIONS(1676),
    [anon_sym_AMP] = ACTIONS(1678),
    [anon_sym_DASH] = ACTIONS(1678),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(1676),
    [anon_sym_BANG_EQ] = ACTIONS(1676),
    [anon_sym_STAR_EQ] = ACTIONS(1676),
    [anon_sym_SLASH] = ACTIONS(1678),
    [anon_sym_SLASH_EQ] = ACTIONS(1676),
    [anon_sym_AMP_AMP] = ACTIONS(1676),
    [anon_sym_AMP_EQ] = ACTIONS(1676),
    [anon_sym_PERCENT] = ACTIONS(1678),
    [anon_sym_PERCENT_EQ] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1678),
    [anon_sym_CARET_EQ] = ACTIONS(1676),
    [anon_sym_PLUS_EQ] = ACTIONS(1676),
    [anon_sym_LT] = ACTIONS(1678),
    [anon_sym_LT_LT] = ACTIONS(1678),
    [anon_sym_LT_LT_EQ] = ACTIONS(1676),
    [anon_sym_LT_EQ] = ACTIONS(1676),
    [anon_sym_EQ] = ACTIONS(1678),
    [anon_sym_EQ_EQ] = ACTIONS(1676),
    [anon_sym_GT] = ACTIONS(1678),
    [anon_sym_GT_EQ] = ACTIONS(1676),
    [anon_sym_GT_GT] = ACTIONS(1678),
    [anon_sym_GT_GT_EQ] = ACTIONS(1676),
    [anon_sym_PIPE] = ACTIONS(1678),
    [anon_sym_PIPE_EQ] = ACTIONS(1676),
    [anon_sym_PIPE_PIPE] = ACTIONS(1676),
    [anon_sym_QMARK] = ACTIONS(1676),
    [anon_sym_DOT_DOT] = ACTIONS(1678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1676),
    [anon_sym_as] = ACTIONS(1676),
    [sym_line_comment] = ACTIONS(7),
  },
  [362] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1680),
    [anon_sym_RPAREN] = ACTIONS(1682),
    [anon_sym_RBRACK] = ACTIONS(1682),
    [anon_sym_COMMA] = ACTIONS(1682),
    [anon_sym_EQ] = ACTIONS(1684),
    [sym_line_comment] = ACTIONS(7),
  },
  [363] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACK] = ACTIONS(1686),
    [sym_line_comment] = ACTIONS(7),
  },
  [364] = {
    [sym_meta_item] = STATE(795),
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(727),
  },
  [365] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1688),
    [anon_sym_LPAREN] = ACTIONS(1688),
    [anon_sym_RPAREN] = ACTIONS(1688),
    [anon_sym_LBRACE] = ACTIONS(1688),
    [anon_sym_RBRACE] = ACTIONS(1688),
    [anon_sym_RBRACK] = ACTIONS(1688),
    [anon_sym_COLON] = ACTIONS(1688),
    [anon_sym_PLUS] = ACTIONS(1688),
    [anon_sym_COMMA] = ACTIONS(1688),
    [anon_sym_EQ] = ACTIONS(1688),
    [anon_sym_GT] = ACTIONS(1688),
    [anon_sym_PIPE] = ACTIONS(1688),
    [anon_sym_as] = ACTIONS(1688),
    [anon_sym_where] = ACTIONS(1688),
    [sym_line_comment] = ACTIONS(7),
  },
  [366] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(1690),
    [sym_mutable_specifier] = ACTIONS(1690),
    [sym_line_comment] = ACTIONS(7),
  },
  [367] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(385),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(798),
    [sym_array_type] = STATE(385),
    [sym_function_type] = STATE(385),
    [sym_tuple_type] = STATE(385),
    [sym_unit_type] = STATE(385),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(385),
    [sym_reference_type] = STATE(385),
    [sym_pointer_type] = STATE(385),
    [sym_empty_type] = STATE(385),
    [sym_dynamic_type] = STATE(385),
    [sym_macro_invocation] = STATE(385),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(1692),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [368] = {
    [sym_parameters] = STATE(799),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [369] = {
    [sym_parameters] = STATE(800),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_RPAREN] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_BANG] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [370] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(803),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_fn] = ACTIONS(1694),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1696),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [371] = {
    [aux_sym_tuple_type_repeat1] = STATE(807),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(1698),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_COMMA] = ACTIONS(1702),
    [sym_line_comment] = ACTIONS(7),
  },
  [372] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(1704),
    [sym_line_comment] = ACTIONS(7),
  },
  [373] = {
    [sym_parameters] = STATE(799),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_RPAREN] = ACTIONS(783),
    [anon_sym_PLUS] = ACTIONS(783),
    [anon_sym_COMMA] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [374] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(1706),
    [sym_mutable_specifier] = ACTIONS(1706),
    [sym_line_comment] = ACTIONS(7),
  },
  [375] = {
    [sym_function_modifiers] = STATE(378),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(385),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(811),
    [sym_array_type] = STATE(385),
    [sym_function_type] = STATE(385),
    [sym_tuple_type] = STATE(385),
    [sym_unit_type] = STATE(385),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(385),
    [sym_reference_type] = STATE(385),
    [sym_pointer_type] = STATE(385),
    [sym_empty_type] = STATE(385),
    [sym_dynamic_type] = STATE(385),
    [sym_macro_invocation] = STATE(385),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(381),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(741),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(745),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(1708),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(747),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [376] = {
    [sym_parameters] = STATE(812),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [377] = {
    [sym_parameters] = STATE(813),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_RBRACK] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_BANG] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [378] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(816),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_fn] = ACTIONS(1710),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1712),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [379] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1714),
    [anon_sym_RBRACK] = ACTIONS(1716),
    [anon_sym_PLUS] = ACTIONS(1718),
    [sym_line_comment] = ACTIONS(7),
  },
  [380] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(1720),
    [sym_line_comment] = ACTIONS(7),
  },
  [381] = {
    [sym_parameters] = STATE(812),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(783),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_RBRACK] = ACTIONS(783),
    [anon_sym_PLUS] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [382] = {
    [sym_function_modifiers] = STATE(124),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(821),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(127),
    [sym_array_type] = STATE(821),
    [sym_function_type] = STATE(821),
    [sym_tuple_type] = STATE(821),
    [sym_unit_type] = STATE(821),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(821),
    [sym_reference_type] = STATE(821),
    [sym_pointer_type] = STATE(821),
    [sym_empty_type] = STATE(821),
    [sym_dynamic_type] = STATE(821),
    [sym_macro_invocation] = STATE(821),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(131),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(197),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(201),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(211),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(217),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [383] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1722),
  },
  [384] = {
    [sym_function_modifiers] = STATE(124),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(127),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(131),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(197),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(201),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(211),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(217),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [385] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1724),
    [anon_sym_LPAREN] = ACTIONS(1724),
    [anon_sym_RPAREN] = ACTIONS(1724),
    [anon_sym_LBRACE] = ACTIONS(1724),
    [anon_sym_RBRACE] = ACTIONS(1724),
    [anon_sym_RBRACK] = ACTIONS(1724),
    [anon_sym_COLON] = ACTIONS(1724),
    [anon_sym_PLUS] = ACTIONS(1724),
    [anon_sym_COMMA] = ACTIONS(1724),
    [anon_sym_EQ] = ACTIONS(1724),
    [anon_sym_GT] = ACTIONS(1724),
    [anon_sym_PIPE] = ACTIONS(1724),
    [anon_sym_as] = ACTIONS(1724),
    [anon_sym_where] = ACTIONS(1724),
    [sym_line_comment] = ACTIONS(7),
  },
  [386] = {
    [sym_function_modifiers] = STATE(124),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(127),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(131),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(797),
    [anon_sym_STAR] = ACTIONS(197),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(201),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(211),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(1726),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(217),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [387] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_LPAREN] = ACTIONS(1728),
    [anon_sym_RPAREN] = ACTIONS(1728),
    [anon_sym_LBRACE] = ACTIONS(1728),
    [anon_sym_RBRACE] = ACTIONS(1728),
    [anon_sym_RBRACK] = ACTIONS(1728),
    [anon_sym_COLON] = ACTIONS(1730),
    [anon_sym_PLUS] = ACTIONS(1728),
    [anon_sym_COMMA] = ACTIONS(1728),
    [anon_sym_COLON_COLON] = ACTIONS(721),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_EQ] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_as] = ACTIONS(1728),
    [anon_sym_for] = ACTIONS(1728),
    [anon_sym_where] = ACTIONS(1728),
    [sym_line_comment] = ACTIONS(7),
  },
  [388] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1732),
    [anon_sym_LPAREN] = ACTIONS(1732),
    [anon_sym_RPAREN] = ACTIONS(1732),
    [anon_sym_LBRACE] = ACTIONS(1732),
    [anon_sym_RBRACE] = ACTIONS(1732),
    [anon_sym_LBRACK] = ACTIONS(1732),
    [anon_sym_RBRACK] = ACTIONS(1732),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_STAR] = ACTIONS(1732),
    [anon_sym_COMMA] = ACTIONS(1732),
    [anon_sym_u8] = ACTIONS(1734),
    [anon_sym_i8] = ACTIONS(1734),
    [anon_sym_u16] = ACTIONS(1734),
    [anon_sym_i16] = ACTIONS(1734),
    [anon_sym_u32] = ACTIONS(1734),
    [anon_sym_i32] = ACTIONS(1734),
    [anon_sym_u64] = ACTIONS(1734),
    [anon_sym_i64] = ACTIONS(1734),
    [anon_sym_u128] = ACTIONS(1734),
    [anon_sym_i128] = ACTIONS(1734),
    [anon_sym_isize] = ACTIONS(1734),
    [anon_sym_usize] = ACTIONS(1734),
    [anon_sym_f32] = ACTIONS(1734),
    [anon_sym_f64] = ACTIONS(1734),
    [anon_sym_bool] = ACTIONS(1734),
    [anon_sym_str] = ACTIONS(1734),
    [anon_sym_char] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(1732),
    [anon_sym_COLON_COLON] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(1732),
    [anon_sym_LT] = ACTIONS(1732),
    [anon_sym_EQ] = ACTIONS(1732),
    [anon_sym_GT] = ACTIONS(1732),
    [anon_sym_PIPE] = ACTIONS(1732),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [anon_sym_as] = ACTIONS(1734),
    [anon_sym_const] = ACTIONS(1734),
    [anon_sym_default] = ACTIONS(1734),
    [anon_sym_fn] = ACTIONS(1734),
    [anon_sym_unsafe] = ACTIONS(1734),
    [anon_sym_where] = ACTIONS(1734),
    [anon_sym_extern] = ACTIONS(1734),
    [anon_sym_dyn] = ACTIONS(1734),
    [sym_mutable_specifier] = ACTIONS(1734),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1734),
    [sym_self] = ACTIONS(1734),
    [sym_super] = ACTIONS(1734),
    [sym_crate] = ACTIONS(1734),
    [sym_metavariable] = ACTIONS(1732),
  },
  [389] = {
    [sym_function_modifiers] = STATE(370),
    [sym_self_parameter] = STATE(837),
    [sym_variadic_parameter] = STATE(837),
    [sym_parameter] = STATE(837),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(838),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(839),
    [sym_array_type] = STATE(838),
    [sym_function_type] = STATE(838),
    [sym_tuple_type] = STATE(838),
    [sym_unit_type] = STATE(838),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(838),
    [sym_reference_type] = STATE(838),
    [sym_pointer_type] = STATE(838),
    [sym_empty_type] = STATE(838),
    [sym_abstract_type] = STATE(837),
    [sym_dynamic_type] = STATE(838),
    [sym_macro_invocation] = STATE(838),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [sym_reference_pattern_in_parameter] = STATE(840),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_RPAREN] = ACTIONS(1736),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(1738),
    [anon_sym_u8] = ACTIONS(1740),
    [anon_sym_i8] = ACTIONS(1740),
    [anon_sym_u16] = ACTIONS(1740),
    [anon_sym_i16] = ACTIONS(1740),
    [anon_sym_u32] = ACTIONS(1740),
    [anon_sym_i32] = ACTIONS(1740),
    [anon_sym_u64] = ACTIONS(1740),
    [anon_sym_i64] = ACTIONS(1740),
    [anon_sym_u128] = ACTIONS(1740),
    [anon_sym_i128] = ACTIONS(1740),
    [anon_sym_isize] = ACTIONS(1740),
    [anon_sym_usize] = ACTIONS(1740),
    [anon_sym_f32] = ACTIONS(1740),
    [anon_sym_f64] = ACTIONS(1740),
    [anon_sym_bool] = ACTIONS(1740),
    [anon_sym_str] = ACTIONS(1740),
    [anon_sym_char] = ACTIONS(1740),
    [anon_sym__] = ACTIONS(1742),
    [anon_sym_AMP] = ACTIONS(1744),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1746),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(1748),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_union] = ACTIONS(1752),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(1754),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1756),
    [sym_self] = ACTIONS(1758),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [390] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(1762),
    [anon_sym_GT] = ACTIONS(1760),
    [anon_sym_as] = ACTIONS(1760),
    [sym_line_comment] = ACTIONS(7),
  },
  [391] = {
    [aux_sym_string_literal_repeat1] = STATE(843),
    [sym_block_comment] = ACTIONS(7),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_RBRACK_PLUS_SLASH] = ACTIONS(1764),
    [anon_sym_DQUOTE] = ACTIONS(1766),
    [sym_escape_sequence] = ACTIONS(1764),
    [sym_line_comment] = ACTIONS(401),
  },
  [392] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(1768),
    [anon_sym_i8] = ACTIONS(1768),
    [anon_sym_u16] = ACTIONS(1768),
    [anon_sym_i16] = ACTIONS(1768),
    [anon_sym_u32] = ACTIONS(1768),
    [anon_sym_i32] = ACTIONS(1768),
    [anon_sym_u64] = ACTIONS(1768),
    [anon_sym_i64] = ACTIONS(1768),
    [anon_sym_u128] = ACTIONS(1768),
    [anon_sym_i128] = ACTIONS(1768),
    [anon_sym_isize] = ACTIONS(1768),
    [anon_sym_usize] = ACTIONS(1768),
    [anon_sym_f32] = ACTIONS(1768),
    [anon_sym_f64] = ACTIONS(1768),
    [anon_sym_bool] = ACTIONS(1768),
    [anon_sym_str] = ACTIONS(1768),
    [anon_sym_char] = ACTIONS(1768),
    [anon_sym_COLON_COLON] = ACTIONS(1115),
    [anon_sym_LT] = ACTIONS(1115),
    [anon_sym_const] = ACTIONS(1768),
    [anon_sym_default] = ACTIONS(1768),
    [anon_sym_fn] = ACTIONS(1768),
    [anon_sym_unsafe] = ACTIONS(1768),
    [anon_sym_extern] = ACTIONS(1768),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1768),
    [sym_self] = ACTIONS(1768),
    [sym_super] = ACTIONS(1768),
    [sym_crate] = ACTIONS(1768),
    [sym_metavariable] = ACTIONS(1115),
  },
  [393] = {
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(1770),
    [anon_sym_RPAREN] = ACTIONS(1770),
    [anon_sym_LBRACE] = ACTIONS(1770),
    [anon_sym_RBRACE] = ACTIONS(1770),
    [anon_sym_RBRACK] = ACTIONS(1770),
    [anon_sym_COLON] = ACTIONS(1772),
    [anon_sym_PLUS] = ACTIONS(1770),
    [anon_sym_COMMA] = ACTIONS(1770),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_EQ] = ACTIONS(1770),
    [anon_sym_GT] = ACTIONS(1770),
    [anon_sym_PIPE] = ACTIONS(1770),
    [anon_sym_as] = ACTIONS(1770),
    [anon_sym_where] = ACTIONS(1770),
    [sym_line_comment] = ACTIONS(7),
  },
  [394] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1774),
    [anon_sym_LPAREN] = ACTIONS(1774),
    [anon_sym_RPAREN] = ACTIONS(1774),
    [anon_sym_LBRACE] = ACTIONS(1774),
    [anon_sym_RBRACE] = ACTIONS(1774),
    [anon_sym_RBRACK] = ACTIONS(1774),
    [anon_sym_COLON] = ACTIONS(1776),
    [anon_sym_PLUS] = ACTIONS(1774),
    [anon_sym_COMMA] = ACTIONS(1774),
    [anon_sym_COLON_COLON] = ACTIONS(799),
    [anon_sym_EQ] = ACTIONS(1774),
    [anon_sym_GT] = ACTIONS(1774),
    [anon_sym_PIPE] = ACTIONS(1774),
    [anon_sym_as] = ACTIONS(1774),
    [anon_sym_where] = ACTIONS(1774),
    [sym_line_comment] = ACTIONS(7),
  },
  [395] = {
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1774),
    [anon_sym_LPAREN] = ACTIONS(1774),
    [anon_sym_RPAREN] = ACTIONS(1774),
    [anon_sym_LBRACE] = ACTIONS(1774),
    [anon_sym_RBRACE] = ACTIONS(1774),
    [anon_sym_RBRACK] = ACTIONS(1774),
    [anon_sym_COLON] = ACTIONS(1774),
    [anon_sym_PLUS] = ACTIONS(1774),
    [anon_sym_COMMA] = ACTIONS(1774),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_EQ] = ACTIONS(1774),
    [anon_sym_GT] = ACTIONS(1774),
    [anon_sym_PIPE] = ACTIONS(1774),
    [anon_sym_as] = ACTIONS(1774),
    [anon_sym_where] = ACTIONS(1774),
    [sym_line_comment] = ACTIONS(7),
  },
  [396] = {
    [sym_type_arguments] = STATE(845),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1778),
  },
  [397] = {
    [sym_token_tree] = STATE(849),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1780),
    [anon_sym_LBRACE] = ACTIONS(1782),
    [anon_sym_LBRACK] = ACTIONS(1784),
    [sym_line_comment] = ACTIONS(7),
  },
  [398] = {
    [sym_function_modifiers] = STATE(854),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(855),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(856),
    [sym_array_type] = STATE(855),
    [sym_function_type] = STATE(855),
    [sym_tuple_type] = STATE(855),
    [sym_unit_type] = STATE(855),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(855),
    [sym_type_binding] = STATE(857),
    [sym_reference_type] = STATE(855),
    [sym_pointer_type] = STATE(855),
    [sym_empty_type] = STATE(855),
    [sym_dynamic_type] = STATE(855),
    [sym_macro_invocation] = STATE(855),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(858),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1786),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1788),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1790),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1792),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [399] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(1794),
    [anon_sym_DASH_GT] = ACTIONS(1796),
    [anon_sym_GT] = ACTIONS(1794),
    [anon_sym_as] = ACTIONS(1794),
    [sym_line_comment] = ACTIONS(7),
  },
  [400] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1798),
    [anon_sym_LPAREN] = ACTIONS(1798),
    [anon_sym_RPAREN] = ACTIONS(1798),
    [anon_sym_LBRACE] = ACTIONS(1798),
    [anon_sym_RBRACE] = ACTIONS(1798),
    [anon_sym_RBRACK] = ACTIONS(1798),
    [anon_sym_COLON] = ACTIONS(1800),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_COMMA] = ACTIONS(1798),
    [anon_sym_COLON_COLON] = ACTIONS(1798),
    [anon_sym_EQ] = ACTIONS(1798),
    [anon_sym_GT] = ACTIONS(1798),
    [anon_sym_PIPE] = ACTIONS(1798),
    [anon_sym_as] = ACTIONS(1798),
    [anon_sym_where] = ACTIONS(1798),
    [sym_line_comment] = ACTIONS(7),
  },
  [401] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1778),
  },
  [402] = {
    [sym_parameters] = STATE(860),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [403] = {
    [sym_parameters] = STATE(861),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [404] = {
    [sym_parameters] = STATE(860),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [405] = {
    [sym_function_modifiers] = STATE(124),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(862),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(131),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(197),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(201),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(211),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(217),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [406] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON_COLON] = ACTIONS(1802),
    [sym_line_comment] = ACTIONS(7),
  },
  [407] = {
    [sym_function_modifiers] = STATE(867),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(868),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(869),
    [sym_array_type] = STATE(868),
    [sym_function_type] = STATE(868),
    [sym_tuple_type] = STATE(868),
    [sym_unit_type] = STATE(868),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(868),
    [sym_reference_type] = STATE(868),
    [sym_pointer_type] = STATE(868),
    [sym_empty_type] = STATE(868),
    [sym_dynamic_type] = STATE(868),
    [sym_macro_invocation] = STATE(868),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(870),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1806),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1808),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1810),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [408] = {
    [sym_function_modifiers] = STATE(124),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(127),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(131),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(197),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(201),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(211),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(217),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [409] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1812),
  },
  [410] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1814),
  },
  [411] = {
    [sym_type_arguments] = STATE(873),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1778),
  },
  [412] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1816),
    [anon_sym_LPAREN] = ACTIONS(1816),
    [anon_sym_RPAREN] = ACTIONS(1816),
    [anon_sym_LBRACE] = ACTIONS(1816),
    [anon_sym_RBRACE] = ACTIONS(1816),
    [anon_sym_RBRACK] = ACTIONS(1816),
    [anon_sym_COLON] = ACTIONS(1818),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_COMMA] = ACTIONS(1816),
    [anon_sym_COLON_COLON] = ACTIONS(1816),
    [anon_sym_EQ] = ACTIONS(1816),
    [anon_sym_GT] = ACTIONS(1816),
    [anon_sym_PIPE] = ACTIONS(1816),
    [anon_sym_as] = ACTIONS(1816),
    [anon_sym_where] = ACTIONS(1816),
    [sym_line_comment] = ACTIONS(7),
  },
  [413] = {
    [sym_extern_modifier] = STATE(413),
    [aux_sym_function_modifiers_repeat1] = STATE(413),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(1820),
    [anon_sym_i8] = ACTIONS(1820),
    [anon_sym_u16] = ACTIONS(1820),
    [anon_sym_i16] = ACTIONS(1820),
    [anon_sym_u32] = ACTIONS(1820),
    [anon_sym_i32] = ACTIONS(1820),
    [anon_sym_u64] = ACTIONS(1820),
    [anon_sym_i64] = ACTIONS(1820),
    [anon_sym_u128] = ACTIONS(1820),
    [anon_sym_i128] = ACTIONS(1820),
    [anon_sym_isize] = ACTIONS(1820),
    [anon_sym_usize] = ACTIONS(1820),
    [anon_sym_f32] = ACTIONS(1820),
    [anon_sym_f64] = ACTIONS(1820),
    [anon_sym_bool] = ACTIONS(1820),
    [anon_sym_str] = ACTIONS(1820),
    [anon_sym_char] = ACTIONS(1820),
    [anon_sym_COLON_COLON] = ACTIONS(1474),
    [anon_sym_LT] = ACTIONS(1474),
    [anon_sym_const] = ACTIONS(1822),
    [anon_sym_default] = ACTIONS(1822),
    [anon_sym_fn] = ACTIONS(1820),
    [anon_sym_unsafe] = ACTIONS(1822),
    [anon_sym_extern] = ACTIONS(1825),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1820),
    [sym_self] = ACTIONS(1820),
    [sym_super] = ACTIONS(1820),
    [sym_crate] = ACTIONS(1820),
    [sym_metavariable] = ACTIONS(1474),
  },
  [414] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1828),
    [anon_sym_RPAREN] = ACTIONS(1828),
    [anon_sym_RBRACE] = ACTIONS(1828),
    [anon_sym_COLON] = ACTIONS(1828),
    [anon_sym_COMMA] = ACTIONS(1828),
    [anon_sym_EQ] = ACTIONS(1828),
    [anon_sym_PIPE] = ACTIONS(1828),
    [anon_sym_in] = ACTIONS(1828),
    [sym_line_comment] = ACTIONS(7),
  },
  [415] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(1830),
    [sym_line_comment] = ACTIONS(7),
  },
  [416] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(428),
    [sym_tuple_pattern] = STATE(428),
    [sym_tuple_struct_pattern] = STATE(428),
    [sym_struct_pattern] = STATE(428),
    [sym_remaining_field_pattern] = STATE(428),
    [sym_mut_pattern] = STATE(428),
    [sym_ref_pattern] = STATE(428),
    [sym_captured_pattern] = STATE(428),
    [sym_reference_pattern] = STATE(428),
    [sym__literal] = STATE(428),
    [sym_string_literal] = STATE(428),
    [sym_boolean_literal] = STATE(428),
    [sym_raw_string_literal] = ACTIONS(833),
    [sym_float_literal] = ACTIONS(833),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(817),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(1832),
    [anon_sym_ref] = ACTIONS(821),
    [sym_integer_literal] = ACTIONS(833),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(833),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(823),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [417] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(438),
    [sym_tuple_pattern] = STATE(438),
    [sym_tuple_struct_pattern] = STATE(438),
    [sym_struct_pattern] = STATE(438),
    [sym_remaining_field_pattern] = STATE(438),
    [sym_mut_pattern] = STATE(438),
    [sym_ref_pattern] = STATE(438),
    [sym_captured_pattern] = STATE(438),
    [sym_reference_pattern] = STATE(438),
    [sym__literal] = STATE(438),
    [sym_string_literal] = STATE(438),
    [sym_boolean_literal] = STATE(438),
    [sym_raw_string_literal] = ACTIONS(855),
    [sym_float_literal] = ACTIONS(855),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(931),
    [anon_sym_AMP] = ACTIONS(817),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(819),
    [anon_sym_ref] = ACTIONS(821),
    [sym_integer_literal] = ACTIONS(855),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(855),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(823),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [418] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(441),
    [sym_tuple_pattern] = STATE(441),
    [sym_tuple_struct_pattern] = STATE(441),
    [sym_struct_pattern] = STATE(441),
    [sym_remaining_field_pattern] = STATE(441),
    [sym_mut_pattern] = STATE(441),
    [sym_ref_pattern] = STATE(441),
    [sym_captured_pattern] = STATE(441),
    [sym_reference_pattern] = STATE(441),
    [sym__literal] = STATE(441),
    [sym_string_literal] = STATE(441),
    [sym_boolean_literal] = STATE(441),
    [sym_raw_string_literal] = ACTIONS(871),
    [sym_float_literal] = ACTIONS(871),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(873),
    [anon_sym_AMP] = ACTIONS(817),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(819),
    [anon_sym_ref] = ACTIONS(821),
    [sym_integer_literal] = ACTIONS(871),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(823),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [419] = {
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(881),
    [anon_sym_RPAREN] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(883),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_COLON_COLON] = ACTIONS(887),
    [anon_sym_AT] = ACTIONS(1834),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [420] = {
    [aux_sym_tuple_pattern_repeat1] = STATE(878),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(1830),
    [anon_sym_COMMA] = ACTIONS(1836),
    [sym_line_comment] = ACTIONS(7),
  },
  [421] = {
    [sym_function_modifiers] = STATE(883),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(884),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(885),
    [sym_array_type] = STATE(884),
    [sym_function_type] = STATE(884),
    [sym_tuple_type] = STATE(884),
    [sym_unit_type] = STATE(884),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(884),
    [sym_reference_type] = STATE(884),
    [sym_pointer_type] = STATE(884),
    [sym_empty_type] = STATE(884),
    [sym_abstract_type] = STATE(886),
    [sym_dynamic_type] = STATE(884),
    [sym_macro_invocation] = STATE(884),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(887),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1838),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1840),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1842),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1844),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [422] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1846),
  },
  [423] = {
    [sym_function_modifiers] = STATE(883),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(889),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(885),
    [sym_array_type] = STATE(889),
    [sym_function_type] = STATE(889),
    [sym_tuple_type] = STATE(889),
    [sym_unit_type] = STATE(889),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(889),
    [sym_reference_type] = STATE(889),
    [sym_pointer_type] = STATE(889),
    [sym_empty_type] = STATE(889),
    [sym_abstract_type] = STATE(890),
    [sym_dynamic_type] = STATE(889),
    [sym_macro_invocation] = STATE(889),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(887),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1838),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1840),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1842),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1844),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [424] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(420),
    [sym_tuple_pattern] = STATE(420),
    [sym_tuple_struct_pattern] = STATE(420),
    [sym_struct_pattern] = STATE(420),
    [sym_remaining_field_pattern] = STATE(420),
    [sym_mut_pattern] = STATE(420),
    [sym_ref_pattern] = STATE(895),
    [sym_captured_pattern] = STATE(420),
    [sym_reference_pattern] = STATE(420),
    [sym_reference_pattern_in_parameter] = STATE(895),
    [sym__literal] = STATE(420),
    [sym_string_literal] = STATE(420),
    [sym_boolean_literal] = STATE(420),
    [sym_raw_string_literal] = ACTIONS(809),
    [sym_float_literal] = ACTIONS(809),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_RPAREN] = ACTIONS(1848),
    [anon_sym_COMMA] = ACTIONS(1850),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(815),
    [anon_sym_AMP] = ACTIONS(1852),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(819),
    [anon_sym_ref] = ACTIONS(821),
    [sym_integer_literal] = ACTIONS(809),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(809),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1854),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [425] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(428),
    [sym_tuple_pattern] = STATE(428),
    [sym_tuple_struct_pattern] = STATE(428),
    [sym_struct_pattern] = STATE(428),
    [sym_remaining_field_pattern] = STATE(428),
    [sym_mut_pattern] = STATE(428),
    [sym_ref_pattern] = STATE(428),
    [sym_captured_pattern] = STATE(428),
    [sym_reference_pattern] = STATE(428),
    [sym__literal] = STATE(428),
    [sym_string_literal] = STATE(428),
    [sym_boolean_literal] = STATE(428),
    [sym_raw_string_literal] = ACTIONS(833),
    [sym_float_literal] = ACTIONS(833),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(839),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(1856),
    [anon_sym_ref] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(833),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(833),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(875),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [426] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(898),
    [sym_tuple_pattern] = STATE(898),
    [sym_tuple_pattern_in_parameter] = STATE(899),
    [sym_tuple_struct_pattern] = STATE(898),
    [sym_struct_pattern] = STATE(898),
    [sym_remaining_field_pattern] = STATE(898),
    [sym_mut_pattern] = STATE(898),
    [sym_ref_pattern] = STATE(898),
    [sym_captured_pattern] = STATE(898),
    [sym_reference_pattern] = STATE(898),
    [sym__literal] = STATE(898),
    [sym_string_literal] = STATE(898),
    [sym_boolean_literal] = STATE(898),
    [sym_raw_string_literal] = ACTIONS(1858),
    [sym_float_literal] = ACTIONS(1858),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(835),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(1860),
    [anon_sym_AMP] = ACTIONS(839),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(865),
    [anon_sym_ref] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(1858),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(1858),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1862),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [427] = {
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(883),
    [anon_sym_COLON] = ACTIONS(1864),
    [anon_sym_COMMA] = ACTIONS(1866),
    [anon_sym_COLON_COLON] = ACTIONS(887),
    [anon_sym_AT] = ACTIONS(889),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_PIPE] = ACTIONS(1866),
    [sym_line_comment] = ACTIONS(7),
  },
  [428] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1868),
    [anon_sym_RPAREN] = ACTIONS(1868),
    [anon_sym_RBRACE] = ACTIONS(1868),
    [anon_sym_COLON] = ACTIONS(1868),
    [anon_sym_COMMA] = ACTIONS(1868),
    [anon_sym_EQ] = ACTIONS(1868),
    [anon_sym_PIPE] = ACTIONS(1868),
    [anon_sym_in] = ACTIONS(1868),
    [sym_line_comment] = ACTIONS(7),
  },
  [429] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(1866),
    [anon_sym_COLON] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(1866),
    [anon_sym_PIPE] = ACTIONS(1866),
    [sym_line_comment] = ACTIONS(7),
  },
  [430] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(721),
    [anon_sym_LPAREN] = ACTIONS(721),
    [anon_sym_RPAREN] = ACTIONS(721),
    [anon_sym_LBRACE] = ACTIONS(1728),
    [anon_sym_RBRACE] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(721),
    [anon_sym_COLON_COLON] = ACTIONS(721),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_EQ] = ACTIONS(721),
    [anon_sym_PIPE] = ACTIONS(721),
    [anon_sym_in] = ACTIONS(721),
    [sym_line_comment] = ACTIONS(7),
  },
  [431] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1870),
    [anon_sym_COLON_COLON] = ACTIONS(827),
    [sym_line_comment] = ACTIONS(7),
  },
  [432] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1872),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(831),
    [sym_line_comment] = ACTIONS(7),
  },
  [433] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(428),
    [sym_tuple_pattern] = STATE(428),
    [sym_tuple_pattern_in_parameter] = STATE(429),
    [sym_tuple_struct_pattern] = STATE(428),
    [sym_struct_pattern] = STATE(428),
    [sym_remaining_field_pattern] = STATE(428),
    [sym_mut_pattern] = STATE(428),
    [sym_ref_pattern] = STATE(428),
    [sym_captured_pattern] = STATE(428),
    [sym_reference_pattern] = STATE(428),
    [sym__literal] = STATE(428),
    [sym_string_literal] = STATE(428),
    [sym_boolean_literal] = STATE(428),
    [sym_raw_string_literal] = ACTIONS(833),
    [sym_float_literal] = ACTIONS(833),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1874),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(839),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(1876),
    [anon_sym_ref] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(833),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(833),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1878),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [434] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1880),
    [sym_line_comment] = ACTIONS(7),
  },
  [435] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(438),
    [sym_tuple_pattern] = STATE(438),
    [sym_tuple_struct_pattern] = STATE(438),
    [sym_struct_pattern] = STATE(438),
    [sym_remaining_field_pattern] = STATE(438),
    [sym_mut_pattern] = STATE(438),
    [sym_ref_pattern] = STATE(438),
    [sym_captured_pattern] = STATE(438),
    [sym_reference_pattern] = STATE(438),
    [sym__literal] = STATE(438),
    [sym_string_literal] = STATE(438),
    [sym_boolean_literal] = STATE(438),
    [sym_raw_string_literal] = ACTIONS(855),
    [sym_float_literal] = ACTIONS(855),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(931),
    [anon_sym_AMP] = ACTIONS(839),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(865),
    [anon_sym_ref] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(855),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(855),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(875),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [436] = {
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(883),
    [anon_sym_COLON] = ACTIONS(1882),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_COLON_COLON] = ACTIONS(887),
    [anon_sym_AT] = ACTIONS(889),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_PIPE] = ACTIONS(831),
    [sym_line_comment] = ACTIONS(7),
  },
  [437] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1882),
    [anon_sym_COLON_COLON] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(7),
  },
  [438] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1884),
    [anon_sym_RPAREN] = ACTIONS(1884),
    [anon_sym_RBRACE] = ACTIONS(1884),
    [anon_sym_COLON] = ACTIONS(1884),
    [anon_sym_COMMA] = ACTIONS(1884),
    [anon_sym_EQ] = ACTIONS(1884),
    [anon_sym_PIPE] = ACTIONS(1884),
    [anon_sym_in] = ACTIONS(1884),
    [sym_line_comment] = ACTIONS(7),
  },
  [439] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1872),
    [sym_line_comment] = ACTIONS(7),
  },
  [440] = {
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(883),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_COLON_COLON] = ACTIONS(887),
    [anon_sym_AT] = ACTIONS(889),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_PIPE] = ACTIONS(831),
    [sym_line_comment] = ACTIONS(7),
  },
  [441] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1886),
    [anon_sym_RPAREN] = ACTIONS(1886),
    [anon_sym_RBRACE] = ACTIONS(1886),
    [anon_sym_COLON] = ACTIONS(1886),
    [anon_sym_COMMA] = ACTIONS(1886),
    [anon_sym_EQ] = ACTIONS(1886),
    [anon_sym_PIPE] = ACTIONS(1886),
    [anon_sym_in] = ACTIONS(1886),
    [sym_line_comment] = ACTIONS(7),
  },
  [442] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(1121),
    [anon_sym_COMMA] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [sym_line_comment] = ACTIONS(7),
  },
  [443] = {
    [aux_sym_string_literal_repeat1] = STATE(575),
    [sym_block_comment] = ACTIONS(7),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_RBRACK_PLUS_SLASH] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1888),
    [sym_escape_sequence] = ACTIONS(1125),
    [sym_line_comment] = ACTIONS(401),
  },
  [444] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(908),
    [sym_tuple_pattern] = STATE(908),
    [sym_tuple_struct_pattern] = STATE(908),
    [sym_struct_pattern] = STATE(908),
    [sym_remaining_field_pattern] = STATE(908),
    [sym_mut_pattern] = STATE(908),
    [sym_ref_pattern] = STATE(908),
    [sym_captured_pattern] = STATE(908),
    [sym_reference_pattern] = STATE(908),
    [sym__literal] = STATE(908),
    [sym_string_literal] = STATE(908),
    [sym_boolean_literal] = STATE(908),
    [sym_raw_string_literal] = ACTIONS(1890),
    [sym_float_literal] = ACTIONS(1890),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_RPAREN] = ACTIONS(1892),
    [anon_sym_COMMA] = ACTIONS(1894),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(1896),
    [anon_sym_AMP] = ACTIONS(817),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(819),
    [anon_sym_ref] = ACTIONS(821),
    [sym_integer_literal] = ACTIONS(1890),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1890),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(823),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [445] = {
    [sym_field_pattern] = STATE(914),
    [sym_remaining_field_pattern] = STATE(914),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(1898),
    [anon_sym_COMMA] = ACTIONS(1900),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(1902),
    [anon_sym_ref] = ACTIONS(1904),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1906),
  },
  [446] = {
    [sym_type_arguments] = STATE(845),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1908),
  },
  [447] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(916),
    [sym_tuple_pattern] = STATE(916),
    [sym_tuple_struct_pattern] = STATE(916),
    [sym_struct_pattern] = STATE(916),
    [sym_remaining_field_pattern] = STATE(916),
    [sym_mut_pattern] = STATE(916),
    [sym_ref_pattern] = STATE(916),
    [sym_captured_pattern] = STATE(916),
    [sym_reference_pattern] = STATE(916),
    [sym__literal] = STATE(916),
    [sym_string_literal] = STATE(916),
    [sym_boolean_literal] = STATE(916),
    [sym_raw_string_literal] = ACTIONS(1910),
    [sym_float_literal] = ACTIONS(1910),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(1912),
    [anon_sym_AMP] = ACTIONS(839),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(865),
    [anon_sym_ref] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(1910),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(1910),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(875),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [448] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1908),
  },
  [449] = {
    [sym_parameter] = STATE(917),
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(917),
    [sym_tuple_pattern] = STATE(917),
    [sym_tuple_struct_pattern] = STATE(917),
    [sym_struct_pattern] = STATE(917),
    [sym_remaining_field_pattern] = STATE(917),
    [sym_mut_pattern] = STATE(917),
    [sym_ref_pattern] = STATE(917),
    [sym_captured_pattern] = STATE(917),
    [sym_reference_pattern] = STATE(917),
    [sym_reference_pattern_in_parameter] = STATE(918),
    [sym__literal] = STATE(917),
    [sym_string_literal] = STATE(917),
    [sym_boolean_literal] = STATE(917),
    [sym_raw_string_literal] = ACTIONS(1914),
    [sym_float_literal] = ACTIONS(1914),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(227),
    [anon_sym_i8] = ACTIONS(227),
    [anon_sym_u16] = ACTIONS(227),
    [anon_sym_i16] = ACTIONS(227),
    [anon_sym_u32] = ACTIONS(227),
    [anon_sym_i32] = ACTIONS(227),
    [anon_sym_u64] = ACTIONS(227),
    [anon_sym_i64] = ACTIONS(227),
    [anon_sym_u128] = ACTIONS(227),
    [anon_sym_i128] = ACTIONS(227),
    [anon_sym_isize] = ACTIONS(227),
    [anon_sym_usize] = ACTIONS(227),
    [anon_sym_f32] = ACTIONS(227),
    [anon_sym_f64] = ACTIONS(227),
    [anon_sym_bool] = ACTIONS(227),
    [anon_sym_str] = ACTIONS(227),
    [anon_sym_char] = ACTIONS(227),
    [anon_sym__] = ACTIONS(229),
    [anon_sym_AMP] = ACTIONS(231),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [anon_sym_default] = ACTIONS(239),
    [anon_sym_union] = ACTIONS(239),
    [sym_mutable_specifier] = ACTIONS(241),
    [anon_sym_ref] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(1914),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(1914),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(249),
    [sym_self] = ACTIONS(251),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [450] = {
    [sym_raw_string_literal] = ACTIONS(1916),
    [sym_float_literal] = ACTIONS(1916),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1916),
    [anon_sym_LBRACE] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1916),
    [anon_sym_STAR] = ACTIONS(1916),
    [anon_sym_u8] = ACTIONS(1918),
    [anon_sym_i8] = ACTIONS(1918),
    [anon_sym_u16] = ACTIONS(1918),
    [anon_sym_i16] = ACTIONS(1918),
    [anon_sym_u32] = ACTIONS(1918),
    [anon_sym_i32] = ACTIONS(1918),
    [anon_sym_u64] = ACTIONS(1918),
    [anon_sym_i64] = ACTIONS(1918),
    [anon_sym_u128] = ACTIONS(1918),
    [anon_sym_i128] = ACTIONS(1918),
    [anon_sym_isize] = ACTIONS(1918),
    [anon_sym_usize] = ACTIONS(1918),
    [anon_sym_f32] = ACTIONS(1918),
    [anon_sym_f64] = ACTIONS(1918),
    [anon_sym_bool] = ACTIONS(1918),
    [anon_sym_str] = ACTIONS(1918),
    [anon_sym_char] = ACTIONS(1918),
    [anon_sym_AMP] = ACTIONS(1916),
    [anon_sym_DASH] = ACTIONS(1918),
    [anon_sym_DASH_GT] = ACTIONS(1916),
    [anon_sym_COLON_COLON] = ACTIONS(1916),
    [anon_sym_BANG] = ACTIONS(1916),
    [anon_sym_LT] = ACTIONS(1916),
    [anon_sym_PIPE] = ACTIONS(1916),
    [anon_sym_SQUOTE] = ACTIONS(1918),
    [anon_sym_DOT_DOT] = ACTIONS(1916),
    [anon_sym_break] = ACTIONS(1918),
    [anon_sym_continue] = ACTIONS(1918),
    [anon_sym_default] = ACTIONS(1918),
    [anon_sym_for] = ACTIONS(1918),
    [anon_sym_if] = ACTIONS(1918),
    [anon_sym_loop] = ACTIONS(1918),
    [anon_sym_match] = ACTIONS(1918),
    [anon_sym_return] = ACTIONS(1918),
    [anon_sym_union] = ACTIONS(1918),
    [anon_sym_unsafe] = ACTIONS(1918),
    [anon_sym_while] = ACTIONS(1918),
    [anon_sym_move] = ACTIONS(1918),
    [sym_integer_literal] = ACTIONS(1916),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(1916),
    [sym_char_literal] = ACTIONS(1916),
    [anon_sym_true] = ACTIONS(1918),
    [anon_sym_false] = ACTIONS(1918),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1918),
    [sym_self] = ACTIONS(1918),
    [sym_super] = ACTIONS(1918),
    [sym_crate] = ACTIONS(1918),
    [sym_metavariable] = ACTIONS(1916),
  },
  [451] = {
    [aux_sym_closure_parameters_repeat1] = STATE(920),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_PIPE] = ACTIONS(1920),
    [sym_line_comment] = ACTIONS(7),
  },
  [452] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1922),
  },
  [453] = {
    [sym_type_arguments] = STATE(873),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1908),
  },
  [454] = {
    [sym_field_pattern] = STATE(924),
    [sym_remaining_field_pattern] = STATE(924),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(1924),
    [anon_sym_COMMA] = ACTIONS(1926),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(1902),
    [anon_sym_ref] = ACTIONS(1904),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1906),
  },
  [455] = {
    [sym_function_modifiers] = STATE(929),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(930),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(931),
    [sym_array_type] = STATE(930),
    [sym_function_type] = STATE(930),
    [sym_tuple_type] = STATE(930),
    [sym_unit_type] = STATE(930),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(930),
    [sym_reference_type] = STATE(930),
    [sym_pointer_type] = STATE(930),
    [sym_empty_type] = STATE(930),
    [sym_dynamic_type] = STATE(930),
    [sym_macro_invocation] = STATE(930),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(932),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1928),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1930),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1932),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1934),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [456] = {
    [sym_attribute_item] = STATE(939),
    [sym_enum_variant] = STATE(937),
    [sym_visibility_modifier] = STATE(938),
    [aux_sym_enum_variant_list_repeat1] = STATE(939),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(1936),
    [anon_sym_COMMA] = ACTIONS(1938),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_pub] = ACTIONS(1940),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1942),
  },
  [457] = {
    [sym_constrained_type_parameter] = STATE(503),
    [sym_optional_type_parameter] = STATE(504),
    [sym_lifetime] = STATE(941),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1944),
    [sym_metavariable] = ACTIONS(1946),
  },
  [458] = {
    [sym_where_predicate] = STATE(944),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(945),
    [sym_generic_type] = STATE(946),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_reference_type] = STATE(945),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(947),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(1948),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1950),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [459] = {
    [sym_raw_string_literal] = ACTIONS(1952),
    [sym_float_literal] = ACTIONS(1952),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(1952),
    [anon_sym_SEMI] = ACTIONS(1952),
    [anon_sym_macro_rules_BANG] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(1952),
    [anon_sym_LBRACE] = ACTIONS(1952),
    [anon_sym_RBRACE] = ACTIONS(1952),
    [anon_sym_LBRACK] = ACTIONS(1952),
    [anon_sym_STAR] = ACTIONS(1952),
    [anon_sym_u8] = ACTIONS(1954),
    [anon_sym_i8] = ACTIONS(1954),
    [anon_sym_u16] = ACTIONS(1954),
    [anon_sym_i16] = ACTIONS(1954),
    [anon_sym_u32] = ACTIONS(1954),
    [anon_sym_i32] = ACTIONS(1954),
    [anon_sym_u64] = ACTIONS(1954),
    [anon_sym_i64] = ACTIONS(1954),
    [anon_sym_u128] = ACTIONS(1954),
    [anon_sym_i128] = ACTIONS(1954),
    [anon_sym_isize] = ACTIONS(1954),
    [anon_sym_usize] = ACTIONS(1954),
    [anon_sym_f32] = ACTIONS(1954),
    [anon_sym_f64] = ACTIONS(1954),
    [anon_sym_bool] = ACTIONS(1954),
    [anon_sym_str] = ACTIONS(1954),
    [anon_sym_char] = ACTIONS(1954),
    [anon_sym_AMP] = ACTIONS(1952),
    [anon_sym_DASH] = ACTIONS(1952),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1952),
    [anon_sym_POUND] = ACTIONS(1952),
    [anon_sym_LT] = ACTIONS(1952),
    [anon_sym_PIPE] = ACTIONS(1952),
    [anon_sym_SQUOTE] = ACTIONS(1954),
    [anon_sym_DOT_DOT] = ACTIONS(1952),
    [anon_sym_break] = ACTIONS(1954),
    [anon_sym_const] = ACTIONS(1954),
    [anon_sym_continue] = ACTIONS(1954),
    [anon_sym_default] = ACTIONS(1954),
    [anon_sym_enum] = ACTIONS(1954),
    [anon_sym_fn] = ACTIONS(1954),
    [anon_sym_for] = ACTIONS(1954),
    [anon_sym_if] = ACTIONS(1954),
    [anon_sym_impl] = ACTIONS(1954),
    [anon_sym_let] = ACTIONS(1954),
    [anon_sym_loop] = ACTIONS(1954),
    [anon_sym_match] = ACTIONS(1954),
    [anon_sym_mod] = ACTIONS(1954),
    [anon_sym_pub] = ACTIONS(1954),
    [anon_sym_return] = ACTIONS(1954),
    [anon_sym_static] = ACTIONS(1954),
    [anon_sym_struct] = ACTIONS(1954),
    [anon_sym_trait] = ACTIONS(1954),
    [anon_sym_type] = ACTIONS(1954),
    [anon_sym_union] = ACTIONS(1954),
    [anon_sym_unsafe] = ACTIONS(1954),
    [anon_sym_use] = ACTIONS(1954),
    [anon_sym_while] = ACTIONS(1954),
    [anon_sym_extern] = ACTIONS(1954),
    [anon_sym_move] = ACTIONS(1954),
    [sym_integer_literal] = ACTIONS(1952),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(1952),
    [sym_char_literal] = ACTIONS(1952),
    [anon_sym_true] = ACTIONS(1954),
    [anon_sym_false] = ACTIONS(1954),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1954),
    [sym_self] = ACTIONS(1954),
    [sym_super] = ACTIONS(1954),
    [sym_crate] = ACTIONS(1954),
    [sym_metavariable] = ACTIONS(1952),
  },
  [460] = {
    [sym_enum_variant_list] = STATE(948),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(923),
    [sym_line_comment] = ACTIONS(7),
  },
  [461] = {
    [sym_enum_variant_list] = STATE(948),
    [sym_where_clause] = STATE(949),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [462] = {
    [sym_parameters] = STATE(950),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [463] = {
    [sym_where_clause] = STATE(955),
    [sym_block] = STATE(956),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_DASH_GT] = ACTIONS(1960),
    [anon_sym_where] = ACTIONS(1962),
    [sym_line_comment] = ACTIONS(7),
  },
  [464] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(898),
    [sym_tuple_pattern] = STATE(898),
    [sym_tuple_struct_pattern] = STATE(898),
    [sym_struct_pattern] = STATE(898),
    [sym_remaining_field_pattern] = STATE(898),
    [sym_mut_pattern] = STATE(898),
    [sym_ref_pattern] = STATE(898),
    [sym_captured_pattern] = STATE(898),
    [sym_reference_pattern] = STATE(898),
    [sym__literal] = STATE(898),
    [sym_string_literal] = STATE(898),
    [sym_boolean_literal] = STATE(898),
    [sym_raw_string_literal] = ACTIONS(1858),
    [sym_float_literal] = ACTIONS(1858),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(1860),
    [anon_sym_AMP] = ACTIONS(293),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(295),
    [anon_sym_ref] = ACTIONS(297),
    [sym_integer_literal] = ACTIONS(1858),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1858),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(299),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [465] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(916),
    [sym_tuple_pattern] = STATE(916),
    [sym_tuple_struct_pattern] = STATE(916),
    [sym_struct_pattern] = STATE(916),
    [sym_remaining_field_pattern] = STATE(916),
    [sym_mut_pattern] = STATE(916),
    [sym_ref_pattern] = STATE(916),
    [sym_captured_pattern] = STATE(916),
    [sym_reference_pattern] = STATE(916),
    [sym__literal] = STATE(916),
    [sym_string_literal] = STATE(916),
    [sym_boolean_literal] = STATE(916),
    [sym_raw_string_literal] = ACTIONS(1910),
    [sym_float_literal] = ACTIONS(1910),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(1912),
    [anon_sym_AMP] = ACTIONS(293),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(295),
    [anon_sym_ref] = ACTIONS(297),
    [sym_integer_literal] = ACTIONS(1910),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1910),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(299),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [466] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(957),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(957),
    [sym_macro_invocation] = STATE(957),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(957),
    [sym_unary_expression] = STATE(957),
    [sym_try_expression] = STATE(957),
    [sym_reference_expression] = STATE(957),
    [sym_binary_expression] = STATE(957),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(957),
    [sym_call_expression] = STATE(957),
    [sym_array_expression] = STATE(957),
    [sym_parenthesized_expression] = STATE(957),
    [sym_tuple_expression] = STATE(957),
    [sym_unit_expression] = STATE(957),
    [sym_struct_expression] = STATE(957),
    [sym_if_expression] = STATE(957),
    [sym_if_let_expression] = STATE(957),
    [sym_match_expression] = STATE(957),
    [sym_while_expression] = STATE(957),
    [sym_while_let_expression] = STATE(957),
    [sym_loop_expression] = STATE(957),
    [sym_for_expression] = STATE(957),
    [sym_closure_expression] = STATE(957),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(957),
    [sym_continue_expression] = STATE(957),
    [sym_index_expression] = STATE(957),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(957),
    [sym_block] = STATE(957),
    [sym__literal] = STATE(957),
    [sym_string_literal] = STATE(957),
    [sym_boolean_literal] = STATE(957),
    [sym_raw_string_literal] = ACTIONS(1964),
    [sym_float_literal] = ACTIONS(1964),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(1964),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1964),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [467] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1966),
  },
  [468] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(361),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(361),
    [sym_macro_invocation] = STATE(361),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(361),
    [sym_unary_expression] = STATE(361),
    [sym_try_expression] = STATE(361),
    [sym_reference_expression] = STATE(361),
    [sym_binary_expression] = STATE(361),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(361),
    [sym_call_expression] = STATE(361),
    [sym_array_expression] = STATE(361),
    [sym_parenthesized_expression] = STATE(361),
    [sym_tuple_expression] = STATE(361),
    [sym_unit_expression] = STATE(361),
    [sym_struct_expression] = STATE(361),
    [sym_if_expression] = STATE(361),
    [sym_if_let_expression] = STATE(361),
    [sym_match_expression] = STATE(361),
    [sym_while_expression] = STATE(361),
    [sym_while_let_expression] = STATE(361),
    [sym_loop_expression] = STATE(361),
    [sym_for_expression] = STATE(361),
    [sym_closure_expression] = STATE(361),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(361),
    [sym_continue_expression] = STATE(361),
    [sym_index_expression] = STATE(361),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(361),
    [sym_block] = STATE(361),
    [sym__literal] = STATE(361),
    [sym_string_literal] = STATE(361),
    [sym_boolean_literal] = STATE(361),
    [sym_raw_string_literal] = ACTIONS(715),
    [sym_float_literal] = ACTIONS(715),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(715),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(715),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [469] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(721),
    [anon_sym_LPAREN] = ACTIONS(721),
    [anon_sym_RPAREN] = ACTIONS(721),
    [anon_sym_LBRACE] = ACTIONS(721),
    [anon_sym_RBRACE] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(721),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(721),
    [anon_sym_AMP] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(721),
    [anon_sym_COLON_COLON] = ACTIONS(721),
    [anon_sym_BANG_EQ] = ACTIONS(721),
    [anon_sym_STAR_EQ] = ACTIONS(721),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(721),
    [anon_sym_AMP_AMP] = ACTIONS(721),
    [anon_sym_AMP_EQ] = ACTIONS(721),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(721),
    [anon_sym_PLUS_EQ] = ACTIONS(721),
    [anon_sym_LT] = ACTIONS(725),
    [anon_sym_LT_LT] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(721),
    [anon_sym_LT_EQ] = ACTIONS(721),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_EQ_EQ] = ACTIONS(721),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(721),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(721),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(721),
    [anon_sym_PIPE_PIPE] = ACTIONS(721),
    [anon_sym_QMARK] = ACTIONS(721),
    [anon_sym_DOT_DOT] = ACTIONS(725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(721),
    [anon_sym_as] = ACTIONS(721),
    [sym_line_comment] = ACTIONS(7),
  },
  [470] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_as] = ACTIONS(909),
    [sym_line_comment] = ACTIONS(7),
  },
  [471] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(959),
    [sym_tuple_pattern] = STATE(959),
    [sym_tuple_struct_pattern] = STATE(959),
    [sym_struct_pattern] = STATE(959),
    [sym_remaining_field_pattern] = STATE(959),
    [sym_mut_pattern] = STATE(959),
    [sym_ref_pattern] = STATE(959),
    [sym_captured_pattern] = STATE(959),
    [sym_reference_pattern] = STATE(959),
    [sym__literal] = STATE(959),
    [sym_string_literal] = STATE(959),
    [sym_boolean_literal] = STATE(959),
    [sym_raw_string_literal] = ACTIONS(1968),
    [sym_float_literal] = ACTIONS(1968),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(955),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(957),
    [anon_sym_ref] = ACTIONS(959),
    [sym_integer_literal] = ACTIONS(1968),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(1968),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(961),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [472] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(960),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [473] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(428),
    [sym_tuple_pattern] = STATE(428),
    [sym_tuple_struct_pattern] = STATE(428),
    [sym_struct_pattern] = STATE(428),
    [sym_remaining_field_pattern] = STATE(428),
    [sym_mut_pattern] = STATE(428),
    [sym_ref_pattern] = STATE(428),
    [sym_captured_pattern] = STATE(428),
    [sym_reference_pattern] = STATE(428),
    [sym__literal] = STATE(428),
    [sym_string_literal] = STATE(428),
    [sym_boolean_literal] = STATE(428),
    [sym_raw_string_literal] = ACTIONS(833),
    [sym_float_literal] = ACTIONS(833),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(955),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(1972),
    [anon_sym_ref] = ACTIONS(959),
    [sym_integer_literal] = ACTIONS(833),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(833),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(961),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [474] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(438),
    [sym_tuple_pattern] = STATE(438),
    [sym_tuple_struct_pattern] = STATE(438),
    [sym_struct_pattern] = STATE(438),
    [sym_remaining_field_pattern] = STATE(438),
    [sym_mut_pattern] = STATE(438),
    [sym_ref_pattern] = STATE(438),
    [sym_captured_pattern] = STATE(438),
    [sym_reference_pattern] = STATE(438),
    [sym__literal] = STATE(438),
    [sym_string_literal] = STATE(438),
    [sym_boolean_literal] = STATE(438),
    [sym_raw_string_literal] = ACTIONS(855),
    [sym_float_literal] = ACTIONS(855),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(931),
    [anon_sym_AMP] = ACTIONS(955),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(957),
    [anon_sym_ref] = ACTIONS(959),
    [sym_integer_literal] = ACTIONS(855),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(855),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(961),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [475] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(441),
    [sym_tuple_pattern] = STATE(441),
    [sym_tuple_struct_pattern] = STATE(441),
    [sym_struct_pattern] = STATE(441),
    [sym_remaining_field_pattern] = STATE(441),
    [sym_mut_pattern] = STATE(441),
    [sym_ref_pattern] = STATE(441),
    [sym_captured_pattern] = STATE(441),
    [sym_reference_pattern] = STATE(441),
    [sym__literal] = STATE(441),
    [sym_string_literal] = STATE(441),
    [sym_boolean_literal] = STATE(441),
    [sym_raw_string_literal] = ACTIONS(871),
    [sym_float_literal] = ACTIONS(871),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(873),
    [anon_sym_AMP] = ACTIONS(955),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(957),
    [anon_sym_ref] = ACTIONS(959),
    [sym_integer_literal] = ACTIONS(871),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(961),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [476] = {
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(883),
    [anon_sym_COLON_COLON] = ACTIONS(887),
    [anon_sym_AT] = ACTIONS(1974),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_EQ] = ACTIONS(831),
    [sym_line_comment] = ACTIONS(7),
  },
  [477] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(1976),
    [sym_line_comment] = ACTIONS(7),
  },
  [478] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(1043),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(1043),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(1043),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(1043),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(1043),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(1043),
    [anon_sym_PLUS_EQ] = ACTIONS(1043),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(1043),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(1043),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(1043),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(1043),
    [sym_line_comment] = ACTIONS(7),
  },
  [479] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(964),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(964),
    [sym_macro_invocation] = STATE(964),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(964),
    [sym_unary_expression] = STATE(964),
    [sym_try_expression] = STATE(964),
    [sym_reference_expression] = STATE(964),
    [sym_binary_expression] = STATE(964),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(964),
    [sym_call_expression] = STATE(964),
    [sym_array_expression] = STATE(964),
    [sym_parenthesized_expression] = STATE(964),
    [sym_tuple_expression] = STATE(964),
    [sym_unit_expression] = STATE(964),
    [sym_struct_expression] = STATE(964),
    [sym_if_expression] = STATE(964),
    [sym_if_let_expression] = STATE(964),
    [sym_match_expression] = STATE(964),
    [sym_while_expression] = STATE(964),
    [sym_while_let_expression] = STATE(964),
    [sym_loop_expression] = STATE(964),
    [sym_for_expression] = STATE(964),
    [sym_closure_expression] = STATE(964),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(964),
    [sym_continue_expression] = STATE(964),
    [sym_index_expression] = STATE(964),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(964),
    [sym_block] = STATE(964),
    [sym__literal] = STATE(964),
    [sym_string_literal] = STATE(964),
    [sym_boolean_literal] = STATE(964),
    [sym_raw_string_literal] = ACTIONS(1978),
    [sym_float_literal] = ACTIONS(1978),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(945),
    [anon_sym_DASH_GT] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(1978),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1978),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [480] = {
    [sym_type_arguments] = STATE(965),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(1139),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1223),
  },
  [481] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1223),
  },
  [482] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1980),
  },
  [483] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(967),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(967),
    [sym_macro_invocation] = STATE(967),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(967),
    [sym_unary_expression] = STATE(967),
    [sym_try_expression] = STATE(967),
    [sym_reference_expression] = STATE(967),
    [sym_binary_expression] = STATE(967),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(967),
    [sym_call_expression] = STATE(967),
    [sym_array_expression] = STATE(967),
    [sym_parenthesized_expression] = STATE(967),
    [sym_tuple_expression] = STATE(967),
    [sym_unit_expression] = STATE(967),
    [sym_struct_expression] = STATE(967),
    [sym_if_expression] = STATE(967),
    [sym_if_let_expression] = STATE(967),
    [sym_match_expression] = STATE(967),
    [sym_while_expression] = STATE(967),
    [sym_while_let_expression] = STATE(967),
    [sym_loop_expression] = STATE(967),
    [sym_for_expression] = STATE(967),
    [sym_closure_expression] = STATE(967),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(967),
    [sym_continue_expression] = STATE(967),
    [sym_index_expression] = STATE(967),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(967),
    [sym_block] = STATE(967),
    [sym__literal] = STATE(967),
    [sym_string_literal] = STATE(967),
    [sym_boolean_literal] = STATE(967),
    [sym_raw_string_literal] = ACTIONS(1982),
    [sym_float_literal] = ACTIONS(1982),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(1982),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1982),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [484] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(640),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(640),
    [sym_macro_invocation] = STATE(640),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(640),
    [sym_unary_expression] = STATE(640),
    [sym_try_expression] = STATE(640),
    [sym_reference_expression] = STATE(640),
    [sym_binary_expression] = STATE(640),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(640),
    [sym_call_expression] = STATE(640),
    [sym_array_expression] = STATE(640),
    [sym_parenthesized_expression] = STATE(640),
    [sym_tuple_expression] = STATE(640),
    [sym_unit_expression] = STATE(640),
    [sym_struct_expression] = STATE(640),
    [sym_if_expression] = STATE(640),
    [sym_if_let_expression] = STATE(640),
    [sym_match_expression] = STATE(640),
    [sym_while_expression] = STATE(640),
    [sym_while_let_expression] = STATE(640),
    [sym_loop_expression] = STATE(640),
    [sym_for_expression] = STATE(640),
    [sym_closure_expression] = STATE(640),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(640),
    [sym_continue_expression] = STATE(640),
    [sym_index_expression] = STATE(640),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(640),
    [sym_block] = STATE(640),
    [sym__literal] = STATE(640),
    [sym_string_literal] = STATE(640),
    [sym_boolean_literal] = STATE(640),
    [sym_raw_string_literal] = ACTIONS(1257),
    [sym_float_literal] = ACTIONS(1257),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(1257),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1257),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [485] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(968),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(968),
    [sym_macro_invocation] = STATE(968),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(968),
    [sym_unary_expression] = STATE(968),
    [sym_try_expression] = STATE(968),
    [sym_reference_expression] = STATE(968),
    [sym_binary_expression] = STATE(968),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(968),
    [sym_call_expression] = STATE(968),
    [sym_array_expression] = STATE(968),
    [sym_parenthesized_expression] = STATE(968),
    [sym_tuple_expression] = STATE(968),
    [sym_unit_expression] = STATE(968),
    [sym_struct_expression] = STATE(968),
    [sym_if_expression] = STATE(968),
    [sym_if_let_expression] = STATE(968),
    [sym_match_expression] = STATE(968),
    [sym_while_expression] = STATE(968),
    [sym_while_let_expression] = STATE(968),
    [sym_loop_expression] = STATE(968),
    [sym_for_expression] = STATE(968),
    [sym_closure_expression] = STATE(968),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(968),
    [sym_continue_expression] = STATE(968),
    [sym_index_expression] = STATE(968),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(968),
    [sym_block] = STATE(968),
    [sym__literal] = STATE(968),
    [sym_string_literal] = STATE(968),
    [sym_boolean_literal] = STATE(968),
    [sym_raw_string_literal] = ACTIONS(1984),
    [sym_float_literal] = ACTIONS(1984),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(1984),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1984),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [486] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(969),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(969),
    [sym_macro_invocation] = STATE(969),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(969),
    [sym_unary_expression] = STATE(969),
    [sym_try_expression] = STATE(969),
    [sym_reference_expression] = STATE(969),
    [sym_binary_expression] = STATE(969),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(969),
    [sym_call_expression] = STATE(969),
    [sym_array_expression] = STATE(969),
    [sym_parenthesized_expression] = STATE(969),
    [sym_tuple_expression] = STATE(969),
    [sym_unit_expression] = STATE(969),
    [sym_struct_expression] = STATE(969),
    [sym_if_expression] = STATE(969),
    [sym_if_let_expression] = STATE(969),
    [sym_match_expression] = STATE(969),
    [sym_while_expression] = STATE(969),
    [sym_while_let_expression] = STATE(969),
    [sym_loop_expression] = STATE(969),
    [sym_for_expression] = STATE(969),
    [sym_closure_expression] = STATE(969),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(969),
    [sym_continue_expression] = STATE(969),
    [sym_index_expression] = STATE(969),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(969),
    [sym_block] = STATE(969),
    [sym__literal] = STATE(969),
    [sym_string_literal] = STATE(969),
    [sym_boolean_literal] = STATE(969),
    [sym_raw_string_literal] = ACTIONS(1986),
    [sym_float_literal] = ACTIONS(1986),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(1986),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1986),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [487] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(970),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(970),
    [sym_macro_invocation] = STATE(970),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(970),
    [sym_unary_expression] = STATE(970),
    [sym_try_expression] = STATE(970),
    [sym_reference_expression] = STATE(970),
    [sym_binary_expression] = STATE(970),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(970),
    [sym_call_expression] = STATE(970),
    [sym_array_expression] = STATE(970),
    [sym_parenthesized_expression] = STATE(970),
    [sym_tuple_expression] = STATE(970),
    [sym_unit_expression] = STATE(970),
    [sym_struct_expression] = STATE(970),
    [sym_if_expression] = STATE(970),
    [sym_if_let_expression] = STATE(970),
    [sym_match_expression] = STATE(970),
    [sym_while_expression] = STATE(970),
    [sym_while_let_expression] = STATE(970),
    [sym_loop_expression] = STATE(970),
    [sym_for_expression] = STATE(970),
    [sym_closure_expression] = STATE(970),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(970),
    [sym_continue_expression] = STATE(970),
    [sym_index_expression] = STATE(970),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(970),
    [sym_block] = STATE(970),
    [sym__literal] = STATE(970),
    [sym_string_literal] = STATE(970),
    [sym_boolean_literal] = STATE(970),
    [sym_raw_string_literal] = ACTIONS(1988),
    [sym_float_literal] = ACTIONS(1988),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(1988),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1988),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [488] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(971),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(971),
    [sym_macro_invocation] = STATE(971),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(971),
    [sym_unary_expression] = STATE(971),
    [sym_try_expression] = STATE(971),
    [sym_reference_expression] = STATE(971),
    [sym_binary_expression] = STATE(971),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(971),
    [sym_call_expression] = STATE(971),
    [sym_array_expression] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym_tuple_expression] = STATE(971),
    [sym_unit_expression] = STATE(971),
    [sym_struct_expression] = STATE(971),
    [sym_if_expression] = STATE(971),
    [sym_if_let_expression] = STATE(971),
    [sym_match_expression] = STATE(971),
    [sym_while_expression] = STATE(971),
    [sym_while_let_expression] = STATE(971),
    [sym_loop_expression] = STATE(971),
    [sym_for_expression] = STATE(971),
    [sym_closure_expression] = STATE(971),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(971),
    [sym_continue_expression] = STATE(971),
    [sym_index_expression] = STATE(971),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(971),
    [sym_block] = STATE(971),
    [sym__literal] = STATE(971),
    [sym_string_literal] = STATE(971),
    [sym_boolean_literal] = STATE(971),
    [sym_raw_string_literal] = ACTIONS(1990),
    [sym_float_literal] = ACTIONS(1990),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(1990),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1990),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [489] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(972),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(972),
    [sym_macro_invocation] = STATE(972),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(972),
    [sym_unary_expression] = STATE(972),
    [sym_try_expression] = STATE(972),
    [sym_reference_expression] = STATE(972),
    [sym_binary_expression] = STATE(972),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(972),
    [sym_call_expression] = STATE(972),
    [sym_array_expression] = STATE(972),
    [sym_parenthesized_expression] = STATE(972),
    [sym_tuple_expression] = STATE(972),
    [sym_unit_expression] = STATE(972),
    [sym_struct_expression] = STATE(972),
    [sym_if_expression] = STATE(972),
    [sym_if_let_expression] = STATE(972),
    [sym_match_expression] = STATE(972),
    [sym_while_expression] = STATE(972),
    [sym_while_let_expression] = STATE(972),
    [sym_loop_expression] = STATE(972),
    [sym_for_expression] = STATE(972),
    [sym_closure_expression] = STATE(972),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(972),
    [sym_continue_expression] = STATE(972),
    [sym_index_expression] = STATE(972),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(972),
    [sym_block] = STATE(972),
    [sym__literal] = STATE(972),
    [sym_string_literal] = STATE(972),
    [sym_boolean_literal] = STATE(972),
    [sym_raw_string_literal] = ACTIONS(1992),
    [sym_float_literal] = ACTIONS(1992),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(1992),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1992),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [490] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(973),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(973),
    [sym_macro_invocation] = STATE(973),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(973),
    [sym_unary_expression] = STATE(973),
    [sym_try_expression] = STATE(973),
    [sym_reference_expression] = STATE(973),
    [sym_binary_expression] = STATE(973),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(973),
    [sym_call_expression] = STATE(973),
    [sym_array_expression] = STATE(973),
    [sym_parenthesized_expression] = STATE(973),
    [sym_tuple_expression] = STATE(973),
    [sym_unit_expression] = STATE(973),
    [sym_struct_expression] = STATE(973),
    [sym_if_expression] = STATE(973),
    [sym_if_let_expression] = STATE(973),
    [sym_match_expression] = STATE(973),
    [sym_while_expression] = STATE(973),
    [sym_while_let_expression] = STATE(973),
    [sym_loop_expression] = STATE(973),
    [sym_for_expression] = STATE(973),
    [sym_closure_expression] = STATE(973),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(973),
    [sym_continue_expression] = STATE(973),
    [sym_index_expression] = STATE(973),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(973),
    [sym_block] = STATE(973),
    [sym__literal] = STATE(973),
    [sym_string_literal] = STATE(973),
    [sym_boolean_literal] = STATE(973),
    [sym_raw_string_literal] = ACTIONS(1994),
    [sym_float_literal] = ACTIONS(1994),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(1994),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1994),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [491] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(974),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(974),
    [sym_macro_invocation] = STATE(974),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(974),
    [sym_unary_expression] = STATE(974),
    [sym_try_expression] = STATE(974),
    [sym_reference_expression] = STATE(974),
    [sym_binary_expression] = STATE(974),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(974),
    [sym_call_expression] = STATE(974),
    [sym_array_expression] = STATE(974),
    [sym_parenthesized_expression] = STATE(974),
    [sym_tuple_expression] = STATE(974),
    [sym_unit_expression] = STATE(974),
    [sym_struct_expression] = STATE(974),
    [sym_if_expression] = STATE(974),
    [sym_if_let_expression] = STATE(974),
    [sym_match_expression] = STATE(974),
    [sym_while_expression] = STATE(974),
    [sym_while_let_expression] = STATE(974),
    [sym_loop_expression] = STATE(974),
    [sym_for_expression] = STATE(974),
    [sym_closure_expression] = STATE(974),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(974),
    [sym_continue_expression] = STATE(974),
    [sym_index_expression] = STATE(974),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(974),
    [sym_block] = STATE(974),
    [sym__literal] = STATE(974),
    [sym_string_literal] = STATE(974),
    [sym_boolean_literal] = STATE(974),
    [sym_raw_string_literal] = ACTIONS(1996),
    [sym_float_literal] = ACTIONS(1996),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(1996),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1996),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [492] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(975),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(975),
    [sym_macro_invocation] = STATE(975),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(975),
    [sym_unary_expression] = STATE(975),
    [sym_try_expression] = STATE(975),
    [sym_reference_expression] = STATE(975),
    [sym_binary_expression] = STATE(975),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(975),
    [sym_call_expression] = STATE(975),
    [sym_array_expression] = STATE(975),
    [sym_parenthesized_expression] = STATE(975),
    [sym_tuple_expression] = STATE(975),
    [sym_unit_expression] = STATE(975),
    [sym_struct_expression] = STATE(975),
    [sym_if_expression] = STATE(975),
    [sym_if_let_expression] = STATE(975),
    [sym_match_expression] = STATE(975),
    [sym_while_expression] = STATE(975),
    [sym_while_let_expression] = STATE(975),
    [sym_loop_expression] = STATE(975),
    [sym_for_expression] = STATE(975),
    [sym_closure_expression] = STATE(975),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(975),
    [sym_continue_expression] = STATE(975),
    [sym_index_expression] = STATE(975),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(975),
    [sym_block] = STATE(975),
    [sym__literal] = STATE(975),
    [sym_string_literal] = STATE(975),
    [sym_boolean_literal] = STATE(975),
    [sym_raw_string_literal] = ACTIONS(1998),
    [sym_float_literal] = ACTIONS(1998),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(1998),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1998),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [493] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(976),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(976),
    [sym_macro_invocation] = STATE(976),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(976),
    [sym_unary_expression] = STATE(976),
    [sym_try_expression] = STATE(976),
    [sym_reference_expression] = STATE(976),
    [sym_binary_expression] = STATE(976),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(976),
    [sym_call_expression] = STATE(976),
    [sym_array_expression] = STATE(976),
    [sym_parenthesized_expression] = STATE(976),
    [sym_tuple_expression] = STATE(976),
    [sym_unit_expression] = STATE(976),
    [sym_struct_expression] = STATE(976),
    [sym_if_expression] = STATE(976),
    [sym_if_let_expression] = STATE(976),
    [sym_match_expression] = STATE(976),
    [sym_while_expression] = STATE(976),
    [sym_while_let_expression] = STATE(976),
    [sym_loop_expression] = STATE(976),
    [sym_for_expression] = STATE(976),
    [sym_closure_expression] = STATE(976),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(976),
    [sym_continue_expression] = STATE(976),
    [sym_index_expression] = STATE(976),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(976),
    [sym_block] = STATE(976),
    [sym__literal] = STATE(976),
    [sym_string_literal] = STATE(976),
    [sym_boolean_literal] = STATE(976),
    [sym_raw_string_literal] = ACTIONS(2000),
    [sym_float_literal] = ACTIONS(2000),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(2000),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(2000),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [494] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(977),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(977),
    [sym_macro_invocation] = STATE(977),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(977),
    [sym_unary_expression] = STATE(977),
    [sym_try_expression] = STATE(977),
    [sym_reference_expression] = STATE(977),
    [sym_binary_expression] = STATE(977),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(977),
    [sym_call_expression] = STATE(977),
    [sym_array_expression] = STATE(977),
    [sym_parenthesized_expression] = STATE(977),
    [sym_tuple_expression] = STATE(977),
    [sym_unit_expression] = STATE(977),
    [sym_struct_expression] = STATE(977),
    [sym_if_expression] = STATE(977),
    [sym_if_let_expression] = STATE(977),
    [sym_match_expression] = STATE(977),
    [sym_while_expression] = STATE(977),
    [sym_while_let_expression] = STATE(977),
    [sym_loop_expression] = STATE(977),
    [sym_for_expression] = STATE(977),
    [sym_closure_expression] = STATE(977),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(977),
    [sym_continue_expression] = STATE(977),
    [sym_index_expression] = STATE(977),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(977),
    [sym_block] = STATE(977),
    [sym__literal] = STATE(977),
    [sym_string_literal] = STATE(977),
    [sym_boolean_literal] = STATE(977),
    [sym_raw_string_literal] = ACTIONS(2002),
    [sym_float_literal] = ACTIONS(2002),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(909),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(911),
    [anon_sym_STAR] = ACTIONS(911),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_DASH] = ACTIONS(911),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(945),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(911),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(911),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_LT_LT] = ACTIONS(911),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(909),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_EQ_EQ] = ACTIONS(909),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(911),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_as] = ACTIONS(911),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(2002),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(2002),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [495] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(977),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(977),
    [sym_macro_invocation] = STATE(977),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(977),
    [sym_unary_expression] = STATE(977),
    [sym_try_expression] = STATE(977),
    [sym_reference_expression] = STATE(977),
    [sym_binary_expression] = STATE(977),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(977),
    [sym_call_expression] = STATE(977),
    [sym_array_expression] = STATE(977),
    [sym_parenthesized_expression] = STATE(977),
    [sym_tuple_expression] = STATE(977),
    [sym_unit_expression] = STATE(977),
    [sym_struct_expression] = STATE(977),
    [sym_if_expression] = STATE(977),
    [sym_if_let_expression] = STATE(977),
    [sym_match_expression] = STATE(977),
    [sym_while_expression] = STATE(977),
    [sym_while_let_expression] = STATE(977),
    [sym_loop_expression] = STATE(977),
    [sym_for_expression] = STATE(977),
    [sym_closure_expression] = STATE(977),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(977),
    [sym_continue_expression] = STATE(977),
    [sym_index_expression] = STATE(977),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(977),
    [sym_block] = STATE(977),
    [sym__literal] = STATE(977),
    [sym_string_literal] = STATE(977),
    [sym_boolean_literal] = STATE(977),
    [sym_raw_string_literal] = ACTIONS(2002),
    [sym_float_literal] = ACTIONS(2002),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(2002),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(2002),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [496] = {
    [sym_function_modifiers] = STATE(982),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(666),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(983),
    [sym_array_type] = STATE(666),
    [sym_function_type] = STATE(666),
    [sym_tuple_type] = STATE(666),
    [sym_unit_type] = STATE(666),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(666),
    [sym_reference_type] = STATE(666),
    [sym_pointer_type] = STATE(666),
    [sym_empty_type] = STATE(666),
    [sym_dynamic_type] = STATE(666),
    [sym_macro_invocation] = STATE(666),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(984),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(2004),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(2006),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2008),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2010),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [497] = {
    [sym_else_tail] = STATE(986),
    [sym_raw_string_literal] = ACTIONS(2012),
    [sym_float_literal] = ACTIONS(2012),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2012),
    [anon_sym_macro_rules_BANG] = ACTIONS(2012),
    [anon_sym_LPAREN] = ACTIONS(2012),
    [anon_sym_LBRACE] = ACTIONS(2012),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_PLUS] = ACTIONS(2014),
    [anon_sym_STAR] = ACTIONS(2014),
    [anon_sym_u8] = ACTIONS(2014),
    [anon_sym_i8] = ACTIONS(2014),
    [anon_sym_u16] = ACTIONS(2014),
    [anon_sym_i16] = ACTIONS(2014),
    [anon_sym_u32] = ACTIONS(2014),
    [anon_sym_i32] = ACTIONS(2014),
    [anon_sym_u64] = ACTIONS(2014),
    [anon_sym_i64] = ACTIONS(2014),
    [anon_sym_u128] = ACTIONS(2014),
    [anon_sym_i128] = ACTIONS(2014),
    [anon_sym_isize] = ACTIONS(2014),
    [anon_sym_usize] = ACTIONS(2014),
    [anon_sym_f32] = ACTIONS(2014),
    [anon_sym_f64] = ACTIONS(2014),
    [anon_sym_bool] = ACTIONS(2014),
    [anon_sym_str] = ACTIONS(2014),
    [anon_sym_char] = ACTIONS(2014),
    [anon_sym_AMP] = ACTIONS(2014),
    [anon_sym_DASH] = ACTIONS(2014),
    [anon_sym_DOT] = ACTIONS(2014),
    [anon_sym_DASH_EQ] = ACTIONS(2012),
    [anon_sym_COLON_COLON] = ACTIONS(2012),
    [anon_sym_BANG] = ACTIONS(2014),
    [anon_sym_BANG_EQ] = ACTIONS(2012),
    [anon_sym_STAR_EQ] = ACTIONS(2012),
    [anon_sym_SLASH] = ACTIONS(2014),
    [anon_sym_SLASH_EQ] = ACTIONS(2012),
    [anon_sym_AMP_AMP] = ACTIONS(2012),
    [anon_sym_AMP_EQ] = ACTIONS(2012),
    [anon_sym_POUND] = ACTIONS(2012),
    [anon_sym_PERCENT] = ACTIONS(2014),
    [anon_sym_PERCENT_EQ] = ACTIONS(2012),
    [anon_sym_CARET] = ACTIONS(2014),
    [anon_sym_CARET_EQ] = ACTIONS(2012),
    [anon_sym_PLUS_EQ] = ACTIONS(2012),
    [anon_sym_LT] = ACTIONS(2014),
    [anon_sym_LT_LT] = ACTIONS(2014),
    [anon_sym_LT_LT_EQ] = ACTIONS(2012),
    [anon_sym_LT_EQ] = ACTIONS(2012),
    [anon_sym_EQ] = ACTIONS(2014),
    [anon_sym_EQ_EQ] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2014),
    [anon_sym_GT_EQ] = ACTIONS(2012),
    [anon_sym_GT_GT] = ACTIONS(2014),
    [anon_sym_GT_GT_EQ] = ACTIONS(2012),
    [anon_sym_PIPE] = ACTIONS(2014),
    [anon_sym_PIPE_EQ] = ACTIONS(2012),
    [anon_sym_PIPE_PIPE] = ACTIONS(2012),
    [anon_sym_QMARK] = ACTIONS(2012),
    [anon_sym_SQUOTE] = ACTIONS(2014),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2012),
    [anon_sym_as] = ACTIONS(2014),
    [anon_sym_break] = ACTIONS(2014),
    [anon_sym_const] = ACTIONS(2014),
    [anon_sym_continue] = ACTIONS(2014),
    [anon_sym_default] = ACTIONS(2014),
    [anon_sym_enum] = ACTIONS(2014),
    [anon_sym_fn] = ACTIONS(2014),
    [anon_sym_for] = ACTIONS(2014),
    [anon_sym_if] = ACTIONS(2014),
    [anon_sym_impl] = ACTIONS(2014),
    [anon_sym_let] = ACTIONS(2014),
    [anon_sym_loop] = ACTIONS(2014),
    [anon_sym_match] = ACTIONS(2014),
    [anon_sym_mod] = ACTIONS(2014),
    [anon_sym_pub] = ACTIONS(2014),
    [anon_sym_return] = ACTIONS(2014),
    [anon_sym_static] = ACTIONS(2014),
    [anon_sym_struct] = ACTIONS(2014),
    [anon_sym_trait] = ACTIONS(2014),
    [anon_sym_type] = ACTIONS(2014),
    [anon_sym_union] = ACTIONS(2014),
    [anon_sym_unsafe] = ACTIONS(2014),
    [anon_sym_use] = ACTIONS(2014),
    [anon_sym_while] = ACTIONS(2014),
    [anon_sym_extern] = ACTIONS(2014),
    [anon_sym_else] = ACTIONS(2016),
    [anon_sym_move] = ACTIONS(2014),
    [sym_integer_literal] = ACTIONS(2012),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2012),
    [sym_char_literal] = ACTIONS(2012),
    [anon_sym_true] = ACTIONS(2014),
    [anon_sym_false] = ACTIONS(2014),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2014),
    [sym_self] = ACTIONS(2014),
    [sym_super] = ACTIONS(2014),
    [sym_crate] = ACTIONS(2014),
    [sym_metavariable] = ACTIONS(2012),
  },
  [498] = {
    [sym_type_arguments] = STATE(987),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(1139),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1223),
  },
  [499] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(1323),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [500] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2018),
  },
  [501] = {
    [sym_trait_bounds] = STATE(993),
    [sym_parameters] = STATE(399),
    [sym_type_arguments] = STATE(400),
    [aux_sym_type_parameters_repeat1] = STATE(994),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(2020),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_COMMA] = ACTIONS(2022),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_BANG] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_EQ] = ACTIONS(2024),
    [anon_sym_GT] = ACTIONS(2026),
    [anon_sym_as] = ACTIONS(773),
    [sym_line_comment] = ACTIONS(7),
  },
  [502] = {
    [aux_sym_type_parameters_repeat1] = STATE(996),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(783),
    [anon_sym_COMMA] = ACTIONS(2022),
    [anon_sym_COLON_COLON] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(2028),
    [anon_sym_as] = ACTIONS(783),
    [sym_line_comment] = ACTIONS(7),
  },
  [503] = {
    [aux_sym_type_parameters_repeat1] = STATE(996),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(2022),
    [anon_sym_EQ] = ACTIONS(2030),
    [anon_sym_GT] = ACTIONS(2028),
    [sym_line_comment] = ACTIONS(7),
  },
  [504] = {
    [aux_sym_type_parameters_repeat1] = STATE(996),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(2022),
    [anon_sym_GT] = ACTIONS(2028),
    [sym_line_comment] = ACTIONS(7),
  },
  [505] = {
    [sym_trait_bounds] = STATE(998),
    [aux_sym_type_parameters_repeat1] = STATE(996),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2032),
    [anon_sym_PLUS] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(2022),
    [anon_sym_GT] = ACTIONS(2028),
    [sym_line_comment] = ACTIONS(7),
  },
  [506] = {
    [sym_function_modifiers] = STATE(1003),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1004),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1005),
    [sym_array_type] = STATE(1004),
    [sym_function_type] = STATE(1004),
    [sym_tuple_type] = STATE(1004),
    [sym_unit_type] = STATE(1004),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1004),
    [sym_reference_type] = STATE(1004),
    [sym_pointer_type] = STATE(1004),
    [sym_empty_type] = STATE(1004),
    [sym_dynamic_type] = STATE(1004),
    [sym_macro_invocation] = STATE(1004),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1006),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2034),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2036),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2038),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2040),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [507] = {
    [sym_raw_string_literal] = ACTIONS(2042),
    [sym_float_literal] = ACTIONS(2042),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(2042),
    [anon_sym_SEMI] = ACTIONS(2042),
    [anon_sym_macro_rules_BANG] = ACTIONS(2042),
    [anon_sym_LPAREN] = ACTIONS(2042),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_RBRACE] = ACTIONS(2042),
    [anon_sym_LBRACK] = ACTIONS(2042),
    [anon_sym_STAR] = ACTIONS(2042),
    [anon_sym_u8] = ACTIONS(2044),
    [anon_sym_i8] = ACTIONS(2044),
    [anon_sym_u16] = ACTIONS(2044),
    [anon_sym_i16] = ACTIONS(2044),
    [anon_sym_u32] = ACTIONS(2044),
    [anon_sym_i32] = ACTIONS(2044),
    [anon_sym_u64] = ACTIONS(2044),
    [anon_sym_i64] = ACTIONS(2044),
    [anon_sym_u128] = ACTIONS(2044),
    [anon_sym_i128] = ACTIONS(2044),
    [anon_sym_isize] = ACTIONS(2044),
    [anon_sym_usize] = ACTIONS(2044),
    [anon_sym_f32] = ACTIONS(2044),
    [anon_sym_f64] = ACTIONS(2044),
    [anon_sym_bool] = ACTIONS(2044),
    [anon_sym_str] = ACTIONS(2044),
    [anon_sym_char] = ACTIONS(2044),
    [anon_sym_AMP] = ACTIONS(2042),
    [anon_sym_DASH] = ACTIONS(2042),
    [anon_sym_COLON_COLON] = ACTIONS(2042),
    [anon_sym_BANG] = ACTIONS(2042),
    [anon_sym_POUND] = ACTIONS(2042),
    [anon_sym_LT] = ACTIONS(2042),
    [anon_sym_PIPE] = ACTIONS(2042),
    [anon_sym_SQUOTE] = ACTIONS(2044),
    [anon_sym_DOT_DOT] = ACTIONS(2042),
    [anon_sym_break] = ACTIONS(2044),
    [anon_sym_const] = ACTIONS(2044),
    [anon_sym_continue] = ACTIONS(2044),
    [anon_sym_default] = ACTIONS(2044),
    [anon_sym_enum] = ACTIONS(2044),
    [anon_sym_fn] = ACTIONS(2044),
    [anon_sym_for] = ACTIONS(2044),
    [anon_sym_if] = ACTIONS(2044),
    [anon_sym_impl] = ACTIONS(2044),
    [anon_sym_let] = ACTIONS(2044),
    [anon_sym_loop] = ACTIONS(2044),
    [anon_sym_match] = ACTIONS(2044),
    [anon_sym_mod] = ACTIONS(2044),
    [anon_sym_pub] = ACTIONS(2044),
    [anon_sym_return] = ACTIONS(2044),
    [anon_sym_static] = ACTIONS(2044),
    [anon_sym_struct] = ACTIONS(2044),
    [anon_sym_trait] = ACTIONS(2044),
    [anon_sym_type] = ACTIONS(2044),
    [anon_sym_union] = ACTIONS(2044),
    [anon_sym_unsafe] = ACTIONS(2044),
    [anon_sym_use] = ACTIONS(2044),
    [anon_sym_while] = ACTIONS(2044),
    [anon_sym_extern] = ACTIONS(2044),
    [anon_sym_move] = ACTIONS(2044),
    [sym_integer_literal] = ACTIONS(2042),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2042),
    [sym_char_literal] = ACTIONS(2042),
    [anon_sym_true] = ACTIONS(2044),
    [anon_sym_false] = ACTIONS(2044),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2044),
    [sym_self] = ACTIONS(2044),
    [sym_super] = ACTIONS(2044),
    [sym_crate] = ACTIONS(2044),
    [sym_metavariable] = ACTIONS(2042),
  },
  [508] = {
    [sym_declaration_list] = STATE(1007),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [sym_line_comment] = ACTIONS(7),
  },
  [509] = {
    [sym_declaration_list] = STATE(1007),
    [sym_where_clause] = STATE(1008),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [510] = {
    [sym_declaration_list] = STATE(1007),
    [sym_where_clause] = STATE(1008),
    [sym_impl_for_clause] = STATE(1009),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1798),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [511] = {
    [sym_declaration_list] = STATE(1010),
    [sym_where_clause] = STATE(1011),
    [sym_impl_for_clause] = STATE(1012),
    [sym_type_arguments] = STATE(1013),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [512] = {
    [sym_declaration_list] = STATE(1014),
    [sym_where_clause] = STATE(1015),
    [sym_impl_for_clause] = STATE(1016),
    [sym_type_arguments] = STATE(1017),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [513] = {
    [sym_raw_string_literal] = ACTIONS(2046),
    [sym_float_literal] = ACTIONS(2046),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(2046),
    [anon_sym_SEMI] = ACTIONS(2046),
    [anon_sym_macro_rules_BANG] = ACTIONS(2046),
    [anon_sym_LPAREN] = ACTIONS(2046),
    [anon_sym_LBRACE] = ACTIONS(2046),
    [anon_sym_RBRACE] = ACTIONS(2046),
    [anon_sym_LBRACK] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(2046),
    [anon_sym_u8] = ACTIONS(2048),
    [anon_sym_i8] = ACTIONS(2048),
    [anon_sym_u16] = ACTIONS(2048),
    [anon_sym_i16] = ACTIONS(2048),
    [anon_sym_u32] = ACTIONS(2048),
    [anon_sym_i32] = ACTIONS(2048),
    [anon_sym_u64] = ACTIONS(2048),
    [anon_sym_i64] = ACTIONS(2048),
    [anon_sym_u128] = ACTIONS(2048),
    [anon_sym_i128] = ACTIONS(2048),
    [anon_sym_isize] = ACTIONS(2048),
    [anon_sym_usize] = ACTIONS(2048),
    [anon_sym_f32] = ACTIONS(2048),
    [anon_sym_f64] = ACTIONS(2048),
    [anon_sym_bool] = ACTIONS(2048),
    [anon_sym_str] = ACTIONS(2048),
    [anon_sym_char] = ACTIONS(2048),
    [anon_sym_AMP] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2046),
    [anon_sym_COLON_COLON] = ACTIONS(2046),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_POUND] = ACTIONS(2046),
    [anon_sym_LT] = ACTIONS(2046),
    [anon_sym_PIPE] = ACTIONS(2046),
    [anon_sym_SQUOTE] = ACTIONS(2048),
    [anon_sym_DOT_DOT] = ACTIONS(2046),
    [anon_sym_break] = ACTIONS(2048),
    [anon_sym_const] = ACTIONS(2048),
    [anon_sym_continue] = ACTIONS(2048),
    [anon_sym_default] = ACTIONS(2048),
    [anon_sym_enum] = ACTIONS(2048),
    [anon_sym_fn] = ACTIONS(2048),
    [anon_sym_for] = ACTIONS(2048),
    [anon_sym_if] = ACTIONS(2048),
    [anon_sym_impl] = ACTIONS(2048),
    [anon_sym_let] = ACTIONS(2048),
    [anon_sym_loop] = ACTIONS(2048),
    [anon_sym_match] = ACTIONS(2048),
    [anon_sym_mod] = ACTIONS(2048),
    [anon_sym_pub] = ACTIONS(2048),
    [anon_sym_return] = ACTIONS(2048),
    [anon_sym_static] = ACTIONS(2048),
    [anon_sym_struct] = ACTIONS(2048),
    [anon_sym_trait] = ACTIONS(2048),
    [anon_sym_type] = ACTIONS(2048),
    [anon_sym_union] = ACTIONS(2048),
    [anon_sym_unsafe] = ACTIONS(2048),
    [anon_sym_use] = ACTIONS(2048),
    [anon_sym_while] = ACTIONS(2048),
    [anon_sym_extern] = ACTIONS(2048),
    [anon_sym_move] = ACTIONS(2048),
    [sym_integer_literal] = ACTIONS(2046),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2046),
    [sym_char_literal] = ACTIONS(2046),
    [anon_sym_true] = ACTIONS(2048),
    [anon_sym_false] = ACTIONS(2048),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2048),
    [sym_self] = ACTIONS(2048),
    [sym_super] = ACTIONS(2048),
    [sym_crate] = ACTIONS(2048),
    [sym_metavariable] = ACTIONS(2046),
  },
  [514] = {
    [sym_declaration_list] = STATE(1014),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [sym_line_comment] = ACTIONS(7),
  },
  [515] = {
    [sym_declaration_list] = STATE(1014),
    [sym_where_clause] = STATE(1015),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [516] = {
    [sym_declaration_list] = STATE(1014),
    [sym_where_clause] = STATE(1015),
    [sym_impl_for_clause] = STATE(1016),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1816),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [517] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(898),
    [sym_tuple_pattern] = STATE(898),
    [sym_tuple_struct_pattern] = STATE(898),
    [sym_struct_pattern] = STATE(898),
    [sym_remaining_field_pattern] = STATE(898),
    [sym_mut_pattern] = STATE(898),
    [sym_ref_pattern] = STATE(898),
    [sym_captured_pattern] = STATE(898),
    [sym_reference_pattern] = STATE(898),
    [sym__literal] = STATE(898),
    [sym_string_literal] = STATE(898),
    [sym_boolean_literal] = STATE(898),
    [sym_raw_string_literal] = ACTIONS(1858),
    [sym_float_literal] = ACTIONS(1858),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(1860),
    [anon_sym_AMP] = ACTIONS(341),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(1021),
    [anon_sym_ref] = ACTIONS(345),
    [sym_integer_literal] = ACTIONS(1858),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(1858),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(347),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [518] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(438),
    [sym_tuple_pattern] = STATE(438),
    [sym_tuple_struct_pattern] = STATE(438),
    [sym_struct_pattern] = STATE(438),
    [sym_remaining_field_pattern] = STATE(438),
    [sym_mut_pattern] = STATE(438),
    [sym_ref_pattern] = STATE(438),
    [sym_captured_pattern] = STATE(438),
    [sym_reference_pattern] = STATE(438),
    [sym__literal] = STATE(438),
    [sym_string_literal] = STATE(438),
    [sym_boolean_literal] = STATE(438),
    [sym_raw_string_literal] = ACTIONS(855),
    [sym_float_literal] = ACTIONS(855),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(931),
    [anon_sym_AMP] = ACTIONS(341),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(1021),
    [anon_sym_ref] = ACTIONS(345),
    [sym_integer_literal] = ACTIONS(855),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(855),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(347),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [519] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2050),
    [anon_sym_COLON] = ACTIONS(2052),
    [anon_sym_EQ] = ACTIONS(2054),
    [sym_line_comment] = ACTIONS(7),
  },
  [520] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(916),
    [sym_tuple_pattern] = STATE(916),
    [sym_tuple_struct_pattern] = STATE(916),
    [sym_struct_pattern] = STATE(916),
    [sym_remaining_field_pattern] = STATE(916),
    [sym_mut_pattern] = STATE(916),
    [sym_ref_pattern] = STATE(916),
    [sym_captured_pattern] = STATE(916),
    [sym_reference_pattern] = STATE(916),
    [sym__literal] = STATE(916),
    [sym_string_literal] = STATE(916),
    [sym_boolean_literal] = STATE(916),
    [sym_raw_string_literal] = ACTIONS(1910),
    [sym_float_literal] = ACTIONS(1910),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(1912),
    [anon_sym_AMP] = ACTIONS(341),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(1021),
    [anon_sym_ref] = ACTIONS(345),
    [sym_integer_literal] = ACTIONS(1910),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(1910),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(347),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [521] = {
    [sym_raw_string_literal] = ACTIONS(2056),
    [sym_float_literal] = ACTIONS(2056),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(2056),
    [anon_sym_SEMI] = ACTIONS(2056),
    [anon_sym_macro_rules_BANG] = ACTIONS(2056),
    [anon_sym_LPAREN] = ACTIONS(2056),
    [anon_sym_LBRACE] = ACTIONS(2056),
    [anon_sym_RBRACE] = ACTIONS(2056),
    [anon_sym_LBRACK] = ACTIONS(2056),
    [anon_sym_STAR] = ACTIONS(2056),
    [anon_sym_u8] = ACTIONS(2058),
    [anon_sym_i8] = ACTIONS(2058),
    [anon_sym_u16] = ACTIONS(2058),
    [anon_sym_i16] = ACTIONS(2058),
    [anon_sym_u32] = ACTIONS(2058),
    [anon_sym_i32] = ACTIONS(2058),
    [anon_sym_u64] = ACTIONS(2058),
    [anon_sym_i64] = ACTIONS(2058),
    [anon_sym_u128] = ACTIONS(2058),
    [anon_sym_i128] = ACTIONS(2058),
    [anon_sym_isize] = ACTIONS(2058),
    [anon_sym_usize] = ACTIONS(2058),
    [anon_sym_f32] = ACTIONS(2058),
    [anon_sym_f64] = ACTIONS(2058),
    [anon_sym_bool] = ACTIONS(2058),
    [anon_sym_str] = ACTIONS(2058),
    [anon_sym_char] = ACTIONS(2058),
    [anon_sym_AMP] = ACTIONS(2056),
    [anon_sym_DASH] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2056),
    [anon_sym_BANG] = ACTIONS(2056),
    [anon_sym_POUND] = ACTIONS(2056),
    [anon_sym_LT] = ACTIONS(2056),
    [anon_sym_PIPE] = ACTIONS(2056),
    [anon_sym_SQUOTE] = ACTIONS(2058),
    [anon_sym_DOT_DOT] = ACTIONS(2056),
    [anon_sym_break] = ACTIONS(2058),
    [anon_sym_const] = ACTIONS(2058),
    [anon_sym_continue] = ACTIONS(2058),
    [anon_sym_default] = ACTIONS(2058),
    [anon_sym_enum] = ACTIONS(2058),
    [anon_sym_fn] = ACTIONS(2058),
    [anon_sym_for] = ACTIONS(2058),
    [anon_sym_if] = ACTIONS(2058),
    [anon_sym_impl] = ACTIONS(2058),
    [anon_sym_let] = ACTIONS(2058),
    [anon_sym_loop] = ACTIONS(2058),
    [anon_sym_match] = ACTIONS(2058),
    [anon_sym_mod] = ACTIONS(2058),
    [anon_sym_pub] = ACTIONS(2058),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_static] = ACTIONS(2058),
    [anon_sym_struct] = ACTIONS(2058),
    [anon_sym_trait] = ACTIONS(2058),
    [anon_sym_type] = ACTIONS(2058),
    [anon_sym_union] = ACTIONS(2058),
    [anon_sym_unsafe] = ACTIONS(2058),
    [anon_sym_use] = ACTIONS(2058),
    [anon_sym_while] = ACTIONS(2058),
    [anon_sym_extern] = ACTIONS(2058),
    [anon_sym_move] = ACTIONS(2058),
    [sym_integer_literal] = ACTIONS(2056),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2056),
    [sym_char_literal] = ACTIONS(2056),
    [anon_sym_true] = ACTIONS(2058),
    [anon_sym_false] = ACTIONS(2058),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2058),
    [sym_self] = ACTIONS(2058),
    [sym_super] = ACTIONS(2058),
    [sym_crate] = ACTIONS(2058),
    [sym_metavariable] = ACTIONS(2056),
  },
  [522] = {
    [sym_function_modifiers] = STATE(1025),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1026),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1027),
    [sym_array_type] = STATE(1026),
    [sym_function_type] = STATE(1026),
    [sym_tuple_type] = STATE(1026),
    [sym_unit_type] = STATE(1026),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1026),
    [sym_reference_type] = STATE(1026),
    [sym_pointer_type] = STATE(1026),
    [sym_empty_type] = STATE(1026),
    [sym_dynamic_type] = STATE(1026),
    [sym_macro_invocation] = STATE(1026),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1028),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2060),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2062),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2064),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2066),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [523] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1029),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1029),
    [sym_macro_invocation] = STATE(1029),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1029),
    [sym_unary_expression] = STATE(1029),
    [sym_try_expression] = STATE(1029),
    [sym_reference_expression] = STATE(1029),
    [sym_binary_expression] = STATE(1029),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1029),
    [sym_call_expression] = STATE(1029),
    [sym_array_expression] = STATE(1029),
    [sym_parenthesized_expression] = STATE(1029),
    [sym_tuple_expression] = STATE(1029),
    [sym_unit_expression] = STATE(1029),
    [sym_struct_expression] = STATE(1029),
    [sym_if_expression] = STATE(1029),
    [sym_if_let_expression] = STATE(1029),
    [sym_match_expression] = STATE(1029),
    [sym_while_expression] = STATE(1029),
    [sym_while_let_expression] = STATE(1029),
    [sym_loop_expression] = STATE(1029),
    [sym_for_expression] = STATE(1029),
    [sym_closure_expression] = STATE(1029),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1029),
    [sym_continue_expression] = STATE(1029),
    [sym_index_expression] = STATE(1029),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1029),
    [sym_block] = STATE(1029),
    [sym__literal] = STATE(1029),
    [sym_string_literal] = STATE(1029),
    [sym_boolean_literal] = STATE(1029),
    [sym_raw_string_literal] = ACTIONS(2068),
    [sym_float_literal] = ACTIONS(2068),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(2068),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(2068),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [524] = {
    [sym_attribute_item] = STATE(1049),
    [sym_bracketed_type] = STATE(1041),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(1042),
    [sym_scoped_identifier] = STATE(1043),
    [sym_scoped_type_identifier] = STATE(1044),
    [sym_match_arm] = STATE(1050),
    [sym_last_match_arm] = STATE(1045),
    [sym_match_pattern] = STATE(1046),
    [sym__pattern] = STATE(1047),
    [sym_tuple_pattern] = STATE(1047),
    [sym_tuple_struct_pattern] = STATE(1047),
    [sym_struct_pattern] = STATE(1047),
    [sym_remaining_field_pattern] = STATE(1047),
    [sym_mut_pattern] = STATE(1047),
    [sym_range_pattern] = STATE(1047),
    [sym_ref_pattern] = STATE(1047),
    [sym_captured_pattern] = STATE(1047),
    [sym_reference_pattern] = STATE(1047),
    [sym__literal] = STATE(1048),
    [sym_string_literal] = STATE(1048),
    [sym_boolean_literal] = STATE(1048),
    [aux_sym_enum_variant_list_repeat1] = STATE(1049),
    [aux_sym_match_expression_repeat1] = STATE(1050),
    [sym_raw_string_literal] = ACTIONS(2070),
    [sym_float_literal] = ACTIONS(2070),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2072),
    [anon_sym_RBRACE] = ACTIONS(2074),
    [anon_sym_u8] = ACTIONS(2076),
    [anon_sym_i8] = ACTIONS(2076),
    [anon_sym_u16] = ACTIONS(2076),
    [anon_sym_i16] = ACTIONS(2076),
    [anon_sym_u32] = ACTIONS(2076),
    [anon_sym_i32] = ACTIONS(2076),
    [anon_sym_u64] = ACTIONS(2076),
    [anon_sym_i64] = ACTIONS(2076),
    [anon_sym_u128] = ACTIONS(2076),
    [anon_sym_i128] = ACTIONS(2076),
    [anon_sym_isize] = ACTIONS(2076),
    [anon_sym_usize] = ACTIONS(2076),
    [anon_sym_f32] = ACTIONS(2076),
    [anon_sym_f64] = ACTIONS(2076),
    [anon_sym_bool] = ACTIONS(2076),
    [anon_sym_str] = ACTIONS(2076),
    [anon_sym_char] = ACTIONS(2076),
    [anon_sym__] = ACTIONS(2078),
    [anon_sym_AMP] = ACTIONS(2080),
    [anon_sym_COLON_COLON] = ACTIONS(2082),
    [anon_sym_POUND] = ACTIONS(2084),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(2086),
    [sym_mutable_specifier] = ACTIONS(2088),
    [anon_sym_ref] = ACTIONS(2090),
    [sym_integer_literal] = ACTIONS(2070),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(769),
    [sym_char_literal] = ACTIONS(2070),
    [anon_sym_true] = ACTIONS(2092),
    [anon_sym_false] = ACTIONS(2092),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2094),
    [sym_self] = ACTIONS(2096),
    [sym_super] = ACTIONS(2096),
    [sym_crate] = ACTIONS(2096),
    [sym_metavariable] = ACTIONS(2098),
  },
  [525] = {
    [sym_raw_string_literal] = ACTIONS(2100),
    [sym_float_literal] = ACTIONS(2100),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(2100),
    [anon_sym_SEMI] = ACTIONS(2100),
    [anon_sym_macro_rules_BANG] = ACTIONS(2100),
    [anon_sym_LPAREN] = ACTIONS(2100),
    [anon_sym_LBRACE] = ACTIONS(2100),
    [anon_sym_RBRACE] = ACTIONS(2100),
    [anon_sym_LBRACK] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(2100),
    [anon_sym_u8] = ACTIONS(2102),
    [anon_sym_i8] = ACTIONS(2102),
    [anon_sym_u16] = ACTIONS(2102),
    [anon_sym_i16] = ACTIONS(2102),
    [anon_sym_u32] = ACTIONS(2102),
    [anon_sym_i32] = ACTIONS(2102),
    [anon_sym_u64] = ACTIONS(2102),
    [anon_sym_i64] = ACTIONS(2102),
    [anon_sym_u128] = ACTIONS(2102),
    [anon_sym_i128] = ACTIONS(2102),
    [anon_sym_isize] = ACTIONS(2102),
    [anon_sym_usize] = ACTIONS(2102),
    [anon_sym_f32] = ACTIONS(2102),
    [anon_sym_f64] = ACTIONS(2102),
    [anon_sym_bool] = ACTIONS(2102),
    [anon_sym_str] = ACTIONS(2102),
    [anon_sym_char] = ACTIONS(2102),
    [anon_sym_AMP] = ACTIONS(2100),
    [anon_sym_DASH] = ACTIONS(2100),
    [anon_sym_COLON_COLON] = ACTIONS(2100),
    [anon_sym_BANG] = ACTIONS(2100),
    [anon_sym_POUND] = ACTIONS(2100),
    [anon_sym_LT] = ACTIONS(2100),
    [anon_sym_PIPE] = ACTIONS(2100),
    [anon_sym_SQUOTE] = ACTIONS(2102),
    [anon_sym_DOT_DOT] = ACTIONS(2100),
    [anon_sym_break] = ACTIONS(2102),
    [anon_sym_const] = ACTIONS(2102),
    [anon_sym_continue] = ACTIONS(2102),
    [anon_sym_default] = ACTIONS(2102),
    [anon_sym_enum] = ACTIONS(2102),
    [anon_sym_fn] = ACTIONS(2102),
    [anon_sym_for] = ACTIONS(2102),
    [anon_sym_if] = ACTIONS(2102),
    [anon_sym_impl] = ACTIONS(2102),
    [anon_sym_let] = ACTIONS(2102),
    [anon_sym_loop] = ACTIONS(2102),
    [anon_sym_match] = ACTIONS(2102),
    [anon_sym_mod] = ACTIONS(2102),
    [anon_sym_pub] = ACTIONS(2102),
    [anon_sym_return] = ACTIONS(2102),
    [anon_sym_static] = ACTIONS(2102),
    [anon_sym_struct] = ACTIONS(2102),
    [anon_sym_trait] = ACTIONS(2102),
    [anon_sym_type] = ACTIONS(2102),
    [anon_sym_union] = ACTIONS(2102),
    [anon_sym_unsafe] = ACTIONS(2102),
    [anon_sym_use] = ACTIONS(2102),
    [anon_sym_while] = ACTIONS(2102),
    [anon_sym_extern] = ACTIONS(2102),
    [anon_sym_move] = ACTIONS(2102),
    [sym_integer_literal] = ACTIONS(2100),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2100),
    [sym_char_literal] = ACTIONS(2100),
    [anon_sym_true] = ACTIONS(2102),
    [anon_sym_false] = ACTIONS(2102),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2102),
    [sym_self] = ACTIONS(2102),
    [sym_super] = ACTIONS(2102),
    [sym_crate] = ACTIONS(2102),
    [sym_metavariable] = ACTIONS(2100),
  },
  [526] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_type_with_turbofish] = STATE(212),
    [sym_scoped_identifier] = STATE(1054),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(2104),
    [anon_sym_i8] = ACTIONS(2104),
    [anon_sym_u16] = ACTIONS(2104),
    [anon_sym_i16] = ACTIONS(2104),
    [anon_sym_u32] = ACTIONS(2104),
    [anon_sym_i32] = ACTIONS(2104),
    [anon_sym_u64] = ACTIONS(2104),
    [anon_sym_i64] = ACTIONS(2104),
    [anon_sym_u128] = ACTIONS(2104),
    [anon_sym_i128] = ACTIONS(2104),
    [anon_sym_isize] = ACTIONS(2104),
    [anon_sym_usize] = ACTIONS(2104),
    [anon_sym_f32] = ACTIONS(2104),
    [anon_sym_f64] = ACTIONS(2104),
    [anon_sym_bool] = ACTIONS(2104),
    [anon_sym_str] = ACTIONS(2104),
    [anon_sym_char] = ACTIONS(2104),
    [anon_sym_COLON_COLON] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(31),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2106),
    [sym_self] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_crate] = ACTIONS(2108),
    [sym_metavariable] = ACTIONS(2110),
  },
  [527] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(2112),
    [sym_line_comment] = ACTIONS(7),
  },
  [528] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2114),
    [sym_line_comment] = ACTIONS(7),
  },
  [529] = {
    [sym_function_modifiers] = STATE(1025),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1057),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1027),
    [sym_array_type] = STATE(1057),
    [sym_function_type] = STATE(1057),
    [sym_tuple_type] = STATE(1057),
    [sym_unit_type] = STATE(1057),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1057),
    [sym_reference_type] = STATE(1057),
    [sym_pointer_type] = STATE(1057),
    [sym_empty_type] = STATE(1057),
    [sym_dynamic_type] = STATE(1057),
    [sym_macro_invocation] = STATE(1057),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1028),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2060),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2062),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2064),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2066),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [530] = {
    [sym_raw_string_literal] = ACTIONS(2116),
    [sym_float_literal] = ACTIONS(2116),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(2116),
    [anon_sym_SEMI] = ACTIONS(2116),
    [anon_sym_macro_rules_BANG] = ACTIONS(2116),
    [anon_sym_LPAREN] = ACTIONS(2116),
    [anon_sym_LBRACE] = ACTIONS(2116),
    [anon_sym_RBRACE] = ACTIONS(2116),
    [anon_sym_LBRACK] = ACTIONS(2116),
    [anon_sym_STAR] = ACTIONS(2116),
    [anon_sym_u8] = ACTIONS(2118),
    [anon_sym_i8] = ACTIONS(2118),
    [anon_sym_u16] = ACTIONS(2118),
    [anon_sym_i16] = ACTIONS(2118),
    [anon_sym_u32] = ACTIONS(2118),
    [anon_sym_i32] = ACTIONS(2118),
    [anon_sym_u64] = ACTIONS(2118),
    [anon_sym_i64] = ACTIONS(2118),
    [anon_sym_u128] = ACTIONS(2118),
    [anon_sym_i128] = ACTIONS(2118),
    [anon_sym_isize] = ACTIONS(2118),
    [anon_sym_usize] = ACTIONS(2118),
    [anon_sym_f32] = ACTIONS(2118),
    [anon_sym_f64] = ACTIONS(2118),
    [anon_sym_bool] = ACTIONS(2118),
    [anon_sym_str] = ACTIONS(2118),
    [anon_sym_char] = ACTIONS(2118),
    [anon_sym_AMP] = ACTIONS(2116),
    [anon_sym_DASH] = ACTIONS(2116),
    [anon_sym_COLON_COLON] = ACTIONS(2116),
    [anon_sym_BANG] = ACTIONS(2116),
    [anon_sym_POUND] = ACTIONS(2116),
    [anon_sym_LT] = ACTIONS(2116),
    [anon_sym_PIPE] = ACTIONS(2116),
    [anon_sym_SQUOTE] = ACTIONS(2118),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_break] = ACTIONS(2118),
    [anon_sym_const] = ACTIONS(2118),
    [anon_sym_continue] = ACTIONS(2118),
    [anon_sym_default] = ACTIONS(2118),
    [anon_sym_enum] = ACTIONS(2118),
    [anon_sym_fn] = ACTIONS(2118),
    [anon_sym_for] = ACTIONS(2118),
    [anon_sym_if] = ACTIONS(2118),
    [anon_sym_impl] = ACTIONS(2118),
    [anon_sym_let] = ACTIONS(2118),
    [anon_sym_loop] = ACTIONS(2118),
    [anon_sym_match] = ACTIONS(2118),
    [anon_sym_mod] = ACTIONS(2118),
    [anon_sym_pub] = ACTIONS(2118),
    [anon_sym_return] = ACTIONS(2118),
    [anon_sym_static] = ACTIONS(2118),
    [anon_sym_struct] = ACTIONS(2118),
    [anon_sym_trait] = ACTIONS(2118),
    [anon_sym_type] = ACTIONS(2118),
    [anon_sym_union] = ACTIONS(2118),
    [anon_sym_unsafe] = ACTIONS(2118),
    [anon_sym_use] = ACTIONS(2118),
    [anon_sym_while] = ACTIONS(2118),
    [anon_sym_extern] = ACTIONS(2118),
    [anon_sym_move] = ACTIONS(2118),
    [sym_integer_literal] = ACTIONS(2116),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2116),
    [sym_char_literal] = ACTIONS(2116),
    [anon_sym_true] = ACTIONS(2118),
    [anon_sym_false] = ACTIONS(2118),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2118),
    [sym_self] = ACTIONS(2118),
    [sym_super] = ACTIONS(2118),
    [sym_crate] = ACTIONS(2118),
    [sym_metavariable] = ACTIONS(2116),
  },
  [531] = {
    [sym_attribute_item] = STATE(1064),
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym_visibility_modifier] = STATE(1062),
    [sym__type] = STATE(1063),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(1063),
    [sym_function_type] = STATE(1063),
    [sym_tuple_type] = STATE(1063),
    [sym_unit_type] = STATE(1063),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1063),
    [sym_reference_type] = STATE(1063),
    [sym_pointer_type] = STATE(1063),
    [sym_empty_type] = STATE(1063),
    [sym_dynamic_type] = STATE(1063),
    [sym_macro_invocation] = STATE(1063),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_enum_variant_list_repeat1] = STATE(1064),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_RPAREN] = ACTIONS(2120),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(2122),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_POUND] = ACTIONS(2124),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_pub] = ACTIONS(2126),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [532] = {
    [sym_attribute_item] = STATE(1070),
    [sym_field_declaration] = STATE(1068),
    [sym_visibility_modifier] = STATE(1069),
    [aux_sym_enum_variant_list_repeat1] = STATE(1070),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(2128),
    [anon_sym_COMMA] = ACTIONS(2130),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_pub] = ACTIONS(1940),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2132),
  },
  [533] = {
    [sym_where_predicate] = STATE(1072),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1073),
    [sym_generic_type] = STATE(1074),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_reference_type] = STATE(1073),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1075),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(1948),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2134),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [534] = {
    [sym_where_clause] = STATE(1078),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2136),
    [anon_sym_where] = ACTIONS(2138),
    [sym_line_comment] = ACTIONS(7),
  },
  [535] = {
    [sym_field_declaration_list] = STATE(1076),
    [sym_ordered_field_declaration_list] = STATE(1079),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2136),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(1055),
    [sym_line_comment] = ACTIONS(7),
  },
  [536] = {
    [sym_field_declaration_list] = STATE(1076),
    [sym_ordered_field_declaration_list] = STATE(1079),
    [sym_where_clause] = STATE(1080),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2136),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(1057),
    [sym_line_comment] = ACTIONS(7),
  },
  [537] = {
    [sym_function_modifiers] = STATE(677),
    [sym_higher_ranked_trait_bound] = STATE(1083),
    [sym_removed_trait_bound] = STATE(1083),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1084),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1084),
    [sym_array_type] = STATE(1084),
    [sym_function_type] = STATE(1084),
    [sym_tuple_type] = STATE(1084),
    [sym_unit_type] = STATE(1084),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1084),
    [sym_reference_type] = STATE(1084),
    [sym_pointer_type] = STATE(1084),
    [sym_empty_type] = STATE(1084),
    [sym_dynamic_type] = STATE(1084),
    [sym_macro_invocation] = STATE(1084),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(680),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1315),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1317),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_QMARK] = ACTIONS(2140),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1319),
    [anon_sym_for] = ACTIONS(2142),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1321),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [538] = {
    [sym_constrained_type_parameter] = STATE(1087),
    [sym_optional_type_parameter] = STATE(1086),
    [sym_lifetime] = STATE(1088),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2144),
    [sym_metavariable] = ACTIONS(2146),
  },
  [539] = {
    [sym_raw_string_literal] = ACTIONS(2148),
    [sym_float_literal] = ACTIONS(2148),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(2148),
    [anon_sym_SEMI] = ACTIONS(2148),
    [anon_sym_macro_rules_BANG] = ACTIONS(2148),
    [anon_sym_LPAREN] = ACTIONS(2148),
    [anon_sym_LBRACE] = ACTIONS(2148),
    [anon_sym_RBRACE] = ACTIONS(2148),
    [anon_sym_LBRACK] = ACTIONS(2148),
    [anon_sym_STAR] = ACTIONS(2148),
    [anon_sym_u8] = ACTIONS(2150),
    [anon_sym_i8] = ACTIONS(2150),
    [anon_sym_u16] = ACTIONS(2150),
    [anon_sym_i16] = ACTIONS(2150),
    [anon_sym_u32] = ACTIONS(2150),
    [anon_sym_i32] = ACTIONS(2150),
    [anon_sym_u64] = ACTIONS(2150),
    [anon_sym_i64] = ACTIONS(2150),
    [anon_sym_u128] = ACTIONS(2150),
    [anon_sym_i128] = ACTIONS(2150),
    [anon_sym_isize] = ACTIONS(2150),
    [anon_sym_usize] = ACTIONS(2150),
    [anon_sym_f32] = ACTIONS(2150),
    [anon_sym_f64] = ACTIONS(2150),
    [anon_sym_bool] = ACTIONS(2150),
    [anon_sym_str] = ACTIONS(2150),
    [anon_sym_char] = ACTIONS(2150),
    [anon_sym_AMP] = ACTIONS(2148),
    [anon_sym_DASH] = ACTIONS(2148),
    [anon_sym_COLON_COLON] = ACTIONS(2148),
    [anon_sym_BANG] = ACTIONS(2148),
    [anon_sym_POUND] = ACTIONS(2148),
    [anon_sym_LT] = ACTIONS(2148),
    [anon_sym_PIPE] = ACTIONS(2148),
    [anon_sym_SQUOTE] = ACTIONS(2150),
    [anon_sym_DOT_DOT] = ACTIONS(2148),
    [anon_sym_break] = ACTIONS(2150),
    [anon_sym_const] = ACTIONS(2150),
    [anon_sym_continue] = ACTIONS(2150),
    [anon_sym_default] = ACTIONS(2150),
    [anon_sym_enum] = ACTIONS(2150),
    [anon_sym_fn] = ACTIONS(2150),
    [anon_sym_for] = ACTIONS(2150),
    [anon_sym_if] = ACTIONS(2150),
    [anon_sym_impl] = ACTIONS(2150),
    [anon_sym_let] = ACTIONS(2150),
    [anon_sym_loop] = ACTIONS(2150),
    [anon_sym_match] = ACTIONS(2150),
    [anon_sym_mod] = ACTIONS(2150),
    [anon_sym_pub] = ACTIONS(2150),
    [anon_sym_return] = ACTIONS(2150),
    [anon_sym_static] = ACTIONS(2150),
    [anon_sym_struct] = ACTIONS(2150),
    [anon_sym_trait] = ACTIONS(2150),
    [anon_sym_type] = ACTIONS(2150),
    [anon_sym_union] = ACTIONS(2150),
    [anon_sym_unsafe] = ACTIONS(2150),
    [anon_sym_use] = ACTIONS(2150),
    [anon_sym_while] = ACTIONS(2150),
    [anon_sym_extern] = ACTIONS(2150),
    [anon_sym_move] = ACTIONS(2150),
    [sym_integer_literal] = ACTIONS(2148),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2148),
    [sym_char_literal] = ACTIONS(2148),
    [anon_sym_true] = ACTIONS(2150),
    [anon_sym_false] = ACTIONS(2150),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2150),
    [sym_self] = ACTIONS(2150),
    [sym_super] = ACTIONS(2150),
    [sym_crate] = ACTIONS(2150),
    [sym_metavariable] = ACTIONS(2148),
  },
  [540] = {
    [sym_declaration_list] = STATE(1089),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [sym_line_comment] = ACTIONS(7),
  },
  [541] = {
    [sym_declaration_list] = STATE(1089),
    [sym_trait_bounds] = STATE(1090),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_COLON] = ACTIONS(1059),
    [sym_line_comment] = ACTIONS(7),
  },
  [542] = {
    [sym_raw_string_literal] = ACTIONS(2152),
    [sym_float_literal] = ACTIONS(2152),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(2152),
    [anon_sym_SEMI] = ACTIONS(2152),
    [anon_sym_macro_rules_BANG] = ACTIONS(2152),
    [anon_sym_LPAREN] = ACTIONS(2152),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_RBRACE] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2152),
    [anon_sym_STAR] = ACTIONS(2152),
    [anon_sym_u8] = ACTIONS(2154),
    [anon_sym_i8] = ACTIONS(2154),
    [anon_sym_u16] = ACTIONS(2154),
    [anon_sym_i16] = ACTIONS(2154),
    [anon_sym_u32] = ACTIONS(2154),
    [anon_sym_i32] = ACTIONS(2154),
    [anon_sym_u64] = ACTIONS(2154),
    [anon_sym_i64] = ACTIONS(2154),
    [anon_sym_u128] = ACTIONS(2154),
    [anon_sym_i128] = ACTIONS(2154),
    [anon_sym_isize] = ACTIONS(2154),
    [anon_sym_usize] = ACTIONS(2154),
    [anon_sym_f32] = ACTIONS(2154),
    [anon_sym_f64] = ACTIONS(2154),
    [anon_sym_bool] = ACTIONS(2154),
    [anon_sym_str] = ACTIONS(2154),
    [anon_sym_char] = ACTIONS(2154),
    [anon_sym_AMP] = ACTIONS(2152),
    [anon_sym_DASH] = ACTIONS(2152),
    [anon_sym_COLON_COLON] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2152),
    [anon_sym_POUND] = ACTIONS(2152),
    [anon_sym_LT] = ACTIONS(2152),
    [anon_sym_PIPE] = ACTIONS(2152),
    [anon_sym_SQUOTE] = ACTIONS(2154),
    [anon_sym_DOT_DOT] = ACTIONS(2152),
    [anon_sym_break] = ACTIONS(2154),
    [anon_sym_const] = ACTIONS(2154),
    [anon_sym_continue] = ACTIONS(2154),
    [anon_sym_default] = ACTIONS(2154),
    [anon_sym_enum] = ACTIONS(2154),
    [anon_sym_fn] = ACTIONS(2154),
    [anon_sym_for] = ACTIONS(2154),
    [anon_sym_if] = ACTIONS(2154),
    [anon_sym_impl] = ACTIONS(2154),
    [anon_sym_let] = ACTIONS(2154),
    [anon_sym_loop] = ACTIONS(2154),
    [anon_sym_match] = ACTIONS(2154),
    [anon_sym_mod] = ACTIONS(2154),
    [anon_sym_pub] = ACTIONS(2154),
    [anon_sym_return] = ACTIONS(2154),
    [anon_sym_static] = ACTIONS(2154),
    [anon_sym_struct] = ACTIONS(2154),
    [anon_sym_trait] = ACTIONS(2154),
    [anon_sym_type] = ACTIONS(2154),
    [anon_sym_union] = ACTIONS(2154),
    [anon_sym_unsafe] = ACTIONS(2154),
    [anon_sym_use] = ACTIONS(2154),
    [anon_sym_while] = ACTIONS(2154),
    [anon_sym_extern] = ACTIONS(2154),
    [anon_sym_move] = ACTIONS(2154),
    [sym_integer_literal] = ACTIONS(2152),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2152),
    [sym_char_literal] = ACTIONS(2152),
    [anon_sym_true] = ACTIONS(2154),
    [anon_sym_false] = ACTIONS(2154),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2154),
    [sym_self] = ACTIONS(2154),
    [sym_super] = ACTIONS(2154),
    [sym_crate] = ACTIONS(2154),
    [sym_metavariable] = ACTIONS(2152),
  },
  [543] = {
    [sym_function_modifiers] = STATE(1097),
    [sym_higher_ranked_trait_bound] = STATE(1098),
    [sym_removed_trait_bound] = STATE(1098),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1099),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1099),
    [sym_array_type] = STATE(1099),
    [sym_function_type] = STATE(1099),
    [sym_tuple_type] = STATE(1099),
    [sym_unit_type] = STATE(1099),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1099),
    [sym_reference_type] = STATE(1099),
    [sym_pointer_type] = STATE(1099),
    [sym_empty_type] = STATE(1099),
    [sym_dynamic_type] = STATE(1099),
    [sym_macro_invocation] = STATE(1099),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2156),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_QMARK] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2162),
    [anon_sym_for] = ACTIONS(2164),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2166),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [544] = {
    [sym_function_modifiers] = STATE(1097),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1101),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1102),
    [sym_array_type] = STATE(1101),
    [sym_function_type] = STATE(1101),
    [sym_tuple_type] = STATE(1101),
    [sym_unit_type] = STATE(1101),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1101),
    [sym_reference_type] = STATE(1101),
    [sym_pointer_type] = STATE(1101),
    [sym_empty_type] = STATE(1101),
    [sym_dynamic_type] = STATE(1101),
    [sym_macro_invocation] = STATE(1101),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2156),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2162),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2166),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [545] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2168),
    [sym_line_comment] = ACTIONS(7),
  },
  [546] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(2170),
    [sym_line_comment] = ACTIONS(7),
  },
  [547] = {
    [sym_raw_string_literal] = ACTIONS(2172),
    [sym_float_literal] = ACTIONS(2172),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(2172),
    [anon_sym_SEMI] = ACTIONS(2172),
    [anon_sym_macro_rules_BANG] = ACTIONS(2172),
    [anon_sym_LPAREN] = ACTIONS(2172),
    [anon_sym_LBRACE] = ACTIONS(2172),
    [anon_sym_RBRACE] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2172),
    [anon_sym_STAR] = ACTIONS(2172),
    [anon_sym_u8] = ACTIONS(2174),
    [anon_sym_i8] = ACTIONS(2174),
    [anon_sym_u16] = ACTIONS(2174),
    [anon_sym_i16] = ACTIONS(2174),
    [anon_sym_u32] = ACTIONS(2174),
    [anon_sym_i32] = ACTIONS(2174),
    [anon_sym_u64] = ACTIONS(2174),
    [anon_sym_i64] = ACTIONS(2174),
    [anon_sym_u128] = ACTIONS(2174),
    [anon_sym_i128] = ACTIONS(2174),
    [anon_sym_isize] = ACTIONS(2174),
    [anon_sym_usize] = ACTIONS(2174),
    [anon_sym_f32] = ACTIONS(2174),
    [anon_sym_f64] = ACTIONS(2174),
    [anon_sym_bool] = ACTIONS(2174),
    [anon_sym_str] = ACTIONS(2174),
    [anon_sym_char] = ACTIONS(2174),
    [anon_sym_AMP] = ACTIONS(2172),
    [anon_sym_DASH] = ACTIONS(2172),
    [anon_sym_COLON_COLON] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2172),
    [anon_sym_POUND] = ACTIONS(2172),
    [anon_sym_LT] = ACTIONS(2172),
    [anon_sym_PIPE] = ACTIONS(2172),
    [anon_sym_SQUOTE] = ACTIONS(2174),
    [anon_sym_DOT_DOT] = ACTIONS(2172),
    [anon_sym_break] = ACTIONS(2174),
    [anon_sym_const] = ACTIONS(2174),
    [anon_sym_continue] = ACTIONS(2174),
    [anon_sym_default] = ACTIONS(2174),
    [anon_sym_enum] = ACTIONS(2174),
    [anon_sym_fn] = ACTIONS(2174),
    [anon_sym_for] = ACTIONS(2174),
    [anon_sym_if] = ACTIONS(2174),
    [anon_sym_impl] = ACTIONS(2174),
    [anon_sym_let] = ACTIONS(2174),
    [anon_sym_loop] = ACTIONS(2174),
    [anon_sym_match] = ACTIONS(2174),
    [anon_sym_mod] = ACTIONS(2174),
    [anon_sym_pub] = ACTIONS(2174),
    [anon_sym_return] = ACTIONS(2174),
    [anon_sym_static] = ACTIONS(2174),
    [anon_sym_struct] = ACTIONS(2174),
    [anon_sym_trait] = ACTIONS(2174),
    [anon_sym_type] = ACTIONS(2174),
    [anon_sym_union] = ACTIONS(2174),
    [anon_sym_unsafe] = ACTIONS(2174),
    [anon_sym_use] = ACTIONS(2174),
    [anon_sym_while] = ACTIONS(2174),
    [anon_sym_extern] = ACTIONS(2174),
    [anon_sym_move] = ACTIONS(2174),
    [sym_integer_literal] = ACTIONS(2172),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2172),
    [sym_char_literal] = ACTIONS(2172),
    [anon_sym_true] = ACTIONS(2174),
    [anon_sym_false] = ACTIONS(2174),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2174),
    [sym_self] = ACTIONS(2174),
    [sym_super] = ACTIONS(2174),
    [sym_crate] = ACTIONS(2174),
    [sym_metavariable] = ACTIONS(2172),
  },
  [548] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2176),
    [sym_line_comment] = ACTIONS(7),
  },
  [549] = {
    [sym_field_declaration_list] = STATE(1105),
    [sym_ordered_field_declaration_list] = STATE(1106),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2176),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(1055),
    [sym_line_comment] = ACTIONS(7),
  },
  [550] = {
    [sym_field_declaration_list] = STATE(1105),
    [sym_ordered_field_declaration_list] = STATE(1106),
    [sym_where_clause] = STATE(1107),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2176),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(1057),
    [sym_line_comment] = ACTIONS(7),
  },
  [551] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1109),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2178),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [552] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2180),
    [anon_sym_RBRACE] = ACTIONS(2180),
    [anon_sym_COMMA] = ACTIONS(2180),
    [sym_line_comment] = ACTIONS(7),
  },
  [553] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(2182),
    [sym_line_comment] = ACTIONS(7),
  },
  [554] = {
    [aux_sym_use_list_repeat1] = STATE(1114),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(2184),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2188),
    [anon_sym_as] = ACTIONS(1093),
    [sym_line_comment] = ACTIONS(7),
  },
  [555] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(941),
  },
  [556] = {
    [aux_sym_use_list_repeat1] = STATE(1117),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(2182),
    [anon_sym_COMMA] = ACTIONS(2190),
    [anon_sym_COLON_COLON] = ACTIONS(2192),
    [anon_sym_as] = ACTIONS(1099),
    [sym_line_comment] = ACTIONS(7),
  },
  [557] = {
    [aux_sym_use_list_repeat1] = STATE(1117),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(2182),
    [anon_sym_COMMA] = ACTIONS(2190),
    [anon_sym_COLON_COLON] = ACTIONS(449),
    [anon_sym_as] = ACTIONS(1099),
    [sym_line_comment] = ACTIONS(7),
  },
  [558] = {
    [aux_sym_use_list_repeat1] = STATE(1117),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(2182),
    [anon_sym_COMMA] = ACTIONS(2190),
    [sym_line_comment] = ACTIONS(7),
  },
  [559] = {
    [aux_sym_use_list_repeat1] = STATE(1117),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(2182),
    [anon_sym_COMMA] = ACTIONS(2190),
    [anon_sym_COLON_COLON] = ACTIONS(2194),
    [anon_sym_as] = ACTIONS(1099),
    [sym_line_comment] = ACTIONS(7),
  },
  [560] = {
    [sym_use_list] = STATE(1120),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(2196),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1966),
  },
  [561] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2198),
  },
  [562] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2200),
    [sym_line_comment] = ACTIONS(7),
  },
  [563] = {
    [sym_use_list] = STATE(1123),
    [sym_type_arguments] = STATE(845),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(2202),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1223),
  },
  [564] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2204),
  },
  [565] = {
    [sym_use_list] = STATE(1123),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(2202),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1223),
  },
  [566] = {
    [sym_raw_string_literal] = ACTIONS(2206),
    [sym_float_literal] = ACTIONS(2206),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(2206),
    [anon_sym_SEMI] = ACTIONS(2206),
    [anon_sym_macro_rules_BANG] = ACTIONS(2206),
    [anon_sym_LPAREN] = ACTIONS(2206),
    [anon_sym_LBRACE] = ACTIONS(2206),
    [anon_sym_RBRACE] = ACTIONS(2206),
    [anon_sym_LBRACK] = ACTIONS(2206),
    [anon_sym_STAR] = ACTIONS(2206),
    [anon_sym_u8] = ACTIONS(2208),
    [anon_sym_i8] = ACTIONS(2208),
    [anon_sym_u16] = ACTIONS(2208),
    [anon_sym_i16] = ACTIONS(2208),
    [anon_sym_u32] = ACTIONS(2208),
    [anon_sym_i32] = ACTIONS(2208),
    [anon_sym_u64] = ACTIONS(2208),
    [anon_sym_i64] = ACTIONS(2208),
    [anon_sym_u128] = ACTIONS(2208),
    [anon_sym_i128] = ACTIONS(2208),
    [anon_sym_isize] = ACTIONS(2208),
    [anon_sym_usize] = ACTIONS(2208),
    [anon_sym_f32] = ACTIONS(2208),
    [anon_sym_f64] = ACTIONS(2208),
    [anon_sym_bool] = ACTIONS(2208),
    [anon_sym_str] = ACTIONS(2208),
    [anon_sym_char] = ACTIONS(2208),
    [anon_sym_AMP] = ACTIONS(2206),
    [anon_sym_DASH] = ACTIONS(2206),
    [anon_sym_COLON_COLON] = ACTIONS(2206),
    [anon_sym_BANG] = ACTIONS(2206),
    [anon_sym_POUND] = ACTIONS(2206),
    [anon_sym_LT] = ACTIONS(2206),
    [anon_sym_PIPE] = ACTIONS(2206),
    [anon_sym_SQUOTE] = ACTIONS(2208),
    [anon_sym_DOT_DOT] = ACTIONS(2206),
    [anon_sym_break] = ACTIONS(2208),
    [anon_sym_const] = ACTIONS(2208),
    [anon_sym_continue] = ACTIONS(2208),
    [anon_sym_default] = ACTIONS(2208),
    [anon_sym_enum] = ACTIONS(2208),
    [anon_sym_fn] = ACTIONS(2208),
    [anon_sym_for] = ACTIONS(2208),
    [anon_sym_if] = ACTIONS(2208),
    [anon_sym_impl] = ACTIONS(2208),
    [anon_sym_let] = ACTIONS(2208),
    [anon_sym_loop] = ACTIONS(2208),
    [anon_sym_match] = ACTIONS(2208),
    [anon_sym_mod] = ACTIONS(2208),
    [anon_sym_pub] = ACTIONS(2208),
    [anon_sym_return] = ACTIONS(2208),
    [anon_sym_static] = ACTIONS(2208),
    [anon_sym_struct] = ACTIONS(2208),
    [anon_sym_trait] = ACTIONS(2208),
    [anon_sym_type] = ACTIONS(2208),
    [anon_sym_union] = ACTIONS(2208),
    [anon_sym_unsafe] = ACTIONS(2208),
    [anon_sym_use] = ACTIONS(2208),
    [anon_sym_while] = ACTIONS(2208),
    [anon_sym_extern] = ACTIONS(2208),
    [anon_sym_move] = ACTIONS(2208),
    [sym_integer_literal] = ACTIONS(2206),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2206),
    [sym_char_literal] = ACTIONS(2206),
    [anon_sym_true] = ACTIONS(2208),
    [anon_sym_false] = ACTIONS(2208),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2208),
    [sym_self] = ACTIONS(2208),
    [sym_super] = ACTIONS(2208),
    [sym_crate] = ACTIONS(2208),
    [sym_metavariable] = ACTIONS(2206),
  },
  [567] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1980),
  },
  [568] = {
    [sym_use_list] = STATE(1123),
    [sym_type_arguments] = STATE(873),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(2202),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1223),
  },
  [569] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(2210),
    [sym_line_comment] = ACTIONS(7),
  },
  [570] = {
    [sym_raw_string_literal] = ACTIONS(2212),
    [sym_float_literal] = ACTIONS(2212),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2212),
    [anon_sym_macro_rules_BANG] = ACTIONS(2212),
    [anon_sym_LPAREN] = ACTIONS(2212),
    [anon_sym_LBRACE] = ACTIONS(2212),
    [anon_sym_RBRACE] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2212),
    [anon_sym_PLUS] = ACTIONS(2214),
    [anon_sym_STAR] = ACTIONS(2214),
    [anon_sym_u8] = ACTIONS(2214),
    [anon_sym_i8] = ACTIONS(2214),
    [anon_sym_u16] = ACTIONS(2214),
    [anon_sym_i16] = ACTIONS(2214),
    [anon_sym_u32] = ACTIONS(2214),
    [anon_sym_i32] = ACTIONS(2214),
    [anon_sym_u64] = ACTIONS(2214),
    [anon_sym_i64] = ACTIONS(2214),
    [anon_sym_u128] = ACTIONS(2214),
    [anon_sym_i128] = ACTIONS(2214),
    [anon_sym_isize] = ACTIONS(2214),
    [anon_sym_usize] = ACTIONS(2214),
    [anon_sym_f32] = ACTIONS(2214),
    [anon_sym_f64] = ACTIONS(2214),
    [anon_sym_bool] = ACTIONS(2214),
    [anon_sym_str] = ACTIONS(2214),
    [anon_sym_char] = ACTIONS(2214),
    [anon_sym_AMP] = ACTIONS(2214),
    [anon_sym_DASH] = ACTIONS(2214),
    [anon_sym_DOT] = ACTIONS(2214),
    [anon_sym_DASH_EQ] = ACTIONS(2212),
    [anon_sym_COLON_COLON] = ACTIONS(2212),
    [anon_sym_BANG] = ACTIONS(2214),
    [anon_sym_BANG_EQ] = ACTIONS(2212),
    [anon_sym_STAR_EQ] = ACTIONS(2212),
    [anon_sym_SLASH] = ACTIONS(2214),
    [anon_sym_SLASH_EQ] = ACTIONS(2212),
    [anon_sym_AMP_AMP] = ACTIONS(2212),
    [anon_sym_AMP_EQ] = ACTIONS(2212),
    [anon_sym_POUND] = ACTIONS(2212),
    [anon_sym_PERCENT] = ACTIONS(2214),
    [anon_sym_PERCENT_EQ] = ACTIONS(2212),
    [anon_sym_CARET] = ACTIONS(2214),
    [anon_sym_CARET_EQ] = ACTIONS(2212),
    [anon_sym_PLUS_EQ] = ACTIONS(2212),
    [anon_sym_LT] = ACTIONS(2214),
    [anon_sym_LT_LT] = ACTIONS(2214),
    [anon_sym_LT_LT_EQ] = ACTIONS(2212),
    [anon_sym_LT_EQ] = ACTIONS(2212),
    [anon_sym_EQ] = ACTIONS(2214),
    [anon_sym_EQ_EQ] = ACTIONS(2212),
    [anon_sym_GT] = ACTIONS(2214),
    [anon_sym_GT_EQ] = ACTIONS(2212),
    [anon_sym_GT_GT] = ACTIONS(2214),
    [anon_sym_GT_GT_EQ] = ACTIONS(2212),
    [anon_sym_PIPE] = ACTIONS(2214),
    [anon_sym_PIPE_EQ] = ACTIONS(2212),
    [anon_sym_PIPE_PIPE] = ACTIONS(2212),
    [anon_sym_QMARK] = ACTIONS(2212),
    [anon_sym_SQUOTE] = ACTIONS(2214),
    [anon_sym_DOT_DOT] = ACTIONS(2214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2212),
    [anon_sym_as] = ACTIONS(2214),
    [anon_sym_break] = ACTIONS(2214),
    [anon_sym_const] = ACTIONS(2214),
    [anon_sym_continue] = ACTIONS(2214),
    [anon_sym_default] = ACTIONS(2214),
    [anon_sym_enum] = ACTIONS(2214),
    [anon_sym_fn] = ACTIONS(2214),
    [anon_sym_for] = ACTIONS(2214),
    [anon_sym_if] = ACTIONS(2214),
    [anon_sym_impl] = ACTIONS(2214),
    [anon_sym_let] = ACTIONS(2214),
    [anon_sym_loop] = ACTIONS(2214),
    [anon_sym_match] = ACTIONS(2214),
    [anon_sym_mod] = ACTIONS(2214),
    [anon_sym_pub] = ACTIONS(2214),
    [anon_sym_return] = ACTIONS(2214),
    [anon_sym_static] = ACTIONS(2214),
    [anon_sym_struct] = ACTIONS(2214),
    [anon_sym_trait] = ACTIONS(2214),
    [anon_sym_type] = ACTIONS(2214),
    [anon_sym_union] = ACTIONS(2214),
    [anon_sym_unsafe] = ACTIONS(2214),
    [anon_sym_use] = ACTIONS(2214),
    [anon_sym_while] = ACTIONS(2214),
    [anon_sym_extern] = ACTIONS(2214),
    [anon_sym_move] = ACTIONS(2214),
    [sym_integer_literal] = ACTIONS(2212),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2212),
    [sym_char_literal] = ACTIONS(2212),
    [anon_sym_true] = ACTIONS(2214),
    [anon_sym_false] = ACTIONS(2214),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2214),
    [sym_self] = ACTIONS(2214),
    [sym_super] = ACTIONS(2214),
    [sym_crate] = ACTIONS(2214),
    [sym_metavariable] = ACTIONS(2212),
  },
  [571] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2216),
    [anon_sym_as] = ACTIONS(2218),
    [sym_line_comment] = ACTIONS(7),
  },
  [572] = {
    [sym_function_modifiers] = STATE(677),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1128),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(679),
    [sym_array_type] = STATE(1128),
    [sym_function_type] = STATE(1128),
    [sym_tuple_type] = STATE(1128),
    [sym_unit_type] = STATE(1128),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1128),
    [sym_reference_type] = STATE(1128),
    [sym_pointer_type] = STATE(1128),
    [sym_empty_type] = STATE(1128),
    [sym_dynamic_type] = STATE(1128),
    [sym_macro_invocation] = STATE(1128),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(680),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1315),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1317),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1319),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1321),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [573] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2220),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(467),
    [anon_sym_BANG_EQ] = ACTIONS(469),
    [anon_sym_STAR_EQ] = ACTIONS(467),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(467),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_AMP_EQ] = ACTIONS(467),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(467),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_CARET_EQ] = ACTIONS(467),
    [anon_sym_PLUS_EQ] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT_LT_EQ] = ACTIONS(467),
    [anon_sym_LT_EQ] = ACTIONS(469),
    [anon_sym_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_EQ] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_PIPE_EQ] = ACTIONS(467),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(489),
    [anon_sym_as] = ACTIONS(491),
    [sym_line_comment] = ACTIONS(7),
  },
  [574] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2222),
    [anon_sym_LPAREN] = ACTIONS(2222),
    [anon_sym_RPAREN] = ACTIONS(2222),
    [anon_sym_LBRACE] = ACTIONS(2222),
    [anon_sym_RBRACE] = ACTIONS(2222),
    [anon_sym_LBRACK] = ACTIONS(2222),
    [anon_sym_RBRACK] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(2224),
    [anon_sym_STAR] = ACTIONS(2224),
    [anon_sym_COMMA] = ACTIONS(2222),
    [anon_sym_AMP] = ACTIONS(2224),
    [anon_sym_DASH] = ACTIONS(2224),
    [anon_sym_DOT] = ACTIONS(2224),
    [anon_sym_DASH_EQ] = ACTIONS(2222),
    [anon_sym_BANG_EQ] = ACTIONS(2222),
    [anon_sym_STAR_EQ] = ACTIONS(2222),
    [anon_sym_SLASH] = ACTIONS(2224),
    [anon_sym_SLASH_EQ] = ACTIONS(2222),
    [anon_sym_AMP_AMP] = ACTIONS(2222),
    [anon_sym_AMP_EQ] = ACTIONS(2222),
    [anon_sym_PERCENT] = ACTIONS(2224),
    [anon_sym_PERCENT_EQ] = ACTIONS(2222),
    [anon_sym_CARET] = ACTIONS(2224),
    [anon_sym_CARET_EQ] = ACTIONS(2222),
    [anon_sym_PLUS_EQ] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(2224),
    [anon_sym_LT_LT] = ACTIONS(2224),
    [anon_sym_LT_LT_EQ] = ACTIONS(2222),
    [anon_sym_LT_EQ] = ACTIONS(2222),
    [anon_sym_EQ] = ACTIONS(2224),
    [anon_sym_EQ_EQ] = ACTIONS(2222),
    [anon_sym_GT] = ACTIONS(2224),
    [anon_sym_GT_EQ] = ACTIONS(2222),
    [anon_sym_GT_GT] = ACTIONS(2224),
    [anon_sym_GT_GT_EQ] = ACTIONS(2222),
    [anon_sym_PIPE] = ACTIONS(2224),
    [anon_sym_PIPE_EQ] = ACTIONS(2222),
    [anon_sym_PIPE_PIPE] = ACTIONS(2222),
    [anon_sym_QMARK] = ACTIONS(2222),
    [anon_sym_DOT_DOT] = ACTIONS(2224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2222),
    [anon_sym_as] = ACTIONS(2222),
    [anon_sym_const] = ACTIONS(2222),
    [anon_sym_default] = ACTIONS(2222),
    [anon_sym_fn] = ACTIONS(2222),
    [anon_sym_unsafe] = ACTIONS(2222),
    [anon_sym_extern] = ACTIONS(2222),
    [anon_sym_in] = ACTIONS(2222),
    [sym_line_comment] = ACTIONS(7),
  },
  [575] = {
    [aux_sym_string_literal_repeat1] = STATE(575),
    [sym_block_comment] = ACTIONS(7),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_RBRACK_PLUS_SLASH] = ACTIONS(2226),
    [anon_sym_DQUOTE] = ACTIONS(2229),
    [sym_escape_sequence] = ACTIONS(2226),
    [sym_line_comment] = ACTIONS(401),
  },
  [576] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2231),
    [anon_sym_LPAREN] = ACTIONS(2231),
    [anon_sym_RPAREN] = ACTIONS(2231),
    [anon_sym_LBRACE] = ACTIONS(2231),
    [anon_sym_RBRACE] = ACTIONS(2231),
    [anon_sym_LBRACK] = ACTIONS(2231),
    [anon_sym_RBRACK] = ACTIONS(2231),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_STAR] = ACTIONS(2233),
    [anon_sym_COMMA] = ACTIONS(2231),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_DASH] = ACTIONS(2233),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_DASH_EQ] = ACTIONS(2231),
    [anon_sym_BANG_EQ] = ACTIONS(2231),
    [anon_sym_STAR_EQ] = ACTIONS(2231),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_SLASH_EQ] = ACTIONS(2231),
    [anon_sym_AMP_AMP] = ACTIONS(2231),
    [anon_sym_AMP_EQ] = ACTIONS(2231),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_PERCENT_EQ] = ACTIONS(2231),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_CARET_EQ] = ACTIONS(2231),
    [anon_sym_PLUS_EQ] = ACTIONS(2231),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_LT_LT_EQ] = ACTIONS(2231),
    [anon_sym_LT_EQ] = ACTIONS(2231),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2231),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2231),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_GT_GT_EQ] = ACTIONS(2231),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_PIPE_EQ] = ACTIONS(2231),
    [anon_sym_PIPE_PIPE] = ACTIONS(2231),
    [anon_sym_QMARK] = ACTIONS(2231),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2231),
    [anon_sym_as] = ACTIONS(2231),
    [sym_line_comment] = ACTIONS(7),
  },
  [577] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [sym_line_comment] = ACTIONS(7),
  },
  [578] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACK] = ACTIONS(2237),
    [sym_line_comment] = ACTIONS(7),
  },
  [579] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1137),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1137),
    [sym_macro_invocation] = STATE(1137),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1137),
    [sym_unary_expression] = STATE(1137),
    [sym_try_expression] = STATE(1137),
    [sym_reference_expression] = STATE(1137),
    [sym_binary_expression] = STATE(1137),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1137),
    [sym_call_expression] = STATE(1137),
    [sym_array_expression] = STATE(1137),
    [sym_parenthesized_expression] = STATE(1137),
    [sym_tuple_expression] = STATE(1137),
    [sym_unit_expression] = STATE(1137),
    [sym_struct_expression] = STATE(1137),
    [sym_if_expression] = STATE(1137),
    [sym_if_let_expression] = STATE(1137),
    [sym_match_expression] = STATE(1137),
    [sym_while_expression] = STATE(1137),
    [sym_while_let_expression] = STATE(1137),
    [sym_loop_expression] = STATE(1137),
    [sym_for_expression] = STATE(1137),
    [sym_closure_expression] = STATE(1137),
    [sym_closure_parameters] = STATE(1138),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1137),
    [sym_continue_expression] = STATE(1137),
    [sym_index_expression] = STATE(1137),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1137),
    [sym_block] = STATE(1137),
    [sym__literal] = STATE(1137),
    [sym_string_literal] = STATE(1137),
    [sym_boolean_literal] = STATE(1137),
    [sym_raw_string_literal] = ACTIONS(2239),
    [sym_float_literal] = ACTIONS(2239),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(2245),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(2247),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(2249),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(2251),
    [sym_integer_literal] = ACTIONS(2239),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(2239),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [580] = {
    [aux_sym_field_initializer_list_repeat1] = STATE(1142),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(2253),
    [anon_sym_COLON] = ACTIONS(2255),
    [anon_sym_COMMA] = ACTIONS(2257),
    [sym_line_comment] = ACTIONS(7),
  },
  [581] = {
    [aux_sym_field_initializer_list_repeat1] = STATE(1144),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2259),
    [sym_line_comment] = ACTIONS(7),
  },
  [582] = {
    [sym_attribute_item] = STATE(1146),
    [aux_sym_enum_variant_list_repeat1] = STATE(1146),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(1133),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2261),
  },
  [583] = {
    [sym_function_modifiers] = STATE(854),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1147),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1148),
    [sym_array_type] = STATE(1147),
    [sym_function_type] = STATE(1147),
    [sym_tuple_type] = STATE(1147),
    [sym_unit_type] = STATE(1147),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1147),
    [sym_type_binding] = STATE(1149),
    [sym_reference_type] = STATE(1147),
    [sym_pointer_type] = STATE(1147),
    [sym_empty_type] = STATE(1147),
    [sym_dynamic_type] = STATE(1147),
    [sym_macro_invocation] = STATE(1147),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(858),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1786),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1788),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1790),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1792),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [584] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2263),
    [anon_sym_LPAREN] = ACTIONS(2263),
    [anon_sym_RPAREN] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(2265),
    [anon_sym_RBRACE] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2263),
    [anon_sym_RBRACK] = ACTIONS(2263),
    [anon_sym_PLUS] = ACTIONS(2267),
    [anon_sym_STAR] = ACTIONS(2267),
    [anon_sym_COMMA] = ACTIONS(2263),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_DASH] = ACTIONS(2267),
    [anon_sym_DOT] = ACTIONS(2267),
    [anon_sym_DASH_EQ] = ACTIONS(2263),
    [anon_sym_COLON_COLON] = ACTIONS(2263),
    [anon_sym_BANG_EQ] = ACTIONS(2263),
    [anon_sym_STAR_EQ] = ACTIONS(2263),
    [anon_sym_SLASH] = ACTIONS(2267),
    [anon_sym_SLASH_EQ] = ACTIONS(2263),
    [anon_sym_AMP_AMP] = ACTIONS(2263),
    [anon_sym_AMP_EQ] = ACTIONS(2263),
    [anon_sym_PERCENT] = ACTIONS(2267),
    [anon_sym_PERCENT_EQ] = ACTIONS(2263),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_CARET_EQ] = ACTIONS(2263),
    [anon_sym_PLUS_EQ] = ACTIONS(2263),
    [anon_sym_LT] = ACTIONS(2267),
    [anon_sym_LT_LT] = ACTIONS(2267),
    [anon_sym_LT_LT_EQ] = ACTIONS(2263),
    [anon_sym_LT_EQ] = ACTIONS(2263),
    [anon_sym_EQ] = ACTIONS(2267),
    [anon_sym_EQ_EQ] = ACTIONS(2263),
    [anon_sym_GT] = ACTIONS(2267),
    [anon_sym_GT_EQ] = ACTIONS(2263),
    [anon_sym_GT_GT] = ACTIONS(2267),
    [anon_sym_GT_GT_EQ] = ACTIONS(2263),
    [anon_sym_PIPE] = ACTIONS(2267),
    [anon_sym_PIPE_EQ] = ACTIONS(2263),
    [anon_sym_PIPE_PIPE] = ACTIONS(2263),
    [anon_sym_QMARK] = ACTIONS(2263),
    [anon_sym_DOT_DOT] = ACTIONS(2267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2263),
    [anon_sym_as] = ACTIONS(2263),
    [sym_line_comment] = ACTIONS(7),
  },
  [585] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2269),
    [anon_sym_LPAREN] = ACTIONS(2269),
    [anon_sym_RPAREN] = ACTIONS(2269),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_RBRACE] = ACTIONS(2269),
    [anon_sym_LBRACK] = ACTIONS(2269),
    [anon_sym_RBRACK] = ACTIONS(2269),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(2273),
    [anon_sym_COMMA] = ACTIONS(2269),
    [anon_sym_AMP] = ACTIONS(2273),
    [anon_sym_DASH] = ACTIONS(2273),
    [anon_sym_DOT] = ACTIONS(2273),
    [anon_sym_DASH_EQ] = ACTIONS(2269),
    [anon_sym_COLON_COLON] = ACTIONS(2271),
    [anon_sym_BANG_EQ] = ACTIONS(2269),
    [anon_sym_STAR_EQ] = ACTIONS(2269),
    [anon_sym_SLASH] = ACTIONS(2273),
    [anon_sym_SLASH_EQ] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2269),
    [anon_sym_AMP_EQ] = ACTIONS(2269),
    [anon_sym_PERCENT] = ACTIONS(2273),
    [anon_sym_PERCENT_EQ] = ACTIONS(2269),
    [anon_sym_CARET] = ACTIONS(2273),
    [anon_sym_CARET_EQ] = ACTIONS(2269),
    [anon_sym_PLUS_EQ] = ACTIONS(2269),
    [anon_sym_LT] = ACTIONS(2273),
    [anon_sym_LT_LT] = ACTIONS(2273),
    [anon_sym_LT_LT_EQ] = ACTIONS(2269),
    [anon_sym_LT_EQ] = ACTIONS(2269),
    [anon_sym_EQ] = ACTIONS(2273),
    [anon_sym_EQ_EQ] = ACTIONS(2269),
    [anon_sym_GT] = ACTIONS(2273),
    [anon_sym_GT_EQ] = ACTIONS(2269),
    [anon_sym_GT_GT] = ACTIONS(2273),
    [anon_sym_GT_GT_EQ] = ACTIONS(2269),
    [anon_sym_PIPE] = ACTIONS(2273),
    [anon_sym_PIPE_EQ] = ACTIONS(2269),
    [anon_sym_PIPE_PIPE] = ACTIONS(2269),
    [anon_sym_QMARK] = ACTIONS(2269),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2269),
    [anon_sym_as] = ACTIONS(2269),
    [sym_line_comment] = ACTIONS(7),
  },
  [586] = {
    [sym_token_tree] = STATE(1179),
    [sym_token_repetition] = STATE(1179),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1177),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1177),
    [sym_macro_invocation] = STATE(1177),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1177),
    [sym_unary_expression] = STATE(1177),
    [sym_try_expression] = STATE(1177),
    [sym_reference_expression] = STATE(1177),
    [sym_binary_expression] = STATE(1177),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_array_expression] = STATE(1177),
    [sym_parenthesized_expression] = STATE(1177),
    [sym_tuple_expression] = STATE(1177),
    [sym_unit_expression] = STATE(1177),
    [sym_struct_expression] = STATE(1177),
    [sym_if_expression] = STATE(1177),
    [sym_if_let_expression] = STATE(1177),
    [sym_match_expression] = STATE(1177),
    [sym_while_expression] = STATE(1177),
    [sym_while_let_expression] = STATE(1177),
    [sym_loop_expression] = STATE(1177),
    [sym_for_expression] = STATE(1177),
    [sym_closure_expression] = STATE(1177),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1177),
    [sym_continue_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1177),
    [sym_block] = STATE(1177),
    [sym__literal] = STATE(1178),
    [sym_string_literal] = STATE(1178),
    [sym_boolean_literal] = STATE(1178),
    [aux_sym_token_tree_repeat1] = STATE(1179),
    [sym_raw_string_literal] = ACTIONS(2275),
    [sym_float_literal] = ACTIONS(2275),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2277),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_RPAREN] = ACTIONS(2281),
    [anon_sym_LBRACE] = ACTIONS(2283),
    [anon_sym_EQ_GT] = ACTIONS(2277),
    [anon_sym_LBRACK] = ACTIONS(2285),
    [anon_sym_COLON] = ACTIONS(2287),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2287),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(2277),
    [anon_sym_u8] = ACTIONS(2293),
    [anon_sym_i8] = ACTIONS(2293),
    [anon_sym_u16] = ACTIONS(2293),
    [anon_sym_i16] = ACTIONS(2293),
    [anon_sym_u32] = ACTIONS(2293),
    [anon_sym_i32] = ACTIONS(2293),
    [anon_sym_u64] = ACTIONS(2293),
    [anon_sym_i64] = ACTIONS(2293),
    [anon_sym_u128] = ACTIONS(2293),
    [anon_sym_i128] = ACTIONS(2293),
    [anon_sym_isize] = ACTIONS(2293),
    [anon_sym_usize] = ACTIONS(2293),
    [anon_sym_f32] = ACTIONS(2293),
    [anon_sym_f64] = ACTIONS(2293),
    [anon_sym_bool] = ACTIONS(2293),
    [anon_sym_str] = ACTIONS(2293),
    [anon_sym_char] = ACTIONS(2293),
    [anon_sym__] = ACTIONS(2287),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_DASH] = ACTIONS(2291),
    [anon_sym_DOT] = ACTIONS(2287),
    [anon_sym_DASH_EQ] = ACTIONS(2277),
    [anon_sym_DASH_GT] = ACTIONS(2277),
    [anon_sym_COLON_COLON] = ACTIONS(2277),
    [anon_sym_BANG] = ACTIONS(2297),
    [anon_sym_BANG_EQ] = ACTIONS(2277),
    [anon_sym_AT] = ACTIONS(2277),
    [anon_sym_STAR_EQ] = ACTIONS(2277),
    [anon_sym_SLASH] = ACTIONS(2287),
    [anon_sym_SLASH_EQ] = ACTIONS(2277),
    [anon_sym_AMP_AMP] = ACTIONS(2277),
    [anon_sym_AMP_EQ] = ACTIONS(2277),
    [anon_sym_POUND] = ACTIONS(2277),
    [anon_sym_PERCENT] = ACTIONS(2287),
    [anon_sym_PERCENT_EQ] = ACTIONS(2277),
    [anon_sym_CARET] = ACTIONS(2287),
    [anon_sym_CARET_EQ] = ACTIONS(2277),
    [anon_sym_PLUS_EQ] = ACTIONS(2277),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_LT_LT] = ACTIONS(2287),
    [anon_sym_LT_LT_EQ] = ACTIONS(2277),
    [anon_sym_LT_EQ] = ACTIONS(2277),
    [anon_sym_EQ] = ACTIONS(2287),
    [anon_sym_EQ_EQ] = ACTIONS(2277),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_GT_EQ] = ACTIONS(2277),
    [anon_sym_GT_GT] = ACTIONS(2287),
    [anon_sym_GT_GT_EQ] = ACTIONS(2277),
    [anon_sym_PIPE] = ACTIONS(2301),
    [anon_sym_PIPE_EQ] = ACTIONS(2277),
    [anon_sym_PIPE_PIPE] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [anon_sym_QMARK] = ACTIONS(2277),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(2305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2277),
    [anon_sym_as] = ACTIONS(2287),
    [anon_sym_break] = ACTIONS(2307),
    [anon_sym_const] = ACTIONS(2287),
    [anon_sym_continue] = ACTIONS(2309),
    [anon_sym_default] = ACTIONS(2311),
    [anon_sym_enum] = ACTIONS(2287),
    [anon_sym_fn] = ACTIONS(2287),
    [anon_sym_for] = ACTIONS(2313),
    [anon_sym_if] = ACTIONS(2315),
    [anon_sym_impl] = ACTIONS(2287),
    [anon_sym_let] = ACTIONS(2287),
    [anon_sym_loop] = ACTIONS(2317),
    [anon_sym_match] = ACTIONS(2319),
    [anon_sym_mod] = ACTIONS(2287),
    [anon_sym_pub] = ACTIONS(2287),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_static] = ACTIONS(2287),
    [anon_sym_struct] = ACTIONS(2287),
    [anon_sym_trait] = ACTIONS(2287),
    [anon_sym_type] = ACTIONS(2287),
    [anon_sym_union] = ACTIONS(2311),
    [anon_sym_unsafe] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(2287),
    [anon_sym_where] = ACTIONS(2287),
    [anon_sym_while] = ACTIONS(2325),
    [sym_mutable_specifier] = ACTIONS(2287),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(2275),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(2275),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2331),
    [sym_self] = ACTIONS(2333),
    [sym_super] = ACTIONS(2287),
    [sym_crate] = ACTIONS(2287),
    [sym_metavariable] = ACTIONS(2335),
  },
  [587] = {
    [sym__statement] = STATE(1217),
    [sym_empty_statement] = STATE(1217),
    [sym__expression_statement] = STATE(1217),
    [sym_macro_definition] = STATE(1217),
    [sym_token_tree] = STATE(1218),
    [sym_token_repetition] = STATE(1218),
    [sym_attribute_item] = STATE(1217),
    [sym_inner_attribute_item] = STATE(1217),
    [sym_mod_item] = STATE(1217),
    [sym_foreign_mod_item] = STATE(1217),
    [sym_struct_item] = STATE(1217),
    [sym_union_item] = STATE(1217),
    [sym_enum_item] = STATE(1217),
    [sym_extern_crate_declaration] = STATE(1217),
    [sym_const_item] = STATE(1217),
    [sym_static_item] = STATE(1217),
    [sym_type_item] = STATE(1217),
    [sym_function_item] = STATE(1217),
    [sym_function_signature_item] = STATE(1217),
    [sym_function_modifiers] = STATE(47),
    [sym_impl_item] = STATE(1217),
    [sym_trait_item] = STATE(1217),
    [sym_associated_type] = STATE(1217),
    [sym_let_declaration] = STATE(1217),
    [sym_use_declaration] = STATE(1217),
    [sym_extern_modifier] = STATE(48),
    [sym_visibility_modifier] = STATE(49),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1215),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1215),
    [sym_macro_invocation] = STATE(53),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1215),
    [sym_unary_expression] = STATE(1215),
    [sym_try_expression] = STATE(1215),
    [sym_reference_expression] = STATE(1215),
    [sym_binary_expression] = STATE(1215),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1215),
    [sym_call_expression] = STATE(1215),
    [sym_array_expression] = STATE(1215),
    [sym_parenthesized_expression] = STATE(1215),
    [sym_tuple_expression] = STATE(1215),
    [sym_unit_expression] = STATE(1215),
    [sym_struct_expression] = STATE(1215),
    [sym_if_expression] = STATE(57),
    [sym_if_let_expression] = STATE(57),
    [sym_match_expression] = STATE(57),
    [sym_while_expression] = STATE(57),
    [sym_while_let_expression] = STATE(57),
    [sym_loop_expression] = STATE(57),
    [sym_for_expression] = STATE(57),
    [sym_closure_expression] = STATE(1215),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(59),
    [sym_break_expression] = STATE(1215),
    [sym_continue_expression] = STATE(1215),
    [sym_index_expression] = STATE(1215),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(57),
    [sym_block] = STATE(57),
    [sym__literal] = STATE(1216),
    [sym_string_literal] = STATE(1216),
    [sym_boolean_literal] = STATE(1216),
    [aux_sym_source_file_repeat1] = STATE(1217),
    [aux_sym_token_tree_repeat1] = STATE(1218),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_raw_string_literal] = ACTIONS(2337),
    [sym_float_literal] = ACTIONS(2337),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(2341),
    [anon_sym_LBRACE] = ACTIONS(2343),
    [anon_sym_RBRACE] = ACTIONS(2281),
    [anon_sym_EQ_GT] = ACTIONS(2345),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [anon_sym_COLON] = ACTIONS(2349),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2349),
    [anon_sym_STAR] = ACTIONS(2351),
    [anon_sym_COMMA] = ACTIONS(2345),
    [anon_sym_u8] = ACTIONS(2353),
    [anon_sym_i8] = ACTIONS(2353),
    [anon_sym_u16] = ACTIONS(2353),
    [anon_sym_i16] = ACTIONS(2353),
    [anon_sym_u32] = ACTIONS(2353),
    [anon_sym_i32] = ACTIONS(2353),
    [anon_sym_u64] = ACTIONS(2353),
    [anon_sym_i64] = ACTIONS(2353),
    [anon_sym_u128] = ACTIONS(2353),
    [anon_sym_i128] = ACTIONS(2353),
    [anon_sym_isize] = ACTIONS(2353),
    [anon_sym_usize] = ACTIONS(2353),
    [anon_sym_f32] = ACTIONS(2353),
    [anon_sym_f64] = ACTIONS(2353),
    [anon_sym_bool] = ACTIONS(2353),
    [anon_sym_str] = ACTIONS(2353),
    [anon_sym_char] = ACTIONS(2353),
    [anon_sym__] = ACTIONS(2349),
    [anon_sym_AMP] = ACTIONS(2355),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_DOT] = ACTIONS(2349),
    [anon_sym_DASH_EQ] = ACTIONS(2345),
    [anon_sym_DASH_GT] = ACTIONS(2345),
    [anon_sym_COLON_COLON] = ACTIONS(2345),
    [anon_sym_BANG] = ACTIONS(2357),
    [anon_sym_BANG_EQ] = ACTIONS(2345),
    [anon_sym_AT] = ACTIONS(2345),
    [anon_sym_STAR_EQ] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2349),
    [anon_sym_SLASH_EQ] = ACTIONS(2345),
    [anon_sym_AMP_AMP] = ACTIONS(2345),
    [anon_sym_AMP_EQ] = ACTIONS(2345),
    [anon_sym_POUND] = ACTIONS(2359),
    [anon_sym_PERCENT] = ACTIONS(2349),
    [anon_sym_PERCENT_EQ] = ACTIONS(2345),
    [anon_sym_CARET] = ACTIONS(2349),
    [anon_sym_CARET_EQ] = ACTIONS(2345),
    [anon_sym_PLUS_EQ] = ACTIONS(2345),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_LT_LT] = ACTIONS(2349),
    [anon_sym_LT_LT_EQ] = ACTIONS(2345),
    [anon_sym_LT_EQ] = ACTIONS(2345),
    [anon_sym_EQ] = ACTIONS(2349),
    [anon_sym_EQ_EQ] = ACTIONS(2345),
    [anon_sym_GT] = ACTIONS(2349),
    [anon_sym_GT_EQ] = ACTIONS(2345),
    [anon_sym_GT_GT] = ACTIONS(2349),
    [anon_sym_GT_GT_EQ] = ACTIONS(2345),
    [anon_sym_PIPE] = ACTIONS(2301),
    [anon_sym_PIPE_EQ] = ACTIONS(2345),
    [anon_sym_PIPE_PIPE] = ACTIONS(2345),
    [anon_sym_TILDE] = ACTIONS(2345),
    [anon_sym_QMARK] = ACTIONS(2345),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(2361),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2345),
    [anon_sym_as] = ACTIONS(2349),
    [anon_sym_break] = ACTIONS(2363),
    [anon_sym_const] = ACTIONS(2365),
    [anon_sym_continue] = ACTIONS(2367),
    [anon_sym_default] = ACTIONS(2369),
    [anon_sym_enum] = ACTIONS(2371),
    [anon_sym_fn] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2375),
    [anon_sym_if] = ACTIONS(2377),
    [anon_sym_impl] = ACTIONS(2379),
    [anon_sym_let] = ACTIONS(2381),
    [anon_sym_loop] = ACTIONS(2383),
    [anon_sym_match] = ACTIONS(2385),
    [anon_sym_mod] = ACTIONS(2387),
    [anon_sym_pub] = ACTIONS(2389),
    [anon_sym_return] = ACTIONS(2391),
    [anon_sym_static] = ACTIONS(2393),
    [anon_sym_struct] = ACTIONS(2395),
    [anon_sym_trait] = ACTIONS(2397),
    [anon_sym_type] = ACTIONS(2399),
    [anon_sym_union] = ACTIONS(2401),
    [anon_sym_unsafe] = ACTIONS(2403),
    [anon_sym_use] = ACTIONS(2405),
    [anon_sym_where] = ACTIONS(2349),
    [anon_sym_while] = ACTIONS(2407),
    [anon_sym_extern] = ACTIONS(85),
    [sym_mutable_specifier] = ACTIONS(2349),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(2337),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(2337),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2409),
    [sym_self] = ACTIONS(2411),
    [sym_super] = ACTIONS(2349),
    [sym_crate] = ACTIONS(2349),
    [sym_metavariable] = ACTIONS(2413),
  },
  [588] = {
    [sym_token_tree] = STATE(1226),
    [sym_token_repetition] = STATE(1226),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1225),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1225),
    [sym_macro_invocation] = STATE(1225),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1225),
    [sym_unary_expression] = STATE(1225),
    [sym_try_expression] = STATE(1225),
    [sym_reference_expression] = STATE(1225),
    [sym_binary_expression] = STATE(1225),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1225),
    [sym_call_expression] = STATE(1225),
    [sym_array_expression] = STATE(1225),
    [sym_parenthesized_expression] = STATE(1225),
    [sym_tuple_expression] = STATE(1225),
    [sym_unit_expression] = STATE(1225),
    [sym_struct_expression] = STATE(1225),
    [sym_if_expression] = STATE(1225),
    [sym_if_let_expression] = STATE(1225),
    [sym_match_expression] = STATE(1225),
    [sym_while_expression] = STATE(1225),
    [sym_while_let_expression] = STATE(1225),
    [sym_loop_expression] = STATE(1225),
    [sym_for_expression] = STATE(1225),
    [sym_closure_expression] = STATE(1225),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1225),
    [sym_continue_expression] = STATE(1225),
    [sym_index_expression] = STATE(1225),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1225),
    [sym_block] = STATE(1225),
    [sym__literal] = STATE(1178),
    [sym_string_literal] = STATE(1178),
    [sym_boolean_literal] = STATE(1178),
    [aux_sym_token_tree_repeat1] = STATE(1226),
    [sym_raw_string_literal] = ACTIONS(2275),
    [sym_float_literal] = ACTIONS(2275),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2415),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_LBRACE] = ACTIONS(2283),
    [anon_sym_EQ_GT] = ACTIONS(2415),
    [anon_sym_LBRACK] = ACTIONS(2285),
    [anon_sym_RBRACK] = ACTIONS(2281),
    [anon_sym_COLON] = ACTIONS(2417),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2417),
    [anon_sym_STAR] = ACTIONS(2419),
    [anon_sym_COMMA] = ACTIONS(2415),
    [anon_sym_u8] = ACTIONS(2293),
    [anon_sym_i8] = ACTIONS(2293),
    [anon_sym_u16] = ACTIONS(2293),
    [anon_sym_i16] = ACTIONS(2293),
    [anon_sym_u32] = ACTIONS(2293),
    [anon_sym_i32] = ACTIONS(2293),
    [anon_sym_u64] = ACTIONS(2293),
    [anon_sym_i64] = ACTIONS(2293),
    [anon_sym_u128] = ACTIONS(2293),
    [anon_sym_i128] = ACTIONS(2293),
    [anon_sym_isize] = ACTIONS(2293),
    [anon_sym_usize] = ACTIONS(2293),
    [anon_sym_f32] = ACTIONS(2293),
    [anon_sym_f64] = ACTIONS(2293),
    [anon_sym_bool] = ACTIONS(2293),
    [anon_sym_str] = ACTIONS(2293),
    [anon_sym_char] = ACTIONS(2293),
    [anon_sym__] = ACTIONS(2417),
    [anon_sym_AMP] = ACTIONS(2421),
    [anon_sym_DASH] = ACTIONS(2419),
    [anon_sym_DOT] = ACTIONS(2417),
    [anon_sym_DASH_EQ] = ACTIONS(2415),
    [anon_sym_DASH_GT] = ACTIONS(2415),
    [anon_sym_COLON_COLON] = ACTIONS(2415),
    [anon_sym_BANG] = ACTIONS(2423),
    [anon_sym_BANG_EQ] = ACTIONS(2415),
    [anon_sym_AT] = ACTIONS(2415),
    [anon_sym_STAR_EQ] = ACTIONS(2415),
    [anon_sym_SLASH] = ACTIONS(2417),
    [anon_sym_SLASH_EQ] = ACTIONS(2415),
    [anon_sym_AMP_AMP] = ACTIONS(2415),
    [anon_sym_AMP_EQ] = ACTIONS(2415),
    [anon_sym_POUND] = ACTIONS(2415),
    [anon_sym_PERCENT] = ACTIONS(2417),
    [anon_sym_PERCENT_EQ] = ACTIONS(2415),
    [anon_sym_CARET] = ACTIONS(2417),
    [anon_sym_CARET_EQ] = ACTIONS(2415),
    [anon_sym_PLUS_EQ] = ACTIONS(2415),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_LT_LT] = ACTIONS(2417),
    [anon_sym_LT_LT_EQ] = ACTIONS(2415),
    [anon_sym_LT_EQ] = ACTIONS(2415),
    [anon_sym_EQ] = ACTIONS(2417),
    [anon_sym_EQ_EQ] = ACTIONS(2415),
    [anon_sym_GT] = ACTIONS(2417),
    [anon_sym_GT_EQ] = ACTIONS(2415),
    [anon_sym_GT_GT] = ACTIONS(2417),
    [anon_sym_GT_GT_EQ] = ACTIONS(2415),
    [anon_sym_PIPE] = ACTIONS(2301),
    [anon_sym_PIPE_EQ] = ACTIONS(2415),
    [anon_sym_PIPE_PIPE] = ACTIONS(2415),
    [anon_sym_TILDE] = ACTIONS(2415),
    [anon_sym_QMARK] = ACTIONS(2415),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(2425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2415),
    [anon_sym_as] = ACTIONS(2417),
    [anon_sym_break] = ACTIONS(2307),
    [anon_sym_const] = ACTIONS(2417),
    [anon_sym_continue] = ACTIONS(2309),
    [anon_sym_default] = ACTIONS(2311),
    [anon_sym_enum] = ACTIONS(2417),
    [anon_sym_fn] = ACTIONS(2417),
    [anon_sym_for] = ACTIONS(2313),
    [anon_sym_if] = ACTIONS(2427),
    [anon_sym_impl] = ACTIONS(2417),
    [anon_sym_let] = ACTIONS(2417),
    [anon_sym_loop] = ACTIONS(2317),
    [anon_sym_match] = ACTIONS(2319),
    [anon_sym_mod] = ACTIONS(2417),
    [anon_sym_pub] = ACTIONS(2417),
    [anon_sym_return] = ACTIONS(2429),
    [anon_sym_static] = ACTIONS(2417),
    [anon_sym_struct] = ACTIONS(2417),
    [anon_sym_trait] = ACTIONS(2417),
    [anon_sym_type] = ACTIONS(2417),
    [anon_sym_union] = ACTIONS(2311),
    [anon_sym_unsafe] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(2417),
    [anon_sym_where] = ACTIONS(2417),
    [anon_sym_while] = ACTIONS(2325),
    [sym_mutable_specifier] = ACTIONS(2417),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(2275),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(2275),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2331),
    [sym_self] = ACTIONS(2333),
    [sym_super] = ACTIONS(2417),
    [sym_crate] = ACTIONS(2417),
    [sym_metavariable] = ACTIONS(2335),
  },
  [589] = {
    [sym_raw_string_literal] = ACTIONS(2431),
    [sym_float_literal] = ACTIONS(2431),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(2431),
    [anon_sym_SEMI] = ACTIONS(2431),
    [anon_sym_macro_rules_BANG] = ACTIONS(2431),
    [anon_sym_LPAREN] = ACTIONS(2431),
    [anon_sym_LBRACE] = ACTIONS(2431),
    [anon_sym_RBRACE] = ACTIONS(2431),
    [anon_sym_LBRACK] = ACTIONS(2431),
    [anon_sym_PLUS] = ACTIONS(2433),
    [anon_sym_STAR] = ACTIONS(2433),
    [anon_sym_u8] = ACTIONS(2433),
    [anon_sym_i8] = ACTIONS(2433),
    [anon_sym_u16] = ACTIONS(2433),
    [anon_sym_i16] = ACTIONS(2433),
    [anon_sym_u32] = ACTIONS(2433),
    [anon_sym_i32] = ACTIONS(2433),
    [anon_sym_u64] = ACTIONS(2433),
    [anon_sym_i64] = ACTIONS(2433),
    [anon_sym_u128] = ACTIONS(2433),
    [anon_sym_i128] = ACTIONS(2433),
    [anon_sym_isize] = ACTIONS(2433),
    [anon_sym_usize] = ACTIONS(2433),
    [anon_sym_f32] = ACTIONS(2433),
    [anon_sym_f64] = ACTIONS(2433),
    [anon_sym_bool] = ACTIONS(2433),
    [anon_sym_str] = ACTIONS(2433),
    [anon_sym_char] = ACTIONS(2433),
    [anon_sym_AMP] = ACTIONS(2433),
    [anon_sym_DASH] = ACTIONS(2433),
    [anon_sym_DOT] = ACTIONS(2433),
    [anon_sym_DASH_EQ] = ACTIONS(2431),
    [anon_sym_COLON_COLON] = ACTIONS(2431),
    [anon_sym_BANG] = ACTIONS(2433),
    [anon_sym_BANG_EQ] = ACTIONS(2431),
    [anon_sym_STAR_EQ] = ACTIONS(2431),
    [anon_sym_SLASH] = ACTIONS(2433),
    [anon_sym_SLASH_EQ] = ACTIONS(2431),
    [anon_sym_AMP_AMP] = ACTIONS(2431),
    [anon_sym_AMP_EQ] = ACTIONS(2431),
    [anon_sym_POUND] = ACTIONS(2431),
    [anon_sym_PERCENT] = ACTIONS(2433),
    [anon_sym_PERCENT_EQ] = ACTIONS(2431),
    [anon_sym_CARET] = ACTIONS(2433),
    [anon_sym_CARET_EQ] = ACTIONS(2431),
    [anon_sym_PLUS_EQ] = ACTIONS(2431),
    [anon_sym_LT] = ACTIONS(2433),
    [anon_sym_LT_LT] = ACTIONS(2433),
    [anon_sym_LT_LT_EQ] = ACTIONS(2431),
    [anon_sym_LT_EQ] = ACTIONS(2431),
    [anon_sym_EQ] = ACTIONS(2433),
    [anon_sym_EQ_EQ] = ACTIONS(2431),
    [anon_sym_GT] = ACTIONS(2433),
    [anon_sym_GT_EQ] = ACTIONS(2431),
    [anon_sym_GT_GT] = ACTIONS(2433),
    [anon_sym_GT_GT_EQ] = ACTIONS(2431),
    [anon_sym_PIPE] = ACTIONS(2433),
    [anon_sym_PIPE_EQ] = ACTIONS(2431),
    [anon_sym_PIPE_PIPE] = ACTIONS(2431),
    [anon_sym_QMARK] = ACTIONS(2431),
    [anon_sym_SQUOTE] = ACTIONS(2433),
    [anon_sym_DOT_DOT] = ACTIONS(2433),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2431),
    [anon_sym_as] = ACTIONS(2433),
    [anon_sym_break] = ACTIONS(2433),
    [anon_sym_const] = ACTIONS(2433),
    [anon_sym_continue] = ACTIONS(2433),
    [anon_sym_default] = ACTIONS(2433),
    [anon_sym_enum] = ACTIONS(2433),
    [anon_sym_fn] = ACTIONS(2433),
    [anon_sym_for] = ACTIONS(2433),
    [anon_sym_if] = ACTIONS(2433),
    [anon_sym_impl] = ACTIONS(2433),
    [anon_sym_let] = ACTIONS(2433),
    [anon_sym_loop] = ACTIONS(2433),
    [anon_sym_match] = ACTIONS(2433),
    [anon_sym_mod] = ACTIONS(2433),
    [anon_sym_pub] = ACTIONS(2433),
    [anon_sym_return] = ACTIONS(2433),
    [anon_sym_static] = ACTIONS(2433),
    [anon_sym_struct] = ACTIONS(2433),
    [anon_sym_trait] = ACTIONS(2433),
    [anon_sym_type] = ACTIONS(2433),
    [anon_sym_union] = ACTIONS(2433),
    [anon_sym_unsafe] = ACTIONS(2433),
    [anon_sym_use] = ACTIONS(2433),
    [anon_sym_while] = ACTIONS(2433),
    [anon_sym_extern] = ACTIONS(2433),
    [anon_sym_move] = ACTIONS(2433),
    [sym_integer_literal] = ACTIONS(2431),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2431),
    [sym_char_literal] = ACTIONS(2431),
    [anon_sym_true] = ACTIONS(2433),
    [anon_sym_false] = ACTIONS(2433),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2433),
    [sym_self] = ACTIONS(2433),
    [sym_super] = ACTIONS(2433),
    [sym_crate] = ACTIONS(2433),
    [sym_metavariable] = ACTIONS(2431),
  },
  [590] = {
    [sym_type_parameters] = STATE(1227),
    [sym_parameters] = STATE(950),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(925),
    [sym_line_comment] = ACTIONS(7),
  },
  [591] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(101),
    [anon_sym_macro_rules_BANG] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(101),
    [anon_sym_POUND] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(103),
    [anon_sym_enum] = ACTIONS(103),
    [anon_sym_fn] = ACTIONS(103),
    [anon_sym_impl] = ACTIONS(103),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_mod] = ACTIONS(103),
    [anon_sym_pub] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(103),
    [anon_sym_struct] = ACTIONS(103),
    [anon_sym_trait] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_union] = ACTIONS(103),
    [anon_sym_unsafe] = ACTIONS(103),
    [anon_sym_use] = ACTIONS(103),
    [anon_sym_extern] = ACTIONS(103),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(103),
  },
  [592] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2435),
  },
  [593] = {
    [sym_raw_string_literal] = ACTIONS(2437),
    [sym_float_literal] = ACTIONS(2437),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(2437),
    [anon_sym_SEMI] = ACTIONS(2437),
    [anon_sym_macro_rules_BANG] = ACTIONS(2437),
    [anon_sym_LPAREN] = ACTIONS(2437),
    [anon_sym_LBRACE] = ACTIONS(2437),
    [anon_sym_RBRACE] = ACTIONS(2437),
    [anon_sym_LBRACK] = ACTIONS(2437),
    [anon_sym_STAR] = ACTIONS(2437),
    [anon_sym_u8] = ACTIONS(2439),
    [anon_sym_i8] = ACTIONS(2439),
    [anon_sym_u16] = ACTIONS(2439),
    [anon_sym_i16] = ACTIONS(2439),
    [anon_sym_u32] = ACTIONS(2439),
    [anon_sym_i32] = ACTIONS(2439),
    [anon_sym_u64] = ACTIONS(2439),
    [anon_sym_i64] = ACTIONS(2439),
    [anon_sym_u128] = ACTIONS(2439),
    [anon_sym_i128] = ACTIONS(2439),
    [anon_sym_isize] = ACTIONS(2439),
    [anon_sym_usize] = ACTIONS(2439),
    [anon_sym_f32] = ACTIONS(2439),
    [anon_sym_f64] = ACTIONS(2439),
    [anon_sym_bool] = ACTIONS(2439),
    [anon_sym_str] = ACTIONS(2439),
    [anon_sym_char] = ACTIONS(2439),
    [anon_sym_AMP] = ACTIONS(2437),
    [anon_sym_DASH] = ACTIONS(2437),
    [anon_sym_COLON_COLON] = ACTIONS(2437),
    [anon_sym_BANG] = ACTIONS(2437),
    [anon_sym_POUND] = ACTIONS(2437),
    [anon_sym_LT] = ACTIONS(2437),
    [anon_sym_PIPE] = ACTIONS(2437),
    [anon_sym_SQUOTE] = ACTIONS(2439),
    [anon_sym_DOT_DOT] = ACTIONS(2437),
    [anon_sym_break] = ACTIONS(2439),
    [anon_sym_const] = ACTIONS(2439),
    [anon_sym_continue] = ACTIONS(2439),
    [anon_sym_default] = ACTIONS(2439),
    [anon_sym_enum] = ACTIONS(2439),
    [anon_sym_fn] = ACTIONS(2439),
    [anon_sym_for] = ACTIONS(2439),
    [anon_sym_if] = ACTIONS(2439),
    [anon_sym_impl] = ACTIONS(2439),
    [anon_sym_let] = ACTIONS(2439),
    [anon_sym_loop] = ACTIONS(2439),
    [anon_sym_match] = ACTIONS(2439),
    [anon_sym_mod] = ACTIONS(2439),
    [anon_sym_pub] = ACTIONS(2439),
    [anon_sym_return] = ACTIONS(2439),
    [anon_sym_static] = ACTIONS(2439),
    [anon_sym_struct] = ACTIONS(2439),
    [anon_sym_trait] = ACTIONS(2439),
    [anon_sym_type] = ACTIONS(2439),
    [anon_sym_union] = ACTIONS(2439),
    [anon_sym_unsafe] = ACTIONS(2439),
    [anon_sym_use] = ACTIONS(2439),
    [anon_sym_while] = ACTIONS(2439),
    [anon_sym_extern] = ACTIONS(2439),
    [anon_sym_move] = ACTIONS(2439),
    [sym_integer_literal] = ACTIONS(2437),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2437),
    [sym_char_literal] = ACTIONS(2437),
    [anon_sym_true] = ACTIONS(2439),
    [anon_sym_false] = ACTIONS(2439),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2439),
    [sym_self] = ACTIONS(2439),
    [sym_super] = ACTIONS(2439),
    [sym_crate] = ACTIONS(2439),
    [sym_metavariable] = ACTIONS(2437),
  },
  [594] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACK] = ACTIONS(2441),
    [anon_sym_BANG] = ACTIONS(2443),
    [sym_line_comment] = ACTIONS(7),
  },
  [595] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(273),
    [anon_sym_default] = ACTIONS(273),
    [anon_sym_fn] = ACTIONS(273),
    [anon_sym_unsafe] = ACTIONS(273),
    [anon_sym_extern] = ACTIONS(273),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2445),
  },
  [596] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2447),
  },
  [597] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2449),
    [sym_metavariable] = ACTIONS(2449),
  },
  [598] = {
    [sym_type_parameters] = STATE(1235),
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1236),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(331),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2451),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [599] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(1238),
    [sym_tuple_pattern] = STATE(1238),
    [sym_tuple_struct_pattern] = STATE(1238),
    [sym_struct_pattern] = STATE(1238),
    [sym_remaining_field_pattern] = STATE(1238),
    [sym_mut_pattern] = STATE(1238),
    [sym_ref_pattern] = STATE(1238),
    [sym_captured_pattern] = STATE(1238),
    [sym_reference_pattern] = STATE(1238),
    [sym__literal] = STATE(1238),
    [sym_string_literal] = STATE(1238),
    [sym_boolean_literal] = STATE(1238),
    [sym_raw_string_literal] = ACTIONS(2453),
    [sym_float_literal] = ACTIONS(2453),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(341),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(2457),
    [anon_sym_ref] = ACTIONS(345),
    [sym_integer_literal] = ACTIONS(2453),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(2453),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(347),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [600] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2459),
  },
  [601] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_mutable_specifier] = ACTIONS(2461),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2463),
  },
  [602] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2465),
  },
  [603] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2467),
  },
  [604] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2469),
  },
  [605] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2471),
  },
  [606] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_default] = ACTIONS(281),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_impl] = ACTIONS(2473),
    [anon_sym_unsafe] = ACTIONS(281),
    [anon_sym_extern] = ACTIONS(281),
    [sym_line_comment] = ACTIONS(7),
  },
  [607] = {
    [sym__use_clause] = STATE(1247),
    [sym_scoped_use_list] = STATE(1247),
    [sym_use_list] = STATE(1247),
    [sym_use_as_clause] = STATE(1247),
    [sym_use_wildcard] = STATE(1247),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_type_with_turbofish] = STATE(212),
    [sym_scoped_identifier] = STATE(213),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(377),
    [anon_sym_u8] = ACTIONS(379),
    [anon_sym_i8] = ACTIONS(379),
    [anon_sym_u16] = ACTIONS(379),
    [anon_sym_i16] = ACTIONS(379),
    [anon_sym_u32] = ACTIONS(379),
    [anon_sym_i32] = ACTIONS(379),
    [anon_sym_u64] = ACTIONS(379),
    [anon_sym_i64] = ACTIONS(379),
    [anon_sym_u128] = ACTIONS(379),
    [anon_sym_i128] = ACTIONS(379),
    [anon_sym_isize] = ACTIONS(379),
    [anon_sym_usize] = ACTIONS(379),
    [anon_sym_f32] = ACTIONS(379),
    [anon_sym_f64] = ACTIONS(379),
    [anon_sym_bool] = ACTIONS(379),
    [anon_sym_str] = ACTIONS(379),
    [anon_sym_char] = ACTIONS(379),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_LT] = ACTIONS(31),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(383),
    [sym_self] = ACTIONS(385),
    [sym_super] = ACTIONS(385),
    [sym_crate] = ACTIONS(385),
    [sym_metavariable] = ACTIONS(387),
  },
  [608] = {
    [sym_string_literal] = STATE(217),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_const] = ACTIONS(393),
    [anon_sym_default] = ACTIONS(393),
    [anon_sym_fn] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(393),
    [anon_sym_extern] = ACTIONS(393),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(7),
    [sym_crate] = ACTIONS(2475),
  },
  [609] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(2477),
    [sym_line_comment] = ACTIONS(7),
  },
  [610] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_fn] = ACTIONS(2479),
    [sym_line_comment] = ACTIONS(7),
  },
  [611] = {
    [sym_declaration_list] = STATE(1250),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2481),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_default] = ACTIONS(281),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_unsafe] = ACTIONS(281),
    [anon_sym_extern] = ACTIONS(281),
    [sym_line_comment] = ACTIONS(7),
  },
  [612] = {
    [sym_function_modifiers] = STATE(1262),
    [sym_extern_modifier] = STATE(1263),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(2485),
    [anon_sym_default] = ACTIONS(429),
    [anon_sym_enum] = ACTIONS(2487),
    [anon_sym_fn] = ACTIONS(2479),
    [anon_sym_mod] = ACTIONS(2489),
    [anon_sym_static] = ACTIONS(2491),
    [anon_sym_struct] = ACTIONS(2493),
    [anon_sym_trait] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2497),
    [anon_sym_union] = ACTIONS(2499),
    [anon_sym_unsafe] = ACTIONS(429),
    [anon_sym_use] = ACTIONS(2501),
    [anon_sym_extern] = ACTIONS(2503),
    [sym_line_comment] = ACTIONS(7),
  },
  [613] = {
    [sym_empty_statement] = STATE(1265),
    [sym_macro_definition] = STATE(1265),
    [sym_attribute_item] = STATE(1265),
    [sym_inner_attribute_item] = STATE(1265),
    [sym_mod_item] = STATE(1265),
    [sym_foreign_mod_item] = STATE(1265),
    [sym_struct_item] = STATE(1265),
    [sym_union_item] = STATE(1265),
    [sym_enum_item] = STATE(1265),
    [sym_extern_crate_declaration] = STATE(1265),
    [sym_const_item] = STATE(1265),
    [sym_static_item] = STATE(1265),
    [sym_type_item] = STATE(1265),
    [sym_function_item] = STATE(1265),
    [sym_function_signature_item] = STATE(1265),
    [sym_function_modifiers] = STATE(610),
    [sym_impl_item] = STATE(1265),
    [sym_trait_item] = STATE(1265),
    [sym_associated_type] = STATE(1265),
    [sym_let_declaration] = STATE(1265),
    [sym_use_declaration] = STATE(1265),
    [sym_extern_modifier] = STATE(611),
    [sym_visibility_modifier] = STATE(612),
    [sym_macro_invocation] = STATE(1265),
    [aux_sym_declaration_list_repeat1] = STATE(1265),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1159),
    [anon_sym_macro_rules_BANG] = ACTIONS(1161),
    [anon_sym_RBRACE] = ACTIONS(2505),
    [anon_sym_POUND] = ACTIONS(1165),
    [anon_sym_const] = ACTIONS(1167),
    [anon_sym_default] = ACTIONS(1169),
    [anon_sym_enum] = ACTIONS(1171),
    [anon_sym_fn] = ACTIONS(1173),
    [anon_sym_impl] = ACTIONS(1175),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_mod] = ACTIONS(1179),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_struct] = ACTIONS(1183),
    [anon_sym_trait] = ACTIONS(1185),
    [anon_sym_type] = ACTIONS(1187),
    [anon_sym_union] = ACTIONS(1189),
    [anon_sym_unsafe] = ACTIONS(1191),
    [anon_sym_use] = ACTIONS(1193),
    [anon_sym_extern] = ACTIONS(1195),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1197),
  },
  [614] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2507),
    [sym_line_comment] = ACTIONS(7),
  },
  [615] = {
    [sym_enum_variant_list] = STATE(1267),
    [sym_where_clause] = STATE(1268),
    [sym_type_parameters] = STATE(1269),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [616] = {
    [sym_declaration_list] = STATE(1270),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2509),
    [anon_sym_LBRACE] = ACTIONS(425),
    [sym_line_comment] = ACTIONS(7),
  },
  [617] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2511),
  },
  [618] = {
    [sym_field_declaration_list] = STATE(1272),
    [sym_ordered_field_declaration_list] = STATE(1273),
    [sym_where_clause] = STATE(1274),
    [sym_type_parameters] = STATE(1275),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2513),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_where] = ACTIONS(1057),
    [sym_line_comment] = ACTIONS(7),
  },
  [619] = {
    [sym_declaration_list] = STATE(1276),
    [sym_trait_bounds] = STATE(1277),
    [sym_type_parameters] = STATE(1278),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_COLON] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [sym_line_comment] = ACTIONS(7),
  },
  [620] = {
    [sym_type_parameters] = STATE(1280),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(2515),
    [sym_line_comment] = ACTIONS(7),
  },
  [621] = {
    [sym_field_declaration_list] = STATE(1281),
    [sym_ordered_field_declaration_list] = STATE(1282),
    [sym_where_clause] = STATE(1283),
    [sym_type_parameters] = STATE(1284),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2517),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_where] = ACTIONS(1057),
    [sym_line_comment] = ACTIONS(7),
  },
  [622] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2519),
    [sym_line_comment] = ACTIONS(7),
  },
  [623] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2521),
  },
  [624] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2523),
    [sym_metavariable] = ACTIONS(2523),
  },
  [625] = {
    [sym_raw_string_literal] = ACTIONS(2525),
    [sym_float_literal] = ACTIONS(2525),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(2525),
    [anon_sym_SEMI] = ACTIONS(2525),
    [anon_sym_macro_rules_BANG] = ACTIONS(2525),
    [anon_sym_LPAREN] = ACTIONS(2525),
    [anon_sym_LBRACE] = ACTIONS(2525),
    [anon_sym_RBRACE] = ACTIONS(2525),
    [anon_sym_LBRACK] = ACTIONS(2525),
    [anon_sym_STAR] = ACTIONS(2525),
    [anon_sym_u8] = ACTIONS(2527),
    [anon_sym_i8] = ACTIONS(2527),
    [anon_sym_u16] = ACTIONS(2527),
    [anon_sym_i16] = ACTIONS(2527),
    [anon_sym_u32] = ACTIONS(2527),
    [anon_sym_i32] = ACTIONS(2527),
    [anon_sym_u64] = ACTIONS(2527),
    [anon_sym_i64] = ACTIONS(2527),
    [anon_sym_u128] = ACTIONS(2527),
    [anon_sym_i128] = ACTIONS(2527),
    [anon_sym_isize] = ACTIONS(2527),
    [anon_sym_usize] = ACTIONS(2527),
    [anon_sym_f32] = ACTIONS(2527),
    [anon_sym_f64] = ACTIONS(2527),
    [anon_sym_bool] = ACTIONS(2527),
    [anon_sym_str] = ACTIONS(2527),
    [anon_sym_char] = ACTIONS(2527),
    [anon_sym_AMP] = ACTIONS(2525),
    [anon_sym_DASH] = ACTIONS(2525),
    [anon_sym_COLON_COLON] = ACTIONS(2525),
    [anon_sym_BANG] = ACTIONS(2525),
    [anon_sym_POUND] = ACTIONS(2525),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_PIPE] = ACTIONS(2525),
    [anon_sym_SQUOTE] = ACTIONS(2527),
    [anon_sym_DOT_DOT] = ACTIONS(2525),
    [anon_sym_break] = ACTIONS(2527),
    [anon_sym_const] = ACTIONS(2527),
    [anon_sym_continue] = ACTIONS(2527),
    [anon_sym_default] = ACTIONS(2527),
    [anon_sym_enum] = ACTIONS(2527),
    [anon_sym_fn] = ACTIONS(2527),
    [anon_sym_for] = ACTIONS(2527),
    [anon_sym_if] = ACTIONS(2527),
    [anon_sym_impl] = ACTIONS(2527),
    [anon_sym_let] = ACTIONS(2527),
    [anon_sym_loop] = ACTIONS(2527),
    [anon_sym_match] = ACTIONS(2527),
    [anon_sym_mod] = ACTIONS(2527),
    [anon_sym_pub] = ACTIONS(2527),
    [anon_sym_return] = ACTIONS(2527),
    [anon_sym_static] = ACTIONS(2527),
    [anon_sym_struct] = ACTIONS(2527),
    [anon_sym_trait] = ACTIONS(2527),
    [anon_sym_type] = ACTIONS(2527),
    [anon_sym_union] = ACTIONS(2527),
    [anon_sym_unsafe] = ACTIONS(2527),
    [anon_sym_use] = ACTIONS(2527),
    [anon_sym_while] = ACTIONS(2527),
    [anon_sym_extern] = ACTIONS(2527),
    [anon_sym_move] = ACTIONS(2527),
    [sym_integer_literal] = ACTIONS(2525),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2525),
    [sym_char_literal] = ACTIONS(2525),
    [anon_sym_true] = ACTIONS(2527),
    [anon_sym_false] = ACTIONS(2527),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2527),
    [sym_self] = ACTIONS(2527),
    [sym_super] = ACTIONS(2527),
    [sym_crate] = ACTIONS(2527),
    [sym_metavariable] = ACTIONS(2525),
  },
  [626] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2263),
    [anon_sym_LPAREN] = ACTIONS(2263),
    [anon_sym_RPAREN] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(2263),
    [anon_sym_RBRACE] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2263),
    [anon_sym_RBRACK] = ACTIONS(2263),
    [anon_sym_PLUS] = ACTIONS(2267),
    [anon_sym_STAR] = ACTIONS(2267),
    [anon_sym_COMMA] = ACTIONS(2263),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_DASH] = ACTIONS(2267),
    [anon_sym_DOT] = ACTIONS(2267),
    [anon_sym_DASH_EQ] = ACTIONS(2263),
    [anon_sym_COLON_COLON] = ACTIONS(2263),
    [anon_sym_BANG_EQ] = ACTIONS(2263),
    [anon_sym_STAR_EQ] = ACTIONS(2263),
    [anon_sym_SLASH] = ACTIONS(2267),
    [anon_sym_SLASH_EQ] = ACTIONS(2263),
    [anon_sym_AMP_AMP] = ACTIONS(2263),
    [anon_sym_AMP_EQ] = ACTIONS(2263),
    [anon_sym_PERCENT] = ACTIONS(2267),
    [anon_sym_PERCENT_EQ] = ACTIONS(2263),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_CARET_EQ] = ACTIONS(2263),
    [anon_sym_PLUS_EQ] = ACTIONS(2263),
    [anon_sym_LT] = ACTIONS(2267),
    [anon_sym_LT_LT] = ACTIONS(2267),
    [anon_sym_LT_LT_EQ] = ACTIONS(2263),
    [anon_sym_LT_EQ] = ACTIONS(2263),
    [anon_sym_EQ] = ACTIONS(2267),
    [anon_sym_EQ_EQ] = ACTIONS(2263),
    [anon_sym_GT] = ACTIONS(2267),
    [anon_sym_GT_EQ] = ACTIONS(2263),
    [anon_sym_GT_GT] = ACTIONS(2267),
    [anon_sym_GT_GT_EQ] = ACTIONS(2263),
    [anon_sym_PIPE] = ACTIONS(2267),
    [anon_sym_PIPE_EQ] = ACTIONS(2263),
    [anon_sym_PIPE_PIPE] = ACTIONS(2263),
    [anon_sym_QMARK] = ACTIONS(2263),
    [anon_sym_DOT_DOT] = ACTIONS(2267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2263),
    [anon_sym_as] = ACTIONS(2263),
    [sym_line_comment] = ACTIONS(7),
  },
  [627] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2529),
    [anon_sym_LPAREN] = ACTIONS(2529),
    [anon_sym_RPAREN] = ACTIONS(2529),
    [anon_sym_LBRACE] = ACTIONS(2531),
    [anon_sym_RBRACE] = ACTIONS(2529),
    [anon_sym_LBRACK] = ACTIONS(2529),
    [anon_sym_RBRACK] = ACTIONS(2529),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_STAR] = ACTIONS(2533),
    [anon_sym_COMMA] = ACTIONS(2529),
    [anon_sym_AMP] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_DOT] = ACTIONS(2533),
    [anon_sym_DASH_EQ] = ACTIONS(2529),
    [anon_sym_COLON_COLON] = ACTIONS(2529),
    [anon_sym_BANG_EQ] = ACTIONS(2529),
    [anon_sym_STAR_EQ] = ACTIONS(2529),
    [anon_sym_SLASH] = ACTIONS(2533),
    [anon_sym_SLASH_EQ] = ACTIONS(2529),
    [anon_sym_AMP_AMP] = ACTIONS(2529),
    [anon_sym_AMP_EQ] = ACTIONS(2529),
    [anon_sym_PERCENT] = ACTIONS(2533),
    [anon_sym_PERCENT_EQ] = ACTIONS(2529),
    [anon_sym_CARET] = ACTIONS(2533),
    [anon_sym_CARET_EQ] = ACTIONS(2529),
    [anon_sym_PLUS_EQ] = ACTIONS(2529),
    [anon_sym_LT] = ACTIONS(2533),
    [anon_sym_LT_LT] = ACTIONS(2533),
    [anon_sym_LT_LT_EQ] = ACTIONS(2529),
    [anon_sym_LT_EQ] = ACTIONS(2529),
    [anon_sym_EQ] = ACTIONS(2533),
    [anon_sym_EQ_EQ] = ACTIONS(2529),
    [anon_sym_GT] = ACTIONS(2533),
    [anon_sym_GT_EQ] = ACTIONS(2529),
    [anon_sym_GT_GT] = ACTIONS(2533),
    [anon_sym_GT_GT_EQ] = ACTIONS(2529),
    [anon_sym_PIPE] = ACTIONS(2533),
    [anon_sym_PIPE_EQ] = ACTIONS(2529),
    [anon_sym_PIPE_PIPE] = ACTIONS(2529),
    [anon_sym_QMARK] = ACTIONS(2529),
    [anon_sym_DOT_DOT] = ACTIONS(2533),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2529),
    [anon_sym_as] = ACTIONS(2529),
    [sym_line_comment] = ACTIONS(7),
  },
  [628] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2535),
    [anon_sym_LPAREN] = ACTIONS(2535),
    [anon_sym_RPAREN] = ACTIONS(2535),
    [anon_sym_LBRACE] = ACTIONS(2535),
    [anon_sym_RBRACE] = ACTIONS(2535),
    [anon_sym_LBRACK] = ACTIONS(2535),
    [anon_sym_RBRACK] = ACTIONS(2535),
    [anon_sym_PLUS] = ACTIONS(2537),
    [anon_sym_STAR] = ACTIONS(2537),
    [anon_sym_COMMA] = ACTIONS(2535),
    [anon_sym_AMP] = ACTIONS(2537),
    [anon_sym_DASH] = ACTIONS(2537),
    [anon_sym_DOT] = ACTIONS(2537),
    [anon_sym_DASH_EQ] = ACTIONS(2535),
    [anon_sym_BANG_EQ] = ACTIONS(2535),
    [anon_sym_STAR_EQ] = ACTIONS(2535),
    [anon_sym_SLASH] = ACTIONS(2537),
    [anon_sym_SLASH_EQ] = ACTIONS(2535),
    [anon_sym_AMP_AMP] = ACTIONS(2535),
    [anon_sym_AMP_EQ] = ACTIONS(2535),
    [anon_sym_PERCENT] = ACTIONS(2537),
    [anon_sym_PERCENT_EQ] = ACTIONS(2535),
    [anon_sym_CARET] = ACTIONS(2537),
    [anon_sym_CARET_EQ] = ACTIONS(2535),
    [anon_sym_PLUS_EQ] = ACTIONS(2535),
    [anon_sym_LT] = ACTIONS(2537),
    [anon_sym_LT_LT] = ACTIONS(2537),
    [anon_sym_LT_LT_EQ] = ACTIONS(2535),
    [anon_sym_LT_EQ] = ACTIONS(2535),
    [anon_sym_EQ] = ACTIONS(2537),
    [anon_sym_EQ_EQ] = ACTIONS(2535),
    [anon_sym_GT] = ACTIONS(2537),
    [anon_sym_GT_EQ] = ACTIONS(2535),
    [anon_sym_GT_GT] = ACTIONS(2537),
    [anon_sym_GT_GT_EQ] = ACTIONS(2535),
    [anon_sym_PIPE] = ACTIONS(2537),
    [anon_sym_PIPE_EQ] = ACTIONS(2535),
    [anon_sym_PIPE_PIPE] = ACTIONS(2535),
    [anon_sym_QMARK] = ACTIONS(2535),
    [anon_sym_DOT_DOT] = ACTIONS(2537),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2535),
    [anon_sym_as] = ACTIONS(2535),
    [sym_line_comment] = ACTIONS(7),
  },
  [629] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(2539),
    [sym_line_comment] = ACTIONS(7),
  },
  [630] = {
    [sym_arguments] = STATE(263),
    [aux_sym_token_tree_repeat2] = STATE(1290),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(2539),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(2541),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_BANG_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH] = ACTIONS(563),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(563),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_LT] = ACTIONS(577),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(581),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(577),
    [anon_sym_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(589),
    [anon_sym_as] = ACTIONS(591),
    [sym_line_comment] = ACTIONS(7),
  },
  [631] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(103),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(103),
    [sym_macro_invocation] = STATE(103),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(103),
    [sym_unary_expression] = STATE(103),
    [sym_try_expression] = STATE(103),
    [sym_reference_expression] = STATE(103),
    [sym_binary_expression] = STATE(103),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(103),
    [sym_call_expression] = STATE(103),
    [sym_array_expression] = STATE(103),
    [sym_parenthesized_expression] = STATE(103),
    [sym_tuple_expression] = STATE(103),
    [sym_unit_expression] = STATE(103),
    [sym_struct_expression] = STATE(103),
    [sym_if_expression] = STATE(103),
    [sym_if_let_expression] = STATE(103),
    [sym_match_expression] = STATE(103),
    [sym_while_expression] = STATE(103),
    [sym_while_let_expression] = STATE(103),
    [sym_loop_expression] = STATE(103),
    [sym_for_expression] = STATE(103),
    [sym_closure_expression] = STATE(103),
    [sym_closure_parameters] = STATE(638),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(103),
    [sym_continue_expression] = STATE(103),
    [sym_index_expression] = STATE(103),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(103),
    [sym_block] = STATE(103),
    [sym__literal] = STATE(103),
    [sym_string_literal] = STATE(103),
    [sym_boolean_literal] = STATE(103),
    [sym_raw_string_literal] = ACTIONS(173),
    [sym_float_literal] = ACTIONS(173),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1245),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1247),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1251),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1253),
    [sym_integer_literal] = ACTIONS(173),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(173),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [632] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(106),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(106),
    [sym_macro_invocation] = STATE(106),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(106),
    [sym_unary_expression] = STATE(106),
    [sym_try_expression] = STATE(106),
    [sym_reference_expression] = STATE(106),
    [sym_binary_expression] = STATE(106),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(106),
    [sym_call_expression] = STATE(106),
    [sym_array_expression] = STATE(106),
    [sym_parenthesized_expression] = STATE(106),
    [sym_tuple_expression] = STATE(106),
    [sym_unit_expression] = STATE(106),
    [sym_struct_expression] = STATE(106),
    [sym_if_expression] = STATE(106),
    [sym_if_let_expression] = STATE(106),
    [sym_match_expression] = STATE(106),
    [sym_while_expression] = STATE(106),
    [sym_while_let_expression] = STATE(106),
    [sym_loop_expression] = STATE(106),
    [sym_for_expression] = STATE(106),
    [sym_closure_expression] = STATE(106),
    [sym_closure_parameters] = STATE(638),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(106),
    [sym_continue_expression] = STATE(106),
    [sym_index_expression] = STATE(106),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(106),
    [sym_block] = STATE(106),
    [sym__literal] = STATE(106),
    [sym_string_literal] = STATE(106),
    [sym_boolean_literal] = STATE(106),
    [sym_raw_string_literal] = ACTIONS(183),
    [sym_float_literal] = ACTIONS(183),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1245),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1247),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1251),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [sym_mutable_specifier] = ACTIONS(2543),
    [anon_sym_move] = ACTIONS(1253),
    [sym_integer_literal] = ACTIONS(183),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(183),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [633] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1292),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1292),
    [sym_macro_invocation] = STATE(1292),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_try_expression] = STATE(1292),
    [sym_reference_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1292),
    [sym_call_expression] = STATE(1292),
    [sym_array_expression] = STATE(1292),
    [sym_parenthesized_expression] = STATE(1292),
    [sym_tuple_expression] = STATE(1292),
    [sym_unit_expression] = STATE(1292),
    [sym_struct_expression] = STATE(1292),
    [sym_if_expression] = STATE(1292),
    [sym_if_let_expression] = STATE(1292),
    [sym_match_expression] = STATE(1292),
    [sym_while_expression] = STATE(1292),
    [sym_while_let_expression] = STATE(1292),
    [sym_loop_expression] = STATE(1292),
    [sym_for_expression] = STATE(1292),
    [sym_closure_expression] = STATE(1292),
    [sym_closure_parameters] = STATE(638),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1292),
    [sym_continue_expression] = STATE(1292),
    [sym_index_expression] = STATE(1292),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1292),
    [sym_block] = STATE(1292),
    [sym__literal] = STATE(1292),
    [sym_string_literal] = STATE(1292),
    [sym_boolean_literal] = STATE(1292),
    [sym_raw_string_literal] = ACTIONS(2545),
    [sym_float_literal] = ACTIONS(2545),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_RBRACK] = ACTIONS(261),
    [anon_sym_PLUS] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(263),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(263),
    [anon_sym_DASH] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(263),
    [anon_sym_DASH_EQ] = ACTIONS(261),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_BANG_EQ] = ACTIONS(261),
    [anon_sym_STAR_EQ] = ACTIONS(261),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_SLASH_EQ] = ACTIONS(261),
    [anon_sym_AMP_AMP] = ACTIONS(261),
    [anon_sym_AMP_EQ] = ACTIONS(261),
    [anon_sym_PERCENT] = ACTIONS(263),
    [anon_sym_PERCENT_EQ] = ACTIONS(261),
    [anon_sym_CARET] = ACTIONS(263),
    [anon_sym_CARET_EQ] = ACTIONS(261),
    [anon_sym_PLUS_EQ] = ACTIONS(261),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_EQ] = ACTIONS(261),
    [anon_sym_LT_EQ] = ACTIONS(261),
    [anon_sym_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(261),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_EQ] = ACTIONS(261),
    [anon_sym_GT_GT] = ACTIONS(263),
    [anon_sym_GT_GT_EQ] = ACTIONS(261),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_PIPE_EQ] = ACTIONS(261),
    [anon_sym_PIPE_PIPE] = ACTIONS(261),
    [anon_sym_QMARK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(263),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(261),
    [anon_sym_as] = ACTIONS(263),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1251),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1253),
    [sym_integer_literal] = ACTIONS(2545),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(2545),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [634] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1294),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(1294),
    [sym_macro_invocation] = STATE(1294),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1294),
    [sym_unary_expression] = STATE(1294),
    [sym_try_expression] = STATE(1294),
    [sym_reference_expression] = STATE(1294),
    [sym_binary_expression] = STATE(1294),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1294),
    [sym_call_expression] = STATE(1294),
    [sym_array_expression] = STATE(1294),
    [sym_parenthesized_expression] = STATE(1294),
    [sym_tuple_expression] = STATE(1294),
    [sym_unit_expression] = STATE(1294),
    [sym_struct_expression] = STATE(1294),
    [sym_if_expression] = STATE(1294),
    [sym_if_let_expression] = STATE(1294),
    [sym_match_expression] = STATE(1294),
    [sym_while_expression] = STATE(1294),
    [sym_while_let_expression] = STATE(1294),
    [sym_loop_expression] = STATE(1294),
    [sym_for_expression] = STATE(1294),
    [sym_closure_expression] = STATE(1294),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1294),
    [sym_continue_expression] = STATE(1294),
    [sym_index_expression] = STATE(1294),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1294),
    [sym_block] = STATE(1294),
    [sym__literal] = STATE(1294),
    [sym_string_literal] = STATE(1294),
    [sym_boolean_literal] = STATE(1294),
    [sym_raw_string_literal] = ACTIONS(2549),
    [sym_float_literal] = ACTIONS(2549),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_let] = ACTIONS(2551),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(2549),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(2549),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [635] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1295),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1295),
    [sym_macro_invocation] = STATE(1295),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1295),
    [sym_unary_expression] = STATE(1295),
    [sym_try_expression] = STATE(1295),
    [sym_reference_expression] = STATE(1295),
    [sym_binary_expression] = STATE(1295),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1295),
    [sym_call_expression] = STATE(1295),
    [sym_array_expression] = STATE(1295),
    [sym_parenthesized_expression] = STATE(1295),
    [sym_tuple_expression] = STATE(1295),
    [sym_unit_expression] = STATE(1295),
    [sym_struct_expression] = STATE(1295),
    [sym_if_expression] = STATE(1295),
    [sym_if_let_expression] = STATE(1295),
    [sym_match_expression] = STATE(1295),
    [sym_while_expression] = STATE(1295),
    [sym_while_let_expression] = STATE(1295),
    [sym_loop_expression] = STATE(1295),
    [sym_for_expression] = STATE(1295),
    [sym_closure_expression] = STATE(1295),
    [sym_closure_parameters] = STATE(638),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1295),
    [sym_continue_expression] = STATE(1295),
    [sym_index_expression] = STATE(1295),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1295),
    [sym_block] = STATE(1295),
    [sym__literal] = STATE(1295),
    [sym_string_literal] = STATE(1295),
    [sym_boolean_literal] = STATE(1295),
    [sym_raw_string_literal] = ACTIONS(2553),
    [sym_float_literal] = ACTIONS(2553),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(359),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(359),
    [anon_sym_RBRACK] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(361),
    [anon_sym_STAR] = ACTIONS(361),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(361),
    [anon_sym_DASH_EQ] = ACTIONS(359),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_BANG_EQ] = ACTIONS(359),
    [anon_sym_STAR_EQ] = ACTIONS(359),
    [anon_sym_SLASH] = ACTIONS(361),
    [anon_sym_SLASH_EQ] = ACTIONS(359),
    [anon_sym_AMP_AMP] = ACTIONS(359),
    [anon_sym_AMP_EQ] = ACTIONS(359),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_PERCENT_EQ] = ACTIONS(359),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_CARET_EQ] = ACTIONS(359),
    [anon_sym_PLUS_EQ] = ACTIONS(359),
    [anon_sym_LT] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_LT_LT_EQ] = ACTIONS(359),
    [anon_sym_LT_EQ] = ACTIONS(359),
    [anon_sym_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(359),
    [anon_sym_GT] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(359),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_GT_GT_EQ] = ACTIONS(359),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_PIPE_EQ] = ACTIONS(359),
    [anon_sym_PIPE_PIPE] = ACTIONS(359),
    [anon_sym_QMARK] = ACTIONS(359),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(361),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(359),
    [anon_sym_as] = ACTIONS(361),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1251),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1253),
    [sym_integer_literal] = ACTIONS(2553),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(2553),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [636] = {
    [sym_closure_parameters] = STATE(1296),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(7),
  },
  [637] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2555),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_STAR_EQ] = ACTIONS(2563),
    [anon_sym_SLASH] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_AMP_EQ] = ACTIONS(2563),
    [anon_sym_PERCENT] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2563),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_CARET_EQ] = ACTIONS(2563),
    [anon_sym_PLUS_EQ] = ACTIONS(2563),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_LT_LT] = ACTIONS(2573),
    [anon_sym_LT_LT_EQ] = ACTIONS(2563),
    [anon_sym_LT_EQ] = ACTIONS(2565),
    [anon_sym_EQ] = ACTIONS(2575),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_GT_EQ] = ACTIONS(2565),
    [anon_sym_GT_GT] = ACTIONS(2573),
    [anon_sym_GT_GT_EQ] = ACTIONS(2563),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_PIPE_EQ] = ACTIONS(2563),
    [anon_sym_PIPE_PIPE] = ACTIONS(2579),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(2581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2583),
    [anon_sym_as] = ACTIONS(2585),
    [sym_line_comment] = ACTIONS(7),
  },
  [638] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1312),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1312),
    [sym_macro_invocation] = STATE(1312),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1312),
    [sym_unary_expression] = STATE(1312),
    [sym_try_expression] = STATE(1312),
    [sym_reference_expression] = STATE(1312),
    [sym_binary_expression] = STATE(1312),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1312),
    [sym_call_expression] = STATE(1312),
    [sym_array_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_tuple_expression] = STATE(1312),
    [sym_unit_expression] = STATE(1312),
    [sym_struct_expression] = STATE(1312),
    [sym_if_expression] = STATE(1312),
    [sym_if_let_expression] = STATE(1312),
    [sym_match_expression] = STATE(1312),
    [sym_while_expression] = STATE(1312),
    [sym_while_let_expression] = STATE(1312),
    [sym_loop_expression] = STATE(1312),
    [sym_for_expression] = STATE(1312),
    [sym_closure_expression] = STATE(1312),
    [sym_closure_parameters] = STATE(638),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1312),
    [sym_continue_expression] = STATE(1312),
    [sym_index_expression] = STATE(1312),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1312),
    [sym_block] = STATE(1312),
    [sym__literal] = STATE(1312),
    [sym_string_literal] = STATE(1312),
    [sym_boolean_literal] = STATE(1312),
    [sym_raw_string_literal] = ACTIONS(2587),
    [sym_float_literal] = ACTIONS(2587),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1245),
    [anon_sym_DASH] = ACTIONS(2547),
    [anon_sym_DASH_GT] = ACTIONS(509),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1247),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1251),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1253),
    [sym_integer_literal] = ACTIONS(2587),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(2587),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [639] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2591),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [640] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(2589),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_RBRACE] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2591),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(2591),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(2591),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2591),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [641] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [642] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2593),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_RPAREN] = ACTIONS(2593),
    [anon_sym_LBRACE] = ACTIONS(2593),
    [anon_sym_RBRACE] = ACTIONS(2593),
    [anon_sym_LBRACK] = ACTIONS(2593),
    [anon_sym_RBRACK] = ACTIONS(2593),
    [anon_sym_PLUS] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(2595),
    [anon_sym_COMMA] = ACTIONS(2593),
    [anon_sym_AMP] = ACTIONS(2595),
    [anon_sym_DASH] = ACTIONS(2595),
    [anon_sym_DOT] = ACTIONS(2595),
    [anon_sym_DASH_EQ] = ACTIONS(2593),
    [anon_sym_COLON_COLON] = ACTIONS(2593),
    [anon_sym_BANG_EQ] = ACTIONS(2593),
    [anon_sym_STAR_EQ] = ACTIONS(2593),
    [anon_sym_SLASH] = ACTIONS(2595),
    [anon_sym_SLASH_EQ] = ACTIONS(2593),
    [anon_sym_AMP_AMP] = ACTIONS(2593),
    [anon_sym_AMP_EQ] = ACTIONS(2593),
    [anon_sym_PERCENT] = ACTIONS(2595),
    [anon_sym_PERCENT_EQ] = ACTIONS(2593),
    [anon_sym_CARET] = ACTIONS(2595),
    [anon_sym_CARET_EQ] = ACTIONS(2593),
    [anon_sym_PLUS_EQ] = ACTIONS(2593),
    [anon_sym_LT] = ACTIONS(2595),
    [anon_sym_LT_LT] = ACTIONS(2595),
    [anon_sym_LT_LT_EQ] = ACTIONS(2593),
    [anon_sym_LT_EQ] = ACTIONS(2593),
    [anon_sym_EQ] = ACTIONS(2595),
    [anon_sym_EQ_EQ] = ACTIONS(2593),
    [anon_sym_GT] = ACTIONS(2595),
    [anon_sym_GT_EQ] = ACTIONS(2593),
    [anon_sym_GT_GT] = ACTIONS(2595),
    [anon_sym_GT_GT_EQ] = ACTIONS(2593),
    [anon_sym_PIPE] = ACTIONS(2595),
    [anon_sym_PIPE_EQ] = ACTIONS(2593),
    [anon_sym_PIPE_PIPE] = ACTIONS(2593),
    [anon_sym_QMARK] = ACTIONS(2593),
    [anon_sym_DOT_DOT] = ACTIONS(2595),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2593),
    [anon_sym_as] = ACTIONS(2593),
    [sym_line_comment] = ACTIONS(7),
  },
  [643] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2597),
    [anon_sym_LPAREN] = ACTIONS(2597),
    [anon_sym_RPAREN] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(2597),
    [anon_sym_RBRACE] = ACTIONS(2597),
    [anon_sym_LBRACK] = ACTIONS(2597),
    [anon_sym_RBRACK] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(2599),
    [anon_sym_STAR] = ACTIONS(2599),
    [anon_sym_COMMA] = ACTIONS(2597),
    [anon_sym_AMP] = ACTIONS(2599),
    [anon_sym_DASH] = ACTIONS(2599),
    [anon_sym_DOT] = ACTIONS(2599),
    [anon_sym_DASH_EQ] = ACTIONS(2597),
    [anon_sym_COLON_COLON] = ACTIONS(2597),
    [anon_sym_BANG_EQ] = ACTIONS(2597),
    [anon_sym_STAR_EQ] = ACTIONS(2597),
    [anon_sym_SLASH] = ACTIONS(2599),
    [anon_sym_SLASH_EQ] = ACTIONS(2597),
    [anon_sym_AMP_AMP] = ACTIONS(2597),
    [anon_sym_AMP_EQ] = ACTIONS(2597),
    [anon_sym_PERCENT] = ACTIONS(2599),
    [anon_sym_PERCENT_EQ] = ACTIONS(2597),
    [anon_sym_CARET] = ACTIONS(2599),
    [anon_sym_CARET_EQ] = ACTIONS(2597),
    [anon_sym_PLUS_EQ] = ACTIONS(2597),
    [anon_sym_LT] = ACTIONS(2599),
    [anon_sym_LT_LT] = ACTIONS(2599),
    [anon_sym_LT_LT_EQ] = ACTIONS(2597),
    [anon_sym_LT_EQ] = ACTIONS(2597),
    [anon_sym_EQ] = ACTIONS(2599),
    [anon_sym_EQ_EQ] = ACTIONS(2597),
    [anon_sym_GT] = ACTIONS(2599),
    [anon_sym_GT_EQ] = ACTIONS(2597),
    [anon_sym_GT_GT] = ACTIONS(2599),
    [anon_sym_GT_GT_EQ] = ACTIONS(2597),
    [anon_sym_PIPE] = ACTIONS(2599),
    [anon_sym_PIPE_EQ] = ACTIONS(2597),
    [anon_sym_PIPE_PIPE] = ACTIONS(2597),
    [anon_sym_QMARK] = ACTIONS(2597),
    [anon_sym_DOT_DOT] = ACTIONS(2599),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2597),
    [anon_sym_as] = ACTIONS(2597),
    [sym_line_comment] = ACTIONS(7),
  },
  [644] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2601),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2601),
    [anon_sym_BANG_EQ] = ACTIONS(469),
    [anon_sym_STAR_EQ] = ACTIONS(2601),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(2601),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_AMP_EQ] = ACTIONS(2601),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(2601),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_CARET_EQ] = ACTIONS(2601),
    [anon_sym_PLUS_EQ] = ACTIONS(2601),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT_LT_EQ] = ACTIONS(2601),
    [anon_sym_LT_EQ] = ACTIONS(469),
    [anon_sym_EQ] = ACTIONS(2603),
    [anon_sym_EQ_EQ] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_EQ] = ACTIONS(2601),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_PIPE_EQ] = ACTIONS(2601),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(2601),
    [anon_sym_DOT_DOT] = ACTIONS(487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(489),
    [anon_sym_as] = ACTIONS(2601),
    [sym_line_comment] = ACTIONS(7),
  },
  [645] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [646] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(469),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(469),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [647] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [648] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2591),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [649] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2605),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2605),
    [anon_sym_BANG_EQ] = ACTIONS(469),
    [anon_sym_STAR_EQ] = ACTIONS(2605),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(2605),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_AMP_EQ] = ACTIONS(2605),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(2605),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_CARET_EQ] = ACTIONS(2605),
    [anon_sym_PLUS_EQ] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT_LT_EQ] = ACTIONS(2605),
    [anon_sym_LT_EQ] = ACTIONS(469),
    [anon_sym_EQ] = ACTIONS(2607),
    [anon_sym_EQ_EQ] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_EQ] = ACTIONS(2605),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_PIPE_EQ] = ACTIONS(2605),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(2605),
    [anon_sym_DOT_DOT] = ACTIONS(487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(489),
    [anon_sym_as] = ACTIONS(2605),
    [sym_line_comment] = ACTIONS(7),
  },
  [650] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [651] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(469),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(469),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [652] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2609),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2609),
    [anon_sym_BANG_EQ] = ACTIONS(469),
    [anon_sym_STAR_EQ] = ACTIONS(2609),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(2609),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_AMP_EQ] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(2609),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_CARET_EQ] = ACTIONS(2609),
    [anon_sym_PLUS_EQ] = ACTIONS(2609),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT_LT_EQ] = ACTIONS(2609),
    [anon_sym_LT_EQ] = ACTIONS(469),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_EQ_EQ] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_EQ] = ACTIONS(2609),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_PIPE_EQ] = ACTIONS(2609),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(2609),
    [anon_sym_DOT_DOT] = ACTIONS(2611),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2609),
    [anon_sym_as] = ACTIONS(2609),
    [sym_line_comment] = ACTIONS(7),
  },
  [653] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1314),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(1314),
    [sym_function_type] = STATE(1314),
    [sym_tuple_type] = STATE(1314),
    [sym_unit_type] = STATE(1314),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1314),
    [sym_reference_type] = STATE(1314),
    [sym_pointer_type] = STATE(1314),
    [sym_empty_type] = STATE(1314),
    [sym_dynamic_type] = STATE(1314),
    [sym_macro_invocation] = STATE(1314),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_RPAREN] = ACTIONS(2613),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [654] = {
    [sym_function_modifiers] = STATE(378),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1315),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(380),
    [sym_array_type] = STATE(1315),
    [sym_function_type] = STATE(1315),
    [sym_tuple_type] = STATE(1315),
    [sym_unit_type] = STATE(1315),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1315),
    [sym_reference_type] = STATE(1315),
    [sym_pointer_type] = STATE(1315),
    [sym_empty_type] = STATE(1315),
    [sym_dynamic_type] = STATE(1315),
    [sym_macro_invocation] = STATE(1315),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(381),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(741),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(745),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(747),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [655] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(2615),
    [sym_mutable_specifier] = ACTIONS(2615),
    [sym_line_comment] = ACTIONS(7),
  },
  [656] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_RBRACE] = ACTIONS(751),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_RBRACK] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(753),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_DASH] = ACTIONS(753),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(2617),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_SLASH] = ACTIONS(753),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_LT_LT] = ACTIONS(753),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [anon_sym_LT_EQ] = ACTIONS(751),
    [anon_sym_EQ] = ACTIONS(753),
    [anon_sym_EQ_EQ] = ACTIONS(751),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_as] = ACTIONS(751),
    [sym_line_comment] = ACTIONS(7),
  },
  [657] = {
    [sym_function_modifiers] = STATE(665),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1319),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(1320),
    [sym_array_type] = STATE(1319),
    [sym_function_type] = STATE(1319),
    [sym_tuple_type] = STATE(1319),
    [sym_unit_type] = STATE(1319),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(1319),
    [sym_reference_type] = STATE(1319),
    [sym_pointer_type] = STATE(1319),
    [sym_empty_type] = STATE(1319),
    [sym_dynamic_type] = STATE(1319),
    [sym_macro_invocation] = STATE(1319),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(671),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1291),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1295),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1301),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_mutable_specifier] = ACTIONS(2619),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1305),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [658] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2621),
  },
  [659] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(761),
    [anon_sym_LPAREN] = ACTIONS(761),
    [anon_sym_RPAREN] = ACTIONS(761),
    [anon_sym_LBRACE] = ACTIONS(761),
    [anon_sym_RBRACE] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(761),
    [anon_sym_RBRACK] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(2623),
    [anon_sym_COMMA] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(2623),
    [anon_sym_DASH] = ACTIONS(2623),
    [anon_sym_DOT] = ACTIONS(2623),
    [anon_sym_DASH_EQ] = ACTIONS(761),
    [anon_sym_BANG_EQ] = ACTIONS(761),
    [anon_sym_STAR_EQ] = ACTIONS(761),
    [anon_sym_SLASH] = ACTIONS(2623),
    [anon_sym_SLASH_EQ] = ACTIONS(761),
    [anon_sym_AMP_AMP] = ACTIONS(761),
    [anon_sym_AMP_EQ] = ACTIONS(761),
    [anon_sym_PERCENT] = ACTIONS(2623),
    [anon_sym_PERCENT_EQ] = ACTIONS(761),
    [anon_sym_CARET] = ACTIONS(2623),
    [anon_sym_CARET_EQ] = ACTIONS(761),
    [anon_sym_PLUS_EQ] = ACTIONS(761),
    [anon_sym_LT] = ACTIONS(2623),
    [anon_sym_LT_LT] = ACTIONS(2623),
    [anon_sym_LT_LT_EQ] = ACTIONS(761),
    [anon_sym_LT_EQ] = ACTIONS(761),
    [anon_sym_EQ] = ACTIONS(2623),
    [anon_sym_EQ_EQ] = ACTIONS(761),
    [anon_sym_GT] = ACTIONS(2623),
    [anon_sym_GT_EQ] = ACTIONS(761),
    [anon_sym_GT_GT] = ACTIONS(2623),
    [anon_sym_GT_GT_EQ] = ACTIONS(761),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_PIPE_EQ] = ACTIONS(761),
    [anon_sym_PIPE_PIPE] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(761),
    [anon_sym_DOT_DOT] = ACTIONS(2623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(761),
    [anon_sym_as] = ACTIONS(761),
    [sym_line_comment] = ACTIONS(7),
  },
  [660] = {
    [sym_parameters] = STATE(1323),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [sym_line_comment] = ACTIONS(7),
  },
  [661] = {
    [sym_bracketed_type] = STATE(663),
    [sym_generic_type] = STATE(1326),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(1327),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(2627),
    [anon_sym_i8] = ACTIONS(2627),
    [anon_sym_u16] = ACTIONS(2627),
    [anon_sym_i16] = ACTIONS(2627),
    [anon_sym_u32] = ACTIONS(2627),
    [anon_sym_i32] = ACTIONS(2627),
    [anon_sym_u64] = ACTIONS(2627),
    [anon_sym_i64] = ACTIONS(2627),
    [anon_sym_u128] = ACTIONS(2627),
    [anon_sym_i128] = ACTIONS(2627),
    [anon_sym_isize] = ACTIONS(2627),
    [anon_sym_usize] = ACTIONS(2627),
    [anon_sym_f32] = ACTIONS(2627),
    [anon_sym_f64] = ACTIONS(2627),
    [anon_sym_bool] = ACTIONS(2627),
    [anon_sym_str] = ACTIONS(2627),
    [anon_sym_char] = ACTIONS(2627),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_LT] = ACTIONS(31),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2629),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(2631),
  },
  [662] = {
    [sym_parameters] = STATE(1329),
    [sym_type_arguments] = STATE(1330),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(2633),
    [anon_sym_STAR] = ACTIONS(2633),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_DASH] = ACTIONS(2633),
    [anon_sym_DOT] = ACTIONS(2633),
    [anon_sym_DASH_EQ] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(2635),
    [anon_sym_BANG] = ACTIONS(557),
    [anon_sym_BANG_EQ] = ACTIONS(773),
    [anon_sym_STAR_EQ] = ACTIONS(773),
    [anon_sym_SLASH] = ACTIONS(2633),
    [anon_sym_SLASH_EQ] = ACTIONS(773),
    [anon_sym_AMP_AMP] = ACTIONS(773),
    [anon_sym_AMP_EQ] = ACTIONS(773),
    [anon_sym_PERCENT] = ACTIONS(2633),
    [anon_sym_PERCENT_EQ] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(2633),
    [anon_sym_CARET_EQ] = ACTIONS(773),
    [anon_sym_PLUS_EQ] = ACTIONS(773),
    [anon_sym_LT] = ACTIONS(2637),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_LT_LT_EQ] = ACTIONS(773),
    [anon_sym_LT_EQ] = ACTIONS(773),
    [anon_sym_EQ] = ACTIONS(2633),
    [anon_sym_EQ_EQ] = ACTIONS(773),
    [anon_sym_GT] = ACTIONS(2633),
    [anon_sym_GT_EQ] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_GT_GT_EQ] = ACTIONS(773),
    [anon_sym_PIPE] = ACTIONS(2633),
    [anon_sym_PIPE_EQ] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(773),
    [anon_sym_QMARK] = ACTIONS(773),
    [anon_sym_DOT_DOT] = ACTIONS(2633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(773),
    [anon_sym_as] = ACTIONS(773),
    [sym_line_comment] = ACTIONS(7),
  },
  [663] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON_COLON] = ACTIONS(2639),
    [sym_line_comment] = ACTIONS(7),
  },
  [664] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(783),
    [anon_sym_LPAREN] = ACTIONS(783),
    [anon_sym_RPAREN] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(783),
    [anon_sym_RBRACE] = ACTIONS(783),
    [anon_sym_LBRACK] = ACTIONS(783),
    [anon_sym_RBRACK] = ACTIONS(783),
    [anon_sym_PLUS] = ACTIONS(785),
    [anon_sym_STAR] = ACTIONS(785),
    [anon_sym_COMMA] = ACTIONS(783),
    [anon_sym_AMP] = ACTIONS(785),
    [anon_sym_DASH] = ACTIONS(785),
    [anon_sym_DOT] = ACTIONS(785),
    [anon_sym_DASH_EQ] = ACTIONS(783),
    [anon_sym_COLON_COLON] = ACTIONS(2639),
    [anon_sym_BANG_EQ] = ACTIONS(783),
    [anon_sym_STAR_EQ] = ACTIONS(783),
    [anon_sym_SLASH] = ACTIONS(785),
    [anon_sym_SLASH_EQ] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_AMP_EQ] = ACTIONS(783),
    [anon_sym_PERCENT] = ACTIONS(785),
    [anon_sym_PERCENT_EQ] = ACTIONS(783),
    [anon_sym_CARET] = ACTIONS(785),
    [anon_sym_CARET_EQ] = ACTIONS(783),
    [anon_sym_PLUS_EQ] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(785),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_LT_LT_EQ] = ACTIONS(783),
    [anon_sym_LT_EQ] = ACTIONS(783),
    [anon_sym_EQ] = ACTIONS(785),
    [anon_sym_EQ_EQ] = ACTIONS(783),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_GT_EQ] = ACTIONS(783),
    [anon_sym_GT_GT] = ACTIONS(785),
    [anon_sym_GT_GT_EQ] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PIPE_EQ] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_DOT_DOT] = ACTIONS(785),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(783),
    [anon_sym_as] = ACTIONS(783),
    [sym_line_comment] = ACTIONS(7),
  },
  [665] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1334),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_fn] = ACTIONS(2641),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2643),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [666] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym_LPAREN] = ACTIONS(2645),
    [anon_sym_RPAREN] = ACTIONS(2645),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_RBRACE] = ACTIONS(2645),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_RBRACK] = ACTIONS(2645),
    [anon_sym_PLUS] = ACTIONS(2647),
    [anon_sym_STAR] = ACTIONS(2647),
    [anon_sym_COMMA] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2647),
    [anon_sym_DASH] = ACTIONS(2647),
    [anon_sym_DOT] = ACTIONS(2647),
    [anon_sym_DASH_EQ] = ACTIONS(2645),
    [anon_sym_BANG_EQ] = ACTIONS(2645),
    [anon_sym_STAR_EQ] = ACTIONS(2645),
    [anon_sym_SLASH] = ACTIONS(2647),
    [anon_sym_SLASH_EQ] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP_EQ] = ACTIONS(2645),
    [anon_sym_PERCENT] = ACTIONS(2647),
    [anon_sym_PERCENT_EQ] = ACTIONS(2645),
    [anon_sym_CARET] = ACTIONS(2647),
    [anon_sym_CARET_EQ] = ACTIONS(2645),
    [anon_sym_PLUS_EQ] = ACTIONS(2645),
    [anon_sym_LT] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2647),
    [anon_sym_LT_LT_EQ] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2645),
    [anon_sym_EQ] = ACTIONS(2647),
    [anon_sym_EQ_EQ] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2645),
    [anon_sym_GT_GT] = ACTIONS(2647),
    [anon_sym_GT_GT_EQ] = ACTIONS(2645),
    [anon_sym_PIPE] = ACTIONS(2647),
    [anon_sym_PIPE_EQ] = ACTIONS(2645),
    [anon_sym_PIPE_PIPE] = ACTIONS(2645),
    [anon_sym_QMARK] = ACTIONS(2645),
    [anon_sym_DOT_DOT] = ACTIONS(2647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2645),
    [anon_sym_as] = ACTIONS(2645),
    [sym_line_comment] = ACTIONS(7),
  },
  [667] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(2649),
    [sym_line_comment] = ACTIONS(7),
  },
  [668] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(783),
    [anon_sym_LPAREN] = ACTIONS(783),
    [anon_sym_RPAREN] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(783),
    [anon_sym_RBRACE] = ACTIONS(783),
    [anon_sym_LBRACK] = ACTIONS(783),
    [anon_sym_RBRACK] = ACTIONS(783),
    [anon_sym_PLUS] = ACTIONS(785),
    [anon_sym_STAR] = ACTIONS(785),
    [anon_sym_COMMA] = ACTIONS(783),
    [anon_sym_AMP] = ACTIONS(785),
    [anon_sym_DASH] = ACTIONS(785),
    [anon_sym_DOT] = ACTIONS(785),
    [anon_sym_DASH_EQ] = ACTIONS(783),
    [anon_sym_COLON_COLON] = ACTIONS(2651),
    [anon_sym_BANG_EQ] = ACTIONS(783),
    [anon_sym_STAR_EQ] = ACTIONS(783),
    [anon_sym_SLASH] = ACTIONS(785),
    [anon_sym_SLASH_EQ] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_AMP_EQ] = ACTIONS(783),
    [anon_sym_PERCENT] = ACTIONS(785),
    [anon_sym_PERCENT_EQ] = ACTIONS(783),
    [anon_sym_CARET] = ACTIONS(785),
    [anon_sym_CARET_EQ] = ACTIONS(783),
    [anon_sym_PLUS_EQ] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(785),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_LT_LT_EQ] = ACTIONS(783),
    [anon_sym_LT_EQ] = ACTIONS(783),
    [anon_sym_EQ] = ACTIONS(785),
    [anon_sym_EQ_EQ] = ACTIONS(783),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_GT_EQ] = ACTIONS(783),
    [anon_sym_GT_GT] = ACTIONS(785),
    [anon_sym_GT_GT_EQ] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PIPE_EQ] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_DOT_DOT] = ACTIONS(785),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(783),
    [anon_sym_as] = ACTIONS(783),
    [sym_line_comment] = ACTIONS(7),
  },
  [669] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON_COLON] = ACTIONS(2653),
    [sym_line_comment] = ACTIONS(7),
  },
  [670] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON_COLON] = ACTIONS(2655),
    [sym_line_comment] = ACTIONS(7),
  },
  [671] = {
    [sym_parameters] = STATE(1323),
    [sym_type_arguments] = STATE(1340),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(783),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(783),
    [anon_sym_PLUS] = ACTIONS(785),
    [anon_sym_STAR] = ACTIONS(785),
    [anon_sym_AMP] = ACTIONS(785),
    [anon_sym_DASH] = ACTIONS(785),
    [anon_sym_DOT] = ACTIONS(785),
    [anon_sym_DASH_EQ] = ACTIONS(783),
    [anon_sym_BANG_EQ] = ACTIONS(783),
    [anon_sym_STAR_EQ] = ACTIONS(783),
    [anon_sym_SLASH] = ACTIONS(785),
    [anon_sym_SLASH_EQ] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_AMP_EQ] = ACTIONS(783),
    [anon_sym_PERCENT] = ACTIONS(785),
    [anon_sym_PERCENT_EQ] = ACTIONS(783),
    [anon_sym_CARET] = ACTIONS(785),
    [anon_sym_CARET_EQ] = ACTIONS(783),
    [anon_sym_PLUS_EQ] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(2637),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_LT_LT_EQ] = ACTIONS(783),
    [anon_sym_LT_EQ] = ACTIONS(783),
    [anon_sym_EQ] = ACTIONS(785),
    [anon_sym_EQ_EQ] = ACTIONS(783),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_GT_EQ] = ACTIONS(783),
    [anon_sym_GT_GT] = ACTIONS(785),
    [anon_sym_GT_GT_EQ] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PIPE_EQ] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_DOT_DOT] = ACTIONS(785),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(783),
    [anon_sym_as] = ACTIONS(783),
    [sym_line_comment] = ACTIONS(7),
  },
  [672] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2269),
    [anon_sym_LPAREN] = ACTIONS(2269),
    [anon_sym_RPAREN] = ACTIONS(2269),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_RBRACE] = ACTIONS(2269),
    [anon_sym_LBRACK] = ACTIONS(2269),
    [anon_sym_RBRACK] = ACTIONS(2269),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(2273),
    [anon_sym_COMMA] = ACTIONS(2269),
    [anon_sym_AMP] = ACTIONS(2273),
    [anon_sym_DASH] = ACTIONS(2273),
    [anon_sym_DOT] = ACTIONS(2273),
    [anon_sym_DASH_EQ] = ACTIONS(2269),
    [anon_sym_COLON_COLON] = ACTIONS(2657),
    [anon_sym_BANG_EQ] = ACTIONS(2269),
    [anon_sym_STAR_EQ] = ACTIONS(2269),
    [anon_sym_SLASH] = ACTIONS(2273),
    [anon_sym_SLASH_EQ] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2269),
    [anon_sym_AMP_EQ] = ACTIONS(2269),
    [anon_sym_PERCENT] = ACTIONS(2273),
    [anon_sym_PERCENT_EQ] = ACTIONS(2269),
    [anon_sym_CARET] = ACTIONS(2273),
    [anon_sym_CARET_EQ] = ACTIONS(2269),
    [anon_sym_PLUS_EQ] = ACTIONS(2269),
    [anon_sym_LT] = ACTIONS(2273),
    [anon_sym_LT_LT] = ACTIONS(2273),
    [anon_sym_LT_LT_EQ] = ACTIONS(2269),
    [anon_sym_LT_EQ] = ACTIONS(2269),
    [anon_sym_EQ] = ACTIONS(2273),
    [anon_sym_EQ_EQ] = ACTIONS(2269),
    [anon_sym_GT] = ACTIONS(2273),
    [anon_sym_GT_EQ] = ACTIONS(2269),
    [anon_sym_GT_GT] = ACTIONS(2273),
    [anon_sym_GT_GT_EQ] = ACTIONS(2269),
    [anon_sym_PIPE] = ACTIONS(2273),
    [anon_sym_PIPE_EQ] = ACTIONS(2269),
    [anon_sym_PIPE_PIPE] = ACTIONS(2269),
    [anon_sym_QMARK] = ACTIONS(2269),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2269),
    [anon_sym_as] = ACTIONS(2269),
    [sym_line_comment] = ACTIONS(7),
  },
  [673] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(2659),
    [sym_mutable_specifier] = ACTIONS(2659),
    [sym_line_comment] = ACTIONS(7),
  },
  [674] = {
    [sym_function_modifiers] = STATE(677),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(385),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1343),
    [sym_array_type] = STATE(385),
    [sym_function_type] = STATE(385),
    [sym_tuple_type] = STATE(385),
    [sym_unit_type] = STATE(385),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(385),
    [sym_reference_type] = STATE(385),
    [sym_pointer_type] = STATE(385),
    [sym_empty_type] = STATE(385),
    [sym_dynamic_type] = STATE(385),
    [sym_macro_invocation] = STATE(385),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(680),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1315),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1317),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1319),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(2661),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1321),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [675] = {
    [sym_parameters] = STATE(1344),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [676] = {
    [sym_parameters] = STATE(1345),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_BANG] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [677] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1348),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_fn] = ACTIONS(2663),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2665),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [678] = {
    [sym_block] = STATE(1350),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(2667),
    [sym_line_comment] = ACTIONS(7),
  },
  [679] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(2669),
    [sym_line_comment] = ACTIONS(7),
  },
  [680] = {
    [sym_parameters] = STATE(1344),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(783),
    [anon_sym_PLUS] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [681] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(1352),
    [sym_tuple_pattern] = STATE(1352),
    [sym_tuple_struct_pattern] = STATE(1352),
    [sym_struct_pattern] = STATE(1352),
    [sym_remaining_field_pattern] = STATE(1352),
    [sym_mut_pattern] = STATE(1352),
    [sym_ref_pattern] = STATE(1352),
    [sym_captured_pattern] = STATE(1352),
    [sym_reference_pattern] = STATE(1352),
    [sym__literal] = STATE(1352),
    [sym_string_literal] = STATE(1352),
    [sym_boolean_literal] = STATE(1352),
    [sym_raw_string_literal] = ACTIONS(2671),
    [sym_float_literal] = ACTIONS(2671),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(2673),
    [anon_sym_AMP] = ACTIONS(293),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(295),
    [anon_sym_ref] = ACTIONS(297),
    [sym_integer_literal] = ACTIONS(2671),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(2671),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(299),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [682] = {
    [sym_block] = STATE(1353),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(17),
    [sym_line_comment] = ACTIONS(7),
  },
  [683] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1355),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(1355),
    [sym_macro_invocation] = STATE(1355),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1355),
    [sym_unary_expression] = STATE(1355),
    [sym_try_expression] = STATE(1355),
    [sym_reference_expression] = STATE(1355),
    [sym_binary_expression] = STATE(1355),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1355),
    [sym_call_expression] = STATE(1355),
    [sym_array_expression] = STATE(1355),
    [sym_parenthesized_expression] = STATE(1355),
    [sym_tuple_expression] = STATE(1355),
    [sym_unit_expression] = STATE(1355),
    [sym_struct_expression] = STATE(1355),
    [sym_if_expression] = STATE(1355),
    [sym_if_let_expression] = STATE(1355),
    [sym_match_expression] = STATE(1355),
    [sym_while_expression] = STATE(1355),
    [sym_while_let_expression] = STATE(1355),
    [sym_loop_expression] = STATE(1355),
    [sym_for_expression] = STATE(1355),
    [sym_closure_expression] = STATE(1355),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1355),
    [sym_continue_expression] = STATE(1355),
    [sym_index_expression] = STATE(1355),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1355),
    [sym_block] = STATE(1355),
    [sym__literal] = STATE(1355),
    [sym_string_literal] = STATE(1355),
    [sym_boolean_literal] = STATE(1355),
    [sym_raw_string_literal] = ACTIONS(2675),
    [sym_float_literal] = ACTIONS(2675),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_let] = ACTIONS(2677),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(2675),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(2675),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [684] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2269),
    [anon_sym_LPAREN] = ACTIONS(2269),
    [anon_sym_RPAREN] = ACTIONS(2269),
    [anon_sym_LBRACE] = ACTIONS(2269),
    [anon_sym_RBRACE] = ACTIONS(2269),
    [anon_sym_LBRACK] = ACTIONS(2269),
    [anon_sym_RBRACK] = ACTIONS(2269),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(2273),
    [anon_sym_COMMA] = ACTIONS(2269),
    [anon_sym_AMP] = ACTIONS(2273),
    [anon_sym_DASH] = ACTIONS(2273),
    [anon_sym_DOT] = ACTIONS(2273),
    [anon_sym_DASH_EQ] = ACTIONS(2269),
    [anon_sym_BANG_EQ] = ACTIONS(2269),
    [anon_sym_STAR_EQ] = ACTIONS(2269),
    [anon_sym_SLASH] = ACTIONS(2273),
    [anon_sym_SLASH_EQ] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2269),
    [anon_sym_AMP_EQ] = ACTIONS(2269),
    [anon_sym_PERCENT] = ACTIONS(2273),
    [anon_sym_PERCENT_EQ] = ACTIONS(2269),
    [anon_sym_CARET] = ACTIONS(2273),
    [anon_sym_CARET_EQ] = ACTIONS(2269),
    [anon_sym_PLUS_EQ] = ACTIONS(2269),
    [anon_sym_LT] = ACTIONS(2273),
    [anon_sym_LT_LT] = ACTIONS(2273),
    [anon_sym_LT_LT_EQ] = ACTIONS(2269),
    [anon_sym_LT_EQ] = ACTIONS(2269),
    [anon_sym_EQ] = ACTIONS(2273),
    [anon_sym_EQ_EQ] = ACTIONS(2269),
    [anon_sym_GT] = ACTIONS(2273),
    [anon_sym_GT_EQ] = ACTIONS(2269),
    [anon_sym_GT_GT] = ACTIONS(2273),
    [anon_sym_GT_GT_EQ] = ACTIONS(2269),
    [anon_sym_PIPE] = ACTIONS(2273),
    [anon_sym_PIPE_EQ] = ACTIONS(2269),
    [anon_sym_PIPE_PIPE] = ACTIONS(2269),
    [anon_sym_QMARK] = ACTIONS(2269),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2269),
    [anon_sym_as] = ACTIONS(2269),
    [sym_line_comment] = ACTIONS(7),
  },
  [685] = {
    [sym__token_pattern] = STATE(1363),
    [sym_token_tree_pattern] = STATE(1363),
    [sym_token_binding_pattern] = STATE(1363),
    [sym_token_repetition_pattern] = STATE(1363),
    [sym__literal] = STATE(1363),
    [sym_string_literal] = STATE(1363),
    [sym_boolean_literal] = STATE(1363),
    [aux_sym_token_tree_pattern_repeat1] = STATE(1363),
    [sym_raw_string_literal] = ACTIONS(2679),
    [sym_float_literal] = ACTIONS(2679),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2679),
    [anon_sym_LPAREN] = ACTIONS(2681),
    [anon_sym_RPAREN] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_EQ_GT] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2689),
    [anon_sym_DOLLAR] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(2689),
    [anon_sym_STAR] = ACTIONS(2689),
    [anon_sym_COMMA] = ACTIONS(2679),
    [anon_sym_u8] = ACTIONS(2693),
    [anon_sym_i8] = ACTIONS(2693),
    [anon_sym_u16] = ACTIONS(2693),
    [anon_sym_i16] = ACTIONS(2693),
    [anon_sym_u32] = ACTIONS(2693),
    [anon_sym_i32] = ACTIONS(2693),
    [anon_sym_u64] = ACTIONS(2693),
    [anon_sym_i64] = ACTIONS(2693),
    [anon_sym_u128] = ACTIONS(2693),
    [anon_sym_i128] = ACTIONS(2693),
    [anon_sym_isize] = ACTIONS(2693),
    [anon_sym_usize] = ACTIONS(2693),
    [anon_sym_f32] = ACTIONS(2693),
    [anon_sym_f64] = ACTIONS(2693),
    [anon_sym_bool] = ACTIONS(2693),
    [anon_sym_str] = ACTIONS(2693),
    [anon_sym_char] = ACTIONS(2693),
    [anon_sym__] = ACTIONS(2689),
    [anon_sym_AMP] = ACTIONS(2689),
    [anon_sym_DASH] = ACTIONS(2689),
    [anon_sym_DOT] = ACTIONS(2689),
    [anon_sym_DASH_EQ] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2679),
    [anon_sym_BANG] = ACTIONS(2689),
    [anon_sym_BANG_EQ] = ACTIONS(2679),
    [anon_sym_AT] = ACTIONS(2679),
    [anon_sym_STAR_EQ] = ACTIONS(2679),
    [anon_sym_SLASH] = ACTIONS(2689),
    [anon_sym_SLASH_EQ] = ACTIONS(2679),
    [anon_sym_AMP_AMP] = ACTIONS(2679),
    [anon_sym_AMP_EQ] = ACTIONS(2679),
    [anon_sym_POUND] = ACTIONS(2679),
    [anon_sym_PERCENT] = ACTIONS(2689),
    [anon_sym_PERCENT_EQ] = ACTIONS(2679),
    [anon_sym_CARET] = ACTIONS(2689),
    [anon_sym_CARET_EQ] = ACTIONS(2679),
    [anon_sym_PLUS_EQ] = ACTIONS(2679),
    [anon_sym_LT] = ACTIONS(2689),
    [anon_sym_LT_LT] = ACTIONS(2689),
    [anon_sym_LT_LT_EQ] = ACTIONS(2679),
    [anon_sym_LT_EQ] = ACTIONS(2679),
    [anon_sym_EQ] = ACTIONS(2689),
    [anon_sym_EQ_EQ] = ACTIONS(2679),
    [anon_sym_GT] = ACTIONS(2689),
    [anon_sym_GT_EQ] = ACTIONS(2679),
    [anon_sym_GT_GT] = ACTIONS(2689),
    [anon_sym_GT_GT_EQ] = ACTIONS(2679),
    [anon_sym_PIPE] = ACTIONS(2689),
    [anon_sym_PIPE_EQ] = ACTIONS(2679),
    [anon_sym_PIPE_PIPE] = ACTIONS(2679),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_QMARK] = ACTIONS(2679),
    [anon_sym_SQUOTE] = ACTIONS(2689),
    [anon_sym_DOT_DOT] = ACTIONS(2689),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2679),
    [anon_sym_as] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2689),
    [anon_sym_const] = ACTIONS(2689),
    [anon_sym_continue] = ACTIONS(2689),
    [anon_sym_default] = ACTIONS(2689),
    [anon_sym_enum] = ACTIONS(2689),
    [anon_sym_fn] = ACTIONS(2689),
    [anon_sym_for] = ACTIONS(2689),
    [anon_sym_if] = ACTIONS(2689),
    [anon_sym_impl] = ACTIONS(2689),
    [anon_sym_let] = ACTIONS(2689),
    [anon_sym_loop] = ACTIONS(2689),
    [anon_sym_match] = ACTIONS(2689),
    [anon_sym_mod] = ACTIONS(2689),
    [anon_sym_pub] = ACTIONS(2689),
    [anon_sym_return] = ACTIONS(2689),
    [anon_sym_static] = ACTIONS(2689),
    [anon_sym_struct] = ACTIONS(2689),
    [anon_sym_trait] = ACTIONS(2689),
    [anon_sym_type] = ACTIONS(2689),
    [anon_sym_union] = ACTIONS(2689),
    [anon_sym_unsafe] = ACTIONS(2689),
    [anon_sym_use] = ACTIONS(2689),
    [anon_sym_where] = ACTIONS(2689),
    [anon_sym_while] = ACTIONS(2689),
    [sym_mutable_specifier] = ACTIONS(2689),
    [sym_integer_literal] = ACTIONS(2679),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(2679),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2689),
    [sym_self] = ACTIONS(2689),
    [sym_super] = ACTIONS(2689),
    [sym_crate] = ACTIONS(2689),
    [sym_metavariable] = ACTIONS(2695),
  },
  [686] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2697),
    [sym_line_comment] = ACTIONS(7),
  },
  [687] = {
    [sym__token_pattern] = STATE(1365),
    [sym_token_tree_pattern] = STATE(1365),
    [sym_token_binding_pattern] = STATE(1365),
    [sym_token_repetition_pattern] = STATE(1365),
    [sym__literal] = STATE(1365),
    [sym_string_literal] = STATE(1365),
    [sym_boolean_literal] = STATE(1365),
    [aux_sym_token_tree_pattern_repeat1] = STATE(1365),
    [sym_raw_string_literal] = ACTIONS(2699),
    [sym_float_literal] = ACTIONS(2699),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2699),
    [anon_sym_LPAREN] = ACTIONS(2681),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_RBRACE] = ACTIONS(2683),
    [anon_sym_EQ_GT] = ACTIONS(2699),
    [anon_sym_LBRACK] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2701),
    [anon_sym_DOLLAR] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(2701),
    [anon_sym_STAR] = ACTIONS(2701),
    [anon_sym_COMMA] = ACTIONS(2699),
    [anon_sym_u8] = ACTIONS(2693),
    [anon_sym_i8] = ACTIONS(2693),
    [anon_sym_u16] = ACTIONS(2693),
    [anon_sym_i16] = ACTIONS(2693),
    [anon_sym_u32] = ACTIONS(2693),
    [anon_sym_i32] = ACTIONS(2693),
    [anon_sym_u64] = ACTIONS(2693),
    [anon_sym_i64] = ACTIONS(2693),
    [anon_sym_u128] = ACTIONS(2693),
    [anon_sym_i128] = ACTIONS(2693),
    [anon_sym_isize] = ACTIONS(2693),
    [anon_sym_usize] = ACTIONS(2693),
    [anon_sym_f32] = ACTIONS(2693),
    [anon_sym_f64] = ACTIONS(2693),
    [anon_sym_bool] = ACTIONS(2693),
    [anon_sym_str] = ACTIONS(2693),
    [anon_sym_char] = ACTIONS(2693),
    [anon_sym__] = ACTIONS(2701),
    [anon_sym_AMP] = ACTIONS(2701),
    [anon_sym_DASH] = ACTIONS(2701),
    [anon_sym_DOT] = ACTIONS(2701),
    [anon_sym_DASH_EQ] = ACTIONS(2699),
    [anon_sym_DASH_GT] = ACTIONS(2699),
    [anon_sym_COLON_COLON] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_BANG_EQ] = ACTIONS(2699),
    [anon_sym_AT] = ACTIONS(2699),
    [anon_sym_STAR_EQ] = ACTIONS(2699),
    [anon_sym_SLASH] = ACTIONS(2701),
    [anon_sym_SLASH_EQ] = ACTIONS(2699),
    [anon_sym_AMP_AMP] = ACTIONS(2699),
    [anon_sym_AMP_EQ] = ACTIONS(2699),
    [anon_sym_POUND] = ACTIONS(2699),
    [anon_sym_PERCENT] = ACTIONS(2701),
    [anon_sym_PERCENT_EQ] = ACTIONS(2699),
    [anon_sym_CARET] = ACTIONS(2701),
    [anon_sym_CARET_EQ] = ACTIONS(2699),
    [anon_sym_PLUS_EQ] = ACTIONS(2699),
    [anon_sym_LT] = ACTIONS(2701),
    [anon_sym_LT_LT] = ACTIONS(2701),
    [anon_sym_LT_LT_EQ] = ACTIONS(2699),
    [anon_sym_LT_EQ] = ACTIONS(2699),
    [anon_sym_EQ] = ACTIONS(2701),
    [anon_sym_EQ_EQ] = ACTIONS(2699),
    [anon_sym_GT] = ACTIONS(2701),
    [anon_sym_GT_EQ] = ACTIONS(2699),
    [anon_sym_GT_GT] = ACTIONS(2701),
    [anon_sym_GT_GT_EQ] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2701),
    [anon_sym_PIPE_EQ] = ACTIONS(2699),
    [anon_sym_PIPE_PIPE] = ACTIONS(2699),
    [anon_sym_TILDE] = ACTIONS(2699),
    [anon_sym_QMARK] = ACTIONS(2699),
    [anon_sym_SQUOTE] = ACTIONS(2701),
    [anon_sym_DOT_DOT] = ACTIONS(2701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2699),
    [anon_sym_as] = ACTIONS(2701),
    [anon_sym_break] = ACTIONS(2701),
    [anon_sym_const] = ACTIONS(2701),
    [anon_sym_continue] = ACTIONS(2701),
    [anon_sym_default] = ACTIONS(2701),
    [anon_sym_enum] = ACTIONS(2701),
    [anon_sym_fn] = ACTIONS(2701),
    [anon_sym_for] = ACTIONS(2701),
    [anon_sym_if] = ACTIONS(2701),
    [anon_sym_impl] = ACTIONS(2701),
    [anon_sym_let] = ACTIONS(2701),
    [anon_sym_loop] = ACTIONS(2701),
    [anon_sym_match] = ACTIONS(2701),
    [anon_sym_mod] = ACTIONS(2701),
    [anon_sym_pub] = ACTIONS(2701),
    [anon_sym_return] = ACTIONS(2701),
    [anon_sym_static] = ACTIONS(2701),
    [anon_sym_struct] = ACTIONS(2701),
    [anon_sym_trait] = ACTIONS(2701),
    [anon_sym_type] = ACTIONS(2701),
    [anon_sym_union] = ACTIONS(2701),
    [anon_sym_unsafe] = ACTIONS(2701),
    [anon_sym_use] = ACTIONS(2701),
    [anon_sym_where] = ACTIONS(2701),
    [anon_sym_while] = ACTIONS(2701),
    [sym_mutable_specifier] = ACTIONS(2701),
    [sym_integer_literal] = ACTIONS(2699),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(2699),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2701),
    [sym_self] = ACTIONS(2701),
    [sym_super] = ACTIONS(2701),
    [sym_crate] = ACTIONS(2701),
    [sym_metavariable] = ACTIONS(2695),
  },
  [688] = {
    [sym__token_pattern] = STATE(1366),
    [sym_token_tree_pattern] = STATE(1366),
    [sym_token_binding_pattern] = STATE(1366),
    [sym_token_repetition_pattern] = STATE(1366),
    [sym__literal] = STATE(1366),
    [sym_string_literal] = STATE(1366),
    [sym_boolean_literal] = STATE(1366),
    [aux_sym_token_tree_pattern_repeat1] = STATE(1366),
    [sym_raw_string_literal] = ACTIONS(2703),
    [sym_float_literal] = ACTIONS(2703),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2703),
    [anon_sym_LPAREN] = ACTIONS(2681),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_EQ_GT] = ACTIONS(2703),
    [anon_sym_LBRACK] = ACTIONS(2687),
    [anon_sym_RBRACK] = ACTIONS(2683),
    [anon_sym_COLON] = ACTIONS(2705),
    [anon_sym_DOLLAR] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(2705),
    [anon_sym_STAR] = ACTIONS(2705),
    [anon_sym_COMMA] = ACTIONS(2703),
    [anon_sym_u8] = ACTIONS(2693),
    [anon_sym_i8] = ACTIONS(2693),
    [anon_sym_u16] = ACTIONS(2693),
    [anon_sym_i16] = ACTIONS(2693),
    [anon_sym_u32] = ACTIONS(2693),
    [anon_sym_i32] = ACTIONS(2693),
    [anon_sym_u64] = ACTIONS(2693),
    [anon_sym_i64] = ACTIONS(2693),
    [anon_sym_u128] = ACTIONS(2693),
    [anon_sym_i128] = ACTIONS(2693),
    [anon_sym_isize] = ACTIONS(2693),
    [anon_sym_usize] = ACTIONS(2693),
    [anon_sym_f32] = ACTIONS(2693),
    [anon_sym_f64] = ACTIONS(2693),
    [anon_sym_bool] = ACTIONS(2693),
    [anon_sym_str] = ACTIONS(2693),
    [anon_sym_char] = ACTIONS(2693),
    [anon_sym__] = ACTIONS(2705),
    [anon_sym_AMP] = ACTIONS(2705),
    [anon_sym_DASH] = ACTIONS(2705),
    [anon_sym_DOT] = ACTIONS(2705),
    [anon_sym_DASH_EQ] = ACTIONS(2703),
    [anon_sym_DASH_GT] = ACTIONS(2703),
    [anon_sym_COLON_COLON] = ACTIONS(2703),
    [anon_sym_BANG] = ACTIONS(2705),
    [anon_sym_BANG_EQ] = ACTIONS(2703),
    [anon_sym_AT] = ACTIONS(2703),
    [anon_sym_STAR_EQ] = ACTIONS(2703),
    [anon_sym_SLASH] = ACTIONS(2705),
    [anon_sym_SLASH_EQ] = ACTIONS(2703),
    [anon_sym_AMP_AMP] = ACTIONS(2703),
    [anon_sym_AMP_EQ] = ACTIONS(2703),
    [anon_sym_POUND] = ACTIONS(2703),
    [anon_sym_PERCENT] = ACTIONS(2705),
    [anon_sym_PERCENT_EQ] = ACTIONS(2703),
    [anon_sym_CARET] = ACTIONS(2705),
    [anon_sym_CARET_EQ] = ACTIONS(2703),
    [anon_sym_PLUS_EQ] = ACTIONS(2703),
    [anon_sym_LT] = ACTIONS(2705),
    [anon_sym_LT_LT] = ACTIONS(2705),
    [anon_sym_LT_LT_EQ] = ACTIONS(2703),
    [anon_sym_LT_EQ] = ACTIONS(2703),
    [anon_sym_EQ] = ACTIONS(2705),
    [anon_sym_EQ_EQ] = ACTIONS(2703),
    [anon_sym_GT] = ACTIONS(2705),
    [anon_sym_GT_EQ] = ACTIONS(2703),
    [anon_sym_GT_GT] = ACTIONS(2705),
    [anon_sym_GT_GT_EQ] = ACTIONS(2703),
    [anon_sym_PIPE] = ACTIONS(2705),
    [anon_sym_PIPE_EQ] = ACTIONS(2703),
    [anon_sym_PIPE_PIPE] = ACTIONS(2703),
    [anon_sym_TILDE] = ACTIONS(2703),
    [anon_sym_QMARK] = ACTIONS(2703),
    [anon_sym_SQUOTE] = ACTIONS(2705),
    [anon_sym_DOT_DOT] = ACTIONS(2705),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2703),
    [anon_sym_as] = ACTIONS(2705),
    [anon_sym_break] = ACTIONS(2705),
    [anon_sym_const] = ACTIONS(2705),
    [anon_sym_continue] = ACTIONS(2705),
    [anon_sym_default] = ACTIONS(2705),
    [anon_sym_enum] = ACTIONS(2705),
    [anon_sym_fn] = ACTIONS(2705),
    [anon_sym_for] = ACTIONS(2705),
    [anon_sym_if] = ACTIONS(2705),
    [anon_sym_impl] = ACTIONS(2705),
    [anon_sym_let] = ACTIONS(2705),
    [anon_sym_loop] = ACTIONS(2705),
    [anon_sym_match] = ACTIONS(2705),
    [anon_sym_mod] = ACTIONS(2705),
    [anon_sym_pub] = ACTIONS(2705),
    [anon_sym_return] = ACTIONS(2705),
    [anon_sym_static] = ACTIONS(2705),
    [anon_sym_struct] = ACTIONS(2705),
    [anon_sym_trait] = ACTIONS(2705),
    [anon_sym_type] = ACTIONS(2705),
    [anon_sym_union] = ACTIONS(2705),
    [anon_sym_unsafe] = ACTIONS(2705),
    [anon_sym_use] = ACTIONS(2705),
    [anon_sym_where] = ACTIONS(2705),
    [anon_sym_while] = ACTIONS(2705),
    [sym_mutable_specifier] = ACTIONS(2705),
    [sym_integer_literal] = ACTIONS(2703),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(2703),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2705),
    [sym_self] = ACTIONS(2705),
    [sym_super] = ACTIONS(2705),
    [sym_crate] = ACTIONS(2705),
    [sym_metavariable] = ACTIONS(2695),
  },
  [689] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_RPAREN] = ACTIONS(2709),
    [sym_line_comment] = ACTIONS(7),
  },
  [690] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(2711),
    [sym_line_comment] = ACTIONS(7),
  },
  [691] = {
    [sym_macro_rule] = STATE(1370),
    [sym_token_tree_pattern] = STATE(690),
    [aux_sym_macro_definition_repeat1] = STATE(1371),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_RPAREN] = ACTIONS(2709),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_LBRACK] = ACTIONS(1485),
    [sym_line_comment] = ACTIONS(7),
  },
  [692] = {
    [sym_raw_string_literal] = ACTIONS(2713),
    [sym_float_literal] = ACTIONS(2713),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(2713),
    [anon_sym_SEMI] = ACTIONS(2713),
    [anon_sym_macro_rules_BANG] = ACTIONS(2713),
    [anon_sym_LPAREN] = ACTIONS(2713),
    [anon_sym_LBRACE] = ACTIONS(2713),
    [anon_sym_RBRACE] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_STAR] = ACTIONS(2713),
    [anon_sym_u8] = ACTIONS(2715),
    [anon_sym_i8] = ACTIONS(2715),
    [anon_sym_u16] = ACTIONS(2715),
    [anon_sym_i16] = ACTIONS(2715),
    [anon_sym_u32] = ACTIONS(2715),
    [anon_sym_i32] = ACTIONS(2715),
    [anon_sym_u64] = ACTIONS(2715),
    [anon_sym_i64] = ACTIONS(2715),
    [anon_sym_u128] = ACTIONS(2715),
    [anon_sym_i128] = ACTIONS(2715),
    [anon_sym_isize] = ACTIONS(2715),
    [anon_sym_usize] = ACTIONS(2715),
    [anon_sym_f32] = ACTIONS(2715),
    [anon_sym_f64] = ACTIONS(2715),
    [anon_sym_bool] = ACTIONS(2715),
    [anon_sym_str] = ACTIONS(2715),
    [anon_sym_char] = ACTIONS(2715),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2713),
    [anon_sym_POUND] = ACTIONS(2713),
    [anon_sym_LT] = ACTIONS(2713),
    [anon_sym_PIPE] = ACTIONS(2713),
    [anon_sym_SQUOTE] = ACTIONS(2715),
    [anon_sym_DOT_DOT] = ACTIONS(2713),
    [anon_sym_break] = ACTIONS(2715),
    [anon_sym_const] = ACTIONS(2715),
    [anon_sym_continue] = ACTIONS(2715),
    [anon_sym_default] = ACTIONS(2715),
    [anon_sym_enum] = ACTIONS(2715),
    [anon_sym_fn] = ACTIONS(2715),
    [anon_sym_for] = ACTIONS(2715),
    [anon_sym_if] = ACTIONS(2715),
    [anon_sym_impl] = ACTIONS(2715),
    [anon_sym_let] = ACTIONS(2715),
    [anon_sym_loop] = ACTIONS(2715),
    [anon_sym_match] = ACTIONS(2715),
    [anon_sym_mod] = ACTIONS(2715),
    [anon_sym_pub] = ACTIONS(2715),
    [anon_sym_return] = ACTIONS(2715),
    [anon_sym_static] = ACTIONS(2715),
    [anon_sym_struct] = ACTIONS(2715),
    [anon_sym_trait] = ACTIONS(2715),
    [anon_sym_type] = ACTIONS(2715),
    [anon_sym_union] = ACTIONS(2715),
    [anon_sym_unsafe] = ACTIONS(2715),
    [anon_sym_use] = ACTIONS(2715),
    [anon_sym_while] = ACTIONS(2715),
    [anon_sym_extern] = ACTIONS(2715),
    [anon_sym_move] = ACTIONS(2715),
    [sym_integer_literal] = ACTIONS(2713),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2713),
    [sym_char_literal] = ACTIONS(2713),
    [anon_sym_true] = ACTIONS(2715),
    [anon_sym_false] = ACTIONS(2715),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2715),
    [sym_self] = ACTIONS(2715),
    [sym_super] = ACTIONS(2715),
    [sym_crate] = ACTIONS(2715),
    [sym_metavariable] = ACTIONS(2713),
  },
  [693] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_RBRACE] = ACTIONS(2697),
    [sym_line_comment] = ACTIONS(7),
  },
  [694] = {
    [sym_macro_rule] = STATE(1372),
    [sym_token_tree_pattern] = STATE(690),
    [aux_sym_macro_definition_repeat1] = STATE(1373),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_RBRACE] = ACTIONS(2697),
    [anon_sym_LBRACK] = ACTIONS(1485),
    [sym_line_comment] = ACTIONS(7),
  },
  [695] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1567),
    [anon_sym_macro_rules_BANG] = ACTIONS(1567),
    [anon_sym_LPAREN] = ACTIONS(1567),
    [anon_sym_RPAREN] = ACTIONS(1567),
    [anon_sym_LBRACE] = ACTIONS(1567),
    [anon_sym_RBRACE] = ACTIONS(1567),
    [anon_sym_LBRACK] = ACTIONS(1567),
    [anon_sym_RBRACK] = ACTIONS(1567),
    [anon_sym_PLUS] = ACTIONS(1569),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_COMMA] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1569),
    [anon_sym_DASH] = ACTIONS(1569),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_DASH_EQ] = ACTIONS(1567),
    [anon_sym_BANG_EQ] = ACTIONS(1567),
    [anon_sym_STAR_EQ] = ACTIONS(1567),
    [anon_sym_SLASH] = ACTIONS(1569),
    [anon_sym_SLASH_EQ] = ACTIONS(1567),
    [anon_sym_AMP_AMP] = ACTIONS(1567),
    [anon_sym_AMP_EQ] = ACTIONS(1567),
    [anon_sym_POUND] = ACTIONS(1567),
    [anon_sym_PERCENT] = ACTIONS(1569),
    [anon_sym_PERCENT_EQ] = ACTIONS(1567),
    [anon_sym_CARET] = ACTIONS(1569),
    [anon_sym_CARET_EQ] = ACTIONS(1567),
    [anon_sym_PLUS_EQ] = ACTIONS(1567),
    [anon_sym_LT] = ACTIONS(1569),
    [anon_sym_LT_LT] = ACTIONS(1569),
    [anon_sym_LT_LT_EQ] = ACTIONS(1567),
    [anon_sym_LT_EQ] = ACTIONS(1567),
    [anon_sym_EQ] = ACTIONS(1569),
    [anon_sym_EQ_EQ] = ACTIONS(1567),
    [anon_sym_GT] = ACTIONS(1569),
    [anon_sym_GT_EQ] = ACTIONS(1567),
    [anon_sym_GT_GT] = ACTIONS(1569),
    [anon_sym_GT_GT_EQ] = ACTIONS(1567),
    [anon_sym_PIPE] = ACTIONS(1569),
    [anon_sym_PIPE_EQ] = ACTIONS(1567),
    [anon_sym_PIPE_PIPE] = ACTIONS(1567),
    [anon_sym_QMARK] = ACTIONS(1567),
    [anon_sym_DOT_DOT] = ACTIONS(1569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1567),
    [anon_sym_as] = ACTIONS(1569),
    [anon_sym_const] = ACTIONS(1569),
    [anon_sym_default] = ACTIONS(1569),
    [anon_sym_enum] = ACTIONS(1569),
    [anon_sym_fn] = ACTIONS(1569),
    [anon_sym_impl] = ACTIONS(1569),
    [anon_sym_let] = ACTIONS(1569),
    [anon_sym_mod] = ACTIONS(1569),
    [anon_sym_pub] = ACTIONS(1569),
    [anon_sym_static] = ACTIONS(1569),
    [anon_sym_struct] = ACTIONS(1569),
    [anon_sym_trait] = ACTIONS(1569),
    [anon_sym_type] = ACTIONS(1569),
    [anon_sym_union] = ACTIONS(1569),
    [anon_sym_unsafe] = ACTIONS(1569),
    [anon_sym_use] = ACTIONS(1569),
    [anon_sym_extern] = ACTIONS(1569),
    [anon_sym_else] = ACTIONS(1569),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1569),
  },
  [696] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(2717),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(623),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(623),
    [anon_sym_PLUS_EQ] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(623),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(643),
    [anon_sym_as] = ACTIONS(645),
    [sym_line_comment] = ACTIONS(7),
  },
  [697] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1375),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(1375),
    [sym_macro_invocation] = STATE(1375),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1375),
    [sym_unary_expression] = STATE(1375),
    [sym_try_expression] = STATE(1375),
    [sym_reference_expression] = STATE(1375),
    [sym_binary_expression] = STATE(1375),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1375),
    [sym_call_expression] = STATE(1375),
    [sym_array_expression] = STATE(1375),
    [sym_parenthesized_expression] = STATE(1375),
    [sym_tuple_expression] = STATE(1375),
    [sym_unit_expression] = STATE(1375),
    [sym_struct_expression] = STATE(1375),
    [sym_if_expression] = STATE(1375),
    [sym_if_let_expression] = STATE(1375),
    [sym_match_expression] = STATE(1375),
    [sym_while_expression] = STATE(1375),
    [sym_while_let_expression] = STATE(1375),
    [sym_loop_expression] = STATE(1375),
    [sym_for_expression] = STATE(1375),
    [sym_closure_expression] = STATE(1375),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1375),
    [sym_continue_expression] = STATE(1375),
    [sym_index_expression] = STATE(1375),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1375),
    [sym_block] = STATE(1375),
    [sym__literal] = STATE(1375),
    [sym_string_literal] = STATE(1375),
    [sym_boolean_literal] = STATE(1375),
    [sym_raw_string_literal] = ACTIONS(2719),
    [sym_float_literal] = ACTIONS(2719),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(2719),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(2719),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [698] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(2721),
    [sym_line_comment] = ACTIONS(7),
  },
  [699] = {
    [sym_else_tail] = STATE(1378),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2012),
    [anon_sym_RPAREN] = ACTIONS(2012),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_PLUS] = ACTIONS(2014),
    [anon_sym_STAR] = ACTIONS(2014),
    [anon_sym_COMMA] = ACTIONS(2012),
    [anon_sym_AMP] = ACTIONS(2014),
    [anon_sym_DASH] = ACTIONS(2014),
    [anon_sym_DOT] = ACTIONS(2014),
    [anon_sym_DASH_EQ] = ACTIONS(2012),
    [anon_sym_BANG_EQ] = ACTIONS(2012),
    [anon_sym_STAR_EQ] = ACTIONS(2012),
    [anon_sym_SLASH] = ACTIONS(2014),
    [anon_sym_SLASH_EQ] = ACTIONS(2012),
    [anon_sym_AMP_AMP] = ACTIONS(2012),
    [anon_sym_AMP_EQ] = ACTIONS(2012),
    [anon_sym_PERCENT] = ACTIONS(2014),
    [anon_sym_PERCENT_EQ] = ACTIONS(2012),
    [anon_sym_CARET] = ACTIONS(2014),
    [anon_sym_CARET_EQ] = ACTIONS(2012),
    [anon_sym_PLUS_EQ] = ACTIONS(2012),
    [anon_sym_LT] = ACTIONS(2014),
    [anon_sym_LT_LT] = ACTIONS(2014),
    [anon_sym_LT_LT_EQ] = ACTIONS(2012),
    [anon_sym_LT_EQ] = ACTIONS(2012),
    [anon_sym_EQ] = ACTIONS(2014),
    [anon_sym_EQ_EQ] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2014),
    [anon_sym_GT_EQ] = ACTIONS(2012),
    [anon_sym_GT_GT] = ACTIONS(2014),
    [anon_sym_GT_GT_EQ] = ACTIONS(2012),
    [anon_sym_PIPE] = ACTIONS(2014),
    [anon_sym_PIPE_EQ] = ACTIONS(2012),
    [anon_sym_PIPE_PIPE] = ACTIONS(2012),
    [anon_sym_QMARK] = ACTIONS(2012),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2012),
    [anon_sym_as] = ACTIONS(2012),
    [anon_sym_else] = ACTIONS(2723),
    [sym_line_comment] = ACTIONS(7),
  },
  [700] = {
    [sym_attribute_item] = STATE(1049),
    [sym_bracketed_type] = STATE(1041),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(1042),
    [sym_scoped_identifier] = STATE(1043),
    [sym_scoped_type_identifier] = STATE(1044),
    [sym_match_arm] = STATE(1381),
    [sym_last_match_arm] = STATE(1380),
    [sym_match_pattern] = STATE(1046),
    [sym__pattern] = STATE(1047),
    [sym_tuple_pattern] = STATE(1047),
    [sym_tuple_struct_pattern] = STATE(1047),
    [sym_struct_pattern] = STATE(1047),
    [sym_remaining_field_pattern] = STATE(1047),
    [sym_mut_pattern] = STATE(1047),
    [sym_range_pattern] = STATE(1047),
    [sym_ref_pattern] = STATE(1047),
    [sym_captured_pattern] = STATE(1047),
    [sym_reference_pattern] = STATE(1047),
    [sym__literal] = STATE(1048),
    [sym_string_literal] = STATE(1048),
    [sym_boolean_literal] = STATE(1048),
    [aux_sym_enum_variant_list_repeat1] = STATE(1049),
    [aux_sym_match_expression_repeat1] = STATE(1381),
    [sym_raw_string_literal] = ACTIONS(2070),
    [sym_float_literal] = ACTIONS(2070),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2072),
    [anon_sym_RBRACE] = ACTIONS(2725),
    [anon_sym_u8] = ACTIONS(2076),
    [anon_sym_i8] = ACTIONS(2076),
    [anon_sym_u16] = ACTIONS(2076),
    [anon_sym_i16] = ACTIONS(2076),
    [anon_sym_u32] = ACTIONS(2076),
    [anon_sym_i32] = ACTIONS(2076),
    [anon_sym_u64] = ACTIONS(2076),
    [anon_sym_i64] = ACTIONS(2076),
    [anon_sym_u128] = ACTIONS(2076),
    [anon_sym_i128] = ACTIONS(2076),
    [anon_sym_isize] = ACTIONS(2076),
    [anon_sym_usize] = ACTIONS(2076),
    [anon_sym_f32] = ACTIONS(2076),
    [anon_sym_f64] = ACTIONS(2076),
    [anon_sym_bool] = ACTIONS(2076),
    [anon_sym_str] = ACTIONS(2076),
    [anon_sym_char] = ACTIONS(2076),
    [anon_sym__] = ACTIONS(2078),
    [anon_sym_AMP] = ACTIONS(2080),
    [anon_sym_COLON_COLON] = ACTIONS(2082),
    [anon_sym_POUND] = ACTIONS(2084),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(2086),
    [sym_mutable_specifier] = ACTIONS(2088),
    [anon_sym_ref] = ACTIONS(2090),
    [sym_integer_literal] = ACTIONS(2070),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(769),
    [sym_char_literal] = ACTIONS(2070),
    [anon_sym_true] = ACTIONS(2092),
    [anon_sym_false] = ACTIONS(2092),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2094),
    [sym_self] = ACTIONS(2096),
    [sym_super] = ACTIONS(2096),
    [sym_crate] = ACTIONS(2096),
    [sym_metavariable] = ACTIONS(2098),
  },
  [701] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(2727),
    [sym_line_comment] = ACTIONS(7),
  },
  [702] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2212),
    [anon_sym_LPAREN] = ACTIONS(2212),
    [anon_sym_RPAREN] = ACTIONS(2212),
    [anon_sym_LBRACE] = ACTIONS(2212),
    [anon_sym_RBRACE] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2212),
    [anon_sym_RBRACK] = ACTIONS(2212),
    [anon_sym_PLUS] = ACTIONS(2214),
    [anon_sym_STAR] = ACTIONS(2214),
    [anon_sym_COMMA] = ACTIONS(2212),
    [anon_sym_AMP] = ACTIONS(2214),
    [anon_sym_DASH] = ACTIONS(2214),
    [anon_sym_DOT] = ACTIONS(2214),
    [anon_sym_DASH_EQ] = ACTIONS(2212),
    [anon_sym_BANG_EQ] = ACTIONS(2212),
    [anon_sym_STAR_EQ] = ACTIONS(2212),
    [anon_sym_SLASH] = ACTIONS(2214),
    [anon_sym_SLASH_EQ] = ACTIONS(2212),
    [anon_sym_AMP_AMP] = ACTIONS(2212),
    [anon_sym_AMP_EQ] = ACTIONS(2212),
    [anon_sym_PERCENT] = ACTIONS(2214),
    [anon_sym_PERCENT_EQ] = ACTIONS(2212),
    [anon_sym_CARET] = ACTIONS(2214),
    [anon_sym_CARET_EQ] = ACTIONS(2212),
    [anon_sym_PLUS_EQ] = ACTIONS(2212),
    [anon_sym_LT] = ACTIONS(2214),
    [anon_sym_LT_LT] = ACTIONS(2214),
    [anon_sym_LT_LT_EQ] = ACTIONS(2212),
    [anon_sym_LT_EQ] = ACTIONS(2212),
    [anon_sym_EQ] = ACTIONS(2214),
    [anon_sym_EQ_EQ] = ACTIONS(2212),
    [anon_sym_GT] = ACTIONS(2214),
    [anon_sym_GT_EQ] = ACTIONS(2212),
    [anon_sym_GT_GT] = ACTIONS(2214),
    [anon_sym_GT_GT_EQ] = ACTIONS(2212),
    [anon_sym_PIPE] = ACTIONS(2214),
    [anon_sym_PIPE_EQ] = ACTIONS(2212),
    [anon_sym_PIPE_PIPE] = ACTIONS(2212),
    [anon_sym_QMARK] = ACTIONS(2212),
    [anon_sym_DOT_DOT] = ACTIONS(2214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2212),
    [anon_sym_as] = ACTIONS(2212),
    [sym_line_comment] = ACTIONS(7),
  },
  [703] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(2220),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_BANG_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH] = ACTIONS(563),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(563),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_LT] = ACTIONS(577),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(581),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(577),
    [anon_sym_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(589),
    [anon_sym_as] = ACTIONS(591),
    [sym_line_comment] = ACTIONS(7),
  },
  [704] = {
    [sym_token_tree] = STATE(1385),
    [sym_token_repetition] = STATE(1385),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1384),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1384),
    [sym_macro_invocation] = STATE(1384),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_try_expression] = STATE(1384),
    [sym_reference_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1384),
    [sym_call_expression] = STATE(1384),
    [sym_array_expression] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple_expression] = STATE(1384),
    [sym_unit_expression] = STATE(1384),
    [sym_struct_expression] = STATE(1384),
    [sym_if_expression] = STATE(1384),
    [sym_if_let_expression] = STATE(1384),
    [sym_match_expression] = STATE(1384),
    [sym_while_expression] = STATE(1384),
    [sym_while_let_expression] = STATE(1384),
    [sym_loop_expression] = STATE(1384),
    [sym_for_expression] = STATE(1384),
    [sym_closure_expression] = STATE(1384),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1384),
    [sym_continue_expression] = STATE(1384),
    [sym_index_expression] = STATE(1384),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1384),
    [sym_block] = STATE(1384),
    [sym__literal] = STATE(1178),
    [sym_string_literal] = STATE(1178),
    [sym_boolean_literal] = STATE(1178),
    [aux_sym_token_tree_repeat1] = STATE(1385),
    [sym_raw_string_literal] = ACTIONS(2275),
    [sym_float_literal] = ACTIONS(2275),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2729),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_RPAREN] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2283),
    [anon_sym_EQ_GT] = ACTIONS(2729),
    [anon_sym_LBRACK] = ACTIONS(2285),
    [anon_sym_COLON] = ACTIONS(2733),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(2729),
    [anon_sym_u8] = ACTIONS(2293),
    [anon_sym_i8] = ACTIONS(2293),
    [anon_sym_u16] = ACTIONS(2293),
    [anon_sym_i16] = ACTIONS(2293),
    [anon_sym_u32] = ACTIONS(2293),
    [anon_sym_i32] = ACTIONS(2293),
    [anon_sym_u64] = ACTIONS(2293),
    [anon_sym_i64] = ACTIONS(2293),
    [anon_sym_u128] = ACTIONS(2293),
    [anon_sym_i128] = ACTIONS(2293),
    [anon_sym_isize] = ACTIONS(2293),
    [anon_sym_usize] = ACTIONS(2293),
    [anon_sym_f32] = ACTIONS(2293),
    [anon_sym_f64] = ACTIONS(2293),
    [anon_sym_bool] = ACTIONS(2293),
    [anon_sym_str] = ACTIONS(2293),
    [anon_sym_char] = ACTIONS(2293),
    [anon_sym__] = ACTIONS(2733),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_DASH] = ACTIONS(2291),
    [anon_sym_DOT] = ACTIONS(2733),
    [anon_sym_DASH_EQ] = ACTIONS(2729),
    [anon_sym_DASH_GT] = ACTIONS(2729),
    [anon_sym_COLON_COLON] = ACTIONS(2729),
    [anon_sym_BANG] = ACTIONS(2297),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_AT] = ACTIONS(2729),
    [anon_sym_STAR_EQ] = ACTIONS(2729),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_SLASH_EQ] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_AMP_EQ] = ACTIONS(2729),
    [anon_sym_POUND] = ACTIONS(2729),
    [anon_sym_PERCENT] = ACTIONS(2733),
    [anon_sym_PERCENT_EQ] = ACTIONS(2729),
    [anon_sym_CARET] = ACTIONS(2733),
    [anon_sym_CARET_EQ] = ACTIONS(2729),
    [anon_sym_PLUS_EQ] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_LT_LT] = ACTIONS(2733),
    [anon_sym_LT_LT_EQ] = ACTIONS(2729),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2733),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2733),
    [anon_sym_GT_EQ] = ACTIONS(2729),
    [anon_sym_GT_GT] = ACTIONS(2733),
    [anon_sym_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_PIPE] = ACTIONS(2301),
    [anon_sym_PIPE_EQ] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_TILDE] = ACTIONS(2729),
    [anon_sym_QMARK] = ACTIONS(2729),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(2305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2729),
    [anon_sym_as] = ACTIONS(2733),
    [anon_sym_break] = ACTIONS(2307),
    [anon_sym_const] = ACTIONS(2733),
    [anon_sym_continue] = ACTIONS(2309),
    [anon_sym_default] = ACTIONS(2311),
    [anon_sym_enum] = ACTIONS(2733),
    [anon_sym_fn] = ACTIONS(2733),
    [anon_sym_for] = ACTIONS(2313),
    [anon_sym_if] = ACTIONS(2315),
    [anon_sym_impl] = ACTIONS(2733),
    [anon_sym_let] = ACTIONS(2733),
    [anon_sym_loop] = ACTIONS(2317),
    [anon_sym_match] = ACTIONS(2319),
    [anon_sym_mod] = ACTIONS(2733),
    [anon_sym_pub] = ACTIONS(2733),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_static] = ACTIONS(2733),
    [anon_sym_struct] = ACTIONS(2733),
    [anon_sym_trait] = ACTIONS(2733),
    [anon_sym_type] = ACTIONS(2733),
    [anon_sym_union] = ACTIONS(2311),
    [anon_sym_unsafe] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(2733),
    [anon_sym_where] = ACTIONS(2733),
    [anon_sym_while] = ACTIONS(2325),
    [sym_mutable_specifier] = ACTIONS(2733),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(2275),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(2275),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2331),
    [sym_self] = ACTIONS(2333),
    [sym_super] = ACTIONS(2733),
    [sym_crate] = ACTIONS(2733),
    [sym_metavariable] = ACTIONS(2335),
  },
  [705] = {
    [sym__statement] = STATE(1387),
    [sym_empty_statement] = STATE(1387),
    [sym__expression_statement] = STATE(1387),
    [sym_macro_definition] = STATE(1387),
    [sym_token_tree] = STATE(1388),
    [sym_token_repetition] = STATE(1388),
    [sym_attribute_item] = STATE(1387),
    [sym_inner_attribute_item] = STATE(1387),
    [sym_mod_item] = STATE(1387),
    [sym_foreign_mod_item] = STATE(1387),
    [sym_struct_item] = STATE(1387),
    [sym_union_item] = STATE(1387),
    [sym_enum_item] = STATE(1387),
    [sym_extern_crate_declaration] = STATE(1387),
    [sym_const_item] = STATE(1387),
    [sym_static_item] = STATE(1387),
    [sym_type_item] = STATE(1387),
    [sym_function_item] = STATE(1387),
    [sym_function_signature_item] = STATE(1387),
    [sym_function_modifiers] = STATE(47),
    [sym_impl_item] = STATE(1387),
    [sym_trait_item] = STATE(1387),
    [sym_associated_type] = STATE(1387),
    [sym_let_declaration] = STATE(1387),
    [sym_use_declaration] = STATE(1387),
    [sym_extern_modifier] = STATE(48),
    [sym_visibility_modifier] = STATE(49),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1386),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1386),
    [sym_macro_invocation] = STATE(53),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1386),
    [sym_unary_expression] = STATE(1386),
    [sym_try_expression] = STATE(1386),
    [sym_reference_expression] = STATE(1386),
    [sym_binary_expression] = STATE(1386),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1386),
    [sym_call_expression] = STATE(1386),
    [sym_array_expression] = STATE(1386),
    [sym_parenthesized_expression] = STATE(1386),
    [sym_tuple_expression] = STATE(1386),
    [sym_unit_expression] = STATE(1386),
    [sym_struct_expression] = STATE(1386),
    [sym_if_expression] = STATE(57),
    [sym_if_let_expression] = STATE(57),
    [sym_match_expression] = STATE(57),
    [sym_while_expression] = STATE(57),
    [sym_while_let_expression] = STATE(57),
    [sym_loop_expression] = STATE(57),
    [sym_for_expression] = STATE(57),
    [sym_closure_expression] = STATE(1386),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(59),
    [sym_break_expression] = STATE(1386),
    [sym_continue_expression] = STATE(1386),
    [sym_index_expression] = STATE(1386),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(57),
    [sym_block] = STATE(57),
    [sym__literal] = STATE(1216),
    [sym_string_literal] = STATE(1216),
    [sym_boolean_literal] = STATE(1216),
    [aux_sym_source_file_repeat1] = STATE(1387),
    [aux_sym_token_tree_repeat1] = STATE(1388),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_raw_string_literal] = ACTIONS(2337),
    [sym_float_literal] = ACTIONS(2337),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(2341),
    [anon_sym_LBRACE] = ACTIONS(2343),
    [anon_sym_RBRACE] = ACTIONS(2731),
    [anon_sym_EQ_GT] = ACTIONS(2735),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [anon_sym_COLON] = ACTIONS(2737),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2737),
    [anon_sym_STAR] = ACTIONS(2351),
    [anon_sym_COMMA] = ACTIONS(2735),
    [anon_sym_u8] = ACTIONS(2353),
    [anon_sym_i8] = ACTIONS(2353),
    [anon_sym_u16] = ACTIONS(2353),
    [anon_sym_i16] = ACTIONS(2353),
    [anon_sym_u32] = ACTIONS(2353),
    [anon_sym_i32] = ACTIONS(2353),
    [anon_sym_u64] = ACTIONS(2353),
    [anon_sym_i64] = ACTIONS(2353),
    [anon_sym_u128] = ACTIONS(2353),
    [anon_sym_i128] = ACTIONS(2353),
    [anon_sym_isize] = ACTIONS(2353),
    [anon_sym_usize] = ACTIONS(2353),
    [anon_sym_f32] = ACTIONS(2353),
    [anon_sym_f64] = ACTIONS(2353),
    [anon_sym_bool] = ACTIONS(2353),
    [anon_sym_str] = ACTIONS(2353),
    [anon_sym_char] = ACTIONS(2353),
    [anon_sym__] = ACTIONS(2737),
    [anon_sym_AMP] = ACTIONS(2355),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_DOT] = ACTIONS(2737),
    [anon_sym_DASH_EQ] = ACTIONS(2735),
    [anon_sym_DASH_GT] = ACTIONS(2735),
    [anon_sym_COLON_COLON] = ACTIONS(2735),
    [anon_sym_BANG] = ACTIONS(2357),
    [anon_sym_BANG_EQ] = ACTIONS(2735),
    [anon_sym_AT] = ACTIONS(2735),
    [anon_sym_STAR_EQ] = ACTIONS(2735),
    [anon_sym_SLASH] = ACTIONS(2737),
    [anon_sym_SLASH_EQ] = ACTIONS(2735),
    [anon_sym_AMP_AMP] = ACTIONS(2735),
    [anon_sym_AMP_EQ] = ACTIONS(2735),
    [anon_sym_POUND] = ACTIONS(2359),
    [anon_sym_PERCENT] = ACTIONS(2737),
    [anon_sym_PERCENT_EQ] = ACTIONS(2735),
    [anon_sym_CARET] = ACTIONS(2737),
    [anon_sym_CARET_EQ] = ACTIONS(2735),
    [anon_sym_PLUS_EQ] = ACTIONS(2735),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_LT_LT] = ACTIONS(2737),
    [anon_sym_LT_LT_EQ] = ACTIONS(2735),
    [anon_sym_LT_EQ] = ACTIONS(2735),
    [anon_sym_EQ] = ACTIONS(2737),
    [anon_sym_EQ_EQ] = ACTIONS(2735),
    [anon_sym_GT] = ACTIONS(2737),
    [anon_sym_GT_EQ] = ACTIONS(2735),
    [anon_sym_GT_GT] = ACTIONS(2737),
    [anon_sym_GT_GT_EQ] = ACTIONS(2735),
    [anon_sym_PIPE] = ACTIONS(2301),
    [anon_sym_PIPE_EQ] = ACTIONS(2735),
    [anon_sym_PIPE_PIPE] = ACTIONS(2735),
    [anon_sym_TILDE] = ACTIONS(2735),
    [anon_sym_QMARK] = ACTIONS(2735),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(2361),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2735),
    [anon_sym_as] = ACTIONS(2737),
    [anon_sym_break] = ACTIONS(2363),
    [anon_sym_const] = ACTIONS(2365),
    [anon_sym_continue] = ACTIONS(2367),
    [anon_sym_default] = ACTIONS(2369),
    [anon_sym_enum] = ACTIONS(2371),
    [anon_sym_fn] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2375),
    [anon_sym_if] = ACTIONS(2377),
    [anon_sym_impl] = ACTIONS(2379),
    [anon_sym_let] = ACTIONS(2381),
    [anon_sym_loop] = ACTIONS(2383),
    [anon_sym_match] = ACTIONS(2385),
    [anon_sym_mod] = ACTIONS(2387),
    [anon_sym_pub] = ACTIONS(2389),
    [anon_sym_return] = ACTIONS(2391),
    [anon_sym_static] = ACTIONS(2393),
    [anon_sym_struct] = ACTIONS(2395),
    [anon_sym_trait] = ACTIONS(2397),
    [anon_sym_type] = ACTIONS(2399),
    [anon_sym_union] = ACTIONS(2401),
    [anon_sym_unsafe] = ACTIONS(2403),
    [anon_sym_use] = ACTIONS(2405),
    [anon_sym_where] = ACTIONS(2737),
    [anon_sym_while] = ACTIONS(2407),
    [anon_sym_extern] = ACTIONS(85),
    [sym_mutable_specifier] = ACTIONS(2737),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(2337),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(2337),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2409),
    [sym_self] = ACTIONS(2411),
    [sym_super] = ACTIONS(2737),
    [sym_crate] = ACTIONS(2737),
    [sym_metavariable] = ACTIONS(2413),
  },
  [706] = {
    [sym_token_tree] = STATE(1390),
    [sym_token_repetition] = STATE(1390),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1389),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1389),
    [sym_macro_invocation] = STATE(1389),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1389),
    [sym_unary_expression] = STATE(1389),
    [sym_try_expression] = STATE(1389),
    [sym_reference_expression] = STATE(1389),
    [sym_binary_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1389),
    [sym_call_expression] = STATE(1389),
    [sym_array_expression] = STATE(1389),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_tuple_expression] = STATE(1389),
    [sym_unit_expression] = STATE(1389),
    [sym_struct_expression] = STATE(1389),
    [sym_if_expression] = STATE(1389),
    [sym_if_let_expression] = STATE(1389),
    [sym_match_expression] = STATE(1389),
    [sym_while_expression] = STATE(1389),
    [sym_while_let_expression] = STATE(1389),
    [sym_loop_expression] = STATE(1389),
    [sym_for_expression] = STATE(1389),
    [sym_closure_expression] = STATE(1389),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1389),
    [sym_continue_expression] = STATE(1389),
    [sym_index_expression] = STATE(1389),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1389),
    [sym_block] = STATE(1389),
    [sym__literal] = STATE(1178),
    [sym_string_literal] = STATE(1178),
    [sym_boolean_literal] = STATE(1178),
    [aux_sym_token_tree_repeat1] = STATE(1390),
    [sym_raw_string_literal] = ACTIONS(2275),
    [sym_float_literal] = ACTIONS(2275),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2739),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_LBRACE] = ACTIONS(2283),
    [anon_sym_EQ_GT] = ACTIONS(2739),
    [anon_sym_LBRACK] = ACTIONS(2285),
    [anon_sym_RBRACK] = ACTIONS(2731),
    [anon_sym_COLON] = ACTIONS(2741),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2741),
    [anon_sym_STAR] = ACTIONS(2419),
    [anon_sym_COMMA] = ACTIONS(2739),
    [anon_sym_u8] = ACTIONS(2293),
    [anon_sym_i8] = ACTIONS(2293),
    [anon_sym_u16] = ACTIONS(2293),
    [anon_sym_i16] = ACTIONS(2293),
    [anon_sym_u32] = ACTIONS(2293),
    [anon_sym_i32] = ACTIONS(2293),
    [anon_sym_u64] = ACTIONS(2293),
    [anon_sym_i64] = ACTIONS(2293),
    [anon_sym_u128] = ACTIONS(2293),
    [anon_sym_i128] = ACTIONS(2293),
    [anon_sym_isize] = ACTIONS(2293),
    [anon_sym_usize] = ACTIONS(2293),
    [anon_sym_f32] = ACTIONS(2293),
    [anon_sym_f64] = ACTIONS(2293),
    [anon_sym_bool] = ACTIONS(2293),
    [anon_sym_str] = ACTIONS(2293),
    [anon_sym_char] = ACTIONS(2293),
    [anon_sym__] = ACTIONS(2741),
    [anon_sym_AMP] = ACTIONS(2421),
    [anon_sym_DASH] = ACTIONS(2419),
    [anon_sym_DOT] = ACTIONS(2741),
    [anon_sym_DASH_EQ] = ACTIONS(2739),
    [anon_sym_DASH_GT] = ACTIONS(2739),
    [anon_sym_COLON_COLON] = ACTIONS(2739),
    [anon_sym_BANG] = ACTIONS(2423),
    [anon_sym_BANG_EQ] = ACTIONS(2739),
    [anon_sym_AT] = ACTIONS(2739),
    [anon_sym_STAR_EQ] = ACTIONS(2739),
    [anon_sym_SLASH] = ACTIONS(2741),
    [anon_sym_SLASH_EQ] = ACTIONS(2739),
    [anon_sym_AMP_AMP] = ACTIONS(2739),
    [anon_sym_AMP_EQ] = ACTIONS(2739),
    [anon_sym_POUND] = ACTIONS(2739),
    [anon_sym_PERCENT] = ACTIONS(2741),
    [anon_sym_PERCENT_EQ] = ACTIONS(2739),
    [anon_sym_CARET] = ACTIONS(2741),
    [anon_sym_CARET_EQ] = ACTIONS(2739),
    [anon_sym_PLUS_EQ] = ACTIONS(2739),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_LT_LT] = ACTIONS(2741),
    [anon_sym_LT_LT_EQ] = ACTIONS(2739),
    [anon_sym_LT_EQ] = ACTIONS(2739),
    [anon_sym_EQ] = ACTIONS(2741),
    [anon_sym_EQ_EQ] = ACTIONS(2739),
    [anon_sym_GT] = ACTIONS(2741),
    [anon_sym_GT_EQ] = ACTIONS(2739),
    [anon_sym_GT_GT] = ACTIONS(2741),
    [anon_sym_GT_GT_EQ] = ACTIONS(2739),
    [anon_sym_PIPE] = ACTIONS(2301),
    [anon_sym_PIPE_EQ] = ACTIONS(2739),
    [anon_sym_PIPE_PIPE] = ACTIONS(2739),
    [anon_sym_TILDE] = ACTIONS(2739),
    [anon_sym_QMARK] = ACTIONS(2739),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(2425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2739),
    [anon_sym_as] = ACTIONS(2741),
    [anon_sym_break] = ACTIONS(2307),
    [anon_sym_const] = ACTIONS(2741),
    [anon_sym_continue] = ACTIONS(2309),
    [anon_sym_default] = ACTIONS(2311),
    [anon_sym_enum] = ACTIONS(2741),
    [anon_sym_fn] = ACTIONS(2741),
    [anon_sym_for] = ACTIONS(2313),
    [anon_sym_if] = ACTIONS(2427),
    [anon_sym_impl] = ACTIONS(2741),
    [anon_sym_let] = ACTIONS(2741),
    [anon_sym_loop] = ACTIONS(2317),
    [anon_sym_match] = ACTIONS(2319),
    [anon_sym_mod] = ACTIONS(2741),
    [anon_sym_pub] = ACTIONS(2741),
    [anon_sym_return] = ACTIONS(2429),
    [anon_sym_static] = ACTIONS(2741),
    [anon_sym_struct] = ACTIONS(2741),
    [anon_sym_trait] = ACTIONS(2741),
    [anon_sym_type] = ACTIONS(2741),
    [anon_sym_union] = ACTIONS(2311),
    [anon_sym_unsafe] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(2741),
    [anon_sym_where] = ACTIONS(2741),
    [anon_sym_while] = ACTIONS(2325),
    [sym_mutable_specifier] = ACTIONS(2741),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(2275),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(2275),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2331),
    [sym_self] = ACTIONS(2333),
    [sym_super] = ACTIONS(2741),
    [sym_crate] = ACTIONS(2741),
    [sym_metavariable] = ACTIONS(2335),
  },
  [707] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2431),
    [anon_sym_macro_rules_BANG] = ACTIONS(2431),
    [anon_sym_LPAREN] = ACTIONS(2431),
    [anon_sym_RPAREN] = ACTIONS(2431),
    [anon_sym_LBRACE] = ACTIONS(2431),
    [anon_sym_RBRACE] = ACTIONS(2431),
    [anon_sym_LBRACK] = ACTIONS(2431),
    [anon_sym_RBRACK] = ACTIONS(2431),
    [anon_sym_PLUS] = ACTIONS(2433),
    [anon_sym_STAR] = ACTIONS(2433),
    [anon_sym_COMMA] = ACTIONS(2431),
    [anon_sym_AMP] = ACTIONS(2433),
    [anon_sym_DASH] = ACTIONS(2433),
    [anon_sym_DOT] = ACTIONS(2433),
    [anon_sym_DASH_EQ] = ACTIONS(2431),
    [anon_sym_BANG_EQ] = ACTIONS(2431),
    [anon_sym_STAR_EQ] = ACTIONS(2431),
    [anon_sym_SLASH] = ACTIONS(2433),
    [anon_sym_SLASH_EQ] = ACTIONS(2431),
    [anon_sym_AMP_AMP] = ACTIONS(2431),
    [anon_sym_AMP_EQ] = ACTIONS(2431),
    [anon_sym_POUND] = ACTIONS(2431),
    [anon_sym_PERCENT] = ACTIONS(2433),
    [anon_sym_PERCENT_EQ] = ACTIONS(2431),
    [anon_sym_CARET] = ACTIONS(2433),
    [anon_sym_CARET_EQ] = ACTIONS(2431),
    [anon_sym_PLUS_EQ] = ACTIONS(2431),
    [anon_sym_LT] = ACTIONS(2433),
    [anon_sym_LT_LT] = ACTIONS(2433),
    [anon_sym_LT_LT_EQ] = ACTIONS(2431),
    [anon_sym_LT_EQ] = ACTIONS(2431),
    [anon_sym_EQ] = ACTIONS(2433),
    [anon_sym_EQ_EQ] = ACTIONS(2431),
    [anon_sym_GT] = ACTIONS(2433),
    [anon_sym_GT_EQ] = ACTIONS(2431),
    [anon_sym_GT_GT] = ACTIONS(2433),
    [anon_sym_GT_GT_EQ] = ACTIONS(2431),
    [anon_sym_PIPE] = ACTIONS(2433),
    [anon_sym_PIPE_EQ] = ACTIONS(2431),
    [anon_sym_PIPE_PIPE] = ACTIONS(2431),
    [anon_sym_QMARK] = ACTIONS(2431),
    [anon_sym_DOT_DOT] = ACTIONS(2433),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2431),
    [anon_sym_as] = ACTIONS(2433),
    [anon_sym_const] = ACTIONS(2433),
    [anon_sym_default] = ACTIONS(2433),
    [anon_sym_enum] = ACTIONS(2433),
    [anon_sym_fn] = ACTIONS(2433),
    [anon_sym_impl] = ACTIONS(2433),
    [anon_sym_let] = ACTIONS(2433),
    [anon_sym_mod] = ACTIONS(2433),
    [anon_sym_pub] = ACTIONS(2433),
    [anon_sym_static] = ACTIONS(2433),
    [anon_sym_struct] = ACTIONS(2433),
    [anon_sym_trait] = ACTIONS(2433),
    [anon_sym_type] = ACTIONS(2433),
    [anon_sym_union] = ACTIONS(2433),
    [anon_sym_unsafe] = ACTIONS(2433),
    [anon_sym_use] = ACTIONS(2433),
    [anon_sym_extern] = ACTIONS(2433),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2433),
  },
  [708] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(563),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(563),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2591),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [709] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2743),
    [anon_sym_LPAREN] = ACTIONS(2743),
    [anon_sym_RPAREN] = ACTIONS(2743),
    [anon_sym_LBRACE] = ACTIONS(2743),
    [anon_sym_RBRACE] = ACTIONS(2743),
    [anon_sym_LBRACK] = ACTIONS(2743),
    [anon_sym_RBRACK] = ACTIONS(2743),
    [anon_sym_PLUS] = ACTIONS(2745),
    [anon_sym_STAR] = ACTIONS(2745),
    [anon_sym_COMMA] = ACTIONS(2743),
    [anon_sym_AMP] = ACTIONS(2745),
    [anon_sym_DASH] = ACTIONS(2745),
    [anon_sym_DOT] = ACTIONS(2745),
    [anon_sym_DASH_EQ] = ACTIONS(2743),
    [anon_sym_BANG_EQ] = ACTIONS(2743),
    [anon_sym_STAR_EQ] = ACTIONS(2743),
    [anon_sym_SLASH] = ACTIONS(2745),
    [anon_sym_SLASH_EQ] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2743),
    [anon_sym_AMP_EQ] = ACTIONS(2743),
    [anon_sym_PERCENT] = ACTIONS(2745),
    [anon_sym_PERCENT_EQ] = ACTIONS(2743),
    [anon_sym_CARET] = ACTIONS(2745),
    [anon_sym_CARET_EQ] = ACTIONS(2743),
    [anon_sym_PLUS_EQ] = ACTIONS(2743),
    [anon_sym_LT] = ACTIONS(2745),
    [anon_sym_LT_LT] = ACTIONS(2745),
    [anon_sym_LT_LT_EQ] = ACTIONS(2743),
    [anon_sym_LT_EQ] = ACTIONS(2743),
    [anon_sym_EQ] = ACTIONS(2745),
    [anon_sym_EQ_EQ] = ACTIONS(2743),
    [anon_sym_GT] = ACTIONS(2745),
    [anon_sym_GT_EQ] = ACTIONS(2743),
    [anon_sym_GT_GT] = ACTIONS(2745),
    [anon_sym_GT_GT_EQ] = ACTIONS(2743),
    [anon_sym_PIPE] = ACTIONS(2745),
    [anon_sym_PIPE_EQ] = ACTIONS(2743),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_QMARK] = ACTIONS(2743),
    [anon_sym_DOT_DOT] = ACTIONS(2745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2743),
    [anon_sym_as] = ACTIONS(2743),
    [sym_line_comment] = ACTIONS(7),
  },
  [710] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(2747),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(2749),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_BANG_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH] = ACTIONS(563),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(563),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_LT] = ACTIONS(577),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(581),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(577),
    [anon_sym_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(589),
    [anon_sym_as] = ACTIONS(591),
    [sym_line_comment] = ACTIONS(7),
  },
  [711] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1393),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1393),
    [sym_macro_invocation] = STATE(1393),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1393),
    [sym_unary_expression] = STATE(1393),
    [sym_try_expression] = STATE(1393),
    [sym_reference_expression] = STATE(1393),
    [sym_binary_expression] = STATE(1393),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1393),
    [sym_call_expression] = STATE(1393),
    [sym_array_expression] = STATE(1393),
    [sym_parenthesized_expression] = STATE(1393),
    [sym_tuple_expression] = STATE(1393),
    [sym_unit_expression] = STATE(1393),
    [sym_struct_expression] = STATE(1393),
    [sym_if_expression] = STATE(1393),
    [sym_if_let_expression] = STATE(1393),
    [sym_match_expression] = STATE(1393),
    [sym_while_expression] = STATE(1393),
    [sym_while_let_expression] = STATE(1393),
    [sym_loop_expression] = STATE(1393),
    [sym_for_expression] = STATE(1393),
    [sym_closure_expression] = STATE(1393),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1393),
    [sym_continue_expression] = STATE(1393),
    [sym_index_expression] = STATE(1393),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1393),
    [sym_block] = STATE(1393),
    [sym__literal] = STATE(1393),
    [sym_string_literal] = STATE(1393),
    [sym_boolean_literal] = STATE(1393),
    [aux_sym_tuple_expression_repeat1] = STATE(1394),
    [sym_raw_string_literal] = ACTIONS(2751),
    [sym_float_literal] = ACTIONS(2751),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(2751),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(2751),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [712] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(563),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(563),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [713] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(2601),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2601),
    [anon_sym_BANG_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(2601),
    [anon_sym_SLASH] = ACTIONS(563),
    [anon_sym_SLASH_EQ] = ACTIONS(2601),
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(2601),
    [anon_sym_PERCENT] = ACTIONS(563),
    [anon_sym_PERCENT_EQ] = ACTIONS(2601),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_CARET_EQ] = ACTIONS(2601),
    [anon_sym_PLUS_EQ] = ACTIONS(2601),
    [anon_sym_LT] = ACTIONS(577),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_EQ] = ACTIONS(2601),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(2603),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(577),
    [anon_sym_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_GT_GT_EQ] = ACTIONS(2601),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_PIPE_EQ] = ACTIONS(2601),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(2601),
    [anon_sym_DOT_DOT] = ACTIONS(587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(589),
    [anon_sym_as] = ACTIONS(2601),
    [sym_line_comment] = ACTIONS(7),
  },
  [714] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(563),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(563),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [715] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(563),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(563),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(577),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(577),
    [anon_sym_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [716] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(563),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(563),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [717] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(563),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(563),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2591),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [718] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(2605),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(2605),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2605),
    [anon_sym_BANG_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(2605),
    [anon_sym_SLASH] = ACTIONS(563),
    [anon_sym_SLASH_EQ] = ACTIONS(2605),
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(2605),
    [anon_sym_PERCENT] = ACTIONS(563),
    [anon_sym_PERCENT_EQ] = ACTIONS(2605),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_CARET_EQ] = ACTIONS(2605),
    [anon_sym_PLUS_EQ] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(577),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_EQ] = ACTIONS(2605),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(2607),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(577),
    [anon_sym_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_GT_GT_EQ] = ACTIONS(2605),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_PIPE_EQ] = ACTIONS(2605),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(2605),
    [anon_sym_DOT_DOT] = ACTIONS(587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(589),
    [anon_sym_as] = ACTIONS(2605),
    [sym_line_comment] = ACTIONS(7),
  },
  [719] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(563),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(563),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [720] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(563),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(563),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(577),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(577),
    [anon_sym_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [721] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(2609),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2609),
    [anon_sym_BANG_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(2609),
    [anon_sym_SLASH] = ACTIONS(563),
    [anon_sym_SLASH_EQ] = ACTIONS(2609),
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(563),
    [anon_sym_PERCENT_EQ] = ACTIONS(2609),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_CARET_EQ] = ACTIONS(2609),
    [anon_sym_PLUS_EQ] = ACTIONS(2609),
    [anon_sym_LT] = ACTIONS(577),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_EQ] = ACTIONS(2609),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(577),
    [anon_sym_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_GT_GT_EQ] = ACTIONS(2609),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_PIPE_EQ] = ACTIONS(2609),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(2609),
    [anon_sym_DOT_DOT] = ACTIONS(2611),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2609),
    [anon_sym_as] = ACTIONS(2609),
    [sym_line_comment] = ACTIONS(7),
  },
  [722] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(2753),
    [sym_mutable_specifier] = ACTIONS(2753),
    [sym_line_comment] = ACTIONS(7),
  },
  [723] = {
    [sym_function_modifiers] = STATE(726),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1319),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(1397),
    [sym_array_type] = STATE(1319),
    [sym_function_type] = STATE(1319),
    [sym_tuple_type] = STATE(1319),
    [sym_unit_type] = STATE(1319),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(1319),
    [sym_reference_type] = STATE(1319),
    [sym_pointer_type] = STATE(1319),
    [sym_empty_type] = STATE(1319),
    [sym_dynamic_type] = STATE(1319),
    [sym_macro_invocation] = STATE(1319),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(728),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1543),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1547),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_mutable_specifier] = ACTIONS(2755),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1549),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [724] = {
    [sym_parameters] = STATE(1398),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [sym_line_comment] = ACTIONS(7),
  },
  [725] = {
    [sym_parameters] = STATE(1399),
    [sym_type_arguments] = STATE(1330),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_RPAREN] = ACTIONS(773),
    [anon_sym_LBRACK] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(2633),
    [anon_sym_STAR] = ACTIONS(2633),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_DASH] = ACTIONS(2633),
    [anon_sym_DOT] = ACTIONS(2633),
    [anon_sym_DASH_EQ] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(2635),
    [anon_sym_BANG] = ACTIONS(557),
    [anon_sym_BANG_EQ] = ACTIONS(773),
    [anon_sym_STAR_EQ] = ACTIONS(773),
    [anon_sym_SLASH] = ACTIONS(2633),
    [anon_sym_SLASH_EQ] = ACTIONS(773),
    [anon_sym_AMP_AMP] = ACTIONS(773),
    [anon_sym_AMP_EQ] = ACTIONS(773),
    [anon_sym_PERCENT] = ACTIONS(2633),
    [anon_sym_PERCENT_EQ] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(2633),
    [anon_sym_CARET_EQ] = ACTIONS(773),
    [anon_sym_PLUS_EQ] = ACTIONS(773),
    [anon_sym_LT] = ACTIONS(2637),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_LT_LT_EQ] = ACTIONS(773),
    [anon_sym_LT_EQ] = ACTIONS(773),
    [anon_sym_EQ] = ACTIONS(2633),
    [anon_sym_EQ_EQ] = ACTIONS(773),
    [anon_sym_GT] = ACTIONS(2633),
    [anon_sym_GT_EQ] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_GT_GT_EQ] = ACTIONS(773),
    [anon_sym_PIPE] = ACTIONS(2633),
    [anon_sym_PIPE_EQ] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(773),
    [anon_sym_QMARK] = ACTIONS(773),
    [anon_sym_DOT_DOT] = ACTIONS(2633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(773),
    [anon_sym_as] = ACTIONS(773),
    [sym_line_comment] = ACTIONS(7),
  },
  [726] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1402),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_fn] = ACTIONS(2757),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2759),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [727] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(2761),
    [sym_line_comment] = ACTIONS(7),
  },
  [728] = {
    [sym_parameters] = STATE(1398),
    [sym_type_arguments] = STATE(1340),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_RPAREN] = ACTIONS(783),
    [anon_sym_LBRACK] = ACTIONS(783),
    [anon_sym_PLUS] = ACTIONS(785),
    [anon_sym_STAR] = ACTIONS(785),
    [anon_sym_COMMA] = ACTIONS(783),
    [anon_sym_AMP] = ACTIONS(785),
    [anon_sym_DASH] = ACTIONS(785),
    [anon_sym_DOT] = ACTIONS(785),
    [anon_sym_DASH_EQ] = ACTIONS(783),
    [anon_sym_BANG_EQ] = ACTIONS(783),
    [anon_sym_STAR_EQ] = ACTIONS(783),
    [anon_sym_SLASH] = ACTIONS(785),
    [anon_sym_SLASH_EQ] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_AMP_EQ] = ACTIONS(783),
    [anon_sym_PERCENT] = ACTIONS(785),
    [anon_sym_PERCENT_EQ] = ACTIONS(783),
    [anon_sym_CARET] = ACTIONS(785),
    [anon_sym_CARET_EQ] = ACTIONS(783),
    [anon_sym_PLUS_EQ] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(2637),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_LT_LT_EQ] = ACTIONS(783),
    [anon_sym_LT_EQ] = ACTIONS(783),
    [anon_sym_EQ] = ACTIONS(785),
    [anon_sym_EQ_EQ] = ACTIONS(783),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_GT_EQ] = ACTIONS(783),
    [anon_sym_GT_GT] = ACTIONS(785),
    [anon_sym_GT_GT_EQ] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PIPE_EQ] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_DOT_DOT] = ACTIONS(785),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(783),
    [anon_sym_as] = ACTIONS(783),
    [sym_line_comment] = ACTIONS(7),
  },
  [729] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(1405),
    [sym_tuple_pattern] = STATE(1405),
    [sym_tuple_struct_pattern] = STATE(1405),
    [sym_struct_pattern] = STATE(1405),
    [sym_remaining_field_pattern] = STATE(1405),
    [sym_mut_pattern] = STATE(1405),
    [sym_ref_pattern] = STATE(1405),
    [sym_captured_pattern] = STATE(1405),
    [sym_reference_pattern] = STATE(1405),
    [sym__literal] = STATE(1405),
    [sym_string_literal] = STATE(1405),
    [sym_boolean_literal] = STATE(1405),
    [sym_raw_string_literal] = ACTIONS(2763),
    [sym_float_literal] = ACTIONS(2763),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(2765),
    [anon_sym_AMP] = ACTIONS(293),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(295),
    [anon_sym_ref] = ACTIONS(297),
    [sym_integer_literal] = ACTIONS(2763),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(2763),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(299),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [730] = {
    [sym_block] = STATE(1406),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(111),
    [sym_line_comment] = ACTIONS(7),
  },
  [731] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1408),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(1408),
    [sym_macro_invocation] = STATE(1408),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1408),
    [sym_unary_expression] = STATE(1408),
    [sym_try_expression] = STATE(1408),
    [sym_reference_expression] = STATE(1408),
    [sym_binary_expression] = STATE(1408),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1408),
    [sym_call_expression] = STATE(1408),
    [sym_array_expression] = STATE(1408),
    [sym_parenthesized_expression] = STATE(1408),
    [sym_tuple_expression] = STATE(1408),
    [sym_unit_expression] = STATE(1408),
    [sym_struct_expression] = STATE(1408),
    [sym_if_expression] = STATE(1408),
    [sym_if_let_expression] = STATE(1408),
    [sym_match_expression] = STATE(1408),
    [sym_while_expression] = STATE(1408),
    [sym_while_let_expression] = STATE(1408),
    [sym_loop_expression] = STATE(1408),
    [sym_for_expression] = STATE(1408),
    [sym_closure_expression] = STATE(1408),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1408),
    [sym_continue_expression] = STATE(1408),
    [sym_index_expression] = STATE(1408),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1408),
    [sym_block] = STATE(1408),
    [sym__literal] = STATE(1408),
    [sym_string_literal] = STATE(1408),
    [sym_boolean_literal] = STATE(1408),
    [sym_raw_string_literal] = ACTIONS(2767),
    [sym_float_literal] = ACTIONS(2767),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_let] = ACTIONS(2769),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(2767),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(2767),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [732] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(1409),
    [sym_tuple_pattern] = STATE(1409),
    [sym_tuple_struct_pattern] = STATE(1409),
    [sym_struct_pattern] = STATE(1409),
    [sym_remaining_field_pattern] = STATE(1409),
    [sym_mut_pattern] = STATE(1409),
    [sym_ref_pattern] = STATE(1409),
    [sym_captured_pattern] = STATE(1409),
    [sym_reference_pattern] = STATE(1409),
    [sym__literal] = STATE(1409),
    [sym_string_literal] = STATE(1409),
    [sym_boolean_literal] = STATE(1409),
    [sym_raw_string_literal] = ACTIONS(2771),
    [sym_float_literal] = ACTIONS(2771),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(2773),
    [anon_sym_AMP] = ACTIONS(955),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(957),
    [anon_sym_ref] = ACTIONS(959),
    [sym_integer_literal] = ACTIONS(2771),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(2771),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(961),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [733] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(1410),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [734] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(2775),
    [sym_line_comment] = ACTIONS(7),
  },
  [735] = {
    [sym_else_tail] = STATE(986),
    [sym_raw_string_literal] = ACTIONS(2012),
    [sym_float_literal] = ACTIONS(2012),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2012),
    [anon_sym_macro_rules_BANG] = ACTIONS(2012),
    [anon_sym_LPAREN] = ACTIONS(2012),
    [anon_sym_LBRACE] = ACTIONS(2012),
    [anon_sym_RBRACE] = ACTIONS(2012),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_PLUS] = ACTIONS(2014),
    [anon_sym_STAR] = ACTIONS(2014),
    [anon_sym_u8] = ACTIONS(2014),
    [anon_sym_i8] = ACTIONS(2014),
    [anon_sym_u16] = ACTIONS(2014),
    [anon_sym_i16] = ACTIONS(2014),
    [anon_sym_u32] = ACTIONS(2014),
    [anon_sym_i32] = ACTIONS(2014),
    [anon_sym_u64] = ACTIONS(2014),
    [anon_sym_i64] = ACTIONS(2014),
    [anon_sym_u128] = ACTIONS(2014),
    [anon_sym_i128] = ACTIONS(2014),
    [anon_sym_isize] = ACTIONS(2014),
    [anon_sym_usize] = ACTIONS(2014),
    [anon_sym_f32] = ACTIONS(2014),
    [anon_sym_f64] = ACTIONS(2014),
    [anon_sym_bool] = ACTIONS(2014),
    [anon_sym_str] = ACTIONS(2014),
    [anon_sym_char] = ACTIONS(2014),
    [anon_sym_AMP] = ACTIONS(2014),
    [anon_sym_DASH] = ACTIONS(2014),
    [anon_sym_DOT] = ACTIONS(2014),
    [anon_sym_DASH_EQ] = ACTIONS(2012),
    [anon_sym_COLON_COLON] = ACTIONS(2012),
    [anon_sym_BANG] = ACTIONS(2014),
    [anon_sym_BANG_EQ] = ACTIONS(2012),
    [anon_sym_STAR_EQ] = ACTIONS(2012),
    [anon_sym_SLASH] = ACTIONS(2014),
    [anon_sym_SLASH_EQ] = ACTIONS(2012),
    [anon_sym_AMP_AMP] = ACTIONS(2012),
    [anon_sym_AMP_EQ] = ACTIONS(2012),
    [anon_sym_POUND] = ACTIONS(2012),
    [anon_sym_PERCENT] = ACTIONS(2014),
    [anon_sym_PERCENT_EQ] = ACTIONS(2012),
    [anon_sym_CARET] = ACTIONS(2014),
    [anon_sym_CARET_EQ] = ACTIONS(2012),
    [anon_sym_PLUS_EQ] = ACTIONS(2012),
    [anon_sym_LT] = ACTIONS(2014),
    [anon_sym_LT_LT] = ACTIONS(2014),
    [anon_sym_LT_LT_EQ] = ACTIONS(2012),
    [anon_sym_LT_EQ] = ACTIONS(2012),
    [anon_sym_EQ] = ACTIONS(2014),
    [anon_sym_EQ_EQ] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2014),
    [anon_sym_GT_EQ] = ACTIONS(2012),
    [anon_sym_GT_GT] = ACTIONS(2014),
    [anon_sym_GT_GT_EQ] = ACTIONS(2012),
    [anon_sym_PIPE] = ACTIONS(2014),
    [anon_sym_PIPE_EQ] = ACTIONS(2012),
    [anon_sym_PIPE_PIPE] = ACTIONS(2012),
    [anon_sym_QMARK] = ACTIONS(2012),
    [anon_sym_SQUOTE] = ACTIONS(2014),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2012),
    [anon_sym_as] = ACTIONS(2014),
    [anon_sym_break] = ACTIONS(2014),
    [anon_sym_const] = ACTIONS(2014),
    [anon_sym_continue] = ACTIONS(2014),
    [anon_sym_default] = ACTIONS(2014),
    [anon_sym_enum] = ACTIONS(2014),
    [anon_sym_fn] = ACTIONS(2014),
    [anon_sym_for] = ACTIONS(2014),
    [anon_sym_if] = ACTIONS(2014),
    [anon_sym_impl] = ACTIONS(2014),
    [anon_sym_let] = ACTIONS(2014),
    [anon_sym_loop] = ACTIONS(2014),
    [anon_sym_match] = ACTIONS(2014),
    [anon_sym_mod] = ACTIONS(2014),
    [anon_sym_pub] = ACTIONS(2014),
    [anon_sym_return] = ACTIONS(2014),
    [anon_sym_static] = ACTIONS(2014),
    [anon_sym_struct] = ACTIONS(2014),
    [anon_sym_trait] = ACTIONS(2014),
    [anon_sym_type] = ACTIONS(2014),
    [anon_sym_union] = ACTIONS(2014),
    [anon_sym_unsafe] = ACTIONS(2014),
    [anon_sym_use] = ACTIONS(2014),
    [anon_sym_while] = ACTIONS(2014),
    [anon_sym_extern] = ACTIONS(2014),
    [anon_sym_else] = ACTIONS(2777),
    [anon_sym_move] = ACTIONS(2014),
    [sym_integer_literal] = ACTIONS(2012),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2012),
    [sym_char_literal] = ACTIONS(2012),
    [anon_sym_true] = ACTIONS(2014),
    [anon_sym_false] = ACTIONS(2014),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2014),
    [sym_self] = ACTIONS(2014),
    [sym_super] = ACTIONS(2014),
    [sym_crate] = ACTIONS(2014),
    [sym_metavariable] = ACTIONS(2012),
  },
  [736] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2220),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(623),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(623),
    [anon_sym_PLUS_EQ] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(623),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(643),
    [anon_sym_as] = ACTIONS(645),
    [sym_line_comment] = ACTIONS(7),
  },
  [737] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2591),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [738] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [739] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2601),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2601),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(2601),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(2601),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(2601),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(2601),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(2601),
    [anon_sym_PLUS_EQ] = ACTIONS(2601),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(2601),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(2603),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(2601),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(2601),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(2601),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(643),
    [anon_sym_as] = ACTIONS(2601),
    [sym_line_comment] = ACTIONS(7),
  },
  [740] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [741] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [742] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [743] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2591),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [744] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2605),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(2605),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2605),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(2605),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(2605),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(2605),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(2605),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(2605),
    [anon_sym_PLUS_EQ] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(2605),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(2607),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(2605),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(2605),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(2605),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(643),
    [anon_sym_as] = ACTIONS(2605),
    [sym_line_comment] = ACTIONS(7),
  },
  [745] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [746] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [747] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2609),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2609),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(2609),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(2609),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(2609),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(2609),
    [anon_sym_PLUS_EQ] = ACTIONS(2609),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(2609),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(2609),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(2609),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(2609),
    [anon_sym_DOT_DOT] = ACTIONS(2611),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2609),
    [anon_sym_as] = ACTIONS(2609),
    [sym_line_comment] = ACTIONS(7),
  },
  [748] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(2779),
    [sym_mutable_specifier] = ACTIONS(2779),
    [sym_line_comment] = ACTIONS(7),
  },
  [749] = {
    [sym_function_modifiers] = STATE(752),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1319),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(1415),
    [sym_array_type] = STATE(1319),
    [sym_function_type] = STATE(1319),
    [sym_tuple_type] = STATE(1319),
    [sym_unit_type] = STATE(1319),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(1319),
    [sym_reference_type] = STATE(1319),
    [sym_pointer_type] = STATE(1319),
    [sym_empty_type] = STATE(1319),
    [sym_dynamic_type] = STATE(1319),
    [sym_macro_invocation] = STATE(1319),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(754),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1593),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1597),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_mutable_specifier] = ACTIONS(2781),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1599),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [750] = {
    [sym_parameters] = STATE(1416),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [sym_line_comment] = ACTIONS(7),
  },
  [751] = {
    [sym_parameters] = STATE(1417),
    [sym_type_arguments] = STATE(1330),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_RBRACE] = ACTIONS(773),
    [anon_sym_LBRACK] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(2633),
    [anon_sym_STAR] = ACTIONS(2633),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_DASH] = ACTIONS(2633),
    [anon_sym_DOT] = ACTIONS(2633),
    [anon_sym_DASH_EQ] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(2635),
    [anon_sym_BANG] = ACTIONS(557),
    [anon_sym_BANG_EQ] = ACTIONS(773),
    [anon_sym_STAR_EQ] = ACTIONS(773),
    [anon_sym_SLASH] = ACTIONS(2633),
    [anon_sym_SLASH_EQ] = ACTIONS(773),
    [anon_sym_AMP_AMP] = ACTIONS(773),
    [anon_sym_AMP_EQ] = ACTIONS(773),
    [anon_sym_PERCENT] = ACTIONS(2633),
    [anon_sym_PERCENT_EQ] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(2633),
    [anon_sym_CARET_EQ] = ACTIONS(773),
    [anon_sym_PLUS_EQ] = ACTIONS(773),
    [anon_sym_LT] = ACTIONS(2637),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_LT_LT_EQ] = ACTIONS(773),
    [anon_sym_LT_EQ] = ACTIONS(773),
    [anon_sym_EQ] = ACTIONS(2633),
    [anon_sym_EQ_EQ] = ACTIONS(773),
    [anon_sym_GT] = ACTIONS(2633),
    [anon_sym_GT_EQ] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_GT_GT_EQ] = ACTIONS(773),
    [anon_sym_PIPE] = ACTIONS(2633),
    [anon_sym_PIPE_EQ] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(773),
    [anon_sym_QMARK] = ACTIONS(773),
    [anon_sym_DOT_DOT] = ACTIONS(2633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(773),
    [anon_sym_as] = ACTIONS(773),
    [sym_line_comment] = ACTIONS(7),
  },
  [752] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1420),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_fn] = ACTIONS(2783),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2785),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [753] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(2787),
    [sym_line_comment] = ACTIONS(7),
  },
  [754] = {
    [sym_parameters] = STATE(1416),
    [sym_type_arguments] = STATE(1340),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(783),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_RBRACE] = ACTIONS(783),
    [anon_sym_LBRACK] = ACTIONS(783),
    [anon_sym_PLUS] = ACTIONS(785),
    [anon_sym_STAR] = ACTIONS(785),
    [anon_sym_AMP] = ACTIONS(785),
    [anon_sym_DASH] = ACTIONS(785),
    [anon_sym_DOT] = ACTIONS(785),
    [anon_sym_DASH_EQ] = ACTIONS(783),
    [anon_sym_BANG_EQ] = ACTIONS(783),
    [anon_sym_STAR_EQ] = ACTIONS(783),
    [anon_sym_SLASH] = ACTIONS(785),
    [anon_sym_SLASH_EQ] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_AMP_EQ] = ACTIONS(783),
    [anon_sym_PERCENT] = ACTIONS(785),
    [anon_sym_PERCENT_EQ] = ACTIONS(783),
    [anon_sym_CARET] = ACTIONS(785),
    [anon_sym_CARET_EQ] = ACTIONS(783),
    [anon_sym_PLUS_EQ] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(2637),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_LT_LT_EQ] = ACTIONS(783),
    [anon_sym_LT_EQ] = ACTIONS(783),
    [anon_sym_EQ] = ACTIONS(785),
    [anon_sym_EQ_EQ] = ACTIONS(783),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_GT_EQ] = ACTIONS(783),
    [anon_sym_GT_GT] = ACTIONS(785),
    [anon_sym_GT_GT_EQ] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PIPE_EQ] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_DOT_DOT] = ACTIONS(785),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(783),
    [anon_sym_as] = ACTIONS(783),
    [sym_line_comment] = ACTIONS(7),
  },
  [755] = {
    [sym_raw_string_literal] = ACTIONS(2789),
    [sym_float_literal] = ACTIONS(2789),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(2789),
    [anon_sym_SEMI] = ACTIONS(2789),
    [anon_sym_macro_rules_BANG] = ACTIONS(2789),
    [anon_sym_LPAREN] = ACTIONS(2789),
    [anon_sym_LBRACE] = ACTIONS(2789),
    [anon_sym_RBRACE] = ACTIONS(2789),
    [anon_sym_LBRACK] = ACTIONS(2789),
    [anon_sym_PLUS] = ACTIONS(2791),
    [anon_sym_STAR] = ACTIONS(2791),
    [anon_sym_u8] = ACTIONS(2791),
    [anon_sym_i8] = ACTIONS(2791),
    [anon_sym_u16] = ACTIONS(2791),
    [anon_sym_i16] = ACTIONS(2791),
    [anon_sym_u32] = ACTIONS(2791),
    [anon_sym_i32] = ACTIONS(2791),
    [anon_sym_u64] = ACTIONS(2791),
    [anon_sym_i64] = ACTIONS(2791),
    [anon_sym_u128] = ACTIONS(2791),
    [anon_sym_i128] = ACTIONS(2791),
    [anon_sym_isize] = ACTIONS(2791),
    [anon_sym_usize] = ACTIONS(2791),
    [anon_sym_f32] = ACTIONS(2791),
    [anon_sym_f64] = ACTIONS(2791),
    [anon_sym_bool] = ACTIONS(2791),
    [anon_sym_str] = ACTIONS(2791),
    [anon_sym_char] = ACTIONS(2791),
    [anon_sym_AMP] = ACTIONS(2791),
    [anon_sym_DASH] = ACTIONS(2791),
    [anon_sym_DOT] = ACTIONS(2791),
    [anon_sym_DASH_EQ] = ACTIONS(2789),
    [anon_sym_COLON_COLON] = ACTIONS(2789),
    [anon_sym_BANG] = ACTIONS(2791),
    [anon_sym_BANG_EQ] = ACTIONS(2789),
    [anon_sym_STAR_EQ] = ACTIONS(2789),
    [anon_sym_SLASH] = ACTIONS(2791),
    [anon_sym_SLASH_EQ] = ACTIONS(2789),
    [anon_sym_AMP_AMP] = ACTIONS(2789),
    [anon_sym_AMP_EQ] = ACTIONS(2789),
    [anon_sym_POUND] = ACTIONS(2789),
    [anon_sym_PERCENT] = ACTIONS(2791),
    [anon_sym_PERCENT_EQ] = ACTIONS(2789),
    [anon_sym_CARET] = ACTIONS(2791),
    [anon_sym_CARET_EQ] = ACTIONS(2789),
    [anon_sym_PLUS_EQ] = ACTIONS(2789),
    [anon_sym_LT] = ACTIONS(2791),
    [anon_sym_LT_LT] = ACTIONS(2791),
    [anon_sym_LT_LT_EQ] = ACTIONS(2789),
    [anon_sym_LT_EQ] = ACTIONS(2789),
    [anon_sym_EQ] = ACTIONS(2791),
    [anon_sym_EQ_EQ] = ACTIONS(2789),
    [anon_sym_GT] = ACTIONS(2791),
    [anon_sym_GT_EQ] = ACTIONS(2789),
    [anon_sym_GT_GT] = ACTIONS(2791),
    [anon_sym_GT_GT_EQ] = ACTIONS(2789),
    [anon_sym_PIPE] = ACTIONS(2791),
    [anon_sym_PIPE_EQ] = ACTIONS(2789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2789),
    [anon_sym_QMARK] = ACTIONS(2789),
    [anon_sym_SQUOTE] = ACTIONS(2791),
    [anon_sym_DOT_DOT] = ACTIONS(2791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2789),
    [anon_sym_as] = ACTIONS(2791),
    [anon_sym_break] = ACTIONS(2791),
    [anon_sym_const] = ACTIONS(2791),
    [anon_sym_continue] = ACTIONS(2791),
    [anon_sym_default] = ACTIONS(2791),
    [anon_sym_enum] = ACTIONS(2791),
    [anon_sym_fn] = ACTIONS(2791),
    [anon_sym_for] = ACTIONS(2791),
    [anon_sym_if] = ACTIONS(2791),
    [anon_sym_impl] = ACTIONS(2791),
    [anon_sym_let] = ACTIONS(2791),
    [anon_sym_loop] = ACTIONS(2791),
    [anon_sym_match] = ACTIONS(2791),
    [anon_sym_mod] = ACTIONS(2791),
    [anon_sym_pub] = ACTIONS(2791),
    [anon_sym_return] = ACTIONS(2791),
    [anon_sym_static] = ACTIONS(2791),
    [anon_sym_struct] = ACTIONS(2791),
    [anon_sym_trait] = ACTIONS(2791),
    [anon_sym_type] = ACTIONS(2791),
    [anon_sym_union] = ACTIONS(2791),
    [anon_sym_unsafe] = ACTIONS(2791),
    [anon_sym_use] = ACTIONS(2791),
    [anon_sym_while] = ACTIONS(2791),
    [anon_sym_extern] = ACTIONS(2791),
    [anon_sym_else] = ACTIONS(2791),
    [anon_sym_move] = ACTIONS(2791),
    [sym_integer_literal] = ACTIONS(2789),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2789),
    [sym_char_literal] = ACTIONS(2789),
    [anon_sym_true] = ACTIONS(2791),
    [anon_sym_false] = ACTIONS(2791),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2791),
    [sym_self] = ACTIONS(2791),
    [sym_super] = ACTIONS(2791),
    [sym_crate] = ACTIONS(2791),
    [sym_metavariable] = ACTIONS(2789),
  },
  [756] = {
    [sym_raw_string_literal] = ACTIONS(493),
    [sym_float_literal] = ACTIONS(493),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(407),
    [anon_sym_macro_rules_BANG] = ACTIONS(493),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_LBRACE] = ACTIONS(493),
    [anon_sym_RBRACE] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(411),
    [anon_sym_u8] = ACTIONS(495),
    [anon_sym_i8] = ACTIONS(495),
    [anon_sym_u16] = ACTIONS(495),
    [anon_sym_i16] = ACTIONS(495),
    [anon_sym_u32] = ACTIONS(495),
    [anon_sym_i32] = ACTIONS(495),
    [anon_sym_u64] = ACTIONS(495),
    [anon_sym_i64] = ACTIONS(495),
    [anon_sym_u128] = ACTIONS(495),
    [anon_sym_i128] = ACTIONS(495),
    [anon_sym_isize] = ACTIONS(495),
    [anon_sym_usize] = ACTIONS(495),
    [anon_sym_f32] = ACTIONS(495),
    [anon_sym_f64] = ACTIONS(495),
    [anon_sym_bool] = ACTIONS(495),
    [anon_sym_str] = ACTIONS(495),
    [anon_sym_char] = ACTIONS(495),
    [anon_sym_AMP] = ACTIONS(411),
    [anon_sym_DASH] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(411),
    [anon_sym_DASH_EQ] = ACTIONS(407),
    [anon_sym_COLON_COLON] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(495),
    [anon_sym_BANG_EQ] = ACTIONS(407),
    [anon_sym_STAR_EQ] = ACTIONS(407),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_SLASH_EQ] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(407),
    [anon_sym_AMP_EQ] = ACTIONS(407),
    [anon_sym_POUND] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_PERCENT_EQ] = ACTIONS(407),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_CARET_EQ] = ACTIONS(407),
    [anon_sym_PLUS_EQ] = ACTIONS(407),
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_LT_LT_EQ] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(407),
    [anon_sym_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(407),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_GT_EQ] = ACTIONS(407),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_EQ] = ACTIONS(407),
    [anon_sym_PIPE] = ACTIONS(411),
    [anon_sym_PIPE_EQ] = ACTIONS(407),
    [anon_sym_PIPE_PIPE] = ACTIONS(407),
    [anon_sym_QMARK] = ACTIONS(407),
    [anon_sym_SQUOTE] = ACTIONS(495),
    [anon_sym_DOT_DOT] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(407),
    [anon_sym_as] = ACTIONS(411),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_const] = ACTIONS(495),
    [anon_sym_continue] = ACTIONS(495),
    [anon_sym_default] = ACTIONS(495),
    [anon_sym_enum] = ACTIONS(495),
    [anon_sym_fn] = ACTIONS(495),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(495),
    [anon_sym_impl] = ACTIONS(495),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_loop] = ACTIONS(495),
    [anon_sym_match] = ACTIONS(495),
    [anon_sym_mod] = ACTIONS(495),
    [anon_sym_pub] = ACTIONS(495),
    [anon_sym_return] = ACTIONS(495),
    [anon_sym_static] = ACTIONS(495),
    [anon_sym_struct] = ACTIONS(495),
    [anon_sym_trait] = ACTIONS(495),
    [anon_sym_type] = ACTIONS(495),
    [anon_sym_union] = ACTIONS(495),
    [anon_sym_unsafe] = ACTIONS(495),
    [anon_sym_use] = ACTIONS(495),
    [anon_sym_while] = ACTIONS(495),
    [anon_sym_extern] = ACTIONS(495),
    [anon_sym_move] = ACTIONS(495),
    [sym_integer_literal] = ACTIONS(493),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(493),
    [sym_char_literal] = ACTIONS(493),
    [anon_sym_true] = ACTIONS(495),
    [anon_sym_false] = ACTIONS(495),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(495),
    [sym_self] = ACTIONS(495),
    [sym_super] = ACTIONS(495),
    [sym_crate] = ACTIONS(495),
    [sym_metavariable] = ACTIONS(493),
  },
  [757] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(2793),
    [sym_line_comment] = ACTIONS(7),
  },
  [758] = {
    [sym_else_tail] = STATE(1378),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2012),
    [anon_sym_LPAREN] = ACTIONS(2012),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_RBRACK] = ACTIONS(2012),
    [anon_sym_PLUS] = ACTIONS(2014),
    [anon_sym_STAR] = ACTIONS(2014),
    [anon_sym_COMMA] = ACTIONS(2012),
    [anon_sym_AMP] = ACTIONS(2014),
    [anon_sym_DASH] = ACTIONS(2014),
    [anon_sym_DOT] = ACTIONS(2014),
    [anon_sym_DASH_EQ] = ACTIONS(2012),
    [anon_sym_BANG_EQ] = ACTIONS(2012),
    [anon_sym_STAR_EQ] = ACTIONS(2012),
    [anon_sym_SLASH] = ACTIONS(2014),
    [anon_sym_SLASH_EQ] = ACTIONS(2012),
    [anon_sym_AMP_AMP] = ACTIONS(2012),
    [anon_sym_AMP_EQ] = ACTIONS(2012),
    [anon_sym_PERCENT] = ACTIONS(2014),
    [anon_sym_PERCENT_EQ] = ACTIONS(2012),
    [anon_sym_CARET] = ACTIONS(2014),
    [anon_sym_CARET_EQ] = ACTIONS(2012),
    [anon_sym_PLUS_EQ] = ACTIONS(2012),
    [anon_sym_LT] = ACTIONS(2014),
    [anon_sym_LT_LT] = ACTIONS(2014),
    [anon_sym_LT_LT_EQ] = ACTIONS(2012),
    [anon_sym_LT_EQ] = ACTIONS(2012),
    [anon_sym_EQ] = ACTIONS(2014),
    [anon_sym_EQ_EQ] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2014),
    [anon_sym_GT_EQ] = ACTIONS(2012),
    [anon_sym_GT_GT] = ACTIONS(2014),
    [anon_sym_GT_GT_EQ] = ACTIONS(2012),
    [anon_sym_PIPE] = ACTIONS(2014),
    [anon_sym_PIPE_EQ] = ACTIONS(2012),
    [anon_sym_PIPE_PIPE] = ACTIONS(2012),
    [anon_sym_QMARK] = ACTIONS(2012),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2012),
    [anon_sym_as] = ACTIONS(2012),
    [anon_sym_else] = ACTIONS(2795),
    [sym_line_comment] = ACTIONS(7),
  },
  [759] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2220),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2220),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_COMMA] = ACTIONS(2220),
    [anon_sym_AMP] = ACTIONS(677),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(679),
    [anon_sym_BANG_EQ] = ACTIONS(681),
    [anon_sym_STAR_EQ] = ACTIONS(679),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_SLASH_EQ] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(683),
    [anon_sym_AMP_EQ] = ACTIONS(679),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_PERCENT_EQ] = ACTIONS(679),
    [anon_sym_CARET] = ACTIONS(685),
    [anon_sym_CARET_EQ] = ACTIONS(679),
    [anon_sym_PLUS_EQ] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_LT_LT] = ACTIONS(689),
    [anon_sym_LT_LT_EQ] = ACTIONS(679),
    [anon_sym_LT_EQ] = ACTIONS(681),
    [anon_sym_EQ] = ACTIONS(691),
    [anon_sym_EQ_EQ] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(689),
    [anon_sym_GT_GT_EQ] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(693),
    [anon_sym_PIPE_EQ] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(697),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(699),
    [anon_sym_as] = ACTIONS(701),
    [sym_line_comment] = ACTIONS(7),
  },
  [760] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2797),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_STAR_EQ] = ACTIONS(2563),
    [anon_sym_SLASH] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_AMP_EQ] = ACTIONS(2563),
    [anon_sym_PERCENT] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2563),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_CARET_EQ] = ACTIONS(2563),
    [anon_sym_PLUS_EQ] = ACTIONS(2563),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_LT_LT] = ACTIONS(2573),
    [anon_sym_LT_LT_EQ] = ACTIONS(2563),
    [anon_sym_LT_EQ] = ACTIONS(2565),
    [anon_sym_EQ] = ACTIONS(2575),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_GT_EQ] = ACTIONS(2565),
    [anon_sym_GT_GT] = ACTIONS(2573),
    [anon_sym_GT_GT_EQ] = ACTIONS(2563),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_PIPE_EQ] = ACTIONS(2563),
    [anon_sym_PIPE_PIPE] = ACTIONS(2579),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(2581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2583),
    [anon_sym_as] = ACTIONS(2585),
    [sym_line_comment] = ACTIONS(7),
  },
  [761] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2591),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [762] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2799),
    [anon_sym_LPAREN] = ACTIONS(2799),
    [anon_sym_RPAREN] = ACTIONS(2799),
    [anon_sym_LBRACE] = ACTIONS(2799),
    [anon_sym_RBRACE] = ACTIONS(2799),
    [anon_sym_LBRACK] = ACTIONS(2799),
    [anon_sym_RBRACK] = ACTIONS(2799),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(2801),
    [anon_sym_COMMA] = ACTIONS(2799),
    [anon_sym_AMP] = ACTIONS(2801),
    [anon_sym_DASH] = ACTIONS(2801),
    [anon_sym_DOT] = ACTIONS(2801),
    [anon_sym_DASH_EQ] = ACTIONS(2799),
    [anon_sym_BANG_EQ] = ACTIONS(2799),
    [anon_sym_STAR_EQ] = ACTIONS(2799),
    [anon_sym_SLASH] = ACTIONS(2801),
    [anon_sym_SLASH_EQ] = ACTIONS(2799),
    [anon_sym_AMP_AMP] = ACTIONS(2799),
    [anon_sym_AMP_EQ] = ACTIONS(2799),
    [anon_sym_PERCENT] = ACTIONS(2801),
    [anon_sym_PERCENT_EQ] = ACTIONS(2799),
    [anon_sym_CARET] = ACTIONS(2801),
    [anon_sym_CARET_EQ] = ACTIONS(2799),
    [anon_sym_PLUS_EQ] = ACTIONS(2799),
    [anon_sym_LT] = ACTIONS(2801),
    [anon_sym_LT_LT] = ACTIONS(2801),
    [anon_sym_LT_LT_EQ] = ACTIONS(2799),
    [anon_sym_LT_EQ] = ACTIONS(2799),
    [anon_sym_EQ] = ACTIONS(2801),
    [anon_sym_EQ_EQ] = ACTIONS(2799),
    [anon_sym_GT] = ACTIONS(2801),
    [anon_sym_GT_EQ] = ACTIONS(2799),
    [anon_sym_GT_GT] = ACTIONS(2801),
    [anon_sym_GT_GT_EQ] = ACTIONS(2799),
    [anon_sym_PIPE] = ACTIONS(2801),
    [anon_sym_PIPE_EQ] = ACTIONS(2799),
    [anon_sym_PIPE_PIPE] = ACTIONS(2799),
    [anon_sym_QMARK] = ACTIONS(2799),
    [anon_sym_DOT_DOT] = ACTIONS(2801),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2799),
    [anon_sym_as] = ACTIONS(2799),
    [sym_line_comment] = ACTIONS(7),
  },
  [763] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(103),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(103),
    [sym_macro_invocation] = STATE(103),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(103),
    [sym_unary_expression] = STATE(103),
    [sym_try_expression] = STATE(103),
    [sym_reference_expression] = STATE(103),
    [sym_binary_expression] = STATE(103),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(103),
    [sym_call_expression] = STATE(103),
    [sym_array_expression] = STATE(103),
    [sym_parenthesized_expression] = STATE(103),
    [sym_tuple_expression] = STATE(103),
    [sym_unit_expression] = STATE(103),
    [sym_struct_expression] = STATE(103),
    [sym_if_expression] = STATE(103),
    [sym_if_let_expression] = STATE(103),
    [sym_match_expression] = STATE(103),
    [sym_while_expression] = STATE(103),
    [sym_while_let_expression] = STATE(103),
    [sym_loop_expression] = STATE(103),
    [sym_for_expression] = STATE(103),
    [sym_closure_expression] = STATE(103),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(103),
    [sym_continue_expression] = STATE(103),
    [sym_index_expression] = STATE(103),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(103),
    [sym_block] = STATE(103),
    [sym__literal] = STATE(103),
    [sym_string_literal] = STATE(103),
    [sym_boolean_literal] = STATE(103),
    [sym_raw_string_literal] = ACTIONS(173),
    [sym_float_literal] = ACTIONS(173),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(173),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(173),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [764] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(106),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(106),
    [sym_macro_invocation] = STATE(106),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(106),
    [sym_unary_expression] = STATE(106),
    [sym_try_expression] = STATE(106),
    [sym_reference_expression] = STATE(106),
    [sym_binary_expression] = STATE(106),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(106),
    [sym_call_expression] = STATE(106),
    [sym_array_expression] = STATE(106),
    [sym_parenthesized_expression] = STATE(106),
    [sym_tuple_expression] = STATE(106),
    [sym_unit_expression] = STATE(106),
    [sym_struct_expression] = STATE(106),
    [sym_if_expression] = STATE(106),
    [sym_if_let_expression] = STATE(106),
    [sym_match_expression] = STATE(106),
    [sym_while_expression] = STATE(106),
    [sym_while_let_expression] = STATE(106),
    [sym_loop_expression] = STATE(106),
    [sym_for_expression] = STATE(106),
    [sym_closure_expression] = STATE(106),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(106),
    [sym_continue_expression] = STATE(106),
    [sym_index_expression] = STATE(106),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(106),
    [sym_block] = STATE(106),
    [sym__literal] = STATE(106),
    [sym_string_literal] = STATE(106),
    [sym_boolean_literal] = STATE(106),
    [sym_raw_string_literal] = ACTIONS(183),
    [sym_float_literal] = ACTIONS(183),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [sym_mutable_specifier] = ACTIONS(2803),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(183),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(183),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [765] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1427),
    [sym_macro_invocation] = STATE(1427),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1427),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_if_let_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_while_let_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1427),
    [sym_boolean_literal] = STATE(1427),
    [sym_raw_string_literal] = ACTIONS(2805),
    [sym_float_literal] = ACTIONS(2805),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_RBRACK] = ACTIONS(261),
    [anon_sym_PLUS] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(263),
    [anon_sym_COMMA] = ACTIONS(261),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(263),
    [anon_sym_DASH] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(263),
    [anon_sym_DASH_EQ] = ACTIONS(261),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(261),
    [anon_sym_STAR_EQ] = ACTIONS(261),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_SLASH_EQ] = ACTIONS(261),
    [anon_sym_AMP_AMP] = ACTIONS(261),
    [anon_sym_AMP_EQ] = ACTIONS(261),
    [anon_sym_PERCENT] = ACTIONS(263),
    [anon_sym_PERCENT_EQ] = ACTIONS(261),
    [anon_sym_CARET] = ACTIONS(263),
    [anon_sym_CARET_EQ] = ACTIONS(261),
    [anon_sym_PLUS_EQ] = ACTIONS(261),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_EQ] = ACTIONS(261),
    [anon_sym_LT_EQ] = ACTIONS(261),
    [anon_sym_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(261),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_EQ] = ACTIONS(261),
    [anon_sym_GT_GT] = ACTIONS(263),
    [anon_sym_GT_GT_EQ] = ACTIONS(261),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_PIPE_EQ] = ACTIONS(261),
    [anon_sym_PIPE_PIPE] = ACTIONS(261),
    [anon_sym_QMARK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(263),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(261),
    [anon_sym_as] = ACTIONS(263),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(2805),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(2805),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [766] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1429),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(1429),
    [sym_macro_invocation] = STATE(1429),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1429),
    [sym_unary_expression] = STATE(1429),
    [sym_try_expression] = STATE(1429),
    [sym_reference_expression] = STATE(1429),
    [sym_binary_expression] = STATE(1429),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1429),
    [sym_call_expression] = STATE(1429),
    [sym_array_expression] = STATE(1429),
    [sym_parenthesized_expression] = STATE(1429),
    [sym_tuple_expression] = STATE(1429),
    [sym_unit_expression] = STATE(1429),
    [sym_struct_expression] = STATE(1429),
    [sym_if_expression] = STATE(1429),
    [sym_if_let_expression] = STATE(1429),
    [sym_match_expression] = STATE(1429),
    [sym_while_expression] = STATE(1429),
    [sym_while_let_expression] = STATE(1429),
    [sym_loop_expression] = STATE(1429),
    [sym_for_expression] = STATE(1429),
    [sym_closure_expression] = STATE(1429),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1429),
    [sym_continue_expression] = STATE(1429),
    [sym_index_expression] = STATE(1429),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1429),
    [sym_block] = STATE(1429),
    [sym__literal] = STATE(1429),
    [sym_string_literal] = STATE(1429),
    [sym_boolean_literal] = STATE(1429),
    [sym_raw_string_literal] = ACTIONS(2809),
    [sym_float_literal] = ACTIONS(2809),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_let] = ACTIONS(2811),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(2809),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(2809),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [767] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1430),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1430),
    [sym_macro_invocation] = STATE(1430),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1430),
    [sym_unary_expression] = STATE(1430),
    [sym_try_expression] = STATE(1430),
    [sym_reference_expression] = STATE(1430),
    [sym_binary_expression] = STATE(1430),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1430),
    [sym_call_expression] = STATE(1430),
    [sym_array_expression] = STATE(1430),
    [sym_parenthesized_expression] = STATE(1430),
    [sym_tuple_expression] = STATE(1430),
    [sym_unit_expression] = STATE(1430),
    [sym_struct_expression] = STATE(1430),
    [sym_if_expression] = STATE(1430),
    [sym_if_let_expression] = STATE(1430),
    [sym_match_expression] = STATE(1430),
    [sym_while_expression] = STATE(1430),
    [sym_while_let_expression] = STATE(1430),
    [sym_loop_expression] = STATE(1430),
    [sym_for_expression] = STATE(1430),
    [sym_closure_expression] = STATE(1430),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1430),
    [sym_continue_expression] = STATE(1430),
    [sym_index_expression] = STATE(1430),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1430),
    [sym_block] = STATE(1430),
    [sym__literal] = STATE(1430),
    [sym_string_literal] = STATE(1430),
    [sym_boolean_literal] = STATE(1430),
    [sym_raw_string_literal] = ACTIONS(2813),
    [sym_float_literal] = ACTIONS(2813),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(359),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(359),
    [anon_sym_RBRACK] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(361),
    [anon_sym_STAR] = ACTIONS(361),
    [anon_sym_COMMA] = ACTIONS(359),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(361),
    [anon_sym_DASH_EQ] = ACTIONS(359),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(359),
    [anon_sym_STAR_EQ] = ACTIONS(359),
    [anon_sym_SLASH] = ACTIONS(361),
    [anon_sym_SLASH_EQ] = ACTIONS(359),
    [anon_sym_AMP_AMP] = ACTIONS(359),
    [anon_sym_AMP_EQ] = ACTIONS(359),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_PERCENT_EQ] = ACTIONS(359),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_CARET_EQ] = ACTIONS(359),
    [anon_sym_PLUS_EQ] = ACTIONS(359),
    [anon_sym_LT] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_LT_LT_EQ] = ACTIONS(359),
    [anon_sym_LT_EQ] = ACTIONS(359),
    [anon_sym_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(359),
    [anon_sym_GT] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(359),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_GT_GT_EQ] = ACTIONS(359),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_PIPE_EQ] = ACTIONS(359),
    [anon_sym_PIPE_PIPE] = ACTIONS(359),
    [anon_sym_QMARK] = ACTIONS(359),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(361),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(359),
    [anon_sym_as] = ACTIONS(361),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(2813),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(2813),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [768] = {
    [sym_closure_parameters] = STATE(1431),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(7),
  },
  [769] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2815),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_STAR] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(2821),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2823),
    [anon_sym_BANG_EQ] = ACTIONS(2825),
    [anon_sym_STAR_EQ] = ACTIONS(2823),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_SLASH_EQ] = ACTIONS(2823),
    [anon_sym_AMP_AMP] = ACTIONS(2827),
    [anon_sym_AMP_EQ] = ACTIONS(2823),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_PERCENT_EQ] = ACTIONS(2823),
    [anon_sym_CARET] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2823),
    [anon_sym_PLUS_EQ] = ACTIONS(2823),
    [anon_sym_LT] = ACTIONS(2831),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_LT_LT_EQ] = ACTIONS(2823),
    [anon_sym_LT_EQ] = ACTIONS(2825),
    [anon_sym_EQ] = ACTIONS(2835),
    [anon_sym_EQ_EQ] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2831),
    [anon_sym_GT_EQ] = ACTIONS(2825),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_GT_GT_EQ] = ACTIONS(2823),
    [anon_sym_PIPE] = ACTIONS(2837),
    [anon_sym_PIPE_EQ] = ACTIONS(2823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2839),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(2841),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2843),
    [anon_sym_as] = ACTIONS(2845),
    [sym_line_comment] = ACTIONS(7),
  },
  [770] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1446),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1446),
    [sym_macro_invocation] = STATE(1446),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1446),
    [sym_unary_expression] = STATE(1446),
    [sym_try_expression] = STATE(1446),
    [sym_reference_expression] = STATE(1446),
    [sym_binary_expression] = STATE(1446),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1446),
    [sym_call_expression] = STATE(1446),
    [sym_array_expression] = STATE(1446),
    [sym_parenthesized_expression] = STATE(1446),
    [sym_tuple_expression] = STATE(1446),
    [sym_unit_expression] = STATE(1446),
    [sym_struct_expression] = STATE(1446),
    [sym_if_expression] = STATE(1446),
    [sym_if_let_expression] = STATE(1446),
    [sym_match_expression] = STATE(1446),
    [sym_while_expression] = STATE(1446),
    [sym_while_let_expression] = STATE(1446),
    [sym_loop_expression] = STATE(1446),
    [sym_for_expression] = STATE(1446),
    [sym_closure_expression] = STATE(1446),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1446),
    [sym_continue_expression] = STATE(1446),
    [sym_index_expression] = STATE(1446),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1446),
    [sym_block] = STATE(1446),
    [sym__literal] = STATE(1446),
    [sym_string_literal] = STATE(1446),
    [sym_boolean_literal] = STATE(1446),
    [sym_raw_string_literal] = ACTIONS(2847),
    [sym_float_literal] = ACTIONS(2847),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_DASH_GT] = ACTIONS(509),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(2847),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(2847),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [771] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(689),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(689),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [772] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2601),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2601),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_COMMA] = ACTIONS(2601),
    [anon_sym_AMP] = ACTIONS(677),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2601),
    [anon_sym_BANG_EQ] = ACTIONS(681),
    [anon_sym_STAR_EQ] = ACTIONS(2601),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_SLASH_EQ] = ACTIONS(2601),
    [anon_sym_AMP_AMP] = ACTIONS(683),
    [anon_sym_AMP_EQ] = ACTIONS(2601),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_PERCENT_EQ] = ACTIONS(2601),
    [anon_sym_CARET] = ACTIONS(685),
    [anon_sym_CARET_EQ] = ACTIONS(2601),
    [anon_sym_PLUS_EQ] = ACTIONS(2601),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_LT_LT] = ACTIONS(689),
    [anon_sym_LT_LT_EQ] = ACTIONS(2601),
    [anon_sym_LT_EQ] = ACTIONS(681),
    [anon_sym_EQ] = ACTIONS(2603),
    [anon_sym_EQ_EQ] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(689),
    [anon_sym_GT_GT_EQ] = ACTIONS(2601),
    [anon_sym_PIPE] = ACTIONS(693),
    [anon_sym_PIPE_EQ] = ACTIONS(2601),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_QMARK] = ACTIONS(2601),
    [anon_sym_DOT_DOT] = ACTIONS(697),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(699),
    [anon_sym_as] = ACTIONS(2601),
    [sym_line_comment] = ACTIONS(7),
  },
  [773] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(677),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(685),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(689),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(689),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(693),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [774] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(677),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(681),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(685),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_LT_LT] = ACTIONS(689),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(681),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(689),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(693),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [775] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(677),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(689),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(689),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [776] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2591),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [777] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2605),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2605),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_COMMA] = ACTIONS(2605),
    [anon_sym_AMP] = ACTIONS(677),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2605),
    [anon_sym_BANG_EQ] = ACTIONS(681),
    [anon_sym_STAR_EQ] = ACTIONS(2605),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_SLASH_EQ] = ACTIONS(2605),
    [anon_sym_AMP_AMP] = ACTIONS(683),
    [anon_sym_AMP_EQ] = ACTIONS(2605),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_PERCENT_EQ] = ACTIONS(2605),
    [anon_sym_CARET] = ACTIONS(685),
    [anon_sym_CARET_EQ] = ACTIONS(2605),
    [anon_sym_PLUS_EQ] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_LT_LT] = ACTIONS(689),
    [anon_sym_LT_LT_EQ] = ACTIONS(2605),
    [anon_sym_LT_EQ] = ACTIONS(681),
    [anon_sym_EQ] = ACTIONS(2607),
    [anon_sym_EQ_EQ] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(689),
    [anon_sym_GT_GT_EQ] = ACTIONS(2605),
    [anon_sym_PIPE] = ACTIONS(693),
    [anon_sym_PIPE_EQ] = ACTIONS(2605),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_QMARK] = ACTIONS(2605),
    [anon_sym_DOT_DOT] = ACTIONS(697),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(699),
    [anon_sym_as] = ACTIONS(2605),
    [sym_line_comment] = ACTIONS(7),
  },
  [778] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(677),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(685),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(689),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(689),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [779] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(677),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(681),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(683),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(685),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_LT_LT] = ACTIONS(689),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(681),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(689),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(693),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [780] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2609),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2609),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_COMMA] = ACTIONS(2609),
    [anon_sym_AMP] = ACTIONS(677),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2609),
    [anon_sym_BANG_EQ] = ACTIONS(681),
    [anon_sym_STAR_EQ] = ACTIONS(2609),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_SLASH_EQ] = ACTIONS(2609),
    [anon_sym_AMP_AMP] = ACTIONS(683),
    [anon_sym_AMP_EQ] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_PERCENT_EQ] = ACTIONS(2609),
    [anon_sym_CARET] = ACTIONS(685),
    [anon_sym_CARET_EQ] = ACTIONS(2609),
    [anon_sym_PLUS_EQ] = ACTIONS(2609),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_LT_LT] = ACTIONS(689),
    [anon_sym_LT_LT_EQ] = ACTIONS(2609),
    [anon_sym_LT_EQ] = ACTIONS(681),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_EQ_EQ] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(689),
    [anon_sym_GT_GT_EQ] = ACTIONS(2609),
    [anon_sym_PIPE] = ACTIONS(693),
    [anon_sym_PIPE_EQ] = ACTIONS(2609),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_QMARK] = ACTIONS(2609),
    [anon_sym_DOT_DOT] = ACTIONS(2611),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2609),
    [anon_sym_as] = ACTIONS(2609),
    [sym_line_comment] = ACTIONS(7),
  },
  [781] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(2849),
    [sym_mutable_specifier] = ACTIONS(2849),
    [sym_line_comment] = ACTIONS(7),
  },
  [782] = {
    [sym_function_modifiers] = STATE(785),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1319),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(1449),
    [sym_array_type] = STATE(1319),
    [sym_function_type] = STATE(1319),
    [sym_tuple_type] = STATE(1319),
    [sym_unit_type] = STATE(1319),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(1319),
    [sym_reference_type] = STATE(1319),
    [sym_pointer_type] = STATE(1319),
    [sym_empty_type] = STATE(1319),
    [sym_dynamic_type] = STATE(1319),
    [sym_macro_invocation] = STATE(1319),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(787),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1656),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1658),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1660),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_mutable_specifier] = ACTIONS(2851),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1662),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [783] = {
    [sym_parameters] = STATE(1450),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [sym_line_comment] = ACTIONS(7),
  },
  [784] = {
    [sym_parameters] = STATE(1451),
    [sym_type_arguments] = STATE(1330),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(773),
    [anon_sym_RBRACK] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(2633),
    [anon_sym_STAR] = ACTIONS(2633),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_DASH] = ACTIONS(2633),
    [anon_sym_DOT] = ACTIONS(2633),
    [anon_sym_DASH_EQ] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(2635),
    [anon_sym_BANG] = ACTIONS(557),
    [anon_sym_BANG_EQ] = ACTIONS(773),
    [anon_sym_STAR_EQ] = ACTIONS(773),
    [anon_sym_SLASH] = ACTIONS(2633),
    [anon_sym_SLASH_EQ] = ACTIONS(773),
    [anon_sym_AMP_AMP] = ACTIONS(773),
    [anon_sym_AMP_EQ] = ACTIONS(773),
    [anon_sym_PERCENT] = ACTIONS(2633),
    [anon_sym_PERCENT_EQ] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(2633),
    [anon_sym_CARET_EQ] = ACTIONS(773),
    [anon_sym_PLUS_EQ] = ACTIONS(773),
    [anon_sym_LT] = ACTIONS(2637),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_LT_LT_EQ] = ACTIONS(773),
    [anon_sym_LT_EQ] = ACTIONS(773),
    [anon_sym_EQ] = ACTIONS(2633),
    [anon_sym_EQ_EQ] = ACTIONS(773),
    [anon_sym_GT] = ACTIONS(2633),
    [anon_sym_GT_EQ] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_GT_GT_EQ] = ACTIONS(773),
    [anon_sym_PIPE] = ACTIONS(2633),
    [anon_sym_PIPE_EQ] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(773),
    [anon_sym_QMARK] = ACTIONS(773),
    [anon_sym_DOT_DOT] = ACTIONS(2633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(773),
    [anon_sym_as] = ACTIONS(773),
    [sym_line_comment] = ACTIONS(7),
  },
  [785] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1454),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_fn] = ACTIONS(2853),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2855),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [786] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(2857),
    [sym_line_comment] = ACTIONS(7),
  },
  [787] = {
    [sym_parameters] = STATE(1450),
    [sym_type_arguments] = STATE(1340),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(783),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(783),
    [anon_sym_RBRACK] = ACTIONS(783),
    [anon_sym_PLUS] = ACTIONS(785),
    [anon_sym_STAR] = ACTIONS(785),
    [anon_sym_COMMA] = ACTIONS(783),
    [anon_sym_AMP] = ACTIONS(785),
    [anon_sym_DASH] = ACTIONS(785),
    [anon_sym_DOT] = ACTIONS(785),
    [anon_sym_DASH_EQ] = ACTIONS(783),
    [anon_sym_BANG_EQ] = ACTIONS(783),
    [anon_sym_STAR_EQ] = ACTIONS(783),
    [anon_sym_SLASH] = ACTIONS(785),
    [anon_sym_SLASH_EQ] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_AMP_EQ] = ACTIONS(783),
    [anon_sym_PERCENT] = ACTIONS(785),
    [anon_sym_PERCENT_EQ] = ACTIONS(783),
    [anon_sym_CARET] = ACTIONS(785),
    [anon_sym_CARET_EQ] = ACTIONS(783),
    [anon_sym_PLUS_EQ] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(2637),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_LT_LT_EQ] = ACTIONS(783),
    [anon_sym_LT_EQ] = ACTIONS(783),
    [anon_sym_EQ] = ACTIONS(785),
    [anon_sym_EQ_EQ] = ACTIONS(783),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_GT_EQ] = ACTIONS(783),
    [anon_sym_GT_GT] = ACTIONS(785),
    [anon_sym_GT_GT_EQ] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PIPE_EQ] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_DOT_DOT] = ACTIONS(785),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(783),
    [anon_sym_as] = ACTIONS(783),
    [sym_line_comment] = ACTIONS(7),
  },
  [788] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(769),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(769),
    [sym_macro_invocation] = STATE(769),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(769),
    [sym_unary_expression] = STATE(769),
    [sym_try_expression] = STATE(769),
    [sym_reference_expression] = STATE(769),
    [sym_binary_expression] = STATE(769),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(769),
    [sym_call_expression] = STATE(769),
    [sym_array_expression] = STATE(769),
    [sym_parenthesized_expression] = STATE(769),
    [sym_tuple_expression] = STATE(769),
    [sym_unit_expression] = STATE(769),
    [sym_struct_expression] = STATE(769),
    [sym_if_expression] = STATE(769),
    [sym_if_let_expression] = STATE(769),
    [sym_match_expression] = STATE(769),
    [sym_while_expression] = STATE(769),
    [sym_while_let_expression] = STATE(769),
    [sym_loop_expression] = STATE(769),
    [sym_for_expression] = STATE(769),
    [sym_closure_expression] = STATE(769),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(769),
    [sym_continue_expression] = STATE(769),
    [sym_index_expression] = STATE(769),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(769),
    [sym_block] = STATE(769),
    [sym__literal] = STATE(769),
    [sym_string_literal] = STATE(769),
    [sym_boolean_literal] = STATE(769),
    [sym_raw_string_literal] = ACTIONS(1620),
    [sym_float_literal] = ACTIONS(1620),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_RBRACK] = ACTIONS(2797),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1620),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1620),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [789] = {
    [aux_sym_token_tree_repeat2] = STATE(789),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACK] = ACTIONS(2815),
    [anon_sym_COMMA] = ACTIONS(2859),
    [sym_line_comment] = ACTIONS(7),
  },
  [790] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(2862),
    [sym_line_comment] = ACTIONS(7),
  },
  [791] = {
    [sym_else_tail] = STATE(1378),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2012),
    [anon_sym_LPAREN] = ACTIONS(2012),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_PLUS] = ACTIONS(2014),
    [anon_sym_STAR] = ACTIONS(2014),
    [anon_sym_AMP] = ACTIONS(2014),
    [anon_sym_DASH] = ACTIONS(2014),
    [anon_sym_DOT] = ACTIONS(2014),
    [anon_sym_DASH_EQ] = ACTIONS(2012),
    [anon_sym_BANG_EQ] = ACTIONS(2012),
    [anon_sym_STAR_EQ] = ACTIONS(2012),
    [anon_sym_SLASH] = ACTIONS(2014),
    [anon_sym_SLASH_EQ] = ACTIONS(2012),
    [anon_sym_AMP_AMP] = ACTIONS(2012),
    [anon_sym_AMP_EQ] = ACTIONS(2012),
    [anon_sym_PERCENT] = ACTIONS(2014),
    [anon_sym_PERCENT_EQ] = ACTIONS(2012),
    [anon_sym_CARET] = ACTIONS(2014),
    [anon_sym_CARET_EQ] = ACTIONS(2012),
    [anon_sym_PLUS_EQ] = ACTIONS(2012),
    [anon_sym_LT] = ACTIONS(2014),
    [anon_sym_LT_LT] = ACTIONS(2014),
    [anon_sym_LT_LT_EQ] = ACTIONS(2012),
    [anon_sym_LT_EQ] = ACTIONS(2012),
    [anon_sym_EQ] = ACTIONS(2014),
    [anon_sym_EQ_EQ] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2014),
    [anon_sym_GT_EQ] = ACTIONS(2012),
    [anon_sym_GT_GT] = ACTIONS(2014),
    [anon_sym_GT_GT_EQ] = ACTIONS(2012),
    [anon_sym_PIPE] = ACTIONS(2014),
    [anon_sym_PIPE_EQ] = ACTIONS(2012),
    [anon_sym_PIPE_PIPE] = ACTIONS(2012),
    [anon_sym_QMARK] = ACTIONS(2012),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2012),
    [anon_sym_as] = ACTIONS(2012),
    [anon_sym_else] = ACTIONS(2864),
    [sym_line_comment] = ACTIONS(7),
  },
  [792] = {
    [sym_meta_item] = STATE(1462),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(2866),
    [anon_sym_COMMA] = ACTIONS(2868),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(727),
  },
  [793] = {
    [sym__literal] = STATE(1460),
    [sym_string_literal] = STATE(1460),
    [sym_boolean_literal] = STATE(1460),
    [sym_raw_string_literal] = ACTIONS(2866),
    [sym_float_literal] = ACTIONS(2866),
    [sym_block_comment] = ACTIONS(7),
    [sym_integer_literal] = ACTIONS(2866),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(2866),
    [anon_sym_true] = ACTIONS(2870),
    [anon_sym_false] = ACTIONS(2870),
    [sym_line_comment] = ACTIONS(7),
  },
  [794] = {
    [sym_raw_string_literal] = ACTIONS(2872),
    [sym_float_literal] = ACTIONS(2872),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(2872),
    [anon_sym_SEMI] = ACTIONS(2872),
    [anon_sym_macro_rules_BANG] = ACTIONS(2872),
    [anon_sym_LPAREN] = ACTIONS(2872),
    [anon_sym_LBRACE] = ACTIONS(2872),
    [anon_sym_RBRACE] = ACTIONS(2872),
    [anon_sym_LBRACK] = ACTIONS(2872),
    [anon_sym_STAR] = ACTIONS(2872),
    [anon_sym_u8] = ACTIONS(2874),
    [anon_sym_i8] = ACTIONS(2874),
    [anon_sym_u16] = ACTIONS(2874),
    [anon_sym_i16] = ACTIONS(2874),
    [anon_sym_u32] = ACTIONS(2874),
    [anon_sym_i32] = ACTIONS(2874),
    [anon_sym_u64] = ACTIONS(2874),
    [anon_sym_i64] = ACTIONS(2874),
    [anon_sym_u128] = ACTIONS(2874),
    [anon_sym_i128] = ACTIONS(2874),
    [anon_sym_isize] = ACTIONS(2874),
    [anon_sym_usize] = ACTIONS(2874),
    [anon_sym_f32] = ACTIONS(2874),
    [anon_sym_f64] = ACTIONS(2874),
    [anon_sym_bool] = ACTIONS(2874),
    [anon_sym_str] = ACTIONS(2874),
    [anon_sym_char] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2872),
    [anon_sym_DASH] = ACTIONS(2872),
    [anon_sym_COLON_COLON] = ACTIONS(2872),
    [anon_sym_BANG] = ACTIONS(2872),
    [anon_sym_POUND] = ACTIONS(2872),
    [anon_sym_LT] = ACTIONS(2872),
    [anon_sym_PIPE] = ACTIONS(2872),
    [anon_sym_SQUOTE] = ACTIONS(2874),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [anon_sym_break] = ACTIONS(2874),
    [anon_sym_const] = ACTIONS(2874),
    [anon_sym_continue] = ACTIONS(2874),
    [anon_sym_default] = ACTIONS(2874),
    [anon_sym_enum] = ACTIONS(2874),
    [anon_sym_fn] = ACTIONS(2874),
    [anon_sym_for] = ACTIONS(2874),
    [anon_sym_if] = ACTIONS(2874),
    [anon_sym_impl] = ACTIONS(2874),
    [anon_sym_let] = ACTIONS(2874),
    [anon_sym_loop] = ACTIONS(2874),
    [anon_sym_match] = ACTIONS(2874),
    [anon_sym_mod] = ACTIONS(2874),
    [anon_sym_pub] = ACTIONS(2874),
    [anon_sym_return] = ACTIONS(2874),
    [anon_sym_static] = ACTIONS(2874),
    [anon_sym_struct] = ACTIONS(2874),
    [anon_sym_trait] = ACTIONS(2874),
    [anon_sym_type] = ACTIONS(2874),
    [anon_sym_union] = ACTIONS(2874),
    [anon_sym_unsafe] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2874),
    [anon_sym_while] = ACTIONS(2874),
    [anon_sym_extern] = ACTIONS(2874),
    [anon_sym_move] = ACTIONS(2874),
    [sym_integer_literal] = ACTIONS(2872),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2872),
    [sym_char_literal] = ACTIONS(2872),
    [anon_sym_true] = ACTIONS(2874),
    [anon_sym_false] = ACTIONS(2874),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2874),
    [sym_self] = ACTIONS(2874),
    [sym_super] = ACTIONS(2874),
    [sym_crate] = ACTIONS(2874),
    [sym_metavariable] = ACTIONS(2872),
  },
  [795] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACK] = ACTIONS(2876),
    [sym_line_comment] = ACTIONS(7),
  },
  [796] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(821),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(821),
    [sym_function_type] = STATE(821),
    [sym_tuple_type] = STATE(821),
    [sym_unit_type] = STATE(821),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(821),
    [sym_reference_type] = STATE(821),
    [sym_pointer_type] = STATE(821),
    [sym_empty_type] = STATE(821),
    [sym_dynamic_type] = STATE(821),
    [sym_macro_invocation] = STATE(821),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [797] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [798] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(1704),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(2878),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [799] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(1760),
    [anon_sym_PLUS] = ACTIONS(1760),
    [anon_sym_COMMA] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(2880),
    [sym_line_comment] = ACTIONS(7),
  },
  [800] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(1794),
    [anon_sym_PLUS] = ACTIONS(1794),
    [anon_sym_COMMA] = ACTIONS(1794),
    [anon_sym_DASH_GT] = ACTIONS(2882),
    [sym_line_comment] = ACTIONS(7),
  },
  [801] = {
    [sym_parameters] = STATE(1467),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [802] = {
    [sym_parameters] = STATE(1468),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [803] = {
    [sym_parameters] = STATE(1467),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [804] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2884),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_RPAREN] = ACTIONS(2884),
    [anon_sym_LBRACE] = ACTIONS(2884),
    [anon_sym_RBRACE] = ACTIONS(2884),
    [anon_sym_RBRACK] = ACTIONS(2884),
    [anon_sym_COLON] = ACTIONS(2884),
    [anon_sym_PLUS] = ACTIONS(2884),
    [anon_sym_COMMA] = ACTIONS(2884),
    [anon_sym_EQ] = ACTIONS(2884),
    [anon_sym_GT] = ACTIONS(2884),
    [anon_sym_PIPE] = ACTIONS(2884),
    [anon_sym_as] = ACTIONS(2884),
    [anon_sym_where] = ACTIONS(2884),
    [sym_line_comment] = ACTIONS(7),
  },
  [805] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(862),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [806] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1470),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(1470),
    [sym_function_type] = STATE(1470),
    [sym_tuple_type] = STATE(1470),
    [sym_unit_type] = STATE(1470),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1470),
    [sym_reference_type] = STATE(1470),
    [sym_pointer_type] = STATE(1470),
    [sym_empty_type] = STATE(1470),
    [sym_dynamic_type] = STATE(1470),
    [sym_macro_invocation] = STATE(1470),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_RPAREN] = ACTIONS(2886),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [807] = {
    [aux_sym_tuple_type_repeat1] = STATE(1472),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(2886),
    [anon_sym_COMMA] = ACTIONS(2888),
    [sym_line_comment] = ACTIONS(7),
  },
  [808] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [809] = {
    [sym_function_modifiers] = STATE(378),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(821),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(380),
    [sym_array_type] = STATE(821),
    [sym_function_type] = STATE(821),
    [sym_tuple_type] = STATE(821),
    [sym_unit_type] = STATE(821),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(821),
    [sym_reference_type] = STATE(821),
    [sym_pointer_type] = STATE(821),
    [sym_empty_type] = STATE(821),
    [sym_dynamic_type] = STATE(821),
    [sym_macro_invocation] = STATE(821),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(381),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(741),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(745),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(747),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [810] = {
    [sym_function_modifiers] = STATE(378),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(380),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(381),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(741),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(745),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(747),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [811] = {
    [sym_function_modifiers] = STATE(378),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(380),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(381),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_STAR] = ACTIONS(741),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(745),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(2890),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(747),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [812] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1760),
    [anon_sym_RBRACK] = ACTIONS(1760),
    [anon_sym_PLUS] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(2892),
    [sym_line_comment] = ACTIONS(7),
  },
  [813] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1794),
    [anon_sym_RBRACK] = ACTIONS(1794),
    [anon_sym_PLUS] = ACTIONS(1794),
    [anon_sym_DASH_GT] = ACTIONS(2894),
    [sym_line_comment] = ACTIONS(7),
  },
  [814] = {
    [sym_parameters] = STATE(1476),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [815] = {
    [sym_parameters] = STATE(1477),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [816] = {
    [sym_parameters] = STATE(1476),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [817] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1478),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1478),
    [sym_macro_invocation] = STATE(1478),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1478),
    [sym_unary_expression] = STATE(1478),
    [sym_try_expression] = STATE(1478),
    [sym_reference_expression] = STATE(1478),
    [sym_binary_expression] = STATE(1478),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1478),
    [sym_call_expression] = STATE(1478),
    [sym_array_expression] = STATE(1478),
    [sym_parenthesized_expression] = STATE(1478),
    [sym_tuple_expression] = STATE(1478),
    [sym_unit_expression] = STATE(1478),
    [sym_struct_expression] = STATE(1478),
    [sym_if_expression] = STATE(1478),
    [sym_if_let_expression] = STATE(1478),
    [sym_match_expression] = STATE(1478),
    [sym_while_expression] = STATE(1478),
    [sym_while_let_expression] = STATE(1478),
    [sym_loop_expression] = STATE(1478),
    [sym_for_expression] = STATE(1478),
    [sym_closure_expression] = STATE(1478),
    [sym_closure_parameters] = STATE(638),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1478),
    [sym_continue_expression] = STATE(1478),
    [sym_index_expression] = STATE(1478),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1478),
    [sym_block] = STATE(1478),
    [sym__literal] = STATE(1478),
    [sym_string_literal] = STATE(1478),
    [sym_boolean_literal] = STATE(1478),
    [sym_raw_string_literal] = ACTIONS(2896),
    [sym_float_literal] = ACTIONS(2896),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1245),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1247),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1251),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1253),
    [sym_integer_literal] = ACTIONS(2896),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(2896),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [818] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2898),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(2898),
    [anon_sym_LBRACE] = ACTIONS(2898),
    [anon_sym_RBRACE] = ACTIONS(2898),
    [anon_sym_RBRACK] = ACTIONS(2898),
    [anon_sym_COLON] = ACTIONS(2898),
    [anon_sym_PLUS] = ACTIONS(2898),
    [anon_sym_COMMA] = ACTIONS(2898),
    [anon_sym_EQ] = ACTIONS(2898),
    [anon_sym_GT] = ACTIONS(2898),
    [anon_sym_PIPE] = ACTIONS(2898),
    [anon_sym_as] = ACTIONS(2898),
    [anon_sym_where] = ACTIONS(2898),
    [sym_line_comment] = ACTIONS(7),
  },
  [819] = {
    [sym_function_modifiers] = STATE(378),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(862),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(381),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(741),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(745),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(747),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [820] = {
    [sym_function_modifiers] = STATE(378),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(380),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(381),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(741),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(745),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(747),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [821] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2900),
    [anon_sym_LPAREN] = ACTIONS(2900),
    [anon_sym_RPAREN] = ACTIONS(2900),
    [anon_sym_LBRACE] = ACTIONS(2900),
    [anon_sym_RBRACE] = ACTIONS(2900),
    [anon_sym_RBRACK] = ACTIONS(2900),
    [anon_sym_COLON] = ACTIONS(2900),
    [anon_sym_PLUS] = ACTIONS(2900),
    [anon_sym_COMMA] = ACTIONS(2900),
    [anon_sym_EQ] = ACTIONS(2900),
    [anon_sym_GT] = ACTIONS(2900),
    [anon_sym_PIPE] = ACTIONS(2900),
    [anon_sym_as] = ACTIONS(2900),
    [anon_sym_where] = ACTIONS(2900),
    [sym_line_comment] = ACTIONS(7),
  },
  [822] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2902),
    [anon_sym_LPAREN] = ACTIONS(2902),
    [anon_sym_RPAREN] = ACTIONS(2902),
    [anon_sym_LBRACE] = ACTIONS(2902),
    [anon_sym_RBRACE] = ACTIONS(2902),
    [anon_sym_RBRACK] = ACTIONS(2902),
    [anon_sym_COLON] = ACTIONS(2904),
    [anon_sym_PLUS] = ACTIONS(2902),
    [anon_sym_COMMA] = ACTIONS(2902),
    [anon_sym_COLON_COLON] = ACTIONS(1670),
    [anon_sym_LT] = ACTIONS(2902),
    [anon_sym_EQ] = ACTIONS(2902),
    [anon_sym_GT] = ACTIONS(2902),
    [anon_sym_PIPE] = ACTIONS(2902),
    [anon_sym_as] = ACTIONS(2902),
    [anon_sym_for] = ACTIONS(2902),
    [anon_sym_where] = ACTIONS(2902),
    [sym_line_comment] = ACTIONS(7),
  },
  [823] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2906),
    [anon_sym_LPAREN] = ACTIONS(2906),
    [anon_sym_RPAREN] = ACTIONS(2906),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(2906),
    [anon_sym_RBRACK] = ACTIONS(2906),
    [anon_sym_COLON] = ACTIONS(2906),
    [anon_sym_PLUS] = ACTIONS(2906),
    [anon_sym_COMMA] = ACTIONS(2906),
    [anon_sym_EQ] = ACTIONS(2906),
    [anon_sym_GT] = ACTIONS(2906),
    [anon_sym_PIPE] = ACTIONS(2906),
    [anon_sym_as] = ACTIONS(2906),
    [anon_sym_where] = ACTIONS(2906),
    [sym_line_comment] = ACTIONS(7),
  },
  [824] = {
    [sym_function_modifiers] = STATE(124),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1479),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(127),
    [sym_array_type] = STATE(1479),
    [sym_function_type] = STATE(1479),
    [sym_tuple_type] = STATE(1479),
    [sym_unit_type] = STATE(1479),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1479),
    [sym_reference_type] = STATE(1479),
    [sym_pointer_type] = STATE(1479),
    [sym_empty_type] = STATE(1479),
    [sym_dynamic_type] = STATE(1479),
    [sym_macro_invocation] = STATE(1479),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(131),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(197),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(201),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(211),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(217),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [825] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2908),
    [anon_sym_LPAREN] = ACTIONS(2908),
    [anon_sym_RPAREN] = ACTIONS(2908),
    [anon_sym_LBRACE] = ACTIONS(2908),
    [anon_sym_RBRACE] = ACTIONS(2908),
    [anon_sym_RBRACK] = ACTIONS(2908),
    [anon_sym_COLON] = ACTIONS(2908),
    [anon_sym_PLUS] = ACTIONS(2908),
    [anon_sym_COMMA] = ACTIONS(2908),
    [anon_sym_DASH_GT] = ACTIONS(2908),
    [anon_sym_EQ] = ACTIONS(2908),
    [anon_sym_GT] = ACTIONS(2908),
    [anon_sym_PIPE] = ACTIONS(2908),
    [anon_sym_as] = ACTIONS(2908),
    [anon_sym_where] = ACTIONS(2908),
    [sym_line_comment] = ACTIONS(7),
  },
  [826] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(2910),
    [sym_line_comment] = ACTIONS(7),
  },
  [827] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(751),
    [anon_sym_COLON] = ACTIONS(2912),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(755),
    [sym_line_comment] = ACTIONS(7),
  },
  [828] = {
    [aux_sym_parameters_repeat1] = STATE(1484),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(2910),
    [anon_sym_COLON] = ACTIONS(2914),
    [anon_sym_COMMA] = ACTIONS(2916),
    [sym_line_comment] = ACTIONS(7),
  },
  [829] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(385),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1489),
    [sym_array_type] = STATE(385),
    [sym_function_type] = STATE(385),
    [sym_tuple_type] = STATE(385),
    [sym_unit_type] = STATE(385),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(385),
    [sym_reference_type] = STATE(385),
    [sym_pointer_type] = STATE(385),
    [sym_empty_type] = STATE(385),
    [sym_dynamic_type] = STATE(385),
    [sym_macro_invocation] = STATE(385),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [sym_tuple_pattern_in_parameter] = STATE(429),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2918),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(2920),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2922),
    [sym_self] = ACTIONS(2924),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [830] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(2926),
    [anon_sym_COMMA] = ACTIONS(2926),
    [sym_line_comment] = ACTIONS(7),
  },
  [831] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2912),
    [anon_sym_u8] = ACTIONS(273),
    [anon_sym_i8] = ACTIONS(273),
    [anon_sym_u16] = ACTIONS(273),
    [anon_sym_i16] = ACTIONS(273),
    [anon_sym_u32] = ACTIONS(273),
    [anon_sym_i32] = ACTIONS(273),
    [anon_sym_u64] = ACTIONS(273),
    [anon_sym_i64] = ACTIONS(273),
    [anon_sym_u128] = ACTIONS(273),
    [anon_sym_i128] = ACTIONS(273),
    [anon_sym_isize] = ACTIONS(273),
    [anon_sym_usize] = ACTIONS(273),
    [anon_sym_f32] = ACTIONS(273),
    [anon_sym_f64] = ACTIONS(273),
    [anon_sym_bool] = ACTIONS(273),
    [anon_sym_str] = ACTIONS(273),
    [anon_sym_char] = ACTIONS(273),
    [anon_sym_COLON_COLON] = ACTIONS(281),
    [anon_sym_LT] = ACTIONS(281),
    [anon_sym_const] = ACTIONS(273),
    [anon_sym_default] = ACTIONS(273),
    [anon_sym_fn] = ACTIONS(273),
    [anon_sym_unsafe] = ACTIONS(273),
    [anon_sym_extern] = ACTIONS(273),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(273),
    [sym_self] = ACTIONS(273),
    [sym_super] = ACTIONS(273),
    [sym_crate] = ACTIONS(273),
    [sym_metavariable] = ACTIONS(281),
  },
  [832] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(1491),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1492),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2928),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [833] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(7),
  },
  [834] = {
    [sym_reference_pattern_in_parameter] = STATE(1494),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(2932),
    [anon_sym_i8] = ACTIONS(2932),
    [anon_sym_u16] = ACTIONS(2932),
    [anon_sym_i16] = ACTIONS(2932),
    [anon_sym_u32] = ACTIONS(2932),
    [anon_sym_i32] = ACTIONS(2932),
    [anon_sym_u64] = ACTIONS(2932),
    [anon_sym_i64] = ACTIONS(2932),
    [anon_sym_u128] = ACTIONS(2932),
    [anon_sym_i128] = ACTIONS(2932),
    [anon_sym_isize] = ACTIONS(2932),
    [anon_sym_usize] = ACTIONS(2932),
    [anon_sym_f32] = ACTIONS(2932),
    [anon_sym_f64] = ACTIONS(2932),
    [anon_sym_bool] = ACTIONS(2932),
    [anon_sym_str] = ACTIONS(2932),
    [anon_sym_char] = ACTIONS(2932),
    [anon_sym__] = ACTIONS(2934),
    [anon_sym_AMP] = ACTIONS(2936),
    [anon_sym_default] = ACTIONS(2932),
    [anon_sym_union] = ACTIONS(2932),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2934),
    [sym_self] = ACTIONS(2938),
  },
  [835] = {
    [sym_parameters] = STATE(800),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_RPAREN] = ACTIONS(773),
    [anon_sym_COLON] = ACTIONS(2940),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_BANG] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [836] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(2942),
    [anon_sym_COLON] = ACTIONS(2940),
    [anon_sym_COMMA] = ACTIONS(2942),
    [anon_sym_COLON_COLON] = ACTIONS(781),
    [sym_line_comment] = ACTIONS(7),
  },
  [837] = {
    [aux_sym_parameters_repeat1] = STATE(1484),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(2910),
    [anon_sym_COMMA] = ACTIONS(2916),
    [sym_line_comment] = ACTIONS(7),
  },
  [838] = {
    [aux_sym_parameters_repeat1] = STATE(1484),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(2910),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_COMMA] = ACTIONS(2916),
    [sym_line_comment] = ACTIONS(7),
  },
  [839] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(1704),
    [sym_mutable_specifier] = ACTIONS(2944),
    [sym_line_comment] = ACTIONS(7),
    [sym_self] = ACTIONS(2946),
  },
  [840] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2914),
    [sym_line_comment] = ACTIONS(7),
  },
  [841] = {
    [sym_function_modifiers] = STATE(124),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1499),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(127),
    [sym_array_type] = STATE(1499),
    [sym_function_type] = STATE(1499),
    [sym_tuple_type] = STATE(1499),
    [sym_unit_type] = STATE(1499),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1499),
    [sym_reference_type] = STATE(1499),
    [sym_pointer_type] = STATE(1499),
    [sym_empty_type] = STATE(1499),
    [sym_abstract_type] = STATE(1500),
    [sym_dynamic_type] = STATE(1499),
    [sym_macro_invocation] = STATE(1499),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(131),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(197),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(201),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(211),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(217),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [842] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(1121),
    [anon_sym_u8] = ACTIONS(1123),
    [anon_sym_i8] = ACTIONS(1123),
    [anon_sym_u16] = ACTIONS(1123),
    [anon_sym_i16] = ACTIONS(1123),
    [anon_sym_u32] = ACTIONS(1123),
    [anon_sym_i32] = ACTIONS(1123),
    [anon_sym_u64] = ACTIONS(1123),
    [anon_sym_i64] = ACTIONS(1123),
    [anon_sym_u128] = ACTIONS(1123),
    [anon_sym_i128] = ACTIONS(1123),
    [anon_sym_isize] = ACTIONS(1123),
    [anon_sym_usize] = ACTIONS(1123),
    [anon_sym_f32] = ACTIONS(1123),
    [anon_sym_f64] = ACTIONS(1123),
    [anon_sym_bool] = ACTIONS(1123),
    [anon_sym_str] = ACTIONS(1123),
    [anon_sym_char] = ACTIONS(1123),
    [anon_sym_COLON_COLON] = ACTIONS(1121),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1121),
    [anon_sym_const] = ACTIONS(1123),
    [anon_sym_default] = ACTIONS(1123),
    [anon_sym_fn] = ACTIONS(1123),
    [anon_sym_if] = ACTIONS(1123),
    [anon_sym_unsafe] = ACTIONS(1123),
    [anon_sym_extern] = ACTIONS(1123),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1123),
    [sym_self] = ACTIONS(1123),
    [sym_super] = ACTIONS(1123),
    [sym_crate] = ACTIONS(1123),
    [sym_metavariable] = ACTIONS(1121),
  },
  [843] = {
    [aux_sym_string_literal_repeat1] = STATE(575),
    [sym_block_comment] = ACTIONS(7),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_RBRACK_PLUS_SLASH] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [sym_escape_sequence] = ACTIONS(1125),
    [sym_line_comment] = ACTIONS(401),
  },
  [844] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2950),
    [anon_sym_LPAREN] = ACTIONS(2950),
    [anon_sym_RPAREN] = ACTIONS(2950),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_RBRACE] = ACTIONS(2950),
    [anon_sym_RBRACK] = ACTIONS(2950),
    [anon_sym_COLON] = ACTIONS(2952),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_COMMA] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2263),
    [anon_sym_LT] = ACTIONS(2950),
    [anon_sym_EQ] = ACTIONS(2950),
    [anon_sym_GT] = ACTIONS(2950),
    [anon_sym_PIPE] = ACTIONS(2950),
    [anon_sym_as] = ACTIONS(2950),
    [anon_sym_for] = ACTIONS(2950),
    [anon_sym_where] = ACTIONS(2950),
    [sym_line_comment] = ACTIONS(7),
  },
  [845] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON_COLON] = ACTIONS(2271),
    [sym_line_comment] = ACTIONS(7),
  },
  [846] = {
    [sym_token_tree] = STATE(1504),
    [sym_token_repetition] = STATE(1504),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1503),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1503),
    [sym_macro_invocation] = STATE(1503),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1503),
    [sym_unary_expression] = STATE(1503),
    [sym_try_expression] = STATE(1503),
    [sym_reference_expression] = STATE(1503),
    [sym_binary_expression] = STATE(1503),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1503),
    [sym_call_expression] = STATE(1503),
    [sym_array_expression] = STATE(1503),
    [sym_parenthesized_expression] = STATE(1503),
    [sym_tuple_expression] = STATE(1503),
    [sym_unit_expression] = STATE(1503),
    [sym_struct_expression] = STATE(1503),
    [sym_if_expression] = STATE(1503),
    [sym_if_let_expression] = STATE(1503),
    [sym_match_expression] = STATE(1503),
    [sym_while_expression] = STATE(1503),
    [sym_while_let_expression] = STATE(1503),
    [sym_loop_expression] = STATE(1503),
    [sym_for_expression] = STATE(1503),
    [sym_closure_expression] = STATE(1503),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1503),
    [sym_continue_expression] = STATE(1503),
    [sym_index_expression] = STATE(1503),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1503),
    [sym_block] = STATE(1503),
    [sym__literal] = STATE(1178),
    [sym_string_literal] = STATE(1178),
    [sym_boolean_literal] = STATE(1178),
    [aux_sym_token_tree_repeat1] = STATE(1504),
    [sym_raw_string_literal] = ACTIONS(2275),
    [sym_float_literal] = ACTIONS(2275),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2954),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_RPAREN] = ACTIONS(2956),
    [anon_sym_LBRACE] = ACTIONS(2283),
    [anon_sym_EQ_GT] = ACTIONS(2954),
    [anon_sym_LBRACK] = ACTIONS(2285),
    [anon_sym_COLON] = ACTIONS(2958),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2958),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(2954),
    [anon_sym_u8] = ACTIONS(2293),
    [anon_sym_i8] = ACTIONS(2293),
    [anon_sym_u16] = ACTIONS(2293),
    [anon_sym_i16] = ACTIONS(2293),
    [anon_sym_u32] = ACTIONS(2293),
    [anon_sym_i32] = ACTIONS(2293),
    [anon_sym_u64] = ACTIONS(2293),
    [anon_sym_i64] = ACTIONS(2293),
    [anon_sym_u128] = ACTIONS(2293),
    [anon_sym_i128] = ACTIONS(2293),
    [anon_sym_isize] = ACTIONS(2293),
    [anon_sym_usize] = ACTIONS(2293),
    [anon_sym_f32] = ACTIONS(2293),
    [anon_sym_f64] = ACTIONS(2293),
    [anon_sym_bool] = ACTIONS(2293),
    [anon_sym_str] = ACTIONS(2293),
    [anon_sym_char] = ACTIONS(2293),
    [anon_sym__] = ACTIONS(2958),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_DASH] = ACTIONS(2291),
    [anon_sym_DOT] = ACTIONS(2958),
    [anon_sym_DASH_EQ] = ACTIONS(2954),
    [anon_sym_DASH_GT] = ACTIONS(2954),
    [anon_sym_COLON_COLON] = ACTIONS(2954),
    [anon_sym_BANG] = ACTIONS(2297),
    [anon_sym_BANG_EQ] = ACTIONS(2954),
    [anon_sym_AT] = ACTIONS(2954),
    [anon_sym_STAR_EQ] = ACTIONS(2954),
    [anon_sym_SLASH] = ACTIONS(2958),
    [anon_sym_SLASH_EQ] = ACTIONS(2954),
    [anon_sym_AMP_AMP] = ACTIONS(2954),
    [anon_sym_AMP_EQ] = ACTIONS(2954),
    [anon_sym_POUND] = ACTIONS(2954),
    [anon_sym_PERCENT] = ACTIONS(2958),
    [anon_sym_PERCENT_EQ] = ACTIONS(2954),
    [anon_sym_CARET] = ACTIONS(2958),
    [anon_sym_CARET_EQ] = ACTIONS(2954),
    [anon_sym_PLUS_EQ] = ACTIONS(2954),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_LT_LT] = ACTIONS(2958),
    [anon_sym_LT_LT_EQ] = ACTIONS(2954),
    [anon_sym_LT_EQ] = ACTIONS(2954),
    [anon_sym_EQ] = ACTIONS(2958),
    [anon_sym_EQ_EQ] = ACTIONS(2954),
    [anon_sym_GT] = ACTIONS(2958),
    [anon_sym_GT_EQ] = ACTIONS(2954),
    [anon_sym_GT_GT] = ACTIONS(2958),
    [anon_sym_GT_GT_EQ] = ACTIONS(2954),
    [anon_sym_PIPE] = ACTIONS(2301),
    [anon_sym_PIPE_EQ] = ACTIONS(2954),
    [anon_sym_PIPE_PIPE] = ACTIONS(2954),
    [anon_sym_TILDE] = ACTIONS(2954),
    [anon_sym_QMARK] = ACTIONS(2954),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(2305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2954),
    [anon_sym_as] = ACTIONS(2958),
    [anon_sym_break] = ACTIONS(2307),
    [anon_sym_const] = ACTIONS(2958),
    [anon_sym_continue] = ACTIONS(2309),
    [anon_sym_default] = ACTIONS(2311),
    [anon_sym_enum] = ACTIONS(2958),
    [anon_sym_fn] = ACTIONS(2958),
    [anon_sym_for] = ACTIONS(2313),
    [anon_sym_if] = ACTIONS(2315),
    [anon_sym_impl] = ACTIONS(2958),
    [anon_sym_let] = ACTIONS(2958),
    [anon_sym_loop] = ACTIONS(2317),
    [anon_sym_match] = ACTIONS(2319),
    [anon_sym_mod] = ACTIONS(2958),
    [anon_sym_pub] = ACTIONS(2958),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_static] = ACTIONS(2958),
    [anon_sym_struct] = ACTIONS(2958),
    [anon_sym_trait] = ACTIONS(2958),
    [anon_sym_type] = ACTIONS(2958),
    [anon_sym_union] = ACTIONS(2311),
    [anon_sym_unsafe] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(2958),
    [anon_sym_where] = ACTIONS(2958),
    [anon_sym_while] = ACTIONS(2325),
    [sym_mutable_specifier] = ACTIONS(2958),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(2275),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(2275),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2331),
    [sym_self] = ACTIONS(2333),
    [sym_super] = ACTIONS(2958),
    [sym_crate] = ACTIONS(2958),
    [sym_metavariable] = ACTIONS(2335),
  },
  [847] = {
    [sym__statement] = STATE(1506),
    [sym_empty_statement] = STATE(1506),
    [sym__expression_statement] = STATE(1506),
    [sym_macro_definition] = STATE(1506),
    [sym_token_tree] = STATE(1507),
    [sym_token_repetition] = STATE(1507),
    [sym_attribute_item] = STATE(1506),
    [sym_inner_attribute_item] = STATE(1506),
    [sym_mod_item] = STATE(1506),
    [sym_foreign_mod_item] = STATE(1506),
    [sym_struct_item] = STATE(1506),
    [sym_union_item] = STATE(1506),
    [sym_enum_item] = STATE(1506),
    [sym_extern_crate_declaration] = STATE(1506),
    [sym_const_item] = STATE(1506),
    [sym_static_item] = STATE(1506),
    [sym_type_item] = STATE(1506),
    [sym_function_item] = STATE(1506),
    [sym_function_signature_item] = STATE(1506),
    [sym_function_modifiers] = STATE(47),
    [sym_impl_item] = STATE(1506),
    [sym_trait_item] = STATE(1506),
    [sym_associated_type] = STATE(1506),
    [sym_let_declaration] = STATE(1506),
    [sym_use_declaration] = STATE(1506),
    [sym_extern_modifier] = STATE(48),
    [sym_visibility_modifier] = STATE(49),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1505),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1505),
    [sym_macro_invocation] = STATE(53),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1505),
    [sym_unary_expression] = STATE(1505),
    [sym_try_expression] = STATE(1505),
    [sym_reference_expression] = STATE(1505),
    [sym_binary_expression] = STATE(1505),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1505),
    [sym_call_expression] = STATE(1505),
    [sym_array_expression] = STATE(1505),
    [sym_parenthesized_expression] = STATE(1505),
    [sym_tuple_expression] = STATE(1505),
    [sym_unit_expression] = STATE(1505),
    [sym_struct_expression] = STATE(1505),
    [sym_if_expression] = STATE(57),
    [sym_if_let_expression] = STATE(57),
    [sym_match_expression] = STATE(57),
    [sym_while_expression] = STATE(57),
    [sym_while_let_expression] = STATE(57),
    [sym_loop_expression] = STATE(57),
    [sym_for_expression] = STATE(57),
    [sym_closure_expression] = STATE(1505),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(59),
    [sym_break_expression] = STATE(1505),
    [sym_continue_expression] = STATE(1505),
    [sym_index_expression] = STATE(1505),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(57),
    [sym_block] = STATE(57),
    [sym__literal] = STATE(1216),
    [sym_string_literal] = STATE(1216),
    [sym_boolean_literal] = STATE(1216),
    [aux_sym_source_file_repeat1] = STATE(1506),
    [aux_sym_token_tree_repeat1] = STATE(1507),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_raw_string_literal] = ACTIONS(2337),
    [sym_float_literal] = ACTIONS(2337),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(2341),
    [anon_sym_LBRACE] = ACTIONS(2343),
    [anon_sym_RBRACE] = ACTIONS(2956),
    [anon_sym_EQ_GT] = ACTIONS(2960),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [anon_sym_COLON] = ACTIONS(2962),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2962),
    [anon_sym_STAR] = ACTIONS(2351),
    [anon_sym_COMMA] = ACTIONS(2960),
    [anon_sym_u8] = ACTIONS(2353),
    [anon_sym_i8] = ACTIONS(2353),
    [anon_sym_u16] = ACTIONS(2353),
    [anon_sym_i16] = ACTIONS(2353),
    [anon_sym_u32] = ACTIONS(2353),
    [anon_sym_i32] = ACTIONS(2353),
    [anon_sym_u64] = ACTIONS(2353),
    [anon_sym_i64] = ACTIONS(2353),
    [anon_sym_u128] = ACTIONS(2353),
    [anon_sym_i128] = ACTIONS(2353),
    [anon_sym_isize] = ACTIONS(2353),
    [anon_sym_usize] = ACTIONS(2353),
    [anon_sym_f32] = ACTIONS(2353),
    [anon_sym_f64] = ACTIONS(2353),
    [anon_sym_bool] = ACTIONS(2353),
    [anon_sym_str] = ACTIONS(2353),
    [anon_sym_char] = ACTIONS(2353),
    [anon_sym__] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2355),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_DOT] = ACTIONS(2962),
    [anon_sym_DASH_EQ] = ACTIONS(2960),
    [anon_sym_DASH_GT] = ACTIONS(2960),
    [anon_sym_COLON_COLON] = ACTIONS(2960),
    [anon_sym_BANG] = ACTIONS(2357),
    [anon_sym_BANG_EQ] = ACTIONS(2960),
    [anon_sym_AT] = ACTIONS(2960),
    [anon_sym_STAR_EQ] = ACTIONS(2960),
    [anon_sym_SLASH] = ACTIONS(2962),
    [anon_sym_SLASH_EQ] = ACTIONS(2960),
    [anon_sym_AMP_AMP] = ACTIONS(2960),
    [anon_sym_AMP_EQ] = ACTIONS(2960),
    [anon_sym_POUND] = ACTIONS(2359),
    [anon_sym_PERCENT] = ACTIONS(2962),
    [anon_sym_PERCENT_EQ] = ACTIONS(2960),
    [anon_sym_CARET] = ACTIONS(2962),
    [anon_sym_CARET_EQ] = ACTIONS(2960),
    [anon_sym_PLUS_EQ] = ACTIONS(2960),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_LT_LT] = ACTIONS(2962),
    [anon_sym_LT_LT_EQ] = ACTIONS(2960),
    [anon_sym_LT_EQ] = ACTIONS(2960),
    [anon_sym_EQ] = ACTIONS(2962),
    [anon_sym_EQ_EQ] = ACTIONS(2960),
    [anon_sym_GT] = ACTIONS(2962),
    [anon_sym_GT_EQ] = ACTIONS(2960),
    [anon_sym_GT_GT] = ACTIONS(2962),
    [anon_sym_GT_GT_EQ] = ACTIONS(2960),
    [anon_sym_PIPE] = ACTIONS(2301),
    [anon_sym_PIPE_EQ] = ACTIONS(2960),
    [anon_sym_PIPE_PIPE] = ACTIONS(2960),
    [anon_sym_TILDE] = ACTIONS(2960),
    [anon_sym_QMARK] = ACTIONS(2960),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(2361),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2960),
    [anon_sym_as] = ACTIONS(2962),
    [anon_sym_break] = ACTIONS(2363),
    [anon_sym_const] = ACTIONS(2365),
    [anon_sym_continue] = ACTIONS(2367),
    [anon_sym_default] = ACTIONS(2369),
    [anon_sym_enum] = ACTIONS(2371),
    [anon_sym_fn] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2375),
    [anon_sym_if] = ACTIONS(2377),
    [anon_sym_impl] = ACTIONS(2379),
    [anon_sym_let] = ACTIONS(2381),
    [anon_sym_loop] = ACTIONS(2383),
    [anon_sym_match] = ACTIONS(2385),
    [anon_sym_mod] = ACTIONS(2387),
    [anon_sym_pub] = ACTIONS(2389),
    [anon_sym_return] = ACTIONS(2391),
    [anon_sym_static] = ACTIONS(2393),
    [anon_sym_struct] = ACTIONS(2395),
    [anon_sym_trait] = ACTIONS(2397),
    [anon_sym_type] = ACTIONS(2399),
    [anon_sym_union] = ACTIONS(2401),
    [anon_sym_unsafe] = ACTIONS(2403),
    [anon_sym_use] = ACTIONS(2405),
    [anon_sym_where] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2407),
    [anon_sym_extern] = ACTIONS(85),
    [sym_mutable_specifier] = ACTIONS(2962),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(2337),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(2337),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2409),
    [sym_self] = ACTIONS(2411),
    [sym_super] = ACTIONS(2962),
    [sym_crate] = ACTIONS(2962),
    [sym_metavariable] = ACTIONS(2413),
  },
  [848] = {
    [sym_token_tree] = STATE(1509),
    [sym_token_repetition] = STATE(1509),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1508),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1508),
    [sym_macro_invocation] = STATE(1508),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1508),
    [sym_unary_expression] = STATE(1508),
    [sym_try_expression] = STATE(1508),
    [sym_reference_expression] = STATE(1508),
    [sym_binary_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1508),
    [sym_call_expression] = STATE(1508),
    [sym_array_expression] = STATE(1508),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_tuple_expression] = STATE(1508),
    [sym_unit_expression] = STATE(1508),
    [sym_struct_expression] = STATE(1508),
    [sym_if_expression] = STATE(1508),
    [sym_if_let_expression] = STATE(1508),
    [sym_match_expression] = STATE(1508),
    [sym_while_expression] = STATE(1508),
    [sym_while_let_expression] = STATE(1508),
    [sym_loop_expression] = STATE(1508),
    [sym_for_expression] = STATE(1508),
    [sym_closure_expression] = STATE(1508),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1508),
    [sym_continue_expression] = STATE(1508),
    [sym_index_expression] = STATE(1508),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1508),
    [sym_block] = STATE(1508),
    [sym__literal] = STATE(1178),
    [sym_string_literal] = STATE(1178),
    [sym_boolean_literal] = STATE(1178),
    [aux_sym_token_tree_repeat1] = STATE(1509),
    [sym_raw_string_literal] = ACTIONS(2275),
    [sym_float_literal] = ACTIONS(2275),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2964),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_LBRACE] = ACTIONS(2283),
    [anon_sym_EQ_GT] = ACTIONS(2964),
    [anon_sym_LBRACK] = ACTIONS(2285),
    [anon_sym_RBRACK] = ACTIONS(2956),
    [anon_sym_COLON] = ACTIONS(2966),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(2966),
    [anon_sym_STAR] = ACTIONS(2419),
    [anon_sym_COMMA] = ACTIONS(2964),
    [anon_sym_u8] = ACTIONS(2293),
    [anon_sym_i8] = ACTIONS(2293),
    [anon_sym_u16] = ACTIONS(2293),
    [anon_sym_i16] = ACTIONS(2293),
    [anon_sym_u32] = ACTIONS(2293),
    [anon_sym_i32] = ACTIONS(2293),
    [anon_sym_u64] = ACTIONS(2293),
    [anon_sym_i64] = ACTIONS(2293),
    [anon_sym_u128] = ACTIONS(2293),
    [anon_sym_i128] = ACTIONS(2293),
    [anon_sym_isize] = ACTIONS(2293),
    [anon_sym_usize] = ACTIONS(2293),
    [anon_sym_f32] = ACTIONS(2293),
    [anon_sym_f64] = ACTIONS(2293),
    [anon_sym_bool] = ACTIONS(2293),
    [anon_sym_str] = ACTIONS(2293),
    [anon_sym_char] = ACTIONS(2293),
    [anon_sym__] = ACTIONS(2966),
    [anon_sym_AMP] = ACTIONS(2421),
    [anon_sym_DASH] = ACTIONS(2419),
    [anon_sym_DOT] = ACTIONS(2966),
    [anon_sym_DASH_EQ] = ACTIONS(2964),
    [anon_sym_DASH_GT] = ACTIONS(2964),
    [anon_sym_COLON_COLON] = ACTIONS(2964),
    [anon_sym_BANG] = ACTIONS(2423),
    [anon_sym_BANG_EQ] = ACTIONS(2964),
    [anon_sym_AT] = ACTIONS(2964),
    [anon_sym_STAR_EQ] = ACTIONS(2964),
    [anon_sym_SLASH] = ACTIONS(2966),
    [anon_sym_SLASH_EQ] = ACTIONS(2964),
    [anon_sym_AMP_AMP] = ACTIONS(2964),
    [anon_sym_AMP_EQ] = ACTIONS(2964),
    [anon_sym_POUND] = ACTIONS(2964),
    [anon_sym_PERCENT] = ACTIONS(2966),
    [anon_sym_PERCENT_EQ] = ACTIONS(2964),
    [anon_sym_CARET] = ACTIONS(2966),
    [anon_sym_CARET_EQ] = ACTIONS(2964),
    [anon_sym_PLUS_EQ] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_LT_LT] = ACTIONS(2966),
    [anon_sym_LT_LT_EQ] = ACTIONS(2964),
    [anon_sym_LT_EQ] = ACTIONS(2964),
    [anon_sym_EQ] = ACTIONS(2966),
    [anon_sym_EQ_EQ] = ACTIONS(2964),
    [anon_sym_GT] = ACTIONS(2966),
    [anon_sym_GT_EQ] = ACTIONS(2964),
    [anon_sym_GT_GT] = ACTIONS(2966),
    [anon_sym_GT_GT_EQ] = ACTIONS(2964),
    [anon_sym_PIPE] = ACTIONS(2301),
    [anon_sym_PIPE_EQ] = ACTIONS(2964),
    [anon_sym_PIPE_PIPE] = ACTIONS(2964),
    [anon_sym_TILDE] = ACTIONS(2964),
    [anon_sym_QMARK] = ACTIONS(2964),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(2425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2964),
    [anon_sym_as] = ACTIONS(2966),
    [anon_sym_break] = ACTIONS(2307),
    [anon_sym_const] = ACTIONS(2966),
    [anon_sym_continue] = ACTIONS(2309),
    [anon_sym_default] = ACTIONS(2311),
    [anon_sym_enum] = ACTIONS(2966),
    [anon_sym_fn] = ACTIONS(2966),
    [anon_sym_for] = ACTIONS(2313),
    [anon_sym_if] = ACTIONS(2427),
    [anon_sym_impl] = ACTIONS(2966),
    [anon_sym_let] = ACTIONS(2966),
    [anon_sym_loop] = ACTIONS(2317),
    [anon_sym_match] = ACTIONS(2319),
    [anon_sym_mod] = ACTIONS(2966),
    [anon_sym_pub] = ACTIONS(2966),
    [anon_sym_return] = ACTIONS(2429),
    [anon_sym_static] = ACTIONS(2966),
    [anon_sym_struct] = ACTIONS(2966),
    [anon_sym_trait] = ACTIONS(2966),
    [anon_sym_type] = ACTIONS(2966),
    [anon_sym_union] = ACTIONS(2311),
    [anon_sym_unsafe] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(2966),
    [anon_sym_where] = ACTIONS(2966),
    [anon_sym_while] = ACTIONS(2325),
    [sym_mutable_specifier] = ACTIONS(2966),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(2275),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(2275),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2331),
    [sym_self] = ACTIONS(2333),
    [sym_super] = ACTIONS(2966),
    [sym_crate] = ACTIONS(2966),
    [sym_metavariable] = ACTIONS(2335),
  },
  [849] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2431),
    [anon_sym_LPAREN] = ACTIONS(2431),
    [anon_sym_RPAREN] = ACTIONS(2431),
    [anon_sym_LBRACE] = ACTIONS(2431),
    [anon_sym_RBRACE] = ACTIONS(2431),
    [anon_sym_RBRACK] = ACTIONS(2431),
    [anon_sym_COLON] = ACTIONS(2431),
    [anon_sym_PLUS] = ACTIONS(2431),
    [anon_sym_COMMA] = ACTIONS(2431),
    [anon_sym_EQ] = ACTIONS(2431),
    [anon_sym_GT] = ACTIONS(2431),
    [anon_sym_PIPE] = ACTIONS(2431),
    [anon_sym_as] = ACTIONS(2431),
    [anon_sym_where] = ACTIONS(2431),
    [sym_line_comment] = ACTIONS(7),
  },
  [850] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(2968),
    [sym_mutable_specifier] = ACTIONS(2968),
    [sym_line_comment] = ACTIONS(7),
  },
  [851] = {
    [sym_function_modifiers] = STATE(854),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(385),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1513),
    [sym_array_type] = STATE(385),
    [sym_function_type] = STATE(385),
    [sym_tuple_type] = STATE(385),
    [sym_unit_type] = STATE(385),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(385),
    [sym_reference_type] = STATE(385),
    [sym_pointer_type] = STATE(385),
    [sym_empty_type] = STATE(385),
    [sym_dynamic_type] = STATE(385),
    [sym_macro_invocation] = STATE(385),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(858),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1786),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1788),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1790),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(2970),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2972),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [852] = {
    [sym_parameters] = STATE(1514),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [853] = {
    [sym_parameters] = STATE(1516),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_BANG] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_EQ] = ACTIONS(2974),
    [anon_sym_GT] = ACTIONS(773),
    [sym_line_comment] = ACTIONS(7),
  },
  [854] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1519),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_fn] = ACTIONS(2976),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2978),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [855] = {
    [aux_sym_type_arguments_repeat1] = STATE(1523),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_COMMA] = ACTIONS(2982),
    [anon_sym_GT] = ACTIONS(2984),
    [sym_line_comment] = ACTIONS(7),
  },
  [856] = {
    [aux_sym_type_arguments_repeat1] = STATE(1523),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(2986),
    [anon_sym_COMMA] = ACTIONS(2982),
    [anon_sym_GT] = ACTIONS(2984),
    [sym_line_comment] = ACTIONS(7),
  },
  [857] = {
    [aux_sym_type_arguments_repeat1] = STATE(1523),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(2982),
    [anon_sym_GT] = ACTIONS(2984),
    [sym_line_comment] = ACTIONS(7),
  },
  [858] = {
    [sym_parameters] = STATE(1514),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(783),
    [anon_sym_COMMA] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_GT] = ACTIONS(783),
    [sym_line_comment] = ACTIONS(7),
  },
  [859] = {
    [sym_function_modifiers] = STATE(124),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1525),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(127),
    [sym_array_type] = STATE(1525),
    [sym_function_type] = STATE(1525),
    [sym_tuple_type] = STATE(1525),
    [sym_unit_type] = STATE(1525),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1525),
    [sym_reference_type] = STATE(1525),
    [sym_pointer_type] = STATE(1525),
    [sym_empty_type] = STATE(1525),
    [sym_abstract_type] = STATE(1526),
    [sym_dynamic_type] = STATE(1525),
    [sym_macro_invocation] = STATE(1525),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(131),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(197),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(201),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(211),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(217),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [860] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_DASH_GT] = ACTIONS(2990),
    [anon_sym_GT] = ACTIONS(2988),
    [anon_sym_as] = ACTIONS(2988),
    [sym_line_comment] = ACTIONS(7),
  },
  [861] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(2994),
    [anon_sym_GT] = ACTIONS(2992),
    [anon_sym_as] = ACTIONS(2992),
    [sym_line_comment] = ACTIONS(7),
  },
  [862] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2996),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(2996),
    [anon_sym_LBRACE] = ACTIONS(2996),
    [anon_sym_RBRACE] = ACTIONS(2996),
    [anon_sym_RBRACK] = ACTIONS(2996),
    [anon_sym_COLON] = ACTIONS(2996),
    [anon_sym_PLUS] = ACTIONS(2996),
    [anon_sym_COMMA] = ACTIONS(2996),
    [anon_sym_EQ] = ACTIONS(2996),
    [anon_sym_GT] = ACTIONS(2996),
    [anon_sym_PIPE] = ACTIONS(2996),
    [anon_sym_as] = ACTIONS(2996),
    [anon_sym_where] = ACTIONS(2996),
    [sym_line_comment] = ACTIONS(7),
  },
  [863] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(2998),
    [sym_mutable_specifier] = ACTIONS(2998),
    [sym_line_comment] = ACTIONS(7),
  },
  [864] = {
    [sym_function_modifiers] = STATE(867),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(385),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1531),
    [sym_array_type] = STATE(385),
    [sym_function_type] = STATE(385),
    [sym_tuple_type] = STATE(385),
    [sym_unit_type] = STATE(385),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(385),
    [sym_reference_type] = STATE(385),
    [sym_pointer_type] = STATE(385),
    [sym_empty_type] = STATE(385),
    [sym_dynamic_type] = STATE(385),
    [sym_macro_invocation] = STATE(385),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(870),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1806),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1808),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(3000),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1810),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [865] = {
    [sym_parameters] = STATE(1532),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [866] = {
    [sym_parameters] = STATE(1533),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_BANG] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_GT] = ACTIONS(773),
    [sym_line_comment] = ACTIONS(7),
  },
  [867] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1536),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_fn] = ACTIONS(3002),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3004),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [868] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(3006),
    [anon_sym_GT] = ACTIONS(3008),
    [sym_line_comment] = ACTIONS(7),
  },
  [869] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(3010),
    [sym_line_comment] = ACTIONS(7),
  },
  [870] = {
    [sym_parameters] = STATE(1532),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_GT] = ACTIONS(783),
    [sym_line_comment] = ACTIONS(7),
  },
  [871] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2950),
    [anon_sym_LPAREN] = ACTIONS(2950),
    [anon_sym_RPAREN] = ACTIONS(2950),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_RBRACE] = ACTIONS(2950),
    [anon_sym_RBRACK] = ACTIONS(2950),
    [anon_sym_COLON] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_COMMA] = ACTIONS(2950),
    [anon_sym_LT] = ACTIONS(2950),
    [anon_sym_EQ] = ACTIONS(2950),
    [anon_sym_GT] = ACTIONS(2950),
    [anon_sym_PIPE] = ACTIONS(2950),
    [anon_sym_as] = ACTIONS(2950),
    [anon_sym_for] = ACTIONS(2950),
    [anon_sym_where] = ACTIONS(2950),
    [sym_line_comment] = ACTIONS(7),
  },
  [872] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3012),
    [anon_sym_LPAREN] = ACTIONS(3012),
    [anon_sym_RPAREN] = ACTIONS(3012),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_RBRACE] = ACTIONS(3012),
    [anon_sym_RBRACK] = ACTIONS(3012),
    [anon_sym_COLON] = ACTIONS(3014),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_COMMA] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(2529),
    [anon_sym_LT] = ACTIONS(3012),
    [anon_sym_EQ] = ACTIONS(3012),
    [anon_sym_GT] = ACTIONS(3012),
    [anon_sym_PIPE] = ACTIONS(3012),
    [anon_sym_as] = ACTIONS(3012),
    [anon_sym_for] = ACTIONS(3012),
    [anon_sym_where] = ACTIONS(3012),
    [sym_line_comment] = ACTIONS(7),
  },
  [873] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON_COLON] = ACTIONS(2657),
    [sym_line_comment] = ACTIONS(7),
  },
  [874] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3016),
    [anon_sym_RPAREN] = ACTIONS(3016),
    [anon_sym_RBRACE] = ACTIONS(3016),
    [anon_sym_COLON] = ACTIONS(3016),
    [anon_sym_COMMA] = ACTIONS(3016),
    [anon_sym_EQ] = ACTIONS(3016),
    [anon_sym_PIPE] = ACTIONS(3016),
    [anon_sym_in] = ACTIONS(3016),
    [sym_line_comment] = ACTIONS(7),
  },
  [875] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(898),
    [sym_tuple_pattern] = STATE(898),
    [sym_tuple_struct_pattern] = STATE(898),
    [sym_struct_pattern] = STATE(898),
    [sym_remaining_field_pattern] = STATE(898),
    [sym_mut_pattern] = STATE(898),
    [sym_ref_pattern] = STATE(898),
    [sym_captured_pattern] = STATE(898),
    [sym_reference_pattern] = STATE(898),
    [sym__literal] = STATE(898),
    [sym_string_literal] = STATE(898),
    [sym_boolean_literal] = STATE(898),
    [sym_raw_string_literal] = ACTIONS(1858),
    [sym_float_literal] = ACTIONS(1858),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(1860),
    [anon_sym_AMP] = ACTIONS(817),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(819),
    [anon_sym_ref] = ACTIONS(821),
    [sym_integer_literal] = ACTIONS(1858),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1858),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(823),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [876] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(916),
    [sym_tuple_pattern] = STATE(916),
    [sym_tuple_struct_pattern] = STATE(916),
    [sym_struct_pattern] = STATE(916),
    [sym_remaining_field_pattern] = STATE(916),
    [sym_mut_pattern] = STATE(916),
    [sym_ref_pattern] = STATE(916),
    [sym_captured_pattern] = STATE(916),
    [sym_reference_pattern] = STATE(916),
    [sym__literal] = STATE(916),
    [sym_string_literal] = STATE(916),
    [sym_boolean_literal] = STATE(916),
    [sym_raw_string_literal] = ACTIONS(1910),
    [sym_float_literal] = ACTIONS(1910),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(1912),
    [anon_sym_AMP] = ACTIONS(817),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(819),
    [anon_sym_ref] = ACTIONS(821),
    [sym_integer_literal] = ACTIONS(1910),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1910),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(823),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [877] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(1540),
    [sym_tuple_pattern] = STATE(1540),
    [sym_tuple_struct_pattern] = STATE(1540),
    [sym_struct_pattern] = STATE(1540),
    [sym_remaining_field_pattern] = STATE(1540),
    [sym_mut_pattern] = STATE(1540),
    [sym_ref_pattern] = STATE(1540),
    [sym_captured_pattern] = STATE(1540),
    [sym_reference_pattern] = STATE(1540),
    [sym__literal] = STATE(1540),
    [sym_string_literal] = STATE(1540),
    [sym_boolean_literal] = STATE(1540),
    [sym_raw_string_literal] = ACTIONS(3018),
    [sym_float_literal] = ACTIONS(3018),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_RPAREN] = ACTIONS(3020),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(817),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(819),
    [anon_sym_ref] = ACTIONS(821),
    [sym_integer_literal] = ACTIONS(3018),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(3018),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(823),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [878] = {
    [aux_sym_tuple_pattern_repeat1] = STATE(1542),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(3020),
    [anon_sym_COMMA] = ACTIONS(3024),
    [sym_line_comment] = ACTIONS(7),
  },
  [879] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(3026),
    [sym_mutable_specifier] = ACTIONS(3026),
    [sym_line_comment] = ACTIONS(7),
  },
  [880] = {
    [sym_function_modifiers] = STATE(883),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(385),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1545),
    [sym_array_type] = STATE(385),
    [sym_function_type] = STATE(385),
    [sym_tuple_type] = STATE(385),
    [sym_unit_type] = STATE(385),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(385),
    [sym_reference_type] = STATE(385),
    [sym_pointer_type] = STATE(385),
    [sym_empty_type] = STATE(385),
    [sym_dynamic_type] = STATE(385),
    [sym_macro_invocation] = STATE(385),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(887),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1838),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1840),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1842),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(3028),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1844),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [881] = {
    [sym_parameters] = STATE(1546),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [882] = {
    [sym_parameters] = STATE(1547),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_BANG] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_PIPE] = ACTIONS(773),
    [sym_line_comment] = ACTIONS(7),
  },
  [883] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1550),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_fn] = ACTIONS(3030),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3032),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [884] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(3034),
    [anon_sym_COMMA] = ACTIONS(3036),
    [anon_sym_PIPE] = ACTIONS(3036),
    [sym_line_comment] = ACTIONS(7),
  },
  [885] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(3038),
    [sym_line_comment] = ACTIONS(7),
  },
  [886] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(3036),
    [anon_sym_COMMA] = ACTIONS(3036),
    [anon_sym_PIPE] = ACTIONS(3036),
    [sym_line_comment] = ACTIONS(7),
  },
  [887] = {
    [sym_parameters] = STATE(1546),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(783),
    [anon_sym_COMMA] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_PIPE] = ACTIONS(783),
    [sym_line_comment] = ACTIONS(7),
  },
  [888] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1670),
    [anon_sym_LPAREN] = ACTIONS(1670),
    [anon_sym_RPAREN] = ACTIONS(1670),
    [anon_sym_LBRACE] = ACTIONS(2902),
    [anon_sym_RBRACE] = ACTIONS(1670),
    [anon_sym_COLON] = ACTIONS(1674),
    [anon_sym_COMMA] = ACTIONS(1670),
    [anon_sym_COLON_COLON] = ACTIONS(1670),
    [anon_sym_LT] = ACTIONS(2902),
    [anon_sym_EQ] = ACTIONS(1670),
    [anon_sym_PIPE] = ACTIONS(1670),
    [anon_sym_in] = ACTIONS(1670),
    [sym_line_comment] = ACTIONS(7),
  },
  [889] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(3034),
    [anon_sym_COMMA] = ACTIONS(3040),
    [anon_sym_PIPE] = ACTIONS(3040),
    [sym_line_comment] = ACTIONS(7),
  },
  [890] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(3040),
    [anon_sym_COMMA] = ACTIONS(3040),
    [anon_sym_PIPE] = ACTIONS(3040),
    [sym_line_comment] = ACTIONS(7),
  },
  [891] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(3042),
    [anon_sym_COLON] = ACTIONS(3042),
    [anon_sym_COMMA] = ACTIONS(3042),
    [anon_sym_PIPE] = ACTIONS(3042),
    [sym_line_comment] = ACTIONS(7),
  },
  [892] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(3044),
    [sym_line_comment] = ACTIONS(7),
  },
  [893] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(428),
    [sym_tuple_pattern] = STATE(428),
    [sym_tuple_pattern_in_parameter] = STATE(429),
    [sym_tuple_struct_pattern] = STATE(428),
    [sym_struct_pattern] = STATE(428),
    [sym_remaining_field_pattern] = STATE(428),
    [sym_mut_pattern] = STATE(428),
    [sym_ref_pattern] = STATE(428),
    [sym_captured_pattern] = STATE(428),
    [sym_reference_pattern] = STATE(428),
    [sym__literal] = STATE(428),
    [sym_string_literal] = STATE(428),
    [sym_boolean_literal] = STATE(428),
    [sym_raw_string_literal] = ACTIONS(833),
    [sym_float_literal] = ACTIONS(833),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(835),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(817),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(3046),
    [anon_sym_ref] = ACTIONS(821),
    [sym_integer_literal] = ACTIONS(833),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(833),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3048),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [894] = {
    [sym_type_arguments] = STATE(400),
    [aux_sym_tuple_pattern_in_parameter_repeat1] = STATE(1557),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(881),
    [anon_sym_RPAREN] = ACTIONS(3044),
    [anon_sym_LBRACE] = ACTIONS(883),
    [anon_sym_COMMA] = ACTIONS(3050),
    [anon_sym_COLON_COLON] = ACTIONS(887),
    [anon_sym_AT] = ACTIONS(1834),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [895] = {
    [aux_sym_tuple_pattern_in_parameter_repeat1] = STATE(1557),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(3044),
    [anon_sym_COMMA] = ACTIONS(3050),
    [sym_line_comment] = ACTIONS(7),
  },
  [896] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(898),
    [sym_tuple_pattern] = STATE(898),
    [sym_tuple_struct_pattern] = STATE(898),
    [sym_struct_pattern] = STATE(898),
    [sym_remaining_field_pattern] = STATE(898),
    [sym_mut_pattern] = STATE(898),
    [sym_ref_pattern] = STATE(898),
    [sym_captured_pattern] = STATE(898),
    [sym_reference_pattern] = STATE(898),
    [sym__literal] = STATE(898),
    [sym_string_literal] = STATE(898),
    [sym_boolean_literal] = STATE(898),
    [sym_raw_string_literal] = ACTIONS(1858),
    [sym_float_literal] = ACTIONS(1858),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(1860),
    [anon_sym_AMP] = ACTIONS(839),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(865),
    [anon_sym_ref] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(1858),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(1858),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(875),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [897] = {
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(883),
    [anon_sym_COLON] = ACTIONS(3052),
    [anon_sym_COMMA] = ACTIONS(3054),
    [anon_sym_COLON_COLON] = ACTIONS(887),
    [anon_sym_AT] = ACTIONS(889),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_PIPE] = ACTIONS(3054),
    [sym_line_comment] = ACTIONS(7),
  },
  [898] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3056),
    [anon_sym_RPAREN] = ACTIONS(3056),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_COLON] = ACTIONS(3056),
    [anon_sym_COMMA] = ACTIONS(3056),
    [anon_sym_EQ] = ACTIONS(3056),
    [anon_sym_PIPE] = ACTIONS(3056),
    [anon_sym_in] = ACTIONS(3056),
    [sym_line_comment] = ACTIONS(7),
  },
  [899] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(3054),
    [anon_sym_COLON] = ACTIONS(3054),
    [anon_sym_COMMA] = ACTIONS(3054),
    [anon_sym_PIPE] = ACTIONS(3054),
    [sym_line_comment] = ACTIONS(7),
  },
  [900] = {
    [sym_function_modifiers] = STATE(883),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1558),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(885),
    [sym_array_type] = STATE(1558),
    [sym_function_type] = STATE(1558),
    [sym_tuple_type] = STATE(1558),
    [sym_unit_type] = STATE(1558),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1558),
    [sym_reference_type] = STATE(1558),
    [sym_pointer_type] = STATE(1558),
    [sym_empty_type] = STATE(1558),
    [sym_abstract_type] = STATE(1559),
    [sym_dynamic_type] = STATE(1558),
    [sym_macro_invocation] = STATE(1558),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(887),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1838),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1840),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1842),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1844),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [901] = {
    [sym_function_modifiers] = STATE(883),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1560),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(885),
    [sym_array_type] = STATE(1560),
    [sym_function_type] = STATE(1560),
    [sym_tuple_type] = STATE(1560),
    [sym_unit_type] = STATE(1560),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1560),
    [sym_reference_type] = STATE(1560),
    [sym_pointer_type] = STATE(1560),
    [sym_empty_type] = STATE(1560),
    [sym_abstract_type] = STATE(1561),
    [sym_dynamic_type] = STATE(1560),
    [sym_macro_invocation] = STATE(1560),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(887),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1838),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1840),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1842),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1844),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [902] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(420),
    [sym_tuple_pattern] = STATE(420),
    [sym_tuple_struct_pattern] = STATE(420),
    [sym_struct_pattern] = STATE(420),
    [sym_remaining_field_pattern] = STATE(420),
    [sym_mut_pattern] = STATE(420),
    [sym_ref_pattern] = STATE(895),
    [sym_captured_pattern] = STATE(420),
    [sym_reference_pattern] = STATE(420),
    [sym_reference_pattern_in_parameter] = STATE(895),
    [sym__literal] = STATE(420),
    [sym_string_literal] = STATE(420),
    [sym_boolean_literal] = STATE(420),
    [sym_raw_string_literal] = ACTIONS(809),
    [sym_float_literal] = ACTIONS(809),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_RPAREN] = ACTIONS(3058),
    [anon_sym_COMMA] = ACTIONS(3060),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(815),
    [anon_sym_AMP] = ACTIONS(1852),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(819),
    [anon_sym_ref] = ACTIONS(821),
    [sym_integer_literal] = ACTIONS(809),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(809),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1854),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [903] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(898),
    [sym_tuple_pattern] = STATE(898),
    [sym_tuple_pattern_in_parameter] = STATE(899),
    [sym_tuple_struct_pattern] = STATE(898),
    [sym_struct_pattern] = STATE(898),
    [sym_remaining_field_pattern] = STATE(898),
    [sym_mut_pattern] = STATE(898),
    [sym_ref_pattern] = STATE(898),
    [sym_captured_pattern] = STATE(898),
    [sym_reference_pattern] = STATE(898),
    [sym__literal] = STATE(898),
    [sym_string_literal] = STATE(898),
    [sym_boolean_literal] = STATE(898),
    [sym_raw_string_literal] = ACTIONS(1858),
    [sym_float_literal] = ACTIONS(1858),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1874),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(1860),
    [anon_sym_AMP] = ACTIONS(839),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(865),
    [anon_sym_ref] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(1858),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(1858),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3062),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [904] = {
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(883),
    [anon_sym_COLON] = ACTIONS(1864),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_COLON_COLON] = ACTIONS(887),
    [anon_sym_AT] = ACTIONS(889),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_PIPE] = ACTIONS(831),
    [sym_line_comment] = ACTIONS(7),
  },
  [905] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2222),
    [anon_sym_COLON] = ACTIONS(2222),
    [anon_sym_COMMA] = ACTIONS(2222),
    [anon_sym_EQ] = ACTIONS(2222),
    [anon_sym_PIPE] = ACTIONS(2222),
    [sym_line_comment] = ACTIONS(7),
  },
  [906] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3064),
    [anon_sym_RPAREN] = ACTIONS(3064),
    [anon_sym_RBRACE] = ACTIONS(3064),
    [anon_sym_COLON] = ACTIONS(3064),
    [anon_sym_COMMA] = ACTIONS(3064),
    [anon_sym_EQ] = ACTIONS(3064),
    [anon_sym_PIPE] = ACTIONS(3064),
    [anon_sym_in] = ACTIONS(3064),
    [sym_line_comment] = ACTIONS(7),
  },
  [907] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(3066),
    [sym_line_comment] = ACTIONS(7),
  },
  [908] = {
    [aux_sym_tuple_pattern_repeat1] = STATE(1567),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(3066),
    [anon_sym_COMMA] = ACTIONS(3068),
    [sym_line_comment] = ACTIONS(7),
  },
  [909] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3070),
    [anon_sym_RPAREN] = ACTIONS(3070),
    [anon_sym_RBRACE] = ACTIONS(3070),
    [anon_sym_COLON] = ACTIONS(3070),
    [anon_sym_COMMA] = ACTIONS(3070),
    [anon_sym_EQ] = ACTIONS(3070),
    [anon_sym_PIPE] = ACTIONS(3070),
    [anon_sym_in] = ACTIONS(3070),
    [sym_line_comment] = ACTIONS(7),
  },
  [910] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(3072),
    [sym_line_comment] = ACTIONS(7),
  },
  [911] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3074),
  },
  [912] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_mutable_specifier] = ACTIONS(3076),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3078),
  },
  [913] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(3080),
    [anon_sym_COLON] = ACTIONS(3082),
    [anon_sym_COMMA] = ACTIONS(3080),
    [sym_line_comment] = ACTIONS(7),
  },
  [914] = {
    [aux_sym_struct_pattern_repeat1] = STATE(1573),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(3072),
    [anon_sym_COMMA] = ACTIONS(3084),
    [sym_line_comment] = ACTIONS(7),
  },
  [915] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2263),
    [anon_sym_LPAREN] = ACTIONS(2263),
    [anon_sym_RPAREN] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_RBRACE] = ACTIONS(2263),
    [anon_sym_COLON] = ACTIONS(2267),
    [anon_sym_COMMA] = ACTIONS(2263),
    [anon_sym_COLON_COLON] = ACTIONS(2263),
    [anon_sym_LT] = ACTIONS(2950),
    [anon_sym_EQ] = ACTIONS(2263),
    [anon_sym_PIPE] = ACTIONS(2263),
    [anon_sym_in] = ACTIONS(2263),
    [sym_line_comment] = ACTIONS(7),
  },
  [916] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3086),
    [anon_sym_RPAREN] = ACTIONS(3086),
    [anon_sym_RBRACE] = ACTIONS(3086),
    [anon_sym_COLON] = ACTIONS(3086),
    [anon_sym_COMMA] = ACTIONS(3086),
    [anon_sym_EQ] = ACTIONS(3086),
    [anon_sym_PIPE] = ACTIONS(3086),
    [anon_sym_in] = ACTIONS(3086),
    [sym_line_comment] = ACTIONS(7),
  },
  [917] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(3088),
    [anon_sym_PIPE] = ACTIONS(3088),
    [sym_line_comment] = ACTIONS(7),
  },
  [918] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(829),
    [anon_sym_COMMA] = ACTIONS(3088),
    [anon_sym_PIPE] = ACTIONS(3088),
    [sym_line_comment] = ACTIONS(7),
  },
  [919] = {
    [sym_raw_string_literal] = ACTIONS(3090),
    [sym_float_literal] = ACTIONS(3090),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(3090),
    [anon_sym_LBRACE] = ACTIONS(3090),
    [anon_sym_LBRACK] = ACTIONS(3090),
    [anon_sym_STAR] = ACTIONS(3090),
    [anon_sym_u8] = ACTIONS(3092),
    [anon_sym_i8] = ACTIONS(3092),
    [anon_sym_u16] = ACTIONS(3092),
    [anon_sym_i16] = ACTIONS(3092),
    [anon_sym_u32] = ACTIONS(3092),
    [anon_sym_i32] = ACTIONS(3092),
    [anon_sym_u64] = ACTIONS(3092),
    [anon_sym_i64] = ACTIONS(3092),
    [anon_sym_u128] = ACTIONS(3092),
    [anon_sym_i128] = ACTIONS(3092),
    [anon_sym_isize] = ACTIONS(3092),
    [anon_sym_usize] = ACTIONS(3092),
    [anon_sym_f32] = ACTIONS(3092),
    [anon_sym_f64] = ACTIONS(3092),
    [anon_sym_bool] = ACTIONS(3092),
    [anon_sym_str] = ACTIONS(3092),
    [anon_sym_char] = ACTIONS(3092),
    [anon_sym_AMP] = ACTIONS(3090),
    [anon_sym_DASH] = ACTIONS(3092),
    [anon_sym_DASH_GT] = ACTIONS(3090),
    [anon_sym_COLON_COLON] = ACTIONS(3090),
    [anon_sym_BANG] = ACTIONS(3090),
    [anon_sym_LT] = ACTIONS(3090),
    [anon_sym_PIPE] = ACTIONS(3090),
    [anon_sym_SQUOTE] = ACTIONS(3092),
    [anon_sym_DOT_DOT] = ACTIONS(3090),
    [anon_sym_break] = ACTIONS(3092),
    [anon_sym_continue] = ACTIONS(3092),
    [anon_sym_default] = ACTIONS(3092),
    [anon_sym_for] = ACTIONS(3092),
    [anon_sym_if] = ACTIONS(3092),
    [anon_sym_loop] = ACTIONS(3092),
    [anon_sym_match] = ACTIONS(3092),
    [anon_sym_return] = ACTIONS(3092),
    [anon_sym_union] = ACTIONS(3092),
    [anon_sym_unsafe] = ACTIONS(3092),
    [anon_sym_while] = ACTIONS(3092),
    [anon_sym_move] = ACTIONS(3092),
    [sym_integer_literal] = ACTIONS(3090),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3090),
    [sym_char_literal] = ACTIONS(3090),
    [anon_sym_true] = ACTIONS(3092),
    [anon_sym_false] = ACTIONS(3092),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3092),
    [sym_self] = ACTIONS(3092),
    [sym_super] = ACTIONS(3092),
    [sym_crate] = ACTIONS(3092),
    [sym_metavariable] = ACTIONS(3090),
  },
  [920] = {
    [aux_sym_closure_parameters_repeat1] = STATE(920),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(3094),
    [anon_sym_PIPE] = ACTIONS(3088),
    [sym_line_comment] = ACTIONS(7),
  },
  [921] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2529),
    [anon_sym_LPAREN] = ACTIONS(2529),
    [anon_sym_RPAREN] = ACTIONS(2529),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_RBRACE] = ACTIONS(2529),
    [anon_sym_COLON] = ACTIONS(2533),
    [anon_sym_COMMA] = ACTIONS(2529),
    [anon_sym_COLON_COLON] = ACTIONS(2529),
    [anon_sym_LT] = ACTIONS(3012),
    [anon_sym_EQ] = ACTIONS(2529),
    [anon_sym_PIPE] = ACTIONS(2529),
    [anon_sym_in] = ACTIONS(2529),
    [sym_line_comment] = ACTIONS(7),
  },
  [922] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3097),
    [anon_sym_RPAREN] = ACTIONS(3097),
    [anon_sym_RBRACE] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_COMMA] = ACTIONS(3097),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_PIPE] = ACTIONS(3097),
    [anon_sym_in] = ACTIONS(3097),
    [sym_line_comment] = ACTIONS(7),
  },
  [923] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(3099),
    [sym_line_comment] = ACTIONS(7),
  },
  [924] = {
    [aux_sym_struct_pattern_repeat1] = STATE(1576),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(3099),
    [anon_sym_COMMA] = ACTIONS(3101),
    [sym_line_comment] = ACTIONS(7),
  },
  [925] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(3103),
    [sym_mutable_specifier] = ACTIONS(3103),
    [sym_line_comment] = ACTIONS(7),
  },
  [926] = {
    [sym_function_modifiers] = STATE(929),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(385),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1579),
    [sym_array_type] = STATE(385),
    [sym_function_type] = STATE(385),
    [sym_tuple_type] = STATE(385),
    [sym_unit_type] = STATE(385),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(385),
    [sym_reference_type] = STATE(385),
    [sym_pointer_type] = STATE(385),
    [sym_empty_type] = STATE(385),
    [sym_dynamic_type] = STATE(385),
    [sym_macro_invocation] = STATE(385),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(932),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1928),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1930),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1932),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(3105),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1934),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [927] = {
    [sym_parameters] = STATE(1580),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [928] = {
    [sym_parameters] = STATE(1581),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_BANG] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_EQ] = ACTIONS(773),
    [sym_line_comment] = ACTIONS(7),
  },
  [929] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1584),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_fn] = ACTIONS(3107),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3109),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [930] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(3111),
    [anon_sym_EQ] = ACTIONS(3113),
    [sym_line_comment] = ACTIONS(7),
  },
  [931] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(3115),
    [sym_line_comment] = ACTIONS(7),
  },
  [932] = {
    [sym_parameters] = STATE(1580),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_EQ] = ACTIONS(783),
    [sym_line_comment] = ACTIONS(7),
  },
  [933] = {
    [sym_raw_string_literal] = ACTIONS(3117),
    [sym_float_literal] = ACTIONS(3117),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(3117),
    [anon_sym_SEMI] = ACTIONS(3117),
    [anon_sym_macro_rules_BANG] = ACTIONS(3117),
    [anon_sym_LPAREN] = ACTIONS(3117),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_RBRACE] = ACTIONS(3117),
    [anon_sym_LBRACK] = ACTIONS(3117),
    [anon_sym_STAR] = ACTIONS(3117),
    [anon_sym_u8] = ACTIONS(3119),
    [anon_sym_i8] = ACTIONS(3119),
    [anon_sym_u16] = ACTIONS(3119),
    [anon_sym_i16] = ACTIONS(3119),
    [anon_sym_u32] = ACTIONS(3119),
    [anon_sym_i32] = ACTIONS(3119),
    [anon_sym_u64] = ACTIONS(3119),
    [anon_sym_i64] = ACTIONS(3119),
    [anon_sym_u128] = ACTIONS(3119),
    [anon_sym_i128] = ACTIONS(3119),
    [anon_sym_isize] = ACTIONS(3119),
    [anon_sym_usize] = ACTIONS(3119),
    [anon_sym_f32] = ACTIONS(3119),
    [anon_sym_f64] = ACTIONS(3119),
    [anon_sym_bool] = ACTIONS(3119),
    [anon_sym_str] = ACTIONS(3119),
    [anon_sym_char] = ACTIONS(3119),
    [anon_sym_AMP] = ACTIONS(3117),
    [anon_sym_DASH] = ACTIONS(3117),
    [anon_sym_COLON_COLON] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3117),
    [anon_sym_POUND] = ACTIONS(3117),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_PIPE] = ACTIONS(3117),
    [anon_sym_SQUOTE] = ACTIONS(3119),
    [anon_sym_DOT_DOT] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_const] = ACTIONS(3119),
    [anon_sym_continue] = ACTIONS(3119),
    [anon_sym_default] = ACTIONS(3119),
    [anon_sym_enum] = ACTIONS(3119),
    [anon_sym_fn] = ACTIONS(3119),
    [anon_sym_for] = ACTIONS(3119),
    [anon_sym_if] = ACTIONS(3119),
    [anon_sym_impl] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_loop] = ACTIONS(3119),
    [anon_sym_match] = ACTIONS(3119),
    [anon_sym_mod] = ACTIONS(3119),
    [anon_sym_pub] = ACTIONS(3119),
    [anon_sym_return] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(3119),
    [anon_sym_struct] = ACTIONS(3119),
    [anon_sym_trait] = ACTIONS(3119),
    [anon_sym_type] = ACTIONS(3119),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(3119),
    [anon_sym_use] = ACTIONS(3119),
    [anon_sym_while] = ACTIONS(3119),
    [anon_sym_extern] = ACTIONS(3119),
    [anon_sym_move] = ACTIONS(3119),
    [sym_integer_literal] = ACTIONS(3117),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3117),
    [sym_char_literal] = ACTIONS(3117),
    [anon_sym_true] = ACTIONS(3119),
    [anon_sym_false] = ACTIONS(3119),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3119),
    [sym_self] = ACTIONS(3119),
    [sym_super] = ACTIONS(3119),
    [sym_crate] = ACTIONS(3119),
    [sym_metavariable] = ACTIONS(3117),
  },
  [934] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(3121),
    [sym_line_comment] = ACTIONS(7),
  },
  [935] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(3123),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(355),
  },
  [936] = {
    [sym_field_declaration_list] = STATE(1592),
    [sym_ordered_field_declaration_list] = STATE(1592),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(3125),
    [anon_sym_RBRACE] = ACTIONS(3127),
    [anon_sym_COMMA] = ACTIONS(3127),
    [anon_sym_EQ] = ACTIONS(3129),
    [sym_line_comment] = ACTIONS(7),
  },
  [937] = {
    [aux_sym_enum_variant_list_repeat2] = STATE(1594),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(3121),
    [anon_sym_COMMA] = ACTIONS(3131),
    [sym_line_comment] = ACTIONS(7),
  },
  [938] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3133),
  },
  [939] = {
    [sym_attribute_item] = STATE(1597),
    [sym_enum_variant] = STATE(1596),
    [sym_visibility_modifier] = STATE(938),
    [aux_sym_enum_variant_list_repeat1] = STATE(1597),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_pub] = ACTIONS(1940),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1942),
  },
  [940] = {
    [sym_trait_bounds] = STATE(993),
    [aux_sym_type_parameters_repeat1] = STATE(994),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2032),
    [anon_sym_COMMA] = ACTIONS(2022),
    [anon_sym_EQ] = ACTIONS(2024),
    [anon_sym_GT] = ACTIONS(2026),
    [sym_line_comment] = ACTIONS(7),
  },
  [941] = {
    [sym_trait_bounds] = STATE(998),
    [aux_sym_type_parameters_repeat1] = STATE(996),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2032),
    [anon_sym_COMMA] = ACTIONS(2022),
    [anon_sym_GT] = ACTIONS(2028),
    [sym_line_comment] = ACTIONS(7),
  },
  [942] = {
    [sym_function_modifiers] = STATE(1603),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1604),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1605),
    [sym_array_type] = STATE(1604),
    [sym_function_type] = STATE(1604),
    [sym_tuple_type] = STATE(1604),
    [sym_unit_type] = STATE(1604),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1604),
    [sym_reference_type] = STATE(1604),
    [sym_pointer_type] = STATE(1604),
    [sym_empty_type] = STATE(1604),
    [sym_dynamic_type] = STATE(1604),
    [sym_macro_invocation] = STATE(1604),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1606),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3135),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3137),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3139),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(3141),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3143),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [943] = {
    [sym_trait_bounds] = STATE(1608),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(3145),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [944] = {
    [aux_sym_where_clause_repeat1] = STATE(1610),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(3147),
    [anon_sym_COMMA] = ACTIONS(3149),
    [sym_line_comment] = ACTIONS(7),
  },
  [945] = {
    [sym_trait_bounds] = STATE(1611),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(3151),
    [sym_line_comment] = ACTIONS(7),
  },
  [946] = {
    [sym_trait_bounds] = STATE(1611),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(3145),
    [anon_sym_COLON_COLON] = ACTIONS(799),
    [sym_line_comment] = ACTIONS(7),
  },
  [947] = {
    [sym_trait_bounds] = STATE(1611),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(3151),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [948] = {
    [sym_raw_string_literal] = ACTIONS(3153),
    [sym_float_literal] = ACTIONS(3153),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(3153),
    [anon_sym_SEMI] = ACTIONS(3153),
    [anon_sym_macro_rules_BANG] = ACTIONS(3153),
    [anon_sym_LPAREN] = ACTIONS(3153),
    [anon_sym_LBRACE] = ACTIONS(3153),
    [anon_sym_RBRACE] = ACTIONS(3153),
    [anon_sym_LBRACK] = ACTIONS(3153),
    [anon_sym_STAR] = ACTIONS(3153),
    [anon_sym_u8] = ACTIONS(3155),
    [anon_sym_i8] = ACTIONS(3155),
    [anon_sym_u16] = ACTIONS(3155),
    [anon_sym_i16] = ACTIONS(3155),
    [anon_sym_u32] = ACTIONS(3155),
    [anon_sym_i32] = ACTIONS(3155),
    [anon_sym_u64] = ACTIONS(3155),
    [anon_sym_i64] = ACTIONS(3155),
    [anon_sym_u128] = ACTIONS(3155),
    [anon_sym_i128] = ACTIONS(3155),
    [anon_sym_isize] = ACTIONS(3155),
    [anon_sym_usize] = ACTIONS(3155),
    [anon_sym_f32] = ACTIONS(3155),
    [anon_sym_f64] = ACTIONS(3155),
    [anon_sym_bool] = ACTIONS(3155),
    [anon_sym_str] = ACTIONS(3155),
    [anon_sym_char] = ACTIONS(3155),
    [anon_sym_AMP] = ACTIONS(3153),
    [anon_sym_DASH] = ACTIONS(3153),
    [anon_sym_COLON_COLON] = ACTIONS(3153),
    [anon_sym_BANG] = ACTIONS(3153),
    [anon_sym_POUND] = ACTIONS(3153),
    [anon_sym_LT] = ACTIONS(3153),
    [anon_sym_PIPE] = ACTIONS(3153),
    [anon_sym_SQUOTE] = ACTIONS(3155),
    [anon_sym_DOT_DOT] = ACTIONS(3153),
    [anon_sym_break] = ACTIONS(3155),
    [anon_sym_const] = ACTIONS(3155),
    [anon_sym_continue] = ACTIONS(3155),
    [anon_sym_default] = ACTIONS(3155),
    [anon_sym_enum] = ACTIONS(3155),
    [anon_sym_fn] = ACTIONS(3155),
    [anon_sym_for] = ACTIONS(3155),
    [anon_sym_if] = ACTIONS(3155),
    [anon_sym_impl] = ACTIONS(3155),
    [anon_sym_let] = ACTIONS(3155),
    [anon_sym_loop] = ACTIONS(3155),
    [anon_sym_match] = ACTIONS(3155),
    [anon_sym_mod] = ACTIONS(3155),
    [anon_sym_pub] = ACTIONS(3155),
    [anon_sym_return] = ACTIONS(3155),
    [anon_sym_static] = ACTIONS(3155),
    [anon_sym_struct] = ACTIONS(3155),
    [anon_sym_trait] = ACTIONS(3155),
    [anon_sym_type] = ACTIONS(3155),
    [anon_sym_union] = ACTIONS(3155),
    [anon_sym_unsafe] = ACTIONS(3155),
    [anon_sym_use] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(3155),
    [anon_sym_extern] = ACTIONS(3155),
    [anon_sym_move] = ACTIONS(3155),
    [sym_integer_literal] = ACTIONS(3153),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3153),
    [sym_char_literal] = ACTIONS(3153),
    [anon_sym_true] = ACTIONS(3155),
    [anon_sym_false] = ACTIONS(3155),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3155),
    [sym_self] = ACTIONS(3155),
    [sym_super] = ACTIONS(3155),
    [sym_crate] = ACTIONS(3155),
    [sym_metavariable] = ACTIONS(3153),
  },
  [949] = {
    [sym_enum_variant_list] = STATE(1612),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(923),
    [sym_line_comment] = ACTIONS(7),
  },
  [950] = {
    [sym_where_clause] = STATE(1615),
    [sym_block] = STATE(1616),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3157),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_DASH_GT] = ACTIONS(3159),
    [anon_sym_where] = ACTIONS(1962),
    [sym_line_comment] = ACTIONS(7),
  },
  [951] = {
    [sym_raw_string_literal] = ACTIONS(3161),
    [sym_float_literal] = ACTIONS(3161),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(3161),
    [anon_sym_SEMI] = ACTIONS(3161),
    [anon_sym_macro_rules_BANG] = ACTIONS(3161),
    [anon_sym_LPAREN] = ACTIONS(3161),
    [anon_sym_LBRACE] = ACTIONS(3161),
    [anon_sym_RBRACE] = ACTIONS(3161),
    [anon_sym_LBRACK] = ACTIONS(3161),
    [anon_sym_STAR] = ACTIONS(3161),
    [anon_sym_u8] = ACTIONS(3163),
    [anon_sym_i8] = ACTIONS(3163),
    [anon_sym_u16] = ACTIONS(3163),
    [anon_sym_i16] = ACTIONS(3163),
    [anon_sym_u32] = ACTIONS(3163),
    [anon_sym_i32] = ACTIONS(3163),
    [anon_sym_u64] = ACTIONS(3163),
    [anon_sym_i64] = ACTIONS(3163),
    [anon_sym_u128] = ACTIONS(3163),
    [anon_sym_i128] = ACTIONS(3163),
    [anon_sym_isize] = ACTIONS(3163),
    [anon_sym_usize] = ACTIONS(3163),
    [anon_sym_f32] = ACTIONS(3163),
    [anon_sym_f64] = ACTIONS(3163),
    [anon_sym_bool] = ACTIONS(3163),
    [anon_sym_str] = ACTIONS(3163),
    [anon_sym_char] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3161),
    [anon_sym_DASH] = ACTIONS(3161),
    [anon_sym_COLON_COLON] = ACTIONS(3161),
    [anon_sym_BANG] = ACTIONS(3161),
    [anon_sym_POUND] = ACTIONS(3161),
    [anon_sym_LT] = ACTIONS(3161),
    [anon_sym_PIPE] = ACTIONS(3161),
    [anon_sym_SQUOTE] = ACTIONS(3163),
    [anon_sym_DOT_DOT] = ACTIONS(3161),
    [anon_sym_break] = ACTIONS(3163),
    [anon_sym_const] = ACTIONS(3163),
    [anon_sym_continue] = ACTIONS(3163),
    [anon_sym_default] = ACTIONS(3163),
    [anon_sym_enum] = ACTIONS(3163),
    [anon_sym_fn] = ACTIONS(3163),
    [anon_sym_for] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3163),
    [anon_sym_impl] = ACTIONS(3163),
    [anon_sym_let] = ACTIONS(3163),
    [anon_sym_loop] = ACTIONS(3163),
    [anon_sym_match] = ACTIONS(3163),
    [anon_sym_mod] = ACTIONS(3163),
    [anon_sym_pub] = ACTIONS(3163),
    [anon_sym_return] = ACTIONS(3163),
    [anon_sym_static] = ACTIONS(3163),
    [anon_sym_struct] = ACTIONS(3163),
    [anon_sym_trait] = ACTIONS(3163),
    [anon_sym_type] = ACTIONS(3163),
    [anon_sym_union] = ACTIONS(3163),
    [anon_sym_unsafe] = ACTIONS(3163),
    [anon_sym_use] = ACTIONS(3163),
    [anon_sym_while] = ACTIONS(3163),
    [anon_sym_extern] = ACTIONS(3163),
    [anon_sym_move] = ACTIONS(3163),
    [sym_integer_literal] = ACTIONS(3161),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3161),
    [sym_char_literal] = ACTIONS(3161),
    [anon_sym_true] = ACTIONS(3163),
    [anon_sym_false] = ACTIONS(3163),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3163),
    [sym_self] = ACTIONS(3163),
    [sym_super] = ACTIONS(3163),
    [sym_crate] = ACTIONS(3163),
    [sym_metavariable] = ACTIONS(3161),
  },
  [952] = {
    [sym__statement] = STATE(1619),
    [sym_empty_statement] = STATE(1619),
    [sym__expression_statement] = STATE(1619),
    [sym_macro_definition] = STATE(1619),
    [sym_attribute_item] = STATE(1619),
    [sym_inner_attribute_item] = STATE(1619),
    [sym_mod_item] = STATE(1619),
    [sym_foreign_mod_item] = STATE(1619),
    [sym_struct_item] = STATE(1619),
    [sym_union_item] = STATE(1619),
    [sym_enum_item] = STATE(1619),
    [sym_extern_crate_declaration] = STATE(1619),
    [sym_const_item] = STATE(1619),
    [sym_static_item] = STATE(1619),
    [sym_type_item] = STATE(1619),
    [sym_function_item] = STATE(1619),
    [sym_function_signature_item] = STATE(1619),
    [sym_function_modifiers] = STATE(47),
    [sym_impl_item] = STATE(1619),
    [sym_trait_item] = STATE(1619),
    [sym_associated_type] = STATE(1619),
    [sym_let_declaration] = STATE(1619),
    [sym_use_declaration] = STATE(1619),
    [sym_extern_modifier] = STATE(48),
    [sym_visibility_modifier] = STATE(49),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1618),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1618),
    [sym_macro_invocation] = STATE(53),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1618),
    [sym_unary_expression] = STATE(1618),
    [sym_try_expression] = STATE(1618),
    [sym_reference_expression] = STATE(1618),
    [sym_binary_expression] = STATE(1618),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1618),
    [sym_call_expression] = STATE(1618),
    [sym_array_expression] = STATE(1618),
    [sym_parenthesized_expression] = STATE(1618),
    [sym_tuple_expression] = STATE(1618),
    [sym_unit_expression] = STATE(1618),
    [sym_struct_expression] = STATE(1618),
    [sym_if_expression] = STATE(57),
    [sym_if_let_expression] = STATE(57),
    [sym_match_expression] = STATE(57),
    [sym_while_expression] = STATE(57),
    [sym_while_let_expression] = STATE(57),
    [sym_loop_expression] = STATE(57),
    [sym_for_expression] = STATE(57),
    [sym_closure_expression] = STATE(1618),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(59),
    [sym_break_expression] = STATE(1618),
    [sym_continue_expression] = STATE(1618),
    [sym_index_expression] = STATE(1618),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(57),
    [sym_block] = STATE(57),
    [sym__literal] = STATE(1618),
    [sym_string_literal] = STATE(1618),
    [sym_boolean_literal] = STATE(1618),
    [aux_sym_source_file_repeat1] = STATE(1619),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_raw_string_literal] = ACTIONS(3165),
    [sym_float_literal] = ACTIONS(3165),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_POUND] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(3165),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(3165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(93),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [953] = {
    [sym_function_modifiers] = STATE(1624),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1625),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1626),
    [sym_array_type] = STATE(1625),
    [sym_function_type] = STATE(1625),
    [sym_tuple_type] = STATE(1625),
    [sym_unit_type] = STATE(1625),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1625),
    [sym_reference_type] = STATE(1625),
    [sym_pointer_type] = STATE(1625),
    [sym_empty_type] = STATE(1625),
    [sym_abstract_type] = STATE(1627),
    [sym_dynamic_type] = STATE(1625),
    [sym_macro_invocation] = STATE(1625),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1628),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3169),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3171),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3173),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3175),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [954] = {
    [sym_where_predicate] = STATE(1630),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1631),
    [sym_generic_type] = STATE(1632),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_reference_type] = STATE(1631),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1633),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(1948),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3177),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [955] = {
    [sym_block] = STATE(1616),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3157),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [sym_line_comment] = ACTIONS(7),
  },
  [956] = {
    [sym_raw_string_literal] = ACTIONS(3179),
    [sym_float_literal] = ACTIONS(3179),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(3179),
    [anon_sym_SEMI] = ACTIONS(3179),
    [anon_sym_macro_rules_BANG] = ACTIONS(3179),
    [anon_sym_LPAREN] = ACTIONS(3179),
    [anon_sym_LBRACE] = ACTIONS(3179),
    [anon_sym_RBRACE] = ACTIONS(3179),
    [anon_sym_LBRACK] = ACTIONS(3179),
    [anon_sym_STAR] = ACTIONS(3179),
    [anon_sym_u8] = ACTIONS(3181),
    [anon_sym_i8] = ACTIONS(3181),
    [anon_sym_u16] = ACTIONS(3181),
    [anon_sym_i16] = ACTIONS(3181),
    [anon_sym_u32] = ACTIONS(3181),
    [anon_sym_i32] = ACTIONS(3181),
    [anon_sym_u64] = ACTIONS(3181),
    [anon_sym_i64] = ACTIONS(3181),
    [anon_sym_u128] = ACTIONS(3181),
    [anon_sym_i128] = ACTIONS(3181),
    [anon_sym_isize] = ACTIONS(3181),
    [anon_sym_usize] = ACTIONS(3181),
    [anon_sym_f32] = ACTIONS(3181),
    [anon_sym_f64] = ACTIONS(3181),
    [anon_sym_bool] = ACTIONS(3181),
    [anon_sym_str] = ACTIONS(3181),
    [anon_sym_char] = ACTIONS(3181),
    [anon_sym_AMP] = ACTIONS(3179),
    [anon_sym_DASH] = ACTIONS(3179),
    [anon_sym_COLON_COLON] = ACTIONS(3179),
    [anon_sym_BANG] = ACTIONS(3179),
    [anon_sym_POUND] = ACTIONS(3179),
    [anon_sym_LT] = ACTIONS(3179),
    [anon_sym_PIPE] = ACTIONS(3179),
    [anon_sym_SQUOTE] = ACTIONS(3181),
    [anon_sym_DOT_DOT] = ACTIONS(3179),
    [anon_sym_break] = ACTIONS(3181),
    [anon_sym_const] = ACTIONS(3181),
    [anon_sym_continue] = ACTIONS(3181),
    [anon_sym_default] = ACTIONS(3181),
    [anon_sym_enum] = ACTIONS(3181),
    [anon_sym_fn] = ACTIONS(3181),
    [anon_sym_for] = ACTIONS(3181),
    [anon_sym_if] = ACTIONS(3181),
    [anon_sym_impl] = ACTIONS(3181),
    [anon_sym_let] = ACTIONS(3181),
    [anon_sym_loop] = ACTIONS(3181),
    [anon_sym_match] = ACTIONS(3181),
    [anon_sym_mod] = ACTIONS(3181),
    [anon_sym_pub] = ACTIONS(3181),
    [anon_sym_return] = ACTIONS(3181),
    [anon_sym_static] = ACTIONS(3181),
    [anon_sym_struct] = ACTIONS(3181),
    [anon_sym_trait] = ACTIONS(3181),
    [anon_sym_type] = ACTIONS(3181),
    [anon_sym_union] = ACTIONS(3181),
    [anon_sym_unsafe] = ACTIONS(3181),
    [anon_sym_use] = ACTIONS(3181),
    [anon_sym_while] = ACTIONS(3181),
    [anon_sym_extern] = ACTIONS(3181),
    [anon_sym_move] = ACTIONS(3181),
    [sym_integer_literal] = ACTIONS(3179),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3179),
    [sym_char_literal] = ACTIONS(3179),
    [anon_sym_true] = ACTIONS(3181),
    [anon_sym_false] = ACTIONS(3181),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3181),
    [sym_self] = ACTIONS(3181),
    [sym_super] = ACTIONS(3181),
    [sym_crate] = ACTIONS(3181),
    [sym_metavariable] = ACTIONS(3179),
  },
  [957] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(1634),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [958] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1670),
    [anon_sym_LPAREN] = ACTIONS(1670),
    [anon_sym_RPAREN] = ACTIONS(1670),
    [anon_sym_LBRACE] = ACTIONS(1670),
    [anon_sym_RBRACE] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(1670),
    [anon_sym_PLUS] = ACTIONS(1674),
    [anon_sym_STAR] = ACTIONS(1674),
    [anon_sym_COMMA] = ACTIONS(1670),
    [anon_sym_AMP] = ACTIONS(1674),
    [anon_sym_DASH] = ACTIONS(1674),
    [anon_sym_DOT] = ACTIONS(1674),
    [anon_sym_DASH_EQ] = ACTIONS(1670),
    [anon_sym_COLON_COLON] = ACTIONS(1670),
    [anon_sym_BANG_EQ] = ACTIONS(1670),
    [anon_sym_STAR_EQ] = ACTIONS(1670),
    [anon_sym_SLASH] = ACTIONS(1674),
    [anon_sym_SLASH_EQ] = ACTIONS(1670),
    [anon_sym_AMP_AMP] = ACTIONS(1670),
    [anon_sym_AMP_EQ] = ACTIONS(1670),
    [anon_sym_PERCENT] = ACTIONS(1674),
    [anon_sym_PERCENT_EQ] = ACTIONS(1670),
    [anon_sym_CARET] = ACTIONS(1674),
    [anon_sym_CARET_EQ] = ACTIONS(1670),
    [anon_sym_PLUS_EQ] = ACTIONS(1670),
    [anon_sym_LT] = ACTIONS(1674),
    [anon_sym_LT_LT] = ACTIONS(1674),
    [anon_sym_LT_LT_EQ] = ACTIONS(1670),
    [anon_sym_LT_EQ] = ACTIONS(1670),
    [anon_sym_EQ] = ACTIONS(1674),
    [anon_sym_EQ_EQ] = ACTIONS(1670),
    [anon_sym_GT] = ACTIONS(1674),
    [anon_sym_GT_EQ] = ACTIONS(1670),
    [anon_sym_GT_GT] = ACTIONS(1674),
    [anon_sym_GT_GT_EQ] = ACTIONS(1670),
    [anon_sym_PIPE] = ACTIONS(1674),
    [anon_sym_PIPE_EQ] = ACTIONS(1670),
    [anon_sym_PIPE_PIPE] = ACTIONS(1670),
    [anon_sym_QMARK] = ACTIONS(1670),
    [anon_sym_DOT_DOT] = ACTIONS(1674),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1670),
    [anon_sym_as] = ACTIONS(1670),
    [sym_line_comment] = ACTIONS(7),
  },
  [959] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(3183),
    [sym_line_comment] = ACTIONS(7),
  },
  [960] = {
    [sym_else_tail] = STATE(1378),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2012),
    [anon_sym_LBRACE] = ACTIONS(2012),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_PLUS] = ACTIONS(2014),
    [anon_sym_STAR] = ACTIONS(2014),
    [anon_sym_AMP] = ACTIONS(2014),
    [anon_sym_DASH] = ACTIONS(2014),
    [anon_sym_DOT] = ACTIONS(2014),
    [anon_sym_DASH_EQ] = ACTIONS(2012),
    [anon_sym_BANG_EQ] = ACTIONS(2012),
    [anon_sym_STAR_EQ] = ACTIONS(2012),
    [anon_sym_SLASH] = ACTIONS(2014),
    [anon_sym_SLASH_EQ] = ACTIONS(2012),
    [anon_sym_AMP_AMP] = ACTIONS(2012),
    [anon_sym_AMP_EQ] = ACTIONS(2012),
    [anon_sym_PERCENT] = ACTIONS(2014),
    [anon_sym_PERCENT_EQ] = ACTIONS(2012),
    [anon_sym_CARET] = ACTIONS(2014),
    [anon_sym_CARET_EQ] = ACTIONS(2012),
    [anon_sym_PLUS_EQ] = ACTIONS(2012),
    [anon_sym_LT] = ACTIONS(2014),
    [anon_sym_LT_LT] = ACTIONS(2014),
    [anon_sym_LT_LT_EQ] = ACTIONS(2012),
    [anon_sym_LT_EQ] = ACTIONS(2012),
    [anon_sym_EQ] = ACTIONS(2014),
    [anon_sym_EQ_EQ] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2014),
    [anon_sym_GT_EQ] = ACTIONS(2012),
    [anon_sym_GT_GT] = ACTIONS(2014),
    [anon_sym_GT_GT_EQ] = ACTIONS(2012),
    [anon_sym_PIPE] = ACTIONS(2014),
    [anon_sym_PIPE_EQ] = ACTIONS(2012),
    [anon_sym_PIPE_PIPE] = ACTIONS(2012),
    [anon_sym_QMARK] = ACTIONS(2012),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2012),
    [anon_sym_as] = ACTIONS(2012),
    [anon_sym_else] = ACTIONS(3185),
    [sym_line_comment] = ACTIONS(7),
  },
  [961] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(898),
    [sym_tuple_pattern] = STATE(898),
    [sym_tuple_struct_pattern] = STATE(898),
    [sym_struct_pattern] = STATE(898),
    [sym_remaining_field_pattern] = STATE(898),
    [sym_mut_pattern] = STATE(898),
    [sym_ref_pattern] = STATE(898),
    [sym_captured_pattern] = STATE(898),
    [sym_reference_pattern] = STATE(898),
    [sym__literal] = STATE(898),
    [sym_string_literal] = STATE(898),
    [sym_boolean_literal] = STATE(898),
    [sym_raw_string_literal] = ACTIONS(1858),
    [sym_float_literal] = ACTIONS(1858),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(1860),
    [anon_sym_AMP] = ACTIONS(955),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(957),
    [anon_sym_ref] = ACTIONS(959),
    [sym_integer_literal] = ACTIONS(1858),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(1858),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(961),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [962] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(916),
    [sym_tuple_pattern] = STATE(916),
    [sym_tuple_struct_pattern] = STATE(916),
    [sym_struct_pattern] = STATE(916),
    [sym_remaining_field_pattern] = STATE(916),
    [sym_mut_pattern] = STATE(916),
    [sym_ref_pattern] = STATE(916),
    [sym_captured_pattern] = STATE(916),
    [sym_reference_pattern] = STATE(916),
    [sym__literal] = STATE(916),
    [sym_string_literal] = STATE(916),
    [sym_boolean_literal] = STATE(916),
    [sym_raw_string_literal] = ACTIONS(1910),
    [sym_float_literal] = ACTIONS(1910),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(1912),
    [anon_sym_AMP] = ACTIONS(955),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(957),
    [anon_sym_ref] = ACTIONS(959),
    [sym_integer_literal] = ACTIONS(1910),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(1910),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(961),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [963] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1637),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(1637),
    [sym_macro_invocation] = STATE(1637),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1637),
    [sym_unary_expression] = STATE(1637),
    [sym_try_expression] = STATE(1637),
    [sym_reference_expression] = STATE(1637),
    [sym_binary_expression] = STATE(1637),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1637),
    [sym_call_expression] = STATE(1637),
    [sym_array_expression] = STATE(1637),
    [sym_parenthesized_expression] = STATE(1637),
    [sym_tuple_expression] = STATE(1637),
    [sym_unit_expression] = STATE(1637),
    [sym_struct_expression] = STATE(1637),
    [sym_if_expression] = STATE(1637),
    [sym_if_let_expression] = STATE(1637),
    [sym_match_expression] = STATE(1637),
    [sym_while_expression] = STATE(1637),
    [sym_while_let_expression] = STATE(1637),
    [sym_loop_expression] = STATE(1637),
    [sym_for_expression] = STATE(1637),
    [sym_closure_expression] = STATE(1637),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1637),
    [sym_continue_expression] = STATE(1637),
    [sym_index_expression] = STATE(1637),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1637),
    [sym_block] = STATE(1637),
    [sym__literal] = STATE(1637),
    [sym_string_literal] = STATE(1637),
    [sym_boolean_literal] = STATE(1637),
    [sym_raw_string_literal] = ACTIONS(3187),
    [sym_float_literal] = ACTIONS(3187),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(3187),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(3187),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [964] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [965] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2269),
    [anon_sym_LBRACE] = ACTIONS(2269),
    [anon_sym_LBRACK] = ACTIONS(2269),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(2273),
    [anon_sym_AMP] = ACTIONS(2273),
    [anon_sym_DASH] = ACTIONS(2273),
    [anon_sym_DOT] = ACTIONS(2273),
    [anon_sym_DASH_EQ] = ACTIONS(2269),
    [anon_sym_COLON_COLON] = ACTIONS(2271),
    [anon_sym_BANG_EQ] = ACTIONS(2269),
    [anon_sym_STAR_EQ] = ACTIONS(2269),
    [anon_sym_SLASH] = ACTIONS(2273),
    [anon_sym_SLASH_EQ] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2269),
    [anon_sym_AMP_EQ] = ACTIONS(2269),
    [anon_sym_PERCENT] = ACTIONS(2273),
    [anon_sym_PERCENT_EQ] = ACTIONS(2269),
    [anon_sym_CARET] = ACTIONS(2273),
    [anon_sym_CARET_EQ] = ACTIONS(2269),
    [anon_sym_PLUS_EQ] = ACTIONS(2269),
    [anon_sym_LT] = ACTIONS(2273),
    [anon_sym_LT_LT] = ACTIONS(2273),
    [anon_sym_LT_LT_EQ] = ACTIONS(2269),
    [anon_sym_LT_EQ] = ACTIONS(2269),
    [anon_sym_EQ] = ACTIONS(2273),
    [anon_sym_EQ_EQ] = ACTIONS(2269),
    [anon_sym_GT] = ACTIONS(2273),
    [anon_sym_GT_EQ] = ACTIONS(2269),
    [anon_sym_GT_GT] = ACTIONS(2273),
    [anon_sym_GT_GT_EQ] = ACTIONS(2269),
    [anon_sym_PIPE] = ACTIONS(2273),
    [anon_sym_PIPE_EQ] = ACTIONS(2269),
    [anon_sym_PIPE_PIPE] = ACTIONS(2269),
    [anon_sym_QMARK] = ACTIONS(2269),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2269),
    [anon_sym_as] = ACTIONS(2269),
    [sym_line_comment] = ACTIONS(7),
  },
  [966] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2529),
    [anon_sym_LPAREN] = ACTIONS(2529),
    [anon_sym_RPAREN] = ACTIONS(2529),
    [anon_sym_LBRACE] = ACTIONS(2529),
    [anon_sym_RBRACE] = ACTIONS(2529),
    [anon_sym_LBRACK] = ACTIONS(2529),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_STAR] = ACTIONS(2533),
    [anon_sym_COMMA] = ACTIONS(2529),
    [anon_sym_AMP] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_DOT] = ACTIONS(2533),
    [anon_sym_DASH_EQ] = ACTIONS(2529),
    [anon_sym_COLON_COLON] = ACTIONS(2529),
    [anon_sym_BANG_EQ] = ACTIONS(2529),
    [anon_sym_STAR_EQ] = ACTIONS(2529),
    [anon_sym_SLASH] = ACTIONS(2533),
    [anon_sym_SLASH_EQ] = ACTIONS(2529),
    [anon_sym_AMP_AMP] = ACTIONS(2529),
    [anon_sym_AMP_EQ] = ACTIONS(2529),
    [anon_sym_PERCENT] = ACTIONS(2533),
    [anon_sym_PERCENT_EQ] = ACTIONS(2529),
    [anon_sym_CARET] = ACTIONS(2533),
    [anon_sym_CARET_EQ] = ACTIONS(2529),
    [anon_sym_PLUS_EQ] = ACTIONS(2529),
    [anon_sym_LT] = ACTIONS(2533),
    [anon_sym_LT_LT] = ACTIONS(2533),
    [anon_sym_LT_LT_EQ] = ACTIONS(2529),
    [anon_sym_LT_EQ] = ACTIONS(2529),
    [anon_sym_EQ] = ACTIONS(2533),
    [anon_sym_EQ_EQ] = ACTIONS(2529),
    [anon_sym_GT] = ACTIONS(2533),
    [anon_sym_GT_EQ] = ACTIONS(2529),
    [anon_sym_GT_GT] = ACTIONS(2533),
    [anon_sym_GT_GT_EQ] = ACTIONS(2529),
    [anon_sym_PIPE] = ACTIONS(2533),
    [anon_sym_PIPE_EQ] = ACTIONS(2529),
    [anon_sym_PIPE_PIPE] = ACTIONS(2529),
    [anon_sym_QMARK] = ACTIONS(2529),
    [anon_sym_DOT_DOT] = ACTIONS(2533),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2529),
    [anon_sym_as] = ACTIONS(2529),
    [sym_line_comment] = ACTIONS(7),
  },
  [967] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2591),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [968] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [969] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2601),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(2601),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(2601),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(2601),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(2601),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(2601),
    [anon_sym_PLUS_EQ] = ACTIONS(2601),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(2601),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(2603),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(2601),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(2601),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(2601),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(2601),
    [sym_line_comment] = ACTIONS(7),
  },
  [970] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [971] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [972] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [973] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2591),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [974] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(2605),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2605),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(2605),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(2605),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(2605),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(2605),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(2605),
    [anon_sym_PLUS_EQ] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(2605),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(2607),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(2605),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(2605),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(2605),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(2605),
    [sym_line_comment] = ACTIONS(7),
  },
  [975] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [976] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [977] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2609),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(2609),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(2609),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(2609),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(2609),
    [anon_sym_PLUS_EQ] = ACTIONS(2609),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(2609),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(2609),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(2609),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(2609),
    [anon_sym_DOT_DOT] = ACTIONS(2611),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2609),
    [anon_sym_as] = ACTIONS(2609),
    [sym_line_comment] = ACTIONS(7),
  },
  [978] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(3189),
    [sym_mutable_specifier] = ACTIONS(3189),
    [sym_line_comment] = ACTIONS(7),
  },
  [979] = {
    [sym_function_modifiers] = STATE(982),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1319),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(1640),
    [sym_array_type] = STATE(1319),
    [sym_function_type] = STATE(1319),
    [sym_tuple_type] = STATE(1319),
    [sym_unit_type] = STATE(1319),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(1319),
    [sym_reference_type] = STATE(1319),
    [sym_pointer_type] = STATE(1319),
    [sym_empty_type] = STATE(1319),
    [sym_dynamic_type] = STATE(1319),
    [sym_macro_invocation] = STATE(1319),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(984),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(2004),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(2006),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2008),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_mutable_specifier] = ACTIONS(3191),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2010),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [980] = {
    [sym_parameters] = STATE(1641),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [sym_line_comment] = ACTIONS(7),
  },
  [981] = {
    [sym_parameters] = STATE(1642),
    [sym_type_arguments] = STATE(1330),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_LBRACE] = ACTIONS(773),
    [anon_sym_LBRACK] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(2633),
    [anon_sym_STAR] = ACTIONS(2633),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_DASH] = ACTIONS(2633),
    [anon_sym_DOT] = ACTIONS(2633),
    [anon_sym_DASH_EQ] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(2635),
    [anon_sym_BANG] = ACTIONS(557),
    [anon_sym_BANG_EQ] = ACTIONS(773),
    [anon_sym_STAR_EQ] = ACTIONS(773),
    [anon_sym_SLASH] = ACTIONS(2633),
    [anon_sym_SLASH_EQ] = ACTIONS(773),
    [anon_sym_AMP_AMP] = ACTIONS(773),
    [anon_sym_AMP_EQ] = ACTIONS(773),
    [anon_sym_PERCENT] = ACTIONS(2633),
    [anon_sym_PERCENT_EQ] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(2633),
    [anon_sym_CARET_EQ] = ACTIONS(773),
    [anon_sym_PLUS_EQ] = ACTIONS(773),
    [anon_sym_LT] = ACTIONS(2637),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_LT_LT_EQ] = ACTIONS(773),
    [anon_sym_LT_EQ] = ACTIONS(773),
    [anon_sym_EQ] = ACTIONS(2633),
    [anon_sym_EQ_EQ] = ACTIONS(773),
    [anon_sym_GT] = ACTIONS(2633),
    [anon_sym_GT_EQ] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_GT_GT_EQ] = ACTIONS(773),
    [anon_sym_PIPE] = ACTIONS(2633),
    [anon_sym_PIPE_EQ] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(773),
    [anon_sym_QMARK] = ACTIONS(773),
    [anon_sym_DOT_DOT] = ACTIONS(2633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(773),
    [anon_sym_as] = ACTIONS(773),
    [sym_line_comment] = ACTIONS(7),
  },
  [982] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1645),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_fn] = ACTIONS(3193),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3195),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [983] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(3197),
    [sym_line_comment] = ACTIONS(7),
  },
  [984] = {
    [sym_parameters] = STATE(1641),
    [sym_type_arguments] = STATE(1340),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_LBRACE] = ACTIONS(783),
    [anon_sym_LBRACK] = ACTIONS(783),
    [anon_sym_PLUS] = ACTIONS(785),
    [anon_sym_STAR] = ACTIONS(785),
    [anon_sym_AMP] = ACTIONS(785),
    [anon_sym_DASH] = ACTIONS(785),
    [anon_sym_DOT] = ACTIONS(785),
    [anon_sym_DASH_EQ] = ACTIONS(783),
    [anon_sym_BANG_EQ] = ACTIONS(783),
    [anon_sym_STAR_EQ] = ACTIONS(783),
    [anon_sym_SLASH] = ACTIONS(785),
    [anon_sym_SLASH_EQ] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_AMP_EQ] = ACTIONS(783),
    [anon_sym_PERCENT] = ACTIONS(785),
    [anon_sym_PERCENT_EQ] = ACTIONS(783),
    [anon_sym_CARET] = ACTIONS(785),
    [anon_sym_CARET_EQ] = ACTIONS(783),
    [anon_sym_PLUS_EQ] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(2637),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_LT_LT_EQ] = ACTIONS(783),
    [anon_sym_LT_EQ] = ACTIONS(783),
    [anon_sym_EQ] = ACTIONS(785),
    [anon_sym_EQ_EQ] = ACTIONS(783),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_GT_EQ] = ACTIONS(783),
    [anon_sym_GT_GT] = ACTIONS(785),
    [anon_sym_GT_GT_EQ] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PIPE_EQ] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_DOT_DOT] = ACTIONS(785),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(783),
    [anon_sym_as] = ACTIONS(783),
    [sym_line_comment] = ACTIONS(7),
  },
  [985] = {
    [sym_if_expression] = STATE(1648),
    [sym_if_let_expression] = STATE(1648),
    [sym_block] = STATE(1648),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_if] = ACTIONS(3199),
    [sym_line_comment] = ACTIONS(7),
  },
  [986] = {
    [sym_raw_string_literal] = ACTIONS(3201),
    [sym_float_literal] = ACTIONS(3201),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(3201),
    [anon_sym_SEMI] = ACTIONS(3201),
    [anon_sym_macro_rules_BANG] = ACTIONS(3201),
    [anon_sym_LPAREN] = ACTIONS(3201),
    [anon_sym_LBRACE] = ACTIONS(3201),
    [anon_sym_RBRACE] = ACTIONS(3201),
    [anon_sym_LBRACK] = ACTIONS(3201),
    [anon_sym_PLUS] = ACTIONS(3203),
    [anon_sym_STAR] = ACTIONS(3203),
    [anon_sym_u8] = ACTIONS(3203),
    [anon_sym_i8] = ACTIONS(3203),
    [anon_sym_u16] = ACTIONS(3203),
    [anon_sym_i16] = ACTIONS(3203),
    [anon_sym_u32] = ACTIONS(3203),
    [anon_sym_i32] = ACTIONS(3203),
    [anon_sym_u64] = ACTIONS(3203),
    [anon_sym_i64] = ACTIONS(3203),
    [anon_sym_u128] = ACTIONS(3203),
    [anon_sym_i128] = ACTIONS(3203),
    [anon_sym_isize] = ACTIONS(3203),
    [anon_sym_usize] = ACTIONS(3203),
    [anon_sym_f32] = ACTIONS(3203),
    [anon_sym_f64] = ACTIONS(3203),
    [anon_sym_bool] = ACTIONS(3203),
    [anon_sym_str] = ACTIONS(3203),
    [anon_sym_char] = ACTIONS(3203),
    [anon_sym_AMP] = ACTIONS(3203),
    [anon_sym_DASH] = ACTIONS(3203),
    [anon_sym_DOT] = ACTIONS(3203),
    [anon_sym_DASH_EQ] = ACTIONS(3201),
    [anon_sym_COLON_COLON] = ACTIONS(3201),
    [anon_sym_BANG] = ACTIONS(3203),
    [anon_sym_BANG_EQ] = ACTIONS(3201),
    [anon_sym_STAR_EQ] = ACTIONS(3201),
    [anon_sym_SLASH] = ACTIONS(3203),
    [anon_sym_SLASH_EQ] = ACTIONS(3201),
    [anon_sym_AMP_AMP] = ACTIONS(3201),
    [anon_sym_AMP_EQ] = ACTIONS(3201),
    [anon_sym_POUND] = ACTIONS(3201),
    [anon_sym_PERCENT] = ACTIONS(3203),
    [anon_sym_PERCENT_EQ] = ACTIONS(3201),
    [anon_sym_CARET] = ACTIONS(3203),
    [anon_sym_CARET_EQ] = ACTIONS(3201),
    [anon_sym_PLUS_EQ] = ACTIONS(3201),
    [anon_sym_LT] = ACTIONS(3203),
    [anon_sym_LT_LT] = ACTIONS(3203),
    [anon_sym_LT_LT_EQ] = ACTIONS(3201),
    [anon_sym_LT_EQ] = ACTIONS(3201),
    [anon_sym_EQ] = ACTIONS(3203),
    [anon_sym_EQ_EQ] = ACTIONS(3201),
    [anon_sym_GT] = ACTIONS(3203),
    [anon_sym_GT_EQ] = ACTIONS(3201),
    [anon_sym_GT_GT] = ACTIONS(3203),
    [anon_sym_GT_GT_EQ] = ACTIONS(3201),
    [anon_sym_PIPE] = ACTIONS(3203),
    [anon_sym_PIPE_EQ] = ACTIONS(3201),
    [anon_sym_PIPE_PIPE] = ACTIONS(3201),
    [anon_sym_QMARK] = ACTIONS(3201),
    [anon_sym_SQUOTE] = ACTIONS(3203),
    [anon_sym_DOT_DOT] = ACTIONS(3203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3201),
    [anon_sym_as] = ACTIONS(3203),
    [anon_sym_break] = ACTIONS(3203),
    [anon_sym_const] = ACTIONS(3203),
    [anon_sym_continue] = ACTIONS(3203),
    [anon_sym_default] = ACTIONS(3203),
    [anon_sym_enum] = ACTIONS(3203),
    [anon_sym_fn] = ACTIONS(3203),
    [anon_sym_for] = ACTIONS(3203),
    [anon_sym_if] = ACTIONS(3203),
    [anon_sym_impl] = ACTIONS(3203),
    [anon_sym_let] = ACTIONS(3203),
    [anon_sym_loop] = ACTIONS(3203),
    [anon_sym_match] = ACTIONS(3203),
    [anon_sym_mod] = ACTIONS(3203),
    [anon_sym_pub] = ACTIONS(3203),
    [anon_sym_return] = ACTIONS(3203),
    [anon_sym_static] = ACTIONS(3203),
    [anon_sym_struct] = ACTIONS(3203),
    [anon_sym_trait] = ACTIONS(3203),
    [anon_sym_type] = ACTIONS(3203),
    [anon_sym_union] = ACTIONS(3203),
    [anon_sym_unsafe] = ACTIONS(3203),
    [anon_sym_use] = ACTIONS(3203),
    [anon_sym_while] = ACTIONS(3203),
    [anon_sym_extern] = ACTIONS(3203),
    [anon_sym_move] = ACTIONS(3203),
    [sym_integer_literal] = ACTIONS(3201),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3201),
    [sym_char_literal] = ACTIONS(3201),
    [anon_sym_true] = ACTIONS(3203),
    [anon_sym_false] = ACTIONS(3203),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3203),
    [sym_self] = ACTIONS(3203),
    [sym_super] = ACTIONS(3203),
    [sym_crate] = ACTIONS(3203),
    [sym_metavariable] = ACTIONS(3201),
  },
  [987] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2269),
    [anon_sym_LBRACE] = ACTIONS(2269),
    [anon_sym_LBRACK] = ACTIONS(2269),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(2273),
    [anon_sym_AMP] = ACTIONS(2273),
    [anon_sym_DASH] = ACTIONS(2273),
    [anon_sym_DOT] = ACTIONS(2273),
    [anon_sym_DASH_EQ] = ACTIONS(2269),
    [anon_sym_COLON_COLON] = ACTIONS(2657),
    [anon_sym_BANG_EQ] = ACTIONS(2269),
    [anon_sym_STAR_EQ] = ACTIONS(2269),
    [anon_sym_SLASH] = ACTIONS(2273),
    [anon_sym_SLASH_EQ] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2269),
    [anon_sym_AMP_EQ] = ACTIONS(2269),
    [anon_sym_PERCENT] = ACTIONS(2273),
    [anon_sym_PERCENT_EQ] = ACTIONS(2269),
    [anon_sym_CARET] = ACTIONS(2273),
    [anon_sym_CARET_EQ] = ACTIONS(2269),
    [anon_sym_PLUS_EQ] = ACTIONS(2269),
    [anon_sym_LT] = ACTIONS(2273),
    [anon_sym_LT_LT] = ACTIONS(2273),
    [anon_sym_LT_LT_EQ] = ACTIONS(2269),
    [anon_sym_LT_EQ] = ACTIONS(2269),
    [anon_sym_EQ] = ACTIONS(2273),
    [anon_sym_EQ_EQ] = ACTIONS(2269),
    [anon_sym_GT] = ACTIONS(2273),
    [anon_sym_GT_EQ] = ACTIONS(2269),
    [anon_sym_GT_GT] = ACTIONS(2273),
    [anon_sym_GT_GT_EQ] = ACTIONS(2269),
    [anon_sym_PIPE] = ACTIONS(2273),
    [anon_sym_PIPE_EQ] = ACTIONS(2269),
    [anon_sym_PIPE_PIPE] = ACTIONS(2269),
    [anon_sym_QMARK] = ACTIONS(2269),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2269),
    [anon_sym_as] = ACTIONS(2269),
    [sym_line_comment] = ACTIONS(7),
  },
  [988] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1732),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_COMMA] = ACTIONS(1732),
    [anon_sym_GT] = ACTIONS(1732),
    [sym_mutable_specifier] = ACTIONS(1732),
    [sym_line_comment] = ACTIONS(7),
    [sym_self] = ACTIONS(1732),
  },
  [989] = {
    [sym_function_modifiers] = STATE(1655),
    [sym_higher_ranked_trait_bound] = STATE(1656),
    [sym_removed_trait_bound] = STATE(1656),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1657),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1657),
    [sym_array_type] = STATE(1657),
    [sym_function_type] = STATE(1657),
    [sym_tuple_type] = STATE(1657),
    [sym_unit_type] = STATE(1657),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1657),
    [sym_reference_type] = STATE(1657),
    [sym_pointer_type] = STATE(1657),
    [sym_empty_type] = STATE(1657),
    [sym_dynamic_type] = STATE(1657),
    [sym_macro_invocation] = STATE(1657),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1658),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3205),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3207),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_QMARK] = ACTIONS(3209),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3211),
    [anon_sym_for] = ACTIONS(3213),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3215),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [990] = {
    [sym_constrained_type_parameter] = STATE(1661),
    [sym_optional_type_parameter] = STATE(1660),
    [sym_lifetime] = STATE(1662),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3217),
    [sym_metavariable] = ACTIONS(3219),
  },
  [991] = {
    [sym_function_modifiers] = STATE(854),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1663),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1664),
    [sym_array_type] = STATE(1663),
    [sym_function_type] = STATE(1663),
    [sym_tuple_type] = STATE(1663),
    [sym_unit_type] = STATE(1663),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1663),
    [sym_reference_type] = STATE(1663),
    [sym_pointer_type] = STATE(1663),
    [sym_empty_type] = STATE(1663),
    [sym_dynamic_type] = STATE(1663),
    [sym_macro_invocation] = STATE(1663),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(858),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1786),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1788),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1790),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2972),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [992] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3221),
    [anon_sym_LPAREN] = ACTIONS(3221),
    [anon_sym_LBRACE] = ACTIONS(3221),
    [anon_sym_u8] = ACTIONS(3223),
    [anon_sym_i8] = ACTIONS(3223),
    [anon_sym_u16] = ACTIONS(3223),
    [anon_sym_i16] = ACTIONS(3223),
    [anon_sym_u32] = ACTIONS(3223),
    [anon_sym_i32] = ACTIONS(3223),
    [anon_sym_u64] = ACTIONS(3223),
    [anon_sym_i64] = ACTIONS(3223),
    [anon_sym_u128] = ACTIONS(3223),
    [anon_sym_i128] = ACTIONS(3223),
    [anon_sym_isize] = ACTIONS(3223),
    [anon_sym_usize] = ACTIONS(3223),
    [anon_sym_f32] = ACTIONS(3223),
    [anon_sym_f64] = ACTIONS(3223),
    [anon_sym_bool] = ACTIONS(3223),
    [anon_sym_str] = ACTIONS(3223),
    [anon_sym_char] = ACTIONS(3223),
    [anon_sym_COLON_COLON] = ACTIONS(3221),
    [anon_sym_LT] = ACTIONS(3221),
    [anon_sym_EQ] = ACTIONS(3221),
    [anon_sym_where] = ACTIONS(3223),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3223),
    [sym_self] = ACTIONS(3223),
    [sym_super] = ACTIONS(3223),
    [sym_crate] = ACTIONS(3223),
    [sym_metavariable] = ACTIONS(3221),
  },
  [993] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(3225),
    [anon_sym_EQ] = ACTIONS(3225),
    [anon_sym_GT] = ACTIONS(3225),
    [sym_line_comment] = ACTIONS(7),
  },
  [994] = {
    [aux_sym_type_parameters_repeat1] = STATE(1666),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(2022),
    [anon_sym_GT] = ACTIONS(3227),
    [sym_line_comment] = ACTIONS(7),
  },
  [995] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3229),
    [anon_sym_LPAREN] = ACTIONS(3229),
    [anon_sym_LBRACE] = ACTIONS(3229),
    [anon_sym_u8] = ACTIONS(3231),
    [anon_sym_i8] = ACTIONS(3231),
    [anon_sym_u16] = ACTIONS(3231),
    [anon_sym_i16] = ACTIONS(3231),
    [anon_sym_u32] = ACTIONS(3231),
    [anon_sym_i32] = ACTIONS(3231),
    [anon_sym_u64] = ACTIONS(3231),
    [anon_sym_i64] = ACTIONS(3231),
    [anon_sym_u128] = ACTIONS(3231),
    [anon_sym_i128] = ACTIONS(3231),
    [anon_sym_isize] = ACTIONS(3231),
    [anon_sym_usize] = ACTIONS(3231),
    [anon_sym_f32] = ACTIONS(3231),
    [anon_sym_f64] = ACTIONS(3231),
    [anon_sym_bool] = ACTIONS(3231),
    [anon_sym_str] = ACTIONS(3231),
    [anon_sym_char] = ACTIONS(3231),
    [anon_sym_COLON_COLON] = ACTIONS(3229),
    [anon_sym_LT] = ACTIONS(3229),
    [anon_sym_EQ] = ACTIONS(3229),
    [anon_sym_where] = ACTIONS(3231),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3231),
    [sym_self] = ACTIONS(3231),
    [sym_super] = ACTIONS(3231),
    [sym_crate] = ACTIONS(3231),
    [sym_metavariable] = ACTIONS(3229),
  },
  [996] = {
    [aux_sym_type_parameters_repeat1] = STATE(1666),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(2022),
    [anon_sym_GT] = ACTIONS(3233),
    [sym_line_comment] = ACTIONS(7),
  },
  [997] = {
    [sym_function_modifiers] = STATE(854),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1668),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1664),
    [sym_array_type] = STATE(1668),
    [sym_function_type] = STATE(1668),
    [sym_tuple_type] = STATE(1668),
    [sym_unit_type] = STATE(1668),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1668),
    [sym_reference_type] = STATE(1668),
    [sym_pointer_type] = STATE(1668),
    [sym_empty_type] = STATE(1668),
    [sym_dynamic_type] = STATE(1668),
    [sym_macro_invocation] = STATE(1668),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(858),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1786),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1788),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1790),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2972),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [998] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(3235),
    [anon_sym_EQ] = ACTIONS(3235),
    [anon_sym_GT] = ACTIONS(3235),
    [sym_line_comment] = ACTIONS(7),
  },
  [999] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(3237),
    [sym_mutable_specifier] = ACTIONS(3237),
    [sym_line_comment] = ACTIONS(7),
  },
  [1000] = {
    [sym_function_modifiers] = STATE(1003),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(385),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1671),
    [sym_array_type] = STATE(385),
    [sym_function_type] = STATE(385),
    [sym_tuple_type] = STATE(385),
    [sym_unit_type] = STATE(385),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(385),
    [sym_reference_type] = STATE(385),
    [sym_pointer_type] = STATE(385),
    [sym_empty_type] = STATE(385),
    [sym_dynamic_type] = STATE(385),
    [sym_macro_invocation] = STATE(385),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1006),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2034),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2036),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2038),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(3239),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2040),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1001] = {
    [sym_parameters] = STATE(1672),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [1002] = {
    [sym_parameters] = STATE(1673),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_BANG] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_where] = ACTIONS(773),
    [sym_line_comment] = ACTIONS(7),
  },
  [1003] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1676),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_fn] = ACTIONS(3241),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3243),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [1004] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(3245),
    [anon_sym_PLUS] = ACTIONS(3247),
    [anon_sym_where] = ACTIONS(3245),
    [sym_line_comment] = ACTIONS(7),
  },
  [1005] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(3249),
    [sym_line_comment] = ACTIONS(7),
  },
  [1006] = {
    [sym_parameters] = STATE(1672),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(783),
    [anon_sym_PLUS] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_where] = ACTIONS(783),
    [sym_line_comment] = ACTIONS(7),
  },
  [1007] = {
    [sym_raw_string_literal] = ACTIONS(3251),
    [sym_float_literal] = ACTIONS(3251),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(3251),
    [anon_sym_SEMI] = ACTIONS(3251),
    [anon_sym_macro_rules_BANG] = ACTIONS(3251),
    [anon_sym_LPAREN] = ACTIONS(3251),
    [anon_sym_LBRACE] = ACTIONS(3251),
    [anon_sym_RBRACE] = ACTIONS(3251),
    [anon_sym_LBRACK] = ACTIONS(3251),
    [anon_sym_STAR] = ACTIONS(3251),
    [anon_sym_u8] = ACTIONS(3253),
    [anon_sym_i8] = ACTIONS(3253),
    [anon_sym_u16] = ACTIONS(3253),
    [anon_sym_i16] = ACTIONS(3253),
    [anon_sym_u32] = ACTIONS(3253),
    [anon_sym_i32] = ACTIONS(3253),
    [anon_sym_u64] = ACTIONS(3253),
    [anon_sym_i64] = ACTIONS(3253),
    [anon_sym_u128] = ACTIONS(3253),
    [anon_sym_i128] = ACTIONS(3253),
    [anon_sym_isize] = ACTIONS(3253),
    [anon_sym_usize] = ACTIONS(3253),
    [anon_sym_f32] = ACTIONS(3253),
    [anon_sym_f64] = ACTIONS(3253),
    [anon_sym_bool] = ACTIONS(3253),
    [anon_sym_str] = ACTIONS(3253),
    [anon_sym_char] = ACTIONS(3253),
    [anon_sym_AMP] = ACTIONS(3251),
    [anon_sym_DASH] = ACTIONS(3251),
    [anon_sym_COLON_COLON] = ACTIONS(3251),
    [anon_sym_BANG] = ACTIONS(3251),
    [anon_sym_POUND] = ACTIONS(3251),
    [anon_sym_LT] = ACTIONS(3251),
    [anon_sym_PIPE] = ACTIONS(3251),
    [anon_sym_SQUOTE] = ACTIONS(3253),
    [anon_sym_DOT_DOT] = ACTIONS(3251),
    [anon_sym_break] = ACTIONS(3253),
    [anon_sym_const] = ACTIONS(3253),
    [anon_sym_continue] = ACTIONS(3253),
    [anon_sym_default] = ACTIONS(3253),
    [anon_sym_enum] = ACTIONS(3253),
    [anon_sym_fn] = ACTIONS(3253),
    [anon_sym_for] = ACTIONS(3253),
    [anon_sym_if] = ACTIONS(3253),
    [anon_sym_impl] = ACTIONS(3253),
    [anon_sym_let] = ACTIONS(3253),
    [anon_sym_loop] = ACTIONS(3253),
    [anon_sym_match] = ACTIONS(3253),
    [anon_sym_mod] = ACTIONS(3253),
    [anon_sym_pub] = ACTIONS(3253),
    [anon_sym_return] = ACTIONS(3253),
    [anon_sym_static] = ACTIONS(3253),
    [anon_sym_struct] = ACTIONS(3253),
    [anon_sym_trait] = ACTIONS(3253),
    [anon_sym_type] = ACTIONS(3253),
    [anon_sym_union] = ACTIONS(3253),
    [anon_sym_unsafe] = ACTIONS(3253),
    [anon_sym_use] = ACTIONS(3253),
    [anon_sym_while] = ACTIONS(3253),
    [anon_sym_extern] = ACTIONS(3253),
    [anon_sym_move] = ACTIONS(3253),
    [sym_integer_literal] = ACTIONS(3251),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3251),
    [sym_char_literal] = ACTIONS(3251),
    [anon_sym_true] = ACTIONS(3253),
    [anon_sym_false] = ACTIONS(3253),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3253),
    [sym_self] = ACTIONS(3253),
    [sym_super] = ACTIONS(3253),
    [sym_crate] = ACTIONS(3253),
    [sym_metavariable] = ACTIONS(3251),
  },
  [1008] = {
    [sym_declaration_list] = STATE(1679),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [sym_line_comment] = ACTIONS(7),
  },
  [1009] = {
    [sym_declaration_list] = STATE(1679),
    [sym_where_clause] = STATE(1680),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [1010] = {
    [sym_raw_string_literal] = ACTIONS(3255),
    [sym_float_literal] = ACTIONS(3255),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_macro_rules_BANG] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3255),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_STAR] = ACTIONS(3255),
    [anon_sym_u8] = ACTIONS(3257),
    [anon_sym_i8] = ACTIONS(3257),
    [anon_sym_u16] = ACTIONS(3257),
    [anon_sym_i16] = ACTIONS(3257),
    [anon_sym_u32] = ACTIONS(3257),
    [anon_sym_i32] = ACTIONS(3257),
    [anon_sym_u64] = ACTIONS(3257),
    [anon_sym_i64] = ACTIONS(3257),
    [anon_sym_u128] = ACTIONS(3257),
    [anon_sym_i128] = ACTIONS(3257),
    [anon_sym_isize] = ACTIONS(3257),
    [anon_sym_usize] = ACTIONS(3257),
    [anon_sym_f32] = ACTIONS(3257),
    [anon_sym_f64] = ACTIONS(3257),
    [anon_sym_bool] = ACTIONS(3257),
    [anon_sym_str] = ACTIONS(3257),
    [anon_sym_char] = ACTIONS(3257),
    [anon_sym_AMP] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_COLON_COLON] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3255),
    [anon_sym_POUND] = ACTIONS(3255),
    [anon_sym_LT] = ACTIONS(3255),
    [anon_sym_PIPE] = ACTIONS(3255),
    [anon_sym_SQUOTE] = ACTIONS(3257),
    [anon_sym_DOT_DOT] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3257),
    [anon_sym_const] = ACTIONS(3257),
    [anon_sym_continue] = ACTIONS(3257),
    [anon_sym_default] = ACTIONS(3257),
    [anon_sym_enum] = ACTIONS(3257),
    [anon_sym_fn] = ACTIONS(3257),
    [anon_sym_for] = ACTIONS(3257),
    [anon_sym_if] = ACTIONS(3257),
    [anon_sym_impl] = ACTIONS(3257),
    [anon_sym_let] = ACTIONS(3257),
    [anon_sym_loop] = ACTIONS(3257),
    [anon_sym_match] = ACTIONS(3257),
    [anon_sym_mod] = ACTIONS(3257),
    [anon_sym_pub] = ACTIONS(3257),
    [anon_sym_return] = ACTIONS(3257),
    [anon_sym_static] = ACTIONS(3257),
    [anon_sym_struct] = ACTIONS(3257),
    [anon_sym_trait] = ACTIONS(3257),
    [anon_sym_type] = ACTIONS(3257),
    [anon_sym_union] = ACTIONS(3257),
    [anon_sym_unsafe] = ACTIONS(3257),
    [anon_sym_use] = ACTIONS(3257),
    [anon_sym_while] = ACTIONS(3257),
    [anon_sym_extern] = ACTIONS(3257),
    [anon_sym_move] = ACTIONS(3257),
    [sym_integer_literal] = ACTIONS(3255),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3255),
    [sym_char_literal] = ACTIONS(3255),
    [anon_sym_true] = ACTIONS(3257),
    [anon_sym_false] = ACTIONS(3257),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3257),
    [sym_self] = ACTIONS(3257),
    [sym_super] = ACTIONS(3257),
    [sym_crate] = ACTIONS(3257),
    [sym_metavariable] = ACTIONS(3255),
  },
  [1011] = {
    [sym_declaration_list] = STATE(1681),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [sym_line_comment] = ACTIONS(7),
  },
  [1012] = {
    [sym_declaration_list] = STATE(1681),
    [sym_where_clause] = STATE(1682),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [1013] = {
    [sym_declaration_list] = STATE(1681),
    [sym_where_clause] = STATE(1682),
    [sym_impl_for_clause] = STATE(1683),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1798),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [1014] = {
    [sym_raw_string_literal] = ACTIONS(3259),
    [sym_float_literal] = ACTIONS(3259),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(3259),
    [anon_sym_SEMI] = ACTIONS(3259),
    [anon_sym_macro_rules_BANG] = ACTIONS(3259),
    [anon_sym_LPAREN] = ACTIONS(3259),
    [anon_sym_LBRACE] = ACTIONS(3259),
    [anon_sym_RBRACE] = ACTIONS(3259),
    [anon_sym_LBRACK] = ACTIONS(3259),
    [anon_sym_STAR] = ACTIONS(3259),
    [anon_sym_u8] = ACTIONS(3261),
    [anon_sym_i8] = ACTIONS(3261),
    [anon_sym_u16] = ACTIONS(3261),
    [anon_sym_i16] = ACTIONS(3261),
    [anon_sym_u32] = ACTIONS(3261),
    [anon_sym_i32] = ACTIONS(3261),
    [anon_sym_u64] = ACTIONS(3261),
    [anon_sym_i64] = ACTIONS(3261),
    [anon_sym_u128] = ACTIONS(3261),
    [anon_sym_i128] = ACTIONS(3261),
    [anon_sym_isize] = ACTIONS(3261),
    [anon_sym_usize] = ACTIONS(3261),
    [anon_sym_f32] = ACTIONS(3261),
    [anon_sym_f64] = ACTIONS(3261),
    [anon_sym_bool] = ACTIONS(3261),
    [anon_sym_str] = ACTIONS(3261),
    [anon_sym_char] = ACTIONS(3261),
    [anon_sym_AMP] = ACTIONS(3259),
    [anon_sym_DASH] = ACTIONS(3259),
    [anon_sym_COLON_COLON] = ACTIONS(3259),
    [anon_sym_BANG] = ACTIONS(3259),
    [anon_sym_POUND] = ACTIONS(3259),
    [anon_sym_LT] = ACTIONS(3259),
    [anon_sym_PIPE] = ACTIONS(3259),
    [anon_sym_SQUOTE] = ACTIONS(3261),
    [anon_sym_DOT_DOT] = ACTIONS(3259),
    [anon_sym_break] = ACTIONS(3261),
    [anon_sym_const] = ACTIONS(3261),
    [anon_sym_continue] = ACTIONS(3261),
    [anon_sym_default] = ACTIONS(3261),
    [anon_sym_enum] = ACTIONS(3261),
    [anon_sym_fn] = ACTIONS(3261),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_impl] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_loop] = ACTIONS(3261),
    [anon_sym_match] = ACTIONS(3261),
    [anon_sym_mod] = ACTIONS(3261),
    [anon_sym_pub] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_static] = ACTIONS(3261),
    [anon_sym_struct] = ACTIONS(3261),
    [anon_sym_trait] = ACTIONS(3261),
    [anon_sym_type] = ACTIONS(3261),
    [anon_sym_union] = ACTIONS(3261),
    [anon_sym_unsafe] = ACTIONS(3261),
    [anon_sym_use] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_extern] = ACTIONS(3261),
    [anon_sym_move] = ACTIONS(3261),
    [sym_integer_literal] = ACTIONS(3259),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3259),
    [sym_char_literal] = ACTIONS(3259),
    [anon_sym_true] = ACTIONS(3261),
    [anon_sym_false] = ACTIONS(3261),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3261),
    [sym_self] = ACTIONS(3261),
    [sym_super] = ACTIONS(3261),
    [sym_crate] = ACTIONS(3261),
    [sym_metavariable] = ACTIONS(3259),
  },
  [1015] = {
    [sym_declaration_list] = STATE(1684),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [sym_line_comment] = ACTIONS(7),
  },
  [1016] = {
    [sym_declaration_list] = STATE(1684),
    [sym_where_clause] = STATE(1685),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [1017] = {
    [sym_declaration_list] = STATE(1684),
    [sym_where_clause] = STATE(1685),
    [sym_impl_for_clause] = STATE(1686),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1816),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [1018] = {
    [sym_raw_string_literal] = ACTIONS(3263),
    [sym_float_literal] = ACTIONS(3263),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(3263),
    [anon_sym_SEMI] = ACTIONS(3263),
    [anon_sym_macro_rules_BANG] = ACTIONS(3263),
    [anon_sym_LPAREN] = ACTIONS(3263),
    [anon_sym_LBRACE] = ACTIONS(3263),
    [anon_sym_RBRACE] = ACTIONS(3263),
    [anon_sym_LBRACK] = ACTIONS(3263),
    [anon_sym_STAR] = ACTIONS(3263),
    [anon_sym_u8] = ACTIONS(3265),
    [anon_sym_i8] = ACTIONS(3265),
    [anon_sym_u16] = ACTIONS(3265),
    [anon_sym_i16] = ACTIONS(3265),
    [anon_sym_u32] = ACTIONS(3265),
    [anon_sym_i32] = ACTIONS(3265),
    [anon_sym_u64] = ACTIONS(3265),
    [anon_sym_i64] = ACTIONS(3265),
    [anon_sym_u128] = ACTIONS(3265),
    [anon_sym_i128] = ACTIONS(3265),
    [anon_sym_isize] = ACTIONS(3265),
    [anon_sym_usize] = ACTIONS(3265),
    [anon_sym_f32] = ACTIONS(3265),
    [anon_sym_f64] = ACTIONS(3265),
    [anon_sym_bool] = ACTIONS(3265),
    [anon_sym_str] = ACTIONS(3265),
    [anon_sym_char] = ACTIONS(3265),
    [anon_sym_AMP] = ACTIONS(3263),
    [anon_sym_DASH] = ACTIONS(3263),
    [anon_sym_COLON_COLON] = ACTIONS(3263),
    [anon_sym_BANG] = ACTIONS(3263),
    [anon_sym_POUND] = ACTIONS(3263),
    [anon_sym_LT] = ACTIONS(3263),
    [anon_sym_PIPE] = ACTIONS(3263),
    [anon_sym_SQUOTE] = ACTIONS(3265),
    [anon_sym_DOT_DOT] = ACTIONS(3263),
    [anon_sym_break] = ACTIONS(3265),
    [anon_sym_const] = ACTIONS(3265),
    [anon_sym_continue] = ACTIONS(3265),
    [anon_sym_default] = ACTIONS(3265),
    [anon_sym_enum] = ACTIONS(3265),
    [anon_sym_fn] = ACTIONS(3265),
    [anon_sym_for] = ACTIONS(3265),
    [anon_sym_if] = ACTIONS(3265),
    [anon_sym_impl] = ACTIONS(3265),
    [anon_sym_let] = ACTIONS(3265),
    [anon_sym_loop] = ACTIONS(3265),
    [anon_sym_match] = ACTIONS(3265),
    [anon_sym_mod] = ACTIONS(3265),
    [anon_sym_pub] = ACTIONS(3265),
    [anon_sym_return] = ACTIONS(3265),
    [anon_sym_static] = ACTIONS(3265),
    [anon_sym_struct] = ACTIONS(3265),
    [anon_sym_trait] = ACTIONS(3265),
    [anon_sym_type] = ACTIONS(3265),
    [anon_sym_union] = ACTIONS(3265),
    [anon_sym_unsafe] = ACTIONS(3265),
    [anon_sym_use] = ACTIONS(3265),
    [anon_sym_while] = ACTIONS(3265),
    [anon_sym_extern] = ACTIONS(3265),
    [anon_sym_move] = ACTIONS(3265),
    [sym_integer_literal] = ACTIONS(3263),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3263),
    [sym_char_literal] = ACTIONS(3263),
    [anon_sym_true] = ACTIONS(3265),
    [anon_sym_false] = ACTIONS(3265),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3265),
    [sym_self] = ACTIONS(3265),
    [sym_super] = ACTIONS(3265),
    [sym_crate] = ACTIONS(3265),
    [sym_metavariable] = ACTIONS(3263),
  },
  [1019] = {
    [sym_function_modifiers] = STATE(1025),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1687),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1027),
    [sym_array_type] = STATE(1687),
    [sym_function_type] = STATE(1687),
    [sym_tuple_type] = STATE(1687),
    [sym_unit_type] = STATE(1687),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1687),
    [sym_reference_type] = STATE(1687),
    [sym_pointer_type] = STATE(1687),
    [sym_empty_type] = STATE(1687),
    [sym_dynamic_type] = STATE(1687),
    [sym_macro_invocation] = STATE(1687),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1028),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2060),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2062),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2064),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2066),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1020] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1688),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1688),
    [sym_macro_invocation] = STATE(1688),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1688),
    [sym_unary_expression] = STATE(1688),
    [sym_try_expression] = STATE(1688),
    [sym_reference_expression] = STATE(1688),
    [sym_binary_expression] = STATE(1688),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1688),
    [sym_call_expression] = STATE(1688),
    [sym_array_expression] = STATE(1688),
    [sym_parenthesized_expression] = STATE(1688),
    [sym_tuple_expression] = STATE(1688),
    [sym_unit_expression] = STATE(1688),
    [sym_struct_expression] = STATE(1688),
    [sym_if_expression] = STATE(1688),
    [sym_if_let_expression] = STATE(1688),
    [sym_match_expression] = STATE(1688),
    [sym_while_expression] = STATE(1688),
    [sym_while_let_expression] = STATE(1688),
    [sym_loop_expression] = STATE(1688),
    [sym_for_expression] = STATE(1688),
    [sym_closure_expression] = STATE(1688),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1688),
    [sym_continue_expression] = STATE(1688),
    [sym_index_expression] = STATE(1688),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1688),
    [sym_block] = STATE(1688),
    [sym__literal] = STATE(1688),
    [sym_string_literal] = STATE(1688),
    [sym_boolean_literal] = STATE(1688),
    [sym_raw_string_literal] = ACTIONS(3267),
    [sym_float_literal] = ACTIONS(3267),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(3267),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(3267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1021] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(3269),
    [sym_mutable_specifier] = ACTIONS(3269),
    [sym_line_comment] = ACTIONS(7),
  },
  [1022] = {
    [sym_function_modifiers] = STATE(1025),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(385),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1691),
    [sym_array_type] = STATE(385),
    [sym_function_type] = STATE(385),
    [sym_tuple_type] = STATE(385),
    [sym_unit_type] = STATE(385),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(385),
    [sym_reference_type] = STATE(385),
    [sym_pointer_type] = STATE(385),
    [sym_empty_type] = STATE(385),
    [sym_dynamic_type] = STATE(385),
    [sym_macro_invocation] = STATE(385),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1028),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2060),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2062),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2064),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(3271),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2066),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1023] = {
    [sym_parameters] = STATE(1692),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [1024] = {
    [sym_parameters] = STATE(1693),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_BANG] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_EQ] = ACTIONS(773),
    [sym_line_comment] = ACTIONS(7),
  },
  [1025] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1696),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_fn] = ACTIONS(3273),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3275),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [1026] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3277),
    [anon_sym_PLUS] = ACTIONS(3279),
    [anon_sym_EQ] = ACTIONS(3281),
    [sym_line_comment] = ACTIONS(7),
  },
  [1027] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(3283),
    [sym_line_comment] = ACTIONS(7),
  },
  [1028] = {
    [sym_parameters] = STATE(1692),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(783),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_EQ] = ACTIONS(783),
    [sym_line_comment] = ACTIONS(7),
  },
  [1029] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3277),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(467),
    [anon_sym_BANG_EQ] = ACTIONS(469),
    [anon_sym_STAR_EQ] = ACTIONS(467),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(467),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_AMP_EQ] = ACTIONS(467),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(467),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_CARET_EQ] = ACTIONS(467),
    [anon_sym_PLUS_EQ] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT_LT_EQ] = ACTIONS(467),
    [anon_sym_LT_EQ] = ACTIONS(469),
    [anon_sym_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_EQ] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_PIPE_EQ] = ACTIONS(467),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(489),
    [anon_sym_as] = ACTIONS(491),
    [sym_line_comment] = ACTIONS(7),
  },
  [1030] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(1703),
    [sym_tuple_pattern] = STATE(1703),
    [sym_tuple_struct_pattern] = STATE(1703),
    [sym_struct_pattern] = STATE(1703),
    [sym_remaining_field_pattern] = STATE(1703),
    [sym_mut_pattern] = STATE(1703),
    [sym_ref_pattern] = STATE(1703),
    [sym_captured_pattern] = STATE(1703),
    [sym_reference_pattern] = STATE(1703),
    [sym__literal] = STATE(1703),
    [sym_string_literal] = STATE(1703),
    [sym_boolean_literal] = STATE(1703),
    [sym_raw_string_literal] = ACTIONS(3285),
    [sym_float_literal] = ACTIONS(3285),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_RPAREN] = ACTIONS(3287),
    [anon_sym_COMMA] = ACTIONS(3289),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(3291),
    [anon_sym_AMP] = ACTIONS(817),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(819),
    [anon_sym_ref] = ACTIONS(821),
    [sym_integer_literal] = ACTIONS(3285),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(3285),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(823),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [1031] = {
    [sym_raw_string_literal] = ACTIONS(3293),
    [sym_float_literal] = ACTIONS(3293),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(3293),
    [anon_sym_SEMI] = ACTIONS(3293),
    [anon_sym_macro_rules_BANG] = ACTIONS(3293),
    [anon_sym_LPAREN] = ACTIONS(3293),
    [anon_sym_LBRACE] = ACTIONS(3293),
    [anon_sym_RBRACE] = ACTIONS(3293),
    [anon_sym_LBRACK] = ACTIONS(3293),
    [anon_sym_PLUS] = ACTIONS(3295),
    [anon_sym_STAR] = ACTIONS(3295),
    [anon_sym_u8] = ACTIONS(3295),
    [anon_sym_i8] = ACTIONS(3295),
    [anon_sym_u16] = ACTIONS(3295),
    [anon_sym_i16] = ACTIONS(3295),
    [anon_sym_u32] = ACTIONS(3295),
    [anon_sym_i32] = ACTIONS(3295),
    [anon_sym_u64] = ACTIONS(3295),
    [anon_sym_i64] = ACTIONS(3295),
    [anon_sym_u128] = ACTIONS(3295),
    [anon_sym_i128] = ACTIONS(3295),
    [anon_sym_isize] = ACTIONS(3295),
    [anon_sym_usize] = ACTIONS(3295),
    [anon_sym_f32] = ACTIONS(3295),
    [anon_sym_f64] = ACTIONS(3295),
    [anon_sym_bool] = ACTIONS(3295),
    [anon_sym_str] = ACTIONS(3295),
    [anon_sym_char] = ACTIONS(3295),
    [anon_sym_AMP] = ACTIONS(3295),
    [anon_sym_DASH] = ACTIONS(3295),
    [anon_sym_DOT] = ACTIONS(3295),
    [anon_sym_DASH_EQ] = ACTIONS(3293),
    [anon_sym_COLON_COLON] = ACTIONS(3293),
    [anon_sym_BANG] = ACTIONS(3295),
    [anon_sym_BANG_EQ] = ACTIONS(3293),
    [anon_sym_STAR_EQ] = ACTIONS(3293),
    [anon_sym_SLASH] = ACTIONS(3295),
    [anon_sym_SLASH_EQ] = ACTIONS(3293),
    [anon_sym_AMP_AMP] = ACTIONS(3293),
    [anon_sym_AMP_EQ] = ACTIONS(3293),
    [anon_sym_POUND] = ACTIONS(3293),
    [anon_sym_PERCENT] = ACTIONS(3295),
    [anon_sym_PERCENT_EQ] = ACTIONS(3293),
    [anon_sym_CARET] = ACTIONS(3295),
    [anon_sym_CARET_EQ] = ACTIONS(3293),
    [anon_sym_PLUS_EQ] = ACTIONS(3293),
    [anon_sym_LT] = ACTIONS(3295),
    [anon_sym_LT_LT] = ACTIONS(3295),
    [anon_sym_LT_LT_EQ] = ACTIONS(3293),
    [anon_sym_LT_EQ] = ACTIONS(3293),
    [anon_sym_EQ] = ACTIONS(3295),
    [anon_sym_EQ_EQ] = ACTIONS(3293),
    [anon_sym_GT] = ACTIONS(3295),
    [anon_sym_GT_EQ] = ACTIONS(3293),
    [anon_sym_GT_GT] = ACTIONS(3295),
    [anon_sym_GT_GT_EQ] = ACTIONS(3293),
    [anon_sym_PIPE] = ACTIONS(3295),
    [anon_sym_PIPE_EQ] = ACTIONS(3293),
    [anon_sym_PIPE_PIPE] = ACTIONS(3293),
    [anon_sym_QMARK] = ACTIONS(3293),
    [anon_sym_SQUOTE] = ACTIONS(3295),
    [anon_sym_DOT_DOT] = ACTIONS(3295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3293),
    [anon_sym_as] = ACTIONS(3295),
    [anon_sym_break] = ACTIONS(3295),
    [anon_sym_const] = ACTIONS(3295),
    [anon_sym_continue] = ACTIONS(3295),
    [anon_sym_default] = ACTIONS(3295),
    [anon_sym_enum] = ACTIONS(3295),
    [anon_sym_fn] = ACTIONS(3295),
    [anon_sym_for] = ACTIONS(3295),
    [anon_sym_if] = ACTIONS(3295),
    [anon_sym_impl] = ACTIONS(3295),
    [anon_sym_let] = ACTIONS(3295),
    [anon_sym_loop] = ACTIONS(3295),
    [anon_sym_match] = ACTIONS(3295),
    [anon_sym_mod] = ACTIONS(3295),
    [anon_sym_pub] = ACTIONS(3295),
    [anon_sym_return] = ACTIONS(3295),
    [anon_sym_static] = ACTIONS(3295),
    [anon_sym_struct] = ACTIONS(3295),
    [anon_sym_trait] = ACTIONS(3295),
    [anon_sym_type] = ACTIONS(3295),
    [anon_sym_union] = ACTIONS(3295),
    [anon_sym_unsafe] = ACTIONS(3295),
    [anon_sym_use] = ACTIONS(3295),
    [anon_sym_while] = ACTIONS(3295),
    [anon_sym_extern] = ACTIONS(3295),
    [anon_sym_move] = ACTIONS(3295),
    [sym_integer_literal] = ACTIONS(3293),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3293),
    [sym_char_literal] = ACTIONS(3293),
    [anon_sym_true] = ACTIONS(3295),
    [anon_sym_false] = ACTIONS(3295),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3295),
    [sym_self] = ACTIONS(3295),
    [sym_super] = ACTIONS(3295),
    [sym_crate] = ACTIONS(3295),
    [sym_metavariable] = ACTIONS(3293),
  },
  [1032] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON_COLON] = ACTIONS(3297),
    [sym_line_comment] = ACTIONS(7),
  },
  [1033] = {
    [sym_bracketed_type] = STATE(1041),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(1042),
    [sym_scoped_identifier] = STATE(1043),
    [sym_scoped_type_identifier] = STATE(1044),
    [sym__pattern] = STATE(1706),
    [sym_tuple_pattern] = STATE(1706),
    [sym_tuple_struct_pattern] = STATE(1706),
    [sym_struct_pattern] = STATE(1706),
    [sym_remaining_field_pattern] = STATE(1706),
    [sym_mut_pattern] = STATE(1706),
    [sym_ref_pattern] = STATE(1706),
    [sym_captured_pattern] = STATE(1706),
    [sym_reference_pattern] = STATE(1706),
    [sym__literal] = STATE(1706),
    [sym_string_literal] = STATE(1706),
    [sym_boolean_literal] = STATE(1706),
    [sym_raw_string_literal] = ACTIONS(3299),
    [sym_float_literal] = ACTIONS(3299),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2072),
    [anon_sym_u8] = ACTIONS(2076),
    [anon_sym_i8] = ACTIONS(2076),
    [anon_sym_u16] = ACTIONS(2076),
    [anon_sym_i16] = ACTIONS(2076),
    [anon_sym_u32] = ACTIONS(2076),
    [anon_sym_i32] = ACTIONS(2076),
    [anon_sym_u64] = ACTIONS(2076),
    [anon_sym_i64] = ACTIONS(2076),
    [anon_sym_u128] = ACTIONS(2076),
    [anon_sym_i128] = ACTIONS(2076),
    [anon_sym_isize] = ACTIONS(2076),
    [anon_sym_usize] = ACTIONS(2076),
    [anon_sym_f32] = ACTIONS(2076),
    [anon_sym_f64] = ACTIONS(2076),
    [anon_sym_bool] = ACTIONS(2076),
    [anon_sym_str] = ACTIONS(2076),
    [anon_sym_char] = ACTIONS(2076),
    [anon_sym__] = ACTIONS(3301),
    [anon_sym_AMP] = ACTIONS(2080),
    [anon_sym_COLON_COLON] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(2086),
    [sym_mutable_specifier] = ACTIONS(3303),
    [anon_sym_ref] = ACTIONS(2090),
    [sym_integer_literal] = ACTIONS(3299),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(769),
    [sym_char_literal] = ACTIONS(3299),
    [anon_sym_true] = ACTIONS(2092),
    [anon_sym_false] = ACTIONS(2092),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2094),
    [sym_self] = ACTIONS(2096),
    [sym_super] = ACTIONS(2096),
    [sym_crate] = ACTIONS(2096),
    [sym_metavariable] = ACTIONS(2098),
  },
  [1034] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3305),
  },
  [1035] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACK] = ACTIONS(3307),
    [sym_line_comment] = ACTIONS(7),
  },
  [1036] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(851),
    [anon_sym_PIPE] = ACTIONS(851),
    [anon_sym_if] = ACTIONS(851),
    [sym_line_comment] = ACTIONS(7),
  },
  [1037] = {
    [sym_bracketed_type] = STATE(1041),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(1042),
    [sym_scoped_identifier] = STATE(1043),
    [sym_scoped_type_identifier] = STATE(1044),
    [sym__pattern] = STATE(1709),
    [sym_tuple_pattern] = STATE(1709),
    [sym_tuple_struct_pattern] = STATE(1709),
    [sym_struct_pattern] = STATE(1709),
    [sym_remaining_field_pattern] = STATE(1709),
    [sym_mut_pattern] = STATE(1709),
    [sym_ref_pattern] = STATE(1709),
    [sym_captured_pattern] = STATE(1709),
    [sym_reference_pattern] = STATE(1709),
    [sym__literal] = STATE(1709),
    [sym_string_literal] = STATE(1709),
    [sym_boolean_literal] = STATE(1709),
    [sym_raw_string_literal] = ACTIONS(3309),
    [sym_float_literal] = ACTIONS(3309),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2072),
    [anon_sym_u8] = ACTIONS(2076),
    [anon_sym_i8] = ACTIONS(2076),
    [anon_sym_u16] = ACTIONS(2076),
    [anon_sym_i16] = ACTIONS(2076),
    [anon_sym_u32] = ACTIONS(2076),
    [anon_sym_i32] = ACTIONS(2076),
    [anon_sym_u64] = ACTIONS(2076),
    [anon_sym_i64] = ACTIONS(2076),
    [anon_sym_u128] = ACTIONS(2076),
    [anon_sym_i128] = ACTIONS(2076),
    [anon_sym_isize] = ACTIONS(2076),
    [anon_sym_usize] = ACTIONS(2076),
    [anon_sym_f32] = ACTIONS(2076),
    [anon_sym_f64] = ACTIONS(2076),
    [anon_sym_bool] = ACTIONS(2076),
    [anon_sym_str] = ACTIONS(2076),
    [anon_sym_char] = ACTIONS(2076),
    [anon_sym__] = ACTIONS(3311),
    [anon_sym_AMP] = ACTIONS(2080),
    [anon_sym_COLON_COLON] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(2086),
    [sym_mutable_specifier] = ACTIONS(2088),
    [anon_sym_ref] = ACTIONS(2090),
    [sym_integer_literal] = ACTIONS(3309),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(769),
    [sym_char_literal] = ACTIONS(3309),
    [anon_sym_true] = ACTIONS(2092),
    [anon_sym_false] = ACTIONS(2092),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2094),
    [sym_self] = ACTIONS(2096),
    [sym_super] = ACTIONS(2096),
    [sym_crate] = ACTIONS(2096),
    [sym_metavariable] = ACTIONS(2098),
  },
  [1038] = {
    [sym_bracketed_type] = STATE(1041),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(1042),
    [sym_scoped_identifier] = STATE(1043),
    [sym_scoped_type_identifier] = STATE(1044),
    [sym__pattern] = STATE(1710),
    [sym_tuple_pattern] = STATE(1710),
    [sym_tuple_struct_pattern] = STATE(1710),
    [sym_struct_pattern] = STATE(1710),
    [sym_remaining_field_pattern] = STATE(1710),
    [sym_mut_pattern] = STATE(1710),
    [sym_ref_pattern] = STATE(1710),
    [sym_captured_pattern] = STATE(1710),
    [sym_reference_pattern] = STATE(1710),
    [sym__literal] = STATE(1710),
    [sym_string_literal] = STATE(1710),
    [sym_boolean_literal] = STATE(1710),
    [sym_raw_string_literal] = ACTIONS(3313),
    [sym_float_literal] = ACTIONS(3313),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2072),
    [anon_sym_u8] = ACTIONS(2076),
    [anon_sym_i8] = ACTIONS(2076),
    [anon_sym_u16] = ACTIONS(2076),
    [anon_sym_i16] = ACTIONS(2076),
    [anon_sym_u32] = ACTIONS(2076),
    [anon_sym_i32] = ACTIONS(2076),
    [anon_sym_u64] = ACTIONS(2076),
    [anon_sym_i64] = ACTIONS(2076),
    [anon_sym_u128] = ACTIONS(2076),
    [anon_sym_i128] = ACTIONS(2076),
    [anon_sym_isize] = ACTIONS(2076),
    [anon_sym_usize] = ACTIONS(2076),
    [anon_sym_f32] = ACTIONS(2076),
    [anon_sym_f64] = ACTIONS(2076),
    [anon_sym_bool] = ACTIONS(2076),
    [anon_sym_str] = ACTIONS(2076),
    [anon_sym_char] = ACTIONS(2076),
    [anon_sym__] = ACTIONS(3315),
    [anon_sym_AMP] = ACTIONS(2080),
    [anon_sym_COLON_COLON] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(2086),
    [sym_mutable_specifier] = ACTIONS(2088),
    [anon_sym_ref] = ACTIONS(2090),
    [sym_integer_literal] = ACTIONS(3313),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(769),
    [sym_char_literal] = ACTIONS(3313),
    [anon_sym_true] = ACTIONS(2092),
    [anon_sym_false] = ACTIONS(2092),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2094),
    [sym_self] = ACTIONS(2096),
    [sym_super] = ACTIONS(2096),
    [sym_crate] = ACTIONS(2096),
    [sym_metavariable] = ACTIONS(2098),
  },
  [1039] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(403),
    [anon_sym_PIPE] = ACTIONS(403),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(403),
    [anon_sym_if] = ACTIONS(403),
    [sym_line_comment] = ACTIONS(7),
  },
  [1040] = {
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(3317),
    [anon_sym_LBRACE] = ACTIONS(3319),
    [anon_sym_EQ_GT] = ACTIONS(831),
    [anon_sym_COLON_COLON] = ACTIONS(3321),
    [anon_sym_AT] = ACTIONS(3323),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_PIPE] = ACTIONS(831),
    [anon_sym_if] = ACTIONS(831),
    [sym_line_comment] = ACTIONS(7),
  },
  [1041] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON_COLON] = ACTIONS(3325),
    [sym_line_comment] = ACTIONS(7),
  },
  [1042] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON_COLON] = ACTIONS(3327),
    [sym_line_comment] = ACTIONS(7),
  },
  [1043] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(3317),
    [anon_sym_EQ_GT] = ACTIONS(831),
    [anon_sym_COLON_COLON] = ACTIONS(3329),
    [anon_sym_PIPE] = ACTIONS(831),
    [anon_sym_if] = ACTIONS(831),
    [sym_line_comment] = ACTIONS(7),
  },
  [1044] = {
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(3331),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1045] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(3333),
    [sym_line_comment] = ACTIONS(7),
  },
  [1046] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(3335),
    [sym_line_comment] = ACTIONS(7),
  },
  [1047] = {
    [aux_sym_match_pattern_repeat1] = STATE(1723),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(3337),
    [anon_sym_PIPE] = ACTIONS(3339),
    [anon_sym_if] = ACTIONS(3341),
    [sym_line_comment] = ACTIONS(7),
  },
  [1048] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(831),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3343),
    [anon_sym_if] = ACTIONS(831),
    [sym_line_comment] = ACTIONS(7),
  },
  [1049] = {
    [sym_attribute_item] = STATE(1726),
    [sym_bracketed_type] = STATE(1041),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(1042),
    [sym_scoped_identifier] = STATE(1043),
    [sym_scoped_type_identifier] = STATE(1044),
    [sym_match_pattern] = STATE(1725),
    [sym__pattern] = STATE(1047),
    [sym_tuple_pattern] = STATE(1047),
    [sym_tuple_struct_pattern] = STATE(1047),
    [sym_struct_pattern] = STATE(1047),
    [sym_remaining_field_pattern] = STATE(1047),
    [sym_mut_pattern] = STATE(1047),
    [sym_range_pattern] = STATE(1047),
    [sym_ref_pattern] = STATE(1047),
    [sym_captured_pattern] = STATE(1047),
    [sym_reference_pattern] = STATE(1047),
    [sym__literal] = STATE(1048),
    [sym_string_literal] = STATE(1048),
    [sym_boolean_literal] = STATE(1048),
    [aux_sym_enum_variant_list_repeat1] = STATE(1726),
    [sym_raw_string_literal] = ACTIONS(2070),
    [sym_float_literal] = ACTIONS(2070),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2072),
    [anon_sym_u8] = ACTIONS(2076),
    [anon_sym_i8] = ACTIONS(2076),
    [anon_sym_u16] = ACTIONS(2076),
    [anon_sym_i16] = ACTIONS(2076),
    [anon_sym_u32] = ACTIONS(2076),
    [anon_sym_i32] = ACTIONS(2076),
    [anon_sym_u64] = ACTIONS(2076),
    [anon_sym_i64] = ACTIONS(2076),
    [anon_sym_u128] = ACTIONS(2076),
    [anon_sym_i128] = ACTIONS(2076),
    [anon_sym_isize] = ACTIONS(2076),
    [anon_sym_usize] = ACTIONS(2076),
    [anon_sym_f32] = ACTIONS(2076),
    [anon_sym_f64] = ACTIONS(2076),
    [anon_sym_bool] = ACTIONS(2076),
    [anon_sym_str] = ACTIONS(2076),
    [anon_sym_char] = ACTIONS(2076),
    [anon_sym__] = ACTIONS(2078),
    [anon_sym_AMP] = ACTIONS(2080),
    [anon_sym_COLON_COLON] = ACTIONS(2082),
    [anon_sym_POUND] = ACTIONS(2084),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(2086),
    [sym_mutable_specifier] = ACTIONS(2088),
    [anon_sym_ref] = ACTIONS(2090),
    [sym_integer_literal] = ACTIONS(2070),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(769),
    [sym_char_literal] = ACTIONS(2070),
    [anon_sym_true] = ACTIONS(2092),
    [anon_sym_false] = ACTIONS(2092),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2094),
    [sym_self] = ACTIONS(2096),
    [sym_super] = ACTIONS(2096),
    [sym_crate] = ACTIONS(2096),
    [sym_metavariable] = ACTIONS(2098),
  },
  [1050] = {
    [sym_attribute_item] = STATE(1049),
    [sym_bracketed_type] = STATE(1041),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(1042),
    [sym_scoped_identifier] = STATE(1043),
    [sym_scoped_type_identifier] = STATE(1044),
    [sym_match_arm] = STATE(1728),
    [sym_last_match_arm] = STATE(1727),
    [sym_match_pattern] = STATE(1046),
    [sym__pattern] = STATE(1047),
    [sym_tuple_pattern] = STATE(1047),
    [sym_tuple_struct_pattern] = STATE(1047),
    [sym_struct_pattern] = STATE(1047),
    [sym_remaining_field_pattern] = STATE(1047),
    [sym_mut_pattern] = STATE(1047),
    [sym_range_pattern] = STATE(1047),
    [sym_ref_pattern] = STATE(1047),
    [sym_captured_pattern] = STATE(1047),
    [sym_reference_pattern] = STATE(1047),
    [sym__literal] = STATE(1048),
    [sym_string_literal] = STATE(1048),
    [sym_boolean_literal] = STATE(1048),
    [aux_sym_enum_variant_list_repeat1] = STATE(1049),
    [aux_sym_match_expression_repeat1] = STATE(1728),
    [sym_raw_string_literal] = ACTIONS(2070),
    [sym_float_literal] = ACTIONS(2070),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2072),
    [anon_sym_u8] = ACTIONS(2076),
    [anon_sym_i8] = ACTIONS(2076),
    [anon_sym_u16] = ACTIONS(2076),
    [anon_sym_i16] = ACTIONS(2076),
    [anon_sym_u32] = ACTIONS(2076),
    [anon_sym_i32] = ACTIONS(2076),
    [anon_sym_u64] = ACTIONS(2076),
    [anon_sym_i64] = ACTIONS(2076),
    [anon_sym_u128] = ACTIONS(2076),
    [anon_sym_i128] = ACTIONS(2076),
    [anon_sym_isize] = ACTIONS(2076),
    [anon_sym_usize] = ACTIONS(2076),
    [anon_sym_f32] = ACTIONS(2076),
    [anon_sym_f64] = ACTIONS(2076),
    [anon_sym_bool] = ACTIONS(2076),
    [anon_sym_str] = ACTIONS(2076),
    [anon_sym_char] = ACTIONS(2076),
    [anon_sym__] = ACTIONS(2078),
    [anon_sym_AMP] = ACTIONS(2080),
    [anon_sym_COLON_COLON] = ACTIONS(2082),
    [anon_sym_POUND] = ACTIONS(2084),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(2086),
    [sym_mutable_specifier] = ACTIONS(2088),
    [anon_sym_ref] = ACTIONS(2090),
    [sym_integer_literal] = ACTIONS(2070),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(769),
    [sym_char_literal] = ACTIONS(2070),
    [anon_sym_true] = ACTIONS(2092),
    [anon_sym_false] = ACTIONS(2092),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2094),
    [sym_self] = ACTIONS(2096),
    [sym_super] = ACTIONS(2096),
    [sym_crate] = ACTIONS(2096),
    [sym_metavariable] = ACTIONS(2098),
  },
  [1051] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(3345),
    [anon_sym_COLON_COLON] = ACTIONS(2188),
    [sym_line_comment] = ACTIONS(7),
  },
  [1052] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(3347),
    [anon_sym_COLON_COLON] = ACTIONS(2192),
    [sym_line_comment] = ACTIONS(7),
  },
  [1053] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(3347),
    [anon_sym_COLON_COLON] = ACTIONS(449),
    [sym_line_comment] = ACTIONS(7),
  },
  [1054] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(3347),
    [anon_sym_COLON_COLON] = ACTIONS(2194),
    [sym_line_comment] = ACTIONS(7),
  },
  [1055] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(3349),
    [anon_sym_default] = ACTIONS(3349),
    [anon_sym_enum] = ACTIONS(3349),
    [anon_sym_fn] = ACTIONS(3349),
    [anon_sym_mod] = ACTIONS(3349),
    [anon_sym_static] = ACTIONS(3349),
    [anon_sym_struct] = ACTIONS(3349),
    [anon_sym_trait] = ACTIONS(3349),
    [anon_sym_type] = ACTIONS(3349),
    [anon_sym_union] = ACTIONS(3349),
    [anon_sym_unsafe] = ACTIONS(3349),
    [anon_sym_use] = ACTIONS(3349),
    [anon_sym_extern] = ACTIONS(3349),
    [sym_line_comment] = ACTIONS(7),
  },
  [1056] = {
    [sym_function_modifiers] = STATE(1025),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1731),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1027),
    [sym_array_type] = STATE(1731),
    [sym_function_type] = STATE(1731),
    [sym_tuple_type] = STATE(1731),
    [sym_unit_type] = STATE(1731),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1731),
    [sym_reference_type] = STATE(1731),
    [sym_pointer_type] = STATE(1731),
    [sym_empty_type] = STATE(1731),
    [sym_dynamic_type] = STATE(1731),
    [sym_macro_invocation] = STATE(1731),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1028),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2060),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2062),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2064),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2066),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1057] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3279),
    [anon_sym_EQ] = ACTIONS(3353),
    [sym_line_comment] = ACTIONS(7),
  },
  [1058] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3355),
    [anon_sym_RBRACE] = ACTIONS(3355),
    [anon_sym_COMMA] = ACTIONS(3355),
    [anon_sym_EQ] = ACTIONS(3355),
    [anon_sym_where] = ACTIONS(3355),
    [sym_line_comment] = ACTIONS(7),
  },
  [1059] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(3357),
    [sym_line_comment] = ACTIONS(7),
  },
  [1060] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACK] = ACTIONS(3359),
    [sym_line_comment] = ACTIONS(7),
  },
  [1061] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(355),
    [anon_sym_STAR] = ACTIONS(355),
    [anon_sym_u8] = ACTIONS(3363),
    [anon_sym_i8] = ACTIONS(3363),
    [anon_sym_u16] = ACTIONS(3363),
    [anon_sym_i16] = ACTIONS(3363),
    [anon_sym_u32] = ACTIONS(3363),
    [anon_sym_i32] = ACTIONS(3363),
    [anon_sym_u64] = ACTIONS(3363),
    [anon_sym_i64] = ACTIONS(3363),
    [anon_sym_u128] = ACTIONS(3363),
    [anon_sym_i128] = ACTIONS(3363),
    [anon_sym_isize] = ACTIONS(3363),
    [anon_sym_usize] = ACTIONS(3363),
    [anon_sym_f32] = ACTIONS(3363),
    [anon_sym_f64] = ACTIONS(3363),
    [anon_sym_bool] = ACTIONS(3363),
    [anon_sym_str] = ACTIONS(3363),
    [anon_sym_char] = ACTIONS(3363),
    [anon_sym_AMP] = ACTIONS(355),
    [anon_sym_COLON_COLON] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_SQUOTE] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(3363),
    [anon_sym_default] = ACTIONS(3363),
    [anon_sym_fn] = ACTIONS(3363),
    [anon_sym_unsafe] = ACTIONS(3363),
    [anon_sym_extern] = ACTIONS(3363),
    [anon_sym_dyn] = ACTIONS(3363),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3363),
    [sym_self] = ACTIONS(3363),
    [sym_super] = ACTIONS(3363),
    [sym_crate] = ACTIONS(3363),
    [sym_metavariable] = ACTIONS(355),
  },
  [1062] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1737),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(1737),
    [sym_function_type] = STATE(1737),
    [sym_tuple_type] = STATE(1737),
    [sym_unit_type] = STATE(1737),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1737),
    [sym_reference_type] = STATE(1737),
    [sym_pointer_type] = STATE(1737),
    [sym_empty_type] = STATE(1737),
    [sym_dynamic_type] = STATE(1737),
    [sym_macro_invocation] = STATE(1737),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1063] = {
    [aux_sym_ordered_field_declaration_list_repeat1] = STATE(1739),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(3357),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_COMMA] = ACTIONS(3365),
    [sym_line_comment] = ACTIONS(7),
  },
  [1064] = {
    [sym_attribute_item] = STATE(1741),
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym_visibility_modifier] = STATE(1740),
    [sym__type] = STATE(1737),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(1737),
    [sym_function_type] = STATE(1737),
    [sym_tuple_type] = STATE(1737),
    [sym_unit_type] = STATE(1737),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1737),
    [sym_reference_type] = STATE(1737),
    [sym_pointer_type] = STATE(1737),
    [sym_empty_type] = STATE(1737),
    [sym_dynamic_type] = STATE(1737),
    [sym_macro_invocation] = STATE(1737),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_enum_variant_list_repeat1] = STATE(1741),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_POUND] = ACTIONS(2124),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_pub] = ACTIONS(2126),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1065] = {
    [sym_raw_string_literal] = ACTIONS(3367),
    [sym_float_literal] = ACTIONS(3367),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(3367),
    [anon_sym_SEMI] = ACTIONS(3367),
    [anon_sym_macro_rules_BANG] = ACTIONS(3367),
    [anon_sym_LPAREN] = ACTIONS(3367),
    [anon_sym_LBRACE] = ACTIONS(3367),
    [anon_sym_RBRACE] = ACTIONS(3367),
    [anon_sym_LBRACK] = ACTIONS(3367),
    [anon_sym_STAR] = ACTIONS(3367),
    [anon_sym_u8] = ACTIONS(3369),
    [anon_sym_i8] = ACTIONS(3369),
    [anon_sym_u16] = ACTIONS(3369),
    [anon_sym_i16] = ACTIONS(3369),
    [anon_sym_u32] = ACTIONS(3369),
    [anon_sym_i32] = ACTIONS(3369),
    [anon_sym_u64] = ACTIONS(3369),
    [anon_sym_i64] = ACTIONS(3369),
    [anon_sym_u128] = ACTIONS(3369),
    [anon_sym_i128] = ACTIONS(3369),
    [anon_sym_isize] = ACTIONS(3369),
    [anon_sym_usize] = ACTIONS(3369),
    [anon_sym_f32] = ACTIONS(3369),
    [anon_sym_f64] = ACTIONS(3369),
    [anon_sym_bool] = ACTIONS(3369),
    [anon_sym_str] = ACTIONS(3369),
    [anon_sym_char] = ACTIONS(3369),
    [anon_sym_AMP] = ACTIONS(3367),
    [anon_sym_DASH] = ACTIONS(3367),
    [anon_sym_COLON_COLON] = ACTIONS(3367),
    [anon_sym_BANG] = ACTIONS(3367),
    [anon_sym_POUND] = ACTIONS(3367),
    [anon_sym_LT] = ACTIONS(3367),
    [anon_sym_PIPE] = ACTIONS(3367),
    [anon_sym_SQUOTE] = ACTIONS(3369),
    [anon_sym_DOT_DOT] = ACTIONS(3367),
    [anon_sym_break] = ACTIONS(3369),
    [anon_sym_const] = ACTIONS(3369),
    [anon_sym_continue] = ACTIONS(3369),
    [anon_sym_default] = ACTIONS(3369),
    [anon_sym_enum] = ACTIONS(3369),
    [anon_sym_fn] = ACTIONS(3369),
    [anon_sym_for] = ACTIONS(3369),
    [anon_sym_if] = ACTIONS(3369),
    [anon_sym_impl] = ACTIONS(3369),
    [anon_sym_let] = ACTIONS(3369),
    [anon_sym_loop] = ACTIONS(3369),
    [anon_sym_match] = ACTIONS(3369),
    [anon_sym_mod] = ACTIONS(3369),
    [anon_sym_pub] = ACTIONS(3369),
    [anon_sym_return] = ACTIONS(3369),
    [anon_sym_static] = ACTIONS(3369),
    [anon_sym_struct] = ACTIONS(3369),
    [anon_sym_trait] = ACTIONS(3369),
    [anon_sym_type] = ACTIONS(3369),
    [anon_sym_union] = ACTIONS(3369),
    [anon_sym_unsafe] = ACTIONS(3369),
    [anon_sym_use] = ACTIONS(3369),
    [anon_sym_while] = ACTIONS(3369),
    [anon_sym_extern] = ACTIONS(3369),
    [anon_sym_move] = ACTIONS(3369),
    [sym_integer_literal] = ACTIONS(3367),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3367),
    [sym_char_literal] = ACTIONS(3367),
    [anon_sym_true] = ACTIONS(3369),
    [anon_sym_false] = ACTIONS(3369),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3369),
    [sym_self] = ACTIONS(3369),
    [sym_super] = ACTIONS(3369),
    [sym_crate] = ACTIONS(3369),
    [sym_metavariable] = ACTIONS(3367),
  },
  [1066] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(3371),
    [sym_line_comment] = ACTIONS(7),
  },
  [1067] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(3373),
    [sym_line_comment] = ACTIONS(7),
  },
  [1068] = {
    [aux_sym_field_declaration_list_repeat1] = STATE(1745),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(3371),
    [anon_sym_COMMA] = ACTIONS(3375),
    [sym_line_comment] = ACTIONS(7),
  },
  [1069] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3377),
  },
  [1070] = {
    [sym_attribute_item] = STATE(1597),
    [sym_field_declaration] = STATE(1747),
    [sym_visibility_modifier] = STATE(1069),
    [aux_sym_enum_variant_list_repeat1] = STATE(1597),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_pub] = ACTIONS(1940),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2132),
  },
  [1071] = {
    [sym_trait_bounds] = STATE(1608),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(3379),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1072] = {
    [aux_sym_where_clause_repeat1] = STATE(1750),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3147),
    [anon_sym_LPAREN] = ACTIONS(3147),
    [anon_sym_LBRACE] = ACTIONS(3147),
    [anon_sym_COMMA] = ACTIONS(3381),
    [sym_line_comment] = ACTIONS(7),
  },
  [1073] = {
    [sym_trait_bounds] = STATE(1611),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(3383),
    [sym_line_comment] = ACTIONS(7),
  },
  [1074] = {
    [sym_trait_bounds] = STATE(1611),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(3379),
    [anon_sym_COLON_COLON] = ACTIONS(799),
    [sym_line_comment] = ACTIONS(7),
  },
  [1075] = {
    [sym_trait_bounds] = STATE(1611),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(3383),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1076] = {
    [sym_raw_string_literal] = ACTIONS(3385),
    [sym_float_literal] = ACTIONS(3385),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(3385),
    [anon_sym_SEMI] = ACTIONS(3385),
    [anon_sym_macro_rules_BANG] = ACTIONS(3385),
    [anon_sym_LPAREN] = ACTIONS(3385),
    [anon_sym_LBRACE] = ACTIONS(3385),
    [anon_sym_RBRACE] = ACTIONS(3385),
    [anon_sym_LBRACK] = ACTIONS(3385),
    [anon_sym_STAR] = ACTIONS(3385),
    [anon_sym_u8] = ACTIONS(3387),
    [anon_sym_i8] = ACTIONS(3387),
    [anon_sym_u16] = ACTIONS(3387),
    [anon_sym_i16] = ACTIONS(3387),
    [anon_sym_u32] = ACTIONS(3387),
    [anon_sym_i32] = ACTIONS(3387),
    [anon_sym_u64] = ACTIONS(3387),
    [anon_sym_i64] = ACTIONS(3387),
    [anon_sym_u128] = ACTIONS(3387),
    [anon_sym_i128] = ACTIONS(3387),
    [anon_sym_isize] = ACTIONS(3387),
    [anon_sym_usize] = ACTIONS(3387),
    [anon_sym_f32] = ACTIONS(3387),
    [anon_sym_f64] = ACTIONS(3387),
    [anon_sym_bool] = ACTIONS(3387),
    [anon_sym_str] = ACTIONS(3387),
    [anon_sym_char] = ACTIONS(3387),
    [anon_sym_AMP] = ACTIONS(3385),
    [anon_sym_DASH] = ACTIONS(3385),
    [anon_sym_COLON_COLON] = ACTIONS(3385),
    [anon_sym_BANG] = ACTIONS(3385),
    [anon_sym_POUND] = ACTIONS(3385),
    [anon_sym_LT] = ACTIONS(3385),
    [anon_sym_PIPE] = ACTIONS(3385),
    [anon_sym_SQUOTE] = ACTIONS(3387),
    [anon_sym_DOT_DOT] = ACTIONS(3385),
    [anon_sym_break] = ACTIONS(3387),
    [anon_sym_const] = ACTIONS(3387),
    [anon_sym_continue] = ACTIONS(3387),
    [anon_sym_default] = ACTIONS(3387),
    [anon_sym_enum] = ACTIONS(3387),
    [anon_sym_fn] = ACTIONS(3387),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_impl] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_loop] = ACTIONS(3387),
    [anon_sym_match] = ACTIONS(3387),
    [anon_sym_mod] = ACTIONS(3387),
    [anon_sym_pub] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_static] = ACTIONS(3387),
    [anon_sym_struct] = ACTIONS(3387),
    [anon_sym_trait] = ACTIONS(3387),
    [anon_sym_type] = ACTIONS(3387),
    [anon_sym_union] = ACTIONS(3387),
    [anon_sym_unsafe] = ACTIONS(3387),
    [anon_sym_use] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_extern] = ACTIONS(3387),
    [anon_sym_move] = ACTIONS(3387),
    [sym_integer_literal] = ACTIONS(3385),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3385),
    [sym_char_literal] = ACTIONS(3385),
    [anon_sym_true] = ACTIONS(3387),
    [anon_sym_false] = ACTIONS(3387),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3387),
    [sym_self] = ACTIONS(3387),
    [sym_super] = ACTIONS(3387),
    [sym_crate] = ACTIONS(3387),
    [sym_metavariable] = ACTIONS(3385),
  },
  [1077] = {
    [sym_where_predicate] = STATE(1752),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1753),
    [sym_generic_type] = STATE(1754),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_reference_type] = STATE(1753),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1755),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(1948),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3389),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [1078] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3391),
    [sym_line_comment] = ACTIONS(7),
  },
  [1079] = {
    [sym_where_clause] = STATE(1757),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3391),
    [anon_sym_where] = ACTIONS(2138),
    [sym_line_comment] = ACTIONS(7),
  },
  [1080] = {
    [sym_field_declaration_list] = STATE(1756),
    [sym_ordered_field_declaration_list] = STATE(1758),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3391),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(1055),
    [sym_line_comment] = ACTIONS(7),
  },
  [1081] = {
    [sym_function_modifiers] = STATE(677),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1759),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(679),
    [sym_array_type] = STATE(1759),
    [sym_function_type] = STATE(1759),
    [sym_tuple_type] = STATE(1759),
    [sym_unit_type] = STATE(1759),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1759),
    [sym_reference_type] = STATE(1759),
    [sym_pointer_type] = STATE(1759),
    [sym_empty_type] = STATE(1759),
    [sym_dynamic_type] = STATE(1759),
    [sym_macro_invocation] = STATE(1759),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(680),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1315),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1317),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1319),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1321),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1082] = {
    [sym_type_parameters] = STATE(1761),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(3393),
    [sym_line_comment] = ACTIONS(7),
  },
  [1083] = {
    [aux_sym_trait_bounds_repeat1] = STATE(1763),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3397),
    [sym_line_comment] = ACTIONS(7),
  },
  [1084] = {
    [aux_sym_trait_bounds_repeat1] = STATE(1763),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3399),
    [sym_line_comment] = ACTIONS(7),
  },
  [1085] = {
    [sym_trait_bounds] = STATE(993),
    [aux_sym_type_parameters_repeat1] = STATE(1766),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2032),
    [anon_sym_COMMA] = ACTIONS(2022),
    [anon_sym_EQ] = ACTIONS(2024),
    [anon_sym_GT] = ACTIONS(3401),
    [sym_line_comment] = ACTIONS(7),
  },
  [1086] = {
    [aux_sym_type_parameters_repeat1] = STATE(1768),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(2022),
    [anon_sym_GT] = ACTIONS(3403),
    [sym_line_comment] = ACTIONS(7),
  },
  [1087] = {
    [aux_sym_type_parameters_repeat1] = STATE(1768),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(2022),
    [anon_sym_EQ] = ACTIONS(2030),
    [anon_sym_GT] = ACTIONS(3403),
    [sym_line_comment] = ACTIONS(7),
  },
  [1088] = {
    [sym_trait_bounds] = STATE(998),
    [aux_sym_type_parameters_repeat1] = STATE(1768),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2032),
    [anon_sym_COMMA] = ACTIONS(2022),
    [anon_sym_GT] = ACTIONS(3403),
    [sym_line_comment] = ACTIONS(7),
  },
  [1089] = {
    [sym_raw_string_literal] = ACTIONS(3405),
    [sym_float_literal] = ACTIONS(3405),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(3405),
    [anon_sym_SEMI] = ACTIONS(3405),
    [anon_sym_macro_rules_BANG] = ACTIONS(3405),
    [anon_sym_LPAREN] = ACTIONS(3405),
    [anon_sym_LBRACE] = ACTIONS(3405),
    [anon_sym_RBRACE] = ACTIONS(3405),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_STAR] = ACTIONS(3405),
    [anon_sym_u8] = ACTIONS(3407),
    [anon_sym_i8] = ACTIONS(3407),
    [anon_sym_u16] = ACTIONS(3407),
    [anon_sym_i16] = ACTIONS(3407),
    [anon_sym_u32] = ACTIONS(3407),
    [anon_sym_i32] = ACTIONS(3407),
    [anon_sym_u64] = ACTIONS(3407),
    [anon_sym_i64] = ACTIONS(3407),
    [anon_sym_u128] = ACTIONS(3407),
    [anon_sym_i128] = ACTIONS(3407),
    [anon_sym_isize] = ACTIONS(3407),
    [anon_sym_usize] = ACTIONS(3407),
    [anon_sym_f32] = ACTIONS(3407),
    [anon_sym_f64] = ACTIONS(3407),
    [anon_sym_bool] = ACTIONS(3407),
    [anon_sym_str] = ACTIONS(3407),
    [anon_sym_char] = ACTIONS(3407),
    [anon_sym_AMP] = ACTIONS(3405),
    [anon_sym_DASH] = ACTIONS(3405),
    [anon_sym_COLON_COLON] = ACTIONS(3405),
    [anon_sym_BANG] = ACTIONS(3405),
    [anon_sym_POUND] = ACTIONS(3405),
    [anon_sym_LT] = ACTIONS(3405),
    [anon_sym_PIPE] = ACTIONS(3405),
    [anon_sym_SQUOTE] = ACTIONS(3407),
    [anon_sym_DOT_DOT] = ACTIONS(3405),
    [anon_sym_break] = ACTIONS(3407),
    [anon_sym_const] = ACTIONS(3407),
    [anon_sym_continue] = ACTIONS(3407),
    [anon_sym_default] = ACTIONS(3407),
    [anon_sym_enum] = ACTIONS(3407),
    [anon_sym_fn] = ACTIONS(3407),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_impl] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_loop] = ACTIONS(3407),
    [anon_sym_match] = ACTIONS(3407),
    [anon_sym_mod] = ACTIONS(3407),
    [anon_sym_pub] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_static] = ACTIONS(3407),
    [anon_sym_struct] = ACTIONS(3407),
    [anon_sym_trait] = ACTIONS(3407),
    [anon_sym_type] = ACTIONS(3407),
    [anon_sym_union] = ACTIONS(3407),
    [anon_sym_unsafe] = ACTIONS(3407),
    [anon_sym_use] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_extern] = ACTIONS(3407),
    [anon_sym_move] = ACTIONS(3407),
    [sym_integer_literal] = ACTIONS(3405),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3405),
    [sym_char_literal] = ACTIONS(3405),
    [anon_sym_true] = ACTIONS(3407),
    [anon_sym_false] = ACTIONS(3407),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3407),
    [sym_self] = ACTIONS(3407),
    [sym_super] = ACTIONS(3407),
    [sym_crate] = ACTIONS(3407),
    [sym_metavariable] = ACTIONS(3405),
  },
  [1090] = {
    [sym_declaration_list] = STATE(1769),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [sym_line_comment] = ACTIONS(7),
  },
  [1091] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(3409),
    [sym_mutable_specifier] = ACTIONS(3409),
    [sym_line_comment] = ACTIONS(7),
  },
  [1092] = {
    [sym_function_modifiers] = STATE(1097),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(385),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1772),
    [sym_array_type] = STATE(385),
    [sym_function_type] = STATE(385),
    [sym_tuple_type] = STATE(385),
    [sym_unit_type] = STATE(385),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(385),
    [sym_reference_type] = STATE(385),
    [sym_pointer_type] = STATE(385),
    [sym_empty_type] = STATE(385),
    [sym_dynamic_type] = STATE(385),
    [sym_macro_invocation] = STATE(385),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2156),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2162),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(3411),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2166),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1093] = {
    [sym_function_modifiers] = STATE(1097),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1759),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1102),
    [sym_array_type] = STATE(1759),
    [sym_function_type] = STATE(1759),
    [sym_tuple_type] = STATE(1759),
    [sym_unit_type] = STATE(1759),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1759),
    [sym_reference_type] = STATE(1759),
    [sym_pointer_type] = STATE(1759),
    [sym_empty_type] = STATE(1759),
    [sym_dynamic_type] = STATE(1759),
    [sym_macro_invocation] = STATE(1759),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2156),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2162),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2166),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1094] = {
    [sym_parameters] = STATE(1773),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [1095] = {
    [sym_type_parameters] = STATE(1774),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(3393),
    [sym_line_comment] = ACTIONS(7),
  },
  [1096] = {
    [sym_parameters] = STATE(1775),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_BANG] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1097] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1778),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_fn] = ACTIONS(3413),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3415),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [1098] = {
    [aux_sym_trait_bounds_repeat1] = STATE(1780),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3417),
    [sym_line_comment] = ACTIONS(7),
  },
  [1099] = {
    [aux_sym_trait_bounds_repeat1] = STATE(1780),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3419),
    [sym_line_comment] = ACTIONS(7),
  },
  [1100] = {
    [sym_parameters] = STATE(1773),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(783),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1101] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3421),
    [anon_sym_PLUS] = ACTIONS(3423),
    [sym_line_comment] = ACTIONS(7),
  },
  [1102] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(3425),
    [sym_line_comment] = ACTIONS(7),
  },
  [1103] = {
    [sym_raw_string_literal] = ACTIONS(3427),
    [sym_float_literal] = ACTIONS(3427),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(3427),
    [anon_sym_SEMI] = ACTIONS(3427),
    [anon_sym_macro_rules_BANG] = ACTIONS(3427),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_RBRACE] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(3427),
    [anon_sym_u8] = ACTIONS(3429),
    [anon_sym_i8] = ACTIONS(3429),
    [anon_sym_u16] = ACTIONS(3429),
    [anon_sym_i16] = ACTIONS(3429),
    [anon_sym_u32] = ACTIONS(3429),
    [anon_sym_i32] = ACTIONS(3429),
    [anon_sym_u64] = ACTIONS(3429),
    [anon_sym_i64] = ACTIONS(3429),
    [anon_sym_u128] = ACTIONS(3429),
    [anon_sym_i128] = ACTIONS(3429),
    [anon_sym_isize] = ACTIONS(3429),
    [anon_sym_usize] = ACTIONS(3429),
    [anon_sym_f32] = ACTIONS(3429),
    [anon_sym_f64] = ACTIONS(3429),
    [anon_sym_bool] = ACTIONS(3429),
    [anon_sym_str] = ACTIONS(3429),
    [anon_sym_char] = ACTIONS(3429),
    [anon_sym_AMP] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_COLON_COLON] = ACTIONS(3427),
    [anon_sym_BANG] = ACTIONS(3427),
    [anon_sym_POUND] = ACTIONS(3427),
    [anon_sym_LT] = ACTIONS(3427),
    [anon_sym_PIPE] = ACTIONS(3427),
    [anon_sym_SQUOTE] = ACTIONS(3429),
    [anon_sym_DOT_DOT] = ACTIONS(3427),
    [anon_sym_break] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_continue] = ACTIONS(3429),
    [anon_sym_default] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_fn] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3429),
    [anon_sym_if] = ACTIONS(3429),
    [anon_sym_impl] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_loop] = ACTIONS(3429),
    [anon_sym_match] = ACTIONS(3429),
    [anon_sym_mod] = ACTIONS(3429),
    [anon_sym_pub] = ACTIONS(3429),
    [anon_sym_return] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_struct] = ACTIONS(3429),
    [anon_sym_trait] = ACTIONS(3429),
    [anon_sym_type] = ACTIONS(3429),
    [anon_sym_union] = ACTIONS(3429),
    [anon_sym_unsafe] = ACTIONS(3429),
    [anon_sym_use] = ACTIONS(3429),
    [anon_sym_while] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(3429),
    [anon_sym_move] = ACTIONS(3429),
    [sym_integer_literal] = ACTIONS(3427),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3427),
    [sym_char_literal] = ACTIONS(3427),
    [anon_sym_true] = ACTIONS(3429),
    [anon_sym_false] = ACTIONS(3429),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3429),
    [sym_self] = ACTIONS(3429),
    [sym_super] = ACTIONS(3429),
    [sym_crate] = ACTIONS(3429),
    [sym_metavariable] = ACTIONS(3427),
  },
  [1104] = {
    [sym_function_modifiers] = STATE(1097),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1785),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1102),
    [sym_array_type] = STATE(1785),
    [sym_function_type] = STATE(1785),
    [sym_tuple_type] = STATE(1785),
    [sym_unit_type] = STATE(1785),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1785),
    [sym_reference_type] = STATE(1785),
    [sym_pointer_type] = STATE(1785),
    [sym_empty_type] = STATE(1785),
    [sym_dynamic_type] = STATE(1785),
    [sym_macro_invocation] = STATE(1785),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2156),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2162),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2166),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1105] = {
    [sym_raw_string_literal] = ACTIONS(3431),
    [sym_float_literal] = ACTIONS(3431),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(3431),
    [anon_sym_SEMI] = ACTIONS(3431),
    [anon_sym_macro_rules_BANG] = ACTIONS(3431),
    [anon_sym_LPAREN] = ACTIONS(3431),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_RBRACE] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3431),
    [anon_sym_u8] = ACTIONS(3433),
    [anon_sym_i8] = ACTIONS(3433),
    [anon_sym_u16] = ACTIONS(3433),
    [anon_sym_i16] = ACTIONS(3433),
    [anon_sym_u32] = ACTIONS(3433),
    [anon_sym_i32] = ACTIONS(3433),
    [anon_sym_u64] = ACTIONS(3433),
    [anon_sym_i64] = ACTIONS(3433),
    [anon_sym_u128] = ACTIONS(3433),
    [anon_sym_i128] = ACTIONS(3433),
    [anon_sym_isize] = ACTIONS(3433),
    [anon_sym_usize] = ACTIONS(3433),
    [anon_sym_f32] = ACTIONS(3433),
    [anon_sym_f64] = ACTIONS(3433),
    [anon_sym_bool] = ACTIONS(3433),
    [anon_sym_str] = ACTIONS(3433),
    [anon_sym_char] = ACTIONS(3433),
    [anon_sym_AMP] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_COLON_COLON] = ACTIONS(3431),
    [anon_sym_BANG] = ACTIONS(3431),
    [anon_sym_POUND] = ACTIONS(3431),
    [anon_sym_LT] = ACTIONS(3431),
    [anon_sym_PIPE] = ACTIONS(3431),
    [anon_sym_SQUOTE] = ACTIONS(3433),
    [anon_sym_DOT_DOT] = ACTIONS(3431),
    [anon_sym_break] = ACTIONS(3433),
    [anon_sym_const] = ACTIONS(3433),
    [anon_sym_continue] = ACTIONS(3433),
    [anon_sym_default] = ACTIONS(3433),
    [anon_sym_enum] = ACTIONS(3433),
    [anon_sym_fn] = ACTIONS(3433),
    [anon_sym_for] = ACTIONS(3433),
    [anon_sym_if] = ACTIONS(3433),
    [anon_sym_impl] = ACTIONS(3433),
    [anon_sym_let] = ACTIONS(3433),
    [anon_sym_loop] = ACTIONS(3433),
    [anon_sym_match] = ACTIONS(3433),
    [anon_sym_mod] = ACTIONS(3433),
    [anon_sym_pub] = ACTIONS(3433),
    [anon_sym_return] = ACTIONS(3433),
    [anon_sym_static] = ACTIONS(3433),
    [anon_sym_struct] = ACTIONS(3433),
    [anon_sym_trait] = ACTIONS(3433),
    [anon_sym_type] = ACTIONS(3433),
    [anon_sym_union] = ACTIONS(3433),
    [anon_sym_unsafe] = ACTIONS(3433),
    [anon_sym_use] = ACTIONS(3433),
    [anon_sym_while] = ACTIONS(3433),
    [anon_sym_extern] = ACTIONS(3433),
    [anon_sym_move] = ACTIONS(3433),
    [sym_integer_literal] = ACTIONS(3431),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3431),
    [sym_char_literal] = ACTIONS(3431),
    [anon_sym_true] = ACTIONS(3433),
    [anon_sym_false] = ACTIONS(3433),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3433),
    [sym_self] = ACTIONS(3433),
    [sym_super] = ACTIONS(3433),
    [sym_crate] = ACTIONS(3433),
    [sym_metavariable] = ACTIONS(3431),
  },
  [1106] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3435),
    [sym_line_comment] = ACTIONS(7),
  },
  [1107] = {
    [sym_field_declaration_list] = STATE(1786),
    [sym_ordered_field_declaration_list] = STATE(1787),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3435),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(1055),
    [sym_line_comment] = ACTIONS(7),
  },
  [1108] = {
    [sym_declaration_list] = STATE(1788),
    [sym_where_clause] = STATE(1789),
    [sym_impl_for_clause] = STATE(1790),
    [sym_type_arguments] = STATE(1791),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [1109] = {
    [sym_declaration_list] = STATE(1684),
    [sym_where_clause] = STATE(1685),
    [sym_impl_for_clause] = STATE(1686),
    [sym_type_arguments] = STATE(1792),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [1110] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3437),
    [anon_sym_RBRACE] = ACTIONS(3437),
    [anon_sym_COMMA] = ACTIONS(3437),
    [sym_line_comment] = ACTIONS(7),
  },
  [1111] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3439),
    [anon_sym_RBRACE] = ACTIONS(3439),
    [anon_sym_COMMA] = ACTIONS(3439),
    [sym_line_comment] = ACTIONS(7),
  },
  [1112] = {
    [sym_use_list] = STATE(1797),
    [sym_use_as_clause] = STATE(1797),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_type_with_turbofish] = STATE(212),
    [sym_scoped_identifier] = STATE(1798),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(377),
    [anon_sym_RBRACE] = ACTIONS(3441),
    [anon_sym_u8] = ACTIONS(3443),
    [anon_sym_i8] = ACTIONS(3443),
    [anon_sym_u16] = ACTIONS(3443),
    [anon_sym_i16] = ACTIONS(3443),
    [anon_sym_u32] = ACTIONS(3443),
    [anon_sym_i32] = ACTIONS(3443),
    [anon_sym_u64] = ACTIONS(3443),
    [anon_sym_i64] = ACTIONS(3443),
    [anon_sym_u128] = ACTIONS(3443),
    [anon_sym_i128] = ACTIONS(3443),
    [anon_sym_isize] = ACTIONS(3443),
    [anon_sym_usize] = ACTIONS(3443),
    [anon_sym_f32] = ACTIONS(3443),
    [anon_sym_f64] = ACTIONS(3443),
    [anon_sym_bool] = ACTIONS(3443),
    [anon_sym_str] = ACTIONS(3443),
    [anon_sym_char] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(31),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3445),
    [sym_self] = ACTIONS(3447),
    [sym_super] = ACTIONS(3447),
    [sym_crate] = ACTIONS(3447),
    [sym_metavariable] = ACTIONS(3449),
  },
  [1113] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1966),
  },
  [1114] = {
    [aux_sym_use_list_repeat1] = STATE(1800),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(3441),
    [anon_sym_COMMA] = ACTIONS(3451),
    [sym_line_comment] = ACTIONS(7),
  },
  [1115] = {
    [sym_use_list] = STATE(1797),
    [sym_use_as_clause] = STATE(1797),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_type_with_turbofish] = STATE(212),
    [sym_scoped_identifier] = STATE(1798),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(377),
    [anon_sym_RBRACE] = ACTIONS(3453),
    [anon_sym_u8] = ACTIONS(3443),
    [anon_sym_i8] = ACTIONS(3443),
    [anon_sym_u16] = ACTIONS(3443),
    [anon_sym_i16] = ACTIONS(3443),
    [anon_sym_u32] = ACTIONS(3443),
    [anon_sym_i32] = ACTIONS(3443),
    [anon_sym_u64] = ACTIONS(3443),
    [anon_sym_i64] = ACTIONS(3443),
    [anon_sym_u128] = ACTIONS(3443),
    [anon_sym_i128] = ACTIONS(3443),
    [anon_sym_isize] = ACTIONS(3443),
    [anon_sym_usize] = ACTIONS(3443),
    [anon_sym_f32] = ACTIONS(3443),
    [anon_sym_f64] = ACTIONS(3443),
    [anon_sym_bool] = ACTIONS(3443),
    [anon_sym_str] = ACTIONS(3443),
    [anon_sym_char] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(31),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3445),
    [sym_self] = ACTIONS(3447),
    [sym_super] = ACTIONS(3447),
    [sym_crate] = ACTIONS(3447),
    [sym_metavariable] = ACTIONS(3449),
  },
  [1116] = {
    [sym_type_arguments] = STATE(845),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1223),
  },
  [1117] = {
    [aux_sym_use_list_repeat1] = STATE(1800),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(3453),
    [anon_sym_COMMA] = ACTIONS(3455),
    [sym_line_comment] = ACTIONS(7),
  },
  [1118] = {
    [sym_type_arguments] = STATE(873),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1223),
  },
  [1119] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3457),
    [sym_line_comment] = ACTIONS(7),
  },
  [1120] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3459),
    [sym_line_comment] = ACTIONS(7),
  },
  [1121] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3461),
    [anon_sym_RBRACE] = ACTIONS(3461),
    [anon_sym_COMMA] = ACTIONS(3461),
    [sym_line_comment] = ACTIONS(7),
  },
  [1122] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3463),
    [sym_line_comment] = ACTIONS(7),
  },
  [1123] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3465),
    [sym_line_comment] = ACTIONS(7),
  },
  [1124] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3467),
    [anon_sym_RBRACE] = ACTIONS(3467),
    [anon_sym_COMMA] = ACTIONS(3467),
    [sym_line_comment] = ACTIONS(7),
  },
  [1125] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1803),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(1803),
    [sym_macro_invocation] = STATE(1803),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1803),
    [sym_unary_expression] = STATE(1803),
    [sym_try_expression] = STATE(1803),
    [sym_reference_expression] = STATE(1803),
    [sym_binary_expression] = STATE(1803),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1803),
    [sym_call_expression] = STATE(1803),
    [sym_array_expression] = STATE(1803),
    [sym_parenthesized_expression] = STATE(1803),
    [sym_tuple_expression] = STATE(1803),
    [sym_unit_expression] = STATE(1803),
    [sym_struct_expression] = STATE(1803),
    [sym_if_expression] = STATE(1803),
    [sym_if_let_expression] = STATE(1803),
    [sym_match_expression] = STATE(1803),
    [sym_while_expression] = STATE(1803),
    [sym_while_let_expression] = STATE(1803),
    [sym_loop_expression] = STATE(1803),
    [sym_for_expression] = STATE(1803),
    [sym_closure_expression] = STATE(1803),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1803),
    [sym_continue_expression] = STATE(1803),
    [sym_index_expression] = STATE(1803),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1803),
    [sym_block] = STATE(1803),
    [sym__literal] = STATE(1803),
    [sym_string_literal] = STATE(1803),
    [sym_boolean_literal] = STATE(1803),
    [sym_raw_string_literal] = ACTIONS(3469),
    [sym_float_literal] = ACTIONS(3469),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(3469),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(3469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [1126] = {
    [sym_raw_string_literal] = ACTIONS(3471),
    [sym_float_literal] = ACTIONS(3471),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(3471),
    [anon_sym_SEMI] = ACTIONS(3471),
    [anon_sym_macro_rules_BANG] = ACTIONS(3471),
    [anon_sym_LPAREN] = ACTIONS(3471),
    [anon_sym_LBRACE] = ACTIONS(3471),
    [anon_sym_RBRACE] = ACTIONS(3471),
    [anon_sym_LBRACK] = ACTIONS(3471),
    [anon_sym_STAR] = ACTIONS(3471),
    [anon_sym_u8] = ACTIONS(3473),
    [anon_sym_i8] = ACTIONS(3473),
    [anon_sym_u16] = ACTIONS(3473),
    [anon_sym_i16] = ACTIONS(3473),
    [anon_sym_u32] = ACTIONS(3473),
    [anon_sym_i32] = ACTIONS(3473),
    [anon_sym_u64] = ACTIONS(3473),
    [anon_sym_i64] = ACTIONS(3473),
    [anon_sym_u128] = ACTIONS(3473),
    [anon_sym_i128] = ACTIONS(3473),
    [anon_sym_isize] = ACTIONS(3473),
    [anon_sym_usize] = ACTIONS(3473),
    [anon_sym_f32] = ACTIONS(3473),
    [anon_sym_f64] = ACTIONS(3473),
    [anon_sym_bool] = ACTIONS(3473),
    [anon_sym_str] = ACTIONS(3473),
    [anon_sym_char] = ACTIONS(3473),
    [anon_sym_AMP] = ACTIONS(3471),
    [anon_sym_DASH] = ACTIONS(3471),
    [anon_sym_COLON_COLON] = ACTIONS(3471),
    [anon_sym_BANG] = ACTIONS(3471),
    [anon_sym_POUND] = ACTIONS(3471),
    [anon_sym_LT] = ACTIONS(3471),
    [anon_sym_PIPE] = ACTIONS(3471),
    [anon_sym_SQUOTE] = ACTIONS(3473),
    [anon_sym_DOT_DOT] = ACTIONS(3471),
    [anon_sym_break] = ACTIONS(3473),
    [anon_sym_const] = ACTIONS(3473),
    [anon_sym_continue] = ACTIONS(3473),
    [anon_sym_default] = ACTIONS(3473),
    [anon_sym_enum] = ACTIONS(3473),
    [anon_sym_fn] = ACTIONS(3473),
    [anon_sym_for] = ACTIONS(3473),
    [anon_sym_if] = ACTIONS(3473),
    [anon_sym_impl] = ACTIONS(3473),
    [anon_sym_let] = ACTIONS(3473),
    [anon_sym_loop] = ACTIONS(3473),
    [anon_sym_match] = ACTIONS(3473),
    [anon_sym_mod] = ACTIONS(3473),
    [anon_sym_pub] = ACTIONS(3473),
    [anon_sym_return] = ACTIONS(3473),
    [anon_sym_static] = ACTIONS(3473),
    [anon_sym_struct] = ACTIONS(3473),
    [anon_sym_trait] = ACTIONS(3473),
    [anon_sym_type] = ACTIONS(3473),
    [anon_sym_union] = ACTIONS(3473),
    [anon_sym_unsafe] = ACTIONS(3473),
    [anon_sym_use] = ACTIONS(3473),
    [anon_sym_while] = ACTIONS(3473),
    [anon_sym_extern] = ACTIONS(3473),
    [anon_sym_move] = ACTIONS(3473),
    [sym_integer_literal] = ACTIONS(3471),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3471),
    [sym_char_literal] = ACTIONS(3471),
    [anon_sym_true] = ACTIONS(3473),
    [anon_sym_false] = ACTIONS(3473),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3473),
    [sym_self] = ACTIONS(3473),
    [sym_super] = ACTIONS(3473),
    [sym_crate] = ACTIONS(3473),
    [sym_metavariable] = ACTIONS(3471),
  },
  [1127] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3475),
  },
  [1128] = {
    [sym_block] = STATE(1805),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(2667),
    [sym_line_comment] = ACTIONS(7),
  },
  [1129] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3477),
    [anon_sym_LPAREN] = ACTIONS(3477),
    [anon_sym_RPAREN] = ACTIONS(3477),
    [anon_sym_LBRACE] = ACTIONS(3477),
    [anon_sym_RBRACE] = ACTIONS(3477),
    [anon_sym_LBRACK] = ACTIONS(3477),
    [anon_sym_RBRACK] = ACTIONS(3477),
    [anon_sym_PLUS] = ACTIONS(3479),
    [anon_sym_STAR] = ACTIONS(3479),
    [anon_sym_COMMA] = ACTIONS(3477),
    [anon_sym_AMP] = ACTIONS(3479),
    [anon_sym_DASH] = ACTIONS(3479),
    [anon_sym_DOT] = ACTIONS(3479),
    [anon_sym_DASH_EQ] = ACTIONS(3477),
    [anon_sym_BANG_EQ] = ACTIONS(3477),
    [anon_sym_STAR_EQ] = ACTIONS(3477),
    [anon_sym_SLASH] = ACTIONS(3479),
    [anon_sym_SLASH_EQ] = ACTIONS(3477),
    [anon_sym_AMP_AMP] = ACTIONS(3477),
    [anon_sym_AMP_EQ] = ACTIONS(3477),
    [anon_sym_PERCENT] = ACTIONS(3479),
    [anon_sym_PERCENT_EQ] = ACTIONS(3477),
    [anon_sym_CARET] = ACTIONS(3479),
    [anon_sym_CARET_EQ] = ACTIONS(3477),
    [anon_sym_PLUS_EQ] = ACTIONS(3477),
    [anon_sym_LT] = ACTIONS(3479),
    [anon_sym_LT_LT] = ACTIONS(3479),
    [anon_sym_LT_LT_EQ] = ACTIONS(3477),
    [anon_sym_LT_EQ] = ACTIONS(3477),
    [anon_sym_EQ] = ACTIONS(3479),
    [anon_sym_EQ_EQ] = ACTIONS(3477),
    [anon_sym_GT] = ACTIONS(3479),
    [anon_sym_GT_EQ] = ACTIONS(3477),
    [anon_sym_GT_GT] = ACTIONS(3479),
    [anon_sym_GT_GT_EQ] = ACTIONS(3477),
    [anon_sym_PIPE] = ACTIONS(3479),
    [anon_sym_PIPE_EQ] = ACTIONS(3477),
    [anon_sym_PIPE_PIPE] = ACTIONS(3477),
    [anon_sym_QMARK] = ACTIONS(3477),
    [anon_sym_DOT_DOT] = ACTIONS(3479),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3477),
    [anon_sym_as] = ACTIONS(3477),
    [sym_line_comment] = ACTIONS(7),
  },
  [1130] = {
    [sym_meta_item] = STATE(1806),
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(727),
  },
  [1131] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(103),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(103),
    [sym_macro_invocation] = STATE(103),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(103),
    [sym_unary_expression] = STATE(103),
    [sym_try_expression] = STATE(103),
    [sym_reference_expression] = STATE(103),
    [sym_binary_expression] = STATE(103),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(103),
    [sym_call_expression] = STATE(103),
    [sym_array_expression] = STATE(103),
    [sym_parenthesized_expression] = STATE(103),
    [sym_tuple_expression] = STATE(103),
    [sym_unit_expression] = STATE(103),
    [sym_struct_expression] = STATE(103),
    [sym_if_expression] = STATE(103),
    [sym_if_let_expression] = STATE(103),
    [sym_match_expression] = STATE(103),
    [sym_while_expression] = STATE(103),
    [sym_while_let_expression] = STATE(103),
    [sym_loop_expression] = STATE(103),
    [sym_for_expression] = STATE(103),
    [sym_closure_expression] = STATE(103),
    [sym_closure_parameters] = STATE(1138),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(103),
    [sym_continue_expression] = STATE(103),
    [sym_index_expression] = STATE(103),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(103),
    [sym_block] = STATE(103),
    [sym__literal] = STATE(103),
    [sym_string_literal] = STATE(103),
    [sym_boolean_literal] = STATE(103),
    [sym_raw_string_literal] = ACTIONS(173),
    [sym_float_literal] = ACTIONS(173),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(2245),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(2247),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(2249),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(2251),
    [sym_integer_literal] = ACTIONS(173),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(173),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1132] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(106),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(106),
    [sym_macro_invocation] = STATE(106),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(106),
    [sym_unary_expression] = STATE(106),
    [sym_try_expression] = STATE(106),
    [sym_reference_expression] = STATE(106),
    [sym_binary_expression] = STATE(106),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(106),
    [sym_call_expression] = STATE(106),
    [sym_array_expression] = STATE(106),
    [sym_parenthesized_expression] = STATE(106),
    [sym_tuple_expression] = STATE(106),
    [sym_unit_expression] = STATE(106),
    [sym_struct_expression] = STATE(106),
    [sym_if_expression] = STATE(106),
    [sym_if_let_expression] = STATE(106),
    [sym_match_expression] = STATE(106),
    [sym_while_expression] = STATE(106),
    [sym_while_let_expression] = STATE(106),
    [sym_loop_expression] = STATE(106),
    [sym_for_expression] = STATE(106),
    [sym_closure_expression] = STATE(106),
    [sym_closure_parameters] = STATE(1138),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(106),
    [sym_continue_expression] = STATE(106),
    [sym_index_expression] = STATE(106),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(106),
    [sym_block] = STATE(106),
    [sym__literal] = STATE(106),
    [sym_string_literal] = STATE(106),
    [sym_boolean_literal] = STATE(106),
    [sym_raw_string_literal] = ACTIONS(183),
    [sym_float_literal] = ACTIONS(183),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(2245),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(2247),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(2249),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [sym_mutable_specifier] = ACTIONS(3481),
    [anon_sym_move] = ACTIONS(2251),
    [sym_integer_literal] = ACTIONS(183),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(183),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1133] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1808),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1808),
    [sym_macro_invocation] = STATE(1808),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1808),
    [sym_unary_expression] = STATE(1808),
    [sym_try_expression] = STATE(1808),
    [sym_reference_expression] = STATE(1808),
    [sym_binary_expression] = STATE(1808),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1808),
    [sym_call_expression] = STATE(1808),
    [sym_array_expression] = STATE(1808),
    [sym_parenthesized_expression] = STATE(1808),
    [sym_tuple_expression] = STATE(1808),
    [sym_unit_expression] = STATE(1808),
    [sym_struct_expression] = STATE(1808),
    [sym_if_expression] = STATE(1808),
    [sym_if_let_expression] = STATE(1808),
    [sym_match_expression] = STATE(1808),
    [sym_while_expression] = STATE(1808),
    [sym_while_let_expression] = STATE(1808),
    [sym_loop_expression] = STATE(1808),
    [sym_for_expression] = STATE(1808),
    [sym_closure_expression] = STATE(1808),
    [sym_closure_parameters] = STATE(1138),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1808),
    [sym_continue_expression] = STATE(1808),
    [sym_index_expression] = STATE(1808),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1808),
    [sym_block] = STATE(1808),
    [sym__literal] = STATE(1808),
    [sym_string_literal] = STATE(1808),
    [sym_boolean_literal] = STATE(1808),
    [sym_raw_string_literal] = ACTIONS(3483),
    [sym_float_literal] = ACTIONS(3483),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(261),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_PLUS] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(263),
    [anon_sym_COMMA] = ACTIONS(261),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(263),
    [anon_sym_DASH] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(263),
    [anon_sym_DASH_EQ] = ACTIONS(261),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(3485),
    [anon_sym_BANG_EQ] = ACTIONS(261),
    [anon_sym_STAR_EQ] = ACTIONS(261),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_SLASH_EQ] = ACTIONS(261),
    [anon_sym_AMP_AMP] = ACTIONS(261),
    [anon_sym_AMP_EQ] = ACTIONS(261),
    [anon_sym_PERCENT] = ACTIONS(263),
    [anon_sym_PERCENT_EQ] = ACTIONS(261),
    [anon_sym_CARET] = ACTIONS(263),
    [anon_sym_CARET_EQ] = ACTIONS(261),
    [anon_sym_PLUS_EQ] = ACTIONS(261),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_EQ] = ACTIONS(261),
    [anon_sym_LT_EQ] = ACTIONS(261),
    [anon_sym_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(261),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_EQ] = ACTIONS(261),
    [anon_sym_GT_GT] = ACTIONS(263),
    [anon_sym_GT_GT_EQ] = ACTIONS(261),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_PIPE_EQ] = ACTIONS(261),
    [anon_sym_PIPE_PIPE] = ACTIONS(261),
    [anon_sym_QMARK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(263),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(261),
    [anon_sym_as] = ACTIONS(263),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(2247),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(2249),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(2251),
    [sym_integer_literal] = ACTIONS(3483),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(3483),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1134] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1810),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(1810),
    [sym_macro_invocation] = STATE(1810),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1810),
    [sym_unary_expression] = STATE(1810),
    [sym_try_expression] = STATE(1810),
    [sym_reference_expression] = STATE(1810),
    [sym_binary_expression] = STATE(1810),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1810),
    [sym_call_expression] = STATE(1810),
    [sym_array_expression] = STATE(1810),
    [sym_parenthesized_expression] = STATE(1810),
    [sym_tuple_expression] = STATE(1810),
    [sym_unit_expression] = STATE(1810),
    [sym_struct_expression] = STATE(1810),
    [sym_if_expression] = STATE(1810),
    [sym_if_let_expression] = STATE(1810),
    [sym_match_expression] = STATE(1810),
    [sym_while_expression] = STATE(1810),
    [sym_while_let_expression] = STATE(1810),
    [sym_loop_expression] = STATE(1810),
    [sym_for_expression] = STATE(1810),
    [sym_closure_expression] = STATE(1810),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1810),
    [sym_continue_expression] = STATE(1810),
    [sym_index_expression] = STATE(1810),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1810),
    [sym_block] = STATE(1810),
    [sym__literal] = STATE(1810),
    [sym_string_literal] = STATE(1810),
    [sym_boolean_literal] = STATE(1810),
    [sym_raw_string_literal] = ACTIONS(3487),
    [sym_float_literal] = ACTIONS(3487),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_let] = ACTIONS(3489),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(3487),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(3487),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [1135] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1811),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1811),
    [sym_macro_invocation] = STATE(1811),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1811),
    [sym_unary_expression] = STATE(1811),
    [sym_try_expression] = STATE(1811),
    [sym_reference_expression] = STATE(1811),
    [sym_binary_expression] = STATE(1811),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1811),
    [sym_call_expression] = STATE(1811),
    [sym_array_expression] = STATE(1811),
    [sym_parenthesized_expression] = STATE(1811),
    [sym_tuple_expression] = STATE(1811),
    [sym_unit_expression] = STATE(1811),
    [sym_struct_expression] = STATE(1811),
    [sym_if_expression] = STATE(1811),
    [sym_if_let_expression] = STATE(1811),
    [sym_match_expression] = STATE(1811),
    [sym_while_expression] = STATE(1811),
    [sym_while_let_expression] = STATE(1811),
    [sym_loop_expression] = STATE(1811),
    [sym_for_expression] = STATE(1811),
    [sym_closure_expression] = STATE(1811),
    [sym_closure_parameters] = STATE(1138),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1811),
    [sym_continue_expression] = STATE(1811),
    [sym_index_expression] = STATE(1811),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1811),
    [sym_block] = STATE(1811),
    [sym__literal] = STATE(1811),
    [sym_string_literal] = STATE(1811),
    [sym_boolean_literal] = STATE(1811),
    [sym_raw_string_literal] = ACTIONS(3491),
    [sym_float_literal] = ACTIONS(3491),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(359),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(359),
    [anon_sym_LBRACK] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(361),
    [anon_sym_STAR] = ACTIONS(361),
    [anon_sym_COMMA] = ACTIONS(359),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(361),
    [anon_sym_DASH_EQ] = ACTIONS(359),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(3485),
    [anon_sym_BANG_EQ] = ACTIONS(359),
    [anon_sym_STAR_EQ] = ACTIONS(359),
    [anon_sym_SLASH] = ACTIONS(361),
    [anon_sym_SLASH_EQ] = ACTIONS(359),
    [anon_sym_AMP_AMP] = ACTIONS(359),
    [anon_sym_AMP_EQ] = ACTIONS(359),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_PERCENT_EQ] = ACTIONS(359),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_CARET_EQ] = ACTIONS(359),
    [anon_sym_PLUS_EQ] = ACTIONS(359),
    [anon_sym_LT] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_LT_LT_EQ] = ACTIONS(359),
    [anon_sym_LT_EQ] = ACTIONS(359),
    [anon_sym_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(359),
    [anon_sym_GT] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(359),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_GT_GT_EQ] = ACTIONS(359),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_PIPE_EQ] = ACTIONS(359),
    [anon_sym_PIPE_PIPE] = ACTIONS(359),
    [anon_sym_QMARK] = ACTIONS(359),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(361),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(359),
    [anon_sym_as] = ACTIONS(361),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(2247),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(2249),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(2251),
    [sym_integer_literal] = ACTIONS(3491),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(3491),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1136] = {
    [sym_closure_parameters] = STATE(1812),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(7),
  },
  [1137] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(3493),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(3495),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(3493),
    [anon_sym_AMP] = ACTIONS(3499),
    [anon_sym_DASH] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(3501),
    [anon_sym_BANG_EQ] = ACTIONS(3503),
    [anon_sym_STAR_EQ] = ACTIONS(3501),
    [anon_sym_SLASH] = ACTIONS(3497),
    [anon_sym_SLASH_EQ] = ACTIONS(3501),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_AMP_EQ] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_PERCENT_EQ] = ACTIONS(3501),
    [anon_sym_CARET] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3501),
    [anon_sym_PLUS_EQ] = ACTIONS(3501),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_LT_LT] = ACTIONS(3511),
    [anon_sym_LT_LT_EQ] = ACTIONS(3501),
    [anon_sym_LT_EQ] = ACTIONS(3503),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_EQ_EQ] = ACTIONS(3503),
    [anon_sym_GT] = ACTIONS(3509),
    [anon_sym_GT_EQ] = ACTIONS(3503),
    [anon_sym_GT_GT] = ACTIONS(3511),
    [anon_sym_GT_GT_EQ] = ACTIONS(3501),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_PIPE_EQ] = ACTIONS(3501),
    [anon_sym_PIPE_PIPE] = ACTIONS(3517),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(3519),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3521),
    [anon_sym_as] = ACTIONS(3523),
    [sym_line_comment] = ACTIONS(7),
  },
  [1138] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1827),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1827),
    [sym_macro_invocation] = STATE(1827),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1827),
    [sym_unary_expression] = STATE(1827),
    [sym_try_expression] = STATE(1827),
    [sym_reference_expression] = STATE(1827),
    [sym_binary_expression] = STATE(1827),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1827),
    [sym_call_expression] = STATE(1827),
    [sym_array_expression] = STATE(1827),
    [sym_parenthesized_expression] = STATE(1827),
    [sym_tuple_expression] = STATE(1827),
    [sym_unit_expression] = STATE(1827),
    [sym_struct_expression] = STATE(1827),
    [sym_if_expression] = STATE(1827),
    [sym_if_let_expression] = STATE(1827),
    [sym_match_expression] = STATE(1827),
    [sym_while_expression] = STATE(1827),
    [sym_while_let_expression] = STATE(1827),
    [sym_loop_expression] = STATE(1827),
    [sym_for_expression] = STATE(1827),
    [sym_closure_expression] = STATE(1827),
    [sym_closure_parameters] = STATE(1138),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1827),
    [sym_continue_expression] = STATE(1827),
    [sym_index_expression] = STATE(1827),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1827),
    [sym_block] = STATE(1827),
    [sym__literal] = STATE(1827),
    [sym_string_literal] = STATE(1827),
    [sym_boolean_literal] = STATE(1827),
    [sym_raw_string_literal] = ACTIONS(3525),
    [sym_float_literal] = ACTIONS(3525),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_DASH] = ACTIONS(3485),
    [anon_sym_DASH_GT] = ACTIONS(509),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(2245),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(2247),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(2249),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(2251),
    [sym_integer_literal] = ACTIONS(3525),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(3525),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1139] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3527),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_RPAREN] = ACTIONS(3527),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_RBRACE] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_RBRACK] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3529),
    [anon_sym_STAR] = ACTIONS(3529),
    [anon_sym_COMMA] = ACTIONS(3527),
    [anon_sym_AMP] = ACTIONS(3529),
    [anon_sym_DASH] = ACTIONS(3529),
    [anon_sym_DOT] = ACTIONS(3529),
    [anon_sym_DASH_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_STAR_EQ] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3529),
    [anon_sym_SLASH_EQ] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_AMP_EQ] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3529),
    [anon_sym_PERCENT_EQ] = ACTIONS(3527),
    [anon_sym_CARET] = ACTIONS(3529),
    [anon_sym_CARET_EQ] = ACTIONS(3527),
    [anon_sym_PLUS_EQ] = ACTIONS(3527),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_LT_LT] = ACTIONS(3529),
    [anon_sym_LT_LT_EQ] = ACTIONS(3527),
    [anon_sym_LT_EQ] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3529),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3529),
    [anon_sym_GT_EQ] = ACTIONS(3527),
    [anon_sym_GT_GT] = ACTIONS(3529),
    [anon_sym_GT_GT_EQ] = ACTIONS(3527),
    [anon_sym_PIPE] = ACTIONS(3529),
    [anon_sym_PIPE_EQ] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_DOT_DOT] = ACTIONS(3529),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3527),
    [anon_sym_as] = ACTIONS(3527),
    [sym_line_comment] = ACTIONS(7),
  },
  [1140] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1828),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1828),
    [sym_macro_invocation] = STATE(1828),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1828),
    [sym_unary_expression] = STATE(1828),
    [sym_try_expression] = STATE(1828),
    [sym_reference_expression] = STATE(1828),
    [sym_binary_expression] = STATE(1828),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1828),
    [sym_call_expression] = STATE(1828),
    [sym_array_expression] = STATE(1828),
    [sym_parenthesized_expression] = STATE(1828),
    [sym_tuple_expression] = STATE(1828),
    [sym_unit_expression] = STATE(1828),
    [sym_struct_expression] = STATE(1828),
    [sym_if_expression] = STATE(1828),
    [sym_if_let_expression] = STATE(1828),
    [sym_match_expression] = STATE(1828),
    [sym_while_expression] = STATE(1828),
    [sym_while_let_expression] = STATE(1828),
    [sym_loop_expression] = STATE(1828),
    [sym_for_expression] = STATE(1828),
    [sym_closure_expression] = STATE(1828),
    [sym_closure_parameters] = STATE(1138),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1828),
    [sym_continue_expression] = STATE(1828),
    [sym_index_expression] = STATE(1828),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1828),
    [sym_block] = STATE(1828),
    [sym__literal] = STATE(1828),
    [sym_string_literal] = STATE(1828),
    [sym_boolean_literal] = STATE(1828),
    [sym_raw_string_literal] = ACTIONS(3531),
    [sym_float_literal] = ACTIONS(3531),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(2245),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(2247),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(2249),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(2251),
    [sym_integer_literal] = ACTIONS(3531),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(3531),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1141] = {
    [sym_attribute_item] = STATE(582),
    [sym_field_initializer] = STATE(1831),
    [sym_base_field_initializer] = STATE(1831),
    [aux_sym_enum_variant_list_repeat1] = STATE(582),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(3533),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_DOT_DOT] = ACTIONS(1135),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3535),
  },
  [1142] = {
    [aux_sym_field_initializer_list_repeat1] = STATE(1833),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(3533),
    [anon_sym_COMMA] = ACTIONS(3537),
    [sym_line_comment] = ACTIONS(7),
  },
  [1143] = {
    [sym_attribute_item] = STATE(582),
    [sym_field_initializer] = STATE(1831),
    [sym_base_field_initializer] = STATE(1831),
    [aux_sym_enum_variant_list_repeat1] = STATE(582),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(3539),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_DOT_DOT] = ACTIONS(1135),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3535),
  },
  [1144] = {
    [aux_sym_field_initializer_list_repeat1] = STATE(1833),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(3539),
    [anon_sym_COMMA] = ACTIONS(3541),
    [sym_line_comment] = ACTIONS(7),
  },
  [1145] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(3543),
    [sym_line_comment] = ACTIONS(7),
  },
  [1146] = {
    [sym_attribute_item] = STATE(1146),
    [aux_sym_enum_variant_list_repeat1] = STATE(1146),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(3545),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3548),
  },
  [1147] = {
    [aux_sym_type_arguments_repeat1] = STATE(1839),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_COMMA] = ACTIONS(3550),
    [anon_sym_GT] = ACTIONS(3552),
    [sym_line_comment] = ACTIONS(7),
  },
  [1148] = {
    [aux_sym_type_arguments_repeat1] = STATE(1839),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(2986),
    [anon_sym_COMMA] = ACTIONS(3550),
    [anon_sym_GT] = ACTIONS(3552),
    [sym_line_comment] = ACTIONS(7),
  },
  [1149] = {
    [aux_sym_type_arguments_repeat1] = STATE(1839),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(3550),
    [anon_sym_GT] = ACTIONS(3552),
    [sym_line_comment] = ACTIONS(7),
  },
  [1150] = {
    [sym_token_tree] = STATE(1842),
    [sym_token_repetition] = STATE(1842),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1841),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1841),
    [sym_macro_invocation] = STATE(1841),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1841),
    [sym_unary_expression] = STATE(1841),
    [sym_try_expression] = STATE(1841),
    [sym_reference_expression] = STATE(1841),
    [sym_binary_expression] = STATE(1841),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1841),
    [sym_call_expression] = STATE(1841),
    [sym_array_expression] = STATE(1841),
    [sym_parenthesized_expression] = STATE(1841),
    [sym_tuple_expression] = STATE(1841),
    [sym_unit_expression] = STATE(1841),
    [sym_struct_expression] = STATE(1841),
    [sym_if_expression] = STATE(1841),
    [sym_if_let_expression] = STATE(1841),
    [sym_match_expression] = STATE(1841),
    [sym_while_expression] = STATE(1841),
    [sym_while_let_expression] = STATE(1841),
    [sym_loop_expression] = STATE(1841),
    [sym_for_expression] = STATE(1841),
    [sym_closure_expression] = STATE(1841),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1841),
    [sym_continue_expression] = STATE(1841),
    [sym_index_expression] = STATE(1841),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1841),
    [sym_block] = STATE(1841),
    [sym__literal] = STATE(1178),
    [sym_string_literal] = STATE(1178),
    [sym_boolean_literal] = STATE(1178),
    [aux_sym_token_tree_repeat1] = STATE(1842),
    [sym_raw_string_literal] = ACTIONS(2275),
    [sym_float_literal] = ACTIONS(2275),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3554),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_RPAREN] = ACTIONS(3556),
    [anon_sym_LBRACE] = ACTIONS(2283),
    [anon_sym_EQ_GT] = ACTIONS(3554),
    [anon_sym_LBRACK] = ACTIONS(2285),
    [anon_sym_COLON] = ACTIONS(3558),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(3558),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(3554),
    [anon_sym_u8] = ACTIONS(2293),
    [anon_sym_i8] = ACTIONS(2293),
    [anon_sym_u16] = ACTIONS(2293),
    [anon_sym_i16] = ACTIONS(2293),
    [anon_sym_u32] = ACTIONS(2293),
    [anon_sym_i32] = ACTIONS(2293),
    [anon_sym_u64] = ACTIONS(2293),
    [anon_sym_i64] = ACTIONS(2293),
    [anon_sym_u128] = ACTIONS(2293),
    [anon_sym_i128] = ACTIONS(2293),
    [anon_sym_isize] = ACTIONS(2293),
    [anon_sym_usize] = ACTIONS(2293),
    [anon_sym_f32] = ACTIONS(2293),
    [anon_sym_f64] = ACTIONS(2293),
    [anon_sym_bool] = ACTIONS(2293),
    [anon_sym_str] = ACTIONS(2293),
    [anon_sym_char] = ACTIONS(2293),
    [anon_sym__] = ACTIONS(3558),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_DASH] = ACTIONS(2291),
    [anon_sym_DOT] = ACTIONS(3558),
    [anon_sym_DASH_EQ] = ACTIONS(3554),
    [anon_sym_DASH_GT] = ACTIONS(3554),
    [anon_sym_COLON_COLON] = ACTIONS(3554),
    [anon_sym_BANG] = ACTIONS(2297),
    [anon_sym_BANG_EQ] = ACTIONS(3554),
    [anon_sym_AT] = ACTIONS(3554),
    [anon_sym_STAR_EQ] = ACTIONS(3554),
    [anon_sym_SLASH] = ACTIONS(3558),
    [anon_sym_SLASH_EQ] = ACTIONS(3554),
    [anon_sym_AMP_AMP] = ACTIONS(3554),
    [anon_sym_AMP_EQ] = ACTIONS(3554),
    [anon_sym_POUND] = ACTIONS(3554),
    [anon_sym_PERCENT] = ACTIONS(3558),
    [anon_sym_PERCENT_EQ] = ACTIONS(3554),
    [anon_sym_CARET] = ACTIONS(3558),
    [anon_sym_CARET_EQ] = ACTIONS(3554),
    [anon_sym_PLUS_EQ] = ACTIONS(3554),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_LT_LT] = ACTIONS(3558),
    [anon_sym_LT_LT_EQ] = ACTIONS(3554),
    [anon_sym_LT_EQ] = ACTIONS(3554),
    [anon_sym_EQ] = ACTIONS(3558),
    [anon_sym_EQ_EQ] = ACTIONS(3554),
    [anon_sym_GT] = ACTIONS(3558),
    [anon_sym_GT_EQ] = ACTIONS(3554),
    [anon_sym_GT_GT] = ACTIONS(3558),
    [anon_sym_GT_GT_EQ] = ACTIONS(3554),
    [anon_sym_PIPE] = ACTIONS(2301),
    [anon_sym_PIPE_EQ] = ACTIONS(3554),
    [anon_sym_PIPE_PIPE] = ACTIONS(3554),
    [anon_sym_TILDE] = ACTIONS(3554),
    [anon_sym_QMARK] = ACTIONS(3554),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(2305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3554),
    [anon_sym_as] = ACTIONS(3558),
    [anon_sym_break] = ACTIONS(2307),
    [anon_sym_const] = ACTIONS(3558),
    [anon_sym_continue] = ACTIONS(2309),
    [anon_sym_default] = ACTIONS(2311),
    [anon_sym_enum] = ACTIONS(3558),
    [anon_sym_fn] = ACTIONS(3558),
    [anon_sym_for] = ACTIONS(2313),
    [anon_sym_if] = ACTIONS(2315),
    [anon_sym_impl] = ACTIONS(3558),
    [anon_sym_let] = ACTIONS(3558),
    [anon_sym_loop] = ACTIONS(2317),
    [anon_sym_match] = ACTIONS(2319),
    [anon_sym_mod] = ACTIONS(3558),
    [anon_sym_pub] = ACTIONS(3558),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_static] = ACTIONS(3558),
    [anon_sym_struct] = ACTIONS(3558),
    [anon_sym_trait] = ACTIONS(3558),
    [anon_sym_type] = ACTIONS(3558),
    [anon_sym_union] = ACTIONS(2311),
    [anon_sym_unsafe] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(3558),
    [anon_sym_where] = ACTIONS(3558),
    [anon_sym_while] = ACTIONS(2325),
    [sym_mutable_specifier] = ACTIONS(3558),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(2275),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(2275),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2331),
    [sym_self] = ACTIONS(2333),
    [sym_super] = ACTIONS(3558),
    [sym_crate] = ACTIONS(3558),
    [sym_metavariable] = ACTIONS(2335),
  },
  [1151] = {
    [sym_raw_string_literal] = ACTIONS(3560),
    [sym_float_literal] = ACTIONS(3560),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(3560),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym_macro_rules_BANG] = ACTIONS(3560),
    [anon_sym_LPAREN] = ACTIONS(3560),
    [anon_sym_LBRACE] = ACTIONS(3560),
    [anon_sym_RBRACE] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(3560),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3562),
    [anon_sym_u8] = ACTIONS(3562),
    [anon_sym_i8] = ACTIONS(3562),
    [anon_sym_u16] = ACTIONS(3562),
    [anon_sym_i16] = ACTIONS(3562),
    [anon_sym_u32] = ACTIONS(3562),
    [anon_sym_i32] = ACTIONS(3562),
    [anon_sym_u64] = ACTIONS(3562),
    [anon_sym_i64] = ACTIONS(3562),
    [anon_sym_u128] = ACTIONS(3562),
    [anon_sym_i128] = ACTIONS(3562),
    [anon_sym_isize] = ACTIONS(3562),
    [anon_sym_usize] = ACTIONS(3562),
    [anon_sym_f32] = ACTIONS(3562),
    [anon_sym_f64] = ACTIONS(3562),
    [anon_sym_bool] = ACTIONS(3562),
    [anon_sym_str] = ACTIONS(3562),
    [anon_sym_char] = ACTIONS(3562),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_DOT] = ACTIONS(3562),
    [anon_sym_DASH_EQ] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_BANG] = ACTIONS(3562),
    [anon_sym_BANG_EQ] = ACTIONS(3560),
    [anon_sym_STAR_EQ] = ACTIONS(3560),
    [anon_sym_SLASH] = ACTIONS(3562),
    [anon_sym_SLASH_EQ] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_AMP_EQ] = ACTIONS(3560),
    [anon_sym_POUND] = ACTIONS(3560),
    [anon_sym_PERCENT] = ACTIONS(3562),
    [anon_sym_PERCENT_EQ] = ACTIONS(3560),
    [anon_sym_CARET] = ACTIONS(3562),
    [anon_sym_CARET_EQ] = ACTIONS(3560),
    [anon_sym_PLUS_EQ] = ACTIONS(3560),
    [anon_sym_LT] = ACTIONS(3562),
    [anon_sym_LT_LT] = ACTIONS(3562),
    [anon_sym_LT_LT_EQ] = ACTIONS(3560),
    [anon_sym_LT_EQ] = ACTIONS(3560),
    [anon_sym_EQ] = ACTIONS(3562),
    [anon_sym_EQ_EQ] = ACTIONS(3560),
    [anon_sym_GT] = ACTIONS(3562),
    [anon_sym_GT_EQ] = ACTIONS(3560),
    [anon_sym_GT_GT] = ACTIONS(3562),
    [anon_sym_GT_GT_EQ] = ACTIONS(3560),
    [anon_sym_PIPE] = ACTIONS(3562),
    [anon_sym_PIPE_EQ] = ACTIONS(3560),
    [anon_sym_PIPE_PIPE] = ACTIONS(3560),
    [anon_sym_QMARK] = ACTIONS(3560),
    [anon_sym_SQUOTE] = ACTIONS(3562),
    [anon_sym_DOT_DOT] = ACTIONS(3562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3560),
    [anon_sym_as] = ACTIONS(3562),
    [anon_sym_break] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_continue] = ACTIONS(3562),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_fn] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_impl] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_loop] = ACTIONS(3562),
    [anon_sym_match] = ACTIONS(3562),
    [anon_sym_mod] = ACTIONS(3562),
    [anon_sym_pub] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_trait] = ACTIONS(3562),
    [anon_sym_type] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [anon_sym_unsafe] = ACTIONS(3562),
    [anon_sym_use] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [anon_sym_extern] = ACTIONS(3562),
    [anon_sym_move] = ACTIONS(3562),
    [sym_integer_literal] = ACTIONS(3560),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3560),
    [sym_char_literal] = ACTIONS(3560),
    [anon_sym_true] = ACTIONS(3562),
    [anon_sym_false] = ACTIONS(3562),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3562),
    [sym_self] = ACTIONS(3562),
    [sym_super] = ACTIONS(3562),
    [sym_crate] = ACTIONS(3562),
    [sym_metavariable] = ACTIONS(3560),
  },
  [1152] = {
    [sym__statement] = STATE(1845),
    [sym_empty_statement] = STATE(1845),
    [sym__expression_statement] = STATE(1845),
    [sym_macro_definition] = STATE(1845),
    [sym_token_tree] = STATE(1846),
    [sym_token_repetition] = STATE(1846),
    [sym_attribute_item] = STATE(1845),
    [sym_inner_attribute_item] = STATE(1845),
    [sym_mod_item] = STATE(1845),
    [sym_foreign_mod_item] = STATE(1845),
    [sym_struct_item] = STATE(1845),
    [sym_union_item] = STATE(1845),
    [sym_enum_item] = STATE(1845),
    [sym_extern_crate_declaration] = STATE(1845),
    [sym_const_item] = STATE(1845),
    [sym_static_item] = STATE(1845),
    [sym_type_item] = STATE(1845),
    [sym_function_item] = STATE(1845),
    [sym_function_signature_item] = STATE(1845),
    [sym_function_modifiers] = STATE(47),
    [sym_impl_item] = STATE(1845),
    [sym_trait_item] = STATE(1845),
    [sym_associated_type] = STATE(1845),
    [sym_let_declaration] = STATE(1845),
    [sym_use_declaration] = STATE(1845),
    [sym_extern_modifier] = STATE(48),
    [sym_visibility_modifier] = STATE(49),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1844),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1844),
    [sym_macro_invocation] = STATE(53),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1844),
    [sym_unary_expression] = STATE(1844),
    [sym_try_expression] = STATE(1844),
    [sym_reference_expression] = STATE(1844),
    [sym_binary_expression] = STATE(1844),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1844),
    [sym_call_expression] = STATE(1844),
    [sym_array_expression] = STATE(1844),
    [sym_parenthesized_expression] = STATE(1844),
    [sym_tuple_expression] = STATE(1844),
    [sym_unit_expression] = STATE(1844),
    [sym_struct_expression] = STATE(1844),
    [sym_if_expression] = STATE(57),
    [sym_if_let_expression] = STATE(57),
    [sym_match_expression] = STATE(57),
    [sym_while_expression] = STATE(57),
    [sym_while_let_expression] = STATE(57),
    [sym_loop_expression] = STATE(57),
    [sym_for_expression] = STATE(57),
    [sym_closure_expression] = STATE(1844),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(59),
    [sym_break_expression] = STATE(1844),
    [sym_continue_expression] = STATE(1844),
    [sym_index_expression] = STATE(1844),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(57),
    [sym_block] = STATE(57),
    [sym__literal] = STATE(1216),
    [sym_string_literal] = STATE(1216),
    [sym_boolean_literal] = STATE(1216),
    [aux_sym_source_file_repeat1] = STATE(1845),
    [aux_sym_token_tree_repeat1] = STATE(1846),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_raw_string_literal] = ACTIONS(2337),
    [sym_float_literal] = ACTIONS(2337),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(2341),
    [anon_sym_LBRACE] = ACTIONS(2343),
    [anon_sym_RBRACE] = ACTIONS(3564),
    [anon_sym_EQ_GT] = ACTIONS(3566),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [anon_sym_COLON] = ACTIONS(3568),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(3568),
    [anon_sym_STAR] = ACTIONS(2351),
    [anon_sym_COMMA] = ACTIONS(3566),
    [anon_sym_u8] = ACTIONS(2353),
    [anon_sym_i8] = ACTIONS(2353),
    [anon_sym_u16] = ACTIONS(2353),
    [anon_sym_i16] = ACTIONS(2353),
    [anon_sym_u32] = ACTIONS(2353),
    [anon_sym_i32] = ACTIONS(2353),
    [anon_sym_u64] = ACTIONS(2353),
    [anon_sym_i64] = ACTIONS(2353),
    [anon_sym_u128] = ACTIONS(2353),
    [anon_sym_i128] = ACTIONS(2353),
    [anon_sym_isize] = ACTIONS(2353),
    [anon_sym_usize] = ACTIONS(2353),
    [anon_sym_f32] = ACTIONS(2353),
    [anon_sym_f64] = ACTIONS(2353),
    [anon_sym_bool] = ACTIONS(2353),
    [anon_sym_str] = ACTIONS(2353),
    [anon_sym_char] = ACTIONS(2353),
    [anon_sym__] = ACTIONS(3568),
    [anon_sym_AMP] = ACTIONS(2355),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_DOT] = ACTIONS(3568),
    [anon_sym_DASH_EQ] = ACTIONS(3566),
    [anon_sym_DASH_GT] = ACTIONS(3566),
    [anon_sym_COLON_COLON] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(2357),
    [anon_sym_BANG_EQ] = ACTIONS(3566),
    [anon_sym_AT] = ACTIONS(3566),
    [anon_sym_STAR_EQ] = ACTIONS(3566),
    [anon_sym_SLASH] = ACTIONS(3568),
    [anon_sym_SLASH_EQ] = ACTIONS(3566),
    [anon_sym_AMP_AMP] = ACTIONS(3566),
    [anon_sym_AMP_EQ] = ACTIONS(3566),
    [anon_sym_POUND] = ACTIONS(2359),
    [anon_sym_PERCENT] = ACTIONS(3568),
    [anon_sym_PERCENT_EQ] = ACTIONS(3566),
    [anon_sym_CARET] = ACTIONS(3568),
    [anon_sym_CARET_EQ] = ACTIONS(3566),
    [anon_sym_PLUS_EQ] = ACTIONS(3566),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_LT_LT] = ACTIONS(3568),
    [anon_sym_LT_LT_EQ] = ACTIONS(3566),
    [anon_sym_LT_EQ] = ACTIONS(3566),
    [anon_sym_EQ] = ACTIONS(3568),
    [anon_sym_EQ_EQ] = ACTIONS(3566),
    [anon_sym_GT] = ACTIONS(3568),
    [anon_sym_GT_EQ] = ACTIONS(3566),
    [anon_sym_GT_GT] = ACTIONS(3568),
    [anon_sym_GT_GT_EQ] = ACTIONS(3566),
    [anon_sym_PIPE] = ACTIONS(2301),
    [anon_sym_PIPE_EQ] = ACTIONS(3566),
    [anon_sym_PIPE_PIPE] = ACTIONS(3566),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3566),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(2361),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3566),
    [anon_sym_as] = ACTIONS(3568),
    [anon_sym_break] = ACTIONS(2363),
    [anon_sym_const] = ACTIONS(2365),
    [anon_sym_continue] = ACTIONS(2367),
    [anon_sym_default] = ACTIONS(2369),
    [anon_sym_enum] = ACTIONS(2371),
    [anon_sym_fn] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2375),
    [anon_sym_if] = ACTIONS(2377),
    [anon_sym_impl] = ACTIONS(2379),
    [anon_sym_let] = ACTIONS(2381),
    [anon_sym_loop] = ACTIONS(2383),
    [anon_sym_match] = ACTIONS(2385),
    [anon_sym_mod] = ACTIONS(2387),
    [anon_sym_pub] = ACTIONS(2389),
    [anon_sym_return] = ACTIONS(2391),
    [anon_sym_static] = ACTIONS(2393),
    [anon_sym_struct] = ACTIONS(2395),
    [anon_sym_trait] = ACTIONS(2397),
    [anon_sym_type] = ACTIONS(2399),
    [anon_sym_union] = ACTIONS(2401),
    [anon_sym_unsafe] = ACTIONS(2403),
    [anon_sym_use] = ACTIONS(2405),
    [anon_sym_where] = ACTIONS(3568),
    [anon_sym_while] = ACTIONS(2407),
    [anon_sym_extern] = ACTIONS(85),
    [sym_mutable_specifier] = ACTIONS(3568),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(2337),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(2337),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2409),
    [sym_self] = ACTIONS(2411),
    [sym_super] = ACTIONS(3568),
    [sym_crate] = ACTIONS(3568),
    [sym_metavariable] = ACTIONS(2413),
  },
  [1153] = {
    [sym_token_tree] = STATE(1866),
    [sym_token_repetition] = STATE(1866),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1864),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1864),
    [sym_macro_invocation] = STATE(1864),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1864),
    [sym_unary_expression] = STATE(1864),
    [sym_try_expression] = STATE(1864),
    [sym_reference_expression] = STATE(1864),
    [sym_binary_expression] = STATE(1864),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1864),
    [sym_call_expression] = STATE(1864),
    [sym_array_expression] = STATE(1864),
    [sym_parenthesized_expression] = STATE(1864),
    [sym_tuple_expression] = STATE(1864),
    [sym_unit_expression] = STATE(1864),
    [sym_struct_expression] = STATE(1864),
    [sym_if_expression] = STATE(1864),
    [sym_if_let_expression] = STATE(1864),
    [sym_match_expression] = STATE(1864),
    [sym_while_expression] = STATE(1864),
    [sym_while_let_expression] = STATE(1864),
    [sym_loop_expression] = STATE(1864),
    [sym_for_expression] = STATE(1864),
    [sym_closure_expression] = STATE(1864),
    [sym_closure_parameters] = STATE(101),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1864),
    [sym_continue_expression] = STATE(1864),
    [sym_index_expression] = STATE(1864),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1864),
    [sym_block] = STATE(1864),
    [sym__literal] = STATE(1865),
    [sym_string_literal] = STATE(1865),
    [sym_boolean_literal] = STATE(1865),
    [aux_sym_token_tree_repeat1] = STATE(1866),
    [sym_raw_string_literal] = ACTIONS(3570),
    [sym_float_literal] = ACTIONS(3570),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3572),
    [anon_sym_LPAREN] = ACTIONS(3574),
    [anon_sym_LBRACE] = ACTIONS(3576),
    [anon_sym_EQ_GT] = ACTIONS(3572),
    [anon_sym_LBRACK] = ACTIONS(3578),
    [anon_sym_RBRACK] = ACTIONS(3580),
    [anon_sym_COLON] = ACTIONS(3582),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(3584),
    [anon_sym_COMMA] = ACTIONS(3586),
    [anon_sym_u8] = ACTIONS(3588),
    [anon_sym_i8] = ACTIONS(3588),
    [anon_sym_u16] = ACTIONS(3588),
    [anon_sym_i16] = ACTIONS(3588),
    [anon_sym_u32] = ACTIONS(3588),
    [anon_sym_i32] = ACTIONS(3588),
    [anon_sym_u64] = ACTIONS(3588),
    [anon_sym_i64] = ACTIONS(3588),
    [anon_sym_u128] = ACTIONS(3588),
    [anon_sym_i128] = ACTIONS(3588),
    [anon_sym_isize] = ACTIONS(3588),
    [anon_sym_usize] = ACTIONS(3588),
    [anon_sym_f32] = ACTIONS(3588),
    [anon_sym_f64] = ACTIONS(3588),
    [anon_sym_bool] = ACTIONS(3588),
    [anon_sym_str] = ACTIONS(3588),
    [anon_sym_char] = ACTIONS(3588),
    [anon_sym__] = ACTIONS(3582),
    [anon_sym_AMP] = ACTIONS(3590),
    [anon_sym_DASH] = ACTIONS(3584),
    [anon_sym_DOT] = ACTIONS(3582),
    [anon_sym_DASH_EQ] = ACTIONS(3572),
    [anon_sym_DASH_GT] = ACTIONS(3572),
    [anon_sym_COLON_COLON] = ACTIONS(3572),
    [anon_sym_BANG] = ACTIONS(3592),
    [anon_sym_BANG_EQ] = ACTIONS(3572),
    [anon_sym_AT] = ACTIONS(3572),
    [anon_sym_STAR_EQ] = ACTIONS(3572),
    [anon_sym_SLASH] = ACTIONS(3582),
    [anon_sym_SLASH_EQ] = ACTIONS(3572),
    [anon_sym_AMP_AMP] = ACTIONS(3572),
    [anon_sym_AMP_EQ] = ACTIONS(3572),
    [anon_sym_POUND] = ACTIONS(3572),
    [anon_sym_PERCENT] = ACTIONS(3582),
    [anon_sym_PERCENT_EQ] = ACTIONS(3572),
    [anon_sym_CARET] = ACTIONS(3582),
    [anon_sym_CARET_EQ] = ACTIONS(3572),
    [anon_sym_PLUS_EQ] = ACTIONS(3572),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_LT_LT] = ACTIONS(3582),
    [anon_sym_LT_LT_EQ] = ACTIONS(3572),
    [anon_sym_LT_EQ] = ACTIONS(3572),
    [anon_sym_EQ] = ACTIONS(3582),
    [anon_sym_EQ_EQ] = ACTIONS(3572),
    [anon_sym_GT] = ACTIONS(3582),
    [anon_sym_GT_EQ] = ACTIONS(3572),
    [anon_sym_GT_GT] = ACTIONS(3582),
    [anon_sym_GT_GT_EQ] = ACTIONS(3572),
    [anon_sym_PIPE] = ACTIONS(2301),
    [anon_sym_PIPE_EQ] = ACTIONS(3572),
    [anon_sym_PIPE_PIPE] = ACTIONS(3572),
    [anon_sym_TILDE] = ACTIONS(3572),
    [anon_sym_QMARK] = ACTIONS(3572),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(3594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3572),
    [anon_sym_as] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3596),
    [anon_sym_const] = ACTIONS(3582),
    [anon_sym_continue] = ACTIONS(3598),
    [anon_sym_default] = ACTIONS(3600),
    [anon_sym_enum] = ACTIONS(3582),
    [anon_sym_fn] = ACTIONS(3582),
    [anon_sym_for] = ACTIONS(2313),
    [anon_sym_if] = ACTIONS(3602),
    [anon_sym_impl] = ACTIONS(3582),
    [anon_sym_let] = ACTIONS(3582),
    [anon_sym_loop] = ACTIONS(2317),
    [anon_sym_match] = ACTIONS(2319),
    [anon_sym_mod] = ACTIONS(3582),
    [anon_sym_pub] = ACTIONS(3582),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_struct] = ACTIONS(3582),
    [anon_sym_trait] = ACTIONS(3582),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_union] = ACTIONS(3600),
    [anon_sym_unsafe] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(3582),
    [anon_sym_where] = ACTIONS(3582),
    [anon_sym_while] = ACTIONS(2325),
    [sym_mutable_specifier] = ACTIONS(3582),
    [anon_sym_move] = ACTIONS(171),
    [sym_integer_literal] = ACTIONS(3570),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(3570),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3606),
    [sym_self] = ACTIONS(3608),
    [sym_super] = ACTIONS(3582),
    [sym_crate] = ACTIONS(3582),
    [sym_metavariable] = ACTIONS(3610),
  },
  [1154] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(3612),
    [sym_line_comment] = ACTIONS(7),
  },
  [1155] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(103),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(103),
    [sym_macro_invocation] = STATE(103),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(103),
    [sym_unary_expression] = STATE(103),
    [sym_try_expression] = STATE(103),
    [sym_reference_expression] = STATE(103),
    [sym_binary_expression] = STATE(103),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(103),
    [sym_call_expression] = STATE(103),
    [sym_array_expression] = STATE(103),
    [sym_parenthesized_expression] = STATE(103),
    [sym_tuple_expression] = STATE(103),
    [sym_unit_expression] = STATE(103),
    [sym_struct_expression] = STATE(103),
    [sym_if_expression] = STATE(103),
    [sym_if_let_expression] = STATE(103),
    [sym_match_expression] = STATE(103),
    [sym_while_expression] = STATE(103),
    [sym_while_let_expression] = STATE(103),
    [sym_loop_expression] = STATE(103),
    [sym_for_expression] = STATE(103),
    [sym_closure_expression] = STATE(103),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(103),
    [sym_continue_expression] = STATE(103),
    [sym_index_expression] = STATE(103),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(103),
    [sym_block] = STATE(103),
    [sym__literal] = STATE(103),
    [sym_string_literal] = STATE(103),
    [sym_boolean_literal] = STATE(103),
    [sym_raw_string_literal] = ACTIONS(3614),
    [sym_float_literal] = ACTIONS(3614),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3619),
    [anon_sym_RPAREN] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(3622),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3625),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3633),
    [anon_sym_i8] = ACTIONS(3633),
    [anon_sym_u16] = ACTIONS(3633),
    [anon_sym_i16] = ACTIONS(3633),
    [anon_sym_u32] = ACTIONS(3633),
    [anon_sym_i32] = ACTIONS(3633),
    [anon_sym_u64] = ACTIONS(3633),
    [anon_sym_i64] = ACTIONS(3633),
    [anon_sym_u128] = ACTIONS(3633),
    [anon_sym_i128] = ACTIONS(3633),
    [anon_sym_isize] = ACTIONS(3633),
    [anon_sym_usize] = ACTIONS(3633),
    [anon_sym_f32] = ACTIONS(3633),
    [anon_sym_f64] = ACTIONS(3633),
    [anon_sym_bool] = ACTIONS(3633),
    [anon_sym_str] = ACTIONS(3633),
    [anon_sym_char] = ACTIONS(3633),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3636),
    [anon_sym_DASH] = ACTIONS(3630),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3639),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3645),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DOT_DOT] = ACTIONS(3651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3657),
    [anon_sym_default] = ACTIONS(3660),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3663),
    [anon_sym_if] = ACTIONS(3666),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3669),
    [anon_sym_match] = ACTIONS(3672),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3675),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3660),
    [anon_sym_unsafe] = ACTIONS(3678),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3681),
    [sym_mutable_specifier] = ACTIONS(3628),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(3614),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3684),
    [sym_char_literal] = ACTIONS(3614),
    [anon_sym_true] = ACTIONS(3687),
    [anon_sym_false] = ACTIONS(3687),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3690),
    [sym_self] = ACTIONS(3693),
    [sym_super] = ACTIONS(3696),
    [sym_crate] = ACTIONS(3696),
    [sym_metavariable] = ACTIONS(3699),
  },
  [1156] = {
    [sym_raw_string_literal] = ACTIONS(3702),
    [sym_float_literal] = ACTIONS(3702),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3702),
    [anon_sym_LPAREN] = ACTIONS(3704),
    [anon_sym_RPAREN] = ACTIONS(3704),
    [anon_sym_LBRACE] = ACTIONS(3702),
    [anon_sym_EQ_GT] = ACTIONS(3702),
    [anon_sym_LBRACK] = ACTIONS(3704),
    [anon_sym_RBRACK] = ACTIONS(3704),
    [anon_sym_COLON] = ACTIONS(3707),
    [anon_sym_DOLLAR] = ACTIONS(3707),
    [anon_sym_PLUS] = ACTIONS(3709),
    [anon_sym_STAR] = ACTIONS(3709),
    [anon_sym_COMMA] = ACTIONS(3704),
    [anon_sym_u8] = ACTIONS(3707),
    [anon_sym_i8] = ACTIONS(3707),
    [anon_sym_u16] = ACTIONS(3707),
    [anon_sym_i16] = ACTIONS(3707),
    [anon_sym_u32] = ACTIONS(3707),
    [anon_sym_i32] = ACTIONS(3707),
    [anon_sym_u64] = ACTIONS(3707),
    [anon_sym_i64] = ACTIONS(3707),
    [anon_sym_u128] = ACTIONS(3707),
    [anon_sym_i128] = ACTIONS(3707),
    [anon_sym_isize] = ACTIONS(3707),
    [anon_sym_usize] = ACTIONS(3707),
    [anon_sym_f32] = ACTIONS(3707),
    [anon_sym_f64] = ACTIONS(3707),
    [anon_sym_bool] = ACTIONS(3707),
    [anon_sym_str] = ACTIONS(3707),
    [anon_sym_char] = ACTIONS(3707),
    [anon_sym__] = ACTIONS(3707),
    [anon_sym_AMP] = ACTIONS(3709),
    [anon_sym_DASH] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3704),
    [anon_sym_DASH_GT] = ACTIONS(3702),
    [anon_sym_COLON_COLON] = ACTIONS(3702),
    [anon_sym_BANG] = ACTIONS(3707),
    [anon_sym_BANG_EQ] = ACTIONS(3704),
    [anon_sym_AT] = ACTIONS(3702),
    [anon_sym_STAR_EQ] = ACTIONS(3704),
    [anon_sym_SLASH] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3704),
    [anon_sym_AMP_AMP] = ACTIONS(3704),
    [anon_sym_AMP_EQ] = ACTIONS(3704),
    [anon_sym_POUND] = ACTIONS(3702),
    [anon_sym_PERCENT] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3704),
    [anon_sym_CARET] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3704),
    [anon_sym_PLUS_EQ] = ACTIONS(3704),
    [anon_sym_LT] = ACTIONS(3709),
    [anon_sym_LT_LT] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3704),
    [anon_sym_LT_EQ] = ACTIONS(3704),
    [anon_sym_EQ] = ACTIONS(3709),
    [anon_sym_EQ_EQ] = ACTIONS(3704),
    [anon_sym_GT] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3704),
    [anon_sym_GT_GT] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3704),
    [anon_sym_PIPE] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3704),
    [anon_sym_PIPE_PIPE] = ACTIONS(3704),
    [anon_sym_TILDE] = ACTIONS(3702),
    [anon_sym_QMARK] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(3707),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3704),
    [anon_sym_as] = ACTIONS(3709),
    [anon_sym_break] = ACTIONS(3707),
    [anon_sym_const] = ACTIONS(3707),
    [anon_sym_continue] = ACTIONS(3707),
    [anon_sym_default] = ACTIONS(3707),
    [anon_sym_enum] = ACTIONS(3707),
    [anon_sym_fn] = ACTIONS(3707),
    [anon_sym_for] = ACTIONS(3707),
    [anon_sym_if] = ACTIONS(3707),
    [anon_sym_impl] = ACTIONS(3707),
    [anon_sym_let] = ACTIONS(3707),
    [anon_sym_loop] = ACTIONS(3707),
    [anon_sym_match] = ACTIONS(3707),
    [anon_sym_mod] = ACTIONS(3707),
    [anon_sym_pub] = ACTIONS(3707),
    [anon_sym_return] = ACTIONS(3707),
    [anon_sym_static] = ACTIONS(3707),
    [anon_sym_struct] = ACTIONS(3707),
    [anon_sym_trait] = ACTIONS(3707),
    [anon_sym_type] = ACTIONS(3707),
    [anon_sym_union] = ACTIONS(3707),
    [anon_sym_unsafe] = ACTIONS(3707),
    [anon_sym_use] = ACTIONS(3707),
    [anon_sym_where] = ACTIONS(3707),
    [anon_sym_while] = ACTIONS(3707),
    [sym_mutable_specifier] = ACTIONS(3707),
    [sym_integer_literal] = ACTIONS(3702),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3702),
    [sym_char_literal] = ACTIONS(3702),
    [anon_sym_true] = ACTIONS(3707),
    [anon_sym_false] = ACTIONS(3707),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3707),
    [sym_self] = ACTIONS(3707),
    [sym_super] = ACTIONS(3707),
    [sym_crate] = ACTIONS(3707),
    [sym_metavariable] = ACTIONS(3702),
  },
  [1157] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(106),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(106),
    [sym_macro_invocation] = STATE(106),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(106),
    [sym_unary_expression] = STATE(106),
    [sym_try_expression] = STATE(106),
    [sym_reference_expression] = STATE(106),
    [sym_binary_expression] = STATE(106),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(106),
    [sym_call_expression] = STATE(106),
    [sym_array_expression] = STATE(106),
    [sym_parenthesized_expression] = STATE(106),
    [sym_tuple_expression] = STATE(106),
    [sym_unit_expression] = STATE(106),
    [sym_struct_expression] = STATE(106),
    [sym_if_expression] = STATE(106),
    [sym_if_let_expression] = STATE(106),
    [sym_match_expression] = STATE(106),
    [sym_while_expression] = STATE(106),
    [sym_while_let_expression] = STATE(106),
    [sym_loop_expression] = STATE(106),
    [sym_for_expression] = STATE(106),
    [sym_closure_expression] = STATE(106),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(106),
    [sym_continue_expression] = STATE(106),
    [sym_index_expression] = STATE(106),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(106),
    [sym_block] = STATE(106),
    [sym__literal] = STATE(106),
    [sym_string_literal] = STATE(106),
    [sym_boolean_literal] = STATE(106),
    [sym_raw_string_literal] = ACTIONS(3712),
    [sym_float_literal] = ACTIONS(3712),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3619),
    [anon_sym_RPAREN] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(3622),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3625),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3633),
    [anon_sym_i8] = ACTIONS(3633),
    [anon_sym_u16] = ACTIONS(3633),
    [anon_sym_i16] = ACTIONS(3633),
    [anon_sym_u32] = ACTIONS(3633),
    [anon_sym_i32] = ACTIONS(3633),
    [anon_sym_u64] = ACTIONS(3633),
    [anon_sym_i64] = ACTIONS(3633),
    [anon_sym_u128] = ACTIONS(3633),
    [anon_sym_i128] = ACTIONS(3633),
    [anon_sym_isize] = ACTIONS(3633),
    [anon_sym_usize] = ACTIONS(3633),
    [anon_sym_f32] = ACTIONS(3633),
    [anon_sym_f64] = ACTIONS(3633),
    [anon_sym_bool] = ACTIONS(3633),
    [anon_sym_str] = ACTIONS(3633),
    [anon_sym_char] = ACTIONS(3633),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3636),
    [anon_sym_DASH] = ACTIONS(3630),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3639),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3645),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DOT_DOT] = ACTIONS(3651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3657),
    [anon_sym_default] = ACTIONS(3660),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3663),
    [anon_sym_if] = ACTIONS(3666),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3669),
    [anon_sym_match] = ACTIONS(3672),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3675),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3660),
    [anon_sym_unsafe] = ACTIONS(3678),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3681),
    [sym_mutable_specifier] = ACTIONS(3715),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(3712),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3684),
    [sym_char_literal] = ACTIONS(3712),
    [anon_sym_true] = ACTIONS(3687),
    [anon_sym_false] = ACTIONS(3687),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3690),
    [sym_self] = ACTIONS(3693),
    [sym_super] = ACTIONS(3696),
    [sym_crate] = ACTIONS(3696),
    [sym_metavariable] = ACTIONS(3699),
  },
  [1158] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(103),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(103),
    [sym_macro_invocation] = STATE(103),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(103),
    [sym_unary_expression] = STATE(103),
    [sym_try_expression] = STATE(103),
    [sym_reference_expression] = STATE(103),
    [sym_binary_expression] = STATE(103),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(103),
    [sym_call_expression] = STATE(103),
    [sym_array_expression] = STATE(103),
    [sym_parenthesized_expression] = STATE(103),
    [sym_tuple_expression] = STATE(103),
    [sym_unit_expression] = STATE(103),
    [sym_struct_expression] = STATE(103),
    [sym_if_expression] = STATE(103),
    [sym_if_let_expression] = STATE(103),
    [sym_match_expression] = STATE(103),
    [sym_while_expression] = STATE(103),
    [sym_while_let_expression] = STATE(103),
    [sym_loop_expression] = STATE(103),
    [sym_for_expression] = STATE(103),
    [sym_closure_expression] = STATE(103),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(103),
    [sym_continue_expression] = STATE(103),
    [sym_index_expression] = STATE(103),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(103),
    [sym_block] = STATE(103),
    [sym__literal] = STATE(103),
    [sym_string_literal] = STATE(103),
    [sym_boolean_literal] = STATE(103),
    [sym_raw_string_literal] = ACTIONS(173),
    [sym_float_literal] = ACTIONS(173),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(539),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3718),
    [anon_sym_DASH] = ACTIONS(539),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3720),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3722),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(3724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(133),
    [sym_mutable_specifier] = ACTIONS(3628),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(173),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(173),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1159] = {
    [sym_function_modifiers] = STATE(124),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(125),
    [sym_bracketed_type] = STATE(122),
    [sym_qualified_type] = STATE(126),
    [sym_lifetime] = STATE(127),
    [sym_array_type] = STATE(125),
    [sym_function_type] = STATE(125),
    [sym_tuple_type] = STATE(125),
    [sym_unit_type] = STATE(125),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(125),
    [sym_reference_type] = STATE(125),
    [sym_pointer_type] = STATE(125),
    [sym_empty_type] = STATE(125),
    [sym_dynamic_type] = STATE(125),
    [sym_macro_invocation] = STATE(125),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(131),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3726),
    [anon_sym_RPAREN] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3729),
    [anon_sym_RBRACK] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3732),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3735),
    [anon_sym_i8] = ACTIONS(3735),
    [anon_sym_u16] = ACTIONS(3735),
    [anon_sym_i16] = ACTIONS(3735),
    [anon_sym_u32] = ACTIONS(3735),
    [anon_sym_i32] = ACTIONS(3735),
    [anon_sym_u64] = ACTIONS(3735),
    [anon_sym_i64] = ACTIONS(3735),
    [anon_sym_u128] = ACTIONS(3735),
    [anon_sym_i128] = ACTIONS(3735),
    [anon_sym_isize] = ACTIONS(3735),
    [anon_sym_usize] = ACTIONS(3735),
    [anon_sym_f32] = ACTIONS(3735),
    [anon_sym_f64] = ACTIONS(3735),
    [anon_sym_bool] = ACTIONS(3735),
    [anon_sym_str] = ACTIONS(3735),
    [anon_sym_char] = ACTIONS(3735),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3628),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_BANG] = ACTIONS(3744),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3628),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3747),
    [anon_sym_DOT_DOT] = ACTIONS(3628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3750),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3750),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3753),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3750),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3756),
    [sym_self] = ACTIONS(3759),
    [sym_super] = ACTIONS(3759),
    [sym_crate] = ACTIONS(3759),
    [sym_metavariable] = ACTIONS(3762),
  },
  [1160] = {
    [sym_parameter] = STATE(148),
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(148),
    [sym_tuple_pattern] = STATE(148),
    [sym_tuple_struct_pattern] = STATE(148),
    [sym_struct_pattern] = STATE(148),
    [sym_remaining_field_pattern] = STATE(148),
    [sym_mut_pattern] = STATE(148),
    [sym_ref_pattern] = STATE(148),
    [sym_captured_pattern] = STATE(148),
    [sym_reference_pattern] = STATE(148),
    [sym_reference_pattern_in_parameter] = STATE(153),
    [sym__literal] = STATE(148),
    [sym_string_literal] = STATE(148),
    [sym_boolean_literal] = STATE(148),
    [sym_raw_string_literal] = ACTIONS(3765),
    [sym_float_literal] = ACTIONS(3765),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3768),
    [anon_sym_RPAREN] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_RBRACK] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3771),
    [anon_sym_i8] = ACTIONS(3771),
    [anon_sym_u16] = ACTIONS(3771),
    [anon_sym_i16] = ACTIONS(3771),
    [anon_sym_u32] = ACTIONS(3771),
    [anon_sym_i32] = ACTIONS(3771),
    [anon_sym_u64] = ACTIONS(3771),
    [anon_sym_i64] = ACTIONS(3771),
    [anon_sym_u128] = ACTIONS(3771),
    [anon_sym_i128] = ACTIONS(3771),
    [anon_sym_isize] = ACTIONS(3771),
    [anon_sym_usize] = ACTIONS(3771),
    [anon_sym_f32] = ACTIONS(3771),
    [anon_sym_f64] = ACTIONS(3771),
    [anon_sym_bool] = ACTIONS(3771),
    [anon_sym_str] = ACTIONS(3771),
    [anon_sym_char] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3774),
    [anon_sym_AMP] = ACTIONS(3777),
    [anon_sym_DASH] = ACTIONS(3628),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3783),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3789),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3789),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3792),
    [anon_sym_ref] = ACTIONS(243),
    [sym_integer_literal] = ACTIONS(3765),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3795),
    [sym_char_literal] = ACTIONS(3765),
    [anon_sym_true] = ACTIONS(3798),
    [anon_sym_false] = ACTIONS(3798),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3801),
    [sym_self] = ACTIONS(3804),
    [sym_super] = ACTIONS(3807),
    [sym_crate] = ACTIONS(3807),
    [sym_metavariable] = ACTIONS(3810),
  },
  [1161] = {
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3617),
    [anon_sym_RPAREN] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_RBRACK] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3628),
    [anon_sym_DASH] = ACTIONS(3628),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3628),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3628),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3813),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1162] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(278),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(278),
    [sym_macro_invocation] = STATE(278),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(278),
    [sym_unary_expression] = STATE(278),
    [sym_try_expression] = STATE(278),
    [sym_reference_expression] = STATE(278),
    [sym_binary_expression] = STATE(278),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_array_expression] = STATE(278),
    [sym_parenthesized_expression] = STATE(278),
    [sym_tuple_expression] = STATE(278),
    [sym_unit_expression] = STATE(278),
    [sym_struct_expression] = STATE(278),
    [sym_if_expression] = STATE(278),
    [sym_if_let_expression] = STATE(278),
    [sym_match_expression] = STATE(278),
    [sym_while_expression] = STATE(278),
    [sym_while_let_expression] = STATE(278),
    [sym_loop_expression] = STATE(278),
    [sym_for_expression] = STATE(278),
    [sym_closure_expression] = STATE(278),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(278),
    [sym_continue_expression] = STATE(278),
    [sym_index_expression] = STATE(278),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(278),
    [sym_block] = STATE(278),
    [sym__literal] = STATE(278),
    [sym_string_literal] = STATE(278),
    [sym_boolean_literal] = STATE(278),
    [sym_raw_string_literal] = ACTIONS(537),
    [sym_float_literal] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(261),
    [anon_sym_RPAREN] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(263),
    [anon_sym_COMMA] = ACTIONS(261),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(263),
    [anon_sym_DASH] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(263),
    [anon_sym_DASH_EQ] = ACTIONS(261),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_BANG_EQ] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(261),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_SLASH_EQ] = ACTIONS(261),
    [anon_sym_AMP_AMP] = ACTIONS(261),
    [anon_sym_AMP_EQ] = ACTIONS(261),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(263),
    [anon_sym_PERCENT_EQ] = ACTIONS(261),
    [anon_sym_CARET] = ACTIONS(263),
    [anon_sym_CARET_EQ] = ACTIONS(261),
    [anon_sym_PLUS_EQ] = ACTIONS(261),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_EQ] = ACTIONS(261),
    [anon_sym_LT_EQ] = ACTIONS(261),
    [anon_sym_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(261),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_EQ] = ACTIONS(261),
    [anon_sym_GT_GT] = ACTIONS(263),
    [anon_sym_GT_GT_EQ] = ACTIONS(261),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_PIPE_EQ] = ACTIONS(261),
    [anon_sym_PIPE_PIPE] = ACTIONS(261),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(263),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(261),
    [anon_sym_as] = ACTIONS(263),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(133),
    [sym_mutable_specifier] = ACTIONS(3628),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(537),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1163] = {
    [sym_loop_label] = STATE(156),
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3816),
    [anon_sym_RPAREN] = ACTIONS(3816),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3816),
    [anon_sym_RBRACK] = ACTIONS(3816),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3819),
    [anon_sym_STAR] = ACTIONS(3819),
    [anon_sym_COMMA] = ACTIONS(3816),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3819),
    [anon_sym_DASH] = ACTIONS(3819),
    [anon_sym_DOT] = ACTIONS(3819),
    [anon_sym_DASH_EQ] = ACTIONS(3816),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3816),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3816),
    [anon_sym_SLASH] = ACTIONS(3819),
    [anon_sym_SLASH_EQ] = ACTIONS(3816),
    [anon_sym_AMP_AMP] = ACTIONS(3816),
    [anon_sym_AMP_EQ] = ACTIONS(3816),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3819),
    [anon_sym_PERCENT_EQ] = ACTIONS(3816),
    [anon_sym_CARET] = ACTIONS(3819),
    [anon_sym_CARET_EQ] = ACTIONS(3816),
    [anon_sym_PLUS_EQ] = ACTIONS(3816),
    [anon_sym_LT] = ACTIONS(3819),
    [anon_sym_LT_LT] = ACTIONS(3819),
    [anon_sym_LT_LT_EQ] = ACTIONS(3816),
    [anon_sym_LT_EQ] = ACTIONS(3816),
    [anon_sym_EQ] = ACTIONS(3819),
    [anon_sym_EQ_EQ] = ACTIONS(3816),
    [anon_sym_GT] = ACTIONS(3819),
    [anon_sym_GT_EQ] = ACTIONS(3816),
    [anon_sym_GT_GT] = ACTIONS(3819),
    [anon_sym_GT_GT_EQ] = ACTIONS(3816),
    [anon_sym_PIPE] = ACTIONS(3819),
    [anon_sym_PIPE_EQ] = ACTIONS(3816),
    [anon_sym_PIPE_PIPE] = ACTIONS(3816),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3816),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DOT_DOT] = ACTIONS(3819),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3816),
    [anon_sym_as] = ACTIONS(3819),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3628),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1164] = {
    [sym_loop_label] = STATE(158),
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3822),
    [anon_sym_RPAREN] = ACTIONS(3822),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3822),
    [anon_sym_RBRACK] = ACTIONS(3822),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_COMMA] = ACTIONS(3822),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3825),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3825),
    [anon_sym_DASH_EQ] = ACTIONS(3822),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3822),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3822),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_SLASH_EQ] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(3822),
    [anon_sym_AMP_EQ] = ACTIONS(3822),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3825),
    [anon_sym_PERCENT_EQ] = ACTIONS(3822),
    [anon_sym_CARET] = ACTIONS(3825),
    [anon_sym_CARET_EQ] = ACTIONS(3822),
    [anon_sym_PLUS_EQ] = ACTIONS(3822),
    [anon_sym_LT] = ACTIONS(3825),
    [anon_sym_LT_LT] = ACTIONS(3825),
    [anon_sym_LT_LT_EQ] = ACTIONS(3822),
    [anon_sym_LT_EQ] = ACTIONS(3822),
    [anon_sym_EQ] = ACTIONS(3825),
    [anon_sym_EQ_EQ] = ACTIONS(3822),
    [anon_sym_GT] = ACTIONS(3825),
    [anon_sym_GT_EQ] = ACTIONS(3822),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_EQ] = ACTIONS(3822),
    [anon_sym_PIPE] = ACTIONS(3825),
    [anon_sym_PIPE_EQ] = ACTIONS(3822),
    [anon_sym_PIPE_PIPE] = ACTIONS(3822),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3822),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DOT_DOT] = ACTIONS(3825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3822),
    [anon_sym_as] = ACTIONS(3825),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3628),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1165] = {
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3828),
    [anon_sym_RPAREN] = ACTIONS(3828),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3828),
    [anon_sym_RBRACK] = ACTIONS(3828),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3831),
    [anon_sym_STAR] = ACTIONS(3831),
    [anon_sym_COMMA] = ACTIONS(3828),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3831),
    [anon_sym_DASH] = ACTIONS(3831),
    [anon_sym_DOT] = ACTIONS(3831),
    [anon_sym_DASH_EQ] = ACTIONS(3828),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3828),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3828),
    [anon_sym_SLASH] = ACTIONS(3831),
    [anon_sym_SLASH_EQ] = ACTIONS(3828),
    [anon_sym_AMP_AMP] = ACTIONS(3828),
    [anon_sym_AMP_EQ] = ACTIONS(3828),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3831),
    [anon_sym_PERCENT_EQ] = ACTIONS(3828),
    [anon_sym_CARET] = ACTIONS(3831),
    [anon_sym_CARET_EQ] = ACTIONS(3828),
    [anon_sym_PLUS_EQ] = ACTIONS(3828),
    [anon_sym_LT] = ACTIONS(3831),
    [anon_sym_LT_LT] = ACTIONS(3831),
    [anon_sym_LT_LT_EQ] = ACTIONS(3828),
    [anon_sym_LT_EQ] = ACTIONS(3828),
    [anon_sym_EQ] = ACTIONS(3831),
    [anon_sym_EQ_EQ] = ACTIONS(3828),
    [anon_sym_GT] = ACTIONS(3831),
    [anon_sym_GT_EQ] = ACTIONS(3828),
    [anon_sym_GT_GT] = ACTIONS(3831),
    [anon_sym_GT_GT_EQ] = ACTIONS(3828),
    [anon_sym_PIPE] = ACTIONS(3831),
    [anon_sym_PIPE_EQ] = ACTIONS(3828),
    [anon_sym_PIPE_PIPE] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3828),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3831),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3828),
    [anon_sym_as] = ACTIONS(3831),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3628),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1166] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(279),
    [sym_tuple_pattern] = STATE(279),
    [sym_tuple_struct_pattern] = STATE(279),
    [sym_struct_pattern] = STATE(279),
    [sym_remaining_field_pattern] = STATE(279),
    [sym_mut_pattern] = STATE(279),
    [sym_ref_pattern] = STATE(279),
    [sym_captured_pattern] = STATE(279),
    [sym_reference_pattern] = STATE(279),
    [sym__literal] = STATE(279),
    [sym_string_literal] = STATE(279),
    [sym_boolean_literal] = STATE(279),
    [sym_raw_string_literal] = ACTIONS(3834),
    [sym_float_literal] = ACTIONS(3834),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3768),
    [anon_sym_RPAREN] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_RBRACK] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3837),
    [anon_sym_i8] = ACTIONS(3837),
    [anon_sym_u16] = ACTIONS(3837),
    [anon_sym_i16] = ACTIONS(3837),
    [anon_sym_u32] = ACTIONS(3837),
    [anon_sym_i32] = ACTIONS(3837),
    [anon_sym_u64] = ACTIONS(3837),
    [anon_sym_i64] = ACTIONS(3837),
    [anon_sym_u128] = ACTIONS(3837),
    [anon_sym_i128] = ACTIONS(3837),
    [anon_sym_isize] = ACTIONS(3837),
    [anon_sym_usize] = ACTIONS(3837),
    [anon_sym_f32] = ACTIONS(3837),
    [anon_sym_f64] = ACTIONS(3837),
    [anon_sym_bool] = ACTIONS(3837),
    [anon_sym_str] = ACTIONS(3837),
    [anon_sym_char] = ACTIONS(3837),
    [anon_sym__] = ACTIONS(3840),
    [anon_sym_AMP] = ACTIONS(3843),
    [anon_sym_DASH] = ACTIONS(3628),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3628),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3846),
    [anon_sym_ref] = ACTIONS(297),
    [sym_integer_literal] = ACTIONS(3834),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3684),
    [sym_char_literal] = ACTIONS(3834),
    [anon_sym_true] = ACTIONS(3687),
    [anon_sym_false] = ACTIONS(3687),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3849),
    [sym_self] = ACTIONS(3807),
    [sym_super] = ACTIONS(3807),
    [sym_crate] = ACTIONS(3807),
    [sym_metavariable] = ACTIONS(3810),
  },
  [1167] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(281),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(281),
    [sym_macro_invocation] = STATE(281),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(281),
    [sym_unary_expression] = STATE(281),
    [sym_try_expression] = STATE(281),
    [sym_reference_expression] = STATE(281),
    [sym_binary_expression] = STATE(281),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(281),
    [sym_call_expression] = STATE(281),
    [sym_array_expression] = STATE(281),
    [sym_parenthesized_expression] = STATE(281),
    [sym_tuple_expression] = STATE(281),
    [sym_unit_expression] = STATE(281),
    [sym_struct_expression] = STATE(281),
    [sym_if_expression] = STATE(281),
    [sym_if_let_expression] = STATE(281),
    [sym_match_expression] = STATE(281),
    [sym_while_expression] = STATE(281),
    [sym_while_let_expression] = STATE(281),
    [sym_loop_expression] = STATE(281),
    [sym_for_expression] = STATE(281),
    [sym_closure_expression] = STATE(281),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(281),
    [sym_continue_expression] = STATE(281),
    [sym_index_expression] = STATE(281),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(281),
    [sym_block] = STATE(281),
    [sym__literal] = STATE(281),
    [sym_string_literal] = STATE(281),
    [sym_boolean_literal] = STATE(281),
    [sym_raw_string_literal] = ACTIONS(3852),
    [sym_float_literal] = ACTIONS(3852),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3619),
    [anon_sym_RPAREN] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(3622),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3625),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3855),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3858),
    [anon_sym_i8] = ACTIONS(3858),
    [anon_sym_u16] = ACTIONS(3858),
    [anon_sym_i16] = ACTIONS(3858),
    [anon_sym_u32] = ACTIONS(3858),
    [anon_sym_i32] = ACTIONS(3858),
    [anon_sym_u64] = ACTIONS(3858),
    [anon_sym_i64] = ACTIONS(3858),
    [anon_sym_u128] = ACTIONS(3858),
    [anon_sym_i128] = ACTIONS(3858),
    [anon_sym_isize] = ACTIONS(3858),
    [anon_sym_usize] = ACTIONS(3858),
    [anon_sym_f32] = ACTIONS(3858),
    [anon_sym_f64] = ACTIONS(3858),
    [anon_sym_bool] = ACTIONS(3858),
    [anon_sym_str] = ACTIONS(3858),
    [anon_sym_char] = ACTIONS(3858),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3861),
    [anon_sym_DASH] = ACTIONS(3855),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3864),
    [anon_sym_BANG] = ACTIONS(3855),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3645),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DOT_DOT] = ACTIONS(3867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3657),
    [anon_sym_default] = ACTIONS(3660),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3663),
    [anon_sym_if] = ACTIONS(3870),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3873),
    [anon_sym_loop] = ACTIONS(3669),
    [anon_sym_match] = ACTIONS(3672),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3876),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3660),
    [anon_sym_unsafe] = ACTIONS(3678),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3681),
    [sym_mutable_specifier] = ACTIONS(3628),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(3852),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3684),
    [sym_char_literal] = ACTIONS(3852),
    [anon_sym_true] = ACTIONS(3687),
    [anon_sym_false] = ACTIONS(3687),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3879),
    [sym_self] = ACTIONS(3882),
    [sym_super] = ACTIONS(3885),
    [sym_crate] = ACTIONS(3885),
    [sym_metavariable] = ACTIONS(3888),
  },
  [1168] = {
    [sym_block] = STATE(282),
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3617),
    [anon_sym_RPAREN] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(3622),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_RBRACK] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3628),
    [anon_sym_DASH] = ACTIONS(3628),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3628),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3628),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3628),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1169] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(283),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(283),
    [sym_macro_invocation] = STATE(283),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(283),
    [sym_unary_expression] = STATE(283),
    [sym_try_expression] = STATE(283),
    [sym_reference_expression] = STATE(283),
    [sym_binary_expression] = STATE(283),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(283),
    [sym_call_expression] = STATE(283),
    [sym_array_expression] = STATE(283),
    [sym_parenthesized_expression] = STATE(283),
    [sym_tuple_expression] = STATE(283),
    [sym_unit_expression] = STATE(283),
    [sym_struct_expression] = STATE(283),
    [sym_if_expression] = STATE(283),
    [sym_if_let_expression] = STATE(283),
    [sym_match_expression] = STATE(283),
    [sym_while_expression] = STATE(283),
    [sym_while_let_expression] = STATE(283),
    [sym_loop_expression] = STATE(283),
    [sym_for_expression] = STATE(283),
    [sym_closure_expression] = STATE(283),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(283),
    [sym_continue_expression] = STATE(283),
    [sym_index_expression] = STATE(283),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(283),
    [sym_block] = STATE(283),
    [sym__literal] = STATE(283),
    [sym_string_literal] = STATE(283),
    [sym_boolean_literal] = STATE(283),
    [sym_raw_string_literal] = ACTIONS(3891),
    [sym_float_literal] = ACTIONS(3891),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3619),
    [anon_sym_RPAREN] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(3622),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3625),
    [anon_sym_RBRACK] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3855),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3858),
    [anon_sym_i8] = ACTIONS(3858),
    [anon_sym_u16] = ACTIONS(3858),
    [anon_sym_i16] = ACTIONS(3858),
    [anon_sym_u32] = ACTIONS(3858),
    [anon_sym_i32] = ACTIONS(3858),
    [anon_sym_u64] = ACTIONS(3858),
    [anon_sym_i64] = ACTIONS(3858),
    [anon_sym_u128] = ACTIONS(3858),
    [anon_sym_i128] = ACTIONS(3858),
    [anon_sym_isize] = ACTIONS(3858),
    [anon_sym_usize] = ACTIONS(3858),
    [anon_sym_f32] = ACTIONS(3858),
    [anon_sym_f64] = ACTIONS(3858),
    [anon_sym_bool] = ACTIONS(3858),
    [anon_sym_str] = ACTIONS(3858),
    [anon_sym_char] = ACTIONS(3858),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3861),
    [anon_sym_DASH] = ACTIONS(3855),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3864),
    [anon_sym_BANG] = ACTIONS(3855),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3645),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DOT_DOT] = ACTIONS(3867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3657),
    [anon_sym_default] = ACTIONS(3660),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3663),
    [anon_sym_if] = ACTIONS(3870),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3669),
    [anon_sym_match] = ACTIONS(3672),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3876),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3660),
    [anon_sym_unsafe] = ACTIONS(3678),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3681),
    [sym_mutable_specifier] = ACTIONS(3628),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(3891),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3684),
    [sym_char_literal] = ACTIONS(3891),
    [anon_sym_true] = ACTIONS(3687),
    [anon_sym_false] = ACTIONS(3687),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3879),
    [sym_self] = ACTIONS(3882),
    [sym_super] = ACTIONS(3885),
    [sym_crate] = ACTIONS(3885),
    [sym_metavariable] = ACTIONS(3888),
  },
  [1170] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(284),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(284),
    [sym_macro_invocation] = STATE(284),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(284),
    [sym_unary_expression] = STATE(284),
    [sym_try_expression] = STATE(284),
    [sym_reference_expression] = STATE(284),
    [sym_binary_expression] = STATE(284),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(284),
    [sym_call_expression] = STATE(284),
    [sym_array_expression] = STATE(284),
    [sym_parenthesized_expression] = STATE(284),
    [sym_tuple_expression] = STATE(284),
    [sym_unit_expression] = STATE(284),
    [sym_struct_expression] = STATE(284),
    [sym_if_expression] = STATE(284),
    [sym_if_let_expression] = STATE(284),
    [sym_match_expression] = STATE(284),
    [sym_while_expression] = STATE(284),
    [sym_while_let_expression] = STATE(284),
    [sym_loop_expression] = STATE(284),
    [sym_for_expression] = STATE(284),
    [sym_closure_expression] = STATE(284),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(284),
    [sym_continue_expression] = STATE(284),
    [sym_index_expression] = STATE(284),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(284),
    [sym_block] = STATE(284),
    [sym__literal] = STATE(284),
    [sym_string_literal] = STATE(284),
    [sym_boolean_literal] = STATE(284),
    [sym_raw_string_literal] = ACTIONS(3894),
    [sym_float_literal] = ACTIONS(3894),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3897),
    [anon_sym_RPAREN] = ACTIONS(3901),
    [anon_sym_LBRACE] = ACTIONS(3622),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3904),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3908),
    [anon_sym_STAR] = ACTIONS(3911),
    [anon_sym_COMMA] = ACTIONS(3901),
    [anon_sym_u8] = ACTIONS(3633),
    [anon_sym_i8] = ACTIONS(3633),
    [anon_sym_u16] = ACTIONS(3633),
    [anon_sym_i16] = ACTIONS(3633),
    [anon_sym_u32] = ACTIONS(3633),
    [anon_sym_i32] = ACTIONS(3633),
    [anon_sym_u64] = ACTIONS(3633),
    [anon_sym_i64] = ACTIONS(3633),
    [anon_sym_u128] = ACTIONS(3633),
    [anon_sym_i128] = ACTIONS(3633),
    [anon_sym_isize] = ACTIONS(3633),
    [anon_sym_usize] = ACTIONS(3633),
    [anon_sym_f32] = ACTIONS(3633),
    [anon_sym_f64] = ACTIONS(3633),
    [anon_sym_bool] = ACTIONS(3633),
    [anon_sym_str] = ACTIONS(3633),
    [anon_sym_char] = ACTIONS(3633),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3915),
    [anon_sym_DASH] = ACTIONS(3911),
    [anon_sym_DOT] = ACTIONS(3908),
    [anon_sym_DASH_EQ] = ACTIONS(3901),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3639),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3908),
    [anon_sym_SLASH_EQ] = ACTIONS(3901),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_AMP_EQ] = ACTIONS(3901),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3908),
    [anon_sym_PERCENT_EQ] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3908),
    [anon_sym_CARET_EQ] = ACTIONS(3901),
    [anon_sym_PLUS_EQ] = ACTIONS(3901),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_LT_LT] = ACTIONS(3908),
    [anon_sym_LT_LT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_EQ] = ACTIONS(3908),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_GT] = ACTIONS(3908),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3908),
    [anon_sym_GT_GT_EQ] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_PIPE_EQ] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3901),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DOT_DOT] = ACTIONS(3927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3901),
    [anon_sym_as] = ACTIONS(3908),
    [anon_sym_break] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3657),
    [anon_sym_default] = ACTIONS(3660),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3663),
    [anon_sym_if] = ACTIONS(3666),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3669),
    [anon_sym_match] = ACTIONS(3672),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3675),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3660),
    [anon_sym_unsafe] = ACTIONS(3678),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3681),
    [sym_mutable_specifier] = ACTIONS(3628),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(3894),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3684),
    [sym_char_literal] = ACTIONS(3894),
    [anon_sym_true] = ACTIONS(3687),
    [anon_sym_false] = ACTIONS(3687),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3690),
    [sym_self] = ACTIONS(3693),
    [sym_super] = ACTIONS(3696),
    [sym_crate] = ACTIONS(3696),
    [sym_metavariable] = ACTIONS(3699),
  },
  [1171] = {
    [sym_block] = STATE(285),
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3617),
    [anon_sym_RPAREN] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(3622),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_RBRACK] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3628),
    [anon_sym_DASH] = ACTIONS(3628),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3628),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3628),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3628),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1172] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(287),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(287),
    [sym_macro_invocation] = STATE(287),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(287),
    [sym_unary_expression] = STATE(287),
    [sym_try_expression] = STATE(287),
    [sym_reference_expression] = STATE(287),
    [sym_binary_expression] = STATE(287),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(287),
    [sym_call_expression] = STATE(287),
    [sym_array_expression] = STATE(287),
    [sym_parenthesized_expression] = STATE(287),
    [sym_tuple_expression] = STATE(287),
    [sym_unit_expression] = STATE(287),
    [sym_struct_expression] = STATE(287),
    [sym_if_expression] = STATE(287),
    [sym_if_let_expression] = STATE(287),
    [sym_match_expression] = STATE(287),
    [sym_while_expression] = STATE(287),
    [sym_while_let_expression] = STATE(287),
    [sym_loop_expression] = STATE(287),
    [sym_for_expression] = STATE(287),
    [sym_closure_expression] = STATE(287),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(287),
    [sym_continue_expression] = STATE(287),
    [sym_index_expression] = STATE(287),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(287),
    [sym_block] = STATE(287),
    [sym__literal] = STATE(287),
    [sym_string_literal] = STATE(287),
    [sym_boolean_literal] = STATE(287),
    [sym_raw_string_literal] = ACTIONS(3931),
    [sym_float_literal] = ACTIONS(3931),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3619),
    [anon_sym_RPAREN] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(3622),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3625),
    [anon_sym_RBRACK] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3855),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3858),
    [anon_sym_i8] = ACTIONS(3858),
    [anon_sym_u16] = ACTIONS(3858),
    [anon_sym_i16] = ACTIONS(3858),
    [anon_sym_u32] = ACTIONS(3858),
    [anon_sym_i32] = ACTIONS(3858),
    [anon_sym_u64] = ACTIONS(3858),
    [anon_sym_i64] = ACTIONS(3858),
    [anon_sym_u128] = ACTIONS(3858),
    [anon_sym_i128] = ACTIONS(3858),
    [anon_sym_isize] = ACTIONS(3858),
    [anon_sym_usize] = ACTIONS(3858),
    [anon_sym_f32] = ACTIONS(3858),
    [anon_sym_f64] = ACTIONS(3858),
    [anon_sym_bool] = ACTIONS(3858),
    [anon_sym_str] = ACTIONS(3858),
    [anon_sym_char] = ACTIONS(3858),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3861),
    [anon_sym_DASH] = ACTIONS(3855),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3864),
    [anon_sym_BANG] = ACTIONS(3855),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3645),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DOT_DOT] = ACTIONS(3867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3657),
    [anon_sym_default] = ACTIONS(3660),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3663),
    [anon_sym_if] = ACTIONS(3870),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3934),
    [anon_sym_loop] = ACTIONS(3669),
    [anon_sym_match] = ACTIONS(3672),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3876),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3660),
    [anon_sym_unsafe] = ACTIONS(3678),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3681),
    [sym_mutable_specifier] = ACTIONS(3628),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(3931),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3684),
    [sym_char_literal] = ACTIONS(3931),
    [anon_sym_true] = ACTIONS(3687),
    [anon_sym_false] = ACTIONS(3687),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3879),
    [sym_self] = ACTIONS(3882),
    [sym_super] = ACTIONS(3885),
    [sym_crate] = ACTIONS(3885),
    [sym_metavariable] = ACTIONS(3888),
  },
  [1173] = {
    [aux_sym_string_literal_repeat1] = STATE(1869),
    [sym_block_comment] = ACTIONS(7),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_RBRACK_PLUS_SLASH] = ACTIONS(3937),
    [anon_sym_DQUOTE] = ACTIONS(3939),
    [sym_escape_sequence] = ACTIONS(3937),
    [sym_line_comment] = ACTIONS(401),
  },
  [1174] = {
    [sym_raw_string_literal] = ACTIONS(403),
    [sym_float_literal] = ACTIONS(403),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_LPAREN] = ACTIONS(403),
    [anon_sym_RPAREN] = ACTIONS(403),
    [anon_sym_LBRACE] = ACTIONS(403),
    [anon_sym_RBRACE] = ACTIONS(403),
    [anon_sym_EQ_GT] = ACTIONS(403),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_RBRACK] = ACTIONS(403),
    [anon_sym_COLON] = ACTIONS(405),
    [anon_sym_DOLLAR] = ACTIONS(405),
    [anon_sym_PLUS] = ACTIONS(405),
    [anon_sym_STAR] = ACTIONS(405),
    [anon_sym_COMMA] = ACTIONS(403),
    [anon_sym_u8] = ACTIONS(405),
    [anon_sym_i8] = ACTIONS(405),
    [anon_sym_u16] = ACTIONS(405),
    [anon_sym_i16] = ACTIONS(405),
    [anon_sym_u32] = ACTIONS(405),
    [anon_sym_i32] = ACTIONS(405),
    [anon_sym_u64] = ACTIONS(405),
    [anon_sym_i64] = ACTIONS(405),
    [anon_sym_u128] = ACTIONS(405),
    [anon_sym_i128] = ACTIONS(405),
    [anon_sym_isize] = ACTIONS(405),
    [anon_sym_usize] = ACTIONS(405),
    [anon_sym_f32] = ACTIONS(405),
    [anon_sym_f64] = ACTIONS(405),
    [anon_sym_bool] = ACTIONS(405),
    [anon_sym_str] = ACTIONS(405),
    [anon_sym_char] = ACTIONS(405),
    [anon_sym__] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(405),
    [anon_sym_DASH] = ACTIONS(405),
    [anon_sym_DOT] = ACTIONS(405),
    [anon_sym_DASH_EQ] = ACTIONS(403),
    [anon_sym_DASH_GT] = ACTIONS(403),
    [anon_sym_COLON_COLON] = ACTIONS(403),
    [anon_sym_BANG] = ACTIONS(405),
    [anon_sym_BANG_EQ] = ACTIONS(403),
    [anon_sym_AT] = ACTIONS(403),
    [anon_sym_STAR_EQ] = ACTIONS(403),
    [anon_sym_SLASH] = ACTIONS(405),
    [anon_sym_SLASH_EQ] = ACTIONS(403),
    [anon_sym_AMP_AMP] = ACTIONS(403),
    [anon_sym_AMP_EQ] = ACTIONS(403),
    [anon_sym_POUND] = ACTIONS(403),
    [anon_sym_PERCENT] = ACTIONS(405),
    [anon_sym_PERCENT_EQ] = ACTIONS(403),
    [anon_sym_CARET] = ACTIONS(405),
    [anon_sym_CARET_EQ] = ACTIONS(403),
    [anon_sym_PLUS_EQ] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(405),
    [anon_sym_LT_LT] = ACTIONS(405),
    [anon_sym_LT_LT_EQ] = ACTIONS(403),
    [anon_sym_LT_EQ] = ACTIONS(403),
    [anon_sym_EQ] = ACTIONS(405),
    [anon_sym_EQ_EQ] = ACTIONS(403),
    [anon_sym_GT] = ACTIONS(405),
    [anon_sym_GT_EQ] = ACTIONS(403),
    [anon_sym_GT_GT] = ACTIONS(405),
    [anon_sym_GT_GT_EQ] = ACTIONS(403),
    [anon_sym_PIPE] = ACTIONS(405),
    [anon_sym_PIPE_EQ] = ACTIONS(403),
    [anon_sym_PIPE_PIPE] = ACTIONS(403),
    [anon_sym_TILDE] = ACTIONS(403),
    [anon_sym_QMARK] = ACTIONS(403),
    [anon_sym_SQUOTE] = ACTIONS(405),
    [anon_sym_DOT_DOT] = ACTIONS(405),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(403),
    [anon_sym_as] = ACTIONS(405),
    [anon_sym_break] = ACTIONS(405),
    [anon_sym_const] = ACTIONS(405),
    [anon_sym_continue] = ACTIONS(405),
    [anon_sym_default] = ACTIONS(405),
    [anon_sym_enum] = ACTIONS(405),
    [anon_sym_fn] = ACTIONS(405),
    [anon_sym_for] = ACTIONS(405),
    [anon_sym_if] = ACTIONS(405),
    [anon_sym_impl] = ACTIONS(405),
    [anon_sym_let] = ACTIONS(405),
    [anon_sym_loop] = ACTIONS(405),
    [anon_sym_match] = ACTIONS(405),
    [anon_sym_mod] = ACTIONS(405),
    [anon_sym_pub] = ACTIONS(405),
    [anon_sym_return] = ACTIONS(405),
    [anon_sym_static] = ACTIONS(405),
    [anon_sym_struct] = ACTIONS(405),
    [anon_sym_trait] = ACTIONS(405),
    [anon_sym_type] = ACTIONS(405),
    [anon_sym_union] = ACTIONS(405),
    [anon_sym_unsafe] = ACTIONS(405),
    [anon_sym_use] = ACTIONS(405),
    [anon_sym_where] = ACTIONS(405),
    [anon_sym_while] = ACTIONS(405),
    [sym_mutable_specifier] = ACTIONS(405),
    [sym_integer_literal] = ACTIONS(403),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(403),
    [sym_char_literal] = ACTIONS(403),
    [anon_sym_true] = ACTIONS(405),
    [anon_sym_false] = ACTIONS(405),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(405),
    [sym_self] = ACTIONS(405),
    [sym_super] = ACTIONS(405),
    [sym_crate] = ACTIONS(405),
    [sym_metavariable] = ACTIONS(403),
  },
  [1175] = {
    [sym_field_initializer_list] = STATE(224),
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3941),
    [anon_sym_RPAREN] = ACTIONS(3941),
    [anon_sym_LBRACE] = ACTIONS(3944),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3941),
    [anon_sym_RBRACK] = ACTIONS(3941),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_STAR] = ACTIONS(3947),
    [anon_sym_COMMA] = ACTIONS(3941),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_DOT] = ACTIONS(3947),
    [anon_sym_DASH_EQ] = ACTIONS(3941),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3950),
    [anon_sym_BANG] = ACTIONS(3953),
    [anon_sym_BANG_EQ] = ACTIONS(3941),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3941),
    [anon_sym_SLASH] = ACTIONS(3947),
    [anon_sym_SLASH_EQ] = ACTIONS(3941),
    [anon_sym_AMP_AMP] = ACTIONS(3941),
    [anon_sym_AMP_EQ] = ACTIONS(3941),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3947),
    [anon_sym_PERCENT_EQ] = ACTIONS(3941),
    [anon_sym_CARET] = ACTIONS(3947),
    [anon_sym_CARET_EQ] = ACTIONS(3941),
    [anon_sym_PLUS_EQ] = ACTIONS(3941),
    [anon_sym_LT] = ACTIONS(3947),
    [anon_sym_LT_LT] = ACTIONS(3947),
    [anon_sym_LT_LT_EQ] = ACTIONS(3941),
    [anon_sym_LT_EQ] = ACTIONS(3941),
    [anon_sym_EQ] = ACTIONS(3947),
    [anon_sym_EQ_EQ] = ACTIONS(3941),
    [anon_sym_GT] = ACTIONS(3947),
    [anon_sym_GT_EQ] = ACTIONS(3941),
    [anon_sym_GT_GT] = ACTIONS(3947),
    [anon_sym_GT_GT_EQ] = ACTIONS(3941),
    [anon_sym_PIPE] = ACTIONS(3947),
    [anon_sym_PIPE_EQ] = ACTIONS(3941),
    [anon_sym_PIPE_PIPE] = ACTIONS(3941),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3947),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3628),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1176] = {
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3941),
    [anon_sym_RPAREN] = ACTIONS(3941),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3941),
    [anon_sym_RBRACK] = ACTIONS(3941),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_STAR] = ACTIONS(3947),
    [anon_sym_COMMA] = ACTIONS(3941),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_DOT] = ACTIONS(3947),
    [anon_sym_DASH_EQ] = ACTIONS(3941),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3941),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3941),
    [anon_sym_SLASH] = ACTIONS(3947),
    [anon_sym_SLASH_EQ] = ACTIONS(3941),
    [anon_sym_AMP_AMP] = ACTIONS(3941),
    [anon_sym_AMP_EQ] = ACTIONS(3941),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3947),
    [anon_sym_PERCENT_EQ] = ACTIONS(3941),
    [anon_sym_CARET] = ACTIONS(3947),
    [anon_sym_CARET_EQ] = ACTIONS(3941),
    [anon_sym_PLUS_EQ] = ACTIONS(3941),
    [anon_sym_LT] = ACTIONS(3947),
    [anon_sym_LT_LT] = ACTIONS(3947),
    [anon_sym_LT_LT_EQ] = ACTIONS(3941),
    [anon_sym_LT_EQ] = ACTIONS(3941),
    [anon_sym_EQ] = ACTIONS(3947),
    [anon_sym_EQ_EQ] = ACTIONS(3941),
    [anon_sym_GT] = ACTIONS(3947),
    [anon_sym_GT_EQ] = ACTIONS(3941),
    [anon_sym_GT_GT] = ACTIONS(3947),
    [anon_sym_GT_GT_EQ] = ACTIONS(3941),
    [anon_sym_PIPE] = ACTIONS(3947),
    [anon_sym_PIPE_EQ] = ACTIONS(3941),
    [anon_sym_PIPE_PIPE] = ACTIONS(3941),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3947),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3628),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1177] = {
    [sym_arguments] = STATE(263),
    [aux_sym_token_tree_repeat2] = STATE(1872),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(3956),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(3958),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_BANG_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH] = ACTIONS(563),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(563),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_LT] = ACTIONS(577),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(581),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(577),
    [anon_sym_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(589),
    [anon_sym_as] = ACTIONS(591),
    [sym_line_comment] = ACTIONS(7),
  },
  [1178] = {
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3941),
    [anon_sym_RPAREN] = ACTIONS(3941),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3941),
    [anon_sym_RBRACK] = ACTIONS(3941),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_STAR] = ACTIONS(3947),
    [anon_sym_COMMA] = ACTIONS(3941),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_DOT] = ACTIONS(3947),
    [anon_sym_DASH_EQ] = ACTIONS(3941),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3941),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3941),
    [anon_sym_SLASH] = ACTIONS(3947),
    [anon_sym_SLASH_EQ] = ACTIONS(3941),
    [anon_sym_AMP_AMP] = ACTIONS(3941),
    [anon_sym_AMP_EQ] = ACTIONS(3941),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3947),
    [anon_sym_PERCENT_EQ] = ACTIONS(3941),
    [anon_sym_CARET] = ACTIONS(3947),
    [anon_sym_CARET_EQ] = ACTIONS(3941),
    [anon_sym_PLUS_EQ] = ACTIONS(3941),
    [anon_sym_LT] = ACTIONS(3947),
    [anon_sym_LT_LT] = ACTIONS(3947),
    [anon_sym_LT_LT_EQ] = ACTIONS(3941),
    [anon_sym_LT_EQ] = ACTIONS(3941),
    [anon_sym_EQ] = ACTIONS(3947),
    [anon_sym_EQ_EQ] = ACTIONS(3941),
    [anon_sym_GT] = ACTIONS(3947),
    [anon_sym_GT_EQ] = ACTIONS(3941),
    [anon_sym_GT_GT] = ACTIONS(3947),
    [anon_sym_GT_GT_EQ] = ACTIONS(3941),
    [anon_sym_PIPE] = ACTIONS(3947),
    [anon_sym_PIPE_EQ] = ACTIONS(3941),
    [anon_sym_PIPE_PIPE] = ACTIONS(3941),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3947),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3628),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1179] = {
    [sym_token_tree] = STATE(1878),
    [sym_token_repetition] = STATE(1878),
    [sym__literal] = STATE(1878),
    [sym_string_literal] = STATE(1878),
    [sym_boolean_literal] = STATE(1878),
    [aux_sym_token_tree_repeat1] = STATE(1878),
    [sym_raw_string_literal] = ACTIONS(3960),
    [sym_float_literal] = ACTIONS(3960),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_RPAREN] = ACTIONS(3964),
    [anon_sym_LBRACE] = ACTIONS(3966),
    [anon_sym_EQ_GT] = ACTIONS(3960),
    [anon_sym_LBRACK] = ACTIONS(3968),
    [anon_sym_COLON] = ACTIONS(3970),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(3970),
    [anon_sym_STAR] = ACTIONS(3970),
    [anon_sym_COMMA] = ACTIONS(3960),
    [anon_sym_u8] = ACTIONS(3972),
    [anon_sym_i8] = ACTIONS(3972),
    [anon_sym_u16] = ACTIONS(3972),
    [anon_sym_i16] = ACTIONS(3972),
    [anon_sym_u32] = ACTIONS(3972),
    [anon_sym_i32] = ACTIONS(3972),
    [anon_sym_u64] = ACTIONS(3972),
    [anon_sym_i64] = ACTIONS(3972),
    [anon_sym_u128] = ACTIONS(3972),
    [anon_sym_i128] = ACTIONS(3972),
    [anon_sym_isize] = ACTIONS(3972),
    [anon_sym_usize] = ACTIONS(3972),
    [anon_sym_f32] = ACTIONS(3972),
    [anon_sym_f64] = ACTIONS(3972),
    [anon_sym_bool] = ACTIONS(3972),
    [anon_sym_str] = ACTIONS(3972),
    [anon_sym_char] = ACTIONS(3972),
    [anon_sym__] = ACTIONS(3970),
    [anon_sym_AMP] = ACTIONS(3970),
    [anon_sym_DASH] = ACTIONS(3970),
    [anon_sym_DOT] = ACTIONS(3970),
    [anon_sym_DASH_EQ] = ACTIONS(3960),
    [anon_sym_DASH_GT] = ACTIONS(3960),
    [anon_sym_COLON_COLON] = ACTIONS(3960),
    [anon_sym_BANG] = ACTIONS(3970),
    [anon_sym_BANG_EQ] = ACTIONS(3960),
    [anon_sym_AT] = ACTIONS(3960),
    [anon_sym_STAR_EQ] = ACTIONS(3960),
    [anon_sym_SLASH] = ACTIONS(3970),
    [anon_sym_SLASH_EQ] = ACTIONS(3960),
    [anon_sym_AMP_AMP] = ACTIONS(3960),
    [anon_sym_AMP_EQ] = ACTIONS(3960),
    [anon_sym_POUND] = ACTIONS(3960),
    [anon_sym_PERCENT] = ACTIONS(3970),
    [anon_sym_PERCENT_EQ] = ACTIONS(3960),
    [anon_sym_CARET] = ACTIONS(3970),
    [anon_sym_CARET_EQ] = ACTIONS(3960),
    [anon_sym_PLUS_EQ] = ACTIONS(3960),
    [anon_sym_LT] = ACTIONS(3970),
    [anon_sym_LT_LT] = ACTIONS(3970),
    [anon_sym_LT_LT_EQ] = ACTIONS(3960),
    [anon_sym_LT_EQ] = ACTIONS(3960),
    [anon_sym_EQ] = ACTIONS(3970),
    [anon_sym_EQ_EQ] = ACTIONS(3960),
    [anon_sym_GT] = ACTIONS(3970),
    [anon_sym_GT_EQ] = ACTIONS(3960),
    [anon_sym_GT_GT] = ACTIONS(3970),
    [anon_sym_GT_GT_EQ] = ACTIONS(3960),
    [anon_sym_PIPE] = ACTIONS(3970),
    [anon_sym_PIPE_EQ] = ACTIONS(3960),
    [anon_sym_PIPE_PIPE] = ACTIONS(3960),
    [anon_sym_TILDE] = ACTIONS(3960),
    [anon_sym_QMARK] = ACTIONS(3960),
    [anon_sym_SQUOTE] = ACTIONS(3970),
    [anon_sym_DOT_DOT] = ACTIONS(3970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3960),
    [anon_sym_as] = ACTIONS(3970),
    [anon_sym_break] = ACTIONS(3970),
    [anon_sym_const] = ACTIONS(3970),
    [anon_sym_continue] = ACTIONS(3970),
    [anon_sym_default] = ACTIONS(3970),
    [anon_sym_enum] = ACTIONS(3970),
    [anon_sym_fn] = ACTIONS(3970),
    [anon_sym_for] = ACTIONS(3970),
    [anon_sym_if] = ACTIONS(3970),
    [anon_sym_impl] = ACTIONS(3970),
    [anon_sym_let] = ACTIONS(3970),
    [anon_sym_loop] = ACTIONS(3970),
    [anon_sym_match] = ACTIONS(3970),
    [anon_sym_mod] = ACTIONS(3970),
    [anon_sym_pub] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3970),
    [anon_sym_static] = ACTIONS(3970),
    [anon_sym_struct] = ACTIONS(3970),
    [anon_sym_trait] = ACTIONS(3970),
    [anon_sym_type] = ACTIONS(3970),
    [anon_sym_union] = ACTIONS(3970),
    [anon_sym_unsafe] = ACTIONS(3970),
    [anon_sym_use] = ACTIONS(3970),
    [anon_sym_where] = ACTIONS(3970),
    [anon_sym_while] = ACTIONS(3970),
    [sym_mutable_specifier] = ACTIONS(3970),
    [sym_integer_literal] = ACTIONS(3960),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(3960),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3970),
    [sym_self] = ACTIONS(3970),
    [sym_super] = ACTIONS(3970),
    [sym_crate] = ACTIONS(3970),
    [sym_metavariable] = ACTIONS(3960),
  },
  [1180] = {
    [sym_raw_string_literal] = ACTIONS(3974),
    [sym_float_literal] = ACTIONS(3974),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3974),
    [anon_sym_macro_rules_BANG] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(3974),
    [anon_sym_LBRACE] = ACTIONS(3974),
    [anon_sym_RBRACE] = ACTIONS(3974),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3974),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3977),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3977),
    [anon_sym_i8] = ACTIONS(3977),
    [anon_sym_u16] = ACTIONS(3977),
    [anon_sym_i16] = ACTIONS(3977),
    [anon_sym_u32] = ACTIONS(3977),
    [anon_sym_i32] = ACTIONS(3977),
    [anon_sym_u64] = ACTIONS(3977),
    [anon_sym_i64] = ACTIONS(3977),
    [anon_sym_u128] = ACTIONS(3977),
    [anon_sym_i128] = ACTIONS(3977),
    [anon_sym_isize] = ACTIONS(3977),
    [anon_sym_usize] = ACTIONS(3977),
    [anon_sym_f32] = ACTIONS(3977),
    [anon_sym_f64] = ACTIONS(3977),
    [anon_sym_bool] = ACTIONS(3977),
    [anon_sym_str] = ACTIONS(3977),
    [anon_sym_char] = ACTIONS(3977),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3977),
    [anon_sym_DASH] = ACTIONS(3977),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3974),
    [anon_sym_BANG] = ACTIONS(3977),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3974),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3977),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3977),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3977),
    [anon_sym_DOT_DOT] = ACTIONS(3977),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3977),
    [anon_sym_const] = ACTIONS(3977),
    [anon_sym_continue] = ACTIONS(3977),
    [anon_sym_default] = ACTIONS(3977),
    [anon_sym_enum] = ACTIONS(3977),
    [anon_sym_fn] = ACTIONS(3977),
    [anon_sym_for] = ACTIONS(3977),
    [anon_sym_if] = ACTIONS(3977),
    [anon_sym_impl] = ACTIONS(3977),
    [anon_sym_let] = ACTIONS(3977),
    [anon_sym_loop] = ACTIONS(3977),
    [anon_sym_match] = ACTIONS(3977),
    [anon_sym_mod] = ACTIONS(3977),
    [anon_sym_pub] = ACTIONS(3977),
    [anon_sym_return] = ACTIONS(3977),
    [anon_sym_static] = ACTIONS(3977),
    [anon_sym_struct] = ACTIONS(3977),
    [anon_sym_trait] = ACTIONS(3977),
    [anon_sym_type] = ACTIONS(3977),
    [anon_sym_union] = ACTIONS(3977),
    [anon_sym_unsafe] = ACTIONS(3977),
    [anon_sym_use] = ACTIONS(3977),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3977),
    [anon_sym_extern] = ACTIONS(103),
    [sym_mutable_specifier] = ACTIONS(3628),
    [anon_sym_move] = ACTIONS(103),
    [sym_integer_literal] = ACTIONS(3974),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3974),
    [sym_char_literal] = ACTIONS(3974),
    [anon_sym_true] = ACTIONS(3977),
    [anon_sym_false] = ACTIONS(3977),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3977),
    [sym_self] = ACTIONS(3977),
    [sym_super] = ACTIONS(3977),
    [sym_crate] = ACTIONS(3977),
    [sym_metavariable] = ACTIONS(3974),
  },
  [1181] = {
    [sym_token_tree] = STATE(1842),
    [sym_token_repetition] = STATE(1842),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1880),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1880),
    [sym_macro_invocation] = STATE(1880),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1880),
    [sym_unary_expression] = STATE(1880),
    [sym_try_expression] = STATE(1880),
    [sym_reference_expression] = STATE(1880),
    [sym_binary_expression] = STATE(1880),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1880),
    [sym_call_expression] = STATE(1880),
    [sym_array_expression] = STATE(1880),
    [sym_parenthesized_expression] = STATE(1880),
    [sym_tuple_expression] = STATE(1880),
    [sym_unit_expression] = STATE(1880),
    [sym_struct_expression] = STATE(1880),
    [sym_if_expression] = STATE(1880),
    [sym_if_let_expression] = STATE(1880),
    [sym_match_expression] = STATE(1880),
    [sym_while_expression] = STATE(1880),
    [sym_while_let_expression] = STATE(1880),
    [sym_loop_expression] = STATE(1880),
    [sym_for_expression] = STATE(1880),
    [sym_closure_expression] = STATE(1880),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1880),
    [sym_continue_expression] = STATE(1880),
    [sym_index_expression] = STATE(1880),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1880),
    [sym_block] = STATE(1880),
    [sym__literal] = STATE(1178),
    [sym_string_literal] = STATE(1178),
    [sym_boolean_literal] = STATE(1178),
    [aux_sym_token_tree_repeat1] = STATE(1842),
    [sym_raw_string_literal] = ACTIONS(2275),
    [sym_float_literal] = ACTIONS(2275),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3554),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_RPAREN] = ACTIONS(3980),
    [anon_sym_LBRACE] = ACTIONS(2283),
    [anon_sym_EQ_GT] = ACTIONS(3554),
    [anon_sym_LBRACK] = ACTIONS(2285),
    [anon_sym_COLON] = ACTIONS(3558),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(3558),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(3554),
    [anon_sym_u8] = ACTIONS(2293),
    [anon_sym_i8] = ACTIONS(2293),
    [anon_sym_u16] = ACTIONS(2293),
    [anon_sym_i16] = ACTIONS(2293),
    [anon_sym_u32] = ACTIONS(2293),
    [anon_sym_i32] = ACTIONS(2293),
    [anon_sym_u64] = ACTIONS(2293),
    [anon_sym_i64] = ACTIONS(2293),
    [anon_sym_u128] = ACTIONS(2293),
    [anon_sym_i128] = ACTIONS(2293),
    [anon_sym_isize] = ACTIONS(2293),
    [anon_sym_usize] = ACTIONS(2293),
    [anon_sym_f32] = ACTIONS(2293),
    [anon_sym_f64] = ACTIONS(2293),
    [anon_sym_bool] = ACTIONS(2293),
    [anon_sym_str] = ACTIONS(2293),
    [anon_sym_char] = ACTIONS(2293),
    [anon_sym__] = ACTIONS(3558),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_DASH] = ACTIONS(2291),
    [anon_sym_DOT] = ACTIONS(3558),
    [anon_sym_DASH_EQ] = ACTIONS(3554),
    [anon_sym_DASH_GT] = ACTIONS(3554),
    [anon_sym_COLON_COLON] = ACTIONS(3554),
    [anon_sym_BANG] = ACTIONS(2297),
    [anon_sym_BANG_EQ] = ACTIONS(3554),
    [anon_sym_AT] = ACTIONS(3554),
    [anon_sym_STAR_EQ] = ACTIONS(3554),
    [anon_sym_SLASH] = ACTIONS(3558),
    [anon_sym_SLASH_EQ] = ACTIONS(3554),
    [anon_sym_AMP_AMP] = ACTIONS(3554),
    [anon_sym_AMP_EQ] = ACTIONS(3554),
    [anon_sym_POUND] = ACTIONS(3554),
    [anon_sym_PERCENT] = ACTIONS(3558),
    [anon_sym_PERCENT_EQ] = ACTIONS(3554),
    [anon_sym_CARET] = ACTIONS(3558),
    [anon_sym_CARET_EQ] = ACTIONS(3554),
    [anon_sym_PLUS_EQ] = ACTIONS(3554),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_LT_LT] = ACTIONS(3558),
    [anon_sym_LT_LT_EQ] = ACTIONS(3554),
    [anon_sym_LT_EQ] = ACTIONS(3554),
    [anon_sym_EQ] = ACTIONS(3558),
    [anon_sym_EQ_EQ] = ACTIONS(3554),
    [anon_sym_GT] = ACTIONS(3558),
    [anon_sym_GT_EQ] = ACTIONS(3554),
    [anon_sym_GT_GT] = ACTIONS(3558),
    [anon_sym_GT_GT_EQ] = ACTIONS(3554),
    [anon_sym_PIPE] = ACTIONS(2301),
    [anon_sym_PIPE_EQ] = ACTIONS(3554),
    [anon_sym_PIPE_PIPE] = ACTIONS(3554),
    [anon_sym_TILDE] = ACTIONS(3554),
    [anon_sym_QMARK] = ACTIONS(3554),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(2305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3554),
    [anon_sym_as] = ACTIONS(3558),
    [anon_sym_break] = ACTIONS(2307),
    [anon_sym_const] = ACTIONS(3558),
    [anon_sym_continue] = ACTIONS(2309),
    [anon_sym_default] = ACTIONS(2311),
    [anon_sym_enum] = ACTIONS(3558),
    [anon_sym_fn] = ACTIONS(3558),
    [anon_sym_for] = ACTIONS(2313),
    [anon_sym_if] = ACTIONS(2315),
    [anon_sym_impl] = ACTIONS(3558),
    [anon_sym_let] = ACTIONS(3558),
    [anon_sym_loop] = ACTIONS(2317),
    [anon_sym_match] = ACTIONS(2319),
    [anon_sym_mod] = ACTIONS(3558),
    [anon_sym_pub] = ACTIONS(3558),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_static] = ACTIONS(3558),
    [anon_sym_struct] = ACTIONS(3558),
    [anon_sym_trait] = ACTIONS(3558),
    [anon_sym_type] = ACTIONS(3558),
    [anon_sym_union] = ACTIONS(2311),
    [anon_sym_unsafe] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(3558),
    [anon_sym_where] = ACTIONS(3558),
    [anon_sym_while] = ACTIONS(2325),
    [sym_mutable_specifier] = ACTIONS(3558),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(2275),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(2275),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2331),
    [sym_self] = ACTIONS(2333),
    [sym_super] = ACTIONS(3558),
    [sym_crate] = ACTIONS(3558),
    [sym_metavariable] = ACTIONS(2335),
  },
  [1182] = {
    [sym__statement] = STATE(1883),
    [sym_empty_statement] = STATE(1883),
    [sym__expression_statement] = STATE(1883),
    [sym_macro_definition] = STATE(1883),
    [sym_token_tree] = STATE(1846),
    [sym_token_repetition] = STATE(1846),
    [sym_attribute_item] = STATE(1883),
    [sym_inner_attribute_item] = STATE(1883),
    [sym_mod_item] = STATE(1883),
    [sym_foreign_mod_item] = STATE(1883),
    [sym_struct_item] = STATE(1883),
    [sym_union_item] = STATE(1883),
    [sym_enum_item] = STATE(1883),
    [sym_extern_crate_declaration] = STATE(1883),
    [sym_const_item] = STATE(1883),
    [sym_static_item] = STATE(1883),
    [sym_type_item] = STATE(1883),
    [sym_function_item] = STATE(1883),
    [sym_function_signature_item] = STATE(1883),
    [sym_function_modifiers] = STATE(47),
    [sym_impl_item] = STATE(1883),
    [sym_trait_item] = STATE(1883),
    [sym_associated_type] = STATE(1883),
    [sym_let_declaration] = STATE(1883),
    [sym_use_declaration] = STATE(1883),
    [sym_extern_modifier] = STATE(48),
    [sym_visibility_modifier] = STATE(49),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1882),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1882),
    [sym_macro_invocation] = STATE(53),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1882),
    [sym_unary_expression] = STATE(1882),
    [sym_try_expression] = STATE(1882),
    [sym_reference_expression] = STATE(1882),
    [sym_binary_expression] = STATE(1882),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1882),
    [sym_call_expression] = STATE(1882),
    [sym_array_expression] = STATE(1882),
    [sym_parenthesized_expression] = STATE(1882),
    [sym_tuple_expression] = STATE(1882),
    [sym_unit_expression] = STATE(1882),
    [sym_struct_expression] = STATE(1882),
    [sym_if_expression] = STATE(57),
    [sym_if_let_expression] = STATE(57),
    [sym_match_expression] = STATE(57),
    [sym_while_expression] = STATE(57),
    [sym_while_let_expression] = STATE(57),
    [sym_loop_expression] = STATE(57),
    [sym_for_expression] = STATE(57),
    [sym_closure_expression] = STATE(1882),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(59),
    [sym_break_expression] = STATE(1882),
    [sym_continue_expression] = STATE(1882),
    [sym_index_expression] = STATE(1882),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(57),
    [sym_block] = STATE(57),
    [sym__literal] = STATE(1216),
    [sym_string_literal] = STATE(1216),
    [sym_boolean_literal] = STATE(1216),
    [aux_sym_source_file_repeat1] = STATE(1883),
    [aux_sym_token_tree_repeat1] = STATE(1846),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_raw_string_literal] = ACTIONS(2337),
    [sym_float_literal] = ACTIONS(2337),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(2341),
    [anon_sym_LBRACE] = ACTIONS(2343),
    [anon_sym_RBRACE] = ACTIONS(3982),
    [anon_sym_EQ_GT] = ACTIONS(3566),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [anon_sym_COLON] = ACTIONS(3568),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(3568),
    [anon_sym_STAR] = ACTIONS(2351),
    [anon_sym_COMMA] = ACTIONS(3566),
    [anon_sym_u8] = ACTIONS(2353),
    [anon_sym_i8] = ACTIONS(2353),
    [anon_sym_u16] = ACTIONS(2353),
    [anon_sym_i16] = ACTIONS(2353),
    [anon_sym_u32] = ACTIONS(2353),
    [anon_sym_i32] = ACTIONS(2353),
    [anon_sym_u64] = ACTIONS(2353),
    [anon_sym_i64] = ACTIONS(2353),
    [anon_sym_u128] = ACTIONS(2353),
    [anon_sym_i128] = ACTIONS(2353),
    [anon_sym_isize] = ACTIONS(2353),
    [anon_sym_usize] = ACTIONS(2353),
    [anon_sym_f32] = ACTIONS(2353),
    [anon_sym_f64] = ACTIONS(2353),
    [anon_sym_bool] = ACTIONS(2353),
    [anon_sym_str] = ACTIONS(2353),
    [anon_sym_char] = ACTIONS(2353),
    [anon_sym__] = ACTIONS(3568),
    [anon_sym_AMP] = ACTIONS(2355),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_DOT] = ACTIONS(3568),
    [anon_sym_DASH_EQ] = ACTIONS(3566),
    [anon_sym_DASH_GT] = ACTIONS(3566),
    [anon_sym_COLON_COLON] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(2357),
    [anon_sym_BANG_EQ] = ACTIONS(3566),
    [anon_sym_AT] = ACTIONS(3566),
    [anon_sym_STAR_EQ] = ACTIONS(3566),
    [anon_sym_SLASH] = ACTIONS(3568),
    [anon_sym_SLASH_EQ] = ACTIONS(3566),
    [anon_sym_AMP_AMP] = ACTIONS(3566),
    [anon_sym_AMP_EQ] = ACTIONS(3566),
    [anon_sym_POUND] = ACTIONS(2359),
    [anon_sym_PERCENT] = ACTIONS(3568),
    [anon_sym_PERCENT_EQ] = ACTIONS(3566),
    [anon_sym_CARET] = ACTIONS(3568),
    [anon_sym_CARET_EQ] = ACTIONS(3566),
    [anon_sym_PLUS_EQ] = ACTIONS(3566),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_LT_LT] = ACTIONS(3568),
    [anon_sym_LT_LT_EQ] = ACTIONS(3566),
    [anon_sym_LT_EQ] = ACTIONS(3566),
    [anon_sym_EQ] = ACTIONS(3568),
    [anon_sym_EQ_EQ] = ACTIONS(3566),
    [anon_sym_GT] = ACTIONS(3568),
    [anon_sym_GT_EQ] = ACTIONS(3566),
    [anon_sym_GT_GT] = ACTIONS(3568),
    [anon_sym_GT_GT_EQ] = ACTIONS(3566),
    [anon_sym_PIPE] = ACTIONS(2301),
    [anon_sym_PIPE_EQ] = ACTIONS(3566),
    [anon_sym_PIPE_PIPE] = ACTIONS(3566),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3566),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(2361),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3566),
    [anon_sym_as] = ACTIONS(3568),
    [anon_sym_break] = ACTIONS(2363),
    [anon_sym_const] = ACTIONS(2365),
    [anon_sym_continue] = ACTIONS(2367),
    [anon_sym_default] = ACTIONS(2369),
    [anon_sym_enum] = ACTIONS(2371),
    [anon_sym_fn] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2375),
    [anon_sym_if] = ACTIONS(2377),
    [anon_sym_impl] = ACTIONS(2379),
    [anon_sym_let] = ACTIONS(2381),
    [anon_sym_loop] = ACTIONS(2383),
    [anon_sym_match] = ACTIONS(2385),
    [anon_sym_mod] = ACTIONS(2387),
    [anon_sym_pub] = ACTIONS(2389),
    [anon_sym_return] = ACTIONS(2391),
    [anon_sym_static] = ACTIONS(2393),
    [anon_sym_struct] = ACTIONS(2395),
    [anon_sym_trait] = ACTIONS(2397),
    [anon_sym_type] = ACTIONS(2399),
    [anon_sym_union] = ACTIONS(2401),
    [anon_sym_unsafe] = ACTIONS(2403),
    [anon_sym_use] = ACTIONS(2405),
    [anon_sym_where] = ACTIONS(3568),
    [anon_sym_while] = ACTIONS(2407),
    [anon_sym_extern] = ACTIONS(85),
    [sym_mutable_specifier] = ACTIONS(3568),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(2337),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(2337),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2409),
    [sym_self] = ACTIONS(2411),
    [sym_super] = ACTIONS(3568),
    [sym_crate] = ACTIONS(3568),
    [sym_metavariable] = ACTIONS(2413),
  },
  [1183] = {
    [sym_token_tree] = STATE(1866),
    [sym_token_repetition] = STATE(1866),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1885),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1885),
    [sym_macro_invocation] = STATE(1885),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1885),
    [sym_unary_expression] = STATE(1885),
    [sym_try_expression] = STATE(1885),
    [sym_reference_expression] = STATE(1885),
    [sym_binary_expression] = STATE(1885),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1885),
    [sym_call_expression] = STATE(1885),
    [sym_array_expression] = STATE(1885),
    [sym_parenthesized_expression] = STATE(1885),
    [sym_tuple_expression] = STATE(1885),
    [sym_unit_expression] = STATE(1885),
    [sym_struct_expression] = STATE(1885),
    [sym_if_expression] = STATE(1885),
    [sym_if_let_expression] = STATE(1885),
    [sym_match_expression] = STATE(1885),
    [sym_while_expression] = STATE(1885),
    [sym_while_let_expression] = STATE(1885),
    [sym_loop_expression] = STATE(1885),
    [sym_for_expression] = STATE(1885),
    [sym_closure_expression] = STATE(1885),
    [sym_closure_parameters] = STATE(101),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1885),
    [sym_continue_expression] = STATE(1885),
    [sym_index_expression] = STATE(1885),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1885),
    [sym_block] = STATE(1885),
    [sym__literal] = STATE(1865),
    [sym_string_literal] = STATE(1865),
    [sym_boolean_literal] = STATE(1865),
    [aux_sym_token_tree_repeat1] = STATE(1866),
    [sym_raw_string_literal] = ACTIONS(3570),
    [sym_float_literal] = ACTIONS(3570),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3572),
    [anon_sym_LPAREN] = ACTIONS(3574),
    [anon_sym_LBRACE] = ACTIONS(3576),
    [anon_sym_EQ_GT] = ACTIONS(3572),
    [anon_sym_LBRACK] = ACTIONS(3578),
    [anon_sym_RBRACK] = ACTIONS(3984),
    [anon_sym_COLON] = ACTIONS(3582),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(3584),
    [anon_sym_COMMA] = ACTIONS(3586),
    [anon_sym_u8] = ACTIONS(3588),
    [anon_sym_i8] = ACTIONS(3588),
    [anon_sym_u16] = ACTIONS(3588),
    [anon_sym_i16] = ACTIONS(3588),
    [anon_sym_u32] = ACTIONS(3588),
    [anon_sym_i32] = ACTIONS(3588),
    [anon_sym_u64] = ACTIONS(3588),
    [anon_sym_i64] = ACTIONS(3588),
    [anon_sym_u128] = ACTIONS(3588),
    [anon_sym_i128] = ACTIONS(3588),
    [anon_sym_isize] = ACTIONS(3588),
    [anon_sym_usize] = ACTIONS(3588),
    [anon_sym_f32] = ACTIONS(3588),
    [anon_sym_f64] = ACTIONS(3588),
    [anon_sym_bool] = ACTIONS(3588),
    [anon_sym_str] = ACTIONS(3588),
    [anon_sym_char] = ACTIONS(3588),
    [anon_sym__] = ACTIONS(3582),
    [anon_sym_AMP] = ACTIONS(3590),
    [anon_sym_DASH] = ACTIONS(3584),
    [anon_sym_DOT] = ACTIONS(3582),
    [anon_sym_DASH_EQ] = ACTIONS(3572),
    [anon_sym_DASH_GT] = ACTIONS(3572),
    [anon_sym_COLON_COLON] = ACTIONS(3572),
    [anon_sym_BANG] = ACTIONS(3592),
    [anon_sym_BANG_EQ] = ACTIONS(3572),
    [anon_sym_AT] = ACTIONS(3572),
    [anon_sym_STAR_EQ] = ACTIONS(3572),
    [anon_sym_SLASH] = ACTIONS(3582),
    [anon_sym_SLASH_EQ] = ACTIONS(3572),
    [anon_sym_AMP_AMP] = ACTIONS(3572),
    [anon_sym_AMP_EQ] = ACTIONS(3572),
    [anon_sym_POUND] = ACTIONS(3572),
    [anon_sym_PERCENT] = ACTIONS(3582),
    [anon_sym_PERCENT_EQ] = ACTIONS(3572),
    [anon_sym_CARET] = ACTIONS(3582),
    [anon_sym_CARET_EQ] = ACTIONS(3572),
    [anon_sym_PLUS_EQ] = ACTIONS(3572),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_LT_LT] = ACTIONS(3582),
    [anon_sym_LT_LT_EQ] = ACTIONS(3572),
    [anon_sym_LT_EQ] = ACTIONS(3572),
    [anon_sym_EQ] = ACTIONS(3582),
    [anon_sym_EQ_EQ] = ACTIONS(3572),
    [anon_sym_GT] = ACTIONS(3582),
    [anon_sym_GT_EQ] = ACTIONS(3572),
    [anon_sym_GT_GT] = ACTIONS(3582),
    [anon_sym_GT_GT_EQ] = ACTIONS(3572),
    [anon_sym_PIPE] = ACTIONS(2301),
    [anon_sym_PIPE_EQ] = ACTIONS(3572),
    [anon_sym_PIPE_PIPE] = ACTIONS(3572),
    [anon_sym_TILDE] = ACTIONS(3572),
    [anon_sym_QMARK] = ACTIONS(3572),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(3594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3572),
    [anon_sym_as] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3596),
    [anon_sym_const] = ACTIONS(3582),
    [anon_sym_continue] = ACTIONS(3598),
    [anon_sym_default] = ACTIONS(3600),
    [anon_sym_enum] = ACTIONS(3582),
    [anon_sym_fn] = ACTIONS(3582),
    [anon_sym_for] = ACTIONS(2313),
    [anon_sym_if] = ACTIONS(3602),
    [anon_sym_impl] = ACTIONS(3582),
    [anon_sym_let] = ACTIONS(3582),
    [anon_sym_loop] = ACTIONS(2317),
    [anon_sym_match] = ACTIONS(2319),
    [anon_sym_mod] = ACTIONS(3582),
    [anon_sym_pub] = ACTIONS(3582),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_struct] = ACTIONS(3582),
    [anon_sym_trait] = ACTIONS(3582),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_union] = ACTIONS(3600),
    [anon_sym_unsafe] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(3582),
    [anon_sym_where] = ACTIONS(3582),
    [anon_sym_while] = ACTIONS(2325),
    [sym_mutable_specifier] = ACTIONS(3582),
    [anon_sym_move] = ACTIONS(171),
    [sym_integer_literal] = ACTIONS(3570),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(3570),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3606),
    [sym_self] = ACTIONS(3608),
    [sym_super] = ACTIONS(3582),
    [sym_crate] = ACTIONS(3582),
    [sym_metavariable] = ACTIONS(3610),
  },
  [1184] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(103),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(103),
    [sym_macro_invocation] = STATE(103),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(103),
    [sym_unary_expression] = STATE(103),
    [sym_try_expression] = STATE(103),
    [sym_reference_expression] = STATE(103),
    [sym_binary_expression] = STATE(103),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(103),
    [sym_call_expression] = STATE(103),
    [sym_array_expression] = STATE(103),
    [sym_parenthesized_expression] = STATE(103),
    [sym_tuple_expression] = STATE(103),
    [sym_unit_expression] = STATE(103),
    [sym_struct_expression] = STATE(103),
    [sym_if_expression] = STATE(103),
    [sym_if_let_expression] = STATE(103),
    [sym_match_expression] = STATE(103),
    [sym_while_expression] = STATE(103),
    [sym_while_let_expression] = STATE(103),
    [sym_loop_expression] = STATE(103),
    [sym_for_expression] = STATE(103),
    [sym_closure_expression] = STATE(103),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(103),
    [sym_continue_expression] = STATE(103),
    [sym_index_expression] = STATE(103),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(103),
    [sym_block] = STATE(103),
    [sym__literal] = STATE(103),
    [sym_string_literal] = STATE(103),
    [sym_boolean_literal] = STATE(103),
    [sym_raw_string_literal] = ACTIONS(3614),
    [sym_float_literal] = ACTIONS(3614),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3619),
    [anon_sym_LBRACE] = ACTIONS(3622),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3625),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3986),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3633),
    [anon_sym_i8] = ACTIONS(3633),
    [anon_sym_u16] = ACTIONS(3633),
    [anon_sym_i16] = ACTIONS(3633),
    [anon_sym_u32] = ACTIONS(3633),
    [anon_sym_i32] = ACTIONS(3633),
    [anon_sym_u64] = ACTIONS(3633),
    [anon_sym_i64] = ACTIONS(3633),
    [anon_sym_u128] = ACTIONS(3633),
    [anon_sym_i128] = ACTIONS(3633),
    [anon_sym_isize] = ACTIONS(3633),
    [anon_sym_usize] = ACTIONS(3633),
    [anon_sym_f32] = ACTIONS(3633),
    [anon_sym_f64] = ACTIONS(3633),
    [anon_sym_bool] = ACTIONS(3633),
    [anon_sym_str] = ACTIONS(3633),
    [anon_sym_char] = ACTIONS(3633),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3989),
    [anon_sym_DASH] = ACTIONS(3986),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3639),
    [anon_sym_BANG] = ACTIONS(3986),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3645),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DOT_DOT] = ACTIONS(3992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3657),
    [anon_sym_default] = ACTIONS(3660),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3663),
    [anon_sym_if] = ACTIONS(3995),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3669),
    [anon_sym_match] = ACTIONS(3672),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3998),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3660),
    [anon_sym_unsafe] = ACTIONS(3678),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3681),
    [sym_mutable_specifier] = ACTIONS(3628),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(3614),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3684),
    [sym_char_literal] = ACTIONS(3614),
    [anon_sym_true] = ACTIONS(3687),
    [anon_sym_false] = ACTIONS(3687),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3690),
    [sym_self] = ACTIONS(3693),
    [sym_super] = ACTIONS(3696),
    [sym_crate] = ACTIONS(3696),
    [sym_metavariable] = ACTIONS(3699),
  },
  [1185] = {
    [sym_raw_string_literal] = ACTIONS(3702),
    [sym_float_literal] = ACTIONS(3702),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3704),
    [anon_sym_LPAREN] = ACTIONS(3704),
    [anon_sym_LBRACE] = ACTIONS(3702),
    [anon_sym_RBRACE] = ACTIONS(3704),
    [anon_sym_EQ_GT] = ACTIONS(3702),
    [anon_sym_LBRACK] = ACTIONS(3704),
    [anon_sym_COLON] = ACTIONS(3707),
    [anon_sym_DOLLAR] = ACTIONS(3707),
    [anon_sym_PLUS] = ACTIONS(3709),
    [anon_sym_STAR] = ACTIONS(3709),
    [anon_sym_COMMA] = ACTIONS(3702),
    [anon_sym_u8] = ACTIONS(3707),
    [anon_sym_i8] = ACTIONS(3707),
    [anon_sym_u16] = ACTIONS(3707),
    [anon_sym_i16] = ACTIONS(3707),
    [anon_sym_u32] = ACTIONS(3707),
    [anon_sym_i32] = ACTIONS(3707),
    [anon_sym_u64] = ACTIONS(3707),
    [anon_sym_i64] = ACTIONS(3707),
    [anon_sym_u128] = ACTIONS(3707),
    [anon_sym_i128] = ACTIONS(3707),
    [anon_sym_isize] = ACTIONS(3707),
    [anon_sym_usize] = ACTIONS(3707),
    [anon_sym_f32] = ACTIONS(3707),
    [anon_sym_f64] = ACTIONS(3707),
    [anon_sym_bool] = ACTIONS(3707),
    [anon_sym_str] = ACTIONS(3707),
    [anon_sym_char] = ACTIONS(3707),
    [anon_sym__] = ACTIONS(3707),
    [anon_sym_AMP] = ACTIONS(3709),
    [anon_sym_DASH] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3704),
    [anon_sym_DASH_GT] = ACTIONS(3702),
    [anon_sym_COLON_COLON] = ACTIONS(3702),
    [anon_sym_BANG] = ACTIONS(3707),
    [anon_sym_BANG_EQ] = ACTIONS(3704),
    [anon_sym_AT] = ACTIONS(3702),
    [anon_sym_STAR_EQ] = ACTIONS(3704),
    [anon_sym_SLASH] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3704),
    [anon_sym_AMP_AMP] = ACTIONS(3704),
    [anon_sym_AMP_EQ] = ACTIONS(3704),
    [anon_sym_POUND] = ACTIONS(3702),
    [anon_sym_PERCENT] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3704),
    [anon_sym_CARET] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3704),
    [anon_sym_PLUS_EQ] = ACTIONS(3704),
    [anon_sym_LT] = ACTIONS(3709),
    [anon_sym_LT_LT] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3704),
    [anon_sym_LT_EQ] = ACTIONS(3704),
    [anon_sym_EQ] = ACTIONS(3709),
    [anon_sym_EQ_EQ] = ACTIONS(3704),
    [anon_sym_GT] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3704),
    [anon_sym_GT_GT] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3704),
    [anon_sym_PIPE] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3704),
    [anon_sym_PIPE_PIPE] = ACTIONS(3704),
    [anon_sym_TILDE] = ACTIONS(3702),
    [anon_sym_QMARK] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(3707),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3704),
    [anon_sym_as] = ACTIONS(3709),
    [anon_sym_break] = ACTIONS(3707),
    [anon_sym_const] = ACTIONS(3707),
    [anon_sym_continue] = ACTIONS(3707),
    [anon_sym_default] = ACTIONS(3707),
    [anon_sym_enum] = ACTIONS(3707),
    [anon_sym_fn] = ACTIONS(3707),
    [anon_sym_for] = ACTIONS(3707),
    [anon_sym_if] = ACTIONS(3707),
    [anon_sym_impl] = ACTIONS(3707),
    [anon_sym_let] = ACTIONS(3707),
    [anon_sym_loop] = ACTIONS(3707),
    [anon_sym_match] = ACTIONS(3707),
    [anon_sym_mod] = ACTIONS(3707),
    [anon_sym_pub] = ACTIONS(3707),
    [anon_sym_return] = ACTIONS(3707),
    [anon_sym_static] = ACTIONS(3707),
    [anon_sym_struct] = ACTIONS(3707),
    [anon_sym_trait] = ACTIONS(3707),
    [anon_sym_type] = ACTIONS(3707),
    [anon_sym_union] = ACTIONS(3707),
    [anon_sym_unsafe] = ACTIONS(3707),
    [anon_sym_use] = ACTIONS(3707),
    [anon_sym_where] = ACTIONS(3707),
    [anon_sym_while] = ACTIONS(3707),
    [sym_mutable_specifier] = ACTIONS(3707),
    [sym_integer_literal] = ACTIONS(3702),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3702),
    [sym_char_literal] = ACTIONS(3702),
    [anon_sym_true] = ACTIONS(3707),
    [anon_sym_false] = ACTIONS(3707),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3707),
    [sym_self] = ACTIONS(3707),
    [sym_super] = ACTIONS(3707),
    [sym_crate] = ACTIONS(3707),
    [sym_metavariable] = ACTIONS(3702),
  },
  [1186] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(106),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(106),
    [sym_macro_invocation] = STATE(106),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(106),
    [sym_unary_expression] = STATE(106),
    [sym_try_expression] = STATE(106),
    [sym_reference_expression] = STATE(106),
    [sym_binary_expression] = STATE(106),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(106),
    [sym_call_expression] = STATE(106),
    [sym_array_expression] = STATE(106),
    [sym_parenthesized_expression] = STATE(106),
    [sym_tuple_expression] = STATE(106),
    [sym_unit_expression] = STATE(106),
    [sym_struct_expression] = STATE(106),
    [sym_if_expression] = STATE(106),
    [sym_if_let_expression] = STATE(106),
    [sym_match_expression] = STATE(106),
    [sym_while_expression] = STATE(106),
    [sym_while_let_expression] = STATE(106),
    [sym_loop_expression] = STATE(106),
    [sym_for_expression] = STATE(106),
    [sym_closure_expression] = STATE(106),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(106),
    [sym_continue_expression] = STATE(106),
    [sym_index_expression] = STATE(106),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(106),
    [sym_block] = STATE(106),
    [sym__literal] = STATE(106),
    [sym_string_literal] = STATE(106),
    [sym_boolean_literal] = STATE(106),
    [sym_raw_string_literal] = ACTIONS(3712),
    [sym_float_literal] = ACTIONS(3712),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3619),
    [anon_sym_LBRACE] = ACTIONS(3622),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3625),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3986),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3633),
    [anon_sym_i8] = ACTIONS(3633),
    [anon_sym_u16] = ACTIONS(3633),
    [anon_sym_i16] = ACTIONS(3633),
    [anon_sym_u32] = ACTIONS(3633),
    [anon_sym_i32] = ACTIONS(3633),
    [anon_sym_u64] = ACTIONS(3633),
    [anon_sym_i64] = ACTIONS(3633),
    [anon_sym_u128] = ACTIONS(3633),
    [anon_sym_i128] = ACTIONS(3633),
    [anon_sym_isize] = ACTIONS(3633),
    [anon_sym_usize] = ACTIONS(3633),
    [anon_sym_f32] = ACTIONS(3633),
    [anon_sym_f64] = ACTIONS(3633),
    [anon_sym_bool] = ACTIONS(3633),
    [anon_sym_str] = ACTIONS(3633),
    [anon_sym_char] = ACTIONS(3633),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3989),
    [anon_sym_DASH] = ACTIONS(3986),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3639),
    [anon_sym_BANG] = ACTIONS(3986),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3645),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DOT_DOT] = ACTIONS(3992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3657),
    [anon_sym_default] = ACTIONS(3660),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3663),
    [anon_sym_if] = ACTIONS(3995),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3669),
    [anon_sym_match] = ACTIONS(3672),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3998),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3660),
    [anon_sym_unsafe] = ACTIONS(3678),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3681),
    [sym_mutable_specifier] = ACTIONS(4001),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(3712),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3684),
    [sym_char_literal] = ACTIONS(3712),
    [anon_sym_true] = ACTIONS(3687),
    [anon_sym_false] = ACTIONS(3687),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3690),
    [sym_self] = ACTIONS(3693),
    [sym_super] = ACTIONS(3696),
    [sym_crate] = ACTIONS(3696),
    [sym_metavariable] = ACTIONS(3699),
  },
  [1187] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(103),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(103),
    [sym_macro_invocation] = STATE(103),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(103),
    [sym_unary_expression] = STATE(103),
    [sym_try_expression] = STATE(103),
    [sym_reference_expression] = STATE(103),
    [sym_binary_expression] = STATE(103),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(103),
    [sym_call_expression] = STATE(103),
    [sym_array_expression] = STATE(103),
    [sym_parenthesized_expression] = STATE(103),
    [sym_tuple_expression] = STATE(103),
    [sym_unit_expression] = STATE(103),
    [sym_struct_expression] = STATE(103),
    [sym_if_expression] = STATE(103),
    [sym_if_let_expression] = STATE(103),
    [sym_match_expression] = STATE(103),
    [sym_while_expression] = STATE(103),
    [sym_while_let_expression] = STATE(103),
    [sym_loop_expression] = STATE(103),
    [sym_for_expression] = STATE(103),
    [sym_closure_expression] = STATE(103),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(103),
    [sym_continue_expression] = STATE(103),
    [sym_index_expression] = STATE(103),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(103),
    [sym_block] = STATE(103),
    [sym__literal] = STATE(103),
    [sym_string_literal] = STATE(103),
    [sym_boolean_literal] = STATE(103),
    [sym_raw_string_literal] = ACTIONS(173),
    [sym_float_literal] = ACTIONS(173),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(4004),
    [anon_sym_DASH] = ACTIONS(607),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3720),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3722),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(4006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(601),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(133),
    [sym_mutable_specifier] = ACTIONS(3628),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(173),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(173),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1188] = {
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(4008),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3628),
    [anon_sym_DASH] = ACTIONS(3628),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(4011),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3628),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3628),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3628),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1189] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(310),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(310),
    [sym_macro_invocation] = STATE(310),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(310),
    [sym_unary_expression] = STATE(310),
    [sym_try_expression] = STATE(310),
    [sym_reference_expression] = STATE(310),
    [sym_binary_expression] = STATE(310),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(310),
    [sym_call_expression] = STATE(310),
    [sym_array_expression] = STATE(310),
    [sym_parenthesized_expression] = STATE(310),
    [sym_tuple_expression] = STATE(310),
    [sym_unit_expression] = STATE(310),
    [sym_struct_expression] = STATE(310),
    [sym_if_expression] = STATE(310),
    [sym_if_let_expression] = STATE(310),
    [sym_match_expression] = STATE(310),
    [sym_while_expression] = STATE(310),
    [sym_while_let_expression] = STATE(310),
    [sym_loop_expression] = STATE(310),
    [sym_for_expression] = STATE(310),
    [sym_closure_expression] = STATE(310),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(310),
    [sym_continue_expression] = STATE(310),
    [sym_index_expression] = STATE(310),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(310),
    [sym_block] = STATE(310),
    [sym__literal] = STATE(310),
    [sym_string_literal] = STATE(310),
    [sym_boolean_literal] = STATE(310),
    [sym_raw_string_literal] = ACTIONS(605),
    [sym_float_literal] = ACTIONS(605),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(261),
    [anon_sym_LPAREN] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(261),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(263),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(263),
    [anon_sym_DASH] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(263),
    [anon_sym_DASH_EQ] = ACTIONS(261),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(607),
    [anon_sym_BANG_EQ] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(261),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_SLASH_EQ] = ACTIONS(261),
    [anon_sym_AMP_AMP] = ACTIONS(261),
    [anon_sym_AMP_EQ] = ACTIONS(261),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(263),
    [anon_sym_PERCENT_EQ] = ACTIONS(261),
    [anon_sym_CARET] = ACTIONS(263),
    [anon_sym_CARET_EQ] = ACTIONS(261),
    [anon_sym_PLUS_EQ] = ACTIONS(261),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_EQ] = ACTIONS(261),
    [anon_sym_LT_EQ] = ACTIONS(261),
    [anon_sym_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(261),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_EQ] = ACTIONS(261),
    [anon_sym_GT_GT] = ACTIONS(263),
    [anon_sym_GT_GT_EQ] = ACTIONS(261),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_PIPE_EQ] = ACTIONS(261),
    [anon_sym_PIPE_PIPE] = ACTIONS(261),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(263),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(261),
    [anon_sym_as] = ACTIONS(263),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(601),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(133),
    [sym_mutable_specifier] = ACTIONS(3628),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(605),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(605),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1190] = {
    [sym_loop_label] = STATE(156),
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3816),
    [anon_sym_LPAREN] = ACTIONS(3816),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_RBRACE] = ACTIONS(3816),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3816),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3819),
    [anon_sym_STAR] = ACTIONS(3819),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3819),
    [anon_sym_DASH] = ACTIONS(3819),
    [anon_sym_DOT] = ACTIONS(3819),
    [anon_sym_DASH_EQ] = ACTIONS(3816),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3816),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3816),
    [anon_sym_SLASH] = ACTIONS(3819),
    [anon_sym_SLASH_EQ] = ACTIONS(3816),
    [anon_sym_AMP_AMP] = ACTIONS(3816),
    [anon_sym_AMP_EQ] = ACTIONS(3816),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3819),
    [anon_sym_PERCENT_EQ] = ACTIONS(3816),
    [anon_sym_CARET] = ACTIONS(3819),
    [anon_sym_CARET_EQ] = ACTIONS(3816),
    [anon_sym_PLUS_EQ] = ACTIONS(3816),
    [anon_sym_LT] = ACTIONS(3819),
    [anon_sym_LT_LT] = ACTIONS(3819),
    [anon_sym_LT_LT_EQ] = ACTIONS(3816),
    [anon_sym_LT_EQ] = ACTIONS(3816),
    [anon_sym_EQ] = ACTIONS(3819),
    [anon_sym_EQ_EQ] = ACTIONS(3816),
    [anon_sym_GT] = ACTIONS(3819),
    [anon_sym_GT_EQ] = ACTIONS(3816),
    [anon_sym_GT_GT] = ACTIONS(3819),
    [anon_sym_GT_GT_EQ] = ACTIONS(3816),
    [anon_sym_PIPE] = ACTIONS(3819),
    [anon_sym_PIPE_EQ] = ACTIONS(3816),
    [anon_sym_PIPE_PIPE] = ACTIONS(3816),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3816),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DOT_DOT] = ACTIONS(3819),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3816),
    [anon_sym_as] = ACTIONS(3819),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3628),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1191] = {
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3628),
    [anon_sym_DASH] = ACTIONS(3628),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3628),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3628),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(4014),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(4014),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(4014),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(4014),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [anon_sym_extern] = ACTIONS(273),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4017),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1192] = {
    [sym_loop_label] = STATE(158),
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3822),
    [anon_sym_LPAREN] = ACTIONS(3822),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_RBRACE] = ACTIONS(3822),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3822),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3825),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3825),
    [anon_sym_DASH_EQ] = ACTIONS(3822),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3822),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3822),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_SLASH_EQ] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(3822),
    [anon_sym_AMP_EQ] = ACTIONS(3822),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3825),
    [anon_sym_PERCENT_EQ] = ACTIONS(3822),
    [anon_sym_CARET] = ACTIONS(3825),
    [anon_sym_CARET_EQ] = ACTIONS(3822),
    [anon_sym_PLUS_EQ] = ACTIONS(3822),
    [anon_sym_LT] = ACTIONS(3825),
    [anon_sym_LT_LT] = ACTIONS(3825),
    [anon_sym_LT_LT_EQ] = ACTIONS(3822),
    [anon_sym_LT_EQ] = ACTIONS(3822),
    [anon_sym_EQ] = ACTIONS(3825),
    [anon_sym_EQ_EQ] = ACTIONS(3822),
    [anon_sym_GT] = ACTIONS(3825),
    [anon_sym_GT_EQ] = ACTIONS(3822),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_EQ] = ACTIONS(3822),
    [anon_sym_PIPE] = ACTIONS(3825),
    [anon_sym_PIPE_EQ] = ACTIONS(3822),
    [anon_sym_PIPE_PIPE] = ACTIONS(3822),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3822),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DOT_DOT] = ACTIONS(3825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3822),
    [anon_sym_as] = ACTIONS(3825),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3628),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1193] = {
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3828),
    [anon_sym_LPAREN] = ACTIONS(3828),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_RBRACE] = ACTIONS(3828),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3828),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3831),
    [anon_sym_STAR] = ACTIONS(3831),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3831),
    [anon_sym_DASH] = ACTIONS(3831),
    [anon_sym_DOT] = ACTIONS(3831),
    [anon_sym_DASH_EQ] = ACTIONS(3828),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3828),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3828),
    [anon_sym_SLASH] = ACTIONS(3831),
    [anon_sym_SLASH_EQ] = ACTIONS(3828),
    [anon_sym_AMP_AMP] = ACTIONS(3828),
    [anon_sym_AMP_EQ] = ACTIONS(3828),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3831),
    [anon_sym_PERCENT_EQ] = ACTIONS(3828),
    [anon_sym_CARET] = ACTIONS(3831),
    [anon_sym_CARET_EQ] = ACTIONS(3828),
    [anon_sym_PLUS_EQ] = ACTIONS(3828),
    [anon_sym_LT] = ACTIONS(3831),
    [anon_sym_LT_LT] = ACTIONS(3831),
    [anon_sym_LT_LT_EQ] = ACTIONS(3828),
    [anon_sym_LT_EQ] = ACTIONS(3828),
    [anon_sym_EQ] = ACTIONS(3831),
    [anon_sym_EQ_EQ] = ACTIONS(3828),
    [anon_sym_GT] = ACTIONS(3831),
    [anon_sym_GT_EQ] = ACTIONS(3828),
    [anon_sym_GT_GT] = ACTIONS(3831),
    [anon_sym_GT_GT_EQ] = ACTIONS(3828),
    [anon_sym_PIPE] = ACTIONS(3831),
    [anon_sym_PIPE_EQ] = ACTIONS(3828),
    [anon_sym_PIPE_PIPE] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3828),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3831),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3828),
    [anon_sym_as] = ACTIONS(3831),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(4014),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(4014),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(4014),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(4014),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [anon_sym_extern] = ACTIONS(273),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3628),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1194] = {
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3628),
    [anon_sym_DASH] = ACTIONS(3628),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3628),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3628),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4020),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1195] = {
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3628),
    [anon_sym_DASH] = ACTIONS(3628),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3628),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3628),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4023),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(4026),
  },
  [1196] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(166),
    [sym_tuple_pattern] = STATE(166),
    [sym_tuple_struct_pattern] = STATE(166),
    [sym_struct_pattern] = STATE(166),
    [sym_remaining_field_pattern] = STATE(166),
    [sym_mut_pattern] = STATE(166),
    [sym_ref_pattern] = STATE(166),
    [sym_captured_pattern] = STATE(166),
    [sym_reference_pattern] = STATE(166),
    [sym__literal] = STATE(166),
    [sym_string_literal] = STATE(166),
    [sym_boolean_literal] = STATE(166),
    [sym_raw_string_literal] = ACTIONS(4029),
    [sym_float_literal] = ACTIONS(4029),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3768),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3837),
    [anon_sym_i8] = ACTIONS(3837),
    [anon_sym_u16] = ACTIONS(3837),
    [anon_sym_i16] = ACTIONS(3837),
    [anon_sym_u32] = ACTIONS(3837),
    [anon_sym_i32] = ACTIONS(3837),
    [anon_sym_u64] = ACTIONS(3837),
    [anon_sym_i64] = ACTIONS(3837),
    [anon_sym_u128] = ACTIONS(3837),
    [anon_sym_i128] = ACTIONS(3837),
    [anon_sym_isize] = ACTIONS(3837),
    [anon_sym_usize] = ACTIONS(3837),
    [anon_sym_f32] = ACTIONS(3837),
    [anon_sym_f64] = ACTIONS(3837),
    [anon_sym_bool] = ACTIONS(3837),
    [anon_sym_str] = ACTIONS(3837),
    [anon_sym_char] = ACTIONS(3837),
    [anon_sym__] = ACTIONS(4032),
    [anon_sym_AMP] = ACTIONS(3843),
    [anon_sym_DASH] = ACTIONS(3628),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3628),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3846),
    [anon_sym_ref] = ACTIONS(297),
    [sym_integer_literal] = ACTIONS(4029),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3684),
    [sym_char_literal] = ACTIONS(4029),
    [anon_sym_true] = ACTIONS(3687),
    [anon_sym_false] = ACTIONS(3687),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3849),
    [sym_self] = ACTIONS(3807),
    [sym_super] = ACTIONS(3807),
    [sym_crate] = ACTIONS(3807),
    [sym_metavariable] = ACTIONS(3810),
  },
  [1197] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(312),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(312),
    [sym_macro_invocation] = STATE(312),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(312),
    [sym_unary_expression] = STATE(312),
    [sym_try_expression] = STATE(312),
    [sym_reference_expression] = STATE(312),
    [sym_binary_expression] = STATE(312),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(312),
    [sym_call_expression] = STATE(312),
    [sym_array_expression] = STATE(312),
    [sym_parenthesized_expression] = STATE(312),
    [sym_tuple_expression] = STATE(312),
    [sym_unit_expression] = STATE(312),
    [sym_struct_expression] = STATE(312),
    [sym_if_expression] = STATE(312),
    [sym_if_let_expression] = STATE(312),
    [sym_match_expression] = STATE(312),
    [sym_while_expression] = STATE(312),
    [sym_while_let_expression] = STATE(312),
    [sym_loop_expression] = STATE(312),
    [sym_for_expression] = STATE(312),
    [sym_closure_expression] = STATE(312),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(312),
    [sym_continue_expression] = STATE(312),
    [sym_index_expression] = STATE(312),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(312),
    [sym_block] = STATE(312),
    [sym__literal] = STATE(312),
    [sym_string_literal] = STATE(312),
    [sym_boolean_literal] = STATE(312),
    [sym_raw_string_literal] = ACTIONS(4035),
    [sym_float_literal] = ACTIONS(4035),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3619),
    [anon_sym_LBRACE] = ACTIONS(3622),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3625),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3855),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3858),
    [anon_sym_i8] = ACTIONS(3858),
    [anon_sym_u16] = ACTIONS(3858),
    [anon_sym_i16] = ACTIONS(3858),
    [anon_sym_u32] = ACTIONS(3858),
    [anon_sym_i32] = ACTIONS(3858),
    [anon_sym_u64] = ACTIONS(3858),
    [anon_sym_i64] = ACTIONS(3858),
    [anon_sym_u128] = ACTIONS(3858),
    [anon_sym_i128] = ACTIONS(3858),
    [anon_sym_isize] = ACTIONS(3858),
    [anon_sym_usize] = ACTIONS(3858),
    [anon_sym_f32] = ACTIONS(3858),
    [anon_sym_f64] = ACTIONS(3858),
    [anon_sym_bool] = ACTIONS(3858),
    [anon_sym_str] = ACTIONS(3858),
    [anon_sym_char] = ACTIONS(3858),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3861),
    [anon_sym_DASH] = ACTIONS(3855),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3864),
    [anon_sym_BANG] = ACTIONS(3855),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3645),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DOT_DOT] = ACTIONS(3867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3657),
    [anon_sym_default] = ACTIONS(3660),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3663),
    [anon_sym_if] = ACTIONS(3870),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(4038),
    [anon_sym_loop] = ACTIONS(3669),
    [anon_sym_match] = ACTIONS(3672),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3876),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3660),
    [anon_sym_unsafe] = ACTIONS(3678),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3681),
    [sym_mutable_specifier] = ACTIONS(3628),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(4035),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3684),
    [sym_char_literal] = ACTIONS(4035),
    [anon_sym_true] = ACTIONS(3687),
    [anon_sym_false] = ACTIONS(3687),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3879),
    [sym_self] = ACTIONS(3882),
    [sym_super] = ACTIONS(3885),
    [sym_crate] = ACTIONS(3885),
    [sym_metavariable] = ACTIONS(3888),
  },
  [1198] = {
    [sym_type_parameters] = STATE(186),
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(187),
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(4041),
    [anon_sym_i8] = ACTIONS(4041),
    [anon_sym_u16] = ACTIONS(4041),
    [anon_sym_i16] = ACTIONS(4041),
    [anon_sym_u32] = ACTIONS(4041),
    [anon_sym_i32] = ACTIONS(4041),
    [anon_sym_u64] = ACTIONS(4041),
    [anon_sym_i64] = ACTIONS(4041),
    [anon_sym_u128] = ACTIONS(4041),
    [anon_sym_i128] = ACTIONS(4041),
    [anon_sym_isize] = ACTIONS(4041),
    [anon_sym_usize] = ACTIONS(4041),
    [anon_sym_f32] = ACTIONS(4041),
    [anon_sym_f64] = ACTIONS(4041),
    [anon_sym_bool] = ACTIONS(4041),
    [anon_sym_str] = ACTIONS(4041),
    [anon_sym_char] = ACTIONS(4041),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3628),
    [anon_sym_DASH] = ACTIONS(3628),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(4044),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3628),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4047),
    [sym_self] = ACTIONS(3759),
    [sym_super] = ACTIONS(3759),
    [sym_crate] = ACTIONS(3759),
    [sym_metavariable] = ACTIONS(4050),
  },
  [1199] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(192),
    [sym_tuple_pattern] = STATE(192),
    [sym_tuple_struct_pattern] = STATE(192),
    [sym_struct_pattern] = STATE(192),
    [sym_remaining_field_pattern] = STATE(192),
    [sym_mut_pattern] = STATE(192),
    [sym_ref_pattern] = STATE(192),
    [sym_captured_pattern] = STATE(192),
    [sym_reference_pattern] = STATE(192),
    [sym__literal] = STATE(192),
    [sym_string_literal] = STATE(192),
    [sym_boolean_literal] = STATE(192),
    [sym_raw_string_literal] = ACTIONS(4053),
    [sym_float_literal] = ACTIONS(4053),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3768),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3837),
    [anon_sym_i8] = ACTIONS(3837),
    [anon_sym_u16] = ACTIONS(3837),
    [anon_sym_i16] = ACTIONS(3837),
    [anon_sym_u32] = ACTIONS(3837),
    [anon_sym_i32] = ACTIONS(3837),
    [anon_sym_u64] = ACTIONS(3837),
    [anon_sym_i64] = ACTIONS(3837),
    [anon_sym_u128] = ACTIONS(3837),
    [anon_sym_i128] = ACTIONS(3837),
    [anon_sym_isize] = ACTIONS(3837),
    [anon_sym_usize] = ACTIONS(3837),
    [anon_sym_f32] = ACTIONS(3837),
    [anon_sym_f64] = ACTIONS(3837),
    [anon_sym_bool] = ACTIONS(3837),
    [anon_sym_str] = ACTIONS(3837),
    [anon_sym_char] = ACTIONS(3837),
    [anon_sym__] = ACTIONS(4056),
    [anon_sym_AMP] = ACTIONS(4059),
    [anon_sym_DASH] = ACTIONS(3628),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3628),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(4062),
    [anon_sym_ref] = ACTIONS(345),
    [sym_integer_literal] = ACTIONS(4053),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3795),
    [sym_char_literal] = ACTIONS(4053),
    [anon_sym_true] = ACTIONS(3798),
    [anon_sym_false] = ACTIONS(3798),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4065),
    [sym_self] = ACTIONS(3807),
    [sym_super] = ACTIONS(3807),
    [sym_crate] = ACTIONS(3807),
    [sym_metavariable] = ACTIONS(3810),
  },
  [1200] = {
    [sym_block] = STATE(193),
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(4068),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3628),
    [anon_sym_DASH] = ACTIONS(3628),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3628),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3628),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3628),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1201] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(194),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(194),
    [sym_macro_invocation] = STATE(194),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(194),
    [sym_unary_expression] = STATE(194),
    [sym_try_expression] = STATE(194),
    [sym_reference_expression] = STATE(194),
    [sym_binary_expression] = STATE(194),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(194),
    [sym_call_expression] = STATE(194),
    [sym_array_expression] = STATE(194),
    [sym_parenthesized_expression] = STATE(194),
    [sym_tuple_expression] = STATE(194),
    [sym_unit_expression] = STATE(194),
    [sym_struct_expression] = STATE(194),
    [sym_if_expression] = STATE(194),
    [sym_if_let_expression] = STATE(194),
    [sym_match_expression] = STATE(194),
    [sym_while_expression] = STATE(194),
    [sym_while_let_expression] = STATE(194),
    [sym_loop_expression] = STATE(194),
    [sym_for_expression] = STATE(194),
    [sym_closure_expression] = STATE(194),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(194),
    [sym_continue_expression] = STATE(194),
    [sym_index_expression] = STATE(194),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(194),
    [sym_block] = STATE(194),
    [sym__literal] = STATE(194),
    [sym_string_literal] = STATE(194),
    [sym_boolean_literal] = STATE(194),
    [sym_raw_string_literal] = ACTIONS(4071),
    [sym_float_literal] = ACTIONS(4071),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3619),
    [anon_sym_LBRACE] = ACTIONS(3622),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3625),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3855),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3858),
    [anon_sym_i8] = ACTIONS(3858),
    [anon_sym_u16] = ACTIONS(3858),
    [anon_sym_i16] = ACTIONS(3858),
    [anon_sym_u32] = ACTIONS(3858),
    [anon_sym_i32] = ACTIONS(3858),
    [anon_sym_u64] = ACTIONS(3858),
    [anon_sym_i64] = ACTIONS(3858),
    [anon_sym_u128] = ACTIONS(3858),
    [anon_sym_i128] = ACTIONS(3858),
    [anon_sym_isize] = ACTIONS(3858),
    [anon_sym_usize] = ACTIONS(3858),
    [anon_sym_f32] = ACTIONS(3858),
    [anon_sym_f64] = ACTIONS(3858),
    [anon_sym_bool] = ACTIONS(3858),
    [anon_sym_str] = ACTIONS(3858),
    [anon_sym_char] = ACTIONS(3858),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3861),
    [anon_sym_DASH] = ACTIONS(3855),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3864),
    [anon_sym_BANG] = ACTIONS(3855),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3645),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DOT_DOT] = ACTIONS(3867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3657),
    [anon_sym_default] = ACTIONS(3660),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3663),
    [anon_sym_if] = ACTIONS(3870),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3669),
    [anon_sym_match] = ACTIONS(3672),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3876),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3660),
    [anon_sym_unsafe] = ACTIONS(3678),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3681),
    [sym_mutable_specifier] = ACTIONS(3628),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(4071),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3684),
    [sym_char_literal] = ACTIONS(4071),
    [anon_sym_true] = ACTIONS(3687),
    [anon_sym_false] = ACTIONS(3687),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3879),
    [sym_self] = ACTIONS(3882),
    [sym_super] = ACTIONS(3885),
    [sym_crate] = ACTIONS(3885),
    [sym_metavariable] = ACTIONS(3888),
  },
  [1202] = {
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3628),
    [anon_sym_DASH] = ACTIONS(3628),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3628),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3628),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4074),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1203] = {
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(4077),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3628),
    [anon_sym_DASH] = ACTIONS(3628),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3628),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3628),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(4080),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(4080),
    [anon_sym_enum] = ACTIONS(4080),
    [anon_sym_fn] = ACTIONS(4080),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(4080),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(4080),
    [anon_sym_struct] = ACTIONS(4080),
    [anon_sym_trait] = ACTIONS(4080),
    [anon_sym_type] = ACTIONS(4080),
    [anon_sym_union] = ACTIONS(4080),
    [anon_sym_unsafe] = ACTIONS(4080),
    [anon_sym_use] = ACTIONS(4080),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [anon_sym_extern] = ACTIONS(3363),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3628),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1204] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(313),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(313),
    [sym_macro_invocation] = STATE(313),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(313),
    [sym_unary_expression] = STATE(313),
    [sym_try_expression] = STATE(313),
    [sym_reference_expression] = STATE(313),
    [sym_binary_expression] = STATE(313),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(313),
    [sym_call_expression] = STATE(313),
    [sym_array_expression] = STATE(313),
    [sym_parenthesized_expression] = STATE(313),
    [sym_tuple_expression] = STATE(313),
    [sym_unit_expression] = STATE(313),
    [sym_struct_expression] = STATE(313),
    [sym_if_expression] = STATE(313),
    [sym_if_let_expression] = STATE(313),
    [sym_match_expression] = STATE(313),
    [sym_while_expression] = STATE(313),
    [sym_while_let_expression] = STATE(313),
    [sym_loop_expression] = STATE(313),
    [sym_for_expression] = STATE(313),
    [sym_closure_expression] = STATE(313),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(313),
    [sym_continue_expression] = STATE(313),
    [sym_index_expression] = STATE(313),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(313),
    [sym_block] = STATE(313),
    [sym__literal] = STATE(313),
    [sym_string_literal] = STATE(313),
    [sym_boolean_literal] = STATE(313),
    [sym_raw_string_literal] = ACTIONS(4083),
    [sym_float_literal] = ACTIONS(4083),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3897),
    [anon_sym_LBRACE] = ACTIONS(3622),
    [anon_sym_RBRACE] = ACTIONS(3901),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3904),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3908),
    [anon_sym_STAR] = ACTIONS(4086),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3633),
    [anon_sym_i8] = ACTIONS(3633),
    [anon_sym_u16] = ACTIONS(3633),
    [anon_sym_i16] = ACTIONS(3633),
    [anon_sym_u32] = ACTIONS(3633),
    [anon_sym_i32] = ACTIONS(3633),
    [anon_sym_u64] = ACTIONS(3633),
    [anon_sym_i64] = ACTIONS(3633),
    [anon_sym_u128] = ACTIONS(3633),
    [anon_sym_i128] = ACTIONS(3633),
    [anon_sym_isize] = ACTIONS(3633),
    [anon_sym_usize] = ACTIONS(3633),
    [anon_sym_f32] = ACTIONS(3633),
    [anon_sym_f64] = ACTIONS(3633),
    [anon_sym_bool] = ACTIONS(3633),
    [anon_sym_str] = ACTIONS(3633),
    [anon_sym_char] = ACTIONS(3633),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_DASH] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(3908),
    [anon_sym_DASH_EQ] = ACTIONS(3901),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3639),
    [anon_sym_BANG] = ACTIONS(3986),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3908),
    [anon_sym_SLASH_EQ] = ACTIONS(3901),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_AMP_EQ] = ACTIONS(3901),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3908),
    [anon_sym_PERCENT_EQ] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3908),
    [anon_sym_CARET_EQ] = ACTIONS(3901),
    [anon_sym_PLUS_EQ] = ACTIONS(3901),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_LT_LT] = ACTIONS(3908),
    [anon_sym_LT_LT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_EQ] = ACTIONS(3908),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_GT] = ACTIONS(3908),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3908),
    [anon_sym_GT_GT_EQ] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_PIPE_EQ] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3901),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DOT_DOT] = ACTIONS(4094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3901),
    [anon_sym_as] = ACTIONS(3908),
    [anon_sym_break] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3657),
    [anon_sym_default] = ACTIONS(3660),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3663),
    [anon_sym_if] = ACTIONS(3995),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3669),
    [anon_sym_match] = ACTIONS(3672),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3998),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3660),
    [anon_sym_unsafe] = ACTIONS(3678),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3681),
    [sym_mutable_specifier] = ACTIONS(3628),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(4083),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3684),
    [sym_char_literal] = ACTIONS(4083),
    [anon_sym_true] = ACTIONS(3687),
    [anon_sym_false] = ACTIONS(3687),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3690),
    [sym_self] = ACTIONS(3693),
    [sym_super] = ACTIONS(3696),
    [sym_crate] = ACTIONS(3696),
    [sym_metavariable] = ACTIONS(3699),
  },
  [1205] = {
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3628),
    [anon_sym_DASH] = ACTIONS(3628),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3628),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3628),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(4098),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4101),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1206] = {
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3628),
    [anon_sym_DASH] = ACTIONS(3628),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3628),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3628),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4104),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1207] = {
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3628),
    [anon_sym_DASH] = ACTIONS(3628),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3628),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3628),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4107),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1208] = {
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3628),
    [anon_sym_DASH] = ACTIONS(3628),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3628),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3628),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4110),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1209] = {
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3828),
    [anon_sym_LPAREN] = ACTIONS(3828),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_RBRACE] = ACTIONS(3828),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3828),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3831),
    [anon_sym_STAR] = ACTIONS(3831),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3831),
    [anon_sym_DASH] = ACTIONS(3831),
    [anon_sym_DOT] = ACTIONS(3831),
    [anon_sym_DASH_EQ] = ACTIONS(3828),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3828),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3828),
    [anon_sym_SLASH] = ACTIONS(3831),
    [anon_sym_SLASH_EQ] = ACTIONS(3828),
    [anon_sym_AMP_AMP] = ACTIONS(3828),
    [anon_sym_AMP_EQ] = ACTIONS(3828),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3831),
    [anon_sym_PERCENT_EQ] = ACTIONS(3828),
    [anon_sym_CARET] = ACTIONS(3831),
    [anon_sym_CARET_EQ] = ACTIONS(3828),
    [anon_sym_PLUS_EQ] = ACTIONS(3828),
    [anon_sym_LT] = ACTIONS(3831),
    [anon_sym_LT_LT] = ACTIONS(3831),
    [anon_sym_LT_LT_EQ] = ACTIONS(3828),
    [anon_sym_LT_EQ] = ACTIONS(3828),
    [anon_sym_EQ] = ACTIONS(3831),
    [anon_sym_EQ_EQ] = ACTIONS(3828),
    [anon_sym_GT] = ACTIONS(3831),
    [anon_sym_GT_EQ] = ACTIONS(3828),
    [anon_sym_GT_GT] = ACTIONS(3831),
    [anon_sym_GT_GT_EQ] = ACTIONS(3828),
    [anon_sym_PIPE] = ACTIONS(3831),
    [anon_sym_PIPE_EQ] = ACTIONS(3828),
    [anon_sym_PIPE_PIPE] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3828),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3831),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3828),
    [anon_sym_as] = ACTIONS(3831),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4113),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1210] = {
    [sym_block] = STATE(205),
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(4068),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3628),
    [anon_sym_DASH] = ACTIONS(3628),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3628),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3628),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(4014),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(4014),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(4014),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(4116),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(4014),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [anon_sym_extern] = ACTIONS(273),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3628),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1211] = {
    [sym__use_clause] = STATE(211),
    [sym_scoped_use_list] = STATE(211),
    [sym_use_list] = STATE(211),
    [sym_use_as_clause] = STATE(211),
    [sym_use_wildcard] = STATE(211),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_type_with_turbofish] = STATE(212),
    [sym_scoped_identifier] = STATE(213),
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(4119),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(4122),
    [anon_sym_i8] = ACTIONS(4122),
    [anon_sym_u16] = ACTIONS(4122),
    [anon_sym_i16] = ACTIONS(4122),
    [anon_sym_u32] = ACTIONS(4122),
    [anon_sym_i32] = ACTIONS(4122),
    [anon_sym_u64] = ACTIONS(4122),
    [anon_sym_i64] = ACTIONS(4122),
    [anon_sym_u128] = ACTIONS(4122),
    [anon_sym_i128] = ACTIONS(4122),
    [anon_sym_isize] = ACTIONS(4122),
    [anon_sym_usize] = ACTIONS(4122),
    [anon_sym_f32] = ACTIONS(4122),
    [anon_sym_f64] = ACTIONS(4122),
    [anon_sym_bool] = ACTIONS(4122),
    [anon_sym_str] = ACTIONS(4122),
    [anon_sym_char] = ACTIONS(4122),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3628),
    [anon_sym_DASH] = ACTIONS(3628),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(4125),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3628),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4128),
    [sym_self] = ACTIONS(4131),
    [sym_super] = ACTIONS(4131),
    [sym_crate] = ACTIONS(4131),
    [sym_metavariable] = ACTIONS(4134),
  },
  [1212] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(215),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(215),
    [sym_macro_invocation] = STATE(215),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(215),
    [sym_unary_expression] = STATE(215),
    [sym_try_expression] = STATE(215),
    [sym_reference_expression] = STATE(215),
    [sym_binary_expression] = STATE(215),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(215),
    [sym_call_expression] = STATE(215),
    [sym_array_expression] = STATE(215),
    [sym_parenthesized_expression] = STATE(215),
    [sym_tuple_expression] = STATE(215),
    [sym_unit_expression] = STATE(215),
    [sym_struct_expression] = STATE(215),
    [sym_if_expression] = STATE(215),
    [sym_if_let_expression] = STATE(215),
    [sym_match_expression] = STATE(215),
    [sym_while_expression] = STATE(215),
    [sym_while_let_expression] = STATE(215),
    [sym_loop_expression] = STATE(215),
    [sym_for_expression] = STATE(215),
    [sym_closure_expression] = STATE(215),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(215),
    [sym_continue_expression] = STATE(215),
    [sym_index_expression] = STATE(215),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(215),
    [sym_block] = STATE(215),
    [sym__literal] = STATE(215),
    [sym_string_literal] = STATE(215),
    [sym_boolean_literal] = STATE(215),
    [sym_raw_string_literal] = ACTIONS(4137),
    [sym_float_literal] = ACTIONS(4137),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3619),
    [anon_sym_LBRACE] = ACTIONS(3622),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3625),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3855),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3858),
    [anon_sym_i8] = ACTIONS(3858),
    [anon_sym_u16] = ACTIONS(3858),
    [anon_sym_i16] = ACTIONS(3858),
    [anon_sym_u32] = ACTIONS(3858),
    [anon_sym_i32] = ACTIONS(3858),
    [anon_sym_u64] = ACTIONS(3858),
    [anon_sym_i64] = ACTIONS(3858),
    [anon_sym_u128] = ACTIONS(3858),
    [anon_sym_i128] = ACTIONS(3858),
    [anon_sym_isize] = ACTIONS(3858),
    [anon_sym_usize] = ACTIONS(3858),
    [anon_sym_f32] = ACTIONS(3858),
    [anon_sym_f64] = ACTIONS(3858),
    [anon_sym_bool] = ACTIONS(3858),
    [anon_sym_str] = ACTIONS(3858),
    [anon_sym_char] = ACTIONS(3858),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3861),
    [anon_sym_DASH] = ACTIONS(3855),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3864),
    [anon_sym_BANG] = ACTIONS(3855),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3645),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DOT_DOT] = ACTIONS(3867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3657),
    [anon_sym_default] = ACTIONS(3660),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3663),
    [anon_sym_if] = ACTIONS(3870),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(4140),
    [anon_sym_loop] = ACTIONS(3669),
    [anon_sym_match] = ACTIONS(3672),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3876),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3660),
    [anon_sym_unsafe] = ACTIONS(3678),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3681),
    [sym_mutable_specifier] = ACTIONS(3628),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(4137),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3684),
    [sym_char_literal] = ACTIONS(4137),
    [anon_sym_true] = ACTIONS(3687),
    [anon_sym_false] = ACTIONS(3687),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3879),
    [sym_self] = ACTIONS(3882),
    [sym_super] = ACTIONS(3885),
    [sym_crate] = ACTIONS(3885),
    [sym_metavariable] = ACTIONS(3888),
  },
  [1213] = {
    [sym_field_initializer_list] = STATE(224),
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3941),
    [anon_sym_LPAREN] = ACTIONS(3941),
    [anon_sym_LBRACE] = ACTIONS(3944),
    [anon_sym_RBRACE] = ACTIONS(3941),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3941),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_STAR] = ACTIONS(3947),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_DOT] = ACTIONS(3947),
    [anon_sym_DASH_EQ] = ACTIONS(3941),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3950),
    [anon_sym_BANG] = ACTIONS(4143),
    [anon_sym_BANG_EQ] = ACTIONS(3941),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3941),
    [anon_sym_SLASH] = ACTIONS(3947),
    [anon_sym_SLASH_EQ] = ACTIONS(3941),
    [anon_sym_AMP_AMP] = ACTIONS(3941),
    [anon_sym_AMP_EQ] = ACTIONS(3941),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3947),
    [anon_sym_PERCENT_EQ] = ACTIONS(3941),
    [anon_sym_CARET] = ACTIONS(3947),
    [anon_sym_CARET_EQ] = ACTIONS(3941),
    [anon_sym_PLUS_EQ] = ACTIONS(3941),
    [anon_sym_LT] = ACTIONS(3947),
    [anon_sym_LT_LT] = ACTIONS(3947),
    [anon_sym_LT_LT_EQ] = ACTIONS(3941),
    [anon_sym_LT_EQ] = ACTIONS(3941),
    [anon_sym_EQ] = ACTIONS(3947),
    [anon_sym_EQ_EQ] = ACTIONS(3941),
    [anon_sym_GT] = ACTIONS(3947),
    [anon_sym_GT_EQ] = ACTIONS(3941),
    [anon_sym_GT_GT] = ACTIONS(3947),
    [anon_sym_GT_GT_EQ] = ACTIONS(3941),
    [anon_sym_PIPE] = ACTIONS(3947),
    [anon_sym_PIPE_EQ] = ACTIONS(3941),
    [anon_sym_PIPE_PIPE] = ACTIONS(3941),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3947),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3628),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1214] = {
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3941),
    [anon_sym_LPAREN] = ACTIONS(3941),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_RBRACE] = ACTIONS(3941),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3941),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_STAR] = ACTIONS(3947),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_DOT] = ACTIONS(3947),
    [anon_sym_DASH_EQ] = ACTIONS(3941),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3941),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3941),
    [anon_sym_SLASH] = ACTIONS(3947),
    [anon_sym_SLASH_EQ] = ACTIONS(3941),
    [anon_sym_AMP_AMP] = ACTIONS(3941),
    [anon_sym_AMP_EQ] = ACTIONS(3941),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3947),
    [anon_sym_PERCENT_EQ] = ACTIONS(3941),
    [anon_sym_CARET] = ACTIONS(3947),
    [anon_sym_CARET_EQ] = ACTIONS(3941),
    [anon_sym_PLUS_EQ] = ACTIONS(3941),
    [anon_sym_LT] = ACTIONS(3947),
    [anon_sym_LT_LT] = ACTIONS(3947),
    [anon_sym_LT_LT_EQ] = ACTIONS(3941),
    [anon_sym_LT_EQ] = ACTIONS(3941),
    [anon_sym_EQ] = ACTIONS(3947),
    [anon_sym_EQ_EQ] = ACTIONS(3941),
    [anon_sym_GT] = ACTIONS(3947),
    [anon_sym_GT_EQ] = ACTIONS(3941),
    [anon_sym_GT_GT] = ACTIONS(3947),
    [anon_sym_GT_GT_EQ] = ACTIONS(3941),
    [anon_sym_PIPE] = ACTIONS(3947),
    [anon_sym_PIPE_EQ] = ACTIONS(3941),
    [anon_sym_PIPE_PIPE] = ACTIONS(3941),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3947),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3628),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1215] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(3956),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(623),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(623),
    [anon_sym_PLUS_EQ] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(623),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(643),
    [anon_sym_as] = ACTIONS(645),
    [sym_line_comment] = ACTIONS(7),
  },
  [1216] = {
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3941),
    [anon_sym_LPAREN] = ACTIONS(3941),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_RBRACE] = ACTIONS(3941),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3941),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_STAR] = ACTIONS(3947),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_DOT] = ACTIONS(3947),
    [anon_sym_DASH_EQ] = ACTIONS(3941),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3941),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3941),
    [anon_sym_SLASH] = ACTIONS(3947),
    [anon_sym_SLASH_EQ] = ACTIONS(3941),
    [anon_sym_AMP_AMP] = ACTIONS(3941),
    [anon_sym_AMP_EQ] = ACTIONS(3941),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3947),
    [anon_sym_PERCENT_EQ] = ACTIONS(3941),
    [anon_sym_CARET] = ACTIONS(3947),
    [anon_sym_CARET_EQ] = ACTIONS(3941),
    [anon_sym_PLUS_EQ] = ACTIONS(3941),
    [anon_sym_LT] = ACTIONS(3947),
    [anon_sym_LT_LT] = ACTIONS(3947),
    [anon_sym_LT_LT_EQ] = ACTIONS(3941),
    [anon_sym_LT_EQ] = ACTIONS(3941),
    [anon_sym_EQ] = ACTIONS(3947),
    [anon_sym_EQ_EQ] = ACTIONS(3941),
    [anon_sym_GT] = ACTIONS(3947),
    [anon_sym_GT_EQ] = ACTIONS(3941),
    [anon_sym_GT_GT] = ACTIONS(3947),
    [anon_sym_GT_GT_EQ] = ACTIONS(3941),
    [anon_sym_PIPE] = ACTIONS(3947),
    [anon_sym_PIPE_EQ] = ACTIONS(3941),
    [anon_sym_PIPE_PIPE] = ACTIONS(3941),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3947),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3628),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1217] = {
    [sym__statement] = STATE(332),
    [sym_empty_statement] = STATE(332),
    [sym__expression_statement] = STATE(332),
    [sym_macro_definition] = STATE(332),
    [sym_attribute_item] = STATE(332),
    [sym_inner_attribute_item] = STATE(332),
    [sym_mod_item] = STATE(332),
    [sym_foreign_mod_item] = STATE(332),
    [sym_struct_item] = STATE(332),
    [sym_union_item] = STATE(332),
    [sym_enum_item] = STATE(332),
    [sym_extern_crate_declaration] = STATE(332),
    [sym_const_item] = STATE(332),
    [sym_static_item] = STATE(332),
    [sym_type_item] = STATE(332),
    [sym_function_item] = STATE(332),
    [sym_function_signature_item] = STATE(332),
    [sym_function_modifiers] = STATE(47),
    [sym_impl_item] = STATE(332),
    [sym_trait_item] = STATE(332),
    [sym_associated_type] = STATE(332),
    [sym_let_declaration] = STATE(332),
    [sym_use_declaration] = STATE(332),
    [sym_extern_modifier] = STATE(48),
    [sym_visibility_modifier] = STATE(49),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1886),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1886),
    [sym_macro_invocation] = STATE(53),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1886),
    [sym_unary_expression] = STATE(1886),
    [sym_try_expression] = STATE(1886),
    [sym_reference_expression] = STATE(1886),
    [sym_binary_expression] = STATE(1886),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1886),
    [sym_call_expression] = STATE(1886),
    [sym_array_expression] = STATE(1886),
    [sym_parenthesized_expression] = STATE(1886),
    [sym_tuple_expression] = STATE(1886),
    [sym_unit_expression] = STATE(1886),
    [sym_struct_expression] = STATE(1886),
    [sym_if_expression] = STATE(57),
    [sym_if_let_expression] = STATE(57),
    [sym_match_expression] = STATE(57),
    [sym_while_expression] = STATE(57),
    [sym_while_let_expression] = STATE(57),
    [sym_loop_expression] = STATE(57),
    [sym_for_expression] = STATE(57),
    [sym_closure_expression] = STATE(1886),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(59),
    [sym_break_expression] = STATE(1886),
    [sym_continue_expression] = STATE(1886),
    [sym_index_expression] = STATE(1886),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(57),
    [sym_block] = STATE(57),
    [sym__literal] = STATE(1886),
    [sym_string_literal] = STATE(1886),
    [sym_boolean_literal] = STATE(1886),
    [aux_sym_source_file_repeat1] = STATE(332),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_raw_string_literal] = ACTIONS(4146),
    [sym_float_literal] = ACTIONS(4146),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(3956),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_POUND] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(4146),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4146),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(93),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1218] = {
    [sym_token_tree] = STATE(1887),
    [sym_token_repetition] = STATE(1887),
    [sym__literal] = STATE(1887),
    [sym_string_literal] = STATE(1887),
    [sym_boolean_literal] = STATE(1887),
    [aux_sym_token_tree_repeat1] = STATE(1887),
    [sym_raw_string_literal] = ACTIONS(4148),
    [sym_float_literal] = ACTIONS(4148),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4148),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_LBRACE] = ACTIONS(3966),
    [anon_sym_RBRACE] = ACTIONS(3964),
    [anon_sym_EQ_GT] = ACTIONS(4148),
    [anon_sym_LBRACK] = ACTIONS(3968),
    [anon_sym_COLON] = ACTIONS(4150),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(4150),
    [anon_sym_STAR] = ACTIONS(4150),
    [anon_sym_COMMA] = ACTIONS(4148),
    [anon_sym_u8] = ACTIONS(3972),
    [anon_sym_i8] = ACTIONS(3972),
    [anon_sym_u16] = ACTIONS(3972),
    [anon_sym_i16] = ACTIONS(3972),
    [anon_sym_u32] = ACTIONS(3972),
    [anon_sym_i32] = ACTIONS(3972),
    [anon_sym_u64] = ACTIONS(3972),
    [anon_sym_i64] = ACTIONS(3972),
    [anon_sym_u128] = ACTIONS(3972),
    [anon_sym_i128] = ACTIONS(3972),
    [anon_sym_isize] = ACTIONS(3972),
    [anon_sym_usize] = ACTIONS(3972),
    [anon_sym_f32] = ACTIONS(3972),
    [anon_sym_f64] = ACTIONS(3972),
    [anon_sym_bool] = ACTIONS(3972),
    [anon_sym_str] = ACTIONS(3972),
    [anon_sym_char] = ACTIONS(3972),
    [anon_sym__] = ACTIONS(4150),
    [anon_sym_AMP] = ACTIONS(4150),
    [anon_sym_DASH] = ACTIONS(4150),
    [anon_sym_DOT] = ACTIONS(4150),
    [anon_sym_DASH_EQ] = ACTIONS(4148),
    [anon_sym_DASH_GT] = ACTIONS(4148),
    [anon_sym_COLON_COLON] = ACTIONS(4148),
    [anon_sym_BANG] = ACTIONS(4150),
    [anon_sym_BANG_EQ] = ACTIONS(4148),
    [anon_sym_AT] = ACTIONS(4148),
    [anon_sym_STAR_EQ] = ACTIONS(4148),
    [anon_sym_SLASH] = ACTIONS(4150),
    [anon_sym_SLASH_EQ] = ACTIONS(4148),
    [anon_sym_AMP_AMP] = ACTIONS(4148),
    [anon_sym_AMP_EQ] = ACTIONS(4148),
    [anon_sym_POUND] = ACTIONS(4148),
    [anon_sym_PERCENT] = ACTIONS(4150),
    [anon_sym_PERCENT_EQ] = ACTIONS(4148),
    [anon_sym_CARET] = ACTIONS(4150),
    [anon_sym_CARET_EQ] = ACTIONS(4148),
    [anon_sym_PLUS_EQ] = ACTIONS(4148),
    [anon_sym_LT] = ACTIONS(4150),
    [anon_sym_LT_LT] = ACTIONS(4150),
    [anon_sym_LT_LT_EQ] = ACTIONS(4148),
    [anon_sym_LT_EQ] = ACTIONS(4148),
    [anon_sym_EQ] = ACTIONS(4150),
    [anon_sym_EQ_EQ] = ACTIONS(4148),
    [anon_sym_GT] = ACTIONS(4150),
    [anon_sym_GT_EQ] = ACTIONS(4148),
    [anon_sym_GT_GT] = ACTIONS(4150),
    [anon_sym_GT_GT_EQ] = ACTIONS(4148),
    [anon_sym_PIPE] = ACTIONS(4150),
    [anon_sym_PIPE_EQ] = ACTIONS(4148),
    [anon_sym_PIPE_PIPE] = ACTIONS(4148),
    [anon_sym_TILDE] = ACTIONS(4148),
    [anon_sym_QMARK] = ACTIONS(4148),
    [anon_sym_SQUOTE] = ACTIONS(4150),
    [anon_sym_DOT_DOT] = ACTIONS(4150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4148),
    [anon_sym_as] = ACTIONS(4150),
    [anon_sym_break] = ACTIONS(4150),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_continue] = ACTIONS(4150),
    [anon_sym_default] = ACTIONS(4150),
    [anon_sym_enum] = ACTIONS(4150),
    [anon_sym_fn] = ACTIONS(4150),
    [anon_sym_for] = ACTIONS(4150),
    [anon_sym_if] = ACTIONS(4150),
    [anon_sym_impl] = ACTIONS(4150),
    [anon_sym_let] = ACTIONS(4150),
    [anon_sym_loop] = ACTIONS(4150),
    [anon_sym_match] = ACTIONS(4150),
    [anon_sym_mod] = ACTIONS(4150),
    [anon_sym_pub] = ACTIONS(4150),
    [anon_sym_return] = ACTIONS(4150),
    [anon_sym_static] = ACTIONS(4150),
    [anon_sym_struct] = ACTIONS(4150),
    [anon_sym_trait] = ACTIONS(4150),
    [anon_sym_type] = ACTIONS(4150),
    [anon_sym_union] = ACTIONS(4150),
    [anon_sym_unsafe] = ACTIONS(4150),
    [anon_sym_use] = ACTIONS(4150),
    [anon_sym_where] = ACTIONS(4150),
    [anon_sym_while] = ACTIONS(4150),
    [sym_mutable_specifier] = ACTIONS(4150),
    [sym_integer_literal] = ACTIONS(4148),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(4148),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4150),
    [sym_self] = ACTIONS(4150),
    [sym_super] = ACTIONS(4150),
    [sym_crate] = ACTIONS(4150),
    [sym_metavariable] = ACTIONS(4148),
  },
  [1219] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(103),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(103),
    [sym_macro_invocation] = STATE(103),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(103),
    [sym_unary_expression] = STATE(103),
    [sym_try_expression] = STATE(103),
    [sym_reference_expression] = STATE(103),
    [sym_binary_expression] = STATE(103),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(103),
    [sym_call_expression] = STATE(103),
    [sym_array_expression] = STATE(103),
    [sym_parenthesized_expression] = STATE(103),
    [sym_tuple_expression] = STATE(103),
    [sym_unit_expression] = STATE(103),
    [sym_struct_expression] = STATE(103),
    [sym_if_expression] = STATE(103),
    [sym_if_let_expression] = STATE(103),
    [sym_match_expression] = STATE(103),
    [sym_while_expression] = STATE(103),
    [sym_while_let_expression] = STATE(103),
    [sym_loop_expression] = STATE(103),
    [sym_for_expression] = STATE(103),
    [sym_closure_expression] = STATE(103),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(103),
    [sym_continue_expression] = STATE(103),
    [sym_index_expression] = STATE(103),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(103),
    [sym_block] = STATE(103),
    [sym__literal] = STATE(103),
    [sym_string_literal] = STATE(103),
    [sym_boolean_literal] = STATE(103),
    [sym_raw_string_literal] = ACTIONS(3614),
    [sym_float_literal] = ACTIONS(3614),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3619),
    [anon_sym_LBRACE] = ACTIONS(3622),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3625),
    [anon_sym_RBRACK] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(4152),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3633),
    [anon_sym_i8] = ACTIONS(3633),
    [anon_sym_u16] = ACTIONS(3633),
    [anon_sym_i16] = ACTIONS(3633),
    [anon_sym_u32] = ACTIONS(3633),
    [anon_sym_i32] = ACTIONS(3633),
    [anon_sym_u64] = ACTIONS(3633),
    [anon_sym_i64] = ACTIONS(3633),
    [anon_sym_u128] = ACTIONS(3633),
    [anon_sym_i128] = ACTIONS(3633),
    [anon_sym_isize] = ACTIONS(3633),
    [anon_sym_usize] = ACTIONS(3633),
    [anon_sym_f32] = ACTIONS(3633),
    [anon_sym_f64] = ACTIONS(3633),
    [anon_sym_bool] = ACTIONS(3633),
    [anon_sym_str] = ACTIONS(3633),
    [anon_sym_char] = ACTIONS(3633),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(4155),
    [anon_sym_DASH] = ACTIONS(4152),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3639),
    [anon_sym_BANG] = ACTIONS(4152),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3645),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DOT_DOT] = ACTIONS(4158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3657),
    [anon_sym_default] = ACTIONS(3660),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3663),
    [anon_sym_if] = ACTIONS(4161),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3669),
    [anon_sym_match] = ACTIONS(3672),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(4164),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3660),
    [anon_sym_unsafe] = ACTIONS(3678),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3681),
    [sym_mutable_specifier] = ACTIONS(3628),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(3614),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3684),
    [sym_char_literal] = ACTIONS(3614),
    [anon_sym_true] = ACTIONS(3687),
    [anon_sym_false] = ACTIONS(3687),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3690),
    [sym_self] = ACTIONS(3693),
    [sym_super] = ACTIONS(3696),
    [sym_crate] = ACTIONS(3696),
    [sym_metavariable] = ACTIONS(3699),
  },
  [1220] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(106),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(106),
    [sym_macro_invocation] = STATE(106),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(106),
    [sym_unary_expression] = STATE(106),
    [sym_try_expression] = STATE(106),
    [sym_reference_expression] = STATE(106),
    [sym_binary_expression] = STATE(106),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(106),
    [sym_call_expression] = STATE(106),
    [sym_array_expression] = STATE(106),
    [sym_parenthesized_expression] = STATE(106),
    [sym_tuple_expression] = STATE(106),
    [sym_unit_expression] = STATE(106),
    [sym_struct_expression] = STATE(106),
    [sym_if_expression] = STATE(106),
    [sym_if_let_expression] = STATE(106),
    [sym_match_expression] = STATE(106),
    [sym_while_expression] = STATE(106),
    [sym_while_let_expression] = STATE(106),
    [sym_loop_expression] = STATE(106),
    [sym_for_expression] = STATE(106),
    [sym_closure_expression] = STATE(106),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(106),
    [sym_continue_expression] = STATE(106),
    [sym_index_expression] = STATE(106),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(106),
    [sym_block] = STATE(106),
    [sym__literal] = STATE(106),
    [sym_string_literal] = STATE(106),
    [sym_boolean_literal] = STATE(106),
    [sym_raw_string_literal] = ACTIONS(3712),
    [sym_float_literal] = ACTIONS(3712),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3619),
    [anon_sym_LBRACE] = ACTIONS(3622),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3625),
    [anon_sym_RBRACK] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(4152),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3633),
    [anon_sym_i8] = ACTIONS(3633),
    [anon_sym_u16] = ACTIONS(3633),
    [anon_sym_i16] = ACTIONS(3633),
    [anon_sym_u32] = ACTIONS(3633),
    [anon_sym_i32] = ACTIONS(3633),
    [anon_sym_u64] = ACTIONS(3633),
    [anon_sym_i64] = ACTIONS(3633),
    [anon_sym_u128] = ACTIONS(3633),
    [anon_sym_i128] = ACTIONS(3633),
    [anon_sym_isize] = ACTIONS(3633),
    [anon_sym_usize] = ACTIONS(3633),
    [anon_sym_f32] = ACTIONS(3633),
    [anon_sym_f64] = ACTIONS(3633),
    [anon_sym_bool] = ACTIONS(3633),
    [anon_sym_str] = ACTIONS(3633),
    [anon_sym_char] = ACTIONS(3633),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(4155),
    [anon_sym_DASH] = ACTIONS(4152),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3639),
    [anon_sym_BANG] = ACTIONS(4152),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3645),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DOT_DOT] = ACTIONS(4158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3657),
    [anon_sym_default] = ACTIONS(3660),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3663),
    [anon_sym_if] = ACTIONS(4161),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3669),
    [anon_sym_match] = ACTIONS(3672),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(4164),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3660),
    [anon_sym_unsafe] = ACTIONS(3678),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3681),
    [sym_mutable_specifier] = ACTIONS(4167),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(3712),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3684),
    [sym_char_literal] = ACTIONS(3712),
    [anon_sym_true] = ACTIONS(3687),
    [anon_sym_false] = ACTIONS(3687),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3690),
    [sym_self] = ACTIONS(3693),
    [sym_super] = ACTIONS(3696),
    [sym_crate] = ACTIONS(3696),
    [sym_metavariable] = ACTIONS(3699),
  },
  [1221] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(103),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(103),
    [sym_macro_invocation] = STATE(103),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(103),
    [sym_unary_expression] = STATE(103),
    [sym_try_expression] = STATE(103),
    [sym_reference_expression] = STATE(103),
    [sym_binary_expression] = STATE(103),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(103),
    [sym_call_expression] = STATE(103),
    [sym_array_expression] = STATE(103),
    [sym_parenthesized_expression] = STATE(103),
    [sym_tuple_expression] = STATE(103),
    [sym_unit_expression] = STATE(103),
    [sym_struct_expression] = STATE(103),
    [sym_if_expression] = STATE(103),
    [sym_if_let_expression] = STATE(103),
    [sym_match_expression] = STATE(103),
    [sym_while_expression] = STATE(103),
    [sym_while_let_expression] = STATE(103),
    [sym_loop_expression] = STATE(103),
    [sym_for_expression] = STATE(103),
    [sym_closure_expression] = STATE(103),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(103),
    [sym_continue_expression] = STATE(103),
    [sym_index_expression] = STATE(103),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(103),
    [sym_block] = STATE(103),
    [sym__literal] = STATE(103),
    [sym_string_literal] = STATE(103),
    [sym_boolean_literal] = STATE(103),
    [sym_raw_string_literal] = ACTIONS(173),
    [sym_float_literal] = ACTIONS(173),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_RBRACK] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(4170),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3720),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3722),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(4172),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(133),
    [sym_mutable_specifier] = ACTIONS(3628),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(173),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(173),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1222] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1427),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1427),
    [sym_macro_invocation] = STATE(1427),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1427),
    [sym_unary_expression] = STATE(1427),
    [sym_try_expression] = STATE(1427),
    [sym_reference_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1427),
    [sym_call_expression] = STATE(1427),
    [sym_array_expression] = STATE(1427),
    [sym_parenthesized_expression] = STATE(1427),
    [sym_tuple_expression] = STATE(1427),
    [sym_unit_expression] = STATE(1427),
    [sym_struct_expression] = STATE(1427),
    [sym_if_expression] = STATE(1427),
    [sym_if_let_expression] = STATE(1427),
    [sym_match_expression] = STATE(1427),
    [sym_while_expression] = STATE(1427),
    [sym_while_let_expression] = STATE(1427),
    [sym_loop_expression] = STATE(1427),
    [sym_for_expression] = STATE(1427),
    [sym_closure_expression] = STATE(1427),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1427),
    [sym_continue_expression] = STATE(1427),
    [sym_index_expression] = STATE(1427),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1427),
    [sym_block] = STATE(1427),
    [sym__literal] = STATE(1427),
    [sym_string_literal] = STATE(1427),
    [sym_boolean_literal] = STATE(1427),
    [sym_raw_string_literal] = ACTIONS(2805),
    [sym_float_literal] = ACTIONS(2805),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_RBRACK] = ACTIONS(261),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(263),
    [anon_sym_COMMA] = ACTIONS(261),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(263),
    [anon_sym_DASH] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(263),
    [anon_sym_DASH_EQ] = ACTIONS(261),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(261),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_SLASH_EQ] = ACTIONS(261),
    [anon_sym_AMP_AMP] = ACTIONS(261),
    [anon_sym_AMP_EQ] = ACTIONS(261),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(263),
    [anon_sym_PERCENT_EQ] = ACTIONS(261),
    [anon_sym_CARET] = ACTIONS(263),
    [anon_sym_CARET_EQ] = ACTIONS(261),
    [anon_sym_PLUS_EQ] = ACTIONS(261),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_EQ] = ACTIONS(261),
    [anon_sym_LT_EQ] = ACTIONS(261),
    [anon_sym_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(261),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_EQ] = ACTIONS(261),
    [anon_sym_GT_GT] = ACTIONS(263),
    [anon_sym_GT_GT_EQ] = ACTIONS(261),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_PIPE_EQ] = ACTIONS(261),
    [anon_sym_PIPE_PIPE] = ACTIONS(261),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(263),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(261),
    [anon_sym_as] = ACTIONS(263),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(133),
    [sym_mutable_specifier] = ACTIONS(3628),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(2805),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(2805),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1223] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1429),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(1429),
    [sym_macro_invocation] = STATE(1429),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1429),
    [sym_unary_expression] = STATE(1429),
    [sym_try_expression] = STATE(1429),
    [sym_reference_expression] = STATE(1429),
    [sym_binary_expression] = STATE(1429),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1429),
    [sym_call_expression] = STATE(1429),
    [sym_array_expression] = STATE(1429),
    [sym_parenthesized_expression] = STATE(1429),
    [sym_tuple_expression] = STATE(1429),
    [sym_unit_expression] = STATE(1429),
    [sym_struct_expression] = STATE(1429),
    [sym_if_expression] = STATE(1429),
    [sym_if_let_expression] = STATE(1429),
    [sym_match_expression] = STATE(1429),
    [sym_while_expression] = STATE(1429),
    [sym_while_let_expression] = STATE(1429),
    [sym_loop_expression] = STATE(1429),
    [sym_for_expression] = STATE(1429),
    [sym_closure_expression] = STATE(1429),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1429),
    [sym_continue_expression] = STATE(1429),
    [sym_index_expression] = STATE(1429),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1429),
    [sym_block] = STATE(1429),
    [sym__literal] = STATE(1429),
    [sym_string_literal] = STATE(1429),
    [sym_boolean_literal] = STATE(1429),
    [sym_raw_string_literal] = ACTIONS(4174),
    [sym_float_literal] = ACTIONS(4174),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3619),
    [anon_sym_LBRACE] = ACTIONS(3622),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3625),
    [anon_sym_RBRACK] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3855),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3858),
    [anon_sym_i8] = ACTIONS(3858),
    [anon_sym_u16] = ACTIONS(3858),
    [anon_sym_i16] = ACTIONS(3858),
    [anon_sym_u32] = ACTIONS(3858),
    [anon_sym_i32] = ACTIONS(3858),
    [anon_sym_u64] = ACTIONS(3858),
    [anon_sym_i64] = ACTIONS(3858),
    [anon_sym_u128] = ACTIONS(3858),
    [anon_sym_i128] = ACTIONS(3858),
    [anon_sym_isize] = ACTIONS(3858),
    [anon_sym_usize] = ACTIONS(3858),
    [anon_sym_f32] = ACTIONS(3858),
    [anon_sym_f64] = ACTIONS(3858),
    [anon_sym_bool] = ACTIONS(3858),
    [anon_sym_str] = ACTIONS(3858),
    [anon_sym_char] = ACTIONS(3858),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3861),
    [anon_sym_DASH] = ACTIONS(3855),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3864),
    [anon_sym_BANG] = ACTIONS(3855),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3645),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DOT_DOT] = ACTIONS(3867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3657),
    [anon_sym_default] = ACTIONS(3660),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3663),
    [anon_sym_if] = ACTIONS(3870),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(4177),
    [anon_sym_loop] = ACTIONS(3669),
    [anon_sym_match] = ACTIONS(3672),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3876),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3660),
    [anon_sym_unsafe] = ACTIONS(3678),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3681),
    [sym_mutable_specifier] = ACTIONS(3628),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(4174),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3684),
    [sym_char_literal] = ACTIONS(4174),
    [anon_sym_true] = ACTIONS(3687),
    [anon_sym_false] = ACTIONS(3687),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3879),
    [sym_self] = ACTIONS(3882),
    [sym_super] = ACTIONS(3885),
    [sym_crate] = ACTIONS(3885),
    [sym_metavariable] = ACTIONS(3888),
  },
  [1224] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1430),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1430),
    [sym_macro_invocation] = STATE(1430),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1430),
    [sym_unary_expression] = STATE(1430),
    [sym_try_expression] = STATE(1430),
    [sym_reference_expression] = STATE(1430),
    [sym_binary_expression] = STATE(1430),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1430),
    [sym_call_expression] = STATE(1430),
    [sym_array_expression] = STATE(1430),
    [sym_parenthesized_expression] = STATE(1430),
    [sym_tuple_expression] = STATE(1430),
    [sym_unit_expression] = STATE(1430),
    [sym_struct_expression] = STATE(1430),
    [sym_if_expression] = STATE(1430),
    [sym_if_let_expression] = STATE(1430),
    [sym_match_expression] = STATE(1430),
    [sym_while_expression] = STATE(1430),
    [sym_while_let_expression] = STATE(1430),
    [sym_loop_expression] = STATE(1430),
    [sym_for_expression] = STATE(1430),
    [sym_closure_expression] = STATE(1430),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1430),
    [sym_continue_expression] = STATE(1430),
    [sym_index_expression] = STATE(1430),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1430),
    [sym_block] = STATE(1430),
    [sym__literal] = STATE(1430),
    [sym_string_literal] = STATE(1430),
    [sym_boolean_literal] = STATE(1430),
    [sym_raw_string_literal] = ACTIONS(4180),
    [sym_float_literal] = ACTIONS(4180),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3897),
    [anon_sym_LBRACE] = ACTIONS(3622),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3904),
    [anon_sym_RBRACK] = ACTIONS(3901),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3908),
    [anon_sym_STAR] = ACTIONS(4183),
    [anon_sym_COMMA] = ACTIONS(3901),
    [anon_sym_u8] = ACTIONS(3633),
    [anon_sym_i8] = ACTIONS(3633),
    [anon_sym_u16] = ACTIONS(3633),
    [anon_sym_i16] = ACTIONS(3633),
    [anon_sym_u32] = ACTIONS(3633),
    [anon_sym_i32] = ACTIONS(3633),
    [anon_sym_u64] = ACTIONS(3633),
    [anon_sym_i64] = ACTIONS(3633),
    [anon_sym_u128] = ACTIONS(3633),
    [anon_sym_i128] = ACTIONS(3633),
    [anon_sym_isize] = ACTIONS(3633),
    [anon_sym_usize] = ACTIONS(3633),
    [anon_sym_f32] = ACTIONS(3633),
    [anon_sym_f64] = ACTIONS(3633),
    [anon_sym_bool] = ACTIONS(3633),
    [anon_sym_str] = ACTIONS(3633),
    [anon_sym_char] = ACTIONS(3633),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(4187),
    [anon_sym_DASH] = ACTIONS(4183),
    [anon_sym_DOT] = ACTIONS(3908),
    [anon_sym_DASH_EQ] = ACTIONS(3901),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3639),
    [anon_sym_BANG] = ACTIONS(4152),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3908),
    [anon_sym_SLASH_EQ] = ACTIONS(3901),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_AMP_EQ] = ACTIONS(3901),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3908),
    [anon_sym_PERCENT_EQ] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3908),
    [anon_sym_CARET_EQ] = ACTIONS(3901),
    [anon_sym_PLUS_EQ] = ACTIONS(3901),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_LT_LT] = ACTIONS(3908),
    [anon_sym_LT_LT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_EQ] = ACTIONS(3908),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_GT] = ACTIONS(3908),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3908),
    [anon_sym_GT_GT_EQ] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_PIPE_EQ] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3901),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DOT_DOT] = ACTIONS(4191),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3901),
    [anon_sym_as] = ACTIONS(3908),
    [anon_sym_break] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3657),
    [anon_sym_default] = ACTIONS(3660),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3663),
    [anon_sym_if] = ACTIONS(4161),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3669),
    [anon_sym_match] = ACTIONS(3672),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(4164),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3660),
    [anon_sym_unsafe] = ACTIONS(3678),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3681),
    [sym_mutable_specifier] = ACTIONS(3628),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(4180),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3684),
    [sym_char_literal] = ACTIONS(4180),
    [anon_sym_true] = ACTIONS(3687),
    [anon_sym_false] = ACTIONS(3687),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3690),
    [sym_self] = ACTIONS(3693),
    [sym_super] = ACTIONS(3696),
    [sym_crate] = ACTIONS(3696),
    [sym_metavariable] = ACTIONS(3699),
  },
  [1225] = {
    [sym_arguments] = STATE(263),
    [aux_sym_token_tree_repeat2] = STATE(1889),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(3956),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_STAR] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(4195),
    [anon_sym_AMP] = ACTIONS(2821),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2823),
    [anon_sym_BANG_EQ] = ACTIONS(2825),
    [anon_sym_STAR_EQ] = ACTIONS(2823),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_SLASH_EQ] = ACTIONS(2823),
    [anon_sym_AMP_AMP] = ACTIONS(2827),
    [anon_sym_AMP_EQ] = ACTIONS(2823),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_PERCENT_EQ] = ACTIONS(2823),
    [anon_sym_CARET] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2823),
    [anon_sym_PLUS_EQ] = ACTIONS(2823),
    [anon_sym_LT] = ACTIONS(2831),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_LT_LT_EQ] = ACTIONS(2823),
    [anon_sym_LT_EQ] = ACTIONS(2825),
    [anon_sym_EQ] = ACTIONS(2835),
    [anon_sym_EQ_EQ] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2831),
    [anon_sym_GT_EQ] = ACTIONS(2825),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_GT_GT_EQ] = ACTIONS(2823),
    [anon_sym_PIPE] = ACTIONS(2837),
    [anon_sym_PIPE_EQ] = ACTIONS(2823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2839),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(2841),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2843),
    [anon_sym_as] = ACTIONS(2845),
    [sym_line_comment] = ACTIONS(7),
  },
  [1226] = {
    [sym_token_tree] = STATE(1890),
    [sym_token_repetition] = STATE(1890),
    [sym__literal] = STATE(1890),
    [sym_string_literal] = STATE(1890),
    [sym_boolean_literal] = STATE(1890),
    [aux_sym_token_tree_repeat1] = STATE(1890),
    [sym_raw_string_literal] = ACTIONS(4197),
    [sym_float_literal] = ACTIONS(4197),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4197),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_LBRACE] = ACTIONS(3966),
    [anon_sym_EQ_GT] = ACTIONS(4197),
    [anon_sym_LBRACK] = ACTIONS(3968),
    [anon_sym_RBRACK] = ACTIONS(3964),
    [anon_sym_COLON] = ACTIONS(4199),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(4199),
    [anon_sym_STAR] = ACTIONS(4199),
    [anon_sym_COMMA] = ACTIONS(4197),
    [anon_sym_u8] = ACTIONS(3972),
    [anon_sym_i8] = ACTIONS(3972),
    [anon_sym_u16] = ACTIONS(3972),
    [anon_sym_i16] = ACTIONS(3972),
    [anon_sym_u32] = ACTIONS(3972),
    [anon_sym_i32] = ACTIONS(3972),
    [anon_sym_u64] = ACTIONS(3972),
    [anon_sym_i64] = ACTIONS(3972),
    [anon_sym_u128] = ACTIONS(3972),
    [anon_sym_i128] = ACTIONS(3972),
    [anon_sym_isize] = ACTIONS(3972),
    [anon_sym_usize] = ACTIONS(3972),
    [anon_sym_f32] = ACTIONS(3972),
    [anon_sym_f64] = ACTIONS(3972),
    [anon_sym_bool] = ACTIONS(3972),
    [anon_sym_str] = ACTIONS(3972),
    [anon_sym_char] = ACTIONS(3972),
    [anon_sym__] = ACTIONS(4199),
    [anon_sym_AMP] = ACTIONS(4199),
    [anon_sym_DASH] = ACTIONS(4199),
    [anon_sym_DOT] = ACTIONS(4199),
    [anon_sym_DASH_EQ] = ACTIONS(4197),
    [anon_sym_DASH_GT] = ACTIONS(4197),
    [anon_sym_COLON_COLON] = ACTIONS(4197),
    [anon_sym_BANG] = ACTIONS(4199),
    [anon_sym_BANG_EQ] = ACTIONS(4197),
    [anon_sym_AT] = ACTIONS(4197),
    [anon_sym_STAR_EQ] = ACTIONS(4197),
    [anon_sym_SLASH] = ACTIONS(4199),
    [anon_sym_SLASH_EQ] = ACTIONS(4197),
    [anon_sym_AMP_AMP] = ACTIONS(4197),
    [anon_sym_AMP_EQ] = ACTIONS(4197),
    [anon_sym_POUND] = ACTIONS(4197),
    [anon_sym_PERCENT] = ACTIONS(4199),
    [anon_sym_PERCENT_EQ] = ACTIONS(4197),
    [anon_sym_CARET] = ACTIONS(4199),
    [anon_sym_CARET_EQ] = ACTIONS(4197),
    [anon_sym_PLUS_EQ] = ACTIONS(4197),
    [anon_sym_LT] = ACTIONS(4199),
    [anon_sym_LT_LT] = ACTIONS(4199),
    [anon_sym_LT_LT_EQ] = ACTIONS(4197),
    [anon_sym_LT_EQ] = ACTIONS(4197),
    [anon_sym_EQ] = ACTIONS(4199),
    [anon_sym_EQ_EQ] = ACTIONS(4197),
    [anon_sym_GT] = ACTIONS(4199),
    [anon_sym_GT_EQ] = ACTIONS(4197),
    [anon_sym_GT_GT] = ACTIONS(4199),
    [anon_sym_GT_GT_EQ] = ACTIONS(4197),
    [anon_sym_PIPE] = ACTIONS(4199),
    [anon_sym_PIPE_EQ] = ACTIONS(4197),
    [anon_sym_PIPE_PIPE] = ACTIONS(4197),
    [anon_sym_TILDE] = ACTIONS(4197),
    [anon_sym_QMARK] = ACTIONS(4197),
    [anon_sym_SQUOTE] = ACTIONS(4199),
    [anon_sym_DOT_DOT] = ACTIONS(4199),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4197),
    [anon_sym_as] = ACTIONS(4199),
    [anon_sym_break] = ACTIONS(4199),
    [anon_sym_const] = ACTIONS(4199),
    [anon_sym_continue] = ACTIONS(4199),
    [anon_sym_default] = ACTIONS(4199),
    [anon_sym_enum] = ACTIONS(4199),
    [anon_sym_fn] = ACTIONS(4199),
    [anon_sym_for] = ACTIONS(4199),
    [anon_sym_if] = ACTIONS(4199),
    [anon_sym_impl] = ACTIONS(4199),
    [anon_sym_let] = ACTIONS(4199),
    [anon_sym_loop] = ACTIONS(4199),
    [anon_sym_match] = ACTIONS(4199),
    [anon_sym_mod] = ACTIONS(4199),
    [anon_sym_pub] = ACTIONS(4199),
    [anon_sym_return] = ACTIONS(4199),
    [anon_sym_static] = ACTIONS(4199),
    [anon_sym_struct] = ACTIONS(4199),
    [anon_sym_trait] = ACTIONS(4199),
    [anon_sym_type] = ACTIONS(4199),
    [anon_sym_union] = ACTIONS(4199),
    [anon_sym_unsafe] = ACTIONS(4199),
    [anon_sym_use] = ACTIONS(4199),
    [anon_sym_where] = ACTIONS(4199),
    [anon_sym_while] = ACTIONS(4199),
    [sym_mutable_specifier] = ACTIONS(4199),
    [sym_integer_literal] = ACTIONS(4197),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(4197),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4199),
    [sym_self] = ACTIONS(4199),
    [sym_super] = ACTIONS(4199),
    [sym_crate] = ACTIONS(4199),
    [sym_metavariable] = ACTIONS(4197),
  },
  [1227] = {
    [sym_parameters] = STATE(1891),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [1228] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(4201),
    [anon_sym_LBRACE] = ACTIONS(4203),
    [sym_line_comment] = ACTIONS(7),
  },
  [1229] = {
    [sym_meta_item] = STATE(1894),
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(727),
  },
  [1230] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACK] = ACTIONS(4205),
    [sym_line_comment] = ACTIONS(7),
  },
  [1231] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(4207),
    [sym_line_comment] = ACTIONS(7),
  },
  [1232] = {
    [sym_enum_variant_list] = STATE(1898),
    [sym_where_clause] = STATE(1899),
    [sym_type_parameters] = STATE(1900),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(4209),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [1233] = {
    [sym_type_parameters] = STATE(1901),
    [sym_parameters] = STATE(1902),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(925),
    [sym_line_comment] = ACTIONS(7),
  },
  [1234] = {
    [sym_declaration_list] = STATE(1903),
    [sym_where_clause] = STATE(1904),
    [sym_impl_for_clause] = STATE(1905),
    [sym_type_arguments] = STATE(1906),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [1235] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1908),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4211),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [1236] = {
    [sym_declaration_list] = STATE(1909),
    [sym_where_clause] = STATE(1910),
    [sym_impl_for_clause] = STATE(1911),
    [sym_type_arguments] = STATE(1912),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [1237] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(1913),
    [sym_tuple_pattern] = STATE(1913),
    [sym_tuple_struct_pattern] = STATE(1913),
    [sym_struct_pattern] = STATE(1913),
    [sym_remaining_field_pattern] = STATE(1913),
    [sym_mut_pattern] = STATE(1913),
    [sym_ref_pattern] = STATE(1913),
    [sym_captured_pattern] = STATE(1913),
    [sym_reference_pattern] = STATE(1913),
    [sym__literal] = STATE(1913),
    [sym_string_literal] = STATE(1913),
    [sym_boolean_literal] = STATE(1913),
    [sym_raw_string_literal] = ACTIONS(4213),
    [sym_float_literal] = ACTIONS(4213),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(341),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(1021),
    [anon_sym_ref] = ACTIONS(345),
    [sym_integer_literal] = ACTIONS(4213),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(4213),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(347),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [1238] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4217),
    [anon_sym_COLON] = ACTIONS(4219),
    [anon_sym_EQ] = ACTIONS(4221),
    [sym_line_comment] = ACTIONS(7),
  },
  [1239] = {
    [sym_declaration_list] = STATE(1917),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4223),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [sym_line_comment] = ACTIONS(7),
  },
  [1240] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4225),
  },
  [1241] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(4227),
    [sym_line_comment] = ACTIONS(7),
  },
  [1242] = {
    [sym_field_declaration_list] = STATE(1920),
    [sym_ordered_field_declaration_list] = STATE(1921),
    [sym_where_clause] = STATE(1922),
    [sym_type_parameters] = STATE(1923),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4229),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(3125),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_where] = ACTIONS(1057),
    [sym_line_comment] = ACTIONS(7),
  },
  [1243] = {
    [sym_declaration_list] = STATE(1924),
    [sym_trait_bounds] = STATE(1925),
    [sym_type_parameters] = STATE(1926),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [anon_sym_COLON] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [sym_line_comment] = ACTIONS(7),
  },
  [1244] = {
    [sym_trait_bounds] = STATE(1929),
    [sym_type_parameters] = STATE(1930),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4231),
    [anon_sym_COLON] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(4233),
    [sym_line_comment] = ACTIONS(7),
  },
  [1245] = {
    [sym_field_declaration_list] = STATE(1931),
    [sym_ordered_field_declaration_list] = STATE(1932),
    [sym_where_clause] = STATE(1933),
    [sym_type_parameters] = STATE(1934),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4235),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(3125),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_where] = ACTIONS(1057),
    [sym_line_comment] = ACTIONS(7),
  },
  [1246] = {
    [sym_type_parameters] = STATE(1935),
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1908),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(331),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4211),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [1247] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4237),
    [sym_line_comment] = ACTIONS(7),
  },
  [1248] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4239),
  },
  [1249] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4241),
    [sym_metavariable] = ACTIONS(4241),
  },
  [1250] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1155),
    [anon_sym_macro_rules_BANG] = ACTIONS(1155),
    [anon_sym_RBRACE] = ACTIONS(1155),
    [anon_sym_POUND] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_default] = ACTIONS(1157),
    [anon_sym_enum] = ACTIONS(1157),
    [anon_sym_fn] = ACTIONS(1157),
    [anon_sym_impl] = ACTIONS(1157),
    [anon_sym_let] = ACTIONS(1157),
    [anon_sym_mod] = ACTIONS(1157),
    [anon_sym_pub] = ACTIONS(1157),
    [anon_sym_static] = ACTIONS(1157),
    [anon_sym_struct] = ACTIONS(1157),
    [anon_sym_trait] = ACTIONS(1157),
    [anon_sym_type] = ACTIONS(1157),
    [anon_sym_union] = ACTIONS(1157),
    [anon_sym_unsafe] = ACTIONS(1157),
    [anon_sym_use] = ACTIONS(1157),
    [anon_sym_extern] = ACTIONS(1157),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1157),
  },
  [1251] = {
    [sym_empty_statement] = STATE(1940),
    [sym_macro_definition] = STATE(1940),
    [sym_attribute_item] = STATE(1940),
    [sym_inner_attribute_item] = STATE(1940),
    [sym_mod_item] = STATE(1940),
    [sym_foreign_mod_item] = STATE(1940),
    [sym_struct_item] = STATE(1940),
    [sym_union_item] = STATE(1940),
    [sym_enum_item] = STATE(1940),
    [sym_extern_crate_declaration] = STATE(1940),
    [sym_const_item] = STATE(1940),
    [sym_static_item] = STATE(1940),
    [sym_type_item] = STATE(1940),
    [sym_function_item] = STATE(1940),
    [sym_function_signature_item] = STATE(1940),
    [sym_function_modifiers] = STATE(610),
    [sym_impl_item] = STATE(1940),
    [sym_trait_item] = STATE(1940),
    [sym_associated_type] = STATE(1940),
    [sym_let_declaration] = STATE(1940),
    [sym_use_declaration] = STATE(1940),
    [sym_extern_modifier] = STATE(611),
    [sym_visibility_modifier] = STATE(612),
    [sym_macro_invocation] = STATE(1940),
    [aux_sym_declaration_list_repeat1] = STATE(1940),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1159),
    [anon_sym_macro_rules_BANG] = ACTIONS(1161),
    [anon_sym_RBRACE] = ACTIONS(4243),
    [anon_sym_POUND] = ACTIONS(1165),
    [anon_sym_const] = ACTIONS(1167),
    [anon_sym_default] = ACTIONS(1169),
    [anon_sym_enum] = ACTIONS(1171),
    [anon_sym_fn] = ACTIONS(1173),
    [anon_sym_impl] = ACTIONS(1175),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_mod] = ACTIONS(1179),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_struct] = ACTIONS(1183),
    [anon_sym_trait] = ACTIONS(1185),
    [anon_sym_type] = ACTIONS(1187),
    [anon_sym_union] = ACTIONS(1189),
    [anon_sym_unsafe] = ACTIONS(1191),
    [anon_sym_use] = ACTIONS(1193),
    [anon_sym_extern] = ACTIONS(1195),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1197),
  },
  [1252] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(273),
    [anon_sym_default] = ACTIONS(273),
    [anon_sym_fn] = ACTIONS(273),
    [anon_sym_unsafe] = ACTIONS(273),
    [anon_sym_extern] = ACTIONS(273),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4245),
  },
  [1253] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4247),
  },
  [1254] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4249),
  },
  [1255] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_mutable_specifier] = ACTIONS(4251),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4253),
  },
  [1256] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4255),
  },
  [1257] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4257),
  },
  [1258] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4259),
  },
  [1259] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4261),
  },
  [1260] = {
    [sym__use_clause] = STATE(1949),
    [sym_scoped_use_list] = STATE(1949),
    [sym_use_list] = STATE(1949),
    [sym_use_as_clause] = STATE(1949),
    [sym_use_wildcard] = STATE(1949),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_type_with_turbofish] = STATE(212),
    [sym_scoped_identifier] = STATE(213),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(377),
    [anon_sym_u8] = ACTIONS(379),
    [anon_sym_i8] = ACTIONS(379),
    [anon_sym_u16] = ACTIONS(379),
    [anon_sym_i16] = ACTIONS(379),
    [anon_sym_u32] = ACTIONS(379),
    [anon_sym_i32] = ACTIONS(379),
    [anon_sym_u64] = ACTIONS(379),
    [anon_sym_i64] = ACTIONS(379),
    [anon_sym_u128] = ACTIONS(379),
    [anon_sym_i128] = ACTIONS(379),
    [anon_sym_isize] = ACTIONS(379),
    [anon_sym_usize] = ACTIONS(379),
    [anon_sym_f32] = ACTIONS(379),
    [anon_sym_f64] = ACTIONS(379),
    [anon_sym_bool] = ACTIONS(379),
    [anon_sym_str] = ACTIONS(379),
    [anon_sym_char] = ACTIONS(379),
    [anon_sym_COLON_COLON] = ACTIONS(381),
    [anon_sym_LT] = ACTIONS(31),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(383),
    [sym_self] = ACTIONS(385),
    [sym_super] = ACTIONS(385),
    [sym_crate] = ACTIONS(385),
    [sym_metavariable] = ACTIONS(387),
  },
  [1261] = {
    [sym_string_literal] = STATE(217),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_const] = ACTIONS(393),
    [anon_sym_default] = ACTIONS(393),
    [anon_sym_fn] = ACTIONS(393),
    [anon_sym_unsafe] = ACTIONS(393),
    [anon_sym_extern] = ACTIONS(393),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_line_comment] = ACTIONS(7),
    [sym_crate] = ACTIONS(4263),
  },
  [1262] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_fn] = ACTIONS(4265),
    [sym_line_comment] = ACTIONS(7),
  },
  [1263] = {
    [sym_declaration_list] = STATE(1952),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4267),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_default] = ACTIONS(281),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_unsafe] = ACTIONS(281),
    [anon_sym_extern] = ACTIONS(281),
    [sym_line_comment] = ACTIONS(7),
  },
  [1264] = {
    [sym_raw_string_literal] = ACTIONS(4269),
    [sym_float_literal] = ACTIONS(4269),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(4269),
    [anon_sym_SEMI] = ACTIONS(4269),
    [anon_sym_macro_rules_BANG] = ACTIONS(4269),
    [anon_sym_LPAREN] = ACTIONS(4269),
    [anon_sym_LBRACE] = ACTIONS(4269),
    [anon_sym_RBRACE] = ACTIONS(4269),
    [anon_sym_LBRACK] = ACTIONS(4269),
    [anon_sym_STAR] = ACTIONS(4269),
    [anon_sym_u8] = ACTIONS(4271),
    [anon_sym_i8] = ACTIONS(4271),
    [anon_sym_u16] = ACTIONS(4271),
    [anon_sym_i16] = ACTIONS(4271),
    [anon_sym_u32] = ACTIONS(4271),
    [anon_sym_i32] = ACTIONS(4271),
    [anon_sym_u64] = ACTIONS(4271),
    [anon_sym_i64] = ACTIONS(4271),
    [anon_sym_u128] = ACTIONS(4271),
    [anon_sym_i128] = ACTIONS(4271),
    [anon_sym_isize] = ACTIONS(4271),
    [anon_sym_usize] = ACTIONS(4271),
    [anon_sym_f32] = ACTIONS(4271),
    [anon_sym_f64] = ACTIONS(4271),
    [anon_sym_bool] = ACTIONS(4271),
    [anon_sym_str] = ACTIONS(4271),
    [anon_sym_char] = ACTIONS(4271),
    [anon_sym_AMP] = ACTIONS(4269),
    [anon_sym_DASH] = ACTIONS(4269),
    [anon_sym_COLON_COLON] = ACTIONS(4269),
    [anon_sym_BANG] = ACTIONS(4269),
    [anon_sym_POUND] = ACTIONS(4269),
    [anon_sym_LT] = ACTIONS(4269),
    [anon_sym_PIPE] = ACTIONS(4269),
    [anon_sym_SQUOTE] = ACTIONS(4271),
    [anon_sym_DOT_DOT] = ACTIONS(4269),
    [anon_sym_break] = ACTIONS(4271),
    [anon_sym_const] = ACTIONS(4271),
    [anon_sym_continue] = ACTIONS(4271),
    [anon_sym_default] = ACTIONS(4271),
    [anon_sym_enum] = ACTIONS(4271),
    [anon_sym_fn] = ACTIONS(4271),
    [anon_sym_for] = ACTIONS(4271),
    [anon_sym_if] = ACTIONS(4271),
    [anon_sym_impl] = ACTIONS(4271),
    [anon_sym_let] = ACTIONS(4271),
    [anon_sym_loop] = ACTIONS(4271),
    [anon_sym_match] = ACTIONS(4271),
    [anon_sym_mod] = ACTIONS(4271),
    [anon_sym_pub] = ACTIONS(4271),
    [anon_sym_return] = ACTIONS(4271),
    [anon_sym_static] = ACTIONS(4271),
    [anon_sym_struct] = ACTIONS(4271),
    [anon_sym_trait] = ACTIONS(4271),
    [anon_sym_type] = ACTIONS(4271),
    [anon_sym_union] = ACTIONS(4271),
    [anon_sym_unsafe] = ACTIONS(4271),
    [anon_sym_use] = ACTIONS(4271),
    [anon_sym_while] = ACTIONS(4271),
    [anon_sym_extern] = ACTIONS(4271),
    [anon_sym_move] = ACTIONS(4271),
    [sym_integer_literal] = ACTIONS(4269),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(4269),
    [sym_char_literal] = ACTIONS(4269),
    [anon_sym_true] = ACTIONS(4271),
    [anon_sym_false] = ACTIONS(4271),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4271),
    [sym_self] = ACTIONS(4271),
    [sym_super] = ACTIONS(4271),
    [sym_crate] = ACTIONS(4271),
    [sym_metavariable] = ACTIONS(4269),
  },
  [1265] = {
    [sym_empty_statement] = STATE(1265),
    [sym_macro_definition] = STATE(1265),
    [sym_attribute_item] = STATE(1265),
    [sym_inner_attribute_item] = STATE(1265),
    [sym_mod_item] = STATE(1265),
    [sym_foreign_mod_item] = STATE(1265),
    [sym_struct_item] = STATE(1265),
    [sym_union_item] = STATE(1265),
    [sym_enum_item] = STATE(1265),
    [sym_extern_crate_declaration] = STATE(1265),
    [sym_const_item] = STATE(1265),
    [sym_static_item] = STATE(1265),
    [sym_type_item] = STATE(1265),
    [sym_function_item] = STATE(1265),
    [sym_function_signature_item] = STATE(1265),
    [sym_function_modifiers] = STATE(610),
    [sym_impl_item] = STATE(1265),
    [sym_trait_item] = STATE(1265),
    [sym_associated_type] = STATE(1265),
    [sym_let_declaration] = STATE(1265),
    [sym_use_declaration] = STATE(1265),
    [sym_extern_modifier] = STATE(611),
    [sym_visibility_modifier] = STATE(612),
    [sym_macro_invocation] = STATE(1265),
    [aux_sym_declaration_list_repeat1] = STATE(1265),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4273),
    [anon_sym_macro_rules_BANG] = ACTIONS(4276),
    [anon_sym_RBRACE] = ACTIONS(4279),
    [anon_sym_POUND] = ACTIONS(4281),
    [anon_sym_const] = ACTIONS(4284),
    [anon_sym_default] = ACTIONS(4287),
    [anon_sym_enum] = ACTIONS(4290),
    [anon_sym_fn] = ACTIONS(4293),
    [anon_sym_impl] = ACTIONS(4296),
    [anon_sym_let] = ACTIONS(4299),
    [anon_sym_mod] = ACTIONS(4302),
    [anon_sym_pub] = ACTIONS(4305),
    [anon_sym_static] = ACTIONS(4308),
    [anon_sym_struct] = ACTIONS(4311),
    [anon_sym_trait] = ACTIONS(4314),
    [anon_sym_type] = ACTIONS(4317),
    [anon_sym_union] = ACTIONS(4320),
    [anon_sym_unsafe] = ACTIONS(4323),
    [anon_sym_use] = ACTIONS(4326),
    [anon_sym_extern] = ACTIONS(4329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4332),
  },
  [1266] = {
    [sym_function_modifiers] = STATE(929),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1953),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(931),
    [sym_array_type] = STATE(1953),
    [sym_function_type] = STATE(1953),
    [sym_tuple_type] = STATE(1953),
    [sym_unit_type] = STATE(1953),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1953),
    [sym_reference_type] = STATE(1953),
    [sym_pointer_type] = STATE(1953),
    [sym_empty_type] = STATE(1953),
    [sym_dynamic_type] = STATE(1953),
    [sym_macro_invocation] = STATE(1953),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(932),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1928),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1930),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1932),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1934),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1267] = {
    [sym_raw_string_literal] = ACTIONS(4335),
    [sym_float_literal] = ACTIONS(4335),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(4335),
    [anon_sym_SEMI] = ACTIONS(4335),
    [anon_sym_macro_rules_BANG] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(4335),
    [anon_sym_LBRACE] = ACTIONS(4335),
    [anon_sym_RBRACE] = ACTIONS(4335),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_u8] = ACTIONS(4337),
    [anon_sym_i8] = ACTIONS(4337),
    [anon_sym_u16] = ACTIONS(4337),
    [anon_sym_i16] = ACTIONS(4337),
    [anon_sym_u32] = ACTIONS(4337),
    [anon_sym_i32] = ACTIONS(4337),
    [anon_sym_u64] = ACTIONS(4337),
    [anon_sym_i64] = ACTIONS(4337),
    [anon_sym_u128] = ACTIONS(4337),
    [anon_sym_i128] = ACTIONS(4337),
    [anon_sym_isize] = ACTIONS(4337),
    [anon_sym_usize] = ACTIONS(4337),
    [anon_sym_f32] = ACTIONS(4337),
    [anon_sym_f64] = ACTIONS(4337),
    [anon_sym_bool] = ACTIONS(4337),
    [anon_sym_str] = ACTIONS(4337),
    [anon_sym_char] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4335),
    [anon_sym_DASH] = ACTIONS(4335),
    [anon_sym_COLON_COLON] = ACTIONS(4335),
    [anon_sym_BANG] = ACTIONS(4335),
    [anon_sym_POUND] = ACTIONS(4335),
    [anon_sym_LT] = ACTIONS(4335),
    [anon_sym_PIPE] = ACTIONS(4335),
    [anon_sym_SQUOTE] = ACTIONS(4337),
    [anon_sym_DOT_DOT] = ACTIONS(4335),
    [anon_sym_break] = ACTIONS(4337),
    [anon_sym_const] = ACTIONS(4337),
    [anon_sym_continue] = ACTIONS(4337),
    [anon_sym_default] = ACTIONS(4337),
    [anon_sym_enum] = ACTIONS(4337),
    [anon_sym_fn] = ACTIONS(4337),
    [anon_sym_for] = ACTIONS(4337),
    [anon_sym_if] = ACTIONS(4337),
    [anon_sym_impl] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_loop] = ACTIONS(4337),
    [anon_sym_match] = ACTIONS(4337),
    [anon_sym_mod] = ACTIONS(4337),
    [anon_sym_pub] = ACTIONS(4337),
    [anon_sym_return] = ACTIONS(4337),
    [anon_sym_static] = ACTIONS(4337),
    [anon_sym_struct] = ACTIONS(4337),
    [anon_sym_trait] = ACTIONS(4337),
    [anon_sym_type] = ACTIONS(4337),
    [anon_sym_union] = ACTIONS(4337),
    [anon_sym_unsafe] = ACTIONS(4337),
    [anon_sym_use] = ACTIONS(4337),
    [anon_sym_while] = ACTIONS(4337),
    [anon_sym_extern] = ACTIONS(4337),
    [anon_sym_move] = ACTIONS(4337),
    [sym_integer_literal] = ACTIONS(4335),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(4335),
    [sym_char_literal] = ACTIONS(4335),
    [anon_sym_true] = ACTIONS(4337),
    [anon_sym_false] = ACTIONS(4337),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4337),
    [sym_self] = ACTIONS(4337),
    [sym_super] = ACTIONS(4337),
    [sym_crate] = ACTIONS(4337),
    [sym_metavariable] = ACTIONS(4335),
  },
  [1268] = {
    [sym_enum_variant_list] = STATE(1954),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(923),
    [sym_line_comment] = ACTIONS(7),
  },
  [1269] = {
    [sym_enum_variant_list] = STATE(1954),
    [sym_where_clause] = STATE(1955),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [1270] = {
    [sym_raw_string_literal] = ACTIONS(4339),
    [sym_float_literal] = ACTIONS(4339),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(4339),
    [anon_sym_SEMI] = ACTIONS(4339),
    [anon_sym_macro_rules_BANG] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4339),
    [anon_sym_RBRACE] = ACTIONS(4339),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_u8] = ACTIONS(4341),
    [anon_sym_i8] = ACTIONS(4341),
    [anon_sym_u16] = ACTIONS(4341),
    [anon_sym_i16] = ACTIONS(4341),
    [anon_sym_u32] = ACTIONS(4341),
    [anon_sym_i32] = ACTIONS(4341),
    [anon_sym_u64] = ACTIONS(4341),
    [anon_sym_i64] = ACTIONS(4341),
    [anon_sym_u128] = ACTIONS(4341),
    [anon_sym_i128] = ACTIONS(4341),
    [anon_sym_isize] = ACTIONS(4341),
    [anon_sym_usize] = ACTIONS(4341),
    [anon_sym_f32] = ACTIONS(4341),
    [anon_sym_f64] = ACTIONS(4341),
    [anon_sym_bool] = ACTIONS(4341),
    [anon_sym_str] = ACTIONS(4341),
    [anon_sym_char] = ACTIONS(4341),
    [anon_sym_AMP] = ACTIONS(4339),
    [anon_sym_DASH] = ACTIONS(4339),
    [anon_sym_COLON_COLON] = ACTIONS(4339),
    [anon_sym_BANG] = ACTIONS(4339),
    [anon_sym_POUND] = ACTIONS(4339),
    [anon_sym_LT] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4339),
    [anon_sym_SQUOTE] = ACTIONS(4341),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_break] = ACTIONS(4341),
    [anon_sym_const] = ACTIONS(4341),
    [anon_sym_continue] = ACTIONS(4341),
    [anon_sym_default] = ACTIONS(4341),
    [anon_sym_enum] = ACTIONS(4341),
    [anon_sym_fn] = ACTIONS(4341),
    [anon_sym_for] = ACTIONS(4341),
    [anon_sym_if] = ACTIONS(4341),
    [anon_sym_impl] = ACTIONS(4341),
    [anon_sym_let] = ACTIONS(4341),
    [anon_sym_loop] = ACTIONS(4341),
    [anon_sym_match] = ACTIONS(4341),
    [anon_sym_mod] = ACTIONS(4341),
    [anon_sym_pub] = ACTIONS(4341),
    [anon_sym_return] = ACTIONS(4341),
    [anon_sym_static] = ACTIONS(4341),
    [anon_sym_struct] = ACTIONS(4341),
    [anon_sym_trait] = ACTIONS(4341),
    [anon_sym_type] = ACTIONS(4341),
    [anon_sym_union] = ACTIONS(4341),
    [anon_sym_unsafe] = ACTIONS(4341),
    [anon_sym_use] = ACTIONS(4341),
    [anon_sym_while] = ACTIONS(4341),
    [anon_sym_extern] = ACTIONS(4341),
    [anon_sym_move] = ACTIONS(4341),
    [sym_integer_literal] = ACTIONS(4339),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(4339),
    [sym_char_literal] = ACTIONS(4339),
    [anon_sym_true] = ACTIONS(4341),
    [anon_sym_false] = ACTIONS(4341),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4341),
    [sym_self] = ACTIONS(4341),
    [sym_super] = ACTIONS(4341),
    [sym_crate] = ACTIONS(4341),
    [sym_metavariable] = ACTIONS(4339),
  },
  [1271] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(4343),
    [sym_line_comment] = ACTIONS(7),
  },
  [1272] = {
    [sym_raw_string_literal] = ACTIONS(4345),
    [sym_float_literal] = ACTIONS(4345),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(4345),
    [anon_sym_SEMI] = ACTIONS(4345),
    [anon_sym_macro_rules_BANG] = ACTIONS(4345),
    [anon_sym_LPAREN] = ACTIONS(4345),
    [anon_sym_LBRACE] = ACTIONS(4345),
    [anon_sym_RBRACE] = ACTIONS(4345),
    [anon_sym_LBRACK] = ACTIONS(4345),
    [anon_sym_STAR] = ACTIONS(4345),
    [anon_sym_u8] = ACTIONS(4347),
    [anon_sym_i8] = ACTIONS(4347),
    [anon_sym_u16] = ACTIONS(4347),
    [anon_sym_i16] = ACTIONS(4347),
    [anon_sym_u32] = ACTIONS(4347),
    [anon_sym_i32] = ACTIONS(4347),
    [anon_sym_u64] = ACTIONS(4347),
    [anon_sym_i64] = ACTIONS(4347),
    [anon_sym_u128] = ACTIONS(4347),
    [anon_sym_i128] = ACTIONS(4347),
    [anon_sym_isize] = ACTIONS(4347),
    [anon_sym_usize] = ACTIONS(4347),
    [anon_sym_f32] = ACTIONS(4347),
    [anon_sym_f64] = ACTIONS(4347),
    [anon_sym_bool] = ACTIONS(4347),
    [anon_sym_str] = ACTIONS(4347),
    [anon_sym_char] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4345),
    [anon_sym_DASH] = ACTIONS(4345),
    [anon_sym_COLON_COLON] = ACTIONS(4345),
    [anon_sym_BANG] = ACTIONS(4345),
    [anon_sym_POUND] = ACTIONS(4345),
    [anon_sym_LT] = ACTIONS(4345),
    [anon_sym_PIPE] = ACTIONS(4345),
    [anon_sym_SQUOTE] = ACTIONS(4347),
    [anon_sym_DOT_DOT] = ACTIONS(4345),
    [anon_sym_break] = ACTIONS(4347),
    [anon_sym_const] = ACTIONS(4347),
    [anon_sym_continue] = ACTIONS(4347),
    [anon_sym_default] = ACTIONS(4347),
    [anon_sym_enum] = ACTIONS(4347),
    [anon_sym_fn] = ACTIONS(4347),
    [anon_sym_for] = ACTIONS(4347),
    [anon_sym_if] = ACTIONS(4347),
    [anon_sym_impl] = ACTIONS(4347),
    [anon_sym_let] = ACTIONS(4347),
    [anon_sym_loop] = ACTIONS(4347),
    [anon_sym_match] = ACTIONS(4347),
    [anon_sym_mod] = ACTIONS(4347),
    [anon_sym_pub] = ACTIONS(4347),
    [anon_sym_return] = ACTIONS(4347),
    [anon_sym_static] = ACTIONS(4347),
    [anon_sym_struct] = ACTIONS(4347),
    [anon_sym_trait] = ACTIONS(4347),
    [anon_sym_type] = ACTIONS(4347),
    [anon_sym_union] = ACTIONS(4347),
    [anon_sym_unsafe] = ACTIONS(4347),
    [anon_sym_use] = ACTIONS(4347),
    [anon_sym_while] = ACTIONS(4347),
    [anon_sym_extern] = ACTIONS(4347),
    [anon_sym_move] = ACTIONS(4347),
    [sym_integer_literal] = ACTIONS(4345),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(4345),
    [sym_char_literal] = ACTIONS(4345),
    [anon_sym_true] = ACTIONS(4347),
    [anon_sym_false] = ACTIONS(4347),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4347),
    [sym_self] = ACTIONS(4347),
    [sym_super] = ACTIONS(4347),
    [sym_crate] = ACTIONS(4347),
    [sym_metavariable] = ACTIONS(4345),
  },
  [1273] = {
    [sym_where_clause] = STATE(1958),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4349),
    [anon_sym_where] = ACTIONS(2138),
    [sym_line_comment] = ACTIONS(7),
  },
  [1274] = {
    [sym_field_declaration_list] = STATE(1957),
    [sym_ordered_field_declaration_list] = STATE(1959),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4349),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(1055),
    [sym_line_comment] = ACTIONS(7),
  },
  [1275] = {
    [sym_field_declaration_list] = STATE(1957),
    [sym_ordered_field_declaration_list] = STATE(1959),
    [sym_where_clause] = STATE(1960),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4349),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(1057),
    [sym_line_comment] = ACTIONS(7),
  },
  [1276] = {
    [sym_raw_string_literal] = ACTIONS(4351),
    [sym_float_literal] = ACTIONS(4351),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(4351),
    [anon_sym_SEMI] = ACTIONS(4351),
    [anon_sym_macro_rules_BANG] = ACTIONS(4351),
    [anon_sym_LPAREN] = ACTIONS(4351),
    [anon_sym_LBRACE] = ACTIONS(4351),
    [anon_sym_RBRACE] = ACTIONS(4351),
    [anon_sym_LBRACK] = ACTIONS(4351),
    [anon_sym_STAR] = ACTIONS(4351),
    [anon_sym_u8] = ACTIONS(4353),
    [anon_sym_i8] = ACTIONS(4353),
    [anon_sym_u16] = ACTIONS(4353),
    [anon_sym_i16] = ACTIONS(4353),
    [anon_sym_u32] = ACTIONS(4353),
    [anon_sym_i32] = ACTIONS(4353),
    [anon_sym_u64] = ACTIONS(4353),
    [anon_sym_i64] = ACTIONS(4353),
    [anon_sym_u128] = ACTIONS(4353),
    [anon_sym_i128] = ACTIONS(4353),
    [anon_sym_isize] = ACTIONS(4353),
    [anon_sym_usize] = ACTIONS(4353),
    [anon_sym_f32] = ACTIONS(4353),
    [anon_sym_f64] = ACTIONS(4353),
    [anon_sym_bool] = ACTIONS(4353),
    [anon_sym_str] = ACTIONS(4353),
    [anon_sym_char] = ACTIONS(4353),
    [anon_sym_AMP] = ACTIONS(4351),
    [anon_sym_DASH] = ACTIONS(4351),
    [anon_sym_COLON_COLON] = ACTIONS(4351),
    [anon_sym_BANG] = ACTIONS(4351),
    [anon_sym_POUND] = ACTIONS(4351),
    [anon_sym_LT] = ACTIONS(4351),
    [anon_sym_PIPE] = ACTIONS(4351),
    [anon_sym_SQUOTE] = ACTIONS(4353),
    [anon_sym_DOT_DOT] = ACTIONS(4351),
    [anon_sym_break] = ACTIONS(4353),
    [anon_sym_const] = ACTIONS(4353),
    [anon_sym_continue] = ACTIONS(4353),
    [anon_sym_default] = ACTIONS(4353),
    [anon_sym_enum] = ACTIONS(4353),
    [anon_sym_fn] = ACTIONS(4353),
    [anon_sym_for] = ACTIONS(4353),
    [anon_sym_if] = ACTIONS(4353),
    [anon_sym_impl] = ACTIONS(4353),
    [anon_sym_let] = ACTIONS(4353),
    [anon_sym_loop] = ACTIONS(4353),
    [anon_sym_match] = ACTIONS(4353),
    [anon_sym_mod] = ACTIONS(4353),
    [anon_sym_pub] = ACTIONS(4353),
    [anon_sym_return] = ACTIONS(4353),
    [anon_sym_static] = ACTIONS(4353),
    [anon_sym_struct] = ACTIONS(4353),
    [anon_sym_trait] = ACTIONS(4353),
    [anon_sym_type] = ACTIONS(4353),
    [anon_sym_union] = ACTIONS(4353),
    [anon_sym_unsafe] = ACTIONS(4353),
    [anon_sym_use] = ACTIONS(4353),
    [anon_sym_while] = ACTIONS(4353),
    [anon_sym_extern] = ACTIONS(4353),
    [anon_sym_move] = ACTIONS(4353),
    [sym_integer_literal] = ACTIONS(4351),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(4351),
    [sym_char_literal] = ACTIONS(4351),
    [anon_sym_true] = ACTIONS(4353),
    [anon_sym_false] = ACTIONS(4353),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4353),
    [sym_self] = ACTIONS(4353),
    [sym_super] = ACTIONS(4353),
    [sym_crate] = ACTIONS(4353),
    [sym_metavariable] = ACTIONS(4351),
  },
  [1277] = {
    [sym_declaration_list] = STATE(1961),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [sym_line_comment] = ACTIONS(7),
  },
  [1278] = {
    [sym_declaration_list] = STATE(1961),
    [sym_trait_bounds] = STATE(1962),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_COLON] = ACTIONS(1059),
    [sym_line_comment] = ACTIONS(7),
  },
  [1279] = {
    [sym_function_modifiers] = STATE(1097),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1963),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1102),
    [sym_array_type] = STATE(1963),
    [sym_function_type] = STATE(1963),
    [sym_tuple_type] = STATE(1963),
    [sym_unit_type] = STATE(1963),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1963),
    [sym_reference_type] = STATE(1963),
    [sym_pointer_type] = STATE(1963),
    [sym_empty_type] = STATE(1963),
    [sym_dynamic_type] = STATE(1963),
    [sym_macro_invocation] = STATE(1963),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2156),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2162),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2166),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1280] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(4355),
    [sym_line_comment] = ACTIONS(7),
  },
  [1281] = {
    [sym_raw_string_literal] = ACTIONS(4357),
    [sym_float_literal] = ACTIONS(4357),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(4357),
    [anon_sym_SEMI] = ACTIONS(4357),
    [anon_sym_macro_rules_BANG] = ACTIONS(4357),
    [anon_sym_LPAREN] = ACTIONS(4357),
    [anon_sym_LBRACE] = ACTIONS(4357),
    [anon_sym_RBRACE] = ACTIONS(4357),
    [anon_sym_LBRACK] = ACTIONS(4357),
    [anon_sym_STAR] = ACTIONS(4357),
    [anon_sym_u8] = ACTIONS(4359),
    [anon_sym_i8] = ACTIONS(4359),
    [anon_sym_u16] = ACTIONS(4359),
    [anon_sym_i16] = ACTIONS(4359),
    [anon_sym_u32] = ACTIONS(4359),
    [anon_sym_i32] = ACTIONS(4359),
    [anon_sym_u64] = ACTIONS(4359),
    [anon_sym_i64] = ACTIONS(4359),
    [anon_sym_u128] = ACTIONS(4359),
    [anon_sym_i128] = ACTIONS(4359),
    [anon_sym_isize] = ACTIONS(4359),
    [anon_sym_usize] = ACTIONS(4359),
    [anon_sym_f32] = ACTIONS(4359),
    [anon_sym_f64] = ACTIONS(4359),
    [anon_sym_bool] = ACTIONS(4359),
    [anon_sym_str] = ACTIONS(4359),
    [anon_sym_char] = ACTIONS(4359),
    [anon_sym_AMP] = ACTIONS(4357),
    [anon_sym_DASH] = ACTIONS(4357),
    [anon_sym_COLON_COLON] = ACTIONS(4357),
    [anon_sym_BANG] = ACTIONS(4357),
    [anon_sym_POUND] = ACTIONS(4357),
    [anon_sym_LT] = ACTIONS(4357),
    [anon_sym_PIPE] = ACTIONS(4357),
    [anon_sym_SQUOTE] = ACTIONS(4359),
    [anon_sym_DOT_DOT] = ACTIONS(4357),
    [anon_sym_break] = ACTIONS(4359),
    [anon_sym_const] = ACTIONS(4359),
    [anon_sym_continue] = ACTIONS(4359),
    [anon_sym_default] = ACTIONS(4359),
    [anon_sym_enum] = ACTIONS(4359),
    [anon_sym_fn] = ACTIONS(4359),
    [anon_sym_for] = ACTIONS(4359),
    [anon_sym_if] = ACTIONS(4359),
    [anon_sym_impl] = ACTIONS(4359),
    [anon_sym_let] = ACTIONS(4359),
    [anon_sym_loop] = ACTIONS(4359),
    [anon_sym_match] = ACTIONS(4359),
    [anon_sym_mod] = ACTIONS(4359),
    [anon_sym_pub] = ACTIONS(4359),
    [anon_sym_return] = ACTIONS(4359),
    [anon_sym_static] = ACTIONS(4359),
    [anon_sym_struct] = ACTIONS(4359),
    [anon_sym_trait] = ACTIONS(4359),
    [anon_sym_type] = ACTIONS(4359),
    [anon_sym_union] = ACTIONS(4359),
    [anon_sym_unsafe] = ACTIONS(4359),
    [anon_sym_use] = ACTIONS(4359),
    [anon_sym_while] = ACTIONS(4359),
    [anon_sym_extern] = ACTIONS(4359),
    [anon_sym_move] = ACTIONS(4359),
    [sym_integer_literal] = ACTIONS(4357),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(4357),
    [sym_char_literal] = ACTIONS(4357),
    [anon_sym_true] = ACTIONS(4359),
    [anon_sym_false] = ACTIONS(4359),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4359),
    [sym_self] = ACTIONS(4359),
    [sym_super] = ACTIONS(4359),
    [sym_crate] = ACTIONS(4359),
    [sym_metavariable] = ACTIONS(4357),
  },
  [1282] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4361),
    [sym_line_comment] = ACTIONS(7),
  },
  [1283] = {
    [sym_field_declaration_list] = STATE(1965),
    [sym_ordered_field_declaration_list] = STATE(1966),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4361),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(1055),
    [sym_line_comment] = ACTIONS(7),
  },
  [1284] = {
    [sym_field_declaration_list] = STATE(1965),
    [sym_ordered_field_declaration_list] = STATE(1966),
    [sym_where_clause] = STATE(1967),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4361),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(1055),
    [anon_sym_where] = ACTIONS(1057),
    [sym_line_comment] = ACTIONS(7),
  },
  [1285] = {
    [sym_raw_string_literal] = ACTIONS(4363),
    [sym_float_literal] = ACTIONS(4363),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(4363),
    [anon_sym_SEMI] = ACTIONS(4363),
    [anon_sym_macro_rules_BANG] = ACTIONS(4363),
    [anon_sym_LPAREN] = ACTIONS(4363),
    [anon_sym_LBRACE] = ACTIONS(4363),
    [anon_sym_RBRACE] = ACTIONS(4363),
    [anon_sym_LBRACK] = ACTIONS(4363),
    [anon_sym_STAR] = ACTIONS(4363),
    [anon_sym_u8] = ACTIONS(4365),
    [anon_sym_i8] = ACTIONS(4365),
    [anon_sym_u16] = ACTIONS(4365),
    [anon_sym_i16] = ACTIONS(4365),
    [anon_sym_u32] = ACTIONS(4365),
    [anon_sym_i32] = ACTIONS(4365),
    [anon_sym_u64] = ACTIONS(4365),
    [anon_sym_i64] = ACTIONS(4365),
    [anon_sym_u128] = ACTIONS(4365),
    [anon_sym_i128] = ACTIONS(4365),
    [anon_sym_isize] = ACTIONS(4365),
    [anon_sym_usize] = ACTIONS(4365),
    [anon_sym_f32] = ACTIONS(4365),
    [anon_sym_f64] = ACTIONS(4365),
    [anon_sym_bool] = ACTIONS(4365),
    [anon_sym_str] = ACTIONS(4365),
    [anon_sym_char] = ACTIONS(4365),
    [anon_sym_AMP] = ACTIONS(4363),
    [anon_sym_DASH] = ACTIONS(4363),
    [anon_sym_COLON_COLON] = ACTIONS(4363),
    [anon_sym_BANG] = ACTIONS(4363),
    [anon_sym_POUND] = ACTIONS(4363),
    [anon_sym_LT] = ACTIONS(4363),
    [anon_sym_PIPE] = ACTIONS(4363),
    [anon_sym_SQUOTE] = ACTIONS(4365),
    [anon_sym_DOT_DOT] = ACTIONS(4363),
    [anon_sym_break] = ACTIONS(4365),
    [anon_sym_const] = ACTIONS(4365),
    [anon_sym_continue] = ACTIONS(4365),
    [anon_sym_default] = ACTIONS(4365),
    [anon_sym_enum] = ACTIONS(4365),
    [anon_sym_fn] = ACTIONS(4365),
    [anon_sym_for] = ACTIONS(4365),
    [anon_sym_if] = ACTIONS(4365),
    [anon_sym_impl] = ACTIONS(4365),
    [anon_sym_let] = ACTIONS(4365),
    [anon_sym_loop] = ACTIONS(4365),
    [anon_sym_match] = ACTIONS(4365),
    [anon_sym_mod] = ACTIONS(4365),
    [anon_sym_pub] = ACTIONS(4365),
    [anon_sym_return] = ACTIONS(4365),
    [anon_sym_static] = ACTIONS(4365),
    [anon_sym_struct] = ACTIONS(4365),
    [anon_sym_trait] = ACTIONS(4365),
    [anon_sym_type] = ACTIONS(4365),
    [anon_sym_union] = ACTIONS(4365),
    [anon_sym_unsafe] = ACTIONS(4365),
    [anon_sym_use] = ACTIONS(4365),
    [anon_sym_while] = ACTIONS(4365),
    [anon_sym_extern] = ACTIONS(4365),
    [anon_sym_move] = ACTIONS(4365),
    [sym_integer_literal] = ACTIONS(4363),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(4363),
    [sym_char_literal] = ACTIONS(4363),
    [anon_sym_true] = ACTIONS(4365),
    [anon_sym_false] = ACTIONS(4365),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4365),
    [sym_self] = ACTIONS(4365),
    [sym_super] = ACTIONS(4365),
    [sym_crate] = ACTIONS(4365),
    [sym_metavariable] = ACTIONS(4363),
  },
  [1286] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4367),
    [anon_sym_as] = ACTIONS(4369),
    [sym_line_comment] = ACTIONS(7),
  },
  [1287] = {
    [sym_type_parameters] = STATE(1970),
    [sym_parameters] = STATE(1891),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(925),
    [sym_line_comment] = ACTIONS(7),
  },
  [1288] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4371),
    [anon_sym_LPAREN] = ACTIONS(4371),
    [anon_sym_RPAREN] = ACTIONS(4371),
    [anon_sym_LBRACE] = ACTIONS(4371),
    [anon_sym_RBRACE] = ACTIONS(4371),
    [anon_sym_LBRACK] = ACTIONS(4371),
    [anon_sym_RBRACK] = ACTIONS(4371),
    [anon_sym_PLUS] = ACTIONS(4373),
    [anon_sym_STAR] = ACTIONS(4373),
    [anon_sym_COMMA] = ACTIONS(4371),
    [anon_sym_AMP] = ACTIONS(4373),
    [anon_sym_DASH] = ACTIONS(4373),
    [anon_sym_DOT] = ACTIONS(4373),
    [anon_sym_DASH_EQ] = ACTIONS(4371),
    [anon_sym_BANG_EQ] = ACTIONS(4371),
    [anon_sym_STAR_EQ] = ACTIONS(4371),
    [anon_sym_SLASH] = ACTIONS(4373),
    [anon_sym_SLASH_EQ] = ACTIONS(4371),
    [anon_sym_AMP_AMP] = ACTIONS(4371),
    [anon_sym_AMP_EQ] = ACTIONS(4371),
    [anon_sym_PERCENT] = ACTIONS(4373),
    [anon_sym_PERCENT_EQ] = ACTIONS(4371),
    [anon_sym_CARET] = ACTIONS(4373),
    [anon_sym_CARET_EQ] = ACTIONS(4371),
    [anon_sym_PLUS_EQ] = ACTIONS(4371),
    [anon_sym_LT] = ACTIONS(4373),
    [anon_sym_LT_LT] = ACTIONS(4373),
    [anon_sym_LT_LT_EQ] = ACTIONS(4371),
    [anon_sym_LT_EQ] = ACTIONS(4371),
    [anon_sym_EQ] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4371),
    [anon_sym_GT] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4371),
    [anon_sym_GT_GT] = ACTIONS(4373),
    [anon_sym_GT_GT_EQ] = ACTIONS(4371),
    [anon_sym_PIPE] = ACTIONS(4373),
    [anon_sym_PIPE_EQ] = ACTIONS(4371),
    [anon_sym_PIPE_PIPE] = ACTIONS(4371),
    [anon_sym_QMARK] = ACTIONS(4371),
    [anon_sym_DOT_DOT] = ACTIONS(4373),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4371),
    [anon_sym_as] = ACTIONS(4371),
    [sym_line_comment] = ACTIONS(7),
  },
  [1289] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1972),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1972),
    [sym_unary_expression] = STATE(1972),
    [sym_try_expression] = STATE(1972),
    [sym_reference_expression] = STATE(1972),
    [sym_binary_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1972),
    [sym_call_expression] = STATE(1972),
    [sym_array_expression] = STATE(1972),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_tuple_expression] = STATE(1972),
    [sym_unit_expression] = STATE(1972),
    [sym_struct_expression] = STATE(1972),
    [sym_if_expression] = STATE(1972),
    [sym_if_let_expression] = STATE(1972),
    [sym_match_expression] = STATE(1972),
    [sym_while_expression] = STATE(1972),
    [sym_while_let_expression] = STATE(1972),
    [sym_loop_expression] = STATE(1972),
    [sym_for_expression] = STATE(1972),
    [sym_closure_expression] = STATE(1972),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1972),
    [sym_continue_expression] = STATE(1972),
    [sym_index_expression] = STATE(1972),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1972),
    [sym_block] = STATE(1972),
    [sym__literal] = STATE(1972),
    [sym_string_literal] = STATE(1972),
    [sym_boolean_literal] = STATE(1972),
    [sym_raw_string_literal] = ACTIONS(4375),
    [sym_float_literal] = ACTIONS(4375),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(4377),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(4375),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4375),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1290] = {
    [aux_sym_token_tree_repeat2] = STATE(1974),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(4377),
    [anon_sym_COMMA] = ACTIONS(4379),
    [sym_line_comment] = ACTIONS(7),
  },
  [1291] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(361),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(361),
    [sym_macro_invocation] = STATE(361),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(361),
    [sym_unary_expression] = STATE(361),
    [sym_try_expression] = STATE(361),
    [sym_reference_expression] = STATE(361),
    [sym_binary_expression] = STATE(361),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(361),
    [sym_call_expression] = STATE(361),
    [sym_array_expression] = STATE(361),
    [sym_parenthesized_expression] = STATE(361),
    [sym_tuple_expression] = STATE(361),
    [sym_unit_expression] = STATE(361),
    [sym_struct_expression] = STATE(361),
    [sym_if_expression] = STATE(361),
    [sym_if_let_expression] = STATE(361),
    [sym_match_expression] = STATE(361),
    [sym_while_expression] = STATE(361),
    [sym_while_let_expression] = STATE(361),
    [sym_loop_expression] = STATE(361),
    [sym_for_expression] = STATE(361),
    [sym_closure_expression] = STATE(361),
    [sym_closure_parameters] = STATE(638),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(361),
    [sym_continue_expression] = STATE(361),
    [sym_index_expression] = STATE(361),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(361),
    [sym_block] = STATE(361),
    [sym__literal] = STATE(361),
    [sym_string_literal] = STATE(361),
    [sym_boolean_literal] = STATE(361),
    [sym_raw_string_literal] = ACTIONS(715),
    [sym_float_literal] = ACTIONS(715),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1245),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1247),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1251),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1253),
    [sym_integer_literal] = ACTIONS(715),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(715),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1292] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_LT_LT] = ACTIONS(2573),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(2565),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_GT_EQ] = ACTIONS(2565),
    [anon_sym_GT_GT] = ACTIONS(2573),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(2579),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_as] = ACTIONS(909),
    [sym_line_comment] = ACTIONS(7),
  },
  [1293] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(1975),
    [sym_tuple_pattern] = STATE(1975),
    [sym_tuple_struct_pattern] = STATE(1975),
    [sym_struct_pattern] = STATE(1975),
    [sym_remaining_field_pattern] = STATE(1975),
    [sym_mut_pattern] = STATE(1975),
    [sym_ref_pattern] = STATE(1975),
    [sym_captured_pattern] = STATE(1975),
    [sym_reference_pattern] = STATE(1975),
    [sym__literal] = STATE(1975),
    [sym_string_literal] = STATE(1975),
    [sym_boolean_literal] = STATE(1975),
    [sym_raw_string_literal] = ACTIONS(4381),
    [sym_float_literal] = ACTIONS(4381),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(955),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(957),
    [anon_sym_ref] = ACTIONS(959),
    [sym_integer_literal] = ACTIONS(4381),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(4381),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(961),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [1294] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(1976),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [1295] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(1043),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(1043),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_STAR_EQ] = ACTIONS(1043),
    [anon_sym_SLASH] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(1043),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_AMP_EQ] = ACTIONS(1043),
    [anon_sym_PERCENT] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(1043),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_CARET_EQ] = ACTIONS(1043),
    [anon_sym_PLUS_EQ] = ACTIONS(1043),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_LT_LT] = ACTIONS(2573),
    [anon_sym_LT_LT_EQ] = ACTIONS(1043),
    [anon_sym_LT_EQ] = ACTIONS(2565),
    [anon_sym_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_GT_EQ] = ACTIONS(2565),
    [anon_sym_GT_GT] = ACTIONS(2573),
    [anon_sym_GT_GT_EQ] = ACTIONS(1043),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_PIPE_EQ] = ACTIONS(1043),
    [anon_sym_PIPE_PIPE] = ACTIONS(2579),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(2581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2583),
    [anon_sym_as] = ACTIONS(1043),
    [sym_line_comment] = ACTIONS(7),
  },
  [1296] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1977),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1977),
    [sym_macro_invocation] = STATE(1977),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1977),
    [sym_unary_expression] = STATE(1977),
    [sym_try_expression] = STATE(1977),
    [sym_reference_expression] = STATE(1977),
    [sym_binary_expression] = STATE(1977),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1977),
    [sym_call_expression] = STATE(1977),
    [sym_array_expression] = STATE(1977),
    [sym_parenthesized_expression] = STATE(1977),
    [sym_tuple_expression] = STATE(1977),
    [sym_unit_expression] = STATE(1977),
    [sym_struct_expression] = STATE(1977),
    [sym_if_expression] = STATE(1977),
    [sym_if_let_expression] = STATE(1977),
    [sym_match_expression] = STATE(1977),
    [sym_while_expression] = STATE(1977),
    [sym_while_let_expression] = STATE(1977),
    [sym_loop_expression] = STATE(1977),
    [sym_for_expression] = STATE(1977),
    [sym_closure_expression] = STATE(1977),
    [sym_closure_parameters] = STATE(638),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1977),
    [sym_continue_expression] = STATE(1977),
    [sym_index_expression] = STATE(1977),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1977),
    [sym_block] = STATE(1977),
    [sym__literal] = STATE(1977),
    [sym_string_literal] = STATE(1977),
    [sym_boolean_literal] = STATE(1977),
    [sym_raw_string_literal] = ACTIONS(4385),
    [sym_float_literal] = ACTIONS(4385),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1245),
    [anon_sym_DASH] = ACTIONS(2547),
    [anon_sym_DASH_GT] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1247),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1251),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1253),
    [sym_integer_literal] = ACTIONS(4385),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4385),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1297] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4387),
    [anon_sym_LPAREN] = ACTIONS(4387),
    [anon_sym_RPAREN] = ACTIONS(4387),
    [anon_sym_LBRACE] = ACTIONS(4387),
    [anon_sym_RBRACE] = ACTIONS(4387),
    [anon_sym_LBRACK] = ACTIONS(4387),
    [anon_sym_RBRACK] = ACTIONS(4387),
    [anon_sym_PLUS] = ACTIONS(4389),
    [anon_sym_STAR] = ACTIONS(4389),
    [anon_sym_COMMA] = ACTIONS(4387),
    [anon_sym_AMP] = ACTIONS(4389),
    [anon_sym_DASH] = ACTIONS(4389),
    [anon_sym_DOT] = ACTIONS(4389),
    [anon_sym_DASH_EQ] = ACTIONS(4387),
    [anon_sym_BANG_EQ] = ACTIONS(4387),
    [anon_sym_STAR_EQ] = ACTIONS(4387),
    [anon_sym_SLASH] = ACTIONS(4389),
    [anon_sym_SLASH_EQ] = ACTIONS(4387),
    [anon_sym_AMP_AMP] = ACTIONS(4387),
    [anon_sym_AMP_EQ] = ACTIONS(4387),
    [anon_sym_PERCENT] = ACTIONS(4389),
    [anon_sym_PERCENT_EQ] = ACTIONS(4387),
    [anon_sym_CARET] = ACTIONS(4389),
    [anon_sym_CARET_EQ] = ACTIONS(4387),
    [anon_sym_PLUS_EQ] = ACTIONS(4387),
    [anon_sym_LT] = ACTIONS(4389),
    [anon_sym_LT_LT] = ACTIONS(4389),
    [anon_sym_LT_LT_EQ] = ACTIONS(4387),
    [anon_sym_LT_EQ] = ACTIONS(4387),
    [anon_sym_EQ] = ACTIONS(4389),
    [anon_sym_EQ_EQ] = ACTIONS(4387),
    [anon_sym_GT] = ACTIONS(4389),
    [anon_sym_GT_EQ] = ACTIONS(4387),
    [anon_sym_GT_GT] = ACTIONS(4389),
    [anon_sym_GT_GT_EQ] = ACTIONS(4387),
    [anon_sym_PIPE] = ACTIONS(4389),
    [anon_sym_PIPE_EQ] = ACTIONS(4387),
    [anon_sym_PIPE_PIPE] = ACTIONS(4387),
    [anon_sym_QMARK] = ACTIONS(4387),
    [anon_sym_DOT_DOT] = ACTIONS(4389),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4387),
    [anon_sym_as] = ACTIONS(4387),
    [sym_line_comment] = ACTIONS(7),
  },
  [1298] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1978),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1978),
    [sym_macro_invocation] = STATE(1978),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1978),
    [sym_unary_expression] = STATE(1978),
    [sym_try_expression] = STATE(1978),
    [sym_reference_expression] = STATE(1978),
    [sym_binary_expression] = STATE(1978),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1978),
    [sym_call_expression] = STATE(1978),
    [sym_array_expression] = STATE(1978),
    [sym_parenthesized_expression] = STATE(1978),
    [sym_tuple_expression] = STATE(1978),
    [sym_unit_expression] = STATE(1978),
    [sym_struct_expression] = STATE(1978),
    [sym_if_expression] = STATE(1978),
    [sym_if_let_expression] = STATE(1978),
    [sym_match_expression] = STATE(1978),
    [sym_while_expression] = STATE(1978),
    [sym_while_let_expression] = STATE(1978),
    [sym_loop_expression] = STATE(1978),
    [sym_for_expression] = STATE(1978),
    [sym_closure_expression] = STATE(1978),
    [sym_closure_parameters] = STATE(638),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1978),
    [sym_continue_expression] = STATE(1978),
    [sym_index_expression] = STATE(1978),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1978),
    [sym_block] = STATE(1978),
    [sym__literal] = STATE(1978),
    [sym_string_literal] = STATE(1978),
    [sym_boolean_literal] = STATE(1978),
    [sym_raw_string_literal] = ACTIONS(4391),
    [sym_float_literal] = ACTIONS(4391),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1245),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1247),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1251),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1253),
    [sym_integer_literal] = ACTIONS(4391),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4391),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1299] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(640),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(640),
    [sym_macro_invocation] = STATE(640),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(640),
    [sym_unary_expression] = STATE(640),
    [sym_try_expression] = STATE(640),
    [sym_reference_expression] = STATE(640),
    [sym_binary_expression] = STATE(640),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(640),
    [sym_call_expression] = STATE(640),
    [sym_array_expression] = STATE(640),
    [sym_parenthesized_expression] = STATE(640),
    [sym_tuple_expression] = STATE(640),
    [sym_unit_expression] = STATE(640),
    [sym_struct_expression] = STATE(640),
    [sym_if_expression] = STATE(640),
    [sym_if_let_expression] = STATE(640),
    [sym_match_expression] = STATE(640),
    [sym_while_expression] = STATE(640),
    [sym_while_let_expression] = STATE(640),
    [sym_loop_expression] = STATE(640),
    [sym_for_expression] = STATE(640),
    [sym_closure_expression] = STATE(640),
    [sym_closure_parameters] = STATE(638),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(640),
    [sym_continue_expression] = STATE(640),
    [sym_index_expression] = STATE(640),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(640),
    [sym_block] = STATE(640),
    [sym__literal] = STATE(640),
    [sym_string_literal] = STATE(640),
    [sym_boolean_literal] = STATE(640),
    [sym_raw_string_literal] = ACTIONS(1257),
    [sym_float_literal] = ACTIONS(1257),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1245),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1247),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1251),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1253),
    [sym_integer_literal] = ACTIONS(1257),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1257),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1300] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1979),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1979),
    [sym_macro_invocation] = STATE(1979),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1979),
    [sym_unary_expression] = STATE(1979),
    [sym_try_expression] = STATE(1979),
    [sym_reference_expression] = STATE(1979),
    [sym_binary_expression] = STATE(1979),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1979),
    [sym_call_expression] = STATE(1979),
    [sym_array_expression] = STATE(1979),
    [sym_parenthesized_expression] = STATE(1979),
    [sym_tuple_expression] = STATE(1979),
    [sym_unit_expression] = STATE(1979),
    [sym_struct_expression] = STATE(1979),
    [sym_if_expression] = STATE(1979),
    [sym_if_let_expression] = STATE(1979),
    [sym_match_expression] = STATE(1979),
    [sym_while_expression] = STATE(1979),
    [sym_while_let_expression] = STATE(1979),
    [sym_loop_expression] = STATE(1979),
    [sym_for_expression] = STATE(1979),
    [sym_closure_expression] = STATE(1979),
    [sym_closure_parameters] = STATE(638),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1979),
    [sym_continue_expression] = STATE(1979),
    [sym_index_expression] = STATE(1979),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1979),
    [sym_block] = STATE(1979),
    [sym__literal] = STATE(1979),
    [sym_string_literal] = STATE(1979),
    [sym_boolean_literal] = STATE(1979),
    [sym_raw_string_literal] = ACTIONS(4393),
    [sym_float_literal] = ACTIONS(4393),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1245),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1247),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1251),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1253),
    [sym_integer_literal] = ACTIONS(4393),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4393),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1301] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1980),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1980),
    [sym_macro_invocation] = STATE(1980),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_try_expression] = STATE(1980),
    [sym_reference_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1980),
    [sym_call_expression] = STATE(1980),
    [sym_array_expression] = STATE(1980),
    [sym_parenthesized_expression] = STATE(1980),
    [sym_tuple_expression] = STATE(1980),
    [sym_unit_expression] = STATE(1980),
    [sym_struct_expression] = STATE(1980),
    [sym_if_expression] = STATE(1980),
    [sym_if_let_expression] = STATE(1980),
    [sym_match_expression] = STATE(1980),
    [sym_while_expression] = STATE(1980),
    [sym_while_let_expression] = STATE(1980),
    [sym_loop_expression] = STATE(1980),
    [sym_for_expression] = STATE(1980),
    [sym_closure_expression] = STATE(1980),
    [sym_closure_parameters] = STATE(638),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1980),
    [sym_continue_expression] = STATE(1980),
    [sym_index_expression] = STATE(1980),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1980),
    [sym_block] = STATE(1980),
    [sym__literal] = STATE(1980),
    [sym_string_literal] = STATE(1980),
    [sym_boolean_literal] = STATE(1980),
    [sym_raw_string_literal] = ACTIONS(4395),
    [sym_float_literal] = ACTIONS(4395),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1245),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1247),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1251),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1253),
    [sym_integer_literal] = ACTIONS(4395),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4395),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1302] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1981),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1981),
    [sym_macro_invocation] = STATE(1981),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1981),
    [sym_unary_expression] = STATE(1981),
    [sym_try_expression] = STATE(1981),
    [sym_reference_expression] = STATE(1981),
    [sym_binary_expression] = STATE(1981),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1981),
    [sym_call_expression] = STATE(1981),
    [sym_array_expression] = STATE(1981),
    [sym_parenthesized_expression] = STATE(1981),
    [sym_tuple_expression] = STATE(1981),
    [sym_unit_expression] = STATE(1981),
    [sym_struct_expression] = STATE(1981),
    [sym_if_expression] = STATE(1981),
    [sym_if_let_expression] = STATE(1981),
    [sym_match_expression] = STATE(1981),
    [sym_while_expression] = STATE(1981),
    [sym_while_let_expression] = STATE(1981),
    [sym_loop_expression] = STATE(1981),
    [sym_for_expression] = STATE(1981),
    [sym_closure_expression] = STATE(1981),
    [sym_closure_parameters] = STATE(638),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1981),
    [sym_continue_expression] = STATE(1981),
    [sym_index_expression] = STATE(1981),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1981),
    [sym_block] = STATE(1981),
    [sym__literal] = STATE(1981),
    [sym_string_literal] = STATE(1981),
    [sym_boolean_literal] = STATE(1981),
    [sym_raw_string_literal] = ACTIONS(4397),
    [sym_float_literal] = ACTIONS(4397),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1245),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1247),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1251),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1253),
    [sym_integer_literal] = ACTIONS(4397),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4397),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1303] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1982),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1982),
    [sym_macro_invocation] = STATE(1982),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1982),
    [sym_unary_expression] = STATE(1982),
    [sym_try_expression] = STATE(1982),
    [sym_reference_expression] = STATE(1982),
    [sym_binary_expression] = STATE(1982),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1982),
    [sym_call_expression] = STATE(1982),
    [sym_array_expression] = STATE(1982),
    [sym_parenthesized_expression] = STATE(1982),
    [sym_tuple_expression] = STATE(1982),
    [sym_unit_expression] = STATE(1982),
    [sym_struct_expression] = STATE(1982),
    [sym_if_expression] = STATE(1982),
    [sym_if_let_expression] = STATE(1982),
    [sym_match_expression] = STATE(1982),
    [sym_while_expression] = STATE(1982),
    [sym_while_let_expression] = STATE(1982),
    [sym_loop_expression] = STATE(1982),
    [sym_for_expression] = STATE(1982),
    [sym_closure_expression] = STATE(1982),
    [sym_closure_parameters] = STATE(638),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1982),
    [sym_continue_expression] = STATE(1982),
    [sym_index_expression] = STATE(1982),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1982),
    [sym_block] = STATE(1982),
    [sym__literal] = STATE(1982),
    [sym_string_literal] = STATE(1982),
    [sym_boolean_literal] = STATE(1982),
    [sym_raw_string_literal] = ACTIONS(4399),
    [sym_float_literal] = ACTIONS(4399),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1245),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1247),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1251),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1253),
    [sym_integer_literal] = ACTIONS(4399),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4399),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1304] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1983),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1983),
    [sym_macro_invocation] = STATE(1983),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1983),
    [sym_unary_expression] = STATE(1983),
    [sym_try_expression] = STATE(1983),
    [sym_reference_expression] = STATE(1983),
    [sym_binary_expression] = STATE(1983),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1983),
    [sym_call_expression] = STATE(1983),
    [sym_array_expression] = STATE(1983),
    [sym_parenthesized_expression] = STATE(1983),
    [sym_tuple_expression] = STATE(1983),
    [sym_unit_expression] = STATE(1983),
    [sym_struct_expression] = STATE(1983),
    [sym_if_expression] = STATE(1983),
    [sym_if_let_expression] = STATE(1983),
    [sym_match_expression] = STATE(1983),
    [sym_while_expression] = STATE(1983),
    [sym_while_let_expression] = STATE(1983),
    [sym_loop_expression] = STATE(1983),
    [sym_for_expression] = STATE(1983),
    [sym_closure_expression] = STATE(1983),
    [sym_closure_parameters] = STATE(638),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1983),
    [sym_continue_expression] = STATE(1983),
    [sym_index_expression] = STATE(1983),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1983),
    [sym_block] = STATE(1983),
    [sym__literal] = STATE(1983),
    [sym_string_literal] = STATE(1983),
    [sym_boolean_literal] = STATE(1983),
    [sym_raw_string_literal] = ACTIONS(4401),
    [sym_float_literal] = ACTIONS(4401),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1245),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1247),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1251),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1253),
    [sym_integer_literal] = ACTIONS(4401),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4401),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1305] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1984),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1984),
    [sym_macro_invocation] = STATE(1984),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1984),
    [sym_unary_expression] = STATE(1984),
    [sym_try_expression] = STATE(1984),
    [sym_reference_expression] = STATE(1984),
    [sym_binary_expression] = STATE(1984),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1984),
    [sym_call_expression] = STATE(1984),
    [sym_array_expression] = STATE(1984),
    [sym_parenthesized_expression] = STATE(1984),
    [sym_tuple_expression] = STATE(1984),
    [sym_unit_expression] = STATE(1984),
    [sym_struct_expression] = STATE(1984),
    [sym_if_expression] = STATE(1984),
    [sym_if_let_expression] = STATE(1984),
    [sym_match_expression] = STATE(1984),
    [sym_while_expression] = STATE(1984),
    [sym_while_let_expression] = STATE(1984),
    [sym_loop_expression] = STATE(1984),
    [sym_for_expression] = STATE(1984),
    [sym_closure_expression] = STATE(1984),
    [sym_closure_parameters] = STATE(638),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1984),
    [sym_continue_expression] = STATE(1984),
    [sym_index_expression] = STATE(1984),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1984),
    [sym_block] = STATE(1984),
    [sym__literal] = STATE(1984),
    [sym_string_literal] = STATE(1984),
    [sym_boolean_literal] = STATE(1984),
    [sym_raw_string_literal] = ACTIONS(4403),
    [sym_float_literal] = ACTIONS(4403),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1245),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1247),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1251),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1253),
    [sym_integer_literal] = ACTIONS(4403),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4403),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1306] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1985),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1985),
    [sym_macro_invocation] = STATE(1985),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1985),
    [sym_unary_expression] = STATE(1985),
    [sym_try_expression] = STATE(1985),
    [sym_reference_expression] = STATE(1985),
    [sym_binary_expression] = STATE(1985),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1985),
    [sym_call_expression] = STATE(1985),
    [sym_array_expression] = STATE(1985),
    [sym_parenthesized_expression] = STATE(1985),
    [sym_tuple_expression] = STATE(1985),
    [sym_unit_expression] = STATE(1985),
    [sym_struct_expression] = STATE(1985),
    [sym_if_expression] = STATE(1985),
    [sym_if_let_expression] = STATE(1985),
    [sym_match_expression] = STATE(1985),
    [sym_while_expression] = STATE(1985),
    [sym_while_let_expression] = STATE(1985),
    [sym_loop_expression] = STATE(1985),
    [sym_for_expression] = STATE(1985),
    [sym_closure_expression] = STATE(1985),
    [sym_closure_parameters] = STATE(638),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1985),
    [sym_continue_expression] = STATE(1985),
    [sym_index_expression] = STATE(1985),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1985),
    [sym_block] = STATE(1985),
    [sym__literal] = STATE(1985),
    [sym_string_literal] = STATE(1985),
    [sym_boolean_literal] = STATE(1985),
    [sym_raw_string_literal] = ACTIONS(4405),
    [sym_float_literal] = ACTIONS(4405),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1245),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1247),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1251),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1253),
    [sym_integer_literal] = ACTIONS(4405),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4405),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1307] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1986),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1986),
    [sym_macro_invocation] = STATE(1986),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1986),
    [sym_unary_expression] = STATE(1986),
    [sym_try_expression] = STATE(1986),
    [sym_reference_expression] = STATE(1986),
    [sym_binary_expression] = STATE(1986),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1986),
    [sym_call_expression] = STATE(1986),
    [sym_array_expression] = STATE(1986),
    [sym_parenthesized_expression] = STATE(1986),
    [sym_tuple_expression] = STATE(1986),
    [sym_unit_expression] = STATE(1986),
    [sym_struct_expression] = STATE(1986),
    [sym_if_expression] = STATE(1986),
    [sym_if_let_expression] = STATE(1986),
    [sym_match_expression] = STATE(1986),
    [sym_while_expression] = STATE(1986),
    [sym_while_let_expression] = STATE(1986),
    [sym_loop_expression] = STATE(1986),
    [sym_for_expression] = STATE(1986),
    [sym_closure_expression] = STATE(1986),
    [sym_closure_parameters] = STATE(638),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1986),
    [sym_continue_expression] = STATE(1986),
    [sym_index_expression] = STATE(1986),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1986),
    [sym_block] = STATE(1986),
    [sym__literal] = STATE(1986),
    [sym_string_literal] = STATE(1986),
    [sym_boolean_literal] = STATE(1986),
    [sym_raw_string_literal] = ACTIONS(4407),
    [sym_float_literal] = ACTIONS(4407),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1245),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1247),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1251),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1253),
    [sym_integer_literal] = ACTIONS(4407),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4407),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1308] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1987),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1987),
    [sym_macro_invocation] = STATE(1987),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1987),
    [sym_unary_expression] = STATE(1987),
    [sym_try_expression] = STATE(1987),
    [sym_reference_expression] = STATE(1987),
    [sym_binary_expression] = STATE(1987),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1987),
    [sym_call_expression] = STATE(1987),
    [sym_array_expression] = STATE(1987),
    [sym_parenthesized_expression] = STATE(1987),
    [sym_tuple_expression] = STATE(1987),
    [sym_unit_expression] = STATE(1987),
    [sym_struct_expression] = STATE(1987),
    [sym_if_expression] = STATE(1987),
    [sym_if_let_expression] = STATE(1987),
    [sym_match_expression] = STATE(1987),
    [sym_while_expression] = STATE(1987),
    [sym_while_let_expression] = STATE(1987),
    [sym_loop_expression] = STATE(1987),
    [sym_for_expression] = STATE(1987),
    [sym_closure_expression] = STATE(1987),
    [sym_closure_parameters] = STATE(638),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1987),
    [sym_continue_expression] = STATE(1987),
    [sym_index_expression] = STATE(1987),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1987),
    [sym_block] = STATE(1987),
    [sym__literal] = STATE(1987),
    [sym_string_literal] = STATE(1987),
    [sym_boolean_literal] = STATE(1987),
    [sym_raw_string_literal] = ACTIONS(4409),
    [sym_float_literal] = ACTIONS(4409),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1245),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1247),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1251),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1253),
    [sym_integer_literal] = ACTIONS(4409),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4409),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1309] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1988),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1988),
    [sym_macro_invocation] = STATE(1988),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1988),
    [sym_unary_expression] = STATE(1988),
    [sym_try_expression] = STATE(1988),
    [sym_reference_expression] = STATE(1988),
    [sym_binary_expression] = STATE(1988),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1988),
    [sym_call_expression] = STATE(1988),
    [sym_array_expression] = STATE(1988),
    [sym_parenthesized_expression] = STATE(1988),
    [sym_tuple_expression] = STATE(1988),
    [sym_unit_expression] = STATE(1988),
    [sym_struct_expression] = STATE(1988),
    [sym_if_expression] = STATE(1988),
    [sym_if_let_expression] = STATE(1988),
    [sym_match_expression] = STATE(1988),
    [sym_while_expression] = STATE(1988),
    [sym_while_let_expression] = STATE(1988),
    [sym_loop_expression] = STATE(1988),
    [sym_for_expression] = STATE(1988),
    [sym_closure_expression] = STATE(1988),
    [sym_closure_parameters] = STATE(638),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1988),
    [sym_continue_expression] = STATE(1988),
    [sym_index_expression] = STATE(1988),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1988),
    [sym_block] = STATE(1988),
    [sym__literal] = STATE(1988),
    [sym_string_literal] = STATE(1988),
    [sym_boolean_literal] = STATE(1988),
    [sym_raw_string_literal] = ACTIONS(4411),
    [sym_float_literal] = ACTIONS(4411),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(909),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(911),
    [anon_sym_STAR] = ACTIONS(911),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_DASH] = ACTIONS(911),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(911),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(911),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_LT_LT] = ACTIONS(911),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(909),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_EQ_EQ] = ACTIONS(909),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(911),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_as] = ACTIONS(911),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1251),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1253),
    [sym_integer_literal] = ACTIONS(4411),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4411),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1310] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1988),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1988),
    [sym_macro_invocation] = STATE(1988),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1988),
    [sym_unary_expression] = STATE(1988),
    [sym_try_expression] = STATE(1988),
    [sym_reference_expression] = STATE(1988),
    [sym_binary_expression] = STATE(1988),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1988),
    [sym_call_expression] = STATE(1988),
    [sym_array_expression] = STATE(1988),
    [sym_parenthesized_expression] = STATE(1988),
    [sym_tuple_expression] = STATE(1988),
    [sym_unit_expression] = STATE(1988),
    [sym_struct_expression] = STATE(1988),
    [sym_if_expression] = STATE(1988),
    [sym_if_let_expression] = STATE(1988),
    [sym_match_expression] = STATE(1988),
    [sym_while_expression] = STATE(1988),
    [sym_while_let_expression] = STATE(1988),
    [sym_loop_expression] = STATE(1988),
    [sym_for_expression] = STATE(1988),
    [sym_closure_expression] = STATE(1988),
    [sym_closure_parameters] = STATE(638),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1988),
    [sym_continue_expression] = STATE(1988),
    [sym_index_expression] = STATE(1988),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1988),
    [sym_block] = STATE(1988),
    [sym__literal] = STATE(1988),
    [sym_string_literal] = STATE(1988),
    [sym_boolean_literal] = STATE(1988),
    [sym_raw_string_literal] = ACTIONS(4411),
    [sym_float_literal] = ACTIONS(4411),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1245),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1247),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1251),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1253),
    [sym_integer_literal] = ACTIONS(4411),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4411),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1311] = {
    [sym_function_modifiers] = STATE(1993),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(666),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(1994),
    [sym_array_type] = STATE(666),
    [sym_function_type] = STATE(666),
    [sym_tuple_type] = STATE(666),
    [sym_unit_type] = STATE(666),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(666),
    [sym_reference_type] = STATE(666),
    [sym_pointer_type] = STATE(666),
    [sym_empty_type] = STATE(666),
    [sym_dynamic_type] = STATE(666),
    [sym_macro_invocation] = STATE(666),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(1995),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(4413),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(4415),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4417),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4419),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [1312] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(1323),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_STAR_EQ] = ACTIONS(2563),
    [anon_sym_SLASH] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_AMP_EQ] = ACTIONS(2563),
    [anon_sym_PERCENT] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2563),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_CARET_EQ] = ACTIONS(2563),
    [anon_sym_PLUS_EQ] = ACTIONS(2563),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_LT_LT] = ACTIONS(2573),
    [anon_sym_LT_LT_EQ] = ACTIONS(2563),
    [anon_sym_LT_EQ] = ACTIONS(2565),
    [anon_sym_EQ] = ACTIONS(2575),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_GT_EQ] = ACTIONS(2565),
    [anon_sym_GT_GT] = ACTIONS(2573),
    [anon_sym_GT_GT_EQ] = ACTIONS(2563),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_PIPE_EQ] = ACTIONS(2563),
    [anon_sym_PIPE_PIPE] = ACTIONS(2579),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(2581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2583),
    [anon_sym_as] = ACTIONS(2585),
    [sym_line_comment] = ACTIONS(7),
  },
  [1313] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1688),
    [anon_sym_LPAREN] = ACTIONS(1688),
    [anon_sym_RPAREN] = ACTIONS(1688),
    [anon_sym_LBRACE] = ACTIONS(1688),
    [anon_sym_RBRACE] = ACTIONS(1688),
    [anon_sym_LBRACK] = ACTIONS(1688),
    [anon_sym_RBRACK] = ACTIONS(1688),
    [anon_sym_PLUS] = ACTIONS(4421),
    [anon_sym_STAR] = ACTIONS(4421),
    [anon_sym_COMMA] = ACTIONS(1688),
    [anon_sym_AMP] = ACTIONS(4421),
    [anon_sym_DASH] = ACTIONS(4421),
    [anon_sym_DOT] = ACTIONS(4421),
    [anon_sym_DASH_EQ] = ACTIONS(1688),
    [anon_sym_BANG_EQ] = ACTIONS(1688),
    [anon_sym_STAR_EQ] = ACTIONS(1688),
    [anon_sym_SLASH] = ACTIONS(4421),
    [anon_sym_SLASH_EQ] = ACTIONS(1688),
    [anon_sym_AMP_AMP] = ACTIONS(1688),
    [anon_sym_AMP_EQ] = ACTIONS(1688),
    [anon_sym_PERCENT] = ACTIONS(4421),
    [anon_sym_PERCENT_EQ] = ACTIONS(1688),
    [anon_sym_CARET] = ACTIONS(4421),
    [anon_sym_CARET_EQ] = ACTIONS(1688),
    [anon_sym_PLUS_EQ] = ACTIONS(1688),
    [anon_sym_LT] = ACTIONS(4421),
    [anon_sym_LT_LT] = ACTIONS(4421),
    [anon_sym_LT_LT_EQ] = ACTIONS(1688),
    [anon_sym_LT_EQ] = ACTIONS(1688),
    [anon_sym_EQ] = ACTIONS(4421),
    [anon_sym_EQ_EQ] = ACTIONS(1688),
    [anon_sym_GT] = ACTIONS(4421),
    [anon_sym_GT_EQ] = ACTIONS(1688),
    [anon_sym_GT_GT] = ACTIONS(4421),
    [anon_sym_GT_GT_EQ] = ACTIONS(1688),
    [anon_sym_PIPE] = ACTIONS(4421),
    [anon_sym_PIPE_EQ] = ACTIONS(1688),
    [anon_sym_PIPE_PIPE] = ACTIONS(1688),
    [anon_sym_QMARK] = ACTIONS(1688),
    [anon_sym_DOT_DOT] = ACTIONS(4421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1688),
    [anon_sym_as] = ACTIONS(1688),
    [sym_line_comment] = ACTIONS(7),
  },
  [1314] = {
    [aux_sym_tuple_type_repeat1] = STATE(1998),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(4423),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_COMMA] = ACTIONS(4425),
    [sym_line_comment] = ACTIONS(7),
  },
  [1315] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4427),
    [anon_sym_RBRACK] = ACTIONS(4429),
    [anon_sym_PLUS] = ACTIONS(1718),
    [sym_line_comment] = ACTIONS(7),
  },
  [1316] = {
    [sym_function_modifiers] = STATE(665),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2001),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(667),
    [sym_array_type] = STATE(2001),
    [sym_function_type] = STATE(2001),
    [sym_tuple_type] = STATE(2001),
    [sym_unit_type] = STATE(2001),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2001),
    [sym_reference_type] = STATE(2001),
    [sym_pointer_type] = STATE(2001),
    [sym_empty_type] = STATE(2001),
    [sym_dynamic_type] = STATE(2001),
    [sym_macro_invocation] = STATE(2001),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(671),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1291),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1295),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1301),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1305),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [1317] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4431),
  },
  [1318] = {
    [sym_function_modifiers] = STATE(665),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2003),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(667),
    [sym_array_type] = STATE(2003),
    [sym_function_type] = STATE(2003),
    [sym_tuple_type] = STATE(2003),
    [sym_unit_type] = STATE(2003),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2003),
    [sym_reference_type] = STATE(2003),
    [sym_pointer_type] = STATE(2003),
    [sym_empty_type] = STATE(2003),
    [sym_dynamic_type] = STATE(2003),
    [sym_macro_invocation] = STATE(2003),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(671),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1291),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1295),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1301),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1305),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [1319] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1724),
    [anon_sym_LPAREN] = ACTIONS(1724),
    [anon_sym_RPAREN] = ACTIONS(1724),
    [anon_sym_LBRACE] = ACTIONS(1724),
    [anon_sym_RBRACE] = ACTIONS(1724),
    [anon_sym_LBRACK] = ACTIONS(1724),
    [anon_sym_RBRACK] = ACTIONS(1724),
    [anon_sym_PLUS] = ACTIONS(4433),
    [anon_sym_STAR] = ACTIONS(4433),
    [anon_sym_COMMA] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(4433),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_DOT] = ACTIONS(4433),
    [anon_sym_DASH_EQ] = ACTIONS(1724),
    [anon_sym_BANG_EQ] = ACTIONS(1724),
    [anon_sym_STAR_EQ] = ACTIONS(1724),
    [anon_sym_SLASH] = ACTIONS(4433),
    [anon_sym_SLASH_EQ] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_AMP_EQ] = ACTIONS(1724),
    [anon_sym_PERCENT] = ACTIONS(4433),
    [anon_sym_PERCENT_EQ] = ACTIONS(1724),
    [anon_sym_CARET] = ACTIONS(4433),
    [anon_sym_CARET_EQ] = ACTIONS(1724),
    [anon_sym_PLUS_EQ] = ACTIONS(1724),
    [anon_sym_LT] = ACTIONS(4433),
    [anon_sym_LT_LT] = ACTIONS(4433),
    [anon_sym_LT_LT_EQ] = ACTIONS(1724),
    [anon_sym_LT_EQ] = ACTIONS(1724),
    [anon_sym_EQ] = ACTIONS(4433),
    [anon_sym_EQ_EQ] = ACTIONS(1724),
    [anon_sym_GT] = ACTIONS(4433),
    [anon_sym_GT_EQ] = ACTIONS(1724),
    [anon_sym_GT_GT] = ACTIONS(4433),
    [anon_sym_GT_GT_EQ] = ACTIONS(1724),
    [anon_sym_PIPE] = ACTIONS(4433),
    [anon_sym_PIPE_EQ] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_QMARK] = ACTIONS(1724),
    [anon_sym_DOT_DOT] = ACTIONS(4433),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1724),
    [anon_sym_as] = ACTIONS(1724),
    [sym_line_comment] = ACTIONS(7),
  },
  [1320] = {
    [sym_function_modifiers] = STATE(665),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2003),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(667),
    [sym_array_type] = STATE(2003),
    [sym_function_type] = STATE(2003),
    [sym_tuple_type] = STATE(2003),
    [sym_unit_type] = STATE(2003),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2003),
    [sym_reference_type] = STATE(2003),
    [sym_pointer_type] = STATE(2003),
    [sym_empty_type] = STATE(2003),
    [sym_dynamic_type] = STATE(2003),
    [sym_macro_invocation] = STATE(2003),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(671),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(1291),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1295),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1301),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_mutable_specifier] = ACTIONS(4435),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1305),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [1321] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_LPAREN] = ACTIONS(1728),
    [anon_sym_RPAREN] = ACTIONS(1728),
    [anon_sym_LBRACE] = ACTIONS(1728),
    [anon_sym_RBRACE] = ACTIONS(1728),
    [anon_sym_LBRACK] = ACTIONS(1728),
    [anon_sym_RBRACK] = ACTIONS(1728),
    [anon_sym_PLUS] = ACTIONS(1730),
    [anon_sym_STAR] = ACTIONS(1730),
    [anon_sym_COMMA] = ACTIONS(1728),
    [anon_sym_AMP] = ACTIONS(1730),
    [anon_sym_DASH] = ACTIONS(1730),
    [anon_sym_DOT] = ACTIONS(1730),
    [anon_sym_DASH_EQ] = ACTIONS(1728),
    [anon_sym_COLON_COLON] = ACTIONS(721),
    [anon_sym_BANG_EQ] = ACTIONS(1728),
    [anon_sym_STAR_EQ] = ACTIONS(1728),
    [anon_sym_SLASH] = ACTIONS(1730),
    [anon_sym_SLASH_EQ] = ACTIONS(1728),
    [anon_sym_AMP_AMP] = ACTIONS(1728),
    [anon_sym_AMP_EQ] = ACTIONS(1728),
    [anon_sym_PERCENT] = ACTIONS(1730),
    [anon_sym_PERCENT_EQ] = ACTIONS(1728),
    [anon_sym_CARET] = ACTIONS(1730),
    [anon_sym_CARET_EQ] = ACTIONS(1728),
    [anon_sym_PLUS_EQ] = ACTIONS(1728),
    [anon_sym_LT] = ACTIONS(1730),
    [anon_sym_LT_LT] = ACTIONS(1730),
    [anon_sym_LT_LT_EQ] = ACTIONS(1728),
    [anon_sym_LT_EQ] = ACTIONS(1728),
    [anon_sym_EQ] = ACTIONS(1730),
    [anon_sym_EQ_EQ] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1730),
    [anon_sym_GT_EQ] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1730),
    [anon_sym_GT_GT_EQ] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1730),
    [anon_sym_PIPE_EQ] = ACTIONS(1728),
    [anon_sym_PIPE_PIPE] = ACTIONS(1728),
    [anon_sym_QMARK] = ACTIONS(1728),
    [anon_sym_DOT_DOT] = ACTIONS(1730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1728),
    [anon_sym_as] = ACTIONS(1728),
    [sym_line_comment] = ACTIONS(7),
  },
  [1322] = {
    [sym_function_modifiers] = STATE(370),
    [sym_self_parameter] = STATE(2008),
    [sym_variadic_parameter] = STATE(2008),
    [sym_parameter] = STATE(2008),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2009),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(839),
    [sym_array_type] = STATE(2009),
    [sym_function_type] = STATE(2009),
    [sym_tuple_type] = STATE(2009),
    [sym_unit_type] = STATE(2009),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2009),
    [sym_reference_type] = STATE(2009),
    [sym_pointer_type] = STATE(2009),
    [sym_empty_type] = STATE(2009),
    [sym_abstract_type] = STATE(2008),
    [sym_dynamic_type] = STATE(2009),
    [sym_macro_invocation] = STATE(2009),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [sym_reference_pattern_in_parameter] = STATE(840),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_RPAREN] = ACTIONS(4437),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(4439),
    [anon_sym_u8] = ACTIONS(1740),
    [anon_sym_i8] = ACTIONS(1740),
    [anon_sym_u16] = ACTIONS(1740),
    [anon_sym_i16] = ACTIONS(1740),
    [anon_sym_u32] = ACTIONS(1740),
    [anon_sym_i32] = ACTIONS(1740),
    [anon_sym_u64] = ACTIONS(1740),
    [anon_sym_i64] = ACTIONS(1740),
    [anon_sym_u128] = ACTIONS(1740),
    [anon_sym_i128] = ACTIONS(1740),
    [anon_sym_isize] = ACTIONS(1740),
    [anon_sym_usize] = ACTIONS(1740),
    [anon_sym_f32] = ACTIONS(1740),
    [anon_sym_f64] = ACTIONS(1740),
    [anon_sym_bool] = ACTIONS(1740),
    [anon_sym_str] = ACTIONS(1740),
    [anon_sym_char] = ACTIONS(1740),
    [anon_sym__] = ACTIONS(4441),
    [anon_sym_AMP] = ACTIONS(1744),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1746),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(1748),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_union] = ACTIONS(1752),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(1754),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1756),
    [sym_self] = ACTIONS(1758),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1323] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1760),
    [anon_sym_LPAREN] = ACTIONS(1760),
    [anon_sym_LBRACK] = ACTIONS(1760),
    [anon_sym_PLUS] = ACTIONS(4443),
    [anon_sym_STAR] = ACTIONS(4443),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_DASH] = ACTIONS(4443),
    [anon_sym_DOT] = ACTIONS(4443),
    [anon_sym_DASH_EQ] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(4445),
    [anon_sym_BANG_EQ] = ACTIONS(1760),
    [anon_sym_STAR_EQ] = ACTIONS(1760),
    [anon_sym_SLASH] = ACTIONS(4443),
    [anon_sym_SLASH_EQ] = ACTIONS(1760),
    [anon_sym_AMP_AMP] = ACTIONS(1760),
    [anon_sym_AMP_EQ] = ACTIONS(1760),
    [anon_sym_PERCENT] = ACTIONS(4443),
    [anon_sym_PERCENT_EQ] = ACTIONS(1760),
    [anon_sym_CARET] = ACTIONS(4443),
    [anon_sym_CARET_EQ] = ACTIONS(1760),
    [anon_sym_PLUS_EQ] = ACTIONS(1760),
    [anon_sym_LT] = ACTIONS(4443),
    [anon_sym_LT_LT] = ACTIONS(4443),
    [anon_sym_LT_LT_EQ] = ACTIONS(1760),
    [anon_sym_LT_EQ] = ACTIONS(1760),
    [anon_sym_EQ] = ACTIONS(4443),
    [anon_sym_EQ_EQ] = ACTIONS(1760),
    [anon_sym_GT] = ACTIONS(4443),
    [anon_sym_GT_EQ] = ACTIONS(1760),
    [anon_sym_GT_GT] = ACTIONS(4443),
    [anon_sym_GT_GT_EQ] = ACTIONS(1760),
    [anon_sym_PIPE] = ACTIONS(4443),
    [anon_sym_PIPE_EQ] = ACTIONS(1760),
    [anon_sym_PIPE_PIPE] = ACTIONS(1760),
    [anon_sym_QMARK] = ACTIONS(1760),
    [anon_sym_DOT_DOT] = ACTIONS(4443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1760),
    [anon_sym_as] = ACTIONS(1760),
    [sym_line_comment] = ACTIONS(7),
  },
  [1324] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON_COLON] = ACTIONS(2617),
    [sym_line_comment] = ACTIONS(7),
  },
  [1325] = {
    [sym_type_arguments] = STATE(1330),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(1770),
    [anon_sym_RPAREN] = ACTIONS(1770),
    [anon_sym_LBRACE] = ACTIONS(1770),
    [anon_sym_RBRACE] = ACTIONS(1770),
    [anon_sym_LBRACK] = ACTIONS(1770),
    [anon_sym_RBRACK] = ACTIONS(1770),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_STAR] = ACTIONS(1772),
    [anon_sym_COMMA] = ACTIONS(1770),
    [anon_sym_AMP] = ACTIONS(1772),
    [anon_sym_DASH] = ACTIONS(1772),
    [anon_sym_DOT] = ACTIONS(1772),
    [anon_sym_DASH_EQ] = ACTIONS(1770),
    [anon_sym_COLON_COLON] = ACTIONS(2635),
    [anon_sym_BANG_EQ] = ACTIONS(1770),
    [anon_sym_STAR_EQ] = ACTIONS(1770),
    [anon_sym_SLASH] = ACTIONS(1772),
    [anon_sym_SLASH_EQ] = ACTIONS(1770),
    [anon_sym_AMP_AMP] = ACTIONS(1770),
    [anon_sym_AMP_EQ] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1772),
    [anon_sym_PERCENT_EQ] = ACTIONS(1770),
    [anon_sym_CARET] = ACTIONS(1772),
    [anon_sym_CARET_EQ] = ACTIONS(1770),
    [anon_sym_PLUS_EQ] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(2637),
    [anon_sym_LT_LT] = ACTIONS(1772),
    [anon_sym_LT_LT_EQ] = ACTIONS(1770),
    [anon_sym_LT_EQ] = ACTIONS(1770),
    [anon_sym_EQ] = ACTIONS(1772),
    [anon_sym_EQ_EQ] = ACTIONS(1770),
    [anon_sym_GT] = ACTIONS(1772),
    [anon_sym_GT_EQ] = ACTIONS(1770),
    [anon_sym_GT_GT] = ACTIONS(1772),
    [anon_sym_GT_GT_EQ] = ACTIONS(1770),
    [anon_sym_PIPE] = ACTIONS(1772),
    [anon_sym_PIPE_EQ] = ACTIONS(1770),
    [anon_sym_PIPE_PIPE] = ACTIONS(1770),
    [anon_sym_QMARK] = ACTIONS(1770),
    [anon_sym_DOT_DOT] = ACTIONS(1772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1770),
    [anon_sym_as] = ACTIONS(1770),
    [sym_line_comment] = ACTIONS(7),
  },
  [1326] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1774),
    [anon_sym_LPAREN] = ACTIONS(1774),
    [anon_sym_RPAREN] = ACTIONS(1774),
    [anon_sym_LBRACE] = ACTIONS(1774),
    [anon_sym_RBRACE] = ACTIONS(1774),
    [anon_sym_LBRACK] = ACTIONS(1774),
    [anon_sym_RBRACK] = ACTIONS(1774),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_STAR] = ACTIONS(1776),
    [anon_sym_COMMA] = ACTIONS(1774),
    [anon_sym_AMP] = ACTIONS(1776),
    [anon_sym_DASH] = ACTIONS(1776),
    [anon_sym_DOT] = ACTIONS(1776),
    [anon_sym_DASH_EQ] = ACTIONS(1774),
    [anon_sym_COLON_COLON] = ACTIONS(2651),
    [anon_sym_BANG_EQ] = ACTIONS(1774),
    [anon_sym_STAR_EQ] = ACTIONS(1774),
    [anon_sym_SLASH] = ACTIONS(1776),
    [anon_sym_SLASH_EQ] = ACTIONS(1774),
    [anon_sym_AMP_AMP] = ACTIONS(1774),
    [anon_sym_AMP_EQ] = ACTIONS(1774),
    [anon_sym_PERCENT] = ACTIONS(1776),
    [anon_sym_PERCENT_EQ] = ACTIONS(1774),
    [anon_sym_CARET] = ACTIONS(1776),
    [anon_sym_CARET_EQ] = ACTIONS(1774),
    [anon_sym_PLUS_EQ] = ACTIONS(1774),
    [anon_sym_LT] = ACTIONS(1776),
    [anon_sym_LT_LT] = ACTIONS(1776),
    [anon_sym_LT_LT_EQ] = ACTIONS(1774),
    [anon_sym_LT_EQ] = ACTIONS(1774),
    [anon_sym_EQ] = ACTIONS(1776),
    [anon_sym_EQ_EQ] = ACTIONS(1774),
    [anon_sym_GT] = ACTIONS(1776),
    [anon_sym_GT_EQ] = ACTIONS(1774),
    [anon_sym_GT_GT] = ACTIONS(1776),
    [anon_sym_GT_GT_EQ] = ACTIONS(1774),
    [anon_sym_PIPE] = ACTIONS(1776),
    [anon_sym_PIPE_EQ] = ACTIONS(1774),
    [anon_sym_PIPE_PIPE] = ACTIONS(1774),
    [anon_sym_QMARK] = ACTIONS(1774),
    [anon_sym_DOT_DOT] = ACTIONS(1776),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1774),
    [anon_sym_as] = ACTIONS(1774),
    [sym_line_comment] = ACTIONS(7),
  },
  [1327] = {
    [sym_type_arguments] = STATE(1340),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1774),
    [anon_sym_LPAREN] = ACTIONS(1774),
    [anon_sym_RPAREN] = ACTIONS(1774),
    [anon_sym_LBRACE] = ACTIONS(1774),
    [anon_sym_RBRACE] = ACTIONS(1774),
    [anon_sym_LBRACK] = ACTIONS(1774),
    [anon_sym_RBRACK] = ACTIONS(1774),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_STAR] = ACTIONS(1776),
    [anon_sym_COMMA] = ACTIONS(1774),
    [anon_sym_AMP] = ACTIONS(1776),
    [anon_sym_DASH] = ACTIONS(1776),
    [anon_sym_DOT] = ACTIONS(1776),
    [anon_sym_DASH_EQ] = ACTIONS(1774),
    [anon_sym_BANG_EQ] = ACTIONS(1774),
    [anon_sym_STAR_EQ] = ACTIONS(1774),
    [anon_sym_SLASH] = ACTIONS(1776),
    [anon_sym_SLASH_EQ] = ACTIONS(1774),
    [anon_sym_AMP_AMP] = ACTIONS(1774),
    [anon_sym_AMP_EQ] = ACTIONS(1774),
    [anon_sym_PERCENT] = ACTIONS(1776),
    [anon_sym_PERCENT_EQ] = ACTIONS(1774),
    [anon_sym_CARET] = ACTIONS(1776),
    [anon_sym_CARET_EQ] = ACTIONS(1774),
    [anon_sym_PLUS_EQ] = ACTIONS(1774),
    [anon_sym_LT] = ACTIONS(2637),
    [anon_sym_LT_LT] = ACTIONS(1776),
    [anon_sym_LT_LT_EQ] = ACTIONS(1774),
    [anon_sym_LT_EQ] = ACTIONS(1774),
    [anon_sym_EQ] = ACTIONS(1776),
    [anon_sym_EQ_EQ] = ACTIONS(1774),
    [anon_sym_GT] = ACTIONS(1776),
    [anon_sym_GT_EQ] = ACTIONS(1774),
    [anon_sym_GT_GT] = ACTIONS(1776),
    [anon_sym_GT_GT_EQ] = ACTIONS(1774),
    [anon_sym_PIPE] = ACTIONS(1776),
    [anon_sym_PIPE_EQ] = ACTIONS(1774),
    [anon_sym_PIPE_PIPE] = ACTIONS(1774),
    [anon_sym_QMARK] = ACTIONS(1774),
    [anon_sym_DOT_DOT] = ACTIONS(1776),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1774),
    [anon_sym_as] = ACTIONS(1774),
    [sym_line_comment] = ACTIONS(7),
  },
  [1328] = {
    [sym_type_arguments] = STATE(845),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4447),
  },
  [1329] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1794),
    [anon_sym_LPAREN] = ACTIONS(1794),
    [anon_sym_LBRACK] = ACTIONS(1794),
    [anon_sym_PLUS] = ACTIONS(4449),
    [anon_sym_STAR] = ACTIONS(4449),
    [anon_sym_AMP] = ACTIONS(4449),
    [anon_sym_DASH] = ACTIONS(4449),
    [anon_sym_DOT] = ACTIONS(4449),
    [anon_sym_DASH_EQ] = ACTIONS(1794),
    [anon_sym_DASH_GT] = ACTIONS(4451),
    [anon_sym_BANG_EQ] = ACTIONS(1794),
    [anon_sym_STAR_EQ] = ACTIONS(1794),
    [anon_sym_SLASH] = ACTIONS(4449),
    [anon_sym_SLASH_EQ] = ACTIONS(1794),
    [anon_sym_AMP_AMP] = ACTIONS(1794),
    [anon_sym_AMP_EQ] = ACTIONS(1794),
    [anon_sym_PERCENT] = ACTIONS(4449),
    [anon_sym_PERCENT_EQ] = ACTIONS(1794),
    [anon_sym_CARET] = ACTIONS(4449),
    [anon_sym_CARET_EQ] = ACTIONS(1794),
    [anon_sym_PLUS_EQ] = ACTIONS(1794),
    [anon_sym_LT] = ACTIONS(4449),
    [anon_sym_LT_LT] = ACTIONS(4449),
    [anon_sym_LT_LT_EQ] = ACTIONS(1794),
    [anon_sym_LT_EQ] = ACTIONS(1794),
    [anon_sym_EQ] = ACTIONS(4449),
    [anon_sym_EQ_EQ] = ACTIONS(1794),
    [anon_sym_GT] = ACTIONS(4449),
    [anon_sym_GT_EQ] = ACTIONS(1794),
    [anon_sym_GT_GT] = ACTIONS(4449),
    [anon_sym_GT_GT_EQ] = ACTIONS(1794),
    [anon_sym_PIPE] = ACTIONS(4449),
    [anon_sym_PIPE_EQ] = ACTIONS(1794),
    [anon_sym_PIPE_PIPE] = ACTIONS(1794),
    [anon_sym_QMARK] = ACTIONS(1794),
    [anon_sym_DOT_DOT] = ACTIONS(4449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1794),
    [anon_sym_as] = ACTIONS(1794),
    [sym_line_comment] = ACTIONS(7),
  },
  [1330] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1798),
    [anon_sym_LPAREN] = ACTIONS(1798),
    [anon_sym_RPAREN] = ACTIONS(1798),
    [anon_sym_LBRACE] = ACTIONS(1798),
    [anon_sym_RBRACE] = ACTIONS(1798),
    [anon_sym_LBRACK] = ACTIONS(1798),
    [anon_sym_RBRACK] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1800),
    [anon_sym_STAR] = ACTIONS(1800),
    [anon_sym_COMMA] = ACTIONS(1798),
    [anon_sym_AMP] = ACTIONS(1800),
    [anon_sym_DASH] = ACTIONS(1800),
    [anon_sym_DOT] = ACTIONS(1800),
    [anon_sym_DASH_EQ] = ACTIONS(1798),
    [anon_sym_COLON_COLON] = ACTIONS(1798),
    [anon_sym_BANG_EQ] = ACTIONS(1798),
    [anon_sym_STAR_EQ] = ACTIONS(1798),
    [anon_sym_SLASH] = ACTIONS(1800),
    [anon_sym_SLASH_EQ] = ACTIONS(1798),
    [anon_sym_AMP_AMP] = ACTIONS(1798),
    [anon_sym_AMP_EQ] = ACTIONS(1798),
    [anon_sym_PERCENT] = ACTIONS(1800),
    [anon_sym_PERCENT_EQ] = ACTIONS(1798),
    [anon_sym_CARET] = ACTIONS(1800),
    [anon_sym_CARET_EQ] = ACTIONS(1798),
    [anon_sym_PLUS_EQ] = ACTIONS(1798),
    [anon_sym_LT] = ACTIONS(1800),
    [anon_sym_LT_LT] = ACTIONS(1800),
    [anon_sym_LT_LT_EQ] = ACTIONS(1798),
    [anon_sym_LT_EQ] = ACTIONS(1798),
    [anon_sym_EQ] = ACTIONS(1800),
    [anon_sym_EQ_EQ] = ACTIONS(1798),
    [anon_sym_GT] = ACTIONS(1800),
    [anon_sym_GT_EQ] = ACTIONS(1798),
    [anon_sym_GT_GT] = ACTIONS(1800),
    [anon_sym_GT_GT_EQ] = ACTIONS(1798),
    [anon_sym_PIPE] = ACTIONS(1800),
    [anon_sym_PIPE_EQ] = ACTIONS(1798),
    [anon_sym_PIPE_PIPE] = ACTIONS(1798),
    [anon_sym_QMARK] = ACTIONS(1798),
    [anon_sym_DOT_DOT] = ACTIONS(1800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1798),
    [anon_sym_as] = ACTIONS(1798),
    [sym_line_comment] = ACTIONS(7),
  },
  [1331] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4447),
  },
  [1332] = {
    [sym_parameters] = STATE(2013),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [sym_line_comment] = ACTIONS(7),
  },
  [1333] = {
    [sym_parameters] = STATE(2014),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1334] = {
    [sym_parameters] = STATE(2013),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1335] = {
    [sym_function_modifiers] = STATE(665),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2016),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(2016),
    [sym_array_type] = STATE(2016),
    [sym_function_type] = STATE(2016),
    [sym_tuple_type] = STATE(2016),
    [sym_unit_type] = STATE(2016),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2016),
    [sym_reference_type] = STATE(2016),
    [sym_pointer_type] = STATE(2016),
    [sym_empty_type] = STATE(2016),
    [sym_dynamic_type] = STATE(2016),
    [sym_macro_invocation] = STATE(2016),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(671),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1291),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1295),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(4453),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1301),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1305),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [1336] = {
    [sym_function_modifiers] = STATE(665),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2016),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(667),
    [sym_array_type] = STATE(2016),
    [sym_function_type] = STATE(2016),
    [sym_tuple_type] = STATE(2016),
    [sym_unit_type] = STATE(2016),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2016),
    [sym_reference_type] = STATE(2016),
    [sym_pointer_type] = STATE(2016),
    [sym_empty_type] = STATE(2016),
    [sym_dynamic_type] = STATE(2016),
    [sym_macro_invocation] = STATE(2016),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(671),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1291),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1295),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1301),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1305),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [1337] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4455),
  },
  [1338] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4457),
  },
  [1339] = {
    [sym_type_arguments] = STATE(873),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4447),
  },
  [1340] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1816),
    [anon_sym_LPAREN] = ACTIONS(1816),
    [anon_sym_RPAREN] = ACTIONS(1816),
    [anon_sym_LBRACE] = ACTIONS(1816),
    [anon_sym_RBRACE] = ACTIONS(1816),
    [anon_sym_LBRACK] = ACTIONS(1816),
    [anon_sym_RBRACK] = ACTIONS(1816),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_STAR] = ACTIONS(1818),
    [anon_sym_COMMA] = ACTIONS(1816),
    [anon_sym_AMP] = ACTIONS(1818),
    [anon_sym_DASH] = ACTIONS(1818),
    [anon_sym_DOT] = ACTIONS(1818),
    [anon_sym_DASH_EQ] = ACTIONS(1816),
    [anon_sym_COLON_COLON] = ACTIONS(1816),
    [anon_sym_BANG_EQ] = ACTIONS(1816),
    [anon_sym_STAR_EQ] = ACTIONS(1816),
    [anon_sym_SLASH] = ACTIONS(1818),
    [anon_sym_SLASH_EQ] = ACTIONS(1816),
    [anon_sym_AMP_AMP] = ACTIONS(1816),
    [anon_sym_AMP_EQ] = ACTIONS(1816),
    [anon_sym_PERCENT] = ACTIONS(1818),
    [anon_sym_PERCENT_EQ] = ACTIONS(1816),
    [anon_sym_CARET] = ACTIONS(1818),
    [anon_sym_CARET_EQ] = ACTIONS(1816),
    [anon_sym_PLUS_EQ] = ACTIONS(1816),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_LT_LT] = ACTIONS(1818),
    [anon_sym_LT_LT_EQ] = ACTIONS(1816),
    [anon_sym_LT_EQ] = ACTIONS(1816),
    [anon_sym_EQ] = ACTIONS(1818),
    [anon_sym_EQ_EQ] = ACTIONS(1816),
    [anon_sym_GT] = ACTIONS(1818),
    [anon_sym_GT_EQ] = ACTIONS(1816),
    [anon_sym_GT_GT] = ACTIONS(1818),
    [anon_sym_GT_GT_EQ] = ACTIONS(1816),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_PIPE_EQ] = ACTIONS(1816),
    [anon_sym_PIPE_PIPE] = ACTIONS(1816),
    [anon_sym_QMARK] = ACTIONS(1816),
    [anon_sym_DOT_DOT] = ACTIONS(1818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1816),
    [anon_sym_as] = ACTIONS(1816),
    [sym_line_comment] = ACTIONS(7),
  },
  [1341] = {
    [sym_function_modifiers] = STATE(677),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(821),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(679),
    [sym_array_type] = STATE(821),
    [sym_function_type] = STATE(821),
    [sym_tuple_type] = STATE(821),
    [sym_unit_type] = STATE(821),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(821),
    [sym_reference_type] = STATE(821),
    [sym_pointer_type] = STATE(821),
    [sym_empty_type] = STATE(821),
    [sym_dynamic_type] = STATE(821),
    [sym_macro_invocation] = STATE(821),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(680),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1315),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1317),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1319),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1321),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1342] = {
    [sym_function_modifiers] = STATE(677),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(679),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(680),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1315),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1317),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1319),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1321),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1343] = {
    [sym_function_modifiers] = STATE(677),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(679),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(680),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(2669),
    [anon_sym_STAR] = ACTIONS(1315),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1317),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1319),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(4459),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1321),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1344] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(1760),
    [anon_sym_PLUS] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(4461),
    [sym_line_comment] = ACTIONS(7),
  },
  [1345] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(1794),
    [anon_sym_PLUS] = ACTIONS(1794),
    [anon_sym_DASH_GT] = ACTIONS(4463),
    [sym_line_comment] = ACTIONS(7),
  },
  [1346] = {
    [sym_parameters] = STATE(2022),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [1347] = {
    [sym_parameters] = STATE(2023),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1348] = {
    [sym_parameters] = STATE(2022),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1349] = {
    [sym_function_modifiers] = STATE(677),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(862),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(680),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1315),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1317),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1319),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1321),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1350] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4465),
    [anon_sym_LPAREN] = ACTIONS(4465),
    [anon_sym_RPAREN] = ACTIONS(4465),
    [anon_sym_LBRACE] = ACTIONS(4465),
    [anon_sym_RBRACE] = ACTIONS(4465),
    [anon_sym_LBRACK] = ACTIONS(4465),
    [anon_sym_RBRACK] = ACTIONS(4465),
    [anon_sym_PLUS] = ACTIONS(4467),
    [anon_sym_STAR] = ACTIONS(4467),
    [anon_sym_COMMA] = ACTIONS(4465),
    [anon_sym_AMP] = ACTIONS(4467),
    [anon_sym_DASH] = ACTIONS(4467),
    [anon_sym_DOT] = ACTIONS(4467),
    [anon_sym_DASH_EQ] = ACTIONS(4465),
    [anon_sym_BANG_EQ] = ACTIONS(4465),
    [anon_sym_STAR_EQ] = ACTIONS(4465),
    [anon_sym_SLASH] = ACTIONS(4467),
    [anon_sym_SLASH_EQ] = ACTIONS(4465),
    [anon_sym_AMP_AMP] = ACTIONS(4465),
    [anon_sym_AMP_EQ] = ACTIONS(4465),
    [anon_sym_PERCENT] = ACTIONS(4467),
    [anon_sym_PERCENT_EQ] = ACTIONS(4465),
    [anon_sym_CARET] = ACTIONS(4467),
    [anon_sym_CARET_EQ] = ACTIONS(4465),
    [anon_sym_PLUS_EQ] = ACTIONS(4465),
    [anon_sym_LT] = ACTIONS(4467),
    [anon_sym_LT_LT] = ACTIONS(4467),
    [anon_sym_LT_LT_EQ] = ACTIONS(4465),
    [anon_sym_LT_EQ] = ACTIONS(4465),
    [anon_sym_EQ] = ACTIONS(4467),
    [anon_sym_EQ_EQ] = ACTIONS(4465),
    [anon_sym_GT] = ACTIONS(4467),
    [anon_sym_GT_EQ] = ACTIONS(4465),
    [anon_sym_GT_GT] = ACTIONS(4467),
    [anon_sym_GT_GT_EQ] = ACTIONS(4465),
    [anon_sym_PIPE] = ACTIONS(4467),
    [anon_sym_PIPE_EQ] = ACTIONS(4465),
    [anon_sym_PIPE_PIPE] = ACTIONS(4465),
    [anon_sym_QMARK] = ACTIONS(4465),
    [anon_sym_DOT_DOT] = ACTIONS(4467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4465),
    [anon_sym_as] = ACTIONS(4465),
    [sym_line_comment] = ACTIONS(7),
  },
  [1351] = {
    [sym_function_modifiers] = STATE(677),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(679),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(680),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1315),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1317),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1319),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1321),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1352] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_in] = ACTIONS(4469),
    [sym_line_comment] = ACTIONS(7),
  },
  [1353] = {
    [sym_raw_string_literal] = ACTIONS(4471),
    [sym_float_literal] = ACTIONS(4471),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(4471),
    [anon_sym_SEMI] = ACTIONS(4471),
    [anon_sym_macro_rules_BANG] = ACTIONS(4471),
    [anon_sym_LPAREN] = ACTIONS(4471),
    [anon_sym_LBRACE] = ACTIONS(4471),
    [anon_sym_RBRACE] = ACTIONS(4471),
    [anon_sym_LBRACK] = ACTIONS(4471),
    [anon_sym_PLUS] = ACTIONS(4473),
    [anon_sym_STAR] = ACTIONS(4473),
    [anon_sym_u8] = ACTIONS(4473),
    [anon_sym_i8] = ACTIONS(4473),
    [anon_sym_u16] = ACTIONS(4473),
    [anon_sym_i16] = ACTIONS(4473),
    [anon_sym_u32] = ACTIONS(4473),
    [anon_sym_i32] = ACTIONS(4473),
    [anon_sym_u64] = ACTIONS(4473),
    [anon_sym_i64] = ACTIONS(4473),
    [anon_sym_u128] = ACTIONS(4473),
    [anon_sym_i128] = ACTIONS(4473),
    [anon_sym_isize] = ACTIONS(4473),
    [anon_sym_usize] = ACTIONS(4473),
    [anon_sym_f32] = ACTIONS(4473),
    [anon_sym_f64] = ACTIONS(4473),
    [anon_sym_bool] = ACTIONS(4473),
    [anon_sym_str] = ACTIONS(4473),
    [anon_sym_char] = ACTIONS(4473),
    [anon_sym_AMP] = ACTIONS(4473),
    [anon_sym_DASH] = ACTIONS(4473),
    [anon_sym_DOT] = ACTIONS(4473),
    [anon_sym_DASH_EQ] = ACTIONS(4471),
    [anon_sym_COLON_COLON] = ACTIONS(4471),
    [anon_sym_BANG] = ACTIONS(4473),
    [anon_sym_BANG_EQ] = ACTIONS(4471),
    [anon_sym_STAR_EQ] = ACTIONS(4471),
    [anon_sym_SLASH] = ACTIONS(4473),
    [anon_sym_SLASH_EQ] = ACTIONS(4471),
    [anon_sym_AMP_AMP] = ACTIONS(4471),
    [anon_sym_AMP_EQ] = ACTIONS(4471),
    [anon_sym_POUND] = ACTIONS(4471),
    [anon_sym_PERCENT] = ACTIONS(4473),
    [anon_sym_PERCENT_EQ] = ACTIONS(4471),
    [anon_sym_CARET] = ACTIONS(4473),
    [anon_sym_CARET_EQ] = ACTIONS(4471),
    [anon_sym_PLUS_EQ] = ACTIONS(4471),
    [anon_sym_LT] = ACTIONS(4473),
    [anon_sym_LT_LT] = ACTIONS(4473),
    [anon_sym_LT_LT_EQ] = ACTIONS(4471),
    [anon_sym_LT_EQ] = ACTIONS(4471),
    [anon_sym_EQ] = ACTIONS(4473),
    [anon_sym_EQ_EQ] = ACTIONS(4471),
    [anon_sym_GT] = ACTIONS(4473),
    [anon_sym_GT_EQ] = ACTIONS(4471),
    [anon_sym_GT_GT] = ACTIONS(4473),
    [anon_sym_GT_GT_EQ] = ACTIONS(4471),
    [anon_sym_PIPE] = ACTIONS(4473),
    [anon_sym_PIPE_EQ] = ACTIONS(4471),
    [anon_sym_PIPE_PIPE] = ACTIONS(4471),
    [anon_sym_QMARK] = ACTIONS(4471),
    [anon_sym_SQUOTE] = ACTIONS(4473),
    [anon_sym_DOT_DOT] = ACTIONS(4473),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4471),
    [anon_sym_as] = ACTIONS(4473),
    [anon_sym_break] = ACTIONS(4473),
    [anon_sym_const] = ACTIONS(4473),
    [anon_sym_continue] = ACTIONS(4473),
    [anon_sym_default] = ACTIONS(4473),
    [anon_sym_enum] = ACTIONS(4473),
    [anon_sym_fn] = ACTIONS(4473),
    [anon_sym_for] = ACTIONS(4473),
    [anon_sym_if] = ACTIONS(4473),
    [anon_sym_impl] = ACTIONS(4473),
    [anon_sym_let] = ACTIONS(4473),
    [anon_sym_loop] = ACTIONS(4473),
    [anon_sym_match] = ACTIONS(4473),
    [anon_sym_mod] = ACTIONS(4473),
    [anon_sym_pub] = ACTIONS(4473),
    [anon_sym_return] = ACTIONS(4473),
    [anon_sym_static] = ACTIONS(4473),
    [anon_sym_struct] = ACTIONS(4473),
    [anon_sym_trait] = ACTIONS(4473),
    [anon_sym_type] = ACTIONS(4473),
    [anon_sym_union] = ACTIONS(4473),
    [anon_sym_unsafe] = ACTIONS(4473),
    [anon_sym_use] = ACTIONS(4473),
    [anon_sym_while] = ACTIONS(4473),
    [anon_sym_extern] = ACTIONS(4473),
    [anon_sym_move] = ACTIONS(4473),
    [sym_integer_literal] = ACTIONS(4471),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(4471),
    [sym_char_literal] = ACTIONS(4471),
    [anon_sym_true] = ACTIONS(4473),
    [anon_sym_false] = ACTIONS(4473),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4473),
    [sym_self] = ACTIONS(4473),
    [sym_super] = ACTIONS(4473),
    [sym_crate] = ACTIONS(4473),
    [sym_metavariable] = ACTIONS(4471),
  },
  [1354] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(2025),
    [sym_tuple_pattern] = STATE(2025),
    [sym_tuple_struct_pattern] = STATE(2025),
    [sym_struct_pattern] = STATE(2025),
    [sym_remaining_field_pattern] = STATE(2025),
    [sym_mut_pattern] = STATE(2025),
    [sym_ref_pattern] = STATE(2025),
    [sym_captured_pattern] = STATE(2025),
    [sym_reference_pattern] = STATE(2025),
    [sym__literal] = STATE(2025),
    [sym_string_literal] = STATE(2025),
    [sym_boolean_literal] = STATE(2025),
    [sym_raw_string_literal] = ACTIONS(4475),
    [sym_float_literal] = ACTIONS(4475),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(4477),
    [anon_sym_AMP] = ACTIONS(955),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(957),
    [anon_sym_ref] = ACTIONS(959),
    [sym_integer_literal] = ACTIONS(4475),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(4475),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(961),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [1355] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(2026),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [1356] = {
    [sym__token_pattern] = STATE(2028),
    [sym_token_tree_pattern] = STATE(2028),
    [sym_token_binding_pattern] = STATE(2028),
    [sym_token_repetition_pattern] = STATE(2028),
    [sym__literal] = STATE(2028),
    [sym_string_literal] = STATE(2028),
    [sym_boolean_literal] = STATE(2028),
    [aux_sym_token_tree_pattern_repeat1] = STATE(2028),
    [sym_raw_string_literal] = ACTIONS(4479),
    [sym_float_literal] = ACTIONS(4479),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4479),
    [anon_sym_LPAREN] = ACTIONS(2681),
    [anon_sym_RPAREN] = ACTIONS(4481),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_EQ_GT] = ACTIONS(4479),
    [anon_sym_LBRACK] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(4483),
    [anon_sym_DOLLAR] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(4483),
    [anon_sym_STAR] = ACTIONS(4483),
    [anon_sym_COMMA] = ACTIONS(4479),
    [anon_sym_u8] = ACTIONS(2693),
    [anon_sym_i8] = ACTIONS(2693),
    [anon_sym_u16] = ACTIONS(2693),
    [anon_sym_i16] = ACTIONS(2693),
    [anon_sym_u32] = ACTIONS(2693),
    [anon_sym_i32] = ACTIONS(2693),
    [anon_sym_u64] = ACTIONS(2693),
    [anon_sym_i64] = ACTIONS(2693),
    [anon_sym_u128] = ACTIONS(2693),
    [anon_sym_i128] = ACTIONS(2693),
    [anon_sym_isize] = ACTIONS(2693),
    [anon_sym_usize] = ACTIONS(2693),
    [anon_sym_f32] = ACTIONS(2693),
    [anon_sym_f64] = ACTIONS(2693),
    [anon_sym_bool] = ACTIONS(2693),
    [anon_sym_str] = ACTIONS(2693),
    [anon_sym_char] = ACTIONS(2693),
    [anon_sym__] = ACTIONS(4483),
    [anon_sym_AMP] = ACTIONS(4483),
    [anon_sym_DASH] = ACTIONS(4483),
    [anon_sym_DOT] = ACTIONS(4483),
    [anon_sym_DASH_EQ] = ACTIONS(4479),
    [anon_sym_DASH_GT] = ACTIONS(4479),
    [anon_sym_COLON_COLON] = ACTIONS(4479),
    [anon_sym_BANG] = ACTIONS(4483),
    [anon_sym_BANG_EQ] = ACTIONS(4479),
    [anon_sym_AT] = ACTIONS(4479),
    [anon_sym_STAR_EQ] = ACTIONS(4479),
    [anon_sym_SLASH] = ACTIONS(4483),
    [anon_sym_SLASH_EQ] = ACTIONS(4479),
    [anon_sym_AMP_AMP] = ACTIONS(4479),
    [anon_sym_AMP_EQ] = ACTIONS(4479),
    [anon_sym_POUND] = ACTIONS(4479),
    [anon_sym_PERCENT] = ACTIONS(4483),
    [anon_sym_PERCENT_EQ] = ACTIONS(4479),
    [anon_sym_CARET] = ACTIONS(4483),
    [anon_sym_CARET_EQ] = ACTIONS(4479),
    [anon_sym_PLUS_EQ] = ACTIONS(4479),
    [anon_sym_LT] = ACTIONS(4483),
    [anon_sym_LT_LT] = ACTIONS(4483),
    [anon_sym_LT_LT_EQ] = ACTIONS(4479),
    [anon_sym_LT_EQ] = ACTIONS(4479),
    [anon_sym_EQ] = ACTIONS(4483),
    [anon_sym_EQ_EQ] = ACTIONS(4479),
    [anon_sym_GT] = ACTIONS(4483),
    [anon_sym_GT_EQ] = ACTIONS(4479),
    [anon_sym_GT_GT] = ACTIONS(4483),
    [anon_sym_GT_GT_EQ] = ACTIONS(4479),
    [anon_sym_PIPE] = ACTIONS(4483),
    [anon_sym_PIPE_EQ] = ACTIONS(4479),
    [anon_sym_PIPE_PIPE] = ACTIONS(4479),
    [anon_sym_TILDE] = ACTIONS(4479),
    [anon_sym_QMARK] = ACTIONS(4479),
    [anon_sym_SQUOTE] = ACTIONS(4483),
    [anon_sym_DOT_DOT] = ACTIONS(4483),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4479),
    [anon_sym_as] = ACTIONS(4483),
    [anon_sym_break] = ACTIONS(4483),
    [anon_sym_const] = ACTIONS(4483),
    [anon_sym_continue] = ACTIONS(4483),
    [anon_sym_default] = ACTIONS(4483),
    [anon_sym_enum] = ACTIONS(4483),
    [anon_sym_fn] = ACTIONS(4483),
    [anon_sym_for] = ACTIONS(4483),
    [anon_sym_if] = ACTIONS(4483),
    [anon_sym_impl] = ACTIONS(4483),
    [anon_sym_let] = ACTIONS(4483),
    [anon_sym_loop] = ACTIONS(4483),
    [anon_sym_match] = ACTIONS(4483),
    [anon_sym_mod] = ACTIONS(4483),
    [anon_sym_pub] = ACTIONS(4483),
    [anon_sym_return] = ACTIONS(4483),
    [anon_sym_static] = ACTIONS(4483),
    [anon_sym_struct] = ACTIONS(4483),
    [anon_sym_trait] = ACTIONS(4483),
    [anon_sym_type] = ACTIONS(4483),
    [anon_sym_union] = ACTIONS(4483),
    [anon_sym_unsafe] = ACTIONS(4483),
    [anon_sym_use] = ACTIONS(4483),
    [anon_sym_where] = ACTIONS(4483),
    [anon_sym_while] = ACTIONS(4483),
    [sym_mutable_specifier] = ACTIONS(4483),
    [sym_integer_literal] = ACTIONS(4479),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(4479),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4483),
    [sym_self] = ACTIONS(4483),
    [sym_super] = ACTIONS(4483),
    [sym_crate] = ACTIONS(4483),
    [sym_metavariable] = ACTIONS(2695),
  },
  [1357] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(4485),
    [sym_line_comment] = ACTIONS(7),
  },
  [1358] = {
    [sym__token_pattern] = STATE(2029),
    [sym_token_tree_pattern] = STATE(2029),
    [sym_token_binding_pattern] = STATE(2029),
    [sym_token_repetition_pattern] = STATE(2029),
    [sym__literal] = STATE(2029),
    [sym_string_literal] = STATE(2029),
    [sym_boolean_literal] = STATE(2029),
    [aux_sym_token_tree_pattern_repeat1] = STATE(2029),
    [sym_raw_string_literal] = ACTIONS(4487),
    [sym_float_literal] = ACTIONS(4487),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4487),
    [anon_sym_LPAREN] = ACTIONS(2681),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_RBRACE] = ACTIONS(4481),
    [anon_sym_EQ_GT] = ACTIONS(4487),
    [anon_sym_LBRACK] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(4489),
    [anon_sym_DOLLAR] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(4489),
    [anon_sym_STAR] = ACTIONS(4489),
    [anon_sym_COMMA] = ACTIONS(4487),
    [anon_sym_u8] = ACTIONS(2693),
    [anon_sym_i8] = ACTIONS(2693),
    [anon_sym_u16] = ACTIONS(2693),
    [anon_sym_i16] = ACTIONS(2693),
    [anon_sym_u32] = ACTIONS(2693),
    [anon_sym_i32] = ACTIONS(2693),
    [anon_sym_u64] = ACTIONS(2693),
    [anon_sym_i64] = ACTIONS(2693),
    [anon_sym_u128] = ACTIONS(2693),
    [anon_sym_i128] = ACTIONS(2693),
    [anon_sym_isize] = ACTIONS(2693),
    [anon_sym_usize] = ACTIONS(2693),
    [anon_sym_f32] = ACTIONS(2693),
    [anon_sym_f64] = ACTIONS(2693),
    [anon_sym_bool] = ACTIONS(2693),
    [anon_sym_str] = ACTIONS(2693),
    [anon_sym_char] = ACTIONS(2693),
    [anon_sym__] = ACTIONS(4489),
    [anon_sym_AMP] = ACTIONS(4489),
    [anon_sym_DASH] = ACTIONS(4489),
    [anon_sym_DOT] = ACTIONS(4489),
    [anon_sym_DASH_EQ] = ACTIONS(4487),
    [anon_sym_DASH_GT] = ACTIONS(4487),
    [anon_sym_COLON_COLON] = ACTIONS(4487),
    [anon_sym_BANG] = ACTIONS(4489),
    [anon_sym_BANG_EQ] = ACTIONS(4487),
    [anon_sym_AT] = ACTIONS(4487),
    [anon_sym_STAR_EQ] = ACTIONS(4487),
    [anon_sym_SLASH] = ACTIONS(4489),
    [anon_sym_SLASH_EQ] = ACTIONS(4487),
    [anon_sym_AMP_AMP] = ACTIONS(4487),
    [anon_sym_AMP_EQ] = ACTIONS(4487),
    [anon_sym_POUND] = ACTIONS(4487),
    [anon_sym_PERCENT] = ACTIONS(4489),
    [anon_sym_PERCENT_EQ] = ACTIONS(4487),
    [anon_sym_CARET] = ACTIONS(4489),
    [anon_sym_CARET_EQ] = ACTIONS(4487),
    [anon_sym_PLUS_EQ] = ACTIONS(4487),
    [anon_sym_LT] = ACTIONS(4489),
    [anon_sym_LT_LT] = ACTIONS(4489),
    [anon_sym_LT_LT_EQ] = ACTIONS(4487),
    [anon_sym_LT_EQ] = ACTIONS(4487),
    [anon_sym_EQ] = ACTIONS(4489),
    [anon_sym_EQ_EQ] = ACTIONS(4487),
    [anon_sym_GT] = ACTIONS(4489),
    [anon_sym_GT_EQ] = ACTIONS(4487),
    [anon_sym_GT_GT] = ACTIONS(4489),
    [anon_sym_GT_GT_EQ] = ACTIONS(4487),
    [anon_sym_PIPE] = ACTIONS(4489),
    [anon_sym_PIPE_EQ] = ACTIONS(4487),
    [anon_sym_PIPE_PIPE] = ACTIONS(4487),
    [anon_sym_TILDE] = ACTIONS(4487),
    [anon_sym_QMARK] = ACTIONS(4487),
    [anon_sym_SQUOTE] = ACTIONS(4489),
    [anon_sym_DOT_DOT] = ACTIONS(4489),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4487),
    [anon_sym_as] = ACTIONS(4489),
    [anon_sym_break] = ACTIONS(4489),
    [anon_sym_const] = ACTIONS(4489),
    [anon_sym_continue] = ACTIONS(4489),
    [anon_sym_default] = ACTIONS(4489),
    [anon_sym_enum] = ACTIONS(4489),
    [anon_sym_fn] = ACTIONS(4489),
    [anon_sym_for] = ACTIONS(4489),
    [anon_sym_if] = ACTIONS(4489),
    [anon_sym_impl] = ACTIONS(4489),
    [anon_sym_let] = ACTIONS(4489),
    [anon_sym_loop] = ACTIONS(4489),
    [anon_sym_match] = ACTIONS(4489),
    [anon_sym_mod] = ACTIONS(4489),
    [anon_sym_pub] = ACTIONS(4489),
    [anon_sym_return] = ACTIONS(4489),
    [anon_sym_static] = ACTIONS(4489),
    [anon_sym_struct] = ACTIONS(4489),
    [anon_sym_trait] = ACTIONS(4489),
    [anon_sym_type] = ACTIONS(4489),
    [anon_sym_union] = ACTIONS(4489),
    [anon_sym_unsafe] = ACTIONS(4489),
    [anon_sym_use] = ACTIONS(4489),
    [anon_sym_where] = ACTIONS(4489),
    [anon_sym_while] = ACTIONS(4489),
    [sym_mutable_specifier] = ACTIONS(4489),
    [sym_integer_literal] = ACTIONS(4487),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4489),
    [sym_self] = ACTIONS(4489),
    [sym_super] = ACTIONS(4489),
    [sym_crate] = ACTIONS(4489),
    [sym_metavariable] = ACTIONS(2695),
  },
  [1359] = {
    [sym__token_pattern] = STATE(2030),
    [sym_token_tree_pattern] = STATE(2030),
    [sym_token_binding_pattern] = STATE(2030),
    [sym_token_repetition_pattern] = STATE(2030),
    [sym__literal] = STATE(2030),
    [sym_string_literal] = STATE(2030),
    [sym_boolean_literal] = STATE(2030),
    [aux_sym_token_tree_pattern_repeat1] = STATE(2030),
    [sym_raw_string_literal] = ACTIONS(4491),
    [sym_float_literal] = ACTIONS(4491),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4491),
    [anon_sym_LPAREN] = ACTIONS(2681),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_EQ_GT] = ACTIONS(4491),
    [anon_sym_LBRACK] = ACTIONS(2687),
    [anon_sym_RBRACK] = ACTIONS(4481),
    [anon_sym_COLON] = ACTIONS(4493),
    [anon_sym_DOLLAR] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(4493),
    [anon_sym_STAR] = ACTIONS(4493),
    [anon_sym_COMMA] = ACTIONS(4491),
    [anon_sym_u8] = ACTIONS(2693),
    [anon_sym_i8] = ACTIONS(2693),
    [anon_sym_u16] = ACTIONS(2693),
    [anon_sym_i16] = ACTIONS(2693),
    [anon_sym_u32] = ACTIONS(2693),
    [anon_sym_i32] = ACTIONS(2693),
    [anon_sym_u64] = ACTIONS(2693),
    [anon_sym_i64] = ACTIONS(2693),
    [anon_sym_u128] = ACTIONS(2693),
    [anon_sym_i128] = ACTIONS(2693),
    [anon_sym_isize] = ACTIONS(2693),
    [anon_sym_usize] = ACTIONS(2693),
    [anon_sym_f32] = ACTIONS(2693),
    [anon_sym_f64] = ACTIONS(2693),
    [anon_sym_bool] = ACTIONS(2693),
    [anon_sym_str] = ACTIONS(2693),
    [anon_sym_char] = ACTIONS(2693),
    [anon_sym__] = ACTIONS(4493),
    [anon_sym_AMP] = ACTIONS(4493),
    [anon_sym_DASH] = ACTIONS(4493),
    [anon_sym_DOT] = ACTIONS(4493),
    [anon_sym_DASH_EQ] = ACTIONS(4491),
    [anon_sym_DASH_GT] = ACTIONS(4491),
    [anon_sym_COLON_COLON] = ACTIONS(4491),
    [anon_sym_BANG] = ACTIONS(4493),
    [anon_sym_BANG_EQ] = ACTIONS(4491),
    [anon_sym_AT] = ACTIONS(4491),
    [anon_sym_STAR_EQ] = ACTIONS(4491),
    [anon_sym_SLASH] = ACTIONS(4493),
    [anon_sym_SLASH_EQ] = ACTIONS(4491),
    [anon_sym_AMP_AMP] = ACTIONS(4491),
    [anon_sym_AMP_EQ] = ACTIONS(4491),
    [anon_sym_POUND] = ACTIONS(4491),
    [anon_sym_PERCENT] = ACTIONS(4493),
    [anon_sym_PERCENT_EQ] = ACTIONS(4491),
    [anon_sym_CARET] = ACTIONS(4493),
    [anon_sym_CARET_EQ] = ACTIONS(4491),
    [anon_sym_PLUS_EQ] = ACTIONS(4491),
    [anon_sym_LT] = ACTIONS(4493),
    [anon_sym_LT_LT] = ACTIONS(4493),
    [anon_sym_LT_LT_EQ] = ACTIONS(4491),
    [anon_sym_LT_EQ] = ACTIONS(4491),
    [anon_sym_EQ] = ACTIONS(4493),
    [anon_sym_EQ_EQ] = ACTIONS(4491),
    [anon_sym_GT] = ACTIONS(4493),
    [anon_sym_GT_EQ] = ACTIONS(4491),
    [anon_sym_GT_GT] = ACTIONS(4493),
    [anon_sym_GT_GT_EQ] = ACTIONS(4491),
    [anon_sym_PIPE] = ACTIONS(4493),
    [anon_sym_PIPE_EQ] = ACTIONS(4491),
    [anon_sym_PIPE_PIPE] = ACTIONS(4491),
    [anon_sym_TILDE] = ACTIONS(4491),
    [anon_sym_QMARK] = ACTIONS(4491),
    [anon_sym_SQUOTE] = ACTIONS(4493),
    [anon_sym_DOT_DOT] = ACTIONS(4493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4491),
    [anon_sym_as] = ACTIONS(4493),
    [anon_sym_break] = ACTIONS(4493),
    [anon_sym_const] = ACTIONS(4493),
    [anon_sym_continue] = ACTIONS(4493),
    [anon_sym_default] = ACTIONS(4493),
    [anon_sym_enum] = ACTIONS(4493),
    [anon_sym_fn] = ACTIONS(4493),
    [anon_sym_for] = ACTIONS(4493),
    [anon_sym_if] = ACTIONS(4493),
    [anon_sym_impl] = ACTIONS(4493),
    [anon_sym_let] = ACTIONS(4493),
    [anon_sym_loop] = ACTIONS(4493),
    [anon_sym_match] = ACTIONS(4493),
    [anon_sym_mod] = ACTIONS(4493),
    [anon_sym_pub] = ACTIONS(4493),
    [anon_sym_return] = ACTIONS(4493),
    [anon_sym_static] = ACTIONS(4493),
    [anon_sym_struct] = ACTIONS(4493),
    [anon_sym_trait] = ACTIONS(4493),
    [anon_sym_type] = ACTIONS(4493),
    [anon_sym_union] = ACTIONS(4493),
    [anon_sym_unsafe] = ACTIONS(4493),
    [anon_sym_use] = ACTIONS(4493),
    [anon_sym_where] = ACTIONS(4493),
    [anon_sym_while] = ACTIONS(4493),
    [sym_mutable_specifier] = ACTIONS(4493),
    [sym_integer_literal] = ACTIONS(4491),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(4491),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4493),
    [sym_self] = ACTIONS(4493),
    [sym_super] = ACTIONS(4493),
    [sym_crate] = ACTIONS(4493),
    [sym_metavariable] = ACTIONS(2695),
  },
  [1360] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(4495),
    [sym_line_comment] = ACTIONS(7),
  },
  [1361] = {
    [sym_raw_string_literal] = ACTIONS(4497),
    [sym_float_literal] = ACTIONS(4497),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4497),
    [anon_sym_LPAREN] = ACTIONS(4497),
    [anon_sym_RPAREN] = ACTIONS(4497),
    [anon_sym_LBRACE] = ACTIONS(4497),
    [anon_sym_RBRACE] = ACTIONS(4497),
    [anon_sym_EQ_GT] = ACTIONS(4497),
    [anon_sym_LBRACK] = ACTIONS(4497),
    [anon_sym_RBRACK] = ACTIONS(4497),
    [anon_sym_COLON] = ACTIONS(4499),
    [anon_sym_DOLLAR] = ACTIONS(4499),
    [anon_sym_PLUS] = ACTIONS(4499),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_COMMA] = ACTIONS(4497),
    [anon_sym_u8] = ACTIONS(4499),
    [anon_sym_i8] = ACTIONS(4499),
    [anon_sym_u16] = ACTIONS(4499),
    [anon_sym_i16] = ACTIONS(4499),
    [anon_sym_u32] = ACTIONS(4499),
    [anon_sym_i32] = ACTIONS(4499),
    [anon_sym_u64] = ACTIONS(4499),
    [anon_sym_i64] = ACTIONS(4499),
    [anon_sym_u128] = ACTIONS(4499),
    [anon_sym_i128] = ACTIONS(4499),
    [anon_sym_isize] = ACTIONS(4499),
    [anon_sym_usize] = ACTIONS(4499),
    [anon_sym_f32] = ACTIONS(4499),
    [anon_sym_f64] = ACTIONS(4499),
    [anon_sym_bool] = ACTIONS(4499),
    [anon_sym_str] = ACTIONS(4499),
    [anon_sym_char] = ACTIONS(4499),
    [anon_sym__] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym_DASH] = ACTIONS(4499),
    [anon_sym_DOT] = ACTIONS(4499),
    [anon_sym_DASH_EQ] = ACTIONS(4497),
    [anon_sym_DASH_GT] = ACTIONS(4497),
    [anon_sym_COLON_COLON] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(4499),
    [anon_sym_BANG_EQ] = ACTIONS(4497),
    [anon_sym_AT] = ACTIONS(4497),
    [anon_sym_STAR_EQ] = ACTIONS(4497),
    [anon_sym_SLASH] = ACTIONS(4499),
    [anon_sym_SLASH_EQ] = ACTIONS(4497),
    [anon_sym_AMP_AMP] = ACTIONS(4497),
    [anon_sym_AMP_EQ] = ACTIONS(4497),
    [anon_sym_POUND] = ACTIONS(4497),
    [anon_sym_PERCENT] = ACTIONS(4499),
    [anon_sym_PERCENT_EQ] = ACTIONS(4497),
    [anon_sym_CARET] = ACTIONS(4499),
    [anon_sym_CARET_EQ] = ACTIONS(4497),
    [anon_sym_PLUS_EQ] = ACTIONS(4497),
    [anon_sym_LT] = ACTIONS(4499),
    [anon_sym_LT_LT] = ACTIONS(4499),
    [anon_sym_LT_LT_EQ] = ACTIONS(4497),
    [anon_sym_LT_EQ] = ACTIONS(4497),
    [anon_sym_EQ] = ACTIONS(4499),
    [anon_sym_EQ_EQ] = ACTIONS(4497),
    [anon_sym_GT] = ACTIONS(4499),
    [anon_sym_GT_EQ] = ACTIONS(4497),
    [anon_sym_GT_GT] = ACTIONS(4499),
    [anon_sym_GT_GT_EQ] = ACTIONS(4497),
    [anon_sym_PIPE] = ACTIONS(4499),
    [anon_sym_PIPE_EQ] = ACTIONS(4497),
    [anon_sym_PIPE_PIPE] = ACTIONS(4497),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_QMARK] = ACTIONS(4497),
    [anon_sym_SQUOTE] = ACTIONS(4499),
    [anon_sym_DOT_DOT] = ACTIONS(4499),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4497),
    [anon_sym_as] = ACTIONS(4499),
    [anon_sym_break] = ACTIONS(4499),
    [anon_sym_const] = ACTIONS(4499),
    [anon_sym_continue] = ACTIONS(4499),
    [anon_sym_default] = ACTIONS(4499),
    [anon_sym_enum] = ACTIONS(4499),
    [anon_sym_fn] = ACTIONS(4499),
    [anon_sym_for] = ACTIONS(4499),
    [anon_sym_if] = ACTIONS(4499),
    [anon_sym_impl] = ACTIONS(4499),
    [anon_sym_let] = ACTIONS(4499),
    [anon_sym_loop] = ACTIONS(4499),
    [anon_sym_match] = ACTIONS(4499),
    [anon_sym_mod] = ACTIONS(4499),
    [anon_sym_pub] = ACTIONS(4499),
    [anon_sym_return] = ACTIONS(4499),
    [anon_sym_static] = ACTIONS(4499),
    [anon_sym_struct] = ACTIONS(4499),
    [anon_sym_trait] = ACTIONS(4499),
    [anon_sym_type] = ACTIONS(4499),
    [anon_sym_union] = ACTIONS(4499),
    [anon_sym_unsafe] = ACTIONS(4499),
    [anon_sym_use] = ACTIONS(4499),
    [anon_sym_where] = ACTIONS(4499),
    [anon_sym_while] = ACTIONS(4499),
    [sym_mutable_specifier] = ACTIONS(4499),
    [sym_integer_literal] = ACTIONS(4497),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(4497),
    [sym_char_literal] = ACTIONS(4497),
    [anon_sym_true] = ACTIONS(4499),
    [anon_sym_false] = ACTIONS(4499),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4499),
    [sym_self] = ACTIONS(4499),
    [sym_super] = ACTIONS(4499),
    [sym_crate] = ACTIONS(4499),
    [sym_metavariable] = ACTIONS(4497),
  },
  [1362] = {
    [sym_raw_string_literal] = ACTIONS(4501),
    [sym_float_literal] = ACTIONS(4501),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4501),
    [anon_sym_LPAREN] = ACTIONS(4501),
    [anon_sym_RPAREN] = ACTIONS(4501),
    [anon_sym_LBRACE] = ACTIONS(4501),
    [anon_sym_RBRACE] = ACTIONS(4501),
    [anon_sym_EQ_GT] = ACTIONS(4501),
    [anon_sym_LBRACK] = ACTIONS(4501),
    [anon_sym_RBRACK] = ACTIONS(4501),
    [anon_sym_COLON] = ACTIONS(4503),
    [anon_sym_DOLLAR] = ACTIONS(4505),
    [anon_sym_PLUS] = ACTIONS(4505),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_COMMA] = ACTIONS(4501),
    [anon_sym_u8] = ACTIONS(4505),
    [anon_sym_i8] = ACTIONS(4505),
    [anon_sym_u16] = ACTIONS(4505),
    [anon_sym_i16] = ACTIONS(4505),
    [anon_sym_u32] = ACTIONS(4505),
    [anon_sym_i32] = ACTIONS(4505),
    [anon_sym_u64] = ACTIONS(4505),
    [anon_sym_i64] = ACTIONS(4505),
    [anon_sym_u128] = ACTIONS(4505),
    [anon_sym_i128] = ACTIONS(4505),
    [anon_sym_isize] = ACTIONS(4505),
    [anon_sym_usize] = ACTIONS(4505),
    [anon_sym_f32] = ACTIONS(4505),
    [anon_sym_f64] = ACTIONS(4505),
    [anon_sym_bool] = ACTIONS(4505),
    [anon_sym_str] = ACTIONS(4505),
    [anon_sym_char] = ACTIONS(4505),
    [anon_sym__] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym_DASH] = ACTIONS(4505),
    [anon_sym_DOT] = ACTIONS(4505),
    [anon_sym_DASH_EQ] = ACTIONS(4501),
    [anon_sym_DASH_GT] = ACTIONS(4501),
    [anon_sym_COLON_COLON] = ACTIONS(4501),
    [anon_sym_BANG] = ACTIONS(4505),
    [anon_sym_BANG_EQ] = ACTIONS(4501),
    [anon_sym_AT] = ACTIONS(4501),
    [anon_sym_STAR_EQ] = ACTIONS(4501),
    [anon_sym_SLASH] = ACTIONS(4505),
    [anon_sym_SLASH_EQ] = ACTIONS(4501),
    [anon_sym_AMP_AMP] = ACTIONS(4501),
    [anon_sym_AMP_EQ] = ACTIONS(4501),
    [anon_sym_POUND] = ACTIONS(4501),
    [anon_sym_PERCENT] = ACTIONS(4505),
    [anon_sym_PERCENT_EQ] = ACTIONS(4501),
    [anon_sym_CARET] = ACTIONS(4505),
    [anon_sym_CARET_EQ] = ACTIONS(4501),
    [anon_sym_PLUS_EQ] = ACTIONS(4501),
    [anon_sym_LT] = ACTIONS(4505),
    [anon_sym_LT_LT] = ACTIONS(4505),
    [anon_sym_LT_LT_EQ] = ACTIONS(4501),
    [anon_sym_LT_EQ] = ACTIONS(4501),
    [anon_sym_EQ] = ACTIONS(4505),
    [anon_sym_EQ_EQ] = ACTIONS(4501),
    [anon_sym_GT] = ACTIONS(4505),
    [anon_sym_GT_EQ] = ACTIONS(4501),
    [anon_sym_GT_GT] = ACTIONS(4505),
    [anon_sym_GT_GT_EQ] = ACTIONS(4501),
    [anon_sym_PIPE] = ACTIONS(4505),
    [anon_sym_PIPE_EQ] = ACTIONS(4501),
    [anon_sym_PIPE_PIPE] = ACTIONS(4501),
    [anon_sym_TILDE] = ACTIONS(4501),
    [anon_sym_QMARK] = ACTIONS(4501),
    [anon_sym_SQUOTE] = ACTIONS(4505),
    [anon_sym_DOT_DOT] = ACTIONS(4505),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4501),
    [anon_sym_as] = ACTIONS(4505),
    [anon_sym_break] = ACTIONS(4505),
    [anon_sym_const] = ACTIONS(4505),
    [anon_sym_continue] = ACTIONS(4505),
    [anon_sym_default] = ACTIONS(4505),
    [anon_sym_enum] = ACTIONS(4505),
    [anon_sym_fn] = ACTIONS(4505),
    [anon_sym_for] = ACTIONS(4505),
    [anon_sym_if] = ACTIONS(4505),
    [anon_sym_impl] = ACTIONS(4505),
    [anon_sym_let] = ACTIONS(4505),
    [anon_sym_loop] = ACTIONS(4505),
    [anon_sym_match] = ACTIONS(4505),
    [anon_sym_mod] = ACTIONS(4505),
    [anon_sym_pub] = ACTIONS(4505),
    [anon_sym_return] = ACTIONS(4505),
    [anon_sym_static] = ACTIONS(4505),
    [anon_sym_struct] = ACTIONS(4505),
    [anon_sym_trait] = ACTIONS(4505),
    [anon_sym_type] = ACTIONS(4505),
    [anon_sym_union] = ACTIONS(4505),
    [anon_sym_unsafe] = ACTIONS(4505),
    [anon_sym_use] = ACTIONS(4505),
    [anon_sym_where] = ACTIONS(4505),
    [anon_sym_while] = ACTIONS(4505),
    [sym_mutable_specifier] = ACTIONS(4505),
    [sym_integer_literal] = ACTIONS(4501),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(4501),
    [sym_char_literal] = ACTIONS(4501),
    [anon_sym_true] = ACTIONS(4505),
    [anon_sym_false] = ACTIONS(4505),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4505),
    [sym_self] = ACTIONS(4505),
    [sym_super] = ACTIONS(4505),
    [sym_crate] = ACTIONS(4505),
    [sym_metavariable] = ACTIONS(4501),
  },
  [1363] = {
    [sym__token_pattern] = STATE(2034),
    [sym_token_tree_pattern] = STATE(2034),
    [sym_token_binding_pattern] = STATE(2034),
    [sym_token_repetition_pattern] = STATE(2034),
    [sym__literal] = STATE(2034),
    [sym_string_literal] = STATE(2034),
    [sym_boolean_literal] = STATE(2034),
    [aux_sym_token_tree_pattern_repeat1] = STATE(2034),
    [sym_raw_string_literal] = ACTIONS(4507),
    [sym_float_literal] = ACTIONS(4507),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4507),
    [anon_sym_LPAREN] = ACTIONS(2681),
    [anon_sym_RPAREN] = ACTIONS(4509),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_EQ_GT] = ACTIONS(4507),
    [anon_sym_LBRACK] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(4511),
    [anon_sym_DOLLAR] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(4511),
    [anon_sym_STAR] = ACTIONS(4511),
    [anon_sym_COMMA] = ACTIONS(4507),
    [anon_sym_u8] = ACTIONS(2693),
    [anon_sym_i8] = ACTIONS(2693),
    [anon_sym_u16] = ACTIONS(2693),
    [anon_sym_i16] = ACTIONS(2693),
    [anon_sym_u32] = ACTIONS(2693),
    [anon_sym_i32] = ACTIONS(2693),
    [anon_sym_u64] = ACTIONS(2693),
    [anon_sym_i64] = ACTIONS(2693),
    [anon_sym_u128] = ACTIONS(2693),
    [anon_sym_i128] = ACTIONS(2693),
    [anon_sym_isize] = ACTIONS(2693),
    [anon_sym_usize] = ACTIONS(2693),
    [anon_sym_f32] = ACTIONS(2693),
    [anon_sym_f64] = ACTIONS(2693),
    [anon_sym_bool] = ACTIONS(2693),
    [anon_sym_str] = ACTIONS(2693),
    [anon_sym_char] = ACTIONS(2693),
    [anon_sym__] = ACTIONS(4511),
    [anon_sym_AMP] = ACTIONS(4511),
    [anon_sym_DASH] = ACTIONS(4511),
    [anon_sym_DOT] = ACTIONS(4511),
    [anon_sym_DASH_EQ] = ACTIONS(4507),
    [anon_sym_DASH_GT] = ACTIONS(4507),
    [anon_sym_COLON_COLON] = ACTIONS(4507),
    [anon_sym_BANG] = ACTIONS(4511),
    [anon_sym_BANG_EQ] = ACTIONS(4507),
    [anon_sym_AT] = ACTIONS(4507),
    [anon_sym_STAR_EQ] = ACTIONS(4507),
    [anon_sym_SLASH] = ACTIONS(4511),
    [anon_sym_SLASH_EQ] = ACTIONS(4507),
    [anon_sym_AMP_AMP] = ACTIONS(4507),
    [anon_sym_AMP_EQ] = ACTIONS(4507),
    [anon_sym_POUND] = ACTIONS(4507),
    [anon_sym_PERCENT] = ACTIONS(4511),
    [anon_sym_PERCENT_EQ] = ACTIONS(4507),
    [anon_sym_CARET] = ACTIONS(4511),
    [anon_sym_CARET_EQ] = ACTIONS(4507),
    [anon_sym_PLUS_EQ] = ACTIONS(4507),
    [anon_sym_LT] = ACTIONS(4511),
    [anon_sym_LT_LT] = ACTIONS(4511),
    [anon_sym_LT_LT_EQ] = ACTIONS(4507),
    [anon_sym_LT_EQ] = ACTIONS(4507),
    [anon_sym_EQ] = ACTIONS(4511),
    [anon_sym_EQ_EQ] = ACTIONS(4507),
    [anon_sym_GT] = ACTIONS(4511),
    [anon_sym_GT_EQ] = ACTIONS(4507),
    [anon_sym_GT_GT] = ACTIONS(4511),
    [anon_sym_GT_GT_EQ] = ACTIONS(4507),
    [anon_sym_PIPE] = ACTIONS(4511),
    [anon_sym_PIPE_EQ] = ACTIONS(4507),
    [anon_sym_PIPE_PIPE] = ACTIONS(4507),
    [anon_sym_TILDE] = ACTIONS(4507),
    [anon_sym_QMARK] = ACTIONS(4507),
    [anon_sym_SQUOTE] = ACTIONS(4511),
    [anon_sym_DOT_DOT] = ACTIONS(4511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4507),
    [anon_sym_as] = ACTIONS(4511),
    [anon_sym_break] = ACTIONS(4511),
    [anon_sym_const] = ACTIONS(4511),
    [anon_sym_continue] = ACTIONS(4511),
    [anon_sym_default] = ACTIONS(4511),
    [anon_sym_enum] = ACTIONS(4511),
    [anon_sym_fn] = ACTIONS(4511),
    [anon_sym_for] = ACTIONS(4511),
    [anon_sym_if] = ACTIONS(4511),
    [anon_sym_impl] = ACTIONS(4511),
    [anon_sym_let] = ACTIONS(4511),
    [anon_sym_loop] = ACTIONS(4511),
    [anon_sym_match] = ACTIONS(4511),
    [anon_sym_mod] = ACTIONS(4511),
    [anon_sym_pub] = ACTIONS(4511),
    [anon_sym_return] = ACTIONS(4511),
    [anon_sym_static] = ACTIONS(4511),
    [anon_sym_struct] = ACTIONS(4511),
    [anon_sym_trait] = ACTIONS(4511),
    [anon_sym_type] = ACTIONS(4511),
    [anon_sym_union] = ACTIONS(4511),
    [anon_sym_unsafe] = ACTIONS(4511),
    [anon_sym_use] = ACTIONS(4511),
    [anon_sym_where] = ACTIONS(4511),
    [anon_sym_while] = ACTIONS(4511),
    [sym_mutable_specifier] = ACTIONS(4511),
    [sym_integer_literal] = ACTIONS(4507),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(4507),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4511),
    [sym_self] = ACTIONS(4511),
    [sym_super] = ACTIONS(4511),
    [sym_crate] = ACTIONS(4511),
    [sym_metavariable] = ACTIONS(2695),
  },
  [1364] = {
    [sym_raw_string_literal] = ACTIONS(4513),
    [sym_float_literal] = ACTIONS(4513),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(4513),
    [anon_sym_SEMI] = ACTIONS(4513),
    [anon_sym_macro_rules_BANG] = ACTIONS(4513),
    [anon_sym_LPAREN] = ACTIONS(4513),
    [anon_sym_LBRACE] = ACTIONS(4513),
    [anon_sym_RBRACE] = ACTIONS(4513),
    [anon_sym_LBRACK] = ACTIONS(4513),
    [anon_sym_STAR] = ACTIONS(4513),
    [anon_sym_u8] = ACTIONS(4515),
    [anon_sym_i8] = ACTIONS(4515),
    [anon_sym_u16] = ACTIONS(4515),
    [anon_sym_i16] = ACTIONS(4515),
    [anon_sym_u32] = ACTIONS(4515),
    [anon_sym_i32] = ACTIONS(4515),
    [anon_sym_u64] = ACTIONS(4515),
    [anon_sym_i64] = ACTIONS(4515),
    [anon_sym_u128] = ACTIONS(4515),
    [anon_sym_i128] = ACTIONS(4515),
    [anon_sym_isize] = ACTIONS(4515),
    [anon_sym_usize] = ACTIONS(4515),
    [anon_sym_f32] = ACTIONS(4515),
    [anon_sym_f64] = ACTIONS(4515),
    [anon_sym_bool] = ACTIONS(4515),
    [anon_sym_str] = ACTIONS(4515),
    [anon_sym_char] = ACTIONS(4515),
    [anon_sym_AMP] = ACTIONS(4513),
    [anon_sym_DASH] = ACTIONS(4513),
    [anon_sym_COLON_COLON] = ACTIONS(4513),
    [anon_sym_BANG] = ACTIONS(4513),
    [anon_sym_POUND] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(4513),
    [anon_sym_PIPE] = ACTIONS(4513),
    [anon_sym_SQUOTE] = ACTIONS(4515),
    [anon_sym_DOT_DOT] = ACTIONS(4513),
    [anon_sym_break] = ACTIONS(4515),
    [anon_sym_const] = ACTIONS(4515),
    [anon_sym_continue] = ACTIONS(4515),
    [anon_sym_default] = ACTIONS(4515),
    [anon_sym_enum] = ACTIONS(4515),
    [anon_sym_fn] = ACTIONS(4515),
    [anon_sym_for] = ACTIONS(4515),
    [anon_sym_if] = ACTIONS(4515),
    [anon_sym_impl] = ACTIONS(4515),
    [anon_sym_let] = ACTIONS(4515),
    [anon_sym_loop] = ACTIONS(4515),
    [anon_sym_match] = ACTIONS(4515),
    [anon_sym_mod] = ACTIONS(4515),
    [anon_sym_pub] = ACTIONS(4515),
    [anon_sym_return] = ACTIONS(4515),
    [anon_sym_static] = ACTIONS(4515),
    [anon_sym_struct] = ACTIONS(4515),
    [anon_sym_trait] = ACTIONS(4515),
    [anon_sym_type] = ACTIONS(4515),
    [anon_sym_union] = ACTIONS(4515),
    [anon_sym_unsafe] = ACTIONS(4515),
    [anon_sym_use] = ACTIONS(4515),
    [anon_sym_while] = ACTIONS(4515),
    [anon_sym_extern] = ACTIONS(4515),
    [anon_sym_move] = ACTIONS(4515),
    [sym_integer_literal] = ACTIONS(4513),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(4513),
    [sym_char_literal] = ACTIONS(4513),
    [anon_sym_true] = ACTIONS(4515),
    [anon_sym_false] = ACTIONS(4515),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4515),
    [sym_self] = ACTIONS(4515),
    [sym_super] = ACTIONS(4515),
    [sym_crate] = ACTIONS(4515),
    [sym_metavariable] = ACTIONS(4513),
  },
  [1365] = {
    [sym__token_pattern] = STATE(2035),
    [sym_token_tree_pattern] = STATE(2035),
    [sym_token_binding_pattern] = STATE(2035),
    [sym_token_repetition_pattern] = STATE(2035),
    [sym__literal] = STATE(2035),
    [sym_string_literal] = STATE(2035),
    [sym_boolean_literal] = STATE(2035),
    [aux_sym_token_tree_pattern_repeat1] = STATE(2035),
    [sym_raw_string_literal] = ACTIONS(4517),
    [sym_float_literal] = ACTIONS(4517),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(2681),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_RBRACE] = ACTIONS(4509),
    [anon_sym_EQ_GT] = ACTIONS(4517),
    [anon_sym_LBRACK] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(4519),
    [anon_sym_DOLLAR] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(4519),
    [anon_sym_STAR] = ACTIONS(4519),
    [anon_sym_COMMA] = ACTIONS(4517),
    [anon_sym_u8] = ACTIONS(2693),
    [anon_sym_i8] = ACTIONS(2693),
    [anon_sym_u16] = ACTIONS(2693),
    [anon_sym_i16] = ACTIONS(2693),
    [anon_sym_u32] = ACTIONS(2693),
    [anon_sym_i32] = ACTIONS(2693),
    [anon_sym_u64] = ACTIONS(2693),
    [anon_sym_i64] = ACTIONS(2693),
    [anon_sym_u128] = ACTIONS(2693),
    [anon_sym_i128] = ACTIONS(2693),
    [anon_sym_isize] = ACTIONS(2693),
    [anon_sym_usize] = ACTIONS(2693),
    [anon_sym_f32] = ACTIONS(2693),
    [anon_sym_f64] = ACTIONS(2693),
    [anon_sym_bool] = ACTIONS(2693),
    [anon_sym_str] = ACTIONS(2693),
    [anon_sym_char] = ACTIONS(2693),
    [anon_sym__] = ACTIONS(4519),
    [anon_sym_AMP] = ACTIONS(4519),
    [anon_sym_DASH] = ACTIONS(4519),
    [anon_sym_DOT] = ACTIONS(4519),
    [anon_sym_DASH_EQ] = ACTIONS(4517),
    [anon_sym_DASH_GT] = ACTIONS(4517),
    [anon_sym_COLON_COLON] = ACTIONS(4517),
    [anon_sym_BANG] = ACTIONS(4519),
    [anon_sym_BANG_EQ] = ACTIONS(4517),
    [anon_sym_AT] = ACTIONS(4517),
    [anon_sym_STAR_EQ] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(4519),
    [anon_sym_SLASH_EQ] = ACTIONS(4517),
    [anon_sym_AMP_AMP] = ACTIONS(4517),
    [anon_sym_AMP_EQ] = ACTIONS(4517),
    [anon_sym_POUND] = ACTIONS(4517),
    [anon_sym_PERCENT] = ACTIONS(4519),
    [anon_sym_PERCENT_EQ] = ACTIONS(4517),
    [anon_sym_CARET] = ACTIONS(4519),
    [anon_sym_CARET_EQ] = ACTIONS(4517),
    [anon_sym_PLUS_EQ] = ACTIONS(4517),
    [anon_sym_LT] = ACTIONS(4519),
    [anon_sym_LT_LT] = ACTIONS(4519),
    [anon_sym_LT_LT_EQ] = ACTIONS(4517),
    [anon_sym_LT_EQ] = ACTIONS(4517),
    [anon_sym_EQ] = ACTIONS(4519),
    [anon_sym_EQ_EQ] = ACTIONS(4517),
    [anon_sym_GT] = ACTIONS(4519),
    [anon_sym_GT_EQ] = ACTIONS(4517),
    [anon_sym_GT_GT] = ACTIONS(4519),
    [anon_sym_GT_GT_EQ] = ACTIONS(4517),
    [anon_sym_PIPE] = ACTIONS(4519),
    [anon_sym_PIPE_EQ] = ACTIONS(4517),
    [anon_sym_PIPE_PIPE] = ACTIONS(4517),
    [anon_sym_TILDE] = ACTIONS(4517),
    [anon_sym_QMARK] = ACTIONS(4517),
    [anon_sym_SQUOTE] = ACTIONS(4519),
    [anon_sym_DOT_DOT] = ACTIONS(4519),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4517),
    [anon_sym_as] = ACTIONS(4519),
    [anon_sym_break] = ACTIONS(4519),
    [anon_sym_const] = ACTIONS(4519),
    [anon_sym_continue] = ACTIONS(4519),
    [anon_sym_default] = ACTIONS(4519),
    [anon_sym_enum] = ACTIONS(4519),
    [anon_sym_fn] = ACTIONS(4519),
    [anon_sym_for] = ACTIONS(4519),
    [anon_sym_if] = ACTIONS(4519),
    [anon_sym_impl] = ACTIONS(4519),
    [anon_sym_let] = ACTIONS(4519),
    [anon_sym_loop] = ACTIONS(4519),
    [anon_sym_match] = ACTIONS(4519),
    [anon_sym_mod] = ACTIONS(4519),
    [anon_sym_pub] = ACTIONS(4519),
    [anon_sym_return] = ACTIONS(4519),
    [anon_sym_static] = ACTIONS(4519),
    [anon_sym_struct] = ACTIONS(4519),
    [anon_sym_trait] = ACTIONS(4519),
    [anon_sym_type] = ACTIONS(4519),
    [anon_sym_union] = ACTIONS(4519),
    [anon_sym_unsafe] = ACTIONS(4519),
    [anon_sym_use] = ACTIONS(4519),
    [anon_sym_where] = ACTIONS(4519),
    [anon_sym_while] = ACTIONS(4519),
    [sym_mutable_specifier] = ACTIONS(4519),
    [sym_integer_literal] = ACTIONS(4517),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(4517),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4519),
    [sym_self] = ACTIONS(4519),
    [sym_super] = ACTIONS(4519),
    [sym_crate] = ACTIONS(4519),
    [sym_metavariable] = ACTIONS(2695),
  },
  [1366] = {
    [sym__token_pattern] = STATE(2036),
    [sym_token_tree_pattern] = STATE(2036),
    [sym_token_binding_pattern] = STATE(2036),
    [sym_token_repetition_pattern] = STATE(2036),
    [sym__literal] = STATE(2036),
    [sym_string_literal] = STATE(2036),
    [sym_boolean_literal] = STATE(2036),
    [aux_sym_token_tree_pattern_repeat1] = STATE(2036),
    [sym_raw_string_literal] = ACTIONS(4521),
    [sym_float_literal] = ACTIONS(4521),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4521),
    [anon_sym_LPAREN] = ACTIONS(2681),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_EQ_GT] = ACTIONS(4521),
    [anon_sym_LBRACK] = ACTIONS(2687),
    [anon_sym_RBRACK] = ACTIONS(4509),
    [anon_sym_COLON] = ACTIONS(4523),
    [anon_sym_DOLLAR] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(4523),
    [anon_sym_STAR] = ACTIONS(4523),
    [anon_sym_COMMA] = ACTIONS(4521),
    [anon_sym_u8] = ACTIONS(2693),
    [anon_sym_i8] = ACTIONS(2693),
    [anon_sym_u16] = ACTIONS(2693),
    [anon_sym_i16] = ACTIONS(2693),
    [anon_sym_u32] = ACTIONS(2693),
    [anon_sym_i32] = ACTIONS(2693),
    [anon_sym_u64] = ACTIONS(2693),
    [anon_sym_i64] = ACTIONS(2693),
    [anon_sym_u128] = ACTIONS(2693),
    [anon_sym_i128] = ACTIONS(2693),
    [anon_sym_isize] = ACTIONS(2693),
    [anon_sym_usize] = ACTIONS(2693),
    [anon_sym_f32] = ACTIONS(2693),
    [anon_sym_f64] = ACTIONS(2693),
    [anon_sym_bool] = ACTIONS(2693),
    [anon_sym_str] = ACTIONS(2693),
    [anon_sym_char] = ACTIONS(2693),
    [anon_sym__] = ACTIONS(4523),
    [anon_sym_AMP] = ACTIONS(4523),
    [anon_sym_DASH] = ACTIONS(4523),
    [anon_sym_DOT] = ACTIONS(4523),
    [anon_sym_DASH_EQ] = ACTIONS(4521),
    [anon_sym_DASH_GT] = ACTIONS(4521),
    [anon_sym_COLON_COLON] = ACTIONS(4521),
    [anon_sym_BANG] = ACTIONS(4523),
    [anon_sym_BANG_EQ] = ACTIONS(4521),
    [anon_sym_AT] = ACTIONS(4521),
    [anon_sym_STAR_EQ] = ACTIONS(4521),
    [anon_sym_SLASH] = ACTIONS(4523),
    [anon_sym_SLASH_EQ] = ACTIONS(4521),
    [anon_sym_AMP_AMP] = ACTIONS(4521),
    [anon_sym_AMP_EQ] = ACTIONS(4521),
    [anon_sym_POUND] = ACTIONS(4521),
    [anon_sym_PERCENT] = ACTIONS(4523),
    [anon_sym_PERCENT_EQ] = ACTIONS(4521),
    [anon_sym_CARET] = ACTIONS(4523),
    [anon_sym_CARET_EQ] = ACTIONS(4521),
    [anon_sym_PLUS_EQ] = ACTIONS(4521),
    [anon_sym_LT] = ACTIONS(4523),
    [anon_sym_LT_LT] = ACTIONS(4523),
    [anon_sym_LT_LT_EQ] = ACTIONS(4521),
    [anon_sym_LT_EQ] = ACTIONS(4521),
    [anon_sym_EQ] = ACTIONS(4523),
    [anon_sym_EQ_EQ] = ACTIONS(4521),
    [anon_sym_GT] = ACTIONS(4523),
    [anon_sym_GT_EQ] = ACTIONS(4521),
    [anon_sym_GT_GT] = ACTIONS(4523),
    [anon_sym_GT_GT_EQ] = ACTIONS(4521),
    [anon_sym_PIPE] = ACTIONS(4523),
    [anon_sym_PIPE_EQ] = ACTIONS(4521),
    [anon_sym_PIPE_PIPE] = ACTIONS(4521),
    [anon_sym_TILDE] = ACTIONS(4521),
    [anon_sym_QMARK] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4523),
    [anon_sym_DOT_DOT] = ACTIONS(4523),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4521),
    [anon_sym_as] = ACTIONS(4523),
    [anon_sym_break] = ACTIONS(4523),
    [anon_sym_const] = ACTIONS(4523),
    [anon_sym_continue] = ACTIONS(4523),
    [anon_sym_default] = ACTIONS(4523),
    [anon_sym_enum] = ACTIONS(4523),
    [anon_sym_fn] = ACTIONS(4523),
    [anon_sym_for] = ACTIONS(4523),
    [anon_sym_if] = ACTIONS(4523),
    [anon_sym_impl] = ACTIONS(4523),
    [anon_sym_let] = ACTIONS(4523),
    [anon_sym_loop] = ACTIONS(4523),
    [anon_sym_match] = ACTIONS(4523),
    [anon_sym_mod] = ACTIONS(4523),
    [anon_sym_pub] = ACTIONS(4523),
    [anon_sym_return] = ACTIONS(4523),
    [anon_sym_static] = ACTIONS(4523),
    [anon_sym_struct] = ACTIONS(4523),
    [anon_sym_trait] = ACTIONS(4523),
    [anon_sym_type] = ACTIONS(4523),
    [anon_sym_union] = ACTIONS(4523),
    [anon_sym_unsafe] = ACTIONS(4523),
    [anon_sym_use] = ACTIONS(4523),
    [anon_sym_where] = ACTIONS(4523),
    [anon_sym_while] = ACTIONS(4523),
    [sym_mutable_specifier] = ACTIONS(4523),
    [sym_integer_literal] = ACTIONS(4521),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(4521),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4523),
    [sym_self] = ACTIONS(4523),
    [sym_super] = ACTIONS(4523),
    [sym_crate] = ACTIONS(4523),
    [sym_metavariable] = ACTIONS(2695),
  },
  [1367] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(4525),
    [anon_sym_RPAREN] = ACTIONS(4525),
    [anon_sym_LBRACE] = ACTIONS(4525),
    [anon_sym_RBRACE] = ACTIONS(4525),
    [anon_sym_LBRACK] = ACTIONS(4525),
    [sym_line_comment] = ACTIONS(7),
  },
  [1368] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4527),
    [sym_line_comment] = ACTIONS(7),
  },
  [1369] = {
    [sym_token_tree] = STATE(2038),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1507),
    [anon_sym_LBRACE] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_line_comment] = ACTIONS(7),
  },
  [1370] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_RPAREN] = ACTIONS(4529),
    [sym_line_comment] = ACTIONS(7),
  },
  [1371] = {
    [sym_macro_rule] = STATE(2040),
    [sym_token_tree_pattern] = STATE(690),
    [aux_sym_macro_definition_repeat1] = STATE(1371),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(4531),
    [anon_sym_RPAREN] = ACTIONS(4525),
    [anon_sym_LBRACE] = ACTIONS(4534),
    [anon_sym_LBRACK] = ACTIONS(4537),
    [sym_line_comment] = ACTIONS(7),
  },
  [1372] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_RBRACE] = ACTIONS(4527),
    [sym_line_comment] = ACTIONS(7),
  },
  [1373] = {
    [sym_macro_rule] = STATE(2040),
    [sym_token_tree_pattern] = STATE(690),
    [aux_sym_macro_definition_repeat1] = STATE(1373),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(4531),
    [anon_sym_LBRACE] = ACTIONS(4534),
    [anon_sym_RBRACE] = ACTIONS(4525),
    [anon_sym_LBRACK] = ACTIONS(4537),
    [sym_line_comment] = ACTIONS(7),
  },
  [1374] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2789),
    [anon_sym_macro_rules_BANG] = ACTIONS(2789),
    [anon_sym_LPAREN] = ACTIONS(2789),
    [anon_sym_RPAREN] = ACTIONS(2789),
    [anon_sym_LBRACE] = ACTIONS(2789),
    [anon_sym_RBRACE] = ACTIONS(2789),
    [anon_sym_LBRACK] = ACTIONS(2789),
    [anon_sym_RBRACK] = ACTIONS(2789),
    [anon_sym_PLUS] = ACTIONS(2791),
    [anon_sym_STAR] = ACTIONS(2791),
    [anon_sym_COMMA] = ACTIONS(2789),
    [anon_sym_AMP] = ACTIONS(2791),
    [anon_sym_DASH] = ACTIONS(2791),
    [anon_sym_DOT] = ACTIONS(2791),
    [anon_sym_DASH_EQ] = ACTIONS(2789),
    [anon_sym_BANG_EQ] = ACTIONS(2789),
    [anon_sym_STAR_EQ] = ACTIONS(2789),
    [anon_sym_SLASH] = ACTIONS(2791),
    [anon_sym_SLASH_EQ] = ACTIONS(2789),
    [anon_sym_AMP_AMP] = ACTIONS(2789),
    [anon_sym_AMP_EQ] = ACTIONS(2789),
    [anon_sym_POUND] = ACTIONS(2789),
    [anon_sym_PERCENT] = ACTIONS(2791),
    [anon_sym_PERCENT_EQ] = ACTIONS(2789),
    [anon_sym_CARET] = ACTIONS(2791),
    [anon_sym_CARET_EQ] = ACTIONS(2789),
    [anon_sym_PLUS_EQ] = ACTIONS(2789),
    [anon_sym_LT] = ACTIONS(2791),
    [anon_sym_LT_LT] = ACTIONS(2791),
    [anon_sym_LT_LT_EQ] = ACTIONS(2789),
    [anon_sym_LT_EQ] = ACTIONS(2789),
    [anon_sym_EQ] = ACTIONS(2791),
    [anon_sym_EQ_EQ] = ACTIONS(2789),
    [anon_sym_GT] = ACTIONS(2791),
    [anon_sym_GT_EQ] = ACTIONS(2789),
    [anon_sym_GT_GT] = ACTIONS(2791),
    [anon_sym_GT_GT_EQ] = ACTIONS(2789),
    [anon_sym_PIPE] = ACTIONS(2791),
    [anon_sym_PIPE_EQ] = ACTIONS(2789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2789),
    [anon_sym_QMARK] = ACTIONS(2789),
    [anon_sym_DOT_DOT] = ACTIONS(2791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2789),
    [anon_sym_as] = ACTIONS(2791),
    [anon_sym_const] = ACTIONS(2791),
    [anon_sym_default] = ACTIONS(2791),
    [anon_sym_enum] = ACTIONS(2791),
    [anon_sym_fn] = ACTIONS(2791),
    [anon_sym_impl] = ACTIONS(2791),
    [anon_sym_let] = ACTIONS(2791),
    [anon_sym_mod] = ACTIONS(2791),
    [anon_sym_pub] = ACTIONS(2791),
    [anon_sym_static] = ACTIONS(2791),
    [anon_sym_struct] = ACTIONS(2791),
    [anon_sym_trait] = ACTIONS(2791),
    [anon_sym_type] = ACTIONS(2791),
    [anon_sym_union] = ACTIONS(2791),
    [anon_sym_unsafe] = ACTIONS(2791),
    [anon_sym_use] = ACTIONS(2791),
    [anon_sym_extern] = ACTIONS(2791),
    [anon_sym_else] = ACTIONS(2791),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2791),
  },
  [1375] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(2041),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [1376] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2042),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(2042),
    [sym_macro_invocation] = STATE(2042),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2042),
    [sym_unary_expression] = STATE(2042),
    [sym_try_expression] = STATE(2042),
    [sym_reference_expression] = STATE(2042),
    [sym_binary_expression] = STATE(2042),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2042),
    [sym_call_expression] = STATE(2042),
    [sym_array_expression] = STATE(2042),
    [sym_parenthesized_expression] = STATE(2042),
    [sym_tuple_expression] = STATE(2042),
    [sym_unit_expression] = STATE(2042),
    [sym_struct_expression] = STATE(2042),
    [sym_if_expression] = STATE(2042),
    [sym_if_let_expression] = STATE(2042),
    [sym_match_expression] = STATE(2042),
    [sym_while_expression] = STATE(2042),
    [sym_while_let_expression] = STATE(2042),
    [sym_loop_expression] = STATE(2042),
    [sym_for_expression] = STATE(2042),
    [sym_closure_expression] = STATE(2042),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2042),
    [sym_continue_expression] = STATE(2042),
    [sym_index_expression] = STATE(2042),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2042),
    [sym_block] = STATE(2042),
    [sym__literal] = STATE(2042),
    [sym_string_literal] = STATE(2042),
    [sym_boolean_literal] = STATE(2042),
    [sym_raw_string_literal] = ACTIONS(4540),
    [sym_float_literal] = ACTIONS(4540),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(4540),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4540),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [1377] = {
    [sym_if_expression] = STATE(2043),
    [sym_if_let_expression] = STATE(2043),
    [sym_block] = STATE(2043),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(4542),
    [sym_line_comment] = ACTIONS(7),
  },
  [1378] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3201),
    [anon_sym_LPAREN] = ACTIONS(3201),
    [anon_sym_RPAREN] = ACTIONS(3201),
    [anon_sym_LBRACE] = ACTIONS(3201),
    [anon_sym_RBRACE] = ACTIONS(3201),
    [anon_sym_LBRACK] = ACTIONS(3201),
    [anon_sym_RBRACK] = ACTIONS(3201),
    [anon_sym_PLUS] = ACTIONS(3203),
    [anon_sym_STAR] = ACTIONS(3203),
    [anon_sym_COMMA] = ACTIONS(3201),
    [anon_sym_AMP] = ACTIONS(3203),
    [anon_sym_DASH] = ACTIONS(3203),
    [anon_sym_DOT] = ACTIONS(3203),
    [anon_sym_DASH_EQ] = ACTIONS(3201),
    [anon_sym_BANG_EQ] = ACTIONS(3201),
    [anon_sym_STAR_EQ] = ACTIONS(3201),
    [anon_sym_SLASH] = ACTIONS(3203),
    [anon_sym_SLASH_EQ] = ACTIONS(3201),
    [anon_sym_AMP_AMP] = ACTIONS(3201),
    [anon_sym_AMP_EQ] = ACTIONS(3201),
    [anon_sym_PERCENT] = ACTIONS(3203),
    [anon_sym_PERCENT_EQ] = ACTIONS(3201),
    [anon_sym_CARET] = ACTIONS(3203),
    [anon_sym_CARET_EQ] = ACTIONS(3201),
    [anon_sym_PLUS_EQ] = ACTIONS(3201),
    [anon_sym_LT] = ACTIONS(3203),
    [anon_sym_LT_LT] = ACTIONS(3203),
    [anon_sym_LT_LT_EQ] = ACTIONS(3201),
    [anon_sym_LT_EQ] = ACTIONS(3201),
    [anon_sym_EQ] = ACTIONS(3203),
    [anon_sym_EQ_EQ] = ACTIONS(3201),
    [anon_sym_GT] = ACTIONS(3203),
    [anon_sym_GT_EQ] = ACTIONS(3201),
    [anon_sym_GT_GT] = ACTIONS(3203),
    [anon_sym_GT_GT_EQ] = ACTIONS(3201),
    [anon_sym_PIPE] = ACTIONS(3203),
    [anon_sym_PIPE_EQ] = ACTIONS(3201),
    [anon_sym_PIPE_PIPE] = ACTIONS(3201),
    [anon_sym_QMARK] = ACTIONS(3201),
    [anon_sym_DOT_DOT] = ACTIONS(3203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3201),
    [anon_sym_as] = ACTIONS(3201),
    [sym_line_comment] = ACTIONS(7),
  },
  [1379] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3293),
    [anon_sym_LPAREN] = ACTIONS(3293),
    [anon_sym_RPAREN] = ACTIONS(3293),
    [anon_sym_LBRACE] = ACTIONS(3293),
    [anon_sym_RBRACE] = ACTIONS(3293),
    [anon_sym_LBRACK] = ACTIONS(3293),
    [anon_sym_RBRACK] = ACTIONS(3293),
    [anon_sym_PLUS] = ACTIONS(3295),
    [anon_sym_STAR] = ACTIONS(3295),
    [anon_sym_COMMA] = ACTIONS(3293),
    [anon_sym_AMP] = ACTIONS(3295),
    [anon_sym_DASH] = ACTIONS(3295),
    [anon_sym_DOT] = ACTIONS(3295),
    [anon_sym_DASH_EQ] = ACTIONS(3293),
    [anon_sym_BANG_EQ] = ACTIONS(3293),
    [anon_sym_STAR_EQ] = ACTIONS(3293),
    [anon_sym_SLASH] = ACTIONS(3295),
    [anon_sym_SLASH_EQ] = ACTIONS(3293),
    [anon_sym_AMP_AMP] = ACTIONS(3293),
    [anon_sym_AMP_EQ] = ACTIONS(3293),
    [anon_sym_PERCENT] = ACTIONS(3295),
    [anon_sym_PERCENT_EQ] = ACTIONS(3293),
    [anon_sym_CARET] = ACTIONS(3295),
    [anon_sym_CARET_EQ] = ACTIONS(3293),
    [anon_sym_PLUS_EQ] = ACTIONS(3293),
    [anon_sym_LT] = ACTIONS(3295),
    [anon_sym_LT_LT] = ACTIONS(3295),
    [anon_sym_LT_LT_EQ] = ACTIONS(3293),
    [anon_sym_LT_EQ] = ACTIONS(3293),
    [anon_sym_EQ] = ACTIONS(3295),
    [anon_sym_EQ_EQ] = ACTIONS(3293),
    [anon_sym_GT] = ACTIONS(3295),
    [anon_sym_GT_EQ] = ACTIONS(3293),
    [anon_sym_GT_GT] = ACTIONS(3295),
    [anon_sym_GT_GT_EQ] = ACTIONS(3293),
    [anon_sym_PIPE] = ACTIONS(3295),
    [anon_sym_PIPE_EQ] = ACTIONS(3293),
    [anon_sym_PIPE_PIPE] = ACTIONS(3293),
    [anon_sym_QMARK] = ACTIONS(3293),
    [anon_sym_DOT_DOT] = ACTIONS(3295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3293),
    [anon_sym_as] = ACTIONS(3293),
    [sym_line_comment] = ACTIONS(7),
  },
  [1380] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(4544),
    [sym_line_comment] = ACTIONS(7),
  },
  [1381] = {
    [sym_attribute_item] = STATE(1049),
    [sym_bracketed_type] = STATE(1041),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(1042),
    [sym_scoped_identifier] = STATE(1043),
    [sym_scoped_type_identifier] = STATE(1044),
    [sym_match_arm] = STATE(1728),
    [sym_last_match_arm] = STATE(2045),
    [sym_match_pattern] = STATE(1046),
    [sym__pattern] = STATE(1047),
    [sym_tuple_pattern] = STATE(1047),
    [sym_tuple_struct_pattern] = STATE(1047),
    [sym_struct_pattern] = STATE(1047),
    [sym_remaining_field_pattern] = STATE(1047),
    [sym_mut_pattern] = STATE(1047),
    [sym_range_pattern] = STATE(1047),
    [sym_ref_pattern] = STATE(1047),
    [sym_captured_pattern] = STATE(1047),
    [sym_reference_pattern] = STATE(1047),
    [sym__literal] = STATE(1048),
    [sym_string_literal] = STATE(1048),
    [sym_boolean_literal] = STATE(1048),
    [aux_sym_enum_variant_list_repeat1] = STATE(1049),
    [aux_sym_match_expression_repeat1] = STATE(1728),
    [sym_raw_string_literal] = ACTIONS(2070),
    [sym_float_literal] = ACTIONS(2070),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2072),
    [anon_sym_u8] = ACTIONS(2076),
    [anon_sym_i8] = ACTIONS(2076),
    [anon_sym_u16] = ACTIONS(2076),
    [anon_sym_i16] = ACTIONS(2076),
    [anon_sym_u32] = ACTIONS(2076),
    [anon_sym_i32] = ACTIONS(2076),
    [anon_sym_u64] = ACTIONS(2076),
    [anon_sym_i64] = ACTIONS(2076),
    [anon_sym_u128] = ACTIONS(2076),
    [anon_sym_i128] = ACTIONS(2076),
    [anon_sym_isize] = ACTIONS(2076),
    [anon_sym_usize] = ACTIONS(2076),
    [anon_sym_f32] = ACTIONS(2076),
    [anon_sym_f64] = ACTIONS(2076),
    [anon_sym_bool] = ACTIONS(2076),
    [anon_sym_str] = ACTIONS(2076),
    [anon_sym_char] = ACTIONS(2076),
    [anon_sym__] = ACTIONS(2078),
    [anon_sym_AMP] = ACTIONS(2080),
    [anon_sym_COLON_COLON] = ACTIONS(2082),
    [anon_sym_POUND] = ACTIONS(2084),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(2086),
    [sym_mutable_specifier] = ACTIONS(2088),
    [anon_sym_ref] = ACTIONS(2090),
    [sym_integer_literal] = ACTIONS(2070),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(769),
    [sym_char_literal] = ACTIONS(2070),
    [anon_sym_true] = ACTIONS(2092),
    [anon_sym_false] = ACTIONS(2092),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2094),
    [sym_self] = ACTIONS(2096),
    [sym_super] = ACTIONS(2096),
    [sym_crate] = ACTIONS(2096),
    [sym_metavariable] = ACTIONS(2098),
  },
  [1382] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2046),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(2046),
    [sym_macro_invocation] = STATE(2046),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2046),
    [sym_unary_expression] = STATE(2046),
    [sym_try_expression] = STATE(2046),
    [sym_reference_expression] = STATE(2046),
    [sym_binary_expression] = STATE(2046),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2046),
    [sym_call_expression] = STATE(2046),
    [sym_array_expression] = STATE(2046),
    [sym_parenthesized_expression] = STATE(2046),
    [sym_tuple_expression] = STATE(2046),
    [sym_unit_expression] = STATE(2046),
    [sym_struct_expression] = STATE(2046),
    [sym_if_expression] = STATE(2046),
    [sym_if_let_expression] = STATE(2046),
    [sym_match_expression] = STATE(2046),
    [sym_while_expression] = STATE(2046),
    [sym_while_let_expression] = STATE(2046),
    [sym_loop_expression] = STATE(2046),
    [sym_for_expression] = STATE(2046),
    [sym_closure_expression] = STATE(2046),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2046),
    [sym_continue_expression] = STATE(2046),
    [sym_index_expression] = STATE(2046),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2046),
    [sym_block] = STATE(2046),
    [sym__literal] = STATE(2046),
    [sym_string_literal] = STATE(2046),
    [sym_boolean_literal] = STATE(2046),
    [sym_raw_string_literal] = ACTIONS(4546),
    [sym_float_literal] = ACTIONS(4546),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(4546),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4546),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [1383] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym_macro_rules_BANG] = ACTIONS(3560),
    [anon_sym_LPAREN] = ACTIONS(3560),
    [anon_sym_RPAREN] = ACTIONS(3560),
    [anon_sym_LBRACE] = ACTIONS(3560),
    [anon_sym_RBRACE] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(3560),
    [anon_sym_RBRACK] = ACTIONS(3560),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3562),
    [anon_sym_COMMA] = ACTIONS(3560),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_DOT] = ACTIONS(3562),
    [anon_sym_DASH_EQ] = ACTIONS(3560),
    [anon_sym_BANG_EQ] = ACTIONS(3560),
    [anon_sym_STAR_EQ] = ACTIONS(3560),
    [anon_sym_SLASH] = ACTIONS(3562),
    [anon_sym_SLASH_EQ] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_AMP_EQ] = ACTIONS(3560),
    [anon_sym_POUND] = ACTIONS(3560),
    [anon_sym_PERCENT] = ACTIONS(3562),
    [anon_sym_PERCENT_EQ] = ACTIONS(3560),
    [anon_sym_CARET] = ACTIONS(3562),
    [anon_sym_CARET_EQ] = ACTIONS(3560),
    [anon_sym_PLUS_EQ] = ACTIONS(3560),
    [anon_sym_LT] = ACTIONS(3562),
    [anon_sym_LT_LT] = ACTIONS(3562),
    [anon_sym_LT_LT_EQ] = ACTIONS(3560),
    [anon_sym_LT_EQ] = ACTIONS(3560),
    [anon_sym_EQ] = ACTIONS(3562),
    [anon_sym_EQ_EQ] = ACTIONS(3560),
    [anon_sym_GT] = ACTIONS(3562),
    [anon_sym_GT_EQ] = ACTIONS(3560),
    [anon_sym_GT_GT] = ACTIONS(3562),
    [anon_sym_GT_GT_EQ] = ACTIONS(3560),
    [anon_sym_PIPE] = ACTIONS(3562),
    [anon_sym_PIPE_EQ] = ACTIONS(3560),
    [anon_sym_PIPE_PIPE] = ACTIONS(3560),
    [anon_sym_QMARK] = ACTIONS(3560),
    [anon_sym_DOT_DOT] = ACTIONS(3562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3560),
    [anon_sym_as] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_fn] = ACTIONS(3562),
    [anon_sym_impl] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_mod] = ACTIONS(3562),
    [anon_sym_pub] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_trait] = ACTIONS(3562),
    [anon_sym_type] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [anon_sym_unsafe] = ACTIONS(3562),
    [anon_sym_use] = ACTIONS(3562),
    [anon_sym_extern] = ACTIONS(3562),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3562),
  },
  [1384] = {
    [sym_arguments] = STATE(263),
    [aux_sym_token_tree_repeat2] = STATE(2049),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(4548),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(4550),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_BANG_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH] = ACTIONS(563),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(563),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_LT] = ACTIONS(577),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(581),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(577),
    [anon_sym_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(589),
    [anon_sym_as] = ACTIONS(591),
    [sym_line_comment] = ACTIONS(7),
  },
  [1385] = {
    [sym_token_tree] = STATE(1878),
    [sym_token_repetition] = STATE(1878),
    [sym__literal] = STATE(1878),
    [sym_string_literal] = STATE(1878),
    [sym_boolean_literal] = STATE(1878),
    [aux_sym_token_tree_repeat1] = STATE(1878),
    [sym_raw_string_literal] = ACTIONS(3960),
    [sym_float_literal] = ACTIONS(3960),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_RPAREN] = ACTIONS(4552),
    [anon_sym_LBRACE] = ACTIONS(3966),
    [anon_sym_EQ_GT] = ACTIONS(3960),
    [anon_sym_LBRACK] = ACTIONS(3968),
    [anon_sym_COLON] = ACTIONS(3970),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(3970),
    [anon_sym_STAR] = ACTIONS(3970),
    [anon_sym_COMMA] = ACTIONS(3960),
    [anon_sym_u8] = ACTIONS(3972),
    [anon_sym_i8] = ACTIONS(3972),
    [anon_sym_u16] = ACTIONS(3972),
    [anon_sym_i16] = ACTIONS(3972),
    [anon_sym_u32] = ACTIONS(3972),
    [anon_sym_i32] = ACTIONS(3972),
    [anon_sym_u64] = ACTIONS(3972),
    [anon_sym_i64] = ACTIONS(3972),
    [anon_sym_u128] = ACTIONS(3972),
    [anon_sym_i128] = ACTIONS(3972),
    [anon_sym_isize] = ACTIONS(3972),
    [anon_sym_usize] = ACTIONS(3972),
    [anon_sym_f32] = ACTIONS(3972),
    [anon_sym_f64] = ACTIONS(3972),
    [anon_sym_bool] = ACTIONS(3972),
    [anon_sym_str] = ACTIONS(3972),
    [anon_sym_char] = ACTIONS(3972),
    [anon_sym__] = ACTIONS(3970),
    [anon_sym_AMP] = ACTIONS(3970),
    [anon_sym_DASH] = ACTIONS(3970),
    [anon_sym_DOT] = ACTIONS(3970),
    [anon_sym_DASH_EQ] = ACTIONS(3960),
    [anon_sym_DASH_GT] = ACTIONS(3960),
    [anon_sym_COLON_COLON] = ACTIONS(3960),
    [anon_sym_BANG] = ACTIONS(3970),
    [anon_sym_BANG_EQ] = ACTIONS(3960),
    [anon_sym_AT] = ACTIONS(3960),
    [anon_sym_STAR_EQ] = ACTIONS(3960),
    [anon_sym_SLASH] = ACTIONS(3970),
    [anon_sym_SLASH_EQ] = ACTIONS(3960),
    [anon_sym_AMP_AMP] = ACTIONS(3960),
    [anon_sym_AMP_EQ] = ACTIONS(3960),
    [anon_sym_POUND] = ACTIONS(3960),
    [anon_sym_PERCENT] = ACTIONS(3970),
    [anon_sym_PERCENT_EQ] = ACTIONS(3960),
    [anon_sym_CARET] = ACTIONS(3970),
    [anon_sym_CARET_EQ] = ACTIONS(3960),
    [anon_sym_PLUS_EQ] = ACTIONS(3960),
    [anon_sym_LT] = ACTIONS(3970),
    [anon_sym_LT_LT] = ACTIONS(3970),
    [anon_sym_LT_LT_EQ] = ACTIONS(3960),
    [anon_sym_LT_EQ] = ACTIONS(3960),
    [anon_sym_EQ] = ACTIONS(3970),
    [anon_sym_EQ_EQ] = ACTIONS(3960),
    [anon_sym_GT] = ACTIONS(3970),
    [anon_sym_GT_EQ] = ACTIONS(3960),
    [anon_sym_GT_GT] = ACTIONS(3970),
    [anon_sym_GT_GT_EQ] = ACTIONS(3960),
    [anon_sym_PIPE] = ACTIONS(3970),
    [anon_sym_PIPE_EQ] = ACTIONS(3960),
    [anon_sym_PIPE_PIPE] = ACTIONS(3960),
    [anon_sym_TILDE] = ACTIONS(3960),
    [anon_sym_QMARK] = ACTIONS(3960),
    [anon_sym_SQUOTE] = ACTIONS(3970),
    [anon_sym_DOT_DOT] = ACTIONS(3970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3960),
    [anon_sym_as] = ACTIONS(3970),
    [anon_sym_break] = ACTIONS(3970),
    [anon_sym_const] = ACTIONS(3970),
    [anon_sym_continue] = ACTIONS(3970),
    [anon_sym_default] = ACTIONS(3970),
    [anon_sym_enum] = ACTIONS(3970),
    [anon_sym_fn] = ACTIONS(3970),
    [anon_sym_for] = ACTIONS(3970),
    [anon_sym_if] = ACTIONS(3970),
    [anon_sym_impl] = ACTIONS(3970),
    [anon_sym_let] = ACTIONS(3970),
    [anon_sym_loop] = ACTIONS(3970),
    [anon_sym_match] = ACTIONS(3970),
    [anon_sym_mod] = ACTIONS(3970),
    [anon_sym_pub] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3970),
    [anon_sym_static] = ACTIONS(3970),
    [anon_sym_struct] = ACTIONS(3970),
    [anon_sym_trait] = ACTIONS(3970),
    [anon_sym_type] = ACTIONS(3970),
    [anon_sym_union] = ACTIONS(3970),
    [anon_sym_unsafe] = ACTIONS(3970),
    [anon_sym_use] = ACTIONS(3970),
    [anon_sym_where] = ACTIONS(3970),
    [anon_sym_while] = ACTIONS(3970),
    [sym_mutable_specifier] = ACTIONS(3970),
    [sym_integer_literal] = ACTIONS(3960),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(3960),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3970),
    [sym_self] = ACTIONS(3970),
    [sym_super] = ACTIONS(3970),
    [sym_crate] = ACTIONS(3970),
    [sym_metavariable] = ACTIONS(3960),
  },
  [1386] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(4548),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(623),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(623),
    [anon_sym_PLUS_EQ] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(623),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(643),
    [anon_sym_as] = ACTIONS(645),
    [sym_line_comment] = ACTIONS(7),
  },
  [1387] = {
    [sym__statement] = STATE(332),
    [sym_empty_statement] = STATE(332),
    [sym__expression_statement] = STATE(332),
    [sym_macro_definition] = STATE(332),
    [sym_attribute_item] = STATE(332),
    [sym_inner_attribute_item] = STATE(332),
    [sym_mod_item] = STATE(332),
    [sym_foreign_mod_item] = STATE(332),
    [sym_struct_item] = STATE(332),
    [sym_union_item] = STATE(332),
    [sym_enum_item] = STATE(332),
    [sym_extern_crate_declaration] = STATE(332),
    [sym_const_item] = STATE(332),
    [sym_static_item] = STATE(332),
    [sym_type_item] = STATE(332),
    [sym_function_item] = STATE(332),
    [sym_function_signature_item] = STATE(332),
    [sym_function_modifiers] = STATE(47),
    [sym_impl_item] = STATE(332),
    [sym_trait_item] = STATE(332),
    [sym_associated_type] = STATE(332),
    [sym_let_declaration] = STATE(332),
    [sym_use_declaration] = STATE(332),
    [sym_extern_modifier] = STATE(48),
    [sym_visibility_modifier] = STATE(49),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2051),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2051),
    [sym_macro_invocation] = STATE(53),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2051),
    [sym_unary_expression] = STATE(2051),
    [sym_try_expression] = STATE(2051),
    [sym_reference_expression] = STATE(2051),
    [sym_binary_expression] = STATE(2051),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2051),
    [sym_call_expression] = STATE(2051),
    [sym_array_expression] = STATE(2051),
    [sym_parenthesized_expression] = STATE(2051),
    [sym_tuple_expression] = STATE(2051),
    [sym_unit_expression] = STATE(2051),
    [sym_struct_expression] = STATE(2051),
    [sym_if_expression] = STATE(57),
    [sym_if_let_expression] = STATE(57),
    [sym_match_expression] = STATE(57),
    [sym_while_expression] = STATE(57),
    [sym_while_let_expression] = STATE(57),
    [sym_loop_expression] = STATE(57),
    [sym_for_expression] = STATE(57),
    [sym_closure_expression] = STATE(2051),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(59),
    [sym_break_expression] = STATE(2051),
    [sym_continue_expression] = STATE(2051),
    [sym_index_expression] = STATE(2051),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(57),
    [sym_block] = STATE(57),
    [sym__literal] = STATE(2051),
    [sym_string_literal] = STATE(2051),
    [sym_boolean_literal] = STATE(2051),
    [aux_sym_source_file_repeat1] = STATE(332),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_raw_string_literal] = ACTIONS(4554),
    [sym_float_literal] = ACTIONS(4554),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(4548),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_POUND] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(4554),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4554),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(93),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1388] = {
    [sym_token_tree] = STATE(1887),
    [sym_token_repetition] = STATE(1887),
    [sym__literal] = STATE(1887),
    [sym_string_literal] = STATE(1887),
    [sym_boolean_literal] = STATE(1887),
    [aux_sym_token_tree_repeat1] = STATE(1887),
    [sym_raw_string_literal] = ACTIONS(4148),
    [sym_float_literal] = ACTIONS(4148),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4148),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_LBRACE] = ACTIONS(3966),
    [anon_sym_RBRACE] = ACTIONS(4552),
    [anon_sym_EQ_GT] = ACTIONS(4148),
    [anon_sym_LBRACK] = ACTIONS(3968),
    [anon_sym_COLON] = ACTIONS(4150),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(4150),
    [anon_sym_STAR] = ACTIONS(4150),
    [anon_sym_COMMA] = ACTIONS(4148),
    [anon_sym_u8] = ACTIONS(3972),
    [anon_sym_i8] = ACTIONS(3972),
    [anon_sym_u16] = ACTIONS(3972),
    [anon_sym_i16] = ACTIONS(3972),
    [anon_sym_u32] = ACTIONS(3972),
    [anon_sym_i32] = ACTIONS(3972),
    [anon_sym_u64] = ACTIONS(3972),
    [anon_sym_i64] = ACTIONS(3972),
    [anon_sym_u128] = ACTIONS(3972),
    [anon_sym_i128] = ACTIONS(3972),
    [anon_sym_isize] = ACTIONS(3972),
    [anon_sym_usize] = ACTIONS(3972),
    [anon_sym_f32] = ACTIONS(3972),
    [anon_sym_f64] = ACTIONS(3972),
    [anon_sym_bool] = ACTIONS(3972),
    [anon_sym_str] = ACTIONS(3972),
    [anon_sym_char] = ACTIONS(3972),
    [anon_sym__] = ACTIONS(4150),
    [anon_sym_AMP] = ACTIONS(4150),
    [anon_sym_DASH] = ACTIONS(4150),
    [anon_sym_DOT] = ACTIONS(4150),
    [anon_sym_DASH_EQ] = ACTIONS(4148),
    [anon_sym_DASH_GT] = ACTIONS(4148),
    [anon_sym_COLON_COLON] = ACTIONS(4148),
    [anon_sym_BANG] = ACTIONS(4150),
    [anon_sym_BANG_EQ] = ACTIONS(4148),
    [anon_sym_AT] = ACTIONS(4148),
    [anon_sym_STAR_EQ] = ACTIONS(4148),
    [anon_sym_SLASH] = ACTIONS(4150),
    [anon_sym_SLASH_EQ] = ACTIONS(4148),
    [anon_sym_AMP_AMP] = ACTIONS(4148),
    [anon_sym_AMP_EQ] = ACTIONS(4148),
    [anon_sym_POUND] = ACTIONS(4148),
    [anon_sym_PERCENT] = ACTIONS(4150),
    [anon_sym_PERCENT_EQ] = ACTIONS(4148),
    [anon_sym_CARET] = ACTIONS(4150),
    [anon_sym_CARET_EQ] = ACTIONS(4148),
    [anon_sym_PLUS_EQ] = ACTIONS(4148),
    [anon_sym_LT] = ACTIONS(4150),
    [anon_sym_LT_LT] = ACTIONS(4150),
    [anon_sym_LT_LT_EQ] = ACTIONS(4148),
    [anon_sym_LT_EQ] = ACTIONS(4148),
    [anon_sym_EQ] = ACTIONS(4150),
    [anon_sym_EQ_EQ] = ACTIONS(4148),
    [anon_sym_GT] = ACTIONS(4150),
    [anon_sym_GT_EQ] = ACTIONS(4148),
    [anon_sym_GT_GT] = ACTIONS(4150),
    [anon_sym_GT_GT_EQ] = ACTIONS(4148),
    [anon_sym_PIPE] = ACTIONS(4150),
    [anon_sym_PIPE_EQ] = ACTIONS(4148),
    [anon_sym_PIPE_PIPE] = ACTIONS(4148),
    [anon_sym_TILDE] = ACTIONS(4148),
    [anon_sym_QMARK] = ACTIONS(4148),
    [anon_sym_SQUOTE] = ACTIONS(4150),
    [anon_sym_DOT_DOT] = ACTIONS(4150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4148),
    [anon_sym_as] = ACTIONS(4150),
    [anon_sym_break] = ACTIONS(4150),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_continue] = ACTIONS(4150),
    [anon_sym_default] = ACTIONS(4150),
    [anon_sym_enum] = ACTIONS(4150),
    [anon_sym_fn] = ACTIONS(4150),
    [anon_sym_for] = ACTIONS(4150),
    [anon_sym_if] = ACTIONS(4150),
    [anon_sym_impl] = ACTIONS(4150),
    [anon_sym_let] = ACTIONS(4150),
    [anon_sym_loop] = ACTIONS(4150),
    [anon_sym_match] = ACTIONS(4150),
    [anon_sym_mod] = ACTIONS(4150),
    [anon_sym_pub] = ACTIONS(4150),
    [anon_sym_return] = ACTIONS(4150),
    [anon_sym_static] = ACTIONS(4150),
    [anon_sym_struct] = ACTIONS(4150),
    [anon_sym_trait] = ACTIONS(4150),
    [anon_sym_type] = ACTIONS(4150),
    [anon_sym_union] = ACTIONS(4150),
    [anon_sym_unsafe] = ACTIONS(4150),
    [anon_sym_use] = ACTIONS(4150),
    [anon_sym_where] = ACTIONS(4150),
    [anon_sym_while] = ACTIONS(4150),
    [sym_mutable_specifier] = ACTIONS(4150),
    [sym_integer_literal] = ACTIONS(4148),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(4148),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4150),
    [sym_self] = ACTIONS(4150),
    [sym_super] = ACTIONS(4150),
    [sym_crate] = ACTIONS(4150),
    [sym_metavariable] = ACTIONS(4148),
  },
  [1389] = {
    [sym_arguments] = STATE(263),
    [aux_sym_token_tree_repeat2] = STATE(2053),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(4548),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_STAR] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(4556),
    [anon_sym_AMP] = ACTIONS(2821),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2823),
    [anon_sym_BANG_EQ] = ACTIONS(2825),
    [anon_sym_STAR_EQ] = ACTIONS(2823),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_SLASH_EQ] = ACTIONS(2823),
    [anon_sym_AMP_AMP] = ACTIONS(2827),
    [anon_sym_AMP_EQ] = ACTIONS(2823),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_PERCENT_EQ] = ACTIONS(2823),
    [anon_sym_CARET] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2823),
    [anon_sym_PLUS_EQ] = ACTIONS(2823),
    [anon_sym_LT] = ACTIONS(2831),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_LT_LT_EQ] = ACTIONS(2823),
    [anon_sym_LT_EQ] = ACTIONS(2825),
    [anon_sym_EQ] = ACTIONS(2835),
    [anon_sym_EQ_EQ] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2831),
    [anon_sym_GT_EQ] = ACTIONS(2825),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_GT_GT_EQ] = ACTIONS(2823),
    [anon_sym_PIPE] = ACTIONS(2837),
    [anon_sym_PIPE_EQ] = ACTIONS(2823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2839),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(2841),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2843),
    [anon_sym_as] = ACTIONS(2845),
    [sym_line_comment] = ACTIONS(7),
  },
  [1390] = {
    [sym_token_tree] = STATE(1890),
    [sym_token_repetition] = STATE(1890),
    [sym__literal] = STATE(1890),
    [sym_string_literal] = STATE(1890),
    [sym_boolean_literal] = STATE(1890),
    [aux_sym_token_tree_repeat1] = STATE(1890),
    [sym_raw_string_literal] = ACTIONS(4197),
    [sym_float_literal] = ACTIONS(4197),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4197),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_LBRACE] = ACTIONS(3966),
    [anon_sym_EQ_GT] = ACTIONS(4197),
    [anon_sym_LBRACK] = ACTIONS(3968),
    [anon_sym_RBRACK] = ACTIONS(4552),
    [anon_sym_COLON] = ACTIONS(4199),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(4199),
    [anon_sym_STAR] = ACTIONS(4199),
    [anon_sym_COMMA] = ACTIONS(4197),
    [anon_sym_u8] = ACTIONS(3972),
    [anon_sym_i8] = ACTIONS(3972),
    [anon_sym_u16] = ACTIONS(3972),
    [anon_sym_i16] = ACTIONS(3972),
    [anon_sym_u32] = ACTIONS(3972),
    [anon_sym_i32] = ACTIONS(3972),
    [anon_sym_u64] = ACTIONS(3972),
    [anon_sym_i64] = ACTIONS(3972),
    [anon_sym_u128] = ACTIONS(3972),
    [anon_sym_i128] = ACTIONS(3972),
    [anon_sym_isize] = ACTIONS(3972),
    [anon_sym_usize] = ACTIONS(3972),
    [anon_sym_f32] = ACTIONS(3972),
    [anon_sym_f64] = ACTIONS(3972),
    [anon_sym_bool] = ACTIONS(3972),
    [anon_sym_str] = ACTIONS(3972),
    [anon_sym_char] = ACTIONS(3972),
    [anon_sym__] = ACTIONS(4199),
    [anon_sym_AMP] = ACTIONS(4199),
    [anon_sym_DASH] = ACTIONS(4199),
    [anon_sym_DOT] = ACTIONS(4199),
    [anon_sym_DASH_EQ] = ACTIONS(4197),
    [anon_sym_DASH_GT] = ACTIONS(4197),
    [anon_sym_COLON_COLON] = ACTIONS(4197),
    [anon_sym_BANG] = ACTIONS(4199),
    [anon_sym_BANG_EQ] = ACTIONS(4197),
    [anon_sym_AT] = ACTIONS(4197),
    [anon_sym_STAR_EQ] = ACTIONS(4197),
    [anon_sym_SLASH] = ACTIONS(4199),
    [anon_sym_SLASH_EQ] = ACTIONS(4197),
    [anon_sym_AMP_AMP] = ACTIONS(4197),
    [anon_sym_AMP_EQ] = ACTIONS(4197),
    [anon_sym_POUND] = ACTIONS(4197),
    [anon_sym_PERCENT] = ACTIONS(4199),
    [anon_sym_PERCENT_EQ] = ACTIONS(4197),
    [anon_sym_CARET] = ACTIONS(4199),
    [anon_sym_CARET_EQ] = ACTIONS(4197),
    [anon_sym_PLUS_EQ] = ACTIONS(4197),
    [anon_sym_LT] = ACTIONS(4199),
    [anon_sym_LT_LT] = ACTIONS(4199),
    [anon_sym_LT_LT_EQ] = ACTIONS(4197),
    [anon_sym_LT_EQ] = ACTIONS(4197),
    [anon_sym_EQ] = ACTIONS(4199),
    [anon_sym_EQ_EQ] = ACTIONS(4197),
    [anon_sym_GT] = ACTIONS(4199),
    [anon_sym_GT_EQ] = ACTIONS(4197),
    [anon_sym_GT_GT] = ACTIONS(4199),
    [anon_sym_GT_GT_EQ] = ACTIONS(4197),
    [anon_sym_PIPE] = ACTIONS(4199),
    [anon_sym_PIPE_EQ] = ACTIONS(4197),
    [anon_sym_PIPE_PIPE] = ACTIONS(4197),
    [anon_sym_TILDE] = ACTIONS(4197),
    [anon_sym_QMARK] = ACTIONS(4197),
    [anon_sym_SQUOTE] = ACTIONS(4199),
    [anon_sym_DOT_DOT] = ACTIONS(4199),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4197),
    [anon_sym_as] = ACTIONS(4199),
    [anon_sym_break] = ACTIONS(4199),
    [anon_sym_const] = ACTIONS(4199),
    [anon_sym_continue] = ACTIONS(4199),
    [anon_sym_default] = ACTIONS(4199),
    [anon_sym_enum] = ACTIONS(4199),
    [anon_sym_fn] = ACTIONS(4199),
    [anon_sym_for] = ACTIONS(4199),
    [anon_sym_if] = ACTIONS(4199),
    [anon_sym_impl] = ACTIONS(4199),
    [anon_sym_let] = ACTIONS(4199),
    [anon_sym_loop] = ACTIONS(4199),
    [anon_sym_match] = ACTIONS(4199),
    [anon_sym_mod] = ACTIONS(4199),
    [anon_sym_pub] = ACTIONS(4199),
    [anon_sym_return] = ACTIONS(4199),
    [anon_sym_static] = ACTIONS(4199),
    [anon_sym_struct] = ACTIONS(4199),
    [anon_sym_trait] = ACTIONS(4199),
    [anon_sym_type] = ACTIONS(4199),
    [anon_sym_union] = ACTIONS(4199),
    [anon_sym_unsafe] = ACTIONS(4199),
    [anon_sym_use] = ACTIONS(4199),
    [anon_sym_where] = ACTIONS(4199),
    [anon_sym_while] = ACTIONS(4199),
    [sym_mutable_specifier] = ACTIONS(4199),
    [sym_integer_literal] = ACTIONS(4197),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(4197),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4199),
    [sym_self] = ACTIONS(4199),
    [sym_super] = ACTIONS(4199),
    [sym_crate] = ACTIONS(4199),
    [sym_metavariable] = ACTIONS(4197),
  },
  [1391] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4558),
    [anon_sym_LPAREN] = ACTIONS(4558),
    [anon_sym_RPAREN] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(4558),
    [anon_sym_RBRACE] = ACTIONS(4558),
    [anon_sym_LBRACK] = ACTIONS(4558),
    [anon_sym_RBRACK] = ACTIONS(4558),
    [anon_sym_PLUS] = ACTIONS(4560),
    [anon_sym_STAR] = ACTIONS(4560),
    [anon_sym_COMMA] = ACTIONS(4558),
    [anon_sym_AMP] = ACTIONS(4560),
    [anon_sym_DASH] = ACTIONS(4560),
    [anon_sym_DOT] = ACTIONS(4560),
    [anon_sym_DASH_EQ] = ACTIONS(4558),
    [anon_sym_BANG_EQ] = ACTIONS(4558),
    [anon_sym_STAR_EQ] = ACTIONS(4558),
    [anon_sym_SLASH] = ACTIONS(4560),
    [anon_sym_SLASH_EQ] = ACTIONS(4558),
    [anon_sym_AMP_AMP] = ACTIONS(4558),
    [anon_sym_AMP_EQ] = ACTIONS(4558),
    [anon_sym_PERCENT] = ACTIONS(4560),
    [anon_sym_PERCENT_EQ] = ACTIONS(4558),
    [anon_sym_CARET] = ACTIONS(4560),
    [anon_sym_CARET_EQ] = ACTIONS(4558),
    [anon_sym_PLUS_EQ] = ACTIONS(4558),
    [anon_sym_LT] = ACTIONS(4560),
    [anon_sym_LT_LT] = ACTIONS(4560),
    [anon_sym_LT_LT_EQ] = ACTIONS(4558),
    [anon_sym_LT_EQ] = ACTIONS(4558),
    [anon_sym_EQ] = ACTIONS(4560),
    [anon_sym_EQ_EQ] = ACTIONS(4558),
    [anon_sym_GT] = ACTIONS(4560),
    [anon_sym_GT_EQ] = ACTIONS(4558),
    [anon_sym_GT_GT] = ACTIONS(4560),
    [anon_sym_GT_GT_EQ] = ACTIONS(4558),
    [anon_sym_PIPE] = ACTIONS(4560),
    [anon_sym_PIPE_EQ] = ACTIONS(4558),
    [anon_sym_PIPE_PIPE] = ACTIONS(4558),
    [anon_sym_QMARK] = ACTIONS(4558),
    [anon_sym_DOT_DOT] = ACTIONS(4560),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4558),
    [anon_sym_as] = ACTIONS(4558),
    [sym_line_comment] = ACTIONS(7),
  },
  [1392] = {
    [sym_raw_string_literal] = ACTIONS(4562),
    [sym_float_literal] = ACTIONS(4562),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(4562),
    [anon_sym_RPAREN] = ACTIONS(4562),
    [anon_sym_LBRACE] = ACTIONS(4562),
    [anon_sym_LBRACK] = ACTIONS(4562),
    [anon_sym_STAR] = ACTIONS(4562),
    [anon_sym_u8] = ACTIONS(4564),
    [anon_sym_i8] = ACTIONS(4564),
    [anon_sym_u16] = ACTIONS(4564),
    [anon_sym_i16] = ACTIONS(4564),
    [anon_sym_u32] = ACTIONS(4564),
    [anon_sym_i32] = ACTIONS(4564),
    [anon_sym_u64] = ACTIONS(4564),
    [anon_sym_i64] = ACTIONS(4564),
    [anon_sym_u128] = ACTIONS(4564),
    [anon_sym_i128] = ACTIONS(4564),
    [anon_sym_isize] = ACTIONS(4564),
    [anon_sym_usize] = ACTIONS(4564),
    [anon_sym_f32] = ACTIONS(4564),
    [anon_sym_f64] = ACTIONS(4564),
    [anon_sym_bool] = ACTIONS(4564),
    [anon_sym_str] = ACTIONS(4564),
    [anon_sym_char] = ACTIONS(4564),
    [anon_sym_AMP] = ACTIONS(4562),
    [anon_sym_DASH] = ACTIONS(4562),
    [anon_sym_COLON_COLON] = ACTIONS(4562),
    [anon_sym_BANG] = ACTIONS(4562),
    [anon_sym_LT] = ACTIONS(4562),
    [anon_sym_PIPE] = ACTIONS(4562),
    [anon_sym_SQUOTE] = ACTIONS(4564),
    [anon_sym_DOT_DOT] = ACTIONS(4562),
    [anon_sym_break] = ACTIONS(4564),
    [anon_sym_continue] = ACTIONS(4564),
    [anon_sym_default] = ACTIONS(4564),
    [anon_sym_for] = ACTIONS(4564),
    [anon_sym_if] = ACTIONS(4564),
    [anon_sym_loop] = ACTIONS(4564),
    [anon_sym_match] = ACTIONS(4564),
    [anon_sym_return] = ACTIONS(4564),
    [anon_sym_union] = ACTIONS(4564),
    [anon_sym_unsafe] = ACTIONS(4564),
    [anon_sym_while] = ACTIONS(4564),
    [anon_sym_move] = ACTIONS(4564),
    [sym_integer_literal] = ACTIONS(4562),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(4562),
    [sym_char_literal] = ACTIONS(4562),
    [anon_sym_true] = ACTIONS(4564),
    [anon_sym_false] = ACTIONS(4564),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4564),
    [sym_self] = ACTIONS(4564),
    [sym_super] = ACTIONS(4564),
    [sym_crate] = ACTIONS(4564),
    [sym_metavariable] = ACTIONS(4562),
  },
  [1393] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(4566),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(2749),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_BANG_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH] = ACTIONS(563),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(563),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_LT] = ACTIONS(577),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(581),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(577),
    [anon_sym_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(589),
    [anon_sym_as] = ACTIONS(591),
    [sym_line_comment] = ACTIONS(7),
  },
  [1394] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2061),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2061),
    [sym_macro_invocation] = STATE(2061),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2061),
    [sym_unary_expression] = STATE(2061),
    [sym_try_expression] = STATE(2061),
    [sym_reference_expression] = STATE(2061),
    [sym_binary_expression] = STATE(2061),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2061),
    [sym_call_expression] = STATE(2061),
    [sym_array_expression] = STATE(2061),
    [sym_parenthesized_expression] = STATE(2061),
    [sym_tuple_expression] = STATE(2061),
    [sym_unit_expression] = STATE(2061),
    [sym_struct_expression] = STATE(2061),
    [sym_if_expression] = STATE(2061),
    [sym_if_let_expression] = STATE(2061),
    [sym_match_expression] = STATE(2061),
    [sym_while_expression] = STATE(2061),
    [sym_while_let_expression] = STATE(2061),
    [sym_loop_expression] = STATE(2061),
    [sym_for_expression] = STATE(2061),
    [sym_closure_expression] = STATE(2061),
    [sym_closure_parameters] = STATE(2062),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2061),
    [sym_continue_expression] = STATE(2061),
    [sym_index_expression] = STATE(2061),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2061),
    [sym_block] = STATE(2061),
    [sym__literal] = STATE(2061),
    [sym_string_literal] = STATE(2061),
    [sym_boolean_literal] = STATE(2061),
    [aux_sym_tuple_expression_repeat1] = STATE(1394),
    [sym_raw_string_literal] = ACTIONS(4568),
    [sym_float_literal] = ACTIONS(4568),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(4571),
    [anon_sym_RPAREN] = ACTIONS(4562),
    [anon_sym_LBRACE] = ACTIONS(4574),
    [anon_sym_LBRACK] = ACTIONS(4577),
    [anon_sym_STAR] = ACTIONS(4580),
    [anon_sym_u8] = ACTIONS(4583),
    [anon_sym_i8] = ACTIONS(4583),
    [anon_sym_u16] = ACTIONS(4583),
    [anon_sym_i16] = ACTIONS(4583),
    [anon_sym_u32] = ACTIONS(4583),
    [anon_sym_i32] = ACTIONS(4583),
    [anon_sym_u64] = ACTIONS(4583),
    [anon_sym_i64] = ACTIONS(4583),
    [anon_sym_u128] = ACTIONS(4583),
    [anon_sym_i128] = ACTIONS(4583),
    [anon_sym_isize] = ACTIONS(4583),
    [anon_sym_usize] = ACTIONS(4583),
    [anon_sym_f32] = ACTIONS(4583),
    [anon_sym_f64] = ACTIONS(4583),
    [anon_sym_bool] = ACTIONS(4583),
    [anon_sym_str] = ACTIONS(4583),
    [anon_sym_char] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(4586),
    [anon_sym_DASH] = ACTIONS(4580),
    [anon_sym_COLON_COLON] = ACTIONS(4589),
    [anon_sym_BANG] = ACTIONS(4580),
    [anon_sym_LT] = ACTIONS(4592),
    [anon_sym_PIPE] = ACTIONS(4595),
    [anon_sym_SQUOTE] = ACTIONS(4598),
    [anon_sym_DOT_DOT] = ACTIONS(4601),
    [anon_sym_break] = ACTIONS(4604),
    [anon_sym_continue] = ACTIONS(4607),
    [anon_sym_default] = ACTIONS(4610),
    [anon_sym_for] = ACTIONS(4613),
    [anon_sym_if] = ACTIONS(4616),
    [anon_sym_loop] = ACTIONS(4619),
    [anon_sym_match] = ACTIONS(4622),
    [anon_sym_return] = ACTIONS(4625),
    [anon_sym_union] = ACTIONS(4610),
    [anon_sym_unsafe] = ACTIONS(4628),
    [anon_sym_while] = ACTIONS(4631),
    [anon_sym_move] = ACTIONS(4634),
    [sym_integer_literal] = ACTIONS(4568),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(4637),
    [sym_char_literal] = ACTIONS(4568),
    [anon_sym_true] = ACTIONS(4640),
    [anon_sym_false] = ACTIONS(4640),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4643),
    [sym_self] = ACTIONS(4646),
    [sym_super] = ACTIONS(4649),
    [sym_crate] = ACTIONS(4649),
    [sym_metavariable] = ACTIONS(4652),
  },
  [1395] = {
    [sym_function_modifiers] = STATE(726),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2001),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(727),
    [sym_array_type] = STATE(2001),
    [sym_function_type] = STATE(2001),
    [sym_tuple_type] = STATE(2001),
    [sym_unit_type] = STATE(2001),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2001),
    [sym_reference_type] = STATE(2001),
    [sym_pointer_type] = STATE(2001),
    [sym_empty_type] = STATE(2001),
    [sym_dynamic_type] = STATE(2001),
    [sym_macro_invocation] = STATE(2001),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(728),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1543),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1547),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1549),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [1396] = {
    [sym_function_modifiers] = STATE(726),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2003),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(727),
    [sym_array_type] = STATE(2003),
    [sym_function_type] = STATE(2003),
    [sym_tuple_type] = STATE(2003),
    [sym_unit_type] = STATE(2003),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2003),
    [sym_reference_type] = STATE(2003),
    [sym_pointer_type] = STATE(2003),
    [sym_empty_type] = STATE(2003),
    [sym_dynamic_type] = STATE(2003),
    [sym_macro_invocation] = STATE(2003),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(728),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1543),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1547),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1549),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [1397] = {
    [sym_function_modifiers] = STATE(726),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2003),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(727),
    [sym_array_type] = STATE(2003),
    [sym_function_type] = STATE(2003),
    [sym_tuple_type] = STATE(2003),
    [sym_unit_type] = STATE(2003),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2003),
    [sym_reference_type] = STATE(2003),
    [sym_pointer_type] = STATE(2003),
    [sym_empty_type] = STATE(2003),
    [sym_dynamic_type] = STATE(2003),
    [sym_macro_invocation] = STATE(2003),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(728),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_STAR] = ACTIONS(1543),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1547),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_mutable_specifier] = ACTIONS(4655),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1549),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [1398] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1760),
    [anon_sym_RPAREN] = ACTIONS(1760),
    [anon_sym_LBRACK] = ACTIONS(1760),
    [anon_sym_PLUS] = ACTIONS(4443),
    [anon_sym_STAR] = ACTIONS(4443),
    [anon_sym_COMMA] = ACTIONS(1760),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_DASH] = ACTIONS(4443),
    [anon_sym_DOT] = ACTIONS(4443),
    [anon_sym_DASH_EQ] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(4657),
    [anon_sym_BANG_EQ] = ACTIONS(1760),
    [anon_sym_STAR_EQ] = ACTIONS(1760),
    [anon_sym_SLASH] = ACTIONS(4443),
    [anon_sym_SLASH_EQ] = ACTIONS(1760),
    [anon_sym_AMP_AMP] = ACTIONS(1760),
    [anon_sym_AMP_EQ] = ACTIONS(1760),
    [anon_sym_PERCENT] = ACTIONS(4443),
    [anon_sym_PERCENT_EQ] = ACTIONS(1760),
    [anon_sym_CARET] = ACTIONS(4443),
    [anon_sym_CARET_EQ] = ACTIONS(1760),
    [anon_sym_PLUS_EQ] = ACTIONS(1760),
    [anon_sym_LT] = ACTIONS(4443),
    [anon_sym_LT_LT] = ACTIONS(4443),
    [anon_sym_LT_LT_EQ] = ACTIONS(1760),
    [anon_sym_LT_EQ] = ACTIONS(1760),
    [anon_sym_EQ] = ACTIONS(4443),
    [anon_sym_EQ_EQ] = ACTIONS(1760),
    [anon_sym_GT] = ACTIONS(4443),
    [anon_sym_GT_EQ] = ACTIONS(1760),
    [anon_sym_GT_GT] = ACTIONS(4443),
    [anon_sym_GT_GT_EQ] = ACTIONS(1760),
    [anon_sym_PIPE] = ACTIONS(4443),
    [anon_sym_PIPE_EQ] = ACTIONS(1760),
    [anon_sym_PIPE_PIPE] = ACTIONS(1760),
    [anon_sym_QMARK] = ACTIONS(1760),
    [anon_sym_DOT_DOT] = ACTIONS(4443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1760),
    [anon_sym_as] = ACTIONS(1760),
    [sym_line_comment] = ACTIONS(7),
  },
  [1399] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1794),
    [anon_sym_RPAREN] = ACTIONS(1794),
    [anon_sym_LBRACK] = ACTIONS(1794),
    [anon_sym_PLUS] = ACTIONS(4449),
    [anon_sym_STAR] = ACTIONS(4449),
    [anon_sym_COMMA] = ACTIONS(1794),
    [anon_sym_AMP] = ACTIONS(4449),
    [anon_sym_DASH] = ACTIONS(4449),
    [anon_sym_DOT] = ACTIONS(4449),
    [anon_sym_DASH_EQ] = ACTIONS(1794),
    [anon_sym_DASH_GT] = ACTIONS(4659),
    [anon_sym_BANG_EQ] = ACTIONS(1794),
    [anon_sym_STAR_EQ] = ACTIONS(1794),
    [anon_sym_SLASH] = ACTIONS(4449),
    [anon_sym_SLASH_EQ] = ACTIONS(1794),
    [anon_sym_AMP_AMP] = ACTIONS(1794),
    [anon_sym_AMP_EQ] = ACTIONS(1794),
    [anon_sym_PERCENT] = ACTIONS(4449),
    [anon_sym_PERCENT_EQ] = ACTIONS(1794),
    [anon_sym_CARET] = ACTIONS(4449),
    [anon_sym_CARET_EQ] = ACTIONS(1794),
    [anon_sym_PLUS_EQ] = ACTIONS(1794),
    [anon_sym_LT] = ACTIONS(4449),
    [anon_sym_LT_LT] = ACTIONS(4449),
    [anon_sym_LT_LT_EQ] = ACTIONS(1794),
    [anon_sym_LT_EQ] = ACTIONS(1794),
    [anon_sym_EQ] = ACTIONS(4449),
    [anon_sym_EQ_EQ] = ACTIONS(1794),
    [anon_sym_GT] = ACTIONS(4449),
    [anon_sym_GT_EQ] = ACTIONS(1794),
    [anon_sym_GT_GT] = ACTIONS(4449),
    [anon_sym_GT_GT_EQ] = ACTIONS(1794),
    [anon_sym_PIPE] = ACTIONS(4449),
    [anon_sym_PIPE_EQ] = ACTIONS(1794),
    [anon_sym_PIPE_PIPE] = ACTIONS(1794),
    [anon_sym_QMARK] = ACTIONS(1794),
    [anon_sym_DOT_DOT] = ACTIONS(4449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1794),
    [anon_sym_as] = ACTIONS(1794),
    [sym_line_comment] = ACTIONS(7),
  },
  [1400] = {
    [sym_parameters] = STATE(2066),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [sym_line_comment] = ACTIONS(7),
  },
  [1401] = {
    [sym_parameters] = STATE(2067),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1402] = {
    [sym_parameters] = STATE(2066),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1403] = {
    [sym_function_modifiers] = STATE(726),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2016),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(2016),
    [sym_array_type] = STATE(2016),
    [sym_function_type] = STATE(2016),
    [sym_tuple_type] = STATE(2016),
    [sym_unit_type] = STATE(2016),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2016),
    [sym_reference_type] = STATE(2016),
    [sym_pointer_type] = STATE(2016),
    [sym_empty_type] = STATE(2016),
    [sym_dynamic_type] = STATE(2016),
    [sym_macro_invocation] = STATE(2016),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(728),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1543),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(4453),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1547),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1549),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [1404] = {
    [sym_function_modifiers] = STATE(726),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2016),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(727),
    [sym_array_type] = STATE(2016),
    [sym_function_type] = STATE(2016),
    [sym_tuple_type] = STATE(2016),
    [sym_unit_type] = STATE(2016),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2016),
    [sym_reference_type] = STATE(2016),
    [sym_pointer_type] = STATE(2016),
    [sym_empty_type] = STATE(2016),
    [sym_dynamic_type] = STATE(2016),
    [sym_macro_invocation] = STATE(2016),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(728),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1543),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1547),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1549),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [1405] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_in] = ACTIONS(4661),
    [sym_line_comment] = ACTIONS(7),
  },
  [1406] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4471),
    [anon_sym_LPAREN] = ACTIONS(4471),
    [anon_sym_RPAREN] = ACTIONS(4471),
    [anon_sym_LBRACE] = ACTIONS(4471),
    [anon_sym_RBRACE] = ACTIONS(4471),
    [anon_sym_LBRACK] = ACTIONS(4471),
    [anon_sym_RBRACK] = ACTIONS(4471),
    [anon_sym_PLUS] = ACTIONS(4473),
    [anon_sym_STAR] = ACTIONS(4473),
    [anon_sym_COMMA] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4473),
    [anon_sym_DASH] = ACTIONS(4473),
    [anon_sym_DOT] = ACTIONS(4473),
    [anon_sym_DASH_EQ] = ACTIONS(4471),
    [anon_sym_BANG_EQ] = ACTIONS(4471),
    [anon_sym_STAR_EQ] = ACTIONS(4471),
    [anon_sym_SLASH] = ACTIONS(4473),
    [anon_sym_SLASH_EQ] = ACTIONS(4471),
    [anon_sym_AMP_AMP] = ACTIONS(4471),
    [anon_sym_AMP_EQ] = ACTIONS(4471),
    [anon_sym_PERCENT] = ACTIONS(4473),
    [anon_sym_PERCENT_EQ] = ACTIONS(4471),
    [anon_sym_CARET] = ACTIONS(4473),
    [anon_sym_CARET_EQ] = ACTIONS(4471),
    [anon_sym_PLUS_EQ] = ACTIONS(4471),
    [anon_sym_LT] = ACTIONS(4473),
    [anon_sym_LT_LT] = ACTIONS(4473),
    [anon_sym_LT_LT_EQ] = ACTIONS(4471),
    [anon_sym_LT_EQ] = ACTIONS(4471),
    [anon_sym_EQ] = ACTIONS(4473),
    [anon_sym_EQ_EQ] = ACTIONS(4471),
    [anon_sym_GT] = ACTIONS(4473),
    [anon_sym_GT_EQ] = ACTIONS(4471),
    [anon_sym_GT_GT] = ACTIONS(4473),
    [anon_sym_GT_GT_EQ] = ACTIONS(4471),
    [anon_sym_PIPE] = ACTIONS(4473),
    [anon_sym_PIPE_EQ] = ACTIONS(4471),
    [anon_sym_PIPE_PIPE] = ACTIONS(4471),
    [anon_sym_QMARK] = ACTIONS(4471),
    [anon_sym_DOT_DOT] = ACTIONS(4473),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4471),
    [anon_sym_as] = ACTIONS(4471),
    [sym_line_comment] = ACTIONS(7),
  },
  [1407] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(2069),
    [sym_tuple_pattern] = STATE(2069),
    [sym_tuple_struct_pattern] = STATE(2069),
    [sym_struct_pattern] = STATE(2069),
    [sym_remaining_field_pattern] = STATE(2069),
    [sym_mut_pattern] = STATE(2069),
    [sym_ref_pattern] = STATE(2069),
    [sym_captured_pattern] = STATE(2069),
    [sym_reference_pattern] = STATE(2069),
    [sym__literal] = STATE(2069),
    [sym_string_literal] = STATE(2069),
    [sym_boolean_literal] = STATE(2069),
    [sym_raw_string_literal] = ACTIONS(4663),
    [sym_float_literal] = ACTIONS(4663),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(4665),
    [anon_sym_AMP] = ACTIONS(955),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(957),
    [anon_sym_ref] = ACTIONS(959),
    [sym_integer_literal] = ACTIONS(4663),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(4663),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(961),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [1408] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(2070),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [1409] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(4667),
    [sym_line_comment] = ACTIONS(7),
  },
  [1410] = {
    [sym_else_tail] = STATE(1378),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2012),
    [anon_sym_LPAREN] = ACTIONS(2012),
    [anon_sym_RBRACE] = ACTIONS(2012),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_PLUS] = ACTIONS(2014),
    [anon_sym_STAR] = ACTIONS(2014),
    [anon_sym_AMP] = ACTIONS(2014),
    [anon_sym_DASH] = ACTIONS(2014),
    [anon_sym_DOT] = ACTIONS(2014),
    [anon_sym_DASH_EQ] = ACTIONS(2012),
    [anon_sym_BANG_EQ] = ACTIONS(2012),
    [anon_sym_STAR_EQ] = ACTIONS(2012),
    [anon_sym_SLASH] = ACTIONS(2014),
    [anon_sym_SLASH_EQ] = ACTIONS(2012),
    [anon_sym_AMP_AMP] = ACTIONS(2012),
    [anon_sym_AMP_EQ] = ACTIONS(2012),
    [anon_sym_PERCENT] = ACTIONS(2014),
    [anon_sym_PERCENT_EQ] = ACTIONS(2012),
    [anon_sym_CARET] = ACTIONS(2014),
    [anon_sym_CARET_EQ] = ACTIONS(2012),
    [anon_sym_PLUS_EQ] = ACTIONS(2012),
    [anon_sym_LT] = ACTIONS(2014),
    [anon_sym_LT_LT] = ACTIONS(2014),
    [anon_sym_LT_LT_EQ] = ACTIONS(2012),
    [anon_sym_LT_EQ] = ACTIONS(2012),
    [anon_sym_EQ] = ACTIONS(2014),
    [anon_sym_EQ_EQ] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2014),
    [anon_sym_GT_EQ] = ACTIONS(2012),
    [anon_sym_GT_GT] = ACTIONS(2014),
    [anon_sym_GT_GT_EQ] = ACTIONS(2012),
    [anon_sym_PIPE] = ACTIONS(2014),
    [anon_sym_PIPE_EQ] = ACTIONS(2012),
    [anon_sym_PIPE_PIPE] = ACTIONS(2012),
    [anon_sym_QMARK] = ACTIONS(2012),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2012),
    [anon_sym_as] = ACTIONS(2012),
    [anon_sym_else] = ACTIONS(4669),
    [sym_line_comment] = ACTIONS(7),
  },
  [1411] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2073),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(2073),
    [sym_macro_invocation] = STATE(2073),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2073),
    [sym_unary_expression] = STATE(2073),
    [sym_try_expression] = STATE(2073),
    [sym_reference_expression] = STATE(2073),
    [sym_binary_expression] = STATE(2073),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2073),
    [sym_call_expression] = STATE(2073),
    [sym_array_expression] = STATE(2073),
    [sym_parenthesized_expression] = STATE(2073),
    [sym_tuple_expression] = STATE(2073),
    [sym_unit_expression] = STATE(2073),
    [sym_struct_expression] = STATE(2073),
    [sym_if_expression] = STATE(2073),
    [sym_if_let_expression] = STATE(2073),
    [sym_match_expression] = STATE(2073),
    [sym_while_expression] = STATE(2073),
    [sym_while_let_expression] = STATE(2073),
    [sym_loop_expression] = STATE(2073),
    [sym_for_expression] = STATE(2073),
    [sym_closure_expression] = STATE(2073),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2073),
    [sym_continue_expression] = STATE(2073),
    [sym_index_expression] = STATE(2073),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2073),
    [sym_block] = STATE(2073),
    [sym__literal] = STATE(2073),
    [sym_string_literal] = STATE(2073),
    [sym_boolean_literal] = STATE(2073),
    [sym_raw_string_literal] = ACTIONS(4671),
    [sym_float_literal] = ACTIONS(4671),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(4671),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4671),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [1412] = {
    [sym_if_expression] = STATE(1648),
    [sym_if_let_expression] = STATE(1648),
    [sym_block] = STATE(1648),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_if] = ACTIONS(4673),
    [sym_line_comment] = ACTIONS(7),
  },
  [1413] = {
    [sym_function_modifiers] = STATE(752),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2001),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(753),
    [sym_array_type] = STATE(2001),
    [sym_function_type] = STATE(2001),
    [sym_tuple_type] = STATE(2001),
    [sym_unit_type] = STATE(2001),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2001),
    [sym_reference_type] = STATE(2001),
    [sym_pointer_type] = STATE(2001),
    [sym_empty_type] = STATE(2001),
    [sym_dynamic_type] = STATE(2001),
    [sym_macro_invocation] = STATE(2001),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(754),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1593),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1597),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1599),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [1414] = {
    [sym_function_modifiers] = STATE(752),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2003),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(753),
    [sym_array_type] = STATE(2003),
    [sym_function_type] = STATE(2003),
    [sym_tuple_type] = STATE(2003),
    [sym_unit_type] = STATE(2003),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2003),
    [sym_reference_type] = STATE(2003),
    [sym_pointer_type] = STATE(2003),
    [sym_empty_type] = STATE(2003),
    [sym_dynamic_type] = STATE(2003),
    [sym_macro_invocation] = STATE(2003),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(754),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1593),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1597),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1599),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [1415] = {
    [sym_function_modifiers] = STATE(752),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2003),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(753),
    [sym_array_type] = STATE(2003),
    [sym_function_type] = STATE(2003),
    [sym_tuple_type] = STATE(2003),
    [sym_unit_type] = STATE(2003),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2003),
    [sym_reference_type] = STATE(2003),
    [sym_pointer_type] = STATE(2003),
    [sym_empty_type] = STATE(2003),
    [sym_dynamic_type] = STATE(2003),
    [sym_macro_invocation] = STATE(2003),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(754),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_PLUS] = ACTIONS(2787),
    [anon_sym_STAR] = ACTIONS(1593),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1597),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_mutable_specifier] = ACTIONS(4675),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1599),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [1416] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1760),
    [anon_sym_LPAREN] = ACTIONS(1760),
    [anon_sym_RBRACE] = ACTIONS(1760),
    [anon_sym_LBRACK] = ACTIONS(1760),
    [anon_sym_PLUS] = ACTIONS(4443),
    [anon_sym_STAR] = ACTIONS(4443),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_DASH] = ACTIONS(4443),
    [anon_sym_DOT] = ACTIONS(4443),
    [anon_sym_DASH_EQ] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(4677),
    [anon_sym_BANG_EQ] = ACTIONS(1760),
    [anon_sym_STAR_EQ] = ACTIONS(1760),
    [anon_sym_SLASH] = ACTIONS(4443),
    [anon_sym_SLASH_EQ] = ACTIONS(1760),
    [anon_sym_AMP_AMP] = ACTIONS(1760),
    [anon_sym_AMP_EQ] = ACTIONS(1760),
    [anon_sym_PERCENT] = ACTIONS(4443),
    [anon_sym_PERCENT_EQ] = ACTIONS(1760),
    [anon_sym_CARET] = ACTIONS(4443),
    [anon_sym_CARET_EQ] = ACTIONS(1760),
    [anon_sym_PLUS_EQ] = ACTIONS(1760),
    [anon_sym_LT] = ACTIONS(4443),
    [anon_sym_LT_LT] = ACTIONS(4443),
    [anon_sym_LT_LT_EQ] = ACTIONS(1760),
    [anon_sym_LT_EQ] = ACTIONS(1760),
    [anon_sym_EQ] = ACTIONS(4443),
    [anon_sym_EQ_EQ] = ACTIONS(1760),
    [anon_sym_GT] = ACTIONS(4443),
    [anon_sym_GT_EQ] = ACTIONS(1760),
    [anon_sym_GT_GT] = ACTIONS(4443),
    [anon_sym_GT_GT_EQ] = ACTIONS(1760),
    [anon_sym_PIPE] = ACTIONS(4443),
    [anon_sym_PIPE_EQ] = ACTIONS(1760),
    [anon_sym_PIPE_PIPE] = ACTIONS(1760),
    [anon_sym_QMARK] = ACTIONS(1760),
    [anon_sym_DOT_DOT] = ACTIONS(4443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1760),
    [anon_sym_as] = ACTIONS(1760),
    [sym_line_comment] = ACTIONS(7),
  },
  [1417] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1794),
    [anon_sym_LPAREN] = ACTIONS(1794),
    [anon_sym_RBRACE] = ACTIONS(1794),
    [anon_sym_LBRACK] = ACTIONS(1794),
    [anon_sym_PLUS] = ACTIONS(4449),
    [anon_sym_STAR] = ACTIONS(4449),
    [anon_sym_AMP] = ACTIONS(4449),
    [anon_sym_DASH] = ACTIONS(4449),
    [anon_sym_DOT] = ACTIONS(4449),
    [anon_sym_DASH_EQ] = ACTIONS(1794),
    [anon_sym_DASH_GT] = ACTIONS(4679),
    [anon_sym_BANG_EQ] = ACTIONS(1794),
    [anon_sym_STAR_EQ] = ACTIONS(1794),
    [anon_sym_SLASH] = ACTIONS(4449),
    [anon_sym_SLASH_EQ] = ACTIONS(1794),
    [anon_sym_AMP_AMP] = ACTIONS(1794),
    [anon_sym_AMP_EQ] = ACTIONS(1794),
    [anon_sym_PERCENT] = ACTIONS(4449),
    [anon_sym_PERCENT_EQ] = ACTIONS(1794),
    [anon_sym_CARET] = ACTIONS(4449),
    [anon_sym_CARET_EQ] = ACTIONS(1794),
    [anon_sym_PLUS_EQ] = ACTIONS(1794),
    [anon_sym_LT] = ACTIONS(4449),
    [anon_sym_LT_LT] = ACTIONS(4449),
    [anon_sym_LT_LT_EQ] = ACTIONS(1794),
    [anon_sym_LT_EQ] = ACTIONS(1794),
    [anon_sym_EQ] = ACTIONS(4449),
    [anon_sym_EQ_EQ] = ACTIONS(1794),
    [anon_sym_GT] = ACTIONS(4449),
    [anon_sym_GT_EQ] = ACTIONS(1794),
    [anon_sym_GT_GT] = ACTIONS(4449),
    [anon_sym_GT_GT_EQ] = ACTIONS(1794),
    [anon_sym_PIPE] = ACTIONS(4449),
    [anon_sym_PIPE_EQ] = ACTIONS(1794),
    [anon_sym_PIPE_PIPE] = ACTIONS(1794),
    [anon_sym_QMARK] = ACTIONS(1794),
    [anon_sym_DOT_DOT] = ACTIONS(4449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1794),
    [anon_sym_as] = ACTIONS(1794),
    [sym_line_comment] = ACTIONS(7),
  },
  [1418] = {
    [sym_parameters] = STATE(2077),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [sym_line_comment] = ACTIONS(7),
  },
  [1419] = {
    [sym_parameters] = STATE(2078),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1420] = {
    [sym_parameters] = STATE(2077),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1421] = {
    [sym_function_modifiers] = STATE(752),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2016),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(2016),
    [sym_array_type] = STATE(2016),
    [sym_function_type] = STATE(2016),
    [sym_tuple_type] = STATE(2016),
    [sym_unit_type] = STATE(2016),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2016),
    [sym_reference_type] = STATE(2016),
    [sym_pointer_type] = STATE(2016),
    [sym_empty_type] = STATE(2016),
    [sym_dynamic_type] = STATE(2016),
    [sym_macro_invocation] = STATE(2016),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(754),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1593),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(4453),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1597),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1599),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [1422] = {
    [sym_function_modifiers] = STATE(752),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2016),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(753),
    [sym_array_type] = STATE(2016),
    [sym_function_type] = STATE(2016),
    [sym_tuple_type] = STATE(2016),
    [sym_unit_type] = STATE(2016),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2016),
    [sym_reference_type] = STATE(2016),
    [sym_pointer_type] = STATE(2016),
    [sym_empty_type] = STATE(2016),
    [sym_dynamic_type] = STATE(2016),
    [sym_macro_invocation] = STATE(2016),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(754),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1593),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1597),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1599),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [1423] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2079),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(2079),
    [sym_macro_invocation] = STATE(2079),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2079),
    [sym_unary_expression] = STATE(2079),
    [sym_try_expression] = STATE(2079),
    [sym_reference_expression] = STATE(2079),
    [sym_binary_expression] = STATE(2079),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2079),
    [sym_call_expression] = STATE(2079),
    [sym_array_expression] = STATE(2079),
    [sym_parenthesized_expression] = STATE(2079),
    [sym_tuple_expression] = STATE(2079),
    [sym_unit_expression] = STATE(2079),
    [sym_struct_expression] = STATE(2079),
    [sym_if_expression] = STATE(2079),
    [sym_if_let_expression] = STATE(2079),
    [sym_match_expression] = STATE(2079),
    [sym_while_expression] = STATE(2079),
    [sym_while_let_expression] = STATE(2079),
    [sym_loop_expression] = STATE(2079),
    [sym_for_expression] = STATE(2079),
    [sym_closure_expression] = STATE(2079),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2079),
    [sym_continue_expression] = STATE(2079),
    [sym_index_expression] = STATE(2079),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2079),
    [sym_block] = STATE(2079),
    [sym__literal] = STATE(2079),
    [sym_string_literal] = STATE(2079),
    [sym_boolean_literal] = STATE(2079),
    [sym_raw_string_literal] = ACTIONS(4681),
    [sym_float_literal] = ACTIONS(4681),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(4681),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4681),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [1424] = {
    [sym_if_expression] = STATE(2043),
    [sym_if_let_expression] = STATE(2043),
    [sym_block] = STATE(2043),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(4683),
    [sym_line_comment] = ACTIONS(7),
  },
  [1425] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4685),
    [anon_sym_LPAREN] = ACTIONS(4685),
    [anon_sym_RPAREN] = ACTIONS(4685),
    [anon_sym_LBRACE] = ACTIONS(4685),
    [anon_sym_RBRACE] = ACTIONS(4685),
    [anon_sym_LBRACK] = ACTIONS(4685),
    [anon_sym_RBRACK] = ACTIONS(4685),
    [anon_sym_PLUS] = ACTIONS(4687),
    [anon_sym_STAR] = ACTIONS(4687),
    [anon_sym_COMMA] = ACTIONS(4685),
    [anon_sym_AMP] = ACTIONS(4687),
    [anon_sym_DASH] = ACTIONS(4687),
    [anon_sym_DOT] = ACTIONS(4687),
    [anon_sym_DASH_EQ] = ACTIONS(4685),
    [anon_sym_BANG_EQ] = ACTIONS(4685),
    [anon_sym_STAR_EQ] = ACTIONS(4685),
    [anon_sym_SLASH] = ACTIONS(4687),
    [anon_sym_SLASH_EQ] = ACTIONS(4685),
    [anon_sym_AMP_AMP] = ACTIONS(4685),
    [anon_sym_AMP_EQ] = ACTIONS(4685),
    [anon_sym_PERCENT] = ACTIONS(4687),
    [anon_sym_PERCENT_EQ] = ACTIONS(4685),
    [anon_sym_CARET] = ACTIONS(4687),
    [anon_sym_CARET_EQ] = ACTIONS(4685),
    [anon_sym_PLUS_EQ] = ACTIONS(4685),
    [anon_sym_LT] = ACTIONS(4687),
    [anon_sym_LT_LT] = ACTIONS(4687),
    [anon_sym_LT_LT_EQ] = ACTIONS(4685),
    [anon_sym_LT_EQ] = ACTIONS(4685),
    [anon_sym_EQ] = ACTIONS(4687),
    [anon_sym_EQ_EQ] = ACTIONS(4685),
    [anon_sym_GT] = ACTIONS(4687),
    [anon_sym_GT_EQ] = ACTIONS(4685),
    [anon_sym_GT_GT] = ACTIONS(4687),
    [anon_sym_GT_GT_EQ] = ACTIONS(4685),
    [anon_sym_PIPE] = ACTIONS(4687),
    [anon_sym_PIPE_EQ] = ACTIONS(4685),
    [anon_sym_PIPE_PIPE] = ACTIONS(4685),
    [anon_sym_QMARK] = ACTIONS(4685),
    [anon_sym_DOT_DOT] = ACTIONS(4687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4685),
    [anon_sym_as] = ACTIONS(4685),
    [sym_line_comment] = ACTIONS(7),
  },
  [1426] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(361),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(361),
    [sym_macro_invocation] = STATE(361),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(361),
    [sym_unary_expression] = STATE(361),
    [sym_try_expression] = STATE(361),
    [sym_reference_expression] = STATE(361),
    [sym_binary_expression] = STATE(361),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(361),
    [sym_call_expression] = STATE(361),
    [sym_array_expression] = STATE(361),
    [sym_parenthesized_expression] = STATE(361),
    [sym_tuple_expression] = STATE(361),
    [sym_unit_expression] = STATE(361),
    [sym_struct_expression] = STATE(361),
    [sym_if_expression] = STATE(361),
    [sym_if_let_expression] = STATE(361),
    [sym_match_expression] = STATE(361),
    [sym_while_expression] = STATE(361),
    [sym_while_let_expression] = STATE(361),
    [sym_loop_expression] = STATE(361),
    [sym_for_expression] = STATE(361),
    [sym_closure_expression] = STATE(361),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(361),
    [sym_continue_expression] = STATE(361),
    [sym_index_expression] = STATE(361),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(361),
    [sym_block] = STATE(361),
    [sym__literal] = STATE(361),
    [sym_string_literal] = STATE(361),
    [sym_boolean_literal] = STATE(361),
    [sym_raw_string_literal] = ACTIONS(715),
    [sym_float_literal] = ACTIONS(715),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(715),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(715),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1427] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_STAR] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_AMP] = ACTIONS(2821),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_BANG_EQ] = ACTIONS(2825),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(2827),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(2831),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(2825),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_EQ_EQ] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2831),
    [anon_sym_GT_EQ] = ACTIONS(2825),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(2837),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(2839),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_as] = ACTIONS(909),
    [sym_line_comment] = ACTIONS(7),
  },
  [1428] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(2080),
    [sym_tuple_pattern] = STATE(2080),
    [sym_tuple_struct_pattern] = STATE(2080),
    [sym_struct_pattern] = STATE(2080),
    [sym_remaining_field_pattern] = STATE(2080),
    [sym_mut_pattern] = STATE(2080),
    [sym_ref_pattern] = STATE(2080),
    [sym_captured_pattern] = STATE(2080),
    [sym_reference_pattern] = STATE(2080),
    [sym__literal] = STATE(2080),
    [sym_string_literal] = STATE(2080),
    [sym_boolean_literal] = STATE(2080),
    [sym_raw_string_literal] = ACTIONS(4689),
    [sym_float_literal] = ACTIONS(4689),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(4691),
    [anon_sym_AMP] = ACTIONS(955),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(957),
    [anon_sym_ref] = ACTIONS(959),
    [sym_integer_literal] = ACTIONS(4689),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(4689),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(961),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [1429] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(2081),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [1430] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(1043),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_STAR] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(1043),
    [anon_sym_AMP] = ACTIONS(2821),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(1043),
    [anon_sym_BANG_EQ] = ACTIONS(2825),
    [anon_sym_STAR_EQ] = ACTIONS(1043),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_SLASH_EQ] = ACTIONS(1043),
    [anon_sym_AMP_AMP] = ACTIONS(2827),
    [anon_sym_AMP_EQ] = ACTIONS(1043),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_PERCENT_EQ] = ACTIONS(1043),
    [anon_sym_CARET] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(1043),
    [anon_sym_PLUS_EQ] = ACTIONS(1043),
    [anon_sym_LT] = ACTIONS(2831),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_LT_LT_EQ] = ACTIONS(1043),
    [anon_sym_LT_EQ] = ACTIONS(2825),
    [anon_sym_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2831),
    [anon_sym_GT_EQ] = ACTIONS(2825),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_GT_GT_EQ] = ACTIONS(1043),
    [anon_sym_PIPE] = ACTIONS(2837),
    [anon_sym_PIPE_EQ] = ACTIONS(1043),
    [anon_sym_PIPE_PIPE] = ACTIONS(2839),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(2841),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2843),
    [anon_sym_as] = ACTIONS(1043),
    [sym_line_comment] = ACTIONS(7),
  },
  [1431] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2082),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2082),
    [sym_macro_invocation] = STATE(2082),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2082),
    [sym_unary_expression] = STATE(2082),
    [sym_try_expression] = STATE(2082),
    [sym_reference_expression] = STATE(2082),
    [sym_binary_expression] = STATE(2082),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2082),
    [sym_call_expression] = STATE(2082),
    [sym_array_expression] = STATE(2082),
    [sym_parenthesized_expression] = STATE(2082),
    [sym_tuple_expression] = STATE(2082),
    [sym_unit_expression] = STATE(2082),
    [sym_struct_expression] = STATE(2082),
    [sym_if_expression] = STATE(2082),
    [sym_if_let_expression] = STATE(2082),
    [sym_match_expression] = STATE(2082),
    [sym_while_expression] = STATE(2082),
    [sym_while_let_expression] = STATE(2082),
    [sym_loop_expression] = STATE(2082),
    [sym_for_expression] = STATE(2082),
    [sym_closure_expression] = STATE(2082),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2082),
    [sym_continue_expression] = STATE(2082),
    [sym_index_expression] = STATE(2082),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2082),
    [sym_block] = STATE(2082),
    [sym__literal] = STATE(2082),
    [sym_string_literal] = STATE(2082),
    [sym_boolean_literal] = STATE(2082),
    [sym_raw_string_literal] = ACTIONS(4693),
    [sym_float_literal] = ACTIONS(4693),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(2807),
    [anon_sym_DASH_GT] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(4693),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4693),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1432] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2083),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2083),
    [sym_macro_invocation] = STATE(2083),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2083),
    [sym_unary_expression] = STATE(2083),
    [sym_try_expression] = STATE(2083),
    [sym_reference_expression] = STATE(2083),
    [sym_binary_expression] = STATE(2083),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2083),
    [sym_call_expression] = STATE(2083),
    [sym_array_expression] = STATE(2083),
    [sym_parenthesized_expression] = STATE(2083),
    [sym_tuple_expression] = STATE(2083),
    [sym_unit_expression] = STATE(2083),
    [sym_struct_expression] = STATE(2083),
    [sym_if_expression] = STATE(2083),
    [sym_if_let_expression] = STATE(2083),
    [sym_match_expression] = STATE(2083),
    [sym_while_expression] = STATE(2083),
    [sym_while_let_expression] = STATE(2083),
    [sym_loop_expression] = STATE(2083),
    [sym_for_expression] = STATE(2083),
    [sym_closure_expression] = STATE(2083),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2083),
    [sym_continue_expression] = STATE(2083),
    [sym_index_expression] = STATE(2083),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2083),
    [sym_block] = STATE(2083),
    [sym__literal] = STATE(2083),
    [sym_string_literal] = STATE(2083),
    [sym_boolean_literal] = STATE(2083),
    [sym_raw_string_literal] = ACTIONS(4695),
    [sym_float_literal] = ACTIONS(4695),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(4695),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4695),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1433] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(640),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(640),
    [sym_macro_invocation] = STATE(640),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(640),
    [sym_unary_expression] = STATE(640),
    [sym_try_expression] = STATE(640),
    [sym_reference_expression] = STATE(640),
    [sym_binary_expression] = STATE(640),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(640),
    [sym_call_expression] = STATE(640),
    [sym_array_expression] = STATE(640),
    [sym_parenthesized_expression] = STATE(640),
    [sym_tuple_expression] = STATE(640),
    [sym_unit_expression] = STATE(640),
    [sym_struct_expression] = STATE(640),
    [sym_if_expression] = STATE(640),
    [sym_if_let_expression] = STATE(640),
    [sym_match_expression] = STATE(640),
    [sym_while_expression] = STATE(640),
    [sym_while_let_expression] = STATE(640),
    [sym_loop_expression] = STATE(640),
    [sym_for_expression] = STATE(640),
    [sym_closure_expression] = STATE(640),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(640),
    [sym_continue_expression] = STATE(640),
    [sym_index_expression] = STATE(640),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(640),
    [sym_block] = STATE(640),
    [sym__literal] = STATE(640),
    [sym_string_literal] = STATE(640),
    [sym_boolean_literal] = STATE(640),
    [sym_raw_string_literal] = ACTIONS(1257),
    [sym_float_literal] = ACTIONS(1257),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1257),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1257),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1434] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2084),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2084),
    [sym_macro_invocation] = STATE(2084),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2084),
    [sym_unary_expression] = STATE(2084),
    [sym_try_expression] = STATE(2084),
    [sym_reference_expression] = STATE(2084),
    [sym_binary_expression] = STATE(2084),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2084),
    [sym_call_expression] = STATE(2084),
    [sym_array_expression] = STATE(2084),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_tuple_expression] = STATE(2084),
    [sym_unit_expression] = STATE(2084),
    [sym_struct_expression] = STATE(2084),
    [sym_if_expression] = STATE(2084),
    [sym_if_let_expression] = STATE(2084),
    [sym_match_expression] = STATE(2084),
    [sym_while_expression] = STATE(2084),
    [sym_while_let_expression] = STATE(2084),
    [sym_loop_expression] = STATE(2084),
    [sym_for_expression] = STATE(2084),
    [sym_closure_expression] = STATE(2084),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2084),
    [sym_continue_expression] = STATE(2084),
    [sym_index_expression] = STATE(2084),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2084),
    [sym_block] = STATE(2084),
    [sym__literal] = STATE(2084),
    [sym_string_literal] = STATE(2084),
    [sym_boolean_literal] = STATE(2084),
    [sym_raw_string_literal] = ACTIONS(4697),
    [sym_float_literal] = ACTIONS(4697),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(4697),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4697),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1435] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2085),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2085),
    [sym_macro_invocation] = STATE(2085),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2085),
    [sym_unary_expression] = STATE(2085),
    [sym_try_expression] = STATE(2085),
    [sym_reference_expression] = STATE(2085),
    [sym_binary_expression] = STATE(2085),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2085),
    [sym_call_expression] = STATE(2085),
    [sym_array_expression] = STATE(2085),
    [sym_parenthesized_expression] = STATE(2085),
    [sym_tuple_expression] = STATE(2085),
    [sym_unit_expression] = STATE(2085),
    [sym_struct_expression] = STATE(2085),
    [sym_if_expression] = STATE(2085),
    [sym_if_let_expression] = STATE(2085),
    [sym_match_expression] = STATE(2085),
    [sym_while_expression] = STATE(2085),
    [sym_while_let_expression] = STATE(2085),
    [sym_loop_expression] = STATE(2085),
    [sym_for_expression] = STATE(2085),
    [sym_closure_expression] = STATE(2085),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2085),
    [sym_continue_expression] = STATE(2085),
    [sym_index_expression] = STATE(2085),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2085),
    [sym_block] = STATE(2085),
    [sym__literal] = STATE(2085),
    [sym_string_literal] = STATE(2085),
    [sym_boolean_literal] = STATE(2085),
    [sym_raw_string_literal] = ACTIONS(4699),
    [sym_float_literal] = ACTIONS(4699),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(4699),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4699),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1436] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2086),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2086),
    [sym_macro_invocation] = STATE(2086),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2086),
    [sym_unary_expression] = STATE(2086),
    [sym_try_expression] = STATE(2086),
    [sym_reference_expression] = STATE(2086),
    [sym_binary_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2086),
    [sym_call_expression] = STATE(2086),
    [sym_array_expression] = STATE(2086),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_tuple_expression] = STATE(2086),
    [sym_unit_expression] = STATE(2086),
    [sym_struct_expression] = STATE(2086),
    [sym_if_expression] = STATE(2086),
    [sym_if_let_expression] = STATE(2086),
    [sym_match_expression] = STATE(2086),
    [sym_while_expression] = STATE(2086),
    [sym_while_let_expression] = STATE(2086),
    [sym_loop_expression] = STATE(2086),
    [sym_for_expression] = STATE(2086),
    [sym_closure_expression] = STATE(2086),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2086),
    [sym_continue_expression] = STATE(2086),
    [sym_index_expression] = STATE(2086),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2086),
    [sym_block] = STATE(2086),
    [sym__literal] = STATE(2086),
    [sym_string_literal] = STATE(2086),
    [sym_boolean_literal] = STATE(2086),
    [sym_raw_string_literal] = ACTIONS(4701),
    [sym_float_literal] = ACTIONS(4701),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(4701),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4701),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1437] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2087),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2087),
    [sym_macro_invocation] = STATE(2087),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2087),
    [sym_unary_expression] = STATE(2087),
    [sym_try_expression] = STATE(2087),
    [sym_reference_expression] = STATE(2087),
    [sym_binary_expression] = STATE(2087),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2087),
    [sym_call_expression] = STATE(2087),
    [sym_array_expression] = STATE(2087),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_tuple_expression] = STATE(2087),
    [sym_unit_expression] = STATE(2087),
    [sym_struct_expression] = STATE(2087),
    [sym_if_expression] = STATE(2087),
    [sym_if_let_expression] = STATE(2087),
    [sym_match_expression] = STATE(2087),
    [sym_while_expression] = STATE(2087),
    [sym_while_let_expression] = STATE(2087),
    [sym_loop_expression] = STATE(2087),
    [sym_for_expression] = STATE(2087),
    [sym_closure_expression] = STATE(2087),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2087),
    [sym_continue_expression] = STATE(2087),
    [sym_index_expression] = STATE(2087),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2087),
    [sym_block] = STATE(2087),
    [sym__literal] = STATE(2087),
    [sym_string_literal] = STATE(2087),
    [sym_boolean_literal] = STATE(2087),
    [sym_raw_string_literal] = ACTIONS(4703),
    [sym_float_literal] = ACTIONS(4703),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(4703),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4703),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1438] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2088),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2088),
    [sym_macro_invocation] = STATE(2088),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2088),
    [sym_unary_expression] = STATE(2088),
    [sym_try_expression] = STATE(2088),
    [sym_reference_expression] = STATE(2088),
    [sym_binary_expression] = STATE(2088),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2088),
    [sym_call_expression] = STATE(2088),
    [sym_array_expression] = STATE(2088),
    [sym_parenthesized_expression] = STATE(2088),
    [sym_tuple_expression] = STATE(2088),
    [sym_unit_expression] = STATE(2088),
    [sym_struct_expression] = STATE(2088),
    [sym_if_expression] = STATE(2088),
    [sym_if_let_expression] = STATE(2088),
    [sym_match_expression] = STATE(2088),
    [sym_while_expression] = STATE(2088),
    [sym_while_let_expression] = STATE(2088),
    [sym_loop_expression] = STATE(2088),
    [sym_for_expression] = STATE(2088),
    [sym_closure_expression] = STATE(2088),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2088),
    [sym_continue_expression] = STATE(2088),
    [sym_index_expression] = STATE(2088),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2088),
    [sym_block] = STATE(2088),
    [sym__literal] = STATE(2088),
    [sym_string_literal] = STATE(2088),
    [sym_boolean_literal] = STATE(2088),
    [sym_raw_string_literal] = ACTIONS(4705),
    [sym_float_literal] = ACTIONS(4705),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(4705),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4705),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1439] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2089),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2089),
    [sym_macro_invocation] = STATE(2089),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2089),
    [sym_unary_expression] = STATE(2089),
    [sym_try_expression] = STATE(2089),
    [sym_reference_expression] = STATE(2089),
    [sym_binary_expression] = STATE(2089),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2089),
    [sym_call_expression] = STATE(2089),
    [sym_array_expression] = STATE(2089),
    [sym_parenthesized_expression] = STATE(2089),
    [sym_tuple_expression] = STATE(2089),
    [sym_unit_expression] = STATE(2089),
    [sym_struct_expression] = STATE(2089),
    [sym_if_expression] = STATE(2089),
    [sym_if_let_expression] = STATE(2089),
    [sym_match_expression] = STATE(2089),
    [sym_while_expression] = STATE(2089),
    [sym_while_let_expression] = STATE(2089),
    [sym_loop_expression] = STATE(2089),
    [sym_for_expression] = STATE(2089),
    [sym_closure_expression] = STATE(2089),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2089),
    [sym_continue_expression] = STATE(2089),
    [sym_index_expression] = STATE(2089),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2089),
    [sym_block] = STATE(2089),
    [sym__literal] = STATE(2089),
    [sym_string_literal] = STATE(2089),
    [sym_boolean_literal] = STATE(2089),
    [sym_raw_string_literal] = ACTIONS(4707),
    [sym_float_literal] = ACTIONS(4707),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(4707),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4707),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1440] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2090),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2090),
    [sym_macro_invocation] = STATE(2090),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2090),
    [sym_unary_expression] = STATE(2090),
    [sym_try_expression] = STATE(2090),
    [sym_reference_expression] = STATE(2090),
    [sym_binary_expression] = STATE(2090),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2090),
    [sym_call_expression] = STATE(2090),
    [sym_array_expression] = STATE(2090),
    [sym_parenthesized_expression] = STATE(2090),
    [sym_tuple_expression] = STATE(2090),
    [sym_unit_expression] = STATE(2090),
    [sym_struct_expression] = STATE(2090),
    [sym_if_expression] = STATE(2090),
    [sym_if_let_expression] = STATE(2090),
    [sym_match_expression] = STATE(2090),
    [sym_while_expression] = STATE(2090),
    [sym_while_let_expression] = STATE(2090),
    [sym_loop_expression] = STATE(2090),
    [sym_for_expression] = STATE(2090),
    [sym_closure_expression] = STATE(2090),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2090),
    [sym_continue_expression] = STATE(2090),
    [sym_index_expression] = STATE(2090),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2090),
    [sym_block] = STATE(2090),
    [sym__literal] = STATE(2090),
    [sym_string_literal] = STATE(2090),
    [sym_boolean_literal] = STATE(2090),
    [sym_raw_string_literal] = ACTIONS(4709),
    [sym_float_literal] = ACTIONS(4709),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(4709),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4709),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1441] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2091),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2091),
    [sym_macro_invocation] = STATE(2091),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2091),
    [sym_unary_expression] = STATE(2091),
    [sym_try_expression] = STATE(2091),
    [sym_reference_expression] = STATE(2091),
    [sym_binary_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2091),
    [sym_call_expression] = STATE(2091),
    [sym_array_expression] = STATE(2091),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_tuple_expression] = STATE(2091),
    [sym_unit_expression] = STATE(2091),
    [sym_struct_expression] = STATE(2091),
    [sym_if_expression] = STATE(2091),
    [sym_if_let_expression] = STATE(2091),
    [sym_match_expression] = STATE(2091),
    [sym_while_expression] = STATE(2091),
    [sym_while_let_expression] = STATE(2091),
    [sym_loop_expression] = STATE(2091),
    [sym_for_expression] = STATE(2091),
    [sym_closure_expression] = STATE(2091),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2091),
    [sym_continue_expression] = STATE(2091),
    [sym_index_expression] = STATE(2091),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2091),
    [sym_block] = STATE(2091),
    [sym__literal] = STATE(2091),
    [sym_string_literal] = STATE(2091),
    [sym_boolean_literal] = STATE(2091),
    [sym_raw_string_literal] = ACTIONS(4711),
    [sym_float_literal] = ACTIONS(4711),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(4711),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4711),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1442] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2092),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2092),
    [sym_macro_invocation] = STATE(2092),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2092),
    [sym_unary_expression] = STATE(2092),
    [sym_try_expression] = STATE(2092),
    [sym_reference_expression] = STATE(2092),
    [sym_binary_expression] = STATE(2092),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2092),
    [sym_call_expression] = STATE(2092),
    [sym_array_expression] = STATE(2092),
    [sym_parenthesized_expression] = STATE(2092),
    [sym_tuple_expression] = STATE(2092),
    [sym_unit_expression] = STATE(2092),
    [sym_struct_expression] = STATE(2092),
    [sym_if_expression] = STATE(2092),
    [sym_if_let_expression] = STATE(2092),
    [sym_match_expression] = STATE(2092),
    [sym_while_expression] = STATE(2092),
    [sym_while_let_expression] = STATE(2092),
    [sym_loop_expression] = STATE(2092),
    [sym_for_expression] = STATE(2092),
    [sym_closure_expression] = STATE(2092),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2092),
    [sym_continue_expression] = STATE(2092),
    [sym_index_expression] = STATE(2092),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2092),
    [sym_block] = STATE(2092),
    [sym__literal] = STATE(2092),
    [sym_string_literal] = STATE(2092),
    [sym_boolean_literal] = STATE(2092),
    [sym_raw_string_literal] = ACTIONS(4713),
    [sym_float_literal] = ACTIONS(4713),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(4713),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4713),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1443] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2093),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2093),
    [sym_macro_invocation] = STATE(2093),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2093),
    [sym_unary_expression] = STATE(2093),
    [sym_try_expression] = STATE(2093),
    [sym_reference_expression] = STATE(2093),
    [sym_binary_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2093),
    [sym_call_expression] = STATE(2093),
    [sym_array_expression] = STATE(2093),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_tuple_expression] = STATE(2093),
    [sym_unit_expression] = STATE(2093),
    [sym_struct_expression] = STATE(2093),
    [sym_if_expression] = STATE(2093),
    [sym_if_let_expression] = STATE(2093),
    [sym_match_expression] = STATE(2093),
    [sym_while_expression] = STATE(2093),
    [sym_while_let_expression] = STATE(2093),
    [sym_loop_expression] = STATE(2093),
    [sym_for_expression] = STATE(2093),
    [sym_closure_expression] = STATE(2093),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2093),
    [sym_continue_expression] = STATE(2093),
    [sym_index_expression] = STATE(2093),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2093),
    [sym_block] = STATE(2093),
    [sym__literal] = STATE(2093),
    [sym_string_literal] = STATE(2093),
    [sym_boolean_literal] = STATE(2093),
    [sym_raw_string_literal] = ACTIONS(4715),
    [sym_float_literal] = ACTIONS(4715),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(909),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(911),
    [anon_sym_STAR] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_DASH] = ACTIONS(911),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(911),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(911),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_LT_LT] = ACTIONS(911),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(909),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_EQ_EQ] = ACTIONS(909),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(911),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_as] = ACTIONS(911),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(4715),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4715),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1444] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2093),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2093),
    [sym_macro_invocation] = STATE(2093),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2093),
    [sym_unary_expression] = STATE(2093),
    [sym_try_expression] = STATE(2093),
    [sym_reference_expression] = STATE(2093),
    [sym_binary_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2093),
    [sym_call_expression] = STATE(2093),
    [sym_array_expression] = STATE(2093),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_tuple_expression] = STATE(2093),
    [sym_unit_expression] = STATE(2093),
    [sym_struct_expression] = STATE(2093),
    [sym_if_expression] = STATE(2093),
    [sym_if_let_expression] = STATE(2093),
    [sym_match_expression] = STATE(2093),
    [sym_while_expression] = STATE(2093),
    [sym_while_let_expression] = STATE(2093),
    [sym_loop_expression] = STATE(2093),
    [sym_for_expression] = STATE(2093),
    [sym_closure_expression] = STATE(2093),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2093),
    [sym_continue_expression] = STATE(2093),
    [sym_index_expression] = STATE(2093),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2093),
    [sym_block] = STATE(2093),
    [sym__literal] = STATE(2093),
    [sym_string_literal] = STATE(2093),
    [sym_boolean_literal] = STATE(2093),
    [sym_raw_string_literal] = ACTIONS(4715),
    [sym_float_literal] = ACTIONS(4715),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(4715),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4715),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1445] = {
    [sym_function_modifiers] = STATE(2098),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(666),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(2099),
    [sym_array_type] = STATE(666),
    [sym_function_type] = STATE(666),
    [sym_tuple_type] = STATE(666),
    [sym_unit_type] = STATE(666),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(666),
    [sym_reference_type] = STATE(666),
    [sym_pointer_type] = STATE(666),
    [sym_empty_type] = STATE(666),
    [sym_dynamic_type] = STATE(666),
    [sym_macro_invocation] = STATE(666),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(2100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(4717),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(4719),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4721),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4723),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [1446] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(1323),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_STAR] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(1323),
    [anon_sym_AMP] = ACTIONS(2821),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2823),
    [anon_sym_BANG_EQ] = ACTIONS(2825),
    [anon_sym_STAR_EQ] = ACTIONS(2823),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_SLASH_EQ] = ACTIONS(2823),
    [anon_sym_AMP_AMP] = ACTIONS(2827),
    [anon_sym_AMP_EQ] = ACTIONS(2823),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_PERCENT_EQ] = ACTIONS(2823),
    [anon_sym_CARET] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2823),
    [anon_sym_PLUS_EQ] = ACTIONS(2823),
    [anon_sym_LT] = ACTIONS(2831),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_LT_LT_EQ] = ACTIONS(2823),
    [anon_sym_LT_EQ] = ACTIONS(2825),
    [anon_sym_EQ] = ACTIONS(2835),
    [anon_sym_EQ_EQ] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2831),
    [anon_sym_GT_EQ] = ACTIONS(2825),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_GT_GT_EQ] = ACTIONS(2823),
    [anon_sym_PIPE] = ACTIONS(2837),
    [anon_sym_PIPE_EQ] = ACTIONS(2823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2839),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(2841),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2843),
    [anon_sym_as] = ACTIONS(2845),
    [sym_line_comment] = ACTIONS(7),
  },
  [1447] = {
    [sym_function_modifiers] = STATE(785),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2001),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(786),
    [sym_array_type] = STATE(2001),
    [sym_function_type] = STATE(2001),
    [sym_tuple_type] = STATE(2001),
    [sym_unit_type] = STATE(2001),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2001),
    [sym_reference_type] = STATE(2001),
    [sym_pointer_type] = STATE(2001),
    [sym_empty_type] = STATE(2001),
    [sym_dynamic_type] = STATE(2001),
    [sym_macro_invocation] = STATE(2001),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(787),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1656),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1658),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1660),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1662),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [1448] = {
    [sym_function_modifiers] = STATE(785),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2003),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(786),
    [sym_array_type] = STATE(2003),
    [sym_function_type] = STATE(2003),
    [sym_tuple_type] = STATE(2003),
    [sym_unit_type] = STATE(2003),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2003),
    [sym_reference_type] = STATE(2003),
    [sym_pointer_type] = STATE(2003),
    [sym_empty_type] = STATE(2003),
    [sym_dynamic_type] = STATE(2003),
    [sym_macro_invocation] = STATE(2003),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(787),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1656),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1658),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1660),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1662),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [1449] = {
    [sym_function_modifiers] = STATE(785),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2003),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(786),
    [sym_array_type] = STATE(2003),
    [sym_function_type] = STATE(2003),
    [sym_tuple_type] = STATE(2003),
    [sym_unit_type] = STATE(2003),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2003),
    [sym_reference_type] = STATE(2003),
    [sym_pointer_type] = STATE(2003),
    [sym_empty_type] = STATE(2003),
    [sym_dynamic_type] = STATE(2003),
    [sym_macro_invocation] = STATE(2003),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(787),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_PLUS] = ACTIONS(2857),
    [anon_sym_STAR] = ACTIONS(1656),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1658),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1660),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_mutable_specifier] = ACTIONS(4725),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1662),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [1450] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1760),
    [anon_sym_LPAREN] = ACTIONS(1760),
    [anon_sym_LBRACK] = ACTIONS(1760),
    [anon_sym_RBRACK] = ACTIONS(1760),
    [anon_sym_PLUS] = ACTIONS(4443),
    [anon_sym_STAR] = ACTIONS(4443),
    [anon_sym_COMMA] = ACTIONS(1760),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_DASH] = ACTIONS(4443),
    [anon_sym_DOT] = ACTIONS(4443),
    [anon_sym_DASH_EQ] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(4727),
    [anon_sym_BANG_EQ] = ACTIONS(1760),
    [anon_sym_STAR_EQ] = ACTIONS(1760),
    [anon_sym_SLASH] = ACTIONS(4443),
    [anon_sym_SLASH_EQ] = ACTIONS(1760),
    [anon_sym_AMP_AMP] = ACTIONS(1760),
    [anon_sym_AMP_EQ] = ACTIONS(1760),
    [anon_sym_PERCENT] = ACTIONS(4443),
    [anon_sym_PERCENT_EQ] = ACTIONS(1760),
    [anon_sym_CARET] = ACTIONS(4443),
    [anon_sym_CARET_EQ] = ACTIONS(1760),
    [anon_sym_PLUS_EQ] = ACTIONS(1760),
    [anon_sym_LT] = ACTIONS(4443),
    [anon_sym_LT_LT] = ACTIONS(4443),
    [anon_sym_LT_LT_EQ] = ACTIONS(1760),
    [anon_sym_LT_EQ] = ACTIONS(1760),
    [anon_sym_EQ] = ACTIONS(4443),
    [anon_sym_EQ_EQ] = ACTIONS(1760),
    [anon_sym_GT] = ACTIONS(4443),
    [anon_sym_GT_EQ] = ACTIONS(1760),
    [anon_sym_GT_GT] = ACTIONS(4443),
    [anon_sym_GT_GT_EQ] = ACTIONS(1760),
    [anon_sym_PIPE] = ACTIONS(4443),
    [anon_sym_PIPE_EQ] = ACTIONS(1760),
    [anon_sym_PIPE_PIPE] = ACTIONS(1760),
    [anon_sym_QMARK] = ACTIONS(1760),
    [anon_sym_DOT_DOT] = ACTIONS(4443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1760),
    [anon_sym_as] = ACTIONS(1760),
    [sym_line_comment] = ACTIONS(7),
  },
  [1451] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1794),
    [anon_sym_LPAREN] = ACTIONS(1794),
    [anon_sym_LBRACK] = ACTIONS(1794),
    [anon_sym_RBRACK] = ACTIONS(1794),
    [anon_sym_PLUS] = ACTIONS(4449),
    [anon_sym_STAR] = ACTIONS(4449),
    [anon_sym_COMMA] = ACTIONS(1794),
    [anon_sym_AMP] = ACTIONS(4449),
    [anon_sym_DASH] = ACTIONS(4449),
    [anon_sym_DOT] = ACTIONS(4449),
    [anon_sym_DASH_EQ] = ACTIONS(1794),
    [anon_sym_DASH_GT] = ACTIONS(4729),
    [anon_sym_BANG_EQ] = ACTIONS(1794),
    [anon_sym_STAR_EQ] = ACTIONS(1794),
    [anon_sym_SLASH] = ACTIONS(4449),
    [anon_sym_SLASH_EQ] = ACTIONS(1794),
    [anon_sym_AMP_AMP] = ACTIONS(1794),
    [anon_sym_AMP_EQ] = ACTIONS(1794),
    [anon_sym_PERCENT] = ACTIONS(4449),
    [anon_sym_PERCENT_EQ] = ACTIONS(1794),
    [anon_sym_CARET] = ACTIONS(4449),
    [anon_sym_CARET_EQ] = ACTIONS(1794),
    [anon_sym_PLUS_EQ] = ACTIONS(1794),
    [anon_sym_LT] = ACTIONS(4449),
    [anon_sym_LT_LT] = ACTIONS(4449),
    [anon_sym_LT_LT_EQ] = ACTIONS(1794),
    [anon_sym_LT_EQ] = ACTIONS(1794),
    [anon_sym_EQ] = ACTIONS(4449),
    [anon_sym_EQ_EQ] = ACTIONS(1794),
    [anon_sym_GT] = ACTIONS(4449),
    [anon_sym_GT_EQ] = ACTIONS(1794),
    [anon_sym_GT_GT] = ACTIONS(4449),
    [anon_sym_GT_GT_EQ] = ACTIONS(1794),
    [anon_sym_PIPE] = ACTIONS(4449),
    [anon_sym_PIPE_EQ] = ACTIONS(1794),
    [anon_sym_PIPE_PIPE] = ACTIONS(1794),
    [anon_sym_QMARK] = ACTIONS(1794),
    [anon_sym_DOT_DOT] = ACTIONS(4449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1794),
    [anon_sym_as] = ACTIONS(1794),
    [sym_line_comment] = ACTIONS(7),
  },
  [1452] = {
    [sym_parameters] = STATE(2104),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [sym_line_comment] = ACTIONS(7),
  },
  [1453] = {
    [sym_parameters] = STATE(2105),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1454] = {
    [sym_parameters] = STATE(2104),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1455] = {
    [sym_function_modifiers] = STATE(785),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2016),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(2016),
    [sym_array_type] = STATE(2016),
    [sym_function_type] = STATE(2016),
    [sym_tuple_type] = STATE(2016),
    [sym_unit_type] = STATE(2016),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2016),
    [sym_reference_type] = STATE(2016),
    [sym_pointer_type] = STATE(2016),
    [sym_empty_type] = STATE(2016),
    [sym_dynamic_type] = STATE(2016),
    [sym_macro_invocation] = STATE(2016),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(787),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1656),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1658),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(4453),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1660),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1662),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [1456] = {
    [sym_function_modifiers] = STATE(785),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2016),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(786),
    [sym_array_type] = STATE(2016),
    [sym_function_type] = STATE(2016),
    [sym_tuple_type] = STATE(2016),
    [sym_unit_type] = STATE(2016),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2016),
    [sym_reference_type] = STATE(2016),
    [sym_pointer_type] = STATE(2016),
    [sym_empty_type] = STATE(2016),
    [sym_dynamic_type] = STATE(2016),
    [sym_macro_invocation] = STATE(2016),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(787),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1656),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1658),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1660),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1662),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [1457] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(769),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(769),
    [sym_macro_invocation] = STATE(769),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(769),
    [sym_unary_expression] = STATE(769),
    [sym_try_expression] = STATE(769),
    [sym_reference_expression] = STATE(769),
    [sym_binary_expression] = STATE(769),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(769),
    [sym_call_expression] = STATE(769),
    [sym_array_expression] = STATE(769),
    [sym_parenthesized_expression] = STATE(769),
    [sym_tuple_expression] = STATE(769),
    [sym_unit_expression] = STATE(769),
    [sym_struct_expression] = STATE(769),
    [sym_if_expression] = STATE(769),
    [sym_if_let_expression] = STATE(769),
    [sym_match_expression] = STATE(769),
    [sym_while_expression] = STATE(769),
    [sym_while_let_expression] = STATE(769),
    [sym_loop_expression] = STATE(769),
    [sym_for_expression] = STATE(769),
    [sym_closure_expression] = STATE(769),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(769),
    [sym_continue_expression] = STATE(769),
    [sym_index_expression] = STATE(769),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(769),
    [sym_block] = STATE(769),
    [sym__literal] = STATE(769),
    [sym_string_literal] = STATE(769),
    [sym_boolean_literal] = STATE(769),
    [sym_raw_string_literal] = ACTIONS(1620),
    [sym_float_literal] = ACTIONS(1620),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1620),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1620),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1458] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2106),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(2106),
    [sym_macro_invocation] = STATE(2106),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2106),
    [sym_unary_expression] = STATE(2106),
    [sym_try_expression] = STATE(2106),
    [sym_reference_expression] = STATE(2106),
    [sym_binary_expression] = STATE(2106),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2106),
    [sym_call_expression] = STATE(2106),
    [sym_array_expression] = STATE(2106),
    [sym_parenthesized_expression] = STATE(2106),
    [sym_tuple_expression] = STATE(2106),
    [sym_unit_expression] = STATE(2106),
    [sym_struct_expression] = STATE(2106),
    [sym_if_expression] = STATE(2106),
    [sym_if_let_expression] = STATE(2106),
    [sym_match_expression] = STATE(2106),
    [sym_while_expression] = STATE(2106),
    [sym_while_let_expression] = STATE(2106),
    [sym_loop_expression] = STATE(2106),
    [sym_for_expression] = STATE(2106),
    [sym_closure_expression] = STATE(2106),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2106),
    [sym_continue_expression] = STATE(2106),
    [sym_index_expression] = STATE(2106),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2106),
    [sym_block] = STATE(2106),
    [sym__literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym_boolean_literal] = STATE(2106),
    [sym_raw_string_literal] = ACTIONS(4731),
    [sym_float_literal] = ACTIONS(4731),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(4731),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4731),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [1459] = {
    [sym_if_expression] = STATE(2043),
    [sym_if_let_expression] = STATE(2043),
    [sym_block] = STATE(2043),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(4733),
    [sym_line_comment] = ACTIONS(7),
  },
  [1460] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(4735),
    [anon_sym_RBRACK] = ACTIONS(4735),
    [anon_sym_COMMA] = ACTIONS(4735),
    [sym_line_comment] = ACTIONS(7),
  },
  [1461] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(4737),
    [sym_line_comment] = ACTIONS(7),
  },
  [1462] = {
    [aux_sym_meta_item_repeat1] = STATE(2109),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(4737),
    [anon_sym_COMMA] = ACTIONS(4739),
    [sym_line_comment] = ACTIONS(7),
  },
  [1463] = {
    [sym_raw_string_literal] = ACTIONS(4741),
    [sym_float_literal] = ACTIONS(4741),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(4741),
    [anon_sym_SEMI] = ACTIONS(4741),
    [anon_sym_macro_rules_BANG] = ACTIONS(4741),
    [anon_sym_LPAREN] = ACTIONS(4741),
    [anon_sym_LBRACE] = ACTIONS(4741),
    [anon_sym_RBRACE] = ACTIONS(4741),
    [anon_sym_LBRACK] = ACTIONS(4741),
    [anon_sym_STAR] = ACTIONS(4741),
    [anon_sym_u8] = ACTIONS(4743),
    [anon_sym_i8] = ACTIONS(4743),
    [anon_sym_u16] = ACTIONS(4743),
    [anon_sym_i16] = ACTIONS(4743),
    [anon_sym_u32] = ACTIONS(4743),
    [anon_sym_i32] = ACTIONS(4743),
    [anon_sym_u64] = ACTIONS(4743),
    [anon_sym_i64] = ACTIONS(4743),
    [anon_sym_u128] = ACTIONS(4743),
    [anon_sym_i128] = ACTIONS(4743),
    [anon_sym_isize] = ACTIONS(4743),
    [anon_sym_usize] = ACTIONS(4743),
    [anon_sym_f32] = ACTIONS(4743),
    [anon_sym_f64] = ACTIONS(4743),
    [anon_sym_bool] = ACTIONS(4743),
    [anon_sym_str] = ACTIONS(4743),
    [anon_sym_char] = ACTIONS(4743),
    [anon_sym_AMP] = ACTIONS(4741),
    [anon_sym_DASH] = ACTIONS(4741),
    [anon_sym_COLON_COLON] = ACTIONS(4741),
    [anon_sym_BANG] = ACTIONS(4741),
    [anon_sym_POUND] = ACTIONS(4741),
    [anon_sym_LT] = ACTIONS(4741),
    [anon_sym_PIPE] = ACTIONS(4741),
    [anon_sym_SQUOTE] = ACTIONS(4743),
    [anon_sym_DOT_DOT] = ACTIONS(4741),
    [anon_sym_break] = ACTIONS(4743),
    [anon_sym_const] = ACTIONS(4743),
    [anon_sym_continue] = ACTIONS(4743),
    [anon_sym_default] = ACTIONS(4743),
    [anon_sym_enum] = ACTIONS(4743),
    [anon_sym_fn] = ACTIONS(4743),
    [anon_sym_for] = ACTIONS(4743),
    [anon_sym_if] = ACTIONS(4743),
    [anon_sym_impl] = ACTIONS(4743),
    [anon_sym_let] = ACTIONS(4743),
    [anon_sym_loop] = ACTIONS(4743),
    [anon_sym_match] = ACTIONS(4743),
    [anon_sym_mod] = ACTIONS(4743),
    [anon_sym_pub] = ACTIONS(4743),
    [anon_sym_return] = ACTIONS(4743),
    [anon_sym_static] = ACTIONS(4743),
    [anon_sym_struct] = ACTIONS(4743),
    [anon_sym_trait] = ACTIONS(4743),
    [anon_sym_type] = ACTIONS(4743),
    [anon_sym_union] = ACTIONS(4743),
    [anon_sym_unsafe] = ACTIONS(4743),
    [anon_sym_use] = ACTIONS(4743),
    [anon_sym_while] = ACTIONS(4743),
    [anon_sym_extern] = ACTIONS(4743),
    [anon_sym_move] = ACTIONS(4743),
    [sym_integer_literal] = ACTIONS(4741),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(4741),
    [sym_char_literal] = ACTIONS(4741),
    [anon_sym_true] = ACTIONS(4743),
    [anon_sym_false] = ACTIONS(4743),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4743),
    [sym_self] = ACTIONS(4743),
    [sym_super] = ACTIONS(4743),
    [sym_crate] = ACTIONS(4743),
    [sym_metavariable] = ACTIONS(4741),
  },
  [1464] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1479),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(1479),
    [sym_function_type] = STATE(1479),
    [sym_tuple_type] = STATE(1479),
    [sym_unit_type] = STATE(1479),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1479),
    [sym_reference_type] = STATE(1479),
    [sym_pointer_type] = STATE(1479),
    [sym_empty_type] = STATE(1479),
    [sym_dynamic_type] = STATE(1479),
    [sym_macro_invocation] = STATE(1479),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1465] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1499),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(1499),
    [sym_function_type] = STATE(1499),
    [sym_tuple_type] = STATE(1499),
    [sym_unit_type] = STATE(1499),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1499),
    [sym_reference_type] = STATE(1499),
    [sym_pointer_type] = STATE(1499),
    [sym_empty_type] = STATE(1499),
    [sym_abstract_type] = STATE(1500),
    [sym_dynamic_type] = STATE(1499),
    [sym_macro_invocation] = STATE(1499),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1466] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1525),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(1525),
    [sym_function_type] = STATE(1525),
    [sym_tuple_type] = STATE(1525),
    [sym_unit_type] = STATE(1525),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1525),
    [sym_reference_type] = STATE(1525),
    [sym_pointer_type] = STATE(1525),
    [sym_empty_type] = STATE(1525),
    [sym_abstract_type] = STATE(1526),
    [sym_dynamic_type] = STATE(1525),
    [sym_macro_invocation] = STATE(1525),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1467] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_COMMA] = ACTIONS(2988),
    [anon_sym_DASH_GT] = ACTIONS(4745),
    [sym_line_comment] = ACTIONS(7),
  },
  [1468] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_COMMA] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(4747),
    [sym_line_comment] = ACTIONS(7),
  },
  [1469] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4749),
    [anon_sym_LPAREN] = ACTIONS(4749),
    [anon_sym_RPAREN] = ACTIONS(4749),
    [anon_sym_LBRACE] = ACTIONS(4749),
    [anon_sym_RBRACE] = ACTIONS(4749),
    [anon_sym_RBRACK] = ACTIONS(4749),
    [anon_sym_COLON] = ACTIONS(4749),
    [anon_sym_PLUS] = ACTIONS(4749),
    [anon_sym_COMMA] = ACTIONS(4749),
    [anon_sym_EQ] = ACTIONS(4749),
    [anon_sym_GT] = ACTIONS(4749),
    [anon_sym_PIPE] = ACTIONS(4749),
    [anon_sym_as] = ACTIONS(4749),
    [anon_sym_where] = ACTIONS(4749),
    [sym_line_comment] = ACTIONS(7),
  },
  [1470] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(4751),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_COMMA] = ACTIONS(4751),
    [sym_line_comment] = ACTIONS(7),
  },
  [1471] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1470),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(1470),
    [sym_function_type] = STATE(1470),
    [sym_tuple_type] = STATE(1470),
    [sym_unit_type] = STATE(1470),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1470),
    [sym_reference_type] = STATE(1470),
    [sym_pointer_type] = STATE(1470),
    [sym_empty_type] = STATE(1470),
    [sym_dynamic_type] = STATE(1470),
    [sym_macro_invocation] = STATE(1470),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_RPAREN] = ACTIONS(4753),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1472] = {
    [aux_sym_tuple_type_repeat1] = STATE(1472),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(4751),
    [anon_sym_COMMA] = ACTIONS(4755),
    [sym_line_comment] = ACTIONS(7),
  },
  [1473] = {
    [sym_function_modifiers] = STATE(378),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1479),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(380),
    [sym_array_type] = STATE(1479),
    [sym_function_type] = STATE(1479),
    [sym_tuple_type] = STATE(1479),
    [sym_unit_type] = STATE(1479),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1479),
    [sym_reference_type] = STATE(1479),
    [sym_pointer_type] = STATE(1479),
    [sym_empty_type] = STATE(1479),
    [sym_dynamic_type] = STATE(1479),
    [sym_macro_invocation] = STATE(1479),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(381),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(741),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(745),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(747),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1474] = {
    [sym_function_modifiers] = STATE(378),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1499),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(380),
    [sym_array_type] = STATE(1499),
    [sym_function_type] = STATE(1499),
    [sym_tuple_type] = STATE(1499),
    [sym_unit_type] = STATE(1499),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1499),
    [sym_reference_type] = STATE(1499),
    [sym_pointer_type] = STATE(1499),
    [sym_empty_type] = STATE(1499),
    [sym_abstract_type] = STATE(1500),
    [sym_dynamic_type] = STATE(1499),
    [sym_macro_invocation] = STATE(1499),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(381),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(741),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(745),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(747),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1475] = {
    [sym_function_modifiers] = STATE(378),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1525),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(380),
    [sym_array_type] = STATE(1525),
    [sym_function_type] = STATE(1525),
    [sym_tuple_type] = STATE(1525),
    [sym_unit_type] = STATE(1525),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1525),
    [sym_reference_type] = STATE(1525),
    [sym_pointer_type] = STATE(1525),
    [sym_empty_type] = STATE(1525),
    [sym_abstract_type] = STATE(1526),
    [sym_dynamic_type] = STATE(1525),
    [sym_macro_invocation] = STATE(1525),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(381),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(741),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(745),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(747),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1476] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2988),
    [anon_sym_RBRACK] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_DASH_GT] = ACTIONS(4758),
    [sym_line_comment] = ACTIONS(7),
  },
  [1477] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym_RBRACK] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(4760),
    [sym_line_comment] = ACTIONS(7),
  },
  [1478] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(4762),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_STAR_EQ] = ACTIONS(2563),
    [anon_sym_SLASH] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_AMP_EQ] = ACTIONS(2563),
    [anon_sym_PERCENT] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2563),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_CARET_EQ] = ACTIONS(2563),
    [anon_sym_PLUS_EQ] = ACTIONS(2563),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_LT_LT] = ACTIONS(2573),
    [anon_sym_LT_LT_EQ] = ACTIONS(2563),
    [anon_sym_LT_EQ] = ACTIONS(2565),
    [anon_sym_EQ] = ACTIONS(2575),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_GT_EQ] = ACTIONS(2565),
    [anon_sym_GT_GT] = ACTIONS(2573),
    [anon_sym_GT_GT_EQ] = ACTIONS(2563),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_PIPE_EQ] = ACTIONS(2563),
    [anon_sym_PIPE_PIPE] = ACTIONS(2579),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(2581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2583),
    [anon_sym_as] = ACTIONS(2585),
    [sym_line_comment] = ACTIONS(7),
  },
  [1479] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4764),
    [anon_sym_LPAREN] = ACTIONS(4764),
    [anon_sym_RPAREN] = ACTIONS(4764),
    [anon_sym_LBRACE] = ACTIONS(4764),
    [anon_sym_RBRACE] = ACTIONS(4764),
    [anon_sym_RBRACK] = ACTIONS(4764),
    [anon_sym_COLON] = ACTIONS(4764),
    [anon_sym_PLUS] = ACTIONS(4764),
    [anon_sym_COMMA] = ACTIONS(4764),
    [anon_sym_EQ] = ACTIONS(4764),
    [anon_sym_GT] = ACTIONS(4764),
    [anon_sym_PIPE] = ACTIONS(4764),
    [anon_sym_as] = ACTIONS(4764),
    [anon_sym_where] = ACTIONS(4764),
    [sym_line_comment] = ACTIONS(7),
  },
  [1480] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4766),
    [anon_sym_LPAREN] = ACTIONS(4766),
    [anon_sym_RPAREN] = ACTIONS(4766),
    [anon_sym_LBRACE] = ACTIONS(4766),
    [anon_sym_RBRACE] = ACTIONS(4766),
    [anon_sym_RBRACK] = ACTIONS(4766),
    [anon_sym_COLON] = ACTIONS(4766),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_COMMA] = ACTIONS(4766),
    [anon_sym_DASH_GT] = ACTIONS(4766),
    [anon_sym_EQ] = ACTIONS(4766),
    [anon_sym_GT] = ACTIONS(4766),
    [anon_sym_PIPE] = ACTIONS(4766),
    [anon_sym_as] = ACTIONS(4766),
    [anon_sym_where] = ACTIONS(4766),
    [sym_line_comment] = ACTIONS(7),
  },
  [1481] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2117),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(2117),
    [sym_function_type] = STATE(2117),
    [sym_tuple_type] = STATE(2117),
    [sym_unit_type] = STATE(2117),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2117),
    [sym_reference_type] = STATE(2117),
    [sym_pointer_type] = STATE(2117),
    [sym_empty_type] = STATE(2117),
    [sym_abstract_type] = STATE(886),
    [sym_dynamic_type] = STATE(2117),
    [sym_macro_invocation] = STATE(2117),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1482] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2118),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(2118),
    [sym_function_type] = STATE(2118),
    [sym_tuple_type] = STATE(2118),
    [sym_unit_type] = STATE(2118),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2118),
    [sym_reference_type] = STATE(2118),
    [sym_pointer_type] = STATE(2118),
    [sym_empty_type] = STATE(2118),
    [sym_abstract_type] = STATE(890),
    [sym_dynamic_type] = STATE(2118),
    [sym_macro_invocation] = STATE(2118),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1483] = {
    [sym_function_modifiers] = STATE(370),
    [sym_self_parameter] = STATE(2121),
    [sym_variadic_parameter] = STATE(2121),
    [sym_parameter] = STATE(2121),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2122),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(839),
    [sym_array_type] = STATE(2122),
    [sym_function_type] = STATE(2122),
    [sym_tuple_type] = STATE(2122),
    [sym_unit_type] = STATE(2122),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2122),
    [sym_reference_type] = STATE(2122),
    [sym_pointer_type] = STATE(2122),
    [sym_empty_type] = STATE(2122),
    [sym_abstract_type] = STATE(2121),
    [sym_dynamic_type] = STATE(2122),
    [sym_macro_invocation] = STATE(2122),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [sym_reference_pattern_in_parameter] = STATE(840),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_RPAREN] = ACTIONS(4768),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(1740),
    [anon_sym_i8] = ACTIONS(1740),
    [anon_sym_u16] = ACTIONS(1740),
    [anon_sym_i16] = ACTIONS(1740),
    [anon_sym_u32] = ACTIONS(1740),
    [anon_sym_i32] = ACTIONS(1740),
    [anon_sym_u64] = ACTIONS(1740),
    [anon_sym_i64] = ACTIONS(1740),
    [anon_sym_u128] = ACTIONS(1740),
    [anon_sym_i128] = ACTIONS(1740),
    [anon_sym_isize] = ACTIONS(1740),
    [anon_sym_usize] = ACTIONS(1740),
    [anon_sym_f32] = ACTIONS(1740),
    [anon_sym_f64] = ACTIONS(1740),
    [anon_sym_bool] = ACTIONS(1740),
    [anon_sym_str] = ACTIONS(1740),
    [anon_sym_char] = ACTIONS(1740),
    [anon_sym__] = ACTIONS(4770),
    [anon_sym_AMP] = ACTIONS(1744),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1746),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(1748),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_union] = ACTIONS(1752),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(1754),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1756),
    [sym_self] = ACTIONS(1758),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1484] = {
    [aux_sym_parameters_repeat1] = STATE(2124),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(4768),
    [anon_sym_COMMA] = ACTIONS(4772),
    [sym_line_comment] = ACTIONS(7),
  },
  [1485] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(371),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(371),
    [sym_function_type] = STATE(371),
    [sym_tuple_type] = STATE(371),
    [sym_unit_type] = STATE(371),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(371),
    [sym_reference_type] = STATE(371),
    [sym_pointer_type] = STATE(371),
    [sym_empty_type] = STATE(371),
    [sym_dynamic_type] = STATE(371),
    [sym_macro_invocation] = STATE(371),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [sym_ref_pattern] = STATE(895),
    [sym_reference_pattern_in_parameter] = STATE(895),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_RPAREN] = ACTIONS(4774),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(4776),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(4778),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [anon_sym_ref] = ACTIONS(821),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4780),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1486] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [sym_tuple_pattern_in_parameter] = STATE(899),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2918),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4782),
    [sym_self] = ACTIONS(4784),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1487] = {
    [sym_parameters] = STATE(800),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_RPAREN] = ACTIONS(773),
    [anon_sym_COLON] = ACTIONS(1864),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_BANG] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1488] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(4786),
    [anon_sym_COMMA] = ACTIONS(4786),
    [anon_sym_COLON_COLON] = ACTIONS(781),
    [sym_line_comment] = ACTIONS(7),
  },
  [1489] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(1704),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(4788),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(4784),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1490] = {
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4790),
    [anon_sym_LPAREN] = ACTIONS(4790),
    [anon_sym_RPAREN] = ACTIONS(4790),
    [anon_sym_LBRACE] = ACTIONS(4790),
    [anon_sym_RBRACE] = ACTIONS(4790),
    [anon_sym_RBRACK] = ACTIONS(4790),
    [anon_sym_COLON] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(4790),
    [anon_sym_COMMA] = ACTIONS(4790),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_EQ] = ACTIONS(4790),
    [anon_sym_GT] = ACTIONS(4790),
    [anon_sym_PIPE] = ACTIONS(4790),
    [anon_sym_as] = ACTIONS(4790),
    [anon_sym_where] = ACTIONS(4790),
    [sym_line_comment] = ACTIONS(7),
  },
  [1491] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4794),
    [anon_sym_LPAREN] = ACTIONS(4794),
    [anon_sym_RPAREN] = ACTIONS(4794),
    [anon_sym_LBRACE] = ACTIONS(4794),
    [anon_sym_RBRACE] = ACTIONS(4794),
    [anon_sym_RBRACK] = ACTIONS(4794),
    [anon_sym_COLON] = ACTIONS(4796),
    [anon_sym_PLUS] = ACTIONS(4794),
    [anon_sym_COMMA] = ACTIONS(4794),
    [anon_sym_COLON_COLON] = ACTIONS(799),
    [anon_sym_EQ] = ACTIONS(4794),
    [anon_sym_GT] = ACTIONS(4794),
    [anon_sym_PIPE] = ACTIONS(4794),
    [anon_sym_as] = ACTIONS(4794),
    [anon_sym_where] = ACTIONS(4794),
    [sym_line_comment] = ACTIONS(7),
  },
  [1492] = {
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4794),
    [anon_sym_LPAREN] = ACTIONS(4794),
    [anon_sym_RPAREN] = ACTIONS(4794),
    [anon_sym_LBRACE] = ACTIONS(4794),
    [anon_sym_RBRACE] = ACTIONS(4794),
    [anon_sym_RBRACK] = ACTIONS(4794),
    [anon_sym_COLON] = ACTIONS(4794),
    [anon_sym_PLUS] = ACTIONS(4794),
    [anon_sym_COMMA] = ACTIONS(4794),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_EQ] = ACTIONS(4794),
    [anon_sym_GT] = ACTIONS(4794),
    [anon_sym_PIPE] = ACTIONS(4794),
    [anon_sym_as] = ACTIONS(4794),
    [anon_sym_where] = ACTIONS(4794),
    [sym_line_comment] = ACTIONS(7),
  },
  [1493] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(4798),
    [sym_line_comment] = ACTIONS(7),
  },
  [1494] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(4800),
    [sym_line_comment] = ACTIONS(7),
  },
  [1495] = {
    [sym_tuple_pattern_in_parameter] = STATE(429),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(4802),
    [sym_mutable_specifier] = ACTIONS(4804),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4806),
  },
  [1496] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(4786),
    [anon_sym_COLON] = ACTIONS(4800),
    [anon_sym_COMMA] = ACTIONS(4786),
    [sym_line_comment] = ACTIONS(7),
  },
  [1497] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_self] = ACTIONS(4808),
  },
  [1498] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(4786),
    [anon_sym_COMMA] = ACTIONS(4786),
    [sym_line_comment] = ACTIONS(7),
  },
  [1499] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4810),
    [anon_sym_LPAREN] = ACTIONS(4810),
    [anon_sym_RPAREN] = ACTIONS(4810),
    [anon_sym_LBRACE] = ACTIONS(4810),
    [anon_sym_RBRACE] = ACTIONS(4810),
    [anon_sym_RBRACK] = ACTIONS(4810),
    [anon_sym_COLON] = ACTIONS(4810),
    [anon_sym_PLUS] = ACTIONS(4810),
    [anon_sym_COMMA] = ACTIONS(4810),
    [anon_sym_EQ] = ACTIONS(4810),
    [anon_sym_GT] = ACTIONS(4810),
    [anon_sym_PIPE] = ACTIONS(4810),
    [anon_sym_as] = ACTIONS(4810),
    [anon_sym_where] = ACTIONS(4810),
    [sym_line_comment] = ACTIONS(7),
  },
  [1500] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4810),
    [anon_sym_LPAREN] = ACTIONS(4810),
    [anon_sym_RPAREN] = ACTIONS(4810),
    [anon_sym_LBRACE] = ACTIONS(4810),
    [anon_sym_RBRACE] = ACTIONS(4810),
    [anon_sym_RBRACK] = ACTIONS(4810),
    [anon_sym_COLON] = ACTIONS(4810),
    [anon_sym_PLUS] = ACTIONS(4810),
    [anon_sym_COMMA] = ACTIONS(4810),
    [anon_sym_EQ] = ACTIONS(4810),
    [anon_sym_GT] = ACTIONS(4810),
    [anon_sym_PIPE] = ACTIONS(4810),
    [anon_sym_as] = ACTIONS(4810),
    [anon_sym_where] = ACTIONS(4810),
    [sym_line_comment] = ACTIONS(7),
  },
  [1501] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(2222),
    [anon_sym_u8] = ACTIONS(2224),
    [anon_sym_i8] = ACTIONS(2224),
    [anon_sym_u16] = ACTIONS(2224),
    [anon_sym_i16] = ACTIONS(2224),
    [anon_sym_u32] = ACTIONS(2224),
    [anon_sym_i32] = ACTIONS(2224),
    [anon_sym_u64] = ACTIONS(2224),
    [anon_sym_i64] = ACTIONS(2224),
    [anon_sym_u128] = ACTIONS(2224),
    [anon_sym_i128] = ACTIONS(2224),
    [anon_sym_isize] = ACTIONS(2224),
    [anon_sym_usize] = ACTIONS(2224),
    [anon_sym_f32] = ACTIONS(2224),
    [anon_sym_f64] = ACTIONS(2224),
    [anon_sym_bool] = ACTIONS(2224),
    [anon_sym_str] = ACTIONS(2224),
    [anon_sym_char] = ACTIONS(2224),
    [anon_sym_COLON_COLON] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(2222),
    [anon_sym_PIPE] = ACTIONS(2222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2222),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2224),
    [anon_sym_fn] = ACTIONS(2224),
    [anon_sym_if] = ACTIONS(2224),
    [anon_sym_unsafe] = ACTIONS(2224),
    [anon_sym_extern] = ACTIONS(2224),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2224),
    [sym_self] = ACTIONS(2224),
    [sym_super] = ACTIONS(2224),
    [sym_crate] = ACTIONS(2224),
    [sym_metavariable] = ACTIONS(2222),
  },
  [1502] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym_LPAREN] = ACTIONS(3560),
    [anon_sym_RPAREN] = ACTIONS(3560),
    [anon_sym_LBRACE] = ACTIONS(3560),
    [anon_sym_RBRACE] = ACTIONS(3560),
    [anon_sym_RBRACK] = ACTIONS(3560),
    [anon_sym_COLON] = ACTIONS(3560),
    [anon_sym_PLUS] = ACTIONS(3560),
    [anon_sym_COMMA] = ACTIONS(3560),
    [anon_sym_EQ] = ACTIONS(3560),
    [anon_sym_GT] = ACTIONS(3560),
    [anon_sym_PIPE] = ACTIONS(3560),
    [anon_sym_as] = ACTIONS(3560),
    [anon_sym_where] = ACTIONS(3560),
    [sym_line_comment] = ACTIONS(7),
  },
  [1503] = {
    [sym_arguments] = STATE(263),
    [aux_sym_token_tree_repeat2] = STATE(2139),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(4812),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(4814),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_BANG_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH] = ACTIONS(563),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(563),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_LT] = ACTIONS(577),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(581),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(577),
    [anon_sym_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(589),
    [anon_sym_as] = ACTIONS(591),
    [sym_line_comment] = ACTIONS(7),
  },
  [1504] = {
    [sym_token_tree] = STATE(1878),
    [sym_token_repetition] = STATE(1878),
    [sym__literal] = STATE(1878),
    [sym_string_literal] = STATE(1878),
    [sym_boolean_literal] = STATE(1878),
    [aux_sym_token_tree_repeat1] = STATE(1878),
    [sym_raw_string_literal] = ACTIONS(3960),
    [sym_float_literal] = ACTIONS(3960),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_RPAREN] = ACTIONS(4816),
    [anon_sym_LBRACE] = ACTIONS(3966),
    [anon_sym_EQ_GT] = ACTIONS(3960),
    [anon_sym_LBRACK] = ACTIONS(3968),
    [anon_sym_COLON] = ACTIONS(3970),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(3970),
    [anon_sym_STAR] = ACTIONS(3970),
    [anon_sym_COMMA] = ACTIONS(3960),
    [anon_sym_u8] = ACTIONS(3972),
    [anon_sym_i8] = ACTIONS(3972),
    [anon_sym_u16] = ACTIONS(3972),
    [anon_sym_i16] = ACTIONS(3972),
    [anon_sym_u32] = ACTIONS(3972),
    [anon_sym_i32] = ACTIONS(3972),
    [anon_sym_u64] = ACTIONS(3972),
    [anon_sym_i64] = ACTIONS(3972),
    [anon_sym_u128] = ACTIONS(3972),
    [anon_sym_i128] = ACTIONS(3972),
    [anon_sym_isize] = ACTIONS(3972),
    [anon_sym_usize] = ACTIONS(3972),
    [anon_sym_f32] = ACTIONS(3972),
    [anon_sym_f64] = ACTIONS(3972),
    [anon_sym_bool] = ACTIONS(3972),
    [anon_sym_str] = ACTIONS(3972),
    [anon_sym_char] = ACTIONS(3972),
    [anon_sym__] = ACTIONS(3970),
    [anon_sym_AMP] = ACTIONS(3970),
    [anon_sym_DASH] = ACTIONS(3970),
    [anon_sym_DOT] = ACTIONS(3970),
    [anon_sym_DASH_EQ] = ACTIONS(3960),
    [anon_sym_DASH_GT] = ACTIONS(3960),
    [anon_sym_COLON_COLON] = ACTIONS(3960),
    [anon_sym_BANG] = ACTIONS(3970),
    [anon_sym_BANG_EQ] = ACTIONS(3960),
    [anon_sym_AT] = ACTIONS(3960),
    [anon_sym_STAR_EQ] = ACTIONS(3960),
    [anon_sym_SLASH] = ACTIONS(3970),
    [anon_sym_SLASH_EQ] = ACTIONS(3960),
    [anon_sym_AMP_AMP] = ACTIONS(3960),
    [anon_sym_AMP_EQ] = ACTIONS(3960),
    [anon_sym_POUND] = ACTIONS(3960),
    [anon_sym_PERCENT] = ACTIONS(3970),
    [anon_sym_PERCENT_EQ] = ACTIONS(3960),
    [anon_sym_CARET] = ACTIONS(3970),
    [anon_sym_CARET_EQ] = ACTIONS(3960),
    [anon_sym_PLUS_EQ] = ACTIONS(3960),
    [anon_sym_LT] = ACTIONS(3970),
    [anon_sym_LT_LT] = ACTIONS(3970),
    [anon_sym_LT_LT_EQ] = ACTIONS(3960),
    [anon_sym_LT_EQ] = ACTIONS(3960),
    [anon_sym_EQ] = ACTIONS(3970),
    [anon_sym_EQ_EQ] = ACTIONS(3960),
    [anon_sym_GT] = ACTIONS(3970),
    [anon_sym_GT_EQ] = ACTIONS(3960),
    [anon_sym_GT_GT] = ACTIONS(3970),
    [anon_sym_GT_GT_EQ] = ACTIONS(3960),
    [anon_sym_PIPE] = ACTIONS(3970),
    [anon_sym_PIPE_EQ] = ACTIONS(3960),
    [anon_sym_PIPE_PIPE] = ACTIONS(3960),
    [anon_sym_TILDE] = ACTIONS(3960),
    [anon_sym_QMARK] = ACTIONS(3960),
    [anon_sym_SQUOTE] = ACTIONS(3970),
    [anon_sym_DOT_DOT] = ACTIONS(3970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3960),
    [anon_sym_as] = ACTIONS(3970),
    [anon_sym_break] = ACTIONS(3970),
    [anon_sym_const] = ACTIONS(3970),
    [anon_sym_continue] = ACTIONS(3970),
    [anon_sym_default] = ACTIONS(3970),
    [anon_sym_enum] = ACTIONS(3970),
    [anon_sym_fn] = ACTIONS(3970),
    [anon_sym_for] = ACTIONS(3970),
    [anon_sym_if] = ACTIONS(3970),
    [anon_sym_impl] = ACTIONS(3970),
    [anon_sym_let] = ACTIONS(3970),
    [anon_sym_loop] = ACTIONS(3970),
    [anon_sym_match] = ACTIONS(3970),
    [anon_sym_mod] = ACTIONS(3970),
    [anon_sym_pub] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3970),
    [anon_sym_static] = ACTIONS(3970),
    [anon_sym_struct] = ACTIONS(3970),
    [anon_sym_trait] = ACTIONS(3970),
    [anon_sym_type] = ACTIONS(3970),
    [anon_sym_union] = ACTIONS(3970),
    [anon_sym_unsafe] = ACTIONS(3970),
    [anon_sym_use] = ACTIONS(3970),
    [anon_sym_where] = ACTIONS(3970),
    [anon_sym_while] = ACTIONS(3970),
    [sym_mutable_specifier] = ACTIONS(3970),
    [sym_integer_literal] = ACTIONS(3960),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(3960),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3970),
    [sym_self] = ACTIONS(3970),
    [sym_super] = ACTIONS(3970),
    [sym_crate] = ACTIONS(3970),
    [sym_metavariable] = ACTIONS(3960),
  },
  [1505] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(4812),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(623),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(623),
    [anon_sym_PLUS_EQ] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(623),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(643),
    [anon_sym_as] = ACTIONS(645),
    [sym_line_comment] = ACTIONS(7),
  },
  [1506] = {
    [sym__statement] = STATE(332),
    [sym_empty_statement] = STATE(332),
    [sym__expression_statement] = STATE(332),
    [sym_macro_definition] = STATE(332),
    [sym_attribute_item] = STATE(332),
    [sym_inner_attribute_item] = STATE(332),
    [sym_mod_item] = STATE(332),
    [sym_foreign_mod_item] = STATE(332),
    [sym_struct_item] = STATE(332),
    [sym_union_item] = STATE(332),
    [sym_enum_item] = STATE(332),
    [sym_extern_crate_declaration] = STATE(332),
    [sym_const_item] = STATE(332),
    [sym_static_item] = STATE(332),
    [sym_type_item] = STATE(332),
    [sym_function_item] = STATE(332),
    [sym_function_signature_item] = STATE(332),
    [sym_function_modifiers] = STATE(47),
    [sym_impl_item] = STATE(332),
    [sym_trait_item] = STATE(332),
    [sym_associated_type] = STATE(332),
    [sym_let_declaration] = STATE(332),
    [sym_use_declaration] = STATE(332),
    [sym_extern_modifier] = STATE(48),
    [sym_visibility_modifier] = STATE(49),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2141),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2141),
    [sym_macro_invocation] = STATE(53),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2141),
    [sym_unary_expression] = STATE(2141),
    [sym_try_expression] = STATE(2141),
    [sym_reference_expression] = STATE(2141),
    [sym_binary_expression] = STATE(2141),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2141),
    [sym_call_expression] = STATE(2141),
    [sym_array_expression] = STATE(2141),
    [sym_parenthesized_expression] = STATE(2141),
    [sym_tuple_expression] = STATE(2141),
    [sym_unit_expression] = STATE(2141),
    [sym_struct_expression] = STATE(2141),
    [sym_if_expression] = STATE(57),
    [sym_if_let_expression] = STATE(57),
    [sym_match_expression] = STATE(57),
    [sym_while_expression] = STATE(57),
    [sym_while_let_expression] = STATE(57),
    [sym_loop_expression] = STATE(57),
    [sym_for_expression] = STATE(57),
    [sym_closure_expression] = STATE(2141),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(59),
    [sym_break_expression] = STATE(2141),
    [sym_continue_expression] = STATE(2141),
    [sym_index_expression] = STATE(2141),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(57),
    [sym_block] = STATE(57),
    [sym__literal] = STATE(2141),
    [sym_string_literal] = STATE(2141),
    [sym_boolean_literal] = STATE(2141),
    [aux_sym_source_file_repeat1] = STATE(332),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_raw_string_literal] = ACTIONS(4818),
    [sym_float_literal] = ACTIONS(4818),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(4812),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_POUND] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(4818),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4818),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(93),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1507] = {
    [sym_token_tree] = STATE(1887),
    [sym_token_repetition] = STATE(1887),
    [sym__literal] = STATE(1887),
    [sym_string_literal] = STATE(1887),
    [sym_boolean_literal] = STATE(1887),
    [aux_sym_token_tree_repeat1] = STATE(1887),
    [sym_raw_string_literal] = ACTIONS(4148),
    [sym_float_literal] = ACTIONS(4148),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4148),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_LBRACE] = ACTIONS(3966),
    [anon_sym_RBRACE] = ACTIONS(4816),
    [anon_sym_EQ_GT] = ACTIONS(4148),
    [anon_sym_LBRACK] = ACTIONS(3968),
    [anon_sym_COLON] = ACTIONS(4150),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(4150),
    [anon_sym_STAR] = ACTIONS(4150),
    [anon_sym_COMMA] = ACTIONS(4148),
    [anon_sym_u8] = ACTIONS(3972),
    [anon_sym_i8] = ACTIONS(3972),
    [anon_sym_u16] = ACTIONS(3972),
    [anon_sym_i16] = ACTIONS(3972),
    [anon_sym_u32] = ACTIONS(3972),
    [anon_sym_i32] = ACTIONS(3972),
    [anon_sym_u64] = ACTIONS(3972),
    [anon_sym_i64] = ACTIONS(3972),
    [anon_sym_u128] = ACTIONS(3972),
    [anon_sym_i128] = ACTIONS(3972),
    [anon_sym_isize] = ACTIONS(3972),
    [anon_sym_usize] = ACTIONS(3972),
    [anon_sym_f32] = ACTIONS(3972),
    [anon_sym_f64] = ACTIONS(3972),
    [anon_sym_bool] = ACTIONS(3972),
    [anon_sym_str] = ACTIONS(3972),
    [anon_sym_char] = ACTIONS(3972),
    [anon_sym__] = ACTIONS(4150),
    [anon_sym_AMP] = ACTIONS(4150),
    [anon_sym_DASH] = ACTIONS(4150),
    [anon_sym_DOT] = ACTIONS(4150),
    [anon_sym_DASH_EQ] = ACTIONS(4148),
    [anon_sym_DASH_GT] = ACTIONS(4148),
    [anon_sym_COLON_COLON] = ACTIONS(4148),
    [anon_sym_BANG] = ACTIONS(4150),
    [anon_sym_BANG_EQ] = ACTIONS(4148),
    [anon_sym_AT] = ACTIONS(4148),
    [anon_sym_STAR_EQ] = ACTIONS(4148),
    [anon_sym_SLASH] = ACTIONS(4150),
    [anon_sym_SLASH_EQ] = ACTIONS(4148),
    [anon_sym_AMP_AMP] = ACTIONS(4148),
    [anon_sym_AMP_EQ] = ACTIONS(4148),
    [anon_sym_POUND] = ACTIONS(4148),
    [anon_sym_PERCENT] = ACTIONS(4150),
    [anon_sym_PERCENT_EQ] = ACTIONS(4148),
    [anon_sym_CARET] = ACTIONS(4150),
    [anon_sym_CARET_EQ] = ACTIONS(4148),
    [anon_sym_PLUS_EQ] = ACTIONS(4148),
    [anon_sym_LT] = ACTIONS(4150),
    [anon_sym_LT_LT] = ACTIONS(4150),
    [anon_sym_LT_LT_EQ] = ACTIONS(4148),
    [anon_sym_LT_EQ] = ACTIONS(4148),
    [anon_sym_EQ] = ACTIONS(4150),
    [anon_sym_EQ_EQ] = ACTIONS(4148),
    [anon_sym_GT] = ACTIONS(4150),
    [anon_sym_GT_EQ] = ACTIONS(4148),
    [anon_sym_GT_GT] = ACTIONS(4150),
    [anon_sym_GT_GT_EQ] = ACTIONS(4148),
    [anon_sym_PIPE] = ACTIONS(4150),
    [anon_sym_PIPE_EQ] = ACTIONS(4148),
    [anon_sym_PIPE_PIPE] = ACTIONS(4148),
    [anon_sym_TILDE] = ACTIONS(4148),
    [anon_sym_QMARK] = ACTIONS(4148),
    [anon_sym_SQUOTE] = ACTIONS(4150),
    [anon_sym_DOT_DOT] = ACTIONS(4150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4148),
    [anon_sym_as] = ACTIONS(4150),
    [anon_sym_break] = ACTIONS(4150),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_continue] = ACTIONS(4150),
    [anon_sym_default] = ACTIONS(4150),
    [anon_sym_enum] = ACTIONS(4150),
    [anon_sym_fn] = ACTIONS(4150),
    [anon_sym_for] = ACTIONS(4150),
    [anon_sym_if] = ACTIONS(4150),
    [anon_sym_impl] = ACTIONS(4150),
    [anon_sym_let] = ACTIONS(4150),
    [anon_sym_loop] = ACTIONS(4150),
    [anon_sym_match] = ACTIONS(4150),
    [anon_sym_mod] = ACTIONS(4150),
    [anon_sym_pub] = ACTIONS(4150),
    [anon_sym_return] = ACTIONS(4150),
    [anon_sym_static] = ACTIONS(4150),
    [anon_sym_struct] = ACTIONS(4150),
    [anon_sym_trait] = ACTIONS(4150),
    [anon_sym_type] = ACTIONS(4150),
    [anon_sym_union] = ACTIONS(4150),
    [anon_sym_unsafe] = ACTIONS(4150),
    [anon_sym_use] = ACTIONS(4150),
    [anon_sym_where] = ACTIONS(4150),
    [anon_sym_while] = ACTIONS(4150),
    [sym_mutable_specifier] = ACTIONS(4150),
    [sym_integer_literal] = ACTIONS(4148),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(4148),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4150),
    [sym_self] = ACTIONS(4150),
    [sym_super] = ACTIONS(4150),
    [sym_crate] = ACTIONS(4150),
    [sym_metavariable] = ACTIONS(4148),
  },
  [1508] = {
    [sym_arguments] = STATE(263),
    [aux_sym_token_tree_repeat2] = STATE(2143),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(4812),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_STAR] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(4820),
    [anon_sym_AMP] = ACTIONS(2821),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2823),
    [anon_sym_BANG_EQ] = ACTIONS(2825),
    [anon_sym_STAR_EQ] = ACTIONS(2823),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_SLASH_EQ] = ACTIONS(2823),
    [anon_sym_AMP_AMP] = ACTIONS(2827),
    [anon_sym_AMP_EQ] = ACTIONS(2823),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_PERCENT_EQ] = ACTIONS(2823),
    [anon_sym_CARET] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2823),
    [anon_sym_PLUS_EQ] = ACTIONS(2823),
    [anon_sym_LT] = ACTIONS(2831),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_LT_LT_EQ] = ACTIONS(2823),
    [anon_sym_LT_EQ] = ACTIONS(2825),
    [anon_sym_EQ] = ACTIONS(2835),
    [anon_sym_EQ_EQ] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2831),
    [anon_sym_GT_EQ] = ACTIONS(2825),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_GT_GT_EQ] = ACTIONS(2823),
    [anon_sym_PIPE] = ACTIONS(2837),
    [anon_sym_PIPE_EQ] = ACTIONS(2823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2839),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(2841),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2843),
    [anon_sym_as] = ACTIONS(2845),
    [sym_line_comment] = ACTIONS(7),
  },
  [1509] = {
    [sym_token_tree] = STATE(1890),
    [sym_token_repetition] = STATE(1890),
    [sym__literal] = STATE(1890),
    [sym_string_literal] = STATE(1890),
    [sym_boolean_literal] = STATE(1890),
    [aux_sym_token_tree_repeat1] = STATE(1890),
    [sym_raw_string_literal] = ACTIONS(4197),
    [sym_float_literal] = ACTIONS(4197),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4197),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_LBRACE] = ACTIONS(3966),
    [anon_sym_EQ_GT] = ACTIONS(4197),
    [anon_sym_LBRACK] = ACTIONS(3968),
    [anon_sym_RBRACK] = ACTIONS(4816),
    [anon_sym_COLON] = ACTIONS(4199),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(4199),
    [anon_sym_STAR] = ACTIONS(4199),
    [anon_sym_COMMA] = ACTIONS(4197),
    [anon_sym_u8] = ACTIONS(3972),
    [anon_sym_i8] = ACTIONS(3972),
    [anon_sym_u16] = ACTIONS(3972),
    [anon_sym_i16] = ACTIONS(3972),
    [anon_sym_u32] = ACTIONS(3972),
    [anon_sym_i32] = ACTIONS(3972),
    [anon_sym_u64] = ACTIONS(3972),
    [anon_sym_i64] = ACTIONS(3972),
    [anon_sym_u128] = ACTIONS(3972),
    [anon_sym_i128] = ACTIONS(3972),
    [anon_sym_isize] = ACTIONS(3972),
    [anon_sym_usize] = ACTIONS(3972),
    [anon_sym_f32] = ACTIONS(3972),
    [anon_sym_f64] = ACTIONS(3972),
    [anon_sym_bool] = ACTIONS(3972),
    [anon_sym_str] = ACTIONS(3972),
    [anon_sym_char] = ACTIONS(3972),
    [anon_sym__] = ACTIONS(4199),
    [anon_sym_AMP] = ACTIONS(4199),
    [anon_sym_DASH] = ACTIONS(4199),
    [anon_sym_DOT] = ACTIONS(4199),
    [anon_sym_DASH_EQ] = ACTIONS(4197),
    [anon_sym_DASH_GT] = ACTIONS(4197),
    [anon_sym_COLON_COLON] = ACTIONS(4197),
    [anon_sym_BANG] = ACTIONS(4199),
    [anon_sym_BANG_EQ] = ACTIONS(4197),
    [anon_sym_AT] = ACTIONS(4197),
    [anon_sym_STAR_EQ] = ACTIONS(4197),
    [anon_sym_SLASH] = ACTIONS(4199),
    [anon_sym_SLASH_EQ] = ACTIONS(4197),
    [anon_sym_AMP_AMP] = ACTIONS(4197),
    [anon_sym_AMP_EQ] = ACTIONS(4197),
    [anon_sym_POUND] = ACTIONS(4197),
    [anon_sym_PERCENT] = ACTIONS(4199),
    [anon_sym_PERCENT_EQ] = ACTIONS(4197),
    [anon_sym_CARET] = ACTIONS(4199),
    [anon_sym_CARET_EQ] = ACTIONS(4197),
    [anon_sym_PLUS_EQ] = ACTIONS(4197),
    [anon_sym_LT] = ACTIONS(4199),
    [anon_sym_LT_LT] = ACTIONS(4199),
    [anon_sym_LT_LT_EQ] = ACTIONS(4197),
    [anon_sym_LT_EQ] = ACTIONS(4197),
    [anon_sym_EQ] = ACTIONS(4199),
    [anon_sym_EQ_EQ] = ACTIONS(4197),
    [anon_sym_GT] = ACTIONS(4199),
    [anon_sym_GT_EQ] = ACTIONS(4197),
    [anon_sym_GT_GT] = ACTIONS(4199),
    [anon_sym_GT_GT_EQ] = ACTIONS(4197),
    [anon_sym_PIPE] = ACTIONS(4199),
    [anon_sym_PIPE_EQ] = ACTIONS(4197),
    [anon_sym_PIPE_PIPE] = ACTIONS(4197),
    [anon_sym_TILDE] = ACTIONS(4197),
    [anon_sym_QMARK] = ACTIONS(4197),
    [anon_sym_SQUOTE] = ACTIONS(4199),
    [anon_sym_DOT_DOT] = ACTIONS(4199),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4197),
    [anon_sym_as] = ACTIONS(4199),
    [anon_sym_break] = ACTIONS(4199),
    [anon_sym_const] = ACTIONS(4199),
    [anon_sym_continue] = ACTIONS(4199),
    [anon_sym_default] = ACTIONS(4199),
    [anon_sym_enum] = ACTIONS(4199),
    [anon_sym_fn] = ACTIONS(4199),
    [anon_sym_for] = ACTIONS(4199),
    [anon_sym_if] = ACTIONS(4199),
    [anon_sym_impl] = ACTIONS(4199),
    [anon_sym_let] = ACTIONS(4199),
    [anon_sym_loop] = ACTIONS(4199),
    [anon_sym_match] = ACTIONS(4199),
    [anon_sym_mod] = ACTIONS(4199),
    [anon_sym_pub] = ACTIONS(4199),
    [anon_sym_return] = ACTIONS(4199),
    [anon_sym_static] = ACTIONS(4199),
    [anon_sym_struct] = ACTIONS(4199),
    [anon_sym_trait] = ACTIONS(4199),
    [anon_sym_type] = ACTIONS(4199),
    [anon_sym_union] = ACTIONS(4199),
    [anon_sym_unsafe] = ACTIONS(4199),
    [anon_sym_use] = ACTIONS(4199),
    [anon_sym_where] = ACTIONS(4199),
    [anon_sym_while] = ACTIONS(4199),
    [sym_mutable_specifier] = ACTIONS(4199),
    [sym_integer_literal] = ACTIONS(4197),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(4197),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4199),
    [sym_self] = ACTIONS(4199),
    [sym_super] = ACTIONS(4199),
    [sym_crate] = ACTIONS(4199),
    [sym_metavariable] = ACTIONS(4197),
  },
  [1510] = {
    [sym_function_modifiers] = STATE(854),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(821),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1664),
    [sym_array_type] = STATE(821),
    [sym_function_type] = STATE(821),
    [sym_tuple_type] = STATE(821),
    [sym_unit_type] = STATE(821),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(821),
    [sym_reference_type] = STATE(821),
    [sym_pointer_type] = STATE(821),
    [sym_empty_type] = STATE(821),
    [sym_dynamic_type] = STATE(821),
    [sym_macro_invocation] = STATE(821),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(858),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1786),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1788),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1790),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2972),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1511] = {
    [sym_function_modifiers] = STATE(854),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1664),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(858),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1786),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1788),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1790),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2972),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1512] = {
    [sym_parameters] = STATE(1516),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_BANG] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_GT] = ACTIONS(773),
    [sym_line_comment] = ACTIONS(7),
  },
  [1513] = {
    [sym_function_modifiers] = STATE(854),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1664),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(858),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(2986),
    [anon_sym_STAR] = ACTIONS(1786),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1788),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1790),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(4822),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2972),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1514] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(1760),
    [anon_sym_COMMA] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(4824),
    [anon_sym_GT] = ACTIONS(1760),
    [sym_line_comment] = ACTIONS(7),
  },
  [1515] = {
    [sym_function_modifiers] = STATE(854),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2146),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1664),
    [sym_array_type] = STATE(2146),
    [sym_function_type] = STATE(2146),
    [sym_tuple_type] = STATE(2146),
    [sym_unit_type] = STATE(2146),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2146),
    [sym_reference_type] = STATE(2146),
    [sym_pointer_type] = STATE(2146),
    [sym_empty_type] = STATE(2146),
    [sym_dynamic_type] = STATE(2146),
    [sym_macro_invocation] = STATE(2146),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(858),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1786),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1788),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1790),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2972),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1516] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(1794),
    [anon_sym_COMMA] = ACTIONS(1794),
    [anon_sym_DASH_GT] = ACTIONS(4826),
    [anon_sym_GT] = ACTIONS(1794),
    [sym_line_comment] = ACTIONS(7),
  },
  [1517] = {
    [sym_parameters] = STATE(2148),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [1518] = {
    [sym_parameters] = STATE(2149),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1519] = {
    [sym_parameters] = STATE(2148),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1520] = {
    [sym_function_modifiers] = STATE(854),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(862),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(858),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1786),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1788),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1790),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2972),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1521] = {
    [sym_function_modifiers] = STATE(854),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2151),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2152),
    [sym_array_type] = STATE(2151),
    [sym_function_type] = STATE(2151),
    [sym_tuple_type] = STATE(2151),
    [sym_unit_type] = STATE(2151),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2151),
    [sym_type_binding] = STATE(2153),
    [sym_reference_type] = STATE(2151),
    [sym_pointer_type] = STATE(2151),
    [sym_empty_type] = STATE(2151),
    [sym_dynamic_type] = STATE(2151),
    [sym_macro_invocation] = STATE(2151),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(858),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1786),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1788),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_GT] = ACTIONS(4828),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1790),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1792),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1522] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4830),
    [anon_sym_LPAREN] = ACTIONS(4830),
    [anon_sym_RPAREN] = ACTIONS(4830),
    [anon_sym_LBRACE] = ACTIONS(4830),
    [anon_sym_RBRACE] = ACTIONS(4830),
    [anon_sym_RBRACK] = ACTIONS(4830),
    [anon_sym_COLON] = ACTIONS(4832),
    [anon_sym_PLUS] = ACTIONS(4830),
    [anon_sym_COMMA] = ACTIONS(4830),
    [anon_sym_COLON_COLON] = ACTIONS(4830),
    [anon_sym_EQ] = ACTIONS(4830),
    [anon_sym_GT] = ACTIONS(4830),
    [anon_sym_PIPE] = ACTIONS(4830),
    [anon_sym_as] = ACTIONS(4830),
    [anon_sym_for] = ACTIONS(4830),
    [anon_sym_where] = ACTIONS(4830),
    [sym_line_comment] = ACTIONS(7),
  },
  [1523] = {
    [aux_sym_type_arguments_repeat1] = STATE(2155),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(4834),
    [anon_sym_GT] = ACTIONS(4828),
    [sym_line_comment] = ACTIONS(7),
  },
  [1524] = {
    [sym_function_modifiers] = STATE(854),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1664),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(858),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1786),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1788),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1790),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2972),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1525] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4836),
    [anon_sym_LPAREN] = ACTIONS(4836),
    [anon_sym_RPAREN] = ACTIONS(4836),
    [anon_sym_LBRACE] = ACTIONS(4836),
    [anon_sym_RBRACE] = ACTIONS(4836),
    [anon_sym_RBRACK] = ACTIONS(4836),
    [anon_sym_COLON] = ACTIONS(4836),
    [anon_sym_PLUS] = ACTIONS(4836),
    [anon_sym_COMMA] = ACTIONS(4836),
    [anon_sym_EQ] = ACTIONS(4836),
    [anon_sym_GT] = ACTIONS(4836),
    [anon_sym_PIPE] = ACTIONS(4836),
    [anon_sym_as] = ACTIONS(4836),
    [anon_sym_where] = ACTIONS(4836),
    [sym_line_comment] = ACTIONS(7),
  },
  [1526] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4836),
    [anon_sym_LPAREN] = ACTIONS(4836),
    [anon_sym_RPAREN] = ACTIONS(4836),
    [anon_sym_LBRACE] = ACTIONS(4836),
    [anon_sym_RBRACE] = ACTIONS(4836),
    [anon_sym_RBRACK] = ACTIONS(4836),
    [anon_sym_COLON] = ACTIONS(4836),
    [anon_sym_PLUS] = ACTIONS(4836),
    [anon_sym_COMMA] = ACTIONS(4836),
    [anon_sym_EQ] = ACTIONS(4836),
    [anon_sym_GT] = ACTIONS(4836),
    [anon_sym_PIPE] = ACTIONS(4836),
    [anon_sym_as] = ACTIONS(4836),
    [anon_sym_where] = ACTIONS(4836),
    [sym_line_comment] = ACTIONS(7),
  },
  [1527] = {
    [sym_function_modifiers] = STATE(124),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2156),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(127),
    [sym_array_type] = STATE(2156),
    [sym_function_type] = STATE(2156),
    [sym_tuple_type] = STATE(2156),
    [sym_unit_type] = STATE(2156),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2156),
    [sym_reference_type] = STATE(2156),
    [sym_pointer_type] = STATE(2156),
    [sym_empty_type] = STATE(2156),
    [sym_abstract_type] = STATE(2157),
    [sym_dynamic_type] = STATE(2156),
    [sym_macro_invocation] = STATE(2156),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(131),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(197),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(201),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(211),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(217),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1528] = {
    [sym_function_modifiers] = STATE(124),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2158),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(127),
    [sym_array_type] = STATE(2158),
    [sym_function_type] = STATE(2158),
    [sym_tuple_type] = STATE(2158),
    [sym_unit_type] = STATE(2158),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2158),
    [sym_reference_type] = STATE(2158),
    [sym_pointer_type] = STATE(2158),
    [sym_empty_type] = STATE(2158),
    [sym_abstract_type] = STATE(2159),
    [sym_dynamic_type] = STATE(2158),
    [sym_macro_invocation] = STATE(2158),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(131),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(197),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(201),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(211),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(217),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1529] = {
    [sym_function_modifiers] = STATE(867),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(821),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(869),
    [sym_array_type] = STATE(821),
    [sym_function_type] = STATE(821),
    [sym_tuple_type] = STATE(821),
    [sym_unit_type] = STATE(821),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(821),
    [sym_reference_type] = STATE(821),
    [sym_pointer_type] = STATE(821),
    [sym_empty_type] = STATE(821),
    [sym_dynamic_type] = STATE(821),
    [sym_macro_invocation] = STATE(821),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(870),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1806),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1808),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1810),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1530] = {
    [sym_function_modifiers] = STATE(867),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(869),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(870),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1806),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1808),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1810),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1531] = {
    [sym_function_modifiers] = STATE(867),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(869),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(870),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(3010),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1806),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1808),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(4838),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1810),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1532] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(4840),
    [anon_sym_GT] = ACTIONS(1760),
    [sym_line_comment] = ACTIONS(7),
  },
  [1533] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(1794),
    [anon_sym_DASH_GT] = ACTIONS(4842),
    [anon_sym_GT] = ACTIONS(1794),
    [sym_line_comment] = ACTIONS(7),
  },
  [1534] = {
    [sym_parameters] = STATE(2163),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [1535] = {
    [sym_parameters] = STATE(2164),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1536] = {
    [sym_parameters] = STATE(2163),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1537] = {
    [sym_function_modifiers] = STATE(867),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(862),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(870),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1806),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1808),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1810),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1538] = {
    [sym_function_modifiers] = STATE(867),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(869),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(870),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1806),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1808),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1810),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1539] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4844),
    [anon_sym_RPAREN] = ACTIONS(4844),
    [anon_sym_RBRACE] = ACTIONS(4844),
    [anon_sym_COLON] = ACTIONS(4844),
    [anon_sym_COMMA] = ACTIONS(4844),
    [anon_sym_EQ] = ACTIONS(4844),
    [anon_sym_PIPE] = ACTIONS(4844),
    [anon_sym_in] = ACTIONS(4844),
    [sym_line_comment] = ACTIONS(7),
  },
  [1540] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(4846),
    [anon_sym_COMMA] = ACTIONS(4846),
    [sym_line_comment] = ACTIONS(7),
  },
  [1541] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(1540),
    [sym_tuple_pattern] = STATE(1540),
    [sym_tuple_struct_pattern] = STATE(1540),
    [sym_struct_pattern] = STATE(1540),
    [sym_remaining_field_pattern] = STATE(1540),
    [sym_mut_pattern] = STATE(1540),
    [sym_ref_pattern] = STATE(1540),
    [sym_captured_pattern] = STATE(1540),
    [sym_reference_pattern] = STATE(1540),
    [sym__literal] = STATE(1540),
    [sym_string_literal] = STATE(1540),
    [sym_boolean_literal] = STATE(1540),
    [sym_raw_string_literal] = ACTIONS(3018),
    [sym_float_literal] = ACTIONS(3018),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_RPAREN] = ACTIONS(4848),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(817),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(819),
    [anon_sym_ref] = ACTIONS(821),
    [sym_integer_literal] = ACTIONS(3018),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(3018),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(823),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [1542] = {
    [aux_sym_tuple_pattern_repeat1] = STATE(1542),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(4846),
    [anon_sym_COMMA] = ACTIONS(4850),
    [sym_line_comment] = ACTIONS(7),
  },
  [1543] = {
    [sym_function_modifiers] = STATE(883),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(821),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(885),
    [sym_array_type] = STATE(821),
    [sym_function_type] = STATE(821),
    [sym_tuple_type] = STATE(821),
    [sym_unit_type] = STATE(821),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(821),
    [sym_reference_type] = STATE(821),
    [sym_pointer_type] = STATE(821),
    [sym_empty_type] = STATE(821),
    [sym_dynamic_type] = STATE(821),
    [sym_macro_invocation] = STATE(821),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(887),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1838),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1840),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1842),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1844),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1544] = {
    [sym_function_modifiers] = STATE(883),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(885),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(887),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1838),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1840),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1842),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1844),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1545] = {
    [sym_function_modifiers] = STATE(883),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(885),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(887),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(3038),
    [anon_sym_STAR] = ACTIONS(1838),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1840),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1842),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(4853),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1844),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1546] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(1760),
    [anon_sym_COMMA] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(4855),
    [anon_sym_PIPE] = ACTIONS(1760),
    [sym_line_comment] = ACTIONS(7),
  },
  [1547] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(1794),
    [anon_sym_COMMA] = ACTIONS(1794),
    [anon_sym_DASH_GT] = ACTIONS(4857),
    [anon_sym_PIPE] = ACTIONS(1794),
    [sym_line_comment] = ACTIONS(7),
  },
  [1548] = {
    [sym_parameters] = STATE(2170),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [1549] = {
    [sym_parameters] = STATE(2171),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1550] = {
    [sym_parameters] = STATE(2170),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1551] = {
    [sym_function_modifiers] = STATE(883),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(862),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(887),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1838),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1840),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1842),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1844),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1552] = {
    [sym_function_modifiers] = STATE(883),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(885),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(887),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1838),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1840),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1842),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1844),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1553] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(4859),
    [anon_sym_COLON] = ACTIONS(4859),
    [anon_sym_COMMA] = ACTIONS(4859),
    [anon_sym_PIPE] = ACTIONS(4859),
    [sym_line_comment] = ACTIONS(7),
  },
  [1554] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(898),
    [sym_tuple_pattern] = STATE(898),
    [sym_tuple_pattern_in_parameter] = STATE(899),
    [sym_tuple_struct_pattern] = STATE(898),
    [sym_struct_pattern] = STATE(898),
    [sym_remaining_field_pattern] = STATE(898),
    [sym_mut_pattern] = STATE(898),
    [sym_ref_pattern] = STATE(898),
    [sym_captured_pattern] = STATE(898),
    [sym_reference_pattern] = STATE(898),
    [sym__literal] = STATE(898),
    [sym_string_literal] = STATE(898),
    [sym_boolean_literal] = STATE(898),
    [sym_raw_string_literal] = ACTIONS(1858),
    [sym_float_literal] = ACTIONS(1858),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(835),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(1860),
    [anon_sym_AMP] = ACTIONS(817),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(819),
    [anon_sym_ref] = ACTIONS(821),
    [sym_integer_literal] = ACTIONS(1858),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1858),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4861),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [1555] = {
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(881),
    [anon_sym_RPAREN] = ACTIONS(1866),
    [anon_sym_LBRACE] = ACTIONS(883),
    [anon_sym_COMMA] = ACTIONS(1866),
    [anon_sym_COLON_COLON] = ACTIONS(887),
    [anon_sym_AT] = ACTIONS(1834),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1556] = {
    [sym_ref_pattern] = STATE(2174),
    [sym_reference_pattern_in_parameter] = STATE(2174),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(4863),
    [anon_sym_AMP] = ACTIONS(2936),
    [anon_sym_ref] = ACTIONS(821),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4865),
  },
  [1557] = {
    [aux_sym_tuple_pattern_in_parameter_repeat1] = STATE(2176),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(4863),
    [anon_sym_COMMA] = ACTIONS(4867),
    [sym_line_comment] = ACTIONS(7),
  },
  [1558] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(3034),
    [anon_sym_COMMA] = ACTIONS(4869),
    [anon_sym_PIPE] = ACTIONS(4869),
    [sym_line_comment] = ACTIONS(7),
  },
  [1559] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(4869),
    [anon_sym_COMMA] = ACTIONS(4869),
    [anon_sym_PIPE] = ACTIONS(4869),
    [sym_line_comment] = ACTIONS(7),
  },
  [1560] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(3034),
    [anon_sym_COMMA] = ACTIONS(4871),
    [anon_sym_PIPE] = ACTIONS(4871),
    [sym_line_comment] = ACTIONS(7),
  },
  [1561] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(4871),
    [anon_sym_COMMA] = ACTIONS(4871),
    [anon_sym_PIPE] = ACTIONS(4871),
    [sym_line_comment] = ACTIONS(7),
  },
  [1562] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(3042),
    [anon_sym_COMMA] = ACTIONS(1828),
    [anon_sym_PIPE] = ACTIONS(1828),
    [sym_line_comment] = ACTIONS(7),
  },
  [1563] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(4873),
    [sym_line_comment] = ACTIONS(7),
  },
  [1564] = {
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(883),
    [anon_sym_COLON] = ACTIONS(3052),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_COLON_COLON] = ACTIONS(887),
    [anon_sym_AT] = ACTIONS(889),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_PIPE] = ACTIONS(831),
    [sym_line_comment] = ACTIONS(7),
  },
  [1565] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4875),
    [anon_sym_RPAREN] = ACTIONS(4875),
    [anon_sym_RBRACE] = ACTIONS(4875),
    [anon_sym_COLON] = ACTIONS(4875),
    [anon_sym_COMMA] = ACTIONS(4875),
    [anon_sym_EQ] = ACTIONS(4875),
    [anon_sym_PIPE] = ACTIONS(4875),
    [anon_sym_in] = ACTIONS(4875),
    [sym_line_comment] = ACTIONS(7),
  },
  [1566] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(1540),
    [sym_tuple_pattern] = STATE(1540),
    [sym_tuple_struct_pattern] = STATE(1540),
    [sym_struct_pattern] = STATE(1540),
    [sym_remaining_field_pattern] = STATE(1540),
    [sym_mut_pattern] = STATE(1540),
    [sym_ref_pattern] = STATE(1540),
    [sym_captured_pattern] = STATE(1540),
    [sym_reference_pattern] = STATE(1540),
    [sym__literal] = STATE(1540),
    [sym_string_literal] = STATE(1540),
    [sym_boolean_literal] = STATE(1540),
    [sym_raw_string_literal] = ACTIONS(3018),
    [sym_float_literal] = ACTIONS(3018),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_RPAREN] = ACTIONS(4877),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(817),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(819),
    [anon_sym_ref] = ACTIONS(821),
    [sym_integer_literal] = ACTIONS(3018),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(3018),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(823),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [1567] = {
    [aux_sym_tuple_pattern_repeat1] = STATE(1542),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(4877),
    [anon_sym_COMMA] = ACTIONS(4879),
    [sym_line_comment] = ACTIONS(7),
  },
  [1568] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4881),
    [anon_sym_RPAREN] = ACTIONS(4881),
    [anon_sym_RBRACE] = ACTIONS(4881),
    [anon_sym_COLON] = ACTIONS(4881),
    [anon_sym_COMMA] = ACTIONS(4881),
    [anon_sym_EQ] = ACTIONS(4881),
    [anon_sym_PIPE] = ACTIONS(4881),
    [anon_sym_in] = ACTIONS(4881),
    [sym_line_comment] = ACTIONS(7),
  },
  [1569] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(4883),
    [anon_sym_COLON] = ACTIONS(4885),
    [anon_sym_COMMA] = ACTIONS(4883),
    [sym_line_comment] = ACTIONS(7),
  },
  [1570] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4887),
  },
  [1571] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(2186),
    [sym_tuple_pattern] = STATE(2186),
    [sym_tuple_struct_pattern] = STATE(2186),
    [sym_struct_pattern] = STATE(2186),
    [sym_remaining_field_pattern] = STATE(2186),
    [sym_mut_pattern] = STATE(2186),
    [sym_ref_pattern] = STATE(2186),
    [sym_captured_pattern] = STATE(2186),
    [sym_reference_pattern] = STATE(2186),
    [sym__literal] = STATE(2186),
    [sym_string_literal] = STATE(2186),
    [sym_boolean_literal] = STATE(2186),
    [sym_raw_string_literal] = ACTIONS(4889),
    [sym_float_literal] = ACTIONS(4889),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(4891),
    [anon_sym_AMP] = ACTIONS(4893),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(4895),
    [anon_sym_ref] = ACTIONS(4897),
    [sym_integer_literal] = ACTIONS(4889),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4889),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4899),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [1572] = {
    [sym_field_pattern] = STATE(2188),
    [sym_remaining_field_pattern] = STATE(2188),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(4901),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(1902),
    [anon_sym_ref] = ACTIONS(1904),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1906),
  },
  [1573] = {
    [aux_sym_struct_pattern_repeat1] = STATE(2190),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(4901),
    [anon_sym_COMMA] = ACTIONS(4903),
    [sym_line_comment] = ACTIONS(7),
  },
  [1574] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4905),
    [anon_sym_RPAREN] = ACTIONS(4905),
    [anon_sym_RBRACE] = ACTIONS(4905),
    [anon_sym_COLON] = ACTIONS(4905),
    [anon_sym_COMMA] = ACTIONS(4905),
    [anon_sym_EQ] = ACTIONS(4905),
    [anon_sym_PIPE] = ACTIONS(4905),
    [anon_sym_in] = ACTIONS(4905),
    [sym_line_comment] = ACTIONS(7),
  },
  [1575] = {
    [sym_field_pattern] = STATE(2188),
    [sym_remaining_field_pattern] = STATE(2188),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(4907),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(1902),
    [anon_sym_ref] = ACTIONS(1904),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1906),
  },
  [1576] = {
    [aux_sym_struct_pattern_repeat1] = STATE(2190),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(4907),
    [anon_sym_COMMA] = ACTIONS(4909),
    [sym_line_comment] = ACTIONS(7),
  },
  [1577] = {
    [sym_function_modifiers] = STATE(929),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(821),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(931),
    [sym_array_type] = STATE(821),
    [sym_function_type] = STATE(821),
    [sym_tuple_type] = STATE(821),
    [sym_unit_type] = STATE(821),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(821),
    [sym_reference_type] = STATE(821),
    [sym_pointer_type] = STATE(821),
    [sym_empty_type] = STATE(821),
    [sym_dynamic_type] = STATE(821),
    [sym_macro_invocation] = STATE(821),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(932),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1928),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1930),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1932),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1934),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1578] = {
    [sym_function_modifiers] = STATE(929),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(931),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(932),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1928),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1930),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1932),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1934),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1579] = {
    [sym_function_modifiers] = STATE(929),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(931),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(932),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_STAR] = ACTIONS(1928),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1930),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1932),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(4911),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1934),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1580] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(4913),
    [anon_sym_EQ] = ACTIONS(1760),
    [sym_line_comment] = ACTIONS(7),
  },
  [1581] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(1794),
    [anon_sym_DASH_GT] = ACTIONS(4915),
    [anon_sym_EQ] = ACTIONS(1794),
    [sym_line_comment] = ACTIONS(7),
  },
  [1582] = {
    [sym_parameters] = STATE(2196),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [1583] = {
    [sym_parameters] = STATE(2197),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1584] = {
    [sym_parameters] = STATE(2196),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1585] = {
    [sym_function_modifiers] = STATE(929),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(862),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(932),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1928),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1930),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1932),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1934),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1586] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2198),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2198),
    [sym_macro_invocation] = STATE(2198),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2198),
    [sym_unary_expression] = STATE(2198),
    [sym_try_expression] = STATE(2198),
    [sym_reference_expression] = STATE(2198),
    [sym_binary_expression] = STATE(2198),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2198),
    [sym_call_expression] = STATE(2198),
    [sym_array_expression] = STATE(2198),
    [sym_parenthesized_expression] = STATE(2198),
    [sym_tuple_expression] = STATE(2198),
    [sym_unit_expression] = STATE(2198),
    [sym_struct_expression] = STATE(2198),
    [sym_if_expression] = STATE(2198),
    [sym_if_let_expression] = STATE(2198),
    [sym_match_expression] = STATE(2198),
    [sym_while_expression] = STATE(2198),
    [sym_while_let_expression] = STATE(2198),
    [sym_loop_expression] = STATE(2198),
    [sym_for_expression] = STATE(2198),
    [sym_closure_expression] = STATE(2198),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2198),
    [sym_continue_expression] = STATE(2198),
    [sym_index_expression] = STATE(2198),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2198),
    [sym_block] = STATE(2198),
    [sym__literal] = STATE(2198),
    [sym_string_literal] = STATE(2198),
    [sym_boolean_literal] = STATE(2198),
    [sym_raw_string_literal] = ACTIONS(4917),
    [sym_float_literal] = ACTIONS(4917),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(4917),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4917),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1587] = {
    [sym_function_modifiers] = STATE(929),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(931),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(932),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1928),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1930),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1932),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1934),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1588] = {
    [sym_raw_string_literal] = ACTIONS(4919),
    [sym_float_literal] = ACTIONS(4919),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(4919),
    [anon_sym_SEMI] = ACTIONS(4919),
    [anon_sym_macro_rules_BANG] = ACTIONS(4919),
    [anon_sym_LPAREN] = ACTIONS(4919),
    [anon_sym_LBRACE] = ACTIONS(4919),
    [anon_sym_RBRACE] = ACTIONS(4919),
    [anon_sym_LBRACK] = ACTIONS(4919),
    [anon_sym_STAR] = ACTIONS(4919),
    [anon_sym_u8] = ACTIONS(4921),
    [anon_sym_i8] = ACTIONS(4921),
    [anon_sym_u16] = ACTIONS(4921),
    [anon_sym_i16] = ACTIONS(4921),
    [anon_sym_u32] = ACTIONS(4921),
    [anon_sym_i32] = ACTIONS(4921),
    [anon_sym_u64] = ACTIONS(4921),
    [anon_sym_i64] = ACTIONS(4921),
    [anon_sym_u128] = ACTIONS(4921),
    [anon_sym_i128] = ACTIONS(4921),
    [anon_sym_isize] = ACTIONS(4921),
    [anon_sym_usize] = ACTIONS(4921),
    [anon_sym_f32] = ACTIONS(4921),
    [anon_sym_f64] = ACTIONS(4921),
    [anon_sym_bool] = ACTIONS(4921),
    [anon_sym_str] = ACTIONS(4921),
    [anon_sym_char] = ACTIONS(4921),
    [anon_sym_AMP] = ACTIONS(4919),
    [anon_sym_DASH] = ACTIONS(4919),
    [anon_sym_COLON_COLON] = ACTIONS(4919),
    [anon_sym_BANG] = ACTIONS(4919),
    [anon_sym_POUND] = ACTIONS(4919),
    [anon_sym_LT] = ACTIONS(4919),
    [anon_sym_PIPE] = ACTIONS(4919),
    [anon_sym_SQUOTE] = ACTIONS(4921),
    [anon_sym_DOT_DOT] = ACTIONS(4919),
    [anon_sym_break] = ACTIONS(4921),
    [anon_sym_const] = ACTIONS(4921),
    [anon_sym_continue] = ACTIONS(4921),
    [anon_sym_default] = ACTIONS(4921),
    [anon_sym_enum] = ACTIONS(4921),
    [anon_sym_fn] = ACTIONS(4921),
    [anon_sym_for] = ACTIONS(4921),
    [anon_sym_if] = ACTIONS(4921),
    [anon_sym_impl] = ACTIONS(4921),
    [anon_sym_let] = ACTIONS(4921),
    [anon_sym_loop] = ACTIONS(4921),
    [anon_sym_match] = ACTIONS(4921),
    [anon_sym_mod] = ACTIONS(4921),
    [anon_sym_pub] = ACTIONS(4921),
    [anon_sym_return] = ACTIONS(4921),
    [anon_sym_static] = ACTIONS(4921),
    [anon_sym_struct] = ACTIONS(4921),
    [anon_sym_trait] = ACTIONS(4921),
    [anon_sym_type] = ACTIONS(4921),
    [anon_sym_union] = ACTIONS(4921),
    [anon_sym_unsafe] = ACTIONS(4921),
    [anon_sym_use] = ACTIONS(4921),
    [anon_sym_while] = ACTIONS(4921),
    [anon_sym_extern] = ACTIONS(4921),
    [anon_sym_move] = ACTIONS(4921),
    [sym_integer_literal] = ACTIONS(4919),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(4919),
    [sym_char_literal] = ACTIONS(4919),
    [anon_sym_true] = ACTIONS(4921),
    [anon_sym_false] = ACTIONS(4921),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4921),
    [sym_self] = ACTIONS(4921),
    [sym_super] = ACTIONS(4921),
    [sym_crate] = ACTIONS(4921),
    [sym_metavariable] = ACTIONS(4919),
  },
  [1589] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_in] = ACTIONS(4923),
    [sym_line_comment] = ACTIONS(7),
    [sym_self] = ACTIONS(4925),
    [sym_super] = ACTIONS(4925),
    [sym_crate] = ACTIONS(4925),
  },
  [1590] = {
    [sym_attribute_item] = STATE(2204),
    [sym_field_declaration] = STATE(2203),
    [sym_visibility_modifier] = STATE(1069),
    [aux_sym_enum_variant_list_repeat1] = STATE(2204),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(4927),
    [anon_sym_COMMA] = ACTIONS(4929),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_pub] = ACTIONS(1940),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2132),
  },
  [1591] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2205),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2205),
    [sym_macro_invocation] = STATE(2205),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2205),
    [sym_unary_expression] = STATE(2205),
    [sym_try_expression] = STATE(2205),
    [sym_reference_expression] = STATE(2205),
    [sym_binary_expression] = STATE(2205),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2205),
    [sym_call_expression] = STATE(2205),
    [sym_array_expression] = STATE(2205),
    [sym_parenthesized_expression] = STATE(2205),
    [sym_tuple_expression] = STATE(2205),
    [sym_unit_expression] = STATE(2205),
    [sym_struct_expression] = STATE(2205),
    [sym_if_expression] = STATE(2205),
    [sym_if_let_expression] = STATE(2205),
    [sym_match_expression] = STATE(2205),
    [sym_while_expression] = STATE(2205),
    [sym_while_let_expression] = STATE(2205),
    [sym_loop_expression] = STATE(2205),
    [sym_for_expression] = STATE(2205),
    [sym_closure_expression] = STATE(2205),
    [sym_closure_parameters] = STATE(1138),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2205),
    [sym_continue_expression] = STATE(2205),
    [sym_index_expression] = STATE(2205),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2205),
    [sym_block] = STATE(2205),
    [sym__literal] = STATE(2205),
    [sym_string_literal] = STATE(2205),
    [sym_boolean_literal] = STATE(2205),
    [sym_raw_string_literal] = ACTIONS(4931),
    [sym_float_literal] = ACTIONS(4931),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(2245),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(2247),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(2249),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(2251),
    [sym_integer_literal] = ACTIONS(4931),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4931),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1592] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(4933),
    [anon_sym_COMMA] = ACTIONS(4933),
    [anon_sym_EQ] = ACTIONS(4935),
    [sym_line_comment] = ACTIONS(7),
  },
  [1593] = {
    [sym_attribute_item] = STATE(2209),
    [sym_enum_variant] = STATE(2208),
    [sym_visibility_modifier] = STATE(938),
    [aux_sym_enum_variant_list_repeat1] = STATE(2209),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(4937),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_pub] = ACTIONS(1940),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1942),
  },
  [1594] = {
    [aux_sym_enum_variant_list_repeat2] = STATE(2211),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(4937),
    [anon_sym_COMMA] = ACTIONS(4939),
    [sym_line_comment] = ACTIONS(7),
  },
  [1595] = {
    [sym_field_declaration_list] = STATE(2212),
    [sym_ordered_field_declaration_list] = STATE(2212),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(3125),
    [anon_sym_RBRACE] = ACTIONS(4933),
    [anon_sym_COMMA] = ACTIONS(4933),
    [anon_sym_EQ] = ACTIONS(4935),
    [sym_line_comment] = ACTIONS(7),
  },
  [1596] = {
    [aux_sym_enum_variant_list_repeat2] = STATE(2213),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(4937),
    [anon_sym_COMMA] = ACTIONS(4939),
    [sym_line_comment] = ACTIONS(7),
  },
  [1597] = {
    [sym_attribute_item] = STATE(1597),
    [aux_sym_enum_variant_list_repeat1] = STATE(1597),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(3545),
    [anon_sym_pub] = ACTIONS(4941),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4941),
  },
  [1598] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(4943),
    [sym_mutable_specifier] = ACTIONS(4943),
    [sym_line_comment] = ACTIONS(7),
  },
  [1599] = {
    [sym_function_modifiers] = STATE(1603),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(385),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2216),
    [sym_array_type] = STATE(385),
    [sym_function_type] = STATE(385),
    [sym_tuple_type] = STATE(385),
    [sym_unit_type] = STATE(385),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(385),
    [sym_reference_type] = STATE(385),
    [sym_pointer_type] = STATE(385),
    [sym_empty_type] = STATE(385),
    [sym_dynamic_type] = STATE(385),
    [sym_macro_invocation] = STATE(385),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1606),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3135),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3137),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3139),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(4945),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3143),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1600] = {
    [sym_parameters] = STATE(2217),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [1601] = {
    [sym_function_modifiers] = STATE(1603),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2218),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2219),
    [sym_array_type] = STATE(2218),
    [sym_function_type] = STATE(2218),
    [sym_tuple_type] = STATE(2218),
    [sym_unit_type] = STATE(2218),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2218),
    [sym_reference_type] = STATE(2218),
    [sym_pointer_type] = STATE(2218),
    [sym_empty_type] = STATE(2218),
    [sym_dynamic_type] = STATE(2218),
    [sym_macro_invocation] = STATE(2218),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1606),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3135),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3137),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3139),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3143),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1602] = {
    [sym_parameters] = STATE(2220),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_BANG] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1603] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2223),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_fn] = ACTIONS(4947),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4949),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [1604] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1724),
    [anon_sym_PLUS] = ACTIONS(4951),
    [sym_line_comment] = ACTIONS(7),
  },
  [1605] = {
    [sym_function_modifiers] = STATE(1603),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2218),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2219),
    [sym_array_type] = STATE(2218),
    [sym_function_type] = STATE(2218),
    [sym_tuple_type] = STATE(2218),
    [sym_unit_type] = STATE(2218),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2218),
    [sym_reference_type] = STATE(2218),
    [sym_pointer_type] = STATE(2218),
    [sym_empty_type] = STATE(2218),
    [sym_dynamic_type] = STATE(2218),
    [sym_macro_invocation] = STATE(2218),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1606),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(4953),
    [anon_sym_STAR] = ACTIONS(3135),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3137),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3139),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(4955),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3143),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1606] = {
    [sym_parameters] = STATE(2217),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_COLON] = ACTIONS(783),
    [anon_sym_PLUS] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1607] = {
    [sym_function_modifiers] = STATE(2233),
    [sym_higher_ranked_trait_bound] = STATE(2234),
    [sym_removed_trait_bound] = STATE(2234),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2235),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2235),
    [sym_array_type] = STATE(2235),
    [sym_function_type] = STATE(2235),
    [sym_tuple_type] = STATE(2235),
    [sym_unit_type] = STATE(2235),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2235),
    [sym_reference_type] = STATE(2235),
    [sym_pointer_type] = STATE(2235),
    [sym_empty_type] = STATE(2235),
    [sym_dynamic_type] = STATE(2235),
    [sym_macro_invocation] = STATE(2235),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2236),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(4957),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(4959),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_QMARK] = ACTIONS(4961),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4963),
    [anon_sym_for] = ACTIONS(4965),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4967),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1608] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4969),
    [anon_sym_LPAREN] = ACTIONS(4969),
    [anon_sym_LBRACE] = ACTIONS(4969),
    [anon_sym_COMMA] = ACTIONS(4969),
    [sym_line_comment] = ACTIONS(7),
  },
  [1609] = {
    [sym_where_predicate] = STATE(2237),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(945),
    [sym_generic_type] = STATE(946),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_reference_type] = STATE(945),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(947),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(4971),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(1948),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1950),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [1610] = {
    [aux_sym_where_clause_repeat1] = STATE(2239),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(4971),
    [anon_sym_COMMA] = ACTIONS(4973),
    [sym_line_comment] = ACTIONS(7),
  },
  [1611] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4975),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [anon_sym_LBRACE] = ACTIONS(4975),
    [anon_sym_COMMA] = ACTIONS(4975),
    [sym_line_comment] = ACTIONS(7),
  },
  [1612] = {
    [sym_raw_string_literal] = ACTIONS(4977),
    [sym_float_literal] = ACTIONS(4977),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(4977),
    [anon_sym_SEMI] = ACTIONS(4977),
    [anon_sym_macro_rules_BANG] = ACTIONS(4977),
    [anon_sym_LPAREN] = ACTIONS(4977),
    [anon_sym_LBRACE] = ACTIONS(4977),
    [anon_sym_RBRACE] = ACTIONS(4977),
    [anon_sym_LBRACK] = ACTIONS(4977),
    [anon_sym_STAR] = ACTIONS(4977),
    [anon_sym_u8] = ACTIONS(4979),
    [anon_sym_i8] = ACTIONS(4979),
    [anon_sym_u16] = ACTIONS(4979),
    [anon_sym_i16] = ACTIONS(4979),
    [anon_sym_u32] = ACTIONS(4979),
    [anon_sym_i32] = ACTIONS(4979),
    [anon_sym_u64] = ACTIONS(4979),
    [anon_sym_i64] = ACTIONS(4979),
    [anon_sym_u128] = ACTIONS(4979),
    [anon_sym_i128] = ACTIONS(4979),
    [anon_sym_isize] = ACTIONS(4979),
    [anon_sym_usize] = ACTIONS(4979),
    [anon_sym_f32] = ACTIONS(4979),
    [anon_sym_f64] = ACTIONS(4979),
    [anon_sym_bool] = ACTIONS(4979),
    [anon_sym_str] = ACTIONS(4979),
    [anon_sym_char] = ACTIONS(4979),
    [anon_sym_AMP] = ACTIONS(4977),
    [anon_sym_DASH] = ACTIONS(4977),
    [anon_sym_COLON_COLON] = ACTIONS(4977),
    [anon_sym_BANG] = ACTIONS(4977),
    [anon_sym_POUND] = ACTIONS(4977),
    [anon_sym_LT] = ACTIONS(4977),
    [anon_sym_PIPE] = ACTIONS(4977),
    [anon_sym_SQUOTE] = ACTIONS(4979),
    [anon_sym_DOT_DOT] = ACTIONS(4977),
    [anon_sym_break] = ACTIONS(4979),
    [anon_sym_const] = ACTIONS(4979),
    [anon_sym_continue] = ACTIONS(4979),
    [anon_sym_default] = ACTIONS(4979),
    [anon_sym_enum] = ACTIONS(4979),
    [anon_sym_fn] = ACTIONS(4979),
    [anon_sym_for] = ACTIONS(4979),
    [anon_sym_if] = ACTIONS(4979),
    [anon_sym_impl] = ACTIONS(4979),
    [anon_sym_let] = ACTIONS(4979),
    [anon_sym_loop] = ACTIONS(4979),
    [anon_sym_match] = ACTIONS(4979),
    [anon_sym_mod] = ACTIONS(4979),
    [anon_sym_pub] = ACTIONS(4979),
    [anon_sym_return] = ACTIONS(4979),
    [anon_sym_static] = ACTIONS(4979),
    [anon_sym_struct] = ACTIONS(4979),
    [anon_sym_trait] = ACTIONS(4979),
    [anon_sym_type] = ACTIONS(4979),
    [anon_sym_union] = ACTIONS(4979),
    [anon_sym_unsafe] = ACTIONS(4979),
    [anon_sym_use] = ACTIONS(4979),
    [anon_sym_while] = ACTIONS(4979),
    [anon_sym_extern] = ACTIONS(4979),
    [anon_sym_move] = ACTIONS(4979),
    [sym_integer_literal] = ACTIONS(4977),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(4977),
    [sym_char_literal] = ACTIONS(4977),
    [anon_sym_true] = ACTIONS(4979),
    [anon_sym_false] = ACTIONS(4979),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4979),
    [sym_self] = ACTIONS(4979),
    [sym_super] = ACTIONS(4979),
    [sym_crate] = ACTIONS(4979),
    [sym_metavariable] = ACTIONS(4977),
  },
  [1613] = {
    [sym_raw_string_literal] = ACTIONS(4981),
    [sym_float_literal] = ACTIONS(4981),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(4981),
    [anon_sym_SEMI] = ACTIONS(4981),
    [anon_sym_macro_rules_BANG] = ACTIONS(4981),
    [anon_sym_LPAREN] = ACTIONS(4981),
    [anon_sym_LBRACE] = ACTIONS(4981),
    [anon_sym_RBRACE] = ACTIONS(4981),
    [anon_sym_LBRACK] = ACTIONS(4981),
    [anon_sym_STAR] = ACTIONS(4981),
    [anon_sym_u8] = ACTIONS(4983),
    [anon_sym_i8] = ACTIONS(4983),
    [anon_sym_u16] = ACTIONS(4983),
    [anon_sym_i16] = ACTIONS(4983),
    [anon_sym_u32] = ACTIONS(4983),
    [anon_sym_i32] = ACTIONS(4983),
    [anon_sym_u64] = ACTIONS(4983),
    [anon_sym_i64] = ACTIONS(4983),
    [anon_sym_u128] = ACTIONS(4983),
    [anon_sym_i128] = ACTIONS(4983),
    [anon_sym_isize] = ACTIONS(4983),
    [anon_sym_usize] = ACTIONS(4983),
    [anon_sym_f32] = ACTIONS(4983),
    [anon_sym_f64] = ACTIONS(4983),
    [anon_sym_bool] = ACTIONS(4983),
    [anon_sym_str] = ACTIONS(4983),
    [anon_sym_char] = ACTIONS(4983),
    [anon_sym_AMP] = ACTIONS(4981),
    [anon_sym_DASH] = ACTIONS(4981),
    [anon_sym_COLON_COLON] = ACTIONS(4981),
    [anon_sym_BANG] = ACTIONS(4981),
    [anon_sym_POUND] = ACTIONS(4981),
    [anon_sym_LT] = ACTIONS(4981),
    [anon_sym_PIPE] = ACTIONS(4981),
    [anon_sym_SQUOTE] = ACTIONS(4983),
    [anon_sym_DOT_DOT] = ACTIONS(4981),
    [anon_sym_break] = ACTIONS(4983),
    [anon_sym_const] = ACTIONS(4983),
    [anon_sym_continue] = ACTIONS(4983),
    [anon_sym_default] = ACTIONS(4983),
    [anon_sym_enum] = ACTIONS(4983),
    [anon_sym_fn] = ACTIONS(4983),
    [anon_sym_for] = ACTIONS(4983),
    [anon_sym_if] = ACTIONS(4983),
    [anon_sym_impl] = ACTIONS(4983),
    [anon_sym_let] = ACTIONS(4983),
    [anon_sym_loop] = ACTIONS(4983),
    [anon_sym_match] = ACTIONS(4983),
    [anon_sym_mod] = ACTIONS(4983),
    [anon_sym_pub] = ACTIONS(4983),
    [anon_sym_return] = ACTIONS(4983),
    [anon_sym_static] = ACTIONS(4983),
    [anon_sym_struct] = ACTIONS(4983),
    [anon_sym_trait] = ACTIONS(4983),
    [anon_sym_type] = ACTIONS(4983),
    [anon_sym_union] = ACTIONS(4983),
    [anon_sym_unsafe] = ACTIONS(4983),
    [anon_sym_use] = ACTIONS(4983),
    [anon_sym_while] = ACTIONS(4983),
    [anon_sym_extern] = ACTIONS(4983),
    [anon_sym_move] = ACTIONS(4983),
    [sym_integer_literal] = ACTIONS(4981),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(4981),
    [sym_char_literal] = ACTIONS(4981),
    [anon_sym_true] = ACTIONS(4983),
    [anon_sym_false] = ACTIONS(4983),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4983),
    [sym_self] = ACTIONS(4983),
    [sym_super] = ACTIONS(4983),
    [sym_crate] = ACTIONS(4983),
    [sym_metavariable] = ACTIONS(4981),
  },
  [1614] = {
    [sym_function_modifiers] = STATE(1624),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2240),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1626),
    [sym_array_type] = STATE(2240),
    [sym_function_type] = STATE(2240),
    [sym_tuple_type] = STATE(2240),
    [sym_unit_type] = STATE(2240),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2240),
    [sym_reference_type] = STATE(2240),
    [sym_pointer_type] = STATE(2240),
    [sym_empty_type] = STATE(2240),
    [sym_abstract_type] = STATE(2241),
    [sym_dynamic_type] = STATE(2240),
    [sym_macro_invocation] = STATE(2240),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1628),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3169),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3171),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3173),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3175),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1615] = {
    [sym_block] = STATE(2243),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4985),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [sym_line_comment] = ACTIONS(7),
  },
  [1616] = {
    [sym_raw_string_literal] = ACTIONS(4987),
    [sym_float_literal] = ACTIONS(4987),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(4987),
    [anon_sym_SEMI] = ACTIONS(4987),
    [anon_sym_macro_rules_BANG] = ACTIONS(4987),
    [anon_sym_LPAREN] = ACTIONS(4987),
    [anon_sym_LBRACE] = ACTIONS(4987),
    [anon_sym_RBRACE] = ACTIONS(4987),
    [anon_sym_LBRACK] = ACTIONS(4987),
    [anon_sym_STAR] = ACTIONS(4987),
    [anon_sym_u8] = ACTIONS(4989),
    [anon_sym_i8] = ACTIONS(4989),
    [anon_sym_u16] = ACTIONS(4989),
    [anon_sym_i16] = ACTIONS(4989),
    [anon_sym_u32] = ACTIONS(4989),
    [anon_sym_i32] = ACTIONS(4989),
    [anon_sym_u64] = ACTIONS(4989),
    [anon_sym_i64] = ACTIONS(4989),
    [anon_sym_u128] = ACTIONS(4989),
    [anon_sym_i128] = ACTIONS(4989),
    [anon_sym_isize] = ACTIONS(4989),
    [anon_sym_usize] = ACTIONS(4989),
    [anon_sym_f32] = ACTIONS(4989),
    [anon_sym_f64] = ACTIONS(4989),
    [anon_sym_bool] = ACTIONS(4989),
    [anon_sym_str] = ACTIONS(4989),
    [anon_sym_char] = ACTIONS(4989),
    [anon_sym_AMP] = ACTIONS(4987),
    [anon_sym_DASH] = ACTIONS(4987),
    [anon_sym_COLON_COLON] = ACTIONS(4987),
    [anon_sym_BANG] = ACTIONS(4987),
    [anon_sym_POUND] = ACTIONS(4987),
    [anon_sym_LT] = ACTIONS(4987),
    [anon_sym_PIPE] = ACTIONS(4987),
    [anon_sym_SQUOTE] = ACTIONS(4989),
    [anon_sym_DOT_DOT] = ACTIONS(4987),
    [anon_sym_break] = ACTIONS(4989),
    [anon_sym_const] = ACTIONS(4989),
    [anon_sym_continue] = ACTIONS(4989),
    [anon_sym_default] = ACTIONS(4989),
    [anon_sym_enum] = ACTIONS(4989),
    [anon_sym_fn] = ACTIONS(4989),
    [anon_sym_for] = ACTIONS(4989),
    [anon_sym_if] = ACTIONS(4989),
    [anon_sym_impl] = ACTIONS(4989),
    [anon_sym_let] = ACTIONS(4989),
    [anon_sym_loop] = ACTIONS(4989),
    [anon_sym_match] = ACTIONS(4989),
    [anon_sym_mod] = ACTIONS(4989),
    [anon_sym_pub] = ACTIONS(4989),
    [anon_sym_return] = ACTIONS(4989),
    [anon_sym_static] = ACTIONS(4989),
    [anon_sym_struct] = ACTIONS(4989),
    [anon_sym_trait] = ACTIONS(4989),
    [anon_sym_type] = ACTIONS(4989),
    [anon_sym_union] = ACTIONS(4989),
    [anon_sym_unsafe] = ACTIONS(4989),
    [anon_sym_use] = ACTIONS(4989),
    [anon_sym_while] = ACTIONS(4989),
    [anon_sym_extern] = ACTIONS(4989),
    [anon_sym_move] = ACTIONS(4989),
    [sym_integer_literal] = ACTIONS(4987),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(4987),
    [sym_char_literal] = ACTIONS(4987),
    [anon_sym_true] = ACTIONS(4989),
    [anon_sym_false] = ACTIONS(4989),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4989),
    [sym_self] = ACTIONS(4989),
    [sym_super] = ACTIONS(4989),
    [sym_crate] = ACTIONS(4989),
    [sym_metavariable] = ACTIONS(4987),
  },
  [1617] = {
    [sym_raw_string_literal] = ACTIONS(597),
    [sym_float_literal] = ACTIONS(597),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(597),
    [anon_sym_SEMI] = ACTIONS(597),
    [anon_sym_macro_rules_BANG] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(597),
    [anon_sym_RBRACE] = ACTIONS(597),
    [anon_sym_LBRACK] = ACTIONS(597),
    [anon_sym_STAR] = ACTIONS(597),
    [anon_sym_u8] = ACTIONS(599),
    [anon_sym_i8] = ACTIONS(599),
    [anon_sym_u16] = ACTIONS(599),
    [anon_sym_i16] = ACTIONS(599),
    [anon_sym_u32] = ACTIONS(599),
    [anon_sym_i32] = ACTIONS(599),
    [anon_sym_u64] = ACTIONS(599),
    [anon_sym_i64] = ACTIONS(599),
    [anon_sym_u128] = ACTIONS(599),
    [anon_sym_i128] = ACTIONS(599),
    [anon_sym_isize] = ACTIONS(599),
    [anon_sym_usize] = ACTIONS(599),
    [anon_sym_f32] = ACTIONS(599),
    [anon_sym_f64] = ACTIONS(599),
    [anon_sym_bool] = ACTIONS(599),
    [anon_sym_str] = ACTIONS(599),
    [anon_sym_char] = ACTIONS(599),
    [anon_sym_AMP] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_COLON_COLON] = ACTIONS(597),
    [anon_sym_BANG] = ACTIONS(597),
    [anon_sym_POUND] = ACTIONS(597),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_PIPE] = ACTIONS(597),
    [anon_sym_SQUOTE] = ACTIONS(599),
    [anon_sym_DOT_DOT] = ACTIONS(597),
    [anon_sym_break] = ACTIONS(599),
    [anon_sym_const] = ACTIONS(599),
    [anon_sym_continue] = ACTIONS(599),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_enum] = ACTIONS(599),
    [anon_sym_fn] = ACTIONS(599),
    [anon_sym_for] = ACTIONS(599),
    [anon_sym_if] = ACTIONS(599),
    [anon_sym_impl] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(599),
    [anon_sym_loop] = ACTIONS(599),
    [anon_sym_match] = ACTIONS(599),
    [anon_sym_mod] = ACTIONS(599),
    [anon_sym_pub] = ACTIONS(599),
    [anon_sym_return] = ACTIONS(599),
    [anon_sym_static] = ACTIONS(599),
    [anon_sym_struct] = ACTIONS(599),
    [anon_sym_trait] = ACTIONS(599),
    [anon_sym_type] = ACTIONS(599),
    [anon_sym_union] = ACTIONS(599),
    [anon_sym_unsafe] = ACTIONS(599),
    [anon_sym_use] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(599),
    [anon_sym_extern] = ACTIONS(599),
    [anon_sym_move] = ACTIONS(599),
    [sym_integer_literal] = ACTIONS(597),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(597),
    [sym_char_literal] = ACTIONS(597),
    [anon_sym_true] = ACTIONS(599),
    [anon_sym_false] = ACTIONS(599),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(599),
    [sym_self] = ACTIONS(599),
    [sym_super] = ACTIONS(599),
    [sym_crate] = ACTIONS(599),
    [sym_metavariable] = ACTIONS(597),
  },
  [1618] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(4991),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(623),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(623),
    [anon_sym_PLUS_EQ] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(623),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(643),
    [anon_sym_as] = ACTIONS(645),
    [sym_line_comment] = ACTIONS(7),
  },
  [1619] = {
    [sym__statement] = STATE(332),
    [sym_empty_statement] = STATE(332),
    [sym__expression_statement] = STATE(332),
    [sym_macro_definition] = STATE(332),
    [sym_attribute_item] = STATE(332),
    [sym_inner_attribute_item] = STATE(332),
    [sym_mod_item] = STATE(332),
    [sym_foreign_mod_item] = STATE(332),
    [sym_struct_item] = STATE(332),
    [sym_union_item] = STATE(332),
    [sym_enum_item] = STATE(332),
    [sym_extern_crate_declaration] = STATE(332),
    [sym_const_item] = STATE(332),
    [sym_static_item] = STATE(332),
    [sym_type_item] = STATE(332),
    [sym_function_item] = STATE(332),
    [sym_function_signature_item] = STATE(332),
    [sym_function_modifiers] = STATE(47),
    [sym_impl_item] = STATE(332),
    [sym_trait_item] = STATE(332),
    [sym_associated_type] = STATE(332),
    [sym_let_declaration] = STATE(332),
    [sym_use_declaration] = STATE(332),
    [sym_extern_modifier] = STATE(48),
    [sym_visibility_modifier] = STATE(49),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2245),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2245),
    [sym_macro_invocation] = STATE(53),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2245),
    [sym_unary_expression] = STATE(2245),
    [sym_try_expression] = STATE(2245),
    [sym_reference_expression] = STATE(2245),
    [sym_binary_expression] = STATE(2245),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2245),
    [sym_call_expression] = STATE(2245),
    [sym_array_expression] = STATE(2245),
    [sym_parenthesized_expression] = STATE(2245),
    [sym_tuple_expression] = STATE(2245),
    [sym_unit_expression] = STATE(2245),
    [sym_struct_expression] = STATE(2245),
    [sym_if_expression] = STATE(57),
    [sym_if_let_expression] = STATE(57),
    [sym_match_expression] = STATE(57),
    [sym_while_expression] = STATE(57),
    [sym_while_let_expression] = STATE(57),
    [sym_loop_expression] = STATE(57),
    [sym_for_expression] = STATE(57),
    [sym_closure_expression] = STATE(2245),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(59),
    [sym_break_expression] = STATE(2245),
    [sym_continue_expression] = STATE(2245),
    [sym_index_expression] = STATE(2245),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(57),
    [sym_block] = STATE(57),
    [sym__literal] = STATE(2245),
    [sym_string_literal] = STATE(2245),
    [sym_boolean_literal] = STATE(2245),
    [aux_sym_source_file_repeat1] = STATE(332),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_raw_string_literal] = ACTIONS(4993),
    [sym_float_literal] = ACTIONS(4993),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(4991),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_POUND] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(4993),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4993),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(93),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1620] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(4995),
    [sym_mutable_specifier] = ACTIONS(4995),
    [sym_line_comment] = ACTIONS(7),
  },
  [1621] = {
    [sym_function_modifiers] = STATE(1624),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(385),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2248),
    [sym_array_type] = STATE(385),
    [sym_function_type] = STATE(385),
    [sym_tuple_type] = STATE(385),
    [sym_unit_type] = STATE(385),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(385),
    [sym_reference_type] = STATE(385),
    [sym_pointer_type] = STATE(385),
    [sym_empty_type] = STATE(385),
    [sym_dynamic_type] = STATE(385),
    [sym_macro_invocation] = STATE(385),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1628),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3169),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3171),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3173),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(4997),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3175),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1622] = {
    [sym_parameters] = STATE(2249),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [1623] = {
    [sym_parameters] = STATE(2250),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_BANG] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_where] = ACTIONS(773),
    [sym_line_comment] = ACTIONS(7),
  },
  [1624] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2253),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_fn] = ACTIONS(4999),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5001),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [1625] = {
    [sym_where_clause] = STATE(2255),
    [sym_block] = STATE(2243),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4985),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_PLUS] = ACTIONS(5003),
    [anon_sym_where] = ACTIONS(1962),
    [sym_line_comment] = ACTIONS(7),
  },
  [1626] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(5005),
    [sym_line_comment] = ACTIONS(7),
  },
  [1627] = {
    [sym_where_clause] = STATE(2255),
    [sym_block] = STATE(2243),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4985),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_where] = ACTIONS(1962),
    [sym_line_comment] = ACTIONS(7),
  },
  [1628] = {
    [sym_parameters] = STATE(2249),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(783),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(783),
    [anon_sym_PLUS] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_where] = ACTIONS(783),
    [sym_line_comment] = ACTIONS(7),
  },
  [1629] = {
    [sym_trait_bounds] = STATE(1608),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(5007),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1630] = {
    [aux_sym_where_clause_repeat1] = STATE(2259),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3147),
    [anon_sym_LBRACE] = ACTIONS(3147),
    [anon_sym_COMMA] = ACTIONS(5009),
    [sym_line_comment] = ACTIONS(7),
  },
  [1631] = {
    [sym_trait_bounds] = STATE(1611),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(5011),
    [sym_line_comment] = ACTIONS(7),
  },
  [1632] = {
    [sym_trait_bounds] = STATE(1611),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(5007),
    [anon_sym_COLON_COLON] = ACTIONS(799),
    [sym_line_comment] = ACTIONS(7),
  },
  [1633] = {
    [sym_trait_bounds] = STATE(1611),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(5011),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1634] = {
    [sym_raw_string_literal] = ACTIONS(5013),
    [sym_float_literal] = ACTIONS(5013),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(5013),
    [anon_sym_SEMI] = ACTIONS(5013),
    [anon_sym_macro_rules_BANG] = ACTIONS(5013),
    [anon_sym_LPAREN] = ACTIONS(5013),
    [anon_sym_LBRACE] = ACTIONS(5013),
    [anon_sym_RBRACE] = ACTIONS(5013),
    [anon_sym_LBRACK] = ACTIONS(5013),
    [anon_sym_PLUS] = ACTIONS(5015),
    [anon_sym_STAR] = ACTIONS(5015),
    [anon_sym_u8] = ACTIONS(5015),
    [anon_sym_i8] = ACTIONS(5015),
    [anon_sym_u16] = ACTIONS(5015),
    [anon_sym_i16] = ACTIONS(5015),
    [anon_sym_u32] = ACTIONS(5015),
    [anon_sym_i32] = ACTIONS(5015),
    [anon_sym_u64] = ACTIONS(5015),
    [anon_sym_i64] = ACTIONS(5015),
    [anon_sym_u128] = ACTIONS(5015),
    [anon_sym_i128] = ACTIONS(5015),
    [anon_sym_isize] = ACTIONS(5015),
    [anon_sym_usize] = ACTIONS(5015),
    [anon_sym_f32] = ACTIONS(5015),
    [anon_sym_f64] = ACTIONS(5015),
    [anon_sym_bool] = ACTIONS(5015),
    [anon_sym_str] = ACTIONS(5015),
    [anon_sym_char] = ACTIONS(5015),
    [anon_sym_AMP] = ACTIONS(5015),
    [anon_sym_DASH] = ACTIONS(5015),
    [anon_sym_DOT] = ACTIONS(5015),
    [anon_sym_DASH_EQ] = ACTIONS(5013),
    [anon_sym_COLON_COLON] = ACTIONS(5013),
    [anon_sym_BANG] = ACTIONS(5015),
    [anon_sym_BANG_EQ] = ACTIONS(5013),
    [anon_sym_STAR_EQ] = ACTIONS(5013),
    [anon_sym_SLASH] = ACTIONS(5015),
    [anon_sym_SLASH_EQ] = ACTIONS(5013),
    [anon_sym_AMP_AMP] = ACTIONS(5013),
    [anon_sym_AMP_EQ] = ACTIONS(5013),
    [anon_sym_POUND] = ACTIONS(5013),
    [anon_sym_PERCENT] = ACTIONS(5015),
    [anon_sym_PERCENT_EQ] = ACTIONS(5013),
    [anon_sym_CARET] = ACTIONS(5015),
    [anon_sym_CARET_EQ] = ACTIONS(5013),
    [anon_sym_PLUS_EQ] = ACTIONS(5013),
    [anon_sym_LT] = ACTIONS(5015),
    [anon_sym_LT_LT] = ACTIONS(5015),
    [anon_sym_LT_LT_EQ] = ACTIONS(5013),
    [anon_sym_LT_EQ] = ACTIONS(5013),
    [anon_sym_EQ] = ACTIONS(5015),
    [anon_sym_EQ_EQ] = ACTIONS(5013),
    [anon_sym_GT] = ACTIONS(5015),
    [anon_sym_GT_EQ] = ACTIONS(5013),
    [anon_sym_GT_GT] = ACTIONS(5015),
    [anon_sym_GT_GT_EQ] = ACTIONS(5013),
    [anon_sym_PIPE] = ACTIONS(5015),
    [anon_sym_PIPE_EQ] = ACTIONS(5013),
    [anon_sym_PIPE_PIPE] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5013),
    [anon_sym_SQUOTE] = ACTIONS(5015),
    [anon_sym_DOT_DOT] = ACTIONS(5015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5013),
    [anon_sym_as] = ACTIONS(5015),
    [anon_sym_break] = ACTIONS(5015),
    [anon_sym_const] = ACTIONS(5015),
    [anon_sym_continue] = ACTIONS(5015),
    [anon_sym_default] = ACTIONS(5015),
    [anon_sym_enum] = ACTIONS(5015),
    [anon_sym_fn] = ACTIONS(5015),
    [anon_sym_for] = ACTIONS(5015),
    [anon_sym_if] = ACTIONS(5015),
    [anon_sym_impl] = ACTIONS(5015),
    [anon_sym_let] = ACTIONS(5015),
    [anon_sym_loop] = ACTIONS(5015),
    [anon_sym_match] = ACTIONS(5015),
    [anon_sym_mod] = ACTIONS(5015),
    [anon_sym_pub] = ACTIONS(5015),
    [anon_sym_return] = ACTIONS(5015),
    [anon_sym_static] = ACTIONS(5015),
    [anon_sym_struct] = ACTIONS(5015),
    [anon_sym_trait] = ACTIONS(5015),
    [anon_sym_type] = ACTIONS(5015),
    [anon_sym_union] = ACTIONS(5015),
    [anon_sym_unsafe] = ACTIONS(5015),
    [anon_sym_use] = ACTIONS(5015),
    [anon_sym_while] = ACTIONS(5015),
    [anon_sym_extern] = ACTIONS(5015),
    [anon_sym_move] = ACTIONS(5015),
    [sym_integer_literal] = ACTIONS(5013),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5013),
    [sym_char_literal] = ACTIONS(5013),
    [anon_sym_true] = ACTIONS(5015),
    [anon_sym_false] = ACTIONS(5015),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5015),
    [sym_self] = ACTIONS(5015),
    [sym_super] = ACTIONS(5015),
    [sym_crate] = ACTIONS(5015),
    [sym_metavariable] = ACTIONS(5013),
  },
  [1635] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2260),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(2260),
    [sym_macro_invocation] = STATE(2260),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2260),
    [sym_unary_expression] = STATE(2260),
    [sym_try_expression] = STATE(2260),
    [sym_reference_expression] = STATE(2260),
    [sym_binary_expression] = STATE(2260),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2260),
    [sym_call_expression] = STATE(2260),
    [sym_array_expression] = STATE(2260),
    [sym_parenthesized_expression] = STATE(2260),
    [sym_tuple_expression] = STATE(2260),
    [sym_unit_expression] = STATE(2260),
    [sym_struct_expression] = STATE(2260),
    [sym_if_expression] = STATE(2260),
    [sym_if_let_expression] = STATE(2260),
    [sym_match_expression] = STATE(2260),
    [sym_while_expression] = STATE(2260),
    [sym_while_let_expression] = STATE(2260),
    [sym_loop_expression] = STATE(2260),
    [sym_for_expression] = STATE(2260),
    [sym_closure_expression] = STATE(2260),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2260),
    [sym_continue_expression] = STATE(2260),
    [sym_index_expression] = STATE(2260),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2260),
    [sym_block] = STATE(2260),
    [sym__literal] = STATE(2260),
    [sym_string_literal] = STATE(2260),
    [sym_boolean_literal] = STATE(2260),
    [sym_raw_string_literal] = ACTIONS(5017),
    [sym_float_literal] = ACTIONS(5017),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(5017),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(5017),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [1636] = {
    [sym_if_expression] = STATE(2043),
    [sym_if_let_expression] = STATE(2043),
    [sym_block] = STATE(2043),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(5019),
    [sym_line_comment] = ACTIONS(7),
  },
  [1637] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(2261),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [1638] = {
    [sym_function_modifiers] = STATE(982),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2001),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(983),
    [sym_array_type] = STATE(2001),
    [sym_function_type] = STATE(2001),
    [sym_tuple_type] = STATE(2001),
    [sym_unit_type] = STATE(2001),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2001),
    [sym_reference_type] = STATE(2001),
    [sym_pointer_type] = STATE(2001),
    [sym_empty_type] = STATE(2001),
    [sym_dynamic_type] = STATE(2001),
    [sym_macro_invocation] = STATE(2001),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(984),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(2004),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(2006),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2008),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2010),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [1639] = {
    [sym_function_modifiers] = STATE(982),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2003),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(983),
    [sym_array_type] = STATE(2003),
    [sym_function_type] = STATE(2003),
    [sym_tuple_type] = STATE(2003),
    [sym_unit_type] = STATE(2003),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2003),
    [sym_reference_type] = STATE(2003),
    [sym_pointer_type] = STATE(2003),
    [sym_empty_type] = STATE(2003),
    [sym_dynamic_type] = STATE(2003),
    [sym_macro_invocation] = STATE(2003),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(984),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(2004),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(2006),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2008),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2010),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [1640] = {
    [sym_function_modifiers] = STATE(982),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2003),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(983),
    [sym_array_type] = STATE(2003),
    [sym_function_type] = STATE(2003),
    [sym_tuple_type] = STATE(2003),
    [sym_unit_type] = STATE(2003),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2003),
    [sym_reference_type] = STATE(2003),
    [sym_pointer_type] = STATE(2003),
    [sym_empty_type] = STATE(2003),
    [sym_dynamic_type] = STATE(2003),
    [sym_macro_invocation] = STATE(2003),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(984),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_PLUS] = ACTIONS(3197),
    [anon_sym_STAR] = ACTIONS(2004),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(2006),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2008),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_mutable_specifier] = ACTIONS(5021),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2010),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [1641] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1760),
    [anon_sym_LBRACE] = ACTIONS(1760),
    [anon_sym_LBRACK] = ACTIONS(1760),
    [anon_sym_PLUS] = ACTIONS(4443),
    [anon_sym_STAR] = ACTIONS(4443),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_DASH] = ACTIONS(4443),
    [anon_sym_DOT] = ACTIONS(4443),
    [anon_sym_DASH_EQ] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(5023),
    [anon_sym_BANG_EQ] = ACTIONS(1760),
    [anon_sym_STAR_EQ] = ACTIONS(1760),
    [anon_sym_SLASH] = ACTIONS(4443),
    [anon_sym_SLASH_EQ] = ACTIONS(1760),
    [anon_sym_AMP_AMP] = ACTIONS(1760),
    [anon_sym_AMP_EQ] = ACTIONS(1760),
    [anon_sym_PERCENT] = ACTIONS(4443),
    [anon_sym_PERCENT_EQ] = ACTIONS(1760),
    [anon_sym_CARET] = ACTIONS(4443),
    [anon_sym_CARET_EQ] = ACTIONS(1760),
    [anon_sym_PLUS_EQ] = ACTIONS(1760),
    [anon_sym_LT] = ACTIONS(4443),
    [anon_sym_LT_LT] = ACTIONS(4443),
    [anon_sym_LT_LT_EQ] = ACTIONS(1760),
    [anon_sym_LT_EQ] = ACTIONS(1760),
    [anon_sym_EQ] = ACTIONS(4443),
    [anon_sym_EQ_EQ] = ACTIONS(1760),
    [anon_sym_GT] = ACTIONS(4443),
    [anon_sym_GT_EQ] = ACTIONS(1760),
    [anon_sym_GT_GT] = ACTIONS(4443),
    [anon_sym_GT_GT_EQ] = ACTIONS(1760),
    [anon_sym_PIPE] = ACTIONS(4443),
    [anon_sym_PIPE_EQ] = ACTIONS(1760),
    [anon_sym_PIPE_PIPE] = ACTIONS(1760),
    [anon_sym_QMARK] = ACTIONS(1760),
    [anon_sym_DOT_DOT] = ACTIONS(4443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1760),
    [anon_sym_as] = ACTIONS(1760),
    [sym_line_comment] = ACTIONS(7),
  },
  [1642] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1794),
    [anon_sym_LBRACE] = ACTIONS(1794),
    [anon_sym_LBRACK] = ACTIONS(1794),
    [anon_sym_PLUS] = ACTIONS(4449),
    [anon_sym_STAR] = ACTIONS(4449),
    [anon_sym_AMP] = ACTIONS(4449),
    [anon_sym_DASH] = ACTIONS(4449),
    [anon_sym_DOT] = ACTIONS(4449),
    [anon_sym_DASH_EQ] = ACTIONS(1794),
    [anon_sym_DASH_GT] = ACTIONS(5025),
    [anon_sym_BANG_EQ] = ACTIONS(1794),
    [anon_sym_STAR_EQ] = ACTIONS(1794),
    [anon_sym_SLASH] = ACTIONS(4449),
    [anon_sym_SLASH_EQ] = ACTIONS(1794),
    [anon_sym_AMP_AMP] = ACTIONS(1794),
    [anon_sym_AMP_EQ] = ACTIONS(1794),
    [anon_sym_PERCENT] = ACTIONS(4449),
    [anon_sym_PERCENT_EQ] = ACTIONS(1794),
    [anon_sym_CARET] = ACTIONS(4449),
    [anon_sym_CARET_EQ] = ACTIONS(1794),
    [anon_sym_PLUS_EQ] = ACTIONS(1794),
    [anon_sym_LT] = ACTIONS(4449),
    [anon_sym_LT_LT] = ACTIONS(4449),
    [anon_sym_LT_LT_EQ] = ACTIONS(1794),
    [anon_sym_LT_EQ] = ACTIONS(1794),
    [anon_sym_EQ] = ACTIONS(4449),
    [anon_sym_EQ_EQ] = ACTIONS(1794),
    [anon_sym_GT] = ACTIONS(4449),
    [anon_sym_GT_EQ] = ACTIONS(1794),
    [anon_sym_GT_GT] = ACTIONS(4449),
    [anon_sym_GT_GT_EQ] = ACTIONS(1794),
    [anon_sym_PIPE] = ACTIONS(4449),
    [anon_sym_PIPE_EQ] = ACTIONS(1794),
    [anon_sym_PIPE_PIPE] = ACTIONS(1794),
    [anon_sym_QMARK] = ACTIONS(1794),
    [anon_sym_DOT_DOT] = ACTIONS(4449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1794),
    [anon_sym_as] = ACTIONS(1794),
    [sym_line_comment] = ACTIONS(7),
  },
  [1643] = {
    [sym_parameters] = STATE(2265),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [sym_line_comment] = ACTIONS(7),
  },
  [1644] = {
    [sym_parameters] = STATE(2266),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1645] = {
    [sym_parameters] = STATE(2265),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1646] = {
    [sym_function_modifiers] = STATE(982),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2016),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(2016),
    [sym_array_type] = STATE(2016),
    [sym_function_type] = STATE(2016),
    [sym_tuple_type] = STATE(2016),
    [sym_unit_type] = STATE(2016),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2016),
    [sym_reference_type] = STATE(2016),
    [sym_pointer_type] = STATE(2016),
    [sym_empty_type] = STATE(2016),
    [sym_dynamic_type] = STATE(2016),
    [sym_macro_invocation] = STATE(2016),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(984),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(2004),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(2006),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(4453),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2008),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2010),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [1647] = {
    [sym_function_modifiers] = STATE(982),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2016),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(983),
    [sym_array_type] = STATE(2016),
    [sym_function_type] = STATE(2016),
    [sym_tuple_type] = STATE(2016),
    [sym_unit_type] = STATE(2016),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2016),
    [sym_reference_type] = STATE(2016),
    [sym_pointer_type] = STATE(2016),
    [sym_empty_type] = STATE(2016),
    [sym_dynamic_type] = STATE(2016),
    [sym_macro_invocation] = STATE(2016),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(984),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(2004),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(2006),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2008),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2010),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [1648] = {
    [sym_raw_string_literal] = ACTIONS(5027),
    [sym_float_literal] = ACTIONS(5027),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(5027),
    [anon_sym_SEMI] = ACTIONS(5027),
    [anon_sym_macro_rules_BANG] = ACTIONS(5027),
    [anon_sym_LPAREN] = ACTIONS(5027),
    [anon_sym_LBRACE] = ACTIONS(5027),
    [anon_sym_RBRACE] = ACTIONS(5027),
    [anon_sym_LBRACK] = ACTIONS(5027),
    [anon_sym_PLUS] = ACTIONS(5029),
    [anon_sym_STAR] = ACTIONS(5029),
    [anon_sym_u8] = ACTIONS(5029),
    [anon_sym_i8] = ACTIONS(5029),
    [anon_sym_u16] = ACTIONS(5029),
    [anon_sym_i16] = ACTIONS(5029),
    [anon_sym_u32] = ACTIONS(5029),
    [anon_sym_i32] = ACTIONS(5029),
    [anon_sym_u64] = ACTIONS(5029),
    [anon_sym_i64] = ACTIONS(5029),
    [anon_sym_u128] = ACTIONS(5029),
    [anon_sym_i128] = ACTIONS(5029),
    [anon_sym_isize] = ACTIONS(5029),
    [anon_sym_usize] = ACTIONS(5029),
    [anon_sym_f32] = ACTIONS(5029),
    [anon_sym_f64] = ACTIONS(5029),
    [anon_sym_bool] = ACTIONS(5029),
    [anon_sym_str] = ACTIONS(5029),
    [anon_sym_char] = ACTIONS(5029),
    [anon_sym_AMP] = ACTIONS(5029),
    [anon_sym_DASH] = ACTIONS(5029),
    [anon_sym_DOT] = ACTIONS(5029),
    [anon_sym_DASH_EQ] = ACTIONS(5027),
    [anon_sym_COLON_COLON] = ACTIONS(5027),
    [anon_sym_BANG] = ACTIONS(5029),
    [anon_sym_BANG_EQ] = ACTIONS(5027),
    [anon_sym_STAR_EQ] = ACTIONS(5027),
    [anon_sym_SLASH] = ACTIONS(5029),
    [anon_sym_SLASH_EQ] = ACTIONS(5027),
    [anon_sym_AMP_AMP] = ACTIONS(5027),
    [anon_sym_AMP_EQ] = ACTIONS(5027),
    [anon_sym_POUND] = ACTIONS(5027),
    [anon_sym_PERCENT] = ACTIONS(5029),
    [anon_sym_PERCENT_EQ] = ACTIONS(5027),
    [anon_sym_CARET] = ACTIONS(5029),
    [anon_sym_CARET_EQ] = ACTIONS(5027),
    [anon_sym_PLUS_EQ] = ACTIONS(5027),
    [anon_sym_LT] = ACTIONS(5029),
    [anon_sym_LT_LT] = ACTIONS(5029),
    [anon_sym_LT_LT_EQ] = ACTIONS(5027),
    [anon_sym_LT_EQ] = ACTIONS(5027),
    [anon_sym_EQ] = ACTIONS(5029),
    [anon_sym_EQ_EQ] = ACTIONS(5027),
    [anon_sym_GT] = ACTIONS(5029),
    [anon_sym_GT_EQ] = ACTIONS(5027),
    [anon_sym_GT_GT] = ACTIONS(5029),
    [anon_sym_GT_GT_EQ] = ACTIONS(5027),
    [anon_sym_PIPE] = ACTIONS(5029),
    [anon_sym_PIPE_EQ] = ACTIONS(5027),
    [anon_sym_PIPE_PIPE] = ACTIONS(5027),
    [anon_sym_QMARK] = ACTIONS(5027),
    [anon_sym_SQUOTE] = ACTIONS(5029),
    [anon_sym_DOT_DOT] = ACTIONS(5029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5027),
    [anon_sym_as] = ACTIONS(5029),
    [anon_sym_break] = ACTIONS(5029),
    [anon_sym_const] = ACTIONS(5029),
    [anon_sym_continue] = ACTIONS(5029),
    [anon_sym_default] = ACTIONS(5029),
    [anon_sym_enum] = ACTIONS(5029),
    [anon_sym_fn] = ACTIONS(5029),
    [anon_sym_for] = ACTIONS(5029),
    [anon_sym_if] = ACTIONS(5029),
    [anon_sym_impl] = ACTIONS(5029),
    [anon_sym_let] = ACTIONS(5029),
    [anon_sym_loop] = ACTIONS(5029),
    [anon_sym_match] = ACTIONS(5029),
    [anon_sym_mod] = ACTIONS(5029),
    [anon_sym_pub] = ACTIONS(5029),
    [anon_sym_return] = ACTIONS(5029),
    [anon_sym_static] = ACTIONS(5029),
    [anon_sym_struct] = ACTIONS(5029),
    [anon_sym_trait] = ACTIONS(5029),
    [anon_sym_type] = ACTIONS(5029),
    [anon_sym_union] = ACTIONS(5029),
    [anon_sym_unsafe] = ACTIONS(5029),
    [anon_sym_use] = ACTIONS(5029),
    [anon_sym_while] = ACTIONS(5029),
    [anon_sym_extern] = ACTIONS(5029),
    [anon_sym_move] = ACTIONS(5029),
    [sym_integer_literal] = ACTIONS(5027),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5027),
    [sym_char_literal] = ACTIONS(5027),
    [anon_sym_true] = ACTIONS(5029),
    [anon_sym_false] = ACTIONS(5029),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5029),
    [sym_self] = ACTIONS(5029),
    [sym_super] = ACTIONS(5029),
    [sym_crate] = ACTIONS(5029),
    [sym_metavariable] = ACTIONS(5027),
  },
  [1649] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(5031),
    [sym_mutable_specifier] = ACTIONS(5031),
    [sym_line_comment] = ACTIONS(7),
  },
  [1650] = {
    [sym_function_modifiers] = STATE(1655),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(385),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2269),
    [sym_array_type] = STATE(385),
    [sym_function_type] = STATE(385),
    [sym_tuple_type] = STATE(385),
    [sym_unit_type] = STATE(385),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(385),
    [sym_reference_type] = STATE(385),
    [sym_pointer_type] = STATE(385),
    [sym_empty_type] = STATE(385),
    [sym_dynamic_type] = STATE(385),
    [sym_macro_invocation] = STATE(385),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1658),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3205),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3207),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3211),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(5033),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3215),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1651] = {
    [sym_function_modifiers] = STATE(1655),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1759),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2270),
    [sym_array_type] = STATE(1759),
    [sym_function_type] = STATE(1759),
    [sym_tuple_type] = STATE(1759),
    [sym_unit_type] = STATE(1759),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1759),
    [sym_reference_type] = STATE(1759),
    [sym_pointer_type] = STATE(1759),
    [sym_empty_type] = STATE(1759),
    [sym_dynamic_type] = STATE(1759),
    [sym_macro_invocation] = STATE(1759),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1658),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3205),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3207),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3211),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3215),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1652] = {
    [sym_parameters] = STATE(2271),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [1653] = {
    [sym_type_parameters] = STATE(2272),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(3393),
    [sym_line_comment] = ACTIONS(7),
  },
  [1654] = {
    [sym_parameters] = STATE(2273),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_BANG] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_EQ] = ACTIONS(773),
    [anon_sym_GT] = ACTIONS(773),
    [sym_line_comment] = ACTIONS(7),
  },
  [1655] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2276),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_fn] = ACTIONS(5035),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5037),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [1656] = {
    [aux_sym_trait_bounds_repeat1] = STATE(2278),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(5039),
    [anon_sym_COMMA] = ACTIONS(3395),
    [anon_sym_EQ] = ACTIONS(3395),
    [anon_sym_GT] = ACTIONS(3395),
    [sym_line_comment] = ACTIONS(7),
  },
  [1657] = {
    [aux_sym_trait_bounds_repeat1] = STATE(2278),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(5041),
    [anon_sym_COMMA] = ACTIONS(3395),
    [anon_sym_EQ] = ACTIONS(3395),
    [anon_sym_GT] = ACTIONS(3395),
    [sym_line_comment] = ACTIONS(7),
  },
  [1658] = {
    [sym_parameters] = STATE(2271),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(783),
    [anon_sym_COMMA] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_EQ] = ACTIONS(783),
    [anon_sym_GT] = ACTIONS(783),
    [sym_line_comment] = ACTIONS(7),
  },
  [1659] = {
    [sym_trait_bounds] = STATE(993),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2032),
    [anon_sym_COMMA] = ACTIONS(5043),
    [anon_sym_EQ] = ACTIONS(2024),
    [anon_sym_GT] = ACTIONS(5043),
    [sym_line_comment] = ACTIONS(7),
  },
  [1660] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(5045),
    [anon_sym_GT] = ACTIONS(5045),
    [sym_line_comment] = ACTIONS(7),
  },
  [1661] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(5045),
    [anon_sym_EQ] = ACTIONS(2030),
    [anon_sym_GT] = ACTIONS(5045),
    [sym_line_comment] = ACTIONS(7),
  },
  [1662] = {
    [sym_trait_bounds] = STATE(998),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2032),
    [anon_sym_COMMA] = ACTIONS(5045),
    [anon_sym_GT] = ACTIONS(5045),
    [sym_line_comment] = ACTIONS(7),
  },
  [1663] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_COMMA] = ACTIONS(5047),
    [anon_sym_GT] = ACTIONS(5047),
    [sym_line_comment] = ACTIONS(7),
  },
  [1664] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(2986),
    [sym_line_comment] = ACTIONS(7),
  },
  [1665] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5049),
    [anon_sym_LPAREN] = ACTIONS(5049),
    [anon_sym_LBRACE] = ACTIONS(5049),
    [anon_sym_u8] = ACTIONS(5051),
    [anon_sym_i8] = ACTIONS(5051),
    [anon_sym_u16] = ACTIONS(5051),
    [anon_sym_i16] = ACTIONS(5051),
    [anon_sym_u32] = ACTIONS(5051),
    [anon_sym_i32] = ACTIONS(5051),
    [anon_sym_u64] = ACTIONS(5051),
    [anon_sym_i64] = ACTIONS(5051),
    [anon_sym_u128] = ACTIONS(5051),
    [anon_sym_i128] = ACTIONS(5051),
    [anon_sym_isize] = ACTIONS(5051),
    [anon_sym_usize] = ACTIONS(5051),
    [anon_sym_f32] = ACTIONS(5051),
    [anon_sym_f64] = ACTIONS(5051),
    [anon_sym_bool] = ACTIONS(5051),
    [anon_sym_str] = ACTIONS(5051),
    [anon_sym_char] = ACTIONS(5051),
    [anon_sym_COLON_COLON] = ACTIONS(5049),
    [anon_sym_LT] = ACTIONS(5049),
    [anon_sym_EQ] = ACTIONS(5049),
    [anon_sym_where] = ACTIONS(5051),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5051),
    [sym_self] = ACTIONS(5051),
    [sym_super] = ACTIONS(5051),
    [sym_crate] = ACTIONS(5051),
    [sym_metavariable] = ACTIONS(5049),
  },
  [1666] = {
    [aux_sym_type_parameters_repeat1] = STATE(1666),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(5053),
    [anon_sym_GT] = ACTIONS(5045),
    [sym_line_comment] = ACTIONS(7),
  },
  [1667] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5056),
    [anon_sym_LPAREN] = ACTIONS(5056),
    [anon_sym_LBRACE] = ACTIONS(5056),
    [anon_sym_u8] = ACTIONS(5058),
    [anon_sym_i8] = ACTIONS(5058),
    [anon_sym_u16] = ACTIONS(5058),
    [anon_sym_i16] = ACTIONS(5058),
    [anon_sym_u32] = ACTIONS(5058),
    [anon_sym_i32] = ACTIONS(5058),
    [anon_sym_u64] = ACTIONS(5058),
    [anon_sym_i64] = ACTIONS(5058),
    [anon_sym_u128] = ACTIONS(5058),
    [anon_sym_i128] = ACTIONS(5058),
    [anon_sym_isize] = ACTIONS(5058),
    [anon_sym_usize] = ACTIONS(5058),
    [anon_sym_f32] = ACTIONS(5058),
    [anon_sym_f64] = ACTIONS(5058),
    [anon_sym_bool] = ACTIONS(5058),
    [anon_sym_str] = ACTIONS(5058),
    [anon_sym_char] = ACTIONS(5058),
    [anon_sym_COLON_COLON] = ACTIONS(5056),
    [anon_sym_LT] = ACTIONS(5056),
    [anon_sym_EQ] = ACTIONS(5056),
    [anon_sym_where] = ACTIONS(5058),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5058),
    [sym_self] = ACTIONS(5058),
    [sym_super] = ACTIONS(5058),
    [sym_crate] = ACTIONS(5058),
    [sym_metavariable] = ACTIONS(5056),
  },
  [1668] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_COMMA] = ACTIONS(5060),
    [anon_sym_GT] = ACTIONS(5060),
    [sym_line_comment] = ACTIONS(7),
  },
  [1669] = {
    [sym_function_modifiers] = STATE(1003),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(821),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1005),
    [sym_array_type] = STATE(821),
    [sym_function_type] = STATE(821),
    [sym_tuple_type] = STATE(821),
    [sym_unit_type] = STATE(821),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(821),
    [sym_reference_type] = STATE(821),
    [sym_pointer_type] = STATE(821),
    [sym_empty_type] = STATE(821),
    [sym_dynamic_type] = STATE(821),
    [sym_macro_invocation] = STATE(821),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1006),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2034),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2036),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2038),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2040),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1670] = {
    [sym_function_modifiers] = STATE(1003),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1005),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1006),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2034),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2036),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2038),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2040),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1671] = {
    [sym_function_modifiers] = STATE(1003),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1005),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1006),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(3249),
    [anon_sym_STAR] = ACTIONS(2034),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2036),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2038),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(5062),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2040),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1672] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(1760),
    [anon_sym_PLUS] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(5064),
    [anon_sym_where] = ACTIONS(1760),
    [sym_line_comment] = ACTIONS(7),
  },
  [1673] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(1794),
    [anon_sym_PLUS] = ACTIONS(1794),
    [anon_sym_DASH_GT] = ACTIONS(5066),
    [anon_sym_where] = ACTIONS(1794),
    [sym_line_comment] = ACTIONS(7),
  },
  [1674] = {
    [sym_parameters] = STATE(2283),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [1675] = {
    [sym_parameters] = STATE(2284),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1676] = {
    [sym_parameters] = STATE(2283),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1677] = {
    [sym_function_modifiers] = STATE(1003),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(862),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1006),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2034),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2036),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2038),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2040),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1678] = {
    [sym_function_modifiers] = STATE(1003),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1005),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1006),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2034),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2036),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2038),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2040),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1679] = {
    [sym_raw_string_literal] = ACTIONS(5068),
    [sym_float_literal] = ACTIONS(5068),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(5068),
    [anon_sym_SEMI] = ACTIONS(5068),
    [anon_sym_macro_rules_BANG] = ACTIONS(5068),
    [anon_sym_LPAREN] = ACTIONS(5068),
    [anon_sym_LBRACE] = ACTIONS(5068),
    [anon_sym_RBRACE] = ACTIONS(5068),
    [anon_sym_LBRACK] = ACTIONS(5068),
    [anon_sym_STAR] = ACTIONS(5068),
    [anon_sym_u8] = ACTIONS(5070),
    [anon_sym_i8] = ACTIONS(5070),
    [anon_sym_u16] = ACTIONS(5070),
    [anon_sym_i16] = ACTIONS(5070),
    [anon_sym_u32] = ACTIONS(5070),
    [anon_sym_i32] = ACTIONS(5070),
    [anon_sym_u64] = ACTIONS(5070),
    [anon_sym_i64] = ACTIONS(5070),
    [anon_sym_u128] = ACTIONS(5070),
    [anon_sym_i128] = ACTIONS(5070),
    [anon_sym_isize] = ACTIONS(5070),
    [anon_sym_usize] = ACTIONS(5070),
    [anon_sym_f32] = ACTIONS(5070),
    [anon_sym_f64] = ACTIONS(5070),
    [anon_sym_bool] = ACTIONS(5070),
    [anon_sym_str] = ACTIONS(5070),
    [anon_sym_char] = ACTIONS(5070),
    [anon_sym_AMP] = ACTIONS(5068),
    [anon_sym_DASH] = ACTIONS(5068),
    [anon_sym_COLON_COLON] = ACTIONS(5068),
    [anon_sym_BANG] = ACTIONS(5068),
    [anon_sym_POUND] = ACTIONS(5068),
    [anon_sym_LT] = ACTIONS(5068),
    [anon_sym_PIPE] = ACTIONS(5068),
    [anon_sym_SQUOTE] = ACTIONS(5070),
    [anon_sym_DOT_DOT] = ACTIONS(5068),
    [anon_sym_break] = ACTIONS(5070),
    [anon_sym_const] = ACTIONS(5070),
    [anon_sym_continue] = ACTIONS(5070),
    [anon_sym_default] = ACTIONS(5070),
    [anon_sym_enum] = ACTIONS(5070),
    [anon_sym_fn] = ACTIONS(5070),
    [anon_sym_for] = ACTIONS(5070),
    [anon_sym_if] = ACTIONS(5070),
    [anon_sym_impl] = ACTIONS(5070),
    [anon_sym_let] = ACTIONS(5070),
    [anon_sym_loop] = ACTIONS(5070),
    [anon_sym_match] = ACTIONS(5070),
    [anon_sym_mod] = ACTIONS(5070),
    [anon_sym_pub] = ACTIONS(5070),
    [anon_sym_return] = ACTIONS(5070),
    [anon_sym_static] = ACTIONS(5070),
    [anon_sym_struct] = ACTIONS(5070),
    [anon_sym_trait] = ACTIONS(5070),
    [anon_sym_type] = ACTIONS(5070),
    [anon_sym_union] = ACTIONS(5070),
    [anon_sym_unsafe] = ACTIONS(5070),
    [anon_sym_use] = ACTIONS(5070),
    [anon_sym_while] = ACTIONS(5070),
    [anon_sym_extern] = ACTIONS(5070),
    [anon_sym_move] = ACTIONS(5070),
    [sym_integer_literal] = ACTIONS(5068),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5068),
    [sym_char_literal] = ACTIONS(5068),
    [anon_sym_true] = ACTIONS(5070),
    [anon_sym_false] = ACTIONS(5070),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5070),
    [sym_self] = ACTIONS(5070),
    [sym_super] = ACTIONS(5070),
    [sym_crate] = ACTIONS(5070),
    [sym_metavariable] = ACTIONS(5068),
  },
  [1680] = {
    [sym_declaration_list] = STATE(2285),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [sym_line_comment] = ACTIONS(7),
  },
  [1681] = {
    [sym_raw_string_literal] = ACTIONS(5072),
    [sym_float_literal] = ACTIONS(5072),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(5072),
    [anon_sym_SEMI] = ACTIONS(5072),
    [anon_sym_macro_rules_BANG] = ACTIONS(5072),
    [anon_sym_LPAREN] = ACTIONS(5072),
    [anon_sym_LBRACE] = ACTIONS(5072),
    [anon_sym_RBRACE] = ACTIONS(5072),
    [anon_sym_LBRACK] = ACTIONS(5072),
    [anon_sym_STAR] = ACTIONS(5072),
    [anon_sym_u8] = ACTIONS(5074),
    [anon_sym_i8] = ACTIONS(5074),
    [anon_sym_u16] = ACTIONS(5074),
    [anon_sym_i16] = ACTIONS(5074),
    [anon_sym_u32] = ACTIONS(5074),
    [anon_sym_i32] = ACTIONS(5074),
    [anon_sym_u64] = ACTIONS(5074),
    [anon_sym_i64] = ACTIONS(5074),
    [anon_sym_u128] = ACTIONS(5074),
    [anon_sym_i128] = ACTIONS(5074),
    [anon_sym_isize] = ACTIONS(5074),
    [anon_sym_usize] = ACTIONS(5074),
    [anon_sym_f32] = ACTIONS(5074),
    [anon_sym_f64] = ACTIONS(5074),
    [anon_sym_bool] = ACTIONS(5074),
    [anon_sym_str] = ACTIONS(5074),
    [anon_sym_char] = ACTIONS(5074),
    [anon_sym_AMP] = ACTIONS(5072),
    [anon_sym_DASH] = ACTIONS(5072),
    [anon_sym_COLON_COLON] = ACTIONS(5072),
    [anon_sym_BANG] = ACTIONS(5072),
    [anon_sym_POUND] = ACTIONS(5072),
    [anon_sym_LT] = ACTIONS(5072),
    [anon_sym_PIPE] = ACTIONS(5072),
    [anon_sym_SQUOTE] = ACTIONS(5074),
    [anon_sym_DOT_DOT] = ACTIONS(5072),
    [anon_sym_break] = ACTIONS(5074),
    [anon_sym_const] = ACTIONS(5074),
    [anon_sym_continue] = ACTIONS(5074),
    [anon_sym_default] = ACTIONS(5074),
    [anon_sym_enum] = ACTIONS(5074),
    [anon_sym_fn] = ACTIONS(5074),
    [anon_sym_for] = ACTIONS(5074),
    [anon_sym_if] = ACTIONS(5074),
    [anon_sym_impl] = ACTIONS(5074),
    [anon_sym_let] = ACTIONS(5074),
    [anon_sym_loop] = ACTIONS(5074),
    [anon_sym_match] = ACTIONS(5074),
    [anon_sym_mod] = ACTIONS(5074),
    [anon_sym_pub] = ACTIONS(5074),
    [anon_sym_return] = ACTIONS(5074),
    [anon_sym_static] = ACTIONS(5074),
    [anon_sym_struct] = ACTIONS(5074),
    [anon_sym_trait] = ACTIONS(5074),
    [anon_sym_type] = ACTIONS(5074),
    [anon_sym_union] = ACTIONS(5074),
    [anon_sym_unsafe] = ACTIONS(5074),
    [anon_sym_use] = ACTIONS(5074),
    [anon_sym_while] = ACTIONS(5074),
    [anon_sym_extern] = ACTIONS(5074),
    [anon_sym_move] = ACTIONS(5074),
    [sym_integer_literal] = ACTIONS(5072),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5072),
    [sym_char_literal] = ACTIONS(5072),
    [anon_sym_true] = ACTIONS(5074),
    [anon_sym_false] = ACTIONS(5074),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5074),
    [sym_self] = ACTIONS(5074),
    [sym_super] = ACTIONS(5074),
    [sym_crate] = ACTIONS(5074),
    [sym_metavariable] = ACTIONS(5072),
  },
  [1682] = {
    [sym_declaration_list] = STATE(2286),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [sym_line_comment] = ACTIONS(7),
  },
  [1683] = {
    [sym_declaration_list] = STATE(2286),
    [sym_where_clause] = STATE(2287),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [1684] = {
    [sym_raw_string_literal] = ACTIONS(5076),
    [sym_float_literal] = ACTIONS(5076),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(5076),
    [anon_sym_SEMI] = ACTIONS(5076),
    [anon_sym_macro_rules_BANG] = ACTIONS(5076),
    [anon_sym_LPAREN] = ACTIONS(5076),
    [anon_sym_LBRACE] = ACTIONS(5076),
    [anon_sym_RBRACE] = ACTIONS(5076),
    [anon_sym_LBRACK] = ACTIONS(5076),
    [anon_sym_STAR] = ACTIONS(5076),
    [anon_sym_u8] = ACTIONS(5078),
    [anon_sym_i8] = ACTIONS(5078),
    [anon_sym_u16] = ACTIONS(5078),
    [anon_sym_i16] = ACTIONS(5078),
    [anon_sym_u32] = ACTIONS(5078),
    [anon_sym_i32] = ACTIONS(5078),
    [anon_sym_u64] = ACTIONS(5078),
    [anon_sym_i64] = ACTIONS(5078),
    [anon_sym_u128] = ACTIONS(5078),
    [anon_sym_i128] = ACTIONS(5078),
    [anon_sym_isize] = ACTIONS(5078),
    [anon_sym_usize] = ACTIONS(5078),
    [anon_sym_f32] = ACTIONS(5078),
    [anon_sym_f64] = ACTIONS(5078),
    [anon_sym_bool] = ACTIONS(5078),
    [anon_sym_str] = ACTIONS(5078),
    [anon_sym_char] = ACTIONS(5078),
    [anon_sym_AMP] = ACTIONS(5076),
    [anon_sym_DASH] = ACTIONS(5076),
    [anon_sym_COLON_COLON] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5076),
    [anon_sym_POUND] = ACTIONS(5076),
    [anon_sym_LT] = ACTIONS(5076),
    [anon_sym_PIPE] = ACTIONS(5076),
    [anon_sym_SQUOTE] = ACTIONS(5078),
    [anon_sym_DOT_DOT] = ACTIONS(5076),
    [anon_sym_break] = ACTIONS(5078),
    [anon_sym_const] = ACTIONS(5078),
    [anon_sym_continue] = ACTIONS(5078),
    [anon_sym_default] = ACTIONS(5078),
    [anon_sym_enum] = ACTIONS(5078),
    [anon_sym_fn] = ACTIONS(5078),
    [anon_sym_for] = ACTIONS(5078),
    [anon_sym_if] = ACTIONS(5078),
    [anon_sym_impl] = ACTIONS(5078),
    [anon_sym_let] = ACTIONS(5078),
    [anon_sym_loop] = ACTIONS(5078),
    [anon_sym_match] = ACTIONS(5078),
    [anon_sym_mod] = ACTIONS(5078),
    [anon_sym_pub] = ACTIONS(5078),
    [anon_sym_return] = ACTIONS(5078),
    [anon_sym_static] = ACTIONS(5078),
    [anon_sym_struct] = ACTIONS(5078),
    [anon_sym_trait] = ACTIONS(5078),
    [anon_sym_type] = ACTIONS(5078),
    [anon_sym_union] = ACTIONS(5078),
    [anon_sym_unsafe] = ACTIONS(5078),
    [anon_sym_use] = ACTIONS(5078),
    [anon_sym_while] = ACTIONS(5078),
    [anon_sym_extern] = ACTIONS(5078),
    [anon_sym_move] = ACTIONS(5078),
    [sym_integer_literal] = ACTIONS(5076),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5076),
    [sym_char_literal] = ACTIONS(5076),
    [anon_sym_true] = ACTIONS(5078),
    [anon_sym_false] = ACTIONS(5078),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5078),
    [sym_self] = ACTIONS(5078),
    [sym_super] = ACTIONS(5078),
    [sym_crate] = ACTIONS(5078),
    [sym_metavariable] = ACTIONS(5076),
  },
  [1685] = {
    [sym_declaration_list] = STATE(2288),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [sym_line_comment] = ACTIONS(7),
  },
  [1686] = {
    [sym_declaration_list] = STATE(2288),
    [sym_where_clause] = STATE(2289),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [1687] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(3279),
    [anon_sym_EQ] = ACTIONS(5082),
    [sym_line_comment] = ACTIONS(7),
  },
  [1688] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5080),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(467),
    [anon_sym_BANG_EQ] = ACTIONS(469),
    [anon_sym_STAR_EQ] = ACTIONS(467),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(467),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_AMP_EQ] = ACTIONS(467),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(467),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_CARET_EQ] = ACTIONS(467),
    [anon_sym_PLUS_EQ] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT_LT_EQ] = ACTIONS(467),
    [anon_sym_LT_EQ] = ACTIONS(469),
    [anon_sym_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_EQ] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_PIPE_EQ] = ACTIONS(467),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(489),
    [anon_sym_as] = ACTIONS(491),
    [sym_line_comment] = ACTIONS(7),
  },
  [1689] = {
    [sym_function_modifiers] = STATE(1025),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(821),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1027),
    [sym_array_type] = STATE(821),
    [sym_function_type] = STATE(821),
    [sym_tuple_type] = STATE(821),
    [sym_unit_type] = STATE(821),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(821),
    [sym_reference_type] = STATE(821),
    [sym_pointer_type] = STATE(821),
    [sym_empty_type] = STATE(821),
    [sym_dynamic_type] = STATE(821),
    [sym_macro_invocation] = STATE(821),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1028),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2060),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2062),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2064),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2066),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1690] = {
    [sym_function_modifiers] = STATE(1025),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1027),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1028),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2060),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2062),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2064),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2066),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1691] = {
    [sym_function_modifiers] = STATE(1025),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1027),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1028),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_STAR] = ACTIONS(2060),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2062),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2064),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(5084),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2066),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1692] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1760),
    [anon_sym_PLUS] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(5086),
    [anon_sym_EQ] = ACTIONS(1760),
    [sym_line_comment] = ACTIONS(7),
  },
  [1693] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1794),
    [anon_sym_PLUS] = ACTIONS(1794),
    [anon_sym_DASH_GT] = ACTIONS(5088),
    [anon_sym_EQ] = ACTIONS(1794),
    [sym_line_comment] = ACTIONS(7),
  },
  [1694] = {
    [sym_parameters] = STATE(2295),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [1695] = {
    [sym_parameters] = STATE(2296),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1696] = {
    [sym_parameters] = STATE(2295),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1697] = {
    [sym_raw_string_literal] = ACTIONS(5090),
    [sym_float_literal] = ACTIONS(5090),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(5090),
    [anon_sym_SEMI] = ACTIONS(5090),
    [anon_sym_macro_rules_BANG] = ACTIONS(5090),
    [anon_sym_LPAREN] = ACTIONS(5090),
    [anon_sym_LBRACE] = ACTIONS(5090),
    [anon_sym_RBRACE] = ACTIONS(5090),
    [anon_sym_LBRACK] = ACTIONS(5090),
    [anon_sym_STAR] = ACTIONS(5090),
    [anon_sym_u8] = ACTIONS(5092),
    [anon_sym_i8] = ACTIONS(5092),
    [anon_sym_u16] = ACTIONS(5092),
    [anon_sym_i16] = ACTIONS(5092),
    [anon_sym_u32] = ACTIONS(5092),
    [anon_sym_i32] = ACTIONS(5092),
    [anon_sym_u64] = ACTIONS(5092),
    [anon_sym_i64] = ACTIONS(5092),
    [anon_sym_u128] = ACTIONS(5092),
    [anon_sym_i128] = ACTIONS(5092),
    [anon_sym_isize] = ACTIONS(5092),
    [anon_sym_usize] = ACTIONS(5092),
    [anon_sym_f32] = ACTIONS(5092),
    [anon_sym_f64] = ACTIONS(5092),
    [anon_sym_bool] = ACTIONS(5092),
    [anon_sym_str] = ACTIONS(5092),
    [anon_sym_char] = ACTIONS(5092),
    [anon_sym_AMP] = ACTIONS(5090),
    [anon_sym_DASH] = ACTIONS(5090),
    [anon_sym_COLON_COLON] = ACTIONS(5090),
    [anon_sym_BANG] = ACTIONS(5090),
    [anon_sym_POUND] = ACTIONS(5090),
    [anon_sym_LT] = ACTIONS(5090),
    [anon_sym_PIPE] = ACTIONS(5090),
    [anon_sym_SQUOTE] = ACTIONS(5092),
    [anon_sym_DOT_DOT] = ACTIONS(5090),
    [anon_sym_break] = ACTIONS(5092),
    [anon_sym_const] = ACTIONS(5092),
    [anon_sym_continue] = ACTIONS(5092),
    [anon_sym_default] = ACTIONS(5092),
    [anon_sym_enum] = ACTIONS(5092),
    [anon_sym_fn] = ACTIONS(5092),
    [anon_sym_for] = ACTIONS(5092),
    [anon_sym_if] = ACTIONS(5092),
    [anon_sym_impl] = ACTIONS(5092),
    [anon_sym_let] = ACTIONS(5092),
    [anon_sym_loop] = ACTIONS(5092),
    [anon_sym_match] = ACTIONS(5092),
    [anon_sym_mod] = ACTIONS(5092),
    [anon_sym_pub] = ACTIONS(5092),
    [anon_sym_return] = ACTIONS(5092),
    [anon_sym_static] = ACTIONS(5092),
    [anon_sym_struct] = ACTIONS(5092),
    [anon_sym_trait] = ACTIONS(5092),
    [anon_sym_type] = ACTIONS(5092),
    [anon_sym_union] = ACTIONS(5092),
    [anon_sym_unsafe] = ACTIONS(5092),
    [anon_sym_use] = ACTIONS(5092),
    [anon_sym_while] = ACTIONS(5092),
    [anon_sym_extern] = ACTIONS(5092),
    [anon_sym_move] = ACTIONS(5092),
    [sym_integer_literal] = ACTIONS(5090),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5090),
    [sym_char_literal] = ACTIONS(5090),
    [anon_sym_true] = ACTIONS(5092),
    [anon_sym_false] = ACTIONS(5092),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5092),
    [sym_self] = ACTIONS(5092),
    [sym_super] = ACTIONS(5092),
    [sym_crate] = ACTIONS(5092),
    [sym_metavariable] = ACTIONS(5090),
  },
  [1698] = {
    [sym_function_modifiers] = STATE(1025),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(862),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1028),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2060),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2062),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2064),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2066),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1699] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2297),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2297),
    [sym_macro_invocation] = STATE(2297),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2297),
    [sym_unary_expression] = STATE(2297),
    [sym_try_expression] = STATE(2297),
    [sym_reference_expression] = STATE(2297),
    [sym_binary_expression] = STATE(2297),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2297),
    [sym_call_expression] = STATE(2297),
    [sym_array_expression] = STATE(2297),
    [sym_parenthesized_expression] = STATE(2297),
    [sym_tuple_expression] = STATE(2297),
    [sym_unit_expression] = STATE(2297),
    [sym_struct_expression] = STATE(2297),
    [sym_if_expression] = STATE(2297),
    [sym_if_let_expression] = STATE(2297),
    [sym_match_expression] = STATE(2297),
    [sym_while_expression] = STATE(2297),
    [sym_while_let_expression] = STATE(2297),
    [sym_loop_expression] = STATE(2297),
    [sym_for_expression] = STATE(2297),
    [sym_closure_expression] = STATE(2297),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2297),
    [sym_continue_expression] = STATE(2297),
    [sym_index_expression] = STATE(2297),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2297),
    [sym_block] = STATE(2297),
    [sym__literal] = STATE(2297),
    [sym_string_literal] = STATE(2297),
    [sym_boolean_literal] = STATE(2297),
    [sym_raw_string_literal] = ACTIONS(5094),
    [sym_float_literal] = ACTIONS(5094),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(5094),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(5094),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1700] = {
    [sym_function_modifiers] = STATE(1025),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1027),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1028),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2060),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2062),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2064),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2066),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1701] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(1828),
    [anon_sym_PIPE] = ACTIONS(1828),
    [anon_sym_if] = ACTIONS(1828),
    [sym_line_comment] = ACTIONS(7),
  },
  [1702] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(5096),
    [sym_line_comment] = ACTIONS(7),
  },
  [1703] = {
    [aux_sym_tuple_pattern_repeat1] = STATE(2300),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(5096),
    [anon_sym_COMMA] = ACTIONS(5098),
    [sym_line_comment] = ACTIONS(7),
  },
  [1704] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5100),
  },
  [1705] = {
    [sym_bracketed_type] = STATE(1041),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(1042),
    [sym_scoped_identifier] = STATE(1043),
    [sym_scoped_type_identifier] = STATE(1044),
    [sym__pattern] = STATE(2302),
    [sym_tuple_pattern] = STATE(2302),
    [sym_tuple_struct_pattern] = STATE(2302),
    [sym_struct_pattern] = STATE(2302),
    [sym_remaining_field_pattern] = STATE(2302),
    [sym_mut_pattern] = STATE(2302),
    [sym_ref_pattern] = STATE(2302),
    [sym_captured_pattern] = STATE(2302),
    [sym_reference_pattern] = STATE(2302),
    [sym__literal] = STATE(2302),
    [sym_string_literal] = STATE(2302),
    [sym_boolean_literal] = STATE(2302),
    [sym_raw_string_literal] = ACTIONS(5102),
    [sym_float_literal] = ACTIONS(5102),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2072),
    [anon_sym_u8] = ACTIONS(2076),
    [anon_sym_i8] = ACTIONS(2076),
    [anon_sym_u16] = ACTIONS(2076),
    [anon_sym_i16] = ACTIONS(2076),
    [anon_sym_u32] = ACTIONS(2076),
    [anon_sym_i32] = ACTIONS(2076),
    [anon_sym_u64] = ACTIONS(2076),
    [anon_sym_i64] = ACTIONS(2076),
    [anon_sym_u128] = ACTIONS(2076),
    [anon_sym_i128] = ACTIONS(2076),
    [anon_sym_isize] = ACTIONS(2076),
    [anon_sym_usize] = ACTIONS(2076),
    [anon_sym_f32] = ACTIONS(2076),
    [anon_sym_f64] = ACTIONS(2076),
    [anon_sym_bool] = ACTIONS(2076),
    [anon_sym_str] = ACTIONS(2076),
    [anon_sym_char] = ACTIONS(2076),
    [anon_sym__] = ACTIONS(5104),
    [anon_sym_AMP] = ACTIONS(2080),
    [anon_sym_COLON_COLON] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(2086),
    [sym_mutable_specifier] = ACTIONS(2088),
    [anon_sym_ref] = ACTIONS(2090),
    [sym_integer_literal] = ACTIONS(5102),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(769),
    [sym_char_literal] = ACTIONS(5102),
    [anon_sym_true] = ACTIONS(2092),
    [anon_sym_false] = ACTIONS(2092),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2094),
    [sym_self] = ACTIONS(2096),
    [sym_super] = ACTIONS(2096),
    [sym_crate] = ACTIONS(2096),
    [sym_metavariable] = ACTIONS(2098),
  },
  [1706] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(1868),
    [anon_sym_PIPE] = ACTIONS(1868),
    [anon_sym_if] = ACTIONS(1868),
    [sym_line_comment] = ACTIONS(7),
  },
  [1707] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(721),
    [anon_sym_LBRACE] = ACTIONS(1728),
    [anon_sym_EQ_GT] = ACTIONS(721),
    [anon_sym_COLON_COLON] = ACTIONS(721),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(721),
    [anon_sym_if] = ACTIONS(721),
    [sym_line_comment] = ACTIONS(7),
  },
  [1708] = {
    [sym_meta_item] = STATE(2303),
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(727),
  },
  [1709] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(1884),
    [anon_sym_PIPE] = ACTIONS(1884),
    [anon_sym_if] = ACTIONS(1884),
    [sym_line_comment] = ACTIONS(7),
  },
  [1710] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(1886),
    [anon_sym_PIPE] = ACTIONS(1886),
    [anon_sym_if] = ACTIONS(1886),
    [sym_line_comment] = ACTIONS(7),
  },
  [1711] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(2306),
    [sym_tuple_pattern] = STATE(2306),
    [sym_tuple_struct_pattern] = STATE(2306),
    [sym_struct_pattern] = STATE(2306),
    [sym_remaining_field_pattern] = STATE(2306),
    [sym_mut_pattern] = STATE(2306),
    [sym_ref_pattern] = STATE(2306),
    [sym_captured_pattern] = STATE(2306),
    [sym_reference_pattern] = STATE(2306),
    [sym__literal] = STATE(2306),
    [sym_string_literal] = STATE(2306),
    [sym_boolean_literal] = STATE(2306),
    [sym_raw_string_literal] = ACTIONS(5106),
    [sym_float_literal] = ACTIONS(5106),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_RPAREN] = ACTIONS(5108),
    [anon_sym_COMMA] = ACTIONS(5110),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(5112),
    [anon_sym_AMP] = ACTIONS(817),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(819),
    [anon_sym_ref] = ACTIONS(821),
    [sym_integer_literal] = ACTIONS(5106),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(5106),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(823),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [1712] = {
    [sym_field_pattern] = STATE(2309),
    [sym_remaining_field_pattern] = STATE(2309),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5114),
    [anon_sym_COMMA] = ACTIONS(5116),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(1902),
    [anon_sym_ref] = ACTIONS(1904),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1906),
  },
  [1713] = {
    [sym_type_arguments] = STATE(845),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5118),
  },
  [1714] = {
    [sym_bracketed_type] = STATE(1041),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(1042),
    [sym_scoped_identifier] = STATE(1043),
    [sym_scoped_type_identifier] = STATE(1044),
    [sym__pattern] = STATE(2311),
    [sym_tuple_pattern] = STATE(2311),
    [sym_tuple_struct_pattern] = STATE(2311),
    [sym_struct_pattern] = STATE(2311),
    [sym_remaining_field_pattern] = STATE(2311),
    [sym_mut_pattern] = STATE(2311),
    [sym_ref_pattern] = STATE(2311),
    [sym_captured_pattern] = STATE(2311),
    [sym_reference_pattern] = STATE(2311),
    [sym__literal] = STATE(2311),
    [sym_string_literal] = STATE(2311),
    [sym_boolean_literal] = STATE(2311),
    [sym_raw_string_literal] = ACTIONS(5120),
    [sym_float_literal] = ACTIONS(5120),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2072),
    [anon_sym_u8] = ACTIONS(2076),
    [anon_sym_i8] = ACTIONS(2076),
    [anon_sym_u16] = ACTIONS(2076),
    [anon_sym_i16] = ACTIONS(2076),
    [anon_sym_u32] = ACTIONS(2076),
    [anon_sym_i32] = ACTIONS(2076),
    [anon_sym_u64] = ACTIONS(2076),
    [anon_sym_i64] = ACTIONS(2076),
    [anon_sym_u128] = ACTIONS(2076),
    [anon_sym_i128] = ACTIONS(2076),
    [anon_sym_isize] = ACTIONS(2076),
    [anon_sym_usize] = ACTIONS(2076),
    [anon_sym_f32] = ACTIONS(2076),
    [anon_sym_f64] = ACTIONS(2076),
    [anon_sym_bool] = ACTIONS(2076),
    [anon_sym_str] = ACTIONS(2076),
    [anon_sym_char] = ACTIONS(2076),
    [anon_sym__] = ACTIONS(5122),
    [anon_sym_AMP] = ACTIONS(2080),
    [anon_sym_COLON_COLON] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(2086),
    [sym_mutable_specifier] = ACTIONS(2088),
    [anon_sym_ref] = ACTIONS(2090),
    [sym_integer_literal] = ACTIONS(5120),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(769),
    [sym_char_literal] = ACTIONS(5120),
    [anon_sym_true] = ACTIONS(2092),
    [anon_sym_false] = ACTIONS(2092),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2094),
    [sym_self] = ACTIONS(2096),
    [sym_super] = ACTIONS(2096),
    [sym_crate] = ACTIONS(2096),
    [sym_metavariable] = ACTIONS(2098),
  },
  [1715] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5118),
  },
  [1716] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5124),
  },
  [1717] = {
    [sym_type_arguments] = STATE(873),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5118),
  },
  [1718] = {
    [sym_field_pattern] = STATE(2315),
    [sym_remaining_field_pattern] = STATE(2315),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5126),
    [anon_sym_COMMA] = ACTIONS(5128),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(1902),
    [anon_sym_ref] = ACTIONS(1904),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1906),
  },
  [1719] = {
    [sym_raw_string_literal] = ACTIONS(5130),
    [sym_float_literal] = ACTIONS(5130),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(5130),
    [anon_sym_SEMI] = ACTIONS(5130),
    [anon_sym_macro_rules_BANG] = ACTIONS(5130),
    [anon_sym_LPAREN] = ACTIONS(5130),
    [anon_sym_LBRACE] = ACTIONS(5130),
    [anon_sym_RBRACE] = ACTIONS(5130),
    [anon_sym_LBRACK] = ACTIONS(5130),
    [anon_sym_PLUS] = ACTIONS(5132),
    [anon_sym_STAR] = ACTIONS(5132),
    [anon_sym_u8] = ACTIONS(5132),
    [anon_sym_i8] = ACTIONS(5132),
    [anon_sym_u16] = ACTIONS(5132),
    [anon_sym_i16] = ACTIONS(5132),
    [anon_sym_u32] = ACTIONS(5132),
    [anon_sym_i32] = ACTIONS(5132),
    [anon_sym_u64] = ACTIONS(5132),
    [anon_sym_i64] = ACTIONS(5132),
    [anon_sym_u128] = ACTIONS(5132),
    [anon_sym_i128] = ACTIONS(5132),
    [anon_sym_isize] = ACTIONS(5132),
    [anon_sym_usize] = ACTIONS(5132),
    [anon_sym_f32] = ACTIONS(5132),
    [anon_sym_f64] = ACTIONS(5132),
    [anon_sym_bool] = ACTIONS(5132),
    [anon_sym_str] = ACTIONS(5132),
    [anon_sym_char] = ACTIONS(5132),
    [anon_sym_AMP] = ACTIONS(5132),
    [anon_sym_DASH] = ACTIONS(5132),
    [anon_sym_DOT] = ACTIONS(5132),
    [anon_sym_DASH_EQ] = ACTIONS(5130),
    [anon_sym_COLON_COLON] = ACTIONS(5130),
    [anon_sym_BANG] = ACTIONS(5132),
    [anon_sym_BANG_EQ] = ACTIONS(5130),
    [anon_sym_STAR_EQ] = ACTIONS(5130),
    [anon_sym_SLASH] = ACTIONS(5132),
    [anon_sym_SLASH_EQ] = ACTIONS(5130),
    [anon_sym_AMP_AMP] = ACTIONS(5130),
    [anon_sym_AMP_EQ] = ACTIONS(5130),
    [anon_sym_POUND] = ACTIONS(5130),
    [anon_sym_PERCENT] = ACTIONS(5132),
    [anon_sym_PERCENT_EQ] = ACTIONS(5130),
    [anon_sym_CARET] = ACTIONS(5132),
    [anon_sym_CARET_EQ] = ACTIONS(5130),
    [anon_sym_PLUS_EQ] = ACTIONS(5130),
    [anon_sym_LT] = ACTIONS(5132),
    [anon_sym_LT_LT] = ACTIONS(5132),
    [anon_sym_LT_LT_EQ] = ACTIONS(5130),
    [anon_sym_LT_EQ] = ACTIONS(5130),
    [anon_sym_EQ] = ACTIONS(5132),
    [anon_sym_EQ_EQ] = ACTIONS(5130),
    [anon_sym_GT] = ACTIONS(5132),
    [anon_sym_GT_EQ] = ACTIONS(5130),
    [anon_sym_GT_GT] = ACTIONS(5132),
    [anon_sym_GT_GT_EQ] = ACTIONS(5130),
    [anon_sym_PIPE] = ACTIONS(5132),
    [anon_sym_PIPE_EQ] = ACTIONS(5130),
    [anon_sym_PIPE_PIPE] = ACTIONS(5130),
    [anon_sym_QMARK] = ACTIONS(5130),
    [anon_sym_SQUOTE] = ACTIONS(5132),
    [anon_sym_DOT_DOT] = ACTIONS(5132),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5130),
    [anon_sym_as] = ACTIONS(5132),
    [anon_sym_break] = ACTIONS(5132),
    [anon_sym_const] = ACTIONS(5132),
    [anon_sym_continue] = ACTIONS(5132),
    [anon_sym_default] = ACTIONS(5132),
    [anon_sym_enum] = ACTIONS(5132),
    [anon_sym_fn] = ACTIONS(5132),
    [anon_sym_for] = ACTIONS(5132),
    [anon_sym_if] = ACTIONS(5132),
    [anon_sym_impl] = ACTIONS(5132),
    [anon_sym_let] = ACTIONS(5132),
    [anon_sym_loop] = ACTIONS(5132),
    [anon_sym_match] = ACTIONS(5132),
    [anon_sym_mod] = ACTIONS(5132),
    [anon_sym_pub] = ACTIONS(5132),
    [anon_sym_return] = ACTIONS(5132),
    [anon_sym_static] = ACTIONS(5132),
    [anon_sym_struct] = ACTIONS(5132),
    [anon_sym_trait] = ACTIONS(5132),
    [anon_sym_type] = ACTIONS(5132),
    [anon_sym_union] = ACTIONS(5132),
    [anon_sym_unsafe] = ACTIONS(5132),
    [anon_sym_use] = ACTIONS(5132),
    [anon_sym_while] = ACTIONS(5132),
    [anon_sym_extern] = ACTIONS(5132),
    [anon_sym_move] = ACTIONS(5132),
    [sym_integer_literal] = ACTIONS(5130),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5130),
    [sym_char_literal] = ACTIONS(5130),
    [anon_sym_true] = ACTIONS(5132),
    [anon_sym_false] = ACTIONS(5132),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5132),
    [sym_self] = ACTIONS(5132),
    [sym_super] = ACTIONS(5132),
    [sym_crate] = ACTIONS(5132),
    [sym_metavariable] = ACTIONS(5130),
  },
  [1720] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2323),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2323),
    [sym_macro_invocation] = STATE(2323),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2323),
    [sym_unary_expression] = STATE(2323),
    [sym_try_expression] = STATE(2323),
    [sym_reference_expression] = STATE(2323),
    [sym_binary_expression] = STATE(2323),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2323),
    [sym_call_expression] = STATE(2323),
    [sym_array_expression] = STATE(2323),
    [sym_parenthesized_expression] = STATE(2323),
    [sym_tuple_expression] = STATE(2323),
    [sym_unit_expression] = STATE(2323),
    [sym_struct_expression] = STATE(2323),
    [sym_if_expression] = STATE(2324),
    [sym_if_let_expression] = STATE(2324),
    [sym_match_expression] = STATE(2324),
    [sym_while_expression] = STATE(2324),
    [sym_while_let_expression] = STATE(2324),
    [sym_loop_expression] = STATE(2324),
    [sym_for_expression] = STATE(2324),
    [sym_closure_expression] = STATE(2323),
    [sym_closure_parameters] = STATE(1138),
    [sym_loop_label] = STATE(2325),
    [sym_break_expression] = STATE(2323),
    [sym_continue_expression] = STATE(2323),
    [sym_index_expression] = STATE(2323),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2324),
    [sym_block] = STATE(2324),
    [sym__literal] = STATE(2323),
    [sym_string_literal] = STATE(2323),
    [sym_boolean_literal] = STATE(2323),
    [sym_raw_string_literal] = ACTIONS(5134),
    [sym_float_literal] = ACTIONS(5134),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(5136),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(2245),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(5138),
    [anon_sym_if] = ACTIONS(5140),
    [anon_sym_loop] = ACTIONS(5142),
    [anon_sym_match] = ACTIONS(5144),
    [anon_sym_return] = ACTIONS(2249),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(5146),
    [anon_sym_while] = ACTIONS(5148),
    [anon_sym_move] = ACTIONS(2251),
    [sym_integer_literal] = ACTIONS(5134),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(5134),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1721] = {
    [sym_bracketed_type] = STATE(1041),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(1042),
    [sym_scoped_identifier] = STATE(1043),
    [sym_scoped_type_identifier] = STATE(1044),
    [sym__pattern] = STATE(2326),
    [sym_tuple_pattern] = STATE(2326),
    [sym_tuple_struct_pattern] = STATE(2326),
    [sym_struct_pattern] = STATE(2326),
    [sym_remaining_field_pattern] = STATE(2326),
    [sym_mut_pattern] = STATE(2326),
    [sym_range_pattern] = STATE(2326),
    [sym_ref_pattern] = STATE(2326),
    [sym_captured_pattern] = STATE(2326),
    [sym_reference_pattern] = STATE(2326),
    [sym__literal] = STATE(1048),
    [sym_string_literal] = STATE(1048),
    [sym_boolean_literal] = STATE(1048),
    [sym_raw_string_literal] = ACTIONS(2070),
    [sym_float_literal] = ACTIONS(2070),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2072),
    [anon_sym_u8] = ACTIONS(2076),
    [anon_sym_i8] = ACTIONS(2076),
    [anon_sym_u16] = ACTIONS(2076),
    [anon_sym_i16] = ACTIONS(2076),
    [anon_sym_u32] = ACTIONS(2076),
    [anon_sym_i32] = ACTIONS(2076),
    [anon_sym_u64] = ACTIONS(2076),
    [anon_sym_i64] = ACTIONS(2076),
    [anon_sym_u128] = ACTIONS(2076),
    [anon_sym_i128] = ACTIONS(2076),
    [anon_sym_isize] = ACTIONS(2076),
    [anon_sym_usize] = ACTIONS(2076),
    [anon_sym_f32] = ACTIONS(2076),
    [anon_sym_f64] = ACTIONS(2076),
    [anon_sym_bool] = ACTIONS(2076),
    [anon_sym_str] = ACTIONS(2076),
    [anon_sym_char] = ACTIONS(2076),
    [anon_sym__] = ACTIONS(5150),
    [anon_sym_AMP] = ACTIONS(2080),
    [anon_sym_COLON_COLON] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(2086),
    [sym_mutable_specifier] = ACTIONS(2088),
    [anon_sym_ref] = ACTIONS(2090),
    [sym_integer_literal] = ACTIONS(2070),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(769),
    [sym_char_literal] = ACTIONS(2070),
    [anon_sym_true] = ACTIONS(2092),
    [anon_sym_false] = ACTIONS(2092),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2094),
    [sym_self] = ACTIONS(2096),
    [sym_super] = ACTIONS(2096),
    [sym_crate] = ACTIONS(2096),
    [sym_metavariable] = ACTIONS(2098),
  },
  [1722] = {
    [sym_bracketed_type] = STATE(2351),
    [sym_generic_function] = STATE(2353),
    [sym_generic_type_with_turbofish] = STATE(2352),
    [sym__expression] = STATE(2353),
    [sym_macro_invocation] = STATE(2353),
    [sym_scoped_identifier] = STATE(2354),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2355),
    [sym_range_expression] = STATE(2353),
    [sym_unary_expression] = STATE(2353),
    [sym_try_expression] = STATE(2353),
    [sym_reference_expression] = STATE(2353),
    [sym_binary_expression] = STATE(2353),
    [sym_assignment_expression] = STATE(2356),
    [sym_compound_assignment_expr] = STATE(2356),
    [sym_type_cast_expression] = STATE(2356),
    [sym_return_expression] = STATE(2353),
    [sym_call_expression] = STATE(2353),
    [sym_array_expression] = STATE(2353),
    [sym_parenthesized_expression] = STATE(2353),
    [sym_tuple_expression] = STATE(2353),
    [sym_unit_expression] = STATE(2353),
    [sym_struct_expression] = STATE(2353),
    [sym_if_expression] = STATE(2353),
    [sym_if_let_expression] = STATE(2353),
    [sym_match_expression] = STATE(2353),
    [sym_while_expression] = STATE(2353),
    [sym_while_let_expression] = STATE(2353),
    [sym_loop_expression] = STATE(2353),
    [sym_for_expression] = STATE(2353),
    [sym_closure_expression] = STATE(2353),
    [sym_closure_parameters] = STATE(2357),
    [sym_loop_label] = STATE(2358),
    [sym_break_expression] = STATE(2353),
    [sym_continue_expression] = STATE(2353),
    [sym_index_expression] = STATE(2353),
    [sym_field_expression] = STATE(2359),
    [sym_unsafe_block] = STATE(2353),
    [sym_block] = STATE(2353),
    [sym__literal] = STATE(2353),
    [sym_string_literal] = STATE(2353),
    [sym_boolean_literal] = STATE(2353),
    [sym_raw_string_literal] = ACTIONS(5152),
    [sym_float_literal] = ACTIONS(5152),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5154),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_LBRACK] = ACTIONS(5158),
    [anon_sym_STAR] = ACTIONS(5160),
    [anon_sym_u8] = ACTIONS(5162),
    [anon_sym_i8] = ACTIONS(5162),
    [anon_sym_u16] = ACTIONS(5162),
    [anon_sym_i16] = ACTIONS(5162),
    [anon_sym_u32] = ACTIONS(5162),
    [anon_sym_i32] = ACTIONS(5162),
    [anon_sym_u64] = ACTIONS(5162),
    [anon_sym_i64] = ACTIONS(5162),
    [anon_sym_u128] = ACTIONS(5162),
    [anon_sym_i128] = ACTIONS(5162),
    [anon_sym_isize] = ACTIONS(5162),
    [anon_sym_usize] = ACTIONS(5162),
    [anon_sym_f32] = ACTIONS(5162),
    [anon_sym_f64] = ACTIONS(5162),
    [anon_sym_bool] = ACTIONS(5162),
    [anon_sym_str] = ACTIONS(5162),
    [anon_sym_char] = ACTIONS(5162),
    [anon_sym_AMP] = ACTIONS(5164),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_COLON_COLON] = ACTIONS(5166),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5168),
    [anon_sym_break] = ACTIONS(5170),
    [anon_sym_continue] = ACTIONS(5172),
    [anon_sym_default] = ACTIONS(5174),
    [anon_sym_for] = ACTIONS(5176),
    [anon_sym_if] = ACTIONS(5178),
    [anon_sym_loop] = ACTIONS(5180),
    [anon_sym_match] = ACTIONS(5182),
    [anon_sym_return] = ACTIONS(5184),
    [anon_sym_union] = ACTIONS(5174),
    [anon_sym_unsafe] = ACTIONS(5186),
    [anon_sym_while] = ACTIONS(5188),
    [anon_sym_move] = ACTIONS(5190),
    [sym_integer_literal] = ACTIONS(5152),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5192),
    [sym_char_literal] = ACTIONS(5152),
    [anon_sym_true] = ACTIONS(5194),
    [anon_sym_false] = ACTIONS(5194),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5196),
    [sym_self] = ACTIONS(5198),
    [sym_super] = ACTIONS(5200),
    [sym_crate] = ACTIONS(5200),
    [sym_metavariable] = ACTIONS(5202),
  },
  [1723] = {
    [aux_sym_match_pattern_repeat1] = STATE(2361),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(5204),
    [anon_sym_PIPE] = ACTIONS(3339),
    [anon_sym_if] = ACTIONS(5206),
    [sym_line_comment] = ACTIONS(7),
  },
  [1724] = {
    [sym__literal] = STATE(2362),
    [sym_string_literal] = STATE(2362),
    [sym_boolean_literal] = STATE(2362),
    [sym_raw_string_literal] = ACTIONS(5208),
    [sym_float_literal] = ACTIONS(5208),
    [sym_block_comment] = ACTIONS(7),
    [sym_integer_literal] = ACTIONS(5208),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(769),
    [sym_char_literal] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(5210),
    [anon_sym_false] = ACTIONS(5210),
    [sym_line_comment] = ACTIONS(7),
  },
  [1725] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(5212),
    [sym_line_comment] = ACTIONS(7),
  },
  [1726] = {
    [sym_attribute_item] = STATE(1726),
    [aux_sym_enum_variant_list_repeat1] = STATE(1726),
    [sym_raw_string_literal] = ACTIONS(3548),
    [sym_float_literal] = ACTIONS(3548),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(3548),
    [anon_sym_u8] = ACTIONS(4941),
    [anon_sym_i8] = ACTIONS(4941),
    [anon_sym_u16] = ACTIONS(4941),
    [anon_sym_i16] = ACTIONS(4941),
    [anon_sym_u32] = ACTIONS(4941),
    [anon_sym_i32] = ACTIONS(4941),
    [anon_sym_u64] = ACTIONS(4941),
    [anon_sym_i64] = ACTIONS(4941),
    [anon_sym_u128] = ACTIONS(4941),
    [anon_sym_i128] = ACTIONS(4941),
    [anon_sym_isize] = ACTIONS(4941),
    [anon_sym_usize] = ACTIONS(4941),
    [anon_sym_f32] = ACTIONS(4941),
    [anon_sym_f64] = ACTIONS(4941),
    [anon_sym_bool] = ACTIONS(4941),
    [anon_sym_str] = ACTIONS(4941),
    [anon_sym_char] = ACTIONS(4941),
    [anon_sym__] = ACTIONS(4941),
    [anon_sym_AMP] = ACTIONS(3548),
    [anon_sym_COLON_COLON] = ACTIONS(3548),
    [anon_sym_POUND] = ACTIONS(5214),
    [anon_sym_LT] = ACTIONS(3548),
    [anon_sym_DOT_DOT] = ACTIONS(3548),
    [sym_mutable_specifier] = ACTIONS(4941),
    [anon_sym_ref] = ACTIONS(4941),
    [sym_integer_literal] = ACTIONS(3548),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3548),
    [sym_char_literal] = ACTIONS(3548),
    [anon_sym_true] = ACTIONS(4941),
    [anon_sym_false] = ACTIONS(4941),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4941),
    [sym_self] = ACTIONS(4941),
    [sym_super] = ACTIONS(4941),
    [sym_crate] = ACTIONS(4941),
    [sym_metavariable] = ACTIONS(3548),
  },
  [1727] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5217),
    [sym_line_comment] = ACTIONS(7),
  },
  [1728] = {
    [sym_attribute_item] = STATE(2366),
    [sym_bracketed_type] = STATE(1041),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(1042),
    [sym_scoped_identifier] = STATE(1043),
    [sym_scoped_type_identifier] = STATE(1044),
    [sym_match_arm] = STATE(1728),
    [sym_match_pattern] = STATE(2365),
    [sym__pattern] = STATE(1047),
    [sym_tuple_pattern] = STATE(1047),
    [sym_tuple_struct_pattern] = STATE(1047),
    [sym_struct_pattern] = STATE(1047),
    [sym_remaining_field_pattern] = STATE(1047),
    [sym_mut_pattern] = STATE(1047),
    [sym_range_pattern] = STATE(1047),
    [sym_ref_pattern] = STATE(1047),
    [sym_captured_pattern] = STATE(1047),
    [sym_reference_pattern] = STATE(1047),
    [sym__literal] = STATE(1048),
    [sym_string_literal] = STATE(1048),
    [sym_boolean_literal] = STATE(1048),
    [aux_sym_enum_variant_list_repeat1] = STATE(2366),
    [aux_sym_match_expression_repeat1] = STATE(1728),
    [sym_raw_string_literal] = ACTIONS(5219),
    [sym_float_literal] = ACTIONS(5219),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5222),
    [anon_sym_u8] = ACTIONS(5225),
    [anon_sym_i8] = ACTIONS(5225),
    [anon_sym_u16] = ACTIONS(5225),
    [anon_sym_i16] = ACTIONS(5225),
    [anon_sym_u32] = ACTIONS(5225),
    [anon_sym_i32] = ACTIONS(5225),
    [anon_sym_u64] = ACTIONS(5225),
    [anon_sym_i64] = ACTIONS(5225),
    [anon_sym_u128] = ACTIONS(5225),
    [anon_sym_i128] = ACTIONS(5225),
    [anon_sym_isize] = ACTIONS(5225),
    [anon_sym_usize] = ACTIONS(5225),
    [anon_sym_f32] = ACTIONS(5225),
    [anon_sym_f64] = ACTIONS(5225),
    [anon_sym_bool] = ACTIONS(5225),
    [anon_sym_str] = ACTIONS(5225),
    [anon_sym_char] = ACTIONS(5225),
    [anon_sym__] = ACTIONS(5228),
    [anon_sym_AMP] = ACTIONS(5231),
    [anon_sym_COLON_COLON] = ACTIONS(5234),
    [anon_sym_POUND] = ACTIONS(5237),
    [anon_sym_LT] = ACTIONS(5240),
    [anon_sym_DOT_DOT] = ACTIONS(5243),
    [sym_mutable_specifier] = ACTIONS(5246),
    [anon_sym_ref] = ACTIONS(5249),
    [sym_integer_literal] = ACTIONS(5219),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5252),
    [sym_char_literal] = ACTIONS(5219),
    [anon_sym_true] = ACTIONS(5255),
    [anon_sym_false] = ACTIONS(5255),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5258),
    [sym_self] = ACTIONS(5261),
    [sym_super] = ACTIONS(5261),
    [sym_crate] = ACTIONS(5261),
    [sym_metavariable] = ACTIONS(5264),
  },
  [1729] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(5267),
    [anon_sym_default] = ACTIONS(5267),
    [anon_sym_enum] = ACTIONS(5267),
    [anon_sym_fn] = ACTIONS(5267),
    [anon_sym_mod] = ACTIONS(5267),
    [anon_sym_static] = ACTIONS(5267),
    [anon_sym_struct] = ACTIONS(5267),
    [anon_sym_trait] = ACTIONS(5267),
    [anon_sym_type] = ACTIONS(5267),
    [anon_sym_union] = ACTIONS(5267),
    [anon_sym_unsafe] = ACTIONS(5267),
    [anon_sym_use] = ACTIONS(5267),
    [anon_sym_extern] = ACTIONS(5267),
    [sym_line_comment] = ACTIONS(7),
  },
  [1730] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(5269),
    [anon_sym_default] = ACTIONS(5269),
    [anon_sym_enum] = ACTIONS(5269),
    [anon_sym_fn] = ACTIONS(5269),
    [anon_sym_mod] = ACTIONS(5269),
    [anon_sym_static] = ACTIONS(5269),
    [anon_sym_struct] = ACTIONS(5269),
    [anon_sym_trait] = ACTIONS(5269),
    [anon_sym_type] = ACTIONS(5269),
    [anon_sym_union] = ACTIONS(5269),
    [anon_sym_unsafe] = ACTIONS(5269),
    [anon_sym_use] = ACTIONS(5269),
    [anon_sym_extern] = ACTIONS(5269),
    [sym_line_comment] = ACTIONS(7),
  },
  [1731] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5271),
    [anon_sym_PLUS] = ACTIONS(3279),
    [anon_sym_EQ] = ACTIONS(5273),
    [sym_line_comment] = ACTIONS(7),
  },
  [1732] = {
    [sym_raw_string_literal] = ACTIONS(5275),
    [sym_float_literal] = ACTIONS(5275),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(5275),
    [anon_sym_SEMI] = ACTIONS(5275),
    [anon_sym_macro_rules_BANG] = ACTIONS(5275),
    [anon_sym_LPAREN] = ACTIONS(5275),
    [anon_sym_LBRACE] = ACTIONS(5275),
    [anon_sym_RBRACE] = ACTIONS(5275),
    [anon_sym_LBRACK] = ACTIONS(5275),
    [anon_sym_STAR] = ACTIONS(5275),
    [anon_sym_u8] = ACTIONS(5277),
    [anon_sym_i8] = ACTIONS(5277),
    [anon_sym_u16] = ACTIONS(5277),
    [anon_sym_i16] = ACTIONS(5277),
    [anon_sym_u32] = ACTIONS(5277),
    [anon_sym_i32] = ACTIONS(5277),
    [anon_sym_u64] = ACTIONS(5277),
    [anon_sym_i64] = ACTIONS(5277),
    [anon_sym_u128] = ACTIONS(5277),
    [anon_sym_i128] = ACTIONS(5277),
    [anon_sym_isize] = ACTIONS(5277),
    [anon_sym_usize] = ACTIONS(5277),
    [anon_sym_f32] = ACTIONS(5277),
    [anon_sym_f64] = ACTIONS(5277),
    [anon_sym_bool] = ACTIONS(5277),
    [anon_sym_str] = ACTIONS(5277),
    [anon_sym_char] = ACTIONS(5277),
    [anon_sym_AMP] = ACTIONS(5275),
    [anon_sym_DASH] = ACTIONS(5275),
    [anon_sym_COLON_COLON] = ACTIONS(5275),
    [anon_sym_BANG] = ACTIONS(5275),
    [anon_sym_POUND] = ACTIONS(5275),
    [anon_sym_LT] = ACTIONS(5275),
    [anon_sym_PIPE] = ACTIONS(5275),
    [anon_sym_SQUOTE] = ACTIONS(5277),
    [anon_sym_DOT_DOT] = ACTIONS(5275),
    [anon_sym_break] = ACTIONS(5277),
    [anon_sym_const] = ACTIONS(5277),
    [anon_sym_continue] = ACTIONS(5277),
    [anon_sym_default] = ACTIONS(5277),
    [anon_sym_enum] = ACTIONS(5277),
    [anon_sym_fn] = ACTIONS(5277),
    [anon_sym_for] = ACTIONS(5277),
    [anon_sym_if] = ACTIONS(5277),
    [anon_sym_impl] = ACTIONS(5277),
    [anon_sym_let] = ACTIONS(5277),
    [anon_sym_loop] = ACTIONS(5277),
    [anon_sym_match] = ACTIONS(5277),
    [anon_sym_mod] = ACTIONS(5277),
    [anon_sym_pub] = ACTIONS(5277),
    [anon_sym_return] = ACTIONS(5277),
    [anon_sym_static] = ACTIONS(5277),
    [anon_sym_struct] = ACTIONS(5277),
    [anon_sym_trait] = ACTIONS(5277),
    [anon_sym_type] = ACTIONS(5277),
    [anon_sym_union] = ACTIONS(5277),
    [anon_sym_unsafe] = ACTIONS(5277),
    [anon_sym_use] = ACTIONS(5277),
    [anon_sym_while] = ACTIONS(5277),
    [anon_sym_extern] = ACTIONS(5277),
    [anon_sym_move] = ACTIONS(5277),
    [sym_integer_literal] = ACTIONS(5275),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5275),
    [sym_char_literal] = ACTIONS(5275),
    [anon_sym_true] = ACTIONS(5277),
    [anon_sym_false] = ACTIONS(5277),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5277),
    [sym_self] = ACTIONS(5277),
    [sym_super] = ACTIONS(5277),
    [sym_crate] = ACTIONS(5277),
    [sym_metavariable] = ACTIONS(5275),
  },
  [1733] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2369),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2369),
    [sym_macro_invocation] = STATE(2369),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2369),
    [sym_unary_expression] = STATE(2369),
    [sym_try_expression] = STATE(2369),
    [sym_reference_expression] = STATE(2369),
    [sym_binary_expression] = STATE(2369),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2369),
    [sym_call_expression] = STATE(2369),
    [sym_array_expression] = STATE(2369),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_tuple_expression] = STATE(2369),
    [sym_unit_expression] = STATE(2369),
    [sym_struct_expression] = STATE(2369),
    [sym_if_expression] = STATE(2369),
    [sym_if_let_expression] = STATE(2369),
    [sym_match_expression] = STATE(2369),
    [sym_while_expression] = STATE(2369),
    [sym_while_let_expression] = STATE(2369),
    [sym_loop_expression] = STATE(2369),
    [sym_for_expression] = STATE(2369),
    [sym_closure_expression] = STATE(2369),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2369),
    [sym_continue_expression] = STATE(2369),
    [sym_index_expression] = STATE(2369),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2369),
    [sym_block] = STATE(2369),
    [sym__literal] = STATE(2369),
    [sym_string_literal] = STATE(2369),
    [sym_boolean_literal] = STATE(2369),
    [sym_raw_string_literal] = ACTIONS(5279),
    [sym_float_literal] = ACTIONS(5279),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(5279),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(5279),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1734] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5281),
    [anon_sym_RBRACE] = ACTIONS(5281),
    [anon_sym_COMMA] = ACTIONS(5281),
    [anon_sym_EQ] = ACTIONS(5281),
    [anon_sym_where] = ACTIONS(5281),
    [sym_line_comment] = ACTIONS(7),
  },
  [1735] = {
    [sym_meta_item] = STATE(2370),
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(727),
  },
  [1736] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_in] = ACTIONS(5283),
    [sym_line_comment] = ACTIONS(7),
    [sym_self] = ACTIONS(5285),
    [sym_super] = ACTIONS(5285),
    [sym_crate] = ACTIONS(5285),
  },
  [1737] = {
    [aux_sym_ordered_field_declaration_list_repeat1] = STATE(2375),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(5287),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_COMMA] = ACTIONS(5289),
    [sym_line_comment] = ACTIONS(7),
  },
  [1738] = {
    [sym_attribute_item] = STATE(2378),
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym_visibility_modifier] = STATE(2376),
    [sym__type] = STATE(2377),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(2377),
    [sym_function_type] = STATE(2377),
    [sym_tuple_type] = STATE(2377),
    [sym_unit_type] = STATE(2377),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2377),
    [sym_reference_type] = STATE(2377),
    [sym_pointer_type] = STATE(2377),
    [sym_empty_type] = STATE(2377),
    [sym_dynamic_type] = STATE(2377),
    [sym_macro_invocation] = STATE(2377),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_enum_variant_list_repeat1] = STATE(2378),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_RPAREN] = ACTIONS(5287),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_POUND] = ACTIONS(2124),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_pub] = ACTIONS(2126),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1739] = {
    [aux_sym_ordered_field_declaration_list_repeat1] = STATE(2379),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(5287),
    [anon_sym_COMMA] = ACTIONS(5289),
    [sym_line_comment] = ACTIONS(7),
  },
  [1740] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2380),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(2380),
    [sym_function_type] = STATE(2380),
    [sym_tuple_type] = STATE(2380),
    [sym_unit_type] = STATE(2380),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2380),
    [sym_reference_type] = STATE(2380),
    [sym_pointer_type] = STATE(2380),
    [sym_empty_type] = STATE(2380),
    [sym_dynamic_type] = STATE(2380),
    [sym_macro_invocation] = STATE(2380),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1741] = {
    [sym_attribute_item] = STATE(1741),
    [aux_sym_enum_variant_list_repeat1] = STATE(1741),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(3548),
    [anon_sym_LBRACK] = ACTIONS(3548),
    [anon_sym_STAR] = ACTIONS(3548),
    [anon_sym_u8] = ACTIONS(4941),
    [anon_sym_i8] = ACTIONS(4941),
    [anon_sym_u16] = ACTIONS(4941),
    [anon_sym_i16] = ACTIONS(4941),
    [anon_sym_u32] = ACTIONS(4941),
    [anon_sym_i32] = ACTIONS(4941),
    [anon_sym_u64] = ACTIONS(4941),
    [anon_sym_i64] = ACTIONS(4941),
    [anon_sym_u128] = ACTIONS(4941),
    [anon_sym_i128] = ACTIONS(4941),
    [anon_sym_isize] = ACTIONS(4941),
    [anon_sym_usize] = ACTIONS(4941),
    [anon_sym_f32] = ACTIONS(4941),
    [anon_sym_f64] = ACTIONS(4941),
    [anon_sym_bool] = ACTIONS(4941),
    [anon_sym_str] = ACTIONS(4941),
    [anon_sym_char] = ACTIONS(4941),
    [anon_sym_AMP] = ACTIONS(3548),
    [anon_sym_COLON_COLON] = ACTIONS(3548),
    [anon_sym_BANG] = ACTIONS(3548),
    [anon_sym_POUND] = ACTIONS(5291),
    [anon_sym_LT] = ACTIONS(3548),
    [anon_sym_SQUOTE] = ACTIONS(3548),
    [anon_sym_const] = ACTIONS(4941),
    [anon_sym_default] = ACTIONS(4941),
    [anon_sym_fn] = ACTIONS(4941),
    [anon_sym_pub] = ACTIONS(4941),
    [anon_sym_unsafe] = ACTIONS(4941),
    [anon_sym_extern] = ACTIONS(4941),
    [anon_sym_dyn] = ACTIONS(4941),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4941),
    [sym_self] = ACTIONS(4941),
    [sym_super] = ACTIONS(4941),
    [sym_crate] = ACTIONS(4941),
    [sym_metavariable] = ACTIONS(3548),
  },
  [1742] = {
    [sym_raw_string_literal] = ACTIONS(5294),
    [sym_float_literal] = ACTIONS(5294),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(5294),
    [anon_sym_SEMI] = ACTIONS(5294),
    [anon_sym_macro_rules_BANG] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LBRACE] = ACTIONS(5294),
    [anon_sym_RBRACE] = ACTIONS(5294),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_STAR] = ACTIONS(5294),
    [anon_sym_u8] = ACTIONS(5296),
    [anon_sym_i8] = ACTIONS(5296),
    [anon_sym_u16] = ACTIONS(5296),
    [anon_sym_i16] = ACTIONS(5296),
    [anon_sym_u32] = ACTIONS(5296),
    [anon_sym_i32] = ACTIONS(5296),
    [anon_sym_u64] = ACTIONS(5296),
    [anon_sym_i64] = ACTIONS(5296),
    [anon_sym_u128] = ACTIONS(5296),
    [anon_sym_i128] = ACTIONS(5296),
    [anon_sym_isize] = ACTIONS(5296),
    [anon_sym_usize] = ACTIONS(5296),
    [anon_sym_f32] = ACTIONS(5296),
    [anon_sym_f64] = ACTIONS(5296),
    [anon_sym_bool] = ACTIONS(5296),
    [anon_sym_str] = ACTIONS(5296),
    [anon_sym_char] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5294),
    [anon_sym_DASH] = ACTIONS(5294),
    [anon_sym_COLON_COLON] = ACTIONS(5294),
    [anon_sym_BANG] = ACTIONS(5294),
    [anon_sym_POUND] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5294),
    [anon_sym_PIPE] = ACTIONS(5294),
    [anon_sym_SQUOTE] = ACTIONS(5296),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_break] = ACTIONS(5296),
    [anon_sym_const] = ACTIONS(5296),
    [anon_sym_continue] = ACTIONS(5296),
    [anon_sym_default] = ACTIONS(5296),
    [anon_sym_enum] = ACTIONS(5296),
    [anon_sym_fn] = ACTIONS(5296),
    [anon_sym_for] = ACTIONS(5296),
    [anon_sym_if] = ACTIONS(5296),
    [anon_sym_impl] = ACTIONS(5296),
    [anon_sym_let] = ACTIONS(5296),
    [anon_sym_loop] = ACTIONS(5296),
    [anon_sym_match] = ACTIONS(5296),
    [anon_sym_mod] = ACTIONS(5296),
    [anon_sym_pub] = ACTIONS(5296),
    [anon_sym_return] = ACTIONS(5296),
    [anon_sym_static] = ACTIONS(5296),
    [anon_sym_struct] = ACTIONS(5296),
    [anon_sym_trait] = ACTIONS(5296),
    [anon_sym_type] = ACTIONS(5296),
    [anon_sym_union] = ACTIONS(5296),
    [anon_sym_unsafe] = ACTIONS(5296),
    [anon_sym_use] = ACTIONS(5296),
    [anon_sym_while] = ACTIONS(5296),
    [anon_sym_extern] = ACTIONS(5296),
    [anon_sym_move] = ACTIONS(5296),
    [sym_integer_literal] = ACTIONS(5294),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5294),
    [sym_char_literal] = ACTIONS(5294),
    [anon_sym_true] = ACTIONS(5296),
    [anon_sym_false] = ACTIONS(5296),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5296),
    [sym_self] = ACTIONS(5296),
    [sym_super] = ACTIONS(5296),
    [sym_crate] = ACTIONS(5296),
    [sym_metavariable] = ACTIONS(5294),
  },
  [1743] = {
    [sym_function_modifiers] = STATE(2385),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2386),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2387),
    [sym_array_type] = STATE(2386),
    [sym_function_type] = STATE(2386),
    [sym_tuple_type] = STATE(2386),
    [sym_unit_type] = STATE(2386),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2386),
    [sym_reference_type] = STATE(2386),
    [sym_pointer_type] = STATE(2386),
    [sym_empty_type] = STATE(2386),
    [sym_dynamic_type] = STATE(2386),
    [sym_macro_invocation] = STATE(2386),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2388),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(5298),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(5300),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5302),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5304),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1744] = {
    [sym_attribute_item] = STATE(2391),
    [sym_field_declaration] = STATE(2390),
    [sym_visibility_modifier] = STATE(1069),
    [aux_sym_enum_variant_list_repeat1] = STATE(2391),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5306),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_pub] = ACTIONS(1940),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2132),
  },
  [1745] = {
    [aux_sym_field_declaration_list_repeat1] = STATE(2393),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5306),
    [anon_sym_COMMA] = ACTIONS(5308),
    [sym_line_comment] = ACTIONS(7),
  },
  [1746] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(5310),
    [sym_line_comment] = ACTIONS(7),
  },
  [1747] = {
    [aux_sym_field_declaration_list_repeat1] = STATE(2395),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5306),
    [anon_sym_COMMA] = ACTIONS(5308),
    [sym_line_comment] = ACTIONS(7),
  },
  [1748] = {
    [sym_function_modifiers] = STATE(2402),
    [sym_higher_ranked_trait_bound] = STATE(2403),
    [sym_removed_trait_bound] = STATE(2403),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2404),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2404),
    [sym_array_type] = STATE(2404),
    [sym_function_type] = STATE(2404),
    [sym_tuple_type] = STATE(2404),
    [sym_unit_type] = STATE(2404),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2404),
    [sym_reference_type] = STATE(2404),
    [sym_pointer_type] = STATE(2404),
    [sym_empty_type] = STATE(2404),
    [sym_dynamic_type] = STATE(2404),
    [sym_macro_invocation] = STATE(2404),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2405),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(5312),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(5314),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_QMARK] = ACTIONS(5316),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5318),
    [anon_sym_for] = ACTIONS(5320),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5322),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1749] = {
    [sym_where_predicate] = STATE(2237),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1073),
    [sym_generic_type] = STATE(1074),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_reference_type] = STATE(1073),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1075),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4971),
    [anon_sym_LPAREN] = ACTIONS(4971),
    [anon_sym_LBRACE] = ACTIONS(4971),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(1948),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2134),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [1750] = {
    [aux_sym_where_clause_repeat1] = STATE(2407),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4971),
    [anon_sym_LPAREN] = ACTIONS(4971),
    [anon_sym_LBRACE] = ACTIONS(4971),
    [anon_sym_COMMA] = ACTIONS(5324),
    [sym_line_comment] = ACTIONS(7),
  },
  [1751] = {
    [sym_trait_bounds] = STATE(1608),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(5326),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1752] = {
    [aux_sym_where_clause_repeat1] = STATE(2410),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3147),
    [anon_sym_COMMA] = ACTIONS(5328),
    [sym_line_comment] = ACTIONS(7),
  },
  [1753] = {
    [sym_trait_bounds] = STATE(1611),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(5330),
    [sym_line_comment] = ACTIONS(7),
  },
  [1754] = {
    [sym_trait_bounds] = STATE(1611),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(5326),
    [anon_sym_COLON_COLON] = ACTIONS(799),
    [sym_line_comment] = ACTIONS(7),
  },
  [1755] = {
    [sym_trait_bounds] = STATE(1611),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(5330),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1756] = {
    [sym_raw_string_literal] = ACTIONS(5332),
    [sym_float_literal] = ACTIONS(5332),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(5332),
    [anon_sym_SEMI] = ACTIONS(5332),
    [anon_sym_macro_rules_BANG] = ACTIONS(5332),
    [anon_sym_LPAREN] = ACTIONS(5332),
    [anon_sym_LBRACE] = ACTIONS(5332),
    [anon_sym_RBRACE] = ACTIONS(5332),
    [anon_sym_LBRACK] = ACTIONS(5332),
    [anon_sym_STAR] = ACTIONS(5332),
    [anon_sym_u8] = ACTIONS(5334),
    [anon_sym_i8] = ACTIONS(5334),
    [anon_sym_u16] = ACTIONS(5334),
    [anon_sym_i16] = ACTIONS(5334),
    [anon_sym_u32] = ACTIONS(5334),
    [anon_sym_i32] = ACTIONS(5334),
    [anon_sym_u64] = ACTIONS(5334),
    [anon_sym_i64] = ACTIONS(5334),
    [anon_sym_u128] = ACTIONS(5334),
    [anon_sym_i128] = ACTIONS(5334),
    [anon_sym_isize] = ACTIONS(5334),
    [anon_sym_usize] = ACTIONS(5334),
    [anon_sym_f32] = ACTIONS(5334),
    [anon_sym_f64] = ACTIONS(5334),
    [anon_sym_bool] = ACTIONS(5334),
    [anon_sym_str] = ACTIONS(5334),
    [anon_sym_char] = ACTIONS(5334),
    [anon_sym_AMP] = ACTIONS(5332),
    [anon_sym_DASH] = ACTIONS(5332),
    [anon_sym_COLON_COLON] = ACTIONS(5332),
    [anon_sym_BANG] = ACTIONS(5332),
    [anon_sym_POUND] = ACTIONS(5332),
    [anon_sym_LT] = ACTIONS(5332),
    [anon_sym_PIPE] = ACTIONS(5332),
    [anon_sym_SQUOTE] = ACTIONS(5334),
    [anon_sym_DOT_DOT] = ACTIONS(5332),
    [anon_sym_break] = ACTIONS(5334),
    [anon_sym_const] = ACTIONS(5334),
    [anon_sym_continue] = ACTIONS(5334),
    [anon_sym_default] = ACTIONS(5334),
    [anon_sym_enum] = ACTIONS(5334),
    [anon_sym_fn] = ACTIONS(5334),
    [anon_sym_for] = ACTIONS(5334),
    [anon_sym_if] = ACTIONS(5334),
    [anon_sym_impl] = ACTIONS(5334),
    [anon_sym_let] = ACTIONS(5334),
    [anon_sym_loop] = ACTIONS(5334),
    [anon_sym_match] = ACTIONS(5334),
    [anon_sym_mod] = ACTIONS(5334),
    [anon_sym_pub] = ACTIONS(5334),
    [anon_sym_return] = ACTIONS(5334),
    [anon_sym_static] = ACTIONS(5334),
    [anon_sym_struct] = ACTIONS(5334),
    [anon_sym_trait] = ACTIONS(5334),
    [anon_sym_type] = ACTIONS(5334),
    [anon_sym_union] = ACTIONS(5334),
    [anon_sym_unsafe] = ACTIONS(5334),
    [anon_sym_use] = ACTIONS(5334),
    [anon_sym_while] = ACTIONS(5334),
    [anon_sym_extern] = ACTIONS(5334),
    [anon_sym_move] = ACTIONS(5334),
    [sym_integer_literal] = ACTIONS(5332),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5332),
    [sym_char_literal] = ACTIONS(5332),
    [anon_sym_true] = ACTIONS(5334),
    [anon_sym_false] = ACTIONS(5334),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5334),
    [sym_self] = ACTIONS(5334),
    [sym_super] = ACTIONS(5334),
    [sym_crate] = ACTIONS(5334),
    [sym_metavariable] = ACTIONS(5332),
  },
  [1757] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5336),
    [sym_line_comment] = ACTIONS(7),
  },
  [1758] = {
    [sym_where_clause] = STATE(2412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5336),
    [anon_sym_where] = ACTIONS(2138),
    [sym_line_comment] = ACTIONS(7),
  },
  [1759] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5338),
    [anon_sym_LPAREN] = ACTIONS(5338),
    [anon_sym_LBRACE] = ACTIONS(5338),
    [anon_sym_PLUS] = ACTIONS(5338),
    [anon_sym_COMMA] = ACTIONS(5338),
    [anon_sym_EQ] = ACTIONS(5338),
    [anon_sym_GT] = ACTIONS(5338),
    [sym_line_comment] = ACTIONS(7),
  },
  [1760] = {
    [sym_constrained_type_parameter] = STATE(2415),
    [sym_optional_type_parameter] = STATE(2414),
    [sym_lifetime] = STATE(2416),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5340),
    [sym_metavariable] = ACTIONS(5342),
  },
  [1761] = {
    [sym_function_modifiers] = STATE(677),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2417),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(679),
    [sym_array_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_tuple_type] = STATE(2417),
    [sym_unit_type] = STATE(2417),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2417),
    [sym_reference_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_empty_type] = STATE(2417),
    [sym_dynamic_type] = STATE(2417),
    [sym_macro_invocation] = STATE(2417),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(680),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1315),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1317),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1319),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1321),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1762] = {
    [sym_function_modifiers] = STATE(677),
    [sym_higher_ranked_trait_bound] = STATE(2418),
    [sym_removed_trait_bound] = STATE(2418),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2419),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2419),
    [sym_array_type] = STATE(2419),
    [sym_function_type] = STATE(2419),
    [sym_tuple_type] = STATE(2419),
    [sym_unit_type] = STATE(2419),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2419),
    [sym_reference_type] = STATE(2419),
    [sym_pointer_type] = STATE(2419),
    [sym_empty_type] = STATE(2419),
    [sym_dynamic_type] = STATE(2419),
    [sym_macro_invocation] = STATE(2419),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(680),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1315),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1317),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_QMARK] = ACTIONS(2140),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1319),
    [anon_sym_for] = ACTIONS(2142),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1321),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1763] = {
    [aux_sym_trait_bounds_repeat1] = STATE(2420),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(5344),
    [anon_sym_PLUS] = ACTIONS(3397),
    [sym_line_comment] = ACTIONS(7),
  },
  [1764] = {
    [sym_function_modifiers] = STATE(677),
    [sym_higher_ranked_trait_bound] = STATE(2418),
    [sym_removed_trait_bound] = STATE(2418),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2419),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2419),
    [sym_array_type] = STATE(2419),
    [sym_function_type] = STATE(2419),
    [sym_tuple_type] = STATE(2419),
    [sym_unit_type] = STATE(2419),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2419),
    [sym_reference_type] = STATE(2419),
    [sym_pointer_type] = STATE(2419),
    [sym_empty_type] = STATE(2419),
    [sym_dynamic_type] = STATE(2419),
    [sym_macro_invocation] = STATE(2419),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(680),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1315),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1317),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_QMARK] = ACTIONS(2140),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1319),
    [anon_sym_for] = ACTIONS(2142),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1321),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1765] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(3221),
    [anon_sym_COLON] = ACTIONS(3221),
    [sym_line_comment] = ACTIONS(7),
  },
  [1766] = {
    [aux_sym_type_parameters_repeat1] = STATE(1666),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(2022),
    [anon_sym_GT] = ACTIONS(5346),
    [sym_line_comment] = ACTIONS(7),
  },
  [1767] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(3229),
    [anon_sym_COLON] = ACTIONS(3229),
    [sym_line_comment] = ACTIONS(7),
  },
  [1768] = {
    [aux_sym_type_parameters_repeat1] = STATE(1666),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(2022),
    [anon_sym_GT] = ACTIONS(5348),
    [sym_line_comment] = ACTIONS(7),
  },
  [1769] = {
    [sym_raw_string_literal] = ACTIONS(5350),
    [sym_float_literal] = ACTIONS(5350),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(5350),
    [anon_sym_SEMI] = ACTIONS(5350),
    [anon_sym_macro_rules_BANG] = ACTIONS(5350),
    [anon_sym_LPAREN] = ACTIONS(5350),
    [anon_sym_LBRACE] = ACTIONS(5350),
    [anon_sym_RBRACE] = ACTIONS(5350),
    [anon_sym_LBRACK] = ACTIONS(5350),
    [anon_sym_STAR] = ACTIONS(5350),
    [anon_sym_u8] = ACTIONS(5352),
    [anon_sym_i8] = ACTIONS(5352),
    [anon_sym_u16] = ACTIONS(5352),
    [anon_sym_i16] = ACTIONS(5352),
    [anon_sym_u32] = ACTIONS(5352),
    [anon_sym_i32] = ACTIONS(5352),
    [anon_sym_u64] = ACTIONS(5352),
    [anon_sym_i64] = ACTIONS(5352),
    [anon_sym_u128] = ACTIONS(5352),
    [anon_sym_i128] = ACTIONS(5352),
    [anon_sym_isize] = ACTIONS(5352),
    [anon_sym_usize] = ACTIONS(5352),
    [anon_sym_f32] = ACTIONS(5352),
    [anon_sym_f64] = ACTIONS(5352),
    [anon_sym_bool] = ACTIONS(5352),
    [anon_sym_str] = ACTIONS(5352),
    [anon_sym_char] = ACTIONS(5352),
    [anon_sym_AMP] = ACTIONS(5350),
    [anon_sym_DASH] = ACTIONS(5350),
    [anon_sym_COLON_COLON] = ACTIONS(5350),
    [anon_sym_BANG] = ACTIONS(5350),
    [anon_sym_POUND] = ACTIONS(5350),
    [anon_sym_LT] = ACTIONS(5350),
    [anon_sym_PIPE] = ACTIONS(5350),
    [anon_sym_SQUOTE] = ACTIONS(5352),
    [anon_sym_DOT_DOT] = ACTIONS(5350),
    [anon_sym_break] = ACTIONS(5352),
    [anon_sym_const] = ACTIONS(5352),
    [anon_sym_continue] = ACTIONS(5352),
    [anon_sym_default] = ACTIONS(5352),
    [anon_sym_enum] = ACTIONS(5352),
    [anon_sym_fn] = ACTIONS(5352),
    [anon_sym_for] = ACTIONS(5352),
    [anon_sym_if] = ACTIONS(5352),
    [anon_sym_impl] = ACTIONS(5352),
    [anon_sym_let] = ACTIONS(5352),
    [anon_sym_loop] = ACTIONS(5352),
    [anon_sym_match] = ACTIONS(5352),
    [anon_sym_mod] = ACTIONS(5352),
    [anon_sym_pub] = ACTIONS(5352),
    [anon_sym_return] = ACTIONS(5352),
    [anon_sym_static] = ACTIONS(5352),
    [anon_sym_struct] = ACTIONS(5352),
    [anon_sym_trait] = ACTIONS(5352),
    [anon_sym_type] = ACTIONS(5352),
    [anon_sym_union] = ACTIONS(5352),
    [anon_sym_unsafe] = ACTIONS(5352),
    [anon_sym_use] = ACTIONS(5352),
    [anon_sym_while] = ACTIONS(5352),
    [anon_sym_extern] = ACTIONS(5352),
    [anon_sym_move] = ACTIONS(5352),
    [sym_integer_literal] = ACTIONS(5350),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5350),
    [sym_char_literal] = ACTIONS(5350),
    [anon_sym_true] = ACTIONS(5352),
    [anon_sym_false] = ACTIONS(5352),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5352),
    [sym_self] = ACTIONS(5352),
    [sym_super] = ACTIONS(5352),
    [sym_crate] = ACTIONS(5352),
    [sym_metavariable] = ACTIONS(5350),
  },
  [1770] = {
    [sym_function_modifiers] = STATE(1097),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(821),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1102),
    [sym_array_type] = STATE(821),
    [sym_function_type] = STATE(821),
    [sym_tuple_type] = STATE(821),
    [sym_unit_type] = STATE(821),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(821),
    [sym_reference_type] = STATE(821),
    [sym_pointer_type] = STATE(821),
    [sym_empty_type] = STATE(821),
    [sym_dynamic_type] = STATE(821),
    [sym_macro_invocation] = STATE(821),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2156),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2162),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2166),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1771] = {
    [sym_function_modifiers] = STATE(1097),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1102),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2156),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2162),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2166),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1772] = {
    [sym_function_modifiers] = STATE(1097),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1102),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(3425),
    [anon_sym_STAR] = ACTIONS(2156),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2162),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(5354),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2166),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1773] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1760),
    [anon_sym_PLUS] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(5356),
    [sym_line_comment] = ACTIONS(7),
  },
  [1774] = {
    [sym_function_modifiers] = STATE(1097),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2417),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1102),
    [sym_array_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_tuple_type] = STATE(2417),
    [sym_unit_type] = STATE(2417),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2417),
    [sym_reference_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_empty_type] = STATE(2417),
    [sym_dynamic_type] = STATE(2417),
    [sym_macro_invocation] = STATE(2417),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2156),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2162),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2166),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1775] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1794),
    [anon_sym_PLUS] = ACTIONS(1794),
    [anon_sym_DASH_GT] = ACTIONS(5358),
    [sym_line_comment] = ACTIONS(7),
  },
  [1776] = {
    [sym_parameters] = STATE(2426),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [1777] = {
    [sym_parameters] = STATE(2427),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1778] = {
    [sym_parameters] = STATE(2426),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [1779] = {
    [sym_function_modifiers] = STATE(1097),
    [sym_higher_ranked_trait_bound] = STATE(2418),
    [sym_removed_trait_bound] = STATE(2418),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2419),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2419),
    [sym_array_type] = STATE(2419),
    [sym_function_type] = STATE(2419),
    [sym_tuple_type] = STATE(2419),
    [sym_unit_type] = STATE(2419),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2419),
    [sym_reference_type] = STATE(2419),
    [sym_pointer_type] = STATE(2419),
    [sym_empty_type] = STATE(2419),
    [sym_dynamic_type] = STATE(2419),
    [sym_macro_invocation] = STATE(2419),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2156),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_QMARK] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2162),
    [anon_sym_for] = ACTIONS(2164),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2166),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1780] = {
    [aux_sym_trait_bounds_repeat1] = STATE(2428),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5344),
    [anon_sym_PLUS] = ACTIONS(3417),
    [sym_line_comment] = ACTIONS(7),
  },
  [1781] = {
    [sym_function_modifiers] = STATE(1097),
    [sym_higher_ranked_trait_bound] = STATE(2418),
    [sym_removed_trait_bound] = STATE(2418),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2419),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2419),
    [sym_array_type] = STATE(2419),
    [sym_function_type] = STATE(2419),
    [sym_tuple_type] = STATE(2419),
    [sym_unit_type] = STATE(2419),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2419),
    [sym_reference_type] = STATE(2419),
    [sym_pointer_type] = STATE(2419),
    [sym_empty_type] = STATE(2419),
    [sym_dynamic_type] = STATE(2419),
    [sym_macro_invocation] = STATE(2419),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2156),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_QMARK] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2162),
    [anon_sym_for] = ACTIONS(2164),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2166),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1782] = {
    [sym_raw_string_literal] = ACTIONS(5360),
    [sym_float_literal] = ACTIONS(5360),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(5360),
    [anon_sym_SEMI] = ACTIONS(5360),
    [anon_sym_macro_rules_BANG] = ACTIONS(5360),
    [anon_sym_LPAREN] = ACTIONS(5360),
    [anon_sym_LBRACE] = ACTIONS(5360),
    [anon_sym_RBRACE] = ACTIONS(5360),
    [anon_sym_LBRACK] = ACTIONS(5360),
    [anon_sym_STAR] = ACTIONS(5360),
    [anon_sym_u8] = ACTIONS(5362),
    [anon_sym_i8] = ACTIONS(5362),
    [anon_sym_u16] = ACTIONS(5362),
    [anon_sym_i16] = ACTIONS(5362),
    [anon_sym_u32] = ACTIONS(5362),
    [anon_sym_i32] = ACTIONS(5362),
    [anon_sym_u64] = ACTIONS(5362),
    [anon_sym_i64] = ACTIONS(5362),
    [anon_sym_u128] = ACTIONS(5362),
    [anon_sym_i128] = ACTIONS(5362),
    [anon_sym_isize] = ACTIONS(5362),
    [anon_sym_usize] = ACTIONS(5362),
    [anon_sym_f32] = ACTIONS(5362),
    [anon_sym_f64] = ACTIONS(5362),
    [anon_sym_bool] = ACTIONS(5362),
    [anon_sym_str] = ACTIONS(5362),
    [anon_sym_char] = ACTIONS(5362),
    [anon_sym_AMP] = ACTIONS(5360),
    [anon_sym_DASH] = ACTIONS(5360),
    [anon_sym_COLON_COLON] = ACTIONS(5360),
    [anon_sym_BANG] = ACTIONS(5360),
    [anon_sym_POUND] = ACTIONS(5360),
    [anon_sym_LT] = ACTIONS(5360),
    [anon_sym_PIPE] = ACTIONS(5360),
    [anon_sym_SQUOTE] = ACTIONS(5362),
    [anon_sym_DOT_DOT] = ACTIONS(5360),
    [anon_sym_break] = ACTIONS(5362),
    [anon_sym_const] = ACTIONS(5362),
    [anon_sym_continue] = ACTIONS(5362),
    [anon_sym_default] = ACTIONS(5362),
    [anon_sym_enum] = ACTIONS(5362),
    [anon_sym_fn] = ACTIONS(5362),
    [anon_sym_for] = ACTIONS(5362),
    [anon_sym_if] = ACTIONS(5362),
    [anon_sym_impl] = ACTIONS(5362),
    [anon_sym_let] = ACTIONS(5362),
    [anon_sym_loop] = ACTIONS(5362),
    [anon_sym_match] = ACTIONS(5362),
    [anon_sym_mod] = ACTIONS(5362),
    [anon_sym_pub] = ACTIONS(5362),
    [anon_sym_return] = ACTIONS(5362),
    [anon_sym_static] = ACTIONS(5362),
    [anon_sym_struct] = ACTIONS(5362),
    [anon_sym_trait] = ACTIONS(5362),
    [anon_sym_type] = ACTIONS(5362),
    [anon_sym_union] = ACTIONS(5362),
    [anon_sym_unsafe] = ACTIONS(5362),
    [anon_sym_use] = ACTIONS(5362),
    [anon_sym_while] = ACTIONS(5362),
    [anon_sym_extern] = ACTIONS(5362),
    [anon_sym_move] = ACTIONS(5362),
    [sym_integer_literal] = ACTIONS(5360),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5360),
    [sym_char_literal] = ACTIONS(5360),
    [anon_sym_true] = ACTIONS(5362),
    [anon_sym_false] = ACTIONS(5362),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5362),
    [sym_self] = ACTIONS(5362),
    [sym_super] = ACTIONS(5362),
    [sym_crate] = ACTIONS(5362),
    [sym_metavariable] = ACTIONS(5360),
  },
  [1783] = {
    [sym_function_modifiers] = STATE(1097),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(862),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2156),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2162),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2166),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1784] = {
    [sym_function_modifiers] = STATE(1097),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1102),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2156),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2162),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2166),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1785] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5364),
    [anon_sym_PLUS] = ACTIONS(3423),
    [sym_line_comment] = ACTIONS(7),
  },
  [1786] = {
    [sym_raw_string_literal] = ACTIONS(5366),
    [sym_float_literal] = ACTIONS(5366),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(5366),
    [anon_sym_SEMI] = ACTIONS(5366),
    [anon_sym_macro_rules_BANG] = ACTIONS(5366),
    [anon_sym_LPAREN] = ACTIONS(5366),
    [anon_sym_LBRACE] = ACTIONS(5366),
    [anon_sym_RBRACE] = ACTIONS(5366),
    [anon_sym_LBRACK] = ACTIONS(5366),
    [anon_sym_STAR] = ACTIONS(5366),
    [anon_sym_u8] = ACTIONS(5368),
    [anon_sym_i8] = ACTIONS(5368),
    [anon_sym_u16] = ACTIONS(5368),
    [anon_sym_i16] = ACTIONS(5368),
    [anon_sym_u32] = ACTIONS(5368),
    [anon_sym_i32] = ACTIONS(5368),
    [anon_sym_u64] = ACTIONS(5368),
    [anon_sym_i64] = ACTIONS(5368),
    [anon_sym_u128] = ACTIONS(5368),
    [anon_sym_i128] = ACTIONS(5368),
    [anon_sym_isize] = ACTIONS(5368),
    [anon_sym_usize] = ACTIONS(5368),
    [anon_sym_f32] = ACTIONS(5368),
    [anon_sym_f64] = ACTIONS(5368),
    [anon_sym_bool] = ACTIONS(5368),
    [anon_sym_str] = ACTIONS(5368),
    [anon_sym_char] = ACTIONS(5368),
    [anon_sym_AMP] = ACTIONS(5366),
    [anon_sym_DASH] = ACTIONS(5366),
    [anon_sym_COLON_COLON] = ACTIONS(5366),
    [anon_sym_BANG] = ACTIONS(5366),
    [anon_sym_POUND] = ACTIONS(5366),
    [anon_sym_LT] = ACTIONS(5366),
    [anon_sym_PIPE] = ACTIONS(5366),
    [anon_sym_SQUOTE] = ACTIONS(5368),
    [anon_sym_DOT_DOT] = ACTIONS(5366),
    [anon_sym_break] = ACTIONS(5368),
    [anon_sym_const] = ACTIONS(5368),
    [anon_sym_continue] = ACTIONS(5368),
    [anon_sym_default] = ACTIONS(5368),
    [anon_sym_enum] = ACTIONS(5368),
    [anon_sym_fn] = ACTIONS(5368),
    [anon_sym_for] = ACTIONS(5368),
    [anon_sym_if] = ACTIONS(5368),
    [anon_sym_impl] = ACTIONS(5368),
    [anon_sym_let] = ACTIONS(5368),
    [anon_sym_loop] = ACTIONS(5368),
    [anon_sym_match] = ACTIONS(5368),
    [anon_sym_mod] = ACTIONS(5368),
    [anon_sym_pub] = ACTIONS(5368),
    [anon_sym_return] = ACTIONS(5368),
    [anon_sym_static] = ACTIONS(5368),
    [anon_sym_struct] = ACTIONS(5368),
    [anon_sym_trait] = ACTIONS(5368),
    [anon_sym_type] = ACTIONS(5368),
    [anon_sym_union] = ACTIONS(5368),
    [anon_sym_unsafe] = ACTIONS(5368),
    [anon_sym_use] = ACTIONS(5368),
    [anon_sym_while] = ACTIONS(5368),
    [anon_sym_extern] = ACTIONS(5368),
    [anon_sym_move] = ACTIONS(5368),
    [sym_integer_literal] = ACTIONS(5366),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5366),
    [sym_char_literal] = ACTIONS(5366),
    [anon_sym_true] = ACTIONS(5368),
    [anon_sym_false] = ACTIONS(5368),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5368),
    [sym_self] = ACTIONS(5368),
    [sym_super] = ACTIONS(5368),
    [sym_crate] = ACTIONS(5368),
    [sym_metavariable] = ACTIONS(5366),
  },
  [1787] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5370),
    [sym_line_comment] = ACTIONS(7),
  },
  [1788] = {
    [sym_raw_string_literal] = ACTIONS(5372),
    [sym_float_literal] = ACTIONS(5372),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(5372),
    [anon_sym_SEMI] = ACTIONS(5372),
    [anon_sym_macro_rules_BANG] = ACTIONS(5372),
    [anon_sym_LPAREN] = ACTIONS(5372),
    [anon_sym_LBRACE] = ACTIONS(5372),
    [anon_sym_RBRACE] = ACTIONS(5372),
    [anon_sym_LBRACK] = ACTIONS(5372),
    [anon_sym_STAR] = ACTIONS(5372),
    [anon_sym_u8] = ACTIONS(5374),
    [anon_sym_i8] = ACTIONS(5374),
    [anon_sym_u16] = ACTIONS(5374),
    [anon_sym_i16] = ACTIONS(5374),
    [anon_sym_u32] = ACTIONS(5374),
    [anon_sym_i32] = ACTIONS(5374),
    [anon_sym_u64] = ACTIONS(5374),
    [anon_sym_i64] = ACTIONS(5374),
    [anon_sym_u128] = ACTIONS(5374),
    [anon_sym_i128] = ACTIONS(5374),
    [anon_sym_isize] = ACTIONS(5374),
    [anon_sym_usize] = ACTIONS(5374),
    [anon_sym_f32] = ACTIONS(5374),
    [anon_sym_f64] = ACTIONS(5374),
    [anon_sym_bool] = ACTIONS(5374),
    [anon_sym_str] = ACTIONS(5374),
    [anon_sym_char] = ACTIONS(5374),
    [anon_sym_AMP] = ACTIONS(5372),
    [anon_sym_DASH] = ACTIONS(5372),
    [anon_sym_COLON_COLON] = ACTIONS(5372),
    [anon_sym_BANG] = ACTIONS(5372),
    [anon_sym_POUND] = ACTIONS(5372),
    [anon_sym_LT] = ACTIONS(5372),
    [anon_sym_PIPE] = ACTIONS(5372),
    [anon_sym_SQUOTE] = ACTIONS(5374),
    [anon_sym_DOT_DOT] = ACTIONS(5372),
    [anon_sym_break] = ACTIONS(5374),
    [anon_sym_const] = ACTIONS(5374),
    [anon_sym_continue] = ACTIONS(5374),
    [anon_sym_default] = ACTIONS(5374),
    [anon_sym_enum] = ACTIONS(5374),
    [anon_sym_fn] = ACTIONS(5374),
    [anon_sym_for] = ACTIONS(5374),
    [anon_sym_if] = ACTIONS(5374),
    [anon_sym_impl] = ACTIONS(5374),
    [anon_sym_let] = ACTIONS(5374),
    [anon_sym_loop] = ACTIONS(5374),
    [anon_sym_match] = ACTIONS(5374),
    [anon_sym_mod] = ACTIONS(5374),
    [anon_sym_pub] = ACTIONS(5374),
    [anon_sym_return] = ACTIONS(5374),
    [anon_sym_static] = ACTIONS(5374),
    [anon_sym_struct] = ACTIONS(5374),
    [anon_sym_trait] = ACTIONS(5374),
    [anon_sym_type] = ACTIONS(5374),
    [anon_sym_union] = ACTIONS(5374),
    [anon_sym_unsafe] = ACTIONS(5374),
    [anon_sym_use] = ACTIONS(5374),
    [anon_sym_while] = ACTIONS(5374),
    [anon_sym_extern] = ACTIONS(5374),
    [anon_sym_move] = ACTIONS(5374),
    [sym_integer_literal] = ACTIONS(5372),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5372),
    [sym_char_literal] = ACTIONS(5372),
    [anon_sym_true] = ACTIONS(5374),
    [anon_sym_false] = ACTIONS(5374),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5374),
    [sym_self] = ACTIONS(5374),
    [sym_super] = ACTIONS(5374),
    [sym_crate] = ACTIONS(5374),
    [sym_metavariable] = ACTIONS(5372),
  },
  [1789] = {
    [sym_declaration_list] = STATE(2431),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [sym_line_comment] = ACTIONS(7),
  },
  [1790] = {
    [sym_declaration_list] = STATE(2431),
    [sym_where_clause] = STATE(2432),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [1791] = {
    [sym_declaration_list] = STATE(2431),
    [sym_where_clause] = STATE(2432),
    [sym_impl_for_clause] = STATE(2433),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1798),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [1792] = {
    [sym_declaration_list] = STATE(2288),
    [sym_where_clause] = STATE(2289),
    [sym_impl_for_clause] = STATE(2434),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1816),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [1793] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5376),
    [anon_sym_RBRACE] = ACTIONS(5376),
    [anon_sym_COMMA] = ACTIONS(5376),
    [sym_line_comment] = ACTIONS(7),
  },
  [1794] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5378),
    [anon_sym_COMMA] = ACTIONS(5378),
    [anon_sym_COLON_COLON] = ACTIONS(2188),
    [anon_sym_as] = ACTIONS(1093),
    [sym_line_comment] = ACTIONS(7),
  },
  [1795] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5380),
    [anon_sym_COMMA] = ACTIONS(5380),
    [anon_sym_COLON_COLON] = ACTIONS(2192),
    [anon_sym_as] = ACTIONS(1099),
    [sym_line_comment] = ACTIONS(7),
  },
  [1796] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5380),
    [anon_sym_COMMA] = ACTIONS(5380),
    [anon_sym_COLON_COLON] = ACTIONS(449),
    [anon_sym_as] = ACTIONS(1099),
    [sym_line_comment] = ACTIONS(7),
  },
  [1797] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5380),
    [anon_sym_COMMA] = ACTIONS(5380),
    [sym_line_comment] = ACTIONS(7),
  },
  [1798] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5380),
    [anon_sym_COMMA] = ACTIONS(5380),
    [anon_sym_COLON_COLON] = ACTIONS(2194),
    [anon_sym_as] = ACTIONS(1099),
    [sym_line_comment] = ACTIONS(7),
  },
  [1799] = {
    [sym_use_list] = STATE(1797),
    [sym_use_as_clause] = STATE(1797),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_type_with_turbofish] = STATE(212),
    [sym_scoped_identifier] = STATE(1798),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(377),
    [anon_sym_RBRACE] = ACTIONS(5382),
    [anon_sym_u8] = ACTIONS(3443),
    [anon_sym_i8] = ACTIONS(3443),
    [anon_sym_u16] = ACTIONS(3443),
    [anon_sym_i16] = ACTIONS(3443),
    [anon_sym_u32] = ACTIONS(3443),
    [anon_sym_i32] = ACTIONS(3443),
    [anon_sym_u64] = ACTIONS(3443),
    [anon_sym_i64] = ACTIONS(3443),
    [anon_sym_u128] = ACTIONS(3443),
    [anon_sym_i128] = ACTIONS(3443),
    [anon_sym_isize] = ACTIONS(3443),
    [anon_sym_usize] = ACTIONS(3443),
    [anon_sym_f32] = ACTIONS(3443),
    [anon_sym_f64] = ACTIONS(3443),
    [anon_sym_bool] = ACTIONS(3443),
    [anon_sym_str] = ACTIONS(3443),
    [anon_sym_char] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(31),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3445),
    [sym_self] = ACTIONS(3447),
    [sym_super] = ACTIONS(3447),
    [sym_crate] = ACTIONS(3447),
    [sym_metavariable] = ACTIONS(3449),
  },
  [1800] = {
    [aux_sym_use_list_repeat1] = STATE(1800),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5380),
    [anon_sym_COMMA] = ACTIONS(5384),
    [sym_line_comment] = ACTIONS(7),
  },
  [1801] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5387),
    [anon_sym_RBRACE] = ACTIONS(5387),
    [anon_sym_COMMA] = ACTIONS(5387),
    [sym_line_comment] = ACTIONS(7),
  },
  [1802] = {
    [sym_use_list] = STATE(1797),
    [sym_use_as_clause] = STATE(1797),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_type_with_turbofish] = STATE(212),
    [sym_scoped_identifier] = STATE(1798),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(377),
    [anon_sym_RBRACE] = ACTIONS(5389),
    [anon_sym_u8] = ACTIONS(3443),
    [anon_sym_i8] = ACTIONS(3443),
    [anon_sym_u16] = ACTIONS(3443),
    [anon_sym_i16] = ACTIONS(3443),
    [anon_sym_u32] = ACTIONS(3443),
    [anon_sym_i32] = ACTIONS(3443),
    [anon_sym_u64] = ACTIONS(3443),
    [anon_sym_i64] = ACTIONS(3443),
    [anon_sym_u128] = ACTIONS(3443),
    [anon_sym_i128] = ACTIONS(3443),
    [anon_sym_isize] = ACTIONS(3443),
    [anon_sym_usize] = ACTIONS(3443),
    [anon_sym_f32] = ACTIONS(3443),
    [anon_sym_f64] = ACTIONS(3443),
    [anon_sym_bool] = ACTIONS(3443),
    [anon_sym_str] = ACTIONS(3443),
    [anon_sym_char] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(31),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3445),
    [sym_self] = ACTIONS(3447),
    [sym_super] = ACTIONS(3447),
    [sym_crate] = ACTIONS(3447),
    [sym_metavariable] = ACTIONS(3449),
  },
  [1803] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(2438),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [1804] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5391),
    [sym_line_comment] = ACTIONS(7),
  },
  [1805] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5393),
    [anon_sym_LPAREN] = ACTIONS(5393),
    [anon_sym_RPAREN] = ACTIONS(5393),
    [anon_sym_LBRACE] = ACTIONS(5393),
    [anon_sym_RBRACE] = ACTIONS(5393),
    [anon_sym_LBRACK] = ACTIONS(5393),
    [anon_sym_RBRACK] = ACTIONS(5393),
    [anon_sym_PLUS] = ACTIONS(5395),
    [anon_sym_STAR] = ACTIONS(5395),
    [anon_sym_COMMA] = ACTIONS(5393),
    [anon_sym_AMP] = ACTIONS(5395),
    [anon_sym_DASH] = ACTIONS(5395),
    [anon_sym_DOT] = ACTIONS(5395),
    [anon_sym_DASH_EQ] = ACTIONS(5393),
    [anon_sym_BANG_EQ] = ACTIONS(5393),
    [anon_sym_STAR_EQ] = ACTIONS(5393),
    [anon_sym_SLASH] = ACTIONS(5395),
    [anon_sym_SLASH_EQ] = ACTIONS(5393),
    [anon_sym_AMP_AMP] = ACTIONS(5393),
    [anon_sym_AMP_EQ] = ACTIONS(5393),
    [anon_sym_PERCENT] = ACTIONS(5395),
    [anon_sym_PERCENT_EQ] = ACTIONS(5393),
    [anon_sym_CARET] = ACTIONS(5395),
    [anon_sym_CARET_EQ] = ACTIONS(5393),
    [anon_sym_PLUS_EQ] = ACTIONS(5393),
    [anon_sym_LT] = ACTIONS(5395),
    [anon_sym_LT_LT] = ACTIONS(5395),
    [anon_sym_LT_LT_EQ] = ACTIONS(5393),
    [anon_sym_LT_EQ] = ACTIONS(5393),
    [anon_sym_EQ] = ACTIONS(5395),
    [anon_sym_EQ_EQ] = ACTIONS(5393),
    [anon_sym_GT] = ACTIONS(5395),
    [anon_sym_GT_EQ] = ACTIONS(5393),
    [anon_sym_GT_GT] = ACTIONS(5395),
    [anon_sym_GT_GT_EQ] = ACTIONS(5393),
    [anon_sym_PIPE] = ACTIONS(5395),
    [anon_sym_PIPE_EQ] = ACTIONS(5393),
    [anon_sym_PIPE_PIPE] = ACTIONS(5393),
    [anon_sym_QMARK] = ACTIONS(5393),
    [anon_sym_DOT_DOT] = ACTIONS(5395),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5393),
    [anon_sym_as] = ACTIONS(5393),
    [sym_line_comment] = ACTIONS(7),
  },
  [1806] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACK] = ACTIONS(5397),
    [sym_line_comment] = ACTIONS(7),
  },
  [1807] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(361),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(361),
    [sym_macro_invocation] = STATE(361),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(361),
    [sym_unary_expression] = STATE(361),
    [sym_try_expression] = STATE(361),
    [sym_reference_expression] = STATE(361),
    [sym_binary_expression] = STATE(361),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(361),
    [sym_call_expression] = STATE(361),
    [sym_array_expression] = STATE(361),
    [sym_parenthesized_expression] = STATE(361),
    [sym_tuple_expression] = STATE(361),
    [sym_unit_expression] = STATE(361),
    [sym_struct_expression] = STATE(361),
    [sym_if_expression] = STATE(361),
    [sym_if_let_expression] = STATE(361),
    [sym_match_expression] = STATE(361),
    [sym_while_expression] = STATE(361),
    [sym_while_let_expression] = STATE(361),
    [sym_loop_expression] = STATE(361),
    [sym_for_expression] = STATE(361),
    [sym_closure_expression] = STATE(361),
    [sym_closure_parameters] = STATE(1138),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(361),
    [sym_continue_expression] = STATE(361),
    [sym_index_expression] = STATE(361),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(361),
    [sym_block] = STATE(361),
    [sym__literal] = STATE(361),
    [sym_string_literal] = STATE(361),
    [sym_boolean_literal] = STATE(361),
    [sym_raw_string_literal] = ACTIONS(715),
    [sym_float_literal] = ACTIONS(715),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(2245),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(2247),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(2249),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(2251),
    [sym_integer_literal] = ACTIONS(715),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(715),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1808] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(3495),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_AMP] = ACTIONS(3499),
    [anon_sym_DASH] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_BANG_EQ] = ACTIONS(3503),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH] = ACTIONS(3497),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_LT_LT] = ACTIONS(3511),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(3503),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_EQ_EQ] = ACTIONS(3503),
    [anon_sym_GT] = ACTIONS(3509),
    [anon_sym_GT_EQ] = ACTIONS(3503),
    [anon_sym_GT_GT] = ACTIONS(3511),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(3517),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_as] = ACTIONS(909),
    [sym_line_comment] = ACTIONS(7),
  },
  [1809] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(2441),
    [sym_tuple_pattern] = STATE(2441),
    [sym_tuple_struct_pattern] = STATE(2441),
    [sym_struct_pattern] = STATE(2441),
    [sym_remaining_field_pattern] = STATE(2441),
    [sym_mut_pattern] = STATE(2441),
    [sym_ref_pattern] = STATE(2441),
    [sym_captured_pattern] = STATE(2441),
    [sym_reference_pattern] = STATE(2441),
    [sym__literal] = STATE(2441),
    [sym_string_literal] = STATE(2441),
    [sym_boolean_literal] = STATE(2441),
    [sym_raw_string_literal] = ACTIONS(5399),
    [sym_float_literal] = ACTIONS(5399),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(5401),
    [anon_sym_AMP] = ACTIONS(955),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(957),
    [anon_sym_ref] = ACTIONS(959),
    [sym_integer_literal] = ACTIONS(5399),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(5399),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(961),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [1810] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(2442),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [1811] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(3495),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(1043),
    [anon_sym_AMP] = ACTIONS(3499),
    [anon_sym_DASH] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(1043),
    [anon_sym_BANG_EQ] = ACTIONS(3503),
    [anon_sym_STAR_EQ] = ACTIONS(1043),
    [anon_sym_SLASH] = ACTIONS(3497),
    [anon_sym_SLASH_EQ] = ACTIONS(1043),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_AMP_EQ] = ACTIONS(1043),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_PERCENT_EQ] = ACTIONS(1043),
    [anon_sym_CARET] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(1043),
    [anon_sym_PLUS_EQ] = ACTIONS(1043),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_LT_LT] = ACTIONS(3511),
    [anon_sym_LT_LT_EQ] = ACTIONS(1043),
    [anon_sym_LT_EQ] = ACTIONS(3503),
    [anon_sym_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(3503),
    [anon_sym_GT] = ACTIONS(3509),
    [anon_sym_GT_EQ] = ACTIONS(3503),
    [anon_sym_GT_GT] = ACTIONS(3511),
    [anon_sym_GT_GT_EQ] = ACTIONS(1043),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_PIPE_EQ] = ACTIONS(1043),
    [anon_sym_PIPE_PIPE] = ACTIONS(3517),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(3519),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3521),
    [anon_sym_as] = ACTIONS(1043),
    [sym_line_comment] = ACTIONS(7),
  },
  [1812] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2443),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2443),
    [sym_macro_invocation] = STATE(2443),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_try_expression] = STATE(2443),
    [sym_reference_expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2443),
    [sym_call_expression] = STATE(2443),
    [sym_array_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_tuple_expression] = STATE(2443),
    [sym_unit_expression] = STATE(2443),
    [sym_struct_expression] = STATE(2443),
    [sym_if_expression] = STATE(2443),
    [sym_if_let_expression] = STATE(2443),
    [sym_match_expression] = STATE(2443),
    [sym_while_expression] = STATE(2443),
    [sym_while_let_expression] = STATE(2443),
    [sym_loop_expression] = STATE(2443),
    [sym_for_expression] = STATE(2443),
    [sym_closure_expression] = STATE(2443),
    [sym_closure_parameters] = STATE(1138),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2443),
    [sym_continue_expression] = STATE(2443),
    [sym_index_expression] = STATE(2443),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2443),
    [sym_block] = STATE(2443),
    [sym__literal] = STATE(2443),
    [sym_string_literal] = STATE(2443),
    [sym_boolean_literal] = STATE(2443),
    [sym_raw_string_literal] = ACTIONS(5403),
    [sym_float_literal] = ACTIONS(5403),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_DASH] = ACTIONS(3485),
    [anon_sym_DASH_GT] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(2245),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(2247),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(2249),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(2251),
    [sym_integer_literal] = ACTIONS(5403),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(5403),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1813] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2444),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2444),
    [sym_macro_invocation] = STATE(2444),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2444),
    [sym_unary_expression] = STATE(2444),
    [sym_try_expression] = STATE(2444),
    [sym_reference_expression] = STATE(2444),
    [sym_binary_expression] = STATE(2444),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2444),
    [sym_call_expression] = STATE(2444),
    [sym_array_expression] = STATE(2444),
    [sym_parenthesized_expression] = STATE(2444),
    [sym_tuple_expression] = STATE(2444),
    [sym_unit_expression] = STATE(2444),
    [sym_struct_expression] = STATE(2444),
    [sym_if_expression] = STATE(2444),
    [sym_if_let_expression] = STATE(2444),
    [sym_match_expression] = STATE(2444),
    [sym_while_expression] = STATE(2444),
    [sym_while_let_expression] = STATE(2444),
    [sym_loop_expression] = STATE(2444),
    [sym_for_expression] = STATE(2444),
    [sym_closure_expression] = STATE(2444),
    [sym_closure_parameters] = STATE(1138),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2444),
    [sym_continue_expression] = STATE(2444),
    [sym_index_expression] = STATE(2444),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2444),
    [sym_block] = STATE(2444),
    [sym__literal] = STATE(2444),
    [sym_string_literal] = STATE(2444),
    [sym_boolean_literal] = STATE(2444),
    [sym_raw_string_literal] = ACTIONS(5405),
    [sym_float_literal] = ACTIONS(5405),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(2245),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(2247),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(2249),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(2251),
    [sym_integer_literal] = ACTIONS(5405),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(5405),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1814] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(640),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(640),
    [sym_macro_invocation] = STATE(640),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(640),
    [sym_unary_expression] = STATE(640),
    [sym_try_expression] = STATE(640),
    [sym_reference_expression] = STATE(640),
    [sym_binary_expression] = STATE(640),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(640),
    [sym_call_expression] = STATE(640),
    [sym_array_expression] = STATE(640),
    [sym_parenthesized_expression] = STATE(640),
    [sym_tuple_expression] = STATE(640),
    [sym_unit_expression] = STATE(640),
    [sym_struct_expression] = STATE(640),
    [sym_if_expression] = STATE(640),
    [sym_if_let_expression] = STATE(640),
    [sym_match_expression] = STATE(640),
    [sym_while_expression] = STATE(640),
    [sym_while_let_expression] = STATE(640),
    [sym_loop_expression] = STATE(640),
    [sym_for_expression] = STATE(640),
    [sym_closure_expression] = STATE(640),
    [sym_closure_parameters] = STATE(1138),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(640),
    [sym_continue_expression] = STATE(640),
    [sym_index_expression] = STATE(640),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(640),
    [sym_block] = STATE(640),
    [sym__literal] = STATE(640),
    [sym_string_literal] = STATE(640),
    [sym_boolean_literal] = STATE(640),
    [sym_raw_string_literal] = ACTIONS(1257),
    [sym_float_literal] = ACTIONS(1257),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(2245),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(2247),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(2249),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(2251),
    [sym_integer_literal] = ACTIONS(1257),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1257),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1815] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2445),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2445),
    [sym_macro_invocation] = STATE(2445),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2445),
    [sym_unary_expression] = STATE(2445),
    [sym_try_expression] = STATE(2445),
    [sym_reference_expression] = STATE(2445),
    [sym_binary_expression] = STATE(2445),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2445),
    [sym_call_expression] = STATE(2445),
    [sym_array_expression] = STATE(2445),
    [sym_parenthesized_expression] = STATE(2445),
    [sym_tuple_expression] = STATE(2445),
    [sym_unit_expression] = STATE(2445),
    [sym_struct_expression] = STATE(2445),
    [sym_if_expression] = STATE(2445),
    [sym_if_let_expression] = STATE(2445),
    [sym_match_expression] = STATE(2445),
    [sym_while_expression] = STATE(2445),
    [sym_while_let_expression] = STATE(2445),
    [sym_loop_expression] = STATE(2445),
    [sym_for_expression] = STATE(2445),
    [sym_closure_expression] = STATE(2445),
    [sym_closure_parameters] = STATE(1138),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2445),
    [sym_continue_expression] = STATE(2445),
    [sym_index_expression] = STATE(2445),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2445),
    [sym_block] = STATE(2445),
    [sym__literal] = STATE(2445),
    [sym_string_literal] = STATE(2445),
    [sym_boolean_literal] = STATE(2445),
    [sym_raw_string_literal] = ACTIONS(5407),
    [sym_float_literal] = ACTIONS(5407),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(2245),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(2247),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(2249),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(2251),
    [sym_integer_literal] = ACTIONS(5407),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(5407),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1816] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2446),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2446),
    [sym_macro_invocation] = STATE(2446),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2446),
    [sym_unary_expression] = STATE(2446),
    [sym_try_expression] = STATE(2446),
    [sym_reference_expression] = STATE(2446),
    [sym_binary_expression] = STATE(2446),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2446),
    [sym_call_expression] = STATE(2446),
    [sym_array_expression] = STATE(2446),
    [sym_parenthesized_expression] = STATE(2446),
    [sym_tuple_expression] = STATE(2446),
    [sym_unit_expression] = STATE(2446),
    [sym_struct_expression] = STATE(2446),
    [sym_if_expression] = STATE(2446),
    [sym_if_let_expression] = STATE(2446),
    [sym_match_expression] = STATE(2446),
    [sym_while_expression] = STATE(2446),
    [sym_while_let_expression] = STATE(2446),
    [sym_loop_expression] = STATE(2446),
    [sym_for_expression] = STATE(2446),
    [sym_closure_expression] = STATE(2446),
    [sym_closure_parameters] = STATE(1138),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2446),
    [sym_continue_expression] = STATE(2446),
    [sym_index_expression] = STATE(2446),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2446),
    [sym_block] = STATE(2446),
    [sym__literal] = STATE(2446),
    [sym_string_literal] = STATE(2446),
    [sym_boolean_literal] = STATE(2446),
    [sym_raw_string_literal] = ACTIONS(5409),
    [sym_float_literal] = ACTIONS(5409),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(2245),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(2247),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(2249),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(2251),
    [sym_integer_literal] = ACTIONS(5409),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(5409),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1817] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2447),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2447),
    [sym_macro_invocation] = STATE(2447),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2447),
    [sym_unary_expression] = STATE(2447),
    [sym_try_expression] = STATE(2447),
    [sym_reference_expression] = STATE(2447),
    [sym_binary_expression] = STATE(2447),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2447),
    [sym_call_expression] = STATE(2447),
    [sym_array_expression] = STATE(2447),
    [sym_parenthesized_expression] = STATE(2447),
    [sym_tuple_expression] = STATE(2447),
    [sym_unit_expression] = STATE(2447),
    [sym_struct_expression] = STATE(2447),
    [sym_if_expression] = STATE(2447),
    [sym_if_let_expression] = STATE(2447),
    [sym_match_expression] = STATE(2447),
    [sym_while_expression] = STATE(2447),
    [sym_while_let_expression] = STATE(2447),
    [sym_loop_expression] = STATE(2447),
    [sym_for_expression] = STATE(2447),
    [sym_closure_expression] = STATE(2447),
    [sym_closure_parameters] = STATE(1138),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2447),
    [sym_continue_expression] = STATE(2447),
    [sym_index_expression] = STATE(2447),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2447),
    [sym_block] = STATE(2447),
    [sym__literal] = STATE(2447),
    [sym_string_literal] = STATE(2447),
    [sym_boolean_literal] = STATE(2447),
    [sym_raw_string_literal] = ACTIONS(5411),
    [sym_float_literal] = ACTIONS(5411),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(2245),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(2247),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(2249),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(2251),
    [sym_integer_literal] = ACTIONS(5411),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(5411),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1818] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2448),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2448),
    [sym_macro_invocation] = STATE(2448),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2448),
    [sym_unary_expression] = STATE(2448),
    [sym_try_expression] = STATE(2448),
    [sym_reference_expression] = STATE(2448),
    [sym_binary_expression] = STATE(2448),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2448),
    [sym_call_expression] = STATE(2448),
    [sym_array_expression] = STATE(2448),
    [sym_parenthesized_expression] = STATE(2448),
    [sym_tuple_expression] = STATE(2448),
    [sym_unit_expression] = STATE(2448),
    [sym_struct_expression] = STATE(2448),
    [sym_if_expression] = STATE(2448),
    [sym_if_let_expression] = STATE(2448),
    [sym_match_expression] = STATE(2448),
    [sym_while_expression] = STATE(2448),
    [sym_while_let_expression] = STATE(2448),
    [sym_loop_expression] = STATE(2448),
    [sym_for_expression] = STATE(2448),
    [sym_closure_expression] = STATE(2448),
    [sym_closure_parameters] = STATE(1138),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2448),
    [sym_continue_expression] = STATE(2448),
    [sym_index_expression] = STATE(2448),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2448),
    [sym_block] = STATE(2448),
    [sym__literal] = STATE(2448),
    [sym_string_literal] = STATE(2448),
    [sym_boolean_literal] = STATE(2448),
    [sym_raw_string_literal] = ACTIONS(5413),
    [sym_float_literal] = ACTIONS(5413),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(2245),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(2247),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(2249),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(2251),
    [sym_integer_literal] = ACTIONS(5413),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(5413),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1819] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2449),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2449),
    [sym_macro_invocation] = STATE(2449),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2449),
    [sym_unary_expression] = STATE(2449),
    [sym_try_expression] = STATE(2449),
    [sym_reference_expression] = STATE(2449),
    [sym_binary_expression] = STATE(2449),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2449),
    [sym_call_expression] = STATE(2449),
    [sym_array_expression] = STATE(2449),
    [sym_parenthesized_expression] = STATE(2449),
    [sym_tuple_expression] = STATE(2449),
    [sym_unit_expression] = STATE(2449),
    [sym_struct_expression] = STATE(2449),
    [sym_if_expression] = STATE(2449),
    [sym_if_let_expression] = STATE(2449),
    [sym_match_expression] = STATE(2449),
    [sym_while_expression] = STATE(2449),
    [sym_while_let_expression] = STATE(2449),
    [sym_loop_expression] = STATE(2449),
    [sym_for_expression] = STATE(2449),
    [sym_closure_expression] = STATE(2449),
    [sym_closure_parameters] = STATE(1138),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2449),
    [sym_continue_expression] = STATE(2449),
    [sym_index_expression] = STATE(2449),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2449),
    [sym_block] = STATE(2449),
    [sym__literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_boolean_literal] = STATE(2449),
    [sym_raw_string_literal] = ACTIONS(5415),
    [sym_float_literal] = ACTIONS(5415),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(2245),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(2247),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(2249),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(2251),
    [sym_integer_literal] = ACTIONS(5415),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(5415),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1820] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2450),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2450),
    [sym_macro_invocation] = STATE(2450),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2450),
    [sym_unary_expression] = STATE(2450),
    [sym_try_expression] = STATE(2450),
    [sym_reference_expression] = STATE(2450),
    [sym_binary_expression] = STATE(2450),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2450),
    [sym_call_expression] = STATE(2450),
    [sym_array_expression] = STATE(2450),
    [sym_parenthesized_expression] = STATE(2450),
    [sym_tuple_expression] = STATE(2450),
    [sym_unit_expression] = STATE(2450),
    [sym_struct_expression] = STATE(2450),
    [sym_if_expression] = STATE(2450),
    [sym_if_let_expression] = STATE(2450),
    [sym_match_expression] = STATE(2450),
    [sym_while_expression] = STATE(2450),
    [sym_while_let_expression] = STATE(2450),
    [sym_loop_expression] = STATE(2450),
    [sym_for_expression] = STATE(2450),
    [sym_closure_expression] = STATE(2450),
    [sym_closure_parameters] = STATE(1138),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2450),
    [sym_continue_expression] = STATE(2450),
    [sym_index_expression] = STATE(2450),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2450),
    [sym_block] = STATE(2450),
    [sym__literal] = STATE(2450),
    [sym_string_literal] = STATE(2450),
    [sym_boolean_literal] = STATE(2450),
    [sym_raw_string_literal] = ACTIONS(5417),
    [sym_float_literal] = ACTIONS(5417),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(2245),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(2247),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(2249),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(2251),
    [sym_integer_literal] = ACTIONS(5417),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(5417),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1821] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2451),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2451),
    [sym_macro_invocation] = STATE(2451),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2451),
    [sym_unary_expression] = STATE(2451),
    [sym_try_expression] = STATE(2451),
    [sym_reference_expression] = STATE(2451),
    [sym_binary_expression] = STATE(2451),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2451),
    [sym_call_expression] = STATE(2451),
    [sym_array_expression] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2451),
    [sym_tuple_expression] = STATE(2451),
    [sym_unit_expression] = STATE(2451),
    [sym_struct_expression] = STATE(2451),
    [sym_if_expression] = STATE(2451),
    [sym_if_let_expression] = STATE(2451),
    [sym_match_expression] = STATE(2451),
    [sym_while_expression] = STATE(2451),
    [sym_while_let_expression] = STATE(2451),
    [sym_loop_expression] = STATE(2451),
    [sym_for_expression] = STATE(2451),
    [sym_closure_expression] = STATE(2451),
    [sym_closure_parameters] = STATE(1138),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2451),
    [sym_continue_expression] = STATE(2451),
    [sym_index_expression] = STATE(2451),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2451),
    [sym_block] = STATE(2451),
    [sym__literal] = STATE(2451),
    [sym_string_literal] = STATE(2451),
    [sym_boolean_literal] = STATE(2451),
    [sym_raw_string_literal] = ACTIONS(5419),
    [sym_float_literal] = ACTIONS(5419),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(2245),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(2247),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(2249),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(2251),
    [sym_integer_literal] = ACTIONS(5419),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(5419),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1822] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2452),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2452),
    [sym_macro_invocation] = STATE(2452),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2452),
    [sym_unary_expression] = STATE(2452),
    [sym_try_expression] = STATE(2452),
    [sym_reference_expression] = STATE(2452),
    [sym_binary_expression] = STATE(2452),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2452),
    [sym_call_expression] = STATE(2452),
    [sym_array_expression] = STATE(2452),
    [sym_parenthesized_expression] = STATE(2452),
    [sym_tuple_expression] = STATE(2452),
    [sym_unit_expression] = STATE(2452),
    [sym_struct_expression] = STATE(2452),
    [sym_if_expression] = STATE(2452),
    [sym_if_let_expression] = STATE(2452),
    [sym_match_expression] = STATE(2452),
    [sym_while_expression] = STATE(2452),
    [sym_while_let_expression] = STATE(2452),
    [sym_loop_expression] = STATE(2452),
    [sym_for_expression] = STATE(2452),
    [sym_closure_expression] = STATE(2452),
    [sym_closure_parameters] = STATE(1138),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2452),
    [sym_continue_expression] = STATE(2452),
    [sym_index_expression] = STATE(2452),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2452),
    [sym_block] = STATE(2452),
    [sym__literal] = STATE(2452),
    [sym_string_literal] = STATE(2452),
    [sym_boolean_literal] = STATE(2452),
    [sym_raw_string_literal] = ACTIONS(5421),
    [sym_float_literal] = ACTIONS(5421),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(2245),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(2247),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(2249),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(2251),
    [sym_integer_literal] = ACTIONS(5421),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(5421),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1823] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2453),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2453),
    [sym_macro_invocation] = STATE(2453),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2453),
    [sym_unary_expression] = STATE(2453),
    [sym_try_expression] = STATE(2453),
    [sym_reference_expression] = STATE(2453),
    [sym_binary_expression] = STATE(2453),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2453),
    [sym_call_expression] = STATE(2453),
    [sym_array_expression] = STATE(2453),
    [sym_parenthesized_expression] = STATE(2453),
    [sym_tuple_expression] = STATE(2453),
    [sym_unit_expression] = STATE(2453),
    [sym_struct_expression] = STATE(2453),
    [sym_if_expression] = STATE(2453),
    [sym_if_let_expression] = STATE(2453),
    [sym_match_expression] = STATE(2453),
    [sym_while_expression] = STATE(2453),
    [sym_while_let_expression] = STATE(2453),
    [sym_loop_expression] = STATE(2453),
    [sym_for_expression] = STATE(2453),
    [sym_closure_expression] = STATE(2453),
    [sym_closure_parameters] = STATE(1138),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2453),
    [sym_continue_expression] = STATE(2453),
    [sym_index_expression] = STATE(2453),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2453),
    [sym_block] = STATE(2453),
    [sym__literal] = STATE(2453),
    [sym_string_literal] = STATE(2453),
    [sym_boolean_literal] = STATE(2453),
    [sym_raw_string_literal] = ACTIONS(5423),
    [sym_float_literal] = ACTIONS(5423),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(2245),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(2247),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(2249),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(2251),
    [sym_integer_literal] = ACTIONS(5423),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(5423),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1824] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2454),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2454),
    [sym_macro_invocation] = STATE(2454),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2454),
    [sym_unary_expression] = STATE(2454),
    [sym_try_expression] = STATE(2454),
    [sym_reference_expression] = STATE(2454),
    [sym_binary_expression] = STATE(2454),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2454),
    [sym_call_expression] = STATE(2454),
    [sym_array_expression] = STATE(2454),
    [sym_parenthesized_expression] = STATE(2454),
    [sym_tuple_expression] = STATE(2454),
    [sym_unit_expression] = STATE(2454),
    [sym_struct_expression] = STATE(2454),
    [sym_if_expression] = STATE(2454),
    [sym_if_let_expression] = STATE(2454),
    [sym_match_expression] = STATE(2454),
    [sym_while_expression] = STATE(2454),
    [sym_while_let_expression] = STATE(2454),
    [sym_loop_expression] = STATE(2454),
    [sym_for_expression] = STATE(2454),
    [sym_closure_expression] = STATE(2454),
    [sym_closure_parameters] = STATE(1138),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2454),
    [sym_continue_expression] = STATE(2454),
    [sym_index_expression] = STATE(2454),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2454),
    [sym_block] = STATE(2454),
    [sym__literal] = STATE(2454),
    [sym_string_literal] = STATE(2454),
    [sym_boolean_literal] = STATE(2454),
    [sym_raw_string_literal] = ACTIONS(5425),
    [sym_float_literal] = ACTIONS(5425),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(909),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(911),
    [anon_sym_STAR] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_DASH] = ACTIONS(911),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(3485),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(911),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(911),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_LT_LT] = ACTIONS(911),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(909),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_EQ_EQ] = ACTIONS(909),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(911),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_as] = ACTIONS(911),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(2247),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(2249),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(2251),
    [sym_integer_literal] = ACTIONS(5425),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(5425),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1825] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2454),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2454),
    [sym_macro_invocation] = STATE(2454),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2454),
    [sym_unary_expression] = STATE(2454),
    [sym_try_expression] = STATE(2454),
    [sym_reference_expression] = STATE(2454),
    [sym_binary_expression] = STATE(2454),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2454),
    [sym_call_expression] = STATE(2454),
    [sym_array_expression] = STATE(2454),
    [sym_parenthesized_expression] = STATE(2454),
    [sym_tuple_expression] = STATE(2454),
    [sym_unit_expression] = STATE(2454),
    [sym_struct_expression] = STATE(2454),
    [sym_if_expression] = STATE(2454),
    [sym_if_let_expression] = STATE(2454),
    [sym_match_expression] = STATE(2454),
    [sym_while_expression] = STATE(2454),
    [sym_while_let_expression] = STATE(2454),
    [sym_loop_expression] = STATE(2454),
    [sym_for_expression] = STATE(2454),
    [sym_closure_expression] = STATE(2454),
    [sym_closure_parameters] = STATE(1138),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2454),
    [sym_continue_expression] = STATE(2454),
    [sym_index_expression] = STATE(2454),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2454),
    [sym_block] = STATE(2454),
    [sym__literal] = STATE(2454),
    [sym_string_literal] = STATE(2454),
    [sym_boolean_literal] = STATE(2454),
    [sym_raw_string_literal] = ACTIONS(5425),
    [sym_float_literal] = ACTIONS(5425),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(2245),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(2247),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(2249),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(2251),
    [sym_integer_literal] = ACTIONS(5425),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(5425),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1826] = {
    [sym_function_modifiers] = STATE(2459),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(666),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(2460),
    [sym_array_type] = STATE(666),
    [sym_function_type] = STATE(666),
    [sym_tuple_type] = STATE(666),
    [sym_unit_type] = STATE(666),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(666),
    [sym_reference_type] = STATE(666),
    [sym_pointer_type] = STATE(666),
    [sym_empty_type] = STATE(666),
    [sym_dynamic_type] = STATE(666),
    [sym_macro_invocation] = STATE(666),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(2461),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(5429),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5431),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5433),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [1827] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(1323),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(3495),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(1323),
    [anon_sym_AMP] = ACTIONS(3499),
    [anon_sym_DASH] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(3501),
    [anon_sym_BANG_EQ] = ACTIONS(3503),
    [anon_sym_STAR_EQ] = ACTIONS(3501),
    [anon_sym_SLASH] = ACTIONS(3497),
    [anon_sym_SLASH_EQ] = ACTIONS(3501),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_AMP_EQ] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_PERCENT_EQ] = ACTIONS(3501),
    [anon_sym_CARET] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3501),
    [anon_sym_PLUS_EQ] = ACTIONS(3501),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_LT_LT] = ACTIONS(3511),
    [anon_sym_LT_LT_EQ] = ACTIONS(3501),
    [anon_sym_LT_EQ] = ACTIONS(3503),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_EQ_EQ] = ACTIONS(3503),
    [anon_sym_GT] = ACTIONS(3509),
    [anon_sym_GT_EQ] = ACTIONS(3503),
    [anon_sym_GT_GT] = ACTIONS(3511),
    [anon_sym_GT_GT_EQ] = ACTIONS(3501),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_PIPE_EQ] = ACTIONS(3501),
    [anon_sym_PIPE_PIPE] = ACTIONS(3517),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(3519),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3521),
    [anon_sym_as] = ACTIONS(3523),
    [sym_line_comment] = ACTIONS(7),
  },
  [1828] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(5435),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(3495),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(5435),
    [anon_sym_AMP] = ACTIONS(3499),
    [anon_sym_DASH] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(3501),
    [anon_sym_BANG_EQ] = ACTIONS(3503),
    [anon_sym_STAR_EQ] = ACTIONS(3501),
    [anon_sym_SLASH] = ACTIONS(3497),
    [anon_sym_SLASH_EQ] = ACTIONS(3501),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_AMP_EQ] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_PERCENT_EQ] = ACTIONS(3501),
    [anon_sym_CARET] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3501),
    [anon_sym_PLUS_EQ] = ACTIONS(3501),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_LT_LT] = ACTIONS(3511),
    [anon_sym_LT_LT_EQ] = ACTIONS(3501),
    [anon_sym_LT_EQ] = ACTIONS(3503),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_EQ_EQ] = ACTIONS(3503),
    [anon_sym_GT] = ACTIONS(3509),
    [anon_sym_GT_EQ] = ACTIONS(3503),
    [anon_sym_GT_GT] = ACTIONS(3511),
    [anon_sym_GT_GT_EQ] = ACTIONS(3501),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_PIPE_EQ] = ACTIONS(3501),
    [anon_sym_PIPE_PIPE] = ACTIONS(3517),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(3519),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3521),
    [anon_sym_as] = ACTIONS(3523),
    [sym_line_comment] = ACTIONS(7),
  },
  [1829] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5437),
    [anon_sym_LPAREN] = ACTIONS(5437),
    [anon_sym_RPAREN] = ACTIONS(5437),
    [anon_sym_LBRACE] = ACTIONS(5437),
    [anon_sym_RBRACE] = ACTIONS(5437),
    [anon_sym_LBRACK] = ACTIONS(5437),
    [anon_sym_RBRACK] = ACTIONS(5437),
    [anon_sym_PLUS] = ACTIONS(5439),
    [anon_sym_STAR] = ACTIONS(5439),
    [anon_sym_COMMA] = ACTIONS(5437),
    [anon_sym_AMP] = ACTIONS(5439),
    [anon_sym_DASH] = ACTIONS(5439),
    [anon_sym_DOT] = ACTIONS(5439),
    [anon_sym_DASH_EQ] = ACTIONS(5437),
    [anon_sym_BANG_EQ] = ACTIONS(5437),
    [anon_sym_STAR_EQ] = ACTIONS(5437),
    [anon_sym_SLASH] = ACTIONS(5439),
    [anon_sym_SLASH_EQ] = ACTIONS(5437),
    [anon_sym_AMP_AMP] = ACTIONS(5437),
    [anon_sym_AMP_EQ] = ACTIONS(5437),
    [anon_sym_PERCENT] = ACTIONS(5439),
    [anon_sym_PERCENT_EQ] = ACTIONS(5437),
    [anon_sym_CARET] = ACTIONS(5439),
    [anon_sym_CARET_EQ] = ACTIONS(5437),
    [anon_sym_PLUS_EQ] = ACTIONS(5437),
    [anon_sym_LT] = ACTIONS(5439),
    [anon_sym_LT_LT] = ACTIONS(5439),
    [anon_sym_LT_LT_EQ] = ACTIONS(5437),
    [anon_sym_LT_EQ] = ACTIONS(5437),
    [anon_sym_EQ] = ACTIONS(5439),
    [anon_sym_EQ_EQ] = ACTIONS(5437),
    [anon_sym_GT] = ACTIONS(5439),
    [anon_sym_GT_EQ] = ACTIONS(5437),
    [anon_sym_GT_GT] = ACTIONS(5439),
    [anon_sym_GT_GT_EQ] = ACTIONS(5437),
    [anon_sym_PIPE] = ACTIONS(5439),
    [anon_sym_PIPE_EQ] = ACTIONS(5437),
    [anon_sym_PIPE_PIPE] = ACTIONS(5437),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_DOT_DOT] = ACTIONS(5439),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5437),
    [anon_sym_as] = ACTIONS(5437),
    [sym_line_comment] = ACTIONS(7),
  },
  [1830] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5441),
    [anon_sym_COLON] = ACTIONS(2255),
    [anon_sym_COMMA] = ACTIONS(5441),
    [sym_line_comment] = ACTIONS(7),
  },
  [1831] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5443),
    [anon_sym_COMMA] = ACTIONS(5443),
    [sym_line_comment] = ACTIONS(7),
  },
  [1832] = {
    [sym_attribute_item] = STATE(582),
    [sym_field_initializer] = STATE(1831),
    [sym_base_field_initializer] = STATE(1831),
    [aux_sym_enum_variant_list_repeat1] = STATE(582),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5445),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_DOT_DOT] = ACTIONS(1135),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3535),
  },
  [1833] = {
    [aux_sym_field_initializer_list_repeat1] = STATE(1833),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5443),
    [anon_sym_COMMA] = ACTIONS(5447),
    [sym_line_comment] = ACTIONS(7),
  },
  [1834] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5450),
    [anon_sym_LPAREN] = ACTIONS(5450),
    [anon_sym_RPAREN] = ACTIONS(5450),
    [anon_sym_LBRACE] = ACTIONS(5450),
    [anon_sym_RBRACE] = ACTIONS(5450),
    [anon_sym_LBRACK] = ACTIONS(5450),
    [anon_sym_RBRACK] = ACTIONS(5450),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_COMMA] = ACTIONS(5450),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_DASH] = ACTIONS(5452),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_DASH_EQ] = ACTIONS(5450),
    [anon_sym_BANG_EQ] = ACTIONS(5450),
    [anon_sym_STAR_EQ] = ACTIONS(5450),
    [anon_sym_SLASH] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5450),
    [anon_sym_AMP_AMP] = ACTIONS(5450),
    [anon_sym_AMP_EQ] = ACTIONS(5450),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [anon_sym_PERCENT_EQ] = ACTIONS(5450),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_CARET_EQ] = ACTIONS(5450),
    [anon_sym_PLUS_EQ] = ACTIONS(5450),
    [anon_sym_LT] = ACTIONS(5452),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5450),
    [anon_sym_LT_EQ] = ACTIONS(5450),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_EQ_EQ] = ACTIONS(5450),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5450),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_GT_GT_EQ] = ACTIONS(5450),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_PIPE_EQ] = ACTIONS(5450),
    [anon_sym_PIPE_PIPE] = ACTIONS(5450),
    [anon_sym_QMARK] = ACTIONS(5450),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5450),
    [anon_sym_as] = ACTIONS(5450),
    [sym_line_comment] = ACTIONS(7),
  },
  [1835] = {
    [sym_attribute_item] = STATE(582),
    [sym_field_initializer] = STATE(1831),
    [sym_base_field_initializer] = STATE(1831),
    [aux_sym_enum_variant_list_repeat1] = STATE(582),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5454),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_DOT_DOT] = ACTIONS(1135),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3535),
  },
  [1836] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2465),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2465),
    [sym_macro_invocation] = STATE(2465),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2465),
    [sym_unary_expression] = STATE(2465),
    [sym_try_expression] = STATE(2465),
    [sym_reference_expression] = STATE(2465),
    [sym_binary_expression] = STATE(2465),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2465),
    [sym_call_expression] = STATE(2465),
    [sym_array_expression] = STATE(2465),
    [sym_parenthesized_expression] = STATE(2465),
    [sym_tuple_expression] = STATE(2465),
    [sym_unit_expression] = STATE(2465),
    [sym_struct_expression] = STATE(2465),
    [sym_if_expression] = STATE(2465),
    [sym_if_let_expression] = STATE(2465),
    [sym_match_expression] = STATE(2465),
    [sym_while_expression] = STATE(2465),
    [sym_while_let_expression] = STATE(2465),
    [sym_loop_expression] = STATE(2465),
    [sym_for_expression] = STATE(2465),
    [sym_closure_expression] = STATE(2465),
    [sym_closure_parameters] = STATE(1138),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2465),
    [sym_continue_expression] = STATE(2465),
    [sym_index_expression] = STATE(2465),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2465),
    [sym_block] = STATE(2465),
    [sym__literal] = STATE(2465),
    [sym_string_literal] = STATE(2465),
    [sym_boolean_literal] = STATE(2465),
    [sym_raw_string_literal] = ACTIONS(5456),
    [sym_float_literal] = ACTIONS(5456),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(2245),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(2247),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(2249),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(2251),
    [sym_integer_literal] = ACTIONS(5456),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(5456),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1837] = {
    [sym_function_modifiers] = STATE(854),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2151),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2152),
    [sym_array_type] = STATE(2151),
    [sym_function_type] = STATE(2151),
    [sym_tuple_type] = STATE(2151),
    [sym_unit_type] = STATE(2151),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2151),
    [sym_type_binding] = STATE(2153),
    [sym_reference_type] = STATE(2151),
    [sym_pointer_type] = STATE(2151),
    [sym_empty_type] = STATE(2151),
    [sym_dynamic_type] = STATE(2151),
    [sym_macro_invocation] = STATE(2151),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(858),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1786),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1788),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_GT] = ACTIONS(5458),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1790),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1792),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1838] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4830),
    [anon_sym_LPAREN] = ACTIONS(4830),
    [anon_sym_RPAREN] = ACTIONS(4830),
    [anon_sym_LBRACE] = ACTIONS(4830),
    [anon_sym_RBRACE] = ACTIONS(4830),
    [anon_sym_LBRACK] = ACTIONS(4830),
    [anon_sym_RBRACK] = ACTIONS(4830),
    [anon_sym_PLUS] = ACTIONS(4832),
    [anon_sym_STAR] = ACTIONS(4832),
    [anon_sym_COMMA] = ACTIONS(4830),
    [anon_sym_AMP] = ACTIONS(4832),
    [anon_sym_DASH] = ACTIONS(4832),
    [anon_sym_DOT] = ACTIONS(4832),
    [anon_sym_DASH_EQ] = ACTIONS(4830),
    [anon_sym_COLON_COLON] = ACTIONS(4830),
    [anon_sym_BANG_EQ] = ACTIONS(4830),
    [anon_sym_STAR_EQ] = ACTIONS(4830),
    [anon_sym_SLASH] = ACTIONS(4832),
    [anon_sym_SLASH_EQ] = ACTIONS(4830),
    [anon_sym_AMP_AMP] = ACTIONS(4830),
    [anon_sym_AMP_EQ] = ACTIONS(4830),
    [anon_sym_PERCENT] = ACTIONS(4832),
    [anon_sym_PERCENT_EQ] = ACTIONS(4830),
    [anon_sym_CARET] = ACTIONS(4832),
    [anon_sym_CARET_EQ] = ACTIONS(4830),
    [anon_sym_PLUS_EQ] = ACTIONS(4830),
    [anon_sym_LT] = ACTIONS(4832),
    [anon_sym_LT_LT] = ACTIONS(4832),
    [anon_sym_LT_LT_EQ] = ACTIONS(4830),
    [anon_sym_LT_EQ] = ACTIONS(4830),
    [anon_sym_EQ] = ACTIONS(4832),
    [anon_sym_EQ_EQ] = ACTIONS(4830),
    [anon_sym_GT] = ACTIONS(4832),
    [anon_sym_GT_EQ] = ACTIONS(4830),
    [anon_sym_GT_GT] = ACTIONS(4832),
    [anon_sym_GT_GT_EQ] = ACTIONS(4830),
    [anon_sym_PIPE] = ACTIONS(4832),
    [anon_sym_PIPE_EQ] = ACTIONS(4830),
    [anon_sym_PIPE_PIPE] = ACTIONS(4830),
    [anon_sym_QMARK] = ACTIONS(4830),
    [anon_sym_DOT_DOT] = ACTIONS(4832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4830),
    [anon_sym_as] = ACTIONS(4830),
    [sym_line_comment] = ACTIONS(7),
  },
  [1839] = {
    [aux_sym_type_arguments_repeat1] = STATE(2155),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(5460),
    [anon_sym_GT] = ACTIONS(5458),
    [sym_line_comment] = ACTIONS(7),
  },
  [1840] = {
    [sym_raw_string_literal] = ACTIONS(3560),
    [sym_float_literal] = ACTIONS(3560),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym_LPAREN] = ACTIONS(5462),
    [anon_sym_RPAREN] = ACTIONS(5462),
    [anon_sym_LBRACE] = ACTIONS(3560),
    [anon_sym_EQ_GT] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(5462),
    [anon_sym_RBRACK] = ACTIONS(5462),
    [anon_sym_COLON] = ACTIONS(3562),
    [anon_sym_DOLLAR] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(5465),
    [anon_sym_STAR] = ACTIONS(5465),
    [anon_sym_COMMA] = ACTIONS(5462),
    [anon_sym_u8] = ACTIONS(3562),
    [anon_sym_i8] = ACTIONS(3562),
    [anon_sym_u16] = ACTIONS(3562),
    [anon_sym_i16] = ACTIONS(3562),
    [anon_sym_u32] = ACTIONS(3562),
    [anon_sym_i32] = ACTIONS(3562),
    [anon_sym_u64] = ACTIONS(3562),
    [anon_sym_i64] = ACTIONS(3562),
    [anon_sym_u128] = ACTIONS(3562),
    [anon_sym_i128] = ACTIONS(3562),
    [anon_sym_isize] = ACTIONS(3562),
    [anon_sym_usize] = ACTIONS(3562),
    [anon_sym_f32] = ACTIONS(3562),
    [anon_sym_f64] = ACTIONS(3562),
    [anon_sym_bool] = ACTIONS(3562),
    [anon_sym_str] = ACTIONS(3562),
    [anon_sym_char] = ACTIONS(3562),
    [anon_sym__] = ACTIONS(3562),
    [anon_sym_AMP] = ACTIONS(5465),
    [anon_sym_DASH] = ACTIONS(5465),
    [anon_sym_DOT] = ACTIONS(5465),
    [anon_sym_DASH_EQ] = ACTIONS(5462),
    [anon_sym_DASH_GT] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_BANG] = ACTIONS(3562),
    [anon_sym_BANG_EQ] = ACTIONS(5462),
    [anon_sym_AT] = ACTIONS(3560),
    [anon_sym_STAR_EQ] = ACTIONS(5462),
    [anon_sym_SLASH] = ACTIONS(5465),
    [anon_sym_SLASH_EQ] = ACTIONS(5462),
    [anon_sym_AMP_AMP] = ACTIONS(5462),
    [anon_sym_AMP_EQ] = ACTIONS(5462),
    [anon_sym_POUND] = ACTIONS(3560),
    [anon_sym_PERCENT] = ACTIONS(5465),
    [anon_sym_PERCENT_EQ] = ACTIONS(5462),
    [anon_sym_CARET] = ACTIONS(5465),
    [anon_sym_CARET_EQ] = ACTIONS(5462),
    [anon_sym_PLUS_EQ] = ACTIONS(5462),
    [anon_sym_LT] = ACTIONS(5465),
    [anon_sym_LT_LT] = ACTIONS(5465),
    [anon_sym_LT_LT_EQ] = ACTIONS(5462),
    [anon_sym_LT_EQ] = ACTIONS(5462),
    [anon_sym_EQ] = ACTIONS(5465),
    [anon_sym_EQ_EQ] = ACTIONS(5462),
    [anon_sym_GT] = ACTIONS(5465),
    [anon_sym_GT_EQ] = ACTIONS(5462),
    [anon_sym_GT_GT] = ACTIONS(5465),
    [anon_sym_GT_GT_EQ] = ACTIONS(5462),
    [anon_sym_PIPE] = ACTIONS(5465),
    [anon_sym_PIPE_EQ] = ACTIONS(5462),
    [anon_sym_PIPE_PIPE] = ACTIONS(5462),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_QMARK] = ACTIONS(5462),
    [anon_sym_SQUOTE] = ACTIONS(3562),
    [anon_sym_DOT_DOT] = ACTIONS(5465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5462),
    [anon_sym_as] = ACTIONS(5465),
    [anon_sym_break] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_continue] = ACTIONS(3562),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_fn] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_impl] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_loop] = ACTIONS(3562),
    [anon_sym_match] = ACTIONS(3562),
    [anon_sym_mod] = ACTIONS(3562),
    [anon_sym_pub] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_trait] = ACTIONS(3562),
    [anon_sym_type] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [anon_sym_unsafe] = ACTIONS(3562),
    [anon_sym_use] = ACTIONS(3562),
    [anon_sym_where] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [sym_mutable_specifier] = ACTIONS(3562),
    [sym_integer_literal] = ACTIONS(3560),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3560),
    [sym_char_literal] = ACTIONS(3560),
    [anon_sym_true] = ACTIONS(3562),
    [anon_sym_false] = ACTIONS(3562),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3562),
    [sym_self] = ACTIONS(3562),
    [sym_super] = ACTIONS(3562),
    [sym_crate] = ACTIONS(3562),
    [sym_metavariable] = ACTIONS(3560),
  },
  [1841] = {
    [sym_arguments] = STATE(263),
    [aux_sym_token_tree_repeat2] = STATE(2470),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(5468),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(5470),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_BANG_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH] = ACTIONS(563),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(563),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_LT] = ACTIONS(577),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(581),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(577),
    [anon_sym_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(589),
    [anon_sym_as] = ACTIONS(591),
    [sym_line_comment] = ACTIONS(7),
  },
  [1842] = {
    [sym_token_tree] = STATE(1878),
    [sym_token_repetition] = STATE(1878),
    [sym__literal] = STATE(1878),
    [sym_string_literal] = STATE(1878),
    [sym_boolean_literal] = STATE(1878),
    [aux_sym_token_tree_repeat1] = STATE(1878),
    [sym_raw_string_literal] = ACTIONS(3960),
    [sym_float_literal] = ACTIONS(3960),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_RPAREN] = ACTIONS(5472),
    [anon_sym_LBRACE] = ACTIONS(3966),
    [anon_sym_EQ_GT] = ACTIONS(3960),
    [anon_sym_LBRACK] = ACTIONS(3968),
    [anon_sym_COLON] = ACTIONS(3970),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(3970),
    [anon_sym_STAR] = ACTIONS(3970),
    [anon_sym_COMMA] = ACTIONS(3960),
    [anon_sym_u8] = ACTIONS(3972),
    [anon_sym_i8] = ACTIONS(3972),
    [anon_sym_u16] = ACTIONS(3972),
    [anon_sym_i16] = ACTIONS(3972),
    [anon_sym_u32] = ACTIONS(3972),
    [anon_sym_i32] = ACTIONS(3972),
    [anon_sym_u64] = ACTIONS(3972),
    [anon_sym_i64] = ACTIONS(3972),
    [anon_sym_u128] = ACTIONS(3972),
    [anon_sym_i128] = ACTIONS(3972),
    [anon_sym_isize] = ACTIONS(3972),
    [anon_sym_usize] = ACTIONS(3972),
    [anon_sym_f32] = ACTIONS(3972),
    [anon_sym_f64] = ACTIONS(3972),
    [anon_sym_bool] = ACTIONS(3972),
    [anon_sym_str] = ACTIONS(3972),
    [anon_sym_char] = ACTIONS(3972),
    [anon_sym__] = ACTIONS(3970),
    [anon_sym_AMP] = ACTIONS(3970),
    [anon_sym_DASH] = ACTIONS(3970),
    [anon_sym_DOT] = ACTIONS(3970),
    [anon_sym_DASH_EQ] = ACTIONS(3960),
    [anon_sym_DASH_GT] = ACTIONS(3960),
    [anon_sym_COLON_COLON] = ACTIONS(3960),
    [anon_sym_BANG] = ACTIONS(3970),
    [anon_sym_BANG_EQ] = ACTIONS(3960),
    [anon_sym_AT] = ACTIONS(3960),
    [anon_sym_STAR_EQ] = ACTIONS(3960),
    [anon_sym_SLASH] = ACTIONS(3970),
    [anon_sym_SLASH_EQ] = ACTIONS(3960),
    [anon_sym_AMP_AMP] = ACTIONS(3960),
    [anon_sym_AMP_EQ] = ACTIONS(3960),
    [anon_sym_POUND] = ACTIONS(3960),
    [anon_sym_PERCENT] = ACTIONS(3970),
    [anon_sym_PERCENT_EQ] = ACTIONS(3960),
    [anon_sym_CARET] = ACTIONS(3970),
    [anon_sym_CARET_EQ] = ACTIONS(3960),
    [anon_sym_PLUS_EQ] = ACTIONS(3960),
    [anon_sym_LT] = ACTIONS(3970),
    [anon_sym_LT_LT] = ACTIONS(3970),
    [anon_sym_LT_LT_EQ] = ACTIONS(3960),
    [anon_sym_LT_EQ] = ACTIONS(3960),
    [anon_sym_EQ] = ACTIONS(3970),
    [anon_sym_EQ_EQ] = ACTIONS(3960),
    [anon_sym_GT] = ACTIONS(3970),
    [anon_sym_GT_EQ] = ACTIONS(3960),
    [anon_sym_GT_GT] = ACTIONS(3970),
    [anon_sym_GT_GT_EQ] = ACTIONS(3960),
    [anon_sym_PIPE] = ACTIONS(3970),
    [anon_sym_PIPE_EQ] = ACTIONS(3960),
    [anon_sym_PIPE_PIPE] = ACTIONS(3960),
    [anon_sym_TILDE] = ACTIONS(3960),
    [anon_sym_QMARK] = ACTIONS(3960),
    [anon_sym_SQUOTE] = ACTIONS(3970),
    [anon_sym_DOT_DOT] = ACTIONS(3970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3960),
    [anon_sym_as] = ACTIONS(3970),
    [anon_sym_break] = ACTIONS(3970),
    [anon_sym_const] = ACTIONS(3970),
    [anon_sym_continue] = ACTIONS(3970),
    [anon_sym_default] = ACTIONS(3970),
    [anon_sym_enum] = ACTIONS(3970),
    [anon_sym_fn] = ACTIONS(3970),
    [anon_sym_for] = ACTIONS(3970),
    [anon_sym_if] = ACTIONS(3970),
    [anon_sym_impl] = ACTIONS(3970),
    [anon_sym_let] = ACTIONS(3970),
    [anon_sym_loop] = ACTIONS(3970),
    [anon_sym_match] = ACTIONS(3970),
    [anon_sym_mod] = ACTIONS(3970),
    [anon_sym_pub] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3970),
    [anon_sym_static] = ACTIONS(3970),
    [anon_sym_struct] = ACTIONS(3970),
    [anon_sym_trait] = ACTIONS(3970),
    [anon_sym_type] = ACTIONS(3970),
    [anon_sym_union] = ACTIONS(3970),
    [anon_sym_unsafe] = ACTIONS(3970),
    [anon_sym_use] = ACTIONS(3970),
    [anon_sym_where] = ACTIONS(3970),
    [anon_sym_while] = ACTIONS(3970),
    [sym_mutable_specifier] = ACTIONS(3970),
    [sym_integer_literal] = ACTIONS(3960),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(3960),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3970),
    [sym_self] = ACTIONS(3970),
    [sym_super] = ACTIONS(3970),
    [sym_crate] = ACTIONS(3970),
    [sym_metavariable] = ACTIONS(3960),
  },
  [1843] = {
    [sym_raw_string_literal] = ACTIONS(3560),
    [sym_float_literal] = ACTIONS(3560),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym_LPAREN] = ACTIONS(5474),
    [anon_sym_RPAREN] = ACTIONS(5474),
    [anon_sym_LBRACE] = ACTIONS(3560),
    [anon_sym_EQ_GT] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(5474),
    [anon_sym_RBRACK] = ACTIONS(5474),
    [anon_sym_COLON] = ACTIONS(3562),
    [anon_sym_DOLLAR] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(5477),
    [anon_sym_STAR] = ACTIONS(5477),
    [anon_sym_COMMA] = ACTIONS(5474),
    [anon_sym_u8] = ACTIONS(3562),
    [anon_sym_i8] = ACTIONS(3562),
    [anon_sym_u16] = ACTIONS(3562),
    [anon_sym_i16] = ACTIONS(3562),
    [anon_sym_u32] = ACTIONS(3562),
    [anon_sym_i32] = ACTIONS(3562),
    [anon_sym_u64] = ACTIONS(3562),
    [anon_sym_i64] = ACTIONS(3562),
    [anon_sym_u128] = ACTIONS(3562),
    [anon_sym_i128] = ACTIONS(3562),
    [anon_sym_isize] = ACTIONS(3562),
    [anon_sym_usize] = ACTIONS(3562),
    [anon_sym_f32] = ACTIONS(3562),
    [anon_sym_f64] = ACTIONS(3562),
    [anon_sym_bool] = ACTIONS(3562),
    [anon_sym_str] = ACTIONS(3562),
    [anon_sym_char] = ACTIONS(3562),
    [anon_sym__] = ACTIONS(3562),
    [anon_sym_AMP] = ACTIONS(5477),
    [anon_sym_DASH] = ACTIONS(5477),
    [anon_sym_DOT] = ACTIONS(5477),
    [anon_sym_DASH_EQ] = ACTIONS(5474),
    [anon_sym_DASH_GT] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_BANG] = ACTIONS(3562),
    [anon_sym_BANG_EQ] = ACTIONS(5474),
    [anon_sym_AT] = ACTIONS(3560),
    [anon_sym_STAR_EQ] = ACTIONS(5474),
    [anon_sym_SLASH] = ACTIONS(5477),
    [anon_sym_SLASH_EQ] = ACTIONS(5474),
    [anon_sym_AMP_AMP] = ACTIONS(5474),
    [anon_sym_AMP_EQ] = ACTIONS(5474),
    [anon_sym_POUND] = ACTIONS(3560),
    [anon_sym_PERCENT] = ACTIONS(5477),
    [anon_sym_PERCENT_EQ] = ACTIONS(5474),
    [anon_sym_CARET] = ACTIONS(5477),
    [anon_sym_CARET_EQ] = ACTIONS(5474),
    [anon_sym_PLUS_EQ] = ACTIONS(5474),
    [anon_sym_LT] = ACTIONS(5477),
    [anon_sym_LT_LT] = ACTIONS(5477),
    [anon_sym_LT_LT_EQ] = ACTIONS(5474),
    [anon_sym_LT_EQ] = ACTIONS(5474),
    [anon_sym_EQ] = ACTIONS(5477),
    [anon_sym_EQ_EQ] = ACTIONS(5474),
    [anon_sym_GT] = ACTIONS(5477),
    [anon_sym_GT_EQ] = ACTIONS(5474),
    [anon_sym_GT_GT] = ACTIONS(5477),
    [anon_sym_GT_GT_EQ] = ACTIONS(5474),
    [anon_sym_PIPE] = ACTIONS(5477),
    [anon_sym_PIPE_EQ] = ACTIONS(5474),
    [anon_sym_PIPE_PIPE] = ACTIONS(5474),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_QMARK] = ACTIONS(5474),
    [anon_sym_SQUOTE] = ACTIONS(3562),
    [anon_sym_DOT_DOT] = ACTIONS(5477),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5474),
    [anon_sym_as] = ACTIONS(5477),
    [anon_sym_break] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_continue] = ACTIONS(3562),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_fn] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_impl] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_loop] = ACTIONS(3562),
    [anon_sym_match] = ACTIONS(3562),
    [anon_sym_mod] = ACTIONS(3562),
    [anon_sym_pub] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_trait] = ACTIONS(3562),
    [anon_sym_type] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [anon_sym_unsafe] = ACTIONS(3562),
    [anon_sym_use] = ACTIONS(3562),
    [anon_sym_where] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [sym_mutable_specifier] = ACTIONS(3562),
    [sym_integer_literal] = ACTIONS(3560),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3560),
    [sym_char_literal] = ACTIONS(3560),
    [anon_sym_true] = ACTIONS(3562),
    [anon_sym_false] = ACTIONS(3562),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3562),
    [sym_self] = ACTIONS(3562),
    [sym_super] = ACTIONS(3562),
    [sym_crate] = ACTIONS(3562),
    [sym_metavariable] = ACTIONS(3560),
  },
  [1844] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(5480),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(623),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(623),
    [anon_sym_PLUS_EQ] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(623),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(643),
    [anon_sym_as] = ACTIONS(645),
    [sym_line_comment] = ACTIONS(7),
  },
  [1845] = {
    [sym__statement] = STATE(332),
    [sym_empty_statement] = STATE(332),
    [sym__expression_statement] = STATE(332),
    [sym_macro_definition] = STATE(332),
    [sym_attribute_item] = STATE(332),
    [sym_inner_attribute_item] = STATE(332),
    [sym_mod_item] = STATE(332),
    [sym_foreign_mod_item] = STATE(332),
    [sym_struct_item] = STATE(332),
    [sym_union_item] = STATE(332),
    [sym_enum_item] = STATE(332),
    [sym_extern_crate_declaration] = STATE(332),
    [sym_const_item] = STATE(332),
    [sym_static_item] = STATE(332),
    [sym_type_item] = STATE(332),
    [sym_function_item] = STATE(332),
    [sym_function_signature_item] = STATE(332),
    [sym_function_modifiers] = STATE(47),
    [sym_impl_item] = STATE(332),
    [sym_trait_item] = STATE(332),
    [sym_associated_type] = STATE(332),
    [sym_let_declaration] = STATE(332),
    [sym_use_declaration] = STATE(332),
    [sym_extern_modifier] = STATE(48),
    [sym_visibility_modifier] = STATE(49),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2473),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2473),
    [sym_macro_invocation] = STATE(53),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2473),
    [sym_unary_expression] = STATE(2473),
    [sym_try_expression] = STATE(2473),
    [sym_reference_expression] = STATE(2473),
    [sym_binary_expression] = STATE(2473),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2473),
    [sym_call_expression] = STATE(2473),
    [sym_array_expression] = STATE(2473),
    [sym_parenthesized_expression] = STATE(2473),
    [sym_tuple_expression] = STATE(2473),
    [sym_unit_expression] = STATE(2473),
    [sym_struct_expression] = STATE(2473),
    [sym_if_expression] = STATE(57),
    [sym_if_let_expression] = STATE(57),
    [sym_match_expression] = STATE(57),
    [sym_while_expression] = STATE(57),
    [sym_while_let_expression] = STATE(57),
    [sym_loop_expression] = STATE(57),
    [sym_for_expression] = STATE(57),
    [sym_closure_expression] = STATE(2473),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(59),
    [sym_break_expression] = STATE(2473),
    [sym_continue_expression] = STATE(2473),
    [sym_index_expression] = STATE(2473),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(57),
    [sym_block] = STATE(57),
    [sym__literal] = STATE(2473),
    [sym_string_literal] = STATE(2473),
    [sym_boolean_literal] = STATE(2473),
    [aux_sym_source_file_repeat1] = STATE(332),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_raw_string_literal] = ACTIONS(5482),
    [sym_float_literal] = ACTIONS(5482),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(5480),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_POUND] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(5482),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(5482),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(93),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1846] = {
    [sym_token_tree] = STATE(1887),
    [sym_token_repetition] = STATE(1887),
    [sym__literal] = STATE(1887),
    [sym_string_literal] = STATE(1887),
    [sym_boolean_literal] = STATE(1887),
    [aux_sym_token_tree_repeat1] = STATE(1887),
    [sym_raw_string_literal] = ACTIONS(4148),
    [sym_float_literal] = ACTIONS(4148),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4148),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_LBRACE] = ACTIONS(3966),
    [anon_sym_RBRACE] = ACTIONS(5472),
    [anon_sym_EQ_GT] = ACTIONS(4148),
    [anon_sym_LBRACK] = ACTIONS(3968),
    [anon_sym_COLON] = ACTIONS(4150),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(4150),
    [anon_sym_STAR] = ACTIONS(4150),
    [anon_sym_COMMA] = ACTIONS(4148),
    [anon_sym_u8] = ACTIONS(3972),
    [anon_sym_i8] = ACTIONS(3972),
    [anon_sym_u16] = ACTIONS(3972),
    [anon_sym_i16] = ACTIONS(3972),
    [anon_sym_u32] = ACTIONS(3972),
    [anon_sym_i32] = ACTIONS(3972),
    [anon_sym_u64] = ACTIONS(3972),
    [anon_sym_i64] = ACTIONS(3972),
    [anon_sym_u128] = ACTIONS(3972),
    [anon_sym_i128] = ACTIONS(3972),
    [anon_sym_isize] = ACTIONS(3972),
    [anon_sym_usize] = ACTIONS(3972),
    [anon_sym_f32] = ACTIONS(3972),
    [anon_sym_f64] = ACTIONS(3972),
    [anon_sym_bool] = ACTIONS(3972),
    [anon_sym_str] = ACTIONS(3972),
    [anon_sym_char] = ACTIONS(3972),
    [anon_sym__] = ACTIONS(4150),
    [anon_sym_AMP] = ACTIONS(4150),
    [anon_sym_DASH] = ACTIONS(4150),
    [anon_sym_DOT] = ACTIONS(4150),
    [anon_sym_DASH_EQ] = ACTIONS(4148),
    [anon_sym_DASH_GT] = ACTIONS(4148),
    [anon_sym_COLON_COLON] = ACTIONS(4148),
    [anon_sym_BANG] = ACTIONS(4150),
    [anon_sym_BANG_EQ] = ACTIONS(4148),
    [anon_sym_AT] = ACTIONS(4148),
    [anon_sym_STAR_EQ] = ACTIONS(4148),
    [anon_sym_SLASH] = ACTIONS(4150),
    [anon_sym_SLASH_EQ] = ACTIONS(4148),
    [anon_sym_AMP_AMP] = ACTIONS(4148),
    [anon_sym_AMP_EQ] = ACTIONS(4148),
    [anon_sym_POUND] = ACTIONS(4148),
    [anon_sym_PERCENT] = ACTIONS(4150),
    [anon_sym_PERCENT_EQ] = ACTIONS(4148),
    [anon_sym_CARET] = ACTIONS(4150),
    [anon_sym_CARET_EQ] = ACTIONS(4148),
    [anon_sym_PLUS_EQ] = ACTIONS(4148),
    [anon_sym_LT] = ACTIONS(4150),
    [anon_sym_LT_LT] = ACTIONS(4150),
    [anon_sym_LT_LT_EQ] = ACTIONS(4148),
    [anon_sym_LT_EQ] = ACTIONS(4148),
    [anon_sym_EQ] = ACTIONS(4150),
    [anon_sym_EQ_EQ] = ACTIONS(4148),
    [anon_sym_GT] = ACTIONS(4150),
    [anon_sym_GT_EQ] = ACTIONS(4148),
    [anon_sym_GT_GT] = ACTIONS(4150),
    [anon_sym_GT_GT_EQ] = ACTIONS(4148),
    [anon_sym_PIPE] = ACTIONS(4150),
    [anon_sym_PIPE_EQ] = ACTIONS(4148),
    [anon_sym_PIPE_PIPE] = ACTIONS(4148),
    [anon_sym_TILDE] = ACTIONS(4148),
    [anon_sym_QMARK] = ACTIONS(4148),
    [anon_sym_SQUOTE] = ACTIONS(4150),
    [anon_sym_DOT_DOT] = ACTIONS(4150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4148),
    [anon_sym_as] = ACTIONS(4150),
    [anon_sym_break] = ACTIONS(4150),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_continue] = ACTIONS(4150),
    [anon_sym_default] = ACTIONS(4150),
    [anon_sym_enum] = ACTIONS(4150),
    [anon_sym_fn] = ACTIONS(4150),
    [anon_sym_for] = ACTIONS(4150),
    [anon_sym_if] = ACTIONS(4150),
    [anon_sym_impl] = ACTIONS(4150),
    [anon_sym_let] = ACTIONS(4150),
    [anon_sym_loop] = ACTIONS(4150),
    [anon_sym_match] = ACTIONS(4150),
    [anon_sym_mod] = ACTIONS(4150),
    [anon_sym_pub] = ACTIONS(4150),
    [anon_sym_return] = ACTIONS(4150),
    [anon_sym_static] = ACTIONS(4150),
    [anon_sym_struct] = ACTIONS(4150),
    [anon_sym_trait] = ACTIONS(4150),
    [anon_sym_type] = ACTIONS(4150),
    [anon_sym_union] = ACTIONS(4150),
    [anon_sym_unsafe] = ACTIONS(4150),
    [anon_sym_use] = ACTIONS(4150),
    [anon_sym_where] = ACTIONS(4150),
    [anon_sym_while] = ACTIONS(4150),
    [sym_mutable_specifier] = ACTIONS(4150),
    [sym_integer_literal] = ACTIONS(4148),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(4148),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4150),
    [sym_self] = ACTIONS(4150),
    [sym_super] = ACTIONS(4150),
    [sym_crate] = ACTIONS(4150),
    [sym_metavariable] = ACTIONS(4148),
  },
  [1847] = {
    [sym_token_tree] = STATE(1842),
    [sym_token_repetition] = STATE(1842),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2475),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2475),
    [sym_macro_invocation] = STATE(2475),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2475),
    [sym_unary_expression] = STATE(2475),
    [sym_try_expression] = STATE(2475),
    [sym_reference_expression] = STATE(2475),
    [sym_binary_expression] = STATE(2475),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2475),
    [sym_call_expression] = STATE(2475),
    [sym_array_expression] = STATE(2475),
    [sym_parenthesized_expression] = STATE(2475),
    [sym_tuple_expression] = STATE(2475),
    [sym_unit_expression] = STATE(2475),
    [sym_struct_expression] = STATE(2475),
    [sym_if_expression] = STATE(2475),
    [sym_if_let_expression] = STATE(2475),
    [sym_match_expression] = STATE(2475),
    [sym_while_expression] = STATE(2475),
    [sym_while_let_expression] = STATE(2475),
    [sym_loop_expression] = STATE(2475),
    [sym_for_expression] = STATE(2475),
    [sym_closure_expression] = STATE(2475),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2475),
    [sym_continue_expression] = STATE(2475),
    [sym_index_expression] = STATE(2475),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2475),
    [sym_block] = STATE(2475),
    [sym__literal] = STATE(1178),
    [sym_string_literal] = STATE(1178),
    [sym_boolean_literal] = STATE(1178),
    [aux_sym_token_tree_repeat1] = STATE(1842),
    [sym_raw_string_literal] = ACTIONS(2275),
    [sym_float_literal] = ACTIONS(2275),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3554),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_RPAREN] = ACTIONS(5484),
    [anon_sym_LBRACE] = ACTIONS(2283),
    [anon_sym_EQ_GT] = ACTIONS(3554),
    [anon_sym_LBRACK] = ACTIONS(2285),
    [anon_sym_COLON] = ACTIONS(3558),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(3558),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(3554),
    [anon_sym_u8] = ACTIONS(2293),
    [anon_sym_i8] = ACTIONS(2293),
    [anon_sym_u16] = ACTIONS(2293),
    [anon_sym_i16] = ACTIONS(2293),
    [anon_sym_u32] = ACTIONS(2293),
    [anon_sym_i32] = ACTIONS(2293),
    [anon_sym_u64] = ACTIONS(2293),
    [anon_sym_i64] = ACTIONS(2293),
    [anon_sym_u128] = ACTIONS(2293),
    [anon_sym_i128] = ACTIONS(2293),
    [anon_sym_isize] = ACTIONS(2293),
    [anon_sym_usize] = ACTIONS(2293),
    [anon_sym_f32] = ACTIONS(2293),
    [anon_sym_f64] = ACTIONS(2293),
    [anon_sym_bool] = ACTIONS(2293),
    [anon_sym_str] = ACTIONS(2293),
    [anon_sym_char] = ACTIONS(2293),
    [anon_sym__] = ACTIONS(3558),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_DASH] = ACTIONS(2291),
    [anon_sym_DOT] = ACTIONS(3558),
    [anon_sym_DASH_EQ] = ACTIONS(3554),
    [anon_sym_DASH_GT] = ACTIONS(3554),
    [anon_sym_COLON_COLON] = ACTIONS(3554),
    [anon_sym_BANG] = ACTIONS(2297),
    [anon_sym_BANG_EQ] = ACTIONS(3554),
    [anon_sym_AT] = ACTIONS(3554),
    [anon_sym_STAR_EQ] = ACTIONS(3554),
    [anon_sym_SLASH] = ACTIONS(3558),
    [anon_sym_SLASH_EQ] = ACTIONS(3554),
    [anon_sym_AMP_AMP] = ACTIONS(3554),
    [anon_sym_AMP_EQ] = ACTIONS(3554),
    [anon_sym_POUND] = ACTIONS(3554),
    [anon_sym_PERCENT] = ACTIONS(3558),
    [anon_sym_PERCENT_EQ] = ACTIONS(3554),
    [anon_sym_CARET] = ACTIONS(3558),
    [anon_sym_CARET_EQ] = ACTIONS(3554),
    [anon_sym_PLUS_EQ] = ACTIONS(3554),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_LT_LT] = ACTIONS(3558),
    [anon_sym_LT_LT_EQ] = ACTIONS(3554),
    [anon_sym_LT_EQ] = ACTIONS(3554),
    [anon_sym_EQ] = ACTIONS(3558),
    [anon_sym_EQ_EQ] = ACTIONS(3554),
    [anon_sym_GT] = ACTIONS(3558),
    [anon_sym_GT_EQ] = ACTIONS(3554),
    [anon_sym_GT_GT] = ACTIONS(3558),
    [anon_sym_GT_GT_EQ] = ACTIONS(3554),
    [anon_sym_PIPE] = ACTIONS(2301),
    [anon_sym_PIPE_EQ] = ACTIONS(3554),
    [anon_sym_PIPE_PIPE] = ACTIONS(3554),
    [anon_sym_TILDE] = ACTIONS(3554),
    [anon_sym_QMARK] = ACTIONS(3554),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(2305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3554),
    [anon_sym_as] = ACTIONS(3558),
    [anon_sym_break] = ACTIONS(2307),
    [anon_sym_const] = ACTIONS(3558),
    [anon_sym_continue] = ACTIONS(2309),
    [anon_sym_default] = ACTIONS(2311),
    [anon_sym_enum] = ACTIONS(3558),
    [anon_sym_fn] = ACTIONS(3558),
    [anon_sym_for] = ACTIONS(2313),
    [anon_sym_if] = ACTIONS(2315),
    [anon_sym_impl] = ACTIONS(3558),
    [anon_sym_let] = ACTIONS(3558),
    [anon_sym_loop] = ACTIONS(2317),
    [anon_sym_match] = ACTIONS(2319),
    [anon_sym_mod] = ACTIONS(3558),
    [anon_sym_pub] = ACTIONS(3558),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_static] = ACTIONS(3558),
    [anon_sym_struct] = ACTIONS(3558),
    [anon_sym_trait] = ACTIONS(3558),
    [anon_sym_type] = ACTIONS(3558),
    [anon_sym_union] = ACTIONS(2311),
    [anon_sym_unsafe] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(3558),
    [anon_sym_where] = ACTIONS(3558),
    [anon_sym_while] = ACTIONS(2325),
    [sym_mutable_specifier] = ACTIONS(3558),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(2275),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(2275),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2331),
    [sym_self] = ACTIONS(2333),
    [sym_super] = ACTIONS(3558),
    [sym_crate] = ACTIONS(3558),
    [sym_metavariable] = ACTIONS(2335),
  },
  [1848] = {
    [sym__statement] = STATE(2478),
    [sym_empty_statement] = STATE(2478),
    [sym__expression_statement] = STATE(2478),
    [sym_macro_definition] = STATE(2478),
    [sym_token_tree] = STATE(1846),
    [sym_token_repetition] = STATE(1846),
    [sym_attribute_item] = STATE(2478),
    [sym_inner_attribute_item] = STATE(2478),
    [sym_mod_item] = STATE(2478),
    [sym_foreign_mod_item] = STATE(2478),
    [sym_struct_item] = STATE(2478),
    [sym_union_item] = STATE(2478),
    [sym_enum_item] = STATE(2478),
    [sym_extern_crate_declaration] = STATE(2478),
    [sym_const_item] = STATE(2478),
    [sym_static_item] = STATE(2478),
    [sym_type_item] = STATE(2478),
    [sym_function_item] = STATE(2478),
    [sym_function_signature_item] = STATE(2478),
    [sym_function_modifiers] = STATE(47),
    [sym_impl_item] = STATE(2478),
    [sym_trait_item] = STATE(2478),
    [sym_associated_type] = STATE(2478),
    [sym_let_declaration] = STATE(2478),
    [sym_use_declaration] = STATE(2478),
    [sym_extern_modifier] = STATE(48),
    [sym_visibility_modifier] = STATE(49),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2477),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2477),
    [sym_macro_invocation] = STATE(53),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2477),
    [sym_unary_expression] = STATE(2477),
    [sym_try_expression] = STATE(2477),
    [sym_reference_expression] = STATE(2477),
    [sym_binary_expression] = STATE(2477),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2477),
    [sym_call_expression] = STATE(2477),
    [sym_array_expression] = STATE(2477),
    [sym_parenthesized_expression] = STATE(2477),
    [sym_tuple_expression] = STATE(2477),
    [sym_unit_expression] = STATE(2477),
    [sym_struct_expression] = STATE(2477),
    [sym_if_expression] = STATE(57),
    [sym_if_let_expression] = STATE(57),
    [sym_match_expression] = STATE(57),
    [sym_while_expression] = STATE(57),
    [sym_while_let_expression] = STATE(57),
    [sym_loop_expression] = STATE(57),
    [sym_for_expression] = STATE(57),
    [sym_closure_expression] = STATE(2477),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(59),
    [sym_break_expression] = STATE(2477),
    [sym_continue_expression] = STATE(2477),
    [sym_index_expression] = STATE(2477),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(57),
    [sym_block] = STATE(57),
    [sym__literal] = STATE(1216),
    [sym_string_literal] = STATE(1216),
    [sym_boolean_literal] = STATE(1216),
    [aux_sym_source_file_repeat1] = STATE(2478),
    [aux_sym_token_tree_repeat1] = STATE(1846),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_raw_string_literal] = ACTIONS(2337),
    [sym_float_literal] = ACTIONS(2337),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(2341),
    [anon_sym_LBRACE] = ACTIONS(2343),
    [anon_sym_RBRACE] = ACTIONS(5486),
    [anon_sym_EQ_GT] = ACTIONS(3566),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [anon_sym_COLON] = ACTIONS(3568),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(3568),
    [anon_sym_STAR] = ACTIONS(2351),
    [anon_sym_COMMA] = ACTIONS(3566),
    [anon_sym_u8] = ACTIONS(2353),
    [anon_sym_i8] = ACTIONS(2353),
    [anon_sym_u16] = ACTIONS(2353),
    [anon_sym_i16] = ACTIONS(2353),
    [anon_sym_u32] = ACTIONS(2353),
    [anon_sym_i32] = ACTIONS(2353),
    [anon_sym_u64] = ACTIONS(2353),
    [anon_sym_i64] = ACTIONS(2353),
    [anon_sym_u128] = ACTIONS(2353),
    [anon_sym_i128] = ACTIONS(2353),
    [anon_sym_isize] = ACTIONS(2353),
    [anon_sym_usize] = ACTIONS(2353),
    [anon_sym_f32] = ACTIONS(2353),
    [anon_sym_f64] = ACTIONS(2353),
    [anon_sym_bool] = ACTIONS(2353),
    [anon_sym_str] = ACTIONS(2353),
    [anon_sym_char] = ACTIONS(2353),
    [anon_sym__] = ACTIONS(3568),
    [anon_sym_AMP] = ACTIONS(2355),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_DOT] = ACTIONS(3568),
    [anon_sym_DASH_EQ] = ACTIONS(3566),
    [anon_sym_DASH_GT] = ACTIONS(3566),
    [anon_sym_COLON_COLON] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(2357),
    [anon_sym_BANG_EQ] = ACTIONS(3566),
    [anon_sym_AT] = ACTIONS(3566),
    [anon_sym_STAR_EQ] = ACTIONS(3566),
    [anon_sym_SLASH] = ACTIONS(3568),
    [anon_sym_SLASH_EQ] = ACTIONS(3566),
    [anon_sym_AMP_AMP] = ACTIONS(3566),
    [anon_sym_AMP_EQ] = ACTIONS(3566),
    [anon_sym_POUND] = ACTIONS(2359),
    [anon_sym_PERCENT] = ACTIONS(3568),
    [anon_sym_PERCENT_EQ] = ACTIONS(3566),
    [anon_sym_CARET] = ACTIONS(3568),
    [anon_sym_CARET_EQ] = ACTIONS(3566),
    [anon_sym_PLUS_EQ] = ACTIONS(3566),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_LT_LT] = ACTIONS(3568),
    [anon_sym_LT_LT_EQ] = ACTIONS(3566),
    [anon_sym_LT_EQ] = ACTIONS(3566),
    [anon_sym_EQ] = ACTIONS(3568),
    [anon_sym_EQ_EQ] = ACTIONS(3566),
    [anon_sym_GT] = ACTIONS(3568),
    [anon_sym_GT_EQ] = ACTIONS(3566),
    [anon_sym_GT_GT] = ACTIONS(3568),
    [anon_sym_GT_GT_EQ] = ACTIONS(3566),
    [anon_sym_PIPE] = ACTIONS(2301),
    [anon_sym_PIPE_EQ] = ACTIONS(3566),
    [anon_sym_PIPE_PIPE] = ACTIONS(3566),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3566),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(2361),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3566),
    [anon_sym_as] = ACTIONS(3568),
    [anon_sym_break] = ACTIONS(2363),
    [anon_sym_const] = ACTIONS(2365),
    [anon_sym_continue] = ACTIONS(2367),
    [anon_sym_default] = ACTIONS(2369),
    [anon_sym_enum] = ACTIONS(2371),
    [anon_sym_fn] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2375),
    [anon_sym_if] = ACTIONS(2377),
    [anon_sym_impl] = ACTIONS(2379),
    [anon_sym_let] = ACTIONS(2381),
    [anon_sym_loop] = ACTIONS(2383),
    [anon_sym_match] = ACTIONS(2385),
    [anon_sym_mod] = ACTIONS(2387),
    [anon_sym_pub] = ACTIONS(2389),
    [anon_sym_return] = ACTIONS(2391),
    [anon_sym_static] = ACTIONS(2393),
    [anon_sym_struct] = ACTIONS(2395),
    [anon_sym_trait] = ACTIONS(2397),
    [anon_sym_type] = ACTIONS(2399),
    [anon_sym_union] = ACTIONS(2401),
    [anon_sym_unsafe] = ACTIONS(2403),
    [anon_sym_use] = ACTIONS(2405),
    [anon_sym_where] = ACTIONS(3568),
    [anon_sym_while] = ACTIONS(2407),
    [anon_sym_extern] = ACTIONS(85),
    [sym_mutable_specifier] = ACTIONS(3568),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(2337),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(2337),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2409),
    [sym_self] = ACTIONS(2411),
    [sym_super] = ACTIONS(3568),
    [sym_crate] = ACTIONS(3568),
    [sym_metavariable] = ACTIONS(2413),
  },
  [1849] = {
    [sym_token_tree] = STATE(1866),
    [sym_token_repetition] = STATE(1866),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2480),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2480),
    [sym_macro_invocation] = STATE(2480),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2480),
    [sym_unary_expression] = STATE(2480),
    [sym_try_expression] = STATE(2480),
    [sym_reference_expression] = STATE(2480),
    [sym_binary_expression] = STATE(2480),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2480),
    [sym_call_expression] = STATE(2480),
    [sym_array_expression] = STATE(2480),
    [sym_parenthesized_expression] = STATE(2480),
    [sym_tuple_expression] = STATE(2480),
    [sym_unit_expression] = STATE(2480),
    [sym_struct_expression] = STATE(2480),
    [sym_if_expression] = STATE(2480),
    [sym_if_let_expression] = STATE(2480),
    [sym_match_expression] = STATE(2480),
    [sym_while_expression] = STATE(2480),
    [sym_while_let_expression] = STATE(2480),
    [sym_loop_expression] = STATE(2480),
    [sym_for_expression] = STATE(2480),
    [sym_closure_expression] = STATE(2480),
    [sym_closure_parameters] = STATE(101),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2480),
    [sym_continue_expression] = STATE(2480),
    [sym_index_expression] = STATE(2480),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2480),
    [sym_block] = STATE(2480),
    [sym__literal] = STATE(1865),
    [sym_string_literal] = STATE(1865),
    [sym_boolean_literal] = STATE(1865),
    [aux_sym_token_tree_repeat1] = STATE(1866),
    [sym_raw_string_literal] = ACTIONS(3570),
    [sym_float_literal] = ACTIONS(3570),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3572),
    [anon_sym_LPAREN] = ACTIONS(3574),
    [anon_sym_LBRACE] = ACTIONS(3576),
    [anon_sym_EQ_GT] = ACTIONS(3572),
    [anon_sym_LBRACK] = ACTIONS(3578),
    [anon_sym_RBRACK] = ACTIONS(5488),
    [anon_sym_COLON] = ACTIONS(3582),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(3584),
    [anon_sym_COMMA] = ACTIONS(3586),
    [anon_sym_u8] = ACTIONS(3588),
    [anon_sym_i8] = ACTIONS(3588),
    [anon_sym_u16] = ACTIONS(3588),
    [anon_sym_i16] = ACTIONS(3588),
    [anon_sym_u32] = ACTIONS(3588),
    [anon_sym_i32] = ACTIONS(3588),
    [anon_sym_u64] = ACTIONS(3588),
    [anon_sym_i64] = ACTIONS(3588),
    [anon_sym_u128] = ACTIONS(3588),
    [anon_sym_i128] = ACTIONS(3588),
    [anon_sym_isize] = ACTIONS(3588),
    [anon_sym_usize] = ACTIONS(3588),
    [anon_sym_f32] = ACTIONS(3588),
    [anon_sym_f64] = ACTIONS(3588),
    [anon_sym_bool] = ACTIONS(3588),
    [anon_sym_str] = ACTIONS(3588),
    [anon_sym_char] = ACTIONS(3588),
    [anon_sym__] = ACTIONS(3582),
    [anon_sym_AMP] = ACTIONS(3590),
    [anon_sym_DASH] = ACTIONS(3584),
    [anon_sym_DOT] = ACTIONS(3582),
    [anon_sym_DASH_EQ] = ACTIONS(3572),
    [anon_sym_DASH_GT] = ACTIONS(3572),
    [anon_sym_COLON_COLON] = ACTIONS(3572),
    [anon_sym_BANG] = ACTIONS(3592),
    [anon_sym_BANG_EQ] = ACTIONS(3572),
    [anon_sym_AT] = ACTIONS(3572),
    [anon_sym_STAR_EQ] = ACTIONS(3572),
    [anon_sym_SLASH] = ACTIONS(3582),
    [anon_sym_SLASH_EQ] = ACTIONS(3572),
    [anon_sym_AMP_AMP] = ACTIONS(3572),
    [anon_sym_AMP_EQ] = ACTIONS(3572),
    [anon_sym_POUND] = ACTIONS(3572),
    [anon_sym_PERCENT] = ACTIONS(3582),
    [anon_sym_PERCENT_EQ] = ACTIONS(3572),
    [anon_sym_CARET] = ACTIONS(3582),
    [anon_sym_CARET_EQ] = ACTIONS(3572),
    [anon_sym_PLUS_EQ] = ACTIONS(3572),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_LT_LT] = ACTIONS(3582),
    [anon_sym_LT_LT_EQ] = ACTIONS(3572),
    [anon_sym_LT_EQ] = ACTIONS(3572),
    [anon_sym_EQ] = ACTIONS(3582),
    [anon_sym_EQ_EQ] = ACTIONS(3572),
    [anon_sym_GT] = ACTIONS(3582),
    [anon_sym_GT_EQ] = ACTIONS(3572),
    [anon_sym_GT_GT] = ACTIONS(3582),
    [anon_sym_GT_GT_EQ] = ACTIONS(3572),
    [anon_sym_PIPE] = ACTIONS(2301),
    [anon_sym_PIPE_EQ] = ACTIONS(3572),
    [anon_sym_PIPE_PIPE] = ACTIONS(3572),
    [anon_sym_TILDE] = ACTIONS(3572),
    [anon_sym_QMARK] = ACTIONS(3572),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(3594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3572),
    [anon_sym_as] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3596),
    [anon_sym_const] = ACTIONS(3582),
    [anon_sym_continue] = ACTIONS(3598),
    [anon_sym_default] = ACTIONS(3600),
    [anon_sym_enum] = ACTIONS(3582),
    [anon_sym_fn] = ACTIONS(3582),
    [anon_sym_for] = ACTIONS(2313),
    [anon_sym_if] = ACTIONS(3602),
    [anon_sym_impl] = ACTIONS(3582),
    [anon_sym_let] = ACTIONS(3582),
    [anon_sym_loop] = ACTIONS(2317),
    [anon_sym_match] = ACTIONS(2319),
    [anon_sym_mod] = ACTIONS(3582),
    [anon_sym_pub] = ACTIONS(3582),
    [anon_sym_return] = ACTIONS(3604),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_struct] = ACTIONS(3582),
    [anon_sym_trait] = ACTIONS(3582),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_union] = ACTIONS(3600),
    [anon_sym_unsafe] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(3582),
    [anon_sym_where] = ACTIONS(3582),
    [anon_sym_while] = ACTIONS(2325),
    [sym_mutable_specifier] = ACTIONS(3582),
    [anon_sym_move] = ACTIONS(171),
    [sym_integer_literal] = ACTIONS(3570),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(3570),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3606),
    [sym_self] = ACTIONS(3608),
    [sym_super] = ACTIONS(3582),
    [sym_crate] = ACTIONS(3582),
    [sym_metavariable] = ACTIONS(3610),
  },
  [1850] = {
    [sym_raw_string_literal] = ACTIONS(3560),
    [sym_float_literal] = ACTIONS(3560),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym_LPAREN] = ACTIONS(5490),
    [anon_sym_RPAREN] = ACTIONS(5490),
    [anon_sym_LBRACE] = ACTIONS(3560),
    [anon_sym_EQ_GT] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(5490),
    [anon_sym_RBRACK] = ACTIONS(5490),
    [anon_sym_COLON] = ACTIONS(3562),
    [anon_sym_DOLLAR] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(5493),
    [anon_sym_STAR] = ACTIONS(5493),
    [anon_sym_COMMA] = ACTIONS(5490),
    [anon_sym_u8] = ACTIONS(3562),
    [anon_sym_i8] = ACTIONS(3562),
    [anon_sym_u16] = ACTIONS(3562),
    [anon_sym_i16] = ACTIONS(3562),
    [anon_sym_u32] = ACTIONS(3562),
    [anon_sym_i32] = ACTIONS(3562),
    [anon_sym_u64] = ACTIONS(3562),
    [anon_sym_i64] = ACTIONS(3562),
    [anon_sym_u128] = ACTIONS(3562),
    [anon_sym_i128] = ACTIONS(3562),
    [anon_sym_isize] = ACTIONS(3562),
    [anon_sym_usize] = ACTIONS(3562),
    [anon_sym_f32] = ACTIONS(3562),
    [anon_sym_f64] = ACTIONS(3562),
    [anon_sym_bool] = ACTIONS(3562),
    [anon_sym_str] = ACTIONS(3562),
    [anon_sym_char] = ACTIONS(3562),
    [anon_sym__] = ACTIONS(3562),
    [anon_sym_AMP] = ACTIONS(5493),
    [anon_sym_DASH] = ACTIONS(5493),
    [anon_sym_DOT] = ACTIONS(5493),
    [anon_sym_DASH_EQ] = ACTIONS(5490),
    [anon_sym_DASH_GT] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_BANG] = ACTIONS(3562),
    [anon_sym_BANG_EQ] = ACTIONS(5490),
    [anon_sym_AT] = ACTIONS(3560),
    [anon_sym_STAR_EQ] = ACTIONS(5490),
    [anon_sym_SLASH] = ACTIONS(5493),
    [anon_sym_SLASH_EQ] = ACTIONS(5490),
    [anon_sym_AMP_AMP] = ACTIONS(5490),
    [anon_sym_AMP_EQ] = ACTIONS(5490),
    [anon_sym_POUND] = ACTIONS(3560),
    [anon_sym_PERCENT] = ACTIONS(5493),
    [anon_sym_PERCENT_EQ] = ACTIONS(5490),
    [anon_sym_CARET] = ACTIONS(5493),
    [anon_sym_CARET_EQ] = ACTIONS(5490),
    [anon_sym_PLUS_EQ] = ACTIONS(5490),
    [anon_sym_LT] = ACTIONS(5493),
    [anon_sym_LT_LT] = ACTIONS(5493),
    [anon_sym_LT_LT_EQ] = ACTIONS(5490),
    [anon_sym_LT_EQ] = ACTIONS(5490),
    [anon_sym_EQ] = ACTIONS(5493),
    [anon_sym_EQ_EQ] = ACTIONS(5490),
    [anon_sym_GT] = ACTIONS(5493),
    [anon_sym_GT_EQ] = ACTIONS(5490),
    [anon_sym_GT_GT] = ACTIONS(5493),
    [anon_sym_GT_GT_EQ] = ACTIONS(5490),
    [anon_sym_PIPE] = ACTIONS(5493),
    [anon_sym_PIPE_EQ] = ACTIONS(5490),
    [anon_sym_PIPE_PIPE] = ACTIONS(5490),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_QMARK] = ACTIONS(5490),
    [anon_sym_SQUOTE] = ACTIONS(3562),
    [anon_sym_DOT_DOT] = ACTIONS(5493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5490),
    [anon_sym_as] = ACTIONS(5493),
    [anon_sym_break] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_continue] = ACTIONS(3562),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_fn] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_impl] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_loop] = ACTIONS(3562),
    [anon_sym_match] = ACTIONS(3562),
    [anon_sym_mod] = ACTIONS(3562),
    [anon_sym_pub] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_trait] = ACTIONS(3562),
    [anon_sym_type] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [anon_sym_unsafe] = ACTIONS(3562),
    [anon_sym_use] = ACTIONS(3562),
    [anon_sym_where] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [sym_mutable_specifier] = ACTIONS(3562),
    [sym_integer_literal] = ACTIONS(3560),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3560),
    [sym_char_literal] = ACTIONS(3560),
    [anon_sym_true] = ACTIONS(3562),
    [anon_sym_false] = ACTIONS(3562),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3562),
    [sym_self] = ACTIONS(3562),
    [sym_super] = ACTIONS(3562),
    [sym_crate] = ACTIONS(3562),
    [sym_metavariable] = ACTIONS(3560),
  },
  [1851] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(103),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(103),
    [sym_macro_invocation] = STATE(103),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(103),
    [sym_unary_expression] = STATE(103),
    [sym_try_expression] = STATE(103),
    [sym_reference_expression] = STATE(103),
    [sym_binary_expression] = STATE(103),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(103),
    [sym_call_expression] = STATE(103),
    [sym_array_expression] = STATE(103),
    [sym_parenthesized_expression] = STATE(103),
    [sym_tuple_expression] = STATE(103),
    [sym_unit_expression] = STATE(103),
    [sym_struct_expression] = STATE(103),
    [sym_if_expression] = STATE(103),
    [sym_if_let_expression] = STATE(103),
    [sym_match_expression] = STATE(103),
    [sym_while_expression] = STATE(103),
    [sym_while_let_expression] = STATE(103),
    [sym_loop_expression] = STATE(103),
    [sym_for_expression] = STATE(103),
    [sym_closure_expression] = STATE(103),
    [sym_closure_parameters] = STATE(101),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(103),
    [sym_continue_expression] = STATE(103),
    [sym_index_expression] = STATE(103),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(103),
    [sym_block] = STATE(103),
    [sym__literal] = STATE(103),
    [sym_string_literal] = STATE(103),
    [sym_boolean_literal] = STATE(103),
    [sym_raw_string_literal] = ACTIONS(3614),
    [sym_float_literal] = ACTIONS(3614),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3619),
    [anon_sym_LBRACE] = ACTIONS(3622),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3625),
    [anon_sym_RBRACK] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(5496),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3633),
    [anon_sym_i8] = ACTIONS(3633),
    [anon_sym_u16] = ACTIONS(3633),
    [anon_sym_i16] = ACTIONS(3633),
    [anon_sym_u32] = ACTIONS(3633),
    [anon_sym_i32] = ACTIONS(3633),
    [anon_sym_u64] = ACTIONS(3633),
    [anon_sym_i64] = ACTIONS(3633),
    [anon_sym_u128] = ACTIONS(3633),
    [anon_sym_i128] = ACTIONS(3633),
    [anon_sym_isize] = ACTIONS(3633),
    [anon_sym_usize] = ACTIONS(3633),
    [anon_sym_f32] = ACTIONS(3633),
    [anon_sym_f64] = ACTIONS(3633),
    [anon_sym_bool] = ACTIONS(3633),
    [anon_sym_str] = ACTIONS(3633),
    [anon_sym_char] = ACTIONS(3633),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(5499),
    [anon_sym_DASH] = ACTIONS(5496),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3639),
    [anon_sym_BANG] = ACTIONS(5496),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3645),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DOT_DOT] = ACTIONS(5502),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3657),
    [anon_sym_default] = ACTIONS(3660),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3663),
    [anon_sym_if] = ACTIONS(5505),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3669),
    [anon_sym_match] = ACTIONS(3672),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(5508),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3660),
    [anon_sym_unsafe] = ACTIONS(3678),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3681),
    [sym_mutable_specifier] = ACTIONS(3628),
    [anon_sym_move] = ACTIONS(171),
    [sym_integer_literal] = ACTIONS(3614),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3684),
    [sym_char_literal] = ACTIONS(3614),
    [anon_sym_true] = ACTIONS(3687),
    [anon_sym_false] = ACTIONS(3687),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3690),
    [sym_self] = ACTIONS(3693),
    [sym_super] = ACTIONS(3696),
    [sym_crate] = ACTIONS(3696),
    [sym_metavariable] = ACTIONS(3699),
  },
  [1852] = {
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3617),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_RBRACK] = ACTIONS(5511),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3628),
    [anon_sym_DASH] = ACTIONS(3628),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3628),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3628),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3628),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1853] = {
    [sym_raw_string_literal] = ACTIONS(3702),
    [sym_float_literal] = ACTIONS(3702),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3704),
    [anon_sym_LPAREN] = ACTIONS(3704),
    [anon_sym_LBRACE] = ACTIONS(3702),
    [anon_sym_EQ_GT] = ACTIONS(3702),
    [anon_sym_LBRACK] = ACTIONS(3704),
    [anon_sym_RBRACK] = ACTIONS(3704),
    [anon_sym_COLON] = ACTIONS(3707),
    [anon_sym_DOLLAR] = ACTIONS(3707),
    [anon_sym_PLUS] = ACTIONS(3709),
    [anon_sym_STAR] = ACTIONS(3709),
    [anon_sym_COMMA] = ACTIONS(3704),
    [anon_sym_u8] = ACTIONS(3707),
    [anon_sym_i8] = ACTIONS(3707),
    [anon_sym_u16] = ACTIONS(3707),
    [anon_sym_i16] = ACTIONS(3707),
    [anon_sym_u32] = ACTIONS(3707),
    [anon_sym_i32] = ACTIONS(3707),
    [anon_sym_u64] = ACTIONS(3707),
    [anon_sym_i64] = ACTIONS(3707),
    [anon_sym_u128] = ACTIONS(3707),
    [anon_sym_i128] = ACTIONS(3707),
    [anon_sym_isize] = ACTIONS(3707),
    [anon_sym_usize] = ACTIONS(3707),
    [anon_sym_f32] = ACTIONS(3707),
    [anon_sym_f64] = ACTIONS(3707),
    [anon_sym_bool] = ACTIONS(3707),
    [anon_sym_str] = ACTIONS(3707),
    [anon_sym_char] = ACTIONS(3707),
    [anon_sym__] = ACTIONS(3707),
    [anon_sym_AMP] = ACTIONS(3709),
    [anon_sym_DASH] = ACTIONS(3709),
    [anon_sym_DOT] = ACTIONS(3709),
    [anon_sym_DASH_EQ] = ACTIONS(3704),
    [anon_sym_DASH_GT] = ACTIONS(3702),
    [anon_sym_COLON_COLON] = ACTIONS(3702),
    [anon_sym_BANG] = ACTIONS(3707),
    [anon_sym_BANG_EQ] = ACTIONS(3704),
    [anon_sym_AT] = ACTIONS(3702),
    [anon_sym_STAR_EQ] = ACTIONS(3704),
    [anon_sym_SLASH] = ACTIONS(3709),
    [anon_sym_SLASH_EQ] = ACTIONS(3704),
    [anon_sym_AMP_AMP] = ACTIONS(3704),
    [anon_sym_AMP_EQ] = ACTIONS(3704),
    [anon_sym_POUND] = ACTIONS(3702),
    [anon_sym_PERCENT] = ACTIONS(3709),
    [anon_sym_PERCENT_EQ] = ACTIONS(3704),
    [anon_sym_CARET] = ACTIONS(3709),
    [anon_sym_CARET_EQ] = ACTIONS(3704),
    [anon_sym_PLUS_EQ] = ACTIONS(3704),
    [anon_sym_LT] = ACTIONS(3709),
    [anon_sym_LT_LT] = ACTIONS(3709),
    [anon_sym_LT_LT_EQ] = ACTIONS(3704),
    [anon_sym_LT_EQ] = ACTIONS(3704),
    [anon_sym_EQ] = ACTIONS(3709),
    [anon_sym_EQ_EQ] = ACTIONS(3704),
    [anon_sym_GT] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3704),
    [anon_sym_GT_GT] = ACTIONS(3709),
    [anon_sym_GT_GT_EQ] = ACTIONS(3704),
    [anon_sym_PIPE] = ACTIONS(3709),
    [anon_sym_PIPE_EQ] = ACTIONS(3704),
    [anon_sym_PIPE_PIPE] = ACTIONS(3704),
    [anon_sym_TILDE] = ACTIONS(3702),
    [anon_sym_QMARK] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(3707),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3704),
    [anon_sym_as] = ACTIONS(3709),
    [anon_sym_break] = ACTIONS(3707),
    [anon_sym_const] = ACTIONS(3707),
    [anon_sym_continue] = ACTIONS(3707),
    [anon_sym_default] = ACTIONS(3707),
    [anon_sym_enum] = ACTIONS(3707),
    [anon_sym_fn] = ACTIONS(3707),
    [anon_sym_for] = ACTIONS(3707),
    [anon_sym_if] = ACTIONS(3707),
    [anon_sym_impl] = ACTIONS(3707),
    [anon_sym_let] = ACTIONS(3707),
    [anon_sym_loop] = ACTIONS(3707),
    [anon_sym_match] = ACTIONS(3707),
    [anon_sym_mod] = ACTIONS(3707),
    [anon_sym_pub] = ACTIONS(3707),
    [anon_sym_return] = ACTIONS(3707),
    [anon_sym_static] = ACTIONS(3707),
    [anon_sym_struct] = ACTIONS(3707),
    [anon_sym_trait] = ACTIONS(3707),
    [anon_sym_type] = ACTIONS(3707),
    [anon_sym_union] = ACTIONS(3707),
    [anon_sym_unsafe] = ACTIONS(3707),
    [anon_sym_use] = ACTIONS(3707),
    [anon_sym_where] = ACTIONS(3707),
    [anon_sym_while] = ACTIONS(3707),
    [sym_mutable_specifier] = ACTIONS(3707),
    [sym_integer_literal] = ACTIONS(3702),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3702),
    [sym_char_literal] = ACTIONS(3702),
    [anon_sym_true] = ACTIONS(3707),
    [anon_sym_false] = ACTIONS(3707),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3707),
    [sym_self] = ACTIONS(3707),
    [sym_super] = ACTIONS(3707),
    [sym_crate] = ACTIONS(3707),
    [sym_metavariable] = ACTIONS(3702),
  },
  [1854] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(106),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(106),
    [sym_macro_invocation] = STATE(106),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(106),
    [sym_unary_expression] = STATE(106),
    [sym_try_expression] = STATE(106),
    [sym_reference_expression] = STATE(106),
    [sym_binary_expression] = STATE(106),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(106),
    [sym_call_expression] = STATE(106),
    [sym_array_expression] = STATE(106),
    [sym_parenthesized_expression] = STATE(106),
    [sym_tuple_expression] = STATE(106),
    [sym_unit_expression] = STATE(106),
    [sym_struct_expression] = STATE(106),
    [sym_if_expression] = STATE(106),
    [sym_if_let_expression] = STATE(106),
    [sym_match_expression] = STATE(106),
    [sym_while_expression] = STATE(106),
    [sym_while_let_expression] = STATE(106),
    [sym_loop_expression] = STATE(106),
    [sym_for_expression] = STATE(106),
    [sym_closure_expression] = STATE(106),
    [sym_closure_parameters] = STATE(101),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(106),
    [sym_continue_expression] = STATE(106),
    [sym_index_expression] = STATE(106),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(106),
    [sym_block] = STATE(106),
    [sym__literal] = STATE(106),
    [sym_string_literal] = STATE(106),
    [sym_boolean_literal] = STATE(106),
    [sym_raw_string_literal] = ACTIONS(3712),
    [sym_float_literal] = ACTIONS(3712),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3619),
    [anon_sym_LBRACE] = ACTIONS(3622),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3625),
    [anon_sym_RBRACK] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(5496),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3633),
    [anon_sym_i8] = ACTIONS(3633),
    [anon_sym_u16] = ACTIONS(3633),
    [anon_sym_i16] = ACTIONS(3633),
    [anon_sym_u32] = ACTIONS(3633),
    [anon_sym_i32] = ACTIONS(3633),
    [anon_sym_u64] = ACTIONS(3633),
    [anon_sym_i64] = ACTIONS(3633),
    [anon_sym_u128] = ACTIONS(3633),
    [anon_sym_i128] = ACTIONS(3633),
    [anon_sym_isize] = ACTIONS(3633),
    [anon_sym_usize] = ACTIONS(3633),
    [anon_sym_f32] = ACTIONS(3633),
    [anon_sym_f64] = ACTIONS(3633),
    [anon_sym_bool] = ACTIONS(3633),
    [anon_sym_str] = ACTIONS(3633),
    [anon_sym_char] = ACTIONS(3633),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(5499),
    [anon_sym_DASH] = ACTIONS(5496),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3639),
    [anon_sym_BANG] = ACTIONS(5496),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3645),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DOT_DOT] = ACTIONS(5502),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3657),
    [anon_sym_default] = ACTIONS(3660),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3663),
    [anon_sym_if] = ACTIONS(5505),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3669),
    [anon_sym_match] = ACTIONS(3672),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(5508),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3660),
    [anon_sym_unsafe] = ACTIONS(3678),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3681),
    [sym_mutable_specifier] = ACTIONS(5514),
    [anon_sym_move] = ACTIONS(171),
    [sym_integer_literal] = ACTIONS(3712),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3684),
    [sym_char_literal] = ACTIONS(3712),
    [anon_sym_true] = ACTIONS(3687),
    [anon_sym_false] = ACTIONS(3687),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3690),
    [sym_self] = ACTIONS(3693),
    [sym_super] = ACTIONS(3696),
    [sym_crate] = ACTIONS(3696),
    [sym_metavariable] = ACTIONS(3699),
  },
  [1855] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(103),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(103),
    [sym_macro_invocation] = STATE(103),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(103),
    [sym_unary_expression] = STATE(103),
    [sym_try_expression] = STATE(103),
    [sym_reference_expression] = STATE(103),
    [sym_binary_expression] = STATE(103),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(103),
    [sym_call_expression] = STATE(103),
    [sym_array_expression] = STATE(103),
    [sym_parenthesized_expression] = STATE(103),
    [sym_tuple_expression] = STATE(103),
    [sym_unit_expression] = STATE(103),
    [sym_struct_expression] = STATE(103),
    [sym_if_expression] = STATE(103),
    [sym_if_let_expression] = STATE(103),
    [sym_match_expression] = STATE(103),
    [sym_while_expression] = STATE(103),
    [sym_while_let_expression] = STATE(103),
    [sym_loop_expression] = STATE(103),
    [sym_for_expression] = STATE(103),
    [sym_closure_expression] = STATE(103),
    [sym_closure_parameters] = STATE(101),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(103),
    [sym_continue_expression] = STATE(103),
    [sym_index_expression] = STATE(103),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(103),
    [sym_block] = STATE(103),
    [sym__literal] = STATE(103),
    [sym_string_literal] = STATE(103),
    [sym_boolean_literal] = STATE(103),
    [sym_raw_string_literal] = ACTIONS(173),
    [sym_float_literal] = ACTIONS(173),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_RBRACK] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(661),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(5517),
    [anon_sym_DASH] = ACTIONS(661),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3720),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3722),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5519),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(133),
    [sym_mutable_specifier] = ACTIONS(3628),
    [anon_sym_move] = ACTIONS(171),
    [sym_integer_literal] = ACTIONS(173),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(173),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1856] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(335),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(335),
    [sym_macro_invocation] = STATE(335),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(335),
    [sym_unary_expression] = STATE(335),
    [sym_try_expression] = STATE(335),
    [sym_reference_expression] = STATE(335),
    [sym_binary_expression] = STATE(335),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(335),
    [sym_call_expression] = STATE(335),
    [sym_array_expression] = STATE(335),
    [sym_parenthesized_expression] = STATE(335),
    [sym_tuple_expression] = STATE(335),
    [sym_unit_expression] = STATE(335),
    [sym_struct_expression] = STATE(335),
    [sym_if_expression] = STATE(335),
    [sym_if_let_expression] = STATE(335),
    [sym_match_expression] = STATE(335),
    [sym_while_expression] = STATE(335),
    [sym_while_let_expression] = STATE(335),
    [sym_loop_expression] = STATE(335),
    [sym_for_expression] = STATE(335),
    [sym_closure_expression] = STATE(335),
    [sym_closure_parameters] = STATE(101),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(335),
    [sym_continue_expression] = STATE(335),
    [sym_index_expression] = STATE(335),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(335),
    [sym_block] = STATE(335),
    [sym__literal] = STATE(335),
    [sym_string_literal] = STATE(335),
    [sym_boolean_literal] = STATE(335),
    [sym_raw_string_literal] = ACTIONS(659),
    [sym_float_literal] = ACTIONS(659),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(261),
    [anon_sym_LPAREN] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_RBRACK] = ACTIONS(261),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(263),
    [anon_sym_COMMA] = ACTIONS(261),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(263),
    [anon_sym_DASH] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(263),
    [anon_sym_DASH_EQ] = ACTIONS(261),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_BANG_EQ] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(261),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_SLASH_EQ] = ACTIONS(261),
    [anon_sym_AMP_AMP] = ACTIONS(261),
    [anon_sym_AMP_EQ] = ACTIONS(261),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(263),
    [anon_sym_PERCENT_EQ] = ACTIONS(261),
    [anon_sym_CARET] = ACTIONS(263),
    [anon_sym_CARET_EQ] = ACTIONS(261),
    [anon_sym_PLUS_EQ] = ACTIONS(261),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_EQ] = ACTIONS(261),
    [anon_sym_LT_EQ] = ACTIONS(261),
    [anon_sym_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(261),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_EQ] = ACTIONS(261),
    [anon_sym_GT_GT] = ACTIONS(263),
    [anon_sym_GT_GT_EQ] = ACTIONS(261),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_PIPE_EQ] = ACTIONS(261),
    [anon_sym_PIPE_PIPE] = ACTIONS(261),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(263),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(261),
    [anon_sym_as] = ACTIONS(263),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(133),
    [sym_mutable_specifier] = ACTIONS(3628),
    [anon_sym_move] = ACTIONS(171),
    [sym_integer_literal] = ACTIONS(659),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(659),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1857] = {
    [sym_loop_label] = STATE(156),
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3816),
    [anon_sym_LPAREN] = ACTIONS(3816),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3816),
    [anon_sym_RBRACK] = ACTIONS(3816),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3819),
    [anon_sym_STAR] = ACTIONS(3819),
    [anon_sym_COMMA] = ACTIONS(3816),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3819),
    [anon_sym_DASH] = ACTIONS(3819),
    [anon_sym_DOT] = ACTIONS(3819),
    [anon_sym_DASH_EQ] = ACTIONS(3816),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3816),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3816),
    [anon_sym_SLASH] = ACTIONS(3819),
    [anon_sym_SLASH_EQ] = ACTIONS(3816),
    [anon_sym_AMP_AMP] = ACTIONS(3816),
    [anon_sym_AMP_EQ] = ACTIONS(3816),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3819),
    [anon_sym_PERCENT_EQ] = ACTIONS(3816),
    [anon_sym_CARET] = ACTIONS(3819),
    [anon_sym_CARET_EQ] = ACTIONS(3816),
    [anon_sym_PLUS_EQ] = ACTIONS(3816),
    [anon_sym_LT] = ACTIONS(3819),
    [anon_sym_LT_LT] = ACTIONS(3819),
    [anon_sym_LT_LT_EQ] = ACTIONS(3816),
    [anon_sym_LT_EQ] = ACTIONS(3816),
    [anon_sym_EQ] = ACTIONS(3819),
    [anon_sym_EQ_EQ] = ACTIONS(3816),
    [anon_sym_GT] = ACTIONS(3819),
    [anon_sym_GT_EQ] = ACTIONS(3816),
    [anon_sym_GT_GT] = ACTIONS(3819),
    [anon_sym_GT_GT_EQ] = ACTIONS(3816),
    [anon_sym_PIPE] = ACTIONS(3819),
    [anon_sym_PIPE_EQ] = ACTIONS(3816),
    [anon_sym_PIPE_PIPE] = ACTIONS(3816),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3816),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DOT_DOT] = ACTIONS(3819),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3816),
    [anon_sym_as] = ACTIONS(3819),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3628),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1858] = {
    [sym_loop_label] = STATE(158),
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3822),
    [anon_sym_LPAREN] = ACTIONS(3822),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3822),
    [anon_sym_RBRACK] = ACTIONS(3822),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3825),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_COMMA] = ACTIONS(3822),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3825),
    [anon_sym_DASH] = ACTIONS(3825),
    [anon_sym_DOT] = ACTIONS(3825),
    [anon_sym_DASH_EQ] = ACTIONS(3822),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3822),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3822),
    [anon_sym_SLASH] = ACTIONS(3825),
    [anon_sym_SLASH_EQ] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(3822),
    [anon_sym_AMP_EQ] = ACTIONS(3822),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3825),
    [anon_sym_PERCENT_EQ] = ACTIONS(3822),
    [anon_sym_CARET] = ACTIONS(3825),
    [anon_sym_CARET_EQ] = ACTIONS(3822),
    [anon_sym_PLUS_EQ] = ACTIONS(3822),
    [anon_sym_LT] = ACTIONS(3825),
    [anon_sym_LT_LT] = ACTIONS(3825),
    [anon_sym_LT_LT_EQ] = ACTIONS(3822),
    [anon_sym_LT_EQ] = ACTIONS(3822),
    [anon_sym_EQ] = ACTIONS(3825),
    [anon_sym_EQ_EQ] = ACTIONS(3822),
    [anon_sym_GT] = ACTIONS(3825),
    [anon_sym_GT_EQ] = ACTIONS(3822),
    [anon_sym_GT_GT] = ACTIONS(3825),
    [anon_sym_GT_GT_EQ] = ACTIONS(3822),
    [anon_sym_PIPE] = ACTIONS(3825),
    [anon_sym_PIPE_EQ] = ACTIONS(3822),
    [anon_sym_PIPE_PIPE] = ACTIONS(3822),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3822),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DOT_DOT] = ACTIONS(3825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3822),
    [anon_sym_as] = ACTIONS(3825),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3628),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1859] = {
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3828),
    [anon_sym_LPAREN] = ACTIONS(3828),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3828),
    [anon_sym_RBRACK] = ACTIONS(3828),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3831),
    [anon_sym_STAR] = ACTIONS(3831),
    [anon_sym_COMMA] = ACTIONS(3828),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3831),
    [anon_sym_DASH] = ACTIONS(3831),
    [anon_sym_DOT] = ACTIONS(3831),
    [anon_sym_DASH_EQ] = ACTIONS(3828),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3828),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3828),
    [anon_sym_SLASH] = ACTIONS(3831),
    [anon_sym_SLASH_EQ] = ACTIONS(3828),
    [anon_sym_AMP_AMP] = ACTIONS(3828),
    [anon_sym_AMP_EQ] = ACTIONS(3828),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3831),
    [anon_sym_PERCENT_EQ] = ACTIONS(3828),
    [anon_sym_CARET] = ACTIONS(3831),
    [anon_sym_CARET_EQ] = ACTIONS(3828),
    [anon_sym_PLUS_EQ] = ACTIONS(3828),
    [anon_sym_LT] = ACTIONS(3831),
    [anon_sym_LT_LT] = ACTIONS(3831),
    [anon_sym_LT_LT_EQ] = ACTIONS(3828),
    [anon_sym_LT_EQ] = ACTIONS(3828),
    [anon_sym_EQ] = ACTIONS(3831),
    [anon_sym_EQ_EQ] = ACTIONS(3828),
    [anon_sym_GT] = ACTIONS(3831),
    [anon_sym_GT_EQ] = ACTIONS(3828),
    [anon_sym_GT_GT] = ACTIONS(3831),
    [anon_sym_GT_GT_EQ] = ACTIONS(3828),
    [anon_sym_PIPE] = ACTIONS(3831),
    [anon_sym_PIPE_EQ] = ACTIONS(3828),
    [anon_sym_PIPE_PIPE] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3828),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3831),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3828),
    [anon_sym_as] = ACTIONS(3831),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3628),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1860] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(337),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(337),
    [sym_macro_invocation] = STATE(337),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(337),
    [sym_unary_expression] = STATE(337),
    [sym_try_expression] = STATE(337),
    [sym_reference_expression] = STATE(337),
    [sym_binary_expression] = STATE(337),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(337),
    [sym_call_expression] = STATE(337),
    [sym_array_expression] = STATE(337),
    [sym_parenthesized_expression] = STATE(337),
    [sym_tuple_expression] = STATE(337),
    [sym_unit_expression] = STATE(337),
    [sym_struct_expression] = STATE(337),
    [sym_if_expression] = STATE(337),
    [sym_if_let_expression] = STATE(337),
    [sym_match_expression] = STATE(337),
    [sym_while_expression] = STATE(337),
    [sym_while_let_expression] = STATE(337),
    [sym_loop_expression] = STATE(337),
    [sym_for_expression] = STATE(337),
    [sym_closure_expression] = STATE(337),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(337),
    [sym_continue_expression] = STATE(337),
    [sym_index_expression] = STATE(337),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(337),
    [sym_block] = STATE(337),
    [sym__literal] = STATE(337),
    [sym_string_literal] = STATE(337),
    [sym_boolean_literal] = STATE(337),
    [sym_raw_string_literal] = ACTIONS(5521),
    [sym_float_literal] = ACTIONS(5521),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3619),
    [anon_sym_LBRACE] = ACTIONS(3622),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3625),
    [anon_sym_RBRACK] = ACTIONS(3617),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3628),
    [anon_sym_STAR] = ACTIONS(3855),
    [anon_sym_COMMA] = ACTIONS(3617),
    [anon_sym_u8] = ACTIONS(3858),
    [anon_sym_i8] = ACTIONS(3858),
    [anon_sym_u16] = ACTIONS(3858),
    [anon_sym_i16] = ACTIONS(3858),
    [anon_sym_u32] = ACTIONS(3858),
    [anon_sym_i32] = ACTIONS(3858),
    [anon_sym_u64] = ACTIONS(3858),
    [anon_sym_i64] = ACTIONS(3858),
    [anon_sym_u128] = ACTIONS(3858),
    [anon_sym_i128] = ACTIONS(3858),
    [anon_sym_isize] = ACTIONS(3858),
    [anon_sym_usize] = ACTIONS(3858),
    [anon_sym_f32] = ACTIONS(3858),
    [anon_sym_f64] = ACTIONS(3858),
    [anon_sym_bool] = ACTIONS(3858),
    [anon_sym_str] = ACTIONS(3858),
    [anon_sym_char] = ACTIONS(3858),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3861),
    [anon_sym_DASH] = ACTIONS(3855),
    [anon_sym_DOT] = ACTIONS(3628),
    [anon_sym_DASH_EQ] = ACTIONS(3617),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3864),
    [anon_sym_BANG] = ACTIONS(3855),
    [anon_sym_BANG_EQ] = ACTIONS(3617),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_SLASH_EQ] = ACTIONS(3617),
    [anon_sym_AMP_AMP] = ACTIONS(3617),
    [anon_sym_AMP_EQ] = ACTIONS(3617),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [anon_sym_PERCENT_EQ] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3628),
    [anon_sym_CARET_EQ] = ACTIONS(3617),
    [anon_sym_PLUS_EQ] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3628),
    [anon_sym_LT_LT_EQ] = ACTIONS(3617),
    [anon_sym_LT_EQ] = ACTIONS(3617),
    [anon_sym_EQ] = ACTIONS(3628),
    [anon_sym_EQ_EQ] = ACTIONS(3617),
    [anon_sym_GT] = ACTIONS(3628),
    [anon_sym_GT_EQ] = ACTIONS(3617),
    [anon_sym_GT_GT] = ACTIONS(3628),
    [anon_sym_GT_GT_EQ] = ACTIONS(3617),
    [anon_sym_PIPE] = ACTIONS(3645),
    [anon_sym_PIPE_EQ] = ACTIONS(3617),
    [anon_sym_PIPE_PIPE] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3617),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DOT_DOT] = ACTIONS(3867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3617),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_break] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3657),
    [anon_sym_default] = ACTIONS(3660),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3663),
    [anon_sym_if] = ACTIONS(3870),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(5524),
    [anon_sym_loop] = ACTIONS(3669),
    [anon_sym_match] = ACTIONS(3672),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3876),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3660),
    [anon_sym_unsafe] = ACTIONS(3678),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3681),
    [sym_mutable_specifier] = ACTIONS(3628),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(5521),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3684),
    [sym_char_literal] = ACTIONS(5521),
    [anon_sym_true] = ACTIONS(3687),
    [anon_sym_false] = ACTIONS(3687),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3879),
    [sym_self] = ACTIONS(3882),
    [sym_super] = ACTIONS(3885),
    [sym_crate] = ACTIONS(3885),
    [sym_metavariable] = ACTIONS(3888),
  },
  [1861] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(338),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(338),
    [sym_macro_invocation] = STATE(338),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(338),
    [sym_unary_expression] = STATE(338),
    [sym_try_expression] = STATE(338),
    [sym_reference_expression] = STATE(338),
    [sym_binary_expression] = STATE(338),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(338),
    [sym_call_expression] = STATE(338),
    [sym_array_expression] = STATE(338),
    [sym_parenthesized_expression] = STATE(338),
    [sym_tuple_expression] = STATE(338),
    [sym_unit_expression] = STATE(338),
    [sym_struct_expression] = STATE(338),
    [sym_if_expression] = STATE(338),
    [sym_if_let_expression] = STATE(338),
    [sym_match_expression] = STATE(338),
    [sym_while_expression] = STATE(338),
    [sym_while_let_expression] = STATE(338),
    [sym_loop_expression] = STATE(338),
    [sym_for_expression] = STATE(338),
    [sym_closure_expression] = STATE(338),
    [sym_closure_parameters] = STATE(101),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(338),
    [sym_continue_expression] = STATE(338),
    [sym_index_expression] = STATE(338),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(338),
    [sym_block] = STATE(338),
    [sym__literal] = STATE(338),
    [sym_string_literal] = STATE(338),
    [sym_boolean_literal] = STATE(338),
    [sym_raw_string_literal] = ACTIONS(5527),
    [sym_float_literal] = ACTIONS(5527),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3901),
    [anon_sym_LPAREN] = ACTIONS(3897),
    [anon_sym_LBRACE] = ACTIONS(3622),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3904),
    [anon_sym_RBRACK] = ACTIONS(3901),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3908),
    [anon_sym_STAR] = ACTIONS(5530),
    [anon_sym_COMMA] = ACTIONS(3901),
    [anon_sym_u8] = ACTIONS(3633),
    [anon_sym_i8] = ACTIONS(3633),
    [anon_sym_u16] = ACTIONS(3633),
    [anon_sym_i16] = ACTIONS(3633),
    [anon_sym_u32] = ACTIONS(3633),
    [anon_sym_i32] = ACTIONS(3633),
    [anon_sym_u64] = ACTIONS(3633),
    [anon_sym_i64] = ACTIONS(3633),
    [anon_sym_u128] = ACTIONS(3633),
    [anon_sym_i128] = ACTIONS(3633),
    [anon_sym_isize] = ACTIONS(3633),
    [anon_sym_usize] = ACTIONS(3633),
    [anon_sym_f32] = ACTIONS(3633),
    [anon_sym_f64] = ACTIONS(3633),
    [anon_sym_bool] = ACTIONS(3633),
    [anon_sym_str] = ACTIONS(3633),
    [anon_sym_char] = ACTIONS(3633),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(5534),
    [anon_sym_DASH] = ACTIONS(5530),
    [anon_sym_DOT] = ACTIONS(3908),
    [anon_sym_DASH_EQ] = ACTIONS(3901),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3639),
    [anon_sym_BANG] = ACTIONS(5496),
    [anon_sym_BANG_EQ] = ACTIONS(3901),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3901),
    [anon_sym_SLASH] = ACTIONS(3908),
    [anon_sym_SLASH_EQ] = ACTIONS(3901),
    [anon_sym_AMP_AMP] = ACTIONS(3901),
    [anon_sym_AMP_EQ] = ACTIONS(3901),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3908),
    [anon_sym_PERCENT_EQ] = ACTIONS(3901),
    [anon_sym_CARET] = ACTIONS(3908),
    [anon_sym_CARET_EQ] = ACTIONS(3901),
    [anon_sym_PLUS_EQ] = ACTIONS(3901),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_LT_LT] = ACTIONS(3908),
    [anon_sym_LT_LT_EQ] = ACTIONS(3901),
    [anon_sym_LT_EQ] = ACTIONS(3901),
    [anon_sym_EQ] = ACTIONS(3908),
    [anon_sym_EQ_EQ] = ACTIONS(3901),
    [anon_sym_GT] = ACTIONS(3908),
    [anon_sym_GT_EQ] = ACTIONS(3901),
    [anon_sym_GT_GT] = ACTIONS(3908),
    [anon_sym_GT_GT_EQ] = ACTIONS(3901),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_PIPE_EQ] = ACTIONS(3901),
    [anon_sym_PIPE_PIPE] = ACTIONS(3901),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3901),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_DOT_DOT] = ACTIONS(5538),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3901),
    [anon_sym_as] = ACTIONS(3908),
    [anon_sym_break] = ACTIONS(3654),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3657),
    [anon_sym_default] = ACTIONS(3660),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3663),
    [anon_sym_if] = ACTIONS(5505),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3669),
    [anon_sym_match] = ACTIONS(3672),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(5508),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3660),
    [anon_sym_unsafe] = ACTIONS(3678),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3681),
    [sym_mutable_specifier] = ACTIONS(3628),
    [anon_sym_move] = ACTIONS(171),
    [sym_integer_literal] = ACTIONS(5527),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3684),
    [sym_char_literal] = ACTIONS(5527),
    [anon_sym_true] = ACTIONS(3687),
    [anon_sym_false] = ACTIONS(3687),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3690),
    [sym_self] = ACTIONS(3693),
    [sym_super] = ACTIONS(3696),
    [sym_crate] = ACTIONS(3696),
    [sym_metavariable] = ACTIONS(3699),
  },
  [1862] = {
    [sym_field_initializer_list] = STATE(224),
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3941),
    [anon_sym_LPAREN] = ACTIONS(3941),
    [anon_sym_LBRACE] = ACTIONS(3944),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3941),
    [anon_sym_RBRACK] = ACTIONS(3941),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_STAR] = ACTIONS(3947),
    [anon_sym_COMMA] = ACTIONS(3941),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_DOT] = ACTIONS(3947),
    [anon_sym_DASH_EQ] = ACTIONS(3941),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3950),
    [anon_sym_BANG] = ACTIONS(3953),
    [anon_sym_BANG_EQ] = ACTIONS(3941),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3941),
    [anon_sym_SLASH] = ACTIONS(3947),
    [anon_sym_SLASH_EQ] = ACTIONS(3941),
    [anon_sym_AMP_AMP] = ACTIONS(3941),
    [anon_sym_AMP_EQ] = ACTIONS(3941),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3947),
    [anon_sym_PERCENT_EQ] = ACTIONS(3941),
    [anon_sym_CARET] = ACTIONS(3947),
    [anon_sym_CARET_EQ] = ACTIONS(3941),
    [anon_sym_PLUS_EQ] = ACTIONS(3941),
    [anon_sym_LT] = ACTIONS(3947),
    [anon_sym_LT_LT] = ACTIONS(3947),
    [anon_sym_LT_LT_EQ] = ACTIONS(3941),
    [anon_sym_LT_EQ] = ACTIONS(3941),
    [anon_sym_EQ] = ACTIONS(3947),
    [anon_sym_EQ_EQ] = ACTIONS(3941),
    [anon_sym_GT] = ACTIONS(3947),
    [anon_sym_GT_EQ] = ACTIONS(3941),
    [anon_sym_GT_GT] = ACTIONS(3947),
    [anon_sym_GT_GT_EQ] = ACTIONS(3941),
    [anon_sym_PIPE] = ACTIONS(3947),
    [anon_sym_PIPE_EQ] = ACTIONS(3941),
    [anon_sym_PIPE_PIPE] = ACTIONS(3941),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3947),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3628),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1863] = {
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3941),
    [anon_sym_LPAREN] = ACTIONS(3941),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3941),
    [anon_sym_RBRACK] = ACTIONS(3941),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_STAR] = ACTIONS(3947),
    [anon_sym_COMMA] = ACTIONS(3941),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_DOT] = ACTIONS(3947),
    [anon_sym_DASH_EQ] = ACTIONS(3941),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3941),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3941),
    [anon_sym_SLASH] = ACTIONS(3947),
    [anon_sym_SLASH_EQ] = ACTIONS(3941),
    [anon_sym_AMP_AMP] = ACTIONS(3941),
    [anon_sym_AMP_EQ] = ACTIONS(3941),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3947),
    [anon_sym_PERCENT_EQ] = ACTIONS(3941),
    [anon_sym_CARET] = ACTIONS(3947),
    [anon_sym_CARET_EQ] = ACTIONS(3941),
    [anon_sym_PLUS_EQ] = ACTIONS(3941),
    [anon_sym_LT] = ACTIONS(3947),
    [anon_sym_LT_LT] = ACTIONS(3947),
    [anon_sym_LT_LT_EQ] = ACTIONS(3941),
    [anon_sym_LT_EQ] = ACTIONS(3941),
    [anon_sym_EQ] = ACTIONS(3947),
    [anon_sym_EQ_EQ] = ACTIONS(3941),
    [anon_sym_GT] = ACTIONS(3947),
    [anon_sym_GT_EQ] = ACTIONS(3941),
    [anon_sym_GT_GT] = ACTIONS(3947),
    [anon_sym_GT_GT_EQ] = ACTIONS(3941),
    [anon_sym_PIPE] = ACTIONS(3947),
    [anon_sym_PIPE_EQ] = ACTIONS(3941),
    [anon_sym_PIPE_PIPE] = ACTIONS(3941),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3947),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3628),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1864] = {
    [sym_arguments] = STATE(263),
    [aux_sym_token_tree_repeat2] = STATE(2483),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5542),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_COMMA] = ACTIONS(5544),
    [anon_sym_AMP] = ACTIONS(677),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(679),
    [anon_sym_BANG_EQ] = ACTIONS(681),
    [anon_sym_STAR_EQ] = ACTIONS(679),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_SLASH_EQ] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(683),
    [anon_sym_AMP_EQ] = ACTIONS(679),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_PERCENT_EQ] = ACTIONS(679),
    [anon_sym_CARET] = ACTIONS(685),
    [anon_sym_CARET_EQ] = ACTIONS(679),
    [anon_sym_PLUS_EQ] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_LT_LT] = ACTIONS(689),
    [anon_sym_LT_LT_EQ] = ACTIONS(679),
    [anon_sym_LT_EQ] = ACTIONS(681),
    [anon_sym_EQ] = ACTIONS(691),
    [anon_sym_EQ_EQ] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(689),
    [anon_sym_GT_GT_EQ] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(693),
    [anon_sym_PIPE_EQ] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(697),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(699),
    [anon_sym_as] = ACTIONS(701),
    [sym_line_comment] = ACTIONS(7),
  },
  [1865] = {
    [sym_raw_string_literal] = ACTIONS(3617),
    [sym_float_literal] = ACTIONS(3617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3941),
    [anon_sym_LPAREN] = ACTIONS(3941),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [anon_sym_LBRACK] = ACTIONS(3941),
    [anon_sym_RBRACK] = ACTIONS(3941),
    [anon_sym_COLON] = ACTIONS(3628),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_STAR] = ACTIONS(3947),
    [anon_sym_COMMA] = ACTIONS(3941),
    [anon_sym_u8] = ACTIONS(3628),
    [anon_sym_i8] = ACTIONS(3628),
    [anon_sym_u16] = ACTIONS(3628),
    [anon_sym_i16] = ACTIONS(3628),
    [anon_sym_u32] = ACTIONS(3628),
    [anon_sym_i32] = ACTIONS(3628),
    [anon_sym_u64] = ACTIONS(3628),
    [anon_sym_i64] = ACTIONS(3628),
    [anon_sym_u128] = ACTIONS(3628),
    [anon_sym_i128] = ACTIONS(3628),
    [anon_sym_isize] = ACTIONS(3628),
    [anon_sym_usize] = ACTIONS(3628),
    [anon_sym_f32] = ACTIONS(3628),
    [anon_sym_f64] = ACTIONS(3628),
    [anon_sym_bool] = ACTIONS(3628),
    [anon_sym_str] = ACTIONS(3628),
    [anon_sym_char] = ACTIONS(3628),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_DOT] = ACTIONS(3947),
    [anon_sym_DASH_EQ] = ACTIONS(3941),
    [anon_sym_DASH_GT] = ACTIONS(3617),
    [anon_sym_COLON_COLON] = ACTIONS(3617),
    [anon_sym_BANG] = ACTIONS(3628),
    [anon_sym_BANG_EQ] = ACTIONS(3941),
    [anon_sym_AT] = ACTIONS(3617),
    [anon_sym_STAR_EQ] = ACTIONS(3941),
    [anon_sym_SLASH] = ACTIONS(3947),
    [anon_sym_SLASH_EQ] = ACTIONS(3941),
    [anon_sym_AMP_AMP] = ACTIONS(3941),
    [anon_sym_AMP_EQ] = ACTIONS(3941),
    [anon_sym_POUND] = ACTIONS(3617),
    [anon_sym_PERCENT] = ACTIONS(3947),
    [anon_sym_PERCENT_EQ] = ACTIONS(3941),
    [anon_sym_CARET] = ACTIONS(3947),
    [anon_sym_CARET_EQ] = ACTIONS(3941),
    [anon_sym_PLUS_EQ] = ACTIONS(3941),
    [anon_sym_LT] = ACTIONS(3947),
    [anon_sym_LT_LT] = ACTIONS(3947),
    [anon_sym_LT_LT_EQ] = ACTIONS(3941),
    [anon_sym_LT_EQ] = ACTIONS(3941),
    [anon_sym_EQ] = ACTIONS(3947),
    [anon_sym_EQ_EQ] = ACTIONS(3941),
    [anon_sym_GT] = ACTIONS(3947),
    [anon_sym_GT_EQ] = ACTIONS(3941),
    [anon_sym_GT_GT] = ACTIONS(3947),
    [anon_sym_GT_GT_EQ] = ACTIONS(3941),
    [anon_sym_PIPE] = ACTIONS(3947),
    [anon_sym_PIPE_EQ] = ACTIONS(3941),
    [anon_sym_PIPE_PIPE] = ACTIONS(3941),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_SQUOTE] = ACTIONS(3628),
    [anon_sym_DOT_DOT] = ACTIONS(3947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3947),
    [anon_sym_break] = ACTIONS(3628),
    [anon_sym_const] = ACTIONS(3628),
    [anon_sym_continue] = ACTIONS(3628),
    [anon_sym_default] = ACTIONS(3628),
    [anon_sym_enum] = ACTIONS(3628),
    [anon_sym_fn] = ACTIONS(3628),
    [anon_sym_for] = ACTIONS(3628),
    [anon_sym_if] = ACTIONS(3628),
    [anon_sym_impl] = ACTIONS(3628),
    [anon_sym_let] = ACTIONS(3628),
    [anon_sym_loop] = ACTIONS(3628),
    [anon_sym_match] = ACTIONS(3628),
    [anon_sym_mod] = ACTIONS(3628),
    [anon_sym_pub] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(3628),
    [anon_sym_static] = ACTIONS(3628),
    [anon_sym_struct] = ACTIONS(3628),
    [anon_sym_trait] = ACTIONS(3628),
    [anon_sym_type] = ACTIONS(3628),
    [anon_sym_union] = ACTIONS(3628),
    [anon_sym_unsafe] = ACTIONS(3628),
    [anon_sym_use] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3628),
    [anon_sym_while] = ACTIONS(3628),
    [sym_mutable_specifier] = ACTIONS(3628),
    [sym_integer_literal] = ACTIONS(3617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3617),
    [sym_char_literal] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3628),
    [anon_sym_false] = ACTIONS(3628),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3628),
    [sym_self] = ACTIONS(3628),
    [sym_super] = ACTIONS(3628),
    [sym_crate] = ACTIONS(3628),
    [sym_metavariable] = ACTIONS(3617),
  },
  [1866] = {
    [sym_token_tree] = STATE(1890),
    [sym_token_repetition] = STATE(1890),
    [sym__literal] = STATE(1890),
    [sym_string_literal] = STATE(1890),
    [sym_boolean_literal] = STATE(1890),
    [aux_sym_token_tree_repeat1] = STATE(1890),
    [sym_raw_string_literal] = ACTIONS(4197),
    [sym_float_literal] = ACTIONS(4197),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4197),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_LBRACE] = ACTIONS(3966),
    [anon_sym_EQ_GT] = ACTIONS(4197),
    [anon_sym_LBRACK] = ACTIONS(3968),
    [anon_sym_RBRACK] = ACTIONS(5472),
    [anon_sym_COLON] = ACTIONS(4199),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(4199),
    [anon_sym_STAR] = ACTIONS(4199),
    [anon_sym_COMMA] = ACTIONS(4197),
    [anon_sym_u8] = ACTIONS(3972),
    [anon_sym_i8] = ACTIONS(3972),
    [anon_sym_u16] = ACTIONS(3972),
    [anon_sym_i16] = ACTIONS(3972),
    [anon_sym_u32] = ACTIONS(3972),
    [anon_sym_i32] = ACTIONS(3972),
    [anon_sym_u64] = ACTIONS(3972),
    [anon_sym_i64] = ACTIONS(3972),
    [anon_sym_u128] = ACTIONS(3972),
    [anon_sym_i128] = ACTIONS(3972),
    [anon_sym_isize] = ACTIONS(3972),
    [anon_sym_usize] = ACTIONS(3972),
    [anon_sym_f32] = ACTIONS(3972),
    [anon_sym_f64] = ACTIONS(3972),
    [anon_sym_bool] = ACTIONS(3972),
    [anon_sym_str] = ACTIONS(3972),
    [anon_sym_char] = ACTIONS(3972),
    [anon_sym__] = ACTIONS(4199),
    [anon_sym_AMP] = ACTIONS(4199),
    [anon_sym_DASH] = ACTIONS(4199),
    [anon_sym_DOT] = ACTIONS(4199),
    [anon_sym_DASH_EQ] = ACTIONS(4197),
    [anon_sym_DASH_GT] = ACTIONS(4197),
    [anon_sym_COLON_COLON] = ACTIONS(4197),
    [anon_sym_BANG] = ACTIONS(4199),
    [anon_sym_BANG_EQ] = ACTIONS(4197),
    [anon_sym_AT] = ACTIONS(4197),
    [anon_sym_STAR_EQ] = ACTIONS(4197),
    [anon_sym_SLASH] = ACTIONS(4199),
    [anon_sym_SLASH_EQ] = ACTIONS(4197),
    [anon_sym_AMP_AMP] = ACTIONS(4197),
    [anon_sym_AMP_EQ] = ACTIONS(4197),
    [anon_sym_POUND] = ACTIONS(4197),
    [anon_sym_PERCENT] = ACTIONS(4199),
    [anon_sym_PERCENT_EQ] = ACTIONS(4197),
    [anon_sym_CARET] = ACTIONS(4199),
    [anon_sym_CARET_EQ] = ACTIONS(4197),
    [anon_sym_PLUS_EQ] = ACTIONS(4197),
    [anon_sym_LT] = ACTIONS(4199),
    [anon_sym_LT_LT] = ACTIONS(4199),
    [anon_sym_LT_LT_EQ] = ACTIONS(4197),
    [anon_sym_LT_EQ] = ACTIONS(4197),
    [anon_sym_EQ] = ACTIONS(4199),
    [anon_sym_EQ_EQ] = ACTIONS(4197),
    [anon_sym_GT] = ACTIONS(4199),
    [anon_sym_GT_EQ] = ACTIONS(4197),
    [anon_sym_GT_GT] = ACTIONS(4199),
    [anon_sym_GT_GT_EQ] = ACTIONS(4197),
    [anon_sym_PIPE] = ACTIONS(4199),
    [anon_sym_PIPE_EQ] = ACTIONS(4197),
    [anon_sym_PIPE_PIPE] = ACTIONS(4197),
    [anon_sym_TILDE] = ACTIONS(4197),
    [anon_sym_QMARK] = ACTIONS(4197),
    [anon_sym_SQUOTE] = ACTIONS(4199),
    [anon_sym_DOT_DOT] = ACTIONS(4199),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4197),
    [anon_sym_as] = ACTIONS(4199),
    [anon_sym_break] = ACTIONS(4199),
    [anon_sym_const] = ACTIONS(4199),
    [anon_sym_continue] = ACTIONS(4199),
    [anon_sym_default] = ACTIONS(4199),
    [anon_sym_enum] = ACTIONS(4199),
    [anon_sym_fn] = ACTIONS(4199),
    [anon_sym_for] = ACTIONS(4199),
    [anon_sym_if] = ACTIONS(4199),
    [anon_sym_impl] = ACTIONS(4199),
    [anon_sym_let] = ACTIONS(4199),
    [anon_sym_loop] = ACTIONS(4199),
    [anon_sym_match] = ACTIONS(4199),
    [anon_sym_mod] = ACTIONS(4199),
    [anon_sym_pub] = ACTIONS(4199),
    [anon_sym_return] = ACTIONS(4199),
    [anon_sym_static] = ACTIONS(4199),
    [anon_sym_struct] = ACTIONS(4199),
    [anon_sym_trait] = ACTIONS(4199),
    [anon_sym_type] = ACTIONS(4199),
    [anon_sym_union] = ACTIONS(4199),
    [anon_sym_unsafe] = ACTIONS(4199),
    [anon_sym_use] = ACTIONS(4199),
    [anon_sym_where] = ACTIONS(4199),
    [anon_sym_while] = ACTIONS(4199),
    [sym_mutable_specifier] = ACTIONS(4199),
    [sym_integer_literal] = ACTIONS(4197),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(4197),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4199),
    [sym_self] = ACTIONS(4199),
    [sym_super] = ACTIONS(4199),
    [sym_crate] = ACTIONS(4199),
    [sym_metavariable] = ACTIONS(4197),
  },
  [1867] = {
    [sym_token_tree] = STATE(2485),
    [sym_token_repetition] = STATE(2485),
    [sym__literal] = STATE(2485),
    [sym_string_literal] = STATE(2485),
    [sym_boolean_literal] = STATE(2485),
    [aux_sym_token_tree_repeat1] = STATE(2485),
    [sym_raw_string_literal] = ACTIONS(5546),
    [sym_float_literal] = ACTIONS(5546),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5546),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_RPAREN] = ACTIONS(5548),
    [anon_sym_LBRACE] = ACTIONS(3966),
    [anon_sym_EQ_GT] = ACTIONS(5546),
    [anon_sym_LBRACK] = ACTIONS(3968),
    [anon_sym_COLON] = ACTIONS(5550),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(5550),
    [anon_sym_STAR] = ACTIONS(5550),
    [anon_sym_COMMA] = ACTIONS(5546),
    [anon_sym_u8] = ACTIONS(3972),
    [anon_sym_i8] = ACTIONS(3972),
    [anon_sym_u16] = ACTIONS(3972),
    [anon_sym_i16] = ACTIONS(3972),
    [anon_sym_u32] = ACTIONS(3972),
    [anon_sym_i32] = ACTIONS(3972),
    [anon_sym_u64] = ACTIONS(3972),
    [anon_sym_i64] = ACTIONS(3972),
    [anon_sym_u128] = ACTIONS(3972),
    [anon_sym_i128] = ACTIONS(3972),
    [anon_sym_isize] = ACTIONS(3972),
    [anon_sym_usize] = ACTIONS(3972),
    [anon_sym_f32] = ACTIONS(3972),
    [anon_sym_f64] = ACTIONS(3972),
    [anon_sym_bool] = ACTIONS(3972),
    [anon_sym_str] = ACTIONS(3972),
    [anon_sym_char] = ACTIONS(3972),
    [anon_sym__] = ACTIONS(5550),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym_DASH] = ACTIONS(5550),
    [anon_sym_DOT] = ACTIONS(5550),
    [anon_sym_DASH_EQ] = ACTIONS(5546),
    [anon_sym_DASH_GT] = ACTIONS(5546),
    [anon_sym_COLON_COLON] = ACTIONS(5546),
    [anon_sym_BANG] = ACTIONS(5550),
    [anon_sym_BANG_EQ] = ACTIONS(5546),
    [anon_sym_AT] = ACTIONS(5546),
    [anon_sym_STAR_EQ] = ACTIONS(5546),
    [anon_sym_SLASH] = ACTIONS(5550),
    [anon_sym_SLASH_EQ] = ACTIONS(5546),
    [anon_sym_AMP_AMP] = ACTIONS(5546),
    [anon_sym_AMP_EQ] = ACTIONS(5546),
    [anon_sym_POUND] = ACTIONS(5546),
    [anon_sym_PERCENT] = ACTIONS(5550),
    [anon_sym_PERCENT_EQ] = ACTIONS(5546),
    [anon_sym_CARET] = ACTIONS(5550),
    [anon_sym_CARET_EQ] = ACTIONS(5546),
    [anon_sym_PLUS_EQ] = ACTIONS(5546),
    [anon_sym_LT] = ACTIONS(5550),
    [anon_sym_LT_LT] = ACTIONS(5550),
    [anon_sym_LT_LT_EQ] = ACTIONS(5546),
    [anon_sym_LT_EQ] = ACTIONS(5546),
    [anon_sym_EQ] = ACTIONS(5550),
    [anon_sym_EQ_EQ] = ACTIONS(5546),
    [anon_sym_GT] = ACTIONS(5550),
    [anon_sym_GT_EQ] = ACTIONS(5546),
    [anon_sym_GT_GT] = ACTIONS(5550),
    [anon_sym_GT_GT_EQ] = ACTIONS(5546),
    [anon_sym_PIPE] = ACTIONS(5550),
    [anon_sym_PIPE_EQ] = ACTIONS(5546),
    [anon_sym_PIPE_PIPE] = ACTIONS(5546),
    [anon_sym_TILDE] = ACTIONS(5546),
    [anon_sym_QMARK] = ACTIONS(5546),
    [anon_sym_SQUOTE] = ACTIONS(5550),
    [anon_sym_DOT_DOT] = ACTIONS(5550),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5546),
    [anon_sym_as] = ACTIONS(5550),
    [anon_sym_break] = ACTIONS(5550),
    [anon_sym_const] = ACTIONS(5550),
    [anon_sym_continue] = ACTIONS(5550),
    [anon_sym_default] = ACTIONS(5550),
    [anon_sym_enum] = ACTIONS(5550),
    [anon_sym_fn] = ACTIONS(5550),
    [anon_sym_for] = ACTIONS(5550),
    [anon_sym_if] = ACTIONS(5550),
    [anon_sym_impl] = ACTIONS(5550),
    [anon_sym_let] = ACTIONS(5550),
    [anon_sym_loop] = ACTIONS(5550),
    [anon_sym_match] = ACTIONS(5550),
    [anon_sym_mod] = ACTIONS(5550),
    [anon_sym_pub] = ACTIONS(5550),
    [anon_sym_return] = ACTIONS(5550),
    [anon_sym_static] = ACTIONS(5550),
    [anon_sym_struct] = ACTIONS(5550),
    [anon_sym_trait] = ACTIONS(5550),
    [anon_sym_type] = ACTIONS(5550),
    [anon_sym_union] = ACTIONS(5550),
    [anon_sym_unsafe] = ACTIONS(5550),
    [anon_sym_use] = ACTIONS(5550),
    [anon_sym_where] = ACTIONS(5550),
    [anon_sym_while] = ACTIONS(5550),
    [sym_mutable_specifier] = ACTIONS(5550),
    [sym_integer_literal] = ACTIONS(5546),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(5546),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5550),
    [sym_self] = ACTIONS(5550),
    [sym_super] = ACTIONS(5550),
    [sym_crate] = ACTIONS(5550),
    [sym_metavariable] = ACTIONS(5546),
  },
  [1868] = {
    [sym_raw_string_literal] = ACTIONS(1121),
    [sym_float_literal] = ACTIONS(1121),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1121),
    [anon_sym_LPAREN] = ACTIONS(1121),
    [anon_sym_RPAREN] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1121),
    [anon_sym_RBRACE] = ACTIONS(1121),
    [anon_sym_EQ_GT] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_RBRACK] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(1123),
    [anon_sym_DOLLAR] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1121),
    [anon_sym_u8] = ACTIONS(1123),
    [anon_sym_i8] = ACTIONS(1123),
    [anon_sym_u16] = ACTIONS(1123),
    [anon_sym_i16] = ACTIONS(1123),
    [anon_sym_u32] = ACTIONS(1123),
    [anon_sym_i32] = ACTIONS(1123),
    [anon_sym_u64] = ACTIONS(1123),
    [anon_sym_i64] = ACTIONS(1123),
    [anon_sym_u128] = ACTIONS(1123),
    [anon_sym_i128] = ACTIONS(1123),
    [anon_sym_isize] = ACTIONS(1123),
    [anon_sym_usize] = ACTIONS(1123),
    [anon_sym_f32] = ACTIONS(1123),
    [anon_sym_f64] = ACTIONS(1123),
    [anon_sym_bool] = ACTIONS(1123),
    [anon_sym_str] = ACTIONS(1123),
    [anon_sym_char] = ACTIONS(1123),
    [anon_sym__] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_DASH_EQ] = ACTIONS(1121),
    [anon_sym_DASH_GT] = ACTIONS(1121),
    [anon_sym_COLON_COLON] = ACTIONS(1121),
    [anon_sym_BANG] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_AT] = ACTIONS(1121),
    [anon_sym_STAR_EQ] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1123),
    [anon_sym_SLASH_EQ] = ACTIONS(1121),
    [anon_sym_AMP_AMP] = ACTIONS(1121),
    [anon_sym_AMP_EQ] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_PERCENT_EQ] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_CARET_EQ] = ACTIONS(1121),
    [anon_sym_PLUS_EQ] = ACTIONS(1121),
    [anon_sym_LT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_LT_LT_EQ] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1121),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_GT_GT_EQ] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1123),
    [anon_sym_PIPE_EQ] = ACTIONS(1121),
    [anon_sym_PIPE_PIPE] = ACTIONS(1121),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_QMARK] = ACTIONS(1121),
    [anon_sym_SQUOTE] = ACTIONS(1123),
    [anon_sym_DOT_DOT] = ACTIONS(1123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_break] = ACTIONS(1123),
    [anon_sym_const] = ACTIONS(1123),
    [anon_sym_continue] = ACTIONS(1123),
    [anon_sym_default] = ACTIONS(1123),
    [anon_sym_enum] = ACTIONS(1123),
    [anon_sym_fn] = ACTIONS(1123),
    [anon_sym_for] = ACTIONS(1123),
    [anon_sym_if] = ACTIONS(1123),
    [anon_sym_impl] = ACTIONS(1123),
    [anon_sym_let] = ACTIONS(1123),
    [anon_sym_loop] = ACTIONS(1123),
    [anon_sym_match] = ACTIONS(1123),
    [anon_sym_mod] = ACTIONS(1123),
    [anon_sym_pub] = ACTIONS(1123),
    [anon_sym_return] = ACTIONS(1123),
    [anon_sym_static] = ACTIONS(1123),
    [anon_sym_struct] = ACTIONS(1123),
    [anon_sym_trait] = ACTIONS(1123),
    [anon_sym_type] = ACTIONS(1123),
    [anon_sym_union] = ACTIONS(1123),
    [anon_sym_unsafe] = ACTIONS(1123),
    [anon_sym_use] = ACTIONS(1123),
    [anon_sym_where] = ACTIONS(1123),
    [anon_sym_while] = ACTIONS(1123),
    [sym_mutable_specifier] = ACTIONS(1123),
    [sym_integer_literal] = ACTIONS(1121),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(1121),
    [sym_char_literal] = ACTIONS(1121),
    [anon_sym_true] = ACTIONS(1123),
    [anon_sym_false] = ACTIONS(1123),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1123),
    [sym_self] = ACTIONS(1123),
    [sym_super] = ACTIONS(1123),
    [sym_crate] = ACTIONS(1123),
    [sym_metavariable] = ACTIONS(1121),
  },
  [1869] = {
    [aux_sym_string_literal_repeat1] = STATE(575),
    [sym_block_comment] = ACTIONS(7),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_RBRACK_PLUS_SLASH] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(5552),
    [sym_escape_sequence] = ACTIONS(1125),
    [sym_line_comment] = ACTIONS(401),
  },
  [1870] = {
    [sym_raw_string_literal] = ACTIONS(5554),
    [sym_float_literal] = ACTIONS(5554),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(5554),
    [anon_sym_SEMI] = ACTIONS(5554),
    [anon_sym_macro_rules_BANG] = ACTIONS(5554),
    [anon_sym_LPAREN] = ACTIONS(5554),
    [anon_sym_LBRACE] = ACTIONS(5554),
    [anon_sym_RBRACE] = ACTIONS(5554),
    [anon_sym_LBRACK] = ACTIONS(5554),
    [anon_sym_PLUS] = ACTIONS(5556),
    [anon_sym_STAR] = ACTIONS(5556),
    [anon_sym_u8] = ACTIONS(5556),
    [anon_sym_i8] = ACTIONS(5556),
    [anon_sym_u16] = ACTIONS(5556),
    [anon_sym_i16] = ACTIONS(5556),
    [anon_sym_u32] = ACTIONS(5556),
    [anon_sym_i32] = ACTIONS(5556),
    [anon_sym_u64] = ACTIONS(5556),
    [anon_sym_i64] = ACTIONS(5556),
    [anon_sym_u128] = ACTIONS(5556),
    [anon_sym_i128] = ACTIONS(5556),
    [anon_sym_isize] = ACTIONS(5556),
    [anon_sym_usize] = ACTIONS(5556),
    [anon_sym_f32] = ACTIONS(5556),
    [anon_sym_f64] = ACTIONS(5556),
    [anon_sym_bool] = ACTIONS(5556),
    [anon_sym_str] = ACTIONS(5556),
    [anon_sym_char] = ACTIONS(5556),
    [anon_sym_AMP] = ACTIONS(5556),
    [anon_sym_DASH] = ACTIONS(5556),
    [anon_sym_DOT] = ACTIONS(5556),
    [anon_sym_DASH_EQ] = ACTIONS(5554),
    [anon_sym_COLON_COLON] = ACTIONS(5554),
    [anon_sym_BANG] = ACTIONS(5556),
    [anon_sym_BANG_EQ] = ACTIONS(5554),
    [anon_sym_STAR_EQ] = ACTIONS(5554),
    [anon_sym_SLASH] = ACTIONS(5556),
    [anon_sym_SLASH_EQ] = ACTIONS(5554),
    [anon_sym_AMP_AMP] = ACTIONS(5554),
    [anon_sym_AMP_EQ] = ACTIONS(5554),
    [anon_sym_POUND] = ACTIONS(5554),
    [anon_sym_PERCENT] = ACTIONS(5556),
    [anon_sym_PERCENT_EQ] = ACTIONS(5554),
    [anon_sym_CARET] = ACTIONS(5556),
    [anon_sym_CARET_EQ] = ACTIONS(5554),
    [anon_sym_PLUS_EQ] = ACTIONS(5554),
    [anon_sym_LT] = ACTIONS(5556),
    [anon_sym_LT_LT] = ACTIONS(5556),
    [anon_sym_LT_LT_EQ] = ACTIONS(5554),
    [anon_sym_LT_EQ] = ACTIONS(5554),
    [anon_sym_EQ] = ACTIONS(5556),
    [anon_sym_EQ_EQ] = ACTIONS(5554),
    [anon_sym_GT] = ACTIONS(5556),
    [anon_sym_GT_EQ] = ACTIONS(5554),
    [anon_sym_GT_GT] = ACTIONS(5556),
    [anon_sym_GT_GT_EQ] = ACTIONS(5554),
    [anon_sym_PIPE] = ACTIONS(5556),
    [anon_sym_PIPE_EQ] = ACTIONS(5554),
    [anon_sym_PIPE_PIPE] = ACTIONS(5554),
    [anon_sym_QMARK] = ACTIONS(5554),
    [anon_sym_SQUOTE] = ACTIONS(5556),
    [anon_sym_DOT_DOT] = ACTIONS(5556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5554),
    [anon_sym_as] = ACTIONS(5556),
    [anon_sym_break] = ACTIONS(5556),
    [anon_sym_const] = ACTIONS(5556),
    [anon_sym_continue] = ACTIONS(5556),
    [anon_sym_default] = ACTIONS(5556),
    [anon_sym_enum] = ACTIONS(5556),
    [anon_sym_fn] = ACTIONS(5556),
    [anon_sym_for] = ACTIONS(5556),
    [anon_sym_if] = ACTIONS(5556),
    [anon_sym_impl] = ACTIONS(5556),
    [anon_sym_let] = ACTIONS(5556),
    [anon_sym_loop] = ACTIONS(5556),
    [anon_sym_match] = ACTIONS(5556),
    [anon_sym_mod] = ACTIONS(5556),
    [anon_sym_pub] = ACTIONS(5556),
    [anon_sym_return] = ACTIONS(5556),
    [anon_sym_static] = ACTIONS(5556),
    [anon_sym_struct] = ACTIONS(5556),
    [anon_sym_trait] = ACTIONS(5556),
    [anon_sym_type] = ACTIONS(5556),
    [anon_sym_union] = ACTIONS(5556),
    [anon_sym_unsafe] = ACTIONS(5556),
    [anon_sym_use] = ACTIONS(5556),
    [anon_sym_while] = ACTIONS(5556),
    [anon_sym_extern] = ACTIONS(5556),
    [anon_sym_move] = ACTIONS(5556),
    [sym_integer_literal] = ACTIONS(5554),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5554),
    [sym_char_literal] = ACTIONS(5554),
    [anon_sym_true] = ACTIONS(5556),
    [anon_sym_false] = ACTIONS(5556),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5556),
    [sym_self] = ACTIONS(5556),
    [sym_super] = ACTIONS(5556),
    [sym_crate] = ACTIONS(5556),
    [sym_metavariable] = ACTIONS(5554),
  },
  [1871] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1972),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1972),
    [sym_unary_expression] = STATE(1972),
    [sym_try_expression] = STATE(1972),
    [sym_reference_expression] = STATE(1972),
    [sym_binary_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1972),
    [sym_call_expression] = STATE(1972),
    [sym_array_expression] = STATE(1972),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_tuple_expression] = STATE(1972),
    [sym_unit_expression] = STATE(1972),
    [sym_struct_expression] = STATE(1972),
    [sym_if_expression] = STATE(1972),
    [sym_if_let_expression] = STATE(1972),
    [sym_match_expression] = STATE(1972),
    [sym_while_expression] = STATE(1972),
    [sym_while_let_expression] = STATE(1972),
    [sym_loop_expression] = STATE(1972),
    [sym_for_expression] = STATE(1972),
    [sym_closure_expression] = STATE(1972),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1972),
    [sym_continue_expression] = STATE(1972),
    [sym_index_expression] = STATE(1972),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1972),
    [sym_block] = STATE(1972),
    [sym__literal] = STATE(1972),
    [sym_string_literal] = STATE(1972),
    [sym_boolean_literal] = STATE(1972),
    [sym_raw_string_literal] = ACTIONS(4375),
    [sym_float_literal] = ACTIONS(4375),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(5558),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(4375),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4375),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1872] = {
    [aux_sym_token_tree_repeat2] = STATE(1974),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(5558),
    [anon_sym_COMMA] = ACTIONS(5560),
    [sym_line_comment] = ACTIONS(7),
  },
  [1873] = {
    [sym_token_tree] = STATE(1842),
    [sym_token_repetition] = STATE(1842),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2490),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2490),
    [sym_macro_invocation] = STATE(2490),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2490),
    [sym_unary_expression] = STATE(2490),
    [sym_try_expression] = STATE(2490),
    [sym_reference_expression] = STATE(2490),
    [sym_binary_expression] = STATE(2490),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2490),
    [sym_call_expression] = STATE(2490),
    [sym_array_expression] = STATE(2490),
    [sym_parenthesized_expression] = STATE(2490),
    [sym_tuple_expression] = STATE(2490),
    [sym_unit_expression] = STATE(2490),
    [sym_struct_expression] = STATE(2490),
    [sym_if_expression] = STATE(2490),
    [sym_if_let_expression] = STATE(2490),
    [sym_match_expression] = STATE(2490),
    [sym_while_expression] = STATE(2490),
    [sym_while_let_expression] = STATE(2490),
    [sym_loop_expression] = STATE(2490),
    [sym_for_expression] = STATE(2490),
    [sym_closure_expression] = STATE(2490),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2490),
    [sym_continue_expression] = STATE(2490),
    [sym_index_expression] = STATE(2490),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2490),
    [sym_block] = STATE(2490),
    [sym__literal] = STATE(1178),
    [sym_string_literal] = STATE(1178),
    [sym_boolean_literal] = STATE(1178),
    [aux_sym_token_tree_repeat1] = STATE(1842),
    [sym_raw_string_literal] = ACTIONS(2275),
    [sym_float_literal] = ACTIONS(2275),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3554),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_RPAREN] = ACTIONS(5562),
    [anon_sym_LBRACE] = ACTIONS(2283),
    [anon_sym_EQ_GT] = ACTIONS(3554),
    [anon_sym_LBRACK] = ACTIONS(2285),
    [anon_sym_COLON] = ACTIONS(3558),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(3558),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(3554),
    [anon_sym_u8] = ACTIONS(2293),
    [anon_sym_i8] = ACTIONS(2293),
    [anon_sym_u16] = ACTIONS(2293),
    [anon_sym_i16] = ACTIONS(2293),
    [anon_sym_u32] = ACTIONS(2293),
    [anon_sym_i32] = ACTIONS(2293),
    [anon_sym_u64] = ACTIONS(2293),
    [anon_sym_i64] = ACTIONS(2293),
    [anon_sym_u128] = ACTIONS(2293),
    [anon_sym_i128] = ACTIONS(2293),
    [anon_sym_isize] = ACTIONS(2293),
    [anon_sym_usize] = ACTIONS(2293),
    [anon_sym_f32] = ACTIONS(2293),
    [anon_sym_f64] = ACTIONS(2293),
    [anon_sym_bool] = ACTIONS(2293),
    [anon_sym_str] = ACTIONS(2293),
    [anon_sym_char] = ACTIONS(2293),
    [anon_sym__] = ACTIONS(3558),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_DASH] = ACTIONS(2291),
    [anon_sym_DOT] = ACTIONS(3558),
    [anon_sym_DASH_EQ] = ACTIONS(3554),
    [anon_sym_DASH_GT] = ACTIONS(3554),
    [anon_sym_COLON_COLON] = ACTIONS(3554),
    [anon_sym_BANG] = ACTIONS(2297),
    [anon_sym_BANG_EQ] = ACTIONS(3554),
    [anon_sym_AT] = ACTIONS(3554),
    [anon_sym_STAR_EQ] = ACTIONS(3554),
    [anon_sym_SLASH] = ACTIONS(3558),
    [anon_sym_SLASH_EQ] = ACTIONS(3554),
    [anon_sym_AMP_AMP] = ACTIONS(3554),
    [anon_sym_AMP_EQ] = ACTIONS(3554),
    [anon_sym_POUND] = ACTIONS(3554),
    [anon_sym_PERCENT] = ACTIONS(3558),
    [anon_sym_PERCENT_EQ] = ACTIONS(3554),
    [anon_sym_CARET] = ACTIONS(3558),
    [anon_sym_CARET_EQ] = ACTIONS(3554),
    [anon_sym_PLUS_EQ] = ACTIONS(3554),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_LT_LT] = ACTIONS(3558),
    [anon_sym_LT_LT_EQ] = ACTIONS(3554),
    [anon_sym_LT_EQ] = ACTIONS(3554),
    [anon_sym_EQ] = ACTIONS(3558),
    [anon_sym_EQ_EQ] = ACTIONS(3554),
    [anon_sym_GT] = ACTIONS(3558),
    [anon_sym_GT_EQ] = ACTIONS(3554),
    [anon_sym_GT_GT] = ACTIONS(3558),
    [anon_sym_GT_GT_EQ] = ACTIONS(3554),
    [anon_sym_PIPE] = ACTIONS(2301),
    [anon_sym_PIPE_EQ] = ACTIONS(3554),
    [anon_sym_PIPE_PIPE] = ACTIONS(3554),
    [anon_sym_TILDE] = ACTIONS(3554),
    [anon_sym_QMARK] = ACTIONS(3554),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(2305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3554),
    [anon_sym_as] = ACTIONS(3558),
    [anon_sym_break] = ACTIONS(2307),
    [anon_sym_const] = ACTIONS(3558),
    [anon_sym_continue] = ACTIONS(2309),
    [anon_sym_default] = ACTIONS(2311),
    [anon_sym_enum] = ACTIONS(3558),
    [anon_sym_fn] = ACTIONS(3558),
    [anon_sym_for] = ACTIONS(2313),
    [anon_sym_if] = ACTIONS(2315),
    [anon_sym_impl] = ACTIONS(3558),
    [anon_sym_let] = ACTIONS(3558),
    [anon_sym_loop] = ACTIONS(2317),
    [anon_sym_match] = ACTIONS(2319),
    [anon_sym_mod] = ACTIONS(3558),
    [anon_sym_pub] = ACTIONS(3558),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_static] = ACTIONS(3558),
    [anon_sym_struct] = ACTIONS(3558),
    [anon_sym_trait] = ACTIONS(3558),
    [anon_sym_type] = ACTIONS(3558),
    [anon_sym_union] = ACTIONS(2311),
    [anon_sym_unsafe] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(3558),
    [anon_sym_where] = ACTIONS(3558),
    [anon_sym_while] = ACTIONS(2325),
    [sym_mutable_specifier] = ACTIONS(3558),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(2275),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(2275),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2331),
    [sym_self] = ACTIONS(2333),
    [sym_super] = ACTIONS(3558),
    [sym_crate] = ACTIONS(3558),
    [sym_metavariable] = ACTIONS(2335),
  },
  [1874] = {
    [sym_raw_string_literal] = ACTIONS(5564),
    [sym_float_literal] = ACTIONS(5564),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5564),
    [anon_sym_macro_rules_BANG] = ACTIONS(5564),
    [anon_sym_LPAREN] = ACTIONS(5564),
    [anon_sym_LBRACE] = ACTIONS(5564),
    [anon_sym_RBRACE] = ACTIONS(5564),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_PLUS] = ACTIONS(5566),
    [anon_sym_STAR] = ACTIONS(5566),
    [anon_sym_u8] = ACTIONS(5566),
    [anon_sym_i8] = ACTIONS(5566),
    [anon_sym_u16] = ACTIONS(5566),
    [anon_sym_i16] = ACTIONS(5566),
    [anon_sym_u32] = ACTIONS(5566),
    [anon_sym_i32] = ACTIONS(5566),
    [anon_sym_u64] = ACTIONS(5566),
    [anon_sym_i64] = ACTIONS(5566),
    [anon_sym_u128] = ACTIONS(5566),
    [anon_sym_i128] = ACTIONS(5566),
    [anon_sym_isize] = ACTIONS(5566),
    [anon_sym_usize] = ACTIONS(5566),
    [anon_sym_f32] = ACTIONS(5566),
    [anon_sym_f64] = ACTIONS(5566),
    [anon_sym_bool] = ACTIONS(5566),
    [anon_sym_str] = ACTIONS(5566),
    [anon_sym_char] = ACTIONS(5566),
    [anon_sym_AMP] = ACTIONS(5566),
    [anon_sym_DASH] = ACTIONS(5566),
    [anon_sym_DOT] = ACTIONS(5566),
    [anon_sym_DASH_EQ] = ACTIONS(5564),
    [anon_sym_COLON_COLON] = ACTIONS(5564),
    [anon_sym_BANG] = ACTIONS(5566),
    [anon_sym_BANG_EQ] = ACTIONS(5564),
    [anon_sym_STAR_EQ] = ACTIONS(5564),
    [anon_sym_SLASH] = ACTIONS(5566),
    [anon_sym_SLASH_EQ] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_AMP_EQ] = ACTIONS(5564),
    [anon_sym_POUND] = ACTIONS(5564),
    [anon_sym_PERCENT] = ACTIONS(5566),
    [anon_sym_PERCENT_EQ] = ACTIONS(5564),
    [anon_sym_CARET] = ACTIONS(5566),
    [anon_sym_CARET_EQ] = ACTIONS(5564),
    [anon_sym_PLUS_EQ] = ACTIONS(5564),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_LT_LT_EQ] = ACTIONS(5564),
    [anon_sym_LT_EQ] = ACTIONS(5564),
    [anon_sym_EQ] = ACTIONS(5566),
    [anon_sym_EQ_EQ] = ACTIONS(5564),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_EQ] = ACTIONS(5564),
    [anon_sym_GT_GT] = ACTIONS(5566),
    [anon_sym_GT_GT_EQ] = ACTIONS(5564),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_PIPE_EQ] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_QMARK] = ACTIONS(5564),
    [anon_sym_SQUOTE] = ACTIONS(5566),
    [anon_sym_DOT_DOT] = ACTIONS(5566),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5564),
    [anon_sym_as] = ACTIONS(5566),
    [anon_sym_break] = ACTIONS(5566),
    [anon_sym_const] = ACTIONS(5566),
    [anon_sym_continue] = ACTIONS(5566),
    [anon_sym_default] = ACTIONS(5566),
    [anon_sym_enum] = ACTIONS(5566),
    [anon_sym_fn] = ACTIONS(5566),
    [anon_sym_for] = ACTIONS(5566),
    [anon_sym_if] = ACTIONS(5566),
    [anon_sym_impl] = ACTIONS(5566),
    [anon_sym_let] = ACTIONS(5566),
    [anon_sym_loop] = ACTIONS(5566),
    [anon_sym_match] = ACTIONS(5566),
    [anon_sym_mod] = ACTIONS(5566),
    [anon_sym_pub] = ACTIONS(5566),
    [anon_sym_return] = ACTIONS(5566),
    [anon_sym_static] = ACTIONS(5566),
    [anon_sym_struct] = ACTIONS(5566),
    [anon_sym_trait] = ACTIONS(5566),
    [anon_sym_type] = ACTIONS(5566),
    [anon_sym_union] = ACTIONS(5566),
    [anon_sym_unsafe] = ACTIONS(5566),
    [anon_sym_use] = ACTIONS(5566),
    [anon_sym_while] = ACTIONS(5566),
    [anon_sym_extern] = ACTIONS(5566),
    [anon_sym_move] = ACTIONS(5566),
    [sym_integer_literal] = ACTIONS(5564),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5564),
    [sym_char_literal] = ACTIONS(5564),
    [anon_sym_true] = ACTIONS(5566),
    [anon_sym_false] = ACTIONS(5566),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5566),
    [sym_self] = ACTIONS(5566),
    [sym_super] = ACTIONS(5566),
    [sym_crate] = ACTIONS(5566),
    [sym_metavariable] = ACTIONS(5564),
  },
  [1875] = {
    [sym__statement] = STATE(2492),
    [sym_empty_statement] = STATE(2492),
    [sym__expression_statement] = STATE(2492),
    [sym_macro_definition] = STATE(2492),
    [sym_token_tree] = STATE(1846),
    [sym_token_repetition] = STATE(1846),
    [sym_attribute_item] = STATE(2492),
    [sym_inner_attribute_item] = STATE(2492),
    [sym_mod_item] = STATE(2492),
    [sym_foreign_mod_item] = STATE(2492),
    [sym_struct_item] = STATE(2492),
    [sym_union_item] = STATE(2492),
    [sym_enum_item] = STATE(2492),
    [sym_extern_crate_declaration] = STATE(2492),
    [sym_const_item] = STATE(2492),
    [sym_static_item] = STATE(2492),
    [sym_type_item] = STATE(2492),
    [sym_function_item] = STATE(2492),
    [sym_function_signature_item] = STATE(2492),
    [sym_function_modifiers] = STATE(47),
    [sym_impl_item] = STATE(2492),
    [sym_trait_item] = STATE(2492),
    [sym_associated_type] = STATE(2492),
    [sym_let_declaration] = STATE(2492),
    [sym_use_declaration] = STATE(2492),
    [sym_extern_modifier] = STATE(48),
    [sym_visibility_modifier] = STATE(49),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2491),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2491),
    [sym_macro_invocation] = STATE(53),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2491),
    [sym_unary_expression] = STATE(2491),
    [sym_try_expression] = STATE(2491),
    [sym_reference_expression] = STATE(2491),
    [sym_binary_expression] = STATE(2491),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2491),
    [sym_call_expression] = STATE(2491),
    [sym_array_expression] = STATE(2491),
    [sym_parenthesized_expression] = STATE(2491),
    [sym_tuple_expression] = STATE(2491),
    [sym_unit_expression] = STATE(2491),
    [sym_struct_expression] = STATE(2491),
    [sym_if_expression] = STATE(57),
    [sym_if_let_expression] = STATE(57),
    [sym_match_expression] = STATE(57),
    [sym_while_expression] = STATE(57),
    [sym_while_let_expression] = STATE(57),
    [sym_loop_expression] = STATE(57),
    [sym_for_expression] = STATE(57),
    [sym_closure_expression] = STATE(2491),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(59),
    [sym_break_expression] = STATE(2491),
    [sym_continue_expression] = STATE(2491),
    [sym_index_expression] = STATE(2491),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(57),
    [sym_block] = STATE(57),
    [sym__literal] = STATE(1216),
    [sym_string_literal] = STATE(1216),
    [sym_boolean_literal] = STATE(1216),
    [aux_sym_source_file_repeat1] = STATE(2492),
    [aux_sym_token_tree_repeat1] = STATE(1846),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_raw_string_literal] = ACTIONS(2337),
    [sym_float_literal] = ACTIONS(2337),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(2341),
    [anon_sym_LBRACE] = ACTIONS(2343),
    [anon_sym_RBRACE] = ACTIONS(5562),
    [anon_sym_EQ_GT] = ACTIONS(3566),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [anon_sym_COLON] = ACTIONS(3568),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(3568),
    [anon_sym_STAR] = ACTIONS(2351),
    [anon_sym_COMMA] = ACTIONS(3566),
    [anon_sym_u8] = ACTIONS(2353),
    [anon_sym_i8] = ACTIONS(2353),
    [anon_sym_u16] = ACTIONS(2353),
    [anon_sym_i16] = ACTIONS(2353),
    [anon_sym_u32] = ACTIONS(2353),
    [anon_sym_i32] = ACTIONS(2353),
    [anon_sym_u64] = ACTIONS(2353),
    [anon_sym_i64] = ACTIONS(2353),
    [anon_sym_u128] = ACTIONS(2353),
    [anon_sym_i128] = ACTIONS(2353),
    [anon_sym_isize] = ACTIONS(2353),
    [anon_sym_usize] = ACTIONS(2353),
    [anon_sym_f32] = ACTIONS(2353),
    [anon_sym_f64] = ACTIONS(2353),
    [anon_sym_bool] = ACTIONS(2353),
    [anon_sym_str] = ACTIONS(2353),
    [anon_sym_char] = ACTIONS(2353),
    [anon_sym__] = ACTIONS(3568),
    [anon_sym_AMP] = ACTIONS(2355),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_DOT] = ACTIONS(3568),
    [anon_sym_DASH_EQ] = ACTIONS(3566),
    [anon_sym_DASH_GT] = ACTIONS(3566),
    [anon_sym_COLON_COLON] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(2357),
    [anon_sym_BANG_EQ] = ACTIONS(3566),
    [anon_sym_AT] = ACTIONS(3566),
    [anon_sym_STAR_EQ] = ACTIONS(3566),
    [anon_sym_SLASH] = ACTIONS(3568),
    [anon_sym_SLASH_EQ] = ACTIONS(3566),
    [anon_sym_AMP_AMP] = ACTIONS(3566),
    [anon_sym_AMP_EQ] = ACTIONS(3566),
    [anon_sym_POUND] = ACTIONS(2359),
    [anon_sym_PERCENT] = ACTIONS(3568),
    [anon_sym_PERCENT_EQ] = ACTIONS(3566),
    [anon_sym_CARET] = ACTIONS(3568),
    [anon_sym_CARET_EQ] = ACTIONS(3566),
    [anon_sym_PLUS_EQ] = ACTIONS(3566),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_LT_LT] = ACTIONS(3568),
    [anon_sym_LT_LT_EQ] = ACTIONS(3566),
    [anon_sym_LT_EQ] = ACTIONS(3566),
    [anon_sym_EQ] = ACTIONS(3568),
    [anon_sym_EQ_EQ] = ACTIONS(3566),
    [anon_sym_GT] = ACTIONS(3568),
    [anon_sym_GT_EQ] = ACTIONS(3566),
    [anon_sym_GT_GT] = ACTIONS(3568),
    [anon_sym_GT_GT_EQ] = ACTIONS(3566),
    [anon_sym_PIPE] = ACTIONS(2301),
    [anon_sym_PIPE_EQ] = ACTIONS(3566),
    [anon_sym_PIPE_PIPE] = ACTIONS(3566),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3566),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(2361),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3566),
    [anon_sym_as] = ACTIONS(3568),
    [anon_sym_break] = ACTIONS(2363),
    [anon_sym_const] = ACTIONS(2365),
    [anon_sym_continue] = ACTIONS(2367),
    [anon_sym_default] = ACTIONS(2369),
    [anon_sym_enum] = ACTIONS(2371),
    [anon_sym_fn] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2375),
    [anon_sym_if] = ACTIONS(2377),
    [anon_sym_impl] = ACTIONS(2379),
    [anon_sym_let] = ACTIONS(2381),
    [anon_sym_loop] = ACTIONS(2383),
    [anon_sym_match] = ACTIONS(2385),
    [anon_sym_mod] = ACTIONS(2387),
    [anon_sym_pub] = ACTIONS(2389),
    [anon_sym_return] = ACTIONS(2391),
    [anon_sym_static] = ACTIONS(2393),
    [anon_sym_struct] = ACTIONS(2395),
    [anon_sym_trait] = ACTIONS(2397),
    [anon_sym_type] = ACTIONS(2399),
    [anon_sym_union] = ACTIONS(2401),
    [anon_sym_unsafe] = ACTIONS(2403),
    [anon_sym_use] = ACTIONS(2405),
    [anon_sym_where] = ACTIONS(3568),
    [anon_sym_while] = ACTIONS(2407),
    [anon_sym_extern] = ACTIONS(85),
    [sym_mutable_specifier] = ACTIONS(3568),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(2337),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(2337),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2409),
    [sym_self] = ACTIONS(2411),
    [sym_super] = ACTIONS(3568),
    [sym_crate] = ACTIONS(3568),
    [sym_metavariable] = ACTIONS(2413),
  },
  [1876] = {
    [sym_token_tree] = STATE(1866),
    [sym_token_repetition] = STATE(1866),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2493),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2493),
    [sym_macro_invocation] = STATE(2493),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2493),
    [sym_unary_expression] = STATE(2493),
    [sym_try_expression] = STATE(2493),
    [sym_reference_expression] = STATE(2493),
    [sym_binary_expression] = STATE(2493),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2493),
    [sym_call_expression] = STATE(2493),
    [sym_array_expression] = STATE(2493),
    [sym_parenthesized_expression] = STATE(2493),
    [sym_tuple_expression] = STATE(2493),
    [sym_unit_expression] = STATE(2493),
    [sym_struct_expression] = STATE(2493),
    [sym_if_expression] = STATE(2493),
    [sym_if_let_expression] = STATE(2493),
    [sym_match_expression] = STATE(2493),
    [sym_while_expression] = STATE(2493),
    [sym_while_let_expression] = STATE(2493),
    [sym_loop_expression] = STATE(2493),
    [sym_for_expression] = STATE(2493),
    [sym_closure_expression] = STATE(2493),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2493),
    [sym_continue_expression] = STATE(2493),
    [sym_index_expression] = STATE(2493),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2493),
    [sym_block] = STATE(2493),
    [sym__literal] = STATE(1178),
    [sym_string_literal] = STATE(1178),
    [sym_boolean_literal] = STATE(1178),
    [aux_sym_token_tree_repeat1] = STATE(1866),
    [sym_raw_string_literal] = ACTIONS(2275),
    [sym_float_literal] = ACTIONS(2275),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3572),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_LBRACE] = ACTIONS(2283),
    [anon_sym_EQ_GT] = ACTIONS(3572),
    [anon_sym_LBRACK] = ACTIONS(2285),
    [anon_sym_RBRACK] = ACTIONS(5562),
    [anon_sym_COLON] = ACTIONS(3582),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(2419),
    [anon_sym_COMMA] = ACTIONS(3572),
    [anon_sym_u8] = ACTIONS(2293),
    [anon_sym_i8] = ACTIONS(2293),
    [anon_sym_u16] = ACTIONS(2293),
    [anon_sym_i16] = ACTIONS(2293),
    [anon_sym_u32] = ACTIONS(2293),
    [anon_sym_i32] = ACTIONS(2293),
    [anon_sym_u64] = ACTIONS(2293),
    [anon_sym_i64] = ACTIONS(2293),
    [anon_sym_u128] = ACTIONS(2293),
    [anon_sym_i128] = ACTIONS(2293),
    [anon_sym_isize] = ACTIONS(2293),
    [anon_sym_usize] = ACTIONS(2293),
    [anon_sym_f32] = ACTIONS(2293),
    [anon_sym_f64] = ACTIONS(2293),
    [anon_sym_bool] = ACTIONS(2293),
    [anon_sym_str] = ACTIONS(2293),
    [anon_sym_char] = ACTIONS(2293),
    [anon_sym__] = ACTIONS(3582),
    [anon_sym_AMP] = ACTIONS(2421),
    [anon_sym_DASH] = ACTIONS(2419),
    [anon_sym_DOT] = ACTIONS(3582),
    [anon_sym_DASH_EQ] = ACTIONS(3572),
    [anon_sym_DASH_GT] = ACTIONS(3572),
    [anon_sym_COLON_COLON] = ACTIONS(3572),
    [anon_sym_BANG] = ACTIONS(2423),
    [anon_sym_BANG_EQ] = ACTIONS(3572),
    [anon_sym_AT] = ACTIONS(3572),
    [anon_sym_STAR_EQ] = ACTIONS(3572),
    [anon_sym_SLASH] = ACTIONS(3582),
    [anon_sym_SLASH_EQ] = ACTIONS(3572),
    [anon_sym_AMP_AMP] = ACTIONS(3572),
    [anon_sym_AMP_EQ] = ACTIONS(3572),
    [anon_sym_POUND] = ACTIONS(3572),
    [anon_sym_PERCENT] = ACTIONS(3582),
    [anon_sym_PERCENT_EQ] = ACTIONS(3572),
    [anon_sym_CARET] = ACTIONS(3582),
    [anon_sym_CARET_EQ] = ACTIONS(3572),
    [anon_sym_PLUS_EQ] = ACTIONS(3572),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_LT_LT] = ACTIONS(3582),
    [anon_sym_LT_LT_EQ] = ACTIONS(3572),
    [anon_sym_LT_EQ] = ACTIONS(3572),
    [anon_sym_EQ] = ACTIONS(3582),
    [anon_sym_EQ_EQ] = ACTIONS(3572),
    [anon_sym_GT] = ACTIONS(3582),
    [anon_sym_GT_EQ] = ACTIONS(3572),
    [anon_sym_GT_GT] = ACTIONS(3582),
    [anon_sym_GT_GT_EQ] = ACTIONS(3572),
    [anon_sym_PIPE] = ACTIONS(2301),
    [anon_sym_PIPE_EQ] = ACTIONS(3572),
    [anon_sym_PIPE_PIPE] = ACTIONS(3572),
    [anon_sym_TILDE] = ACTIONS(3572),
    [anon_sym_QMARK] = ACTIONS(3572),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(2425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3572),
    [anon_sym_as] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(2307),
    [anon_sym_const] = ACTIONS(3582),
    [anon_sym_continue] = ACTIONS(2309),
    [anon_sym_default] = ACTIONS(2311),
    [anon_sym_enum] = ACTIONS(3582),
    [anon_sym_fn] = ACTIONS(3582),
    [anon_sym_for] = ACTIONS(2313),
    [anon_sym_if] = ACTIONS(2427),
    [anon_sym_impl] = ACTIONS(3582),
    [anon_sym_let] = ACTIONS(3582),
    [anon_sym_loop] = ACTIONS(2317),
    [anon_sym_match] = ACTIONS(2319),
    [anon_sym_mod] = ACTIONS(3582),
    [anon_sym_pub] = ACTIONS(3582),
    [anon_sym_return] = ACTIONS(2429),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_struct] = ACTIONS(3582),
    [anon_sym_trait] = ACTIONS(3582),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_union] = ACTIONS(2311),
    [anon_sym_unsafe] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(3582),
    [anon_sym_where] = ACTIONS(3582),
    [anon_sym_while] = ACTIONS(2325),
    [sym_mutable_specifier] = ACTIONS(3582),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(2275),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(2275),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2331),
    [sym_self] = ACTIONS(2333),
    [sym_super] = ACTIONS(3582),
    [sym_crate] = ACTIONS(3582),
    [sym_metavariable] = ACTIONS(2335),
  },
  [1877] = {
    [sym_raw_string_literal] = ACTIONS(3702),
    [sym_float_literal] = ACTIONS(3702),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3702),
    [anon_sym_LPAREN] = ACTIONS(3702),
    [anon_sym_RPAREN] = ACTIONS(3702),
    [anon_sym_LBRACE] = ACTIONS(3702),
    [anon_sym_RBRACE] = ACTIONS(3702),
    [anon_sym_EQ_GT] = ACTIONS(3702),
    [anon_sym_LBRACK] = ACTIONS(3702),
    [anon_sym_RBRACK] = ACTIONS(3702),
    [anon_sym_COLON] = ACTIONS(3707),
    [anon_sym_DOLLAR] = ACTIONS(3707),
    [anon_sym_PLUS] = ACTIONS(3707),
    [anon_sym_STAR] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3702),
    [anon_sym_u8] = ACTIONS(3707),
    [anon_sym_i8] = ACTIONS(3707),
    [anon_sym_u16] = ACTIONS(3707),
    [anon_sym_i16] = ACTIONS(3707),
    [anon_sym_u32] = ACTIONS(3707),
    [anon_sym_i32] = ACTIONS(3707),
    [anon_sym_u64] = ACTIONS(3707),
    [anon_sym_i64] = ACTIONS(3707),
    [anon_sym_u128] = ACTIONS(3707),
    [anon_sym_i128] = ACTIONS(3707),
    [anon_sym_isize] = ACTIONS(3707),
    [anon_sym_usize] = ACTIONS(3707),
    [anon_sym_f32] = ACTIONS(3707),
    [anon_sym_f64] = ACTIONS(3707),
    [anon_sym_bool] = ACTIONS(3707),
    [anon_sym_str] = ACTIONS(3707),
    [anon_sym_char] = ACTIONS(3707),
    [anon_sym__] = ACTIONS(3707),
    [anon_sym_AMP] = ACTIONS(3707),
    [anon_sym_DASH] = ACTIONS(3707),
    [anon_sym_DOT] = ACTIONS(3707),
    [anon_sym_DASH_EQ] = ACTIONS(3702),
    [anon_sym_DASH_GT] = ACTIONS(3702),
    [anon_sym_COLON_COLON] = ACTIONS(3702),
    [anon_sym_BANG] = ACTIONS(3707),
    [anon_sym_BANG_EQ] = ACTIONS(3702),
    [anon_sym_AT] = ACTIONS(3702),
    [anon_sym_STAR_EQ] = ACTIONS(3702),
    [anon_sym_SLASH] = ACTIONS(3707),
    [anon_sym_SLASH_EQ] = ACTIONS(3702),
    [anon_sym_AMP_AMP] = ACTIONS(3702),
    [anon_sym_AMP_EQ] = ACTIONS(3702),
    [anon_sym_POUND] = ACTIONS(3702),
    [anon_sym_PERCENT] = ACTIONS(3707),
    [anon_sym_PERCENT_EQ] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3707),
    [anon_sym_CARET_EQ] = ACTIONS(3702),
    [anon_sym_PLUS_EQ] = ACTIONS(3702),
    [anon_sym_LT] = ACTIONS(3707),
    [anon_sym_LT_LT] = ACTIONS(3707),
    [anon_sym_LT_LT_EQ] = ACTIONS(3702),
    [anon_sym_LT_EQ] = ACTIONS(3702),
    [anon_sym_EQ] = ACTIONS(3707),
    [anon_sym_EQ_EQ] = ACTIONS(3702),
    [anon_sym_GT] = ACTIONS(3707),
    [anon_sym_GT_EQ] = ACTIONS(3702),
    [anon_sym_GT_GT] = ACTIONS(3707),
    [anon_sym_GT_GT_EQ] = ACTIONS(3702),
    [anon_sym_PIPE] = ACTIONS(3707),
    [anon_sym_PIPE_EQ] = ACTIONS(3702),
    [anon_sym_PIPE_PIPE] = ACTIONS(3702),
    [anon_sym_TILDE] = ACTIONS(3702),
    [anon_sym_QMARK] = ACTIONS(3702),
    [anon_sym_SQUOTE] = ACTIONS(3707),
    [anon_sym_DOT_DOT] = ACTIONS(3707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3702),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_break] = ACTIONS(3707),
    [anon_sym_const] = ACTIONS(3707),
    [anon_sym_continue] = ACTIONS(3707),
    [anon_sym_default] = ACTIONS(3707),
    [anon_sym_enum] = ACTIONS(3707),
    [anon_sym_fn] = ACTIONS(3707),
    [anon_sym_for] = ACTIONS(3707),
    [anon_sym_if] = ACTIONS(3707),
    [anon_sym_impl] = ACTIONS(3707),
    [anon_sym_let] = ACTIONS(3707),
    [anon_sym_loop] = ACTIONS(3707),
    [anon_sym_match] = ACTIONS(3707),
    [anon_sym_mod] = ACTIONS(3707),
    [anon_sym_pub] = ACTIONS(3707),
    [anon_sym_return] = ACTIONS(3707),
    [anon_sym_static] = ACTIONS(3707),
    [anon_sym_struct] = ACTIONS(3707),
    [anon_sym_trait] = ACTIONS(3707),
    [anon_sym_type] = ACTIONS(3707),
    [anon_sym_union] = ACTIONS(3707),
    [anon_sym_unsafe] = ACTIONS(3707),
    [anon_sym_use] = ACTIONS(3707),
    [anon_sym_where] = ACTIONS(3707),
    [anon_sym_while] = ACTIONS(3707),
    [sym_mutable_specifier] = ACTIONS(3707),
    [sym_integer_literal] = ACTIONS(3702),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3702),
    [sym_char_literal] = ACTIONS(3702),
    [anon_sym_true] = ACTIONS(3707),
    [anon_sym_false] = ACTIONS(3707),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3707),
    [sym_self] = ACTIONS(3707),
    [sym_super] = ACTIONS(3707),
    [sym_crate] = ACTIONS(3707),
    [sym_metavariable] = ACTIONS(3702),
  },
  [1878] = {
    [sym_token_tree] = STATE(1878),
    [sym_token_repetition] = STATE(1878),
    [sym__literal] = STATE(1878),
    [sym_string_literal] = STATE(1878),
    [sym_boolean_literal] = STATE(1878),
    [aux_sym_token_tree_repeat1] = STATE(1878),
    [sym_raw_string_literal] = ACTIONS(5568),
    [sym_float_literal] = ACTIONS(5568),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5568),
    [anon_sym_LPAREN] = ACTIONS(5571),
    [anon_sym_RPAREN] = ACTIONS(5574),
    [anon_sym_LBRACE] = ACTIONS(5576),
    [anon_sym_EQ_GT] = ACTIONS(5568),
    [anon_sym_LBRACK] = ACTIONS(5579),
    [anon_sym_COLON] = ACTIONS(5582),
    [anon_sym_DOLLAR] = ACTIONS(5585),
    [anon_sym_PLUS] = ACTIONS(5582),
    [anon_sym_STAR] = ACTIONS(5582),
    [anon_sym_COMMA] = ACTIONS(5568),
    [anon_sym_u8] = ACTIONS(5588),
    [anon_sym_i8] = ACTIONS(5588),
    [anon_sym_u16] = ACTIONS(5588),
    [anon_sym_i16] = ACTIONS(5588),
    [anon_sym_u32] = ACTIONS(5588),
    [anon_sym_i32] = ACTIONS(5588),
    [anon_sym_u64] = ACTIONS(5588),
    [anon_sym_i64] = ACTIONS(5588),
    [anon_sym_u128] = ACTIONS(5588),
    [anon_sym_i128] = ACTIONS(5588),
    [anon_sym_isize] = ACTIONS(5588),
    [anon_sym_usize] = ACTIONS(5588),
    [anon_sym_f32] = ACTIONS(5588),
    [anon_sym_f64] = ACTIONS(5588),
    [anon_sym_bool] = ACTIONS(5588),
    [anon_sym_str] = ACTIONS(5588),
    [anon_sym_char] = ACTIONS(5588),
    [anon_sym__] = ACTIONS(5582),
    [anon_sym_AMP] = ACTIONS(5582),
    [anon_sym_DASH] = ACTIONS(5582),
    [anon_sym_DOT] = ACTIONS(5582),
    [anon_sym_DASH_EQ] = ACTIONS(5568),
    [anon_sym_DASH_GT] = ACTIONS(5568),
    [anon_sym_COLON_COLON] = ACTIONS(5568),
    [anon_sym_BANG] = ACTIONS(5582),
    [anon_sym_BANG_EQ] = ACTIONS(5568),
    [anon_sym_AT] = ACTIONS(5568),
    [anon_sym_STAR_EQ] = ACTIONS(5568),
    [anon_sym_SLASH] = ACTIONS(5582),
    [anon_sym_SLASH_EQ] = ACTIONS(5568),
    [anon_sym_AMP_AMP] = ACTIONS(5568),
    [anon_sym_AMP_EQ] = ACTIONS(5568),
    [anon_sym_POUND] = ACTIONS(5568),
    [anon_sym_PERCENT] = ACTIONS(5582),
    [anon_sym_PERCENT_EQ] = ACTIONS(5568),
    [anon_sym_CARET] = ACTIONS(5582),
    [anon_sym_CARET_EQ] = ACTIONS(5568),
    [anon_sym_PLUS_EQ] = ACTIONS(5568),
    [anon_sym_LT] = ACTIONS(5582),
    [anon_sym_LT_LT] = ACTIONS(5582),
    [anon_sym_LT_LT_EQ] = ACTIONS(5568),
    [anon_sym_LT_EQ] = ACTIONS(5568),
    [anon_sym_EQ] = ACTIONS(5582),
    [anon_sym_EQ_EQ] = ACTIONS(5568),
    [anon_sym_GT] = ACTIONS(5582),
    [anon_sym_GT_EQ] = ACTIONS(5568),
    [anon_sym_GT_GT] = ACTIONS(5582),
    [anon_sym_GT_GT_EQ] = ACTIONS(5568),
    [anon_sym_PIPE] = ACTIONS(5582),
    [anon_sym_PIPE_EQ] = ACTIONS(5568),
    [anon_sym_PIPE_PIPE] = ACTIONS(5568),
    [anon_sym_TILDE] = ACTIONS(5568),
    [anon_sym_QMARK] = ACTIONS(5568),
    [anon_sym_SQUOTE] = ACTIONS(5582),
    [anon_sym_DOT_DOT] = ACTIONS(5582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5568),
    [anon_sym_as] = ACTIONS(5582),
    [anon_sym_break] = ACTIONS(5582),
    [anon_sym_const] = ACTIONS(5582),
    [anon_sym_continue] = ACTIONS(5582),
    [anon_sym_default] = ACTIONS(5582),
    [anon_sym_enum] = ACTIONS(5582),
    [anon_sym_fn] = ACTIONS(5582),
    [anon_sym_for] = ACTIONS(5582),
    [anon_sym_if] = ACTIONS(5582),
    [anon_sym_impl] = ACTIONS(5582),
    [anon_sym_let] = ACTIONS(5582),
    [anon_sym_loop] = ACTIONS(5582),
    [anon_sym_match] = ACTIONS(5582),
    [anon_sym_mod] = ACTIONS(5582),
    [anon_sym_pub] = ACTIONS(5582),
    [anon_sym_return] = ACTIONS(5582),
    [anon_sym_static] = ACTIONS(5582),
    [anon_sym_struct] = ACTIONS(5582),
    [anon_sym_trait] = ACTIONS(5582),
    [anon_sym_type] = ACTIONS(5582),
    [anon_sym_union] = ACTIONS(5582),
    [anon_sym_unsafe] = ACTIONS(5582),
    [anon_sym_use] = ACTIONS(5582),
    [anon_sym_where] = ACTIONS(5582),
    [anon_sym_while] = ACTIONS(5582),
    [sym_mutable_specifier] = ACTIONS(5582),
    [sym_integer_literal] = ACTIONS(5568),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5591),
    [sym_char_literal] = ACTIONS(5568),
    [anon_sym_true] = ACTIONS(5594),
    [anon_sym_false] = ACTIONS(5594),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5582),
    [sym_self] = ACTIONS(5582),
    [sym_super] = ACTIONS(5582),
    [sym_crate] = ACTIONS(5582),
    [sym_metavariable] = ACTIONS(5568),
  },
  [1879] = {
    [sym_raw_string_literal] = ACTIONS(3560),
    [sym_float_literal] = ACTIONS(3560),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5462),
    [anon_sym_LPAREN] = ACTIONS(5462),
    [anon_sym_LBRACE] = ACTIONS(3560),
    [anon_sym_RBRACE] = ACTIONS(5462),
    [anon_sym_EQ_GT] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(5462),
    [anon_sym_COLON] = ACTIONS(3562),
    [anon_sym_DOLLAR] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(5465),
    [anon_sym_STAR] = ACTIONS(5465),
    [anon_sym_COMMA] = ACTIONS(3560),
    [anon_sym_u8] = ACTIONS(3562),
    [anon_sym_i8] = ACTIONS(3562),
    [anon_sym_u16] = ACTIONS(3562),
    [anon_sym_i16] = ACTIONS(3562),
    [anon_sym_u32] = ACTIONS(3562),
    [anon_sym_i32] = ACTIONS(3562),
    [anon_sym_u64] = ACTIONS(3562),
    [anon_sym_i64] = ACTIONS(3562),
    [anon_sym_u128] = ACTIONS(3562),
    [anon_sym_i128] = ACTIONS(3562),
    [anon_sym_isize] = ACTIONS(3562),
    [anon_sym_usize] = ACTIONS(3562),
    [anon_sym_f32] = ACTIONS(3562),
    [anon_sym_f64] = ACTIONS(3562),
    [anon_sym_bool] = ACTIONS(3562),
    [anon_sym_str] = ACTIONS(3562),
    [anon_sym_char] = ACTIONS(3562),
    [anon_sym__] = ACTIONS(3562),
    [anon_sym_AMP] = ACTIONS(5465),
    [anon_sym_DASH] = ACTIONS(5465),
    [anon_sym_DOT] = ACTIONS(5465),
    [anon_sym_DASH_EQ] = ACTIONS(5462),
    [anon_sym_DASH_GT] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_BANG] = ACTIONS(3562),
    [anon_sym_BANG_EQ] = ACTIONS(5462),
    [anon_sym_AT] = ACTIONS(3560),
    [anon_sym_STAR_EQ] = ACTIONS(5462),
    [anon_sym_SLASH] = ACTIONS(5465),
    [anon_sym_SLASH_EQ] = ACTIONS(5462),
    [anon_sym_AMP_AMP] = ACTIONS(5462),
    [anon_sym_AMP_EQ] = ACTIONS(5462),
    [anon_sym_POUND] = ACTIONS(3560),
    [anon_sym_PERCENT] = ACTIONS(5465),
    [anon_sym_PERCENT_EQ] = ACTIONS(5462),
    [anon_sym_CARET] = ACTIONS(5465),
    [anon_sym_CARET_EQ] = ACTIONS(5462),
    [anon_sym_PLUS_EQ] = ACTIONS(5462),
    [anon_sym_LT] = ACTIONS(5465),
    [anon_sym_LT_LT] = ACTIONS(5465),
    [anon_sym_LT_LT_EQ] = ACTIONS(5462),
    [anon_sym_LT_EQ] = ACTIONS(5462),
    [anon_sym_EQ] = ACTIONS(5465),
    [anon_sym_EQ_EQ] = ACTIONS(5462),
    [anon_sym_GT] = ACTIONS(5465),
    [anon_sym_GT_EQ] = ACTIONS(5462),
    [anon_sym_GT_GT] = ACTIONS(5465),
    [anon_sym_GT_GT_EQ] = ACTIONS(5462),
    [anon_sym_PIPE] = ACTIONS(5465),
    [anon_sym_PIPE_EQ] = ACTIONS(5462),
    [anon_sym_PIPE_PIPE] = ACTIONS(5462),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_QMARK] = ACTIONS(5462),
    [anon_sym_SQUOTE] = ACTIONS(3562),
    [anon_sym_DOT_DOT] = ACTIONS(5465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5462),
    [anon_sym_as] = ACTIONS(5465),
    [anon_sym_break] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_continue] = ACTIONS(3562),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_fn] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_impl] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_loop] = ACTIONS(3562),
    [anon_sym_match] = ACTIONS(3562),
    [anon_sym_mod] = ACTIONS(3562),
    [anon_sym_pub] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_trait] = ACTIONS(3562),
    [anon_sym_type] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [anon_sym_unsafe] = ACTIONS(3562),
    [anon_sym_use] = ACTIONS(3562),
    [anon_sym_where] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [sym_mutable_specifier] = ACTIONS(3562),
    [sym_integer_literal] = ACTIONS(3560),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3560),
    [sym_char_literal] = ACTIONS(3560),
    [anon_sym_true] = ACTIONS(3562),
    [anon_sym_false] = ACTIONS(3562),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3562),
    [sym_self] = ACTIONS(3562),
    [sym_super] = ACTIONS(3562),
    [sym_crate] = ACTIONS(3562),
    [sym_metavariable] = ACTIONS(3560),
  },
  [1880] = {
    [sym_arguments] = STATE(263),
    [aux_sym_token_tree_repeat2] = STATE(2470),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(5597),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(5599),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_BANG_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH] = ACTIONS(563),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(563),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_LT] = ACTIONS(577),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(581),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(577),
    [anon_sym_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(589),
    [anon_sym_as] = ACTIONS(591),
    [sym_line_comment] = ACTIONS(7),
  },
  [1881] = {
    [sym_raw_string_literal] = ACTIONS(5474),
    [sym_float_literal] = ACTIONS(5474),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5474),
    [anon_sym_macro_rules_BANG] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(5474),
    [anon_sym_LBRACE] = ACTIONS(5474),
    [anon_sym_RBRACE] = ACTIONS(5474),
    [anon_sym_EQ_GT] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(5474),
    [anon_sym_COLON] = ACTIONS(3562),
    [anon_sym_DOLLAR] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(5477),
    [anon_sym_STAR] = ACTIONS(5477),
    [anon_sym_COMMA] = ACTIONS(3560),
    [anon_sym_u8] = ACTIONS(5477),
    [anon_sym_i8] = ACTIONS(5477),
    [anon_sym_u16] = ACTIONS(5477),
    [anon_sym_i16] = ACTIONS(5477),
    [anon_sym_u32] = ACTIONS(5477),
    [anon_sym_i32] = ACTIONS(5477),
    [anon_sym_u64] = ACTIONS(5477),
    [anon_sym_i64] = ACTIONS(5477),
    [anon_sym_u128] = ACTIONS(5477),
    [anon_sym_i128] = ACTIONS(5477),
    [anon_sym_isize] = ACTIONS(5477),
    [anon_sym_usize] = ACTIONS(5477),
    [anon_sym_f32] = ACTIONS(5477),
    [anon_sym_f64] = ACTIONS(5477),
    [anon_sym_bool] = ACTIONS(5477),
    [anon_sym_str] = ACTIONS(5477),
    [anon_sym_char] = ACTIONS(5477),
    [anon_sym__] = ACTIONS(3562),
    [anon_sym_AMP] = ACTIONS(5477),
    [anon_sym_DASH] = ACTIONS(5477),
    [anon_sym_DOT] = ACTIONS(5477),
    [anon_sym_DASH_EQ] = ACTIONS(5474),
    [anon_sym_DASH_GT] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(5474),
    [anon_sym_BANG] = ACTIONS(5477),
    [anon_sym_BANG_EQ] = ACTIONS(5474),
    [anon_sym_AT] = ACTIONS(3560),
    [anon_sym_STAR_EQ] = ACTIONS(5474),
    [anon_sym_SLASH] = ACTIONS(5477),
    [anon_sym_SLASH_EQ] = ACTIONS(5474),
    [anon_sym_AMP_AMP] = ACTIONS(5474),
    [anon_sym_AMP_EQ] = ACTIONS(5474),
    [anon_sym_POUND] = ACTIONS(5474),
    [anon_sym_PERCENT] = ACTIONS(5477),
    [anon_sym_PERCENT_EQ] = ACTIONS(5474),
    [anon_sym_CARET] = ACTIONS(5477),
    [anon_sym_CARET_EQ] = ACTIONS(5474),
    [anon_sym_PLUS_EQ] = ACTIONS(5474),
    [anon_sym_LT] = ACTIONS(5477),
    [anon_sym_LT_LT] = ACTIONS(5477),
    [anon_sym_LT_LT_EQ] = ACTIONS(5474),
    [anon_sym_LT_EQ] = ACTIONS(5474),
    [anon_sym_EQ] = ACTIONS(5477),
    [anon_sym_EQ_EQ] = ACTIONS(5474),
    [anon_sym_GT] = ACTIONS(5477),
    [anon_sym_GT_EQ] = ACTIONS(5474),
    [anon_sym_GT_GT] = ACTIONS(5477),
    [anon_sym_GT_GT_EQ] = ACTIONS(5474),
    [anon_sym_PIPE] = ACTIONS(5477),
    [anon_sym_PIPE_EQ] = ACTIONS(5474),
    [anon_sym_PIPE_PIPE] = ACTIONS(5474),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_QMARK] = ACTIONS(5474),
    [anon_sym_SQUOTE] = ACTIONS(5477),
    [anon_sym_DOT_DOT] = ACTIONS(5477),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5474),
    [anon_sym_as] = ACTIONS(5477),
    [anon_sym_break] = ACTIONS(5477),
    [anon_sym_const] = ACTIONS(5477),
    [anon_sym_continue] = ACTIONS(5477),
    [anon_sym_default] = ACTIONS(5477),
    [anon_sym_enum] = ACTIONS(5477),
    [anon_sym_fn] = ACTIONS(5477),
    [anon_sym_for] = ACTIONS(5477),
    [anon_sym_if] = ACTIONS(5477),
    [anon_sym_impl] = ACTIONS(5477),
    [anon_sym_let] = ACTIONS(5477),
    [anon_sym_loop] = ACTIONS(5477),
    [anon_sym_match] = ACTIONS(5477),
    [anon_sym_mod] = ACTIONS(5477),
    [anon_sym_pub] = ACTIONS(5477),
    [anon_sym_return] = ACTIONS(5477),
    [anon_sym_static] = ACTIONS(5477),
    [anon_sym_struct] = ACTIONS(5477),
    [anon_sym_trait] = ACTIONS(5477),
    [anon_sym_type] = ACTIONS(5477),
    [anon_sym_union] = ACTIONS(5477),
    [anon_sym_unsafe] = ACTIONS(5477),
    [anon_sym_use] = ACTIONS(5477),
    [anon_sym_where] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(5477),
    [anon_sym_extern] = ACTIONS(599),
    [sym_mutable_specifier] = ACTIONS(3562),
    [anon_sym_move] = ACTIONS(599),
    [sym_integer_literal] = ACTIONS(5474),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5474),
    [sym_char_literal] = ACTIONS(5474),
    [anon_sym_true] = ACTIONS(5477),
    [anon_sym_false] = ACTIONS(5477),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5477),
    [sym_self] = ACTIONS(5477),
    [sym_super] = ACTIONS(5477),
    [sym_crate] = ACTIONS(5477),
    [sym_metavariable] = ACTIONS(5474),
  },
  [1882] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(5601),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(623),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(623),
    [anon_sym_PLUS_EQ] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(623),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(643),
    [anon_sym_as] = ACTIONS(645),
    [sym_line_comment] = ACTIONS(7),
  },
  [1883] = {
    [sym__statement] = STATE(332),
    [sym_empty_statement] = STATE(332),
    [sym__expression_statement] = STATE(332),
    [sym_macro_definition] = STATE(332),
    [sym_attribute_item] = STATE(332),
    [sym_inner_attribute_item] = STATE(332),
    [sym_mod_item] = STATE(332),
    [sym_foreign_mod_item] = STATE(332),
    [sym_struct_item] = STATE(332),
    [sym_union_item] = STATE(332),
    [sym_enum_item] = STATE(332),
    [sym_extern_crate_declaration] = STATE(332),
    [sym_const_item] = STATE(332),
    [sym_static_item] = STATE(332),
    [sym_type_item] = STATE(332),
    [sym_function_item] = STATE(332),
    [sym_function_signature_item] = STATE(332),
    [sym_function_modifiers] = STATE(47),
    [sym_impl_item] = STATE(332),
    [sym_trait_item] = STATE(332),
    [sym_associated_type] = STATE(332),
    [sym_let_declaration] = STATE(332),
    [sym_use_declaration] = STATE(332),
    [sym_extern_modifier] = STATE(48),
    [sym_visibility_modifier] = STATE(49),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2497),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2497),
    [sym_macro_invocation] = STATE(53),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2497),
    [sym_unary_expression] = STATE(2497),
    [sym_try_expression] = STATE(2497),
    [sym_reference_expression] = STATE(2497),
    [sym_binary_expression] = STATE(2497),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2497),
    [sym_call_expression] = STATE(2497),
    [sym_array_expression] = STATE(2497),
    [sym_parenthesized_expression] = STATE(2497),
    [sym_tuple_expression] = STATE(2497),
    [sym_unit_expression] = STATE(2497),
    [sym_struct_expression] = STATE(2497),
    [sym_if_expression] = STATE(57),
    [sym_if_let_expression] = STATE(57),
    [sym_match_expression] = STATE(57),
    [sym_while_expression] = STATE(57),
    [sym_while_let_expression] = STATE(57),
    [sym_loop_expression] = STATE(57),
    [sym_for_expression] = STATE(57),
    [sym_closure_expression] = STATE(2497),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(59),
    [sym_break_expression] = STATE(2497),
    [sym_continue_expression] = STATE(2497),
    [sym_index_expression] = STATE(2497),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(57),
    [sym_block] = STATE(57),
    [sym__literal] = STATE(2497),
    [sym_string_literal] = STATE(2497),
    [sym_boolean_literal] = STATE(2497),
    [aux_sym_source_file_repeat1] = STATE(332),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_raw_string_literal] = ACTIONS(5603),
    [sym_float_literal] = ACTIONS(5603),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(5601),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_POUND] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(5603),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(5603),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(93),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1884] = {
    [sym_raw_string_literal] = ACTIONS(3560),
    [sym_float_literal] = ACTIONS(3560),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5490),
    [anon_sym_LPAREN] = ACTIONS(5490),
    [anon_sym_LBRACE] = ACTIONS(3560),
    [anon_sym_RBRACE] = ACTIONS(5490),
    [anon_sym_EQ_GT] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(5490),
    [anon_sym_COLON] = ACTIONS(3562),
    [anon_sym_DOLLAR] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(5493),
    [anon_sym_STAR] = ACTIONS(5493),
    [anon_sym_COMMA] = ACTIONS(3560),
    [anon_sym_u8] = ACTIONS(3562),
    [anon_sym_i8] = ACTIONS(3562),
    [anon_sym_u16] = ACTIONS(3562),
    [anon_sym_i16] = ACTIONS(3562),
    [anon_sym_u32] = ACTIONS(3562),
    [anon_sym_i32] = ACTIONS(3562),
    [anon_sym_u64] = ACTIONS(3562),
    [anon_sym_i64] = ACTIONS(3562),
    [anon_sym_u128] = ACTIONS(3562),
    [anon_sym_i128] = ACTIONS(3562),
    [anon_sym_isize] = ACTIONS(3562),
    [anon_sym_usize] = ACTIONS(3562),
    [anon_sym_f32] = ACTIONS(3562),
    [anon_sym_f64] = ACTIONS(3562),
    [anon_sym_bool] = ACTIONS(3562),
    [anon_sym_str] = ACTIONS(3562),
    [anon_sym_char] = ACTIONS(3562),
    [anon_sym__] = ACTIONS(3562),
    [anon_sym_AMP] = ACTIONS(5493),
    [anon_sym_DASH] = ACTIONS(5493),
    [anon_sym_DOT] = ACTIONS(5493),
    [anon_sym_DASH_EQ] = ACTIONS(5490),
    [anon_sym_DASH_GT] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_BANG] = ACTIONS(3562),
    [anon_sym_BANG_EQ] = ACTIONS(5490),
    [anon_sym_AT] = ACTIONS(3560),
    [anon_sym_STAR_EQ] = ACTIONS(5490),
    [anon_sym_SLASH] = ACTIONS(5493),
    [anon_sym_SLASH_EQ] = ACTIONS(5490),
    [anon_sym_AMP_AMP] = ACTIONS(5490),
    [anon_sym_AMP_EQ] = ACTIONS(5490),
    [anon_sym_POUND] = ACTIONS(3560),
    [anon_sym_PERCENT] = ACTIONS(5493),
    [anon_sym_PERCENT_EQ] = ACTIONS(5490),
    [anon_sym_CARET] = ACTIONS(5493),
    [anon_sym_CARET_EQ] = ACTIONS(5490),
    [anon_sym_PLUS_EQ] = ACTIONS(5490),
    [anon_sym_LT] = ACTIONS(5493),
    [anon_sym_LT_LT] = ACTIONS(5493),
    [anon_sym_LT_LT_EQ] = ACTIONS(5490),
    [anon_sym_LT_EQ] = ACTIONS(5490),
    [anon_sym_EQ] = ACTIONS(5493),
    [anon_sym_EQ_EQ] = ACTIONS(5490),
    [anon_sym_GT] = ACTIONS(5493),
    [anon_sym_GT_EQ] = ACTIONS(5490),
    [anon_sym_GT_GT] = ACTIONS(5493),
    [anon_sym_GT_GT_EQ] = ACTIONS(5490),
    [anon_sym_PIPE] = ACTIONS(5493),
    [anon_sym_PIPE_EQ] = ACTIONS(5490),
    [anon_sym_PIPE_PIPE] = ACTIONS(5490),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_QMARK] = ACTIONS(5490),
    [anon_sym_SQUOTE] = ACTIONS(3562),
    [anon_sym_DOT_DOT] = ACTIONS(5493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5490),
    [anon_sym_as] = ACTIONS(5493),
    [anon_sym_break] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_continue] = ACTIONS(3562),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_fn] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_impl] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_loop] = ACTIONS(3562),
    [anon_sym_match] = ACTIONS(3562),
    [anon_sym_mod] = ACTIONS(3562),
    [anon_sym_pub] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_trait] = ACTIONS(3562),
    [anon_sym_type] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [anon_sym_unsafe] = ACTIONS(3562),
    [anon_sym_use] = ACTIONS(3562),
    [anon_sym_where] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [sym_mutable_specifier] = ACTIONS(3562),
    [sym_integer_literal] = ACTIONS(3560),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3560),
    [sym_char_literal] = ACTIONS(3560),
    [anon_sym_true] = ACTIONS(3562),
    [anon_sym_false] = ACTIONS(3562),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3562),
    [sym_self] = ACTIONS(3562),
    [sym_super] = ACTIONS(3562),
    [sym_crate] = ACTIONS(3562),
    [sym_metavariable] = ACTIONS(3560),
  },
  [1885] = {
    [sym_arguments] = STATE(263),
    [aux_sym_token_tree_repeat2] = STATE(2500),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5605),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_COMMA] = ACTIONS(5607),
    [anon_sym_AMP] = ACTIONS(677),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(679),
    [anon_sym_BANG_EQ] = ACTIONS(681),
    [anon_sym_STAR_EQ] = ACTIONS(679),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_SLASH_EQ] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(683),
    [anon_sym_AMP_EQ] = ACTIONS(679),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_PERCENT_EQ] = ACTIONS(679),
    [anon_sym_CARET] = ACTIONS(685),
    [anon_sym_CARET_EQ] = ACTIONS(679),
    [anon_sym_PLUS_EQ] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_LT_LT] = ACTIONS(689),
    [anon_sym_LT_LT_EQ] = ACTIONS(679),
    [anon_sym_LT_EQ] = ACTIONS(681),
    [anon_sym_EQ] = ACTIONS(691),
    [anon_sym_EQ_EQ] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(689),
    [anon_sym_GT_GT_EQ] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(693),
    [anon_sym_PIPE_EQ] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(697),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(699),
    [anon_sym_as] = ACTIONS(701),
    [sym_line_comment] = ACTIONS(7),
  },
  [1886] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(5558),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(623),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(623),
    [anon_sym_PLUS_EQ] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(623),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(643),
    [anon_sym_as] = ACTIONS(645),
    [sym_line_comment] = ACTIONS(7),
  },
  [1887] = {
    [sym_token_tree] = STATE(1887),
    [sym_token_repetition] = STATE(1887),
    [sym__literal] = STATE(1887),
    [sym_string_literal] = STATE(1887),
    [sym_boolean_literal] = STATE(1887),
    [aux_sym_token_tree_repeat1] = STATE(1887),
    [sym_raw_string_literal] = ACTIONS(5609),
    [sym_float_literal] = ACTIONS(5609),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5609),
    [anon_sym_LPAREN] = ACTIONS(5571),
    [anon_sym_LBRACE] = ACTIONS(5576),
    [anon_sym_RBRACE] = ACTIONS(5574),
    [anon_sym_EQ_GT] = ACTIONS(5609),
    [anon_sym_LBRACK] = ACTIONS(5579),
    [anon_sym_COLON] = ACTIONS(5612),
    [anon_sym_DOLLAR] = ACTIONS(5585),
    [anon_sym_PLUS] = ACTIONS(5612),
    [anon_sym_STAR] = ACTIONS(5612),
    [anon_sym_COMMA] = ACTIONS(5609),
    [anon_sym_u8] = ACTIONS(5588),
    [anon_sym_i8] = ACTIONS(5588),
    [anon_sym_u16] = ACTIONS(5588),
    [anon_sym_i16] = ACTIONS(5588),
    [anon_sym_u32] = ACTIONS(5588),
    [anon_sym_i32] = ACTIONS(5588),
    [anon_sym_u64] = ACTIONS(5588),
    [anon_sym_i64] = ACTIONS(5588),
    [anon_sym_u128] = ACTIONS(5588),
    [anon_sym_i128] = ACTIONS(5588),
    [anon_sym_isize] = ACTIONS(5588),
    [anon_sym_usize] = ACTIONS(5588),
    [anon_sym_f32] = ACTIONS(5588),
    [anon_sym_f64] = ACTIONS(5588),
    [anon_sym_bool] = ACTIONS(5588),
    [anon_sym_str] = ACTIONS(5588),
    [anon_sym_char] = ACTIONS(5588),
    [anon_sym__] = ACTIONS(5612),
    [anon_sym_AMP] = ACTIONS(5612),
    [anon_sym_DASH] = ACTIONS(5612),
    [anon_sym_DOT] = ACTIONS(5612),
    [anon_sym_DASH_EQ] = ACTIONS(5609),
    [anon_sym_DASH_GT] = ACTIONS(5609),
    [anon_sym_COLON_COLON] = ACTIONS(5609),
    [anon_sym_BANG] = ACTIONS(5612),
    [anon_sym_BANG_EQ] = ACTIONS(5609),
    [anon_sym_AT] = ACTIONS(5609),
    [anon_sym_STAR_EQ] = ACTIONS(5609),
    [anon_sym_SLASH] = ACTIONS(5612),
    [anon_sym_SLASH_EQ] = ACTIONS(5609),
    [anon_sym_AMP_AMP] = ACTIONS(5609),
    [anon_sym_AMP_EQ] = ACTIONS(5609),
    [anon_sym_POUND] = ACTIONS(5609),
    [anon_sym_PERCENT] = ACTIONS(5612),
    [anon_sym_PERCENT_EQ] = ACTIONS(5609),
    [anon_sym_CARET] = ACTIONS(5612),
    [anon_sym_CARET_EQ] = ACTIONS(5609),
    [anon_sym_PLUS_EQ] = ACTIONS(5609),
    [anon_sym_LT] = ACTIONS(5612),
    [anon_sym_LT_LT] = ACTIONS(5612),
    [anon_sym_LT_LT_EQ] = ACTIONS(5609),
    [anon_sym_LT_EQ] = ACTIONS(5609),
    [anon_sym_EQ] = ACTIONS(5612),
    [anon_sym_EQ_EQ] = ACTIONS(5609),
    [anon_sym_GT] = ACTIONS(5612),
    [anon_sym_GT_EQ] = ACTIONS(5609),
    [anon_sym_GT_GT] = ACTIONS(5612),
    [anon_sym_GT_GT_EQ] = ACTIONS(5609),
    [anon_sym_PIPE] = ACTIONS(5612),
    [anon_sym_PIPE_EQ] = ACTIONS(5609),
    [anon_sym_PIPE_PIPE] = ACTIONS(5609),
    [anon_sym_TILDE] = ACTIONS(5609),
    [anon_sym_QMARK] = ACTIONS(5609),
    [anon_sym_SQUOTE] = ACTIONS(5612),
    [anon_sym_DOT_DOT] = ACTIONS(5612),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5609),
    [anon_sym_as] = ACTIONS(5612),
    [anon_sym_break] = ACTIONS(5612),
    [anon_sym_const] = ACTIONS(5612),
    [anon_sym_continue] = ACTIONS(5612),
    [anon_sym_default] = ACTIONS(5612),
    [anon_sym_enum] = ACTIONS(5612),
    [anon_sym_fn] = ACTIONS(5612),
    [anon_sym_for] = ACTIONS(5612),
    [anon_sym_if] = ACTIONS(5612),
    [anon_sym_impl] = ACTIONS(5612),
    [anon_sym_let] = ACTIONS(5612),
    [anon_sym_loop] = ACTIONS(5612),
    [anon_sym_match] = ACTIONS(5612),
    [anon_sym_mod] = ACTIONS(5612),
    [anon_sym_pub] = ACTIONS(5612),
    [anon_sym_return] = ACTIONS(5612),
    [anon_sym_static] = ACTIONS(5612),
    [anon_sym_struct] = ACTIONS(5612),
    [anon_sym_trait] = ACTIONS(5612),
    [anon_sym_type] = ACTIONS(5612),
    [anon_sym_union] = ACTIONS(5612),
    [anon_sym_unsafe] = ACTIONS(5612),
    [anon_sym_use] = ACTIONS(5612),
    [anon_sym_where] = ACTIONS(5612),
    [anon_sym_while] = ACTIONS(5612),
    [sym_mutable_specifier] = ACTIONS(5612),
    [sym_integer_literal] = ACTIONS(5609),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5591),
    [sym_char_literal] = ACTIONS(5609),
    [anon_sym_true] = ACTIONS(5594),
    [anon_sym_false] = ACTIONS(5594),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5612),
    [sym_self] = ACTIONS(5612),
    [sym_super] = ACTIONS(5612),
    [sym_crate] = ACTIONS(5612),
    [sym_metavariable] = ACTIONS(5609),
  },
  [1888] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(769),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(769),
    [sym_macro_invocation] = STATE(769),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(769),
    [sym_unary_expression] = STATE(769),
    [sym_try_expression] = STATE(769),
    [sym_reference_expression] = STATE(769),
    [sym_binary_expression] = STATE(769),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(769),
    [sym_call_expression] = STATE(769),
    [sym_array_expression] = STATE(769),
    [sym_parenthesized_expression] = STATE(769),
    [sym_tuple_expression] = STATE(769),
    [sym_unit_expression] = STATE(769),
    [sym_struct_expression] = STATE(769),
    [sym_if_expression] = STATE(769),
    [sym_if_let_expression] = STATE(769),
    [sym_match_expression] = STATE(769),
    [sym_while_expression] = STATE(769),
    [sym_while_let_expression] = STATE(769),
    [sym_loop_expression] = STATE(769),
    [sym_for_expression] = STATE(769),
    [sym_closure_expression] = STATE(769),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(769),
    [sym_continue_expression] = STATE(769),
    [sym_index_expression] = STATE(769),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(769),
    [sym_block] = STATE(769),
    [sym__literal] = STATE(769),
    [sym_string_literal] = STATE(769),
    [sym_boolean_literal] = STATE(769),
    [sym_raw_string_literal] = ACTIONS(1620),
    [sym_float_literal] = ACTIONS(1620),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_RBRACK] = ACTIONS(5558),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1620),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1620),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1889] = {
    [aux_sym_token_tree_repeat2] = STATE(789),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACK] = ACTIONS(5558),
    [anon_sym_COMMA] = ACTIONS(5615),
    [sym_line_comment] = ACTIONS(7),
  },
  [1890] = {
    [sym_token_tree] = STATE(1890),
    [sym_token_repetition] = STATE(1890),
    [sym__literal] = STATE(1890),
    [sym_string_literal] = STATE(1890),
    [sym_boolean_literal] = STATE(1890),
    [aux_sym_token_tree_repeat1] = STATE(1890),
    [sym_raw_string_literal] = ACTIONS(5617),
    [sym_float_literal] = ACTIONS(5617),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_LPAREN] = ACTIONS(5571),
    [anon_sym_LBRACE] = ACTIONS(5576),
    [anon_sym_EQ_GT] = ACTIONS(5617),
    [anon_sym_LBRACK] = ACTIONS(5579),
    [anon_sym_RBRACK] = ACTIONS(5574),
    [anon_sym_COLON] = ACTIONS(5620),
    [anon_sym_DOLLAR] = ACTIONS(5585),
    [anon_sym_PLUS] = ACTIONS(5620),
    [anon_sym_STAR] = ACTIONS(5620),
    [anon_sym_COMMA] = ACTIONS(5617),
    [anon_sym_u8] = ACTIONS(5588),
    [anon_sym_i8] = ACTIONS(5588),
    [anon_sym_u16] = ACTIONS(5588),
    [anon_sym_i16] = ACTIONS(5588),
    [anon_sym_u32] = ACTIONS(5588),
    [anon_sym_i32] = ACTIONS(5588),
    [anon_sym_u64] = ACTIONS(5588),
    [anon_sym_i64] = ACTIONS(5588),
    [anon_sym_u128] = ACTIONS(5588),
    [anon_sym_i128] = ACTIONS(5588),
    [anon_sym_isize] = ACTIONS(5588),
    [anon_sym_usize] = ACTIONS(5588),
    [anon_sym_f32] = ACTIONS(5588),
    [anon_sym_f64] = ACTIONS(5588),
    [anon_sym_bool] = ACTIONS(5588),
    [anon_sym_str] = ACTIONS(5588),
    [anon_sym_char] = ACTIONS(5588),
    [anon_sym__] = ACTIONS(5620),
    [anon_sym_AMP] = ACTIONS(5620),
    [anon_sym_DASH] = ACTIONS(5620),
    [anon_sym_DOT] = ACTIONS(5620),
    [anon_sym_DASH_EQ] = ACTIONS(5617),
    [anon_sym_DASH_GT] = ACTIONS(5617),
    [anon_sym_COLON_COLON] = ACTIONS(5617),
    [anon_sym_BANG] = ACTIONS(5620),
    [anon_sym_BANG_EQ] = ACTIONS(5617),
    [anon_sym_AT] = ACTIONS(5617),
    [anon_sym_STAR_EQ] = ACTIONS(5617),
    [anon_sym_SLASH] = ACTIONS(5620),
    [anon_sym_SLASH_EQ] = ACTIONS(5617),
    [anon_sym_AMP_AMP] = ACTIONS(5617),
    [anon_sym_AMP_EQ] = ACTIONS(5617),
    [anon_sym_POUND] = ACTIONS(5617),
    [anon_sym_PERCENT] = ACTIONS(5620),
    [anon_sym_PERCENT_EQ] = ACTIONS(5617),
    [anon_sym_CARET] = ACTIONS(5620),
    [anon_sym_CARET_EQ] = ACTIONS(5617),
    [anon_sym_PLUS_EQ] = ACTIONS(5617),
    [anon_sym_LT] = ACTIONS(5620),
    [anon_sym_LT_LT] = ACTIONS(5620),
    [anon_sym_LT_LT_EQ] = ACTIONS(5617),
    [anon_sym_LT_EQ] = ACTIONS(5617),
    [anon_sym_EQ] = ACTIONS(5620),
    [anon_sym_EQ_EQ] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5620),
    [anon_sym_GT_EQ] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5620),
    [anon_sym_GT_GT_EQ] = ACTIONS(5617),
    [anon_sym_PIPE] = ACTIONS(5620),
    [anon_sym_PIPE_EQ] = ACTIONS(5617),
    [anon_sym_PIPE_PIPE] = ACTIONS(5617),
    [anon_sym_TILDE] = ACTIONS(5617),
    [anon_sym_QMARK] = ACTIONS(5617),
    [anon_sym_SQUOTE] = ACTIONS(5620),
    [anon_sym_DOT_DOT] = ACTIONS(5620),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5617),
    [anon_sym_as] = ACTIONS(5620),
    [anon_sym_break] = ACTIONS(5620),
    [anon_sym_const] = ACTIONS(5620),
    [anon_sym_continue] = ACTIONS(5620),
    [anon_sym_default] = ACTIONS(5620),
    [anon_sym_enum] = ACTIONS(5620),
    [anon_sym_fn] = ACTIONS(5620),
    [anon_sym_for] = ACTIONS(5620),
    [anon_sym_if] = ACTIONS(5620),
    [anon_sym_impl] = ACTIONS(5620),
    [anon_sym_let] = ACTIONS(5620),
    [anon_sym_loop] = ACTIONS(5620),
    [anon_sym_match] = ACTIONS(5620),
    [anon_sym_mod] = ACTIONS(5620),
    [anon_sym_pub] = ACTIONS(5620),
    [anon_sym_return] = ACTIONS(5620),
    [anon_sym_static] = ACTIONS(5620),
    [anon_sym_struct] = ACTIONS(5620),
    [anon_sym_trait] = ACTIONS(5620),
    [anon_sym_type] = ACTIONS(5620),
    [anon_sym_union] = ACTIONS(5620),
    [anon_sym_unsafe] = ACTIONS(5620),
    [anon_sym_use] = ACTIONS(5620),
    [anon_sym_where] = ACTIONS(5620),
    [anon_sym_while] = ACTIONS(5620),
    [sym_mutable_specifier] = ACTIONS(5620),
    [sym_integer_literal] = ACTIONS(5617),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5591),
    [sym_char_literal] = ACTIONS(5617),
    [anon_sym_true] = ACTIONS(5594),
    [anon_sym_false] = ACTIONS(5594),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5620),
    [sym_self] = ACTIONS(5620),
    [sym_super] = ACTIONS(5620),
    [sym_crate] = ACTIONS(5620),
    [sym_metavariable] = ACTIONS(5617),
  },
  [1891] = {
    [sym_where_clause] = STATE(2255),
    [sym_block] = STATE(2243),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4985),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_DASH_GT] = ACTIONS(5623),
    [anon_sym_where] = ACTIONS(1962),
    [sym_line_comment] = ACTIONS(7),
  },
  [1892] = {
    [sym_macro_rule] = STATE(2504),
    [sym_token_tree_pattern] = STATE(690),
    [aux_sym_macro_definition_repeat1] = STATE(2505),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_RPAREN] = ACTIONS(5625),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_LBRACK] = ACTIONS(1485),
    [sym_line_comment] = ACTIONS(7),
  },
  [1893] = {
    [sym_macro_rule] = STATE(2507),
    [sym_token_tree_pattern] = STATE(690),
    [aux_sym_macro_definition_repeat1] = STATE(2508),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_RBRACE] = ACTIONS(5627),
    [anon_sym_LBRACK] = ACTIONS(1485),
    [sym_line_comment] = ACTIONS(7),
  },
  [1894] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACK] = ACTIONS(5629),
    [sym_line_comment] = ACTIONS(7),
  },
  [1895] = {
    [sym_meta_item] = STATE(2510),
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(727),
  },
  [1896] = {
    [sym_function_modifiers] = STATE(929),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2511),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(931),
    [sym_array_type] = STATE(2511),
    [sym_function_type] = STATE(2511),
    [sym_tuple_type] = STATE(2511),
    [sym_unit_type] = STATE(2511),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2511),
    [sym_reference_type] = STATE(2511),
    [sym_pointer_type] = STATE(2511),
    [sym_empty_type] = STATE(2511),
    [sym_dynamic_type] = STATE(2511),
    [sym_macro_invocation] = STATE(2511),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(932),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1928),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1930),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1932),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1934),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1897] = {
    [sym_attribute_item] = STATE(2515),
    [sym_enum_variant] = STATE(2514),
    [sym_visibility_modifier] = STATE(938),
    [aux_sym_enum_variant_list_repeat1] = STATE(2515),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5631),
    [anon_sym_COMMA] = ACTIONS(5633),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_pub] = ACTIONS(1940),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1942),
  },
  [1898] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1952),
    [anon_sym_macro_rules_BANG] = ACTIONS(1952),
    [anon_sym_RBRACE] = ACTIONS(1952),
    [anon_sym_POUND] = ACTIONS(1952),
    [anon_sym_const] = ACTIONS(1954),
    [anon_sym_default] = ACTIONS(1954),
    [anon_sym_enum] = ACTIONS(1954),
    [anon_sym_fn] = ACTIONS(1954),
    [anon_sym_impl] = ACTIONS(1954),
    [anon_sym_let] = ACTIONS(1954),
    [anon_sym_mod] = ACTIONS(1954),
    [anon_sym_pub] = ACTIONS(1954),
    [anon_sym_static] = ACTIONS(1954),
    [anon_sym_struct] = ACTIONS(1954),
    [anon_sym_trait] = ACTIONS(1954),
    [anon_sym_type] = ACTIONS(1954),
    [anon_sym_union] = ACTIONS(1954),
    [anon_sym_unsafe] = ACTIONS(1954),
    [anon_sym_use] = ACTIONS(1954),
    [anon_sym_extern] = ACTIONS(1954),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1954),
  },
  [1899] = {
    [sym_enum_variant_list] = STATE(2516),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(4209),
    [sym_line_comment] = ACTIONS(7),
  },
  [1900] = {
    [sym_enum_variant_list] = STATE(2516),
    [sym_where_clause] = STATE(2517),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(4209),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [1901] = {
    [sym_parameters] = STATE(2518),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [1902] = {
    [sym_where_clause] = STATE(2521),
    [sym_block] = STATE(2522),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5635),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_DASH_GT] = ACTIONS(5637),
    [anon_sym_where] = ACTIONS(1962),
    [sym_line_comment] = ACTIONS(7),
  },
  [1903] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2042),
    [anon_sym_macro_rules_BANG] = ACTIONS(2042),
    [anon_sym_RBRACE] = ACTIONS(2042),
    [anon_sym_POUND] = ACTIONS(2042),
    [anon_sym_const] = ACTIONS(2044),
    [anon_sym_default] = ACTIONS(2044),
    [anon_sym_enum] = ACTIONS(2044),
    [anon_sym_fn] = ACTIONS(2044),
    [anon_sym_impl] = ACTIONS(2044),
    [anon_sym_let] = ACTIONS(2044),
    [anon_sym_mod] = ACTIONS(2044),
    [anon_sym_pub] = ACTIONS(2044),
    [anon_sym_static] = ACTIONS(2044),
    [anon_sym_struct] = ACTIONS(2044),
    [anon_sym_trait] = ACTIONS(2044),
    [anon_sym_type] = ACTIONS(2044),
    [anon_sym_union] = ACTIONS(2044),
    [anon_sym_unsafe] = ACTIONS(2044),
    [anon_sym_use] = ACTIONS(2044),
    [anon_sym_extern] = ACTIONS(2044),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2044),
  },
  [1904] = {
    [sym_declaration_list] = STATE(2523),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [sym_line_comment] = ACTIONS(7),
  },
  [1905] = {
    [sym_declaration_list] = STATE(2523),
    [sym_where_clause] = STATE(2524),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [1906] = {
    [sym_declaration_list] = STATE(2523),
    [sym_where_clause] = STATE(2524),
    [sym_impl_for_clause] = STATE(2525),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [anon_sym_COLON_COLON] = ACTIONS(1798),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [1907] = {
    [sym_declaration_list] = STATE(2526),
    [sym_where_clause] = STATE(2527),
    [sym_impl_for_clause] = STATE(2528),
    [sym_type_arguments] = STATE(2529),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [1908] = {
    [sym_declaration_list] = STATE(2530),
    [sym_where_clause] = STATE(2531),
    [sym_impl_for_clause] = STATE(2532),
    [sym_type_arguments] = STATE(2533),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [1909] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2046),
    [anon_sym_macro_rules_BANG] = ACTIONS(2046),
    [anon_sym_RBRACE] = ACTIONS(2046),
    [anon_sym_POUND] = ACTIONS(2046),
    [anon_sym_const] = ACTIONS(2048),
    [anon_sym_default] = ACTIONS(2048),
    [anon_sym_enum] = ACTIONS(2048),
    [anon_sym_fn] = ACTIONS(2048),
    [anon_sym_impl] = ACTIONS(2048),
    [anon_sym_let] = ACTIONS(2048),
    [anon_sym_mod] = ACTIONS(2048),
    [anon_sym_pub] = ACTIONS(2048),
    [anon_sym_static] = ACTIONS(2048),
    [anon_sym_struct] = ACTIONS(2048),
    [anon_sym_trait] = ACTIONS(2048),
    [anon_sym_type] = ACTIONS(2048),
    [anon_sym_union] = ACTIONS(2048),
    [anon_sym_unsafe] = ACTIONS(2048),
    [anon_sym_use] = ACTIONS(2048),
    [anon_sym_extern] = ACTIONS(2048),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2048),
  },
  [1910] = {
    [sym_declaration_list] = STATE(2530),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [sym_line_comment] = ACTIONS(7),
  },
  [1911] = {
    [sym_declaration_list] = STATE(2530),
    [sym_where_clause] = STATE(2531),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [1912] = {
    [sym_declaration_list] = STATE(2530),
    [sym_where_clause] = STATE(2531),
    [sym_impl_for_clause] = STATE(2532),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [anon_sym_COLON_COLON] = ACTIONS(1816),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [1913] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5639),
    [anon_sym_COLON] = ACTIONS(5641),
    [anon_sym_EQ] = ACTIONS(5643),
    [sym_line_comment] = ACTIONS(7),
  },
  [1914] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2056),
    [anon_sym_macro_rules_BANG] = ACTIONS(2056),
    [anon_sym_RBRACE] = ACTIONS(2056),
    [anon_sym_POUND] = ACTIONS(2056),
    [anon_sym_const] = ACTIONS(2058),
    [anon_sym_default] = ACTIONS(2058),
    [anon_sym_enum] = ACTIONS(2058),
    [anon_sym_fn] = ACTIONS(2058),
    [anon_sym_impl] = ACTIONS(2058),
    [anon_sym_let] = ACTIONS(2058),
    [anon_sym_mod] = ACTIONS(2058),
    [anon_sym_pub] = ACTIONS(2058),
    [anon_sym_static] = ACTIONS(2058),
    [anon_sym_struct] = ACTIONS(2058),
    [anon_sym_trait] = ACTIONS(2058),
    [anon_sym_type] = ACTIONS(2058),
    [anon_sym_union] = ACTIONS(2058),
    [anon_sym_unsafe] = ACTIONS(2058),
    [anon_sym_use] = ACTIONS(2058),
    [anon_sym_extern] = ACTIONS(2058),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2058),
  },
  [1915] = {
    [sym_function_modifiers] = STATE(1025),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2537),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1027),
    [sym_array_type] = STATE(2537),
    [sym_function_type] = STATE(2537),
    [sym_tuple_type] = STATE(2537),
    [sym_unit_type] = STATE(2537),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2537),
    [sym_reference_type] = STATE(2537),
    [sym_pointer_type] = STATE(2537),
    [sym_empty_type] = STATE(2537),
    [sym_dynamic_type] = STATE(2537),
    [sym_macro_invocation] = STATE(2537),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1028),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2060),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2062),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2064),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2066),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1916] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2538),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2538),
    [sym_macro_invocation] = STATE(2538),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2538),
    [sym_unary_expression] = STATE(2538),
    [sym_try_expression] = STATE(2538),
    [sym_reference_expression] = STATE(2538),
    [sym_binary_expression] = STATE(2538),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2538),
    [sym_call_expression] = STATE(2538),
    [sym_array_expression] = STATE(2538),
    [sym_parenthesized_expression] = STATE(2538),
    [sym_tuple_expression] = STATE(2538),
    [sym_unit_expression] = STATE(2538),
    [sym_struct_expression] = STATE(2538),
    [sym_if_expression] = STATE(2538),
    [sym_if_let_expression] = STATE(2538),
    [sym_match_expression] = STATE(2538),
    [sym_while_expression] = STATE(2538),
    [sym_while_let_expression] = STATE(2538),
    [sym_loop_expression] = STATE(2538),
    [sym_for_expression] = STATE(2538),
    [sym_closure_expression] = STATE(2538),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2538),
    [sym_continue_expression] = STATE(2538),
    [sym_index_expression] = STATE(2538),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2538),
    [sym_block] = STATE(2538),
    [sym__literal] = STATE(2538),
    [sym_string_literal] = STATE(2538),
    [sym_boolean_literal] = STATE(2538),
    [sym_raw_string_literal] = ACTIONS(5645),
    [sym_float_literal] = ACTIONS(5645),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(5645),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(5645),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1917] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2100),
    [anon_sym_macro_rules_BANG] = ACTIONS(2100),
    [anon_sym_RBRACE] = ACTIONS(2100),
    [anon_sym_POUND] = ACTIONS(2100),
    [anon_sym_const] = ACTIONS(2102),
    [anon_sym_default] = ACTIONS(2102),
    [anon_sym_enum] = ACTIONS(2102),
    [anon_sym_fn] = ACTIONS(2102),
    [anon_sym_impl] = ACTIONS(2102),
    [anon_sym_let] = ACTIONS(2102),
    [anon_sym_mod] = ACTIONS(2102),
    [anon_sym_pub] = ACTIONS(2102),
    [anon_sym_static] = ACTIONS(2102),
    [anon_sym_struct] = ACTIONS(2102),
    [anon_sym_trait] = ACTIONS(2102),
    [anon_sym_type] = ACTIONS(2102),
    [anon_sym_union] = ACTIONS(2102),
    [anon_sym_unsafe] = ACTIONS(2102),
    [anon_sym_use] = ACTIONS(2102),
    [anon_sym_extern] = ACTIONS(2102),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2102),
  },
  [1918] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(5647),
    [sym_line_comment] = ACTIONS(7),
  },
  [1919] = {
    [sym_function_modifiers] = STATE(1025),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2540),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1027),
    [sym_array_type] = STATE(2540),
    [sym_function_type] = STATE(2540),
    [sym_tuple_type] = STATE(2540),
    [sym_unit_type] = STATE(2540),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2540),
    [sym_reference_type] = STATE(2540),
    [sym_pointer_type] = STATE(2540),
    [sym_empty_type] = STATE(2540),
    [sym_dynamic_type] = STATE(2540),
    [sym_macro_invocation] = STATE(2540),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1028),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2060),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2062),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2064),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2066),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1920] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2116),
    [anon_sym_macro_rules_BANG] = ACTIONS(2116),
    [anon_sym_RBRACE] = ACTIONS(2116),
    [anon_sym_POUND] = ACTIONS(2116),
    [anon_sym_const] = ACTIONS(2118),
    [anon_sym_default] = ACTIONS(2118),
    [anon_sym_enum] = ACTIONS(2118),
    [anon_sym_fn] = ACTIONS(2118),
    [anon_sym_impl] = ACTIONS(2118),
    [anon_sym_let] = ACTIONS(2118),
    [anon_sym_mod] = ACTIONS(2118),
    [anon_sym_pub] = ACTIONS(2118),
    [anon_sym_static] = ACTIONS(2118),
    [anon_sym_struct] = ACTIONS(2118),
    [anon_sym_trait] = ACTIONS(2118),
    [anon_sym_type] = ACTIONS(2118),
    [anon_sym_union] = ACTIONS(2118),
    [anon_sym_unsafe] = ACTIONS(2118),
    [anon_sym_use] = ACTIONS(2118),
    [anon_sym_extern] = ACTIONS(2118),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2118),
  },
  [1921] = {
    [sym_where_clause] = STATE(2542),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5649),
    [anon_sym_where] = ACTIONS(2138),
    [sym_line_comment] = ACTIONS(7),
  },
  [1922] = {
    [sym_field_declaration_list] = STATE(2541),
    [sym_ordered_field_declaration_list] = STATE(2543),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5649),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(3125),
    [sym_line_comment] = ACTIONS(7),
  },
  [1923] = {
    [sym_field_declaration_list] = STATE(2541),
    [sym_ordered_field_declaration_list] = STATE(2543),
    [sym_where_clause] = STATE(2544),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5649),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(3125),
    [anon_sym_where] = ACTIONS(1057),
    [sym_line_comment] = ACTIONS(7),
  },
  [1924] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2148),
    [anon_sym_macro_rules_BANG] = ACTIONS(2148),
    [anon_sym_RBRACE] = ACTIONS(2148),
    [anon_sym_POUND] = ACTIONS(2148),
    [anon_sym_const] = ACTIONS(2150),
    [anon_sym_default] = ACTIONS(2150),
    [anon_sym_enum] = ACTIONS(2150),
    [anon_sym_fn] = ACTIONS(2150),
    [anon_sym_impl] = ACTIONS(2150),
    [anon_sym_let] = ACTIONS(2150),
    [anon_sym_mod] = ACTIONS(2150),
    [anon_sym_pub] = ACTIONS(2150),
    [anon_sym_static] = ACTIONS(2150),
    [anon_sym_struct] = ACTIONS(2150),
    [anon_sym_trait] = ACTIONS(2150),
    [anon_sym_type] = ACTIONS(2150),
    [anon_sym_union] = ACTIONS(2150),
    [anon_sym_unsafe] = ACTIONS(2150),
    [anon_sym_use] = ACTIONS(2150),
    [anon_sym_extern] = ACTIONS(2150),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2150),
  },
  [1925] = {
    [sym_declaration_list] = STATE(2545),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [sym_line_comment] = ACTIONS(7),
  },
  [1926] = {
    [sym_declaration_list] = STATE(2545),
    [sym_trait_bounds] = STATE(2546),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [anon_sym_COLON] = ACTIONS(1059),
    [sym_line_comment] = ACTIONS(7),
  },
  [1927] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2152),
    [anon_sym_macro_rules_BANG] = ACTIONS(2152),
    [anon_sym_RBRACE] = ACTIONS(2152),
    [anon_sym_POUND] = ACTIONS(2152),
    [anon_sym_const] = ACTIONS(2154),
    [anon_sym_default] = ACTIONS(2154),
    [anon_sym_enum] = ACTIONS(2154),
    [anon_sym_fn] = ACTIONS(2154),
    [anon_sym_impl] = ACTIONS(2154),
    [anon_sym_let] = ACTIONS(2154),
    [anon_sym_mod] = ACTIONS(2154),
    [anon_sym_pub] = ACTIONS(2154),
    [anon_sym_static] = ACTIONS(2154),
    [anon_sym_struct] = ACTIONS(2154),
    [anon_sym_trait] = ACTIONS(2154),
    [anon_sym_type] = ACTIONS(2154),
    [anon_sym_union] = ACTIONS(2154),
    [anon_sym_unsafe] = ACTIONS(2154),
    [anon_sym_use] = ACTIONS(2154),
    [anon_sym_extern] = ACTIONS(2154),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2154),
  },
  [1928] = {
    [sym_function_modifiers] = STATE(1097),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2547),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1102),
    [sym_array_type] = STATE(2547),
    [sym_function_type] = STATE(2547),
    [sym_tuple_type] = STATE(2547),
    [sym_unit_type] = STATE(2547),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2547),
    [sym_reference_type] = STATE(2547),
    [sym_pointer_type] = STATE(2547),
    [sym_empty_type] = STATE(2547),
    [sym_dynamic_type] = STATE(2547),
    [sym_macro_invocation] = STATE(2547),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2156),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2162),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2166),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1929] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5651),
    [sym_line_comment] = ACTIONS(7),
  },
  [1930] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(5653),
    [sym_line_comment] = ACTIONS(7),
  },
  [1931] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2172),
    [anon_sym_macro_rules_BANG] = ACTIONS(2172),
    [anon_sym_RBRACE] = ACTIONS(2172),
    [anon_sym_POUND] = ACTIONS(2172),
    [anon_sym_const] = ACTIONS(2174),
    [anon_sym_default] = ACTIONS(2174),
    [anon_sym_enum] = ACTIONS(2174),
    [anon_sym_fn] = ACTIONS(2174),
    [anon_sym_impl] = ACTIONS(2174),
    [anon_sym_let] = ACTIONS(2174),
    [anon_sym_mod] = ACTIONS(2174),
    [anon_sym_pub] = ACTIONS(2174),
    [anon_sym_static] = ACTIONS(2174),
    [anon_sym_struct] = ACTIONS(2174),
    [anon_sym_trait] = ACTIONS(2174),
    [anon_sym_type] = ACTIONS(2174),
    [anon_sym_union] = ACTIONS(2174),
    [anon_sym_unsafe] = ACTIONS(2174),
    [anon_sym_use] = ACTIONS(2174),
    [anon_sym_extern] = ACTIONS(2174),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2174),
  },
  [1932] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5655),
    [sym_line_comment] = ACTIONS(7),
  },
  [1933] = {
    [sym_field_declaration_list] = STATE(2550),
    [sym_ordered_field_declaration_list] = STATE(2551),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5655),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(3125),
    [sym_line_comment] = ACTIONS(7),
  },
  [1934] = {
    [sym_field_declaration_list] = STATE(2550),
    [sym_ordered_field_declaration_list] = STATE(2551),
    [sym_where_clause] = STATE(2552),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5655),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(3125),
    [anon_sym_where] = ACTIONS(1057),
    [sym_line_comment] = ACTIONS(7),
  },
  [1935] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2554),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5657),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [1936] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2206),
    [anon_sym_macro_rules_BANG] = ACTIONS(2206),
    [anon_sym_RBRACE] = ACTIONS(2206),
    [anon_sym_POUND] = ACTIONS(2206),
    [anon_sym_const] = ACTIONS(2208),
    [anon_sym_default] = ACTIONS(2208),
    [anon_sym_enum] = ACTIONS(2208),
    [anon_sym_fn] = ACTIONS(2208),
    [anon_sym_impl] = ACTIONS(2208),
    [anon_sym_let] = ACTIONS(2208),
    [anon_sym_mod] = ACTIONS(2208),
    [anon_sym_pub] = ACTIONS(2208),
    [anon_sym_static] = ACTIONS(2208),
    [anon_sym_struct] = ACTIONS(2208),
    [anon_sym_trait] = ACTIONS(2208),
    [anon_sym_type] = ACTIONS(2208),
    [anon_sym_union] = ACTIONS(2208),
    [anon_sym_unsafe] = ACTIONS(2208),
    [anon_sym_use] = ACTIONS(2208),
    [anon_sym_extern] = ACTIONS(2208),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2208),
  },
  [1937] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5659),
    [anon_sym_as] = ACTIONS(5661),
    [sym_line_comment] = ACTIONS(7),
  },
  [1938] = {
    [sym_type_parameters] = STATE(2557),
    [sym_parameters] = STATE(2518),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(925),
    [sym_line_comment] = ACTIONS(7),
  },
  [1939] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2437),
    [anon_sym_macro_rules_BANG] = ACTIONS(2437),
    [anon_sym_RBRACE] = ACTIONS(2437),
    [anon_sym_POUND] = ACTIONS(2437),
    [anon_sym_const] = ACTIONS(2439),
    [anon_sym_default] = ACTIONS(2439),
    [anon_sym_enum] = ACTIONS(2439),
    [anon_sym_fn] = ACTIONS(2439),
    [anon_sym_impl] = ACTIONS(2439),
    [anon_sym_let] = ACTIONS(2439),
    [anon_sym_mod] = ACTIONS(2439),
    [anon_sym_pub] = ACTIONS(2439),
    [anon_sym_static] = ACTIONS(2439),
    [anon_sym_struct] = ACTIONS(2439),
    [anon_sym_trait] = ACTIONS(2439),
    [anon_sym_type] = ACTIONS(2439),
    [anon_sym_union] = ACTIONS(2439),
    [anon_sym_unsafe] = ACTIONS(2439),
    [anon_sym_use] = ACTIONS(2439),
    [anon_sym_extern] = ACTIONS(2439),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2439),
  },
  [1940] = {
    [sym_empty_statement] = STATE(1265),
    [sym_macro_definition] = STATE(1265),
    [sym_attribute_item] = STATE(1265),
    [sym_inner_attribute_item] = STATE(1265),
    [sym_mod_item] = STATE(1265),
    [sym_foreign_mod_item] = STATE(1265),
    [sym_struct_item] = STATE(1265),
    [sym_union_item] = STATE(1265),
    [sym_enum_item] = STATE(1265),
    [sym_extern_crate_declaration] = STATE(1265),
    [sym_const_item] = STATE(1265),
    [sym_static_item] = STATE(1265),
    [sym_type_item] = STATE(1265),
    [sym_function_item] = STATE(1265),
    [sym_function_signature_item] = STATE(1265),
    [sym_function_modifiers] = STATE(610),
    [sym_impl_item] = STATE(1265),
    [sym_trait_item] = STATE(1265),
    [sym_associated_type] = STATE(1265),
    [sym_let_declaration] = STATE(1265),
    [sym_use_declaration] = STATE(1265),
    [sym_extern_modifier] = STATE(611),
    [sym_visibility_modifier] = STATE(612),
    [sym_macro_invocation] = STATE(1265),
    [aux_sym_declaration_list_repeat1] = STATE(1265),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1159),
    [anon_sym_macro_rules_BANG] = ACTIONS(1161),
    [anon_sym_RBRACE] = ACTIONS(5663),
    [anon_sym_POUND] = ACTIONS(1165),
    [anon_sym_const] = ACTIONS(1167),
    [anon_sym_default] = ACTIONS(1169),
    [anon_sym_enum] = ACTIONS(1171),
    [anon_sym_fn] = ACTIONS(1173),
    [anon_sym_impl] = ACTIONS(1175),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_mod] = ACTIONS(1179),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_struct] = ACTIONS(1183),
    [anon_sym_trait] = ACTIONS(1185),
    [anon_sym_type] = ACTIONS(1187),
    [anon_sym_union] = ACTIONS(1189),
    [anon_sym_unsafe] = ACTIONS(1191),
    [anon_sym_use] = ACTIONS(1193),
    [anon_sym_extern] = ACTIONS(1195),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1197),
  },
  [1941] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(5665),
    [sym_line_comment] = ACTIONS(7),
  },
  [1942] = {
    [sym_enum_variant_list] = STATE(2560),
    [sym_where_clause] = STATE(2561),
    [sym_type_parameters] = STATE(2562),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(4209),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [1943] = {
    [sym_declaration_list] = STATE(2563),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5667),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [sym_line_comment] = ACTIONS(7),
  },
  [1944] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5669),
  },
  [1945] = {
    [sym_field_declaration_list] = STATE(2565),
    [sym_ordered_field_declaration_list] = STATE(2566),
    [sym_where_clause] = STATE(2567),
    [sym_type_parameters] = STATE(2568),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5671),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(3125),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_where] = ACTIONS(1057),
    [sym_line_comment] = ACTIONS(7),
  },
  [1946] = {
    [sym_declaration_list] = STATE(2569),
    [sym_trait_bounds] = STATE(2570),
    [sym_type_parameters] = STATE(2571),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [anon_sym_COLON] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [sym_line_comment] = ACTIONS(7),
  },
  [1947] = {
    [sym_type_parameters] = STATE(2573),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(5673),
    [sym_line_comment] = ACTIONS(7),
  },
  [1948] = {
    [sym_field_declaration_list] = STATE(2574),
    [sym_ordered_field_declaration_list] = STATE(2575),
    [sym_where_clause] = STATE(2576),
    [sym_type_parameters] = STATE(2577),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5675),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(3125),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_where] = ACTIONS(1057),
    [sym_line_comment] = ACTIONS(7),
  },
  [1949] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5677),
    [sym_line_comment] = ACTIONS(7),
  },
  [1950] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5679),
  },
  [1951] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5681),
    [sym_metavariable] = ACTIONS(5681),
  },
  [1952] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2525),
    [anon_sym_macro_rules_BANG] = ACTIONS(2525),
    [anon_sym_RBRACE] = ACTIONS(2525),
    [anon_sym_POUND] = ACTIONS(2525),
    [anon_sym_const] = ACTIONS(2527),
    [anon_sym_default] = ACTIONS(2527),
    [anon_sym_enum] = ACTIONS(2527),
    [anon_sym_fn] = ACTIONS(2527),
    [anon_sym_impl] = ACTIONS(2527),
    [anon_sym_let] = ACTIONS(2527),
    [anon_sym_mod] = ACTIONS(2527),
    [anon_sym_pub] = ACTIONS(2527),
    [anon_sym_static] = ACTIONS(2527),
    [anon_sym_struct] = ACTIONS(2527),
    [anon_sym_trait] = ACTIONS(2527),
    [anon_sym_type] = ACTIONS(2527),
    [anon_sym_union] = ACTIONS(2527),
    [anon_sym_unsafe] = ACTIONS(2527),
    [anon_sym_use] = ACTIONS(2527),
    [anon_sym_extern] = ACTIONS(2527),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2527),
  },
  [1953] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(3111),
    [anon_sym_EQ] = ACTIONS(5683),
    [sym_line_comment] = ACTIONS(7),
  },
  [1954] = {
    [sym_raw_string_literal] = ACTIONS(5685),
    [sym_float_literal] = ACTIONS(5685),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(5685),
    [anon_sym_SEMI] = ACTIONS(5685),
    [anon_sym_macro_rules_BANG] = ACTIONS(5685),
    [anon_sym_LPAREN] = ACTIONS(5685),
    [anon_sym_LBRACE] = ACTIONS(5685),
    [anon_sym_RBRACE] = ACTIONS(5685),
    [anon_sym_LBRACK] = ACTIONS(5685),
    [anon_sym_STAR] = ACTIONS(5685),
    [anon_sym_u8] = ACTIONS(5687),
    [anon_sym_i8] = ACTIONS(5687),
    [anon_sym_u16] = ACTIONS(5687),
    [anon_sym_i16] = ACTIONS(5687),
    [anon_sym_u32] = ACTIONS(5687),
    [anon_sym_i32] = ACTIONS(5687),
    [anon_sym_u64] = ACTIONS(5687),
    [anon_sym_i64] = ACTIONS(5687),
    [anon_sym_u128] = ACTIONS(5687),
    [anon_sym_i128] = ACTIONS(5687),
    [anon_sym_isize] = ACTIONS(5687),
    [anon_sym_usize] = ACTIONS(5687),
    [anon_sym_f32] = ACTIONS(5687),
    [anon_sym_f64] = ACTIONS(5687),
    [anon_sym_bool] = ACTIONS(5687),
    [anon_sym_str] = ACTIONS(5687),
    [anon_sym_char] = ACTIONS(5687),
    [anon_sym_AMP] = ACTIONS(5685),
    [anon_sym_DASH] = ACTIONS(5685),
    [anon_sym_COLON_COLON] = ACTIONS(5685),
    [anon_sym_BANG] = ACTIONS(5685),
    [anon_sym_POUND] = ACTIONS(5685),
    [anon_sym_LT] = ACTIONS(5685),
    [anon_sym_PIPE] = ACTIONS(5685),
    [anon_sym_SQUOTE] = ACTIONS(5687),
    [anon_sym_DOT_DOT] = ACTIONS(5685),
    [anon_sym_break] = ACTIONS(5687),
    [anon_sym_const] = ACTIONS(5687),
    [anon_sym_continue] = ACTIONS(5687),
    [anon_sym_default] = ACTIONS(5687),
    [anon_sym_enum] = ACTIONS(5687),
    [anon_sym_fn] = ACTIONS(5687),
    [anon_sym_for] = ACTIONS(5687),
    [anon_sym_if] = ACTIONS(5687),
    [anon_sym_impl] = ACTIONS(5687),
    [anon_sym_let] = ACTIONS(5687),
    [anon_sym_loop] = ACTIONS(5687),
    [anon_sym_match] = ACTIONS(5687),
    [anon_sym_mod] = ACTIONS(5687),
    [anon_sym_pub] = ACTIONS(5687),
    [anon_sym_return] = ACTIONS(5687),
    [anon_sym_static] = ACTIONS(5687),
    [anon_sym_struct] = ACTIONS(5687),
    [anon_sym_trait] = ACTIONS(5687),
    [anon_sym_type] = ACTIONS(5687),
    [anon_sym_union] = ACTIONS(5687),
    [anon_sym_unsafe] = ACTIONS(5687),
    [anon_sym_use] = ACTIONS(5687),
    [anon_sym_while] = ACTIONS(5687),
    [anon_sym_extern] = ACTIONS(5687),
    [anon_sym_move] = ACTIONS(5687),
    [sym_integer_literal] = ACTIONS(5685),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5685),
    [sym_char_literal] = ACTIONS(5685),
    [anon_sym_true] = ACTIONS(5687),
    [anon_sym_false] = ACTIONS(5687),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5687),
    [sym_self] = ACTIONS(5687),
    [sym_super] = ACTIONS(5687),
    [sym_crate] = ACTIONS(5687),
    [sym_metavariable] = ACTIONS(5685),
  },
  [1955] = {
    [sym_enum_variant_list] = STATE(2582),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(923),
    [sym_line_comment] = ACTIONS(7),
  },
  [1956] = {
    [sym_function_modifiers] = STATE(1025),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2583),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1027),
    [sym_array_type] = STATE(2583),
    [sym_function_type] = STATE(2583),
    [sym_tuple_type] = STATE(2583),
    [sym_unit_type] = STATE(2583),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2583),
    [sym_reference_type] = STATE(2583),
    [sym_pointer_type] = STATE(2583),
    [sym_empty_type] = STATE(2583),
    [sym_dynamic_type] = STATE(2583),
    [sym_macro_invocation] = STATE(2583),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1028),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2060),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2062),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2064),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2066),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1957] = {
    [sym_raw_string_literal] = ACTIONS(5689),
    [sym_float_literal] = ACTIONS(5689),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(5689),
    [anon_sym_SEMI] = ACTIONS(5689),
    [anon_sym_macro_rules_BANG] = ACTIONS(5689),
    [anon_sym_LPAREN] = ACTIONS(5689),
    [anon_sym_LBRACE] = ACTIONS(5689),
    [anon_sym_RBRACE] = ACTIONS(5689),
    [anon_sym_LBRACK] = ACTIONS(5689),
    [anon_sym_STAR] = ACTIONS(5689),
    [anon_sym_u8] = ACTIONS(5691),
    [anon_sym_i8] = ACTIONS(5691),
    [anon_sym_u16] = ACTIONS(5691),
    [anon_sym_i16] = ACTIONS(5691),
    [anon_sym_u32] = ACTIONS(5691),
    [anon_sym_i32] = ACTIONS(5691),
    [anon_sym_u64] = ACTIONS(5691),
    [anon_sym_i64] = ACTIONS(5691),
    [anon_sym_u128] = ACTIONS(5691),
    [anon_sym_i128] = ACTIONS(5691),
    [anon_sym_isize] = ACTIONS(5691),
    [anon_sym_usize] = ACTIONS(5691),
    [anon_sym_f32] = ACTIONS(5691),
    [anon_sym_f64] = ACTIONS(5691),
    [anon_sym_bool] = ACTIONS(5691),
    [anon_sym_str] = ACTIONS(5691),
    [anon_sym_char] = ACTIONS(5691),
    [anon_sym_AMP] = ACTIONS(5689),
    [anon_sym_DASH] = ACTIONS(5689),
    [anon_sym_COLON_COLON] = ACTIONS(5689),
    [anon_sym_BANG] = ACTIONS(5689),
    [anon_sym_POUND] = ACTIONS(5689),
    [anon_sym_LT] = ACTIONS(5689),
    [anon_sym_PIPE] = ACTIONS(5689),
    [anon_sym_SQUOTE] = ACTIONS(5691),
    [anon_sym_DOT_DOT] = ACTIONS(5689),
    [anon_sym_break] = ACTIONS(5691),
    [anon_sym_const] = ACTIONS(5691),
    [anon_sym_continue] = ACTIONS(5691),
    [anon_sym_default] = ACTIONS(5691),
    [anon_sym_enum] = ACTIONS(5691),
    [anon_sym_fn] = ACTIONS(5691),
    [anon_sym_for] = ACTIONS(5691),
    [anon_sym_if] = ACTIONS(5691),
    [anon_sym_impl] = ACTIONS(5691),
    [anon_sym_let] = ACTIONS(5691),
    [anon_sym_loop] = ACTIONS(5691),
    [anon_sym_match] = ACTIONS(5691),
    [anon_sym_mod] = ACTIONS(5691),
    [anon_sym_pub] = ACTIONS(5691),
    [anon_sym_return] = ACTIONS(5691),
    [anon_sym_static] = ACTIONS(5691),
    [anon_sym_struct] = ACTIONS(5691),
    [anon_sym_trait] = ACTIONS(5691),
    [anon_sym_type] = ACTIONS(5691),
    [anon_sym_union] = ACTIONS(5691),
    [anon_sym_unsafe] = ACTIONS(5691),
    [anon_sym_use] = ACTIONS(5691),
    [anon_sym_while] = ACTIONS(5691),
    [anon_sym_extern] = ACTIONS(5691),
    [anon_sym_move] = ACTIONS(5691),
    [sym_integer_literal] = ACTIONS(5689),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5689),
    [sym_char_literal] = ACTIONS(5689),
    [anon_sym_true] = ACTIONS(5691),
    [anon_sym_false] = ACTIONS(5691),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5691),
    [sym_self] = ACTIONS(5691),
    [sym_super] = ACTIONS(5691),
    [sym_crate] = ACTIONS(5691),
    [sym_metavariable] = ACTIONS(5689),
  },
  [1958] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5693),
    [sym_line_comment] = ACTIONS(7),
  },
  [1959] = {
    [sym_where_clause] = STATE(2585),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5693),
    [anon_sym_where] = ACTIONS(2138),
    [sym_line_comment] = ACTIONS(7),
  },
  [1960] = {
    [sym_field_declaration_list] = STATE(2584),
    [sym_ordered_field_declaration_list] = STATE(2586),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5693),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(1055),
    [sym_line_comment] = ACTIONS(7),
  },
  [1961] = {
    [sym_raw_string_literal] = ACTIONS(5695),
    [sym_float_literal] = ACTIONS(5695),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(5695),
    [anon_sym_SEMI] = ACTIONS(5695),
    [anon_sym_macro_rules_BANG] = ACTIONS(5695),
    [anon_sym_LPAREN] = ACTIONS(5695),
    [anon_sym_LBRACE] = ACTIONS(5695),
    [anon_sym_RBRACE] = ACTIONS(5695),
    [anon_sym_LBRACK] = ACTIONS(5695),
    [anon_sym_STAR] = ACTIONS(5695),
    [anon_sym_u8] = ACTIONS(5697),
    [anon_sym_i8] = ACTIONS(5697),
    [anon_sym_u16] = ACTIONS(5697),
    [anon_sym_i16] = ACTIONS(5697),
    [anon_sym_u32] = ACTIONS(5697),
    [anon_sym_i32] = ACTIONS(5697),
    [anon_sym_u64] = ACTIONS(5697),
    [anon_sym_i64] = ACTIONS(5697),
    [anon_sym_u128] = ACTIONS(5697),
    [anon_sym_i128] = ACTIONS(5697),
    [anon_sym_isize] = ACTIONS(5697),
    [anon_sym_usize] = ACTIONS(5697),
    [anon_sym_f32] = ACTIONS(5697),
    [anon_sym_f64] = ACTIONS(5697),
    [anon_sym_bool] = ACTIONS(5697),
    [anon_sym_str] = ACTIONS(5697),
    [anon_sym_char] = ACTIONS(5697),
    [anon_sym_AMP] = ACTIONS(5695),
    [anon_sym_DASH] = ACTIONS(5695),
    [anon_sym_COLON_COLON] = ACTIONS(5695),
    [anon_sym_BANG] = ACTIONS(5695),
    [anon_sym_POUND] = ACTIONS(5695),
    [anon_sym_LT] = ACTIONS(5695),
    [anon_sym_PIPE] = ACTIONS(5695),
    [anon_sym_SQUOTE] = ACTIONS(5697),
    [anon_sym_DOT_DOT] = ACTIONS(5695),
    [anon_sym_break] = ACTIONS(5697),
    [anon_sym_const] = ACTIONS(5697),
    [anon_sym_continue] = ACTIONS(5697),
    [anon_sym_default] = ACTIONS(5697),
    [anon_sym_enum] = ACTIONS(5697),
    [anon_sym_fn] = ACTIONS(5697),
    [anon_sym_for] = ACTIONS(5697),
    [anon_sym_if] = ACTIONS(5697),
    [anon_sym_impl] = ACTIONS(5697),
    [anon_sym_let] = ACTIONS(5697),
    [anon_sym_loop] = ACTIONS(5697),
    [anon_sym_match] = ACTIONS(5697),
    [anon_sym_mod] = ACTIONS(5697),
    [anon_sym_pub] = ACTIONS(5697),
    [anon_sym_return] = ACTIONS(5697),
    [anon_sym_static] = ACTIONS(5697),
    [anon_sym_struct] = ACTIONS(5697),
    [anon_sym_trait] = ACTIONS(5697),
    [anon_sym_type] = ACTIONS(5697),
    [anon_sym_union] = ACTIONS(5697),
    [anon_sym_unsafe] = ACTIONS(5697),
    [anon_sym_use] = ACTIONS(5697),
    [anon_sym_while] = ACTIONS(5697),
    [anon_sym_extern] = ACTIONS(5697),
    [anon_sym_move] = ACTIONS(5697),
    [sym_integer_literal] = ACTIONS(5695),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5695),
    [sym_char_literal] = ACTIONS(5695),
    [anon_sym_true] = ACTIONS(5697),
    [anon_sym_false] = ACTIONS(5697),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5697),
    [sym_self] = ACTIONS(5697),
    [sym_super] = ACTIONS(5697),
    [sym_crate] = ACTIONS(5697),
    [sym_metavariable] = ACTIONS(5695),
  },
  [1962] = {
    [sym_declaration_list] = STATE(2587),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [sym_line_comment] = ACTIONS(7),
  },
  [1963] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5699),
    [anon_sym_PLUS] = ACTIONS(3423),
    [sym_line_comment] = ACTIONS(7),
  },
  [1964] = {
    [sym_function_modifiers] = STATE(1097),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2589),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1102),
    [sym_array_type] = STATE(2589),
    [sym_function_type] = STATE(2589),
    [sym_tuple_type] = STATE(2589),
    [sym_unit_type] = STATE(2589),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2589),
    [sym_reference_type] = STATE(2589),
    [sym_pointer_type] = STATE(2589),
    [sym_empty_type] = STATE(2589),
    [sym_dynamic_type] = STATE(2589),
    [sym_macro_invocation] = STATE(2589),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2156),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2162),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2166),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1965] = {
    [sym_raw_string_literal] = ACTIONS(5701),
    [sym_float_literal] = ACTIONS(5701),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(5701),
    [anon_sym_SEMI] = ACTIONS(5701),
    [anon_sym_macro_rules_BANG] = ACTIONS(5701),
    [anon_sym_LPAREN] = ACTIONS(5701),
    [anon_sym_LBRACE] = ACTIONS(5701),
    [anon_sym_RBRACE] = ACTIONS(5701),
    [anon_sym_LBRACK] = ACTIONS(5701),
    [anon_sym_STAR] = ACTIONS(5701),
    [anon_sym_u8] = ACTIONS(5703),
    [anon_sym_i8] = ACTIONS(5703),
    [anon_sym_u16] = ACTIONS(5703),
    [anon_sym_i16] = ACTIONS(5703),
    [anon_sym_u32] = ACTIONS(5703),
    [anon_sym_i32] = ACTIONS(5703),
    [anon_sym_u64] = ACTIONS(5703),
    [anon_sym_i64] = ACTIONS(5703),
    [anon_sym_u128] = ACTIONS(5703),
    [anon_sym_i128] = ACTIONS(5703),
    [anon_sym_isize] = ACTIONS(5703),
    [anon_sym_usize] = ACTIONS(5703),
    [anon_sym_f32] = ACTIONS(5703),
    [anon_sym_f64] = ACTIONS(5703),
    [anon_sym_bool] = ACTIONS(5703),
    [anon_sym_str] = ACTIONS(5703),
    [anon_sym_char] = ACTIONS(5703),
    [anon_sym_AMP] = ACTIONS(5701),
    [anon_sym_DASH] = ACTIONS(5701),
    [anon_sym_COLON_COLON] = ACTIONS(5701),
    [anon_sym_BANG] = ACTIONS(5701),
    [anon_sym_POUND] = ACTIONS(5701),
    [anon_sym_LT] = ACTIONS(5701),
    [anon_sym_PIPE] = ACTIONS(5701),
    [anon_sym_SQUOTE] = ACTIONS(5703),
    [anon_sym_DOT_DOT] = ACTIONS(5701),
    [anon_sym_break] = ACTIONS(5703),
    [anon_sym_const] = ACTIONS(5703),
    [anon_sym_continue] = ACTIONS(5703),
    [anon_sym_default] = ACTIONS(5703),
    [anon_sym_enum] = ACTIONS(5703),
    [anon_sym_fn] = ACTIONS(5703),
    [anon_sym_for] = ACTIONS(5703),
    [anon_sym_if] = ACTIONS(5703),
    [anon_sym_impl] = ACTIONS(5703),
    [anon_sym_let] = ACTIONS(5703),
    [anon_sym_loop] = ACTIONS(5703),
    [anon_sym_match] = ACTIONS(5703),
    [anon_sym_mod] = ACTIONS(5703),
    [anon_sym_pub] = ACTIONS(5703),
    [anon_sym_return] = ACTIONS(5703),
    [anon_sym_static] = ACTIONS(5703),
    [anon_sym_struct] = ACTIONS(5703),
    [anon_sym_trait] = ACTIONS(5703),
    [anon_sym_type] = ACTIONS(5703),
    [anon_sym_union] = ACTIONS(5703),
    [anon_sym_unsafe] = ACTIONS(5703),
    [anon_sym_use] = ACTIONS(5703),
    [anon_sym_while] = ACTIONS(5703),
    [anon_sym_extern] = ACTIONS(5703),
    [anon_sym_move] = ACTIONS(5703),
    [sym_integer_literal] = ACTIONS(5701),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5701),
    [sym_char_literal] = ACTIONS(5701),
    [anon_sym_true] = ACTIONS(5703),
    [anon_sym_false] = ACTIONS(5703),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5703),
    [sym_self] = ACTIONS(5703),
    [sym_super] = ACTIONS(5703),
    [sym_crate] = ACTIONS(5703),
    [sym_metavariable] = ACTIONS(5701),
  },
  [1966] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5705),
    [sym_line_comment] = ACTIONS(7),
  },
  [1967] = {
    [sym_field_declaration_list] = STATE(2590),
    [sym_ordered_field_declaration_list] = STATE(2591),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5705),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(1055),
    [sym_line_comment] = ACTIONS(7),
  },
  [1968] = {
    [sym_raw_string_literal] = ACTIONS(5707),
    [sym_float_literal] = ACTIONS(5707),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(5707),
    [anon_sym_SEMI] = ACTIONS(5707),
    [anon_sym_macro_rules_BANG] = ACTIONS(5707),
    [anon_sym_LPAREN] = ACTIONS(5707),
    [anon_sym_LBRACE] = ACTIONS(5707),
    [anon_sym_RBRACE] = ACTIONS(5707),
    [anon_sym_LBRACK] = ACTIONS(5707),
    [anon_sym_STAR] = ACTIONS(5707),
    [anon_sym_u8] = ACTIONS(5709),
    [anon_sym_i8] = ACTIONS(5709),
    [anon_sym_u16] = ACTIONS(5709),
    [anon_sym_i16] = ACTIONS(5709),
    [anon_sym_u32] = ACTIONS(5709),
    [anon_sym_i32] = ACTIONS(5709),
    [anon_sym_u64] = ACTIONS(5709),
    [anon_sym_i64] = ACTIONS(5709),
    [anon_sym_u128] = ACTIONS(5709),
    [anon_sym_i128] = ACTIONS(5709),
    [anon_sym_isize] = ACTIONS(5709),
    [anon_sym_usize] = ACTIONS(5709),
    [anon_sym_f32] = ACTIONS(5709),
    [anon_sym_f64] = ACTIONS(5709),
    [anon_sym_bool] = ACTIONS(5709),
    [anon_sym_str] = ACTIONS(5709),
    [anon_sym_char] = ACTIONS(5709),
    [anon_sym_AMP] = ACTIONS(5707),
    [anon_sym_DASH] = ACTIONS(5707),
    [anon_sym_COLON_COLON] = ACTIONS(5707),
    [anon_sym_BANG] = ACTIONS(5707),
    [anon_sym_POUND] = ACTIONS(5707),
    [anon_sym_LT] = ACTIONS(5707),
    [anon_sym_PIPE] = ACTIONS(5707),
    [anon_sym_SQUOTE] = ACTIONS(5709),
    [anon_sym_DOT_DOT] = ACTIONS(5707),
    [anon_sym_break] = ACTIONS(5709),
    [anon_sym_const] = ACTIONS(5709),
    [anon_sym_continue] = ACTIONS(5709),
    [anon_sym_default] = ACTIONS(5709),
    [anon_sym_enum] = ACTIONS(5709),
    [anon_sym_fn] = ACTIONS(5709),
    [anon_sym_for] = ACTIONS(5709),
    [anon_sym_if] = ACTIONS(5709),
    [anon_sym_impl] = ACTIONS(5709),
    [anon_sym_let] = ACTIONS(5709),
    [anon_sym_loop] = ACTIONS(5709),
    [anon_sym_match] = ACTIONS(5709),
    [anon_sym_mod] = ACTIONS(5709),
    [anon_sym_pub] = ACTIONS(5709),
    [anon_sym_return] = ACTIONS(5709),
    [anon_sym_static] = ACTIONS(5709),
    [anon_sym_struct] = ACTIONS(5709),
    [anon_sym_trait] = ACTIONS(5709),
    [anon_sym_type] = ACTIONS(5709),
    [anon_sym_union] = ACTIONS(5709),
    [anon_sym_unsafe] = ACTIONS(5709),
    [anon_sym_use] = ACTIONS(5709),
    [anon_sym_while] = ACTIONS(5709),
    [anon_sym_extern] = ACTIONS(5709),
    [anon_sym_move] = ACTIONS(5709),
    [sym_integer_literal] = ACTIONS(5707),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5707),
    [sym_char_literal] = ACTIONS(5707),
    [anon_sym_true] = ACTIONS(5709),
    [anon_sym_false] = ACTIONS(5709),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5709),
    [sym_self] = ACTIONS(5709),
    [sym_super] = ACTIONS(5709),
    [sym_crate] = ACTIONS(5709),
    [sym_metavariable] = ACTIONS(5707),
  },
  [1969] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5711),
  },
  [1970] = {
    [sym_parameters] = STATE(2593),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [1971] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5713),
    [anon_sym_LPAREN] = ACTIONS(5713),
    [anon_sym_RPAREN] = ACTIONS(5713),
    [anon_sym_LBRACE] = ACTIONS(5713),
    [anon_sym_RBRACE] = ACTIONS(5713),
    [anon_sym_LBRACK] = ACTIONS(5713),
    [anon_sym_RBRACK] = ACTIONS(5713),
    [anon_sym_PLUS] = ACTIONS(5715),
    [anon_sym_STAR] = ACTIONS(5715),
    [anon_sym_COMMA] = ACTIONS(5713),
    [anon_sym_AMP] = ACTIONS(5715),
    [anon_sym_DASH] = ACTIONS(5715),
    [anon_sym_DOT] = ACTIONS(5715),
    [anon_sym_DASH_EQ] = ACTIONS(5713),
    [anon_sym_BANG_EQ] = ACTIONS(5713),
    [anon_sym_STAR_EQ] = ACTIONS(5713),
    [anon_sym_SLASH] = ACTIONS(5715),
    [anon_sym_SLASH_EQ] = ACTIONS(5713),
    [anon_sym_AMP_AMP] = ACTIONS(5713),
    [anon_sym_AMP_EQ] = ACTIONS(5713),
    [anon_sym_PERCENT] = ACTIONS(5715),
    [anon_sym_PERCENT_EQ] = ACTIONS(5713),
    [anon_sym_CARET] = ACTIONS(5715),
    [anon_sym_CARET_EQ] = ACTIONS(5713),
    [anon_sym_PLUS_EQ] = ACTIONS(5713),
    [anon_sym_LT] = ACTIONS(5715),
    [anon_sym_LT_LT] = ACTIONS(5715),
    [anon_sym_LT_LT_EQ] = ACTIONS(5713),
    [anon_sym_LT_EQ] = ACTIONS(5713),
    [anon_sym_EQ] = ACTIONS(5715),
    [anon_sym_EQ_EQ] = ACTIONS(5713),
    [anon_sym_GT] = ACTIONS(5715),
    [anon_sym_GT_EQ] = ACTIONS(5713),
    [anon_sym_GT_GT] = ACTIONS(5715),
    [anon_sym_GT_GT_EQ] = ACTIONS(5713),
    [anon_sym_PIPE] = ACTIONS(5715),
    [anon_sym_PIPE_EQ] = ACTIONS(5713),
    [anon_sym_PIPE_PIPE] = ACTIONS(5713),
    [anon_sym_QMARK] = ACTIONS(5713),
    [anon_sym_DOT_DOT] = ACTIONS(5715),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5713),
    [anon_sym_as] = ACTIONS(5713),
    [sym_line_comment] = ACTIONS(7),
  },
  [1972] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_BANG_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH] = ACTIONS(563),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(563),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_LT] = ACTIONS(577),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(581),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(577),
    [anon_sym_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(589),
    [anon_sym_as] = ACTIONS(591),
    [sym_line_comment] = ACTIONS(7),
  },
  [1973] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1972),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1972),
    [sym_unary_expression] = STATE(1972),
    [sym_try_expression] = STATE(1972),
    [sym_reference_expression] = STATE(1972),
    [sym_binary_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1972),
    [sym_call_expression] = STATE(1972),
    [sym_array_expression] = STATE(1972),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_tuple_expression] = STATE(1972),
    [sym_unit_expression] = STATE(1972),
    [sym_struct_expression] = STATE(1972),
    [sym_if_expression] = STATE(1972),
    [sym_if_let_expression] = STATE(1972),
    [sym_match_expression] = STATE(1972),
    [sym_while_expression] = STATE(1972),
    [sym_while_let_expression] = STATE(1972),
    [sym_loop_expression] = STATE(1972),
    [sym_for_expression] = STATE(1972),
    [sym_closure_expression] = STATE(1972),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1972),
    [sym_continue_expression] = STATE(1972),
    [sym_index_expression] = STATE(1972),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1972),
    [sym_block] = STATE(1972),
    [sym__literal] = STATE(1972),
    [sym_string_literal] = STATE(1972),
    [sym_boolean_literal] = STATE(1972),
    [sym_raw_string_literal] = ACTIONS(4375),
    [sym_float_literal] = ACTIONS(4375),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(5717),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(4375),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4375),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [1974] = {
    [aux_sym_token_tree_repeat2] = STATE(1974),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(2815),
    [anon_sym_COMMA] = ACTIONS(5719),
    [sym_line_comment] = ACTIONS(7),
  },
  [1975] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(5722),
    [sym_line_comment] = ACTIONS(7),
  },
  [1976] = {
    [sym_else_tail] = STATE(1378),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2012),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_RBRACK] = ACTIONS(2012),
    [anon_sym_PLUS] = ACTIONS(2014),
    [anon_sym_STAR] = ACTIONS(2014),
    [anon_sym_AMP] = ACTIONS(2014),
    [anon_sym_DASH] = ACTIONS(2014),
    [anon_sym_DOT] = ACTIONS(2014),
    [anon_sym_DASH_EQ] = ACTIONS(2012),
    [anon_sym_BANG_EQ] = ACTIONS(2012),
    [anon_sym_STAR_EQ] = ACTIONS(2012),
    [anon_sym_SLASH] = ACTIONS(2014),
    [anon_sym_SLASH_EQ] = ACTIONS(2012),
    [anon_sym_AMP_AMP] = ACTIONS(2012),
    [anon_sym_AMP_EQ] = ACTIONS(2012),
    [anon_sym_PERCENT] = ACTIONS(2014),
    [anon_sym_PERCENT_EQ] = ACTIONS(2012),
    [anon_sym_CARET] = ACTIONS(2014),
    [anon_sym_CARET_EQ] = ACTIONS(2012),
    [anon_sym_PLUS_EQ] = ACTIONS(2012),
    [anon_sym_LT] = ACTIONS(2014),
    [anon_sym_LT_LT] = ACTIONS(2014),
    [anon_sym_LT_LT_EQ] = ACTIONS(2012),
    [anon_sym_LT_EQ] = ACTIONS(2012),
    [anon_sym_EQ] = ACTIONS(2014),
    [anon_sym_EQ_EQ] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2014),
    [anon_sym_GT_EQ] = ACTIONS(2012),
    [anon_sym_GT_GT] = ACTIONS(2014),
    [anon_sym_GT_GT_EQ] = ACTIONS(2012),
    [anon_sym_PIPE] = ACTIONS(2014),
    [anon_sym_PIPE_EQ] = ACTIONS(2012),
    [anon_sym_PIPE_PIPE] = ACTIONS(2012),
    [anon_sym_QMARK] = ACTIONS(2012),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2012),
    [anon_sym_as] = ACTIONS(2012),
    [anon_sym_else] = ACTIONS(5724),
    [sym_line_comment] = ACTIONS(7),
  },
  [1977] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2220),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_STAR_EQ] = ACTIONS(2563),
    [anon_sym_SLASH] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_AMP_EQ] = ACTIONS(2563),
    [anon_sym_PERCENT] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2563),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_CARET_EQ] = ACTIONS(2563),
    [anon_sym_PLUS_EQ] = ACTIONS(2563),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_LT_LT] = ACTIONS(2573),
    [anon_sym_LT_LT_EQ] = ACTIONS(2563),
    [anon_sym_LT_EQ] = ACTIONS(2565),
    [anon_sym_EQ] = ACTIONS(2575),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_GT_EQ] = ACTIONS(2565),
    [anon_sym_GT_GT] = ACTIONS(2573),
    [anon_sym_GT_GT_EQ] = ACTIONS(2563),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_PIPE_EQ] = ACTIONS(2563),
    [anon_sym_PIPE_PIPE] = ACTIONS(2579),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(2581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2583),
    [anon_sym_as] = ACTIONS(2585),
    [sym_line_comment] = ACTIONS(7),
  },
  [1978] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2591),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [1979] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2573),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2573),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [1980] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2601),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2601),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_STAR_EQ] = ACTIONS(2601),
    [anon_sym_SLASH] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2601),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_AMP_EQ] = ACTIONS(2601),
    [anon_sym_PERCENT] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2601),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_CARET_EQ] = ACTIONS(2601),
    [anon_sym_PLUS_EQ] = ACTIONS(2601),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_LT_LT] = ACTIONS(2573),
    [anon_sym_LT_LT_EQ] = ACTIONS(2601),
    [anon_sym_LT_EQ] = ACTIONS(2565),
    [anon_sym_EQ] = ACTIONS(2603),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_GT_EQ] = ACTIONS(2565),
    [anon_sym_GT_GT] = ACTIONS(2573),
    [anon_sym_GT_GT_EQ] = ACTIONS(2601),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_PIPE_EQ] = ACTIONS(2601),
    [anon_sym_PIPE_PIPE] = ACTIONS(2579),
    [anon_sym_QMARK] = ACTIONS(2601),
    [anon_sym_DOT_DOT] = ACTIONS(2581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2583),
    [anon_sym_as] = ACTIONS(2601),
    [sym_line_comment] = ACTIONS(7),
  },
  [1981] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2573),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2573),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [1982] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_LT_LT] = ACTIONS(2573),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2565),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_GT_EQ] = ACTIONS(2565),
    [anon_sym_GT_GT] = ACTIONS(2573),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [1983] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2573),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2573),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [1984] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2591),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [1985] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2605),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2605),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_STAR_EQ] = ACTIONS(2605),
    [anon_sym_SLASH] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2605),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_AMP_EQ] = ACTIONS(2605),
    [anon_sym_PERCENT] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2605),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_CARET_EQ] = ACTIONS(2605),
    [anon_sym_PLUS_EQ] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_LT_LT] = ACTIONS(2573),
    [anon_sym_LT_LT_EQ] = ACTIONS(2605),
    [anon_sym_LT_EQ] = ACTIONS(2565),
    [anon_sym_EQ] = ACTIONS(2607),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_GT_EQ] = ACTIONS(2565),
    [anon_sym_GT_GT] = ACTIONS(2573),
    [anon_sym_GT_GT_EQ] = ACTIONS(2605),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_PIPE_EQ] = ACTIONS(2605),
    [anon_sym_PIPE_PIPE] = ACTIONS(2579),
    [anon_sym_QMARK] = ACTIONS(2605),
    [anon_sym_DOT_DOT] = ACTIONS(2581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2583),
    [anon_sym_as] = ACTIONS(2605),
    [sym_line_comment] = ACTIONS(7),
  },
  [1986] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2573),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2573),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [1987] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_LT_LT] = ACTIONS(2573),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2565),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_GT_EQ] = ACTIONS(2565),
    [anon_sym_GT_GT] = ACTIONS(2573),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [1988] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2609),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2609),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_STAR_EQ] = ACTIONS(2609),
    [anon_sym_SLASH] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2609),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_AMP_EQ] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2609),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_CARET_EQ] = ACTIONS(2609),
    [anon_sym_PLUS_EQ] = ACTIONS(2609),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_LT_LT] = ACTIONS(2573),
    [anon_sym_LT_LT_EQ] = ACTIONS(2609),
    [anon_sym_LT_EQ] = ACTIONS(2565),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_GT_EQ] = ACTIONS(2565),
    [anon_sym_GT_GT] = ACTIONS(2573),
    [anon_sym_GT_GT_EQ] = ACTIONS(2609),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_PIPE_EQ] = ACTIONS(2609),
    [anon_sym_PIPE_PIPE] = ACTIONS(2579),
    [anon_sym_QMARK] = ACTIONS(2609),
    [anon_sym_DOT_DOT] = ACTIONS(2611),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2609),
    [anon_sym_as] = ACTIONS(2609),
    [sym_line_comment] = ACTIONS(7),
  },
  [1989] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(5726),
    [sym_mutable_specifier] = ACTIONS(5726),
    [sym_line_comment] = ACTIONS(7),
  },
  [1990] = {
    [sym_function_modifiers] = STATE(1993),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1319),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(2600),
    [sym_array_type] = STATE(1319),
    [sym_function_type] = STATE(1319),
    [sym_tuple_type] = STATE(1319),
    [sym_unit_type] = STATE(1319),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(1319),
    [sym_reference_type] = STATE(1319),
    [sym_pointer_type] = STATE(1319),
    [sym_empty_type] = STATE(1319),
    [sym_dynamic_type] = STATE(1319),
    [sym_macro_invocation] = STATE(1319),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(1995),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(4413),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(4415),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4417),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_mutable_specifier] = ACTIONS(5728),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4419),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [1991] = {
    [sym_parameters] = STATE(2601),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [sym_line_comment] = ACTIONS(7),
  },
  [1992] = {
    [sym_parameters] = STATE(2602),
    [sym_type_arguments] = STATE(1330),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(773),
    [anon_sym_RBRACK] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(2633),
    [anon_sym_STAR] = ACTIONS(2633),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_DASH] = ACTIONS(2633),
    [anon_sym_DOT] = ACTIONS(2633),
    [anon_sym_DASH_EQ] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(2635),
    [anon_sym_BANG] = ACTIONS(557),
    [anon_sym_BANG_EQ] = ACTIONS(773),
    [anon_sym_STAR_EQ] = ACTIONS(773),
    [anon_sym_SLASH] = ACTIONS(2633),
    [anon_sym_SLASH_EQ] = ACTIONS(773),
    [anon_sym_AMP_AMP] = ACTIONS(773),
    [anon_sym_AMP_EQ] = ACTIONS(773),
    [anon_sym_PERCENT] = ACTIONS(2633),
    [anon_sym_PERCENT_EQ] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(2633),
    [anon_sym_CARET_EQ] = ACTIONS(773),
    [anon_sym_PLUS_EQ] = ACTIONS(773),
    [anon_sym_LT] = ACTIONS(2637),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_LT_LT_EQ] = ACTIONS(773),
    [anon_sym_LT_EQ] = ACTIONS(773),
    [anon_sym_EQ] = ACTIONS(2633),
    [anon_sym_EQ_EQ] = ACTIONS(773),
    [anon_sym_GT] = ACTIONS(2633),
    [anon_sym_GT_EQ] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_GT_GT_EQ] = ACTIONS(773),
    [anon_sym_PIPE] = ACTIONS(2633),
    [anon_sym_PIPE_EQ] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(773),
    [anon_sym_QMARK] = ACTIONS(773),
    [anon_sym_DOT_DOT] = ACTIONS(2633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(773),
    [anon_sym_as] = ACTIONS(773),
    [sym_line_comment] = ACTIONS(7),
  },
  [1993] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2605),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_fn] = ACTIONS(5730),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5732),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [1994] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(5734),
    [sym_line_comment] = ACTIONS(7),
  },
  [1995] = {
    [sym_parameters] = STATE(2601),
    [sym_type_arguments] = STATE(1340),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(783),
    [anon_sym_RBRACK] = ACTIONS(783),
    [anon_sym_PLUS] = ACTIONS(785),
    [anon_sym_STAR] = ACTIONS(785),
    [anon_sym_AMP] = ACTIONS(785),
    [anon_sym_DASH] = ACTIONS(785),
    [anon_sym_DOT] = ACTIONS(785),
    [anon_sym_DASH_EQ] = ACTIONS(783),
    [anon_sym_BANG_EQ] = ACTIONS(783),
    [anon_sym_STAR_EQ] = ACTIONS(783),
    [anon_sym_SLASH] = ACTIONS(785),
    [anon_sym_SLASH_EQ] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_AMP_EQ] = ACTIONS(783),
    [anon_sym_PERCENT] = ACTIONS(785),
    [anon_sym_PERCENT_EQ] = ACTIONS(783),
    [anon_sym_CARET] = ACTIONS(785),
    [anon_sym_CARET_EQ] = ACTIONS(783),
    [anon_sym_PLUS_EQ] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(2637),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_LT_LT_EQ] = ACTIONS(783),
    [anon_sym_LT_EQ] = ACTIONS(783),
    [anon_sym_EQ] = ACTIONS(785),
    [anon_sym_EQ_EQ] = ACTIONS(783),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_GT_EQ] = ACTIONS(783),
    [anon_sym_GT_GT] = ACTIONS(785),
    [anon_sym_GT_GT_EQ] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PIPE_EQ] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_DOT_DOT] = ACTIONS(785),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(783),
    [anon_sym_as] = ACTIONS(783),
    [sym_line_comment] = ACTIONS(7),
  },
  [1996] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2884),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_RPAREN] = ACTIONS(2884),
    [anon_sym_LBRACE] = ACTIONS(2884),
    [anon_sym_RBRACE] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2884),
    [anon_sym_RBRACK] = ACTIONS(2884),
    [anon_sym_PLUS] = ACTIONS(5736),
    [anon_sym_STAR] = ACTIONS(5736),
    [anon_sym_COMMA] = ACTIONS(2884),
    [anon_sym_AMP] = ACTIONS(5736),
    [anon_sym_DASH] = ACTIONS(5736),
    [anon_sym_DOT] = ACTIONS(5736),
    [anon_sym_DASH_EQ] = ACTIONS(2884),
    [anon_sym_BANG_EQ] = ACTIONS(2884),
    [anon_sym_STAR_EQ] = ACTIONS(2884),
    [anon_sym_SLASH] = ACTIONS(5736),
    [anon_sym_SLASH_EQ] = ACTIONS(2884),
    [anon_sym_AMP_AMP] = ACTIONS(2884),
    [anon_sym_AMP_EQ] = ACTIONS(2884),
    [anon_sym_PERCENT] = ACTIONS(5736),
    [anon_sym_PERCENT_EQ] = ACTIONS(2884),
    [anon_sym_CARET] = ACTIONS(5736),
    [anon_sym_CARET_EQ] = ACTIONS(2884),
    [anon_sym_PLUS_EQ] = ACTIONS(2884),
    [anon_sym_LT] = ACTIONS(5736),
    [anon_sym_LT_LT] = ACTIONS(5736),
    [anon_sym_LT_LT_EQ] = ACTIONS(2884),
    [anon_sym_LT_EQ] = ACTIONS(2884),
    [anon_sym_EQ] = ACTIONS(5736),
    [anon_sym_EQ_EQ] = ACTIONS(2884),
    [anon_sym_GT] = ACTIONS(5736),
    [anon_sym_GT_EQ] = ACTIONS(2884),
    [anon_sym_GT_GT] = ACTIONS(5736),
    [anon_sym_GT_GT_EQ] = ACTIONS(2884),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_PIPE_EQ] = ACTIONS(2884),
    [anon_sym_PIPE_PIPE] = ACTIONS(2884),
    [anon_sym_QMARK] = ACTIONS(2884),
    [anon_sym_DOT_DOT] = ACTIONS(5736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2884),
    [anon_sym_as] = ACTIONS(2884),
    [sym_line_comment] = ACTIONS(7),
  },
  [1997] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1470),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(1470),
    [sym_function_type] = STATE(1470),
    [sym_tuple_type] = STATE(1470),
    [sym_unit_type] = STATE(1470),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1470),
    [sym_reference_type] = STATE(1470),
    [sym_pointer_type] = STATE(1470),
    [sym_empty_type] = STATE(1470),
    [sym_dynamic_type] = STATE(1470),
    [sym_macro_invocation] = STATE(1470),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_RPAREN] = ACTIONS(5738),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [1998] = {
    [aux_sym_tuple_type_repeat1] = STATE(1472),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(5738),
    [anon_sym_COMMA] = ACTIONS(5740),
    [sym_line_comment] = ACTIONS(7),
  },
  [1999] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2610),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2610),
    [sym_macro_invocation] = STATE(2610),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2610),
    [sym_unary_expression] = STATE(2610),
    [sym_try_expression] = STATE(2610),
    [sym_reference_expression] = STATE(2610),
    [sym_binary_expression] = STATE(2610),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2610),
    [sym_call_expression] = STATE(2610),
    [sym_array_expression] = STATE(2610),
    [sym_parenthesized_expression] = STATE(2610),
    [sym_tuple_expression] = STATE(2610),
    [sym_unit_expression] = STATE(2610),
    [sym_struct_expression] = STATE(2610),
    [sym_if_expression] = STATE(2610),
    [sym_if_let_expression] = STATE(2610),
    [sym_match_expression] = STATE(2610),
    [sym_while_expression] = STATE(2610),
    [sym_while_let_expression] = STATE(2610),
    [sym_loop_expression] = STATE(2610),
    [sym_for_expression] = STATE(2610),
    [sym_closure_expression] = STATE(2610),
    [sym_closure_parameters] = STATE(638),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2610),
    [sym_continue_expression] = STATE(2610),
    [sym_index_expression] = STATE(2610),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2610),
    [sym_block] = STATE(2610),
    [sym__literal] = STATE(2610),
    [sym_string_literal] = STATE(2610),
    [sym_boolean_literal] = STATE(2610),
    [sym_raw_string_literal] = ACTIONS(5742),
    [sym_float_literal] = ACTIONS(5742),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1245),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1247),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1251),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1253),
    [sym_integer_literal] = ACTIONS(5742),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(5742),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2000] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2898),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(2898),
    [anon_sym_LBRACE] = ACTIONS(2898),
    [anon_sym_RBRACE] = ACTIONS(2898),
    [anon_sym_LBRACK] = ACTIONS(2898),
    [anon_sym_RBRACK] = ACTIONS(2898),
    [anon_sym_PLUS] = ACTIONS(5744),
    [anon_sym_STAR] = ACTIONS(5744),
    [anon_sym_COMMA] = ACTIONS(2898),
    [anon_sym_AMP] = ACTIONS(5744),
    [anon_sym_DASH] = ACTIONS(5744),
    [anon_sym_DOT] = ACTIONS(5744),
    [anon_sym_DASH_EQ] = ACTIONS(2898),
    [anon_sym_BANG_EQ] = ACTIONS(2898),
    [anon_sym_STAR_EQ] = ACTIONS(2898),
    [anon_sym_SLASH] = ACTIONS(5744),
    [anon_sym_SLASH_EQ] = ACTIONS(2898),
    [anon_sym_AMP_AMP] = ACTIONS(2898),
    [anon_sym_AMP_EQ] = ACTIONS(2898),
    [anon_sym_PERCENT] = ACTIONS(5744),
    [anon_sym_PERCENT_EQ] = ACTIONS(2898),
    [anon_sym_CARET] = ACTIONS(5744),
    [anon_sym_CARET_EQ] = ACTIONS(2898),
    [anon_sym_PLUS_EQ] = ACTIONS(2898),
    [anon_sym_LT] = ACTIONS(5744),
    [anon_sym_LT_LT] = ACTIONS(5744),
    [anon_sym_LT_LT_EQ] = ACTIONS(2898),
    [anon_sym_LT_EQ] = ACTIONS(2898),
    [anon_sym_EQ] = ACTIONS(5744),
    [anon_sym_EQ_EQ] = ACTIONS(2898),
    [anon_sym_GT] = ACTIONS(5744),
    [anon_sym_GT_EQ] = ACTIONS(2898),
    [anon_sym_GT_GT] = ACTIONS(5744),
    [anon_sym_GT_GT_EQ] = ACTIONS(2898),
    [anon_sym_PIPE] = ACTIONS(5744),
    [anon_sym_PIPE_EQ] = ACTIONS(2898),
    [anon_sym_PIPE_PIPE] = ACTIONS(2898),
    [anon_sym_QMARK] = ACTIONS(2898),
    [anon_sym_DOT_DOT] = ACTIONS(5744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2898),
    [anon_sym_as] = ACTIONS(2898),
    [sym_line_comment] = ACTIONS(7),
  },
  [2001] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2900),
    [anon_sym_LPAREN] = ACTIONS(2900),
    [anon_sym_RPAREN] = ACTIONS(2900),
    [anon_sym_LBRACE] = ACTIONS(2900),
    [anon_sym_RBRACE] = ACTIONS(2900),
    [anon_sym_LBRACK] = ACTIONS(2900),
    [anon_sym_RBRACK] = ACTIONS(2900),
    [anon_sym_PLUS] = ACTIONS(5746),
    [anon_sym_STAR] = ACTIONS(5746),
    [anon_sym_COMMA] = ACTIONS(2900),
    [anon_sym_AMP] = ACTIONS(5746),
    [anon_sym_DASH] = ACTIONS(5746),
    [anon_sym_DOT] = ACTIONS(5746),
    [anon_sym_DASH_EQ] = ACTIONS(2900),
    [anon_sym_BANG_EQ] = ACTIONS(2900),
    [anon_sym_STAR_EQ] = ACTIONS(2900),
    [anon_sym_SLASH] = ACTIONS(5746),
    [anon_sym_SLASH_EQ] = ACTIONS(2900),
    [anon_sym_AMP_AMP] = ACTIONS(2900),
    [anon_sym_AMP_EQ] = ACTIONS(2900),
    [anon_sym_PERCENT] = ACTIONS(5746),
    [anon_sym_PERCENT_EQ] = ACTIONS(2900),
    [anon_sym_CARET] = ACTIONS(5746),
    [anon_sym_CARET_EQ] = ACTIONS(2900),
    [anon_sym_PLUS_EQ] = ACTIONS(2900),
    [anon_sym_LT] = ACTIONS(5746),
    [anon_sym_LT_LT] = ACTIONS(5746),
    [anon_sym_LT_LT_EQ] = ACTIONS(2900),
    [anon_sym_LT_EQ] = ACTIONS(2900),
    [anon_sym_EQ] = ACTIONS(5746),
    [anon_sym_EQ_EQ] = ACTIONS(2900),
    [anon_sym_GT] = ACTIONS(5746),
    [anon_sym_GT_EQ] = ACTIONS(2900),
    [anon_sym_GT_GT] = ACTIONS(5746),
    [anon_sym_GT_GT_EQ] = ACTIONS(2900),
    [anon_sym_PIPE] = ACTIONS(5746),
    [anon_sym_PIPE_EQ] = ACTIONS(2900),
    [anon_sym_PIPE_PIPE] = ACTIONS(2900),
    [anon_sym_QMARK] = ACTIONS(2900),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2900),
    [anon_sym_as] = ACTIONS(2900),
    [sym_line_comment] = ACTIONS(7),
  },
  [2002] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2902),
    [anon_sym_LPAREN] = ACTIONS(2902),
    [anon_sym_RPAREN] = ACTIONS(2902),
    [anon_sym_LBRACE] = ACTIONS(2902),
    [anon_sym_RBRACE] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2902),
    [anon_sym_RBRACK] = ACTIONS(2902),
    [anon_sym_PLUS] = ACTIONS(2904),
    [anon_sym_STAR] = ACTIONS(2904),
    [anon_sym_COMMA] = ACTIONS(2902),
    [anon_sym_AMP] = ACTIONS(2904),
    [anon_sym_DASH] = ACTIONS(2904),
    [anon_sym_DOT] = ACTIONS(2904),
    [anon_sym_DASH_EQ] = ACTIONS(2902),
    [anon_sym_COLON_COLON] = ACTIONS(1670),
    [anon_sym_BANG_EQ] = ACTIONS(2902),
    [anon_sym_STAR_EQ] = ACTIONS(2902),
    [anon_sym_SLASH] = ACTIONS(2904),
    [anon_sym_SLASH_EQ] = ACTIONS(2902),
    [anon_sym_AMP_AMP] = ACTIONS(2902),
    [anon_sym_AMP_EQ] = ACTIONS(2902),
    [anon_sym_PERCENT] = ACTIONS(2904),
    [anon_sym_PERCENT_EQ] = ACTIONS(2902),
    [anon_sym_CARET] = ACTIONS(2904),
    [anon_sym_CARET_EQ] = ACTIONS(2902),
    [anon_sym_PLUS_EQ] = ACTIONS(2902),
    [anon_sym_LT] = ACTIONS(2904),
    [anon_sym_LT_LT] = ACTIONS(2904),
    [anon_sym_LT_LT_EQ] = ACTIONS(2902),
    [anon_sym_LT_EQ] = ACTIONS(2902),
    [anon_sym_EQ] = ACTIONS(2904),
    [anon_sym_EQ_EQ] = ACTIONS(2902),
    [anon_sym_GT] = ACTIONS(2904),
    [anon_sym_GT_EQ] = ACTIONS(2902),
    [anon_sym_GT_GT] = ACTIONS(2904),
    [anon_sym_GT_GT_EQ] = ACTIONS(2902),
    [anon_sym_PIPE] = ACTIONS(2904),
    [anon_sym_PIPE_EQ] = ACTIONS(2902),
    [anon_sym_PIPE_PIPE] = ACTIONS(2902),
    [anon_sym_QMARK] = ACTIONS(2902),
    [anon_sym_DOT_DOT] = ACTIONS(2904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2902),
    [anon_sym_as] = ACTIONS(2902),
    [sym_line_comment] = ACTIONS(7),
  },
  [2003] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2906),
    [anon_sym_LPAREN] = ACTIONS(2906),
    [anon_sym_RPAREN] = ACTIONS(2906),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(2906),
    [anon_sym_LBRACK] = ACTIONS(2906),
    [anon_sym_RBRACK] = ACTIONS(2906),
    [anon_sym_PLUS] = ACTIONS(5748),
    [anon_sym_STAR] = ACTIONS(5748),
    [anon_sym_COMMA] = ACTIONS(2906),
    [anon_sym_AMP] = ACTIONS(5748),
    [anon_sym_DASH] = ACTIONS(5748),
    [anon_sym_DOT] = ACTIONS(5748),
    [anon_sym_DASH_EQ] = ACTIONS(2906),
    [anon_sym_BANG_EQ] = ACTIONS(2906),
    [anon_sym_STAR_EQ] = ACTIONS(2906),
    [anon_sym_SLASH] = ACTIONS(5748),
    [anon_sym_SLASH_EQ] = ACTIONS(2906),
    [anon_sym_AMP_AMP] = ACTIONS(2906),
    [anon_sym_AMP_EQ] = ACTIONS(2906),
    [anon_sym_PERCENT] = ACTIONS(5748),
    [anon_sym_PERCENT_EQ] = ACTIONS(2906),
    [anon_sym_CARET] = ACTIONS(5748),
    [anon_sym_CARET_EQ] = ACTIONS(2906),
    [anon_sym_PLUS_EQ] = ACTIONS(2906),
    [anon_sym_LT] = ACTIONS(5748),
    [anon_sym_LT_LT] = ACTIONS(5748),
    [anon_sym_LT_LT_EQ] = ACTIONS(2906),
    [anon_sym_LT_EQ] = ACTIONS(2906),
    [anon_sym_EQ] = ACTIONS(5748),
    [anon_sym_EQ_EQ] = ACTIONS(2906),
    [anon_sym_GT] = ACTIONS(5748),
    [anon_sym_GT_EQ] = ACTIONS(2906),
    [anon_sym_GT_GT] = ACTIONS(5748),
    [anon_sym_GT_GT_EQ] = ACTIONS(2906),
    [anon_sym_PIPE] = ACTIONS(5748),
    [anon_sym_PIPE_EQ] = ACTIONS(2906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2906),
    [anon_sym_QMARK] = ACTIONS(2906),
    [anon_sym_DOT_DOT] = ACTIONS(5748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2906),
    [anon_sym_as] = ACTIONS(2906),
    [sym_line_comment] = ACTIONS(7),
  },
  [2004] = {
    [sym_function_modifiers] = STATE(665),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2611),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(667),
    [sym_array_type] = STATE(2611),
    [sym_function_type] = STATE(2611),
    [sym_tuple_type] = STATE(2611),
    [sym_unit_type] = STATE(2611),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2611),
    [sym_reference_type] = STATE(2611),
    [sym_pointer_type] = STATE(2611),
    [sym_empty_type] = STATE(2611),
    [sym_dynamic_type] = STATE(2611),
    [sym_macro_invocation] = STATE(2611),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(671),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1291),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1295),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1301),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1305),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2005] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2908),
    [anon_sym_LPAREN] = ACTIONS(2908),
    [anon_sym_RPAREN] = ACTIONS(2908),
    [anon_sym_LBRACE] = ACTIONS(2908),
    [anon_sym_RBRACE] = ACTIONS(2908),
    [anon_sym_LBRACK] = ACTIONS(2908),
    [anon_sym_RBRACK] = ACTIONS(2908),
    [anon_sym_PLUS] = ACTIONS(5750),
    [anon_sym_STAR] = ACTIONS(5750),
    [anon_sym_COMMA] = ACTIONS(2908),
    [anon_sym_AMP] = ACTIONS(5750),
    [anon_sym_DASH] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5750),
    [anon_sym_DASH_EQ] = ACTIONS(2908),
    [anon_sym_DASH_GT] = ACTIONS(2908),
    [anon_sym_BANG_EQ] = ACTIONS(2908),
    [anon_sym_STAR_EQ] = ACTIONS(2908),
    [anon_sym_SLASH] = ACTIONS(5750),
    [anon_sym_SLASH_EQ] = ACTIONS(2908),
    [anon_sym_AMP_AMP] = ACTIONS(2908),
    [anon_sym_AMP_EQ] = ACTIONS(2908),
    [anon_sym_PERCENT] = ACTIONS(5750),
    [anon_sym_PERCENT_EQ] = ACTIONS(2908),
    [anon_sym_CARET] = ACTIONS(5750),
    [anon_sym_CARET_EQ] = ACTIONS(2908),
    [anon_sym_PLUS_EQ] = ACTIONS(2908),
    [anon_sym_LT] = ACTIONS(5750),
    [anon_sym_LT_LT] = ACTIONS(5750),
    [anon_sym_LT_LT_EQ] = ACTIONS(2908),
    [anon_sym_LT_EQ] = ACTIONS(2908),
    [anon_sym_EQ] = ACTIONS(5750),
    [anon_sym_EQ_EQ] = ACTIONS(2908),
    [anon_sym_GT] = ACTIONS(5750),
    [anon_sym_GT_EQ] = ACTIONS(2908),
    [anon_sym_GT_GT] = ACTIONS(5750),
    [anon_sym_GT_GT_EQ] = ACTIONS(2908),
    [anon_sym_PIPE] = ACTIONS(5750),
    [anon_sym_PIPE_EQ] = ACTIONS(2908),
    [anon_sym_PIPE_PIPE] = ACTIONS(2908),
    [anon_sym_QMARK] = ACTIONS(2908),
    [anon_sym_DOT_DOT] = ACTIONS(5750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2908),
    [anon_sym_as] = ACTIONS(2908),
    [sym_line_comment] = ACTIONS(7),
  },
  [2006] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(5752),
    [sym_line_comment] = ACTIONS(7),
  },
  [2007] = {
    [aux_sym_parameters_repeat1] = STATE(2614),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(5752),
    [anon_sym_COLON] = ACTIONS(2914),
    [anon_sym_COMMA] = ACTIONS(5754),
    [sym_line_comment] = ACTIONS(7),
  },
  [2008] = {
    [aux_sym_parameters_repeat1] = STATE(2614),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5754),
    [sym_line_comment] = ACTIONS(7),
  },
  [2009] = {
    [aux_sym_parameters_repeat1] = STATE(2614),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_COMMA] = ACTIONS(5754),
    [sym_line_comment] = ACTIONS(7),
  },
  [2010] = {
    [sym_function_modifiers] = STATE(665),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2616),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(667),
    [sym_array_type] = STATE(2616),
    [sym_function_type] = STATE(2616),
    [sym_tuple_type] = STATE(2616),
    [sym_unit_type] = STATE(2616),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2616),
    [sym_reference_type] = STATE(2616),
    [sym_pointer_type] = STATE(2616),
    [sym_empty_type] = STATE(2616),
    [sym_abstract_type] = STATE(2617),
    [sym_dynamic_type] = STATE(2616),
    [sym_macro_invocation] = STATE(2616),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(671),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1291),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1295),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1301),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1305),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2011] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2950),
    [anon_sym_LPAREN] = ACTIONS(2950),
    [anon_sym_RPAREN] = ACTIONS(2950),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_RBRACE] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_RBRACK] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2952),
    [anon_sym_STAR] = ACTIONS(2952),
    [anon_sym_COMMA] = ACTIONS(2950),
    [anon_sym_AMP] = ACTIONS(2952),
    [anon_sym_DASH] = ACTIONS(2952),
    [anon_sym_DOT] = ACTIONS(2952),
    [anon_sym_DASH_EQ] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2263),
    [anon_sym_BANG_EQ] = ACTIONS(2950),
    [anon_sym_STAR_EQ] = ACTIONS(2950),
    [anon_sym_SLASH] = ACTIONS(2952),
    [anon_sym_SLASH_EQ] = ACTIONS(2950),
    [anon_sym_AMP_AMP] = ACTIONS(2950),
    [anon_sym_AMP_EQ] = ACTIONS(2950),
    [anon_sym_PERCENT] = ACTIONS(2952),
    [anon_sym_PERCENT_EQ] = ACTIONS(2950),
    [anon_sym_CARET] = ACTIONS(2952),
    [anon_sym_CARET_EQ] = ACTIONS(2950),
    [anon_sym_PLUS_EQ] = ACTIONS(2950),
    [anon_sym_LT] = ACTIONS(2952),
    [anon_sym_LT_LT] = ACTIONS(2952),
    [anon_sym_LT_LT_EQ] = ACTIONS(2950),
    [anon_sym_LT_EQ] = ACTIONS(2950),
    [anon_sym_EQ] = ACTIONS(2952),
    [anon_sym_EQ_EQ] = ACTIONS(2950),
    [anon_sym_GT] = ACTIONS(2952),
    [anon_sym_GT_EQ] = ACTIONS(2950),
    [anon_sym_GT_GT] = ACTIONS(2952),
    [anon_sym_GT_GT_EQ] = ACTIONS(2950),
    [anon_sym_PIPE] = ACTIONS(2952),
    [anon_sym_PIPE_EQ] = ACTIONS(2950),
    [anon_sym_PIPE_PIPE] = ACTIONS(2950),
    [anon_sym_QMARK] = ACTIONS(2950),
    [anon_sym_DOT_DOT] = ACTIONS(2952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2950),
    [anon_sym_as] = ACTIONS(2950),
    [sym_line_comment] = ACTIONS(7),
  },
  [2012] = {
    [sym_function_modifiers] = STATE(665),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2618),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(667),
    [sym_array_type] = STATE(2618),
    [sym_function_type] = STATE(2618),
    [sym_tuple_type] = STATE(2618),
    [sym_unit_type] = STATE(2618),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2618),
    [sym_reference_type] = STATE(2618),
    [sym_pointer_type] = STATE(2618),
    [sym_empty_type] = STATE(2618),
    [sym_abstract_type] = STATE(2619),
    [sym_dynamic_type] = STATE(2618),
    [sym_macro_invocation] = STATE(2618),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(671),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1291),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1295),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1301),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1305),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2013] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2988),
    [anon_sym_LPAREN] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(5758),
    [anon_sym_STAR] = ACTIONS(5758),
    [anon_sym_AMP] = ACTIONS(5758),
    [anon_sym_DASH] = ACTIONS(5758),
    [anon_sym_DOT] = ACTIONS(5758),
    [anon_sym_DASH_EQ] = ACTIONS(2988),
    [anon_sym_DASH_GT] = ACTIONS(5760),
    [anon_sym_BANG_EQ] = ACTIONS(2988),
    [anon_sym_STAR_EQ] = ACTIONS(2988),
    [anon_sym_SLASH] = ACTIONS(5758),
    [anon_sym_SLASH_EQ] = ACTIONS(2988),
    [anon_sym_AMP_AMP] = ACTIONS(2988),
    [anon_sym_AMP_EQ] = ACTIONS(2988),
    [anon_sym_PERCENT] = ACTIONS(5758),
    [anon_sym_PERCENT_EQ] = ACTIONS(2988),
    [anon_sym_CARET] = ACTIONS(5758),
    [anon_sym_CARET_EQ] = ACTIONS(2988),
    [anon_sym_PLUS_EQ] = ACTIONS(2988),
    [anon_sym_LT] = ACTIONS(5758),
    [anon_sym_LT_LT] = ACTIONS(5758),
    [anon_sym_LT_LT_EQ] = ACTIONS(2988),
    [anon_sym_LT_EQ] = ACTIONS(2988),
    [anon_sym_EQ] = ACTIONS(5758),
    [anon_sym_EQ_EQ] = ACTIONS(2988),
    [anon_sym_GT] = ACTIONS(5758),
    [anon_sym_GT_EQ] = ACTIONS(2988),
    [anon_sym_GT_GT] = ACTIONS(5758),
    [anon_sym_GT_GT_EQ] = ACTIONS(2988),
    [anon_sym_PIPE] = ACTIONS(5758),
    [anon_sym_PIPE_EQ] = ACTIONS(2988),
    [anon_sym_PIPE_PIPE] = ACTIONS(2988),
    [anon_sym_QMARK] = ACTIONS(2988),
    [anon_sym_DOT_DOT] = ACTIONS(5758),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2988),
    [anon_sym_as] = ACTIONS(2988),
    [sym_line_comment] = ACTIONS(7),
  },
  [2014] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym_LPAREN] = ACTIONS(2992),
    [anon_sym_LBRACK] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(5762),
    [anon_sym_STAR] = ACTIONS(5762),
    [anon_sym_AMP] = ACTIONS(5762),
    [anon_sym_DASH] = ACTIONS(5762),
    [anon_sym_DOT] = ACTIONS(5762),
    [anon_sym_DASH_EQ] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(5764),
    [anon_sym_BANG_EQ] = ACTIONS(2992),
    [anon_sym_STAR_EQ] = ACTIONS(2992),
    [anon_sym_SLASH] = ACTIONS(5762),
    [anon_sym_SLASH_EQ] = ACTIONS(2992),
    [anon_sym_AMP_AMP] = ACTIONS(2992),
    [anon_sym_AMP_EQ] = ACTIONS(2992),
    [anon_sym_PERCENT] = ACTIONS(5762),
    [anon_sym_PERCENT_EQ] = ACTIONS(2992),
    [anon_sym_CARET] = ACTIONS(5762),
    [anon_sym_CARET_EQ] = ACTIONS(2992),
    [anon_sym_PLUS_EQ] = ACTIONS(2992),
    [anon_sym_LT] = ACTIONS(5762),
    [anon_sym_LT_LT] = ACTIONS(5762),
    [anon_sym_LT_LT_EQ] = ACTIONS(2992),
    [anon_sym_LT_EQ] = ACTIONS(2992),
    [anon_sym_EQ] = ACTIONS(5762),
    [anon_sym_EQ_EQ] = ACTIONS(2992),
    [anon_sym_GT] = ACTIONS(5762),
    [anon_sym_GT_EQ] = ACTIONS(2992),
    [anon_sym_GT_GT] = ACTIONS(5762),
    [anon_sym_GT_GT_EQ] = ACTIONS(2992),
    [anon_sym_PIPE] = ACTIONS(5762),
    [anon_sym_PIPE_EQ] = ACTIONS(2992),
    [anon_sym_PIPE_PIPE] = ACTIONS(2992),
    [anon_sym_QMARK] = ACTIONS(2992),
    [anon_sym_DOT_DOT] = ACTIONS(5762),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2992),
    [anon_sym_as] = ACTIONS(2992),
    [sym_line_comment] = ACTIONS(7),
  },
  [2015] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5766),
  },
  [2016] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2996),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_RPAREN] = ACTIONS(2996),
    [anon_sym_LBRACE] = ACTIONS(2996),
    [anon_sym_RBRACE] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(2996),
    [anon_sym_RBRACK] = ACTIONS(2996),
    [anon_sym_PLUS] = ACTIONS(5768),
    [anon_sym_STAR] = ACTIONS(5768),
    [anon_sym_COMMA] = ACTIONS(2996),
    [anon_sym_AMP] = ACTIONS(5768),
    [anon_sym_DASH] = ACTIONS(5768),
    [anon_sym_DOT] = ACTIONS(5768),
    [anon_sym_DASH_EQ] = ACTIONS(2996),
    [anon_sym_BANG_EQ] = ACTIONS(2996),
    [anon_sym_STAR_EQ] = ACTIONS(2996),
    [anon_sym_SLASH] = ACTIONS(5768),
    [anon_sym_SLASH_EQ] = ACTIONS(2996),
    [anon_sym_AMP_AMP] = ACTIONS(2996),
    [anon_sym_AMP_EQ] = ACTIONS(2996),
    [anon_sym_PERCENT] = ACTIONS(5768),
    [anon_sym_PERCENT_EQ] = ACTIONS(2996),
    [anon_sym_CARET] = ACTIONS(5768),
    [anon_sym_CARET_EQ] = ACTIONS(2996),
    [anon_sym_PLUS_EQ] = ACTIONS(2996),
    [anon_sym_LT] = ACTIONS(5768),
    [anon_sym_LT_LT] = ACTIONS(5768),
    [anon_sym_LT_LT_EQ] = ACTIONS(2996),
    [anon_sym_LT_EQ] = ACTIONS(2996),
    [anon_sym_EQ] = ACTIONS(5768),
    [anon_sym_EQ_EQ] = ACTIONS(2996),
    [anon_sym_GT] = ACTIONS(5768),
    [anon_sym_GT_EQ] = ACTIONS(2996),
    [anon_sym_GT_GT] = ACTIONS(5768),
    [anon_sym_GT_GT_EQ] = ACTIONS(2996),
    [anon_sym_PIPE] = ACTIONS(5768),
    [anon_sym_PIPE_EQ] = ACTIONS(2996),
    [anon_sym_PIPE_PIPE] = ACTIONS(2996),
    [anon_sym_QMARK] = ACTIONS(2996),
    [anon_sym_DOT_DOT] = ACTIONS(5768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2996),
    [anon_sym_as] = ACTIONS(2996),
    [sym_line_comment] = ACTIONS(7),
  },
  [2017] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2950),
    [anon_sym_LPAREN] = ACTIONS(2950),
    [anon_sym_RPAREN] = ACTIONS(2950),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_RBRACE] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_RBRACK] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2952),
    [anon_sym_STAR] = ACTIONS(2952),
    [anon_sym_COMMA] = ACTIONS(2950),
    [anon_sym_AMP] = ACTIONS(2952),
    [anon_sym_DASH] = ACTIONS(2952),
    [anon_sym_DOT] = ACTIONS(2952),
    [anon_sym_DASH_EQ] = ACTIONS(2950),
    [anon_sym_BANG_EQ] = ACTIONS(2950),
    [anon_sym_STAR_EQ] = ACTIONS(2950),
    [anon_sym_SLASH] = ACTIONS(2952),
    [anon_sym_SLASH_EQ] = ACTIONS(2950),
    [anon_sym_AMP_AMP] = ACTIONS(2950),
    [anon_sym_AMP_EQ] = ACTIONS(2950),
    [anon_sym_PERCENT] = ACTIONS(2952),
    [anon_sym_PERCENT_EQ] = ACTIONS(2950),
    [anon_sym_CARET] = ACTIONS(2952),
    [anon_sym_CARET_EQ] = ACTIONS(2950),
    [anon_sym_PLUS_EQ] = ACTIONS(2950),
    [anon_sym_LT] = ACTIONS(2952),
    [anon_sym_LT_LT] = ACTIONS(2952),
    [anon_sym_LT_LT_EQ] = ACTIONS(2950),
    [anon_sym_LT_EQ] = ACTIONS(2950),
    [anon_sym_EQ] = ACTIONS(2952),
    [anon_sym_EQ_EQ] = ACTIONS(2950),
    [anon_sym_GT] = ACTIONS(2952),
    [anon_sym_GT_EQ] = ACTIONS(2950),
    [anon_sym_GT_GT] = ACTIONS(2952),
    [anon_sym_GT_GT_EQ] = ACTIONS(2950),
    [anon_sym_PIPE] = ACTIONS(2952),
    [anon_sym_PIPE_EQ] = ACTIONS(2950),
    [anon_sym_PIPE_PIPE] = ACTIONS(2950),
    [anon_sym_QMARK] = ACTIONS(2950),
    [anon_sym_DOT_DOT] = ACTIONS(2952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2950),
    [anon_sym_as] = ACTIONS(2950),
    [sym_line_comment] = ACTIONS(7),
  },
  [2018] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3012),
    [anon_sym_LPAREN] = ACTIONS(3012),
    [anon_sym_RPAREN] = ACTIONS(3012),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_RBRACE] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_RBRACK] = ACTIONS(3012),
    [anon_sym_PLUS] = ACTIONS(3014),
    [anon_sym_STAR] = ACTIONS(3014),
    [anon_sym_COMMA] = ACTIONS(3012),
    [anon_sym_AMP] = ACTIONS(3014),
    [anon_sym_DASH] = ACTIONS(3014),
    [anon_sym_DOT] = ACTIONS(3014),
    [anon_sym_DASH_EQ] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(2529),
    [anon_sym_BANG_EQ] = ACTIONS(3012),
    [anon_sym_STAR_EQ] = ACTIONS(3012),
    [anon_sym_SLASH] = ACTIONS(3014),
    [anon_sym_SLASH_EQ] = ACTIONS(3012),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_AMP_EQ] = ACTIONS(3012),
    [anon_sym_PERCENT] = ACTIONS(3014),
    [anon_sym_PERCENT_EQ] = ACTIONS(3012),
    [anon_sym_CARET] = ACTIONS(3014),
    [anon_sym_CARET_EQ] = ACTIONS(3012),
    [anon_sym_PLUS_EQ] = ACTIONS(3012),
    [anon_sym_LT] = ACTIONS(3014),
    [anon_sym_LT_LT] = ACTIONS(3014),
    [anon_sym_LT_LT_EQ] = ACTIONS(3012),
    [anon_sym_LT_EQ] = ACTIONS(3012),
    [anon_sym_EQ] = ACTIONS(3014),
    [anon_sym_EQ_EQ] = ACTIONS(3012),
    [anon_sym_GT] = ACTIONS(3014),
    [anon_sym_GT_EQ] = ACTIONS(3012),
    [anon_sym_GT_GT] = ACTIONS(3014),
    [anon_sym_GT_GT_EQ] = ACTIONS(3012),
    [anon_sym_PIPE] = ACTIONS(3014),
    [anon_sym_PIPE_EQ] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE] = ACTIONS(3012),
    [anon_sym_QMARK] = ACTIONS(3012),
    [anon_sym_DOT_DOT] = ACTIONS(3014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3012),
    [anon_sym_as] = ACTIONS(3012),
    [sym_line_comment] = ACTIONS(7),
  },
  [2019] = {
    [sym_function_modifiers] = STATE(677),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1479),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(679),
    [sym_array_type] = STATE(1479),
    [sym_function_type] = STATE(1479),
    [sym_tuple_type] = STATE(1479),
    [sym_unit_type] = STATE(1479),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1479),
    [sym_reference_type] = STATE(1479),
    [sym_pointer_type] = STATE(1479),
    [sym_empty_type] = STATE(1479),
    [sym_dynamic_type] = STATE(1479),
    [sym_macro_invocation] = STATE(1479),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(680),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1315),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1317),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1319),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1321),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2020] = {
    [sym_function_modifiers] = STATE(677),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1499),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(679),
    [sym_array_type] = STATE(1499),
    [sym_function_type] = STATE(1499),
    [sym_tuple_type] = STATE(1499),
    [sym_unit_type] = STATE(1499),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1499),
    [sym_reference_type] = STATE(1499),
    [sym_pointer_type] = STATE(1499),
    [sym_empty_type] = STATE(1499),
    [sym_abstract_type] = STATE(1500),
    [sym_dynamic_type] = STATE(1499),
    [sym_macro_invocation] = STATE(1499),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(680),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1315),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1317),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1319),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1321),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2021] = {
    [sym_function_modifiers] = STATE(677),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1525),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(679),
    [sym_array_type] = STATE(1525),
    [sym_function_type] = STATE(1525),
    [sym_tuple_type] = STATE(1525),
    [sym_unit_type] = STATE(1525),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1525),
    [sym_reference_type] = STATE(1525),
    [sym_pointer_type] = STATE(1525),
    [sym_empty_type] = STATE(1525),
    [sym_abstract_type] = STATE(1526),
    [sym_dynamic_type] = STATE(1525),
    [sym_macro_invocation] = STATE(1525),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(680),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1315),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1317),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1319),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1321),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2022] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_DASH_GT] = ACTIONS(5770),
    [sym_line_comment] = ACTIONS(7),
  },
  [2023] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(5772),
    [sym_line_comment] = ACTIONS(7),
  },
  [2024] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2625),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(2625),
    [sym_macro_invocation] = STATE(2625),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2625),
    [sym_unary_expression] = STATE(2625),
    [sym_try_expression] = STATE(2625),
    [sym_reference_expression] = STATE(2625),
    [sym_binary_expression] = STATE(2625),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2625),
    [sym_call_expression] = STATE(2625),
    [sym_array_expression] = STATE(2625),
    [sym_parenthesized_expression] = STATE(2625),
    [sym_tuple_expression] = STATE(2625),
    [sym_unit_expression] = STATE(2625),
    [sym_struct_expression] = STATE(2625),
    [sym_if_expression] = STATE(2625),
    [sym_if_let_expression] = STATE(2625),
    [sym_match_expression] = STATE(2625),
    [sym_while_expression] = STATE(2625),
    [sym_while_let_expression] = STATE(2625),
    [sym_loop_expression] = STATE(2625),
    [sym_for_expression] = STATE(2625),
    [sym_closure_expression] = STATE(2625),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2625),
    [sym_continue_expression] = STATE(2625),
    [sym_index_expression] = STATE(2625),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2625),
    [sym_block] = STATE(2625),
    [sym__literal] = STATE(2625),
    [sym_string_literal] = STATE(2625),
    [sym_boolean_literal] = STATE(2625),
    [sym_raw_string_literal] = ACTIONS(5774),
    [sym_float_literal] = ACTIONS(5774),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(5774),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(5774),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [2025] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(5776),
    [sym_line_comment] = ACTIONS(7),
  },
  [2026] = {
    [sym_raw_string_literal] = ACTIONS(5778),
    [sym_float_literal] = ACTIONS(5778),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(5778),
    [anon_sym_SEMI] = ACTIONS(5778),
    [anon_sym_macro_rules_BANG] = ACTIONS(5778),
    [anon_sym_LPAREN] = ACTIONS(5778),
    [anon_sym_LBRACE] = ACTIONS(5778),
    [anon_sym_RBRACE] = ACTIONS(5778),
    [anon_sym_LBRACK] = ACTIONS(5778),
    [anon_sym_PLUS] = ACTIONS(5780),
    [anon_sym_STAR] = ACTIONS(5780),
    [anon_sym_u8] = ACTIONS(5780),
    [anon_sym_i8] = ACTIONS(5780),
    [anon_sym_u16] = ACTIONS(5780),
    [anon_sym_i16] = ACTIONS(5780),
    [anon_sym_u32] = ACTIONS(5780),
    [anon_sym_i32] = ACTIONS(5780),
    [anon_sym_u64] = ACTIONS(5780),
    [anon_sym_i64] = ACTIONS(5780),
    [anon_sym_u128] = ACTIONS(5780),
    [anon_sym_i128] = ACTIONS(5780),
    [anon_sym_isize] = ACTIONS(5780),
    [anon_sym_usize] = ACTIONS(5780),
    [anon_sym_f32] = ACTIONS(5780),
    [anon_sym_f64] = ACTIONS(5780),
    [anon_sym_bool] = ACTIONS(5780),
    [anon_sym_str] = ACTIONS(5780),
    [anon_sym_char] = ACTIONS(5780),
    [anon_sym_AMP] = ACTIONS(5780),
    [anon_sym_DASH] = ACTIONS(5780),
    [anon_sym_DOT] = ACTIONS(5780),
    [anon_sym_DASH_EQ] = ACTIONS(5778),
    [anon_sym_COLON_COLON] = ACTIONS(5778),
    [anon_sym_BANG] = ACTIONS(5780),
    [anon_sym_BANG_EQ] = ACTIONS(5778),
    [anon_sym_STAR_EQ] = ACTIONS(5778),
    [anon_sym_SLASH] = ACTIONS(5780),
    [anon_sym_SLASH_EQ] = ACTIONS(5778),
    [anon_sym_AMP_AMP] = ACTIONS(5778),
    [anon_sym_AMP_EQ] = ACTIONS(5778),
    [anon_sym_POUND] = ACTIONS(5778),
    [anon_sym_PERCENT] = ACTIONS(5780),
    [anon_sym_PERCENT_EQ] = ACTIONS(5778),
    [anon_sym_CARET] = ACTIONS(5780),
    [anon_sym_CARET_EQ] = ACTIONS(5778),
    [anon_sym_PLUS_EQ] = ACTIONS(5778),
    [anon_sym_LT] = ACTIONS(5780),
    [anon_sym_LT_LT] = ACTIONS(5780),
    [anon_sym_LT_LT_EQ] = ACTIONS(5778),
    [anon_sym_LT_EQ] = ACTIONS(5778),
    [anon_sym_EQ] = ACTIONS(5780),
    [anon_sym_EQ_EQ] = ACTIONS(5778),
    [anon_sym_GT] = ACTIONS(5780),
    [anon_sym_GT_EQ] = ACTIONS(5778),
    [anon_sym_GT_GT] = ACTIONS(5780),
    [anon_sym_GT_GT_EQ] = ACTIONS(5778),
    [anon_sym_PIPE] = ACTIONS(5780),
    [anon_sym_PIPE_EQ] = ACTIONS(5778),
    [anon_sym_PIPE_PIPE] = ACTIONS(5778),
    [anon_sym_QMARK] = ACTIONS(5778),
    [anon_sym_SQUOTE] = ACTIONS(5780),
    [anon_sym_DOT_DOT] = ACTIONS(5780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5778),
    [anon_sym_as] = ACTIONS(5780),
    [anon_sym_break] = ACTIONS(5780),
    [anon_sym_const] = ACTIONS(5780),
    [anon_sym_continue] = ACTIONS(5780),
    [anon_sym_default] = ACTIONS(5780),
    [anon_sym_enum] = ACTIONS(5780),
    [anon_sym_fn] = ACTIONS(5780),
    [anon_sym_for] = ACTIONS(5780),
    [anon_sym_if] = ACTIONS(5780),
    [anon_sym_impl] = ACTIONS(5780),
    [anon_sym_let] = ACTIONS(5780),
    [anon_sym_loop] = ACTIONS(5780),
    [anon_sym_match] = ACTIONS(5780),
    [anon_sym_mod] = ACTIONS(5780),
    [anon_sym_pub] = ACTIONS(5780),
    [anon_sym_return] = ACTIONS(5780),
    [anon_sym_static] = ACTIONS(5780),
    [anon_sym_struct] = ACTIONS(5780),
    [anon_sym_trait] = ACTIONS(5780),
    [anon_sym_type] = ACTIONS(5780),
    [anon_sym_union] = ACTIONS(5780),
    [anon_sym_unsafe] = ACTIONS(5780),
    [anon_sym_use] = ACTIONS(5780),
    [anon_sym_while] = ACTIONS(5780),
    [anon_sym_extern] = ACTIONS(5780),
    [anon_sym_move] = ACTIONS(5780),
    [sym_integer_literal] = ACTIONS(5778),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5778),
    [sym_char_literal] = ACTIONS(5778),
    [anon_sym_true] = ACTIONS(5780),
    [anon_sym_false] = ACTIONS(5780),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5780),
    [sym_self] = ACTIONS(5780),
    [sym_super] = ACTIONS(5780),
    [sym_crate] = ACTIONS(5780),
    [sym_metavariable] = ACTIONS(5778),
  },
  [2027] = {
    [sym_raw_string_literal] = ACTIONS(4485),
    [sym_float_literal] = ACTIONS(4485),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4485),
    [anon_sym_LPAREN] = ACTIONS(4485),
    [anon_sym_RPAREN] = ACTIONS(4485),
    [anon_sym_LBRACE] = ACTIONS(4485),
    [anon_sym_RBRACE] = ACTIONS(4485),
    [anon_sym_EQ_GT] = ACTIONS(4485),
    [anon_sym_LBRACK] = ACTIONS(4485),
    [anon_sym_RBRACK] = ACTIONS(4485),
    [anon_sym_COLON] = ACTIONS(5782),
    [anon_sym_DOLLAR] = ACTIONS(5782),
    [anon_sym_PLUS] = ACTIONS(5782),
    [anon_sym_STAR] = ACTIONS(5782),
    [anon_sym_COMMA] = ACTIONS(4485),
    [anon_sym_u8] = ACTIONS(5782),
    [anon_sym_i8] = ACTIONS(5782),
    [anon_sym_u16] = ACTIONS(5782),
    [anon_sym_i16] = ACTIONS(5782),
    [anon_sym_u32] = ACTIONS(5782),
    [anon_sym_i32] = ACTIONS(5782),
    [anon_sym_u64] = ACTIONS(5782),
    [anon_sym_i64] = ACTIONS(5782),
    [anon_sym_u128] = ACTIONS(5782),
    [anon_sym_i128] = ACTIONS(5782),
    [anon_sym_isize] = ACTIONS(5782),
    [anon_sym_usize] = ACTIONS(5782),
    [anon_sym_f32] = ACTIONS(5782),
    [anon_sym_f64] = ACTIONS(5782),
    [anon_sym_bool] = ACTIONS(5782),
    [anon_sym_str] = ACTIONS(5782),
    [anon_sym_char] = ACTIONS(5782),
    [anon_sym__] = ACTIONS(5782),
    [anon_sym_AMP] = ACTIONS(5782),
    [anon_sym_DASH] = ACTIONS(5782),
    [anon_sym_DOT] = ACTIONS(5782),
    [anon_sym_DASH_EQ] = ACTIONS(4485),
    [anon_sym_DASH_GT] = ACTIONS(4485),
    [anon_sym_COLON_COLON] = ACTIONS(4485),
    [anon_sym_BANG] = ACTIONS(5782),
    [anon_sym_BANG_EQ] = ACTIONS(4485),
    [anon_sym_AT] = ACTIONS(4485),
    [anon_sym_STAR_EQ] = ACTIONS(4485),
    [anon_sym_SLASH] = ACTIONS(5782),
    [anon_sym_SLASH_EQ] = ACTIONS(4485),
    [anon_sym_AMP_AMP] = ACTIONS(4485),
    [anon_sym_AMP_EQ] = ACTIONS(4485),
    [anon_sym_POUND] = ACTIONS(4485),
    [anon_sym_PERCENT] = ACTIONS(5782),
    [anon_sym_PERCENT_EQ] = ACTIONS(4485),
    [anon_sym_CARET] = ACTIONS(5782),
    [anon_sym_CARET_EQ] = ACTIONS(4485),
    [anon_sym_PLUS_EQ] = ACTIONS(4485),
    [anon_sym_LT] = ACTIONS(5782),
    [anon_sym_LT_LT] = ACTIONS(5782),
    [anon_sym_LT_LT_EQ] = ACTIONS(4485),
    [anon_sym_LT_EQ] = ACTIONS(4485),
    [anon_sym_EQ] = ACTIONS(5782),
    [anon_sym_EQ_EQ] = ACTIONS(4485),
    [anon_sym_GT] = ACTIONS(5782),
    [anon_sym_GT_EQ] = ACTIONS(4485),
    [anon_sym_GT_GT] = ACTIONS(5782),
    [anon_sym_GT_GT_EQ] = ACTIONS(4485),
    [anon_sym_PIPE] = ACTIONS(5782),
    [anon_sym_PIPE_EQ] = ACTIONS(4485),
    [anon_sym_PIPE_PIPE] = ACTIONS(4485),
    [anon_sym_TILDE] = ACTIONS(4485),
    [anon_sym_QMARK] = ACTIONS(4485),
    [anon_sym_SQUOTE] = ACTIONS(5782),
    [anon_sym_DOT_DOT] = ACTIONS(5782),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4485),
    [anon_sym_as] = ACTIONS(5782),
    [anon_sym_break] = ACTIONS(5782),
    [anon_sym_const] = ACTIONS(5782),
    [anon_sym_continue] = ACTIONS(5782),
    [anon_sym_default] = ACTIONS(5782),
    [anon_sym_enum] = ACTIONS(5782),
    [anon_sym_fn] = ACTIONS(5782),
    [anon_sym_for] = ACTIONS(5782),
    [anon_sym_if] = ACTIONS(5782),
    [anon_sym_impl] = ACTIONS(5782),
    [anon_sym_let] = ACTIONS(5782),
    [anon_sym_loop] = ACTIONS(5782),
    [anon_sym_match] = ACTIONS(5782),
    [anon_sym_mod] = ACTIONS(5782),
    [anon_sym_pub] = ACTIONS(5782),
    [anon_sym_return] = ACTIONS(5782),
    [anon_sym_static] = ACTIONS(5782),
    [anon_sym_struct] = ACTIONS(5782),
    [anon_sym_trait] = ACTIONS(5782),
    [anon_sym_type] = ACTIONS(5782),
    [anon_sym_union] = ACTIONS(5782),
    [anon_sym_unsafe] = ACTIONS(5782),
    [anon_sym_use] = ACTIONS(5782),
    [anon_sym_where] = ACTIONS(5782),
    [anon_sym_while] = ACTIONS(5782),
    [sym_mutable_specifier] = ACTIONS(5782),
    [sym_integer_literal] = ACTIONS(4485),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(4485),
    [sym_char_literal] = ACTIONS(4485),
    [anon_sym_true] = ACTIONS(5782),
    [anon_sym_false] = ACTIONS(5782),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5782),
    [sym_self] = ACTIONS(5782),
    [sym_super] = ACTIONS(5782),
    [sym_crate] = ACTIONS(5782),
    [sym_metavariable] = ACTIONS(4485),
  },
  [2028] = {
    [sym__token_pattern] = STATE(2034),
    [sym_token_tree_pattern] = STATE(2034),
    [sym_token_binding_pattern] = STATE(2034),
    [sym_token_repetition_pattern] = STATE(2034),
    [sym__literal] = STATE(2034),
    [sym_string_literal] = STATE(2034),
    [sym_boolean_literal] = STATE(2034),
    [aux_sym_token_tree_pattern_repeat1] = STATE(2034),
    [sym_raw_string_literal] = ACTIONS(4507),
    [sym_float_literal] = ACTIONS(4507),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4507),
    [anon_sym_LPAREN] = ACTIONS(2681),
    [anon_sym_RPAREN] = ACTIONS(5784),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_EQ_GT] = ACTIONS(4507),
    [anon_sym_LBRACK] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(4511),
    [anon_sym_DOLLAR] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(4511),
    [anon_sym_STAR] = ACTIONS(4511),
    [anon_sym_COMMA] = ACTIONS(4507),
    [anon_sym_u8] = ACTIONS(2693),
    [anon_sym_i8] = ACTIONS(2693),
    [anon_sym_u16] = ACTIONS(2693),
    [anon_sym_i16] = ACTIONS(2693),
    [anon_sym_u32] = ACTIONS(2693),
    [anon_sym_i32] = ACTIONS(2693),
    [anon_sym_u64] = ACTIONS(2693),
    [anon_sym_i64] = ACTIONS(2693),
    [anon_sym_u128] = ACTIONS(2693),
    [anon_sym_i128] = ACTIONS(2693),
    [anon_sym_isize] = ACTIONS(2693),
    [anon_sym_usize] = ACTIONS(2693),
    [anon_sym_f32] = ACTIONS(2693),
    [anon_sym_f64] = ACTIONS(2693),
    [anon_sym_bool] = ACTIONS(2693),
    [anon_sym_str] = ACTIONS(2693),
    [anon_sym_char] = ACTIONS(2693),
    [anon_sym__] = ACTIONS(4511),
    [anon_sym_AMP] = ACTIONS(4511),
    [anon_sym_DASH] = ACTIONS(4511),
    [anon_sym_DOT] = ACTIONS(4511),
    [anon_sym_DASH_EQ] = ACTIONS(4507),
    [anon_sym_DASH_GT] = ACTIONS(4507),
    [anon_sym_COLON_COLON] = ACTIONS(4507),
    [anon_sym_BANG] = ACTIONS(4511),
    [anon_sym_BANG_EQ] = ACTIONS(4507),
    [anon_sym_AT] = ACTIONS(4507),
    [anon_sym_STAR_EQ] = ACTIONS(4507),
    [anon_sym_SLASH] = ACTIONS(4511),
    [anon_sym_SLASH_EQ] = ACTIONS(4507),
    [anon_sym_AMP_AMP] = ACTIONS(4507),
    [anon_sym_AMP_EQ] = ACTIONS(4507),
    [anon_sym_POUND] = ACTIONS(4507),
    [anon_sym_PERCENT] = ACTIONS(4511),
    [anon_sym_PERCENT_EQ] = ACTIONS(4507),
    [anon_sym_CARET] = ACTIONS(4511),
    [anon_sym_CARET_EQ] = ACTIONS(4507),
    [anon_sym_PLUS_EQ] = ACTIONS(4507),
    [anon_sym_LT] = ACTIONS(4511),
    [anon_sym_LT_LT] = ACTIONS(4511),
    [anon_sym_LT_LT_EQ] = ACTIONS(4507),
    [anon_sym_LT_EQ] = ACTIONS(4507),
    [anon_sym_EQ] = ACTIONS(4511),
    [anon_sym_EQ_EQ] = ACTIONS(4507),
    [anon_sym_GT] = ACTIONS(4511),
    [anon_sym_GT_EQ] = ACTIONS(4507),
    [anon_sym_GT_GT] = ACTIONS(4511),
    [anon_sym_GT_GT_EQ] = ACTIONS(4507),
    [anon_sym_PIPE] = ACTIONS(4511),
    [anon_sym_PIPE_EQ] = ACTIONS(4507),
    [anon_sym_PIPE_PIPE] = ACTIONS(4507),
    [anon_sym_TILDE] = ACTIONS(4507),
    [anon_sym_QMARK] = ACTIONS(4507),
    [anon_sym_SQUOTE] = ACTIONS(4511),
    [anon_sym_DOT_DOT] = ACTIONS(4511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4507),
    [anon_sym_as] = ACTIONS(4511),
    [anon_sym_break] = ACTIONS(4511),
    [anon_sym_const] = ACTIONS(4511),
    [anon_sym_continue] = ACTIONS(4511),
    [anon_sym_default] = ACTIONS(4511),
    [anon_sym_enum] = ACTIONS(4511),
    [anon_sym_fn] = ACTIONS(4511),
    [anon_sym_for] = ACTIONS(4511),
    [anon_sym_if] = ACTIONS(4511),
    [anon_sym_impl] = ACTIONS(4511),
    [anon_sym_let] = ACTIONS(4511),
    [anon_sym_loop] = ACTIONS(4511),
    [anon_sym_match] = ACTIONS(4511),
    [anon_sym_mod] = ACTIONS(4511),
    [anon_sym_pub] = ACTIONS(4511),
    [anon_sym_return] = ACTIONS(4511),
    [anon_sym_static] = ACTIONS(4511),
    [anon_sym_struct] = ACTIONS(4511),
    [anon_sym_trait] = ACTIONS(4511),
    [anon_sym_type] = ACTIONS(4511),
    [anon_sym_union] = ACTIONS(4511),
    [anon_sym_unsafe] = ACTIONS(4511),
    [anon_sym_use] = ACTIONS(4511),
    [anon_sym_where] = ACTIONS(4511),
    [anon_sym_while] = ACTIONS(4511),
    [sym_mutable_specifier] = ACTIONS(4511),
    [sym_integer_literal] = ACTIONS(4507),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(4507),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4511),
    [sym_self] = ACTIONS(4511),
    [sym_super] = ACTIONS(4511),
    [sym_crate] = ACTIONS(4511),
    [sym_metavariable] = ACTIONS(2695),
  },
  [2029] = {
    [sym__token_pattern] = STATE(2035),
    [sym_token_tree_pattern] = STATE(2035),
    [sym_token_binding_pattern] = STATE(2035),
    [sym_token_repetition_pattern] = STATE(2035),
    [sym__literal] = STATE(2035),
    [sym_string_literal] = STATE(2035),
    [sym_boolean_literal] = STATE(2035),
    [aux_sym_token_tree_pattern_repeat1] = STATE(2035),
    [sym_raw_string_literal] = ACTIONS(4517),
    [sym_float_literal] = ACTIONS(4517),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4517),
    [anon_sym_LPAREN] = ACTIONS(2681),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_RBRACE] = ACTIONS(5784),
    [anon_sym_EQ_GT] = ACTIONS(4517),
    [anon_sym_LBRACK] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(4519),
    [anon_sym_DOLLAR] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(4519),
    [anon_sym_STAR] = ACTIONS(4519),
    [anon_sym_COMMA] = ACTIONS(4517),
    [anon_sym_u8] = ACTIONS(2693),
    [anon_sym_i8] = ACTIONS(2693),
    [anon_sym_u16] = ACTIONS(2693),
    [anon_sym_i16] = ACTIONS(2693),
    [anon_sym_u32] = ACTIONS(2693),
    [anon_sym_i32] = ACTIONS(2693),
    [anon_sym_u64] = ACTIONS(2693),
    [anon_sym_i64] = ACTIONS(2693),
    [anon_sym_u128] = ACTIONS(2693),
    [anon_sym_i128] = ACTIONS(2693),
    [anon_sym_isize] = ACTIONS(2693),
    [anon_sym_usize] = ACTIONS(2693),
    [anon_sym_f32] = ACTIONS(2693),
    [anon_sym_f64] = ACTIONS(2693),
    [anon_sym_bool] = ACTIONS(2693),
    [anon_sym_str] = ACTIONS(2693),
    [anon_sym_char] = ACTIONS(2693),
    [anon_sym__] = ACTIONS(4519),
    [anon_sym_AMP] = ACTIONS(4519),
    [anon_sym_DASH] = ACTIONS(4519),
    [anon_sym_DOT] = ACTIONS(4519),
    [anon_sym_DASH_EQ] = ACTIONS(4517),
    [anon_sym_DASH_GT] = ACTIONS(4517),
    [anon_sym_COLON_COLON] = ACTIONS(4517),
    [anon_sym_BANG] = ACTIONS(4519),
    [anon_sym_BANG_EQ] = ACTIONS(4517),
    [anon_sym_AT] = ACTIONS(4517),
    [anon_sym_STAR_EQ] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(4519),
    [anon_sym_SLASH_EQ] = ACTIONS(4517),
    [anon_sym_AMP_AMP] = ACTIONS(4517),
    [anon_sym_AMP_EQ] = ACTIONS(4517),
    [anon_sym_POUND] = ACTIONS(4517),
    [anon_sym_PERCENT] = ACTIONS(4519),
    [anon_sym_PERCENT_EQ] = ACTIONS(4517),
    [anon_sym_CARET] = ACTIONS(4519),
    [anon_sym_CARET_EQ] = ACTIONS(4517),
    [anon_sym_PLUS_EQ] = ACTIONS(4517),
    [anon_sym_LT] = ACTIONS(4519),
    [anon_sym_LT_LT] = ACTIONS(4519),
    [anon_sym_LT_LT_EQ] = ACTIONS(4517),
    [anon_sym_LT_EQ] = ACTIONS(4517),
    [anon_sym_EQ] = ACTIONS(4519),
    [anon_sym_EQ_EQ] = ACTIONS(4517),
    [anon_sym_GT] = ACTIONS(4519),
    [anon_sym_GT_EQ] = ACTIONS(4517),
    [anon_sym_GT_GT] = ACTIONS(4519),
    [anon_sym_GT_GT_EQ] = ACTIONS(4517),
    [anon_sym_PIPE] = ACTIONS(4519),
    [anon_sym_PIPE_EQ] = ACTIONS(4517),
    [anon_sym_PIPE_PIPE] = ACTIONS(4517),
    [anon_sym_TILDE] = ACTIONS(4517),
    [anon_sym_QMARK] = ACTIONS(4517),
    [anon_sym_SQUOTE] = ACTIONS(4519),
    [anon_sym_DOT_DOT] = ACTIONS(4519),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4517),
    [anon_sym_as] = ACTIONS(4519),
    [anon_sym_break] = ACTIONS(4519),
    [anon_sym_const] = ACTIONS(4519),
    [anon_sym_continue] = ACTIONS(4519),
    [anon_sym_default] = ACTIONS(4519),
    [anon_sym_enum] = ACTIONS(4519),
    [anon_sym_fn] = ACTIONS(4519),
    [anon_sym_for] = ACTIONS(4519),
    [anon_sym_if] = ACTIONS(4519),
    [anon_sym_impl] = ACTIONS(4519),
    [anon_sym_let] = ACTIONS(4519),
    [anon_sym_loop] = ACTIONS(4519),
    [anon_sym_match] = ACTIONS(4519),
    [anon_sym_mod] = ACTIONS(4519),
    [anon_sym_pub] = ACTIONS(4519),
    [anon_sym_return] = ACTIONS(4519),
    [anon_sym_static] = ACTIONS(4519),
    [anon_sym_struct] = ACTIONS(4519),
    [anon_sym_trait] = ACTIONS(4519),
    [anon_sym_type] = ACTIONS(4519),
    [anon_sym_union] = ACTIONS(4519),
    [anon_sym_unsafe] = ACTIONS(4519),
    [anon_sym_use] = ACTIONS(4519),
    [anon_sym_where] = ACTIONS(4519),
    [anon_sym_while] = ACTIONS(4519),
    [sym_mutable_specifier] = ACTIONS(4519),
    [sym_integer_literal] = ACTIONS(4517),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(4517),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4519),
    [sym_self] = ACTIONS(4519),
    [sym_super] = ACTIONS(4519),
    [sym_crate] = ACTIONS(4519),
    [sym_metavariable] = ACTIONS(2695),
  },
  [2030] = {
    [sym__token_pattern] = STATE(2036),
    [sym_token_tree_pattern] = STATE(2036),
    [sym_token_binding_pattern] = STATE(2036),
    [sym_token_repetition_pattern] = STATE(2036),
    [sym__literal] = STATE(2036),
    [sym_string_literal] = STATE(2036),
    [sym_boolean_literal] = STATE(2036),
    [aux_sym_token_tree_pattern_repeat1] = STATE(2036),
    [sym_raw_string_literal] = ACTIONS(4521),
    [sym_float_literal] = ACTIONS(4521),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4521),
    [anon_sym_LPAREN] = ACTIONS(2681),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_EQ_GT] = ACTIONS(4521),
    [anon_sym_LBRACK] = ACTIONS(2687),
    [anon_sym_RBRACK] = ACTIONS(5784),
    [anon_sym_COLON] = ACTIONS(4523),
    [anon_sym_DOLLAR] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(4523),
    [anon_sym_STAR] = ACTIONS(4523),
    [anon_sym_COMMA] = ACTIONS(4521),
    [anon_sym_u8] = ACTIONS(2693),
    [anon_sym_i8] = ACTIONS(2693),
    [anon_sym_u16] = ACTIONS(2693),
    [anon_sym_i16] = ACTIONS(2693),
    [anon_sym_u32] = ACTIONS(2693),
    [anon_sym_i32] = ACTIONS(2693),
    [anon_sym_u64] = ACTIONS(2693),
    [anon_sym_i64] = ACTIONS(2693),
    [anon_sym_u128] = ACTIONS(2693),
    [anon_sym_i128] = ACTIONS(2693),
    [anon_sym_isize] = ACTIONS(2693),
    [anon_sym_usize] = ACTIONS(2693),
    [anon_sym_f32] = ACTIONS(2693),
    [anon_sym_f64] = ACTIONS(2693),
    [anon_sym_bool] = ACTIONS(2693),
    [anon_sym_str] = ACTIONS(2693),
    [anon_sym_char] = ACTIONS(2693),
    [anon_sym__] = ACTIONS(4523),
    [anon_sym_AMP] = ACTIONS(4523),
    [anon_sym_DASH] = ACTIONS(4523),
    [anon_sym_DOT] = ACTIONS(4523),
    [anon_sym_DASH_EQ] = ACTIONS(4521),
    [anon_sym_DASH_GT] = ACTIONS(4521),
    [anon_sym_COLON_COLON] = ACTIONS(4521),
    [anon_sym_BANG] = ACTIONS(4523),
    [anon_sym_BANG_EQ] = ACTIONS(4521),
    [anon_sym_AT] = ACTIONS(4521),
    [anon_sym_STAR_EQ] = ACTIONS(4521),
    [anon_sym_SLASH] = ACTIONS(4523),
    [anon_sym_SLASH_EQ] = ACTIONS(4521),
    [anon_sym_AMP_AMP] = ACTIONS(4521),
    [anon_sym_AMP_EQ] = ACTIONS(4521),
    [anon_sym_POUND] = ACTIONS(4521),
    [anon_sym_PERCENT] = ACTIONS(4523),
    [anon_sym_PERCENT_EQ] = ACTIONS(4521),
    [anon_sym_CARET] = ACTIONS(4523),
    [anon_sym_CARET_EQ] = ACTIONS(4521),
    [anon_sym_PLUS_EQ] = ACTIONS(4521),
    [anon_sym_LT] = ACTIONS(4523),
    [anon_sym_LT_LT] = ACTIONS(4523),
    [anon_sym_LT_LT_EQ] = ACTIONS(4521),
    [anon_sym_LT_EQ] = ACTIONS(4521),
    [anon_sym_EQ] = ACTIONS(4523),
    [anon_sym_EQ_EQ] = ACTIONS(4521),
    [anon_sym_GT] = ACTIONS(4523),
    [anon_sym_GT_EQ] = ACTIONS(4521),
    [anon_sym_GT_GT] = ACTIONS(4523),
    [anon_sym_GT_GT_EQ] = ACTIONS(4521),
    [anon_sym_PIPE] = ACTIONS(4523),
    [anon_sym_PIPE_EQ] = ACTIONS(4521),
    [anon_sym_PIPE_PIPE] = ACTIONS(4521),
    [anon_sym_TILDE] = ACTIONS(4521),
    [anon_sym_QMARK] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4523),
    [anon_sym_DOT_DOT] = ACTIONS(4523),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4521),
    [anon_sym_as] = ACTIONS(4523),
    [anon_sym_break] = ACTIONS(4523),
    [anon_sym_const] = ACTIONS(4523),
    [anon_sym_continue] = ACTIONS(4523),
    [anon_sym_default] = ACTIONS(4523),
    [anon_sym_enum] = ACTIONS(4523),
    [anon_sym_fn] = ACTIONS(4523),
    [anon_sym_for] = ACTIONS(4523),
    [anon_sym_if] = ACTIONS(4523),
    [anon_sym_impl] = ACTIONS(4523),
    [anon_sym_let] = ACTIONS(4523),
    [anon_sym_loop] = ACTIONS(4523),
    [anon_sym_match] = ACTIONS(4523),
    [anon_sym_mod] = ACTIONS(4523),
    [anon_sym_pub] = ACTIONS(4523),
    [anon_sym_return] = ACTIONS(4523),
    [anon_sym_static] = ACTIONS(4523),
    [anon_sym_struct] = ACTIONS(4523),
    [anon_sym_trait] = ACTIONS(4523),
    [anon_sym_type] = ACTIONS(4523),
    [anon_sym_union] = ACTIONS(4523),
    [anon_sym_unsafe] = ACTIONS(4523),
    [anon_sym_use] = ACTIONS(4523),
    [anon_sym_where] = ACTIONS(4523),
    [anon_sym_while] = ACTIONS(4523),
    [sym_mutable_specifier] = ACTIONS(4523),
    [sym_integer_literal] = ACTIONS(4521),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(4521),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4523),
    [sym_self] = ACTIONS(4523),
    [sym_super] = ACTIONS(4523),
    [sym_crate] = ACTIONS(4523),
    [sym_metavariable] = ACTIONS(2695),
  },
  [2031] = {
    [sym__token_pattern] = STATE(2629),
    [sym_token_tree_pattern] = STATE(2629),
    [sym_token_binding_pattern] = STATE(2629),
    [sym_token_repetition_pattern] = STATE(2629),
    [sym__literal] = STATE(2629),
    [sym_string_literal] = STATE(2629),
    [sym_boolean_literal] = STATE(2629),
    [aux_sym_token_tree_pattern_repeat1] = STATE(2629),
    [sym_raw_string_literal] = ACTIONS(5786),
    [sym_float_literal] = ACTIONS(5786),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5786),
    [anon_sym_LPAREN] = ACTIONS(2681),
    [anon_sym_RPAREN] = ACTIONS(5788),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_EQ_GT] = ACTIONS(5786),
    [anon_sym_LBRACK] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(5790),
    [anon_sym_DOLLAR] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(5790),
    [anon_sym_STAR] = ACTIONS(5790),
    [anon_sym_COMMA] = ACTIONS(5786),
    [anon_sym_u8] = ACTIONS(2693),
    [anon_sym_i8] = ACTIONS(2693),
    [anon_sym_u16] = ACTIONS(2693),
    [anon_sym_i16] = ACTIONS(2693),
    [anon_sym_u32] = ACTIONS(2693),
    [anon_sym_i32] = ACTIONS(2693),
    [anon_sym_u64] = ACTIONS(2693),
    [anon_sym_i64] = ACTIONS(2693),
    [anon_sym_u128] = ACTIONS(2693),
    [anon_sym_i128] = ACTIONS(2693),
    [anon_sym_isize] = ACTIONS(2693),
    [anon_sym_usize] = ACTIONS(2693),
    [anon_sym_f32] = ACTIONS(2693),
    [anon_sym_f64] = ACTIONS(2693),
    [anon_sym_bool] = ACTIONS(2693),
    [anon_sym_str] = ACTIONS(2693),
    [anon_sym_char] = ACTIONS(2693),
    [anon_sym__] = ACTIONS(5790),
    [anon_sym_AMP] = ACTIONS(5790),
    [anon_sym_DASH] = ACTIONS(5790),
    [anon_sym_DOT] = ACTIONS(5790),
    [anon_sym_DASH_EQ] = ACTIONS(5786),
    [anon_sym_DASH_GT] = ACTIONS(5786),
    [anon_sym_COLON_COLON] = ACTIONS(5786),
    [anon_sym_BANG] = ACTIONS(5790),
    [anon_sym_BANG_EQ] = ACTIONS(5786),
    [anon_sym_AT] = ACTIONS(5786),
    [anon_sym_STAR_EQ] = ACTIONS(5786),
    [anon_sym_SLASH] = ACTIONS(5790),
    [anon_sym_SLASH_EQ] = ACTIONS(5786),
    [anon_sym_AMP_AMP] = ACTIONS(5786),
    [anon_sym_AMP_EQ] = ACTIONS(5786),
    [anon_sym_POUND] = ACTIONS(5786),
    [anon_sym_PERCENT] = ACTIONS(5790),
    [anon_sym_PERCENT_EQ] = ACTIONS(5786),
    [anon_sym_CARET] = ACTIONS(5790),
    [anon_sym_CARET_EQ] = ACTIONS(5786),
    [anon_sym_PLUS_EQ] = ACTIONS(5786),
    [anon_sym_LT] = ACTIONS(5790),
    [anon_sym_LT_LT] = ACTIONS(5790),
    [anon_sym_LT_LT_EQ] = ACTIONS(5786),
    [anon_sym_LT_EQ] = ACTIONS(5786),
    [anon_sym_EQ] = ACTIONS(5790),
    [anon_sym_EQ_EQ] = ACTIONS(5786),
    [anon_sym_GT] = ACTIONS(5790),
    [anon_sym_GT_EQ] = ACTIONS(5786),
    [anon_sym_GT_GT] = ACTIONS(5790),
    [anon_sym_GT_GT_EQ] = ACTIONS(5786),
    [anon_sym_PIPE] = ACTIONS(5790),
    [anon_sym_PIPE_EQ] = ACTIONS(5786),
    [anon_sym_PIPE_PIPE] = ACTIONS(5786),
    [anon_sym_TILDE] = ACTIONS(5786),
    [anon_sym_QMARK] = ACTIONS(5786),
    [anon_sym_SQUOTE] = ACTIONS(5790),
    [anon_sym_DOT_DOT] = ACTIONS(5790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5786),
    [anon_sym_as] = ACTIONS(5790),
    [anon_sym_break] = ACTIONS(5790),
    [anon_sym_const] = ACTIONS(5790),
    [anon_sym_continue] = ACTIONS(5790),
    [anon_sym_default] = ACTIONS(5790),
    [anon_sym_enum] = ACTIONS(5790),
    [anon_sym_fn] = ACTIONS(5790),
    [anon_sym_for] = ACTIONS(5790),
    [anon_sym_if] = ACTIONS(5790),
    [anon_sym_impl] = ACTIONS(5790),
    [anon_sym_let] = ACTIONS(5790),
    [anon_sym_loop] = ACTIONS(5790),
    [anon_sym_match] = ACTIONS(5790),
    [anon_sym_mod] = ACTIONS(5790),
    [anon_sym_pub] = ACTIONS(5790),
    [anon_sym_return] = ACTIONS(5790),
    [anon_sym_static] = ACTIONS(5790),
    [anon_sym_struct] = ACTIONS(5790),
    [anon_sym_trait] = ACTIONS(5790),
    [anon_sym_type] = ACTIONS(5790),
    [anon_sym_union] = ACTIONS(5790),
    [anon_sym_unsafe] = ACTIONS(5790),
    [anon_sym_use] = ACTIONS(5790),
    [anon_sym_where] = ACTIONS(5790),
    [anon_sym_while] = ACTIONS(5790),
    [sym_mutable_specifier] = ACTIONS(5790),
    [sym_integer_literal] = ACTIONS(5786),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(5786),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5790),
    [sym_self] = ACTIONS(5790),
    [sym_super] = ACTIONS(5790),
    [sym_crate] = ACTIONS(5790),
    [sym_metavariable] = ACTIONS(2695),
  },
  [2032] = {
    [sym_fragment_specifier] = STATE(2631),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_ident] = ACTIONS(5792),
    [anon_sym_path] = ACTIONS(5792),
    [anon_sym_expr] = ACTIONS(5792),
    [anon_sym_ty] = ACTIONS(5792),
    [anon_sym_pat] = ACTIONS(5794),
    [anon_sym_stmt] = ACTIONS(5792),
    [anon_sym_block] = ACTIONS(5792),
    [anon_sym_item] = ACTIONS(5792),
    [anon_sym_meta] = ACTIONS(5792),
    [anon_sym_tt] = ACTIONS(5792),
    [sym_line_comment] = ACTIONS(7),
  },
  [2033] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(5796),
    [sym_line_comment] = ACTIONS(7),
  },
  [2034] = {
    [sym__token_pattern] = STATE(2034),
    [sym_token_tree_pattern] = STATE(2034),
    [sym_token_binding_pattern] = STATE(2034),
    [sym_token_repetition_pattern] = STATE(2034),
    [sym__literal] = STATE(2034),
    [sym_string_literal] = STATE(2034),
    [sym_boolean_literal] = STATE(2034),
    [aux_sym_token_tree_pattern_repeat1] = STATE(2034),
    [sym_raw_string_literal] = ACTIONS(5798),
    [sym_float_literal] = ACTIONS(5798),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_LPAREN] = ACTIONS(5801),
    [anon_sym_RPAREN] = ACTIONS(5804),
    [anon_sym_LBRACE] = ACTIONS(5806),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5809),
    [anon_sym_COLON] = ACTIONS(5812),
    [anon_sym_DOLLAR] = ACTIONS(5815),
    [anon_sym_PLUS] = ACTIONS(5812),
    [anon_sym_STAR] = ACTIONS(5812),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_u8] = ACTIONS(5818),
    [anon_sym_i8] = ACTIONS(5818),
    [anon_sym_u16] = ACTIONS(5818),
    [anon_sym_i16] = ACTIONS(5818),
    [anon_sym_u32] = ACTIONS(5818),
    [anon_sym_i32] = ACTIONS(5818),
    [anon_sym_u64] = ACTIONS(5818),
    [anon_sym_i64] = ACTIONS(5818),
    [anon_sym_u128] = ACTIONS(5818),
    [anon_sym_i128] = ACTIONS(5818),
    [anon_sym_isize] = ACTIONS(5818),
    [anon_sym_usize] = ACTIONS(5818),
    [anon_sym_f32] = ACTIONS(5818),
    [anon_sym_f64] = ACTIONS(5818),
    [anon_sym_bool] = ACTIONS(5818),
    [anon_sym_str] = ACTIONS(5818),
    [anon_sym_char] = ACTIONS(5818),
    [anon_sym__] = ACTIONS(5812),
    [anon_sym_AMP] = ACTIONS(5812),
    [anon_sym_DASH] = ACTIONS(5812),
    [anon_sym_DOT] = ACTIONS(5812),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_DASH_GT] = ACTIONS(5798),
    [anon_sym_COLON_COLON] = ACTIONS(5798),
    [anon_sym_BANG] = ACTIONS(5812),
    [anon_sym_BANG_EQ] = ACTIONS(5798),
    [anon_sym_AT] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH] = ACTIONS(5812),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_POUND] = ACTIONS(5798),
    [anon_sym_PERCENT] = ACTIONS(5812),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_CARET] = ACTIONS(5812),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_LT] = ACTIONS(5812),
    [anon_sym_LT_LT] = ACTIONS(5812),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_LT_EQ] = ACTIONS(5798),
    [anon_sym_EQ] = ACTIONS(5812),
    [anon_sym_EQ_EQ] = ACTIONS(5798),
    [anon_sym_GT] = ACTIONS(5812),
    [anon_sym_GT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT] = ACTIONS(5812),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(5812),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(5798),
    [anon_sym_TILDE] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_SQUOTE] = ACTIONS(5812),
    [anon_sym_DOT_DOT] = ACTIONS(5812),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5798),
    [anon_sym_as] = ACTIONS(5812),
    [anon_sym_break] = ACTIONS(5812),
    [anon_sym_const] = ACTIONS(5812),
    [anon_sym_continue] = ACTIONS(5812),
    [anon_sym_default] = ACTIONS(5812),
    [anon_sym_enum] = ACTIONS(5812),
    [anon_sym_fn] = ACTIONS(5812),
    [anon_sym_for] = ACTIONS(5812),
    [anon_sym_if] = ACTIONS(5812),
    [anon_sym_impl] = ACTIONS(5812),
    [anon_sym_let] = ACTIONS(5812),
    [anon_sym_loop] = ACTIONS(5812),
    [anon_sym_match] = ACTIONS(5812),
    [anon_sym_mod] = ACTIONS(5812),
    [anon_sym_pub] = ACTIONS(5812),
    [anon_sym_return] = ACTIONS(5812),
    [anon_sym_static] = ACTIONS(5812),
    [anon_sym_struct] = ACTIONS(5812),
    [anon_sym_trait] = ACTIONS(5812),
    [anon_sym_type] = ACTIONS(5812),
    [anon_sym_union] = ACTIONS(5812),
    [anon_sym_unsafe] = ACTIONS(5812),
    [anon_sym_use] = ACTIONS(5812),
    [anon_sym_where] = ACTIONS(5812),
    [anon_sym_while] = ACTIONS(5812),
    [sym_mutable_specifier] = ACTIONS(5812),
    [sym_integer_literal] = ACTIONS(5798),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5821),
    [sym_char_literal] = ACTIONS(5798),
    [anon_sym_true] = ACTIONS(5824),
    [anon_sym_false] = ACTIONS(5824),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5812),
    [sym_self] = ACTIONS(5812),
    [sym_super] = ACTIONS(5812),
    [sym_crate] = ACTIONS(5812),
    [sym_metavariable] = ACTIONS(5827),
  },
  [2035] = {
    [sym__token_pattern] = STATE(2035),
    [sym_token_tree_pattern] = STATE(2035),
    [sym_token_binding_pattern] = STATE(2035),
    [sym_token_repetition_pattern] = STATE(2035),
    [sym__literal] = STATE(2035),
    [sym_string_literal] = STATE(2035),
    [sym_boolean_literal] = STATE(2035),
    [aux_sym_token_tree_pattern_repeat1] = STATE(2035),
    [sym_raw_string_literal] = ACTIONS(5830),
    [sym_float_literal] = ACTIONS(5830),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5830),
    [anon_sym_LPAREN] = ACTIONS(5801),
    [anon_sym_LBRACE] = ACTIONS(5806),
    [anon_sym_RBRACE] = ACTIONS(5804),
    [anon_sym_EQ_GT] = ACTIONS(5830),
    [anon_sym_LBRACK] = ACTIONS(5809),
    [anon_sym_COLON] = ACTIONS(5833),
    [anon_sym_DOLLAR] = ACTIONS(5815),
    [anon_sym_PLUS] = ACTIONS(5833),
    [anon_sym_STAR] = ACTIONS(5833),
    [anon_sym_COMMA] = ACTIONS(5830),
    [anon_sym_u8] = ACTIONS(5818),
    [anon_sym_i8] = ACTIONS(5818),
    [anon_sym_u16] = ACTIONS(5818),
    [anon_sym_i16] = ACTIONS(5818),
    [anon_sym_u32] = ACTIONS(5818),
    [anon_sym_i32] = ACTIONS(5818),
    [anon_sym_u64] = ACTIONS(5818),
    [anon_sym_i64] = ACTIONS(5818),
    [anon_sym_u128] = ACTIONS(5818),
    [anon_sym_i128] = ACTIONS(5818),
    [anon_sym_isize] = ACTIONS(5818),
    [anon_sym_usize] = ACTIONS(5818),
    [anon_sym_f32] = ACTIONS(5818),
    [anon_sym_f64] = ACTIONS(5818),
    [anon_sym_bool] = ACTIONS(5818),
    [anon_sym_str] = ACTIONS(5818),
    [anon_sym_char] = ACTIONS(5818),
    [anon_sym__] = ACTIONS(5833),
    [anon_sym_AMP] = ACTIONS(5833),
    [anon_sym_DASH] = ACTIONS(5833),
    [anon_sym_DOT] = ACTIONS(5833),
    [anon_sym_DASH_EQ] = ACTIONS(5830),
    [anon_sym_DASH_GT] = ACTIONS(5830),
    [anon_sym_COLON_COLON] = ACTIONS(5830),
    [anon_sym_BANG] = ACTIONS(5833),
    [anon_sym_BANG_EQ] = ACTIONS(5830),
    [anon_sym_AT] = ACTIONS(5830),
    [anon_sym_STAR_EQ] = ACTIONS(5830),
    [anon_sym_SLASH] = ACTIONS(5833),
    [anon_sym_SLASH_EQ] = ACTIONS(5830),
    [anon_sym_AMP_AMP] = ACTIONS(5830),
    [anon_sym_AMP_EQ] = ACTIONS(5830),
    [anon_sym_POUND] = ACTIONS(5830),
    [anon_sym_PERCENT] = ACTIONS(5833),
    [anon_sym_PERCENT_EQ] = ACTIONS(5830),
    [anon_sym_CARET] = ACTIONS(5833),
    [anon_sym_CARET_EQ] = ACTIONS(5830),
    [anon_sym_PLUS_EQ] = ACTIONS(5830),
    [anon_sym_LT] = ACTIONS(5833),
    [anon_sym_LT_LT] = ACTIONS(5833),
    [anon_sym_LT_LT_EQ] = ACTIONS(5830),
    [anon_sym_LT_EQ] = ACTIONS(5830),
    [anon_sym_EQ] = ACTIONS(5833),
    [anon_sym_EQ_EQ] = ACTIONS(5830),
    [anon_sym_GT] = ACTIONS(5833),
    [anon_sym_GT_EQ] = ACTIONS(5830),
    [anon_sym_GT_GT] = ACTIONS(5833),
    [anon_sym_GT_GT_EQ] = ACTIONS(5830),
    [anon_sym_PIPE] = ACTIONS(5833),
    [anon_sym_PIPE_EQ] = ACTIONS(5830),
    [anon_sym_PIPE_PIPE] = ACTIONS(5830),
    [anon_sym_TILDE] = ACTIONS(5830),
    [anon_sym_QMARK] = ACTIONS(5830),
    [anon_sym_SQUOTE] = ACTIONS(5833),
    [anon_sym_DOT_DOT] = ACTIONS(5833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5830),
    [anon_sym_as] = ACTIONS(5833),
    [anon_sym_break] = ACTIONS(5833),
    [anon_sym_const] = ACTIONS(5833),
    [anon_sym_continue] = ACTIONS(5833),
    [anon_sym_default] = ACTIONS(5833),
    [anon_sym_enum] = ACTIONS(5833),
    [anon_sym_fn] = ACTIONS(5833),
    [anon_sym_for] = ACTIONS(5833),
    [anon_sym_if] = ACTIONS(5833),
    [anon_sym_impl] = ACTIONS(5833),
    [anon_sym_let] = ACTIONS(5833),
    [anon_sym_loop] = ACTIONS(5833),
    [anon_sym_match] = ACTIONS(5833),
    [anon_sym_mod] = ACTIONS(5833),
    [anon_sym_pub] = ACTIONS(5833),
    [anon_sym_return] = ACTIONS(5833),
    [anon_sym_static] = ACTIONS(5833),
    [anon_sym_struct] = ACTIONS(5833),
    [anon_sym_trait] = ACTIONS(5833),
    [anon_sym_type] = ACTIONS(5833),
    [anon_sym_union] = ACTIONS(5833),
    [anon_sym_unsafe] = ACTIONS(5833),
    [anon_sym_use] = ACTIONS(5833),
    [anon_sym_where] = ACTIONS(5833),
    [anon_sym_while] = ACTIONS(5833),
    [sym_mutable_specifier] = ACTIONS(5833),
    [sym_integer_literal] = ACTIONS(5830),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5821),
    [sym_char_literal] = ACTIONS(5830),
    [anon_sym_true] = ACTIONS(5824),
    [anon_sym_false] = ACTIONS(5824),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5833),
    [sym_self] = ACTIONS(5833),
    [sym_super] = ACTIONS(5833),
    [sym_crate] = ACTIONS(5833),
    [sym_metavariable] = ACTIONS(5827),
  },
  [2036] = {
    [sym__token_pattern] = STATE(2036),
    [sym_token_tree_pattern] = STATE(2036),
    [sym_token_binding_pattern] = STATE(2036),
    [sym_token_repetition_pattern] = STATE(2036),
    [sym__literal] = STATE(2036),
    [sym_string_literal] = STATE(2036),
    [sym_boolean_literal] = STATE(2036),
    [aux_sym_token_tree_pattern_repeat1] = STATE(2036),
    [sym_raw_string_literal] = ACTIONS(5836),
    [sym_float_literal] = ACTIONS(5836),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5836),
    [anon_sym_LPAREN] = ACTIONS(5801),
    [anon_sym_LBRACE] = ACTIONS(5806),
    [anon_sym_EQ_GT] = ACTIONS(5836),
    [anon_sym_LBRACK] = ACTIONS(5809),
    [anon_sym_RBRACK] = ACTIONS(5804),
    [anon_sym_COLON] = ACTIONS(5839),
    [anon_sym_DOLLAR] = ACTIONS(5815),
    [anon_sym_PLUS] = ACTIONS(5839),
    [anon_sym_STAR] = ACTIONS(5839),
    [anon_sym_COMMA] = ACTIONS(5836),
    [anon_sym_u8] = ACTIONS(5818),
    [anon_sym_i8] = ACTIONS(5818),
    [anon_sym_u16] = ACTIONS(5818),
    [anon_sym_i16] = ACTIONS(5818),
    [anon_sym_u32] = ACTIONS(5818),
    [anon_sym_i32] = ACTIONS(5818),
    [anon_sym_u64] = ACTIONS(5818),
    [anon_sym_i64] = ACTIONS(5818),
    [anon_sym_u128] = ACTIONS(5818),
    [anon_sym_i128] = ACTIONS(5818),
    [anon_sym_isize] = ACTIONS(5818),
    [anon_sym_usize] = ACTIONS(5818),
    [anon_sym_f32] = ACTIONS(5818),
    [anon_sym_f64] = ACTIONS(5818),
    [anon_sym_bool] = ACTIONS(5818),
    [anon_sym_str] = ACTIONS(5818),
    [anon_sym_char] = ACTIONS(5818),
    [anon_sym__] = ACTIONS(5839),
    [anon_sym_AMP] = ACTIONS(5839),
    [anon_sym_DASH] = ACTIONS(5839),
    [anon_sym_DOT] = ACTIONS(5839),
    [anon_sym_DASH_EQ] = ACTIONS(5836),
    [anon_sym_DASH_GT] = ACTIONS(5836),
    [anon_sym_COLON_COLON] = ACTIONS(5836),
    [anon_sym_BANG] = ACTIONS(5839),
    [anon_sym_BANG_EQ] = ACTIONS(5836),
    [anon_sym_AT] = ACTIONS(5836),
    [anon_sym_STAR_EQ] = ACTIONS(5836),
    [anon_sym_SLASH] = ACTIONS(5839),
    [anon_sym_SLASH_EQ] = ACTIONS(5836),
    [anon_sym_AMP_AMP] = ACTIONS(5836),
    [anon_sym_AMP_EQ] = ACTIONS(5836),
    [anon_sym_POUND] = ACTIONS(5836),
    [anon_sym_PERCENT] = ACTIONS(5839),
    [anon_sym_PERCENT_EQ] = ACTIONS(5836),
    [anon_sym_CARET] = ACTIONS(5839),
    [anon_sym_CARET_EQ] = ACTIONS(5836),
    [anon_sym_PLUS_EQ] = ACTIONS(5836),
    [anon_sym_LT] = ACTIONS(5839),
    [anon_sym_LT_LT] = ACTIONS(5839),
    [anon_sym_LT_LT_EQ] = ACTIONS(5836),
    [anon_sym_LT_EQ] = ACTIONS(5836),
    [anon_sym_EQ] = ACTIONS(5839),
    [anon_sym_EQ_EQ] = ACTIONS(5836),
    [anon_sym_GT] = ACTIONS(5839),
    [anon_sym_GT_EQ] = ACTIONS(5836),
    [anon_sym_GT_GT] = ACTIONS(5839),
    [anon_sym_GT_GT_EQ] = ACTIONS(5836),
    [anon_sym_PIPE] = ACTIONS(5839),
    [anon_sym_PIPE_EQ] = ACTIONS(5836),
    [anon_sym_PIPE_PIPE] = ACTIONS(5836),
    [anon_sym_TILDE] = ACTIONS(5836),
    [anon_sym_QMARK] = ACTIONS(5836),
    [anon_sym_SQUOTE] = ACTIONS(5839),
    [anon_sym_DOT_DOT] = ACTIONS(5839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5836),
    [anon_sym_as] = ACTIONS(5839),
    [anon_sym_break] = ACTIONS(5839),
    [anon_sym_const] = ACTIONS(5839),
    [anon_sym_continue] = ACTIONS(5839),
    [anon_sym_default] = ACTIONS(5839),
    [anon_sym_enum] = ACTIONS(5839),
    [anon_sym_fn] = ACTIONS(5839),
    [anon_sym_for] = ACTIONS(5839),
    [anon_sym_if] = ACTIONS(5839),
    [anon_sym_impl] = ACTIONS(5839),
    [anon_sym_let] = ACTIONS(5839),
    [anon_sym_loop] = ACTIONS(5839),
    [anon_sym_match] = ACTIONS(5839),
    [anon_sym_mod] = ACTIONS(5839),
    [anon_sym_pub] = ACTIONS(5839),
    [anon_sym_return] = ACTIONS(5839),
    [anon_sym_static] = ACTIONS(5839),
    [anon_sym_struct] = ACTIONS(5839),
    [anon_sym_trait] = ACTIONS(5839),
    [anon_sym_type] = ACTIONS(5839),
    [anon_sym_union] = ACTIONS(5839),
    [anon_sym_unsafe] = ACTIONS(5839),
    [anon_sym_use] = ACTIONS(5839),
    [anon_sym_where] = ACTIONS(5839),
    [anon_sym_while] = ACTIONS(5839),
    [sym_mutable_specifier] = ACTIONS(5839),
    [sym_integer_literal] = ACTIONS(5836),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5821),
    [sym_char_literal] = ACTIONS(5836),
    [anon_sym_true] = ACTIONS(5824),
    [anon_sym_false] = ACTIONS(5824),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5839),
    [sym_self] = ACTIONS(5839),
    [sym_super] = ACTIONS(5839),
    [sym_crate] = ACTIONS(5839),
    [sym_metavariable] = ACTIONS(5827),
  },
  [2037] = {
    [sym_raw_string_literal] = ACTIONS(5842),
    [sym_float_literal] = ACTIONS(5842),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(5842),
    [anon_sym_SEMI] = ACTIONS(5842),
    [anon_sym_macro_rules_BANG] = ACTIONS(5842),
    [anon_sym_LPAREN] = ACTIONS(5842),
    [anon_sym_LBRACE] = ACTIONS(5842),
    [anon_sym_RBRACE] = ACTIONS(5842),
    [anon_sym_LBRACK] = ACTIONS(5842),
    [anon_sym_STAR] = ACTIONS(5842),
    [anon_sym_u8] = ACTIONS(5844),
    [anon_sym_i8] = ACTIONS(5844),
    [anon_sym_u16] = ACTIONS(5844),
    [anon_sym_i16] = ACTIONS(5844),
    [anon_sym_u32] = ACTIONS(5844),
    [anon_sym_i32] = ACTIONS(5844),
    [anon_sym_u64] = ACTIONS(5844),
    [anon_sym_i64] = ACTIONS(5844),
    [anon_sym_u128] = ACTIONS(5844),
    [anon_sym_i128] = ACTIONS(5844),
    [anon_sym_isize] = ACTIONS(5844),
    [anon_sym_usize] = ACTIONS(5844),
    [anon_sym_f32] = ACTIONS(5844),
    [anon_sym_f64] = ACTIONS(5844),
    [anon_sym_bool] = ACTIONS(5844),
    [anon_sym_str] = ACTIONS(5844),
    [anon_sym_char] = ACTIONS(5844),
    [anon_sym_AMP] = ACTIONS(5842),
    [anon_sym_DASH] = ACTIONS(5842),
    [anon_sym_COLON_COLON] = ACTIONS(5842),
    [anon_sym_BANG] = ACTIONS(5842),
    [anon_sym_POUND] = ACTIONS(5842),
    [anon_sym_LT] = ACTIONS(5842),
    [anon_sym_PIPE] = ACTIONS(5842),
    [anon_sym_SQUOTE] = ACTIONS(5844),
    [anon_sym_DOT_DOT] = ACTIONS(5842),
    [anon_sym_break] = ACTIONS(5844),
    [anon_sym_const] = ACTIONS(5844),
    [anon_sym_continue] = ACTIONS(5844),
    [anon_sym_default] = ACTIONS(5844),
    [anon_sym_enum] = ACTIONS(5844),
    [anon_sym_fn] = ACTIONS(5844),
    [anon_sym_for] = ACTIONS(5844),
    [anon_sym_if] = ACTIONS(5844),
    [anon_sym_impl] = ACTIONS(5844),
    [anon_sym_let] = ACTIONS(5844),
    [anon_sym_loop] = ACTIONS(5844),
    [anon_sym_match] = ACTIONS(5844),
    [anon_sym_mod] = ACTIONS(5844),
    [anon_sym_pub] = ACTIONS(5844),
    [anon_sym_return] = ACTIONS(5844),
    [anon_sym_static] = ACTIONS(5844),
    [anon_sym_struct] = ACTIONS(5844),
    [anon_sym_trait] = ACTIONS(5844),
    [anon_sym_type] = ACTIONS(5844),
    [anon_sym_union] = ACTIONS(5844),
    [anon_sym_unsafe] = ACTIONS(5844),
    [anon_sym_use] = ACTIONS(5844),
    [anon_sym_while] = ACTIONS(5844),
    [anon_sym_extern] = ACTIONS(5844),
    [anon_sym_move] = ACTIONS(5844),
    [sym_integer_literal] = ACTIONS(5842),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5842),
    [sym_char_literal] = ACTIONS(5842),
    [anon_sym_true] = ACTIONS(5844),
    [anon_sym_false] = ACTIONS(5844),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5844),
    [sym_self] = ACTIONS(5844),
    [sym_super] = ACTIONS(5844),
    [sym_crate] = ACTIONS(5844),
    [sym_metavariable] = ACTIONS(5842),
  },
  [2038] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5846),
    [anon_sym_RPAREN] = ACTIONS(5846),
    [anon_sym_RBRACE] = ACTIONS(5846),
    [sym_line_comment] = ACTIONS(7),
  },
  [2039] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5848),
    [sym_line_comment] = ACTIONS(7),
  },
  [2040] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2707),
    [sym_line_comment] = ACTIONS(7),
  },
  [2041] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5013),
    [anon_sym_LPAREN] = ACTIONS(5013),
    [anon_sym_RPAREN] = ACTIONS(5013),
    [anon_sym_LBRACE] = ACTIONS(5013),
    [anon_sym_RBRACE] = ACTIONS(5013),
    [anon_sym_LBRACK] = ACTIONS(5013),
    [anon_sym_RBRACK] = ACTIONS(5013),
    [anon_sym_PLUS] = ACTIONS(5015),
    [anon_sym_STAR] = ACTIONS(5015),
    [anon_sym_COMMA] = ACTIONS(5013),
    [anon_sym_AMP] = ACTIONS(5015),
    [anon_sym_DASH] = ACTIONS(5015),
    [anon_sym_DOT] = ACTIONS(5015),
    [anon_sym_DASH_EQ] = ACTIONS(5013),
    [anon_sym_BANG_EQ] = ACTIONS(5013),
    [anon_sym_STAR_EQ] = ACTIONS(5013),
    [anon_sym_SLASH] = ACTIONS(5015),
    [anon_sym_SLASH_EQ] = ACTIONS(5013),
    [anon_sym_AMP_AMP] = ACTIONS(5013),
    [anon_sym_AMP_EQ] = ACTIONS(5013),
    [anon_sym_PERCENT] = ACTIONS(5015),
    [anon_sym_PERCENT_EQ] = ACTIONS(5013),
    [anon_sym_CARET] = ACTIONS(5015),
    [anon_sym_CARET_EQ] = ACTIONS(5013),
    [anon_sym_PLUS_EQ] = ACTIONS(5013),
    [anon_sym_LT] = ACTIONS(5015),
    [anon_sym_LT_LT] = ACTIONS(5015),
    [anon_sym_LT_LT_EQ] = ACTIONS(5013),
    [anon_sym_LT_EQ] = ACTIONS(5013),
    [anon_sym_EQ] = ACTIONS(5015),
    [anon_sym_EQ_EQ] = ACTIONS(5013),
    [anon_sym_GT] = ACTIONS(5015),
    [anon_sym_GT_EQ] = ACTIONS(5013),
    [anon_sym_GT_GT] = ACTIONS(5015),
    [anon_sym_GT_GT_EQ] = ACTIONS(5013),
    [anon_sym_PIPE] = ACTIONS(5015),
    [anon_sym_PIPE_EQ] = ACTIONS(5013),
    [anon_sym_PIPE_PIPE] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5013),
    [anon_sym_DOT_DOT] = ACTIONS(5015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5013),
    [anon_sym_as] = ACTIONS(5013),
    [sym_line_comment] = ACTIONS(7),
  },
  [2042] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(2633),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [2043] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5027),
    [anon_sym_LPAREN] = ACTIONS(5027),
    [anon_sym_RPAREN] = ACTIONS(5027),
    [anon_sym_LBRACE] = ACTIONS(5027),
    [anon_sym_RBRACE] = ACTIONS(5027),
    [anon_sym_LBRACK] = ACTIONS(5027),
    [anon_sym_RBRACK] = ACTIONS(5027),
    [anon_sym_PLUS] = ACTIONS(5029),
    [anon_sym_STAR] = ACTIONS(5029),
    [anon_sym_COMMA] = ACTIONS(5027),
    [anon_sym_AMP] = ACTIONS(5029),
    [anon_sym_DASH] = ACTIONS(5029),
    [anon_sym_DOT] = ACTIONS(5029),
    [anon_sym_DASH_EQ] = ACTIONS(5027),
    [anon_sym_BANG_EQ] = ACTIONS(5027),
    [anon_sym_STAR_EQ] = ACTIONS(5027),
    [anon_sym_SLASH] = ACTIONS(5029),
    [anon_sym_SLASH_EQ] = ACTIONS(5027),
    [anon_sym_AMP_AMP] = ACTIONS(5027),
    [anon_sym_AMP_EQ] = ACTIONS(5027),
    [anon_sym_PERCENT] = ACTIONS(5029),
    [anon_sym_PERCENT_EQ] = ACTIONS(5027),
    [anon_sym_CARET] = ACTIONS(5029),
    [anon_sym_CARET_EQ] = ACTIONS(5027),
    [anon_sym_PLUS_EQ] = ACTIONS(5027),
    [anon_sym_LT] = ACTIONS(5029),
    [anon_sym_LT_LT] = ACTIONS(5029),
    [anon_sym_LT_LT_EQ] = ACTIONS(5027),
    [anon_sym_LT_EQ] = ACTIONS(5027),
    [anon_sym_EQ] = ACTIONS(5029),
    [anon_sym_EQ_EQ] = ACTIONS(5027),
    [anon_sym_GT] = ACTIONS(5029),
    [anon_sym_GT_EQ] = ACTIONS(5027),
    [anon_sym_GT_GT] = ACTIONS(5029),
    [anon_sym_GT_GT_EQ] = ACTIONS(5027),
    [anon_sym_PIPE] = ACTIONS(5029),
    [anon_sym_PIPE_EQ] = ACTIONS(5027),
    [anon_sym_PIPE_PIPE] = ACTIONS(5027),
    [anon_sym_QMARK] = ACTIONS(5027),
    [anon_sym_DOT_DOT] = ACTIONS(5029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5027),
    [anon_sym_as] = ACTIONS(5027),
    [sym_line_comment] = ACTIONS(7),
  },
  [2044] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5130),
    [anon_sym_LPAREN] = ACTIONS(5130),
    [anon_sym_RPAREN] = ACTIONS(5130),
    [anon_sym_LBRACE] = ACTIONS(5130),
    [anon_sym_RBRACE] = ACTIONS(5130),
    [anon_sym_LBRACK] = ACTIONS(5130),
    [anon_sym_RBRACK] = ACTIONS(5130),
    [anon_sym_PLUS] = ACTIONS(5132),
    [anon_sym_STAR] = ACTIONS(5132),
    [anon_sym_COMMA] = ACTIONS(5130),
    [anon_sym_AMP] = ACTIONS(5132),
    [anon_sym_DASH] = ACTIONS(5132),
    [anon_sym_DOT] = ACTIONS(5132),
    [anon_sym_DASH_EQ] = ACTIONS(5130),
    [anon_sym_BANG_EQ] = ACTIONS(5130),
    [anon_sym_STAR_EQ] = ACTIONS(5130),
    [anon_sym_SLASH] = ACTIONS(5132),
    [anon_sym_SLASH_EQ] = ACTIONS(5130),
    [anon_sym_AMP_AMP] = ACTIONS(5130),
    [anon_sym_AMP_EQ] = ACTIONS(5130),
    [anon_sym_PERCENT] = ACTIONS(5132),
    [anon_sym_PERCENT_EQ] = ACTIONS(5130),
    [anon_sym_CARET] = ACTIONS(5132),
    [anon_sym_CARET_EQ] = ACTIONS(5130),
    [anon_sym_PLUS_EQ] = ACTIONS(5130),
    [anon_sym_LT] = ACTIONS(5132),
    [anon_sym_LT_LT] = ACTIONS(5132),
    [anon_sym_LT_LT_EQ] = ACTIONS(5130),
    [anon_sym_LT_EQ] = ACTIONS(5130),
    [anon_sym_EQ] = ACTIONS(5132),
    [anon_sym_EQ_EQ] = ACTIONS(5130),
    [anon_sym_GT] = ACTIONS(5132),
    [anon_sym_GT_EQ] = ACTIONS(5130),
    [anon_sym_GT_GT] = ACTIONS(5132),
    [anon_sym_GT_GT_EQ] = ACTIONS(5130),
    [anon_sym_PIPE] = ACTIONS(5132),
    [anon_sym_PIPE_EQ] = ACTIONS(5130),
    [anon_sym_PIPE_PIPE] = ACTIONS(5130),
    [anon_sym_QMARK] = ACTIONS(5130),
    [anon_sym_DOT_DOT] = ACTIONS(5132),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5130),
    [anon_sym_as] = ACTIONS(5130),
    [sym_line_comment] = ACTIONS(7),
  },
  [2045] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5850),
    [sym_line_comment] = ACTIONS(7),
  },
  [2046] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(2635),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [2047] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5554),
    [anon_sym_macro_rules_BANG] = ACTIONS(5554),
    [anon_sym_LPAREN] = ACTIONS(5554),
    [anon_sym_RPAREN] = ACTIONS(5554),
    [anon_sym_LBRACE] = ACTIONS(5554),
    [anon_sym_RBRACE] = ACTIONS(5554),
    [anon_sym_LBRACK] = ACTIONS(5554),
    [anon_sym_RBRACK] = ACTIONS(5554),
    [anon_sym_PLUS] = ACTIONS(5556),
    [anon_sym_STAR] = ACTIONS(5556),
    [anon_sym_COMMA] = ACTIONS(5554),
    [anon_sym_AMP] = ACTIONS(5556),
    [anon_sym_DASH] = ACTIONS(5556),
    [anon_sym_DOT] = ACTIONS(5556),
    [anon_sym_DASH_EQ] = ACTIONS(5554),
    [anon_sym_BANG_EQ] = ACTIONS(5554),
    [anon_sym_STAR_EQ] = ACTIONS(5554),
    [anon_sym_SLASH] = ACTIONS(5556),
    [anon_sym_SLASH_EQ] = ACTIONS(5554),
    [anon_sym_AMP_AMP] = ACTIONS(5554),
    [anon_sym_AMP_EQ] = ACTIONS(5554),
    [anon_sym_POUND] = ACTIONS(5554),
    [anon_sym_PERCENT] = ACTIONS(5556),
    [anon_sym_PERCENT_EQ] = ACTIONS(5554),
    [anon_sym_CARET] = ACTIONS(5556),
    [anon_sym_CARET_EQ] = ACTIONS(5554),
    [anon_sym_PLUS_EQ] = ACTIONS(5554),
    [anon_sym_LT] = ACTIONS(5556),
    [anon_sym_LT_LT] = ACTIONS(5556),
    [anon_sym_LT_LT_EQ] = ACTIONS(5554),
    [anon_sym_LT_EQ] = ACTIONS(5554),
    [anon_sym_EQ] = ACTIONS(5556),
    [anon_sym_EQ_EQ] = ACTIONS(5554),
    [anon_sym_GT] = ACTIONS(5556),
    [anon_sym_GT_EQ] = ACTIONS(5554),
    [anon_sym_GT_GT] = ACTIONS(5556),
    [anon_sym_GT_GT_EQ] = ACTIONS(5554),
    [anon_sym_PIPE] = ACTIONS(5556),
    [anon_sym_PIPE_EQ] = ACTIONS(5554),
    [anon_sym_PIPE_PIPE] = ACTIONS(5554),
    [anon_sym_QMARK] = ACTIONS(5554),
    [anon_sym_DOT_DOT] = ACTIONS(5556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5554),
    [anon_sym_as] = ACTIONS(5556),
    [anon_sym_const] = ACTIONS(5556),
    [anon_sym_default] = ACTIONS(5556),
    [anon_sym_enum] = ACTIONS(5556),
    [anon_sym_fn] = ACTIONS(5556),
    [anon_sym_impl] = ACTIONS(5556),
    [anon_sym_let] = ACTIONS(5556),
    [anon_sym_mod] = ACTIONS(5556),
    [anon_sym_pub] = ACTIONS(5556),
    [anon_sym_static] = ACTIONS(5556),
    [anon_sym_struct] = ACTIONS(5556),
    [anon_sym_trait] = ACTIONS(5556),
    [anon_sym_type] = ACTIONS(5556),
    [anon_sym_union] = ACTIONS(5556),
    [anon_sym_unsafe] = ACTIONS(5556),
    [anon_sym_use] = ACTIONS(5556),
    [anon_sym_extern] = ACTIONS(5556),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5556),
  },
  [2048] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1972),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1972),
    [sym_unary_expression] = STATE(1972),
    [sym_try_expression] = STATE(1972),
    [sym_reference_expression] = STATE(1972),
    [sym_binary_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1972),
    [sym_call_expression] = STATE(1972),
    [sym_array_expression] = STATE(1972),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_tuple_expression] = STATE(1972),
    [sym_unit_expression] = STATE(1972),
    [sym_struct_expression] = STATE(1972),
    [sym_if_expression] = STATE(1972),
    [sym_if_let_expression] = STATE(1972),
    [sym_match_expression] = STATE(1972),
    [sym_while_expression] = STATE(1972),
    [sym_while_let_expression] = STATE(1972),
    [sym_loop_expression] = STATE(1972),
    [sym_for_expression] = STATE(1972),
    [sym_closure_expression] = STATE(1972),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1972),
    [sym_continue_expression] = STATE(1972),
    [sym_index_expression] = STATE(1972),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1972),
    [sym_block] = STATE(1972),
    [sym__literal] = STATE(1972),
    [sym_string_literal] = STATE(1972),
    [sym_boolean_literal] = STATE(1972),
    [sym_raw_string_literal] = ACTIONS(4375),
    [sym_float_literal] = ACTIONS(4375),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(5852),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(4375),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4375),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2049] = {
    [aux_sym_token_tree_repeat2] = STATE(1974),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(5852),
    [anon_sym_COMMA] = ACTIONS(5854),
    [sym_line_comment] = ACTIONS(7),
  },
  [2050] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5564),
    [anon_sym_macro_rules_BANG] = ACTIONS(5564),
    [anon_sym_LPAREN] = ACTIONS(5564),
    [anon_sym_RPAREN] = ACTIONS(5564),
    [anon_sym_LBRACE] = ACTIONS(5564),
    [anon_sym_RBRACE] = ACTIONS(5564),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_RBRACK] = ACTIONS(5564),
    [anon_sym_PLUS] = ACTIONS(5566),
    [anon_sym_STAR] = ACTIONS(5566),
    [anon_sym_COMMA] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5566),
    [anon_sym_DASH] = ACTIONS(5566),
    [anon_sym_DOT] = ACTIONS(5566),
    [anon_sym_DASH_EQ] = ACTIONS(5564),
    [anon_sym_BANG_EQ] = ACTIONS(5564),
    [anon_sym_STAR_EQ] = ACTIONS(5564),
    [anon_sym_SLASH] = ACTIONS(5566),
    [anon_sym_SLASH_EQ] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_AMP_EQ] = ACTIONS(5564),
    [anon_sym_POUND] = ACTIONS(5564),
    [anon_sym_PERCENT] = ACTIONS(5566),
    [anon_sym_PERCENT_EQ] = ACTIONS(5564),
    [anon_sym_CARET] = ACTIONS(5566),
    [anon_sym_CARET_EQ] = ACTIONS(5564),
    [anon_sym_PLUS_EQ] = ACTIONS(5564),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_LT_LT_EQ] = ACTIONS(5564),
    [anon_sym_LT_EQ] = ACTIONS(5564),
    [anon_sym_EQ] = ACTIONS(5566),
    [anon_sym_EQ_EQ] = ACTIONS(5564),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_EQ] = ACTIONS(5564),
    [anon_sym_GT_GT] = ACTIONS(5566),
    [anon_sym_GT_GT_EQ] = ACTIONS(5564),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_PIPE_EQ] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_QMARK] = ACTIONS(5564),
    [anon_sym_DOT_DOT] = ACTIONS(5566),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5564),
    [anon_sym_as] = ACTIONS(5566),
    [anon_sym_const] = ACTIONS(5566),
    [anon_sym_default] = ACTIONS(5566),
    [anon_sym_enum] = ACTIONS(5566),
    [anon_sym_fn] = ACTIONS(5566),
    [anon_sym_impl] = ACTIONS(5566),
    [anon_sym_let] = ACTIONS(5566),
    [anon_sym_mod] = ACTIONS(5566),
    [anon_sym_pub] = ACTIONS(5566),
    [anon_sym_static] = ACTIONS(5566),
    [anon_sym_struct] = ACTIONS(5566),
    [anon_sym_trait] = ACTIONS(5566),
    [anon_sym_type] = ACTIONS(5566),
    [anon_sym_union] = ACTIONS(5566),
    [anon_sym_unsafe] = ACTIONS(5566),
    [anon_sym_use] = ACTIONS(5566),
    [anon_sym_extern] = ACTIONS(5566),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5566),
  },
  [2051] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(623),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(623),
    [anon_sym_PLUS_EQ] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(623),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(643),
    [anon_sym_as] = ACTIONS(645),
    [sym_line_comment] = ACTIONS(7),
  },
  [2052] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(769),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(769),
    [sym_macro_invocation] = STATE(769),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(769),
    [sym_unary_expression] = STATE(769),
    [sym_try_expression] = STATE(769),
    [sym_reference_expression] = STATE(769),
    [sym_binary_expression] = STATE(769),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(769),
    [sym_call_expression] = STATE(769),
    [sym_array_expression] = STATE(769),
    [sym_parenthesized_expression] = STATE(769),
    [sym_tuple_expression] = STATE(769),
    [sym_unit_expression] = STATE(769),
    [sym_struct_expression] = STATE(769),
    [sym_if_expression] = STATE(769),
    [sym_if_let_expression] = STATE(769),
    [sym_match_expression] = STATE(769),
    [sym_while_expression] = STATE(769),
    [sym_while_let_expression] = STATE(769),
    [sym_loop_expression] = STATE(769),
    [sym_for_expression] = STATE(769),
    [sym_closure_expression] = STATE(769),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(769),
    [sym_continue_expression] = STATE(769),
    [sym_index_expression] = STATE(769),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(769),
    [sym_block] = STATE(769),
    [sym__literal] = STATE(769),
    [sym_string_literal] = STATE(769),
    [sym_boolean_literal] = STATE(769),
    [sym_raw_string_literal] = ACTIONS(1620),
    [sym_float_literal] = ACTIONS(1620),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_RBRACK] = ACTIONS(5852),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1620),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1620),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2053] = {
    [aux_sym_token_tree_repeat2] = STATE(789),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACK] = ACTIONS(5852),
    [anon_sym_COMMA] = ACTIONS(5856),
    [sym_line_comment] = ACTIONS(7),
  },
  [2054] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5858),
    [anon_sym_LPAREN] = ACTIONS(5858),
    [anon_sym_RPAREN] = ACTIONS(5858),
    [anon_sym_LBRACE] = ACTIONS(5858),
    [anon_sym_RBRACE] = ACTIONS(5858),
    [anon_sym_LBRACK] = ACTIONS(5858),
    [anon_sym_RBRACK] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_STAR] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5858),
    [anon_sym_AMP] = ACTIONS(5860),
    [anon_sym_DASH] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5858),
    [anon_sym_STAR_EQ] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_AMP_EQ] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5858),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5858),
    [anon_sym_PLUS_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5858),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5860),
    [anon_sym_GT_EQ] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5858),
    [anon_sym_PIPE] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5858),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_QMARK] = ACTIONS(5858),
    [anon_sym_DOT_DOT] = ACTIONS(5860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5858),
    [anon_sym_as] = ACTIONS(5858),
    [sym_line_comment] = ACTIONS(7),
  },
  [2055] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(103),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(103),
    [sym_macro_invocation] = STATE(103),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(103),
    [sym_unary_expression] = STATE(103),
    [sym_try_expression] = STATE(103),
    [sym_reference_expression] = STATE(103),
    [sym_binary_expression] = STATE(103),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(103),
    [sym_call_expression] = STATE(103),
    [sym_array_expression] = STATE(103),
    [sym_parenthesized_expression] = STATE(103),
    [sym_tuple_expression] = STATE(103),
    [sym_unit_expression] = STATE(103),
    [sym_struct_expression] = STATE(103),
    [sym_if_expression] = STATE(103),
    [sym_if_let_expression] = STATE(103),
    [sym_match_expression] = STATE(103),
    [sym_while_expression] = STATE(103),
    [sym_while_let_expression] = STATE(103),
    [sym_loop_expression] = STATE(103),
    [sym_for_expression] = STATE(103),
    [sym_closure_expression] = STATE(103),
    [sym_closure_parameters] = STATE(2062),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(103),
    [sym_continue_expression] = STATE(103),
    [sym_index_expression] = STATE(103),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(103),
    [sym_block] = STATE(103),
    [sym__literal] = STATE(103),
    [sym_string_literal] = STATE(103),
    [sym_boolean_literal] = STATE(103),
    [sym_raw_string_literal] = ACTIONS(173),
    [sym_float_literal] = ACTIONS(173),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(5862),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5862),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5866),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(5868),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(5870),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(5872),
    [sym_integer_literal] = ACTIONS(173),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(173),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2056] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(106),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(106),
    [sym_macro_invocation] = STATE(106),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(106),
    [sym_unary_expression] = STATE(106),
    [sym_try_expression] = STATE(106),
    [sym_reference_expression] = STATE(106),
    [sym_binary_expression] = STATE(106),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(106),
    [sym_call_expression] = STATE(106),
    [sym_array_expression] = STATE(106),
    [sym_parenthesized_expression] = STATE(106),
    [sym_tuple_expression] = STATE(106),
    [sym_unit_expression] = STATE(106),
    [sym_struct_expression] = STATE(106),
    [sym_if_expression] = STATE(106),
    [sym_if_let_expression] = STATE(106),
    [sym_match_expression] = STATE(106),
    [sym_while_expression] = STATE(106),
    [sym_while_let_expression] = STATE(106),
    [sym_loop_expression] = STATE(106),
    [sym_for_expression] = STATE(106),
    [sym_closure_expression] = STATE(106),
    [sym_closure_parameters] = STATE(2062),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(106),
    [sym_continue_expression] = STATE(106),
    [sym_index_expression] = STATE(106),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(106),
    [sym_block] = STATE(106),
    [sym__literal] = STATE(106),
    [sym_string_literal] = STATE(106),
    [sym_boolean_literal] = STATE(106),
    [sym_raw_string_literal] = ACTIONS(183),
    [sym_float_literal] = ACTIONS(183),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(5862),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5862),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5866),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(5868),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(5870),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [sym_mutable_specifier] = ACTIONS(5874),
    [anon_sym_move] = ACTIONS(5872),
    [sym_integer_literal] = ACTIONS(183),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(183),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2057] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2640),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2640),
    [sym_macro_invocation] = STATE(2640),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2640),
    [sym_unary_expression] = STATE(2640),
    [sym_try_expression] = STATE(2640),
    [sym_reference_expression] = STATE(2640),
    [sym_binary_expression] = STATE(2640),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2640),
    [sym_call_expression] = STATE(2640),
    [sym_array_expression] = STATE(2640),
    [sym_parenthesized_expression] = STATE(2640),
    [sym_tuple_expression] = STATE(2640),
    [sym_unit_expression] = STATE(2640),
    [sym_struct_expression] = STATE(2640),
    [sym_if_expression] = STATE(2640),
    [sym_if_let_expression] = STATE(2640),
    [sym_match_expression] = STATE(2640),
    [sym_while_expression] = STATE(2640),
    [sym_while_let_expression] = STATE(2640),
    [sym_loop_expression] = STATE(2640),
    [sym_for_expression] = STATE(2640),
    [sym_closure_expression] = STATE(2640),
    [sym_closure_parameters] = STATE(2062),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2640),
    [sym_continue_expression] = STATE(2640),
    [sym_index_expression] = STATE(2640),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2640),
    [sym_block] = STATE(2640),
    [sym__literal] = STATE(2640),
    [sym_string_literal] = STATE(2640),
    [sym_boolean_literal] = STATE(2640),
    [sym_raw_string_literal] = ACTIONS(5876),
    [sym_float_literal] = ACTIONS(5876),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_PLUS] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(263),
    [anon_sym_COMMA] = ACTIONS(261),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(263),
    [anon_sym_DASH] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(263),
    [anon_sym_DASH_EQ] = ACTIONS(261),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(5878),
    [anon_sym_BANG_EQ] = ACTIONS(261),
    [anon_sym_STAR_EQ] = ACTIONS(261),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_SLASH_EQ] = ACTIONS(261),
    [anon_sym_AMP_AMP] = ACTIONS(261),
    [anon_sym_AMP_EQ] = ACTIONS(261),
    [anon_sym_PERCENT] = ACTIONS(263),
    [anon_sym_PERCENT_EQ] = ACTIONS(261),
    [anon_sym_CARET] = ACTIONS(263),
    [anon_sym_CARET_EQ] = ACTIONS(261),
    [anon_sym_PLUS_EQ] = ACTIONS(261),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_EQ] = ACTIONS(261),
    [anon_sym_LT_EQ] = ACTIONS(261),
    [anon_sym_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(261),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_EQ] = ACTIONS(261),
    [anon_sym_GT_GT] = ACTIONS(263),
    [anon_sym_GT_GT_EQ] = ACTIONS(261),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_PIPE_EQ] = ACTIONS(261),
    [anon_sym_PIPE_PIPE] = ACTIONS(261),
    [anon_sym_QMARK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(263),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(261),
    [anon_sym_as] = ACTIONS(263),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(5868),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(5870),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(5872),
    [sym_integer_literal] = ACTIONS(5876),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(5876),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2058] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2642),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(2642),
    [sym_macro_invocation] = STATE(2642),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2642),
    [sym_unary_expression] = STATE(2642),
    [sym_try_expression] = STATE(2642),
    [sym_reference_expression] = STATE(2642),
    [sym_binary_expression] = STATE(2642),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2642),
    [sym_call_expression] = STATE(2642),
    [sym_array_expression] = STATE(2642),
    [sym_parenthesized_expression] = STATE(2642),
    [sym_tuple_expression] = STATE(2642),
    [sym_unit_expression] = STATE(2642),
    [sym_struct_expression] = STATE(2642),
    [sym_if_expression] = STATE(2642),
    [sym_if_let_expression] = STATE(2642),
    [sym_match_expression] = STATE(2642),
    [sym_while_expression] = STATE(2642),
    [sym_while_let_expression] = STATE(2642),
    [sym_loop_expression] = STATE(2642),
    [sym_for_expression] = STATE(2642),
    [sym_closure_expression] = STATE(2642),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2642),
    [sym_continue_expression] = STATE(2642),
    [sym_index_expression] = STATE(2642),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2642),
    [sym_block] = STATE(2642),
    [sym__literal] = STATE(2642),
    [sym_string_literal] = STATE(2642),
    [sym_boolean_literal] = STATE(2642),
    [sym_raw_string_literal] = ACTIONS(5880),
    [sym_float_literal] = ACTIONS(5880),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_let] = ACTIONS(5882),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(5880),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(5880),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [2059] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2643),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2643),
    [sym_macro_invocation] = STATE(2643),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2643),
    [sym_unary_expression] = STATE(2643),
    [sym_try_expression] = STATE(2643),
    [sym_reference_expression] = STATE(2643),
    [sym_binary_expression] = STATE(2643),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2643),
    [sym_call_expression] = STATE(2643),
    [sym_array_expression] = STATE(2643),
    [sym_parenthesized_expression] = STATE(2643),
    [sym_tuple_expression] = STATE(2643),
    [sym_unit_expression] = STATE(2643),
    [sym_struct_expression] = STATE(2643),
    [sym_if_expression] = STATE(2643),
    [sym_if_let_expression] = STATE(2643),
    [sym_match_expression] = STATE(2643),
    [sym_while_expression] = STATE(2643),
    [sym_while_let_expression] = STATE(2643),
    [sym_loop_expression] = STATE(2643),
    [sym_for_expression] = STATE(2643),
    [sym_closure_expression] = STATE(2643),
    [sym_closure_parameters] = STATE(2062),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2643),
    [sym_continue_expression] = STATE(2643),
    [sym_index_expression] = STATE(2643),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2643),
    [sym_block] = STATE(2643),
    [sym__literal] = STATE(2643),
    [sym_string_literal] = STATE(2643),
    [sym_boolean_literal] = STATE(2643),
    [sym_raw_string_literal] = ACTIONS(5884),
    [sym_float_literal] = ACTIONS(5884),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(359),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(361),
    [anon_sym_STAR] = ACTIONS(361),
    [anon_sym_COMMA] = ACTIONS(359),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(361),
    [anon_sym_DASH_EQ] = ACTIONS(359),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(5878),
    [anon_sym_BANG_EQ] = ACTIONS(359),
    [anon_sym_STAR_EQ] = ACTIONS(359),
    [anon_sym_SLASH] = ACTIONS(361),
    [anon_sym_SLASH_EQ] = ACTIONS(359),
    [anon_sym_AMP_AMP] = ACTIONS(359),
    [anon_sym_AMP_EQ] = ACTIONS(359),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_PERCENT_EQ] = ACTIONS(359),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_CARET_EQ] = ACTIONS(359),
    [anon_sym_PLUS_EQ] = ACTIONS(359),
    [anon_sym_LT] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_LT_LT_EQ] = ACTIONS(359),
    [anon_sym_LT_EQ] = ACTIONS(359),
    [anon_sym_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(359),
    [anon_sym_GT] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(359),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_GT_GT_EQ] = ACTIONS(359),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_PIPE_EQ] = ACTIONS(359),
    [anon_sym_PIPE_PIPE] = ACTIONS(359),
    [anon_sym_QMARK] = ACTIONS(359),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(361),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(359),
    [anon_sym_as] = ACTIONS(361),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(5868),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(5870),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(5872),
    [sym_integer_literal] = ACTIONS(5884),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(5884),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2060] = {
    [sym_closure_parameters] = STATE(2644),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(7),
  },
  [2061] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(5886),
    [anon_sym_STAR] = ACTIONS(5888),
    [anon_sym_COMMA] = ACTIONS(2749),
    [anon_sym_AMP] = ACTIONS(5890),
    [anon_sym_DASH] = ACTIONS(5886),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(5892),
    [anon_sym_BANG_EQ] = ACTIONS(5894),
    [anon_sym_STAR_EQ] = ACTIONS(5892),
    [anon_sym_SLASH] = ACTIONS(5888),
    [anon_sym_SLASH_EQ] = ACTIONS(5892),
    [anon_sym_AMP_AMP] = ACTIONS(5896),
    [anon_sym_AMP_EQ] = ACTIONS(5892),
    [anon_sym_PERCENT] = ACTIONS(5888),
    [anon_sym_PERCENT_EQ] = ACTIONS(5892),
    [anon_sym_CARET] = ACTIONS(5898),
    [anon_sym_CARET_EQ] = ACTIONS(5892),
    [anon_sym_PLUS_EQ] = ACTIONS(5892),
    [anon_sym_LT] = ACTIONS(5900),
    [anon_sym_LT_LT] = ACTIONS(5902),
    [anon_sym_LT_LT_EQ] = ACTIONS(5892),
    [anon_sym_LT_EQ] = ACTIONS(5894),
    [anon_sym_EQ] = ACTIONS(5904),
    [anon_sym_EQ_EQ] = ACTIONS(5894),
    [anon_sym_GT] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5894),
    [anon_sym_GT_GT] = ACTIONS(5902),
    [anon_sym_GT_GT_EQ] = ACTIONS(5892),
    [anon_sym_PIPE] = ACTIONS(5906),
    [anon_sym_PIPE_EQ] = ACTIONS(5892),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(5910),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5912),
    [anon_sym_as] = ACTIONS(5914),
    [sym_line_comment] = ACTIONS(7),
  },
  [2062] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2659),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2659),
    [sym_macro_invocation] = STATE(2659),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2659),
    [sym_unary_expression] = STATE(2659),
    [sym_try_expression] = STATE(2659),
    [sym_reference_expression] = STATE(2659),
    [sym_binary_expression] = STATE(2659),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2659),
    [sym_call_expression] = STATE(2659),
    [sym_array_expression] = STATE(2659),
    [sym_parenthesized_expression] = STATE(2659),
    [sym_tuple_expression] = STATE(2659),
    [sym_unit_expression] = STATE(2659),
    [sym_struct_expression] = STATE(2659),
    [sym_if_expression] = STATE(2659),
    [sym_if_let_expression] = STATE(2659),
    [sym_match_expression] = STATE(2659),
    [sym_while_expression] = STATE(2659),
    [sym_while_let_expression] = STATE(2659),
    [sym_loop_expression] = STATE(2659),
    [sym_for_expression] = STATE(2659),
    [sym_closure_expression] = STATE(2659),
    [sym_closure_parameters] = STATE(2062),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2659),
    [sym_continue_expression] = STATE(2659),
    [sym_index_expression] = STATE(2659),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2659),
    [sym_block] = STATE(2659),
    [sym__literal] = STATE(2659),
    [sym_string_literal] = STATE(2659),
    [sym_boolean_literal] = STATE(2659),
    [sym_raw_string_literal] = ACTIONS(5916),
    [sym_float_literal] = ACTIONS(5916),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(5862),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5878),
    [anon_sym_DASH_GT] = ACTIONS(509),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5866),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(5868),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(5870),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(5872),
    [sym_integer_literal] = ACTIONS(5916),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(5916),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2063] = {
    [sym_function_modifiers] = STATE(726),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2611),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(727),
    [sym_array_type] = STATE(2611),
    [sym_function_type] = STATE(2611),
    [sym_tuple_type] = STATE(2611),
    [sym_unit_type] = STATE(2611),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2611),
    [sym_reference_type] = STATE(2611),
    [sym_pointer_type] = STATE(2611),
    [sym_empty_type] = STATE(2611),
    [sym_dynamic_type] = STATE(2611),
    [sym_macro_invocation] = STATE(2611),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(728),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1543),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1547),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1549),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2064] = {
    [sym_function_modifiers] = STATE(726),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2616),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(727),
    [sym_array_type] = STATE(2616),
    [sym_function_type] = STATE(2616),
    [sym_tuple_type] = STATE(2616),
    [sym_unit_type] = STATE(2616),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2616),
    [sym_reference_type] = STATE(2616),
    [sym_pointer_type] = STATE(2616),
    [sym_empty_type] = STATE(2616),
    [sym_abstract_type] = STATE(2617),
    [sym_dynamic_type] = STATE(2616),
    [sym_macro_invocation] = STATE(2616),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(728),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1543),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1547),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1549),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2065] = {
    [sym_function_modifiers] = STATE(726),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2618),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(727),
    [sym_array_type] = STATE(2618),
    [sym_function_type] = STATE(2618),
    [sym_tuple_type] = STATE(2618),
    [sym_unit_type] = STATE(2618),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2618),
    [sym_reference_type] = STATE(2618),
    [sym_pointer_type] = STATE(2618),
    [sym_empty_type] = STATE(2618),
    [sym_abstract_type] = STATE(2619),
    [sym_dynamic_type] = STATE(2618),
    [sym_macro_invocation] = STATE(2618),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(728),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1543),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1547),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1549),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2066] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2988),
    [anon_sym_RPAREN] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(5758),
    [anon_sym_STAR] = ACTIONS(5758),
    [anon_sym_COMMA] = ACTIONS(2988),
    [anon_sym_AMP] = ACTIONS(5758),
    [anon_sym_DASH] = ACTIONS(5758),
    [anon_sym_DOT] = ACTIONS(5758),
    [anon_sym_DASH_EQ] = ACTIONS(2988),
    [anon_sym_DASH_GT] = ACTIONS(5918),
    [anon_sym_BANG_EQ] = ACTIONS(2988),
    [anon_sym_STAR_EQ] = ACTIONS(2988),
    [anon_sym_SLASH] = ACTIONS(5758),
    [anon_sym_SLASH_EQ] = ACTIONS(2988),
    [anon_sym_AMP_AMP] = ACTIONS(2988),
    [anon_sym_AMP_EQ] = ACTIONS(2988),
    [anon_sym_PERCENT] = ACTIONS(5758),
    [anon_sym_PERCENT_EQ] = ACTIONS(2988),
    [anon_sym_CARET] = ACTIONS(5758),
    [anon_sym_CARET_EQ] = ACTIONS(2988),
    [anon_sym_PLUS_EQ] = ACTIONS(2988),
    [anon_sym_LT] = ACTIONS(5758),
    [anon_sym_LT_LT] = ACTIONS(5758),
    [anon_sym_LT_LT_EQ] = ACTIONS(2988),
    [anon_sym_LT_EQ] = ACTIONS(2988),
    [anon_sym_EQ] = ACTIONS(5758),
    [anon_sym_EQ_EQ] = ACTIONS(2988),
    [anon_sym_GT] = ACTIONS(5758),
    [anon_sym_GT_EQ] = ACTIONS(2988),
    [anon_sym_GT_GT] = ACTIONS(5758),
    [anon_sym_GT_GT_EQ] = ACTIONS(2988),
    [anon_sym_PIPE] = ACTIONS(5758),
    [anon_sym_PIPE_EQ] = ACTIONS(2988),
    [anon_sym_PIPE_PIPE] = ACTIONS(2988),
    [anon_sym_QMARK] = ACTIONS(2988),
    [anon_sym_DOT_DOT] = ACTIONS(5758),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2988),
    [anon_sym_as] = ACTIONS(2988),
    [sym_line_comment] = ACTIONS(7),
  },
  [2067] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2992),
    [anon_sym_RPAREN] = ACTIONS(2992),
    [anon_sym_LBRACK] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(5762),
    [anon_sym_STAR] = ACTIONS(5762),
    [anon_sym_COMMA] = ACTIONS(2992),
    [anon_sym_AMP] = ACTIONS(5762),
    [anon_sym_DASH] = ACTIONS(5762),
    [anon_sym_DOT] = ACTIONS(5762),
    [anon_sym_DASH_EQ] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(5920),
    [anon_sym_BANG_EQ] = ACTIONS(2992),
    [anon_sym_STAR_EQ] = ACTIONS(2992),
    [anon_sym_SLASH] = ACTIONS(5762),
    [anon_sym_SLASH_EQ] = ACTIONS(2992),
    [anon_sym_AMP_AMP] = ACTIONS(2992),
    [anon_sym_AMP_EQ] = ACTIONS(2992),
    [anon_sym_PERCENT] = ACTIONS(5762),
    [anon_sym_PERCENT_EQ] = ACTIONS(2992),
    [anon_sym_CARET] = ACTIONS(5762),
    [anon_sym_CARET_EQ] = ACTIONS(2992),
    [anon_sym_PLUS_EQ] = ACTIONS(2992),
    [anon_sym_LT] = ACTIONS(5762),
    [anon_sym_LT_LT] = ACTIONS(5762),
    [anon_sym_LT_LT_EQ] = ACTIONS(2992),
    [anon_sym_LT_EQ] = ACTIONS(2992),
    [anon_sym_EQ] = ACTIONS(5762),
    [anon_sym_EQ_EQ] = ACTIONS(2992),
    [anon_sym_GT] = ACTIONS(5762),
    [anon_sym_GT_EQ] = ACTIONS(2992),
    [anon_sym_GT_GT] = ACTIONS(5762),
    [anon_sym_GT_GT_EQ] = ACTIONS(2992),
    [anon_sym_PIPE] = ACTIONS(5762),
    [anon_sym_PIPE_EQ] = ACTIONS(2992),
    [anon_sym_PIPE_PIPE] = ACTIONS(2992),
    [anon_sym_QMARK] = ACTIONS(2992),
    [anon_sym_DOT_DOT] = ACTIONS(5762),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2992),
    [anon_sym_as] = ACTIONS(2992),
    [sym_line_comment] = ACTIONS(7),
  },
  [2068] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2662),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(2662),
    [sym_macro_invocation] = STATE(2662),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2662),
    [sym_unary_expression] = STATE(2662),
    [sym_try_expression] = STATE(2662),
    [sym_reference_expression] = STATE(2662),
    [sym_binary_expression] = STATE(2662),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2662),
    [sym_call_expression] = STATE(2662),
    [sym_array_expression] = STATE(2662),
    [sym_parenthesized_expression] = STATE(2662),
    [sym_tuple_expression] = STATE(2662),
    [sym_unit_expression] = STATE(2662),
    [sym_struct_expression] = STATE(2662),
    [sym_if_expression] = STATE(2662),
    [sym_if_let_expression] = STATE(2662),
    [sym_match_expression] = STATE(2662),
    [sym_while_expression] = STATE(2662),
    [sym_while_let_expression] = STATE(2662),
    [sym_loop_expression] = STATE(2662),
    [sym_for_expression] = STATE(2662),
    [sym_closure_expression] = STATE(2662),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2662),
    [sym_continue_expression] = STATE(2662),
    [sym_index_expression] = STATE(2662),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2662),
    [sym_block] = STATE(2662),
    [sym__literal] = STATE(2662),
    [sym_string_literal] = STATE(2662),
    [sym_boolean_literal] = STATE(2662),
    [sym_raw_string_literal] = ACTIONS(5922),
    [sym_float_literal] = ACTIONS(5922),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(5922),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(5922),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [2069] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(5924),
    [sym_line_comment] = ACTIONS(7),
  },
  [2070] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5778),
    [anon_sym_LPAREN] = ACTIONS(5778),
    [anon_sym_RPAREN] = ACTIONS(5778),
    [anon_sym_LBRACE] = ACTIONS(5778),
    [anon_sym_RBRACE] = ACTIONS(5778),
    [anon_sym_LBRACK] = ACTIONS(5778),
    [anon_sym_RBRACK] = ACTIONS(5778),
    [anon_sym_PLUS] = ACTIONS(5780),
    [anon_sym_STAR] = ACTIONS(5780),
    [anon_sym_COMMA] = ACTIONS(5778),
    [anon_sym_AMP] = ACTIONS(5780),
    [anon_sym_DASH] = ACTIONS(5780),
    [anon_sym_DOT] = ACTIONS(5780),
    [anon_sym_DASH_EQ] = ACTIONS(5778),
    [anon_sym_BANG_EQ] = ACTIONS(5778),
    [anon_sym_STAR_EQ] = ACTIONS(5778),
    [anon_sym_SLASH] = ACTIONS(5780),
    [anon_sym_SLASH_EQ] = ACTIONS(5778),
    [anon_sym_AMP_AMP] = ACTIONS(5778),
    [anon_sym_AMP_EQ] = ACTIONS(5778),
    [anon_sym_PERCENT] = ACTIONS(5780),
    [anon_sym_PERCENT_EQ] = ACTIONS(5778),
    [anon_sym_CARET] = ACTIONS(5780),
    [anon_sym_CARET_EQ] = ACTIONS(5778),
    [anon_sym_PLUS_EQ] = ACTIONS(5778),
    [anon_sym_LT] = ACTIONS(5780),
    [anon_sym_LT_LT] = ACTIONS(5780),
    [anon_sym_LT_LT_EQ] = ACTIONS(5778),
    [anon_sym_LT_EQ] = ACTIONS(5778),
    [anon_sym_EQ] = ACTIONS(5780),
    [anon_sym_EQ_EQ] = ACTIONS(5778),
    [anon_sym_GT] = ACTIONS(5780),
    [anon_sym_GT_EQ] = ACTIONS(5778),
    [anon_sym_GT_GT] = ACTIONS(5780),
    [anon_sym_GT_GT_EQ] = ACTIONS(5778),
    [anon_sym_PIPE] = ACTIONS(5780),
    [anon_sym_PIPE_EQ] = ACTIONS(5778),
    [anon_sym_PIPE_PIPE] = ACTIONS(5778),
    [anon_sym_QMARK] = ACTIONS(5778),
    [anon_sym_DOT_DOT] = ACTIONS(5780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5778),
    [anon_sym_as] = ACTIONS(5778),
    [sym_line_comment] = ACTIONS(7),
  },
  [2071] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2664),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(2664),
    [sym_macro_invocation] = STATE(2664),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2664),
    [sym_unary_expression] = STATE(2664),
    [sym_try_expression] = STATE(2664),
    [sym_reference_expression] = STATE(2664),
    [sym_binary_expression] = STATE(2664),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2664),
    [sym_call_expression] = STATE(2664),
    [sym_array_expression] = STATE(2664),
    [sym_parenthesized_expression] = STATE(2664),
    [sym_tuple_expression] = STATE(2664),
    [sym_unit_expression] = STATE(2664),
    [sym_struct_expression] = STATE(2664),
    [sym_if_expression] = STATE(2664),
    [sym_if_let_expression] = STATE(2664),
    [sym_match_expression] = STATE(2664),
    [sym_while_expression] = STATE(2664),
    [sym_while_let_expression] = STATE(2664),
    [sym_loop_expression] = STATE(2664),
    [sym_for_expression] = STATE(2664),
    [sym_closure_expression] = STATE(2664),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2664),
    [sym_continue_expression] = STATE(2664),
    [sym_index_expression] = STATE(2664),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2664),
    [sym_block] = STATE(2664),
    [sym__literal] = STATE(2664),
    [sym_string_literal] = STATE(2664),
    [sym_boolean_literal] = STATE(2664),
    [sym_raw_string_literal] = ACTIONS(5926),
    [sym_float_literal] = ACTIONS(5926),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(5926),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(5926),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [2072] = {
    [sym_if_expression] = STATE(2043),
    [sym_if_let_expression] = STATE(2043),
    [sym_block] = STATE(2043),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(5928),
    [sym_line_comment] = ACTIONS(7),
  },
  [2073] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(2665),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [2074] = {
    [sym_function_modifiers] = STATE(752),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2611),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(753),
    [sym_array_type] = STATE(2611),
    [sym_function_type] = STATE(2611),
    [sym_tuple_type] = STATE(2611),
    [sym_unit_type] = STATE(2611),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2611),
    [sym_reference_type] = STATE(2611),
    [sym_pointer_type] = STATE(2611),
    [sym_empty_type] = STATE(2611),
    [sym_dynamic_type] = STATE(2611),
    [sym_macro_invocation] = STATE(2611),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(754),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1593),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1597),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1599),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2075] = {
    [sym_function_modifiers] = STATE(752),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2616),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(753),
    [sym_array_type] = STATE(2616),
    [sym_function_type] = STATE(2616),
    [sym_tuple_type] = STATE(2616),
    [sym_unit_type] = STATE(2616),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2616),
    [sym_reference_type] = STATE(2616),
    [sym_pointer_type] = STATE(2616),
    [sym_empty_type] = STATE(2616),
    [sym_abstract_type] = STATE(2617),
    [sym_dynamic_type] = STATE(2616),
    [sym_macro_invocation] = STATE(2616),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(754),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1593),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1597),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1599),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2076] = {
    [sym_function_modifiers] = STATE(752),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2618),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(753),
    [sym_array_type] = STATE(2618),
    [sym_function_type] = STATE(2618),
    [sym_tuple_type] = STATE(2618),
    [sym_unit_type] = STATE(2618),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2618),
    [sym_reference_type] = STATE(2618),
    [sym_pointer_type] = STATE(2618),
    [sym_empty_type] = STATE(2618),
    [sym_abstract_type] = STATE(2619),
    [sym_dynamic_type] = STATE(2618),
    [sym_macro_invocation] = STATE(2618),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(754),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1593),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1597),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1599),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2077] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2988),
    [anon_sym_LPAREN] = ACTIONS(2988),
    [anon_sym_RBRACE] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(5758),
    [anon_sym_STAR] = ACTIONS(5758),
    [anon_sym_AMP] = ACTIONS(5758),
    [anon_sym_DASH] = ACTIONS(5758),
    [anon_sym_DOT] = ACTIONS(5758),
    [anon_sym_DASH_EQ] = ACTIONS(2988),
    [anon_sym_DASH_GT] = ACTIONS(5930),
    [anon_sym_BANG_EQ] = ACTIONS(2988),
    [anon_sym_STAR_EQ] = ACTIONS(2988),
    [anon_sym_SLASH] = ACTIONS(5758),
    [anon_sym_SLASH_EQ] = ACTIONS(2988),
    [anon_sym_AMP_AMP] = ACTIONS(2988),
    [anon_sym_AMP_EQ] = ACTIONS(2988),
    [anon_sym_PERCENT] = ACTIONS(5758),
    [anon_sym_PERCENT_EQ] = ACTIONS(2988),
    [anon_sym_CARET] = ACTIONS(5758),
    [anon_sym_CARET_EQ] = ACTIONS(2988),
    [anon_sym_PLUS_EQ] = ACTIONS(2988),
    [anon_sym_LT] = ACTIONS(5758),
    [anon_sym_LT_LT] = ACTIONS(5758),
    [anon_sym_LT_LT_EQ] = ACTIONS(2988),
    [anon_sym_LT_EQ] = ACTIONS(2988),
    [anon_sym_EQ] = ACTIONS(5758),
    [anon_sym_EQ_EQ] = ACTIONS(2988),
    [anon_sym_GT] = ACTIONS(5758),
    [anon_sym_GT_EQ] = ACTIONS(2988),
    [anon_sym_GT_GT] = ACTIONS(5758),
    [anon_sym_GT_GT_EQ] = ACTIONS(2988),
    [anon_sym_PIPE] = ACTIONS(5758),
    [anon_sym_PIPE_EQ] = ACTIONS(2988),
    [anon_sym_PIPE_PIPE] = ACTIONS(2988),
    [anon_sym_QMARK] = ACTIONS(2988),
    [anon_sym_DOT_DOT] = ACTIONS(5758),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2988),
    [anon_sym_as] = ACTIONS(2988),
    [sym_line_comment] = ACTIONS(7),
  },
  [2078] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym_LPAREN] = ACTIONS(2992),
    [anon_sym_RBRACE] = ACTIONS(2992),
    [anon_sym_LBRACK] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(5762),
    [anon_sym_STAR] = ACTIONS(5762),
    [anon_sym_AMP] = ACTIONS(5762),
    [anon_sym_DASH] = ACTIONS(5762),
    [anon_sym_DOT] = ACTIONS(5762),
    [anon_sym_DASH_EQ] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(5932),
    [anon_sym_BANG_EQ] = ACTIONS(2992),
    [anon_sym_STAR_EQ] = ACTIONS(2992),
    [anon_sym_SLASH] = ACTIONS(5762),
    [anon_sym_SLASH_EQ] = ACTIONS(2992),
    [anon_sym_AMP_AMP] = ACTIONS(2992),
    [anon_sym_AMP_EQ] = ACTIONS(2992),
    [anon_sym_PERCENT] = ACTIONS(5762),
    [anon_sym_PERCENT_EQ] = ACTIONS(2992),
    [anon_sym_CARET] = ACTIONS(5762),
    [anon_sym_CARET_EQ] = ACTIONS(2992),
    [anon_sym_PLUS_EQ] = ACTIONS(2992),
    [anon_sym_LT] = ACTIONS(5762),
    [anon_sym_LT_LT] = ACTIONS(5762),
    [anon_sym_LT_LT_EQ] = ACTIONS(2992),
    [anon_sym_LT_EQ] = ACTIONS(2992),
    [anon_sym_EQ] = ACTIONS(5762),
    [anon_sym_EQ_EQ] = ACTIONS(2992),
    [anon_sym_GT] = ACTIONS(5762),
    [anon_sym_GT_EQ] = ACTIONS(2992),
    [anon_sym_GT_GT] = ACTIONS(5762),
    [anon_sym_GT_GT_EQ] = ACTIONS(2992),
    [anon_sym_PIPE] = ACTIONS(5762),
    [anon_sym_PIPE_EQ] = ACTIONS(2992),
    [anon_sym_PIPE_PIPE] = ACTIONS(2992),
    [anon_sym_QMARK] = ACTIONS(2992),
    [anon_sym_DOT_DOT] = ACTIONS(5762),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2992),
    [anon_sym_as] = ACTIONS(2992),
    [sym_line_comment] = ACTIONS(7),
  },
  [2079] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(2668),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [2080] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(5934),
    [sym_line_comment] = ACTIONS(7),
  },
  [2081] = {
    [sym_else_tail] = STATE(1378),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2012),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_RBRACK] = ACTIONS(2012),
    [anon_sym_PLUS] = ACTIONS(2014),
    [anon_sym_STAR] = ACTIONS(2014),
    [anon_sym_COMMA] = ACTIONS(2012),
    [anon_sym_AMP] = ACTIONS(2014),
    [anon_sym_DASH] = ACTIONS(2014),
    [anon_sym_DOT] = ACTIONS(2014),
    [anon_sym_DASH_EQ] = ACTIONS(2012),
    [anon_sym_BANG_EQ] = ACTIONS(2012),
    [anon_sym_STAR_EQ] = ACTIONS(2012),
    [anon_sym_SLASH] = ACTIONS(2014),
    [anon_sym_SLASH_EQ] = ACTIONS(2012),
    [anon_sym_AMP_AMP] = ACTIONS(2012),
    [anon_sym_AMP_EQ] = ACTIONS(2012),
    [anon_sym_PERCENT] = ACTIONS(2014),
    [anon_sym_PERCENT_EQ] = ACTIONS(2012),
    [anon_sym_CARET] = ACTIONS(2014),
    [anon_sym_CARET_EQ] = ACTIONS(2012),
    [anon_sym_PLUS_EQ] = ACTIONS(2012),
    [anon_sym_LT] = ACTIONS(2014),
    [anon_sym_LT_LT] = ACTIONS(2014),
    [anon_sym_LT_LT_EQ] = ACTIONS(2012),
    [anon_sym_LT_EQ] = ACTIONS(2012),
    [anon_sym_EQ] = ACTIONS(2014),
    [anon_sym_EQ_EQ] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2014),
    [anon_sym_GT_EQ] = ACTIONS(2012),
    [anon_sym_GT_GT] = ACTIONS(2014),
    [anon_sym_GT_GT_EQ] = ACTIONS(2012),
    [anon_sym_PIPE] = ACTIONS(2014),
    [anon_sym_PIPE_EQ] = ACTIONS(2012),
    [anon_sym_PIPE_PIPE] = ACTIONS(2012),
    [anon_sym_QMARK] = ACTIONS(2012),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2012),
    [anon_sym_as] = ACTIONS(2012),
    [anon_sym_else] = ACTIONS(5936),
    [sym_line_comment] = ACTIONS(7),
  },
  [2082] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2220),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_STAR] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(2220),
    [anon_sym_AMP] = ACTIONS(2821),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2823),
    [anon_sym_BANG_EQ] = ACTIONS(2825),
    [anon_sym_STAR_EQ] = ACTIONS(2823),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_SLASH_EQ] = ACTIONS(2823),
    [anon_sym_AMP_AMP] = ACTIONS(2827),
    [anon_sym_AMP_EQ] = ACTIONS(2823),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_PERCENT_EQ] = ACTIONS(2823),
    [anon_sym_CARET] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2823),
    [anon_sym_PLUS_EQ] = ACTIONS(2823),
    [anon_sym_LT] = ACTIONS(2831),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_LT_LT_EQ] = ACTIONS(2823),
    [anon_sym_LT_EQ] = ACTIONS(2825),
    [anon_sym_EQ] = ACTIONS(2835),
    [anon_sym_EQ_EQ] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2831),
    [anon_sym_GT_EQ] = ACTIONS(2825),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_GT_GT_EQ] = ACTIONS(2823),
    [anon_sym_PIPE] = ACTIONS(2837),
    [anon_sym_PIPE_EQ] = ACTIONS(2823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2839),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(2841),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2843),
    [anon_sym_as] = ACTIONS(2845),
    [sym_line_comment] = ACTIONS(7),
  },
  [2083] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2591),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [2084] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_STAR] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [2085] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2601),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_STAR] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(2601),
    [anon_sym_AMP] = ACTIONS(2821),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2601),
    [anon_sym_BANG_EQ] = ACTIONS(2825),
    [anon_sym_STAR_EQ] = ACTIONS(2601),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_SLASH_EQ] = ACTIONS(2601),
    [anon_sym_AMP_AMP] = ACTIONS(2827),
    [anon_sym_AMP_EQ] = ACTIONS(2601),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_PERCENT_EQ] = ACTIONS(2601),
    [anon_sym_CARET] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2601),
    [anon_sym_PLUS_EQ] = ACTIONS(2601),
    [anon_sym_LT] = ACTIONS(2831),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_LT_LT_EQ] = ACTIONS(2601),
    [anon_sym_LT_EQ] = ACTIONS(2825),
    [anon_sym_EQ] = ACTIONS(2603),
    [anon_sym_EQ_EQ] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2831),
    [anon_sym_GT_EQ] = ACTIONS(2825),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_GT_GT_EQ] = ACTIONS(2601),
    [anon_sym_PIPE] = ACTIONS(2837),
    [anon_sym_PIPE_EQ] = ACTIONS(2601),
    [anon_sym_PIPE_PIPE] = ACTIONS(2839),
    [anon_sym_QMARK] = ACTIONS(2601),
    [anon_sym_DOT_DOT] = ACTIONS(2841),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2843),
    [anon_sym_as] = ACTIONS(2601),
    [sym_line_comment] = ACTIONS(7),
  },
  [2086] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_STAR] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(2821),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2837),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [2087] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_STAR] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(2821),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2825),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2831),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2825),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2831),
    [anon_sym_GT_EQ] = ACTIONS(2825),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2837),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [2088] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_STAR] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(2821),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [2089] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_STAR] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2591),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [2090] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2605),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_STAR] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(2605),
    [anon_sym_AMP] = ACTIONS(2821),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2605),
    [anon_sym_BANG_EQ] = ACTIONS(2825),
    [anon_sym_STAR_EQ] = ACTIONS(2605),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_SLASH_EQ] = ACTIONS(2605),
    [anon_sym_AMP_AMP] = ACTIONS(2827),
    [anon_sym_AMP_EQ] = ACTIONS(2605),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_PERCENT_EQ] = ACTIONS(2605),
    [anon_sym_CARET] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2605),
    [anon_sym_PLUS_EQ] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(2831),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_LT_LT_EQ] = ACTIONS(2605),
    [anon_sym_LT_EQ] = ACTIONS(2825),
    [anon_sym_EQ] = ACTIONS(2607),
    [anon_sym_EQ_EQ] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2831),
    [anon_sym_GT_EQ] = ACTIONS(2825),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_GT_GT_EQ] = ACTIONS(2605),
    [anon_sym_PIPE] = ACTIONS(2837),
    [anon_sym_PIPE_EQ] = ACTIONS(2605),
    [anon_sym_PIPE_PIPE] = ACTIONS(2839),
    [anon_sym_QMARK] = ACTIONS(2605),
    [anon_sym_DOT_DOT] = ACTIONS(2841),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2843),
    [anon_sym_as] = ACTIONS(2605),
    [sym_line_comment] = ACTIONS(7),
  },
  [2091] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_STAR] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(2821),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [2092] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_STAR] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(2821),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2825),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2827),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2831),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2825),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2831),
    [anon_sym_GT_EQ] = ACTIONS(2825),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2837),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [2093] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2609),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_STAR] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(2609),
    [anon_sym_AMP] = ACTIONS(2821),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2609),
    [anon_sym_BANG_EQ] = ACTIONS(2825),
    [anon_sym_STAR_EQ] = ACTIONS(2609),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_SLASH_EQ] = ACTIONS(2609),
    [anon_sym_AMP_AMP] = ACTIONS(2827),
    [anon_sym_AMP_EQ] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_PERCENT_EQ] = ACTIONS(2609),
    [anon_sym_CARET] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2609),
    [anon_sym_PLUS_EQ] = ACTIONS(2609),
    [anon_sym_LT] = ACTIONS(2831),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_LT_LT_EQ] = ACTIONS(2609),
    [anon_sym_LT_EQ] = ACTIONS(2825),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_EQ_EQ] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2831),
    [anon_sym_GT_EQ] = ACTIONS(2825),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_GT_GT_EQ] = ACTIONS(2609),
    [anon_sym_PIPE] = ACTIONS(2837),
    [anon_sym_PIPE_EQ] = ACTIONS(2609),
    [anon_sym_PIPE_PIPE] = ACTIONS(2839),
    [anon_sym_QMARK] = ACTIONS(2609),
    [anon_sym_DOT_DOT] = ACTIONS(2611),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2609),
    [anon_sym_as] = ACTIONS(2609),
    [sym_line_comment] = ACTIONS(7),
  },
  [2094] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(5938),
    [sym_mutable_specifier] = ACTIONS(5938),
    [sym_line_comment] = ACTIONS(7),
  },
  [2095] = {
    [sym_function_modifiers] = STATE(2098),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1319),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(2673),
    [sym_array_type] = STATE(1319),
    [sym_function_type] = STATE(1319),
    [sym_tuple_type] = STATE(1319),
    [sym_unit_type] = STATE(1319),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(1319),
    [sym_reference_type] = STATE(1319),
    [sym_pointer_type] = STATE(1319),
    [sym_empty_type] = STATE(1319),
    [sym_dynamic_type] = STATE(1319),
    [sym_macro_invocation] = STATE(1319),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(2100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(4717),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(4719),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4721),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_mutable_specifier] = ACTIONS(5940),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4723),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2096] = {
    [sym_parameters] = STATE(2674),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [sym_line_comment] = ACTIONS(7),
  },
  [2097] = {
    [sym_parameters] = STATE(2675),
    [sym_type_arguments] = STATE(1330),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(773),
    [anon_sym_RBRACK] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(2633),
    [anon_sym_STAR] = ACTIONS(2633),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_DASH] = ACTIONS(2633),
    [anon_sym_DOT] = ACTIONS(2633),
    [anon_sym_DASH_EQ] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(2635),
    [anon_sym_BANG] = ACTIONS(557),
    [anon_sym_BANG_EQ] = ACTIONS(773),
    [anon_sym_STAR_EQ] = ACTIONS(773),
    [anon_sym_SLASH] = ACTIONS(2633),
    [anon_sym_SLASH_EQ] = ACTIONS(773),
    [anon_sym_AMP_AMP] = ACTIONS(773),
    [anon_sym_AMP_EQ] = ACTIONS(773),
    [anon_sym_PERCENT] = ACTIONS(2633),
    [anon_sym_PERCENT_EQ] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(2633),
    [anon_sym_CARET_EQ] = ACTIONS(773),
    [anon_sym_PLUS_EQ] = ACTIONS(773),
    [anon_sym_LT] = ACTIONS(2637),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_LT_LT_EQ] = ACTIONS(773),
    [anon_sym_LT_EQ] = ACTIONS(773),
    [anon_sym_EQ] = ACTIONS(2633),
    [anon_sym_EQ_EQ] = ACTIONS(773),
    [anon_sym_GT] = ACTIONS(2633),
    [anon_sym_GT_EQ] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_GT_GT_EQ] = ACTIONS(773),
    [anon_sym_PIPE] = ACTIONS(2633),
    [anon_sym_PIPE_EQ] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(773),
    [anon_sym_QMARK] = ACTIONS(773),
    [anon_sym_DOT_DOT] = ACTIONS(2633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(773),
    [anon_sym_as] = ACTIONS(773),
    [sym_line_comment] = ACTIONS(7),
  },
  [2098] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2678),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_fn] = ACTIONS(5942),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5944),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [2099] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(5946),
    [sym_line_comment] = ACTIONS(7),
  },
  [2100] = {
    [sym_parameters] = STATE(2674),
    [sym_type_arguments] = STATE(1340),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(783),
    [anon_sym_RBRACK] = ACTIONS(783),
    [anon_sym_PLUS] = ACTIONS(785),
    [anon_sym_STAR] = ACTIONS(785),
    [anon_sym_COMMA] = ACTIONS(783),
    [anon_sym_AMP] = ACTIONS(785),
    [anon_sym_DASH] = ACTIONS(785),
    [anon_sym_DOT] = ACTIONS(785),
    [anon_sym_DASH_EQ] = ACTIONS(783),
    [anon_sym_BANG_EQ] = ACTIONS(783),
    [anon_sym_STAR_EQ] = ACTIONS(783),
    [anon_sym_SLASH] = ACTIONS(785),
    [anon_sym_SLASH_EQ] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_AMP_EQ] = ACTIONS(783),
    [anon_sym_PERCENT] = ACTIONS(785),
    [anon_sym_PERCENT_EQ] = ACTIONS(783),
    [anon_sym_CARET] = ACTIONS(785),
    [anon_sym_CARET_EQ] = ACTIONS(783),
    [anon_sym_PLUS_EQ] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(2637),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_LT_LT_EQ] = ACTIONS(783),
    [anon_sym_LT_EQ] = ACTIONS(783),
    [anon_sym_EQ] = ACTIONS(785),
    [anon_sym_EQ_EQ] = ACTIONS(783),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_GT_EQ] = ACTIONS(783),
    [anon_sym_GT_GT] = ACTIONS(785),
    [anon_sym_GT_GT_EQ] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PIPE_EQ] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_DOT_DOT] = ACTIONS(785),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(783),
    [anon_sym_as] = ACTIONS(783),
    [sym_line_comment] = ACTIONS(7),
  },
  [2101] = {
    [sym_function_modifiers] = STATE(785),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2611),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(786),
    [sym_array_type] = STATE(2611),
    [sym_function_type] = STATE(2611),
    [sym_tuple_type] = STATE(2611),
    [sym_unit_type] = STATE(2611),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2611),
    [sym_reference_type] = STATE(2611),
    [sym_pointer_type] = STATE(2611),
    [sym_empty_type] = STATE(2611),
    [sym_dynamic_type] = STATE(2611),
    [sym_macro_invocation] = STATE(2611),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(787),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1656),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1658),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1660),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1662),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2102] = {
    [sym_function_modifiers] = STATE(785),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2616),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(786),
    [sym_array_type] = STATE(2616),
    [sym_function_type] = STATE(2616),
    [sym_tuple_type] = STATE(2616),
    [sym_unit_type] = STATE(2616),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2616),
    [sym_reference_type] = STATE(2616),
    [sym_pointer_type] = STATE(2616),
    [sym_empty_type] = STATE(2616),
    [sym_abstract_type] = STATE(2617),
    [sym_dynamic_type] = STATE(2616),
    [sym_macro_invocation] = STATE(2616),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(787),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1656),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1658),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1660),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1662),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2103] = {
    [sym_function_modifiers] = STATE(785),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2618),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(786),
    [sym_array_type] = STATE(2618),
    [sym_function_type] = STATE(2618),
    [sym_tuple_type] = STATE(2618),
    [sym_unit_type] = STATE(2618),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2618),
    [sym_reference_type] = STATE(2618),
    [sym_pointer_type] = STATE(2618),
    [sym_empty_type] = STATE(2618),
    [sym_abstract_type] = STATE(2619),
    [sym_dynamic_type] = STATE(2618),
    [sym_macro_invocation] = STATE(2618),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(787),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1656),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1658),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1660),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1662),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2104] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2988),
    [anon_sym_LPAREN] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2988),
    [anon_sym_RBRACK] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(5758),
    [anon_sym_STAR] = ACTIONS(5758),
    [anon_sym_COMMA] = ACTIONS(2988),
    [anon_sym_AMP] = ACTIONS(5758),
    [anon_sym_DASH] = ACTIONS(5758),
    [anon_sym_DOT] = ACTIONS(5758),
    [anon_sym_DASH_EQ] = ACTIONS(2988),
    [anon_sym_DASH_GT] = ACTIONS(5948),
    [anon_sym_BANG_EQ] = ACTIONS(2988),
    [anon_sym_STAR_EQ] = ACTIONS(2988),
    [anon_sym_SLASH] = ACTIONS(5758),
    [anon_sym_SLASH_EQ] = ACTIONS(2988),
    [anon_sym_AMP_AMP] = ACTIONS(2988),
    [anon_sym_AMP_EQ] = ACTIONS(2988),
    [anon_sym_PERCENT] = ACTIONS(5758),
    [anon_sym_PERCENT_EQ] = ACTIONS(2988),
    [anon_sym_CARET] = ACTIONS(5758),
    [anon_sym_CARET_EQ] = ACTIONS(2988),
    [anon_sym_PLUS_EQ] = ACTIONS(2988),
    [anon_sym_LT] = ACTIONS(5758),
    [anon_sym_LT_LT] = ACTIONS(5758),
    [anon_sym_LT_LT_EQ] = ACTIONS(2988),
    [anon_sym_LT_EQ] = ACTIONS(2988),
    [anon_sym_EQ] = ACTIONS(5758),
    [anon_sym_EQ_EQ] = ACTIONS(2988),
    [anon_sym_GT] = ACTIONS(5758),
    [anon_sym_GT_EQ] = ACTIONS(2988),
    [anon_sym_GT_GT] = ACTIONS(5758),
    [anon_sym_GT_GT_EQ] = ACTIONS(2988),
    [anon_sym_PIPE] = ACTIONS(5758),
    [anon_sym_PIPE_EQ] = ACTIONS(2988),
    [anon_sym_PIPE_PIPE] = ACTIONS(2988),
    [anon_sym_QMARK] = ACTIONS(2988),
    [anon_sym_DOT_DOT] = ACTIONS(5758),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2988),
    [anon_sym_as] = ACTIONS(2988),
    [sym_line_comment] = ACTIONS(7),
  },
  [2105] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym_LPAREN] = ACTIONS(2992),
    [anon_sym_LBRACK] = ACTIONS(2992),
    [anon_sym_RBRACK] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(5762),
    [anon_sym_STAR] = ACTIONS(5762),
    [anon_sym_COMMA] = ACTIONS(2992),
    [anon_sym_AMP] = ACTIONS(5762),
    [anon_sym_DASH] = ACTIONS(5762),
    [anon_sym_DOT] = ACTIONS(5762),
    [anon_sym_DASH_EQ] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(5950),
    [anon_sym_BANG_EQ] = ACTIONS(2992),
    [anon_sym_STAR_EQ] = ACTIONS(2992),
    [anon_sym_SLASH] = ACTIONS(5762),
    [anon_sym_SLASH_EQ] = ACTIONS(2992),
    [anon_sym_AMP_AMP] = ACTIONS(2992),
    [anon_sym_AMP_EQ] = ACTIONS(2992),
    [anon_sym_PERCENT] = ACTIONS(5762),
    [anon_sym_PERCENT_EQ] = ACTIONS(2992),
    [anon_sym_CARET] = ACTIONS(5762),
    [anon_sym_CARET_EQ] = ACTIONS(2992),
    [anon_sym_PLUS_EQ] = ACTIONS(2992),
    [anon_sym_LT] = ACTIONS(5762),
    [anon_sym_LT_LT] = ACTIONS(5762),
    [anon_sym_LT_LT_EQ] = ACTIONS(2992),
    [anon_sym_LT_EQ] = ACTIONS(2992),
    [anon_sym_EQ] = ACTIONS(5762),
    [anon_sym_EQ_EQ] = ACTIONS(2992),
    [anon_sym_GT] = ACTIONS(5762),
    [anon_sym_GT_EQ] = ACTIONS(2992),
    [anon_sym_GT_GT] = ACTIONS(5762),
    [anon_sym_GT_GT_EQ] = ACTIONS(2992),
    [anon_sym_PIPE] = ACTIONS(5762),
    [anon_sym_PIPE_EQ] = ACTIONS(2992),
    [anon_sym_PIPE_PIPE] = ACTIONS(2992),
    [anon_sym_QMARK] = ACTIONS(2992),
    [anon_sym_DOT_DOT] = ACTIONS(5762),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2992),
    [anon_sym_as] = ACTIONS(2992),
    [sym_line_comment] = ACTIONS(7),
  },
  [2106] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(2683),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [2107] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(5952),
    [anon_sym_RBRACK] = ACTIONS(5952),
    [anon_sym_COMMA] = ACTIONS(5952),
    [sym_line_comment] = ACTIONS(7),
  },
  [2108] = {
    [sym_meta_item] = STATE(2685),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(5954),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(727),
  },
  [2109] = {
    [aux_sym_meta_item_repeat1] = STATE(2687),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(5954),
    [anon_sym_COMMA] = ACTIONS(5956),
    [sym_line_comment] = ACTIONS(7),
  },
  [2110] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2156),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(2156),
    [sym_function_type] = STATE(2156),
    [sym_tuple_type] = STATE(2156),
    [sym_unit_type] = STATE(2156),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2156),
    [sym_reference_type] = STATE(2156),
    [sym_pointer_type] = STATE(2156),
    [sym_empty_type] = STATE(2156),
    [sym_abstract_type] = STATE(2157),
    [sym_dynamic_type] = STATE(2156),
    [sym_macro_invocation] = STATE(2156),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2111] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2158),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(2158),
    [sym_function_type] = STATE(2158),
    [sym_tuple_type] = STATE(2158),
    [sym_unit_type] = STATE(2158),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2158),
    [sym_reference_type] = STATE(2158),
    [sym_pointer_type] = STATE(2158),
    [sym_empty_type] = STATE(2158),
    [sym_abstract_type] = STATE(2159),
    [sym_dynamic_type] = STATE(2158),
    [sym_macro_invocation] = STATE(2158),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2112] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5958),
    [anon_sym_LPAREN] = ACTIONS(5958),
    [anon_sym_RPAREN] = ACTIONS(5958),
    [anon_sym_LBRACE] = ACTIONS(5958),
    [anon_sym_RBRACE] = ACTIONS(5958),
    [anon_sym_RBRACK] = ACTIONS(5958),
    [anon_sym_COLON] = ACTIONS(5958),
    [anon_sym_PLUS] = ACTIONS(5958),
    [anon_sym_COMMA] = ACTIONS(5958),
    [anon_sym_EQ] = ACTIONS(5958),
    [anon_sym_GT] = ACTIONS(5958),
    [anon_sym_PIPE] = ACTIONS(5958),
    [anon_sym_as] = ACTIONS(5958),
    [anon_sym_where] = ACTIONS(5958),
    [sym_line_comment] = ACTIONS(7),
  },
  [2113] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1470),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(1470),
    [sym_function_type] = STATE(1470),
    [sym_tuple_type] = STATE(1470),
    [sym_unit_type] = STATE(1470),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1470),
    [sym_reference_type] = STATE(1470),
    [sym_pointer_type] = STATE(1470),
    [sym_empty_type] = STATE(1470),
    [sym_dynamic_type] = STATE(1470),
    [sym_macro_invocation] = STATE(1470),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2114] = {
    [sym_function_modifiers] = STATE(378),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2156),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(380),
    [sym_array_type] = STATE(2156),
    [sym_function_type] = STATE(2156),
    [sym_tuple_type] = STATE(2156),
    [sym_unit_type] = STATE(2156),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2156),
    [sym_reference_type] = STATE(2156),
    [sym_pointer_type] = STATE(2156),
    [sym_empty_type] = STATE(2156),
    [sym_abstract_type] = STATE(2157),
    [sym_dynamic_type] = STATE(2156),
    [sym_macro_invocation] = STATE(2156),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(381),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(741),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(745),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(747),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2115] = {
    [sym_function_modifiers] = STATE(378),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2158),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(380),
    [sym_array_type] = STATE(2158),
    [sym_function_type] = STATE(2158),
    [sym_tuple_type] = STATE(2158),
    [sym_unit_type] = STATE(2158),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2158),
    [sym_reference_type] = STATE(2158),
    [sym_pointer_type] = STATE(2158),
    [sym_empty_type] = STATE(2158),
    [sym_abstract_type] = STATE(2159),
    [sym_dynamic_type] = STATE(2158),
    [sym_macro_invocation] = STATE(2158),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(381),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(741),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(745),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(747),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2116] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5960),
    [anon_sym_LPAREN] = ACTIONS(5960),
    [anon_sym_RPAREN] = ACTIONS(5960),
    [anon_sym_LBRACE] = ACTIONS(5960),
    [anon_sym_RBRACE] = ACTIONS(5960),
    [anon_sym_RBRACK] = ACTIONS(5960),
    [anon_sym_COLON] = ACTIONS(5960),
    [anon_sym_PLUS] = ACTIONS(5960),
    [anon_sym_COMMA] = ACTIONS(5960),
    [anon_sym_EQ] = ACTIONS(5960),
    [anon_sym_GT] = ACTIONS(5960),
    [anon_sym_PIPE] = ACTIONS(5960),
    [anon_sym_as] = ACTIONS(5960),
    [anon_sym_where] = ACTIONS(5960),
    [sym_line_comment] = ACTIONS(7),
  },
  [2117] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(3036),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_COMMA] = ACTIONS(3036),
    [sym_line_comment] = ACTIONS(7),
  },
  [2118] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(3040),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_COMMA] = ACTIONS(3040),
    [sym_line_comment] = ACTIONS(7),
  },
  [2119] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5962),
    [anon_sym_LPAREN] = ACTIONS(5962),
    [anon_sym_RPAREN] = ACTIONS(5962),
    [anon_sym_LBRACE] = ACTIONS(5962),
    [anon_sym_RBRACE] = ACTIONS(5962),
    [anon_sym_RBRACK] = ACTIONS(5962),
    [anon_sym_COLON] = ACTIONS(5962),
    [anon_sym_PLUS] = ACTIONS(5962),
    [anon_sym_COMMA] = ACTIONS(5962),
    [anon_sym_DASH_GT] = ACTIONS(5962),
    [anon_sym_EQ] = ACTIONS(5962),
    [anon_sym_GT] = ACTIONS(5962),
    [anon_sym_PIPE] = ACTIONS(5962),
    [anon_sym_as] = ACTIONS(5962),
    [anon_sym_where] = ACTIONS(5962),
    [sym_line_comment] = ACTIONS(7),
  },
  [2120] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(5964),
    [anon_sym_COLON] = ACTIONS(2914),
    [anon_sym_COMMA] = ACTIONS(5964),
    [sym_line_comment] = ACTIONS(7),
  },
  [2121] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(5964),
    [anon_sym_COMMA] = ACTIONS(5964),
    [sym_line_comment] = ACTIONS(7),
  },
  [2122] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(5964),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_COMMA] = ACTIONS(5964),
    [sym_line_comment] = ACTIONS(7),
  },
  [2123] = {
    [sym_function_modifiers] = STATE(370),
    [sym_self_parameter] = STATE(2121),
    [sym_variadic_parameter] = STATE(2121),
    [sym_parameter] = STATE(2121),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2122),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(839),
    [sym_array_type] = STATE(2122),
    [sym_function_type] = STATE(2122),
    [sym_tuple_type] = STATE(2122),
    [sym_unit_type] = STATE(2122),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2122),
    [sym_reference_type] = STATE(2122),
    [sym_pointer_type] = STATE(2122),
    [sym_empty_type] = STATE(2122),
    [sym_abstract_type] = STATE(2121),
    [sym_dynamic_type] = STATE(2122),
    [sym_macro_invocation] = STATE(2122),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [sym_reference_pattern_in_parameter] = STATE(840),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_RPAREN] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(1740),
    [anon_sym_i8] = ACTIONS(1740),
    [anon_sym_u16] = ACTIONS(1740),
    [anon_sym_i16] = ACTIONS(1740),
    [anon_sym_u32] = ACTIONS(1740),
    [anon_sym_i32] = ACTIONS(1740),
    [anon_sym_u64] = ACTIONS(1740),
    [anon_sym_i64] = ACTIONS(1740),
    [anon_sym_u128] = ACTIONS(1740),
    [anon_sym_i128] = ACTIONS(1740),
    [anon_sym_isize] = ACTIONS(1740),
    [anon_sym_usize] = ACTIONS(1740),
    [anon_sym_f32] = ACTIONS(1740),
    [anon_sym_f64] = ACTIONS(1740),
    [anon_sym_bool] = ACTIONS(1740),
    [anon_sym_str] = ACTIONS(1740),
    [anon_sym_char] = ACTIONS(1740),
    [anon_sym__] = ACTIONS(4770),
    [anon_sym_AMP] = ACTIONS(1744),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1746),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(1748),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_union] = ACTIONS(1752),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(1754),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1756),
    [sym_self] = ACTIONS(1758),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2124] = {
    [aux_sym_parameters_repeat1] = STATE(2124),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(5964),
    [anon_sym_COMMA] = ACTIONS(5968),
    [sym_line_comment] = ACTIONS(7),
  },
  [2125] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(1688),
    [anon_sym_COLON] = ACTIONS(3042),
    [anon_sym_PLUS] = ACTIONS(1688),
    [anon_sym_COMMA] = ACTIONS(1688),
    [sym_line_comment] = ACTIONS(7),
  },
  [2126] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(3044),
    [sym_line_comment] = ACTIONS(7),
  },
  [2127] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(385),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(798),
    [sym_array_type] = STATE(385),
    [sym_function_type] = STATE(385),
    [sym_tuple_type] = STATE(385),
    [sym_unit_type] = STATE(385),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(385),
    [sym_reference_type] = STATE(385),
    [sym_pointer_type] = STATE(385),
    [sym_empty_type] = STATE(385),
    [sym_dynamic_type] = STATE(385),
    [sym_macro_invocation] = STATE(385),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [sym_tuple_pattern_in_parameter] = STATE(429),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5971),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(5973),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5975),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2128] = {
    [sym_parameters] = STATE(800),
    [sym_type_arguments] = STATE(400),
    [aux_sym_tuple_pattern_in_parameter_repeat1] = STATE(1557),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_RPAREN] = ACTIONS(3044),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_COMMA] = ACTIONS(3050),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_BANG] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [2129] = {
    [sym_parameters] = STATE(800),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_RPAREN] = ACTIONS(773),
    [anon_sym_COLON] = ACTIONS(3052),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_BANG] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [2130] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(5977),
    [anon_sym_COMMA] = ACTIONS(5977),
    [anon_sym_COLON_COLON] = ACTIONS(781),
    [sym_line_comment] = ACTIONS(7),
  },
  [2131] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1479),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(1479),
    [sym_function_type] = STATE(1479),
    [sym_tuple_type] = STATE(1479),
    [sym_unit_type] = STATE(1479),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1479),
    [sym_reference_type] = STATE(1479),
    [sym_pointer_type] = STATE(1479),
    [sym_empty_type] = STATE(1479),
    [sym_dynamic_type] = STATE(1479),
    [sym_macro_invocation] = STATE(1479),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(5979),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2132] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2694),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(2694),
    [sym_function_type] = STATE(2694),
    [sym_tuple_type] = STATE(2694),
    [sym_unit_type] = STATE(2694),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2694),
    [sym_reference_type] = STATE(2694),
    [sym_pointer_type] = STATE(2694),
    [sym_empty_type] = STATE(2694),
    [sym_abstract_type] = STATE(1559),
    [sym_dynamic_type] = STATE(2694),
    [sym_macro_invocation] = STATE(2694),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2133] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2695),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(2695),
    [sym_function_type] = STATE(2695),
    [sym_tuple_type] = STATE(2695),
    [sym_unit_type] = STATE(2695),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2695),
    [sym_reference_type] = STATE(2695),
    [sym_pointer_type] = STATE(2695),
    [sym_empty_type] = STATE(2695),
    [sym_abstract_type] = STATE(1561),
    [sym_dynamic_type] = STATE(2695),
    [sym_macro_invocation] = STATE(2695),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2134] = {
    [sym_ref_pattern] = STATE(895),
    [sym_reference_pattern_in_parameter] = STATE(895),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(1848),
    [anon_sym_COMMA] = ACTIONS(4776),
    [anon_sym_AMP] = ACTIONS(2936),
    [anon_sym_ref] = ACTIONS(821),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5981),
  },
  [2135] = {
    [sym_tuple_pattern_in_parameter] = STATE(899),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(4802),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5983),
  },
  [2136] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(5977),
    [anon_sym_COMMA] = ACTIONS(5977),
    [sym_line_comment] = ACTIONS(7),
  },
  [2137] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5554),
    [anon_sym_LPAREN] = ACTIONS(5554),
    [anon_sym_RPAREN] = ACTIONS(5554),
    [anon_sym_LBRACE] = ACTIONS(5554),
    [anon_sym_RBRACE] = ACTIONS(5554),
    [anon_sym_RBRACK] = ACTIONS(5554),
    [anon_sym_COLON] = ACTIONS(5554),
    [anon_sym_PLUS] = ACTIONS(5554),
    [anon_sym_COMMA] = ACTIONS(5554),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_GT] = ACTIONS(5554),
    [anon_sym_PIPE] = ACTIONS(5554),
    [anon_sym_as] = ACTIONS(5554),
    [anon_sym_where] = ACTIONS(5554),
    [sym_line_comment] = ACTIONS(7),
  },
  [2138] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1972),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1972),
    [sym_unary_expression] = STATE(1972),
    [sym_try_expression] = STATE(1972),
    [sym_reference_expression] = STATE(1972),
    [sym_binary_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1972),
    [sym_call_expression] = STATE(1972),
    [sym_array_expression] = STATE(1972),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_tuple_expression] = STATE(1972),
    [sym_unit_expression] = STATE(1972),
    [sym_struct_expression] = STATE(1972),
    [sym_if_expression] = STATE(1972),
    [sym_if_let_expression] = STATE(1972),
    [sym_match_expression] = STATE(1972),
    [sym_while_expression] = STATE(1972),
    [sym_while_let_expression] = STATE(1972),
    [sym_loop_expression] = STATE(1972),
    [sym_for_expression] = STATE(1972),
    [sym_closure_expression] = STATE(1972),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1972),
    [sym_continue_expression] = STATE(1972),
    [sym_index_expression] = STATE(1972),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1972),
    [sym_block] = STATE(1972),
    [sym__literal] = STATE(1972),
    [sym_string_literal] = STATE(1972),
    [sym_boolean_literal] = STATE(1972),
    [sym_raw_string_literal] = ACTIONS(4375),
    [sym_float_literal] = ACTIONS(4375),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(5985),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(4375),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4375),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2139] = {
    [aux_sym_token_tree_repeat2] = STATE(1974),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(5985),
    [anon_sym_COMMA] = ACTIONS(5987),
    [sym_line_comment] = ACTIONS(7),
  },
  [2140] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5564),
    [anon_sym_LPAREN] = ACTIONS(5564),
    [anon_sym_RPAREN] = ACTIONS(5564),
    [anon_sym_LBRACE] = ACTIONS(5564),
    [anon_sym_RBRACE] = ACTIONS(5564),
    [anon_sym_RBRACK] = ACTIONS(5564),
    [anon_sym_COLON] = ACTIONS(5564),
    [anon_sym_PLUS] = ACTIONS(5564),
    [anon_sym_COMMA] = ACTIONS(5564),
    [anon_sym_EQ] = ACTIONS(5564),
    [anon_sym_GT] = ACTIONS(5564),
    [anon_sym_PIPE] = ACTIONS(5564),
    [anon_sym_as] = ACTIONS(5564),
    [anon_sym_where] = ACTIONS(5564),
    [sym_line_comment] = ACTIONS(7),
  },
  [2141] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(5985),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(623),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(623),
    [anon_sym_PLUS_EQ] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(623),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(643),
    [anon_sym_as] = ACTIONS(645),
    [sym_line_comment] = ACTIONS(7),
  },
  [2142] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(769),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(769),
    [sym_macro_invocation] = STATE(769),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(769),
    [sym_unary_expression] = STATE(769),
    [sym_try_expression] = STATE(769),
    [sym_reference_expression] = STATE(769),
    [sym_binary_expression] = STATE(769),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(769),
    [sym_call_expression] = STATE(769),
    [sym_array_expression] = STATE(769),
    [sym_parenthesized_expression] = STATE(769),
    [sym_tuple_expression] = STATE(769),
    [sym_unit_expression] = STATE(769),
    [sym_struct_expression] = STATE(769),
    [sym_if_expression] = STATE(769),
    [sym_if_let_expression] = STATE(769),
    [sym_match_expression] = STATE(769),
    [sym_while_expression] = STATE(769),
    [sym_while_let_expression] = STATE(769),
    [sym_loop_expression] = STATE(769),
    [sym_for_expression] = STATE(769),
    [sym_closure_expression] = STATE(769),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(769),
    [sym_continue_expression] = STATE(769),
    [sym_index_expression] = STATE(769),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(769),
    [sym_block] = STATE(769),
    [sym__literal] = STATE(769),
    [sym_string_literal] = STATE(769),
    [sym_boolean_literal] = STATE(769),
    [sym_raw_string_literal] = ACTIONS(1620),
    [sym_float_literal] = ACTIONS(1620),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_RBRACK] = ACTIONS(5985),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1620),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1620),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2143] = {
    [aux_sym_token_tree_repeat2] = STATE(789),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACK] = ACTIONS(5985),
    [anon_sym_COMMA] = ACTIONS(5989),
    [sym_line_comment] = ACTIONS(7),
  },
  [2144] = {
    [sym_function_modifiers] = STATE(854),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1479),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1664),
    [sym_array_type] = STATE(1479),
    [sym_function_type] = STATE(1479),
    [sym_tuple_type] = STATE(1479),
    [sym_unit_type] = STATE(1479),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1479),
    [sym_reference_type] = STATE(1479),
    [sym_pointer_type] = STATE(1479),
    [sym_empty_type] = STATE(1479),
    [sym_dynamic_type] = STATE(1479),
    [sym_macro_invocation] = STATE(1479),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(858),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1786),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1788),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1790),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2972),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2145] = {
    [sym_function_modifiers] = STATE(854),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1499),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1664),
    [sym_array_type] = STATE(1499),
    [sym_function_type] = STATE(1499),
    [sym_tuple_type] = STATE(1499),
    [sym_unit_type] = STATE(1499),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1499),
    [sym_reference_type] = STATE(1499),
    [sym_pointer_type] = STATE(1499),
    [sym_empty_type] = STATE(1499),
    [sym_abstract_type] = STATE(1500),
    [sym_dynamic_type] = STATE(1499),
    [sym_macro_invocation] = STATE(1499),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(858),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1786),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1788),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1790),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2972),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2146] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_COMMA] = ACTIONS(5991),
    [anon_sym_GT] = ACTIONS(5991),
    [sym_line_comment] = ACTIONS(7),
  },
  [2147] = {
    [sym_function_modifiers] = STATE(854),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1525),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1664),
    [sym_array_type] = STATE(1525),
    [sym_function_type] = STATE(1525),
    [sym_tuple_type] = STATE(1525),
    [sym_unit_type] = STATE(1525),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1525),
    [sym_reference_type] = STATE(1525),
    [sym_pointer_type] = STATE(1525),
    [sym_empty_type] = STATE(1525),
    [sym_abstract_type] = STATE(1526),
    [sym_dynamic_type] = STATE(1525),
    [sym_macro_invocation] = STATE(1525),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(858),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1786),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1788),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1790),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2972),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2148] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_COMMA] = ACTIONS(2988),
    [anon_sym_DASH_GT] = ACTIONS(5993),
    [anon_sym_GT] = ACTIONS(2988),
    [sym_line_comment] = ACTIONS(7),
  },
  [2149] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_COMMA] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(5995),
    [anon_sym_GT] = ACTIONS(2992),
    [sym_line_comment] = ACTIONS(7),
  },
  [2150] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5997),
    [anon_sym_LPAREN] = ACTIONS(5997),
    [anon_sym_RPAREN] = ACTIONS(5997),
    [anon_sym_LBRACE] = ACTIONS(5997),
    [anon_sym_RBRACE] = ACTIONS(5997),
    [anon_sym_RBRACK] = ACTIONS(5997),
    [anon_sym_COLON] = ACTIONS(5999),
    [anon_sym_PLUS] = ACTIONS(5997),
    [anon_sym_COMMA] = ACTIONS(5997),
    [anon_sym_COLON_COLON] = ACTIONS(5997),
    [anon_sym_EQ] = ACTIONS(5997),
    [anon_sym_GT] = ACTIONS(5997),
    [anon_sym_PIPE] = ACTIONS(5997),
    [anon_sym_as] = ACTIONS(5997),
    [anon_sym_for] = ACTIONS(5997),
    [anon_sym_where] = ACTIONS(5997),
    [sym_line_comment] = ACTIONS(7),
  },
  [2151] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_COMMA] = ACTIONS(6001),
    [anon_sym_GT] = ACTIONS(6001),
    [sym_line_comment] = ACTIONS(7),
  },
  [2152] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(2986),
    [anon_sym_COMMA] = ACTIONS(6001),
    [anon_sym_GT] = ACTIONS(6001),
    [sym_line_comment] = ACTIONS(7),
  },
  [2153] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(6001),
    [anon_sym_GT] = ACTIONS(6001),
    [sym_line_comment] = ACTIONS(7),
  },
  [2154] = {
    [sym_function_modifiers] = STATE(854),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2151),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2152),
    [sym_array_type] = STATE(2151),
    [sym_function_type] = STATE(2151),
    [sym_tuple_type] = STATE(2151),
    [sym_unit_type] = STATE(2151),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2151),
    [sym_type_binding] = STATE(2153),
    [sym_reference_type] = STATE(2151),
    [sym_pointer_type] = STATE(2151),
    [sym_empty_type] = STATE(2151),
    [sym_dynamic_type] = STATE(2151),
    [sym_macro_invocation] = STATE(2151),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(858),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1786),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1788),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_GT] = ACTIONS(6003),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1790),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1792),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2155] = {
    [aux_sym_type_arguments_repeat1] = STATE(2155),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(6005),
    [anon_sym_GT] = ACTIONS(6001),
    [sym_line_comment] = ACTIONS(7),
  },
  [2156] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6008),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_RPAREN] = ACTIONS(6008),
    [anon_sym_LBRACE] = ACTIONS(6008),
    [anon_sym_RBRACE] = ACTIONS(6008),
    [anon_sym_RBRACK] = ACTIONS(6008),
    [anon_sym_COLON] = ACTIONS(6008),
    [anon_sym_PLUS] = ACTIONS(6008),
    [anon_sym_COMMA] = ACTIONS(6008),
    [anon_sym_EQ] = ACTIONS(6008),
    [anon_sym_GT] = ACTIONS(6008),
    [anon_sym_PIPE] = ACTIONS(6008),
    [anon_sym_as] = ACTIONS(6008),
    [anon_sym_where] = ACTIONS(6008),
    [sym_line_comment] = ACTIONS(7),
  },
  [2157] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6008),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_RPAREN] = ACTIONS(6008),
    [anon_sym_LBRACE] = ACTIONS(6008),
    [anon_sym_RBRACE] = ACTIONS(6008),
    [anon_sym_RBRACK] = ACTIONS(6008),
    [anon_sym_COLON] = ACTIONS(6008),
    [anon_sym_PLUS] = ACTIONS(6008),
    [anon_sym_COMMA] = ACTIONS(6008),
    [anon_sym_EQ] = ACTIONS(6008),
    [anon_sym_GT] = ACTIONS(6008),
    [anon_sym_PIPE] = ACTIONS(6008),
    [anon_sym_as] = ACTIONS(6008),
    [anon_sym_where] = ACTIONS(6008),
    [sym_line_comment] = ACTIONS(7),
  },
  [2158] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6010),
    [anon_sym_LPAREN] = ACTIONS(6010),
    [anon_sym_RPAREN] = ACTIONS(6010),
    [anon_sym_LBRACE] = ACTIONS(6010),
    [anon_sym_RBRACE] = ACTIONS(6010),
    [anon_sym_RBRACK] = ACTIONS(6010),
    [anon_sym_COLON] = ACTIONS(6010),
    [anon_sym_PLUS] = ACTIONS(6010),
    [anon_sym_COMMA] = ACTIONS(6010),
    [anon_sym_EQ] = ACTIONS(6010),
    [anon_sym_GT] = ACTIONS(6010),
    [anon_sym_PIPE] = ACTIONS(6010),
    [anon_sym_as] = ACTIONS(6010),
    [anon_sym_where] = ACTIONS(6010),
    [sym_line_comment] = ACTIONS(7),
  },
  [2159] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6010),
    [anon_sym_LPAREN] = ACTIONS(6010),
    [anon_sym_RPAREN] = ACTIONS(6010),
    [anon_sym_LBRACE] = ACTIONS(6010),
    [anon_sym_RBRACE] = ACTIONS(6010),
    [anon_sym_RBRACK] = ACTIONS(6010),
    [anon_sym_COLON] = ACTIONS(6010),
    [anon_sym_PLUS] = ACTIONS(6010),
    [anon_sym_COMMA] = ACTIONS(6010),
    [anon_sym_EQ] = ACTIONS(6010),
    [anon_sym_GT] = ACTIONS(6010),
    [anon_sym_PIPE] = ACTIONS(6010),
    [anon_sym_as] = ACTIONS(6010),
    [anon_sym_where] = ACTIONS(6010),
    [sym_line_comment] = ACTIONS(7),
  },
  [2160] = {
    [sym_function_modifiers] = STATE(867),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1479),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(869),
    [sym_array_type] = STATE(1479),
    [sym_function_type] = STATE(1479),
    [sym_tuple_type] = STATE(1479),
    [sym_unit_type] = STATE(1479),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1479),
    [sym_reference_type] = STATE(1479),
    [sym_pointer_type] = STATE(1479),
    [sym_empty_type] = STATE(1479),
    [sym_dynamic_type] = STATE(1479),
    [sym_macro_invocation] = STATE(1479),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(870),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1806),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1808),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1810),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2161] = {
    [sym_function_modifiers] = STATE(867),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1499),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(869),
    [sym_array_type] = STATE(1499),
    [sym_function_type] = STATE(1499),
    [sym_tuple_type] = STATE(1499),
    [sym_unit_type] = STATE(1499),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1499),
    [sym_reference_type] = STATE(1499),
    [sym_pointer_type] = STATE(1499),
    [sym_empty_type] = STATE(1499),
    [sym_abstract_type] = STATE(1500),
    [sym_dynamic_type] = STATE(1499),
    [sym_macro_invocation] = STATE(1499),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(870),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1806),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1808),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1810),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2162] = {
    [sym_function_modifiers] = STATE(867),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1525),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(869),
    [sym_array_type] = STATE(1525),
    [sym_function_type] = STATE(1525),
    [sym_tuple_type] = STATE(1525),
    [sym_unit_type] = STATE(1525),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1525),
    [sym_reference_type] = STATE(1525),
    [sym_pointer_type] = STATE(1525),
    [sym_empty_type] = STATE(1525),
    [sym_abstract_type] = STATE(1526),
    [sym_dynamic_type] = STATE(1525),
    [sym_macro_invocation] = STATE(1525),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(870),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1806),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1808),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1810),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2163] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_DASH_GT] = ACTIONS(6012),
    [anon_sym_GT] = ACTIONS(2988),
    [sym_line_comment] = ACTIONS(7),
  },
  [2164] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(6014),
    [anon_sym_GT] = ACTIONS(2992),
    [sym_line_comment] = ACTIONS(7),
  },
  [2165] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6016),
    [anon_sym_RPAREN] = ACTIONS(6016),
    [anon_sym_RBRACE] = ACTIONS(6016),
    [anon_sym_COLON] = ACTIONS(6016),
    [anon_sym_COMMA] = ACTIONS(6016),
    [anon_sym_EQ] = ACTIONS(6016),
    [anon_sym_PIPE] = ACTIONS(6016),
    [anon_sym_in] = ACTIONS(6016),
    [sym_line_comment] = ACTIONS(7),
  },
  [2166] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(1540),
    [sym_tuple_pattern] = STATE(1540),
    [sym_tuple_struct_pattern] = STATE(1540),
    [sym_struct_pattern] = STATE(1540),
    [sym_remaining_field_pattern] = STATE(1540),
    [sym_mut_pattern] = STATE(1540),
    [sym_ref_pattern] = STATE(1540),
    [sym_captured_pattern] = STATE(1540),
    [sym_reference_pattern] = STATE(1540),
    [sym__literal] = STATE(1540),
    [sym_string_literal] = STATE(1540),
    [sym_boolean_literal] = STATE(1540),
    [sym_raw_string_literal] = ACTIONS(3018),
    [sym_float_literal] = ACTIONS(3018),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(817),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(819),
    [anon_sym_ref] = ACTIONS(821),
    [sym_integer_literal] = ACTIONS(3018),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(3018),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(823),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [2167] = {
    [sym_function_modifiers] = STATE(883),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1479),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(885),
    [sym_array_type] = STATE(1479),
    [sym_function_type] = STATE(1479),
    [sym_tuple_type] = STATE(1479),
    [sym_unit_type] = STATE(1479),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1479),
    [sym_reference_type] = STATE(1479),
    [sym_pointer_type] = STATE(1479),
    [sym_empty_type] = STATE(1479),
    [sym_dynamic_type] = STATE(1479),
    [sym_macro_invocation] = STATE(1479),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(887),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1838),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1840),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1842),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1844),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2168] = {
    [sym_function_modifiers] = STATE(883),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1499),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(885),
    [sym_array_type] = STATE(1499),
    [sym_function_type] = STATE(1499),
    [sym_tuple_type] = STATE(1499),
    [sym_unit_type] = STATE(1499),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1499),
    [sym_reference_type] = STATE(1499),
    [sym_pointer_type] = STATE(1499),
    [sym_empty_type] = STATE(1499),
    [sym_abstract_type] = STATE(1500),
    [sym_dynamic_type] = STATE(1499),
    [sym_macro_invocation] = STATE(1499),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(887),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1838),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1840),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1842),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1844),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2169] = {
    [sym_function_modifiers] = STATE(883),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1525),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(885),
    [sym_array_type] = STATE(1525),
    [sym_function_type] = STATE(1525),
    [sym_tuple_type] = STATE(1525),
    [sym_unit_type] = STATE(1525),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1525),
    [sym_reference_type] = STATE(1525),
    [sym_pointer_type] = STATE(1525),
    [sym_empty_type] = STATE(1525),
    [sym_abstract_type] = STATE(1526),
    [sym_dynamic_type] = STATE(1525),
    [sym_macro_invocation] = STATE(1525),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(887),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1838),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1840),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1842),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1844),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2170] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_COMMA] = ACTIONS(2988),
    [anon_sym_DASH_GT] = ACTIONS(6018),
    [anon_sym_PIPE] = ACTIONS(2988),
    [sym_line_comment] = ACTIONS(7),
  },
  [2171] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_COMMA] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(6020),
    [anon_sym_PIPE] = ACTIONS(2992),
    [sym_line_comment] = ACTIONS(7),
  },
  [2172] = {
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(881),
    [anon_sym_RPAREN] = ACTIONS(3054),
    [anon_sym_LBRACE] = ACTIONS(883),
    [anon_sym_COMMA] = ACTIONS(3054),
    [anon_sym_COLON_COLON] = ACTIONS(887),
    [anon_sym_AT] = ACTIONS(1834),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [2173] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(6022),
    [anon_sym_COLON] = ACTIONS(6022),
    [anon_sym_COMMA] = ACTIONS(6022),
    [anon_sym_PIPE] = ACTIONS(6022),
    [sym_line_comment] = ACTIONS(7),
  },
  [2174] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(6024),
    [anon_sym_COMMA] = ACTIONS(6024),
    [sym_line_comment] = ACTIONS(7),
  },
  [2175] = {
    [sym_ref_pattern] = STATE(2174),
    [sym_reference_pattern_in_parameter] = STATE(2174),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(6026),
    [anon_sym_AMP] = ACTIONS(2936),
    [anon_sym_ref] = ACTIONS(821),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4865),
  },
  [2176] = {
    [aux_sym_tuple_pattern_in_parameter_repeat1] = STATE(2176),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(6024),
    [anon_sym_COMMA] = ACTIONS(6028),
    [sym_line_comment] = ACTIONS(7),
  },
  [2177] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(4859),
    [anon_sym_COMMA] = ACTIONS(3016),
    [anon_sym_PIPE] = ACTIONS(3016),
    [sym_line_comment] = ACTIONS(7),
  },
  [2178] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6031),
    [anon_sym_RPAREN] = ACTIONS(6031),
    [anon_sym_RBRACE] = ACTIONS(6031),
    [anon_sym_COLON] = ACTIONS(6031),
    [anon_sym_COMMA] = ACTIONS(6031),
    [anon_sym_EQ] = ACTIONS(6031),
    [anon_sym_PIPE] = ACTIONS(6031),
    [anon_sym_in] = ACTIONS(6031),
    [sym_line_comment] = ACTIONS(7),
  },
  [2179] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(1540),
    [sym_tuple_pattern] = STATE(1540),
    [sym_tuple_struct_pattern] = STATE(1540),
    [sym_struct_pattern] = STATE(1540),
    [sym_remaining_field_pattern] = STATE(1540),
    [sym_mut_pattern] = STATE(1540),
    [sym_ref_pattern] = STATE(1540),
    [sym_captured_pattern] = STATE(1540),
    [sym_reference_pattern] = STATE(1540),
    [sym__literal] = STATE(1540),
    [sym_string_literal] = STATE(1540),
    [sym_boolean_literal] = STATE(1540),
    [sym_raw_string_literal] = ACTIONS(3018),
    [sym_float_literal] = ACTIONS(3018),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_RPAREN] = ACTIONS(6033),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(817),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(819),
    [anon_sym_ref] = ACTIONS(821),
    [sym_integer_literal] = ACTIONS(3018),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(3018),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(823),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [2180] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(2710),
    [sym_tuple_pattern] = STATE(2710),
    [sym_tuple_struct_pattern] = STATE(2710),
    [sym_struct_pattern] = STATE(2710),
    [sym_remaining_field_pattern] = STATE(2710),
    [sym_mut_pattern] = STATE(2710),
    [sym_ref_pattern] = STATE(2710),
    [sym_captured_pattern] = STATE(2710),
    [sym_reference_pattern] = STATE(2710),
    [sym__literal] = STATE(2710),
    [sym_string_literal] = STATE(2710),
    [sym_boolean_literal] = STATE(2710),
    [sym_raw_string_literal] = ACTIONS(6035),
    [sym_float_literal] = ACTIONS(6035),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(6037),
    [anon_sym_AMP] = ACTIONS(4893),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(4895),
    [anon_sym_ref] = ACTIONS(4897),
    [sym_integer_literal] = ACTIONS(6035),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6035),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4899),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [2181] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6039),
    [anon_sym_COLON] = ACTIONS(6041),
    [anon_sym_COMMA] = ACTIONS(6039),
    [sym_line_comment] = ACTIONS(7),
  },
  [2182] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(428),
    [sym_tuple_pattern] = STATE(428),
    [sym_tuple_struct_pattern] = STATE(428),
    [sym_struct_pattern] = STATE(428),
    [sym_remaining_field_pattern] = STATE(428),
    [sym_mut_pattern] = STATE(428),
    [sym_ref_pattern] = STATE(428),
    [sym_captured_pattern] = STATE(428),
    [sym_reference_pattern] = STATE(428),
    [sym__literal] = STATE(428),
    [sym_string_literal] = STATE(428),
    [sym_boolean_literal] = STATE(428),
    [sym_raw_string_literal] = ACTIONS(833),
    [sym_float_literal] = ACTIONS(833),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(4893),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(6043),
    [anon_sym_ref] = ACTIONS(4897),
    [sym_integer_literal] = ACTIONS(833),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(833),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4899),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [2183] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(438),
    [sym_tuple_pattern] = STATE(438),
    [sym_tuple_struct_pattern] = STATE(438),
    [sym_struct_pattern] = STATE(438),
    [sym_remaining_field_pattern] = STATE(438),
    [sym_mut_pattern] = STATE(438),
    [sym_ref_pattern] = STATE(438),
    [sym_captured_pattern] = STATE(438),
    [sym_reference_pattern] = STATE(438),
    [sym__literal] = STATE(438),
    [sym_string_literal] = STATE(438),
    [sym_boolean_literal] = STATE(438),
    [sym_raw_string_literal] = ACTIONS(855),
    [sym_float_literal] = ACTIONS(855),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(931),
    [anon_sym_AMP] = ACTIONS(4893),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(4895),
    [anon_sym_ref] = ACTIONS(4897),
    [sym_integer_literal] = ACTIONS(855),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(855),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4899),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [2184] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(441),
    [sym_tuple_pattern] = STATE(441),
    [sym_tuple_struct_pattern] = STATE(441),
    [sym_struct_pattern] = STATE(441),
    [sym_remaining_field_pattern] = STATE(441),
    [sym_mut_pattern] = STATE(441),
    [sym_ref_pattern] = STATE(441),
    [sym_captured_pattern] = STATE(441),
    [sym_reference_pattern] = STATE(441),
    [sym__literal] = STATE(441),
    [sym_string_literal] = STATE(441),
    [sym_boolean_literal] = STATE(441),
    [sym_raw_string_literal] = ACTIONS(871),
    [sym_float_literal] = ACTIONS(871),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(873),
    [anon_sym_AMP] = ACTIONS(4893),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(4895),
    [anon_sym_ref] = ACTIONS(4897),
    [sym_integer_literal] = ACTIONS(871),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4899),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [2185] = {
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(883),
    [anon_sym_RBRACE] = ACTIONS(831),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_COLON_COLON] = ACTIONS(887),
    [anon_sym_AT] = ACTIONS(6045),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [2186] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6047),
    [anon_sym_COMMA] = ACTIONS(6047),
    [sym_line_comment] = ACTIONS(7),
  },
  [2187] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6049),
    [anon_sym_RPAREN] = ACTIONS(6049),
    [anon_sym_RBRACE] = ACTIONS(6049),
    [anon_sym_COLON] = ACTIONS(6049),
    [anon_sym_COMMA] = ACTIONS(6049),
    [anon_sym_EQ] = ACTIONS(6049),
    [anon_sym_PIPE] = ACTIONS(6049),
    [anon_sym_in] = ACTIONS(6049),
    [sym_line_comment] = ACTIONS(7),
  },
  [2188] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6051),
    [anon_sym_COMMA] = ACTIONS(6051),
    [sym_line_comment] = ACTIONS(7),
  },
  [2189] = {
    [sym_field_pattern] = STATE(2188),
    [sym_remaining_field_pattern] = STATE(2188),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6053),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(1902),
    [anon_sym_ref] = ACTIONS(1904),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1906),
  },
  [2190] = {
    [aux_sym_struct_pattern_repeat1] = STATE(2190),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6051),
    [anon_sym_COMMA] = ACTIONS(6055),
    [sym_line_comment] = ACTIONS(7),
  },
  [2191] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6058),
    [anon_sym_RPAREN] = ACTIONS(6058),
    [anon_sym_RBRACE] = ACTIONS(6058),
    [anon_sym_COLON] = ACTIONS(6058),
    [anon_sym_COMMA] = ACTIONS(6058),
    [anon_sym_EQ] = ACTIONS(6058),
    [anon_sym_PIPE] = ACTIONS(6058),
    [anon_sym_in] = ACTIONS(6058),
    [sym_line_comment] = ACTIONS(7),
  },
  [2192] = {
    [sym_field_pattern] = STATE(2188),
    [sym_remaining_field_pattern] = STATE(2188),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(1902),
    [anon_sym_ref] = ACTIONS(1904),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1906),
  },
  [2193] = {
    [sym_function_modifiers] = STATE(929),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1479),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(931),
    [sym_array_type] = STATE(1479),
    [sym_function_type] = STATE(1479),
    [sym_tuple_type] = STATE(1479),
    [sym_unit_type] = STATE(1479),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1479),
    [sym_reference_type] = STATE(1479),
    [sym_pointer_type] = STATE(1479),
    [sym_empty_type] = STATE(1479),
    [sym_dynamic_type] = STATE(1479),
    [sym_macro_invocation] = STATE(1479),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(932),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1928),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1930),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1932),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1934),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2194] = {
    [sym_function_modifiers] = STATE(929),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1499),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(931),
    [sym_array_type] = STATE(1499),
    [sym_function_type] = STATE(1499),
    [sym_tuple_type] = STATE(1499),
    [sym_unit_type] = STATE(1499),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1499),
    [sym_reference_type] = STATE(1499),
    [sym_pointer_type] = STATE(1499),
    [sym_empty_type] = STATE(1499),
    [sym_abstract_type] = STATE(1500),
    [sym_dynamic_type] = STATE(1499),
    [sym_macro_invocation] = STATE(1499),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(932),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1928),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1930),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1932),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1934),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2195] = {
    [sym_function_modifiers] = STATE(929),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1525),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(931),
    [sym_array_type] = STATE(1525),
    [sym_function_type] = STATE(1525),
    [sym_tuple_type] = STATE(1525),
    [sym_unit_type] = STATE(1525),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1525),
    [sym_reference_type] = STATE(1525),
    [sym_pointer_type] = STATE(1525),
    [sym_empty_type] = STATE(1525),
    [sym_abstract_type] = STATE(1526),
    [sym_dynamic_type] = STATE(1525),
    [sym_macro_invocation] = STATE(1525),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(932),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1928),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1930),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1932),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1934),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2196] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_DASH_GT] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(2988),
    [sym_line_comment] = ACTIONS(7),
  },
  [2197] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(6064),
    [anon_sym_EQ] = ACTIONS(2992),
    [sym_line_comment] = ACTIONS(7),
  },
  [2198] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6066),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(467),
    [anon_sym_BANG_EQ] = ACTIONS(469),
    [anon_sym_STAR_EQ] = ACTIONS(467),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(467),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_AMP_EQ] = ACTIONS(467),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(467),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_CARET_EQ] = ACTIONS(467),
    [anon_sym_PLUS_EQ] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT_LT_EQ] = ACTIONS(467),
    [anon_sym_LT_EQ] = ACTIONS(469),
    [anon_sym_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_EQ] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_PIPE_EQ] = ACTIONS(467),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(489),
    [anon_sym_as] = ACTIONS(491),
    [sym_line_comment] = ACTIONS(7),
  },
  [2199] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_type_with_turbofish] = STATE(212),
    [sym_scoped_identifier] = STATE(2723),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(6068),
    [anon_sym_i8] = ACTIONS(6068),
    [anon_sym_u16] = ACTIONS(6068),
    [anon_sym_i16] = ACTIONS(6068),
    [anon_sym_u32] = ACTIONS(6068),
    [anon_sym_i32] = ACTIONS(6068),
    [anon_sym_u64] = ACTIONS(6068),
    [anon_sym_i64] = ACTIONS(6068),
    [anon_sym_u128] = ACTIONS(6068),
    [anon_sym_i128] = ACTIONS(6068),
    [anon_sym_isize] = ACTIONS(6068),
    [anon_sym_usize] = ACTIONS(6068),
    [anon_sym_f32] = ACTIONS(6068),
    [anon_sym_f64] = ACTIONS(6068),
    [anon_sym_bool] = ACTIONS(6068),
    [anon_sym_str] = ACTIONS(6068),
    [anon_sym_char] = ACTIONS(6068),
    [anon_sym_COLON_COLON] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(31),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6070),
    [sym_self] = ACTIONS(6072),
    [sym_super] = ACTIONS(6072),
    [sym_crate] = ACTIONS(6072),
    [sym_metavariable] = ACTIONS(6074),
  },
  [2200] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(6076),
    [sym_line_comment] = ACTIONS(7),
  },
  [2201] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3367),
    [anon_sym_macro_rules_BANG] = ACTIONS(3367),
    [anon_sym_RBRACE] = ACTIONS(3367),
    [anon_sym_COMMA] = ACTIONS(3367),
    [anon_sym_POUND] = ACTIONS(3367),
    [anon_sym_EQ] = ACTIONS(3367),
    [anon_sym_const] = ACTIONS(3369),
    [anon_sym_default] = ACTIONS(3369),
    [anon_sym_enum] = ACTIONS(3369),
    [anon_sym_fn] = ACTIONS(3369),
    [anon_sym_impl] = ACTIONS(3369),
    [anon_sym_let] = ACTIONS(3369),
    [anon_sym_mod] = ACTIONS(3369),
    [anon_sym_pub] = ACTIONS(3369),
    [anon_sym_static] = ACTIONS(3369),
    [anon_sym_struct] = ACTIONS(3369),
    [anon_sym_trait] = ACTIONS(3369),
    [anon_sym_type] = ACTIONS(3369),
    [anon_sym_union] = ACTIONS(3369),
    [anon_sym_unsafe] = ACTIONS(3369),
    [anon_sym_use] = ACTIONS(3369),
    [anon_sym_extern] = ACTIONS(3369),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3369),
  },
  [2202] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6078),
    [sym_line_comment] = ACTIONS(7),
  },
  [2203] = {
    [aux_sym_field_declaration_list_repeat1] = STATE(2727),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6078),
    [anon_sym_COMMA] = ACTIONS(6080),
    [sym_line_comment] = ACTIONS(7),
  },
  [2204] = {
    [sym_attribute_item] = STATE(1597),
    [sym_field_declaration] = STATE(2728),
    [sym_visibility_modifier] = STATE(1069),
    [aux_sym_enum_variant_list_repeat1] = STATE(1597),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_pub] = ACTIONS(1940),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2132),
  },
  [2205] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(6082),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(3495),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(6082),
    [anon_sym_AMP] = ACTIONS(3499),
    [anon_sym_DASH] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(3501),
    [anon_sym_BANG_EQ] = ACTIONS(3503),
    [anon_sym_STAR_EQ] = ACTIONS(3501),
    [anon_sym_SLASH] = ACTIONS(3497),
    [anon_sym_SLASH_EQ] = ACTIONS(3501),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_AMP_EQ] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_PERCENT_EQ] = ACTIONS(3501),
    [anon_sym_CARET] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3501),
    [anon_sym_PLUS_EQ] = ACTIONS(3501),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_LT_LT] = ACTIONS(3511),
    [anon_sym_LT_LT_EQ] = ACTIONS(3501),
    [anon_sym_LT_EQ] = ACTIONS(3503),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_EQ_EQ] = ACTIONS(3503),
    [anon_sym_GT] = ACTIONS(3509),
    [anon_sym_GT_EQ] = ACTIONS(3503),
    [anon_sym_GT_GT] = ACTIONS(3511),
    [anon_sym_GT_GT_EQ] = ACTIONS(3501),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_PIPE_EQ] = ACTIONS(3501),
    [anon_sym_PIPE_PIPE] = ACTIONS(3517),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(3519),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3521),
    [anon_sym_as] = ACTIONS(3523),
    [sym_line_comment] = ACTIONS(7),
  },
  [2206] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2729),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2729),
    [sym_macro_invocation] = STATE(2729),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2729),
    [sym_unary_expression] = STATE(2729),
    [sym_try_expression] = STATE(2729),
    [sym_reference_expression] = STATE(2729),
    [sym_binary_expression] = STATE(2729),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2729),
    [sym_call_expression] = STATE(2729),
    [sym_array_expression] = STATE(2729),
    [sym_parenthesized_expression] = STATE(2729),
    [sym_tuple_expression] = STATE(2729),
    [sym_unit_expression] = STATE(2729),
    [sym_struct_expression] = STATE(2729),
    [sym_if_expression] = STATE(2729),
    [sym_if_let_expression] = STATE(2729),
    [sym_match_expression] = STATE(2729),
    [sym_while_expression] = STATE(2729),
    [sym_while_let_expression] = STATE(2729),
    [sym_loop_expression] = STATE(2729),
    [sym_for_expression] = STATE(2729),
    [sym_closure_expression] = STATE(2729),
    [sym_closure_parameters] = STATE(1138),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2729),
    [sym_continue_expression] = STATE(2729),
    [sym_index_expression] = STATE(2729),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2729),
    [sym_block] = STATE(2729),
    [sym__literal] = STATE(2729),
    [sym_string_literal] = STATE(2729),
    [sym_boolean_literal] = STATE(2729),
    [sym_raw_string_literal] = ACTIONS(6084),
    [sym_float_literal] = ACTIONS(6084),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(2245),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(2247),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(2249),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(2251),
    [sym_integer_literal] = ACTIONS(6084),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6084),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2207] = {
    [sym_raw_string_literal] = ACTIONS(6086),
    [sym_float_literal] = ACTIONS(6086),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(6086),
    [anon_sym_SEMI] = ACTIONS(6086),
    [anon_sym_macro_rules_BANG] = ACTIONS(6086),
    [anon_sym_LPAREN] = ACTIONS(6086),
    [anon_sym_LBRACE] = ACTIONS(6086),
    [anon_sym_RBRACE] = ACTIONS(6086),
    [anon_sym_LBRACK] = ACTIONS(6086),
    [anon_sym_STAR] = ACTIONS(6086),
    [anon_sym_u8] = ACTIONS(6088),
    [anon_sym_i8] = ACTIONS(6088),
    [anon_sym_u16] = ACTIONS(6088),
    [anon_sym_i16] = ACTIONS(6088),
    [anon_sym_u32] = ACTIONS(6088),
    [anon_sym_i32] = ACTIONS(6088),
    [anon_sym_u64] = ACTIONS(6088),
    [anon_sym_i64] = ACTIONS(6088),
    [anon_sym_u128] = ACTIONS(6088),
    [anon_sym_i128] = ACTIONS(6088),
    [anon_sym_isize] = ACTIONS(6088),
    [anon_sym_usize] = ACTIONS(6088),
    [anon_sym_f32] = ACTIONS(6088),
    [anon_sym_f64] = ACTIONS(6088),
    [anon_sym_bool] = ACTIONS(6088),
    [anon_sym_str] = ACTIONS(6088),
    [anon_sym_char] = ACTIONS(6088),
    [anon_sym_AMP] = ACTIONS(6086),
    [anon_sym_DASH] = ACTIONS(6086),
    [anon_sym_COLON_COLON] = ACTIONS(6086),
    [anon_sym_BANG] = ACTIONS(6086),
    [anon_sym_POUND] = ACTIONS(6086),
    [anon_sym_LT] = ACTIONS(6086),
    [anon_sym_PIPE] = ACTIONS(6086),
    [anon_sym_SQUOTE] = ACTIONS(6088),
    [anon_sym_DOT_DOT] = ACTIONS(6086),
    [anon_sym_break] = ACTIONS(6088),
    [anon_sym_const] = ACTIONS(6088),
    [anon_sym_continue] = ACTIONS(6088),
    [anon_sym_default] = ACTIONS(6088),
    [anon_sym_enum] = ACTIONS(6088),
    [anon_sym_fn] = ACTIONS(6088),
    [anon_sym_for] = ACTIONS(6088),
    [anon_sym_if] = ACTIONS(6088),
    [anon_sym_impl] = ACTIONS(6088),
    [anon_sym_let] = ACTIONS(6088),
    [anon_sym_loop] = ACTIONS(6088),
    [anon_sym_match] = ACTIONS(6088),
    [anon_sym_mod] = ACTIONS(6088),
    [anon_sym_pub] = ACTIONS(6088),
    [anon_sym_return] = ACTIONS(6088),
    [anon_sym_static] = ACTIONS(6088),
    [anon_sym_struct] = ACTIONS(6088),
    [anon_sym_trait] = ACTIONS(6088),
    [anon_sym_type] = ACTIONS(6088),
    [anon_sym_union] = ACTIONS(6088),
    [anon_sym_unsafe] = ACTIONS(6088),
    [anon_sym_use] = ACTIONS(6088),
    [anon_sym_while] = ACTIONS(6088),
    [anon_sym_extern] = ACTIONS(6088),
    [anon_sym_move] = ACTIONS(6088),
    [sym_integer_literal] = ACTIONS(6086),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6086),
    [sym_char_literal] = ACTIONS(6086),
    [anon_sym_true] = ACTIONS(6088),
    [anon_sym_false] = ACTIONS(6088),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6088),
    [sym_self] = ACTIONS(6088),
    [sym_super] = ACTIONS(6088),
    [sym_crate] = ACTIONS(6088),
    [sym_metavariable] = ACTIONS(6086),
  },
  [2208] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6090),
    [anon_sym_COMMA] = ACTIONS(6090),
    [sym_line_comment] = ACTIONS(7),
  },
  [2209] = {
    [sym_attribute_item] = STATE(1597),
    [sym_enum_variant] = STATE(2730),
    [sym_visibility_modifier] = STATE(938),
    [aux_sym_enum_variant_list_repeat1] = STATE(1597),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_pub] = ACTIONS(1940),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1942),
  },
  [2210] = {
    [sym_attribute_item] = STATE(2209),
    [sym_enum_variant] = STATE(2208),
    [sym_visibility_modifier] = STATE(938),
    [aux_sym_enum_variant_list_repeat1] = STATE(2209),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6092),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_pub] = ACTIONS(1940),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1942),
  },
  [2211] = {
    [aux_sym_enum_variant_list_repeat2] = STATE(2211),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6090),
    [anon_sym_COMMA] = ACTIONS(6094),
    [sym_line_comment] = ACTIONS(7),
  },
  [2212] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6082),
    [anon_sym_COMMA] = ACTIONS(6082),
    [anon_sym_EQ] = ACTIONS(6097),
    [sym_line_comment] = ACTIONS(7),
  },
  [2213] = {
    [aux_sym_enum_variant_list_repeat2] = STATE(2211),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6092),
    [anon_sym_COMMA] = ACTIONS(6099),
    [sym_line_comment] = ACTIONS(7),
  },
  [2214] = {
    [sym_function_modifiers] = STATE(1603),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(821),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2219),
    [sym_array_type] = STATE(821),
    [sym_function_type] = STATE(821),
    [sym_tuple_type] = STATE(821),
    [sym_unit_type] = STATE(821),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(821),
    [sym_reference_type] = STATE(821),
    [sym_pointer_type] = STATE(821),
    [sym_empty_type] = STATE(821),
    [sym_dynamic_type] = STATE(821),
    [sym_macro_invocation] = STATE(821),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1606),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3135),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3137),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3139),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3143),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2215] = {
    [sym_function_modifiers] = STATE(1603),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2219),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1606),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3135),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3137),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3139),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3143),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2216] = {
    [sym_function_modifiers] = STATE(1603),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2219),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1606),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(4953),
    [anon_sym_STAR] = ACTIONS(3135),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3137),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3139),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(6101),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3143),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2217] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1760),
    [anon_sym_PLUS] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(6103),
    [sym_line_comment] = ACTIONS(7),
  },
  [2218] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2906),
    [anon_sym_PLUS] = ACTIONS(4951),
    [sym_line_comment] = ACTIONS(7),
  },
  [2219] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(4953),
    [sym_line_comment] = ACTIONS(7),
  },
  [2220] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1794),
    [anon_sym_PLUS] = ACTIONS(1794),
    [anon_sym_DASH_GT] = ACTIONS(6105),
    [sym_line_comment] = ACTIONS(7),
  },
  [2221] = {
    [sym_parameters] = STATE(2738),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [2222] = {
    [sym_parameters] = STATE(2739),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [2223] = {
    [sym_parameters] = STATE(2738),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [2224] = {
    [sym_function_modifiers] = STATE(1603),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(862),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1606),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3135),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3137),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3139),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3143),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2225] = {
    [sym_function_modifiers] = STATE(1603),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2219),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1606),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3135),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3137),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3139),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3143),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2226] = {
    [sym_function_modifiers] = STATE(1603),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2740),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2219),
    [sym_array_type] = STATE(2740),
    [sym_function_type] = STATE(2740),
    [sym_tuple_type] = STATE(2740),
    [sym_unit_type] = STATE(2740),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2740),
    [sym_reference_type] = STATE(2740),
    [sym_pointer_type] = STATE(2740),
    [sym_empty_type] = STATE(2740),
    [sym_dynamic_type] = STATE(2740),
    [sym_macro_invocation] = STATE(2740),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1606),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3135),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3137),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3139),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3143),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2227] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(6107),
    [sym_mutable_specifier] = ACTIONS(6107),
    [sym_line_comment] = ACTIONS(7),
  },
  [2228] = {
    [sym_function_modifiers] = STATE(2233),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(385),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2743),
    [sym_array_type] = STATE(385),
    [sym_function_type] = STATE(385),
    [sym_tuple_type] = STATE(385),
    [sym_unit_type] = STATE(385),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(385),
    [sym_reference_type] = STATE(385),
    [sym_pointer_type] = STATE(385),
    [sym_empty_type] = STATE(385),
    [sym_dynamic_type] = STATE(385),
    [sym_macro_invocation] = STATE(385),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2236),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(4957),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(4959),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4963),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(6109),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4967),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2229] = {
    [sym_function_modifiers] = STATE(2233),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1759),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2744),
    [sym_array_type] = STATE(1759),
    [sym_function_type] = STATE(1759),
    [sym_tuple_type] = STATE(1759),
    [sym_unit_type] = STATE(1759),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1759),
    [sym_reference_type] = STATE(1759),
    [sym_pointer_type] = STATE(1759),
    [sym_empty_type] = STATE(1759),
    [sym_dynamic_type] = STATE(1759),
    [sym_macro_invocation] = STATE(1759),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2236),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(4957),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(4959),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4963),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4967),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2230] = {
    [sym_parameters] = STATE(2745),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [2231] = {
    [sym_type_parameters] = STATE(2746),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(3393),
    [sym_line_comment] = ACTIONS(7),
  },
  [2232] = {
    [sym_parameters] = STATE(2747),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_BANG] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [2233] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2750),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_fn] = ACTIONS(6111),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6113),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [2234] = {
    [aux_sym_trait_bounds_repeat1] = STATE(2752),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_COMMA] = ACTIONS(3395),
    [sym_line_comment] = ACTIONS(7),
  },
  [2235] = {
    [aux_sym_trait_bounds_repeat1] = STATE(2752),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(6117),
    [anon_sym_COMMA] = ACTIONS(3395),
    [sym_line_comment] = ACTIONS(7),
  },
  [2236] = {
    [sym_parameters] = STATE(2745),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(783),
    [anon_sym_PLUS] = ACTIONS(783),
    [anon_sym_COMMA] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [2237] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6119),
    [anon_sym_LPAREN] = ACTIONS(6119),
    [anon_sym_LBRACE] = ACTIONS(6119),
    [anon_sym_COMMA] = ACTIONS(6119),
    [sym_line_comment] = ACTIONS(7),
  },
  [2238] = {
    [sym_where_predicate] = STATE(2237),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(945),
    [sym_generic_type] = STATE(946),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_reference_type] = STATE(945),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(947),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(6121),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(1948),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1950),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [2239] = {
    [aux_sym_where_clause_repeat1] = STATE(2239),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(6119),
    [anon_sym_COMMA] = ACTIONS(6123),
    [sym_line_comment] = ACTIONS(7),
  },
  [2240] = {
    [sym_where_clause] = STATE(2756),
    [sym_block] = STATE(2757),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6126),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_PLUS] = ACTIONS(5003),
    [anon_sym_where] = ACTIONS(1962),
    [sym_line_comment] = ACTIONS(7),
  },
  [2241] = {
    [sym_where_clause] = STATE(2756),
    [sym_block] = STATE(2757),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6126),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_where] = ACTIONS(1962),
    [sym_line_comment] = ACTIONS(7),
  },
  [2242] = {
    [sym_raw_string_literal] = ACTIONS(6128),
    [sym_float_literal] = ACTIONS(6128),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(6128),
    [anon_sym_SEMI] = ACTIONS(6128),
    [anon_sym_macro_rules_BANG] = ACTIONS(6128),
    [anon_sym_LPAREN] = ACTIONS(6128),
    [anon_sym_LBRACE] = ACTIONS(6128),
    [anon_sym_RBRACE] = ACTIONS(6128),
    [anon_sym_LBRACK] = ACTIONS(6128),
    [anon_sym_STAR] = ACTIONS(6128),
    [anon_sym_u8] = ACTIONS(6130),
    [anon_sym_i8] = ACTIONS(6130),
    [anon_sym_u16] = ACTIONS(6130),
    [anon_sym_i16] = ACTIONS(6130),
    [anon_sym_u32] = ACTIONS(6130),
    [anon_sym_i32] = ACTIONS(6130),
    [anon_sym_u64] = ACTIONS(6130),
    [anon_sym_i64] = ACTIONS(6130),
    [anon_sym_u128] = ACTIONS(6130),
    [anon_sym_i128] = ACTIONS(6130),
    [anon_sym_isize] = ACTIONS(6130),
    [anon_sym_usize] = ACTIONS(6130),
    [anon_sym_f32] = ACTIONS(6130),
    [anon_sym_f64] = ACTIONS(6130),
    [anon_sym_bool] = ACTIONS(6130),
    [anon_sym_str] = ACTIONS(6130),
    [anon_sym_char] = ACTIONS(6130),
    [anon_sym_AMP] = ACTIONS(6128),
    [anon_sym_DASH] = ACTIONS(6128),
    [anon_sym_COLON_COLON] = ACTIONS(6128),
    [anon_sym_BANG] = ACTIONS(6128),
    [anon_sym_POUND] = ACTIONS(6128),
    [anon_sym_LT] = ACTIONS(6128),
    [anon_sym_PIPE] = ACTIONS(6128),
    [anon_sym_SQUOTE] = ACTIONS(6130),
    [anon_sym_DOT_DOT] = ACTIONS(6128),
    [anon_sym_break] = ACTIONS(6130),
    [anon_sym_const] = ACTIONS(6130),
    [anon_sym_continue] = ACTIONS(6130),
    [anon_sym_default] = ACTIONS(6130),
    [anon_sym_enum] = ACTIONS(6130),
    [anon_sym_fn] = ACTIONS(6130),
    [anon_sym_for] = ACTIONS(6130),
    [anon_sym_if] = ACTIONS(6130),
    [anon_sym_impl] = ACTIONS(6130),
    [anon_sym_let] = ACTIONS(6130),
    [anon_sym_loop] = ACTIONS(6130),
    [anon_sym_match] = ACTIONS(6130),
    [anon_sym_mod] = ACTIONS(6130),
    [anon_sym_pub] = ACTIONS(6130),
    [anon_sym_return] = ACTIONS(6130),
    [anon_sym_static] = ACTIONS(6130),
    [anon_sym_struct] = ACTIONS(6130),
    [anon_sym_trait] = ACTIONS(6130),
    [anon_sym_type] = ACTIONS(6130),
    [anon_sym_union] = ACTIONS(6130),
    [anon_sym_unsafe] = ACTIONS(6130),
    [anon_sym_use] = ACTIONS(6130),
    [anon_sym_while] = ACTIONS(6130),
    [anon_sym_extern] = ACTIONS(6130),
    [anon_sym_move] = ACTIONS(6130),
    [sym_integer_literal] = ACTIONS(6128),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6128),
    [sym_char_literal] = ACTIONS(6128),
    [anon_sym_true] = ACTIONS(6130),
    [anon_sym_false] = ACTIONS(6130),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6130),
    [sym_self] = ACTIONS(6130),
    [sym_super] = ACTIONS(6130),
    [sym_crate] = ACTIONS(6130),
    [sym_metavariable] = ACTIONS(6128),
  },
  [2243] = {
    [sym_raw_string_literal] = ACTIONS(6132),
    [sym_float_literal] = ACTIONS(6132),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(6132),
    [anon_sym_SEMI] = ACTIONS(6132),
    [anon_sym_macro_rules_BANG] = ACTIONS(6132),
    [anon_sym_LPAREN] = ACTIONS(6132),
    [anon_sym_LBRACE] = ACTIONS(6132),
    [anon_sym_RBRACE] = ACTIONS(6132),
    [anon_sym_LBRACK] = ACTIONS(6132),
    [anon_sym_STAR] = ACTIONS(6132),
    [anon_sym_u8] = ACTIONS(6134),
    [anon_sym_i8] = ACTIONS(6134),
    [anon_sym_u16] = ACTIONS(6134),
    [anon_sym_i16] = ACTIONS(6134),
    [anon_sym_u32] = ACTIONS(6134),
    [anon_sym_i32] = ACTIONS(6134),
    [anon_sym_u64] = ACTIONS(6134),
    [anon_sym_i64] = ACTIONS(6134),
    [anon_sym_u128] = ACTIONS(6134),
    [anon_sym_i128] = ACTIONS(6134),
    [anon_sym_isize] = ACTIONS(6134),
    [anon_sym_usize] = ACTIONS(6134),
    [anon_sym_f32] = ACTIONS(6134),
    [anon_sym_f64] = ACTIONS(6134),
    [anon_sym_bool] = ACTIONS(6134),
    [anon_sym_str] = ACTIONS(6134),
    [anon_sym_char] = ACTIONS(6134),
    [anon_sym_AMP] = ACTIONS(6132),
    [anon_sym_DASH] = ACTIONS(6132),
    [anon_sym_COLON_COLON] = ACTIONS(6132),
    [anon_sym_BANG] = ACTIONS(6132),
    [anon_sym_POUND] = ACTIONS(6132),
    [anon_sym_LT] = ACTIONS(6132),
    [anon_sym_PIPE] = ACTIONS(6132),
    [anon_sym_SQUOTE] = ACTIONS(6134),
    [anon_sym_DOT_DOT] = ACTIONS(6132),
    [anon_sym_break] = ACTIONS(6134),
    [anon_sym_const] = ACTIONS(6134),
    [anon_sym_continue] = ACTIONS(6134),
    [anon_sym_default] = ACTIONS(6134),
    [anon_sym_enum] = ACTIONS(6134),
    [anon_sym_fn] = ACTIONS(6134),
    [anon_sym_for] = ACTIONS(6134),
    [anon_sym_if] = ACTIONS(6134),
    [anon_sym_impl] = ACTIONS(6134),
    [anon_sym_let] = ACTIONS(6134),
    [anon_sym_loop] = ACTIONS(6134),
    [anon_sym_match] = ACTIONS(6134),
    [anon_sym_mod] = ACTIONS(6134),
    [anon_sym_pub] = ACTIONS(6134),
    [anon_sym_return] = ACTIONS(6134),
    [anon_sym_static] = ACTIONS(6134),
    [anon_sym_struct] = ACTIONS(6134),
    [anon_sym_trait] = ACTIONS(6134),
    [anon_sym_type] = ACTIONS(6134),
    [anon_sym_union] = ACTIONS(6134),
    [anon_sym_unsafe] = ACTIONS(6134),
    [anon_sym_use] = ACTIONS(6134),
    [anon_sym_while] = ACTIONS(6134),
    [anon_sym_extern] = ACTIONS(6134),
    [anon_sym_move] = ACTIONS(6134),
    [sym_integer_literal] = ACTIONS(6132),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6132),
    [sym_char_literal] = ACTIONS(6132),
    [anon_sym_true] = ACTIONS(6134),
    [anon_sym_false] = ACTIONS(6134),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6134),
    [sym_self] = ACTIONS(6134),
    [sym_super] = ACTIONS(6134),
    [sym_crate] = ACTIONS(6134),
    [sym_metavariable] = ACTIONS(6132),
  },
  [2244] = {
    [sym_raw_string_literal] = ACTIONS(1567),
    [sym_float_literal] = ACTIONS(1567),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(1567),
    [anon_sym_SEMI] = ACTIONS(1567),
    [anon_sym_macro_rules_BANG] = ACTIONS(1567),
    [anon_sym_LPAREN] = ACTIONS(1567),
    [anon_sym_LBRACE] = ACTIONS(1567),
    [anon_sym_RBRACE] = ACTIONS(1567),
    [anon_sym_LBRACK] = ACTIONS(1567),
    [anon_sym_STAR] = ACTIONS(1567),
    [anon_sym_u8] = ACTIONS(1569),
    [anon_sym_i8] = ACTIONS(1569),
    [anon_sym_u16] = ACTIONS(1569),
    [anon_sym_i16] = ACTIONS(1569),
    [anon_sym_u32] = ACTIONS(1569),
    [anon_sym_i32] = ACTIONS(1569),
    [anon_sym_u64] = ACTIONS(1569),
    [anon_sym_i64] = ACTIONS(1569),
    [anon_sym_u128] = ACTIONS(1569),
    [anon_sym_i128] = ACTIONS(1569),
    [anon_sym_isize] = ACTIONS(1569),
    [anon_sym_usize] = ACTIONS(1569),
    [anon_sym_f32] = ACTIONS(1569),
    [anon_sym_f64] = ACTIONS(1569),
    [anon_sym_bool] = ACTIONS(1569),
    [anon_sym_str] = ACTIONS(1569),
    [anon_sym_char] = ACTIONS(1569),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_COLON_COLON] = ACTIONS(1567),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_POUND] = ACTIONS(1567),
    [anon_sym_LT] = ACTIONS(1567),
    [anon_sym_PIPE] = ACTIONS(1567),
    [anon_sym_SQUOTE] = ACTIONS(1569),
    [anon_sym_DOT_DOT] = ACTIONS(1567),
    [anon_sym_break] = ACTIONS(1569),
    [anon_sym_const] = ACTIONS(1569),
    [anon_sym_continue] = ACTIONS(1569),
    [anon_sym_default] = ACTIONS(1569),
    [anon_sym_enum] = ACTIONS(1569),
    [anon_sym_fn] = ACTIONS(1569),
    [anon_sym_for] = ACTIONS(1569),
    [anon_sym_if] = ACTIONS(1569),
    [anon_sym_impl] = ACTIONS(1569),
    [anon_sym_let] = ACTIONS(1569),
    [anon_sym_loop] = ACTIONS(1569),
    [anon_sym_match] = ACTIONS(1569),
    [anon_sym_mod] = ACTIONS(1569),
    [anon_sym_pub] = ACTIONS(1569),
    [anon_sym_return] = ACTIONS(1569),
    [anon_sym_static] = ACTIONS(1569),
    [anon_sym_struct] = ACTIONS(1569),
    [anon_sym_trait] = ACTIONS(1569),
    [anon_sym_type] = ACTIONS(1569),
    [anon_sym_union] = ACTIONS(1569),
    [anon_sym_unsafe] = ACTIONS(1569),
    [anon_sym_use] = ACTIONS(1569),
    [anon_sym_while] = ACTIONS(1569),
    [anon_sym_extern] = ACTIONS(1569),
    [anon_sym_move] = ACTIONS(1569),
    [sym_integer_literal] = ACTIONS(1567),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(1567),
    [sym_char_literal] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1569),
    [anon_sym_false] = ACTIONS(1569),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1569),
    [sym_self] = ACTIONS(1569),
    [sym_super] = ACTIONS(1569),
    [sym_crate] = ACTIONS(1569),
    [sym_metavariable] = ACTIONS(1567),
  },
  [2245] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(6136),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(623),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(623),
    [anon_sym_PLUS_EQ] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(623),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(643),
    [anon_sym_as] = ACTIONS(645),
    [sym_line_comment] = ACTIONS(7),
  },
  [2246] = {
    [sym_function_modifiers] = STATE(1624),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(821),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1626),
    [sym_array_type] = STATE(821),
    [sym_function_type] = STATE(821),
    [sym_tuple_type] = STATE(821),
    [sym_unit_type] = STATE(821),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(821),
    [sym_reference_type] = STATE(821),
    [sym_pointer_type] = STATE(821),
    [sym_empty_type] = STATE(821),
    [sym_dynamic_type] = STATE(821),
    [sym_macro_invocation] = STATE(821),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1628),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3169),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3171),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3173),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3175),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2247] = {
    [sym_function_modifiers] = STATE(1624),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1626),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1628),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3169),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3171),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3173),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3175),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2248] = {
    [sym_function_modifiers] = STATE(1624),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1626),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1628),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(5005),
    [anon_sym_STAR] = ACTIONS(3169),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3171),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3173),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(6138),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3175),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2249] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1760),
    [anon_sym_LBRACE] = ACTIONS(1760),
    [anon_sym_PLUS] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(6140),
    [anon_sym_where] = ACTIONS(1760),
    [sym_line_comment] = ACTIONS(7),
  },
  [2250] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1794),
    [anon_sym_LBRACE] = ACTIONS(1794),
    [anon_sym_PLUS] = ACTIONS(1794),
    [anon_sym_DASH_GT] = ACTIONS(6142),
    [anon_sym_where] = ACTIONS(1794),
    [sym_line_comment] = ACTIONS(7),
  },
  [2251] = {
    [sym_parameters] = STATE(2762),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [2252] = {
    [sym_parameters] = STATE(2763),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [2253] = {
    [sym_parameters] = STATE(2762),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [2254] = {
    [sym_function_modifiers] = STATE(1624),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(862),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1628),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3169),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3171),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3173),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3175),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2255] = {
    [sym_block] = STATE(2757),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6126),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [sym_line_comment] = ACTIONS(7),
  },
  [2256] = {
    [sym_function_modifiers] = STATE(1624),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1626),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1628),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3169),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3171),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3173),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3175),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2257] = {
    [sym_function_modifiers] = STATE(2770),
    [sym_higher_ranked_trait_bound] = STATE(2771),
    [sym_removed_trait_bound] = STATE(2771),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2772),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2772),
    [sym_array_type] = STATE(2772),
    [sym_function_type] = STATE(2772),
    [sym_tuple_type] = STATE(2772),
    [sym_unit_type] = STATE(2772),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2772),
    [sym_reference_type] = STATE(2772),
    [sym_pointer_type] = STATE(2772),
    [sym_empty_type] = STATE(2772),
    [sym_dynamic_type] = STATE(2772),
    [sym_macro_invocation] = STATE(2772),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2773),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(6144),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(6146),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_QMARK] = ACTIONS(6148),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6150),
    [anon_sym_for] = ACTIONS(6152),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6154),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2258] = {
    [sym_where_predicate] = STATE(2237),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1631),
    [sym_generic_type] = STATE(1632),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_reference_type] = STATE(1631),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1633),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4971),
    [anon_sym_LBRACE] = ACTIONS(4971),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(1948),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3177),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [2259] = {
    [aux_sym_where_clause_repeat1] = STATE(2775),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4971),
    [anon_sym_LBRACE] = ACTIONS(4971),
    [anon_sym_COMMA] = ACTIONS(6156),
    [sym_line_comment] = ACTIONS(7),
  },
  [2260] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(2776),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [2261] = {
    [sym_else_tail] = STATE(2777),
    [sym_raw_string_literal] = ACTIONS(6158),
    [sym_float_literal] = ACTIONS(6158),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(6158),
    [anon_sym_SEMI] = ACTIONS(6158),
    [anon_sym_macro_rules_BANG] = ACTIONS(6158),
    [anon_sym_LPAREN] = ACTIONS(6158),
    [anon_sym_LBRACE] = ACTIONS(6158),
    [anon_sym_LBRACK] = ACTIONS(6158),
    [anon_sym_PLUS] = ACTIONS(6160),
    [anon_sym_STAR] = ACTIONS(6160),
    [anon_sym_u8] = ACTIONS(6160),
    [anon_sym_i8] = ACTIONS(6160),
    [anon_sym_u16] = ACTIONS(6160),
    [anon_sym_i16] = ACTIONS(6160),
    [anon_sym_u32] = ACTIONS(6160),
    [anon_sym_i32] = ACTIONS(6160),
    [anon_sym_u64] = ACTIONS(6160),
    [anon_sym_i64] = ACTIONS(6160),
    [anon_sym_u128] = ACTIONS(6160),
    [anon_sym_i128] = ACTIONS(6160),
    [anon_sym_isize] = ACTIONS(6160),
    [anon_sym_usize] = ACTIONS(6160),
    [anon_sym_f32] = ACTIONS(6160),
    [anon_sym_f64] = ACTIONS(6160),
    [anon_sym_bool] = ACTIONS(6160),
    [anon_sym_str] = ACTIONS(6160),
    [anon_sym_char] = ACTIONS(6160),
    [anon_sym_AMP] = ACTIONS(6160),
    [anon_sym_DASH] = ACTIONS(6160),
    [anon_sym_DOT] = ACTIONS(6160),
    [anon_sym_DASH_EQ] = ACTIONS(6158),
    [anon_sym_COLON_COLON] = ACTIONS(6158),
    [anon_sym_BANG] = ACTIONS(6160),
    [anon_sym_BANG_EQ] = ACTIONS(6158),
    [anon_sym_STAR_EQ] = ACTIONS(6158),
    [anon_sym_SLASH] = ACTIONS(6160),
    [anon_sym_SLASH_EQ] = ACTIONS(6158),
    [anon_sym_AMP_AMP] = ACTIONS(6158),
    [anon_sym_AMP_EQ] = ACTIONS(6158),
    [anon_sym_POUND] = ACTIONS(6158),
    [anon_sym_PERCENT] = ACTIONS(6160),
    [anon_sym_PERCENT_EQ] = ACTIONS(6158),
    [anon_sym_CARET] = ACTIONS(6160),
    [anon_sym_CARET_EQ] = ACTIONS(6158),
    [anon_sym_PLUS_EQ] = ACTIONS(6158),
    [anon_sym_LT] = ACTIONS(6160),
    [anon_sym_LT_LT] = ACTIONS(6160),
    [anon_sym_LT_LT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_EQ] = ACTIONS(6160),
    [anon_sym_EQ_EQ] = ACTIONS(6158),
    [anon_sym_GT] = ACTIONS(6160),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_GT_GT] = ACTIONS(6160),
    [anon_sym_GT_GT_EQ] = ACTIONS(6158),
    [anon_sym_PIPE] = ACTIONS(6160),
    [anon_sym_PIPE_EQ] = ACTIONS(6158),
    [anon_sym_PIPE_PIPE] = ACTIONS(6158),
    [anon_sym_QMARK] = ACTIONS(6158),
    [anon_sym_SQUOTE] = ACTIONS(6160),
    [anon_sym_DOT_DOT] = ACTIONS(6160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6158),
    [anon_sym_as] = ACTIONS(6160),
    [anon_sym_break] = ACTIONS(6160),
    [anon_sym_const] = ACTIONS(6160),
    [anon_sym_continue] = ACTIONS(6160),
    [anon_sym_default] = ACTIONS(6160),
    [anon_sym_enum] = ACTIONS(6160),
    [anon_sym_fn] = ACTIONS(6160),
    [anon_sym_for] = ACTIONS(6160),
    [anon_sym_if] = ACTIONS(6160),
    [anon_sym_impl] = ACTIONS(6160),
    [anon_sym_let] = ACTIONS(6160),
    [anon_sym_loop] = ACTIONS(6160),
    [anon_sym_match] = ACTIONS(6160),
    [anon_sym_mod] = ACTIONS(6160),
    [anon_sym_pub] = ACTIONS(6160),
    [anon_sym_return] = ACTIONS(6160),
    [anon_sym_static] = ACTIONS(6160),
    [anon_sym_struct] = ACTIONS(6160),
    [anon_sym_trait] = ACTIONS(6160),
    [anon_sym_type] = ACTIONS(6160),
    [anon_sym_union] = ACTIONS(6160),
    [anon_sym_unsafe] = ACTIONS(6160),
    [anon_sym_use] = ACTIONS(6160),
    [anon_sym_while] = ACTIONS(6160),
    [anon_sym_extern] = ACTIONS(6160),
    [anon_sym_else] = ACTIONS(2016),
    [anon_sym_move] = ACTIONS(6160),
    [sym_integer_literal] = ACTIONS(6158),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6158),
    [sym_char_literal] = ACTIONS(6158),
    [anon_sym_true] = ACTIONS(6160),
    [anon_sym_false] = ACTIONS(6160),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6160),
    [sym_self] = ACTIONS(6160),
    [sym_super] = ACTIONS(6160),
    [sym_crate] = ACTIONS(6160),
    [sym_metavariable] = ACTIONS(6158),
  },
  [2262] = {
    [sym_function_modifiers] = STATE(982),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2611),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(983),
    [sym_array_type] = STATE(2611),
    [sym_function_type] = STATE(2611),
    [sym_tuple_type] = STATE(2611),
    [sym_unit_type] = STATE(2611),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2611),
    [sym_reference_type] = STATE(2611),
    [sym_pointer_type] = STATE(2611),
    [sym_empty_type] = STATE(2611),
    [sym_dynamic_type] = STATE(2611),
    [sym_macro_invocation] = STATE(2611),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(984),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(2004),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(2006),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2008),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2010),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2263] = {
    [sym_function_modifiers] = STATE(982),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2616),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(983),
    [sym_array_type] = STATE(2616),
    [sym_function_type] = STATE(2616),
    [sym_tuple_type] = STATE(2616),
    [sym_unit_type] = STATE(2616),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2616),
    [sym_reference_type] = STATE(2616),
    [sym_pointer_type] = STATE(2616),
    [sym_empty_type] = STATE(2616),
    [sym_abstract_type] = STATE(2617),
    [sym_dynamic_type] = STATE(2616),
    [sym_macro_invocation] = STATE(2616),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(984),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(2004),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(2006),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2008),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2010),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2264] = {
    [sym_function_modifiers] = STATE(982),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2618),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(983),
    [sym_array_type] = STATE(2618),
    [sym_function_type] = STATE(2618),
    [sym_tuple_type] = STATE(2618),
    [sym_unit_type] = STATE(2618),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2618),
    [sym_reference_type] = STATE(2618),
    [sym_pointer_type] = STATE(2618),
    [sym_empty_type] = STATE(2618),
    [sym_abstract_type] = STATE(2619),
    [sym_dynamic_type] = STATE(2618),
    [sym_macro_invocation] = STATE(2618),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(984),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(2004),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(2006),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2008),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2010),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2265] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2988),
    [anon_sym_LBRACE] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(5758),
    [anon_sym_STAR] = ACTIONS(5758),
    [anon_sym_AMP] = ACTIONS(5758),
    [anon_sym_DASH] = ACTIONS(5758),
    [anon_sym_DOT] = ACTIONS(5758),
    [anon_sym_DASH_EQ] = ACTIONS(2988),
    [anon_sym_DASH_GT] = ACTIONS(6162),
    [anon_sym_BANG_EQ] = ACTIONS(2988),
    [anon_sym_STAR_EQ] = ACTIONS(2988),
    [anon_sym_SLASH] = ACTIONS(5758),
    [anon_sym_SLASH_EQ] = ACTIONS(2988),
    [anon_sym_AMP_AMP] = ACTIONS(2988),
    [anon_sym_AMP_EQ] = ACTIONS(2988),
    [anon_sym_PERCENT] = ACTIONS(5758),
    [anon_sym_PERCENT_EQ] = ACTIONS(2988),
    [anon_sym_CARET] = ACTIONS(5758),
    [anon_sym_CARET_EQ] = ACTIONS(2988),
    [anon_sym_PLUS_EQ] = ACTIONS(2988),
    [anon_sym_LT] = ACTIONS(5758),
    [anon_sym_LT_LT] = ACTIONS(5758),
    [anon_sym_LT_LT_EQ] = ACTIONS(2988),
    [anon_sym_LT_EQ] = ACTIONS(2988),
    [anon_sym_EQ] = ACTIONS(5758),
    [anon_sym_EQ_EQ] = ACTIONS(2988),
    [anon_sym_GT] = ACTIONS(5758),
    [anon_sym_GT_EQ] = ACTIONS(2988),
    [anon_sym_GT_GT] = ACTIONS(5758),
    [anon_sym_GT_GT_EQ] = ACTIONS(2988),
    [anon_sym_PIPE] = ACTIONS(5758),
    [anon_sym_PIPE_EQ] = ACTIONS(2988),
    [anon_sym_PIPE_PIPE] = ACTIONS(2988),
    [anon_sym_QMARK] = ACTIONS(2988),
    [anon_sym_DOT_DOT] = ACTIONS(5758),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2988),
    [anon_sym_as] = ACTIONS(2988),
    [sym_line_comment] = ACTIONS(7),
  },
  [2266] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2992),
    [anon_sym_LBRACE] = ACTIONS(2992),
    [anon_sym_LBRACK] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(5762),
    [anon_sym_STAR] = ACTIONS(5762),
    [anon_sym_AMP] = ACTIONS(5762),
    [anon_sym_DASH] = ACTIONS(5762),
    [anon_sym_DOT] = ACTIONS(5762),
    [anon_sym_DASH_EQ] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(6164),
    [anon_sym_BANG_EQ] = ACTIONS(2992),
    [anon_sym_STAR_EQ] = ACTIONS(2992),
    [anon_sym_SLASH] = ACTIONS(5762),
    [anon_sym_SLASH_EQ] = ACTIONS(2992),
    [anon_sym_AMP_AMP] = ACTIONS(2992),
    [anon_sym_AMP_EQ] = ACTIONS(2992),
    [anon_sym_PERCENT] = ACTIONS(5762),
    [anon_sym_PERCENT_EQ] = ACTIONS(2992),
    [anon_sym_CARET] = ACTIONS(5762),
    [anon_sym_CARET_EQ] = ACTIONS(2992),
    [anon_sym_PLUS_EQ] = ACTIONS(2992),
    [anon_sym_LT] = ACTIONS(5762),
    [anon_sym_LT_LT] = ACTIONS(5762),
    [anon_sym_LT_LT_EQ] = ACTIONS(2992),
    [anon_sym_LT_EQ] = ACTIONS(2992),
    [anon_sym_EQ] = ACTIONS(5762),
    [anon_sym_EQ_EQ] = ACTIONS(2992),
    [anon_sym_GT] = ACTIONS(5762),
    [anon_sym_GT_EQ] = ACTIONS(2992),
    [anon_sym_GT_GT] = ACTIONS(5762),
    [anon_sym_GT_GT_EQ] = ACTIONS(2992),
    [anon_sym_PIPE] = ACTIONS(5762),
    [anon_sym_PIPE_EQ] = ACTIONS(2992),
    [anon_sym_PIPE_PIPE] = ACTIONS(2992),
    [anon_sym_QMARK] = ACTIONS(2992),
    [anon_sym_DOT_DOT] = ACTIONS(5762),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2992),
    [anon_sym_as] = ACTIONS(2992),
    [sym_line_comment] = ACTIONS(7),
  },
  [2267] = {
    [sym_function_modifiers] = STATE(1655),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(821),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2270),
    [sym_array_type] = STATE(821),
    [sym_function_type] = STATE(821),
    [sym_tuple_type] = STATE(821),
    [sym_unit_type] = STATE(821),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(821),
    [sym_reference_type] = STATE(821),
    [sym_pointer_type] = STATE(821),
    [sym_empty_type] = STATE(821),
    [sym_dynamic_type] = STATE(821),
    [sym_macro_invocation] = STATE(821),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1658),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3205),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3207),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3211),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3215),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2268] = {
    [sym_function_modifiers] = STATE(1655),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2270),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1658),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3205),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3207),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3211),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3215),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2269] = {
    [sym_function_modifiers] = STATE(1655),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2270),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1658),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(6166),
    [anon_sym_STAR] = ACTIONS(3205),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3207),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3211),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(6168),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3215),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2270] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(6166),
    [sym_line_comment] = ACTIONS(7),
  },
  [2271] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(1760),
    [anon_sym_COMMA] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(6170),
    [anon_sym_EQ] = ACTIONS(1760),
    [anon_sym_GT] = ACTIONS(1760),
    [sym_line_comment] = ACTIONS(7),
  },
  [2272] = {
    [sym_function_modifiers] = STATE(1655),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2417),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2270),
    [sym_array_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_tuple_type] = STATE(2417),
    [sym_unit_type] = STATE(2417),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2417),
    [sym_reference_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_empty_type] = STATE(2417),
    [sym_dynamic_type] = STATE(2417),
    [sym_macro_invocation] = STATE(2417),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1658),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3205),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3207),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3211),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3215),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2273] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(1794),
    [anon_sym_COMMA] = ACTIONS(1794),
    [anon_sym_DASH_GT] = ACTIONS(6172),
    [anon_sym_EQ] = ACTIONS(1794),
    [anon_sym_GT] = ACTIONS(1794),
    [sym_line_comment] = ACTIONS(7),
  },
  [2274] = {
    [sym_parameters] = STATE(2785),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [2275] = {
    [sym_parameters] = STATE(2786),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [2276] = {
    [sym_parameters] = STATE(2785),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [2277] = {
    [sym_function_modifiers] = STATE(1655),
    [sym_higher_ranked_trait_bound] = STATE(2418),
    [sym_removed_trait_bound] = STATE(2418),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2419),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2419),
    [sym_array_type] = STATE(2419),
    [sym_function_type] = STATE(2419),
    [sym_tuple_type] = STATE(2419),
    [sym_unit_type] = STATE(2419),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2419),
    [sym_reference_type] = STATE(2419),
    [sym_pointer_type] = STATE(2419),
    [sym_empty_type] = STATE(2419),
    [sym_dynamic_type] = STATE(2419),
    [sym_macro_invocation] = STATE(2419),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1658),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3205),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3207),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_QMARK] = ACTIONS(3209),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3211),
    [anon_sym_for] = ACTIONS(3213),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3215),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2278] = {
    [aux_sym_trait_bounds_repeat1] = STATE(2787),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(5039),
    [anon_sym_COMMA] = ACTIONS(5344),
    [anon_sym_EQ] = ACTIONS(5344),
    [anon_sym_GT] = ACTIONS(5344),
    [sym_line_comment] = ACTIONS(7),
  },
  [2279] = {
    [sym_function_modifiers] = STATE(1655),
    [sym_higher_ranked_trait_bound] = STATE(2418),
    [sym_removed_trait_bound] = STATE(2418),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2419),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2419),
    [sym_array_type] = STATE(2419),
    [sym_function_type] = STATE(2419),
    [sym_tuple_type] = STATE(2419),
    [sym_unit_type] = STATE(2419),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2419),
    [sym_reference_type] = STATE(2419),
    [sym_pointer_type] = STATE(2419),
    [sym_empty_type] = STATE(2419),
    [sym_dynamic_type] = STATE(2419),
    [sym_macro_invocation] = STATE(2419),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1658),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3205),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3207),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_QMARK] = ACTIONS(3209),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3211),
    [anon_sym_for] = ACTIONS(3213),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3215),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2280] = {
    [sym_function_modifiers] = STATE(1003),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1479),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1005),
    [sym_array_type] = STATE(1479),
    [sym_function_type] = STATE(1479),
    [sym_tuple_type] = STATE(1479),
    [sym_unit_type] = STATE(1479),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1479),
    [sym_reference_type] = STATE(1479),
    [sym_pointer_type] = STATE(1479),
    [sym_empty_type] = STATE(1479),
    [sym_dynamic_type] = STATE(1479),
    [sym_macro_invocation] = STATE(1479),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1006),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2034),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2036),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2038),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2040),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2281] = {
    [sym_function_modifiers] = STATE(1003),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1499),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1005),
    [sym_array_type] = STATE(1499),
    [sym_function_type] = STATE(1499),
    [sym_tuple_type] = STATE(1499),
    [sym_unit_type] = STATE(1499),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1499),
    [sym_reference_type] = STATE(1499),
    [sym_pointer_type] = STATE(1499),
    [sym_empty_type] = STATE(1499),
    [sym_abstract_type] = STATE(1500),
    [sym_dynamic_type] = STATE(1499),
    [sym_macro_invocation] = STATE(1499),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1006),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2034),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2036),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2038),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2040),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2282] = {
    [sym_function_modifiers] = STATE(1003),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1525),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1005),
    [sym_array_type] = STATE(1525),
    [sym_function_type] = STATE(1525),
    [sym_tuple_type] = STATE(1525),
    [sym_unit_type] = STATE(1525),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1525),
    [sym_reference_type] = STATE(1525),
    [sym_pointer_type] = STATE(1525),
    [sym_empty_type] = STATE(1525),
    [sym_abstract_type] = STATE(1526),
    [sym_dynamic_type] = STATE(1525),
    [sym_macro_invocation] = STATE(1525),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1006),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2034),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2036),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2038),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2040),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2283] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_DASH_GT] = ACTIONS(6174),
    [anon_sym_where] = ACTIONS(2988),
    [sym_line_comment] = ACTIONS(7),
  },
  [2284] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(6176),
    [anon_sym_where] = ACTIONS(2992),
    [sym_line_comment] = ACTIONS(7),
  },
  [2285] = {
    [sym_raw_string_literal] = ACTIONS(6178),
    [sym_float_literal] = ACTIONS(6178),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(6178),
    [anon_sym_SEMI] = ACTIONS(6178),
    [anon_sym_macro_rules_BANG] = ACTIONS(6178),
    [anon_sym_LPAREN] = ACTIONS(6178),
    [anon_sym_LBRACE] = ACTIONS(6178),
    [anon_sym_RBRACE] = ACTIONS(6178),
    [anon_sym_LBRACK] = ACTIONS(6178),
    [anon_sym_STAR] = ACTIONS(6178),
    [anon_sym_u8] = ACTIONS(6180),
    [anon_sym_i8] = ACTIONS(6180),
    [anon_sym_u16] = ACTIONS(6180),
    [anon_sym_i16] = ACTIONS(6180),
    [anon_sym_u32] = ACTIONS(6180),
    [anon_sym_i32] = ACTIONS(6180),
    [anon_sym_u64] = ACTIONS(6180),
    [anon_sym_i64] = ACTIONS(6180),
    [anon_sym_u128] = ACTIONS(6180),
    [anon_sym_i128] = ACTIONS(6180),
    [anon_sym_isize] = ACTIONS(6180),
    [anon_sym_usize] = ACTIONS(6180),
    [anon_sym_f32] = ACTIONS(6180),
    [anon_sym_f64] = ACTIONS(6180),
    [anon_sym_bool] = ACTIONS(6180),
    [anon_sym_str] = ACTIONS(6180),
    [anon_sym_char] = ACTIONS(6180),
    [anon_sym_AMP] = ACTIONS(6178),
    [anon_sym_DASH] = ACTIONS(6178),
    [anon_sym_COLON_COLON] = ACTIONS(6178),
    [anon_sym_BANG] = ACTIONS(6178),
    [anon_sym_POUND] = ACTIONS(6178),
    [anon_sym_LT] = ACTIONS(6178),
    [anon_sym_PIPE] = ACTIONS(6178),
    [anon_sym_SQUOTE] = ACTIONS(6180),
    [anon_sym_DOT_DOT] = ACTIONS(6178),
    [anon_sym_break] = ACTIONS(6180),
    [anon_sym_const] = ACTIONS(6180),
    [anon_sym_continue] = ACTIONS(6180),
    [anon_sym_default] = ACTIONS(6180),
    [anon_sym_enum] = ACTIONS(6180),
    [anon_sym_fn] = ACTIONS(6180),
    [anon_sym_for] = ACTIONS(6180),
    [anon_sym_if] = ACTIONS(6180),
    [anon_sym_impl] = ACTIONS(6180),
    [anon_sym_let] = ACTIONS(6180),
    [anon_sym_loop] = ACTIONS(6180),
    [anon_sym_match] = ACTIONS(6180),
    [anon_sym_mod] = ACTIONS(6180),
    [anon_sym_pub] = ACTIONS(6180),
    [anon_sym_return] = ACTIONS(6180),
    [anon_sym_static] = ACTIONS(6180),
    [anon_sym_struct] = ACTIONS(6180),
    [anon_sym_trait] = ACTIONS(6180),
    [anon_sym_type] = ACTIONS(6180),
    [anon_sym_union] = ACTIONS(6180),
    [anon_sym_unsafe] = ACTIONS(6180),
    [anon_sym_use] = ACTIONS(6180),
    [anon_sym_while] = ACTIONS(6180),
    [anon_sym_extern] = ACTIONS(6180),
    [anon_sym_move] = ACTIONS(6180),
    [sym_integer_literal] = ACTIONS(6178),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6178),
    [sym_char_literal] = ACTIONS(6178),
    [anon_sym_true] = ACTIONS(6180),
    [anon_sym_false] = ACTIONS(6180),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6180),
    [sym_self] = ACTIONS(6180),
    [sym_super] = ACTIONS(6180),
    [sym_crate] = ACTIONS(6180),
    [sym_metavariable] = ACTIONS(6178),
  },
  [2286] = {
    [sym_raw_string_literal] = ACTIONS(6182),
    [sym_float_literal] = ACTIONS(6182),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(6182),
    [anon_sym_SEMI] = ACTIONS(6182),
    [anon_sym_macro_rules_BANG] = ACTIONS(6182),
    [anon_sym_LPAREN] = ACTIONS(6182),
    [anon_sym_LBRACE] = ACTIONS(6182),
    [anon_sym_RBRACE] = ACTIONS(6182),
    [anon_sym_LBRACK] = ACTIONS(6182),
    [anon_sym_STAR] = ACTIONS(6182),
    [anon_sym_u8] = ACTIONS(6184),
    [anon_sym_i8] = ACTIONS(6184),
    [anon_sym_u16] = ACTIONS(6184),
    [anon_sym_i16] = ACTIONS(6184),
    [anon_sym_u32] = ACTIONS(6184),
    [anon_sym_i32] = ACTIONS(6184),
    [anon_sym_u64] = ACTIONS(6184),
    [anon_sym_i64] = ACTIONS(6184),
    [anon_sym_u128] = ACTIONS(6184),
    [anon_sym_i128] = ACTIONS(6184),
    [anon_sym_isize] = ACTIONS(6184),
    [anon_sym_usize] = ACTIONS(6184),
    [anon_sym_f32] = ACTIONS(6184),
    [anon_sym_f64] = ACTIONS(6184),
    [anon_sym_bool] = ACTIONS(6184),
    [anon_sym_str] = ACTIONS(6184),
    [anon_sym_char] = ACTIONS(6184),
    [anon_sym_AMP] = ACTIONS(6182),
    [anon_sym_DASH] = ACTIONS(6182),
    [anon_sym_COLON_COLON] = ACTIONS(6182),
    [anon_sym_BANG] = ACTIONS(6182),
    [anon_sym_POUND] = ACTIONS(6182),
    [anon_sym_LT] = ACTIONS(6182),
    [anon_sym_PIPE] = ACTIONS(6182),
    [anon_sym_SQUOTE] = ACTIONS(6184),
    [anon_sym_DOT_DOT] = ACTIONS(6182),
    [anon_sym_break] = ACTIONS(6184),
    [anon_sym_const] = ACTIONS(6184),
    [anon_sym_continue] = ACTIONS(6184),
    [anon_sym_default] = ACTIONS(6184),
    [anon_sym_enum] = ACTIONS(6184),
    [anon_sym_fn] = ACTIONS(6184),
    [anon_sym_for] = ACTIONS(6184),
    [anon_sym_if] = ACTIONS(6184),
    [anon_sym_impl] = ACTIONS(6184),
    [anon_sym_let] = ACTIONS(6184),
    [anon_sym_loop] = ACTIONS(6184),
    [anon_sym_match] = ACTIONS(6184),
    [anon_sym_mod] = ACTIONS(6184),
    [anon_sym_pub] = ACTIONS(6184),
    [anon_sym_return] = ACTIONS(6184),
    [anon_sym_static] = ACTIONS(6184),
    [anon_sym_struct] = ACTIONS(6184),
    [anon_sym_trait] = ACTIONS(6184),
    [anon_sym_type] = ACTIONS(6184),
    [anon_sym_union] = ACTIONS(6184),
    [anon_sym_unsafe] = ACTIONS(6184),
    [anon_sym_use] = ACTIONS(6184),
    [anon_sym_while] = ACTIONS(6184),
    [anon_sym_extern] = ACTIONS(6184),
    [anon_sym_move] = ACTIONS(6184),
    [sym_integer_literal] = ACTIONS(6182),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6182),
    [sym_char_literal] = ACTIONS(6182),
    [anon_sym_true] = ACTIONS(6184),
    [anon_sym_false] = ACTIONS(6184),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6184),
    [sym_self] = ACTIONS(6184),
    [sym_super] = ACTIONS(6184),
    [sym_crate] = ACTIONS(6184),
    [sym_metavariable] = ACTIONS(6182),
  },
  [2287] = {
    [sym_declaration_list] = STATE(2790),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [sym_line_comment] = ACTIONS(7),
  },
  [2288] = {
    [sym_raw_string_literal] = ACTIONS(6186),
    [sym_float_literal] = ACTIONS(6186),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(6186),
    [anon_sym_SEMI] = ACTIONS(6186),
    [anon_sym_macro_rules_BANG] = ACTIONS(6186),
    [anon_sym_LPAREN] = ACTIONS(6186),
    [anon_sym_LBRACE] = ACTIONS(6186),
    [anon_sym_RBRACE] = ACTIONS(6186),
    [anon_sym_LBRACK] = ACTIONS(6186),
    [anon_sym_STAR] = ACTIONS(6186),
    [anon_sym_u8] = ACTIONS(6188),
    [anon_sym_i8] = ACTIONS(6188),
    [anon_sym_u16] = ACTIONS(6188),
    [anon_sym_i16] = ACTIONS(6188),
    [anon_sym_u32] = ACTIONS(6188),
    [anon_sym_i32] = ACTIONS(6188),
    [anon_sym_u64] = ACTIONS(6188),
    [anon_sym_i64] = ACTIONS(6188),
    [anon_sym_u128] = ACTIONS(6188),
    [anon_sym_i128] = ACTIONS(6188),
    [anon_sym_isize] = ACTIONS(6188),
    [anon_sym_usize] = ACTIONS(6188),
    [anon_sym_f32] = ACTIONS(6188),
    [anon_sym_f64] = ACTIONS(6188),
    [anon_sym_bool] = ACTIONS(6188),
    [anon_sym_str] = ACTIONS(6188),
    [anon_sym_char] = ACTIONS(6188),
    [anon_sym_AMP] = ACTIONS(6186),
    [anon_sym_DASH] = ACTIONS(6186),
    [anon_sym_COLON_COLON] = ACTIONS(6186),
    [anon_sym_BANG] = ACTIONS(6186),
    [anon_sym_POUND] = ACTIONS(6186),
    [anon_sym_LT] = ACTIONS(6186),
    [anon_sym_PIPE] = ACTIONS(6186),
    [anon_sym_SQUOTE] = ACTIONS(6188),
    [anon_sym_DOT_DOT] = ACTIONS(6186),
    [anon_sym_break] = ACTIONS(6188),
    [anon_sym_const] = ACTIONS(6188),
    [anon_sym_continue] = ACTIONS(6188),
    [anon_sym_default] = ACTIONS(6188),
    [anon_sym_enum] = ACTIONS(6188),
    [anon_sym_fn] = ACTIONS(6188),
    [anon_sym_for] = ACTIONS(6188),
    [anon_sym_if] = ACTIONS(6188),
    [anon_sym_impl] = ACTIONS(6188),
    [anon_sym_let] = ACTIONS(6188),
    [anon_sym_loop] = ACTIONS(6188),
    [anon_sym_match] = ACTIONS(6188),
    [anon_sym_mod] = ACTIONS(6188),
    [anon_sym_pub] = ACTIONS(6188),
    [anon_sym_return] = ACTIONS(6188),
    [anon_sym_static] = ACTIONS(6188),
    [anon_sym_struct] = ACTIONS(6188),
    [anon_sym_trait] = ACTIONS(6188),
    [anon_sym_type] = ACTIONS(6188),
    [anon_sym_union] = ACTIONS(6188),
    [anon_sym_unsafe] = ACTIONS(6188),
    [anon_sym_use] = ACTIONS(6188),
    [anon_sym_while] = ACTIONS(6188),
    [anon_sym_extern] = ACTIONS(6188),
    [anon_sym_move] = ACTIONS(6188),
    [sym_integer_literal] = ACTIONS(6186),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6186),
    [sym_char_literal] = ACTIONS(6186),
    [anon_sym_true] = ACTIONS(6188),
    [anon_sym_false] = ACTIONS(6188),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6188),
    [sym_self] = ACTIONS(6188),
    [sym_super] = ACTIONS(6188),
    [sym_crate] = ACTIONS(6188),
    [sym_metavariable] = ACTIONS(6186),
  },
  [2289] = {
    [sym_declaration_list] = STATE(2791),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [sym_line_comment] = ACTIONS(7),
  },
  [2290] = {
    [sym_raw_string_literal] = ACTIONS(6190),
    [sym_float_literal] = ACTIONS(6190),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(6190),
    [anon_sym_SEMI] = ACTIONS(6190),
    [anon_sym_macro_rules_BANG] = ACTIONS(6190),
    [anon_sym_LPAREN] = ACTIONS(6190),
    [anon_sym_LBRACE] = ACTIONS(6190),
    [anon_sym_RBRACE] = ACTIONS(6190),
    [anon_sym_LBRACK] = ACTIONS(6190),
    [anon_sym_STAR] = ACTIONS(6190),
    [anon_sym_u8] = ACTIONS(6192),
    [anon_sym_i8] = ACTIONS(6192),
    [anon_sym_u16] = ACTIONS(6192),
    [anon_sym_i16] = ACTIONS(6192),
    [anon_sym_u32] = ACTIONS(6192),
    [anon_sym_i32] = ACTIONS(6192),
    [anon_sym_u64] = ACTIONS(6192),
    [anon_sym_i64] = ACTIONS(6192),
    [anon_sym_u128] = ACTIONS(6192),
    [anon_sym_i128] = ACTIONS(6192),
    [anon_sym_isize] = ACTIONS(6192),
    [anon_sym_usize] = ACTIONS(6192),
    [anon_sym_f32] = ACTIONS(6192),
    [anon_sym_f64] = ACTIONS(6192),
    [anon_sym_bool] = ACTIONS(6192),
    [anon_sym_str] = ACTIONS(6192),
    [anon_sym_char] = ACTIONS(6192),
    [anon_sym_AMP] = ACTIONS(6190),
    [anon_sym_DASH] = ACTIONS(6190),
    [anon_sym_COLON_COLON] = ACTIONS(6190),
    [anon_sym_BANG] = ACTIONS(6190),
    [anon_sym_POUND] = ACTIONS(6190),
    [anon_sym_LT] = ACTIONS(6190),
    [anon_sym_PIPE] = ACTIONS(6190),
    [anon_sym_SQUOTE] = ACTIONS(6192),
    [anon_sym_DOT_DOT] = ACTIONS(6190),
    [anon_sym_break] = ACTIONS(6192),
    [anon_sym_const] = ACTIONS(6192),
    [anon_sym_continue] = ACTIONS(6192),
    [anon_sym_default] = ACTIONS(6192),
    [anon_sym_enum] = ACTIONS(6192),
    [anon_sym_fn] = ACTIONS(6192),
    [anon_sym_for] = ACTIONS(6192),
    [anon_sym_if] = ACTIONS(6192),
    [anon_sym_impl] = ACTIONS(6192),
    [anon_sym_let] = ACTIONS(6192),
    [anon_sym_loop] = ACTIONS(6192),
    [anon_sym_match] = ACTIONS(6192),
    [anon_sym_mod] = ACTIONS(6192),
    [anon_sym_pub] = ACTIONS(6192),
    [anon_sym_return] = ACTIONS(6192),
    [anon_sym_static] = ACTIONS(6192),
    [anon_sym_struct] = ACTIONS(6192),
    [anon_sym_trait] = ACTIONS(6192),
    [anon_sym_type] = ACTIONS(6192),
    [anon_sym_union] = ACTIONS(6192),
    [anon_sym_unsafe] = ACTIONS(6192),
    [anon_sym_use] = ACTIONS(6192),
    [anon_sym_while] = ACTIONS(6192),
    [anon_sym_extern] = ACTIONS(6192),
    [anon_sym_move] = ACTIONS(6192),
    [sym_integer_literal] = ACTIONS(6190),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6190),
    [sym_char_literal] = ACTIONS(6190),
    [anon_sym_true] = ACTIONS(6192),
    [anon_sym_false] = ACTIONS(6192),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6192),
    [sym_self] = ACTIONS(6192),
    [sym_super] = ACTIONS(6192),
    [sym_crate] = ACTIONS(6192),
    [sym_metavariable] = ACTIONS(6190),
  },
  [2291] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2792),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2792),
    [sym_macro_invocation] = STATE(2792),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2792),
    [sym_unary_expression] = STATE(2792),
    [sym_try_expression] = STATE(2792),
    [sym_reference_expression] = STATE(2792),
    [sym_binary_expression] = STATE(2792),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2792),
    [sym_call_expression] = STATE(2792),
    [sym_array_expression] = STATE(2792),
    [sym_parenthesized_expression] = STATE(2792),
    [sym_tuple_expression] = STATE(2792),
    [sym_unit_expression] = STATE(2792),
    [sym_struct_expression] = STATE(2792),
    [sym_if_expression] = STATE(2792),
    [sym_if_let_expression] = STATE(2792),
    [sym_match_expression] = STATE(2792),
    [sym_while_expression] = STATE(2792),
    [sym_while_let_expression] = STATE(2792),
    [sym_loop_expression] = STATE(2792),
    [sym_for_expression] = STATE(2792),
    [sym_closure_expression] = STATE(2792),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2792),
    [sym_continue_expression] = STATE(2792),
    [sym_index_expression] = STATE(2792),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2792),
    [sym_block] = STATE(2792),
    [sym__literal] = STATE(2792),
    [sym_string_literal] = STATE(2792),
    [sym_boolean_literal] = STATE(2792),
    [sym_raw_string_literal] = ACTIONS(6194),
    [sym_float_literal] = ACTIONS(6194),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(6194),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6194),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2292] = {
    [sym_function_modifiers] = STATE(1025),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1479),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1027),
    [sym_array_type] = STATE(1479),
    [sym_function_type] = STATE(1479),
    [sym_tuple_type] = STATE(1479),
    [sym_unit_type] = STATE(1479),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1479),
    [sym_reference_type] = STATE(1479),
    [sym_pointer_type] = STATE(1479),
    [sym_empty_type] = STATE(1479),
    [sym_dynamic_type] = STATE(1479),
    [sym_macro_invocation] = STATE(1479),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1028),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2060),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2062),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2064),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2066),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2293] = {
    [sym_function_modifiers] = STATE(1025),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1499),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1027),
    [sym_array_type] = STATE(1499),
    [sym_function_type] = STATE(1499),
    [sym_tuple_type] = STATE(1499),
    [sym_unit_type] = STATE(1499),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1499),
    [sym_reference_type] = STATE(1499),
    [sym_pointer_type] = STATE(1499),
    [sym_empty_type] = STATE(1499),
    [sym_abstract_type] = STATE(1500),
    [sym_dynamic_type] = STATE(1499),
    [sym_macro_invocation] = STATE(1499),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1028),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2060),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2062),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2064),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2066),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2294] = {
    [sym_function_modifiers] = STATE(1025),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1525),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1027),
    [sym_array_type] = STATE(1525),
    [sym_function_type] = STATE(1525),
    [sym_tuple_type] = STATE(1525),
    [sym_unit_type] = STATE(1525),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1525),
    [sym_reference_type] = STATE(1525),
    [sym_pointer_type] = STATE(1525),
    [sym_empty_type] = STATE(1525),
    [sym_abstract_type] = STATE(1526),
    [sym_dynamic_type] = STATE(1525),
    [sym_macro_invocation] = STATE(1525),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1028),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2060),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2062),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2064),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2066),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2295] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_DASH_GT] = ACTIONS(6196),
    [anon_sym_EQ] = ACTIONS(2988),
    [sym_line_comment] = ACTIONS(7),
  },
  [2296] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(6198),
    [anon_sym_EQ] = ACTIONS(2992),
    [sym_line_comment] = ACTIONS(7),
  },
  [2297] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6200),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(467),
    [anon_sym_BANG_EQ] = ACTIONS(469),
    [anon_sym_STAR_EQ] = ACTIONS(467),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(467),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_AMP_EQ] = ACTIONS(467),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(467),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_CARET_EQ] = ACTIONS(467),
    [anon_sym_PLUS_EQ] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT_LT_EQ] = ACTIONS(467),
    [anon_sym_LT_EQ] = ACTIONS(469),
    [anon_sym_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_EQ] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_PIPE_EQ] = ACTIONS(467),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(489),
    [anon_sym_as] = ACTIONS(491),
    [sym_line_comment] = ACTIONS(7),
  },
  [2298] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(3016),
    [anon_sym_PIPE] = ACTIONS(3016),
    [anon_sym_if] = ACTIONS(3016),
    [sym_line_comment] = ACTIONS(7),
  },
  [2299] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(1540),
    [sym_tuple_pattern] = STATE(1540),
    [sym_tuple_struct_pattern] = STATE(1540),
    [sym_struct_pattern] = STATE(1540),
    [sym_remaining_field_pattern] = STATE(1540),
    [sym_mut_pattern] = STATE(1540),
    [sym_ref_pattern] = STATE(1540),
    [sym_captured_pattern] = STATE(1540),
    [sym_reference_pattern] = STATE(1540),
    [sym__literal] = STATE(1540),
    [sym_string_literal] = STATE(1540),
    [sym_boolean_literal] = STATE(1540),
    [sym_raw_string_literal] = ACTIONS(3018),
    [sym_float_literal] = ACTIONS(3018),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_RPAREN] = ACTIONS(6202),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(817),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(819),
    [anon_sym_ref] = ACTIONS(821),
    [sym_integer_literal] = ACTIONS(3018),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(3018),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(823),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [2300] = {
    [aux_sym_tuple_pattern_repeat1] = STATE(1542),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(6202),
    [anon_sym_COMMA] = ACTIONS(6204),
    [sym_line_comment] = ACTIONS(7),
  },
  [2301] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1670),
    [anon_sym_LBRACE] = ACTIONS(2902),
    [anon_sym_EQ_GT] = ACTIONS(1670),
    [anon_sym_COLON_COLON] = ACTIONS(1670),
    [anon_sym_LT] = ACTIONS(2902),
    [anon_sym_PIPE] = ACTIONS(1670),
    [anon_sym_if] = ACTIONS(1670),
    [sym_line_comment] = ACTIONS(7),
  },
  [2302] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(3056),
    [anon_sym_PIPE] = ACTIONS(3056),
    [anon_sym_if] = ACTIONS(3056),
    [sym_line_comment] = ACTIONS(7),
  },
  [2303] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACK] = ACTIONS(6206),
    [sym_line_comment] = ACTIONS(7),
  },
  [2304] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(3064),
    [anon_sym_PIPE] = ACTIONS(3064),
    [anon_sym_if] = ACTIONS(3064),
    [sym_line_comment] = ACTIONS(7),
  },
  [2305] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(6208),
    [sym_line_comment] = ACTIONS(7),
  },
  [2306] = {
    [aux_sym_tuple_pattern_repeat1] = STATE(2801),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(6208),
    [anon_sym_COMMA] = ACTIONS(6210),
    [sym_line_comment] = ACTIONS(7),
  },
  [2307] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(3070),
    [anon_sym_PIPE] = ACTIONS(3070),
    [anon_sym_if] = ACTIONS(3070),
    [sym_line_comment] = ACTIONS(7),
  },
  [2308] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6212),
    [sym_line_comment] = ACTIONS(7),
  },
  [2309] = {
    [aux_sym_struct_pattern_repeat1] = STATE(2804),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6212),
    [anon_sym_COMMA] = ACTIONS(6214),
    [sym_line_comment] = ACTIONS(7),
  },
  [2310] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_EQ_GT] = ACTIONS(2263),
    [anon_sym_COLON_COLON] = ACTIONS(2263),
    [anon_sym_LT] = ACTIONS(2950),
    [anon_sym_PIPE] = ACTIONS(2263),
    [anon_sym_if] = ACTIONS(2263),
    [sym_line_comment] = ACTIONS(7),
  },
  [2311] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(3086),
    [anon_sym_PIPE] = ACTIONS(3086),
    [anon_sym_if] = ACTIONS(3086),
    [sym_line_comment] = ACTIONS(7),
  },
  [2312] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2529),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_EQ_GT] = ACTIONS(2529),
    [anon_sym_COLON_COLON] = ACTIONS(2529),
    [anon_sym_LT] = ACTIONS(3012),
    [anon_sym_PIPE] = ACTIONS(2529),
    [anon_sym_if] = ACTIONS(2529),
    [sym_line_comment] = ACTIONS(7),
  },
  [2313] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(3097),
    [anon_sym_PIPE] = ACTIONS(3097),
    [anon_sym_if] = ACTIONS(3097),
    [sym_line_comment] = ACTIONS(7),
  },
  [2314] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6216),
    [sym_line_comment] = ACTIONS(7),
  },
  [2315] = {
    [aux_sym_struct_pattern_repeat1] = STATE(2807),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6216),
    [anon_sym_COMMA] = ACTIONS(6218),
    [sym_line_comment] = ACTIONS(7),
  },
  [2316] = {
    [sym__statement] = STATE(2810),
    [sym_empty_statement] = STATE(2810),
    [sym__expression_statement] = STATE(2810),
    [sym_macro_definition] = STATE(2810),
    [sym_attribute_item] = STATE(2810),
    [sym_inner_attribute_item] = STATE(2810),
    [sym_mod_item] = STATE(2810),
    [sym_foreign_mod_item] = STATE(2810),
    [sym_struct_item] = STATE(2810),
    [sym_union_item] = STATE(2810),
    [sym_enum_item] = STATE(2810),
    [sym_extern_crate_declaration] = STATE(2810),
    [sym_const_item] = STATE(2810),
    [sym_static_item] = STATE(2810),
    [sym_type_item] = STATE(2810),
    [sym_function_item] = STATE(2810),
    [sym_function_signature_item] = STATE(2810),
    [sym_function_modifiers] = STATE(47),
    [sym_impl_item] = STATE(2810),
    [sym_trait_item] = STATE(2810),
    [sym_associated_type] = STATE(2810),
    [sym_let_declaration] = STATE(2810),
    [sym_use_declaration] = STATE(2810),
    [sym_extern_modifier] = STATE(48),
    [sym_visibility_modifier] = STATE(49),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2809),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2809),
    [sym_macro_invocation] = STATE(53),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2809),
    [sym_unary_expression] = STATE(2809),
    [sym_try_expression] = STATE(2809),
    [sym_reference_expression] = STATE(2809),
    [sym_binary_expression] = STATE(2809),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2809),
    [sym_call_expression] = STATE(2809),
    [sym_array_expression] = STATE(2809),
    [sym_parenthesized_expression] = STATE(2809),
    [sym_tuple_expression] = STATE(2809),
    [sym_unit_expression] = STATE(2809),
    [sym_struct_expression] = STATE(2809),
    [sym_if_expression] = STATE(57),
    [sym_if_let_expression] = STATE(57),
    [sym_match_expression] = STATE(57),
    [sym_while_expression] = STATE(57),
    [sym_while_let_expression] = STATE(57),
    [sym_loop_expression] = STATE(57),
    [sym_for_expression] = STATE(57),
    [sym_closure_expression] = STATE(2809),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(59),
    [sym_break_expression] = STATE(2809),
    [sym_continue_expression] = STATE(2809),
    [sym_index_expression] = STATE(2809),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(57),
    [sym_block] = STATE(57),
    [sym__literal] = STATE(2809),
    [sym_string_literal] = STATE(2809),
    [sym_boolean_literal] = STATE(2809),
    [aux_sym_source_file_repeat1] = STATE(2810),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_raw_string_literal] = ACTIONS(6220),
    [sym_float_literal] = ACTIONS(6220),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(6222),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_POUND] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(6220),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6220),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(93),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2317] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(2811),
    [sym_tuple_pattern] = STATE(2811),
    [sym_tuple_struct_pattern] = STATE(2811),
    [sym_struct_pattern] = STATE(2811),
    [sym_remaining_field_pattern] = STATE(2811),
    [sym_mut_pattern] = STATE(2811),
    [sym_ref_pattern] = STATE(2811),
    [sym_captured_pattern] = STATE(2811),
    [sym_reference_pattern] = STATE(2811),
    [sym__literal] = STATE(2811),
    [sym_string_literal] = STATE(2811),
    [sym_boolean_literal] = STATE(2811),
    [sym_raw_string_literal] = ACTIONS(6224),
    [sym_float_literal] = ACTIONS(6224),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(6226),
    [anon_sym_AMP] = ACTIONS(293),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(295),
    [anon_sym_ref] = ACTIONS(297),
    [sym_integer_literal] = ACTIONS(6224),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6224),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(299),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [2318] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2813),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(2813),
    [sym_macro_invocation] = STATE(2813),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2813),
    [sym_unary_expression] = STATE(2813),
    [sym_try_expression] = STATE(2813),
    [sym_reference_expression] = STATE(2813),
    [sym_binary_expression] = STATE(2813),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2813),
    [sym_call_expression] = STATE(2813),
    [sym_array_expression] = STATE(2813),
    [sym_parenthesized_expression] = STATE(2813),
    [sym_tuple_expression] = STATE(2813),
    [sym_unit_expression] = STATE(2813),
    [sym_struct_expression] = STATE(2813),
    [sym_if_expression] = STATE(2813),
    [sym_if_let_expression] = STATE(2813),
    [sym_match_expression] = STATE(2813),
    [sym_while_expression] = STATE(2813),
    [sym_while_let_expression] = STATE(2813),
    [sym_loop_expression] = STATE(2813),
    [sym_for_expression] = STATE(2813),
    [sym_closure_expression] = STATE(2813),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2813),
    [sym_continue_expression] = STATE(2813),
    [sym_index_expression] = STATE(2813),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2813),
    [sym_block] = STATE(2813),
    [sym__literal] = STATE(2813),
    [sym_string_literal] = STATE(2813),
    [sym_boolean_literal] = STATE(2813),
    [sym_raw_string_literal] = ACTIONS(6228),
    [sym_float_literal] = ACTIONS(6228),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_let] = ACTIONS(6230),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(6228),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6228),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [2319] = {
    [sym_block] = STATE(2814),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(5136),
    [sym_line_comment] = ACTIONS(7),
  },
  [2320] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2815),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(2815),
    [sym_macro_invocation] = STATE(2815),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2815),
    [sym_unary_expression] = STATE(2815),
    [sym_try_expression] = STATE(2815),
    [sym_reference_expression] = STATE(2815),
    [sym_binary_expression] = STATE(2815),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2815),
    [sym_call_expression] = STATE(2815),
    [sym_array_expression] = STATE(2815),
    [sym_parenthesized_expression] = STATE(2815),
    [sym_tuple_expression] = STATE(2815),
    [sym_unit_expression] = STATE(2815),
    [sym_struct_expression] = STATE(2815),
    [sym_if_expression] = STATE(2815),
    [sym_if_let_expression] = STATE(2815),
    [sym_match_expression] = STATE(2815),
    [sym_while_expression] = STATE(2815),
    [sym_while_let_expression] = STATE(2815),
    [sym_loop_expression] = STATE(2815),
    [sym_for_expression] = STATE(2815),
    [sym_closure_expression] = STATE(2815),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2815),
    [sym_continue_expression] = STATE(2815),
    [sym_index_expression] = STATE(2815),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2815),
    [sym_block] = STATE(2815),
    [sym__literal] = STATE(2815),
    [sym_string_literal] = STATE(2815),
    [sym_boolean_literal] = STATE(2815),
    [sym_raw_string_literal] = ACTIONS(6232),
    [sym_float_literal] = ACTIONS(6232),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(6232),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6232),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [2321] = {
    [sym_block] = STATE(2816),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(5136),
    [sym_line_comment] = ACTIONS(7),
  },
  [2322] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2818),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(2818),
    [sym_macro_invocation] = STATE(2818),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2818),
    [sym_unary_expression] = STATE(2818),
    [sym_try_expression] = STATE(2818),
    [sym_reference_expression] = STATE(2818),
    [sym_binary_expression] = STATE(2818),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2818),
    [sym_call_expression] = STATE(2818),
    [sym_array_expression] = STATE(2818),
    [sym_parenthesized_expression] = STATE(2818),
    [sym_tuple_expression] = STATE(2818),
    [sym_unit_expression] = STATE(2818),
    [sym_struct_expression] = STATE(2818),
    [sym_if_expression] = STATE(2818),
    [sym_if_let_expression] = STATE(2818),
    [sym_match_expression] = STATE(2818),
    [sym_while_expression] = STATE(2818),
    [sym_while_let_expression] = STATE(2818),
    [sym_loop_expression] = STATE(2818),
    [sym_for_expression] = STATE(2818),
    [sym_closure_expression] = STATE(2818),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2818),
    [sym_continue_expression] = STATE(2818),
    [sym_index_expression] = STATE(2818),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2818),
    [sym_block] = STATE(2818),
    [sym__literal] = STATE(2818),
    [sym_string_literal] = STATE(2818),
    [sym_boolean_literal] = STATE(2818),
    [sym_raw_string_literal] = ACTIONS(6234),
    [sym_float_literal] = ACTIONS(6234),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_let] = ACTIONS(6236),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(6234),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6234),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [2323] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(6238),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(3495),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(6240),
    [anon_sym_AMP] = ACTIONS(3499),
    [anon_sym_DASH] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(3501),
    [anon_sym_BANG_EQ] = ACTIONS(3503),
    [anon_sym_STAR_EQ] = ACTIONS(3501),
    [anon_sym_SLASH] = ACTIONS(3497),
    [anon_sym_SLASH_EQ] = ACTIONS(3501),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_AMP_EQ] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_PERCENT_EQ] = ACTIONS(3501),
    [anon_sym_CARET] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3501),
    [anon_sym_PLUS_EQ] = ACTIONS(3501),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_LT_LT] = ACTIONS(3511),
    [anon_sym_LT_LT_EQ] = ACTIONS(3501),
    [anon_sym_LT_EQ] = ACTIONS(3503),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_EQ_EQ] = ACTIONS(3503),
    [anon_sym_GT] = ACTIONS(3509),
    [anon_sym_GT_EQ] = ACTIONS(3503),
    [anon_sym_GT_GT] = ACTIONS(3511),
    [anon_sym_GT_GT_EQ] = ACTIONS(3501),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_PIPE_EQ] = ACTIONS(3501),
    [anon_sym_PIPE_PIPE] = ACTIONS(3517),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(3519),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3521),
    [anon_sym_as] = ACTIONS(3523),
    [sym_line_comment] = ACTIONS(7),
  },
  [2324] = {
    [sym_raw_string_literal] = ACTIONS(6242),
    [sym_float_literal] = ACTIONS(6242),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6242),
    [anon_sym_RBRACE] = ACTIONS(407),
    [anon_sym_LBRACK] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(411),
    [anon_sym_COMMA] = ACTIONS(407),
    [anon_sym_u8] = ACTIONS(6244),
    [anon_sym_i8] = ACTIONS(6244),
    [anon_sym_u16] = ACTIONS(6244),
    [anon_sym_i16] = ACTIONS(6244),
    [anon_sym_u32] = ACTIONS(6244),
    [anon_sym_i32] = ACTIONS(6244),
    [anon_sym_u64] = ACTIONS(6244),
    [anon_sym_i64] = ACTIONS(6244),
    [anon_sym_u128] = ACTIONS(6244),
    [anon_sym_i128] = ACTIONS(6244),
    [anon_sym_isize] = ACTIONS(6244),
    [anon_sym_usize] = ACTIONS(6244),
    [anon_sym_f32] = ACTIONS(6244),
    [anon_sym_f64] = ACTIONS(6244),
    [anon_sym_bool] = ACTIONS(6244),
    [anon_sym_str] = ACTIONS(6244),
    [anon_sym_char] = ACTIONS(6244),
    [anon_sym__] = ACTIONS(6244),
    [anon_sym_AMP] = ACTIONS(6244),
    [anon_sym_DASH] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(411),
    [anon_sym_DASH_EQ] = ACTIONS(407),
    [anon_sym_COLON_COLON] = ACTIONS(6242),
    [anon_sym_BANG_EQ] = ACTIONS(407),
    [anon_sym_STAR_EQ] = ACTIONS(407),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_SLASH_EQ] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(407),
    [anon_sym_AMP_EQ] = ACTIONS(407),
    [anon_sym_POUND] = ACTIONS(6242),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_PERCENT_EQ] = ACTIONS(407),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_CARET_EQ] = ACTIONS(407),
    [anon_sym_PLUS_EQ] = ACTIONS(407),
    [anon_sym_LT] = ACTIONS(6244),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_LT_LT_EQ] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(407),
    [anon_sym_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(407),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_GT_EQ] = ACTIONS(407),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_EQ] = ACTIONS(407),
    [anon_sym_PIPE] = ACTIONS(411),
    [anon_sym_PIPE_EQ] = ACTIONS(407),
    [anon_sym_PIPE_PIPE] = ACTIONS(407),
    [anon_sym_QMARK] = ACTIONS(407),
    [anon_sym_DOT_DOT] = ACTIONS(6244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(407),
    [anon_sym_as] = ACTIONS(411),
    [sym_mutable_specifier] = ACTIONS(6244),
    [anon_sym_ref] = ACTIONS(6244),
    [sym_integer_literal] = ACTIONS(6242),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6242),
    [sym_char_literal] = ACTIONS(6242),
    [anon_sym_true] = ACTIONS(6244),
    [anon_sym_false] = ACTIONS(6244),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6244),
    [sym_self] = ACTIONS(6244),
    [sym_super] = ACTIONS(6244),
    [sym_crate] = ACTIONS(6244),
    [sym_metavariable] = ACTIONS(6242),
  },
  [2325] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(6246),
    [sym_line_comment] = ACTIONS(7),
  },
  [2326] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(6248),
    [anon_sym_PIPE] = ACTIONS(6248),
    [anon_sym_if] = ACTIONS(6248),
    [sym_line_comment] = ACTIONS(7),
  },
  [2327] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2822),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2822),
    [sym_macro_invocation] = STATE(2822),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2822),
    [sym_unary_expression] = STATE(2822),
    [sym_try_expression] = STATE(2822),
    [sym_reference_expression] = STATE(2822),
    [sym_binary_expression] = STATE(2822),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2822),
    [sym_call_expression] = STATE(2822),
    [sym_array_expression] = STATE(2822),
    [sym_parenthesized_expression] = STATE(2822),
    [sym_tuple_expression] = STATE(2822),
    [sym_unit_expression] = STATE(2822),
    [sym_struct_expression] = STATE(2822),
    [sym_if_expression] = STATE(2822),
    [sym_if_let_expression] = STATE(2822),
    [sym_match_expression] = STATE(2822),
    [sym_while_expression] = STATE(2822),
    [sym_while_let_expression] = STATE(2822),
    [sym_loop_expression] = STATE(2822),
    [sym_for_expression] = STATE(2822),
    [sym_closure_expression] = STATE(2822),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2822),
    [sym_continue_expression] = STATE(2822),
    [sym_index_expression] = STATE(2822),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2822),
    [sym_block] = STATE(2822),
    [sym__literal] = STATE(2822),
    [sym_string_literal] = STATE(2822),
    [sym_boolean_literal] = STATE(2822),
    [sym_raw_string_literal] = ACTIONS(6250),
    [sym_float_literal] = ACTIONS(6250),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(6250),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6250),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2328] = {
    [sym__statement] = STATE(2825),
    [sym_empty_statement] = STATE(2825),
    [sym__expression_statement] = STATE(2825),
    [sym_macro_definition] = STATE(2825),
    [sym_attribute_item] = STATE(2825),
    [sym_inner_attribute_item] = STATE(2825),
    [sym_mod_item] = STATE(2825),
    [sym_foreign_mod_item] = STATE(2825),
    [sym_struct_item] = STATE(2825),
    [sym_union_item] = STATE(2825),
    [sym_enum_item] = STATE(2825),
    [sym_extern_crate_declaration] = STATE(2825),
    [sym_const_item] = STATE(2825),
    [sym_static_item] = STATE(2825),
    [sym_type_item] = STATE(2825),
    [sym_function_item] = STATE(2825),
    [sym_function_signature_item] = STATE(2825),
    [sym_function_modifiers] = STATE(47),
    [sym_impl_item] = STATE(2825),
    [sym_trait_item] = STATE(2825),
    [sym_associated_type] = STATE(2825),
    [sym_let_declaration] = STATE(2825),
    [sym_use_declaration] = STATE(2825),
    [sym_extern_modifier] = STATE(48),
    [sym_visibility_modifier] = STATE(49),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2824),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2824),
    [sym_macro_invocation] = STATE(53),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2824),
    [sym_unary_expression] = STATE(2824),
    [sym_try_expression] = STATE(2824),
    [sym_reference_expression] = STATE(2824),
    [sym_binary_expression] = STATE(2824),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2824),
    [sym_call_expression] = STATE(2824),
    [sym_array_expression] = STATE(2824),
    [sym_parenthesized_expression] = STATE(2824),
    [sym_tuple_expression] = STATE(2824),
    [sym_unit_expression] = STATE(2824),
    [sym_struct_expression] = STATE(2824),
    [sym_if_expression] = STATE(57),
    [sym_if_let_expression] = STATE(57),
    [sym_match_expression] = STATE(57),
    [sym_while_expression] = STATE(57),
    [sym_while_let_expression] = STATE(57),
    [sym_loop_expression] = STATE(57),
    [sym_for_expression] = STATE(57),
    [sym_closure_expression] = STATE(2824),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(59),
    [sym_break_expression] = STATE(2824),
    [sym_continue_expression] = STATE(2824),
    [sym_index_expression] = STATE(2824),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(57),
    [sym_block] = STATE(57),
    [sym__literal] = STATE(2824),
    [sym_string_literal] = STATE(2824),
    [sym_boolean_literal] = STATE(2824),
    [aux_sym_source_file_repeat1] = STATE(2825),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_raw_string_literal] = ACTIONS(6254),
    [sym_float_literal] = ACTIONS(6254),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(6256),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_POUND] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(6254),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6254),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(93),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2329] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2828),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2828),
    [sym_macro_invocation] = STATE(2828),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2828),
    [sym_unary_expression] = STATE(2828),
    [sym_try_expression] = STATE(2828),
    [sym_reference_expression] = STATE(2828),
    [sym_binary_expression] = STATE(2828),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2828),
    [sym_call_expression] = STATE(2828),
    [sym_array_expression] = STATE(2828),
    [sym_parenthesized_expression] = STATE(2828),
    [sym_tuple_expression] = STATE(2828),
    [sym_unit_expression] = STATE(2828),
    [sym_struct_expression] = STATE(2828),
    [sym_if_expression] = STATE(2828),
    [sym_if_let_expression] = STATE(2828),
    [sym_match_expression] = STATE(2828),
    [sym_while_expression] = STATE(2828),
    [sym_while_let_expression] = STATE(2828),
    [sym_loop_expression] = STATE(2828),
    [sym_for_expression] = STATE(2828),
    [sym_closure_expression] = STATE(2828),
    [sym_closure_parameters] = STATE(101),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2828),
    [sym_continue_expression] = STATE(2828),
    [sym_index_expression] = STATE(2828),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2828),
    [sym_block] = STATE(2828),
    [sym__literal] = STATE(2828),
    [sym_string_literal] = STATE(2828),
    [sym_boolean_literal] = STATE(2828),
    [sym_raw_string_literal] = ACTIONS(6258),
    [sym_float_literal] = ACTIONS(6258),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_RBRACK] = ACTIONS(6260),
    [anon_sym_STAR] = ACTIONS(159),
    [anon_sym_COMMA] = ACTIONS(6262),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(159),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(171),
    [sym_integer_literal] = ACTIONS(6258),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6258),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2330] = {
    [sym_bracketed_type] = STATE(2351),
    [sym_generic_function] = STATE(2829),
    [sym_generic_type_with_turbofish] = STATE(2352),
    [sym__expression] = STATE(2829),
    [sym_macro_invocation] = STATE(2829),
    [sym_scoped_identifier] = STATE(2354),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2355),
    [sym_range_expression] = STATE(2829),
    [sym_unary_expression] = STATE(2829),
    [sym_try_expression] = STATE(2829),
    [sym_reference_expression] = STATE(2829),
    [sym_binary_expression] = STATE(2829),
    [sym_assignment_expression] = STATE(2356),
    [sym_compound_assignment_expr] = STATE(2356),
    [sym_type_cast_expression] = STATE(2356),
    [sym_return_expression] = STATE(2829),
    [sym_call_expression] = STATE(2829),
    [sym_array_expression] = STATE(2829),
    [sym_parenthesized_expression] = STATE(2829),
    [sym_tuple_expression] = STATE(2829),
    [sym_unit_expression] = STATE(2829),
    [sym_struct_expression] = STATE(2829),
    [sym_if_expression] = STATE(2829),
    [sym_if_let_expression] = STATE(2829),
    [sym_match_expression] = STATE(2829),
    [sym_while_expression] = STATE(2829),
    [sym_while_let_expression] = STATE(2829),
    [sym_loop_expression] = STATE(2829),
    [sym_for_expression] = STATE(2829),
    [sym_closure_expression] = STATE(2829),
    [sym_closure_parameters] = STATE(2357),
    [sym_loop_label] = STATE(2358),
    [sym_break_expression] = STATE(2829),
    [sym_continue_expression] = STATE(2829),
    [sym_index_expression] = STATE(2829),
    [sym_field_expression] = STATE(2359),
    [sym_unsafe_block] = STATE(2829),
    [sym_block] = STATE(2829),
    [sym__literal] = STATE(2829),
    [sym_string_literal] = STATE(2829),
    [sym_boolean_literal] = STATE(2829),
    [sym_raw_string_literal] = ACTIONS(6264),
    [sym_float_literal] = ACTIONS(6264),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5154),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_LBRACK] = ACTIONS(5158),
    [anon_sym_STAR] = ACTIONS(5160),
    [anon_sym_u8] = ACTIONS(5162),
    [anon_sym_i8] = ACTIONS(5162),
    [anon_sym_u16] = ACTIONS(5162),
    [anon_sym_i16] = ACTIONS(5162),
    [anon_sym_u32] = ACTIONS(5162),
    [anon_sym_i32] = ACTIONS(5162),
    [anon_sym_u64] = ACTIONS(5162),
    [anon_sym_i64] = ACTIONS(5162),
    [anon_sym_u128] = ACTIONS(5162),
    [anon_sym_i128] = ACTIONS(5162),
    [anon_sym_isize] = ACTIONS(5162),
    [anon_sym_usize] = ACTIONS(5162),
    [anon_sym_f32] = ACTIONS(5162),
    [anon_sym_f64] = ACTIONS(5162),
    [anon_sym_bool] = ACTIONS(5162),
    [anon_sym_str] = ACTIONS(5162),
    [anon_sym_char] = ACTIONS(5162),
    [anon_sym_AMP] = ACTIONS(5164),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_COLON_COLON] = ACTIONS(5166),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5168),
    [anon_sym_break] = ACTIONS(5170),
    [anon_sym_continue] = ACTIONS(5172),
    [anon_sym_default] = ACTIONS(5174),
    [anon_sym_for] = ACTIONS(5176),
    [anon_sym_if] = ACTIONS(5178),
    [anon_sym_loop] = ACTIONS(5180),
    [anon_sym_match] = ACTIONS(5182),
    [anon_sym_return] = ACTIONS(5184),
    [anon_sym_union] = ACTIONS(5174),
    [anon_sym_unsafe] = ACTIONS(5186),
    [anon_sym_while] = ACTIONS(5188),
    [anon_sym_move] = ACTIONS(5190),
    [sym_integer_literal] = ACTIONS(6264),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5192),
    [sym_char_literal] = ACTIONS(6264),
    [anon_sym_true] = ACTIONS(5194),
    [anon_sym_false] = ACTIONS(5194),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5196),
    [sym_self] = ACTIONS(5198),
    [sym_super] = ACTIONS(5200),
    [sym_crate] = ACTIONS(5200),
    [sym_metavariable] = ACTIONS(5202),
  },
  [2331] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(177),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(179),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_DASH] = ACTIONS(179),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_COLON_COLON] = ACTIONS(6266),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ] = ACTIONS(177),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(177),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(177),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_as] = ACTIONS(177),
    [sym_line_comment] = ACTIONS(7),
  },
  [2332] = {
    [sym_bracketed_type] = STATE(2351),
    [sym_generic_function] = STATE(2832),
    [sym_generic_type_with_turbofish] = STATE(2352),
    [sym__expression] = STATE(2832),
    [sym_macro_invocation] = STATE(2832),
    [sym_scoped_identifier] = STATE(2354),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2355),
    [sym_range_expression] = STATE(2832),
    [sym_unary_expression] = STATE(2832),
    [sym_try_expression] = STATE(2832),
    [sym_reference_expression] = STATE(2832),
    [sym_binary_expression] = STATE(2832),
    [sym_assignment_expression] = STATE(2356),
    [sym_compound_assignment_expr] = STATE(2356),
    [sym_type_cast_expression] = STATE(2356),
    [sym_return_expression] = STATE(2832),
    [sym_call_expression] = STATE(2832),
    [sym_array_expression] = STATE(2832),
    [sym_parenthesized_expression] = STATE(2832),
    [sym_tuple_expression] = STATE(2832),
    [sym_unit_expression] = STATE(2832),
    [sym_struct_expression] = STATE(2832),
    [sym_if_expression] = STATE(2832),
    [sym_if_let_expression] = STATE(2832),
    [sym_match_expression] = STATE(2832),
    [sym_while_expression] = STATE(2832),
    [sym_while_let_expression] = STATE(2832),
    [sym_loop_expression] = STATE(2832),
    [sym_for_expression] = STATE(2832),
    [sym_closure_expression] = STATE(2832),
    [sym_closure_parameters] = STATE(2357),
    [sym_loop_label] = STATE(2358),
    [sym_break_expression] = STATE(2832),
    [sym_continue_expression] = STATE(2832),
    [sym_index_expression] = STATE(2832),
    [sym_field_expression] = STATE(2359),
    [sym_unsafe_block] = STATE(2832),
    [sym_block] = STATE(2832),
    [sym__literal] = STATE(2832),
    [sym_string_literal] = STATE(2832),
    [sym_boolean_literal] = STATE(2832),
    [sym_raw_string_literal] = ACTIONS(6268),
    [sym_float_literal] = ACTIONS(6268),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5154),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_LBRACK] = ACTIONS(5158),
    [anon_sym_STAR] = ACTIONS(5160),
    [anon_sym_u8] = ACTIONS(5162),
    [anon_sym_i8] = ACTIONS(5162),
    [anon_sym_u16] = ACTIONS(5162),
    [anon_sym_i16] = ACTIONS(5162),
    [anon_sym_u32] = ACTIONS(5162),
    [anon_sym_i32] = ACTIONS(5162),
    [anon_sym_u64] = ACTIONS(5162),
    [anon_sym_i64] = ACTIONS(5162),
    [anon_sym_u128] = ACTIONS(5162),
    [anon_sym_i128] = ACTIONS(5162),
    [anon_sym_isize] = ACTIONS(5162),
    [anon_sym_usize] = ACTIONS(5162),
    [anon_sym_f32] = ACTIONS(5162),
    [anon_sym_f64] = ACTIONS(5162),
    [anon_sym_bool] = ACTIONS(5162),
    [anon_sym_str] = ACTIONS(5162),
    [anon_sym_char] = ACTIONS(5162),
    [anon_sym_AMP] = ACTIONS(5164),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_COLON_COLON] = ACTIONS(5166),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5168),
    [anon_sym_break] = ACTIONS(5170),
    [anon_sym_continue] = ACTIONS(5172),
    [anon_sym_default] = ACTIONS(5174),
    [anon_sym_for] = ACTIONS(5176),
    [anon_sym_if] = ACTIONS(5178),
    [anon_sym_loop] = ACTIONS(5180),
    [anon_sym_match] = ACTIONS(5182),
    [anon_sym_return] = ACTIONS(5184),
    [anon_sym_union] = ACTIONS(5174),
    [anon_sym_unsafe] = ACTIONS(5186),
    [anon_sym_while] = ACTIONS(5188),
    [sym_mutable_specifier] = ACTIONS(6270),
    [anon_sym_move] = ACTIONS(5190),
    [sym_integer_literal] = ACTIONS(6268),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5192),
    [sym_char_literal] = ACTIONS(6268),
    [anon_sym_true] = ACTIONS(5194),
    [anon_sym_false] = ACTIONS(5194),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5196),
    [sym_self] = ACTIONS(5198),
    [sym_super] = ACTIONS(5200),
    [sym_crate] = ACTIONS(5200),
    [sym_metavariable] = ACTIONS(5202),
  },
  [2333] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6272),
  },
  [2334] = {
    [sym_bracketed_type] = STATE(2351),
    [sym_generic_function] = STATE(2834),
    [sym_generic_type_with_turbofish] = STATE(2352),
    [sym__expression] = STATE(2834),
    [sym_macro_invocation] = STATE(2834),
    [sym_scoped_identifier] = STATE(2354),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2355),
    [sym_range_expression] = STATE(2834),
    [sym_unary_expression] = STATE(2834),
    [sym_try_expression] = STATE(2834),
    [sym_reference_expression] = STATE(2834),
    [sym_binary_expression] = STATE(2834),
    [sym_assignment_expression] = STATE(2356),
    [sym_compound_assignment_expr] = STATE(2356),
    [sym_type_cast_expression] = STATE(2356),
    [sym_return_expression] = STATE(2834),
    [sym_call_expression] = STATE(2834),
    [sym_array_expression] = STATE(2834),
    [sym_parenthesized_expression] = STATE(2834),
    [sym_tuple_expression] = STATE(2834),
    [sym_unit_expression] = STATE(2834),
    [sym_struct_expression] = STATE(2834),
    [sym_if_expression] = STATE(2834),
    [sym_if_let_expression] = STATE(2834),
    [sym_match_expression] = STATE(2834),
    [sym_while_expression] = STATE(2834),
    [sym_while_let_expression] = STATE(2834),
    [sym_loop_expression] = STATE(2834),
    [sym_for_expression] = STATE(2834),
    [sym_closure_expression] = STATE(2834),
    [sym_closure_parameters] = STATE(2357),
    [sym_loop_label] = STATE(2358),
    [sym_break_expression] = STATE(2834),
    [sym_continue_expression] = STATE(2834),
    [sym_index_expression] = STATE(2834),
    [sym_field_expression] = STATE(2359),
    [sym_unsafe_block] = STATE(2834),
    [sym_block] = STATE(2834),
    [sym__literal] = STATE(2834),
    [sym_string_literal] = STATE(2834),
    [sym_boolean_literal] = STATE(2834),
    [sym_raw_string_literal] = ACTIONS(6274),
    [sym_float_literal] = ACTIONS(6274),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_EQ_GT] = ACTIONS(261),
    [anon_sym_LBRACK] = ACTIONS(261),
    [anon_sym_PLUS] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(263),
    [anon_sym_u8] = ACTIONS(5162),
    [anon_sym_i8] = ACTIONS(5162),
    [anon_sym_u16] = ACTIONS(5162),
    [anon_sym_i16] = ACTIONS(5162),
    [anon_sym_u32] = ACTIONS(5162),
    [anon_sym_i32] = ACTIONS(5162),
    [anon_sym_u64] = ACTIONS(5162),
    [anon_sym_i64] = ACTIONS(5162),
    [anon_sym_u128] = ACTIONS(5162),
    [anon_sym_i128] = ACTIONS(5162),
    [anon_sym_isize] = ACTIONS(5162),
    [anon_sym_usize] = ACTIONS(5162),
    [anon_sym_f32] = ACTIONS(5162),
    [anon_sym_f64] = ACTIONS(5162),
    [anon_sym_bool] = ACTIONS(5162),
    [anon_sym_str] = ACTIONS(5162),
    [anon_sym_char] = ACTIONS(5162),
    [anon_sym_AMP] = ACTIONS(263),
    [anon_sym_DASH] = ACTIONS(263),
    [anon_sym_DOT] = ACTIONS(263),
    [anon_sym_DASH_EQ] = ACTIONS(261),
    [anon_sym_COLON_COLON] = ACTIONS(5166),
    [anon_sym_BANG] = ACTIONS(6276),
    [anon_sym_BANG_EQ] = ACTIONS(261),
    [anon_sym_STAR_EQ] = ACTIONS(261),
    [anon_sym_SLASH] = ACTIONS(263),
    [anon_sym_SLASH_EQ] = ACTIONS(261),
    [anon_sym_AMP_AMP] = ACTIONS(261),
    [anon_sym_AMP_EQ] = ACTIONS(261),
    [anon_sym_PERCENT] = ACTIONS(263),
    [anon_sym_PERCENT_EQ] = ACTIONS(261),
    [anon_sym_CARET] = ACTIONS(263),
    [anon_sym_CARET_EQ] = ACTIONS(261),
    [anon_sym_PLUS_EQ] = ACTIONS(261),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_EQ] = ACTIONS(261),
    [anon_sym_LT_EQ] = ACTIONS(261),
    [anon_sym_EQ] = ACTIONS(263),
    [anon_sym_EQ_EQ] = ACTIONS(261),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_EQ] = ACTIONS(261),
    [anon_sym_GT_GT] = ACTIONS(263),
    [anon_sym_GT_GT_EQ] = ACTIONS(261),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_PIPE_EQ] = ACTIONS(261),
    [anon_sym_PIPE_PIPE] = ACTIONS(261),
    [anon_sym_QMARK] = ACTIONS(261),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(263),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(261),
    [anon_sym_as] = ACTIONS(263),
    [anon_sym_break] = ACTIONS(5170),
    [anon_sym_continue] = ACTIONS(5172),
    [anon_sym_default] = ACTIONS(5174),
    [anon_sym_for] = ACTIONS(5176),
    [anon_sym_if] = ACTIONS(5178),
    [anon_sym_loop] = ACTIONS(5180),
    [anon_sym_match] = ACTIONS(5182),
    [anon_sym_return] = ACTIONS(5184),
    [anon_sym_union] = ACTIONS(5174),
    [anon_sym_unsafe] = ACTIONS(5186),
    [anon_sym_while] = ACTIONS(5188),
    [anon_sym_move] = ACTIONS(5190),
    [sym_integer_literal] = ACTIONS(6274),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5192),
    [sym_char_literal] = ACTIONS(6274),
    [anon_sym_true] = ACTIONS(5194),
    [anon_sym_false] = ACTIONS(5194),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5196),
    [sym_self] = ACTIONS(5198),
    [sym_super] = ACTIONS(5200),
    [sym_crate] = ACTIONS(5200),
    [sym_metavariable] = ACTIONS(5202),
  },
  [2335] = {
    [sym_loop_label] = STATE(2836),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(267),
    [anon_sym_EQ_GT] = ACTIONS(267),
    [anon_sym_LBRACK] = ACTIONS(267),
    [anon_sym_PLUS] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(269),
    [anon_sym_AMP] = ACTIONS(269),
    [anon_sym_DASH] = ACTIONS(269),
    [anon_sym_DOT] = ACTIONS(269),
    [anon_sym_DASH_EQ] = ACTIONS(267),
    [anon_sym_BANG_EQ] = ACTIONS(267),
    [anon_sym_STAR_EQ] = ACTIONS(267),
    [anon_sym_SLASH] = ACTIONS(269),
    [anon_sym_SLASH_EQ] = ACTIONS(267),
    [anon_sym_AMP_AMP] = ACTIONS(267),
    [anon_sym_AMP_EQ] = ACTIONS(267),
    [anon_sym_PERCENT] = ACTIONS(269),
    [anon_sym_PERCENT_EQ] = ACTIONS(267),
    [anon_sym_CARET] = ACTIONS(269),
    [anon_sym_CARET_EQ] = ACTIONS(267),
    [anon_sym_PLUS_EQ] = ACTIONS(267),
    [anon_sym_LT] = ACTIONS(269),
    [anon_sym_LT_LT] = ACTIONS(269),
    [anon_sym_LT_LT_EQ] = ACTIONS(267),
    [anon_sym_LT_EQ] = ACTIONS(267),
    [anon_sym_EQ] = ACTIONS(269),
    [anon_sym_EQ_EQ] = ACTIONS(267),
    [anon_sym_GT] = ACTIONS(269),
    [anon_sym_GT_EQ] = ACTIONS(267),
    [anon_sym_GT_GT] = ACTIONS(269),
    [anon_sym_GT_GT_EQ] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(267),
    [anon_sym_PIPE_PIPE] = ACTIONS(267),
    [anon_sym_QMARK] = ACTIONS(267),
    [anon_sym_SQUOTE] = ACTIONS(6278),
    [anon_sym_DOT_DOT] = ACTIONS(269),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(267),
    [anon_sym_as] = ACTIONS(267),
    [sym_line_comment] = ACTIONS(7),
  },
  [2336] = {
    [sym_loop_label] = STATE(2837),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_EQ_GT] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_PLUS] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(279),
    [anon_sym_AMP] = ACTIONS(279),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_DASH_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_STAR_EQ] = ACTIONS(277),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_SLASH_EQ] = ACTIONS(277),
    [anon_sym_AMP_AMP] = ACTIONS(277),
    [anon_sym_AMP_EQ] = ACTIONS(277),
    [anon_sym_PERCENT] = ACTIONS(279),
    [anon_sym_PERCENT_EQ] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(279),
    [anon_sym_CARET_EQ] = ACTIONS(277),
    [anon_sym_PLUS_EQ] = ACTIONS(277),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(279),
    [anon_sym_LT_LT_EQ] = ACTIONS(277),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ] = ACTIONS(279),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT_GT] = ACTIONS(279),
    [anon_sym_GT_GT_EQ] = ACTIONS(277),
    [anon_sym_PIPE] = ACTIONS(279),
    [anon_sym_PIPE_EQ] = ACTIONS(277),
    [anon_sym_PIPE_PIPE] = ACTIONS(277),
    [anon_sym_QMARK] = ACTIONS(277),
    [anon_sym_SQUOTE] = ACTIONS(6278),
    [anon_sym_DOT_DOT] = ACTIONS(279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(277),
    [sym_line_comment] = ACTIONS(7),
  },
  [2337] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(177),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(179),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_DASH] = ACTIONS(179),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ] = ACTIONS(177),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(177),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(177),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_as] = ACTIONS(177),
    [sym_line_comment] = ACTIONS(7),
  },
  [2338] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(2838),
    [sym_tuple_pattern] = STATE(2838),
    [sym_tuple_struct_pattern] = STATE(2838),
    [sym_struct_pattern] = STATE(2838),
    [sym_remaining_field_pattern] = STATE(2838),
    [sym_mut_pattern] = STATE(2838),
    [sym_ref_pattern] = STATE(2838),
    [sym_captured_pattern] = STATE(2838),
    [sym_reference_pattern] = STATE(2838),
    [sym__literal] = STATE(2838),
    [sym_string_literal] = STATE(2838),
    [sym_boolean_literal] = STATE(2838),
    [sym_raw_string_literal] = ACTIONS(6280),
    [sym_float_literal] = ACTIONS(6280),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(6282),
    [anon_sym_AMP] = ACTIONS(293),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(295),
    [anon_sym_ref] = ACTIONS(297),
    [sym_integer_literal] = ACTIONS(6280),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6280),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(299),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [2339] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2840),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(2840),
    [sym_macro_invocation] = STATE(2840),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2840),
    [sym_unary_expression] = STATE(2840),
    [sym_try_expression] = STATE(2840),
    [sym_reference_expression] = STATE(2840),
    [sym_binary_expression] = STATE(2840),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2840),
    [sym_call_expression] = STATE(2840),
    [sym_array_expression] = STATE(2840),
    [sym_parenthesized_expression] = STATE(2840),
    [sym_tuple_expression] = STATE(2840),
    [sym_unit_expression] = STATE(2840),
    [sym_struct_expression] = STATE(2840),
    [sym_if_expression] = STATE(2840),
    [sym_if_let_expression] = STATE(2840),
    [sym_match_expression] = STATE(2840),
    [sym_while_expression] = STATE(2840),
    [sym_while_let_expression] = STATE(2840),
    [sym_loop_expression] = STATE(2840),
    [sym_for_expression] = STATE(2840),
    [sym_closure_expression] = STATE(2840),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2840),
    [sym_continue_expression] = STATE(2840),
    [sym_index_expression] = STATE(2840),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2840),
    [sym_block] = STATE(2840),
    [sym__literal] = STATE(2840),
    [sym_string_literal] = STATE(2840),
    [sym_boolean_literal] = STATE(2840),
    [sym_raw_string_literal] = ACTIONS(6284),
    [sym_float_literal] = ACTIONS(6284),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_let] = ACTIONS(6286),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(6284),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6284),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [2340] = {
    [sym_block] = STATE(2841),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [sym_line_comment] = ACTIONS(7),
  },
  [2341] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2842),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(2842),
    [sym_macro_invocation] = STATE(2842),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2842),
    [sym_unary_expression] = STATE(2842),
    [sym_try_expression] = STATE(2842),
    [sym_reference_expression] = STATE(2842),
    [sym_binary_expression] = STATE(2842),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2842),
    [sym_call_expression] = STATE(2842),
    [sym_array_expression] = STATE(2842),
    [sym_parenthesized_expression] = STATE(2842),
    [sym_tuple_expression] = STATE(2842),
    [sym_unit_expression] = STATE(2842),
    [sym_struct_expression] = STATE(2842),
    [sym_if_expression] = STATE(2842),
    [sym_if_let_expression] = STATE(2842),
    [sym_match_expression] = STATE(2842),
    [sym_while_expression] = STATE(2842),
    [sym_while_let_expression] = STATE(2842),
    [sym_loop_expression] = STATE(2842),
    [sym_for_expression] = STATE(2842),
    [sym_closure_expression] = STATE(2842),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2842),
    [sym_continue_expression] = STATE(2842),
    [sym_index_expression] = STATE(2842),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2842),
    [sym_block] = STATE(2842),
    [sym__literal] = STATE(2842),
    [sym_string_literal] = STATE(2842),
    [sym_boolean_literal] = STATE(2842),
    [sym_raw_string_literal] = ACTIONS(6288),
    [sym_float_literal] = ACTIONS(6288),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(6288),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6288),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [2342] = {
    [sym_bracketed_type] = STATE(2351),
    [sym_generic_function] = STATE(2843),
    [sym_generic_type_with_turbofish] = STATE(2352),
    [sym__expression] = STATE(2843),
    [sym_macro_invocation] = STATE(2843),
    [sym_scoped_identifier] = STATE(2354),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2355),
    [sym_range_expression] = STATE(2843),
    [sym_unary_expression] = STATE(2843),
    [sym_try_expression] = STATE(2843),
    [sym_reference_expression] = STATE(2843),
    [sym_binary_expression] = STATE(2843),
    [sym_assignment_expression] = STATE(2356),
    [sym_compound_assignment_expr] = STATE(2356),
    [sym_type_cast_expression] = STATE(2356),
    [sym_return_expression] = STATE(2843),
    [sym_call_expression] = STATE(2843),
    [sym_array_expression] = STATE(2843),
    [sym_parenthesized_expression] = STATE(2843),
    [sym_tuple_expression] = STATE(2843),
    [sym_unit_expression] = STATE(2843),
    [sym_struct_expression] = STATE(2843),
    [sym_if_expression] = STATE(2843),
    [sym_if_let_expression] = STATE(2843),
    [sym_match_expression] = STATE(2843),
    [sym_while_expression] = STATE(2843),
    [sym_while_let_expression] = STATE(2843),
    [sym_loop_expression] = STATE(2843),
    [sym_for_expression] = STATE(2843),
    [sym_closure_expression] = STATE(2843),
    [sym_closure_parameters] = STATE(2357),
    [sym_loop_label] = STATE(2358),
    [sym_break_expression] = STATE(2843),
    [sym_continue_expression] = STATE(2843),
    [sym_index_expression] = STATE(2843),
    [sym_field_expression] = STATE(2359),
    [sym_unsafe_block] = STATE(2843),
    [sym_block] = STATE(2843),
    [sym__literal] = STATE(2843),
    [sym_string_literal] = STATE(2843),
    [sym_boolean_literal] = STATE(2843),
    [sym_raw_string_literal] = ACTIONS(6290),
    [sym_float_literal] = ACTIONS(6290),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(359),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_EQ_GT] = ACTIONS(359),
    [anon_sym_LBRACK] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(361),
    [anon_sym_STAR] = ACTIONS(361),
    [anon_sym_u8] = ACTIONS(5162),
    [anon_sym_i8] = ACTIONS(5162),
    [anon_sym_u16] = ACTIONS(5162),
    [anon_sym_i16] = ACTIONS(5162),
    [anon_sym_u32] = ACTIONS(5162),
    [anon_sym_i32] = ACTIONS(5162),
    [anon_sym_u64] = ACTIONS(5162),
    [anon_sym_i64] = ACTIONS(5162),
    [anon_sym_u128] = ACTIONS(5162),
    [anon_sym_i128] = ACTIONS(5162),
    [anon_sym_isize] = ACTIONS(5162),
    [anon_sym_usize] = ACTIONS(5162),
    [anon_sym_f32] = ACTIONS(5162),
    [anon_sym_f64] = ACTIONS(5162),
    [anon_sym_bool] = ACTIONS(5162),
    [anon_sym_str] = ACTIONS(5162),
    [anon_sym_char] = ACTIONS(5162),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(361),
    [anon_sym_DASH_EQ] = ACTIONS(359),
    [anon_sym_COLON_COLON] = ACTIONS(5166),
    [anon_sym_BANG] = ACTIONS(6276),
    [anon_sym_BANG_EQ] = ACTIONS(359),
    [anon_sym_STAR_EQ] = ACTIONS(359),
    [anon_sym_SLASH] = ACTIONS(361),
    [anon_sym_SLASH_EQ] = ACTIONS(359),
    [anon_sym_AMP_AMP] = ACTIONS(359),
    [anon_sym_AMP_EQ] = ACTIONS(359),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_PERCENT_EQ] = ACTIONS(359),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_CARET_EQ] = ACTIONS(359),
    [anon_sym_PLUS_EQ] = ACTIONS(359),
    [anon_sym_LT] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_LT_LT_EQ] = ACTIONS(359),
    [anon_sym_LT_EQ] = ACTIONS(359),
    [anon_sym_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(359),
    [anon_sym_GT] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(359),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_GT_GT_EQ] = ACTIONS(359),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_PIPE_EQ] = ACTIONS(359),
    [anon_sym_PIPE_PIPE] = ACTIONS(359),
    [anon_sym_QMARK] = ACTIONS(359),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(361),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(359),
    [anon_sym_as] = ACTIONS(361),
    [anon_sym_break] = ACTIONS(5170),
    [anon_sym_continue] = ACTIONS(5172),
    [anon_sym_default] = ACTIONS(5174),
    [anon_sym_for] = ACTIONS(5176),
    [anon_sym_if] = ACTIONS(5178),
    [anon_sym_loop] = ACTIONS(5180),
    [anon_sym_match] = ACTIONS(5182),
    [anon_sym_return] = ACTIONS(5184),
    [anon_sym_union] = ACTIONS(5174),
    [anon_sym_unsafe] = ACTIONS(5186),
    [anon_sym_while] = ACTIONS(5188),
    [anon_sym_move] = ACTIONS(5190),
    [sym_integer_literal] = ACTIONS(6290),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5192),
    [sym_char_literal] = ACTIONS(6290),
    [anon_sym_true] = ACTIONS(5194),
    [anon_sym_false] = ACTIONS(5194),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5196),
    [sym_self] = ACTIONS(5198),
    [sym_super] = ACTIONS(5200),
    [sym_crate] = ACTIONS(5200),
    [sym_metavariable] = ACTIONS(5202),
  },
  [2343] = {
    [sym_block] = STATE(2844),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [sym_line_comment] = ACTIONS(7),
  },
  [2344] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2846),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(2846),
    [sym_macro_invocation] = STATE(2846),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2846),
    [sym_unary_expression] = STATE(2846),
    [sym_try_expression] = STATE(2846),
    [sym_reference_expression] = STATE(2846),
    [sym_binary_expression] = STATE(2846),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2846),
    [sym_call_expression] = STATE(2846),
    [sym_array_expression] = STATE(2846),
    [sym_parenthesized_expression] = STATE(2846),
    [sym_tuple_expression] = STATE(2846),
    [sym_unit_expression] = STATE(2846),
    [sym_struct_expression] = STATE(2846),
    [sym_if_expression] = STATE(2846),
    [sym_if_let_expression] = STATE(2846),
    [sym_match_expression] = STATE(2846),
    [sym_while_expression] = STATE(2846),
    [sym_while_let_expression] = STATE(2846),
    [sym_loop_expression] = STATE(2846),
    [sym_for_expression] = STATE(2846),
    [sym_closure_expression] = STATE(2846),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2846),
    [sym_continue_expression] = STATE(2846),
    [sym_index_expression] = STATE(2846),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2846),
    [sym_block] = STATE(2846),
    [sym__literal] = STATE(2846),
    [sym_string_literal] = STATE(2846),
    [sym_boolean_literal] = STATE(2846),
    [sym_raw_string_literal] = ACTIONS(6292),
    [sym_float_literal] = ACTIONS(6292),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_let] = ACTIONS(6294),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(6292),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6292),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [2345] = {
    [sym_closure_parameters] = STATE(2847),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(33),
    [sym_line_comment] = ACTIONS(7),
  },
  [2346] = {
    [aux_sym_string_literal_repeat1] = STATE(2849),
    [sym_block_comment] = ACTIONS(7),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_RBRACK_PLUS_SLASH] = ACTIONS(6296),
    [anon_sym_DQUOTE] = ACTIONS(6298),
    [sym_escape_sequence] = ACTIONS(6296),
    [sym_line_comment] = ACTIONS(401),
  },
  [2347] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(403),
    [anon_sym_EQ_GT] = ACTIONS(403),
    [anon_sym_LBRACK] = ACTIONS(403),
    [anon_sym_PLUS] = ACTIONS(405),
    [anon_sym_STAR] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(405),
    [anon_sym_DASH] = ACTIONS(405),
    [anon_sym_DOT] = ACTIONS(405),
    [anon_sym_DASH_EQ] = ACTIONS(403),
    [anon_sym_BANG_EQ] = ACTIONS(403),
    [anon_sym_STAR_EQ] = ACTIONS(403),
    [anon_sym_SLASH] = ACTIONS(405),
    [anon_sym_SLASH_EQ] = ACTIONS(403),
    [anon_sym_AMP_AMP] = ACTIONS(403),
    [anon_sym_AMP_EQ] = ACTIONS(403),
    [anon_sym_PERCENT] = ACTIONS(405),
    [anon_sym_PERCENT_EQ] = ACTIONS(403),
    [anon_sym_CARET] = ACTIONS(405),
    [anon_sym_CARET_EQ] = ACTIONS(403),
    [anon_sym_PLUS_EQ] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(405),
    [anon_sym_LT_LT] = ACTIONS(405),
    [anon_sym_LT_LT_EQ] = ACTIONS(403),
    [anon_sym_LT_EQ] = ACTIONS(403),
    [anon_sym_EQ] = ACTIONS(405),
    [anon_sym_EQ_EQ] = ACTIONS(403),
    [anon_sym_GT] = ACTIONS(405),
    [anon_sym_GT_EQ] = ACTIONS(403),
    [anon_sym_GT_GT] = ACTIONS(405),
    [anon_sym_GT_GT_EQ] = ACTIONS(403),
    [anon_sym_PIPE] = ACTIONS(405),
    [anon_sym_PIPE_EQ] = ACTIONS(403),
    [anon_sym_PIPE_PIPE] = ACTIONS(403),
    [anon_sym_QMARK] = ACTIONS(403),
    [anon_sym_DOT_DOT] = ACTIONS(405),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(403),
    [anon_sym_as] = ACTIONS(403),
    [sym_line_comment] = ACTIONS(7),
  },
  [2348] = {
    [sym_field_initializer_list] = STATE(2853),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_LBRACE] = ACTIONS(6300),
    [anon_sym_EQ_GT] = ACTIONS(407),
    [anon_sym_LBRACK] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(411),
    [anon_sym_AMP] = ACTIONS(411),
    [anon_sym_DASH] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(411),
    [anon_sym_DASH_EQ] = ACTIONS(407),
    [anon_sym_COLON_COLON] = ACTIONS(6302),
    [anon_sym_BANG] = ACTIONS(6304),
    [anon_sym_BANG_EQ] = ACTIONS(407),
    [anon_sym_STAR_EQ] = ACTIONS(407),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_SLASH_EQ] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(407),
    [anon_sym_AMP_EQ] = ACTIONS(407),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_PERCENT_EQ] = ACTIONS(407),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_CARET_EQ] = ACTIONS(407),
    [anon_sym_PLUS_EQ] = ACTIONS(407),
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_LT_LT_EQ] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(407),
    [anon_sym_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(407),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_GT_EQ] = ACTIONS(407),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_EQ] = ACTIONS(407),
    [anon_sym_PIPE] = ACTIONS(411),
    [anon_sym_PIPE_EQ] = ACTIONS(407),
    [anon_sym_PIPE_PIPE] = ACTIONS(407),
    [anon_sym_QMARK] = ACTIONS(407),
    [anon_sym_DOT_DOT] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(407),
    [anon_sym_as] = ACTIONS(407),
    [sym_line_comment] = ACTIONS(7),
  },
  [2349] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_EQ_GT] = ACTIONS(407),
    [anon_sym_LBRACK] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(411),
    [anon_sym_AMP] = ACTIONS(411),
    [anon_sym_DASH] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(411),
    [anon_sym_DASH_EQ] = ACTIONS(407),
    [anon_sym_COLON_COLON] = ACTIONS(6306),
    [anon_sym_BANG_EQ] = ACTIONS(407),
    [anon_sym_STAR_EQ] = ACTIONS(407),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_SLASH_EQ] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(407),
    [anon_sym_AMP_EQ] = ACTIONS(407),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_PERCENT_EQ] = ACTIONS(407),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_CARET_EQ] = ACTIONS(407),
    [anon_sym_PLUS_EQ] = ACTIONS(407),
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_LT_LT_EQ] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(407),
    [anon_sym_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(407),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_GT_EQ] = ACTIONS(407),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_EQ] = ACTIONS(407),
    [anon_sym_PIPE] = ACTIONS(411),
    [anon_sym_PIPE_EQ] = ACTIONS(407),
    [anon_sym_PIPE_PIPE] = ACTIONS(407),
    [anon_sym_QMARK] = ACTIONS(407),
    [anon_sym_DOT_DOT] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(407),
    [anon_sym_as] = ACTIONS(407),
    [sym_line_comment] = ACTIONS(7),
  },
  [2350] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON_COLON] = ACTIONS(6306),
    [sym_line_comment] = ACTIONS(7),
  },
  [2351] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON_COLON] = ACTIONS(6308),
    [sym_line_comment] = ACTIONS(7),
  },
  [2352] = {
    [sym_field_initializer_list] = STATE(2857),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(6300),
    [anon_sym_COLON_COLON] = ACTIONS(6310),
    [sym_line_comment] = ACTIONS(7),
  },
  [2353] = {
    [sym_arguments] = STATE(2876),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6312),
    [anon_sym_EQ_GT] = ACTIONS(6314),
    [anon_sym_LBRACK] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6318),
    [anon_sym_STAR] = ACTIONS(6320),
    [anon_sym_AMP] = ACTIONS(6322),
    [anon_sym_DASH] = ACTIONS(6318),
    [anon_sym_DOT] = ACTIONS(6324),
    [anon_sym_DASH_EQ] = ACTIONS(6326),
    [anon_sym_BANG_EQ] = ACTIONS(6328),
    [anon_sym_STAR_EQ] = ACTIONS(6326),
    [anon_sym_SLASH] = ACTIONS(6320),
    [anon_sym_SLASH_EQ] = ACTIONS(6326),
    [anon_sym_AMP_AMP] = ACTIONS(6330),
    [anon_sym_AMP_EQ] = ACTIONS(6326),
    [anon_sym_PERCENT] = ACTIONS(6320),
    [anon_sym_PERCENT_EQ] = ACTIONS(6326),
    [anon_sym_CARET] = ACTIONS(6332),
    [anon_sym_CARET_EQ] = ACTIONS(6326),
    [anon_sym_PLUS_EQ] = ACTIONS(6326),
    [anon_sym_LT] = ACTIONS(6334),
    [anon_sym_LT_LT] = ACTIONS(6336),
    [anon_sym_LT_LT_EQ] = ACTIONS(6326),
    [anon_sym_LT_EQ] = ACTIONS(6328),
    [anon_sym_EQ] = ACTIONS(6338),
    [anon_sym_EQ_EQ] = ACTIONS(6328),
    [anon_sym_GT] = ACTIONS(6334),
    [anon_sym_GT_EQ] = ACTIONS(6328),
    [anon_sym_GT_GT] = ACTIONS(6336),
    [anon_sym_GT_GT_EQ] = ACTIONS(6326),
    [anon_sym_PIPE] = ACTIONS(6340),
    [anon_sym_PIPE_EQ] = ACTIONS(6326),
    [anon_sym_PIPE_PIPE] = ACTIONS(6342),
    [anon_sym_QMARK] = ACTIONS(6344),
    [anon_sym_DOT_DOT] = ACTIONS(6346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6348),
    [anon_sym_as] = ACTIONS(6350),
    [sym_line_comment] = ACTIONS(7),
  },
  [2354] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_EQ_GT] = ACTIONS(407),
    [anon_sym_LBRACK] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(411),
    [anon_sym_AMP] = ACTIONS(411),
    [anon_sym_DASH] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(411),
    [anon_sym_DASH_EQ] = ACTIONS(407),
    [anon_sym_COLON_COLON] = ACTIONS(6352),
    [anon_sym_BANG_EQ] = ACTIONS(407),
    [anon_sym_STAR_EQ] = ACTIONS(407),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_SLASH_EQ] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(407),
    [anon_sym_AMP_EQ] = ACTIONS(407),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_PERCENT_EQ] = ACTIONS(407),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_CARET_EQ] = ACTIONS(407),
    [anon_sym_PLUS_EQ] = ACTIONS(407),
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_LT_LT_EQ] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(407),
    [anon_sym_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(407),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_GT_EQ] = ACTIONS(407),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_EQ] = ACTIONS(407),
    [anon_sym_PIPE] = ACTIONS(411),
    [anon_sym_PIPE_EQ] = ACTIONS(407),
    [anon_sym_PIPE_PIPE] = ACTIONS(407),
    [anon_sym_QMARK] = ACTIONS(407),
    [anon_sym_DOT_DOT] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(407),
    [anon_sym_as] = ACTIONS(407),
    [sym_line_comment] = ACTIONS(7),
  },
  [2355] = {
    [sym_field_initializer_list] = STATE(2857),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(6300),
    [sym_line_comment] = ACTIONS(7),
  },
  [2356] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(499),
    [anon_sym_EQ_GT] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(501),
    [anon_sym_DASH_EQ] = ACTIONS(499),
    [anon_sym_BANG_EQ] = ACTIONS(499),
    [anon_sym_STAR_EQ] = ACTIONS(499),
    [anon_sym_SLASH] = ACTIONS(501),
    [anon_sym_SLASH_EQ] = ACTIONS(499),
    [anon_sym_AMP_AMP] = ACTIONS(499),
    [anon_sym_AMP_EQ] = ACTIONS(499),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_PERCENT_EQ] = ACTIONS(499),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_CARET_EQ] = ACTIONS(499),
    [anon_sym_PLUS_EQ] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(501),
    [anon_sym_LT_LT] = ACTIONS(501),
    [anon_sym_LT_LT_EQ] = ACTIONS(499),
    [anon_sym_LT_EQ] = ACTIONS(499),
    [anon_sym_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(499),
    [anon_sym_GT] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(499),
    [anon_sym_GT_GT] = ACTIONS(501),
    [anon_sym_GT_GT_EQ] = ACTIONS(499),
    [anon_sym_PIPE] = ACTIONS(501),
    [anon_sym_PIPE_EQ] = ACTIONS(499),
    [anon_sym_PIPE_PIPE] = ACTIONS(499),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_DOT_DOT] = ACTIONS(501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(499),
    [anon_sym_as] = ACTIONS(499),
    [sym_line_comment] = ACTIONS(7),
  },
  [2357] = {
    [sym_bracketed_type] = STATE(2351),
    [sym_generic_function] = STATE(2879),
    [sym_generic_type_with_turbofish] = STATE(2352),
    [sym__expression] = STATE(2879),
    [sym_macro_invocation] = STATE(2879),
    [sym_scoped_identifier] = STATE(2354),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2355),
    [sym_range_expression] = STATE(2879),
    [sym_unary_expression] = STATE(2879),
    [sym_try_expression] = STATE(2879),
    [sym_reference_expression] = STATE(2879),
    [sym_binary_expression] = STATE(2879),
    [sym_assignment_expression] = STATE(2356),
    [sym_compound_assignment_expr] = STATE(2356),
    [sym_type_cast_expression] = STATE(2356),
    [sym_return_expression] = STATE(2879),
    [sym_call_expression] = STATE(2879),
    [sym_array_expression] = STATE(2879),
    [sym_parenthesized_expression] = STATE(2879),
    [sym_tuple_expression] = STATE(2879),
    [sym_unit_expression] = STATE(2879),
    [sym_struct_expression] = STATE(2879),
    [sym_if_expression] = STATE(2879),
    [sym_if_let_expression] = STATE(2879),
    [sym_match_expression] = STATE(2879),
    [sym_while_expression] = STATE(2879),
    [sym_while_let_expression] = STATE(2879),
    [sym_loop_expression] = STATE(2879),
    [sym_for_expression] = STATE(2879),
    [sym_closure_expression] = STATE(2879),
    [sym_closure_parameters] = STATE(2357),
    [sym_loop_label] = STATE(2358),
    [sym_break_expression] = STATE(2879),
    [sym_continue_expression] = STATE(2879),
    [sym_index_expression] = STATE(2879),
    [sym_field_expression] = STATE(2359),
    [sym_unsafe_block] = STATE(2879),
    [sym_block] = STATE(2879),
    [sym__literal] = STATE(2879),
    [sym_string_literal] = STATE(2879),
    [sym_boolean_literal] = STATE(2879),
    [sym_raw_string_literal] = ACTIONS(6354),
    [sym_float_literal] = ACTIONS(6354),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5154),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_LBRACK] = ACTIONS(5158),
    [anon_sym_STAR] = ACTIONS(5160),
    [anon_sym_u8] = ACTIONS(5162),
    [anon_sym_i8] = ACTIONS(5162),
    [anon_sym_u16] = ACTIONS(5162),
    [anon_sym_i16] = ACTIONS(5162),
    [anon_sym_u32] = ACTIONS(5162),
    [anon_sym_i32] = ACTIONS(5162),
    [anon_sym_u64] = ACTIONS(5162),
    [anon_sym_i64] = ACTIONS(5162),
    [anon_sym_u128] = ACTIONS(5162),
    [anon_sym_i128] = ACTIONS(5162),
    [anon_sym_isize] = ACTIONS(5162),
    [anon_sym_usize] = ACTIONS(5162),
    [anon_sym_f32] = ACTIONS(5162),
    [anon_sym_f64] = ACTIONS(5162),
    [anon_sym_bool] = ACTIONS(5162),
    [anon_sym_str] = ACTIONS(5162),
    [anon_sym_char] = ACTIONS(5162),
    [anon_sym_AMP] = ACTIONS(5164),
    [anon_sym_DASH] = ACTIONS(6276),
    [anon_sym_DASH_GT] = ACTIONS(6356),
    [anon_sym_COLON_COLON] = ACTIONS(5166),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5168),
    [anon_sym_break] = ACTIONS(5170),
    [anon_sym_continue] = ACTIONS(5172),
    [anon_sym_default] = ACTIONS(5174),
    [anon_sym_for] = ACTIONS(5176),
    [anon_sym_if] = ACTIONS(5178),
    [anon_sym_loop] = ACTIONS(5180),
    [anon_sym_match] = ACTIONS(5182),
    [anon_sym_return] = ACTIONS(5184),
    [anon_sym_union] = ACTIONS(5174),
    [anon_sym_unsafe] = ACTIONS(5186),
    [anon_sym_while] = ACTIONS(5188),
    [anon_sym_move] = ACTIONS(5190),
    [sym_integer_literal] = ACTIONS(6354),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5192),
    [sym_char_literal] = ACTIONS(6354),
    [anon_sym_true] = ACTIONS(5194),
    [anon_sym_false] = ACTIONS(5194),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5196),
    [sym_self] = ACTIONS(5198),
    [sym_super] = ACTIONS(5200),
    [sym_crate] = ACTIONS(5200),
    [sym_metavariable] = ACTIONS(5202),
  },
  [2358] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(6358),
    [sym_line_comment] = ACTIONS(7),
  },
  [2359] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(407),
    [anon_sym_EQ_GT] = ACTIONS(407),
    [anon_sym_LBRACK] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(411),
    [anon_sym_AMP] = ACTIONS(411),
    [anon_sym_DASH] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(411),
    [anon_sym_DASH_EQ] = ACTIONS(407),
    [anon_sym_COLON_COLON] = ACTIONS(6360),
    [anon_sym_BANG_EQ] = ACTIONS(407),
    [anon_sym_STAR_EQ] = ACTIONS(407),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_SLASH_EQ] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(407),
    [anon_sym_AMP_EQ] = ACTIONS(407),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_PERCENT_EQ] = ACTIONS(407),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_CARET_EQ] = ACTIONS(407),
    [anon_sym_PLUS_EQ] = ACTIONS(407),
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_LT_LT_EQ] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(407),
    [anon_sym_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(407),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_GT_EQ] = ACTIONS(407),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_EQ] = ACTIONS(407),
    [anon_sym_PIPE] = ACTIONS(411),
    [anon_sym_PIPE_EQ] = ACTIONS(407),
    [anon_sym_PIPE_PIPE] = ACTIONS(407),
    [anon_sym_QMARK] = ACTIONS(407),
    [anon_sym_DOT_DOT] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(407),
    [anon_sym_as] = ACTIONS(407),
    [sym_line_comment] = ACTIONS(7),
  },
  [2360] = {
    [sym_bracketed_type] = STATE(2351),
    [sym_generic_function] = STATE(2882),
    [sym_generic_type_with_turbofish] = STATE(2352),
    [sym__expression] = STATE(2882),
    [sym_macro_invocation] = STATE(2882),
    [sym_scoped_identifier] = STATE(2354),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2355),
    [sym_range_expression] = STATE(2882),
    [sym_unary_expression] = STATE(2882),
    [sym_try_expression] = STATE(2882),
    [sym_reference_expression] = STATE(2882),
    [sym_binary_expression] = STATE(2882),
    [sym_assignment_expression] = STATE(2356),
    [sym_compound_assignment_expr] = STATE(2356),
    [sym_type_cast_expression] = STATE(2356),
    [sym_return_expression] = STATE(2882),
    [sym_call_expression] = STATE(2882),
    [sym_array_expression] = STATE(2882),
    [sym_parenthesized_expression] = STATE(2882),
    [sym_tuple_expression] = STATE(2882),
    [sym_unit_expression] = STATE(2882),
    [sym_struct_expression] = STATE(2882),
    [sym_if_expression] = STATE(2882),
    [sym_if_let_expression] = STATE(2882),
    [sym_match_expression] = STATE(2882),
    [sym_while_expression] = STATE(2882),
    [sym_while_let_expression] = STATE(2882),
    [sym_loop_expression] = STATE(2882),
    [sym_for_expression] = STATE(2882),
    [sym_closure_expression] = STATE(2882),
    [sym_closure_parameters] = STATE(2357),
    [sym_loop_label] = STATE(2358),
    [sym_break_expression] = STATE(2882),
    [sym_continue_expression] = STATE(2882),
    [sym_index_expression] = STATE(2882),
    [sym_field_expression] = STATE(2359),
    [sym_unsafe_block] = STATE(2882),
    [sym_block] = STATE(2882),
    [sym__literal] = STATE(2882),
    [sym_string_literal] = STATE(2882),
    [sym_boolean_literal] = STATE(2882),
    [sym_raw_string_literal] = ACTIONS(6362),
    [sym_float_literal] = ACTIONS(6362),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5154),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_LBRACK] = ACTIONS(5158),
    [anon_sym_STAR] = ACTIONS(5160),
    [anon_sym_u8] = ACTIONS(5162),
    [anon_sym_i8] = ACTIONS(5162),
    [anon_sym_u16] = ACTIONS(5162),
    [anon_sym_i16] = ACTIONS(5162),
    [anon_sym_u32] = ACTIONS(5162),
    [anon_sym_i32] = ACTIONS(5162),
    [anon_sym_u64] = ACTIONS(5162),
    [anon_sym_i64] = ACTIONS(5162),
    [anon_sym_u128] = ACTIONS(5162),
    [anon_sym_i128] = ACTIONS(5162),
    [anon_sym_isize] = ACTIONS(5162),
    [anon_sym_usize] = ACTIONS(5162),
    [anon_sym_f32] = ACTIONS(5162),
    [anon_sym_f64] = ACTIONS(5162),
    [anon_sym_bool] = ACTIONS(5162),
    [anon_sym_str] = ACTIONS(5162),
    [anon_sym_char] = ACTIONS(5162),
    [anon_sym_AMP] = ACTIONS(5164),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_COLON_COLON] = ACTIONS(5166),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5168),
    [anon_sym_break] = ACTIONS(5170),
    [anon_sym_continue] = ACTIONS(5172),
    [anon_sym_default] = ACTIONS(5174),
    [anon_sym_for] = ACTIONS(5176),
    [anon_sym_if] = ACTIONS(5178),
    [anon_sym_loop] = ACTIONS(5180),
    [anon_sym_match] = ACTIONS(5182),
    [anon_sym_return] = ACTIONS(5184),
    [anon_sym_union] = ACTIONS(5174),
    [anon_sym_unsafe] = ACTIONS(5186),
    [anon_sym_while] = ACTIONS(5188),
    [anon_sym_move] = ACTIONS(5190),
    [sym_integer_literal] = ACTIONS(6362),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5192),
    [sym_char_literal] = ACTIONS(6362),
    [anon_sym_true] = ACTIONS(5194),
    [anon_sym_false] = ACTIONS(5194),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5196),
    [sym_self] = ACTIONS(5198),
    [sym_super] = ACTIONS(5200),
    [sym_crate] = ACTIONS(5200),
    [sym_metavariable] = ACTIONS(5202),
  },
  [2361] = {
    [aux_sym_match_pattern_repeat1] = STATE(2361),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(6248),
    [anon_sym_PIPE] = ACTIONS(6364),
    [anon_sym_if] = ACTIONS(6248),
    [sym_line_comment] = ACTIONS(7),
  },
  [2362] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(6367),
    [anon_sym_PIPE] = ACTIONS(6367),
    [anon_sym_if] = ACTIONS(6367),
    [sym_line_comment] = ACTIONS(7),
  },
  [2363] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2883),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2883),
    [sym_macro_invocation] = STATE(2883),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2883),
    [sym_unary_expression] = STATE(2883),
    [sym_try_expression] = STATE(2883),
    [sym_reference_expression] = STATE(2883),
    [sym_binary_expression] = STATE(2883),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2883),
    [sym_call_expression] = STATE(2883),
    [sym_array_expression] = STATE(2883),
    [sym_parenthesized_expression] = STATE(2883),
    [sym_tuple_expression] = STATE(2883),
    [sym_unit_expression] = STATE(2883),
    [sym_struct_expression] = STATE(2883),
    [sym_if_expression] = STATE(2884),
    [sym_if_let_expression] = STATE(2884),
    [sym_match_expression] = STATE(2884),
    [sym_while_expression] = STATE(2884),
    [sym_while_let_expression] = STATE(2884),
    [sym_loop_expression] = STATE(2884),
    [sym_for_expression] = STATE(2884),
    [sym_closure_expression] = STATE(2883),
    [sym_closure_parameters] = STATE(1138),
    [sym_loop_label] = STATE(2325),
    [sym_break_expression] = STATE(2883),
    [sym_continue_expression] = STATE(2883),
    [sym_index_expression] = STATE(2883),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2884),
    [sym_block] = STATE(2884),
    [sym__literal] = STATE(2883),
    [sym_string_literal] = STATE(2883),
    [sym_boolean_literal] = STATE(2883),
    [sym_raw_string_literal] = ACTIONS(6369),
    [sym_float_literal] = ACTIONS(6369),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(5136),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(2245),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(5138),
    [anon_sym_if] = ACTIONS(5140),
    [anon_sym_loop] = ACTIONS(5142),
    [anon_sym_match] = ACTIONS(5144),
    [anon_sym_return] = ACTIONS(2249),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(5146),
    [anon_sym_while] = ACTIONS(5148),
    [anon_sym_move] = ACTIONS(2251),
    [sym_integer_literal] = ACTIONS(6369),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6369),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2364] = {
    [sym_raw_string_literal] = ACTIONS(6371),
    [sym_float_literal] = ACTIONS(6371),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(6371),
    [anon_sym_SEMI] = ACTIONS(6371),
    [anon_sym_macro_rules_BANG] = ACTIONS(6371),
    [anon_sym_LPAREN] = ACTIONS(6371),
    [anon_sym_LBRACE] = ACTIONS(6371),
    [anon_sym_RBRACE] = ACTIONS(6371),
    [anon_sym_LBRACK] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(6373),
    [anon_sym_STAR] = ACTIONS(6373),
    [anon_sym_u8] = ACTIONS(6373),
    [anon_sym_i8] = ACTIONS(6373),
    [anon_sym_u16] = ACTIONS(6373),
    [anon_sym_i16] = ACTIONS(6373),
    [anon_sym_u32] = ACTIONS(6373),
    [anon_sym_i32] = ACTIONS(6373),
    [anon_sym_u64] = ACTIONS(6373),
    [anon_sym_i64] = ACTIONS(6373),
    [anon_sym_u128] = ACTIONS(6373),
    [anon_sym_i128] = ACTIONS(6373),
    [anon_sym_isize] = ACTIONS(6373),
    [anon_sym_usize] = ACTIONS(6373),
    [anon_sym_f32] = ACTIONS(6373),
    [anon_sym_f64] = ACTIONS(6373),
    [anon_sym_bool] = ACTIONS(6373),
    [anon_sym_str] = ACTIONS(6373),
    [anon_sym_char] = ACTIONS(6373),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_DASH] = ACTIONS(6373),
    [anon_sym_DOT] = ACTIONS(6373),
    [anon_sym_DASH_EQ] = ACTIONS(6371),
    [anon_sym_COLON_COLON] = ACTIONS(6371),
    [anon_sym_BANG] = ACTIONS(6373),
    [anon_sym_BANG_EQ] = ACTIONS(6371),
    [anon_sym_STAR_EQ] = ACTIONS(6371),
    [anon_sym_SLASH] = ACTIONS(6373),
    [anon_sym_SLASH_EQ] = ACTIONS(6371),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_AMP_EQ] = ACTIONS(6371),
    [anon_sym_POUND] = ACTIONS(6371),
    [anon_sym_PERCENT] = ACTIONS(6373),
    [anon_sym_PERCENT_EQ] = ACTIONS(6371),
    [anon_sym_CARET] = ACTIONS(6373),
    [anon_sym_CARET_EQ] = ACTIONS(6371),
    [anon_sym_PLUS_EQ] = ACTIONS(6371),
    [anon_sym_LT] = ACTIONS(6373),
    [anon_sym_LT_LT] = ACTIONS(6373),
    [anon_sym_LT_LT_EQ] = ACTIONS(6371),
    [anon_sym_LT_EQ] = ACTIONS(6371),
    [anon_sym_EQ] = ACTIONS(6373),
    [anon_sym_EQ_EQ] = ACTIONS(6371),
    [anon_sym_GT] = ACTIONS(6373),
    [anon_sym_GT_EQ] = ACTIONS(6371),
    [anon_sym_GT_GT] = ACTIONS(6373),
    [anon_sym_GT_GT_EQ] = ACTIONS(6371),
    [anon_sym_PIPE] = ACTIONS(6373),
    [anon_sym_PIPE_EQ] = ACTIONS(6371),
    [anon_sym_PIPE_PIPE] = ACTIONS(6371),
    [anon_sym_QMARK] = ACTIONS(6371),
    [anon_sym_SQUOTE] = ACTIONS(6373),
    [anon_sym_DOT_DOT] = ACTIONS(6373),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6371),
    [anon_sym_as] = ACTIONS(6373),
    [anon_sym_break] = ACTIONS(6373),
    [anon_sym_const] = ACTIONS(6373),
    [anon_sym_continue] = ACTIONS(6373),
    [anon_sym_default] = ACTIONS(6373),
    [anon_sym_enum] = ACTIONS(6373),
    [anon_sym_fn] = ACTIONS(6373),
    [anon_sym_for] = ACTIONS(6373),
    [anon_sym_if] = ACTIONS(6373),
    [anon_sym_impl] = ACTIONS(6373),
    [anon_sym_let] = ACTIONS(6373),
    [anon_sym_loop] = ACTIONS(6373),
    [anon_sym_match] = ACTIONS(6373),
    [anon_sym_mod] = ACTIONS(6373),
    [anon_sym_pub] = ACTIONS(6373),
    [anon_sym_return] = ACTIONS(6373),
    [anon_sym_static] = ACTIONS(6373),
    [anon_sym_struct] = ACTIONS(6373),
    [anon_sym_trait] = ACTIONS(6373),
    [anon_sym_type] = ACTIONS(6373),
    [anon_sym_union] = ACTIONS(6373),
    [anon_sym_unsafe] = ACTIONS(6373),
    [anon_sym_use] = ACTIONS(6373),
    [anon_sym_while] = ACTIONS(6373),
    [anon_sym_extern] = ACTIONS(6373),
    [anon_sym_move] = ACTIONS(6373),
    [sym_integer_literal] = ACTIONS(6371),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6371),
    [sym_char_literal] = ACTIONS(6371),
    [anon_sym_true] = ACTIONS(6373),
    [anon_sym_false] = ACTIONS(6373),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6373),
    [sym_self] = ACTIONS(6373),
    [sym_super] = ACTIONS(6373),
    [sym_crate] = ACTIONS(6373),
    [sym_metavariable] = ACTIONS(6371),
  },
  [2365] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(6375),
    [sym_line_comment] = ACTIONS(7),
  },
  [2366] = {
    [sym_attribute_item] = STATE(1726),
    [sym_bracketed_type] = STATE(1041),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(1042),
    [sym_scoped_identifier] = STATE(1043),
    [sym_scoped_type_identifier] = STATE(1044),
    [sym_match_pattern] = STATE(2886),
    [sym__pattern] = STATE(1047),
    [sym_tuple_pattern] = STATE(1047),
    [sym_tuple_struct_pattern] = STATE(1047),
    [sym_struct_pattern] = STATE(1047),
    [sym_remaining_field_pattern] = STATE(1047),
    [sym_mut_pattern] = STATE(1047),
    [sym_range_pattern] = STATE(1047),
    [sym_ref_pattern] = STATE(1047),
    [sym_captured_pattern] = STATE(1047),
    [sym_reference_pattern] = STATE(1047),
    [sym__literal] = STATE(1048),
    [sym_string_literal] = STATE(1048),
    [sym_boolean_literal] = STATE(1048),
    [aux_sym_enum_variant_list_repeat1] = STATE(1726),
    [sym_raw_string_literal] = ACTIONS(2070),
    [sym_float_literal] = ACTIONS(2070),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2072),
    [anon_sym_u8] = ACTIONS(2076),
    [anon_sym_i8] = ACTIONS(2076),
    [anon_sym_u16] = ACTIONS(2076),
    [anon_sym_i16] = ACTIONS(2076),
    [anon_sym_u32] = ACTIONS(2076),
    [anon_sym_i32] = ACTIONS(2076),
    [anon_sym_u64] = ACTIONS(2076),
    [anon_sym_i64] = ACTIONS(2076),
    [anon_sym_u128] = ACTIONS(2076),
    [anon_sym_i128] = ACTIONS(2076),
    [anon_sym_isize] = ACTIONS(2076),
    [anon_sym_usize] = ACTIONS(2076),
    [anon_sym_f32] = ACTIONS(2076),
    [anon_sym_f64] = ACTIONS(2076),
    [anon_sym_bool] = ACTIONS(2076),
    [anon_sym_str] = ACTIONS(2076),
    [anon_sym_char] = ACTIONS(2076),
    [anon_sym__] = ACTIONS(2078),
    [anon_sym_AMP] = ACTIONS(2080),
    [anon_sym_COLON_COLON] = ACTIONS(2082),
    [anon_sym_POUND] = ACTIONS(2084),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(2086),
    [sym_mutable_specifier] = ACTIONS(2088),
    [anon_sym_ref] = ACTIONS(2090),
    [sym_integer_literal] = ACTIONS(2070),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(769),
    [sym_char_literal] = ACTIONS(2070),
    [anon_sym_true] = ACTIONS(2092),
    [anon_sym_false] = ACTIONS(2092),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2094),
    [sym_self] = ACTIONS(2096),
    [sym_super] = ACTIONS(2096),
    [sym_crate] = ACTIONS(2096),
    [sym_metavariable] = ACTIONS(2098),
  },
  [2367] = {
    [sym_raw_string_literal] = ACTIONS(6377),
    [sym_float_literal] = ACTIONS(6377),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(6377),
    [anon_sym_SEMI] = ACTIONS(6377),
    [anon_sym_macro_rules_BANG] = ACTIONS(6377),
    [anon_sym_LPAREN] = ACTIONS(6377),
    [anon_sym_LBRACE] = ACTIONS(6377),
    [anon_sym_RBRACE] = ACTIONS(6377),
    [anon_sym_LBRACK] = ACTIONS(6377),
    [anon_sym_STAR] = ACTIONS(6377),
    [anon_sym_u8] = ACTIONS(6379),
    [anon_sym_i8] = ACTIONS(6379),
    [anon_sym_u16] = ACTIONS(6379),
    [anon_sym_i16] = ACTIONS(6379),
    [anon_sym_u32] = ACTIONS(6379),
    [anon_sym_i32] = ACTIONS(6379),
    [anon_sym_u64] = ACTIONS(6379),
    [anon_sym_i64] = ACTIONS(6379),
    [anon_sym_u128] = ACTIONS(6379),
    [anon_sym_i128] = ACTIONS(6379),
    [anon_sym_isize] = ACTIONS(6379),
    [anon_sym_usize] = ACTIONS(6379),
    [anon_sym_f32] = ACTIONS(6379),
    [anon_sym_f64] = ACTIONS(6379),
    [anon_sym_bool] = ACTIONS(6379),
    [anon_sym_str] = ACTIONS(6379),
    [anon_sym_char] = ACTIONS(6379),
    [anon_sym_AMP] = ACTIONS(6377),
    [anon_sym_DASH] = ACTIONS(6377),
    [anon_sym_COLON_COLON] = ACTIONS(6377),
    [anon_sym_BANG] = ACTIONS(6377),
    [anon_sym_POUND] = ACTIONS(6377),
    [anon_sym_LT] = ACTIONS(6377),
    [anon_sym_PIPE] = ACTIONS(6377),
    [anon_sym_SQUOTE] = ACTIONS(6379),
    [anon_sym_DOT_DOT] = ACTIONS(6377),
    [anon_sym_break] = ACTIONS(6379),
    [anon_sym_const] = ACTIONS(6379),
    [anon_sym_continue] = ACTIONS(6379),
    [anon_sym_default] = ACTIONS(6379),
    [anon_sym_enum] = ACTIONS(6379),
    [anon_sym_fn] = ACTIONS(6379),
    [anon_sym_for] = ACTIONS(6379),
    [anon_sym_if] = ACTIONS(6379),
    [anon_sym_impl] = ACTIONS(6379),
    [anon_sym_let] = ACTIONS(6379),
    [anon_sym_loop] = ACTIONS(6379),
    [anon_sym_match] = ACTIONS(6379),
    [anon_sym_mod] = ACTIONS(6379),
    [anon_sym_pub] = ACTIONS(6379),
    [anon_sym_return] = ACTIONS(6379),
    [anon_sym_static] = ACTIONS(6379),
    [anon_sym_struct] = ACTIONS(6379),
    [anon_sym_trait] = ACTIONS(6379),
    [anon_sym_type] = ACTIONS(6379),
    [anon_sym_union] = ACTIONS(6379),
    [anon_sym_unsafe] = ACTIONS(6379),
    [anon_sym_use] = ACTIONS(6379),
    [anon_sym_while] = ACTIONS(6379),
    [anon_sym_extern] = ACTIONS(6379),
    [anon_sym_move] = ACTIONS(6379),
    [sym_integer_literal] = ACTIONS(6377),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6377),
    [sym_char_literal] = ACTIONS(6377),
    [anon_sym_true] = ACTIONS(6379),
    [anon_sym_false] = ACTIONS(6379),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6379),
    [sym_self] = ACTIONS(6379),
    [sym_super] = ACTIONS(6379),
    [sym_crate] = ACTIONS(6379),
    [sym_metavariable] = ACTIONS(6377),
  },
  [2368] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2887),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2887),
    [sym_macro_invocation] = STATE(2887),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2887),
    [sym_unary_expression] = STATE(2887),
    [sym_try_expression] = STATE(2887),
    [sym_reference_expression] = STATE(2887),
    [sym_binary_expression] = STATE(2887),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2887),
    [sym_call_expression] = STATE(2887),
    [sym_array_expression] = STATE(2887),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_tuple_expression] = STATE(2887),
    [sym_unit_expression] = STATE(2887),
    [sym_struct_expression] = STATE(2887),
    [sym_if_expression] = STATE(2887),
    [sym_if_let_expression] = STATE(2887),
    [sym_match_expression] = STATE(2887),
    [sym_while_expression] = STATE(2887),
    [sym_while_let_expression] = STATE(2887),
    [sym_loop_expression] = STATE(2887),
    [sym_for_expression] = STATE(2887),
    [sym_closure_expression] = STATE(2887),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2887),
    [sym_continue_expression] = STATE(2887),
    [sym_index_expression] = STATE(2887),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2887),
    [sym_block] = STATE(2887),
    [sym__literal] = STATE(2887),
    [sym_string_literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2887),
    [sym_raw_string_literal] = ACTIONS(6381),
    [sym_float_literal] = ACTIONS(6381),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(6381),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6381),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2369] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6383),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(467),
    [anon_sym_BANG_EQ] = ACTIONS(469),
    [anon_sym_STAR_EQ] = ACTIONS(467),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(467),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_AMP_EQ] = ACTIONS(467),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(467),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_CARET_EQ] = ACTIONS(467),
    [anon_sym_PLUS_EQ] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT_LT_EQ] = ACTIONS(467),
    [anon_sym_LT_EQ] = ACTIONS(469),
    [anon_sym_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_EQ] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_PIPE_EQ] = ACTIONS(467),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(489),
    [anon_sym_as] = ACTIONS(491),
    [sym_line_comment] = ACTIONS(7),
  },
  [2370] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACK] = ACTIONS(6385),
    [sym_line_comment] = ACTIONS(7),
  },
  [2371] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_type_with_turbofish] = STATE(212),
    [sym_scoped_identifier] = STATE(2893),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(6387),
    [anon_sym_i8] = ACTIONS(6387),
    [anon_sym_u16] = ACTIONS(6387),
    [anon_sym_i16] = ACTIONS(6387),
    [anon_sym_u32] = ACTIONS(6387),
    [anon_sym_i32] = ACTIONS(6387),
    [anon_sym_u64] = ACTIONS(6387),
    [anon_sym_i64] = ACTIONS(6387),
    [anon_sym_u128] = ACTIONS(6387),
    [anon_sym_i128] = ACTIONS(6387),
    [anon_sym_isize] = ACTIONS(6387),
    [anon_sym_usize] = ACTIONS(6387),
    [anon_sym_f32] = ACTIONS(6387),
    [anon_sym_f64] = ACTIONS(6387),
    [anon_sym_bool] = ACTIONS(6387),
    [anon_sym_str] = ACTIONS(6387),
    [anon_sym_char] = ACTIONS(6387),
    [anon_sym_COLON_COLON] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(31),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6389),
    [sym_self] = ACTIONS(6391),
    [sym_super] = ACTIONS(6391),
    [sym_crate] = ACTIONS(6391),
    [sym_metavariable] = ACTIONS(6393),
  },
  [2372] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(6395),
    [sym_line_comment] = ACTIONS(7),
  },
  [2373] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6397),
    [anon_sym_RBRACE] = ACTIONS(6397),
    [anon_sym_COMMA] = ACTIONS(6397),
    [anon_sym_EQ] = ACTIONS(6397),
    [anon_sym_where] = ACTIONS(6397),
    [sym_line_comment] = ACTIONS(7),
  },
  [2374] = {
    [sym_attribute_item] = STATE(2378),
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym_visibility_modifier] = STATE(2376),
    [sym__type] = STATE(2377),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(2377),
    [sym_function_type] = STATE(2377),
    [sym_tuple_type] = STATE(2377),
    [sym_unit_type] = STATE(2377),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2377),
    [sym_reference_type] = STATE(2377),
    [sym_pointer_type] = STATE(2377),
    [sym_empty_type] = STATE(2377),
    [sym_dynamic_type] = STATE(2377),
    [sym_macro_invocation] = STATE(2377),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_enum_variant_list_repeat1] = STATE(2378),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_RPAREN] = ACTIONS(6399),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_POUND] = ACTIONS(2124),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_pub] = ACTIONS(2126),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2375] = {
    [aux_sym_ordered_field_declaration_list_repeat1] = STATE(2379),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(6399),
    [anon_sym_COMMA] = ACTIONS(6401),
    [sym_line_comment] = ACTIONS(7),
  },
  [2376] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2897),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(2897),
    [sym_function_type] = STATE(2897),
    [sym_tuple_type] = STATE(2897),
    [sym_unit_type] = STATE(2897),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2897),
    [sym_reference_type] = STATE(2897),
    [sym_pointer_type] = STATE(2897),
    [sym_empty_type] = STATE(2897),
    [sym_dynamic_type] = STATE(2897),
    [sym_macro_invocation] = STATE(2897),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2377] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(6403),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_COMMA] = ACTIONS(6403),
    [sym_line_comment] = ACTIONS(7),
  },
  [2378] = {
    [sym_attribute_item] = STATE(1741),
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym_visibility_modifier] = STATE(2898),
    [sym__type] = STATE(2897),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(2897),
    [sym_function_type] = STATE(2897),
    [sym_tuple_type] = STATE(2897),
    [sym_unit_type] = STATE(2897),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2897),
    [sym_reference_type] = STATE(2897),
    [sym_pointer_type] = STATE(2897),
    [sym_empty_type] = STATE(2897),
    [sym_dynamic_type] = STATE(2897),
    [sym_macro_invocation] = STATE(2897),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_enum_variant_list_repeat1] = STATE(1741),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_POUND] = ACTIONS(2124),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_pub] = ACTIONS(2126),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2379] = {
    [aux_sym_ordered_field_declaration_list_repeat1] = STATE(2379),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(6403),
    [anon_sym_COMMA] = ACTIONS(6405),
    [sym_line_comment] = ACTIONS(7),
  },
  [2380] = {
    [aux_sym_ordered_field_declaration_list_repeat1] = STATE(2900),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(6399),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_COMMA] = ACTIONS(6401),
    [sym_line_comment] = ACTIONS(7),
  },
  [2381] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(6408),
    [sym_mutable_specifier] = ACTIONS(6408),
    [sym_line_comment] = ACTIONS(7),
  },
  [2382] = {
    [sym_function_modifiers] = STATE(2385),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(385),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2903),
    [sym_array_type] = STATE(385),
    [sym_function_type] = STATE(385),
    [sym_tuple_type] = STATE(385),
    [sym_unit_type] = STATE(385),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(385),
    [sym_reference_type] = STATE(385),
    [sym_pointer_type] = STATE(385),
    [sym_empty_type] = STATE(385),
    [sym_dynamic_type] = STATE(385),
    [sym_macro_invocation] = STATE(385),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2388),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(5298),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(5300),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5302),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(6410),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5304),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2383] = {
    [sym_parameters] = STATE(2904),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [2384] = {
    [sym_parameters] = STATE(2905),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_RBRACE] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_BANG] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [2385] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2908),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_fn] = ACTIONS(6412),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6414),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [2386] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6416),
    [anon_sym_PLUS] = ACTIONS(6418),
    [anon_sym_COMMA] = ACTIONS(6416),
    [sym_line_comment] = ACTIONS(7),
  },
  [2387] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(6420),
    [sym_line_comment] = ACTIONS(7),
  },
  [2388] = {
    [sym_parameters] = STATE(2904),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_RBRACE] = ACTIONS(783),
    [anon_sym_PLUS] = ACTIONS(783),
    [anon_sym_COMMA] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [2389] = {
    [sym_raw_string_literal] = ACTIONS(6422),
    [sym_float_literal] = ACTIONS(6422),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(6422),
    [anon_sym_SEMI] = ACTIONS(6422),
    [anon_sym_macro_rules_BANG] = ACTIONS(6422),
    [anon_sym_LPAREN] = ACTIONS(6422),
    [anon_sym_LBRACE] = ACTIONS(6422),
    [anon_sym_RBRACE] = ACTIONS(6422),
    [anon_sym_LBRACK] = ACTIONS(6422),
    [anon_sym_STAR] = ACTIONS(6422),
    [anon_sym_u8] = ACTIONS(6424),
    [anon_sym_i8] = ACTIONS(6424),
    [anon_sym_u16] = ACTIONS(6424),
    [anon_sym_i16] = ACTIONS(6424),
    [anon_sym_u32] = ACTIONS(6424),
    [anon_sym_i32] = ACTIONS(6424),
    [anon_sym_u64] = ACTIONS(6424),
    [anon_sym_i64] = ACTIONS(6424),
    [anon_sym_u128] = ACTIONS(6424),
    [anon_sym_i128] = ACTIONS(6424),
    [anon_sym_isize] = ACTIONS(6424),
    [anon_sym_usize] = ACTIONS(6424),
    [anon_sym_f32] = ACTIONS(6424),
    [anon_sym_f64] = ACTIONS(6424),
    [anon_sym_bool] = ACTIONS(6424),
    [anon_sym_str] = ACTIONS(6424),
    [anon_sym_char] = ACTIONS(6424),
    [anon_sym_AMP] = ACTIONS(6422),
    [anon_sym_DASH] = ACTIONS(6422),
    [anon_sym_COLON_COLON] = ACTIONS(6422),
    [anon_sym_BANG] = ACTIONS(6422),
    [anon_sym_POUND] = ACTIONS(6422),
    [anon_sym_LT] = ACTIONS(6422),
    [anon_sym_PIPE] = ACTIONS(6422),
    [anon_sym_SQUOTE] = ACTIONS(6424),
    [anon_sym_DOT_DOT] = ACTIONS(6422),
    [anon_sym_break] = ACTIONS(6424),
    [anon_sym_const] = ACTIONS(6424),
    [anon_sym_continue] = ACTIONS(6424),
    [anon_sym_default] = ACTIONS(6424),
    [anon_sym_enum] = ACTIONS(6424),
    [anon_sym_fn] = ACTIONS(6424),
    [anon_sym_for] = ACTIONS(6424),
    [anon_sym_if] = ACTIONS(6424),
    [anon_sym_impl] = ACTIONS(6424),
    [anon_sym_let] = ACTIONS(6424),
    [anon_sym_loop] = ACTIONS(6424),
    [anon_sym_match] = ACTIONS(6424),
    [anon_sym_mod] = ACTIONS(6424),
    [anon_sym_pub] = ACTIONS(6424),
    [anon_sym_return] = ACTIONS(6424),
    [anon_sym_static] = ACTIONS(6424),
    [anon_sym_struct] = ACTIONS(6424),
    [anon_sym_trait] = ACTIONS(6424),
    [anon_sym_type] = ACTIONS(6424),
    [anon_sym_union] = ACTIONS(6424),
    [anon_sym_unsafe] = ACTIONS(6424),
    [anon_sym_use] = ACTIONS(6424),
    [anon_sym_while] = ACTIONS(6424),
    [anon_sym_extern] = ACTIONS(6424),
    [anon_sym_move] = ACTIONS(6424),
    [sym_integer_literal] = ACTIONS(6422),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6422),
    [sym_char_literal] = ACTIONS(6422),
    [anon_sym_true] = ACTIONS(6424),
    [anon_sym_false] = ACTIONS(6424),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6424),
    [sym_self] = ACTIONS(6424),
    [sym_super] = ACTIONS(6424),
    [sym_crate] = ACTIONS(6424),
    [sym_metavariable] = ACTIONS(6422),
  },
  [2390] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6426),
    [anon_sym_COMMA] = ACTIONS(6426),
    [sym_line_comment] = ACTIONS(7),
  },
  [2391] = {
    [sym_attribute_item] = STATE(1597),
    [sym_field_declaration] = STATE(2911),
    [sym_visibility_modifier] = STATE(1069),
    [aux_sym_enum_variant_list_repeat1] = STATE(1597),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_pub] = ACTIONS(1940),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2132),
  },
  [2392] = {
    [sym_attribute_item] = STATE(2391),
    [sym_field_declaration] = STATE(2390),
    [sym_visibility_modifier] = STATE(1069),
    [aux_sym_enum_variant_list_repeat1] = STATE(2391),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6428),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_pub] = ACTIONS(1940),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2132),
  },
  [2393] = {
    [aux_sym_field_declaration_list_repeat1] = STATE(2393),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6426),
    [anon_sym_COMMA] = ACTIONS(6430),
    [sym_line_comment] = ACTIONS(7),
  },
  [2394] = {
    [sym_function_modifiers] = STATE(2385),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2914),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2387),
    [sym_array_type] = STATE(2914),
    [sym_function_type] = STATE(2914),
    [sym_tuple_type] = STATE(2914),
    [sym_unit_type] = STATE(2914),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2914),
    [sym_reference_type] = STATE(2914),
    [sym_pointer_type] = STATE(2914),
    [sym_empty_type] = STATE(2914),
    [sym_dynamic_type] = STATE(2914),
    [sym_macro_invocation] = STATE(2914),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2388),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(5298),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(5300),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5302),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5304),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2395] = {
    [aux_sym_field_declaration_list_repeat1] = STATE(2393),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6428),
    [anon_sym_COMMA] = ACTIONS(6433),
    [sym_line_comment] = ACTIONS(7),
  },
  [2396] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(6435),
    [sym_mutable_specifier] = ACTIONS(6435),
    [sym_line_comment] = ACTIONS(7),
  },
  [2397] = {
    [sym_function_modifiers] = STATE(2402),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(385),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2918),
    [sym_array_type] = STATE(385),
    [sym_function_type] = STATE(385),
    [sym_tuple_type] = STATE(385),
    [sym_unit_type] = STATE(385),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(385),
    [sym_reference_type] = STATE(385),
    [sym_pointer_type] = STATE(385),
    [sym_empty_type] = STATE(385),
    [sym_dynamic_type] = STATE(385),
    [sym_macro_invocation] = STATE(385),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2405),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(5312),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(5314),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5318),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(6437),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5322),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2398] = {
    [sym_function_modifiers] = STATE(2402),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1759),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2919),
    [sym_array_type] = STATE(1759),
    [sym_function_type] = STATE(1759),
    [sym_tuple_type] = STATE(1759),
    [sym_unit_type] = STATE(1759),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1759),
    [sym_reference_type] = STATE(1759),
    [sym_pointer_type] = STATE(1759),
    [sym_empty_type] = STATE(1759),
    [sym_dynamic_type] = STATE(1759),
    [sym_macro_invocation] = STATE(1759),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2405),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(5312),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(5314),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5318),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5322),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2399] = {
    [sym_parameters] = STATE(2920),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [2400] = {
    [sym_type_parameters] = STATE(2921),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(3393),
    [sym_line_comment] = ACTIONS(7),
  },
  [2401] = {
    [sym_parameters] = STATE(2922),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_BANG] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [2402] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2925),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_fn] = ACTIONS(6439),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6441),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [2403] = {
    [aux_sym_trait_bounds_repeat1] = STATE(2927),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3395),
    [anon_sym_LPAREN] = ACTIONS(3395),
    [anon_sym_LBRACE] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(6443),
    [anon_sym_COMMA] = ACTIONS(3395),
    [sym_line_comment] = ACTIONS(7),
  },
  [2404] = {
    [aux_sym_trait_bounds_repeat1] = STATE(2927),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3395),
    [anon_sym_LPAREN] = ACTIONS(3395),
    [anon_sym_LBRACE] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(6445),
    [anon_sym_COMMA] = ACTIONS(3395),
    [sym_line_comment] = ACTIONS(7),
  },
  [2405] = {
    [sym_parameters] = STATE(2920),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(783),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(783),
    [anon_sym_PLUS] = ACTIONS(783),
    [anon_sym_COMMA] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [2406] = {
    [sym_where_predicate] = STATE(2237),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1073),
    [sym_generic_type] = STATE(1074),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_reference_type] = STATE(1073),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1075),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6121),
    [anon_sym_LPAREN] = ACTIONS(6121),
    [anon_sym_LBRACE] = ACTIONS(6121),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(1948),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2134),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [2407] = {
    [aux_sym_where_clause_repeat1] = STATE(2407),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6119),
    [anon_sym_LPAREN] = ACTIONS(6119),
    [anon_sym_LBRACE] = ACTIONS(6119),
    [anon_sym_COMMA] = ACTIONS(6447),
    [sym_line_comment] = ACTIONS(7),
  },
  [2408] = {
    [sym_function_modifiers] = STATE(2936),
    [sym_higher_ranked_trait_bound] = STATE(2937),
    [sym_removed_trait_bound] = STATE(2937),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2938),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2938),
    [sym_array_type] = STATE(2938),
    [sym_function_type] = STATE(2938),
    [sym_tuple_type] = STATE(2938),
    [sym_unit_type] = STATE(2938),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2938),
    [sym_reference_type] = STATE(2938),
    [sym_pointer_type] = STATE(2938),
    [sym_empty_type] = STATE(2938),
    [sym_dynamic_type] = STATE(2938),
    [sym_macro_invocation] = STATE(2938),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2939),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(6450),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(6452),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_QMARK] = ACTIONS(6454),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6456),
    [anon_sym_for] = ACTIONS(6458),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6460),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2409] = {
    [sym_where_predicate] = STATE(2237),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1753),
    [sym_generic_type] = STATE(1754),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_reference_type] = STATE(1753),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1755),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4971),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(1948),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3389),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [2410] = {
    [aux_sym_where_clause_repeat1] = STATE(2941),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4971),
    [anon_sym_COMMA] = ACTIONS(6462),
    [sym_line_comment] = ACTIONS(7),
  },
  [2411] = {
    [sym_raw_string_literal] = ACTIONS(6464),
    [sym_float_literal] = ACTIONS(6464),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(6464),
    [anon_sym_SEMI] = ACTIONS(6464),
    [anon_sym_macro_rules_BANG] = ACTIONS(6464),
    [anon_sym_LPAREN] = ACTIONS(6464),
    [anon_sym_LBRACE] = ACTIONS(6464),
    [anon_sym_RBRACE] = ACTIONS(6464),
    [anon_sym_LBRACK] = ACTIONS(6464),
    [anon_sym_STAR] = ACTIONS(6464),
    [anon_sym_u8] = ACTIONS(6466),
    [anon_sym_i8] = ACTIONS(6466),
    [anon_sym_u16] = ACTIONS(6466),
    [anon_sym_i16] = ACTIONS(6466),
    [anon_sym_u32] = ACTIONS(6466),
    [anon_sym_i32] = ACTIONS(6466),
    [anon_sym_u64] = ACTIONS(6466),
    [anon_sym_i64] = ACTIONS(6466),
    [anon_sym_u128] = ACTIONS(6466),
    [anon_sym_i128] = ACTIONS(6466),
    [anon_sym_isize] = ACTIONS(6466),
    [anon_sym_usize] = ACTIONS(6466),
    [anon_sym_f32] = ACTIONS(6466),
    [anon_sym_f64] = ACTIONS(6466),
    [anon_sym_bool] = ACTIONS(6466),
    [anon_sym_str] = ACTIONS(6466),
    [anon_sym_char] = ACTIONS(6466),
    [anon_sym_AMP] = ACTIONS(6464),
    [anon_sym_DASH] = ACTIONS(6464),
    [anon_sym_COLON_COLON] = ACTIONS(6464),
    [anon_sym_BANG] = ACTIONS(6464),
    [anon_sym_POUND] = ACTIONS(6464),
    [anon_sym_LT] = ACTIONS(6464),
    [anon_sym_PIPE] = ACTIONS(6464),
    [anon_sym_SQUOTE] = ACTIONS(6466),
    [anon_sym_DOT_DOT] = ACTIONS(6464),
    [anon_sym_break] = ACTIONS(6466),
    [anon_sym_const] = ACTIONS(6466),
    [anon_sym_continue] = ACTIONS(6466),
    [anon_sym_default] = ACTIONS(6466),
    [anon_sym_enum] = ACTIONS(6466),
    [anon_sym_fn] = ACTIONS(6466),
    [anon_sym_for] = ACTIONS(6466),
    [anon_sym_if] = ACTIONS(6466),
    [anon_sym_impl] = ACTIONS(6466),
    [anon_sym_let] = ACTIONS(6466),
    [anon_sym_loop] = ACTIONS(6466),
    [anon_sym_match] = ACTIONS(6466),
    [anon_sym_mod] = ACTIONS(6466),
    [anon_sym_pub] = ACTIONS(6466),
    [anon_sym_return] = ACTIONS(6466),
    [anon_sym_static] = ACTIONS(6466),
    [anon_sym_struct] = ACTIONS(6466),
    [anon_sym_trait] = ACTIONS(6466),
    [anon_sym_type] = ACTIONS(6466),
    [anon_sym_union] = ACTIONS(6466),
    [anon_sym_unsafe] = ACTIONS(6466),
    [anon_sym_use] = ACTIONS(6466),
    [anon_sym_while] = ACTIONS(6466),
    [anon_sym_extern] = ACTIONS(6466),
    [anon_sym_move] = ACTIONS(6466),
    [sym_integer_literal] = ACTIONS(6464),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6464),
    [sym_char_literal] = ACTIONS(6464),
    [anon_sym_true] = ACTIONS(6466),
    [anon_sym_false] = ACTIONS(6466),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6466),
    [sym_self] = ACTIONS(6466),
    [sym_super] = ACTIONS(6466),
    [sym_crate] = ACTIONS(6466),
    [sym_metavariable] = ACTIONS(6464),
  },
  [2412] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6468),
    [sym_line_comment] = ACTIONS(7),
  },
  [2413] = {
    [sym_trait_bounds] = STATE(993),
    [aux_sym_type_parameters_repeat1] = STATE(2944),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2032),
    [anon_sym_COMMA] = ACTIONS(2022),
    [anon_sym_EQ] = ACTIONS(2024),
    [anon_sym_GT] = ACTIONS(6470),
    [sym_line_comment] = ACTIONS(7),
  },
  [2414] = {
    [aux_sym_type_parameters_repeat1] = STATE(2946),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(2022),
    [anon_sym_GT] = ACTIONS(6472),
    [sym_line_comment] = ACTIONS(7),
  },
  [2415] = {
    [aux_sym_type_parameters_repeat1] = STATE(2946),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(2022),
    [anon_sym_EQ] = ACTIONS(2030),
    [anon_sym_GT] = ACTIONS(6472),
    [sym_line_comment] = ACTIONS(7),
  },
  [2416] = {
    [sym_trait_bounds] = STATE(998),
    [aux_sym_type_parameters_repeat1] = STATE(2946),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2032),
    [anon_sym_COMMA] = ACTIONS(2022),
    [anon_sym_GT] = ACTIONS(6472),
    [sym_line_comment] = ACTIONS(7),
  },
  [2417] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6474),
    [anon_sym_LPAREN] = ACTIONS(6474),
    [anon_sym_LBRACE] = ACTIONS(6474),
    [anon_sym_PLUS] = ACTIONS(6474),
    [anon_sym_COMMA] = ACTIONS(6474),
    [anon_sym_EQ] = ACTIONS(6474),
    [anon_sym_GT] = ACTIONS(6474),
    [sym_line_comment] = ACTIONS(7),
  },
  [2418] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6476),
    [anon_sym_LPAREN] = ACTIONS(6476),
    [anon_sym_LBRACE] = ACTIONS(6476),
    [anon_sym_PLUS] = ACTIONS(6476),
    [anon_sym_COMMA] = ACTIONS(6476),
    [anon_sym_EQ] = ACTIONS(6476),
    [anon_sym_GT] = ACTIONS(6476),
    [sym_line_comment] = ACTIONS(7),
  },
  [2419] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6476),
    [anon_sym_LPAREN] = ACTIONS(6476),
    [anon_sym_LBRACE] = ACTIONS(6476),
    [anon_sym_PLUS] = ACTIONS(6476),
    [anon_sym_COMMA] = ACTIONS(6476),
    [anon_sym_EQ] = ACTIONS(6476),
    [anon_sym_GT] = ACTIONS(6476),
    [sym_line_comment] = ACTIONS(7),
  },
  [2420] = {
    [aux_sym_trait_bounds_repeat1] = STATE(2420),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(6476),
    [anon_sym_PLUS] = ACTIONS(6478),
    [sym_line_comment] = ACTIONS(7),
  },
  [2421] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(5049),
    [anon_sym_COLON] = ACTIONS(5049),
    [sym_line_comment] = ACTIONS(7),
  },
  [2422] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(5056),
    [anon_sym_COLON] = ACTIONS(5056),
    [sym_line_comment] = ACTIONS(7),
  },
  [2423] = {
    [sym_function_modifiers] = STATE(1097),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1479),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1102),
    [sym_array_type] = STATE(1479),
    [sym_function_type] = STATE(1479),
    [sym_tuple_type] = STATE(1479),
    [sym_unit_type] = STATE(1479),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1479),
    [sym_reference_type] = STATE(1479),
    [sym_pointer_type] = STATE(1479),
    [sym_empty_type] = STATE(1479),
    [sym_dynamic_type] = STATE(1479),
    [sym_macro_invocation] = STATE(1479),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2156),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2162),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2166),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2424] = {
    [sym_function_modifiers] = STATE(1097),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1499),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1102),
    [sym_array_type] = STATE(1499),
    [sym_function_type] = STATE(1499),
    [sym_tuple_type] = STATE(1499),
    [sym_unit_type] = STATE(1499),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1499),
    [sym_reference_type] = STATE(1499),
    [sym_pointer_type] = STATE(1499),
    [sym_empty_type] = STATE(1499),
    [sym_abstract_type] = STATE(1500),
    [sym_dynamic_type] = STATE(1499),
    [sym_macro_invocation] = STATE(1499),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2156),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2162),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2166),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2425] = {
    [sym_function_modifiers] = STATE(1097),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1525),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1102),
    [sym_array_type] = STATE(1525),
    [sym_function_type] = STATE(1525),
    [sym_tuple_type] = STATE(1525),
    [sym_unit_type] = STATE(1525),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1525),
    [sym_reference_type] = STATE(1525),
    [sym_pointer_type] = STATE(1525),
    [sym_empty_type] = STATE(1525),
    [sym_abstract_type] = STATE(1526),
    [sym_dynamic_type] = STATE(1525),
    [sym_macro_invocation] = STATE(1525),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2156),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2162),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2166),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2426] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_DASH_GT] = ACTIONS(6481),
    [sym_line_comment] = ACTIONS(7),
  },
  [2427] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(6483),
    [sym_line_comment] = ACTIONS(7),
  },
  [2428] = {
    [aux_sym_trait_bounds_repeat1] = STATE(2428),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6476),
    [anon_sym_PLUS] = ACTIONS(6485),
    [sym_line_comment] = ACTIONS(7),
  },
  [2429] = {
    [sym_raw_string_literal] = ACTIONS(6488),
    [sym_float_literal] = ACTIONS(6488),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(6488),
    [anon_sym_SEMI] = ACTIONS(6488),
    [anon_sym_macro_rules_BANG] = ACTIONS(6488),
    [anon_sym_LPAREN] = ACTIONS(6488),
    [anon_sym_LBRACE] = ACTIONS(6488),
    [anon_sym_RBRACE] = ACTIONS(6488),
    [anon_sym_LBRACK] = ACTIONS(6488),
    [anon_sym_STAR] = ACTIONS(6488),
    [anon_sym_u8] = ACTIONS(6490),
    [anon_sym_i8] = ACTIONS(6490),
    [anon_sym_u16] = ACTIONS(6490),
    [anon_sym_i16] = ACTIONS(6490),
    [anon_sym_u32] = ACTIONS(6490),
    [anon_sym_i32] = ACTIONS(6490),
    [anon_sym_u64] = ACTIONS(6490),
    [anon_sym_i64] = ACTIONS(6490),
    [anon_sym_u128] = ACTIONS(6490),
    [anon_sym_i128] = ACTIONS(6490),
    [anon_sym_isize] = ACTIONS(6490),
    [anon_sym_usize] = ACTIONS(6490),
    [anon_sym_f32] = ACTIONS(6490),
    [anon_sym_f64] = ACTIONS(6490),
    [anon_sym_bool] = ACTIONS(6490),
    [anon_sym_str] = ACTIONS(6490),
    [anon_sym_char] = ACTIONS(6490),
    [anon_sym_AMP] = ACTIONS(6488),
    [anon_sym_DASH] = ACTIONS(6488),
    [anon_sym_COLON_COLON] = ACTIONS(6488),
    [anon_sym_BANG] = ACTIONS(6488),
    [anon_sym_POUND] = ACTIONS(6488),
    [anon_sym_LT] = ACTIONS(6488),
    [anon_sym_PIPE] = ACTIONS(6488),
    [anon_sym_SQUOTE] = ACTIONS(6490),
    [anon_sym_DOT_DOT] = ACTIONS(6488),
    [anon_sym_break] = ACTIONS(6490),
    [anon_sym_const] = ACTIONS(6490),
    [anon_sym_continue] = ACTIONS(6490),
    [anon_sym_default] = ACTIONS(6490),
    [anon_sym_enum] = ACTIONS(6490),
    [anon_sym_fn] = ACTIONS(6490),
    [anon_sym_for] = ACTIONS(6490),
    [anon_sym_if] = ACTIONS(6490),
    [anon_sym_impl] = ACTIONS(6490),
    [anon_sym_let] = ACTIONS(6490),
    [anon_sym_loop] = ACTIONS(6490),
    [anon_sym_match] = ACTIONS(6490),
    [anon_sym_mod] = ACTIONS(6490),
    [anon_sym_pub] = ACTIONS(6490),
    [anon_sym_return] = ACTIONS(6490),
    [anon_sym_static] = ACTIONS(6490),
    [anon_sym_struct] = ACTIONS(6490),
    [anon_sym_trait] = ACTIONS(6490),
    [anon_sym_type] = ACTIONS(6490),
    [anon_sym_union] = ACTIONS(6490),
    [anon_sym_unsafe] = ACTIONS(6490),
    [anon_sym_use] = ACTIONS(6490),
    [anon_sym_while] = ACTIONS(6490),
    [anon_sym_extern] = ACTIONS(6490),
    [anon_sym_move] = ACTIONS(6490),
    [sym_integer_literal] = ACTIONS(6488),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6488),
    [sym_char_literal] = ACTIONS(6488),
    [anon_sym_true] = ACTIONS(6490),
    [anon_sym_false] = ACTIONS(6490),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6490),
    [sym_self] = ACTIONS(6490),
    [sym_super] = ACTIONS(6490),
    [sym_crate] = ACTIONS(6490),
    [sym_metavariable] = ACTIONS(6488),
  },
  [2430] = {
    [sym_raw_string_literal] = ACTIONS(6492),
    [sym_float_literal] = ACTIONS(6492),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(6492),
    [anon_sym_SEMI] = ACTIONS(6492),
    [anon_sym_macro_rules_BANG] = ACTIONS(6492),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [anon_sym_LBRACE] = ACTIONS(6492),
    [anon_sym_RBRACE] = ACTIONS(6492),
    [anon_sym_LBRACK] = ACTIONS(6492),
    [anon_sym_STAR] = ACTIONS(6492),
    [anon_sym_u8] = ACTIONS(6494),
    [anon_sym_i8] = ACTIONS(6494),
    [anon_sym_u16] = ACTIONS(6494),
    [anon_sym_i16] = ACTIONS(6494),
    [anon_sym_u32] = ACTIONS(6494),
    [anon_sym_i32] = ACTIONS(6494),
    [anon_sym_u64] = ACTIONS(6494),
    [anon_sym_i64] = ACTIONS(6494),
    [anon_sym_u128] = ACTIONS(6494),
    [anon_sym_i128] = ACTIONS(6494),
    [anon_sym_isize] = ACTIONS(6494),
    [anon_sym_usize] = ACTIONS(6494),
    [anon_sym_f32] = ACTIONS(6494),
    [anon_sym_f64] = ACTIONS(6494),
    [anon_sym_bool] = ACTIONS(6494),
    [anon_sym_str] = ACTIONS(6494),
    [anon_sym_char] = ACTIONS(6494),
    [anon_sym_AMP] = ACTIONS(6492),
    [anon_sym_DASH] = ACTIONS(6492),
    [anon_sym_COLON_COLON] = ACTIONS(6492),
    [anon_sym_BANG] = ACTIONS(6492),
    [anon_sym_POUND] = ACTIONS(6492),
    [anon_sym_LT] = ACTIONS(6492),
    [anon_sym_PIPE] = ACTIONS(6492),
    [anon_sym_SQUOTE] = ACTIONS(6494),
    [anon_sym_DOT_DOT] = ACTIONS(6492),
    [anon_sym_break] = ACTIONS(6494),
    [anon_sym_const] = ACTIONS(6494),
    [anon_sym_continue] = ACTIONS(6494),
    [anon_sym_default] = ACTIONS(6494),
    [anon_sym_enum] = ACTIONS(6494),
    [anon_sym_fn] = ACTIONS(6494),
    [anon_sym_for] = ACTIONS(6494),
    [anon_sym_if] = ACTIONS(6494),
    [anon_sym_impl] = ACTIONS(6494),
    [anon_sym_let] = ACTIONS(6494),
    [anon_sym_loop] = ACTIONS(6494),
    [anon_sym_match] = ACTIONS(6494),
    [anon_sym_mod] = ACTIONS(6494),
    [anon_sym_pub] = ACTIONS(6494),
    [anon_sym_return] = ACTIONS(6494),
    [anon_sym_static] = ACTIONS(6494),
    [anon_sym_struct] = ACTIONS(6494),
    [anon_sym_trait] = ACTIONS(6494),
    [anon_sym_type] = ACTIONS(6494),
    [anon_sym_union] = ACTIONS(6494),
    [anon_sym_unsafe] = ACTIONS(6494),
    [anon_sym_use] = ACTIONS(6494),
    [anon_sym_while] = ACTIONS(6494),
    [anon_sym_extern] = ACTIONS(6494),
    [anon_sym_move] = ACTIONS(6494),
    [sym_integer_literal] = ACTIONS(6492),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6492),
    [sym_char_literal] = ACTIONS(6492),
    [anon_sym_true] = ACTIONS(6494),
    [anon_sym_false] = ACTIONS(6494),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6494),
    [sym_self] = ACTIONS(6494),
    [sym_super] = ACTIONS(6494),
    [sym_crate] = ACTIONS(6494),
    [sym_metavariable] = ACTIONS(6492),
  },
  [2431] = {
    [sym_raw_string_literal] = ACTIONS(6496),
    [sym_float_literal] = ACTIONS(6496),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(6496),
    [anon_sym_SEMI] = ACTIONS(6496),
    [anon_sym_macro_rules_BANG] = ACTIONS(6496),
    [anon_sym_LPAREN] = ACTIONS(6496),
    [anon_sym_LBRACE] = ACTIONS(6496),
    [anon_sym_RBRACE] = ACTIONS(6496),
    [anon_sym_LBRACK] = ACTIONS(6496),
    [anon_sym_STAR] = ACTIONS(6496),
    [anon_sym_u8] = ACTIONS(6498),
    [anon_sym_i8] = ACTIONS(6498),
    [anon_sym_u16] = ACTIONS(6498),
    [anon_sym_i16] = ACTIONS(6498),
    [anon_sym_u32] = ACTIONS(6498),
    [anon_sym_i32] = ACTIONS(6498),
    [anon_sym_u64] = ACTIONS(6498),
    [anon_sym_i64] = ACTIONS(6498),
    [anon_sym_u128] = ACTIONS(6498),
    [anon_sym_i128] = ACTIONS(6498),
    [anon_sym_isize] = ACTIONS(6498),
    [anon_sym_usize] = ACTIONS(6498),
    [anon_sym_f32] = ACTIONS(6498),
    [anon_sym_f64] = ACTIONS(6498),
    [anon_sym_bool] = ACTIONS(6498),
    [anon_sym_str] = ACTIONS(6498),
    [anon_sym_char] = ACTIONS(6498),
    [anon_sym_AMP] = ACTIONS(6496),
    [anon_sym_DASH] = ACTIONS(6496),
    [anon_sym_COLON_COLON] = ACTIONS(6496),
    [anon_sym_BANG] = ACTIONS(6496),
    [anon_sym_POUND] = ACTIONS(6496),
    [anon_sym_LT] = ACTIONS(6496),
    [anon_sym_PIPE] = ACTIONS(6496),
    [anon_sym_SQUOTE] = ACTIONS(6498),
    [anon_sym_DOT_DOT] = ACTIONS(6496),
    [anon_sym_break] = ACTIONS(6498),
    [anon_sym_const] = ACTIONS(6498),
    [anon_sym_continue] = ACTIONS(6498),
    [anon_sym_default] = ACTIONS(6498),
    [anon_sym_enum] = ACTIONS(6498),
    [anon_sym_fn] = ACTIONS(6498),
    [anon_sym_for] = ACTIONS(6498),
    [anon_sym_if] = ACTIONS(6498),
    [anon_sym_impl] = ACTIONS(6498),
    [anon_sym_let] = ACTIONS(6498),
    [anon_sym_loop] = ACTIONS(6498),
    [anon_sym_match] = ACTIONS(6498),
    [anon_sym_mod] = ACTIONS(6498),
    [anon_sym_pub] = ACTIONS(6498),
    [anon_sym_return] = ACTIONS(6498),
    [anon_sym_static] = ACTIONS(6498),
    [anon_sym_struct] = ACTIONS(6498),
    [anon_sym_trait] = ACTIONS(6498),
    [anon_sym_type] = ACTIONS(6498),
    [anon_sym_union] = ACTIONS(6498),
    [anon_sym_unsafe] = ACTIONS(6498),
    [anon_sym_use] = ACTIONS(6498),
    [anon_sym_while] = ACTIONS(6498),
    [anon_sym_extern] = ACTIONS(6498),
    [anon_sym_move] = ACTIONS(6498),
    [sym_integer_literal] = ACTIONS(6496),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6496),
    [sym_char_literal] = ACTIONS(6496),
    [anon_sym_true] = ACTIONS(6498),
    [anon_sym_false] = ACTIONS(6498),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6498),
    [sym_self] = ACTIONS(6498),
    [sym_super] = ACTIONS(6498),
    [sym_crate] = ACTIONS(6498),
    [sym_metavariable] = ACTIONS(6496),
  },
  [2432] = {
    [sym_declaration_list] = STATE(2949),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [sym_line_comment] = ACTIONS(7),
  },
  [2433] = {
    [sym_declaration_list] = STATE(2949),
    [sym_where_clause] = STATE(2950),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [2434] = {
    [sym_declaration_list] = STATE(2791),
    [sym_where_clause] = STATE(2951),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [2435] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6500),
    [anon_sym_RBRACE] = ACTIONS(6500),
    [anon_sym_COMMA] = ACTIONS(6500),
    [sym_line_comment] = ACTIONS(7),
  },
  [2436] = {
    [sym_use_list] = STATE(1797),
    [sym_use_as_clause] = STATE(1797),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_type_with_turbofish] = STATE(212),
    [sym_scoped_identifier] = STATE(1798),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(377),
    [anon_sym_u8] = ACTIONS(3443),
    [anon_sym_i8] = ACTIONS(3443),
    [anon_sym_u16] = ACTIONS(3443),
    [anon_sym_i16] = ACTIONS(3443),
    [anon_sym_u32] = ACTIONS(3443),
    [anon_sym_i32] = ACTIONS(3443),
    [anon_sym_u64] = ACTIONS(3443),
    [anon_sym_i64] = ACTIONS(3443),
    [anon_sym_u128] = ACTIONS(3443),
    [anon_sym_i128] = ACTIONS(3443),
    [anon_sym_isize] = ACTIONS(3443),
    [anon_sym_usize] = ACTIONS(3443),
    [anon_sym_f32] = ACTIONS(3443),
    [anon_sym_f64] = ACTIONS(3443),
    [anon_sym_bool] = ACTIONS(3443),
    [anon_sym_str] = ACTIONS(3443),
    [anon_sym_char] = ACTIONS(3443),
    [anon_sym_COLON_COLON] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(31),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3445),
    [sym_self] = ACTIONS(3447),
    [sym_super] = ACTIONS(3447),
    [sym_crate] = ACTIONS(3447),
    [sym_metavariable] = ACTIONS(3449),
  },
  [2437] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6502),
    [anon_sym_RBRACE] = ACTIONS(6502),
    [anon_sym_COMMA] = ACTIONS(6502),
    [sym_line_comment] = ACTIONS(7),
  },
  [2438] = {
    [sym_raw_string_literal] = ACTIONS(6504),
    [sym_float_literal] = ACTIONS(6504),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(6504),
    [anon_sym_SEMI] = ACTIONS(6504),
    [anon_sym_macro_rules_BANG] = ACTIONS(6504),
    [anon_sym_LPAREN] = ACTIONS(6504),
    [anon_sym_LBRACE] = ACTIONS(6504),
    [anon_sym_RBRACE] = ACTIONS(6504),
    [anon_sym_LBRACK] = ACTIONS(6504),
    [anon_sym_PLUS] = ACTIONS(6506),
    [anon_sym_STAR] = ACTIONS(6506),
    [anon_sym_u8] = ACTIONS(6506),
    [anon_sym_i8] = ACTIONS(6506),
    [anon_sym_u16] = ACTIONS(6506),
    [anon_sym_i16] = ACTIONS(6506),
    [anon_sym_u32] = ACTIONS(6506),
    [anon_sym_i32] = ACTIONS(6506),
    [anon_sym_u64] = ACTIONS(6506),
    [anon_sym_i64] = ACTIONS(6506),
    [anon_sym_u128] = ACTIONS(6506),
    [anon_sym_i128] = ACTIONS(6506),
    [anon_sym_isize] = ACTIONS(6506),
    [anon_sym_usize] = ACTIONS(6506),
    [anon_sym_f32] = ACTIONS(6506),
    [anon_sym_f64] = ACTIONS(6506),
    [anon_sym_bool] = ACTIONS(6506),
    [anon_sym_str] = ACTIONS(6506),
    [anon_sym_char] = ACTIONS(6506),
    [anon_sym_AMP] = ACTIONS(6506),
    [anon_sym_DASH] = ACTIONS(6506),
    [anon_sym_DOT] = ACTIONS(6506),
    [anon_sym_DASH_EQ] = ACTIONS(6504),
    [anon_sym_COLON_COLON] = ACTIONS(6504),
    [anon_sym_BANG] = ACTIONS(6506),
    [anon_sym_BANG_EQ] = ACTIONS(6504),
    [anon_sym_STAR_EQ] = ACTIONS(6504),
    [anon_sym_SLASH] = ACTIONS(6506),
    [anon_sym_SLASH_EQ] = ACTIONS(6504),
    [anon_sym_AMP_AMP] = ACTIONS(6504),
    [anon_sym_AMP_EQ] = ACTIONS(6504),
    [anon_sym_POUND] = ACTIONS(6504),
    [anon_sym_PERCENT] = ACTIONS(6506),
    [anon_sym_PERCENT_EQ] = ACTIONS(6504),
    [anon_sym_CARET] = ACTIONS(6506),
    [anon_sym_CARET_EQ] = ACTIONS(6504),
    [anon_sym_PLUS_EQ] = ACTIONS(6504),
    [anon_sym_LT] = ACTIONS(6506),
    [anon_sym_LT_LT] = ACTIONS(6506),
    [anon_sym_LT_LT_EQ] = ACTIONS(6504),
    [anon_sym_LT_EQ] = ACTIONS(6504),
    [anon_sym_EQ] = ACTIONS(6506),
    [anon_sym_EQ_EQ] = ACTIONS(6504),
    [anon_sym_GT] = ACTIONS(6506),
    [anon_sym_GT_EQ] = ACTIONS(6504),
    [anon_sym_GT_GT] = ACTIONS(6506),
    [anon_sym_GT_GT_EQ] = ACTIONS(6504),
    [anon_sym_PIPE] = ACTIONS(6506),
    [anon_sym_PIPE_EQ] = ACTIONS(6504),
    [anon_sym_PIPE_PIPE] = ACTIONS(6504),
    [anon_sym_QMARK] = ACTIONS(6504),
    [anon_sym_SQUOTE] = ACTIONS(6506),
    [anon_sym_DOT_DOT] = ACTIONS(6506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6504),
    [anon_sym_as] = ACTIONS(6506),
    [anon_sym_break] = ACTIONS(6506),
    [anon_sym_const] = ACTIONS(6506),
    [anon_sym_continue] = ACTIONS(6506),
    [anon_sym_default] = ACTIONS(6506),
    [anon_sym_enum] = ACTIONS(6506),
    [anon_sym_fn] = ACTIONS(6506),
    [anon_sym_for] = ACTIONS(6506),
    [anon_sym_if] = ACTIONS(6506),
    [anon_sym_impl] = ACTIONS(6506),
    [anon_sym_let] = ACTIONS(6506),
    [anon_sym_loop] = ACTIONS(6506),
    [anon_sym_match] = ACTIONS(6506),
    [anon_sym_mod] = ACTIONS(6506),
    [anon_sym_pub] = ACTIONS(6506),
    [anon_sym_return] = ACTIONS(6506),
    [anon_sym_static] = ACTIONS(6506),
    [anon_sym_struct] = ACTIONS(6506),
    [anon_sym_trait] = ACTIONS(6506),
    [anon_sym_type] = ACTIONS(6506),
    [anon_sym_union] = ACTIONS(6506),
    [anon_sym_unsafe] = ACTIONS(6506),
    [anon_sym_use] = ACTIONS(6506),
    [anon_sym_while] = ACTIONS(6506),
    [anon_sym_extern] = ACTIONS(6506),
    [anon_sym_move] = ACTIONS(6506),
    [sym_integer_literal] = ACTIONS(6504),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6504),
    [sym_char_literal] = ACTIONS(6504),
    [anon_sym_true] = ACTIONS(6506),
    [anon_sym_false] = ACTIONS(6506),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6506),
    [sym_self] = ACTIONS(6506),
    [sym_super] = ACTIONS(6506),
    [sym_crate] = ACTIONS(6506),
    [sym_metavariable] = ACTIONS(6504),
  },
  [2439] = {
    [sym_raw_string_literal] = ACTIONS(6508),
    [sym_float_literal] = ACTIONS(6508),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(6508),
    [anon_sym_SEMI] = ACTIONS(6508),
    [anon_sym_macro_rules_BANG] = ACTIONS(6508),
    [anon_sym_LPAREN] = ACTIONS(6508),
    [anon_sym_LBRACE] = ACTIONS(6508),
    [anon_sym_RBRACE] = ACTIONS(6508),
    [anon_sym_LBRACK] = ACTIONS(6508),
    [anon_sym_STAR] = ACTIONS(6508),
    [anon_sym_u8] = ACTIONS(6510),
    [anon_sym_i8] = ACTIONS(6510),
    [anon_sym_u16] = ACTIONS(6510),
    [anon_sym_i16] = ACTIONS(6510),
    [anon_sym_u32] = ACTIONS(6510),
    [anon_sym_i32] = ACTIONS(6510),
    [anon_sym_u64] = ACTIONS(6510),
    [anon_sym_i64] = ACTIONS(6510),
    [anon_sym_u128] = ACTIONS(6510),
    [anon_sym_i128] = ACTIONS(6510),
    [anon_sym_isize] = ACTIONS(6510),
    [anon_sym_usize] = ACTIONS(6510),
    [anon_sym_f32] = ACTIONS(6510),
    [anon_sym_f64] = ACTIONS(6510),
    [anon_sym_bool] = ACTIONS(6510),
    [anon_sym_str] = ACTIONS(6510),
    [anon_sym_char] = ACTIONS(6510),
    [anon_sym_AMP] = ACTIONS(6508),
    [anon_sym_DASH] = ACTIONS(6508),
    [anon_sym_COLON_COLON] = ACTIONS(6508),
    [anon_sym_BANG] = ACTIONS(6508),
    [anon_sym_POUND] = ACTIONS(6508),
    [anon_sym_LT] = ACTIONS(6508),
    [anon_sym_PIPE] = ACTIONS(6508),
    [anon_sym_SQUOTE] = ACTIONS(6510),
    [anon_sym_DOT_DOT] = ACTIONS(6508),
    [anon_sym_break] = ACTIONS(6510),
    [anon_sym_const] = ACTIONS(6510),
    [anon_sym_continue] = ACTIONS(6510),
    [anon_sym_default] = ACTIONS(6510),
    [anon_sym_enum] = ACTIONS(6510),
    [anon_sym_fn] = ACTIONS(6510),
    [anon_sym_for] = ACTIONS(6510),
    [anon_sym_if] = ACTIONS(6510),
    [anon_sym_impl] = ACTIONS(6510),
    [anon_sym_let] = ACTIONS(6510),
    [anon_sym_loop] = ACTIONS(6510),
    [anon_sym_match] = ACTIONS(6510),
    [anon_sym_mod] = ACTIONS(6510),
    [anon_sym_pub] = ACTIONS(6510),
    [anon_sym_return] = ACTIONS(6510),
    [anon_sym_static] = ACTIONS(6510),
    [anon_sym_struct] = ACTIONS(6510),
    [anon_sym_trait] = ACTIONS(6510),
    [anon_sym_type] = ACTIONS(6510),
    [anon_sym_union] = ACTIONS(6510),
    [anon_sym_unsafe] = ACTIONS(6510),
    [anon_sym_use] = ACTIONS(6510),
    [anon_sym_while] = ACTIONS(6510),
    [anon_sym_extern] = ACTIONS(6510),
    [anon_sym_move] = ACTIONS(6510),
    [sym_integer_literal] = ACTIONS(6508),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6508),
    [sym_char_literal] = ACTIONS(6508),
    [anon_sym_true] = ACTIONS(6510),
    [anon_sym_false] = ACTIONS(6510),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6510),
    [sym_self] = ACTIONS(6510),
    [sym_super] = ACTIONS(6510),
    [sym_crate] = ACTIONS(6510),
    [sym_metavariable] = ACTIONS(6508),
  },
  [2440] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(2872),
    [anon_sym_pub] = ACTIONS(2874),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2874),
  },
  [2441] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(6512),
    [sym_line_comment] = ACTIONS(7),
  },
  [2442] = {
    [sym_else_tail] = STATE(1378),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2012),
    [anon_sym_RBRACE] = ACTIONS(2012),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_PLUS] = ACTIONS(2014),
    [anon_sym_STAR] = ACTIONS(2014),
    [anon_sym_COMMA] = ACTIONS(2012),
    [anon_sym_AMP] = ACTIONS(2014),
    [anon_sym_DASH] = ACTIONS(2014),
    [anon_sym_DOT] = ACTIONS(2014),
    [anon_sym_DASH_EQ] = ACTIONS(2012),
    [anon_sym_BANG_EQ] = ACTIONS(2012),
    [anon_sym_STAR_EQ] = ACTIONS(2012),
    [anon_sym_SLASH] = ACTIONS(2014),
    [anon_sym_SLASH_EQ] = ACTIONS(2012),
    [anon_sym_AMP_AMP] = ACTIONS(2012),
    [anon_sym_AMP_EQ] = ACTIONS(2012),
    [anon_sym_PERCENT] = ACTIONS(2014),
    [anon_sym_PERCENT_EQ] = ACTIONS(2012),
    [anon_sym_CARET] = ACTIONS(2014),
    [anon_sym_CARET_EQ] = ACTIONS(2012),
    [anon_sym_PLUS_EQ] = ACTIONS(2012),
    [anon_sym_LT] = ACTIONS(2014),
    [anon_sym_LT_LT] = ACTIONS(2014),
    [anon_sym_LT_LT_EQ] = ACTIONS(2012),
    [anon_sym_LT_EQ] = ACTIONS(2012),
    [anon_sym_EQ] = ACTIONS(2014),
    [anon_sym_EQ_EQ] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2014),
    [anon_sym_GT_EQ] = ACTIONS(2012),
    [anon_sym_GT_GT] = ACTIONS(2014),
    [anon_sym_GT_GT_EQ] = ACTIONS(2012),
    [anon_sym_PIPE] = ACTIONS(2014),
    [anon_sym_PIPE_EQ] = ACTIONS(2012),
    [anon_sym_PIPE_PIPE] = ACTIONS(2012),
    [anon_sym_QMARK] = ACTIONS(2012),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2012),
    [anon_sym_as] = ACTIONS(2012),
    [anon_sym_else] = ACTIONS(6514),
    [sym_line_comment] = ACTIONS(7),
  },
  [2443] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(3495),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2220),
    [anon_sym_AMP] = ACTIONS(3499),
    [anon_sym_DASH] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(3501),
    [anon_sym_BANG_EQ] = ACTIONS(3503),
    [anon_sym_STAR_EQ] = ACTIONS(3501),
    [anon_sym_SLASH] = ACTIONS(3497),
    [anon_sym_SLASH_EQ] = ACTIONS(3501),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_AMP_EQ] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_PERCENT_EQ] = ACTIONS(3501),
    [anon_sym_CARET] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3501),
    [anon_sym_PLUS_EQ] = ACTIONS(3501),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_LT_LT] = ACTIONS(3511),
    [anon_sym_LT_LT_EQ] = ACTIONS(3501),
    [anon_sym_LT_EQ] = ACTIONS(3503),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_EQ_EQ] = ACTIONS(3503),
    [anon_sym_GT] = ACTIONS(3509),
    [anon_sym_GT_EQ] = ACTIONS(3503),
    [anon_sym_GT_GT] = ACTIONS(3511),
    [anon_sym_GT_GT_EQ] = ACTIONS(3501),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_PIPE_EQ] = ACTIONS(3501),
    [anon_sym_PIPE_PIPE] = ACTIONS(3517),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(3519),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3521),
    [anon_sym_as] = ACTIONS(3523),
    [sym_line_comment] = ACTIONS(7),
  },
  [2444] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(3497),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2591),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [2445] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(3495),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(3497),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(3511),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(3511),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [2446] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(3495),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2601),
    [anon_sym_AMP] = ACTIONS(3499),
    [anon_sym_DASH] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2601),
    [anon_sym_BANG_EQ] = ACTIONS(3503),
    [anon_sym_STAR_EQ] = ACTIONS(2601),
    [anon_sym_SLASH] = ACTIONS(3497),
    [anon_sym_SLASH_EQ] = ACTIONS(2601),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_AMP_EQ] = ACTIONS(2601),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_PERCENT_EQ] = ACTIONS(2601),
    [anon_sym_CARET] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(2601),
    [anon_sym_PLUS_EQ] = ACTIONS(2601),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_LT_LT] = ACTIONS(3511),
    [anon_sym_LT_LT_EQ] = ACTIONS(2601),
    [anon_sym_LT_EQ] = ACTIONS(3503),
    [anon_sym_EQ] = ACTIONS(2603),
    [anon_sym_EQ_EQ] = ACTIONS(3503),
    [anon_sym_GT] = ACTIONS(3509),
    [anon_sym_GT_EQ] = ACTIONS(3503),
    [anon_sym_GT_GT] = ACTIONS(3511),
    [anon_sym_GT_GT_EQ] = ACTIONS(2601),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_PIPE_EQ] = ACTIONS(2601),
    [anon_sym_PIPE_PIPE] = ACTIONS(3517),
    [anon_sym_QMARK] = ACTIONS(2601),
    [anon_sym_DOT_DOT] = ACTIONS(3519),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3521),
    [anon_sym_as] = ACTIONS(2601),
    [sym_line_comment] = ACTIONS(7),
  },
  [2447] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(3495),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(3499),
    [anon_sym_DASH] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(3497),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(3511),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(3511),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [2448] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(3495),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(3499),
    [anon_sym_DASH] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(3503),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(3497),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_LT_LT] = ACTIONS(3511),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(3503),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(3503),
    [anon_sym_GT] = ACTIONS(3509),
    [anon_sym_GT_EQ] = ACTIONS(3503),
    [anon_sym_GT_GT] = ACTIONS(3511),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [2449] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(3495),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(3499),
    [anon_sym_DASH] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(3497),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(3511),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(3511),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [2450] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(3495),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(3497),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2591),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [2451] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(2605),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(3495),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2605),
    [anon_sym_AMP] = ACTIONS(3499),
    [anon_sym_DASH] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2605),
    [anon_sym_BANG_EQ] = ACTIONS(3503),
    [anon_sym_STAR_EQ] = ACTIONS(2605),
    [anon_sym_SLASH] = ACTIONS(3497),
    [anon_sym_SLASH_EQ] = ACTIONS(2605),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_AMP_EQ] = ACTIONS(2605),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_PERCENT_EQ] = ACTIONS(2605),
    [anon_sym_CARET] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(2605),
    [anon_sym_PLUS_EQ] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_LT_LT] = ACTIONS(3511),
    [anon_sym_LT_LT_EQ] = ACTIONS(2605),
    [anon_sym_LT_EQ] = ACTIONS(3503),
    [anon_sym_EQ] = ACTIONS(2607),
    [anon_sym_EQ_EQ] = ACTIONS(3503),
    [anon_sym_GT] = ACTIONS(3509),
    [anon_sym_GT_EQ] = ACTIONS(3503),
    [anon_sym_GT_GT] = ACTIONS(3511),
    [anon_sym_GT_GT_EQ] = ACTIONS(2605),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_PIPE_EQ] = ACTIONS(2605),
    [anon_sym_PIPE_PIPE] = ACTIONS(3517),
    [anon_sym_QMARK] = ACTIONS(2605),
    [anon_sym_DOT_DOT] = ACTIONS(3519),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3521),
    [anon_sym_as] = ACTIONS(2605),
    [sym_line_comment] = ACTIONS(7),
  },
  [2452] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(3495),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(3499),
    [anon_sym_DASH] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(3497),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(3511),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(3511),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [2453] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(3495),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(3499),
    [anon_sym_DASH] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(3503),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(3497),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_LT_LT] = ACTIONS(3511),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(3503),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(3503),
    [anon_sym_GT] = ACTIONS(3509),
    [anon_sym_GT_EQ] = ACTIONS(3503),
    [anon_sym_GT_GT] = ACTIONS(3511),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [2454] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(3495),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2609),
    [anon_sym_AMP] = ACTIONS(3499),
    [anon_sym_DASH] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2609),
    [anon_sym_BANG_EQ] = ACTIONS(3503),
    [anon_sym_STAR_EQ] = ACTIONS(2609),
    [anon_sym_SLASH] = ACTIONS(3497),
    [anon_sym_SLASH_EQ] = ACTIONS(2609),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_AMP_EQ] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_PERCENT_EQ] = ACTIONS(2609),
    [anon_sym_CARET] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(2609),
    [anon_sym_PLUS_EQ] = ACTIONS(2609),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_LT_LT] = ACTIONS(3511),
    [anon_sym_LT_LT_EQ] = ACTIONS(2609),
    [anon_sym_LT_EQ] = ACTIONS(3503),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_EQ_EQ] = ACTIONS(3503),
    [anon_sym_GT] = ACTIONS(3509),
    [anon_sym_GT_EQ] = ACTIONS(3503),
    [anon_sym_GT_GT] = ACTIONS(3511),
    [anon_sym_GT_GT_EQ] = ACTIONS(2609),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_PIPE_EQ] = ACTIONS(2609),
    [anon_sym_PIPE_PIPE] = ACTIONS(3517),
    [anon_sym_QMARK] = ACTIONS(2609),
    [anon_sym_DOT_DOT] = ACTIONS(2611),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2609),
    [anon_sym_as] = ACTIONS(2609),
    [sym_line_comment] = ACTIONS(7),
  },
  [2455] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(6516),
    [sym_mutable_specifier] = ACTIONS(6516),
    [sym_line_comment] = ACTIONS(7),
  },
  [2456] = {
    [sym_function_modifiers] = STATE(2459),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1319),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(2956),
    [sym_array_type] = STATE(1319),
    [sym_function_type] = STATE(1319),
    [sym_tuple_type] = STATE(1319),
    [sym_unit_type] = STATE(1319),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(1319),
    [sym_reference_type] = STATE(1319),
    [sym_pointer_type] = STATE(1319),
    [sym_empty_type] = STATE(1319),
    [sym_dynamic_type] = STATE(1319),
    [sym_macro_invocation] = STATE(1319),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(2461),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(5429),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5431),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_mutable_specifier] = ACTIONS(6518),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5433),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2457] = {
    [sym_parameters] = STATE(2957),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [sym_line_comment] = ACTIONS(7),
  },
  [2458] = {
    [sym_parameters] = STATE(2958),
    [sym_type_arguments] = STATE(1330),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_RBRACE] = ACTIONS(773),
    [anon_sym_LBRACK] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(2633),
    [anon_sym_STAR] = ACTIONS(2633),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_DASH] = ACTIONS(2633),
    [anon_sym_DOT] = ACTIONS(2633),
    [anon_sym_DASH_EQ] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(2635),
    [anon_sym_BANG] = ACTIONS(557),
    [anon_sym_BANG_EQ] = ACTIONS(773),
    [anon_sym_STAR_EQ] = ACTIONS(773),
    [anon_sym_SLASH] = ACTIONS(2633),
    [anon_sym_SLASH_EQ] = ACTIONS(773),
    [anon_sym_AMP_AMP] = ACTIONS(773),
    [anon_sym_AMP_EQ] = ACTIONS(773),
    [anon_sym_PERCENT] = ACTIONS(2633),
    [anon_sym_PERCENT_EQ] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(2633),
    [anon_sym_CARET_EQ] = ACTIONS(773),
    [anon_sym_PLUS_EQ] = ACTIONS(773),
    [anon_sym_LT] = ACTIONS(2637),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_LT_LT_EQ] = ACTIONS(773),
    [anon_sym_LT_EQ] = ACTIONS(773),
    [anon_sym_EQ] = ACTIONS(2633),
    [anon_sym_EQ_EQ] = ACTIONS(773),
    [anon_sym_GT] = ACTIONS(2633),
    [anon_sym_GT_EQ] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_GT_GT_EQ] = ACTIONS(773),
    [anon_sym_PIPE] = ACTIONS(2633),
    [anon_sym_PIPE_EQ] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(773),
    [anon_sym_QMARK] = ACTIONS(773),
    [anon_sym_DOT_DOT] = ACTIONS(2633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(773),
    [anon_sym_as] = ACTIONS(773),
    [sym_line_comment] = ACTIONS(7),
  },
  [2459] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2961),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_fn] = ACTIONS(6520),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6522),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [2460] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(6524),
    [sym_line_comment] = ACTIONS(7),
  },
  [2461] = {
    [sym_parameters] = STATE(2957),
    [sym_type_arguments] = STATE(1340),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_RBRACE] = ACTIONS(783),
    [anon_sym_LBRACK] = ACTIONS(783),
    [anon_sym_PLUS] = ACTIONS(785),
    [anon_sym_STAR] = ACTIONS(785),
    [anon_sym_COMMA] = ACTIONS(783),
    [anon_sym_AMP] = ACTIONS(785),
    [anon_sym_DASH] = ACTIONS(785),
    [anon_sym_DOT] = ACTIONS(785),
    [anon_sym_DASH_EQ] = ACTIONS(783),
    [anon_sym_BANG_EQ] = ACTIONS(783),
    [anon_sym_STAR_EQ] = ACTIONS(783),
    [anon_sym_SLASH] = ACTIONS(785),
    [anon_sym_SLASH_EQ] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_AMP_EQ] = ACTIONS(783),
    [anon_sym_PERCENT] = ACTIONS(785),
    [anon_sym_PERCENT_EQ] = ACTIONS(783),
    [anon_sym_CARET] = ACTIONS(785),
    [anon_sym_CARET_EQ] = ACTIONS(783),
    [anon_sym_PLUS_EQ] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(2637),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_LT_LT_EQ] = ACTIONS(783),
    [anon_sym_LT_EQ] = ACTIONS(783),
    [anon_sym_EQ] = ACTIONS(785),
    [anon_sym_EQ_EQ] = ACTIONS(783),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_GT_EQ] = ACTIONS(783),
    [anon_sym_GT_GT] = ACTIONS(785),
    [anon_sym_GT_GT_EQ] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PIPE_EQ] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_DOT_DOT] = ACTIONS(785),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(783),
    [anon_sym_as] = ACTIONS(783),
    [sym_line_comment] = ACTIONS(7),
  },
  [2462] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(6526),
    [anon_sym_RPAREN] = ACTIONS(6526),
    [anon_sym_LBRACE] = ACTIONS(6526),
    [anon_sym_RBRACE] = ACTIONS(6526),
    [anon_sym_LBRACK] = ACTIONS(6526),
    [anon_sym_RBRACK] = ACTIONS(6526),
    [anon_sym_PLUS] = ACTIONS(6528),
    [anon_sym_STAR] = ACTIONS(6528),
    [anon_sym_COMMA] = ACTIONS(6526),
    [anon_sym_AMP] = ACTIONS(6528),
    [anon_sym_DASH] = ACTIONS(6528),
    [anon_sym_DOT] = ACTIONS(6528),
    [anon_sym_DASH_EQ] = ACTIONS(6526),
    [anon_sym_BANG_EQ] = ACTIONS(6526),
    [anon_sym_STAR_EQ] = ACTIONS(6526),
    [anon_sym_SLASH] = ACTIONS(6528),
    [anon_sym_SLASH_EQ] = ACTIONS(6526),
    [anon_sym_AMP_AMP] = ACTIONS(6526),
    [anon_sym_AMP_EQ] = ACTIONS(6526),
    [anon_sym_PERCENT] = ACTIONS(6528),
    [anon_sym_PERCENT_EQ] = ACTIONS(6526),
    [anon_sym_CARET] = ACTIONS(6528),
    [anon_sym_CARET_EQ] = ACTIONS(6526),
    [anon_sym_PLUS_EQ] = ACTIONS(6526),
    [anon_sym_LT] = ACTIONS(6528),
    [anon_sym_LT_LT] = ACTIONS(6528),
    [anon_sym_LT_LT_EQ] = ACTIONS(6526),
    [anon_sym_LT_EQ] = ACTIONS(6526),
    [anon_sym_EQ] = ACTIONS(6528),
    [anon_sym_EQ_EQ] = ACTIONS(6526),
    [anon_sym_GT] = ACTIONS(6528),
    [anon_sym_GT_EQ] = ACTIONS(6526),
    [anon_sym_GT_GT] = ACTIONS(6528),
    [anon_sym_GT_GT_EQ] = ACTIONS(6526),
    [anon_sym_PIPE] = ACTIONS(6528),
    [anon_sym_PIPE_EQ] = ACTIONS(6526),
    [anon_sym_PIPE_PIPE] = ACTIONS(6526),
    [anon_sym_QMARK] = ACTIONS(6526),
    [anon_sym_DOT_DOT] = ACTIONS(6528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6526),
    [anon_sym_as] = ACTIONS(6526),
    [sym_line_comment] = ACTIONS(7),
  },
  [2463] = {
    [sym_attribute_item] = STATE(582),
    [sym_field_initializer] = STATE(1831),
    [sym_base_field_initializer] = STATE(1831),
    [aux_sym_enum_variant_list_repeat1] = STATE(582),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_DOT_DOT] = ACTIONS(1135),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3535),
  },
  [2464] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6530),
    [anon_sym_LPAREN] = ACTIONS(6530),
    [anon_sym_RPAREN] = ACTIONS(6530),
    [anon_sym_LBRACE] = ACTIONS(6530),
    [anon_sym_RBRACE] = ACTIONS(6530),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_RBRACK] = ACTIONS(6530),
    [anon_sym_PLUS] = ACTIONS(6532),
    [anon_sym_STAR] = ACTIONS(6532),
    [anon_sym_COMMA] = ACTIONS(6530),
    [anon_sym_AMP] = ACTIONS(6532),
    [anon_sym_DASH] = ACTIONS(6532),
    [anon_sym_DOT] = ACTIONS(6532),
    [anon_sym_DASH_EQ] = ACTIONS(6530),
    [anon_sym_BANG_EQ] = ACTIONS(6530),
    [anon_sym_STAR_EQ] = ACTIONS(6530),
    [anon_sym_SLASH] = ACTIONS(6532),
    [anon_sym_SLASH_EQ] = ACTIONS(6530),
    [anon_sym_AMP_AMP] = ACTIONS(6530),
    [anon_sym_AMP_EQ] = ACTIONS(6530),
    [anon_sym_PERCENT] = ACTIONS(6532),
    [anon_sym_PERCENT_EQ] = ACTIONS(6530),
    [anon_sym_CARET] = ACTIONS(6532),
    [anon_sym_CARET_EQ] = ACTIONS(6530),
    [anon_sym_PLUS_EQ] = ACTIONS(6530),
    [anon_sym_LT] = ACTIONS(6532),
    [anon_sym_LT_LT] = ACTIONS(6532),
    [anon_sym_LT_LT_EQ] = ACTIONS(6530),
    [anon_sym_LT_EQ] = ACTIONS(6530),
    [anon_sym_EQ] = ACTIONS(6532),
    [anon_sym_EQ_EQ] = ACTIONS(6530),
    [anon_sym_GT] = ACTIONS(6532),
    [anon_sym_GT_EQ] = ACTIONS(6530),
    [anon_sym_GT_GT] = ACTIONS(6532),
    [anon_sym_GT_GT_EQ] = ACTIONS(6530),
    [anon_sym_PIPE] = ACTIONS(6532),
    [anon_sym_PIPE_EQ] = ACTIONS(6530),
    [anon_sym_PIPE_PIPE] = ACTIONS(6530),
    [anon_sym_QMARK] = ACTIONS(6530),
    [anon_sym_DOT_DOT] = ACTIONS(6532),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6530),
    [anon_sym_as] = ACTIONS(6530),
    [sym_line_comment] = ACTIONS(7),
  },
  [2465] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(6534),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(3495),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(6534),
    [anon_sym_AMP] = ACTIONS(3499),
    [anon_sym_DASH] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(3501),
    [anon_sym_BANG_EQ] = ACTIONS(3503),
    [anon_sym_STAR_EQ] = ACTIONS(3501),
    [anon_sym_SLASH] = ACTIONS(3497),
    [anon_sym_SLASH_EQ] = ACTIONS(3501),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_AMP_EQ] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_PERCENT_EQ] = ACTIONS(3501),
    [anon_sym_CARET] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3501),
    [anon_sym_PLUS_EQ] = ACTIONS(3501),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_LT_LT] = ACTIONS(3511),
    [anon_sym_LT_LT_EQ] = ACTIONS(3501),
    [anon_sym_LT_EQ] = ACTIONS(3503),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_EQ_EQ] = ACTIONS(3503),
    [anon_sym_GT] = ACTIONS(3509),
    [anon_sym_GT_EQ] = ACTIONS(3503),
    [anon_sym_GT_GT] = ACTIONS(3511),
    [anon_sym_GT_GT_EQ] = ACTIONS(3501),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_PIPE_EQ] = ACTIONS(3501),
    [anon_sym_PIPE_PIPE] = ACTIONS(3517),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(3519),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3521),
    [anon_sym_as] = ACTIONS(3523),
    [sym_line_comment] = ACTIONS(7),
  },
  [2466] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5997),
    [anon_sym_LPAREN] = ACTIONS(5997),
    [anon_sym_RPAREN] = ACTIONS(5997),
    [anon_sym_LBRACE] = ACTIONS(5997),
    [anon_sym_RBRACE] = ACTIONS(5997),
    [anon_sym_LBRACK] = ACTIONS(5997),
    [anon_sym_RBRACK] = ACTIONS(5997),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_STAR] = ACTIONS(5999),
    [anon_sym_COMMA] = ACTIONS(5997),
    [anon_sym_AMP] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(5999),
    [anon_sym_DOT] = ACTIONS(5999),
    [anon_sym_DASH_EQ] = ACTIONS(5997),
    [anon_sym_COLON_COLON] = ACTIONS(5997),
    [anon_sym_BANG_EQ] = ACTIONS(5997),
    [anon_sym_STAR_EQ] = ACTIONS(5997),
    [anon_sym_SLASH] = ACTIONS(5999),
    [anon_sym_SLASH_EQ] = ACTIONS(5997),
    [anon_sym_AMP_AMP] = ACTIONS(5997),
    [anon_sym_AMP_EQ] = ACTIONS(5997),
    [anon_sym_PERCENT] = ACTIONS(5999),
    [anon_sym_PERCENT_EQ] = ACTIONS(5997),
    [anon_sym_CARET] = ACTIONS(5999),
    [anon_sym_CARET_EQ] = ACTIONS(5997),
    [anon_sym_PLUS_EQ] = ACTIONS(5997),
    [anon_sym_LT] = ACTIONS(5999),
    [anon_sym_LT_LT] = ACTIONS(5999),
    [anon_sym_LT_LT_EQ] = ACTIONS(5997),
    [anon_sym_LT_EQ] = ACTIONS(5997),
    [anon_sym_EQ] = ACTIONS(5999),
    [anon_sym_EQ_EQ] = ACTIONS(5997),
    [anon_sym_GT] = ACTIONS(5999),
    [anon_sym_GT_EQ] = ACTIONS(5997),
    [anon_sym_GT_GT] = ACTIONS(5999),
    [anon_sym_GT_GT_EQ] = ACTIONS(5997),
    [anon_sym_PIPE] = ACTIONS(5999),
    [anon_sym_PIPE_EQ] = ACTIONS(5997),
    [anon_sym_PIPE_PIPE] = ACTIONS(5997),
    [anon_sym_QMARK] = ACTIONS(5997),
    [anon_sym_DOT_DOT] = ACTIONS(5999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5997),
    [anon_sym_as] = ACTIONS(5997),
    [sym_line_comment] = ACTIONS(7),
  },
  [2467] = {
    [sym_function_modifiers] = STATE(854),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2151),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2152),
    [sym_array_type] = STATE(2151),
    [sym_function_type] = STATE(2151),
    [sym_tuple_type] = STATE(2151),
    [sym_unit_type] = STATE(2151),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2151),
    [sym_type_binding] = STATE(2153),
    [sym_reference_type] = STATE(2151),
    [sym_pointer_type] = STATE(2151),
    [sym_empty_type] = STATE(2151),
    [sym_dynamic_type] = STATE(2151),
    [sym_macro_invocation] = STATE(2151),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(858),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1786),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1788),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_GT] = ACTIONS(6536),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1790),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1792),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2468] = {
    [sym_raw_string_literal] = ACTIONS(5554),
    [sym_float_literal] = ACTIONS(5554),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5554),
    [anon_sym_LPAREN] = ACTIONS(6538),
    [anon_sym_RPAREN] = ACTIONS(6538),
    [anon_sym_LBRACE] = ACTIONS(5554),
    [anon_sym_EQ_GT] = ACTIONS(5554),
    [anon_sym_LBRACK] = ACTIONS(6538),
    [anon_sym_RBRACK] = ACTIONS(6538),
    [anon_sym_COLON] = ACTIONS(5556),
    [anon_sym_DOLLAR] = ACTIONS(5556),
    [anon_sym_PLUS] = ACTIONS(6541),
    [anon_sym_STAR] = ACTIONS(6541),
    [anon_sym_COMMA] = ACTIONS(6538),
    [anon_sym_u8] = ACTIONS(5556),
    [anon_sym_i8] = ACTIONS(5556),
    [anon_sym_u16] = ACTIONS(5556),
    [anon_sym_i16] = ACTIONS(5556),
    [anon_sym_u32] = ACTIONS(5556),
    [anon_sym_i32] = ACTIONS(5556),
    [anon_sym_u64] = ACTIONS(5556),
    [anon_sym_i64] = ACTIONS(5556),
    [anon_sym_u128] = ACTIONS(5556),
    [anon_sym_i128] = ACTIONS(5556),
    [anon_sym_isize] = ACTIONS(5556),
    [anon_sym_usize] = ACTIONS(5556),
    [anon_sym_f32] = ACTIONS(5556),
    [anon_sym_f64] = ACTIONS(5556),
    [anon_sym_bool] = ACTIONS(5556),
    [anon_sym_str] = ACTIONS(5556),
    [anon_sym_char] = ACTIONS(5556),
    [anon_sym__] = ACTIONS(5556),
    [anon_sym_AMP] = ACTIONS(6541),
    [anon_sym_DASH] = ACTIONS(6541),
    [anon_sym_DOT] = ACTIONS(6541),
    [anon_sym_DASH_EQ] = ACTIONS(6538),
    [anon_sym_DASH_GT] = ACTIONS(5554),
    [anon_sym_COLON_COLON] = ACTIONS(5554),
    [anon_sym_BANG] = ACTIONS(5556),
    [anon_sym_BANG_EQ] = ACTIONS(6538),
    [anon_sym_AT] = ACTIONS(5554),
    [anon_sym_STAR_EQ] = ACTIONS(6538),
    [anon_sym_SLASH] = ACTIONS(6541),
    [anon_sym_SLASH_EQ] = ACTIONS(6538),
    [anon_sym_AMP_AMP] = ACTIONS(6538),
    [anon_sym_AMP_EQ] = ACTIONS(6538),
    [anon_sym_POUND] = ACTIONS(5554),
    [anon_sym_PERCENT] = ACTIONS(6541),
    [anon_sym_PERCENT_EQ] = ACTIONS(6538),
    [anon_sym_CARET] = ACTIONS(6541),
    [anon_sym_CARET_EQ] = ACTIONS(6538),
    [anon_sym_PLUS_EQ] = ACTIONS(6538),
    [anon_sym_LT] = ACTIONS(6541),
    [anon_sym_LT_LT] = ACTIONS(6541),
    [anon_sym_LT_LT_EQ] = ACTIONS(6538),
    [anon_sym_LT_EQ] = ACTIONS(6538),
    [anon_sym_EQ] = ACTIONS(6541),
    [anon_sym_EQ_EQ] = ACTIONS(6538),
    [anon_sym_GT] = ACTIONS(6541),
    [anon_sym_GT_EQ] = ACTIONS(6538),
    [anon_sym_GT_GT] = ACTIONS(6541),
    [anon_sym_GT_GT_EQ] = ACTIONS(6538),
    [anon_sym_PIPE] = ACTIONS(6541),
    [anon_sym_PIPE_EQ] = ACTIONS(6538),
    [anon_sym_PIPE_PIPE] = ACTIONS(6538),
    [anon_sym_TILDE] = ACTIONS(5554),
    [anon_sym_QMARK] = ACTIONS(6538),
    [anon_sym_SQUOTE] = ACTIONS(5556),
    [anon_sym_DOT_DOT] = ACTIONS(6541),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6538),
    [anon_sym_as] = ACTIONS(6541),
    [anon_sym_break] = ACTIONS(5556),
    [anon_sym_const] = ACTIONS(5556),
    [anon_sym_continue] = ACTIONS(5556),
    [anon_sym_default] = ACTIONS(5556),
    [anon_sym_enum] = ACTIONS(5556),
    [anon_sym_fn] = ACTIONS(5556),
    [anon_sym_for] = ACTIONS(5556),
    [anon_sym_if] = ACTIONS(5556),
    [anon_sym_impl] = ACTIONS(5556),
    [anon_sym_let] = ACTIONS(5556),
    [anon_sym_loop] = ACTIONS(5556),
    [anon_sym_match] = ACTIONS(5556),
    [anon_sym_mod] = ACTIONS(5556),
    [anon_sym_pub] = ACTIONS(5556),
    [anon_sym_return] = ACTIONS(5556),
    [anon_sym_static] = ACTIONS(5556),
    [anon_sym_struct] = ACTIONS(5556),
    [anon_sym_trait] = ACTIONS(5556),
    [anon_sym_type] = ACTIONS(5556),
    [anon_sym_union] = ACTIONS(5556),
    [anon_sym_unsafe] = ACTIONS(5556),
    [anon_sym_use] = ACTIONS(5556),
    [anon_sym_where] = ACTIONS(5556),
    [anon_sym_while] = ACTIONS(5556),
    [sym_mutable_specifier] = ACTIONS(5556),
    [sym_integer_literal] = ACTIONS(5554),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5554),
    [sym_char_literal] = ACTIONS(5554),
    [anon_sym_true] = ACTIONS(5556),
    [anon_sym_false] = ACTIONS(5556),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5556),
    [sym_self] = ACTIONS(5556),
    [sym_super] = ACTIONS(5556),
    [sym_crate] = ACTIONS(5556),
    [sym_metavariable] = ACTIONS(5554),
  },
  [2469] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2966),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2966),
    [sym_macro_invocation] = STATE(2966),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2966),
    [sym_unary_expression] = STATE(2966),
    [sym_try_expression] = STATE(2966),
    [sym_reference_expression] = STATE(2966),
    [sym_binary_expression] = STATE(2966),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2966),
    [sym_call_expression] = STATE(2966),
    [sym_array_expression] = STATE(2966),
    [sym_parenthesized_expression] = STATE(2966),
    [sym_tuple_expression] = STATE(2966),
    [sym_unit_expression] = STATE(2966),
    [sym_struct_expression] = STATE(2966),
    [sym_if_expression] = STATE(2966),
    [sym_if_let_expression] = STATE(2966),
    [sym_match_expression] = STATE(2966),
    [sym_while_expression] = STATE(2966),
    [sym_while_let_expression] = STATE(2966),
    [sym_loop_expression] = STATE(2966),
    [sym_for_expression] = STATE(2966),
    [sym_closure_expression] = STATE(2966),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2966),
    [sym_continue_expression] = STATE(2966),
    [sym_index_expression] = STATE(2966),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2966),
    [sym_block] = STATE(2966),
    [sym__literal] = STATE(2966),
    [sym_string_literal] = STATE(2966),
    [sym_boolean_literal] = STATE(2966),
    [aux_sym_tuple_expression_repeat1] = STATE(711),
    [sym_raw_string_literal] = ACTIONS(6544),
    [sym_float_literal] = ACTIONS(6544),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(6546),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(6544),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6544),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2470] = {
    [aux_sym_token_tree_repeat2] = STATE(1974),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(6548),
    [anon_sym_COMMA] = ACTIONS(6550),
    [sym_line_comment] = ACTIONS(7),
  },
  [2471] = {
    [sym_raw_string_literal] = ACTIONS(5564),
    [sym_float_literal] = ACTIONS(5564),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5564),
    [anon_sym_LPAREN] = ACTIONS(5564),
    [anon_sym_RPAREN] = ACTIONS(5564),
    [anon_sym_LBRACE] = ACTIONS(5564),
    [anon_sym_RBRACE] = ACTIONS(5564),
    [anon_sym_EQ_GT] = ACTIONS(5564),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_RBRACK] = ACTIONS(5564),
    [anon_sym_COLON] = ACTIONS(5566),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [anon_sym_PLUS] = ACTIONS(5566),
    [anon_sym_STAR] = ACTIONS(5566),
    [anon_sym_COMMA] = ACTIONS(5564),
    [anon_sym_u8] = ACTIONS(5566),
    [anon_sym_i8] = ACTIONS(5566),
    [anon_sym_u16] = ACTIONS(5566),
    [anon_sym_i16] = ACTIONS(5566),
    [anon_sym_u32] = ACTIONS(5566),
    [anon_sym_i32] = ACTIONS(5566),
    [anon_sym_u64] = ACTIONS(5566),
    [anon_sym_i64] = ACTIONS(5566),
    [anon_sym_u128] = ACTIONS(5566),
    [anon_sym_i128] = ACTIONS(5566),
    [anon_sym_isize] = ACTIONS(5566),
    [anon_sym_usize] = ACTIONS(5566),
    [anon_sym_f32] = ACTIONS(5566),
    [anon_sym_f64] = ACTIONS(5566),
    [anon_sym_bool] = ACTIONS(5566),
    [anon_sym_str] = ACTIONS(5566),
    [anon_sym_char] = ACTIONS(5566),
    [anon_sym__] = ACTIONS(5566),
    [anon_sym_AMP] = ACTIONS(5566),
    [anon_sym_DASH] = ACTIONS(5566),
    [anon_sym_DOT] = ACTIONS(5566),
    [anon_sym_DASH_EQ] = ACTIONS(5564),
    [anon_sym_DASH_GT] = ACTIONS(5564),
    [anon_sym_COLON_COLON] = ACTIONS(5564),
    [anon_sym_BANG] = ACTIONS(5566),
    [anon_sym_BANG_EQ] = ACTIONS(5564),
    [anon_sym_AT] = ACTIONS(5564),
    [anon_sym_STAR_EQ] = ACTIONS(5564),
    [anon_sym_SLASH] = ACTIONS(5566),
    [anon_sym_SLASH_EQ] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_AMP_EQ] = ACTIONS(5564),
    [anon_sym_POUND] = ACTIONS(5564),
    [anon_sym_PERCENT] = ACTIONS(5566),
    [anon_sym_PERCENT_EQ] = ACTIONS(5564),
    [anon_sym_CARET] = ACTIONS(5566),
    [anon_sym_CARET_EQ] = ACTIONS(5564),
    [anon_sym_PLUS_EQ] = ACTIONS(5564),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_LT_LT_EQ] = ACTIONS(5564),
    [anon_sym_LT_EQ] = ACTIONS(5564),
    [anon_sym_EQ] = ACTIONS(5566),
    [anon_sym_EQ_EQ] = ACTIONS(5564),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_EQ] = ACTIONS(5564),
    [anon_sym_GT_GT] = ACTIONS(5566),
    [anon_sym_GT_GT_EQ] = ACTIONS(5564),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_PIPE_EQ] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_TILDE] = ACTIONS(5564),
    [anon_sym_QMARK] = ACTIONS(5564),
    [anon_sym_SQUOTE] = ACTIONS(5566),
    [anon_sym_DOT_DOT] = ACTIONS(5566),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5564),
    [anon_sym_as] = ACTIONS(5566),
    [anon_sym_break] = ACTIONS(5566),
    [anon_sym_const] = ACTIONS(5566),
    [anon_sym_continue] = ACTIONS(5566),
    [anon_sym_default] = ACTIONS(5566),
    [anon_sym_enum] = ACTIONS(5566),
    [anon_sym_fn] = ACTIONS(5566),
    [anon_sym_for] = ACTIONS(5566),
    [anon_sym_if] = ACTIONS(5566),
    [anon_sym_impl] = ACTIONS(5566),
    [anon_sym_let] = ACTIONS(5566),
    [anon_sym_loop] = ACTIONS(5566),
    [anon_sym_match] = ACTIONS(5566),
    [anon_sym_mod] = ACTIONS(5566),
    [anon_sym_pub] = ACTIONS(5566),
    [anon_sym_return] = ACTIONS(5566),
    [anon_sym_static] = ACTIONS(5566),
    [anon_sym_struct] = ACTIONS(5566),
    [anon_sym_trait] = ACTIONS(5566),
    [anon_sym_type] = ACTIONS(5566),
    [anon_sym_union] = ACTIONS(5566),
    [anon_sym_unsafe] = ACTIONS(5566),
    [anon_sym_use] = ACTIONS(5566),
    [anon_sym_where] = ACTIONS(5566),
    [anon_sym_while] = ACTIONS(5566),
    [sym_mutable_specifier] = ACTIONS(5566),
    [sym_integer_literal] = ACTIONS(5564),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5564),
    [sym_char_literal] = ACTIONS(5564),
    [anon_sym_true] = ACTIONS(5566),
    [anon_sym_false] = ACTIONS(5566),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5566),
    [sym_self] = ACTIONS(5566),
    [sym_super] = ACTIONS(5566),
    [sym_crate] = ACTIONS(5566),
    [sym_metavariable] = ACTIONS(5564),
  },
  [2472] = {
    [sym_raw_string_literal] = ACTIONS(5554),
    [sym_float_literal] = ACTIONS(5554),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5554),
    [anon_sym_LPAREN] = ACTIONS(6552),
    [anon_sym_RPAREN] = ACTIONS(6552),
    [anon_sym_LBRACE] = ACTIONS(5554),
    [anon_sym_EQ_GT] = ACTIONS(5554),
    [anon_sym_LBRACK] = ACTIONS(6552),
    [anon_sym_RBRACK] = ACTIONS(6552),
    [anon_sym_COLON] = ACTIONS(5556),
    [anon_sym_DOLLAR] = ACTIONS(5556),
    [anon_sym_PLUS] = ACTIONS(6555),
    [anon_sym_STAR] = ACTIONS(6555),
    [anon_sym_COMMA] = ACTIONS(6552),
    [anon_sym_u8] = ACTIONS(5556),
    [anon_sym_i8] = ACTIONS(5556),
    [anon_sym_u16] = ACTIONS(5556),
    [anon_sym_i16] = ACTIONS(5556),
    [anon_sym_u32] = ACTIONS(5556),
    [anon_sym_i32] = ACTIONS(5556),
    [anon_sym_u64] = ACTIONS(5556),
    [anon_sym_i64] = ACTIONS(5556),
    [anon_sym_u128] = ACTIONS(5556),
    [anon_sym_i128] = ACTIONS(5556),
    [anon_sym_isize] = ACTIONS(5556),
    [anon_sym_usize] = ACTIONS(5556),
    [anon_sym_f32] = ACTIONS(5556),
    [anon_sym_f64] = ACTIONS(5556),
    [anon_sym_bool] = ACTIONS(5556),
    [anon_sym_str] = ACTIONS(5556),
    [anon_sym_char] = ACTIONS(5556),
    [anon_sym__] = ACTIONS(5556),
    [anon_sym_AMP] = ACTIONS(6555),
    [anon_sym_DASH] = ACTIONS(6555),
    [anon_sym_DOT] = ACTIONS(6555),
    [anon_sym_DASH_EQ] = ACTIONS(6552),
    [anon_sym_DASH_GT] = ACTIONS(5554),
    [anon_sym_COLON_COLON] = ACTIONS(5554),
    [anon_sym_BANG] = ACTIONS(5556),
    [anon_sym_BANG_EQ] = ACTIONS(6552),
    [anon_sym_AT] = ACTIONS(5554),
    [anon_sym_STAR_EQ] = ACTIONS(6552),
    [anon_sym_SLASH] = ACTIONS(6555),
    [anon_sym_SLASH_EQ] = ACTIONS(6552),
    [anon_sym_AMP_AMP] = ACTIONS(6552),
    [anon_sym_AMP_EQ] = ACTIONS(6552),
    [anon_sym_POUND] = ACTIONS(5554),
    [anon_sym_PERCENT] = ACTIONS(6555),
    [anon_sym_PERCENT_EQ] = ACTIONS(6552),
    [anon_sym_CARET] = ACTIONS(6555),
    [anon_sym_CARET_EQ] = ACTIONS(6552),
    [anon_sym_PLUS_EQ] = ACTIONS(6552),
    [anon_sym_LT] = ACTIONS(6555),
    [anon_sym_LT_LT] = ACTIONS(6555),
    [anon_sym_LT_LT_EQ] = ACTIONS(6552),
    [anon_sym_LT_EQ] = ACTIONS(6552),
    [anon_sym_EQ] = ACTIONS(6555),
    [anon_sym_EQ_EQ] = ACTIONS(6552),
    [anon_sym_GT] = ACTIONS(6555),
    [anon_sym_GT_EQ] = ACTIONS(6552),
    [anon_sym_GT_GT] = ACTIONS(6555),
    [anon_sym_GT_GT_EQ] = ACTIONS(6552),
    [anon_sym_PIPE] = ACTIONS(6555),
    [anon_sym_PIPE_EQ] = ACTIONS(6552),
    [anon_sym_PIPE_PIPE] = ACTIONS(6552),
    [anon_sym_TILDE] = ACTIONS(5554),
    [anon_sym_QMARK] = ACTIONS(6552),
    [anon_sym_SQUOTE] = ACTIONS(5556),
    [anon_sym_DOT_DOT] = ACTIONS(6555),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6552),
    [anon_sym_as] = ACTIONS(6555),
    [anon_sym_break] = ACTIONS(5556),
    [anon_sym_const] = ACTIONS(5556),
    [anon_sym_continue] = ACTIONS(5556),
    [anon_sym_default] = ACTIONS(5556),
    [anon_sym_enum] = ACTIONS(5556),
    [anon_sym_fn] = ACTIONS(5556),
    [anon_sym_for] = ACTIONS(5556),
    [anon_sym_if] = ACTIONS(5556),
    [anon_sym_impl] = ACTIONS(5556),
    [anon_sym_let] = ACTIONS(5556),
    [anon_sym_loop] = ACTIONS(5556),
    [anon_sym_match] = ACTIONS(5556),
    [anon_sym_mod] = ACTIONS(5556),
    [anon_sym_pub] = ACTIONS(5556),
    [anon_sym_return] = ACTIONS(5556),
    [anon_sym_static] = ACTIONS(5556),
    [anon_sym_struct] = ACTIONS(5556),
    [anon_sym_trait] = ACTIONS(5556),
    [anon_sym_type] = ACTIONS(5556),
    [anon_sym_union] = ACTIONS(5556),
    [anon_sym_unsafe] = ACTIONS(5556),
    [anon_sym_use] = ACTIONS(5556),
    [anon_sym_where] = ACTIONS(5556),
    [anon_sym_while] = ACTIONS(5556),
    [sym_mutable_specifier] = ACTIONS(5556),
    [sym_integer_literal] = ACTIONS(5554),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5554),
    [sym_char_literal] = ACTIONS(5554),
    [anon_sym_true] = ACTIONS(5556),
    [anon_sym_false] = ACTIONS(5556),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5556),
    [sym_self] = ACTIONS(5556),
    [sym_super] = ACTIONS(5556),
    [sym_crate] = ACTIONS(5556),
    [sym_metavariable] = ACTIONS(5554),
  },
  [2473] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(6558),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(623),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(623),
    [anon_sym_PLUS_EQ] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(623),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(643),
    [anon_sym_as] = ACTIONS(645),
    [sym_line_comment] = ACTIONS(7),
  },
  [2474] = {
    [sym_raw_string_literal] = ACTIONS(3560),
    [sym_float_literal] = ACTIONS(3560),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5462),
    [anon_sym_LPAREN] = ACTIONS(5462),
    [anon_sym_LBRACE] = ACTIONS(3560),
    [anon_sym_EQ_GT] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(5462),
    [anon_sym_RBRACK] = ACTIONS(5462),
    [anon_sym_COLON] = ACTIONS(3562),
    [anon_sym_DOLLAR] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(5465),
    [anon_sym_STAR] = ACTIONS(5465),
    [anon_sym_COMMA] = ACTIONS(5462),
    [anon_sym_u8] = ACTIONS(3562),
    [anon_sym_i8] = ACTIONS(3562),
    [anon_sym_u16] = ACTIONS(3562),
    [anon_sym_i16] = ACTIONS(3562),
    [anon_sym_u32] = ACTIONS(3562),
    [anon_sym_i32] = ACTIONS(3562),
    [anon_sym_u64] = ACTIONS(3562),
    [anon_sym_i64] = ACTIONS(3562),
    [anon_sym_u128] = ACTIONS(3562),
    [anon_sym_i128] = ACTIONS(3562),
    [anon_sym_isize] = ACTIONS(3562),
    [anon_sym_usize] = ACTIONS(3562),
    [anon_sym_f32] = ACTIONS(3562),
    [anon_sym_f64] = ACTIONS(3562),
    [anon_sym_bool] = ACTIONS(3562),
    [anon_sym_str] = ACTIONS(3562),
    [anon_sym_char] = ACTIONS(3562),
    [anon_sym__] = ACTIONS(3562),
    [anon_sym_AMP] = ACTIONS(5465),
    [anon_sym_DASH] = ACTIONS(5465),
    [anon_sym_DOT] = ACTIONS(5465),
    [anon_sym_DASH_EQ] = ACTIONS(5462),
    [anon_sym_DASH_GT] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_BANG] = ACTIONS(3562),
    [anon_sym_BANG_EQ] = ACTIONS(5462),
    [anon_sym_AT] = ACTIONS(3560),
    [anon_sym_STAR_EQ] = ACTIONS(5462),
    [anon_sym_SLASH] = ACTIONS(5465),
    [anon_sym_SLASH_EQ] = ACTIONS(5462),
    [anon_sym_AMP_AMP] = ACTIONS(5462),
    [anon_sym_AMP_EQ] = ACTIONS(5462),
    [anon_sym_POUND] = ACTIONS(3560),
    [anon_sym_PERCENT] = ACTIONS(5465),
    [anon_sym_PERCENT_EQ] = ACTIONS(5462),
    [anon_sym_CARET] = ACTIONS(5465),
    [anon_sym_CARET_EQ] = ACTIONS(5462),
    [anon_sym_PLUS_EQ] = ACTIONS(5462),
    [anon_sym_LT] = ACTIONS(5465),
    [anon_sym_LT_LT] = ACTIONS(5465),
    [anon_sym_LT_LT_EQ] = ACTIONS(5462),
    [anon_sym_LT_EQ] = ACTIONS(5462),
    [anon_sym_EQ] = ACTIONS(5465),
    [anon_sym_EQ_EQ] = ACTIONS(5462),
    [anon_sym_GT] = ACTIONS(5465),
    [anon_sym_GT_EQ] = ACTIONS(5462),
    [anon_sym_GT_GT] = ACTIONS(5465),
    [anon_sym_GT_GT_EQ] = ACTIONS(5462),
    [anon_sym_PIPE] = ACTIONS(5465),
    [anon_sym_PIPE_EQ] = ACTIONS(5462),
    [anon_sym_PIPE_PIPE] = ACTIONS(5462),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_QMARK] = ACTIONS(5462),
    [anon_sym_SQUOTE] = ACTIONS(3562),
    [anon_sym_DOT_DOT] = ACTIONS(5465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5462),
    [anon_sym_as] = ACTIONS(5465),
    [anon_sym_break] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_continue] = ACTIONS(3562),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_fn] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_impl] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_loop] = ACTIONS(3562),
    [anon_sym_match] = ACTIONS(3562),
    [anon_sym_mod] = ACTIONS(3562),
    [anon_sym_pub] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_trait] = ACTIONS(3562),
    [anon_sym_type] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [anon_sym_unsafe] = ACTIONS(3562),
    [anon_sym_use] = ACTIONS(3562),
    [anon_sym_where] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [sym_mutable_specifier] = ACTIONS(3562),
    [sym_integer_literal] = ACTIONS(3560),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3560),
    [sym_char_literal] = ACTIONS(3560),
    [anon_sym_true] = ACTIONS(3562),
    [anon_sym_false] = ACTIONS(3562),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3562),
    [sym_self] = ACTIONS(3562),
    [sym_super] = ACTIONS(3562),
    [sym_crate] = ACTIONS(3562),
    [sym_metavariable] = ACTIONS(3560),
  },
  [2475] = {
    [sym_arguments] = STATE(263),
    [aux_sym_token_tree_repeat2] = STATE(2470),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(6560),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(6562),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_BANG_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH] = ACTIONS(563),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(563),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_LT] = ACTIONS(577),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(581),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(577),
    [anon_sym_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(589),
    [anon_sym_as] = ACTIONS(591),
    [sym_line_comment] = ACTIONS(7),
  },
  [2476] = {
    [sym_raw_string_literal] = ACTIONS(3560),
    [sym_float_literal] = ACTIONS(3560),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5474),
    [anon_sym_LPAREN] = ACTIONS(5474),
    [anon_sym_LBRACE] = ACTIONS(3560),
    [anon_sym_EQ_GT] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(5474),
    [anon_sym_RBRACK] = ACTIONS(5474),
    [anon_sym_COLON] = ACTIONS(3562),
    [anon_sym_DOLLAR] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(5477),
    [anon_sym_STAR] = ACTIONS(5477),
    [anon_sym_COMMA] = ACTIONS(5474),
    [anon_sym_u8] = ACTIONS(3562),
    [anon_sym_i8] = ACTIONS(3562),
    [anon_sym_u16] = ACTIONS(3562),
    [anon_sym_i16] = ACTIONS(3562),
    [anon_sym_u32] = ACTIONS(3562),
    [anon_sym_i32] = ACTIONS(3562),
    [anon_sym_u64] = ACTIONS(3562),
    [anon_sym_i64] = ACTIONS(3562),
    [anon_sym_u128] = ACTIONS(3562),
    [anon_sym_i128] = ACTIONS(3562),
    [anon_sym_isize] = ACTIONS(3562),
    [anon_sym_usize] = ACTIONS(3562),
    [anon_sym_f32] = ACTIONS(3562),
    [anon_sym_f64] = ACTIONS(3562),
    [anon_sym_bool] = ACTIONS(3562),
    [anon_sym_str] = ACTIONS(3562),
    [anon_sym_char] = ACTIONS(3562),
    [anon_sym__] = ACTIONS(3562),
    [anon_sym_AMP] = ACTIONS(5477),
    [anon_sym_DASH] = ACTIONS(5477),
    [anon_sym_DOT] = ACTIONS(5477),
    [anon_sym_DASH_EQ] = ACTIONS(5474),
    [anon_sym_DASH_GT] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_BANG] = ACTIONS(3562),
    [anon_sym_BANG_EQ] = ACTIONS(5474),
    [anon_sym_AT] = ACTIONS(3560),
    [anon_sym_STAR_EQ] = ACTIONS(5474),
    [anon_sym_SLASH] = ACTIONS(5477),
    [anon_sym_SLASH_EQ] = ACTIONS(5474),
    [anon_sym_AMP_AMP] = ACTIONS(5474),
    [anon_sym_AMP_EQ] = ACTIONS(5474),
    [anon_sym_POUND] = ACTIONS(3560),
    [anon_sym_PERCENT] = ACTIONS(5477),
    [anon_sym_PERCENT_EQ] = ACTIONS(5474),
    [anon_sym_CARET] = ACTIONS(5477),
    [anon_sym_CARET_EQ] = ACTIONS(5474),
    [anon_sym_PLUS_EQ] = ACTIONS(5474),
    [anon_sym_LT] = ACTIONS(5477),
    [anon_sym_LT_LT] = ACTIONS(5477),
    [anon_sym_LT_LT_EQ] = ACTIONS(5474),
    [anon_sym_LT_EQ] = ACTIONS(5474),
    [anon_sym_EQ] = ACTIONS(5477),
    [anon_sym_EQ_EQ] = ACTIONS(5474),
    [anon_sym_GT] = ACTIONS(5477),
    [anon_sym_GT_EQ] = ACTIONS(5474),
    [anon_sym_GT_GT] = ACTIONS(5477),
    [anon_sym_GT_GT_EQ] = ACTIONS(5474),
    [anon_sym_PIPE] = ACTIONS(5477),
    [anon_sym_PIPE_EQ] = ACTIONS(5474),
    [anon_sym_PIPE_PIPE] = ACTIONS(5474),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_QMARK] = ACTIONS(5474),
    [anon_sym_SQUOTE] = ACTIONS(3562),
    [anon_sym_DOT_DOT] = ACTIONS(5477),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5474),
    [anon_sym_as] = ACTIONS(5477),
    [anon_sym_break] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_continue] = ACTIONS(3562),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_fn] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_impl] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_loop] = ACTIONS(3562),
    [anon_sym_match] = ACTIONS(3562),
    [anon_sym_mod] = ACTIONS(3562),
    [anon_sym_pub] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_trait] = ACTIONS(3562),
    [anon_sym_type] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [anon_sym_unsafe] = ACTIONS(3562),
    [anon_sym_use] = ACTIONS(3562),
    [anon_sym_where] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [sym_mutable_specifier] = ACTIONS(3562),
    [sym_integer_literal] = ACTIONS(3560),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3560),
    [sym_char_literal] = ACTIONS(3560),
    [anon_sym_true] = ACTIONS(3562),
    [anon_sym_false] = ACTIONS(3562),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3562),
    [sym_self] = ACTIONS(3562),
    [sym_super] = ACTIONS(3562),
    [sym_crate] = ACTIONS(3562),
    [sym_metavariable] = ACTIONS(3560),
  },
  [2477] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(6564),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(623),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(623),
    [anon_sym_PLUS_EQ] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(623),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(643),
    [anon_sym_as] = ACTIONS(645),
    [sym_line_comment] = ACTIONS(7),
  },
  [2478] = {
    [sym__statement] = STATE(332),
    [sym_empty_statement] = STATE(332),
    [sym__expression_statement] = STATE(332),
    [sym_macro_definition] = STATE(332),
    [sym_attribute_item] = STATE(332),
    [sym_inner_attribute_item] = STATE(332),
    [sym_mod_item] = STATE(332),
    [sym_foreign_mod_item] = STATE(332),
    [sym_struct_item] = STATE(332),
    [sym_union_item] = STATE(332),
    [sym_enum_item] = STATE(332),
    [sym_extern_crate_declaration] = STATE(332),
    [sym_const_item] = STATE(332),
    [sym_static_item] = STATE(332),
    [sym_type_item] = STATE(332),
    [sym_function_item] = STATE(332),
    [sym_function_signature_item] = STATE(332),
    [sym_function_modifiers] = STATE(47),
    [sym_impl_item] = STATE(332),
    [sym_trait_item] = STATE(332),
    [sym_associated_type] = STATE(332),
    [sym_let_declaration] = STATE(332),
    [sym_use_declaration] = STATE(332),
    [sym_extern_modifier] = STATE(48),
    [sym_visibility_modifier] = STATE(49),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2973),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2973),
    [sym_macro_invocation] = STATE(53),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2973),
    [sym_unary_expression] = STATE(2973),
    [sym_try_expression] = STATE(2973),
    [sym_reference_expression] = STATE(2973),
    [sym_binary_expression] = STATE(2973),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2973),
    [sym_call_expression] = STATE(2973),
    [sym_array_expression] = STATE(2973),
    [sym_parenthesized_expression] = STATE(2973),
    [sym_tuple_expression] = STATE(2973),
    [sym_unit_expression] = STATE(2973),
    [sym_struct_expression] = STATE(2973),
    [sym_if_expression] = STATE(57),
    [sym_if_let_expression] = STATE(57),
    [sym_match_expression] = STATE(57),
    [sym_while_expression] = STATE(57),
    [sym_while_let_expression] = STATE(57),
    [sym_loop_expression] = STATE(57),
    [sym_for_expression] = STATE(57),
    [sym_closure_expression] = STATE(2973),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(59),
    [sym_break_expression] = STATE(2973),
    [sym_continue_expression] = STATE(2973),
    [sym_index_expression] = STATE(2973),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(57),
    [sym_block] = STATE(57),
    [sym__literal] = STATE(2973),
    [sym_string_literal] = STATE(2973),
    [sym_boolean_literal] = STATE(2973),
    [aux_sym_source_file_repeat1] = STATE(332),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_raw_string_literal] = ACTIONS(6566),
    [sym_float_literal] = ACTIONS(6566),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(6564),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_POUND] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(6566),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6566),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(93),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2479] = {
    [sym_raw_string_literal] = ACTIONS(3560),
    [sym_float_literal] = ACTIONS(3560),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5490),
    [anon_sym_LPAREN] = ACTIONS(5490),
    [anon_sym_LBRACE] = ACTIONS(3560),
    [anon_sym_EQ_GT] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(5490),
    [anon_sym_RBRACK] = ACTIONS(5490),
    [anon_sym_COLON] = ACTIONS(3562),
    [anon_sym_DOLLAR] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(5493),
    [anon_sym_STAR] = ACTIONS(5493),
    [anon_sym_COMMA] = ACTIONS(5490),
    [anon_sym_u8] = ACTIONS(3562),
    [anon_sym_i8] = ACTIONS(3562),
    [anon_sym_u16] = ACTIONS(3562),
    [anon_sym_i16] = ACTIONS(3562),
    [anon_sym_u32] = ACTIONS(3562),
    [anon_sym_i32] = ACTIONS(3562),
    [anon_sym_u64] = ACTIONS(3562),
    [anon_sym_i64] = ACTIONS(3562),
    [anon_sym_u128] = ACTIONS(3562),
    [anon_sym_i128] = ACTIONS(3562),
    [anon_sym_isize] = ACTIONS(3562),
    [anon_sym_usize] = ACTIONS(3562),
    [anon_sym_f32] = ACTIONS(3562),
    [anon_sym_f64] = ACTIONS(3562),
    [anon_sym_bool] = ACTIONS(3562),
    [anon_sym_str] = ACTIONS(3562),
    [anon_sym_char] = ACTIONS(3562),
    [anon_sym__] = ACTIONS(3562),
    [anon_sym_AMP] = ACTIONS(5493),
    [anon_sym_DASH] = ACTIONS(5493),
    [anon_sym_DOT] = ACTIONS(5493),
    [anon_sym_DASH_EQ] = ACTIONS(5490),
    [anon_sym_DASH_GT] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_BANG] = ACTIONS(3562),
    [anon_sym_BANG_EQ] = ACTIONS(5490),
    [anon_sym_AT] = ACTIONS(3560),
    [anon_sym_STAR_EQ] = ACTIONS(5490),
    [anon_sym_SLASH] = ACTIONS(5493),
    [anon_sym_SLASH_EQ] = ACTIONS(5490),
    [anon_sym_AMP_AMP] = ACTIONS(5490),
    [anon_sym_AMP_EQ] = ACTIONS(5490),
    [anon_sym_POUND] = ACTIONS(3560),
    [anon_sym_PERCENT] = ACTIONS(5493),
    [anon_sym_PERCENT_EQ] = ACTIONS(5490),
    [anon_sym_CARET] = ACTIONS(5493),
    [anon_sym_CARET_EQ] = ACTIONS(5490),
    [anon_sym_PLUS_EQ] = ACTIONS(5490),
    [anon_sym_LT] = ACTIONS(5493),
    [anon_sym_LT_LT] = ACTIONS(5493),
    [anon_sym_LT_LT_EQ] = ACTIONS(5490),
    [anon_sym_LT_EQ] = ACTIONS(5490),
    [anon_sym_EQ] = ACTIONS(5493),
    [anon_sym_EQ_EQ] = ACTIONS(5490),
    [anon_sym_GT] = ACTIONS(5493),
    [anon_sym_GT_EQ] = ACTIONS(5490),
    [anon_sym_GT_GT] = ACTIONS(5493),
    [anon_sym_GT_GT_EQ] = ACTIONS(5490),
    [anon_sym_PIPE] = ACTIONS(5493),
    [anon_sym_PIPE_EQ] = ACTIONS(5490),
    [anon_sym_PIPE_PIPE] = ACTIONS(5490),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_QMARK] = ACTIONS(5490),
    [anon_sym_SQUOTE] = ACTIONS(3562),
    [anon_sym_DOT_DOT] = ACTIONS(5493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5490),
    [anon_sym_as] = ACTIONS(5493),
    [anon_sym_break] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_continue] = ACTIONS(3562),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_fn] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_impl] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_loop] = ACTIONS(3562),
    [anon_sym_match] = ACTIONS(3562),
    [anon_sym_mod] = ACTIONS(3562),
    [anon_sym_pub] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_trait] = ACTIONS(3562),
    [anon_sym_type] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [anon_sym_unsafe] = ACTIONS(3562),
    [anon_sym_use] = ACTIONS(3562),
    [anon_sym_where] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [sym_mutable_specifier] = ACTIONS(3562),
    [sym_integer_literal] = ACTIONS(3560),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3560),
    [sym_char_literal] = ACTIONS(3560),
    [anon_sym_true] = ACTIONS(3562),
    [anon_sym_false] = ACTIONS(3562),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3562),
    [sym_self] = ACTIONS(3562),
    [sym_super] = ACTIONS(3562),
    [sym_crate] = ACTIONS(3562),
    [sym_metavariable] = ACTIONS(3560),
  },
  [2480] = {
    [sym_arguments] = STATE(263),
    [aux_sym_token_tree_repeat2] = STATE(2976),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6568),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_COMMA] = ACTIONS(6570),
    [anon_sym_AMP] = ACTIONS(677),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(679),
    [anon_sym_BANG_EQ] = ACTIONS(681),
    [anon_sym_STAR_EQ] = ACTIONS(679),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_SLASH_EQ] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(683),
    [anon_sym_AMP_EQ] = ACTIONS(679),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_PERCENT_EQ] = ACTIONS(679),
    [anon_sym_CARET] = ACTIONS(685),
    [anon_sym_CARET_EQ] = ACTIONS(679),
    [anon_sym_PLUS_EQ] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_LT_LT] = ACTIONS(689),
    [anon_sym_LT_LT_EQ] = ACTIONS(679),
    [anon_sym_LT_EQ] = ACTIONS(681),
    [anon_sym_EQ] = ACTIONS(691),
    [anon_sym_EQ_EQ] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(689),
    [anon_sym_GT_GT_EQ] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(693),
    [anon_sym_PIPE_EQ] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(697),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(699),
    [anon_sym_as] = ACTIONS(701),
    [sym_line_comment] = ACTIONS(7),
  },
  [2481] = {
    [sym_raw_string_literal] = ACTIONS(5554),
    [sym_float_literal] = ACTIONS(5554),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5554),
    [anon_sym_LPAREN] = ACTIONS(6572),
    [anon_sym_RPAREN] = ACTIONS(6572),
    [anon_sym_LBRACE] = ACTIONS(5554),
    [anon_sym_EQ_GT] = ACTIONS(5554),
    [anon_sym_LBRACK] = ACTIONS(6572),
    [anon_sym_RBRACK] = ACTIONS(6572),
    [anon_sym_COLON] = ACTIONS(5556),
    [anon_sym_DOLLAR] = ACTIONS(5556),
    [anon_sym_PLUS] = ACTIONS(6575),
    [anon_sym_STAR] = ACTIONS(6575),
    [anon_sym_COMMA] = ACTIONS(6572),
    [anon_sym_u8] = ACTIONS(5556),
    [anon_sym_i8] = ACTIONS(5556),
    [anon_sym_u16] = ACTIONS(5556),
    [anon_sym_i16] = ACTIONS(5556),
    [anon_sym_u32] = ACTIONS(5556),
    [anon_sym_i32] = ACTIONS(5556),
    [anon_sym_u64] = ACTIONS(5556),
    [anon_sym_i64] = ACTIONS(5556),
    [anon_sym_u128] = ACTIONS(5556),
    [anon_sym_i128] = ACTIONS(5556),
    [anon_sym_isize] = ACTIONS(5556),
    [anon_sym_usize] = ACTIONS(5556),
    [anon_sym_f32] = ACTIONS(5556),
    [anon_sym_f64] = ACTIONS(5556),
    [anon_sym_bool] = ACTIONS(5556),
    [anon_sym_str] = ACTIONS(5556),
    [anon_sym_char] = ACTIONS(5556),
    [anon_sym__] = ACTIONS(5556),
    [anon_sym_AMP] = ACTIONS(6575),
    [anon_sym_DASH] = ACTIONS(6575),
    [anon_sym_DOT] = ACTIONS(6575),
    [anon_sym_DASH_EQ] = ACTIONS(6572),
    [anon_sym_DASH_GT] = ACTIONS(5554),
    [anon_sym_COLON_COLON] = ACTIONS(5554),
    [anon_sym_BANG] = ACTIONS(5556),
    [anon_sym_BANG_EQ] = ACTIONS(6572),
    [anon_sym_AT] = ACTIONS(5554),
    [anon_sym_STAR_EQ] = ACTIONS(6572),
    [anon_sym_SLASH] = ACTIONS(6575),
    [anon_sym_SLASH_EQ] = ACTIONS(6572),
    [anon_sym_AMP_AMP] = ACTIONS(6572),
    [anon_sym_AMP_EQ] = ACTIONS(6572),
    [anon_sym_POUND] = ACTIONS(5554),
    [anon_sym_PERCENT] = ACTIONS(6575),
    [anon_sym_PERCENT_EQ] = ACTIONS(6572),
    [anon_sym_CARET] = ACTIONS(6575),
    [anon_sym_CARET_EQ] = ACTIONS(6572),
    [anon_sym_PLUS_EQ] = ACTIONS(6572),
    [anon_sym_LT] = ACTIONS(6575),
    [anon_sym_LT_LT] = ACTIONS(6575),
    [anon_sym_LT_LT_EQ] = ACTIONS(6572),
    [anon_sym_LT_EQ] = ACTIONS(6572),
    [anon_sym_EQ] = ACTIONS(6575),
    [anon_sym_EQ_EQ] = ACTIONS(6572),
    [anon_sym_GT] = ACTIONS(6575),
    [anon_sym_GT_EQ] = ACTIONS(6572),
    [anon_sym_GT_GT] = ACTIONS(6575),
    [anon_sym_GT_GT_EQ] = ACTIONS(6572),
    [anon_sym_PIPE] = ACTIONS(6575),
    [anon_sym_PIPE_EQ] = ACTIONS(6572),
    [anon_sym_PIPE_PIPE] = ACTIONS(6572),
    [anon_sym_TILDE] = ACTIONS(5554),
    [anon_sym_QMARK] = ACTIONS(6572),
    [anon_sym_SQUOTE] = ACTIONS(5556),
    [anon_sym_DOT_DOT] = ACTIONS(6575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6572),
    [anon_sym_as] = ACTIONS(6575),
    [anon_sym_break] = ACTIONS(5556),
    [anon_sym_const] = ACTIONS(5556),
    [anon_sym_continue] = ACTIONS(5556),
    [anon_sym_default] = ACTIONS(5556),
    [anon_sym_enum] = ACTIONS(5556),
    [anon_sym_fn] = ACTIONS(5556),
    [anon_sym_for] = ACTIONS(5556),
    [anon_sym_if] = ACTIONS(5556),
    [anon_sym_impl] = ACTIONS(5556),
    [anon_sym_let] = ACTIONS(5556),
    [anon_sym_loop] = ACTIONS(5556),
    [anon_sym_match] = ACTIONS(5556),
    [anon_sym_mod] = ACTIONS(5556),
    [anon_sym_pub] = ACTIONS(5556),
    [anon_sym_return] = ACTIONS(5556),
    [anon_sym_static] = ACTIONS(5556),
    [anon_sym_struct] = ACTIONS(5556),
    [anon_sym_trait] = ACTIONS(5556),
    [anon_sym_type] = ACTIONS(5556),
    [anon_sym_union] = ACTIONS(5556),
    [anon_sym_unsafe] = ACTIONS(5556),
    [anon_sym_use] = ACTIONS(5556),
    [anon_sym_where] = ACTIONS(5556),
    [anon_sym_while] = ACTIONS(5556),
    [sym_mutable_specifier] = ACTIONS(5556),
    [sym_integer_literal] = ACTIONS(5554),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5554),
    [sym_char_literal] = ACTIONS(5554),
    [anon_sym_true] = ACTIONS(5556),
    [anon_sym_false] = ACTIONS(5556),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5556),
    [sym_self] = ACTIONS(5556),
    [sym_super] = ACTIONS(5556),
    [sym_crate] = ACTIONS(5556),
    [sym_metavariable] = ACTIONS(5554),
  },
  [2482] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(769),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(769),
    [sym_macro_invocation] = STATE(769),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(769),
    [sym_unary_expression] = STATE(769),
    [sym_try_expression] = STATE(769),
    [sym_reference_expression] = STATE(769),
    [sym_binary_expression] = STATE(769),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(769),
    [sym_call_expression] = STATE(769),
    [sym_array_expression] = STATE(769),
    [sym_parenthesized_expression] = STATE(769),
    [sym_tuple_expression] = STATE(769),
    [sym_unit_expression] = STATE(769),
    [sym_struct_expression] = STATE(769),
    [sym_if_expression] = STATE(769),
    [sym_if_let_expression] = STATE(769),
    [sym_match_expression] = STATE(769),
    [sym_while_expression] = STATE(769),
    [sym_while_let_expression] = STATE(769),
    [sym_loop_expression] = STATE(769),
    [sym_for_expression] = STATE(769),
    [sym_closure_expression] = STATE(769),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(769),
    [sym_continue_expression] = STATE(769),
    [sym_index_expression] = STATE(769),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(769),
    [sym_block] = STATE(769),
    [sym__literal] = STATE(769),
    [sym_string_literal] = STATE(769),
    [sym_boolean_literal] = STATE(769),
    [sym_raw_string_literal] = ACTIONS(1620),
    [sym_float_literal] = ACTIONS(1620),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_RBRACK] = ACTIONS(6578),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1620),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1620),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2483] = {
    [aux_sym_token_tree_repeat2] = STATE(789),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACK] = ACTIONS(6578),
    [anon_sym_COMMA] = ACTIONS(6580),
    [sym_line_comment] = ACTIONS(7),
  },
  [2484] = {
    [sym_block_comment] = ACTIONS(7),
    [aux_sym_SLASH_LBRACK_CARET_PLUS_STAR_RBRACK_PLUS_SLASH] = ACTIONS(6582),
    [anon_sym_PLUS] = ACTIONS(6584),
    [anon_sym_STAR] = ACTIONS(6584),
    [sym_line_comment] = ACTIONS(401),
  },
  [2485] = {
    [sym_token_tree] = STATE(1878),
    [sym_token_repetition] = STATE(1878),
    [sym__literal] = STATE(1878),
    [sym_string_literal] = STATE(1878),
    [sym_boolean_literal] = STATE(1878),
    [aux_sym_token_tree_repeat1] = STATE(1878),
    [sym_raw_string_literal] = ACTIONS(3960),
    [sym_float_literal] = ACTIONS(3960),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_RPAREN] = ACTIONS(6586),
    [anon_sym_LBRACE] = ACTIONS(3966),
    [anon_sym_EQ_GT] = ACTIONS(3960),
    [anon_sym_LBRACK] = ACTIONS(3968),
    [anon_sym_COLON] = ACTIONS(3970),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(3970),
    [anon_sym_STAR] = ACTIONS(3970),
    [anon_sym_COMMA] = ACTIONS(3960),
    [anon_sym_u8] = ACTIONS(3972),
    [anon_sym_i8] = ACTIONS(3972),
    [anon_sym_u16] = ACTIONS(3972),
    [anon_sym_i16] = ACTIONS(3972),
    [anon_sym_u32] = ACTIONS(3972),
    [anon_sym_i32] = ACTIONS(3972),
    [anon_sym_u64] = ACTIONS(3972),
    [anon_sym_i64] = ACTIONS(3972),
    [anon_sym_u128] = ACTIONS(3972),
    [anon_sym_i128] = ACTIONS(3972),
    [anon_sym_isize] = ACTIONS(3972),
    [anon_sym_usize] = ACTIONS(3972),
    [anon_sym_f32] = ACTIONS(3972),
    [anon_sym_f64] = ACTIONS(3972),
    [anon_sym_bool] = ACTIONS(3972),
    [anon_sym_str] = ACTIONS(3972),
    [anon_sym_char] = ACTIONS(3972),
    [anon_sym__] = ACTIONS(3970),
    [anon_sym_AMP] = ACTIONS(3970),
    [anon_sym_DASH] = ACTIONS(3970),
    [anon_sym_DOT] = ACTIONS(3970),
    [anon_sym_DASH_EQ] = ACTIONS(3960),
    [anon_sym_DASH_GT] = ACTIONS(3960),
    [anon_sym_COLON_COLON] = ACTIONS(3960),
    [anon_sym_BANG] = ACTIONS(3970),
    [anon_sym_BANG_EQ] = ACTIONS(3960),
    [anon_sym_AT] = ACTIONS(3960),
    [anon_sym_STAR_EQ] = ACTIONS(3960),
    [anon_sym_SLASH] = ACTIONS(3970),
    [anon_sym_SLASH_EQ] = ACTIONS(3960),
    [anon_sym_AMP_AMP] = ACTIONS(3960),
    [anon_sym_AMP_EQ] = ACTIONS(3960),
    [anon_sym_POUND] = ACTIONS(3960),
    [anon_sym_PERCENT] = ACTIONS(3970),
    [anon_sym_PERCENT_EQ] = ACTIONS(3960),
    [anon_sym_CARET] = ACTIONS(3970),
    [anon_sym_CARET_EQ] = ACTIONS(3960),
    [anon_sym_PLUS_EQ] = ACTIONS(3960),
    [anon_sym_LT] = ACTIONS(3970),
    [anon_sym_LT_LT] = ACTIONS(3970),
    [anon_sym_LT_LT_EQ] = ACTIONS(3960),
    [anon_sym_LT_EQ] = ACTIONS(3960),
    [anon_sym_EQ] = ACTIONS(3970),
    [anon_sym_EQ_EQ] = ACTIONS(3960),
    [anon_sym_GT] = ACTIONS(3970),
    [anon_sym_GT_EQ] = ACTIONS(3960),
    [anon_sym_GT_GT] = ACTIONS(3970),
    [anon_sym_GT_GT_EQ] = ACTIONS(3960),
    [anon_sym_PIPE] = ACTIONS(3970),
    [anon_sym_PIPE_EQ] = ACTIONS(3960),
    [anon_sym_PIPE_PIPE] = ACTIONS(3960),
    [anon_sym_TILDE] = ACTIONS(3960),
    [anon_sym_QMARK] = ACTIONS(3960),
    [anon_sym_SQUOTE] = ACTIONS(3970),
    [anon_sym_DOT_DOT] = ACTIONS(3970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3960),
    [anon_sym_as] = ACTIONS(3970),
    [anon_sym_break] = ACTIONS(3970),
    [anon_sym_const] = ACTIONS(3970),
    [anon_sym_continue] = ACTIONS(3970),
    [anon_sym_default] = ACTIONS(3970),
    [anon_sym_enum] = ACTIONS(3970),
    [anon_sym_fn] = ACTIONS(3970),
    [anon_sym_for] = ACTIONS(3970),
    [anon_sym_if] = ACTIONS(3970),
    [anon_sym_impl] = ACTIONS(3970),
    [anon_sym_let] = ACTIONS(3970),
    [anon_sym_loop] = ACTIONS(3970),
    [anon_sym_match] = ACTIONS(3970),
    [anon_sym_mod] = ACTIONS(3970),
    [anon_sym_pub] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3970),
    [anon_sym_static] = ACTIONS(3970),
    [anon_sym_struct] = ACTIONS(3970),
    [anon_sym_trait] = ACTIONS(3970),
    [anon_sym_type] = ACTIONS(3970),
    [anon_sym_union] = ACTIONS(3970),
    [anon_sym_unsafe] = ACTIONS(3970),
    [anon_sym_use] = ACTIONS(3970),
    [anon_sym_where] = ACTIONS(3970),
    [anon_sym_while] = ACTIONS(3970),
    [sym_mutable_specifier] = ACTIONS(3970),
    [sym_integer_literal] = ACTIONS(3960),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(3960),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3970),
    [sym_self] = ACTIONS(3970),
    [sym_super] = ACTIONS(3970),
    [sym_crate] = ACTIONS(3970),
    [sym_metavariable] = ACTIONS(3960),
  },
  [2486] = {
    [sym_raw_string_literal] = ACTIONS(2222),
    [sym_float_literal] = ACTIONS(2222),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2222),
    [anon_sym_LPAREN] = ACTIONS(2222),
    [anon_sym_RPAREN] = ACTIONS(2222),
    [anon_sym_LBRACE] = ACTIONS(2222),
    [anon_sym_RBRACE] = ACTIONS(2222),
    [anon_sym_EQ_GT] = ACTIONS(2222),
    [anon_sym_LBRACK] = ACTIONS(2222),
    [anon_sym_RBRACK] = ACTIONS(2222),
    [anon_sym_COLON] = ACTIONS(2224),
    [anon_sym_DOLLAR] = ACTIONS(2224),
    [anon_sym_PLUS] = ACTIONS(2224),
    [anon_sym_STAR] = ACTIONS(2224),
    [anon_sym_COMMA] = ACTIONS(2222),
    [anon_sym_u8] = ACTIONS(2224),
    [anon_sym_i8] = ACTIONS(2224),
    [anon_sym_u16] = ACTIONS(2224),
    [anon_sym_i16] = ACTIONS(2224),
    [anon_sym_u32] = ACTIONS(2224),
    [anon_sym_i32] = ACTIONS(2224),
    [anon_sym_u64] = ACTIONS(2224),
    [anon_sym_i64] = ACTIONS(2224),
    [anon_sym_u128] = ACTIONS(2224),
    [anon_sym_i128] = ACTIONS(2224),
    [anon_sym_isize] = ACTIONS(2224),
    [anon_sym_usize] = ACTIONS(2224),
    [anon_sym_f32] = ACTIONS(2224),
    [anon_sym_f64] = ACTIONS(2224),
    [anon_sym_bool] = ACTIONS(2224),
    [anon_sym_str] = ACTIONS(2224),
    [anon_sym_char] = ACTIONS(2224),
    [anon_sym__] = ACTIONS(2224),
    [anon_sym_AMP] = ACTIONS(2224),
    [anon_sym_DASH] = ACTIONS(2224),
    [anon_sym_DOT] = ACTIONS(2224),
    [anon_sym_DASH_EQ] = ACTIONS(2222),
    [anon_sym_DASH_GT] = ACTIONS(2222),
    [anon_sym_COLON_COLON] = ACTIONS(2222),
    [anon_sym_BANG] = ACTIONS(2224),
    [anon_sym_BANG_EQ] = ACTIONS(2222),
    [anon_sym_AT] = ACTIONS(2222),
    [anon_sym_STAR_EQ] = ACTIONS(2222),
    [anon_sym_SLASH] = ACTIONS(2224),
    [anon_sym_SLASH_EQ] = ACTIONS(2222),
    [anon_sym_AMP_AMP] = ACTIONS(2222),
    [anon_sym_AMP_EQ] = ACTIONS(2222),
    [anon_sym_POUND] = ACTIONS(2222),
    [anon_sym_PERCENT] = ACTIONS(2224),
    [anon_sym_PERCENT_EQ] = ACTIONS(2222),
    [anon_sym_CARET] = ACTIONS(2224),
    [anon_sym_CARET_EQ] = ACTIONS(2222),
    [anon_sym_PLUS_EQ] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(2224),
    [anon_sym_LT_LT] = ACTIONS(2224),
    [anon_sym_LT_LT_EQ] = ACTIONS(2222),
    [anon_sym_LT_EQ] = ACTIONS(2222),
    [anon_sym_EQ] = ACTIONS(2224),
    [anon_sym_EQ_EQ] = ACTIONS(2222),
    [anon_sym_GT] = ACTIONS(2224),
    [anon_sym_GT_EQ] = ACTIONS(2222),
    [anon_sym_GT_GT] = ACTIONS(2224),
    [anon_sym_GT_GT_EQ] = ACTIONS(2222),
    [anon_sym_PIPE] = ACTIONS(2224),
    [anon_sym_PIPE_EQ] = ACTIONS(2222),
    [anon_sym_PIPE_PIPE] = ACTIONS(2222),
    [anon_sym_TILDE] = ACTIONS(2222),
    [anon_sym_QMARK] = ACTIONS(2222),
    [anon_sym_SQUOTE] = ACTIONS(2224),
    [anon_sym_DOT_DOT] = ACTIONS(2224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2222),
    [anon_sym_as] = ACTIONS(2224),
    [anon_sym_break] = ACTIONS(2224),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_continue] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2224),
    [anon_sym_enum] = ACTIONS(2224),
    [anon_sym_fn] = ACTIONS(2224),
    [anon_sym_for] = ACTIONS(2224),
    [anon_sym_if] = ACTIONS(2224),
    [anon_sym_impl] = ACTIONS(2224),
    [anon_sym_let] = ACTIONS(2224),
    [anon_sym_loop] = ACTIONS(2224),
    [anon_sym_match] = ACTIONS(2224),
    [anon_sym_mod] = ACTIONS(2224),
    [anon_sym_pub] = ACTIONS(2224),
    [anon_sym_return] = ACTIONS(2224),
    [anon_sym_static] = ACTIONS(2224),
    [anon_sym_struct] = ACTIONS(2224),
    [anon_sym_trait] = ACTIONS(2224),
    [anon_sym_type] = ACTIONS(2224),
    [anon_sym_union] = ACTIONS(2224),
    [anon_sym_unsafe] = ACTIONS(2224),
    [anon_sym_use] = ACTIONS(2224),
    [anon_sym_where] = ACTIONS(2224),
    [anon_sym_while] = ACTIONS(2224),
    [sym_mutable_specifier] = ACTIONS(2224),
    [sym_integer_literal] = ACTIONS(2222),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2222),
    [sym_char_literal] = ACTIONS(2222),
    [anon_sym_true] = ACTIONS(2224),
    [anon_sym_false] = ACTIONS(2224),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2224),
    [sym_self] = ACTIONS(2224),
    [sym_super] = ACTIONS(2224),
    [sym_crate] = ACTIONS(2224),
    [sym_metavariable] = ACTIONS(2222),
  },
  [2487] = {
    [sym_raw_string_literal] = ACTIONS(6588),
    [sym_float_literal] = ACTIONS(6588),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(6588),
    [anon_sym_SEMI] = ACTIONS(6588),
    [anon_sym_macro_rules_BANG] = ACTIONS(6588),
    [anon_sym_LPAREN] = ACTIONS(6588),
    [anon_sym_LBRACE] = ACTIONS(6588),
    [anon_sym_RBRACE] = ACTIONS(6588),
    [anon_sym_LBRACK] = ACTIONS(6588),
    [anon_sym_PLUS] = ACTIONS(6590),
    [anon_sym_STAR] = ACTIONS(6590),
    [anon_sym_u8] = ACTIONS(6590),
    [anon_sym_i8] = ACTIONS(6590),
    [anon_sym_u16] = ACTIONS(6590),
    [anon_sym_i16] = ACTIONS(6590),
    [anon_sym_u32] = ACTIONS(6590),
    [anon_sym_i32] = ACTIONS(6590),
    [anon_sym_u64] = ACTIONS(6590),
    [anon_sym_i64] = ACTIONS(6590),
    [anon_sym_u128] = ACTIONS(6590),
    [anon_sym_i128] = ACTIONS(6590),
    [anon_sym_isize] = ACTIONS(6590),
    [anon_sym_usize] = ACTIONS(6590),
    [anon_sym_f32] = ACTIONS(6590),
    [anon_sym_f64] = ACTIONS(6590),
    [anon_sym_bool] = ACTIONS(6590),
    [anon_sym_str] = ACTIONS(6590),
    [anon_sym_char] = ACTIONS(6590),
    [anon_sym_AMP] = ACTIONS(6590),
    [anon_sym_DASH] = ACTIONS(6590),
    [anon_sym_DOT] = ACTIONS(6590),
    [anon_sym_DASH_EQ] = ACTIONS(6588),
    [anon_sym_COLON_COLON] = ACTIONS(6588),
    [anon_sym_BANG] = ACTIONS(6590),
    [anon_sym_BANG_EQ] = ACTIONS(6588),
    [anon_sym_STAR_EQ] = ACTIONS(6588),
    [anon_sym_SLASH] = ACTIONS(6590),
    [anon_sym_SLASH_EQ] = ACTIONS(6588),
    [anon_sym_AMP_AMP] = ACTIONS(6588),
    [anon_sym_AMP_EQ] = ACTIONS(6588),
    [anon_sym_POUND] = ACTIONS(6588),
    [anon_sym_PERCENT] = ACTIONS(6590),
    [anon_sym_PERCENT_EQ] = ACTIONS(6588),
    [anon_sym_CARET] = ACTIONS(6590),
    [anon_sym_CARET_EQ] = ACTIONS(6588),
    [anon_sym_PLUS_EQ] = ACTIONS(6588),
    [anon_sym_LT] = ACTIONS(6590),
    [anon_sym_LT_LT] = ACTIONS(6590),
    [anon_sym_LT_LT_EQ] = ACTIONS(6588),
    [anon_sym_LT_EQ] = ACTIONS(6588),
    [anon_sym_EQ] = ACTIONS(6590),
    [anon_sym_EQ_EQ] = ACTIONS(6588),
    [anon_sym_GT] = ACTIONS(6590),
    [anon_sym_GT_EQ] = ACTIONS(6588),
    [anon_sym_GT_GT] = ACTIONS(6590),
    [anon_sym_GT_GT_EQ] = ACTIONS(6588),
    [anon_sym_PIPE] = ACTIONS(6590),
    [anon_sym_PIPE_EQ] = ACTIONS(6588),
    [anon_sym_PIPE_PIPE] = ACTIONS(6588),
    [anon_sym_QMARK] = ACTIONS(6588),
    [anon_sym_SQUOTE] = ACTIONS(6590),
    [anon_sym_DOT_DOT] = ACTIONS(6590),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6588),
    [anon_sym_as] = ACTIONS(6590),
    [anon_sym_break] = ACTIONS(6590),
    [anon_sym_const] = ACTIONS(6590),
    [anon_sym_continue] = ACTIONS(6590),
    [anon_sym_default] = ACTIONS(6590),
    [anon_sym_enum] = ACTIONS(6590),
    [anon_sym_fn] = ACTIONS(6590),
    [anon_sym_for] = ACTIONS(6590),
    [anon_sym_if] = ACTIONS(6590),
    [anon_sym_impl] = ACTIONS(6590),
    [anon_sym_let] = ACTIONS(6590),
    [anon_sym_loop] = ACTIONS(6590),
    [anon_sym_match] = ACTIONS(6590),
    [anon_sym_mod] = ACTIONS(6590),
    [anon_sym_pub] = ACTIONS(6590),
    [anon_sym_return] = ACTIONS(6590),
    [anon_sym_static] = ACTIONS(6590),
    [anon_sym_struct] = ACTIONS(6590),
    [anon_sym_trait] = ACTIONS(6590),
    [anon_sym_type] = ACTIONS(6590),
    [anon_sym_union] = ACTIONS(6590),
    [anon_sym_unsafe] = ACTIONS(6590),
    [anon_sym_use] = ACTIONS(6590),
    [anon_sym_while] = ACTIONS(6590),
    [anon_sym_extern] = ACTIONS(6590),
    [anon_sym_move] = ACTIONS(6590),
    [sym_integer_literal] = ACTIONS(6588),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6588),
    [sym_char_literal] = ACTIONS(6588),
    [anon_sym_true] = ACTIONS(6590),
    [anon_sym_false] = ACTIONS(6590),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6590),
    [sym_self] = ACTIONS(6590),
    [sym_super] = ACTIONS(6590),
    [sym_crate] = ACTIONS(6590),
    [sym_metavariable] = ACTIONS(6588),
  },
  [2488] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1972),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1972),
    [sym_unary_expression] = STATE(1972),
    [sym_try_expression] = STATE(1972),
    [sym_reference_expression] = STATE(1972),
    [sym_binary_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1972),
    [sym_call_expression] = STATE(1972),
    [sym_array_expression] = STATE(1972),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_tuple_expression] = STATE(1972),
    [sym_unit_expression] = STATE(1972),
    [sym_struct_expression] = STATE(1972),
    [sym_if_expression] = STATE(1972),
    [sym_if_let_expression] = STATE(1972),
    [sym_match_expression] = STATE(1972),
    [sym_while_expression] = STATE(1972),
    [sym_while_let_expression] = STATE(1972),
    [sym_loop_expression] = STATE(1972),
    [sym_for_expression] = STATE(1972),
    [sym_closure_expression] = STATE(1972),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1972),
    [sym_continue_expression] = STATE(1972),
    [sym_index_expression] = STATE(1972),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1972),
    [sym_block] = STATE(1972),
    [sym__literal] = STATE(1972),
    [sym_string_literal] = STATE(1972),
    [sym_boolean_literal] = STATE(1972),
    [sym_raw_string_literal] = ACTIONS(4375),
    [sym_float_literal] = ACTIONS(4375),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(6592),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(4375),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4375),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2489] = {
    [sym_raw_string_literal] = ACTIONS(3560),
    [sym_float_literal] = ACTIONS(3560),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym_LPAREN] = ACTIONS(3560),
    [anon_sym_RPAREN] = ACTIONS(3560),
    [anon_sym_LBRACE] = ACTIONS(3560),
    [anon_sym_RBRACE] = ACTIONS(3560),
    [anon_sym_EQ_GT] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(3560),
    [anon_sym_RBRACK] = ACTIONS(3560),
    [anon_sym_COLON] = ACTIONS(3562),
    [anon_sym_DOLLAR] = ACTIONS(3562),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3562),
    [anon_sym_COMMA] = ACTIONS(3560),
    [anon_sym_u8] = ACTIONS(3562),
    [anon_sym_i8] = ACTIONS(3562),
    [anon_sym_u16] = ACTIONS(3562),
    [anon_sym_i16] = ACTIONS(3562),
    [anon_sym_u32] = ACTIONS(3562),
    [anon_sym_i32] = ACTIONS(3562),
    [anon_sym_u64] = ACTIONS(3562),
    [anon_sym_i64] = ACTIONS(3562),
    [anon_sym_u128] = ACTIONS(3562),
    [anon_sym_i128] = ACTIONS(3562),
    [anon_sym_isize] = ACTIONS(3562),
    [anon_sym_usize] = ACTIONS(3562),
    [anon_sym_f32] = ACTIONS(3562),
    [anon_sym_f64] = ACTIONS(3562),
    [anon_sym_bool] = ACTIONS(3562),
    [anon_sym_str] = ACTIONS(3562),
    [anon_sym_char] = ACTIONS(3562),
    [anon_sym__] = ACTIONS(3562),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_DOT] = ACTIONS(3562),
    [anon_sym_DASH_EQ] = ACTIONS(3560),
    [anon_sym_DASH_GT] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(3560),
    [anon_sym_BANG] = ACTIONS(3562),
    [anon_sym_BANG_EQ] = ACTIONS(3560),
    [anon_sym_AT] = ACTIONS(3560),
    [anon_sym_STAR_EQ] = ACTIONS(3560),
    [anon_sym_SLASH] = ACTIONS(3562),
    [anon_sym_SLASH_EQ] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_AMP_EQ] = ACTIONS(3560),
    [anon_sym_POUND] = ACTIONS(3560),
    [anon_sym_PERCENT] = ACTIONS(3562),
    [anon_sym_PERCENT_EQ] = ACTIONS(3560),
    [anon_sym_CARET] = ACTIONS(3562),
    [anon_sym_CARET_EQ] = ACTIONS(3560),
    [anon_sym_PLUS_EQ] = ACTIONS(3560),
    [anon_sym_LT] = ACTIONS(3562),
    [anon_sym_LT_LT] = ACTIONS(3562),
    [anon_sym_LT_LT_EQ] = ACTIONS(3560),
    [anon_sym_LT_EQ] = ACTIONS(3560),
    [anon_sym_EQ] = ACTIONS(3562),
    [anon_sym_EQ_EQ] = ACTIONS(3560),
    [anon_sym_GT] = ACTIONS(3562),
    [anon_sym_GT_EQ] = ACTIONS(3560),
    [anon_sym_GT_GT] = ACTIONS(3562),
    [anon_sym_GT_GT_EQ] = ACTIONS(3560),
    [anon_sym_PIPE] = ACTIONS(3562),
    [anon_sym_PIPE_EQ] = ACTIONS(3560),
    [anon_sym_PIPE_PIPE] = ACTIONS(3560),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_QMARK] = ACTIONS(3560),
    [anon_sym_SQUOTE] = ACTIONS(3562),
    [anon_sym_DOT_DOT] = ACTIONS(3562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3560),
    [anon_sym_as] = ACTIONS(3562),
    [anon_sym_break] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_continue] = ACTIONS(3562),
    [anon_sym_default] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_fn] = ACTIONS(3562),
    [anon_sym_for] = ACTIONS(3562),
    [anon_sym_if] = ACTIONS(3562),
    [anon_sym_impl] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_loop] = ACTIONS(3562),
    [anon_sym_match] = ACTIONS(3562),
    [anon_sym_mod] = ACTIONS(3562),
    [anon_sym_pub] = ACTIONS(3562),
    [anon_sym_return] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_trait] = ACTIONS(3562),
    [anon_sym_type] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3562),
    [anon_sym_unsafe] = ACTIONS(3562),
    [anon_sym_use] = ACTIONS(3562),
    [anon_sym_where] = ACTIONS(3562),
    [anon_sym_while] = ACTIONS(3562),
    [sym_mutable_specifier] = ACTIONS(3562),
    [sym_integer_literal] = ACTIONS(3560),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3560),
    [sym_char_literal] = ACTIONS(3560),
    [anon_sym_true] = ACTIONS(3562),
    [anon_sym_false] = ACTIONS(3562),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3562),
    [sym_self] = ACTIONS(3562),
    [sym_super] = ACTIONS(3562),
    [sym_crate] = ACTIONS(3562),
    [sym_metavariable] = ACTIONS(3560),
  },
  [2490] = {
    [sym_arguments] = STATE(263),
    [aux_sym_token_tree_repeat2] = STATE(2470),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(6594),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(6596),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_BANG_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH] = ACTIONS(563),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(563),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_LT] = ACTIONS(577),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(581),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(577),
    [anon_sym_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(589),
    [anon_sym_as] = ACTIONS(591),
    [sym_line_comment] = ACTIONS(7),
  },
  [2491] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(6594),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(623),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(623),
    [anon_sym_PLUS_EQ] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(623),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(643),
    [anon_sym_as] = ACTIONS(645),
    [sym_line_comment] = ACTIONS(7),
  },
  [2492] = {
    [sym__statement] = STATE(332),
    [sym_empty_statement] = STATE(332),
    [sym__expression_statement] = STATE(332),
    [sym_macro_definition] = STATE(332),
    [sym_attribute_item] = STATE(332),
    [sym_inner_attribute_item] = STATE(332),
    [sym_mod_item] = STATE(332),
    [sym_foreign_mod_item] = STATE(332),
    [sym_struct_item] = STATE(332),
    [sym_union_item] = STATE(332),
    [sym_enum_item] = STATE(332),
    [sym_extern_crate_declaration] = STATE(332),
    [sym_const_item] = STATE(332),
    [sym_static_item] = STATE(332),
    [sym_type_item] = STATE(332),
    [sym_function_item] = STATE(332),
    [sym_function_signature_item] = STATE(332),
    [sym_function_modifiers] = STATE(47),
    [sym_impl_item] = STATE(332),
    [sym_trait_item] = STATE(332),
    [sym_associated_type] = STATE(332),
    [sym_let_declaration] = STATE(332),
    [sym_use_declaration] = STATE(332),
    [sym_extern_modifier] = STATE(48),
    [sym_visibility_modifier] = STATE(49),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2985),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2985),
    [sym_macro_invocation] = STATE(53),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2985),
    [sym_unary_expression] = STATE(2985),
    [sym_try_expression] = STATE(2985),
    [sym_reference_expression] = STATE(2985),
    [sym_binary_expression] = STATE(2985),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2985),
    [sym_call_expression] = STATE(2985),
    [sym_array_expression] = STATE(2985),
    [sym_parenthesized_expression] = STATE(2985),
    [sym_tuple_expression] = STATE(2985),
    [sym_unit_expression] = STATE(2985),
    [sym_struct_expression] = STATE(2985),
    [sym_if_expression] = STATE(57),
    [sym_if_let_expression] = STATE(57),
    [sym_match_expression] = STATE(57),
    [sym_while_expression] = STATE(57),
    [sym_while_let_expression] = STATE(57),
    [sym_loop_expression] = STATE(57),
    [sym_for_expression] = STATE(57),
    [sym_closure_expression] = STATE(2985),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(59),
    [sym_break_expression] = STATE(2985),
    [sym_continue_expression] = STATE(2985),
    [sym_index_expression] = STATE(2985),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(57),
    [sym_block] = STATE(57),
    [sym__literal] = STATE(2985),
    [sym_string_literal] = STATE(2985),
    [sym_boolean_literal] = STATE(2985),
    [aux_sym_source_file_repeat1] = STATE(332),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_raw_string_literal] = ACTIONS(6598),
    [sym_float_literal] = ACTIONS(6598),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(6594),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_POUND] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(6598),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6598),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(93),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2493] = {
    [sym_arguments] = STATE(263),
    [aux_sym_token_tree_repeat2] = STATE(2987),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6594),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_STAR] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(6600),
    [anon_sym_AMP] = ACTIONS(2821),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2823),
    [anon_sym_BANG_EQ] = ACTIONS(2825),
    [anon_sym_STAR_EQ] = ACTIONS(2823),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_SLASH_EQ] = ACTIONS(2823),
    [anon_sym_AMP_AMP] = ACTIONS(2827),
    [anon_sym_AMP_EQ] = ACTIONS(2823),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_PERCENT_EQ] = ACTIONS(2823),
    [anon_sym_CARET] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2823),
    [anon_sym_PLUS_EQ] = ACTIONS(2823),
    [anon_sym_LT] = ACTIONS(2831),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_LT_LT_EQ] = ACTIONS(2823),
    [anon_sym_LT_EQ] = ACTIONS(2825),
    [anon_sym_EQ] = ACTIONS(2835),
    [anon_sym_EQ_EQ] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2831),
    [anon_sym_GT_EQ] = ACTIONS(2825),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_GT_GT_EQ] = ACTIONS(2823),
    [anon_sym_PIPE] = ACTIONS(2837),
    [anon_sym_PIPE_EQ] = ACTIONS(2823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2839),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(2841),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2843),
    [anon_sym_as] = ACTIONS(2845),
    [sym_line_comment] = ACTIONS(7),
  },
  [2494] = {
    [sym_raw_string_literal] = ACTIONS(5554),
    [sym_float_literal] = ACTIONS(5554),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6538),
    [anon_sym_LPAREN] = ACTIONS(6538),
    [anon_sym_LBRACE] = ACTIONS(5554),
    [anon_sym_RBRACE] = ACTIONS(6538),
    [anon_sym_EQ_GT] = ACTIONS(5554),
    [anon_sym_LBRACK] = ACTIONS(6538),
    [anon_sym_COLON] = ACTIONS(5556),
    [anon_sym_DOLLAR] = ACTIONS(5556),
    [anon_sym_PLUS] = ACTIONS(6541),
    [anon_sym_STAR] = ACTIONS(6541),
    [anon_sym_COMMA] = ACTIONS(5554),
    [anon_sym_u8] = ACTIONS(5556),
    [anon_sym_i8] = ACTIONS(5556),
    [anon_sym_u16] = ACTIONS(5556),
    [anon_sym_i16] = ACTIONS(5556),
    [anon_sym_u32] = ACTIONS(5556),
    [anon_sym_i32] = ACTIONS(5556),
    [anon_sym_u64] = ACTIONS(5556),
    [anon_sym_i64] = ACTIONS(5556),
    [anon_sym_u128] = ACTIONS(5556),
    [anon_sym_i128] = ACTIONS(5556),
    [anon_sym_isize] = ACTIONS(5556),
    [anon_sym_usize] = ACTIONS(5556),
    [anon_sym_f32] = ACTIONS(5556),
    [anon_sym_f64] = ACTIONS(5556),
    [anon_sym_bool] = ACTIONS(5556),
    [anon_sym_str] = ACTIONS(5556),
    [anon_sym_char] = ACTIONS(5556),
    [anon_sym__] = ACTIONS(5556),
    [anon_sym_AMP] = ACTIONS(6541),
    [anon_sym_DASH] = ACTIONS(6541),
    [anon_sym_DOT] = ACTIONS(6541),
    [anon_sym_DASH_EQ] = ACTIONS(6538),
    [anon_sym_DASH_GT] = ACTIONS(5554),
    [anon_sym_COLON_COLON] = ACTIONS(5554),
    [anon_sym_BANG] = ACTIONS(5556),
    [anon_sym_BANG_EQ] = ACTIONS(6538),
    [anon_sym_AT] = ACTIONS(5554),
    [anon_sym_STAR_EQ] = ACTIONS(6538),
    [anon_sym_SLASH] = ACTIONS(6541),
    [anon_sym_SLASH_EQ] = ACTIONS(6538),
    [anon_sym_AMP_AMP] = ACTIONS(6538),
    [anon_sym_AMP_EQ] = ACTIONS(6538),
    [anon_sym_POUND] = ACTIONS(5554),
    [anon_sym_PERCENT] = ACTIONS(6541),
    [anon_sym_PERCENT_EQ] = ACTIONS(6538),
    [anon_sym_CARET] = ACTIONS(6541),
    [anon_sym_CARET_EQ] = ACTIONS(6538),
    [anon_sym_PLUS_EQ] = ACTIONS(6538),
    [anon_sym_LT] = ACTIONS(6541),
    [anon_sym_LT_LT] = ACTIONS(6541),
    [anon_sym_LT_LT_EQ] = ACTIONS(6538),
    [anon_sym_LT_EQ] = ACTIONS(6538),
    [anon_sym_EQ] = ACTIONS(6541),
    [anon_sym_EQ_EQ] = ACTIONS(6538),
    [anon_sym_GT] = ACTIONS(6541),
    [anon_sym_GT_EQ] = ACTIONS(6538),
    [anon_sym_GT_GT] = ACTIONS(6541),
    [anon_sym_GT_GT_EQ] = ACTIONS(6538),
    [anon_sym_PIPE] = ACTIONS(6541),
    [anon_sym_PIPE_EQ] = ACTIONS(6538),
    [anon_sym_PIPE_PIPE] = ACTIONS(6538),
    [anon_sym_TILDE] = ACTIONS(5554),
    [anon_sym_QMARK] = ACTIONS(6538),
    [anon_sym_SQUOTE] = ACTIONS(5556),
    [anon_sym_DOT_DOT] = ACTIONS(6541),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6538),
    [anon_sym_as] = ACTIONS(6541),
    [anon_sym_break] = ACTIONS(5556),
    [anon_sym_const] = ACTIONS(5556),
    [anon_sym_continue] = ACTIONS(5556),
    [anon_sym_default] = ACTIONS(5556),
    [anon_sym_enum] = ACTIONS(5556),
    [anon_sym_fn] = ACTIONS(5556),
    [anon_sym_for] = ACTIONS(5556),
    [anon_sym_if] = ACTIONS(5556),
    [anon_sym_impl] = ACTIONS(5556),
    [anon_sym_let] = ACTIONS(5556),
    [anon_sym_loop] = ACTIONS(5556),
    [anon_sym_match] = ACTIONS(5556),
    [anon_sym_mod] = ACTIONS(5556),
    [anon_sym_pub] = ACTIONS(5556),
    [anon_sym_return] = ACTIONS(5556),
    [anon_sym_static] = ACTIONS(5556),
    [anon_sym_struct] = ACTIONS(5556),
    [anon_sym_trait] = ACTIONS(5556),
    [anon_sym_type] = ACTIONS(5556),
    [anon_sym_union] = ACTIONS(5556),
    [anon_sym_unsafe] = ACTIONS(5556),
    [anon_sym_use] = ACTIONS(5556),
    [anon_sym_where] = ACTIONS(5556),
    [anon_sym_while] = ACTIONS(5556),
    [sym_mutable_specifier] = ACTIONS(5556),
    [sym_integer_literal] = ACTIONS(5554),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5554),
    [sym_char_literal] = ACTIONS(5554),
    [anon_sym_true] = ACTIONS(5556),
    [anon_sym_false] = ACTIONS(5556),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5556),
    [sym_self] = ACTIONS(5556),
    [sym_super] = ACTIONS(5556),
    [sym_crate] = ACTIONS(5556),
    [sym_metavariable] = ACTIONS(5554),
  },
  [2495] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2966),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2966),
    [sym_macro_invocation] = STATE(2966),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2966),
    [sym_unary_expression] = STATE(2966),
    [sym_try_expression] = STATE(2966),
    [sym_reference_expression] = STATE(2966),
    [sym_binary_expression] = STATE(2966),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2966),
    [sym_call_expression] = STATE(2966),
    [sym_array_expression] = STATE(2966),
    [sym_parenthesized_expression] = STATE(2966),
    [sym_tuple_expression] = STATE(2966),
    [sym_unit_expression] = STATE(2966),
    [sym_struct_expression] = STATE(2966),
    [sym_if_expression] = STATE(2966),
    [sym_if_let_expression] = STATE(2966),
    [sym_match_expression] = STATE(2966),
    [sym_while_expression] = STATE(2966),
    [sym_while_let_expression] = STATE(2966),
    [sym_loop_expression] = STATE(2966),
    [sym_for_expression] = STATE(2966),
    [sym_closure_expression] = STATE(2966),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2966),
    [sym_continue_expression] = STATE(2966),
    [sym_index_expression] = STATE(2966),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2966),
    [sym_block] = STATE(2966),
    [sym__literal] = STATE(2966),
    [sym_string_literal] = STATE(2966),
    [sym_boolean_literal] = STATE(2966),
    [aux_sym_tuple_expression_repeat1] = STATE(711),
    [sym_raw_string_literal] = ACTIONS(6544),
    [sym_float_literal] = ACTIONS(6544),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(6602),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(6544),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6544),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2496] = {
    [sym_raw_string_literal] = ACTIONS(6552),
    [sym_float_literal] = ACTIONS(6552),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6552),
    [anon_sym_macro_rules_BANG] = ACTIONS(1567),
    [anon_sym_LPAREN] = ACTIONS(6552),
    [anon_sym_LBRACE] = ACTIONS(6552),
    [anon_sym_RBRACE] = ACTIONS(6552),
    [anon_sym_EQ_GT] = ACTIONS(5554),
    [anon_sym_LBRACK] = ACTIONS(6552),
    [anon_sym_COLON] = ACTIONS(5556),
    [anon_sym_DOLLAR] = ACTIONS(5556),
    [anon_sym_PLUS] = ACTIONS(6555),
    [anon_sym_STAR] = ACTIONS(6555),
    [anon_sym_COMMA] = ACTIONS(5554),
    [anon_sym_u8] = ACTIONS(6555),
    [anon_sym_i8] = ACTIONS(6555),
    [anon_sym_u16] = ACTIONS(6555),
    [anon_sym_i16] = ACTIONS(6555),
    [anon_sym_u32] = ACTIONS(6555),
    [anon_sym_i32] = ACTIONS(6555),
    [anon_sym_u64] = ACTIONS(6555),
    [anon_sym_i64] = ACTIONS(6555),
    [anon_sym_u128] = ACTIONS(6555),
    [anon_sym_i128] = ACTIONS(6555),
    [anon_sym_isize] = ACTIONS(6555),
    [anon_sym_usize] = ACTIONS(6555),
    [anon_sym_f32] = ACTIONS(6555),
    [anon_sym_f64] = ACTIONS(6555),
    [anon_sym_bool] = ACTIONS(6555),
    [anon_sym_str] = ACTIONS(6555),
    [anon_sym_char] = ACTIONS(6555),
    [anon_sym__] = ACTIONS(5556),
    [anon_sym_AMP] = ACTIONS(6555),
    [anon_sym_DASH] = ACTIONS(6555),
    [anon_sym_DOT] = ACTIONS(6555),
    [anon_sym_DASH_EQ] = ACTIONS(6552),
    [anon_sym_DASH_GT] = ACTIONS(5554),
    [anon_sym_COLON_COLON] = ACTIONS(6552),
    [anon_sym_BANG] = ACTIONS(6555),
    [anon_sym_BANG_EQ] = ACTIONS(6552),
    [anon_sym_AT] = ACTIONS(5554),
    [anon_sym_STAR_EQ] = ACTIONS(6552),
    [anon_sym_SLASH] = ACTIONS(6555),
    [anon_sym_SLASH_EQ] = ACTIONS(6552),
    [anon_sym_AMP_AMP] = ACTIONS(6552),
    [anon_sym_AMP_EQ] = ACTIONS(6552),
    [anon_sym_POUND] = ACTIONS(6552),
    [anon_sym_PERCENT] = ACTIONS(6555),
    [anon_sym_PERCENT_EQ] = ACTIONS(6552),
    [anon_sym_CARET] = ACTIONS(6555),
    [anon_sym_CARET_EQ] = ACTIONS(6552),
    [anon_sym_PLUS_EQ] = ACTIONS(6552),
    [anon_sym_LT] = ACTIONS(6555),
    [anon_sym_LT_LT] = ACTIONS(6555),
    [anon_sym_LT_LT_EQ] = ACTIONS(6552),
    [anon_sym_LT_EQ] = ACTIONS(6552),
    [anon_sym_EQ] = ACTIONS(6555),
    [anon_sym_EQ_EQ] = ACTIONS(6552),
    [anon_sym_GT] = ACTIONS(6555),
    [anon_sym_GT_EQ] = ACTIONS(6552),
    [anon_sym_GT_GT] = ACTIONS(6555),
    [anon_sym_GT_GT_EQ] = ACTIONS(6552),
    [anon_sym_PIPE] = ACTIONS(6555),
    [anon_sym_PIPE_EQ] = ACTIONS(6552),
    [anon_sym_PIPE_PIPE] = ACTIONS(6552),
    [anon_sym_TILDE] = ACTIONS(5554),
    [anon_sym_QMARK] = ACTIONS(6552),
    [anon_sym_SQUOTE] = ACTIONS(6555),
    [anon_sym_DOT_DOT] = ACTIONS(6555),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6552),
    [anon_sym_as] = ACTIONS(6555),
    [anon_sym_break] = ACTIONS(6555),
    [anon_sym_const] = ACTIONS(6555),
    [anon_sym_continue] = ACTIONS(6555),
    [anon_sym_default] = ACTIONS(6555),
    [anon_sym_enum] = ACTIONS(6555),
    [anon_sym_fn] = ACTIONS(6555),
    [anon_sym_for] = ACTIONS(6555),
    [anon_sym_if] = ACTIONS(6555),
    [anon_sym_impl] = ACTIONS(6555),
    [anon_sym_let] = ACTIONS(6555),
    [anon_sym_loop] = ACTIONS(6555),
    [anon_sym_match] = ACTIONS(6555),
    [anon_sym_mod] = ACTIONS(6555),
    [anon_sym_pub] = ACTIONS(6555),
    [anon_sym_return] = ACTIONS(6555),
    [anon_sym_static] = ACTIONS(6555),
    [anon_sym_struct] = ACTIONS(6555),
    [anon_sym_trait] = ACTIONS(6555),
    [anon_sym_type] = ACTIONS(6555),
    [anon_sym_union] = ACTIONS(6555),
    [anon_sym_unsafe] = ACTIONS(6555),
    [anon_sym_use] = ACTIONS(6555),
    [anon_sym_where] = ACTIONS(5556),
    [anon_sym_while] = ACTIONS(6555),
    [anon_sym_extern] = ACTIONS(1569),
    [sym_mutable_specifier] = ACTIONS(5556),
    [anon_sym_move] = ACTIONS(1569),
    [sym_integer_literal] = ACTIONS(6552),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6552),
    [sym_char_literal] = ACTIONS(6552),
    [anon_sym_true] = ACTIONS(6555),
    [anon_sym_false] = ACTIONS(6555),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6555),
    [sym_self] = ACTIONS(6555),
    [sym_super] = ACTIONS(6555),
    [sym_crate] = ACTIONS(6555),
    [sym_metavariable] = ACTIONS(6552),
  },
  [2497] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(6604),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(623),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(623),
    [anon_sym_PLUS_EQ] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(623),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(643),
    [anon_sym_as] = ACTIONS(645),
    [sym_line_comment] = ACTIONS(7),
  },
  [2498] = {
    [sym_raw_string_literal] = ACTIONS(5554),
    [sym_float_literal] = ACTIONS(5554),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6572),
    [anon_sym_LPAREN] = ACTIONS(6572),
    [anon_sym_LBRACE] = ACTIONS(5554),
    [anon_sym_RBRACE] = ACTIONS(6572),
    [anon_sym_EQ_GT] = ACTIONS(5554),
    [anon_sym_LBRACK] = ACTIONS(6572),
    [anon_sym_COLON] = ACTIONS(5556),
    [anon_sym_DOLLAR] = ACTIONS(5556),
    [anon_sym_PLUS] = ACTIONS(6575),
    [anon_sym_STAR] = ACTIONS(6575),
    [anon_sym_COMMA] = ACTIONS(5554),
    [anon_sym_u8] = ACTIONS(5556),
    [anon_sym_i8] = ACTIONS(5556),
    [anon_sym_u16] = ACTIONS(5556),
    [anon_sym_i16] = ACTIONS(5556),
    [anon_sym_u32] = ACTIONS(5556),
    [anon_sym_i32] = ACTIONS(5556),
    [anon_sym_u64] = ACTIONS(5556),
    [anon_sym_i64] = ACTIONS(5556),
    [anon_sym_u128] = ACTIONS(5556),
    [anon_sym_i128] = ACTIONS(5556),
    [anon_sym_isize] = ACTIONS(5556),
    [anon_sym_usize] = ACTIONS(5556),
    [anon_sym_f32] = ACTIONS(5556),
    [anon_sym_f64] = ACTIONS(5556),
    [anon_sym_bool] = ACTIONS(5556),
    [anon_sym_str] = ACTIONS(5556),
    [anon_sym_char] = ACTIONS(5556),
    [anon_sym__] = ACTIONS(5556),
    [anon_sym_AMP] = ACTIONS(6575),
    [anon_sym_DASH] = ACTIONS(6575),
    [anon_sym_DOT] = ACTIONS(6575),
    [anon_sym_DASH_EQ] = ACTIONS(6572),
    [anon_sym_DASH_GT] = ACTIONS(5554),
    [anon_sym_COLON_COLON] = ACTIONS(5554),
    [anon_sym_BANG] = ACTIONS(5556),
    [anon_sym_BANG_EQ] = ACTIONS(6572),
    [anon_sym_AT] = ACTIONS(5554),
    [anon_sym_STAR_EQ] = ACTIONS(6572),
    [anon_sym_SLASH] = ACTIONS(6575),
    [anon_sym_SLASH_EQ] = ACTIONS(6572),
    [anon_sym_AMP_AMP] = ACTIONS(6572),
    [anon_sym_AMP_EQ] = ACTIONS(6572),
    [anon_sym_POUND] = ACTIONS(5554),
    [anon_sym_PERCENT] = ACTIONS(6575),
    [anon_sym_PERCENT_EQ] = ACTIONS(6572),
    [anon_sym_CARET] = ACTIONS(6575),
    [anon_sym_CARET_EQ] = ACTIONS(6572),
    [anon_sym_PLUS_EQ] = ACTIONS(6572),
    [anon_sym_LT] = ACTIONS(6575),
    [anon_sym_LT_LT] = ACTIONS(6575),
    [anon_sym_LT_LT_EQ] = ACTIONS(6572),
    [anon_sym_LT_EQ] = ACTIONS(6572),
    [anon_sym_EQ] = ACTIONS(6575),
    [anon_sym_EQ_EQ] = ACTIONS(6572),
    [anon_sym_GT] = ACTIONS(6575),
    [anon_sym_GT_EQ] = ACTIONS(6572),
    [anon_sym_GT_GT] = ACTIONS(6575),
    [anon_sym_GT_GT_EQ] = ACTIONS(6572),
    [anon_sym_PIPE] = ACTIONS(6575),
    [anon_sym_PIPE_EQ] = ACTIONS(6572),
    [anon_sym_PIPE_PIPE] = ACTIONS(6572),
    [anon_sym_TILDE] = ACTIONS(5554),
    [anon_sym_QMARK] = ACTIONS(6572),
    [anon_sym_SQUOTE] = ACTIONS(5556),
    [anon_sym_DOT_DOT] = ACTIONS(6575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6572),
    [anon_sym_as] = ACTIONS(6575),
    [anon_sym_break] = ACTIONS(5556),
    [anon_sym_const] = ACTIONS(5556),
    [anon_sym_continue] = ACTIONS(5556),
    [anon_sym_default] = ACTIONS(5556),
    [anon_sym_enum] = ACTIONS(5556),
    [anon_sym_fn] = ACTIONS(5556),
    [anon_sym_for] = ACTIONS(5556),
    [anon_sym_if] = ACTIONS(5556),
    [anon_sym_impl] = ACTIONS(5556),
    [anon_sym_let] = ACTIONS(5556),
    [anon_sym_loop] = ACTIONS(5556),
    [anon_sym_match] = ACTIONS(5556),
    [anon_sym_mod] = ACTIONS(5556),
    [anon_sym_pub] = ACTIONS(5556),
    [anon_sym_return] = ACTIONS(5556),
    [anon_sym_static] = ACTIONS(5556),
    [anon_sym_struct] = ACTIONS(5556),
    [anon_sym_trait] = ACTIONS(5556),
    [anon_sym_type] = ACTIONS(5556),
    [anon_sym_union] = ACTIONS(5556),
    [anon_sym_unsafe] = ACTIONS(5556),
    [anon_sym_use] = ACTIONS(5556),
    [anon_sym_where] = ACTIONS(5556),
    [anon_sym_while] = ACTIONS(5556),
    [sym_mutable_specifier] = ACTIONS(5556),
    [sym_integer_literal] = ACTIONS(5554),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5554),
    [sym_char_literal] = ACTIONS(5554),
    [anon_sym_true] = ACTIONS(5556),
    [anon_sym_false] = ACTIONS(5556),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5556),
    [sym_self] = ACTIONS(5556),
    [sym_super] = ACTIONS(5556),
    [sym_crate] = ACTIONS(5556),
    [sym_metavariable] = ACTIONS(5554),
  },
  [2499] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(769),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(769),
    [sym_macro_invocation] = STATE(769),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(769),
    [sym_unary_expression] = STATE(769),
    [sym_try_expression] = STATE(769),
    [sym_reference_expression] = STATE(769),
    [sym_binary_expression] = STATE(769),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(769),
    [sym_call_expression] = STATE(769),
    [sym_array_expression] = STATE(769),
    [sym_parenthesized_expression] = STATE(769),
    [sym_tuple_expression] = STATE(769),
    [sym_unit_expression] = STATE(769),
    [sym_struct_expression] = STATE(769),
    [sym_if_expression] = STATE(769),
    [sym_if_let_expression] = STATE(769),
    [sym_match_expression] = STATE(769),
    [sym_while_expression] = STATE(769),
    [sym_while_let_expression] = STATE(769),
    [sym_loop_expression] = STATE(769),
    [sym_for_expression] = STATE(769),
    [sym_closure_expression] = STATE(769),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(769),
    [sym_continue_expression] = STATE(769),
    [sym_index_expression] = STATE(769),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(769),
    [sym_block] = STATE(769),
    [sym__literal] = STATE(769),
    [sym_string_literal] = STATE(769),
    [sym_boolean_literal] = STATE(769),
    [sym_raw_string_literal] = ACTIONS(1620),
    [sym_float_literal] = ACTIONS(1620),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_RBRACK] = ACTIONS(6606),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1620),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1620),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2500] = {
    [aux_sym_token_tree_repeat2] = STATE(789),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACK] = ACTIONS(6606),
    [anon_sym_COMMA] = ACTIONS(6608),
    [sym_line_comment] = ACTIONS(7),
  },
  [2501] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(769),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(769),
    [sym_macro_invocation] = STATE(769),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(769),
    [sym_unary_expression] = STATE(769),
    [sym_try_expression] = STATE(769),
    [sym_reference_expression] = STATE(769),
    [sym_binary_expression] = STATE(769),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(769),
    [sym_call_expression] = STATE(769),
    [sym_array_expression] = STATE(769),
    [sym_parenthesized_expression] = STATE(769),
    [sym_tuple_expression] = STATE(769),
    [sym_unit_expression] = STATE(769),
    [sym_struct_expression] = STATE(769),
    [sym_if_expression] = STATE(769),
    [sym_if_let_expression] = STATE(769),
    [sym_match_expression] = STATE(769),
    [sym_while_expression] = STATE(769),
    [sym_while_let_expression] = STATE(769),
    [sym_loop_expression] = STATE(769),
    [sym_for_expression] = STATE(769),
    [sym_closure_expression] = STATE(769),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(769),
    [sym_continue_expression] = STATE(769),
    [sym_index_expression] = STATE(769),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(769),
    [sym_block] = STATE(769),
    [sym__literal] = STATE(769),
    [sym_string_literal] = STATE(769),
    [sym_boolean_literal] = STATE(769),
    [sym_raw_string_literal] = ACTIONS(1620),
    [sym_float_literal] = ACTIONS(1620),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_RBRACK] = ACTIONS(6592),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1620),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1620),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2502] = {
    [sym_function_modifiers] = STATE(1624),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2992),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1626),
    [sym_array_type] = STATE(2992),
    [sym_function_type] = STATE(2992),
    [sym_tuple_type] = STATE(2992),
    [sym_unit_type] = STATE(2992),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2992),
    [sym_reference_type] = STATE(2992),
    [sym_pointer_type] = STATE(2992),
    [sym_empty_type] = STATE(2992),
    [sym_abstract_type] = STATE(2993),
    [sym_dynamic_type] = STATE(2992),
    [sym_macro_invocation] = STATE(2992),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1628),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3169),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3171),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3173),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3175),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2503] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6610),
    [sym_line_comment] = ACTIONS(7),
  },
  [2504] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_RPAREN] = ACTIONS(6612),
    [sym_line_comment] = ACTIONS(7),
  },
  [2505] = {
    [sym_macro_rule] = STATE(2996),
    [sym_token_tree_pattern] = STATE(690),
    [aux_sym_macro_definition_repeat1] = STATE(1371),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_RPAREN] = ACTIONS(6612),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_LBRACK] = ACTIONS(1485),
    [sym_line_comment] = ACTIONS(7),
  },
  [2506] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2713),
    [anon_sym_macro_rules_BANG] = ACTIONS(2713),
    [anon_sym_RBRACE] = ACTIONS(2713),
    [anon_sym_POUND] = ACTIONS(2713),
    [anon_sym_const] = ACTIONS(2715),
    [anon_sym_default] = ACTIONS(2715),
    [anon_sym_enum] = ACTIONS(2715),
    [anon_sym_fn] = ACTIONS(2715),
    [anon_sym_impl] = ACTIONS(2715),
    [anon_sym_let] = ACTIONS(2715),
    [anon_sym_mod] = ACTIONS(2715),
    [anon_sym_pub] = ACTIONS(2715),
    [anon_sym_static] = ACTIONS(2715),
    [anon_sym_struct] = ACTIONS(2715),
    [anon_sym_trait] = ACTIONS(2715),
    [anon_sym_type] = ACTIONS(2715),
    [anon_sym_union] = ACTIONS(2715),
    [anon_sym_unsafe] = ACTIONS(2715),
    [anon_sym_use] = ACTIONS(2715),
    [anon_sym_extern] = ACTIONS(2715),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2715),
  },
  [2507] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_RBRACE] = ACTIONS(6610),
    [sym_line_comment] = ACTIONS(7),
  },
  [2508] = {
    [sym_macro_rule] = STATE(2997),
    [sym_token_tree_pattern] = STATE(690),
    [aux_sym_macro_definition_repeat1] = STATE(1373),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_RBRACE] = ACTIONS(6610),
    [anon_sym_LBRACK] = ACTIONS(1485),
    [sym_line_comment] = ACTIONS(7),
  },
  [2509] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2872),
    [anon_sym_macro_rules_BANG] = ACTIONS(2872),
    [anon_sym_RBRACE] = ACTIONS(2872),
    [anon_sym_POUND] = ACTIONS(2872),
    [anon_sym_const] = ACTIONS(2874),
    [anon_sym_default] = ACTIONS(2874),
    [anon_sym_enum] = ACTIONS(2874),
    [anon_sym_fn] = ACTIONS(2874),
    [anon_sym_impl] = ACTIONS(2874),
    [anon_sym_let] = ACTIONS(2874),
    [anon_sym_mod] = ACTIONS(2874),
    [anon_sym_pub] = ACTIONS(2874),
    [anon_sym_static] = ACTIONS(2874),
    [anon_sym_struct] = ACTIONS(2874),
    [anon_sym_trait] = ACTIONS(2874),
    [anon_sym_type] = ACTIONS(2874),
    [anon_sym_union] = ACTIONS(2874),
    [anon_sym_unsafe] = ACTIONS(2874),
    [anon_sym_use] = ACTIONS(2874),
    [anon_sym_extern] = ACTIONS(2874),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2874),
  },
  [2510] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACK] = ACTIONS(6614),
    [sym_line_comment] = ACTIONS(7),
  },
  [2511] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(3111),
    [anon_sym_EQ] = ACTIONS(6616),
    [sym_line_comment] = ACTIONS(7),
  },
  [2512] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3117),
    [anon_sym_macro_rules_BANG] = ACTIONS(3117),
    [anon_sym_RBRACE] = ACTIONS(3117),
    [anon_sym_POUND] = ACTIONS(3117),
    [anon_sym_const] = ACTIONS(3119),
    [anon_sym_default] = ACTIONS(3119),
    [anon_sym_enum] = ACTIONS(3119),
    [anon_sym_fn] = ACTIONS(3119),
    [anon_sym_impl] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_mod] = ACTIONS(3119),
    [anon_sym_pub] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(3119),
    [anon_sym_struct] = ACTIONS(3119),
    [anon_sym_trait] = ACTIONS(3119),
    [anon_sym_type] = ACTIONS(3119),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(3119),
    [anon_sym_use] = ACTIONS(3119),
    [anon_sym_extern] = ACTIONS(3119),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3119),
  },
  [2513] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6618),
    [sym_line_comment] = ACTIONS(7),
  },
  [2514] = {
    [aux_sym_enum_variant_list_repeat2] = STATE(3002),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6618),
    [anon_sym_COMMA] = ACTIONS(6620),
    [sym_line_comment] = ACTIONS(7),
  },
  [2515] = {
    [sym_attribute_item] = STATE(1597),
    [sym_enum_variant] = STATE(3003),
    [sym_visibility_modifier] = STATE(938),
    [aux_sym_enum_variant_list_repeat1] = STATE(1597),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_pub] = ACTIONS(1940),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1942),
  },
  [2516] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3153),
    [anon_sym_macro_rules_BANG] = ACTIONS(3153),
    [anon_sym_RBRACE] = ACTIONS(3153),
    [anon_sym_POUND] = ACTIONS(3153),
    [anon_sym_const] = ACTIONS(3155),
    [anon_sym_default] = ACTIONS(3155),
    [anon_sym_enum] = ACTIONS(3155),
    [anon_sym_fn] = ACTIONS(3155),
    [anon_sym_impl] = ACTIONS(3155),
    [anon_sym_let] = ACTIONS(3155),
    [anon_sym_mod] = ACTIONS(3155),
    [anon_sym_pub] = ACTIONS(3155),
    [anon_sym_static] = ACTIONS(3155),
    [anon_sym_struct] = ACTIONS(3155),
    [anon_sym_trait] = ACTIONS(3155),
    [anon_sym_type] = ACTIONS(3155),
    [anon_sym_union] = ACTIONS(3155),
    [anon_sym_unsafe] = ACTIONS(3155),
    [anon_sym_use] = ACTIONS(3155),
    [anon_sym_extern] = ACTIONS(3155),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3155),
  },
  [2517] = {
    [sym_enum_variant_list] = STATE(3004),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(4209),
    [sym_line_comment] = ACTIONS(7),
  },
  [2518] = {
    [sym_where_clause] = STATE(3007),
    [sym_block] = STATE(3008),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6622),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_DASH_GT] = ACTIONS(6624),
    [anon_sym_where] = ACTIONS(1962),
    [sym_line_comment] = ACTIONS(7),
  },
  [2519] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3161),
    [anon_sym_macro_rules_BANG] = ACTIONS(3161),
    [anon_sym_RBRACE] = ACTIONS(3161),
    [anon_sym_POUND] = ACTIONS(3161),
    [anon_sym_const] = ACTIONS(3163),
    [anon_sym_default] = ACTIONS(3163),
    [anon_sym_enum] = ACTIONS(3163),
    [anon_sym_fn] = ACTIONS(3163),
    [anon_sym_impl] = ACTIONS(3163),
    [anon_sym_let] = ACTIONS(3163),
    [anon_sym_mod] = ACTIONS(3163),
    [anon_sym_pub] = ACTIONS(3163),
    [anon_sym_static] = ACTIONS(3163),
    [anon_sym_struct] = ACTIONS(3163),
    [anon_sym_trait] = ACTIONS(3163),
    [anon_sym_type] = ACTIONS(3163),
    [anon_sym_union] = ACTIONS(3163),
    [anon_sym_unsafe] = ACTIONS(3163),
    [anon_sym_use] = ACTIONS(3163),
    [anon_sym_extern] = ACTIONS(3163),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3163),
  },
  [2520] = {
    [sym_function_modifiers] = STATE(1624),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3009),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1626),
    [sym_array_type] = STATE(3009),
    [sym_function_type] = STATE(3009),
    [sym_tuple_type] = STATE(3009),
    [sym_unit_type] = STATE(3009),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(3009),
    [sym_reference_type] = STATE(3009),
    [sym_pointer_type] = STATE(3009),
    [sym_empty_type] = STATE(3009),
    [sym_abstract_type] = STATE(3010),
    [sym_dynamic_type] = STATE(3009),
    [sym_macro_invocation] = STATE(3009),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1628),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3169),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3171),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3173),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3175),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2521] = {
    [sym_block] = STATE(3008),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6622),
    [anon_sym_LBRACE] = ACTIONS(111),
    [sym_line_comment] = ACTIONS(7),
  },
  [2522] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3179),
    [anon_sym_macro_rules_BANG] = ACTIONS(3179),
    [anon_sym_RBRACE] = ACTIONS(3179),
    [anon_sym_POUND] = ACTIONS(3179),
    [anon_sym_const] = ACTIONS(3181),
    [anon_sym_default] = ACTIONS(3181),
    [anon_sym_enum] = ACTIONS(3181),
    [anon_sym_fn] = ACTIONS(3181),
    [anon_sym_impl] = ACTIONS(3181),
    [anon_sym_let] = ACTIONS(3181),
    [anon_sym_mod] = ACTIONS(3181),
    [anon_sym_pub] = ACTIONS(3181),
    [anon_sym_static] = ACTIONS(3181),
    [anon_sym_struct] = ACTIONS(3181),
    [anon_sym_trait] = ACTIONS(3181),
    [anon_sym_type] = ACTIONS(3181),
    [anon_sym_union] = ACTIONS(3181),
    [anon_sym_unsafe] = ACTIONS(3181),
    [anon_sym_use] = ACTIONS(3181),
    [anon_sym_extern] = ACTIONS(3181),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3181),
  },
  [2523] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3251),
    [anon_sym_macro_rules_BANG] = ACTIONS(3251),
    [anon_sym_RBRACE] = ACTIONS(3251),
    [anon_sym_POUND] = ACTIONS(3251),
    [anon_sym_const] = ACTIONS(3253),
    [anon_sym_default] = ACTIONS(3253),
    [anon_sym_enum] = ACTIONS(3253),
    [anon_sym_fn] = ACTIONS(3253),
    [anon_sym_impl] = ACTIONS(3253),
    [anon_sym_let] = ACTIONS(3253),
    [anon_sym_mod] = ACTIONS(3253),
    [anon_sym_pub] = ACTIONS(3253),
    [anon_sym_static] = ACTIONS(3253),
    [anon_sym_struct] = ACTIONS(3253),
    [anon_sym_trait] = ACTIONS(3253),
    [anon_sym_type] = ACTIONS(3253),
    [anon_sym_union] = ACTIONS(3253),
    [anon_sym_unsafe] = ACTIONS(3253),
    [anon_sym_use] = ACTIONS(3253),
    [anon_sym_extern] = ACTIONS(3253),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3253),
  },
  [2524] = {
    [sym_declaration_list] = STATE(3011),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [sym_line_comment] = ACTIONS(7),
  },
  [2525] = {
    [sym_declaration_list] = STATE(3011),
    [sym_where_clause] = STATE(3012),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [2526] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_macro_rules_BANG] = ACTIONS(3255),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_POUND] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3257),
    [anon_sym_default] = ACTIONS(3257),
    [anon_sym_enum] = ACTIONS(3257),
    [anon_sym_fn] = ACTIONS(3257),
    [anon_sym_impl] = ACTIONS(3257),
    [anon_sym_let] = ACTIONS(3257),
    [anon_sym_mod] = ACTIONS(3257),
    [anon_sym_pub] = ACTIONS(3257),
    [anon_sym_static] = ACTIONS(3257),
    [anon_sym_struct] = ACTIONS(3257),
    [anon_sym_trait] = ACTIONS(3257),
    [anon_sym_type] = ACTIONS(3257),
    [anon_sym_union] = ACTIONS(3257),
    [anon_sym_unsafe] = ACTIONS(3257),
    [anon_sym_use] = ACTIONS(3257),
    [anon_sym_extern] = ACTIONS(3257),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3257),
  },
  [2527] = {
    [sym_declaration_list] = STATE(3013),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [sym_line_comment] = ACTIONS(7),
  },
  [2528] = {
    [sym_declaration_list] = STATE(3013),
    [sym_where_clause] = STATE(3014),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [2529] = {
    [sym_declaration_list] = STATE(3013),
    [sym_where_clause] = STATE(3014),
    [sym_impl_for_clause] = STATE(3015),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [anon_sym_COLON_COLON] = ACTIONS(1798),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [2530] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3259),
    [anon_sym_macro_rules_BANG] = ACTIONS(3259),
    [anon_sym_RBRACE] = ACTIONS(3259),
    [anon_sym_POUND] = ACTIONS(3259),
    [anon_sym_const] = ACTIONS(3261),
    [anon_sym_default] = ACTIONS(3261),
    [anon_sym_enum] = ACTIONS(3261),
    [anon_sym_fn] = ACTIONS(3261),
    [anon_sym_impl] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_mod] = ACTIONS(3261),
    [anon_sym_pub] = ACTIONS(3261),
    [anon_sym_static] = ACTIONS(3261),
    [anon_sym_struct] = ACTIONS(3261),
    [anon_sym_trait] = ACTIONS(3261),
    [anon_sym_type] = ACTIONS(3261),
    [anon_sym_union] = ACTIONS(3261),
    [anon_sym_unsafe] = ACTIONS(3261),
    [anon_sym_use] = ACTIONS(3261),
    [anon_sym_extern] = ACTIONS(3261),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3261),
  },
  [2531] = {
    [sym_declaration_list] = STATE(3016),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [sym_line_comment] = ACTIONS(7),
  },
  [2532] = {
    [sym_declaration_list] = STATE(3016),
    [sym_where_clause] = STATE(3017),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [2533] = {
    [sym_declaration_list] = STATE(3016),
    [sym_where_clause] = STATE(3017),
    [sym_impl_for_clause] = STATE(3018),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [anon_sym_COLON_COLON] = ACTIONS(1816),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [2534] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3263),
    [anon_sym_macro_rules_BANG] = ACTIONS(3263),
    [anon_sym_RBRACE] = ACTIONS(3263),
    [anon_sym_POUND] = ACTIONS(3263),
    [anon_sym_const] = ACTIONS(3265),
    [anon_sym_default] = ACTIONS(3265),
    [anon_sym_enum] = ACTIONS(3265),
    [anon_sym_fn] = ACTIONS(3265),
    [anon_sym_impl] = ACTIONS(3265),
    [anon_sym_let] = ACTIONS(3265),
    [anon_sym_mod] = ACTIONS(3265),
    [anon_sym_pub] = ACTIONS(3265),
    [anon_sym_static] = ACTIONS(3265),
    [anon_sym_struct] = ACTIONS(3265),
    [anon_sym_trait] = ACTIONS(3265),
    [anon_sym_type] = ACTIONS(3265),
    [anon_sym_union] = ACTIONS(3265),
    [anon_sym_unsafe] = ACTIONS(3265),
    [anon_sym_use] = ACTIONS(3265),
    [anon_sym_extern] = ACTIONS(3265),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3265),
  },
  [2535] = {
    [sym_function_modifiers] = STATE(1025),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3019),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1027),
    [sym_array_type] = STATE(3019),
    [sym_function_type] = STATE(3019),
    [sym_tuple_type] = STATE(3019),
    [sym_unit_type] = STATE(3019),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(3019),
    [sym_reference_type] = STATE(3019),
    [sym_pointer_type] = STATE(3019),
    [sym_empty_type] = STATE(3019),
    [sym_dynamic_type] = STATE(3019),
    [sym_macro_invocation] = STATE(3019),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1028),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2060),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2062),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2064),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2066),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2536] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3020),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3020),
    [sym_macro_invocation] = STATE(3020),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3020),
    [sym_unary_expression] = STATE(3020),
    [sym_try_expression] = STATE(3020),
    [sym_reference_expression] = STATE(3020),
    [sym_binary_expression] = STATE(3020),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3020),
    [sym_call_expression] = STATE(3020),
    [sym_array_expression] = STATE(3020),
    [sym_parenthesized_expression] = STATE(3020),
    [sym_tuple_expression] = STATE(3020),
    [sym_unit_expression] = STATE(3020),
    [sym_struct_expression] = STATE(3020),
    [sym_if_expression] = STATE(3020),
    [sym_if_let_expression] = STATE(3020),
    [sym_match_expression] = STATE(3020),
    [sym_while_expression] = STATE(3020),
    [sym_while_let_expression] = STATE(3020),
    [sym_loop_expression] = STATE(3020),
    [sym_for_expression] = STATE(3020),
    [sym_closure_expression] = STATE(3020),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3020),
    [sym_continue_expression] = STATE(3020),
    [sym_index_expression] = STATE(3020),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3020),
    [sym_block] = STATE(3020),
    [sym__literal] = STATE(3020),
    [sym_string_literal] = STATE(3020),
    [sym_boolean_literal] = STATE(3020),
    [sym_raw_string_literal] = ACTIONS(6626),
    [sym_float_literal] = ACTIONS(6626),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(6626),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6626),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2537] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6628),
    [anon_sym_PLUS] = ACTIONS(3279),
    [anon_sym_EQ] = ACTIONS(6630),
    [sym_line_comment] = ACTIONS(7),
  },
  [2538] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6628),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(467),
    [anon_sym_BANG_EQ] = ACTIONS(469),
    [anon_sym_STAR_EQ] = ACTIONS(467),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(467),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_AMP_EQ] = ACTIONS(467),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(467),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_CARET_EQ] = ACTIONS(467),
    [anon_sym_PLUS_EQ] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT_LT_EQ] = ACTIONS(467),
    [anon_sym_LT_EQ] = ACTIONS(469),
    [anon_sym_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_EQ] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_PIPE_EQ] = ACTIONS(467),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(489),
    [anon_sym_as] = ACTIONS(491),
    [sym_line_comment] = ACTIONS(7),
  },
  [2539] = {
    [sym_function_modifiers] = STATE(1025),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3023),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1027),
    [sym_array_type] = STATE(3023),
    [sym_function_type] = STATE(3023),
    [sym_tuple_type] = STATE(3023),
    [sym_unit_type] = STATE(3023),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(3023),
    [sym_reference_type] = STATE(3023),
    [sym_pointer_type] = STATE(3023),
    [sym_empty_type] = STATE(3023),
    [sym_dynamic_type] = STATE(3023),
    [sym_macro_invocation] = STATE(3023),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1028),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2060),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2062),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2064),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2066),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2540] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6632),
    [anon_sym_PLUS] = ACTIONS(3279),
    [anon_sym_EQ] = ACTIONS(6634),
    [sym_line_comment] = ACTIONS(7),
  },
  [2541] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3385),
    [anon_sym_macro_rules_BANG] = ACTIONS(3385),
    [anon_sym_RBRACE] = ACTIONS(3385),
    [anon_sym_POUND] = ACTIONS(3385),
    [anon_sym_const] = ACTIONS(3387),
    [anon_sym_default] = ACTIONS(3387),
    [anon_sym_enum] = ACTIONS(3387),
    [anon_sym_fn] = ACTIONS(3387),
    [anon_sym_impl] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_mod] = ACTIONS(3387),
    [anon_sym_pub] = ACTIONS(3387),
    [anon_sym_static] = ACTIONS(3387),
    [anon_sym_struct] = ACTIONS(3387),
    [anon_sym_trait] = ACTIONS(3387),
    [anon_sym_type] = ACTIONS(3387),
    [anon_sym_union] = ACTIONS(3387),
    [anon_sym_unsafe] = ACTIONS(3387),
    [anon_sym_use] = ACTIONS(3387),
    [anon_sym_extern] = ACTIONS(3387),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3387),
  },
  [2542] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6636),
    [sym_line_comment] = ACTIONS(7),
  },
  [2543] = {
    [sym_where_clause] = STATE(3027),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6636),
    [anon_sym_where] = ACTIONS(2138),
    [sym_line_comment] = ACTIONS(7),
  },
  [2544] = {
    [sym_field_declaration_list] = STATE(3026),
    [sym_ordered_field_declaration_list] = STATE(3028),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6636),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(3125),
    [sym_line_comment] = ACTIONS(7),
  },
  [2545] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3405),
    [anon_sym_macro_rules_BANG] = ACTIONS(3405),
    [anon_sym_RBRACE] = ACTIONS(3405),
    [anon_sym_POUND] = ACTIONS(3405),
    [anon_sym_const] = ACTIONS(3407),
    [anon_sym_default] = ACTIONS(3407),
    [anon_sym_enum] = ACTIONS(3407),
    [anon_sym_fn] = ACTIONS(3407),
    [anon_sym_impl] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_mod] = ACTIONS(3407),
    [anon_sym_pub] = ACTIONS(3407),
    [anon_sym_static] = ACTIONS(3407),
    [anon_sym_struct] = ACTIONS(3407),
    [anon_sym_trait] = ACTIONS(3407),
    [anon_sym_type] = ACTIONS(3407),
    [anon_sym_union] = ACTIONS(3407),
    [anon_sym_unsafe] = ACTIONS(3407),
    [anon_sym_use] = ACTIONS(3407),
    [anon_sym_extern] = ACTIONS(3407),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3407),
  },
  [2546] = {
    [sym_declaration_list] = STATE(3029),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [sym_line_comment] = ACTIONS(7),
  },
  [2547] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6638),
    [anon_sym_PLUS] = ACTIONS(3423),
    [sym_line_comment] = ACTIONS(7),
  },
  [2548] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3427),
    [anon_sym_macro_rules_BANG] = ACTIONS(3427),
    [anon_sym_RBRACE] = ACTIONS(3427),
    [anon_sym_POUND] = ACTIONS(3427),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_default] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_fn] = ACTIONS(3429),
    [anon_sym_impl] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_mod] = ACTIONS(3429),
    [anon_sym_pub] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_struct] = ACTIONS(3429),
    [anon_sym_trait] = ACTIONS(3429),
    [anon_sym_type] = ACTIONS(3429),
    [anon_sym_union] = ACTIONS(3429),
    [anon_sym_unsafe] = ACTIONS(3429),
    [anon_sym_use] = ACTIONS(3429),
    [anon_sym_extern] = ACTIONS(3429),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3429),
  },
  [2549] = {
    [sym_function_modifiers] = STATE(1097),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3031),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1102),
    [sym_array_type] = STATE(3031),
    [sym_function_type] = STATE(3031),
    [sym_tuple_type] = STATE(3031),
    [sym_unit_type] = STATE(3031),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(3031),
    [sym_reference_type] = STATE(3031),
    [sym_pointer_type] = STATE(3031),
    [sym_empty_type] = STATE(3031),
    [sym_dynamic_type] = STATE(3031),
    [sym_macro_invocation] = STATE(3031),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2156),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2162),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2166),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2550] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3431),
    [anon_sym_macro_rules_BANG] = ACTIONS(3431),
    [anon_sym_RBRACE] = ACTIONS(3431),
    [anon_sym_POUND] = ACTIONS(3431),
    [anon_sym_const] = ACTIONS(3433),
    [anon_sym_default] = ACTIONS(3433),
    [anon_sym_enum] = ACTIONS(3433),
    [anon_sym_fn] = ACTIONS(3433),
    [anon_sym_impl] = ACTIONS(3433),
    [anon_sym_let] = ACTIONS(3433),
    [anon_sym_mod] = ACTIONS(3433),
    [anon_sym_pub] = ACTIONS(3433),
    [anon_sym_static] = ACTIONS(3433),
    [anon_sym_struct] = ACTIONS(3433),
    [anon_sym_trait] = ACTIONS(3433),
    [anon_sym_type] = ACTIONS(3433),
    [anon_sym_union] = ACTIONS(3433),
    [anon_sym_unsafe] = ACTIONS(3433),
    [anon_sym_use] = ACTIONS(3433),
    [anon_sym_extern] = ACTIONS(3433),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3433),
  },
  [2551] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6640),
    [sym_line_comment] = ACTIONS(7),
  },
  [2552] = {
    [sym_field_declaration_list] = STATE(3032),
    [sym_ordered_field_declaration_list] = STATE(3033),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6640),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(3125),
    [sym_line_comment] = ACTIONS(7),
  },
  [2553] = {
    [sym_declaration_list] = STATE(3034),
    [sym_where_clause] = STATE(3035),
    [sym_impl_for_clause] = STATE(3036),
    [sym_type_arguments] = STATE(3037),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [2554] = {
    [sym_declaration_list] = STATE(3016),
    [sym_where_clause] = STATE(3017),
    [sym_impl_for_clause] = STATE(3018),
    [sym_type_arguments] = STATE(3038),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [anon_sym_LT] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [2555] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3471),
    [anon_sym_macro_rules_BANG] = ACTIONS(3471),
    [anon_sym_RBRACE] = ACTIONS(3471),
    [anon_sym_POUND] = ACTIONS(3471),
    [anon_sym_const] = ACTIONS(3473),
    [anon_sym_default] = ACTIONS(3473),
    [anon_sym_enum] = ACTIONS(3473),
    [anon_sym_fn] = ACTIONS(3473),
    [anon_sym_impl] = ACTIONS(3473),
    [anon_sym_let] = ACTIONS(3473),
    [anon_sym_mod] = ACTIONS(3473),
    [anon_sym_pub] = ACTIONS(3473),
    [anon_sym_static] = ACTIONS(3473),
    [anon_sym_struct] = ACTIONS(3473),
    [anon_sym_trait] = ACTIONS(3473),
    [anon_sym_type] = ACTIONS(3473),
    [anon_sym_union] = ACTIONS(3473),
    [anon_sym_unsafe] = ACTIONS(3473),
    [anon_sym_use] = ACTIONS(3473),
    [anon_sym_extern] = ACTIONS(3473),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3473),
  },
  [2556] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6642),
  },
  [2557] = {
    [sym_parameters] = STATE(3040),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [2558] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4269),
    [anon_sym_macro_rules_BANG] = ACTIONS(4269),
    [anon_sym_RBRACE] = ACTIONS(4269),
    [anon_sym_POUND] = ACTIONS(4269),
    [anon_sym_const] = ACTIONS(4271),
    [anon_sym_default] = ACTIONS(4271),
    [anon_sym_enum] = ACTIONS(4271),
    [anon_sym_fn] = ACTIONS(4271),
    [anon_sym_impl] = ACTIONS(4271),
    [anon_sym_let] = ACTIONS(4271),
    [anon_sym_mod] = ACTIONS(4271),
    [anon_sym_pub] = ACTIONS(4271),
    [anon_sym_static] = ACTIONS(4271),
    [anon_sym_struct] = ACTIONS(4271),
    [anon_sym_trait] = ACTIONS(4271),
    [anon_sym_type] = ACTIONS(4271),
    [anon_sym_union] = ACTIONS(4271),
    [anon_sym_unsafe] = ACTIONS(4271),
    [anon_sym_use] = ACTIONS(4271),
    [anon_sym_extern] = ACTIONS(4271),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4271),
  },
  [2559] = {
    [sym_function_modifiers] = STATE(929),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3041),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(931),
    [sym_array_type] = STATE(3041),
    [sym_function_type] = STATE(3041),
    [sym_tuple_type] = STATE(3041),
    [sym_unit_type] = STATE(3041),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(3041),
    [sym_reference_type] = STATE(3041),
    [sym_pointer_type] = STATE(3041),
    [sym_empty_type] = STATE(3041),
    [sym_dynamic_type] = STATE(3041),
    [sym_macro_invocation] = STATE(3041),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(932),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1928),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1930),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1932),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1934),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2560] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4335),
    [anon_sym_macro_rules_BANG] = ACTIONS(4335),
    [anon_sym_RBRACE] = ACTIONS(4335),
    [anon_sym_POUND] = ACTIONS(4335),
    [anon_sym_const] = ACTIONS(4337),
    [anon_sym_default] = ACTIONS(4337),
    [anon_sym_enum] = ACTIONS(4337),
    [anon_sym_fn] = ACTIONS(4337),
    [anon_sym_impl] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_mod] = ACTIONS(4337),
    [anon_sym_pub] = ACTIONS(4337),
    [anon_sym_static] = ACTIONS(4337),
    [anon_sym_struct] = ACTIONS(4337),
    [anon_sym_trait] = ACTIONS(4337),
    [anon_sym_type] = ACTIONS(4337),
    [anon_sym_union] = ACTIONS(4337),
    [anon_sym_unsafe] = ACTIONS(4337),
    [anon_sym_use] = ACTIONS(4337),
    [anon_sym_extern] = ACTIONS(4337),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4337),
  },
  [2561] = {
    [sym_enum_variant_list] = STATE(3042),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(4209),
    [sym_line_comment] = ACTIONS(7),
  },
  [2562] = {
    [sym_enum_variant_list] = STATE(3042),
    [sym_where_clause] = STATE(3043),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(4209),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [2563] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4339),
    [anon_sym_macro_rules_BANG] = ACTIONS(4339),
    [anon_sym_RBRACE] = ACTIONS(4339),
    [anon_sym_POUND] = ACTIONS(4339),
    [anon_sym_const] = ACTIONS(4341),
    [anon_sym_default] = ACTIONS(4341),
    [anon_sym_enum] = ACTIONS(4341),
    [anon_sym_fn] = ACTIONS(4341),
    [anon_sym_impl] = ACTIONS(4341),
    [anon_sym_let] = ACTIONS(4341),
    [anon_sym_mod] = ACTIONS(4341),
    [anon_sym_pub] = ACTIONS(4341),
    [anon_sym_static] = ACTIONS(4341),
    [anon_sym_struct] = ACTIONS(4341),
    [anon_sym_trait] = ACTIONS(4341),
    [anon_sym_type] = ACTIONS(4341),
    [anon_sym_union] = ACTIONS(4341),
    [anon_sym_unsafe] = ACTIONS(4341),
    [anon_sym_use] = ACTIONS(4341),
    [anon_sym_extern] = ACTIONS(4341),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4341),
  },
  [2564] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(6644),
    [sym_line_comment] = ACTIONS(7),
  },
  [2565] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4345),
    [anon_sym_macro_rules_BANG] = ACTIONS(4345),
    [anon_sym_RBRACE] = ACTIONS(4345),
    [anon_sym_POUND] = ACTIONS(4345),
    [anon_sym_const] = ACTIONS(4347),
    [anon_sym_default] = ACTIONS(4347),
    [anon_sym_enum] = ACTIONS(4347),
    [anon_sym_fn] = ACTIONS(4347),
    [anon_sym_impl] = ACTIONS(4347),
    [anon_sym_let] = ACTIONS(4347),
    [anon_sym_mod] = ACTIONS(4347),
    [anon_sym_pub] = ACTIONS(4347),
    [anon_sym_static] = ACTIONS(4347),
    [anon_sym_struct] = ACTIONS(4347),
    [anon_sym_trait] = ACTIONS(4347),
    [anon_sym_type] = ACTIONS(4347),
    [anon_sym_union] = ACTIONS(4347),
    [anon_sym_unsafe] = ACTIONS(4347),
    [anon_sym_use] = ACTIONS(4347),
    [anon_sym_extern] = ACTIONS(4347),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4347),
  },
  [2566] = {
    [sym_where_clause] = STATE(3046),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6646),
    [anon_sym_where] = ACTIONS(2138),
    [sym_line_comment] = ACTIONS(7),
  },
  [2567] = {
    [sym_field_declaration_list] = STATE(3045),
    [sym_ordered_field_declaration_list] = STATE(3047),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6646),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(3125),
    [sym_line_comment] = ACTIONS(7),
  },
  [2568] = {
    [sym_field_declaration_list] = STATE(3045),
    [sym_ordered_field_declaration_list] = STATE(3047),
    [sym_where_clause] = STATE(3048),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6646),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(3125),
    [anon_sym_where] = ACTIONS(1057),
    [sym_line_comment] = ACTIONS(7),
  },
  [2569] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4351),
    [anon_sym_macro_rules_BANG] = ACTIONS(4351),
    [anon_sym_RBRACE] = ACTIONS(4351),
    [anon_sym_POUND] = ACTIONS(4351),
    [anon_sym_const] = ACTIONS(4353),
    [anon_sym_default] = ACTIONS(4353),
    [anon_sym_enum] = ACTIONS(4353),
    [anon_sym_fn] = ACTIONS(4353),
    [anon_sym_impl] = ACTIONS(4353),
    [anon_sym_let] = ACTIONS(4353),
    [anon_sym_mod] = ACTIONS(4353),
    [anon_sym_pub] = ACTIONS(4353),
    [anon_sym_static] = ACTIONS(4353),
    [anon_sym_struct] = ACTIONS(4353),
    [anon_sym_trait] = ACTIONS(4353),
    [anon_sym_type] = ACTIONS(4353),
    [anon_sym_union] = ACTIONS(4353),
    [anon_sym_unsafe] = ACTIONS(4353),
    [anon_sym_use] = ACTIONS(4353),
    [anon_sym_extern] = ACTIONS(4353),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4353),
  },
  [2570] = {
    [sym_declaration_list] = STATE(3049),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [sym_line_comment] = ACTIONS(7),
  },
  [2571] = {
    [sym_declaration_list] = STATE(3049),
    [sym_trait_bounds] = STATE(3050),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [anon_sym_COLON] = ACTIONS(1059),
    [sym_line_comment] = ACTIONS(7),
  },
  [2572] = {
    [sym_function_modifiers] = STATE(1097),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3051),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1102),
    [sym_array_type] = STATE(3051),
    [sym_function_type] = STATE(3051),
    [sym_tuple_type] = STATE(3051),
    [sym_unit_type] = STATE(3051),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(3051),
    [sym_reference_type] = STATE(3051),
    [sym_pointer_type] = STATE(3051),
    [sym_empty_type] = STATE(3051),
    [sym_dynamic_type] = STATE(3051),
    [sym_macro_invocation] = STATE(3051),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2156),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2162),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2166),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2573] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(6648),
    [sym_line_comment] = ACTIONS(7),
  },
  [2574] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4357),
    [anon_sym_macro_rules_BANG] = ACTIONS(4357),
    [anon_sym_RBRACE] = ACTIONS(4357),
    [anon_sym_POUND] = ACTIONS(4357),
    [anon_sym_const] = ACTIONS(4359),
    [anon_sym_default] = ACTIONS(4359),
    [anon_sym_enum] = ACTIONS(4359),
    [anon_sym_fn] = ACTIONS(4359),
    [anon_sym_impl] = ACTIONS(4359),
    [anon_sym_let] = ACTIONS(4359),
    [anon_sym_mod] = ACTIONS(4359),
    [anon_sym_pub] = ACTIONS(4359),
    [anon_sym_static] = ACTIONS(4359),
    [anon_sym_struct] = ACTIONS(4359),
    [anon_sym_trait] = ACTIONS(4359),
    [anon_sym_type] = ACTIONS(4359),
    [anon_sym_union] = ACTIONS(4359),
    [anon_sym_unsafe] = ACTIONS(4359),
    [anon_sym_use] = ACTIONS(4359),
    [anon_sym_extern] = ACTIONS(4359),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4359),
  },
  [2575] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6650),
    [sym_line_comment] = ACTIONS(7),
  },
  [2576] = {
    [sym_field_declaration_list] = STATE(3053),
    [sym_ordered_field_declaration_list] = STATE(3054),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6650),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(3125),
    [sym_line_comment] = ACTIONS(7),
  },
  [2577] = {
    [sym_field_declaration_list] = STATE(3053),
    [sym_ordered_field_declaration_list] = STATE(3054),
    [sym_where_clause] = STATE(3055),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6650),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(3125),
    [anon_sym_where] = ACTIONS(1057),
    [sym_line_comment] = ACTIONS(7),
  },
  [2578] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4363),
    [anon_sym_macro_rules_BANG] = ACTIONS(4363),
    [anon_sym_RBRACE] = ACTIONS(4363),
    [anon_sym_POUND] = ACTIONS(4363),
    [anon_sym_const] = ACTIONS(4365),
    [anon_sym_default] = ACTIONS(4365),
    [anon_sym_enum] = ACTIONS(4365),
    [anon_sym_fn] = ACTIONS(4365),
    [anon_sym_impl] = ACTIONS(4365),
    [anon_sym_let] = ACTIONS(4365),
    [anon_sym_mod] = ACTIONS(4365),
    [anon_sym_pub] = ACTIONS(4365),
    [anon_sym_static] = ACTIONS(4365),
    [anon_sym_struct] = ACTIONS(4365),
    [anon_sym_trait] = ACTIONS(4365),
    [anon_sym_type] = ACTIONS(4365),
    [anon_sym_union] = ACTIONS(4365),
    [anon_sym_unsafe] = ACTIONS(4365),
    [anon_sym_use] = ACTIONS(4365),
    [anon_sym_extern] = ACTIONS(4365),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4365),
  },
  [2579] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6652),
    [anon_sym_as] = ACTIONS(6654),
    [sym_line_comment] = ACTIONS(7),
  },
  [2580] = {
    [sym_type_parameters] = STATE(3058),
    [sym_parameters] = STATE(3040),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(925),
    [sym_line_comment] = ACTIONS(7),
  },
  [2581] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3059),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3059),
    [sym_macro_invocation] = STATE(3059),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3059),
    [sym_unary_expression] = STATE(3059),
    [sym_try_expression] = STATE(3059),
    [sym_reference_expression] = STATE(3059),
    [sym_binary_expression] = STATE(3059),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3059),
    [sym_call_expression] = STATE(3059),
    [sym_array_expression] = STATE(3059),
    [sym_parenthesized_expression] = STATE(3059),
    [sym_tuple_expression] = STATE(3059),
    [sym_unit_expression] = STATE(3059),
    [sym_struct_expression] = STATE(3059),
    [sym_if_expression] = STATE(3059),
    [sym_if_let_expression] = STATE(3059),
    [sym_match_expression] = STATE(3059),
    [sym_while_expression] = STATE(3059),
    [sym_while_let_expression] = STATE(3059),
    [sym_loop_expression] = STATE(3059),
    [sym_for_expression] = STATE(3059),
    [sym_closure_expression] = STATE(3059),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3059),
    [sym_continue_expression] = STATE(3059),
    [sym_index_expression] = STATE(3059),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3059),
    [sym_block] = STATE(3059),
    [sym__literal] = STATE(3059),
    [sym_string_literal] = STATE(3059),
    [sym_boolean_literal] = STATE(3059),
    [sym_raw_string_literal] = ACTIONS(6656),
    [sym_float_literal] = ACTIONS(6656),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(6656),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6656),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2582] = {
    [sym_raw_string_literal] = ACTIONS(6658),
    [sym_float_literal] = ACTIONS(6658),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(6658),
    [anon_sym_SEMI] = ACTIONS(6658),
    [anon_sym_macro_rules_BANG] = ACTIONS(6658),
    [anon_sym_LPAREN] = ACTIONS(6658),
    [anon_sym_LBRACE] = ACTIONS(6658),
    [anon_sym_RBRACE] = ACTIONS(6658),
    [anon_sym_LBRACK] = ACTIONS(6658),
    [anon_sym_STAR] = ACTIONS(6658),
    [anon_sym_u8] = ACTIONS(6660),
    [anon_sym_i8] = ACTIONS(6660),
    [anon_sym_u16] = ACTIONS(6660),
    [anon_sym_i16] = ACTIONS(6660),
    [anon_sym_u32] = ACTIONS(6660),
    [anon_sym_i32] = ACTIONS(6660),
    [anon_sym_u64] = ACTIONS(6660),
    [anon_sym_i64] = ACTIONS(6660),
    [anon_sym_u128] = ACTIONS(6660),
    [anon_sym_i128] = ACTIONS(6660),
    [anon_sym_isize] = ACTIONS(6660),
    [anon_sym_usize] = ACTIONS(6660),
    [anon_sym_f32] = ACTIONS(6660),
    [anon_sym_f64] = ACTIONS(6660),
    [anon_sym_bool] = ACTIONS(6660),
    [anon_sym_str] = ACTIONS(6660),
    [anon_sym_char] = ACTIONS(6660),
    [anon_sym_AMP] = ACTIONS(6658),
    [anon_sym_DASH] = ACTIONS(6658),
    [anon_sym_COLON_COLON] = ACTIONS(6658),
    [anon_sym_BANG] = ACTIONS(6658),
    [anon_sym_POUND] = ACTIONS(6658),
    [anon_sym_LT] = ACTIONS(6658),
    [anon_sym_PIPE] = ACTIONS(6658),
    [anon_sym_SQUOTE] = ACTIONS(6660),
    [anon_sym_DOT_DOT] = ACTIONS(6658),
    [anon_sym_break] = ACTIONS(6660),
    [anon_sym_const] = ACTIONS(6660),
    [anon_sym_continue] = ACTIONS(6660),
    [anon_sym_default] = ACTIONS(6660),
    [anon_sym_enum] = ACTIONS(6660),
    [anon_sym_fn] = ACTIONS(6660),
    [anon_sym_for] = ACTIONS(6660),
    [anon_sym_if] = ACTIONS(6660),
    [anon_sym_impl] = ACTIONS(6660),
    [anon_sym_let] = ACTIONS(6660),
    [anon_sym_loop] = ACTIONS(6660),
    [anon_sym_match] = ACTIONS(6660),
    [anon_sym_mod] = ACTIONS(6660),
    [anon_sym_pub] = ACTIONS(6660),
    [anon_sym_return] = ACTIONS(6660),
    [anon_sym_static] = ACTIONS(6660),
    [anon_sym_struct] = ACTIONS(6660),
    [anon_sym_trait] = ACTIONS(6660),
    [anon_sym_type] = ACTIONS(6660),
    [anon_sym_union] = ACTIONS(6660),
    [anon_sym_unsafe] = ACTIONS(6660),
    [anon_sym_use] = ACTIONS(6660),
    [anon_sym_while] = ACTIONS(6660),
    [anon_sym_extern] = ACTIONS(6660),
    [anon_sym_move] = ACTIONS(6660),
    [sym_integer_literal] = ACTIONS(6658),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6658),
    [sym_char_literal] = ACTIONS(6658),
    [anon_sym_true] = ACTIONS(6660),
    [anon_sym_false] = ACTIONS(6660),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6660),
    [sym_self] = ACTIONS(6660),
    [sym_super] = ACTIONS(6660),
    [sym_crate] = ACTIONS(6660),
    [sym_metavariable] = ACTIONS(6658),
  },
  [2583] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6383),
    [anon_sym_PLUS] = ACTIONS(3279),
    [anon_sym_EQ] = ACTIONS(6662),
    [sym_line_comment] = ACTIONS(7),
  },
  [2584] = {
    [sym_raw_string_literal] = ACTIONS(6664),
    [sym_float_literal] = ACTIONS(6664),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(6664),
    [anon_sym_SEMI] = ACTIONS(6664),
    [anon_sym_macro_rules_BANG] = ACTIONS(6664),
    [anon_sym_LPAREN] = ACTIONS(6664),
    [anon_sym_LBRACE] = ACTIONS(6664),
    [anon_sym_RBRACE] = ACTIONS(6664),
    [anon_sym_LBRACK] = ACTIONS(6664),
    [anon_sym_STAR] = ACTIONS(6664),
    [anon_sym_u8] = ACTIONS(6666),
    [anon_sym_i8] = ACTIONS(6666),
    [anon_sym_u16] = ACTIONS(6666),
    [anon_sym_i16] = ACTIONS(6666),
    [anon_sym_u32] = ACTIONS(6666),
    [anon_sym_i32] = ACTIONS(6666),
    [anon_sym_u64] = ACTIONS(6666),
    [anon_sym_i64] = ACTIONS(6666),
    [anon_sym_u128] = ACTIONS(6666),
    [anon_sym_i128] = ACTIONS(6666),
    [anon_sym_isize] = ACTIONS(6666),
    [anon_sym_usize] = ACTIONS(6666),
    [anon_sym_f32] = ACTIONS(6666),
    [anon_sym_f64] = ACTIONS(6666),
    [anon_sym_bool] = ACTIONS(6666),
    [anon_sym_str] = ACTIONS(6666),
    [anon_sym_char] = ACTIONS(6666),
    [anon_sym_AMP] = ACTIONS(6664),
    [anon_sym_DASH] = ACTIONS(6664),
    [anon_sym_COLON_COLON] = ACTIONS(6664),
    [anon_sym_BANG] = ACTIONS(6664),
    [anon_sym_POUND] = ACTIONS(6664),
    [anon_sym_LT] = ACTIONS(6664),
    [anon_sym_PIPE] = ACTIONS(6664),
    [anon_sym_SQUOTE] = ACTIONS(6666),
    [anon_sym_DOT_DOT] = ACTIONS(6664),
    [anon_sym_break] = ACTIONS(6666),
    [anon_sym_const] = ACTIONS(6666),
    [anon_sym_continue] = ACTIONS(6666),
    [anon_sym_default] = ACTIONS(6666),
    [anon_sym_enum] = ACTIONS(6666),
    [anon_sym_fn] = ACTIONS(6666),
    [anon_sym_for] = ACTIONS(6666),
    [anon_sym_if] = ACTIONS(6666),
    [anon_sym_impl] = ACTIONS(6666),
    [anon_sym_let] = ACTIONS(6666),
    [anon_sym_loop] = ACTIONS(6666),
    [anon_sym_match] = ACTIONS(6666),
    [anon_sym_mod] = ACTIONS(6666),
    [anon_sym_pub] = ACTIONS(6666),
    [anon_sym_return] = ACTIONS(6666),
    [anon_sym_static] = ACTIONS(6666),
    [anon_sym_struct] = ACTIONS(6666),
    [anon_sym_trait] = ACTIONS(6666),
    [anon_sym_type] = ACTIONS(6666),
    [anon_sym_union] = ACTIONS(6666),
    [anon_sym_unsafe] = ACTIONS(6666),
    [anon_sym_use] = ACTIONS(6666),
    [anon_sym_while] = ACTIONS(6666),
    [anon_sym_extern] = ACTIONS(6666),
    [anon_sym_move] = ACTIONS(6666),
    [sym_integer_literal] = ACTIONS(6664),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6664),
    [sym_char_literal] = ACTIONS(6664),
    [anon_sym_true] = ACTIONS(6666),
    [anon_sym_false] = ACTIONS(6666),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6666),
    [sym_self] = ACTIONS(6666),
    [sym_super] = ACTIONS(6666),
    [sym_crate] = ACTIONS(6666),
    [sym_metavariable] = ACTIONS(6664),
  },
  [2585] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6668),
    [sym_line_comment] = ACTIONS(7),
  },
  [2586] = {
    [sym_where_clause] = STATE(3062),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6668),
    [anon_sym_where] = ACTIONS(2138),
    [sym_line_comment] = ACTIONS(7),
  },
  [2587] = {
    [sym_raw_string_literal] = ACTIONS(6670),
    [sym_float_literal] = ACTIONS(6670),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(6670),
    [anon_sym_SEMI] = ACTIONS(6670),
    [anon_sym_macro_rules_BANG] = ACTIONS(6670),
    [anon_sym_LPAREN] = ACTIONS(6670),
    [anon_sym_LBRACE] = ACTIONS(6670),
    [anon_sym_RBRACE] = ACTIONS(6670),
    [anon_sym_LBRACK] = ACTIONS(6670),
    [anon_sym_STAR] = ACTIONS(6670),
    [anon_sym_u8] = ACTIONS(6672),
    [anon_sym_i8] = ACTIONS(6672),
    [anon_sym_u16] = ACTIONS(6672),
    [anon_sym_i16] = ACTIONS(6672),
    [anon_sym_u32] = ACTIONS(6672),
    [anon_sym_i32] = ACTIONS(6672),
    [anon_sym_u64] = ACTIONS(6672),
    [anon_sym_i64] = ACTIONS(6672),
    [anon_sym_u128] = ACTIONS(6672),
    [anon_sym_i128] = ACTIONS(6672),
    [anon_sym_isize] = ACTIONS(6672),
    [anon_sym_usize] = ACTIONS(6672),
    [anon_sym_f32] = ACTIONS(6672),
    [anon_sym_f64] = ACTIONS(6672),
    [anon_sym_bool] = ACTIONS(6672),
    [anon_sym_str] = ACTIONS(6672),
    [anon_sym_char] = ACTIONS(6672),
    [anon_sym_AMP] = ACTIONS(6670),
    [anon_sym_DASH] = ACTIONS(6670),
    [anon_sym_COLON_COLON] = ACTIONS(6670),
    [anon_sym_BANG] = ACTIONS(6670),
    [anon_sym_POUND] = ACTIONS(6670),
    [anon_sym_LT] = ACTIONS(6670),
    [anon_sym_PIPE] = ACTIONS(6670),
    [anon_sym_SQUOTE] = ACTIONS(6672),
    [anon_sym_DOT_DOT] = ACTIONS(6670),
    [anon_sym_break] = ACTIONS(6672),
    [anon_sym_const] = ACTIONS(6672),
    [anon_sym_continue] = ACTIONS(6672),
    [anon_sym_default] = ACTIONS(6672),
    [anon_sym_enum] = ACTIONS(6672),
    [anon_sym_fn] = ACTIONS(6672),
    [anon_sym_for] = ACTIONS(6672),
    [anon_sym_if] = ACTIONS(6672),
    [anon_sym_impl] = ACTIONS(6672),
    [anon_sym_let] = ACTIONS(6672),
    [anon_sym_loop] = ACTIONS(6672),
    [anon_sym_match] = ACTIONS(6672),
    [anon_sym_mod] = ACTIONS(6672),
    [anon_sym_pub] = ACTIONS(6672),
    [anon_sym_return] = ACTIONS(6672),
    [anon_sym_static] = ACTIONS(6672),
    [anon_sym_struct] = ACTIONS(6672),
    [anon_sym_trait] = ACTIONS(6672),
    [anon_sym_type] = ACTIONS(6672),
    [anon_sym_union] = ACTIONS(6672),
    [anon_sym_unsafe] = ACTIONS(6672),
    [anon_sym_use] = ACTIONS(6672),
    [anon_sym_while] = ACTIONS(6672),
    [anon_sym_extern] = ACTIONS(6672),
    [anon_sym_move] = ACTIONS(6672),
    [sym_integer_literal] = ACTIONS(6670),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6670),
    [sym_char_literal] = ACTIONS(6670),
    [anon_sym_true] = ACTIONS(6672),
    [anon_sym_false] = ACTIONS(6672),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6672),
    [sym_self] = ACTIONS(6672),
    [sym_super] = ACTIONS(6672),
    [sym_crate] = ACTIONS(6672),
    [sym_metavariable] = ACTIONS(6670),
  },
  [2588] = {
    [sym_raw_string_literal] = ACTIONS(6674),
    [sym_float_literal] = ACTIONS(6674),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(6674),
    [anon_sym_SEMI] = ACTIONS(6674),
    [anon_sym_macro_rules_BANG] = ACTIONS(6674),
    [anon_sym_LPAREN] = ACTIONS(6674),
    [anon_sym_LBRACE] = ACTIONS(6674),
    [anon_sym_RBRACE] = ACTIONS(6674),
    [anon_sym_LBRACK] = ACTIONS(6674),
    [anon_sym_STAR] = ACTIONS(6674),
    [anon_sym_u8] = ACTIONS(6676),
    [anon_sym_i8] = ACTIONS(6676),
    [anon_sym_u16] = ACTIONS(6676),
    [anon_sym_i16] = ACTIONS(6676),
    [anon_sym_u32] = ACTIONS(6676),
    [anon_sym_i32] = ACTIONS(6676),
    [anon_sym_u64] = ACTIONS(6676),
    [anon_sym_i64] = ACTIONS(6676),
    [anon_sym_u128] = ACTIONS(6676),
    [anon_sym_i128] = ACTIONS(6676),
    [anon_sym_isize] = ACTIONS(6676),
    [anon_sym_usize] = ACTIONS(6676),
    [anon_sym_f32] = ACTIONS(6676),
    [anon_sym_f64] = ACTIONS(6676),
    [anon_sym_bool] = ACTIONS(6676),
    [anon_sym_str] = ACTIONS(6676),
    [anon_sym_char] = ACTIONS(6676),
    [anon_sym_AMP] = ACTIONS(6674),
    [anon_sym_DASH] = ACTIONS(6674),
    [anon_sym_COLON_COLON] = ACTIONS(6674),
    [anon_sym_BANG] = ACTIONS(6674),
    [anon_sym_POUND] = ACTIONS(6674),
    [anon_sym_LT] = ACTIONS(6674),
    [anon_sym_PIPE] = ACTIONS(6674),
    [anon_sym_SQUOTE] = ACTIONS(6676),
    [anon_sym_DOT_DOT] = ACTIONS(6674),
    [anon_sym_break] = ACTIONS(6676),
    [anon_sym_const] = ACTIONS(6676),
    [anon_sym_continue] = ACTIONS(6676),
    [anon_sym_default] = ACTIONS(6676),
    [anon_sym_enum] = ACTIONS(6676),
    [anon_sym_fn] = ACTIONS(6676),
    [anon_sym_for] = ACTIONS(6676),
    [anon_sym_if] = ACTIONS(6676),
    [anon_sym_impl] = ACTIONS(6676),
    [anon_sym_let] = ACTIONS(6676),
    [anon_sym_loop] = ACTIONS(6676),
    [anon_sym_match] = ACTIONS(6676),
    [anon_sym_mod] = ACTIONS(6676),
    [anon_sym_pub] = ACTIONS(6676),
    [anon_sym_return] = ACTIONS(6676),
    [anon_sym_static] = ACTIONS(6676),
    [anon_sym_struct] = ACTIONS(6676),
    [anon_sym_trait] = ACTIONS(6676),
    [anon_sym_type] = ACTIONS(6676),
    [anon_sym_union] = ACTIONS(6676),
    [anon_sym_unsafe] = ACTIONS(6676),
    [anon_sym_use] = ACTIONS(6676),
    [anon_sym_while] = ACTIONS(6676),
    [anon_sym_extern] = ACTIONS(6676),
    [anon_sym_move] = ACTIONS(6676),
    [sym_integer_literal] = ACTIONS(6674),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6674),
    [sym_char_literal] = ACTIONS(6674),
    [anon_sym_true] = ACTIONS(6676),
    [anon_sym_false] = ACTIONS(6676),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6676),
    [sym_self] = ACTIONS(6676),
    [sym_super] = ACTIONS(6676),
    [sym_crate] = ACTIONS(6676),
    [sym_metavariable] = ACTIONS(6674),
  },
  [2589] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6678),
    [anon_sym_PLUS] = ACTIONS(3423),
    [sym_line_comment] = ACTIONS(7),
  },
  [2590] = {
    [sym_raw_string_literal] = ACTIONS(6680),
    [sym_float_literal] = ACTIONS(6680),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(6680),
    [anon_sym_SEMI] = ACTIONS(6680),
    [anon_sym_macro_rules_BANG] = ACTIONS(6680),
    [anon_sym_LPAREN] = ACTIONS(6680),
    [anon_sym_LBRACE] = ACTIONS(6680),
    [anon_sym_RBRACE] = ACTIONS(6680),
    [anon_sym_LBRACK] = ACTIONS(6680),
    [anon_sym_STAR] = ACTIONS(6680),
    [anon_sym_u8] = ACTIONS(6682),
    [anon_sym_i8] = ACTIONS(6682),
    [anon_sym_u16] = ACTIONS(6682),
    [anon_sym_i16] = ACTIONS(6682),
    [anon_sym_u32] = ACTIONS(6682),
    [anon_sym_i32] = ACTIONS(6682),
    [anon_sym_u64] = ACTIONS(6682),
    [anon_sym_i64] = ACTIONS(6682),
    [anon_sym_u128] = ACTIONS(6682),
    [anon_sym_i128] = ACTIONS(6682),
    [anon_sym_isize] = ACTIONS(6682),
    [anon_sym_usize] = ACTIONS(6682),
    [anon_sym_f32] = ACTIONS(6682),
    [anon_sym_f64] = ACTIONS(6682),
    [anon_sym_bool] = ACTIONS(6682),
    [anon_sym_str] = ACTIONS(6682),
    [anon_sym_char] = ACTIONS(6682),
    [anon_sym_AMP] = ACTIONS(6680),
    [anon_sym_DASH] = ACTIONS(6680),
    [anon_sym_COLON_COLON] = ACTIONS(6680),
    [anon_sym_BANG] = ACTIONS(6680),
    [anon_sym_POUND] = ACTIONS(6680),
    [anon_sym_LT] = ACTIONS(6680),
    [anon_sym_PIPE] = ACTIONS(6680),
    [anon_sym_SQUOTE] = ACTIONS(6682),
    [anon_sym_DOT_DOT] = ACTIONS(6680),
    [anon_sym_break] = ACTIONS(6682),
    [anon_sym_const] = ACTIONS(6682),
    [anon_sym_continue] = ACTIONS(6682),
    [anon_sym_default] = ACTIONS(6682),
    [anon_sym_enum] = ACTIONS(6682),
    [anon_sym_fn] = ACTIONS(6682),
    [anon_sym_for] = ACTIONS(6682),
    [anon_sym_if] = ACTIONS(6682),
    [anon_sym_impl] = ACTIONS(6682),
    [anon_sym_let] = ACTIONS(6682),
    [anon_sym_loop] = ACTIONS(6682),
    [anon_sym_match] = ACTIONS(6682),
    [anon_sym_mod] = ACTIONS(6682),
    [anon_sym_pub] = ACTIONS(6682),
    [anon_sym_return] = ACTIONS(6682),
    [anon_sym_static] = ACTIONS(6682),
    [anon_sym_struct] = ACTIONS(6682),
    [anon_sym_trait] = ACTIONS(6682),
    [anon_sym_type] = ACTIONS(6682),
    [anon_sym_union] = ACTIONS(6682),
    [anon_sym_unsafe] = ACTIONS(6682),
    [anon_sym_use] = ACTIONS(6682),
    [anon_sym_while] = ACTIONS(6682),
    [anon_sym_extern] = ACTIONS(6682),
    [anon_sym_move] = ACTIONS(6682),
    [sym_integer_literal] = ACTIONS(6680),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6680),
    [sym_char_literal] = ACTIONS(6680),
    [anon_sym_true] = ACTIONS(6682),
    [anon_sym_false] = ACTIONS(6682),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6682),
    [sym_self] = ACTIONS(6682),
    [sym_super] = ACTIONS(6682),
    [sym_crate] = ACTIONS(6682),
    [sym_metavariable] = ACTIONS(6680),
  },
  [2591] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6684),
    [sym_line_comment] = ACTIONS(7),
  },
  [2592] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6686),
    [sym_line_comment] = ACTIONS(7),
  },
  [2593] = {
    [sym_where_clause] = STATE(2756),
    [sym_block] = STATE(2757),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6126),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_DASH_GT] = ACTIONS(6688),
    [anon_sym_where] = ACTIONS(1962),
    [sym_line_comment] = ACTIONS(7),
  },
  [2594] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6690),
    [anon_sym_LPAREN] = ACTIONS(6690),
    [anon_sym_RPAREN] = ACTIONS(6690),
    [anon_sym_LBRACE] = ACTIONS(6690),
    [anon_sym_RBRACE] = ACTIONS(6690),
    [anon_sym_LBRACK] = ACTIONS(6690),
    [anon_sym_RBRACK] = ACTIONS(6690),
    [anon_sym_PLUS] = ACTIONS(6692),
    [anon_sym_STAR] = ACTIONS(6692),
    [anon_sym_COMMA] = ACTIONS(6690),
    [anon_sym_AMP] = ACTIONS(6692),
    [anon_sym_DASH] = ACTIONS(6692),
    [anon_sym_DOT] = ACTIONS(6692),
    [anon_sym_DASH_EQ] = ACTIONS(6690),
    [anon_sym_BANG_EQ] = ACTIONS(6690),
    [anon_sym_STAR_EQ] = ACTIONS(6690),
    [anon_sym_SLASH] = ACTIONS(6692),
    [anon_sym_SLASH_EQ] = ACTIONS(6690),
    [anon_sym_AMP_AMP] = ACTIONS(6690),
    [anon_sym_AMP_EQ] = ACTIONS(6690),
    [anon_sym_PERCENT] = ACTIONS(6692),
    [anon_sym_PERCENT_EQ] = ACTIONS(6690),
    [anon_sym_CARET] = ACTIONS(6692),
    [anon_sym_CARET_EQ] = ACTIONS(6690),
    [anon_sym_PLUS_EQ] = ACTIONS(6690),
    [anon_sym_LT] = ACTIONS(6692),
    [anon_sym_LT_LT] = ACTIONS(6692),
    [anon_sym_LT_LT_EQ] = ACTIONS(6690),
    [anon_sym_LT_EQ] = ACTIONS(6690),
    [anon_sym_EQ] = ACTIONS(6692),
    [anon_sym_EQ_EQ] = ACTIONS(6690),
    [anon_sym_GT] = ACTIONS(6692),
    [anon_sym_GT_EQ] = ACTIONS(6690),
    [anon_sym_GT_GT] = ACTIONS(6692),
    [anon_sym_GT_GT_EQ] = ACTIONS(6690),
    [anon_sym_PIPE] = ACTIONS(6692),
    [anon_sym_PIPE_EQ] = ACTIONS(6690),
    [anon_sym_PIPE_PIPE] = ACTIONS(6690),
    [anon_sym_QMARK] = ACTIONS(6690),
    [anon_sym_DOT_DOT] = ACTIONS(6692),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6690),
    [anon_sym_as] = ACTIONS(6690),
    [sym_line_comment] = ACTIONS(7),
  },
  [2595] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1972),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1972),
    [sym_unary_expression] = STATE(1972),
    [sym_try_expression] = STATE(1972),
    [sym_reference_expression] = STATE(1972),
    [sym_binary_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1972),
    [sym_call_expression] = STATE(1972),
    [sym_array_expression] = STATE(1972),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_tuple_expression] = STATE(1972),
    [sym_unit_expression] = STATE(1972),
    [sym_struct_expression] = STATE(1972),
    [sym_if_expression] = STATE(1972),
    [sym_if_let_expression] = STATE(1972),
    [sym_match_expression] = STATE(1972),
    [sym_while_expression] = STATE(1972),
    [sym_while_let_expression] = STATE(1972),
    [sym_loop_expression] = STATE(1972),
    [sym_for_expression] = STATE(1972),
    [sym_closure_expression] = STATE(1972),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1972),
    [sym_continue_expression] = STATE(1972),
    [sym_index_expression] = STATE(1972),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1972),
    [sym_block] = STATE(1972),
    [sym__literal] = STATE(1972),
    [sym_string_literal] = STATE(1972),
    [sym_boolean_literal] = STATE(1972),
    [sym_raw_string_literal] = ACTIONS(4375),
    [sym_float_literal] = ACTIONS(4375),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(4375),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4375),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2596] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3067),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(3067),
    [sym_macro_invocation] = STATE(3067),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3067),
    [sym_unary_expression] = STATE(3067),
    [sym_try_expression] = STATE(3067),
    [sym_reference_expression] = STATE(3067),
    [sym_binary_expression] = STATE(3067),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3067),
    [sym_call_expression] = STATE(3067),
    [sym_array_expression] = STATE(3067),
    [sym_parenthesized_expression] = STATE(3067),
    [sym_tuple_expression] = STATE(3067),
    [sym_unit_expression] = STATE(3067),
    [sym_struct_expression] = STATE(3067),
    [sym_if_expression] = STATE(3067),
    [sym_if_let_expression] = STATE(3067),
    [sym_match_expression] = STATE(3067),
    [sym_while_expression] = STATE(3067),
    [sym_while_let_expression] = STATE(3067),
    [sym_loop_expression] = STATE(3067),
    [sym_for_expression] = STATE(3067),
    [sym_closure_expression] = STATE(3067),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3067),
    [sym_continue_expression] = STATE(3067),
    [sym_index_expression] = STATE(3067),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3067),
    [sym_block] = STATE(3067),
    [sym__literal] = STATE(3067),
    [sym_string_literal] = STATE(3067),
    [sym_boolean_literal] = STATE(3067),
    [sym_raw_string_literal] = ACTIONS(6694),
    [sym_float_literal] = ACTIONS(6694),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(6694),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6694),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [2597] = {
    [sym_if_expression] = STATE(2043),
    [sym_if_let_expression] = STATE(2043),
    [sym_block] = STATE(2043),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(6696),
    [sym_line_comment] = ACTIONS(7),
  },
  [2598] = {
    [sym_function_modifiers] = STATE(1993),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2001),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(1994),
    [sym_array_type] = STATE(2001),
    [sym_function_type] = STATE(2001),
    [sym_tuple_type] = STATE(2001),
    [sym_unit_type] = STATE(2001),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2001),
    [sym_reference_type] = STATE(2001),
    [sym_pointer_type] = STATE(2001),
    [sym_empty_type] = STATE(2001),
    [sym_dynamic_type] = STATE(2001),
    [sym_macro_invocation] = STATE(2001),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(1995),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(4413),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(4415),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4417),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4419),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2599] = {
    [sym_function_modifiers] = STATE(1993),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2003),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(1994),
    [sym_array_type] = STATE(2003),
    [sym_function_type] = STATE(2003),
    [sym_tuple_type] = STATE(2003),
    [sym_unit_type] = STATE(2003),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2003),
    [sym_reference_type] = STATE(2003),
    [sym_pointer_type] = STATE(2003),
    [sym_empty_type] = STATE(2003),
    [sym_dynamic_type] = STATE(2003),
    [sym_macro_invocation] = STATE(2003),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(1995),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(4413),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(4415),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4417),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4419),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2600] = {
    [sym_function_modifiers] = STATE(1993),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2003),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(1994),
    [sym_array_type] = STATE(2003),
    [sym_function_type] = STATE(2003),
    [sym_tuple_type] = STATE(2003),
    [sym_unit_type] = STATE(2003),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2003),
    [sym_reference_type] = STATE(2003),
    [sym_pointer_type] = STATE(2003),
    [sym_empty_type] = STATE(2003),
    [sym_dynamic_type] = STATE(2003),
    [sym_macro_invocation] = STATE(2003),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(1995),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_PLUS] = ACTIONS(5734),
    [anon_sym_STAR] = ACTIONS(4413),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(4415),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4417),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_mutable_specifier] = ACTIONS(6698),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4419),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2601] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1760),
    [anon_sym_LBRACK] = ACTIONS(1760),
    [anon_sym_RBRACK] = ACTIONS(1760),
    [anon_sym_PLUS] = ACTIONS(4443),
    [anon_sym_STAR] = ACTIONS(4443),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_DASH] = ACTIONS(4443),
    [anon_sym_DOT] = ACTIONS(4443),
    [anon_sym_DASH_EQ] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(6700),
    [anon_sym_BANG_EQ] = ACTIONS(1760),
    [anon_sym_STAR_EQ] = ACTIONS(1760),
    [anon_sym_SLASH] = ACTIONS(4443),
    [anon_sym_SLASH_EQ] = ACTIONS(1760),
    [anon_sym_AMP_AMP] = ACTIONS(1760),
    [anon_sym_AMP_EQ] = ACTIONS(1760),
    [anon_sym_PERCENT] = ACTIONS(4443),
    [anon_sym_PERCENT_EQ] = ACTIONS(1760),
    [anon_sym_CARET] = ACTIONS(4443),
    [anon_sym_CARET_EQ] = ACTIONS(1760),
    [anon_sym_PLUS_EQ] = ACTIONS(1760),
    [anon_sym_LT] = ACTIONS(4443),
    [anon_sym_LT_LT] = ACTIONS(4443),
    [anon_sym_LT_LT_EQ] = ACTIONS(1760),
    [anon_sym_LT_EQ] = ACTIONS(1760),
    [anon_sym_EQ] = ACTIONS(4443),
    [anon_sym_EQ_EQ] = ACTIONS(1760),
    [anon_sym_GT] = ACTIONS(4443),
    [anon_sym_GT_EQ] = ACTIONS(1760),
    [anon_sym_GT_GT] = ACTIONS(4443),
    [anon_sym_GT_GT_EQ] = ACTIONS(1760),
    [anon_sym_PIPE] = ACTIONS(4443),
    [anon_sym_PIPE_EQ] = ACTIONS(1760),
    [anon_sym_PIPE_PIPE] = ACTIONS(1760),
    [anon_sym_QMARK] = ACTIONS(1760),
    [anon_sym_DOT_DOT] = ACTIONS(4443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1760),
    [anon_sym_as] = ACTIONS(1760),
    [sym_line_comment] = ACTIONS(7),
  },
  [2602] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1794),
    [anon_sym_LBRACK] = ACTIONS(1794),
    [anon_sym_RBRACK] = ACTIONS(1794),
    [anon_sym_PLUS] = ACTIONS(4449),
    [anon_sym_STAR] = ACTIONS(4449),
    [anon_sym_AMP] = ACTIONS(4449),
    [anon_sym_DASH] = ACTIONS(4449),
    [anon_sym_DOT] = ACTIONS(4449),
    [anon_sym_DASH_EQ] = ACTIONS(1794),
    [anon_sym_DASH_GT] = ACTIONS(6702),
    [anon_sym_BANG_EQ] = ACTIONS(1794),
    [anon_sym_STAR_EQ] = ACTIONS(1794),
    [anon_sym_SLASH] = ACTIONS(4449),
    [anon_sym_SLASH_EQ] = ACTIONS(1794),
    [anon_sym_AMP_AMP] = ACTIONS(1794),
    [anon_sym_AMP_EQ] = ACTIONS(1794),
    [anon_sym_PERCENT] = ACTIONS(4449),
    [anon_sym_PERCENT_EQ] = ACTIONS(1794),
    [anon_sym_CARET] = ACTIONS(4449),
    [anon_sym_CARET_EQ] = ACTIONS(1794),
    [anon_sym_PLUS_EQ] = ACTIONS(1794),
    [anon_sym_LT] = ACTIONS(4449),
    [anon_sym_LT_LT] = ACTIONS(4449),
    [anon_sym_LT_LT_EQ] = ACTIONS(1794),
    [anon_sym_LT_EQ] = ACTIONS(1794),
    [anon_sym_EQ] = ACTIONS(4449),
    [anon_sym_EQ_EQ] = ACTIONS(1794),
    [anon_sym_GT] = ACTIONS(4449),
    [anon_sym_GT_EQ] = ACTIONS(1794),
    [anon_sym_GT_GT] = ACTIONS(4449),
    [anon_sym_GT_GT_EQ] = ACTIONS(1794),
    [anon_sym_PIPE] = ACTIONS(4449),
    [anon_sym_PIPE_EQ] = ACTIONS(1794),
    [anon_sym_PIPE_PIPE] = ACTIONS(1794),
    [anon_sym_QMARK] = ACTIONS(1794),
    [anon_sym_DOT_DOT] = ACTIONS(4449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1794),
    [anon_sym_as] = ACTIONS(1794),
    [sym_line_comment] = ACTIONS(7),
  },
  [2603] = {
    [sym_parameters] = STATE(3071),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [sym_line_comment] = ACTIONS(7),
  },
  [2604] = {
    [sym_parameters] = STATE(3072),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [2605] = {
    [sym_parameters] = STATE(3071),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [2606] = {
    [sym_function_modifiers] = STATE(1993),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2016),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(2016),
    [sym_array_type] = STATE(2016),
    [sym_function_type] = STATE(2016),
    [sym_tuple_type] = STATE(2016),
    [sym_unit_type] = STATE(2016),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2016),
    [sym_reference_type] = STATE(2016),
    [sym_pointer_type] = STATE(2016),
    [sym_empty_type] = STATE(2016),
    [sym_dynamic_type] = STATE(2016),
    [sym_macro_invocation] = STATE(2016),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(1995),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(4413),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(4415),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(4453),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4417),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4419),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2607] = {
    [sym_function_modifiers] = STATE(1993),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2016),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(1994),
    [sym_array_type] = STATE(2016),
    [sym_function_type] = STATE(2016),
    [sym_tuple_type] = STATE(2016),
    [sym_unit_type] = STATE(2016),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2016),
    [sym_reference_type] = STATE(2016),
    [sym_pointer_type] = STATE(2016),
    [sym_empty_type] = STATE(2016),
    [sym_dynamic_type] = STATE(2016),
    [sym_macro_invocation] = STATE(2016),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(1995),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(4413),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(4415),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4417),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4419),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2608] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4749),
    [anon_sym_LPAREN] = ACTIONS(4749),
    [anon_sym_RPAREN] = ACTIONS(4749),
    [anon_sym_LBRACE] = ACTIONS(4749),
    [anon_sym_RBRACE] = ACTIONS(4749),
    [anon_sym_LBRACK] = ACTIONS(4749),
    [anon_sym_RBRACK] = ACTIONS(4749),
    [anon_sym_PLUS] = ACTIONS(6704),
    [anon_sym_STAR] = ACTIONS(6704),
    [anon_sym_COMMA] = ACTIONS(4749),
    [anon_sym_AMP] = ACTIONS(6704),
    [anon_sym_DASH] = ACTIONS(6704),
    [anon_sym_DOT] = ACTIONS(6704),
    [anon_sym_DASH_EQ] = ACTIONS(4749),
    [anon_sym_BANG_EQ] = ACTIONS(4749),
    [anon_sym_STAR_EQ] = ACTIONS(4749),
    [anon_sym_SLASH] = ACTIONS(6704),
    [anon_sym_SLASH_EQ] = ACTIONS(4749),
    [anon_sym_AMP_AMP] = ACTIONS(4749),
    [anon_sym_AMP_EQ] = ACTIONS(4749),
    [anon_sym_PERCENT] = ACTIONS(6704),
    [anon_sym_PERCENT_EQ] = ACTIONS(4749),
    [anon_sym_CARET] = ACTIONS(6704),
    [anon_sym_CARET_EQ] = ACTIONS(4749),
    [anon_sym_PLUS_EQ] = ACTIONS(4749),
    [anon_sym_LT] = ACTIONS(6704),
    [anon_sym_LT_LT] = ACTIONS(6704),
    [anon_sym_LT_LT_EQ] = ACTIONS(4749),
    [anon_sym_LT_EQ] = ACTIONS(4749),
    [anon_sym_EQ] = ACTIONS(6704),
    [anon_sym_EQ_EQ] = ACTIONS(4749),
    [anon_sym_GT] = ACTIONS(6704),
    [anon_sym_GT_EQ] = ACTIONS(4749),
    [anon_sym_GT_GT] = ACTIONS(6704),
    [anon_sym_GT_GT_EQ] = ACTIONS(4749),
    [anon_sym_PIPE] = ACTIONS(6704),
    [anon_sym_PIPE_EQ] = ACTIONS(4749),
    [anon_sym_PIPE_PIPE] = ACTIONS(4749),
    [anon_sym_QMARK] = ACTIONS(4749),
    [anon_sym_DOT_DOT] = ACTIONS(6704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4749),
    [anon_sym_as] = ACTIONS(4749),
    [sym_line_comment] = ACTIONS(7),
  },
  [2609] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1470),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(1470),
    [sym_function_type] = STATE(1470),
    [sym_tuple_type] = STATE(1470),
    [sym_unit_type] = STATE(1470),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1470),
    [sym_reference_type] = STATE(1470),
    [sym_pointer_type] = STATE(1470),
    [sym_empty_type] = STATE(1470),
    [sym_dynamic_type] = STATE(1470),
    [sym_macro_invocation] = STATE(1470),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_RPAREN] = ACTIONS(6706),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2610] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6708),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_STAR_EQ] = ACTIONS(2563),
    [anon_sym_SLASH] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_AMP_EQ] = ACTIONS(2563),
    [anon_sym_PERCENT] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2563),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_CARET_EQ] = ACTIONS(2563),
    [anon_sym_PLUS_EQ] = ACTIONS(2563),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_LT_LT] = ACTIONS(2573),
    [anon_sym_LT_LT_EQ] = ACTIONS(2563),
    [anon_sym_LT_EQ] = ACTIONS(2565),
    [anon_sym_EQ] = ACTIONS(2575),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_GT_EQ] = ACTIONS(2565),
    [anon_sym_GT_GT] = ACTIONS(2573),
    [anon_sym_GT_GT_EQ] = ACTIONS(2563),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_PIPE_EQ] = ACTIONS(2563),
    [anon_sym_PIPE_PIPE] = ACTIONS(2579),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(2581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2583),
    [anon_sym_as] = ACTIONS(2585),
    [sym_line_comment] = ACTIONS(7),
  },
  [2611] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4764),
    [anon_sym_LPAREN] = ACTIONS(4764),
    [anon_sym_RPAREN] = ACTIONS(4764),
    [anon_sym_LBRACE] = ACTIONS(4764),
    [anon_sym_RBRACE] = ACTIONS(4764),
    [anon_sym_LBRACK] = ACTIONS(4764),
    [anon_sym_RBRACK] = ACTIONS(4764),
    [anon_sym_PLUS] = ACTIONS(6710),
    [anon_sym_STAR] = ACTIONS(6710),
    [anon_sym_COMMA] = ACTIONS(4764),
    [anon_sym_AMP] = ACTIONS(6710),
    [anon_sym_DASH] = ACTIONS(6710),
    [anon_sym_DOT] = ACTIONS(6710),
    [anon_sym_DASH_EQ] = ACTIONS(4764),
    [anon_sym_BANG_EQ] = ACTIONS(4764),
    [anon_sym_STAR_EQ] = ACTIONS(4764),
    [anon_sym_SLASH] = ACTIONS(6710),
    [anon_sym_SLASH_EQ] = ACTIONS(4764),
    [anon_sym_AMP_AMP] = ACTIONS(4764),
    [anon_sym_AMP_EQ] = ACTIONS(4764),
    [anon_sym_PERCENT] = ACTIONS(6710),
    [anon_sym_PERCENT_EQ] = ACTIONS(4764),
    [anon_sym_CARET] = ACTIONS(6710),
    [anon_sym_CARET_EQ] = ACTIONS(4764),
    [anon_sym_PLUS_EQ] = ACTIONS(4764),
    [anon_sym_LT] = ACTIONS(6710),
    [anon_sym_LT_LT] = ACTIONS(6710),
    [anon_sym_LT_LT_EQ] = ACTIONS(4764),
    [anon_sym_LT_EQ] = ACTIONS(4764),
    [anon_sym_EQ] = ACTIONS(6710),
    [anon_sym_EQ_EQ] = ACTIONS(4764),
    [anon_sym_GT] = ACTIONS(6710),
    [anon_sym_GT_EQ] = ACTIONS(4764),
    [anon_sym_GT_GT] = ACTIONS(6710),
    [anon_sym_GT_GT_EQ] = ACTIONS(4764),
    [anon_sym_PIPE] = ACTIONS(6710),
    [anon_sym_PIPE_EQ] = ACTIONS(4764),
    [anon_sym_PIPE_PIPE] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4764),
    [anon_sym_DOT_DOT] = ACTIONS(6710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4764),
    [anon_sym_as] = ACTIONS(4764),
    [sym_line_comment] = ACTIONS(7),
  },
  [2612] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4766),
    [anon_sym_LPAREN] = ACTIONS(4766),
    [anon_sym_RPAREN] = ACTIONS(4766),
    [anon_sym_LBRACE] = ACTIONS(4766),
    [anon_sym_RBRACE] = ACTIONS(4766),
    [anon_sym_LBRACK] = ACTIONS(4766),
    [anon_sym_RBRACK] = ACTIONS(4766),
    [anon_sym_PLUS] = ACTIONS(6712),
    [anon_sym_STAR] = ACTIONS(6712),
    [anon_sym_COMMA] = ACTIONS(4766),
    [anon_sym_AMP] = ACTIONS(6712),
    [anon_sym_DASH] = ACTIONS(6712),
    [anon_sym_DOT] = ACTIONS(6712),
    [anon_sym_DASH_EQ] = ACTIONS(4766),
    [anon_sym_DASH_GT] = ACTIONS(4766),
    [anon_sym_BANG_EQ] = ACTIONS(4766),
    [anon_sym_STAR_EQ] = ACTIONS(4766),
    [anon_sym_SLASH] = ACTIONS(6712),
    [anon_sym_SLASH_EQ] = ACTIONS(4766),
    [anon_sym_AMP_AMP] = ACTIONS(4766),
    [anon_sym_AMP_EQ] = ACTIONS(4766),
    [anon_sym_PERCENT] = ACTIONS(6712),
    [anon_sym_PERCENT_EQ] = ACTIONS(4766),
    [anon_sym_CARET] = ACTIONS(6712),
    [anon_sym_CARET_EQ] = ACTIONS(4766),
    [anon_sym_PLUS_EQ] = ACTIONS(4766),
    [anon_sym_LT] = ACTIONS(6712),
    [anon_sym_LT_LT] = ACTIONS(6712),
    [anon_sym_LT_LT_EQ] = ACTIONS(4766),
    [anon_sym_LT_EQ] = ACTIONS(4766),
    [anon_sym_EQ] = ACTIONS(6712),
    [anon_sym_EQ_EQ] = ACTIONS(4766),
    [anon_sym_GT] = ACTIONS(6712),
    [anon_sym_GT_EQ] = ACTIONS(4766),
    [anon_sym_GT_GT] = ACTIONS(6712),
    [anon_sym_GT_GT_EQ] = ACTIONS(4766),
    [anon_sym_PIPE] = ACTIONS(6712),
    [anon_sym_PIPE_EQ] = ACTIONS(4766),
    [anon_sym_PIPE_PIPE] = ACTIONS(4766),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_DOT_DOT] = ACTIONS(6712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4766),
    [anon_sym_as] = ACTIONS(4766),
    [sym_line_comment] = ACTIONS(7),
  },
  [2613] = {
    [sym_function_modifiers] = STATE(370),
    [sym_self_parameter] = STATE(2121),
    [sym_variadic_parameter] = STATE(2121),
    [sym_parameter] = STATE(2121),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2122),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(839),
    [sym_array_type] = STATE(2122),
    [sym_function_type] = STATE(2122),
    [sym_tuple_type] = STATE(2122),
    [sym_unit_type] = STATE(2122),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2122),
    [sym_reference_type] = STATE(2122),
    [sym_pointer_type] = STATE(2122),
    [sym_empty_type] = STATE(2122),
    [sym_abstract_type] = STATE(2121),
    [sym_dynamic_type] = STATE(2122),
    [sym_macro_invocation] = STATE(2122),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [sym_reference_pattern_in_parameter] = STATE(840),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_RPAREN] = ACTIONS(6714),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(1740),
    [anon_sym_i8] = ACTIONS(1740),
    [anon_sym_u16] = ACTIONS(1740),
    [anon_sym_i16] = ACTIONS(1740),
    [anon_sym_u32] = ACTIONS(1740),
    [anon_sym_i32] = ACTIONS(1740),
    [anon_sym_u64] = ACTIONS(1740),
    [anon_sym_i64] = ACTIONS(1740),
    [anon_sym_u128] = ACTIONS(1740),
    [anon_sym_i128] = ACTIONS(1740),
    [anon_sym_isize] = ACTIONS(1740),
    [anon_sym_usize] = ACTIONS(1740),
    [anon_sym_f32] = ACTIONS(1740),
    [anon_sym_f64] = ACTIONS(1740),
    [anon_sym_bool] = ACTIONS(1740),
    [anon_sym_str] = ACTIONS(1740),
    [anon_sym_char] = ACTIONS(1740),
    [anon_sym__] = ACTIONS(4770),
    [anon_sym_AMP] = ACTIONS(1744),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1746),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(1748),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_union] = ACTIONS(1752),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(1754),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1756),
    [sym_self] = ACTIONS(1758),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2614] = {
    [aux_sym_parameters_repeat1] = STATE(2124),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(6714),
    [anon_sym_COMMA] = ACTIONS(6716),
    [sym_line_comment] = ACTIONS(7),
  },
  [2615] = {
    [sym_bracketed_type] = STATE(663),
    [sym_generic_type] = STATE(3078),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(3079),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(2627),
    [anon_sym_i8] = ACTIONS(2627),
    [anon_sym_u16] = ACTIONS(2627),
    [anon_sym_i16] = ACTIONS(2627),
    [anon_sym_u32] = ACTIONS(2627),
    [anon_sym_i32] = ACTIONS(2627),
    [anon_sym_u64] = ACTIONS(2627),
    [anon_sym_i64] = ACTIONS(2627),
    [anon_sym_u128] = ACTIONS(2627),
    [anon_sym_i128] = ACTIONS(2627),
    [anon_sym_isize] = ACTIONS(2627),
    [anon_sym_usize] = ACTIONS(2627),
    [anon_sym_f32] = ACTIONS(2627),
    [anon_sym_f64] = ACTIONS(2627),
    [anon_sym_bool] = ACTIONS(2627),
    [anon_sym_str] = ACTIONS(2627),
    [anon_sym_char] = ACTIONS(2627),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_LT] = ACTIONS(31),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6718),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(2631),
  },
  [2616] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4810),
    [anon_sym_LPAREN] = ACTIONS(4810),
    [anon_sym_RPAREN] = ACTIONS(4810),
    [anon_sym_LBRACE] = ACTIONS(4810),
    [anon_sym_RBRACE] = ACTIONS(4810),
    [anon_sym_LBRACK] = ACTIONS(4810),
    [anon_sym_RBRACK] = ACTIONS(4810),
    [anon_sym_PLUS] = ACTIONS(6720),
    [anon_sym_STAR] = ACTIONS(6720),
    [anon_sym_COMMA] = ACTIONS(4810),
    [anon_sym_AMP] = ACTIONS(6720),
    [anon_sym_DASH] = ACTIONS(6720),
    [anon_sym_DOT] = ACTIONS(6720),
    [anon_sym_DASH_EQ] = ACTIONS(4810),
    [anon_sym_BANG_EQ] = ACTIONS(4810),
    [anon_sym_STAR_EQ] = ACTIONS(4810),
    [anon_sym_SLASH] = ACTIONS(6720),
    [anon_sym_SLASH_EQ] = ACTIONS(4810),
    [anon_sym_AMP_AMP] = ACTIONS(4810),
    [anon_sym_AMP_EQ] = ACTIONS(4810),
    [anon_sym_PERCENT] = ACTIONS(6720),
    [anon_sym_PERCENT_EQ] = ACTIONS(4810),
    [anon_sym_CARET] = ACTIONS(6720),
    [anon_sym_CARET_EQ] = ACTIONS(4810),
    [anon_sym_PLUS_EQ] = ACTIONS(4810),
    [anon_sym_LT] = ACTIONS(6720),
    [anon_sym_LT_LT] = ACTIONS(6720),
    [anon_sym_LT_LT_EQ] = ACTIONS(4810),
    [anon_sym_LT_EQ] = ACTIONS(4810),
    [anon_sym_EQ] = ACTIONS(6720),
    [anon_sym_EQ_EQ] = ACTIONS(4810),
    [anon_sym_GT] = ACTIONS(6720),
    [anon_sym_GT_EQ] = ACTIONS(4810),
    [anon_sym_GT_GT] = ACTIONS(6720),
    [anon_sym_GT_GT_EQ] = ACTIONS(4810),
    [anon_sym_PIPE] = ACTIONS(6720),
    [anon_sym_PIPE_EQ] = ACTIONS(4810),
    [anon_sym_PIPE_PIPE] = ACTIONS(4810),
    [anon_sym_QMARK] = ACTIONS(4810),
    [anon_sym_DOT_DOT] = ACTIONS(6720),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4810),
    [anon_sym_as] = ACTIONS(4810),
    [sym_line_comment] = ACTIONS(7),
  },
  [2617] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4810),
    [anon_sym_LPAREN] = ACTIONS(4810),
    [anon_sym_RPAREN] = ACTIONS(4810),
    [anon_sym_LBRACE] = ACTIONS(4810),
    [anon_sym_RBRACE] = ACTIONS(4810),
    [anon_sym_LBRACK] = ACTIONS(4810),
    [anon_sym_RBRACK] = ACTIONS(4810),
    [anon_sym_PLUS] = ACTIONS(6720),
    [anon_sym_STAR] = ACTIONS(6720),
    [anon_sym_COMMA] = ACTIONS(4810),
    [anon_sym_AMP] = ACTIONS(6720),
    [anon_sym_DASH] = ACTIONS(6720),
    [anon_sym_DOT] = ACTIONS(6720),
    [anon_sym_DASH_EQ] = ACTIONS(4810),
    [anon_sym_BANG_EQ] = ACTIONS(4810),
    [anon_sym_STAR_EQ] = ACTIONS(4810),
    [anon_sym_SLASH] = ACTIONS(6720),
    [anon_sym_SLASH_EQ] = ACTIONS(4810),
    [anon_sym_AMP_AMP] = ACTIONS(4810),
    [anon_sym_AMP_EQ] = ACTIONS(4810),
    [anon_sym_PERCENT] = ACTIONS(6720),
    [anon_sym_PERCENT_EQ] = ACTIONS(4810),
    [anon_sym_CARET] = ACTIONS(6720),
    [anon_sym_CARET_EQ] = ACTIONS(4810),
    [anon_sym_PLUS_EQ] = ACTIONS(4810),
    [anon_sym_LT] = ACTIONS(6720),
    [anon_sym_LT_LT] = ACTIONS(6720),
    [anon_sym_LT_LT_EQ] = ACTIONS(4810),
    [anon_sym_LT_EQ] = ACTIONS(4810),
    [anon_sym_EQ] = ACTIONS(6720),
    [anon_sym_EQ_EQ] = ACTIONS(4810),
    [anon_sym_GT] = ACTIONS(6720),
    [anon_sym_GT_EQ] = ACTIONS(4810),
    [anon_sym_GT_GT] = ACTIONS(6720),
    [anon_sym_GT_GT_EQ] = ACTIONS(4810),
    [anon_sym_PIPE] = ACTIONS(6720),
    [anon_sym_PIPE_EQ] = ACTIONS(4810),
    [anon_sym_PIPE_PIPE] = ACTIONS(4810),
    [anon_sym_QMARK] = ACTIONS(4810),
    [anon_sym_DOT_DOT] = ACTIONS(6720),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4810),
    [anon_sym_as] = ACTIONS(4810),
    [sym_line_comment] = ACTIONS(7),
  },
  [2618] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4836),
    [anon_sym_LPAREN] = ACTIONS(4836),
    [anon_sym_RPAREN] = ACTIONS(4836),
    [anon_sym_LBRACE] = ACTIONS(4836),
    [anon_sym_RBRACE] = ACTIONS(4836),
    [anon_sym_LBRACK] = ACTIONS(4836),
    [anon_sym_RBRACK] = ACTIONS(4836),
    [anon_sym_PLUS] = ACTIONS(6722),
    [anon_sym_STAR] = ACTIONS(6722),
    [anon_sym_COMMA] = ACTIONS(4836),
    [anon_sym_AMP] = ACTIONS(6722),
    [anon_sym_DASH] = ACTIONS(6722),
    [anon_sym_DOT] = ACTIONS(6722),
    [anon_sym_DASH_EQ] = ACTIONS(4836),
    [anon_sym_BANG_EQ] = ACTIONS(4836),
    [anon_sym_STAR_EQ] = ACTIONS(4836),
    [anon_sym_SLASH] = ACTIONS(6722),
    [anon_sym_SLASH_EQ] = ACTIONS(4836),
    [anon_sym_AMP_AMP] = ACTIONS(4836),
    [anon_sym_AMP_EQ] = ACTIONS(4836),
    [anon_sym_PERCENT] = ACTIONS(6722),
    [anon_sym_PERCENT_EQ] = ACTIONS(4836),
    [anon_sym_CARET] = ACTIONS(6722),
    [anon_sym_CARET_EQ] = ACTIONS(4836),
    [anon_sym_PLUS_EQ] = ACTIONS(4836),
    [anon_sym_LT] = ACTIONS(6722),
    [anon_sym_LT_LT] = ACTIONS(6722),
    [anon_sym_LT_LT_EQ] = ACTIONS(4836),
    [anon_sym_LT_EQ] = ACTIONS(4836),
    [anon_sym_EQ] = ACTIONS(6722),
    [anon_sym_EQ_EQ] = ACTIONS(4836),
    [anon_sym_GT] = ACTIONS(6722),
    [anon_sym_GT_EQ] = ACTIONS(4836),
    [anon_sym_GT_GT] = ACTIONS(6722),
    [anon_sym_GT_GT_EQ] = ACTIONS(4836),
    [anon_sym_PIPE] = ACTIONS(6722),
    [anon_sym_PIPE_EQ] = ACTIONS(4836),
    [anon_sym_PIPE_PIPE] = ACTIONS(4836),
    [anon_sym_QMARK] = ACTIONS(4836),
    [anon_sym_DOT_DOT] = ACTIONS(6722),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4836),
    [anon_sym_as] = ACTIONS(4836),
    [sym_line_comment] = ACTIONS(7),
  },
  [2619] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4836),
    [anon_sym_LPAREN] = ACTIONS(4836),
    [anon_sym_RPAREN] = ACTIONS(4836),
    [anon_sym_LBRACE] = ACTIONS(4836),
    [anon_sym_RBRACE] = ACTIONS(4836),
    [anon_sym_LBRACK] = ACTIONS(4836),
    [anon_sym_RBRACK] = ACTIONS(4836),
    [anon_sym_PLUS] = ACTIONS(6722),
    [anon_sym_STAR] = ACTIONS(6722),
    [anon_sym_COMMA] = ACTIONS(4836),
    [anon_sym_AMP] = ACTIONS(6722),
    [anon_sym_DASH] = ACTIONS(6722),
    [anon_sym_DOT] = ACTIONS(6722),
    [anon_sym_DASH_EQ] = ACTIONS(4836),
    [anon_sym_BANG_EQ] = ACTIONS(4836),
    [anon_sym_STAR_EQ] = ACTIONS(4836),
    [anon_sym_SLASH] = ACTIONS(6722),
    [anon_sym_SLASH_EQ] = ACTIONS(4836),
    [anon_sym_AMP_AMP] = ACTIONS(4836),
    [anon_sym_AMP_EQ] = ACTIONS(4836),
    [anon_sym_PERCENT] = ACTIONS(6722),
    [anon_sym_PERCENT_EQ] = ACTIONS(4836),
    [anon_sym_CARET] = ACTIONS(6722),
    [anon_sym_CARET_EQ] = ACTIONS(4836),
    [anon_sym_PLUS_EQ] = ACTIONS(4836),
    [anon_sym_LT] = ACTIONS(6722),
    [anon_sym_LT_LT] = ACTIONS(6722),
    [anon_sym_LT_LT_EQ] = ACTIONS(4836),
    [anon_sym_LT_EQ] = ACTIONS(4836),
    [anon_sym_EQ] = ACTIONS(6722),
    [anon_sym_EQ_EQ] = ACTIONS(4836),
    [anon_sym_GT] = ACTIONS(6722),
    [anon_sym_GT_EQ] = ACTIONS(4836),
    [anon_sym_GT_GT] = ACTIONS(6722),
    [anon_sym_GT_GT_EQ] = ACTIONS(4836),
    [anon_sym_PIPE] = ACTIONS(6722),
    [anon_sym_PIPE_EQ] = ACTIONS(4836),
    [anon_sym_PIPE_PIPE] = ACTIONS(4836),
    [anon_sym_QMARK] = ACTIONS(4836),
    [anon_sym_DOT_DOT] = ACTIONS(6722),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4836),
    [anon_sym_as] = ACTIONS(4836),
    [sym_line_comment] = ACTIONS(7),
  },
  [2620] = {
    [sym_function_modifiers] = STATE(665),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3080),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(667),
    [sym_array_type] = STATE(3080),
    [sym_function_type] = STATE(3080),
    [sym_tuple_type] = STATE(3080),
    [sym_unit_type] = STATE(3080),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(3080),
    [sym_reference_type] = STATE(3080),
    [sym_pointer_type] = STATE(3080),
    [sym_empty_type] = STATE(3080),
    [sym_abstract_type] = STATE(3081),
    [sym_dynamic_type] = STATE(3080),
    [sym_macro_invocation] = STATE(3080),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(671),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1291),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1295),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1301),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1305),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2621] = {
    [sym_function_modifiers] = STATE(665),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3082),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(667),
    [sym_array_type] = STATE(3082),
    [sym_function_type] = STATE(3082),
    [sym_tuple_type] = STATE(3082),
    [sym_unit_type] = STATE(3082),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(3082),
    [sym_reference_type] = STATE(3082),
    [sym_pointer_type] = STATE(3082),
    [sym_empty_type] = STATE(3082),
    [sym_abstract_type] = STATE(3083),
    [sym_dynamic_type] = STATE(3082),
    [sym_macro_invocation] = STATE(3082),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(671),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1291),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1295),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1301),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1305),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2622] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1732),
    [anon_sym_LPAREN] = ACTIONS(1732),
    [anon_sym_RPAREN] = ACTIONS(1732),
    [anon_sym_LBRACE] = ACTIONS(1732),
    [anon_sym_RBRACE] = ACTIONS(1732),
    [anon_sym_LBRACK] = ACTIONS(1732),
    [anon_sym_RBRACK] = ACTIONS(1732),
    [anon_sym_PLUS] = ACTIONS(1734),
    [anon_sym_STAR] = ACTIONS(1734),
    [anon_sym_COMMA] = ACTIONS(1732),
    [anon_sym_AMP] = ACTIONS(1734),
    [anon_sym_DASH] = ACTIONS(1734),
    [anon_sym_DOT] = ACTIONS(1734),
    [anon_sym_DASH_EQ] = ACTIONS(1732),
    [anon_sym_BANG_EQ] = ACTIONS(1732),
    [anon_sym_STAR_EQ] = ACTIONS(1732),
    [anon_sym_SLASH] = ACTIONS(1734),
    [anon_sym_SLASH_EQ] = ACTIONS(1732),
    [anon_sym_AMP_AMP] = ACTIONS(1732),
    [anon_sym_AMP_EQ] = ACTIONS(1732),
    [anon_sym_PERCENT] = ACTIONS(1734),
    [anon_sym_PERCENT_EQ] = ACTIONS(1732),
    [anon_sym_CARET] = ACTIONS(1734),
    [anon_sym_CARET_EQ] = ACTIONS(1732),
    [anon_sym_PLUS_EQ] = ACTIONS(1732),
    [anon_sym_LT] = ACTIONS(1734),
    [anon_sym_LT_LT] = ACTIONS(1734),
    [anon_sym_LT_LT_EQ] = ACTIONS(1732),
    [anon_sym_LT_EQ] = ACTIONS(1732),
    [anon_sym_EQ] = ACTIONS(1734),
    [anon_sym_EQ_EQ] = ACTIONS(1732),
    [anon_sym_GT] = ACTIONS(1734),
    [anon_sym_GT_EQ] = ACTIONS(1732),
    [anon_sym_GT_GT] = ACTIONS(1734),
    [anon_sym_GT_GT_EQ] = ACTIONS(1732),
    [anon_sym_PIPE] = ACTIONS(1734),
    [anon_sym_PIPE_EQ] = ACTIONS(1732),
    [anon_sym_PIPE_PIPE] = ACTIONS(1732),
    [anon_sym_QMARK] = ACTIONS(1732),
    [anon_sym_DOT_DOT] = ACTIONS(1734),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1732),
    [anon_sym_as] = ACTIONS(1732),
    [sym_line_comment] = ACTIONS(7),
  },
  [2623] = {
    [sym_function_modifiers] = STATE(677),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2156),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(679),
    [sym_array_type] = STATE(2156),
    [sym_function_type] = STATE(2156),
    [sym_tuple_type] = STATE(2156),
    [sym_unit_type] = STATE(2156),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2156),
    [sym_reference_type] = STATE(2156),
    [sym_pointer_type] = STATE(2156),
    [sym_empty_type] = STATE(2156),
    [sym_abstract_type] = STATE(2157),
    [sym_dynamic_type] = STATE(2156),
    [sym_macro_invocation] = STATE(2156),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(680),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1315),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1317),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1319),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1321),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2624] = {
    [sym_function_modifiers] = STATE(677),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2158),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(679),
    [sym_array_type] = STATE(2158),
    [sym_function_type] = STATE(2158),
    [sym_tuple_type] = STATE(2158),
    [sym_unit_type] = STATE(2158),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2158),
    [sym_reference_type] = STATE(2158),
    [sym_pointer_type] = STATE(2158),
    [sym_empty_type] = STATE(2158),
    [sym_abstract_type] = STATE(2159),
    [sym_dynamic_type] = STATE(2158),
    [sym_macro_invocation] = STATE(2158),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(680),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1315),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1317),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1319),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1321),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2625] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(3084),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [2626] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3085),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(3085),
    [sym_macro_invocation] = STATE(3085),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3085),
    [sym_unary_expression] = STATE(3085),
    [sym_try_expression] = STATE(3085),
    [sym_reference_expression] = STATE(3085),
    [sym_binary_expression] = STATE(3085),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3085),
    [sym_call_expression] = STATE(3085),
    [sym_array_expression] = STATE(3085),
    [sym_parenthesized_expression] = STATE(3085),
    [sym_tuple_expression] = STATE(3085),
    [sym_unit_expression] = STATE(3085),
    [sym_struct_expression] = STATE(3085),
    [sym_if_expression] = STATE(3085),
    [sym_if_let_expression] = STATE(3085),
    [sym_match_expression] = STATE(3085),
    [sym_while_expression] = STATE(3085),
    [sym_while_let_expression] = STATE(3085),
    [sym_loop_expression] = STATE(3085),
    [sym_for_expression] = STATE(3085),
    [sym_closure_expression] = STATE(3085),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3085),
    [sym_continue_expression] = STATE(3085),
    [sym_index_expression] = STATE(3085),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3085),
    [sym_block] = STATE(3085),
    [sym__literal] = STATE(3085),
    [sym_string_literal] = STATE(3085),
    [sym_boolean_literal] = STATE(3085),
    [sym_raw_string_literal] = ACTIONS(6724),
    [sym_float_literal] = ACTIONS(6724),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(6724),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6724),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [2627] = {
    [sym_raw_string_literal] = ACTIONS(5796),
    [sym_float_literal] = ACTIONS(5796),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5796),
    [anon_sym_LPAREN] = ACTIONS(5796),
    [anon_sym_RPAREN] = ACTIONS(5796),
    [anon_sym_LBRACE] = ACTIONS(5796),
    [anon_sym_RBRACE] = ACTIONS(5796),
    [anon_sym_EQ_GT] = ACTIONS(5796),
    [anon_sym_LBRACK] = ACTIONS(5796),
    [anon_sym_RBRACK] = ACTIONS(5796),
    [anon_sym_COLON] = ACTIONS(6726),
    [anon_sym_DOLLAR] = ACTIONS(6726),
    [anon_sym_PLUS] = ACTIONS(6726),
    [anon_sym_STAR] = ACTIONS(6726),
    [anon_sym_COMMA] = ACTIONS(5796),
    [anon_sym_u8] = ACTIONS(6726),
    [anon_sym_i8] = ACTIONS(6726),
    [anon_sym_u16] = ACTIONS(6726),
    [anon_sym_i16] = ACTIONS(6726),
    [anon_sym_u32] = ACTIONS(6726),
    [anon_sym_i32] = ACTIONS(6726),
    [anon_sym_u64] = ACTIONS(6726),
    [anon_sym_i64] = ACTIONS(6726),
    [anon_sym_u128] = ACTIONS(6726),
    [anon_sym_i128] = ACTIONS(6726),
    [anon_sym_isize] = ACTIONS(6726),
    [anon_sym_usize] = ACTIONS(6726),
    [anon_sym_f32] = ACTIONS(6726),
    [anon_sym_f64] = ACTIONS(6726),
    [anon_sym_bool] = ACTIONS(6726),
    [anon_sym_str] = ACTIONS(6726),
    [anon_sym_char] = ACTIONS(6726),
    [anon_sym__] = ACTIONS(6726),
    [anon_sym_AMP] = ACTIONS(6726),
    [anon_sym_DASH] = ACTIONS(6726),
    [anon_sym_DOT] = ACTIONS(6726),
    [anon_sym_DASH_EQ] = ACTIONS(5796),
    [anon_sym_DASH_GT] = ACTIONS(5796),
    [anon_sym_COLON_COLON] = ACTIONS(5796),
    [anon_sym_BANG] = ACTIONS(6726),
    [anon_sym_BANG_EQ] = ACTIONS(5796),
    [anon_sym_AT] = ACTIONS(5796),
    [anon_sym_STAR_EQ] = ACTIONS(5796),
    [anon_sym_SLASH] = ACTIONS(6726),
    [anon_sym_SLASH_EQ] = ACTIONS(5796),
    [anon_sym_AMP_AMP] = ACTIONS(5796),
    [anon_sym_AMP_EQ] = ACTIONS(5796),
    [anon_sym_POUND] = ACTIONS(5796),
    [anon_sym_PERCENT] = ACTIONS(6726),
    [anon_sym_PERCENT_EQ] = ACTIONS(5796),
    [anon_sym_CARET] = ACTIONS(6726),
    [anon_sym_CARET_EQ] = ACTIONS(5796),
    [anon_sym_PLUS_EQ] = ACTIONS(5796),
    [anon_sym_LT] = ACTIONS(6726),
    [anon_sym_LT_LT] = ACTIONS(6726),
    [anon_sym_LT_LT_EQ] = ACTIONS(5796),
    [anon_sym_LT_EQ] = ACTIONS(5796),
    [anon_sym_EQ] = ACTIONS(6726),
    [anon_sym_EQ_EQ] = ACTIONS(5796),
    [anon_sym_GT] = ACTIONS(6726),
    [anon_sym_GT_EQ] = ACTIONS(5796),
    [anon_sym_GT_GT] = ACTIONS(6726),
    [anon_sym_GT_GT_EQ] = ACTIONS(5796),
    [anon_sym_PIPE] = ACTIONS(6726),
    [anon_sym_PIPE_EQ] = ACTIONS(5796),
    [anon_sym_PIPE_PIPE] = ACTIONS(5796),
    [anon_sym_TILDE] = ACTIONS(5796),
    [anon_sym_QMARK] = ACTIONS(5796),
    [anon_sym_SQUOTE] = ACTIONS(6726),
    [anon_sym_DOT_DOT] = ACTIONS(6726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5796),
    [anon_sym_as] = ACTIONS(6726),
    [anon_sym_break] = ACTIONS(6726),
    [anon_sym_const] = ACTIONS(6726),
    [anon_sym_continue] = ACTIONS(6726),
    [anon_sym_default] = ACTIONS(6726),
    [anon_sym_enum] = ACTIONS(6726),
    [anon_sym_fn] = ACTIONS(6726),
    [anon_sym_for] = ACTIONS(6726),
    [anon_sym_if] = ACTIONS(6726),
    [anon_sym_impl] = ACTIONS(6726),
    [anon_sym_let] = ACTIONS(6726),
    [anon_sym_loop] = ACTIONS(6726),
    [anon_sym_match] = ACTIONS(6726),
    [anon_sym_mod] = ACTIONS(6726),
    [anon_sym_pub] = ACTIONS(6726),
    [anon_sym_return] = ACTIONS(6726),
    [anon_sym_static] = ACTIONS(6726),
    [anon_sym_struct] = ACTIONS(6726),
    [anon_sym_trait] = ACTIONS(6726),
    [anon_sym_type] = ACTIONS(6726),
    [anon_sym_union] = ACTIONS(6726),
    [anon_sym_unsafe] = ACTIONS(6726),
    [anon_sym_use] = ACTIONS(6726),
    [anon_sym_where] = ACTIONS(6726),
    [anon_sym_while] = ACTIONS(6726),
    [sym_mutable_specifier] = ACTIONS(6726),
    [sym_integer_literal] = ACTIONS(5796),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5796),
    [sym_char_literal] = ACTIONS(5796),
    [anon_sym_true] = ACTIONS(6726),
    [anon_sym_false] = ACTIONS(6726),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6726),
    [sym_self] = ACTIONS(6726),
    [sym_super] = ACTIONS(6726),
    [sym_crate] = ACTIONS(6726),
    [sym_metavariable] = ACTIONS(5796),
  },
  [2628] = {
    [sym_block_comment] = ACTIONS(7),
    [aux_sym_SLASH_LBRACK_CARET_PLUS_STAR_RBRACK_PLUS_SLASH] = ACTIONS(6728),
    [anon_sym_PLUS] = ACTIONS(6730),
    [anon_sym_STAR] = ACTIONS(6730),
    [sym_line_comment] = ACTIONS(401),
  },
  [2629] = {
    [sym__token_pattern] = STATE(2034),
    [sym_token_tree_pattern] = STATE(2034),
    [sym_token_binding_pattern] = STATE(2034),
    [sym_token_repetition_pattern] = STATE(2034),
    [sym__literal] = STATE(2034),
    [sym_string_literal] = STATE(2034),
    [sym_boolean_literal] = STATE(2034),
    [aux_sym_token_tree_pattern_repeat1] = STATE(2034),
    [sym_raw_string_literal] = ACTIONS(4507),
    [sym_float_literal] = ACTIONS(4507),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4507),
    [anon_sym_LPAREN] = ACTIONS(2681),
    [anon_sym_RPAREN] = ACTIONS(6732),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_EQ_GT] = ACTIONS(4507),
    [anon_sym_LBRACK] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(4511),
    [anon_sym_DOLLAR] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(4511),
    [anon_sym_STAR] = ACTIONS(4511),
    [anon_sym_COMMA] = ACTIONS(4507),
    [anon_sym_u8] = ACTIONS(2693),
    [anon_sym_i8] = ACTIONS(2693),
    [anon_sym_u16] = ACTIONS(2693),
    [anon_sym_i16] = ACTIONS(2693),
    [anon_sym_u32] = ACTIONS(2693),
    [anon_sym_i32] = ACTIONS(2693),
    [anon_sym_u64] = ACTIONS(2693),
    [anon_sym_i64] = ACTIONS(2693),
    [anon_sym_u128] = ACTIONS(2693),
    [anon_sym_i128] = ACTIONS(2693),
    [anon_sym_isize] = ACTIONS(2693),
    [anon_sym_usize] = ACTIONS(2693),
    [anon_sym_f32] = ACTIONS(2693),
    [anon_sym_f64] = ACTIONS(2693),
    [anon_sym_bool] = ACTIONS(2693),
    [anon_sym_str] = ACTIONS(2693),
    [anon_sym_char] = ACTIONS(2693),
    [anon_sym__] = ACTIONS(4511),
    [anon_sym_AMP] = ACTIONS(4511),
    [anon_sym_DASH] = ACTIONS(4511),
    [anon_sym_DOT] = ACTIONS(4511),
    [anon_sym_DASH_EQ] = ACTIONS(4507),
    [anon_sym_DASH_GT] = ACTIONS(4507),
    [anon_sym_COLON_COLON] = ACTIONS(4507),
    [anon_sym_BANG] = ACTIONS(4511),
    [anon_sym_BANG_EQ] = ACTIONS(4507),
    [anon_sym_AT] = ACTIONS(4507),
    [anon_sym_STAR_EQ] = ACTIONS(4507),
    [anon_sym_SLASH] = ACTIONS(4511),
    [anon_sym_SLASH_EQ] = ACTIONS(4507),
    [anon_sym_AMP_AMP] = ACTIONS(4507),
    [anon_sym_AMP_EQ] = ACTIONS(4507),
    [anon_sym_POUND] = ACTIONS(4507),
    [anon_sym_PERCENT] = ACTIONS(4511),
    [anon_sym_PERCENT_EQ] = ACTIONS(4507),
    [anon_sym_CARET] = ACTIONS(4511),
    [anon_sym_CARET_EQ] = ACTIONS(4507),
    [anon_sym_PLUS_EQ] = ACTIONS(4507),
    [anon_sym_LT] = ACTIONS(4511),
    [anon_sym_LT_LT] = ACTIONS(4511),
    [anon_sym_LT_LT_EQ] = ACTIONS(4507),
    [anon_sym_LT_EQ] = ACTIONS(4507),
    [anon_sym_EQ] = ACTIONS(4511),
    [anon_sym_EQ_EQ] = ACTIONS(4507),
    [anon_sym_GT] = ACTIONS(4511),
    [anon_sym_GT_EQ] = ACTIONS(4507),
    [anon_sym_GT_GT] = ACTIONS(4511),
    [anon_sym_GT_GT_EQ] = ACTIONS(4507),
    [anon_sym_PIPE] = ACTIONS(4511),
    [anon_sym_PIPE_EQ] = ACTIONS(4507),
    [anon_sym_PIPE_PIPE] = ACTIONS(4507),
    [anon_sym_TILDE] = ACTIONS(4507),
    [anon_sym_QMARK] = ACTIONS(4507),
    [anon_sym_SQUOTE] = ACTIONS(4511),
    [anon_sym_DOT_DOT] = ACTIONS(4511),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4507),
    [anon_sym_as] = ACTIONS(4511),
    [anon_sym_break] = ACTIONS(4511),
    [anon_sym_const] = ACTIONS(4511),
    [anon_sym_continue] = ACTIONS(4511),
    [anon_sym_default] = ACTIONS(4511),
    [anon_sym_enum] = ACTIONS(4511),
    [anon_sym_fn] = ACTIONS(4511),
    [anon_sym_for] = ACTIONS(4511),
    [anon_sym_if] = ACTIONS(4511),
    [anon_sym_impl] = ACTIONS(4511),
    [anon_sym_let] = ACTIONS(4511),
    [anon_sym_loop] = ACTIONS(4511),
    [anon_sym_match] = ACTIONS(4511),
    [anon_sym_mod] = ACTIONS(4511),
    [anon_sym_pub] = ACTIONS(4511),
    [anon_sym_return] = ACTIONS(4511),
    [anon_sym_static] = ACTIONS(4511),
    [anon_sym_struct] = ACTIONS(4511),
    [anon_sym_trait] = ACTIONS(4511),
    [anon_sym_type] = ACTIONS(4511),
    [anon_sym_union] = ACTIONS(4511),
    [anon_sym_unsafe] = ACTIONS(4511),
    [anon_sym_use] = ACTIONS(4511),
    [anon_sym_where] = ACTIONS(4511),
    [anon_sym_while] = ACTIONS(4511),
    [sym_mutable_specifier] = ACTIONS(4511),
    [sym_integer_literal] = ACTIONS(4507),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(4507),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4511),
    [sym_self] = ACTIONS(4511),
    [sym_super] = ACTIONS(4511),
    [sym_crate] = ACTIONS(4511),
    [sym_metavariable] = ACTIONS(2695),
  },
  [2630] = {
    [sym_raw_string_literal] = ACTIONS(6734),
    [sym_float_literal] = ACTIONS(6734),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6734),
    [anon_sym_LPAREN] = ACTIONS(6734),
    [anon_sym_RPAREN] = ACTIONS(6734),
    [anon_sym_LBRACE] = ACTIONS(6734),
    [anon_sym_RBRACE] = ACTIONS(6734),
    [anon_sym_EQ_GT] = ACTIONS(6734),
    [anon_sym_LBRACK] = ACTIONS(6734),
    [anon_sym_RBRACK] = ACTIONS(6734),
    [anon_sym_COLON] = ACTIONS(6736),
    [anon_sym_DOLLAR] = ACTIONS(6736),
    [anon_sym_PLUS] = ACTIONS(6736),
    [anon_sym_STAR] = ACTIONS(6736),
    [anon_sym_COMMA] = ACTIONS(6734),
    [anon_sym_u8] = ACTIONS(6736),
    [anon_sym_i8] = ACTIONS(6736),
    [anon_sym_u16] = ACTIONS(6736),
    [anon_sym_i16] = ACTIONS(6736),
    [anon_sym_u32] = ACTIONS(6736),
    [anon_sym_i32] = ACTIONS(6736),
    [anon_sym_u64] = ACTIONS(6736),
    [anon_sym_i64] = ACTIONS(6736),
    [anon_sym_u128] = ACTIONS(6736),
    [anon_sym_i128] = ACTIONS(6736),
    [anon_sym_isize] = ACTIONS(6736),
    [anon_sym_usize] = ACTIONS(6736),
    [anon_sym_f32] = ACTIONS(6736),
    [anon_sym_f64] = ACTIONS(6736),
    [anon_sym_bool] = ACTIONS(6736),
    [anon_sym_str] = ACTIONS(6736),
    [anon_sym_char] = ACTIONS(6736),
    [anon_sym__] = ACTIONS(6736),
    [anon_sym_AMP] = ACTIONS(6736),
    [anon_sym_DASH] = ACTIONS(6736),
    [anon_sym_DOT] = ACTIONS(6736),
    [anon_sym_DASH_EQ] = ACTIONS(6734),
    [anon_sym_DASH_GT] = ACTIONS(6734),
    [anon_sym_COLON_COLON] = ACTIONS(6734),
    [anon_sym_BANG] = ACTIONS(6736),
    [anon_sym_BANG_EQ] = ACTIONS(6734),
    [anon_sym_AT] = ACTIONS(6734),
    [anon_sym_STAR_EQ] = ACTIONS(6734),
    [anon_sym_SLASH] = ACTIONS(6736),
    [anon_sym_SLASH_EQ] = ACTIONS(6734),
    [anon_sym_AMP_AMP] = ACTIONS(6734),
    [anon_sym_AMP_EQ] = ACTIONS(6734),
    [anon_sym_POUND] = ACTIONS(6734),
    [anon_sym_PERCENT] = ACTIONS(6736),
    [anon_sym_PERCENT_EQ] = ACTIONS(6734),
    [anon_sym_CARET] = ACTIONS(6736),
    [anon_sym_CARET_EQ] = ACTIONS(6734),
    [anon_sym_PLUS_EQ] = ACTIONS(6734),
    [anon_sym_LT] = ACTIONS(6736),
    [anon_sym_LT_LT] = ACTIONS(6736),
    [anon_sym_LT_LT_EQ] = ACTIONS(6734),
    [anon_sym_LT_EQ] = ACTIONS(6734),
    [anon_sym_EQ] = ACTIONS(6736),
    [anon_sym_EQ_EQ] = ACTIONS(6734),
    [anon_sym_GT] = ACTIONS(6736),
    [anon_sym_GT_EQ] = ACTIONS(6734),
    [anon_sym_GT_GT] = ACTIONS(6736),
    [anon_sym_GT_GT_EQ] = ACTIONS(6734),
    [anon_sym_PIPE] = ACTIONS(6736),
    [anon_sym_PIPE_EQ] = ACTIONS(6734),
    [anon_sym_PIPE_PIPE] = ACTIONS(6734),
    [anon_sym_TILDE] = ACTIONS(6734),
    [anon_sym_QMARK] = ACTIONS(6734),
    [anon_sym_SQUOTE] = ACTIONS(6736),
    [anon_sym_DOT_DOT] = ACTIONS(6736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6734),
    [anon_sym_as] = ACTIONS(6736),
    [anon_sym_break] = ACTIONS(6736),
    [anon_sym_const] = ACTIONS(6736),
    [anon_sym_continue] = ACTIONS(6736),
    [anon_sym_default] = ACTIONS(6736),
    [anon_sym_enum] = ACTIONS(6736),
    [anon_sym_fn] = ACTIONS(6736),
    [anon_sym_for] = ACTIONS(6736),
    [anon_sym_if] = ACTIONS(6736),
    [anon_sym_impl] = ACTIONS(6736),
    [anon_sym_let] = ACTIONS(6736),
    [anon_sym_loop] = ACTIONS(6736),
    [anon_sym_match] = ACTIONS(6736),
    [anon_sym_mod] = ACTIONS(6736),
    [anon_sym_pub] = ACTIONS(6736),
    [anon_sym_return] = ACTIONS(6736),
    [anon_sym_static] = ACTIONS(6736),
    [anon_sym_struct] = ACTIONS(6736),
    [anon_sym_trait] = ACTIONS(6736),
    [anon_sym_type] = ACTIONS(6736),
    [anon_sym_union] = ACTIONS(6736),
    [anon_sym_unsafe] = ACTIONS(6736),
    [anon_sym_use] = ACTIONS(6736),
    [anon_sym_where] = ACTIONS(6736),
    [anon_sym_while] = ACTIONS(6736),
    [sym_mutable_specifier] = ACTIONS(6736),
    [sym_integer_literal] = ACTIONS(6734),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6734),
    [sym_char_literal] = ACTIONS(6734),
    [anon_sym_true] = ACTIONS(6736),
    [anon_sym_false] = ACTIONS(6736),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6736),
    [sym_self] = ACTIONS(6736),
    [sym_super] = ACTIONS(6736),
    [sym_crate] = ACTIONS(6736),
    [sym_metavariable] = ACTIONS(6734),
  },
  [2631] = {
    [sym_raw_string_literal] = ACTIONS(6738),
    [sym_float_literal] = ACTIONS(6738),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6738),
    [anon_sym_LPAREN] = ACTIONS(6738),
    [anon_sym_RPAREN] = ACTIONS(6738),
    [anon_sym_LBRACE] = ACTIONS(6738),
    [anon_sym_RBRACE] = ACTIONS(6738),
    [anon_sym_EQ_GT] = ACTIONS(6738),
    [anon_sym_LBRACK] = ACTIONS(6738),
    [anon_sym_RBRACK] = ACTIONS(6738),
    [anon_sym_COLON] = ACTIONS(6740),
    [anon_sym_DOLLAR] = ACTIONS(6740),
    [anon_sym_PLUS] = ACTIONS(6740),
    [anon_sym_STAR] = ACTIONS(6740),
    [anon_sym_COMMA] = ACTIONS(6738),
    [anon_sym_u8] = ACTIONS(6740),
    [anon_sym_i8] = ACTIONS(6740),
    [anon_sym_u16] = ACTIONS(6740),
    [anon_sym_i16] = ACTIONS(6740),
    [anon_sym_u32] = ACTIONS(6740),
    [anon_sym_i32] = ACTIONS(6740),
    [anon_sym_u64] = ACTIONS(6740),
    [anon_sym_i64] = ACTIONS(6740),
    [anon_sym_u128] = ACTIONS(6740),
    [anon_sym_i128] = ACTIONS(6740),
    [anon_sym_isize] = ACTIONS(6740),
    [anon_sym_usize] = ACTIONS(6740),
    [anon_sym_f32] = ACTIONS(6740),
    [anon_sym_f64] = ACTIONS(6740),
    [anon_sym_bool] = ACTIONS(6740),
    [anon_sym_str] = ACTIONS(6740),
    [anon_sym_char] = ACTIONS(6740),
    [anon_sym__] = ACTIONS(6740),
    [anon_sym_AMP] = ACTIONS(6740),
    [anon_sym_DASH] = ACTIONS(6740),
    [anon_sym_DOT] = ACTIONS(6740),
    [anon_sym_DASH_EQ] = ACTIONS(6738),
    [anon_sym_DASH_GT] = ACTIONS(6738),
    [anon_sym_COLON_COLON] = ACTIONS(6738),
    [anon_sym_BANG] = ACTIONS(6740),
    [anon_sym_BANG_EQ] = ACTIONS(6738),
    [anon_sym_AT] = ACTIONS(6738),
    [anon_sym_STAR_EQ] = ACTIONS(6738),
    [anon_sym_SLASH] = ACTIONS(6740),
    [anon_sym_SLASH_EQ] = ACTIONS(6738),
    [anon_sym_AMP_AMP] = ACTIONS(6738),
    [anon_sym_AMP_EQ] = ACTIONS(6738),
    [anon_sym_POUND] = ACTIONS(6738),
    [anon_sym_PERCENT] = ACTIONS(6740),
    [anon_sym_PERCENT_EQ] = ACTIONS(6738),
    [anon_sym_CARET] = ACTIONS(6740),
    [anon_sym_CARET_EQ] = ACTIONS(6738),
    [anon_sym_PLUS_EQ] = ACTIONS(6738),
    [anon_sym_LT] = ACTIONS(6740),
    [anon_sym_LT_LT] = ACTIONS(6740),
    [anon_sym_LT_LT_EQ] = ACTIONS(6738),
    [anon_sym_LT_EQ] = ACTIONS(6738),
    [anon_sym_EQ] = ACTIONS(6740),
    [anon_sym_EQ_EQ] = ACTIONS(6738),
    [anon_sym_GT] = ACTIONS(6740),
    [anon_sym_GT_EQ] = ACTIONS(6738),
    [anon_sym_GT_GT] = ACTIONS(6740),
    [anon_sym_GT_GT_EQ] = ACTIONS(6738),
    [anon_sym_PIPE] = ACTIONS(6740),
    [anon_sym_PIPE_EQ] = ACTIONS(6738),
    [anon_sym_PIPE_PIPE] = ACTIONS(6738),
    [anon_sym_TILDE] = ACTIONS(6738),
    [anon_sym_QMARK] = ACTIONS(6738),
    [anon_sym_SQUOTE] = ACTIONS(6740),
    [anon_sym_DOT_DOT] = ACTIONS(6740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6738),
    [anon_sym_as] = ACTIONS(6740),
    [anon_sym_break] = ACTIONS(6740),
    [anon_sym_const] = ACTIONS(6740),
    [anon_sym_continue] = ACTIONS(6740),
    [anon_sym_default] = ACTIONS(6740),
    [anon_sym_enum] = ACTIONS(6740),
    [anon_sym_fn] = ACTIONS(6740),
    [anon_sym_for] = ACTIONS(6740),
    [anon_sym_if] = ACTIONS(6740),
    [anon_sym_impl] = ACTIONS(6740),
    [anon_sym_let] = ACTIONS(6740),
    [anon_sym_loop] = ACTIONS(6740),
    [anon_sym_match] = ACTIONS(6740),
    [anon_sym_mod] = ACTIONS(6740),
    [anon_sym_pub] = ACTIONS(6740),
    [anon_sym_return] = ACTIONS(6740),
    [anon_sym_static] = ACTIONS(6740),
    [anon_sym_struct] = ACTIONS(6740),
    [anon_sym_trait] = ACTIONS(6740),
    [anon_sym_type] = ACTIONS(6740),
    [anon_sym_union] = ACTIONS(6740),
    [anon_sym_unsafe] = ACTIONS(6740),
    [anon_sym_use] = ACTIONS(6740),
    [anon_sym_where] = ACTIONS(6740),
    [anon_sym_while] = ACTIONS(6740),
    [sym_mutable_specifier] = ACTIONS(6740),
    [sym_integer_literal] = ACTIONS(6738),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6738),
    [sym_char_literal] = ACTIONS(6738),
    [anon_sym_true] = ACTIONS(6740),
    [anon_sym_false] = ACTIONS(6740),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6740),
    [sym_self] = ACTIONS(6740),
    [sym_super] = ACTIONS(6740),
    [sym_crate] = ACTIONS(6740),
    [sym_metavariable] = ACTIONS(6738),
  },
  [2632] = {
    [sym_raw_string_literal] = ACTIONS(6742),
    [sym_float_literal] = ACTIONS(6742),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(6742),
    [anon_sym_SEMI] = ACTIONS(6742),
    [anon_sym_macro_rules_BANG] = ACTIONS(6742),
    [anon_sym_LPAREN] = ACTIONS(6742),
    [anon_sym_LBRACE] = ACTIONS(6742),
    [anon_sym_RBRACE] = ACTIONS(6742),
    [anon_sym_LBRACK] = ACTIONS(6742),
    [anon_sym_STAR] = ACTIONS(6742),
    [anon_sym_u8] = ACTIONS(6744),
    [anon_sym_i8] = ACTIONS(6744),
    [anon_sym_u16] = ACTIONS(6744),
    [anon_sym_i16] = ACTIONS(6744),
    [anon_sym_u32] = ACTIONS(6744),
    [anon_sym_i32] = ACTIONS(6744),
    [anon_sym_u64] = ACTIONS(6744),
    [anon_sym_i64] = ACTIONS(6744),
    [anon_sym_u128] = ACTIONS(6744),
    [anon_sym_i128] = ACTIONS(6744),
    [anon_sym_isize] = ACTIONS(6744),
    [anon_sym_usize] = ACTIONS(6744),
    [anon_sym_f32] = ACTIONS(6744),
    [anon_sym_f64] = ACTIONS(6744),
    [anon_sym_bool] = ACTIONS(6744),
    [anon_sym_str] = ACTIONS(6744),
    [anon_sym_char] = ACTIONS(6744),
    [anon_sym_AMP] = ACTIONS(6742),
    [anon_sym_DASH] = ACTIONS(6742),
    [anon_sym_COLON_COLON] = ACTIONS(6742),
    [anon_sym_BANG] = ACTIONS(6742),
    [anon_sym_POUND] = ACTIONS(6742),
    [anon_sym_LT] = ACTIONS(6742),
    [anon_sym_PIPE] = ACTIONS(6742),
    [anon_sym_SQUOTE] = ACTIONS(6744),
    [anon_sym_DOT_DOT] = ACTIONS(6742),
    [anon_sym_break] = ACTIONS(6744),
    [anon_sym_const] = ACTIONS(6744),
    [anon_sym_continue] = ACTIONS(6744),
    [anon_sym_default] = ACTIONS(6744),
    [anon_sym_enum] = ACTIONS(6744),
    [anon_sym_fn] = ACTIONS(6744),
    [anon_sym_for] = ACTIONS(6744),
    [anon_sym_if] = ACTIONS(6744),
    [anon_sym_impl] = ACTIONS(6744),
    [anon_sym_let] = ACTIONS(6744),
    [anon_sym_loop] = ACTIONS(6744),
    [anon_sym_match] = ACTIONS(6744),
    [anon_sym_mod] = ACTIONS(6744),
    [anon_sym_pub] = ACTIONS(6744),
    [anon_sym_return] = ACTIONS(6744),
    [anon_sym_static] = ACTIONS(6744),
    [anon_sym_struct] = ACTIONS(6744),
    [anon_sym_trait] = ACTIONS(6744),
    [anon_sym_type] = ACTIONS(6744),
    [anon_sym_union] = ACTIONS(6744),
    [anon_sym_unsafe] = ACTIONS(6744),
    [anon_sym_use] = ACTIONS(6744),
    [anon_sym_while] = ACTIONS(6744),
    [anon_sym_extern] = ACTIONS(6744),
    [anon_sym_move] = ACTIONS(6744),
    [sym_integer_literal] = ACTIONS(6742),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6742),
    [sym_char_literal] = ACTIONS(6742),
    [anon_sym_true] = ACTIONS(6744),
    [anon_sym_false] = ACTIONS(6744),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6744),
    [sym_self] = ACTIONS(6744),
    [sym_super] = ACTIONS(6744),
    [sym_crate] = ACTIONS(6744),
    [sym_metavariable] = ACTIONS(6742),
  },
  [2633] = {
    [sym_else_tail] = STATE(3089),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6158),
    [anon_sym_RPAREN] = ACTIONS(6158),
    [anon_sym_LBRACK] = ACTIONS(6158),
    [anon_sym_PLUS] = ACTIONS(6160),
    [anon_sym_STAR] = ACTIONS(6160),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_AMP] = ACTIONS(6160),
    [anon_sym_DASH] = ACTIONS(6160),
    [anon_sym_DOT] = ACTIONS(6160),
    [anon_sym_DASH_EQ] = ACTIONS(6158),
    [anon_sym_BANG_EQ] = ACTIONS(6158),
    [anon_sym_STAR_EQ] = ACTIONS(6158),
    [anon_sym_SLASH] = ACTIONS(6160),
    [anon_sym_SLASH_EQ] = ACTIONS(6158),
    [anon_sym_AMP_AMP] = ACTIONS(6158),
    [anon_sym_AMP_EQ] = ACTIONS(6158),
    [anon_sym_PERCENT] = ACTIONS(6160),
    [anon_sym_PERCENT_EQ] = ACTIONS(6158),
    [anon_sym_CARET] = ACTIONS(6160),
    [anon_sym_CARET_EQ] = ACTIONS(6158),
    [anon_sym_PLUS_EQ] = ACTIONS(6158),
    [anon_sym_LT] = ACTIONS(6160),
    [anon_sym_LT_LT] = ACTIONS(6160),
    [anon_sym_LT_LT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_EQ] = ACTIONS(6160),
    [anon_sym_EQ_EQ] = ACTIONS(6158),
    [anon_sym_GT] = ACTIONS(6160),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_GT_GT] = ACTIONS(6160),
    [anon_sym_GT_GT_EQ] = ACTIONS(6158),
    [anon_sym_PIPE] = ACTIONS(6160),
    [anon_sym_PIPE_EQ] = ACTIONS(6158),
    [anon_sym_PIPE_PIPE] = ACTIONS(6158),
    [anon_sym_QMARK] = ACTIONS(6158),
    [anon_sym_DOT_DOT] = ACTIONS(6160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6158),
    [anon_sym_as] = ACTIONS(6158),
    [anon_sym_else] = ACTIONS(2723),
    [sym_line_comment] = ACTIONS(7),
  },
  [2634] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6371),
    [anon_sym_LPAREN] = ACTIONS(6371),
    [anon_sym_RPAREN] = ACTIONS(6371),
    [anon_sym_LBRACE] = ACTIONS(6371),
    [anon_sym_RBRACE] = ACTIONS(6371),
    [anon_sym_LBRACK] = ACTIONS(6371),
    [anon_sym_RBRACK] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(6373),
    [anon_sym_STAR] = ACTIONS(6373),
    [anon_sym_COMMA] = ACTIONS(6371),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_DASH] = ACTIONS(6373),
    [anon_sym_DOT] = ACTIONS(6373),
    [anon_sym_DASH_EQ] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6371),
    [anon_sym_STAR_EQ] = ACTIONS(6371),
    [anon_sym_SLASH] = ACTIONS(6373),
    [anon_sym_SLASH_EQ] = ACTIONS(6371),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_AMP_EQ] = ACTIONS(6371),
    [anon_sym_PERCENT] = ACTIONS(6373),
    [anon_sym_PERCENT_EQ] = ACTIONS(6371),
    [anon_sym_CARET] = ACTIONS(6373),
    [anon_sym_CARET_EQ] = ACTIONS(6371),
    [anon_sym_PLUS_EQ] = ACTIONS(6371),
    [anon_sym_LT] = ACTIONS(6373),
    [anon_sym_LT_LT] = ACTIONS(6373),
    [anon_sym_LT_LT_EQ] = ACTIONS(6371),
    [anon_sym_LT_EQ] = ACTIONS(6371),
    [anon_sym_EQ] = ACTIONS(6373),
    [anon_sym_EQ_EQ] = ACTIONS(6371),
    [anon_sym_GT] = ACTIONS(6373),
    [anon_sym_GT_EQ] = ACTIONS(6371),
    [anon_sym_GT_GT] = ACTIONS(6373),
    [anon_sym_GT_GT_EQ] = ACTIONS(6371),
    [anon_sym_PIPE] = ACTIONS(6373),
    [anon_sym_PIPE_EQ] = ACTIONS(6371),
    [anon_sym_PIPE_PIPE] = ACTIONS(6371),
    [anon_sym_QMARK] = ACTIONS(6371),
    [anon_sym_DOT_DOT] = ACTIONS(6373),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6371),
    [anon_sym_as] = ACTIONS(6371),
    [sym_line_comment] = ACTIONS(7),
  },
  [2635] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6504),
    [anon_sym_LPAREN] = ACTIONS(6504),
    [anon_sym_RPAREN] = ACTIONS(6504),
    [anon_sym_LBRACE] = ACTIONS(6504),
    [anon_sym_RBRACE] = ACTIONS(6504),
    [anon_sym_LBRACK] = ACTIONS(6504),
    [anon_sym_RBRACK] = ACTIONS(6504),
    [anon_sym_PLUS] = ACTIONS(6506),
    [anon_sym_STAR] = ACTIONS(6506),
    [anon_sym_COMMA] = ACTIONS(6504),
    [anon_sym_AMP] = ACTIONS(6506),
    [anon_sym_DASH] = ACTIONS(6506),
    [anon_sym_DOT] = ACTIONS(6506),
    [anon_sym_DASH_EQ] = ACTIONS(6504),
    [anon_sym_BANG_EQ] = ACTIONS(6504),
    [anon_sym_STAR_EQ] = ACTIONS(6504),
    [anon_sym_SLASH] = ACTIONS(6506),
    [anon_sym_SLASH_EQ] = ACTIONS(6504),
    [anon_sym_AMP_AMP] = ACTIONS(6504),
    [anon_sym_AMP_EQ] = ACTIONS(6504),
    [anon_sym_PERCENT] = ACTIONS(6506),
    [anon_sym_PERCENT_EQ] = ACTIONS(6504),
    [anon_sym_CARET] = ACTIONS(6506),
    [anon_sym_CARET_EQ] = ACTIONS(6504),
    [anon_sym_PLUS_EQ] = ACTIONS(6504),
    [anon_sym_LT] = ACTIONS(6506),
    [anon_sym_LT_LT] = ACTIONS(6506),
    [anon_sym_LT_LT_EQ] = ACTIONS(6504),
    [anon_sym_LT_EQ] = ACTIONS(6504),
    [anon_sym_EQ] = ACTIONS(6506),
    [anon_sym_EQ_EQ] = ACTIONS(6504),
    [anon_sym_GT] = ACTIONS(6506),
    [anon_sym_GT_EQ] = ACTIONS(6504),
    [anon_sym_GT_GT] = ACTIONS(6506),
    [anon_sym_GT_GT_EQ] = ACTIONS(6504),
    [anon_sym_PIPE] = ACTIONS(6506),
    [anon_sym_PIPE_EQ] = ACTIONS(6504),
    [anon_sym_PIPE_PIPE] = ACTIONS(6504),
    [anon_sym_QMARK] = ACTIONS(6504),
    [anon_sym_DOT_DOT] = ACTIONS(6506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6504),
    [anon_sym_as] = ACTIONS(6504),
    [sym_line_comment] = ACTIONS(7),
  },
  [2636] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6588),
    [anon_sym_macro_rules_BANG] = ACTIONS(6588),
    [anon_sym_LPAREN] = ACTIONS(6588),
    [anon_sym_RPAREN] = ACTIONS(6588),
    [anon_sym_LBRACE] = ACTIONS(6588),
    [anon_sym_RBRACE] = ACTIONS(6588),
    [anon_sym_LBRACK] = ACTIONS(6588),
    [anon_sym_RBRACK] = ACTIONS(6588),
    [anon_sym_PLUS] = ACTIONS(6590),
    [anon_sym_STAR] = ACTIONS(6590),
    [anon_sym_COMMA] = ACTIONS(6588),
    [anon_sym_AMP] = ACTIONS(6590),
    [anon_sym_DASH] = ACTIONS(6590),
    [anon_sym_DOT] = ACTIONS(6590),
    [anon_sym_DASH_EQ] = ACTIONS(6588),
    [anon_sym_BANG_EQ] = ACTIONS(6588),
    [anon_sym_STAR_EQ] = ACTIONS(6588),
    [anon_sym_SLASH] = ACTIONS(6590),
    [anon_sym_SLASH_EQ] = ACTIONS(6588),
    [anon_sym_AMP_AMP] = ACTIONS(6588),
    [anon_sym_AMP_EQ] = ACTIONS(6588),
    [anon_sym_POUND] = ACTIONS(6588),
    [anon_sym_PERCENT] = ACTIONS(6590),
    [anon_sym_PERCENT_EQ] = ACTIONS(6588),
    [anon_sym_CARET] = ACTIONS(6590),
    [anon_sym_CARET_EQ] = ACTIONS(6588),
    [anon_sym_PLUS_EQ] = ACTIONS(6588),
    [anon_sym_LT] = ACTIONS(6590),
    [anon_sym_LT_LT] = ACTIONS(6590),
    [anon_sym_LT_LT_EQ] = ACTIONS(6588),
    [anon_sym_LT_EQ] = ACTIONS(6588),
    [anon_sym_EQ] = ACTIONS(6590),
    [anon_sym_EQ_EQ] = ACTIONS(6588),
    [anon_sym_GT] = ACTIONS(6590),
    [anon_sym_GT_EQ] = ACTIONS(6588),
    [anon_sym_GT_GT] = ACTIONS(6590),
    [anon_sym_GT_GT_EQ] = ACTIONS(6588),
    [anon_sym_PIPE] = ACTIONS(6590),
    [anon_sym_PIPE_EQ] = ACTIONS(6588),
    [anon_sym_PIPE_PIPE] = ACTIONS(6588),
    [anon_sym_QMARK] = ACTIONS(6588),
    [anon_sym_DOT_DOT] = ACTIONS(6590),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6588),
    [anon_sym_as] = ACTIONS(6590),
    [anon_sym_const] = ACTIONS(6590),
    [anon_sym_default] = ACTIONS(6590),
    [anon_sym_enum] = ACTIONS(6590),
    [anon_sym_fn] = ACTIONS(6590),
    [anon_sym_impl] = ACTIONS(6590),
    [anon_sym_let] = ACTIONS(6590),
    [anon_sym_mod] = ACTIONS(6590),
    [anon_sym_pub] = ACTIONS(6590),
    [anon_sym_static] = ACTIONS(6590),
    [anon_sym_struct] = ACTIONS(6590),
    [anon_sym_trait] = ACTIONS(6590),
    [anon_sym_type] = ACTIONS(6590),
    [anon_sym_union] = ACTIONS(6590),
    [anon_sym_unsafe] = ACTIONS(6590),
    [anon_sym_use] = ACTIONS(6590),
    [anon_sym_extern] = ACTIONS(6590),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6590),
  },
  [2637] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1972),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1972),
    [sym_unary_expression] = STATE(1972),
    [sym_try_expression] = STATE(1972),
    [sym_reference_expression] = STATE(1972),
    [sym_binary_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1972),
    [sym_call_expression] = STATE(1972),
    [sym_array_expression] = STATE(1972),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_tuple_expression] = STATE(1972),
    [sym_unit_expression] = STATE(1972),
    [sym_struct_expression] = STATE(1972),
    [sym_if_expression] = STATE(1972),
    [sym_if_let_expression] = STATE(1972),
    [sym_match_expression] = STATE(1972),
    [sym_while_expression] = STATE(1972),
    [sym_while_let_expression] = STATE(1972),
    [sym_loop_expression] = STATE(1972),
    [sym_for_expression] = STATE(1972),
    [sym_closure_expression] = STATE(1972),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1972),
    [sym_continue_expression] = STATE(1972),
    [sym_index_expression] = STATE(1972),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1972),
    [sym_block] = STATE(1972),
    [sym__literal] = STATE(1972),
    [sym_string_literal] = STATE(1972),
    [sym_boolean_literal] = STATE(1972),
    [sym_raw_string_literal] = ACTIONS(4375),
    [sym_float_literal] = ACTIONS(4375),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(6746),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(4375),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4375),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2638] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(769),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(769),
    [sym_macro_invocation] = STATE(769),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(769),
    [sym_unary_expression] = STATE(769),
    [sym_try_expression] = STATE(769),
    [sym_reference_expression] = STATE(769),
    [sym_binary_expression] = STATE(769),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(769),
    [sym_call_expression] = STATE(769),
    [sym_array_expression] = STATE(769),
    [sym_parenthesized_expression] = STATE(769),
    [sym_tuple_expression] = STATE(769),
    [sym_unit_expression] = STATE(769),
    [sym_struct_expression] = STATE(769),
    [sym_if_expression] = STATE(769),
    [sym_if_let_expression] = STATE(769),
    [sym_match_expression] = STATE(769),
    [sym_while_expression] = STATE(769),
    [sym_while_let_expression] = STATE(769),
    [sym_loop_expression] = STATE(769),
    [sym_for_expression] = STATE(769),
    [sym_closure_expression] = STATE(769),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(769),
    [sym_continue_expression] = STATE(769),
    [sym_index_expression] = STATE(769),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(769),
    [sym_block] = STATE(769),
    [sym__literal] = STATE(769),
    [sym_string_literal] = STATE(769),
    [sym_boolean_literal] = STATE(769),
    [sym_raw_string_literal] = ACTIONS(1620),
    [sym_float_literal] = ACTIONS(1620),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_RBRACK] = ACTIONS(6746),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1620),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1620),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2639] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(361),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(361),
    [sym_macro_invocation] = STATE(361),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(361),
    [sym_unary_expression] = STATE(361),
    [sym_try_expression] = STATE(361),
    [sym_reference_expression] = STATE(361),
    [sym_binary_expression] = STATE(361),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(361),
    [sym_call_expression] = STATE(361),
    [sym_array_expression] = STATE(361),
    [sym_parenthesized_expression] = STATE(361),
    [sym_tuple_expression] = STATE(361),
    [sym_unit_expression] = STATE(361),
    [sym_struct_expression] = STATE(361),
    [sym_if_expression] = STATE(361),
    [sym_if_let_expression] = STATE(361),
    [sym_match_expression] = STATE(361),
    [sym_while_expression] = STATE(361),
    [sym_while_let_expression] = STATE(361),
    [sym_loop_expression] = STATE(361),
    [sym_for_expression] = STATE(361),
    [sym_closure_expression] = STATE(361),
    [sym_closure_parameters] = STATE(2062),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(361),
    [sym_continue_expression] = STATE(361),
    [sym_index_expression] = STATE(361),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(361),
    [sym_block] = STATE(361),
    [sym__literal] = STATE(361),
    [sym_string_literal] = STATE(361),
    [sym_boolean_literal] = STATE(361),
    [sym_raw_string_literal] = ACTIONS(715),
    [sym_float_literal] = ACTIONS(715),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(5862),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5862),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5866),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(5868),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(5870),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(5872),
    [sym_integer_literal] = ACTIONS(715),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(715),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2640] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(5886),
    [anon_sym_STAR] = ACTIONS(5888),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_AMP] = ACTIONS(5890),
    [anon_sym_DASH] = ACTIONS(5886),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_BANG_EQ] = ACTIONS(5894),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH] = ACTIONS(5888),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(5896),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(5888),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(5898),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(5900),
    [anon_sym_LT_LT] = ACTIONS(5902),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(5894),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_EQ_EQ] = ACTIONS(5894),
    [anon_sym_GT] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5894),
    [anon_sym_GT_GT] = ACTIONS(5902),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(5906),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_as] = ACTIONS(909),
    [sym_line_comment] = ACTIONS(7),
  },
  [2641] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(3091),
    [sym_tuple_pattern] = STATE(3091),
    [sym_tuple_struct_pattern] = STATE(3091),
    [sym_struct_pattern] = STATE(3091),
    [sym_remaining_field_pattern] = STATE(3091),
    [sym_mut_pattern] = STATE(3091),
    [sym_ref_pattern] = STATE(3091),
    [sym_captured_pattern] = STATE(3091),
    [sym_reference_pattern] = STATE(3091),
    [sym__literal] = STATE(3091),
    [sym_string_literal] = STATE(3091),
    [sym_boolean_literal] = STATE(3091),
    [sym_raw_string_literal] = ACTIONS(6748),
    [sym_float_literal] = ACTIONS(6748),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(6750),
    [anon_sym_AMP] = ACTIONS(955),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(957),
    [anon_sym_ref] = ACTIONS(959),
    [sym_integer_literal] = ACTIONS(6748),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(6748),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(961),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [2642] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(3092),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [2643] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(5886),
    [anon_sym_STAR] = ACTIONS(5888),
    [anon_sym_COMMA] = ACTIONS(1043),
    [anon_sym_AMP] = ACTIONS(5890),
    [anon_sym_DASH] = ACTIONS(5886),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(1043),
    [anon_sym_BANG_EQ] = ACTIONS(5894),
    [anon_sym_STAR_EQ] = ACTIONS(1043),
    [anon_sym_SLASH] = ACTIONS(5888),
    [anon_sym_SLASH_EQ] = ACTIONS(1043),
    [anon_sym_AMP_AMP] = ACTIONS(5896),
    [anon_sym_AMP_EQ] = ACTIONS(1043),
    [anon_sym_PERCENT] = ACTIONS(5888),
    [anon_sym_PERCENT_EQ] = ACTIONS(1043),
    [anon_sym_CARET] = ACTIONS(5898),
    [anon_sym_CARET_EQ] = ACTIONS(1043),
    [anon_sym_PLUS_EQ] = ACTIONS(1043),
    [anon_sym_LT] = ACTIONS(5900),
    [anon_sym_LT_LT] = ACTIONS(5902),
    [anon_sym_LT_LT_EQ] = ACTIONS(1043),
    [anon_sym_LT_EQ] = ACTIONS(5894),
    [anon_sym_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(5894),
    [anon_sym_GT] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5894),
    [anon_sym_GT_GT] = ACTIONS(5902),
    [anon_sym_GT_GT_EQ] = ACTIONS(1043),
    [anon_sym_PIPE] = ACTIONS(5906),
    [anon_sym_PIPE_EQ] = ACTIONS(1043),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(5910),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5912),
    [anon_sym_as] = ACTIONS(1043),
    [sym_line_comment] = ACTIONS(7),
  },
  [2644] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3093),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3093),
    [sym_macro_invocation] = STATE(3093),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3093),
    [sym_unary_expression] = STATE(3093),
    [sym_try_expression] = STATE(3093),
    [sym_reference_expression] = STATE(3093),
    [sym_binary_expression] = STATE(3093),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3093),
    [sym_call_expression] = STATE(3093),
    [sym_array_expression] = STATE(3093),
    [sym_parenthesized_expression] = STATE(3093),
    [sym_tuple_expression] = STATE(3093),
    [sym_unit_expression] = STATE(3093),
    [sym_struct_expression] = STATE(3093),
    [sym_if_expression] = STATE(3093),
    [sym_if_let_expression] = STATE(3093),
    [sym_match_expression] = STATE(3093),
    [sym_while_expression] = STATE(3093),
    [sym_while_let_expression] = STATE(3093),
    [sym_loop_expression] = STATE(3093),
    [sym_for_expression] = STATE(3093),
    [sym_closure_expression] = STATE(3093),
    [sym_closure_parameters] = STATE(2062),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3093),
    [sym_continue_expression] = STATE(3093),
    [sym_index_expression] = STATE(3093),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3093),
    [sym_block] = STATE(3093),
    [sym__literal] = STATE(3093),
    [sym_string_literal] = STATE(3093),
    [sym_boolean_literal] = STATE(3093),
    [sym_raw_string_literal] = ACTIONS(6752),
    [sym_float_literal] = ACTIONS(6752),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(5862),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5878),
    [anon_sym_DASH_GT] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5866),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(5868),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(5870),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(5872),
    [sym_integer_literal] = ACTIONS(6752),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6752),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2645] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3094),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3094),
    [sym_macro_invocation] = STATE(3094),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3094),
    [sym_unary_expression] = STATE(3094),
    [sym_try_expression] = STATE(3094),
    [sym_reference_expression] = STATE(3094),
    [sym_binary_expression] = STATE(3094),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3094),
    [sym_call_expression] = STATE(3094),
    [sym_array_expression] = STATE(3094),
    [sym_parenthesized_expression] = STATE(3094),
    [sym_tuple_expression] = STATE(3094),
    [sym_unit_expression] = STATE(3094),
    [sym_struct_expression] = STATE(3094),
    [sym_if_expression] = STATE(3094),
    [sym_if_let_expression] = STATE(3094),
    [sym_match_expression] = STATE(3094),
    [sym_while_expression] = STATE(3094),
    [sym_while_let_expression] = STATE(3094),
    [sym_loop_expression] = STATE(3094),
    [sym_for_expression] = STATE(3094),
    [sym_closure_expression] = STATE(3094),
    [sym_closure_parameters] = STATE(2062),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3094),
    [sym_continue_expression] = STATE(3094),
    [sym_index_expression] = STATE(3094),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3094),
    [sym_block] = STATE(3094),
    [sym__literal] = STATE(3094),
    [sym_string_literal] = STATE(3094),
    [sym_boolean_literal] = STATE(3094),
    [sym_raw_string_literal] = ACTIONS(6754),
    [sym_float_literal] = ACTIONS(6754),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(5862),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5862),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5866),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(5868),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(5870),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(5872),
    [sym_integer_literal] = ACTIONS(6754),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6754),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2646] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(640),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(640),
    [sym_macro_invocation] = STATE(640),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(640),
    [sym_unary_expression] = STATE(640),
    [sym_try_expression] = STATE(640),
    [sym_reference_expression] = STATE(640),
    [sym_binary_expression] = STATE(640),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(640),
    [sym_call_expression] = STATE(640),
    [sym_array_expression] = STATE(640),
    [sym_parenthesized_expression] = STATE(640),
    [sym_tuple_expression] = STATE(640),
    [sym_unit_expression] = STATE(640),
    [sym_struct_expression] = STATE(640),
    [sym_if_expression] = STATE(640),
    [sym_if_let_expression] = STATE(640),
    [sym_match_expression] = STATE(640),
    [sym_while_expression] = STATE(640),
    [sym_while_let_expression] = STATE(640),
    [sym_loop_expression] = STATE(640),
    [sym_for_expression] = STATE(640),
    [sym_closure_expression] = STATE(640),
    [sym_closure_parameters] = STATE(2062),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(640),
    [sym_continue_expression] = STATE(640),
    [sym_index_expression] = STATE(640),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(640),
    [sym_block] = STATE(640),
    [sym__literal] = STATE(640),
    [sym_string_literal] = STATE(640),
    [sym_boolean_literal] = STATE(640),
    [sym_raw_string_literal] = ACTIONS(1257),
    [sym_float_literal] = ACTIONS(1257),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(5862),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5862),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5866),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(5868),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(5870),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(5872),
    [sym_integer_literal] = ACTIONS(1257),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1257),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2647] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3095),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3095),
    [sym_macro_invocation] = STATE(3095),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3095),
    [sym_unary_expression] = STATE(3095),
    [sym_try_expression] = STATE(3095),
    [sym_reference_expression] = STATE(3095),
    [sym_binary_expression] = STATE(3095),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3095),
    [sym_call_expression] = STATE(3095),
    [sym_array_expression] = STATE(3095),
    [sym_parenthesized_expression] = STATE(3095),
    [sym_tuple_expression] = STATE(3095),
    [sym_unit_expression] = STATE(3095),
    [sym_struct_expression] = STATE(3095),
    [sym_if_expression] = STATE(3095),
    [sym_if_let_expression] = STATE(3095),
    [sym_match_expression] = STATE(3095),
    [sym_while_expression] = STATE(3095),
    [sym_while_let_expression] = STATE(3095),
    [sym_loop_expression] = STATE(3095),
    [sym_for_expression] = STATE(3095),
    [sym_closure_expression] = STATE(3095),
    [sym_closure_parameters] = STATE(2062),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3095),
    [sym_continue_expression] = STATE(3095),
    [sym_index_expression] = STATE(3095),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3095),
    [sym_block] = STATE(3095),
    [sym__literal] = STATE(3095),
    [sym_string_literal] = STATE(3095),
    [sym_boolean_literal] = STATE(3095),
    [sym_raw_string_literal] = ACTIONS(6756),
    [sym_float_literal] = ACTIONS(6756),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(5862),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5862),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5866),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(5868),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(5870),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(5872),
    [sym_integer_literal] = ACTIONS(6756),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6756),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2648] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3096),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3096),
    [sym_macro_invocation] = STATE(3096),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3096),
    [sym_unary_expression] = STATE(3096),
    [sym_try_expression] = STATE(3096),
    [sym_reference_expression] = STATE(3096),
    [sym_binary_expression] = STATE(3096),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3096),
    [sym_call_expression] = STATE(3096),
    [sym_array_expression] = STATE(3096),
    [sym_parenthesized_expression] = STATE(3096),
    [sym_tuple_expression] = STATE(3096),
    [sym_unit_expression] = STATE(3096),
    [sym_struct_expression] = STATE(3096),
    [sym_if_expression] = STATE(3096),
    [sym_if_let_expression] = STATE(3096),
    [sym_match_expression] = STATE(3096),
    [sym_while_expression] = STATE(3096),
    [sym_while_let_expression] = STATE(3096),
    [sym_loop_expression] = STATE(3096),
    [sym_for_expression] = STATE(3096),
    [sym_closure_expression] = STATE(3096),
    [sym_closure_parameters] = STATE(2062),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3096),
    [sym_continue_expression] = STATE(3096),
    [sym_index_expression] = STATE(3096),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3096),
    [sym_block] = STATE(3096),
    [sym__literal] = STATE(3096),
    [sym_string_literal] = STATE(3096),
    [sym_boolean_literal] = STATE(3096),
    [sym_raw_string_literal] = ACTIONS(6758),
    [sym_float_literal] = ACTIONS(6758),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(5862),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5862),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5866),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(5868),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(5870),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(5872),
    [sym_integer_literal] = ACTIONS(6758),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6758),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2649] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3097),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3097),
    [sym_macro_invocation] = STATE(3097),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3097),
    [sym_unary_expression] = STATE(3097),
    [sym_try_expression] = STATE(3097),
    [sym_reference_expression] = STATE(3097),
    [sym_binary_expression] = STATE(3097),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3097),
    [sym_call_expression] = STATE(3097),
    [sym_array_expression] = STATE(3097),
    [sym_parenthesized_expression] = STATE(3097),
    [sym_tuple_expression] = STATE(3097),
    [sym_unit_expression] = STATE(3097),
    [sym_struct_expression] = STATE(3097),
    [sym_if_expression] = STATE(3097),
    [sym_if_let_expression] = STATE(3097),
    [sym_match_expression] = STATE(3097),
    [sym_while_expression] = STATE(3097),
    [sym_while_let_expression] = STATE(3097),
    [sym_loop_expression] = STATE(3097),
    [sym_for_expression] = STATE(3097),
    [sym_closure_expression] = STATE(3097),
    [sym_closure_parameters] = STATE(2062),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3097),
    [sym_continue_expression] = STATE(3097),
    [sym_index_expression] = STATE(3097),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3097),
    [sym_block] = STATE(3097),
    [sym__literal] = STATE(3097),
    [sym_string_literal] = STATE(3097),
    [sym_boolean_literal] = STATE(3097),
    [sym_raw_string_literal] = ACTIONS(6760),
    [sym_float_literal] = ACTIONS(6760),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(5862),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5862),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5866),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(5868),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(5870),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(5872),
    [sym_integer_literal] = ACTIONS(6760),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6760),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2650] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3098),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3098),
    [sym_macro_invocation] = STATE(3098),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3098),
    [sym_unary_expression] = STATE(3098),
    [sym_try_expression] = STATE(3098),
    [sym_reference_expression] = STATE(3098),
    [sym_binary_expression] = STATE(3098),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3098),
    [sym_call_expression] = STATE(3098),
    [sym_array_expression] = STATE(3098),
    [sym_parenthesized_expression] = STATE(3098),
    [sym_tuple_expression] = STATE(3098),
    [sym_unit_expression] = STATE(3098),
    [sym_struct_expression] = STATE(3098),
    [sym_if_expression] = STATE(3098),
    [sym_if_let_expression] = STATE(3098),
    [sym_match_expression] = STATE(3098),
    [sym_while_expression] = STATE(3098),
    [sym_while_let_expression] = STATE(3098),
    [sym_loop_expression] = STATE(3098),
    [sym_for_expression] = STATE(3098),
    [sym_closure_expression] = STATE(3098),
    [sym_closure_parameters] = STATE(2062),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3098),
    [sym_continue_expression] = STATE(3098),
    [sym_index_expression] = STATE(3098),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3098),
    [sym_block] = STATE(3098),
    [sym__literal] = STATE(3098),
    [sym_string_literal] = STATE(3098),
    [sym_boolean_literal] = STATE(3098),
    [sym_raw_string_literal] = ACTIONS(6762),
    [sym_float_literal] = ACTIONS(6762),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(5862),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5862),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5866),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(5868),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(5870),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(5872),
    [sym_integer_literal] = ACTIONS(6762),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6762),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2651] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3099),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3099),
    [sym_macro_invocation] = STATE(3099),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3099),
    [sym_unary_expression] = STATE(3099),
    [sym_try_expression] = STATE(3099),
    [sym_reference_expression] = STATE(3099),
    [sym_binary_expression] = STATE(3099),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3099),
    [sym_call_expression] = STATE(3099),
    [sym_array_expression] = STATE(3099),
    [sym_parenthesized_expression] = STATE(3099),
    [sym_tuple_expression] = STATE(3099),
    [sym_unit_expression] = STATE(3099),
    [sym_struct_expression] = STATE(3099),
    [sym_if_expression] = STATE(3099),
    [sym_if_let_expression] = STATE(3099),
    [sym_match_expression] = STATE(3099),
    [sym_while_expression] = STATE(3099),
    [sym_while_let_expression] = STATE(3099),
    [sym_loop_expression] = STATE(3099),
    [sym_for_expression] = STATE(3099),
    [sym_closure_expression] = STATE(3099),
    [sym_closure_parameters] = STATE(2062),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3099),
    [sym_continue_expression] = STATE(3099),
    [sym_index_expression] = STATE(3099),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3099),
    [sym_block] = STATE(3099),
    [sym__literal] = STATE(3099),
    [sym_string_literal] = STATE(3099),
    [sym_boolean_literal] = STATE(3099),
    [sym_raw_string_literal] = ACTIONS(6764),
    [sym_float_literal] = ACTIONS(6764),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(5862),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5862),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5866),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(5868),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(5870),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(5872),
    [sym_integer_literal] = ACTIONS(6764),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6764),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2652] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3100),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3100),
    [sym_macro_invocation] = STATE(3100),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3100),
    [sym_unary_expression] = STATE(3100),
    [sym_try_expression] = STATE(3100),
    [sym_reference_expression] = STATE(3100),
    [sym_binary_expression] = STATE(3100),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3100),
    [sym_call_expression] = STATE(3100),
    [sym_array_expression] = STATE(3100),
    [sym_parenthesized_expression] = STATE(3100),
    [sym_tuple_expression] = STATE(3100),
    [sym_unit_expression] = STATE(3100),
    [sym_struct_expression] = STATE(3100),
    [sym_if_expression] = STATE(3100),
    [sym_if_let_expression] = STATE(3100),
    [sym_match_expression] = STATE(3100),
    [sym_while_expression] = STATE(3100),
    [sym_while_let_expression] = STATE(3100),
    [sym_loop_expression] = STATE(3100),
    [sym_for_expression] = STATE(3100),
    [sym_closure_expression] = STATE(3100),
    [sym_closure_parameters] = STATE(2062),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3100),
    [sym_continue_expression] = STATE(3100),
    [sym_index_expression] = STATE(3100),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3100),
    [sym_block] = STATE(3100),
    [sym__literal] = STATE(3100),
    [sym_string_literal] = STATE(3100),
    [sym_boolean_literal] = STATE(3100),
    [sym_raw_string_literal] = ACTIONS(6766),
    [sym_float_literal] = ACTIONS(6766),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(5862),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5862),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5866),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(5868),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(5870),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(5872),
    [sym_integer_literal] = ACTIONS(6766),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6766),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2653] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3101),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3101),
    [sym_macro_invocation] = STATE(3101),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3101),
    [sym_unary_expression] = STATE(3101),
    [sym_try_expression] = STATE(3101),
    [sym_reference_expression] = STATE(3101),
    [sym_binary_expression] = STATE(3101),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3101),
    [sym_call_expression] = STATE(3101),
    [sym_array_expression] = STATE(3101),
    [sym_parenthesized_expression] = STATE(3101),
    [sym_tuple_expression] = STATE(3101),
    [sym_unit_expression] = STATE(3101),
    [sym_struct_expression] = STATE(3101),
    [sym_if_expression] = STATE(3101),
    [sym_if_let_expression] = STATE(3101),
    [sym_match_expression] = STATE(3101),
    [sym_while_expression] = STATE(3101),
    [sym_while_let_expression] = STATE(3101),
    [sym_loop_expression] = STATE(3101),
    [sym_for_expression] = STATE(3101),
    [sym_closure_expression] = STATE(3101),
    [sym_closure_parameters] = STATE(2062),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3101),
    [sym_continue_expression] = STATE(3101),
    [sym_index_expression] = STATE(3101),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3101),
    [sym_block] = STATE(3101),
    [sym__literal] = STATE(3101),
    [sym_string_literal] = STATE(3101),
    [sym_boolean_literal] = STATE(3101),
    [sym_raw_string_literal] = ACTIONS(6768),
    [sym_float_literal] = ACTIONS(6768),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(5862),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5862),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5866),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(5868),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(5870),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(5872),
    [sym_integer_literal] = ACTIONS(6768),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6768),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2654] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3102),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3102),
    [sym_macro_invocation] = STATE(3102),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3102),
    [sym_unary_expression] = STATE(3102),
    [sym_try_expression] = STATE(3102),
    [sym_reference_expression] = STATE(3102),
    [sym_binary_expression] = STATE(3102),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3102),
    [sym_call_expression] = STATE(3102),
    [sym_array_expression] = STATE(3102),
    [sym_parenthesized_expression] = STATE(3102),
    [sym_tuple_expression] = STATE(3102),
    [sym_unit_expression] = STATE(3102),
    [sym_struct_expression] = STATE(3102),
    [sym_if_expression] = STATE(3102),
    [sym_if_let_expression] = STATE(3102),
    [sym_match_expression] = STATE(3102),
    [sym_while_expression] = STATE(3102),
    [sym_while_let_expression] = STATE(3102),
    [sym_loop_expression] = STATE(3102),
    [sym_for_expression] = STATE(3102),
    [sym_closure_expression] = STATE(3102),
    [sym_closure_parameters] = STATE(2062),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3102),
    [sym_continue_expression] = STATE(3102),
    [sym_index_expression] = STATE(3102),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3102),
    [sym_block] = STATE(3102),
    [sym__literal] = STATE(3102),
    [sym_string_literal] = STATE(3102),
    [sym_boolean_literal] = STATE(3102),
    [sym_raw_string_literal] = ACTIONS(6770),
    [sym_float_literal] = ACTIONS(6770),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(5862),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5862),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5866),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(5868),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(5870),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(5872),
    [sym_integer_literal] = ACTIONS(6770),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6770),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2655] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3103),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3103),
    [sym_macro_invocation] = STATE(3103),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3103),
    [sym_unary_expression] = STATE(3103),
    [sym_try_expression] = STATE(3103),
    [sym_reference_expression] = STATE(3103),
    [sym_binary_expression] = STATE(3103),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3103),
    [sym_call_expression] = STATE(3103),
    [sym_array_expression] = STATE(3103),
    [sym_parenthesized_expression] = STATE(3103),
    [sym_tuple_expression] = STATE(3103),
    [sym_unit_expression] = STATE(3103),
    [sym_struct_expression] = STATE(3103),
    [sym_if_expression] = STATE(3103),
    [sym_if_let_expression] = STATE(3103),
    [sym_match_expression] = STATE(3103),
    [sym_while_expression] = STATE(3103),
    [sym_while_let_expression] = STATE(3103),
    [sym_loop_expression] = STATE(3103),
    [sym_for_expression] = STATE(3103),
    [sym_closure_expression] = STATE(3103),
    [sym_closure_parameters] = STATE(2062),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3103),
    [sym_continue_expression] = STATE(3103),
    [sym_index_expression] = STATE(3103),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3103),
    [sym_block] = STATE(3103),
    [sym__literal] = STATE(3103),
    [sym_string_literal] = STATE(3103),
    [sym_boolean_literal] = STATE(3103),
    [sym_raw_string_literal] = ACTIONS(6772),
    [sym_float_literal] = ACTIONS(6772),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(5862),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5862),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5866),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(5868),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(5870),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(5872),
    [sym_integer_literal] = ACTIONS(6772),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6772),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2656] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3104),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3104),
    [sym_macro_invocation] = STATE(3104),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3104),
    [sym_unary_expression] = STATE(3104),
    [sym_try_expression] = STATE(3104),
    [sym_reference_expression] = STATE(3104),
    [sym_binary_expression] = STATE(3104),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3104),
    [sym_call_expression] = STATE(3104),
    [sym_array_expression] = STATE(3104),
    [sym_parenthesized_expression] = STATE(3104),
    [sym_tuple_expression] = STATE(3104),
    [sym_unit_expression] = STATE(3104),
    [sym_struct_expression] = STATE(3104),
    [sym_if_expression] = STATE(3104),
    [sym_if_let_expression] = STATE(3104),
    [sym_match_expression] = STATE(3104),
    [sym_while_expression] = STATE(3104),
    [sym_while_let_expression] = STATE(3104),
    [sym_loop_expression] = STATE(3104),
    [sym_for_expression] = STATE(3104),
    [sym_closure_expression] = STATE(3104),
    [sym_closure_parameters] = STATE(2062),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3104),
    [sym_continue_expression] = STATE(3104),
    [sym_index_expression] = STATE(3104),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3104),
    [sym_block] = STATE(3104),
    [sym__literal] = STATE(3104),
    [sym_string_literal] = STATE(3104),
    [sym_boolean_literal] = STATE(3104),
    [sym_raw_string_literal] = ACTIONS(6774),
    [sym_float_literal] = ACTIONS(6774),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(909),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(911),
    [anon_sym_STAR] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_DASH] = ACTIONS(911),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(5878),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(911),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(911),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_LT_LT] = ACTIONS(911),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(909),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_EQ_EQ] = ACTIONS(909),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(911),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_as] = ACTIONS(911),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(5868),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(5870),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(5872),
    [sym_integer_literal] = ACTIONS(6774),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6774),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2657] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3104),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3104),
    [sym_macro_invocation] = STATE(3104),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3104),
    [sym_unary_expression] = STATE(3104),
    [sym_try_expression] = STATE(3104),
    [sym_reference_expression] = STATE(3104),
    [sym_binary_expression] = STATE(3104),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3104),
    [sym_call_expression] = STATE(3104),
    [sym_array_expression] = STATE(3104),
    [sym_parenthesized_expression] = STATE(3104),
    [sym_tuple_expression] = STATE(3104),
    [sym_unit_expression] = STATE(3104),
    [sym_struct_expression] = STATE(3104),
    [sym_if_expression] = STATE(3104),
    [sym_if_let_expression] = STATE(3104),
    [sym_match_expression] = STATE(3104),
    [sym_while_expression] = STATE(3104),
    [sym_while_let_expression] = STATE(3104),
    [sym_loop_expression] = STATE(3104),
    [sym_for_expression] = STATE(3104),
    [sym_closure_expression] = STATE(3104),
    [sym_closure_parameters] = STATE(2062),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3104),
    [sym_continue_expression] = STATE(3104),
    [sym_index_expression] = STATE(3104),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3104),
    [sym_block] = STATE(3104),
    [sym__literal] = STATE(3104),
    [sym_string_literal] = STATE(3104),
    [sym_boolean_literal] = STATE(3104),
    [sym_raw_string_literal] = ACTIONS(6774),
    [sym_float_literal] = ACTIONS(6774),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(5862),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5862),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5866),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(5868),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(5870),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(5872),
    [sym_integer_literal] = ACTIONS(6774),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6774),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2658] = {
    [sym_function_modifiers] = STATE(3109),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(666),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(3110),
    [sym_array_type] = STATE(666),
    [sym_function_type] = STATE(666),
    [sym_tuple_type] = STATE(666),
    [sym_unit_type] = STATE(666),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(666),
    [sym_reference_type] = STATE(666),
    [sym_pointer_type] = STATE(666),
    [sym_empty_type] = STATE(666),
    [sym_dynamic_type] = STATE(666),
    [sym_macro_invocation] = STATE(666),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(3111),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(6776),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(6778),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6780),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6782),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2659] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(5886),
    [anon_sym_STAR] = ACTIONS(5888),
    [anon_sym_COMMA] = ACTIONS(1323),
    [anon_sym_AMP] = ACTIONS(5890),
    [anon_sym_DASH] = ACTIONS(5886),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(5892),
    [anon_sym_BANG_EQ] = ACTIONS(5894),
    [anon_sym_STAR_EQ] = ACTIONS(5892),
    [anon_sym_SLASH] = ACTIONS(5888),
    [anon_sym_SLASH_EQ] = ACTIONS(5892),
    [anon_sym_AMP_AMP] = ACTIONS(5896),
    [anon_sym_AMP_EQ] = ACTIONS(5892),
    [anon_sym_PERCENT] = ACTIONS(5888),
    [anon_sym_PERCENT_EQ] = ACTIONS(5892),
    [anon_sym_CARET] = ACTIONS(5898),
    [anon_sym_CARET_EQ] = ACTIONS(5892),
    [anon_sym_PLUS_EQ] = ACTIONS(5892),
    [anon_sym_LT] = ACTIONS(5900),
    [anon_sym_LT_LT] = ACTIONS(5902),
    [anon_sym_LT_LT_EQ] = ACTIONS(5892),
    [anon_sym_LT_EQ] = ACTIONS(5894),
    [anon_sym_EQ] = ACTIONS(5904),
    [anon_sym_EQ_EQ] = ACTIONS(5894),
    [anon_sym_GT] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5894),
    [anon_sym_GT_GT] = ACTIONS(5902),
    [anon_sym_GT_GT_EQ] = ACTIONS(5892),
    [anon_sym_PIPE] = ACTIONS(5906),
    [anon_sym_PIPE_EQ] = ACTIONS(5892),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(5910),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5912),
    [anon_sym_as] = ACTIONS(5914),
    [sym_line_comment] = ACTIONS(7),
  },
  [2660] = {
    [sym_function_modifiers] = STATE(726),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3080),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(727),
    [sym_array_type] = STATE(3080),
    [sym_function_type] = STATE(3080),
    [sym_tuple_type] = STATE(3080),
    [sym_unit_type] = STATE(3080),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(3080),
    [sym_reference_type] = STATE(3080),
    [sym_pointer_type] = STATE(3080),
    [sym_empty_type] = STATE(3080),
    [sym_abstract_type] = STATE(3081),
    [sym_dynamic_type] = STATE(3080),
    [sym_macro_invocation] = STATE(3080),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(728),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1543),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1547),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1549),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2661] = {
    [sym_function_modifiers] = STATE(726),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3082),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(727),
    [sym_array_type] = STATE(3082),
    [sym_function_type] = STATE(3082),
    [sym_tuple_type] = STATE(3082),
    [sym_unit_type] = STATE(3082),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(3082),
    [sym_reference_type] = STATE(3082),
    [sym_pointer_type] = STATE(3082),
    [sym_empty_type] = STATE(3082),
    [sym_abstract_type] = STATE(3083),
    [sym_dynamic_type] = STATE(3082),
    [sym_macro_invocation] = STATE(3082),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(728),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1543),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1547),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1549),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2662] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(3112),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [2663] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3113),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(3113),
    [sym_macro_invocation] = STATE(3113),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3113),
    [sym_unary_expression] = STATE(3113),
    [sym_try_expression] = STATE(3113),
    [sym_reference_expression] = STATE(3113),
    [sym_binary_expression] = STATE(3113),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3113),
    [sym_call_expression] = STATE(3113),
    [sym_array_expression] = STATE(3113),
    [sym_parenthesized_expression] = STATE(3113),
    [sym_tuple_expression] = STATE(3113),
    [sym_unit_expression] = STATE(3113),
    [sym_struct_expression] = STATE(3113),
    [sym_if_expression] = STATE(3113),
    [sym_if_let_expression] = STATE(3113),
    [sym_match_expression] = STATE(3113),
    [sym_while_expression] = STATE(3113),
    [sym_while_let_expression] = STATE(3113),
    [sym_loop_expression] = STATE(3113),
    [sym_for_expression] = STATE(3113),
    [sym_closure_expression] = STATE(3113),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3113),
    [sym_continue_expression] = STATE(3113),
    [sym_index_expression] = STATE(3113),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3113),
    [sym_block] = STATE(3113),
    [sym__literal] = STATE(3113),
    [sym_string_literal] = STATE(3113),
    [sym_boolean_literal] = STATE(3113),
    [sym_raw_string_literal] = ACTIONS(6784),
    [sym_float_literal] = ACTIONS(6784),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(6784),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6784),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [2664] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(3114),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [2665] = {
    [sym_else_tail] = STATE(2777),
    [sym_raw_string_literal] = ACTIONS(6158),
    [sym_float_literal] = ACTIONS(6158),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6158),
    [anon_sym_macro_rules_BANG] = ACTIONS(6158),
    [anon_sym_LPAREN] = ACTIONS(6158),
    [anon_sym_LBRACE] = ACTIONS(6158),
    [anon_sym_RBRACE] = ACTIONS(6158),
    [anon_sym_LBRACK] = ACTIONS(6158),
    [anon_sym_PLUS] = ACTIONS(6160),
    [anon_sym_STAR] = ACTIONS(6160),
    [anon_sym_u8] = ACTIONS(6160),
    [anon_sym_i8] = ACTIONS(6160),
    [anon_sym_u16] = ACTIONS(6160),
    [anon_sym_i16] = ACTIONS(6160),
    [anon_sym_u32] = ACTIONS(6160),
    [anon_sym_i32] = ACTIONS(6160),
    [anon_sym_u64] = ACTIONS(6160),
    [anon_sym_i64] = ACTIONS(6160),
    [anon_sym_u128] = ACTIONS(6160),
    [anon_sym_i128] = ACTIONS(6160),
    [anon_sym_isize] = ACTIONS(6160),
    [anon_sym_usize] = ACTIONS(6160),
    [anon_sym_f32] = ACTIONS(6160),
    [anon_sym_f64] = ACTIONS(6160),
    [anon_sym_bool] = ACTIONS(6160),
    [anon_sym_str] = ACTIONS(6160),
    [anon_sym_char] = ACTIONS(6160),
    [anon_sym_AMP] = ACTIONS(6160),
    [anon_sym_DASH] = ACTIONS(6160),
    [anon_sym_DOT] = ACTIONS(6160),
    [anon_sym_DASH_EQ] = ACTIONS(6158),
    [anon_sym_COLON_COLON] = ACTIONS(6158),
    [anon_sym_BANG] = ACTIONS(6160),
    [anon_sym_BANG_EQ] = ACTIONS(6158),
    [anon_sym_STAR_EQ] = ACTIONS(6158),
    [anon_sym_SLASH] = ACTIONS(6160),
    [anon_sym_SLASH_EQ] = ACTIONS(6158),
    [anon_sym_AMP_AMP] = ACTIONS(6158),
    [anon_sym_AMP_EQ] = ACTIONS(6158),
    [anon_sym_POUND] = ACTIONS(6158),
    [anon_sym_PERCENT] = ACTIONS(6160),
    [anon_sym_PERCENT_EQ] = ACTIONS(6158),
    [anon_sym_CARET] = ACTIONS(6160),
    [anon_sym_CARET_EQ] = ACTIONS(6158),
    [anon_sym_PLUS_EQ] = ACTIONS(6158),
    [anon_sym_LT] = ACTIONS(6160),
    [anon_sym_LT_LT] = ACTIONS(6160),
    [anon_sym_LT_LT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_EQ] = ACTIONS(6160),
    [anon_sym_EQ_EQ] = ACTIONS(6158),
    [anon_sym_GT] = ACTIONS(6160),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_GT_GT] = ACTIONS(6160),
    [anon_sym_GT_GT_EQ] = ACTIONS(6158),
    [anon_sym_PIPE] = ACTIONS(6160),
    [anon_sym_PIPE_EQ] = ACTIONS(6158),
    [anon_sym_PIPE_PIPE] = ACTIONS(6158),
    [anon_sym_QMARK] = ACTIONS(6158),
    [anon_sym_SQUOTE] = ACTIONS(6160),
    [anon_sym_DOT_DOT] = ACTIONS(6160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6158),
    [anon_sym_as] = ACTIONS(6160),
    [anon_sym_break] = ACTIONS(6160),
    [anon_sym_const] = ACTIONS(6160),
    [anon_sym_continue] = ACTIONS(6160),
    [anon_sym_default] = ACTIONS(6160),
    [anon_sym_enum] = ACTIONS(6160),
    [anon_sym_fn] = ACTIONS(6160),
    [anon_sym_for] = ACTIONS(6160),
    [anon_sym_if] = ACTIONS(6160),
    [anon_sym_impl] = ACTIONS(6160),
    [anon_sym_let] = ACTIONS(6160),
    [anon_sym_loop] = ACTIONS(6160),
    [anon_sym_match] = ACTIONS(6160),
    [anon_sym_mod] = ACTIONS(6160),
    [anon_sym_pub] = ACTIONS(6160),
    [anon_sym_return] = ACTIONS(6160),
    [anon_sym_static] = ACTIONS(6160),
    [anon_sym_struct] = ACTIONS(6160),
    [anon_sym_trait] = ACTIONS(6160),
    [anon_sym_type] = ACTIONS(6160),
    [anon_sym_union] = ACTIONS(6160),
    [anon_sym_unsafe] = ACTIONS(6160),
    [anon_sym_use] = ACTIONS(6160),
    [anon_sym_while] = ACTIONS(6160),
    [anon_sym_extern] = ACTIONS(6160),
    [anon_sym_else] = ACTIONS(2777),
    [anon_sym_move] = ACTIONS(6160),
    [sym_integer_literal] = ACTIONS(6158),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6158),
    [sym_char_literal] = ACTIONS(6158),
    [anon_sym_true] = ACTIONS(6160),
    [anon_sym_false] = ACTIONS(6160),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6160),
    [sym_self] = ACTIONS(6160),
    [sym_super] = ACTIONS(6160),
    [sym_crate] = ACTIONS(6160),
    [sym_metavariable] = ACTIONS(6158),
  },
  [2666] = {
    [sym_function_modifiers] = STATE(752),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3080),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(753),
    [sym_array_type] = STATE(3080),
    [sym_function_type] = STATE(3080),
    [sym_tuple_type] = STATE(3080),
    [sym_unit_type] = STATE(3080),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(3080),
    [sym_reference_type] = STATE(3080),
    [sym_pointer_type] = STATE(3080),
    [sym_empty_type] = STATE(3080),
    [sym_abstract_type] = STATE(3081),
    [sym_dynamic_type] = STATE(3080),
    [sym_macro_invocation] = STATE(3080),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(754),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1593),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1597),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1599),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2667] = {
    [sym_function_modifiers] = STATE(752),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3082),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(753),
    [sym_array_type] = STATE(3082),
    [sym_function_type] = STATE(3082),
    [sym_tuple_type] = STATE(3082),
    [sym_unit_type] = STATE(3082),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(3082),
    [sym_reference_type] = STATE(3082),
    [sym_pointer_type] = STATE(3082),
    [sym_empty_type] = STATE(3082),
    [sym_abstract_type] = STATE(3083),
    [sym_dynamic_type] = STATE(3082),
    [sym_macro_invocation] = STATE(3082),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(754),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1593),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1595),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1597),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1599),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2668] = {
    [sym_else_tail] = STATE(3089),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6158),
    [anon_sym_LPAREN] = ACTIONS(6158),
    [anon_sym_LBRACK] = ACTIONS(6158),
    [anon_sym_RBRACK] = ACTIONS(6158),
    [anon_sym_PLUS] = ACTIONS(6160),
    [anon_sym_STAR] = ACTIONS(6160),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_AMP] = ACTIONS(6160),
    [anon_sym_DASH] = ACTIONS(6160),
    [anon_sym_DOT] = ACTIONS(6160),
    [anon_sym_DASH_EQ] = ACTIONS(6158),
    [anon_sym_BANG_EQ] = ACTIONS(6158),
    [anon_sym_STAR_EQ] = ACTIONS(6158),
    [anon_sym_SLASH] = ACTIONS(6160),
    [anon_sym_SLASH_EQ] = ACTIONS(6158),
    [anon_sym_AMP_AMP] = ACTIONS(6158),
    [anon_sym_AMP_EQ] = ACTIONS(6158),
    [anon_sym_PERCENT] = ACTIONS(6160),
    [anon_sym_PERCENT_EQ] = ACTIONS(6158),
    [anon_sym_CARET] = ACTIONS(6160),
    [anon_sym_CARET_EQ] = ACTIONS(6158),
    [anon_sym_PLUS_EQ] = ACTIONS(6158),
    [anon_sym_LT] = ACTIONS(6160),
    [anon_sym_LT_LT] = ACTIONS(6160),
    [anon_sym_LT_LT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_EQ] = ACTIONS(6160),
    [anon_sym_EQ_EQ] = ACTIONS(6158),
    [anon_sym_GT] = ACTIONS(6160),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_GT_GT] = ACTIONS(6160),
    [anon_sym_GT_GT_EQ] = ACTIONS(6158),
    [anon_sym_PIPE] = ACTIONS(6160),
    [anon_sym_PIPE_EQ] = ACTIONS(6158),
    [anon_sym_PIPE_PIPE] = ACTIONS(6158),
    [anon_sym_QMARK] = ACTIONS(6158),
    [anon_sym_DOT_DOT] = ACTIONS(6160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6158),
    [anon_sym_as] = ACTIONS(6158),
    [anon_sym_else] = ACTIONS(2795),
    [sym_line_comment] = ACTIONS(7),
  },
  [2669] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3115),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(3115),
    [sym_macro_invocation] = STATE(3115),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3115),
    [sym_unary_expression] = STATE(3115),
    [sym_try_expression] = STATE(3115),
    [sym_reference_expression] = STATE(3115),
    [sym_binary_expression] = STATE(3115),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3115),
    [sym_call_expression] = STATE(3115),
    [sym_array_expression] = STATE(3115),
    [sym_parenthesized_expression] = STATE(3115),
    [sym_tuple_expression] = STATE(3115),
    [sym_unit_expression] = STATE(3115),
    [sym_struct_expression] = STATE(3115),
    [sym_if_expression] = STATE(3115),
    [sym_if_let_expression] = STATE(3115),
    [sym_match_expression] = STATE(3115),
    [sym_while_expression] = STATE(3115),
    [sym_while_let_expression] = STATE(3115),
    [sym_loop_expression] = STATE(3115),
    [sym_for_expression] = STATE(3115),
    [sym_closure_expression] = STATE(3115),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3115),
    [sym_continue_expression] = STATE(3115),
    [sym_index_expression] = STATE(3115),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3115),
    [sym_block] = STATE(3115),
    [sym__literal] = STATE(3115),
    [sym_string_literal] = STATE(3115),
    [sym_boolean_literal] = STATE(3115),
    [sym_raw_string_literal] = ACTIONS(6786),
    [sym_float_literal] = ACTIONS(6786),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(6786),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6786),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [2670] = {
    [sym_if_expression] = STATE(2043),
    [sym_if_let_expression] = STATE(2043),
    [sym_block] = STATE(2043),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(6788),
    [sym_line_comment] = ACTIONS(7),
  },
  [2671] = {
    [sym_function_modifiers] = STATE(2098),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2001),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(2099),
    [sym_array_type] = STATE(2001),
    [sym_function_type] = STATE(2001),
    [sym_tuple_type] = STATE(2001),
    [sym_unit_type] = STATE(2001),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2001),
    [sym_reference_type] = STATE(2001),
    [sym_pointer_type] = STATE(2001),
    [sym_empty_type] = STATE(2001),
    [sym_dynamic_type] = STATE(2001),
    [sym_macro_invocation] = STATE(2001),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(2100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(4717),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(4719),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4721),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4723),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2672] = {
    [sym_function_modifiers] = STATE(2098),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2003),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(2099),
    [sym_array_type] = STATE(2003),
    [sym_function_type] = STATE(2003),
    [sym_tuple_type] = STATE(2003),
    [sym_unit_type] = STATE(2003),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2003),
    [sym_reference_type] = STATE(2003),
    [sym_pointer_type] = STATE(2003),
    [sym_empty_type] = STATE(2003),
    [sym_dynamic_type] = STATE(2003),
    [sym_macro_invocation] = STATE(2003),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(2100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(4717),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(4719),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4721),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4723),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2673] = {
    [sym_function_modifiers] = STATE(2098),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2003),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(2099),
    [sym_array_type] = STATE(2003),
    [sym_function_type] = STATE(2003),
    [sym_tuple_type] = STATE(2003),
    [sym_unit_type] = STATE(2003),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2003),
    [sym_reference_type] = STATE(2003),
    [sym_pointer_type] = STATE(2003),
    [sym_empty_type] = STATE(2003),
    [sym_dynamic_type] = STATE(2003),
    [sym_macro_invocation] = STATE(2003),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(2100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_PLUS] = ACTIONS(5946),
    [anon_sym_STAR] = ACTIONS(4717),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(4719),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4721),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_mutable_specifier] = ACTIONS(6790),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4723),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2674] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1760),
    [anon_sym_LBRACK] = ACTIONS(1760),
    [anon_sym_RBRACK] = ACTIONS(1760),
    [anon_sym_PLUS] = ACTIONS(4443),
    [anon_sym_STAR] = ACTIONS(4443),
    [anon_sym_COMMA] = ACTIONS(1760),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_DASH] = ACTIONS(4443),
    [anon_sym_DOT] = ACTIONS(4443),
    [anon_sym_DASH_EQ] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(6792),
    [anon_sym_BANG_EQ] = ACTIONS(1760),
    [anon_sym_STAR_EQ] = ACTIONS(1760),
    [anon_sym_SLASH] = ACTIONS(4443),
    [anon_sym_SLASH_EQ] = ACTIONS(1760),
    [anon_sym_AMP_AMP] = ACTIONS(1760),
    [anon_sym_AMP_EQ] = ACTIONS(1760),
    [anon_sym_PERCENT] = ACTIONS(4443),
    [anon_sym_PERCENT_EQ] = ACTIONS(1760),
    [anon_sym_CARET] = ACTIONS(4443),
    [anon_sym_CARET_EQ] = ACTIONS(1760),
    [anon_sym_PLUS_EQ] = ACTIONS(1760),
    [anon_sym_LT] = ACTIONS(4443),
    [anon_sym_LT_LT] = ACTIONS(4443),
    [anon_sym_LT_LT_EQ] = ACTIONS(1760),
    [anon_sym_LT_EQ] = ACTIONS(1760),
    [anon_sym_EQ] = ACTIONS(4443),
    [anon_sym_EQ_EQ] = ACTIONS(1760),
    [anon_sym_GT] = ACTIONS(4443),
    [anon_sym_GT_EQ] = ACTIONS(1760),
    [anon_sym_GT_GT] = ACTIONS(4443),
    [anon_sym_GT_GT_EQ] = ACTIONS(1760),
    [anon_sym_PIPE] = ACTIONS(4443),
    [anon_sym_PIPE_EQ] = ACTIONS(1760),
    [anon_sym_PIPE_PIPE] = ACTIONS(1760),
    [anon_sym_QMARK] = ACTIONS(1760),
    [anon_sym_DOT_DOT] = ACTIONS(4443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1760),
    [anon_sym_as] = ACTIONS(1760),
    [sym_line_comment] = ACTIONS(7),
  },
  [2675] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1794),
    [anon_sym_LBRACK] = ACTIONS(1794),
    [anon_sym_RBRACK] = ACTIONS(1794),
    [anon_sym_PLUS] = ACTIONS(4449),
    [anon_sym_STAR] = ACTIONS(4449),
    [anon_sym_COMMA] = ACTIONS(1794),
    [anon_sym_AMP] = ACTIONS(4449),
    [anon_sym_DASH] = ACTIONS(4449),
    [anon_sym_DOT] = ACTIONS(4449),
    [anon_sym_DASH_EQ] = ACTIONS(1794),
    [anon_sym_DASH_GT] = ACTIONS(6794),
    [anon_sym_BANG_EQ] = ACTIONS(1794),
    [anon_sym_STAR_EQ] = ACTIONS(1794),
    [anon_sym_SLASH] = ACTIONS(4449),
    [anon_sym_SLASH_EQ] = ACTIONS(1794),
    [anon_sym_AMP_AMP] = ACTIONS(1794),
    [anon_sym_AMP_EQ] = ACTIONS(1794),
    [anon_sym_PERCENT] = ACTIONS(4449),
    [anon_sym_PERCENT_EQ] = ACTIONS(1794),
    [anon_sym_CARET] = ACTIONS(4449),
    [anon_sym_CARET_EQ] = ACTIONS(1794),
    [anon_sym_PLUS_EQ] = ACTIONS(1794),
    [anon_sym_LT] = ACTIONS(4449),
    [anon_sym_LT_LT] = ACTIONS(4449),
    [anon_sym_LT_LT_EQ] = ACTIONS(1794),
    [anon_sym_LT_EQ] = ACTIONS(1794),
    [anon_sym_EQ] = ACTIONS(4449),
    [anon_sym_EQ_EQ] = ACTIONS(1794),
    [anon_sym_GT] = ACTIONS(4449),
    [anon_sym_GT_EQ] = ACTIONS(1794),
    [anon_sym_GT_GT] = ACTIONS(4449),
    [anon_sym_GT_GT_EQ] = ACTIONS(1794),
    [anon_sym_PIPE] = ACTIONS(4449),
    [anon_sym_PIPE_EQ] = ACTIONS(1794),
    [anon_sym_PIPE_PIPE] = ACTIONS(1794),
    [anon_sym_QMARK] = ACTIONS(1794),
    [anon_sym_DOT_DOT] = ACTIONS(4449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1794),
    [anon_sym_as] = ACTIONS(1794),
    [sym_line_comment] = ACTIONS(7),
  },
  [2676] = {
    [sym_parameters] = STATE(3119),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [sym_line_comment] = ACTIONS(7),
  },
  [2677] = {
    [sym_parameters] = STATE(3120),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [2678] = {
    [sym_parameters] = STATE(3119),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [2679] = {
    [sym_function_modifiers] = STATE(2098),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2016),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(2016),
    [sym_array_type] = STATE(2016),
    [sym_function_type] = STATE(2016),
    [sym_tuple_type] = STATE(2016),
    [sym_unit_type] = STATE(2016),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2016),
    [sym_reference_type] = STATE(2016),
    [sym_pointer_type] = STATE(2016),
    [sym_empty_type] = STATE(2016),
    [sym_dynamic_type] = STATE(2016),
    [sym_macro_invocation] = STATE(2016),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(2100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(4717),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(4719),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(4453),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4721),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4723),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2680] = {
    [sym_function_modifiers] = STATE(2098),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2016),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(2099),
    [sym_array_type] = STATE(2016),
    [sym_function_type] = STATE(2016),
    [sym_tuple_type] = STATE(2016),
    [sym_unit_type] = STATE(2016),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2016),
    [sym_reference_type] = STATE(2016),
    [sym_pointer_type] = STATE(2016),
    [sym_empty_type] = STATE(2016),
    [sym_dynamic_type] = STATE(2016),
    [sym_macro_invocation] = STATE(2016),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(2100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(4717),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(4719),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4721),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4723),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2681] = {
    [sym_function_modifiers] = STATE(785),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3080),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(786),
    [sym_array_type] = STATE(3080),
    [sym_function_type] = STATE(3080),
    [sym_tuple_type] = STATE(3080),
    [sym_unit_type] = STATE(3080),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(3080),
    [sym_reference_type] = STATE(3080),
    [sym_pointer_type] = STATE(3080),
    [sym_empty_type] = STATE(3080),
    [sym_abstract_type] = STATE(3081),
    [sym_dynamic_type] = STATE(3080),
    [sym_macro_invocation] = STATE(3080),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(787),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1656),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1658),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1660),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1662),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2682] = {
    [sym_function_modifiers] = STATE(785),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3082),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(786),
    [sym_array_type] = STATE(3082),
    [sym_function_type] = STATE(3082),
    [sym_tuple_type] = STATE(3082),
    [sym_unit_type] = STATE(3082),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(3082),
    [sym_reference_type] = STATE(3082),
    [sym_pointer_type] = STATE(3082),
    [sym_empty_type] = STATE(3082),
    [sym_abstract_type] = STATE(3083),
    [sym_dynamic_type] = STATE(3082),
    [sym_macro_invocation] = STATE(3082),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(787),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1656),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1658),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1660),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1662),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2683] = {
    [sym_else_tail] = STATE(3089),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6158),
    [anon_sym_LPAREN] = ACTIONS(6158),
    [anon_sym_LBRACK] = ACTIONS(6158),
    [anon_sym_PLUS] = ACTIONS(6160),
    [anon_sym_STAR] = ACTIONS(6160),
    [anon_sym_AMP] = ACTIONS(6160),
    [anon_sym_DASH] = ACTIONS(6160),
    [anon_sym_DOT] = ACTIONS(6160),
    [anon_sym_DASH_EQ] = ACTIONS(6158),
    [anon_sym_BANG_EQ] = ACTIONS(6158),
    [anon_sym_STAR_EQ] = ACTIONS(6158),
    [anon_sym_SLASH] = ACTIONS(6160),
    [anon_sym_SLASH_EQ] = ACTIONS(6158),
    [anon_sym_AMP_AMP] = ACTIONS(6158),
    [anon_sym_AMP_EQ] = ACTIONS(6158),
    [anon_sym_PERCENT] = ACTIONS(6160),
    [anon_sym_PERCENT_EQ] = ACTIONS(6158),
    [anon_sym_CARET] = ACTIONS(6160),
    [anon_sym_CARET_EQ] = ACTIONS(6158),
    [anon_sym_PLUS_EQ] = ACTIONS(6158),
    [anon_sym_LT] = ACTIONS(6160),
    [anon_sym_LT_LT] = ACTIONS(6160),
    [anon_sym_LT_LT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_EQ] = ACTIONS(6160),
    [anon_sym_EQ_EQ] = ACTIONS(6158),
    [anon_sym_GT] = ACTIONS(6160),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_GT_GT] = ACTIONS(6160),
    [anon_sym_GT_GT_EQ] = ACTIONS(6158),
    [anon_sym_PIPE] = ACTIONS(6160),
    [anon_sym_PIPE_EQ] = ACTIONS(6158),
    [anon_sym_PIPE_PIPE] = ACTIONS(6158),
    [anon_sym_QMARK] = ACTIONS(6158),
    [anon_sym_DOT_DOT] = ACTIONS(6160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6158),
    [anon_sym_as] = ACTIONS(6158),
    [anon_sym_else] = ACTIONS(2864),
    [sym_line_comment] = ACTIONS(7),
  },
  [2684] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(6796),
    [anon_sym_RBRACK] = ACTIONS(6796),
    [anon_sym_COMMA] = ACTIONS(6796),
    [sym_line_comment] = ACTIONS(7),
  },
  [2685] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(6798),
    [anon_sym_COMMA] = ACTIONS(6798),
    [sym_line_comment] = ACTIONS(7),
  },
  [2686] = {
    [sym_meta_item] = STATE(2685),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(6800),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(727),
  },
  [2687] = {
    [aux_sym_meta_item_repeat1] = STATE(2687),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(6798),
    [anon_sym_COMMA] = ACTIONS(6802),
    [sym_line_comment] = ACTIONS(7),
  },
  [2688] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6805),
    [anon_sym_LPAREN] = ACTIONS(6805),
    [anon_sym_RPAREN] = ACTIONS(6805),
    [anon_sym_LBRACE] = ACTIONS(6805),
    [anon_sym_RBRACE] = ACTIONS(6805),
    [anon_sym_RBRACK] = ACTIONS(6805),
    [anon_sym_COLON] = ACTIONS(6805),
    [anon_sym_PLUS] = ACTIONS(6805),
    [anon_sym_COMMA] = ACTIONS(6805),
    [anon_sym_DASH_GT] = ACTIONS(6805),
    [anon_sym_EQ] = ACTIONS(6805),
    [anon_sym_GT] = ACTIONS(6805),
    [anon_sym_PIPE] = ACTIONS(6805),
    [anon_sym_as] = ACTIONS(6805),
    [anon_sym_where] = ACTIONS(6805),
    [sym_line_comment] = ACTIONS(7),
  },
  [2689] = {
    [sym_function_modifiers] = STATE(370),
    [sym_self_parameter] = STATE(2121),
    [sym_variadic_parameter] = STATE(2121),
    [sym_parameter] = STATE(2121),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2122),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(839),
    [sym_array_type] = STATE(2122),
    [sym_function_type] = STATE(2122),
    [sym_tuple_type] = STATE(2122),
    [sym_unit_type] = STATE(2122),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2122),
    [sym_reference_type] = STATE(2122),
    [sym_pointer_type] = STATE(2122),
    [sym_empty_type] = STATE(2122),
    [sym_abstract_type] = STATE(2121),
    [sym_dynamic_type] = STATE(2122),
    [sym_macro_invocation] = STATE(2122),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [sym_reference_pattern_in_parameter] = STATE(840),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(1740),
    [anon_sym_i8] = ACTIONS(1740),
    [anon_sym_u16] = ACTIONS(1740),
    [anon_sym_i16] = ACTIONS(1740),
    [anon_sym_u32] = ACTIONS(1740),
    [anon_sym_i32] = ACTIONS(1740),
    [anon_sym_u64] = ACTIONS(1740),
    [anon_sym_i64] = ACTIONS(1740),
    [anon_sym_u128] = ACTIONS(1740),
    [anon_sym_i128] = ACTIONS(1740),
    [anon_sym_isize] = ACTIONS(1740),
    [anon_sym_usize] = ACTIONS(1740),
    [anon_sym_f32] = ACTIONS(1740),
    [anon_sym_f64] = ACTIONS(1740),
    [anon_sym_bool] = ACTIONS(1740),
    [anon_sym_str] = ACTIONS(1740),
    [anon_sym_char] = ACTIONS(1740),
    [anon_sym__] = ACTIONS(4770),
    [anon_sym_AMP] = ACTIONS(1744),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1746),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(1748),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_union] = ACTIONS(1752),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(1754),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1756),
    [sym_self] = ACTIONS(1758),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2690] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(371),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(371),
    [sym_function_type] = STATE(371),
    [sym_tuple_type] = STATE(371),
    [sym_unit_type] = STATE(371),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(371),
    [sym_reference_type] = STATE(371),
    [sym_pointer_type] = STATE(371),
    [sym_empty_type] = STATE(371),
    [sym_dynamic_type] = STATE(371),
    [sym_macro_invocation] = STATE(371),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [sym_ref_pattern] = STATE(895),
    [sym_reference_pattern_in_parameter] = STATE(895),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_RPAREN] = ACTIONS(6807),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(4776),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(4778),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [anon_sym_ref] = ACTIONS(821),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4780),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2691] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [sym_tuple_pattern_in_parameter] = STATE(899),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5971),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6809),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2692] = {
    [sym_parameters] = STATE(800),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_RPAREN] = ACTIONS(1866),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_COMMA] = ACTIONS(1866),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_BANG] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [2693] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(6811),
    [anon_sym_COMMA] = ACTIONS(6811),
    [anon_sym_COLON_COLON] = ACTIONS(781),
    [sym_line_comment] = ACTIONS(7),
  },
  [2694] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(4869),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_COMMA] = ACTIONS(4869),
    [sym_line_comment] = ACTIONS(7),
  },
  [2695] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(4871),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_COMMA] = ACTIONS(4871),
    [sym_line_comment] = ACTIONS(7),
  },
  [2696] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6588),
    [anon_sym_LPAREN] = ACTIONS(6588),
    [anon_sym_RPAREN] = ACTIONS(6588),
    [anon_sym_LBRACE] = ACTIONS(6588),
    [anon_sym_RBRACE] = ACTIONS(6588),
    [anon_sym_RBRACK] = ACTIONS(6588),
    [anon_sym_COLON] = ACTIONS(6588),
    [anon_sym_PLUS] = ACTIONS(6588),
    [anon_sym_COMMA] = ACTIONS(6588),
    [anon_sym_EQ] = ACTIONS(6588),
    [anon_sym_GT] = ACTIONS(6588),
    [anon_sym_PIPE] = ACTIONS(6588),
    [anon_sym_as] = ACTIONS(6588),
    [anon_sym_where] = ACTIONS(6588),
    [sym_line_comment] = ACTIONS(7),
  },
  [2697] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1972),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1972),
    [sym_unary_expression] = STATE(1972),
    [sym_try_expression] = STATE(1972),
    [sym_reference_expression] = STATE(1972),
    [sym_binary_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1972),
    [sym_call_expression] = STATE(1972),
    [sym_array_expression] = STATE(1972),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_tuple_expression] = STATE(1972),
    [sym_unit_expression] = STATE(1972),
    [sym_struct_expression] = STATE(1972),
    [sym_if_expression] = STATE(1972),
    [sym_if_let_expression] = STATE(1972),
    [sym_match_expression] = STATE(1972),
    [sym_while_expression] = STATE(1972),
    [sym_while_let_expression] = STATE(1972),
    [sym_loop_expression] = STATE(1972),
    [sym_for_expression] = STATE(1972),
    [sym_closure_expression] = STATE(1972),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1972),
    [sym_continue_expression] = STATE(1972),
    [sym_index_expression] = STATE(1972),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1972),
    [sym_block] = STATE(1972),
    [sym__literal] = STATE(1972),
    [sym_string_literal] = STATE(1972),
    [sym_boolean_literal] = STATE(1972),
    [sym_raw_string_literal] = ACTIONS(4375),
    [sym_float_literal] = ACTIONS(4375),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(6813),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(4375),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4375),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2698] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(769),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(769),
    [sym_macro_invocation] = STATE(769),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(769),
    [sym_unary_expression] = STATE(769),
    [sym_try_expression] = STATE(769),
    [sym_reference_expression] = STATE(769),
    [sym_binary_expression] = STATE(769),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(769),
    [sym_call_expression] = STATE(769),
    [sym_array_expression] = STATE(769),
    [sym_parenthesized_expression] = STATE(769),
    [sym_tuple_expression] = STATE(769),
    [sym_unit_expression] = STATE(769),
    [sym_struct_expression] = STATE(769),
    [sym_if_expression] = STATE(769),
    [sym_if_let_expression] = STATE(769),
    [sym_match_expression] = STATE(769),
    [sym_while_expression] = STATE(769),
    [sym_while_let_expression] = STATE(769),
    [sym_loop_expression] = STATE(769),
    [sym_for_expression] = STATE(769),
    [sym_closure_expression] = STATE(769),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(769),
    [sym_continue_expression] = STATE(769),
    [sym_index_expression] = STATE(769),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(769),
    [sym_block] = STATE(769),
    [sym__literal] = STATE(769),
    [sym_string_literal] = STATE(769),
    [sym_boolean_literal] = STATE(769),
    [sym_raw_string_literal] = ACTIONS(1620),
    [sym_float_literal] = ACTIONS(1620),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_RBRACK] = ACTIONS(6813),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1620),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1620),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2699] = {
    [sym_function_modifiers] = STATE(854),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2156),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1664),
    [sym_array_type] = STATE(2156),
    [sym_function_type] = STATE(2156),
    [sym_tuple_type] = STATE(2156),
    [sym_unit_type] = STATE(2156),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2156),
    [sym_reference_type] = STATE(2156),
    [sym_pointer_type] = STATE(2156),
    [sym_empty_type] = STATE(2156),
    [sym_abstract_type] = STATE(2157),
    [sym_dynamic_type] = STATE(2156),
    [sym_macro_invocation] = STATE(2156),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(858),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1786),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1788),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1790),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2972),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2700] = {
    [sym_function_modifiers] = STATE(854),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2158),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1664),
    [sym_array_type] = STATE(2158),
    [sym_function_type] = STATE(2158),
    [sym_tuple_type] = STATE(2158),
    [sym_unit_type] = STATE(2158),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2158),
    [sym_reference_type] = STATE(2158),
    [sym_pointer_type] = STATE(2158),
    [sym_empty_type] = STATE(2158),
    [sym_abstract_type] = STATE(2159),
    [sym_dynamic_type] = STATE(2158),
    [sym_macro_invocation] = STATE(2158),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(858),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1786),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1788),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1790),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2972),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2701] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6815),
    [anon_sym_LPAREN] = ACTIONS(6815),
    [anon_sym_RPAREN] = ACTIONS(6815),
    [anon_sym_LBRACE] = ACTIONS(6815),
    [anon_sym_RBRACE] = ACTIONS(6815),
    [anon_sym_RBRACK] = ACTIONS(6815),
    [anon_sym_COLON] = ACTIONS(6817),
    [anon_sym_PLUS] = ACTIONS(6815),
    [anon_sym_COMMA] = ACTIONS(6815),
    [anon_sym_COLON_COLON] = ACTIONS(6815),
    [anon_sym_EQ] = ACTIONS(6815),
    [anon_sym_GT] = ACTIONS(6815),
    [anon_sym_PIPE] = ACTIONS(6815),
    [anon_sym_as] = ACTIONS(6815),
    [anon_sym_for] = ACTIONS(6815),
    [anon_sym_where] = ACTIONS(6815),
    [sym_line_comment] = ACTIONS(7),
  },
  [2702] = {
    [sym_function_modifiers] = STATE(854),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2151),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2152),
    [sym_array_type] = STATE(2151),
    [sym_function_type] = STATE(2151),
    [sym_tuple_type] = STATE(2151),
    [sym_unit_type] = STATE(2151),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2151),
    [sym_type_binding] = STATE(2153),
    [sym_reference_type] = STATE(2151),
    [sym_pointer_type] = STATE(2151),
    [sym_empty_type] = STATE(2151),
    [sym_dynamic_type] = STATE(2151),
    [sym_macro_invocation] = STATE(2151),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(858),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1786),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1788),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1790),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1792),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2703] = {
    [sym_function_modifiers] = STATE(867),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2156),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(869),
    [sym_array_type] = STATE(2156),
    [sym_function_type] = STATE(2156),
    [sym_tuple_type] = STATE(2156),
    [sym_unit_type] = STATE(2156),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2156),
    [sym_reference_type] = STATE(2156),
    [sym_pointer_type] = STATE(2156),
    [sym_empty_type] = STATE(2156),
    [sym_abstract_type] = STATE(2157),
    [sym_dynamic_type] = STATE(2156),
    [sym_macro_invocation] = STATE(2156),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(870),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1806),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1808),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1810),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2704] = {
    [sym_function_modifiers] = STATE(867),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2158),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(869),
    [sym_array_type] = STATE(2158),
    [sym_function_type] = STATE(2158),
    [sym_tuple_type] = STATE(2158),
    [sym_unit_type] = STATE(2158),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2158),
    [sym_reference_type] = STATE(2158),
    [sym_pointer_type] = STATE(2158),
    [sym_empty_type] = STATE(2158),
    [sym_abstract_type] = STATE(2159),
    [sym_dynamic_type] = STATE(2158),
    [sym_macro_invocation] = STATE(2158),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(870),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1806),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1808),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1810),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2705] = {
    [sym_function_modifiers] = STATE(883),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2156),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(885),
    [sym_array_type] = STATE(2156),
    [sym_function_type] = STATE(2156),
    [sym_tuple_type] = STATE(2156),
    [sym_unit_type] = STATE(2156),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2156),
    [sym_reference_type] = STATE(2156),
    [sym_pointer_type] = STATE(2156),
    [sym_empty_type] = STATE(2156),
    [sym_abstract_type] = STATE(2157),
    [sym_dynamic_type] = STATE(2156),
    [sym_macro_invocation] = STATE(2156),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(887),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1838),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1840),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1842),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1844),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2706] = {
    [sym_function_modifiers] = STATE(883),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2158),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(885),
    [sym_array_type] = STATE(2158),
    [sym_function_type] = STATE(2158),
    [sym_tuple_type] = STATE(2158),
    [sym_unit_type] = STATE(2158),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2158),
    [sym_reference_type] = STATE(2158),
    [sym_pointer_type] = STATE(2158),
    [sym_empty_type] = STATE(2158),
    [sym_abstract_type] = STATE(2159),
    [sym_dynamic_type] = STATE(2158),
    [sym_macro_invocation] = STATE(2158),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(887),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1838),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1840),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1842),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1844),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2707] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(6819),
    [anon_sym_COLON] = ACTIONS(6819),
    [anon_sym_COMMA] = ACTIONS(6819),
    [anon_sym_PIPE] = ACTIONS(6819),
    [sym_line_comment] = ACTIONS(7),
  },
  [2708] = {
    [sym_ref_pattern] = STATE(2174),
    [sym_reference_pattern_in_parameter] = STATE(2174),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_AMP] = ACTIONS(2936),
    [anon_sym_ref] = ACTIONS(821),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4865),
  },
  [2709] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6821),
    [anon_sym_RPAREN] = ACTIONS(6821),
    [anon_sym_RBRACE] = ACTIONS(6821),
    [anon_sym_COLON] = ACTIONS(6821),
    [anon_sym_COMMA] = ACTIONS(6821),
    [anon_sym_EQ] = ACTIONS(6821),
    [anon_sym_PIPE] = ACTIONS(6821),
    [anon_sym_in] = ACTIONS(6821),
    [sym_line_comment] = ACTIONS(7),
  },
  [2710] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6823),
    [anon_sym_COMMA] = ACTIONS(6823),
    [sym_line_comment] = ACTIONS(7),
  },
  [2711] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(3126),
    [sym_tuple_pattern] = STATE(3126),
    [sym_tuple_struct_pattern] = STATE(3126),
    [sym_struct_pattern] = STATE(3126),
    [sym_remaining_field_pattern] = STATE(3126),
    [sym_mut_pattern] = STATE(3126),
    [sym_ref_pattern] = STATE(3126),
    [sym_captured_pattern] = STATE(3126),
    [sym_reference_pattern] = STATE(3126),
    [sym__literal] = STATE(3126),
    [sym_string_literal] = STATE(3126),
    [sym_boolean_literal] = STATE(3126),
    [sym_raw_string_literal] = ACTIONS(6825),
    [sym_float_literal] = ACTIONS(6825),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(6827),
    [anon_sym_AMP] = ACTIONS(4893),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(4895),
    [anon_sym_ref] = ACTIONS(4897),
    [sym_integer_literal] = ACTIONS(6825),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6825),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4899),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [2712] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(898),
    [sym_tuple_pattern] = STATE(898),
    [sym_tuple_struct_pattern] = STATE(898),
    [sym_struct_pattern] = STATE(898),
    [sym_remaining_field_pattern] = STATE(898),
    [sym_mut_pattern] = STATE(898),
    [sym_ref_pattern] = STATE(898),
    [sym_captured_pattern] = STATE(898),
    [sym_reference_pattern] = STATE(898),
    [sym__literal] = STATE(898),
    [sym_string_literal] = STATE(898),
    [sym_boolean_literal] = STATE(898),
    [sym_raw_string_literal] = ACTIONS(1858),
    [sym_float_literal] = ACTIONS(1858),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(1860),
    [anon_sym_AMP] = ACTIONS(4893),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(4895),
    [anon_sym_ref] = ACTIONS(4897),
    [sym_integer_literal] = ACTIONS(1858),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1858),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4899),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [2713] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(916),
    [sym_tuple_pattern] = STATE(916),
    [sym_tuple_struct_pattern] = STATE(916),
    [sym_struct_pattern] = STATE(916),
    [sym_remaining_field_pattern] = STATE(916),
    [sym_mut_pattern] = STATE(916),
    [sym_ref_pattern] = STATE(916),
    [sym_captured_pattern] = STATE(916),
    [sym_reference_pattern] = STATE(916),
    [sym__literal] = STATE(916),
    [sym_string_literal] = STATE(916),
    [sym_boolean_literal] = STATE(916),
    [sym_raw_string_literal] = ACTIONS(1910),
    [sym_float_literal] = ACTIONS(1910),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(1912),
    [anon_sym_AMP] = ACTIONS(4893),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(4895),
    [anon_sym_ref] = ACTIONS(4897),
    [sym_integer_literal] = ACTIONS(1910),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1910),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4899),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [2714] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6829),
    [anon_sym_RPAREN] = ACTIONS(6829),
    [anon_sym_RBRACE] = ACTIONS(6829),
    [anon_sym_COLON] = ACTIONS(6829),
    [anon_sym_COMMA] = ACTIONS(6829),
    [anon_sym_EQ] = ACTIONS(6829),
    [anon_sym_PIPE] = ACTIONS(6829),
    [anon_sym_in] = ACTIONS(6829),
    [sym_line_comment] = ACTIONS(7),
  },
  [2715] = {
    [sym_field_pattern] = STATE(2188),
    [sym_remaining_field_pattern] = STATE(2188),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(1902),
    [anon_sym_ref] = ACTIONS(1904),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1906),
  },
  [2716] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6831),
    [anon_sym_RPAREN] = ACTIONS(6831),
    [anon_sym_RBRACE] = ACTIONS(6831),
    [anon_sym_COLON] = ACTIONS(6831),
    [anon_sym_COMMA] = ACTIONS(6831),
    [anon_sym_EQ] = ACTIONS(6831),
    [anon_sym_PIPE] = ACTIONS(6831),
    [anon_sym_in] = ACTIONS(6831),
    [sym_line_comment] = ACTIONS(7),
  },
  [2717] = {
    [sym_function_modifiers] = STATE(929),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2156),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(931),
    [sym_array_type] = STATE(2156),
    [sym_function_type] = STATE(2156),
    [sym_tuple_type] = STATE(2156),
    [sym_unit_type] = STATE(2156),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2156),
    [sym_reference_type] = STATE(2156),
    [sym_pointer_type] = STATE(2156),
    [sym_empty_type] = STATE(2156),
    [sym_abstract_type] = STATE(2157),
    [sym_dynamic_type] = STATE(2156),
    [sym_macro_invocation] = STATE(2156),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(932),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1928),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1930),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1932),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1934),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2718] = {
    [sym_function_modifiers] = STATE(929),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2158),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(931),
    [sym_array_type] = STATE(2158),
    [sym_function_type] = STATE(2158),
    [sym_tuple_type] = STATE(2158),
    [sym_unit_type] = STATE(2158),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2158),
    [sym_reference_type] = STATE(2158),
    [sym_pointer_type] = STATE(2158),
    [sym_empty_type] = STATE(2158),
    [sym_abstract_type] = STATE(2159),
    [sym_dynamic_type] = STATE(2158),
    [sym_macro_invocation] = STATE(2158),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(932),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1928),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1930),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1932),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1934),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2719] = {
    [sym_raw_string_literal] = ACTIONS(6833),
    [sym_float_literal] = ACTIONS(6833),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(6833),
    [anon_sym_SEMI] = ACTIONS(6833),
    [anon_sym_macro_rules_BANG] = ACTIONS(6833),
    [anon_sym_LPAREN] = ACTIONS(6833),
    [anon_sym_LBRACE] = ACTIONS(6833),
    [anon_sym_RBRACE] = ACTIONS(6833),
    [anon_sym_LBRACK] = ACTIONS(6833),
    [anon_sym_STAR] = ACTIONS(6833),
    [anon_sym_u8] = ACTIONS(6835),
    [anon_sym_i8] = ACTIONS(6835),
    [anon_sym_u16] = ACTIONS(6835),
    [anon_sym_i16] = ACTIONS(6835),
    [anon_sym_u32] = ACTIONS(6835),
    [anon_sym_i32] = ACTIONS(6835),
    [anon_sym_u64] = ACTIONS(6835),
    [anon_sym_i64] = ACTIONS(6835),
    [anon_sym_u128] = ACTIONS(6835),
    [anon_sym_i128] = ACTIONS(6835),
    [anon_sym_isize] = ACTIONS(6835),
    [anon_sym_usize] = ACTIONS(6835),
    [anon_sym_f32] = ACTIONS(6835),
    [anon_sym_f64] = ACTIONS(6835),
    [anon_sym_bool] = ACTIONS(6835),
    [anon_sym_str] = ACTIONS(6835),
    [anon_sym_char] = ACTIONS(6835),
    [anon_sym_AMP] = ACTIONS(6833),
    [anon_sym_DASH] = ACTIONS(6833),
    [anon_sym_COLON_COLON] = ACTIONS(6833),
    [anon_sym_BANG] = ACTIONS(6833),
    [anon_sym_POUND] = ACTIONS(6833),
    [anon_sym_LT] = ACTIONS(6833),
    [anon_sym_PIPE] = ACTIONS(6833),
    [anon_sym_SQUOTE] = ACTIONS(6835),
    [anon_sym_DOT_DOT] = ACTIONS(6833),
    [anon_sym_break] = ACTIONS(6835),
    [anon_sym_const] = ACTIONS(6835),
    [anon_sym_continue] = ACTIONS(6835),
    [anon_sym_default] = ACTIONS(6835),
    [anon_sym_enum] = ACTIONS(6835),
    [anon_sym_fn] = ACTIONS(6835),
    [anon_sym_for] = ACTIONS(6835),
    [anon_sym_if] = ACTIONS(6835),
    [anon_sym_impl] = ACTIONS(6835),
    [anon_sym_let] = ACTIONS(6835),
    [anon_sym_loop] = ACTIONS(6835),
    [anon_sym_match] = ACTIONS(6835),
    [anon_sym_mod] = ACTIONS(6835),
    [anon_sym_pub] = ACTIONS(6835),
    [anon_sym_return] = ACTIONS(6835),
    [anon_sym_static] = ACTIONS(6835),
    [anon_sym_struct] = ACTIONS(6835),
    [anon_sym_trait] = ACTIONS(6835),
    [anon_sym_type] = ACTIONS(6835),
    [anon_sym_union] = ACTIONS(6835),
    [anon_sym_unsafe] = ACTIONS(6835),
    [anon_sym_use] = ACTIONS(6835),
    [anon_sym_while] = ACTIONS(6835),
    [anon_sym_extern] = ACTIONS(6835),
    [anon_sym_move] = ACTIONS(6835),
    [sym_integer_literal] = ACTIONS(6833),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6833),
    [sym_char_literal] = ACTIONS(6833),
    [anon_sym_true] = ACTIONS(6835),
    [anon_sym_false] = ACTIONS(6835),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6835),
    [sym_self] = ACTIONS(6835),
    [sym_super] = ACTIONS(6835),
    [sym_crate] = ACTIONS(6835),
    [sym_metavariable] = ACTIONS(6833),
  },
  [2720] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(6837),
    [anon_sym_COLON_COLON] = ACTIONS(2188),
    [sym_line_comment] = ACTIONS(7),
  },
  [2721] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(6839),
    [anon_sym_COLON_COLON] = ACTIONS(2192),
    [sym_line_comment] = ACTIONS(7),
  },
  [2722] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(6839),
    [anon_sym_COLON_COLON] = ACTIONS(449),
    [sym_line_comment] = ACTIONS(7),
  },
  [2723] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(6839),
    [anon_sym_COLON_COLON] = ACTIONS(2194),
    [sym_line_comment] = ACTIONS(7),
  },
  [2724] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3349),
  },
  [2725] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5294),
    [anon_sym_macro_rules_BANG] = ACTIONS(5294),
    [anon_sym_RBRACE] = ACTIONS(5294),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_POUND] = ACTIONS(5294),
    [anon_sym_EQ] = ACTIONS(5294),
    [anon_sym_const] = ACTIONS(5296),
    [anon_sym_default] = ACTIONS(5296),
    [anon_sym_enum] = ACTIONS(5296),
    [anon_sym_fn] = ACTIONS(5296),
    [anon_sym_impl] = ACTIONS(5296),
    [anon_sym_let] = ACTIONS(5296),
    [anon_sym_mod] = ACTIONS(5296),
    [anon_sym_pub] = ACTIONS(5296),
    [anon_sym_static] = ACTIONS(5296),
    [anon_sym_struct] = ACTIONS(5296),
    [anon_sym_trait] = ACTIONS(5296),
    [anon_sym_type] = ACTIONS(5296),
    [anon_sym_union] = ACTIONS(5296),
    [anon_sym_unsafe] = ACTIONS(5296),
    [anon_sym_use] = ACTIONS(5296),
    [anon_sym_extern] = ACTIONS(5296),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5296),
  },
  [2726] = {
    [sym_attribute_item] = STATE(2391),
    [sym_field_declaration] = STATE(2390),
    [sym_visibility_modifier] = STATE(1069),
    [aux_sym_enum_variant_list_repeat1] = STATE(2391),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6841),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_pub] = ACTIONS(1940),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2132),
  },
  [2727] = {
    [aux_sym_field_declaration_list_repeat1] = STATE(2393),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6841),
    [anon_sym_COMMA] = ACTIONS(6843),
    [sym_line_comment] = ACTIONS(7),
  },
  [2728] = {
    [aux_sym_field_declaration_list_repeat1] = STATE(3131),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6841),
    [anon_sym_COMMA] = ACTIONS(6843),
    [sym_line_comment] = ACTIONS(7),
  },
  [2729] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(6845),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(3495),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(6845),
    [anon_sym_AMP] = ACTIONS(3499),
    [anon_sym_DASH] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(3501),
    [anon_sym_BANG_EQ] = ACTIONS(3503),
    [anon_sym_STAR_EQ] = ACTIONS(3501),
    [anon_sym_SLASH] = ACTIONS(3497),
    [anon_sym_SLASH_EQ] = ACTIONS(3501),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_AMP_EQ] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_PERCENT_EQ] = ACTIONS(3501),
    [anon_sym_CARET] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3501),
    [anon_sym_PLUS_EQ] = ACTIONS(3501),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_LT_LT] = ACTIONS(3511),
    [anon_sym_LT_LT_EQ] = ACTIONS(3501),
    [anon_sym_LT_EQ] = ACTIONS(3503),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_EQ_EQ] = ACTIONS(3503),
    [anon_sym_GT] = ACTIONS(3509),
    [anon_sym_GT_EQ] = ACTIONS(3503),
    [anon_sym_GT_GT] = ACTIONS(3511),
    [anon_sym_GT_GT_EQ] = ACTIONS(3501),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_PIPE_EQ] = ACTIONS(3501),
    [anon_sym_PIPE_PIPE] = ACTIONS(3517),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(3519),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3521),
    [anon_sym_as] = ACTIONS(3523),
    [sym_line_comment] = ACTIONS(7),
  },
  [2730] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6847),
    [anon_sym_COMMA] = ACTIONS(6847),
    [sym_line_comment] = ACTIONS(7),
  },
  [2731] = {
    [sym_raw_string_literal] = ACTIONS(6849),
    [sym_float_literal] = ACTIONS(6849),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(6849),
    [anon_sym_SEMI] = ACTIONS(6849),
    [anon_sym_macro_rules_BANG] = ACTIONS(6849),
    [anon_sym_LPAREN] = ACTIONS(6849),
    [anon_sym_LBRACE] = ACTIONS(6849),
    [anon_sym_RBRACE] = ACTIONS(6849),
    [anon_sym_LBRACK] = ACTIONS(6849),
    [anon_sym_STAR] = ACTIONS(6849),
    [anon_sym_u8] = ACTIONS(6851),
    [anon_sym_i8] = ACTIONS(6851),
    [anon_sym_u16] = ACTIONS(6851),
    [anon_sym_i16] = ACTIONS(6851),
    [anon_sym_u32] = ACTIONS(6851),
    [anon_sym_i32] = ACTIONS(6851),
    [anon_sym_u64] = ACTIONS(6851),
    [anon_sym_i64] = ACTIONS(6851),
    [anon_sym_u128] = ACTIONS(6851),
    [anon_sym_i128] = ACTIONS(6851),
    [anon_sym_isize] = ACTIONS(6851),
    [anon_sym_usize] = ACTIONS(6851),
    [anon_sym_f32] = ACTIONS(6851),
    [anon_sym_f64] = ACTIONS(6851),
    [anon_sym_bool] = ACTIONS(6851),
    [anon_sym_str] = ACTIONS(6851),
    [anon_sym_char] = ACTIONS(6851),
    [anon_sym_AMP] = ACTIONS(6849),
    [anon_sym_DASH] = ACTIONS(6849),
    [anon_sym_COLON_COLON] = ACTIONS(6849),
    [anon_sym_BANG] = ACTIONS(6849),
    [anon_sym_POUND] = ACTIONS(6849),
    [anon_sym_LT] = ACTIONS(6849),
    [anon_sym_PIPE] = ACTIONS(6849),
    [anon_sym_SQUOTE] = ACTIONS(6851),
    [anon_sym_DOT_DOT] = ACTIONS(6849),
    [anon_sym_break] = ACTIONS(6851),
    [anon_sym_const] = ACTIONS(6851),
    [anon_sym_continue] = ACTIONS(6851),
    [anon_sym_default] = ACTIONS(6851),
    [anon_sym_enum] = ACTIONS(6851),
    [anon_sym_fn] = ACTIONS(6851),
    [anon_sym_for] = ACTIONS(6851),
    [anon_sym_if] = ACTIONS(6851),
    [anon_sym_impl] = ACTIONS(6851),
    [anon_sym_let] = ACTIONS(6851),
    [anon_sym_loop] = ACTIONS(6851),
    [anon_sym_match] = ACTIONS(6851),
    [anon_sym_mod] = ACTIONS(6851),
    [anon_sym_pub] = ACTIONS(6851),
    [anon_sym_return] = ACTIONS(6851),
    [anon_sym_static] = ACTIONS(6851),
    [anon_sym_struct] = ACTIONS(6851),
    [anon_sym_trait] = ACTIONS(6851),
    [anon_sym_type] = ACTIONS(6851),
    [anon_sym_union] = ACTIONS(6851),
    [anon_sym_unsafe] = ACTIONS(6851),
    [anon_sym_use] = ACTIONS(6851),
    [anon_sym_while] = ACTIONS(6851),
    [anon_sym_extern] = ACTIONS(6851),
    [anon_sym_move] = ACTIONS(6851),
    [sym_integer_literal] = ACTIONS(6849),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6849),
    [sym_char_literal] = ACTIONS(6849),
    [anon_sym_true] = ACTIONS(6851),
    [anon_sym_false] = ACTIONS(6851),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6851),
    [sym_self] = ACTIONS(6851),
    [sym_super] = ACTIONS(6851),
    [sym_crate] = ACTIONS(6851),
    [sym_metavariable] = ACTIONS(6849),
  },
  [2732] = {
    [sym_attribute_item] = STATE(2209),
    [sym_enum_variant] = STATE(2208),
    [sym_visibility_modifier] = STATE(938),
    [aux_sym_enum_variant_list_repeat1] = STATE(2209),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_pub] = ACTIONS(1940),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1942),
  },
  [2733] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3132),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3132),
    [sym_macro_invocation] = STATE(3132),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3132),
    [sym_unary_expression] = STATE(3132),
    [sym_try_expression] = STATE(3132),
    [sym_reference_expression] = STATE(3132),
    [sym_binary_expression] = STATE(3132),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3132),
    [sym_call_expression] = STATE(3132),
    [sym_array_expression] = STATE(3132),
    [sym_parenthesized_expression] = STATE(3132),
    [sym_tuple_expression] = STATE(3132),
    [sym_unit_expression] = STATE(3132),
    [sym_struct_expression] = STATE(3132),
    [sym_if_expression] = STATE(3132),
    [sym_if_let_expression] = STATE(3132),
    [sym_match_expression] = STATE(3132),
    [sym_while_expression] = STATE(3132),
    [sym_while_let_expression] = STATE(3132),
    [sym_loop_expression] = STATE(3132),
    [sym_for_expression] = STATE(3132),
    [sym_closure_expression] = STATE(3132),
    [sym_closure_parameters] = STATE(1138),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3132),
    [sym_continue_expression] = STATE(3132),
    [sym_index_expression] = STATE(3132),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3132),
    [sym_block] = STATE(3132),
    [sym__literal] = STATE(3132),
    [sym_string_literal] = STATE(3132),
    [sym_boolean_literal] = STATE(3132),
    [sym_raw_string_literal] = ACTIONS(6853),
    [sym_float_literal] = ACTIONS(6853),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(2245),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(2247),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(2249),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(2251),
    [sym_integer_literal] = ACTIONS(6853),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6853),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2734] = {
    [sym_attribute_item] = STATE(2209),
    [sym_enum_variant] = STATE(2208),
    [sym_visibility_modifier] = STATE(938),
    [aux_sym_enum_variant_list_repeat1] = STATE(2209),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6855),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_pub] = ACTIONS(1940),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1942),
  },
  [2735] = {
    [sym_function_modifiers] = STATE(1603),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1479),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2219),
    [sym_array_type] = STATE(1479),
    [sym_function_type] = STATE(1479),
    [sym_tuple_type] = STATE(1479),
    [sym_unit_type] = STATE(1479),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1479),
    [sym_reference_type] = STATE(1479),
    [sym_pointer_type] = STATE(1479),
    [sym_empty_type] = STATE(1479),
    [sym_dynamic_type] = STATE(1479),
    [sym_macro_invocation] = STATE(1479),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1606),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3135),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3137),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3139),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3143),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2736] = {
    [sym_function_modifiers] = STATE(1603),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1499),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2219),
    [sym_array_type] = STATE(1499),
    [sym_function_type] = STATE(1499),
    [sym_tuple_type] = STATE(1499),
    [sym_unit_type] = STATE(1499),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1499),
    [sym_reference_type] = STATE(1499),
    [sym_pointer_type] = STATE(1499),
    [sym_empty_type] = STATE(1499),
    [sym_abstract_type] = STATE(1500),
    [sym_dynamic_type] = STATE(1499),
    [sym_macro_invocation] = STATE(1499),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1606),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3135),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3137),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3139),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3143),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2737] = {
    [sym_function_modifiers] = STATE(1603),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1525),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2219),
    [sym_array_type] = STATE(1525),
    [sym_function_type] = STATE(1525),
    [sym_tuple_type] = STATE(1525),
    [sym_unit_type] = STATE(1525),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1525),
    [sym_reference_type] = STATE(1525),
    [sym_pointer_type] = STATE(1525),
    [sym_empty_type] = STATE(1525),
    [sym_abstract_type] = STATE(1526),
    [sym_dynamic_type] = STATE(1525),
    [sym_macro_invocation] = STATE(1525),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1606),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3135),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3137),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3139),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3143),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2738] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_DASH_GT] = ACTIONS(6857),
    [sym_line_comment] = ACTIONS(7),
  },
  [2739] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(6859),
    [sym_line_comment] = ACTIONS(7),
  },
  [2740] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(4764),
    [anon_sym_PLUS] = ACTIONS(4951),
    [sym_line_comment] = ACTIONS(7),
  },
  [2741] = {
    [sym_function_modifiers] = STATE(2233),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(821),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2744),
    [sym_array_type] = STATE(821),
    [sym_function_type] = STATE(821),
    [sym_tuple_type] = STATE(821),
    [sym_unit_type] = STATE(821),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(821),
    [sym_reference_type] = STATE(821),
    [sym_pointer_type] = STATE(821),
    [sym_empty_type] = STATE(821),
    [sym_dynamic_type] = STATE(821),
    [sym_macro_invocation] = STATE(821),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2236),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(4957),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(4959),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4963),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4967),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2742] = {
    [sym_function_modifiers] = STATE(2233),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2744),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2236),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(4957),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(4959),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4963),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4967),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2743] = {
    [sym_function_modifiers] = STATE(2233),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2744),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2236),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(6861),
    [anon_sym_STAR] = ACTIONS(4957),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(4959),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4963),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(6863),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4967),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2744] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(6861),
    [sym_line_comment] = ACTIONS(7),
  },
  [2745] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(1760),
    [anon_sym_PLUS] = ACTIONS(1760),
    [anon_sym_COMMA] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(6865),
    [sym_line_comment] = ACTIONS(7),
  },
  [2746] = {
    [sym_function_modifiers] = STATE(2233),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2417),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2744),
    [sym_array_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_tuple_type] = STATE(2417),
    [sym_unit_type] = STATE(2417),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2417),
    [sym_reference_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_empty_type] = STATE(2417),
    [sym_dynamic_type] = STATE(2417),
    [sym_macro_invocation] = STATE(2417),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2236),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(4957),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(4959),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4963),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4967),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2747] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(1794),
    [anon_sym_PLUS] = ACTIONS(1794),
    [anon_sym_COMMA] = ACTIONS(1794),
    [anon_sym_DASH_GT] = ACTIONS(6867),
    [sym_line_comment] = ACTIONS(7),
  },
  [2748] = {
    [sym_parameters] = STATE(3141),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [2749] = {
    [sym_parameters] = STATE(3142),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [2750] = {
    [sym_parameters] = STATE(3141),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [2751] = {
    [sym_function_modifiers] = STATE(2233),
    [sym_higher_ranked_trait_bound] = STATE(2418),
    [sym_removed_trait_bound] = STATE(2418),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2419),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2419),
    [sym_array_type] = STATE(2419),
    [sym_function_type] = STATE(2419),
    [sym_tuple_type] = STATE(2419),
    [sym_unit_type] = STATE(2419),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2419),
    [sym_reference_type] = STATE(2419),
    [sym_pointer_type] = STATE(2419),
    [sym_empty_type] = STATE(2419),
    [sym_dynamic_type] = STATE(2419),
    [sym_macro_invocation] = STATE(2419),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2236),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(4957),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(4959),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_QMARK] = ACTIONS(4961),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4963),
    [anon_sym_for] = ACTIONS(4965),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4967),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2752] = {
    [aux_sym_trait_bounds_repeat1] = STATE(3143),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(5344),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_COMMA] = ACTIONS(5344),
    [sym_line_comment] = ACTIONS(7),
  },
  [2753] = {
    [sym_function_modifiers] = STATE(2233),
    [sym_higher_ranked_trait_bound] = STATE(2418),
    [sym_removed_trait_bound] = STATE(2418),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2419),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2419),
    [sym_array_type] = STATE(2419),
    [sym_function_type] = STATE(2419),
    [sym_tuple_type] = STATE(2419),
    [sym_unit_type] = STATE(2419),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2419),
    [sym_reference_type] = STATE(2419),
    [sym_pointer_type] = STATE(2419),
    [sym_empty_type] = STATE(2419),
    [sym_dynamic_type] = STATE(2419),
    [sym_macro_invocation] = STATE(2419),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2236),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(4957),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(4959),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_QMARK] = ACTIONS(4961),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4963),
    [anon_sym_for] = ACTIONS(4965),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4967),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2754] = {
    [sym_where_predicate] = STATE(2237),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(945),
    [sym_generic_type] = STATE(946),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_reference_type] = STATE(945),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(947),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(1948),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1950),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [2755] = {
    [sym_raw_string_literal] = ACTIONS(6869),
    [sym_float_literal] = ACTIONS(6869),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(6869),
    [anon_sym_SEMI] = ACTIONS(6869),
    [anon_sym_macro_rules_BANG] = ACTIONS(6869),
    [anon_sym_LPAREN] = ACTIONS(6869),
    [anon_sym_LBRACE] = ACTIONS(6869),
    [anon_sym_RBRACE] = ACTIONS(6869),
    [anon_sym_LBRACK] = ACTIONS(6869),
    [anon_sym_STAR] = ACTIONS(6869),
    [anon_sym_u8] = ACTIONS(6871),
    [anon_sym_i8] = ACTIONS(6871),
    [anon_sym_u16] = ACTIONS(6871),
    [anon_sym_i16] = ACTIONS(6871),
    [anon_sym_u32] = ACTIONS(6871),
    [anon_sym_i32] = ACTIONS(6871),
    [anon_sym_u64] = ACTIONS(6871),
    [anon_sym_i64] = ACTIONS(6871),
    [anon_sym_u128] = ACTIONS(6871),
    [anon_sym_i128] = ACTIONS(6871),
    [anon_sym_isize] = ACTIONS(6871),
    [anon_sym_usize] = ACTIONS(6871),
    [anon_sym_f32] = ACTIONS(6871),
    [anon_sym_f64] = ACTIONS(6871),
    [anon_sym_bool] = ACTIONS(6871),
    [anon_sym_str] = ACTIONS(6871),
    [anon_sym_char] = ACTIONS(6871),
    [anon_sym_AMP] = ACTIONS(6869),
    [anon_sym_DASH] = ACTIONS(6869),
    [anon_sym_COLON_COLON] = ACTIONS(6869),
    [anon_sym_BANG] = ACTIONS(6869),
    [anon_sym_POUND] = ACTIONS(6869),
    [anon_sym_LT] = ACTIONS(6869),
    [anon_sym_PIPE] = ACTIONS(6869),
    [anon_sym_SQUOTE] = ACTIONS(6871),
    [anon_sym_DOT_DOT] = ACTIONS(6869),
    [anon_sym_break] = ACTIONS(6871),
    [anon_sym_const] = ACTIONS(6871),
    [anon_sym_continue] = ACTIONS(6871),
    [anon_sym_default] = ACTIONS(6871),
    [anon_sym_enum] = ACTIONS(6871),
    [anon_sym_fn] = ACTIONS(6871),
    [anon_sym_for] = ACTIONS(6871),
    [anon_sym_if] = ACTIONS(6871),
    [anon_sym_impl] = ACTIONS(6871),
    [anon_sym_let] = ACTIONS(6871),
    [anon_sym_loop] = ACTIONS(6871),
    [anon_sym_match] = ACTIONS(6871),
    [anon_sym_mod] = ACTIONS(6871),
    [anon_sym_pub] = ACTIONS(6871),
    [anon_sym_return] = ACTIONS(6871),
    [anon_sym_static] = ACTIONS(6871),
    [anon_sym_struct] = ACTIONS(6871),
    [anon_sym_trait] = ACTIONS(6871),
    [anon_sym_type] = ACTIONS(6871),
    [anon_sym_union] = ACTIONS(6871),
    [anon_sym_unsafe] = ACTIONS(6871),
    [anon_sym_use] = ACTIONS(6871),
    [anon_sym_while] = ACTIONS(6871),
    [anon_sym_extern] = ACTIONS(6871),
    [anon_sym_move] = ACTIONS(6871),
    [sym_integer_literal] = ACTIONS(6869),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6869),
    [sym_char_literal] = ACTIONS(6869),
    [anon_sym_true] = ACTIONS(6871),
    [anon_sym_false] = ACTIONS(6871),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6871),
    [sym_self] = ACTIONS(6871),
    [sym_super] = ACTIONS(6871),
    [sym_crate] = ACTIONS(6871),
    [sym_metavariable] = ACTIONS(6869),
  },
  [2756] = {
    [sym_block] = STATE(3145),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6873),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [sym_line_comment] = ACTIONS(7),
  },
  [2757] = {
    [sym_raw_string_literal] = ACTIONS(6875),
    [sym_float_literal] = ACTIONS(6875),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(6875),
    [anon_sym_SEMI] = ACTIONS(6875),
    [anon_sym_macro_rules_BANG] = ACTIONS(6875),
    [anon_sym_LPAREN] = ACTIONS(6875),
    [anon_sym_LBRACE] = ACTIONS(6875),
    [anon_sym_RBRACE] = ACTIONS(6875),
    [anon_sym_LBRACK] = ACTIONS(6875),
    [anon_sym_STAR] = ACTIONS(6875),
    [anon_sym_u8] = ACTIONS(6877),
    [anon_sym_i8] = ACTIONS(6877),
    [anon_sym_u16] = ACTIONS(6877),
    [anon_sym_i16] = ACTIONS(6877),
    [anon_sym_u32] = ACTIONS(6877),
    [anon_sym_i32] = ACTIONS(6877),
    [anon_sym_u64] = ACTIONS(6877),
    [anon_sym_i64] = ACTIONS(6877),
    [anon_sym_u128] = ACTIONS(6877),
    [anon_sym_i128] = ACTIONS(6877),
    [anon_sym_isize] = ACTIONS(6877),
    [anon_sym_usize] = ACTIONS(6877),
    [anon_sym_f32] = ACTIONS(6877),
    [anon_sym_f64] = ACTIONS(6877),
    [anon_sym_bool] = ACTIONS(6877),
    [anon_sym_str] = ACTIONS(6877),
    [anon_sym_char] = ACTIONS(6877),
    [anon_sym_AMP] = ACTIONS(6875),
    [anon_sym_DASH] = ACTIONS(6875),
    [anon_sym_COLON_COLON] = ACTIONS(6875),
    [anon_sym_BANG] = ACTIONS(6875),
    [anon_sym_POUND] = ACTIONS(6875),
    [anon_sym_LT] = ACTIONS(6875),
    [anon_sym_PIPE] = ACTIONS(6875),
    [anon_sym_SQUOTE] = ACTIONS(6877),
    [anon_sym_DOT_DOT] = ACTIONS(6875),
    [anon_sym_break] = ACTIONS(6877),
    [anon_sym_const] = ACTIONS(6877),
    [anon_sym_continue] = ACTIONS(6877),
    [anon_sym_default] = ACTIONS(6877),
    [anon_sym_enum] = ACTIONS(6877),
    [anon_sym_fn] = ACTIONS(6877),
    [anon_sym_for] = ACTIONS(6877),
    [anon_sym_if] = ACTIONS(6877),
    [anon_sym_impl] = ACTIONS(6877),
    [anon_sym_let] = ACTIONS(6877),
    [anon_sym_loop] = ACTIONS(6877),
    [anon_sym_match] = ACTIONS(6877),
    [anon_sym_mod] = ACTIONS(6877),
    [anon_sym_pub] = ACTIONS(6877),
    [anon_sym_return] = ACTIONS(6877),
    [anon_sym_static] = ACTIONS(6877),
    [anon_sym_struct] = ACTIONS(6877),
    [anon_sym_trait] = ACTIONS(6877),
    [anon_sym_type] = ACTIONS(6877),
    [anon_sym_union] = ACTIONS(6877),
    [anon_sym_unsafe] = ACTIONS(6877),
    [anon_sym_use] = ACTIONS(6877),
    [anon_sym_while] = ACTIONS(6877),
    [anon_sym_extern] = ACTIONS(6877),
    [anon_sym_move] = ACTIONS(6877),
    [sym_integer_literal] = ACTIONS(6875),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6875),
    [sym_char_literal] = ACTIONS(6875),
    [anon_sym_true] = ACTIONS(6877),
    [anon_sym_false] = ACTIONS(6877),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6877),
    [sym_self] = ACTIONS(6877),
    [sym_super] = ACTIONS(6877),
    [sym_crate] = ACTIONS(6877),
    [sym_metavariable] = ACTIONS(6875),
  },
  [2758] = {
    [sym_raw_string_literal] = ACTIONS(2789),
    [sym_float_literal] = ACTIONS(2789),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(2789),
    [anon_sym_SEMI] = ACTIONS(2789),
    [anon_sym_macro_rules_BANG] = ACTIONS(2789),
    [anon_sym_LPAREN] = ACTIONS(2789),
    [anon_sym_LBRACE] = ACTIONS(2789),
    [anon_sym_RBRACE] = ACTIONS(2789),
    [anon_sym_LBRACK] = ACTIONS(2789),
    [anon_sym_STAR] = ACTIONS(2789),
    [anon_sym_u8] = ACTIONS(2791),
    [anon_sym_i8] = ACTIONS(2791),
    [anon_sym_u16] = ACTIONS(2791),
    [anon_sym_i16] = ACTIONS(2791),
    [anon_sym_u32] = ACTIONS(2791),
    [anon_sym_i32] = ACTIONS(2791),
    [anon_sym_u64] = ACTIONS(2791),
    [anon_sym_i64] = ACTIONS(2791),
    [anon_sym_u128] = ACTIONS(2791),
    [anon_sym_i128] = ACTIONS(2791),
    [anon_sym_isize] = ACTIONS(2791),
    [anon_sym_usize] = ACTIONS(2791),
    [anon_sym_f32] = ACTIONS(2791),
    [anon_sym_f64] = ACTIONS(2791),
    [anon_sym_bool] = ACTIONS(2791),
    [anon_sym_str] = ACTIONS(2791),
    [anon_sym_char] = ACTIONS(2791),
    [anon_sym_AMP] = ACTIONS(2789),
    [anon_sym_DASH] = ACTIONS(2789),
    [anon_sym_COLON_COLON] = ACTIONS(2789),
    [anon_sym_BANG] = ACTIONS(2789),
    [anon_sym_POUND] = ACTIONS(2789),
    [anon_sym_LT] = ACTIONS(2789),
    [anon_sym_PIPE] = ACTIONS(2789),
    [anon_sym_SQUOTE] = ACTIONS(2791),
    [anon_sym_DOT_DOT] = ACTIONS(2789),
    [anon_sym_break] = ACTIONS(2791),
    [anon_sym_const] = ACTIONS(2791),
    [anon_sym_continue] = ACTIONS(2791),
    [anon_sym_default] = ACTIONS(2791),
    [anon_sym_enum] = ACTIONS(2791),
    [anon_sym_fn] = ACTIONS(2791),
    [anon_sym_for] = ACTIONS(2791),
    [anon_sym_if] = ACTIONS(2791),
    [anon_sym_impl] = ACTIONS(2791),
    [anon_sym_let] = ACTIONS(2791),
    [anon_sym_loop] = ACTIONS(2791),
    [anon_sym_match] = ACTIONS(2791),
    [anon_sym_mod] = ACTIONS(2791),
    [anon_sym_pub] = ACTIONS(2791),
    [anon_sym_return] = ACTIONS(2791),
    [anon_sym_static] = ACTIONS(2791),
    [anon_sym_struct] = ACTIONS(2791),
    [anon_sym_trait] = ACTIONS(2791),
    [anon_sym_type] = ACTIONS(2791),
    [anon_sym_union] = ACTIONS(2791),
    [anon_sym_unsafe] = ACTIONS(2791),
    [anon_sym_use] = ACTIONS(2791),
    [anon_sym_while] = ACTIONS(2791),
    [anon_sym_extern] = ACTIONS(2791),
    [anon_sym_move] = ACTIONS(2791),
    [sym_integer_literal] = ACTIONS(2789),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2789),
    [sym_char_literal] = ACTIONS(2789),
    [anon_sym_true] = ACTIONS(2791),
    [anon_sym_false] = ACTIONS(2791),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2791),
    [sym_self] = ACTIONS(2791),
    [sym_super] = ACTIONS(2791),
    [sym_crate] = ACTIONS(2791),
    [sym_metavariable] = ACTIONS(2789),
  },
  [2759] = {
    [sym_function_modifiers] = STATE(1624),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1479),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1626),
    [sym_array_type] = STATE(1479),
    [sym_function_type] = STATE(1479),
    [sym_tuple_type] = STATE(1479),
    [sym_unit_type] = STATE(1479),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1479),
    [sym_reference_type] = STATE(1479),
    [sym_pointer_type] = STATE(1479),
    [sym_empty_type] = STATE(1479),
    [sym_dynamic_type] = STATE(1479),
    [sym_macro_invocation] = STATE(1479),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1628),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3169),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3171),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3173),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3175),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2760] = {
    [sym_function_modifiers] = STATE(1624),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1499),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1626),
    [sym_array_type] = STATE(1499),
    [sym_function_type] = STATE(1499),
    [sym_tuple_type] = STATE(1499),
    [sym_unit_type] = STATE(1499),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1499),
    [sym_reference_type] = STATE(1499),
    [sym_pointer_type] = STATE(1499),
    [sym_empty_type] = STATE(1499),
    [sym_abstract_type] = STATE(1500),
    [sym_dynamic_type] = STATE(1499),
    [sym_macro_invocation] = STATE(1499),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1628),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3169),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3171),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3173),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3175),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2761] = {
    [sym_function_modifiers] = STATE(1624),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1525),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1626),
    [sym_array_type] = STATE(1525),
    [sym_function_type] = STATE(1525),
    [sym_tuple_type] = STATE(1525),
    [sym_unit_type] = STATE(1525),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1525),
    [sym_reference_type] = STATE(1525),
    [sym_pointer_type] = STATE(1525),
    [sym_empty_type] = STATE(1525),
    [sym_abstract_type] = STATE(1526),
    [sym_dynamic_type] = STATE(1525),
    [sym_macro_invocation] = STATE(1525),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1628),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3169),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3171),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3173),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3175),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2762] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2988),
    [anon_sym_LBRACE] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_DASH_GT] = ACTIONS(6879),
    [anon_sym_where] = ACTIONS(2988),
    [sym_line_comment] = ACTIONS(7),
  },
  [2763] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym_LBRACE] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(6881),
    [anon_sym_where] = ACTIONS(2992),
    [sym_line_comment] = ACTIONS(7),
  },
  [2764] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(6883),
    [sym_mutable_specifier] = ACTIONS(6883),
    [sym_line_comment] = ACTIONS(7),
  },
  [2765] = {
    [sym_function_modifiers] = STATE(2770),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(385),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(3150),
    [sym_array_type] = STATE(385),
    [sym_function_type] = STATE(385),
    [sym_tuple_type] = STATE(385),
    [sym_unit_type] = STATE(385),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(385),
    [sym_reference_type] = STATE(385),
    [sym_pointer_type] = STATE(385),
    [sym_empty_type] = STATE(385),
    [sym_dynamic_type] = STATE(385),
    [sym_macro_invocation] = STATE(385),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2773),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(6144),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(6146),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6150),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(6885),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6154),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2766] = {
    [sym_function_modifiers] = STATE(2770),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1759),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(3151),
    [sym_array_type] = STATE(1759),
    [sym_function_type] = STATE(1759),
    [sym_tuple_type] = STATE(1759),
    [sym_unit_type] = STATE(1759),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1759),
    [sym_reference_type] = STATE(1759),
    [sym_pointer_type] = STATE(1759),
    [sym_empty_type] = STATE(1759),
    [sym_dynamic_type] = STATE(1759),
    [sym_macro_invocation] = STATE(1759),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2773),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(6144),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(6146),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6150),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6154),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2767] = {
    [sym_parameters] = STATE(3152),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [2768] = {
    [sym_type_parameters] = STATE(3153),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(3393),
    [sym_line_comment] = ACTIONS(7),
  },
  [2769] = {
    [sym_parameters] = STATE(3154),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_BANG] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [2770] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(3157),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_fn] = ACTIONS(6887),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6889),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [2771] = {
    [aux_sym_trait_bounds_repeat1] = STATE(3159),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3395),
    [anon_sym_LBRACE] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(6891),
    [anon_sym_COMMA] = ACTIONS(3395),
    [sym_line_comment] = ACTIONS(7),
  },
  [2772] = {
    [aux_sym_trait_bounds_repeat1] = STATE(3159),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3395),
    [anon_sym_LBRACE] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(6893),
    [anon_sym_COMMA] = ACTIONS(3395),
    [sym_line_comment] = ACTIONS(7),
  },
  [2773] = {
    [sym_parameters] = STATE(3152),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(783),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(783),
    [anon_sym_PLUS] = ACTIONS(783),
    [anon_sym_COMMA] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [2774] = {
    [sym_where_predicate] = STATE(2237),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1631),
    [sym_generic_type] = STATE(1632),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_reference_type] = STATE(1631),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1633),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6121),
    [anon_sym_LBRACE] = ACTIONS(6121),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(1948),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3177),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [2775] = {
    [aux_sym_where_clause_repeat1] = STATE(2775),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6119),
    [anon_sym_LBRACE] = ACTIONS(6119),
    [anon_sym_COMMA] = ACTIONS(6895),
    [sym_line_comment] = ACTIONS(7),
  },
  [2776] = {
    [sym_else_tail] = STATE(3089),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6158),
    [anon_sym_LBRACE] = ACTIONS(6158),
    [anon_sym_LBRACK] = ACTIONS(6158),
    [anon_sym_PLUS] = ACTIONS(6160),
    [anon_sym_STAR] = ACTIONS(6160),
    [anon_sym_AMP] = ACTIONS(6160),
    [anon_sym_DASH] = ACTIONS(6160),
    [anon_sym_DOT] = ACTIONS(6160),
    [anon_sym_DASH_EQ] = ACTIONS(6158),
    [anon_sym_BANG_EQ] = ACTIONS(6158),
    [anon_sym_STAR_EQ] = ACTIONS(6158),
    [anon_sym_SLASH] = ACTIONS(6160),
    [anon_sym_SLASH_EQ] = ACTIONS(6158),
    [anon_sym_AMP_AMP] = ACTIONS(6158),
    [anon_sym_AMP_EQ] = ACTIONS(6158),
    [anon_sym_PERCENT] = ACTIONS(6160),
    [anon_sym_PERCENT_EQ] = ACTIONS(6158),
    [anon_sym_CARET] = ACTIONS(6160),
    [anon_sym_CARET_EQ] = ACTIONS(6158),
    [anon_sym_PLUS_EQ] = ACTIONS(6158),
    [anon_sym_LT] = ACTIONS(6160),
    [anon_sym_LT_LT] = ACTIONS(6160),
    [anon_sym_LT_LT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_EQ] = ACTIONS(6160),
    [anon_sym_EQ_EQ] = ACTIONS(6158),
    [anon_sym_GT] = ACTIONS(6160),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_GT_GT] = ACTIONS(6160),
    [anon_sym_GT_GT_EQ] = ACTIONS(6158),
    [anon_sym_PIPE] = ACTIONS(6160),
    [anon_sym_PIPE_EQ] = ACTIONS(6158),
    [anon_sym_PIPE_PIPE] = ACTIONS(6158),
    [anon_sym_QMARK] = ACTIONS(6158),
    [anon_sym_DOT_DOT] = ACTIONS(6160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6158),
    [anon_sym_as] = ACTIONS(6158),
    [anon_sym_else] = ACTIONS(3185),
    [sym_line_comment] = ACTIONS(7),
  },
  [2777] = {
    [sym_raw_string_literal] = ACTIONS(6898),
    [sym_float_literal] = ACTIONS(6898),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(6898),
    [anon_sym_SEMI] = ACTIONS(6898),
    [anon_sym_macro_rules_BANG] = ACTIONS(6898),
    [anon_sym_LPAREN] = ACTIONS(6898),
    [anon_sym_LBRACE] = ACTIONS(6898),
    [anon_sym_RBRACE] = ACTIONS(6898),
    [anon_sym_LBRACK] = ACTIONS(6898),
    [anon_sym_PLUS] = ACTIONS(6900),
    [anon_sym_STAR] = ACTIONS(6900),
    [anon_sym_u8] = ACTIONS(6900),
    [anon_sym_i8] = ACTIONS(6900),
    [anon_sym_u16] = ACTIONS(6900),
    [anon_sym_i16] = ACTIONS(6900),
    [anon_sym_u32] = ACTIONS(6900),
    [anon_sym_i32] = ACTIONS(6900),
    [anon_sym_u64] = ACTIONS(6900),
    [anon_sym_i64] = ACTIONS(6900),
    [anon_sym_u128] = ACTIONS(6900),
    [anon_sym_i128] = ACTIONS(6900),
    [anon_sym_isize] = ACTIONS(6900),
    [anon_sym_usize] = ACTIONS(6900),
    [anon_sym_f32] = ACTIONS(6900),
    [anon_sym_f64] = ACTIONS(6900),
    [anon_sym_bool] = ACTIONS(6900),
    [anon_sym_str] = ACTIONS(6900),
    [anon_sym_char] = ACTIONS(6900),
    [anon_sym_AMP] = ACTIONS(6900),
    [anon_sym_DASH] = ACTIONS(6900),
    [anon_sym_DOT] = ACTIONS(6900),
    [anon_sym_DASH_EQ] = ACTIONS(6898),
    [anon_sym_COLON_COLON] = ACTIONS(6898),
    [anon_sym_BANG] = ACTIONS(6900),
    [anon_sym_BANG_EQ] = ACTIONS(6898),
    [anon_sym_STAR_EQ] = ACTIONS(6898),
    [anon_sym_SLASH] = ACTIONS(6900),
    [anon_sym_SLASH_EQ] = ACTIONS(6898),
    [anon_sym_AMP_AMP] = ACTIONS(6898),
    [anon_sym_AMP_EQ] = ACTIONS(6898),
    [anon_sym_POUND] = ACTIONS(6898),
    [anon_sym_PERCENT] = ACTIONS(6900),
    [anon_sym_PERCENT_EQ] = ACTIONS(6898),
    [anon_sym_CARET] = ACTIONS(6900),
    [anon_sym_CARET_EQ] = ACTIONS(6898),
    [anon_sym_PLUS_EQ] = ACTIONS(6898),
    [anon_sym_LT] = ACTIONS(6900),
    [anon_sym_LT_LT] = ACTIONS(6900),
    [anon_sym_LT_LT_EQ] = ACTIONS(6898),
    [anon_sym_LT_EQ] = ACTIONS(6898),
    [anon_sym_EQ] = ACTIONS(6900),
    [anon_sym_EQ_EQ] = ACTIONS(6898),
    [anon_sym_GT] = ACTIONS(6900),
    [anon_sym_GT_EQ] = ACTIONS(6898),
    [anon_sym_GT_GT] = ACTIONS(6900),
    [anon_sym_GT_GT_EQ] = ACTIONS(6898),
    [anon_sym_PIPE] = ACTIONS(6900),
    [anon_sym_PIPE_EQ] = ACTIONS(6898),
    [anon_sym_PIPE_PIPE] = ACTIONS(6898),
    [anon_sym_QMARK] = ACTIONS(6898),
    [anon_sym_SQUOTE] = ACTIONS(6900),
    [anon_sym_DOT_DOT] = ACTIONS(6900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6898),
    [anon_sym_as] = ACTIONS(6900),
    [anon_sym_break] = ACTIONS(6900),
    [anon_sym_const] = ACTIONS(6900),
    [anon_sym_continue] = ACTIONS(6900),
    [anon_sym_default] = ACTIONS(6900),
    [anon_sym_enum] = ACTIONS(6900),
    [anon_sym_fn] = ACTIONS(6900),
    [anon_sym_for] = ACTIONS(6900),
    [anon_sym_if] = ACTIONS(6900),
    [anon_sym_impl] = ACTIONS(6900),
    [anon_sym_let] = ACTIONS(6900),
    [anon_sym_loop] = ACTIONS(6900),
    [anon_sym_match] = ACTIONS(6900),
    [anon_sym_mod] = ACTIONS(6900),
    [anon_sym_pub] = ACTIONS(6900),
    [anon_sym_return] = ACTIONS(6900),
    [anon_sym_static] = ACTIONS(6900),
    [anon_sym_struct] = ACTIONS(6900),
    [anon_sym_trait] = ACTIONS(6900),
    [anon_sym_type] = ACTIONS(6900),
    [anon_sym_union] = ACTIONS(6900),
    [anon_sym_unsafe] = ACTIONS(6900),
    [anon_sym_use] = ACTIONS(6900),
    [anon_sym_while] = ACTIONS(6900),
    [anon_sym_extern] = ACTIONS(6900),
    [anon_sym_move] = ACTIONS(6900),
    [sym_integer_literal] = ACTIONS(6898),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6898),
    [sym_char_literal] = ACTIONS(6898),
    [anon_sym_true] = ACTIONS(6900),
    [anon_sym_false] = ACTIONS(6900),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6900),
    [sym_self] = ACTIONS(6900),
    [sym_super] = ACTIONS(6900),
    [sym_crate] = ACTIONS(6900),
    [sym_metavariable] = ACTIONS(6898),
  },
  [2778] = {
    [sym_function_modifiers] = STATE(982),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3080),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(983),
    [sym_array_type] = STATE(3080),
    [sym_function_type] = STATE(3080),
    [sym_tuple_type] = STATE(3080),
    [sym_unit_type] = STATE(3080),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(3080),
    [sym_reference_type] = STATE(3080),
    [sym_pointer_type] = STATE(3080),
    [sym_empty_type] = STATE(3080),
    [sym_abstract_type] = STATE(3081),
    [sym_dynamic_type] = STATE(3080),
    [sym_macro_invocation] = STATE(3080),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(984),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(2004),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(2006),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2008),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2010),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2779] = {
    [sym_function_modifiers] = STATE(982),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3082),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(983),
    [sym_array_type] = STATE(3082),
    [sym_function_type] = STATE(3082),
    [sym_tuple_type] = STATE(3082),
    [sym_unit_type] = STATE(3082),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(3082),
    [sym_reference_type] = STATE(3082),
    [sym_pointer_type] = STATE(3082),
    [sym_empty_type] = STATE(3082),
    [sym_abstract_type] = STATE(3083),
    [sym_dynamic_type] = STATE(3082),
    [sym_macro_invocation] = STATE(3082),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(984),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(2004),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(2006),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2008),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2010),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2780] = {
    [sym_function_modifiers] = STATE(1655),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(862),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1658),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3205),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3207),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3211),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3215),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2781] = {
    [sym_function_modifiers] = STATE(1655),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2270),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1658),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3205),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3207),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3211),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3215),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2782] = {
    [sym_function_modifiers] = STATE(1655),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1479),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2270),
    [sym_array_type] = STATE(1479),
    [sym_function_type] = STATE(1479),
    [sym_tuple_type] = STATE(1479),
    [sym_unit_type] = STATE(1479),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1479),
    [sym_reference_type] = STATE(1479),
    [sym_pointer_type] = STATE(1479),
    [sym_empty_type] = STATE(1479),
    [sym_dynamic_type] = STATE(1479),
    [sym_macro_invocation] = STATE(1479),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1658),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3205),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3207),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3211),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3215),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2783] = {
    [sym_function_modifiers] = STATE(1655),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1499),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2270),
    [sym_array_type] = STATE(1499),
    [sym_function_type] = STATE(1499),
    [sym_tuple_type] = STATE(1499),
    [sym_unit_type] = STATE(1499),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1499),
    [sym_reference_type] = STATE(1499),
    [sym_pointer_type] = STATE(1499),
    [sym_empty_type] = STATE(1499),
    [sym_abstract_type] = STATE(1500),
    [sym_dynamic_type] = STATE(1499),
    [sym_macro_invocation] = STATE(1499),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1658),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3205),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3207),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3211),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3215),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2784] = {
    [sym_function_modifiers] = STATE(1655),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1525),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2270),
    [sym_array_type] = STATE(1525),
    [sym_function_type] = STATE(1525),
    [sym_tuple_type] = STATE(1525),
    [sym_unit_type] = STATE(1525),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1525),
    [sym_reference_type] = STATE(1525),
    [sym_pointer_type] = STATE(1525),
    [sym_empty_type] = STATE(1525),
    [sym_abstract_type] = STATE(1526),
    [sym_dynamic_type] = STATE(1525),
    [sym_macro_invocation] = STATE(1525),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1658),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3205),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3207),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3211),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3215),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2785] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_COMMA] = ACTIONS(2988),
    [anon_sym_DASH_GT] = ACTIONS(6902),
    [anon_sym_EQ] = ACTIONS(2988),
    [anon_sym_GT] = ACTIONS(2988),
    [sym_line_comment] = ACTIONS(7),
  },
  [2786] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_COMMA] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(6904),
    [anon_sym_EQ] = ACTIONS(2992),
    [anon_sym_GT] = ACTIONS(2992),
    [sym_line_comment] = ACTIONS(7),
  },
  [2787] = {
    [aux_sym_trait_bounds_repeat1] = STATE(2787),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(6906),
    [anon_sym_COMMA] = ACTIONS(6476),
    [anon_sym_EQ] = ACTIONS(6476),
    [anon_sym_GT] = ACTIONS(6476),
    [sym_line_comment] = ACTIONS(7),
  },
  [2788] = {
    [sym_function_modifiers] = STATE(1003),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2156),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1005),
    [sym_array_type] = STATE(2156),
    [sym_function_type] = STATE(2156),
    [sym_tuple_type] = STATE(2156),
    [sym_unit_type] = STATE(2156),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2156),
    [sym_reference_type] = STATE(2156),
    [sym_pointer_type] = STATE(2156),
    [sym_empty_type] = STATE(2156),
    [sym_abstract_type] = STATE(2157),
    [sym_dynamic_type] = STATE(2156),
    [sym_macro_invocation] = STATE(2156),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1006),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2034),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2036),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2038),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2040),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2789] = {
    [sym_function_modifiers] = STATE(1003),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2158),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1005),
    [sym_array_type] = STATE(2158),
    [sym_function_type] = STATE(2158),
    [sym_tuple_type] = STATE(2158),
    [sym_unit_type] = STATE(2158),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2158),
    [sym_reference_type] = STATE(2158),
    [sym_pointer_type] = STATE(2158),
    [sym_empty_type] = STATE(2158),
    [sym_abstract_type] = STATE(2159),
    [sym_dynamic_type] = STATE(2158),
    [sym_macro_invocation] = STATE(2158),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1006),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2034),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2036),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2038),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2040),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2790] = {
    [sym_raw_string_literal] = ACTIONS(6909),
    [sym_float_literal] = ACTIONS(6909),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(6909),
    [anon_sym_SEMI] = ACTIONS(6909),
    [anon_sym_macro_rules_BANG] = ACTIONS(6909),
    [anon_sym_LPAREN] = ACTIONS(6909),
    [anon_sym_LBRACE] = ACTIONS(6909),
    [anon_sym_RBRACE] = ACTIONS(6909),
    [anon_sym_LBRACK] = ACTIONS(6909),
    [anon_sym_STAR] = ACTIONS(6909),
    [anon_sym_u8] = ACTIONS(6911),
    [anon_sym_i8] = ACTIONS(6911),
    [anon_sym_u16] = ACTIONS(6911),
    [anon_sym_i16] = ACTIONS(6911),
    [anon_sym_u32] = ACTIONS(6911),
    [anon_sym_i32] = ACTIONS(6911),
    [anon_sym_u64] = ACTIONS(6911),
    [anon_sym_i64] = ACTIONS(6911),
    [anon_sym_u128] = ACTIONS(6911),
    [anon_sym_i128] = ACTIONS(6911),
    [anon_sym_isize] = ACTIONS(6911),
    [anon_sym_usize] = ACTIONS(6911),
    [anon_sym_f32] = ACTIONS(6911),
    [anon_sym_f64] = ACTIONS(6911),
    [anon_sym_bool] = ACTIONS(6911),
    [anon_sym_str] = ACTIONS(6911),
    [anon_sym_char] = ACTIONS(6911),
    [anon_sym_AMP] = ACTIONS(6909),
    [anon_sym_DASH] = ACTIONS(6909),
    [anon_sym_COLON_COLON] = ACTIONS(6909),
    [anon_sym_BANG] = ACTIONS(6909),
    [anon_sym_POUND] = ACTIONS(6909),
    [anon_sym_LT] = ACTIONS(6909),
    [anon_sym_PIPE] = ACTIONS(6909),
    [anon_sym_SQUOTE] = ACTIONS(6911),
    [anon_sym_DOT_DOT] = ACTIONS(6909),
    [anon_sym_break] = ACTIONS(6911),
    [anon_sym_const] = ACTIONS(6911),
    [anon_sym_continue] = ACTIONS(6911),
    [anon_sym_default] = ACTIONS(6911),
    [anon_sym_enum] = ACTIONS(6911),
    [anon_sym_fn] = ACTIONS(6911),
    [anon_sym_for] = ACTIONS(6911),
    [anon_sym_if] = ACTIONS(6911),
    [anon_sym_impl] = ACTIONS(6911),
    [anon_sym_let] = ACTIONS(6911),
    [anon_sym_loop] = ACTIONS(6911),
    [anon_sym_match] = ACTIONS(6911),
    [anon_sym_mod] = ACTIONS(6911),
    [anon_sym_pub] = ACTIONS(6911),
    [anon_sym_return] = ACTIONS(6911),
    [anon_sym_static] = ACTIONS(6911),
    [anon_sym_struct] = ACTIONS(6911),
    [anon_sym_trait] = ACTIONS(6911),
    [anon_sym_type] = ACTIONS(6911),
    [anon_sym_union] = ACTIONS(6911),
    [anon_sym_unsafe] = ACTIONS(6911),
    [anon_sym_use] = ACTIONS(6911),
    [anon_sym_while] = ACTIONS(6911),
    [anon_sym_extern] = ACTIONS(6911),
    [anon_sym_move] = ACTIONS(6911),
    [sym_integer_literal] = ACTIONS(6909),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6909),
    [sym_char_literal] = ACTIONS(6909),
    [anon_sym_true] = ACTIONS(6911),
    [anon_sym_false] = ACTIONS(6911),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6911),
    [sym_self] = ACTIONS(6911),
    [sym_super] = ACTIONS(6911),
    [sym_crate] = ACTIONS(6911),
    [sym_metavariable] = ACTIONS(6909),
  },
  [2791] = {
    [sym_raw_string_literal] = ACTIONS(6913),
    [sym_float_literal] = ACTIONS(6913),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(6913),
    [anon_sym_SEMI] = ACTIONS(6913),
    [anon_sym_macro_rules_BANG] = ACTIONS(6913),
    [anon_sym_LPAREN] = ACTIONS(6913),
    [anon_sym_LBRACE] = ACTIONS(6913),
    [anon_sym_RBRACE] = ACTIONS(6913),
    [anon_sym_LBRACK] = ACTIONS(6913),
    [anon_sym_STAR] = ACTIONS(6913),
    [anon_sym_u8] = ACTIONS(6915),
    [anon_sym_i8] = ACTIONS(6915),
    [anon_sym_u16] = ACTIONS(6915),
    [anon_sym_i16] = ACTIONS(6915),
    [anon_sym_u32] = ACTIONS(6915),
    [anon_sym_i32] = ACTIONS(6915),
    [anon_sym_u64] = ACTIONS(6915),
    [anon_sym_i64] = ACTIONS(6915),
    [anon_sym_u128] = ACTIONS(6915),
    [anon_sym_i128] = ACTIONS(6915),
    [anon_sym_isize] = ACTIONS(6915),
    [anon_sym_usize] = ACTIONS(6915),
    [anon_sym_f32] = ACTIONS(6915),
    [anon_sym_f64] = ACTIONS(6915),
    [anon_sym_bool] = ACTIONS(6915),
    [anon_sym_str] = ACTIONS(6915),
    [anon_sym_char] = ACTIONS(6915),
    [anon_sym_AMP] = ACTIONS(6913),
    [anon_sym_DASH] = ACTIONS(6913),
    [anon_sym_COLON_COLON] = ACTIONS(6913),
    [anon_sym_BANG] = ACTIONS(6913),
    [anon_sym_POUND] = ACTIONS(6913),
    [anon_sym_LT] = ACTIONS(6913),
    [anon_sym_PIPE] = ACTIONS(6913),
    [anon_sym_SQUOTE] = ACTIONS(6915),
    [anon_sym_DOT_DOT] = ACTIONS(6913),
    [anon_sym_break] = ACTIONS(6915),
    [anon_sym_const] = ACTIONS(6915),
    [anon_sym_continue] = ACTIONS(6915),
    [anon_sym_default] = ACTIONS(6915),
    [anon_sym_enum] = ACTIONS(6915),
    [anon_sym_fn] = ACTIONS(6915),
    [anon_sym_for] = ACTIONS(6915),
    [anon_sym_if] = ACTIONS(6915),
    [anon_sym_impl] = ACTIONS(6915),
    [anon_sym_let] = ACTIONS(6915),
    [anon_sym_loop] = ACTIONS(6915),
    [anon_sym_match] = ACTIONS(6915),
    [anon_sym_mod] = ACTIONS(6915),
    [anon_sym_pub] = ACTIONS(6915),
    [anon_sym_return] = ACTIONS(6915),
    [anon_sym_static] = ACTIONS(6915),
    [anon_sym_struct] = ACTIONS(6915),
    [anon_sym_trait] = ACTIONS(6915),
    [anon_sym_type] = ACTIONS(6915),
    [anon_sym_union] = ACTIONS(6915),
    [anon_sym_unsafe] = ACTIONS(6915),
    [anon_sym_use] = ACTIONS(6915),
    [anon_sym_while] = ACTIONS(6915),
    [anon_sym_extern] = ACTIONS(6915),
    [anon_sym_move] = ACTIONS(6915),
    [sym_integer_literal] = ACTIONS(6913),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6913),
    [sym_char_literal] = ACTIONS(6913),
    [anon_sym_true] = ACTIONS(6915),
    [anon_sym_false] = ACTIONS(6915),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6915),
    [sym_self] = ACTIONS(6915),
    [sym_super] = ACTIONS(6915),
    [sym_crate] = ACTIONS(6915),
    [sym_metavariable] = ACTIONS(6913),
  },
  [2792] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6917),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(467),
    [anon_sym_BANG_EQ] = ACTIONS(469),
    [anon_sym_STAR_EQ] = ACTIONS(467),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(467),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_AMP_EQ] = ACTIONS(467),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(467),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_CARET_EQ] = ACTIONS(467),
    [anon_sym_PLUS_EQ] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT_LT_EQ] = ACTIONS(467),
    [anon_sym_LT_EQ] = ACTIONS(469),
    [anon_sym_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_EQ] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_PIPE_EQ] = ACTIONS(467),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(489),
    [anon_sym_as] = ACTIONS(491),
    [sym_line_comment] = ACTIONS(7),
  },
  [2793] = {
    [sym_function_modifiers] = STATE(1025),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2156),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1027),
    [sym_array_type] = STATE(2156),
    [sym_function_type] = STATE(2156),
    [sym_tuple_type] = STATE(2156),
    [sym_unit_type] = STATE(2156),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2156),
    [sym_reference_type] = STATE(2156),
    [sym_pointer_type] = STATE(2156),
    [sym_empty_type] = STATE(2156),
    [sym_abstract_type] = STATE(2157),
    [sym_dynamic_type] = STATE(2156),
    [sym_macro_invocation] = STATE(2156),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1028),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2060),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2062),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2064),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2066),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2794] = {
    [sym_function_modifiers] = STATE(1025),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2158),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1027),
    [sym_array_type] = STATE(2158),
    [sym_function_type] = STATE(2158),
    [sym_tuple_type] = STATE(2158),
    [sym_unit_type] = STATE(2158),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2158),
    [sym_reference_type] = STATE(2158),
    [sym_pointer_type] = STATE(2158),
    [sym_empty_type] = STATE(2158),
    [sym_abstract_type] = STATE(2159),
    [sym_dynamic_type] = STATE(2158),
    [sym_macro_invocation] = STATE(2158),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1028),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2060),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2062),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2064),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2066),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2795] = {
    [sym_raw_string_literal] = ACTIONS(6919),
    [sym_float_literal] = ACTIONS(6919),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(6919),
    [anon_sym_SEMI] = ACTIONS(6919),
    [anon_sym_macro_rules_BANG] = ACTIONS(6919),
    [anon_sym_LPAREN] = ACTIONS(6919),
    [anon_sym_LBRACE] = ACTIONS(6919),
    [anon_sym_RBRACE] = ACTIONS(6919),
    [anon_sym_LBRACK] = ACTIONS(6919),
    [anon_sym_STAR] = ACTIONS(6919),
    [anon_sym_u8] = ACTIONS(6921),
    [anon_sym_i8] = ACTIONS(6921),
    [anon_sym_u16] = ACTIONS(6921),
    [anon_sym_i16] = ACTIONS(6921),
    [anon_sym_u32] = ACTIONS(6921),
    [anon_sym_i32] = ACTIONS(6921),
    [anon_sym_u64] = ACTIONS(6921),
    [anon_sym_i64] = ACTIONS(6921),
    [anon_sym_u128] = ACTIONS(6921),
    [anon_sym_i128] = ACTIONS(6921),
    [anon_sym_isize] = ACTIONS(6921),
    [anon_sym_usize] = ACTIONS(6921),
    [anon_sym_f32] = ACTIONS(6921),
    [anon_sym_f64] = ACTIONS(6921),
    [anon_sym_bool] = ACTIONS(6921),
    [anon_sym_str] = ACTIONS(6921),
    [anon_sym_char] = ACTIONS(6921),
    [anon_sym_AMP] = ACTIONS(6919),
    [anon_sym_DASH] = ACTIONS(6919),
    [anon_sym_COLON_COLON] = ACTIONS(6919),
    [anon_sym_BANG] = ACTIONS(6919),
    [anon_sym_POUND] = ACTIONS(6919),
    [anon_sym_LT] = ACTIONS(6919),
    [anon_sym_PIPE] = ACTIONS(6919),
    [anon_sym_SQUOTE] = ACTIONS(6921),
    [anon_sym_DOT_DOT] = ACTIONS(6919),
    [anon_sym_break] = ACTIONS(6921),
    [anon_sym_const] = ACTIONS(6921),
    [anon_sym_continue] = ACTIONS(6921),
    [anon_sym_default] = ACTIONS(6921),
    [anon_sym_enum] = ACTIONS(6921),
    [anon_sym_fn] = ACTIONS(6921),
    [anon_sym_for] = ACTIONS(6921),
    [anon_sym_if] = ACTIONS(6921),
    [anon_sym_impl] = ACTIONS(6921),
    [anon_sym_let] = ACTIONS(6921),
    [anon_sym_loop] = ACTIONS(6921),
    [anon_sym_match] = ACTIONS(6921),
    [anon_sym_mod] = ACTIONS(6921),
    [anon_sym_pub] = ACTIONS(6921),
    [anon_sym_return] = ACTIONS(6921),
    [anon_sym_static] = ACTIONS(6921),
    [anon_sym_struct] = ACTIONS(6921),
    [anon_sym_trait] = ACTIONS(6921),
    [anon_sym_type] = ACTIONS(6921),
    [anon_sym_union] = ACTIONS(6921),
    [anon_sym_unsafe] = ACTIONS(6921),
    [anon_sym_use] = ACTIONS(6921),
    [anon_sym_while] = ACTIONS(6921),
    [anon_sym_extern] = ACTIONS(6921),
    [anon_sym_move] = ACTIONS(6921),
    [sym_integer_literal] = ACTIONS(6919),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6919),
    [sym_char_literal] = ACTIONS(6919),
    [anon_sym_true] = ACTIONS(6921),
    [anon_sym_false] = ACTIONS(6921),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6921),
    [sym_self] = ACTIONS(6921),
    [sym_super] = ACTIONS(6921),
    [sym_crate] = ACTIONS(6921),
    [sym_metavariable] = ACTIONS(6919),
  },
  [2796] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(4844),
    [anon_sym_PIPE] = ACTIONS(4844),
    [anon_sym_if] = ACTIONS(4844),
    [sym_line_comment] = ACTIONS(7),
  },
  [2797] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(1540),
    [sym_tuple_pattern] = STATE(1540),
    [sym_tuple_struct_pattern] = STATE(1540),
    [sym_struct_pattern] = STATE(1540),
    [sym_remaining_field_pattern] = STATE(1540),
    [sym_mut_pattern] = STATE(1540),
    [sym_ref_pattern] = STATE(1540),
    [sym_captured_pattern] = STATE(1540),
    [sym_reference_pattern] = STATE(1540),
    [sym__literal] = STATE(1540),
    [sym_string_literal] = STATE(1540),
    [sym_boolean_literal] = STATE(1540),
    [sym_raw_string_literal] = ACTIONS(3018),
    [sym_float_literal] = ACTIONS(3018),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_RPAREN] = ACTIONS(6923),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(817),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(819),
    [anon_sym_ref] = ACTIONS(821),
    [sym_integer_literal] = ACTIONS(3018),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(3018),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(823),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [2798] = {
    [sym_raw_string_literal] = ACTIONS(2872),
    [sym_float_literal] = ACTIONS(2872),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2872),
    [anon_sym_u8] = ACTIONS(2874),
    [anon_sym_i8] = ACTIONS(2874),
    [anon_sym_u16] = ACTIONS(2874),
    [anon_sym_i16] = ACTIONS(2874),
    [anon_sym_u32] = ACTIONS(2874),
    [anon_sym_i32] = ACTIONS(2874),
    [anon_sym_u64] = ACTIONS(2874),
    [anon_sym_i64] = ACTIONS(2874),
    [anon_sym_u128] = ACTIONS(2874),
    [anon_sym_i128] = ACTIONS(2874),
    [anon_sym_isize] = ACTIONS(2874),
    [anon_sym_usize] = ACTIONS(2874),
    [anon_sym_f32] = ACTIONS(2874),
    [anon_sym_f64] = ACTIONS(2874),
    [anon_sym_bool] = ACTIONS(2874),
    [anon_sym_str] = ACTIONS(2874),
    [anon_sym_char] = ACTIONS(2874),
    [anon_sym__] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2872),
    [anon_sym_COLON_COLON] = ACTIONS(2872),
    [anon_sym_POUND] = ACTIONS(2872),
    [anon_sym_LT] = ACTIONS(2872),
    [anon_sym_DOT_DOT] = ACTIONS(2872),
    [sym_mutable_specifier] = ACTIONS(2874),
    [anon_sym_ref] = ACTIONS(2874),
    [sym_integer_literal] = ACTIONS(2872),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2872),
    [sym_char_literal] = ACTIONS(2872),
    [anon_sym_true] = ACTIONS(2874),
    [anon_sym_false] = ACTIONS(2874),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2874),
    [sym_self] = ACTIONS(2874),
    [sym_super] = ACTIONS(2874),
    [sym_crate] = ACTIONS(2874),
    [sym_metavariable] = ACTIONS(2872),
  },
  [2799] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(4875),
    [anon_sym_PIPE] = ACTIONS(4875),
    [anon_sym_if] = ACTIONS(4875),
    [sym_line_comment] = ACTIONS(7),
  },
  [2800] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(1540),
    [sym_tuple_pattern] = STATE(1540),
    [sym_tuple_struct_pattern] = STATE(1540),
    [sym_struct_pattern] = STATE(1540),
    [sym_remaining_field_pattern] = STATE(1540),
    [sym_mut_pattern] = STATE(1540),
    [sym_ref_pattern] = STATE(1540),
    [sym_captured_pattern] = STATE(1540),
    [sym_reference_pattern] = STATE(1540),
    [sym__literal] = STATE(1540),
    [sym_string_literal] = STATE(1540),
    [sym_boolean_literal] = STATE(1540),
    [sym_raw_string_literal] = ACTIONS(3018),
    [sym_float_literal] = ACTIONS(3018),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_RPAREN] = ACTIONS(6925),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(817),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(819),
    [anon_sym_ref] = ACTIONS(821),
    [sym_integer_literal] = ACTIONS(3018),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(3018),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(823),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [2801] = {
    [aux_sym_tuple_pattern_repeat1] = STATE(1542),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(6925),
    [anon_sym_COMMA] = ACTIONS(6927),
    [sym_line_comment] = ACTIONS(7),
  },
  [2802] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(4881),
    [anon_sym_PIPE] = ACTIONS(4881),
    [anon_sym_if] = ACTIONS(4881),
    [sym_line_comment] = ACTIONS(7),
  },
  [2803] = {
    [sym_field_pattern] = STATE(2188),
    [sym_remaining_field_pattern] = STATE(2188),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6929),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(1902),
    [anon_sym_ref] = ACTIONS(1904),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1906),
  },
  [2804] = {
    [aux_sym_struct_pattern_repeat1] = STATE(2190),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6929),
    [anon_sym_COMMA] = ACTIONS(6931),
    [sym_line_comment] = ACTIONS(7),
  },
  [2805] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(4905),
    [anon_sym_PIPE] = ACTIONS(4905),
    [anon_sym_if] = ACTIONS(4905),
    [sym_line_comment] = ACTIONS(7),
  },
  [2806] = {
    [sym_field_pattern] = STATE(2188),
    [sym_remaining_field_pattern] = STATE(2188),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6933),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(1902),
    [anon_sym_ref] = ACTIONS(1904),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1906),
  },
  [2807] = {
    [aux_sym_struct_pattern_repeat1] = STATE(2190),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(6933),
    [anon_sym_COMMA] = ACTIONS(6935),
    [sym_line_comment] = ACTIONS(7),
  },
  [2808] = {
    [sym_raw_string_literal] = ACTIONS(597),
    [sym_float_literal] = ACTIONS(597),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_RBRACE] = ACTIONS(597),
    [anon_sym_LBRACK] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(599),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_COMMA] = ACTIONS(597),
    [anon_sym_u8] = ACTIONS(599),
    [anon_sym_i8] = ACTIONS(599),
    [anon_sym_u16] = ACTIONS(599),
    [anon_sym_i16] = ACTIONS(599),
    [anon_sym_u32] = ACTIONS(599),
    [anon_sym_i32] = ACTIONS(599),
    [anon_sym_u64] = ACTIONS(599),
    [anon_sym_i64] = ACTIONS(599),
    [anon_sym_u128] = ACTIONS(599),
    [anon_sym_i128] = ACTIONS(599),
    [anon_sym_isize] = ACTIONS(599),
    [anon_sym_usize] = ACTIONS(599),
    [anon_sym_f32] = ACTIONS(599),
    [anon_sym_f64] = ACTIONS(599),
    [anon_sym_bool] = ACTIONS(599),
    [anon_sym_str] = ACTIONS(599),
    [anon_sym_char] = ACTIONS(599),
    [anon_sym__] = ACTIONS(599),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_DASH] = ACTIONS(599),
    [anon_sym_DOT] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(597),
    [anon_sym_COLON_COLON] = ACTIONS(597),
    [anon_sym_BANG_EQ] = ACTIONS(597),
    [anon_sym_STAR_EQ] = ACTIONS(597),
    [anon_sym_SLASH] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(597),
    [anon_sym_AMP_AMP] = ACTIONS(597),
    [anon_sym_AMP_EQ] = ACTIONS(597),
    [anon_sym_POUND] = ACTIONS(597),
    [anon_sym_PERCENT] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(597),
    [anon_sym_CARET] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(597),
    [anon_sym_PLUS_EQ] = ACTIONS(597),
    [anon_sym_LT] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(597),
    [anon_sym_LT_EQ] = ACTIONS(597),
    [anon_sym_EQ] = ACTIONS(599),
    [anon_sym_EQ_EQ] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(599),
    [anon_sym_GT_EQ] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(597),
    [anon_sym_PIPE] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(597),
    [anon_sym_PIPE_PIPE] = ACTIONS(597),
    [anon_sym_QMARK] = ACTIONS(597),
    [anon_sym_DOT_DOT] = ACTIONS(599),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(597),
    [anon_sym_as] = ACTIONS(599),
    [sym_mutable_specifier] = ACTIONS(599),
    [anon_sym_else] = ACTIONS(599),
    [anon_sym_ref] = ACTIONS(599),
    [sym_integer_literal] = ACTIONS(597),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(597),
    [sym_char_literal] = ACTIONS(597),
    [anon_sym_true] = ACTIONS(599),
    [anon_sym_false] = ACTIONS(599),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(599),
    [sym_self] = ACTIONS(599),
    [sym_super] = ACTIONS(599),
    [sym_crate] = ACTIONS(599),
    [sym_metavariable] = ACTIONS(597),
  },
  [2809] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(6937),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(623),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(623),
    [anon_sym_PLUS_EQ] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(623),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(643),
    [anon_sym_as] = ACTIONS(645),
    [sym_line_comment] = ACTIONS(7),
  },
  [2810] = {
    [sym__statement] = STATE(332),
    [sym_empty_statement] = STATE(332),
    [sym__expression_statement] = STATE(332),
    [sym_macro_definition] = STATE(332),
    [sym_attribute_item] = STATE(332),
    [sym_inner_attribute_item] = STATE(332),
    [sym_mod_item] = STATE(332),
    [sym_foreign_mod_item] = STATE(332),
    [sym_struct_item] = STATE(332),
    [sym_union_item] = STATE(332),
    [sym_enum_item] = STATE(332),
    [sym_extern_crate_declaration] = STATE(332),
    [sym_const_item] = STATE(332),
    [sym_static_item] = STATE(332),
    [sym_type_item] = STATE(332),
    [sym_function_item] = STATE(332),
    [sym_function_signature_item] = STATE(332),
    [sym_function_modifiers] = STATE(47),
    [sym_impl_item] = STATE(332),
    [sym_trait_item] = STATE(332),
    [sym_associated_type] = STATE(332),
    [sym_let_declaration] = STATE(332),
    [sym_use_declaration] = STATE(332),
    [sym_extern_modifier] = STATE(48),
    [sym_visibility_modifier] = STATE(49),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3173),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3173),
    [sym_macro_invocation] = STATE(53),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3173),
    [sym_unary_expression] = STATE(3173),
    [sym_try_expression] = STATE(3173),
    [sym_reference_expression] = STATE(3173),
    [sym_binary_expression] = STATE(3173),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3173),
    [sym_call_expression] = STATE(3173),
    [sym_array_expression] = STATE(3173),
    [sym_parenthesized_expression] = STATE(3173),
    [sym_tuple_expression] = STATE(3173),
    [sym_unit_expression] = STATE(3173),
    [sym_struct_expression] = STATE(3173),
    [sym_if_expression] = STATE(57),
    [sym_if_let_expression] = STATE(57),
    [sym_match_expression] = STATE(57),
    [sym_while_expression] = STATE(57),
    [sym_while_let_expression] = STATE(57),
    [sym_loop_expression] = STATE(57),
    [sym_for_expression] = STATE(57),
    [sym_closure_expression] = STATE(3173),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(59),
    [sym_break_expression] = STATE(3173),
    [sym_continue_expression] = STATE(3173),
    [sym_index_expression] = STATE(3173),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(57),
    [sym_block] = STATE(57),
    [sym__literal] = STATE(3173),
    [sym_string_literal] = STATE(3173),
    [sym_boolean_literal] = STATE(3173),
    [aux_sym_source_file_repeat1] = STATE(332),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_raw_string_literal] = ACTIONS(6939),
    [sym_float_literal] = ACTIONS(6939),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(6937),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_POUND] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(6939),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6939),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(93),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2811] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_in] = ACTIONS(6941),
    [sym_line_comment] = ACTIONS(7),
  },
  [2812] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(3175),
    [sym_tuple_pattern] = STATE(3175),
    [sym_tuple_struct_pattern] = STATE(3175),
    [sym_struct_pattern] = STATE(3175),
    [sym_remaining_field_pattern] = STATE(3175),
    [sym_mut_pattern] = STATE(3175),
    [sym_ref_pattern] = STATE(3175),
    [sym_captured_pattern] = STATE(3175),
    [sym_reference_pattern] = STATE(3175),
    [sym__literal] = STATE(3175),
    [sym_string_literal] = STATE(3175),
    [sym_boolean_literal] = STATE(3175),
    [sym_raw_string_literal] = ACTIONS(6943),
    [sym_float_literal] = ACTIONS(6943),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(6945),
    [anon_sym_AMP] = ACTIONS(955),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(957),
    [anon_sym_ref] = ACTIONS(959),
    [sym_integer_literal] = ACTIONS(6943),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(6943),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(961),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [2813] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(3176),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(5136),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [2814] = {
    [sym_raw_string_literal] = ACTIONS(1031),
    [sym_float_literal] = ACTIONS(1031),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1031),
    [anon_sym_RBRACE] = ACTIONS(1031),
    [anon_sym_LBRACK] = ACTIONS(1031),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_STAR] = ACTIONS(1033),
    [anon_sym_COMMA] = ACTIONS(1031),
    [anon_sym_u8] = ACTIONS(1033),
    [anon_sym_i8] = ACTIONS(1033),
    [anon_sym_u16] = ACTIONS(1033),
    [anon_sym_i16] = ACTIONS(1033),
    [anon_sym_u32] = ACTIONS(1033),
    [anon_sym_i32] = ACTIONS(1033),
    [anon_sym_u64] = ACTIONS(1033),
    [anon_sym_i64] = ACTIONS(1033),
    [anon_sym_u128] = ACTIONS(1033),
    [anon_sym_i128] = ACTIONS(1033),
    [anon_sym_isize] = ACTIONS(1033),
    [anon_sym_usize] = ACTIONS(1033),
    [anon_sym_f32] = ACTIONS(1033),
    [anon_sym_f64] = ACTIONS(1033),
    [anon_sym_bool] = ACTIONS(1033),
    [anon_sym_str] = ACTIONS(1033),
    [anon_sym_char] = ACTIONS(1033),
    [anon_sym__] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_DOT] = ACTIONS(1033),
    [anon_sym_DASH_EQ] = ACTIONS(1031),
    [anon_sym_COLON_COLON] = ACTIONS(1031),
    [anon_sym_BANG_EQ] = ACTIONS(1031),
    [anon_sym_STAR_EQ] = ACTIONS(1031),
    [anon_sym_SLASH] = ACTIONS(1033),
    [anon_sym_SLASH_EQ] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(1031),
    [anon_sym_AMP_EQ] = ACTIONS(1031),
    [anon_sym_POUND] = ACTIONS(1031),
    [anon_sym_PERCENT] = ACTIONS(1033),
    [anon_sym_PERCENT_EQ] = ACTIONS(1031),
    [anon_sym_CARET] = ACTIONS(1033),
    [anon_sym_CARET_EQ] = ACTIONS(1031),
    [anon_sym_PLUS_EQ] = ACTIONS(1031),
    [anon_sym_LT] = ACTIONS(1033),
    [anon_sym_LT_LT] = ACTIONS(1033),
    [anon_sym_LT_LT_EQ] = ACTIONS(1031),
    [anon_sym_LT_EQ] = ACTIONS(1031),
    [anon_sym_EQ] = ACTIONS(1033),
    [anon_sym_EQ_EQ] = ACTIONS(1031),
    [anon_sym_GT] = ACTIONS(1033),
    [anon_sym_GT_EQ] = ACTIONS(1031),
    [anon_sym_GT_GT] = ACTIONS(1033),
    [anon_sym_GT_GT_EQ] = ACTIONS(1031),
    [anon_sym_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_EQ] = ACTIONS(1031),
    [anon_sym_PIPE_PIPE] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1031),
    [anon_sym_DOT_DOT] = ACTIONS(1033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1031),
    [anon_sym_as] = ACTIONS(1033),
    [sym_mutable_specifier] = ACTIONS(1033),
    [anon_sym_ref] = ACTIONS(1033),
    [sym_integer_literal] = ACTIONS(1031),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(1031),
    [sym_char_literal] = ACTIONS(1031),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1033),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1033),
    [sym_self] = ACTIONS(1033),
    [sym_super] = ACTIONS(1033),
    [sym_crate] = ACTIONS(1033),
    [sym_metavariable] = ACTIONS(1031),
  },
  [2815] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(6947),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [2816] = {
    [sym_raw_string_literal] = ACTIONS(1071),
    [sym_float_literal] = ACTIONS(1071),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1073),
    [anon_sym_STAR] = ACTIONS(1073),
    [anon_sym_COMMA] = ACTIONS(1071),
    [anon_sym_u8] = ACTIONS(1073),
    [anon_sym_i8] = ACTIONS(1073),
    [anon_sym_u16] = ACTIONS(1073),
    [anon_sym_i16] = ACTIONS(1073),
    [anon_sym_u32] = ACTIONS(1073),
    [anon_sym_i32] = ACTIONS(1073),
    [anon_sym_u64] = ACTIONS(1073),
    [anon_sym_i64] = ACTIONS(1073),
    [anon_sym_u128] = ACTIONS(1073),
    [anon_sym_i128] = ACTIONS(1073),
    [anon_sym_isize] = ACTIONS(1073),
    [anon_sym_usize] = ACTIONS(1073),
    [anon_sym_f32] = ACTIONS(1073),
    [anon_sym_f64] = ACTIONS(1073),
    [anon_sym_bool] = ACTIONS(1073),
    [anon_sym_str] = ACTIONS(1073),
    [anon_sym_char] = ACTIONS(1073),
    [anon_sym__] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_DASH] = ACTIONS(1073),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_DASH_EQ] = ACTIONS(1071),
    [anon_sym_COLON_COLON] = ACTIONS(1071),
    [anon_sym_BANG_EQ] = ACTIONS(1071),
    [anon_sym_STAR_EQ] = ACTIONS(1071),
    [anon_sym_SLASH] = ACTIONS(1073),
    [anon_sym_SLASH_EQ] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_AMP_EQ] = ACTIONS(1071),
    [anon_sym_POUND] = ACTIONS(1071),
    [anon_sym_PERCENT] = ACTIONS(1073),
    [anon_sym_PERCENT_EQ] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1073),
    [anon_sym_CARET_EQ] = ACTIONS(1071),
    [anon_sym_PLUS_EQ] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_LT_LT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(1071),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_GT_GT_EQ] = ACTIONS(1071),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_PIPE_EQ] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_QMARK] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(1073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1071),
    [anon_sym_as] = ACTIONS(1073),
    [sym_mutable_specifier] = ACTIONS(1073),
    [anon_sym_ref] = ACTIONS(1073),
    [sym_integer_literal] = ACTIONS(1071),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(1071),
    [sym_char_literal] = ACTIONS(1071),
    [anon_sym_true] = ACTIONS(1073),
    [anon_sym_false] = ACTIONS(1073),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1073),
    [sym_self] = ACTIONS(1073),
    [sym_super] = ACTIONS(1073),
    [sym_crate] = ACTIONS(1073),
    [sym_metavariable] = ACTIONS(1071),
  },
  [2817] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(3178),
    [sym_tuple_pattern] = STATE(3178),
    [sym_tuple_struct_pattern] = STATE(3178),
    [sym_struct_pattern] = STATE(3178),
    [sym_remaining_field_pattern] = STATE(3178),
    [sym_mut_pattern] = STATE(3178),
    [sym_ref_pattern] = STATE(3178),
    [sym_captured_pattern] = STATE(3178),
    [sym_reference_pattern] = STATE(3178),
    [sym__literal] = STATE(3178),
    [sym_string_literal] = STATE(3178),
    [sym_boolean_literal] = STATE(3178),
    [sym_raw_string_literal] = ACTIONS(6949),
    [sym_float_literal] = ACTIONS(6949),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(6951),
    [anon_sym_AMP] = ACTIONS(955),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(957),
    [anon_sym_ref] = ACTIONS(959),
    [sym_integer_literal] = ACTIONS(6949),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(6949),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(961),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [2818] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(3179),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(5136),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [2819] = {
    [sym_raw_string_literal] = ACTIONS(6953),
    [sym_float_literal] = ACTIONS(6953),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6953),
    [anon_sym_RBRACE] = ACTIONS(6955),
    [anon_sym_u8] = ACTIONS(6957),
    [anon_sym_i8] = ACTIONS(6957),
    [anon_sym_u16] = ACTIONS(6957),
    [anon_sym_i16] = ACTIONS(6957),
    [anon_sym_u32] = ACTIONS(6957),
    [anon_sym_i32] = ACTIONS(6957),
    [anon_sym_u64] = ACTIONS(6957),
    [anon_sym_i64] = ACTIONS(6957),
    [anon_sym_u128] = ACTIONS(6957),
    [anon_sym_i128] = ACTIONS(6957),
    [anon_sym_isize] = ACTIONS(6957),
    [anon_sym_usize] = ACTIONS(6957),
    [anon_sym_f32] = ACTIONS(6957),
    [anon_sym_f64] = ACTIONS(6957),
    [anon_sym_bool] = ACTIONS(6957),
    [anon_sym_str] = ACTIONS(6957),
    [anon_sym_char] = ACTIONS(6957),
    [anon_sym__] = ACTIONS(6957),
    [anon_sym_AMP] = ACTIONS(6953),
    [anon_sym_COLON_COLON] = ACTIONS(6953),
    [anon_sym_POUND] = ACTIONS(6953),
    [anon_sym_LT] = ACTIONS(6953),
    [anon_sym_DOT_DOT] = ACTIONS(6953),
    [sym_mutable_specifier] = ACTIONS(6957),
    [anon_sym_ref] = ACTIONS(6957),
    [sym_integer_literal] = ACTIONS(6953),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6953),
    [sym_char_literal] = ACTIONS(6953),
    [anon_sym_true] = ACTIONS(6957),
    [anon_sym_false] = ACTIONS(6957),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6957),
    [sym_self] = ACTIONS(6957),
    [sym_super] = ACTIONS(6957),
    [sym_crate] = ACTIONS(6957),
    [sym_metavariable] = ACTIONS(6953),
  },
  [2820] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(6959),
    [anon_sym_loop] = ACTIONS(6961),
    [anon_sym_while] = ACTIONS(6963),
    [sym_line_comment] = ACTIONS(7),
  },
  [2821] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(527),
    [anon_sym_EQ_GT] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_STAR] = ACTIONS(529),
    [anon_sym_AMP] = ACTIONS(529),
    [anon_sym_DASH] = ACTIONS(529),
    [anon_sym_DOT] = ACTIONS(529),
    [anon_sym_DASH_EQ] = ACTIONS(527),
    [anon_sym_BANG_EQ] = ACTIONS(527),
    [anon_sym_STAR_EQ] = ACTIONS(527),
    [anon_sym_SLASH] = ACTIONS(529),
    [anon_sym_SLASH_EQ] = ACTIONS(527),
    [anon_sym_AMP_AMP] = ACTIONS(527),
    [anon_sym_AMP_EQ] = ACTIONS(527),
    [anon_sym_PERCENT] = ACTIONS(529),
    [anon_sym_PERCENT_EQ] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(529),
    [anon_sym_CARET_EQ] = ACTIONS(527),
    [anon_sym_PLUS_EQ] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(529),
    [anon_sym_LT_LT] = ACTIONS(529),
    [anon_sym_LT_LT_EQ] = ACTIONS(527),
    [anon_sym_LT_EQ] = ACTIONS(527),
    [anon_sym_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(527),
    [anon_sym_GT] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(527),
    [anon_sym_GT_GT] = ACTIONS(529),
    [anon_sym_GT_GT_EQ] = ACTIONS(527),
    [anon_sym_PIPE] = ACTIONS(529),
    [anon_sym_PIPE_EQ] = ACTIONS(527),
    [anon_sym_PIPE_PIPE] = ACTIONS(527),
    [anon_sym_QMARK] = ACTIONS(527),
    [anon_sym_DOT_DOT] = ACTIONS(529),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(527),
    [anon_sym_as] = ACTIONS(527),
    [sym_line_comment] = ACTIONS(7),
  },
  [2822] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(6965),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(6967),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_BANG_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH] = ACTIONS(563),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(563),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_LT] = ACTIONS(577),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(581),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(577),
    [anon_sym_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(589),
    [anon_sym_as] = ACTIONS(591),
    [sym_line_comment] = ACTIONS(7),
  },
  [2823] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(597),
    [anon_sym_EQ_GT] = ACTIONS(597),
    [anon_sym_LBRACK] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(599),
    [anon_sym_STAR] = ACTIONS(599),
    [anon_sym_AMP] = ACTIONS(599),
    [anon_sym_DASH] = ACTIONS(599),
    [anon_sym_DOT] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(597),
    [anon_sym_BANG_EQ] = ACTIONS(597),
    [anon_sym_STAR_EQ] = ACTIONS(597),
    [anon_sym_SLASH] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(597),
    [anon_sym_AMP_AMP] = ACTIONS(597),
    [anon_sym_AMP_EQ] = ACTIONS(597),
    [anon_sym_PERCENT] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(597),
    [anon_sym_CARET] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(597),
    [anon_sym_PLUS_EQ] = ACTIONS(597),
    [anon_sym_LT] = ACTIONS(599),
    [anon_sym_LT_LT] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(597),
    [anon_sym_LT_EQ] = ACTIONS(597),
    [anon_sym_EQ] = ACTIONS(599),
    [anon_sym_EQ_EQ] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(599),
    [anon_sym_GT_EQ] = ACTIONS(597),
    [anon_sym_GT_GT] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(597),
    [anon_sym_PIPE] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(597),
    [anon_sym_PIPE_PIPE] = ACTIONS(597),
    [anon_sym_QMARK] = ACTIONS(597),
    [anon_sym_DOT_DOT] = ACTIONS(599),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(597),
    [anon_sym_as] = ACTIONS(597),
    [anon_sym_else] = ACTIONS(597),
    [sym_line_comment] = ACTIONS(7),
  },
  [2824] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(623),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(623),
    [anon_sym_PLUS_EQ] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(623),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(643),
    [anon_sym_as] = ACTIONS(645),
    [sym_line_comment] = ACTIONS(7),
  },
  [2825] = {
    [sym__statement] = STATE(332),
    [sym_empty_statement] = STATE(332),
    [sym__expression_statement] = STATE(332),
    [sym_macro_definition] = STATE(332),
    [sym_attribute_item] = STATE(332),
    [sym_inner_attribute_item] = STATE(332),
    [sym_mod_item] = STATE(332),
    [sym_foreign_mod_item] = STATE(332),
    [sym_struct_item] = STATE(332),
    [sym_union_item] = STATE(332),
    [sym_enum_item] = STATE(332),
    [sym_extern_crate_declaration] = STATE(332),
    [sym_const_item] = STATE(332),
    [sym_static_item] = STATE(332),
    [sym_type_item] = STATE(332),
    [sym_function_item] = STATE(332),
    [sym_function_signature_item] = STATE(332),
    [sym_function_modifiers] = STATE(47),
    [sym_impl_item] = STATE(332),
    [sym_trait_item] = STATE(332),
    [sym_associated_type] = STATE(332),
    [sym_let_declaration] = STATE(332),
    [sym_use_declaration] = STATE(332),
    [sym_extern_modifier] = STATE(48),
    [sym_visibility_modifier] = STATE(49),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3186),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3186),
    [sym_macro_invocation] = STATE(53),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3186),
    [sym_unary_expression] = STATE(3186),
    [sym_try_expression] = STATE(3186),
    [sym_reference_expression] = STATE(3186),
    [sym_binary_expression] = STATE(3186),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3186),
    [sym_call_expression] = STATE(3186),
    [sym_array_expression] = STATE(3186),
    [sym_parenthesized_expression] = STATE(3186),
    [sym_tuple_expression] = STATE(3186),
    [sym_unit_expression] = STATE(3186),
    [sym_struct_expression] = STATE(3186),
    [sym_if_expression] = STATE(57),
    [sym_if_let_expression] = STATE(57),
    [sym_match_expression] = STATE(57),
    [sym_while_expression] = STATE(57),
    [sym_while_let_expression] = STATE(57),
    [sym_loop_expression] = STATE(57),
    [sym_for_expression] = STATE(57),
    [sym_closure_expression] = STATE(3186),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(59),
    [sym_break_expression] = STATE(3186),
    [sym_continue_expression] = STATE(3186),
    [sym_index_expression] = STATE(3186),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(57),
    [sym_block] = STATE(57),
    [sym__literal] = STATE(3186),
    [sym_string_literal] = STATE(3186),
    [sym_boolean_literal] = STATE(3186),
    [aux_sym_source_file_repeat1] = STATE(332),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_raw_string_literal] = ACTIONS(6971),
    [sym_float_literal] = ACTIONS(6971),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_POUND] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(6971),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6971),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(93),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2826] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(651),
    [anon_sym_EQ_GT] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(653),
    [anon_sym_AMP] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_DOT] = ACTIONS(653),
    [anon_sym_DASH_EQ] = ACTIONS(651),
    [anon_sym_BANG_EQ] = ACTIONS(651),
    [anon_sym_STAR_EQ] = ACTIONS(651),
    [anon_sym_SLASH] = ACTIONS(653),
    [anon_sym_SLASH_EQ] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(651),
    [anon_sym_AMP_EQ] = ACTIONS(651),
    [anon_sym_PERCENT] = ACTIONS(653),
    [anon_sym_PERCENT_EQ] = ACTIONS(651),
    [anon_sym_CARET] = ACTIONS(653),
    [anon_sym_CARET_EQ] = ACTIONS(651),
    [anon_sym_PLUS_EQ] = ACTIONS(651),
    [anon_sym_LT] = ACTIONS(653),
    [anon_sym_LT_LT] = ACTIONS(653),
    [anon_sym_LT_LT_EQ] = ACTIONS(651),
    [anon_sym_LT_EQ] = ACTIONS(651),
    [anon_sym_EQ] = ACTIONS(653),
    [anon_sym_EQ_EQ] = ACTIONS(651),
    [anon_sym_GT] = ACTIONS(653),
    [anon_sym_GT_EQ] = ACTIONS(651),
    [anon_sym_GT_GT] = ACTIONS(653),
    [anon_sym_GT_GT_EQ] = ACTIONS(651),
    [anon_sym_PIPE] = ACTIONS(653),
    [anon_sym_PIPE_EQ] = ACTIONS(651),
    [anon_sym_PIPE_PIPE] = ACTIONS(651),
    [anon_sym_QMARK] = ACTIONS(651),
    [anon_sym_DOT_DOT] = ACTIONS(653),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(651),
    [anon_sym_as] = ACTIONS(651),
    [sym_line_comment] = ACTIONS(7),
  },
  [2827] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACK] = ACTIONS(6973),
    [sym_line_comment] = ACTIONS(7),
  },
  [2828] = {
    [sym_arguments] = STATE(263),
    [aux_sym_token_tree_repeat2] = STATE(3190),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6975),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6973),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_COMMA] = ACTIONS(6977),
    [anon_sym_AMP] = ACTIONS(677),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(679),
    [anon_sym_BANG_EQ] = ACTIONS(681),
    [anon_sym_STAR_EQ] = ACTIONS(679),
    [anon_sym_SLASH] = ACTIONS(673),
    [anon_sym_SLASH_EQ] = ACTIONS(679),
    [anon_sym_AMP_AMP] = ACTIONS(683),
    [anon_sym_AMP_EQ] = ACTIONS(679),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_PERCENT_EQ] = ACTIONS(679),
    [anon_sym_CARET] = ACTIONS(685),
    [anon_sym_CARET_EQ] = ACTIONS(679),
    [anon_sym_PLUS_EQ] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_LT_LT] = ACTIONS(689),
    [anon_sym_LT_LT_EQ] = ACTIONS(679),
    [anon_sym_LT_EQ] = ACTIONS(681),
    [anon_sym_EQ] = ACTIONS(691),
    [anon_sym_EQ_EQ] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(689),
    [anon_sym_GT_GT_EQ] = ACTIONS(679),
    [anon_sym_PIPE] = ACTIONS(693),
    [anon_sym_PIPE_EQ] = ACTIONS(679),
    [anon_sym_PIPE_PIPE] = ACTIONS(695),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(697),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(699),
    [anon_sym_as] = ACTIONS(701),
    [sym_line_comment] = ACTIONS(7),
  },
  [2829] = {
    [sym_arguments] = STATE(2876),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6312),
    [anon_sym_EQ_GT] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(711),
    [anon_sym_AMP] = ACTIONS(711),
    [anon_sym_DASH] = ACTIONS(711),
    [anon_sym_DOT] = ACTIONS(6324),
    [anon_sym_DASH_EQ] = ACTIONS(709),
    [anon_sym_BANG_EQ] = ACTIONS(709),
    [anon_sym_STAR_EQ] = ACTIONS(709),
    [anon_sym_SLASH] = ACTIONS(711),
    [anon_sym_SLASH_EQ] = ACTIONS(709),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_AMP_EQ] = ACTIONS(709),
    [anon_sym_PERCENT] = ACTIONS(711),
    [anon_sym_PERCENT_EQ] = ACTIONS(709),
    [anon_sym_CARET] = ACTIONS(711),
    [anon_sym_CARET_EQ] = ACTIONS(709),
    [anon_sym_PLUS_EQ] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_LT] = ACTIONS(711),
    [anon_sym_LT_LT_EQ] = ACTIONS(709),
    [anon_sym_LT_EQ] = ACTIONS(709),
    [anon_sym_EQ] = ACTIONS(711),
    [anon_sym_EQ_EQ] = ACTIONS(709),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(709),
    [anon_sym_GT_GT] = ACTIONS(711),
    [anon_sym_GT_GT_EQ] = ACTIONS(709),
    [anon_sym_PIPE] = ACTIONS(711),
    [anon_sym_PIPE_EQ] = ACTIONS(709),
    [anon_sym_PIPE_PIPE] = ACTIONS(709),
    [anon_sym_QMARK] = ACTIONS(709),
    [anon_sym_DOT_DOT] = ACTIONS(711),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(709),
    [anon_sym_as] = ACTIONS(709),
    [sym_line_comment] = ACTIONS(7),
  },
  [2830] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6979),
  },
  [2831] = {
    [sym_bracketed_type] = STATE(2351),
    [sym_generic_function] = STATE(3192),
    [sym_generic_type_with_turbofish] = STATE(2352),
    [sym__expression] = STATE(3192),
    [sym_macro_invocation] = STATE(3192),
    [sym_scoped_identifier] = STATE(2354),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2355),
    [sym_range_expression] = STATE(3192),
    [sym_unary_expression] = STATE(3192),
    [sym_try_expression] = STATE(3192),
    [sym_reference_expression] = STATE(3192),
    [sym_binary_expression] = STATE(3192),
    [sym_assignment_expression] = STATE(2356),
    [sym_compound_assignment_expr] = STATE(2356),
    [sym_type_cast_expression] = STATE(2356),
    [sym_return_expression] = STATE(3192),
    [sym_call_expression] = STATE(3192),
    [sym_array_expression] = STATE(3192),
    [sym_parenthesized_expression] = STATE(3192),
    [sym_tuple_expression] = STATE(3192),
    [sym_unit_expression] = STATE(3192),
    [sym_struct_expression] = STATE(3192),
    [sym_if_expression] = STATE(3192),
    [sym_if_let_expression] = STATE(3192),
    [sym_match_expression] = STATE(3192),
    [sym_while_expression] = STATE(3192),
    [sym_while_let_expression] = STATE(3192),
    [sym_loop_expression] = STATE(3192),
    [sym_for_expression] = STATE(3192),
    [sym_closure_expression] = STATE(3192),
    [sym_closure_parameters] = STATE(2357),
    [sym_loop_label] = STATE(2358),
    [sym_break_expression] = STATE(3192),
    [sym_continue_expression] = STATE(3192),
    [sym_index_expression] = STATE(3192),
    [sym_field_expression] = STATE(2359),
    [sym_unsafe_block] = STATE(3192),
    [sym_block] = STATE(3192),
    [sym__literal] = STATE(3192),
    [sym_string_literal] = STATE(3192),
    [sym_boolean_literal] = STATE(3192),
    [sym_raw_string_literal] = ACTIONS(6981),
    [sym_float_literal] = ACTIONS(6981),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5154),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_LBRACK] = ACTIONS(5158),
    [anon_sym_STAR] = ACTIONS(5160),
    [anon_sym_u8] = ACTIONS(5162),
    [anon_sym_i8] = ACTIONS(5162),
    [anon_sym_u16] = ACTIONS(5162),
    [anon_sym_i16] = ACTIONS(5162),
    [anon_sym_u32] = ACTIONS(5162),
    [anon_sym_i32] = ACTIONS(5162),
    [anon_sym_u64] = ACTIONS(5162),
    [anon_sym_i64] = ACTIONS(5162),
    [anon_sym_u128] = ACTIONS(5162),
    [anon_sym_i128] = ACTIONS(5162),
    [anon_sym_isize] = ACTIONS(5162),
    [anon_sym_usize] = ACTIONS(5162),
    [anon_sym_f32] = ACTIONS(5162),
    [anon_sym_f64] = ACTIONS(5162),
    [anon_sym_bool] = ACTIONS(5162),
    [anon_sym_str] = ACTIONS(5162),
    [anon_sym_char] = ACTIONS(5162),
    [anon_sym_AMP] = ACTIONS(5164),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_COLON_COLON] = ACTIONS(5166),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5168),
    [anon_sym_break] = ACTIONS(5170),
    [anon_sym_continue] = ACTIONS(5172),
    [anon_sym_default] = ACTIONS(5174),
    [anon_sym_for] = ACTIONS(5176),
    [anon_sym_if] = ACTIONS(5178),
    [anon_sym_loop] = ACTIONS(5180),
    [anon_sym_match] = ACTIONS(5182),
    [anon_sym_return] = ACTIONS(5184),
    [anon_sym_union] = ACTIONS(5174),
    [anon_sym_unsafe] = ACTIONS(5186),
    [anon_sym_while] = ACTIONS(5188),
    [anon_sym_move] = ACTIONS(5190),
    [sym_integer_literal] = ACTIONS(6981),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5192),
    [sym_char_literal] = ACTIONS(6981),
    [anon_sym_true] = ACTIONS(5194),
    [anon_sym_false] = ACTIONS(5194),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5196),
    [sym_self] = ACTIONS(5198),
    [sym_super] = ACTIONS(5200),
    [sym_crate] = ACTIONS(5200),
    [sym_metavariable] = ACTIONS(5202),
  },
  [2832] = {
    [sym_arguments] = STATE(2876),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6312),
    [anon_sym_EQ_GT] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(719),
    [anon_sym_STAR] = ACTIONS(719),
    [anon_sym_AMP] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(719),
    [anon_sym_DOT] = ACTIONS(6324),
    [anon_sym_DASH_EQ] = ACTIONS(717),
    [anon_sym_BANG_EQ] = ACTIONS(717),
    [anon_sym_STAR_EQ] = ACTIONS(717),
    [anon_sym_SLASH] = ACTIONS(719),
    [anon_sym_SLASH_EQ] = ACTIONS(717),
    [anon_sym_AMP_AMP] = ACTIONS(717),
    [anon_sym_AMP_EQ] = ACTIONS(717),
    [anon_sym_PERCENT] = ACTIONS(719),
    [anon_sym_PERCENT_EQ] = ACTIONS(717),
    [anon_sym_CARET] = ACTIONS(719),
    [anon_sym_CARET_EQ] = ACTIONS(717),
    [anon_sym_PLUS_EQ] = ACTIONS(717),
    [anon_sym_LT] = ACTIONS(719),
    [anon_sym_LT_LT] = ACTIONS(719),
    [anon_sym_LT_LT_EQ] = ACTIONS(717),
    [anon_sym_LT_EQ] = ACTIONS(717),
    [anon_sym_EQ] = ACTIONS(719),
    [anon_sym_EQ_EQ] = ACTIONS(717),
    [anon_sym_GT] = ACTIONS(719),
    [anon_sym_GT_EQ] = ACTIONS(717),
    [anon_sym_GT_GT] = ACTIONS(719),
    [anon_sym_GT_GT_EQ] = ACTIONS(717),
    [anon_sym_PIPE] = ACTIONS(719),
    [anon_sym_PIPE_EQ] = ACTIONS(717),
    [anon_sym_PIPE_PIPE] = ACTIONS(717),
    [anon_sym_QMARK] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(717),
    [anon_sym_as] = ACTIONS(717),
    [sym_line_comment] = ACTIONS(7),
  },
  [2833] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(721),
    [anon_sym_LBRACE] = ACTIONS(723),
    [anon_sym_EQ_GT] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(721),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(721),
    [anon_sym_COLON_COLON] = ACTIONS(721),
    [anon_sym_BANG_EQ] = ACTIONS(721),
    [anon_sym_STAR_EQ] = ACTIONS(721),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(721),
    [anon_sym_AMP_AMP] = ACTIONS(721),
    [anon_sym_AMP_EQ] = ACTIONS(721),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(721),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(721),
    [anon_sym_PLUS_EQ] = ACTIONS(721),
    [anon_sym_LT] = ACTIONS(725),
    [anon_sym_LT_LT] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(721),
    [anon_sym_LT_EQ] = ACTIONS(721),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_EQ_EQ] = ACTIONS(721),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(721),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(721),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(721),
    [anon_sym_PIPE_PIPE] = ACTIONS(721),
    [anon_sym_QMARK] = ACTIONS(721),
    [anon_sym_DOT_DOT] = ACTIONS(725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(721),
    [anon_sym_as] = ACTIONS(721),
    [sym_line_comment] = ACTIONS(7),
  },
  [2834] = {
    [sym_arguments] = STATE(2876),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6312),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6318),
    [anon_sym_STAR] = ACTIONS(6320),
    [anon_sym_AMP] = ACTIONS(6322),
    [anon_sym_DASH] = ACTIONS(6318),
    [anon_sym_DOT] = ACTIONS(6324),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_BANG_EQ] = ACTIONS(6328),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH] = ACTIONS(6320),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(6330),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(6320),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(6332),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(6334),
    [anon_sym_LT_LT] = ACTIONS(6336),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(6328),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_EQ_EQ] = ACTIONS(6328),
    [anon_sym_GT] = ACTIONS(6334),
    [anon_sym_GT_EQ] = ACTIONS(6328),
    [anon_sym_GT_GT] = ACTIONS(6336),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(6340),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(6342),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_as] = ACTIONS(909),
    [sym_line_comment] = ACTIONS(7),
  },
  [2835] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6983),
  },
  [2836] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(913),
    [anon_sym_EQ_GT] = ACTIONS(913),
    [anon_sym_LBRACK] = ACTIONS(913),
    [anon_sym_PLUS] = ACTIONS(915),
    [anon_sym_STAR] = ACTIONS(915),
    [anon_sym_AMP] = ACTIONS(915),
    [anon_sym_DASH] = ACTIONS(915),
    [anon_sym_DOT] = ACTIONS(915),
    [anon_sym_DASH_EQ] = ACTIONS(913),
    [anon_sym_BANG_EQ] = ACTIONS(913),
    [anon_sym_STAR_EQ] = ACTIONS(913),
    [anon_sym_SLASH] = ACTIONS(915),
    [anon_sym_SLASH_EQ] = ACTIONS(913),
    [anon_sym_AMP_AMP] = ACTIONS(913),
    [anon_sym_AMP_EQ] = ACTIONS(913),
    [anon_sym_PERCENT] = ACTIONS(915),
    [anon_sym_PERCENT_EQ] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_CARET_EQ] = ACTIONS(913),
    [anon_sym_PLUS_EQ] = ACTIONS(913),
    [anon_sym_LT] = ACTIONS(915),
    [anon_sym_LT_LT] = ACTIONS(915),
    [anon_sym_LT_LT_EQ] = ACTIONS(913),
    [anon_sym_LT_EQ] = ACTIONS(913),
    [anon_sym_EQ] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(913),
    [anon_sym_GT] = ACTIONS(915),
    [anon_sym_GT_EQ] = ACTIONS(913),
    [anon_sym_GT_GT] = ACTIONS(915),
    [anon_sym_GT_GT_EQ] = ACTIONS(913),
    [anon_sym_PIPE] = ACTIONS(915),
    [anon_sym_PIPE_EQ] = ACTIONS(913),
    [anon_sym_PIPE_PIPE] = ACTIONS(913),
    [anon_sym_QMARK] = ACTIONS(913),
    [anon_sym_DOT_DOT] = ACTIONS(915),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(913),
    [anon_sym_as] = ACTIONS(913),
    [sym_line_comment] = ACTIONS(7),
  },
  [2837] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_STAR] = ACTIONS(921),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_DASH_EQ] = ACTIONS(919),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_STAR_EQ] = ACTIONS(919),
    [anon_sym_SLASH] = ACTIONS(921),
    [anon_sym_SLASH_EQ] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_AMP_EQ] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(921),
    [anon_sym_PERCENT_EQ] = ACTIONS(919),
    [anon_sym_CARET] = ACTIONS(921),
    [anon_sym_CARET_EQ] = ACTIONS(919),
    [anon_sym_PLUS_EQ] = ACTIONS(919),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_LT_LT] = ACTIONS(921),
    [anon_sym_LT_LT_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(919),
    [anon_sym_EQ] = ACTIONS(921),
    [anon_sym_EQ_EQ] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(921),
    [anon_sym_GT_GT_EQ] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_PIPE_EQ] = ACTIONS(919),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(919),
    [anon_sym_DOT_DOT] = ACTIONS(921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(919),
    [anon_sym_as] = ACTIONS(919),
    [sym_line_comment] = ACTIONS(7),
  },
  [2838] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_in] = ACTIONS(6985),
    [sym_line_comment] = ACTIONS(7),
  },
  [2839] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(3195),
    [sym_tuple_pattern] = STATE(3195),
    [sym_tuple_struct_pattern] = STATE(3195),
    [sym_struct_pattern] = STATE(3195),
    [sym_remaining_field_pattern] = STATE(3195),
    [sym_mut_pattern] = STATE(3195),
    [sym_ref_pattern] = STATE(3195),
    [sym_captured_pattern] = STATE(3195),
    [sym_reference_pattern] = STATE(3195),
    [sym__literal] = STATE(3195),
    [sym_string_literal] = STATE(3195),
    [sym_boolean_literal] = STATE(3195),
    [sym_raw_string_literal] = ACTIONS(6987),
    [sym_float_literal] = ACTIONS(6987),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(6989),
    [anon_sym_AMP] = ACTIONS(955),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(957),
    [anon_sym_ref] = ACTIONS(959),
    [sym_integer_literal] = ACTIONS(6987),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(6987),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(961),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [2840] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(3196),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [2841] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1031),
    [anon_sym_EQ_GT] = ACTIONS(1031),
    [anon_sym_LBRACK] = ACTIONS(1031),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_STAR] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_DOT] = ACTIONS(1033),
    [anon_sym_DASH_EQ] = ACTIONS(1031),
    [anon_sym_BANG_EQ] = ACTIONS(1031),
    [anon_sym_STAR_EQ] = ACTIONS(1031),
    [anon_sym_SLASH] = ACTIONS(1033),
    [anon_sym_SLASH_EQ] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(1031),
    [anon_sym_AMP_EQ] = ACTIONS(1031),
    [anon_sym_PERCENT] = ACTIONS(1033),
    [anon_sym_PERCENT_EQ] = ACTIONS(1031),
    [anon_sym_CARET] = ACTIONS(1033),
    [anon_sym_CARET_EQ] = ACTIONS(1031),
    [anon_sym_PLUS_EQ] = ACTIONS(1031),
    [anon_sym_LT] = ACTIONS(1033),
    [anon_sym_LT_LT] = ACTIONS(1033),
    [anon_sym_LT_LT_EQ] = ACTIONS(1031),
    [anon_sym_LT_EQ] = ACTIONS(1031),
    [anon_sym_EQ] = ACTIONS(1033),
    [anon_sym_EQ_EQ] = ACTIONS(1031),
    [anon_sym_GT] = ACTIONS(1033),
    [anon_sym_GT_EQ] = ACTIONS(1031),
    [anon_sym_GT_GT] = ACTIONS(1033),
    [anon_sym_GT_GT_EQ] = ACTIONS(1031),
    [anon_sym_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_EQ] = ACTIONS(1031),
    [anon_sym_PIPE_PIPE] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1031),
    [anon_sym_DOT_DOT] = ACTIONS(1033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1031),
    [anon_sym_as] = ACTIONS(1031),
    [sym_line_comment] = ACTIONS(7),
  },
  [2842] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(6991),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [2843] = {
    [sym_arguments] = STATE(2876),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6312),
    [anon_sym_EQ_GT] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6318),
    [anon_sym_STAR] = ACTIONS(6320),
    [anon_sym_AMP] = ACTIONS(6322),
    [anon_sym_DASH] = ACTIONS(6318),
    [anon_sym_DOT] = ACTIONS(6324),
    [anon_sym_DASH_EQ] = ACTIONS(1043),
    [anon_sym_BANG_EQ] = ACTIONS(6328),
    [anon_sym_STAR_EQ] = ACTIONS(1043),
    [anon_sym_SLASH] = ACTIONS(6320),
    [anon_sym_SLASH_EQ] = ACTIONS(1043),
    [anon_sym_AMP_AMP] = ACTIONS(6330),
    [anon_sym_AMP_EQ] = ACTIONS(1043),
    [anon_sym_PERCENT] = ACTIONS(6320),
    [anon_sym_PERCENT_EQ] = ACTIONS(1043),
    [anon_sym_CARET] = ACTIONS(6332),
    [anon_sym_CARET_EQ] = ACTIONS(1043),
    [anon_sym_PLUS_EQ] = ACTIONS(1043),
    [anon_sym_LT] = ACTIONS(6334),
    [anon_sym_LT_LT] = ACTIONS(6336),
    [anon_sym_LT_LT_EQ] = ACTIONS(1043),
    [anon_sym_LT_EQ] = ACTIONS(6328),
    [anon_sym_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(6328),
    [anon_sym_GT] = ACTIONS(6334),
    [anon_sym_GT_EQ] = ACTIONS(6328),
    [anon_sym_GT_GT] = ACTIONS(6336),
    [anon_sym_GT_GT_EQ] = ACTIONS(1043),
    [anon_sym_PIPE] = ACTIONS(6340),
    [anon_sym_PIPE_EQ] = ACTIONS(1043),
    [anon_sym_PIPE_PIPE] = ACTIONS(6342),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(6346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6348),
    [anon_sym_as] = ACTIONS(1043),
    [sym_line_comment] = ACTIONS(7),
  },
  [2844] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1071),
    [anon_sym_EQ_GT] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1073),
    [anon_sym_STAR] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_DASH] = ACTIONS(1073),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_DASH_EQ] = ACTIONS(1071),
    [anon_sym_BANG_EQ] = ACTIONS(1071),
    [anon_sym_STAR_EQ] = ACTIONS(1071),
    [anon_sym_SLASH] = ACTIONS(1073),
    [anon_sym_SLASH_EQ] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_AMP_EQ] = ACTIONS(1071),
    [anon_sym_PERCENT] = ACTIONS(1073),
    [anon_sym_PERCENT_EQ] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1073),
    [anon_sym_CARET_EQ] = ACTIONS(1071),
    [anon_sym_PLUS_EQ] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_LT_LT_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(1071),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_GT_GT_EQ] = ACTIONS(1071),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_PIPE_EQ] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_QMARK] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(1073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1071),
    [anon_sym_as] = ACTIONS(1071),
    [sym_line_comment] = ACTIONS(7),
  },
  [2845] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(3198),
    [sym_tuple_pattern] = STATE(3198),
    [sym_tuple_struct_pattern] = STATE(3198),
    [sym_struct_pattern] = STATE(3198),
    [sym_remaining_field_pattern] = STATE(3198),
    [sym_mut_pattern] = STATE(3198),
    [sym_ref_pattern] = STATE(3198),
    [sym_captured_pattern] = STATE(3198),
    [sym_reference_pattern] = STATE(3198),
    [sym__literal] = STATE(3198),
    [sym_string_literal] = STATE(3198),
    [sym_boolean_literal] = STATE(3198),
    [sym_raw_string_literal] = ACTIONS(6993),
    [sym_float_literal] = ACTIONS(6993),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(6995),
    [anon_sym_AMP] = ACTIONS(955),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(957),
    [anon_sym_ref] = ACTIONS(959),
    [sym_integer_literal] = ACTIONS(6993),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(6993),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(961),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [2846] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(3199),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [2847] = {
    [sym_bracketed_type] = STATE(2351),
    [sym_generic_function] = STATE(3201),
    [sym_generic_type_with_turbofish] = STATE(2352),
    [sym__expression] = STATE(3201),
    [sym_macro_invocation] = STATE(3201),
    [sym_scoped_identifier] = STATE(2354),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2355),
    [sym_range_expression] = STATE(3201),
    [sym_unary_expression] = STATE(3201),
    [sym_try_expression] = STATE(3201),
    [sym_reference_expression] = STATE(3201),
    [sym_binary_expression] = STATE(3201),
    [sym_assignment_expression] = STATE(2356),
    [sym_compound_assignment_expr] = STATE(2356),
    [sym_type_cast_expression] = STATE(2356),
    [sym_return_expression] = STATE(3201),
    [sym_call_expression] = STATE(3201),
    [sym_array_expression] = STATE(3201),
    [sym_parenthesized_expression] = STATE(3201),
    [sym_tuple_expression] = STATE(3201),
    [sym_unit_expression] = STATE(3201),
    [sym_struct_expression] = STATE(3201),
    [sym_if_expression] = STATE(3201),
    [sym_if_let_expression] = STATE(3201),
    [sym_match_expression] = STATE(3201),
    [sym_while_expression] = STATE(3201),
    [sym_while_let_expression] = STATE(3201),
    [sym_loop_expression] = STATE(3201),
    [sym_for_expression] = STATE(3201),
    [sym_closure_expression] = STATE(3201),
    [sym_closure_parameters] = STATE(2357),
    [sym_loop_label] = STATE(2358),
    [sym_break_expression] = STATE(3201),
    [sym_continue_expression] = STATE(3201),
    [sym_index_expression] = STATE(3201),
    [sym_field_expression] = STATE(2359),
    [sym_unsafe_block] = STATE(3201),
    [sym_block] = STATE(3201),
    [sym__literal] = STATE(3201),
    [sym_string_literal] = STATE(3201),
    [sym_boolean_literal] = STATE(3201),
    [sym_raw_string_literal] = ACTIONS(6997),
    [sym_float_literal] = ACTIONS(6997),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5154),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_LBRACK] = ACTIONS(5158),
    [anon_sym_STAR] = ACTIONS(5160),
    [anon_sym_u8] = ACTIONS(5162),
    [anon_sym_i8] = ACTIONS(5162),
    [anon_sym_u16] = ACTIONS(5162),
    [anon_sym_i16] = ACTIONS(5162),
    [anon_sym_u32] = ACTIONS(5162),
    [anon_sym_i32] = ACTIONS(5162),
    [anon_sym_u64] = ACTIONS(5162),
    [anon_sym_i64] = ACTIONS(5162),
    [anon_sym_u128] = ACTIONS(5162),
    [anon_sym_i128] = ACTIONS(5162),
    [anon_sym_isize] = ACTIONS(5162),
    [anon_sym_usize] = ACTIONS(5162),
    [anon_sym_f32] = ACTIONS(5162),
    [anon_sym_f64] = ACTIONS(5162),
    [anon_sym_bool] = ACTIONS(5162),
    [anon_sym_str] = ACTIONS(5162),
    [anon_sym_char] = ACTIONS(5162),
    [anon_sym_AMP] = ACTIONS(5164),
    [anon_sym_DASH] = ACTIONS(6276),
    [anon_sym_DASH_GT] = ACTIONS(6999),
    [anon_sym_COLON_COLON] = ACTIONS(5166),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5168),
    [anon_sym_break] = ACTIONS(5170),
    [anon_sym_continue] = ACTIONS(5172),
    [anon_sym_default] = ACTIONS(5174),
    [anon_sym_for] = ACTIONS(5176),
    [anon_sym_if] = ACTIONS(5178),
    [anon_sym_loop] = ACTIONS(5180),
    [anon_sym_match] = ACTIONS(5182),
    [anon_sym_return] = ACTIONS(5184),
    [anon_sym_union] = ACTIONS(5174),
    [anon_sym_unsafe] = ACTIONS(5186),
    [anon_sym_while] = ACTIONS(5188),
    [anon_sym_move] = ACTIONS(5190),
    [sym_integer_literal] = ACTIONS(6997),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5192),
    [sym_char_literal] = ACTIONS(6997),
    [anon_sym_true] = ACTIONS(5194),
    [anon_sym_false] = ACTIONS(5194),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5196),
    [sym_self] = ACTIONS(5198),
    [sym_super] = ACTIONS(5200),
    [sym_crate] = ACTIONS(5200),
    [sym_metavariable] = ACTIONS(5202),
  },
  [2848] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1121),
    [anon_sym_EQ_GT] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_DASH_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_STAR_EQ] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1123),
    [anon_sym_SLASH_EQ] = ACTIONS(1121),
    [anon_sym_AMP_AMP] = ACTIONS(1121),
    [anon_sym_AMP_EQ] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_PERCENT_EQ] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_CARET_EQ] = ACTIONS(1121),
    [anon_sym_PLUS_EQ] = ACTIONS(1121),
    [anon_sym_LT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_LT_LT_EQ] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1121),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_GT_GT_EQ] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1123),
    [anon_sym_PIPE_EQ] = ACTIONS(1121),
    [anon_sym_PIPE_PIPE] = ACTIONS(1121),
    [anon_sym_QMARK] = ACTIONS(1121),
    [anon_sym_DOT_DOT] = ACTIONS(1123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1121),
    [sym_line_comment] = ACTIONS(7),
  },
  [2849] = {
    [aux_sym_string_literal_repeat1] = STATE(575),
    [sym_block_comment] = ACTIONS(7),
    [aux_sym_SLASH_LBRACK_CARET_BSLASH_BSLASH_DQUOTE_RBRACK_PLUS_SLASH] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(7001),
    [sym_escape_sequence] = ACTIONS(1125),
    [sym_line_comment] = ACTIONS(401),
  },
  [2850] = {
    [sym_attribute_item] = STATE(582),
    [sym_field_initializer] = STATE(3206),
    [sym_base_field_initializer] = STATE(3206),
    [aux_sym_enum_variant_list_repeat1] = STATE(582),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_COMMA] = ACTIONS(7005),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_DOT_DOT] = ACTIONS(1135),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7007),
  },
  [2851] = {
    [sym_type_arguments] = STATE(3209),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7009),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7011),
  },
  [2852] = {
    [sym_token_tree] = STATE(3213),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7013),
    [anon_sym_LBRACE] = ACTIONS(7015),
    [anon_sym_LBRACK] = ACTIONS(7017),
    [sym_line_comment] = ACTIONS(7),
  },
  [2853] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1149),
    [anon_sym_EQ_GT] = ACTIONS(1149),
    [anon_sym_LBRACK] = ACTIONS(1149),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1151),
    [anon_sym_AMP] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_DASH_EQ] = ACTIONS(1149),
    [anon_sym_BANG_EQ] = ACTIONS(1149),
    [anon_sym_STAR_EQ] = ACTIONS(1149),
    [anon_sym_SLASH] = ACTIONS(1151),
    [anon_sym_SLASH_EQ] = ACTIONS(1149),
    [anon_sym_AMP_AMP] = ACTIONS(1149),
    [anon_sym_AMP_EQ] = ACTIONS(1149),
    [anon_sym_PERCENT] = ACTIONS(1151),
    [anon_sym_PERCENT_EQ] = ACTIONS(1149),
    [anon_sym_CARET] = ACTIONS(1151),
    [anon_sym_CARET_EQ] = ACTIONS(1149),
    [anon_sym_PLUS_EQ] = ACTIONS(1149),
    [anon_sym_LT] = ACTIONS(1151),
    [anon_sym_LT_LT] = ACTIONS(1151),
    [anon_sym_LT_LT_EQ] = ACTIONS(1149),
    [anon_sym_LT_EQ] = ACTIONS(1149),
    [anon_sym_EQ] = ACTIONS(1151),
    [anon_sym_EQ_EQ] = ACTIONS(1149),
    [anon_sym_GT] = ACTIONS(1151),
    [anon_sym_GT_EQ] = ACTIONS(1149),
    [anon_sym_GT_GT] = ACTIONS(1151),
    [anon_sym_GT_GT_EQ] = ACTIONS(1149),
    [anon_sym_PIPE] = ACTIONS(1151),
    [anon_sym_PIPE_EQ] = ACTIONS(1149),
    [anon_sym_PIPE_PIPE] = ACTIONS(1149),
    [anon_sym_QMARK] = ACTIONS(1149),
    [anon_sym_DOT_DOT] = ACTIONS(1151),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1149),
    [anon_sym_as] = ACTIONS(1149),
    [sym_line_comment] = ACTIONS(7),
  },
  [2854] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7011),
  },
  [2855] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7019),
  },
  [2856] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7021),
  },
  [2857] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1227),
    [anon_sym_EQ_GT] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1229),
    [anon_sym_STAR] = ACTIONS(1229),
    [anon_sym_AMP] = ACTIONS(1229),
    [anon_sym_DASH] = ACTIONS(1229),
    [anon_sym_DOT] = ACTIONS(1229),
    [anon_sym_DASH_EQ] = ACTIONS(1227),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_STAR_EQ] = ACTIONS(1227),
    [anon_sym_SLASH] = ACTIONS(1229),
    [anon_sym_SLASH_EQ] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1227),
    [anon_sym_AMP_EQ] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_PERCENT_EQ] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1229),
    [anon_sym_CARET_EQ] = ACTIONS(1227),
    [anon_sym_PLUS_EQ] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(1229),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_LT_LT_EQ] = ACTIONS(1227),
    [anon_sym_LT_EQ] = ACTIONS(1227),
    [anon_sym_EQ] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1227),
    [anon_sym_GT_GT] = ACTIONS(1229),
    [anon_sym_GT_GT_EQ] = ACTIONS(1227),
    [anon_sym_PIPE] = ACTIONS(1229),
    [anon_sym_PIPE_EQ] = ACTIONS(1227),
    [anon_sym_PIPE_PIPE] = ACTIONS(1227),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_DOT_DOT] = ACTIONS(1229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1227),
    [anon_sym_as] = ACTIONS(1227),
    [sym_line_comment] = ACTIONS(7),
  },
  [2858] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3218),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3218),
    [sym_macro_invocation] = STATE(3218),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3218),
    [sym_unary_expression] = STATE(3218),
    [sym_try_expression] = STATE(3218),
    [sym_reference_expression] = STATE(3218),
    [sym_binary_expression] = STATE(3218),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3218),
    [sym_call_expression] = STATE(3218),
    [sym_array_expression] = STATE(3218),
    [sym_parenthesized_expression] = STATE(3218),
    [sym_tuple_expression] = STATE(3218),
    [sym_unit_expression] = STATE(3218),
    [sym_struct_expression] = STATE(3218),
    [sym_if_expression] = STATE(3218),
    [sym_if_let_expression] = STATE(3218),
    [sym_match_expression] = STATE(3218),
    [sym_while_expression] = STATE(3218),
    [sym_while_let_expression] = STATE(3218),
    [sym_loop_expression] = STATE(3218),
    [sym_for_expression] = STATE(3218),
    [sym_closure_expression] = STATE(3218),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3218),
    [sym_continue_expression] = STATE(3218),
    [sym_index_expression] = STATE(3218),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3218),
    [sym_block] = STATE(3218),
    [sym__literal] = STATE(3218),
    [sym_string_literal] = STATE(3218),
    [sym_boolean_literal] = STATE(3218),
    [sym_raw_string_literal] = ACTIONS(7023),
    [sym_float_literal] = ACTIONS(7023),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(7025),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(7027),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(7023),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7023),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2859] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3219),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3219),
    [sym_macro_invocation] = STATE(3219),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3219),
    [sym_unary_expression] = STATE(3219),
    [sym_try_expression] = STATE(3219),
    [sym_reference_expression] = STATE(3219),
    [sym_binary_expression] = STATE(3219),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3219),
    [sym_call_expression] = STATE(3219),
    [sym_array_expression] = STATE(3219),
    [sym_parenthesized_expression] = STATE(3219),
    [sym_tuple_expression] = STATE(3219),
    [sym_unit_expression] = STATE(3219),
    [sym_struct_expression] = STATE(3219),
    [sym_if_expression] = STATE(3219),
    [sym_if_let_expression] = STATE(3219),
    [sym_match_expression] = STATE(3219),
    [sym_while_expression] = STATE(3219),
    [sym_while_let_expression] = STATE(3219),
    [sym_loop_expression] = STATE(3219),
    [sym_for_expression] = STATE(3219),
    [sym_closure_expression] = STATE(3219),
    [sym_closure_parameters] = STATE(638),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3219),
    [sym_continue_expression] = STATE(3219),
    [sym_index_expression] = STATE(3219),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3219),
    [sym_block] = STATE(3219),
    [sym__literal] = STATE(3219),
    [sym_string_literal] = STATE(3219),
    [sym_boolean_literal] = STATE(3219),
    [sym_raw_string_literal] = ACTIONS(7029),
    [sym_float_literal] = ACTIONS(7029),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1245),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1247),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1251),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1253),
    [sym_integer_literal] = ACTIONS(7029),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7029),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2860] = {
    [sym_bracketed_type] = STATE(2351),
    [sym_generic_function] = STATE(3220),
    [sym_generic_type_with_turbofish] = STATE(2352),
    [sym__expression] = STATE(3220),
    [sym_macro_invocation] = STATE(3220),
    [sym_scoped_identifier] = STATE(2354),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2355),
    [sym_range_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3220),
    [sym_try_expression] = STATE(3220),
    [sym_reference_expression] = STATE(3220),
    [sym_binary_expression] = STATE(3220),
    [sym_assignment_expression] = STATE(2356),
    [sym_compound_assignment_expr] = STATE(2356),
    [sym_type_cast_expression] = STATE(2356),
    [sym_return_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_array_expression] = STATE(3220),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_tuple_expression] = STATE(3220),
    [sym_unit_expression] = STATE(3220),
    [sym_struct_expression] = STATE(3220),
    [sym_if_expression] = STATE(3220),
    [sym_if_let_expression] = STATE(3220),
    [sym_match_expression] = STATE(3220),
    [sym_while_expression] = STATE(3220),
    [sym_while_let_expression] = STATE(3220),
    [sym_loop_expression] = STATE(3220),
    [sym_for_expression] = STATE(3220),
    [sym_closure_expression] = STATE(3220),
    [sym_closure_parameters] = STATE(2357),
    [sym_loop_label] = STATE(2358),
    [sym_break_expression] = STATE(3220),
    [sym_continue_expression] = STATE(3220),
    [sym_index_expression] = STATE(3220),
    [sym_field_expression] = STATE(2359),
    [sym_unsafe_block] = STATE(3220),
    [sym_block] = STATE(3220),
    [sym__literal] = STATE(3220),
    [sym_string_literal] = STATE(3220),
    [sym_boolean_literal] = STATE(3220),
    [sym_raw_string_literal] = ACTIONS(7031),
    [sym_float_literal] = ACTIONS(7031),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5154),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_LBRACK] = ACTIONS(5158),
    [anon_sym_STAR] = ACTIONS(5160),
    [anon_sym_u8] = ACTIONS(5162),
    [anon_sym_i8] = ACTIONS(5162),
    [anon_sym_u16] = ACTIONS(5162),
    [anon_sym_i16] = ACTIONS(5162),
    [anon_sym_u32] = ACTIONS(5162),
    [anon_sym_i32] = ACTIONS(5162),
    [anon_sym_u64] = ACTIONS(5162),
    [anon_sym_i64] = ACTIONS(5162),
    [anon_sym_u128] = ACTIONS(5162),
    [anon_sym_i128] = ACTIONS(5162),
    [anon_sym_isize] = ACTIONS(5162),
    [anon_sym_usize] = ACTIONS(5162),
    [anon_sym_f32] = ACTIONS(5162),
    [anon_sym_f64] = ACTIONS(5162),
    [anon_sym_bool] = ACTIONS(5162),
    [anon_sym_str] = ACTIONS(5162),
    [anon_sym_char] = ACTIONS(5162),
    [anon_sym_AMP] = ACTIONS(5164),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_COLON_COLON] = ACTIONS(5166),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5168),
    [anon_sym_break] = ACTIONS(5170),
    [anon_sym_continue] = ACTIONS(5172),
    [anon_sym_default] = ACTIONS(5174),
    [anon_sym_for] = ACTIONS(5176),
    [anon_sym_if] = ACTIONS(5178),
    [anon_sym_loop] = ACTIONS(5180),
    [anon_sym_match] = ACTIONS(5182),
    [anon_sym_return] = ACTIONS(5184),
    [anon_sym_union] = ACTIONS(5174),
    [anon_sym_unsafe] = ACTIONS(5186),
    [anon_sym_while] = ACTIONS(5188),
    [anon_sym_move] = ACTIONS(5190),
    [sym_integer_literal] = ACTIONS(7031),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5192),
    [sym_char_literal] = ACTIONS(7031),
    [anon_sym_true] = ACTIONS(5194),
    [anon_sym_false] = ACTIONS(5194),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5196),
    [sym_self] = ACTIONS(5198),
    [sym_super] = ACTIONS(5200),
    [sym_crate] = ACTIONS(5200),
    [sym_metavariable] = ACTIONS(5202),
  },
  [2861] = {
    [sym_bracketed_type] = STATE(2351),
    [sym_generic_function] = STATE(3221),
    [sym_generic_type_with_turbofish] = STATE(2352),
    [sym__expression] = STATE(3221),
    [sym_macro_invocation] = STATE(3221),
    [sym_scoped_identifier] = STATE(2354),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2355),
    [sym_range_expression] = STATE(3221),
    [sym_unary_expression] = STATE(3221),
    [sym_try_expression] = STATE(3221),
    [sym_reference_expression] = STATE(3221),
    [sym_binary_expression] = STATE(3221),
    [sym_assignment_expression] = STATE(2356),
    [sym_compound_assignment_expr] = STATE(2356),
    [sym_type_cast_expression] = STATE(2356),
    [sym_return_expression] = STATE(3221),
    [sym_call_expression] = STATE(3221),
    [sym_array_expression] = STATE(3221),
    [sym_parenthesized_expression] = STATE(3221),
    [sym_tuple_expression] = STATE(3221),
    [sym_unit_expression] = STATE(3221),
    [sym_struct_expression] = STATE(3221),
    [sym_if_expression] = STATE(3221),
    [sym_if_let_expression] = STATE(3221),
    [sym_match_expression] = STATE(3221),
    [sym_while_expression] = STATE(3221),
    [sym_while_let_expression] = STATE(3221),
    [sym_loop_expression] = STATE(3221),
    [sym_for_expression] = STATE(3221),
    [sym_closure_expression] = STATE(3221),
    [sym_closure_parameters] = STATE(2357),
    [sym_loop_label] = STATE(2358),
    [sym_break_expression] = STATE(3221),
    [sym_continue_expression] = STATE(3221),
    [sym_index_expression] = STATE(3221),
    [sym_field_expression] = STATE(2359),
    [sym_unsafe_block] = STATE(3221),
    [sym_block] = STATE(3221),
    [sym__literal] = STATE(3221),
    [sym_string_literal] = STATE(3221),
    [sym_boolean_literal] = STATE(3221),
    [sym_raw_string_literal] = ACTIONS(7033),
    [sym_float_literal] = ACTIONS(7033),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5154),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_LBRACK] = ACTIONS(5158),
    [anon_sym_STAR] = ACTIONS(5160),
    [anon_sym_u8] = ACTIONS(5162),
    [anon_sym_i8] = ACTIONS(5162),
    [anon_sym_u16] = ACTIONS(5162),
    [anon_sym_i16] = ACTIONS(5162),
    [anon_sym_u32] = ACTIONS(5162),
    [anon_sym_i32] = ACTIONS(5162),
    [anon_sym_u64] = ACTIONS(5162),
    [anon_sym_i64] = ACTIONS(5162),
    [anon_sym_u128] = ACTIONS(5162),
    [anon_sym_i128] = ACTIONS(5162),
    [anon_sym_isize] = ACTIONS(5162),
    [anon_sym_usize] = ACTIONS(5162),
    [anon_sym_f32] = ACTIONS(5162),
    [anon_sym_f64] = ACTIONS(5162),
    [anon_sym_bool] = ACTIONS(5162),
    [anon_sym_str] = ACTIONS(5162),
    [anon_sym_char] = ACTIONS(5162),
    [anon_sym_AMP] = ACTIONS(5164),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_COLON_COLON] = ACTIONS(5166),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5168),
    [anon_sym_break] = ACTIONS(5170),
    [anon_sym_continue] = ACTIONS(5172),
    [anon_sym_default] = ACTIONS(5174),
    [anon_sym_for] = ACTIONS(5176),
    [anon_sym_if] = ACTIONS(5178),
    [anon_sym_loop] = ACTIONS(5180),
    [anon_sym_match] = ACTIONS(5182),
    [anon_sym_return] = ACTIONS(5184),
    [anon_sym_union] = ACTIONS(5174),
    [anon_sym_unsafe] = ACTIONS(5186),
    [anon_sym_while] = ACTIONS(5188),
    [anon_sym_move] = ACTIONS(5190),
    [sym_integer_literal] = ACTIONS(7033),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5192),
    [sym_char_literal] = ACTIONS(7033),
    [anon_sym_true] = ACTIONS(5194),
    [anon_sym_false] = ACTIONS(5194),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5196),
    [sym_self] = ACTIONS(5198),
    [sym_super] = ACTIONS(5200),
    [sym_crate] = ACTIONS(5200),
    [sym_metavariable] = ACTIONS(5202),
  },
  [2862] = {
    [sym_bracketed_type] = STATE(2351),
    [sym_generic_function] = STATE(3222),
    [sym_generic_type_with_turbofish] = STATE(2352),
    [sym__expression] = STATE(3222),
    [sym_macro_invocation] = STATE(3222),
    [sym_scoped_identifier] = STATE(2354),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2355),
    [sym_range_expression] = STATE(3222),
    [sym_unary_expression] = STATE(3222),
    [sym_try_expression] = STATE(3222),
    [sym_reference_expression] = STATE(3222),
    [sym_binary_expression] = STATE(3222),
    [sym_assignment_expression] = STATE(2356),
    [sym_compound_assignment_expr] = STATE(2356),
    [sym_type_cast_expression] = STATE(2356),
    [sym_return_expression] = STATE(3222),
    [sym_call_expression] = STATE(3222),
    [sym_array_expression] = STATE(3222),
    [sym_parenthesized_expression] = STATE(3222),
    [sym_tuple_expression] = STATE(3222),
    [sym_unit_expression] = STATE(3222),
    [sym_struct_expression] = STATE(3222),
    [sym_if_expression] = STATE(3222),
    [sym_if_let_expression] = STATE(3222),
    [sym_match_expression] = STATE(3222),
    [sym_while_expression] = STATE(3222),
    [sym_while_let_expression] = STATE(3222),
    [sym_loop_expression] = STATE(3222),
    [sym_for_expression] = STATE(3222),
    [sym_closure_expression] = STATE(3222),
    [sym_closure_parameters] = STATE(2357),
    [sym_loop_label] = STATE(2358),
    [sym_break_expression] = STATE(3222),
    [sym_continue_expression] = STATE(3222),
    [sym_index_expression] = STATE(3222),
    [sym_field_expression] = STATE(2359),
    [sym_unsafe_block] = STATE(3222),
    [sym_block] = STATE(3222),
    [sym__literal] = STATE(3222),
    [sym_string_literal] = STATE(3222),
    [sym_boolean_literal] = STATE(3222),
    [sym_raw_string_literal] = ACTIONS(7035),
    [sym_float_literal] = ACTIONS(7035),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5154),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_LBRACK] = ACTIONS(5158),
    [anon_sym_STAR] = ACTIONS(5160),
    [anon_sym_u8] = ACTIONS(5162),
    [anon_sym_i8] = ACTIONS(5162),
    [anon_sym_u16] = ACTIONS(5162),
    [anon_sym_i16] = ACTIONS(5162),
    [anon_sym_u32] = ACTIONS(5162),
    [anon_sym_i32] = ACTIONS(5162),
    [anon_sym_u64] = ACTIONS(5162),
    [anon_sym_i64] = ACTIONS(5162),
    [anon_sym_u128] = ACTIONS(5162),
    [anon_sym_i128] = ACTIONS(5162),
    [anon_sym_isize] = ACTIONS(5162),
    [anon_sym_usize] = ACTIONS(5162),
    [anon_sym_f32] = ACTIONS(5162),
    [anon_sym_f64] = ACTIONS(5162),
    [anon_sym_bool] = ACTIONS(5162),
    [anon_sym_str] = ACTIONS(5162),
    [anon_sym_char] = ACTIONS(5162),
    [anon_sym_AMP] = ACTIONS(5164),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_COLON_COLON] = ACTIONS(5166),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5168),
    [anon_sym_break] = ACTIONS(5170),
    [anon_sym_continue] = ACTIONS(5172),
    [anon_sym_default] = ACTIONS(5174),
    [anon_sym_for] = ACTIONS(5176),
    [anon_sym_if] = ACTIONS(5178),
    [anon_sym_loop] = ACTIONS(5180),
    [anon_sym_match] = ACTIONS(5182),
    [anon_sym_return] = ACTIONS(5184),
    [anon_sym_union] = ACTIONS(5174),
    [anon_sym_unsafe] = ACTIONS(5186),
    [anon_sym_while] = ACTIONS(5188),
    [anon_sym_move] = ACTIONS(5190),
    [sym_integer_literal] = ACTIONS(7035),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5192),
    [sym_char_literal] = ACTIONS(7035),
    [anon_sym_true] = ACTIONS(5194),
    [anon_sym_false] = ACTIONS(5194),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5196),
    [sym_self] = ACTIONS(5198),
    [sym_super] = ACTIONS(5200),
    [sym_crate] = ACTIONS(5200),
    [sym_metavariable] = ACTIONS(5202),
  },
  [2863] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_integer_literal] = ACTIONS(7037),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7039),
  },
  [2864] = {
    [sym_bracketed_type] = STATE(2351),
    [sym_generic_function] = STATE(3225),
    [sym_generic_type_with_turbofish] = STATE(2352),
    [sym__expression] = STATE(3225),
    [sym_macro_invocation] = STATE(3225),
    [sym_scoped_identifier] = STATE(2354),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2355),
    [sym_range_expression] = STATE(3225),
    [sym_unary_expression] = STATE(3225),
    [sym_try_expression] = STATE(3225),
    [sym_reference_expression] = STATE(3225),
    [sym_binary_expression] = STATE(3225),
    [sym_assignment_expression] = STATE(2356),
    [sym_compound_assignment_expr] = STATE(2356),
    [sym_type_cast_expression] = STATE(2356),
    [sym_return_expression] = STATE(3225),
    [sym_call_expression] = STATE(3225),
    [sym_array_expression] = STATE(3225),
    [sym_parenthesized_expression] = STATE(3225),
    [sym_tuple_expression] = STATE(3225),
    [sym_unit_expression] = STATE(3225),
    [sym_struct_expression] = STATE(3225),
    [sym_if_expression] = STATE(3225),
    [sym_if_let_expression] = STATE(3225),
    [sym_match_expression] = STATE(3225),
    [sym_while_expression] = STATE(3225),
    [sym_while_let_expression] = STATE(3225),
    [sym_loop_expression] = STATE(3225),
    [sym_for_expression] = STATE(3225),
    [sym_closure_expression] = STATE(3225),
    [sym_closure_parameters] = STATE(2357),
    [sym_loop_label] = STATE(2358),
    [sym_break_expression] = STATE(3225),
    [sym_continue_expression] = STATE(3225),
    [sym_index_expression] = STATE(3225),
    [sym_field_expression] = STATE(2359),
    [sym_unsafe_block] = STATE(3225),
    [sym_block] = STATE(3225),
    [sym__literal] = STATE(3225),
    [sym_string_literal] = STATE(3225),
    [sym_boolean_literal] = STATE(3225),
    [sym_raw_string_literal] = ACTIONS(7041),
    [sym_float_literal] = ACTIONS(7041),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5154),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_LBRACK] = ACTIONS(5158),
    [anon_sym_STAR] = ACTIONS(5160),
    [anon_sym_u8] = ACTIONS(5162),
    [anon_sym_i8] = ACTIONS(5162),
    [anon_sym_u16] = ACTIONS(5162),
    [anon_sym_i16] = ACTIONS(5162),
    [anon_sym_u32] = ACTIONS(5162),
    [anon_sym_i32] = ACTIONS(5162),
    [anon_sym_u64] = ACTIONS(5162),
    [anon_sym_i64] = ACTIONS(5162),
    [anon_sym_u128] = ACTIONS(5162),
    [anon_sym_i128] = ACTIONS(5162),
    [anon_sym_isize] = ACTIONS(5162),
    [anon_sym_usize] = ACTIONS(5162),
    [anon_sym_f32] = ACTIONS(5162),
    [anon_sym_f64] = ACTIONS(5162),
    [anon_sym_bool] = ACTIONS(5162),
    [anon_sym_str] = ACTIONS(5162),
    [anon_sym_char] = ACTIONS(5162),
    [anon_sym_AMP] = ACTIONS(5164),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_COLON_COLON] = ACTIONS(5166),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5168),
    [anon_sym_break] = ACTIONS(5170),
    [anon_sym_continue] = ACTIONS(5172),
    [anon_sym_default] = ACTIONS(5174),
    [anon_sym_for] = ACTIONS(5176),
    [anon_sym_if] = ACTIONS(5178),
    [anon_sym_loop] = ACTIONS(5180),
    [anon_sym_match] = ACTIONS(5182),
    [anon_sym_return] = ACTIONS(5184),
    [anon_sym_union] = ACTIONS(5174),
    [anon_sym_unsafe] = ACTIONS(5186),
    [anon_sym_while] = ACTIONS(5188),
    [anon_sym_move] = ACTIONS(5190),
    [sym_integer_literal] = ACTIONS(7041),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5192),
    [sym_char_literal] = ACTIONS(7041),
    [anon_sym_true] = ACTIONS(5194),
    [anon_sym_false] = ACTIONS(5194),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5196),
    [sym_self] = ACTIONS(5198),
    [sym_super] = ACTIONS(5200),
    [sym_crate] = ACTIONS(5200),
    [sym_metavariable] = ACTIONS(5202),
  },
  [2865] = {
    [sym_bracketed_type] = STATE(2351),
    [sym_generic_function] = STATE(3226),
    [sym_generic_type_with_turbofish] = STATE(2352),
    [sym__expression] = STATE(3226),
    [sym_macro_invocation] = STATE(3226),
    [sym_scoped_identifier] = STATE(2354),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2355),
    [sym_range_expression] = STATE(3226),
    [sym_unary_expression] = STATE(3226),
    [sym_try_expression] = STATE(3226),
    [sym_reference_expression] = STATE(3226),
    [sym_binary_expression] = STATE(3226),
    [sym_assignment_expression] = STATE(2356),
    [sym_compound_assignment_expr] = STATE(2356),
    [sym_type_cast_expression] = STATE(2356),
    [sym_return_expression] = STATE(3226),
    [sym_call_expression] = STATE(3226),
    [sym_array_expression] = STATE(3226),
    [sym_parenthesized_expression] = STATE(3226),
    [sym_tuple_expression] = STATE(3226),
    [sym_unit_expression] = STATE(3226),
    [sym_struct_expression] = STATE(3226),
    [sym_if_expression] = STATE(3226),
    [sym_if_let_expression] = STATE(3226),
    [sym_match_expression] = STATE(3226),
    [sym_while_expression] = STATE(3226),
    [sym_while_let_expression] = STATE(3226),
    [sym_loop_expression] = STATE(3226),
    [sym_for_expression] = STATE(3226),
    [sym_closure_expression] = STATE(3226),
    [sym_closure_parameters] = STATE(2357),
    [sym_loop_label] = STATE(2358),
    [sym_break_expression] = STATE(3226),
    [sym_continue_expression] = STATE(3226),
    [sym_index_expression] = STATE(3226),
    [sym_field_expression] = STATE(2359),
    [sym_unsafe_block] = STATE(3226),
    [sym_block] = STATE(3226),
    [sym__literal] = STATE(3226),
    [sym_string_literal] = STATE(3226),
    [sym_boolean_literal] = STATE(3226),
    [sym_raw_string_literal] = ACTIONS(7043),
    [sym_float_literal] = ACTIONS(7043),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5154),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_LBRACK] = ACTIONS(5158),
    [anon_sym_STAR] = ACTIONS(5160),
    [anon_sym_u8] = ACTIONS(5162),
    [anon_sym_i8] = ACTIONS(5162),
    [anon_sym_u16] = ACTIONS(5162),
    [anon_sym_i16] = ACTIONS(5162),
    [anon_sym_u32] = ACTIONS(5162),
    [anon_sym_i32] = ACTIONS(5162),
    [anon_sym_u64] = ACTIONS(5162),
    [anon_sym_i64] = ACTIONS(5162),
    [anon_sym_u128] = ACTIONS(5162),
    [anon_sym_i128] = ACTIONS(5162),
    [anon_sym_isize] = ACTIONS(5162),
    [anon_sym_usize] = ACTIONS(5162),
    [anon_sym_f32] = ACTIONS(5162),
    [anon_sym_f64] = ACTIONS(5162),
    [anon_sym_bool] = ACTIONS(5162),
    [anon_sym_str] = ACTIONS(5162),
    [anon_sym_char] = ACTIONS(5162),
    [anon_sym_AMP] = ACTIONS(5164),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_COLON_COLON] = ACTIONS(5166),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5168),
    [anon_sym_break] = ACTIONS(5170),
    [anon_sym_continue] = ACTIONS(5172),
    [anon_sym_default] = ACTIONS(5174),
    [anon_sym_for] = ACTIONS(5176),
    [anon_sym_if] = ACTIONS(5178),
    [anon_sym_loop] = ACTIONS(5180),
    [anon_sym_match] = ACTIONS(5182),
    [anon_sym_return] = ACTIONS(5184),
    [anon_sym_union] = ACTIONS(5174),
    [anon_sym_unsafe] = ACTIONS(5186),
    [anon_sym_while] = ACTIONS(5188),
    [anon_sym_move] = ACTIONS(5190),
    [sym_integer_literal] = ACTIONS(7043),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5192),
    [sym_char_literal] = ACTIONS(7043),
    [anon_sym_true] = ACTIONS(5194),
    [anon_sym_false] = ACTIONS(5194),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5196),
    [sym_self] = ACTIONS(5198),
    [sym_super] = ACTIONS(5200),
    [sym_crate] = ACTIONS(5200),
    [sym_metavariable] = ACTIONS(5202),
  },
  [2866] = {
    [sym_bracketed_type] = STATE(2351),
    [sym_generic_function] = STATE(3227),
    [sym_generic_type_with_turbofish] = STATE(2352),
    [sym__expression] = STATE(3227),
    [sym_macro_invocation] = STATE(3227),
    [sym_scoped_identifier] = STATE(2354),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2355),
    [sym_range_expression] = STATE(3227),
    [sym_unary_expression] = STATE(3227),
    [sym_try_expression] = STATE(3227),
    [sym_reference_expression] = STATE(3227),
    [sym_binary_expression] = STATE(3227),
    [sym_assignment_expression] = STATE(2356),
    [sym_compound_assignment_expr] = STATE(2356),
    [sym_type_cast_expression] = STATE(2356),
    [sym_return_expression] = STATE(3227),
    [sym_call_expression] = STATE(3227),
    [sym_array_expression] = STATE(3227),
    [sym_parenthesized_expression] = STATE(3227),
    [sym_tuple_expression] = STATE(3227),
    [sym_unit_expression] = STATE(3227),
    [sym_struct_expression] = STATE(3227),
    [sym_if_expression] = STATE(3227),
    [sym_if_let_expression] = STATE(3227),
    [sym_match_expression] = STATE(3227),
    [sym_while_expression] = STATE(3227),
    [sym_while_let_expression] = STATE(3227),
    [sym_loop_expression] = STATE(3227),
    [sym_for_expression] = STATE(3227),
    [sym_closure_expression] = STATE(3227),
    [sym_closure_parameters] = STATE(2357),
    [sym_loop_label] = STATE(2358),
    [sym_break_expression] = STATE(3227),
    [sym_continue_expression] = STATE(3227),
    [sym_index_expression] = STATE(3227),
    [sym_field_expression] = STATE(2359),
    [sym_unsafe_block] = STATE(3227),
    [sym_block] = STATE(3227),
    [sym__literal] = STATE(3227),
    [sym_string_literal] = STATE(3227),
    [sym_boolean_literal] = STATE(3227),
    [sym_raw_string_literal] = ACTIONS(7045),
    [sym_float_literal] = ACTIONS(7045),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5154),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_LBRACK] = ACTIONS(5158),
    [anon_sym_STAR] = ACTIONS(5160),
    [anon_sym_u8] = ACTIONS(5162),
    [anon_sym_i8] = ACTIONS(5162),
    [anon_sym_u16] = ACTIONS(5162),
    [anon_sym_i16] = ACTIONS(5162),
    [anon_sym_u32] = ACTIONS(5162),
    [anon_sym_i32] = ACTIONS(5162),
    [anon_sym_u64] = ACTIONS(5162),
    [anon_sym_i64] = ACTIONS(5162),
    [anon_sym_u128] = ACTIONS(5162),
    [anon_sym_i128] = ACTIONS(5162),
    [anon_sym_isize] = ACTIONS(5162),
    [anon_sym_usize] = ACTIONS(5162),
    [anon_sym_f32] = ACTIONS(5162),
    [anon_sym_f64] = ACTIONS(5162),
    [anon_sym_bool] = ACTIONS(5162),
    [anon_sym_str] = ACTIONS(5162),
    [anon_sym_char] = ACTIONS(5162),
    [anon_sym_AMP] = ACTIONS(5164),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_COLON_COLON] = ACTIONS(5166),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5168),
    [anon_sym_break] = ACTIONS(5170),
    [anon_sym_continue] = ACTIONS(5172),
    [anon_sym_default] = ACTIONS(5174),
    [anon_sym_for] = ACTIONS(5176),
    [anon_sym_if] = ACTIONS(5178),
    [anon_sym_loop] = ACTIONS(5180),
    [anon_sym_match] = ACTIONS(5182),
    [anon_sym_return] = ACTIONS(5184),
    [anon_sym_union] = ACTIONS(5174),
    [anon_sym_unsafe] = ACTIONS(5186),
    [anon_sym_while] = ACTIONS(5188),
    [anon_sym_move] = ACTIONS(5190),
    [sym_integer_literal] = ACTIONS(7045),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5192),
    [sym_char_literal] = ACTIONS(7045),
    [anon_sym_true] = ACTIONS(5194),
    [anon_sym_false] = ACTIONS(5194),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5196),
    [sym_self] = ACTIONS(5198),
    [sym_super] = ACTIONS(5200),
    [sym_crate] = ACTIONS(5200),
    [sym_metavariable] = ACTIONS(5202),
  },
  [2867] = {
    [sym_bracketed_type] = STATE(2351),
    [sym_generic_function] = STATE(3228),
    [sym_generic_type_with_turbofish] = STATE(2352),
    [sym__expression] = STATE(3228),
    [sym_macro_invocation] = STATE(3228),
    [sym_scoped_identifier] = STATE(2354),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2355),
    [sym_range_expression] = STATE(3228),
    [sym_unary_expression] = STATE(3228),
    [sym_try_expression] = STATE(3228),
    [sym_reference_expression] = STATE(3228),
    [sym_binary_expression] = STATE(3228),
    [sym_assignment_expression] = STATE(2356),
    [sym_compound_assignment_expr] = STATE(2356),
    [sym_type_cast_expression] = STATE(2356),
    [sym_return_expression] = STATE(3228),
    [sym_call_expression] = STATE(3228),
    [sym_array_expression] = STATE(3228),
    [sym_parenthesized_expression] = STATE(3228),
    [sym_tuple_expression] = STATE(3228),
    [sym_unit_expression] = STATE(3228),
    [sym_struct_expression] = STATE(3228),
    [sym_if_expression] = STATE(3228),
    [sym_if_let_expression] = STATE(3228),
    [sym_match_expression] = STATE(3228),
    [sym_while_expression] = STATE(3228),
    [sym_while_let_expression] = STATE(3228),
    [sym_loop_expression] = STATE(3228),
    [sym_for_expression] = STATE(3228),
    [sym_closure_expression] = STATE(3228),
    [sym_closure_parameters] = STATE(2357),
    [sym_loop_label] = STATE(2358),
    [sym_break_expression] = STATE(3228),
    [sym_continue_expression] = STATE(3228),
    [sym_index_expression] = STATE(3228),
    [sym_field_expression] = STATE(2359),
    [sym_unsafe_block] = STATE(3228),
    [sym_block] = STATE(3228),
    [sym__literal] = STATE(3228),
    [sym_string_literal] = STATE(3228),
    [sym_boolean_literal] = STATE(3228),
    [sym_raw_string_literal] = ACTIONS(7047),
    [sym_float_literal] = ACTIONS(7047),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5154),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_LBRACK] = ACTIONS(5158),
    [anon_sym_STAR] = ACTIONS(5160),
    [anon_sym_u8] = ACTIONS(5162),
    [anon_sym_i8] = ACTIONS(5162),
    [anon_sym_u16] = ACTIONS(5162),
    [anon_sym_i16] = ACTIONS(5162),
    [anon_sym_u32] = ACTIONS(5162),
    [anon_sym_i32] = ACTIONS(5162),
    [anon_sym_u64] = ACTIONS(5162),
    [anon_sym_i64] = ACTIONS(5162),
    [anon_sym_u128] = ACTIONS(5162),
    [anon_sym_i128] = ACTIONS(5162),
    [anon_sym_isize] = ACTIONS(5162),
    [anon_sym_usize] = ACTIONS(5162),
    [anon_sym_f32] = ACTIONS(5162),
    [anon_sym_f64] = ACTIONS(5162),
    [anon_sym_bool] = ACTIONS(5162),
    [anon_sym_str] = ACTIONS(5162),
    [anon_sym_char] = ACTIONS(5162),
    [anon_sym_AMP] = ACTIONS(5164),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_COLON_COLON] = ACTIONS(5166),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5168),
    [anon_sym_break] = ACTIONS(5170),
    [anon_sym_continue] = ACTIONS(5172),
    [anon_sym_default] = ACTIONS(5174),
    [anon_sym_for] = ACTIONS(5176),
    [anon_sym_if] = ACTIONS(5178),
    [anon_sym_loop] = ACTIONS(5180),
    [anon_sym_match] = ACTIONS(5182),
    [anon_sym_return] = ACTIONS(5184),
    [anon_sym_union] = ACTIONS(5174),
    [anon_sym_unsafe] = ACTIONS(5186),
    [anon_sym_while] = ACTIONS(5188),
    [anon_sym_move] = ACTIONS(5190),
    [sym_integer_literal] = ACTIONS(7047),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5192),
    [sym_char_literal] = ACTIONS(7047),
    [anon_sym_true] = ACTIONS(5194),
    [anon_sym_false] = ACTIONS(5194),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5196),
    [sym_self] = ACTIONS(5198),
    [sym_super] = ACTIONS(5200),
    [sym_crate] = ACTIONS(5200),
    [sym_metavariable] = ACTIONS(5202),
  },
  [2868] = {
    [sym_bracketed_type] = STATE(2351),
    [sym_generic_function] = STATE(3229),
    [sym_generic_type_with_turbofish] = STATE(2352),
    [sym__expression] = STATE(3229),
    [sym_macro_invocation] = STATE(3229),
    [sym_scoped_identifier] = STATE(2354),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2355),
    [sym_range_expression] = STATE(3229),
    [sym_unary_expression] = STATE(3229),
    [sym_try_expression] = STATE(3229),
    [sym_reference_expression] = STATE(3229),
    [sym_binary_expression] = STATE(3229),
    [sym_assignment_expression] = STATE(2356),
    [sym_compound_assignment_expr] = STATE(2356),
    [sym_type_cast_expression] = STATE(2356),
    [sym_return_expression] = STATE(3229),
    [sym_call_expression] = STATE(3229),
    [sym_array_expression] = STATE(3229),
    [sym_parenthesized_expression] = STATE(3229),
    [sym_tuple_expression] = STATE(3229),
    [sym_unit_expression] = STATE(3229),
    [sym_struct_expression] = STATE(3229),
    [sym_if_expression] = STATE(3229),
    [sym_if_let_expression] = STATE(3229),
    [sym_match_expression] = STATE(3229),
    [sym_while_expression] = STATE(3229),
    [sym_while_let_expression] = STATE(3229),
    [sym_loop_expression] = STATE(3229),
    [sym_for_expression] = STATE(3229),
    [sym_closure_expression] = STATE(3229),
    [sym_closure_parameters] = STATE(2357),
    [sym_loop_label] = STATE(2358),
    [sym_break_expression] = STATE(3229),
    [sym_continue_expression] = STATE(3229),
    [sym_index_expression] = STATE(3229),
    [sym_field_expression] = STATE(2359),
    [sym_unsafe_block] = STATE(3229),
    [sym_block] = STATE(3229),
    [sym__literal] = STATE(3229),
    [sym_string_literal] = STATE(3229),
    [sym_boolean_literal] = STATE(3229),
    [sym_raw_string_literal] = ACTIONS(7049),
    [sym_float_literal] = ACTIONS(7049),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5154),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_LBRACK] = ACTIONS(5158),
    [anon_sym_STAR] = ACTIONS(5160),
    [anon_sym_u8] = ACTIONS(5162),
    [anon_sym_i8] = ACTIONS(5162),
    [anon_sym_u16] = ACTIONS(5162),
    [anon_sym_i16] = ACTIONS(5162),
    [anon_sym_u32] = ACTIONS(5162),
    [anon_sym_i32] = ACTIONS(5162),
    [anon_sym_u64] = ACTIONS(5162),
    [anon_sym_i64] = ACTIONS(5162),
    [anon_sym_u128] = ACTIONS(5162),
    [anon_sym_i128] = ACTIONS(5162),
    [anon_sym_isize] = ACTIONS(5162),
    [anon_sym_usize] = ACTIONS(5162),
    [anon_sym_f32] = ACTIONS(5162),
    [anon_sym_f64] = ACTIONS(5162),
    [anon_sym_bool] = ACTIONS(5162),
    [anon_sym_str] = ACTIONS(5162),
    [anon_sym_char] = ACTIONS(5162),
    [anon_sym_AMP] = ACTIONS(5164),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_COLON_COLON] = ACTIONS(5166),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5168),
    [anon_sym_break] = ACTIONS(5170),
    [anon_sym_continue] = ACTIONS(5172),
    [anon_sym_default] = ACTIONS(5174),
    [anon_sym_for] = ACTIONS(5176),
    [anon_sym_if] = ACTIONS(5178),
    [anon_sym_loop] = ACTIONS(5180),
    [anon_sym_match] = ACTIONS(5182),
    [anon_sym_return] = ACTIONS(5184),
    [anon_sym_union] = ACTIONS(5174),
    [anon_sym_unsafe] = ACTIONS(5186),
    [anon_sym_while] = ACTIONS(5188),
    [anon_sym_move] = ACTIONS(5190),
    [sym_integer_literal] = ACTIONS(7049),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5192),
    [sym_char_literal] = ACTIONS(7049),
    [anon_sym_true] = ACTIONS(5194),
    [anon_sym_false] = ACTIONS(5194),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5196),
    [sym_self] = ACTIONS(5198),
    [sym_super] = ACTIONS(5200),
    [sym_crate] = ACTIONS(5200),
    [sym_metavariable] = ACTIONS(5202),
  },
  [2869] = {
    [sym_bracketed_type] = STATE(2351),
    [sym_generic_function] = STATE(3230),
    [sym_generic_type_with_turbofish] = STATE(2352),
    [sym__expression] = STATE(3230),
    [sym_macro_invocation] = STATE(3230),
    [sym_scoped_identifier] = STATE(2354),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2355),
    [sym_range_expression] = STATE(3230),
    [sym_unary_expression] = STATE(3230),
    [sym_try_expression] = STATE(3230),
    [sym_reference_expression] = STATE(3230),
    [sym_binary_expression] = STATE(3230),
    [sym_assignment_expression] = STATE(2356),
    [sym_compound_assignment_expr] = STATE(2356),
    [sym_type_cast_expression] = STATE(2356),
    [sym_return_expression] = STATE(3230),
    [sym_call_expression] = STATE(3230),
    [sym_array_expression] = STATE(3230),
    [sym_parenthesized_expression] = STATE(3230),
    [sym_tuple_expression] = STATE(3230),
    [sym_unit_expression] = STATE(3230),
    [sym_struct_expression] = STATE(3230),
    [sym_if_expression] = STATE(3230),
    [sym_if_let_expression] = STATE(3230),
    [sym_match_expression] = STATE(3230),
    [sym_while_expression] = STATE(3230),
    [sym_while_let_expression] = STATE(3230),
    [sym_loop_expression] = STATE(3230),
    [sym_for_expression] = STATE(3230),
    [sym_closure_expression] = STATE(3230),
    [sym_closure_parameters] = STATE(2357),
    [sym_loop_label] = STATE(2358),
    [sym_break_expression] = STATE(3230),
    [sym_continue_expression] = STATE(3230),
    [sym_index_expression] = STATE(3230),
    [sym_field_expression] = STATE(2359),
    [sym_unsafe_block] = STATE(3230),
    [sym_block] = STATE(3230),
    [sym__literal] = STATE(3230),
    [sym_string_literal] = STATE(3230),
    [sym_boolean_literal] = STATE(3230),
    [sym_raw_string_literal] = ACTIONS(7051),
    [sym_float_literal] = ACTIONS(7051),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5154),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_LBRACK] = ACTIONS(5158),
    [anon_sym_STAR] = ACTIONS(5160),
    [anon_sym_u8] = ACTIONS(5162),
    [anon_sym_i8] = ACTIONS(5162),
    [anon_sym_u16] = ACTIONS(5162),
    [anon_sym_i16] = ACTIONS(5162),
    [anon_sym_u32] = ACTIONS(5162),
    [anon_sym_i32] = ACTIONS(5162),
    [anon_sym_u64] = ACTIONS(5162),
    [anon_sym_i64] = ACTIONS(5162),
    [anon_sym_u128] = ACTIONS(5162),
    [anon_sym_i128] = ACTIONS(5162),
    [anon_sym_isize] = ACTIONS(5162),
    [anon_sym_usize] = ACTIONS(5162),
    [anon_sym_f32] = ACTIONS(5162),
    [anon_sym_f64] = ACTIONS(5162),
    [anon_sym_bool] = ACTIONS(5162),
    [anon_sym_str] = ACTIONS(5162),
    [anon_sym_char] = ACTIONS(5162),
    [anon_sym_AMP] = ACTIONS(5164),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_COLON_COLON] = ACTIONS(5166),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5168),
    [anon_sym_break] = ACTIONS(5170),
    [anon_sym_continue] = ACTIONS(5172),
    [anon_sym_default] = ACTIONS(5174),
    [anon_sym_for] = ACTIONS(5176),
    [anon_sym_if] = ACTIONS(5178),
    [anon_sym_loop] = ACTIONS(5180),
    [anon_sym_match] = ACTIONS(5182),
    [anon_sym_return] = ACTIONS(5184),
    [anon_sym_union] = ACTIONS(5174),
    [anon_sym_unsafe] = ACTIONS(5186),
    [anon_sym_while] = ACTIONS(5188),
    [anon_sym_move] = ACTIONS(5190),
    [sym_integer_literal] = ACTIONS(7051),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5192),
    [sym_char_literal] = ACTIONS(7051),
    [anon_sym_true] = ACTIONS(5194),
    [anon_sym_false] = ACTIONS(5194),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5196),
    [sym_self] = ACTIONS(5198),
    [sym_super] = ACTIONS(5200),
    [sym_crate] = ACTIONS(5200),
    [sym_metavariable] = ACTIONS(5202),
  },
  [2870] = {
    [sym_bracketed_type] = STATE(2351),
    [sym_generic_function] = STATE(3231),
    [sym_generic_type_with_turbofish] = STATE(2352),
    [sym__expression] = STATE(3231),
    [sym_macro_invocation] = STATE(3231),
    [sym_scoped_identifier] = STATE(2354),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2355),
    [sym_range_expression] = STATE(3231),
    [sym_unary_expression] = STATE(3231),
    [sym_try_expression] = STATE(3231),
    [sym_reference_expression] = STATE(3231),
    [sym_binary_expression] = STATE(3231),
    [sym_assignment_expression] = STATE(2356),
    [sym_compound_assignment_expr] = STATE(2356),
    [sym_type_cast_expression] = STATE(2356),
    [sym_return_expression] = STATE(3231),
    [sym_call_expression] = STATE(3231),
    [sym_array_expression] = STATE(3231),
    [sym_parenthesized_expression] = STATE(3231),
    [sym_tuple_expression] = STATE(3231),
    [sym_unit_expression] = STATE(3231),
    [sym_struct_expression] = STATE(3231),
    [sym_if_expression] = STATE(3231),
    [sym_if_let_expression] = STATE(3231),
    [sym_match_expression] = STATE(3231),
    [sym_while_expression] = STATE(3231),
    [sym_while_let_expression] = STATE(3231),
    [sym_loop_expression] = STATE(3231),
    [sym_for_expression] = STATE(3231),
    [sym_closure_expression] = STATE(3231),
    [sym_closure_parameters] = STATE(2357),
    [sym_loop_label] = STATE(2358),
    [sym_break_expression] = STATE(3231),
    [sym_continue_expression] = STATE(3231),
    [sym_index_expression] = STATE(3231),
    [sym_field_expression] = STATE(2359),
    [sym_unsafe_block] = STATE(3231),
    [sym_block] = STATE(3231),
    [sym__literal] = STATE(3231),
    [sym_string_literal] = STATE(3231),
    [sym_boolean_literal] = STATE(3231),
    [sym_raw_string_literal] = ACTIONS(7053),
    [sym_float_literal] = ACTIONS(7053),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5154),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_LBRACK] = ACTIONS(5158),
    [anon_sym_STAR] = ACTIONS(5160),
    [anon_sym_u8] = ACTIONS(5162),
    [anon_sym_i8] = ACTIONS(5162),
    [anon_sym_u16] = ACTIONS(5162),
    [anon_sym_i16] = ACTIONS(5162),
    [anon_sym_u32] = ACTIONS(5162),
    [anon_sym_i32] = ACTIONS(5162),
    [anon_sym_u64] = ACTIONS(5162),
    [anon_sym_i64] = ACTIONS(5162),
    [anon_sym_u128] = ACTIONS(5162),
    [anon_sym_i128] = ACTIONS(5162),
    [anon_sym_isize] = ACTIONS(5162),
    [anon_sym_usize] = ACTIONS(5162),
    [anon_sym_f32] = ACTIONS(5162),
    [anon_sym_f64] = ACTIONS(5162),
    [anon_sym_bool] = ACTIONS(5162),
    [anon_sym_str] = ACTIONS(5162),
    [anon_sym_char] = ACTIONS(5162),
    [anon_sym_AMP] = ACTIONS(5164),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_COLON_COLON] = ACTIONS(5166),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5168),
    [anon_sym_break] = ACTIONS(5170),
    [anon_sym_continue] = ACTIONS(5172),
    [anon_sym_default] = ACTIONS(5174),
    [anon_sym_for] = ACTIONS(5176),
    [anon_sym_if] = ACTIONS(5178),
    [anon_sym_loop] = ACTIONS(5180),
    [anon_sym_match] = ACTIONS(5182),
    [anon_sym_return] = ACTIONS(5184),
    [anon_sym_union] = ACTIONS(5174),
    [anon_sym_unsafe] = ACTIONS(5186),
    [anon_sym_while] = ACTIONS(5188),
    [anon_sym_move] = ACTIONS(5190),
    [sym_integer_literal] = ACTIONS(7053),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5192),
    [sym_char_literal] = ACTIONS(7053),
    [anon_sym_true] = ACTIONS(5194),
    [anon_sym_false] = ACTIONS(5194),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5196),
    [sym_self] = ACTIONS(5198),
    [sym_super] = ACTIONS(5200),
    [sym_crate] = ACTIONS(5200),
    [sym_metavariable] = ACTIONS(5202),
  },
  [2871] = {
    [sym_bracketed_type] = STATE(2351),
    [sym_generic_function] = STATE(3232),
    [sym_generic_type_with_turbofish] = STATE(2352),
    [sym__expression] = STATE(3232),
    [sym_macro_invocation] = STATE(3232),
    [sym_scoped_identifier] = STATE(2354),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2355),
    [sym_range_expression] = STATE(3232),
    [sym_unary_expression] = STATE(3232),
    [sym_try_expression] = STATE(3232),
    [sym_reference_expression] = STATE(3232),
    [sym_binary_expression] = STATE(3232),
    [sym_assignment_expression] = STATE(2356),
    [sym_compound_assignment_expr] = STATE(2356),
    [sym_type_cast_expression] = STATE(2356),
    [sym_return_expression] = STATE(3232),
    [sym_call_expression] = STATE(3232),
    [sym_array_expression] = STATE(3232),
    [sym_parenthesized_expression] = STATE(3232),
    [sym_tuple_expression] = STATE(3232),
    [sym_unit_expression] = STATE(3232),
    [sym_struct_expression] = STATE(3232),
    [sym_if_expression] = STATE(3232),
    [sym_if_let_expression] = STATE(3232),
    [sym_match_expression] = STATE(3232),
    [sym_while_expression] = STATE(3232),
    [sym_while_let_expression] = STATE(3232),
    [sym_loop_expression] = STATE(3232),
    [sym_for_expression] = STATE(3232),
    [sym_closure_expression] = STATE(3232),
    [sym_closure_parameters] = STATE(2357),
    [sym_loop_label] = STATE(2358),
    [sym_break_expression] = STATE(3232),
    [sym_continue_expression] = STATE(3232),
    [sym_index_expression] = STATE(3232),
    [sym_field_expression] = STATE(2359),
    [sym_unsafe_block] = STATE(3232),
    [sym_block] = STATE(3232),
    [sym__literal] = STATE(3232),
    [sym_string_literal] = STATE(3232),
    [sym_boolean_literal] = STATE(3232),
    [sym_raw_string_literal] = ACTIONS(7055),
    [sym_float_literal] = ACTIONS(7055),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5154),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_LBRACK] = ACTIONS(5158),
    [anon_sym_STAR] = ACTIONS(5160),
    [anon_sym_u8] = ACTIONS(5162),
    [anon_sym_i8] = ACTIONS(5162),
    [anon_sym_u16] = ACTIONS(5162),
    [anon_sym_i16] = ACTIONS(5162),
    [anon_sym_u32] = ACTIONS(5162),
    [anon_sym_i32] = ACTIONS(5162),
    [anon_sym_u64] = ACTIONS(5162),
    [anon_sym_i64] = ACTIONS(5162),
    [anon_sym_u128] = ACTIONS(5162),
    [anon_sym_i128] = ACTIONS(5162),
    [anon_sym_isize] = ACTIONS(5162),
    [anon_sym_usize] = ACTIONS(5162),
    [anon_sym_f32] = ACTIONS(5162),
    [anon_sym_f64] = ACTIONS(5162),
    [anon_sym_bool] = ACTIONS(5162),
    [anon_sym_str] = ACTIONS(5162),
    [anon_sym_char] = ACTIONS(5162),
    [anon_sym_AMP] = ACTIONS(5164),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_COLON_COLON] = ACTIONS(5166),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5168),
    [anon_sym_break] = ACTIONS(5170),
    [anon_sym_continue] = ACTIONS(5172),
    [anon_sym_default] = ACTIONS(5174),
    [anon_sym_for] = ACTIONS(5176),
    [anon_sym_if] = ACTIONS(5178),
    [anon_sym_loop] = ACTIONS(5180),
    [anon_sym_match] = ACTIONS(5182),
    [anon_sym_return] = ACTIONS(5184),
    [anon_sym_union] = ACTIONS(5174),
    [anon_sym_unsafe] = ACTIONS(5186),
    [anon_sym_while] = ACTIONS(5188),
    [anon_sym_move] = ACTIONS(5190),
    [sym_integer_literal] = ACTIONS(7055),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5192),
    [sym_char_literal] = ACTIONS(7055),
    [anon_sym_true] = ACTIONS(5194),
    [anon_sym_false] = ACTIONS(5194),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5196),
    [sym_self] = ACTIONS(5198),
    [sym_super] = ACTIONS(5200),
    [sym_crate] = ACTIONS(5200),
    [sym_metavariable] = ACTIONS(5202),
  },
  [2872] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_EQ_GT] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_DOT] = ACTIONS(1283),
    [anon_sym_DASH_EQ] = ACTIONS(1281),
    [anon_sym_BANG_EQ] = ACTIONS(1281),
    [anon_sym_STAR_EQ] = ACTIONS(1281),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_SLASH_EQ] = ACTIONS(1281),
    [anon_sym_AMP_AMP] = ACTIONS(1281),
    [anon_sym_AMP_EQ] = ACTIONS(1281),
    [anon_sym_PERCENT] = ACTIONS(1283),
    [anon_sym_PERCENT_EQ] = ACTIONS(1281),
    [anon_sym_CARET] = ACTIONS(1283),
    [anon_sym_CARET_EQ] = ACTIONS(1281),
    [anon_sym_PLUS_EQ] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_LT_LT] = ACTIONS(1283),
    [anon_sym_LT_LT_EQ] = ACTIONS(1281),
    [anon_sym_LT_EQ] = ACTIONS(1281),
    [anon_sym_EQ] = ACTIONS(1283),
    [anon_sym_EQ_EQ] = ACTIONS(1281),
    [anon_sym_GT] = ACTIONS(1283),
    [anon_sym_GT_EQ] = ACTIONS(1281),
    [anon_sym_GT_GT] = ACTIONS(1283),
    [anon_sym_GT_GT_EQ] = ACTIONS(1281),
    [anon_sym_PIPE] = ACTIONS(1283),
    [anon_sym_PIPE_EQ] = ACTIONS(1281),
    [anon_sym_PIPE_PIPE] = ACTIONS(1281),
    [anon_sym_QMARK] = ACTIONS(1281),
    [anon_sym_DOT_DOT] = ACTIONS(1283),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1281),
    [anon_sym_as] = ACTIONS(1281),
    [sym_line_comment] = ACTIONS(7),
  },
  [2873] = {
    [sym_bracketed_type] = STATE(2351),
    [sym_generic_function] = STATE(3233),
    [sym_generic_type_with_turbofish] = STATE(2352),
    [sym__expression] = STATE(3233),
    [sym_macro_invocation] = STATE(3233),
    [sym_scoped_identifier] = STATE(2354),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2355),
    [sym_range_expression] = STATE(3233),
    [sym_unary_expression] = STATE(3233),
    [sym_try_expression] = STATE(3233),
    [sym_reference_expression] = STATE(3233),
    [sym_binary_expression] = STATE(3233),
    [sym_assignment_expression] = STATE(2356),
    [sym_compound_assignment_expr] = STATE(2356),
    [sym_type_cast_expression] = STATE(2356),
    [sym_return_expression] = STATE(3233),
    [sym_call_expression] = STATE(3233),
    [sym_array_expression] = STATE(3233),
    [sym_parenthesized_expression] = STATE(3233),
    [sym_tuple_expression] = STATE(3233),
    [sym_unit_expression] = STATE(3233),
    [sym_struct_expression] = STATE(3233),
    [sym_if_expression] = STATE(3233),
    [sym_if_let_expression] = STATE(3233),
    [sym_match_expression] = STATE(3233),
    [sym_while_expression] = STATE(3233),
    [sym_while_let_expression] = STATE(3233),
    [sym_loop_expression] = STATE(3233),
    [sym_for_expression] = STATE(3233),
    [sym_closure_expression] = STATE(3233),
    [sym_closure_parameters] = STATE(2357),
    [sym_loop_label] = STATE(2358),
    [sym_break_expression] = STATE(3233),
    [sym_continue_expression] = STATE(3233),
    [sym_index_expression] = STATE(3233),
    [sym_field_expression] = STATE(2359),
    [sym_unsafe_block] = STATE(3233),
    [sym_block] = STATE(3233),
    [sym__literal] = STATE(3233),
    [sym_string_literal] = STATE(3233),
    [sym_boolean_literal] = STATE(3233),
    [sym_raw_string_literal] = ACTIONS(7057),
    [sym_float_literal] = ACTIONS(7057),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(909),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(911),
    [anon_sym_STAR] = ACTIONS(911),
    [anon_sym_u8] = ACTIONS(5162),
    [anon_sym_i8] = ACTIONS(5162),
    [anon_sym_u16] = ACTIONS(5162),
    [anon_sym_i16] = ACTIONS(5162),
    [anon_sym_u32] = ACTIONS(5162),
    [anon_sym_i32] = ACTIONS(5162),
    [anon_sym_u64] = ACTIONS(5162),
    [anon_sym_i64] = ACTIONS(5162),
    [anon_sym_u128] = ACTIONS(5162),
    [anon_sym_i128] = ACTIONS(5162),
    [anon_sym_isize] = ACTIONS(5162),
    [anon_sym_usize] = ACTIONS(5162),
    [anon_sym_f32] = ACTIONS(5162),
    [anon_sym_f64] = ACTIONS(5162),
    [anon_sym_bool] = ACTIONS(5162),
    [anon_sym_str] = ACTIONS(5162),
    [anon_sym_char] = ACTIONS(5162),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_DASH] = ACTIONS(911),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_COLON_COLON] = ACTIONS(5166),
    [anon_sym_BANG] = ACTIONS(6276),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(911),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(911),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_LT_LT] = ACTIONS(911),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(909),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_EQ_EQ] = ACTIONS(909),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(911),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_as] = ACTIONS(911),
    [anon_sym_break] = ACTIONS(5170),
    [anon_sym_continue] = ACTIONS(5172),
    [anon_sym_default] = ACTIONS(5174),
    [anon_sym_for] = ACTIONS(5176),
    [anon_sym_if] = ACTIONS(5178),
    [anon_sym_loop] = ACTIONS(5180),
    [anon_sym_match] = ACTIONS(5182),
    [anon_sym_return] = ACTIONS(5184),
    [anon_sym_union] = ACTIONS(5174),
    [anon_sym_unsafe] = ACTIONS(5186),
    [anon_sym_while] = ACTIONS(5188),
    [anon_sym_move] = ACTIONS(5190),
    [sym_integer_literal] = ACTIONS(7057),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5192),
    [sym_char_literal] = ACTIONS(7057),
    [anon_sym_true] = ACTIONS(5194),
    [anon_sym_false] = ACTIONS(5194),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5196),
    [sym_self] = ACTIONS(5198),
    [sym_super] = ACTIONS(5200),
    [sym_crate] = ACTIONS(5200),
    [sym_metavariable] = ACTIONS(5202),
  },
  [2874] = {
    [sym_bracketed_type] = STATE(2351),
    [sym_generic_function] = STATE(3233),
    [sym_generic_type_with_turbofish] = STATE(2352),
    [sym__expression] = STATE(3233),
    [sym_macro_invocation] = STATE(3233),
    [sym_scoped_identifier] = STATE(2354),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2355),
    [sym_range_expression] = STATE(3233),
    [sym_unary_expression] = STATE(3233),
    [sym_try_expression] = STATE(3233),
    [sym_reference_expression] = STATE(3233),
    [sym_binary_expression] = STATE(3233),
    [sym_assignment_expression] = STATE(2356),
    [sym_compound_assignment_expr] = STATE(2356),
    [sym_type_cast_expression] = STATE(2356),
    [sym_return_expression] = STATE(3233),
    [sym_call_expression] = STATE(3233),
    [sym_array_expression] = STATE(3233),
    [sym_parenthesized_expression] = STATE(3233),
    [sym_tuple_expression] = STATE(3233),
    [sym_unit_expression] = STATE(3233),
    [sym_struct_expression] = STATE(3233),
    [sym_if_expression] = STATE(3233),
    [sym_if_let_expression] = STATE(3233),
    [sym_match_expression] = STATE(3233),
    [sym_while_expression] = STATE(3233),
    [sym_while_let_expression] = STATE(3233),
    [sym_loop_expression] = STATE(3233),
    [sym_for_expression] = STATE(3233),
    [sym_closure_expression] = STATE(3233),
    [sym_closure_parameters] = STATE(2357),
    [sym_loop_label] = STATE(2358),
    [sym_break_expression] = STATE(3233),
    [sym_continue_expression] = STATE(3233),
    [sym_index_expression] = STATE(3233),
    [sym_field_expression] = STATE(2359),
    [sym_unsafe_block] = STATE(3233),
    [sym_block] = STATE(3233),
    [sym__literal] = STATE(3233),
    [sym_string_literal] = STATE(3233),
    [sym_boolean_literal] = STATE(3233),
    [sym_raw_string_literal] = ACTIONS(7057),
    [sym_float_literal] = ACTIONS(7057),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5154),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_LBRACK] = ACTIONS(5158),
    [anon_sym_STAR] = ACTIONS(5160),
    [anon_sym_u8] = ACTIONS(5162),
    [anon_sym_i8] = ACTIONS(5162),
    [anon_sym_u16] = ACTIONS(5162),
    [anon_sym_i16] = ACTIONS(5162),
    [anon_sym_u32] = ACTIONS(5162),
    [anon_sym_i32] = ACTIONS(5162),
    [anon_sym_u64] = ACTIONS(5162),
    [anon_sym_i64] = ACTIONS(5162),
    [anon_sym_u128] = ACTIONS(5162),
    [anon_sym_i128] = ACTIONS(5162),
    [anon_sym_isize] = ACTIONS(5162),
    [anon_sym_usize] = ACTIONS(5162),
    [anon_sym_f32] = ACTIONS(5162),
    [anon_sym_f64] = ACTIONS(5162),
    [anon_sym_bool] = ACTIONS(5162),
    [anon_sym_str] = ACTIONS(5162),
    [anon_sym_char] = ACTIONS(5162),
    [anon_sym_AMP] = ACTIONS(5164),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_COLON_COLON] = ACTIONS(5166),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5168),
    [anon_sym_break] = ACTIONS(5170),
    [anon_sym_continue] = ACTIONS(5172),
    [anon_sym_default] = ACTIONS(5174),
    [anon_sym_for] = ACTIONS(5176),
    [anon_sym_if] = ACTIONS(5178),
    [anon_sym_loop] = ACTIONS(5180),
    [anon_sym_match] = ACTIONS(5182),
    [anon_sym_return] = ACTIONS(5184),
    [anon_sym_union] = ACTIONS(5174),
    [anon_sym_unsafe] = ACTIONS(5186),
    [anon_sym_while] = ACTIONS(5188),
    [anon_sym_move] = ACTIONS(5190),
    [sym_integer_literal] = ACTIONS(7057),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5192),
    [sym_char_literal] = ACTIONS(7057),
    [anon_sym_true] = ACTIONS(5194),
    [anon_sym_false] = ACTIONS(5194),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5196),
    [sym_self] = ACTIONS(5198),
    [sym_super] = ACTIONS(5200),
    [sym_crate] = ACTIONS(5200),
    [sym_metavariable] = ACTIONS(5202),
  },
  [2875] = {
    [sym_function_modifiers] = STATE(3246),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3247),
    [sym_bracketed_type] = STATE(3244),
    [sym_lifetime] = STATE(3248),
    [sym_array_type] = STATE(3247),
    [sym_function_type] = STATE(3247),
    [sym_tuple_type] = STATE(3247),
    [sym_unit_type] = STATE(3247),
    [sym_generic_type] = STATE(3249),
    [sym_generic_type_with_turbofish] = STATE(3250),
    [sym_bounded_type] = STATE(3247),
    [sym_reference_type] = STATE(3247),
    [sym_pointer_type] = STATE(3247),
    [sym_empty_type] = STATE(3247),
    [sym_dynamic_type] = STATE(3247),
    [sym_macro_invocation] = STATE(3247),
    [sym_scoped_identifier] = STATE(3251),
    [sym_scoped_type_identifier] = STATE(3252),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7059),
    [anon_sym_LBRACK] = ACTIONS(7061),
    [anon_sym_STAR] = ACTIONS(7063),
    [anon_sym_u8] = ACTIONS(7065),
    [anon_sym_i8] = ACTIONS(7065),
    [anon_sym_u16] = ACTIONS(7065),
    [anon_sym_i16] = ACTIONS(7065),
    [anon_sym_u32] = ACTIONS(7065),
    [anon_sym_i32] = ACTIONS(7065),
    [anon_sym_u64] = ACTIONS(7065),
    [anon_sym_i64] = ACTIONS(7065),
    [anon_sym_u128] = ACTIONS(7065),
    [anon_sym_i128] = ACTIONS(7065),
    [anon_sym_isize] = ACTIONS(7065),
    [anon_sym_usize] = ACTIONS(7065),
    [anon_sym_f32] = ACTIONS(7065),
    [anon_sym_f64] = ACTIONS(7065),
    [anon_sym_bool] = ACTIONS(7065),
    [anon_sym_str] = ACTIONS(7065),
    [anon_sym_char] = ACTIONS(7065),
    [anon_sym_AMP] = ACTIONS(7067),
    [anon_sym_COLON_COLON] = ACTIONS(7069),
    [anon_sym_BANG] = ACTIONS(7071),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(7073),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(7075),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7077),
    [sym_self] = ACTIONS(7079),
    [sym_super] = ACTIONS(7079),
    [sym_crate] = ACTIONS(7079),
    [sym_metavariable] = ACTIONS(7081),
  },
  [2876] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1311),
    [anon_sym_EQ_GT] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_STAR] = ACTIONS(1313),
    [anon_sym_AMP] = ACTIONS(1313),
    [anon_sym_DASH] = ACTIONS(1313),
    [anon_sym_DOT] = ACTIONS(1313),
    [anon_sym_DASH_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(1311),
    [anon_sym_STAR_EQ] = ACTIONS(1311),
    [anon_sym_SLASH] = ACTIONS(1313),
    [anon_sym_SLASH_EQ] = ACTIONS(1311),
    [anon_sym_AMP_AMP] = ACTIONS(1311),
    [anon_sym_AMP_EQ] = ACTIONS(1311),
    [anon_sym_PERCENT] = ACTIONS(1313),
    [anon_sym_PERCENT_EQ] = ACTIONS(1311),
    [anon_sym_CARET] = ACTIONS(1313),
    [anon_sym_CARET_EQ] = ACTIONS(1311),
    [anon_sym_PLUS_EQ] = ACTIONS(1311),
    [anon_sym_LT] = ACTIONS(1313),
    [anon_sym_LT_LT] = ACTIONS(1313),
    [anon_sym_LT_LT_EQ] = ACTIONS(1311),
    [anon_sym_LT_EQ] = ACTIONS(1311),
    [anon_sym_EQ] = ACTIONS(1313),
    [anon_sym_EQ_EQ] = ACTIONS(1311),
    [anon_sym_GT] = ACTIONS(1313),
    [anon_sym_GT_EQ] = ACTIONS(1311),
    [anon_sym_GT_GT] = ACTIONS(1313),
    [anon_sym_GT_GT_EQ] = ACTIONS(1311),
    [anon_sym_PIPE] = ACTIONS(1313),
    [anon_sym_PIPE_EQ] = ACTIONS(1311),
    [anon_sym_PIPE_PIPE] = ACTIONS(1311),
    [anon_sym_QMARK] = ACTIONS(1311),
    [anon_sym_DOT_DOT] = ACTIONS(1313),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1311),
    [anon_sym_as] = ACTIONS(1311),
    [sym_line_comment] = ACTIONS(7),
  },
  [2877] = {
    [sym_type_arguments] = STATE(3253),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7009),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7011),
  },
  [2878] = {
    [sym_function_modifiers] = STATE(677),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3254),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(679),
    [sym_array_type] = STATE(3254),
    [sym_function_type] = STATE(3254),
    [sym_tuple_type] = STATE(3254),
    [sym_unit_type] = STATE(3254),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(3254),
    [sym_reference_type] = STATE(3254),
    [sym_pointer_type] = STATE(3254),
    [sym_empty_type] = STATE(3254),
    [sym_dynamic_type] = STATE(3254),
    [sym_macro_invocation] = STATE(3254),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(680),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1315),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1317),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1319),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1321),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2879] = {
    [sym_arguments] = STATE(2876),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6312),
    [anon_sym_EQ_GT] = ACTIONS(1323),
    [anon_sym_LBRACK] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6318),
    [anon_sym_STAR] = ACTIONS(6320),
    [anon_sym_AMP] = ACTIONS(6322),
    [anon_sym_DASH] = ACTIONS(6318),
    [anon_sym_DOT] = ACTIONS(6324),
    [anon_sym_DASH_EQ] = ACTIONS(6326),
    [anon_sym_BANG_EQ] = ACTIONS(6328),
    [anon_sym_STAR_EQ] = ACTIONS(6326),
    [anon_sym_SLASH] = ACTIONS(6320),
    [anon_sym_SLASH_EQ] = ACTIONS(6326),
    [anon_sym_AMP_AMP] = ACTIONS(6330),
    [anon_sym_AMP_EQ] = ACTIONS(6326),
    [anon_sym_PERCENT] = ACTIONS(6320),
    [anon_sym_PERCENT_EQ] = ACTIONS(6326),
    [anon_sym_CARET] = ACTIONS(6332),
    [anon_sym_CARET_EQ] = ACTIONS(6326),
    [anon_sym_PLUS_EQ] = ACTIONS(6326),
    [anon_sym_LT] = ACTIONS(6334),
    [anon_sym_LT_LT] = ACTIONS(6336),
    [anon_sym_LT_LT_EQ] = ACTIONS(6326),
    [anon_sym_LT_EQ] = ACTIONS(6328),
    [anon_sym_EQ] = ACTIONS(6338),
    [anon_sym_EQ_EQ] = ACTIONS(6328),
    [anon_sym_GT] = ACTIONS(6334),
    [anon_sym_GT_EQ] = ACTIONS(6328),
    [anon_sym_GT_GT] = ACTIONS(6336),
    [anon_sym_GT_GT_EQ] = ACTIONS(6326),
    [anon_sym_PIPE] = ACTIONS(6340),
    [anon_sym_PIPE_EQ] = ACTIONS(6326),
    [anon_sym_PIPE_PIPE] = ACTIONS(6342),
    [anon_sym_QMARK] = ACTIONS(6344),
    [anon_sym_DOT_DOT] = ACTIONS(6346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6348),
    [anon_sym_as] = ACTIONS(6350),
    [sym_line_comment] = ACTIONS(7),
  },
  [2880] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(7083),
    [anon_sym_loop] = ACTIONS(7085),
    [anon_sym_while] = ACTIONS(7087),
    [sym_line_comment] = ACTIONS(7),
  },
  [2881] = {
    [sym_type_arguments] = STATE(3258),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(7009),
    [sym_line_comment] = ACTIONS(7),
  },
  [2882] = {
    [sym_arguments] = STATE(2876),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6312),
    [anon_sym_EQ_GT] = ACTIONS(7089),
    [anon_sym_LBRACK] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6318),
    [anon_sym_STAR] = ACTIONS(6320),
    [anon_sym_AMP] = ACTIONS(6322),
    [anon_sym_DASH] = ACTIONS(6318),
    [anon_sym_DOT] = ACTIONS(6324),
    [anon_sym_DASH_EQ] = ACTIONS(6326),
    [anon_sym_BANG_EQ] = ACTIONS(6328),
    [anon_sym_STAR_EQ] = ACTIONS(6326),
    [anon_sym_SLASH] = ACTIONS(6320),
    [anon_sym_SLASH_EQ] = ACTIONS(6326),
    [anon_sym_AMP_AMP] = ACTIONS(6330),
    [anon_sym_AMP_EQ] = ACTIONS(6326),
    [anon_sym_PERCENT] = ACTIONS(6320),
    [anon_sym_PERCENT_EQ] = ACTIONS(6326),
    [anon_sym_CARET] = ACTIONS(6332),
    [anon_sym_CARET_EQ] = ACTIONS(6326),
    [anon_sym_PLUS_EQ] = ACTIONS(6326),
    [anon_sym_LT] = ACTIONS(6334),
    [anon_sym_LT_LT] = ACTIONS(6336),
    [anon_sym_LT_LT_EQ] = ACTIONS(6326),
    [anon_sym_LT_EQ] = ACTIONS(6328),
    [anon_sym_EQ] = ACTIONS(6338),
    [anon_sym_EQ_EQ] = ACTIONS(6328),
    [anon_sym_GT] = ACTIONS(6334),
    [anon_sym_GT_EQ] = ACTIONS(6328),
    [anon_sym_GT_GT] = ACTIONS(6336),
    [anon_sym_GT_GT_EQ] = ACTIONS(6326),
    [anon_sym_PIPE] = ACTIONS(6340),
    [anon_sym_PIPE_EQ] = ACTIONS(6326),
    [anon_sym_PIPE_PIPE] = ACTIONS(6342),
    [anon_sym_QMARK] = ACTIONS(6344),
    [anon_sym_DOT_DOT] = ACTIONS(6346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6348),
    [anon_sym_as] = ACTIONS(6350),
    [sym_line_comment] = ACTIONS(7),
  },
  [2883] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(6955),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(3495),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(7091),
    [anon_sym_AMP] = ACTIONS(3499),
    [anon_sym_DASH] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(3501),
    [anon_sym_BANG_EQ] = ACTIONS(3503),
    [anon_sym_STAR_EQ] = ACTIONS(3501),
    [anon_sym_SLASH] = ACTIONS(3497),
    [anon_sym_SLASH_EQ] = ACTIONS(3501),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_AMP_EQ] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_PERCENT_EQ] = ACTIONS(3501),
    [anon_sym_CARET] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3501),
    [anon_sym_PLUS_EQ] = ACTIONS(3501),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_LT_LT] = ACTIONS(3511),
    [anon_sym_LT_LT_EQ] = ACTIONS(3501),
    [anon_sym_LT_EQ] = ACTIONS(3503),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_EQ_EQ] = ACTIONS(3503),
    [anon_sym_GT] = ACTIONS(3509),
    [anon_sym_GT_EQ] = ACTIONS(3503),
    [anon_sym_GT_GT] = ACTIONS(3511),
    [anon_sym_GT_GT_EQ] = ACTIONS(3501),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_PIPE_EQ] = ACTIONS(3501),
    [anon_sym_PIPE_PIPE] = ACTIONS(3517),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(3519),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3521),
    [anon_sym_as] = ACTIONS(3523),
    [sym_line_comment] = ACTIONS(7),
  },
  [2884] = {
    [sym_raw_string_literal] = ACTIONS(6953),
    [sym_float_literal] = ACTIONS(6953),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6953),
    [anon_sym_RBRACE] = ACTIONS(407),
    [anon_sym_LBRACK] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(411),
    [anon_sym_COMMA] = ACTIONS(407),
    [anon_sym_u8] = ACTIONS(6957),
    [anon_sym_i8] = ACTIONS(6957),
    [anon_sym_u16] = ACTIONS(6957),
    [anon_sym_i16] = ACTIONS(6957),
    [anon_sym_u32] = ACTIONS(6957),
    [anon_sym_i32] = ACTIONS(6957),
    [anon_sym_u64] = ACTIONS(6957),
    [anon_sym_i64] = ACTIONS(6957),
    [anon_sym_u128] = ACTIONS(6957),
    [anon_sym_i128] = ACTIONS(6957),
    [anon_sym_isize] = ACTIONS(6957),
    [anon_sym_usize] = ACTIONS(6957),
    [anon_sym_f32] = ACTIONS(6957),
    [anon_sym_f64] = ACTIONS(6957),
    [anon_sym_bool] = ACTIONS(6957),
    [anon_sym_str] = ACTIONS(6957),
    [anon_sym_char] = ACTIONS(6957),
    [anon_sym__] = ACTIONS(6957),
    [anon_sym_AMP] = ACTIONS(6957),
    [anon_sym_DASH] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(411),
    [anon_sym_DASH_EQ] = ACTIONS(407),
    [anon_sym_COLON_COLON] = ACTIONS(6953),
    [anon_sym_BANG_EQ] = ACTIONS(407),
    [anon_sym_STAR_EQ] = ACTIONS(407),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_SLASH_EQ] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(407),
    [anon_sym_AMP_EQ] = ACTIONS(407),
    [anon_sym_POUND] = ACTIONS(6953),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_PERCENT_EQ] = ACTIONS(407),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_CARET_EQ] = ACTIONS(407),
    [anon_sym_PLUS_EQ] = ACTIONS(407),
    [anon_sym_LT] = ACTIONS(6957),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_LT_LT_EQ] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(407),
    [anon_sym_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(407),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_GT_EQ] = ACTIONS(407),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_EQ] = ACTIONS(407),
    [anon_sym_PIPE] = ACTIONS(411),
    [anon_sym_PIPE_EQ] = ACTIONS(407),
    [anon_sym_PIPE_PIPE] = ACTIONS(407),
    [anon_sym_QMARK] = ACTIONS(407),
    [anon_sym_DOT_DOT] = ACTIONS(6957),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(407),
    [anon_sym_as] = ACTIONS(411),
    [sym_mutable_specifier] = ACTIONS(6957),
    [anon_sym_ref] = ACTIONS(6957),
    [sym_integer_literal] = ACTIONS(6953),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6953),
    [sym_char_literal] = ACTIONS(6953),
    [anon_sym_true] = ACTIONS(6957),
    [anon_sym_false] = ACTIONS(6957),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6957),
    [sym_self] = ACTIONS(6957),
    [sym_super] = ACTIONS(6957),
    [sym_crate] = ACTIONS(6957),
    [sym_metavariable] = ACTIONS(6953),
  },
  [2885] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3261),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3261),
    [sym_macro_invocation] = STATE(3261),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3261),
    [sym_unary_expression] = STATE(3261),
    [sym_try_expression] = STATE(3261),
    [sym_reference_expression] = STATE(3261),
    [sym_binary_expression] = STATE(3261),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3261),
    [sym_call_expression] = STATE(3261),
    [sym_array_expression] = STATE(3261),
    [sym_parenthesized_expression] = STATE(3261),
    [sym_tuple_expression] = STATE(3261),
    [sym_unit_expression] = STATE(3261),
    [sym_struct_expression] = STATE(3261),
    [sym_if_expression] = STATE(2324),
    [sym_if_let_expression] = STATE(2324),
    [sym_match_expression] = STATE(2324),
    [sym_while_expression] = STATE(2324),
    [sym_while_let_expression] = STATE(2324),
    [sym_loop_expression] = STATE(2324),
    [sym_for_expression] = STATE(2324),
    [sym_closure_expression] = STATE(3261),
    [sym_closure_parameters] = STATE(2062),
    [sym_loop_label] = STATE(2325),
    [sym_break_expression] = STATE(3261),
    [sym_continue_expression] = STATE(3261),
    [sym_index_expression] = STATE(3261),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2324),
    [sym_block] = STATE(2324),
    [sym__literal] = STATE(3261),
    [sym_string_literal] = STATE(3261),
    [sym_boolean_literal] = STATE(3261),
    [sym_raw_string_literal] = ACTIONS(7093),
    [sym_float_literal] = ACTIONS(7093),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(5136),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(5862),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5862),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5866),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(5138),
    [anon_sym_if] = ACTIONS(7095),
    [anon_sym_loop] = ACTIONS(5142),
    [anon_sym_match] = ACTIONS(5144),
    [anon_sym_return] = ACTIONS(5870),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(5146),
    [anon_sym_while] = ACTIONS(5148),
    [anon_sym_move] = ACTIONS(5872),
    [sym_integer_literal] = ACTIONS(7093),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7093),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2886] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(7097),
    [sym_line_comment] = ACTIONS(7),
  },
  [2887] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7099),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(467),
    [anon_sym_BANG_EQ] = ACTIONS(469),
    [anon_sym_STAR_EQ] = ACTIONS(467),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(467),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_AMP_EQ] = ACTIONS(467),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(467),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_CARET_EQ] = ACTIONS(467),
    [anon_sym_PLUS_EQ] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT_LT_EQ] = ACTIONS(467),
    [anon_sym_LT_EQ] = ACTIONS(469),
    [anon_sym_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_EQ] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_PIPE_EQ] = ACTIONS(467),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(489),
    [anon_sym_as] = ACTIONS(491),
    [sym_line_comment] = ACTIONS(7),
  },
  [2888] = {
    [sym_raw_string_literal] = ACTIONS(7101),
    [sym_float_literal] = ACTIONS(7101),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(7101),
    [anon_sym_SEMI] = ACTIONS(7101),
    [anon_sym_macro_rules_BANG] = ACTIONS(7101),
    [anon_sym_LPAREN] = ACTIONS(7101),
    [anon_sym_LBRACE] = ACTIONS(7101),
    [anon_sym_RBRACE] = ACTIONS(7101),
    [anon_sym_LBRACK] = ACTIONS(7101),
    [anon_sym_STAR] = ACTIONS(7101),
    [anon_sym_u8] = ACTIONS(7103),
    [anon_sym_i8] = ACTIONS(7103),
    [anon_sym_u16] = ACTIONS(7103),
    [anon_sym_i16] = ACTIONS(7103),
    [anon_sym_u32] = ACTIONS(7103),
    [anon_sym_i32] = ACTIONS(7103),
    [anon_sym_u64] = ACTIONS(7103),
    [anon_sym_i64] = ACTIONS(7103),
    [anon_sym_u128] = ACTIONS(7103),
    [anon_sym_i128] = ACTIONS(7103),
    [anon_sym_isize] = ACTIONS(7103),
    [anon_sym_usize] = ACTIONS(7103),
    [anon_sym_f32] = ACTIONS(7103),
    [anon_sym_f64] = ACTIONS(7103),
    [anon_sym_bool] = ACTIONS(7103),
    [anon_sym_str] = ACTIONS(7103),
    [anon_sym_char] = ACTIONS(7103),
    [anon_sym_AMP] = ACTIONS(7101),
    [anon_sym_DASH] = ACTIONS(7101),
    [anon_sym_COLON_COLON] = ACTIONS(7101),
    [anon_sym_BANG] = ACTIONS(7101),
    [anon_sym_POUND] = ACTIONS(7101),
    [anon_sym_LT] = ACTIONS(7101),
    [anon_sym_PIPE] = ACTIONS(7101),
    [anon_sym_SQUOTE] = ACTIONS(7103),
    [anon_sym_DOT_DOT] = ACTIONS(7101),
    [anon_sym_break] = ACTIONS(7103),
    [anon_sym_const] = ACTIONS(7103),
    [anon_sym_continue] = ACTIONS(7103),
    [anon_sym_default] = ACTIONS(7103),
    [anon_sym_enum] = ACTIONS(7103),
    [anon_sym_fn] = ACTIONS(7103),
    [anon_sym_for] = ACTIONS(7103),
    [anon_sym_if] = ACTIONS(7103),
    [anon_sym_impl] = ACTIONS(7103),
    [anon_sym_let] = ACTIONS(7103),
    [anon_sym_loop] = ACTIONS(7103),
    [anon_sym_match] = ACTIONS(7103),
    [anon_sym_mod] = ACTIONS(7103),
    [anon_sym_pub] = ACTIONS(7103),
    [anon_sym_return] = ACTIONS(7103),
    [anon_sym_static] = ACTIONS(7103),
    [anon_sym_struct] = ACTIONS(7103),
    [anon_sym_trait] = ACTIONS(7103),
    [anon_sym_type] = ACTIONS(7103),
    [anon_sym_union] = ACTIONS(7103),
    [anon_sym_unsafe] = ACTIONS(7103),
    [anon_sym_use] = ACTIONS(7103),
    [anon_sym_while] = ACTIONS(7103),
    [anon_sym_extern] = ACTIONS(7103),
    [anon_sym_move] = ACTIONS(7103),
    [sym_integer_literal] = ACTIONS(7101),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7101),
    [sym_char_literal] = ACTIONS(7101),
    [anon_sym_true] = ACTIONS(7103),
    [anon_sym_false] = ACTIONS(7103),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7103),
    [sym_self] = ACTIONS(7103),
    [sym_super] = ACTIONS(7103),
    [sym_crate] = ACTIONS(7103),
    [sym_metavariable] = ACTIONS(7101),
  },
  [2889] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2872),
    [anon_sym_LBRACK] = ACTIONS(2872),
    [anon_sym_STAR] = ACTIONS(2872),
    [anon_sym_u8] = ACTIONS(2874),
    [anon_sym_i8] = ACTIONS(2874),
    [anon_sym_u16] = ACTIONS(2874),
    [anon_sym_i16] = ACTIONS(2874),
    [anon_sym_u32] = ACTIONS(2874),
    [anon_sym_i32] = ACTIONS(2874),
    [anon_sym_u64] = ACTIONS(2874),
    [anon_sym_i64] = ACTIONS(2874),
    [anon_sym_u128] = ACTIONS(2874),
    [anon_sym_i128] = ACTIONS(2874),
    [anon_sym_isize] = ACTIONS(2874),
    [anon_sym_usize] = ACTIONS(2874),
    [anon_sym_f32] = ACTIONS(2874),
    [anon_sym_f64] = ACTIONS(2874),
    [anon_sym_bool] = ACTIONS(2874),
    [anon_sym_str] = ACTIONS(2874),
    [anon_sym_char] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2872),
    [anon_sym_COLON_COLON] = ACTIONS(2872),
    [anon_sym_BANG] = ACTIONS(2872),
    [anon_sym_POUND] = ACTIONS(2872),
    [anon_sym_LT] = ACTIONS(2872),
    [anon_sym_SQUOTE] = ACTIONS(2872),
    [anon_sym_const] = ACTIONS(2874),
    [anon_sym_default] = ACTIONS(2874),
    [anon_sym_fn] = ACTIONS(2874),
    [anon_sym_pub] = ACTIONS(2874),
    [anon_sym_unsafe] = ACTIONS(2874),
    [anon_sym_extern] = ACTIONS(2874),
    [anon_sym_dyn] = ACTIONS(2874),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2874),
    [sym_self] = ACTIONS(2874),
    [sym_super] = ACTIONS(2874),
    [sym_crate] = ACTIONS(2874),
    [sym_metavariable] = ACTIONS(2872),
  },
  [2890] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7105),
    [anon_sym_COLON_COLON] = ACTIONS(2188),
    [sym_line_comment] = ACTIONS(7),
  },
  [2891] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7107),
    [anon_sym_COLON_COLON] = ACTIONS(2192),
    [sym_line_comment] = ACTIONS(7),
  },
  [2892] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7107),
    [anon_sym_COLON_COLON] = ACTIONS(449),
    [sym_line_comment] = ACTIONS(7),
  },
  [2893] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7107),
    [anon_sym_COLON_COLON] = ACTIONS(2194),
    [sym_line_comment] = ACTIONS(7),
  },
  [2894] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(3349),
    [anon_sym_LBRACK] = ACTIONS(3349),
    [anon_sym_STAR] = ACTIONS(3349),
    [anon_sym_u8] = ACTIONS(7109),
    [anon_sym_i8] = ACTIONS(7109),
    [anon_sym_u16] = ACTIONS(7109),
    [anon_sym_i16] = ACTIONS(7109),
    [anon_sym_u32] = ACTIONS(7109),
    [anon_sym_i32] = ACTIONS(7109),
    [anon_sym_u64] = ACTIONS(7109),
    [anon_sym_i64] = ACTIONS(7109),
    [anon_sym_u128] = ACTIONS(7109),
    [anon_sym_i128] = ACTIONS(7109),
    [anon_sym_isize] = ACTIONS(7109),
    [anon_sym_usize] = ACTIONS(7109),
    [anon_sym_f32] = ACTIONS(7109),
    [anon_sym_f64] = ACTIONS(7109),
    [anon_sym_bool] = ACTIONS(7109),
    [anon_sym_str] = ACTIONS(7109),
    [anon_sym_char] = ACTIONS(7109),
    [anon_sym_AMP] = ACTIONS(3349),
    [anon_sym_COLON_COLON] = ACTIONS(3349),
    [anon_sym_BANG] = ACTIONS(3349),
    [anon_sym_LT] = ACTIONS(3349),
    [anon_sym_SQUOTE] = ACTIONS(3349),
    [anon_sym_const] = ACTIONS(7109),
    [anon_sym_default] = ACTIONS(7109),
    [anon_sym_fn] = ACTIONS(7109),
    [anon_sym_unsafe] = ACTIONS(7109),
    [anon_sym_extern] = ACTIONS(7109),
    [anon_sym_dyn] = ACTIONS(7109),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7109),
    [sym_self] = ACTIONS(7109),
    [sym_super] = ACTIONS(7109),
    [sym_crate] = ACTIONS(7109),
    [sym_metavariable] = ACTIONS(3349),
  },
  [2895] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7111),
    [anon_sym_RBRACE] = ACTIONS(7111),
    [anon_sym_COMMA] = ACTIONS(7111),
    [anon_sym_EQ] = ACTIONS(7111),
    [anon_sym_where] = ACTIONS(7111),
    [sym_line_comment] = ACTIONS(7),
  },
  [2896] = {
    [sym_attribute_item] = STATE(2378),
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym_visibility_modifier] = STATE(2376),
    [sym__type] = STATE(2377),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(2377),
    [sym_function_type] = STATE(2377),
    [sym_tuple_type] = STATE(2377),
    [sym_unit_type] = STATE(2377),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2377),
    [sym_reference_type] = STATE(2377),
    [sym_pointer_type] = STATE(2377),
    [sym_empty_type] = STATE(2377),
    [sym_dynamic_type] = STATE(2377),
    [sym_macro_invocation] = STATE(2377),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_enum_variant_list_repeat1] = STATE(2378),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_RPAREN] = ACTIONS(7113),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_POUND] = ACTIONS(2124),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_pub] = ACTIONS(2126),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2897] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7115),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_COMMA] = ACTIONS(7115),
    [sym_line_comment] = ACTIONS(7),
  },
  [2898] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3267),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(3267),
    [sym_function_type] = STATE(3267),
    [sym_tuple_type] = STATE(3267),
    [sym_unit_type] = STATE(3267),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(3267),
    [sym_reference_type] = STATE(3267),
    [sym_pointer_type] = STATE(3267),
    [sym_empty_type] = STATE(3267),
    [sym_dynamic_type] = STATE(3267),
    [sym_macro_invocation] = STATE(3267),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2899] = {
    [sym_attribute_item] = STATE(2378),
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym_visibility_modifier] = STATE(2376),
    [sym__type] = STATE(2377),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(2377),
    [sym_function_type] = STATE(2377),
    [sym_tuple_type] = STATE(2377),
    [sym_unit_type] = STATE(2377),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2377),
    [sym_reference_type] = STATE(2377),
    [sym_pointer_type] = STATE(2377),
    [sym_empty_type] = STATE(2377),
    [sym_dynamic_type] = STATE(2377),
    [sym_macro_invocation] = STATE(2377),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_enum_variant_list_repeat1] = STATE(2378),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_POUND] = ACTIONS(2124),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_pub] = ACTIONS(2126),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2900] = {
    [aux_sym_ordered_field_declaration_list_repeat1] = STATE(2379),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7113),
    [anon_sym_COMMA] = ACTIONS(7117),
    [sym_line_comment] = ACTIONS(7),
  },
  [2901] = {
    [sym_function_modifiers] = STATE(2385),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(821),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2387),
    [sym_array_type] = STATE(821),
    [sym_function_type] = STATE(821),
    [sym_tuple_type] = STATE(821),
    [sym_unit_type] = STATE(821),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(821),
    [sym_reference_type] = STATE(821),
    [sym_pointer_type] = STATE(821),
    [sym_empty_type] = STATE(821),
    [sym_dynamic_type] = STATE(821),
    [sym_macro_invocation] = STATE(821),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2388),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(5298),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(5300),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5302),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5304),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2902] = {
    [sym_function_modifiers] = STATE(2385),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2387),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2388),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(5298),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(5300),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5302),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5304),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2903] = {
    [sym_function_modifiers] = STATE(2385),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2387),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2388),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(6420),
    [anon_sym_STAR] = ACTIONS(5298),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(5300),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5302),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(7119),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5304),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2904] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(1760),
    [anon_sym_PLUS] = ACTIONS(1760),
    [anon_sym_COMMA] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(7121),
    [sym_line_comment] = ACTIONS(7),
  },
  [2905] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(1794),
    [anon_sym_PLUS] = ACTIONS(1794),
    [anon_sym_COMMA] = ACTIONS(1794),
    [anon_sym_DASH_GT] = ACTIONS(7123),
    [sym_line_comment] = ACTIONS(7),
  },
  [2906] = {
    [sym_parameters] = STATE(3272),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [2907] = {
    [sym_parameters] = STATE(3273),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [2908] = {
    [sym_parameters] = STATE(3272),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [2909] = {
    [sym_function_modifiers] = STATE(2385),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(862),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2388),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(5298),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(5300),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5302),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5304),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2910] = {
    [sym_function_modifiers] = STATE(2385),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2387),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2388),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(5298),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(5300),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5302),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5304),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2911] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7125),
    [anon_sym_COMMA] = ACTIONS(7125),
    [sym_line_comment] = ACTIONS(7),
  },
  [2912] = {
    [sym_raw_string_literal] = ACTIONS(7127),
    [sym_float_literal] = ACTIONS(7127),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(7127),
    [anon_sym_SEMI] = ACTIONS(7127),
    [anon_sym_macro_rules_BANG] = ACTIONS(7127),
    [anon_sym_LPAREN] = ACTIONS(7127),
    [anon_sym_LBRACE] = ACTIONS(7127),
    [anon_sym_RBRACE] = ACTIONS(7127),
    [anon_sym_LBRACK] = ACTIONS(7127),
    [anon_sym_STAR] = ACTIONS(7127),
    [anon_sym_u8] = ACTIONS(7129),
    [anon_sym_i8] = ACTIONS(7129),
    [anon_sym_u16] = ACTIONS(7129),
    [anon_sym_i16] = ACTIONS(7129),
    [anon_sym_u32] = ACTIONS(7129),
    [anon_sym_i32] = ACTIONS(7129),
    [anon_sym_u64] = ACTIONS(7129),
    [anon_sym_i64] = ACTIONS(7129),
    [anon_sym_u128] = ACTIONS(7129),
    [anon_sym_i128] = ACTIONS(7129),
    [anon_sym_isize] = ACTIONS(7129),
    [anon_sym_usize] = ACTIONS(7129),
    [anon_sym_f32] = ACTIONS(7129),
    [anon_sym_f64] = ACTIONS(7129),
    [anon_sym_bool] = ACTIONS(7129),
    [anon_sym_str] = ACTIONS(7129),
    [anon_sym_char] = ACTIONS(7129),
    [anon_sym_AMP] = ACTIONS(7127),
    [anon_sym_DASH] = ACTIONS(7127),
    [anon_sym_COLON_COLON] = ACTIONS(7127),
    [anon_sym_BANG] = ACTIONS(7127),
    [anon_sym_POUND] = ACTIONS(7127),
    [anon_sym_LT] = ACTIONS(7127),
    [anon_sym_PIPE] = ACTIONS(7127),
    [anon_sym_SQUOTE] = ACTIONS(7129),
    [anon_sym_DOT_DOT] = ACTIONS(7127),
    [anon_sym_break] = ACTIONS(7129),
    [anon_sym_const] = ACTIONS(7129),
    [anon_sym_continue] = ACTIONS(7129),
    [anon_sym_default] = ACTIONS(7129),
    [anon_sym_enum] = ACTIONS(7129),
    [anon_sym_fn] = ACTIONS(7129),
    [anon_sym_for] = ACTIONS(7129),
    [anon_sym_if] = ACTIONS(7129),
    [anon_sym_impl] = ACTIONS(7129),
    [anon_sym_let] = ACTIONS(7129),
    [anon_sym_loop] = ACTIONS(7129),
    [anon_sym_match] = ACTIONS(7129),
    [anon_sym_mod] = ACTIONS(7129),
    [anon_sym_pub] = ACTIONS(7129),
    [anon_sym_return] = ACTIONS(7129),
    [anon_sym_static] = ACTIONS(7129),
    [anon_sym_struct] = ACTIONS(7129),
    [anon_sym_trait] = ACTIONS(7129),
    [anon_sym_type] = ACTIONS(7129),
    [anon_sym_union] = ACTIONS(7129),
    [anon_sym_unsafe] = ACTIONS(7129),
    [anon_sym_use] = ACTIONS(7129),
    [anon_sym_while] = ACTIONS(7129),
    [anon_sym_extern] = ACTIONS(7129),
    [anon_sym_move] = ACTIONS(7129),
    [sym_integer_literal] = ACTIONS(7127),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7127),
    [sym_char_literal] = ACTIONS(7127),
    [anon_sym_true] = ACTIONS(7129),
    [anon_sym_false] = ACTIONS(7129),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7129),
    [sym_self] = ACTIONS(7129),
    [sym_super] = ACTIONS(7129),
    [sym_crate] = ACTIONS(7129),
    [sym_metavariable] = ACTIONS(7127),
  },
  [2913] = {
    [sym_attribute_item] = STATE(2391),
    [sym_field_declaration] = STATE(2390),
    [sym_visibility_modifier] = STATE(1069),
    [aux_sym_enum_variant_list_repeat1] = STATE(2391),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_pub] = ACTIONS(1940),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2132),
  },
  [2914] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7131),
    [anon_sym_PLUS] = ACTIONS(6418),
    [anon_sym_COMMA] = ACTIONS(7131),
    [sym_line_comment] = ACTIONS(7),
  },
  [2915] = {
    [sym_attribute_item] = STATE(2391),
    [sym_field_declaration] = STATE(2390),
    [sym_visibility_modifier] = STATE(1069),
    [aux_sym_enum_variant_list_repeat1] = STATE(2391),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7133),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_pub] = ACTIONS(1940),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2132),
  },
  [2916] = {
    [sym_function_modifiers] = STATE(2402),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(821),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2919),
    [sym_array_type] = STATE(821),
    [sym_function_type] = STATE(821),
    [sym_tuple_type] = STATE(821),
    [sym_unit_type] = STATE(821),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(821),
    [sym_reference_type] = STATE(821),
    [sym_pointer_type] = STATE(821),
    [sym_empty_type] = STATE(821),
    [sym_dynamic_type] = STATE(821),
    [sym_macro_invocation] = STATE(821),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2405),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(5312),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(5314),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5318),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5322),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2917] = {
    [sym_function_modifiers] = STATE(2402),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2919),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2405),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(5312),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(5314),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5318),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5322),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2918] = {
    [sym_function_modifiers] = STATE(2402),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2919),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2405),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(7135),
    [anon_sym_STAR] = ACTIONS(5312),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(5314),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5318),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(7137),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5322),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2919] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7135),
    [sym_line_comment] = ACTIONS(7),
  },
  [2920] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1760),
    [anon_sym_LPAREN] = ACTIONS(1760),
    [anon_sym_LBRACE] = ACTIONS(1760),
    [anon_sym_PLUS] = ACTIONS(1760),
    [anon_sym_COMMA] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(7139),
    [sym_line_comment] = ACTIONS(7),
  },
  [2921] = {
    [sym_function_modifiers] = STATE(2402),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2417),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2919),
    [sym_array_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_tuple_type] = STATE(2417),
    [sym_unit_type] = STATE(2417),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2417),
    [sym_reference_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_empty_type] = STATE(2417),
    [sym_dynamic_type] = STATE(2417),
    [sym_macro_invocation] = STATE(2417),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2405),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(5312),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(5314),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5318),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5322),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2922] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1794),
    [anon_sym_LPAREN] = ACTIONS(1794),
    [anon_sym_LBRACE] = ACTIONS(1794),
    [anon_sym_PLUS] = ACTIONS(1794),
    [anon_sym_COMMA] = ACTIONS(1794),
    [anon_sym_DASH_GT] = ACTIONS(7141),
    [sym_line_comment] = ACTIONS(7),
  },
  [2923] = {
    [sym_parameters] = STATE(3280),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [2924] = {
    [sym_parameters] = STATE(3281),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [2925] = {
    [sym_parameters] = STATE(3280),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [2926] = {
    [sym_function_modifiers] = STATE(2402),
    [sym_higher_ranked_trait_bound] = STATE(2418),
    [sym_removed_trait_bound] = STATE(2418),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2419),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2419),
    [sym_array_type] = STATE(2419),
    [sym_function_type] = STATE(2419),
    [sym_tuple_type] = STATE(2419),
    [sym_unit_type] = STATE(2419),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2419),
    [sym_reference_type] = STATE(2419),
    [sym_pointer_type] = STATE(2419),
    [sym_empty_type] = STATE(2419),
    [sym_dynamic_type] = STATE(2419),
    [sym_macro_invocation] = STATE(2419),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2405),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(5312),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(5314),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_QMARK] = ACTIONS(5316),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5318),
    [anon_sym_for] = ACTIONS(5320),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5322),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2927] = {
    [aux_sym_trait_bounds_repeat1] = STATE(3282),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5344),
    [anon_sym_LPAREN] = ACTIONS(5344),
    [anon_sym_LBRACE] = ACTIONS(5344),
    [anon_sym_PLUS] = ACTIONS(6443),
    [anon_sym_COMMA] = ACTIONS(5344),
    [sym_line_comment] = ACTIONS(7),
  },
  [2928] = {
    [sym_function_modifiers] = STATE(2402),
    [sym_higher_ranked_trait_bound] = STATE(2418),
    [sym_removed_trait_bound] = STATE(2418),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2419),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2419),
    [sym_array_type] = STATE(2419),
    [sym_function_type] = STATE(2419),
    [sym_tuple_type] = STATE(2419),
    [sym_unit_type] = STATE(2419),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2419),
    [sym_reference_type] = STATE(2419),
    [sym_pointer_type] = STATE(2419),
    [sym_empty_type] = STATE(2419),
    [sym_dynamic_type] = STATE(2419),
    [sym_macro_invocation] = STATE(2419),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2405),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(5312),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(5314),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_QMARK] = ACTIONS(5316),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5318),
    [anon_sym_for] = ACTIONS(5320),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5322),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2929] = {
    [sym_where_predicate] = STATE(2237),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1073),
    [sym_generic_type] = STATE(1074),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_reference_type] = STATE(1073),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1075),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(1948),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2134),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [2930] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(7143),
    [sym_mutable_specifier] = ACTIONS(7143),
    [sym_line_comment] = ACTIONS(7),
  },
  [2931] = {
    [sym_function_modifiers] = STATE(2936),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(385),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(3285),
    [sym_array_type] = STATE(385),
    [sym_function_type] = STATE(385),
    [sym_tuple_type] = STATE(385),
    [sym_unit_type] = STATE(385),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(385),
    [sym_reference_type] = STATE(385),
    [sym_pointer_type] = STATE(385),
    [sym_empty_type] = STATE(385),
    [sym_dynamic_type] = STATE(385),
    [sym_macro_invocation] = STATE(385),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2939),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(6450),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(6452),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6456),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(7145),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6460),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2932] = {
    [sym_function_modifiers] = STATE(2936),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1759),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(3286),
    [sym_array_type] = STATE(1759),
    [sym_function_type] = STATE(1759),
    [sym_tuple_type] = STATE(1759),
    [sym_unit_type] = STATE(1759),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1759),
    [sym_reference_type] = STATE(1759),
    [sym_pointer_type] = STATE(1759),
    [sym_empty_type] = STATE(1759),
    [sym_dynamic_type] = STATE(1759),
    [sym_macro_invocation] = STATE(1759),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2939),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(6450),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(6452),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6456),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6460),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2933] = {
    [sym_parameters] = STATE(3287),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [2934] = {
    [sym_type_parameters] = STATE(3288),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(3393),
    [sym_line_comment] = ACTIONS(7),
  },
  [2935] = {
    [sym_parameters] = STATE(3289),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_BANG] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [2936] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(3292),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_fn] = ACTIONS(7147),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7149),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [2937] = {
    [aux_sym_trait_bounds_repeat1] = STATE(3294),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(7151),
    [anon_sym_COMMA] = ACTIONS(3395),
    [sym_line_comment] = ACTIONS(7),
  },
  [2938] = {
    [aux_sym_trait_bounds_repeat1] = STATE(3294),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(7153),
    [anon_sym_COMMA] = ACTIONS(3395),
    [sym_line_comment] = ACTIONS(7),
  },
  [2939] = {
    [sym_parameters] = STATE(3287),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(783),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(783),
    [anon_sym_COMMA] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [2940] = {
    [sym_where_predicate] = STATE(2237),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1753),
    [sym_generic_type] = STATE(1754),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_reference_type] = STATE(1753),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1755),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6121),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(1948),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3389),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [2941] = {
    [aux_sym_where_clause_repeat1] = STATE(2941),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6119),
    [anon_sym_COMMA] = ACTIONS(7155),
    [sym_line_comment] = ACTIONS(7),
  },
  [2942] = {
    [sym_raw_string_literal] = ACTIONS(7158),
    [sym_float_literal] = ACTIONS(7158),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(7158),
    [anon_sym_SEMI] = ACTIONS(7158),
    [anon_sym_macro_rules_BANG] = ACTIONS(7158),
    [anon_sym_LPAREN] = ACTIONS(7158),
    [anon_sym_LBRACE] = ACTIONS(7158),
    [anon_sym_RBRACE] = ACTIONS(7158),
    [anon_sym_LBRACK] = ACTIONS(7158),
    [anon_sym_STAR] = ACTIONS(7158),
    [anon_sym_u8] = ACTIONS(7160),
    [anon_sym_i8] = ACTIONS(7160),
    [anon_sym_u16] = ACTIONS(7160),
    [anon_sym_i16] = ACTIONS(7160),
    [anon_sym_u32] = ACTIONS(7160),
    [anon_sym_i32] = ACTIONS(7160),
    [anon_sym_u64] = ACTIONS(7160),
    [anon_sym_i64] = ACTIONS(7160),
    [anon_sym_u128] = ACTIONS(7160),
    [anon_sym_i128] = ACTIONS(7160),
    [anon_sym_isize] = ACTIONS(7160),
    [anon_sym_usize] = ACTIONS(7160),
    [anon_sym_f32] = ACTIONS(7160),
    [anon_sym_f64] = ACTIONS(7160),
    [anon_sym_bool] = ACTIONS(7160),
    [anon_sym_str] = ACTIONS(7160),
    [anon_sym_char] = ACTIONS(7160),
    [anon_sym_AMP] = ACTIONS(7158),
    [anon_sym_DASH] = ACTIONS(7158),
    [anon_sym_COLON_COLON] = ACTIONS(7158),
    [anon_sym_BANG] = ACTIONS(7158),
    [anon_sym_POUND] = ACTIONS(7158),
    [anon_sym_LT] = ACTIONS(7158),
    [anon_sym_PIPE] = ACTIONS(7158),
    [anon_sym_SQUOTE] = ACTIONS(7160),
    [anon_sym_DOT_DOT] = ACTIONS(7158),
    [anon_sym_break] = ACTIONS(7160),
    [anon_sym_const] = ACTIONS(7160),
    [anon_sym_continue] = ACTIONS(7160),
    [anon_sym_default] = ACTIONS(7160),
    [anon_sym_enum] = ACTIONS(7160),
    [anon_sym_fn] = ACTIONS(7160),
    [anon_sym_for] = ACTIONS(7160),
    [anon_sym_if] = ACTIONS(7160),
    [anon_sym_impl] = ACTIONS(7160),
    [anon_sym_let] = ACTIONS(7160),
    [anon_sym_loop] = ACTIONS(7160),
    [anon_sym_match] = ACTIONS(7160),
    [anon_sym_mod] = ACTIONS(7160),
    [anon_sym_pub] = ACTIONS(7160),
    [anon_sym_return] = ACTIONS(7160),
    [anon_sym_static] = ACTIONS(7160),
    [anon_sym_struct] = ACTIONS(7160),
    [anon_sym_trait] = ACTIONS(7160),
    [anon_sym_type] = ACTIONS(7160),
    [anon_sym_union] = ACTIONS(7160),
    [anon_sym_unsafe] = ACTIONS(7160),
    [anon_sym_use] = ACTIONS(7160),
    [anon_sym_while] = ACTIONS(7160),
    [anon_sym_extern] = ACTIONS(7160),
    [anon_sym_move] = ACTIONS(7160),
    [sym_integer_literal] = ACTIONS(7158),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7158),
    [sym_char_literal] = ACTIONS(7158),
    [anon_sym_true] = ACTIONS(7160),
    [anon_sym_false] = ACTIONS(7160),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7160),
    [sym_self] = ACTIONS(7160),
    [sym_super] = ACTIONS(7160),
    [sym_crate] = ACTIONS(7160),
    [sym_metavariable] = ACTIONS(7158),
  },
  [2943] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(3221),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_STAR] = ACTIONS(3221),
    [anon_sym_u8] = ACTIONS(3223),
    [anon_sym_i8] = ACTIONS(3223),
    [anon_sym_u16] = ACTIONS(3223),
    [anon_sym_i16] = ACTIONS(3223),
    [anon_sym_u32] = ACTIONS(3223),
    [anon_sym_i32] = ACTIONS(3223),
    [anon_sym_u64] = ACTIONS(3223),
    [anon_sym_i64] = ACTIONS(3223),
    [anon_sym_u128] = ACTIONS(3223),
    [anon_sym_i128] = ACTIONS(3223),
    [anon_sym_isize] = ACTIONS(3223),
    [anon_sym_usize] = ACTIONS(3223),
    [anon_sym_f32] = ACTIONS(3223),
    [anon_sym_f64] = ACTIONS(3223),
    [anon_sym_bool] = ACTIONS(3223),
    [anon_sym_str] = ACTIONS(3223),
    [anon_sym_char] = ACTIONS(3223),
    [anon_sym_AMP] = ACTIONS(3221),
    [anon_sym_COLON_COLON] = ACTIONS(3221),
    [anon_sym_BANG] = ACTIONS(3221),
    [anon_sym_LT] = ACTIONS(3221),
    [anon_sym_SQUOTE] = ACTIONS(3221),
    [anon_sym_const] = ACTIONS(3223),
    [anon_sym_default] = ACTIONS(3223),
    [anon_sym_fn] = ACTIONS(3223),
    [anon_sym_unsafe] = ACTIONS(3223),
    [anon_sym_extern] = ACTIONS(3223),
    [anon_sym_dyn] = ACTIONS(3223),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3223),
    [sym_self] = ACTIONS(3223),
    [sym_super] = ACTIONS(3223),
    [sym_crate] = ACTIONS(3223),
    [sym_metavariable] = ACTIONS(3221),
  },
  [2944] = {
    [aux_sym_type_parameters_repeat1] = STATE(1666),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(2022),
    [anon_sym_GT] = ACTIONS(7162),
    [sym_line_comment] = ACTIONS(7),
  },
  [2945] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(3229),
    [anon_sym_LBRACK] = ACTIONS(3229),
    [anon_sym_STAR] = ACTIONS(3229),
    [anon_sym_u8] = ACTIONS(3231),
    [anon_sym_i8] = ACTIONS(3231),
    [anon_sym_u16] = ACTIONS(3231),
    [anon_sym_i16] = ACTIONS(3231),
    [anon_sym_u32] = ACTIONS(3231),
    [anon_sym_i32] = ACTIONS(3231),
    [anon_sym_u64] = ACTIONS(3231),
    [anon_sym_i64] = ACTIONS(3231),
    [anon_sym_u128] = ACTIONS(3231),
    [anon_sym_i128] = ACTIONS(3231),
    [anon_sym_isize] = ACTIONS(3231),
    [anon_sym_usize] = ACTIONS(3231),
    [anon_sym_f32] = ACTIONS(3231),
    [anon_sym_f64] = ACTIONS(3231),
    [anon_sym_bool] = ACTIONS(3231),
    [anon_sym_str] = ACTIONS(3231),
    [anon_sym_char] = ACTIONS(3231),
    [anon_sym_AMP] = ACTIONS(3229),
    [anon_sym_COLON_COLON] = ACTIONS(3229),
    [anon_sym_BANG] = ACTIONS(3229),
    [anon_sym_LT] = ACTIONS(3229),
    [anon_sym_SQUOTE] = ACTIONS(3229),
    [anon_sym_const] = ACTIONS(3231),
    [anon_sym_default] = ACTIONS(3231),
    [anon_sym_fn] = ACTIONS(3231),
    [anon_sym_unsafe] = ACTIONS(3231),
    [anon_sym_extern] = ACTIONS(3231),
    [anon_sym_dyn] = ACTIONS(3231),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3231),
    [sym_self] = ACTIONS(3231),
    [sym_super] = ACTIONS(3231),
    [sym_crate] = ACTIONS(3231),
    [sym_metavariable] = ACTIONS(3229),
  },
  [2946] = {
    [aux_sym_type_parameters_repeat1] = STATE(1666),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(2022),
    [anon_sym_GT] = ACTIONS(7164),
    [sym_line_comment] = ACTIONS(7),
  },
  [2947] = {
    [sym_function_modifiers] = STATE(1097),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2156),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1102),
    [sym_array_type] = STATE(2156),
    [sym_function_type] = STATE(2156),
    [sym_tuple_type] = STATE(2156),
    [sym_unit_type] = STATE(2156),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2156),
    [sym_reference_type] = STATE(2156),
    [sym_pointer_type] = STATE(2156),
    [sym_empty_type] = STATE(2156),
    [sym_abstract_type] = STATE(2157),
    [sym_dynamic_type] = STATE(2156),
    [sym_macro_invocation] = STATE(2156),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2156),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2162),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2166),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2948] = {
    [sym_function_modifiers] = STATE(1097),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2158),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1102),
    [sym_array_type] = STATE(2158),
    [sym_function_type] = STATE(2158),
    [sym_tuple_type] = STATE(2158),
    [sym_unit_type] = STATE(2158),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2158),
    [sym_reference_type] = STATE(2158),
    [sym_pointer_type] = STATE(2158),
    [sym_empty_type] = STATE(2158),
    [sym_abstract_type] = STATE(2159),
    [sym_dynamic_type] = STATE(2158),
    [sym_macro_invocation] = STATE(2158),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2156),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2162),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2166),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [2949] = {
    [sym_raw_string_literal] = ACTIONS(7166),
    [sym_float_literal] = ACTIONS(7166),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(7166),
    [anon_sym_SEMI] = ACTIONS(7166),
    [anon_sym_macro_rules_BANG] = ACTIONS(7166),
    [anon_sym_LPAREN] = ACTIONS(7166),
    [anon_sym_LBRACE] = ACTIONS(7166),
    [anon_sym_RBRACE] = ACTIONS(7166),
    [anon_sym_LBRACK] = ACTIONS(7166),
    [anon_sym_STAR] = ACTIONS(7166),
    [anon_sym_u8] = ACTIONS(7168),
    [anon_sym_i8] = ACTIONS(7168),
    [anon_sym_u16] = ACTIONS(7168),
    [anon_sym_i16] = ACTIONS(7168),
    [anon_sym_u32] = ACTIONS(7168),
    [anon_sym_i32] = ACTIONS(7168),
    [anon_sym_u64] = ACTIONS(7168),
    [anon_sym_i64] = ACTIONS(7168),
    [anon_sym_u128] = ACTIONS(7168),
    [anon_sym_i128] = ACTIONS(7168),
    [anon_sym_isize] = ACTIONS(7168),
    [anon_sym_usize] = ACTIONS(7168),
    [anon_sym_f32] = ACTIONS(7168),
    [anon_sym_f64] = ACTIONS(7168),
    [anon_sym_bool] = ACTIONS(7168),
    [anon_sym_str] = ACTIONS(7168),
    [anon_sym_char] = ACTIONS(7168),
    [anon_sym_AMP] = ACTIONS(7166),
    [anon_sym_DASH] = ACTIONS(7166),
    [anon_sym_COLON_COLON] = ACTIONS(7166),
    [anon_sym_BANG] = ACTIONS(7166),
    [anon_sym_POUND] = ACTIONS(7166),
    [anon_sym_LT] = ACTIONS(7166),
    [anon_sym_PIPE] = ACTIONS(7166),
    [anon_sym_SQUOTE] = ACTIONS(7168),
    [anon_sym_DOT_DOT] = ACTIONS(7166),
    [anon_sym_break] = ACTIONS(7168),
    [anon_sym_const] = ACTIONS(7168),
    [anon_sym_continue] = ACTIONS(7168),
    [anon_sym_default] = ACTIONS(7168),
    [anon_sym_enum] = ACTIONS(7168),
    [anon_sym_fn] = ACTIONS(7168),
    [anon_sym_for] = ACTIONS(7168),
    [anon_sym_if] = ACTIONS(7168),
    [anon_sym_impl] = ACTIONS(7168),
    [anon_sym_let] = ACTIONS(7168),
    [anon_sym_loop] = ACTIONS(7168),
    [anon_sym_match] = ACTIONS(7168),
    [anon_sym_mod] = ACTIONS(7168),
    [anon_sym_pub] = ACTIONS(7168),
    [anon_sym_return] = ACTIONS(7168),
    [anon_sym_static] = ACTIONS(7168),
    [anon_sym_struct] = ACTIONS(7168),
    [anon_sym_trait] = ACTIONS(7168),
    [anon_sym_type] = ACTIONS(7168),
    [anon_sym_union] = ACTIONS(7168),
    [anon_sym_unsafe] = ACTIONS(7168),
    [anon_sym_use] = ACTIONS(7168),
    [anon_sym_while] = ACTIONS(7168),
    [anon_sym_extern] = ACTIONS(7168),
    [anon_sym_move] = ACTIONS(7168),
    [sym_integer_literal] = ACTIONS(7166),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7166),
    [sym_char_literal] = ACTIONS(7166),
    [anon_sym_true] = ACTIONS(7168),
    [anon_sym_false] = ACTIONS(7168),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7168),
    [sym_self] = ACTIONS(7168),
    [sym_super] = ACTIONS(7168),
    [sym_crate] = ACTIONS(7168),
    [sym_metavariable] = ACTIONS(7166),
  },
  [2950] = {
    [sym_declaration_list] = STATE(3299),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [sym_line_comment] = ACTIONS(7),
  },
  [2951] = {
    [sym_declaration_list] = STATE(3300),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(425),
    [sym_line_comment] = ACTIONS(7),
  },
  [2952] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3301),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(3301),
    [sym_macro_invocation] = STATE(3301),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3301),
    [sym_unary_expression] = STATE(3301),
    [sym_try_expression] = STATE(3301),
    [sym_reference_expression] = STATE(3301),
    [sym_binary_expression] = STATE(3301),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3301),
    [sym_call_expression] = STATE(3301),
    [sym_array_expression] = STATE(3301),
    [sym_parenthesized_expression] = STATE(3301),
    [sym_tuple_expression] = STATE(3301),
    [sym_unit_expression] = STATE(3301),
    [sym_struct_expression] = STATE(3301),
    [sym_if_expression] = STATE(3301),
    [sym_if_let_expression] = STATE(3301),
    [sym_match_expression] = STATE(3301),
    [sym_while_expression] = STATE(3301),
    [sym_while_let_expression] = STATE(3301),
    [sym_loop_expression] = STATE(3301),
    [sym_for_expression] = STATE(3301),
    [sym_closure_expression] = STATE(3301),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3301),
    [sym_continue_expression] = STATE(3301),
    [sym_index_expression] = STATE(3301),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3301),
    [sym_block] = STATE(3301),
    [sym__literal] = STATE(3301),
    [sym_string_literal] = STATE(3301),
    [sym_boolean_literal] = STATE(3301),
    [sym_raw_string_literal] = ACTIONS(7170),
    [sym_float_literal] = ACTIONS(7170),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(7170),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7170),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [2953] = {
    [sym_if_expression] = STATE(2043),
    [sym_if_let_expression] = STATE(2043),
    [sym_block] = STATE(2043),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(7172),
    [sym_line_comment] = ACTIONS(7),
  },
  [2954] = {
    [sym_function_modifiers] = STATE(2459),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2001),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(2460),
    [sym_array_type] = STATE(2001),
    [sym_function_type] = STATE(2001),
    [sym_tuple_type] = STATE(2001),
    [sym_unit_type] = STATE(2001),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2001),
    [sym_reference_type] = STATE(2001),
    [sym_pointer_type] = STATE(2001),
    [sym_empty_type] = STATE(2001),
    [sym_dynamic_type] = STATE(2001),
    [sym_macro_invocation] = STATE(2001),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(2461),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(5429),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5431),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5433),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2955] = {
    [sym_function_modifiers] = STATE(2459),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2003),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(2460),
    [sym_array_type] = STATE(2003),
    [sym_function_type] = STATE(2003),
    [sym_tuple_type] = STATE(2003),
    [sym_unit_type] = STATE(2003),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2003),
    [sym_reference_type] = STATE(2003),
    [sym_pointer_type] = STATE(2003),
    [sym_empty_type] = STATE(2003),
    [sym_dynamic_type] = STATE(2003),
    [sym_macro_invocation] = STATE(2003),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(2461),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(5429),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5431),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5433),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2956] = {
    [sym_function_modifiers] = STATE(2459),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2003),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(2460),
    [sym_array_type] = STATE(2003),
    [sym_function_type] = STATE(2003),
    [sym_tuple_type] = STATE(2003),
    [sym_unit_type] = STATE(2003),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2003),
    [sym_reference_type] = STATE(2003),
    [sym_pointer_type] = STATE(2003),
    [sym_empty_type] = STATE(2003),
    [sym_dynamic_type] = STATE(2003),
    [sym_macro_invocation] = STATE(2003),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(2461),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_PLUS] = ACTIONS(6524),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(5429),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5431),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_mutable_specifier] = ACTIONS(7174),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5433),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2957] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1760),
    [anon_sym_RBRACE] = ACTIONS(1760),
    [anon_sym_LBRACK] = ACTIONS(1760),
    [anon_sym_PLUS] = ACTIONS(4443),
    [anon_sym_STAR] = ACTIONS(4443),
    [anon_sym_COMMA] = ACTIONS(1760),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_DASH] = ACTIONS(4443),
    [anon_sym_DOT] = ACTIONS(4443),
    [anon_sym_DASH_EQ] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(7176),
    [anon_sym_BANG_EQ] = ACTIONS(1760),
    [anon_sym_STAR_EQ] = ACTIONS(1760),
    [anon_sym_SLASH] = ACTIONS(4443),
    [anon_sym_SLASH_EQ] = ACTIONS(1760),
    [anon_sym_AMP_AMP] = ACTIONS(1760),
    [anon_sym_AMP_EQ] = ACTIONS(1760),
    [anon_sym_PERCENT] = ACTIONS(4443),
    [anon_sym_PERCENT_EQ] = ACTIONS(1760),
    [anon_sym_CARET] = ACTIONS(4443),
    [anon_sym_CARET_EQ] = ACTIONS(1760),
    [anon_sym_PLUS_EQ] = ACTIONS(1760),
    [anon_sym_LT] = ACTIONS(4443),
    [anon_sym_LT_LT] = ACTIONS(4443),
    [anon_sym_LT_LT_EQ] = ACTIONS(1760),
    [anon_sym_LT_EQ] = ACTIONS(1760),
    [anon_sym_EQ] = ACTIONS(4443),
    [anon_sym_EQ_EQ] = ACTIONS(1760),
    [anon_sym_GT] = ACTIONS(4443),
    [anon_sym_GT_EQ] = ACTIONS(1760),
    [anon_sym_GT_GT] = ACTIONS(4443),
    [anon_sym_GT_GT_EQ] = ACTIONS(1760),
    [anon_sym_PIPE] = ACTIONS(4443),
    [anon_sym_PIPE_EQ] = ACTIONS(1760),
    [anon_sym_PIPE_PIPE] = ACTIONS(1760),
    [anon_sym_QMARK] = ACTIONS(1760),
    [anon_sym_DOT_DOT] = ACTIONS(4443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1760),
    [anon_sym_as] = ACTIONS(1760),
    [sym_line_comment] = ACTIONS(7),
  },
  [2958] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1794),
    [anon_sym_RBRACE] = ACTIONS(1794),
    [anon_sym_LBRACK] = ACTIONS(1794),
    [anon_sym_PLUS] = ACTIONS(4449),
    [anon_sym_STAR] = ACTIONS(4449),
    [anon_sym_COMMA] = ACTIONS(1794),
    [anon_sym_AMP] = ACTIONS(4449),
    [anon_sym_DASH] = ACTIONS(4449),
    [anon_sym_DOT] = ACTIONS(4449),
    [anon_sym_DASH_EQ] = ACTIONS(1794),
    [anon_sym_DASH_GT] = ACTIONS(7178),
    [anon_sym_BANG_EQ] = ACTIONS(1794),
    [anon_sym_STAR_EQ] = ACTIONS(1794),
    [anon_sym_SLASH] = ACTIONS(4449),
    [anon_sym_SLASH_EQ] = ACTIONS(1794),
    [anon_sym_AMP_AMP] = ACTIONS(1794),
    [anon_sym_AMP_EQ] = ACTIONS(1794),
    [anon_sym_PERCENT] = ACTIONS(4449),
    [anon_sym_PERCENT_EQ] = ACTIONS(1794),
    [anon_sym_CARET] = ACTIONS(4449),
    [anon_sym_CARET_EQ] = ACTIONS(1794),
    [anon_sym_PLUS_EQ] = ACTIONS(1794),
    [anon_sym_LT] = ACTIONS(4449),
    [anon_sym_LT_LT] = ACTIONS(4449),
    [anon_sym_LT_LT_EQ] = ACTIONS(1794),
    [anon_sym_LT_EQ] = ACTIONS(1794),
    [anon_sym_EQ] = ACTIONS(4449),
    [anon_sym_EQ_EQ] = ACTIONS(1794),
    [anon_sym_GT] = ACTIONS(4449),
    [anon_sym_GT_EQ] = ACTIONS(1794),
    [anon_sym_GT_GT] = ACTIONS(4449),
    [anon_sym_GT_GT_EQ] = ACTIONS(1794),
    [anon_sym_PIPE] = ACTIONS(4449),
    [anon_sym_PIPE_EQ] = ACTIONS(1794),
    [anon_sym_PIPE_PIPE] = ACTIONS(1794),
    [anon_sym_QMARK] = ACTIONS(1794),
    [anon_sym_DOT_DOT] = ACTIONS(4449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1794),
    [anon_sym_as] = ACTIONS(1794),
    [sym_line_comment] = ACTIONS(7),
  },
  [2959] = {
    [sym_parameters] = STATE(3305),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [sym_line_comment] = ACTIONS(7),
  },
  [2960] = {
    [sym_parameters] = STATE(3306),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [2961] = {
    [sym_parameters] = STATE(3305),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [2962] = {
    [sym_function_modifiers] = STATE(2459),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2016),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(2016),
    [sym_array_type] = STATE(2016),
    [sym_function_type] = STATE(2016),
    [sym_tuple_type] = STATE(2016),
    [sym_unit_type] = STATE(2016),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2016),
    [sym_reference_type] = STATE(2016),
    [sym_pointer_type] = STATE(2016),
    [sym_empty_type] = STATE(2016),
    [sym_dynamic_type] = STATE(2016),
    [sym_macro_invocation] = STATE(2016),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(2461),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(5429),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(4453),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5431),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5433),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2963] = {
    [sym_function_modifiers] = STATE(2459),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2016),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(2460),
    [sym_array_type] = STATE(2016),
    [sym_function_type] = STATE(2016),
    [sym_tuple_type] = STATE(2016),
    [sym_unit_type] = STATE(2016),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2016),
    [sym_reference_type] = STATE(2016),
    [sym_pointer_type] = STATE(2016),
    [sym_empty_type] = STATE(2016),
    [sym_dynamic_type] = STATE(2016),
    [sym_macro_invocation] = STATE(2016),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(2461),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(5429),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5431),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5433),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [2964] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6815),
    [anon_sym_LPAREN] = ACTIONS(6815),
    [anon_sym_RPAREN] = ACTIONS(6815),
    [anon_sym_LBRACE] = ACTIONS(6815),
    [anon_sym_RBRACE] = ACTIONS(6815),
    [anon_sym_LBRACK] = ACTIONS(6815),
    [anon_sym_RBRACK] = ACTIONS(6815),
    [anon_sym_PLUS] = ACTIONS(6817),
    [anon_sym_STAR] = ACTIONS(6817),
    [anon_sym_COMMA] = ACTIONS(6815),
    [anon_sym_AMP] = ACTIONS(6817),
    [anon_sym_DASH] = ACTIONS(6817),
    [anon_sym_DOT] = ACTIONS(6817),
    [anon_sym_DASH_EQ] = ACTIONS(6815),
    [anon_sym_COLON_COLON] = ACTIONS(6815),
    [anon_sym_BANG_EQ] = ACTIONS(6815),
    [anon_sym_STAR_EQ] = ACTIONS(6815),
    [anon_sym_SLASH] = ACTIONS(6817),
    [anon_sym_SLASH_EQ] = ACTIONS(6815),
    [anon_sym_AMP_AMP] = ACTIONS(6815),
    [anon_sym_AMP_EQ] = ACTIONS(6815),
    [anon_sym_PERCENT] = ACTIONS(6817),
    [anon_sym_PERCENT_EQ] = ACTIONS(6815),
    [anon_sym_CARET] = ACTIONS(6817),
    [anon_sym_CARET_EQ] = ACTIONS(6815),
    [anon_sym_PLUS_EQ] = ACTIONS(6815),
    [anon_sym_LT] = ACTIONS(6817),
    [anon_sym_LT_LT] = ACTIONS(6817),
    [anon_sym_LT_LT_EQ] = ACTIONS(6815),
    [anon_sym_LT_EQ] = ACTIONS(6815),
    [anon_sym_EQ] = ACTIONS(6817),
    [anon_sym_EQ_EQ] = ACTIONS(6815),
    [anon_sym_GT] = ACTIONS(6817),
    [anon_sym_GT_EQ] = ACTIONS(6815),
    [anon_sym_GT_GT] = ACTIONS(6817),
    [anon_sym_GT_GT_EQ] = ACTIONS(6815),
    [anon_sym_PIPE] = ACTIONS(6817),
    [anon_sym_PIPE_EQ] = ACTIONS(6815),
    [anon_sym_PIPE_PIPE] = ACTIONS(6815),
    [anon_sym_QMARK] = ACTIONS(6815),
    [anon_sym_DOT_DOT] = ACTIONS(6817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6815),
    [anon_sym_as] = ACTIONS(6815),
    [sym_line_comment] = ACTIONS(7),
  },
  [2965] = {
    [sym_raw_string_literal] = ACTIONS(6588),
    [sym_float_literal] = ACTIONS(6588),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6588),
    [anon_sym_LPAREN] = ACTIONS(7180),
    [anon_sym_RPAREN] = ACTIONS(7180),
    [anon_sym_LBRACE] = ACTIONS(6588),
    [anon_sym_EQ_GT] = ACTIONS(6588),
    [anon_sym_LBRACK] = ACTIONS(7180),
    [anon_sym_RBRACK] = ACTIONS(7180),
    [anon_sym_COLON] = ACTIONS(6590),
    [anon_sym_DOLLAR] = ACTIONS(6590),
    [anon_sym_PLUS] = ACTIONS(7183),
    [anon_sym_STAR] = ACTIONS(7183),
    [anon_sym_COMMA] = ACTIONS(7180),
    [anon_sym_u8] = ACTIONS(6590),
    [anon_sym_i8] = ACTIONS(6590),
    [anon_sym_u16] = ACTIONS(6590),
    [anon_sym_i16] = ACTIONS(6590),
    [anon_sym_u32] = ACTIONS(6590),
    [anon_sym_i32] = ACTIONS(6590),
    [anon_sym_u64] = ACTIONS(6590),
    [anon_sym_i64] = ACTIONS(6590),
    [anon_sym_u128] = ACTIONS(6590),
    [anon_sym_i128] = ACTIONS(6590),
    [anon_sym_isize] = ACTIONS(6590),
    [anon_sym_usize] = ACTIONS(6590),
    [anon_sym_f32] = ACTIONS(6590),
    [anon_sym_f64] = ACTIONS(6590),
    [anon_sym_bool] = ACTIONS(6590),
    [anon_sym_str] = ACTIONS(6590),
    [anon_sym_char] = ACTIONS(6590),
    [anon_sym__] = ACTIONS(6590),
    [anon_sym_AMP] = ACTIONS(7183),
    [anon_sym_DASH] = ACTIONS(7183),
    [anon_sym_DOT] = ACTIONS(7183),
    [anon_sym_DASH_EQ] = ACTIONS(7180),
    [anon_sym_DASH_GT] = ACTIONS(6588),
    [anon_sym_COLON_COLON] = ACTIONS(6588),
    [anon_sym_BANG] = ACTIONS(6590),
    [anon_sym_BANG_EQ] = ACTIONS(7180),
    [anon_sym_AT] = ACTIONS(6588),
    [anon_sym_STAR_EQ] = ACTIONS(7180),
    [anon_sym_SLASH] = ACTIONS(7183),
    [anon_sym_SLASH_EQ] = ACTIONS(7180),
    [anon_sym_AMP_AMP] = ACTIONS(7180),
    [anon_sym_AMP_EQ] = ACTIONS(7180),
    [anon_sym_POUND] = ACTIONS(6588),
    [anon_sym_PERCENT] = ACTIONS(7183),
    [anon_sym_PERCENT_EQ] = ACTIONS(7180),
    [anon_sym_CARET] = ACTIONS(7183),
    [anon_sym_CARET_EQ] = ACTIONS(7180),
    [anon_sym_PLUS_EQ] = ACTIONS(7180),
    [anon_sym_LT] = ACTIONS(7183),
    [anon_sym_LT_LT] = ACTIONS(7183),
    [anon_sym_LT_LT_EQ] = ACTIONS(7180),
    [anon_sym_LT_EQ] = ACTIONS(7180),
    [anon_sym_EQ] = ACTIONS(7183),
    [anon_sym_EQ_EQ] = ACTIONS(7180),
    [anon_sym_GT] = ACTIONS(7183),
    [anon_sym_GT_EQ] = ACTIONS(7180),
    [anon_sym_GT_GT] = ACTIONS(7183),
    [anon_sym_GT_GT_EQ] = ACTIONS(7180),
    [anon_sym_PIPE] = ACTIONS(7183),
    [anon_sym_PIPE_EQ] = ACTIONS(7180),
    [anon_sym_PIPE_PIPE] = ACTIONS(7180),
    [anon_sym_TILDE] = ACTIONS(6588),
    [anon_sym_QMARK] = ACTIONS(7180),
    [anon_sym_SQUOTE] = ACTIONS(6590),
    [anon_sym_DOT_DOT] = ACTIONS(7183),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7180),
    [anon_sym_as] = ACTIONS(7183),
    [anon_sym_break] = ACTIONS(6590),
    [anon_sym_const] = ACTIONS(6590),
    [anon_sym_continue] = ACTIONS(6590),
    [anon_sym_default] = ACTIONS(6590),
    [anon_sym_enum] = ACTIONS(6590),
    [anon_sym_fn] = ACTIONS(6590),
    [anon_sym_for] = ACTIONS(6590),
    [anon_sym_if] = ACTIONS(6590),
    [anon_sym_impl] = ACTIONS(6590),
    [anon_sym_let] = ACTIONS(6590),
    [anon_sym_loop] = ACTIONS(6590),
    [anon_sym_match] = ACTIONS(6590),
    [anon_sym_mod] = ACTIONS(6590),
    [anon_sym_pub] = ACTIONS(6590),
    [anon_sym_return] = ACTIONS(6590),
    [anon_sym_static] = ACTIONS(6590),
    [anon_sym_struct] = ACTIONS(6590),
    [anon_sym_trait] = ACTIONS(6590),
    [anon_sym_type] = ACTIONS(6590),
    [anon_sym_union] = ACTIONS(6590),
    [anon_sym_unsafe] = ACTIONS(6590),
    [anon_sym_use] = ACTIONS(6590),
    [anon_sym_where] = ACTIONS(6590),
    [anon_sym_while] = ACTIONS(6590),
    [sym_mutable_specifier] = ACTIONS(6590),
    [sym_integer_literal] = ACTIONS(6588),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6588),
    [sym_char_literal] = ACTIONS(6588),
    [anon_sym_true] = ACTIONS(6590),
    [anon_sym_false] = ACTIONS(6590),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6590),
    [sym_self] = ACTIONS(6590),
    [sym_super] = ACTIONS(6590),
    [sym_crate] = ACTIONS(6590),
    [sym_metavariable] = ACTIONS(6588),
  },
  [2966] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(7186),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(7189),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_BANG_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH] = ACTIONS(563),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(563),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_LT] = ACTIONS(577),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(581),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(577),
    [anon_sym_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(589),
    [anon_sym_as] = ACTIONS(591),
    [sym_line_comment] = ACTIONS(7),
  },
  [2967] = {
    [sym_raw_string_literal] = ACTIONS(6588),
    [sym_float_literal] = ACTIONS(6588),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6588),
    [anon_sym_LPAREN] = ACTIONS(6588),
    [anon_sym_RPAREN] = ACTIONS(6588),
    [anon_sym_LBRACE] = ACTIONS(6588),
    [anon_sym_RBRACE] = ACTIONS(6588),
    [anon_sym_EQ_GT] = ACTIONS(6588),
    [anon_sym_LBRACK] = ACTIONS(6588),
    [anon_sym_RBRACK] = ACTIONS(6588),
    [anon_sym_COLON] = ACTIONS(6590),
    [anon_sym_DOLLAR] = ACTIONS(6590),
    [anon_sym_PLUS] = ACTIONS(6590),
    [anon_sym_STAR] = ACTIONS(6590),
    [anon_sym_COMMA] = ACTIONS(6588),
    [anon_sym_u8] = ACTIONS(6590),
    [anon_sym_i8] = ACTIONS(6590),
    [anon_sym_u16] = ACTIONS(6590),
    [anon_sym_i16] = ACTIONS(6590),
    [anon_sym_u32] = ACTIONS(6590),
    [anon_sym_i32] = ACTIONS(6590),
    [anon_sym_u64] = ACTIONS(6590),
    [anon_sym_i64] = ACTIONS(6590),
    [anon_sym_u128] = ACTIONS(6590),
    [anon_sym_i128] = ACTIONS(6590),
    [anon_sym_isize] = ACTIONS(6590),
    [anon_sym_usize] = ACTIONS(6590),
    [anon_sym_f32] = ACTIONS(6590),
    [anon_sym_f64] = ACTIONS(6590),
    [anon_sym_bool] = ACTIONS(6590),
    [anon_sym_str] = ACTIONS(6590),
    [anon_sym_char] = ACTIONS(6590),
    [anon_sym__] = ACTIONS(6590),
    [anon_sym_AMP] = ACTIONS(6590),
    [anon_sym_DASH] = ACTIONS(6590),
    [anon_sym_DOT] = ACTIONS(6590),
    [anon_sym_DASH_EQ] = ACTIONS(6588),
    [anon_sym_DASH_GT] = ACTIONS(6588),
    [anon_sym_COLON_COLON] = ACTIONS(6588),
    [anon_sym_BANG] = ACTIONS(6590),
    [anon_sym_BANG_EQ] = ACTIONS(6588),
    [anon_sym_AT] = ACTIONS(6588),
    [anon_sym_STAR_EQ] = ACTIONS(6588),
    [anon_sym_SLASH] = ACTIONS(6590),
    [anon_sym_SLASH_EQ] = ACTIONS(6588),
    [anon_sym_AMP_AMP] = ACTIONS(6588),
    [anon_sym_AMP_EQ] = ACTIONS(6588),
    [anon_sym_POUND] = ACTIONS(6588),
    [anon_sym_PERCENT] = ACTIONS(6590),
    [anon_sym_PERCENT_EQ] = ACTIONS(6588),
    [anon_sym_CARET] = ACTIONS(6590),
    [anon_sym_CARET_EQ] = ACTIONS(6588),
    [anon_sym_PLUS_EQ] = ACTIONS(6588),
    [anon_sym_LT] = ACTIONS(6590),
    [anon_sym_LT_LT] = ACTIONS(6590),
    [anon_sym_LT_LT_EQ] = ACTIONS(6588),
    [anon_sym_LT_EQ] = ACTIONS(6588),
    [anon_sym_EQ] = ACTIONS(6590),
    [anon_sym_EQ_EQ] = ACTIONS(6588),
    [anon_sym_GT] = ACTIONS(6590),
    [anon_sym_GT_EQ] = ACTIONS(6588),
    [anon_sym_GT_GT] = ACTIONS(6590),
    [anon_sym_GT_GT_EQ] = ACTIONS(6588),
    [anon_sym_PIPE] = ACTIONS(6590),
    [anon_sym_PIPE_EQ] = ACTIONS(6588),
    [anon_sym_PIPE_PIPE] = ACTIONS(6588),
    [anon_sym_TILDE] = ACTIONS(6588),
    [anon_sym_QMARK] = ACTIONS(6588),
    [anon_sym_SQUOTE] = ACTIONS(6590),
    [anon_sym_DOT_DOT] = ACTIONS(6590),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6588),
    [anon_sym_as] = ACTIONS(6590),
    [anon_sym_break] = ACTIONS(6590),
    [anon_sym_const] = ACTIONS(6590),
    [anon_sym_continue] = ACTIONS(6590),
    [anon_sym_default] = ACTIONS(6590),
    [anon_sym_enum] = ACTIONS(6590),
    [anon_sym_fn] = ACTIONS(6590),
    [anon_sym_for] = ACTIONS(6590),
    [anon_sym_if] = ACTIONS(6590),
    [anon_sym_impl] = ACTIONS(6590),
    [anon_sym_let] = ACTIONS(6590),
    [anon_sym_loop] = ACTIONS(6590),
    [anon_sym_match] = ACTIONS(6590),
    [anon_sym_mod] = ACTIONS(6590),
    [anon_sym_pub] = ACTIONS(6590),
    [anon_sym_return] = ACTIONS(6590),
    [anon_sym_static] = ACTIONS(6590),
    [anon_sym_struct] = ACTIONS(6590),
    [anon_sym_trait] = ACTIONS(6590),
    [anon_sym_type] = ACTIONS(6590),
    [anon_sym_union] = ACTIONS(6590),
    [anon_sym_unsafe] = ACTIONS(6590),
    [anon_sym_use] = ACTIONS(6590),
    [anon_sym_where] = ACTIONS(6590),
    [anon_sym_while] = ACTIONS(6590),
    [sym_mutable_specifier] = ACTIONS(6590),
    [sym_integer_literal] = ACTIONS(6588),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6588),
    [sym_char_literal] = ACTIONS(6588),
    [anon_sym_true] = ACTIONS(6590),
    [anon_sym_false] = ACTIONS(6590),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6590),
    [sym_self] = ACTIONS(6590),
    [sym_super] = ACTIONS(6590),
    [sym_crate] = ACTIONS(6590),
    [sym_metavariable] = ACTIONS(6588),
  },
  [2968] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1972),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1972),
    [sym_unary_expression] = STATE(1972),
    [sym_try_expression] = STATE(1972),
    [sym_reference_expression] = STATE(1972),
    [sym_binary_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1972),
    [sym_call_expression] = STATE(1972),
    [sym_array_expression] = STATE(1972),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_tuple_expression] = STATE(1972),
    [sym_unit_expression] = STATE(1972),
    [sym_struct_expression] = STATE(1972),
    [sym_if_expression] = STATE(1972),
    [sym_if_let_expression] = STATE(1972),
    [sym_match_expression] = STATE(1972),
    [sym_while_expression] = STATE(1972),
    [sym_while_let_expression] = STATE(1972),
    [sym_loop_expression] = STATE(1972),
    [sym_for_expression] = STATE(1972),
    [sym_closure_expression] = STATE(1972),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1972),
    [sym_continue_expression] = STATE(1972),
    [sym_index_expression] = STATE(1972),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1972),
    [sym_block] = STATE(1972),
    [sym__literal] = STATE(1972),
    [sym_string_literal] = STATE(1972),
    [sym_boolean_literal] = STATE(1972),
    [sym_raw_string_literal] = ACTIONS(4375),
    [sym_float_literal] = ACTIONS(4375),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(7192),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(4375),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4375),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2969] = {
    [sym_raw_string_literal] = ACTIONS(6588),
    [sym_float_literal] = ACTIONS(6588),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6588),
    [anon_sym_LPAREN] = ACTIONS(7194),
    [anon_sym_RPAREN] = ACTIONS(7194),
    [anon_sym_LBRACE] = ACTIONS(6588),
    [anon_sym_EQ_GT] = ACTIONS(6588),
    [anon_sym_LBRACK] = ACTIONS(7194),
    [anon_sym_RBRACK] = ACTIONS(7194),
    [anon_sym_COLON] = ACTIONS(6590),
    [anon_sym_DOLLAR] = ACTIONS(6590),
    [anon_sym_PLUS] = ACTIONS(7197),
    [anon_sym_STAR] = ACTIONS(7197),
    [anon_sym_COMMA] = ACTIONS(7194),
    [anon_sym_u8] = ACTIONS(6590),
    [anon_sym_i8] = ACTIONS(6590),
    [anon_sym_u16] = ACTIONS(6590),
    [anon_sym_i16] = ACTIONS(6590),
    [anon_sym_u32] = ACTIONS(6590),
    [anon_sym_i32] = ACTIONS(6590),
    [anon_sym_u64] = ACTIONS(6590),
    [anon_sym_i64] = ACTIONS(6590),
    [anon_sym_u128] = ACTIONS(6590),
    [anon_sym_i128] = ACTIONS(6590),
    [anon_sym_isize] = ACTIONS(6590),
    [anon_sym_usize] = ACTIONS(6590),
    [anon_sym_f32] = ACTIONS(6590),
    [anon_sym_f64] = ACTIONS(6590),
    [anon_sym_bool] = ACTIONS(6590),
    [anon_sym_str] = ACTIONS(6590),
    [anon_sym_char] = ACTIONS(6590),
    [anon_sym__] = ACTIONS(6590),
    [anon_sym_AMP] = ACTIONS(7197),
    [anon_sym_DASH] = ACTIONS(7197),
    [anon_sym_DOT] = ACTIONS(7197),
    [anon_sym_DASH_EQ] = ACTIONS(7194),
    [anon_sym_DASH_GT] = ACTIONS(6588),
    [anon_sym_COLON_COLON] = ACTIONS(6588),
    [anon_sym_BANG] = ACTIONS(6590),
    [anon_sym_BANG_EQ] = ACTIONS(7194),
    [anon_sym_AT] = ACTIONS(6588),
    [anon_sym_STAR_EQ] = ACTIONS(7194),
    [anon_sym_SLASH] = ACTIONS(7197),
    [anon_sym_SLASH_EQ] = ACTIONS(7194),
    [anon_sym_AMP_AMP] = ACTIONS(7194),
    [anon_sym_AMP_EQ] = ACTIONS(7194),
    [anon_sym_POUND] = ACTIONS(6588),
    [anon_sym_PERCENT] = ACTIONS(7197),
    [anon_sym_PERCENT_EQ] = ACTIONS(7194),
    [anon_sym_CARET] = ACTIONS(7197),
    [anon_sym_CARET_EQ] = ACTIONS(7194),
    [anon_sym_PLUS_EQ] = ACTIONS(7194),
    [anon_sym_LT] = ACTIONS(7197),
    [anon_sym_LT_LT] = ACTIONS(7197),
    [anon_sym_LT_LT_EQ] = ACTIONS(7194),
    [anon_sym_LT_EQ] = ACTIONS(7194),
    [anon_sym_EQ] = ACTIONS(7197),
    [anon_sym_EQ_EQ] = ACTIONS(7194),
    [anon_sym_GT] = ACTIONS(7197),
    [anon_sym_GT_EQ] = ACTIONS(7194),
    [anon_sym_GT_GT] = ACTIONS(7197),
    [anon_sym_GT_GT_EQ] = ACTIONS(7194),
    [anon_sym_PIPE] = ACTIONS(7197),
    [anon_sym_PIPE_EQ] = ACTIONS(7194),
    [anon_sym_PIPE_PIPE] = ACTIONS(7194),
    [anon_sym_TILDE] = ACTIONS(6588),
    [anon_sym_QMARK] = ACTIONS(7194),
    [anon_sym_SQUOTE] = ACTIONS(6590),
    [anon_sym_DOT_DOT] = ACTIONS(7197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7194),
    [anon_sym_as] = ACTIONS(7197),
    [anon_sym_break] = ACTIONS(6590),
    [anon_sym_const] = ACTIONS(6590),
    [anon_sym_continue] = ACTIONS(6590),
    [anon_sym_default] = ACTIONS(6590),
    [anon_sym_enum] = ACTIONS(6590),
    [anon_sym_fn] = ACTIONS(6590),
    [anon_sym_for] = ACTIONS(6590),
    [anon_sym_if] = ACTIONS(6590),
    [anon_sym_impl] = ACTIONS(6590),
    [anon_sym_let] = ACTIONS(6590),
    [anon_sym_loop] = ACTIONS(6590),
    [anon_sym_match] = ACTIONS(6590),
    [anon_sym_mod] = ACTIONS(6590),
    [anon_sym_pub] = ACTIONS(6590),
    [anon_sym_return] = ACTIONS(6590),
    [anon_sym_static] = ACTIONS(6590),
    [anon_sym_struct] = ACTIONS(6590),
    [anon_sym_trait] = ACTIONS(6590),
    [anon_sym_type] = ACTIONS(6590),
    [anon_sym_union] = ACTIONS(6590),
    [anon_sym_unsafe] = ACTIONS(6590),
    [anon_sym_use] = ACTIONS(6590),
    [anon_sym_where] = ACTIONS(6590),
    [anon_sym_while] = ACTIONS(6590),
    [sym_mutable_specifier] = ACTIONS(6590),
    [sym_integer_literal] = ACTIONS(6588),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6588),
    [sym_char_literal] = ACTIONS(6588),
    [anon_sym_true] = ACTIONS(6590),
    [anon_sym_false] = ACTIONS(6590),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6590),
    [sym_self] = ACTIONS(6590),
    [sym_super] = ACTIONS(6590),
    [sym_crate] = ACTIONS(6590),
    [sym_metavariable] = ACTIONS(6588),
  },
  [2970] = {
    [sym_raw_string_literal] = ACTIONS(5554),
    [sym_float_literal] = ACTIONS(5554),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6538),
    [anon_sym_LPAREN] = ACTIONS(6538),
    [anon_sym_LBRACE] = ACTIONS(5554),
    [anon_sym_EQ_GT] = ACTIONS(5554),
    [anon_sym_LBRACK] = ACTIONS(6538),
    [anon_sym_RBRACK] = ACTIONS(6538),
    [anon_sym_COLON] = ACTIONS(5556),
    [anon_sym_DOLLAR] = ACTIONS(5556),
    [anon_sym_PLUS] = ACTIONS(6541),
    [anon_sym_STAR] = ACTIONS(6541),
    [anon_sym_COMMA] = ACTIONS(6538),
    [anon_sym_u8] = ACTIONS(5556),
    [anon_sym_i8] = ACTIONS(5556),
    [anon_sym_u16] = ACTIONS(5556),
    [anon_sym_i16] = ACTIONS(5556),
    [anon_sym_u32] = ACTIONS(5556),
    [anon_sym_i32] = ACTIONS(5556),
    [anon_sym_u64] = ACTIONS(5556),
    [anon_sym_i64] = ACTIONS(5556),
    [anon_sym_u128] = ACTIONS(5556),
    [anon_sym_i128] = ACTIONS(5556),
    [anon_sym_isize] = ACTIONS(5556),
    [anon_sym_usize] = ACTIONS(5556),
    [anon_sym_f32] = ACTIONS(5556),
    [anon_sym_f64] = ACTIONS(5556),
    [anon_sym_bool] = ACTIONS(5556),
    [anon_sym_str] = ACTIONS(5556),
    [anon_sym_char] = ACTIONS(5556),
    [anon_sym__] = ACTIONS(5556),
    [anon_sym_AMP] = ACTIONS(6541),
    [anon_sym_DASH] = ACTIONS(6541),
    [anon_sym_DOT] = ACTIONS(6541),
    [anon_sym_DASH_EQ] = ACTIONS(6538),
    [anon_sym_DASH_GT] = ACTIONS(5554),
    [anon_sym_COLON_COLON] = ACTIONS(5554),
    [anon_sym_BANG] = ACTIONS(5556),
    [anon_sym_BANG_EQ] = ACTIONS(6538),
    [anon_sym_AT] = ACTIONS(5554),
    [anon_sym_STAR_EQ] = ACTIONS(6538),
    [anon_sym_SLASH] = ACTIONS(6541),
    [anon_sym_SLASH_EQ] = ACTIONS(6538),
    [anon_sym_AMP_AMP] = ACTIONS(6538),
    [anon_sym_AMP_EQ] = ACTIONS(6538),
    [anon_sym_POUND] = ACTIONS(5554),
    [anon_sym_PERCENT] = ACTIONS(6541),
    [anon_sym_PERCENT_EQ] = ACTIONS(6538),
    [anon_sym_CARET] = ACTIONS(6541),
    [anon_sym_CARET_EQ] = ACTIONS(6538),
    [anon_sym_PLUS_EQ] = ACTIONS(6538),
    [anon_sym_LT] = ACTIONS(6541),
    [anon_sym_LT_LT] = ACTIONS(6541),
    [anon_sym_LT_LT_EQ] = ACTIONS(6538),
    [anon_sym_LT_EQ] = ACTIONS(6538),
    [anon_sym_EQ] = ACTIONS(6541),
    [anon_sym_EQ_EQ] = ACTIONS(6538),
    [anon_sym_GT] = ACTIONS(6541),
    [anon_sym_GT_EQ] = ACTIONS(6538),
    [anon_sym_GT_GT] = ACTIONS(6541),
    [anon_sym_GT_GT_EQ] = ACTIONS(6538),
    [anon_sym_PIPE] = ACTIONS(6541),
    [anon_sym_PIPE_EQ] = ACTIONS(6538),
    [anon_sym_PIPE_PIPE] = ACTIONS(6538),
    [anon_sym_TILDE] = ACTIONS(5554),
    [anon_sym_QMARK] = ACTIONS(6538),
    [anon_sym_SQUOTE] = ACTIONS(5556),
    [anon_sym_DOT_DOT] = ACTIONS(6541),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6538),
    [anon_sym_as] = ACTIONS(6541),
    [anon_sym_break] = ACTIONS(5556),
    [anon_sym_const] = ACTIONS(5556),
    [anon_sym_continue] = ACTIONS(5556),
    [anon_sym_default] = ACTIONS(5556),
    [anon_sym_enum] = ACTIONS(5556),
    [anon_sym_fn] = ACTIONS(5556),
    [anon_sym_for] = ACTIONS(5556),
    [anon_sym_if] = ACTIONS(5556),
    [anon_sym_impl] = ACTIONS(5556),
    [anon_sym_let] = ACTIONS(5556),
    [anon_sym_loop] = ACTIONS(5556),
    [anon_sym_match] = ACTIONS(5556),
    [anon_sym_mod] = ACTIONS(5556),
    [anon_sym_pub] = ACTIONS(5556),
    [anon_sym_return] = ACTIONS(5556),
    [anon_sym_static] = ACTIONS(5556),
    [anon_sym_struct] = ACTIONS(5556),
    [anon_sym_trait] = ACTIONS(5556),
    [anon_sym_type] = ACTIONS(5556),
    [anon_sym_union] = ACTIONS(5556),
    [anon_sym_unsafe] = ACTIONS(5556),
    [anon_sym_use] = ACTIONS(5556),
    [anon_sym_where] = ACTIONS(5556),
    [anon_sym_while] = ACTIONS(5556),
    [sym_mutable_specifier] = ACTIONS(5556),
    [sym_integer_literal] = ACTIONS(5554),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5554),
    [sym_char_literal] = ACTIONS(5554),
    [anon_sym_true] = ACTIONS(5556),
    [anon_sym_false] = ACTIONS(5556),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5556),
    [sym_self] = ACTIONS(5556),
    [sym_super] = ACTIONS(5556),
    [sym_crate] = ACTIONS(5556),
    [sym_metavariable] = ACTIONS(5554),
  },
  [2971] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(2966),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(2966),
    [sym_macro_invocation] = STATE(2966),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(2966),
    [sym_unary_expression] = STATE(2966),
    [sym_try_expression] = STATE(2966),
    [sym_reference_expression] = STATE(2966),
    [sym_binary_expression] = STATE(2966),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(2966),
    [sym_call_expression] = STATE(2966),
    [sym_array_expression] = STATE(2966),
    [sym_parenthesized_expression] = STATE(2966),
    [sym_tuple_expression] = STATE(2966),
    [sym_unit_expression] = STATE(2966),
    [sym_struct_expression] = STATE(2966),
    [sym_if_expression] = STATE(2966),
    [sym_if_let_expression] = STATE(2966),
    [sym_match_expression] = STATE(2966),
    [sym_while_expression] = STATE(2966),
    [sym_while_let_expression] = STATE(2966),
    [sym_loop_expression] = STATE(2966),
    [sym_for_expression] = STATE(2966),
    [sym_closure_expression] = STATE(2966),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(2966),
    [sym_continue_expression] = STATE(2966),
    [sym_index_expression] = STATE(2966),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2966),
    [sym_block] = STATE(2966),
    [sym__literal] = STATE(2966),
    [sym_string_literal] = STATE(2966),
    [sym_boolean_literal] = STATE(2966),
    [aux_sym_tuple_expression_repeat1] = STATE(711),
    [sym_raw_string_literal] = ACTIONS(6544),
    [sym_float_literal] = ACTIONS(6544),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(7200),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(6544),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(6544),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2972] = {
    [sym_raw_string_literal] = ACTIONS(5554),
    [sym_float_literal] = ACTIONS(5554),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6552),
    [anon_sym_LPAREN] = ACTIONS(6552),
    [anon_sym_LBRACE] = ACTIONS(5554),
    [anon_sym_EQ_GT] = ACTIONS(5554),
    [anon_sym_LBRACK] = ACTIONS(6552),
    [anon_sym_RBRACK] = ACTIONS(6552),
    [anon_sym_COLON] = ACTIONS(5556),
    [anon_sym_DOLLAR] = ACTIONS(5556),
    [anon_sym_PLUS] = ACTIONS(6555),
    [anon_sym_STAR] = ACTIONS(6555),
    [anon_sym_COMMA] = ACTIONS(6552),
    [anon_sym_u8] = ACTIONS(5556),
    [anon_sym_i8] = ACTIONS(5556),
    [anon_sym_u16] = ACTIONS(5556),
    [anon_sym_i16] = ACTIONS(5556),
    [anon_sym_u32] = ACTIONS(5556),
    [anon_sym_i32] = ACTIONS(5556),
    [anon_sym_u64] = ACTIONS(5556),
    [anon_sym_i64] = ACTIONS(5556),
    [anon_sym_u128] = ACTIONS(5556),
    [anon_sym_i128] = ACTIONS(5556),
    [anon_sym_isize] = ACTIONS(5556),
    [anon_sym_usize] = ACTIONS(5556),
    [anon_sym_f32] = ACTIONS(5556),
    [anon_sym_f64] = ACTIONS(5556),
    [anon_sym_bool] = ACTIONS(5556),
    [anon_sym_str] = ACTIONS(5556),
    [anon_sym_char] = ACTIONS(5556),
    [anon_sym__] = ACTIONS(5556),
    [anon_sym_AMP] = ACTIONS(6555),
    [anon_sym_DASH] = ACTIONS(6555),
    [anon_sym_DOT] = ACTIONS(6555),
    [anon_sym_DASH_EQ] = ACTIONS(6552),
    [anon_sym_DASH_GT] = ACTIONS(5554),
    [anon_sym_COLON_COLON] = ACTIONS(5554),
    [anon_sym_BANG] = ACTIONS(5556),
    [anon_sym_BANG_EQ] = ACTIONS(6552),
    [anon_sym_AT] = ACTIONS(5554),
    [anon_sym_STAR_EQ] = ACTIONS(6552),
    [anon_sym_SLASH] = ACTIONS(6555),
    [anon_sym_SLASH_EQ] = ACTIONS(6552),
    [anon_sym_AMP_AMP] = ACTIONS(6552),
    [anon_sym_AMP_EQ] = ACTIONS(6552),
    [anon_sym_POUND] = ACTIONS(5554),
    [anon_sym_PERCENT] = ACTIONS(6555),
    [anon_sym_PERCENT_EQ] = ACTIONS(6552),
    [anon_sym_CARET] = ACTIONS(6555),
    [anon_sym_CARET_EQ] = ACTIONS(6552),
    [anon_sym_PLUS_EQ] = ACTIONS(6552),
    [anon_sym_LT] = ACTIONS(6555),
    [anon_sym_LT_LT] = ACTIONS(6555),
    [anon_sym_LT_LT_EQ] = ACTIONS(6552),
    [anon_sym_LT_EQ] = ACTIONS(6552),
    [anon_sym_EQ] = ACTIONS(6555),
    [anon_sym_EQ_EQ] = ACTIONS(6552),
    [anon_sym_GT] = ACTIONS(6555),
    [anon_sym_GT_EQ] = ACTIONS(6552),
    [anon_sym_GT_GT] = ACTIONS(6555),
    [anon_sym_GT_GT_EQ] = ACTIONS(6552),
    [anon_sym_PIPE] = ACTIONS(6555),
    [anon_sym_PIPE_EQ] = ACTIONS(6552),
    [anon_sym_PIPE_PIPE] = ACTIONS(6552),
    [anon_sym_TILDE] = ACTIONS(5554),
    [anon_sym_QMARK] = ACTIONS(6552),
    [anon_sym_SQUOTE] = ACTIONS(5556),
    [anon_sym_DOT_DOT] = ACTIONS(6555),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6552),
    [anon_sym_as] = ACTIONS(6555),
    [anon_sym_break] = ACTIONS(5556),
    [anon_sym_const] = ACTIONS(5556),
    [anon_sym_continue] = ACTIONS(5556),
    [anon_sym_default] = ACTIONS(5556),
    [anon_sym_enum] = ACTIONS(5556),
    [anon_sym_fn] = ACTIONS(5556),
    [anon_sym_for] = ACTIONS(5556),
    [anon_sym_if] = ACTIONS(5556),
    [anon_sym_impl] = ACTIONS(5556),
    [anon_sym_let] = ACTIONS(5556),
    [anon_sym_loop] = ACTIONS(5556),
    [anon_sym_match] = ACTIONS(5556),
    [anon_sym_mod] = ACTIONS(5556),
    [anon_sym_pub] = ACTIONS(5556),
    [anon_sym_return] = ACTIONS(5556),
    [anon_sym_static] = ACTIONS(5556),
    [anon_sym_struct] = ACTIONS(5556),
    [anon_sym_trait] = ACTIONS(5556),
    [anon_sym_type] = ACTIONS(5556),
    [anon_sym_union] = ACTIONS(5556),
    [anon_sym_unsafe] = ACTIONS(5556),
    [anon_sym_use] = ACTIONS(5556),
    [anon_sym_where] = ACTIONS(5556),
    [anon_sym_while] = ACTIONS(5556),
    [sym_mutable_specifier] = ACTIONS(5556),
    [sym_integer_literal] = ACTIONS(5554),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5554),
    [sym_char_literal] = ACTIONS(5554),
    [anon_sym_true] = ACTIONS(5556),
    [anon_sym_false] = ACTIONS(5556),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5556),
    [sym_self] = ACTIONS(5556),
    [sym_super] = ACTIONS(5556),
    [sym_crate] = ACTIONS(5556),
    [sym_metavariable] = ACTIONS(5554),
  },
  [2973] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(7202),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(623),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(623),
    [anon_sym_PLUS_EQ] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(623),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(643),
    [anon_sym_as] = ACTIONS(645),
    [sym_line_comment] = ACTIONS(7),
  },
  [2974] = {
    [sym_raw_string_literal] = ACTIONS(5554),
    [sym_float_literal] = ACTIONS(5554),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6572),
    [anon_sym_LPAREN] = ACTIONS(6572),
    [anon_sym_LBRACE] = ACTIONS(5554),
    [anon_sym_EQ_GT] = ACTIONS(5554),
    [anon_sym_LBRACK] = ACTIONS(6572),
    [anon_sym_RBRACK] = ACTIONS(6572),
    [anon_sym_COLON] = ACTIONS(5556),
    [anon_sym_DOLLAR] = ACTIONS(5556),
    [anon_sym_PLUS] = ACTIONS(6575),
    [anon_sym_STAR] = ACTIONS(6575),
    [anon_sym_COMMA] = ACTIONS(6572),
    [anon_sym_u8] = ACTIONS(5556),
    [anon_sym_i8] = ACTIONS(5556),
    [anon_sym_u16] = ACTIONS(5556),
    [anon_sym_i16] = ACTIONS(5556),
    [anon_sym_u32] = ACTIONS(5556),
    [anon_sym_i32] = ACTIONS(5556),
    [anon_sym_u64] = ACTIONS(5556),
    [anon_sym_i64] = ACTIONS(5556),
    [anon_sym_u128] = ACTIONS(5556),
    [anon_sym_i128] = ACTIONS(5556),
    [anon_sym_isize] = ACTIONS(5556),
    [anon_sym_usize] = ACTIONS(5556),
    [anon_sym_f32] = ACTIONS(5556),
    [anon_sym_f64] = ACTIONS(5556),
    [anon_sym_bool] = ACTIONS(5556),
    [anon_sym_str] = ACTIONS(5556),
    [anon_sym_char] = ACTIONS(5556),
    [anon_sym__] = ACTIONS(5556),
    [anon_sym_AMP] = ACTIONS(6575),
    [anon_sym_DASH] = ACTIONS(6575),
    [anon_sym_DOT] = ACTIONS(6575),
    [anon_sym_DASH_EQ] = ACTIONS(6572),
    [anon_sym_DASH_GT] = ACTIONS(5554),
    [anon_sym_COLON_COLON] = ACTIONS(5554),
    [anon_sym_BANG] = ACTIONS(5556),
    [anon_sym_BANG_EQ] = ACTIONS(6572),
    [anon_sym_AT] = ACTIONS(5554),
    [anon_sym_STAR_EQ] = ACTIONS(6572),
    [anon_sym_SLASH] = ACTIONS(6575),
    [anon_sym_SLASH_EQ] = ACTIONS(6572),
    [anon_sym_AMP_AMP] = ACTIONS(6572),
    [anon_sym_AMP_EQ] = ACTIONS(6572),
    [anon_sym_POUND] = ACTIONS(5554),
    [anon_sym_PERCENT] = ACTIONS(6575),
    [anon_sym_PERCENT_EQ] = ACTIONS(6572),
    [anon_sym_CARET] = ACTIONS(6575),
    [anon_sym_CARET_EQ] = ACTIONS(6572),
    [anon_sym_PLUS_EQ] = ACTIONS(6572),
    [anon_sym_LT] = ACTIONS(6575),
    [anon_sym_LT_LT] = ACTIONS(6575),
    [anon_sym_LT_LT_EQ] = ACTIONS(6572),
    [anon_sym_LT_EQ] = ACTIONS(6572),
    [anon_sym_EQ] = ACTIONS(6575),
    [anon_sym_EQ_EQ] = ACTIONS(6572),
    [anon_sym_GT] = ACTIONS(6575),
    [anon_sym_GT_EQ] = ACTIONS(6572),
    [anon_sym_GT_GT] = ACTIONS(6575),
    [anon_sym_GT_GT_EQ] = ACTIONS(6572),
    [anon_sym_PIPE] = ACTIONS(6575),
    [anon_sym_PIPE_EQ] = ACTIONS(6572),
    [anon_sym_PIPE_PIPE] = ACTIONS(6572),
    [anon_sym_TILDE] = ACTIONS(5554),
    [anon_sym_QMARK] = ACTIONS(6572),
    [anon_sym_SQUOTE] = ACTIONS(5556),
    [anon_sym_DOT_DOT] = ACTIONS(6575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6572),
    [anon_sym_as] = ACTIONS(6575),
    [anon_sym_break] = ACTIONS(5556),
    [anon_sym_const] = ACTIONS(5556),
    [anon_sym_continue] = ACTIONS(5556),
    [anon_sym_default] = ACTIONS(5556),
    [anon_sym_enum] = ACTIONS(5556),
    [anon_sym_fn] = ACTIONS(5556),
    [anon_sym_for] = ACTIONS(5556),
    [anon_sym_if] = ACTIONS(5556),
    [anon_sym_impl] = ACTIONS(5556),
    [anon_sym_let] = ACTIONS(5556),
    [anon_sym_loop] = ACTIONS(5556),
    [anon_sym_match] = ACTIONS(5556),
    [anon_sym_mod] = ACTIONS(5556),
    [anon_sym_pub] = ACTIONS(5556),
    [anon_sym_return] = ACTIONS(5556),
    [anon_sym_static] = ACTIONS(5556),
    [anon_sym_struct] = ACTIONS(5556),
    [anon_sym_trait] = ACTIONS(5556),
    [anon_sym_type] = ACTIONS(5556),
    [anon_sym_union] = ACTIONS(5556),
    [anon_sym_unsafe] = ACTIONS(5556),
    [anon_sym_use] = ACTIONS(5556),
    [anon_sym_where] = ACTIONS(5556),
    [anon_sym_while] = ACTIONS(5556),
    [sym_mutable_specifier] = ACTIONS(5556),
    [sym_integer_literal] = ACTIONS(5554),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5554),
    [sym_char_literal] = ACTIONS(5554),
    [anon_sym_true] = ACTIONS(5556),
    [anon_sym_false] = ACTIONS(5556),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5556),
    [sym_self] = ACTIONS(5556),
    [sym_super] = ACTIONS(5556),
    [sym_crate] = ACTIONS(5556),
    [sym_metavariable] = ACTIONS(5554),
  },
  [2975] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(769),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(769),
    [sym_macro_invocation] = STATE(769),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(769),
    [sym_unary_expression] = STATE(769),
    [sym_try_expression] = STATE(769),
    [sym_reference_expression] = STATE(769),
    [sym_binary_expression] = STATE(769),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(769),
    [sym_call_expression] = STATE(769),
    [sym_array_expression] = STATE(769),
    [sym_parenthesized_expression] = STATE(769),
    [sym_tuple_expression] = STATE(769),
    [sym_unit_expression] = STATE(769),
    [sym_struct_expression] = STATE(769),
    [sym_if_expression] = STATE(769),
    [sym_if_let_expression] = STATE(769),
    [sym_match_expression] = STATE(769),
    [sym_while_expression] = STATE(769),
    [sym_while_let_expression] = STATE(769),
    [sym_loop_expression] = STATE(769),
    [sym_for_expression] = STATE(769),
    [sym_closure_expression] = STATE(769),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(769),
    [sym_continue_expression] = STATE(769),
    [sym_index_expression] = STATE(769),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(769),
    [sym_block] = STATE(769),
    [sym__literal] = STATE(769),
    [sym_string_literal] = STATE(769),
    [sym_boolean_literal] = STATE(769),
    [sym_raw_string_literal] = ACTIONS(1620),
    [sym_float_literal] = ACTIONS(1620),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_RBRACK] = ACTIONS(7204),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1620),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1620),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2976] = {
    [aux_sym_token_tree_repeat2] = STATE(789),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACK] = ACTIONS(7204),
    [anon_sym_COMMA] = ACTIONS(7206),
    [sym_line_comment] = ACTIONS(7),
  },
  [2977] = {
    [sym_raw_string_literal] = ACTIONS(6588),
    [sym_float_literal] = ACTIONS(6588),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6588),
    [anon_sym_LPAREN] = ACTIONS(7208),
    [anon_sym_RPAREN] = ACTIONS(7208),
    [anon_sym_LBRACE] = ACTIONS(6588),
    [anon_sym_EQ_GT] = ACTIONS(6588),
    [anon_sym_LBRACK] = ACTIONS(7208),
    [anon_sym_RBRACK] = ACTIONS(7208),
    [anon_sym_COLON] = ACTIONS(6590),
    [anon_sym_DOLLAR] = ACTIONS(6590),
    [anon_sym_PLUS] = ACTIONS(7211),
    [anon_sym_STAR] = ACTIONS(7211),
    [anon_sym_COMMA] = ACTIONS(7208),
    [anon_sym_u8] = ACTIONS(6590),
    [anon_sym_i8] = ACTIONS(6590),
    [anon_sym_u16] = ACTIONS(6590),
    [anon_sym_i16] = ACTIONS(6590),
    [anon_sym_u32] = ACTIONS(6590),
    [anon_sym_i32] = ACTIONS(6590),
    [anon_sym_u64] = ACTIONS(6590),
    [anon_sym_i64] = ACTIONS(6590),
    [anon_sym_u128] = ACTIONS(6590),
    [anon_sym_i128] = ACTIONS(6590),
    [anon_sym_isize] = ACTIONS(6590),
    [anon_sym_usize] = ACTIONS(6590),
    [anon_sym_f32] = ACTIONS(6590),
    [anon_sym_f64] = ACTIONS(6590),
    [anon_sym_bool] = ACTIONS(6590),
    [anon_sym_str] = ACTIONS(6590),
    [anon_sym_char] = ACTIONS(6590),
    [anon_sym__] = ACTIONS(6590),
    [anon_sym_AMP] = ACTIONS(7211),
    [anon_sym_DASH] = ACTIONS(7211),
    [anon_sym_DOT] = ACTIONS(7211),
    [anon_sym_DASH_EQ] = ACTIONS(7208),
    [anon_sym_DASH_GT] = ACTIONS(6588),
    [anon_sym_COLON_COLON] = ACTIONS(6588),
    [anon_sym_BANG] = ACTIONS(6590),
    [anon_sym_BANG_EQ] = ACTIONS(7208),
    [anon_sym_AT] = ACTIONS(6588),
    [anon_sym_STAR_EQ] = ACTIONS(7208),
    [anon_sym_SLASH] = ACTIONS(7211),
    [anon_sym_SLASH_EQ] = ACTIONS(7208),
    [anon_sym_AMP_AMP] = ACTIONS(7208),
    [anon_sym_AMP_EQ] = ACTIONS(7208),
    [anon_sym_POUND] = ACTIONS(6588),
    [anon_sym_PERCENT] = ACTIONS(7211),
    [anon_sym_PERCENT_EQ] = ACTIONS(7208),
    [anon_sym_CARET] = ACTIONS(7211),
    [anon_sym_CARET_EQ] = ACTIONS(7208),
    [anon_sym_PLUS_EQ] = ACTIONS(7208),
    [anon_sym_LT] = ACTIONS(7211),
    [anon_sym_LT_LT] = ACTIONS(7211),
    [anon_sym_LT_LT_EQ] = ACTIONS(7208),
    [anon_sym_LT_EQ] = ACTIONS(7208),
    [anon_sym_EQ] = ACTIONS(7211),
    [anon_sym_EQ_EQ] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7211),
    [anon_sym_GT_EQ] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7211),
    [anon_sym_GT_GT_EQ] = ACTIONS(7208),
    [anon_sym_PIPE] = ACTIONS(7211),
    [anon_sym_PIPE_EQ] = ACTIONS(7208),
    [anon_sym_PIPE_PIPE] = ACTIONS(7208),
    [anon_sym_TILDE] = ACTIONS(6588),
    [anon_sym_QMARK] = ACTIONS(7208),
    [anon_sym_SQUOTE] = ACTIONS(6590),
    [anon_sym_DOT_DOT] = ACTIONS(7211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7208),
    [anon_sym_as] = ACTIONS(7211),
    [anon_sym_break] = ACTIONS(6590),
    [anon_sym_const] = ACTIONS(6590),
    [anon_sym_continue] = ACTIONS(6590),
    [anon_sym_default] = ACTIONS(6590),
    [anon_sym_enum] = ACTIONS(6590),
    [anon_sym_fn] = ACTIONS(6590),
    [anon_sym_for] = ACTIONS(6590),
    [anon_sym_if] = ACTIONS(6590),
    [anon_sym_impl] = ACTIONS(6590),
    [anon_sym_let] = ACTIONS(6590),
    [anon_sym_loop] = ACTIONS(6590),
    [anon_sym_match] = ACTIONS(6590),
    [anon_sym_mod] = ACTIONS(6590),
    [anon_sym_pub] = ACTIONS(6590),
    [anon_sym_return] = ACTIONS(6590),
    [anon_sym_static] = ACTIONS(6590),
    [anon_sym_struct] = ACTIONS(6590),
    [anon_sym_trait] = ACTIONS(6590),
    [anon_sym_type] = ACTIONS(6590),
    [anon_sym_union] = ACTIONS(6590),
    [anon_sym_unsafe] = ACTIONS(6590),
    [anon_sym_use] = ACTIONS(6590),
    [anon_sym_where] = ACTIONS(6590),
    [anon_sym_while] = ACTIONS(6590),
    [sym_mutable_specifier] = ACTIONS(6590),
    [sym_integer_literal] = ACTIONS(6588),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6588),
    [sym_char_literal] = ACTIONS(6588),
    [anon_sym_true] = ACTIONS(6590),
    [anon_sym_false] = ACTIONS(6590),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6590),
    [sym_self] = ACTIONS(6590),
    [sym_super] = ACTIONS(6590),
    [sym_crate] = ACTIONS(6590),
    [sym_metavariable] = ACTIONS(6588),
  },
  [2978] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(769),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(769),
    [sym_macro_invocation] = STATE(769),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(769),
    [sym_unary_expression] = STATE(769),
    [sym_try_expression] = STATE(769),
    [sym_reference_expression] = STATE(769),
    [sym_binary_expression] = STATE(769),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(769),
    [sym_call_expression] = STATE(769),
    [sym_array_expression] = STATE(769),
    [sym_parenthesized_expression] = STATE(769),
    [sym_tuple_expression] = STATE(769),
    [sym_unit_expression] = STATE(769),
    [sym_struct_expression] = STATE(769),
    [sym_if_expression] = STATE(769),
    [sym_if_let_expression] = STATE(769),
    [sym_match_expression] = STATE(769),
    [sym_while_expression] = STATE(769),
    [sym_while_let_expression] = STATE(769),
    [sym_loop_expression] = STATE(769),
    [sym_for_expression] = STATE(769),
    [sym_closure_expression] = STATE(769),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(769),
    [sym_continue_expression] = STATE(769),
    [sym_index_expression] = STATE(769),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(769),
    [sym_block] = STATE(769),
    [sym__literal] = STATE(769),
    [sym_string_literal] = STATE(769),
    [sym_boolean_literal] = STATE(769),
    [sym_raw_string_literal] = ACTIONS(1620),
    [sym_float_literal] = ACTIONS(1620),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_RBRACK] = ACTIONS(7214),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1620),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1620),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2979] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7216),
    [anon_sym_STAR] = ACTIONS(7216),
    [sym_line_comment] = ACTIONS(7),
  },
  [2980] = {
    [sym_raw_string_literal] = ACTIONS(7218),
    [sym_float_literal] = ACTIONS(7218),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7218),
    [anon_sym_LPAREN] = ACTIONS(7218),
    [anon_sym_RPAREN] = ACTIONS(7218),
    [anon_sym_LBRACE] = ACTIONS(7218),
    [anon_sym_RBRACE] = ACTIONS(7218),
    [anon_sym_EQ_GT] = ACTIONS(7218),
    [anon_sym_LBRACK] = ACTIONS(7218),
    [anon_sym_RBRACK] = ACTIONS(7218),
    [anon_sym_COLON] = ACTIONS(7220),
    [anon_sym_DOLLAR] = ACTIONS(7220),
    [anon_sym_PLUS] = ACTIONS(7220),
    [anon_sym_STAR] = ACTIONS(7220),
    [anon_sym_COMMA] = ACTIONS(7218),
    [anon_sym_u8] = ACTIONS(7220),
    [anon_sym_i8] = ACTIONS(7220),
    [anon_sym_u16] = ACTIONS(7220),
    [anon_sym_i16] = ACTIONS(7220),
    [anon_sym_u32] = ACTIONS(7220),
    [anon_sym_i32] = ACTIONS(7220),
    [anon_sym_u64] = ACTIONS(7220),
    [anon_sym_i64] = ACTIONS(7220),
    [anon_sym_u128] = ACTIONS(7220),
    [anon_sym_i128] = ACTIONS(7220),
    [anon_sym_isize] = ACTIONS(7220),
    [anon_sym_usize] = ACTIONS(7220),
    [anon_sym_f32] = ACTIONS(7220),
    [anon_sym_f64] = ACTIONS(7220),
    [anon_sym_bool] = ACTIONS(7220),
    [anon_sym_str] = ACTIONS(7220),
    [anon_sym_char] = ACTIONS(7220),
    [anon_sym__] = ACTIONS(7220),
    [anon_sym_AMP] = ACTIONS(7220),
    [anon_sym_DASH] = ACTIONS(7220),
    [anon_sym_DOT] = ACTIONS(7220),
    [anon_sym_DASH_EQ] = ACTIONS(7218),
    [anon_sym_DASH_GT] = ACTIONS(7218),
    [anon_sym_COLON_COLON] = ACTIONS(7218),
    [anon_sym_BANG] = ACTIONS(7220),
    [anon_sym_BANG_EQ] = ACTIONS(7218),
    [anon_sym_AT] = ACTIONS(7218),
    [anon_sym_STAR_EQ] = ACTIONS(7218),
    [anon_sym_SLASH] = ACTIONS(7220),
    [anon_sym_SLASH_EQ] = ACTIONS(7218),
    [anon_sym_AMP_AMP] = ACTIONS(7218),
    [anon_sym_AMP_EQ] = ACTIONS(7218),
    [anon_sym_POUND] = ACTIONS(7218),
    [anon_sym_PERCENT] = ACTIONS(7220),
    [anon_sym_PERCENT_EQ] = ACTIONS(7218),
    [anon_sym_CARET] = ACTIONS(7220),
    [anon_sym_CARET_EQ] = ACTIONS(7218),
    [anon_sym_PLUS_EQ] = ACTIONS(7218),
    [anon_sym_LT] = ACTIONS(7220),
    [anon_sym_LT_LT] = ACTIONS(7220),
    [anon_sym_LT_LT_EQ] = ACTIONS(7218),
    [anon_sym_LT_EQ] = ACTIONS(7218),
    [anon_sym_EQ] = ACTIONS(7220),
    [anon_sym_EQ_EQ] = ACTIONS(7218),
    [anon_sym_GT] = ACTIONS(7220),
    [anon_sym_GT_EQ] = ACTIONS(7218),
    [anon_sym_GT_GT] = ACTIONS(7220),
    [anon_sym_GT_GT_EQ] = ACTIONS(7218),
    [anon_sym_PIPE] = ACTIONS(7220),
    [anon_sym_PIPE_EQ] = ACTIONS(7218),
    [anon_sym_PIPE_PIPE] = ACTIONS(7218),
    [anon_sym_TILDE] = ACTIONS(7218),
    [anon_sym_QMARK] = ACTIONS(7218),
    [anon_sym_SQUOTE] = ACTIONS(7220),
    [anon_sym_DOT_DOT] = ACTIONS(7220),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7218),
    [anon_sym_as] = ACTIONS(7220),
    [anon_sym_break] = ACTIONS(7220),
    [anon_sym_const] = ACTIONS(7220),
    [anon_sym_continue] = ACTIONS(7220),
    [anon_sym_default] = ACTIONS(7220),
    [anon_sym_enum] = ACTIONS(7220),
    [anon_sym_fn] = ACTIONS(7220),
    [anon_sym_for] = ACTIONS(7220),
    [anon_sym_if] = ACTIONS(7220),
    [anon_sym_impl] = ACTIONS(7220),
    [anon_sym_let] = ACTIONS(7220),
    [anon_sym_loop] = ACTIONS(7220),
    [anon_sym_match] = ACTIONS(7220),
    [anon_sym_mod] = ACTIONS(7220),
    [anon_sym_pub] = ACTIONS(7220),
    [anon_sym_return] = ACTIONS(7220),
    [anon_sym_static] = ACTIONS(7220),
    [anon_sym_struct] = ACTIONS(7220),
    [anon_sym_trait] = ACTIONS(7220),
    [anon_sym_type] = ACTIONS(7220),
    [anon_sym_union] = ACTIONS(7220),
    [anon_sym_unsafe] = ACTIONS(7220),
    [anon_sym_use] = ACTIONS(7220),
    [anon_sym_where] = ACTIONS(7220),
    [anon_sym_while] = ACTIONS(7220),
    [sym_mutable_specifier] = ACTIONS(7220),
    [sym_integer_literal] = ACTIONS(7218),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7218),
    [sym_char_literal] = ACTIONS(7218),
    [anon_sym_true] = ACTIONS(7220),
    [anon_sym_false] = ACTIONS(7220),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7220),
    [sym_self] = ACTIONS(7220),
    [sym_super] = ACTIONS(7220),
    [sym_crate] = ACTIONS(7220),
    [sym_metavariable] = ACTIONS(7218),
  },
  [2981] = {
    [sym_block_comment] = ACTIONS(7),
    [aux_sym_SLASH_LBRACK_CARET_PLUS_STAR_RBRACK_PLUS_SLASH] = ACTIONS(7222),
    [anon_sym_PLUS] = ACTIONS(7224),
    [anon_sym_STAR] = ACTIONS(7224),
    [sym_line_comment] = ACTIONS(401),
  },
  [2982] = {
    [sym_raw_string_literal] = ACTIONS(7226),
    [sym_float_literal] = ACTIONS(7226),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(7226),
    [anon_sym_SEMI] = ACTIONS(7226),
    [anon_sym_macro_rules_BANG] = ACTIONS(7226),
    [anon_sym_LPAREN] = ACTIONS(7226),
    [anon_sym_LBRACE] = ACTIONS(7226),
    [anon_sym_RBRACE] = ACTIONS(7226),
    [anon_sym_LBRACK] = ACTIONS(7226),
    [anon_sym_PLUS] = ACTIONS(7228),
    [anon_sym_STAR] = ACTIONS(7228),
    [anon_sym_u8] = ACTIONS(7228),
    [anon_sym_i8] = ACTIONS(7228),
    [anon_sym_u16] = ACTIONS(7228),
    [anon_sym_i16] = ACTIONS(7228),
    [anon_sym_u32] = ACTIONS(7228),
    [anon_sym_i32] = ACTIONS(7228),
    [anon_sym_u64] = ACTIONS(7228),
    [anon_sym_i64] = ACTIONS(7228),
    [anon_sym_u128] = ACTIONS(7228),
    [anon_sym_i128] = ACTIONS(7228),
    [anon_sym_isize] = ACTIONS(7228),
    [anon_sym_usize] = ACTIONS(7228),
    [anon_sym_f32] = ACTIONS(7228),
    [anon_sym_f64] = ACTIONS(7228),
    [anon_sym_bool] = ACTIONS(7228),
    [anon_sym_str] = ACTIONS(7228),
    [anon_sym_char] = ACTIONS(7228),
    [anon_sym_AMP] = ACTIONS(7228),
    [anon_sym_DASH] = ACTIONS(7228),
    [anon_sym_DOT] = ACTIONS(7228),
    [anon_sym_DASH_EQ] = ACTIONS(7226),
    [anon_sym_COLON_COLON] = ACTIONS(7226),
    [anon_sym_BANG] = ACTIONS(7228),
    [anon_sym_BANG_EQ] = ACTIONS(7226),
    [anon_sym_STAR_EQ] = ACTIONS(7226),
    [anon_sym_SLASH] = ACTIONS(7228),
    [anon_sym_SLASH_EQ] = ACTIONS(7226),
    [anon_sym_AMP_AMP] = ACTIONS(7226),
    [anon_sym_AMP_EQ] = ACTIONS(7226),
    [anon_sym_POUND] = ACTIONS(7226),
    [anon_sym_PERCENT] = ACTIONS(7228),
    [anon_sym_PERCENT_EQ] = ACTIONS(7226),
    [anon_sym_CARET] = ACTIONS(7228),
    [anon_sym_CARET_EQ] = ACTIONS(7226),
    [anon_sym_PLUS_EQ] = ACTIONS(7226),
    [anon_sym_LT] = ACTIONS(7228),
    [anon_sym_LT_LT] = ACTIONS(7228),
    [anon_sym_LT_LT_EQ] = ACTIONS(7226),
    [anon_sym_LT_EQ] = ACTIONS(7226),
    [anon_sym_EQ] = ACTIONS(7228),
    [anon_sym_EQ_EQ] = ACTIONS(7226),
    [anon_sym_GT] = ACTIONS(7228),
    [anon_sym_GT_EQ] = ACTIONS(7226),
    [anon_sym_GT_GT] = ACTIONS(7228),
    [anon_sym_GT_GT_EQ] = ACTIONS(7226),
    [anon_sym_PIPE] = ACTIONS(7228),
    [anon_sym_PIPE_EQ] = ACTIONS(7226),
    [anon_sym_PIPE_PIPE] = ACTIONS(7226),
    [anon_sym_QMARK] = ACTIONS(7226),
    [anon_sym_SQUOTE] = ACTIONS(7228),
    [anon_sym_DOT_DOT] = ACTIONS(7228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7226),
    [anon_sym_as] = ACTIONS(7228),
    [anon_sym_break] = ACTIONS(7228),
    [anon_sym_const] = ACTIONS(7228),
    [anon_sym_continue] = ACTIONS(7228),
    [anon_sym_default] = ACTIONS(7228),
    [anon_sym_enum] = ACTIONS(7228),
    [anon_sym_fn] = ACTIONS(7228),
    [anon_sym_for] = ACTIONS(7228),
    [anon_sym_if] = ACTIONS(7228),
    [anon_sym_impl] = ACTIONS(7228),
    [anon_sym_let] = ACTIONS(7228),
    [anon_sym_loop] = ACTIONS(7228),
    [anon_sym_match] = ACTIONS(7228),
    [anon_sym_mod] = ACTIONS(7228),
    [anon_sym_pub] = ACTIONS(7228),
    [anon_sym_return] = ACTIONS(7228),
    [anon_sym_static] = ACTIONS(7228),
    [anon_sym_struct] = ACTIONS(7228),
    [anon_sym_trait] = ACTIONS(7228),
    [anon_sym_type] = ACTIONS(7228),
    [anon_sym_union] = ACTIONS(7228),
    [anon_sym_unsafe] = ACTIONS(7228),
    [anon_sym_use] = ACTIONS(7228),
    [anon_sym_while] = ACTIONS(7228),
    [anon_sym_extern] = ACTIONS(7228),
    [anon_sym_move] = ACTIONS(7228),
    [sym_integer_literal] = ACTIONS(7226),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7226),
    [sym_char_literal] = ACTIONS(7226),
    [anon_sym_true] = ACTIONS(7228),
    [anon_sym_false] = ACTIONS(7228),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7228),
    [sym_self] = ACTIONS(7228),
    [sym_super] = ACTIONS(7228),
    [sym_crate] = ACTIONS(7228),
    [sym_metavariable] = ACTIONS(7226),
  },
  [2983] = {
    [sym_raw_string_literal] = ACTIONS(5554),
    [sym_float_literal] = ACTIONS(5554),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5554),
    [anon_sym_LPAREN] = ACTIONS(5554),
    [anon_sym_RPAREN] = ACTIONS(5554),
    [anon_sym_LBRACE] = ACTIONS(5554),
    [anon_sym_RBRACE] = ACTIONS(5554),
    [anon_sym_EQ_GT] = ACTIONS(5554),
    [anon_sym_LBRACK] = ACTIONS(5554),
    [anon_sym_RBRACK] = ACTIONS(5554),
    [anon_sym_COLON] = ACTIONS(5556),
    [anon_sym_DOLLAR] = ACTIONS(5556),
    [anon_sym_PLUS] = ACTIONS(5556),
    [anon_sym_STAR] = ACTIONS(5556),
    [anon_sym_COMMA] = ACTIONS(5554),
    [anon_sym_u8] = ACTIONS(5556),
    [anon_sym_i8] = ACTIONS(5556),
    [anon_sym_u16] = ACTIONS(5556),
    [anon_sym_i16] = ACTIONS(5556),
    [anon_sym_u32] = ACTIONS(5556),
    [anon_sym_i32] = ACTIONS(5556),
    [anon_sym_u64] = ACTIONS(5556),
    [anon_sym_i64] = ACTIONS(5556),
    [anon_sym_u128] = ACTIONS(5556),
    [anon_sym_i128] = ACTIONS(5556),
    [anon_sym_isize] = ACTIONS(5556),
    [anon_sym_usize] = ACTIONS(5556),
    [anon_sym_f32] = ACTIONS(5556),
    [anon_sym_f64] = ACTIONS(5556),
    [anon_sym_bool] = ACTIONS(5556),
    [anon_sym_str] = ACTIONS(5556),
    [anon_sym_char] = ACTIONS(5556),
    [anon_sym__] = ACTIONS(5556),
    [anon_sym_AMP] = ACTIONS(5556),
    [anon_sym_DASH] = ACTIONS(5556),
    [anon_sym_DOT] = ACTIONS(5556),
    [anon_sym_DASH_EQ] = ACTIONS(5554),
    [anon_sym_DASH_GT] = ACTIONS(5554),
    [anon_sym_COLON_COLON] = ACTIONS(5554),
    [anon_sym_BANG] = ACTIONS(5556),
    [anon_sym_BANG_EQ] = ACTIONS(5554),
    [anon_sym_AT] = ACTIONS(5554),
    [anon_sym_STAR_EQ] = ACTIONS(5554),
    [anon_sym_SLASH] = ACTIONS(5556),
    [anon_sym_SLASH_EQ] = ACTIONS(5554),
    [anon_sym_AMP_AMP] = ACTIONS(5554),
    [anon_sym_AMP_EQ] = ACTIONS(5554),
    [anon_sym_POUND] = ACTIONS(5554),
    [anon_sym_PERCENT] = ACTIONS(5556),
    [anon_sym_PERCENT_EQ] = ACTIONS(5554),
    [anon_sym_CARET] = ACTIONS(5556),
    [anon_sym_CARET_EQ] = ACTIONS(5554),
    [anon_sym_PLUS_EQ] = ACTIONS(5554),
    [anon_sym_LT] = ACTIONS(5556),
    [anon_sym_LT_LT] = ACTIONS(5556),
    [anon_sym_LT_LT_EQ] = ACTIONS(5554),
    [anon_sym_LT_EQ] = ACTIONS(5554),
    [anon_sym_EQ] = ACTIONS(5556),
    [anon_sym_EQ_EQ] = ACTIONS(5554),
    [anon_sym_GT] = ACTIONS(5556),
    [anon_sym_GT_EQ] = ACTIONS(5554),
    [anon_sym_GT_GT] = ACTIONS(5556),
    [anon_sym_GT_GT_EQ] = ACTIONS(5554),
    [anon_sym_PIPE] = ACTIONS(5556),
    [anon_sym_PIPE_EQ] = ACTIONS(5554),
    [anon_sym_PIPE_PIPE] = ACTIONS(5554),
    [anon_sym_TILDE] = ACTIONS(5554),
    [anon_sym_QMARK] = ACTIONS(5554),
    [anon_sym_SQUOTE] = ACTIONS(5556),
    [anon_sym_DOT_DOT] = ACTIONS(5556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5554),
    [anon_sym_as] = ACTIONS(5556),
    [anon_sym_break] = ACTIONS(5556),
    [anon_sym_const] = ACTIONS(5556),
    [anon_sym_continue] = ACTIONS(5556),
    [anon_sym_default] = ACTIONS(5556),
    [anon_sym_enum] = ACTIONS(5556),
    [anon_sym_fn] = ACTIONS(5556),
    [anon_sym_for] = ACTIONS(5556),
    [anon_sym_if] = ACTIONS(5556),
    [anon_sym_impl] = ACTIONS(5556),
    [anon_sym_let] = ACTIONS(5556),
    [anon_sym_loop] = ACTIONS(5556),
    [anon_sym_match] = ACTIONS(5556),
    [anon_sym_mod] = ACTIONS(5556),
    [anon_sym_pub] = ACTIONS(5556),
    [anon_sym_return] = ACTIONS(5556),
    [anon_sym_static] = ACTIONS(5556),
    [anon_sym_struct] = ACTIONS(5556),
    [anon_sym_trait] = ACTIONS(5556),
    [anon_sym_type] = ACTIONS(5556),
    [anon_sym_union] = ACTIONS(5556),
    [anon_sym_unsafe] = ACTIONS(5556),
    [anon_sym_use] = ACTIONS(5556),
    [anon_sym_where] = ACTIONS(5556),
    [anon_sym_while] = ACTIONS(5556),
    [sym_mutable_specifier] = ACTIONS(5556),
    [sym_integer_literal] = ACTIONS(5554),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5554),
    [sym_char_literal] = ACTIONS(5554),
    [anon_sym_true] = ACTIONS(5556),
    [anon_sym_false] = ACTIONS(5556),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5556),
    [sym_self] = ACTIONS(5556),
    [sym_super] = ACTIONS(5556),
    [sym_crate] = ACTIONS(5556),
    [sym_metavariable] = ACTIONS(5554),
  },
  [2984] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1972),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1972),
    [sym_unary_expression] = STATE(1972),
    [sym_try_expression] = STATE(1972),
    [sym_reference_expression] = STATE(1972),
    [sym_binary_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1972),
    [sym_call_expression] = STATE(1972),
    [sym_array_expression] = STATE(1972),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_tuple_expression] = STATE(1972),
    [sym_unit_expression] = STATE(1972),
    [sym_struct_expression] = STATE(1972),
    [sym_if_expression] = STATE(1972),
    [sym_if_let_expression] = STATE(1972),
    [sym_match_expression] = STATE(1972),
    [sym_while_expression] = STATE(1972),
    [sym_while_let_expression] = STATE(1972),
    [sym_loop_expression] = STATE(1972),
    [sym_for_expression] = STATE(1972),
    [sym_closure_expression] = STATE(1972),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1972),
    [sym_continue_expression] = STATE(1972),
    [sym_index_expression] = STATE(1972),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1972),
    [sym_block] = STATE(1972),
    [sym__literal] = STATE(1972),
    [sym_string_literal] = STATE(1972),
    [sym_boolean_literal] = STATE(1972),
    [sym_raw_string_literal] = ACTIONS(4375),
    [sym_float_literal] = ACTIONS(4375),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(6548),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(4375),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4375),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2985] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(6548),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(623),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(623),
    [anon_sym_PLUS_EQ] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(623),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(643),
    [anon_sym_as] = ACTIONS(645),
    [sym_line_comment] = ACTIONS(7),
  },
  [2986] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(769),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(769),
    [sym_macro_invocation] = STATE(769),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(769),
    [sym_unary_expression] = STATE(769),
    [sym_try_expression] = STATE(769),
    [sym_reference_expression] = STATE(769),
    [sym_binary_expression] = STATE(769),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(769),
    [sym_call_expression] = STATE(769),
    [sym_array_expression] = STATE(769),
    [sym_parenthesized_expression] = STATE(769),
    [sym_tuple_expression] = STATE(769),
    [sym_unit_expression] = STATE(769),
    [sym_struct_expression] = STATE(769),
    [sym_if_expression] = STATE(769),
    [sym_if_let_expression] = STATE(769),
    [sym_match_expression] = STATE(769),
    [sym_while_expression] = STATE(769),
    [sym_while_let_expression] = STATE(769),
    [sym_loop_expression] = STATE(769),
    [sym_for_expression] = STATE(769),
    [sym_closure_expression] = STATE(769),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(769),
    [sym_continue_expression] = STATE(769),
    [sym_index_expression] = STATE(769),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(769),
    [sym_block] = STATE(769),
    [sym__literal] = STATE(769),
    [sym_string_literal] = STATE(769),
    [sym_boolean_literal] = STATE(769),
    [sym_raw_string_literal] = ACTIONS(1620),
    [sym_float_literal] = ACTIONS(1620),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_RBRACK] = ACTIONS(6548),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1620),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1620),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2987] = {
    [aux_sym_token_tree_repeat2] = STATE(789),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACK] = ACTIONS(6548),
    [anon_sym_COMMA] = ACTIONS(7230),
    [sym_line_comment] = ACTIONS(7),
  },
  [2988] = {
    [sym_raw_string_literal] = ACTIONS(6588),
    [sym_float_literal] = ACTIONS(6588),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7180),
    [anon_sym_LPAREN] = ACTIONS(7180),
    [anon_sym_LBRACE] = ACTIONS(6588),
    [anon_sym_RBRACE] = ACTIONS(7180),
    [anon_sym_EQ_GT] = ACTIONS(6588),
    [anon_sym_LBRACK] = ACTIONS(7180),
    [anon_sym_COLON] = ACTIONS(6590),
    [anon_sym_DOLLAR] = ACTIONS(6590),
    [anon_sym_PLUS] = ACTIONS(7183),
    [anon_sym_STAR] = ACTIONS(7183),
    [anon_sym_COMMA] = ACTIONS(6588),
    [anon_sym_u8] = ACTIONS(6590),
    [anon_sym_i8] = ACTIONS(6590),
    [anon_sym_u16] = ACTIONS(6590),
    [anon_sym_i16] = ACTIONS(6590),
    [anon_sym_u32] = ACTIONS(6590),
    [anon_sym_i32] = ACTIONS(6590),
    [anon_sym_u64] = ACTIONS(6590),
    [anon_sym_i64] = ACTIONS(6590),
    [anon_sym_u128] = ACTIONS(6590),
    [anon_sym_i128] = ACTIONS(6590),
    [anon_sym_isize] = ACTIONS(6590),
    [anon_sym_usize] = ACTIONS(6590),
    [anon_sym_f32] = ACTIONS(6590),
    [anon_sym_f64] = ACTIONS(6590),
    [anon_sym_bool] = ACTIONS(6590),
    [anon_sym_str] = ACTIONS(6590),
    [anon_sym_char] = ACTIONS(6590),
    [anon_sym__] = ACTIONS(6590),
    [anon_sym_AMP] = ACTIONS(7183),
    [anon_sym_DASH] = ACTIONS(7183),
    [anon_sym_DOT] = ACTIONS(7183),
    [anon_sym_DASH_EQ] = ACTIONS(7180),
    [anon_sym_DASH_GT] = ACTIONS(6588),
    [anon_sym_COLON_COLON] = ACTIONS(6588),
    [anon_sym_BANG] = ACTIONS(6590),
    [anon_sym_BANG_EQ] = ACTIONS(7180),
    [anon_sym_AT] = ACTIONS(6588),
    [anon_sym_STAR_EQ] = ACTIONS(7180),
    [anon_sym_SLASH] = ACTIONS(7183),
    [anon_sym_SLASH_EQ] = ACTIONS(7180),
    [anon_sym_AMP_AMP] = ACTIONS(7180),
    [anon_sym_AMP_EQ] = ACTIONS(7180),
    [anon_sym_POUND] = ACTIONS(6588),
    [anon_sym_PERCENT] = ACTIONS(7183),
    [anon_sym_PERCENT_EQ] = ACTIONS(7180),
    [anon_sym_CARET] = ACTIONS(7183),
    [anon_sym_CARET_EQ] = ACTIONS(7180),
    [anon_sym_PLUS_EQ] = ACTIONS(7180),
    [anon_sym_LT] = ACTIONS(7183),
    [anon_sym_LT_LT] = ACTIONS(7183),
    [anon_sym_LT_LT_EQ] = ACTIONS(7180),
    [anon_sym_LT_EQ] = ACTIONS(7180),
    [anon_sym_EQ] = ACTIONS(7183),
    [anon_sym_EQ_EQ] = ACTIONS(7180),
    [anon_sym_GT] = ACTIONS(7183),
    [anon_sym_GT_EQ] = ACTIONS(7180),
    [anon_sym_GT_GT] = ACTIONS(7183),
    [anon_sym_GT_GT_EQ] = ACTIONS(7180),
    [anon_sym_PIPE] = ACTIONS(7183),
    [anon_sym_PIPE_EQ] = ACTIONS(7180),
    [anon_sym_PIPE_PIPE] = ACTIONS(7180),
    [anon_sym_TILDE] = ACTIONS(6588),
    [anon_sym_QMARK] = ACTIONS(7180),
    [anon_sym_SQUOTE] = ACTIONS(6590),
    [anon_sym_DOT_DOT] = ACTIONS(7183),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7180),
    [anon_sym_as] = ACTIONS(7183),
    [anon_sym_break] = ACTIONS(6590),
    [anon_sym_const] = ACTIONS(6590),
    [anon_sym_continue] = ACTIONS(6590),
    [anon_sym_default] = ACTIONS(6590),
    [anon_sym_enum] = ACTIONS(6590),
    [anon_sym_fn] = ACTIONS(6590),
    [anon_sym_for] = ACTIONS(6590),
    [anon_sym_if] = ACTIONS(6590),
    [anon_sym_impl] = ACTIONS(6590),
    [anon_sym_let] = ACTIONS(6590),
    [anon_sym_loop] = ACTIONS(6590),
    [anon_sym_match] = ACTIONS(6590),
    [anon_sym_mod] = ACTIONS(6590),
    [anon_sym_pub] = ACTIONS(6590),
    [anon_sym_return] = ACTIONS(6590),
    [anon_sym_static] = ACTIONS(6590),
    [anon_sym_struct] = ACTIONS(6590),
    [anon_sym_trait] = ACTIONS(6590),
    [anon_sym_type] = ACTIONS(6590),
    [anon_sym_union] = ACTIONS(6590),
    [anon_sym_unsafe] = ACTIONS(6590),
    [anon_sym_use] = ACTIONS(6590),
    [anon_sym_where] = ACTIONS(6590),
    [anon_sym_while] = ACTIONS(6590),
    [sym_mutable_specifier] = ACTIONS(6590),
    [sym_integer_literal] = ACTIONS(6588),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6588),
    [sym_char_literal] = ACTIONS(6588),
    [anon_sym_true] = ACTIONS(6590),
    [anon_sym_false] = ACTIONS(6590),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6590),
    [sym_self] = ACTIONS(6590),
    [sym_super] = ACTIONS(6590),
    [sym_crate] = ACTIONS(6590),
    [sym_metavariable] = ACTIONS(6588),
  },
  [2989] = {
    [sym_raw_string_literal] = ACTIONS(7194),
    [sym_float_literal] = ACTIONS(7194),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7194),
    [anon_sym_macro_rules_BANG] = ACTIONS(2789),
    [anon_sym_LPAREN] = ACTIONS(7194),
    [anon_sym_LBRACE] = ACTIONS(7194),
    [anon_sym_RBRACE] = ACTIONS(7194),
    [anon_sym_EQ_GT] = ACTIONS(6588),
    [anon_sym_LBRACK] = ACTIONS(7194),
    [anon_sym_COLON] = ACTIONS(6590),
    [anon_sym_DOLLAR] = ACTIONS(6590),
    [anon_sym_PLUS] = ACTIONS(7197),
    [anon_sym_STAR] = ACTIONS(7197),
    [anon_sym_COMMA] = ACTIONS(6588),
    [anon_sym_u8] = ACTIONS(7197),
    [anon_sym_i8] = ACTIONS(7197),
    [anon_sym_u16] = ACTIONS(7197),
    [anon_sym_i16] = ACTIONS(7197),
    [anon_sym_u32] = ACTIONS(7197),
    [anon_sym_i32] = ACTIONS(7197),
    [anon_sym_u64] = ACTIONS(7197),
    [anon_sym_i64] = ACTIONS(7197),
    [anon_sym_u128] = ACTIONS(7197),
    [anon_sym_i128] = ACTIONS(7197),
    [anon_sym_isize] = ACTIONS(7197),
    [anon_sym_usize] = ACTIONS(7197),
    [anon_sym_f32] = ACTIONS(7197),
    [anon_sym_f64] = ACTIONS(7197),
    [anon_sym_bool] = ACTIONS(7197),
    [anon_sym_str] = ACTIONS(7197),
    [anon_sym_char] = ACTIONS(7197),
    [anon_sym__] = ACTIONS(6590),
    [anon_sym_AMP] = ACTIONS(7197),
    [anon_sym_DASH] = ACTIONS(7197),
    [anon_sym_DOT] = ACTIONS(7197),
    [anon_sym_DASH_EQ] = ACTIONS(7194),
    [anon_sym_DASH_GT] = ACTIONS(6588),
    [anon_sym_COLON_COLON] = ACTIONS(7194),
    [anon_sym_BANG] = ACTIONS(7197),
    [anon_sym_BANG_EQ] = ACTIONS(7194),
    [anon_sym_AT] = ACTIONS(6588),
    [anon_sym_STAR_EQ] = ACTIONS(7194),
    [anon_sym_SLASH] = ACTIONS(7197),
    [anon_sym_SLASH_EQ] = ACTIONS(7194),
    [anon_sym_AMP_AMP] = ACTIONS(7194),
    [anon_sym_AMP_EQ] = ACTIONS(7194),
    [anon_sym_POUND] = ACTIONS(7194),
    [anon_sym_PERCENT] = ACTIONS(7197),
    [anon_sym_PERCENT_EQ] = ACTIONS(7194),
    [anon_sym_CARET] = ACTIONS(7197),
    [anon_sym_CARET_EQ] = ACTIONS(7194),
    [anon_sym_PLUS_EQ] = ACTIONS(7194),
    [anon_sym_LT] = ACTIONS(7197),
    [anon_sym_LT_LT] = ACTIONS(7197),
    [anon_sym_LT_LT_EQ] = ACTIONS(7194),
    [anon_sym_LT_EQ] = ACTIONS(7194),
    [anon_sym_EQ] = ACTIONS(7197),
    [anon_sym_EQ_EQ] = ACTIONS(7194),
    [anon_sym_GT] = ACTIONS(7197),
    [anon_sym_GT_EQ] = ACTIONS(7194),
    [anon_sym_GT_GT] = ACTIONS(7197),
    [anon_sym_GT_GT_EQ] = ACTIONS(7194),
    [anon_sym_PIPE] = ACTIONS(7197),
    [anon_sym_PIPE_EQ] = ACTIONS(7194),
    [anon_sym_PIPE_PIPE] = ACTIONS(7194),
    [anon_sym_TILDE] = ACTIONS(6588),
    [anon_sym_QMARK] = ACTIONS(7194),
    [anon_sym_SQUOTE] = ACTIONS(7197),
    [anon_sym_DOT_DOT] = ACTIONS(7197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7194),
    [anon_sym_as] = ACTIONS(7197),
    [anon_sym_break] = ACTIONS(7197),
    [anon_sym_const] = ACTIONS(7197),
    [anon_sym_continue] = ACTIONS(7197),
    [anon_sym_default] = ACTIONS(7197),
    [anon_sym_enum] = ACTIONS(7197),
    [anon_sym_fn] = ACTIONS(7197),
    [anon_sym_for] = ACTIONS(7197),
    [anon_sym_if] = ACTIONS(7197),
    [anon_sym_impl] = ACTIONS(7197),
    [anon_sym_let] = ACTIONS(7197),
    [anon_sym_loop] = ACTIONS(7197),
    [anon_sym_match] = ACTIONS(7197),
    [anon_sym_mod] = ACTIONS(7197),
    [anon_sym_pub] = ACTIONS(7197),
    [anon_sym_return] = ACTIONS(7197),
    [anon_sym_static] = ACTIONS(7197),
    [anon_sym_struct] = ACTIONS(7197),
    [anon_sym_trait] = ACTIONS(7197),
    [anon_sym_type] = ACTIONS(7197),
    [anon_sym_union] = ACTIONS(7197),
    [anon_sym_unsafe] = ACTIONS(7197),
    [anon_sym_use] = ACTIONS(7197),
    [anon_sym_where] = ACTIONS(6590),
    [anon_sym_while] = ACTIONS(7197),
    [anon_sym_extern] = ACTIONS(2791),
    [sym_mutable_specifier] = ACTIONS(6590),
    [anon_sym_move] = ACTIONS(2791),
    [sym_integer_literal] = ACTIONS(7194),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7194),
    [sym_char_literal] = ACTIONS(7194),
    [anon_sym_true] = ACTIONS(7197),
    [anon_sym_false] = ACTIONS(7197),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7197),
    [sym_self] = ACTIONS(7197),
    [sym_super] = ACTIONS(7197),
    [sym_crate] = ACTIONS(7197),
    [sym_metavariable] = ACTIONS(7194),
  },
  [2990] = {
    [sym_raw_string_literal] = ACTIONS(6588),
    [sym_float_literal] = ACTIONS(6588),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_LPAREN] = ACTIONS(7208),
    [anon_sym_LBRACE] = ACTIONS(6588),
    [anon_sym_RBRACE] = ACTIONS(7208),
    [anon_sym_EQ_GT] = ACTIONS(6588),
    [anon_sym_LBRACK] = ACTIONS(7208),
    [anon_sym_COLON] = ACTIONS(6590),
    [anon_sym_DOLLAR] = ACTIONS(6590),
    [anon_sym_PLUS] = ACTIONS(7211),
    [anon_sym_STAR] = ACTIONS(7211),
    [anon_sym_COMMA] = ACTIONS(6588),
    [anon_sym_u8] = ACTIONS(6590),
    [anon_sym_i8] = ACTIONS(6590),
    [anon_sym_u16] = ACTIONS(6590),
    [anon_sym_i16] = ACTIONS(6590),
    [anon_sym_u32] = ACTIONS(6590),
    [anon_sym_i32] = ACTIONS(6590),
    [anon_sym_u64] = ACTIONS(6590),
    [anon_sym_i64] = ACTIONS(6590),
    [anon_sym_u128] = ACTIONS(6590),
    [anon_sym_i128] = ACTIONS(6590),
    [anon_sym_isize] = ACTIONS(6590),
    [anon_sym_usize] = ACTIONS(6590),
    [anon_sym_f32] = ACTIONS(6590),
    [anon_sym_f64] = ACTIONS(6590),
    [anon_sym_bool] = ACTIONS(6590),
    [anon_sym_str] = ACTIONS(6590),
    [anon_sym_char] = ACTIONS(6590),
    [anon_sym__] = ACTIONS(6590),
    [anon_sym_AMP] = ACTIONS(7211),
    [anon_sym_DASH] = ACTIONS(7211),
    [anon_sym_DOT] = ACTIONS(7211),
    [anon_sym_DASH_EQ] = ACTIONS(7208),
    [anon_sym_DASH_GT] = ACTIONS(6588),
    [anon_sym_COLON_COLON] = ACTIONS(6588),
    [anon_sym_BANG] = ACTIONS(6590),
    [anon_sym_BANG_EQ] = ACTIONS(7208),
    [anon_sym_AT] = ACTIONS(6588),
    [anon_sym_STAR_EQ] = ACTIONS(7208),
    [anon_sym_SLASH] = ACTIONS(7211),
    [anon_sym_SLASH_EQ] = ACTIONS(7208),
    [anon_sym_AMP_AMP] = ACTIONS(7208),
    [anon_sym_AMP_EQ] = ACTIONS(7208),
    [anon_sym_POUND] = ACTIONS(6588),
    [anon_sym_PERCENT] = ACTIONS(7211),
    [anon_sym_PERCENT_EQ] = ACTIONS(7208),
    [anon_sym_CARET] = ACTIONS(7211),
    [anon_sym_CARET_EQ] = ACTIONS(7208),
    [anon_sym_PLUS_EQ] = ACTIONS(7208),
    [anon_sym_LT] = ACTIONS(7211),
    [anon_sym_LT_LT] = ACTIONS(7211),
    [anon_sym_LT_LT_EQ] = ACTIONS(7208),
    [anon_sym_LT_EQ] = ACTIONS(7208),
    [anon_sym_EQ] = ACTIONS(7211),
    [anon_sym_EQ_EQ] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7211),
    [anon_sym_GT_EQ] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7211),
    [anon_sym_GT_GT_EQ] = ACTIONS(7208),
    [anon_sym_PIPE] = ACTIONS(7211),
    [anon_sym_PIPE_EQ] = ACTIONS(7208),
    [anon_sym_PIPE_PIPE] = ACTIONS(7208),
    [anon_sym_TILDE] = ACTIONS(6588),
    [anon_sym_QMARK] = ACTIONS(7208),
    [anon_sym_SQUOTE] = ACTIONS(6590),
    [anon_sym_DOT_DOT] = ACTIONS(7211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7208),
    [anon_sym_as] = ACTIONS(7211),
    [anon_sym_break] = ACTIONS(6590),
    [anon_sym_const] = ACTIONS(6590),
    [anon_sym_continue] = ACTIONS(6590),
    [anon_sym_default] = ACTIONS(6590),
    [anon_sym_enum] = ACTIONS(6590),
    [anon_sym_fn] = ACTIONS(6590),
    [anon_sym_for] = ACTIONS(6590),
    [anon_sym_if] = ACTIONS(6590),
    [anon_sym_impl] = ACTIONS(6590),
    [anon_sym_let] = ACTIONS(6590),
    [anon_sym_loop] = ACTIONS(6590),
    [anon_sym_match] = ACTIONS(6590),
    [anon_sym_mod] = ACTIONS(6590),
    [anon_sym_pub] = ACTIONS(6590),
    [anon_sym_return] = ACTIONS(6590),
    [anon_sym_static] = ACTIONS(6590),
    [anon_sym_struct] = ACTIONS(6590),
    [anon_sym_trait] = ACTIONS(6590),
    [anon_sym_type] = ACTIONS(6590),
    [anon_sym_union] = ACTIONS(6590),
    [anon_sym_unsafe] = ACTIONS(6590),
    [anon_sym_use] = ACTIONS(6590),
    [anon_sym_where] = ACTIONS(6590),
    [anon_sym_while] = ACTIONS(6590),
    [sym_mutable_specifier] = ACTIONS(6590),
    [sym_integer_literal] = ACTIONS(6588),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6588),
    [sym_char_literal] = ACTIONS(6588),
    [anon_sym_true] = ACTIONS(6590),
    [anon_sym_false] = ACTIONS(6590),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6590),
    [sym_self] = ACTIONS(6590),
    [sym_super] = ACTIONS(6590),
    [sym_crate] = ACTIONS(6590),
    [sym_metavariable] = ACTIONS(6588),
  },
  [2991] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(769),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(769),
    [sym_macro_invocation] = STATE(769),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(769),
    [sym_unary_expression] = STATE(769),
    [sym_try_expression] = STATE(769),
    [sym_reference_expression] = STATE(769),
    [sym_binary_expression] = STATE(769),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(769),
    [sym_call_expression] = STATE(769),
    [sym_array_expression] = STATE(769),
    [sym_parenthesized_expression] = STATE(769),
    [sym_tuple_expression] = STATE(769),
    [sym_unit_expression] = STATE(769),
    [sym_struct_expression] = STATE(769),
    [sym_if_expression] = STATE(769),
    [sym_if_let_expression] = STATE(769),
    [sym_match_expression] = STATE(769),
    [sym_while_expression] = STATE(769),
    [sym_while_let_expression] = STATE(769),
    [sym_loop_expression] = STATE(769),
    [sym_for_expression] = STATE(769),
    [sym_closure_expression] = STATE(769),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(769),
    [sym_continue_expression] = STATE(769),
    [sym_index_expression] = STATE(769),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(769),
    [sym_block] = STATE(769),
    [sym__literal] = STATE(769),
    [sym_string_literal] = STATE(769),
    [sym_boolean_literal] = STATE(769),
    [sym_raw_string_literal] = ACTIONS(1620),
    [sym_float_literal] = ACTIONS(1620),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_RBRACK] = ACTIONS(7232),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1620),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1620),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [2992] = {
    [sym_where_clause] = STATE(3317),
    [sym_block] = STATE(3145),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6873),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_PLUS] = ACTIONS(5003),
    [anon_sym_where] = ACTIONS(1962),
    [sym_line_comment] = ACTIONS(7),
  },
  [2993] = {
    [sym_where_clause] = STATE(3317),
    [sym_block] = STATE(3145),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6873),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_where] = ACTIONS(1962),
    [sym_line_comment] = ACTIONS(7),
  },
  [2994] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4513),
    [anon_sym_macro_rules_BANG] = ACTIONS(4513),
    [anon_sym_RBRACE] = ACTIONS(4513),
    [anon_sym_POUND] = ACTIONS(4513),
    [anon_sym_const] = ACTIONS(4515),
    [anon_sym_default] = ACTIONS(4515),
    [anon_sym_enum] = ACTIONS(4515),
    [anon_sym_fn] = ACTIONS(4515),
    [anon_sym_impl] = ACTIONS(4515),
    [anon_sym_let] = ACTIONS(4515),
    [anon_sym_mod] = ACTIONS(4515),
    [anon_sym_pub] = ACTIONS(4515),
    [anon_sym_static] = ACTIONS(4515),
    [anon_sym_struct] = ACTIONS(4515),
    [anon_sym_trait] = ACTIONS(4515),
    [anon_sym_type] = ACTIONS(4515),
    [anon_sym_union] = ACTIONS(4515),
    [anon_sym_unsafe] = ACTIONS(4515),
    [anon_sym_use] = ACTIONS(4515),
    [anon_sym_extern] = ACTIONS(4515),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4515),
  },
  [2995] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7234),
    [sym_line_comment] = ACTIONS(7),
  },
  [2996] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_RPAREN] = ACTIONS(7236),
    [sym_line_comment] = ACTIONS(7),
  },
  [2997] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_RBRACE] = ACTIONS(7234),
    [sym_line_comment] = ACTIONS(7),
  },
  [2998] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4741),
    [anon_sym_macro_rules_BANG] = ACTIONS(4741),
    [anon_sym_RBRACE] = ACTIONS(4741),
    [anon_sym_POUND] = ACTIONS(4741),
    [anon_sym_const] = ACTIONS(4743),
    [anon_sym_default] = ACTIONS(4743),
    [anon_sym_enum] = ACTIONS(4743),
    [anon_sym_fn] = ACTIONS(4743),
    [anon_sym_impl] = ACTIONS(4743),
    [anon_sym_let] = ACTIONS(4743),
    [anon_sym_mod] = ACTIONS(4743),
    [anon_sym_pub] = ACTIONS(4743),
    [anon_sym_static] = ACTIONS(4743),
    [anon_sym_struct] = ACTIONS(4743),
    [anon_sym_trait] = ACTIONS(4743),
    [anon_sym_type] = ACTIONS(4743),
    [anon_sym_union] = ACTIONS(4743),
    [anon_sym_unsafe] = ACTIONS(4743),
    [anon_sym_use] = ACTIONS(4743),
    [anon_sym_extern] = ACTIONS(4743),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4743),
  },
  [2999] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3320),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3320),
    [sym_macro_invocation] = STATE(3320),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3320),
    [sym_unary_expression] = STATE(3320),
    [sym_try_expression] = STATE(3320),
    [sym_reference_expression] = STATE(3320),
    [sym_binary_expression] = STATE(3320),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3320),
    [sym_call_expression] = STATE(3320),
    [sym_array_expression] = STATE(3320),
    [sym_parenthesized_expression] = STATE(3320),
    [sym_tuple_expression] = STATE(3320),
    [sym_unit_expression] = STATE(3320),
    [sym_struct_expression] = STATE(3320),
    [sym_if_expression] = STATE(3320),
    [sym_if_let_expression] = STATE(3320),
    [sym_match_expression] = STATE(3320),
    [sym_while_expression] = STATE(3320),
    [sym_while_let_expression] = STATE(3320),
    [sym_loop_expression] = STATE(3320),
    [sym_for_expression] = STATE(3320),
    [sym_closure_expression] = STATE(3320),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3320),
    [sym_continue_expression] = STATE(3320),
    [sym_index_expression] = STATE(3320),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3320),
    [sym_block] = STATE(3320),
    [sym__literal] = STATE(3320),
    [sym_string_literal] = STATE(3320),
    [sym_boolean_literal] = STATE(3320),
    [sym_raw_string_literal] = ACTIONS(7238),
    [sym_float_literal] = ACTIONS(7238),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(7238),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7238),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [3000] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4919),
    [anon_sym_macro_rules_BANG] = ACTIONS(4919),
    [anon_sym_RBRACE] = ACTIONS(4919),
    [anon_sym_POUND] = ACTIONS(4919),
    [anon_sym_const] = ACTIONS(4921),
    [anon_sym_default] = ACTIONS(4921),
    [anon_sym_enum] = ACTIONS(4921),
    [anon_sym_fn] = ACTIONS(4921),
    [anon_sym_impl] = ACTIONS(4921),
    [anon_sym_let] = ACTIONS(4921),
    [anon_sym_mod] = ACTIONS(4921),
    [anon_sym_pub] = ACTIONS(4921),
    [anon_sym_static] = ACTIONS(4921),
    [anon_sym_struct] = ACTIONS(4921),
    [anon_sym_trait] = ACTIONS(4921),
    [anon_sym_type] = ACTIONS(4921),
    [anon_sym_union] = ACTIONS(4921),
    [anon_sym_unsafe] = ACTIONS(4921),
    [anon_sym_use] = ACTIONS(4921),
    [anon_sym_extern] = ACTIONS(4921),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4921),
  },
  [3001] = {
    [sym_attribute_item] = STATE(2209),
    [sym_enum_variant] = STATE(2208),
    [sym_visibility_modifier] = STATE(938),
    [aux_sym_enum_variant_list_repeat1] = STATE(2209),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7240),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_pub] = ACTIONS(1940),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1942),
  },
  [3002] = {
    [aux_sym_enum_variant_list_repeat2] = STATE(2211),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7240),
    [anon_sym_COMMA] = ACTIONS(7242),
    [sym_line_comment] = ACTIONS(7),
  },
  [3003] = {
    [aux_sym_enum_variant_list_repeat2] = STATE(3323),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7240),
    [anon_sym_COMMA] = ACTIONS(7242),
    [sym_line_comment] = ACTIONS(7),
  },
  [3004] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4977),
    [anon_sym_macro_rules_BANG] = ACTIONS(4977),
    [anon_sym_RBRACE] = ACTIONS(4977),
    [anon_sym_POUND] = ACTIONS(4977),
    [anon_sym_const] = ACTIONS(4979),
    [anon_sym_default] = ACTIONS(4979),
    [anon_sym_enum] = ACTIONS(4979),
    [anon_sym_fn] = ACTIONS(4979),
    [anon_sym_impl] = ACTIONS(4979),
    [anon_sym_let] = ACTIONS(4979),
    [anon_sym_mod] = ACTIONS(4979),
    [anon_sym_pub] = ACTIONS(4979),
    [anon_sym_static] = ACTIONS(4979),
    [anon_sym_struct] = ACTIONS(4979),
    [anon_sym_trait] = ACTIONS(4979),
    [anon_sym_type] = ACTIONS(4979),
    [anon_sym_union] = ACTIONS(4979),
    [anon_sym_unsafe] = ACTIONS(4979),
    [anon_sym_use] = ACTIONS(4979),
    [anon_sym_extern] = ACTIONS(4979),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4979),
  },
  [3005] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4981),
    [anon_sym_macro_rules_BANG] = ACTIONS(4981),
    [anon_sym_RBRACE] = ACTIONS(4981),
    [anon_sym_POUND] = ACTIONS(4981),
    [anon_sym_const] = ACTIONS(4983),
    [anon_sym_default] = ACTIONS(4983),
    [anon_sym_enum] = ACTIONS(4983),
    [anon_sym_fn] = ACTIONS(4983),
    [anon_sym_impl] = ACTIONS(4983),
    [anon_sym_let] = ACTIONS(4983),
    [anon_sym_mod] = ACTIONS(4983),
    [anon_sym_pub] = ACTIONS(4983),
    [anon_sym_static] = ACTIONS(4983),
    [anon_sym_struct] = ACTIONS(4983),
    [anon_sym_trait] = ACTIONS(4983),
    [anon_sym_type] = ACTIONS(4983),
    [anon_sym_union] = ACTIONS(4983),
    [anon_sym_unsafe] = ACTIONS(4983),
    [anon_sym_use] = ACTIONS(4983),
    [anon_sym_extern] = ACTIONS(4983),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4983),
  },
  [3006] = {
    [sym_function_modifiers] = STATE(1624),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3324),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1626),
    [sym_array_type] = STATE(3324),
    [sym_function_type] = STATE(3324),
    [sym_tuple_type] = STATE(3324),
    [sym_unit_type] = STATE(3324),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(3324),
    [sym_reference_type] = STATE(3324),
    [sym_pointer_type] = STATE(3324),
    [sym_empty_type] = STATE(3324),
    [sym_abstract_type] = STATE(3325),
    [sym_dynamic_type] = STATE(3324),
    [sym_macro_invocation] = STATE(3324),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1628),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3169),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3171),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3173),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3175),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3007] = {
    [sym_block] = STATE(3327),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_LBRACE] = ACTIONS(111),
    [sym_line_comment] = ACTIONS(7),
  },
  [3008] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4987),
    [anon_sym_macro_rules_BANG] = ACTIONS(4987),
    [anon_sym_RBRACE] = ACTIONS(4987),
    [anon_sym_POUND] = ACTIONS(4987),
    [anon_sym_const] = ACTIONS(4989),
    [anon_sym_default] = ACTIONS(4989),
    [anon_sym_enum] = ACTIONS(4989),
    [anon_sym_fn] = ACTIONS(4989),
    [anon_sym_impl] = ACTIONS(4989),
    [anon_sym_let] = ACTIONS(4989),
    [anon_sym_mod] = ACTIONS(4989),
    [anon_sym_pub] = ACTIONS(4989),
    [anon_sym_static] = ACTIONS(4989),
    [anon_sym_struct] = ACTIONS(4989),
    [anon_sym_trait] = ACTIONS(4989),
    [anon_sym_type] = ACTIONS(4989),
    [anon_sym_union] = ACTIONS(4989),
    [anon_sym_unsafe] = ACTIONS(4989),
    [anon_sym_use] = ACTIONS(4989),
    [anon_sym_extern] = ACTIONS(4989),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4989),
  },
  [3009] = {
    [sym_where_clause] = STATE(3328),
    [sym_block] = STATE(3327),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(5003),
    [anon_sym_where] = ACTIONS(1962),
    [sym_line_comment] = ACTIONS(7),
  },
  [3010] = {
    [sym_where_clause] = STATE(3328),
    [sym_block] = STATE(3327),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_where] = ACTIONS(1962),
    [sym_line_comment] = ACTIONS(7),
  },
  [3011] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5068),
    [anon_sym_macro_rules_BANG] = ACTIONS(5068),
    [anon_sym_RBRACE] = ACTIONS(5068),
    [anon_sym_POUND] = ACTIONS(5068),
    [anon_sym_const] = ACTIONS(5070),
    [anon_sym_default] = ACTIONS(5070),
    [anon_sym_enum] = ACTIONS(5070),
    [anon_sym_fn] = ACTIONS(5070),
    [anon_sym_impl] = ACTIONS(5070),
    [anon_sym_let] = ACTIONS(5070),
    [anon_sym_mod] = ACTIONS(5070),
    [anon_sym_pub] = ACTIONS(5070),
    [anon_sym_static] = ACTIONS(5070),
    [anon_sym_struct] = ACTIONS(5070),
    [anon_sym_trait] = ACTIONS(5070),
    [anon_sym_type] = ACTIONS(5070),
    [anon_sym_union] = ACTIONS(5070),
    [anon_sym_unsafe] = ACTIONS(5070),
    [anon_sym_use] = ACTIONS(5070),
    [anon_sym_extern] = ACTIONS(5070),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5070),
  },
  [3012] = {
    [sym_declaration_list] = STATE(3329),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [sym_line_comment] = ACTIONS(7),
  },
  [3013] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5072),
    [anon_sym_macro_rules_BANG] = ACTIONS(5072),
    [anon_sym_RBRACE] = ACTIONS(5072),
    [anon_sym_POUND] = ACTIONS(5072),
    [anon_sym_const] = ACTIONS(5074),
    [anon_sym_default] = ACTIONS(5074),
    [anon_sym_enum] = ACTIONS(5074),
    [anon_sym_fn] = ACTIONS(5074),
    [anon_sym_impl] = ACTIONS(5074),
    [anon_sym_let] = ACTIONS(5074),
    [anon_sym_mod] = ACTIONS(5074),
    [anon_sym_pub] = ACTIONS(5074),
    [anon_sym_static] = ACTIONS(5074),
    [anon_sym_struct] = ACTIONS(5074),
    [anon_sym_trait] = ACTIONS(5074),
    [anon_sym_type] = ACTIONS(5074),
    [anon_sym_union] = ACTIONS(5074),
    [anon_sym_unsafe] = ACTIONS(5074),
    [anon_sym_use] = ACTIONS(5074),
    [anon_sym_extern] = ACTIONS(5074),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5074),
  },
  [3014] = {
    [sym_declaration_list] = STATE(3330),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [sym_line_comment] = ACTIONS(7),
  },
  [3015] = {
    [sym_declaration_list] = STATE(3330),
    [sym_where_clause] = STATE(3331),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [3016] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5076),
    [anon_sym_macro_rules_BANG] = ACTIONS(5076),
    [anon_sym_RBRACE] = ACTIONS(5076),
    [anon_sym_POUND] = ACTIONS(5076),
    [anon_sym_const] = ACTIONS(5078),
    [anon_sym_default] = ACTIONS(5078),
    [anon_sym_enum] = ACTIONS(5078),
    [anon_sym_fn] = ACTIONS(5078),
    [anon_sym_impl] = ACTIONS(5078),
    [anon_sym_let] = ACTIONS(5078),
    [anon_sym_mod] = ACTIONS(5078),
    [anon_sym_pub] = ACTIONS(5078),
    [anon_sym_static] = ACTIONS(5078),
    [anon_sym_struct] = ACTIONS(5078),
    [anon_sym_trait] = ACTIONS(5078),
    [anon_sym_type] = ACTIONS(5078),
    [anon_sym_union] = ACTIONS(5078),
    [anon_sym_unsafe] = ACTIONS(5078),
    [anon_sym_use] = ACTIONS(5078),
    [anon_sym_extern] = ACTIONS(5078),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5078),
  },
  [3017] = {
    [sym_declaration_list] = STATE(3332),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [sym_line_comment] = ACTIONS(7),
  },
  [3018] = {
    [sym_declaration_list] = STATE(3332),
    [sym_where_clause] = STATE(3333),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [3019] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7246),
    [anon_sym_PLUS] = ACTIONS(3279),
    [anon_sym_EQ] = ACTIONS(7248),
    [sym_line_comment] = ACTIONS(7),
  },
  [3020] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7246),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(467),
    [anon_sym_BANG_EQ] = ACTIONS(469),
    [anon_sym_STAR_EQ] = ACTIONS(467),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(467),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_AMP_EQ] = ACTIONS(467),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(467),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_CARET_EQ] = ACTIONS(467),
    [anon_sym_PLUS_EQ] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT_LT_EQ] = ACTIONS(467),
    [anon_sym_LT_EQ] = ACTIONS(469),
    [anon_sym_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_EQ] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_PIPE_EQ] = ACTIONS(467),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(489),
    [anon_sym_as] = ACTIONS(491),
    [sym_line_comment] = ACTIONS(7),
  },
  [3021] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5090),
    [anon_sym_macro_rules_BANG] = ACTIONS(5090),
    [anon_sym_RBRACE] = ACTIONS(5090),
    [anon_sym_POUND] = ACTIONS(5090),
    [anon_sym_const] = ACTIONS(5092),
    [anon_sym_default] = ACTIONS(5092),
    [anon_sym_enum] = ACTIONS(5092),
    [anon_sym_fn] = ACTIONS(5092),
    [anon_sym_impl] = ACTIONS(5092),
    [anon_sym_let] = ACTIONS(5092),
    [anon_sym_mod] = ACTIONS(5092),
    [anon_sym_pub] = ACTIONS(5092),
    [anon_sym_static] = ACTIONS(5092),
    [anon_sym_struct] = ACTIONS(5092),
    [anon_sym_trait] = ACTIONS(5092),
    [anon_sym_type] = ACTIONS(5092),
    [anon_sym_union] = ACTIONS(5092),
    [anon_sym_unsafe] = ACTIONS(5092),
    [anon_sym_use] = ACTIONS(5092),
    [anon_sym_extern] = ACTIONS(5092),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5092),
  },
  [3022] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3336),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3336),
    [sym_macro_invocation] = STATE(3336),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3336),
    [sym_unary_expression] = STATE(3336),
    [sym_try_expression] = STATE(3336),
    [sym_reference_expression] = STATE(3336),
    [sym_binary_expression] = STATE(3336),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3336),
    [sym_call_expression] = STATE(3336),
    [sym_array_expression] = STATE(3336),
    [sym_parenthesized_expression] = STATE(3336),
    [sym_tuple_expression] = STATE(3336),
    [sym_unit_expression] = STATE(3336),
    [sym_struct_expression] = STATE(3336),
    [sym_if_expression] = STATE(3336),
    [sym_if_let_expression] = STATE(3336),
    [sym_match_expression] = STATE(3336),
    [sym_while_expression] = STATE(3336),
    [sym_while_let_expression] = STATE(3336),
    [sym_loop_expression] = STATE(3336),
    [sym_for_expression] = STATE(3336),
    [sym_closure_expression] = STATE(3336),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3336),
    [sym_continue_expression] = STATE(3336),
    [sym_index_expression] = STATE(3336),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3336),
    [sym_block] = STATE(3336),
    [sym__literal] = STATE(3336),
    [sym_string_literal] = STATE(3336),
    [sym_boolean_literal] = STATE(3336),
    [sym_raw_string_literal] = ACTIONS(7250),
    [sym_float_literal] = ACTIONS(7250),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(7250),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7250),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [3023] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7252),
    [anon_sym_PLUS] = ACTIONS(3279),
    [anon_sym_EQ] = ACTIONS(7254),
    [sym_line_comment] = ACTIONS(7),
  },
  [3024] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5275),
    [anon_sym_macro_rules_BANG] = ACTIONS(5275),
    [anon_sym_RBRACE] = ACTIONS(5275),
    [anon_sym_POUND] = ACTIONS(5275),
    [anon_sym_const] = ACTIONS(5277),
    [anon_sym_default] = ACTIONS(5277),
    [anon_sym_enum] = ACTIONS(5277),
    [anon_sym_fn] = ACTIONS(5277),
    [anon_sym_impl] = ACTIONS(5277),
    [anon_sym_let] = ACTIONS(5277),
    [anon_sym_mod] = ACTIONS(5277),
    [anon_sym_pub] = ACTIONS(5277),
    [anon_sym_static] = ACTIONS(5277),
    [anon_sym_struct] = ACTIONS(5277),
    [anon_sym_trait] = ACTIONS(5277),
    [anon_sym_type] = ACTIONS(5277),
    [anon_sym_union] = ACTIONS(5277),
    [anon_sym_unsafe] = ACTIONS(5277),
    [anon_sym_use] = ACTIONS(5277),
    [anon_sym_extern] = ACTIONS(5277),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5277),
  },
  [3025] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3339),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3339),
    [sym_macro_invocation] = STATE(3339),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3339),
    [sym_unary_expression] = STATE(3339),
    [sym_try_expression] = STATE(3339),
    [sym_reference_expression] = STATE(3339),
    [sym_binary_expression] = STATE(3339),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3339),
    [sym_call_expression] = STATE(3339),
    [sym_array_expression] = STATE(3339),
    [sym_parenthesized_expression] = STATE(3339),
    [sym_tuple_expression] = STATE(3339),
    [sym_unit_expression] = STATE(3339),
    [sym_struct_expression] = STATE(3339),
    [sym_if_expression] = STATE(3339),
    [sym_if_let_expression] = STATE(3339),
    [sym_match_expression] = STATE(3339),
    [sym_while_expression] = STATE(3339),
    [sym_while_let_expression] = STATE(3339),
    [sym_loop_expression] = STATE(3339),
    [sym_for_expression] = STATE(3339),
    [sym_closure_expression] = STATE(3339),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3339),
    [sym_continue_expression] = STATE(3339),
    [sym_index_expression] = STATE(3339),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3339),
    [sym_block] = STATE(3339),
    [sym__literal] = STATE(3339),
    [sym_string_literal] = STATE(3339),
    [sym_boolean_literal] = STATE(3339),
    [sym_raw_string_literal] = ACTIONS(7256),
    [sym_float_literal] = ACTIONS(7256),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(7256),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7256),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [3026] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5332),
    [anon_sym_macro_rules_BANG] = ACTIONS(5332),
    [anon_sym_RBRACE] = ACTIONS(5332),
    [anon_sym_POUND] = ACTIONS(5332),
    [anon_sym_const] = ACTIONS(5334),
    [anon_sym_default] = ACTIONS(5334),
    [anon_sym_enum] = ACTIONS(5334),
    [anon_sym_fn] = ACTIONS(5334),
    [anon_sym_impl] = ACTIONS(5334),
    [anon_sym_let] = ACTIONS(5334),
    [anon_sym_mod] = ACTIONS(5334),
    [anon_sym_pub] = ACTIONS(5334),
    [anon_sym_static] = ACTIONS(5334),
    [anon_sym_struct] = ACTIONS(5334),
    [anon_sym_trait] = ACTIONS(5334),
    [anon_sym_type] = ACTIONS(5334),
    [anon_sym_union] = ACTIONS(5334),
    [anon_sym_unsafe] = ACTIONS(5334),
    [anon_sym_use] = ACTIONS(5334),
    [anon_sym_extern] = ACTIONS(5334),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5334),
  },
  [3027] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7258),
    [sym_line_comment] = ACTIONS(7),
  },
  [3028] = {
    [sym_where_clause] = STATE(3341),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7258),
    [anon_sym_where] = ACTIONS(2138),
    [sym_line_comment] = ACTIONS(7),
  },
  [3029] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5350),
    [anon_sym_macro_rules_BANG] = ACTIONS(5350),
    [anon_sym_RBRACE] = ACTIONS(5350),
    [anon_sym_POUND] = ACTIONS(5350),
    [anon_sym_const] = ACTIONS(5352),
    [anon_sym_default] = ACTIONS(5352),
    [anon_sym_enum] = ACTIONS(5352),
    [anon_sym_fn] = ACTIONS(5352),
    [anon_sym_impl] = ACTIONS(5352),
    [anon_sym_let] = ACTIONS(5352),
    [anon_sym_mod] = ACTIONS(5352),
    [anon_sym_pub] = ACTIONS(5352),
    [anon_sym_static] = ACTIONS(5352),
    [anon_sym_struct] = ACTIONS(5352),
    [anon_sym_trait] = ACTIONS(5352),
    [anon_sym_type] = ACTIONS(5352),
    [anon_sym_union] = ACTIONS(5352),
    [anon_sym_unsafe] = ACTIONS(5352),
    [anon_sym_use] = ACTIONS(5352),
    [anon_sym_extern] = ACTIONS(5352),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5352),
  },
  [3030] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5360),
    [anon_sym_macro_rules_BANG] = ACTIONS(5360),
    [anon_sym_RBRACE] = ACTIONS(5360),
    [anon_sym_POUND] = ACTIONS(5360),
    [anon_sym_const] = ACTIONS(5362),
    [anon_sym_default] = ACTIONS(5362),
    [anon_sym_enum] = ACTIONS(5362),
    [anon_sym_fn] = ACTIONS(5362),
    [anon_sym_impl] = ACTIONS(5362),
    [anon_sym_let] = ACTIONS(5362),
    [anon_sym_mod] = ACTIONS(5362),
    [anon_sym_pub] = ACTIONS(5362),
    [anon_sym_static] = ACTIONS(5362),
    [anon_sym_struct] = ACTIONS(5362),
    [anon_sym_trait] = ACTIONS(5362),
    [anon_sym_type] = ACTIONS(5362),
    [anon_sym_union] = ACTIONS(5362),
    [anon_sym_unsafe] = ACTIONS(5362),
    [anon_sym_use] = ACTIONS(5362),
    [anon_sym_extern] = ACTIONS(5362),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5362),
  },
  [3031] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7260),
    [anon_sym_PLUS] = ACTIONS(3423),
    [sym_line_comment] = ACTIONS(7),
  },
  [3032] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5366),
    [anon_sym_macro_rules_BANG] = ACTIONS(5366),
    [anon_sym_RBRACE] = ACTIONS(5366),
    [anon_sym_POUND] = ACTIONS(5366),
    [anon_sym_const] = ACTIONS(5368),
    [anon_sym_default] = ACTIONS(5368),
    [anon_sym_enum] = ACTIONS(5368),
    [anon_sym_fn] = ACTIONS(5368),
    [anon_sym_impl] = ACTIONS(5368),
    [anon_sym_let] = ACTIONS(5368),
    [anon_sym_mod] = ACTIONS(5368),
    [anon_sym_pub] = ACTIONS(5368),
    [anon_sym_static] = ACTIONS(5368),
    [anon_sym_struct] = ACTIONS(5368),
    [anon_sym_trait] = ACTIONS(5368),
    [anon_sym_type] = ACTIONS(5368),
    [anon_sym_union] = ACTIONS(5368),
    [anon_sym_unsafe] = ACTIONS(5368),
    [anon_sym_use] = ACTIONS(5368),
    [anon_sym_extern] = ACTIONS(5368),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5368),
  },
  [3033] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7262),
    [sym_line_comment] = ACTIONS(7),
  },
  [3034] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5372),
    [anon_sym_macro_rules_BANG] = ACTIONS(5372),
    [anon_sym_RBRACE] = ACTIONS(5372),
    [anon_sym_POUND] = ACTIONS(5372),
    [anon_sym_const] = ACTIONS(5374),
    [anon_sym_default] = ACTIONS(5374),
    [anon_sym_enum] = ACTIONS(5374),
    [anon_sym_fn] = ACTIONS(5374),
    [anon_sym_impl] = ACTIONS(5374),
    [anon_sym_let] = ACTIONS(5374),
    [anon_sym_mod] = ACTIONS(5374),
    [anon_sym_pub] = ACTIONS(5374),
    [anon_sym_static] = ACTIONS(5374),
    [anon_sym_struct] = ACTIONS(5374),
    [anon_sym_trait] = ACTIONS(5374),
    [anon_sym_type] = ACTIONS(5374),
    [anon_sym_union] = ACTIONS(5374),
    [anon_sym_unsafe] = ACTIONS(5374),
    [anon_sym_use] = ACTIONS(5374),
    [anon_sym_extern] = ACTIONS(5374),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5374),
  },
  [3035] = {
    [sym_declaration_list] = STATE(3344),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [sym_line_comment] = ACTIONS(7),
  },
  [3036] = {
    [sym_declaration_list] = STATE(3344),
    [sym_where_clause] = STATE(3345),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [3037] = {
    [sym_declaration_list] = STATE(3344),
    [sym_where_clause] = STATE(3345),
    [sym_impl_for_clause] = STATE(3346),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [anon_sym_COLON_COLON] = ACTIONS(1798),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [3038] = {
    [sym_declaration_list] = STATE(3332),
    [sym_where_clause] = STATE(3333),
    [sym_impl_for_clause] = STATE(3347),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [anon_sym_COLON_COLON] = ACTIONS(1816),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [3039] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7264),
    [sym_line_comment] = ACTIONS(7),
  },
  [3040] = {
    [sym_where_clause] = STATE(3328),
    [sym_block] = STATE(3327),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_DASH_GT] = ACTIONS(7266),
    [anon_sym_where] = ACTIONS(1962),
    [sym_line_comment] = ACTIONS(7),
  },
  [3041] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(3111),
    [anon_sym_EQ] = ACTIONS(7268),
    [sym_line_comment] = ACTIONS(7),
  },
  [3042] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5685),
    [anon_sym_macro_rules_BANG] = ACTIONS(5685),
    [anon_sym_RBRACE] = ACTIONS(5685),
    [anon_sym_POUND] = ACTIONS(5685),
    [anon_sym_const] = ACTIONS(5687),
    [anon_sym_default] = ACTIONS(5687),
    [anon_sym_enum] = ACTIONS(5687),
    [anon_sym_fn] = ACTIONS(5687),
    [anon_sym_impl] = ACTIONS(5687),
    [anon_sym_let] = ACTIONS(5687),
    [anon_sym_mod] = ACTIONS(5687),
    [anon_sym_pub] = ACTIONS(5687),
    [anon_sym_static] = ACTIONS(5687),
    [anon_sym_struct] = ACTIONS(5687),
    [anon_sym_trait] = ACTIONS(5687),
    [anon_sym_type] = ACTIONS(5687),
    [anon_sym_union] = ACTIONS(5687),
    [anon_sym_unsafe] = ACTIONS(5687),
    [anon_sym_use] = ACTIONS(5687),
    [anon_sym_extern] = ACTIONS(5687),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5687),
  },
  [3043] = {
    [sym_enum_variant_list] = STATE(3351),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(4209),
    [sym_line_comment] = ACTIONS(7),
  },
  [3044] = {
    [sym_function_modifiers] = STATE(1025),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3352),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1027),
    [sym_array_type] = STATE(3352),
    [sym_function_type] = STATE(3352),
    [sym_tuple_type] = STATE(3352),
    [sym_unit_type] = STATE(3352),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(3352),
    [sym_reference_type] = STATE(3352),
    [sym_pointer_type] = STATE(3352),
    [sym_empty_type] = STATE(3352),
    [sym_dynamic_type] = STATE(3352),
    [sym_macro_invocation] = STATE(3352),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1028),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2060),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2062),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2064),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2066),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3045] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5689),
    [anon_sym_macro_rules_BANG] = ACTIONS(5689),
    [anon_sym_RBRACE] = ACTIONS(5689),
    [anon_sym_POUND] = ACTIONS(5689),
    [anon_sym_const] = ACTIONS(5691),
    [anon_sym_default] = ACTIONS(5691),
    [anon_sym_enum] = ACTIONS(5691),
    [anon_sym_fn] = ACTIONS(5691),
    [anon_sym_impl] = ACTIONS(5691),
    [anon_sym_let] = ACTIONS(5691),
    [anon_sym_mod] = ACTIONS(5691),
    [anon_sym_pub] = ACTIONS(5691),
    [anon_sym_static] = ACTIONS(5691),
    [anon_sym_struct] = ACTIONS(5691),
    [anon_sym_trait] = ACTIONS(5691),
    [anon_sym_type] = ACTIONS(5691),
    [anon_sym_union] = ACTIONS(5691),
    [anon_sym_unsafe] = ACTIONS(5691),
    [anon_sym_use] = ACTIONS(5691),
    [anon_sym_extern] = ACTIONS(5691),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5691),
  },
  [3046] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7270),
    [sym_line_comment] = ACTIONS(7),
  },
  [3047] = {
    [sym_where_clause] = STATE(3354),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7270),
    [anon_sym_where] = ACTIONS(2138),
    [sym_line_comment] = ACTIONS(7),
  },
  [3048] = {
    [sym_field_declaration_list] = STATE(3353),
    [sym_ordered_field_declaration_list] = STATE(3355),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7270),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(3125),
    [sym_line_comment] = ACTIONS(7),
  },
  [3049] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5695),
    [anon_sym_macro_rules_BANG] = ACTIONS(5695),
    [anon_sym_RBRACE] = ACTIONS(5695),
    [anon_sym_POUND] = ACTIONS(5695),
    [anon_sym_const] = ACTIONS(5697),
    [anon_sym_default] = ACTIONS(5697),
    [anon_sym_enum] = ACTIONS(5697),
    [anon_sym_fn] = ACTIONS(5697),
    [anon_sym_impl] = ACTIONS(5697),
    [anon_sym_let] = ACTIONS(5697),
    [anon_sym_mod] = ACTIONS(5697),
    [anon_sym_pub] = ACTIONS(5697),
    [anon_sym_static] = ACTIONS(5697),
    [anon_sym_struct] = ACTIONS(5697),
    [anon_sym_trait] = ACTIONS(5697),
    [anon_sym_type] = ACTIONS(5697),
    [anon_sym_union] = ACTIONS(5697),
    [anon_sym_unsafe] = ACTIONS(5697),
    [anon_sym_use] = ACTIONS(5697),
    [anon_sym_extern] = ACTIONS(5697),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5697),
  },
  [3050] = {
    [sym_declaration_list] = STATE(3356),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [sym_line_comment] = ACTIONS(7),
  },
  [3051] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7272),
    [anon_sym_PLUS] = ACTIONS(3423),
    [sym_line_comment] = ACTIONS(7),
  },
  [3052] = {
    [sym_function_modifiers] = STATE(1097),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3358),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1102),
    [sym_array_type] = STATE(3358),
    [sym_function_type] = STATE(3358),
    [sym_tuple_type] = STATE(3358),
    [sym_unit_type] = STATE(3358),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(3358),
    [sym_reference_type] = STATE(3358),
    [sym_pointer_type] = STATE(3358),
    [sym_empty_type] = STATE(3358),
    [sym_dynamic_type] = STATE(3358),
    [sym_macro_invocation] = STATE(3358),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(2156),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(2162),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2166),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3053] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5701),
    [anon_sym_macro_rules_BANG] = ACTIONS(5701),
    [anon_sym_RBRACE] = ACTIONS(5701),
    [anon_sym_POUND] = ACTIONS(5701),
    [anon_sym_const] = ACTIONS(5703),
    [anon_sym_default] = ACTIONS(5703),
    [anon_sym_enum] = ACTIONS(5703),
    [anon_sym_fn] = ACTIONS(5703),
    [anon_sym_impl] = ACTIONS(5703),
    [anon_sym_let] = ACTIONS(5703),
    [anon_sym_mod] = ACTIONS(5703),
    [anon_sym_pub] = ACTIONS(5703),
    [anon_sym_static] = ACTIONS(5703),
    [anon_sym_struct] = ACTIONS(5703),
    [anon_sym_trait] = ACTIONS(5703),
    [anon_sym_type] = ACTIONS(5703),
    [anon_sym_union] = ACTIONS(5703),
    [anon_sym_unsafe] = ACTIONS(5703),
    [anon_sym_use] = ACTIONS(5703),
    [anon_sym_extern] = ACTIONS(5703),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5703),
  },
  [3054] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7274),
    [sym_line_comment] = ACTIONS(7),
  },
  [3055] = {
    [sym_field_declaration_list] = STATE(3359),
    [sym_ordered_field_declaration_list] = STATE(3360),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7274),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(3125),
    [sym_line_comment] = ACTIONS(7),
  },
  [3056] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5707),
    [anon_sym_macro_rules_BANG] = ACTIONS(5707),
    [anon_sym_RBRACE] = ACTIONS(5707),
    [anon_sym_POUND] = ACTIONS(5707),
    [anon_sym_const] = ACTIONS(5709),
    [anon_sym_default] = ACTIONS(5709),
    [anon_sym_enum] = ACTIONS(5709),
    [anon_sym_fn] = ACTIONS(5709),
    [anon_sym_impl] = ACTIONS(5709),
    [anon_sym_let] = ACTIONS(5709),
    [anon_sym_mod] = ACTIONS(5709),
    [anon_sym_pub] = ACTIONS(5709),
    [anon_sym_static] = ACTIONS(5709),
    [anon_sym_struct] = ACTIONS(5709),
    [anon_sym_trait] = ACTIONS(5709),
    [anon_sym_type] = ACTIONS(5709),
    [anon_sym_union] = ACTIONS(5709),
    [anon_sym_unsafe] = ACTIONS(5709),
    [anon_sym_use] = ACTIONS(5709),
    [anon_sym_extern] = ACTIONS(5709),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5709),
  },
  [3057] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7276),
  },
  [3058] = {
    [sym_parameters] = STATE(3362),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [3059] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7278),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(467),
    [anon_sym_BANG_EQ] = ACTIONS(469),
    [anon_sym_STAR_EQ] = ACTIONS(467),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(467),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_AMP_EQ] = ACTIONS(467),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(467),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_CARET_EQ] = ACTIONS(467),
    [anon_sym_PLUS_EQ] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT_LT_EQ] = ACTIONS(467),
    [anon_sym_LT_EQ] = ACTIONS(469),
    [anon_sym_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_EQ] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_PIPE_EQ] = ACTIONS(467),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(489),
    [anon_sym_as] = ACTIONS(491),
    [sym_line_comment] = ACTIONS(7),
  },
  [3060] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3364),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3364),
    [sym_macro_invocation] = STATE(3364),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3364),
    [sym_unary_expression] = STATE(3364),
    [sym_try_expression] = STATE(3364),
    [sym_reference_expression] = STATE(3364),
    [sym_binary_expression] = STATE(3364),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3364),
    [sym_call_expression] = STATE(3364),
    [sym_array_expression] = STATE(3364),
    [sym_parenthesized_expression] = STATE(3364),
    [sym_tuple_expression] = STATE(3364),
    [sym_unit_expression] = STATE(3364),
    [sym_struct_expression] = STATE(3364),
    [sym_if_expression] = STATE(3364),
    [sym_if_let_expression] = STATE(3364),
    [sym_match_expression] = STATE(3364),
    [sym_while_expression] = STATE(3364),
    [sym_while_let_expression] = STATE(3364),
    [sym_loop_expression] = STATE(3364),
    [sym_for_expression] = STATE(3364),
    [sym_closure_expression] = STATE(3364),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3364),
    [sym_continue_expression] = STATE(3364),
    [sym_index_expression] = STATE(3364),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3364),
    [sym_block] = STATE(3364),
    [sym__literal] = STATE(3364),
    [sym_string_literal] = STATE(3364),
    [sym_boolean_literal] = STATE(3364),
    [sym_raw_string_literal] = ACTIONS(7280),
    [sym_float_literal] = ACTIONS(7280),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(7280),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7280),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [3061] = {
    [sym_raw_string_literal] = ACTIONS(7282),
    [sym_float_literal] = ACTIONS(7282),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(7282),
    [anon_sym_SEMI] = ACTIONS(7282),
    [anon_sym_macro_rules_BANG] = ACTIONS(7282),
    [anon_sym_LPAREN] = ACTIONS(7282),
    [anon_sym_LBRACE] = ACTIONS(7282),
    [anon_sym_RBRACE] = ACTIONS(7282),
    [anon_sym_LBRACK] = ACTIONS(7282),
    [anon_sym_STAR] = ACTIONS(7282),
    [anon_sym_u8] = ACTIONS(7284),
    [anon_sym_i8] = ACTIONS(7284),
    [anon_sym_u16] = ACTIONS(7284),
    [anon_sym_i16] = ACTIONS(7284),
    [anon_sym_u32] = ACTIONS(7284),
    [anon_sym_i32] = ACTIONS(7284),
    [anon_sym_u64] = ACTIONS(7284),
    [anon_sym_i64] = ACTIONS(7284),
    [anon_sym_u128] = ACTIONS(7284),
    [anon_sym_i128] = ACTIONS(7284),
    [anon_sym_isize] = ACTIONS(7284),
    [anon_sym_usize] = ACTIONS(7284),
    [anon_sym_f32] = ACTIONS(7284),
    [anon_sym_f64] = ACTIONS(7284),
    [anon_sym_bool] = ACTIONS(7284),
    [anon_sym_str] = ACTIONS(7284),
    [anon_sym_char] = ACTIONS(7284),
    [anon_sym_AMP] = ACTIONS(7282),
    [anon_sym_DASH] = ACTIONS(7282),
    [anon_sym_COLON_COLON] = ACTIONS(7282),
    [anon_sym_BANG] = ACTIONS(7282),
    [anon_sym_POUND] = ACTIONS(7282),
    [anon_sym_LT] = ACTIONS(7282),
    [anon_sym_PIPE] = ACTIONS(7282),
    [anon_sym_SQUOTE] = ACTIONS(7284),
    [anon_sym_DOT_DOT] = ACTIONS(7282),
    [anon_sym_break] = ACTIONS(7284),
    [anon_sym_const] = ACTIONS(7284),
    [anon_sym_continue] = ACTIONS(7284),
    [anon_sym_default] = ACTIONS(7284),
    [anon_sym_enum] = ACTIONS(7284),
    [anon_sym_fn] = ACTIONS(7284),
    [anon_sym_for] = ACTIONS(7284),
    [anon_sym_if] = ACTIONS(7284),
    [anon_sym_impl] = ACTIONS(7284),
    [anon_sym_let] = ACTIONS(7284),
    [anon_sym_loop] = ACTIONS(7284),
    [anon_sym_match] = ACTIONS(7284),
    [anon_sym_mod] = ACTIONS(7284),
    [anon_sym_pub] = ACTIONS(7284),
    [anon_sym_return] = ACTIONS(7284),
    [anon_sym_static] = ACTIONS(7284),
    [anon_sym_struct] = ACTIONS(7284),
    [anon_sym_trait] = ACTIONS(7284),
    [anon_sym_type] = ACTIONS(7284),
    [anon_sym_union] = ACTIONS(7284),
    [anon_sym_unsafe] = ACTIONS(7284),
    [anon_sym_use] = ACTIONS(7284),
    [anon_sym_while] = ACTIONS(7284),
    [anon_sym_extern] = ACTIONS(7284),
    [anon_sym_move] = ACTIONS(7284),
    [sym_integer_literal] = ACTIONS(7282),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7282),
    [sym_char_literal] = ACTIONS(7282),
    [anon_sym_true] = ACTIONS(7284),
    [anon_sym_false] = ACTIONS(7284),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7284),
    [sym_self] = ACTIONS(7284),
    [sym_super] = ACTIONS(7284),
    [sym_crate] = ACTIONS(7284),
    [sym_metavariable] = ACTIONS(7282),
  },
  [3062] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7286),
    [sym_line_comment] = ACTIONS(7),
  },
  [3063] = {
    [sym_raw_string_literal] = ACTIONS(7288),
    [sym_float_literal] = ACTIONS(7288),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(7288),
    [anon_sym_SEMI] = ACTIONS(7288),
    [anon_sym_macro_rules_BANG] = ACTIONS(7288),
    [anon_sym_LPAREN] = ACTIONS(7288),
    [anon_sym_LBRACE] = ACTIONS(7288),
    [anon_sym_RBRACE] = ACTIONS(7288),
    [anon_sym_LBRACK] = ACTIONS(7288),
    [anon_sym_STAR] = ACTIONS(7288),
    [anon_sym_u8] = ACTIONS(7290),
    [anon_sym_i8] = ACTIONS(7290),
    [anon_sym_u16] = ACTIONS(7290),
    [anon_sym_i16] = ACTIONS(7290),
    [anon_sym_u32] = ACTIONS(7290),
    [anon_sym_i32] = ACTIONS(7290),
    [anon_sym_u64] = ACTIONS(7290),
    [anon_sym_i64] = ACTIONS(7290),
    [anon_sym_u128] = ACTIONS(7290),
    [anon_sym_i128] = ACTIONS(7290),
    [anon_sym_isize] = ACTIONS(7290),
    [anon_sym_usize] = ACTIONS(7290),
    [anon_sym_f32] = ACTIONS(7290),
    [anon_sym_f64] = ACTIONS(7290),
    [anon_sym_bool] = ACTIONS(7290),
    [anon_sym_str] = ACTIONS(7290),
    [anon_sym_char] = ACTIONS(7290),
    [anon_sym_AMP] = ACTIONS(7288),
    [anon_sym_DASH] = ACTIONS(7288),
    [anon_sym_COLON_COLON] = ACTIONS(7288),
    [anon_sym_BANG] = ACTIONS(7288),
    [anon_sym_POUND] = ACTIONS(7288),
    [anon_sym_LT] = ACTIONS(7288),
    [anon_sym_PIPE] = ACTIONS(7288),
    [anon_sym_SQUOTE] = ACTIONS(7290),
    [anon_sym_DOT_DOT] = ACTIONS(7288),
    [anon_sym_break] = ACTIONS(7290),
    [anon_sym_const] = ACTIONS(7290),
    [anon_sym_continue] = ACTIONS(7290),
    [anon_sym_default] = ACTIONS(7290),
    [anon_sym_enum] = ACTIONS(7290),
    [anon_sym_fn] = ACTIONS(7290),
    [anon_sym_for] = ACTIONS(7290),
    [anon_sym_if] = ACTIONS(7290),
    [anon_sym_impl] = ACTIONS(7290),
    [anon_sym_let] = ACTIONS(7290),
    [anon_sym_loop] = ACTIONS(7290),
    [anon_sym_match] = ACTIONS(7290),
    [anon_sym_mod] = ACTIONS(7290),
    [anon_sym_pub] = ACTIONS(7290),
    [anon_sym_return] = ACTIONS(7290),
    [anon_sym_static] = ACTIONS(7290),
    [anon_sym_struct] = ACTIONS(7290),
    [anon_sym_trait] = ACTIONS(7290),
    [anon_sym_type] = ACTIONS(7290),
    [anon_sym_union] = ACTIONS(7290),
    [anon_sym_unsafe] = ACTIONS(7290),
    [anon_sym_use] = ACTIONS(7290),
    [anon_sym_while] = ACTIONS(7290),
    [anon_sym_extern] = ACTIONS(7290),
    [anon_sym_move] = ACTIONS(7290),
    [sym_integer_literal] = ACTIONS(7288),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7288),
    [sym_char_literal] = ACTIONS(7288),
    [anon_sym_true] = ACTIONS(7290),
    [anon_sym_false] = ACTIONS(7290),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7290),
    [sym_self] = ACTIONS(7290),
    [sym_super] = ACTIONS(7290),
    [sym_crate] = ACTIONS(7290),
    [sym_metavariable] = ACTIONS(7288),
  },
  [3064] = {
    [sym_raw_string_literal] = ACTIONS(7292),
    [sym_float_literal] = ACTIONS(7292),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(7292),
    [anon_sym_SEMI] = ACTIONS(7292),
    [anon_sym_macro_rules_BANG] = ACTIONS(7292),
    [anon_sym_LPAREN] = ACTIONS(7292),
    [anon_sym_LBRACE] = ACTIONS(7292),
    [anon_sym_RBRACE] = ACTIONS(7292),
    [anon_sym_LBRACK] = ACTIONS(7292),
    [anon_sym_STAR] = ACTIONS(7292),
    [anon_sym_u8] = ACTIONS(7294),
    [anon_sym_i8] = ACTIONS(7294),
    [anon_sym_u16] = ACTIONS(7294),
    [anon_sym_i16] = ACTIONS(7294),
    [anon_sym_u32] = ACTIONS(7294),
    [anon_sym_i32] = ACTIONS(7294),
    [anon_sym_u64] = ACTIONS(7294),
    [anon_sym_i64] = ACTIONS(7294),
    [anon_sym_u128] = ACTIONS(7294),
    [anon_sym_i128] = ACTIONS(7294),
    [anon_sym_isize] = ACTIONS(7294),
    [anon_sym_usize] = ACTIONS(7294),
    [anon_sym_f32] = ACTIONS(7294),
    [anon_sym_f64] = ACTIONS(7294),
    [anon_sym_bool] = ACTIONS(7294),
    [anon_sym_str] = ACTIONS(7294),
    [anon_sym_char] = ACTIONS(7294),
    [anon_sym_AMP] = ACTIONS(7292),
    [anon_sym_DASH] = ACTIONS(7292),
    [anon_sym_COLON_COLON] = ACTIONS(7292),
    [anon_sym_BANG] = ACTIONS(7292),
    [anon_sym_POUND] = ACTIONS(7292),
    [anon_sym_LT] = ACTIONS(7292),
    [anon_sym_PIPE] = ACTIONS(7292),
    [anon_sym_SQUOTE] = ACTIONS(7294),
    [anon_sym_DOT_DOT] = ACTIONS(7292),
    [anon_sym_break] = ACTIONS(7294),
    [anon_sym_const] = ACTIONS(7294),
    [anon_sym_continue] = ACTIONS(7294),
    [anon_sym_default] = ACTIONS(7294),
    [anon_sym_enum] = ACTIONS(7294),
    [anon_sym_fn] = ACTIONS(7294),
    [anon_sym_for] = ACTIONS(7294),
    [anon_sym_if] = ACTIONS(7294),
    [anon_sym_impl] = ACTIONS(7294),
    [anon_sym_let] = ACTIONS(7294),
    [anon_sym_loop] = ACTIONS(7294),
    [anon_sym_match] = ACTIONS(7294),
    [anon_sym_mod] = ACTIONS(7294),
    [anon_sym_pub] = ACTIONS(7294),
    [anon_sym_return] = ACTIONS(7294),
    [anon_sym_static] = ACTIONS(7294),
    [anon_sym_struct] = ACTIONS(7294),
    [anon_sym_trait] = ACTIONS(7294),
    [anon_sym_type] = ACTIONS(7294),
    [anon_sym_union] = ACTIONS(7294),
    [anon_sym_unsafe] = ACTIONS(7294),
    [anon_sym_use] = ACTIONS(7294),
    [anon_sym_while] = ACTIONS(7294),
    [anon_sym_extern] = ACTIONS(7294),
    [anon_sym_move] = ACTIONS(7294),
    [sym_integer_literal] = ACTIONS(7292),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7292),
    [sym_char_literal] = ACTIONS(7292),
    [anon_sym_true] = ACTIONS(7294),
    [anon_sym_false] = ACTIONS(7294),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7294),
    [sym_self] = ACTIONS(7294),
    [sym_super] = ACTIONS(7294),
    [sym_crate] = ACTIONS(7294),
    [sym_metavariable] = ACTIONS(7292),
  },
  [3065] = {
    [sym_raw_string_literal] = ACTIONS(7296),
    [sym_float_literal] = ACTIONS(7296),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(7296),
    [anon_sym_SEMI] = ACTIONS(7296),
    [anon_sym_macro_rules_BANG] = ACTIONS(7296),
    [anon_sym_LPAREN] = ACTIONS(7296),
    [anon_sym_LBRACE] = ACTIONS(7296),
    [anon_sym_RBRACE] = ACTIONS(7296),
    [anon_sym_LBRACK] = ACTIONS(7296),
    [anon_sym_STAR] = ACTIONS(7296),
    [anon_sym_u8] = ACTIONS(7298),
    [anon_sym_i8] = ACTIONS(7298),
    [anon_sym_u16] = ACTIONS(7298),
    [anon_sym_i16] = ACTIONS(7298),
    [anon_sym_u32] = ACTIONS(7298),
    [anon_sym_i32] = ACTIONS(7298),
    [anon_sym_u64] = ACTIONS(7298),
    [anon_sym_i64] = ACTIONS(7298),
    [anon_sym_u128] = ACTIONS(7298),
    [anon_sym_i128] = ACTIONS(7298),
    [anon_sym_isize] = ACTIONS(7298),
    [anon_sym_usize] = ACTIONS(7298),
    [anon_sym_f32] = ACTIONS(7298),
    [anon_sym_f64] = ACTIONS(7298),
    [anon_sym_bool] = ACTIONS(7298),
    [anon_sym_str] = ACTIONS(7298),
    [anon_sym_char] = ACTIONS(7298),
    [anon_sym_AMP] = ACTIONS(7296),
    [anon_sym_DASH] = ACTIONS(7296),
    [anon_sym_COLON_COLON] = ACTIONS(7296),
    [anon_sym_BANG] = ACTIONS(7296),
    [anon_sym_POUND] = ACTIONS(7296),
    [anon_sym_LT] = ACTIONS(7296),
    [anon_sym_PIPE] = ACTIONS(7296),
    [anon_sym_SQUOTE] = ACTIONS(7298),
    [anon_sym_DOT_DOT] = ACTIONS(7296),
    [anon_sym_break] = ACTIONS(7298),
    [anon_sym_const] = ACTIONS(7298),
    [anon_sym_continue] = ACTIONS(7298),
    [anon_sym_default] = ACTIONS(7298),
    [anon_sym_enum] = ACTIONS(7298),
    [anon_sym_fn] = ACTIONS(7298),
    [anon_sym_for] = ACTIONS(7298),
    [anon_sym_if] = ACTIONS(7298),
    [anon_sym_impl] = ACTIONS(7298),
    [anon_sym_let] = ACTIONS(7298),
    [anon_sym_loop] = ACTIONS(7298),
    [anon_sym_match] = ACTIONS(7298),
    [anon_sym_mod] = ACTIONS(7298),
    [anon_sym_pub] = ACTIONS(7298),
    [anon_sym_return] = ACTIONS(7298),
    [anon_sym_static] = ACTIONS(7298),
    [anon_sym_struct] = ACTIONS(7298),
    [anon_sym_trait] = ACTIONS(7298),
    [anon_sym_type] = ACTIONS(7298),
    [anon_sym_union] = ACTIONS(7298),
    [anon_sym_unsafe] = ACTIONS(7298),
    [anon_sym_use] = ACTIONS(7298),
    [anon_sym_while] = ACTIONS(7298),
    [anon_sym_extern] = ACTIONS(7298),
    [anon_sym_move] = ACTIONS(7298),
    [sym_integer_literal] = ACTIONS(7296),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7296),
    [sym_char_literal] = ACTIONS(7296),
    [anon_sym_true] = ACTIONS(7298),
    [anon_sym_false] = ACTIONS(7298),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7298),
    [sym_self] = ACTIONS(7298),
    [sym_super] = ACTIONS(7298),
    [sym_crate] = ACTIONS(7298),
    [sym_metavariable] = ACTIONS(7296),
  },
  [3066] = {
    [sym_function_modifiers] = STATE(1624),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3366),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1626),
    [sym_array_type] = STATE(3366),
    [sym_function_type] = STATE(3366),
    [sym_tuple_type] = STATE(3366),
    [sym_unit_type] = STATE(3366),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(3366),
    [sym_reference_type] = STATE(3366),
    [sym_pointer_type] = STATE(3366),
    [sym_empty_type] = STATE(3366),
    [sym_abstract_type] = STATE(3367),
    [sym_dynamic_type] = STATE(3366),
    [sym_macro_invocation] = STATE(3366),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1628),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3169),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3171),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3173),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3175),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3067] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(3368),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [3068] = {
    [sym_function_modifiers] = STATE(1993),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2611),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(1994),
    [sym_array_type] = STATE(2611),
    [sym_function_type] = STATE(2611),
    [sym_tuple_type] = STATE(2611),
    [sym_unit_type] = STATE(2611),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2611),
    [sym_reference_type] = STATE(2611),
    [sym_pointer_type] = STATE(2611),
    [sym_empty_type] = STATE(2611),
    [sym_dynamic_type] = STATE(2611),
    [sym_macro_invocation] = STATE(2611),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(1995),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(4413),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(4415),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4417),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4419),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [3069] = {
    [sym_function_modifiers] = STATE(1993),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2616),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(1994),
    [sym_array_type] = STATE(2616),
    [sym_function_type] = STATE(2616),
    [sym_tuple_type] = STATE(2616),
    [sym_unit_type] = STATE(2616),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2616),
    [sym_reference_type] = STATE(2616),
    [sym_pointer_type] = STATE(2616),
    [sym_empty_type] = STATE(2616),
    [sym_abstract_type] = STATE(2617),
    [sym_dynamic_type] = STATE(2616),
    [sym_macro_invocation] = STATE(2616),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(1995),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(4413),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(4415),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4417),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4419),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [3070] = {
    [sym_function_modifiers] = STATE(1993),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2618),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(1994),
    [sym_array_type] = STATE(2618),
    [sym_function_type] = STATE(2618),
    [sym_tuple_type] = STATE(2618),
    [sym_unit_type] = STATE(2618),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2618),
    [sym_reference_type] = STATE(2618),
    [sym_pointer_type] = STATE(2618),
    [sym_empty_type] = STATE(2618),
    [sym_abstract_type] = STATE(2619),
    [sym_dynamic_type] = STATE(2618),
    [sym_macro_invocation] = STATE(2618),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(1995),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(4413),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(4415),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4417),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4419),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [3071] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2988),
    [anon_sym_RBRACK] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(5758),
    [anon_sym_STAR] = ACTIONS(5758),
    [anon_sym_AMP] = ACTIONS(5758),
    [anon_sym_DASH] = ACTIONS(5758),
    [anon_sym_DOT] = ACTIONS(5758),
    [anon_sym_DASH_EQ] = ACTIONS(2988),
    [anon_sym_DASH_GT] = ACTIONS(7300),
    [anon_sym_BANG_EQ] = ACTIONS(2988),
    [anon_sym_STAR_EQ] = ACTIONS(2988),
    [anon_sym_SLASH] = ACTIONS(5758),
    [anon_sym_SLASH_EQ] = ACTIONS(2988),
    [anon_sym_AMP_AMP] = ACTIONS(2988),
    [anon_sym_AMP_EQ] = ACTIONS(2988),
    [anon_sym_PERCENT] = ACTIONS(5758),
    [anon_sym_PERCENT_EQ] = ACTIONS(2988),
    [anon_sym_CARET] = ACTIONS(5758),
    [anon_sym_CARET_EQ] = ACTIONS(2988),
    [anon_sym_PLUS_EQ] = ACTIONS(2988),
    [anon_sym_LT] = ACTIONS(5758),
    [anon_sym_LT_LT] = ACTIONS(5758),
    [anon_sym_LT_LT_EQ] = ACTIONS(2988),
    [anon_sym_LT_EQ] = ACTIONS(2988),
    [anon_sym_EQ] = ACTIONS(5758),
    [anon_sym_EQ_EQ] = ACTIONS(2988),
    [anon_sym_GT] = ACTIONS(5758),
    [anon_sym_GT_EQ] = ACTIONS(2988),
    [anon_sym_GT_GT] = ACTIONS(5758),
    [anon_sym_GT_GT_EQ] = ACTIONS(2988),
    [anon_sym_PIPE] = ACTIONS(5758),
    [anon_sym_PIPE_EQ] = ACTIONS(2988),
    [anon_sym_PIPE_PIPE] = ACTIONS(2988),
    [anon_sym_QMARK] = ACTIONS(2988),
    [anon_sym_DOT_DOT] = ACTIONS(5758),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2988),
    [anon_sym_as] = ACTIONS(2988),
    [sym_line_comment] = ACTIONS(7),
  },
  [3072] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2992),
    [anon_sym_LBRACK] = ACTIONS(2992),
    [anon_sym_RBRACK] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(5762),
    [anon_sym_STAR] = ACTIONS(5762),
    [anon_sym_AMP] = ACTIONS(5762),
    [anon_sym_DASH] = ACTIONS(5762),
    [anon_sym_DOT] = ACTIONS(5762),
    [anon_sym_DASH_EQ] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(7302),
    [anon_sym_BANG_EQ] = ACTIONS(2992),
    [anon_sym_STAR_EQ] = ACTIONS(2992),
    [anon_sym_SLASH] = ACTIONS(5762),
    [anon_sym_SLASH_EQ] = ACTIONS(2992),
    [anon_sym_AMP_AMP] = ACTIONS(2992),
    [anon_sym_AMP_EQ] = ACTIONS(2992),
    [anon_sym_PERCENT] = ACTIONS(5762),
    [anon_sym_PERCENT_EQ] = ACTIONS(2992),
    [anon_sym_CARET] = ACTIONS(5762),
    [anon_sym_CARET_EQ] = ACTIONS(2992),
    [anon_sym_PLUS_EQ] = ACTIONS(2992),
    [anon_sym_LT] = ACTIONS(5762),
    [anon_sym_LT_LT] = ACTIONS(5762),
    [anon_sym_LT_LT_EQ] = ACTIONS(2992),
    [anon_sym_LT_EQ] = ACTIONS(2992),
    [anon_sym_EQ] = ACTIONS(5762),
    [anon_sym_EQ_EQ] = ACTIONS(2992),
    [anon_sym_GT] = ACTIONS(5762),
    [anon_sym_GT_EQ] = ACTIONS(2992),
    [anon_sym_GT_GT] = ACTIONS(5762),
    [anon_sym_GT_GT_EQ] = ACTIONS(2992),
    [anon_sym_PIPE] = ACTIONS(5762),
    [anon_sym_PIPE_EQ] = ACTIONS(2992),
    [anon_sym_PIPE_PIPE] = ACTIONS(2992),
    [anon_sym_QMARK] = ACTIONS(2992),
    [anon_sym_DOT_DOT] = ACTIONS(5762),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2992),
    [anon_sym_as] = ACTIONS(2992),
    [sym_line_comment] = ACTIONS(7),
  },
  [3073] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5958),
    [anon_sym_LPAREN] = ACTIONS(5958),
    [anon_sym_RPAREN] = ACTIONS(5958),
    [anon_sym_LBRACE] = ACTIONS(5958),
    [anon_sym_RBRACE] = ACTIONS(5958),
    [anon_sym_LBRACK] = ACTIONS(5958),
    [anon_sym_RBRACK] = ACTIONS(5958),
    [anon_sym_PLUS] = ACTIONS(7304),
    [anon_sym_STAR] = ACTIONS(7304),
    [anon_sym_COMMA] = ACTIONS(5958),
    [anon_sym_AMP] = ACTIONS(7304),
    [anon_sym_DASH] = ACTIONS(7304),
    [anon_sym_DOT] = ACTIONS(7304),
    [anon_sym_DASH_EQ] = ACTIONS(5958),
    [anon_sym_BANG_EQ] = ACTIONS(5958),
    [anon_sym_STAR_EQ] = ACTIONS(5958),
    [anon_sym_SLASH] = ACTIONS(7304),
    [anon_sym_SLASH_EQ] = ACTIONS(5958),
    [anon_sym_AMP_AMP] = ACTIONS(5958),
    [anon_sym_AMP_EQ] = ACTIONS(5958),
    [anon_sym_PERCENT] = ACTIONS(7304),
    [anon_sym_PERCENT_EQ] = ACTIONS(5958),
    [anon_sym_CARET] = ACTIONS(7304),
    [anon_sym_CARET_EQ] = ACTIONS(5958),
    [anon_sym_PLUS_EQ] = ACTIONS(5958),
    [anon_sym_LT] = ACTIONS(7304),
    [anon_sym_LT_LT] = ACTIONS(7304),
    [anon_sym_LT_LT_EQ] = ACTIONS(5958),
    [anon_sym_LT_EQ] = ACTIONS(5958),
    [anon_sym_EQ] = ACTIONS(7304),
    [anon_sym_EQ_EQ] = ACTIONS(5958),
    [anon_sym_GT] = ACTIONS(7304),
    [anon_sym_GT_EQ] = ACTIONS(5958),
    [anon_sym_GT_GT] = ACTIONS(7304),
    [anon_sym_GT_GT_EQ] = ACTIONS(5958),
    [anon_sym_PIPE] = ACTIONS(7304),
    [anon_sym_PIPE_EQ] = ACTIONS(5958),
    [anon_sym_PIPE_PIPE] = ACTIONS(5958),
    [anon_sym_QMARK] = ACTIONS(5958),
    [anon_sym_DOT_DOT] = ACTIONS(7304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5958),
    [anon_sym_as] = ACTIONS(5958),
    [sym_line_comment] = ACTIONS(7),
  },
  [3074] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5960),
    [anon_sym_LPAREN] = ACTIONS(5960),
    [anon_sym_RPAREN] = ACTIONS(5960),
    [anon_sym_LBRACE] = ACTIONS(5960),
    [anon_sym_RBRACE] = ACTIONS(5960),
    [anon_sym_LBRACK] = ACTIONS(5960),
    [anon_sym_RBRACK] = ACTIONS(5960),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_STAR] = ACTIONS(7306),
    [anon_sym_COMMA] = ACTIONS(5960),
    [anon_sym_AMP] = ACTIONS(7306),
    [anon_sym_DASH] = ACTIONS(7306),
    [anon_sym_DOT] = ACTIONS(7306),
    [anon_sym_DASH_EQ] = ACTIONS(5960),
    [anon_sym_BANG_EQ] = ACTIONS(5960),
    [anon_sym_STAR_EQ] = ACTIONS(5960),
    [anon_sym_SLASH] = ACTIONS(7306),
    [anon_sym_SLASH_EQ] = ACTIONS(5960),
    [anon_sym_AMP_AMP] = ACTIONS(5960),
    [anon_sym_AMP_EQ] = ACTIONS(5960),
    [anon_sym_PERCENT] = ACTIONS(7306),
    [anon_sym_PERCENT_EQ] = ACTIONS(5960),
    [anon_sym_CARET] = ACTIONS(7306),
    [anon_sym_CARET_EQ] = ACTIONS(5960),
    [anon_sym_PLUS_EQ] = ACTIONS(5960),
    [anon_sym_LT] = ACTIONS(7306),
    [anon_sym_LT_LT] = ACTIONS(7306),
    [anon_sym_LT_LT_EQ] = ACTIONS(5960),
    [anon_sym_LT_EQ] = ACTIONS(5960),
    [anon_sym_EQ] = ACTIONS(7306),
    [anon_sym_EQ_EQ] = ACTIONS(5960),
    [anon_sym_GT] = ACTIONS(7306),
    [anon_sym_GT_EQ] = ACTIONS(5960),
    [anon_sym_GT_GT] = ACTIONS(7306),
    [anon_sym_GT_GT_EQ] = ACTIONS(5960),
    [anon_sym_PIPE] = ACTIONS(7306),
    [anon_sym_PIPE_EQ] = ACTIONS(5960),
    [anon_sym_PIPE_PIPE] = ACTIONS(5960),
    [anon_sym_QMARK] = ACTIONS(5960),
    [anon_sym_DOT_DOT] = ACTIONS(7306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5960),
    [anon_sym_as] = ACTIONS(5960),
    [sym_line_comment] = ACTIONS(7),
  },
  [3075] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5962),
    [anon_sym_LPAREN] = ACTIONS(5962),
    [anon_sym_RPAREN] = ACTIONS(5962),
    [anon_sym_LBRACE] = ACTIONS(5962),
    [anon_sym_RBRACE] = ACTIONS(5962),
    [anon_sym_LBRACK] = ACTIONS(5962),
    [anon_sym_RBRACK] = ACTIONS(5962),
    [anon_sym_PLUS] = ACTIONS(7308),
    [anon_sym_STAR] = ACTIONS(7308),
    [anon_sym_COMMA] = ACTIONS(5962),
    [anon_sym_AMP] = ACTIONS(7308),
    [anon_sym_DASH] = ACTIONS(7308),
    [anon_sym_DOT] = ACTIONS(7308),
    [anon_sym_DASH_EQ] = ACTIONS(5962),
    [anon_sym_DASH_GT] = ACTIONS(5962),
    [anon_sym_BANG_EQ] = ACTIONS(5962),
    [anon_sym_STAR_EQ] = ACTIONS(5962),
    [anon_sym_SLASH] = ACTIONS(7308),
    [anon_sym_SLASH_EQ] = ACTIONS(5962),
    [anon_sym_AMP_AMP] = ACTIONS(5962),
    [anon_sym_AMP_EQ] = ACTIONS(5962),
    [anon_sym_PERCENT] = ACTIONS(7308),
    [anon_sym_PERCENT_EQ] = ACTIONS(5962),
    [anon_sym_CARET] = ACTIONS(7308),
    [anon_sym_CARET_EQ] = ACTIONS(5962),
    [anon_sym_PLUS_EQ] = ACTIONS(5962),
    [anon_sym_LT] = ACTIONS(7308),
    [anon_sym_LT_LT] = ACTIONS(7308),
    [anon_sym_LT_LT_EQ] = ACTIONS(5962),
    [anon_sym_LT_EQ] = ACTIONS(5962),
    [anon_sym_EQ] = ACTIONS(7308),
    [anon_sym_EQ_EQ] = ACTIONS(5962),
    [anon_sym_GT] = ACTIONS(7308),
    [anon_sym_GT_EQ] = ACTIONS(5962),
    [anon_sym_GT_GT] = ACTIONS(7308),
    [anon_sym_GT_GT_EQ] = ACTIONS(5962),
    [anon_sym_PIPE] = ACTIONS(7308),
    [anon_sym_PIPE_EQ] = ACTIONS(5962),
    [anon_sym_PIPE_PIPE] = ACTIONS(5962),
    [anon_sym_QMARK] = ACTIONS(5962),
    [anon_sym_DOT_DOT] = ACTIONS(7308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5962),
    [anon_sym_as] = ACTIONS(5962),
    [sym_line_comment] = ACTIONS(7),
  },
  [3076] = {
    [sym_function_modifiers] = STATE(370),
    [sym_self_parameter] = STATE(2121),
    [sym_variadic_parameter] = STATE(2121),
    [sym_parameter] = STATE(2121),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2122),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(839),
    [sym_array_type] = STATE(2122),
    [sym_function_type] = STATE(2122),
    [sym_tuple_type] = STATE(2122),
    [sym_unit_type] = STATE(2122),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2122),
    [sym_reference_type] = STATE(2122),
    [sym_pointer_type] = STATE(2122),
    [sym_empty_type] = STATE(2122),
    [sym_abstract_type] = STATE(2121),
    [sym_dynamic_type] = STATE(2122),
    [sym_macro_invocation] = STATE(2122),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [sym_reference_pattern_in_parameter] = STATE(840),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_RPAREN] = ACTIONS(7310),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(1740),
    [anon_sym_i8] = ACTIONS(1740),
    [anon_sym_u16] = ACTIONS(1740),
    [anon_sym_i16] = ACTIONS(1740),
    [anon_sym_u32] = ACTIONS(1740),
    [anon_sym_i32] = ACTIONS(1740),
    [anon_sym_u64] = ACTIONS(1740),
    [anon_sym_i64] = ACTIONS(1740),
    [anon_sym_u128] = ACTIONS(1740),
    [anon_sym_i128] = ACTIONS(1740),
    [anon_sym_isize] = ACTIONS(1740),
    [anon_sym_usize] = ACTIONS(1740),
    [anon_sym_f32] = ACTIONS(1740),
    [anon_sym_f64] = ACTIONS(1740),
    [anon_sym_bool] = ACTIONS(1740),
    [anon_sym_str] = ACTIONS(1740),
    [anon_sym_char] = ACTIONS(1740),
    [anon_sym__] = ACTIONS(4770),
    [anon_sym_AMP] = ACTIONS(1744),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1746),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(1748),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_union] = ACTIONS(1752),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(1754),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1756),
    [sym_self] = ACTIONS(1758),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3077] = {
    [sym_type_arguments] = STATE(1330),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4790),
    [anon_sym_LPAREN] = ACTIONS(4790),
    [anon_sym_RPAREN] = ACTIONS(4790),
    [anon_sym_LBRACE] = ACTIONS(4790),
    [anon_sym_RBRACE] = ACTIONS(4790),
    [anon_sym_LBRACK] = ACTIONS(4790),
    [anon_sym_RBRACK] = ACTIONS(4790),
    [anon_sym_PLUS] = ACTIONS(4792),
    [anon_sym_STAR] = ACTIONS(4792),
    [anon_sym_COMMA] = ACTIONS(4790),
    [anon_sym_AMP] = ACTIONS(4792),
    [anon_sym_DASH] = ACTIONS(4792),
    [anon_sym_DOT] = ACTIONS(4792),
    [anon_sym_DASH_EQ] = ACTIONS(4790),
    [anon_sym_COLON_COLON] = ACTIONS(2635),
    [anon_sym_BANG_EQ] = ACTIONS(4790),
    [anon_sym_STAR_EQ] = ACTIONS(4790),
    [anon_sym_SLASH] = ACTIONS(4792),
    [anon_sym_SLASH_EQ] = ACTIONS(4790),
    [anon_sym_AMP_AMP] = ACTIONS(4790),
    [anon_sym_AMP_EQ] = ACTIONS(4790),
    [anon_sym_PERCENT] = ACTIONS(4792),
    [anon_sym_PERCENT_EQ] = ACTIONS(4790),
    [anon_sym_CARET] = ACTIONS(4792),
    [anon_sym_CARET_EQ] = ACTIONS(4790),
    [anon_sym_PLUS_EQ] = ACTIONS(4790),
    [anon_sym_LT] = ACTIONS(2637),
    [anon_sym_LT_LT] = ACTIONS(4792),
    [anon_sym_LT_LT_EQ] = ACTIONS(4790),
    [anon_sym_LT_EQ] = ACTIONS(4790),
    [anon_sym_EQ] = ACTIONS(4792),
    [anon_sym_EQ_EQ] = ACTIONS(4790),
    [anon_sym_GT] = ACTIONS(4792),
    [anon_sym_GT_EQ] = ACTIONS(4790),
    [anon_sym_GT_GT] = ACTIONS(4792),
    [anon_sym_GT_GT_EQ] = ACTIONS(4790),
    [anon_sym_PIPE] = ACTIONS(4792),
    [anon_sym_PIPE_EQ] = ACTIONS(4790),
    [anon_sym_PIPE_PIPE] = ACTIONS(4790),
    [anon_sym_QMARK] = ACTIONS(4790),
    [anon_sym_DOT_DOT] = ACTIONS(4792),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4790),
    [anon_sym_as] = ACTIONS(4790),
    [sym_line_comment] = ACTIONS(7),
  },
  [3078] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4794),
    [anon_sym_LPAREN] = ACTIONS(4794),
    [anon_sym_RPAREN] = ACTIONS(4794),
    [anon_sym_LBRACE] = ACTIONS(4794),
    [anon_sym_RBRACE] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4794),
    [anon_sym_RBRACK] = ACTIONS(4794),
    [anon_sym_PLUS] = ACTIONS(4796),
    [anon_sym_STAR] = ACTIONS(4796),
    [anon_sym_COMMA] = ACTIONS(4794),
    [anon_sym_AMP] = ACTIONS(4796),
    [anon_sym_DASH] = ACTIONS(4796),
    [anon_sym_DOT] = ACTIONS(4796),
    [anon_sym_DASH_EQ] = ACTIONS(4794),
    [anon_sym_COLON_COLON] = ACTIONS(2651),
    [anon_sym_BANG_EQ] = ACTIONS(4794),
    [anon_sym_STAR_EQ] = ACTIONS(4794),
    [anon_sym_SLASH] = ACTIONS(4796),
    [anon_sym_SLASH_EQ] = ACTIONS(4794),
    [anon_sym_AMP_AMP] = ACTIONS(4794),
    [anon_sym_AMP_EQ] = ACTIONS(4794),
    [anon_sym_PERCENT] = ACTIONS(4796),
    [anon_sym_PERCENT_EQ] = ACTIONS(4794),
    [anon_sym_CARET] = ACTIONS(4796),
    [anon_sym_CARET_EQ] = ACTIONS(4794),
    [anon_sym_PLUS_EQ] = ACTIONS(4794),
    [anon_sym_LT] = ACTIONS(4796),
    [anon_sym_LT_LT] = ACTIONS(4796),
    [anon_sym_LT_LT_EQ] = ACTIONS(4794),
    [anon_sym_LT_EQ] = ACTIONS(4794),
    [anon_sym_EQ] = ACTIONS(4796),
    [anon_sym_EQ_EQ] = ACTIONS(4794),
    [anon_sym_GT] = ACTIONS(4796),
    [anon_sym_GT_EQ] = ACTIONS(4794),
    [anon_sym_GT_GT] = ACTIONS(4796),
    [anon_sym_GT_GT_EQ] = ACTIONS(4794),
    [anon_sym_PIPE] = ACTIONS(4796),
    [anon_sym_PIPE_EQ] = ACTIONS(4794),
    [anon_sym_PIPE_PIPE] = ACTIONS(4794),
    [anon_sym_QMARK] = ACTIONS(4794),
    [anon_sym_DOT_DOT] = ACTIONS(4796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4794),
    [anon_sym_as] = ACTIONS(4794),
    [sym_line_comment] = ACTIONS(7),
  },
  [3079] = {
    [sym_type_arguments] = STATE(1340),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4794),
    [anon_sym_LPAREN] = ACTIONS(4794),
    [anon_sym_RPAREN] = ACTIONS(4794),
    [anon_sym_LBRACE] = ACTIONS(4794),
    [anon_sym_RBRACE] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4794),
    [anon_sym_RBRACK] = ACTIONS(4794),
    [anon_sym_PLUS] = ACTIONS(4796),
    [anon_sym_STAR] = ACTIONS(4796),
    [anon_sym_COMMA] = ACTIONS(4794),
    [anon_sym_AMP] = ACTIONS(4796),
    [anon_sym_DASH] = ACTIONS(4796),
    [anon_sym_DOT] = ACTIONS(4796),
    [anon_sym_DASH_EQ] = ACTIONS(4794),
    [anon_sym_BANG_EQ] = ACTIONS(4794),
    [anon_sym_STAR_EQ] = ACTIONS(4794),
    [anon_sym_SLASH] = ACTIONS(4796),
    [anon_sym_SLASH_EQ] = ACTIONS(4794),
    [anon_sym_AMP_AMP] = ACTIONS(4794),
    [anon_sym_AMP_EQ] = ACTIONS(4794),
    [anon_sym_PERCENT] = ACTIONS(4796),
    [anon_sym_PERCENT_EQ] = ACTIONS(4794),
    [anon_sym_CARET] = ACTIONS(4796),
    [anon_sym_CARET_EQ] = ACTIONS(4794),
    [anon_sym_PLUS_EQ] = ACTIONS(4794),
    [anon_sym_LT] = ACTIONS(2637),
    [anon_sym_LT_LT] = ACTIONS(4796),
    [anon_sym_LT_LT_EQ] = ACTIONS(4794),
    [anon_sym_LT_EQ] = ACTIONS(4794),
    [anon_sym_EQ] = ACTIONS(4796),
    [anon_sym_EQ_EQ] = ACTIONS(4794),
    [anon_sym_GT] = ACTIONS(4796),
    [anon_sym_GT_EQ] = ACTIONS(4794),
    [anon_sym_GT_GT] = ACTIONS(4796),
    [anon_sym_GT_GT_EQ] = ACTIONS(4794),
    [anon_sym_PIPE] = ACTIONS(4796),
    [anon_sym_PIPE_EQ] = ACTIONS(4794),
    [anon_sym_PIPE_PIPE] = ACTIONS(4794),
    [anon_sym_QMARK] = ACTIONS(4794),
    [anon_sym_DOT_DOT] = ACTIONS(4796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4794),
    [anon_sym_as] = ACTIONS(4794),
    [sym_line_comment] = ACTIONS(7),
  },
  [3080] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6008),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_RPAREN] = ACTIONS(6008),
    [anon_sym_LBRACE] = ACTIONS(6008),
    [anon_sym_RBRACE] = ACTIONS(6008),
    [anon_sym_LBRACK] = ACTIONS(6008),
    [anon_sym_RBRACK] = ACTIONS(6008),
    [anon_sym_PLUS] = ACTIONS(7312),
    [anon_sym_STAR] = ACTIONS(7312),
    [anon_sym_COMMA] = ACTIONS(6008),
    [anon_sym_AMP] = ACTIONS(7312),
    [anon_sym_DASH] = ACTIONS(7312),
    [anon_sym_DOT] = ACTIONS(7312),
    [anon_sym_DASH_EQ] = ACTIONS(6008),
    [anon_sym_BANG_EQ] = ACTIONS(6008),
    [anon_sym_STAR_EQ] = ACTIONS(6008),
    [anon_sym_SLASH] = ACTIONS(7312),
    [anon_sym_SLASH_EQ] = ACTIONS(6008),
    [anon_sym_AMP_AMP] = ACTIONS(6008),
    [anon_sym_AMP_EQ] = ACTIONS(6008),
    [anon_sym_PERCENT] = ACTIONS(7312),
    [anon_sym_PERCENT_EQ] = ACTIONS(6008),
    [anon_sym_CARET] = ACTIONS(7312),
    [anon_sym_CARET_EQ] = ACTIONS(6008),
    [anon_sym_PLUS_EQ] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(7312),
    [anon_sym_LT_LT] = ACTIONS(7312),
    [anon_sym_LT_LT_EQ] = ACTIONS(6008),
    [anon_sym_LT_EQ] = ACTIONS(6008),
    [anon_sym_EQ] = ACTIONS(7312),
    [anon_sym_EQ_EQ] = ACTIONS(6008),
    [anon_sym_GT] = ACTIONS(7312),
    [anon_sym_GT_EQ] = ACTIONS(6008),
    [anon_sym_GT_GT] = ACTIONS(7312),
    [anon_sym_GT_GT_EQ] = ACTIONS(6008),
    [anon_sym_PIPE] = ACTIONS(7312),
    [anon_sym_PIPE_EQ] = ACTIONS(6008),
    [anon_sym_PIPE_PIPE] = ACTIONS(6008),
    [anon_sym_QMARK] = ACTIONS(6008),
    [anon_sym_DOT_DOT] = ACTIONS(7312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6008),
    [anon_sym_as] = ACTIONS(6008),
    [sym_line_comment] = ACTIONS(7),
  },
  [3081] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6008),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_RPAREN] = ACTIONS(6008),
    [anon_sym_LBRACE] = ACTIONS(6008),
    [anon_sym_RBRACE] = ACTIONS(6008),
    [anon_sym_LBRACK] = ACTIONS(6008),
    [anon_sym_RBRACK] = ACTIONS(6008),
    [anon_sym_PLUS] = ACTIONS(7312),
    [anon_sym_STAR] = ACTIONS(7312),
    [anon_sym_COMMA] = ACTIONS(6008),
    [anon_sym_AMP] = ACTIONS(7312),
    [anon_sym_DASH] = ACTIONS(7312),
    [anon_sym_DOT] = ACTIONS(7312),
    [anon_sym_DASH_EQ] = ACTIONS(6008),
    [anon_sym_BANG_EQ] = ACTIONS(6008),
    [anon_sym_STAR_EQ] = ACTIONS(6008),
    [anon_sym_SLASH] = ACTIONS(7312),
    [anon_sym_SLASH_EQ] = ACTIONS(6008),
    [anon_sym_AMP_AMP] = ACTIONS(6008),
    [anon_sym_AMP_EQ] = ACTIONS(6008),
    [anon_sym_PERCENT] = ACTIONS(7312),
    [anon_sym_PERCENT_EQ] = ACTIONS(6008),
    [anon_sym_CARET] = ACTIONS(7312),
    [anon_sym_CARET_EQ] = ACTIONS(6008),
    [anon_sym_PLUS_EQ] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(7312),
    [anon_sym_LT_LT] = ACTIONS(7312),
    [anon_sym_LT_LT_EQ] = ACTIONS(6008),
    [anon_sym_LT_EQ] = ACTIONS(6008),
    [anon_sym_EQ] = ACTIONS(7312),
    [anon_sym_EQ_EQ] = ACTIONS(6008),
    [anon_sym_GT] = ACTIONS(7312),
    [anon_sym_GT_EQ] = ACTIONS(6008),
    [anon_sym_GT_GT] = ACTIONS(7312),
    [anon_sym_GT_GT_EQ] = ACTIONS(6008),
    [anon_sym_PIPE] = ACTIONS(7312),
    [anon_sym_PIPE_EQ] = ACTIONS(6008),
    [anon_sym_PIPE_PIPE] = ACTIONS(6008),
    [anon_sym_QMARK] = ACTIONS(6008),
    [anon_sym_DOT_DOT] = ACTIONS(7312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6008),
    [anon_sym_as] = ACTIONS(6008),
    [sym_line_comment] = ACTIONS(7),
  },
  [3082] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6010),
    [anon_sym_LPAREN] = ACTIONS(6010),
    [anon_sym_RPAREN] = ACTIONS(6010),
    [anon_sym_LBRACE] = ACTIONS(6010),
    [anon_sym_RBRACE] = ACTIONS(6010),
    [anon_sym_LBRACK] = ACTIONS(6010),
    [anon_sym_RBRACK] = ACTIONS(6010),
    [anon_sym_PLUS] = ACTIONS(7314),
    [anon_sym_STAR] = ACTIONS(7314),
    [anon_sym_COMMA] = ACTIONS(6010),
    [anon_sym_AMP] = ACTIONS(7314),
    [anon_sym_DASH] = ACTIONS(7314),
    [anon_sym_DOT] = ACTIONS(7314),
    [anon_sym_DASH_EQ] = ACTIONS(6010),
    [anon_sym_BANG_EQ] = ACTIONS(6010),
    [anon_sym_STAR_EQ] = ACTIONS(6010),
    [anon_sym_SLASH] = ACTIONS(7314),
    [anon_sym_SLASH_EQ] = ACTIONS(6010),
    [anon_sym_AMP_AMP] = ACTIONS(6010),
    [anon_sym_AMP_EQ] = ACTIONS(6010),
    [anon_sym_PERCENT] = ACTIONS(7314),
    [anon_sym_PERCENT_EQ] = ACTIONS(6010),
    [anon_sym_CARET] = ACTIONS(7314),
    [anon_sym_CARET_EQ] = ACTIONS(6010),
    [anon_sym_PLUS_EQ] = ACTIONS(6010),
    [anon_sym_LT] = ACTIONS(7314),
    [anon_sym_LT_LT] = ACTIONS(7314),
    [anon_sym_LT_LT_EQ] = ACTIONS(6010),
    [anon_sym_LT_EQ] = ACTIONS(6010),
    [anon_sym_EQ] = ACTIONS(7314),
    [anon_sym_EQ_EQ] = ACTIONS(6010),
    [anon_sym_GT] = ACTIONS(7314),
    [anon_sym_GT_EQ] = ACTIONS(6010),
    [anon_sym_GT_GT] = ACTIONS(7314),
    [anon_sym_GT_GT_EQ] = ACTIONS(6010),
    [anon_sym_PIPE] = ACTIONS(7314),
    [anon_sym_PIPE_EQ] = ACTIONS(6010),
    [anon_sym_PIPE_PIPE] = ACTIONS(6010),
    [anon_sym_QMARK] = ACTIONS(6010),
    [anon_sym_DOT_DOT] = ACTIONS(7314),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6010),
    [anon_sym_as] = ACTIONS(6010),
    [sym_line_comment] = ACTIONS(7),
  },
  [3083] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6010),
    [anon_sym_LPAREN] = ACTIONS(6010),
    [anon_sym_RPAREN] = ACTIONS(6010),
    [anon_sym_LBRACE] = ACTIONS(6010),
    [anon_sym_RBRACE] = ACTIONS(6010),
    [anon_sym_LBRACK] = ACTIONS(6010),
    [anon_sym_RBRACK] = ACTIONS(6010),
    [anon_sym_PLUS] = ACTIONS(7314),
    [anon_sym_STAR] = ACTIONS(7314),
    [anon_sym_COMMA] = ACTIONS(6010),
    [anon_sym_AMP] = ACTIONS(7314),
    [anon_sym_DASH] = ACTIONS(7314),
    [anon_sym_DOT] = ACTIONS(7314),
    [anon_sym_DASH_EQ] = ACTIONS(6010),
    [anon_sym_BANG_EQ] = ACTIONS(6010),
    [anon_sym_STAR_EQ] = ACTIONS(6010),
    [anon_sym_SLASH] = ACTIONS(7314),
    [anon_sym_SLASH_EQ] = ACTIONS(6010),
    [anon_sym_AMP_AMP] = ACTIONS(6010),
    [anon_sym_AMP_EQ] = ACTIONS(6010),
    [anon_sym_PERCENT] = ACTIONS(7314),
    [anon_sym_PERCENT_EQ] = ACTIONS(6010),
    [anon_sym_CARET] = ACTIONS(7314),
    [anon_sym_CARET_EQ] = ACTIONS(6010),
    [anon_sym_PLUS_EQ] = ACTIONS(6010),
    [anon_sym_LT] = ACTIONS(7314),
    [anon_sym_LT_LT] = ACTIONS(7314),
    [anon_sym_LT_LT_EQ] = ACTIONS(6010),
    [anon_sym_LT_EQ] = ACTIONS(6010),
    [anon_sym_EQ] = ACTIONS(7314),
    [anon_sym_EQ_EQ] = ACTIONS(6010),
    [anon_sym_GT] = ACTIONS(7314),
    [anon_sym_GT_EQ] = ACTIONS(6010),
    [anon_sym_GT_GT] = ACTIONS(7314),
    [anon_sym_GT_GT_EQ] = ACTIONS(6010),
    [anon_sym_PIPE] = ACTIONS(7314),
    [anon_sym_PIPE_EQ] = ACTIONS(6010),
    [anon_sym_PIPE_PIPE] = ACTIONS(6010),
    [anon_sym_QMARK] = ACTIONS(6010),
    [anon_sym_DOT_DOT] = ACTIONS(7314),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6010),
    [anon_sym_as] = ACTIONS(6010),
    [sym_line_comment] = ACTIONS(7),
  },
  [3084] = {
    [sym_raw_string_literal] = ACTIONS(7316),
    [sym_float_literal] = ACTIONS(7316),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(7316),
    [anon_sym_SEMI] = ACTIONS(7316),
    [anon_sym_macro_rules_BANG] = ACTIONS(7316),
    [anon_sym_LPAREN] = ACTIONS(7316),
    [anon_sym_LBRACE] = ACTIONS(7316),
    [anon_sym_RBRACE] = ACTIONS(7316),
    [anon_sym_LBRACK] = ACTIONS(7316),
    [anon_sym_PLUS] = ACTIONS(7318),
    [anon_sym_STAR] = ACTIONS(7318),
    [anon_sym_u8] = ACTIONS(7318),
    [anon_sym_i8] = ACTIONS(7318),
    [anon_sym_u16] = ACTIONS(7318),
    [anon_sym_i16] = ACTIONS(7318),
    [anon_sym_u32] = ACTIONS(7318),
    [anon_sym_i32] = ACTIONS(7318),
    [anon_sym_u64] = ACTIONS(7318),
    [anon_sym_i64] = ACTIONS(7318),
    [anon_sym_u128] = ACTIONS(7318),
    [anon_sym_i128] = ACTIONS(7318),
    [anon_sym_isize] = ACTIONS(7318),
    [anon_sym_usize] = ACTIONS(7318),
    [anon_sym_f32] = ACTIONS(7318),
    [anon_sym_f64] = ACTIONS(7318),
    [anon_sym_bool] = ACTIONS(7318),
    [anon_sym_str] = ACTIONS(7318),
    [anon_sym_char] = ACTIONS(7318),
    [anon_sym_AMP] = ACTIONS(7318),
    [anon_sym_DASH] = ACTIONS(7318),
    [anon_sym_DOT] = ACTIONS(7318),
    [anon_sym_DASH_EQ] = ACTIONS(7316),
    [anon_sym_COLON_COLON] = ACTIONS(7316),
    [anon_sym_BANG] = ACTIONS(7318),
    [anon_sym_BANG_EQ] = ACTIONS(7316),
    [anon_sym_STAR_EQ] = ACTIONS(7316),
    [anon_sym_SLASH] = ACTIONS(7318),
    [anon_sym_SLASH_EQ] = ACTIONS(7316),
    [anon_sym_AMP_AMP] = ACTIONS(7316),
    [anon_sym_AMP_EQ] = ACTIONS(7316),
    [anon_sym_POUND] = ACTIONS(7316),
    [anon_sym_PERCENT] = ACTIONS(7318),
    [anon_sym_PERCENT_EQ] = ACTIONS(7316),
    [anon_sym_CARET] = ACTIONS(7318),
    [anon_sym_CARET_EQ] = ACTIONS(7316),
    [anon_sym_PLUS_EQ] = ACTIONS(7316),
    [anon_sym_LT] = ACTIONS(7318),
    [anon_sym_LT_LT] = ACTIONS(7318),
    [anon_sym_LT_LT_EQ] = ACTIONS(7316),
    [anon_sym_LT_EQ] = ACTIONS(7316),
    [anon_sym_EQ] = ACTIONS(7318),
    [anon_sym_EQ_EQ] = ACTIONS(7316),
    [anon_sym_GT] = ACTIONS(7318),
    [anon_sym_GT_EQ] = ACTIONS(7316),
    [anon_sym_GT_GT] = ACTIONS(7318),
    [anon_sym_GT_GT_EQ] = ACTIONS(7316),
    [anon_sym_PIPE] = ACTIONS(7318),
    [anon_sym_PIPE_EQ] = ACTIONS(7316),
    [anon_sym_PIPE_PIPE] = ACTIONS(7316),
    [anon_sym_QMARK] = ACTIONS(7316),
    [anon_sym_SQUOTE] = ACTIONS(7318),
    [anon_sym_DOT_DOT] = ACTIONS(7318),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7316),
    [anon_sym_as] = ACTIONS(7318),
    [anon_sym_break] = ACTIONS(7318),
    [anon_sym_const] = ACTIONS(7318),
    [anon_sym_continue] = ACTIONS(7318),
    [anon_sym_default] = ACTIONS(7318),
    [anon_sym_enum] = ACTIONS(7318),
    [anon_sym_fn] = ACTIONS(7318),
    [anon_sym_for] = ACTIONS(7318),
    [anon_sym_if] = ACTIONS(7318),
    [anon_sym_impl] = ACTIONS(7318),
    [anon_sym_let] = ACTIONS(7318),
    [anon_sym_loop] = ACTIONS(7318),
    [anon_sym_match] = ACTIONS(7318),
    [anon_sym_mod] = ACTIONS(7318),
    [anon_sym_pub] = ACTIONS(7318),
    [anon_sym_return] = ACTIONS(7318),
    [anon_sym_static] = ACTIONS(7318),
    [anon_sym_struct] = ACTIONS(7318),
    [anon_sym_trait] = ACTIONS(7318),
    [anon_sym_type] = ACTIONS(7318),
    [anon_sym_union] = ACTIONS(7318),
    [anon_sym_unsafe] = ACTIONS(7318),
    [anon_sym_use] = ACTIONS(7318),
    [anon_sym_while] = ACTIONS(7318),
    [anon_sym_extern] = ACTIONS(7318),
    [anon_sym_move] = ACTIONS(7318),
    [sym_integer_literal] = ACTIONS(7316),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7316),
    [sym_char_literal] = ACTIONS(7316),
    [anon_sym_true] = ACTIONS(7318),
    [anon_sym_false] = ACTIONS(7318),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7318),
    [sym_self] = ACTIONS(7318),
    [sym_super] = ACTIONS(7318),
    [sym_crate] = ACTIONS(7318),
    [sym_metavariable] = ACTIONS(7316),
  },
  [3085] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(3372),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [3086] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7320),
    [anon_sym_STAR] = ACTIONS(7320),
    [sym_line_comment] = ACTIONS(7),
  },
  [3087] = {
    [sym_raw_string_literal] = ACTIONS(7322),
    [sym_float_literal] = ACTIONS(7322),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7322),
    [anon_sym_LPAREN] = ACTIONS(7322),
    [anon_sym_RPAREN] = ACTIONS(7322),
    [anon_sym_LBRACE] = ACTIONS(7322),
    [anon_sym_RBRACE] = ACTIONS(7322),
    [anon_sym_EQ_GT] = ACTIONS(7322),
    [anon_sym_LBRACK] = ACTIONS(7322),
    [anon_sym_RBRACK] = ACTIONS(7322),
    [anon_sym_COLON] = ACTIONS(7324),
    [anon_sym_DOLLAR] = ACTIONS(7324),
    [anon_sym_PLUS] = ACTIONS(7324),
    [anon_sym_STAR] = ACTIONS(7324),
    [anon_sym_COMMA] = ACTIONS(7322),
    [anon_sym_u8] = ACTIONS(7324),
    [anon_sym_i8] = ACTIONS(7324),
    [anon_sym_u16] = ACTIONS(7324),
    [anon_sym_i16] = ACTIONS(7324),
    [anon_sym_u32] = ACTIONS(7324),
    [anon_sym_i32] = ACTIONS(7324),
    [anon_sym_u64] = ACTIONS(7324),
    [anon_sym_i64] = ACTIONS(7324),
    [anon_sym_u128] = ACTIONS(7324),
    [anon_sym_i128] = ACTIONS(7324),
    [anon_sym_isize] = ACTIONS(7324),
    [anon_sym_usize] = ACTIONS(7324),
    [anon_sym_f32] = ACTIONS(7324),
    [anon_sym_f64] = ACTIONS(7324),
    [anon_sym_bool] = ACTIONS(7324),
    [anon_sym_str] = ACTIONS(7324),
    [anon_sym_char] = ACTIONS(7324),
    [anon_sym__] = ACTIONS(7324),
    [anon_sym_AMP] = ACTIONS(7324),
    [anon_sym_DASH] = ACTIONS(7324),
    [anon_sym_DOT] = ACTIONS(7324),
    [anon_sym_DASH_EQ] = ACTIONS(7322),
    [anon_sym_DASH_GT] = ACTIONS(7322),
    [anon_sym_COLON_COLON] = ACTIONS(7322),
    [anon_sym_BANG] = ACTIONS(7324),
    [anon_sym_BANG_EQ] = ACTIONS(7322),
    [anon_sym_AT] = ACTIONS(7322),
    [anon_sym_STAR_EQ] = ACTIONS(7322),
    [anon_sym_SLASH] = ACTIONS(7324),
    [anon_sym_SLASH_EQ] = ACTIONS(7322),
    [anon_sym_AMP_AMP] = ACTIONS(7322),
    [anon_sym_AMP_EQ] = ACTIONS(7322),
    [anon_sym_POUND] = ACTIONS(7322),
    [anon_sym_PERCENT] = ACTIONS(7324),
    [anon_sym_PERCENT_EQ] = ACTIONS(7322),
    [anon_sym_CARET] = ACTIONS(7324),
    [anon_sym_CARET_EQ] = ACTIONS(7322),
    [anon_sym_PLUS_EQ] = ACTIONS(7322),
    [anon_sym_LT] = ACTIONS(7324),
    [anon_sym_LT_LT] = ACTIONS(7324),
    [anon_sym_LT_LT_EQ] = ACTIONS(7322),
    [anon_sym_LT_EQ] = ACTIONS(7322),
    [anon_sym_EQ] = ACTIONS(7324),
    [anon_sym_EQ_EQ] = ACTIONS(7322),
    [anon_sym_GT] = ACTIONS(7324),
    [anon_sym_GT_EQ] = ACTIONS(7322),
    [anon_sym_GT_GT] = ACTIONS(7324),
    [anon_sym_GT_GT_EQ] = ACTIONS(7322),
    [anon_sym_PIPE] = ACTIONS(7324),
    [anon_sym_PIPE_EQ] = ACTIONS(7322),
    [anon_sym_PIPE_PIPE] = ACTIONS(7322),
    [anon_sym_TILDE] = ACTIONS(7322),
    [anon_sym_QMARK] = ACTIONS(7322),
    [anon_sym_SQUOTE] = ACTIONS(7324),
    [anon_sym_DOT_DOT] = ACTIONS(7324),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7322),
    [anon_sym_as] = ACTIONS(7324),
    [anon_sym_break] = ACTIONS(7324),
    [anon_sym_const] = ACTIONS(7324),
    [anon_sym_continue] = ACTIONS(7324),
    [anon_sym_default] = ACTIONS(7324),
    [anon_sym_enum] = ACTIONS(7324),
    [anon_sym_fn] = ACTIONS(7324),
    [anon_sym_for] = ACTIONS(7324),
    [anon_sym_if] = ACTIONS(7324),
    [anon_sym_impl] = ACTIONS(7324),
    [anon_sym_let] = ACTIONS(7324),
    [anon_sym_loop] = ACTIONS(7324),
    [anon_sym_match] = ACTIONS(7324),
    [anon_sym_mod] = ACTIONS(7324),
    [anon_sym_pub] = ACTIONS(7324),
    [anon_sym_return] = ACTIONS(7324),
    [anon_sym_static] = ACTIONS(7324),
    [anon_sym_struct] = ACTIONS(7324),
    [anon_sym_trait] = ACTIONS(7324),
    [anon_sym_type] = ACTIONS(7324),
    [anon_sym_union] = ACTIONS(7324),
    [anon_sym_unsafe] = ACTIONS(7324),
    [anon_sym_use] = ACTIONS(7324),
    [anon_sym_where] = ACTIONS(7324),
    [anon_sym_while] = ACTIONS(7324),
    [sym_mutable_specifier] = ACTIONS(7324),
    [sym_integer_literal] = ACTIONS(7322),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7322),
    [sym_char_literal] = ACTIONS(7322),
    [anon_sym_true] = ACTIONS(7324),
    [anon_sym_false] = ACTIONS(7324),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7324),
    [sym_self] = ACTIONS(7324),
    [sym_super] = ACTIONS(7324),
    [sym_crate] = ACTIONS(7324),
    [sym_metavariable] = ACTIONS(7322),
  },
  [3088] = {
    [sym_block_comment] = ACTIONS(7),
    [aux_sym_SLASH_LBRACK_CARET_PLUS_STAR_RBRACK_PLUS_SLASH] = ACTIONS(7326),
    [anon_sym_PLUS] = ACTIONS(7328),
    [anon_sym_STAR] = ACTIONS(7328),
    [sym_line_comment] = ACTIONS(401),
  },
  [3089] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6898),
    [anon_sym_LPAREN] = ACTIONS(6898),
    [anon_sym_RPAREN] = ACTIONS(6898),
    [anon_sym_LBRACE] = ACTIONS(6898),
    [anon_sym_RBRACE] = ACTIONS(6898),
    [anon_sym_LBRACK] = ACTIONS(6898),
    [anon_sym_RBRACK] = ACTIONS(6898),
    [anon_sym_PLUS] = ACTIONS(6900),
    [anon_sym_STAR] = ACTIONS(6900),
    [anon_sym_COMMA] = ACTIONS(6898),
    [anon_sym_AMP] = ACTIONS(6900),
    [anon_sym_DASH] = ACTIONS(6900),
    [anon_sym_DOT] = ACTIONS(6900),
    [anon_sym_DASH_EQ] = ACTIONS(6898),
    [anon_sym_BANG_EQ] = ACTIONS(6898),
    [anon_sym_STAR_EQ] = ACTIONS(6898),
    [anon_sym_SLASH] = ACTIONS(6900),
    [anon_sym_SLASH_EQ] = ACTIONS(6898),
    [anon_sym_AMP_AMP] = ACTIONS(6898),
    [anon_sym_AMP_EQ] = ACTIONS(6898),
    [anon_sym_PERCENT] = ACTIONS(6900),
    [anon_sym_PERCENT_EQ] = ACTIONS(6898),
    [anon_sym_CARET] = ACTIONS(6900),
    [anon_sym_CARET_EQ] = ACTIONS(6898),
    [anon_sym_PLUS_EQ] = ACTIONS(6898),
    [anon_sym_LT] = ACTIONS(6900),
    [anon_sym_LT_LT] = ACTIONS(6900),
    [anon_sym_LT_LT_EQ] = ACTIONS(6898),
    [anon_sym_LT_EQ] = ACTIONS(6898),
    [anon_sym_EQ] = ACTIONS(6900),
    [anon_sym_EQ_EQ] = ACTIONS(6898),
    [anon_sym_GT] = ACTIONS(6900),
    [anon_sym_GT_EQ] = ACTIONS(6898),
    [anon_sym_GT_GT] = ACTIONS(6900),
    [anon_sym_GT_GT_EQ] = ACTIONS(6898),
    [anon_sym_PIPE] = ACTIONS(6900),
    [anon_sym_PIPE_EQ] = ACTIONS(6898),
    [anon_sym_PIPE_PIPE] = ACTIONS(6898),
    [anon_sym_QMARK] = ACTIONS(6898),
    [anon_sym_DOT_DOT] = ACTIONS(6900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6898),
    [anon_sym_as] = ACTIONS(6898),
    [sym_line_comment] = ACTIONS(7),
  },
  [3090] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7226),
    [anon_sym_macro_rules_BANG] = ACTIONS(7226),
    [anon_sym_LPAREN] = ACTIONS(7226),
    [anon_sym_RPAREN] = ACTIONS(7226),
    [anon_sym_LBRACE] = ACTIONS(7226),
    [anon_sym_RBRACE] = ACTIONS(7226),
    [anon_sym_LBRACK] = ACTIONS(7226),
    [anon_sym_RBRACK] = ACTIONS(7226),
    [anon_sym_PLUS] = ACTIONS(7228),
    [anon_sym_STAR] = ACTIONS(7228),
    [anon_sym_COMMA] = ACTIONS(7226),
    [anon_sym_AMP] = ACTIONS(7228),
    [anon_sym_DASH] = ACTIONS(7228),
    [anon_sym_DOT] = ACTIONS(7228),
    [anon_sym_DASH_EQ] = ACTIONS(7226),
    [anon_sym_BANG_EQ] = ACTIONS(7226),
    [anon_sym_STAR_EQ] = ACTIONS(7226),
    [anon_sym_SLASH] = ACTIONS(7228),
    [anon_sym_SLASH_EQ] = ACTIONS(7226),
    [anon_sym_AMP_AMP] = ACTIONS(7226),
    [anon_sym_AMP_EQ] = ACTIONS(7226),
    [anon_sym_POUND] = ACTIONS(7226),
    [anon_sym_PERCENT] = ACTIONS(7228),
    [anon_sym_PERCENT_EQ] = ACTIONS(7226),
    [anon_sym_CARET] = ACTIONS(7228),
    [anon_sym_CARET_EQ] = ACTIONS(7226),
    [anon_sym_PLUS_EQ] = ACTIONS(7226),
    [anon_sym_LT] = ACTIONS(7228),
    [anon_sym_LT_LT] = ACTIONS(7228),
    [anon_sym_LT_LT_EQ] = ACTIONS(7226),
    [anon_sym_LT_EQ] = ACTIONS(7226),
    [anon_sym_EQ] = ACTIONS(7228),
    [anon_sym_EQ_EQ] = ACTIONS(7226),
    [anon_sym_GT] = ACTIONS(7228),
    [anon_sym_GT_EQ] = ACTIONS(7226),
    [anon_sym_GT_GT] = ACTIONS(7228),
    [anon_sym_GT_GT_EQ] = ACTIONS(7226),
    [anon_sym_PIPE] = ACTIONS(7228),
    [anon_sym_PIPE_EQ] = ACTIONS(7226),
    [anon_sym_PIPE_PIPE] = ACTIONS(7226),
    [anon_sym_QMARK] = ACTIONS(7226),
    [anon_sym_DOT_DOT] = ACTIONS(7228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7226),
    [anon_sym_as] = ACTIONS(7228),
    [anon_sym_const] = ACTIONS(7228),
    [anon_sym_default] = ACTIONS(7228),
    [anon_sym_enum] = ACTIONS(7228),
    [anon_sym_fn] = ACTIONS(7228),
    [anon_sym_impl] = ACTIONS(7228),
    [anon_sym_let] = ACTIONS(7228),
    [anon_sym_mod] = ACTIONS(7228),
    [anon_sym_pub] = ACTIONS(7228),
    [anon_sym_static] = ACTIONS(7228),
    [anon_sym_struct] = ACTIONS(7228),
    [anon_sym_trait] = ACTIONS(7228),
    [anon_sym_type] = ACTIONS(7228),
    [anon_sym_union] = ACTIONS(7228),
    [anon_sym_unsafe] = ACTIONS(7228),
    [anon_sym_use] = ACTIONS(7228),
    [anon_sym_extern] = ACTIONS(7228),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7228),
  },
  [3091] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7330),
    [sym_line_comment] = ACTIONS(7),
  },
  [3092] = {
    [sym_else_tail] = STATE(1378),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2012),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_PLUS] = ACTIONS(2014),
    [anon_sym_STAR] = ACTIONS(2014),
    [anon_sym_COMMA] = ACTIONS(2012),
    [anon_sym_AMP] = ACTIONS(2014),
    [anon_sym_DASH] = ACTIONS(2014),
    [anon_sym_DOT] = ACTIONS(2014),
    [anon_sym_DASH_EQ] = ACTIONS(2012),
    [anon_sym_BANG_EQ] = ACTIONS(2012),
    [anon_sym_STAR_EQ] = ACTIONS(2012),
    [anon_sym_SLASH] = ACTIONS(2014),
    [anon_sym_SLASH_EQ] = ACTIONS(2012),
    [anon_sym_AMP_AMP] = ACTIONS(2012),
    [anon_sym_AMP_EQ] = ACTIONS(2012),
    [anon_sym_PERCENT] = ACTIONS(2014),
    [anon_sym_PERCENT_EQ] = ACTIONS(2012),
    [anon_sym_CARET] = ACTIONS(2014),
    [anon_sym_CARET_EQ] = ACTIONS(2012),
    [anon_sym_PLUS_EQ] = ACTIONS(2012),
    [anon_sym_LT] = ACTIONS(2014),
    [anon_sym_LT_LT] = ACTIONS(2014),
    [anon_sym_LT_LT_EQ] = ACTIONS(2012),
    [anon_sym_LT_EQ] = ACTIONS(2012),
    [anon_sym_EQ] = ACTIONS(2014),
    [anon_sym_EQ_EQ] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2014),
    [anon_sym_GT_EQ] = ACTIONS(2012),
    [anon_sym_GT_GT] = ACTIONS(2014),
    [anon_sym_GT_GT_EQ] = ACTIONS(2012),
    [anon_sym_PIPE] = ACTIONS(2014),
    [anon_sym_PIPE_EQ] = ACTIONS(2012),
    [anon_sym_PIPE_PIPE] = ACTIONS(2012),
    [anon_sym_QMARK] = ACTIONS(2012),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2012),
    [anon_sym_as] = ACTIONS(2012),
    [anon_sym_else] = ACTIONS(7332),
    [sym_line_comment] = ACTIONS(7),
  },
  [3093] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(5886),
    [anon_sym_STAR] = ACTIONS(5888),
    [anon_sym_COMMA] = ACTIONS(2220),
    [anon_sym_AMP] = ACTIONS(5890),
    [anon_sym_DASH] = ACTIONS(5886),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(5892),
    [anon_sym_BANG_EQ] = ACTIONS(5894),
    [anon_sym_STAR_EQ] = ACTIONS(5892),
    [anon_sym_SLASH] = ACTIONS(5888),
    [anon_sym_SLASH_EQ] = ACTIONS(5892),
    [anon_sym_AMP_AMP] = ACTIONS(5896),
    [anon_sym_AMP_EQ] = ACTIONS(5892),
    [anon_sym_PERCENT] = ACTIONS(5888),
    [anon_sym_PERCENT_EQ] = ACTIONS(5892),
    [anon_sym_CARET] = ACTIONS(5898),
    [anon_sym_CARET_EQ] = ACTIONS(5892),
    [anon_sym_PLUS_EQ] = ACTIONS(5892),
    [anon_sym_LT] = ACTIONS(5900),
    [anon_sym_LT_LT] = ACTIONS(5902),
    [anon_sym_LT_LT_EQ] = ACTIONS(5892),
    [anon_sym_LT_EQ] = ACTIONS(5894),
    [anon_sym_EQ] = ACTIONS(5904),
    [anon_sym_EQ_EQ] = ACTIONS(5894),
    [anon_sym_GT] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5894),
    [anon_sym_GT_GT] = ACTIONS(5902),
    [anon_sym_GT_GT_EQ] = ACTIONS(5892),
    [anon_sym_PIPE] = ACTIONS(5906),
    [anon_sym_PIPE_EQ] = ACTIONS(5892),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(5910),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5912),
    [anon_sym_as] = ACTIONS(5914),
    [sym_line_comment] = ACTIONS(7),
  },
  [3094] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(5888),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(5888),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(5888),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2591),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [3095] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(5886),
    [anon_sym_STAR] = ACTIONS(5888),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(5886),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(5888),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(5888),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(5902),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(5902),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [3096] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(5886),
    [anon_sym_STAR] = ACTIONS(5888),
    [anon_sym_COMMA] = ACTIONS(2601),
    [anon_sym_AMP] = ACTIONS(5890),
    [anon_sym_DASH] = ACTIONS(5886),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2601),
    [anon_sym_BANG_EQ] = ACTIONS(5894),
    [anon_sym_STAR_EQ] = ACTIONS(2601),
    [anon_sym_SLASH] = ACTIONS(5888),
    [anon_sym_SLASH_EQ] = ACTIONS(2601),
    [anon_sym_AMP_AMP] = ACTIONS(5896),
    [anon_sym_AMP_EQ] = ACTIONS(2601),
    [anon_sym_PERCENT] = ACTIONS(5888),
    [anon_sym_PERCENT_EQ] = ACTIONS(2601),
    [anon_sym_CARET] = ACTIONS(5898),
    [anon_sym_CARET_EQ] = ACTIONS(2601),
    [anon_sym_PLUS_EQ] = ACTIONS(2601),
    [anon_sym_LT] = ACTIONS(5900),
    [anon_sym_LT_LT] = ACTIONS(5902),
    [anon_sym_LT_LT_EQ] = ACTIONS(2601),
    [anon_sym_LT_EQ] = ACTIONS(5894),
    [anon_sym_EQ] = ACTIONS(2603),
    [anon_sym_EQ_EQ] = ACTIONS(5894),
    [anon_sym_GT] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5894),
    [anon_sym_GT_GT] = ACTIONS(5902),
    [anon_sym_GT_GT_EQ] = ACTIONS(2601),
    [anon_sym_PIPE] = ACTIONS(5906),
    [anon_sym_PIPE_EQ] = ACTIONS(2601),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_QMARK] = ACTIONS(2601),
    [anon_sym_DOT_DOT] = ACTIONS(5910),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5912),
    [anon_sym_as] = ACTIONS(2601),
    [sym_line_comment] = ACTIONS(7),
  },
  [3097] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(5886),
    [anon_sym_STAR] = ACTIONS(5888),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(5890),
    [anon_sym_DASH] = ACTIONS(5886),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(5888),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(5888),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(5898),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(5902),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(5902),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(5906),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [3098] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(5886),
    [anon_sym_STAR] = ACTIONS(5888),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(5890),
    [anon_sym_DASH] = ACTIONS(5886),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(5894),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(5888),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(5888),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(5898),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(5900),
    [anon_sym_LT_LT] = ACTIONS(5902),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(5894),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(5894),
    [anon_sym_GT] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5894),
    [anon_sym_GT_GT] = ACTIONS(5902),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(5906),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [3099] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(5886),
    [anon_sym_STAR] = ACTIONS(5888),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(5890),
    [anon_sym_DASH] = ACTIONS(5886),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(5888),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(5888),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(5902),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(5902),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [3100] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(5886),
    [anon_sym_STAR] = ACTIONS(5888),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(5886),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(5888),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(5888),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2591),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [3101] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(5886),
    [anon_sym_STAR] = ACTIONS(5888),
    [anon_sym_COMMA] = ACTIONS(2605),
    [anon_sym_AMP] = ACTIONS(5890),
    [anon_sym_DASH] = ACTIONS(5886),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2605),
    [anon_sym_BANG_EQ] = ACTIONS(5894),
    [anon_sym_STAR_EQ] = ACTIONS(2605),
    [anon_sym_SLASH] = ACTIONS(5888),
    [anon_sym_SLASH_EQ] = ACTIONS(2605),
    [anon_sym_AMP_AMP] = ACTIONS(5896),
    [anon_sym_AMP_EQ] = ACTIONS(2605),
    [anon_sym_PERCENT] = ACTIONS(5888),
    [anon_sym_PERCENT_EQ] = ACTIONS(2605),
    [anon_sym_CARET] = ACTIONS(5898),
    [anon_sym_CARET_EQ] = ACTIONS(2605),
    [anon_sym_PLUS_EQ] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(5900),
    [anon_sym_LT_LT] = ACTIONS(5902),
    [anon_sym_LT_LT_EQ] = ACTIONS(2605),
    [anon_sym_LT_EQ] = ACTIONS(5894),
    [anon_sym_EQ] = ACTIONS(2607),
    [anon_sym_EQ_EQ] = ACTIONS(5894),
    [anon_sym_GT] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5894),
    [anon_sym_GT_GT] = ACTIONS(5902),
    [anon_sym_GT_GT_EQ] = ACTIONS(2605),
    [anon_sym_PIPE] = ACTIONS(5906),
    [anon_sym_PIPE_EQ] = ACTIONS(2605),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_QMARK] = ACTIONS(2605),
    [anon_sym_DOT_DOT] = ACTIONS(5910),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5912),
    [anon_sym_as] = ACTIONS(2605),
    [sym_line_comment] = ACTIONS(7),
  },
  [3102] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(5886),
    [anon_sym_STAR] = ACTIONS(5888),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(5890),
    [anon_sym_DASH] = ACTIONS(5886),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(5888),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(5888),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(5898),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(5902),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(5902),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [3103] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(5886),
    [anon_sym_STAR] = ACTIONS(5888),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(5890),
    [anon_sym_DASH] = ACTIONS(5886),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(5894),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(5888),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(5896),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(5888),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(5898),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(5900),
    [anon_sym_LT_LT] = ACTIONS(5902),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(5894),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(5894),
    [anon_sym_GT] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5894),
    [anon_sym_GT_GT] = ACTIONS(5902),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(5906),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [3104] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(5886),
    [anon_sym_STAR] = ACTIONS(5888),
    [anon_sym_COMMA] = ACTIONS(2609),
    [anon_sym_AMP] = ACTIONS(5890),
    [anon_sym_DASH] = ACTIONS(5886),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2609),
    [anon_sym_BANG_EQ] = ACTIONS(5894),
    [anon_sym_STAR_EQ] = ACTIONS(2609),
    [anon_sym_SLASH] = ACTIONS(5888),
    [anon_sym_SLASH_EQ] = ACTIONS(2609),
    [anon_sym_AMP_AMP] = ACTIONS(5896),
    [anon_sym_AMP_EQ] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(5888),
    [anon_sym_PERCENT_EQ] = ACTIONS(2609),
    [anon_sym_CARET] = ACTIONS(5898),
    [anon_sym_CARET_EQ] = ACTIONS(2609),
    [anon_sym_PLUS_EQ] = ACTIONS(2609),
    [anon_sym_LT] = ACTIONS(5900),
    [anon_sym_LT_LT] = ACTIONS(5902),
    [anon_sym_LT_LT_EQ] = ACTIONS(2609),
    [anon_sym_LT_EQ] = ACTIONS(5894),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_EQ_EQ] = ACTIONS(5894),
    [anon_sym_GT] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5894),
    [anon_sym_GT_GT] = ACTIONS(5902),
    [anon_sym_GT_GT_EQ] = ACTIONS(2609),
    [anon_sym_PIPE] = ACTIONS(5906),
    [anon_sym_PIPE_EQ] = ACTIONS(2609),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_QMARK] = ACTIONS(2609),
    [anon_sym_DOT_DOT] = ACTIONS(2611),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2609),
    [anon_sym_as] = ACTIONS(2609),
    [sym_line_comment] = ACTIONS(7),
  },
  [3105] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(7334),
    [sym_mutable_specifier] = ACTIONS(7334),
    [sym_line_comment] = ACTIONS(7),
  },
  [3106] = {
    [sym_function_modifiers] = STATE(3109),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1319),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(3379),
    [sym_array_type] = STATE(1319),
    [sym_function_type] = STATE(1319),
    [sym_tuple_type] = STATE(1319),
    [sym_unit_type] = STATE(1319),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(1319),
    [sym_reference_type] = STATE(1319),
    [sym_pointer_type] = STATE(1319),
    [sym_empty_type] = STATE(1319),
    [sym_dynamic_type] = STATE(1319),
    [sym_macro_invocation] = STATE(1319),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(3111),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(6776),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(6778),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6780),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_mutable_specifier] = ACTIONS(7336),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6782),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [3107] = {
    [sym_parameters] = STATE(3380),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [sym_line_comment] = ACTIONS(7),
  },
  [3108] = {
    [sym_parameters] = STATE(3381),
    [sym_type_arguments] = STATE(1330),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(2633),
    [anon_sym_STAR] = ACTIONS(2633),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_DASH] = ACTIONS(2633),
    [anon_sym_DOT] = ACTIONS(2633),
    [anon_sym_DASH_EQ] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(2635),
    [anon_sym_BANG] = ACTIONS(557),
    [anon_sym_BANG_EQ] = ACTIONS(773),
    [anon_sym_STAR_EQ] = ACTIONS(773),
    [anon_sym_SLASH] = ACTIONS(2633),
    [anon_sym_SLASH_EQ] = ACTIONS(773),
    [anon_sym_AMP_AMP] = ACTIONS(773),
    [anon_sym_AMP_EQ] = ACTIONS(773),
    [anon_sym_PERCENT] = ACTIONS(2633),
    [anon_sym_PERCENT_EQ] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(2633),
    [anon_sym_CARET_EQ] = ACTIONS(773),
    [anon_sym_PLUS_EQ] = ACTIONS(773),
    [anon_sym_LT] = ACTIONS(2637),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_LT_LT_EQ] = ACTIONS(773),
    [anon_sym_LT_EQ] = ACTIONS(773),
    [anon_sym_EQ] = ACTIONS(2633),
    [anon_sym_EQ_EQ] = ACTIONS(773),
    [anon_sym_GT] = ACTIONS(2633),
    [anon_sym_GT_EQ] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_GT_GT_EQ] = ACTIONS(773),
    [anon_sym_PIPE] = ACTIONS(2633),
    [anon_sym_PIPE_EQ] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(773),
    [anon_sym_QMARK] = ACTIONS(773),
    [anon_sym_DOT_DOT] = ACTIONS(2633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(773),
    [anon_sym_as] = ACTIONS(773),
    [sym_line_comment] = ACTIONS(7),
  },
  [3109] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(3384),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_fn] = ACTIONS(7338),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7340),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [3110] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7342),
    [sym_line_comment] = ACTIONS(7),
  },
  [3111] = {
    [sym_parameters] = STATE(3380),
    [sym_type_arguments] = STATE(1340),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(783),
    [anon_sym_PLUS] = ACTIONS(785),
    [anon_sym_STAR] = ACTIONS(785),
    [anon_sym_COMMA] = ACTIONS(783),
    [anon_sym_AMP] = ACTIONS(785),
    [anon_sym_DASH] = ACTIONS(785),
    [anon_sym_DOT] = ACTIONS(785),
    [anon_sym_DASH_EQ] = ACTIONS(783),
    [anon_sym_BANG_EQ] = ACTIONS(783),
    [anon_sym_STAR_EQ] = ACTIONS(783),
    [anon_sym_SLASH] = ACTIONS(785),
    [anon_sym_SLASH_EQ] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_AMP_EQ] = ACTIONS(783),
    [anon_sym_PERCENT] = ACTIONS(785),
    [anon_sym_PERCENT_EQ] = ACTIONS(783),
    [anon_sym_CARET] = ACTIONS(785),
    [anon_sym_CARET_EQ] = ACTIONS(783),
    [anon_sym_PLUS_EQ] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(2637),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_LT_LT_EQ] = ACTIONS(783),
    [anon_sym_LT_EQ] = ACTIONS(783),
    [anon_sym_EQ] = ACTIONS(785),
    [anon_sym_EQ_EQ] = ACTIONS(783),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_GT_EQ] = ACTIONS(783),
    [anon_sym_GT_GT] = ACTIONS(785),
    [anon_sym_GT_GT_EQ] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PIPE_EQ] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_DOT_DOT] = ACTIONS(785),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(783),
    [anon_sym_as] = ACTIONS(783),
    [sym_line_comment] = ACTIONS(7),
  },
  [3112] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7316),
    [anon_sym_LPAREN] = ACTIONS(7316),
    [anon_sym_RPAREN] = ACTIONS(7316),
    [anon_sym_LBRACE] = ACTIONS(7316),
    [anon_sym_RBRACE] = ACTIONS(7316),
    [anon_sym_LBRACK] = ACTIONS(7316),
    [anon_sym_RBRACK] = ACTIONS(7316),
    [anon_sym_PLUS] = ACTIONS(7318),
    [anon_sym_STAR] = ACTIONS(7318),
    [anon_sym_COMMA] = ACTIONS(7316),
    [anon_sym_AMP] = ACTIONS(7318),
    [anon_sym_DASH] = ACTIONS(7318),
    [anon_sym_DOT] = ACTIONS(7318),
    [anon_sym_DASH_EQ] = ACTIONS(7316),
    [anon_sym_BANG_EQ] = ACTIONS(7316),
    [anon_sym_STAR_EQ] = ACTIONS(7316),
    [anon_sym_SLASH] = ACTIONS(7318),
    [anon_sym_SLASH_EQ] = ACTIONS(7316),
    [anon_sym_AMP_AMP] = ACTIONS(7316),
    [anon_sym_AMP_EQ] = ACTIONS(7316),
    [anon_sym_PERCENT] = ACTIONS(7318),
    [anon_sym_PERCENT_EQ] = ACTIONS(7316),
    [anon_sym_CARET] = ACTIONS(7318),
    [anon_sym_CARET_EQ] = ACTIONS(7316),
    [anon_sym_PLUS_EQ] = ACTIONS(7316),
    [anon_sym_LT] = ACTIONS(7318),
    [anon_sym_LT_LT] = ACTIONS(7318),
    [anon_sym_LT_LT_EQ] = ACTIONS(7316),
    [anon_sym_LT_EQ] = ACTIONS(7316),
    [anon_sym_EQ] = ACTIONS(7318),
    [anon_sym_EQ_EQ] = ACTIONS(7316),
    [anon_sym_GT] = ACTIONS(7318),
    [anon_sym_GT_EQ] = ACTIONS(7316),
    [anon_sym_GT_GT] = ACTIONS(7318),
    [anon_sym_GT_GT_EQ] = ACTIONS(7316),
    [anon_sym_PIPE] = ACTIONS(7318),
    [anon_sym_PIPE_EQ] = ACTIONS(7316),
    [anon_sym_PIPE_PIPE] = ACTIONS(7316),
    [anon_sym_QMARK] = ACTIONS(7316),
    [anon_sym_DOT_DOT] = ACTIONS(7318),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7316),
    [anon_sym_as] = ACTIONS(7316),
    [sym_line_comment] = ACTIONS(7),
  },
  [3113] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(3387),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [3114] = {
    [sym_else_tail] = STATE(3089),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6158),
    [anon_sym_LPAREN] = ACTIONS(6158),
    [anon_sym_RBRACE] = ACTIONS(6158),
    [anon_sym_LBRACK] = ACTIONS(6158),
    [anon_sym_PLUS] = ACTIONS(6160),
    [anon_sym_STAR] = ACTIONS(6160),
    [anon_sym_AMP] = ACTIONS(6160),
    [anon_sym_DASH] = ACTIONS(6160),
    [anon_sym_DOT] = ACTIONS(6160),
    [anon_sym_DASH_EQ] = ACTIONS(6158),
    [anon_sym_BANG_EQ] = ACTIONS(6158),
    [anon_sym_STAR_EQ] = ACTIONS(6158),
    [anon_sym_SLASH] = ACTIONS(6160),
    [anon_sym_SLASH_EQ] = ACTIONS(6158),
    [anon_sym_AMP_AMP] = ACTIONS(6158),
    [anon_sym_AMP_EQ] = ACTIONS(6158),
    [anon_sym_PERCENT] = ACTIONS(6160),
    [anon_sym_PERCENT_EQ] = ACTIONS(6158),
    [anon_sym_CARET] = ACTIONS(6160),
    [anon_sym_CARET_EQ] = ACTIONS(6158),
    [anon_sym_PLUS_EQ] = ACTIONS(6158),
    [anon_sym_LT] = ACTIONS(6160),
    [anon_sym_LT_LT] = ACTIONS(6160),
    [anon_sym_LT_LT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_EQ] = ACTIONS(6160),
    [anon_sym_EQ_EQ] = ACTIONS(6158),
    [anon_sym_GT] = ACTIONS(6160),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_GT_GT] = ACTIONS(6160),
    [anon_sym_GT_GT_EQ] = ACTIONS(6158),
    [anon_sym_PIPE] = ACTIONS(6160),
    [anon_sym_PIPE_EQ] = ACTIONS(6158),
    [anon_sym_PIPE_PIPE] = ACTIONS(6158),
    [anon_sym_QMARK] = ACTIONS(6158),
    [anon_sym_DOT_DOT] = ACTIONS(6160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6158),
    [anon_sym_as] = ACTIONS(6158),
    [anon_sym_else] = ACTIONS(4669),
    [sym_line_comment] = ACTIONS(7),
  },
  [3115] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(3388),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [3116] = {
    [sym_function_modifiers] = STATE(2098),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2611),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(2099),
    [sym_array_type] = STATE(2611),
    [sym_function_type] = STATE(2611),
    [sym_tuple_type] = STATE(2611),
    [sym_unit_type] = STATE(2611),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2611),
    [sym_reference_type] = STATE(2611),
    [sym_pointer_type] = STATE(2611),
    [sym_empty_type] = STATE(2611),
    [sym_dynamic_type] = STATE(2611),
    [sym_macro_invocation] = STATE(2611),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(2100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(4717),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(4719),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4721),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4723),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [3117] = {
    [sym_function_modifiers] = STATE(2098),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2616),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(2099),
    [sym_array_type] = STATE(2616),
    [sym_function_type] = STATE(2616),
    [sym_tuple_type] = STATE(2616),
    [sym_unit_type] = STATE(2616),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2616),
    [sym_reference_type] = STATE(2616),
    [sym_pointer_type] = STATE(2616),
    [sym_empty_type] = STATE(2616),
    [sym_abstract_type] = STATE(2617),
    [sym_dynamic_type] = STATE(2616),
    [sym_macro_invocation] = STATE(2616),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(2100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(4717),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(4719),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4721),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4723),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [3118] = {
    [sym_function_modifiers] = STATE(2098),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2618),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(2099),
    [sym_array_type] = STATE(2618),
    [sym_function_type] = STATE(2618),
    [sym_tuple_type] = STATE(2618),
    [sym_unit_type] = STATE(2618),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2618),
    [sym_reference_type] = STATE(2618),
    [sym_pointer_type] = STATE(2618),
    [sym_empty_type] = STATE(2618),
    [sym_abstract_type] = STATE(2619),
    [sym_dynamic_type] = STATE(2618),
    [sym_macro_invocation] = STATE(2618),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(2100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(4717),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(4719),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4721),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4723),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [3119] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2988),
    [anon_sym_RBRACK] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(5758),
    [anon_sym_STAR] = ACTIONS(5758),
    [anon_sym_COMMA] = ACTIONS(2988),
    [anon_sym_AMP] = ACTIONS(5758),
    [anon_sym_DASH] = ACTIONS(5758),
    [anon_sym_DOT] = ACTIONS(5758),
    [anon_sym_DASH_EQ] = ACTIONS(2988),
    [anon_sym_DASH_GT] = ACTIONS(7344),
    [anon_sym_BANG_EQ] = ACTIONS(2988),
    [anon_sym_STAR_EQ] = ACTIONS(2988),
    [anon_sym_SLASH] = ACTIONS(5758),
    [anon_sym_SLASH_EQ] = ACTIONS(2988),
    [anon_sym_AMP_AMP] = ACTIONS(2988),
    [anon_sym_AMP_EQ] = ACTIONS(2988),
    [anon_sym_PERCENT] = ACTIONS(5758),
    [anon_sym_PERCENT_EQ] = ACTIONS(2988),
    [anon_sym_CARET] = ACTIONS(5758),
    [anon_sym_CARET_EQ] = ACTIONS(2988),
    [anon_sym_PLUS_EQ] = ACTIONS(2988),
    [anon_sym_LT] = ACTIONS(5758),
    [anon_sym_LT_LT] = ACTIONS(5758),
    [anon_sym_LT_LT_EQ] = ACTIONS(2988),
    [anon_sym_LT_EQ] = ACTIONS(2988),
    [anon_sym_EQ] = ACTIONS(5758),
    [anon_sym_EQ_EQ] = ACTIONS(2988),
    [anon_sym_GT] = ACTIONS(5758),
    [anon_sym_GT_EQ] = ACTIONS(2988),
    [anon_sym_GT_GT] = ACTIONS(5758),
    [anon_sym_GT_GT_EQ] = ACTIONS(2988),
    [anon_sym_PIPE] = ACTIONS(5758),
    [anon_sym_PIPE_EQ] = ACTIONS(2988),
    [anon_sym_PIPE_PIPE] = ACTIONS(2988),
    [anon_sym_QMARK] = ACTIONS(2988),
    [anon_sym_DOT_DOT] = ACTIONS(5758),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2988),
    [anon_sym_as] = ACTIONS(2988),
    [sym_line_comment] = ACTIONS(7),
  },
  [3120] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2992),
    [anon_sym_LBRACK] = ACTIONS(2992),
    [anon_sym_RBRACK] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(5762),
    [anon_sym_STAR] = ACTIONS(5762),
    [anon_sym_COMMA] = ACTIONS(2992),
    [anon_sym_AMP] = ACTIONS(5762),
    [anon_sym_DASH] = ACTIONS(5762),
    [anon_sym_DOT] = ACTIONS(5762),
    [anon_sym_DASH_EQ] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(7346),
    [anon_sym_BANG_EQ] = ACTIONS(2992),
    [anon_sym_STAR_EQ] = ACTIONS(2992),
    [anon_sym_SLASH] = ACTIONS(5762),
    [anon_sym_SLASH_EQ] = ACTIONS(2992),
    [anon_sym_AMP_AMP] = ACTIONS(2992),
    [anon_sym_AMP_EQ] = ACTIONS(2992),
    [anon_sym_PERCENT] = ACTIONS(5762),
    [anon_sym_PERCENT_EQ] = ACTIONS(2992),
    [anon_sym_CARET] = ACTIONS(5762),
    [anon_sym_CARET_EQ] = ACTIONS(2992),
    [anon_sym_PLUS_EQ] = ACTIONS(2992),
    [anon_sym_LT] = ACTIONS(5762),
    [anon_sym_LT_LT] = ACTIONS(5762),
    [anon_sym_LT_LT_EQ] = ACTIONS(2992),
    [anon_sym_LT_EQ] = ACTIONS(2992),
    [anon_sym_EQ] = ACTIONS(5762),
    [anon_sym_EQ_EQ] = ACTIONS(2992),
    [anon_sym_GT] = ACTIONS(5762),
    [anon_sym_GT_EQ] = ACTIONS(2992),
    [anon_sym_GT_GT] = ACTIONS(5762),
    [anon_sym_GT_GT_EQ] = ACTIONS(2992),
    [anon_sym_PIPE] = ACTIONS(5762),
    [anon_sym_PIPE_EQ] = ACTIONS(2992),
    [anon_sym_PIPE_PIPE] = ACTIONS(2992),
    [anon_sym_QMARK] = ACTIONS(2992),
    [anon_sym_DOT_DOT] = ACTIONS(5762),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2992),
    [anon_sym_as] = ACTIONS(2992),
    [sym_line_comment] = ACTIONS(7),
  },
  [3121] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7348),
    [anon_sym_RBRACK] = ACTIONS(7348),
    [anon_sym_COMMA] = ACTIONS(7348),
    [sym_line_comment] = ACTIONS(7),
  },
  [3122] = {
    [sym_meta_item] = STATE(2685),
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(727),
  },
  [3123] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(3042),
    [anon_sym_PLUS] = ACTIONS(1688),
    [anon_sym_COMMA] = ACTIONS(3042),
    [sym_line_comment] = ACTIONS(7),
  },
  [3124] = {
    [sym_parameters] = STATE(800),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_RPAREN] = ACTIONS(3054),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_COMMA] = ACTIONS(3054),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_BANG] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [3125] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7226),
    [anon_sym_LPAREN] = ACTIONS(7226),
    [anon_sym_RPAREN] = ACTIONS(7226),
    [anon_sym_LBRACE] = ACTIONS(7226),
    [anon_sym_RBRACE] = ACTIONS(7226),
    [anon_sym_RBRACK] = ACTIONS(7226),
    [anon_sym_COLON] = ACTIONS(7226),
    [anon_sym_PLUS] = ACTIONS(7226),
    [anon_sym_COMMA] = ACTIONS(7226),
    [anon_sym_EQ] = ACTIONS(7226),
    [anon_sym_GT] = ACTIONS(7226),
    [anon_sym_PIPE] = ACTIONS(7226),
    [anon_sym_as] = ACTIONS(7226),
    [anon_sym_where] = ACTIONS(7226),
    [sym_line_comment] = ACTIONS(7),
  },
  [3126] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7350),
    [anon_sym_COMMA] = ACTIONS(7350),
    [sym_line_comment] = ACTIONS(7),
  },
  [3127] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5267),
  },
  [3128] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5269),
  },
  [3129] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6422),
    [anon_sym_macro_rules_BANG] = ACTIONS(6422),
    [anon_sym_RBRACE] = ACTIONS(6422),
    [anon_sym_COMMA] = ACTIONS(6422),
    [anon_sym_POUND] = ACTIONS(6422),
    [anon_sym_EQ] = ACTIONS(6422),
    [anon_sym_const] = ACTIONS(6424),
    [anon_sym_default] = ACTIONS(6424),
    [anon_sym_enum] = ACTIONS(6424),
    [anon_sym_fn] = ACTIONS(6424),
    [anon_sym_impl] = ACTIONS(6424),
    [anon_sym_let] = ACTIONS(6424),
    [anon_sym_mod] = ACTIONS(6424),
    [anon_sym_pub] = ACTIONS(6424),
    [anon_sym_static] = ACTIONS(6424),
    [anon_sym_struct] = ACTIONS(6424),
    [anon_sym_trait] = ACTIONS(6424),
    [anon_sym_type] = ACTIONS(6424),
    [anon_sym_union] = ACTIONS(6424),
    [anon_sym_unsafe] = ACTIONS(6424),
    [anon_sym_use] = ACTIONS(6424),
    [anon_sym_extern] = ACTIONS(6424),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6424),
  },
  [3130] = {
    [sym_attribute_item] = STATE(2391),
    [sym_field_declaration] = STATE(2390),
    [sym_visibility_modifier] = STATE(1069),
    [aux_sym_enum_variant_list_repeat1] = STATE(2391),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7352),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_pub] = ACTIONS(1940),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2132),
  },
  [3131] = {
    [aux_sym_field_declaration_list_repeat1] = STATE(2393),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7352),
    [anon_sym_COMMA] = ACTIONS(7354),
    [sym_line_comment] = ACTIONS(7),
  },
  [3132] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(7356),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(3495),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(7356),
    [anon_sym_AMP] = ACTIONS(3499),
    [anon_sym_DASH] = ACTIONS(3495),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(3501),
    [anon_sym_BANG_EQ] = ACTIONS(3503),
    [anon_sym_STAR_EQ] = ACTIONS(3501),
    [anon_sym_SLASH] = ACTIONS(3497),
    [anon_sym_SLASH_EQ] = ACTIONS(3501),
    [anon_sym_AMP_AMP] = ACTIONS(3505),
    [anon_sym_AMP_EQ] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_PERCENT_EQ] = ACTIONS(3501),
    [anon_sym_CARET] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(3501),
    [anon_sym_PLUS_EQ] = ACTIONS(3501),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_LT_LT] = ACTIONS(3511),
    [anon_sym_LT_LT_EQ] = ACTIONS(3501),
    [anon_sym_LT_EQ] = ACTIONS(3503),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_EQ_EQ] = ACTIONS(3503),
    [anon_sym_GT] = ACTIONS(3509),
    [anon_sym_GT_EQ] = ACTIONS(3503),
    [anon_sym_GT_GT] = ACTIONS(3511),
    [anon_sym_GT_GT_EQ] = ACTIONS(3501),
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_PIPE_EQ] = ACTIONS(3501),
    [anon_sym_PIPE_PIPE] = ACTIONS(3517),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(3519),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3521),
    [anon_sym_as] = ACTIONS(3523),
    [sym_line_comment] = ACTIONS(7),
  },
  [3133] = {
    [sym_raw_string_literal] = ACTIONS(7358),
    [sym_float_literal] = ACTIONS(7358),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(7358),
    [anon_sym_SEMI] = ACTIONS(7358),
    [anon_sym_macro_rules_BANG] = ACTIONS(7358),
    [anon_sym_LPAREN] = ACTIONS(7358),
    [anon_sym_LBRACE] = ACTIONS(7358),
    [anon_sym_RBRACE] = ACTIONS(7358),
    [anon_sym_LBRACK] = ACTIONS(7358),
    [anon_sym_STAR] = ACTIONS(7358),
    [anon_sym_u8] = ACTIONS(7360),
    [anon_sym_i8] = ACTIONS(7360),
    [anon_sym_u16] = ACTIONS(7360),
    [anon_sym_i16] = ACTIONS(7360),
    [anon_sym_u32] = ACTIONS(7360),
    [anon_sym_i32] = ACTIONS(7360),
    [anon_sym_u64] = ACTIONS(7360),
    [anon_sym_i64] = ACTIONS(7360),
    [anon_sym_u128] = ACTIONS(7360),
    [anon_sym_i128] = ACTIONS(7360),
    [anon_sym_isize] = ACTIONS(7360),
    [anon_sym_usize] = ACTIONS(7360),
    [anon_sym_f32] = ACTIONS(7360),
    [anon_sym_f64] = ACTIONS(7360),
    [anon_sym_bool] = ACTIONS(7360),
    [anon_sym_str] = ACTIONS(7360),
    [anon_sym_char] = ACTIONS(7360),
    [anon_sym_AMP] = ACTIONS(7358),
    [anon_sym_DASH] = ACTIONS(7358),
    [anon_sym_COLON_COLON] = ACTIONS(7358),
    [anon_sym_BANG] = ACTIONS(7358),
    [anon_sym_POUND] = ACTIONS(7358),
    [anon_sym_LT] = ACTIONS(7358),
    [anon_sym_PIPE] = ACTIONS(7358),
    [anon_sym_SQUOTE] = ACTIONS(7360),
    [anon_sym_DOT_DOT] = ACTIONS(7358),
    [anon_sym_break] = ACTIONS(7360),
    [anon_sym_const] = ACTIONS(7360),
    [anon_sym_continue] = ACTIONS(7360),
    [anon_sym_default] = ACTIONS(7360),
    [anon_sym_enum] = ACTIONS(7360),
    [anon_sym_fn] = ACTIONS(7360),
    [anon_sym_for] = ACTIONS(7360),
    [anon_sym_if] = ACTIONS(7360),
    [anon_sym_impl] = ACTIONS(7360),
    [anon_sym_let] = ACTIONS(7360),
    [anon_sym_loop] = ACTIONS(7360),
    [anon_sym_match] = ACTIONS(7360),
    [anon_sym_mod] = ACTIONS(7360),
    [anon_sym_pub] = ACTIONS(7360),
    [anon_sym_return] = ACTIONS(7360),
    [anon_sym_static] = ACTIONS(7360),
    [anon_sym_struct] = ACTIONS(7360),
    [anon_sym_trait] = ACTIONS(7360),
    [anon_sym_type] = ACTIONS(7360),
    [anon_sym_union] = ACTIONS(7360),
    [anon_sym_unsafe] = ACTIONS(7360),
    [anon_sym_use] = ACTIONS(7360),
    [anon_sym_while] = ACTIONS(7360),
    [anon_sym_extern] = ACTIONS(7360),
    [anon_sym_move] = ACTIONS(7360),
    [sym_integer_literal] = ACTIONS(7358),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7358),
    [sym_char_literal] = ACTIONS(7358),
    [anon_sym_true] = ACTIONS(7360),
    [anon_sym_false] = ACTIONS(7360),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7360),
    [sym_self] = ACTIONS(7360),
    [sym_super] = ACTIONS(7360),
    [sym_crate] = ACTIONS(7360),
    [sym_metavariable] = ACTIONS(7358),
  },
  [3134] = {
    [sym_function_modifiers] = STATE(1603),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2156),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2219),
    [sym_array_type] = STATE(2156),
    [sym_function_type] = STATE(2156),
    [sym_tuple_type] = STATE(2156),
    [sym_unit_type] = STATE(2156),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2156),
    [sym_reference_type] = STATE(2156),
    [sym_pointer_type] = STATE(2156),
    [sym_empty_type] = STATE(2156),
    [sym_abstract_type] = STATE(2157),
    [sym_dynamic_type] = STATE(2156),
    [sym_macro_invocation] = STATE(2156),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1606),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3135),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3137),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3139),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3143),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3135] = {
    [sym_function_modifiers] = STATE(1603),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2158),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2219),
    [sym_array_type] = STATE(2158),
    [sym_function_type] = STATE(2158),
    [sym_tuple_type] = STATE(2158),
    [sym_unit_type] = STATE(2158),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2158),
    [sym_reference_type] = STATE(2158),
    [sym_pointer_type] = STATE(2158),
    [sym_empty_type] = STATE(2158),
    [sym_abstract_type] = STATE(2159),
    [sym_dynamic_type] = STATE(2158),
    [sym_macro_invocation] = STATE(2158),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1606),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3135),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3137),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3139),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3143),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3136] = {
    [sym_function_modifiers] = STATE(2233),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(862),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2236),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(4957),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(4959),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4963),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4967),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3137] = {
    [sym_function_modifiers] = STATE(2233),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2744),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2236),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(4957),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(4959),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4963),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4967),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3138] = {
    [sym_function_modifiers] = STATE(2233),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1479),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2744),
    [sym_array_type] = STATE(1479),
    [sym_function_type] = STATE(1479),
    [sym_tuple_type] = STATE(1479),
    [sym_unit_type] = STATE(1479),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1479),
    [sym_reference_type] = STATE(1479),
    [sym_pointer_type] = STATE(1479),
    [sym_empty_type] = STATE(1479),
    [sym_dynamic_type] = STATE(1479),
    [sym_macro_invocation] = STATE(1479),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2236),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(4957),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(4959),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4963),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4967),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3139] = {
    [sym_function_modifiers] = STATE(2233),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1499),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2744),
    [sym_array_type] = STATE(1499),
    [sym_function_type] = STATE(1499),
    [sym_tuple_type] = STATE(1499),
    [sym_unit_type] = STATE(1499),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1499),
    [sym_reference_type] = STATE(1499),
    [sym_pointer_type] = STATE(1499),
    [sym_empty_type] = STATE(1499),
    [sym_abstract_type] = STATE(1500),
    [sym_dynamic_type] = STATE(1499),
    [sym_macro_invocation] = STATE(1499),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2236),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(4957),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(4959),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4963),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4967),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3140] = {
    [sym_function_modifiers] = STATE(2233),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1525),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2744),
    [sym_array_type] = STATE(1525),
    [sym_function_type] = STATE(1525),
    [sym_tuple_type] = STATE(1525),
    [sym_unit_type] = STATE(1525),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1525),
    [sym_reference_type] = STATE(1525),
    [sym_pointer_type] = STATE(1525),
    [sym_empty_type] = STATE(1525),
    [sym_abstract_type] = STATE(1526),
    [sym_dynamic_type] = STATE(1525),
    [sym_macro_invocation] = STATE(1525),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2236),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(4957),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(4959),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4963),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4967),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3141] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_COMMA] = ACTIONS(2988),
    [anon_sym_DASH_GT] = ACTIONS(7362),
    [sym_line_comment] = ACTIONS(7),
  },
  [3142] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_COMMA] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(7364),
    [sym_line_comment] = ACTIONS(7),
  },
  [3143] = {
    [aux_sym_trait_bounds_repeat1] = STATE(3143),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(6476),
    [anon_sym_PLUS] = ACTIONS(7366),
    [anon_sym_COMMA] = ACTIONS(6476),
    [sym_line_comment] = ACTIONS(7),
  },
  [3144] = {
    [sym_raw_string_literal] = ACTIONS(7369),
    [sym_float_literal] = ACTIONS(7369),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(7369),
    [anon_sym_SEMI] = ACTIONS(7369),
    [anon_sym_macro_rules_BANG] = ACTIONS(7369),
    [anon_sym_LPAREN] = ACTIONS(7369),
    [anon_sym_LBRACE] = ACTIONS(7369),
    [anon_sym_RBRACE] = ACTIONS(7369),
    [anon_sym_LBRACK] = ACTIONS(7369),
    [anon_sym_STAR] = ACTIONS(7369),
    [anon_sym_u8] = ACTIONS(7371),
    [anon_sym_i8] = ACTIONS(7371),
    [anon_sym_u16] = ACTIONS(7371),
    [anon_sym_i16] = ACTIONS(7371),
    [anon_sym_u32] = ACTIONS(7371),
    [anon_sym_i32] = ACTIONS(7371),
    [anon_sym_u64] = ACTIONS(7371),
    [anon_sym_i64] = ACTIONS(7371),
    [anon_sym_u128] = ACTIONS(7371),
    [anon_sym_i128] = ACTIONS(7371),
    [anon_sym_isize] = ACTIONS(7371),
    [anon_sym_usize] = ACTIONS(7371),
    [anon_sym_f32] = ACTIONS(7371),
    [anon_sym_f64] = ACTIONS(7371),
    [anon_sym_bool] = ACTIONS(7371),
    [anon_sym_str] = ACTIONS(7371),
    [anon_sym_char] = ACTIONS(7371),
    [anon_sym_AMP] = ACTIONS(7369),
    [anon_sym_DASH] = ACTIONS(7369),
    [anon_sym_COLON_COLON] = ACTIONS(7369),
    [anon_sym_BANG] = ACTIONS(7369),
    [anon_sym_POUND] = ACTIONS(7369),
    [anon_sym_LT] = ACTIONS(7369),
    [anon_sym_PIPE] = ACTIONS(7369),
    [anon_sym_SQUOTE] = ACTIONS(7371),
    [anon_sym_DOT_DOT] = ACTIONS(7369),
    [anon_sym_break] = ACTIONS(7371),
    [anon_sym_const] = ACTIONS(7371),
    [anon_sym_continue] = ACTIONS(7371),
    [anon_sym_default] = ACTIONS(7371),
    [anon_sym_enum] = ACTIONS(7371),
    [anon_sym_fn] = ACTIONS(7371),
    [anon_sym_for] = ACTIONS(7371),
    [anon_sym_if] = ACTIONS(7371),
    [anon_sym_impl] = ACTIONS(7371),
    [anon_sym_let] = ACTIONS(7371),
    [anon_sym_loop] = ACTIONS(7371),
    [anon_sym_match] = ACTIONS(7371),
    [anon_sym_mod] = ACTIONS(7371),
    [anon_sym_pub] = ACTIONS(7371),
    [anon_sym_return] = ACTIONS(7371),
    [anon_sym_static] = ACTIONS(7371),
    [anon_sym_struct] = ACTIONS(7371),
    [anon_sym_trait] = ACTIONS(7371),
    [anon_sym_type] = ACTIONS(7371),
    [anon_sym_union] = ACTIONS(7371),
    [anon_sym_unsafe] = ACTIONS(7371),
    [anon_sym_use] = ACTIONS(7371),
    [anon_sym_while] = ACTIONS(7371),
    [anon_sym_extern] = ACTIONS(7371),
    [anon_sym_move] = ACTIONS(7371),
    [sym_integer_literal] = ACTIONS(7369),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7369),
    [sym_char_literal] = ACTIONS(7369),
    [anon_sym_true] = ACTIONS(7371),
    [anon_sym_false] = ACTIONS(7371),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7371),
    [sym_self] = ACTIONS(7371),
    [sym_super] = ACTIONS(7371),
    [sym_crate] = ACTIONS(7371),
    [sym_metavariable] = ACTIONS(7369),
  },
  [3145] = {
    [sym_raw_string_literal] = ACTIONS(7373),
    [sym_float_literal] = ACTIONS(7373),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(7373),
    [anon_sym_SEMI] = ACTIONS(7373),
    [anon_sym_macro_rules_BANG] = ACTIONS(7373),
    [anon_sym_LPAREN] = ACTIONS(7373),
    [anon_sym_LBRACE] = ACTIONS(7373),
    [anon_sym_RBRACE] = ACTIONS(7373),
    [anon_sym_LBRACK] = ACTIONS(7373),
    [anon_sym_STAR] = ACTIONS(7373),
    [anon_sym_u8] = ACTIONS(7375),
    [anon_sym_i8] = ACTIONS(7375),
    [anon_sym_u16] = ACTIONS(7375),
    [anon_sym_i16] = ACTIONS(7375),
    [anon_sym_u32] = ACTIONS(7375),
    [anon_sym_i32] = ACTIONS(7375),
    [anon_sym_u64] = ACTIONS(7375),
    [anon_sym_i64] = ACTIONS(7375),
    [anon_sym_u128] = ACTIONS(7375),
    [anon_sym_i128] = ACTIONS(7375),
    [anon_sym_isize] = ACTIONS(7375),
    [anon_sym_usize] = ACTIONS(7375),
    [anon_sym_f32] = ACTIONS(7375),
    [anon_sym_f64] = ACTIONS(7375),
    [anon_sym_bool] = ACTIONS(7375),
    [anon_sym_str] = ACTIONS(7375),
    [anon_sym_char] = ACTIONS(7375),
    [anon_sym_AMP] = ACTIONS(7373),
    [anon_sym_DASH] = ACTIONS(7373),
    [anon_sym_COLON_COLON] = ACTIONS(7373),
    [anon_sym_BANG] = ACTIONS(7373),
    [anon_sym_POUND] = ACTIONS(7373),
    [anon_sym_LT] = ACTIONS(7373),
    [anon_sym_PIPE] = ACTIONS(7373),
    [anon_sym_SQUOTE] = ACTIONS(7375),
    [anon_sym_DOT_DOT] = ACTIONS(7373),
    [anon_sym_break] = ACTIONS(7375),
    [anon_sym_const] = ACTIONS(7375),
    [anon_sym_continue] = ACTIONS(7375),
    [anon_sym_default] = ACTIONS(7375),
    [anon_sym_enum] = ACTIONS(7375),
    [anon_sym_fn] = ACTIONS(7375),
    [anon_sym_for] = ACTIONS(7375),
    [anon_sym_if] = ACTIONS(7375),
    [anon_sym_impl] = ACTIONS(7375),
    [anon_sym_let] = ACTIONS(7375),
    [anon_sym_loop] = ACTIONS(7375),
    [anon_sym_match] = ACTIONS(7375),
    [anon_sym_mod] = ACTIONS(7375),
    [anon_sym_pub] = ACTIONS(7375),
    [anon_sym_return] = ACTIONS(7375),
    [anon_sym_static] = ACTIONS(7375),
    [anon_sym_struct] = ACTIONS(7375),
    [anon_sym_trait] = ACTIONS(7375),
    [anon_sym_type] = ACTIONS(7375),
    [anon_sym_union] = ACTIONS(7375),
    [anon_sym_unsafe] = ACTIONS(7375),
    [anon_sym_use] = ACTIONS(7375),
    [anon_sym_while] = ACTIONS(7375),
    [anon_sym_extern] = ACTIONS(7375),
    [anon_sym_move] = ACTIONS(7375),
    [sym_integer_literal] = ACTIONS(7373),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7373),
    [sym_char_literal] = ACTIONS(7373),
    [anon_sym_true] = ACTIONS(7375),
    [anon_sym_false] = ACTIONS(7375),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7375),
    [sym_self] = ACTIONS(7375),
    [sym_super] = ACTIONS(7375),
    [sym_crate] = ACTIONS(7375),
    [sym_metavariable] = ACTIONS(7373),
  },
  [3146] = {
    [sym_function_modifiers] = STATE(1624),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2156),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1626),
    [sym_array_type] = STATE(2156),
    [sym_function_type] = STATE(2156),
    [sym_tuple_type] = STATE(2156),
    [sym_unit_type] = STATE(2156),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2156),
    [sym_reference_type] = STATE(2156),
    [sym_pointer_type] = STATE(2156),
    [sym_empty_type] = STATE(2156),
    [sym_abstract_type] = STATE(2157),
    [sym_dynamic_type] = STATE(2156),
    [sym_macro_invocation] = STATE(2156),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1628),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3169),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3171),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3173),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3175),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3147] = {
    [sym_function_modifiers] = STATE(1624),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2158),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1626),
    [sym_array_type] = STATE(2158),
    [sym_function_type] = STATE(2158),
    [sym_tuple_type] = STATE(2158),
    [sym_unit_type] = STATE(2158),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2158),
    [sym_reference_type] = STATE(2158),
    [sym_pointer_type] = STATE(2158),
    [sym_empty_type] = STATE(2158),
    [sym_abstract_type] = STATE(2159),
    [sym_dynamic_type] = STATE(2158),
    [sym_macro_invocation] = STATE(2158),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1628),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3169),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3171),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3173),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3175),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3148] = {
    [sym_function_modifiers] = STATE(2770),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(821),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(3151),
    [sym_array_type] = STATE(821),
    [sym_function_type] = STATE(821),
    [sym_tuple_type] = STATE(821),
    [sym_unit_type] = STATE(821),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(821),
    [sym_reference_type] = STATE(821),
    [sym_pointer_type] = STATE(821),
    [sym_empty_type] = STATE(821),
    [sym_dynamic_type] = STATE(821),
    [sym_macro_invocation] = STATE(821),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2773),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(6144),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(6146),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6150),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6154),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3149] = {
    [sym_function_modifiers] = STATE(2770),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(3151),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2773),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(6144),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(6146),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6150),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6154),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3150] = {
    [sym_function_modifiers] = STATE(2770),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(3151),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2773),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(7377),
    [anon_sym_STAR] = ACTIONS(6144),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(6146),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6150),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(7379),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6154),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3151] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7377),
    [sym_line_comment] = ACTIONS(7),
  },
  [3152] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1760),
    [anon_sym_LBRACE] = ACTIONS(1760),
    [anon_sym_PLUS] = ACTIONS(1760),
    [anon_sym_COMMA] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(7381),
    [sym_line_comment] = ACTIONS(7),
  },
  [3153] = {
    [sym_function_modifiers] = STATE(2770),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2417),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(3151),
    [sym_array_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_tuple_type] = STATE(2417),
    [sym_unit_type] = STATE(2417),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2417),
    [sym_reference_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_empty_type] = STATE(2417),
    [sym_dynamic_type] = STATE(2417),
    [sym_macro_invocation] = STATE(2417),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2773),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(6144),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(6146),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6150),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6154),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3154] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1794),
    [anon_sym_LBRACE] = ACTIONS(1794),
    [anon_sym_PLUS] = ACTIONS(1794),
    [anon_sym_COMMA] = ACTIONS(1794),
    [anon_sym_DASH_GT] = ACTIONS(7383),
    [sym_line_comment] = ACTIONS(7),
  },
  [3155] = {
    [sym_parameters] = STATE(3400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [3156] = {
    [sym_parameters] = STATE(3401),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [3157] = {
    [sym_parameters] = STATE(3400),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [3158] = {
    [sym_function_modifiers] = STATE(2770),
    [sym_higher_ranked_trait_bound] = STATE(2418),
    [sym_removed_trait_bound] = STATE(2418),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2419),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2419),
    [sym_array_type] = STATE(2419),
    [sym_function_type] = STATE(2419),
    [sym_tuple_type] = STATE(2419),
    [sym_unit_type] = STATE(2419),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2419),
    [sym_reference_type] = STATE(2419),
    [sym_pointer_type] = STATE(2419),
    [sym_empty_type] = STATE(2419),
    [sym_dynamic_type] = STATE(2419),
    [sym_macro_invocation] = STATE(2419),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2773),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(6144),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(6146),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_QMARK] = ACTIONS(6148),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6150),
    [anon_sym_for] = ACTIONS(6152),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6154),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3159] = {
    [aux_sym_trait_bounds_repeat1] = STATE(3402),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5344),
    [anon_sym_LBRACE] = ACTIONS(5344),
    [anon_sym_PLUS] = ACTIONS(6891),
    [anon_sym_COMMA] = ACTIONS(5344),
    [sym_line_comment] = ACTIONS(7),
  },
  [3160] = {
    [sym_function_modifiers] = STATE(2770),
    [sym_higher_ranked_trait_bound] = STATE(2418),
    [sym_removed_trait_bound] = STATE(2418),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2419),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2419),
    [sym_array_type] = STATE(2419),
    [sym_function_type] = STATE(2419),
    [sym_tuple_type] = STATE(2419),
    [sym_unit_type] = STATE(2419),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2419),
    [sym_reference_type] = STATE(2419),
    [sym_pointer_type] = STATE(2419),
    [sym_empty_type] = STATE(2419),
    [sym_dynamic_type] = STATE(2419),
    [sym_macro_invocation] = STATE(2419),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2773),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(6144),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(6146),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_QMARK] = ACTIONS(6148),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6150),
    [anon_sym_for] = ACTIONS(6152),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6154),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3161] = {
    [sym_where_predicate] = STATE(2237),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1631),
    [sym_generic_type] = STATE(1632),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_reference_type] = STATE(1631),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1633),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(1948),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3177),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [3162] = {
    [sym_function_modifiers] = STATE(1655),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2156),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2270),
    [sym_array_type] = STATE(2156),
    [sym_function_type] = STATE(2156),
    [sym_tuple_type] = STATE(2156),
    [sym_unit_type] = STATE(2156),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2156),
    [sym_reference_type] = STATE(2156),
    [sym_pointer_type] = STATE(2156),
    [sym_empty_type] = STATE(2156),
    [sym_abstract_type] = STATE(2157),
    [sym_dynamic_type] = STATE(2156),
    [sym_macro_invocation] = STATE(2156),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1658),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3205),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3207),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3211),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3215),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3163] = {
    [sym_function_modifiers] = STATE(1655),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2158),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2270),
    [sym_array_type] = STATE(2158),
    [sym_function_type] = STATE(2158),
    [sym_tuple_type] = STATE(2158),
    [sym_unit_type] = STATE(2158),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2158),
    [sym_reference_type] = STATE(2158),
    [sym_pointer_type] = STATE(2158),
    [sym_empty_type] = STATE(2158),
    [sym_abstract_type] = STATE(2159),
    [sym_dynamic_type] = STATE(2158),
    [sym_macro_invocation] = STATE(2158),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1658),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3205),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3207),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3211),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3215),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3164] = {
    [sym_raw_string_literal] = ACTIONS(7385),
    [sym_float_literal] = ACTIONS(7385),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(7385),
    [anon_sym_SEMI] = ACTIONS(7385),
    [anon_sym_macro_rules_BANG] = ACTIONS(7385),
    [anon_sym_LPAREN] = ACTIONS(7385),
    [anon_sym_LBRACE] = ACTIONS(7385),
    [anon_sym_RBRACE] = ACTIONS(7385),
    [anon_sym_LBRACK] = ACTIONS(7385),
    [anon_sym_STAR] = ACTIONS(7385),
    [anon_sym_u8] = ACTIONS(7387),
    [anon_sym_i8] = ACTIONS(7387),
    [anon_sym_u16] = ACTIONS(7387),
    [anon_sym_i16] = ACTIONS(7387),
    [anon_sym_u32] = ACTIONS(7387),
    [anon_sym_i32] = ACTIONS(7387),
    [anon_sym_u64] = ACTIONS(7387),
    [anon_sym_i64] = ACTIONS(7387),
    [anon_sym_u128] = ACTIONS(7387),
    [anon_sym_i128] = ACTIONS(7387),
    [anon_sym_isize] = ACTIONS(7387),
    [anon_sym_usize] = ACTIONS(7387),
    [anon_sym_f32] = ACTIONS(7387),
    [anon_sym_f64] = ACTIONS(7387),
    [anon_sym_bool] = ACTIONS(7387),
    [anon_sym_str] = ACTIONS(7387),
    [anon_sym_char] = ACTIONS(7387),
    [anon_sym_AMP] = ACTIONS(7385),
    [anon_sym_DASH] = ACTIONS(7385),
    [anon_sym_COLON_COLON] = ACTIONS(7385),
    [anon_sym_BANG] = ACTIONS(7385),
    [anon_sym_POUND] = ACTIONS(7385),
    [anon_sym_LT] = ACTIONS(7385),
    [anon_sym_PIPE] = ACTIONS(7385),
    [anon_sym_SQUOTE] = ACTIONS(7387),
    [anon_sym_DOT_DOT] = ACTIONS(7385),
    [anon_sym_break] = ACTIONS(7387),
    [anon_sym_const] = ACTIONS(7387),
    [anon_sym_continue] = ACTIONS(7387),
    [anon_sym_default] = ACTIONS(7387),
    [anon_sym_enum] = ACTIONS(7387),
    [anon_sym_fn] = ACTIONS(7387),
    [anon_sym_for] = ACTIONS(7387),
    [anon_sym_if] = ACTIONS(7387),
    [anon_sym_impl] = ACTIONS(7387),
    [anon_sym_let] = ACTIONS(7387),
    [anon_sym_loop] = ACTIONS(7387),
    [anon_sym_match] = ACTIONS(7387),
    [anon_sym_mod] = ACTIONS(7387),
    [anon_sym_pub] = ACTIONS(7387),
    [anon_sym_return] = ACTIONS(7387),
    [anon_sym_static] = ACTIONS(7387),
    [anon_sym_struct] = ACTIONS(7387),
    [anon_sym_trait] = ACTIONS(7387),
    [anon_sym_type] = ACTIONS(7387),
    [anon_sym_union] = ACTIONS(7387),
    [anon_sym_unsafe] = ACTIONS(7387),
    [anon_sym_use] = ACTIONS(7387),
    [anon_sym_while] = ACTIONS(7387),
    [anon_sym_extern] = ACTIONS(7387),
    [anon_sym_move] = ACTIONS(7387),
    [sym_integer_literal] = ACTIONS(7385),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7385),
    [sym_char_literal] = ACTIONS(7385),
    [anon_sym_true] = ACTIONS(7387),
    [anon_sym_false] = ACTIONS(7387),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7387),
    [sym_self] = ACTIONS(7387),
    [sym_super] = ACTIONS(7387),
    [sym_crate] = ACTIONS(7387),
    [sym_metavariable] = ACTIONS(7385),
  },
  [3165] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(6016),
    [anon_sym_PIPE] = ACTIONS(6016),
    [anon_sym_if] = ACTIONS(6016),
    [sym_line_comment] = ACTIONS(7),
  },
  [3166] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(6031),
    [anon_sym_PIPE] = ACTIONS(6031),
    [anon_sym_if] = ACTIONS(6031),
    [sym_line_comment] = ACTIONS(7),
  },
  [3167] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(1540),
    [sym_tuple_pattern] = STATE(1540),
    [sym_tuple_struct_pattern] = STATE(1540),
    [sym_struct_pattern] = STATE(1540),
    [sym_remaining_field_pattern] = STATE(1540),
    [sym_mut_pattern] = STATE(1540),
    [sym_ref_pattern] = STATE(1540),
    [sym_captured_pattern] = STATE(1540),
    [sym_reference_pattern] = STATE(1540),
    [sym__literal] = STATE(1540),
    [sym_string_literal] = STATE(1540),
    [sym_boolean_literal] = STATE(1540),
    [sym_raw_string_literal] = ACTIONS(3018),
    [sym_float_literal] = ACTIONS(3018),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_RPAREN] = ACTIONS(7389),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(817),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(819),
    [anon_sym_ref] = ACTIONS(821),
    [sym_integer_literal] = ACTIONS(3018),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(3018),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(823),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [3168] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(6049),
    [anon_sym_PIPE] = ACTIONS(6049),
    [anon_sym_if] = ACTIONS(6049),
    [sym_line_comment] = ACTIONS(7),
  },
  [3169] = {
    [sym_field_pattern] = STATE(2188),
    [sym_remaining_field_pattern] = STATE(2188),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7391),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(1902),
    [anon_sym_ref] = ACTIONS(1904),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1906),
  },
  [3170] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(6058),
    [anon_sym_PIPE] = ACTIONS(6058),
    [anon_sym_if] = ACTIONS(6058),
    [sym_line_comment] = ACTIONS(7),
  },
  [3171] = {
    [sym_field_pattern] = STATE(2188),
    [sym_remaining_field_pattern] = STATE(2188),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7393),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(1902),
    [anon_sym_ref] = ACTIONS(1904),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1906),
  },
  [3172] = {
    [sym_raw_string_literal] = ACTIONS(1567),
    [sym_float_literal] = ACTIONS(1567),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1567),
    [anon_sym_RBRACE] = ACTIONS(1567),
    [anon_sym_LBRACK] = ACTIONS(1567),
    [anon_sym_PLUS] = ACTIONS(1569),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_COMMA] = ACTIONS(1567),
    [anon_sym_u8] = ACTIONS(1569),
    [anon_sym_i8] = ACTIONS(1569),
    [anon_sym_u16] = ACTIONS(1569),
    [anon_sym_i16] = ACTIONS(1569),
    [anon_sym_u32] = ACTIONS(1569),
    [anon_sym_i32] = ACTIONS(1569),
    [anon_sym_u64] = ACTIONS(1569),
    [anon_sym_i64] = ACTIONS(1569),
    [anon_sym_u128] = ACTIONS(1569),
    [anon_sym_i128] = ACTIONS(1569),
    [anon_sym_isize] = ACTIONS(1569),
    [anon_sym_usize] = ACTIONS(1569),
    [anon_sym_f32] = ACTIONS(1569),
    [anon_sym_f64] = ACTIONS(1569),
    [anon_sym_bool] = ACTIONS(1569),
    [anon_sym_str] = ACTIONS(1569),
    [anon_sym_char] = ACTIONS(1569),
    [anon_sym__] = ACTIONS(1569),
    [anon_sym_AMP] = ACTIONS(1569),
    [anon_sym_DASH] = ACTIONS(1569),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_DASH_EQ] = ACTIONS(1567),
    [anon_sym_COLON_COLON] = ACTIONS(1567),
    [anon_sym_BANG_EQ] = ACTIONS(1567),
    [anon_sym_STAR_EQ] = ACTIONS(1567),
    [anon_sym_SLASH] = ACTIONS(1569),
    [anon_sym_SLASH_EQ] = ACTIONS(1567),
    [anon_sym_AMP_AMP] = ACTIONS(1567),
    [anon_sym_AMP_EQ] = ACTIONS(1567),
    [anon_sym_POUND] = ACTIONS(1567),
    [anon_sym_PERCENT] = ACTIONS(1569),
    [anon_sym_PERCENT_EQ] = ACTIONS(1567),
    [anon_sym_CARET] = ACTIONS(1569),
    [anon_sym_CARET_EQ] = ACTIONS(1567),
    [anon_sym_PLUS_EQ] = ACTIONS(1567),
    [anon_sym_LT] = ACTIONS(1569),
    [anon_sym_LT_LT] = ACTIONS(1569),
    [anon_sym_LT_LT_EQ] = ACTIONS(1567),
    [anon_sym_LT_EQ] = ACTIONS(1567),
    [anon_sym_EQ] = ACTIONS(1569),
    [anon_sym_EQ_EQ] = ACTIONS(1567),
    [anon_sym_GT] = ACTIONS(1569),
    [anon_sym_GT_EQ] = ACTIONS(1567),
    [anon_sym_GT_GT] = ACTIONS(1569),
    [anon_sym_GT_GT_EQ] = ACTIONS(1567),
    [anon_sym_PIPE] = ACTIONS(1569),
    [anon_sym_PIPE_EQ] = ACTIONS(1567),
    [anon_sym_PIPE_PIPE] = ACTIONS(1567),
    [anon_sym_QMARK] = ACTIONS(1567),
    [anon_sym_DOT_DOT] = ACTIONS(1569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1567),
    [anon_sym_as] = ACTIONS(1569),
    [sym_mutable_specifier] = ACTIONS(1569),
    [anon_sym_else] = ACTIONS(1569),
    [anon_sym_ref] = ACTIONS(1569),
    [sym_integer_literal] = ACTIONS(1567),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(1567),
    [sym_char_literal] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1569),
    [anon_sym_false] = ACTIONS(1569),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1569),
    [sym_self] = ACTIONS(1569),
    [sym_super] = ACTIONS(1569),
    [sym_crate] = ACTIONS(1569),
    [sym_metavariable] = ACTIONS(1567),
  },
  [3173] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(7395),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(623),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(623),
    [anon_sym_PLUS_EQ] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(623),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(643),
    [anon_sym_as] = ACTIONS(645),
    [sym_line_comment] = ACTIONS(7),
  },
  [3174] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3407),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(3407),
    [sym_macro_invocation] = STATE(3407),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3407),
    [sym_unary_expression] = STATE(3407),
    [sym_try_expression] = STATE(3407),
    [sym_reference_expression] = STATE(3407),
    [sym_binary_expression] = STATE(3407),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3407),
    [sym_call_expression] = STATE(3407),
    [sym_array_expression] = STATE(3407),
    [sym_parenthesized_expression] = STATE(3407),
    [sym_tuple_expression] = STATE(3407),
    [sym_unit_expression] = STATE(3407),
    [sym_struct_expression] = STATE(3407),
    [sym_if_expression] = STATE(3407),
    [sym_if_let_expression] = STATE(3407),
    [sym_match_expression] = STATE(3407),
    [sym_while_expression] = STATE(3407),
    [sym_while_let_expression] = STATE(3407),
    [sym_loop_expression] = STATE(3407),
    [sym_for_expression] = STATE(3407),
    [sym_closure_expression] = STATE(3407),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3407),
    [sym_continue_expression] = STATE(3407),
    [sym_index_expression] = STATE(3407),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3407),
    [sym_block] = STATE(3407),
    [sym__literal] = STATE(3407),
    [sym_string_literal] = STATE(3407),
    [sym_boolean_literal] = STATE(3407),
    [sym_raw_string_literal] = ACTIONS(7397),
    [sym_float_literal] = ACTIONS(7397),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(7397),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7397),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [3175] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7399),
    [sym_line_comment] = ACTIONS(7),
  },
  [3176] = {
    [sym_else_tail] = STATE(3410),
    [sym_raw_string_literal] = ACTIONS(2012),
    [sym_float_literal] = ACTIONS(2012),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2012),
    [anon_sym_RBRACE] = ACTIONS(2012),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_PLUS] = ACTIONS(2014),
    [anon_sym_STAR] = ACTIONS(2014),
    [anon_sym_COMMA] = ACTIONS(2012),
    [anon_sym_u8] = ACTIONS(2014),
    [anon_sym_i8] = ACTIONS(2014),
    [anon_sym_u16] = ACTIONS(2014),
    [anon_sym_i16] = ACTIONS(2014),
    [anon_sym_u32] = ACTIONS(2014),
    [anon_sym_i32] = ACTIONS(2014),
    [anon_sym_u64] = ACTIONS(2014),
    [anon_sym_i64] = ACTIONS(2014),
    [anon_sym_u128] = ACTIONS(2014),
    [anon_sym_i128] = ACTIONS(2014),
    [anon_sym_isize] = ACTIONS(2014),
    [anon_sym_usize] = ACTIONS(2014),
    [anon_sym_f32] = ACTIONS(2014),
    [anon_sym_f64] = ACTIONS(2014),
    [anon_sym_bool] = ACTIONS(2014),
    [anon_sym_str] = ACTIONS(2014),
    [anon_sym_char] = ACTIONS(2014),
    [anon_sym__] = ACTIONS(2014),
    [anon_sym_AMP] = ACTIONS(2014),
    [anon_sym_DASH] = ACTIONS(2014),
    [anon_sym_DOT] = ACTIONS(2014),
    [anon_sym_DASH_EQ] = ACTIONS(2012),
    [anon_sym_COLON_COLON] = ACTIONS(2012),
    [anon_sym_BANG_EQ] = ACTIONS(2012),
    [anon_sym_STAR_EQ] = ACTIONS(2012),
    [anon_sym_SLASH] = ACTIONS(2014),
    [anon_sym_SLASH_EQ] = ACTIONS(2012),
    [anon_sym_AMP_AMP] = ACTIONS(2012),
    [anon_sym_AMP_EQ] = ACTIONS(2012),
    [anon_sym_POUND] = ACTIONS(2012),
    [anon_sym_PERCENT] = ACTIONS(2014),
    [anon_sym_PERCENT_EQ] = ACTIONS(2012),
    [anon_sym_CARET] = ACTIONS(2014),
    [anon_sym_CARET_EQ] = ACTIONS(2012),
    [anon_sym_PLUS_EQ] = ACTIONS(2012),
    [anon_sym_LT] = ACTIONS(2014),
    [anon_sym_LT_LT] = ACTIONS(2014),
    [anon_sym_LT_LT_EQ] = ACTIONS(2012),
    [anon_sym_LT_EQ] = ACTIONS(2012),
    [anon_sym_EQ] = ACTIONS(2014),
    [anon_sym_EQ_EQ] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2014),
    [anon_sym_GT_EQ] = ACTIONS(2012),
    [anon_sym_GT_GT] = ACTIONS(2014),
    [anon_sym_GT_GT_EQ] = ACTIONS(2012),
    [anon_sym_PIPE] = ACTIONS(2014),
    [anon_sym_PIPE_EQ] = ACTIONS(2012),
    [anon_sym_PIPE_PIPE] = ACTIONS(2012),
    [anon_sym_QMARK] = ACTIONS(2012),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2012),
    [anon_sym_as] = ACTIONS(2014),
    [sym_mutable_specifier] = ACTIONS(2014),
    [anon_sym_else] = ACTIONS(7401),
    [anon_sym_ref] = ACTIONS(2014),
    [sym_integer_literal] = ACTIONS(2012),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2012),
    [sym_char_literal] = ACTIONS(2012),
    [anon_sym_true] = ACTIONS(2014),
    [anon_sym_false] = ACTIONS(2014),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2014),
    [sym_self] = ACTIONS(2014),
    [sym_super] = ACTIONS(2014),
    [sym_crate] = ACTIONS(2014),
    [sym_metavariable] = ACTIONS(2012),
  },
  [3177] = {
    [sym_attribute_item] = STATE(1049),
    [sym_bracketed_type] = STATE(1041),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(1042),
    [sym_scoped_identifier] = STATE(1043),
    [sym_scoped_type_identifier] = STATE(1044),
    [sym_match_arm] = STATE(3413),
    [sym_last_match_arm] = STATE(3412),
    [sym_match_pattern] = STATE(1046),
    [sym__pattern] = STATE(1047),
    [sym_tuple_pattern] = STATE(1047),
    [sym_tuple_struct_pattern] = STATE(1047),
    [sym_struct_pattern] = STATE(1047),
    [sym_remaining_field_pattern] = STATE(1047),
    [sym_mut_pattern] = STATE(1047),
    [sym_range_pattern] = STATE(1047),
    [sym_ref_pattern] = STATE(1047),
    [sym_captured_pattern] = STATE(1047),
    [sym_reference_pattern] = STATE(1047),
    [sym__literal] = STATE(1048),
    [sym_string_literal] = STATE(1048),
    [sym_boolean_literal] = STATE(1048),
    [aux_sym_enum_variant_list_repeat1] = STATE(1049),
    [aux_sym_match_expression_repeat1] = STATE(3413),
    [sym_raw_string_literal] = ACTIONS(2070),
    [sym_float_literal] = ACTIONS(2070),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2072),
    [anon_sym_RBRACE] = ACTIONS(7403),
    [anon_sym_u8] = ACTIONS(2076),
    [anon_sym_i8] = ACTIONS(2076),
    [anon_sym_u16] = ACTIONS(2076),
    [anon_sym_i16] = ACTIONS(2076),
    [anon_sym_u32] = ACTIONS(2076),
    [anon_sym_i32] = ACTIONS(2076),
    [anon_sym_u64] = ACTIONS(2076),
    [anon_sym_i64] = ACTIONS(2076),
    [anon_sym_u128] = ACTIONS(2076),
    [anon_sym_i128] = ACTIONS(2076),
    [anon_sym_isize] = ACTIONS(2076),
    [anon_sym_usize] = ACTIONS(2076),
    [anon_sym_f32] = ACTIONS(2076),
    [anon_sym_f64] = ACTIONS(2076),
    [anon_sym_bool] = ACTIONS(2076),
    [anon_sym_str] = ACTIONS(2076),
    [anon_sym_char] = ACTIONS(2076),
    [anon_sym__] = ACTIONS(2078),
    [anon_sym_AMP] = ACTIONS(2080),
    [anon_sym_COLON_COLON] = ACTIONS(2082),
    [anon_sym_POUND] = ACTIONS(2084),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(2086),
    [sym_mutable_specifier] = ACTIONS(2088),
    [anon_sym_ref] = ACTIONS(2090),
    [sym_integer_literal] = ACTIONS(2070),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(769),
    [sym_char_literal] = ACTIONS(2070),
    [anon_sym_true] = ACTIONS(2092),
    [anon_sym_false] = ACTIONS(2092),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2094),
    [sym_self] = ACTIONS(2096),
    [sym_super] = ACTIONS(2096),
    [sym_crate] = ACTIONS(2096),
    [sym_metavariable] = ACTIONS(2098),
  },
  [3178] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7405),
    [sym_line_comment] = ACTIONS(7),
  },
  [3179] = {
    [sym_raw_string_literal] = ACTIONS(2212),
    [sym_float_literal] = ACTIONS(2212),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2212),
    [anon_sym_RBRACE] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2212),
    [anon_sym_PLUS] = ACTIONS(2214),
    [anon_sym_STAR] = ACTIONS(2214),
    [anon_sym_COMMA] = ACTIONS(2212),
    [anon_sym_u8] = ACTIONS(2214),
    [anon_sym_i8] = ACTIONS(2214),
    [anon_sym_u16] = ACTIONS(2214),
    [anon_sym_i16] = ACTIONS(2214),
    [anon_sym_u32] = ACTIONS(2214),
    [anon_sym_i32] = ACTIONS(2214),
    [anon_sym_u64] = ACTIONS(2214),
    [anon_sym_i64] = ACTIONS(2214),
    [anon_sym_u128] = ACTIONS(2214),
    [anon_sym_i128] = ACTIONS(2214),
    [anon_sym_isize] = ACTIONS(2214),
    [anon_sym_usize] = ACTIONS(2214),
    [anon_sym_f32] = ACTIONS(2214),
    [anon_sym_f64] = ACTIONS(2214),
    [anon_sym_bool] = ACTIONS(2214),
    [anon_sym_str] = ACTIONS(2214),
    [anon_sym_char] = ACTIONS(2214),
    [anon_sym__] = ACTIONS(2214),
    [anon_sym_AMP] = ACTIONS(2214),
    [anon_sym_DASH] = ACTIONS(2214),
    [anon_sym_DOT] = ACTIONS(2214),
    [anon_sym_DASH_EQ] = ACTIONS(2212),
    [anon_sym_COLON_COLON] = ACTIONS(2212),
    [anon_sym_BANG_EQ] = ACTIONS(2212),
    [anon_sym_STAR_EQ] = ACTIONS(2212),
    [anon_sym_SLASH] = ACTIONS(2214),
    [anon_sym_SLASH_EQ] = ACTIONS(2212),
    [anon_sym_AMP_AMP] = ACTIONS(2212),
    [anon_sym_AMP_EQ] = ACTIONS(2212),
    [anon_sym_POUND] = ACTIONS(2212),
    [anon_sym_PERCENT] = ACTIONS(2214),
    [anon_sym_PERCENT_EQ] = ACTIONS(2212),
    [anon_sym_CARET] = ACTIONS(2214),
    [anon_sym_CARET_EQ] = ACTIONS(2212),
    [anon_sym_PLUS_EQ] = ACTIONS(2212),
    [anon_sym_LT] = ACTIONS(2214),
    [anon_sym_LT_LT] = ACTIONS(2214),
    [anon_sym_LT_LT_EQ] = ACTIONS(2212),
    [anon_sym_LT_EQ] = ACTIONS(2212),
    [anon_sym_EQ] = ACTIONS(2214),
    [anon_sym_EQ_EQ] = ACTIONS(2212),
    [anon_sym_GT] = ACTIONS(2214),
    [anon_sym_GT_EQ] = ACTIONS(2212),
    [anon_sym_GT_GT] = ACTIONS(2214),
    [anon_sym_GT_GT_EQ] = ACTIONS(2212),
    [anon_sym_PIPE] = ACTIONS(2214),
    [anon_sym_PIPE_EQ] = ACTIONS(2212),
    [anon_sym_PIPE_PIPE] = ACTIONS(2212),
    [anon_sym_QMARK] = ACTIONS(2212),
    [anon_sym_DOT_DOT] = ACTIONS(2214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2212),
    [anon_sym_as] = ACTIONS(2214),
    [sym_mutable_specifier] = ACTIONS(2214),
    [anon_sym_ref] = ACTIONS(2214),
    [sym_integer_literal] = ACTIONS(2212),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2212),
    [sym_char_literal] = ACTIONS(2212),
    [anon_sym_true] = ACTIONS(2214),
    [anon_sym_false] = ACTIONS(2214),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2214),
    [sym_self] = ACTIONS(2214),
    [sym_super] = ACTIONS(2214),
    [sym_crate] = ACTIONS(2214),
    [sym_metavariable] = ACTIONS(2212),
  },
  [3180] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(3415),
    [sym_tuple_pattern] = STATE(3415),
    [sym_tuple_struct_pattern] = STATE(3415),
    [sym_struct_pattern] = STATE(3415),
    [sym_remaining_field_pattern] = STATE(3415),
    [sym_mut_pattern] = STATE(3415),
    [sym_ref_pattern] = STATE(3415),
    [sym_captured_pattern] = STATE(3415),
    [sym_reference_pattern] = STATE(3415),
    [sym__literal] = STATE(3415),
    [sym_string_literal] = STATE(3415),
    [sym_boolean_literal] = STATE(3415),
    [sym_raw_string_literal] = ACTIONS(7407),
    [sym_float_literal] = ACTIONS(7407),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(7409),
    [anon_sym_AMP] = ACTIONS(293),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(295),
    [anon_sym_ref] = ACTIONS(297),
    [sym_integer_literal] = ACTIONS(7407),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7407),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(299),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [3181] = {
    [sym_block] = STATE(3416),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(5136),
    [sym_line_comment] = ACTIONS(7),
  },
  [3182] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3418),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(3418),
    [sym_macro_invocation] = STATE(3418),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3418),
    [sym_unary_expression] = STATE(3418),
    [sym_try_expression] = STATE(3418),
    [sym_reference_expression] = STATE(3418),
    [sym_binary_expression] = STATE(3418),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3418),
    [sym_call_expression] = STATE(3418),
    [sym_array_expression] = STATE(3418),
    [sym_parenthesized_expression] = STATE(3418),
    [sym_tuple_expression] = STATE(3418),
    [sym_unit_expression] = STATE(3418),
    [sym_struct_expression] = STATE(3418),
    [sym_if_expression] = STATE(3418),
    [sym_if_let_expression] = STATE(3418),
    [sym_match_expression] = STATE(3418),
    [sym_while_expression] = STATE(3418),
    [sym_while_let_expression] = STATE(3418),
    [sym_loop_expression] = STATE(3418),
    [sym_for_expression] = STATE(3418),
    [sym_closure_expression] = STATE(3418),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3418),
    [sym_continue_expression] = STATE(3418),
    [sym_index_expression] = STATE(3418),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3418),
    [sym_block] = STATE(3418),
    [sym__literal] = STATE(3418),
    [sym_string_literal] = STATE(3418),
    [sym_boolean_literal] = STATE(3418),
    [sym_raw_string_literal] = ACTIONS(7411),
    [sym_float_literal] = ACTIONS(7411),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_let] = ACTIONS(7413),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(7411),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7411),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [3183] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1513),
    [anon_sym_EQ_GT] = ACTIONS(1513),
    [anon_sym_LBRACK] = ACTIONS(1513),
    [anon_sym_PLUS] = ACTIONS(1515),
    [anon_sym_STAR] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_DASH] = ACTIONS(1515),
    [anon_sym_DOT] = ACTIONS(1515),
    [anon_sym_DASH_EQ] = ACTIONS(1513),
    [anon_sym_BANG_EQ] = ACTIONS(1513),
    [anon_sym_STAR_EQ] = ACTIONS(1513),
    [anon_sym_SLASH] = ACTIONS(1515),
    [anon_sym_SLASH_EQ] = ACTIONS(1513),
    [anon_sym_AMP_AMP] = ACTIONS(1513),
    [anon_sym_AMP_EQ] = ACTIONS(1513),
    [anon_sym_PERCENT] = ACTIONS(1515),
    [anon_sym_PERCENT_EQ] = ACTIONS(1513),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_CARET_EQ] = ACTIONS(1513),
    [anon_sym_PLUS_EQ] = ACTIONS(1513),
    [anon_sym_LT] = ACTIONS(1515),
    [anon_sym_LT_LT] = ACTIONS(1515),
    [anon_sym_LT_LT_EQ] = ACTIONS(1513),
    [anon_sym_LT_EQ] = ACTIONS(1513),
    [anon_sym_EQ] = ACTIONS(1515),
    [anon_sym_EQ_EQ] = ACTIONS(1513),
    [anon_sym_GT] = ACTIONS(1515),
    [anon_sym_GT_EQ] = ACTIONS(1513),
    [anon_sym_GT_GT] = ACTIONS(1515),
    [anon_sym_GT_GT_EQ] = ACTIONS(1513),
    [anon_sym_PIPE] = ACTIONS(1515),
    [anon_sym_PIPE_EQ] = ACTIONS(1513),
    [anon_sym_PIPE_PIPE] = ACTIONS(1513),
    [anon_sym_QMARK] = ACTIONS(1513),
    [anon_sym_DOT_DOT] = ACTIONS(1515),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1513),
    [anon_sym_as] = ACTIONS(1513),
    [sym_line_comment] = ACTIONS(7),
  },
  [3184] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3420),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3420),
    [sym_macro_invocation] = STATE(3420),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3420),
    [sym_unary_expression] = STATE(3420),
    [sym_try_expression] = STATE(3420),
    [sym_reference_expression] = STATE(3420),
    [sym_binary_expression] = STATE(3420),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3420),
    [sym_call_expression] = STATE(3420),
    [sym_array_expression] = STATE(3420),
    [sym_parenthesized_expression] = STATE(3420),
    [sym_tuple_expression] = STATE(3420),
    [sym_unit_expression] = STATE(3420),
    [sym_struct_expression] = STATE(3420),
    [sym_if_expression] = STATE(3420),
    [sym_if_let_expression] = STATE(3420),
    [sym_match_expression] = STATE(3420),
    [sym_while_expression] = STATE(3420),
    [sym_while_let_expression] = STATE(3420),
    [sym_loop_expression] = STATE(3420),
    [sym_for_expression] = STATE(3420),
    [sym_closure_expression] = STATE(3420),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3420),
    [sym_continue_expression] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3420),
    [sym_block] = STATE(3420),
    [sym__literal] = STATE(3420),
    [sym_string_literal] = STATE(3420),
    [sym_boolean_literal] = STATE(3420),
    [aux_sym_tuple_expression_repeat1] = STATE(3421),
    [sym_raw_string_literal] = ACTIONS(7415),
    [sym_float_literal] = ACTIONS(7415),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(7417),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(7415),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7415),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [3185] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1567),
    [anon_sym_EQ_GT] = ACTIONS(1567),
    [anon_sym_LBRACK] = ACTIONS(1567),
    [anon_sym_PLUS] = ACTIONS(1569),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_AMP] = ACTIONS(1569),
    [anon_sym_DASH] = ACTIONS(1569),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_DASH_EQ] = ACTIONS(1567),
    [anon_sym_BANG_EQ] = ACTIONS(1567),
    [anon_sym_STAR_EQ] = ACTIONS(1567),
    [anon_sym_SLASH] = ACTIONS(1569),
    [anon_sym_SLASH_EQ] = ACTIONS(1567),
    [anon_sym_AMP_AMP] = ACTIONS(1567),
    [anon_sym_AMP_EQ] = ACTIONS(1567),
    [anon_sym_PERCENT] = ACTIONS(1569),
    [anon_sym_PERCENT_EQ] = ACTIONS(1567),
    [anon_sym_CARET] = ACTIONS(1569),
    [anon_sym_CARET_EQ] = ACTIONS(1567),
    [anon_sym_PLUS_EQ] = ACTIONS(1567),
    [anon_sym_LT] = ACTIONS(1569),
    [anon_sym_LT_LT] = ACTIONS(1569),
    [anon_sym_LT_LT_EQ] = ACTIONS(1567),
    [anon_sym_LT_EQ] = ACTIONS(1567),
    [anon_sym_EQ] = ACTIONS(1569),
    [anon_sym_EQ_EQ] = ACTIONS(1567),
    [anon_sym_GT] = ACTIONS(1569),
    [anon_sym_GT_EQ] = ACTIONS(1567),
    [anon_sym_GT_GT] = ACTIONS(1569),
    [anon_sym_GT_GT_EQ] = ACTIONS(1567),
    [anon_sym_PIPE] = ACTIONS(1569),
    [anon_sym_PIPE_EQ] = ACTIONS(1567),
    [anon_sym_PIPE_PIPE] = ACTIONS(1567),
    [anon_sym_QMARK] = ACTIONS(1567),
    [anon_sym_DOT_DOT] = ACTIONS(1569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1567),
    [anon_sym_as] = ACTIONS(1567),
    [anon_sym_else] = ACTIONS(1567),
    [sym_line_comment] = ACTIONS(7),
  },
  [3186] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(7419),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(623),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(623),
    [anon_sym_PLUS_EQ] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(623),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(643),
    [anon_sym_as] = ACTIONS(645),
    [sym_line_comment] = ACTIONS(7),
  },
  [3187] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_EQ_GT] = ACTIONS(1606),
    [anon_sym_LBRACK] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_STAR] = ACTIONS(1608),
    [anon_sym_AMP] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_DOT] = ACTIONS(1608),
    [anon_sym_DASH_EQ] = ACTIONS(1606),
    [anon_sym_BANG_EQ] = ACTIONS(1606),
    [anon_sym_STAR_EQ] = ACTIONS(1606),
    [anon_sym_SLASH] = ACTIONS(1608),
    [anon_sym_SLASH_EQ] = ACTIONS(1606),
    [anon_sym_AMP_AMP] = ACTIONS(1606),
    [anon_sym_AMP_EQ] = ACTIONS(1606),
    [anon_sym_PERCENT] = ACTIONS(1608),
    [anon_sym_PERCENT_EQ] = ACTIONS(1606),
    [anon_sym_CARET] = ACTIONS(1608),
    [anon_sym_CARET_EQ] = ACTIONS(1606),
    [anon_sym_PLUS_EQ] = ACTIONS(1606),
    [anon_sym_LT] = ACTIONS(1608),
    [anon_sym_LT_LT] = ACTIONS(1608),
    [anon_sym_LT_LT_EQ] = ACTIONS(1606),
    [anon_sym_LT_EQ] = ACTIONS(1606),
    [anon_sym_EQ] = ACTIONS(1608),
    [anon_sym_EQ_EQ] = ACTIONS(1606),
    [anon_sym_GT] = ACTIONS(1608),
    [anon_sym_GT_EQ] = ACTIONS(1606),
    [anon_sym_GT_GT] = ACTIONS(1608),
    [anon_sym_GT_GT_EQ] = ACTIONS(1606),
    [anon_sym_PIPE] = ACTIONS(1608),
    [anon_sym_PIPE_EQ] = ACTIONS(1606),
    [anon_sym_PIPE_PIPE] = ACTIONS(1606),
    [anon_sym_QMARK] = ACTIONS(1606),
    [anon_sym_DOT_DOT] = ACTIONS(1608),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1606),
    [anon_sym_as] = ACTIONS(1606),
    [sym_line_comment] = ACTIONS(7),
  },
  [3188] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3423),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3423),
    [sym_macro_invocation] = STATE(3423),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3423),
    [sym_unary_expression] = STATE(3423),
    [sym_try_expression] = STATE(3423),
    [sym_reference_expression] = STATE(3423),
    [sym_binary_expression] = STATE(3423),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3423),
    [sym_call_expression] = STATE(3423),
    [sym_array_expression] = STATE(3423),
    [sym_parenthesized_expression] = STATE(3423),
    [sym_tuple_expression] = STATE(3423),
    [sym_unit_expression] = STATE(3423),
    [sym_struct_expression] = STATE(3423),
    [sym_if_expression] = STATE(3423),
    [sym_if_let_expression] = STATE(3423),
    [sym_match_expression] = STATE(3423),
    [sym_while_expression] = STATE(3423),
    [sym_while_let_expression] = STATE(3423),
    [sym_loop_expression] = STATE(3423),
    [sym_for_expression] = STATE(3423),
    [sym_closure_expression] = STATE(3423),
    [sym_closure_parameters] = STATE(638),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3423),
    [sym_continue_expression] = STATE(3423),
    [sym_index_expression] = STATE(3423),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3423),
    [sym_block] = STATE(3423),
    [sym__literal] = STATE(3423),
    [sym_string_literal] = STATE(3423),
    [sym_boolean_literal] = STATE(3423),
    [sym_raw_string_literal] = ACTIONS(7421),
    [sym_float_literal] = ACTIONS(7421),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1245),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1247),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1251),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1253),
    [sym_integer_literal] = ACTIONS(7421),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7421),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [3189] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(769),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(769),
    [sym_macro_invocation] = STATE(769),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(769),
    [sym_unary_expression] = STATE(769),
    [sym_try_expression] = STATE(769),
    [sym_reference_expression] = STATE(769),
    [sym_binary_expression] = STATE(769),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(769),
    [sym_call_expression] = STATE(769),
    [sym_array_expression] = STATE(769),
    [sym_parenthesized_expression] = STATE(769),
    [sym_tuple_expression] = STATE(769),
    [sym_unit_expression] = STATE(769),
    [sym_struct_expression] = STATE(769),
    [sym_if_expression] = STATE(769),
    [sym_if_let_expression] = STATE(769),
    [sym_match_expression] = STATE(769),
    [sym_while_expression] = STATE(769),
    [sym_while_let_expression] = STATE(769),
    [sym_loop_expression] = STATE(769),
    [sym_for_expression] = STATE(769),
    [sym_closure_expression] = STATE(769),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(769),
    [sym_continue_expression] = STATE(769),
    [sym_index_expression] = STATE(769),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(769),
    [sym_block] = STATE(769),
    [sym__literal] = STATE(769),
    [sym_string_literal] = STATE(769),
    [sym_boolean_literal] = STATE(769),
    [sym_raw_string_literal] = ACTIONS(1620),
    [sym_float_literal] = ACTIONS(1620),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_RBRACK] = ACTIONS(7423),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1620),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1620),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [3190] = {
    [aux_sym_token_tree_repeat2] = STATE(789),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACK] = ACTIONS(7423),
    [anon_sym_COMMA] = ACTIONS(7425),
    [sym_line_comment] = ACTIONS(7),
  },
  [3191] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1670),
    [anon_sym_LBRACE] = ACTIONS(1672),
    [anon_sym_EQ_GT] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(1670),
    [anon_sym_PLUS] = ACTIONS(1674),
    [anon_sym_STAR] = ACTIONS(1674),
    [anon_sym_AMP] = ACTIONS(1674),
    [anon_sym_DASH] = ACTIONS(1674),
    [anon_sym_DOT] = ACTIONS(1674),
    [anon_sym_DASH_EQ] = ACTIONS(1670),
    [anon_sym_COLON_COLON] = ACTIONS(1670),
    [anon_sym_BANG_EQ] = ACTIONS(1670),
    [anon_sym_STAR_EQ] = ACTIONS(1670),
    [anon_sym_SLASH] = ACTIONS(1674),
    [anon_sym_SLASH_EQ] = ACTIONS(1670),
    [anon_sym_AMP_AMP] = ACTIONS(1670),
    [anon_sym_AMP_EQ] = ACTIONS(1670),
    [anon_sym_PERCENT] = ACTIONS(1674),
    [anon_sym_PERCENT_EQ] = ACTIONS(1670),
    [anon_sym_CARET] = ACTIONS(1674),
    [anon_sym_CARET_EQ] = ACTIONS(1670),
    [anon_sym_PLUS_EQ] = ACTIONS(1670),
    [anon_sym_LT] = ACTIONS(1674),
    [anon_sym_LT_LT] = ACTIONS(1674),
    [anon_sym_LT_LT_EQ] = ACTIONS(1670),
    [anon_sym_LT_EQ] = ACTIONS(1670),
    [anon_sym_EQ] = ACTIONS(1674),
    [anon_sym_EQ_EQ] = ACTIONS(1670),
    [anon_sym_GT] = ACTIONS(1674),
    [anon_sym_GT_EQ] = ACTIONS(1670),
    [anon_sym_GT_GT] = ACTIONS(1674),
    [anon_sym_GT_GT_EQ] = ACTIONS(1670),
    [anon_sym_PIPE] = ACTIONS(1674),
    [anon_sym_PIPE_EQ] = ACTIONS(1670),
    [anon_sym_PIPE_PIPE] = ACTIONS(1670),
    [anon_sym_QMARK] = ACTIONS(1670),
    [anon_sym_DOT_DOT] = ACTIONS(1674),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1670),
    [anon_sym_as] = ACTIONS(1670),
    [sym_line_comment] = ACTIONS(7),
  },
  [3192] = {
    [sym_arguments] = STATE(2876),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6312),
    [anon_sym_EQ_GT] = ACTIONS(1676),
    [anon_sym_LBRACK] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(1678),
    [anon_sym_STAR] = ACTIONS(1678),
    [anon_sym_AMP] = ACTIONS(1678),
    [anon_sym_DASH] = ACTIONS(1678),
    [anon_sym_DOT] = ACTIONS(6324),
    [anon_sym_DASH_EQ] = ACTIONS(1676),
    [anon_sym_BANG_EQ] = ACTIONS(1676),
    [anon_sym_STAR_EQ] = ACTIONS(1676),
    [anon_sym_SLASH] = ACTIONS(1678),
    [anon_sym_SLASH_EQ] = ACTIONS(1676),
    [anon_sym_AMP_AMP] = ACTIONS(1676),
    [anon_sym_AMP_EQ] = ACTIONS(1676),
    [anon_sym_PERCENT] = ACTIONS(1678),
    [anon_sym_PERCENT_EQ] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1678),
    [anon_sym_CARET_EQ] = ACTIONS(1676),
    [anon_sym_PLUS_EQ] = ACTIONS(1676),
    [anon_sym_LT] = ACTIONS(1678),
    [anon_sym_LT_LT] = ACTIONS(1678),
    [anon_sym_LT_LT_EQ] = ACTIONS(1676),
    [anon_sym_LT_EQ] = ACTIONS(1676),
    [anon_sym_EQ] = ACTIONS(1678),
    [anon_sym_EQ_EQ] = ACTIONS(1676),
    [anon_sym_GT] = ACTIONS(1678),
    [anon_sym_GT_EQ] = ACTIONS(1676),
    [anon_sym_GT_GT] = ACTIONS(1678),
    [anon_sym_GT_GT_EQ] = ACTIONS(1676),
    [anon_sym_PIPE] = ACTIONS(1678),
    [anon_sym_PIPE_EQ] = ACTIONS(1676),
    [anon_sym_PIPE_PIPE] = ACTIONS(1676),
    [anon_sym_QMARK] = ACTIONS(1676),
    [anon_sym_DOT_DOT] = ACTIONS(1678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1676),
    [anon_sym_as] = ACTIONS(1676),
    [sym_line_comment] = ACTIONS(7),
  },
  [3193] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_EQ_GT] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_PLUS] = ACTIONS(907),
    [anon_sym_STAR] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_DASH] = ACTIONS(907),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_BANG_EQ] = ACTIONS(905),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH] = ACTIONS(907),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_AMP_AMP] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_PERCENT] = ACTIONS(907),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_CARET] = ACTIONS(907),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(907),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_LT_EQ] = ACTIONS(905),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_EQ_EQ] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(907),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_PIPE_PIPE] = ACTIONS(905),
    [anon_sym_QMARK] = ACTIONS(905),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(905),
    [anon_sym_as] = ACTIONS(905),
    [sym_line_comment] = ACTIONS(7),
  },
  [3194] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3426),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(3426),
    [sym_macro_invocation] = STATE(3426),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3426),
    [sym_unary_expression] = STATE(3426),
    [sym_try_expression] = STATE(3426),
    [sym_reference_expression] = STATE(3426),
    [sym_binary_expression] = STATE(3426),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3426),
    [sym_call_expression] = STATE(3426),
    [sym_array_expression] = STATE(3426),
    [sym_parenthesized_expression] = STATE(3426),
    [sym_tuple_expression] = STATE(3426),
    [sym_unit_expression] = STATE(3426),
    [sym_struct_expression] = STATE(3426),
    [sym_if_expression] = STATE(3426),
    [sym_if_let_expression] = STATE(3426),
    [sym_match_expression] = STATE(3426),
    [sym_while_expression] = STATE(3426),
    [sym_while_let_expression] = STATE(3426),
    [sym_loop_expression] = STATE(3426),
    [sym_for_expression] = STATE(3426),
    [sym_closure_expression] = STATE(3426),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3426),
    [sym_continue_expression] = STATE(3426),
    [sym_index_expression] = STATE(3426),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3426),
    [sym_block] = STATE(3426),
    [sym__literal] = STATE(3426),
    [sym_string_literal] = STATE(3426),
    [sym_boolean_literal] = STATE(3426),
    [sym_raw_string_literal] = ACTIONS(7427),
    [sym_float_literal] = ACTIONS(7427),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(7427),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7427),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [3195] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7429),
    [sym_line_comment] = ACTIONS(7),
  },
  [3196] = {
    [sym_else_tail] = STATE(3429),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2012),
    [anon_sym_EQ_GT] = ACTIONS(2012),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_PLUS] = ACTIONS(2014),
    [anon_sym_STAR] = ACTIONS(2014),
    [anon_sym_AMP] = ACTIONS(2014),
    [anon_sym_DASH] = ACTIONS(2014),
    [anon_sym_DOT] = ACTIONS(2014),
    [anon_sym_DASH_EQ] = ACTIONS(2012),
    [anon_sym_BANG_EQ] = ACTIONS(2012),
    [anon_sym_STAR_EQ] = ACTIONS(2012),
    [anon_sym_SLASH] = ACTIONS(2014),
    [anon_sym_SLASH_EQ] = ACTIONS(2012),
    [anon_sym_AMP_AMP] = ACTIONS(2012),
    [anon_sym_AMP_EQ] = ACTIONS(2012),
    [anon_sym_PERCENT] = ACTIONS(2014),
    [anon_sym_PERCENT_EQ] = ACTIONS(2012),
    [anon_sym_CARET] = ACTIONS(2014),
    [anon_sym_CARET_EQ] = ACTIONS(2012),
    [anon_sym_PLUS_EQ] = ACTIONS(2012),
    [anon_sym_LT] = ACTIONS(2014),
    [anon_sym_LT_LT] = ACTIONS(2014),
    [anon_sym_LT_LT_EQ] = ACTIONS(2012),
    [anon_sym_LT_EQ] = ACTIONS(2012),
    [anon_sym_EQ] = ACTIONS(2014),
    [anon_sym_EQ_EQ] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2014),
    [anon_sym_GT_EQ] = ACTIONS(2012),
    [anon_sym_GT_GT] = ACTIONS(2014),
    [anon_sym_GT_GT_EQ] = ACTIONS(2012),
    [anon_sym_PIPE] = ACTIONS(2014),
    [anon_sym_PIPE_EQ] = ACTIONS(2012),
    [anon_sym_PIPE_PIPE] = ACTIONS(2012),
    [anon_sym_QMARK] = ACTIONS(2012),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2012),
    [anon_sym_as] = ACTIONS(2012),
    [anon_sym_else] = ACTIONS(7431),
    [sym_line_comment] = ACTIONS(7),
  },
  [3197] = {
    [sym_attribute_item] = STATE(1049),
    [sym_bracketed_type] = STATE(1041),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(1042),
    [sym_scoped_identifier] = STATE(1043),
    [sym_scoped_type_identifier] = STATE(1044),
    [sym_match_arm] = STATE(3432),
    [sym_last_match_arm] = STATE(3431),
    [sym_match_pattern] = STATE(1046),
    [sym__pattern] = STATE(1047),
    [sym_tuple_pattern] = STATE(1047),
    [sym_tuple_struct_pattern] = STATE(1047),
    [sym_struct_pattern] = STATE(1047),
    [sym_remaining_field_pattern] = STATE(1047),
    [sym_mut_pattern] = STATE(1047),
    [sym_range_pattern] = STATE(1047),
    [sym_ref_pattern] = STATE(1047),
    [sym_captured_pattern] = STATE(1047),
    [sym_reference_pattern] = STATE(1047),
    [sym__literal] = STATE(1048),
    [sym_string_literal] = STATE(1048),
    [sym_boolean_literal] = STATE(1048),
    [aux_sym_enum_variant_list_repeat1] = STATE(1049),
    [aux_sym_match_expression_repeat1] = STATE(3432),
    [sym_raw_string_literal] = ACTIONS(2070),
    [sym_float_literal] = ACTIONS(2070),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2072),
    [anon_sym_RBRACE] = ACTIONS(7433),
    [anon_sym_u8] = ACTIONS(2076),
    [anon_sym_i8] = ACTIONS(2076),
    [anon_sym_u16] = ACTIONS(2076),
    [anon_sym_i16] = ACTIONS(2076),
    [anon_sym_u32] = ACTIONS(2076),
    [anon_sym_i32] = ACTIONS(2076),
    [anon_sym_u64] = ACTIONS(2076),
    [anon_sym_i64] = ACTIONS(2076),
    [anon_sym_u128] = ACTIONS(2076),
    [anon_sym_i128] = ACTIONS(2076),
    [anon_sym_isize] = ACTIONS(2076),
    [anon_sym_usize] = ACTIONS(2076),
    [anon_sym_f32] = ACTIONS(2076),
    [anon_sym_f64] = ACTIONS(2076),
    [anon_sym_bool] = ACTIONS(2076),
    [anon_sym_str] = ACTIONS(2076),
    [anon_sym_char] = ACTIONS(2076),
    [anon_sym__] = ACTIONS(2078),
    [anon_sym_AMP] = ACTIONS(2080),
    [anon_sym_COLON_COLON] = ACTIONS(2082),
    [anon_sym_POUND] = ACTIONS(2084),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(2086),
    [sym_mutable_specifier] = ACTIONS(2088),
    [anon_sym_ref] = ACTIONS(2090),
    [sym_integer_literal] = ACTIONS(2070),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(769),
    [sym_char_literal] = ACTIONS(2070),
    [anon_sym_true] = ACTIONS(2092),
    [anon_sym_false] = ACTIONS(2092),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2094),
    [sym_self] = ACTIONS(2096),
    [sym_super] = ACTIONS(2096),
    [sym_crate] = ACTIONS(2096),
    [sym_metavariable] = ACTIONS(2098),
  },
  [3198] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7435),
    [sym_line_comment] = ACTIONS(7),
  },
  [3199] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2212),
    [anon_sym_EQ_GT] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2212),
    [anon_sym_PLUS] = ACTIONS(2214),
    [anon_sym_STAR] = ACTIONS(2214),
    [anon_sym_AMP] = ACTIONS(2214),
    [anon_sym_DASH] = ACTIONS(2214),
    [anon_sym_DOT] = ACTIONS(2214),
    [anon_sym_DASH_EQ] = ACTIONS(2212),
    [anon_sym_BANG_EQ] = ACTIONS(2212),
    [anon_sym_STAR_EQ] = ACTIONS(2212),
    [anon_sym_SLASH] = ACTIONS(2214),
    [anon_sym_SLASH_EQ] = ACTIONS(2212),
    [anon_sym_AMP_AMP] = ACTIONS(2212),
    [anon_sym_AMP_EQ] = ACTIONS(2212),
    [anon_sym_PERCENT] = ACTIONS(2214),
    [anon_sym_PERCENT_EQ] = ACTIONS(2212),
    [anon_sym_CARET] = ACTIONS(2214),
    [anon_sym_CARET_EQ] = ACTIONS(2212),
    [anon_sym_PLUS_EQ] = ACTIONS(2212),
    [anon_sym_LT] = ACTIONS(2214),
    [anon_sym_LT_LT] = ACTIONS(2214),
    [anon_sym_LT_LT_EQ] = ACTIONS(2212),
    [anon_sym_LT_EQ] = ACTIONS(2212),
    [anon_sym_EQ] = ACTIONS(2214),
    [anon_sym_EQ_EQ] = ACTIONS(2212),
    [anon_sym_GT] = ACTIONS(2214),
    [anon_sym_GT_EQ] = ACTIONS(2212),
    [anon_sym_GT_GT] = ACTIONS(2214),
    [anon_sym_GT_GT_EQ] = ACTIONS(2212),
    [anon_sym_PIPE] = ACTIONS(2214),
    [anon_sym_PIPE_EQ] = ACTIONS(2212),
    [anon_sym_PIPE_PIPE] = ACTIONS(2212),
    [anon_sym_QMARK] = ACTIONS(2212),
    [anon_sym_DOT_DOT] = ACTIONS(2214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2212),
    [anon_sym_as] = ACTIONS(2212),
    [sym_line_comment] = ACTIONS(7),
  },
  [3200] = {
    [sym_function_modifiers] = STATE(677),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3434),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(679),
    [sym_array_type] = STATE(3434),
    [sym_function_type] = STATE(3434),
    [sym_tuple_type] = STATE(3434),
    [sym_unit_type] = STATE(3434),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(3434),
    [sym_reference_type] = STATE(3434),
    [sym_pointer_type] = STATE(3434),
    [sym_empty_type] = STATE(3434),
    [sym_dynamic_type] = STATE(3434),
    [sym_macro_invocation] = STATE(3434),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(680),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1315),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1317),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1319),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1321),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3201] = {
    [sym_arguments] = STATE(2876),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6312),
    [anon_sym_EQ_GT] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6318),
    [anon_sym_STAR] = ACTIONS(6320),
    [anon_sym_AMP] = ACTIONS(6322),
    [anon_sym_DASH] = ACTIONS(6318),
    [anon_sym_DOT] = ACTIONS(6324),
    [anon_sym_DASH_EQ] = ACTIONS(6326),
    [anon_sym_BANG_EQ] = ACTIONS(6328),
    [anon_sym_STAR_EQ] = ACTIONS(6326),
    [anon_sym_SLASH] = ACTIONS(6320),
    [anon_sym_SLASH_EQ] = ACTIONS(6326),
    [anon_sym_AMP_AMP] = ACTIONS(6330),
    [anon_sym_AMP_EQ] = ACTIONS(6326),
    [anon_sym_PERCENT] = ACTIONS(6320),
    [anon_sym_PERCENT_EQ] = ACTIONS(6326),
    [anon_sym_CARET] = ACTIONS(6332),
    [anon_sym_CARET_EQ] = ACTIONS(6326),
    [anon_sym_PLUS_EQ] = ACTIONS(6326),
    [anon_sym_LT] = ACTIONS(6334),
    [anon_sym_LT_LT] = ACTIONS(6336),
    [anon_sym_LT_LT_EQ] = ACTIONS(6326),
    [anon_sym_LT_EQ] = ACTIONS(6328),
    [anon_sym_EQ] = ACTIONS(6338),
    [anon_sym_EQ_EQ] = ACTIONS(6328),
    [anon_sym_GT] = ACTIONS(6334),
    [anon_sym_GT_EQ] = ACTIONS(6328),
    [anon_sym_GT_GT] = ACTIONS(6336),
    [anon_sym_GT_GT_EQ] = ACTIONS(6326),
    [anon_sym_PIPE] = ACTIONS(6340),
    [anon_sym_PIPE_EQ] = ACTIONS(6326),
    [anon_sym_PIPE_PIPE] = ACTIONS(6342),
    [anon_sym_QMARK] = ACTIONS(6344),
    [anon_sym_DOT_DOT] = ACTIONS(6346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6348),
    [anon_sym_as] = ACTIONS(6350),
    [sym_line_comment] = ACTIONS(7),
  },
  [3202] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2222),
    [anon_sym_EQ_GT] = ACTIONS(2222),
    [anon_sym_LBRACK] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(2224),
    [anon_sym_STAR] = ACTIONS(2224),
    [anon_sym_AMP] = ACTIONS(2224),
    [anon_sym_DASH] = ACTIONS(2224),
    [anon_sym_DOT] = ACTIONS(2224),
    [anon_sym_DASH_EQ] = ACTIONS(2222),
    [anon_sym_BANG_EQ] = ACTIONS(2222),
    [anon_sym_STAR_EQ] = ACTIONS(2222),
    [anon_sym_SLASH] = ACTIONS(2224),
    [anon_sym_SLASH_EQ] = ACTIONS(2222),
    [anon_sym_AMP_AMP] = ACTIONS(2222),
    [anon_sym_AMP_EQ] = ACTIONS(2222),
    [anon_sym_PERCENT] = ACTIONS(2224),
    [anon_sym_PERCENT_EQ] = ACTIONS(2222),
    [anon_sym_CARET] = ACTIONS(2224),
    [anon_sym_CARET_EQ] = ACTIONS(2222),
    [anon_sym_PLUS_EQ] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(2224),
    [anon_sym_LT_LT] = ACTIONS(2224),
    [anon_sym_LT_LT_EQ] = ACTIONS(2222),
    [anon_sym_LT_EQ] = ACTIONS(2222),
    [anon_sym_EQ] = ACTIONS(2224),
    [anon_sym_EQ_EQ] = ACTIONS(2222),
    [anon_sym_GT] = ACTIONS(2224),
    [anon_sym_GT_EQ] = ACTIONS(2222),
    [anon_sym_GT_GT] = ACTIONS(2224),
    [anon_sym_GT_GT_EQ] = ACTIONS(2222),
    [anon_sym_PIPE] = ACTIONS(2224),
    [anon_sym_PIPE_EQ] = ACTIONS(2222),
    [anon_sym_PIPE_PIPE] = ACTIONS(2222),
    [anon_sym_QMARK] = ACTIONS(2222),
    [anon_sym_DOT_DOT] = ACTIONS(2224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2222),
    [anon_sym_as] = ACTIONS(2222),
    [sym_line_comment] = ACTIONS(7),
  },
  [3203] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2231),
    [anon_sym_EQ_GT] = ACTIONS(2231),
    [anon_sym_LBRACK] = ACTIONS(2231),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_STAR] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_DASH] = ACTIONS(2233),
    [anon_sym_DOT] = ACTIONS(2233),
    [anon_sym_DASH_EQ] = ACTIONS(2231),
    [anon_sym_BANG_EQ] = ACTIONS(2231),
    [anon_sym_STAR_EQ] = ACTIONS(2231),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_SLASH_EQ] = ACTIONS(2231),
    [anon_sym_AMP_AMP] = ACTIONS(2231),
    [anon_sym_AMP_EQ] = ACTIONS(2231),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_PERCENT_EQ] = ACTIONS(2231),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_CARET_EQ] = ACTIONS(2231),
    [anon_sym_PLUS_EQ] = ACTIONS(2231),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_LT_LT_EQ] = ACTIONS(2231),
    [anon_sym_LT_EQ] = ACTIONS(2231),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_EQ_EQ] = ACTIONS(2231),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2231),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_GT_GT_EQ] = ACTIONS(2231),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_PIPE_EQ] = ACTIONS(2231),
    [anon_sym_PIPE_PIPE] = ACTIONS(2231),
    [anon_sym_QMARK] = ACTIONS(2231),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2231),
    [anon_sym_as] = ACTIONS(2231),
    [sym_line_comment] = ACTIONS(7),
  },
  [3204] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7437),
    [sym_line_comment] = ACTIONS(7),
  },
  [3205] = {
    [aux_sym_field_initializer_list_repeat1] = STATE(3438),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7439),
    [anon_sym_COLON] = ACTIONS(2255),
    [anon_sym_COMMA] = ACTIONS(7441),
    [sym_line_comment] = ACTIONS(7),
  },
  [3206] = {
    [aux_sym_field_initializer_list_repeat1] = STATE(3440),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7437),
    [anon_sym_COMMA] = ACTIONS(7443),
    [sym_line_comment] = ACTIONS(7),
  },
  [3207] = {
    [sym_function_modifiers] = STATE(854),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3441),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(3442),
    [sym_array_type] = STATE(3441),
    [sym_function_type] = STATE(3441),
    [sym_tuple_type] = STATE(3441),
    [sym_unit_type] = STATE(3441),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(3441),
    [sym_type_binding] = STATE(3443),
    [sym_reference_type] = STATE(3441),
    [sym_pointer_type] = STATE(3441),
    [sym_empty_type] = STATE(3441),
    [sym_dynamic_type] = STATE(3441),
    [sym_macro_invocation] = STATE(3441),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(858),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1786),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1788),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1790),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1792),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3208] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(2265),
    [anon_sym_EQ_GT] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2263),
    [anon_sym_PLUS] = ACTIONS(2267),
    [anon_sym_STAR] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_DASH] = ACTIONS(2267),
    [anon_sym_DOT] = ACTIONS(2267),
    [anon_sym_DASH_EQ] = ACTIONS(2263),
    [anon_sym_COLON_COLON] = ACTIONS(2263),
    [anon_sym_BANG_EQ] = ACTIONS(2263),
    [anon_sym_STAR_EQ] = ACTIONS(2263),
    [anon_sym_SLASH] = ACTIONS(2267),
    [anon_sym_SLASH_EQ] = ACTIONS(2263),
    [anon_sym_AMP_AMP] = ACTIONS(2263),
    [anon_sym_AMP_EQ] = ACTIONS(2263),
    [anon_sym_PERCENT] = ACTIONS(2267),
    [anon_sym_PERCENT_EQ] = ACTIONS(2263),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_CARET_EQ] = ACTIONS(2263),
    [anon_sym_PLUS_EQ] = ACTIONS(2263),
    [anon_sym_LT] = ACTIONS(2267),
    [anon_sym_LT_LT] = ACTIONS(2267),
    [anon_sym_LT_LT_EQ] = ACTIONS(2263),
    [anon_sym_LT_EQ] = ACTIONS(2263),
    [anon_sym_EQ] = ACTIONS(2267),
    [anon_sym_EQ_EQ] = ACTIONS(2263),
    [anon_sym_GT] = ACTIONS(2267),
    [anon_sym_GT_EQ] = ACTIONS(2263),
    [anon_sym_GT_GT] = ACTIONS(2267),
    [anon_sym_GT_GT_EQ] = ACTIONS(2263),
    [anon_sym_PIPE] = ACTIONS(2267),
    [anon_sym_PIPE_EQ] = ACTIONS(2263),
    [anon_sym_PIPE_PIPE] = ACTIONS(2263),
    [anon_sym_QMARK] = ACTIONS(2263),
    [anon_sym_DOT_DOT] = ACTIONS(2267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2263),
    [anon_sym_as] = ACTIONS(2263),
    [sym_line_comment] = ACTIONS(7),
  },
  [3209] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2269),
    [anon_sym_LBRACE] = ACTIONS(2271),
    [anon_sym_EQ_GT] = ACTIONS(2269),
    [anon_sym_LBRACK] = ACTIONS(2269),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(2273),
    [anon_sym_AMP] = ACTIONS(2273),
    [anon_sym_DASH] = ACTIONS(2273),
    [anon_sym_DOT] = ACTIONS(2273),
    [anon_sym_DASH_EQ] = ACTIONS(2269),
    [anon_sym_COLON_COLON] = ACTIONS(2271),
    [anon_sym_BANG_EQ] = ACTIONS(2269),
    [anon_sym_STAR_EQ] = ACTIONS(2269),
    [anon_sym_SLASH] = ACTIONS(2273),
    [anon_sym_SLASH_EQ] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2269),
    [anon_sym_AMP_EQ] = ACTIONS(2269),
    [anon_sym_PERCENT] = ACTIONS(2273),
    [anon_sym_PERCENT_EQ] = ACTIONS(2269),
    [anon_sym_CARET] = ACTIONS(2273),
    [anon_sym_CARET_EQ] = ACTIONS(2269),
    [anon_sym_PLUS_EQ] = ACTIONS(2269),
    [anon_sym_LT] = ACTIONS(2273),
    [anon_sym_LT_LT] = ACTIONS(2273),
    [anon_sym_LT_LT_EQ] = ACTIONS(2269),
    [anon_sym_LT_EQ] = ACTIONS(2269),
    [anon_sym_EQ] = ACTIONS(2273),
    [anon_sym_EQ_EQ] = ACTIONS(2269),
    [anon_sym_GT] = ACTIONS(2273),
    [anon_sym_GT_EQ] = ACTIONS(2269),
    [anon_sym_GT_GT] = ACTIONS(2273),
    [anon_sym_GT_GT_EQ] = ACTIONS(2269),
    [anon_sym_PIPE] = ACTIONS(2273),
    [anon_sym_PIPE_EQ] = ACTIONS(2269),
    [anon_sym_PIPE_PIPE] = ACTIONS(2269),
    [anon_sym_QMARK] = ACTIONS(2269),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2269),
    [anon_sym_as] = ACTIONS(2269),
    [sym_line_comment] = ACTIONS(7),
  },
  [3210] = {
    [sym_token_tree] = STATE(3446),
    [sym_token_repetition] = STATE(3446),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3445),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3445),
    [sym_macro_invocation] = STATE(3445),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3445),
    [sym_unary_expression] = STATE(3445),
    [sym_try_expression] = STATE(3445),
    [sym_reference_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3445),
    [sym_call_expression] = STATE(3445),
    [sym_array_expression] = STATE(3445),
    [sym_parenthesized_expression] = STATE(3445),
    [sym_tuple_expression] = STATE(3445),
    [sym_unit_expression] = STATE(3445),
    [sym_struct_expression] = STATE(3445),
    [sym_if_expression] = STATE(3445),
    [sym_if_let_expression] = STATE(3445),
    [sym_match_expression] = STATE(3445),
    [sym_while_expression] = STATE(3445),
    [sym_while_let_expression] = STATE(3445),
    [sym_loop_expression] = STATE(3445),
    [sym_for_expression] = STATE(3445),
    [sym_closure_expression] = STATE(3445),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3445),
    [sym_continue_expression] = STATE(3445),
    [sym_index_expression] = STATE(3445),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3445),
    [sym_block] = STATE(3445),
    [sym__literal] = STATE(1178),
    [sym_string_literal] = STATE(1178),
    [sym_boolean_literal] = STATE(1178),
    [aux_sym_token_tree_repeat1] = STATE(3446),
    [sym_raw_string_literal] = ACTIONS(2275),
    [sym_float_literal] = ACTIONS(2275),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7445),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_RPAREN] = ACTIONS(7447),
    [anon_sym_LBRACE] = ACTIONS(2283),
    [anon_sym_EQ_GT] = ACTIONS(7445),
    [anon_sym_LBRACK] = ACTIONS(2285),
    [anon_sym_COLON] = ACTIONS(7449),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(7449),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_COMMA] = ACTIONS(7445),
    [anon_sym_u8] = ACTIONS(2293),
    [anon_sym_i8] = ACTIONS(2293),
    [anon_sym_u16] = ACTIONS(2293),
    [anon_sym_i16] = ACTIONS(2293),
    [anon_sym_u32] = ACTIONS(2293),
    [anon_sym_i32] = ACTIONS(2293),
    [anon_sym_u64] = ACTIONS(2293),
    [anon_sym_i64] = ACTIONS(2293),
    [anon_sym_u128] = ACTIONS(2293),
    [anon_sym_i128] = ACTIONS(2293),
    [anon_sym_isize] = ACTIONS(2293),
    [anon_sym_usize] = ACTIONS(2293),
    [anon_sym_f32] = ACTIONS(2293),
    [anon_sym_f64] = ACTIONS(2293),
    [anon_sym_bool] = ACTIONS(2293),
    [anon_sym_str] = ACTIONS(2293),
    [anon_sym_char] = ACTIONS(2293),
    [anon_sym__] = ACTIONS(7449),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_DASH] = ACTIONS(2291),
    [anon_sym_DOT] = ACTIONS(7449),
    [anon_sym_DASH_EQ] = ACTIONS(7445),
    [anon_sym_DASH_GT] = ACTIONS(7445),
    [anon_sym_COLON_COLON] = ACTIONS(7445),
    [anon_sym_BANG] = ACTIONS(2297),
    [anon_sym_BANG_EQ] = ACTIONS(7445),
    [anon_sym_AT] = ACTIONS(7445),
    [anon_sym_STAR_EQ] = ACTIONS(7445),
    [anon_sym_SLASH] = ACTIONS(7449),
    [anon_sym_SLASH_EQ] = ACTIONS(7445),
    [anon_sym_AMP_AMP] = ACTIONS(7445),
    [anon_sym_AMP_EQ] = ACTIONS(7445),
    [anon_sym_POUND] = ACTIONS(7445),
    [anon_sym_PERCENT] = ACTIONS(7449),
    [anon_sym_PERCENT_EQ] = ACTIONS(7445),
    [anon_sym_CARET] = ACTIONS(7449),
    [anon_sym_CARET_EQ] = ACTIONS(7445),
    [anon_sym_PLUS_EQ] = ACTIONS(7445),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_LT_LT] = ACTIONS(7449),
    [anon_sym_LT_LT_EQ] = ACTIONS(7445),
    [anon_sym_LT_EQ] = ACTIONS(7445),
    [anon_sym_EQ] = ACTIONS(7449),
    [anon_sym_EQ_EQ] = ACTIONS(7445),
    [anon_sym_GT] = ACTIONS(7449),
    [anon_sym_GT_EQ] = ACTIONS(7445),
    [anon_sym_GT_GT] = ACTIONS(7449),
    [anon_sym_GT_GT_EQ] = ACTIONS(7445),
    [anon_sym_PIPE] = ACTIONS(2301),
    [anon_sym_PIPE_EQ] = ACTIONS(7445),
    [anon_sym_PIPE_PIPE] = ACTIONS(7445),
    [anon_sym_TILDE] = ACTIONS(7445),
    [anon_sym_QMARK] = ACTIONS(7445),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(2305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7445),
    [anon_sym_as] = ACTIONS(7449),
    [anon_sym_break] = ACTIONS(2307),
    [anon_sym_const] = ACTIONS(7449),
    [anon_sym_continue] = ACTIONS(2309),
    [anon_sym_default] = ACTIONS(2311),
    [anon_sym_enum] = ACTIONS(7449),
    [anon_sym_fn] = ACTIONS(7449),
    [anon_sym_for] = ACTIONS(2313),
    [anon_sym_if] = ACTIONS(2315),
    [anon_sym_impl] = ACTIONS(7449),
    [anon_sym_let] = ACTIONS(7449),
    [anon_sym_loop] = ACTIONS(2317),
    [anon_sym_match] = ACTIONS(2319),
    [anon_sym_mod] = ACTIONS(7449),
    [anon_sym_pub] = ACTIONS(7449),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_static] = ACTIONS(7449),
    [anon_sym_struct] = ACTIONS(7449),
    [anon_sym_trait] = ACTIONS(7449),
    [anon_sym_type] = ACTIONS(7449),
    [anon_sym_union] = ACTIONS(2311),
    [anon_sym_unsafe] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(7449),
    [anon_sym_where] = ACTIONS(7449),
    [anon_sym_while] = ACTIONS(2325),
    [sym_mutable_specifier] = ACTIONS(7449),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(2275),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(2275),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2331),
    [sym_self] = ACTIONS(2333),
    [sym_super] = ACTIONS(7449),
    [sym_crate] = ACTIONS(7449),
    [sym_metavariable] = ACTIONS(2335),
  },
  [3211] = {
    [sym__statement] = STATE(3448),
    [sym_empty_statement] = STATE(3448),
    [sym__expression_statement] = STATE(3448),
    [sym_macro_definition] = STATE(3448),
    [sym_token_tree] = STATE(3449),
    [sym_token_repetition] = STATE(3449),
    [sym_attribute_item] = STATE(3448),
    [sym_inner_attribute_item] = STATE(3448),
    [sym_mod_item] = STATE(3448),
    [sym_foreign_mod_item] = STATE(3448),
    [sym_struct_item] = STATE(3448),
    [sym_union_item] = STATE(3448),
    [sym_enum_item] = STATE(3448),
    [sym_extern_crate_declaration] = STATE(3448),
    [sym_const_item] = STATE(3448),
    [sym_static_item] = STATE(3448),
    [sym_type_item] = STATE(3448),
    [sym_function_item] = STATE(3448),
    [sym_function_signature_item] = STATE(3448),
    [sym_function_modifiers] = STATE(47),
    [sym_impl_item] = STATE(3448),
    [sym_trait_item] = STATE(3448),
    [sym_associated_type] = STATE(3448),
    [sym_let_declaration] = STATE(3448),
    [sym_use_declaration] = STATE(3448),
    [sym_extern_modifier] = STATE(48),
    [sym_visibility_modifier] = STATE(49),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3447),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3447),
    [sym_macro_invocation] = STATE(53),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3447),
    [sym_unary_expression] = STATE(3447),
    [sym_try_expression] = STATE(3447),
    [sym_reference_expression] = STATE(3447),
    [sym_binary_expression] = STATE(3447),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3447),
    [sym_call_expression] = STATE(3447),
    [sym_array_expression] = STATE(3447),
    [sym_parenthesized_expression] = STATE(3447),
    [sym_tuple_expression] = STATE(3447),
    [sym_unit_expression] = STATE(3447),
    [sym_struct_expression] = STATE(3447),
    [sym_if_expression] = STATE(57),
    [sym_if_let_expression] = STATE(57),
    [sym_match_expression] = STATE(57),
    [sym_while_expression] = STATE(57),
    [sym_while_let_expression] = STATE(57),
    [sym_loop_expression] = STATE(57),
    [sym_for_expression] = STATE(57),
    [sym_closure_expression] = STATE(3447),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(59),
    [sym_break_expression] = STATE(3447),
    [sym_continue_expression] = STATE(3447),
    [sym_index_expression] = STATE(3447),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(57),
    [sym_block] = STATE(57),
    [sym__literal] = STATE(1216),
    [sym_string_literal] = STATE(1216),
    [sym_boolean_literal] = STATE(1216),
    [aux_sym_source_file_repeat1] = STATE(3448),
    [aux_sym_token_tree_repeat1] = STATE(3449),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_raw_string_literal] = ACTIONS(2337),
    [sym_float_literal] = ACTIONS(2337),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2339),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(2341),
    [anon_sym_LBRACE] = ACTIONS(2343),
    [anon_sym_RBRACE] = ACTIONS(7447),
    [anon_sym_EQ_GT] = ACTIONS(7451),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [anon_sym_COLON] = ACTIONS(7453),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(7453),
    [anon_sym_STAR] = ACTIONS(2351),
    [anon_sym_COMMA] = ACTIONS(7451),
    [anon_sym_u8] = ACTIONS(2353),
    [anon_sym_i8] = ACTIONS(2353),
    [anon_sym_u16] = ACTIONS(2353),
    [anon_sym_i16] = ACTIONS(2353),
    [anon_sym_u32] = ACTIONS(2353),
    [anon_sym_i32] = ACTIONS(2353),
    [anon_sym_u64] = ACTIONS(2353),
    [anon_sym_i64] = ACTIONS(2353),
    [anon_sym_u128] = ACTIONS(2353),
    [anon_sym_i128] = ACTIONS(2353),
    [anon_sym_isize] = ACTIONS(2353),
    [anon_sym_usize] = ACTIONS(2353),
    [anon_sym_f32] = ACTIONS(2353),
    [anon_sym_f64] = ACTIONS(2353),
    [anon_sym_bool] = ACTIONS(2353),
    [anon_sym_str] = ACTIONS(2353),
    [anon_sym_char] = ACTIONS(2353),
    [anon_sym__] = ACTIONS(7453),
    [anon_sym_AMP] = ACTIONS(2355),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_DOT] = ACTIONS(7453),
    [anon_sym_DASH_EQ] = ACTIONS(7451),
    [anon_sym_DASH_GT] = ACTIONS(7451),
    [anon_sym_COLON_COLON] = ACTIONS(7451),
    [anon_sym_BANG] = ACTIONS(2357),
    [anon_sym_BANG_EQ] = ACTIONS(7451),
    [anon_sym_AT] = ACTIONS(7451),
    [anon_sym_STAR_EQ] = ACTIONS(7451),
    [anon_sym_SLASH] = ACTIONS(7453),
    [anon_sym_SLASH_EQ] = ACTIONS(7451),
    [anon_sym_AMP_AMP] = ACTIONS(7451),
    [anon_sym_AMP_EQ] = ACTIONS(7451),
    [anon_sym_POUND] = ACTIONS(2359),
    [anon_sym_PERCENT] = ACTIONS(7453),
    [anon_sym_PERCENT_EQ] = ACTIONS(7451),
    [anon_sym_CARET] = ACTIONS(7453),
    [anon_sym_CARET_EQ] = ACTIONS(7451),
    [anon_sym_PLUS_EQ] = ACTIONS(7451),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_LT_LT] = ACTIONS(7453),
    [anon_sym_LT_LT_EQ] = ACTIONS(7451),
    [anon_sym_LT_EQ] = ACTIONS(7451),
    [anon_sym_EQ] = ACTIONS(7453),
    [anon_sym_EQ_EQ] = ACTIONS(7451),
    [anon_sym_GT] = ACTIONS(7453),
    [anon_sym_GT_EQ] = ACTIONS(7451),
    [anon_sym_GT_GT] = ACTIONS(7453),
    [anon_sym_GT_GT_EQ] = ACTIONS(7451),
    [anon_sym_PIPE] = ACTIONS(2301),
    [anon_sym_PIPE_EQ] = ACTIONS(7451),
    [anon_sym_PIPE_PIPE] = ACTIONS(7451),
    [anon_sym_TILDE] = ACTIONS(7451),
    [anon_sym_QMARK] = ACTIONS(7451),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(2361),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7451),
    [anon_sym_as] = ACTIONS(7453),
    [anon_sym_break] = ACTIONS(2363),
    [anon_sym_const] = ACTIONS(2365),
    [anon_sym_continue] = ACTIONS(2367),
    [anon_sym_default] = ACTIONS(2369),
    [anon_sym_enum] = ACTIONS(2371),
    [anon_sym_fn] = ACTIONS(2373),
    [anon_sym_for] = ACTIONS(2375),
    [anon_sym_if] = ACTIONS(2377),
    [anon_sym_impl] = ACTIONS(2379),
    [anon_sym_let] = ACTIONS(2381),
    [anon_sym_loop] = ACTIONS(2383),
    [anon_sym_match] = ACTIONS(2385),
    [anon_sym_mod] = ACTIONS(2387),
    [anon_sym_pub] = ACTIONS(2389),
    [anon_sym_return] = ACTIONS(2391),
    [anon_sym_static] = ACTIONS(2393),
    [anon_sym_struct] = ACTIONS(2395),
    [anon_sym_trait] = ACTIONS(2397),
    [anon_sym_type] = ACTIONS(2399),
    [anon_sym_union] = ACTIONS(2401),
    [anon_sym_unsafe] = ACTIONS(2403),
    [anon_sym_use] = ACTIONS(2405),
    [anon_sym_where] = ACTIONS(7453),
    [anon_sym_while] = ACTIONS(2407),
    [anon_sym_extern] = ACTIONS(85),
    [sym_mutable_specifier] = ACTIONS(7453),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(2337),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(2337),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2409),
    [sym_self] = ACTIONS(2411),
    [sym_super] = ACTIONS(7453),
    [sym_crate] = ACTIONS(7453),
    [sym_metavariable] = ACTIONS(2413),
  },
  [3212] = {
    [sym_token_tree] = STATE(3451),
    [sym_token_repetition] = STATE(3451),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3450),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3450),
    [sym_macro_invocation] = STATE(3450),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3450),
    [sym_unary_expression] = STATE(3450),
    [sym_try_expression] = STATE(3450),
    [sym_reference_expression] = STATE(3450),
    [sym_binary_expression] = STATE(3450),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3450),
    [sym_call_expression] = STATE(3450),
    [sym_array_expression] = STATE(3450),
    [sym_parenthesized_expression] = STATE(3450),
    [sym_tuple_expression] = STATE(3450),
    [sym_unit_expression] = STATE(3450),
    [sym_struct_expression] = STATE(3450),
    [sym_if_expression] = STATE(3450),
    [sym_if_let_expression] = STATE(3450),
    [sym_match_expression] = STATE(3450),
    [sym_while_expression] = STATE(3450),
    [sym_while_let_expression] = STATE(3450),
    [sym_loop_expression] = STATE(3450),
    [sym_for_expression] = STATE(3450),
    [sym_closure_expression] = STATE(3450),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3450),
    [sym_continue_expression] = STATE(3450),
    [sym_index_expression] = STATE(3450),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3450),
    [sym_block] = STATE(3450),
    [sym__literal] = STATE(1178),
    [sym_string_literal] = STATE(1178),
    [sym_boolean_literal] = STATE(1178),
    [aux_sym_token_tree_repeat1] = STATE(3451),
    [sym_raw_string_literal] = ACTIONS(2275),
    [sym_float_literal] = ACTIONS(2275),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7455),
    [anon_sym_LPAREN] = ACTIONS(2279),
    [anon_sym_LBRACE] = ACTIONS(2283),
    [anon_sym_EQ_GT] = ACTIONS(7455),
    [anon_sym_LBRACK] = ACTIONS(2285),
    [anon_sym_RBRACK] = ACTIONS(7447),
    [anon_sym_COLON] = ACTIONS(7457),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(7457),
    [anon_sym_STAR] = ACTIONS(2419),
    [anon_sym_COMMA] = ACTIONS(7455),
    [anon_sym_u8] = ACTIONS(2293),
    [anon_sym_i8] = ACTIONS(2293),
    [anon_sym_u16] = ACTIONS(2293),
    [anon_sym_i16] = ACTIONS(2293),
    [anon_sym_u32] = ACTIONS(2293),
    [anon_sym_i32] = ACTIONS(2293),
    [anon_sym_u64] = ACTIONS(2293),
    [anon_sym_i64] = ACTIONS(2293),
    [anon_sym_u128] = ACTIONS(2293),
    [anon_sym_i128] = ACTIONS(2293),
    [anon_sym_isize] = ACTIONS(2293),
    [anon_sym_usize] = ACTIONS(2293),
    [anon_sym_f32] = ACTIONS(2293),
    [anon_sym_f64] = ACTIONS(2293),
    [anon_sym_bool] = ACTIONS(2293),
    [anon_sym_str] = ACTIONS(2293),
    [anon_sym_char] = ACTIONS(2293),
    [anon_sym__] = ACTIONS(7457),
    [anon_sym_AMP] = ACTIONS(2421),
    [anon_sym_DASH] = ACTIONS(2419),
    [anon_sym_DOT] = ACTIONS(7457),
    [anon_sym_DASH_EQ] = ACTIONS(7455),
    [anon_sym_DASH_GT] = ACTIONS(7455),
    [anon_sym_COLON_COLON] = ACTIONS(7455),
    [anon_sym_BANG] = ACTIONS(2423),
    [anon_sym_BANG_EQ] = ACTIONS(7455),
    [anon_sym_AT] = ACTIONS(7455),
    [anon_sym_STAR_EQ] = ACTIONS(7455),
    [anon_sym_SLASH] = ACTIONS(7457),
    [anon_sym_SLASH_EQ] = ACTIONS(7455),
    [anon_sym_AMP_AMP] = ACTIONS(7455),
    [anon_sym_AMP_EQ] = ACTIONS(7455),
    [anon_sym_POUND] = ACTIONS(7455),
    [anon_sym_PERCENT] = ACTIONS(7457),
    [anon_sym_PERCENT_EQ] = ACTIONS(7455),
    [anon_sym_CARET] = ACTIONS(7457),
    [anon_sym_CARET_EQ] = ACTIONS(7455),
    [anon_sym_PLUS_EQ] = ACTIONS(7455),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_LT_LT] = ACTIONS(7457),
    [anon_sym_LT_LT_EQ] = ACTIONS(7455),
    [anon_sym_LT_EQ] = ACTIONS(7455),
    [anon_sym_EQ] = ACTIONS(7457),
    [anon_sym_EQ_EQ] = ACTIONS(7455),
    [anon_sym_GT] = ACTIONS(7457),
    [anon_sym_GT_EQ] = ACTIONS(7455),
    [anon_sym_GT_GT] = ACTIONS(7457),
    [anon_sym_GT_GT_EQ] = ACTIONS(7455),
    [anon_sym_PIPE] = ACTIONS(2301),
    [anon_sym_PIPE_EQ] = ACTIONS(7455),
    [anon_sym_PIPE_PIPE] = ACTIONS(7455),
    [anon_sym_TILDE] = ACTIONS(7455),
    [anon_sym_QMARK] = ACTIONS(7455),
    [anon_sym_SQUOTE] = ACTIONS(2303),
    [anon_sym_DOT_DOT] = ACTIONS(2425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7455),
    [anon_sym_as] = ACTIONS(7457),
    [anon_sym_break] = ACTIONS(2307),
    [anon_sym_const] = ACTIONS(7457),
    [anon_sym_continue] = ACTIONS(2309),
    [anon_sym_default] = ACTIONS(2311),
    [anon_sym_enum] = ACTIONS(7457),
    [anon_sym_fn] = ACTIONS(7457),
    [anon_sym_for] = ACTIONS(2313),
    [anon_sym_if] = ACTIONS(2427),
    [anon_sym_impl] = ACTIONS(7457),
    [anon_sym_let] = ACTIONS(7457),
    [anon_sym_loop] = ACTIONS(2317),
    [anon_sym_match] = ACTIONS(2319),
    [anon_sym_mod] = ACTIONS(7457),
    [anon_sym_pub] = ACTIONS(7457),
    [anon_sym_return] = ACTIONS(2429),
    [anon_sym_static] = ACTIONS(7457),
    [anon_sym_struct] = ACTIONS(7457),
    [anon_sym_trait] = ACTIONS(7457),
    [anon_sym_type] = ACTIONS(7457),
    [anon_sym_union] = ACTIONS(2311),
    [anon_sym_unsafe] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(7457),
    [anon_sym_where] = ACTIONS(7457),
    [anon_sym_while] = ACTIONS(2325),
    [sym_mutable_specifier] = ACTIONS(7457),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(2275),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(2275),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2331),
    [sym_self] = ACTIONS(2333),
    [sym_super] = ACTIONS(7457),
    [sym_crate] = ACTIONS(7457),
    [sym_metavariable] = ACTIONS(2335),
  },
  [3213] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2431),
    [anon_sym_EQ_GT] = ACTIONS(2431),
    [anon_sym_LBRACK] = ACTIONS(2431),
    [anon_sym_PLUS] = ACTIONS(2433),
    [anon_sym_STAR] = ACTIONS(2433),
    [anon_sym_AMP] = ACTIONS(2433),
    [anon_sym_DASH] = ACTIONS(2433),
    [anon_sym_DOT] = ACTIONS(2433),
    [anon_sym_DASH_EQ] = ACTIONS(2431),
    [anon_sym_BANG_EQ] = ACTIONS(2431),
    [anon_sym_STAR_EQ] = ACTIONS(2431),
    [anon_sym_SLASH] = ACTIONS(2433),
    [anon_sym_SLASH_EQ] = ACTIONS(2431),
    [anon_sym_AMP_AMP] = ACTIONS(2431),
    [anon_sym_AMP_EQ] = ACTIONS(2431),
    [anon_sym_PERCENT] = ACTIONS(2433),
    [anon_sym_PERCENT_EQ] = ACTIONS(2431),
    [anon_sym_CARET] = ACTIONS(2433),
    [anon_sym_CARET_EQ] = ACTIONS(2431),
    [anon_sym_PLUS_EQ] = ACTIONS(2431),
    [anon_sym_LT] = ACTIONS(2433),
    [anon_sym_LT_LT] = ACTIONS(2433),
    [anon_sym_LT_LT_EQ] = ACTIONS(2431),
    [anon_sym_LT_EQ] = ACTIONS(2431),
    [anon_sym_EQ] = ACTIONS(2433),
    [anon_sym_EQ_EQ] = ACTIONS(2431),
    [anon_sym_GT] = ACTIONS(2433),
    [anon_sym_GT_EQ] = ACTIONS(2431),
    [anon_sym_GT_GT] = ACTIONS(2433),
    [anon_sym_GT_GT_EQ] = ACTIONS(2431),
    [anon_sym_PIPE] = ACTIONS(2433),
    [anon_sym_PIPE_EQ] = ACTIONS(2431),
    [anon_sym_PIPE_PIPE] = ACTIONS(2431),
    [anon_sym_QMARK] = ACTIONS(2431),
    [anon_sym_DOT_DOT] = ACTIONS(2433),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2431),
    [anon_sym_as] = ACTIONS(2431),
    [sym_line_comment] = ACTIONS(7),
  },
  [3214] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2263),
    [anon_sym_EQ_GT] = ACTIONS(2263),
    [anon_sym_LBRACK] = ACTIONS(2263),
    [anon_sym_PLUS] = ACTIONS(2267),
    [anon_sym_STAR] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_DASH] = ACTIONS(2267),
    [anon_sym_DOT] = ACTIONS(2267),
    [anon_sym_DASH_EQ] = ACTIONS(2263),
    [anon_sym_COLON_COLON] = ACTIONS(2263),
    [anon_sym_BANG_EQ] = ACTIONS(2263),
    [anon_sym_STAR_EQ] = ACTIONS(2263),
    [anon_sym_SLASH] = ACTIONS(2267),
    [anon_sym_SLASH_EQ] = ACTIONS(2263),
    [anon_sym_AMP_AMP] = ACTIONS(2263),
    [anon_sym_AMP_EQ] = ACTIONS(2263),
    [anon_sym_PERCENT] = ACTIONS(2267),
    [anon_sym_PERCENT_EQ] = ACTIONS(2263),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_CARET_EQ] = ACTIONS(2263),
    [anon_sym_PLUS_EQ] = ACTIONS(2263),
    [anon_sym_LT] = ACTIONS(2267),
    [anon_sym_LT_LT] = ACTIONS(2267),
    [anon_sym_LT_LT_EQ] = ACTIONS(2263),
    [anon_sym_LT_EQ] = ACTIONS(2263),
    [anon_sym_EQ] = ACTIONS(2267),
    [anon_sym_EQ_EQ] = ACTIONS(2263),
    [anon_sym_GT] = ACTIONS(2267),
    [anon_sym_GT_EQ] = ACTIONS(2263),
    [anon_sym_GT_GT] = ACTIONS(2267),
    [anon_sym_GT_GT_EQ] = ACTIONS(2263),
    [anon_sym_PIPE] = ACTIONS(2267),
    [anon_sym_PIPE_EQ] = ACTIONS(2263),
    [anon_sym_PIPE_PIPE] = ACTIONS(2263),
    [anon_sym_QMARK] = ACTIONS(2263),
    [anon_sym_DOT_DOT] = ACTIONS(2267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2263),
    [anon_sym_as] = ACTIONS(2263),
    [sym_line_comment] = ACTIONS(7),
  },
  [3215] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2529),
    [anon_sym_LBRACE] = ACTIONS(2531),
    [anon_sym_EQ_GT] = ACTIONS(2529),
    [anon_sym_LBRACK] = ACTIONS(2529),
    [anon_sym_PLUS] = ACTIONS(2533),
    [anon_sym_STAR] = ACTIONS(2533),
    [anon_sym_AMP] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(2533),
    [anon_sym_DOT] = ACTIONS(2533),
    [anon_sym_DASH_EQ] = ACTIONS(2529),
    [anon_sym_COLON_COLON] = ACTIONS(2529),
    [anon_sym_BANG_EQ] = ACTIONS(2529),
    [anon_sym_STAR_EQ] = ACTIONS(2529),
    [anon_sym_SLASH] = ACTIONS(2533),
    [anon_sym_SLASH_EQ] = ACTIONS(2529),
    [anon_sym_AMP_AMP] = ACTIONS(2529),
    [anon_sym_AMP_EQ] = ACTIONS(2529),
    [anon_sym_PERCENT] = ACTIONS(2533),
    [anon_sym_PERCENT_EQ] = ACTIONS(2529),
    [anon_sym_CARET] = ACTIONS(2533),
    [anon_sym_CARET_EQ] = ACTIONS(2529),
    [anon_sym_PLUS_EQ] = ACTIONS(2529),
    [anon_sym_LT] = ACTIONS(2533),
    [anon_sym_LT_LT] = ACTIONS(2533),
    [anon_sym_LT_LT_EQ] = ACTIONS(2529),
    [anon_sym_LT_EQ] = ACTIONS(2529),
    [anon_sym_EQ] = ACTIONS(2533),
    [anon_sym_EQ_EQ] = ACTIONS(2529),
    [anon_sym_GT] = ACTIONS(2533),
    [anon_sym_GT_EQ] = ACTIONS(2529),
    [anon_sym_GT_GT] = ACTIONS(2533),
    [anon_sym_GT_GT_EQ] = ACTIONS(2529),
    [anon_sym_PIPE] = ACTIONS(2533),
    [anon_sym_PIPE_EQ] = ACTIONS(2529),
    [anon_sym_PIPE_PIPE] = ACTIONS(2529),
    [anon_sym_QMARK] = ACTIONS(2529),
    [anon_sym_DOT_DOT] = ACTIONS(2533),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2529),
    [anon_sym_as] = ACTIONS(2529),
    [sym_line_comment] = ACTIONS(7),
  },
  [3216] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2535),
    [anon_sym_EQ_GT] = ACTIONS(2535),
    [anon_sym_LBRACK] = ACTIONS(2535),
    [anon_sym_PLUS] = ACTIONS(2537),
    [anon_sym_STAR] = ACTIONS(2537),
    [anon_sym_AMP] = ACTIONS(2537),
    [anon_sym_DASH] = ACTIONS(2537),
    [anon_sym_DOT] = ACTIONS(2537),
    [anon_sym_DASH_EQ] = ACTIONS(2535),
    [anon_sym_BANG_EQ] = ACTIONS(2535),
    [anon_sym_STAR_EQ] = ACTIONS(2535),
    [anon_sym_SLASH] = ACTIONS(2537),
    [anon_sym_SLASH_EQ] = ACTIONS(2535),
    [anon_sym_AMP_AMP] = ACTIONS(2535),
    [anon_sym_AMP_EQ] = ACTIONS(2535),
    [anon_sym_PERCENT] = ACTIONS(2537),
    [anon_sym_PERCENT_EQ] = ACTIONS(2535),
    [anon_sym_CARET] = ACTIONS(2537),
    [anon_sym_CARET_EQ] = ACTIONS(2535),
    [anon_sym_PLUS_EQ] = ACTIONS(2535),
    [anon_sym_LT] = ACTIONS(2537),
    [anon_sym_LT_LT] = ACTIONS(2537),
    [anon_sym_LT_LT_EQ] = ACTIONS(2535),
    [anon_sym_LT_EQ] = ACTIONS(2535),
    [anon_sym_EQ] = ACTIONS(2537),
    [anon_sym_EQ_EQ] = ACTIONS(2535),
    [anon_sym_GT] = ACTIONS(2537),
    [anon_sym_GT_EQ] = ACTIONS(2535),
    [anon_sym_GT_GT] = ACTIONS(2537),
    [anon_sym_GT_GT_EQ] = ACTIONS(2535),
    [anon_sym_PIPE] = ACTIONS(2537),
    [anon_sym_PIPE_EQ] = ACTIONS(2535),
    [anon_sym_PIPE_PIPE] = ACTIONS(2535),
    [anon_sym_QMARK] = ACTIONS(2535),
    [anon_sym_DOT_DOT] = ACTIONS(2537),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2535),
    [anon_sym_as] = ACTIONS(2535),
    [sym_line_comment] = ACTIONS(7),
  },
  [3217] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7459),
    [sym_line_comment] = ACTIONS(7),
  },
  [3218] = {
    [sym_arguments] = STATE(263),
    [aux_sym_token_tree_repeat2] = STATE(3454),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(7459),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(7461),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_BANG_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH] = ACTIONS(563),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(563),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_LT] = ACTIONS(577),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(581),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(577),
    [anon_sym_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(589),
    [anon_sym_as] = ACTIONS(591),
    [sym_line_comment] = ACTIONS(7),
  },
  [3219] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(7463),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_STAR_EQ] = ACTIONS(2563),
    [anon_sym_SLASH] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_AMP_EQ] = ACTIONS(2563),
    [anon_sym_PERCENT] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2563),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_CARET_EQ] = ACTIONS(2563),
    [anon_sym_PLUS_EQ] = ACTIONS(2563),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_LT_LT] = ACTIONS(2573),
    [anon_sym_LT_LT_EQ] = ACTIONS(2563),
    [anon_sym_LT_EQ] = ACTIONS(2565),
    [anon_sym_EQ] = ACTIONS(2575),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_GT_EQ] = ACTIONS(2565),
    [anon_sym_GT_GT] = ACTIONS(2573),
    [anon_sym_GT_GT_EQ] = ACTIONS(2563),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_PIPE_EQ] = ACTIONS(2563),
    [anon_sym_PIPE_PIPE] = ACTIONS(2579),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(2581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2583),
    [anon_sym_as] = ACTIONS(2585),
    [sym_line_comment] = ACTIONS(7),
  },
  [3220] = {
    [sym_arguments] = STATE(2876),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6312),
    [anon_sym_EQ_GT] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(6320),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_DOT] = ACTIONS(6324),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(6320),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(6320),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2591),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [3221] = {
    [sym_arguments] = STATE(2876),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6312),
    [anon_sym_EQ_GT] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_DOT] = ACTIONS(6324),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(2591),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(2591),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2591),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [3222] = {
    [sym_arguments] = STATE(2876),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6312),
    [anon_sym_EQ_GT] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6318),
    [anon_sym_STAR] = ACTIONS(6320),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(6318),
    [anon_sym_DOT] = ACTIONS(6324),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(6320),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(6320),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(6336),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(6336),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [3223] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_EQ_GT] = ACTIONS(2593),
    [anon_sym_LBRACK] = ACTIONS(2593),
    [anon_sym_PLUS] = ACTIONS(2595),
    [anon_sym_STAR] = ACTIONS(2595),
    [anon_sym_AMP] = ACTIONS(2595),
    [anon_sym_DASH] = ACTIONS(2595),
    [anon_sym_DOT] = ACTIONS(2595),
    [anon_sym_DASH_EQ] = ACTIONS(2593),
    [anon_sym_COLON_COLON] = ACTIONS(2593),
    [anon_sym_BANG_EQ] = ACTIONS(2593),
    [anon_sym_STAR_EQ] = ACTIONS(2593),
    [anon_sym_SLASH] = ACTIONS(2595),
    [anon_sym_SLASH_EQ] = ACTIONS(2593),
    [anon_sym_AMP_AMP] = ACTIONS(2593),
    [anon_sym_AMP_EQ] = ACTIONS(2593),
    [anon_sym_PERCENT] = ACTIONS(2595),
    [anon_sym_PERCENT_EQ] = ACTIONS(2593),
    [anon_sym_CARET] = ACTIONS(2595),
    [anon_sym_CARET_EQ] = ACTIONS(2593),
    [anon_sym_PLUS_EQ] = ACTIONS(2593),
    [anon_sym_LT] = ACTIONS(2595),
    [anon_sym_LT_LT] = ACTIONS(2595),
    [anon_sym_LT_LT_EQ] = ACTIONS(2593),
    [anon_sym_LT_EQ] = ACTIONS(2593),
    [anon_sym_EQ] = ACTIONS(2595),
    [anon_sym_EQ_EQ] = ACTIONS(2593),
    [anon_sym_GT] = ACTIONS(2595),
    [anon_sym_GT_EQ] = ACTIONS(2593),
    [anon_sym_GT_GT] = ACTIONS(2595),
    [anon_sym_GT_GT_EQ] = ACTIONS(2593),
    [anon_sym_PIPE] = ACTIONS(2595),
    [anon_sym_PIPE_EQ] = ACTIONS(2593),
    [anon_sym_PIPE_PIPE] = ACTIONS(2593),
    [anon_sym_QMARK] = ACTIONS(2593),
    [anon_sym_DOT_DOT] = ACTIONS(2595),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2593),
    [anon_sym_as] = ACTIONS(2593),
    [sym_line_comment] = ACTIONS(7),
  },
  [3224] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2597),
    [anon_sym_EQ_GT] = ACTIONS(2597),
    [anon_sym_LBRACK] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(2599),
    [anon_sym_STAR] = ACTIONS(2599),
    [anon_sym_AMP] = ACTIONS(2599),
    [anon_sym_DASH] = ACTIONS(2599),
    [anon_sym_DOT] = ACTIONS(2599),
    [anon_sym_DASH_EQ] = ACTIONS(2597),
    [anon_sym_COLON_COLON] = ACTIONS(2597),
    [anon_sym_BANG_EQ] = ACTIONS(2597),
    [anon_sym_STAR_EQ] = ACTIONS(2597),
    [anon_sym_SLASH] = ACTIONS(2599),
    [anon_sym_SLASH_EQ] = ACTIONS(2597),
    [anon_sym_AMP_AMP] = ACTIONS(2597),
    [anon_sym_AMP_EQ] = ACTIONS(2597),
    [anon_sym_PERCENT] = ACTIONS(2599),
    [anon_sym_PERCENT_EQ] = ACTIONS(2597),
    [anon_sym_CARET] = ACTIONS(2599),
    [anon_sym_CARET_EQ] = ACTIONS(2597),
    [anon_sym_PLUS_EQ] = ACTIONS(2597),
    [anon_sym_LT] = ACTIONS(2599),
    [anon_sym_LT_LT] = ACTIONS(2599),
    [anon_sym_LT_LT_EQ] = ACTIONS(2597),
    [anon_sym_LT_EQ] = ACTIONS(2597),
    [anon_sym_EQ] = ACTIONS(2599),
    [anon_sym_EQ_EQ] = ACTIONS(2597),
    [anon_sym_GT] = ACTIONS(2599),
    [anon_sym_GT_EQ] = ACTIONS(2597),
    [anon_sym_GT_GT] = ACTIONS(2599),
    [anon_sym_GT_GT_EQ] = ACTIONS(2597),
    [anon_sym_PIPE] = ACTIONS(2599),
    [anon_sym_PIPE_EQ] = ACTIONS(2597),
    [anon_sym_PIPE_PIPE] = ACTIONS(2597),
    [anon_sym_QMARK] = ACTIONS(2597),
    [anon_sym_DOT_DOT] = ACTIONS(2599),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2597),
    [anon_sym_as] = ACTIONS(2597),
    [sym_line_comment] = ACTIONS(7),
  },
  [3225] = {
    [sym_arguments] = STATE(2876),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6312),
    [anon_sym_EQ_GT] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6318),
    [anon_sym_STAR] = ACTIONS(6320),
    [anon_sym_AMP] = ACTIONS(6322),
    [anon_sym_DASH] = ACTIONS(6318),
    [anon_sym_DOT] = ACTIONS(6324),
    [anon_sym_DASH_EQ] = ACTIONS(2601),
    [anon_sym_BANG_EQ] = ACTIONS(6328),
    [anon_sym_STAR_EQ] = ACTIONS(2601),
    [anon_sym_SLASH] = ACTIONS(6320),
    [anon_sym_SLASH_EQ] = ACTIONS(2601),
    [anon_sym_AMP_AMP] = ACTIONS(6330),
    [anon_sym_AMP_EQ] = ACTIONS(2601),
    [anon_sym_PERCENT] = ACTIONS(6320),
    [anon_sym_PERCENT_EQ] = ACTIONS(2601),
    [anon_sym_CARET] = ACTIONS(6332),
    [anon_sym_CARET_EQ] = ACTIONS(2601),
    [anon_sym_PLUS_EQ] = ACTIONS(2601),
    [anon_sym_LT] = ACTIONS(6334),
    [anon_sym_LT_LT] = ACTIONS(6336),
    [anon_sym_LT_LT_EQ] = ACTIONS(2601),
    [anon_sym_LT_EQ] = ACTIONS(6328),
    [anon_sym_EQ] = ACTIONS(2603),
    [anon_sym_EQ_EQ] = ACTIONS(6328),
    [anon_sym_GT] = ACTIONS(6334),
    [anon_sym_GT_EQ] = ACTIONS(6328),
    [anon_sym_GT_GT] = ACTIONS(6336),
    [anon_sym_GT_GT_EQ] = ACTIONS(2601),
    [anon_sym_PIPE] = ACTIONS(6340),
    [anon_sym_PIPE_EQ] = ACTIONS(2601),
    [anon_sym_PIPE_PIPE] = ACTIONS(6342),
    [anon_sym_QMARK] = ACTIONS(2601),
    [anon_sym_DOT_DOT] = ACTIONS(6346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6348),
    [anon_sym_as] = ACTIONS(2601),
    [sym_line_comment] = ACTIONS(7),
  },
  [3226] = {
    [sym_arguments] = STATE(2876),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6312),
    [anon_sym_EQ_GT] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6318),
    [anon_sym_STAR] = ACTIONS(6320),
    [anon_sym_AMP] = ACTIONS(6322),
    [anon_sym_DASH] = ACTIONS(6318),
    [anon_sym_DOT] = ACTIONS(6324),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(6320),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(6320),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(6332),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(6336),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(6336),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(6340),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [3227] = {
    [sym_arguments] = STATE(2876),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6312),
    [anon_sym_EQ_GT] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6318),
    [anon_sym_STAR] = ACTIONS(6320),
    [anon_sym_AMP] = ACTIONS(6322),
    [anon_sym_DASH] = ACTIONS(6318),
    [anon_sym_DOT] = ACTIONS(6324),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(6328),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(6320),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(6320),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(6332),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(6334),
    [anon_sym_LT_LT] = ACTIONS(6336),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(6328),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(6328),
    [anon_sym_GT] = ACTIONS(6334),
    [anon_sym_GT_EQ] = ACTIONS(6328),
    [anon_sym_GT_GT] = ACTIONS(6336),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(6340),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [3228] = {
    [sym_arguments] = STATE(2876),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6312),
    [anon_sym_EQ_GT] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6318),
    [anon_sym_STAR] = ACTIONS(6320),
    [anon_sym_AMP] = ACTIONS(6322),
    [anon_sym_DASH] = ACTIONS(6318),
    [anon_sym_DOT] = ACTIONS(6324),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(6320),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(6320),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(6336),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(6336),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [3229] = {
    [sym_arguments] = STATE(2876),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6312),
    [anon_sym_EQ_GT] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6318),
    [anon_sym_STAR] = ACTIONS(6320),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(6318),
    [anon_sym_DOT] = ACTIONS(6324),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(6320),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(6320),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2591),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [3230] = {
    [sym_arguments] = STATE(2876),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6312),
    [anon_sym_EQ_GT] = ACTIONS(2605),
    [anon_sym_LBRACK] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6318),
    [anon_sym_STAR] = ACTIONS(6320),
    [anon_sym_AMP] = ACTIONS(6322),
    [anon_sym_DASH] = ACTIONS(6318),
    [anon_sym_DOT] = ACTIONS(6324),
    [anon_sym_DASH_EQ] = ACTIONS(2605),
    [anon_sym_BANG_EQ] = ACTIONS(6328),
    [anon_sym_STAR_EQ] = ACTIONS(2605),
    [anon_sym_SLASH] = ACTIONS(6320),
    [anon_sym_SLASH_EQ] = ACTIONS(2605),
    [anon_sym_AMP_AMP] = ACTIONS(6330),
    [anon_sym_AMP_EQ] = ACTIONS(2605),
    [anon_sym_PERCENT] = ACTIONS(6320),
    [anon_sym_PERCENT_EQ] = ACTIONS(2605),
    [anon_sym_CARET] = ACTIONS(6332),
    [anon_sym_CARET_EQ] = ACTIONS(2605),
    [anon_sym_PLUS_EQ] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(6334),
    [anon_sym_LT_LT] = ACTIONS(6336),
    [anon_sym_LT_LT_EQ] = ACTIONS(2605),
    [anon_sym_LT_EQ] = ACTIONS(6328),
    [anon_sym_EQ] = ACTIONS(2607),
    [anon_sym_EQ_EQ] = ACTIONS(6328),
    [anon_sym_GT] = ACTIONS(6334),
    [anon_sym_GT_EQ] = ACTIONS(6328),
    [anon_sym_GT_GT] = ACTIONS(6336),
    [anon_sym_GT_GT_EQ] = ACTIONS(2605),
    [anon_sym_PIPE] = ACTIONS(6340),
    [anon_sym_PIPE_EQ] = ACTIONS(2605),
    [anon_sym_PIPE_PIPE] = ACTIONS(6342),
    [anon_sym_QMARK] = ACTIONS(2605),
    [anon_sym_DOT_DOT] = ACTIONS(6346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6348),
    [anon_sym_as] = ACTIONS(2605),
    [sym_line_comment] = ACTIONS(7),
  },
  [3231] = {
    [sym_arguments] = STATE(2876),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6312),
    [anon_sym_EQ_GT] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6318),
    [anon_sym_STAR] = ACTIONS(6320),
    [anon_sym_AMP] = ACTIONS(6322),
    [anon_sym_DASH] = ACTIONS(6318),
    [anon_sym_DOT] = ACTIONS(6324),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2589),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(6320),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(6320),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(6332),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(6336),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(6336),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [3232] = {
    [sym_arguments] = STATE(2876),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6312),
    [anon_sym_EQ_GT] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6318),
    [anon_sym_STAR] = ACTIONS(6320),
    [anon_sym_AMP] = ACTIONS(6322),
    [anon_sym_DASH] = ACTIONS(6318),
    [anon_sym_DOT] = ACTIONS(6324),
    [anon_sym_DASH_EQ] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(6328),
    [anon_sym_STAR_EQ] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(6320),
    [anon_sym_SLASH_EQ] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(6330),
    [anon_sym_AMP_EQ] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(6320),
    [anon_sym_PERCENT_EQ] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(6332),
    [anon_sym_CARET_EQ] = ACTIONS(2589),
    [anon_sym_PLUS_EQ] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(6334),
    [anon_sym_LT_LT] = ACTIONS(6336),
    [anon_sym_LT_LT_EQ] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(6328),
    [anon_sym_EQ] = ACTIONS(2591),
    [anon_sym_EQ_EQ] = ACTIONS(6328),
    [anon_sym_GT] = ACTIONS(6334),
    [anon_sym_GT_EQ] = ACTIONS(6328),
    [anon_sym_GT_GT] = ACTIONS(6336),
    [anon_sym_GT_GT_EQ] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(6340),
    [anon_sym_PIPE_EQ] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(2589),
    [sym_line_comment] = ACTIONS(7),
  },
  [3233] = {
    [sym_arguments] = STATE(2876),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6312),
    [anon_sym_EQ_GT] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6318),
    [anon_sym_STAR] = ACTIONS(6320),
    [anon_sym_AMP] = ACTIONS(6322),
    [anon_sym_DASH] = ACTIONS(6318),
    [anon_sym_DOT] = ACTIONS(6324),
    [anon_sym_DASH_EQ] = ACTIONS(2609),
    [anon_sym_BANG_EQ] = ACTIONS(6328),
    [anon_sym_STAR_EQ] = ACTIONS(2609),
    [anon_sym_SLASH] = ACTIONS(6320),
    [anon_sym_SLASH_EQ] = ACTIONS(2609),
    [anon_sym_AMP_AMP] = ACTIONS(6330),
    [anon_sym_AMP_EQ] = ACTIONS(2609),
    [anon_sym_PERCENT] = ACTIONS(6320),
    [anon_sym_PERCENT_EQ] = ACTIONS(2609),
    [anon_sym_CARET] = ACTIONS(6332),
    [anon_sym_CARET_EQ] = ACTIONS(2609),
    [anon_sym_PLUS_EQ] = ACTIONS(2609),
    [anon_sym_LT] = ACTIONS(6334),
    [anon_sym_LT_LT] = ACTIONS(6336),
    [anon_sym_LT_LT_EQ] = ACTIONS(2609),
    [anon_sym_LT_EQ] = ACTIONS(6328),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_EQ_EQ] = ACTIONS(6328),
    [anon_sym_GT] = ACTIONS(6334),
    [anon_sym_GT_EQ] = ACTIONS(6328),
    [anon_sym_GT_GT] = ACTIONS(6336),
    [anon_sym_GT_GT_EQ] = ACTIONS(2609),
    [anon_sym_PIPE] = ACTIONS(6340),
    [anon_sym_PIPE_EQ] = ACTIONS(2609),
    [anon_sym_PIPE_PIPE] = ACTIONS(6342),
    [anon_sym_QMARK] = ACTIONS(2609),
    [anon_sym_DOT_DOT] = ACTIONS(2611),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2609),
    [anon_sym_as] = ACTIONS(2609),
    [sym_line_comment] = ACTIONS(7),
  },
  [3234] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3457),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(3457),
    [sym_function_type] = STATE(3457),
    [sym_tuple_type] = STATE(3457),
    [sym_unit_type] = STATE(3457),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(3457),
    [sym_reference_type] = STATE(3457),
    [sym_pointer_type] = STATE(3457),
    [sym_empty_type] = STATE(3457),
    [sym_dynamic_type] = STATE(3457),
    [sym_macro_invocation] = STATE(3457),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_RPAREN] = ACTIONS(7465),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3235] = {
    [sym_function_modifiers] = STATE(378),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3458),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(380),
    [sym_array_type] = STATE(3458),
    [sym_function_type] = STATE(3458),
    [sym_tuple_type] = STATE(3458),
    [sym_unit_type] = STATE(3458),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(3458),
    [sym_reference_type] = STATE(3458),
    [sym_pointer_type] = STATE(3458),
    [sym_empty_type] = STATE(3458),
    [sym_dynamic_type] = STATE(3458),
    [sym_macro_invocation] = STATE(3458),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(381),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(741),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(743),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(745),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(747),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3236] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_const] = ACTIONS(7467),
    [sym_mutable_specifier] = ACTIONS(7467),
    [sym_line_comment] = ACTIONS(7),
  },
  [3237] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(751),
    [anon_sym_EQ_GT] = ACTIONS(751),
    [anon_sym_LBRACK] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_STAR] = ACTIONS(753),
    [anon_sym_AMP] = ACTIONS(753),
    [anon_sym_DASH] = ACTIONS(753),
    [anon_sym_DOT] = ACTIONS(753),
    [anon_sym_DASH_EQ] = ACTIONS(751),
    [anon_sym_COLON_COLON] = ACTIONS(7469),
    [anon_sym_BANG_EQ] = ACTIONS(751),
    [anon_sym_STAR_EQ] = ACTIONS(751),
    [anon_sym_SLASH] = ACTIONS(753),
    [anon_sym_SLASH_EQ] = ACTIONS(751),
    [anon_sym_AMP_AMP] = ACTIONS(751),
    [anon_sym_AMP_EQ] = ACTIONS(751),
    [anon_sym_PERCENT] = ACTIONS(753),
    [anon_sym_PERCENT_EQ] = ACTIONS(751),
    [anon_sym_CARET] = ACTIONS(753),
    [anon_sym_CARET_EQ] = ACTIONS(751),
    [anon_sym_PLUS_EQ] = ACTIONS(751),
    [anon_sym_LT] = ACTIONS(753),
    [anon_sym_LT_LT] = ACTIONS(753),
    [anon_sym_LT_LT_EQ] = ACTIONS(751),
    [anon_sym_LT_EQ] = ACTIONS(751),
    [anon_sym_EQ] = ACTIONS(753),
    [anon_sym_EQ_EQ] = ACTIONS(751),
    [anon_sym_GT] = ACTIONS(753),
    [anon_sym_GT_EQ] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(753),
    [anon_sym_GT_GT_EQ] = ACTIONS(751),
    [anon_sym_PIPE] = ACTIONS(753),
    [anon_sym_PIPE_EQ] = ACTIONS(751),
    [anon_sym_PIPE_PIPE] = ACTIONS(751),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_DOT_DOT] = ACTIONS(753),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(751),
    [anon_sym_as] = ACTIONS(751),
    [sym_line_comment] = ACTIONS(7),
  },
  [3238] = {
    [sym_function_modifiers] = STATE(3246),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3462),
    [sym_bracketed_type] = STATE(3244),
    [sym_lifetime] = STATE(3463),
    [sym_array_type] = STATE(3462),
    [sym_function_type] = STATE(3462),
    [sym_tuple_type] = STATE(3462),
    [sym_unit_type] = STATE(3462),
    [sym_generic_type] = STATE(3249),
    [sym_generic_type_with_turbofish] = STATE(3250),
    [sym_bounded_type] = STATE(3462),
    [sym_reference_type] = STATE(3462),
    [sym_pointer_type] = STATE(3462),
    [sym_empty_type] = STATE(3462),
    [sym_dynamic_type] = STATE(3462),
    [sym_macro_invocation] = STATE(3462),
    [sym_scoped_identifier] = STATE(3251),
    [sym_scoped_type_identifier] = STATE(3252),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7059),
    [anon_sym_LBRACK] = ACTIONS(7061),
    [anon_sym_STAR] = ACTIONS(7063),
    [anon_sym_u8] = ACTIONS(7065),
    [anon_sym_i8] = ACTIONS(7065),
    [anon_sym_u16] = ACTIONS(7065),
    [anon_sym_i16] = ACTIONS(7065),
    [anon_sym_u32] = ACTIONS(7065),
    [anon_sym_i32] = ACTIONS(7065),
    [anon_sym_u64] = ACTIONS(7065),
    [anon_sym_i64] = ACTIONS(7065),
    [anon_sym_u128] = ACTIONS(7065),
    [anon_sym_i128] = ACTIONS(7065),
    [anon_sym_isize] = ACTIONS(7065),
    [anon_sym_usize] = ACTIONS(7065),
    [anon_sym_f32] = ACTIONS(7065),
    [anon_sym_f64] = ACTIONS(7065),
    [anon_sym_bool] = ACTIONS(7065),
    [anon_sym_str] = ACTIONS(7065),
    [anon_sym_char] = ACTIONS(7065),
    [anon_sym_AMP] = ACTIONS(7067),
    [anon_sym_COLON_COLON] = ACTIONS(7069),
    [anon_sym_BANG] = ACTIONS(7071),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(7073),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(7075),
    [sym_mutable_specifier] = ACTIONS(7471),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7077),
    [sym_self] = ACTIONS(7079),
    [sym_super] = ACTIONS(7079),
    [sym_crate] = ACTIONS(7079),
    [sym_metavariable] = ACTIONS(7081),
  },
  [3239] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7473),
  },
  [3240] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(761),
    [anon_sym_EQ_GT] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_STAR] = ACTIONS(2623),
    [anon_sym_AMP] = ACTIONS(2623),
    [anon_sym_DASH] = ACTIONS(2623),
    [anon_sym_DOT] = ACTIONS(2623),
    [anon_sym_DASH_EQ] = ACTIONS(761),
    [anon_sym_BANG_EQ] = ACTIONS(761),
    [anon_sym_STAR_EQ] = ACTIONS(761),
    [anon_sym_SLASH] = ACTIONS(2623),
    [anon_sym_SLASH_EQ] = ACTIONS(761),
    [anon_sym_AMP_AMP] = ACTIONS(761),
    [anon_sym_AMP_EQ] = ACTIONS(761),
    [anon_sym_PERCENT] = ACTIONS(2623),
    [anon_sym_PERCENT_EQ] = ACTIONS(761),
    [anon_sym_CARET] = ACTIONS(2623),
    [anon_sym_CARET_EQ] = ACTIONS(761),
    [anon_sym_PLUS_EQ] = ACTIONS(761),
    [anon_sym_LT] = ACTIONS(2623),
    [anon_sym_LT_LT] = ACTIONS(2623),
    [anon_sym_LT_LT_EQ] = ACTIONS(761),
    [anon_sym_LT_EQ] = ACTIONS(761),
    [anon_sym_EQ] = ACTIONS(2623),
    [anon_sym_EQ_EQ] = ACTIONS(761),
    [anon_sym_GT] = ACTIONS(2623),
    [anon_sym_GT_EQ] = ACTIONS(761),
    [anon_sym_GT_GT] = ACTIONS(2623),
    [anon_sym_GT_GT_EQ] = ACTIONS(761),
    [anon_sym_PIPE] = ACTIONS(2623),
    [anon_sym_PIPE_EQ] = ACTIONS(761),
    [anon_sym_PIPE_PIPE] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(761),
    [anon_sym_DOT_DOT] = ACTIONS(2623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(761),
    [anon_sym_as] = ACTIONS(761),
    [sym_line_comment] = ACTIONS(7),
  },
  [3241] = {
    [sym_parameters] = STATE(3466),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7475),
    [sym_line_comment] = ACTIONS(7),
  },
  [3242] = {
    [sym_bracketed_type] = STATE(3244),
    [sym_generic_type] = STATE(3469),
    [sym_generic_type_with_turbofish] = STATE(3250),
    [sym_scoped_identifier] = STATE(3251),
    [sym_scoped_type_identifier] = STATE(3470),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(7477),
    [anon_sym_i8] = ACTIONS(7477),
    [anon_sym_u16] = ACTIONS(7477),
    [anon_sym_i16] = ACTIONS(7477),
    [anon_sym_u32] = ACTIONS(7477),
    [anon_sym_i32] = ACTIONS(7477),
    [anon_sym_u64] = ACTIONS(7477),
    [anon_sym_i64] = ACTIONS(7477),
    [anon_sym_u128] = ACTIONS(7477),
    [anon_sym_i128] = ACTIONS(7477),
    [anon_sym_isize] = ACTIONS(7477),
    [anon_sym_usize] = ACTIONS(7477),
    [anon_sym_f32] = ACTIONS(7477),
    [anon_sym_f64] = ACTIONS(7477),
    [anon_sym_bool] = ACTIONS(7477),
    [anon_sym_str] = ACTIONS(7477),
    [anon_sym_char] = ACTIONS(7477),
    [anon_sym_COLON_COLON] = ACTIONS(7069),
    [anon_sym_LT] = ACTIONS(31),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7479),
    [sym_self] = ACTIONS(7079),
    [sym_super] = ACTIONS(7079),
    [sym_crate] = ACTIONS(7079),
    [sym_metavariable] = ACTIONS(7481),
  },
  [3243] = {
    [sym_parameters] = STATE(3472),
    [sym_type_arguments] = STATE(3473),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7475),
    [anon_sym_EQ_GT] = ACTIONS(773),
    [anon_sym_LBRACK] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(2633),
    [anon_sym_STAR] = ACTIONS(2633),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_DASH] = ACTIONS(2633),
    [anon_sym_DOT] = ACTIONS(2633),
    [anon_sym_DASH_EQ] = ACTIONS(773),
    [anon_sym_COLON_COLON] = ACTIONS(7483),
    [anon_sym_BANG] = ACTIONS(6304),
    [anon_sym_BANG_EQ] = ACTIONS(773),
    [anon_sym_STAR_EQ] = ACTIONS(773),
    [anon_sym_SLASH] = ACTIONS(2633),
    [anon_sym_SLASH_EQ] = ACTIONS(773),
    [anon_sym_AMP_AMP] = ACTIONS(773),
    [anon_sym_AMP_EQ] = ACTIONS(773),
    [anon_sym_PERCENT] = ACTIONS(2633),
    [anon_sym_PERCENT_EQ] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(2633),
    [anon_sym_CARET_EQ] = ACTIONS(773),
    [anon_sym_PLUS_EQ] = ACTIONS(773),
    [anon_sym_LT] = ACTIONS(7485),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_LT_LT_EQ] = ACTIONS(773),
    [anon_sym_LT_EQ] = ACTIONS(773),
    [anon_sym_EQ] = ACTIONS(2633),
    [anon_sym_EQ_EQ] = ACTIONS(773),
    [anon_sym_GT] = ACTIONS(2633),
    [anon_sym_GT_EQ] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(2633),
    [anon_sym_GT_GT_EQ] = ACTIONS(773),
    [anon_sym_PIPE] = ACTIONS(2633),
    [anon_sym_PIPE_EQ] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(773),
    [anon_sym_QMARK] = ACTIONS(773),
    [anon_sym_DOT_DOT] = ACTIONS(2633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(773),
    [anon_sym_as] = ACTIONS(773),
    [sym_line_comment] = ACTIONS(7),
  },
  [3244] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON_COLON] = ACTIONS(7487),
    [sym_line_comment] = ACTIONS(7),
  },
  [3245] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(783),
    [anon_sym_EQ_GT] = ACTIONS(783),
    [anon_sym_LBRACK] = ACTIONS(783),
    [anon_sym_PLUS] = ACTIONS(785),
    [anon_sym_STAR] = ACTIONS(785),
    [anon_sym_AMP] = ACTIONS(785),
    [anon_sym_DASH] = ACTIONS(785),
    [anon_sym_DOT] = ACTIONS(785),
    [anon_sym_DASH_EQ] = ACTIONS(783),
    [anon_sym_COLON_COLON] = ACTIONS(7487),
    [anon_sym_BANG_EQ] = ACTIONS(783),
    [anon_sym_STAR_EQ] = ACTIONS(783),
    [anon_sym_SLASH] = ACTIONS(785),
    [anon_sym_SLASH_EQ] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_AMP_EQ] = ACTIONS(783),
    [anon_sym_PERCENT] = ACTIONS(785),
    [anon_sym_PERCENT_EQ] = ACTIONS(783),
    [anon_sym_CARET] = ACTIONS(785),
    [anon_sym_CARET_EQ] = ACTIONS(783),
    [anon_sym_PLUS_EQ] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(785),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_LT_LT_EQ] = ACTIONS(783),
    [anon_sym_LT_EQ] = ACTIONS(783),
    [anon_sym_EQ] = ACTIONS(785),
    [anon_sym_EQ_EQ] = ACTIONS(783),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_GT_EQ] = ACTIONS(783),
    [anon_sym_GT_GT] = ACTIONS(785),
    [anon_sym_GT_GT_EQ] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PIPE_EQ] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_DOT_DOT] = ACTIONS(785),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(783),
    [anon_sym_as] = ACTIONS(783),
    [sym_line_comment] = ACTIONS(7),
  },
  [3246] = {
    [sym_bracketed_type] = STATE(122),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(3477),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_fn] = ACTIONS(7489),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7491),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [3247] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2645),
    [anon_sym_EQ_GT] = ACTIONS(2645),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_PLUS] = ACTIONS(2647),
    [anon_sym_STAR] = ACTIONS(2647),
    [anon_sym_AMP] = ACTIONS(2647),
    [anon_sym_DASH] = ACTIONS(2647),
    [anon_sym_DOT] = ACTIONS(2647),
    [anon_sym_DASH_EQ] = ACTIONS(2645),
    [anon_sym_BANG_EQ] = ACTIONS(2645),
    [anon_sym_STAR_EQ] = ACTIONS(2645),
    [anon_sym_SLASH] = ACTIONS(2647),
    [anon_sym_SLASH_EQ] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP_EQ] = ACTIONS(2645),
    [anon_sym_PERCENT] = ACTIONS(2647),
    [anon_sym_PERCENT_EQ] = ACTIONS(2645),
    [anon_sym_CARET] = ACTIONS(2647),
    [anon_sym_CARET_EQ] = ACTIONS(2645),
    [anon_sym_PLUS_EQ] = ACTIONS(2645),
    [anon_sym_LT] = ACTIONS(2647),
    [anon_sym_LT_LT] = ACTIONS(2647),
    [anon_sym_LT_LT_EQ] = ACTIONS(2645),
    [anon_sym_LT_EQ] = ACTIONS(2645),
    [anon_sym_EQ] = ACTIONS(2647),
    [anon_sym_EQ_EQ] = ACTIONS(2645),
    [anon_sym_GT] = ACTIONS(2647),
    [anon_sym_GT_EQ] = ACTIONS(2645),
    [anon_sym_GT_GT] = ACTIONS(2647),
    [anon_sym_GT_GT_EQ] = ACTIONS(2645),
    [anon_sym_PIPE] = ACTIONS(2647),
    [anon_sym_PIPE_EQ] = ACTIONS(2645),
    [anon_sym_PIPE_PIPE] = ACTIONS(2645),
    [anon_sym_QMARK] = ACTIONS(2645),
    [anon_sym_DOT_DOT] = ACTIONS(2647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2645),
    [anon_sym_as] = ACTIONS(2645),
    [sym_line_comment] = ACTIONS(7),
  },
  [3248] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7493),
    [sym_line_comment] = ACTIONS(7),
  },
  [3249] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(783),
    [anon_sym_EQ_GT] = ACTIONS(783),
    [anon_sym_LBRACK] = ACTIONS(783),
    [anon_sym_PLUS] = ACTIONS(785),
    [anon_sym_STAR] = ACTIONS(785),
    [anon_sym_AMP] = ACTIONS(785),
    [anon_sym_DASH] = ACTIONS(785),
    [anon_sym_DOT] = ACTIONS(785),
    [anon_sym_DASH_EQ] = ACTIONS(783),
    [anon_sym_COLON_COLON] = ACTIONS(7495),
    [anon_sym_BANG_EQ] = ACTIONS(783),
    [anon_sym_STAR_EQ] = ACTIONS(783),
    [anon_sym_SLASH] = ACTIONS(785),
    [anon_sym_SLASH_EQ] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_AMP_EQ] = ACTIONS(783),
    [anon_sym_PERCENT] = ACTIONS(785),
    [anon_sym_PERCENT_EQ] = ACTIONS(783),
    [anon_sym_CARET] = ACTIONS(785),
    [anon_sym_CARET_EQ] = ACTIONS(783),
    [anon_sym_PLUS_EQ] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(785),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_LT_LT_EQ] = ACTIONS(783),
    [anon_sym_LT_EQ] = ACTIONS(783),
    [anon_sym_EQ] = ACTIONS(785),
    [anon_sym_EQ_EQ] = ACTIONS(783),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_GT_EQ] = ACTIONS(783),
    [anon_sym_GT_GT] = ACTIONS(785),
    [anon_sym_GT_GT_EQ] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PIPE_EQ] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_DOT_DOT] = ACTIONS(785),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(783),
    [anon_sym_as] = ACTIONS(783),
    [sym_line_comment] = ACTIONS(7),
  },
  [3250] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON_COLON] = ACTIONS(7497),
    [sym_line_comment] = ACTIONS(7),
  },
  [3251] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON_COLON] = ACTIONS(7499),
    [sym_line_comment] = ACTIONS(7),
  },
  [3252] = {
    [sym_parameters] = STATE(3466),
    [sym_type_arguments] = STATE(3483),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7475),
    [anon_sym_EQ_GT] = ACTIONS(783),
    [anon_sym_LBRACK] = ACTIONS(783),
    [anon_sym_PLUS] = ACTIONS(785),
    [anon_sym_STAR] = ACTIONS(785),
    [anon_sym_AMP] = ACTIONS(785),
    [anon_sym_DASH] = ACTIONS(785),
    [anon_sym_DOT] = ACTIONS(785),
    [anon_sym_DASH_EQ] = ACTIONS(783),
    [anon_sym_BANG_EQ] = ACTIONS(783),
    [anon_sym_STAR_EQ] = ACTIONS(783),
    [anon_sym_SLASH] = ACTIONS(785),
    [anon_sym_SLASH_EQ] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_AMP_EQ] = ACTIONS(783),
    [anon_sym_PERCENT] = ACTIONS(785),
    [anon_sym_PERCENT_EQ] = ACTIONS(783),
    [anon_sym_CARET] = ACTIONS(785),
    [anon_sym_CARET_EQ] = ACTIONS(783),
    [anon_sym_PLUS_EQ] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(7485),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_LT_LT_EQ] = ACTIONS(783),
    [anon_sym_LT_EQ] = ACTIONS(783),
    [anon_sym_EQ] = ACTIONS(785),
    [anon_sym_EQ_EQ] = ACTIONS(783),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_GT_EQ] = ACTIONS(783),
    [anon_sym_GT_GT] = ACTIONS(785),
    [anon_sym_GT_GT_EQ] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_PIPE_EQ] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(783),
    [anon_sym_DOT_DOT] = ACTIONS(785),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(783),
    [anon_sym_as] = ACTIONS(783),
    [sym_line_comment] = ACTIONS(7),
  },
  [3253] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2269),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_EQ_GT] = ACTIONS(2269),
    [anon_sym_LBRACK] = ACTIONS(2269),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(2273),
    [anon_sym_AMP] = ACTIONS(2273),
    [anon_sym_DASH] = ACTIONS(2273),
    [anon_sym_DOT] = ACTIONS(2273),
    [anon_sym_DASH_EQ] = ACTIONS(2269),
    [anon_sym_COLON_COLON] = ACTIONS(2657),
    [anon_sym_BANG_EQ] = ACTIONS(2269),
    [anon_sym_STAR_EQ] = ACTIONS(2269),
    [anon_sym_SLASH] = ACTIONS(2273),
    [anon_sym_SLASH_EQ] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2269),
    [anon_sym_AMP_EQ] = ACTIONS(2269),
    [anon_sym_PERCENT] = ACTIONS(2273),
    [anon_sym_PERCENT_EQ] = ACTIONS(2269),
    [anon_sym_CARET] = ACTIONS(2273),
    [anon_sym_CARET_EQ] = ACTIONS(2269),
    [anon_sym_PLUS_EQ] = ACTIONS(2269),
    [anon_sym_LT] = ACTIONS(2273),
    [anon_sym_LT_LT] = ACTIONS(2273),
    [anon_sym_LT_LT_EQ] = ACTIONS(2269),
    [anon_sym_LT_EQ] = ACTIONS(2269),
    [anon_sym_EQ] = ACTIONS(2273),
    [anon_sym_EQ_EQ] = ACTIONS(2269),
    [anon_sym_GT] = ACTIONS(2273),
    [anon_sym_GT_EQ] = ACTIONS(2269),
    [anon_sym_GT_GT] = ACTIONS(2273),
    [anon_sym_GT_GT_EQ] = ACTIONS(2269),
    [anon_sym_PIPE] = ACTIONS(2273),
    [anon_sym_PIPE_EQ] = ACTIONS(2269),
    [anon_sym_PIPE_PIPE] = ACTIONS(2269),
    [anon_sym_QMARK] = ACTIONS(2269),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2269),
    [anon_sym_as] = ACTIONS(2269),
    [sym_line_comment] = ACTIONS(7),
  },
  [3254] = {
    [sym_block] = STATE(3484),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_PLUS] = ACTIONS(2667),
    [sym_line_comment] = ACTIONS(7),
  },
  [3255] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(3485),
    [sym_tuple_pattern] = STATE(3485),
    [sym_tuple_struct_pattern] = STATE(3485),
    [sym_struct_pattern] = STATE(3485),
    [sym_remaining_field_pattern] = STATE(3485),
    [sym_mut_pattern] = STATE(3485),
    [sym_ref_pattern] = STATE(3485),
    [sym_captured_pattern] = STATE(3485),
    [sym_reference_pattern] = STATE(3485),
    [sym__literal] = STATE(3485),
    [sym_string_literal] = STATE(3485),
    [sym_boolean_literal] = STATE(3485),
    [sym_raw_string_literal] = ACTIONS(7501),
    [sym_float_literal] = ACTIONS(7501),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(7503),
    [anon_sym_AMP] = ACTIONS(293),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(295),
    [anon_sym_ref] = ACTIONS(297),
    [sym_integer_literal] = ACTIONS(7501),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(299),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [3256] = {
    [sym_block] = STATE(3486),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [sym_line_comment] = ACTIONS(7),
  },
  [3257] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3488),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(3488),
    [sym_macro_invocation] = STATE(3488),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3488),
    [sym_unary_expression] = STATE(3488),
    [sym_try_expression] = STATE(3488),
    [sym_reference_expression] = STATE(3488),
    [sym_binary_expression] = STATE(3488),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3488),
    [sym_call_expression] = STATE(3488),
    [sym_array_expression] = STATE(3488),
    [sym_parenthesized_expression] = STATE(3488),
    [sym_tuple_expression] = STATE(3488),
    [sym_unit_expression] = STATE(3488),
    [sym_struct_expression] = STATE(3488),
    [sym_if_expression] = STATE(3488),
    [sym_if_let_expression] = STATE(3488),
    [sym_match_expression] = STATE(3488),
    [sym_while_expression] = STATE(3488),
    [sym_while_let_expression] = STATE(3488),
    [sym_loop_expression] = STATE(3488),
    [sym_for_expression] = STATE(3488),
    [sym_closure_expression] = STATE(3488),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3488),
    [sym_continue_expression] = STATE(3488),
    [sym_index_expression] = STATE(3488),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3488),
    [sym_block] = STATE(3488),
    [sym__literal] = STATE(3488),
    [sym_string_literal] = STATE(3488),
    [sym_boolean_literal] = STATE(3488),
    [sym_raw_string_literal] = ACTIONS(7505),
    [sym_float_literal] = ACTIONS(7505),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_let] = ACTIONS(7507),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(7505),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7505),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [3258] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2269),
    [anon_sym_EQ_GT] = ACTIONS(2269),
    [anon_sym_LBRACK] = ACTIONS(2269),
    [anon_sym_PLUS] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(2273),
    [anon_sym_AMP] = ACTIONS(2273),
    [anon_sym_DASH] = ACTIONS(2273),
    [anon_sym_DOT] = ACTIONS(2273),
    [anon_sym_DASH_EQ] = ACTIONS(2269),
    [anon_sym_BANG_EQ] = ACTIONS(2269),
    [anon_sym_STAR_EQ] = ACTIONS(2269),
    [anon_sym_SLASH] = ACTIONS(2273),
    [anon_sym_SLASH_EQ] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2269),
    [anon_sym_AMP_EQ] = ACTIONS(2269),
    [anon_sym_PERCENT] = ACTIONS(2273),
    [anon_sym_PERCENT_EQ] = ACTIONS(2269),
    [anon_sym_CARET] = ACTIONS(2273),
    [anon_sym_CARET_EQ] = ACTIONS(2269),
    [anon_sym_PLUS_EQ] = ACTIONS(2269),
    [anon_sym_LT] = ACTIONS(2273),
    [anon_sym_LT_LT] = ACTIONS(2273),
    [anon_sym_LT_LT_EQ] = ACTIONS(2269),
    [anon_sym_LT_EQ] = ACTIONS(2269),
    [anon_sym_EQ] = ACTIONS(2273),
    [anon_sym_EQ_EQ] = ACTIONS(2269),
    [anon_sym_GT] = ACTIONS(2273),
    [anon_sym_GT_EQ] = ACTIONS(2269),
    [anon_sym_GT_GT] = ACTIONS(2273),
    [anon_sym_GT_GT_EQ] = ACTIONS(2269),
    [anon_sym_PIPE] = ACTIONS(2273),
    [anon_sym_PIPE_EQ] = ACTIONS(2269),
    [anon_sym_PIPE_PIPE] = ACTIONS(2269),
    [anon_sym_QMARK] = ACTIONS(2269),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2269),
    [anon_sym_as] = ACTIONS(2269),
    [sym_line_comment] = ACTIONS(7),
  },
  [3259] = {
    [sym_raw_string_literal] = ACTIONS(7509),
    [sym_float_literal] = ACTIONS(7509),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7509),
    [anon_sym_RBRACE] = ACTIONS(7511),
    [anon_sym_u8] = ACTIONS(7513),
    [anon_sym_i8] = ACTIONS(7513),
    [anon_sym_u16] = ACTIONS(7513),
    [anon_sym_i16] = ACTIONS(7513),
    [anon_sym_u32] = ACTIONS(7513),
    [anon_sym_i32] = ACTIONS(7513),
    [anon_sym_u64] = ACTIONS(7513),
    [anon_sym_i64] = ACTIONS(7513),
    [anon_sym_u128] = ACTIONS(7513),
    [anon_sym_i128] = ACTIONS(7513),
    [anon_sym_isize] = ACTIONS(7513),
    [anon_sym_usize] = ACTIONS(7513),
    [anon_sym_f32] = ACTIONS(7513),
    [anon_sym_f64] = ACTIONS(7513),
    [anon_sym_bool] = ACTIONS(7513),
    [anon_sym_str] = ACTIONS(7513),
    [anon_sym_char] = ACTIONS(7513),
    [anon_sym__] = ACTIONS(7513),
    [anon_sym_AMP] = ACTIONS(7509),
    [anon_sym_COLON_COLON] = ACTIONS(7509),
    [anon_sym_POUND] = ACTIONS(7509),
    [anon_sym_LT] = ACTIONS(7509),
    [anon_sym_DOT_DOT] = ACTIONS(7509),
    [sym_mutable_specifier] = ACTIONS(7513),
    [anon_sym_ref] = ACTIONS(7513),
    [sym_integer_literal] = ACTIONS(7509),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7509),
    [sym_char_literal] = ACTIONS(7509),
    [anon_sym_true] = ACTIONS(7513),
    [anon_sym_false] = ACTIONS(7513),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7513),
    [sym_self] = ACTIONS(7513),
    [sym_super] = ACTIONS(7513),
    [sym_crate] = ACTIONS(7513),
    [sym_metavariable] = ACTIONS(7509),
  },
  [3260] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3490),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(3490),
    [sym_macro_invocation] = STATE(3490),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3490),
    [sym_unary_expression] = STATE(3490),
    [sym_try_expression] = STATE(3490),
    [sym_reference_expression] = STATE(3490),
    [sym_binary_expression] = STATE(3490),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3490),
    [sym_call_expression] = STATE(3490),
    [sym_array_expression] = STATE(3490),
    [sym_parenthesized_expression] = STATE(3490),
    [sym_tuple_expression] = STATE(3490),
    [sym_unit_expression] = STATE(3490),
    [sym_struct_expression] = STATE(3490),
    [sym_if_expression] = STATE(3490),
    [sym_if_let_expression] = STATE(3490),
    [sym_match_expression] = STATE(3490),
    [sym_while_expression] = STATE(3490),
    [sym_while_let_expression] = STATE(3490),
    [sym_loop_expression] = STATE(3490),
    [sym_for_expression] = STATE(3490),
    [sym_closure_expression] = STATE(3490),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3490),
    [sym_continue_expression] = STATE(3490),
    [sym_index_expression] = STATE(3490),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3490),
    [sym_block] = STATE(3490),
    [sym__literal] = STATE(3490),
    [sym_string_literal] = STATE(3490),
    [sym_boolean_literal] = STATE(3490),
    [sym_raw_string_literal] = ACTIONS(7515),
    [sym_float_literal] = ACTIONS(7515),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_let] = ACTIONS(7517),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(7515),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7515),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [3261] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(5886),
    [anon_sym_STAR] = ACTIONS(5888),
    [anon_sym_COMMA] = ACTIONS(7519),
    [anon_sym_AMP] = ACTIONS(5890),
    [anon_sym_DASH] = ACTIONS(5886),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(5892),
    [anon_sym_BANG_EQ] = ACTIONS(5894),
    [anon_sym_STAR_EQ] = ACTIONS(5892),
    [anon_sym_SLASH] = ACTIONS(5888),
    [anon_sym_SLASH_EQ] = ACTIONS(5892),
    [anon_sym_AMP_AMP] = ACTIONS(5896),
    [anon_sym_AMP_EQ] = ACTIONS(5892),
    [anon_sym_PERCENT] = ACTIONS(5888),
    [anon_sym_PERCENT_EQ] = ACTIONS(5892),
    [anon_sym_CARET] = ACTIONS(5898),
    [anon_sym_CARET_EQ] = ACTIONS(5892),
    [anon_sym_PLUS_EQ] = ACTIONS(5892),
    [anon_sym_LT] = ACTIONS(5900),
    [anon_sym_LT_LT] = ACTIONS(5902),
    [anon_sym_LT_LT_EQ] = ACTIONS(5892),
    [anon_sym_LT_EQ] = ACTIONS(5894),
    [anon_sym_EQ] = ACTIONS(5904),
    [anon_sym_EQ_EQ] = ACTIONS(5894),
    [anon_sym_GT] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5894),
    [anon_sym_GT_GT] = ACTIONS(5902),
    [anon_sym_GT_GT_EQ] = ACTIONS(5892),
    [anon_sym_PIPE] = ACTIONS(5906),
    [anon_sym_PIPE_EQ] = ACTIONS(5892),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(5910),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5912),
    [anon_sym_as] = ACTIONS(5914),
    [sym_line_comment] = ACTIONS(7),
  },
  [3262] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3492),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3492),
    [sym_macro_invocation] = STATE(3492),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3492),
    [sym_unary_expression] = STATE(3492),
    [sym_try_expression] = STATE(3492),
    [sym_reference_expression] = STATE(3492),
    [sym_binary_expression] = STATE(3492),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3492),
    [sym_call_expression] = STATE(3492),
    [sym_array_expression] = STATE(3492),
    [sym_parenthesized_expression] = STATE(3492),
    [sym_tuple_expression] = STATE(3492),
    [sym_unit_expression] = STATE(3492),
    [sym_struct_expression] = STATE(3492),
    [sym_if_expression] = STATE(2884),
    [sym_if_let_expression] = STATE(2884),
    [sym_match_expression] = STATE(2884),
    [sym_while_expression] = STATE(2884),
    [sym_while_let_expression] = STATE(2884),
    [sym_loop_expression] = STATE(2884),
    [sym_for_expression] = STATE(2884),
    [sym_closure_expression] = STATE(3492),
    [sym_closure_parameters] = STATE(2062),
    [sym_loop_label] = STATE(2325),
    [sym_break_expression] = STATE(3492),
    [sym_continue_expression] = STATE(3492),
    [sym_index_expression] = STATE(3492),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(2884),
    [sym_block] = STATE(2884),
    [sym__literal] = STATE(3492),
    [sym_string_literal] = STATE(3492),
    [sym_boolean_literal] = STATE(3492),
    [sym_raw_string_literal] = ACTIONS(7521),
    [sym_float_literal] = ACTIONS(7521),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(5136),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(5862),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(5864),
    [anon_sym_DASH] = ACTIONS(5862),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(5866),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(5138),
    [anon_sym_if] = ACTIONS(7095),
    [anon_sym_loop] = ACTIONS(5142),
    [anon_sym_match] = ACTIONS(5144),
    [anon_sym_return] = ACTIONS(5870),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(5146),
    [anon_sym_while] = ACTIONS(5148),
    [anon_sym_move] = ACTIONS(5872),
    [sym_integer_literal] = ACTIONS(7521),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7521),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [3263] = {
    [sym_raw_string_literal] = ACTIONS(7523),
    [sym_float_literal] = ACTIONS(7523),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(7523),
    [anon_sym_SEMI] = ACTIONS(7523),
    [anon_sym_macro_rules_BANG] = ACTIONS(7523),
    [anon_sym_LPAREN] = ACTIONS(7523),
    [anon_sym_LBRACE] = ACTIONS(7523),
    [anon_sym_RBRACE] = ACTIONS(7523),
    [anon_sym_LBRACK] = ACTIONS(7523),
    [anon_sym_STAR] = ACTIONS(7523),
    [anon_sym_u8] = ACTIONS(7525),
    [anon_sym_i8] = ACTIONS(7525),
    [anon_sym_u16] = ACTIONS(7525),
    [anon_sym_i16] = ACTIONS(7525),
    [anon_sym_u32] = ACTIONS(7525),
    [anon_sym_i32] = ACTIONS(7525),
    [anon_sym_u64] = ACTIONS(7525),
    [anon_sym_i64] = ACTIONS(7525),
    [anon_sym_u128] = ACTIONS(7525),
    [anon_sym_i128] = ACTIONS(7525),
    [anon_sym_isize] = ACTIONS(7525),
    [anon_sym_usize] = ACTIONS(7525),
    [anon_sym_f32] = ACTIONS(7525),
    [anon_sym_f64] = ACTIONS(7525),
    [anon_sym_bool] = ACTIONS(7525),
    [anon_sym_str] = ACTIONS(7525),
    [anon_sym_char] = ACTIONS(7525),
    [anon_sym_AMP] = ACTIONS(7523),
    [anon_sym_DASH] = ACTIONS(7523),
    [anon_sym_COLON_COLON] = ACTIONS(7523),
    [anon_sym_BANG] = ACTIONS(7523),
    [anon_sym_POUND] = ACTIONS(7523),
    [anon_sym_LT] = ACTIONS(7523),
    [anon_sym_PIPE] = ACTIONS(7523),
    [anon_sym_SQUOTE] = ACTIONS(7525),
    [anon_sym_DOT_DOT] = ACTIONS(7523),
    [anon_sym_break] = ACTIONS(7525),
    [anon_sym_const] = ACTIONS(7525),
    [anon_sym_continue] = ACTIONS(7525),
    [anon_sym_default] = ACTIONS(7525),
    [anon_sym_enum] = ACTIONS(7525),
    [anon_sym_fn] = ACTIONS(7525),
    [anon_sym_for] = ACTIONS(7525),
    [anon_sym_if] = ACTIONS(7525),
    [anon_sym_impl] = ACTIONS(7525),
    [anon_sym_let] = ACTIONS(7525),
    [anon_sym_loop] = ACTIONS(7525),
    [anon_sym_match] = ACTIONS(7525),
    [anon_sym_mod] = ACTIONS(7525),
    [anon_sym_pub] = ACTIONS(7525),
    [anon_sym_return] = ACTIONS(7525),
    [anon_sym_static] = ACTIONS(7525),
    [anon_sym_struct] = ACTIONS(7525),
    [anon_sym_trait] = ACTIONS(7525),
    [anon_sym_type] = ACTIONS(7525),
    [anon_sym_union] = ACTIONS(7525),
    [anon_sym_unsafe] = ACTIONS(7525),
    [anon_sym_use] = ACTIONS(7525),
    [anon_sym_while] = ACTIONS(7525),
    [anon_sym_extern] = ACTIONS(7525),
    [anon_sym_move] = ACTIONS(7525),
    [sym_integer_literal] = ACTIONS(7523),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7523),
    [sym_char_literal] = ACTIONS(7523),
    [anon_sym_true] = ACTIONS(7525),
    [anon_sym_false] = ACTIONS(7525),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7525),
    [sym_self] = ACTIONS(7525),
    [sym_super] = ACTIONS(7525),
    [sym_crate] = ACTIONS(7525),
    [sym_metavariable] = ACTIONS(7523),
  },
  [3264] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5267),
    [anon_sym_LBRACK] = ACTIONS(5267),
    [anon_sym_STAR] = ACTIONS(5267),
    [anon_sym_u8] = ACTIONS(7527),
    [anon_sym_i8] = ACTIONS(7527),
    [anon_sym_u16] = ACTIONS(7527),
    [anon_sym_i16] = ACTIONS(7527),
    [anon_sym_u32] = ACTIONS(7527),
    [anon_sym_i32] = ACTIONS(7527),
    [anon_sym_u64] = ACTIONS(7527),
    [anon_sym_i64] = ACTIONS(7527),
    [anon_sym_u128] = ACTIONS(7527),
    [anon_sym_i128] = ACTIONS(7527),
    [anon_sym_isize] = ACTIONS(7527),
    [anon_sym_usize] = ACTIONS(7527),
    [anon_sym_f32] = ACTIONS(7527),
    [anon_sym_f64] = ACTIONS(7527),
    [anon_sym_bool] = ACTIONS(7527),
    [anon_sym_str] = ACTIONS(7527),
    [anon_sym_char] = ACTIONS(7527),
    [anon_sym_AMP] = ACTIONS(5267),
    [anon_sym_COLON_COLON] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5267),
    [anon_sym_LT] = ACTIONS(5267),
    [anon_sym_SQUOTE] = ACTIONS(5267),
    [anon_sym_const] = ACTIONS(7527),
    [anon_sym_default] = ACTIONS(7527),
    [anon_sym_fn] = ACTIONS(7527),
    [anon_sym_unsafe] = ACTIONS(7527),
    [anon_sym_extern] = ACTIONS(7527),
    [anon_sym_dyn] = ACTIONS(7527),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7527),
    [sym_self] = ACTIONS(7527),
    [sym_super] = ACTIONS(7527),
    [sym_crate] = ACTIONS(7527),
    [sym_metavariable] = ACTIONS(5267),
  },
  [3265] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5269),
    [anon_sym_LBRACK] = ACTIONS(5269),
    [anon_sym_STAR] = ACTIONS(5269),
    [anon_sym_u8] = ACTIONS(7529),
    [anon_sym_i8] = ACTIONS(7529),
    [anon_sym_u16] = ACTIONS(7529),
    [anon_sym_i16] = ACTIONS(7529),
    [anon_sym_u32] = ACTIONS(7529),
    [anon_sym_i32] = ACTIONS(7529),
    [anon_sym_u64] = ACTIONS(7529),
    [anon_sym_i64] = ACTIONS(7529),
    [anon_sym_u128] = ACTIONS(7529),
    [anon_sym_i128] = ACTIONS(7529),
    [anon_sym_isize] = ACTIONS(7529),
    [anon_sym_usize] = ACTIONS(7529),
    [anon_sym_f32] = ACTIONS(7529),
    [anon_sym_f64] = ACTIONS(7529),
    [anon_sym_bool] = ACTIONS(7529),
    [anon_sym_str] = ACTIONS(7529),
    [anon_sym_char] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(5269),
    [anon_sym_COLON_COLON] = ACTIONS(5269),
    [anon_sym_BANG] = ACTIONS(5269),
    [anon_sym_LT] = ACTIONS(5269),
    [anon_sym_SQUOTE] = ACTIONS(5269),
    [anon_sym_const] = ACTIONS(7529),
    [anon_sym_default] = ACTIONS(7529),
    [anon_sym_fn] = ACTIONS(7529),
    [anon_sym_unsafe] = ACTIONS(7529),
    [anon_sym_extern] = ACTIONS(7529),
    [anon_sym_dyn] = ACTIONS(7529),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7529),
    [sym_self] = ACTIONS(7529),
    [sym_super] = ACTIONS(7529),
    [sym_crate] = ACTIONS(7529),
    [sym_metavariable] = ACTIONS(5269),
  },
  [3266] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7531),
    [anon_sym_RBRACE] = ACTIONS(7531),
    [anon_sym_COMMA] = ACTIONS(7531),
    [anon_sym_EQ] = ACTIONS(7531),
    [anon_sym_where] = ACTIONS(7531),
    [sym_line_comment] = ACTIONS(7),
  },
  [3267] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7533),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_COMMA] = ACTIONS(7533),
    [sym_line_comment] = ACTIONS(7),
  },
  [3268] = {
    [sym_attribute_item] = STATE(2378),
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym_visibility_modifier] = STATE(2376),
    [sym__type] = STATE(2377),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(2377),
    [sym_function_type] = STATE(2377),
    [sym_tuple_type] = STATE(2377),
    [sym_unit_type] = STATE(2377),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2377),
    [sym_reference_type] = STATE(2377),
    [sym_pointer_type] = STATE(2377),
    [sym_empty_type] = STATE(2377),
    [sym_dynamic_type] = STATE(2377),
    [sym_macro_invocation] = STATE(2377),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_enum_variant_list_repeat1] = STATE(2378),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_RPAREN] = ACTIONS(7535),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_POUND] = ACTIONS(2124),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_pub] = ACTIONS(2126),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3269] = {
    [sym_function_modifiers] = STATE(2385),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1479),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2387),
    [sym_array_type] = STATE(1479),
    [sym_function_type] = STATE(1479),
    [sym_tuple_type] = STATE(1479),
    [sym_unit_type] = STATE(1479),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1479),
    [sym_reference_type] = STATE(1479),
    [sym_pointer_type] = STATE(1479),
    [sym_empty_type] = STATE(1479),
    [sym_dynamic_type] = STATE(1479),
    [sym_macro_invocation] = STATE(1479),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2388),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(5298),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(5300),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5302),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5304),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3270] = {
    [sym_function_modifiers] = STATE(2385),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1499),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2387),
    [sym_array_type] = STATE(1499),
    [sym_function_type] = STATE(1499),
    [sym_tuple_type] = STATE(1499),
    [sym_unit_type] = STATE(1499),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1499),
    [sym_reference_type] = STATE(1499),
    [sym_pointer_type] = STATE(1499),
    [sym_empty_type] = STATE(1499),
    [sym_abstract_type] = STATE(1500),
    [sym_dynamic_type] = STATE(1499),
    [sym_macro_invocation] = STATE(1499),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2388),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(5298),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(5300),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5302),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5304),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3271] = {
    [sym_function_modifiers] = STATE(2385),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1525),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2387),
    [sym_array_type] = STATE(1525),
    [sym_function_type] = STATE(1525),
    [sym_tuple_type] = STATE(1525),
    [sym_unit_type] = STATE(1525),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1525),
    [sym_reference_type] = STATE(1525),
    [sym_pointer_type] = STATE(1525),
    [sym_empty_type] = STATE(1525),
    [sym_abstract_type] = STATE(1526),
    [sym_dynamic_type] = STATE(1525),
    [sym_macro_invocation] = STATE(1525),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2388),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(5298),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(5300),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5302),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5304),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3272] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_COMMA] = ACTIONS(2988),
    [anon_sym_DASH_GT] = ACTIONS(7537),
    [sym_line_comment] = ACTIONS(7),
  },
  [3273] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_COMMA] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(7539),
    [sym_line_comment] = ACTIONS(7),
  },
  [3274] = {
    [sym_raw_string_literal] = ACTIONS(7541),
    [sym_float_literal] = ACTIONS(7541),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(7541),
    [anon_sym_SEMI] = ACTIONS(7541),
    [anon_sym_macro_rules_BANG] = ACTIONS(7541),
    [anon_sym_LPAREN] = ACTIONS(7541),
    [anon_sym_LBRACE] = ACTIONS(7541),
    [anon_sym_RBRACE] = ACTIONS(7541),
    [anon_sym_LBRACK] = ACTIONS(7541),
    [anon_sym_STAR] = ACTIONS(7541),
    [anon_sym_u8] = ACTIONS(7543),
    [anon_sym_i8] = ACTIONS(7543),
    [anon_sym_u16] = ACTIONS(7543),
    [anon_sym_i16] = ACTIONS(7543),
    [anon_sym_u32] = ACTIONS(7543),
    [anon_sym_i32] = ACTIONS(7543),
    [anon_sym_u64] = ACTIONS(7543),
    [anon_sym_i64] = ACTIONS(7543),
    [anon_sym_u128] = ACTIONS(7543),
    [anon_sym_i128] = ACTIONS(7543),
    [anon_sym_isize] = ACTIONS(7543),
    [anon_sym_usize] = ACTIONS(7543),
    [anon_sym_f32] = ACTIONS(7543),
    [anon_sym_f64] = ACTIONS(7543),
    [anon_sym_bool] = ACTIONS(7543),
    [anon_sym_str] = ACTIONS(7543),
    [anon_sym_char] = ACTIONS(7543),
    [anon_sym_AMP] = ACTIONS(7541),
    [anon_sym_DASH] = ACTIONS(7541),
    [anon_sym_COLON_COLON] = ACTIONS(7541),
    [anon_sym_BANG] = ACTIONS(7541),
    [anon_sym_POUND] = ACTIONS(7541),
    [anon_sym_LT] = ACTIONS(7541),
    [anon_sym_PIPE] = ACTIONS(7541),
    [anon_sym_SQUOTE] = ACTIONS(7543),
    [anon_sym_DOT_DOT] = ACTIONS(7541),
    [anon_sym_break] = ACTIONS(7543),
    [anon_sym_const] = ACTIONS(7543),
    [anon_sym_continue] = ACTIONS(7543),
    [anon_sym_default] = ACTIONS(7543),
    [anon_sym_enum] = ACTIONS(7543),
    [anon_sym_fn] = ACTIONS(7543),
    [anon_sym_for] = ACTIONS(7543),
    [anon_sym_if] = ACTIONS(7543),
    [anon_sym_impl] = ACTIONS(7543),
    [anon_sym_let] = ACTIONS(7543),
    [anon_sym_loop] = ACTIONS(7543),
    [anon_sym_match] = ACTIONS(7543),
    [anon_sym_mod] = ACTIONS(7543),
    [anon_sym_pub] = ACTIONS(7543),
    [anon_sym_return] = ACTIONS(7543),
    [anon_sym_static] = ACTIONS(7543),
    [anon_sym_struct] = ACTIONS(7543),
    [anon_sym_trait] = ACTIONS(7543),
    [anon_sym_type] = ACTIONS(7543),
    [anon_sym_union] = ACTIONS(7543),
    [anon_sym_unsafe] = ACTIONS(7543),
    [anon_sym_use] = ACTIONS(7543),
    [anon_sym_while] = ACTIONS(7543),
    [anon_sym_extern] = ACTIONS(7543),
    [anon_sym_move] = ACTIONS(7543),
    [sym_integer_literal] = ACTIONS(7541),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7541),
    [sym_char_literal] = ACTIONS(7541),
    [anon_sym_true] = ACTIONS(7543),
    [anon_sym_false] = ACTIONS(7543),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7543),
    [sym_self] = ACTIONS(7543),
    [sym_super] = ACTIONS(7543),
    [sym_crate] = ACTIONS(7543),
    [sym_metavariable] = ACTIONS(7541),
  },
  [3275] = {
    [sym_function_modifiers] = STATE(2402),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(862),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2405),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(5312),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(5314),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5318),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5322),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3276] = {
    [sym_function_modifiers] = STATE(2402),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2919),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2405),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(5312),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(5314),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5318),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5322),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3277] = {
    [sym_function_modifiers] = STATE(2402),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1479),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2919),
    [sym_array_type] = STATE(1479),
    [sym_function_type] = STATE(1479),
    [sym_tuple_type] = STATE(1479),
    [sym_unit_type] = STATE(1479),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1479),
    [sym_reference_type] = STATE(1479),
    [sym_pointer_type] = STATE(1479),
    [sym_empty_type] = STATE(1479),
    [sym_dynamic_type] = STATE(1479),
    [sym_macro_invocation] = STATE(1479),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2405),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(5312),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(5314),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5318),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5322),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3278] = {
    [sym_function_modifiers] = STATE(2402),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1499),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2919),
    [sym_array_type] = STATE(1499),
    [sym_function_type] = STATE(1499),
    [sym_tuple_type] = STATE(1499),
    [sym_unit_type] = STATE(1499),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1499),
    [sym_reference_type] = STATE(1499),
    [sym_pointer_type] = STATE(1499),
    [sym_empty_type] = STATE(1499),
    [sym_abstract_type] = STATE(1500),
    [sym_dynamic_type] = STATE(1499),
    [sym_macro_invocation] = STATE(1499),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2405),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(5312),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(5314),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5318),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5322),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3279] = {
    [sym_function_modifiers] = STATE(2402),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1525),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2919),
    [sym_array_type] = STATE(1525),
    [sym_function_type] = STATE(1525),
    [sym_tuple_type] = STATE(1525),
    [sym_unit_type] = STATE(1525),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1525),
    [sym_reference_type] = STATE(1525),
    [sym_pointer_type] = STATE(1525),
    [sym_empty_type] = STATE(1525),
    [sym_abstract_type] = STATE(1526),
    [sym_dynamic_type] = STATE(1525),
    [sym_macro_invocation] = STATE(1525),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2405),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(5312),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(5314),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5318),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5322),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3280] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2988),
    [anon_sym_LPAREN] = ACTIONS(2988),
    [anon_sym_LBRACE] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_COMMA] = ACTIONS(2988),
    [anon_sym_DASH_GT] = ACTIONS(7545),
    [sym_line_comment] = ACTIONS(7),
  },
  [3281] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym_LPAREN] = ACTIONS(2992),
    [anon_sym_LBRACE] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_COMMA] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(7547),
    [sym_line_comment] = ACTIONS(7),
  },
  [3282] = {
    [aux_sym_trait_bounds_repeat1] = STATE(3282),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6476),
    [anon_sym_LPAREN] = ACTIONS(6476),
    [anon_sym_LBRACE] = ACTIONS(6476),
    [anon_sym_PLUS] = ACTIONS(7549),
    [anon_sym_COMMA] = ACTIONS(6476),
    [sym_line_comment] = ACTIONS(7),
  },
  [3283] = {
    [sym_function_modifiers] = STATE(2936),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(821),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(3286),
    [sym_array_type] = STATE(821),
    [sym_function_type] = STATE(821),
    [sym_tuple_type] = STATE(821),
    [sym_unit_type] = STATE(821),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(821),
    [sym_reference_type] = STATE(821),
    [sym_pointer_type] = STATE(821),
    [sym_empty_type] = STATE(821),
    [sym_dynamic_type] = STATE(821),
    [sym_macro_invocation] = STATE(821),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2939),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(6450),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(6452),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6456),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6460),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3284] = {
    [sym_function_modifiers] = STATE(2936),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(3286),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2939),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(6450),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(6452),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6456),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6460),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3285] = {
    [sym_function_modifiers] = STATE(2936),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(823),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(3286),
    [sym_array_type] = STATE(823),
    [sym_function_type] = STATE(823),
    [sym_tuple_type] = STATE(823),
    [sym_unit_type] = STATE(823),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(823),
    [sym_reference_type] = STATE(823),
    [sym_pointer_type] = STATE(823),
    [sym_empty_type] = STATE(823),
    [sym_dynamic_type] = STATE(823),
    [sym_macro_invocation] = STATE(823),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2939),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(7552),
    [anon_sym_STAR] = ACTIONS(6450),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(6452),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6456),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(7554),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6460),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3286] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7552),
    [sym_line_comment] = ACTIONS(7),
  },
  [3287] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1760),
    [anon_sym_PLUS] = ACTIONS(1760),
    [anon_sym_COMMA] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(7556),
    [sym_line_comment] = ACTIONS(7),
  },
  [3288] = {
    [sym_function_modifiers] = STATE(2936),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2417),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(3286),
    [sym_array_type] = STATE(2417),
    [sym_function_type] = STATE(2417),
    [sym_tuple_type] = STATE(2417),
    [sym_unit_type] = STATE(2417),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2417),
    [sym_reference_type] = STATE(2417),
    [sym_pointer_type] = STATE(2417),
    [sym_empty_type] = STATE(2417),
    [sym_dynamic_type] = STATE(2417),
    [sym_macro_invocation] = STATE(2417),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2939),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(6450),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(6452),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6456),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6460),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3289] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(1794),
    [anon_sym_PLUS] = ACTIONS(1794),
    [anon_sym_COMMA] = ACTIONS(1794),
    [anon_sym_DASH_GT] = ACTIONS(7558),
    [sym_line_comment] = ACTIONS(7),
  },
  [3290] = {
    [sym_parameters] = STATE(3503),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(7),
  },
  [3291] = {
    [sym_parameters] = STATE(3504),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [3292] = {
    [sym_parameters] = STATE(3503),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [3293] = {
    [sym_function_modifiers] = STATE(2936),
    [sym_higher_ranked_trait_bound] = STATE(2418),
    [sym_removed_trait_bound] = STATE(2418),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2419),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2419),
    [sym_array_type] = STATE(2419),
    [sym_function_type] = STATE(2419),
    [sym_tuple_type] = STATE(2419),
    [sym_unit_type] = STATE(2419),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2419),
    [sym_reference_type] = STATE(2419),
    [sym_pointer_type] = STATE(2419),
    [sym_empty_type] = STATE(2419),
    [sym_dynamic_type] = STATE(2419),
    [sym_macro_invocation] = STATE(2419),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2939),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(6450),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(6452),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_QMARK] = ACTIONS(6454),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6456),
    [anon_sym_for] = ACTIONS(6458),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6460),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3294] = {
    [aux_sym_trait_bounds_repeat1] = STATE(3505),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5344),
    [anon_sym_PLUS] = ACTIONS(7151),
    [anon_sym_COMMA] = ACTIONS(5344),
    [sym_line_comment] = ACTIONS(7),
  },
  [3295] = {
    [sym_function_modifiers] = STATE(2936),
    [sym_higher_ranked_trait_bound] = STATE(2418),
    [sym_removed_trait_bound] = STATE(2418),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2419),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2419),
    [sym_array_type] = STATE(2419),
    [sym_function_type] = STATE(2419),
    [sym_tuple_type] = STATE(2419),
    [sym_unit_type] = STATE(2419),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2419),
    [sym_reference_type] = STATE(2419),
    [sym_pointer_type] = STATE(2419),
    [sym_empty_type] = STATE(2419),
    [sym_dynamic_type] = STATE(2419),
    [sym_macro_invocation] = STATE(2419),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2939),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(6450),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(6452),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_QMARK] = ACTIONS(6454),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6456),
    [anon_sym_for] = ACTIONS(6458),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6460),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3296] = {
    [sym_where_predicate] = STATE(2237),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1753),
    [sym_generic_type] = STATE(1754),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_reference_type] = STATE(1753),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1755),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(329),
    [anon_sym_i8] = ACTIONS(329),
    [anon_sym_u16] = ACTIONS(329),
    [anon_sym_i16] = ACTIONS(329),
    [anon_sym_u32] = ACTIONS(329),
    [anon_sym_i32] = ACTIONS(329),
    [anon_sym_u64] = ACTIONS(329),
    [anon_sym_i64] = ACTIONS(329),
    [anon_sym_u128] = ACTIONS(329),
    [anon_sym_i128] = ACTIONS(329),
    [anon_sym_isize] = ACTIONS(329),
    [anon_sym_usize] = ACTIONS(329),
    [anon_sym_f32] = ACTIONS(329),
    [anon_sym_f64] = ACTIONS(329),
    [anon_sym_bool] = ACTIONS(329),
    [anon_sym_str] = ACTIONS(329),
    [anon_sym_char] = ACTIONS(329),
    [anon_sym_AMP] = ACTIONS(1948),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3389),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(335),
  },
  [3297] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5049),
    [anon_sym_LBRACK] = ACTIONS(5049),
    [anon_sym_STAR] = ACTIONS(5049),
    [anon_sym_u8] = ACTIONS(5051),
    [anon_sym_i8] = ACTIONS(5051),
    [anon_sym_u16] = ACTIONS(5051),
    [anon_sym_i16] = ACTIONS(5051),
    [anon_sym_u32] = ACTIONS(5051),
    [anon_sym_i32] = ACTIONS(5051),
    [anon_sym_u64] = ACTIONS(5051),
    [anon_sym_i64] = ACTIONS(5051),
    [anon_sym_u128] = ACTIONS(5051),
    [anon_sym_i128] = ACTIONS(5051),
    [anon_sym_isize] = ACTIONS(5051),
    [anon_sym_usize] = ACTIONS(5051),
    [anon_sym_f32] = ACTIONS(5051),
    [anon_sym_f64] = ACTIONS(5051),
    [anon_sym_bool] = ACTIONS(5051),
    [anon_sym_str] = ACTIONS(5051),
    [anon_sym_char] = ACTIONS(5051),
    [anon_sym_AMP] = ACTIONS(5049),
    [anon_sym_COLON_COLON] = ACTIONS(5049),
    [anon_sym_BANG] = ACTIONS(5049),
    [anon_sym_LT] = ACTIONS(5049),
    [anon_sym_SQUOTE] = ACTIONS(5049),
    [anon_sym_const] = ACTIONS(5051),
    [anon_sym_default] = ACTIONS(5051),
    [anon_sym_fn] = ACTIONS(5051),
    [anon_sym_unsafe] = ACTIONS(5051),
    [anon_sym_extern] = ACTIONS(5051),
    [anon_sym_dyn] = ACTIONS(5051),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5051),
    [sym_self] = ACTIONS(5051),
    [sym_super] = ACTIONS(5051),
    [sym_crate] = ACTIONS(5051),
    [sym_metavariable] = ACTIONS(5049),
  },
  [3298] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5056),
    [anon_sym_LBRACK] = ACTIONS(5056),
    [anon_sym_STAR] = ACTIONS(5056),
    [anon_sym_u8] = ACTIONS(5058),
    [anon_sym_i8] = ACTIONS(5058),
    [anon_sym_u16] = ACTIONS(5058),
    [anon_sym_i16] = ACTIONS(5058),
    [anon_sym_u32] = ACTIONS(5058),
    [anon_sym_i32] = ACTIONS(5058),
    [anon_sym_u64] = ACTIONS(5058),
    [anon_sym_i64] = ACTIONS(5058),
    [anon_sym_u128] = ACTIONS(5058),
    [anon_sym_i128] = ACTIONS(5058),
    [anon_sym_isize] = ACTIONS(5058),
    [anon_sym_usize] = ACTIONS(5058),
    [anon_sym_f32] = ACTIONS(5058),
    [anon_sym_f64] = ACTIONS(5058),
    [anon_sym_bool] = ACTIONS(5058),
    [anon_sym_str] = ACTIONS(5058),
    [anon_sym_char] = ACTIONS(5058),
    [anon_sym_AMP] = ACTIONS(5056),
    [anon_sym_COLON_COLON] = ACTIONS(5056),
    [anon_sym_BANG] = ACTIONS(5056),
    [anon_sym_LT] = ACTIONS(5056),
    [anon_sym_SQUOTE] = ACTIONS(5056),
    [anon_sym_const] = ACTIONS(5058),
    [anon_sym_default] = ACTIONS(5058),
    [anon_sym_fn] = ACTIONS(5058),
    [anon_sym_unsafe] = ACTIONS(5058),
    [anon_sym_extern] = ACTIONS(5058),
    [anon_sym_dyn] = ACTIONS(5058),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5058),
    [sym_self] = ACTIONS(5058),
    [sym_super] = ACTIONS(5058),
    [sym_crate] = ACTIONS(5058),
    [sym_metavariable] = ACTIONS(5056),
  },
  [3299] = {
    [sym_raw_string_literal] = ACTIONS(7560),
    [sym_float_literal] = ACTIONS(7560),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(7560),
    [anon_sym_SEMI] = ACTIONS(7560),
    [anon_sym_macro_rules_BANG] = ACTIONS(7560),
    [anon_sym_LPAREN] = ACTIONS(7560),
    [anon_sym_LBRACE] = ACTIONS(7560),
    [anon_sym_RBRACE] = ACTIONS(7560),
    [anon_sym_LBRACK] = ACTIONS(7560),
    [anon_sym_STAR] = ACTIONS(7560),
    [anon_sym_u8] = ACTIONS(7562),
    [anon_sym_i8] = ACTIONS(7562),
    [anon_sym_u16] = ACTIONS(7562),
    [anon_sym_i16] = ACTIONS(7562),
    [anon_sym_u32] = ACTIONS(7562),
    [anon_sym_i32] = ACTIONS(7562),
    [anon_sym_u64] = ACTIONS(7562),
    [anon_sym_i64] = ACTIONS(7562),
    [anon_sym_u128] = ACTIONS(7562),
    [anon_sym_i128] = ACTIONS(7562),
    [anon_sym_isize] = ACTIONS(7562),
    [anon_sym_usize] = ACTIONS(7562),
    [anon_sym_f32] = ACTIONS(7562),
    [anon_sym_f64] = ACTIONS(7562),
    [anon_sym_bool] = ACTIONS(7562),
    [anon_sym_str] = ACTIONS(7562),
    [anon_sym_char] = ACTIONS(7562),
    [anon_sym_AMP] = ACTIONS(7560),
    [anon_sym_DASH] = ACTIONS(7560),
    [anon_sym_COLON_COLON] = ACTIONS(7560),
    [anon_sym_BANG] = ACTIONS(7560),
    [anon_sym_POUND] = ACTIONS(7560),
    [anon_sym_LT] = ACTIONS(7560),
    [anon_sym_PIPE] = ACTIONS(7560),
    [anon_sym_SQUOTE] = ACTIONS(7562),
    [anon_sym_DOT_DOT] = ACTIONS(7560),
    [anon_sym_break] = ACTIONS(7562),
    [anon_sym_const] = ACTIONS(7562),
    [anon_sym_continue] = ACTIONS(7562),
    [anon_sym_default] = ACTIONS(7562),
    [anon_sym_enum] = ACTIONS(7562),
    [anon_sym_fn] = ACTIONS(7562),
    [anon_sym_for] = ACTIONS(7562),
    [anon_sym_if] = ACTIONS(7562),
    [anon_sym_impl] = ACTIONS(7562),
    [anon_sym_let] = ACTIONS(7562),
    [anon_sym_loop] = ACTIONS(7562),
    [anon_sym_match] = ACTIONS(7562),
    [anon_sym_mod] = ACTIONS(7562),
    [anon_sym_pub] = ACTIONS(7562),
    [anon_sym_return] = ACTIONS(7562),
    [anon_sym_static] = ACTIONS(7562),
    [anon_sym_struct] = ACTIONS(7562),
    [anon_sym_trait] = ACTIONS(7562),
    [anon_sym_type] = ACTIONS(7562),
    [anon_sym_union] = ACTIONS(7562),
    [anon_sym_unsafe] = ACTIONS(7562),
    [anon_sym_use] = ACTIONS(7562),
    [anon_sym_while] = ACTIONS(7562),
    [anon_sym_extern] = ACTIONS(7562),
    [anon_sym_move] = ACTIONS(7562),
    [sym_integer_literal] = ACTIONS(7560),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7560),
    [sym_char_literal] = ACTIONS(7560),
    [anon_sym_true] = ACTIONS(7562),
    [anon_sym_false] = ACTIONS(7562),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7562),
    [sym_self] = ACTIONS(7562),
    [sym_super] = ACTIONS(7562),
    [sym_crate] = ACTIONS(7562),
    [sym_metavariable] = ACTIONS(7560),
  },
  [3300] = {
    [sym_raw_string_literal] = ACTIONS(7564),
    [sym_float_literal] = ACTIONS(7564),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(7564),
    [anon_sym_SEMI] = ACTIONS(7564),
    [anon_sym_macro_rules_BANG] = ACTIONS(7564),
    [anon_sym_LPAREN] = ACTIONS(7564),
    [anon_sym_LBRACE] = ACTIONS(7564),
    [anon_sym_RBRACE] = ACTIONS(7564),
    [anon_sym_LBRACK] = ACTIONS(7564),
    [anon_sym_STAR] = ACTIONS(7564),
    [anon_sym_u8] = ACTIONS(7566),
    [anon_sym_i8] = ACTIONS(7566),
    [anon_sym_u16] = ACTIONS(7566),
    [anon_sym_i16] = ACTIONS(7566),
    [anon_sym_u32] = ACTIONS(7566),
    [anon_sym_i32] = ACTIONS(7566),
    [anon_sym_u64] = ACTIONS(7566),
    [anon_sym_i64] = ACTIONS(7566),
    [anon_sym_u128] = ACTIONS(7566),
    [anon_sym_i128] = ACTIONS(7566),
    [anon_sym_isize] = ACTIONS(7566),
    [anon_sym_usize] = ACTIONS(7566),
    [anon_sym_f32] = ACTIONS(7566),
    [anon_sym_f64] = ACTIONS(7566),
    [anon_sym_bool] = ACTIONS(7566),
    [anon_sym_str] = ACTIONS(7566),
    [anon_sym_char] = ACTIONS(7566),
    [anon_sym_AMP] = ACTIONS(7564),
    [anon_sym_DASH] = ACTIONS(7564),
    [anon_sym_COLON_COLON] = ACTIONS(7564),
    [anon_sym_BANG] = ACTIONS(7564),
    [anon_sym_POUND] = ACTIONS(7564),
    [anon_sym_LT] = ACTIONS(7564),
    [anon_sym_PIPE] = ACTIONS(7564),
    [anon_sym_SQUOTE] = ACTIONS(7566),
    [anon_sym_DOT_DOT] = ACTIONS(7564),
    [anon_sym_break] = ACTIONS(7566),
    [anon_sym_const] = ACTIONS(7566),
    [anon_sym_continue] = ACTIONS(7566),
    [anon_sym_default] = ACTIONS(7566),
    [anon_sym_enum] = ACTIONS(7566),
    [anon_sym_fn] = ACTIONS(7566),
    [anon_sym_for] = ACTIONS(7566),
    [anon_sym_if] = ACTIONS(7566),
    [anon_sym_impl] = ACTIONS(7566),
    [anon_sym_let] = ACTIONS(7566),
    [anon_sym_loop] = ACTIONS(7566),
    [anon_sym_match] = ACTIONS(7566),
    [anon_sym_mod] = ACTIONS(7566),
    [anon_sym_pub] = ACTIONS(7566),
    [anon_sym_return] = ACTIONS(7566),
    [anon_sym_static] = ACTIONS(7566),
    [anon_sym_struct] = ACTIONS(7566),
    [anon_sym_trait] = ACTIONS(7566),
    [anon_sym_type] = ACTIONS(7566),
    [anon_sym_union] = ACTIONS(7566),
    [anon_sym_unsafe] = ACTIONS(7566),
    [anon_sym_use] = ACTIONS(7566),
    [anon_sym_while] = ACTIONS(7566),
    [anon_sym_extern] = ACTIONS(7566),
    [anon_sym_move] = ACTIONS(7566),
    [sym_integer_literal] = ACTIONS(7564),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7564),
    [sym_char_literal] = ACTIONS(7564),
    [anon_sym_true] = ACTIONS(7566),
    [anon_sym_false] = ACTIONS(7566),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7566),
    [sym_self] = ACTIONS(7566),
    [sym_super] = ACTIONS(7566),
    [sym_crate] = ACTIONS(7566),
    [sym_metavariable] = ACTIONS(7564),
  },
  [3301] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(3506),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [3302] = {
    [sym_function_modifiers] = STATE(2459),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2611),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(2460),
    [sym_array_type] = STATE(2611),
    [sym_function_type] = STATE(2611),
    [sym_tuple_type] = STATE(2611),
    [sym_unit_type] = STATE(2611),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2611),
    [sym_reference_type] = STATE(2611),
    [sym_pointer_type] = STATE(2611),
    [sym_empty_type] = STATE(2611),
    [sym_dynamic_type] = STATE(2611),
    [sym_macro_invocation] = STATE(2611),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(2461),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(5429),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5431),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5433),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [3303] = {
    [sym_function_modifiers] = STATE(2459),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2616),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(2460),
    [sym_array_type] = STATE(2616),
    [sym_function_type] = STATE(2616),
    [sym_tuple_type] = STATE(2616),
    [sym_unit_type] = STATE(2616),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2616),
    [sym_reference_type] = STATE(2616),
    [sym_pointer_type] = STATE(2616),
    [sym_empty_type] = STATE(2616),
    [sym_abstract_type] = STATE(2617),
    [sym_dynamic_type] = STATE(2616),
    [sym_macro_invocation] = STATE(2616),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(2461),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(5429),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5431),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5433),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [3304] = {
    [sym_function_modifiers] = STATE(2459),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2618),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(2460),
    [sym_array_type] = STATE(2618),
    [sym_function_type] = STATE(2618),
    [sym_tuple_type] = STATE(2618),
    [sym_unit_type] = STATE(2618),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2618),
    [sym_reference_type] = STATE(2618),
    [sym_pointer_type] = STATE(2618),
    [sym_empty_type] = STATE(2618),
    [sym_abstract_type] = STATE(2619),
    [sym_dynamic_type] = STATE(2618),
    [sym_macro_invocation] = STATE(2618),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(2461),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(5429),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5431),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5433),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [3305] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2988),
    [anon_sym_RBRACE] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(5758),
    [anon_sym_STAR] = ACTIONS(5758),
    [anon_sym_COMMA] = ACTIONS(2988),
    [anon_sym_AMP] = ACTIONS(5758),
    [anon_sym_DASH] = ACTIONS(5758),
    [anon_sym_DOT] = ACTIONS(5758),
    [anon_sym_DASH_EQ] = ACTIONS(2988),
    [anon_sym_DASH_GT] = ACTIONS(7568),
    [anon_sym_BANG_EQ] = ACTIONS(2988),
    [anon_sym_STAR_EQ] = ACTIONS(2988),
    [anon_sym_SLASH] = ACTIONS(5758),
    [anon_sym_SLASH_EQ] = ACTIONS(2988),
    [anon_sym_AMP_AMP] = ACTIONS(2988),
    [anon_sym_AMP_EQ] = ACTIONS(2988),
    [anon_sym_PERCENT] = ACTIONS(5758),
    [anon_sym_PERCENT_EQ] = ACTIONS(2988),
    [anon_sym_CARET] = ACTIONS(5758),
    [anon_sym_CARET_EQ] = ACTIONS(2988),
    [anon_sym_PLUS_EQ] = ACTIONS(2988),
    [anon_sym_LT] = ACTIONS(5758),
    [anon_sym_LT_LT] = ACTIONS(5758),
    [anon_sym_LT_LT_EQ] = ACTIONS(2988),
    [anon_sym_LT_EQ] = ACTIONS(2988),
    [anon_sym_EQ] = ACTIONS(5758),
    [anon_sym_EQ_EQ] = ACTIONS(2988),
    [anon_sym_GT] = ACTIONS(5758),
    [anon_sym_GT_EQ] = ACTIONS(2988),
    [anon_sym_GT_GT] = ACTIONS(5758),
    [anon_sym_GT_GT_EQ] = ACTIONS(2988),
    [anon_sym_PIPE] = ACTIONS(5758),
    [anon_sym_PIPE_EQ] = ACTIONS(2988),
    [anon_sym_PIPE_PIPE] = ACTIONS(2988),
    [anon_sym_QMARK] = ACTIONS(2988),
    [anon_sym_DOT_DOT] = ACTIONS(5758),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2988),
    [anon_sym_as] = ACTIONS(2988),
    [sym_line_comment] = ACTIONS(7),
  },
  [3306] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2992),
    [anon_sym_RBRACE] = ACTIONS(2992),
    [anon_sym_LBRACK] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(5762),
    [anon_sym_STAR] = ACTIONS(5762),
    [anon_sym_COMMA] = ACTIONS(2992),
    [anon_sym_AMP] = ACTIONS(5762),
    [anon_sym_DASH] = ACTIONS(5762),
    [anon_sym_DOT] = ACTIONS(5762),
    [anon_sym_DASH_EQ] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(7570),
    [anon_sym_BANG_EQ] = ACTIONS(2992),
    [anon_sym_STAR_EQ] = ACTIONS(2992),
    [anon_sym_SLASH] = ACTIONS(5762),
    [anon_sym_SLASH_EQ] = ACTIONS(2992),
    [anon_sym_AMP_AMP] = ACTIONS(2992),
    [anon_sym_AMP_EQ] = ACTIONS(2992),
    [anon_sym_PERCENT] = ACTIONS(5762),
    [anon_sym_PERCENT_EQ] = ACTIONS(2992),
    [anon_sym_CARET] = ACTIONS(5762),
    [anon_sym_CARET_EQ] = ACTIONS(2992),
    [anon_sym_PLUS_EQ] = ACTIONS(2992),
    [anon_sym_LT] = ACTIONS(5762),
    [anon_sym_LT_LT] = ACTIONS(5762),
    [anon_sym_LT_LT_EQ] = ACTIONS(2992),
    [anon_sym_LT_EQ] = ACTIONS(2992),
    [anon_sym_EQ] = ACTIONS(5762),
    [anon_sym_EQ_EQ] = ACTIONS(2992),
    [anon_sym_GT] = ACTIONS(5762),
    [anon_sym_GT_EQ] = ACTIONS(2992),
    [anon_sym_GT_GT] = ACTIONS(5762),
    [anon_sym_GT_GT_EQ] = ACTIONS(2992),
    [anon_sym_PIPE] = ACTIONS(5762),
    [anon_sym_PIPE_EQ] = ACTIONS(2992),
    [anon_sym_PIPE_PIPE] = ACTIONS(2992),
    [anon_sym_QMARK] = ACTIONS(2992),
    [anon_sym_DOT_DOT] = ACTIONS(5762),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2992),
    [anon_sym_as] = ACTIONS(2992),
    [sym_line_comment] = ACTIONS(7),
  },
  [3307] = {
    [sym_raw_string_literal] = ACTIONS(7226),
    [sym_float_literal] = ACTIONS(7226),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7226),
    [anon_sym_LPAREN] = ACTIONS(7226),
    [anon_sym_RPAREN] = ACTIONS(7226),
    [anon_sym_LBRACE] = ACTIONS(7226),
    [anon_sym_RBRACE] = ACTIONS(7226),
    [anon_sym_EQ_GT] = ACTIONS(7226),
    [anon_sym_LBRACK] = ACTIONS(7226),
    [anon_sym_RBRACK] = ACTIONS(7226),
    [anon_sym_COLON] = ACTIONS(7228),
    [anon_sym_DOLLAR] = ACTIONS(7228),
    [anon_sym_PLUS] = ACTIONS(7228),
    [anon_sym_STAR] = ACTIONS(7228),
    [anon_sym_COMMA] = ACTIONS(7226),
    [anon_sym_u8] = ACTIONS(7228),
    [anon_sym_i8] = ACTIONS(7228),
    [anon_sym_u16] = ACTIONS(7228),
    [anon_sym_i16] = ACTIONS(7228),
    [anon_sym_u32] = ACTIONS(7228),
    [anon_sym_i32] = ACTIONS(7228),
    [anon_sym_u64] = ACTIONS(7228),
    [anon_sym_i64] = ACTIONS(7228),
    [anon_sym_u128] = ACTIONS(7228),
    [anon_sym_i128] = ACTIONS(7228),
    [anon_sym_isize] = ACTIONS(7228),
    [anon_sym_usize] = ACTIONS(7228),
    [anon_sym_f32] = ACTIONS(7228),
    [anon_sym_f64] = ACTIONS(7228),
    [anon_sym_bool] = ACTIONS(7228),
    [anon_sym_str] = ACTIONS(7228),
    [anon_sym_char] = ACTIONS(7228),
    [anon_sym__] = ACTIONS(7228),
    [anon_sym_AMP] = ACTIONS(7228),
    [anon_sym_DASH] = ACTIONS(7228),
    [anon_sym_DOT] = ACTIONS(7228),
    [anon_sym_DASH_EQ] = ACTIONS(7226),
    [anon_sym_DASH_GT] = ACTIONS(7226),
    [anon_sym_COLON_COLON] = ACTIONS(7226),
    [anon_sym_BANG] = ACTIONS(7228),
    [anon_sym_BANG_EQ] = ACTIONS(7226),
    [anon_sym_AT] = ACTIONS(7226),
    [anon_sym_STAR_EQ] = ACTIONS(7226),
    [anon_sym_SLASH] = ACTIONS(7228),
    [anon_sym_SLASH_EQ] = ACTIONS(7226),
    [anon_sym_AMP_AMP] = ACTIONS(7226),
    [anon_sym_AMP_EQ] = ACTIONS(7226),
    [anon_sym_POUND] = ACTIONS(7226),
    [anon_sym_PERCENT] = ACTIONS(7228),
    [anon_sym_PERCENT_EQ] = ACTIONS(7226),
    [anon_sym_CARET] = ACTIONS(7228),
    [anon_sym_CARET_EQ] = ACTIONS(7226),
    [anon_sym_PLUS_EQ] = ACTIONS(7226),
    [anon_sym_LT] = ACTIONS(7228),
    [anon_sym_LT_LT] = ACTIONS(7228),
    [anon_sym_LT_LT_EQ] = ACTIONS(7226),
    [anon_sym_LT_EQ] = ACTIONS(7226),
    [anon_sym_EQ] = ACTIONS(7228),
    [anon_sym_EQ_EQ] = ACTIONS(7226),
    [anon_sym_GT] = ACTIONS(7228),
    [anon_sym_GT_EQ] = ACTIONS(7226),
    [anon_sym_GT_GT] = ACTIONS(7228),
    [anon_sym_GT_GT_EQ] = ACTIONS(7226),
    [anon_sym_PIPE] = ACTIONS(7228),
    [anon_sym_PIPE_EQ] = ACTIONS(7226),
    [anon_sym_PIPE_PIPE] = ACTIONS(7226),
    [anon_sym_TILDE] = ACTIONS(7226),
    [anon_sym_QMARK] = ACTIONS(7226),
    [anon_sym_SQUOTE] = ACTIONS(7228),
    [anon_sym_DOT_DOT] = ACTIONS(7228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7226),
    [anon_sym_as] = ACTIONS(7228),
    [anon_sym_break] = ACTIONS(7228),
    [anon_sym_const] = ACTIONS(7228),
    [anon_sym_continue] = ACTIONS(7228),
    [anon_sym_default] = ACTIONS(7228),
    [anon_sym_enum] = ACTIONS(7228),
    [anon_sym_fn] = ACTIONS(7228),
    [anon_sym_for] = ACTIONS(7228),
    [anon_sym_if] = ACTIONS(7228),
    [anon_sym_impl] = ACTIONS(7228),
    [anon_sym_let] = ACTIONS(7228),
    [anon_sym_loop] = ACTIONS(7228),
    [anon_sym_match] = ACTIONS(7228),
    [anon_sym_mod] = ACTIONS(7228),
    [anon_sym_pub] = ACTIONS(7228),
    [anon_sym_return] = ACTIONS(7228),
    [anon_sym_static] = ACTIONS(7228),
    [anon_sym_struct] = ACTIONS(7228),
    [anon_sym_trait] = ACTIONS(7228),
    [anon_sym_type] = ACTIONS(7228),
    [anon_sym_union] = ACTIONS(7228),
    [anon_sym_unsafe] = ACTIONS(7228),
    [anon_sym_use] = ACTIONS(7228),
    [anon_sym_where] = ACTIONS(7228),
    [anon_sym_while] = ACTIONS(7228),
    [sym_mutable_specifier] = ACTIONS(7228),
    [sym_integer_literal] = ACTIONS(7226),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7226),
    [sym_char_literal] = ACTIONS(7226),
    [anon_sym_true] = ACTIONS(7228),
    [anon_sym_false] = ACTIONS(7228),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7228),
    [sym_self] = ACTIONS(7228),
    [sym_super] = ACTIONS(7228),
    [sym_crate] = ACTIONS(7228),
    [sym_metavariable] = ACTIONS(7226),
  },
  [3308] = {
    [sym_raw_string_literal] = ACTIONS(6588),
    [sym_float_literal] = ACTIONS(6588),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7180),
    [anon_sym_LPAREN] = ACTIONS(7180),
    [anon_sym_LBRACE] = ACTIONS(6588),
    [anon_sym_EQ_GT] = ACTIONS(6588),
    [anon_sym_LBRACK] = ACTIONS(7180),
    [anon_sym_RBRACK] = ACTIONS(7180),
    [anon_sym_COLON] = ACTIONS(6590),
    [anon_sym_DOLLAR] = ACTIONS(6590),
    [anon_sym_PLUS] = ACTIONS(7183),
    [anon_sym_STAR] = ACTIONS(7183),
    [anon_sym_COMMA] = ACTIONS(7180),
    [anon_sym_u8] = ACTIONS(6590),
    [anon_sym_i8] = ACTIONS(6590),
    [anon_sym_u16] = ACTIONS(6590),
    [anon_sym_i16] = ACTIONS(6590),
    [anon_sym_u32] = ACTIONS(6590),
    [anon_sym_i32] = ACTIONS(6590),
    [anon_sym_u64] = ACTIONS(6590),
    [anon_sym_i64] = ACTIONS(6590),
    [anon_sym_u128] = ACTIONS(6590),
    [anon_sym_i128] = ACTIONS(6590),
    [anon_sym_isize] = ACTIONS(6590),
    [anon_sym_usize] = ACTIONS(6590),
    [anon_sym_f32] = ACTIONS(6590),
    [anon_sym_f64] = ACTIONS(6590),
    [anon_sym_bool] = ACTIONS(6590),
    [anon_sym_str] = ACTIONS(6590),
    [anon_sym_char] = ACTIONS(6590),
    [anon_sym__] = ACTIONS(6590),
    [anon_sym_AMP] = ACTIONS(7183),
    [anon_sym_DASH] = ACTIONS(7183),
    [anon_sym_DOT] = ACTIONS(7183),
    [anon_sym_DASH_EQ] = ACTIONS(7180),
    [anon_sym_DASH_GT] = ACTIONS(6588),
    [anon_sym_COLON_COLON] = ACTIONS(6588),
    [anon_sym_BANG] = ACTIONS(6590),
    [anon_sym_BANG_EQ] = ACTIONS(7180),
    [anon_sym_AT] = ACTIONS(6588),
    [anon_sym_STAR_EQ] = ACTIONS(7180),
    [anon_sym_SLASH] = ACTIONS(7183),
    [anon_sym_SLASH_EQ] = ACTIONS(7180),
    [anon_sym_AMP_AMP] = ACTIONS(7180),
    [anon_sym_AMP_EQ] = ACTIONS(7180),
    [anon_sym_POUND] = ACTIONS(6588),
    [anon_sym_PERCENT] = ACTIONS(7183),
    [anon_sym_PERCENT_EQ] = ACTIONS(7180),
    [anon_sym_CARET] = ACTIONS(7183),
    [anon_sym_CARET_EQ] = ACTIONS(7180),
    [anon_sym_PLUS_EQ] = ACTIONS(7180),
    [anon_sym_LT] = ACTIONS(7183),
    [anon_sym_LT_LT] = ACTIONS(7183),
    [anon_sym_LT_LT_EQ] = ACTIONS(7180),
    [anon_sym_LT_EQ] = ACTIONS(7180),
    [anon_sym_EQ] = ACTIONS(7183),
    [anon_sym_EQ_EQ] = ACTIONS(7180),
    [anon_sym_GT] = ACTIONS(7183),
    [anon_sym_GT_EQ] = ACTIONS(7180),
    [anon_sym_GT_GT] = ACTIONS(7183),
    [anon_sym_GT_GT_EQ] = ACTIONS(7180),
    [anon_sym_PIPE] = ACTIONS(7183),
    [anon_sym_PIPE_EQ] = ACTIONS(7180),
    [anon_sym_PIPE_PIPE] = ACTIONS(7180),
    [anon_sym_TILDE] = ACTIONS(6588),
    [anon_sym_QMARK] = ACTIONS(7180),
    [anon_sym_SQUOTE] = ACTIONS(6590),
    [anon_sym_DOT_DOT] = ACTIONS(7183),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7180),
    [anon_sym_as] = ACTIONS(7183),
    [anon_sym_break] = ACTIONS(6590),
    [anon_sym_const] = ACTIONS(6590),
    [anon_sym_continue] = ACTIONS(6590),
    [anon_sym_default] = ACTIONS(6590),
    [anon_sym_enum] = ACTIONS(6590),
    [anon_sym_fn] = ACTIONS(6590),
    [anon_sym_for] = ACTIONS(6590),
    [anon_sym_if] = ACTIONS(6590),
    [anon_sym_impl] = ACTIONS(6590),
    [anon_sym_let] = ACTIONS(6590),
    [anon_sym_loop] = ACTIONS(6590),
    [anon_sym_match] = ACTIONS(6590),
    [anon_sym_mod] = ACTIONS(6590),
    [anon_sym_pub] = ACTIONS(6590),
    [anon_sym_return] = ACTIONS(6590),
    [anon_sym_static] = ACTIONS(6590),
    [anon_sym_struct] = ACTIONS(6590),
    [anon_sym_trait] = ACTIONS(6590),
    [anon_sym_type] = ACTIONS(6590),
    [anon_sym_union] = ACTIONS(6590),
    [anon_sym_unsafe] = ACTIONS(6590),
    [anon_sym_use] = ACTIONS(6590),
    [anon_sym_where] = ACTIONS(6590),
    [anon_sym_while] = ACTIONS(6590),
    [sym_mutable_specifier] = ACTIONS(6590),
    [sym_integer_literal] = ACTIONS(6588),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6588),
    [sym_char_literal] = ACTIONS(6588),
    [anon_sym_true] = ACTIONS(6590),
    [anon_sym_false] = ACTIONS(6590),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6590),
    [sym_self] = ACTIONS(6590),
    [sym_super] = ACTIONS(6590),
    [sym_crate] = ACTIONS(6590),
    [sym_metavariable] = ACTIONS(6588),
  },
  [3309] = {
    [sym_raw_string_literal] = ACTIONS(6588),
    [sym_float_literal] = ACTIONS(6588),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7194),
    [anon_sym_LPAREN] = ACTIONS(7194),
    [anon_sym_LBRACE] = ACTIONS(6588),
    [anon_sym_EQ_GT] = ACTIONS(6588),
    [anon_sym_LBRACK] = ACTIONS(7194),
    [anon_sym_RBRACK] = ACTIONS(7194),
    [anon_sym_COLON] = ACTIONS(6590),
    [anon_sym_DOLLAR] = ACTIONS(6590),
    [anon_sym_PLUS] = ACTIONS(7197),
    [anon_sym_STAR] = ACTIONS(7197),
    [anon_sym_COMMA] = ACTIONS(7194),
    [anon_sym_u8] = ACTIONS(6590),
    [anon_sym_i8] = ACTIONS(6590),
    [anon_sym_u16] = ACTIONS(6590),
    [anon_sym_i16] = ACTIONS(6590),
    [anon_sym_u32] = ACTIONS(6590),
    [anon_sym_i32] = ACTIONS(6590),
    [anon_sym_u64] = ACTIONS(6590),
    [anon_sym_i64] = ACTIONS(6590),
    [anon_sym_u128] = ACTIONS(6590),
    [anon_sym_i128] = ACTIONS(6590),
    [anon_sym_isize] = ACTIONS(6590),
    [anon_sym_usize] = ACTIONS(6590),
    [anon_sym_f32] = ACTIONS(6590),
    [anon_sym_f64] = ACTIONS(6590),
    [anon_sym_bool] = ACTIONS(6590),
    [anon_sym_str] = ACTIONS(6590),
    [anon_sym_char] = ACTIONS(6590),
    [anon_sym__] = ACTIONS(6590),
    [anon_sym_AMP] = ACTIONS(7197),
    [anon_sym_DASH] = ACTIONS(7197),
    [anon_sym_DOT] = ACTIONS(7197),
    [anon_sym_DASH_EQ] = ACTIONS(7194),
    [anon_sym_DASH_GT] = ACTIONS(6588),
    [anon_sym_COLON_COLON] = ACTIONS(6588),
    [anon_sym_BANG] = ACTIONS(6590),
    [anon_sym_BANG_EQ] = ACTIONS(7194),
    [anon_sym_AT] = ACTIONS(6588),
    [anon_sym_STAR_EQ] = ACTIONS(7194),
    [anon_sym_SLASH] = ACTIONS(7197),
    [anon_sym_SLASH_EQ] = ACTIONS(7194),
    [anon_sym_AMP_AMP] = ACTIONS(7194),
    [anon_sym_AMP_EQ] = ACTIONS(7194),
    [anon_sym_POUND] = ACTIONS(6588),
    [anon_sym_PERCENT] = ACTIONS(7197),
    [anon_sym_PERCENT_EQ] = ACTIONS(7194),
    [anon_sym_CARET] = ACTIONS(7197),
    [anon_sym_CARET_EQ] = ACTIONS(7194),
    [anon_sym_PLUS_EQ] = ACTIONS(7194),
    [anon_sym_LT] = ACTIONS(7197),
    [anon_sym_LT_LT] = ACTIONS(7197),
    [anon_sym_LT_LT_EQ] = ACTIONS(7194),
    [anon_sym_LT_EQ] = ACTIONS(7194),
    [anon_sym_EQ] = ACTIONS(7197),
    [anon_sym_EQ_EQ] = ACTIONS(7194),
    [anon_sym_GT] = ACTIONS(7197),
    [anon_sym_GT_EQ] = ACTIONS(7194),
    [anon_sym_GT_GT] = ACTIONS(7197),
    [anon_sym_GT_GT_EQ] = ACTIONS(7194),
    [anon_sym_PIPE] = ACTIONS(7197),
    [anon_sym_PIPE_EQ] = ACTIONS(7194),
    [anon_sym_PIPE_PIPE] = ACTIONS(7194),
    [anon_sym_TILDE] = ACTIONS(6588),
    [anon_sym_QMARK] = ACTIONS(7194),
    [anon_sym_SQUOTE] = ACTIONS(6590),
    [anon_sym_DOT_DOT] = ACTIONS(7197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7194),
    [anon_sym_as] = ACTIONS(7197),
    [anon_sym_break] = ACTIONS(6590),
    [anon_sym_const] = ACTIONS(6590),
    [anon_sym_continue] = ACTIONS(6590),
    [anon_sym_default] = ACTIONS(6590),
    [anon_sym_enum] = ACTIONS(6590),
    [anon_sym_fn] = ACTIONS(6590),
    [anon_sym_for] = ACTIONS(6590),
    [anon_sym_if] = ACTIONS(6590),
    [anon_sym_impl] = ACTIONS(6590),
    [anon_sym_let] = ACTIONS(6590),
    [anon_sym_loop] = ACTIONS(6590),
    [anon_sym_match] = ACTIONS(6590),
    [anon_sym_mod] = ACTIONS(6590),
    [anon_sym_pub] = ACTIONS(6590),
    [anon_sym_return] = ACTIONS(6590),
    [anon_sym_static] = ACTIONS(6590),
    [anon_sym_struct] = ACTIONS(6590),
    [anon_sym_trait] = ACTIONS(6590),
    [anon_sym_type] = ACTIONS(6590),
    [anon_sym_union] = ACTIONS(6590),
    [anon_sym_unsafe] = ACTIONS(6590),
    [anon_sym_use] = ACTIONS(6590),
    [anon_sym_where] = ACTIONS(6590),
    [anon_sym_while] = ACTIONS(6590),
    [sym_mutable_specifier] = ACTIONS(6590),
    [sym_integer_literal] = ACTIONS(6588),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6588),
    [sym_char_literal] = ACTIONS(6588),
    [anon_sym_true] = ACTIONS(6590),
    [anon_sym_false] = ACTIONS(6590),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6590),
    [sym_self] = ACTIONS(6590),
    [sym_super] = ACTIONS(6590),
    [sym_crate] = ACTIONS(6590),
    [sym_metavariable] = ACTIONS(6588),
  },
  [3310] = {
    [sym_raw_string_literal] = ACTIONS(6588),
    [sym_float_literal] = ACTIONS(6588),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_LPAREN] = ACTIONS(7208),
    [anon_sym_LBRACE] = ACTIONS(6588),
    [anon_sym_EQ_GT] = ACTIONS(6588),
    [anon_sym_LBRACK] = ACTIONS(7208),
    [anon_sym_RBRACK] = ACTIONS(7208),
    [anon_sym_COLON] = ACTIONS(6590),
    [anon_sym_DOLLAR] = ACTIONS(6590),
    [anon_sym_PLUS] = ACTIONS(7211),
    [anon_sym_STAR] = ACTIONS(7211),
    [anon_sym_COMMA] = ACTIONS(7208),
    [anon_sym_u8] = ACTIONS(6590),
    [anon_sym_i8] = ACTIONS(6590),
    [anon_sym_u16] = ACTIONS(6590),
    [anon_sym_i16] = ACTIONS(6590),
    [anon_sym_u32] = ACTIONS(6590),
    [anon_sym_i32] = ACTIONS(6590),
    [anon_sym_u64] = ACTIONS(6590),
    [anon_sym_i64] = ACTIONS(6590),
    [anon_sym_u128] = ACTIONS(6590),
    [anon_sym_i128] = ACTIONS(6590),
    [anon_sym_isize] = ACTIONS(6590),
    [anon_sym_usize] = ACTIONS(6590),
    [anon_sym_f32] = ACTIONS(6590),
    [anon_sym_f64] = ACTIONS(6590),
    [anon_sym_bool] = ACTIONS(6590),
    [anon_sym_str] = ACTIONS(6590),
    [anon_sym_char] = ACTIONS(6590),
    [anon_sym__] = ACTIONS(6590),
    [anon_sym_AMP] = ACTIONS(7211),
    [anon_sym_DASH] = ACTIONS(7211),
    [anon_sym_DOT] = ACTIONS(7211),
    [anon_sym_DASH_EQ] = ACTIONS(7208),
    [anon_sym_DASH_GT] = ACTIONS(6588),
    [anon_sym_COLON_COLON] = ACTIONS(6588),
    [anon_sym_BANG] = ACTIONS(6590),
    [anon_sym_BANG_EQ] = ACTIONS(7208),
    [anon_sym_AT] = ACTIONS(6588),
    [anon_sym_STAR_EQ] = ACTIONS(7208),
    [anon_sym_SLASH] = ACTIONS(7211),
    [anon_sym_SLASH_EQ] = ACTIONS(7208),
    [anon_sym_AMP_AMP] = ACTIONS(7208),
    [anon_sym_AMP_EQ] = ACTIONS(7208),
    [anon_sym_POUND] = ACTIONS(6588),
    [anon_sym_PERCENT] = ACTIONS(7211),
    [anon_sym_PERCENT_EQ] = ACTIONS(7208),
    [anon_sym_CARET] = ACTIONS(7211),
    [anon_sym_CARET_EQ] = ACTIONS(7208),
    [anon_sym_PLUS_EQ] = ACTIONS(7208),
    [anon_sym_LT] = ACTIONS(7211),
    [anon_sym_LT_LT] = ACTIONS(7211),
    [anon_sym_LT_LT_EQ] = ACTIONS(7208),
    [anon_sym_LT_EQ] = ACTIONS(7208),
    [anon_sym_EQ] = ACTIONS(7211),
    [anon_sym_EQ_EQ] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7211),
    [anon_sym_GT_EQ] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7211),
    [anon_sym_GT_GT_EQ] = ACTIONS(7208),
    [anon_sym_PIPE] = ACTIONS(7211),
    [anon_sym_PIPE_EQ] = ACTIONS(7208),
    [anon_sym_PIPE_PIPE] = ACTIONS(7208),
    [anon_sym_TILDE] = ACTIONS(6588),
    [anon_sym_QMARK] = ACTIONS(7208),
    [anon_sym_SQUOTE] = ACTIONS(6590),
    [anon_sym_DOT_DOT] = ACTIONS(7211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7208),
    [anon_sym_as] = ACTIONS(7211),
    [anon_sym_break] = ACTIONS(6590),
    [anon_sym_const] = ACTIONS(6590),
    [anon_sym_continue] = ACTIONS(6590),
    [anon_sym_default] = ACTIONS(6590),
    [anon_sym_enum] = ACTIONS(6590),
    [anon_sym_fn] = ACTIONS(6590),
    [anon_sym_for] = ACTIONS(6590),
    [anon_sym_if] = ACTIONS(6590),
    [anon_sym_impl] = ACTIONS(6590),
    [anon_sym_let] = ACTIONS(6590),
    [anon_sym_loop] = ACTIONS(6590),
    [anon_sym_match] = ACTIONS(6590),
    [anon_sym_mod] = ACTIONS(6590),
    [anon_sym_pub] = ACTIONS(6590),
    [anon_sym_return] = ACTIONS(6590),
    [anon_sym_static] = ACTIONS(6590),
    [anon_sym_struct] = ACTIONS(6590),
    [anon_sym_trait] = ACTIONS(6590),
    [anon_sym_type] = ACTIONS(6590),
    [anon_sym_union] = ACTIONS(6590),
    [anon_sym_unsafe] = ACTIONS(6590),
    [anon_sym_use] = ACTIONS(6590),
    [anon_sym_where] = ACTIONS(6590),
    [anon_sym_while] = ACTIONS(6590),
    [sym_mutable_specifier] = ACTIONS(6590),
    [sym_integer_literal] = ACTIONS(6588),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6588),
    [sym_char_literal] = ACTIONS(6588),
    [anon_sym_true] = ACTIONS(6590),
    [anon_sym_false] = ACTIONS(6590),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6590),
    [sym_self] = ACTIONS(6590),
    [sym_super] = ACTIONS(6590),
    [sym_crate] = ACTIONS(6590),
    [sym_metavariable] = ACTIONS(6588),
  },
  [3311] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(769),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(769),
    [sym_macro_invocation] = STATE(769),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(769),
    [sym_unary_expression] = STATE(769),
    [sym_try_expression] = STATE(769),
    [sym_reference_expression] = STATE(769),
    [sym_binary_expression] = STATE(769),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(769),
    [sym_call_expression] = STATE(769),
    [sym_array_expression] = STATE(769),
    [sym_parenthesized_expression] = STATE(769),
    [sym_tuple_expression] = STATE(769),
    [sym_unit_expression] = STATE(769),
    [sym_struct_expression] = STATE(769),
    [sym_if_expression] = STATE(769),
    [sym_if_let_expression] = STATE(769),
    [sym_match_expression] = STATE(769),
    [sym_while_expression] = STATE(769),
    [sym_while_let_expression] = STATE(769),
    [sym_loop_expression] = STATE(769),
    [sym_for_expression] = STATE(769),
    [sym_closure_expression] = STATE(769),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(769),
    [sym_continue_expression] = STATE(769),
    [sym_index_expression] = STATE(769),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(769),
    [sym_block] = STATE(769),
    [sym__literal] = STATE(769),
    [sym_string_literal] = STATE(769),
    [sym_boolean_literal] = STATE(769),
    [sym_raw_string_literal] = ACTIONS(1620),
    [sym_float_literal] = ACTIONS(1620),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_RBRACK] = ACTIONS(7572),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1620),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1620),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [3312] = {
    [sym_raw_string_literal] = ACTIONS(7226),
    [sym_float_literal] = ACTIONS(7226),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7226),
    [anon_sym_LPAREN] = ACTIONS(7574),
    [anon_sym_RPAREN] = ACTIONS(7574),
    [anon_sym_LBRACE] = ACTIONS(7226),
    [anon_sym_EQ_GT] = ACTIONS(7226),
    [anon_sym_LBRACK] = ACTIONS(7574),
    [anon_sym_RBRACK] = ACTIONS(7574),
    [anon_sym_COLON] = ACTIONS(7228),
    [anon_sym_DOLLAR] = ACTIONS(7228),
    [anon_sym_PLUS] = ACTIONS(7577),
    [anon_sym_STAR] = ACTIONS(7577),
    [anon_sym_COMMA] = ACTIONS(7574),
    [anon_sym_u8] = ACTIONS(7228),
    [anon_sym_i8] = ACTIONS(7228),
    [anon_sym_u16] = ACTIONS(7228),
    [anon_sym_i16] = ACTIONS(7228),
    [anon_sym_u32] = ACTIONS(7228),
    [anon_sym_i32] = ACTIONS(7228),
    [anon_sym_u64] = ACTIONS(7228),
    [anon_sym_i64] = ACTIONS(7228),
    [anon_sym_u128] = ACTIONS(7228),
    [anon_sym_i128] = ACTIONS(7228),
    [anon_sym_isize] = ACTIONS(7228),
    [anon_sym_usize] = ACTIONS(7228),
    [anon_sym_f32] = ACTIONS(7228),
    [anon_sym_f64] = ACTIONS(7228),
    [anon_sym_bool] = ACTIONS(7228),
    [anon_sym_str] = ACTIONS(7228),
    [anon_sym_char] = ACTIONS(7228),
    [anon_sym__] = ACTIONS(7228),
    [anon_sym_AMP] = ACTIONS(7577),
    [anon_sym_DASH] = ACTIONS(7577),
    [anon_sym_DOT] = ACTIONS(7577),
    [anon_sym_DASH_EQ] = ACTIONS(7574),
    [anon_sym_DASH_GT] = ACTIONS(7226),
    [anon_sym_COLON_COLON] = ACTIONS(7226),
    [anon_sym_BANG] = ACTIONS(7228),
    [anon_sym_BANG_EQ] = ACTIONS(7574),
    [anon_sym_AT] = ACTIONS(7226),
    [anon_sym_STAR_EQ] = ACTIONS(7574),
    [anon_sym_SLASH] = ACTIONS(7577),
    [anon_sym_SLASH_EQ] = ACTIONS(7574),
    [anon_sym_AMP_AMP] = ACTIONS(7574),
    [anon_sym_AMP_EQ] = ACTIONS(7574),
    [anon_sym_POUND] = ACTIONS(7226),
    [anon_sym_PERCENT] = ACTIONS(7577),
    [anon_sym_PERCENT_EQ] = ACTIONS(7574),
    [anon_sym_CARET] = ACTIONS(7577),
    [anon_sym_CARET_EQ] = ACTIONS(7574),
    [anon_sym_PLUS_EQ] = ACTIONS(7574),
    [anon_sym_LT] = ACTIONS(7577),
    [anon_sym_LT_LT] = ACTIONS(7577),
    [anon_sym_LT_LT_EQ] = ACTIONS(7574),
    [anon_sym_LT_EQ] = ACTIONS(7574),
    [anon_sym_EQ] = ACTIONS(7577),
    [anon_sym_EQ_EQ] = ACTIONS(7574),
    [anon_sym_GT] = ACTIONS(7577),
    [anon_sym_GT_EQ] = ACTIONS(7574),
    [anon_sym_GT_GT] = ACTIONS(7577),
    [anon_sym_GT_GT_EQ] = ACTIONS(7574),
    [anon_sym_PIPE] = ACTIONS(7577),
    [anon_sym_PIPE_EQ] = ACTIONS(7574),
    [anon_sym_PIPE_PIPE] = ACTIONS(7574),
    [anon_sym_TILDE] = ACTIONS(7226),
    [anon_sym_QMARK] = ACTIONS(7574),
    [anon_sym_SQUOTE] = ACTIONS(7228),
    [anon_sym_DOT_DOT] = ACTIONS(7577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7574),
    [anon_sym_as] = ACTIONS(7577),
    [anon_sym_break] = ACTIONS(7228),
    [anon_sym_const] = ACTIONS(7228),
    [anon_sym_continue] = ACTIONS(7228),
    [anon_sym_default] = ACTIONS(7228),
    [anon_sym_enum] = ACTIONS(7228),
    [anon_sym_fn] = ACTIONS(7228),
    [anon_sym_for] = ACTIONS(7228),
    [anon_sym_if] = ACTIONS(7228),
    [anon_sym_impl] = ACTIONS(7228),
    [anon_sym_let] = ACTIONS(7228),
    [anon_sym_loop] = ACTIONS(7228),
    [anon_sym_match] = ACTIONS(7228),
    [anon_sym_mod] = ACTIONS(7228),
    [anon_sym_pub] = ACTIONS(7228),
    [anon_sym_return] = ACTIONS(7228),
    [anon_sym_static] = ACTIONS(7228),
    [anon_sym_struct] = ACTIONS(7228),
    [anon_sym_trait] = ACTIONS(7228),
    [anon_sym_type] = ACTIONS(7228),
    [anon_sym_union] = ACTIONS(7228),
    [anon_sym_unsafe] = ACTIONS(7228),
    [anon_sym_use] = ACTIONS(7228),
    [anon_sym_where] = ACTIONS(7228),
    [anon_sym_while] = ACTIONS(7228),
    [sym_mutable_specifier] = ACTIONS(7228),
    [sym_integer_literal] = ACTIONS(7226),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7226),
    [sym_char_literal] = ACTIONS(7226),
    [anon_sym_true] = ACTIONS(7228),
    [anon_sym_false] = ACTIONS(7228),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7228),
    [sym_self] = ACTIONS(7228),
    [sym_super] = ACTIONS(7228),
    [sym_crate] = ACTIONS(7228),
    [sym_metavariable] = ACTIONS(7226),
  },
  [3313] = {
    [sym_raw_string_literal] = ACTIONS(7580),
    [sym_float_literal] = ACTIONS(7580),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7580),
    [anon_sym_LPAREN] = ACTIONS(7580),
    [anon_sym_RPAREN] = ACTIONS(7580),
    [anon_sym_LBRACE] = ACTIONS(7580),
    [anon_sym_RBRACE] = ACTIONS(7580),
    [anon_sym_EQ_GT] = ACTIONS(7580),
    [anon_sym_LBRACK] = ACTIONS(7580),
    [anon_sym_RBRACK] = ACTIONS(7580),
    [anon_sym_COLON] = ACTIONS(7582),
    [anon_sym_DOLLAR] = ACTIONS(7582),
    [anon_sym_PLUS] = ACTIONS(7582),
    [anon_sym_STAR] = ACTIONS(7582),
    [anon_sym_COMMA] = ACTIONS(7580),
    [anon_sym_u8] = ACTIONS(7582),
    [anon_sym_i8] = ACTIONS(7582),
    [anon_sym_u16] = ACTIONS(7582),
    [anon_sym_i16] = ACTIONS(7582),
    [anon_sym_u32] = ACTIONS(7582),
    [anon_sym_i32] = ACTIONS(7582),
    [anon_sym_u64] = ACTIONS(7582),
    [anon_sym_i64] = ACTIONS(7582),
    [anon_sym_u128] = ACTIONS(7582),
    [anon_sym_i128] = ACTIONS(7582),
    [anon_sym_isize] = ACTIONS(7582),
    [anon_sym_usize] = ACTIONS(7582),
    [anon_sym_f32] = ACTIONS(7582),
    [anon_sym_f64] = ACTIONS(7582),
    [anon_sym_bool] = ACTIONS(7582),
    [anon_sym_str] = ACTIONS(7582),
    [anon_sym_char] = ACTIONS(7582),
    [anon_sym__] = ACTIONS(7582),
    [anon_sym_AMP] = ACTIONS(7582),
    [anon_sym_DASH] = ACTIONS(7582),
    [anon_sym_DOT] = ACTIONS(7582),
    [anon_sym_DASH_EQ] = ACTIONS(7580),
    [anon_sym_DASH_GT] = ACTIONS(7580),
    [anon_sym_COLON_COLON] = ACTIONS(7580),
    [anon_sym_BANG] = ACTIONS(7582),
    [anon_sym_BANG_EQ] = ACTIONS(7580),
    [anon_sym_AT] = ACTIONS(7580),
    [anon_sym_STAR_EQ] = ACTIONS(7580),
    [anon_sym_SLASH] = ACTIONS(7582),
    [anon_sym_SLASH_EQ] = ACTIONS(7580),
    [anon_sym_AMP_AMP] = ACTIONS(7580),
    [anon_sym_AMP_EQ] = ACTIONS(7580),
    [anon_sym_POUND] = ACTIONS(7580),
    [anon_sym_PERCENT] = ACTIONS(7582),
    [anon_sym_PERCENT_EQ] = ACTIONS(7580),
    [anon_sym_CARET] = ACTIONS(7582),
    [anon_sym_CARET_EQ] = ACTIONS(7580),
    [anon_sym_PLUS_EQ] = ACTIONS(7580),
    [anon_sym_LT] = ACTIONS(7582),
    [anon_sym_LT_LT] = ACTIONS(7582),
    [anon_sym_LT_LT_EQ] = ACTIONS(7580),
    [anon_sym_LT_EQ] = ACTIONS(7580),
    [anon_sym_EQ] = ACTIONS(7582),
    [anon_sym_EQ_EQ] = ACTIONS(7580),
    [anon_sym_GT] = ACTIONS(7582),
    [anon_sym_GT_EQ] = ACTIONS(7580),
    [anon_sym_GT_GT] = ACTIONS(7582),
    [anon_sym_GT_GT_EQ] = ACTIONS(7580),
    [anon_sym_PIPE] = ACTIONS(7582),
    [anon_sym_PIPE_EQ] = ACTIONS(7580),
    [anon_sym_PIPE_PIPE] = ACTIONS(7580),
    [anon_sym_TILDE] = ACTIONS(7580),
    [anon_sym_QMARK] = ACTIONS(7580),
    [anon_sym_SQUOTE] = ACTIONS(7582),
    [anon_sym_DOT_DOT] = ACTIONS(7582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7580),
    [anon_sym_as] = ACTIONS(7582),
    [anon_sym_break] = ACTIONS(7582),
    [anon_sym_const] = ACTIONS(7582),
    [anon_sym_continue] = ACTIONS(7582),
    [anon_sym_default] = ACTIONS(7582),
    [anon_sym_enum] = ACTIONS(7582),
    [anon_sym_fn] = ACTIONS(7582),
    [anon_sym_for] = ACTIONS(7582),
    [anon_sym_if] = ACTIONS(7582),
    [anon_sym_impl] = ACTIONS(7582),
    [anon_sym_let] = ACTIONS(7582),
    [anon_sym_loop] = ACTIONS(7582),
    [anon_sym_match] = ACTIONS(7582),
    [anon_sym_mod] = ACTIONS(7582),
    [anon_sym_pub] = ACTIONS(7582),
    [anon_sym_return] = ACTIONS(7582),
    [anon_sym_static] = ACTIONS(7582),
    [anon_sym_struct] = ACTIONS(7582),
    [anon_sym_trait] = ACTIONS(7582),
    [anon_sym_type] = ACTIONS(7582),
    [anon_sym_union] = ACTIONS(7582),
    [anon_sym_unsafe] = ACTIONS(7582),
    [anon_sym_use] = ACTIONS(7582),
    [anon_sym_where] = ACTIONS(7582),
    [anon_sym_while] = ACTIONS(7582),
    [sym_mutable_specifier] = ACTIONS(7582),
    [sym_integer_literal] = ACTIONS(7580),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7580),
    [sym_char_literal] = ACTIONS(7580),
    [anon_sym_true] = ACTIONS(7582),
    [anon_sym_false] = ACTIONS(7582),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7582),
    [sym_self] = ACTIONS(7582),
    [sym_super] = ACTIONS(7582),
    [sym_crate] = ACTIONS(7582),
    [sym_metavariable] = ACTIONS(7580),
  },
  [3314] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7584),
    [anon_sym_STAR] = ACTIONS(7584),
    [sym_line_comment] = ACTIONS(7),
  },
  [3315] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(769),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(769),
    [sym_macro_invocation] = STATE(769),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(769),
    [sym_unary_expression] = STATE(769),
    [sym_try_expression] = STATE(769),
    [sym_reference_expression] = STATE(769),
    [sym_binary_expression] = STATE(769),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(769),
    [sym_call_expression] = STATE(769),
    [sym_array_expression] = STATE(769),
    [sym_parenthesized_expression] = STATE(769),
    [sym_tuple_expression] = STATE(769),
    [sym_unit_expression] = STATE(769),
    [sym_struct_expression] = STATE(769),
    [sym_if_expression] = STATE(769),
    [sym_if_let_expression] = STATE(769),
    [sym_match_expression] = STATE(769),
    [sym_while_expression] = STATE(769),
    [sym_while_let_expression] = STATE(769),
    [sym_loop_expression] = STATE(769),
    [sym_for_expression] = STATE(769),
    [sym_closure_expression] = STATE(769),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(769),
    [sym_continue_expression] = STATE(769),
    [sym_index_expression] = STATE(769),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(769),
    [sym_block] = STATE(769),
    [sym__literal] = STATE(769),
    [sym_string_literal] = STATE(769),
    [sym_boolean_literal] = STATE(769),
    [sym_raw_string_literal] = ACTIONS(1620),
    [sym_float_literal] = ACTIONS(1620),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_RBRACK] = ACTIONS(7192),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1620),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1620),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [3316] = {
    [sym_raw_string_literal] = ACTIONS(7226),
    [sym_float_literal] = ACTIONS(7226),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7574),
    [anon_sym_LPAREN] = ACTIONS(7574),
    [anon_sym_LBRACE] = ACTIONS(7226),
    [anon_sym_RBRACE] = ACTIONS(7574),
    [anon_sym_EQ_GT] = ACTIONS(7226),
    [anon_sym_LBRACK] = ACTIONS(7574),
    [anon_sym_COLON] = ACTIONS(7228),
    [anon_sym_DOLLAR] = ACTIONS(7228),
    [anon_sym_PLUS] = ACTIONS(7577),
    [anon_sym_STAR] = ACTIONS(7577),
    [anon_sym_COMMA] = ACTIONS(7226),
    [anon_sym_u8] = ACTIONS(7228),
    [anon_sym_i8] = ACTIONS(7228),
    [anon_sym_u16] = ACTIONS(7228),
    [anon_sym_i16] = ACTIONS(7228),
    [anon_sym_u32] = ACTIONS(7228),
    [anon_sym_i32] = ACTIONS(7228),
    [anon_sym_u64] = ACTIONS(7228),
    [anon_sym_i64] = ACTIONS(7228),
    [anon_sym_u128] = ACTIONS(7228),
    [anon_sym_i128] = ACTIONS(7228),
    [anon_sym_isize] = ACTIONS(7228),
    [anon_sym_usize] = ACTIONS(7228),
    [anon_sym_f32] = ACTIONS(7228),
    [anon_sym_f64] = ACTIONS(7228),
    [anon_sym_bool] = ACTIONS(7228),
    [anon_sym_str] = ACTIONS(7228),
    [anon_sym_char] = ACTIONS(7228),
    [anon_sym__] = ACTIONS(7228),
    [anon_sym_AMP] = ACTIONS(7577),
    [anon_sym_DASH] = ACTIONS(7577),
    [anon_sym_DOT] = ACTIONS(7577),
    [anon_sym_DASH_EQ] = ACTIONS(7574),
    [anon_sym_DASH_GT] = ACTIONS(7226),
    [anon_sym_COLON_COLON] = ACTIONS(7226),
    [anon_sym_BANG] = ACTIONS(7228),
    [anon_sym_BANG_EQ] = ACTIONS(7574),
    [anon_sym_AT] = ACTIONS(7226),
    [anon_sym_STAR_EQ] = ACTIONS(7574),
    [anon_sym_SLASH] = ACTIONS(7577),
    [anon_sym_SLASH_EQ] = ACTIONS(7574),
    [anon_sym_AMP_AMP] = ACTIONS(7574),
    [anon_sym_AMP_EQ] = ACTIONS(7574),
    [anon_sym_POUND] = ACTIONS(7226),
    [anon_sym_PERCENT] = ACTIONS(7577),
    [anon_sym_PERCENT_EQ] = ACTIONS(7574),
    [anon_sym_CARET] = ACTIONS(7577),
    [anon_sym_CARET_EQ] = ACTIONS(7574),
    [anon_sym_PLUS_EQ] = ACTIONS(7574),
    [anon_sym_LT] = ACTIONS(7577),
    [anon_sym_LT_LT] = ACTIONS(7577),
    [anon_sym_LT_LT_EQ] = ACTIONS(7574),
    [anon_sym_LT_EQ] = ACTIONS(7574),
    [anon_sym_EQ] = ACTIONS(7577),
    [anon_sym_EQ_EQ] = ACTIONS(7574),
    [anon_sym_GT] = ACTIONS(7577),
    [anon_sym_GT_EQ] = ACTIONS(7574),
    [anon_sym_GT_GT] = ACTIONS(7577),
    [anon_sym_GT_GT_EQ] = ACTIONS(7574),
    [anon_sym_PIPE] = ACTIONS(7577),
    [anon_sym_PIPE_EQ] = ACTIONS(7574),
    [anon_sym_PIPE_PIPE] = ACTIONS(7574),
    [anon_sym_TILDE] = ACTIONS(7226),
    [anon_sym_QMARK] = ACTIONS(7574),
    [anon_sym_SQUOTE] = ACTIONS(7228),
    [anon_sym_DOT_DOT] = ACTIONS(7577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7574),
    [anon_sym_as] = ACTIONS(7577),
    [anon_sym_break] = ACTIONS(7228),
    [anon_sym_const] = ACTIONS(7228),
    [anon_sym_continue] = ACTIONS(7228),
    [anon_sym_default] = ACTIONS(7228),
    [anon_sym_enum] = ACTIONS(7228),
    [anon_sym_fn] = ACTIONS(7228),
    [anon_sym_for] = ACTIONS(7228),
    [anon_sym_if] = ACTIONS(7228),
    [anon_sym_impl] = ACTIONS(7228),
    [anon_sym_let] = ACTIONS(7228),
    [anon_sym_loop] = ACTIONS(7228),
    [anon_sym_match] = ACTIONS(7228),
    [anon_sym_mod] = ACTIONS(7228),
    [anon_sym_pub] = ACTIONS(7228),
    [anon_sym_return] = ACTIONS(7228),
    [anon_sym_static] = ACTIONS(7228),
    [anon_sym_struct] = ACTIONS(7228),
    [anon_sym_trait] = ACTIONS(7228),
    [anon_sym_type] = ACTIONS(7228),
    [anon_sym_union] = ACTIONS(7228),
    [anon_sym_unsafe] = ACTIONS(7228),
    [anon_sym_use] = ACTIONS(7228),
    [anon_sym_where] = ACTIONS(7228),
    [anon_sym_while] = ACTIONS(7228),
    [sym_mutable_specifier] = ACTIONS(7228),
    [sym_integer_literal] = ACTIONS(7226),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7226),
    [sym_char_literal] = ACTIONS(7226),
    [anon_sym_true] = ACTIONS(7228),
    [anon_sym_false] = ACTIONS(7228),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7228),
    [sym_self] = ACTIONS(7228),
    [sym_super] = ACTIONS(7228),
    [sym_crate] = ACTIONS(7228),
    [sym_metavariable] = ACTIONS(7226),
  },
  [3317] = {
    [sym_block] = STATE(3512),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7586),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [sym_line_comment] = ACTIONS(7),
  },
  [3318] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5842),
    [anon_sym_macro_rules_BANG] = ACTIONS(5842),
    [anon_sym_RBRACE] = ACTIONS(5842),
    [anon_sym_POUND] = ACTIONS(5842),
    [anon_sym_const] = ACTIONS(5844),
    [anon_sym_default] = ACTIONS(5844),
    [anon_sym_enum] = ACTIONS(5844),
    [anon_sym_fn] = ACTIONS(5844),
    [anon_sym_impl] = ACTIONS(5844),
    [anon_sym_let] = ACTIONS(5844),
    [anon_sym_mod] = ACTIONS(5844),
    [anon_sym_pub] = ACTIONS(5844),
    [anon_sym_static] = ACTIONS(5844),
    [anon_sym_struct] = ACTIONS(5844),
    [anon_sym_trait] = ACTIONS(5844),
    [anon_sym_type] = ACTIONS(5844),
    [anon_sym_union] = ACTIONS(5844),
    [anon_sym_unsafe] = ACTIONS(5844),
    [anon_sym_use] = ACTIONS(5844),
    [anon_sym_extern] = ACTIONS(5844),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5844),
  },
  [3319] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7588),
    [sym_line_comment] = ACTIONS(7),
  },
  [3320] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7590),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(467),
    [anon_sym_BANG_EQ] = ACTIONS(469),
    [anon_sym_STAR_EQ] = ACTIONS(467),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(467),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_AMP_EQ] = ACTIONS(467),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(467),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_CARET_EQ] = ACTIONS(467),
    [anon_sym_PLUS_EQ] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT_LT_EQ] = ACTIONS(467),
    [anon_sym_LT_EQ] = ACTIONS(469),
    [anon_sym_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_EQ] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_PIPE_EQ] = ACTIONS(467),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(489),
    [anon_sym_as] = ACTIONS(491),
    [sym_line_comment] = ACTIONS(7),
  },
  [3321] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6086),
    [anon_sym_macro_rules_BANG] = ACTIONS(6086),
    [anon_sym_RBRACE] = ACTIONS(6086),
    [anon_sym_POUND] = ACTIONS(6086),
    [anon_sym_const] = ACTIONS(6088),
    [anon_sym_default] = ACTIONS(6088),
    [anon_sym_enum] = ACTIONS(6088),
    [anon_sym_fn] = ACTIONS(6088),
    [anon_sym_impl] = ACTIONS(6088),
    [anon_sym_let] = ACTIONS(6088),
    [anon_sym_mod] = ACTIONS(6088),
    [anon_sym_pub] = ACTIONS(6088),
    [anon_sym_static] = ACTIONS(6088),
    [anon_sym_struct] = ACTIONS(6088),
    [anon_sym_trait] = ACTIONS(6088),
    [anon_sym_type] = ACTIONS(6088),
    [anon_sym_union] = ACTIONS(6088),
    [anon_sym_unsafe] = ACTIONS(6088),
    [anon_sym_use] = ACTIONS(6088),
    [anon_sym_extern] = ACTIONS(6088),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6088),
  },
  [3322] = {
    [sym_attribute_item] = STATE(2209),
    [sym_enum_variant] = STATE(2208),
    [sym_visibility_modifier] = STATE(938),
    [aux_sym_enum_variant_list_repeat1] = STATE(2209),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7592),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_pub] = ACTIONS(1940),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1942),
  },
  [3323] = {
    [aux_sym_enum_variant_list_repeat2] = STATE(2211),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7592),
    [anon_sym_COMMA] = ACTIONS(7594),
    [sym_line_comment] = ACTIONS(7),
  },
  [3324] = {
    [sym_where_clause] = STATE(3518),
    [sym_block] = STATE(3519),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7596),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(5003),
    [anon_sym_where] = ACTIONS(1962),
    [sym_line_comment] = ACTIONS(7),
  },
  [3325] = {
    [sym_where_clause] = STATE(3518),
    [sym_block] = STATE(3519),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7596),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_where] = ACTIONS(1962),
    [sym_line_comment] = ACTIONS(7),
  },
  [3326] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6128),
    [anon_sym_macro_rules_BANG] = ACTIONS(6128),
    [anon_sym_RBRACE] = ACTIONS(6128),
    [anon_sym_POUND] = ACTIONS(6128),
    [anon_sym_const] = ACTIONS(6130),
    [anon_sym_default] = ACTIONS(6130),
    [anon_sym_enum] = ACTIONS(6130),
    [anon_sym_fn] = ACTIONS(6130),
    [anon_sym_impl] = ACTIONS(6130),
    [anon_sym_let] = ACTIONS(6130),
    [anon_sym_mod] = ACTIONS(6130),
    [anon_sym_pub] = ACTIONS(6130),
    [anon_sym_static] = ACTIONS(6130),
    [anon_sym_struct] = ACTIONS(6130),
    [anon_sym_trait] = ACTIONS(6130),
    [anon_sym_type] = ACTIONS(6130),
    [anon_sym_union] = ACTIONS(6130),
    [anon_sym_unsafe] = ACTIONS(6130),
    [anon_sym_use] = ACTIONS(6130),
    [anon_sym_extern] = ACTIONS(6130),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6130),
  },
  [3327] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6132),
    [anon_sym_macro_rules_BANG] = ACTIONS(6132),
    [anon_sym_RBRACE] = ACTIONS(6132),
    [anon_sym_POUND] = ACTIONS(6132),
    [anon_sym_const] = ACTIONS(6134),
    [anon_sym_default] = ACTIONS(6134),
    [anon_sym_enum] = ACTIONS(6134),
    [anon_sym_fn] = ACTIONS(6134),
    [anon_sym_impl] = ACTIONS(6134),
    [anon_sym_let] = ACTIONS(6134),
    [anon_sym_mod] = ACTIONS(6134),
    [anon_sym_pub] = ACTIONS(6134),
    [anon_sym_static] = ACTIONS(6134),
    [anon_sym_struct] = ACTIONS(6134),
    [anon_sym_trait] = ACTIONS(6134),
    [anon_sym_type] = ACTIONS(6134),
    [anon_sym_union] = ACTIONS(6134),
    [anon_sym_unsafe] = ACTIONS(6134),
    [anon_sym_use] = ACTIONS(6134),
    [anon_sym_extern] = ACTIONS(6134),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6134),
  },
  [3328] = {
    [sym_block] = STATE(3519),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7596),
    [anon_sym_LBRACE] = ACTIONS(111),
    [sym_line_comment] = ACTIONS(7),
  },
  [3329] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6178),
    [anon_sym_macro_rules_BANG] = ACTIONS(6178),
    [anon_sym_RBRACE] = ACTIONS(6178),
    [anon_sym_POUND] = ACTIONS(6178),
    [anon_sym_const] = ACTIONS(6180),
    [anon_sym_default] = ACTIONS(6180),
    [anon_sym_enum] = ACTIONS(6180),
    [anon_sym_fn] = ACTIONS(6180),
    [anon_sym_impl] = ACTIONS(6180),
    [anon_sym_let] = ACTIONS(6180),
    [anon_sym_mod] = ACTIONS(6180),
    [anon_sym_pub] = ACTIONS(6180),
    [anon_sym_static] = ACTIONS(6180),
    [anon_sym_struct] = ACTIONS(6180),
    [anon_sym_trait] = ACTIONS(6180),
    [anon_sym_type] = ACTIONS(6180),
    [anon_sym_union] = ACTIONS(6180),
    [anon_sym_unsafe] = ACTIONS(6180),
    [anon_sym_use] = ACTIONS(6180),
    [anon_sym_extern] = ACTIONS(6180),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6180),
  },
  [3330] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6182),
    [anon_sym_macro_rules_BANG] = ACTIONS(6182),
    [anon_sym_RBRACE] = ACTIONS(6182),
    [anon_sym_POUND] = ACTIONS(6182),
    [anon_sym_const] = ACTIONS(6184),
    [anon_sym_default] = ACTIONS(6184),
    [anon_sym_enum] = ACTIONS(6184),
    [anon_sym_fn] = ACTIONS(6184),
    [anon_sym_impl] = ACTIONS(6184),
    [anon_sym_let] = ACTIONS(6184),
    [anon_sym_mod] = ACTIONS(6184),
    [anon_sym_pub] = ACTIONS(6184),
    [anon_sym_static] = ACTIONS(6184),
    [anon_sym_struct] = ACTIONS(6184),
    [anon_sym_trait] = ACTIONS(6184),
    [anon_sym_type] = ACTIONS(6184),
    [anon_sym_union] = ACTIONS(6184),
    [anon_sym_unsafe] = ACTIONS(6184),
    [anon_sym_use] = ACTIONS(6184),
    [anon_sym_extern] = ACTIONS(6184),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6184),
  },
  [3331] = {
    [sym_declaration_list] = STATE(3520),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [sym_line_comment] = ACTIONS(7),
  },
  [3332] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6186),
    [anon_sym_macro_rules_BANG] = ACTIONS(6186),
    [anon_sym_RBRACE] = ACTIONS(6186),
    [anon_sym_POUND] = ACTIONS(6186),
    [anon_sym_const] = ACTIONS(6188),
    [anon_sym_default] = ACTIONS(6188),
    [anon_sym_enum] = ACTIONS(6188),
    [anon_sym_fn] = ACTIONS(6188),
    [anon_sym_impl] = ACTIONS(6188),
    [anon_sym_let] = ACTIONS(6188),
    [anon_sym_mod] = ACTIONS(6188),
    [anon_sym_pub] = ACTIONS(6188),
    [anon_sym_static] = ACTIONS(6188),
    [anon_sym_struct] = ACTIONS(6188),
    [anon_sym_trait] = ACTIONS(6188),
    [anon_sym_type] = ACTIONS(6188),
    [anon_sym_union] = ACTIONS(6188),
    [anon_sym_unsafe] = ACTIONS(6188),
    [anon_sym_use] = ACTIONS(6188),
    [anon_sym_extern] = ACTIONS(6188),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6188),
  },
  [3333] = {
    [sym_declaration_list] = STATE(3521),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [sym_line_comment] = ACTIONS(7),
  },
  [3334] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6190),
    [anon_sym_macro_rules_BANG] = ACTIONS(6190),
    [anon_sym_RBRACE] = ACTIONS(6190),
    [anon_sym_POUND] = ACTIONS(6190),
    [anon_sym_const] = ACTIONS(6192),
    [anon_sym_default] = ACTIONS(6192),
    [anon_sym_enum] = ACTIONS(6192),
    [anon_sym_fn] = ACTIONS(6192),
    [anon_sym_impl] = ACTIONS(6192),
    [anon_sym_let] = ACTIONS(6192),
    [anon_sym_mod] = ACTIONS(6192),
    [anon_sym_pub] = ACTIONS(6192),
    [anon_sym_static] = ACTIONS(6192),
    [anon_sym_struct] = ACTIONS(6192),
    [anon_sym_trait] = ACTIONS(6192),
    [anon_sym_type] = ACTIONS(6192),
    [anon_sym_union] = ACTIONS(6192),
    [anon_sym_unsafe] = ACTIONS(6192),
    [anon_sym_use] = ACTIONS(6192),
    [anon_sym_extern] = ACTIONS(6192),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6192),
  },
  [3335] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3522),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3522),
    [sym_macro_invocation] = STATE(3522),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3522),
    [sym_unary_expression] = STATE(3522),
    [sym_try_expression] = STATE(3522),
    [sym_reference_expression] = STATE(3522),
    [sym_binary_expression] = STATE(3522),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3522),
    [sym_call_expression] = STATE(3522),
    [sym_array_expression] = STATE(3522),
    [sym_parenthesized_expression] = STATE(3522),
    [sym_tuple_expression] = STATE(3522),
    [sym_unit_expression] = STATE(3522),
    [sym_struct_expression] = STATE(3522),
    [sym_if_expression] = STATE(3522),
    [sym_if_let_expression] = STATE(3522),
    [sym_match_expression] = STATE(3522),
    [sym_while_expression] = STATE(3522),
    [sym_while_let_expression] = STATE(3522),
    [sym_loop_expression] = STATE(3522),
    [sym_for_expression] = STATE(3522),
    [sym_closure_expression] = STATE(3522),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3522),
    [sym_continue_expression] = STATE(3522),
    [sym_index_expression] = STATE(3522),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3522),
    [sym_block] = STATE(3522),
    [sym__literal] = STATE(3522),
    [sym_string_literal] = STATE(3522),
    [sym_boolean_literal] = STATE(3522),
    [sym_raw_string_literal] = ACTIONS(7598),
    [sym_float_literal] = ACTIONS(7598),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(7598),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7598),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [3336] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7600),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(467),
    [anon_sym_BANG_EQ] = ACTIONS(469),
    [anon_sym_STAR_EQ] = ACTIONS(467),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(467),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_AMP_EQ] = ACTIONS(467),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(467),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_CARET_EQ] = ACTIONS(467),
    [anon_sym_PLUS_EQ] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT_LT_EQ] = ACTIONS(467),
    [anon_sym_LT_EQ] = ACTIONS(469),
    [anon_sym_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_EQ] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_PIPE_EQ] = ACTIONS(467),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(489),
    [anon_sym_as] = ACTIONS(491),
    [sym_line_comment] = ACTIONS(7),
  },
  [3337] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6377),
    [anon_sym_macro_rules_BANG] = ACTIONS(6377),
    [anon_sym_RBRACE] = ACTIONS(6377),
    [anon_sym_POUND] = ACTIONS(6377),
    [anon_sym_const] = ACTIONS(6379),
    [anon_sym_default] = ACTIONS(6379),
    [anon_sym_enum] = ACTIONS(6379),
    [anon_sym_fn] = ACTIONS(6379),
    [anon_sym_impl] = ACTIONS(6379),
    [anon_sym_let] = ACTIONS(6379),
    [anon_sym_mod] = ACTIONS(6379),
    [anon_sym_pub] = ACTIONS(6379),
    [anon_sym_static] = ACTIONS(6379),
    [anon_sym_struct] = ACTIONS(6379),
    [anon_sym_trait] = ACTIONS(6379),
    [anon_sym_type] = ACTIONS(6379),
    [anon_sym_union] = ACTIONS(6379),
    [anon_sym_unsafe] = ACTIONS(6379),
    [anon_sym_use] = ACTIONS(6379),
    [anon_sym_extern] = ACTIONS(6379),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6379),
  },
  [3338] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3524),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3524),
    [sym_macro_invocation] = STATE(3524),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3524),
    [sym_unary_expression] = STATE(3524),
    [sym_try_expression] = STATE(3524),
    [sym_reference_expression] = STATE(3524),
    [sym_binary_expression] = STATE(3524),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3524),
    [sym_call_expression] = STATE(3524),
    [sym_array_expression] = STATE(3524),
    [sym_parenthesized_expression] = STATE(3524),
    [sym_tuple_expression] = STATE(3524),
    [sym_unit_expression] = STATE(3524),
    [sym_struct_expression] = STATE(3524),
    [sym_if_expression] = STATE(3524),
    [sym_if_let_expression] = STATE(3524),
    [sym_match_expression] = STATE(3524),
    [sym_while_expression] = STATE(3524),
    [sym_while_let_expression] = STATE(3524),
    [sym_loop_expression] = STATE(3524),
    [sym_for_expression] = STATE(3524),
    [sym_closure_expression] = STATE(3524),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3524),
    [sym_continue_expression] = STATE(3524),
    [sym_index_expression] = STATE(3524),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3524),
    [sym_block] = STATE(3524),
    [sym__literal] = STATE(3524),
    [sym_string_literal] = STATE(3524),
    [sym_boolean_literal] = STATE(3524),
    [sym_raw_string_literal] = ACTIONS(7602),
    [sym_float_literal] = ACTIONS(7602),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(7602),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7602),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [3339] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7604),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(467),
    [anon_sym_BANG_EQ] = ACTIONS(469),
    [anon_sym_STAR_EQ] = ACTIONS(467),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(467),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_AMP_EQ] = ACTIONS(467),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(467),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_CARET_EQ] = ACTIONS(467),
    [anon_sym_PLUS_EQ] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT_LT_EQ] = ACTIONS(467),
    [anon_sym_LT_EQ] = ACTIONS(469),
    [anon_sym_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_EQ] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_PIPE_EQ] = ACTIONS(467),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(489),
    [anon_sym_as] = ACTIONS(491),
    [sym_line_comment] = ACTIONS(7),
  },
  [3340] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6464),
    [anon_sym_macro_rules_BANG] = ACTIONS(6464),
    [anon_sym_RBRACE] = ACTIONS(6464),
    [anon_sym_POUND] = ACTIONS(6464),
    [anon_sym_const] = ACTIONS(6466),
    [anon_sym_default] = ACTIONS(6466),
    [anon_sym_enum] = ACTIONS(6466),
    [anon_sym_fn] = ACTIONS(6466),
    [anon_sym_impl] = ACTIONS(6466),
    [anon_sym_let] = ACTIONS(6466),
    [anon_sym_mod] = ACTIONS(6466),
    [anon_sym_pub] = ACTIONS(6466),
    [anon_sym_static] = ACTIONS(6466),
    [anon_sym_struct] = ACTIONS(6466),
    [anon_sym_trait] = ACTIONS(6466),
    [anon_sym_type] = ACTIONS(6466),
    [anon_sym_union] = ACTIONS(6466),
    [anon_sym_unsafe] = ACTIONS(6466),
    [anon_sym_use] = ACTIONS(6466),
    [anon_sym_extern] = ACTIONS(6466),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6466),
  },
  [3341] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7606),
    [sym_line_comment] = ACTIONS(7),
  },
  [3342] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6488),
    [anon_sym_macro_rules_BANG] = ACTIONS(6488),
    [anon_sym_RBRACE] = ACTIONS(6488),
    [anon_sym_POUND] = ACTIONS(6488),
    [anon_sym_const] = ACTIONS(6490),
    [anon_sym_default] = ACTIONS(6490),
    [anon_sym_enum] = ACTIONS(6490),
    [anon_sym_fn] = ACTIONS(6490),
    [anon_sym_impl] = ACTIONS(6490),
    [anon_sym_let] = ACTIONS(6490),
    [anon_sym_mod] = ACTIONS(6490),
    [anon_sym_pub] = ACTIONS(6490),
    [anon_sym_static] = ACTIONS(6490),
    [anon_sym_struct] = ACTIONS(6490),
    [anon_sym_trait] = ACTIONS(6490),
    [anon_sym_type] = ACTIONS(6490),
    [anon_sym_union] = ACTIONS(6490),
    [anon_sym_unsafe] = ACTIONS(6490),
    [anon_sym_use] = ACTIONS(6490),
    [anon_sym_extern] = ACTIONS(6490),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6490),
  },
  [3343] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6492),
    [anon_sym_macro_rules_BANG] = ACTIONS(6492),
    [anon_sym_RBRACE] = ACTIONS(6492),
    [anon_sym_POUND] = ACTIONS(6492),
    [anon_sym_const] = ACTIONS(6494),
    [anon_sym_default] = ACTIONS(6494),
    [anon_sym_enum] = ACTIONS(6494),
    [anon_sym_fn] = ACTIONS(6494),
    [anon_sym_impl] = ACTIONS(6494),
    [anon_sym_let] = ACTIONS(6494),
    [anon_sym_mod] = ACTIONS(6494),
    [anon_sym_pub] = ACTIONS(6494),
    [anon_sym_static] = ACTIONS(6494),
    [anon_sym_struct] = ACTIONS(6494),
    [anon_sym_trait] = ACTIONS(6494),
    [anon_sym_type] = ACTIONS(6494),
    [anon_sym_union] = ACTIONS(6494),
    [anon_sym_unsafe] = ACTIONS(6494),
    [anon_sym_use] = ACTIONS(6494),
    [anon_sym_extern] = ACTIONS(6494),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6494),
  },
  [3344] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6496),
    [anon_sym_macro_rules_BANG] = ACTIONS(6496),
    [anon_sym_RBRACE] = ACTIONS(6496),
    [anon_sym_POUND] = ACTIONS(6496),
    [anon_sym_const] = ACTIONS(6498),
    [anon_sym_default] = ACTIONS(6498),
    [anon_sym_enum] = ACTIONS(6498),
    [anon_sym_fn] = ACTIONS(6498),
    [anon_sym_impl] = ACTIONS(6498),
    [anon_sym_let] = ACTIONS(6498),
    [anon_sym_mod] = ACTIONS(6498),
    [anon_sym_pub] = ACTIONS(6498),
    [anon_sym_static] = ACTIONS(6498),
    [anon_sym_struct] = ACTIONS(6498),
    [anon_sym_trait] = ACTIONS(6498),
    [anon_sym_type] = ACTIONS(6498),
    [anon_sym_union] = ACTIONS(6498),
    [anon_sym_unsafe] = ACTIONS(6498),
    [anon_sym_use] = ACTIONS(6498),
    [anon_sym_extern] = ACTIONS(6498),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6498),
  },
  [3345] = {
    [sym_declaration_list] = STATE(3527),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [sym_line_comment] = ACTIONS(7),
  },
  [3346] = {
    [sym_declaration_list] = STATE(3527),
    [sym_where_clause] = STATE(3528),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [3347] = {
    [sym_declaration_list] = STATE(3521),
    [sym_where_clause] = STATE(3529),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [anon_sym_where] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(7),
  },
  [3348] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6508),
    [anon_sym_macro_rules_BANG] = ACTIONS(6508),
    [anon_sym_RBRACE] = ACTIONS(6508),
    [anon_sym_POUND] = ACTIONS(6508),
    [anon_sym_const] = ACTIONS(6510),
    [anon_sym_default] = ACTIONS(6510),
    [anon_sym_enum] = ACTIONS(6510),
    [anon_sym_fn] = ACTIONS(6510),
    [anon_sym_impl] = ACTIONS(6510),
    [anon_sym_let] = ACTIONS(6510),
    [anon_sym_mod] = ACTIONS(6510),
    [anon_sym_pub] = ACTIONS(6510),
    [anon_sym_static] = ACTIONS(6510),
    [anon_sym_struct] = ACTIONS(6510),
    [anon_sym_trait] = ACTIONS(6510),
    [anon_sym_type] = ACTIONS(6510),
    [anon_sym_union] = ACTIONS(6510),
    [anon_sym_unsafe] = ACTIONS(6510),
    [anon_sym_use] = ACTIONS(6510),
    [anon_sym_extern] = ACTIONS(6510),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6510),
  },
  [3349] = {
    [sym_function_modifiers] = STATE(1624),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3530),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1626),
    [sym_array_type] = STATE(3530),
    [sym_function_type] = STATE(3530),
    [sym_tuple_type] = STATE(3530),
    [sym_unit_type] = STATE(3530),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(3530),
    [sym_reference_type] = STATE(3530),
    [sym_pointer_type] = STATE(3530),
    [sym_empty_type] = STATE(3530),
    [sym_abstract_type] = STATE(3531),
    [sym_dynamic_type] = STATE(3530),
    [sym_macro_invocation] = STATE(3530),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1628),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3169),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3171),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3173),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3175),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3350] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3532),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3532),
    [sym_macro_invocation] = STATE(3532),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3532),
    [sym_unary_expression] = STATE(3532),
    [sym_try_expression] = STATE(3532),
    [sym_reference_expression] = STATE(3532),
    [sym_binary_expression] = STATE(3532),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3532),
    [sym_call_expression] = STATE(3532),
    [sym_array_expression] = STATE(3532),
    [sym_parenthesized_expression] = STATE(3532),
    [sym_tuple_expression] = STATE(3532),
    [sym_unit_expression] = STATE(3532),
    [sym_struct_expression] = STATE(3532),
    [sym_if_expression] = STATE(3532),
    [sym_if_let_expression] = STATE(3532),
    [sym_match_expression] = STATE(3532),
    [sym_while_expression] = STATE(3532),
    [sym_while_let_expression] = STATE(3532),
    [sym_loop_expression] = STATE(3532),
    [sym_for_expression] = STATE(3532),
    [sym_closure_expression] = STATE(3532),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3532),
    [sym_continue_expression] = STATE(3532),
    [sym_index_expression] = STATE(3532),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3532),
    [sym_block] = STATE(3532),
    [sym__literal] = STATE(3532),
    [sym_string_literal] = STATE(3532),
    [sym_boolean_literal] = STATE(3532),
    [sym_raw_string_literal] = ACTIONS(7608),
    [sym_float_literal] = ACTIONS(7608),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(7608),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7608),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [3351] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6658),
    [anon_sym_macro_rules_BANG] = ACTIONS(6658),
    [anon_sym_RBRACE] = ACTIONS(6658),
    [anon_sym_POUND] = ACTIONS(6658),
    [anon_sym_const] = ACTIONS(6660),
    [anon_sym_default] = ACTIONS(6660),
    [anon_sym_enum] = ACTIONS(6660),
    [anon_sym_fn] = ACTIONS(6660),
    [anon_sym_impl] = ACTIONS(6660),
    [anon_sym_let] = ACTIONS(6660),
    [anon_sym_mod] = ACTIONS(6660),
    [anon_sym_pub] = ACTIONS(6660),
    [anon_sym_static] = ACTIONS(6660),
    [anon_sym_struct] = ACTIONS(6660),
    [anon_sym_trait] = ACTIONS(6660),
    [anon_sym_type] = ACTIONS(6660),
    [anon_sym_union] = ACTIONS(6660),
    [anon_sym_unsafe] = ACTIONS(6660),
    [anon_sym_use] = ACTIONS(6660),
    [anon_sym_extern] = ACTIONS(6660),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6660),
  },
  [3352] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7604),
    [anon_sym_PLUS] = ACTIONS(3279),
    [anon_sym_EQ] = ACTIONS(7610),
    [sym_line_comment] = ACTIONS(7),
  },
  [3353] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6664),
    [anon_sym_macro_rules_BANG] = ACTIONS(6664),
    [anon_sym_RBRACE] = ACTIONS(6664),
    [anon_sym_POUND] = ACTIONS(6664),
    [anon_sym_const] = ACTIONS(6666),
    [anon_sym_default] = ACTIONS(6666),
    [anon_sym_enum] = ACTIONS(6666),
    [anon_sym_fn] = ACTIONS(6666),
    [anon_sym_impl] = ACTIONS(6666),
    [anon_sym_let] = ACTIONS(6666),
    [anon_sym_mod] = ACTIONS(6666),
    [anon_sym_pub] = ACTIONS(6666),
    [anon_sym_static] = ACTIONS(6666),
    [anon_sym_struct] = ACTIONS(6666),
    [anon_sym_trait] = ACTIONS(6666),
    [anon_sym_type] = ACTIONS(6666),
    [anon_sym_union] = ACTIONS(6666),
    [anon_sym_unsafe] = ACTIONS(6666),
    [anon_sym_use] = ACTIONS(6666),
    [anon_sym_extern] = ACTIONS(6666),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6666),
  },
  [3354] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7612),
    [sym_line_comment] = ACTIONS(7),
  },
  [3355] = {
    [sym_where_clause] = STATE(3535),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7612),
    [anon_sym_where] = ACTIONS(2138),
    [sym_line_comment] = ACTIONS(7),
  },
  [3356] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6670),
    [anon_sym_macro_rules_BANG] = ACTIONS(6670),
    [anon_sym_RBRACE] = ACTIONS(6670),
    [anon_sym_POUND] = ACTIONS(6670),
    [anon_sym_const] = ACTIONS(6672),
    [anon_sym_default] = ACTIONS(6672),
    [anon_sym_enum] = ACTIONS(6672),
    [anon_sym_fn] = ACTIONS(6672),
    [anon_sym_impl] = ACTIONS(6672),
    [anon_sym_let] = ACTIONS(6672),
    [anon_sym_mod] = ACTIONS(6672),
    [anon_sym_pub] = ACTIONS(6672),
    [anon_sym_static] = ACTIONS(6672),
    [anon_sym_struct] = ACTIONS(6672),
    [anon_sym_trait] = ACTIONS(6672),
    [anon_sym_type] = ACTIONS(6672),
    [anon_sym_union] = ACTIONS(6672),
    [anon_sym_unsafe] = ACTIONS(6672),
    [anon_sym_use] = ACTIONS(6672),
    [anon_sym_extern] = ACTIONS(6672),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6672),
  },
  [3357] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6674),
    [anon_sym_macro_rules_BANG] = ACTIONS(6674),
    [anon_sym_RBRACE] = ACTIONS(6674),
    [anon_sym_POUND] = ACTIONS(6674),
    [anon_sym_const] = ACTIONS(6676),
    [anon_sym_default] = ACTIONS(6676),
    [anon_sym_enum] = ACTIONS(6676),
    [anon_sym_fn] = ACTIONS(6676),
    [anon_sym_impl] = ACTIONS(6676),
    [anon_sym_let] = ACTIONS(6676),
    [anon_sym_mod] = ACTIONS(6676),
    [anon_sym_pub] = ACTIONS(6676),
    [anon_sym_static] = ACTIONS(6676),
    [anon_sym_struct] = ACTIONS(6676),
    [anon_sym_trait] = ACTIONS(6676),
    [anon_sym_type] = ACTIONS(6676),
    [anon_sym_union] = ACTIONS(6676),
    [anon_sym_unsafe] = ACTIONS(6676),
    [anon_sym_use] = ACTIONS(6676),
    [anon_sym_extern] = ACTIONS(6676),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6676),
  },
  [3358] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7614),
    [anon_sym_PLUS] = ACTIONS(3423),
    [sym_line_comment] = ACTIONS(7),
  },
  [3359] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6680),
    [anon_sym_macro_rules_BANG] = ACTIONS(6680),
    [anon_sym_RBRACE] = ACTIONS(6680),
    [anon_sym_POUND] = ACTIONS(6680),
    [anon_sym_const] = ACTIONS(6682),
    [anon_sym_default] = ACTIONS(6682),
    [anon_sym_enum] = ACTIONS(6682),
    [anon_sym_fn] = ACTIONS(6682),
    [anon_sym_impl] = ACTIONS(6682),
    [anon_sym_let] = ACTIONS(6682),
    [anon_sym_mod] = ACTIONS(6682),
    [anon_sym_pub] = ACTIONS(6682),
    [anon_sym_static] = ACTIONS(6682),
    [anon_sym_struct] = ACTIONS(6682),
    [anon_sym_trait] = ACTIONS(6682),
    [anon_sym_type] = ACTIONS(6682),
    [anon_sym_union] = ACTIONS(6682),
    [anon_sym_unsafe] = ACTIONS(6682),
    [anon_sym_use] = ACTIONS(6682),
    [anon_sym_extern] = ACTIONS(6682),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6682),
  },
  [3360] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7616),
    [sym_line_comment] = ACTIONS(7),
  },
  [3361] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7618),
    [sym_line_comment] = ACTIONS(7),
  },
  [3362] = {
    [sym_where_clause] = STATE(3518),
    [sym_block] = STATE(3519),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7596),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_DASH_GT] = ACTIONS(7620),
    [anon_sym_where] = ACTIONS(1962),
    [sym_line_comment] = ACTIONS(7),
  },
  [3363] = {
    [sym_raw_string_literal] = ACTIONS(7622),
    [sym_float_literal] = ACTIONS(7622),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(7622),
    [anon_sym_SEMI] = ACTIONS(7622),
    [anon_sym_macro_rules_BANG] = ACTIONS(7622),
    [anon_sym_LPAREN] = ACTIONS(7622),
    [anon_sym_LBRACE] = ACTIONS(7622),
    [anon_sym_RBRACE] = ACTIONS(7622),
    [anon_sym_LBRACK] = ACTIONS(7622),
    [anon_sym_STAR] = ACTIONS(7622),
    [anon_sym_u8] = ACTIONS(7624),
    [anon_sym_i8] = ACTIONS(7624),
    [anon_sym_u16] = ACTIONS(7624),
    [anon_sym_i16] = ACTIONS(7624),
    [anon_sym_u32] = ACTIONS(7624),
    [anon_sym_i32] = ACTIONS(7624),
    [anon_sym_u64] = ACTIONS(7624),
    [anon_sym_i64] = ACTIONS(7624),
    [anon_sym_u128] = ACTIONS(7624),
    [anon_sym_i128] = ACTIONS(7624),
    [anon_sym_isize] = ACTIONS(7624),
    [anon_sym_usize] = ACTIONS(7624),
    [anon_sym_f32] = ACTIONS(7624),
    [anon_sym_f64] = ACTIONS(7624),
    [anon_sym_bool] = ACTIONS(7624),
    [anon_sym_str] = ACTIONS(7624),
    [anon_sym_char] = ACTIONS(7624),
    [anon_sym_AMP] = ACTIONS(7622),
    [anon_sym_DASH] = ACTIONS(7622),
    [anon_sym_COLON_COLON] = ACTIONS(7622),
    [anon_sym_BANG] = ACTIONS(7622),
    [anon_sym_POUND] = ACTIONS(7622),
    [anon_sym_LT] = ACTIONS(7622),
    [anon_sym_PIPE] = ACTIONS(7622),
    [anon_sym_SQUOTE] = ACTIONS(7624),
    [anon_sym_DOT_DOT] = ACTIONS(7622),
    [anon_sym_break] = ACTIONS(7624),
    [anon_sym_const] = ACTIONS(7624),
    [anon_sym_continue] = ACTIONS(7624),
    [anon_sym_default] = ACTIONS(7624),
    [anon_sym_enum] = ACTIONS(7624),
    [anon_sym_fn] = ACTIONS(7624),
    [anon_sym_for] = ACTIONS(7624),
    [anon_sym_if] = ACTIONS(7624),
    [anon_sym_impl] = ACTIONS(7624),
    [anon_sym_let] = ACTIONS(7624),
    [anon_sym_loop] = ACTIONS(7624),
    [anon_sym_match] = ACTIONS(7624),
    [anon_sym_mod] = ACTIONS(7624),
    [anon_sym_pub] = ACTIONS(7624),
    [anon_sym_return] = ACTIONS(7624),
    [anon_sym_static] = ACTIONS(7624),
    [anon_sym_struct] = ACTIONS(7624),
    [anon_sym_trait] = ACTIONS(7624),
    [anon_sym_type] = ACTIONS(7624),
    [anon_sym_union] = ACTIONS(7624),
    [anon_sym_unsafe] = ACTIONS(7624),
    [anon_sym_use] = ACTIONS(7624),
    [anon_sym_while] = ACTIONS(7624),
    [anon_sym_extern] = ACTIONS(7624),
    [anon_sym_move] = ACTIONS(7624),
    [sym_integer_literal] = ACTIONS(7622),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7622),
    [sym_char_literal] = ACTIONS(7622),
    [anon_sym_true] = ACTIONS(7624),
    [anon_sym_false] = ACTIONS(7624),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7624),
    [sym_self] = ACTIONS(7624),
    [sym_super] = ACTIONS(7624),
    [sym_crate] = ACTIONS(7624),
    [sym_metavariable] = ACTIONS(7622),
  },
  [3364] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7626),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(467),
    [anon_sym_BANG_EQ] = ACTIONS(469),
    [anon_sym_STAR_EQ] = ACTIONS(467),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(467),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_AMP_EQ] = ACTIONS(467),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(467),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_CARET_EQ] = ACTIONS(467),
    [anon_sym_PLUS_EQ] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT_LT_EQ] = ACTIONS(467),
    [anon_sym_LT_EQ] = ACTIONS(469),
    [anon_sym_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_EQ] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_PIPE_EQ] = ACTIONS(467),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(489),
    [anon_sym_as] = ACTIONS(491),
    [sym_line_comment] = ACTIONS(7),
  },
  [3365] = {
    [sym_raw_string_literal] = ACTIONS(7628),
    [sym_float_literal] = ACTIONS(7628),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(7628),
    [anon_sym_SEMI] = ACTIONS(7628),
    [anon_sym_macro_rules_BANG] = ACTIONS(7628),
    [anon_sym_LPAREN] = ACTIONS(7628),
    [anon_sym_LBRACE] = ACTIONS(7628),
    [anon_sym_RBRACE] = ACTIONS(7628),
    [anon_sym_LBRACK] = ACTIONS(7628),
    [anon_sym_STAR] = ACTIONS(7628),
    [anon_sym_u8] = ACTIONS(7630),
    [anon_sym_i8] = ACTIONS(7630),
    [anon_sym_u16] = ACTIONS(7630),
    [anon_sym_i16] = ACTIONS(7630),
    [anon_sym_u32] = ACTIONS(7630),
    [anon_sym_i32] = ACTIONS(7630),
    [anon_sym_u64] = ACTIONS(7630),
    [anon_sym_i64] = ACTIONS(7630),
    [anon_sym_u128] = ACTIONS(7630),
    [anon_sym_i128] = ACTIONS(7630),
    [anon_sym_isize] = ACTIONS(7630),
    [anon_sym_usize] = ACTIONS(7630),
    [anon_sym_f32] = ACTIONS(7630),
    [anon_sym_f64] = ACTIONS(7630),
    [anon_sym_bool] = ACTIONS(7630),
    [anon_sym_str] = ACTIONS(7630),
    [anon_sym_char] = ACTIONS(7630),
    [anon_sym_AMP] = ACTIONS(7628),
    [anon_sym_DASH] = ACTIONS(7628),
    [anon_sym_COLON_COLON] = ACTIONS(7628),
    [anon_sym_BANG] = ACTIONS(7628),
    [anon_sym_POUND] = ACTIONS(7628),
    [anon_sym_LT] = ACTIONS(7628),
    [anon_sym_PIPE] = ACTIONS(7628),
    [anon_sym_SQUOTE] = ACTIONS(7630),
    [anon_sym_DOT_DOT] = ACTIONS(7628),
    [anon_sym_break] = ACTIONS(7630),
    [anon_sym_const] = ACTIONS(7630),
    [anon_sym_continue] = ACTIONS(7630),
    [anon_sym_default] = ACTIONS(7630),
    [anon_sym_enum] = ACTIONS(7630),
    [anon_sym_fn] = ACTIONS(7630),
    [anon_sym_for] = ACTIONS(7630),
    [anon_sym_if] = ACTIONS(7630),
    [anon_sym_impl] = ACTIONS(7630),
    [anon_sym_let] = ACTIONS(7630),
    [anon_sym_loop] = ACTIONS(7630),
    [anon_sym_match] = ACTIONS(7630),
    [anon_sym_mod] = ACTIONS(7630),
    [anon_sym_pub] = ACTIONS(7630),
    [anon_sym_return] = ACTIONS(7630),
    [anon_sym_static] = ACTIONS(7630),
    [anon_sym_struct] = ACTIONS(7630),
    [anon_sym_trait] = ACTIONS(7630),
    [anon_sym_type] = ACTIONS(7630),
    [anon_sym_union] = ACTIONS(7630),
    [anon_sym_unsafe] = ACTIONS(7630),
    [anon_sym_use] = ACTIONS(7630),
    [anon_sym_while] = ACTIONS(7630),
    [anon_sym_extern] = ACTIONS(7630),
    [anon_sym_move] = ACTIONS(7630),
    [sym_integer_literal] = ACTIONS(7628),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7628),
    [sym_char_literal] = ACTIONS(7628),
    [anon_sym_true] = ACTIONS(7630),
    [anon_sym_false] = ACTIONS(7630),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7630),
    [sym_self] = ACTIONS(7630),
    [sym_super] = ACTIONS(7630),
    [sym_crate] = ACTIONS(7630),
    [sym_metavariable] = ACTIONS(7628),
  },
  [3366] = {
    [sym_where_clause] = STATE(3541),
    [sym_block] = STATE(3512),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7586),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_PLUS] = ACTIONS(5003),
    [anon_sym_where] = ACTIONS(1962),
    [sym_line_comment] = ACTIONS(7),
  },
  [3367] = {
    [sym_where_clause] = STATE(3541),
    [sym_block] = STATE(3512),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7586),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_where] = ACTIONS(1962),
    [sym_line_comment] = ACTIONS(7),
  },
  [3368] = {
    [sym_else_tail] = STATE(3089),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6158),
    [anon_sym_LBRACK] = ACTIONS(6158),
    [anon_sym_RBRACK] = ACTIONS(6158),
    [anon_sym_PLUS] = ACTIONS(6160),
    [anon_sym_STAR] = ACTIONS(6160),
    [anon_sym_AMP] = ACTIONS(6160),
    [anon_sym_DASH] = ACTIONS(6160),
    [anon_sym_DOT] = ACTIONS(6160),
    [anon_sym_DASH_EQ] = ACTIONS(6158),
    [anon_sym_BANG_EQ] = ACTIONS(6158),
    [anon_sym_STAR_EQ] = ACTIONS(6158),
    [anon_sym_SLASH] = ACTIONS(6160),
    [anon_sym_SLASH_EQ] = ACTIONS(6158),
    [anon_sym_AMP_AMP] = ACTIONS(6158),
    [anon_sym_AMP_EQ] = ACTIONS(6158),
    [anon_sym_PERCENT] = ACTIONS(6160),
    [anon_sym_PERCENT_EQ] = ACTIONS(6158),
    [anon_sym_CARET] = ACTIONS(6160),
    [anon_sym_CARET_EQ] = ACTIONS(6158),
    [anon_sym_PLUS_EQ] = ACTIONS(6158),
    [anon_sym_LT] = ACTIONS(6160),
    [anon_sym_LT_LT] = ACTIONS(6160),
    [anon_sym_LT_LT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_EQ] = ACTIONS(6160),
    [anon_sym_EQ_EQ] = ACTIONS(6158),
    [anon_sym_GT] = ACTIONS(6160),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_GT_GT] = ACTIONS(6160),
    [anon_sym_GT_GT_EQ] = ACTIONS(6158),
    [anon_sym_PIPE] = ACTIONS(6160),
    [anon_sym_PIPE_EQ] = ACTIONS(6158),
    [anon_sym_PIPE_PIPE] = ACTIONS(6158),
    [anon_sym_QMARK] = ACTIONS(6158),
    [anon_sym_DOT_DOT] = ACTIONS(6160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6158),
    [anon_sym_as] = ACTIONS(6158),
    [anon_sym_else] = ACTIONS(5724),
    [sym_line_comment] = ACTIONS(7),
  },
  [3369] = {
    [sym_function_modifiers] = STATE(1993),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3080),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(1994),
    [sym_array_type] = STATE(3080),
    [sym_function_type] = STATE(3080),
    [sym_tuple_type] = STATE(3080),
    [sym_unit_type] = STATE(3080),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(3080),
    [sym_reference_type] = STATE(3080),
    [sym_pointer_type] = STATE(3080),
    [sym_empty_type] = STATE(3080),
    [sym_abstract_type] = STATE(3081),
    [sym_dynamic_type] = STATE(3080),
    [sym_macro_invocation] = STATE(3080),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(1995),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(4413),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(4415),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4417),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4419),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [3370] = {
    [sym_function_modifiers] = STATE(1993),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3082),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(1994),
    [sym_array_type] = STATE(3082),
    [sym_function_type] = STATE(3082),
    [sym_tuple_type] = STATE(3082),
    [sym_unit_type] = STATE(3082),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(3082),
    [sym_reference_type] = STATE(3082),
    [sym_pointer_type] = STATE(3082),
    [sym_empty_type] = STATE(3082),
    [sym_abstract_type] = STATE(3083),
    [sym_dynamic_type] = STATE(3082),
    [sym_macro_invocation] = STATE(3082),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(1995),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(4413),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(4415),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4417),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4419),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [3371] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6805),
    [anon_sym_LPAREN] = ACTIONS(6805),
    [anon_sym_RPAREN] = ACTIONS(6805),
    [anon_sym_LBRACE] = ACTIONS(6805),
    [anon_sym_RBRACE] = ACTIONS(6805),
    [anon_sym_LBRACK] = ACTIONS(6805),
    [anon_sym_RBRACK] = ACTIONS(6805),
    [anon_sym_PLUS] = ACTIONS(7632),
    [anon_sym_STAR] = ACTIONS(7632),
    [anon_sym_COMMA] = ACTIONS(6805),
    [anon_sym_AMP] = ACTIONS(7632),
    [anon_sym_DASH] = ACTIONS(7632),
    [anon_sym_DOT] = ACTIONS(7632),
    [anon_sym_DASH_EQ] = ACTIONS(6805),
    [anon_sym_DASH_GT] = ACTIONS(6805),
    [anon_sym_BANG_EQ] = ACTIONS(6805),
    [anon_sym_STAR_EQ] = ACTIONS(6805),
    [anon_sym_SLASH] = ACTIONS(7632),
    [anon_sym_SLASH_EQ] = ACTIONS(6805),
    [anon_sym_AMP_AMP] = ACTIONS(6805),
    [anon_sym_AMP_EQ] = ACTIONS(6805),
    [anon_sym_PERCENT] = ACTIONS(7632),
    [anon_sym_PERCENT_EQ] = ACTIONS(6805),
    [anon_sym_CARET] = ACTIONS(7632),
    [anon_sym_CARET_EQ] = ACTIONS(6805),
    [anon_sym_PLUS_EQ] = ACTIONS(6805),
    [anon_sym_LT] = ACTIONS(7632),
    [anon_sym_LT_LT] = ACTIONS(7632),
    [anon_sym_LT_LT_EQ] = ACTIONS(6805),
    [anon_sym_LT_EQ] = ACTIONS(6805),
    [anon_sym_EQ] = ACTIONS(7632),
    [anon_sym_EQ_EQ] = ACTIONS(6805),
    [anon_sym_GT] = ACTIONS(7632),
    [anon_sym_GT_EQ] = ACTIONS(6805),
    [anon_sym_GT_GT] = ACTIONS(7632),
    [anon_sym_GT_GT_EQ] = ACTIONS(6805),
    [anon_sym_PIPE] = ACTIONS(7632),
    [anon_sym_PIPE_EQ] = ACTIONS(6805),
    [anon_sym_PIPE_PIPE] = ACTIONS(6805),
    [anon_sym_QMARK] = ACTIONS(6805),
    [anon_sym_DOT_DOT] = ACTIONS(7632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6805),
    [anon_sym_as] = ACTIONS(6805),
    [sym_line_comment] = ACTIONS(7),
  },
  [3372] = {
    [sym_raw_string_literal] = ACTIONS(7634),
    [sym_float_literal] = ACTIONS(7634),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(7634),
    [anon_sym_SEMI] = ACTIONS(7634),
    [anon_sym_macro_rules_BANG] = ACTIONS(7634),
    [anon_sym_LPAREN] = ACTIONS(7634),
    [anon_sym_LBRACE] = ACTIONS(7634),
    [anon_sym_RBRACE] = ACTIONS(7634),
    [anon_sym_LBRACK] = ACTIONS(7634),
    [anon_sym_PLUS] = ACTIONS(7636),
    [anon_sym_STAR] = ACTIONS(7636),
    [anon_sym_u8] = ACTIONS(7636),
    [anon_sym_i8] = ACTIONS(7636),
    [anon_sym_u16] = ACTIONS(7636),
    [anon_sym_i16] = ACTIONS(7636),
    [anon_sym_u32] = ACTIONS(7636),
    [anon_sym_i32] = ACTIONS(7636),
    [anon_sym_u64] = ACTIONS(7636),
    [anon_sym_i64] = ACTIONS(7636),
    [anon_sym_u128] = ACTIONS(7636),
    [anon_sym_i128] = ACTIONS(7636),
    [anon_sym_isize] = ACTIONS(7636),
    [anon_sym_usize] = ACTIONS(7636),
    [anon_sym_f32] = ACTIONS(7636),
    [anon_sym_f64] = ACTIONS(7636),
    [anon_sym_bool] = ACTIONS(7636),
    [anon_sym_str] = ACTIONS(7636),
    [anon_sym_char] = ACTIONS(7636),
    [anon_sym_AMP] = ACTIONS(7636),
    [anon_sym_DASH] = ACTIONS(7636),
    [anon_sym_DOT] = ACTIONS(7636),
    [anon_sym_DASH_EQ] = ACTIONS(7634),
    [anon_sym_COLON_COLON] = ACTIONS(7634),
    [anon_sym_BANG] = ACTIONS(7636),
    [anon_sym_BANG_EQ] = ACTIONS(7634),
    [anon_sym_STAR_EQ] = ACTIONS(7634),
    [anon_sym_SLASH] = ACTIONS(7636),
    [anon_sym_SLASH_EQ] = ACTIONS(7634),
    [anon_sym_AMP_AMP] = ACTIONS(7634),
    [anon_sym_AMP_EQ] = ACTIONS(7634),
    [anon_sym_POUND] = ACTIONS(7634),
    [anon_sym_PERCENT] = ACTIONS(7636),
    [anon_sym_PERCENT_EQ] = ACTIONS(7634),
    [anon_sym_CARET] = ACTIONS(7636),
    [anon_sym_CARET_EQ] = ACTIONS(7634),
    [anon_sym_PLUS_EQ] = ACTIONS(7634),
    [anon_sym_LT] = ACTIONS(7636),
    [anon_sym_LT_LT] = ACTIONS(7636),
    [anon_sym_LT_LT_EQ] = ACTIONS(7634),
    [anon_sym_LT_EQ] = ACTIONS(7634),
    [anon_sym_EQ] = ACTIONS(7636),
    [anon_sym_EQ_EQ] = ACTIONS(7634),
    [anon_sym_GT] = ACTIONS(7636),
    [anon_sym_GT_EQ] = ACTIONS(7634),
    [anon_sym_GT_GT] = ACTIONS(7636),
    [anon_sym_GT_GT_EQ] = ACTIONS(7634),
    [anon_sym_PIPE] = ACTIONS(7636),
    [anon_sym_PIPE_EQ] = ACTIONS(7634),
    [anon_sym_PIPE_PIPE] = ACTIONS(7634),
    [anon_sym_QMARK] = ACTIONS(7634),
    [anon_sym_SQUOTE] = ACTIONS(7636),
    [anon_sym_DOT_DOT] = ACTIONS(7636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7634),
    [anon_sym_as] = ACTIONS(7636),
    [anon_sym_break] = ACTIONS(7636),
    [anon_sym_const] = ACTIONS(7636),
    [anon_sym_continue] = ACTIONS(7636),
    [anon_sym_default] = ACTIONS(7636),
    [anon_sym_enum] = ACTIONS(7636),
    [anon_sym_fn] = ACTIONS(7636),
    [anon_sym_for] = ACTIONS(7636),
    [anon_sym_if] = ACTIONS(7636),
    [anon_sym_impl] = ACTIONS(7636),
    [anon_sym_let] = ACTIONS(7636),
    [anon_sym_loop] = ACTIONS(7636),
    [anon_sym_match] = ACTIONS(7636),
    [anon_sym_mod] = ACTIONS(7636),
    [anon_sym_pub] = ACTIONS(7636),
    [anon_sym_return] = ACTIONS(7636),
    [anon_sym_static] = ACTIONS(7636),
    [anon_sym_struct] = ACTIONS(7636),
    [anon_sym_trait] = ACTIONS(7636),
    [anon_sym_type] = ACTIONS(7636),
    [anon_sym_union] = ACTIONS(7636),
    [anon_sym_unsafe] = ACTIONS(7636),
    [anon_sym_use] = ACTIONS(7636),
    [anon_sym_while] = ACTIONS(7636),
    [anon_sym_extern] = ACTIONS(7636),
    [anon_sym_move] = ACTIONS(7636),
    [sym_integer_literal] = ACTIONS(7634),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7634),
    [sym_char_literal] = ACTIONS(7634),
    [anon_sym_true] = ACTIONS(7636),
    [anon_sym_false] = ACTIONS(7636),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7636),
    [sym_self] = ACTIONS(7636),
    [sym_super] = ACTIONS(7636),
    [sym_crate] = ACTIONS(7636),
    [sym_metavariable] = ACTIONS(7634),
  },
  [3373] = {
    [sym_raw_string_literal] = ACTIONS(7638),
    [sym_float_literal] = ACTIONS(7638),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7638),
    [anon_sym_LPAREN] = ACTIONS(7638),
    [anon_sym_RPAREN] = ACTIONS(7638),
    [anon_sym_LBRACE] = ACTIONS(7638),
    [anon_sym_RBRACE] = ACTIONS(7638),
    [anon_sym_EQ_GT] = ACTIONS(7638),
    [anon_sym_LBRACK] = ACTIONS(7638),
    [anon_sym_RBRACK] = ACTIONS(7638),
    [anon_sym_COLON] = ACTIONS(7640),
    [anon_sym_DOLLAR] = ACTIONS(7640),
    [anon_sym_PLUS] = ACTIONS(7640),
    [anon_sym_STAR] = ACTIONS(7640),
    [anon_sym_COMMA] = ACTIONS(7638),
    [anon_sym_u8] = ACTIONS(7640),
    [anon_sym_i8] = ACTIONS(7640),
    [anon_sym_u16] = ACTIONS(7640),
    [anon_sym_i16] = ACTIONS(7640),
    [anon_sym_u32] = ACTIONS(7640),
    [anon_sym_i32] = ACTIONS(7640),
    [anon_sym_u64] = ACTIONS(7640),
    [anon_sym_i64] = ACTIONS(7640),
    [anon_sym_u128] = ACTIONS(7640),
    [anon_sym_i128] = ACTIONS(7640),
    [anon_sym_isize] = ACTIONS(7640),
    [anon_sym_usize] = ACTIONS(7640),
    [anon_sym_f32] = ACTIONS(7640),
    [anon_sym_f64] = ACTIONS(7640),
    [anon_sym_bool] = ACTIONS(7640),
    [anon_sym_str] = ACTIONS(7640),
    [anon_sym_char] = ACTIONS(7640),
    [anon_sym__] = ACTIONS(7640),
    [anon_sym_AMP] = ACTIONS(7640),
    [anon_sym_DASH] = ACTIONS(7640),
    [anon_sym_DOT] = ACTIONS(7640),
    [anon_sym_DASH_EQ] = ACTIONS(7638),
    [anon_sym_DASH_GT] = ACTIONS(7638),
    [anon_sym_COLON_COLON] = ACTIONS(7638),
    [anon_sym_BANG] = ACTIONS(7640),
    [anon_sym_BANG_EQ] = ACTIONS(7638),
    [anon_sym_AT] = ACTIONS(7638),
    [anon_sym_STAR_EQ] = ACTIONS(7638),
    [anon_sym_SLASH] = ACTIONS(7640),
    [anon_sym_SLASH_EQ] = ACTIONS(7638),
    [anon_sym_AMP_AMP] = ACTIONS(7638),
    [anon_sym_AMP_EQ] = ACTIONS(7638),
    [anon_sym_POUND] = ACTIONS(7638),
    [anon_sym_PERCENT] = ACTIONS(7640),
    [anon_sym_PERCENT_EQ] = ACTIONS(7638),
    [anon_sym_CARET] = ACTIONS(7640),
    [anon_sym_CARET_EQ] = ACTIONS(7638),
    [anon_sym_PLUS_EQ] = ACTIONS(7638),
    [anon_sym_LT] = ACTIONS(7640),
    [anon_sym_LT_LT] = ACTIONS(7640),
    [anon_sym_LT_LT_EQ] = ACTIONS(7638),
    [anon_sym_LT_EQ] = ACTIONS(7638),
    [anon_sym_EQ] = ACTIONS(7640),
    [anon_sym_EQ_EQ] = ACTIONS(7638),
    [anon_sym_GT] = ACTIONS(7640),
    [anon_sym_GT_EQ] = ACTIONS(7638),
    [anon_sym_GT_GT] = ACTIONS(7640),
    [anon_sym_GT_GT_EQ] = ACTIONS(7638),
    [anon_sym_PIPE] = ACTIONS(7640),
    [anon_sym_PIPE_EQ] = ACTIONS(7638),
    [anon_sym_PIPE_PIPE] = ACTIONS(7638),
    [anon_sym_TILDE] = ACTIONS(7638),
    [anon_sym_QMARK] = ACTIONS(7638),
    [anon_sym_SQUOTE] = ACTIONS(7640),
    [anon_sym_DOT_DOT] = ACTIONS(7640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7638),
    [anon_sym_as] = ACTIONS(7640),
    [anon_sym_break] = ACTIONS(7640),
    [anon_sym_const] = ACTIONS(7640),
    [anon_sym_continue] = ACTIONS(7640),
    [anon_sym_default] = ACTIONS(7640),
    [anon_sym_enum] = ACTIONS(7640),
    [anon_sym_fn] = ACTIONS(7640),
    [anon_sym_for] = ACTIONS(7640),
    [anon_sym_if] = ACTIONS(7640),
    [anon_sym_impl] = ACTIONS(7640),
    [anon_sym_let] = ACTIONS(7640),
    [anon_sym_loop] = ACTIONS(7640),
    [anon_sym_match] = ACTIONS(7640),
    [anon_sym_mod] = ACTIONS(7640),
    [anon_sym_pub] = ACTIONS(7640),
    [anon_sym_return] = ACTIONS(7640),
    [anon_sym_static] = ACTIONS(7640),
    [anon_sym_struct] = ACTIONS(7640),
    [anon_sym_trait] = ACTIONS(7640),
    [anon_sym_type] = ACTIONS(7640),
    [anon_sym_union] = ACTIONS(7640),
    [anon_sym_unsafe] = ACTIONS(7640),
    [anon_sym_use] = ACTIONS(7640),
    [anon_sym_where] = ACTIONS(7640),
    [anon_sym_while] = ACTIONS(7640),
    [sym_mutable_specifier] = ACTIONS(7640),
    [sym_integer_literal] = ACTIONS(7638),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7638),
    [sym_char_literal] = ACTIONS(7638),
    [anon_sym_true] = ACTIONS(7640),
    [anon_sym_false] = ACTIONS(7640),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7640),
    [sym_self] = ACTIONS(7640),
    [sym_super] = ACTIONS(7640),
    [sym_crate] = ACTIONS(7640),
    [sym_metavariable] = ACTIONS(7638),
  },
  [3374] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(7642),
    [anon_sym_STAR] = ACTIONS(7642),
    [sym_line_comment] = ACTIONS(7),
  },
  [3375] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3543),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(3543),
    [sym_macro_invocation] = STATE(3543),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3543),
    [sym_unary_expression] = STATE(3543),
    [sym_try_expression] = STATE(3543),
    [sym_reference_expression] = STATE(3543),
    [sym_binary_expression] = STATE(3543),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3543),
    [sym_call_expression] = STATE(3543),
    [sym_array_expression] = STATE(3543),
    [sym_parenthesized_expression] = STATE(3543),
    [sym_tuple_expression] = STATE(3543),
    [sym_unit_expression] = STATE(3543),
    [sym_struct_expression] = STATE(3543),
    [sym_if_expression] = STATE(3543),
    [sym_if_let_expression] = STATE(3543),
    [sym_match_expression] = STATE(3543),
    [sym_while_expression] = STATE(3543),
    [sym_while_let_expression] = STATE(3543),
    [sym_loop_expression] = STATE(3543),
    [sym_for_expression] = STATE(3543),
    [sym_closure_expression] = STATE(3543),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3543),
    [sym_continue_expression] = STATE(3543),
    [sym_index_expression] = STATE(3543),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3543),
    [sym_block] = STATE(3543),
    [sym__literal] = STATE(3543),
    [sym_string_literal] = STATE(3543),
    [sym_boolean_literal] = STATE(3543),
    [sym_raw_string_literal] = ACTIONS(7644),
    [sym_float_literal] = ACTIONS(7644),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(7644),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7644),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [3376] = {
    [sym_if_expression] = STATE(2043),
    [sym_if_let_expression] = STATE(2043),
    [sym_block] = STATE(2043),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_if] = ACTIONS(7646),
    [sym_line_comment] = ACTIONS(7),
  },
  [3377] = {
    [sym_function_modifiers] = STATE(3109),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2001),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(3110),
    [sym_array_type] = STATE(2001),
    [sym_function_type] = STATE(2001),
    [sym_tuple_type] = STATE(2001),
    [sym_unit_type] = STATE(2001),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2001),
    [sym_reference_type] = STATE(2001),
    [sym_pointer_type] = STATE(2001),
    [sym_empty_type] = STATE(2001),
    [sym_dynamic_type] = STATE(2001),
    [sym_macro_invocation] = STATE(2001),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(3111),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(6776),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(6778),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6780),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6782),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [3378] = {
    [sym_function_modifiers] = STATE(3109),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2003),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(3110),
    [sym_array_type] = STATE(2003),
    [sym_function_type] = STATE(2003),
    [sym_tuple_type] = STATE(2003),
    [sym_unit_type] = STATE(2003),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2003),
    [sym_reference_type] = STATE(2003),
    [sym_pointer_type] = STATE(2003),
    [sym_empty_type] = STATE(2003),
    [sym_dynamic_type] = STATE(2003),
    [sym_macro_invocation] = STATE(2003),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(3111),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(6776),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(6778),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6780),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6782),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [3379] = {
    [sym_function_modifiers] = STATE(3109),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2003),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(3110),
    [sym_array_type] = STATE(2003),
    [sym_function_type] = STATE(2003),
    [sym_tuple_type] = STATE(2003),
    [sym_unit_type] = STATE(2003),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2003),
    [sym_reference_type] = STATE(2003),
    [sym_pointer_type] = STATE(2003),
    [sym_empty_type] = STATE(2003),
    [sym_dynamic_type] = STATE(2003),
    [sym_macro_invocation] = STATE(2003),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(3111),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_PLUS] = ACTIONS(7342),
    [anon_sym_STAR] = ACTIONS(6776),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(6778),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6780),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_mutable_specifier] = ACTIONS(7648),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6782),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [3380] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1760),
    [anon_sym_LBRACK] = ACTIONS(1760),
    [anon_sym_PLUS] = ACTIONS(4443),
    [anon_sym_STAR] = ACTIONS(4443),
    [anon_sym_COMMA] = ACTIONS(1760),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_DASH] = ACTIONS(4443),
    [anon_sym_DOT] = ACTIONS(4443),
    [anon_sym_DASH_EQ] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(7650),
    [anon_sym_BANG_EQ] = ACTIONS(1760),
    [anon_sym_STAR_EQ] = ACTIONS(1760),
    [anon_sym_SLASH] = ACTIONS(4443),
    [anon_sym_SLASH_EQ] = ACTIONS(1760),
    [anon_sym_AMP_AMP] = ACTIONS(1760),
    [anon_sym_AMP_EQ] = ACTIONS(1760),
    [anon_sym_PERCENT] = ACTIONS(4443),
    [anon_sym_PERCENT_EQ] = ACTIONS(1760),
    [anon_sym_CARET] = ACTIONS(4443),
    [anon_sym_CARET_EQ] = ACTIONS(1760),
    [anon_sym_PLUS_EQ] = ACTIONS(1760),
    [anon_sym_LT] = ACTIONS(4443),
    [anon_sym_LT_LT] = ACTIONS(4443),
    [anon_sym_LT_LT_EQ] = ACTIONS(1760),
    [anon_sym_LT_EQ] = ACTIONS(1760),
    [anon_sym_EQ] = ACTIONS(4443),
    [anon_sym_EQ_EQ] = ACTIONS(1760),
    [anon_sym_GT] = ACTIONS(4443),
    [anon_sym_GT_EQ] = ACTIONS(1760),
    [anon_sym_GT_GT] = ACTIONS(4443),
    [anon_sym_GT_GT_EQ] = ACTIONS(1760),
    [anon_sym_PIPE] = ACTIONS(4443),
    [anon_sym_PIPE_EQ] = ACTIONS(1760),
    [anon_sym_PIPE_PIPE] = ACTIONS(1760),
    [anon_sym_QMARK] = ACTIONS(1760),
    [anon_sym_DOT_DOT] = ACTIONS(4443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1760),
    [anon_sym_as] = ACTIONS(1760),
    [sym_line_comment] = ACTIONS(7),
  },
  [3381] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1794),
    [anon_sym_LBRACK] = ACTIONS(1794),
    [anon_sym_PLUS] = ACTIONS(4449),
    [anon_sym_STAR] = ACTIONS(4449),
    [anon_sym_COMMA] = ACTIONS(1794),
    [anon_sym_AMP] = ACTIONS(4449),
    [anon_sym_DASH] = ACTIONS(4449),
    [anon_sym_DOT] = ACTIONS(4449),
    [anon_sym_DASH_EQ] = ACTIONS(1794),
    [anon_sym_DASH_GT] = ACTIONS(7652),
    [anon_sym_BANG_EQ] = ACTIONS(1794),
    [anon_sym_STAR_EQ] = ACTIONS(1794),
    [anon_sym_SLASH] = ACTIONS(4449),
    [anon_sym_SLASH_EQ] = ACTIONS(1794),
    [anon_sym_AMP_AMP] = ACTIONS(1794),
    [anon_sym_AMP_EQ] = ACTIONS(1794),
    [anon_sym_PERCENT] = ACTIONS(4449),
    [anon_sym_PERCENT_EQ] = ACTIONS(1794),
    [anon_sym_CARET] = ACTIONS(4449),
    [anon_sym_CARET_EQ] = ACTIONS(1794),
    [anon_sym_PLUS_EQ] = ACTIONS(1794),
    [anon_sym_LT] = ACTIONS(4449),
    [anon_sym_LT_LT] = ACTIONS(4449),
    [anon_sym_LT_LT_EQ] = ACTIONS(1794),
    [anon_sym_LT_EQ] = ACTIONS(1794),
    [anon_sym_EQ] = ACTIONS(4449),
    [anon_sym_EQ_EQ] = ACTIONS(1794),
    [anon_sym_GT] = ACTIONS(4449),
    [anon_sym_GT_EQ] = ACTIONS(1794),
    [anon_sym_GT_GT] = ACTIONS(4449),
    [anon_sym_GT_GT_EQ] = ACTIONS(1794),
    [anon_sym_PIPE] = ACTIONS(4449),
    [anon_sym_PIPE_EQ] = ACTIONS(1794),
    [anon_sym_PIPE_PIPE] = ACTIONS(1794),
    [anon_sym_QMARK] = ACTIONS(1794),
    [anon_sym_DOT_DOT] = ACTIONS(4449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1794),
    [anon_sym_as] = ACTIONS(1794),
    [sym_line_comment] = ACTIONS(7),
  },
  [3382] = {
    [sym_parameters] = STATE(3547),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [sym_line_comment] = ACTIONS(7),
  },
  [3383] = {
    [sym_parameters] = STATE(3548),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [3384] = {
    [sym_parameters] = STATE(3547),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [3385] = {
    [sym_function_modifiers] = STATE(3109),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2016),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(2016),
    [sym_array_type] = STATE(2016),
    [sym_function_type] = STATE(2016),
    [sym_tuple_type] = STATE(2016),
    [sym_unit_type] = STATE(2016),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2016),
    [sym_reference_type] = STATE(2016),
    [sym_pointer_type] = STATE(2016),
    [sym_empty_type] = STATE(2016),
    [sym_dynamic_type] = STATE(2016),
    [sym_macro_invocation] = STATE(2016),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(3111),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(6776),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(6778),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(4453),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6780),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6782),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [3386] = {
    [sym_function_modifiers] = STATE(3109),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2016),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(3110),
    [sym_array_type] = STATE(2016),
    [sym_function_type] = STATE(2016),
    [sym_tuple_type] = STATE(2016),
    [sym_unit_type] = STATE(2016),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2016),
    [sym_reference_type] = STATE(2016),
    [sym_pointer_type] = STATE(2016),
    [sym_empty_type] = STATE(2016),
    [sym_dynamic_type] = STATE(2016),
    [sym_macro_invocation] = STATE(2016),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(3111),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(6776),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(6778),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6780),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6782),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [3387] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7634),
    [anon_sym_LPAREN] = ACTIONS(7634),
    [anon_sym_RPAREN] = ACTIONS(7634),
    [anon_sym_LBRACE] = ACTIONS(7634),
    [anon_sym_RBRACE] = ACTIONS(7634),
    [anon_sym_LBRACK] = ACTIONS(7634),
    [anon_sym_RBRACK] = ACTIONS(7634),
    [anon_sym_PLUS] = ACTIONS(7636),
    [anon_sym_STAR] = ACTIONS(7636),
    [anon_sym_COMMA] = ACTIONS(7634),
    [anon_sym_AMP] = ACTIONS(7636),
    [anon_sym_DASH] = ACTIONS(7636),
    [anon_sym_DOT] = ACTIONS(7636),
    [anon_sym_DASH_EQ] = ACTIONS(7634),
    [anon_sym_BANG_EQ] = ACTIONS(7634),
    [anon_sym_STAR_EQ] = ACTIONS(7634),
    [anon_sym_SLASH] = ACTIONS(7636),
    [anon_sym_SLASH_EQ] = ACTIONS(7634),
    [anon_sym_AMP_AMP] = ACTIONS(7634),
    [anon_sym_AMP_EQ] = ACTIONS(7634),
    [anon_sym_PERCENT] = ACTIONS(7636),
    [anon_sym_PERCENT_EQ] = ACTIONS(7634),
    [anon_sym_CARET] = ACTIONS(7636),
    [anon_sym_CARET_EQ] = ACTIONS(7634),
    [anon_sym_PLUS_EQ] = ACTIONS(7634),
    [anon_sym_LT] = ACTIONS(7636),
    [anon_sym_LT_LT] = ACTIONS(7636),
    [anon_sym_LT_LT_EQ] = ACTIONS(7634),
    [anon_sym_LT_EQ] = ACTIONS(7634),
    [anon_sym_EQ] = ACTIONS(7636),
    [anon_sym_EQ_EQ] = ACTIONS(7634),
    [anon_sym_GT] = ACTIONS(7636),
    [anon_sym_GT_EQ] = ACTIONS(7634),
    [anon_sym_GT_GT] = ACTIONS(7636),
    [anon_sym_GT_GT_EQ] = ACTIONS(7634),
    [anon_sym_PIPE] = ACTIONS(7636),
    [anon_sym_PIPE_EQ] = ACTIONS(7634),
    [anon_sym_PIPE_PIPE] = ACTIONS(7634),
    [anon_sym_QMARK] = ACTIONS(7634),
    [anon_sym_DOT_DOT] = ACTIONS(7636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7634),
    [anon_sym_as] = ACTIONS(7634),
    [sym_line_comment] = ACTIONS(7),
  },
  [3388] = {
    [sym_else_tail] = STATE(3089),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6158),
    [anon_sym_LBRACK] = ACTIONS(6158),
    [anon_sym_RBRACK] = ACTIONS(6158),
    [anon_sym_PLUS] = ACTIONS(6160),
    [anon_sym_STAR] = ACTIONS(6160),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_AMP] = ACTIONS(6160),
    [anon_sym_DASH] = ACTIONS(6160),
    [anon_sym_DOT] = ACTIONS(6160),
    [anon_sym_DASH_EQ] = ACTIONS(6158),
    [anon_sym_BANG_EQ] = ACTIONS(6158),
    [anon_sym_STAR_EQ] = ACTIONS(6158),
    [anon_sym_SLASH] = ACTIONS(6160),
    [anon_sym_SLASH_EQ] = ACTIONS(6158),
    [anon_sym_AMP_AMP] = ACTIONS(6158),
    [anon_sym_AMP_EQ] = ACTIONS(6158),
    [anon_sym_PERCENT] = ACTIONS(6160),
    [anon_sym_PERCENT_EQ] = ACTIONS(6158),
    [anon_sym_CARET] = ACTIONS(6160),
    [anon_sym_CARET_EQ] = ACTIONS(6158),
    [anon_sym_PLUS_EQ] = ACTIONS(6158),
    [anon_sym_LT] = ACTIONS(6160),
    [anon_sym_LT_LT] = ACTIONS(6160),
    [anon_sym_LT_LT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_EQ] = ACTIONS(6160),
    [anon_sym_EQ_EQ] = ACTIONS(6158),
    [anon_sym_GT] = ACTIONS(6160),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_GT_GT] = ACTIONS(6160),
    [anon_sym_GT_GT_EQ] = ACTIONS(6158),
    [anon_sym_PIPE] = ACTIONS(6160),
    [anon_sym_PIPE_EQ] = ACTIONS(6158),
    [anon_sym_PIPE_PIPE] = ACTIONS(6158),
    [anon_sym_QMARK] = ACTIONS(6158),
    [anon_sym_DOT_DOT] = ACTIONS(6160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6158),
    [anon_sym_as] = ACTIONS(6158),
    [anon_sym_else] = ACTIONS(5936),
    [sym_line_comment] = ACTIONS(7),
  },
  [3389] = {
    [sym_function_modifiers] = STATE(2098),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3080),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(2099),
    [sym_array_type] = STATE(3080),
    [sym_function_type] = STATE(3080),
    [sym_tuple_type] = STATE(3080),
    [sym_unit_type] = STATE(3080),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(3080),
    [sym_reference_type] = STATE(3080),
    [sym_pointer_type] = STATE(3080),
    [sym_empty_type] = STATE(3080),
    [sym_abstract_type] = STATE(3081),
    [sym_dynamic_type] = STATE(3080),
    [sym_macro_invocation] = STATE(3080),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(2100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(4717),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(4719),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4721),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4723),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [3390] = {
    [sym_function_modifiers] = STATE(2098),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3082),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(2099),
    [sym_array_type] = STATE(3082),
    [sym_function_type] = STATE(3082),
    [sym_tuple_type] = STATE(3082),
    [sym_unit_type] = STATE(3082),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(3082),
    [sym_reference_type] = STATE(3082),
    [sym_pointer_type] = STATE(3082),
    [sym_empty_type] = STATE(3082),
    [sym_abstract_type] = STATE(3083),
    [sym_dynamic_type] = STATE(3082),
    [sym_macro_invocation] = STATE(3082),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(2100),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(4717),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(4719),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4721),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4723),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [3391] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7127),
    [anon_sym_macro_rules_BANG] = ACTIONS(7127),
    [anon_sym_RBRACE] = ACTIONS(7127),
    [anon_sym_COMMA] = ACTIONS(7127),
    [anon_sym_POUND] = ACTIONS(7127),
    [anon_sym_EQ] = ACTIONS(7127),
    [anon_sym_const] = ACTIONS(7129),
    [anon_sym_default] = ACTIONS(7129),
    [anon_sym_enum] = ACTIONS(7129),
    [anon_sym_fn] = ACTIONS(7129),
    [anon_sym_impl] = ACTIONS(7129),
    [anon_sym_let] = ACTIONS(7129),
    [anon_sym_mod] = ACTIONS(7129),
    [anon_sym_pub] = ACTIONS(7129),
    [anon_sym_static] = ACTIONS(7129),
    [anon_sym_struct] = ACTIONS(7129),
    [anon_sym_trait] = ACTIONS(7129),
    [anon_sym_type] = ACTIONS(7129),
    [anon_sym_union] = ACTIONS(7129),
    [anon_sym_unsafe] = ACTIONS(7129),
    [anon_sym_use] = ACTIONS(7129),
    [anon_sym_extern] = ACTIONS(7129),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7129),
  },
  [3392] = {
    [sym_attribute_item] = STATE(2391),
    [sym_field_declaration] = STATE(2390),
    [sym_visibility_modifier] = STATE(1069),
    [aux_sym_enum_variant_list_repeat1] = STATE(2391),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7654),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_pub] = ACTIONS(1940),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2132),
  },
  [3393] = {
    [sym_function_modifiers] = STATE(2233),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2156),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2744),
    [sym_array_type] = STATE(2156),
    [sym_function_type] = STATE(2156),
    [sym_tuple_type] = STATE(2156),
    [sym_unit_type] = STATE(2156),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2156),
    [sym_reference_type] = STATE(2156),
    [sym_pointer_type] = STATE(2156),
    [sym_empty_type] = STATE(2156),
    [sym_abstract_type] = STATE(2157),
    [sym_dynamic_type] = STATE(2156),
    [sym_macro_invocation] = STATE(2156),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2236),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(4957),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(4959),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4963),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4967),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3394] = {
    [sym_function_modifiers] = STATE(2233),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2158),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2744),
    [sym_array_type] = STATE(2158),
    [sym_function_type] = STATE(2158),
    [sym_tuple_type] = STATE(2158),
    [sym_unit_type] = STATE(2158),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2158),
    [sym_reference_type] = STATE(2158),
    [sym_pointer_type] = STATE(2158),
    [sym_empty_type] = STATE(2158),
    [sym_abstract_type] = STATE(2159),
    [sym_dynamic_type] = STATE(2158),
    [sym_macro_invocation] = STATE(2158),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2236),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(4957),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(4959),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(4963),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4967),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3395] = {
    [sym_function_modifiers] = STATE(2770),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(862),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2773),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(6144),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(6146),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6150),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6154),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3396] = {
    [sym_function_modifiers] = STATE(2770),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(3151),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2773),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(6144),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(6146),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6150),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6154),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3397] = {
    [sym_function_modifiers] = STATE(2770),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1479),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(3151),
    [sym_array_type] = STATE(1479),
    [sym_function_type] = STATE(1479),
    [sym_tuple_type] = STATE(1479),
    [sym_unit_type] = STATE(1479),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1479),
    [sym_reference_type] = STATE(1479),
    [sym_pointer_type] = STATE(1479),
    [sym_empty_type] = STATE(1479),
    [sym_dynamic_type] = STATE(1479),
    [sym_macro_invocation] = STATE(1479),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2773),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(6144),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(6146),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6150),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6154),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3398] = {
    [sym_function_modifiers] = STATE(2770),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1499),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(3151),
    [sym_array_type] = STATE(1499),
    [sym_function_type] = STATE(1499),
    [sym_tuple_type] = STATE(1499),
    [sym_unit_type] = STATE(1499),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1499),
    [sym_reference_type] = STATE(1499),
    [sym_pointer_type] = STATE(1499),
    [sym_empty_type] = STATE(1499),
    [sym_abstract_type] = STATE(1500),
    [sym_dynamic_type] = STATE(1499),
    [sym_macro_invocation] = STATE(1499),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2773),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(6144),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(6146),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6150),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6154),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3399] = {
    [sym_function_modifiers] = STATE(2770),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1525),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(3151),
    [sym_array_type] = STATE(1525),
    [sym_function_type] = STATE(1525),
    [sym_tuple_type] = STATE(1525),
    [sym_unit_type] = STATE(1525),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1525),
    [sym_reference_type] = STATE(1525),
    [sym_pointer_type] = STATE(1525),
    [sym_empty_type] = STATE(1525),
    [sym_abstract_type] = STATE(1526),
    [sym_dynamic_type] = STATE(1525),
    [sym_macro_invocation] = STATE(1525),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2773),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(6144),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(6146),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6150),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6154),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3400] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2988),
    [anon_sym_LBRACE] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_COMMA] = ACTIONS(2988),
    [anon_sym_DASH_GT] = ACTIONS(7656),
    [sym_line_comment] = ACTIONS(7),
  },
  [3401] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym_LBRACE] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_COMMA] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(7658),
    [sym_line_comment] = ACTIONS(7),
  },
  [3402] = {
    [aux_sym_trait_bounds_repeat1] = STATE(3402),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6476),
    [anon_sym_LBRACE] = ACTIONS(6476),
    [anon_sym_PLUS] = ACTIONS(7660),
    [anon_sym_COMMA] = ACTIONS(6476),
    [sym_line_comment] = ACTIONS(7),
  },
  [3403] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(6821),
    [anon_sym_PIPE] = ACTIONS(6821),
    [anon_sym_if] = ACTIONS(6821),
    [sym_line_comment] = ACTIONS(7),
  },
  [3404] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(6829),
    [anon_sym_PIPE] = ACTIONS(6829),
    [anon_sym_if] = ACTIONS(6829),
    [sym_line_comment] = ACTIONS(7),
  },
  [3405] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ_GT] = ACTIONS(6831),
    [anon_sym_PIPE] = ACTIONS(6831),
    [anon_sym_if] = ACTIONS(6831),
    [sym_line_comment] = ACTIONS(7),
  },
  [3406] = {
    [sym_raw_string_literal] = ACTIONS(2789),
    [sym_float_literal] = ACTIONS(2789),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2789),
    [anon_sym_RBRACE] = ACTIONS(2789),
    [anon_sym_LBRACK] = ACTIONS(2789),
    [anon_sym_PLUS] = ACTIONS(2791),
    [anon_sym_STAR] = ACTIONS(2791),
    [anon_sym_COMMA] = ACTIONS(2789),
    [anon_sym_u8] = ACTIONS(2791),
    [anon_sym_i8] = ACTIONS(2791),
    [anon_sym_u16] = ACTIONS(2791),
    [anon_sym_i16] = ACTIONS(2791),
    [anon_sym_u32] = ACTIONS(2791),
    [anon_sym_i32] = ACTIONS(2791),
    [anon_sym_u64] = ACTIONS(2791),
    [anon_sym_i64] = ACTIONS(2791),
    [anon_sym_u128] = ACTIONS(2791),
    [anon_sym_i128] = ACTIONS(2791),
    [anon_sym_isize] = ACTIONS(2791),
    [anon_sym_usize] = ACTIONS(2791),
    [anon_sym_f32] = ACTIONS(2791),
    [anon_sym_f64] = ACTIONS(2791),
    [anon_sym_bool] = ACTIONS(2791),
    [anon_sym_str] = ACTIONS(2791),
    [anon_sym_char] = ACTIONS(2791),
    [anon_sym__] = ACTIONS(2791),
    [anon_sym_AMP] = ACTIONS(2791),
    [anon_sym_DASH] = ACTIONS(2791),
    [anon_sym_DOT] = ACTIONS(2791),
    [anon_sym_DASH_EQ] = ACTIONS(2789),
    [anon_sym_COLON_COLON] = ACTIONS(2789),
    [anon_sym_BANG_EQ] = ACTIONS(2789),
    [anon_sym_STAR_EQ] = ACTIONS(2789),
    [anon_sym_SLASH] = ACTIONS(2791),
    [anon_sym_SLASH_EQ] = ACTIONS(2789),
    [anon_sym_AMP_AMP] = ACTIONS(2789),
    [anon_sym_AMP_EQ] = ACTIONS(2789),
    [anon_sym_POUND] = ACTIONS(2789),
    [anon_sym_PERCENT] = ACTIONS(2791),
    [anon_sym_PERCENT_EQ] = ACTIONS(2789),
    [anon_sym_CARET] = ACTIONS(2791),
    [anon_sym_CARET_EQ] = ACTIONS(2789),
    [anon_sym_PLUS_EQ] = ACTIONS(2789),
    [anon_sym_LT] = ACTIONS(2791),
    [anon_sym_LT_LT] = ACTIONS(2791),
    [anon_sym_LT_LT_EQ] = ACTIONS(2789),
    [anon_sym_LT_EQ] = ACTIONS(2789),
    [anon_sym_EQ] = ACTIONS(2791),
    [anon_sym_EQ_EQ] = ACTIONS(2789),
    [anon_sym_GT] = ACTIONS(2791),
    [anon_sym_GT_EQ] = ACTIONS(2789),
    [anon_sym_GT_GT] = ACTIONS(2791),
    [anon_sym_GT_GT_EQ] = ACTIONS(2789),
    [anon_sym_PIPE] = ACTIONS(2791),
    [anon_sym_PIPE_EQ] = ACTIONS(2789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2789),
    [anon_sym_QMARK] = ACTIONS(2789),
    [anon_sym_DOT_DOT] = ACTIONS(2791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2789),
    [anon_sym_as] = ACTIONS(2791),
    [sym_mutable_specifier] = ACTIONS(2791),
    [anon_sym_else] = ACTIONS(2791),
    [anon_sym_ref] = ACTIONS(2791),
    [sym_integer_literal] = ACTIONS(2789),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2789),
    [sym_char_literal] = ACTIONS(2789),
    [anon_sym_true] = ACTIONS(2791),
    [anon_sym_false] = ACTIONS(2791),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2791),
    [sym_self] = ACTIONS(2791),
    [sym_super] = ACTIONS(2791),
    [sym_crate] = ACTIONS(2791),
    [sym_metavariable] = ACTIONS(2789),
  },
  [3407] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(3552),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(5136),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [3408] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3553),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(3553),
    [sym_macro_invocation] = STATE(3553),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3553),
    [sym_unary_expression] = STATE(3553),
    [sym_try_expression] = STATE(3553),
    [sym_reference_expression] = STATE(3553),
    [sym_binary_expression] = STATE(3553),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3553),
    [sym_call_expression] = STATE(3553),
    [sym_array_expression] = STATE(3553),
    [sym_parenthesized_expression] = STATE(3553),
    [sym_tuple_expression] = STATE(3553),
    [sym_unit_expression] = STATE(3553),
    [sym_struct_expression] = STATE(3553),
    [sym_if_expression] = STATE(3553),
    [sym_if_let_expression] = STATE(3553),
    [sym_match_expression] = STATE(3553),
    [sym_while_expression] = STATE(3553),
    [sym_while_let_expression] = STATE(3553),
    [sym_loop_expression] = STATE(3553),
    [sym_for_expression] = STATE(3553),
    [sym_closure_expression] = STATE(3553),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3553),
    [sym_continue_expression] = STATE(3553),
    [sym_index_expression] = STATE(3553),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3553),
    [sym_block] = STATE(3553),
    [sym__literal] = STATE(3553),
    [sym_string_literal] = STATE(3553),
    [sym_boolean_literal] = STATE(3553),
    [sym_raw_string_literal] = ACTIONS(7663),
    [sym_float_literal] = ACTIONS(7663),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(7663),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7663),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [3409] = {
    [sym_if_expression] = STATE(3554),
    [sym_if_let_expression] = STATE(3554),
    [sym_block] = STATE(3554),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(5136),
    [anon_sym_if] = ACTIONS(7665),
    [sym_line_comment] = ACTIONS(7),
  },
  [3410] = {
    [sym_raw_string_literal] = ACTIONS(3201),
    [sym_float_literal] = ACTIONS(3201),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(3201),
    [anon_sym_RBRACE] = ACTIONS(3201),
    [anon_sym_LBRACK] = ACTIONS(3201),
    [anon_sym_PLUS] = ACTIONS(3203),
    [anon_sym_STAR] = ACTIONS(3203),
    [anon_sym_COMMA] = ACTIONS(3201),
    [anon_sym_u8] = ACTIONS(3203),
    [anon_sym_i8] = ACTIONS(3203),
    [anon_sym_u16] = ACTIONS(3203),
    [anon_sym_i16] = ACTIONS(3203),
    [anon_sym_u32] = ACTIONS(3203),
    [anon_sym_i32] = ACTIONS(3203),
    [anon_sym_u64] = ACTIONS(3203),
    [anon_sym_i64] = ACTIONS(3203),
    [anon_sym_u128] = ACTIONS(3203),
    [anon_sym_i128] = ACTIONS(3203),
    [anon_sym_isize] = ACTIONS(3203),
    [anon_sym_usize] = ACTIONS(3203),
    [anon_sym_f32] = ACTIONS(3203),
    [anon_sym_f64] = ACTIONS(3203),
    [anon_sym_bool] = ACTIONS(3203),
    [anon_sym_str] = ACTIONS(3203),
    [anon_sym_char] = ACTIONS(3203),
    [anon_sym__] = ACTIONS(3203),
    [anon_sym_AMP] = ACTIONS(3203),
    [anon_sym_DASH] = ACTIONS(3203),
    [anon_sym_DOT] = ACTIONS(3203),
    [anon_sym_DASH_EQ] = ACTIONS(3201),
    [anon_sym_COLON_COLON] = ACTIONS(3201),
    [anon_sym_BANG_EQ] = ACTIONS(3201),
    [anon_sym_STAR_EQ] = ACTIONS(3201),
    [anon_sym_SLASH] = ACTIONS(3203),
    [anon_sym_SLASH_EQ] = ACTIONS(3201),
    [anon_sym_AMP_AMP] = ACTIONS(3201),
    [anon_sym_AMP_EQ] = ACTIONS(3201),
    [anon_sym_POUND] = ACTIONS(3201),
    [anon_sym_PERCENT] = ACTIONS(3203),
    [anon_sym_PERCENT_EQ] = ACTIONS(3201),
    [anon_sym_CARET] = ACTIONS(3203),
    [anon_sym_CARET_EQ] = ACTIONS(3201),
    [anon_sym_PLUS_EQ] = ACTIONS(3201),
    [anon_sym_LT] = ACTIONS(3203),
    [anon_sym_LT_LT] = ACTIONS(3203),
    [anon_sym_LT_LT_EQ] = ACTIONS(3201),
    [anon_sym_LT_EQ] = ACTIONS(3201),
    [anon_sym_EQ] = ACTIONS(3203),
    [anon_sym_EQ_EQ] = ACTIONS(3201),
    [anon_sym_GT] = ACTIONS(3203),
    [anon_sym_GT_EQ] = ACTIONS(3201),
    [anon_sym_GT_GT] = ACTIONS(3203),
    [anon_sym_GT_GT_EQ] = ACTIONS(3201),
    [anon_sym_PIPE] = ACTIONS(3203),
    [anon_sym_PIPE_EQ] = ACTIONS(3201),
    [anon_sym_PIPE_PIPE] = ACTIONS(3201),
    [anon_sym_QMARK] = ACTIONS(3201),
    [anon_sym_DOT_DOT] = ACTIONS(3203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3201),
    [anon_sym_as] = ACTIONS(3203),
    [sym_mutable_specifier] = ACTIONS(3203),
    [anon_sym_ref] = ACTIONS(3203),
    [sym_integer_literal] = ACTIONS(3201),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3201),
    [sym_char_literal] = ACTIONS(3201),
    [anon_sym_true] = ACTIONS(3203),
    [anon_sym_false] = ACTIONS(3203),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3203),
    [sym_self] = ACTIONS(3203),
    [sym_super] = ACTIONS(3203),
    [sym_crate] = ACTIONS(3203),
    [sym_metavariable] = ACTIONS(3201),
  },
  [3411] = {
    [sym_raw_string_literal] = ACTIONS(3293),
    [sym_float_literal] = ACTIONS(3293),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(3293),
    [anon_sym_RBRACE] = ACTIONS(3293),
    [anon_sym_LBRACK] = ACTIONS(3293),
    [anon_sym_PLUS] = ACTIONS(3295),
    [anon_sym_STAR] = ACTIONS(3295),
    [anon_sym_COMMA] = ACTIONS(3293),
    [anon_sym_u8] = ACTIONS(3295),
    [anon_sym_i8] = ACTIONS(3295),
    [anon_sym_u16] = ACTIONS(3295),
    [anon_sym_i16] = ACTIONS(3295),
    [anon_sym_u32] = ACTIONS(3295),
    [anon_sym_i32] = ACTIONS(3295),
    [anon_sym_u64] = ACTIONS(3295),
    [anon_sym_i64] = ACTIONS(3295),
    [anon_sym_u128] = ACTIONS(3295),
    [anon_sym_i128] = ACTIONS(3295),
    [anon_sym_isize] = ACTIONS(3295),
    [anon_sym_usize] = ACTIONS(3295),
    [anon_sym_f32] = ACTIONS(3295),
    [anon_sym_f64] = ACTIONS(3295),
    [anon_sym_bool] = ACTIONS(3295),
    [anon_sym_str] = ACTIONS(3295),
    [anon_sym_char] = ACTIONS(3295),
    [anon_sym__] = ACTIONS(3295),
    [anon_sym_AMP] = ACTIONS(3295),
    [anon_sym_DASH] = ACTIONS(3295),
    [anon_sym_DOT] = ACTIONS(3295),
    [anon_sym_DASH_EQ] = ACTIONS(3293),
    [anon_sym_COLON_COLON] = ACTIONS(3293),
    [anon_sym_BANG_EQ] = ACTIONS(3293),
    [anon_sym_STAR_EQ] = ACTIONS(3293),
    [anon_sym_SLASH] = ACTIONS(3295),
    [anon_sym_SLASH_EQ] = ACTIONS(3293),
    [anon_sym_AMP_AMP] = ACTIONS(3293),
    [anon_sym_AMP_EQ] = ACTIONS(3293),
    [anon_sym_POUND] = ACTIONS(3293),
    [anon_sym_PERCENT] = ACTIONS(3295),
    [anon_sym_PERCENT_EQ] = ACTIONS(3293),
    [anon_sym_CARET] = ACTIONS(3295),
    [anon_sym_CARET_EQ] = ACTIONS(3293),
    [anon_sym_PLUS_EQ] = ACTIONS(3293),
    [anon_sym_LT] = ACTIONS(3295),
    [anon_sym_LT_LT] = ACTIONS(3295),
    [anon_sym_LT_LT_EQ] = ACTIONS(3293),
    [anon_sym_LT_EQ] = ACTIONS(3293),
    [anon_sym_EQ] = ACTIONS(3295),
    [anon_sym_EQ_EQ] = ACTIONS(3293),
    [anon_sym_GT] = ACTIONS(3295),
    [anon_sym_GT_EQ] = ACTIONS(3293),
    [anon_sym_GT_GT] = ACTIONS(3295),
    [anon_sym_GT_GT_EQ] = ACTIONS(3293),
    [anon_sym_PIPE] = ACTIONS(3295),
    [anon_sym_PIPE_EQ] = ACTIONS(3293),
    [anon_sym_PIPE_PIPE] = ACTIONS(3293),
    [anon_sym_QMARK] = ACTIONS(3293),
    [anon_sym_DOT_DOT] = ACTIONS(3295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3293),
    [anon_sym_as] = ACTIONS(3295),
    [sym_mutable_specifier] = ACTIONS(3295),
    [anon_sym_ref] = ACTIONS(3295),
    [sym_integer_literal] = ACTIONS(3293),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(3293),
    [sym_char_literal] = ACTIONS(3293),
    [anon_sym_true] = ACTIONS(3295),
    [anon_sym_false] = ACTIONS(3295),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3295),
    [sym_self] = ACTIONS(3295),
    [sym_super] = ACTIONS(3295),
    [sym_crate] = ACTIONS(3295),
    [sym_metavariable] = ACTIONS(3293),
  },
  [3412] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7667),
    [sym_line_comment] = ACTIONS(7),
  },
  [3413] = {
    [sym_attribute_item] = STATE(1049),
    [sym_bracketed_type] = STATE(1041),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(1042),
    [sym_scoped_identifier] = STATE(1043),
    [sym_scoped_type_identifier] = STATE(1044),
    [sym_match_arm] = STATE(1728),
    [sym_last_match_arm] = STATE(3556),
    [sym_match_pattern] = STATE(1046),
    [sym__pattern] = STATE(1047),
    [sym_tuple_pattern] = STATE(1047),
    [sym_tuple_struct_pattern] = STATE(1047),
    [sym_struct_pattern] = STATE(1047),
    [sym_remaining_field_pattern] = STATE(1047),
    [sym_mut_pattern] = STATE(1047),
    [sym_range_pattern] = STATE(1047),
    [sym_ref_pattern] = STATE(1047),
    [sym_captured_pattern] = STATE(1047),
    [sym_reference_pattern] = STATE(1047),
    [sym__literal] = STATE(1048),
    [sym_string_literal] = STATE(1048),
    [sym_boolean_literal] = STATE(1048),
    [aux_sym_enum_variant_list_repeat1] = STATE(1049),
    [aux_sym_match_expression_repeat1] = STATE(1728),
    [sym_raw_string_literal] = ACTIONS(2070),
    [sym_float_literal] = ACTIONS(2070),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2072),
    [anon_sym_u8] = ACTIONS(2076),
    [anon_sym_i8] = ACTIONS(2076),
    [anon_sym_u16] = ACTIONS(2076),
    [anon_sym_i16] = ACTIONS(2076),
    [anon_sym_u32] = ACTIONS(2076),
    [anon_sym_i32] = ACTIONS(2076),
    [anon_sym_u64] = ACTIONS(2076),
    [anon_sym_i64] = ACTIONS(2076),
    [anon_sym_u128] = ACTIONS(2076),
    [anon_sym_i128] = ACTIONS(2076),
    [anon_sym_isize] = ACTIONS(2076),
    [anon_sym_usize] = ACTIONS(2076),
    [anon_sym_f32] = ACTIONS(2076),
    [anon_sym_f64] = ACTIONS(2076),
    [anon_sym_bool] = ACTIONS(2076),
    [anon_sym_str] = ACTIONS(2076),
    [anon_sym_char] = ACTIONS(2076),
    [anon_sym__] = ACTIONS(2078),
    [anon_sym_AMP] = ACTIONS(2080),
    [anon_sym_COLON_COLON] = ACTIONS(2082),
    [anon_sym_POUND] = ACTIONS(2084),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(2086),
    [sym_mutable_specifier] = ACTIONS(2088),
    [anon_sym_ref] = ACTIONS(2090),
    [sym_integer_literal] = ACTIONS(2070),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(769),
    [sym_char_literal] = ACTIONS(2070),
    [anon_sym_true] = ACTIONS(2092),
    [anon_sym_false] = ACTIONS(2092),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2094),
    [sym_self] = ACTIONS(2096),
    [sym_super] = ACTIONS(2096),
    [sym_crate] = ACTIONS(2096),
    [sym_metavariable] = ACTIONS(2098),
  },
  [3414] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3557),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(3557),
    [sym_macro_invocation] = STATE(3557),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3557),
    [sym_unary_expression] = STATE(3557),
    [sym_try_expression] = STATE(3557),
    [sym_reference_expression] = STATE(3557),
    [sym_binary_expression] = STATE(3557),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3557),
    [sym_call_expression] = STATE(3557),
    [sym_array_expression] = STATE(3557),
    [sym_parenthesized_expression] = STATE(3557),
    [sym_tuple_expression] = STATE(3557),
    [sym_unit_expression] = STATE(3557),
    [sym_struct_expression] = STATE(3557),
    [sym_if_expression] = STATE(3557),
    [sym_if_let_expression] = STATE(3557),
    [sym_match_expression] = STATE(3557),
    [sym_while_expression] = STATE(3557),
    [sym_while_let_expression] = STATE(3557),
    [sym_loop_expression] = STATE(3557),
    [sym_for_expression] = STATE(3557),
    [sym_closure_expression] = STATE(3557),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3557),
    [sym_continue_expression] = STATE(3557),
    [sym_index_expression] = STATE(3557),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3557),
    [sym_block] = STATE(3557),
    [sym__literal] = STATE(3557),
    [sym_string_literal] = STATE(3557),
    [sym_boolean_literal] = STATE(3557),
    [sym_raw_string_literal] = ACTIONS(7669),
    [sym_float_literal] = ACTIONS(7669),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(7669),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7669),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [3415] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_in] = ACTIONS(7671),
    [sym_line_comment] = ACTIONS(7),
  },
  [3416] = {
    [sym_raw_string_literal] = ACTIONS(4471),
    [sym_float_literal] = ACTIONS(4471),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(4471),
    [anon_sym_RBRACE] = ACTIONS(4471),
    [anon_sym_LBRACK] = ACTIONS(4471),
    [anon_sym_PLUS] = ACTIONS(4473),
    [anon_sym_STAR] = ACTIONS(4473),
    [anon_sym_COMMA] = ACTIONS(4471),
    [anon_sym_u8] = ACTIONS(4473),
    [anon_sym_i8] = ACTIONS(4473),
    [anon_sym_u16] = ACTIONS(4473),
    [anon_sym_i16] = ACTIONS(4473),
    [anon_sym_u32] = ACTIONS(4473),
    [anon_sym_i32] = ACTIONS(4473),
    [anon_sym_u64] = ACTIONS(4473),
    [anon_sym_i64] = ACTIONS(4473),
    [anon_sym_u128] = ACTIONS(4473),
    [anon_sym_i128] = ACTIONS(4473),
    [anon_sym_isize] = ACTIONS(4473),
    [anon_sym_usize] = ACTIONS(4473),
    [anon_sym_f32] = ACTIONS(4473),
    [anon_sym_f64] = ACTIONS(4473),
    [anon_sym_bool] = ACTIONS(4473),
    [anon_sym_str] = ACTIONS(4473),
    [anon_sym_char] = ACTIONS(4473),
    [anon_sym__] = ACTIONS(4473),
    [anon_sym_AMP] = ACTIONS(4473),
    [anon_sym_DASH] = ACTIONS(4473),
    [anon_sym_DOT] = ACTIONS(4473),
    [anon_sym_DASH_EQ] = ACTIONS(4471),
    [anon_sym_COLON_COLON] = ACTIONS(4471),
    [anon_sym_BANG_EQ] = ACTIONS(4471),
    [anon_sym_STAR_EQ] = ACTIONS(4471),
    [anon_sym_SLASH] = ACTIONS(4473),
    [anon_sym_SLASH_EQ] = ACTIONS(4471),
    [anon_sym_AMP_AMP] = ACTIONS(4471),
    [anon_sym_AMP_EQ] = ACTIONS(4471),
    [anon_sym_POUND] = ACTIONS(4471),
    [anon_sym_PERCENT] = ACTIONS(4473),
    [anon_sym_PERCENT_EQ] = ACTIONS(4471),
    [anon_sym_CARET] = ACTIONS(4473),
    [anon_sym_CARET_EQ] = ACTIONS(4471),
    [anon_sym_PLUS_EQ] = ACTIONS(4471),
    [anon_sym_LT] = ACTIONS(4473),
    [anon_sym_LT_LT] = ACTIONS(4473),
    [anon_sym_LT_LT_EQ] = ACTIONS(4471),
    [anon_sym_LT_EQ] = ACTIONS(4471),
    [anon_sym_EQ] = ACTIONS(4473),
    [anon_sym_EQ_EQ] = ACTIONS(4471),
    [anon_sym_GT] = ACTIONS(4473),
    [anon_sym_GT_EQ] = ACTIONS(4471),
    [anon_sym_GT_GT] = ACTIONS(4473),
    [anon_sym_GT_GT_EQ] = ACTIONS(4471),
    [anon_sym_PIPE] = ACTIONS(4473),
    [anon_sym_PIPE_EQ] = ACTIONS(4471),
    [anon_sym_PIPE_PIPE] = ACTIONS(4471),
    [anon_sym_QMARK] = ACTIONS(4471),
    [anon_sym_DOT_DOT] = ACTIONS(4473),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4471),
    [anon_sym_as] = ACTIONS(4473),
    [sym_mutable_specifier] = ACTIONS(4473),
    [anon_sym_ref] = ACTIONS(4473),
    [sym_integer_literal] = ACTIONS(4471),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(4471),
    [sym_char_literal] = ACTIONS(4471),
    [anon_sym_true] = ACTIONS(4473),
    [anon_sym_false] = ACTIONS(4473),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4473),
    [sym_self] = ACTIONS(4473),
    [sym_super] = ACTIONS(4473),
    [sym_crate] = ACTIONS(4473),
    [sym_metavariable] = ACTIONS(4471),
  },
  [3417] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(3559),
    [sym_tuple_pattern] = STATE(3559),
    [sym_tuple_struct_pattern] = STATE(3559),
    [sym_struct_pattern] = STATE(3559),
    [sym_remaining_field_pattern] = STATE(3559),
    [sym_mut_pattern] = STATE(3559),
    [sym_ref_pattern] = STATE(3559),
    [sym_captured_pattern] = STATE(3559),
    [sym_reference_pattern] = STATE(3559),
    [sym__literal] = STATE(3559),
    [sym_string_literal] = STATE(3559),
    [sym_boolean_literal] = STATE(3559),
    [sym_raw_string_literal] = ACTIONS(7673),
    [sym_float_literal] = ACTIONS(7673),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(7675),
    [anon_sym_AMP] = ACTIONS(955),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(957),
    [anon_sym_ref] = ACTIONS(959),
    [sym_integer_literal] = ACTIONS(7673),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(7673),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(961),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [3418] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(3560),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(5136),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [3419] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2743),
    [anon_sym_EQ_GT] = ACTIONS(2743),
    [anon_sym_LBRACK] = ACTIONS(2743),
    [anon_sym_PLUS] = ACTIONS(2745),
    [anon_sym_STAR] = ACTIONS(2745),
    [anon_sym_AMP] = ACTIONS(2745),
    [anon_sym_DASH] = ACTIONS(2745),
    [anon_sym_DOT] = ACTIONS(2745),
    [anon_sym_DASH_EQ] = ACTIONS(2743),
    [anon_sym_BANG_EQ] = ACTIONS(2743),
    [anon_sym_STAR_EQ] = ACTIONS(2743),
    [anon_sym_SLASH] = ACTIONS(2745),
    [anon_sym_SLASH_EQ] = ACTIONS(2743),
    [anon_sym_AMP_AMP] = ACTIONS(2743),
    [anon_sym_AMP_EQ] = ACTIONS(2743),
    [anon_sym_PERCENT] = ACTIONS(2745),
    [anon_sym_PERCENT_EQ] = ACTIONS(2743),
    [anon_sym_CARET] = ACTIONS(2745),
    [anon_sym_CARET_EQ] = ACTIONS(2743),
    [anon_sym_PLUS_EQ] = ACTIONS(2743),
    [anon_sym_LT] = ACTIONS(2745),
    [anon_sym_LT_LT] = ACTIONS(2745),
    [anon_sym_LT_LT_EQ] = ACTIONS(2743),
    [anon_sym_LT_EQ] = ACTIONS(2743),
    [anon_sym_EQ] = ACTIONS(2745),
    [anon_sym_EQ_EQ] = ACTIONS(2743),
    [anon_sym_GT] = ACTIONS(2745),
    [anon_sym_GT_EQ] = ACTIONS(2743),
    [anon_sym_GT_GT] = ACTIONS(2745),
    [anon_sym_GT_GT_EQ] = ACTIONS(2743),
    [anon_sym_PIPE] = ACTIONS(2745),
    [anon_sym_PIPE_EQ] = ACTIONS(2743),
    [anon_sym_PIPE_PIPE] = ACTIONS(2743),
    [anon_sym_QMARK] = ACTIONS(2743),
    [anon_sym_DOT_DOT] = ACTIONS(2745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2743),
    [anon_sym_as] = ACTIONS(2743),
    [sym_line_comment] = ACTIONS(7),
  },
  [3420] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(7677),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(2749),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_BANG_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH] = ACTIONS(563),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(563),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_LT] = ACTIONS(577),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(581),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(577),
    [anon_sym_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(589),
    [anon_sym_as] = ACTIONS(591),
    [sym_line_comment] = ACTIONS(7),
  },
  [3421] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3562),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3562),
    [sym_macro_invocation] = STATE(3562),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3562),
    [sym_unary_expression] = STATE(3562),
    [sym_try_expression] = STATE(3562),
    [sym_reference_expression] = STATE(3562),
    [sym_binary_expression] = STATE(3562),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3562),
    [sym_call_expression] = STATE(3562),
    [sym_array_expression] = STATE(3562),
    [sym_parenthesized_expression] = STATE(3562),
    [sym_tuple_expression] = STATE(3562),
    [sym_unit_expression] = STATE(3562),
    [sym_struct_expression] = STATE(3562),
    [sym_if_expression] = STATE(3562),
    [sym_if_let_expression] = STATE(3562),
    [sym_match_expression] = STATE(3562),
    [sym_while_expression] = STATE(3562),
    [sym_while_let_expression] = STATE(3562),
    [sym_loop_expression] = STATE(3562),
    [sym_for_expression] = STATE(3562),
    [sym_closure_expression] = STATE(3562),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3562),
    [sym_continue_expression] = STATE(3562),
    [sym_index_expression] = STATE(3562),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3562),
    [sym_block] = STATE(3562),
    [sym__literal] = STATE(3562),
    [sym_string_literal] = STATE(3562),
    [sym_boolean_literal] = STATE(3562),
    [aux_sym_tuple_expression_repeat1] = STATE(1394),
    [sym_raw_string_literal] = ACTIONS(7679),
    [sym_float_literal] = ACTIONS(7679),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(7677),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(7679),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7679),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [3422] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2789),
    [anon_sym_EQ_GT] = ACTIONS(2789),
    [anon_sym_LBRACK] = ACTIONS(2789),
    [anon_sym_PLUS] = ACTIONS(2791),
    [anon_sym_STAR] = ACTIONS(2791),
    [anon_sym_AMP] = ACTIONS(2791),
    [anon_sym_DASH] = ACTIONS(2791),
    [anon_sym_DOT] = ACTIONS(2791),
    [anon_sym_DASH_EQ] = ACTIONS(2789),
    [anon_sym_BANG_EQ] = ACTIONS(2789),
    [anon_sym_STAR_EQ] = ACTIONS(2789),
    [anon_sym_SLASH] = ACTIONS(2791),
    [anon_sym_SLASH_EQ] = ACTIONS(2789),
    [anon_sym_AMP_AMP] = ACTIONS(2789),
    [anon_sym_AMP_EQ] = ACTIONS(2789),
    [anon_sym_PERCENT] = ACTIONS(2791),
    [anon_sym_PERCENT_EQ] = ACTIONS(2789),
    [anon_sym_CARET] = ACTIONS(2791),
    [anon_sym_CARET_EQ] = ACTIONS(2789),
    [anon_sym_PLUS_EQ] = ACTIONS(2789),
    [anon_sym_LT] = ACTIONS(2791),
    [anon_sym_LT_LT] = ACTIONS(2791),
    [anon_sym_LT_LT_EQ] = ACTIONS(2789),
    [anon_sym_LT_EQ] = ACTIONS(2789),
    [anon_sym_EQ] = ACTIONS(2791),
    [anon_sym_EQ_EQ] = ACTIONS(2789),
    [anon_sym_GT] = ACTIONS(2791),
    [anon_sym_GT_EQ] = ACTIONS(2789),
    [anon_sym_GT_GT] = ACTIONS(2791),
    [anon_sym_GT_GT_EQ] = ACTIONS(2789),
    [anon_sym_PIPE] = ACTIONS(2791),
    [anon_sym_PIPE_EQ] = ACTIONS(2789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2789),
    [anon_sym_QMARK] = ACTIONS(2789),
    [anon_sym_DOT_DOT] = ACTIONS(2791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2789),
    [anon_sym_as] = ACTIONS(2789),
    [anon_sym_else] = ACTIONS(2789),
    [sym_line_comment] = ACTIONS(7),
  },
  [3423] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(7681),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_STAR_EQ] = ACTIONS(2563),
    [anon_sym_SLASH] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_AMP_EQ] = ACTIONS(2563),
    [anon_sym_PERCENT] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2563),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_CARET_EQ] = ACTIONS(2563),
    [anon_sym_PLUS_EQ] = ACTIONS(2563),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_LT_LT] = ACTIONS(2573),
    [anon_sym_LT_LT_EQ] = ACTIONS(2563),
    [anon_sym_LT_EQ] = ACTIONS(2565),
    [anon_sym_EQ] = ACTIONS(2575),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_GT_EQ] = ACTIONS(2565),
    [anon_sym_GT_GT] = ACTIONS(2573),
    [anon_sym_GT_GT_EQ] = ACTIONS(2563),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_PIPE_EQ] = ACTIONS(2563),
    [anon_sym_PIPE_PIPE] = ACTIONS(2579),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(2581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2583),
    [anon_sym_as] = ACTIONS(2585),
    [sym_line_comment] = ACTIONS(7),
  },
  [3424] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2799),
    [anon_sym_EQ_GT] = ACTIONS(2799),
    [anon_sym_LBRACK] = ACTIONS(2799),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(2801),
    [anon_sym_AMP] = ACTIONS(2801),
    [anon_sym_DASH] = ACTIONS(2801),
    [anon_sym_DOT] = ACTIONS(2801),
    [anon_sym_DASH_EQ] = ACTIONS(2799),
    [anon_sym_BANG_EQ] = ACTIONS(2799),
    [anon_sym_STAR_EQ] = ACTIONS(2799),
    [anon_sym_SLASH] = ACTIONS(2801),
    [anon_sym_SLASH_EQ] = ACTIONS(2799),
    [anon_sym_AMP_AMP] = ACTIONS(2799),
    [anon_sym_AMP_EQ] = ACTIONS(2799),
    [anon_sym_PERCENT] = ACTIONS(2801),
    [anon_sym_PERCENT_EQ] = ACTIONS(2799),
    [anon_sym_CARET] = ACTIONS(2801),
    [anon_sym_CARET_EQ] = ACTIONS(2799),
    [anon_sym_PLUS_EQ] = ACTIONS(2799),
    [anon_sym_LT] = ACTIONS(2801),
    [anon_sym_LT_LT] = ACTIONS(2801),
    [anon_sym_LT_LT_EQ] = ACTIONS(2799),
    [anon_sym_LT_EQ] = ACTIONS(2799),
    [anon_sym_EQ] = ACTIONS(2801),
    [anon_sym_EQ_EQ] = ACTIONS(2799),
    [anon_sym_GT] = ACTIONS(2801),
    [anon_sym_GT_EQ] = ACTIONS(2799),
    [anon_sym_GT_GT] = ACTIONS(2801),
    [anon_sym_GT_GT_EQ] = ACTIONS(2799),
    [anon_sym_PIPE] = ACTIONS(2801),
    [anon_sym_PIPE_EQ] = ACTIONS(2799),
    [anon_sym_PIPE_PIPE] = ACTIONS(2799),
    [anon_sym_QMARK] = ACTIONS(2799),
    [anon_sym_DOT_DOT] = ACTIONS(2801),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2799),
    [anon_sym_as] = ACTIONS(2799),
    [sym_line_comment] = ACTIONS(7),
  },
  [3425] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(769),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(769),
    [sym_macro_invocation] = STATE(769),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(769),
    [sym_unary_expression] = STATE(769),
    [sym_try_expression] = STATE(769),
    [sym_reference_expression] = STATE(769),
    [sym_binary_expression] = STATE(769),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(769),
    [sym_call_expression] = STATE(769),
    [sym_array_expression] = STATE(769),
    [sym_parenthesized_expression] = STATE(769),
    [sym_tuple_expression] = STATE(769),
    [sym_unit_expression] = STATE(769),
    [sym_struct_expression] = STATE(769),
    [sym_if_expression] = STATE(769),
    [sym_if_let_expression] = STATE(769),
    [sym_match_expression] = STATE(769),
    [sym_while_expression] = STATE(769),
    [sym_while_let_expression] = STATE(769),
    [sym_loop_expression] = STATE(769),
    [sym_for_expression] = STATE(769),
    [sym_closure_expression] = STATE(769),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(769),
    [sym_continue_expression] = STATE(769),
    [sym_index_expression] = STATE(769),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(769),
    [sym_block] = STATE(769),
    [sym__literal] = STATE(769),
    [sym_string_literal] = STATE(769),
    [sym_boolean_literal] = STATE(769),
    [sym_raw_string_literal] = ACTIONS(1620),
    [sym_float_literal] = ACTIONS(1620),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_RBRACK] = ACTIONS(7681),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1620),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1620),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [3426] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(3564),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [3427] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3565),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(3565),
    [sym_macro_invocation] = STATE(3565),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3565),
    [sym_unary_expression] = STATE(3565),
    [sym_try_expression] = STATE(3565),
    [sym_reference_expression] = STATE(3565),
    [sym_binary_expression] = STATE(3565),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3565),
    [sym_call_expression] = STATE(3565),
    [sym_array_expression] = STATE(3565),
    [sym_parenthesized_expression] = STATE(3565),
    [sym_tuple_expression] = STATE(3565),
    [sym_unit_expression] = STATE(3565),
    [sym_struct_expression] = STATE(3565),
    [sym_if_expression] = STATE(3565),
    [sym_if_let_expression] = STATE(3565),
    [sym_match_expression] = STATE(3565),
    [sym_while_expression] = STATE(3565),
    [sym_while_let_expression] = STATE(3565),
    [sym_loop_expression] = STATE(3565),
    [sym_for_expression] = STATE(3565),
    [sym_closure_expression] = STATE(3565),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3565),
    [sym_continue_expression] = STATE(3565),
    [sym_index_expression] = STATE(3565),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3565),
    [sym_block] = STATE(3565),
    [sym__literal] = STATE(3565),
    [sym_string_literal] = STATE(3565),
    [sym_boolean_literal] = STATE(3565),
    [sym_raw_string_literal] = ACTIONS(7683),
    [sym_float_literal] = ACTIONS(7683),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(7683),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7683),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [3428] = {
    [sym_if_expression] = STATE(3566),
    [sym_if_let_expression] = STATE(3566),
    [sym_block] = STATE(3566),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_if] = ACTIONS(7685),
    [sym_line_comment] = ACTIONS(7),
  },
  [3429] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(3201),
    [anon_sym_EQ_GT] = ACTIONS(3201),
    [anon_sym_LBRACK] = ACTIONS(3201),
    [anon_sym_PLUS] = ACTIONS(3203),
    [anon_sym_STAR] = ACTIONS(3203),
    [anon_sym_AMP] = ACTIONS(3203),
    [anon_sym_DASH] = ACTIONS(3203),
    [anon_sym_DOT] = ACTIONS(3203),
    [anon_sym_DASH_EQ] = ACTIONS(3201),
    [anon_sym_BANG_EQ] = ACTIONS(3201),
    [anon_sym_STAR_EQ] = ACTIONS(3201),
    [anon_sym_SLASH] = ACTIONS(3203),
    [anon_sym_SLASH_EQ] = ACTIONS(3201),
    [anon_sym_AMP_AMP] = ACTIONS(3201),
    [anon_sym_AMP_EQ] = ACTIONS(3201),
    [anon_sym_PERCENT] = ACTIONS(3203),
    [anon_sym_PERCENT_EQ] = ACTIONS(3201),
    [anon_sym_CARET] = ACTIONS(3203),
    [anon_sym_CARET_EQ] = ACTIONS(3201),
    [anon_sym_PLUS_EQ] = ACTIONS(3201),
    [anon_sym_LT] = ACTIONS(3203),
    [anon_sym_LT_LT] = ACTIONS(3203),
    [anon_sym_LT_LT_EQ] = ACTIONS(3201),
    [anon_sym_LT_EQ] = ACTIONS(3201),
    [anon_sym_EQ] = ACTIONS(3203),
    [anon_sym_EQ_EQ] = ACTIONS(3201),
    [anon_sym_GT] = ACTIONS(3203),
    [anon_sym_GT_EQ] = ACTIONS(3201),
    [anon_sym_GT_GT] = ACTIONS(3203),
    [anon_sym_GT_GT_EQ] = ACTIONS(3201),
    [anon_sym_PIPE] = ACTIONS(3203),
    [anon_sym_PIPE_EQ] = ACTIONS(3201),
    [anon_sym_PIPE_PIPE] = ACTIONS(3201),
    [anon_sym_QMARK] = ACTIONS(3201),
    [anon_sym_DOT_DOT] = ACTIONS(3203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3201),
    [anon_sym_as] = ACTIONS(3201),
    [sym_line_comment] = ACTIONS(7),
  },
  [3430] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(3293),
    [anon_sym_EQ_GT] = ACTIONS(3293),
    [anon_sym_LBRACK] = ACTIONS(3293),
    [anon_sym_PLUS] = ACTIONS(3295),
    [anon_sym_STAR] = ACTIONS(3295),
    [anon_sym_AMP] = ACTIONS(3295),
    [anon_sym_DASH] = ACTIONS(3295),
    [anon_sym_DOT] = ACTIONS(3295),
    [anon_sym_DASH_EQ] = ACTIONS(3293),
    [anon_sym_BANG_EQ] = ACTIONS(3293),
    [anon_sym_STAR_EQ] = ACTIONS(3293),
    [anon_sym_SLASH] = ACTIONS(3295),
    [anon_sym_SLASH_EQ] = ACTIONS(3293),
    [anon_sym_AMP_AMP] = ACTIONS(3293),
    [anon_sym_AMP_EQ] = ACTIONS(3293),
    [anon_sym_PERCENT] = ACTIONS(3295),
    [anon_sym_PERCENT_EQ] = ACTIONS(3293),
    [anon_sym_CARET] = ACTIONS(3295),
    [anon_sym_CARET_EQ] = ACTIONS(3293),
    [anon_sym_PLUS_EQ] = ACTIONS(3293),
    [anon_sym_LT] = ACTIONS(3295),
    [anon_sym_LT_LT] = ACTIONS(3295),
    [anon_sym_LT_LT_EQ] = ACTIONS(3293),
    [anon_sym_LT_EQ] = ACTIONS(3293),
    [anon_sym_EQ] = ACTIONS(3295),
    [anon_sym_EQ_EQ] = ACTIONS(3293),
    [anon_sym_GT] = ACTIONS(3295),
    [anon_sym_GT_EQ] = ACTIONS(3293),
    [anon_sym_GT_GT] = ACTIONS(3295),
    [anon_sym_GT_GT_EQ] = ACTIONS(3293),
    [anon_sym_PIPE] = ACTIONS(3295),
    [anon_sym_PIPE_EQ] = ACTIONS(3293),
    [anon_sym_PIPE_PIPE] = ACTIONS(3293),
    [anon_sym_QMARK] = ACTIONS(3293),
    [anon_sym_DOT_DOT] = ACTIONS(3295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3293),
    [anon_sym_as] = ACTIONS(3293),
    [sym_line_comment] = ACTIONS(7),
  },
  [3431] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7687),
    [sym_line_comment] = ACTIONS(7),
  },
  [3432] = {
    [sym_attribute_item] = STATE(1049),
    [sym_bracketed_type] = STATE(1041),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(1042),
    [sym_scoped_identifier] = STATE(1043),
    [sym_scoped_type_identifier] = STATE(1044),
    [sym_match_arm] = STATE(1728),
    [sym_last_match_arm] = STATE(3568),
    [sym_match_pattern] = STATE(1046),
    [sym__pattern] = STATE(1047),
    [sym_tuple_pattern] = STATE(1047),
    [sym_tuple_struct_pattern] = STATE(1047),
    [sym_struct_pattern] = STATE(1047),
    [sym_remaining_field_pattern] = STATE(1047),
    [sym_mut_pattern] = STATE(1047),
    [sym_range_pattern] = STATE(1047),
    [sym_ref_pattern] = STATE(1047),
    [sym_captured_pattern] = STATE(1047),
    [sym_reference_pattern] = STATE(1047),
    [sym__literal] = STATE(1048),
    [sym_string_literal] = STATE(1048),
    [sym_boolean_literal] = STATE(1048),
    [aux_sym_enum_variant_list_repeat1] = STATE(1049),
    [aux_sym_match_expression_repeat1] = STATE(1728),
    [sym_raw_string_literal] = ACTIONS(2070),
    [sym_float_literal] = ACTIONS(2070),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2072),
    [anon_sym_u8] = ACTIONS(2076),
    [anon_sym_i8] = ACTIONS(2076),
    [anon_sym_u16] = ACTIONS(2076),
    [anon_sym_i16] = ACTIONS(2076),
    [anon_sym_u32] = ACTIONS(2076),
    [anon_sym_i32] = ACTIONS(2076),
    [anon_sym_u64] = ACTIONS(2076),
    [anon_sym_i64] = ACTIONS(2076),
    [anon_sym_u128] = ACTIONS(2076),
    [anon_sym_i128] = ACTIONS(2076),
    [anon_sym_isize] = ACTIONS(2076),
    [anon_sym_usize] = ACTIONS(2076),
    [anon_sym_f32] = ACTIONS(2076),
    [anon_sym_f64] = ACTIONS(2076),
    [anon_sym_bool] = ACTIONS(2076),
    [anon_sym_str] = ACTIONS(2076),
    [anon_sym_char] = ACTIONS(2076),
    [anon_sym__] = ACTIONS(2078),
    [anon_sym_AMP] = ACTIONS(2080),
    [anon_sym_COLON_COLON] = ACTIONS(2082),
    [anon_sym_POUND] = ACTIONS(2084),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(2086),
    [sym_mutable_specifier] = ACTIONS(2088),
    [anon_sym_ref] = ACTIONS(2090),
    [sym_integer_literal] = ACTIONS(2070),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(769),
    [sym_char_literal] = ACTIONS(2070),
    [anon_sym_true] = ACTIONS(2092),
    [anon_sym_false] = ACTIONS(2092),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2094),
    [sym_self] = ACTIONS(2096),
    [sym_super] = ACTIONS(2096),
    [sym_crate] = ACTIONS(2096),
    [sym_metavariable] = ACTIONS(2098),
  },
  [3433] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3569),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(3569),
    [sym_macro_invocation] = STATE(3569),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3569),
    [sym_unary_expression] = STATE(3569),
    [sym_try_expression] = STATE(3569),
    [sym_reference_expression] = STATE(3569),
    [sym_binary_expression] = STATE(3569),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3569),
    [sym_call_expression] = STATE(3569),
    [sym_array_expression] = STATE(3569),
    [sym_parenthesized_expression] = STATE(3569),
    [sym_tuple_expression] = STATE(3569),
    [sym_unit_expression] = STATE(3569),
    [sym_struct_expression] = STATE(3569),
    [sym_if_expression] = STATE(3569),
    [sym_if_let_expression] = STATE(3569),
    [sym_match_expression] = STATE(3569),
    [sym_while_expression] = STATE(3569),
    [sym_while_let_expression] = STATE(3569),
    [sym_loop_expression] = STATE(3569),
    [sym_for_expression] = STATE(3569),
    [sym_closure_expression] = STATE(3569),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3569),
    [sym_continue_expression] = STATE(3569),
    [sym_index_expression] = STATE(3569),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3569),
    [sym_block] = STATE(3569),
    [sym__literal] = STATE(3569),
    [sym_string_literal] = STATE(3569),
    [sym_boolean_literal] = STATE(3569),
    [sym_raw_string_literal] = ACTIONS(7689),
    [sym_float_literal] = ACTIONS(7689),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(7689),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7689),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [3434] = {
    [sym_block] = STATE(3570),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_PLUS] = ACTIONS(2667),
    [sym_line_comment] = ACTIONS(7),
  },
  [3435] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(3477),
    [anon_sym_EQ_GT] = ACTIONS(3477),
    [anon_sym_LBRACK] = ACTIONS(3477),
    [anon_sym_PLUS] = ACTIONS(3479),
    [anon_sym_STAR] = ACTIONS(3479),
    [anon_sym_AMP] = ACTIONS(3479),
    [anon_sym_DASH] = ACTIONS(3479),
    [anon_sym_DOT] = ACTIONS(3479),
    [anon_sym_DASH_EQ] = ACTIONS(3477),
    [anon_sym_BANG_EQ] = ACTIONS(3477),
    [anon_sym_STAR_EQ] = ACTIONS(3477),
    [anon_sym_SLASH] = ACTIONS(3479),
    [anon_sym_SLASH_EQ] = ACTIONS(3477),
    [anon_sym_AMP_AMP] = ACTIONS(3477),
    [anon_sym_AMP_EQ] = ACTIONS(3477),
    [anon_sym_PERCENT] = ACTIONS(3479),
    [anon_sym_PERCENT_EQ] = ACTIONS(3477),
    [anon_sym_CARET] = ACTIONS(3479),
    [anon_sym_CARET_EQ] = ACTIONS(3477),
    [anon_sym_PLUS_EQ] = ACTIONS(3477),
    [anon_sym_LT] = ACTIONS(3479),
    [anon_sym_LT_LT] = ACTIONS(3479),
    [anon_sym_LT_LT_EQ] = ACTIONS(3477),
    [anon_sym_LT_EQ] = ACTIONS(3477),
    [anon_sym_EQ] = ACTIONS(3479),
    [anon_sym_EQ_EQ] = ACTIONS(3477),
    [anon_sym_GT] = ACTIONS(3479),
    [anon_sym_GT_EQ] = ACTIONS(3477),
    [anon_sym_GT_GT] = ACTIONS(3479),
    [anon_sym_GT_GT_EQ] = ACTIONS(3477),
    [anon_sym_PIPE] = ACTIONS(3479),
    [anon_sym_PIPE_EQ] = ACTIONS(3477),
    [anon_sym_PIPE_PIPE] = ACTIONS(3477),
    [anon_sym_QMARK] = ACTIONS(3477),
    [anon_sym_DOT_DOT] = ACTIONS(3479),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3477),
    [anon_sym_as] = ACTIONS(3477),
    [sym_line_comment] = ACTIONS(7),
  },
  [3436] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_EQ_GT] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3529),
    [anon_sym_STAR] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3529),
    [anon_sym_DASH] = ACTIONS(3529),
    [anon_sym_DOT] = ACTIONS(3529),
    [anon_sym_DASH_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_STAR_EQ] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3529),
    [anon_sym_SLASH_EQ] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_AMP_EQ] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3529),
    [anon_sym_PERCENT_EQ] = ACTIONS(3527),
    [anon_sym_CARET] = ACTIONS(3529),
    [anon_sym_CARET_EQ] = ACTIONS(3527),
    [anon_sym_PLUS_EQ] = ACTIONS(3527),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_LT_LT] = ACTIONS(3529),
    [anon_sym_LT_LT_EQ] = ACTIONS(3527),
    [anon_sym_LT_EQ] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3529),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3529),
    [anon_sym_GT_EQ] = ACTIONS(3527),
    [anon_sym_GT_GT] = ACTIONS(3529),
    [anon_sym_GT_GT_EQ] = ACTIONS(3527),
    [anon_sym_PIPE] = ACTIONS(3529),
    [anon_sym_PIPE_EQ] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_DOT_DOT] = ACTIONS(3529),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3527),
    [anon_sym_as] = ACTIONS(3527),
    [sym_line_comment] = ACTIONS(7),
  },
  [3437] = {
    [sym_attribute_item] = STATE(582),
    [sym_field_initializer] = STATE(1831),
    [sym_base_field_initializer] = STATE(1831),
    [aux_sym_enum_variant_list_repeat1] = STATE(582),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7691),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_DOT_DOT] = ACTIONS(1135),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3535),
  },
  [3438] = {
    [aux_sym_field_initializer_list_repeat1] = STATE(1833),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7691),
    [anon_sym_COMMA] = ACTIONS(7693),
    [sym_line_comment] = ACTIONS(7),
  },
  [3439] = {
    [sym_attribute_item] = STATE(582),
    [sym_field_initializer] = STATE(1831),
    [sym_base_field_initializer] = STATE(1831),
    [aux_sym_enum_variant_list_repeat1] = STATE(582),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7695),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_DOT_DOT] = ACTIONS(1135),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3535),
  },
  [3440] = {
    [aux_sym_field_initializer_list_repeat1] = STATE(1833),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7695),
    [anon_sym_COMMA] = ACTIONS(7697),
    [sym_line_comment] = ACTIONS(7),
  },
  [3441] = {
    [aux_sym_type_arguments_repeat1] = STATE(3577),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_COMMA] = ACTIONS(7699),
    [anon_sym_GT] = ACTIONS(7701),
    [sym_line_comment] = ACTIONS(7),
  },
  [3442] = {
    [aux_sym_type_arguments_repeat1] = STATE(3577),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_PLUS] = ACTIONS(2986),
    [anon_sym_COMMA] = ACTIONS(7699),
    [anon_sym_GT] = ACTIONS(7701),
    [sym_line_comment] = ACTIONS(7),
  },
  [3443] = {
    [aux_sym_type_arguments_repeat1] = STATE(3577),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7699),
    [anon_sym_GT] = ACTIONS(7701),
    [sym_line_comment] = ACTIONS(7),
  },
  [3444] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(3560),
    [anon_sym_EQ_GT] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(3560),
    [anon_sym_PLUS] = ACTIONS(3562),
    [anon_sym_STAR] = ACTIONS(3562),
    [anon_sym_AMP] = ACTIONS(3562),
    [anon_sym_DASH] = ACTIONS(3562),
    [anon_sym_DOT] = ACTIONS(3562),
    [anon_sym_DASH_EQ] = ACTIONS(3560),
    [anon_sym_BANG_EQ] = ACTIONS(3560),
    [anon_sym_STAR_EQ] = ACTIONS(3560),
    [anon_sym_SLASH] = ACTIONS(3562),
    [anon_sym_SLASH_EQ] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_AMP_EQ] = ACTIONS(3560),
    [anon_sym_PERCENT] = ACTIONS(3562),
    [anon_sym_PERCENT_EQ] = ACTIONS(3560),
    [anon_sym_CARET] = ACTIONS(3562),
    [anon_sym_CARET_EQ] = ACTIONS(3560),
    [anon_sym_PLUS_EQ] = ACTIONS(3560),
    [anon_sym_LT] = ACTIONS(3562),
    [anon_sym_LT_LT] = ACTIONS(3562),
    [anon_sym_LT_LT_EQ] = ACTIONS(3560),
    [anon_sym_LT_EQ] = ACTIONS(3560),
    [anon_sym_EQ] = ACTIONS(3562),
    [anon_sym_EQ_EQ] = ACTIONS(3560),
    [anon_sym_GT] = ACTIONS(3562),
    [anon_sym_GT_EQ] = ACTIONS(3560),
    [anon_sym_GT_GT] = ACTIONS(3562),
    [anon_sym_GT_GT_EQ] = ACTIONS(3560),
    [anon_sym_PIPE] = ACTIONS(3562),
    [anon_sym_PIPE_EQ] = ACTIONS(3560),
    [anon_sym_PIPE_PIPE] = ACTIONS(3560),
    [anon_sym_QMARK] = ACTIONS(3560),
    [anon_sym_DOT_DOT] = ACTIONS(3562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3560),
    [anon_sym_as] = ACTIONS(3560),
    [sym_line_comment] = ACTIONS(7),
  },
  [3445] = {
    [sym_arguments] = STATE(263),
    [aux_sym_token_tree_repeat2] = STATE(3580),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(7703),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(7705),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_BANG_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH] = ACTIONS(563),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(563),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_LT] = ACTIONS(577),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(581),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(577),
    [anon_sym_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(589),
    [anon_sym_as] = ACTIONS(591),
    [sym_line_comment] = ACTIONS(7),
  },
  [3446] = {
    [sym_token_tree] = STATE(1878),
    [sym_token_repetition] = STATE(1878),
    [sym__literal] = STATE(1878),
    [sym_string_literal] = STATE(1878),
    [sym_boolean_literal] = STATE(1878),
    [aux_sym_token_tree_repeat1] = STATE(1878),
    [sym_raw_string_literal] = ACTIONS(3960),
    [sym_float_literal] = ACTIONS(3960),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_RPAREN] = ACTIONS(7707),
    [anon_sym_LBRACE] = ACTIONS(3966),
    [anon_sym_EQ_GT] = ACTIONS(3960),
    [anon_sym_LBRACK] = ACTIONS(3968),
    [anon_sym_COLON] = ACTIONS(3970),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(3970),
    [anon_sym_STAR] = ACTIONS(3970),
    [anon_sym_COMMA] = ACTIONS(3960),
    [anon_sym_u8] = ACTIONS(3972),
    [anon_sym_i8] = ACTIONS(3972),
    [anon_sym_u16] = ACTIONS(3972),
    [anon_sym_i16] = ACTIONS(3972),
    [anon_sym_u32] = ACTIONS(3972),
    [anon_sym_i32] = ACTIONS(3972),
    [anon_sym_u64] = ACTIONS(3972),
    [anon_sym_i64] = ACTIONS(3972),
    [anon_sym_u128] = ACTIONS(3972),
    [anon_sym_i128] = ACTIONS(3972),
    [anon_sym_isize] = ACTIONS(3972),
    [anon_sym_usize] = ACTIONS(3972),
    [anon_sym_f32] = ACTIONS(3972),
    [anon_sym_f64] = ACTIONS(3972),
    [anon_sym_bool] = ACTIONS(3972),
    [anon_sym_str] = ACTIONS(3972),
    [anon_sym_char] = ACTIONS(3972),
    [anon_sym__] = ACTIONS(3970),
    [anon_sym_AMP] = ACTIONS(3970),
    [anon_sym_DASH] = ACTIONS(3970),
    [anon_sym_DOT] = ACTIONS(3970),
    [anon_sym_DASH_EQ] = ACTIONS(3960),
    [anon_sym_DASH_GT] = ACTIONS(3960),
    [anon_sym_COLON_COLON] = ACTIONS(3960),
    [anon_sym_BANG] = ACTIONS(3970),
    [anon_sym_BANG_EQ] = ACTIONS(3960),
    [anon_sym_AT] = ACTIONS(3960),
    [anon_sym_STAR_EQ] = ACTIONS(3960),
    [anon_sym_SLASH] = ACTIONS(3970),
    [anon_sym_SLASH_EQ] = ACTIONS(3960),
    [anon_sym_AMP_AMP] = ACTIONS(3960),
    [anon_sym_AMP_EQ] = ACTIONS(3960),
    [anon_sym_POUND] = ACTIONS(3960),
    [anon_sym_PERCENT] = ACTIONS(3970),
    [anon_sym_PERCENT_EQ] = ACTIONS(3960),
    [anon_sym_CARET] = ACTIONS(3970),
    [anon_sym_CARET_EQ] = ACTIONS(3960),
    [anon_sym_PLUS_EQ] = ACTIONS(3960),
    [anon_sym_LT] = ACTIONS(3970),
    [anon_sym_LT_LT] = ACTIONS(3970),
    [anon_sym_LT_LT_EQ] = ACTIONS(3960),
    [anon_sym_LT_EQ] = ACTIONS(3960),
    [anon_sym_EQ] = ACTIONS(3970),
    [anon_sym_EQ_EQ] = ACTIONS(3960),
    [anon_sym_GT] = ACTIONS(3970),
    [anon_sym_GT_EQ] = ACTIONS(3960),
    [anon_sym_GT_GT] = ACTIONS(3970),
    [anon_sym_GT_GT_EQ] = ACTIONS(3960),
    [anon_sym_PIPE] = ACTIONS(3970),
    [anon_sym_PIPE_EQ] = ACTIONS(3960),
    [anon_sym_PIPE_PIPE] = ACTIONS(3960),
    [anon_sym_TILDE] = ACTIONS(3960),
    [anon_sym_QMARK] = ACTIONS(3960),
    [anon_sym_SQUOTE] = ACTIONS(3970),
    [anon_sym_DOT_DOT] = ACTIONS(3970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3960),
    [anon_sym_as] = ACTIONS(3970),
    [anon_sym_break] = ACTIONS(3970),
    [anon_sym_const] = ACTIONS(3970),
    [anon_sym_continue] = ACTIONS(3970),
    [anon_sym_default] = ACTIONS(3970),
    [anon_sym_enum] = ACTIONS(3970),
    [anon_sym_fn] = ACTIONS(3970),
    [anon_sym_for] = ACTIONS(3970),
    [anon_sym_if] = ACTIONS(3970),
    [anon_sym_impl] = ACTIONS(3970),
    [anon_sym_let] = ACTIONS(3970),
    [anon_sym_loop] = ACTIONS(3970),
    [anon_sym_match] = ACTIONS(3970),
    [anon_sym_mod] = ACTIONS(3970),
    [anon_sym_pub] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3970),
    [anon_sym_static] = ACTIONS(3970),
    [anon_sym_struct] = ACTIONS(3970),
    [anon_sym_trait] = ACTIONS(3970),
    [anon_sym_type] = ACTIONS(3970),
    [anon_sym_union] = ACTIONS(3970),
    [anon_sym_unsafe] = ACTIONS(3970),
    [anon_sym_use] = ACTIONS(3970),
    [anon_sym_where] = ACTIONS(3970),
    [anon_sym_while] = ACTIONS(3970),
    [sym_mutable_specifier] = ACTIONS(3970),
    [sym_integer_literal] = ACTIONS(3960),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(3960),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3970),
    [sym_self] = ACTIONS(3970),
    [sym_super] = ACTIONS(3970),
    [sym_crate] = ACTIONS(3970),
    [sym_metavariable] = ACTIONS(3960),
  },
  [3447] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(7703),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(623),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(623),
    [anon_sym_PLUS_EQ] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(623),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(643),
    [anon_sym_as] = ACTIONS(645),
    [sym_line_comment] = ACTIONS(7),
  },
  [3448] = {
    [sym__statement] = STATE(332),
    [sym_empty_statement] = STATE(332),
    [sym__expression_statement] = STATE(332),
    [sym_macro_definition] = STATE(332),
    [sym_attribute_item] = STATE(332),
    [sym_inner_attribute_item] = STATE(332),
    [sym_mod_item] = STATE(332),
    [sym_foreign_mod_item] = STATE(332),
    [sym_struct_item] = STATE(332),
    [sym_union_item] = STATE(332),
    [sym_enum_item] = STATE(332),
    [sym_extern_crate_declaration] = STATE(332),
    [sym_const_item] = STATE(332),
    [sym_static_item] = STATE(332),
    [sym_type_item] = STATE(332),
    [sym_function_item] = STATE(332),
    [sym_function_signature_item] = STATE(332),
    [sym_function_modifiers] = STATE(47),
    [sym_impl_item] = STATE(332),
    [sym_trait_item] = STATE(332),
    [sym_associated_type] = STATE(332),
    [sym_let_declaration] = STATE(332),
    [sym_use_declaration] = STATE(332),
    [sym_extern_modifier] = STATE(48),
    [sym_visibility_modifier] = STATE(49),
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3582),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3582),
    [sym_macro_invocation] = STATE(53),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3582),
    [sym_unary_expression] = STATE(3582),
    [sym_try_expression] = STATE(3582),
    [sym_reference_expression] = STATE(3582),
    [sym_binary_expression] = STATE(3582),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3582),
    [sym_call_expression] = STATE(3582),
    [sym_array_expression] = STATE(3582),
    [sym_parenthesized_expression] = STATE(3582),
    [sym_tuple_expression] = STATE(3582),
    [sym_unit_expression] = STATE(3582),
    [sym_struct_expression] = STATE(3582),
    [sym_if_expression] = STATE(57),
    [sym_if_let_expression] = STATE(57),
    [sym_match_expression] = STATE(57),
    [sym_while_expression] = STATE(57),
    [sym_while_let_expression] = STATE(57),
    [sym_loop_expression] = STATE(57),
    [sym_for_expression] = STATE(57),
    [sym_closure_expression] = STATE(3582),
    [sym_closure_parameters] = STATE(90),
    [sym_loop_label] = STATE(59),
    [sym_break_expression] = STATE(3582),
    [sym_continue_expression] = STATE(3582),
    [sym_index_expression] = STATE(3582),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(57),
    [sym_block] = STATE(57),
    [sym__literal] = STATE(3582),
    [sym_string_literal] = STATE(3582),
    [sym_boolean_literal] = STATE(3582),
    [aux_sym_source_file_repeat1] = STATE(332),
    [aux_sym_function_modifiers_repeat1] = STATE(62),
    [sym_raw_string_literal] = ACTIONS(7709),
    [sym_float_literal] = ACTIONS(7709),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(11),
    [anon_sym_macro_rules_BANG] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(7703),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_POUND] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(45),
    [anon_sym_enum] = ACTIONS(47),
    [anon_sym_fn] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_impl] = ACTIONS(55),
    [anon_sym_let] = ACTIONS(57),
    [anon_sym_loop] = ACTIONS(59),
    [anon_sym_match] = ACTIONS(61),
    [anon_sym_mod] = ACTIONS(63),
    [anon_sym_pub] = ACTIONS(65),
    [anon_sym_return] = ACTIONS(151),
    [anon_sym_static] = ACTIONS(69),
    [anon_sym_struct] = ACTIONS(71),
    [anon_sym_trait] = ACTIONS(73),
    [anon_sym_type] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_unsafe] = ACTIONS(79),
    [anon_sym_use] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(83),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(153),
    [sym_integer_literal] = ACTIONS(7709),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7709),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(93),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [3449] = {
    [sym_token_tree] = STATE(1887),
    [sym_token_repetition] = STATE(1887),
    [sym__literal] = STATE(1887),
    [sym_string_literal] = STATE(1887),
    [sym_boolean_literal] = STATE(1887),
    [aux_sym_token_tree_repeat1] = STATE(1887),
    [sym_raw_string_literal] = ACTIONS(4148),
    [sym_float_literal] = ACTIONS(4148),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4148),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_LBRACE] = ACTIONS(3966),
    [anon_sym_RBRACE] = ACTIONS(7707),
    [anon_sym_EQ_GT] = ACTIONS(4148),
    [anon_sym_LBRACK] = ACTIONS(3968),
    [anon_sym_COLON] = ACTIONS(4150),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(4150),
    [anon_sym_STAR] = ACTIONS(4150),
    [anon_sym_COMMA] = ACTIONS(4148),
    [anon_sym_u8] = ACTIONS(3972),
    [anon_sym_i8] = ACTIONS(3972),
    [anon_sym_u16] = ACTIONS(3972),
    [anon_sym_i16] = ACTIONS(3972),
    [anon_sym_u32] = ACTIONS(3972),
    [anon_sym_i32] = ACTIONS(3972),
    [anon_sym_u64] = ACTIONS(3972),
    [anon_sym_i64] = ACTIONS(3972),
    [anon_sym_u128] = ACTIONS(3972),
    [anon_sym_i128] = ACTIONS(3972),
    [anon_sym_isize] = ACTIONS(3972),
    [anon_sym_usize] = ACTIONS(3972),
    [anon_sym_f32] = ACTIONS(3972),
    [anon_sym_f64] = ACTIONS(3972),
    [anon_sym_bool] = ACTIONS(3972),
    [anon_sym_str] = ACTIONS(3972),
    [anon_sym_char] = ACTIONS(3972),
    [anon_sym__] = ACTIONS(4150),
    [anon_sym_AMP] = ACTIONS(4150),
    [anon_sym_DASH] = ACTIONS(4150),
    [anon_sym_DOT] = ACTIONS(4150),
    [anon_sym_DASH_EQ] = ACTIONS(4148),
    [anon_sym_DASH_GT] = ACTIONS(4148),
    [anon_sym_COLON_COLON] = ACTIONS(4148),
    [anon_sym_BANG] = ACTIONS(4150),
    [anon_sym_BANG_EQ] = ACTIONS(4148),
    [anon_sym_AT] = ACTIONS(4148),
    [anon_sym_STAR_EQ] = ACTIONS(4148),
    [anon_sym_SLASH] = ACTIONS(4150),
    [anon_sym_SLASH_EQ] = ACTIONS(4148),
    [anon_sym_AMP_AMP] = ACTIONS(4148),
    [anon_sym_AMP_EQ] = ACTIONS(4148),
    [anon_sym_POUND] = ACTIONS(4148),
    [anon_sym_PERCENT] = ACTIONS(4150),
    [anon_sym_PERCENT_EQ] = ACTIONS(4148),
    [anon_sym_CARET] = ACTIONS(4150),
    [anon_sym_CARET_EQ] = ACTIONS(4148),
    [anon_sym_PLUS_EQ] = ACTIONS(4148),
    [anon_sym_LT] = ACTIONS(4150),
    [anon_sym_LT_LT] = ACTIONS(4150),
    [anon_sym_LT_LT_EQ] = ACTIONS(4148),
    [anon_sym_LT_EQ] = ACTIONS(4148),
    [anon_sym_EQ] = ACTIONS(4150),
    [anon_sym_EQ_EQ] = ACTIONS(4148),
    [anon_sym_GT] = ACTIONS(4150),
    [anon_sym_GT_EQ] = ACTIONS(4148),
    [anon_sym_GT_GT] = ACTIONS(4150),
    [anon_sym_GT_GT_EQ] = ACTIONS(4148),
    [anon_sym_PIPE] = ACTIONS(4150),
    [anon_sym_PIPE_EQ] = ACTIONS(4148),
    [anon_sym_PIPE_PIPE] = ACTIONS(4148),
    [anon_sym_TILDE] = ACTIONS(4148),
    [anon_sym_QMARK] = ACTIONS(4148),
    [anon_sym_SQUOTE] = ACTIONS(4150),
    [anon_sym_DOT_DOT] = ACTIONS(4150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4148),
    [anon_sym_as] = ACTIONS(4150),
    [anon_sym_break] = ACTIONS(4150),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_continue] = ACTIONS(4150),
    [anon_sym_default] = ACTIONS(4150),
    [anon_sym_enum] = ACTIONS(4150),
    [anon_sym_fn] = ACTIONS(4150),
    [anon_sym_for] = ACTIONS(4150),
    [anon_sym_if] = ACTIONS(4150),
    [anon_sym_impl] = ACTIONS(4150),
    [anon_sym_let] = ACTIONS(4150),
    [anon_sym_loop] = ACTIONS(4150),
    [anon_sym_match] = ACTIONS(4150),
    [anon_sym_mod] = ACTIONS(4150),
    [anon_sym_pub] = ACTIONS(4150),
    [anon_sym_return] = ACTIONS(4150),
    [anon_sym_static] = ACTIONS(4150),
    [anon_sym_struct] = ACTIONS(4150),
    [anon_sym_trait] = ACTIONS(4150),
    [anon_sym_type] = ACTIONS(4150),
    [anon_sym_union] = ACTIONS(4150),
    [anon_sym_unsafe] = ACTIONS(4150),
    [anon_sym_use] = ACTIONS(4150),
    [anon_sym_where] = ACTIONS(4150),
    [anon_sym_while] = ACTIONS(4150),
    [sym_mutable_specifier] = ACTIONS(4150),
    [sym_integer_literal] = ACTIONS(4148),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(4148),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4150),
    [sym_self] = ACTIONS(4150),
    [sym_super] = ACTIONS(4150),
    [sym_crate] = ACTIONS(4150),
    [sym_metavariable] = ACTIONS(4148),
  },
  [3450] = {
    [sym_arguments] = STATE(263),
    [aux_sym_token_tree_repeat2] = STATE(3584),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(7703),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_STAR] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(7711),
    [anon_sym_AMP] = ACTIONS(2821),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2823),
    [anon_sym_BANG_EQ] = ACTIONS(2825),
    [anon_sym_STAR_EQ] = ACTIONS(2823),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_SLASH_EQ] = ACTIONS(2823),
    [anon_sym_AMP_AMP] = ACTIONS(2827),
    [anon_sym_AMP_EQ] = ACTIONS(2823),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_PERCENT_EQ] = ACTIONS(2823),
    [anon_sym_CARET] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2823),
    [anon_sym_PLUS_EQ] = ACTIONS(2823),
    [anon_sym_LT] = ACTIONS(2831),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_LT_LT_EQ] = ACTIONS(2823),
    [anon_sym_LT_EQ] = ACTIONS(2825),
    [anon_sym_EQ] = ACTIONS(2835),
    [anon_sym_EQ_EQ] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2831),
    [anon_sym_GT_EQ] = ACTIONS(2825),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_GT_GT_EQ] = ACTIONS(2823),
    [anon_sym_PIPE] = ACTIONS(2837),
    [anon_sym_PIPE_EQ] = ACTIONS(2823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2839),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(2841),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2843),
    [anon_sym_as] = ACTIONS(2845),
    [sym_line_comment] = ACTIONS(7),
  },
  [3451] = {
    [sym_token_tree] = STATE(1890),
    [sym_token_repetition] = STATE(1890),
    [sym__literal] = STATE(1890),
    [sym_string_literal] = STATE(1890),
    [sym_boolean_literal] = STATE(1890),
    [aux_sym_token_tree_repeat1] = STATE(1890),
    [sym_raw_string_literal] = ACTIONS(4197),
    [sym_float_literal] = ACTIONS(4197),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4197),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_LBRACE] = ACTIONS(3966),
    [anon_sym_EQ_GT] = ACTIONS(4197),
    [anon_sym_LBRACK] = ACTIONS(3968),
    [anon_sym_RBRACK] = ACTIONS(7707),
    [anon_sym_COLON] = ACTIONS(4199),
    [anon_sym_DOLLAR] = ACTIONS(2289),
    [anon_sym_PLUS] = ACTIONS(4199),
    [anon_sym_STAR] = ACTIONS(4199),
    [anon_sym_COMMA] = ACTIONS(4197),
    [anon_sym_u8] = ACTIONS(3972),
    [anon_sym_i8] = ACTIONS(3972),
    [anon_sym_u16] = ACTIONS(3972),
    [anon_sym_i16] = ACTIONS(3972),
    [anon_sym_u32] = ACTIONS(3972),
    [anon_sym_i32] = ACTIONS(3972),
    [anon_sym_u64] = ACTIONS(3972),
    [anon_sym_i64] = ACTIONS(3972),
    [anon_sym_u128] = ACTIONS(3972),
    [anon_sym_i128] = ACTIONS(3972),
    [anon_sym_isize] = ACTIONS(3972),
    [anon_sym_usize] = ACTIONS(3972),
    [anon_sym_f32] = ACTIONS(3972),
    [anon_sym_f64] = ACTIONS(3972),
    [anon_sym_bool] = ACTIONS(3972),
    [anon_sym_str] = ACTIONS(3972),
    [anon_sym_char] = ACTIONS(3972),
    [anon_sym__] = ACTIONS(4199),
    [anon_sym_AMP] = ACTIONS(4199),
    [anon_sym_DASH] = ACTIONS(4199),
    [anon_sym_DOT] = ACTIONS(4199),
    [anon_sym_DASH_EQ] = ACTIONS(4197),
    [anon_sym_DASH_GT] = ACTIONS(4197),
    [anon_sym_COLON_COLON] = ACTIONS(4197),
    [anon_sym_BANG] = ACTIONS(4199),
    [anon_sym_BANG_EQ] = ACTIONS(4197),
    [anon_sym_AT] = ACTIONS(4197),
    [anon_sym_STAR_EQ] = ACTIONS(4197),
    [anon_sym_SLASH] = ACTIONS(4199),
    [anon_sym_SLASH_EQ] = ACTIONS(4197),
    [anon_sym_AMP_AMP] = ACTIONS(4197),
    [anon_sym_AMP_EQ] = ACTIONS(4197),
    [anon_sym_POUND] = ACTIONS(4197),
    [anon_sym_PERCENT] = ACTIONS(4199),
    [anon_sym_PERCENT_EQ] = ACTIONS(4197),
    [anon_sym_CARET] = ACTIONS(4199),
    [anon_sym_CARET_EQ] = ACTIONS(4197),
    [anon_sym_PLUS_EQ] = ACTIONS(4197),
    [anon_sym_LT] = ACTIONS(4199),
    [anon_sym_LT_LT] = ACTIONS(4199),
    [anon_sym_LT_LT_EQ] = ACTIONS(4197),
    [anon_sym_LT_EQ] = ACTIONS(4197),
    [anon_sym_EQ] = ACTIONS(4199),
    [anon_sym_EQ_EQ] = ACTIONS(4197),
    [anon_sym_GT] = ACTIONS(4199),
    [anon_sym_GT_EQ] = ACTIONS(4197),
    [anon_sym_GT_GT] = ACTIONS(4199),
    [anon_sym_GT_GT_EQ] = ACTIONS(4197),
    [anon_sym_PIPE] = ACTIONS(4199),
    [anon_sym_PIPE_EQ] = ACTIONS(4197),
    [anon_sym_PIPE_PIPE] = ACTIONS(4197),
    [anon_sym_TILDE] = ACTIONS(4197),
    [anon_sym_QMARK] = ACTIONS(4197),
    [anon_sym_SQUOTE] = ACTIONS(4199),
    [anon_sym_DOT_DOT] = ACTIONS(4199),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4197),
    [anon_sym_as] = ACTIONS(4199),
    [anon_sym_break] = ACTIONS(4199),
    [anon_sym_const] = ACTIONS(4199),
    [anon_sym_continue] = ACTIONS(4199),
    [anon_sym_default] = ACTIONS(4199),
    [anon_sym_enum] = ACTIONS(4199),
    [anon_sym_fn] = ACTIONS(4199),
    [anon_sym_for] = ACTIONS(4199),
    [anon_sym_if] = ACTIONS(4199),
    [anon_sym_impl] = ACTIONS(4199),
    [anon_sym_let] = ACTIONS(4199),
    [anon_sym_loop] = ACTIONS(4199),
    [anon_sym_match] = ACTIONS(4199),
    [anon_sym_mod] = ACTIONS(4199),
    [anon_sym_pub] = ACTIONS(4199),
    [anon_sym_return] = ACTIONS(4199),
    [anon_sym_static] = ACTIONS(4199),
    [anon_sym_struct] = ACTIONS(4199),
    [anon_sym_trait] = ACTIONS(4199),
    [anon_sym_type] = ACTIONS(4199),
    [anon_sym_union] = ACTIONS(4199),
    [anon_sym_unsafe] = ACTIONS(4199),
    [anon_sym_use] = ACTIONS(4199),
    [anon_sym_where] = ACTIONS(4199),
    [anon_sym_while] = ACTIONS(4199),
    [sym_mutable_specifier] = ACTIONS(4199),
    [sym_integer_literal] = ACTIONS(4197),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2327),
    [sym_char_literal] = ACTIONS(4197),
    [anon_sym_true] = ACTIONS(2329),
    [anon_sym_false] = ACTIONS(2329),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(4199),
    [sym_self] = ACTIONS(4199),
    [sym_super] = ACTIONS(4199),
    [sym_crate] = ACTIONS(4199),
    [sym_metavariable] = ACTIONS(4197),
  },
  [3452] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(4371),
    [anon_sym_EQ_GT] = ACTIONS(4371),
    [anon_sym_LBRACK] = ACTIONS(4371),
    [anon_sym_PLUS] = ACTIONS(4373),
    [anon_sym_STAR] = ACTIONS(4373),
    [anon_sym_AMP] = ACTIONS(4373),
    [anon_sym_DASH] = ACTIONS(4373),
    [anon_sym_DOT] = ACTIONS(4373),
    [anon_sym_DASH_EQ] = ACTIONS(4371),
    [anon_sym_BANG_EQ] = ACTIONS(4371),
    [anon_sym_STAR_EQ] = ACTIONS(4371),
    [anon_sym_SLASH] = ACTIONS(4373),
    [anon_sym_SLASH_EQ] = ACTIONS(4371),
    [anon_sym_AMP_AMP] = ACTIONS(4371),
    [anon_sym_AMP_EQ] = ACTIONS(4371),
    [anon_sym_PERCENT] = ACTIONS(4373),
    [anon_sym_PERCENT_EQ] = ACTIONS(4371),
    [anon_sym_CARET] = ACTIONS(4373),
    [anon_sym_CARET_EQ] = ACTIONS(4371),
    [anon_sym_PLUS_EQ] = ACTIONS(4371),
    [anon_sym_LT] = ACTIONS(4373),
    [anon_sym_LT_LT] = ACTIONS(4373),
    [anon_sym_LT_LT_EQ] = ACTIONS(4371),
    [anon_sym_LT_EQ] = ACTIONS(4371),
    [anon_sym_EQ] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4371),
    [anon_sym_GT] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4371),
    [anon_sym_GT_GT] = ACTIONS(4373),
    [anon_sym_GT_GT_EQ] = ACTIONS(4371),
    [anon_sym_PIPE] = ACTIONS(4373),
    [anon_sym_PIPE_EQ] = ACTIONS(4371),
    [anon_sym_PIPE_PIPE] = ACTIONS(4371),
    [anon_sym_QMARK] = ACTIONS(4371),
    [anon_sym_DOT_DOT] = ACTIONS(4373),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4371),
    [anon_sym_as] = ACTIONS(4371),
    [sym_line_comment] = ACTIONS(7),
  },
  [3453] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1972),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1972),
    [sym_unary_expression] = STATE(1972),
    [sym_try_expression] = STATE(1972),
    [sym_reference_expression] = STATE(1972),
    [sym_binary_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1972),
    [sym_call_expression] = STATE(1972),
    [sym_array_expression] = STATE(1972),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_tuple_expression] = STATE(1972),
    [sym_unit_expression] = STATE(1972),
    [sym_struct_expression] = STATE(1972),
    [sym_if_expression] = STATE(1972),
    [sym_if_let_expression] = STATE(1972),
    [sym_match_expression] = STATE(1972),
    [sym_while_expression] = STATE(1972),
    [sym_while_let_expression] = STATE(1972),
    [sym_loop_expression] = STATE(1972),
    [sym_for_expression] = STATE(1972),
    [sym_closure_expression] = STATE(1972),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1972),
    [sym_continue_expression] = STATE(1972),
    [sym_index_expression] = STATE(1972),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1972),
    [sym_block] = STATE(1972),
    [sym__literal] = STATE(1972),
    [sym_string_literal] = STATE(1972),
    [sym_boolean_literal] = STATE(1972),
    [sym_raw_string_literal] = ACTIONS(4375),
    [sym_float_literal] = ACTIONS(4375),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(7713),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(4375),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4375),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [3454] = {
    [aux_sym_token_tree_repeat2] = STATE(1974),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7713),
    [anon_sym_COMMA] = ACTIONS(7715),
    [sym_line_comment] = ACTIONS(7),
  },
  [3455] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(4387),
    [anon_sym_EQ_GT] = ACTIONS(4387),
    [anon_sym_LBRACK] = ACTIONS(4387),
    [anon_sym_PLUS] = ACTIONS(4389),
    [anon_sym_STAR] = ACTIONS(4389),
    [anon_sym_AMP] = ACTIONS(4389),
    [anon_sym_DASH] = ACTIONS(4389),
    [anon_sym_DOT] = ACTIONS(4389),
    [anon_sym_DASH_EQ] = ACTIONS(4387),
    [anon_sym_BANG_EQ] = ACTIONS(4387),
    [anon_sym_STAR_EQ] = ACTIONS(4387),
    [anon_sym_SLASH] = ACTIONS(4389),
    [anon_sym_SLASH_EQ] = ACTIONS(4387),
    [anon_sym_AMP_AMP] = ACTIONS(4387),
    [anon_sym_AMP_EQ] = ACTIONS(4387),
    [anon_sym_PERCENT] = ACTIONS(4389),
    [anon_sym_PERCENT_EQ] = ACTIONS(4387),
    [anon_sym_CARET] = ACTIONS(4389),
    [anon_sym_CARET_EQ] = ACTIONS(4387),
    [anon_sym_PLUS_EQ] = ACTIONS(4387),
    [anon_sym_LT] = ACTIONS(4389),
    [anon_sym_LT_LT] = ACTIONS(4389),
    [anon_sym_LT_LT_EQ] = ACTIONS(4387),
    [anon_sym_LT_EQ] = ACTIONS(4387),
    [anon_sym_EQ] = ACTIONS(4389),
    [anon_sym_EQ_EQ] = ACTIONS(4387),
    [anon_sym_GT] = ACTIONS(4389),
    [anon_sym_GT_EQ] = ACTIONS(4387),
    [anon_sym_GT_GT] = ACTIONS(4389),
    [anon_sym_GT_GT_EQ] = ACTIONS(4387),
    [anon_sym_PIPE] = ACTIONS(4389),
    [anon_sym_PIPE_EQ] = ACTIONS(4387),
    [anon_sym_PIPE_PIPE] = ACTIONS(4387),
    [anon_sym_QMARK] = ACTIONS(4387),
    [anon_sym_DOT_DOT] = ACTIONS(4389),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4387),
    [anon_sym_as] = ACTIONS(4387),
    [sym_line_comment] = ACTIONS(7),
  },
  [3456] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1688),
    [anon_sym_EQ_GT] = ACTIONS(1688),
    [anon_sym_LBRACK] = ACTIONS(1688),
    [anon_sym_PLUS] = ACTIONS(4421),
    [anon_sym_STAR] = ACTIONS(4421),
    [anon_sym_AMP] = ACTIONS(4421),
    [anon_sym_DASH] = ACTIONS(4421),
    [anon_sym_DOT] = ACTIONS(4421),
    [anon_sym_DASH_EQ] = ACTIONS(1688),
    [anon_sym_BANG_EQ] = ACTIONS(1688),
    [anon_sym_STAR_EQ] = ACTIONS(1688),
    [anon_sym_SLASH] = ACTIONS(4421),
    [anon_sym_SLASH_EQ] = ACTIONS(1688),
    [anon_sym_AMP_AMP] = ACTIONS(1688),
    [anon_sym_AMP_EQ] = ACTIONS(1688),
    [anon_sym_PERCENT] = ACTIONS(4421),
    [anon_sym_PERCENT_EQ] = ACTIONS(1688),
    [anon_sym_CARET] = ACTIONS(4421),
    [anon_sym_CARET_EQ] = ACTIONS(1688),
    [anon_sym_PLUS_EQ] = ACTIONS(1688),
    [anon_sym_LT] = ACTIONS(4421),
    [anon_sym_LT_LT] = ACTIONS(4421),
    [anon_sym_LT_LT_EQ] = ACTIONS(1688),
    [anon_sym_LT_EQ] = ACTIONS(1688),
    [anon_sym_EQ] = ACTIONS(4421),
    [anon_sym_EQ_EQ] = ACTIONS(1688),
    [anon_sym_GT] = ACTIONS(4421),
    [anon_sym_GT_EQ] = ACTIONS(1688),
    [anon_sym_GT_GT] = ACTIONS(4421),
    [anon_sym_GT_GT_EQ] = ACTIONS(1688),
    [anon_sym_PIPE] = ACTIONS(4421),
    [anon_sym_PIPE_EQ] = ACTIONS(1688),
    [anon_sym_PIPE_PIPE] = ACTIONS(1688),
    [anon_sym_QMARK] = ACTIONS(1688),
    [anon_sym_DOT_DOT] = ACTIONS(4421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1688),
    [anon_sym_as] = ACTIONS(1688),
    [sym_line_comment] = ACTIONS(7),
  },
  [3457] = {
    [aux_sym_tuple_type_repeat1] = STATE(3589),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7717),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_COMMA] = ACTIONS(7719),
    [sym_line_comment] = ACTIONS(7),
  },
  [3458] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7721),
    [anon_sym_RBRACK] = ACTIONS(7723),
    [anon_sym_PLUS] = ACTIONS(1718),
    [sym_line_comment] = ACTIONS(7),
  },
  [3459] = {
    [sym_function_modifiers] = STATE(3246),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3592),
    [sym_bracketed_type] = STATE(3244),
    [sym_lifetime] = STATE(3248),
    [sym_array_type] = STATE(3592),
    [sym_function_type] = STATE(3592),
    [sym_tuple_type] = STATE(3592),
    [sym_unit_type] = STATE(3592),
    [sym_generic_type] = STATE(3249),
    [sym_generic_type_with_turbofish] = STATE(3250),
    [sym_bounded_type] = STATE(3592),
    [sym_reference_type] = STATE(3592),
    [sym_pointer_type] = STATE(3592),
    [sym_empty_type] = STATE(3592),
    [sym_dynamic_type] = STATE(3592),
    [sym_macro_invocation] = STATE(3592),
    [sym_scoped_identifier] = STATE(3251),
    [sym_scoped_type_identifier] = STATE(3252),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7059),
    [anon_sym_LBRACK] = ACTIONS(7061),
    [anon_sym_STAR] = ACTIONS(7063),
    [anon_sym_u8] = ACTIONS(7065),
    [anon_sym_i8] = ACTIONS(7065),
    [anon_sym_u16] = ACTIONS(7065),
    [anon_sym_i16] = ACTIONS(7065),
    [anon_sym_u32] = ACTIONS(7065),
    [anon_sym_i32] = ACTIONS(7065),
    [anon_sym_u64] = ACTIONS(7065),
    [anon_sym_i64] = ACTIONS(7065),
    [anon_sym_u128] = ACTIONS(7065),
    [anon_sym_i128] = ACTIONS(7065),
    [anon_sym_isize] = ACTIONS(7065),
    [anon_sym_usize] = ACTIONS(7065),
    [anon_sym_f32] = ACTIONS(7065),
    [anon_sym_f64] = ACTIONS(7065),
    [anon_sym_bool] = ACTIONS(7065),
    [anon_sym_str] = ACTIONS(7065),
    [anon_sym_char] = ACTIONS(7065),
    [anon_sym_AMP] = ACTIONS(7067),
    [anon_sym_COLON_COLON] = ACTIONS(7069),
    [anon_sym_BANG] = ACTIONS(7071),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(7073),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(7075),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7077),
    [sym_self] = ACTIONS(7079),
    [sym_super] = ACTIONS(7079),
    [sym_crate] = ACTIONS(7079),
    [sym_metavariable] = ACTIONS(7081),
  },
  [3460] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7725),
  },
  [3461] = {
    [sym_function_modifiers] = STATE(3246),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3594),
    [sym_bracketed_type] = STATE(3244),
    [sym_lifetime] = STATE(3248),
    [sym_array_type] = STATE(3594),
    [sym_function_type] = STATE(3594),
    [sym_tuple_type] = STATE(3594),
    [sym_unit_type] = STATE(3594),
    [sym_generic_type] = STATE(3249),
    [sym_generic_type_with_turbofish] = STATE(3250),
    [sym_bounded_type] = STATE(3594),
    [sym_reference_type] = STATE(3594),
    [sym_pointer_type] = STATE(3594),
    [sym_empty_type] = STATE(3594),
    [sym_dynamic_type] = STATE(3594),
    [sym_macro_invocation] = STATE(3594),
    [sym_scoped_identifier] = STATE(3251),
    [sym_scoped_type_identifier] = STATE(3252),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7059),
    [anon_sym_LBRACK] = ACTIONS(7061),
    [anon_sym_STAR] = ACTIONS(7063),
    [anon_sym_u8] = ACTIONS(7065),
    [anon_sym_i8] = ACTIONS(7065),
    [anon_sym_u16] = ACTIONS(7065),
    [anon_sym_i16] = ACTIONS(7065),
    [anon_sym_u32] = ACTIONS(7065),
    [anon_sym_i32] = ACTIONS(7065),
    [anon_sym_u64] = ACTIONS(7065),
    [anon_sym_i64] = ACTIONS(7065),
    [anon_sym_u128] = ACTIONS(7065),
    [anon_sym_i128] = ACTIONS(7065),
    [anon_sym_isize] = ACTIONS(7065),
    [anon_sym_usize] = ACTIONS(7065),
    [anon_sym_f32] = ACTIONS(7065),
    [anon_sym_f64] = ACTIONS(7065),
    [anon_sym_bool] = ACTIONS(7065),
    [anon_sym_str] = ACTIONS(7065),
    [anon_sym_char] = ACTIONS(7065),
    [anon_sym_AMP] = ACTIONS(7067),
    [anon_sym_COLON_COLON] = ACTIONS(7069),
    [anon_sym_BANG] = ACTIONS(7071),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(7073),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(7075),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7077),
    [sym_self] = ACTIONS(7079),
    [sym_super] = ACTIONS(7079),
    [sym_crate] = ACTIONS(7079),
    [sym_metavariable] = ACTIONS(7081),
  },
  [3462] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1724),
    [anon_sym_EQ_GT] = ACTIONS(1724),
    [anon_sym_LBRACK] = ACTIONS(1724),
    [anon_sym_PLUS] = ACTIONS(4433),
    [anon_sym_STAR] = ACTIONS(4433),
    [anon_sym_AMP] = ACTIONS(4433),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_DOT] = ACTIONS(4433),
    [anon_sym_DASH_EQ] = ACTIONS(1724),
    [anon_sym_BANG_EQ] = ACTIONS(1724),
    [anon_sym_STAR_EQ] = ACTIONS(1724),
    [anon_sym_SLASH] = ACTIONS(4433),
    [anon_sym_SLASH_EQ] = ACTIONS(1724),
    [anon_sym_AMP_AMP] = ACTIONS(1724),
    [anon_sym_AMP_EQ] = ACTIONS(1724),
    [anon_sym_PERCENT] = ACTIONS(4433),
    [anon_sym_PERCENT_EQ] = ACTIONS(1724),
    [anon_sym_CARET] = ACTIONS(4433),
    [anon_sym_CARET_EQ] = ACTIONS(1724),
    [anon_sym_PLUS_EQ] = ACTIONS(1724),
    [anon_sym_LT] = ACTIONS(4433),
    [anon_sym_LT_LT] = ACTIONS(4433),
    [anon_sym_LT_LT_EQ] = ACTIONS(1724),
    [anon_sym_LT_EQ] = ACTIONS(1724),
    [anon_sym_EQ] = ACTIONS(4433),
    [anon_sym_EQ_EQ] = ACTIONS(1724),
    [anon_sym_GT] = ACTIONS(4433),
    [anon_sym_GT_EQ] = ACTIONS(1724),
    [anon_sym_GT_GT] = ACTIONS(4433),
    [anon_sym_GT_GT_EQ] = ACTIONS(1724),
    [anon_sym_PIPE] = ACTIONS(4433),
    [anon_sym_PIPE_EQ] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1724),
    [anon_sym_QMARK] = ACTIONS(1724),
    [anon_sym_DOT_DOT] = ACTIONS(4433),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1724),
    [anon_sym_as] = ACTIONS(1724),
    [sym_line_comment] = ACTIONS(7),
  },
  [3463] = {
    [sym_function_modifiers] = STATE(3246),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3594),
    [sym_bracketed_type] = STATE(3244),
    [sym_lifetime] = STATE(3248),
    [sym_array_type] = STATE(3594),
    [sym_function_type] = STATE(3594),
    [sym_tuple_type] = STATE(3594),
    [sym_unit_type] = STATE(3594),
    [sym_generic_type] = STATE(3249),
    [sym_generic_type_with_turbofish] = STATE(3250),
    [sym_bounded_type] = STATE(3594),
    [sym_reference_type] = STATE(3594),
    [sym_pointer_type] = STATE(3594),
    [sym_empty_type] = STATE(3594),
    [sym_dynamic_type] = STATE(3594),
    [sym_macro_invocation] = STATE(3594),
    [sym_scoped_identifier] = STATE(3251),
    [sym_scoped_type_identifier] = STATE(3252),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7059),
    [anon_sym_LBRACK] = ACTIONS(7061),
    [anon_sym_PLUS] = ACTIONS(7493),
    [anon_sym_STAR] = ACTIONS(7063),
    [anon_sym_u8] = ACTIONS(7065),
    [anon_sym_i8] = ACTIONS(7065),
    [anon_sym_u16] = ACTIONS(7065),
    [anon_sym_i16] = ACTIONS(7065),
    [anon_sym_u32] = ACTIONS(7065),
    [anon_sym_i32] = ACTIONS(7065),
    [anon_sym_u64] = ACTIONS(7065),
    [anon_sym_i64] = ACTIONS(7065),
    [anon_sym_u128] = ACTIONS(7065),
    [anon_sym_i128] = ACTIONS(7065),
    [anon_sym_isize] = ACTIONS(7065),
    [anon_sym_usize] = ACTIONS(7065),
    [anon_sym_f32] = ACTIONS(7065),
    [anon_sym_f64] = ACTIONS(7065),
    [anon_sym_bool] = ACTIONS(7065),
    [anon_sym_str] = ACTIONS(7065),
    [anon_sym_char] = ACTIONS(7065),
    [anon_sym_AMP] = ACTIONS(7067),
    [anon_sym_COLON_COLON] = ACTIONS(7069),
    [anon_sym_BANG] = ACTIONS(7071),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(7073),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(7075),
    [sym_mutable_specifier] = ACTIONS(7727),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7077),
    [sym_self] = ACTIONS(7079),
    [sym_super] = ACTIONS(7079),
    [sym_crate] = ACTIONS(7079),
    [sym_metavariable] = ACTIONS(7081),
  },
  [3464] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1728),
    [anon_sym_EQ_GT] = ACTIONS(1728),
    [anon_sym_LBRACK] = ACTIONS(1728),
    [anon_sym_PLUS] = ACTIONS(1730),
    [anon_sym_STAR] = ACTIONS(1730),
    [anon_sym_AMP] = ACTIONS(1730),
    [anon_sym_DASH] = ACTIONS(1730),
    [anon_sym_DOT] = ACTIONS(1730),
    [anon_sym_DASH_EQ] = ACTIONS(1728),
    [anon_sym_COLON_COLON] = ACTIONS(721),
    [anon_sym_BANG_EQ] = ACTIONS(1728),
    [anon_sym_STAR_EQ] = ACTIONS(1728),
    [anon_sym_SLASH] = ACTIONS(1730),
    [anon_sym_SLASH_EQ] = ACTIONS(1728),
    [anon_sym_AMP_AMP] = ACTIONS(1728),
    [anon_sym_AMP_EQ] = ACTIONS(1728),
    [anon_sym_PERCENT] = ACTIONS(1730),
    [anon_sym_PERCENT_EQ] = ACTIONS(1728),
    [anon_sym_CARET] = ACTIONS(1730),
    [anon_sym_CARET_EQ] = ACTIONS(1728),
    [anon_sym_PLUS_EQ] = ACTIONS(1728),
    [anon_sym_LT] = ACTIONS(1730),
    [anon_sym_LT_LT] = ACTIONS(1730),
    [anon_sym_LT_LT_EQ] = ACTIONS(1728),
    [anon_sym_LT_EQ] = ACTIONS(1728),
    [anon_sym_EQ] = ACTIONS(1730),
    [anon_sym_EQ_EQ] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1730),
    [anon_sym_GT_EQ] = ACTIONS(1728),
    [anon_sym_GT_GT] = ACTIONS(1730),
    [anon_sym_GT_GT_EQ] = ACTIONS(1728),
    [anon_sym_PIPE] = ACTIONS(1730),
    [anon_sym_PIPE_EQ] = ACTIONS(1728),
    [anon_sym_PIPE_PIPE] = ACTIONS(1728),
    [anon_sym_QMARK] = ACTIONS(1728),
    [anon_sym_DOT_DOT] = ACTIONS(1730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1728),
    [anon_sym_as] = ACTIONS(1728),
    [sym_line_comment] = ACTIONS(7),
  },
  [3465] = {
    [sym_function_modifiers] = STATE(370),
    [sym_self_parameter] = STATE(3599),
    [sym_variadic_parameter] = STATE(3599),
    [sym_parameter] = STATE(3599),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3600),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(839),
    [sym_array_type] = STATE(3600),
    [sym_function_type] = STATE(3600),
    [sym_tuple_type] = STATE(3600),
    [sym_unit_type] = STATE(3600),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(3600),
    [sym_reference_type] = STATE(3600),
    [sym_pointer_type] = STATE(3600),
    [sym_empty_type] = STATE(3600),
    [sym_abstract_type] = STATE(3599),
    [sym_dynamic_type] = STATE(3600),
    [sym_macro_invocation] = STATE(3600),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [sym_reference_pattern_in_parameter] = STATE(840),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_RPAREN] = ACTIONS(7729),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(7731),
    [anon_sym_u8] = ACTIONS(1740),
    [anon_sym_i8] = ACTIONS(1740),
    [anon_sym_u16] = ACTIONS(1740),
    [anon_sym_i16] = ACTIONS(1740),
    [anon_sym_u32] = ACTIONS(1740),
    [anon_sym_i32] = ACTIONS(1740),
    [anon_sym_u64] = ACTIONS(1740),
    [anon_sym_i64] = ACTIONS(1740),
    [anon_sym_u128] = ACTIONS(1740),
    [anon_sym_i128] = ACTIONS(1740),
    [anon_sym_isize] = ACTIONS(1740),
    [anon_sym_usize] = ACTIONS(1740),
    [anon_sym_f32] = ACTIONS(1740),
    [anon_sym_f64] = ACTIONS(1740),
    [anon_sym_bool] = ACTIONS(1740),
    [anon_sym_str] = ACTIONS(1740),
    [anon_sym_char] = ACTIONS(1740),
    [anon_sym__] = ACTIONS(7733),
    [anon_sym_AMP] = ACTIONS(1744),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1746),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(1748),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_union] = ACTIONS(1752),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(1754),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1756),
    [sym_self] = ACTIONS(1758),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3466] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1760),
    [anon_sym_EQ_GT] = ACTIONS(1760),
    [anon_sym_LBRACK] = ACTIONS(1760),
    [anon_sym_PLUS] = ACTIONS(4443),
    [anon_sym_STAR] = ACTIONS(4443),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_DASH] = ACTIONS(4443),
    [anon_sym_DOT] = ACTIONS(4443),
    [anon_sym_DASH_EQ] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(7735),
    [anon_sym_BANG_EQ] = ACTIONS(1760),
    [anon_sym_STAR_EQ] = ACTIONS(1760),
    [anon_sym_SLASH] = ACTIONS(4443),
    [anon_sym_SLASH_EQ] = ACTIONS(1760),
    [anon_sym_AMP_AMP] = ACTIONS(1760),
    [anon_sym_AMP_EQ] = ACTIONS(1760),
    [anon_sym_PERCENT] = ACTIONS(4443),
    [anon_sym_PERCENT_EQ] = ACTIONS(1760),
    [anon_sym_CARET] = ACTIONS(4443),
    [anon_sym_CARET_EQ] = ACTIONS(1760),
    [anon_sym_PLUS_EQ] = ACTIONS(1760),
    [anon_sym_LT] = ACTIONS(4443),
    [anon_sym_LT_LT] = ACTIONS(4443),
    [anon_sym_LT_LT_EQ] = ACTIONS(1760),
    [anon_sym_LT_EQ] = ACTIONS(1760),
    [anon_sym_EQ] = ACTIONS(4443),
    [anon_sym_EQ_EQ] = ACTIONS(1760),
    [anon_sym_GT] = ACTIONS(4443),
    [anon_sym_GT_EQ] = ACTIONS(1760),
    [anon_sym_GT_GT] = ACTIONS(4443),
    [anon_sym_GT_GT_EQ] = ACTIONS(1760),
    [anon_sym_PIPE] = ACTIONS(4443),
    [anon_sym_PIPE_EQ] = ACTIONS(1760),
    [anon_sym_PIPE_PIPE] = ACTIONS(1760),
    [anon_sym_QMARK] = ACTIONS(1760),
    [anon_sym_DOT_DOT] = ACTIONS(4443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1760),
    [anon_sym_as] = ACTIONS(1760),
    [sym_line_comment] = ACTIONS(7),
  },
  [3467] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COLON_COLON] = ACTIONS(7469),
    [sym_line_comment] = ACTIONS(7),
  },
  [3468] = {
    [sym_type_arguments] = STATE(3473),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1770),
    [anon_sym_EQ_GT] = ACTIONS(1770),
    [anon_sym_LBRACK] = ACTIONS(1770),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_STAR] = ACTIONS(1772),
    [anon_sym_AMP] = ACTIONS(1772),
    [anon_sym_DASH] = ACTIONS(1772),
    [anon_sym_DOT] = ACTIONS(1772),
    [anon_sym_DASH_EQ] = ACTIONS(1770),
    [anon_sym_COLON_COLON] = ACTIONS(7483),
    [anon_sym_BANG_EQ] = ACTIONS(1770),
    [anon_sym_STAR_EQ] = ACTIONS(1770),
    [anon_sym_SLASH] = ACTIONS(1772),
    [anon_sym_SLASH_EQ] = ACTIONS(1770),
    [anon_sym_AMP_AMP] = ACTIONS(1770),
    [anon_sym_AMP_EQ] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1772),
    [anon_sym_PERCENT_EQ] = ACTIONS(1770),
    [anon_sym_CARET] = ACTIONS(1772),
    [anon_sym_CARET_EQ] = ACTIONS(1770),
    [anon_sym_PLUS_EQ] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(7485),
    [anon_sym_LT_LT] = ACTIONS(1772),
    [anon_sym_LT_LT_EQ] = ACTIONS(1770),
    [anon_sym_LT_EQ] = ACTIONS(1770),
    [anon_sym_EQ] = ACTIONS(1772),
    [anon_sym_EQ_EQ] = ACTIONS(1770),
    [anon_sym_GT] = ACTIONS(1772),
    [anon_sym_GT_EQ] = ACTIONS(1770),
    [anon_sym_GT_GT] = ACTIONS(1772),
    [anon_sym_GT_GT_EQ] = ACTIONS(1770),
    [anon_sym_PIPE] = ACTIONS(1772),
    [anon_sym_PIPE_EQ] = ACTIONS(1770),
    [anon_sym_PIPE_PIPE] = ACTIONS(1770),
    [anon_sym_QMARK] = ACTIONS(1770),
    [anon_sym_DOT_DOT] = ACTIONS(1772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1770),
    [anon_sym_as] = ACTIONS(1770),
    [sym_line_comment] = ACTIONS(7),
  },
  [3469] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1774),
    [anon_sym_EQ_GT] = ACTIONS(1774),
    [anon_sym_LBRACK] = ACTIONS(1774),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_STAR] = ACTIONS(1776),
    [anon_sym_AMP] = ACTIONS(1776),
    [anon_sym_DASH] = ACTIONS(1776),
    [anon_sym_DOT] = ACTIONS(1776),
    [anon_sym_DASH_EQ] = ACTIONS(1774),
    [anon_sym_COLON_COLON] = ACTIONS(7495),
    [anon_sym_BANG_EQ] = ACTIONS(1774),
    [anon_sym_STAR_EQ] = ACTIONS(1774),
    [anon_sym_SLASH] = ACTIONS(1776),
    [anon_sym_SLASH_EQ] = ACTIONS(1774),
    [anon_sym_AMP_AMP] = ACTIONS(1774),
    [anon_sym_AMP_EQ] = ACTIONS(1774),
    [anon_sym_PERCENT] = ACTIONS(1776),
    [anon_sym_PERCENT_EQ] = ACTIONS(1774),
    [anon_sym_CARET] = ACTIONS(1776),
    [anon_sym_CARET_EQ] = ACTIONS(1774),
    [anon_sym_PLUS_EQ] = ACTIONS(1774),
    [anon_sym_LT] = ACTIONS(1776),
    [anon_sym_LT_LT] = ACTIONS(1776),
    [anon_sym_LT_LT_EQ] = ACTIONS(1774),
    [anon_sym_LT_EQ] = ACTIONS(1774),
    [anon_sym_EQ] = ACTIONS(1776),
    [anon_sym_EQ_EQ] = ACTIONS(1774),
    [anon_sym_GT] = ACTIONS(1776),
    [anon_sym_GT_EQ] = ACTIONS(1774),
    [anon_sym_GT_GT] = ACTIONS(1776),
    [anon_sym_GT_GT_EQ] = ACTIONS(1774),
    [anon_sym_PIPE] = ACTIONS(1776),
    [anon_sym_PIPE_EQ] = ACTIONS(1774),
    [anon_sym_PIPE_PIPE] = ACTIONS(1774),
    [anon_sym_QMARK] = ACTIONS(1774),
    [anon_sym_DOT_DOT] = ACTIONS(1776),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1774),
    [anon_sym_as] = ACTIONS(1774),
    [sym_line_comment] = ACTIONS(7),
  },
  [3470] = {
    [sym_type_arguments] = STATE(3483),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1774),
    [anon_sym_EQ_GT] = ACTIONS(1774),
    [anon_sym_LBRACK] = ACTIONS(1774),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_STAR] = ACTIONS(1776),
    [anon_sym_AMP] = ACTIONS(1776),
    [anon_sym_DASH] = ACTIONS(1776),
    [anon_sym_DOT] = ACTIONS(1776),
    [anon_sym_DASH_EQ] = ACTIONS(1774),
    [anon_sym_BANG_EQ] = ACTIONS(1774),
    [anon_sym_STAR_EQ] = ACTIONS(1774),
    [anon_sym_SLASH] = ACTIONS(1776),
    [anon_sym_SLASH_EQ] = ACTIONS(1774),
    [anon_sym_AMP_AMP] = ACTIONS(1774),
    [anon_sym_AMP_EQ] = ACTIONS(1774),
    [anon_sym_PERCENT] = ACTIONS(1776),
    [anon_sym_PERCENT_EQ] = ACTIONS(1774),
    [anon_sym_CARET] = ACTIONS(1776),
    [anon_sym_CARET_EQ] = ACTIONS(1774),
    [anon_sym_PLUS_EQ] = ACTIONS(1774),
    [anon_sym_LT] = ACTIONS(7485),
    [anon_sym_LT_LT] = ACTIONS(1776),
    [anon_sym_LT_LT_EQ] = ACTIONS(1774),
    [anon_sym_LT_EQ] = ACTIONS(1774),
    [anon_sym_EQ] = ACTIONS(1776),
    [anon_sym_EQ_EQ] = ACTIONS(1774),
    [anon_sym_GT] = ACTIONS(1776),
    [anon_sym_GT_EQ] = ACTIONS(1774),
    [anon_sym_GT_GT] = ACTIONS(1776),
    [anon_sym_GT_GT_EQ] = ACTIONS(1774),
    [anon_sym_PIPE] = ACTIONS(1776),
    [anon_sym_PIPE_EQ] = ACTIONS(1774),
    [anon_sym_PIPE_PIPE] = ACTIONS(1774),
    [anon_sym_QMARK] = ACTIONS(1774),
    [anon_sym_DOT_DOT] = ACTIONS(1776),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1774),
    [anon_sym_as] = ACTIONS(1774),
    [sym_line_comment] = ACTIONS(7),
  },
  [3471] = {
    [sym_type_arguments] = STATE(845),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7737),
  },
  [3472] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1794),
    [anon_sym_EQ_GT] = ACTIONS(1794),
    [anon_sym_LBRACK] = ACTIONS(1794),
    [anon_sym_PLUS] = ACTIONS(4449),
    [anon_sym_STAR] = ACTIONS(4449),
    [anon_sym_AMP] = ACTIONS(4449),
    [anon_sym_DASH] = ACTIONS(4449),
    [anon_sym_DOT] = ACTIONS(4449),
    [anon_sym_DASH_EQ] = ACTIONS(1794),
    [anon_sym_DASH_GT] = ACTIONS(7739),
    [anon_sym_BANG_EQ] = ACTIONS(1794),
    [anon_sym_STAR_EQ] = ACTIONS(1794),
    [anon_sym_SLASH] = ACTIONS(4449),
    [anon_sym_SLASH_EQ] = ACTIONS(1794),
    [anon_sym_AMP_AMP] = ACTIONS(1794),
    [anon_sym_AMP_EQ] = ACTIONS(1794),
    [anon_sym_PERCENT] = ACTIONS(4449),
    [anon_sym_PERCENT_EQ] = ACTIONS(1794),
    [anon_sym_CARET] = ACTIONS(4449),
    [anon_sym_CARET_EQ] = ACTIONS(1794),
    [anon_sym_PLUS_EQ] = ACTIONS(1794),
    [anon_sym_LT] = ACTIONS(4449),
    [anon_sym_LT_LT] = ACTIONS(4449),
    [anon_sym_LT_LT_EQ] = ACTIONS(1794),
    [anon_sym_LT_EQ] = ACTIONS(1794),
    [anon_sym_EQ] = ACTIONS(4449),
    [anon_sym_EQ_EQ] = ACTIONS(1794),
    [anon_sym_GT] = ACTIONS(4449),
    [anon_sym_GT_EQ] = ACTIONS(1794),
    [anon_sym_GT_GT] = ACTIONS(4449),
    [anon_sym_GT_GT_EQ] = ACTIONS(1794),
    [anon_sym_PIPE] = ACTIONS(4449),
    [anon_sym_PIPE_EQ] = ACTIONS(1794),
    [anon_sym_PIPE_PIPE] = ACTIONS(1794),
    [anon_sym_QMARK] = ACTIONS(1794),
    [anon_sym_DOT_DOT] = ACTIONS(4449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1794),
    [anon_sym_as] = ACTIONS(1794),
    [sym_line_comment] = ACTIONS(7),
  },
  [3473] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1798),
    [anon_sym_EQ_GT] = ACTIONS(1798),
    [anon_sym_LBRACK] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1800),
    [anon_sym_STAR] = ACTIONS(1800),
    [anon_sym_AMP] = ACTIONS(1800),
    [anon_sym_DASH] = ACTIONS(1800),
    [anon_sym_DOT] = ACTIONS(1800),
    [anon_sym_DASH_EQ] = ACTIONS(1798),
    [anon_sym_COLON_COLON] = ACTIONS(1798),
    [anon_sym_BANG_EQ] = ACTIONS(1798),
    [anon_sym_STAR_EQ] = ACTIONS(1798),
    [anon_sym_SLASH] = ACTIONS(1800),
    [anon_sym_SLASH_EQ] = ACTIONS(1798),
    [anon_sym_AMP_AMP] = ACTIONS(1798),
    [anon_sym_AMP_EQ] = ACTIONS(1798),
    [anon_sym_PERCENT] = ACTIONS(1800),
    [anon_sym_PERCENT_EQ] = ACTIONS(1798),
    [anon_sym_CARET] = ACTIONS(1800),
    [anon_sym_CARET_EQ] = ACTIONS(1798),
    [anon_sym_PLUS_EQ] = ACTIONS(1798),
    [anon_sym_LT] = ACTIONS(1800),
    [anon_sym_LT_LT] = ACTIONS(1800),
    [anon_sym_LT_LT_EQ] = ACTIONS(1798),
    [anon_sym_LT_EQ] = ACTIONS(1798),
    [anon_sym_EQ] = ACTIONS(1800),
    [anon_sym_EQ_EQ] = ACTIONS(1798),
    [anon_sym_GT] = ACTIONS(1800),
    [anon_sym_GT_EQ] = ACTIONS(1798),
    [anon_sym_GT_GT] = ACTIONS(1800),
    [anon_sym_GT_GT_EQ] = ACTIONS(1798),
    [anon_sym_PIPE] = ACTIONS(1800),
    [anon_sym_PIPE_EQ] = ACTIONS(1798),
    [anon_sym_PIPE_PIPE] = ACTIONS(1798),
    [anon_sym_QMARK] = ACTIONS(1798),
    [anon_sym_DOT_DOT] = ACTIONS(1800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1798),
    [anon_sym_as] = ACTIONS(1798),
    [sym_line_comment] = ACTIONS(7),
  },
  [3474] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7737),
  },
  [3475] = {
    [sym_parameters] = STATE(3604),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7475),
    [sym_line_comment] = ACTIONS(7),
  },
  [3476] = {
    [sym_parameters] = STATE(3605),
    [sym_type_arguments] = STATE(400),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7475),
    [anon_sym_COLON_COLON] = ACTIONS(775),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [3477] = {
    [sym_parameters] = STATE(3604),
    [sym_type_arguments] = STATE(412),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7475),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
  },
  [3478] = {
    [sym_function_modifiers] = STATE(3246),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3607),
    [sym_bracketed_type] = STATE(3244),
    [sym_lifetime] = STATE(3607),
    [sym_array_type] = STATE(3607),
    [sym_function_type] = STATE(3607),
    [sym_tuple_type] = STATE(3607),
    [sym_unit_type] = STATE(3607),
    [sym_generic_type] = STATE(3249),
    [sym_generic_type_with_turbofish] = STATE(3250),
    [sym_bounded_type] = STATE(3607),
    [sym_reference_type] = STATE(3607),
    [sym_pointer_type] = STATE(3607),
    [sym_empty_type] = STATE(3607),
    [sym_dynamic_type] = STATE(3607),
    [sym_macro_invocation] = STATE(3607),
    [sym_scoped_identifier] = STATE(3251),
    [sym_scoped_type_identifier] = STATE(3252),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7059),
    [anon_sym_LBRACK] = ACTIONS(7061),
    [anon_sym_STAR] = ACTIONS(7063),
    [anon_sym_u8] = ACTIONS(7065),
    [anon_sym_i8] = ACTIONS(7065),
    [anon_sym_u16] = ACTIONS(7065),
    [anon_sym_i16] = ACTIONS(7065),
    [anon_sym_u32] = ACTIONS(7065),
    [anon_sym_i32] = ACTIONS(7065),
    [anon_sym_u64] = ACTIONS(7065),
    [anon_sym_i64] = ACTIONS(7065),
    [anon_sym_u128] = ACTIONS(7065),
    [anon_sym_i128] = ACTIONS(7065),
    [anon_sym_isize] = ACTIONS(7065),
    [anon_sym_usize] = ACTIONS(7065),
    [anon_sym_f32] = ACTIONS(7065),
    [anon_sym_f64] = ACTIONS(7065),
    [anon_sym_bool] = ACTIONS(7065),
    [anon_sym_str] = ACTIONS(7065),
    [anon_sym_char] = ACTIONS(7065),
    [anon_sym_AMP] = ACTIONS(7067),
    [anon_sym_COLON_COLON] = ACTIONS(7069),
    [anon_sym_BANG] = ACTIONS(7071),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(7741),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(7073),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(7075),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7077),
    [sym_self] = ACTIONS(7079),
    [sym_super] = ACTIONS(7079),
    [sym_crate] = ACTIONS(7079),
    [sym_metavariable] = ACTIONS(7081),
  },
  [3479] = {
    [sym_function_modifiers] = STATE(3246),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3607),
    [sym_bracketed_type] = STATE(3244),
    [sym_lifetime] = STATE(3248),
    [sym_array_type] = STATE(3607),
    [sym_function_type] = STATE(3607),
    [sym_tuple_type] = STATE(3607),
    [sym_unit_type] = STATE(3607),
    [sym_generic_type] = STATE(3249),
    [sym_generic_type_with_turbofish] = STATE(3250),
    [sym_bounded_type] = STATE(3607),
    [sym_reference_type] = STATE(3607),
    [sym_pointer_type] = STATE(3607),
    [sym_empty_type] = STATE(3607),
    [sym_dynamic_type] = STATE(3607),
    [sym_macro_invocation] = STATE(3607),
    [sym_scoped_identifier] = STATE(3251),
    [sym_scoped_type_identifier] = STATE(3252),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7059),
    [anon_sym_LBRACK] = ACTIONS(7061),
    [anon_sym_STAR] = ACTIONS(7063),
    [anon_sym_u8] = ACTIONS(7065),
    [anon_sym_i8] = ACTIONS(7065),
    [anon_sym_u16] = ACTIONS(7065),
    [anon_sym_i16] = ACTIONS(7065),
    [anon_sym_u32] = ACTIONS(7065),
    [anon_sym_i32] = ACTIONS(7065),
    [anon_sym_u64] = ACTIONS(7065),
    [anon_sym_i64] = ACTIONS(7065),
    [anon_sym_u128] = ACTIONS(7065),
    [anon_sym_i128] = ACTIONS(7065),
    [anon_sym_isize] = ACTIONS(7065),
    [anon_sym_usize] = ACTIONS(7065),
    [anon_sym_f32] = ACTIONS(7065),
    [anon_sym_f64] = ACTIONS(7065),
    [anon_sym_bool] = ACTIONS(7065),
    [anon_sym_str] = ACTIONS(7065),
    [anon_sym_char] = ACTIONS(7065),
    [anon_sym_AMP] = ACTIONS(7067),
    [anon_sym_COLON_COLON] = ACTIONS(7069),
    [anon_sym_BANG] = ACTIONS(7071),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(7073),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(7075),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7077),
    [sym_self] = ACTIONS(7079),
    [sym_super] = ACTIONS(7079),
    [sym_crate] = ACTIONS(7079),
    [sym_metavariable] = ACTIONS(7081),
  },
  [3480] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7743),
  },
  [3481] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7745),
  },
  [3482] = {
    [sym_type_arguments] = STATE(873),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(779),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7737),
  },
  [3483] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1816),
    [anon_sym_EQ_GT] = ACTIONS(1816),
    [anon_sym_LBRACK] = ACTIONS(1816),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_STAR] = ACTIONS(1818),
    [anon_sym_AMP] = ACTIONS(1818),
    [anon_sym_DASH] = ACTIONS(1818),
    [anon_sym_DOT] = ACTIONS(1818),
    [anon_sym_DASH_EQ] = ACTIONS(1816),
    [anon_sym_COLON_COLON] = ACTIONS(1816),
    [anon_sym_BANG_EQ] = ACTIONS(1816),
    [anon_sym_STAR_EQ] = ACTIONS(1816),
    [anon_sym_SLASH] = ACTIONS(1818),
    [anon_sym_SLASH_EQ] = ACTIONS(1816),
    [anon_sym_AMP_AMP] = ACTIONS(1816),
    [anon_sym_AMP_EQ] = ACTIONS(1816),
    [anon_sym_PERCENT] = ACTIONS(1818),
    [anon_sym_PERCENT_EQ] = ACTIONS(1816),
    [anon_sym_CARET] = ACTIONS(1818),
    [anon_sym_CARET_EQ] = ACTIONS(1816),
    [anon_sym_PLUS_EQ] = ACTIONS(1816),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_LT_LT] = ACTIONS(1818),
    [anon_sym_LT_LT_EQ] = ACTIONS(1816),
    [anon_sym_LT_EQ] = ACTIONS(1816),
    [anon_sym_EQ] = ACTIONS(1818),
    [anon_sym_EQ_EQ] = ACTIONS(1816),
    [anon_sym_GT] = ACTIONS(1818),
    [anon_sym_GT_EQ] = ACTIONS(1816),
    [anon_sym_GT_GT] = ACTIONS(1818),
    [anon_sym_GT_GT_EQ] = ACTIONS(1816),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_PIPE_EQ] = ACTIONS(1816),
    [anon_sym_PIPE_PIPE] = ACTIONS(1816),
    [anon_sym_QMARK] = ACTIONS(1816),
    [anon_sym_DOT_DOT] = ACTIONS(1818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1816),
    [anon_sym_as] = ACTIONS(1816),
    [sym_line_comment] = ACTIONS(7),
  },
  [3484] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(4465),
    [anon_sym_EQ_GT] = ACTIONS(4465),
    [anon_sym_LBRACK] = ACTIONS(4465),
    [anon_sym_PLUS] = ACTIONS(4467),
    [anon_sym_STAR] = ACTIONS(4467),
    [anon_sym_AMP] = ACTIONS(4467),
    [anon_sym_DASH] = ACTIONS(4467),
    [anon_sym_DOT] = ACTIONS(4467),
    [anon_sym_DASH_EQ] = ACTIONS(4465),
    [anon_sym_BANG_EQ] = ACTIONS(4465),
    [anon_sym_STAR_EQ] = ACTIONS(4465),
    [anon_sym_SLASH] = ACTIONS(4467),
    [anon_sym_SLASH_EQ] = ACTIONS(4465),
    [anon_sym_AMP_AMP] = ACTIONS(4465),
    [anon_sym_AMP_EQ] = ACTIONS(4465),
    [anon_sym_PERCENT] = ACTIONS(4467),
    [anon_sym_PERCENT_EQ] = ACTIONS(4465),
    [anon_sym_CARET] = ACTIONS(4467),
    [anon_sym_CARET_EQ] = ACTIONS(4465),
    [anon_sym_PLUS_EQ] = ACTIONS(4465),
    [anon_sym_LT] = ACTIONS(4467),
    [anon_sym_LT_LT] = ACTIONS(4467),
    [anon_sym_LT_LT_EQ] = ACTIONS(4465),
    [anon_sym_LT_EQ] = ACTIONS(4465),
    [anon_sym_EQ] = ACTIONS(4467),
    [anon_sym_EQ_EQ] = ACTIONS(4465),
    [anon_sym_GT] = ACTIONS(4467),
    [anon_sym_GT_EQ] = ACTIONS(4465),
    [anon_sym_GT_GT] = ACTIONS(4467),
    [anon_sym_GT_GT_EQ] = ACTIONS(4465),
    [anon_sym_PIPE] = ACTIONS(4467),
    [anon_sym_PIPE_EQ] = ACTIONS(4465),
    [anon_sym_PIPE_PIPE] = ACTIONS(4465),
    [anon_sym_QMARK] = ACTIONS(4465),
    [anon_sym_DOT_DOT] = ACTIONS(4467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4465),
    [anon_sym_as] = ACTIONS(4465),
    [sym_line_comment] = ACTIONS(7),
  },
  [3485] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_in] = ACTIONS(7747),
    [sym_line_comment] = ACTIONS(7),
  },
  [3486] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(4471),
    [anon_sym_EQ_GT] = ACTIONS(4471),
    [anon_sym_LBRACK] = ACTIONS(4471),
    [anon_sym_PLUS] = ACTIONS(4473),
    [anon_sym_STAR] = ACTIONS(4473),
    [anon_sym_AMP] = ACTIONS(4473),
    [anon_sym_DASH] = ACTIONS(4473),
    [anon_sym_DOT] = ACTIONS(4473),
    [anon_sym_DASH_EQ] = ACTIONS(4471),
    [anon_sym_BANG_EQ] = ACTIONS(4471),
    [anon_sym_STAR_EQ] = ACTIONS(4471),
    [anon_sym_SLASH] = ACTIONS(4473),
    [anon_sym_SLASH_EQ] = ACTIONS(4471),
    [anon_sym_AMP_AMP] = ACTIONS(4471),
    [anon_sym_AMP_EQ] = ACTIONS(4471),
    [anon_sym_PERCENT] = ACTIONS(4473),
    [anon_sym_PERCENT_EQ] = ACTIONS(4471),
    [anon_sym_CARET] = ACTIONS(4473),
    [anon_sym_CARET_EQ] = ACTIONS(4471),
    [anon_sym_PLUS_EQ] = ACTIONS(4471),
    [anon_sym_LT] = ACTIONS(4473),
    [anon_sym_LT_LT] = ACTIONS(4473),
    [anon_sym_LT_LT_EQ] = ACTIONS(4471),
    [anon_sym_LT_EQ] = ACTIONS(4471),
    [anon_sym_EQ] = ACTIONS(4473),
    [anon_sym_EQ_EQ] = ACTIONS(4471),
    [anon_sym_GT] = ACTIONS(4473),
    [anon_sym_GT_EQ] = ACTIONS(4471),
    [anon_sym_GT_GT] = ACTIONS(4473),
    [anon_sym_GT_GT_EQ] = ACTIONS(4471),
    [anon_sym_PIPE] = ACTIONS(4473),
    [anon_sym_PIPE_EQ] = ACTIONS(4471),
    [anon_sym_PIPE_PIPE] = ACTIONS(4471),
    [anon_sym_QMARK] = ACTIONS(4471),
    [anon_sym_DOT_DOT] = ACTIONS(4473),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4471),
    [anon_sym_as] = ACTIONS(4471),
    [sym_line_comment] = ACTIONS(7),
  },
  [3487] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(3611),
    [sym_tuple_pattern] = STATE(3611),
    [sym_tuple_struct_pattern] = STATE(3611),
    [sym_struct_pattern] = STATE(3611),
    [sym_remaining_field_pattern] = STATE(3611),
    [sym_mut_pattern] = STATE(3611),
    [sym_ref_pattern] = STATE(3611),
    [sym_captured_pattern] = STATE(3611),
    [sym_reference_pattern] = STATE(3611),
    [sym__literal] = STATE(3611),
    [sym_string_literal] = STATE(3611),
    [sym_boolean_literal] = STATE(3611),
    [sym_raw_string_literal] = ACTIONS(7749),
    [sym_float_literal] = ACTIONS(7749),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(7751),
    [anon_sym_AMP] = ACTIONS(955),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(957),
    [anon_sym_ref] = ACTIONS(959),
    [sym_integer_literal] = ACTIONS(7749),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(7749),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(961),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [3488] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(3612),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [3489] = {
    [sym_bracketed_type] = STATE(147),
    [sym_generic_type] = STATE(149),
    [sym_generic_type_with_turbofish] = STATE(150),
    [sym_scoped_identifier] = STATE(151),
    [sym_scoped_type_identifier] = STATE(152),
    [sym__pattern] = STATE(3613),
    [sym_tuple_pattern] = STATE(3613),
    [sym_tuple_struct_pattern] = STATE(3613),
    [sym_struct_pattern] = STATE(3613),
    [sym_remaining_field_pattern] = STATE(3613),
    [sym_mut_pattern] = STATE(3613),
    [sym_ref_pattern] = STATE(3613),
    [sym_captured_pattern] = STATE(3613),
    [sym_reference_pattern] = STATE(3613),
    [sym__literal] = STATE(3613),
    [sym_string_literal] = STATE(3613),
    [sym_boolean_literal] = STATE(3613),
    [sym_raw_string_literal] = ACTIONS(7753),
    [sym_float_literal] = ACTIONS(7753),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_u8] = ACTIONS(289),
    [anon_sym_i8] = ACTIONS(289),
    [anon_sym_u16] = ACTIONS(289),
    [anon_sym_i16] = ACTIONS(289),
    [anon_sym_u32] = ACTIONS(289),
    [anon_sym_i32] = ACTIONS(289),
    [anon_sym_u64] = ACTIONS(289),
    [anon_sym_i64] = ACTIONS(289),
    [anon_sym_u128] = ACTIONS(289),
    [anon_sym_i128] = ACTIONS(289),
    [anon_sym_isize] = ACTIONS(289),
    [anon_sym_usize] = ACTIONS(289),
    [anon_sym_f32] = ACTIONS(289),
    [anon_sym_f64] = ACTIONS(289),
    [anon_sym_bool] = ACTIONS(289),
    [anon_sym_str] = ACTIONS(289),
    [anon_sym_char] = ACTIONS(289),
    [anon_sym__] = ACTIONS(7755),
    [anon_sym_AMP] = ACTIONS(955),
    [anon_sym_COLON_COLON] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_DOT_DOT] = ACTIONS(237),
    [sym_mutable_specifier] = ACTIONS(957),
    [anon_sym_ref] = ACTIONS(959),
    [sym_integer_literal] = ACTIONS(7753),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(7753),
    [anon_sym_true] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(247),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(961),
    [sym_self] = ACTIONS(253),
    [sym_super] = ACTIONS(253),
    [sym_crate] = ACTIONS(253),
    [sym_metavariable] = ACTIONS(255),
  },
  [3490] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(3614),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(5136),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [3491] = {
    [sym_raw_string_literal] = ACTIONS(6953),
    [sym_float_literal] = ACTIONS(6953),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6953),
    [anon_sym_u8] = ACTIONS(6957),
    [anon_sym_i8] = ACTIONS(6957),
    [anon_sym_u16] = ACTIONS(6957),
    [anon_sym_i16] = ACTIONS(6957),
    [anon_sym_u32] = ACTIONS(6957),
    [anon_sym_i32] = ACTIONS(6957),
    [anon_sym_u64] = ACTIONS(6957),
    [anon_sym_i64] = ACTIONS(6957),
    [anon_sym_u128] = ACTIONS(6957),
    [anon_sym_i128] = ACTIONS(6957),
    [anon_sym_isize] = ACTIONS(6957),
    [anon_sym_usize] = ACTIONS(6957),
    [anon_sym_f32] = ACTIONS(6957),
    [anon_sym_f64] = ACTIONS(6957),
    [anon_sym_bool] = ACTIONS(6957),
    [anon_sym_str] = ACTIONS(6957),
    [anon_sym_char] = ACTIONS(6957),
    [anon_sym__] = ACTIONS(6957),
    [anon_sym_AMP] = ACTIONS(6953),
    [anon_sym_COLON_COLON] = ACTIONS(6953),
    [anon_sym_POUND] = ACTIONS(6953),
    [anon_sym_LT] = ACTIONS(6953),
    [anon_sym_DOT_DOT] = ACTIONS(6953),
    [sym_mutable_specifier] = ACTIONS(6957),
    [anon_sym_ref] = ACTIONS(6957),
    [sym_integer_literal] = ACTIONS(6953),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6953),
    [sym_char_literal] = ACTIONS(6953),
    [anon_sym_true] = ACTIONS(6957),
    [anon_sym_false] = ACTIONS(6957),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6957),
    [sym_self] = ACTIONS(6957),
    [sym_super] = ACTIONS(6957),
    [sym_crate] = ACTIONS(6957),
    [sym_metavariable] = ACTIONS(6953),
  },
  [3492] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(5886),
    [anon_sym_STAR] = ACTIONS(5888),
    [anon_sym_COMMA] = ACTIONS(7757),
    [anon_sym_AMP] = ACTIONS(5890),
    [anon_sym_DASH] = ACTIONS(5886),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(5892),
    [anon_sym_BANG_EQ] = ACTIONS(5894),
    [anon_sym_STAR_EQ] = ACTIONS(5892),
    [anon_sym_SLASH] = ACTIONS(5888),
    [anon_sym_SLASH_EQ] = ACTIONS(5892),
    [anon_sym_AMP_AMP] = ACTIONS(5896),
    [anon_sym_AMP_EQ] = ACTIONS(5892),
    [anon_sym_PERCENT] = ACTIONS(5888),
    [anon_sym_PERCENT_EQ] = ACTIONS(5892),
    [anon_sym_CARET] = ACTIONS(5898),
    [anon_sym_CARET_EQ] = ACTIONS(5892),
    [anon_sym_PLUS_EQ] = ACTIONS(5892),
    [anon_sym_LT] = ACTIONS(5900),
    [anon_sym_LT_LT] = ACTIONS(5902),
    [anon_sym_LT_LT_EQ] = ACTIONS(5892),
    [anon_sym_LT_EQ] = ACTIONS(5894),
    [anon_sym_EQ] = ACTIONS(5904),
    [anon_sym_EQ_EQ] = ACTIONS(5894),
    [anon_sym_GT] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5894),
    [anon_sym_GT_GT] = ACTIONS(5902),
    [anon_sym_GT_GT_EQ] = ACTIONS(5892),
    [anon_sym_PIPE] = ACTIONS(5906),
    [anon_sym_PIPE_EQ] = ACTIONS(5892),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(5910),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5912),
    [anon_sym_as] = ACTIONS(5914),
    [sym_line_comment] = ACTIONS(7),
  },
  [3493] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7759),
    [anon_sym_RBRACE] = ACTIONS(7759),
    [anon_sym_COMMA] = ACTIONS(7759),
    [anon_sym_EQ] = ACTIONS(7759),
    [anon_sym_where] = ACTIONS(7759),
    [sym_line_comment] = ACTIONS(7),
  },
  [3494] = {
    [sym_function_modifiers] = STATE(2385),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2156),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2387),
    [sym_array_type] = STATE(2156),
    [sym_function_type] = STATE(2156),
    [sym_tuple_type] = STATE(2156),
    [sym_unit_type] = STATE(2156),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2156),
    [sym_reference_type] = STATE(2156),
    [sym_pointer_type] = STATE(2156),
    [sym_empty_type] = STATE(2156),
    [sym_abstract_type] = STATE(2157),
    [sym_dynamic_type] = STATE(2156),
    [sym_macro_invocation] = STATE(2156),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2388),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(5298),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(5300),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5302),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5304),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3495] = {
    [sym_function_modifiers] = STATE(2385),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2158),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2387),
    [sym_array_type] = STATE(2158),
    [sym_function_type] = STATE(2158),
    [sym_tuple_type] = STATE(2158),
    [sym_unit_type] = STATE(2158),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2158),
    [sym_reference_type] = STATE(2158),
    [sym_pointer_type] = STATE(2158),
    [sym_empty_type] = STATE(2158),
    [sym_abstract_type] = STATE(2159),
    [sym_dynamic_type] = STATE(2158),
    [sym_macro_invocation] = STATE(2158),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2388),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(5298),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(5300),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5302),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5304),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3496] = {
    [sym_function_modifiers] = STATE(2402),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2156),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2919),
    [sym_array_type] = STATE(2156),
    [sym_function_type] = STATE(2156),
    [sym_tuple_type] = STATE(2156),
    [sym_unit_type] = STATE(2156),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2156),
    [sym_reference_type] = STATE(2156),
    [sym_pointer_type] = STATE(2156),
    [sym_empty_type] = STATE(2156),
    [sym_abstract_type] = STATE(2157),
    [sym_dynamic_type] = STATE(2156),
    [sym_macro_invocation] = STATE(2156),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2405),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(5312),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(5314),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5318),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5322),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3497] = {
    [sym_function_modifiers] = STATE(2402),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2158),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2919),
    [sym_array_type] = STATE(2158),
    [sym_function_type] = STATE(2158),
    [sym_tuple_type] = STATE(2158),
    [sym_unit_type] = STATE(2158),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2158),
    [sym_reference_type] = STATE(2158),
    [sym_pointer_type] = STATE(2158),
    [sym_empty_type] = STATE(2158),
    [sym_abstract_type] = STATE(2159),
    [sym_dynamic_type] = STATE(2158),
    [sym_macro_invocation] = STATE(2158),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2405),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(5312),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(5314),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5318),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5322),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3498] = {
    [sym_function_modifiers] = STATE(2936),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(862),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2939),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(6450),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(6452),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6456),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6460),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3499] = {
    [sym_function_modifiers] = STATE(2936),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(862),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(3286),
    [sym_array_type] = STATE(862),
    [sym_function_type] = STATE(862),
    [sym_tuple_type] = STATE(862),
    [sym_unit_type] = STATE(862),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(862),
    [sym_reference_type] = STATE(862),
    [sym_pointer_type] = STATE(862),
    [sym_empty_type] = STATE(862),
    [sym_dynamic_type] = STATE(862),
    [sym_macro_invocation] = STATE(862),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2939),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(6450),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(6452),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6456),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6460),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3500] = {
    [sym_function_modifiers] = STATE(2936),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1479),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(3286),
    [sym_array_type] = STATE(1479),
    [sym_function_type] = STATE(1479),
    [sym_tuple_type] = STATE(1479),
    [sym_unit_type] = STATE(1479),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1479),
    [sym_reference_type] = STATE(1479),
    [sym_pointer_type] = STATE(1479),
    [sym_empty_type] = STATE(1479),
    [sym_dynamic_type] = STATE(1479),
    [sym_macro_invocation] = STATE(1479),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2939),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(6450),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(6452),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6456),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6460),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3501] = {
    [sym_function_modifiers] = STATE(2936),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1499),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(3286),
    [sym_array_type] = STATE(1499),
    [sym_function_type] = STATE(1499),
    [sym_tuple_type] = STATE(1499),
    [sym_unit_type] = STATE(1499),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1499),
    [sym_reference_type] = STATE(1499),
    [sym_pointer_type] = STATE(1499),
    [sym_empty_type] = STATE(1499),
    [sym_abstract_type] = STATE(1500),
    [sym_dynamic_type] = STATE(1499),
    [sym_macro_invocation] = STATE(1499),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2939),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(6450),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(6452),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6456),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6460),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3502] = {
    [sym_function_modifiers] = STATE(2936),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1525),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(3286),
    [sym_array_type] = STATE(1525),
    [sym_function_type] = STATE(1525),
    [sym_tuple_type] = STATE(1525),
    [sym_unit_type] = STATE(1525),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1525),
    [sym_reference_type] = STATE(1525),
    [sym_pointer_type] = STATE(1525),
    [sym_empty_type] = STATE(1525),
    [sym_abstract_type] = STATE(1526),
    [sym_dynamic_type] = STATE(1525),
    [sym_macro_invocation] = STATE(1525),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2939),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(6450),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(6452),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6456),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6460),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3503] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_COMMA] = ACTIONS(2988),
    [anon_sym_DASH_GT] = ACTIONS(7761),
    [sym_line_comment] = ACTIONS(7),
  },
  [3504] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_COMMA] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(7763),
    [sym_line_comment] = ACTIONS(7),
  },
  [3505] = {
    [aux_sym_trait_bounds_repeat1] = STATE(3505),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6476),
    [anon_sym_PLUS] = ACTIONS(7765),
    [anon_sym_COMMA] = ACTIONS(6476),
    [sym_line_comment] = ACTIONS(7),
  },
  [3506] = {
    [sym_else_tail] = STATE(3089),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6158),
    [anon_sym_RBRACE] = ACTIONS(6158),
    [anon_sym_LBRACK] = ACTIONS(6158),
    [anon_sym_PLUS] = ACTIONS(6160),
    [anon_sym_STAR] = ACTIONS(6160),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_AMP] = ACTIONS(6160),
    [anon_sym_DASH] = ACTIONS(6160),
    [anon_sym_DOT] = ACTIONS(6160),
    [anon_sym_DASH_EQ] = ACTIONS(6158),
    [anon_sym_BANG_EQ] = ACTIONS(6158),
    [anon_sym_STAR_EQ] = ACTIONS(6158),
    [anon_sym_SLASH] = ACTIONS(6160),
    [anon_sym_SLASH_EQ] = ACTIONS(6158),
    [anon_sym_AMP_AMP] = ACTIONS(6158),
    [anon_sym_AMP_EQ] = ACTIONS(6158),
    [anon_sym_PERCENT] = ACTIONS(6160),
    [anon_sym_PERCENT_EQ] = ACTIONS(6158),
    [anon_sym_CARET] = ACTIONS(6160),
    [anon_sym_CARET_EQ] = ACTIONS(6158),
    [anon_sym_PLUS_EQ] = ACTIONS(6158),
    [anon_sym_LT] = ACTIONS(6160),
    [anon_sym_LT_LT] = ACTIONS(6160),
    [anon_sym_LT_LT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_EQ] = ACTIONS(6160),
    [anon_sym_EQ_EQ] = ACTIONS(6158),
    [anon_sym_GT] = ACTIONS(6160),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_GT_GT] = ACTIONS(6160),
    [anon_sym_GT_GT_EQ] = ACTIONS(6158),
    [anon_sym_PIPE] = ACTIONS(6160),
    [anon_sym_PIPE_EQ] = ACTIONS(6158),
    [anon_sym_PIPE_PIPE] = ACTIONS(6158),
    [anon_sym_QMARK] = ACTIONS(6158),
    [anon_sym_DOT_DOT] = ACTIONS(6160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6158),
    [anon_sym_as] = ACTIONS(6158),
    [anon_sym_else] = ACTIONS(6514),
    [sym_line_comment] = ACTIONS(7),
  },
  [3507] = {
    [sym_function_modifiers] = STATE(2459),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3080),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(2460),
    [sym_array_type] = STATE(3080),
    [sym_function_type] = STATE(3080),
    [sym_tuple_type] = STATE(3080),
    [sym_unit_type] = STATE(3080),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(3080),
    [sym_reference_type] = STATE(3080),
    [sym_pointer_type] = STATE(3080),
    [sym_empty_type] = STATE(3080),
    [sym_abstract_type] = STATE(3081),
    [sym_dynamic_type] = STATE(3080),
    [sym_macro_invocation] = STATE(3080),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(2461),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(5429),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5431),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5433),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [3508] = {
    [sym_function_modifiers] = STATE(2459),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3082),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(2460),
    [sym_array_type] = STATE(3082),
    [sym_function_type] = STATE(3082),
    [sym_tuple_type] = STATE(3082),
    [sym_unit_type] = STATE(3082),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(3082),
    [sym_reference_type] = STATE(3082),
    [sym_pointer_type] = STATE(3082),
    [sym_empty_type] = STATE(3082),
    [sym_abstract_type] = STATE(3083),
    [sym_dynamic_type] = STATE(3082),
    [sym_macro_invocation] = STATE(3082),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(2461),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(5429),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(5431),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5433),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [3509] = {
    [sym_raw_string_literal] = ACTIONS(7226),
    [sym_float_literal] = ACTIONS(7226),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7574),
    [anon_sym_LPAREN] = ACTIONS(7574),
    [anon_sym_LBRACE] = ACTIONS(7226),
    [anon_sym_EQ_GT] = ACTIONS(7226),
    [anon_sym_LBRACK] = ACTIONS(7574),
    [anon_sym_RBRACK] = ACTIONS(7574),
    [anon_sym_COLON] = ACTIONS(7228),
    [anon_sym_DOLLAR] = ACTIONS(7228),
    [anon_sym_PLUS] = ACTIONS(7577),
    [anon_sym_STAR] = ACTIONS(7577),
    [anon_sym_COMMA] = ACTIONS(7574),
    [anon_sym_u8] = ACTIONS(7228),
    [anon_sym_i8] = ACTIONS(7228),
    [anon_sym_u16] = ACTIONS(7228),
    [anon_sym_i16] = ACTIONS(7228),
    [anon_sym_u32] = ACTIONS(7228),
    [anon_sym_i32] = ACTIONS(7228),
    [anon_sym_u64] = ACTIONS(7228),
    [anon_sym_i64] = ACTIONS(7228),
    [anon_sym_u128] = ACTIONS(7228),
    [anon_sym_i128] = ACTIONS(7228),
    [anon_sym_isize] = ACTIONS(7228),
    [anon_sym_usize] = ACTIONS(7228),
    [anon_sym_f32] = ACTIONS(7228),
    [anon_sym_f64] = ACTIONS(7228),
    [anon_sym_bool] = ACTIONS(7228),
    [anon_sym_str] = ACTIONS(7228),
    [anon_sym_char] = ACTIONS(7228),
    [anon_sym__] = ACTIONS(7228),
    [anon_sym_AMP] = ACTIONS(7577),
    [anon_sym_DASH] = ACTIONS(7577),
    [anon_sym_DOT] = ACTIONS(7577),
    [anon_sym_DASH_EQ] = ACTIONS(7574),
    [anon_sym_DASH_GT] = ACTIONS(7226),
    [anon_sym_COLON_COLON] = ACTIONS(7226),
    [anon_sym_BANG] = ACTIONS(7228),
    [anon_sym_BANG_EQ] = ACTIONS(7574),
    [anon_sym_AT] = ACTIONS(7226),
    [anon_sym_STAR_EQ] = ACTIONS(7574),
    [anon_sym_SLASH] = ACTIONS(7577),
    [anon_sym_SLASH_EQ] = ACTIONS(7574),
    [anon_sym_AMP_AMP] = ACTIONS(7574),
    [anon_sym_AMP_EQ] = ACTIONS(7574),
    [anon_sym_POUND] = ACTIONS(7226),
    [anon_sym_PERCENT] = ACTIONS(7577),
    [anon_sym_PERCENT_EQ] = ACTIONS(7574),
    [anon_sym_CARET] = ACTIONS(7577),
    [anon_sym_CARET_EQ] = ACTIONS(7574),
    [anon_sym_PLUS_EQ] = ACTIONS(7574),
    [anon_sym_LT] = ACTIONS(7577),
    [anon_sym_LT_LT] = ACTIONS(7577),
    [anon_sym_LT_LT_EQ] = ACTIONS(7574),
    [anon_sym_LT_EQ] = ACTIONS(7574),
    [anon_sym_EQ] = ACTIONS(7577),
    [anon_sym_EQ_EQ] = ACTIONS(7574),
    [anon_sym_GT] = ACTIONS(7577),
    [anon_sym_GT_EQ] = ACTIONS(7574),
    [anon_sym_GT_GT] = ACTIONS(7577),
    [anon_sym_GT_GT_EQ] = ACTIONS(7574),
    [anon_sym_PIPE] = ACTIONS(7577),
    [anon_sym_PIPE_EQ] = ACTIONS(7574),
    [anon_sym_PIPE_PIPE] = ACTIONS(7574),
    [anon_sym_TILDE] = ACTIONS(7226),
    [anon_sym_QMARK] = ACTIONS(7574),
    [anon_sym_SQUOTE] = ACTIONS(7228),
    [anon_sym_DOT_DOT] = ACTIONS(7577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7574),
    [anon_sym_as] = ACTIONS(7577),
    [anon_sym_break] = ACTIONS(7228),
    [anon_sym_const] = ACTIONS(7228),
    [anon_sym_continue] = ACTIONS(7228),
    [anon_sym_default] = ACTIONS(7228),
    [anon_sym_enum] = ACTIONS(7228),
    [anon_sym_fn] = ACTIONS(7228),
    [anon_sym_for] = ACTIONS(7228),
    [anon_sym_if] = ACTIONS(7228),
    [anon_sym_impl] = ACTIONS(7228),
    [anon_sym_let] = ACTIONS(7228),
    [anon_sym_loop] = ACTIONS(7228),
    [anon_sym_match] = ACTIONS(7228),
    [anon_sym_mod] = ACTIONS(7228),
    [anon_sym_pub] = ACTIONS(7228),
    [anon_sym_return] = ACTIONS(7228),
    [anon_sym_static] = ACTIONS(7228),
    [anon_sym_struct] = ACTIONS(7228),
    [anon_sym_trait] = ACTIONS(7228),
    [anon_sym_type] = ACTIONS(7228),
    [anon_sym_union] = ACTIONS(7228),
    [anon_sym_unsafe] = ACTIONS(7228),
    [anon_sym_use] = ACTIONS(7228),
    [anon_sym_where] = ACTIONS(7228),
    [anon_sym_while] = ACTIONS(7228),
    [sym_mutable_specifier] = ACTIONS(7228),
    [sym_integer_literal] = ACTIONS(7226),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7226),
    [sym_char_literal] = ACTIONS(7226),
    [anon_sym_true] = ACTIONS(7228),
    [anon_sym_false] = ACTIONS(7228),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7228),
    [sym_self] = ACTIONS(7228),
    [sym_super] = ACTIONS(7228),
    [sym_crate] = ACTIONS(7228),
    [sym_metavariable] = ACTIONS(7226),
  },
  [3510] = {
    [sym_raw_string_literal] = ACTIONS(7768),
    [sym_float_literal] = ACTIONS(7768),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7768),
    [anon_sym_LPAREN] = ACTIONS(7768),
    [anon_sym_RPAREN] = ACTIONS(7768),
    [anon_sym_LBRACE] = ACTIONS(7768),
    [anon_sym_RBRACE] = ACTIONS(7768),
    [anon_sym_EQ_GT] = ACTIONS(7768),
    [anon_sym_LBRACK] = ACTIONS(7768),
    [anon_sym_RBRACK] = ACTIONS(7768),
    [anon_sym_COLON] = ACTIONS(7770),
    [anon_sym_DOLLAR] = ACTIONS(7770),
    [anon_sym_PLUS] = ACTIONS(7770),
    [anon_sym_STAR] = ACTIONS(7770),
    [anon_sym_COMMA] = ACTIONS(7768),
    [anon_sym_u8] = ACTIONS(7770),
    [anon_sym_i8] = ACTIONS(7770),
    [anon_sym_u16] = ACTIONS(7770),
    [anon_sym_i16] = ACTIONS(7770),
    [anon_sym_u32] = ACTIONS(7770),
    [anon_sym_i32] = ACTIONS(7770),
    [anon_sym_u64] = ACTIONS(7770),
    [anon_sym_i64] = ACTIONS(7770),
    [anon_sym_u128] = ACTIONS(7770),
    [anon_sym_i128] = ACTIONS(7770),
    [anon_sym_isize] = ACTIONS(7770),
    [anon_sym_usize] = ACTIONS(7770),
    [anon_sym_f32] = ACTIONS(7770),
    [anon_sym_f64] = ACTIONS(7770),
    [anon_sym_bool] = ACTIONS(7770),
    [anon_sym_str] = ACTIONS(7770),
    [anon_sym_char] = ACTIONS(7770),
    [anon_sym__] = ACTIONS(7770),
    [anon_sym_AMP] = ACTIONS(7770),
    [anon_sym_DASH] = ACTIONS(7770),
    [anon_sym_DOT] = ACTIONS(7770),
    [anon_sym_DASH_EQ] = ACTIONS(7768),
    [anon_sym_DASH_GT] = ACTIONS(7768),
    [anon_sym_COLON_COLON] = ACTIONS(7768),
    [anon_sym_BANG] = ACTIONS(7770),
    [anon_sym_BANG_EQ] = ACTIONS(7768),
    [anon_sym_AT] = ACTIONS(7768),
    [anon_sym_STAR_EQ] = ACTIONS(7768),
    [anon_sym_SLASH] = ACTIONS(7770),
    [anon_sym_SLASH_EQ] = ACTIONS(7768),
    [anon_sym_AMP_AMP] = ACTIONS(7768),
    [anon_sym_AMP_EQ] = ACTIONS(7768),
    [anon_sym_POUND] = ACTIONS(7768),
    [anon_sym_PERCENT] = ACTIONS(7770),
    [anon_sym_PERCENT_EQ] = ACTIONS(7768),
    [anon_sym_CARET] = ACTIONS(7770),
    [anon_sym_CARET_EQ] = ACTIONS(7768),
    [anon_sym_PLUS_EQ] = ACTIONS(7768),
    [anon_sym_LT] = ACTIONS(7770),
    [anon_sym_LT_LT] = ACTIONS(7770),
    [anon_sym_LT_LT_EQ] = ACTIONS(7768),
    [anon_sym_LT_EQ] = ACTIONS(7768),
    [anon_sym_EQ] = ACTIONS(7770),
    [anon_sym_EQ_EQ] = ACTIONS(7768),
    [anon_sym_GT] = ACTIONS(7770),
    [anon_sym_GT_EQ] = ACTIONS(7768),
    [anon_sym_GT_GT] = ACTIONS(7770),
    [anon_sym_GT_GT_EQ] = ACTIONS(7768),
    [anon_sym_PIPE] = ACTIONS(7770),
    [anon_sym_PIPE_EQ] = ACTIONS(7768),
    [anon_sym_PIPE_PIPE] = ACTIONS(7768),
    [anon_sym_TILDE] = ACTIONS(7768),
    [anon_sym_QMARK] = ACTIONS(7768),
    [anon_sym_SQUOTE] = ACTIONS(7770),
    [anon_sym_DOT_DOT] = ACTIONS(7770),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7768),
    [anon_sym_as] = ACTIONS(7770),
    [anon_sym_break] = ACTIONS(7770),
    [anon_sym_const] = ACTIONS(7770),
    [anon_sym_continue] = ACTIONS(7770),
    [anon_sym_default] = ACTIONS(7770),
    [anon_sym_enum] = ACTIONS(7770),
    [anon_sym_fn] = ACTIONS(7770),
    [anon_sym_for] = ACTIONS(7770),
    [anon_sym_if] = ACTIONS(7770),
    [anon_sym_impl] = ACTIONS(7770),
    [anon_sym_let] = ACTIONS(7770),
    [anon_sym_loop] = ACTIONS(7770),
    [anon_sym_match] = ACTIONS(7770),
    [anon_sym_mod] = ACTIONS(7770),
    [anon_sym_pub] = ACTIONS(7770),
    [anon_sym_return] = ACTIONS(7770),
    [anon_sym_static] = ACTIONS(7770),
    [anon_sym_struct] = ACTIONS(7770),
    [anon_sym_trait] = ACTIONS(7770),
    [anon_sym_type] = ACTIONS(7770),
    [anon_sym_union] = ACTIONS(7770),
    [anon_sym_unsafe] = ACTIONS(7770),
    [anon_sym_use] = ACTIONS(7770),
    [anon_sym_where] = ACTIONS(7770),
    [anon_sym_while] = ACTIONS(7770),
    [sym_mutable_specifier] = ACTIONS(7770),
    [sym_integer_literal] = ACTIONS(7768),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7768),
    [sym_char_literal] = ACTIONS(7768),
    [anon_sym_true] = ACTIONS(7770),
    [anon_sym_false] = ACTIONS(7770),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7770),
    [sym_self] = ACTIONS(7770),
    [sym_super] = ACTIONS(7770),
    [sym_crate] = ACTIONS(7770),
    [sym_metavariable] = ACTIONS(7768),
  },
  [3511] = {
    [sym_raw_string_literal] = ACTIONS(7772),
    [sym_float_literal] = ACTIONS(7772),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(7772),
    [anon_sym_SEMI] = ACTIONS(7772),
    [anon_sym_macro_rules_BANG] = ACTIONS(7772),
    [anon_sym_LPAREN] = ACTIONS(7772),
    [anon_sym_LBRACE] = ACTIONS(7772),
    [anon_sym_RBRACE] = ACTIONS(7772),
    [anon_sym_LBRACK] = ACTIONS(7772),
    [anon_sym_STAR] = ACTIONS(7772),
    [anon_sym_u8] = ACTIONS(7774),
    [anon_sym_i8] = ACTIONS(7774),
    [anon_sym_u16] = ACTIONS(7774),
    [anon_sym_i16] = ACTIONS(7774),
    [anon_sym_u32] = ACTIONS(7774),
    [anon_sym_i32] = ACTIONS(7774),
    [anon_sym_u64] = ACTIONS(7774),
    [anon_sym_i64] = ACTIONS(7774),
    [anon_sym_u128] = ACTIONS(7774),
    [anon_sym_i128] = ACTIONS(7774),
    [anon_sym_isize] = ACTIONS(7774),
    [anon_sym_usize] = ACTIONS(7774),
    [anon_sym_f32] = ACTIONS(7774),
    [anon_sym_f64] = ACTIONS(7774),
    [anon_sym_bool] = ACTIONS(7774),
    [anon_sym_str] = ACTIONS(7774),
    [anon_sym_char] = ACTIONS(7774),
    [anon_sym_AMP] = ACTIONS(7772),
    [anon_sym_DASH] = ACTIONS(7772),
    [anon_sym_COLON_COLON] = ACTIONS(7772),
    [anon_sym_BANG] = ACTIONS(7772),
    [anon_sym_POUND] = ACTIONS(7772),
    [anon_sym_LT] = ACTIONS(7772),
    [anon_sym_PIPE] = ACTIONS(7772),
    [anon_sym_SQUOTE] = ACTIONS(7774),
    [anon_sym_DOT_DOT] = ACTIONS(7772),
    [anon_sym_break] = ACTIONS(7774),
    [anon_sym_const] = ACTIONS(7774),
    [anon_sym_continue] = ACTIONS(7774),
    [anon_sym_default] = ACTIONS(7774),
    [anon_sym_enum] = ACTIONS(7774),
    [anon_sym_fn] = ACTIONS(7774),
    [anon_sym_for] = ACTIONS(7774),
    [anon_sym_if] = ACTIONS(7774),
    [anon_sym_impl] = ACTIONS(7774),
    [anon_sym_let] = ACTIONS(7774),
    [anon_sym_loop] = ACTIONS(7774),
    [anon_sym_match] = ACTIONS(7774),
    [anon_sym_mod] = ACTIONS(7774),
    [anon_sym_pub] = ACTIONS(7774),
    [anon_sym_return] = ACTIONS(7774),
    [anon_sym_static] = ACTIONS(7774),
    [anon_sym_struct] = ACTIONS(7774),
    [anon_sym_trait] = ACTIONS(7774),
    [anon_sym_type] = ACTIONS(7774),
    [anon_sym_union] = ACTIONS(7774),
    [anon_sym_unsafe] = ACTIONS(7774),
    [anon_sym_use] = ACTIONS(7774),
    [anon_sym_while] = ACTIONS(7774),
    [anon_sym_extern] = ACTIONS(7774),
    [anon_sym_move] = ACTIONS(7774),
    [sym_integer_literal] = ACTIONS(7772),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7772),
    [sym_char_literal] = ACTIONS(7772),
    [anon_sym_true] = ACTIONS(7774),
    [anon_sym_false] = ACTIONS(7774),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7774),
    [sym_self] = ACTIONS(7774),
    [sym_super] = ACTIONS(7774),
    [sym_crate] = ACTIONS(7774),
    [sym_metavariable] = ACTIONS(7772),
  },
  [3512] = {
    [sym_raw_string_literal] = ACTIONS(7776),
    [sym_float_literal] = ACTIONS(7776),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(7776),
    [anon_sym_SEMI] = ACTIONS(7776),
    [anon_sym_macro_rules_BANG] = ACTIONS(7776),
    [anon_sym_LPAREN] = ACTIONS(7776),
    [anon_sym_LBRACE] = ACTIONS(7776),
    [anon_sym_RBRACE] = ACTIONS(7776),
    [anon_sym_LBRACK] = ACTIONS(7776),
    [anon_sym_STAR] = ACTIONS(7776),
    [anon_sym_u8] = ACTIONS(7778),
    [anon_sym_i8] = ACTIONS(7778),
    [anon_sym_u16] = ACTIONS(7778),
    [anon_sym_i16] = ACTIONS(7778),
    [anon_sym_u32] = ACTIONS(7778),
    [anon_sym_i32] = ACTIONS(7778),
    [anon_sym_u64] = ACTIONS(7778),
    [anon_sym_i64] = ACTIONS(7778),
    [anon_sym_u128] = ACTIONS(7778),
    [anon_sym_i128] = ACTIONS(7778),
    [anon_sym_isize] = ACTIONS(7778),
    [anon_sym_usize] = ACTIONS(7778),
    [anon_sym_f32] = ACTIONS(7778),
    [anon_sym_f64] = ACTIONS(7778),
    [anon_sym_bool] = ACTIONS(7778),
    [anon_sym_str] = ACTIONS(7778),
    [anon_sym_char] = ACTIONS(7778),
    [anon_sym_AMP] = ACTIONS(7776),
    [anon_sym_DASH] = ACTIONS(7776),
    [anon_sym_COLON_COLON] = ACTIONS(7776),
    [anon_sym_BANG] = ACTIONS(7776),
    [anon_sym_POUND] = ACTIONS(7776),
    [anon_sym_LT] = ACTIONS(7776),
    [anon_sym_PIPE] = ACTIONS(7776),
    [anon_sym_SQUOTE] = ACTIONS(7778),
    [anon_sym_DOT_DOT] = ACTIONS(7776),
    [anon_sym_break] = ACTIONS(7778),
    [anon_sym_const] = ACTIONS(7778),
    [anon_sym_continue] = ACTIONS(7778),
    [anon_sym_default] = ACTIONS(7778),
    [anon_sym_enum] = ACTIONS(7778),
    [anon_sym_fn] = ACTIONS(7778),
    [anon_sym_for] = ACTIONS(7778),
    [anon_sym_if] = ACTIONS(7778),
    [anon_sym_impl] = ACTIONS(7778),
    [anon_sym_let] = ACTIONS(7778),
    [anon_sym_loop] = ACTIONS(7778),
    [anon_sym_match] = ACTIONS(7778),
    [anon_sym_mod] = ACTIONS(7778),
    [anon_sym_pub] = ACTIONS(7778),
    [anon_sym_return] = ACTIONS(7778),
    [anon_sym_static] = ACTIONS(7778),
    [anon_sym_struct] = ACTIONS(7778),
    [anon_sym_trait] = ACTIONS(7778),
    [anon_sym_type] = ACTIONS(7778),
    [anon_sym_union] = ACTIONS(7778),
    [anon_sym_unsafe] = ACTIONS(7778),
    [anon_sym_use] = ACTIONS(7778),
    [anon_sym_while] = ACTIONS(7778),
    [anon_sym_extern] = ACTIONS(7778),
    [anon_sym_move] = ACTIONS(7778),
    [sym_integer_literal] = ACTIONS(7776),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7776),
    [sym_char_literal] = ACTIONS(7776),
    [anon_sym_true] = ACTIONS(7778),
    [anon_sym_false] = ACTIONS(7778),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7778),
    [sym_self] = ACTIONS(7778),
    [sym_super] = ACTIONS(7778),
    [sym_crate] = ACTIONS(7778),
    [sym_metavariable] = ACTIONS(7776),
  },
  [3513] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6742),
    [anon_sym_macro_rules_BANG] = ACTIONS(6742),
    [anon_sym_RBRACE] = ACTIONS(6742),
    [anon_sym_POUND] = ACTIONS(6742),
    [anon_sym_const] = ACTIONS(6744),
    [anon_sym_default] = ACTIONS(6744),
    [anon_sym_enum] = ACTIONS(6744),
    [anon_sym_fn] = ACTIONS(6744),
    [anon_sym_impl] = ACTIONS(6744),
    [anon_sym_let] = ACTIONS(6744),
    [anon_sym_mod] = ACTIONS(6744),
    [anon_sym_pub] = ACTIONS(6744),
    [anon_sym_static] = ACTIONS(6744),
    [anon_sym_struct] = ACTIONS(6744),
    [anon_sym_trait] = ACTIONS(6744),
    [anon_sym_type] = ACTIONS(6744),
    [anon_sym_union] = ACTIONS(6744),
    [anon_sym_unsafe] = ACTIONS(6744),
    [anon_sym_use] = ACTIONS(6744),
    [anon_sym_extern] = ACTIONS(6744),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6744),
  },
  [3514] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6833),
    [anon_sym_macro_rules_BANG] = ACTIONS(6833),
    [anon_sym_RBRACE] = ACTIONS(6833),
    [anon_sym_POUND] = ACTIONS(6833),
    [anon_sym_const] = ACTIONS(6835),
    [anon_sym_default] = ACTIONS(6835),
    [anon_sym_enum] = ACTIONS(6835),
    [anon_sym_fn] = ACTIONS(6835),
    [anon_sym_impl] = ACTIONS(6835),
    [anon_sym_let] = ACTIONS(6835),
    [anon_sym_mod] = ACTIONS(6835),
    [anon_sym_pub] = ACTIONS(6835),
    [anon_sym_static] = ACTIONS(6835),
    [anon_sym_struct] = ACTIONS(6835),
    [anon_sym_trait] = ACTIONS(6835),
    [anon_sym_type] = ACTIONS(6835),
    [anon_sym_union] = ACTIONS(6835),
    [anon_sym_unsafe] = ACTIONS(6835),
    [anon_sym_use] = ACTIONS(6835),
    [anon_sym_extern] = ACTIONS(6835),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6835),
  },
  [3515] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6849),
    [anon_sym_macro_rules_BANG] = ACTIONS(6849),
    [anon_sym_RBRACE] = ACTIONS(6849),
    [anon_sym_POUND] = ACTIONS(6849),
    [anon_sym_const] = ACTIONS(6851),
    [anon_sym_default] = ACTIONS(6851),
    [anon_sym_enum] = ACTIONS(6851),
    [anon_sym_fn] = ACTIONS(6851),
    [anon_sym_impl] = ACTIONS(6851),
    [anon_sym_let] = ACTIONS(6851),
    [anon_sym_mod] = ACTIONS(6851),
    [anon_sym_pub] = ACTIONS(6851),
    [anon_sym_static] = ACTIONS(6851),
    [anon_sym_struct] = ACTIONS(6851),
    [anon_sym_trait] = ACTIONS(6851),
    [anon_sym_type] = ACTIONS(6851),
    [anon_sym_union] = ACTIONS(6851),
    [anon_sym_unsafe] = ACTIONS(6851),
    [anon_sym_use] = ACTIONS(6851),
    [anon_sym_extern] = ACTIONS(6851),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6851),
  },
  [3516] = {
    [sym_attribute_item] = STATE(2209),
    [sym_enum_variant] = STATE(2208),
    [sym_visibility_modifier] = STATE(938),
    [aux_sym_enum_variant_list_repeat1] = STATE(2209),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7780),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_pub] = ACTIONS(1940),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1942),
  },
  [3517] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6869),
    [anon_sym_macro_rules_BANG] = ACTIONS(6869),
    [anon_sym_RBRACE] = ACTIONS(6869),
    [anon_sym_POUND] = ACTIONS(6869),
    [anon_sym_const] = ACTIONS(6871),
    [anon_sym_default] = ACTIONS(6871),
    [anon_sym_enum] = ACTIONS(6871),
    [anon_sym_fn] = ACTIONS(6871),
    [anon_sym_impl] = ACTIONS(6871),
    [anon_sym_let] = ACTIONS(6871),
    [anon_sym_mod] = ACTIONS(6871),
    [anon_sym_pub] = ACTIONS(6871),
    [anon_sym_static] = ACTIONS(6871),
    [anon_sym_struct] = ACTIONS(6871),
    [anon_sym_trait] = ACTIONS(6871),
    [anon_sym_type] = ACTIONS(6871),
    [anon_sym_union] = ACTIONS(6871),
    [anon_sym_unsafe] = ACTIONS(6871),
    [anon_sym_use] = ACTIONS(6871),
    [anon_sym_extern] = ACTIONS(6871),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6871),
  },
  [3518] = {
    [sym_block] = STATE(3620),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7782),
    [anon_sym_LBRACE] = ACTIONS(111),
    [sym_line_comment] = ACTIONS(7),
  },
  [3519] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6875),
    [anon_sym_macro_rules_BANG] = ACTIONS(6875),
    [anon_sym_RBRACE] = ACTIONS(6875),
    [anon_sym_POUND] = ACTIONS(6875),
    [anon_sym_const] = ACTIONS(6877),
    [anon_sym_default] = ACTIONS(6877),
    [anon_sym_enum] = ACTIONS(6877),
    [anon_sym_fn] = ACTIONS(6877),
    [anon_sym_impl] = ACTIONS(6877),
    [anon_sym_let] = ACTIONS(6877),
    [anon_sym_mod] = ACTIONS(6877),
    [anon_sym_pub] = ACTIONS(6877),
    [anon_sym_static] = ACTIONS(6877),
    [anon_sym_struct] = ACTIONS(6877),
    [anon_sym_trait] = ACTIONS(6877),
    [anon_sym_type] = ACTIONS(6877),
    [anon_sym_union] = ACTIONS(6877),
    [anon_sym_unsafe] = ACTIONS(6877),
    [anon_sym_use] = ACTIONS(6877),
    [anon_sym_extern] = ACTIONS(6877),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6877),
  },
  [3520] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6909),
    [anon_sym_macro_rules_BANG] = ACTIONS(6909),
    [anon_sym_RBRACE] = ACTIONS(6909),
    [anon_sym_POUND] = ACTIONS(6909),
    [anon_sym_const] = ACTIONS(6911),
    [anon_sym_default] = ACTIONS(6911),
    [anon_sym_enum] = ACTIONS(6911),
    [anon_sym_fn] = ACTIONS(6911),
    [anon_sym_impl] = ACTIONS(6911),
    [anon_sym_let] = ACTIONS(6911),
    [anon_sym_mod] = ACTIONS(6911),
    [anon_sym_pub] = ACTIONS(6911),
    [anon_sym_static] = ACTIONS(6911),
    [anon_sym_struct] = ACTIONS(6911),
    [anon_sym_trait] = ACTIONS(6911),
    [anon_sym_type] = ACTIONS(6911),
    [anon_sym_union] = ACTIONS(6911),
    [anon_sym_unsafe] = ACTIONS(6911),
    [anon_sym_use] = ACTIONS(6911),
    [anon_sym_extern] = ACTIONS(6911),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6911),
  },
  [3521] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6913),
    [anon_sym_macro_rules_BANG] = ACTIONS(6913),
    [anon_sym_RBRACE] = ACTIONS(6913),
    [anon_sym_POUND] = ACTIONS(6913),
    [anon_sym_const] = ACTIONS(6915),
    [anon_sym_default] = ACTIONS(6915),
    [anon_sym_enum] = ACTIONS(6915),
    [anon_sym_fn] = ACTIONS(6915),
    [anon_sym_impl] = ACTIONS(6915),
    [anon_sym_let] = ACTIONS(6915),
    [anon_sym_mod] = ACTIONS(6915),
    [anon_sym_pub] = ACTIONS(6915),
    [anon_sym_static] = ACTIONS(6915),
    [anon_sym_struct] = ACTIONS(6915),
    [anon_sym_trait] = ACTIONS(6915),
    [anon_sym_type] = ACTIONS(6915),
    [anon_sym_union] = ACTIONS(6915),
    [anon_sym_unsafe] = ACTIONS(6915),
    [anon_sym_use] = ACTIONS(6915),
    [anon_sym_extern] = ACTIONS(6915),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6915),
  },
  [3522] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7784),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(467),
    [anon_sym_BANG_EQ] = ACTIONS(469),
    [anon_sym_STAR_EQ] = ACTIONS(467),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(467),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_AMP_EQ] = ACTIONS(467),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(467),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_CARET_EQ] = ACTIONS(467),
    [anon_sym_PLUS_EQ] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT_LT_EQ] = ACTIONS(467),
    [anon_sym_LT_EQ] = ACTIONS(469),
    [anon_sym_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_EQ] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_PIPE_EQ] = ACTIONS(467),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(489),
    [anon_sym_as] = ACTIONS(491),
    [sym_line_comment] = ACTIONS(7),
  },
  [3523] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(6919),
    [anon_sym_macro_rules_BANG] = ACTIONS(6919),
    [anon_sym_RBRACE] = ACTIONS(6919),
    [anon_sym_POUND] = ACTIONS(6919),
    [anon_sym_const] = ACTIONS(6921),
    [anon_sym_default] = ACTIONS(6921),
    [anon_sym_enum] = ACTIONS(6921),
    [anon_sym_fn] = ACTIONS(6921),
    [anon_sym_impl] = ACTIONS(6921),
    [anon_sym_let] = ACTIONS(6921),
    [anon_sym_mod] = ACTIONS(6921),
    [anon_sym_pub] = ACTIONS(6921),
    [anon_sym_static] = ACTIONS(6921),
    [anon_sym_struct] = ACTIONS(6921),
    [anon_sym_trait] = ACTIONS(6921),
    [anon_sym_type] = ACTIONS(6921),
    [anon_sym_union] = ACTIONS(6921),
    [anon_sym_unsafe] = ACTIONS(6921),
    [anon_sym_use] = ACTIONS(6921),
    [anon_sym_extern] = ACTIONS(6921),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6921),
  },
  [3524] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7786),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(467),
    [anon_sym_BANG_EQ] = ACTIONS(469),
    [anon_sym_STAR_EQ] = ACTIONS(467),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(467),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_AMP_EQ] = ACTIONS(467),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(467),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_CARET_EQ] = ACTIONS(467),
    [anon_sym_PLUS_EQ] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT_LT_EQ] = ACTIONS(467),
    [anon_sym_LT_EQ] = ACTIONS(469),
    [anon_sym_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_EQ] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_PIPE_EQ] = ACTIONS(467),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(489),
    [anon_sym_as] = ACTIONS(491),
    [sym_line_comment] = ACTIONS(7),
  },
  [3525] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7101),
    [anon_sym_macro_rules_BANG] = ACTIONS(7101),
    [anon_sym_RBRACE] = ACTIONS(7101),
    [anon_sym_POUND] = ACTIONS(7101),
    [anon_sym_const] = ACTIONS(7103),
    [anon_sym_default] = ACTIONS(7103),
    [anon_sym_enum] = ACTIONS(7103),
    [anon_sym_fn] = ACTIONS(7103),
    [anon_sym_impl] = ACTIONS(7103),
    [anon_sym_let] = ACTIONS(7103),
    [anon_sym_mod] = ACTIONS(7103),
    [anon_sym_pub] = ACTIONS(7103),
    [anon_sym_static] = ACTIONS(7103),
    [anon_sym_struct] = ACTIONS(7103),
    [anon_sym_trait] = ACTIONS(7103),
    [anon_sym_type] = ACTIONS(7103),
    [anon_sym_union] = ACTIONS(7103),
    [anon_sym_unsafe] = ACTIONS(7103),
    [anon_sym_use] = ACTIONS(7103),
    [anon_sym_extern] = ACTIONS(7103),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7103),
  },
  [3526] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7158),
    [anon_sym_macro_rules_BANG] = ACTIONS(7158),
    [anon_sym_RBRACE] = ACTIONS(7158),
    [anon_sym_POUND] = ACTIONS(7158),
    [anon_sym_const] = ACTIONS(7160),
    [anon_sym_default] = ACTIONS(7160),
    [anon_sym_enum] = ACTIONS(7160),
    [anon_sym_fn] = ACTIONS(7160),
    [anon_sym_impl] = ACTIONS(7160),
    [anon_sym_let] = ACTIONS(7160),
    [anon_sym_mod] = ACTIONS(7160),
    [anon_sym_pub] = ACTIONS(7160),
    [anon_sym_static] = ACTIONS(7160),
    [anon_sym_struct] = ACTIONS(7160),
    [anon_sym_trait] = ACTIONS(7160),
    [anon_sym_type] = ACTIONS(7160),
    [anon_sym_union] = ACTIONS(7160),
    [anon_sym_unsafe] = ACTIONS(7160),
    [anon_sym_use] = ACTIONS(7160),
    [anon_sym_extern] = ACTIONS(7160),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7160),
  },
  [3527] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7166),
    [anon_sym_macro_rules_BANG] = ACTIONS(7166),
    [anon_sym_RBRACE] = ACTIONS(7166),
    [anon_sym_POUND] = ACTIONS(7166),
    [anon_sym_const] = ACTIONS(7168),
    [anon_sym_default] = ACTIONS(7168),
    [anon_sym_enum] = ACTIONS(7168),
    [anon_sym_fn] = ACTIONS(7168),
    [anon_sym_impl] = ACTIONS(7168),
    [anon_sym_let] = ACTIONS(7168),
    [anon_sym_mod] = ACTIONS(7168),
    [anon_sym_pub] = ACTIONS(7168),
    [anon_sym_static] = ACTIONS(7168),
    [anon_sym_struct] = ACTIONS(7168),
    [anon_sym_trait] = ACTIONS(7168),
    [anon_sym_type] = ACTIONS(7168),
    [anon_sym_union] = ACTIONS(7168),
    [anon_sym_unsafe] = ACTIONS(7168),
    [anon_sym_use] = ACTIONS(7168),
    [anon_sym_extern] = ACTIONS(7168),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7168),
  },
  [3528] = {
    [sym_declaration_list] = STATE(3623),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [sym_line_comment] = ACTIONS(7),
  },
  [3529] = {
    [sym_declaration_list] = STATE(3624),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(2483),
    [sym_line_comment] = ACTIONS(7),
  },
  [3530] = {
    [sym_where_clause] = STATE(3625),
    [sym_block] = STATE(3620),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7782),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(5003),
    [anon_sym_where] = ACTIONS(1962),
    [sym_line_comment] = ACTIONS(7),
  },
  [3531] = {
    [sym_where_clause] = STATE(3625),
    [sym_block] = STATE(3620),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7782),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_where] = ACTIONS(1962),
    [sym_line_comment] = ACTIONS(7),
  },
  [3532] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7788),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(467),
    [anon_sym_BANG_EQ] = ACTIONS(469),
    [anon_sym_STAR_EQ] = ACTIONS(467),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(467),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_AMP_EQ] = ACTIONS(467),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(467),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_CARET_EQ] = ACTIONS(467),
    [anon_sym_PLUS_EQ] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT_LT_EQ] = ACTIONS(467),
    [anon_sym_LT_EQ] = ACTIONS(469),
    [anon_sym_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_EQ] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_PIPE_EQ] = ACTIONS(467),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(489),
    [anon_sym_as] = ACTIONS(491),
    [sym_line_comment] = ACTIONS(7),
  },
  [3533] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3627),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3627),
    [sym_macro_invocation] = STATE(3627),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3627),
    [sym_unary_expression] = STATE(3627),
    [sym_try_expression] = STATE(3627),
    [sym_reference_expression] = STATE(3627),
    [sym_binary_expression] = STATE(3627),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3627),
    [sym_call_expression] = STATE(3627),
    [sym_array_expression] = STATE(3627),
    [sym_parenthesized_expression] = STATE(3627),
    [sym_tuple_expression] = STATE(3627),
    [sym_unit_expression] = STATE(3627),
    [sym_struct_expression] = STATE(3627),
    [sym_if_expression] = STATE(3627),
    [sym_if_let_expression] = STATE(3627),
    [sym_match_expression] = STATE(3627),
    [sym_while_expression] = STATE(3627),
    [sym_while_let_expression] = STATE(3627),
    [sym_loop_expression] = STATE(3627),
    [sym_for_expression] = STATE(3627),
    [sym_closure_expression] = STATE(3627),
    [sym_closure_parameters] = STATE(58),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3627),
    [sym_continue_expression] = STATE(3627),
    [sym_index_expression] = STATE(3627),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3627),
    [sym_block] = STATE(3627),
    [sym__literal] = STATE(3627),
    [sym_string_literal] = STATE(3627),
    [sym_boolean_literal] = STATE(3627),
    [sym_raw_string_literal] = ACTIONS(7790),
    [sym_float_literal] = ACTIONS(7790),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(175),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(7790),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7790),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [3534] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7282),
    [anon_sym_macro_rules_BANG] = ACTIONS(7282),
    [anon_sym_RBRACE] = ACTIONS(7282),
    [anon_sym_POUND] = ACTIONS(7282),
    [anon_sym_const] = ACTIONS(7284),
    [anon_sym_default] = ACTIONS(7284),
    [anon_sym_enum] = ACTIONS(7284),
    [anon_sym_fn] = ACTIONS(7284),
    [anon_sym_impl] = ACTIONS(7284),
    [anon_sym_let] = ACTIONS(7284),
    [anon_sym_mod] = ACTIONS(7284),
    [anon_sym_pub] = ACTIONS(7284),
    [anon_sym_static] = ACTIONS(7284),
    [anon_sym_struct] = ACTIONS(7284),
    [anon_sym_trait] = ACTIONS(7284),
    [anon_sym_type] = ACTIONS(7284),
    [anon_sym_union] = ACTIONS(7284),
    [anon_sym_unsafe] = ACTIONS(7284),
    [anon_sym_use] = ACTIONS(7284),
    [anon_sym_extern] = ACTIONS(7284),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7284),
  },
  [3535] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7792),
    [sym_line_comment] = ACTIONS(7),
  },
  [3536] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7288),
    [anon_sym_macro_rules_BANG] = ACTIONS(7288),
    [anon_sym_RBRACE] = ACTIONS(7288),
    [anon_sym_POUND] = ACTIONS(7288),
    [anon_sym_const] = ACTIONS(7290),
    [anon_sym_default] = ACTIONS(7290),
    [anon_sym_enum] = ACTIONS(7290),
    [anon_sym_fn] = ACTIONS(7290),
    [anon_sym_impl] = ACTIONS(7290),
    [anon_sym_let] = ACTIONS(7290),
    [anon_sym_mod] = ACTIONS(7290),
    [anon_sym_pub] = ACTIONS(7290),
    [anon_sym_static] = ACTIONS(7290),
    [anon_sym_struct] = ACTIONS(7290),
    [anon_sym_trait] = ACTIONS(7290),
    [anon_sym_type] = ACTIONS(7290),
    [anon_sym_union] = ACTIONS(7290),
    [anon_sym_unsafe] = ACTIONS(7290),
    [anon_sym_use] = ACTIONS(7290),
    [anon_sym_extern] = ACTIONS(7290),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7290),
  },
  [3537] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7292),
    [anon_sym_macro_rules_BANG] = ACTIONS(7292),
    [anon_sym_RBRACE] = ACTIONS(7292),
    [anon_sym_POUND] = ACTIONS(7292),
    [anon_sym_const] = ACTIONS(7294),
    [anon_sym_default] = ACTIONS(7294),
    [anon_sym_enum] = ACTIONS(7294),
    [anon_sym_fn] = ACTIONS(7294),
    [anon_sym_impl] = ACTIONS(7294),
    [anon_sym_let] = ACTIONS(7294),
    [anon_sym_mod] = ACTIONS(7294),
    [anon_sym_pub] = ACTIONS(7294),
    [anon_sym_static] = ACTIONS(7294),
    [anon_sym_struct] = ACTIONS(7294),
    [anon_sym_trait] = ACTIONS(7294),
    [anon_sym_type] = ACTIONS(7294),
    [anon_sym_union] = ACTIONS(7294),
    [anon_sym_unsafe] = ACTIONS(7294),
    [anon_sym_use] = ACTIONS(7294),
    [anon_sym_extern] = ACTIONS(7294),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7294),
  },
  [3538] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7296),
    [anon_sym_macro_rules_BANG] = ACTIONS(7296),
    [anon_sym_RBRACE] = ACTIONS(7296),
    [anon_sym_POUND] = ACTIONS(7296),
    [anon_sym_const] = ACTIONS(7298),
    [anon_sym_default] = ACTIONS(7298),
    [anon_sym_enum] = ACTIONS(7298),
    [anon_sym_fn] = ACTIONS(7298),
    [anon_sym_impl] = ACTIONS(7298),
    [anon_sym_let] = ACTIONS(7298),
    [anon_sym_mod] = ACTIONS(7298),
    [anon_sym_pub] = ACTIONS(7298),
    [anon_sym_static] = ACTIONS(7298),
    [anon_sym_struct] = ACTIONS(7298),
    [anon_sym_trait] = ACTIONS(7298),
    [anon_sym_type] = ACTIONS(7298),
    [anon_sym_union] = ACTIONS(7298),
    [anon_sym_unsafe] = ACTIONS(7298),
    [anon_sym_use] = ACTIONS(7298),
    [anon_sym_extern] = ACTIONS(7298),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7298),
  },
  [3539] = {
    [sym_function_modifiers] = STATE(1624),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3629),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(1626),
    [sym_array_type] = STATE(3629),
    [sym_function_type] = STATE(3629),
    [sym_tuple_type] = STATE(3629),
    [sym_unit_type] = STATE(3629),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(3629),
    [sym_reference_type] = STATE(3629),
    [sym_pointer_type] = STATE(3629),
    [sym_empty_type] = STATE(3629),
    [sym_abstract_type] = STATE(3630),
    [sym_dynamic_type] = STATE(3629),
    [sym_macro_invocation] = STATE(3629),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(1628),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(3169),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(3171),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(3173),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3175),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3540] = {
    [sym_raw_string_literal] = ACTIONS(7794),
    [sym_float_literal] = ACTIONS(7794),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(7794),
    [anon_sym_SEMI] = ACTIONS(7794),
    [anon_sym_macro_rules_BANG] = ACTIONS(7794),
    [anon_sym_LPAREN] = ACTIONS(7794),
    [anon_sym_LBRACE] = ACTIONS(7794),
    [anon_sym_RBRACE] = ACTIONS(7794),
    [anon_sym_LBRACK] = ACTIONS(7794),
    [anon_sym_STAR] = ACTIONS(7794),
    [anon_sym_u8] = ACTIONS(7796),
    [anon_sym_i8] = ACTIONS(7796),
    [anon_sym_u16] = ACTIONS(7796),
    [anon_sym_i16] = ACTIONS(7796),
    [anon_sym_u32] = ACTIONS(7796),
    [anon_sym_i32] = ACTIONS(7796),
    [anon_sym_u64] = ACTIONS(7796),
    [anon_sym_i64] = ACTIONS(7796),
    [anon_sym_u128] = ACTIONS(7796),
    [anon_sym_i128] = ACTIONS(7796),
    [anon_sym_isize] = ACTIONS(7796),
    [anon_sym_usize] = ACTIONS(7796),
    [anon_sym_f32] = ACTIONS(7796),
    [anon_sym_f64] = ACTIONS(7796),
    [anon_sym_bool] = ACTIONS(7796),
    [anon_sym_str] = ACTIONS(7796),
    [anon_sym_char] = ACTIONS(7796),
    [anon_sym_AMP] = ACTIONS(7794),
    [anon_sym_DASH] = ACTIONS(7794),
    [anon_sym_COLON_COLON] = ACTIONS(7794),
    [anon_sym_BANG] = ACTIONS(7794),
    [anon_sym_POUND] = ACTIONS(7794),
    [anon_sym_LT] = ACTIONS(7794),
    [anon_sym_PIPE] = ACTIONS(7794),
    [anon_sym_SQUOTE] = ACTIONS(7796),
    [anon_sym_DOT_DOT] = ACTIONS(7794),
    [anon_sym_break] = ACTIONS(7796),
    [anon_sym_const] = ACTIONS(7796),
    [anon_sym_continue] = ACTIONS(7796),
    [anon_sym_default] = ACTIONS(7796),
    [anon_sym_enum] = ACTIONS(7796),
    [anon_sym_fn] = ACTIONS(7796),
    [anon_sym_for] = ACTIONS(7796),
    [anon_sym_if] = ACTIONS(7796),
    [anon_sym_impl] = ACTIONS(7796),
    [anon_sym_let] = ACTIONS(7796),
    [anon_sym_loop] = ACTIONS(7796),
    [anon_sym_match] = ACTIONS(7796),
    [anon_sym_mod] = ACTIONS(7796),
    [anon_sym_pub] = ACTIONS(7796),
    [anon_sym_return] = ACTIONS(7796),
    [anon_sym_static] = ACTIONS(7796),
    [anon_sym_struct] = ACTIONS(7796),
    [anon_sym_trait] = ACTIONS(7796),
    [anon_sym_type] = ACTIONS(7796),
    [anon_sym_union] = ACTIONS(7796),
    [anon_sym_unsafe] = ACTIONS(7796),
    [anon_sym_use] = ACTIONS(7796),
    [anon_sym_while] = ACTIONS(7796),
    [anon_sym_extern] = ACTIONS(7796),
    [anon_sym_move] = ACTIONS(7796),
    [sym_integer_literal] = ACTIONS(7794),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7794),
    [sym_char_literal] = ACTIONS(7794),
    [anon_sym_true] = ACTIONS(7796),
    [anon_sym_false] = ACTIONS(7796),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7796),
    [sym_self] = ACTIONS(7796),
    [sym_super] = ACTIONS(7796),
    [sym_crate] = ACTIONS(7796),
    [sym_metavariable] = ACTIONS(7794),
  },
  [3541] = {
    [sym_block] = STATE(3632),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7798),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [sym_line_comment] = ACTIONS(7),
  },
  [3542] = {
    [sym_raw_string_literal] = ACTIONS(7800),
    [sym_float_literal] = ACTIONS(7800),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7800),
    [anon_sym_LPAREN] = ACTIONS(7800),
    [anon_sym_RPAREN] = ACTIONS(7800),
    [anon_sym_LBRACE] = ACTIONS(7800),
    [anon_sym_RBRACE] = ACTIONS(7800),
    [anon_sym_EQ_GT] = ACTIONS(7800),
    [anon_sym_LBRACK] = ACTIONS(7800),
    [anon_sym_RBRACK] = ACTIONS(7800),
    [anon_sym_COLON] = ACTIONS(7802),
    [anon_sym_DOLLAR] = ACTIONS(7802),
    [anon_sym_PLUS] = ACTIONS(7802),
    [anon_sym_STAR] = ACTIONS(7802),
    [anon_sym_COMMA] = ACTIONS(7800),
    [anon_sym_u8] = ACTIONS(7802),
    [anon_sym_i8] = ACTIONS(7802),
    [anon_sym_u16] = ACTIONS(7802),
    [anon_sym_i16] = ACTIONS(7802),
    [anon_sym_u32] = ACTIONS(7802),
    [anon_sym_i32] = ACTIONS(7802),
    [anon_sym_u64] = ACTIONS(7802),
    [anon_sym_i64] = ACTIONS(7802),
    [anon_sym_u128] = ACTIONS(7802),
    [anon_sym_i128] = ACTIONS(7802),
    [anon_sym_isize] = ACTIONS(7802),
    [anon_sym_usize] = ACTIONS(7802),
    [anon_sym_f32] = ACTIONS(7802),
    [anon_sym_f64] = ACTIONS(7802),
    [anon_sym_bool] = ACTIONS(7802),
    [anon_sym_str] = ACTIONS(7802),
    [anon_sym_char] = ACTIONS(7802),
    [anon_sym__] = ACTIONS(7802),
    [anon_sym_AMP] = ACTIONS(7802),
    [anon_sym_DASH] = ACTIONS(7802),
    [anon_sym_DOT] = ACTIONS(7802),
    [anon_sym_DASH_EQ] = ACTIONS(7800),
    [anon_sym_DASH_GT] = ACTIONS(7800),
    [anon_sym_COLON_COLON] = ACTIONS(7800),
    [anon_sym_BANG] = ACTIONS(7802),
    [anon_sym_BANG_EQ] = ACTIONS(7800),
    [anon_sym_AT] = ACTIONS(7800),
    [anon_sym_STAR_EQ] = ACTIONS(7800),
    [anon_sym_SLASH] = ACTIONS(7802),
    [anon_sym_SLASH_EQ] = ACTIONS(7800),
    [anon_sym_AMP_AMP] = ACTIONS(7800),
    [anon_sym_AMP_EQ] = ACTIONS(7800),
    [anon_sym_POUND] = ACTIONS(7800),
    [anon_sym_PERCENT] = ACTIONS(7802),
    [anon_sym_PERCENT_EQ] = ACTIONS(7800),
    [anon_sym_CARET] = ACTIONS(7802),
    [anon_sym_CARET_EQ] = ACTIONS(7800),
    [anon_sym_PLUS_EQ] = ACTIONS(7800),
    [anon_sym_LT] = ACTIONS(7802),
    [anon_sym_LT_LT] = ACTIONS(7802),
    [anon_sym_LT_LT_EQ] = ACTIONS(7800),
    [anon_sym_LT_EQ] = ACTIONS(7800),
    [anon_sym_EQ] = ACTIONS(7802),
    [anon_sym_EQ_EQ] = ACTIONS(7800),
    [anon_sym_GT] = ACTIONS(7802),
    [anon_sym_GT_EQ] = ACTIONS(7800),
    [anon_sym_GT_GT] = ACTIONS(7802),
    [anon_sym_GT_GT_EQ] = ACTIONS(7800),
    [anon_sym_PIPE] = ACTIONS(7802),
    [anon_sym_PIPE_EQ] = ACTIONS(7800),
    [anon_sym_PIPE_PIPE] = ACTIONS(7800),
    [anon_sym_TILDE] = ACTIONS(7800),
    [anon_sym_QMARK] = ACTIONS(7800),
    [anon_sym_SQUOTE] = ACTIONS(7802),
    [anon_sym_DOT_DOT] = ACTIONS(7802),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7800),
    [anon_sym_as] = ACTIONS(7802),
    [anon_sym_break] = ACTIONS(7802),
    [anon_sym_const] = ACTIONS(7802),
    [anon_sym_continue] = ACTIONS(7802),
    [anon_sym_default] = ACTIONS(7802),
    [anon_sym_enum] = ACTIONS(7802),
    [anon_sym_fn] = ACTIONS(7802),
    [anon_sym_for] = ACTIONS(7802),
    [anon_sym_if] = ACTIONS(7802),
    [anon_sym_impl] = ACTIONS(7802),
    [anon_sym_let] = ACTIONS(7802),
    [anon_sym_loop] = ACTIONS(7802),
    [anon_sym_match] = ACTIONS(7802),
    [anon_sym_mod] = ACTIONS(7802),
    [anon_sym_pub] = ACTIONS(7802),
    [anon_sym_return] = ACTIONS(7802),
    [anon_sym_static] = ACTIONS(7802),
    [anon_sym_struct] = ACTIONS(7802),
    [anon_sym_trait] = ACTIONS(7802),
    [anon_sym_type] = ACTIONS(7802),
    [anon_sym_union] = ACTIONS(7802),
    [anon_sym_unsafe] = ACTIONS(7802),
    [anon_sym_use] = ACTIONS(7802),
    [anon_sym_where] = ACTIONS(7802),
    [anon_sym_while] = ACTIONS(7802),
    [sym_mutable_specifier] = ACTIONS(7802),
    [sym_integer_literal] = ACTIONS(7800),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7800),
    [sym_char_literal] = ACTIONS(7800),
    [anon_sym_true] = ACTIONS(7802),
    [anon_sym_false] = ACTIONS(7802),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7802),
    [sym_self] = ACTIONS(7802),
    [sym_super] = ACTIONS(7802),
    [sym_crate] = ACTIONS(7802),
    [sym_metavariable] = ACTIONS(7800),
  },
  [3543] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(3633),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [3544] = {
    [sym_function_modifiers] = STATE(3109),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2611),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(3110),
    [sym_array_type] = STATE(2611),
    [sym_function_type] = STATE(2611),
    [sym_tuple_type] = STATE(2611),
    [sym_unit_type] = STATE(2611),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2611),
    [sym_reference_type] = STATE(2611),
    [sym_pointer_type] = STATE(2611),
    [sym_empty_type] = STATE(2611),
    [sym_dynamic_type] = STATE(2611),
    [sym_macro_invocation] = STATE(2611),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(3111),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(6776),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(6778),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6780),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6782),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [3545] = {
    [sym_function_modifiers] = STATE(3109),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2616),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(3110),
    [sym_array_type] = STATE(2616),
    [sym_function_type] = STATE(2616),
    [sym_tuple_type] = STATE(2616),
    [sym_unit_type] = STATE(2616),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2616),
    [sym_reference_type] = STATE(2616),
    [sym_pointer_type] = STATE(2616),
    [sym_empty_type] = STATE(2616),
    [sym_abstract_type] = STATE(2617),
    [sym_dynamic_type] = STATE(2616),
    [sym_macro_invocation] = STATE(2616),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(3111),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(6776),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(6778),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6780),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6782),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [3546] = {
    [sym_function_modifiers] = STATE(3109),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2618),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(3110),
    [sym_array_type] = STATE(2618),
    [sym_function_type] = STATE(2618),
    [sym_tuple_type] = STATE(2618),
    [sym_unit_type] = STATE(2618),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(2618),
    [sym_reference_type] = STATE(2618),
    [sym_pointer_type] = STATE(2618),
    [sym_empty_type] = STATE(2618),
    [sym_abstract_type] = STATE(2619),
    [sym_dynamic_type] = STATE(2618),
    [sym_macro_invocation] = STATE(2618),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(3111),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(6776),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(6778),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6780),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6782),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [3547] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(5758),
    [anon_sym_STAR] = ACTIONS(5758),
    [anon_sym_COMMA] = ACTIONS(2988),
    [anon_sym_AMP] = ACTIONS(5758),
    [anon_sym_DASH] = ACTIONS(5758),
    [anon_sym_DOT] = ACTIONS(5758),
    [anon_sym_DASH_EQ] = ACTIONS(2988),
    [anon_sym_DASH_GT] = ACTIONS(7804),
    [anon_sym_BANG_EQ] = ACTIONS(2988),
    [anon_sym_STAR_EQ] = ACTIONS(2988),
    [anon_sym_SLASH] = ACTIONS(5758),
    [anon_sym_SLASH_EQ] = ACTIONS(2988),
    [anon_sym_AMP_AMP] = ACTIONS(2988),
    [anon_sym_AMP_EQ] = ACTIONS(2988),
    [anon_sym_PERCENT] = ACTIONS(5758),
    [anon_sym_PERCENT_EQ] = ACTIONS(2988),
    [anon_sym_CARET] = ACTIONS(5758),
    [anon_sym_CARET_EQ] = ACTIONS(2988),
    [anon_sym_PLUS_EQ] = ACTIONS(2988),
    [anon_sym_LT] = ACTIONS(5758),
    [anon_sym_LT_LT] = ACTIONS(5758),
    [anon_sym_LT_LT_EQ] = ACTIONS(2988),
    [anon_sym_LT_EQ] = ACTIONS(2988),
    [anon_sym_EQ] = ACTIONS(5758),
    [anon_sym_EQ_EQ] = ACTIONS(2988),
    [anon_sym_GT] = ACTIONS(5758),
    [anon_sym_GT_EQ] = ACTIONS(2988),
    [anon_sym_GT_GT] = ACTIONS(5758),
    [anon_sym_GT_GT_EQ] = ACTIONS(2988),
    [anon_sym_PIPE] = ACTIONS(5758),
    [anon_sym_PIPE_EQ] = ACTIONS(2988),
    [anon_sym_PIPE_PIPE] = ACTIONS(2988),
    [anon_sym_QMARK] = ACTIONS(2988),
    [anon_sym_DOT_DOT] = ACTIONS(5758),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2988),
    [anon_sym_as] = ACTIONS(2988),
    [sym_line_comment] = ACTIONS(7),
  },
  [3548] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2992),
    [anon_sym_LBRACK] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(5762),
    [anon_sym_STAR] = ACTIONS(5762),
    [anon_sym_COMMA] = ACTIONS(2992),
    [anon_sym_AMP] = ACTIONS(5762),
    [anon_sym_DASH] = ACTIONS(5762),
    [anon_sym_DOT] = ACTIONS(5762),
    [anon_sym_DASH_EQ] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(7806),
    [anon_sym_BANG_EQ] = ACTIONS(2992),
    [anon_sym_STAR_EQ] = ACTIONS(2992),
    [anon_sym_SLASH] = ACTIONS(5762),
    [anon_sym_SLASH_EQ] = ACTIONS(2992),
    [anon_sym_AMP_AMP] = ACTIONS(2992),
    [anon_sym_AMP_EQ] = ACTIONS(2992),
    [anon_sym_PERCENT] = ACTIONS(5762),
    [anon_sym_PERCENT_EQ] = ACTIONS(2992),
    [anon_sym_CARET] = ACTIONS(5762),
    [anon_sym_CARET_EQ] = ACTIONS(2992),
    [anon_sym_PLUS_EQ] = ACTIONS(2992),
    [anon_sym_LT] = ACTIONS(5762),
    [anon_sym_LT_LT] = ACTIONS(5762),
    [anon_sym_LT_LT_EQ] = ACTIONS(2992),
    [anon_sym_LT_EQ] = ACTIONS(2992),
    [anon_sym_EQ] = ACTIONS(5762),
    [anon_sym_EQ_EQ] = ACTIONS(2992),
    [anon_sym_GT] = ACTIONS(5762),
    [anon_sym_GT_EQ] = ACTIONS(2992),
    [anon_sym_GT_GT] = ACTIONS(5762),
    [anon_sym_GT_GT_EQ] = ACTIONS(2992),
    [anon_sym_PIPE] = ACTIONS(5762),
    [anon_sym_PIPE_EQ] = ACTIONS(2992),
    [anon_sym_PIPE_PIPE] = ACTIONS(2992),
    [anon_sym_QMARK] = ACTIONS(2992),
    [anon_sym_DOT_DOT] = ACTIONS(5762),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2992),
    [anon_sym_as] = ACTIONS(2992),
    [sym_line_comment] = ACTIONS(7),
  },
  [3549] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7541),
    [anon_sym_macro_rules_BANG] = ACTIONS(7541),
    [anon_sym_RBRACE] = ACTIONS(7541),
    [anon_sym_COMMA] = ACTIONS(7541),
    [anon_sym_POUND] = ACTIONS(7541),
    [anon_sym_EQ] = ACTIONS(7541),
    [anon_sym_const] = ACTIONS(7543),
    [anon_sym_default] = ACTIONS(7543),
    [anon_sym_enum] = ACTIONS(7543),
    [anon_sym_fn] = ACTIONS(7543),
    [anon_sym_impl] = ACTIONS(7543),
    [anon_sym_let] = ACTIONS(7543),
    [anon_sym_mod] = ACTIONS(7543),
    [anon_sym_pub] = ACTIONS(7543),
    [anon_sym_static] = ACTIONS(7543),
    [anon_sym_struct] = ACTIONS(7543),
    [anon_sym_trait] = ACTIONS(7543),
    [anon_sym_type] = ACTIONS(7543),
    [anon_sym_union] = ACTIONS(7543),
    [anon_sym_unsafe] = ACTIONS(7543),
    [anon_sym_use] = ACTIONS(7543),
    [anon_sym_extern] = ACTIONS(7543),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7543),
  },
  [3550] = {
    [sym_function_modifiers] = STATE(2770),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2156),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(3151),
    [sym_array_type] = STATE(2156),
    [sym_function_type] = STATE(2156),
    [sym_tuple_type] = STATE(2156),
    [sym_unit_type] = STATE(2156),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2156),
    [sym_reference_type] = STATE(2156),
    [sym_pointer_type] = STATE(2156),
    [sym_empty_type] = STATE(2156),
    [sym_abstract_type] = STATE(2157),
    [sym_dynamic_type] = STATE(2156),
    [sym_macro_invocation] = STATE(2156),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2773),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(6144),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(6146),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6150),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6154),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3551] = {
    [sym_function_modifiers] = STATE(2770),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2158),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(3151),
    [sym_array_type] = STATE(2158),
    [sym_function_type] = STATE(2158),
    [sym_tuple_type] = STATE(2158),
    [sym_unit_type] = STATE(2158),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2158),
    [sym_reference_type] = STATE(2158),
    [sym_pointer_type] = STATE(2158),
    [sym_empty_type] = STATE(2158),
    [sym_abstract_type] = STATE(2159),
    [sym_dynamic_type] = STATE(2158),
    [sym_macro_invocation] = STATE(2158),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2773),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(6144),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(6146),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6150),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6154),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3552] = {
    [sym_raw_string_literal] = ACTIONS(5013),
    [sym_float_literal] = ACTIONS(5013),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5013),
    [anon_sym_RBRACE] = ACTIONS(5013),
    [anon_sym_LBRACK] = ACTIONS(5013),
    [anon_sym_PLUS] = ACTIONS(5015),
    [anon_sym_STAR] = ACTIONS(5015),
    [anon_sym_COMMA] = ACTIONS(5013),
    [anon_sym_u8] = ACTIONS(5015),
    [anon_sym_i8] = ACTIONS(5015),
    [anon_sym_u16] = ACTIONS(5015),
    [anon_sym_i16] = ACTIONS(5015),
    [anon_sym_u32] = ACTIONS(5015),
    [anon_sym_i32] = ACTIONS(5015),
    [anon_sym_u64] = ACTIONS(5015),
    [anon_sym_i64] = ACTIONS(5015),
    [anon_sym_u128] = ACTIONS(5015),
    [anon_sym_i128] = ACTIONS(5015),
    [anon_sym_isize] = ACTIONS(5015),
    [anon_sym_usize] = ACTIONS(5015),
    [anon_sym_f32] = ACTIONS(5015),
    [anon_sym_f64] = ACTIONS(5015),
    [anon_sym_bool] = ACTIONS(5015),
    [anon_sym_str] = ACTIONS(5015),
    [anon_sym_char] = ACTIONS(5015),
    [anon_sym__] = ACTIONS(5015),
    [anon_sym_AMP] = ACTIONS(5015),
    [anon_sym_DASH] = ACTIONS(5015),
    [anon_sym_DOT] = ACTIONS(5015),
    [anon_sym_DASH_EQ] = ACTIONS(5013),
    [anon_sym_COLON_COLON] = ACTIONS(5013),
    [anon_sym_BANG_EQ] = ACTIONS(5013),
    [anon_sym_STAR_EQ] = ACTIONS(5013),
    [anon_sym_SLASH] = ACTIONS(5015),
    [anon_sym_SLASH_EQ] = ACTIONS(5013),
    [anon_sym_AMP_AMP] = ACTIONS(5013),
    [anon_sym_AMP_EQ] = ACTIONS(5013),
    [anon_sym_POUND] = ACTIONS(5013),
    [anon_sym_PERCENT] = ACTIONS(5015),
    [anon_sym_PERCENT_EQ] = ACTIONS(5013),
    [anon_sym_CARET] = ACTIONS(5015),
    [anon_sym_CARET_EQ] = ACTIONS(5013),
    [anon_sym_PLUS_EQ] = ACTIONS(5013),
    [anon_sym_LT] = ACTIONS(5015),
    [anon_sym_LT_LT] = ACTIONS(5015),
    [anon_sym_LT_LT_EQ] = ACTIONS(5013),
    [anon_sym_LT_EQ] = ACTIONS(5013),
    [anon_sym_EQ] = ACTIONS(5015),
    [anon_sym_EQ_EQ] = ACTIONS(5013),
    [anon_sym_GT] = ACTIONS(5015),
    [anon_sym_GT_EQ] = ACTIONS(5013),
    [anon_sym_GT_GT] = ACTIONS(5015),
    [anon_sym_GT_GT_EQ] = ACTIONS(5013),
    [anon_sym_PIPE] = ACTIONS(5015),
    [anon_sym_PIPE_EQ] = ACTIONS(5013),
    [anon_sym_PIPE_PIPE] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5013),
    [anon_sym_DOT_DOT] = ACTIONS(5015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5013),
    [anon_sym_as] = ACTIONS(5015),
    [sym_mutable_specifier] = ACTIONS(5015),
    [anon_sym_ref] = ACTIONS(5015),
    [sym_integer_literal] = ACTIONS(5013),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5013),
    [sym_char_literal] = ACTIONS(5013),
    [anon_sym_true] = ACTIONS(5015),
    [anon_sym_false] = ACTIONS(5015),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5015),
    [sym_self] = ACTIONS(5015),
    [sym_super] = ACTIONS(5015),
    [sym_crate] = ACTIONS(5015),
    [sym_metavariable] = ACTIONS(5013),
  },
  [3553] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(3636),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(5136),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [3554] = {
    [sym_raw_string_literal] = ACTIONS(5027),
    [sym_float_literal] = ACTIONS(5027),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5027),
    [anon_sym_RBRACE] = ACTIONS(5027),
    [anon_sym_LBRACK] = ACTIONS(5027),
    [anon_sym_PLUS] = ACTIONS(5029),
    [anon_sym_STAR] = ACTIONS(5029),
    [anon_sym_COMMA] = ACTIONS(5027),
    [anon_sym_u8] = ACTIONS(5029),
    [anon_sym_i8] = ACTIONS(5029),
    [anon_sym_u16] = ACTIONS(5029),
    [anon_sym_i16] = ACTIONS(5029),
    [anon_sym_u32] = ACTIONS(5029),
    [anon_sym_i32] = ACTIONS(5029),
    [anon_sym_u64] = ACTIONS(5029),
    [anon_sym_i64] = ACTIONS(5029),
    [anon_sym_u128] = ACTIONS(5029),
    [anon_sym_i128] = ACTIONS(5029),
    [anon_sym_isize] = ACTIONS(5029),
    [anon_sym_usize] = ACTIONS(5029),
    [anon_sym_f32] = ACTIONS(5029),
    [anon_sym_f64] = ACTIONS(5029),
    [anon_sym_bool] = ACTIONS(5029),
    [anon_sym_str] = ACTIONS(5029),
    [anon_sym_char] = ACTIONS(5029),
    [anon_sym__] = ACTIONS(5029),
    [anon_sym_AMP] = ACTIONS(5029),
    [anon_sym_DASH] = ACTIONS(5029),
    [anon_sym_DOT] = ACTIONS(5029),
    [anon_sym_DASH_EQ] = ACTIONS(5027),
    [anon_sym_COLON_COLON] = ACTIONS(5027),
    [anon_sym_BANG_EQ] = ACTIONS(5027),
    [anon_sym_STAR_EQ] = ACTIONS(5027),
    [anon_sym_SLASH] = ACTIONS(5029),
    [anon_sym_SLASH_EQ] = ACTIONS(5027),
    [anon_sym_AMP_AMP] = ACTIONS(5027),
    [anon_sym_AMP_EQ] = ACTIONS(5027),
    [anon_sym_POUND] = ACTIONS(5027),
    [anon_sym_PERCENT] = ACTIONS(5029),
    [anon_sym_PERCENT_EQ] = ACTIONS(5027),
    [anon_sym_CARET] = ACTIONS(5029),
    [anon_sym_CARET_EQ] = ACTIONS(5027),
    [anon_sym_PLUS_EQ] = ACTIONS(5027),
    [anon_sym_LT] = ACTIONS(5029),
    [anon_sym_LT_LT] = ACTIONS(5029),
    [anon_sym_LT_LT_EQ] = ACTIONS(5027),
    [anon_sym_LT_EQ] = ACTIONS(5027),
    [anon_sym_EQ] = ACTIONS(5029),
    [anon_sym_EQ_EQ] = ACTIONS(5027),
    [anon_sym_GT] = ACTIONS(5029),
    [anon_sym_GT_EQ] = ACTIONS(5027),
    [anon_sym_GT_GT] = ACTIONS(5029),
    [anon_sym_GT_GT_EQ] = ACTIONS(5027),
    [anon_sym_PIPE] = ACTIONS(5029),
    [anon_sym_PIPE_EQ] = ACTIONS(5027),
    [anon_sym_PIPE_PIPE] = ACTIONS(5027),
    [anon_sym_QMARK] = ACTIONS(5027),
    [anon_sym_DOT_DOT] = ACTIONS(5029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5027),
    [anon_sym_as] = ACTIONS(5029),
    [sym_mutable_specifier] = ACTIONS(5029),
    [anon_sym_ref] = ACTIONS(5029),
    [sym_integer_literal] = ACTIONS(5027),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5027),
    [sym_char_literal] = ACTIONS(5027),
    [anon_sym_true] = ACTIONS(5029),
    [anon_sym_false] = ACTIONS(5029),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5029),
    [sym_self] = ACTIONS(5029),
    [sym_super] = ACTIONS(5029),
    [sym_crate] = ACTIONS(5029),
    [sym_metavariable] = ACTIONS(5027),
  },
  [3555] = {
    [sym_raw_string_literal] = ACTIONS(5130),
    [sym_float_literal] = ACTIONS(5130),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5130),
    [anon_sym_RBRACE] = ACTIONS(5130),
    [anon_sym_LBRACK] = ACTIONS(5130),
    [anon_sym_PLUS] = ACTIONS(5132),
    [anon_sym_STAR] = ACTIONS(5132),
    [anon_sym_COMMA] = ACTIONS(5130),
    [anon_sym_u8] = ACTIONS(5132),
    [anon_sym_i8] = ACTIONS(5132),
    [anon_sym_u16] = ACTIONS(5132),
    [anon_sym_i16] = ACTIONS(5132),
    [anon_sym_u32] = ACTIONS(5132),
    [anon_sym_i32] = ACTIONS(5132),
    [anon_sym_u64] = ACTIONS(5132),
    [anon_sym_i64] = ACTIONS(5132),
    [anon_sym_u128] = ACTIONS(5132),
    [anon_sym_i128] = ACTIONS(5132),
    [anon_sym_isize] = ACTIONS(5132),
    [anon_sym_usize] = ACTIONS(5132),
    [anon_sym_f32] = ACTIONS(5132),
    [anon_sym_f64] = ACTIONS(5132),
    [anon_sym_bool] = ACTIONS(5132),
    [anon_sym_str] = ACTIONS(5132),
    [anon_sym_char] = ACTIONS(5132),
    [anon_sym__] = ACTIONS(5132),
    [anon_sym_AMP] = ACTIONS(5132),
    [anon_sym_DASH] = ACTIONS(5132),
    [anon_sym_DOT] = ACTIONS(5132),
    [anon_sym_DASH_EQ] = ACTIONS(5130),
    [anon_sym_COLON_COLON] = ACTIONS(5130),
    [anon_sym_BANG_EQ] = ACTIONS(5130),
    [anon_sym_STAR_EQ] = ACTIONS(5130),
    [anon_sym_SLASH] = ACTIONS(5132),
    [anon_sym_SLASH_EQ] = ACTIONS(5130),
    [anon_sym_AMP_AMP] = ACTIONS(5130),
    [anon_sym_AMP_EQ] = ACTIONS(5130),
    [anon_sym_POUND] = ACTIONS(5130),
    [anon_sym_PERCENT] = ACTIONS(5132),
    [anon_sym_PERCENT_EQ] = ACTIONS(5130),
    [anon_sym_CARET] = ACTIONS(5132),
    [anon_sym_CARET_EQ] = ACTIONS(5130),
    [anon_sym_PLUS_EQ] = ACTIONS(5130),
    [anon_sym_LT] = ACTIONS(5132),
    [anon_sym_LT_LT] = ACTIONS(5132),
    [anon_sym_LT_LT_EQ] = ACTIONS(5130),
    [anon_sym_LT_EQ] = ACTIONS(5130),
    [anon_sym_EQ] = ACTIONS(5132),
    [anon_sym_EQ_EQ] = ACTIONS(5130),
    [anon_sym_GT] = ACTIONS(5132),
    [anon_sym_GT_EQ] = ACTIONS(5130),
    [anon_sym_GT_GT] = ACTIONS(5132),
    [anon_sym_GT_GT_EQ] = ACTIONS(5130),
    [anon_sym_PIPE] = ACTIONS(5132),
    [anon_sym_PIPE_EQ] = ACTIONS(5130),
    [anon_sym_PIPE_PIPE] = ACTIONS(5130),
    [anon_sym_QMARK] = ACTIONS(5130),
    [anon_sym_DOT_DOT] = ACTIONS(5132),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5130),
    [anon_sym_as] = ACTIONS(5132),
    [sym_mutable_specifier] = ACTIONS(5132),
    [anon_sym_ref] = ACTIONS(5132),
    [sym_integer_literal] = ACTIONS(5130),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5130),
    [sym_char_literal] = ACTIONS(5130),
    [anon_sym_true] = ACTIONS(5132),
    [anon_sym_false] = ACTIONS(5132),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5132),
    [sym_self] = ACTIONS(5132),
    [sym_super] = ACTIONS(5132),
    [sym_crate] = ACTIONS(5132),
    [sym_metavariable] = ACTIONS(5130),
  },
  [3556] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7808),
    [sym_line_comment] = ACTIONS(7),
  },
  [3557] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(3638),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(5136),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [3558] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3639),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(3639),
    [sym_macro_invocation] = STATE(3639),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3639),
    [sym_unary_expression] = STATE(3639),
    [sym_try_expression] = STATE(3639),
    [sym_reference_expression] = STATE(3639),
    [sym_binary_expression] = STATE(3639),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3639),
    [sym_call_expression] = STATE(3639),
    [sym_array_expression] = STATE(3639),
    [sym_parenthesized_expression] = STATE(3639),
    [sym_tuple_expression] = STATE(3639),
    [sym_unit_expression] = STATE(3639),
    [sym_struct_expression] = STATE(3639),
    [sym_if_expression] = STATE(3639),
    [sym_if_let_expression] = STATE(3639),
    [sym_match_expression] = STATE(3639),
    [sym_while_expression] = STATE(3639),
    [sym_while_let_expression] = STATE(3639),
    [sym_loop_expression] = STATE(3639),
    [sym_for_expression] = STATE(3639),
    [sym_closure_expression] = STATE(3639),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3639),
    [sym_continue_expression] = STATE(3639),
    [sym_index_expression] = STATE(3639),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3639),
    [sym_block] = STATE(3639),
    [sym__literal] = STATE(3639),
    [sym_string_literal] = STATE(3639),
    [sym_boolean_literal] = STATE(3639),
    [sym_raw_string_literal] = ACTIONS(7810),
    [sym_float_literal] = ACTIONS(7810),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(7810),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7810),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [3559] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7812),
    [sym_line_comment] = ACTIONS(7),
  },
  [3560] = {
    [sym_raw_string_literal] = ACTIONS(5778),
    [sym_float_literal] = ACTIONS(5778),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5778),
    [anon_sym_RBRACE] = ACTIONS(5778),
    [anon_sym_LBRACK] = ACTIONS(5778),
    [anon_sym_PLUS] = ACTIONS(5780),
    [anon_sym_STAR] = ACTIONS(5780),
    [anon_sym_COMMA] = ACTIONS(5778),
    [anon_sym_u8] = ACTIONS(5780),
    [anon_sym_i8] = ACTIONS(5780),
    [anon_sym_u16] = ACTIONS(5780),
    [anon_sym_i16] = ACTIONS(5780),
    [anon_sym_u32] = ACTIONS(5780),
    [anon_sym_i32] = ACTIONS(5780),
    [anon_sym_u64] = ACTIONS(5780),
    [anon_sym_i64] = ACTIONS(5780),
    [anon_sym_u128] = ACTIONS(5780),
    [anon_sym_i128] = ACTIONS(5780),
    [anon_sym_isize] = ACTIONS(5780),
    [anon_sym_usize] = ACTIONS(5780),
    [anon_sym_f32] = ACTIONS(5780),
    [anon_sym_f64] = ACTIONS(5780),
    [anon_sym_bool] = ACTIONS(5780),
    [anon_sym_str] = ACTIONS(5780),
    [anon_sym_char] = ACTIONS(5780),
    [anon_sym__] = ACTIONS(5780),
    [anon_sym_AMP] = ACTIONS(5780),
    [anon_sym_DASH] = ACTIONS(5780),
    [anon_sym_DOT] = ACTIONS(5780),
    [anon_sym_DASH_EQ] = ACTIONS(5778),
    [anon_sym_COLON_COLON] = ACTIONS(5778),
    [anon_sym_BANG_EQ] = ACTIONS(5778),
    [anon_sym_STAR_EQ] = ACTIONS(5778),
    [anon_sym_SLASH] = ACTIONS(5780),
    [anon_sym_SLASH_EQ] = ACTIONS(5778),
    [anon_sym_AMP_AMP] = ACTIONS(5778),
    [anon_sym_AMP_EQ] = ACTIONS(5778),
    [anon_sym_POUND] = ACTIONS(5778),
    [anon_sym_PERCENT] = ACTIONS(5780),
    [anon_sym_PERCENT_EQ] = ACTIONS(5778),
    [anon_sym_CARET] = ACTIONS(5780),
    [anon_sym_CARET_EQ] = ACTIONS(5778),
    [anon_sym_PLUS_EQ] = ACTIONS(5778),
    [anon_sym_LT] = ACTIONS(5780),
    [anon_sym_LT_LT] = ACTIONS(5780),
    [anon_sym_LT_LT_EQ] = ACTIONS(5778),
    [anon_sym_LT_EQ] = ACTIONS(5778),
    [anon_sym_EQ] = ACTIONS(5780),
    [anon_sym_EQ_EQ] = ACTIONS(5778),
    [anon_sym_GT] = ACTIONS(5780),
    [anon_sym_GT_EQ] = ACTIONS(5778),
    [anon_sym_GT_GT] = ACTIONS(5780),
    [anon_sym_GT_GT_EQ] = ACTIONS(5778),
    [anon_sym_PIPE] = ACTIONS(5780),
    [anon_sym_PIPE_EQ] = ACTIONS(5778),
    [anon_sym_PIPE_PIPE] = ACTIONS(5778),
    [anon_sym_QMARK] = ACTIONS(5778),
    [anon_sym_DOT_DOT] = ACTIONS(5780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5778),
    [anon_sym_as] = ACTIONS(5780),
    [sym_mutable_specifier] = ACTIONS(5780),
    [anon_sym_ref] = ACTIONS(5780),
    [sym_integer_literal] = ACTIONS(5778),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(5778),
    [sym_char_literal] = ACTIONS(5778),
    [anon_sym_true] = ACTIONS(5780),
    [anon_sym_false] = ACTIONS(5780),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(5780),
    [sym_self] = ACTIONS(5780),
    [sym_super] = ACTIONS(5780),
    [sym_crate] = ACTIONS(5780),
    [sym_metavariable] = ACTIONS(5778),
  },
  [3561] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(4558),
    [anon_sym_EQ_GT] = ACTIONS(4558),
    [anon_sym_LBRACK] = ACTIONS(4558),
    [anon_sym_PLUS] = ACTIONS(4560),
    [anon_sym_STAR] = ACTIONS(4560),
    [anon_sym_AMP] = ACTIONS(4560),
    [anon_sym_DASH] = ACTIONS(4560),
    [anon_sym_DOT] = ACTIONS(4560),
    [anon_sym_DASH_EQ] = ACTIONS(4558),
    [anon_sym_BANG_EQ] = ACTIONS(4558),
    [anon_sym_STAR_EQ] = ACTIONS(4558),
    [anon_sym_SLASH] = ACTIONS(4560),
    [anon_sym_SLASH_EQ] = ACTIONS(4558),
    [anon_sym_AMP_AMP] = ACTIONS(4558),
    [anon_sym_AMP_EQ] = ACTIONS(4558),
    [anon_sym_PERCENT] = ACTIONS(4560),
    [anon_sym_PERCENT_EQ] = ACTIONS(4558),
    [anon_sym_CARET] = ACTIONS(4560),
    [anon_sym_CARET_EQ] = ACTIONS(4558),
    [anon_sym_PLUS_EQ] = ACTIONS(4558),
    [anon_sym_LT] = ACTIONS(4560),
    [anon_sym_LT_LT] = ACTIONS(4560),
    [anon_sym_LT_LT_EQ] = ACTIONS(4558),
    [anon_sym_LT_EQ] = ACTIONS(4558),
    [anon_sym_EQ] = ACTIONS(4560),
    [anon_sym_EQ_EQ] = ACTIONS(4558),
    [anon_sym_GT] = ACTIONS(4560),
    [anon_sym_GT_EQ] = ACTIONS(4558),
    [anon_sym_GT_GT] = ACTIONS(4560),
    [anon_sym_GT_GT_EQ] = ACTIONS(4558),
    [anon_sym_PIPE] = ACTIONS(4560),
    [anon_sym_PIPE_EQ] = ACTIONS(4558),
    [anon_sym_PIPE_PIPE] = ACTIONS(4558),
    [anon_sym_QMARK] = ACTIONS(4558),
    [anon_sym_DOT_DOT] = ACTIONS(4560),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4558),
    [anon_sym_as] = ACTIONS(4558),
    [sym_line_comment] = ACTIONS(7),
  },
  [3562] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(7814),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(2749),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_BANG_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH] = ACTIONS(563),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(563),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_LT] = ACTIONS(577),
    [anon_sym_LT_LT] = ACTIONS(579),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(581),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(577),
    [anon_sym_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(579),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(589),
    [anon_sym_as] = ACTIONS(591),
    [sym_line_comment] = ACTIONS(7),
  },
  [3563] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(4685),
    [anon_sym_EQ_GT] = ACTIONS(4685),
    [anon_sym_LBRACK] = ACTIONS(4685),
    [anon_sym_PLUS] = ACTIONS(4687),
    [anon_sym_STAR] = ACTIONS(4687),
    [anon_sym_AMP] = ACTIONS(4687),
    [anon_sym_DASH] = ACTIONS(4687),
    [anon_sym_DOT] = ACTIONS(4687),
    [anon_sym_DASH_EQ] = ACTIONS(4685),
    [anon_sym_BANG_EQ] = ACTIONS(4685),
    [anon_sym_STAR_EQ] = ACTIONS(4685),
    [anon_sym_SLASH] = ACTIONS(4687),
    [anon_sym_SLASH_EQ] = ACTIONS(4685),
    [anon_sym_AMP_AMP] = ACTIONS(4685),
    [anon_sym_AMP_EQ] = ACTIONS(4685),
    [anon_sym_PERCENT] = ACTIONS(4687),
    [anon_sym_PERCENT_EQ] = ACTIONS(4685),
    [anon_sym_CARET] = ACTIONS(4687),
    [anon_sym_CARET_EQ] = ACTIONS(4685),
    [anon_sym_PLUS_EQ] = ACTIONS(4685),
    [anon_sym_LT] = ACTIONS(4687),
    [anon_sym_LT_LT] = ACTIONS(4687),
    [anon_sym_LT_LT_EQ] = ACTIONS(4685),
    [anon_sym_LT_EQ] = ACTIONS(4685),
    [anon_sym_EQ] = ACTIONS(4687),
    [anon_sym_EQ_EQ] = ACTIONS(4685),
    [anon_sym_GT] = ACTIONS(4687),
    [anon_sym_GT_EQ] = ACTIONS(4685),
    [anon_sym_GT_GT] = ACTIONS(4687),
    [anon_sym_GT_GT_EQ] = ACTIONS(4685),
    [anon_sym_PIPE] = ACTIONS(4687),
    [anon_sym_PIPE_EQ] = ACTIONS(4685),
    [anon_sym_PIPE_PIPE] = ACTIONS(4685),
    [anon_sym_QMARK] = ACTIONS(4685),
    [anon_sym_DOT_DOT] = ACTIONS(4687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4685),
    [anon_sym_as] = ACTIONS(4685),
    [sym_line_comment] = ACTIONS(7),
  },
  [3564] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5013),
    [anon_sym_EQ_GT] = ACTIONS(5013),
    [anon_sym_LBRACK] = ACTIONS(5013),
    [anon_sym_PLUS] = ACTIONS(5015),
    [anon_sym_STAR] = ACTIONS(5015),
    [anon_sym_AMP] = ACTIONS(5015),
    [anon_sym_DASH] = ACTIONS(5015),
    [anon_sym_DOT] = ACTIONS(5015),
    [anon_sym_DASH_EQ] = ACTIONS(5013),
    [anon_sym_BANG_EQ] = ACTIONS(5013),
    [anon_sym_STAR_EQ] = ACTIONS(5013),
    [anon_sym_SLASH] = ACTIONS(5015),
    [anon_sym_SLASH_EQ] = ACTIONS(5013),
    [anon_sym_AMP_AMP] = ACTIONS(5013),
    [anon_sym_AMP_EQ] = ACTIONS(5013),
    [anon_sym_PERCENT] = ACTIONS(5015),
    [anon_sym_PERCENT_EQ] = ACTIONS(5013),
    [anon_sym_CARET] = ACTIONS(5015),
    [anon_sym_CARET_EQ] = ACTIONS(5013),
    [anon_sym_PLUS_EQ] = ACTIONS(5013),
    [anon_sym_LT] = ACTIONS(5015),
    [anon_sym_LT_LT] = ACTIONS(5015),
    [anon_sym_LT_LT_EQ] = ACTIONS(5013),
    [anon_sym_LT_EQ] = ACTIONS(5013),
    [anon_sym_EQ] = ACTIONS(5015),
    [anon_sym_EQ_EQ] = ACTIONS(5013),
    [anon_sym_GT] = ACTIONS(5015),
    [anon_sym_GT_EQ] = ACTIONS(5013),
    [anon_sym_GT_GT] = ACTIONS(5015),
    [anon_sym_GT_GT_EQ] = ACTIONS(5013),
    [anon_sym_PIPE] = ACTIONS(5015),
    [anon_sym_PIPE_EQ] = ACTIONS(5013),
    [anon_sym_PIPE_PIPE] = ACTIONS(5013),
    [anon_sym_QMARK] = ACTIONS(5013),
    [anon_sym_DOT_DOT] = ACTIONS(5015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5013),
    [anon_sym_as] = ACTIONS(5013),
    [sym_line_comment] = ACTIONS(7),
  },
  [3565] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(3642),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [3566] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5027),
    [anon_sym_EQ_GT] = ACTIONS(5027),
    [anon_sym_LBRACK] = ACTIONS(5027),
    [anon_sym_PLUS] = ACTIONS(5029),
    [anon_sym_STAR] = ACTIONS(5029),
    [anon_sym_AMP] = ACTIONS(5029),
    [anon_sym_DASH] = ACTIONS(5029),
    [anon_sym_DOT] = ACTIONS(5029),
    [anon_sym_DASH_EQ] = ACTIONS(5027),
    [anon_sym_BANG_EQ] = ACTIONS(5027),
    [anon_sym_STAR_EQ] = ACTIONS(5027),
    [anon_sym_SLASH] = ACTIONS(5029),
    [anon_sym_SLASH_EQ] = ACTIONS(5027),
    [anon_sym_AMP_AMP] = ACTIONS(5027),
    [anon_sym_AMP_EQ] = ACTIONS(5027),
    [anon_sym_PERCENT] = ACTIONS(5029),
    [anon_sym_PERCENT_EQ] = ACTIONS(5027),
    [anon_sym_CARET] = ACTIONS(5029),
    [anon_sym_CARET_EQ] = ACTIONS(5027),
    [anon_sym_PLUS_EQ] = ACTIONS(5027),
    [anon_sym_LT] = ACTIONS(5029),
    [anon_sym_LT_LT] = ACTIONS(5029),
    [anon_sym_LT_LT_EQ] = ACTIONS(5027),
    [anon_sym_LT_EQ] = ACTIONS(5027),
    [anon_sym_EQ] = ACTIONS(5029),
    [anon_sym_EQ_EQ] = ACTIONS(5027),
    [anon_sym_GT] = ACTIONS(5029),
    [anon_sym_GT_EQ] = ACTIONS(5027),
    [anon_sym_GT_GT] = ACTIONS(5029),
    [anon_sym_GT_GT_EQ] = ACTIONS(5027),
    [anon_sym_PIPE] = ACTIONS(5029),
    [anon_sym_PIPE_EQ] = ACTIONS(5027),
    [anon_sym_PIPE_PIPE] = ACTIONS(5027),
    [anon_sym_QMARK] = ACTIONS(5027),
    [anon_sym_DOT_DOT] = ACTIONS(5029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5027),
    [anon_sym_as] = ACTIONS(5027),
    [sym_line_comment] = ACTIONS(7),
  },
  [3567] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5130),
    [anon_sym_EQ_GT] = ACTIONS(5130),
    [anon_sym_LBRACK] = ACTIONS(5130),
    [anon_sym_PLUS] = ACTIONS(5132),
    [anon_sym_STAR] = ACTIONS(5132),
    [anon_sym_AMP] = ACTIONS(5132),
    [anon_sym_DASH] = ACTIONS(5132),
    [anon_sym_DOT] = ACTIONS(5132),
    [anon_sym_DASH_EQ] = ACTIONS(5130),
    [anon_sym_BANG_EQ] = ACTIONS(5130),
    [anon_sym_STAR_EQ] = ACTIONS(5130),
    [anon_sym_SLASH] = ACTIONS(5132),
    [anon_sym_SLASH_EQ] = ACTIONS(5130),
    [anon_sym_AMP_AMP] = ACTIONS(5130),
    [anon_sym_AMP_EQ] = ACTIONS(5130),
    [anon_sym_PERCENT] = ACTIONS(5132),
    [anon_sym_PERCENT_EQ] = ACTIONS(5130),
    [anon_sym_CARET] = ACTIONS(5132),
    [anon_sym_CARET_EQ] = ACTIONS(5130),
    [anon_sym_PLUS_EQ] = ACTIONS(5130),
    [anon_sym_LT] = ACTIONS(5132),
    [anon_sym_LT_LT] = ACTIONS(5132),
    [anon_sym_LT_LT_EQ] = ACTIONS(5130),
    [anon_sym_LT_EQ] = ACTIONS(5130),
    [anon_sym_EQ] = ACTIONS(5132),
    [anon_sym_EQ_EQ] = ACTIONS(5130),
    [anon_sym_GT] = ACTIONS(5132),
    [anon_sym_GT_EQ] = ACTIONS(5130),
    [anon_sym_GT_GT] = ACTIONS(5132),
    [anon_sym_GT_GT_EQ] = ACTIONS(5130),
    [anon_sym_PIPE] = ACTIONS(5132),
    [anon_sym_PIPE_EQ] = ACTIONS(5130),
    [anon_sym_PIPE_PIPE] = ACTIONS(5130),
    [anon_sym_QMARK] = ACTIONS(5130),
    [anon_sym_DOT_DOT] = ACTIONS(5132),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5130),
    [anon_sym_as] = ACTIONS(5130),
    [sym_line_comment] = ACTIONS(7),
  },
  [3568] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7816),
    [sym_line_comment] = ACTIONS(7),
  },
  [3569] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(3644),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [3570] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5393),
    [anon_sym_EQ_GT] = ACTIONS(5393),
    [anon_sym_LBRACK] = ACTIONS(5393),
    [anon_sym_PLUS] = ACTIONS(5395),
    [anon_sym_STAR] = ACTIONS(5395),
    [anon_sym_AMP] = ACTIONS(5395),
    [anon_sym_DASH] = ACTIONS(5395),
    [anon_sym_DOT] = ACTIONS(5395),
    [anon_sym_DASH_EQ] = ACTIONS(5393),
    [anon_sym_BANG_EQ] = ACTIONS(5393),
    [anon_sym_STAR_EQ] = ACTIONS(5393),
    [anon_sym_SLASH] = ACTIONS(5395),
    [anon_sym_SLASH_EQ] = ACTIONS(5393),
    [anon_sym_AMP_AMP] = ACTIONS(5393),
    [anon_sym_AMP_EQ] = ACTIONS(5393),
    [anon_sym_PERCENT] = ACTIONS(5395),
    [anon_sym_PERCENT_EQ] = ACTIONS(5393),
    [anon_sym_CARET] = ACTIONS(5395),
    [anon_sym_CARET_EQ] = ACTIONS(5393),
    [anon_sym_PLUS_EQ] = ACTIONS(5393),
    [anon_sym_LT] = ACTIONS(5395),
    [anon_sym_LT_LT] = ACTIONS(5395),
    [anon_sym_LT_LT_EQ] = ACTIONS(5393),
    [anon_sym_LT_EQ] = ACTIONS(5393),
    [anon_sym_EQ] = ACTIONS(5395),
    [anon_sym_EQ_EQ] = ACTIONS(5393),
    [anon_sym_GT] = ACTIONS(5395),
    [anon_sym_GT_EQ] = ACTIONS(5393),
    [anon_sym_GT_GT] = ACTIONS(5395),
    [anon_sym_GT_GT_EQ] = ACTIONS(5393),
    [anon_sym_PIPE] = ACTIONS(5395),
    [anon_sym_PIPE_EQ] = ACTIONS(5393),
    [anon_sym_PIPE_PIPE] = ACTIONS(5393),
    [anon_sym_QMARK] = ACTIONS(5393),
    [anon_sym_DOT_DOT] = ACTIONS(5395),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5393),
    [anon_sym_as] = ACTIONS(5393),
    [sym_line_comment] = ACTIONS(7),
  },
  [3571] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5437),
    [anon_sym_EQ_GT] = ACTIONS(5437),
    [anon_sym_LBRACK] = ACTIONS(5437),
    [anon_sym_PLUS] = ACTIONS(5439),
    [anon_sym_STAR] = ACTIONS(5439),
    [anon_sym_AMP] = ACTIONS(5439),
    [anon_sym_DASH] = ACTIONS(5439),
    [anon_sym_DOT] = ACTIONS(5439),
    [anon_sym_DASH_EQ] = ACTIONS(5437),
    [anon_sym_BANG_EQ] = ACTIONS(5437),
    [anon_sym_STAR_EQ] = ACTIONS(5437),
    [anon_sym_SLASH] = ACTIONS(5439),
    [anon_sym_SLASH_EQ] = ACTIONS(5437),
    [anon_sym_AMP_AMP] = ACTIONS(5437),
    [anon_sym_AMP_EQ] = ACTIONS(5437),
    [anon_sym_PERCENT] = ACTIONS(5439),
    [anon_sym_PERCENT_EQ] = ACTIONS(5437),
    [anon_sym_CARET] = ACTIONS(5439),
    [anon_sym_CARET_EQ] = ACTIONS(5437),
    [anon_sym_PLUS_EQ] = ACTIONS(5437),
    [anon_sym_LT] = ACTIONS(5439),
    [anon_sym_LT_LT] = ACTIONS(5439),
    [anon_sym_LT_LT_EQ] = ACTIONS(5437),
    [anon_sym_LT_EQ] = ACTIONS(5437),
    [anon_sym_EQ] = ACTIONS(5439),
    [anon_sym_EQ_EQ] = ACTIONS(5437),
    [anon_sym_GT] = ACTIONS(5439),
    [anon_sym_GT_EQ] = ACTIONS(5437),
    [anon_sym_GT_GT] = ACTIONS(5439),
    [anon_sym_GT_GT_EQ] = ACTIONS(5437),
    [anon_sym_PIPE] = ACTIONS(5439),
    [anon_sym_PIPE_EQ] = ACTIONS(5437),
    [anon_sym_PIPE_PIPE] = ACTIONS(5437),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_DOT_DOT] = ACTIONS(5439),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5437),
    [anon_sym_as] = ACTIONS(5437),
    [sym_line_comment] = ACTIONS(7),
  },
  [3572] = {
    [sym_attribute_item] = STATE(582),
    [sym_field_initializer] = STATE(1831),
    [sym_base_field_initializer] = STATE(1831),
    [aux_sym_enum_variant_list_repeat1] = STATE(582),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7818),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_DOT_DOT] = ACTIONS(1135),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3535),
  },
  [3573] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5450),
    [anon_sym_EQ_GT] = ACTIONS(5450),
    [anon_sym_LBRACK] = ACTIONS(5450),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_DASH] = ACTIONS(5452),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_DASH_EQ] = ACTIONS(5450),
    [anon_sym_BANG_EQ] = ACTIONS(5450),
    [anon_sym_STAR_EQ] = ACTIONS(5450),
    [anon_sym_SLASH] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5450),
    [anon_sym_AMP_AMP] = ACTIONS(5450),
    [anon_sym_AMP_EQ] = ACTIONS(5450),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [anon_sym_PERCENT_EQ] = ACTIONS(5450),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_CARET_EQ] = ACTIONS(5450),
    [anon_sym_PLUS_EQ] = ACTIONS(5450),
    [anon_sym_LT] = ACTIONS(5452),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5450),
    [anon_sym_LT_EQ] = ACTIONS(5450),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_EQ_EQ] = ACTIONS(5450),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5450),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_GT_GT_EQ] = ACTIONS(5450),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_PIPE_EQ] = ACTIONS(5450),
    [anon_sym_PIPE_PIPE] = ACTIONS(5450),
    [anon_sym_QMARK] = ACTIONS(5450),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5450),
    [anon_sym_as] = ACTIONS(5450),
    [sym_line_comment] = ACTIONS(7),
  },
  [3574] = {
    [sym_attribute_item] = STATE(582),
    [sym_field_initializer] = STATE(1831),
    [sym_base_field_initializer] = STATE(1831),
    [aux_sym_enum_variant_list_repeat1] = STATE(582),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(7820),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_DOT_DOT] = ACTIONS(1135),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(3535),
  },
  [3575] = {
    [sym_function_modifiers] = STATE(854),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2151),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2152),
    [sym_array_type] = STATE(2151),
    [sym_function_type] = STATE(2151),
    [sym_tuple_type] = STATE(2151),
    [sym_unit_type] = STATE(2151),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2151),
    [sym_type_binding] = STATE(2153),
    [sym_reference_type] = STATE(2151),
    [sym_pointer_type] = STATE(2151),
    [sym_empty_type] = STATE(2151),
    [sym_dynamic_type] = STATE(2151),
    [sym_macro_invocation] = STATE(2151),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(858),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1786),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1788),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_GT] = ACTIONS(7822),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1790),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1792),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3576] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(4830),
    [anon_sym_LBRACE] = ACTIONS(4830),
    [anon_sym_EQ_GT] = ACTIONS(4830),
    [anon_sym_LBRACK] = ACTIONS(4830),
    [anon_sym_PLUS] = ACTIONS(4832),
    [anon_sym_STAR] = ACTIONS(4832),
    [anon_sym_AMP] = ACTIONS(4832),
    [anon_sym_DASH] = ACTIONS(4832),
    [anon_sym_DOT] = ACTIONS(4832),
    [anon_sym_DASH_EQ] = ACTIONS(4830),
    [anon_sym_COLON_COLON] = ACTIONS(4830),
    [anon_sym_BANG_EQ] = ACTIONS(4830),
    [anon_sym_STAR_EQ] = ACTIONS(4830),
    [anon_sym_SLASH] = ACTIONS(4832),
    [anon_sym_SLASH_EQ] = ACTIONS(4830),
    [anon_sym_AMP_AMP] = ACTIONS(4830),
    [anon_sym_AMP_EQ] = ACTIONS(4830),
    [anon_sym_PERCENT] = ACTIONS(4832),
    [anon_sym_PERCENT_EQ] = ACTIONS(4830),
    [anon_sym_CARET] = ACTIONS(4832),
    [anon_sym_CARET_EQ] = ACTIONS(4830),
    [anon_sym_PLUS_EQ] = ACTIONS(4830),
    [anon_sym_LT] = ACTIONS(4832),
    [anon_sym_LT_LT] = ACTIONS(4832),
    [anon_sym_LT_LT_EQ] = ACTIONS(4830),
    [anon_sym_LT_EQ] = ACTIONS(4830),
    [anon_sym_EQ] = ACTIONS(4832),
    [anon_sym_EQ_EQ] = ACTIONS(4830),
    [anon_sym_GT] = ACTIONS(4832),
    [anon_sym_GT_EQ] = ACTIONS(4830),
    [anon_sym_GT_GT] = ACTIONS(4832),
    [anon_sym_GT_GT_EQ] = ACTIONS(4830),
    [anon_sym_PIPE] = ACTIONS(4832),
    [anon_sym_PIPE_EQ] = ACTIONS(4830),
    [anon_sym_PIPE_PIPE] = ACTIONS(4830),
    [anon_sym_QMARK] = ACTIONS(4830),
    [anon_sym_DOT_DOT] = ACTIONS(4832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4830),
    [anon_sym_as] = ACTIONS(4830),
    [sym_line_comment] = ACTIONS(7),
  },
  [3577] = {
    [aux_sym_type_arguments_repeat1] = STATE(2155),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(7824),
    [anon_sym_GT] = ACTIONS(7822),
    [sym_line_comment] = ACTIONS(7),
  },
  [3578] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5554),
    [anon_sym_EQ_GT] = ACTIONS(5554),
    [anon_sym_LBRACK] = ACTIONS(5554),
    [anon_sym_PLUS] = ACTIONS(5556),
    [anon_sym_STAR] = ACTIONS(5556),
    [anon_sym_AMP] = ACTIONS(5556),
    [anon_sym_DASH] = ACTIONS(5556),
    [anon_sym_DOT] = ACTIONS(5556),
    [anon_sym_DASH_EQ] = ACTIONS(5554),
    [anon_sym_BANG_EQ] = ACTIONS(5554),
    [anon_sym_STAR_EQ] = ACTIONS(5554),
    [anon_sym_SLASH] = ACTIONS(5556),
    [anon_sym_SLASH_EQ] = ACTIONS(5554),
    [anon_sym_AMP_AMP] = ACTIONS(5554),
    [anon_sym_AMP_EQ] = ACTIONS(5554),
    [anon_sym_PERCENT] = ACTIONS(5556),
    [anon_sym_PERCENT_EQ] = ACTIONS(5554),
    [anon_sym_CARET] = ACTIONS(5556),
    [anon_sym_CARET_EQ] = ACTIONS(5554),
    [anon_sym_PLUS_EQ] = ACTIONS(5554),
    [anon_sym_LT] = ACTIONS(5556),
    [anon_sym_LT_LT] = ACTIONS(5556),
    [anon_sym_LT_LT_EQ] = ACTIONS(5554),
    [anon_sym_LT_EQ] = ACTIONS(5554),
    [anon_sym_EQ] = ACTIONS(5556),
    [anon_sym_EQ_EQ] = ACTIONS(5554),
    [anon_sym_GT] = ACTIONS(5556),
    [anon_sym_GT_EQ] = ACTIONS(5554),
    [anon_sym_GT_GT] = ACTIONS(5556),
    [anon_sym_GT_GT_EQ] = ACTIONS(5554),
    [anon_sym_PIPE] = ACTIONS(5556),
    [anon_sym_PIPE_EQ] = ACTIONS(5554),
    [anon_sym_PIPE_PIPE] = ACTIONS(5554),
    [anon_sym_QMARK] = ACTIONS(5554),
    [anon_sym_DOT_DOT] = ACTIONS(5556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5554),
    [anon_sym_as] = ACTIONS(5554),
    [sym_line_comment] = ACTIONS(7),
  },
  [3579] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1972),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1972),
    [sym_unary_expression] = STATE(1972),
    [sym_try_expression] = STATE(1972),
    [sym_reference_expression] = STATE(1972),
    [sym_binary_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1972),
    [sym_call_expression] = STATE(1972),
    [sym_array_expression] = STATE(1972),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_tuple_expression] = STATE(1972),
    [sym_unit_expression] = STATE(1972),
    [sym_struct_expression] = STATE(1972),
    [sym_if_expression] = STATE(1972),
    [sym_if_let_expression] = STATE(1972),
    [sym_match_expression] = STATE(1972),
    [sym_while_expression] = STATE(1972),
    [sym_while_let_expression] = STATE(1972),
    [sym_loop_expression] = STATE(1972),
    [sym_for_expression] = STATE(1972),
    [sym_closure_expression] = STATE(1972),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1972),
    [sym_continue_expression] = STATE(1972),
    [sym_index_expression] = STATE(1972),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1972),
    [sym_block] = STATE(1972),
    [sym__literal] = STATE(1972),
    [sym_string_literal] = STATE(1972),
    [sym_boolean_literal] = STATE(1972),
    [sym_raw_string_literal] = ACTIONS(4375),
    [sym_float_literal] = ACTIONS(4375),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(7826),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(4375),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4375),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [3580] = {
    [aux_sym_token_tree_repeat2] = STATE(1974),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7826),
    [anon_sym_COMMA] = ACTIONS(7828),
    [sym_line_comment] = ACTIONS(7),
  },
  [3581] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5564),
    [anon_sym_EQ_GT] = ACTIONS(5564),
    [anon_sym_LBRACK] = ACTIONS(5564),
    [anon_sym_PLUS] = ACTIONS(5566),
    [anon_sym_STAR] = ACTIONS(5566),
    [anon_sym_AMP] = ACTIONS(5566),
    [anon_sym_DASH] = ACTIONS(5566),
    [anon_sym_DOT] = ACTIONS(5566),
    [anon_sym_DASH_EQ] = ACTIONS(5564),
    [anon_sym_BANG_EQ] = ACTIONS(5564),
    [anon_sym_STAR_EQ] = ACTIONS(5564),
    [anon_sym_SLASH] = ACTIONS(5566),
    [anon_sym_SLASH_EQ] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_AMP_EQ] = ACTIONS(5564),
    [anon_sym_PERCENT] = ACTIONS(5566),
    [anon_sym_PERCENT_EQ] = ACTIONS(5564),
    [anon_sym_CARET] = ACTIONS(5566),
    [anon_sym_CARET_EQ] = ACTIONS(5564),
    [anon_sym_PLUS_EQ] = ACTIONS(5564),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_LT_LT_EQ] = ACTIONS(5564),
    [anon_sym_LT_EQ] = ACTIONS(5564),
    [anon_sym_EQ] = ACTIONS(5566),
    [anon_sym_EQ_EQ] = ACTIONS(5564),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_EQ] = ACTIONS(5564),
    [anon_sym_GT_GT] = ACTIONS(5566),
    [anon_sym_GT_GT_EQ] = ACTIONS(5564),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_PIPE_EQ] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_QMARK] = ACTIONS(5564),
    [anon_sym_DOT_DOT] = ACTIONS(5566),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5564),
    [anon_sym_as] = ACTIONS(5564),
    [sym_line_comment] = ACTIONS(7),
  },
  [3582] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(7826),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(619),
    [anon_sym_AMP] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(623),
    [anon_sym_BANG_EQ] = ACTIONS(625),
    [anon_sym_STAR_EQ] = ACTIONS(623),
    [anon_sym_SLASH] = ACTIONS(619),
    [anon_sym_SLASH_EQ] = ACTIONS(623),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_AMP_EQ] = ACTIONS(623),
    [anon_sym_PERCENT] = ACTIONS(619),
    [anon_sym_PERCENT_EQ] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(629),
    [anon_sym_CARET_EQ] = ACTIONS(623),
    [anon_sym_PLUS_EQ] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_LT_LT] = ACTIONS(633),
    [anon_sym_LT_LT_EQ] = ACTIONS(623),
    [anon_sym_LT_EQ] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(625),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_GT_GT_EQ] = ACTIONS(623),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_PIPE_EQ] = ACTIONS(623),
    [anon_sym_PIPE_PIPE] = ACTIONS(639),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(643),
    [anon_sym_as] = ACTIONS(645),
    [sym_line_comment] = ACTIONS(7),
  },
  [3583] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(769),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(769),
    [sym_macro_invocation] = STATE(769),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(769),
    [sym_unary_expression] = STATE(769),
    [sym_try_expression] = STATE(769),
    [sym_reference_expression] = STATE(769),
    [sym_binary_expression] = STATE(769),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(769),
    [sym_call_expression] = STATE(769),
    [sym_array_expression] = STATE(769),
    [sym_parenthesized_expression] = STATE(769),
    [sym_tuple_expression] = STATE(769),
    [sym_unit_expression] = STATE(769),
    [sym_struct_expression] = STATE(769),
    [sym_if_expression] = STATE(769),
    [sym_if_let_expression] = STATE(769),
    [sym_match_expression] = STATE(769),
    [sym_while_expression] = STATE(769),
    [sym_while_let_expression] = STATE(769),
    [sym_loop_expression] = STATE(769),
    [sym_for_expression] = STATE(769),
    [sym_closure_expression] = STATE(769),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(769),
    [sym_continue_expression] = STATE(769),
    [sym_index_expression] = STATE(769),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(769),
    [sym_block] = STATE(769),
    [sym__literal] = STATE(769),
    [sym_string_literal] = STATE(769),
    [sym_boolean_literal] = STATE(769),
    [sym_raw_string_literal] = ACTIONS(1620),
    [sym_float_literal] = ACTIONS(1620),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_RBRACK] = ACTIONS(7826),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1620),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1620),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [3584] = {
    [aux_sym_token_tree_repeat2] = STATE(789),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RBRACK] = ACTIONS(7826),
    [anon_sym_COMMA] = ACTIONS(7830),
    [sym_line_comment] = ACTIONS(7),
  },
  [3585] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5713),
    [anon_sym_EQ_GT] = ACTIONS(5713),
    [anon_sym_LBRACK] = ACTIONS(5713),
    [anon_sym_PLUS] = ACTIONS(5715),
    [anon_sym_STAR] = ACTIONS(5715),
    [anon_sym_AMP] = ACTIONS(5715),
    [anon_sym_DASH] = ACTIONS(5715),
    [anon_sym_DOT] = ACTIONS(5715),
    [anon_sym_DASH_EQ] = ACTIONS(5713),
    [anon_sym_BANG_EQ] = ACTIONS(5713),
    [anon_sym_STAR_EQ] = ACTIONS(5713),
    [anon_sym_SLASH] = ACTIONS(5715),
    [anon_sym_SLASH_EQ] = ACTIONS(5713),
    [anon_sym_AMP_AMP] = ACTIONS(5713),
    [anon_sym_AMP_EQ] = ACTIONS(5713),
    [anon_sym_PERCENT] = ACTIONS(5715),
    [anon_sym_PERCENT_EQ] = ACTIONS(5713),
    [anon_sym_CARET] = ACTIONS(5715),
    [anon_sym_CARET_EQ] = ACTIONS(5713),
    [anon_sym_PLUS_EQ] = ACTIONS(5713),
    [anon_sym_LT] = ACTIONS(5715),
    [anon_sym_LT_LT] = ACTIONS(5715),
    [anon_sym_LT_LT_EQ] = ACTIONS(5713),
    [anon_sym_LT_EQ] = ACTIONS(5713),
    [anon_sym_EQ] = ACTIONS(5715),
    [anon_sym_EQ_EQ] = ACTIONS(5713),
    [anon_sym_GT] = ACTIONS(5715),
    [anon_sym_GT_EQ] = ACTIONS(5713),
    [anon_sym_GT_GT] = ACTIONS(5715),
    [anon_sym_GT_GT_EQ] = ACTIONS(5713),
    [anon_sym_PIPE] = ACTIONS(5715),
    [anon_sym_PIPE_EQ] = ACTIONS(5713),
    [anon_sym_PIPE_PIPE] = ACTIONS(5713),
    [anon_sym_QMARK] = ACTIONS(5713),
    [anon_sym_DOT_DOT] = ACTIONS(5715),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5713),
    [anon_sym_as] = ACTIONS(5713),
    [sym_line_comment] = ACTIONS(7),
  },
  [3586] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1972),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1972),
    [sym_unary_expression] = STATE(1972),
    [sym_try_expression] = STATE(1972),
    [sym_reference_expression] = STATE(1972),
    [sym_binary_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1972),
    [sym_call_expression] = STATE(1972),
    [sym_array_expression] = STATE(1972),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_tuple_expression] = STATE(1972),
    [sym_unit_expression] = STATE(1972),
    [sym_struct_expression] = STATE(1972),
    [sym_if_expression] = STATE(1972),
    [sym_if_let_expression] = STATE(1972),
    [sym_match_expression] = STATE(1972),
    [sym_while_expression] = STATE(1972),
    [sym_while_let_expression] = STATE(1972),
    [sym_loop_expression] = STATE(1972),
    [sym_for_expression] = STATE(1972),
    [sym_closure_expression] = STATE(1972),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1972),
    [sym_continue_expression] = STATE(1972),
    [sym_index_expression] = STATE(1972),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1972),
    [sym_block] = STATE(1972),
    [sym__literal] = STATE(1972),
    [sym_string_literal] = STATE(1972),
    [sym_boolean_literal] = STATE(1972),
    [sym_raw_string_literal] = ACTIONS(4375),
    [sym_float_literal] = ACTIONS(4375),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(7832),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(4375),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4375),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [3587] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_EQ_GT] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2884),
    [anon_sym_PLUS] = ACTIONS(5736),
    [anon_sym_STAR] = ACTIONS(5736),
    [anon_sym_AMP] = ACTIONS(5736),
    [anon_sym_DASH] = ACTIONS(5736),
    [anon_sym_DOT] = ACTIONS(5736),
    [anon_sym_DASH_EQ] = ACTIONS(2884),
    [anon_sym_BANG_EQ] = ACTIONS(2884),
    [anon_sym_STAR_EQ] = ACTIONS(2884),
    [anon_sym_SLASH] = ACTIONS(5736),
    [anon_sym_SLASH_EQ] = ACTIONS(2884),
    [anon_sym_AMP_AMP] = ACTIONS(2884),
    [anon_sym_AMP_EQ] = ACTIONS(2884),
    [anon_sym_PERCENT] = ACTIONS(5736),
    [anon_sym_PERCENT_EQ] = ACTIONS(2884),
    [anon_sym_CARET] = ACTIONS(5736),
    [anon_sym_CARET_EQ] = ACTIONS(2884),
    [anon_sym_PLUS_EQ] = ACTIONS(2884),
    [anon_sym_LT] = ACTIONS(5736),
    [anon_sym_LT_LT] = ACTIONS(5736),
    [anon_sym_LT_LT_EQ] = ACTIONS(2884),
    [anon_sym_LT_EQ] = ACTIONS(2884),
    [anon_sym_EQ] = ACTIONS(5736),
    [anon_sym_EQ_EQ] = ACTIONS(2884),
    [anon_sym_GT] = ACTIONS(5736),
    [anon_sym_GT_EQ] = ACTIONS(2884),
    [anon_sym_GT_GT] = ACTIONS(5736),
    [anon_sym_GT_GT_EQ] = ACTIONS(2884),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_PIPE_EQ] = ACTIONS(2884),
    [anon_sym_PIPE_PIPE] = ACTIONS(2884),
    [anon_sym_QMARK] = ACTIONS(2884),
    [anon_sym_DOT_DOT] = ACTIONS(5736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2884),
    [anon_sym_as] = ACTIONS(2884),
    [sym_line_comment] = ACTIONS(7),
  },
  [3588] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1470),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(1470),
    [sym_function_type] = STATE(1470),
    [sym_tuple_type] = STATE(1470),
    [sym_unit_type] = STATE(1470),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1470),
    [sym_reference_type] = STATE(1470),
    [sym_pointer_type] = STATE(1470),
    [sym_empty_type] = STATE(1470),
    [sym_dynamic_type] = STATE(1470),
    [sym_macro_invocation] = STATE(1470),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_RPAREN] = ACTIONS(7834),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3589] = {
    [aux_sym_tuple_type_repeat1] = STATE(1472),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7834),
    [anon_sym_COMMA] = ACTIONS(7836),
    [sym_line_comment] = ACTIONS(7),
  },
  [3590] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3655),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(3655),
    [sym_macro_invocation] = STATE(3655),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3655),
    [sym_unary_expression] = STATE(3655),
    [sym_try_expression] = STATE(3655),
    [sym_reference_expression] = STATE(3655),
    [sym_binary_expression] = STATE(3655),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3655),
    [sym_call_expression] = STATE(3655),
    [sym_array_expression] = STATE(3655),
    [sym_parenthesized_expression] = STATE(3655),
    [sym_tuple_expression] = STATE(3655),
    [sym_unit_expression] = STATE(3655),
    [sym_struct_expression] = STATE(3655),
    [sym_if_expression] = STATE(3655),
    [sym_if_let_expression] = STATE(3655),
    [sym_match_expression] = STATE(3655),
    [sym_while_expression] = STATE(3655),
    [sym_while_let_expression] = STATE(3655),
    [sym_loop_expression] = STATE(3655),
    [sym_for_expression] = STATE(3655),
    [sym_closure_expression] = STATE(3655),
    [sym_closure_parameters] = STATE(638),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3655),
    [sym_continue_expression] = STATE(3655),
    [sym_index_expression] = STATE(3655),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3655),
    [sym_block] = STATE(3655),
    [sym__literal] = STATE(3655),
    [sym_string_literal] = STATE(3655),
    [sym_boolean_literal] = STATE(3655),
    [sym_raw_string_literal] = ACTIONS(7838),
    [sym_float_literal] = ACTIONS(7838),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1245),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1247),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1251),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1253),
    [sym_integer_literal] = ACTIONS(7838),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7838),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [3591] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_EQ_GT] = ACTIONS(2898),
    [anon_sym_LBRACK] = ACTIONS(2898),
    [anon_sym_PLUS] = ACTIONS(5744),
    [anon_sym_STAR] = ACTIONS(5744),
    [anon_sym_AMP] = ACTIONS(5744),
    [anon_sym_DASH] = ACTIONS(5744),
    [anon_sym_DOT] = ACTIONS(5744),
    [anon_sym_DASH_EQ] = ACTIONS(2898),
    [anon_sym_BANG_EQ] = ACTIONS(2898),
    [anon_sym_STAR_EQ] = ACTIONS(2898),
    [anon_sym_SLASH] = ACTIONS(5744),
    [anon_sym_SLASH_EQ] = ACTIONS(2898),
    [anon_sym_AMP_AMP] = ACTIONS(2898),
    [anon_sym_AMP_EQ] = ACTIONS(2898),
    [anon_sym_PERCENT] = ACTIONS(5744),
    [anon_sym_PERCENT_EQ] = ACTIONS(2898),
    [anon_sym_CARET] = ACTIONS(5744),
    [anon_sym_CARET_EQ] = ACTIONS(2898),
    [anon_sym_PLUS_EQ] = ACTIONS(2898),
    [anon_sym_LT] = ACTIONS(5744),
    [anon_sym_LT_LT] = ACTIONS(5744),
    [anon_sym_LT_LT_EQ] = ACTIONS(2898),
    [anon_sym_LT_EQ] = ACTIONS(2898),
    [anon_sym_EQ] = ACTIONS(5744),
    [anon_sym_EQ_EQ] = ACTIONS(2898),
    [anon_sym_GT] = ACTIONS(5744),
    [anon_sym_GT_EQ] = ACTIONS(2898),
    [anon_sym_GT_GT] = ACTIONS(5744),
    [anon_sym_GT_GT_EQ] = ACTIONS(2898),
    [anon_sym_PIPE] = ACTIONS(5744),
    [anon_sym_PIPE_EQ] = ACTIONS(2898),
    [anon_sym_PIPE_PIPE] = ACTIONS(2898),
    [anon_sym_QMARK] = ACTIONS(2898),
    [anon_sym_DOT_DOT] = ACTIONS(5744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2898),
    [anon_sym_as] = ACTIONS(2898),
    [sym_line_comment] = ACTIONS(7),
  },
  [3592] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2900),
    [anon_sym_EQ_GT] = ACTIONS(2900),
    [anon_sym_LBRACK] = ACTIONS(2900),
    [anon_sym_PLUS] = ACTIONS(5746),
    [anon_sym_STAR] = ACTIONS(5746),
    [anon_sym_AMP] = ACTIONS(5746),
    [anon_sym_DASH] = ACTIONS(5746),
    [anon_sym_DOT] = ACTIONS(5746),
    [anon_sym_DASH_EQ] = ACTIONS(2900),
    [anon_sym_BANG_EQ] = ACTIONS(2900),
    [anon_sym_STAR_EQ] = ACTIONS(2900),
    [anon_sym_SLASH] = ACTIONS(5746),
    [anon_sym_SLASH_EQ] = ACTIONS(2900),
    [anon_sym_AMP_AMP] = ACTIONS(2900),
    [anon_sym_AMP_EQ] = ACTIONS(2900),
    [anon_sym_PERCENT] = ACTIONS(5746),
    [anon_sym_PERCENT_EQ] = ACTIONS(2900),
    [anon_sym_CARET] = ACTIONS(5746),
    [anon_sym_CARET_EQ] = ACTIONS(2900),
    [anon_sym_PLUS_EQ] = ACTIONS(2900),
    [anon_sym_LT] = ACTIONS(5746),
    [anon_sym_LT_LT] = ACTIONS(5746),
    [anon_sym_LT_LT_EQ] = ACTIONS(2900),
    [anon_sym_LT_EQ] = ACTIONS(2900),
    [anon_sym_EQ] = ACTIONS(5746),
    [anon_sym_EQ_EQ] = ACTIONS(2900),
    [anon_sym_GT] = ACTIONS(5746),
    [anon_sym_GT_EQ] = ACTIONS(2900),
    [anon_sym_GT_GT] = ACTIONS(5746),
    [anon_sym_GT_GT_EQ] = ACTIONS(2900),
    [anon_sym_PIPE] = ACTIONS(5746),
    [anon_sym_PIPE_EQ] = ACTIONS(2900),
    [anon_sym_PIPE_PIPE] = ACTIONS(2900),
    [anon_sym_QMARK] = ACTIONS(2900),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2900),
    [anon_sym_as] = ACTIONS(2900),
    [sym_line_comment] = ACTIONS(7),
  },
  [3593] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2902),
    [anon_sym_EQ_GT] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2902),
    [anon_sym_PLUS] = ACTIONS(2904),
    [anon_sym_STAR] = ACTIONS(2904),
    [anon_sym_AMP] = ACTIONS(2904),
    [anon_sym_DASH] = ACTIONS(2904),
    [anon_sym_DOT] = ACTIONS(2904),
    [anon_sym_DASH_EQ] = ACTIONS(2902),
    [anon_sym_COLON_COLON] = ACTIONS(1670),
    [anon_sym_BANG_EQ] = ACTIONS(2902),
    [anon_sym_STAR_EQ] = ACTIONS(2902),
    [anon_sym_SLASH] = ACTIONS(2904),
    [anon_sym_SLASH_EQ] = ACTIONS(2902),
    [anon_sym_AMP_AMP] = ACTIONS(2902),
    [anon_sym_AMP_EQ] = ACTIONS(2902),
    [anon_sym_PERCENT] = ACTIONS(2904),
    [anon_sym_PERCENT_EQ] = ACTIONS(2902),
    [anon_sym_CARET] = ACTIONS(2904),
    [anon_sym_CARET_EQ] = ACTIONS(2902),
    [anon_sym_PLUS_EQ] = ACTIONS(2902),
    [anon_sym_LT] = ACTIONS(2904),
    [anon_sym_LT_LT] = ACTIONS(2904),
    [anon_sym_LT_LT_EQ] = ACTIONS(2902),
    [anon_sym_LT_EQ] = ACTIONS(2902),
    [anon_sym_EQ] = ACTIONS(2904),
    [anon_sym_EQ_EQ] = ACTIONS(2902),
    [anon_sym_GT] = ACTIONS(2904),
    [anon_sym_GT_EQ] = ACTIONS(2902),
    [anon_sym_GT_GT] = ACTIONS(2904),
    [anon_sym_GT_GT_EQ] = ACTIONS(2902),
    [anon_sym_PIPE] = ACTIONS(2904),
    [anon_sym_PIPE_EQ] = ACTIONS(2902),
    [anon_sym_PIPE_PIPE] = ACTIONS(2902),
    [anon_sym_QMARK] = ACTIONS(2902),
    [anon_sym_DOT_DOT] = ACTIONS(2904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2902),
    [anon_sym_as] = ACTIONS(2902),
    [sym_line_comment] = ACTIONS(7),
  },
  [3594] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2906),
    [anon_sym_EQ_GT] = ACTIONS(2906),
    [anon_sym_LBRACK] = ACTIONS(2906),
    [anon_sym_PLUS] = ACTIONS(5748),
    [anon_sym_STAR] = ACTIONS(5748),
    [anon_sym_AMP] = ACTIONS(5748),
    [anon_sym_DASH] = ACTIONS(5748),
    [anon_sym_DOT] = ACTIONS(5748),
    [anon_sym_DASH_EQ] = ACTIONS(2906),
    [anon_sym_BANG_EQ] = ACTIONS(2906),
    [anon_sym_STAR_EQ] = ACTIONS(2906),
    [anon_sym_SLASH] = ACTIONS(5748),
    [anon_sym_SLASH_EQ] = ACTIONS(2906),
    [anon_sym_AMP_AMP] = ACTIONS(2906),
    [anon_sym_AMP_EQ] = ACTIONS(2906),
    [anon_sym_PERCENT] = ACTIONS(5748),
    [anon_sym_PERCENT_EQ] = ACTIONS(2906),
    [anon_sym_CARET] = ACTIONS(5748),
    [anon_sym_CARET_EQ] = ACTIONS(2906),
    [anon_sym_PLUS_EQ] = ACTIONS(2906),
    [anon_sym_LT] = ACTIONS(5748),
    [anon_sym_LT_LT] = ACTIONS(5748),
    [anon_sym_LT_LT_EQ] = ACTIONS(2906),
    [anon_sym_LT_EQ] = ACTIONS(2906),
    [anon_sym_EQ] = ACTIONS(5748),
    [anon_sym_EQ_EQ] = ACTIONS(2906),
    [anon_sym_GT] = ACTIONS(5748),
    [anon_sym_GT_EQ] = ACTIONS(2906),
    [anon_sym_GT_GT] = ACTIONS(5748),
    [anon_sym_GT_GT_EQ] = ACTIONS(2906),
    [anon_sym_PIPE] = ACTIONS(5748),
    [anon_sym_PIPE_EQ] = ACTIONS(2906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2906),
    [anon_sym_QMARK] = ACTIONS(2906),
    [anon_sym_DOT_DOT] = ACTIONS(5748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2906),
    [anon_sym_as] = ACTIONS(2906),
    [sym_line_comment] = ACTIONS(7),
  },
  [3595] = {
    [sym_function_modifiers] = STATE(3246),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3656),
    [sym_bracketed_type] = STATE(3244),
    [sym_lifetime] = STATE(3248),
    [sym_array_type] = STATE(3656),
    [sym_function_type] = STATE(3656),
    [sym_tuple_type] = STATE(3656),
    [sym_unit_type] = STATE(3656),
    [sym_generic_type] = STATE(3249),
    [sym_generic_type_with_turbofish] = STATE(3250),
    [sym_bounded_type] = STATE(3656),
    [sym_reference_type] = STATE(3656),
    [sym_pointer_type] = STATE(3656),
    [sym_empty_type] = STATE(3656),
    [sym_dynamic_type] = STATE(3656),
    [sym_macro_invocation] = STATE(3656),
    [sym_scoped_identifier] = STATE(3251),
    [sym_scoped_type_identifier] = STATE(3252),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7059),
    [anon_sym_LBRACK] = ACTIONS(7061),
    [anon_sym_STAR] = ACTIONS(7063),
    [anon_sym_u8] = ACTIONS(7065),
    [anon_sym_i8] = ACTIONS(7065),
    [anon_sym_u16] = ACTIONS(7065),
    [anon_sym_i16] = ACTIONS(7065),
    [anon_sym_u32] = ACTIONS(7065),
    [anon_sym_i32] = ACTIONS(7065),
    [anon_sym_u64] = ACTIONS(7065),
    [anon_sym_i64] = ACTIONS(7065),
    [anon_sym_u128] = ACTIONS(7065),
    [anon_sym_i128] = ACTIONS(7065),
    [anon_sym_isize] = ACTIONS(7065),
    [anon_sym_usize] = ACTIONS(7065),
    [anon_sym_f32] = ACTIONS(7065),
    [anon_sym_f64] = ACTIONS(7065),
    [anon_sym_bool] = ACTIONS(7065),
    [anon_sym_str] = ACTIONS(7065),
    [anon_sym_char] = ACTIONS(7065),
    [anon_sym_AMP] = ACTIONS(7067),
    [anon_sym_COLON_COLON] = ACTIONS(7069),
    [anon_sym_BANG] = ACTIONS(7071),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(7073),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(7075),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7077),
    [sym_self] = ACTIONS(7079),
    [sym_super] = ACTIONS(7079),
    [sym_crate] = ACTIONS(7079),
    [sym_metavariable] = ACTIONS(7081),
  },
  [3596] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2908),
    [anon_sym_EQ_GT] = ACTIONS(2908),
    [anon_sym_LBRACK] = ACTIONS(2908),
    [anon_sym_PLUS] = ACTIONS(5750),
    [anon_sym_STAR] = ACTIONS(5750),
    [anon_sym_AMP] = ACTIONS(5750),
    [anon_sym_DASH] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5750),
    [anon_sym_DASH_EQ] = ACTIONS(2908),
    [anon_sym_DASH_GT] = ACTIONS(2908),
    [anon_sym_BANG_EQ] = ACTIONS(2908),
    [anon_sym_STAR_EQ] = ACTIONS(2908),
    [anon_sym_SLASH] = ACTIONS(5750),
    [anon_sym_SLASH_EQ] = ACTIONS(2908),
    [anon_sym_AMP_AMP] = ACTIONS(2908),
    [anon_sym_AMP_EQ] = ACTIONS(2908),
    [anon_sym_PERCENT] = ACTIONS(5750),
    [anon_sym_PERCENT_EQ] = ACTIONS(2908),
    [anon_sym_CARET] = ACTIONS(5750),
    [anon_sym_CARET_EQ] = ACTIONS(2908),
    [anon_sym_PLUS_EQ] = ACTIONS(2908),
    [anon_sym_LT] = ACTIONS(5750),
    [anon_sym_LT_LT] = ACTIONS(5750),
    [anon_sym_LT_LT_EQ] = ACTIONS(2908),
    [anon_sym_LT_EQ] = ACTIONS(2908),
    [anon_sym_EQ] = ACTIONS(5750),
    [anon_sym_EQ_EQ] = ACTIONS(2908),
    [anon_sym_GT] = ACTIONS(5750),
    [anon_sym_GT_EQ] = ACTIONS(2908),
    [anon_sym_GT_GT] = ACTIONS(5750),
    [anon_sym_GT_GT_EQ] = ACTIONS(2908),
    [anon_sym_PIPE] = ACTIONS(5750),
    [anon_sym_PIPE_EQ] = ACTIONS(2908),
    [anon_sym_PIPE_PIPE] = ACTIONS(2908),
    [anon_sym_QMARK] = ACTIONS(2908),
    [anon_sym_DOT_DOT] = ACTIONS(5750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2908),
    [anon_sym_as] = ACTIONS(2908),
    [sym_line_comment] = ACTIONS(7),
  },
  [3597] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7840),
    [sym_line_comment] = ACTIONS(7),
  },
  [3598] = {
    [aux_sym_parameters_repeat1] = STATE(3659),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7840),
    [anon_sym_COLON] = ACTIONS(2914),
    [anon_sym_COMMA] = ACTIONS(7842),
    [sym_line_comment] = ACTIONS(7),
  },
  [3599] = {
    [aux_sym_parameters_repeat1] = STATE(3659),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7840),
    [anon_sym_COMMA] = ACTIONS(7842),
    [sym_line_comment] = ACTIONS(7),
  },
  [3600] = {
    [aux_sym_parameters_repeat1] = STATE(3659),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7840),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_COMMA] = ACTIONS(7842),
    [sym_line_comment] = ACTIONS(7),
  },
  [3601] = {
    [sym_function_modifiers] = STATE(3246),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3661),
    [sym_bracketed_type] = STATE(3244),
    [sym_lifetime] = STATE(3248),
    [sym_array_type] = STATE(3661),
    [sym_function_type] = STATE(3661),
    [sym_tuple_type] = STATE(3661),
    [sym_unit_type] = STATE(3661),
    [sym_generic_type] = STATE(3249),
    [sym_generic_type_with_turbofish] = STATE(3250),
    [sym_bounded_type] = STATE(3661),
    [sym_reference_type] = STATE(3661),
    [sym_pointer_type] = STATE(3661),
    [sym_empty_type] = STATE(3661),
    [sym_abstract_type] = STATE(3662),
    [sym_dynamic_type] = STATE(3661),
    [sym_macro_invocation] = STATE(3661),
    [sym_scoped_identifier] = STATE(3251),
    [sym_scoped_type_identifier] = STATE(3252),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7059),
    [anon_sym_LBRACK] = ACTIONS(7061),
    [anon_sym_STAR] = ACTIONS(7063),
    [anon_sym_u8] = ACTIONS(7065),
    [anon_sym_i8] = ACTIONS(7065),
    [anon_sym_u16] = ACTIONS(7065),
    [anon_sym_i16] = ACTIONS(7065),
    [anon_sym_u32] = ACTIONS(7065),
    [anon_sym_i32] = ACTIONS(7065),
    [anon_sym_u64] = ACTIONS(7065),
    [anon_sym_i64] = ACTIONS(7065),
    [anon_sym_u128] = ACTIONS(7065),
    [anon_sym_i128] = ACTIONS(7065),
    [anon_sym_isize] = ACTIONS(7065),
    [anon_sym_usize] = ACTIONS(7065),
    [anon_sym_f32] = ACTIONS(7065),
    [anon_sym_f64] = ACTIONS(7065),
    [anon_sym_bool] = ACTIONS(7065),
    [anon_sym_str] = ACTIONS(7065),
    [anon_sym_char] = ACTIONS(7065),
    [anon_sym_AMP] = ACTIONS(7067),
    [anon_sym_COLON_COLON] = ACTIONS(7069),
    [anon_sym_BANG] = ACTIONS(7071),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(7073),
    [anon_sym_impl] = ACTIONS(7844),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(7075),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7077),
    [sym_self] = ACTIONS(7079),
    [sym_super] = ACTIONS(7079),
    [sym_crate] = ACTIONS(7079),
    [sym_metavariable] = ACTIONS(7081),
  },
  [3602] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2950),
    [anon_sym_EQ_GT] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2952),
    [anon_sym_STAR] = ACTIONS(2952),
    [anon_sym_AMP] = ACTIONS(2952),
    [anon_sym_DASH] = ACTIONS(2952),
    [anon_sym_DOT] = ACTIONS(2952),
    [anon_sym_DASH_EQ] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2263),
    [anon_sym_BANG_EQ] = ACTIONS(2950),
    [anon_sym_STAR_EQ] = ACTIONS(2950),
    [anon_sym_SLASH] = ACTIONS(2952),
    [anon_sym_SLASH_EQ] = ACTIONS(2950),
    [anon_sym_AMP_AMP] = ACTIONS(2950),
    [anon_sym_AMP_EQ] = ACTIONS(2950),
    [anon_sym_PERCENT] = ACTIONS(2952),
    [anon_sym_PERCENT_EQ] = ACTIONS(2950),
    [anon_sym_CARET] = ACTIONS(2952),
    [anon_sym_CARET_EQ] = ACTIONS(2950),
    [anon_sym_PLUS_EQ] = ACTIONS(2950),
    [anon_sym_LT] = ACTIONS(2952),
    [anon_sym_LT_LT] = ACTIONS(2952),
    [anon_sym_LT_LT_EQ] = ACTIONS(2950),
    [anon_sym_LT_EQ] = ACTIONS(2950),
    [anon_sym_EQ] = ACTIONS(2952),
    [anon_sym_EQ_EQ] = ACTIONS(2950),
    [anon_sym_GT] = ACTIONS(2952),
    [anon_sym_GT_EQ] = ACTIONS(2950),
    [anon_sym_GT_GT] = ACTIONS(2952),
    [anon_sym_GT_GT_EQ] = ACTIONS(2950),
    [anon_sym_PIPE] = ACTIONS(2952),
    [anon_sym_PIPE_EQ] = ACTIONS(2950),
    [anon_sym_PIPE_PIPE] = ACTIONS(2950),
    [anon_sym_QMARK] = ACTIONS(2950),
    [anon_sym_DOT_DOT] = ACTIONS(2952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2950),
    [anon_sym_as] = ACTIONS(2950),
    [sym_line_comment] = ACTIONS(7),
  },
  [3603] = {
    [sym_function_modifiers] = STATE(3246),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3663),
    [sym_bracketed_type] = STATE(3244),
    [sym_lifetime] = STATE(3248),
    [sym_array_type] = STATE(3663),
    [sym_function_type] = STATE(3663),
    [sym_tuple_type] = STATE(3663),
    [sym_unit_type] = STATE(3663),
    [sym_generic_type] = STATE(3249),
    [sym_generic_type_with_turbofish] = STATE(3250),
    [sym_bounded_type] = STATE(3663),
    [sym_reference_type] = STATE(3663),
    [sym_pointer_type] = STATE(3663),
    [sym_empty_type] = STATE(3663),
    [sym_abstract_type] = STATE(3664),
    [sym_dynamic_type] = STATE(3663),
    [sym_macro_invocation] = STATE(3663),
    [sym_scoped_identifier] = STATE(3251),
    [sym_scoped_type_identifier] = STATE(3252),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7059),
    [anon_sym_LBRACK] = ACTIONS(7061),
    [anon_sym_STAR] = ACTIONS(7063),
    [anon_sym_u8] = ACTIONS(7065),
    [anon_sym_i8] = ACTIONS(7065),
    [anon_sym_u16] = ACTIONS(7065),
    [anon_sym_i16] = ACTIONS(7065),
    [anon_sym_u32] = ACTIONS(7065),
    [anon_sym_i32] = ACTIONS(7065),
    [anon_sym_u64] = ACTIONS(7065),
    [anon_sym_i64] = ACTIONS(7065),
    [anon_sym_u128] = ACTIONS(7065),
    [anon_sym_i128] = ACTIONS(7065),
    [anon_sym_isize] = ACTIONS(7065),
    [anon_sym_usize] = ACTIONS(7065),
    [anon_sym_f32] = ACTIONS(7065),
    [anon_sym_f64] = ACTIONS(7065),
    [anon_sym_bool] = ACTIONS(7065),
    [anon_sym_str] = ACTIONS(7065),
    [anon_sym_char] = ACTIONS(7065),
    [anon_sym_AMP] = ACTIONS(7067),
    [anon_sym_COLON_COLON] = ACTIONS(7069),
    [anon_sym_BANG] = ACTIONS(7071),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(7073),
    [anon_sym_impl] = ACTIONS(7844),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(7075),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7077),
    [sym_self] = ACTIONS(7079),
    [sym_super] = ACTIONS(7079),
    [sym_crate] = ACTIONS(7079),
    [sym_metavariable] = ACTIONS(7081),
  },
  [3604] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2988),
    [anon_sym_EQ_GT] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(5758),
    [anon_sym_STAR] = ACTIONS(5758),
    [anon_sym_AMP] = ACTIONS(5758),
    [anon_sym_DASH] = ACTIONS(5758),
    [anon_sym_DOT] = ACTIONS(5758),
    [anon_sym_DASH_EQ] = ACTIONS(2988),
    [anon_sym_DASH_GT] = ACTIONS(7846),
    [anon_sym_BANG_EQ] = ACTIONS(2988),
    [anon_sym_STAR_EQ] = ACTIONS(2988),
    [anon_sym_SLASH] = ACTIONS(5758),
    [anon_sym_SLASH_EQ] = ACTIONS(2988),
    [anon_sym_AMP_AMP] = ACTIONS(2988),
    [anon_sym_AMP_EQ] = ACTIONS(2988),
    [anon_sym_PERCENT] = ACTIONS(5758),
    [anon_sym_PERCENT_EQ] = ACTIONS(2988),
    [anon_sym_CARET] = ACTIONS(5758),
    [anon_sym_CARET_EQ] = ACTIONS(2988),
    [anon_sym_PLUS_EQ] = ACTIONS(2988),
    [anon_sym_LT] = ACTIONS(5758),
    [anon_sym_LT_LT] = ACTIONS(5758),
    [anon_sym_LT_LT_EQ] = ACTIONS(2988),
    [anon_sym_LT_EQ] = ACTIONS(2988),
    [anon_sym_EQ] = ACTIONS(5758),
    [anon_sym_EQ_EQ] = ACTIONS(2988),
    [anon_sym_GT] = ACTIONS(5758),
    [anon_sym_GT_EQ] = ACTIONS(2988),
    [anon_sym_GT_GT] = ACTIONS(5758),
    [anon_sym_GT_GT_EQ] = ACTIONS(2988),
    [anon_sym_PIPE] = ACTIONS(5758),
    [anon_sym_PIPE_EQ] = ACTIONS(2988),
    [anon_sym_PIPE_PIPE] = ACTIONS(2988),
    [anon_sym_QMARK] = ACTIONS(2988),
    [anon_sym_DOT_DOT] = ACTIONS(5758),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2988),
    [anon_sym_as] = ACTIONS(2988),
    [sym_line_comment] = ACTIONS(7),
  },
  [3605] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2992),
    [anon_sym_EQ_GT] = ACTIONS(2992),
    [anon_sym_LBRACK] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(5762),
    [anon_sym_STAR] = ACTIONS(5762),
    [anon_sym_AMP] = ACTIONS(5762),
    [anon_sym_DASH] = ACTIONS(5762),
    [anon_sym_DOT] = ACTIONS(5762),
    [anon_sym_DASH_EQ] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(7848),
    [anon_sym_BANG_EQ] = ACTIONS(2992),
    [anon_sym_STAR_EQ] = ACTIONS(2992),
    [anon_sym_SLASH] = ACTIONS(5762),
    [anon_sym_SLASH_EQ] = ACTIONS(2992),
    [anon_sym_AMP_AMP] = ACTIONS(2992),
    [anon_sym_AMP_EQ] = ACTIONS(2992),
    [anon_sym_PERCENT] = ACTIONS(5762),
    [anon_sym_PERCENT_EQ] = ACTIONS(2992),
    [anon_sym_CARET] = ACTIONS(5762),
    [anon_sym_CARET_EQ] = ACTIONS(2992),
    [anon_sym_PLUS_EQ] = ACTIONS(2992),
    [anon_sym_LT] = ACTIONS(5762),
    [anon_sym_LT_LT] = ACTIONS(5762),
    [anon_sym_LT_LT_EQ] = ACTIONS(2992),
    [anon_sym_LT_EQ] = ACTIONS(2992),
    [anon_sym_EQ] = ACTIONS(5762),
    [anon_sym_EQ_EQ] = ACTIONS(2992),
    [anon_sym_GT] = ACTIONS(5762),
    [anon_sym_GT_EQ] = ACTIONS(2992),
    [anon_sym_GT_GT] = ACTIONS(5762),
    [anon_sym_GT_GT_EQ] = ACTIONS(2992),
    [anon_sym_PIPE] = ACTIONS(5762),
    [anon_sym_PIPE_EQ] = ACTIONS(2992),
    [anon_sym_PIPE_PIPE] = ACTIONS(2992),
    [anon_sym_QMARK] = ACTIONS(2992),
    [anon_sym_DOT_DOT] = ACTIONS(5762),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2992),
    [anon_sym_as] = ACTIONS(2992),
    [sym_line_comment] = ACTIONS(7),
  },
  [3606] = {
    [sym_block_comment] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7850),
  },
  [3607] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_EQ_GT] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(2996),
    [anon_sym_PLUS] = ACTIONS(5768),
    [anon_sym_STAR] = ACTIONS(5768),
    [anon_sym_AMP] = ACTIONS(5768),
    [anon_sym_DASH] = ACTIONS(5768),
    [anon_sym_DOT] = ACTIONS(5768),
    [anon_sym_DASH_EQ] = ACTIONS(2996),
    [anon_sym_BANG_EQ] = ACTIONS(2996),
    [anon_sym_STAR_EQ] = ACTIONS(2996),
    [anon_sym_SLASH] = ACTIONS(5768),
    [anon_sym_SLASH_EQ] = ACTIONS(2996),
    [anon_sym_AMP_AMP] = ACTIONS(2996),
    [anon_sym_AMP_EQ] = ACTIONS(2996),
    [anon_sym_PERCENT] = ACTIONS(5768),
    [anon_sym_PERCENT_EQ] = ACTIONS(2996),
    [anon_sym_CARET] = ACTIONS(5768),
    [anon_sym_CARET_EQ] = ACTIONS(2996),
    [anon_sym_PLUS_EQ] = ACTIONS(2996),
    [anon_sym_LT] = ACTIONS(5768),
    [anon_sym_LT_LT] = ACTIONS(5768),
    [anon_sym_LT_LT_EQ] = ACTIONS(2996),
    [anon_sym_LT_EQ] = ACTIONS(2996),
    [anon_sym_EQ] = ACTIONS(5768),
    [anon_sym_EQ_EQ] = ACTIONS(2996),
    [anon_sym_GT] = ACTIONS(5768),
    [anon_sym_GT_EQ] = ACTIONS(2996),
    [anon_sym_GT_GT] = ACTIONS(5768),
    [anon_sym_GT_GT_EQ] = ACTIONS(2996),
    [anon_sym_PIPE] = ACTIONS(5768),
    [anon_sym_PIPE_EQ] = ACTIONS(2996),
    [anon_sym_PIPE_PIPE] = ACTIONS(2996),
    [anon_sym_QMARK] = ACTIONS(2996),
    [anon_sym_DOT_DOT] = ACTIONS(5768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2996),
    [anon_sym_as] = ACTIONS(2996),
    [sym_line_comment] = ACTIONS(7),
  },
  [3608] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2950),
    [anon_sym_EQ_GT] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2952),
    [anon_sym_STAR] = ACTIONS(2952),
    [anon_sym_AMP] = ACTIONS(2952),
    [anon_sym_DASH] = ACTIONS(2952),
    [anon_sym_DOT] = ACTIONS(2952),
    [anon_sym_DASH_EQ] = ACTIONS(2950),
    [anon_sym_BANG_EQ] = ACTIONS(2950),
    [anon_sym_STAR_EQ] = ACTIONS(2950),
    [anon_sym_SLASH] = ACTIONS(2952),
    [anon_sym_SLASH_EQ] = ACTIONS(2950),
    [anon_sym_AMP_AMP] = ACTIONS(2950),
    [anon_sym_AMP_EQ] = ACTIONS(2950),
    [anon_sym_PERCENT] = ACTIONS(2952),
    [anon_sym_PERCENT_EQ] = ACTIONS(2950),
    [anon_sym_CARET] = ACTIONS(2952),
    [anon_sym_CARET_EQ] = ACTIONS(2950),
    [anon_sym_PLUS_EQ] = ACTIONS(2950),
    [anon_sym_LT] = ACTIONS(2952),
    [anon_sym_LT_LT] = ACTIONS(2952),
    [anon_sym_LT_LT_EQ] = ACTIONS(2950),
    [anon_sym_LT_EQ] = ACTIONS(2950),
    [anon_sym_EQ] = ACTIONS(2952),
    [anon_sym_EQ_EQ] = ACTIONS(2950),
    [anon_sym_GT] = ACTIONS(2952),
    [anon_sym_GT_EQ] = ACTIONS(2950),
    [anon_sym_GT_GT] = ACTIONS(2952),
    [anon_sym_GT_GT_EQ] = ACTIONS(2950),
    [anon_sym_PIPE] = ACTIONS(2952),
    [anon_sym_PIPE_EQ] = ACTIONS(2950),
    [anon_sym_PIPE_PIPE] = ACTIONS(2950),
    [anon_sym_QMARK] = ACTIONS(2950),
    [anon_sym_DOT_DOT] = ACTIONS(2952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2950),
    [anon_sym_as] = ACTIONS(2950),
    [sym_line_comment] = ACTIONS(7),
  },
  [3609] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(3012),
    [anon_sym_EQ_GT] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_PLUS] = ACTIONS(3014),
    [anon_sym_STAR] = ACTIONS(3014),
    [anon_sym_AMP] = ACTIONS(3014),
    [anon_sym_DASH] = ACTIONS(3014),
    [anon_sym_DOT] = ACTIONS(3014),
    [anon_sym_DASH_EQ] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(2529),
    [anon_sym_BANG_EQ] = ACTIONS(3012),
    [anon_sym_STAR_EQ] = ACTIONS(3012),
    [anon_sym_SLASH] = ACTIONS(3014),
    [anon_sym_SLASH_EQ] = ACTIONS(3012),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_AMP_EQ] = ACTIONS(3012),
    [anon_sym_PERCENT] = ACTIONS(3014),
    [anon_sym_PERCENT_EQ] = ACTIONS(3012),
    [anon_sym_CARET] = ACTIONS(3014),
    [anon_sym_CARET_EQ] = ACTIONS(3012),
    [anon_sym_PLUS_EQ] = ACTIONS(3012),
    [anon_sym_LT] = ACTIONS(3014),
    [anon_sym_LT_LT] = ACTIONS(3014),
    [anon_sym_LT_LT_EQ] = ACTIONS(3012),
    [anon_sym_LT_EQ] = ACTIONS(3012),
    [anon_sym_EQ] = ACTIONS(3014),
    [anon_sym_EQ_EQ] = ACTIONS(3012),
    [anon_sym_GT] = ACTIONS(3014),
    [anon_sym_GT_EQ] = ACTIONS(3012),
    [anon_sym_GT_GT] = ACTIONS(3014),
    [anon_sym_GT_GT_EQ] = ACTIONS(3012),
    [anon_sym_PIPE] = ACTIONS(3014),
    [anon_sym_PIPE_EQ] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE] = ACTIONS(3012),
    [anon_sym_QMARK] = ACTIONS(3012),
    [anon_sym_DOT_DOT] = ACTIONS(3014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3012),
    [anon_sym_as] = ACTIONS(3012),
    [sym_line_comment] = ACTIONS(7),
  },
  [3610] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3668),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(3668),
    [sym_macro_invocation] = STATE(3668),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3668),
    [sym_unary_expression] = STATE(3668),
    [sym_try_expression] = STATE(3668),
    [sym_reference_expression] = STATE(3668),
    [sym_binary_expression] = STATE(3668),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3668),
    [sym_call_expression] = STATE(3668),
    [sym_array_expression] = STATE(3668),
    [sym_parenthesized_expression] = STATE(3668),
    [sym_tuple_expression] = STATE(3668),
    [sym_unit_expression] = STATE(3668),
    [sym_struct_expression] = STATE(3668),
    [sym_if_expression] = STATE(3668),
    [sym_if_let_expression] = STATE(3668),
    [sym_match_expression] = STATE(3668),
    [sym_while_expression] = STATE(3668),
    [sym_while_let_expression] = STATE(3668),
    [sym_loop_expression] = STATE(3668),
    [sym_for_expression] = STATE(3668),
    [sym_closure_expression] = STATE(3668),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3668),
    [sym_continue_expression] = STATE(3668),
    [sym_index_expression] = STATE(3668),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3668),
    [sym_block] = STATE(3668),
    [sym__literal] = STATE(3668),
    [sym_string_literal] = STATE(3668),
    [sym_boolean_literal] = STATE(3668),
    [sym_raw_string_literal] = ACTIONS(7852),
    [sym_float_literal] = ACTIONS(7852),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(7852),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7852),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [3611] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7854),
    [sym_line_comment] = ACTIONS(7),
  },
  [3612] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5778),
    [anon_sym_EQ_GT] = ACTIONS(5778),
    [anon_sym_LBRACK] = ACTIONS(5778),
    [anon_sym_PLUS] = ACTIONS(5780),
    [anon_sym_STAR] = ACTIONS(5780),
    [anon_sym_AMP] = ACTIONS(5780),
    [anon_sym_DASH] = ACTIONS(5780),
    [anon_sym_DOT] = ACTIONS(5780),
    [anon_sym_DASH_EQ] = ACTIONS(5778),
    [anon_sym_BANG_EQ] = ACTIONS(5778),
    [anon_sym_STAR_EQ] = ACTIONS(5778),
    [anon_sym_SLASH] = ACTIONS(5780),
    [anon_sym_SLASH_EQ] = ACTIONS(5778),
    [anon_sym_AMP_AMP] = ACTIONS(5778),
    [anon_sym_AMP_EQ] = ACTIONS(5778),
    [anon_sym_PERCENT] = ACTIONS(5780),
    [anon_sym_PERCENT_EQ] = ACTIONS(5778),
    [anon_sym_CARET] = ACTIONS(5780),
    [anon_sym_CARET_EQ] = ACTIONS(5778),
    [anon_sym_PLUS_EQ] = ACTIONS(5778),
    [anon_sym_LT] = ACTIONS(5780),
    [anon_sym_LT_LT] = ACTIONS(5780),
    [anon_sym_LT_LT_EQ] = ACTIONS(5778),
    [anon_sym_LT_EQ] = ACTIONS(5778),
    [anon_sym_EQ] = ACTIONS(5780),
    [anon_sym_EQ_EQ] = ACTIONS(5778),
    [anon_sym_GT] = ACTIONS(5780),
    [anon_sym_GT_EQ] = ACTIONS(5778),
    [anon_sym_GT_GT] = ACTIONS(5780),
    [anon_sym_GT_GT_EQ] = ACTIONS(5778),
    [anon_sym_PIPE] = ACTIONS(5780),
    [anon_sym_PIPE_EQ] = ACTIONS(5778),
    [anon_sym_PIPE_PIPE] = ACTIONS(5778),
    [anon_sym_QMARK] = ACTIONS(5778),
    [anon_sym_DOT_DOT] = ACTIONS(5780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5778),
    [anon_sym_as] = ACTIONS(5778),
    [sym_line_comment] = ACTIONS(7),
  },
  [3613] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(7856),
    [sym_line_comment] = ACTIONS(7),
  },
  [3614] = {
    [sym_else_tail] = STATE(3410),
    [sym_raw_string_literal] = ACTIONS(2012),
    [sym_float_literal] = ACTIONS(2012),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(2012),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_PLUS] = ACTIONS(2014),
    [anon_sym_STAR] = ACTIONS(2014),
    [anon_sym_COMMA] = ACTIONS(2012),
    [anon_sym_u8] = ACTIONS(2014),
    [anon_sym_i8] = ACTIONS(2014),
    [anon_sym_u16] = ACTIONS(2014),
    [anon_sym_i16] = ACTIONS(2014),
    [anon_sym_u32] = ACTIONS(2014),
    [anon_sym_i32] = ACTIONS(2014),
    [anon_sym_u64] = ACTIONS(2014),
    [anon_sym_i64] = ACTIONS(2014),
    [anon_sym_u128] = ACTIONS(2014),
    [anon_sym_i128] = ACTIONS(2014),
    [anon_sym_isize] = ACTIONS(2014),
    [anon_sym_usize] = ACTIONS(2014),
    [anon_sym_f32] = ACTIONS(2014),
    [anon_sym_f64] = ACTIONS(2014),
    [anon_sym_bool] = ACTIONS(2014),
    [anon_sym_str] = ACTIONS(2014),
    [anon_sym_char] = ACTIONS(2014),
    [anon_sym__] = ACTIONS(2014),
    [anon_sym_AMP] = ACTIONS(2014),
    [anon_sym_DASH] = ACTIONS(2014),
    [anon_sym_DOT] = ACTIONS(2014),
    [anon_sym_DASH_EQ] = ACTIONS(2012),
    [anon_sym_COLON_COLON] = ACTIONS(2012),
    [anon_sym_BANG_EQ] = ACTIONS(2012),
    [anon_sym_STAR_EQ] = ACTIONS(2012),
    [anon_sym_SLASH] = ACTIONS(2014),
    [anon_sym_SLASH_EQ] = ACTIONS(2012),
    [anon_sym_AMP_AMP] = ACTIONS(2012),
    [anon_sym_AMP_EQ] = ACTIONS(2012),
    [anon_sym_POUND] = ACTIONS(2012),
    [anon_sym_PERCENT] = ACTIONS(2014),
    [anon_sym_PERCENT_EQ] = ACTIONS(2012),
    [anon_sym_CARET] = ACTIONS(2014),
    [anon_sym_CARET_EQ] = ACTIONS(2012),
    [anon_sym_PLUS_EQ] = ACTIONS(2012),
    [anon_sym_LT] = ACTIONS(2014),
    [anon_sym_LT_LT] = ACTIONS(2014),
    [anon_sym_LT_LT_EQ] = ACTIONS(2012),
    [anon_sym_LT_EQ] = ACTIONS(2012),
    [anon_sym_EQ] = ACTIONS(2014),
    [anon_sym_EQ_EQ] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2014),
    [anon_sym_GT_EQ] = ACTIONS(2012),
    [anon_sym_GT_GT] = ACTIONS(2014),
    [anon_sym_GT_GT_EQ] = ACTIONS(2012),
    [anon_sym_PIPE] = ACTIONS(2014),
    [anon_sym_PIPE_EQ] = ACTIONS(2012),
    [anon_sym_PIPE_PIPE] = ACTIONS(2012),
    [anon_sym_QMARK] = ACTIONS(2012),
    [anon_sym_DOT_DOT] = ACTIONS(2014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2012),
    [anon_sym_as] = ACTIONS(2014),
    [sym_mutable_specifier] = ACTIONS(2014),
    [anon_sym_else] = ACTIONS(7858),
    [anon_sym_ref] = ACTIONS(2014),
    [sym_integer_literal] = ACTIONS(2012),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(2012),
    [sym_char_literal] = ACTIONS(2012),
    [anon_sym_true] = ACTIONS(2014),
    [anon_sym_false] = ACTIONS(2014),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(2014),
    [sym_self] = ACTIONS(2014),
    [sym_super] = ACTIONS(2014),
    [sym_crate] = ACTIONS(2014),
    [sym_metavariable] = ACTIONS(2012),
  },
  [3615] = {
    [sym_raw_string_literal] = ACTIONS(7509),
    [sym_float_literal] = ACTIONS(7509),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7509),
    [anon_sym_u8] = ACTIONS(7513),
    [anon_sym_i8] = ACTIONS(7513),
    [anon_sym_u16] = ACTIONS(7513),
    [anon_sym_i16] = ACTIONS(7513),
    [anon_sym_u32] = ACTIONS(7513),
    [anon_sym_i32] = ACTIONS(7513),
    [anon_sym_u64] = ACTIONS(7513),
    [anon_sym_i64] = ACTIONS(7513),
    [anon_sym_u128] = ACTIONS(7513),
    [anon_sym_i128] = ACTIONS(7513),
    [anon_sym_isize] = ACTIONS(7513),
    [anon_sym_usize] = ACTIONS(7513),
    [anon_sym_f32] = ACTIONS(7513),
    [anon_sym_f64] = ACTIONS(7513),
    [anon_sym_bool] = ACTIONS(7513),
    [anon_sym_str] = ACTIONS(7513),
    [anon_sym_char] = ACTIONS(7513),
    [anon_sym__] = ACTIONS(7513),
    [anon_sym_AMP] = ACTIONS(7509),
    [anon_sym_COLON_COLON] = ACTIONS(7509),
    [anon_sym_POUND] = ACTIONS(7509),
    [anon_sym_LT] = ACTIONS(7509),
    [anon_sym_DOT_DOT] = ACTIONS(7509),
    [sym_mutable_specifier] = ACTIONS(7513),
    [anon_sym_ref] = ACTIONS(7513),
    [sym_integer_literal] = ACTIONS(7509),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7509),
    [sym_char_literal] = ACTIONS(7509),
    [anon_sym_true] = ACTIONS(7513),
    [anon_sym_false] = ACTIONS(7513),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7513),
    [sym_self] = ACTIONS(7513),
    [sym_super] = ACTIONS(7513),
    [sym_crate] = ACTIONS(7513),
    [sym_metavariable] = ACTIONS(7509),
  },
  [3616] = {
    [sym_function_modifiers] = STATE(2936),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2156),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(3286),
    [sym_array_type] = STATE(2156),
    [sym_function_type] = STATE(2156),
    [sym_tuple_type] = STATE(2156),
    [sym_unit_type] = STATE(2156),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2156),
    [sym_reference_type] = STATE(2156),
    [sym_pointer_type] = STATE(2156),
    [sym_empty_type] = STATE(2156),
    [sym_abstract_type] = STATE(2157),
    [sym_dynamic_type] = STATE(2156),
    [sym_macro_invocation] = STATE(2156),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2939),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(6450),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(6452),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6456),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6460),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3617] = {
    [sym_function_modifiers] = STATE(2936),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2158),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(3286),
    [sym_array_type] = STATE(2158),
    [sym_function_type] = STATE(2158),
    [sym_tuple_type] = STATE(2158),
    [sym_unit_type] = STATE(2158),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2158),
    [sym_reference_type] = STATE(2158),
    [sym_pointer_type] = STATE(2158),
    [sym_empty_type] = STATE(2158),
    [sym_abstract_type] = STATE(2159),
    [sym_dynamic_type] = STATE(2158),
    [sym_macro_invocation] = STATE(2158),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(2939),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(6450),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(6452),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6456),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6460),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3618] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7358),
    [anon_sym_macro_rules_BANG] = ACTIONS(7358),
    [anon_sym_RBRACE] = ACTIONS(7358),
    [anon_sym_POUND] = ACTIONS(7358),
    [anon_sym_const] = ACTIONS(7360),
    [anon_sym_default] = ACTIONS(7360),
    [anon_sym_enum] = ACTIONS(7360),
    [anon_sym_fn] = ACTIONS(7360),
    [anon_sym_impl] = ACTIONS(7360),
    [anon_sym_let] = ACTIONS(7360),
    [anon_sym_mod] = ACTIONS(7360),
    [anon_sym_pub] = ACTIONS(7360),
    [anon_sym_static] = ACTIONS(7360),
    [anon_sym_struct] = ACTIONS(7360),
    [anon_sym_trait] = ACTIONS(7360),
    [anon_sym_type] = ACTIONS(7360),
    [anon_sym_union] = ACTIONS(7360),
    [anon_sym_unsafe] = ACTIONS(7360),
    [anon_sym_use] = ACTIONS(7360),
    [anon_sym_extern] = ACTIONS(7360),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7360),
  },
  [3619] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7369),
    [anon_sym_macro_rules_BANG] = ACTIONS(7369),
    [anon_sym_RBRACE] = ACTIONS(7369),
    [anon_sym_POUND] = ACTIONS(7369),
    [anon_sym_const] = ACTIONS(7371),
    [anon_sym_default] = ACTIONS(7371),
    [anon_sym_enum] = ACTIONS(7371),
    [anon_sym_fn] = ACTIONS(7371),
    [anon_sym_impl] = ACTIONS(7371),
    [anon_sym_let] = ACTIONS(7371),
    [anon_sym_mod] = ACTIONS(7371),
    [anon_sym_pub] = ACTIONS(7371),
    [anon_sym_static] = ACTIONS(7371),
    [anon_sym_struct] = ACTIONS(7371),
    [anon_sym_trait] = ACTIONS(7371),
    [anon_sym_type] = ACTIONS(7371),
    [anon_sym_union] = ACTIONS(7371),
    [anon_sym_unsafe] = ACTIONS(7371),
    [anon_sym_use] = ACTIONS(7371),
    [anon_sym_extern] = ACTIONS(7371),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7371),
  },
  [3620] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7373),
    [anon_sym_macro_rules_BANG] = ACTIONS(7373),
    [anon_sym_RBRACE] = ACTIONS(7373),
    [anon_sym_POUND] = ACTIONS(7373),
    [anon_sym_const] = ACTIONS(7375),
    [anon_sym_default] = ACTIONS(7375),
    [anon_sym_enum] = ACTIONS(7375),
    [anon_sym_fn] = ACTIONS(7375),
    [anon_sym_impl] = ACTIONS(7375),
    [anon_sym_let] = ACTIONS(7375),
    [anon_sym_mod] = ACTIONS(7375),
    [anon_sym_pub] = ACTIONS(7375),
    [anon_sym_static] = ACTIONS(7375),
    [anon_sym_struct] = ACTIONS(7375),
    [anon_sym_trait] = ACTIONS(7375),
    [anon_sym_type] = ACTIONS(7375),
    [anon_sym_union] = ACTIONS(7375),
    [anon_sym_unsafe] = ACTIONS(7375),
    [anon_sym_use] = ACTIONS(7375),
    [anon_sym_extern] = ACTIONS(7375),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7375),
  },
  [3621] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7385),
    [anon_sym_macro_rules_BANG] = ACTIONS(7385),
    [anon_sym_RBRACE] = ACTIONS(7385),
    [anon_sym_POUND] = ACTIONS(7385),
    [anon_sym_const] = ACTIONS(7387),
    [anon_sym_default] = ACTIONS(7387),
    [anon_sym_enum] = ACTIONS(7387),
    [anon_sym_fn] = ACTIONS(7387),
    [anon_sym_impl] = ACTIONS(7387),
    [anon_sym_let] = ACTIONS(7387),
    [anon_sym_mod] = ACTIONS(7387),
    [anon_sym_pub] = ACTIONS(7387),
    [anon_sym_static] = ACTIONS(7387),
    [anon_sym_struct] = ACTIONS(7387),
    [anon_sym_trait] = ACTIONS(7387),
    [anon_sym_type] = ACTIONS(7387),
    [anon_sym_union] = ACTIONS(7387),
    [anon_sym_unsafe] = ACTIONS(7387),
    [anon_sym_use] = ACTIONS(7387),
    [anon_sym_extern] = ACTIONS(7387),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7387),
  },
  [3622] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7523),
    [anon_sym_macro_rules_BANG] = ACTIONS(7523),
    [anon_sym_RBRACE] = ACTIONS(7523),
    [anon_sym_POUND] = ACTIONS(7523),
    [anon_sym_const] = ACTIONS(7525),
    [anon_sym_default] = ACTIONS(7525),
    [anon_sym_enum] = ACTIONS(7525),
    [anon_sym_fn] = ACTIONS(7525),
    [anon_sym_impl] = ACTIONS(7525),
    [anon_sym_let] = ACTIONS(7525),
    [anon_sym_mod] = ACTIONS(7525),
    [anon_sym_pub] = ACTIONS(7525),
    [anon_sym_static] = ACTIONS(7525),
    [anon_sym_struct] = ACTIONS(7525),
    [anon_sym_trait] = ACTIONS(7525),
    [anon_sym_type] = ACTIONS(7525),
    [anon_sym_union] = ACTIONS(7525),
    [anon_sym_unsafe] = ACTIONS(7525),
    [anon_sym_use] = ACTIONS(7525),
    [anon_sym_extern] = ACTIONS(7525),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7525),
  },
  [3623] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7560),
    [anon_sym_macro_rules_BANG] = ACTIONS(7560),
    [anon_sym_RBRACE] = ACTIONS(7560),
    [anon_sym_POUND] = ACTIONS(7560),
    [anon_sym_const] = ACTIONS(7562),
    [anon_sym_default] = ACTIONS(7562),
    [anon_sym_enum] = ACTIONS(7562),
    [anon_sym_fn] = ACTIONS(7562),
    [anon_sym_impl] = ACTIONS(7562),
    [anon_sym_let] = ACTIONS(7562),
    [anon_sym_mod] = ACTIONS(7562),
    [anon_sym_pub] = ACTIONS(7562),
    [anon_sym_static] = ACTIONS(7562),
    [anon_sym_struct] = ACTIONS(7562),
    [anon_sym_trait] = ACTIONS(7562),
    [anon_sym_type] = ACTIONS(7562),
    [anon_sym_union] = ACTIONS(7562),
    [anon_sym_unsafe] = ACTIONS(7562),
    [anon_sym_use] = ACTIONS(7562),
    [anon_sym_extern] = ACTIONS(7562),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7562),
  },
  [3624] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7564),
    [anon_sym_macro_rules_BANG] = ACTIONS(7564),
    [anon_sym_RBRACE] = ACTIONS(7564),
    [anon_sym_POUND] = ACTIONS(7564),
    [anon_sym_const] = ACTIONS(7566),
    [anon_sym_default] = ACTIONS(7566),
    [anon_sym_enum] = ACTIONS(7566),
    [anon_sym_fn] = ACTIONS(7566),
    [anon_sym_impl] = ACTIONS(7566),
    [anon_sym_let] = ACTIONS(7566),
    [anon_sym_mod] = ACTIONS(7566),
    [anon_sym_pub] = ACTIONS(7566),
    [anon_sym_static] = ACTIONS(7566),
    [anon_sym_struct] = ACTIONS(7566),
    [anon_sym_trait] = ACTIONS(7566),
    [anon_sym_type] = ACTIONS(7566),
    [anon_sym_union] = ACTIONS(7566),
    [anon_sym_unsafe] = ACTIONS(7566),
    [anon_sym_use] = ACTIONS(7566),
    [anon_sym_extern] = ACTIONS(7566),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7566),
  },
  [3625] = {
    [sym_block] = STATE(3673),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7860),
    [anon_sym_LBRACE] = ACTIONS(111),
    [sym_line_comment] = ACTIONS(7),
  },
  [3626] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7622),
    [anon_sym_macro_rules_BANG] = ACTIONS(7622),
    [anon_sym_RBRACE] = ACTIONS(7622),
    [anon_sym_POUND] = ACTIONS(7622),
    [anon_sym_const] = ACTIONS(7624),
    [anon_sym_default] = ACTIONS(7624),
    [anon_sym_enum] = ACTIONS(7624),
    [anon_sym_fn] = ACTIONS(7624),
    [anon_sym_impl] = ACTIONS(7624),
    [anon_sym_let] = ACTIONS(7624),
    [anon_sym_mod] = ACTIONS(7624),
    [anon_sym_pub] = ACTIONS(7624),
    [anon_sym_static] = ACTIONS(7624),
    [anon_sym_struct] = ACTIONS(7624),
    [anon_sym_trait] = ACTIONS(7624),
    [anon_sym_type] = ACTIONS(7624),
    [anon_sym_union] = ACTIONS(7624),
    [anon_sym_unsafe] = ACTIONS(7624),
    [anon_sym_use] = ACTIONS(7624),
    [anon_sym_extern] = ACTIONS(7624),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7624),
  },
  [3627] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7862),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(467),
    [anon_sym_BANG_EQ] = ACTIONS(469),
    [anon_sym_STAR_EQ] = ACTIONS(467),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_SLASH_EQ] = ACTIONS(467),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_AMP_EQ] = ACTIONS(467),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PERCENT_EQ] = ACTIONS(467),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_CARET_EQ] = ACTIONS(467),
    [anon_sym_PLUS_EQ] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT_LT_EQ] = ACTIONS(467),
    [anon_sym_LT_EQ] = ACTIONS(469),
    [anon_sym_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_GT_GT_EQ] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_PIPE_EQ] = ACTIONS(467),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(489),
    [anon_sym_as] = ACTIONS(491),
    [sym_line_comment] = ACTIONS(7),
  },
  [3628] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7628),
    [anon_sym_macro_rules_BANG] = ACTIONS(7628),
    [anon_sym_RBRACE] = ACTIONS(7628),
    [anon_sym_POUND] = ACTIONS(7628),
    [anon_sym_const] = ACTIONS(7630),
    [anon_sym_default] = ACTIONS(7630),
    [anon_sym_enum] = ACTIONS(7630),
    [anon_sym_fn] = ACTIONS(7630),
    [anon_sym_impl] = ACTIONS(7630),
    [anon_sym_let] = ACTIONS(7630),
    [anon_sym_mod] = ACTIONS(7630),
    [anon_sym_pub] = ACTIONS(7630),
    [anon_sym_static] = ACTIONS(7630),
    [anon_sym_struct] = ACTIONS(7630),
    [anon_sym_trait] = ACTIONS(7630),
    [anon_sym_type] = ACTIONS(7630),
    [anon_sym_union] = ACTIONS(7630),
    [anon_sym_unsafe] = ACTIONS(7630),
    [anon_sym_use] = ACTIONS(7630),
    [anon_sym_extern] = ACTIONS(7630),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7630),
  },
  [3629] = {
    [sym_where_clause] = STATE(3675),
    [sym_block] = STATE(3673),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7860),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(5003),
    [anon_sym_where] = ACTIONS(1962),
    [sym_line_comment] = ACTIONS(7),
  },
  [3630] = {
    [sym_where_clause] = STATE(3675),
    [sym_block] = STATE(3673),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7860),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_where] = ACTIONS(1962),
    [sym_line_comment] = ACTIONS(7),
  },
  [3631] = {
    [sym_raw_string_literal] = ACTIONS(7864),
    [sym_float_literal] = ACTIONS(7864),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(7864),
    [anon_sym_SEMI] = ACTIONS(7864),
    [anon_sym_macro_rules_BANG] = ACTIONS(7864),
    [anon_sym_LPAREN] = ACTIONS(7864),
    [anon_sym_LBRACE] = ACTIONS(7864),
    [anon_sym_RBRACE] = ACTIONS(7864),
    [anon_sym_LBRACK] = ACTIONS(7864),
    [anon_sym_STAR] = ACTIONS(7864),
    [anon_sym_u8] = ACTIONS(7866),
    [anon_sym_i8] = ACTIONS(7866),
    [anon_sym_u16] = ACTIONS(7866),
    [anon_sym_i16] = ACTIONS(7866),
    [anon_sym_u32] = ACTIONS(7866),
    [anon_sym_i32] = ACTIONS(7866),
    [anon_sym_u64] = ACTIONS(7866),
    [anon_sym_i64] = ACTIONS(7866),
    [anon_sym_u128] = ACTIONS(7866),
    [anon_sym_i128] = ACTIONS(7866),
    [anon_sym_isize] = ACTIONS(7866),
    [anon_sym_usize] = ACTIONS(7866),
    [anon_sym_f32] = ACTIONS(7866),
    [anon_sym_f64] = ACTIONS(7866),
    [anon_sym_bool] = ACTIONS(7866),
    [anon_sym_str] = ACTIONS(7866),
    [anon_sym_char] = ACTIONS(7866),
    [anon_sym_AMP] = ACTIONS(7864),
    [anon_sym_DASH] = ACTIONS(7864),
    [anon_sym_COLON_COLON] = ACTIONS(7864),
    [anon_sym_BANG] = ACTIONS(7864),
    [anon_sym_POUND] = ACTIONS(7864),
    [anon_sym_LT] = ACTIONS(7864),
    [anon_sym_PIPE] = ACTIONS(7864),
    [anon_sym_SQUOTE] = ACTIONS(7866),
    [anon_sym_DOT_DOT] = ACTIONS(7864),
    [anon_sym_break] = ACTIONS(7866),
    [anon_sym_const] = ACTIONS(7866),
    [anon_sym_continue] = ACTIONS(7866),
    [anon_sym_default] = ACTIONS(7866),
    [anon_sym_enum] = ACTIONS(7866),
    [anon_sym_fn] = ACTIONS(7866),
    [anon_sym_for] = ACTIONS(7866),
    [anon_sym_if] = ACTIONS(7866),
    [anon_sym_impl] = ACTIONS(7866),
    [anon_sym_let] = ACTIONS(7866),
    [anon_sym_loop] = ACTIONS(7866),
    [anon_sym_match] = ACTIONS(7866),
    [anon_sym_mod] = ACTIONS(7866),
    [anon_sym_pub] = ACTIONS(7866),
    [anon_sym_return] = ACTIONS(7866),
    [anon_sym_static] = ACTIONS(7866),
    [anon_sym_struct] = ACTIONS(7866),
    [anon_sym_trait] = ACTIONS(7866),
    [anon_sym_type] = ACTIONS(7866),
    [anon_sym_union] = ACTIONS(7866),
    [anon_sym_unsafe] = ACTIONS(7866),
    [anon_sym_use] = ACTIONS(7866),
    [anon_sym_while] = ACTIONS(7866),
    [anon_sym_extern] = ACTIONS(7866),
    [anon_sym_move] = ACTIONS(7866),
    [sym_integer_literal] = ACTIONS(7864),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7864),
    [sym_char_literal] = ACTIONS(7864),
    [anon_sym_true] = ACTIONS(7866),
    [anon_sym_false] = ACTIONS(7866),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7866),
    [sym_self] = ACTIONS(7866),
    [sym_super] = ACTIONS(7866),
    [sym_crate] = ACTIONS(7866),
    [sym_metavariable] = ACTIONS(7864),
  },
  [3632] = {
    [sym_raw_string_literal] = ACTIONS(7868),
    [sym_float_literal] = ACTIONS(7868),
    [sym_block_comment] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(7868),
    [anon_sym_SEMI] = ACTIONS(7868),
    [anon_sym_macro_rules_BANG] = ACTIONS(7868),
    [anon_sym_LPAREN] = ACTIONS(7868),
    [anon_sym_LBRACE] = ACTIONS(7868),
    [anon_sym_RBRACE] = ACTIONS(7868),
    [anon_sym_LBRACK] = ACTIONS(7868),
    [anon_sym_STAR] = ACTIONS(7868),
    [anon_sym_u8] = ACTIONS(7870),
    [anon_sym_i8] = ACTIONS(7870),
    [anon_sym_u16] = ACTIONS(7870),
    [anon_sym_i16] = ACTIONS(7870),
    [anon_sym_u32] = ACTIONS(7870),
    [anon_sym_i32] = ACTIONS(7870),
    [anon_sym_u64] = ACTIONS(7870),
    [anon_sym_i64] = ACTIONS(7870),
    [anon_sym_u128] = ACTIONS(7870),
    [anon_sym_i128] = ACTIONS(7870),
    [anon_sym_isize] = ACTIONS(7870),
    [anon_sym_usize] = ACTIONS(7870),
    [anon_sym_f32] = ACTIONS(7870),
    [anon_sym_f64] = ACTIONS(7870),
    [anon_sym_bool] = ACTIONS(7870),
    [anon_sym_str] = ACTIONS(7870),
    [anon_sym_char] = ACTIONS(7870),
    [anon_sym_AMP] = ACTIONS(7868),
    [anon_sym_DASH] = ACTIONS(7868),
    [anon_sym_COLON_COLON] = ACTIONS(7868),
    [anon_sym_BANG] = ACTIONS(7868),
    [anon_sym_POUND] = ACTIONS(7868),
    [anon_sym_LT] = ACTIONS(7868),
    [anon_sym_PIPE] = ACTIONS(7868),
    [anon_sym_SQUOTE] = ACTIONS(7870),
    [anon_sym_DOT_DOT] = ACTIONS(7868),
    [anon_sym_break] = ACTIONS(7870),
    [anon_sym_const] = ACTIONS(7870),
    [anon_sym_continue] = ACTIONS(7870),
    [anon_sym_default] = ACTIONS(7870),
    [anon_sym_enum] = ACTIONS(7870),
    [anon_sym_fn] = ACTIONS(7870),
    [anon_sym_for] = ACTIONS(7870),
    [anon_sym_if] = ACTIONS(7870),
    [anon_sym_impl] = ACTIONS(7870),
    [anon_sym_let] = ACTIONS(7870),
    [anon_sym_loop] = ACTIONS(7870),
    [anon_sym_match] = ACTIONS(7870),
    [anon_sym_mod] = ACTIONS(7870),
    [anon_sym_pub] = ACTIONS(7870),
    [anon_sym_return] = ACTIONS(7870),
    [anon_sym_static] = ACTIONS(7870),
    [anon_sym_struct] = ACTIONS(7870),
    [anon_sym_trait] = ACTIONS(7870),
    [anon_sym_type] = ACTIONS(7870),
    [anon_sym_union] = ACTIONS(7870),
    [anon_sym_unsafe] = ACTIONS(7870),
    [anon_sym_use] = ACTIONS(7870),
    [anon_sym_while] = ACTIONS(7870),
    [anon_sym_extern] = ACTIONS(7870),
    [anon_sym_move] = ACTIONS(7870),
    [sym_integer_literal] = ACTIONS(7868),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7868),
    [sym_char_literal] = ACTIONS(7868),
    [anon_sym_true] = ACTIONS(7870),
    [anon_sym_false] = ACTIONS(7870),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7870),
    [sym_self] = ACTIONS(7870),
    [sym_super] = ACTIONS(7870),
    [sym_crate] = ACTIONS(7870),
    [sym_metavariable] = ACTIONS(7868),
  },
  [3633] = {
    [sym_else_tail] = STATE(3089),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6158),
    [anon_sym_LBRACK] = ACTIONS(6158),
    [anon_sym_PLUS] = ACTIONS(6160),
    [anon_sym_STAR] = ACTIONS(6160),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_AMP] = ACTIONS(6160),
    [anon_sym_DASH] = ACTIONS(6160),
    [anon_sym_DOT] = ACTIONS(6160),
    [anon_sym_DASH_EQ] = ACTIONS(6158),
    [anon_sym_BANG_EQ] = ACTIONS(6158),
    [anon_sym_STAR_EQ] = ACTIONS(6158),
    [anon_sym_SLASH] = ACTIONS(6160),
    [anon_sym_SLASH_EQ] = ACTIONS(6158),
    [anon_sym_AMP_AMP] = ACTIONS(6158),
    [anon_sym_AMP_EQ] = ACTIONS(6158),
    [anon_sym_PERCENT] = ACTIONS(6160),
    [anon_sym_PERCENT_EQ] = ACTIONS(6158),
    [anon_sym_CARET] = ACTIONS(6160),
    [anon_sym_CARET_EQ] = ACTIONS(6158),
    [anon_sym_PLUS_EQ] = ACTIONS(6158),
    [anon_sym_LT] = ACTIONS(6160),
    [anon_sym_LT_LT] = ACTIONS(6160),
    [anon_sym_LT_LT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_EQ] = ACTIONS(6160),
    [anon_sym_EQ_EQ] = ACTIONS(6158),
    [anon_sym_GT] = ACTIONS(6160),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_GT_GT] = ACTIONS(6160),
    [anon_sym_GT_GT_EQ] = ACTIONS(6158),
    [anon_sym_PIPE] = ACTIONS(6160),
    [anon_sym_PIPE_EQ] = ACTIONS(6158),
    [anon_sym_PIPE_PIPE] = ACTIONS(6158),
    [anon_sym_QMARK] = ACTIONS(6158),
    [anon_sym_DOT_DOT] = ACTIONS(6160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6158),
    [anon_sym_as] = ACTIONS(6158),
    [anon_sym_else] = ACTIONS(7332),
    [sym_line_comment] = ACTIONS(7),
  },
  [3634] = {
    [sym_function_modifiers] = STATE(3109),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3080),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(3110),
    [sym_array_type] = STATE(3080),
    [sym_function_type] = STATE(3080),
    [sym_tuple_type] = STATE(3080),
    [sym_unit_type] = STATE(3080),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(3080),
    [sym_reference_type] = STATE(3080),
    [sym_pointer_type] = STATE(3080),
    [sym_empty_type] = STATE(3080),
    [sym_abstract_type] = STATE(3081),
    [sym_dynamic_type] = STATE(3080),
    [sym_macro_invocation] = STATE(3080),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(3111),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(6776),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(6778),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6780),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6782),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [3635] = {
    [sym_function_modifiers] = STATE(3109),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3082),
    [sym_bracketed_type] = STATE(663),
    [sym_lifetime] = STATE(3110),
    [sym_array_type] = STATE(3082),
    [sym_function_type] = STATE(3082),
    [sym_tuple_type] = STATE(3082),
    [sym_unit_type] = STATE(3082),
    [sym_generic_type] = STATE(668),
    [sym_generic_type_with_turbofish] = STATE(669),
    [sym_bounded_type] = STATE(3082),
    [sym_reference_type] = STATE(3082),
    [sym_pointer_type] = STATE(3082),
    [sym_empty_type] = STATE(3082),
    [sym_abstract_type] = STATE(3083),
    [sym_dynamic_type] = STATE(3082),
    [sym_macro_invocation] = STATE(3082),
    [sym_scoped_identifier] = STATE(670),
    [sym_scoped_type_identifier] = STATE(3111),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(6776),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(6778),
    [anon_sym_COLON_COLON] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(6780),
    [anon_sym_impl] = ACTIONS(5756),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6782),
    [sym_self] = ACTIONS(1307),
    [sym_super] = ACTIONS(1307),
    [sym_crate] = ACTIONS(1307),
    [sym_metavariable] = ACTIONS(1309),
  },
  [3636] = {
    [sym_else_tail] = STATE(3676),
    [sym_raw_string_literal] = ACTIONS(6158),
    [sym_float_literal] = ACTIONS(6158),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6158),
    [anon_sym_RBRACE] = ACTIONS(6158),
    [anon_sym_LBRACK] = ACTIONS(6158),
    [anon_sym_PLUS] = ACTIONS(6160),
    [anon_sym_STAR] = ACTIONS(6160),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_u8] = ACTIONS(6160),
    [anon_sym_i8] = ACTIONS(6160),
    [anon_sym_u16] = ACTIONS(6160),
    [anon_sym_i16] = ACTIONS(6160),
    [anon_sym_u32] = ACTIONS(6160),
    [anon_sym_i32] = ACTIONS(6160),
    [anon_sym_u64] = ACTIONS(6160),
    [anon_sym_i64] = ACTIONS(6160),
    [anon_sym_u128] = ACTIONS(6160),
    [anon_sym_i128] = ACTIONS(6160),
    [anon_sym_isize] = ACTIONS(6160),
    [anon_sym_usize] = ACTIONS(6160),
    [anon_sym_f32] = ACTIONS(6160),
    [anon_sym_f64] = ACTIONS(6160),
    [anon_sym_bool] = ACTIONS(6160),
    [anon_sym_str] = ACTIONS(6160),
    [anon_sym_char] = ACTIONS(6160),
    [anon_sym__] = ACTIONS(6160),
    [anon_sym_AMP] = ACTIONS(6160),
    [anon_sym_DASH] = ACTIONS(6160),
    [anon_sym_DOT] = ACTIONS(6160),
    [anon_sym_DASH_EQ] = ACTIONS(6158),
    [anon_sym_COLON_COLON] = ACTIONS(6158),
    [anon_sym_BANG_EQ] = ACTIONS(6158),
    [anon_sym_STAR_EQ] = ACTIONS(6158),
    [anon_sym_SLASH] = ACTIONS(6160),
    [anon_sym_SLASH_EQ] = ACTIONS(6158),
    [anon_sym_AMP_AMP] = ACTIONS(6158),
    [anon_sym_AMP_EQ] = ACTIONS(6158),
    [anon_sym_POUND] = ACTIONS(6158),
    [anon_sym_PERCENT] = ACTIONS(6160),
    [anon_sym_PERCENT_EQ] = ACTIONS(6158),
    [anon_sym_CARET] = ACTIONS(6160),
    [anon_sym_CARET_EQ] = ACTIONS(6158),
    [anon_sym_PLUS_EQ] = ACTIONS(6158),
    [anon_sym_LT] = ACTIONS(6160),
    [anon_sym_LT_LT] = ACTIONS(6160),
    [anon_sym_LT_LT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_EQ] = ACTIONS(6160),
    [anon_sym_EQ_EQ] = ACTIONS(6158),
    [anon_sym_GT] = ACTIONS(6160),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_GT_GT] = ACTIONS(6160),
    [anon_sym_GT_GT_EQ] = ACTIONS(6158),
    [anon_sym_PIPE] = ACTIONS(6160),
    [anon_sym_PIPE_EQ] = ACTIONS(6158),
    [anon_sym_PIPE_PIPE] = ACTIONS(6158),
    [anon_sym_QMARK] = ACTIONS(6158),
    [anon_sym_DOT_DOT] = ACTIONS(6160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6158),
    [anon_sym_as] = ACTIONS(6160),
    [sym_mutable_specifier] = ACTIONS(6160),
    [anon_sym_else] = ACTIONS(7401),
    [anon_sym_ref] = ACTIONS(6160),
    [sym_integer_literal] = ACTIONS(6158),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6158),
    [sym_char_literal] = ACTIONS(6158),
    [anon_sym_true] = ACTIONS(6160),
    [anon_sym_false] = ACTIONS(6160),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6160),
    [sym_self] = ACTIONS(6160),
    [sym_super] = ACTIONS(6160),
    [sym_crate] = ACTIONS(6160),
    [sym_metavariable] = ACTIONS(6158),
  },
  [3637] = {
    [sym_raw_string_literal] = ACTIONS(6371),
    [sym_float_literal] = ACTIONS(6371),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6371),
    [anon_sym_RBRACE] = ACTIONS(6371),
    [anon_sym_LBRACK] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(6373),
    [anon_sym_STAR] = ACTIONS(6373),
    [anon_sym_COMMA] = ACTIONS(6371),
    [anon_sym_u8] = ACTIONS(6373),
    [anon_sym_i8] = ACTIONS(6373),
    [anon_sym_u16] = ACTIONS(6373),
    [anon_sym_i16] = ACTIONS(6373),
    [anon_sym_u32] = ACTIONS(6373),
    [anon_sym_i32] = ACTIONS(6373),
    [anon_sym_u64] = ACTIONS(6373),
    [anon_sym_i64] = ACTIONS(6373),
    [anon_sym_u128] = ACTIONS(6373),
    [anon_sym_i128] = ACTIONS(6373),
    [anon_sym_isize] = ACTIONS(6373),
    [anon_sym_usize] = ACTIONS(6373),
    [anon_sym_f32] = ACTIONS(6373),
    [anon_sym_f64] = ACTIONS(6373),
    [anon_sym_bool] = ACTIONS(6373),
    [anon_sym_str] = ACTIONS(6373),
    [anon_sym_char] = ACTIONS(6373),
    [anon_sym__] = ACTIONS(6373),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_DASH] = ACTIONS(6373),
    [anon_sym_DOT] = ACTIONS(6373),
    [anon_sym_DASH_EQ] = ACTIONS(6371),
    [anon_sym_COLON_COLON] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6371),
    [anon_sym_STAR_EQ] = ACTIONS(6371),
    [anon_sym_SLASH] = ACTIONS(6373),
    [anon_sym_SLASH_EQ] = ACTIONS(6371),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_AMP_EQ] = ACTIONS(6371),
    [anon_sym_POUND] = ACTIONS(6371),
    [anon_sym_PERCENT] = ACTIONS(6373),
    [anon_sym_PERCENT_EQ] = ACTIONS(6371),
    [anon_sym_CARET] = ACTIONS(6373),
    [anon_sym_CARET_EQ] = ACTIONS(6371),
    [anon_sym_PLUS_EQ] = ACTIONS(6371),
    [anon_sym_LT] = ACTIONS(6373),
    [anon_sym_LT_LT] = ACTIONS(6373),
    [anon_sym_LT_LT_EQ] = ACTIONS(6371),
    [anon_sym_LT_EQ] = ACTIONS(6371),
    [anon_sym_EQ] = ACTIONS(6373),
    [anon_sym_EQ_EQ] = ACTIONS(6371),
    [anon_sym_GT] = ACTIONS(6373),
    [anon_sym_GT_EQ] = ACTIONS(6371),
    [anon_sym_GT_GT] = ACTIONS(6373),
    [anon_sym_GT_GT_EQ] = ACTIONS(6371),
    [anon_sym_PIPE] = ACTIONS(6373),
    [anon_sym_PIPE_EQ] = ACTIONS(6371),
    [anon_sym_PIPE_PIPE] = ACTIONS(6371),
    [anon_sym_QMARK] = ACTIONS(6371),
    [anon_sym_DOT_DOT] = ACTIONS(6373),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6371),
    [anon_sym_as] = ACTIONS(6373),
    [sym_mutable_specifier] = ACTIONS(6373),
    [anon_sym_ref] = ACTIONS(6373),
    [sym_integer_literal] = ACTIONS(6371),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6371),
    [sym_char_literal] = ACTIONS(6371),
    [anon_sym_true] = ACTIONS(6373),
    [anon_sym_false] = ACTIONS(6373),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6373),
    [sym_self] = ACTIONS(6373),
    [sym_super] = ACTIONS(6373),
    [sym_crate] = ACTIONS(6373),
    [sym_metavariable] = ACTIONS(6371),
  },
  [3638] = {
    [sym_raw_string_literal] = ACTIONS(6504),
    [sym_float_literal] = ACTIONS(6504),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6504),
    [anon_sym_RBRACE] = ACTIONS(6504),
    [anon_sym_LBRACK] = ACTIONS(6504),
    [anon_sym_PLUS] = ACTIONS(6506),
    [anon_sym_STAR] = ACTIONS(6506),
    [anon_sym_COMMA] = ACTIONS(6504),
    [anon_sym_u8] = ACTIONS(6506),
    [anon_sym_i8] = ACTIONS(6506),
    [anon_sym_u16] = ACTIONS(6506),
    [anon_sym_i16] = ACTIONS(6506),
    [anon_sym_u32] = ACTIONS(6506),
    [anon_sym_i32] = ACTIONS(6506),
    [anon_sym_u64] = ACTIONS(6506),
    [anon_sym_i64] = ACTIONS(6506),
    [anon_sym_u128] = ACTIONS(6506),
    [anon_sym_i128] = ACTIONS(6506),
    [anon_sym_isize] = ACTIONS(6506),
    [anon_sym_usize] = ACTIONS(6506),
    [anon_sym_f32] = ACTIONS(6506),
    [anon_sym_f64] = ACTIONS(6506),
    [anon_sym_bool] = ACTIONS(6506),
    [anon_sym_str] = ACTIONS(6506),
    [anon_sym_char] = ACTIONS(6506),
    [anon_sym__] = ACTIONS(6506),
    [anon_sym_AMP] = ACTIONS(6506),
    [anon_sym_DASH] = ACTIONS(6506),
    [anon_sym_DOT] = ACTIONS(6506),
    [anon_sym_DASH_EQ] = ACTIONS(6504),
    [anon_sym_COLON_COLON] = ACTIONS(6504),
    [anon_sym_BANG_EQ] = ACTIONS(6504),
    [anon_sym_STAR_EQ] = ACTIONS(6504),
    [anon_sym_SLASH] = ACTIONS(6506),
    [anon_sym_SLASH_EQ] = ACTIONS(6504),
    [anon_sym_AMP_AMP] = ACTIONS(6504),
    [anon_sym_AMP_EQ] = ACTIONS(6504),
    [anon_sym_POUND] = ACTIONS(6504),
    [anon_sym_PERCENT] = ACTIONS(6506),
    [anon_sym_PERCENT_EQ] = ACTIONS(6504),
    [anon_sym_CARET] = ACTIONS(6506),
    [anon_sym_CARET_EQ] = ACTIONS(6504),
    [anon_sym_PLUS_EQ] = ACTIONS(6504),
    [anon_sym_LT] = ACTIONS(6506),
    [anon_sym_LT_LT] = ACTIONS(6506),
    [anon_sym_LT_LT_EQ] = ACTIONS(6504),
    [anon_sym_LT_EQ] = ACTIONS(6504),
    [anon_sym_EQ] = ACTIONS(6506),
    [anon_sym_EQ_EQ] = ACTIONS(6504),
    [anon_sym_GT] = ACTIONS(6506),
    [anon_sym_GT_EQ] = ACTIONS(6504),
    [anon_sym_GT_GT] = ACTIONS(6506),
    [anon_sym_GT_GT_EQ] = ACTIONS(6504),
    [anon_sym_PIPE] = ACTIONS(6506),
    [anon_sym_PIPE_EQ] = ACTIONS(6504),
    [anon_sym_PIPE_PIPE] = ACTIONS(6504),
    [anon_sym_QMARK] = ACTIONS(6504),
    [anon_sym_DOT_DOT] = ACTIONS(6506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6504),
    [anon_sym_as] = ACTIONS(6506),
    [sym_mutable_specifier] = ACTIONS(6506),
    [anon_sym_ref] = ACTIONS(6506),
    [sym_integer_literal] = ACTIONS(6504),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6504),
    [sym_char_literal] = ACTIONS(6504),
    [anon_sym_true] = ACTIONS(6506),
    [anon_sym_false] = ACTIONS(6506),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6506),
    [sym_self] = ACTIONS(6506),
    [sym_super] = ACTIONS(6506),
    [sym_crate] = ACTIONS(6506),
    [sym_metavariable] = ACTIONS(6504),
  },
  [3639] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(3677),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(5136),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [3640] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3678),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(3678),
    [sym_macro_invocation] = STATE(3678),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3678),
    [sym_try_expression] = STATE(3678),
    [sym_reference_expression] = STATE(3678),
    [sym_binary_expression] = STATE(3678),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_array_expression] = STATE(3678),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_tuple_expression] = STATE(3678),
    [sym_unit_expression] = STATE(3678),
    [sym_struct_expression] = STATE(3678),
    [sym_if_expression] = STATE(3678),
    [sym_if_let_expression] = STATE(3678),
    [sym_match_expression] = STATE(3678),
    [sym_while_expression] = STATE(3678),
    [sym_while_let_expression] = STATE(3678),
    [sym_loop_expression] = STATE(3678),
    [sym_for_expression] = STATE(3678),
    [sym_closure_expression] = STATE(3678),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3678),
    [sym_continue_expression] = STATE(3678),
    [sym_index_expression] = STATE(3678),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3678),
    [sym_block] = STATE(3678),
    [sym__literal] = STATE(3678),
    [sym_string_literal] = STATE(3678),
    [sym_boolean_literal] = STATE(3678),
    [sym_raw_string_literal] = ACTIONS(7872),
    [sym_float_literal] = ACTIONS(7872),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(7872),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7872),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [3641] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5858),
    [anon_sym_EQ_GT] = ACTIONS(5858),
    [anon_sym_LBRACK] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_STAR] = ACTIONS(5860),
    [anon_sym_AMP] = ACTIONS(5860),
    [anon_sym_DASH] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5858),
    [anon_sym_STAR_EQ] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_AMP_EQ] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5858),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5858),
    [anon_sym_PLUS_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5858),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5860),
    [anon_sym_GT_EQ] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5858),
    [anon_sym_PIPE] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5858),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_QMARK] = ACTIONS(5858),
    [anon_sym_DOT_DOT] = ACTIONS(5860),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5858),
    [anon_sym_as] = ACTIONS(5858),
    [sym_line_comment] = ACTIONS(7),
  },
  [3642] = {
    [sym_else_tail] = STATE(3679),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6158),
    [anon_sym_EQ_GT] = ACTIONS(6158),
    [anon_sym_LBRACK] = ACTIONS(6158),
    [anon_sym_PLUS] = ACTIONS(6160),
    [anon_sym_STAR] = ACTIONS(6160),
    [anon_sym_AMP] = ACTIONS(6160),
    [anon_sym_DASH] = ACTIONS(6160),
    [anon_sym_DOT] = ACTIONS(6160),
    [anon_sym_DASH_EQ] = ACTIONS(6158),
    [anon_sym_BANG_EQ] = ACTIONS(6158),
    [anon_sym_STAR_EQ] = ACTIONS(6158),
    [anon_sym_SLASH] = ACTIONS(6160),
    [anon_sym_SLASH_EQ] = ACTIONS(6158),
    [anon_sym_AMP_AMP] = ACTIONS(6158),
    [anon_sym_AMP_EQ] = ACTIONS(6158),
    [anon_sym_PERCENT] = ACTIONS(6160),
    [anon_sym_PERCENT_EQ] = ACTIONS(6158),
    [anon_sym_CARET] = ACTIONS(6160),
    [anon_sym_CARET_EQ] = ACTIONS(6158),
    [anon_sym_PLUS_EQ] = ACTIONS(6158),
    [anon_sym_LT] = ACTIONS(6160),
    [anon_sym_LT_LT] = ACTIONS(6160),
    [anon_sym_LT_LT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_EQ] = ACTIONS(6160),
    [anon_sym_EQ_EQ] = ACTIONS(6158),
    [anon_sym_GT] = ACTIONS(6160),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_GT_GT] = ACTIONS(6160),
    [anon_sym_GT_GT_EQ] = ACTIONS(6158),
    [anon_sym_PIPE] = ACTIONS(6160),
    [anon_sym_PIPE_EQ] = ACTIONS(6158),
    [anon_sym_PIPE_PIPE] = ACTIONS(6158),
    [anon_sym_QMARK] = ACTIONS(6158),
    [anon_sym_DOT_DOT] = ACTIONS(6160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6158),
    [anon_sym_as] = ACTIONS(6158),
    [anon_sym_else] = ACTIONS(7431),
    [sym_line_comment] = ACTIONS(7),
  },
  [3643] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6371),
    [anon_sym_EQ_GT] = ACTIONS(6371),
    [anon_sym_LBRACK] = ACTIONS(6371),
    [anon_sym_PLUS] = ACTIONS(6373),
    [anon_sym_STAR] = ACTIONS(6373),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_DASH] = ACTIONS(6373),
    [anon_sym_DOT] = ACTIONS(6373),
    [anon_sym_DASH_EQ] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6371),
    [anon_sym_STAR_EQ] = ACTIONS(6371),
    [anon_sym_SLASH] = ACTIONS(6373),
    [anon_sym_SLASH_EQ] = ACTIONS(6371),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_AMP_EQ] = ACTIONS(6371),
    [anon_sym_PERCENT] = ACTIONS(6373),
    [anon_sym_PERCENT_EQ] = ACTIONS(6371),
    [anon_sym_CARET] = ACTIONS(6373),
    [anon_sym_CARET_EQ] = ACTIONS(6371),
    [anon_sym_PLUS_EQ] = ACTIONS(6371),
    [anon_sym_LT] = ACTIONS(6373),
    [anon_sym_LT_LT] = ACTIONS(6373),
    [anon_sym_LT_LT_EQ] = ACTIONS(6371),
    [anon_sym_LT_EQ] = ACTIONS(6371),
    [anon_sym_EQ] = ACTIONS(6373),
    [anon_sym_EQ_EQ] = ACTIONS(6371),
    [anon_sym_GT] = ACTIONS(6373),
    [anon_sym_GT_EQ] = ACTIONS(6371),
    [anon_sym_GT_GT] = ACTIONS(6373),
    [anon_sym_GT_GT_EQ] = ACTIONS(6371),
    [anon_sym_PIPE] = ACTIONS(6373),
    [anon_sym_PIPE_EQ] = ACTIONS(6371),
    [anon_sym_PIPE_PIPE] = ACTIONS(6371),
    [anon_sym_QMARK] = ACTIONS(6371),
    [anon_sym_DOT_DOT] = ACTIONS(6373),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6371),
    [anon_sym_as] = ACTIONS(6371),
    [sym_line_comment] = ACTIONS(7),
  },
  [3644] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6504),
    [anon_sym_EQ_GT] = ACTIONS(6504),
    [anon_sym_LBRACK] = ACTIONS(6504),
    [anon_sym_PLUS] = ACTIONS(6506),
    [anon_sym_STAR] = ACTIONS(6506),
    [anon_sym_AMP] = ACTIONS(6506),
    [anon_sym_DASH] = ACTIONS(6506),
    [anon_sym_DOT] = ACTIONS(6506),
    [anon_sym_DASH_EQ] = ACTIONS(6504),
    [anon_sym_BANG_EQ] = ACTIONS(6504),
    [anon_sym_STAR_EQ] = ACTIONS(6504),
    [anon_sym_SLASH] = ACTIONS(6506),
    [anon_sym_SLASH_EQ] = ACTIONS(6504),
    [anon_sym_AMP_AMP] = ACTIONS(6504),
    [anon_sym_AMP_EQ] = ACTIONS(6504),
    [anon_sym_PERCENT] = ACTIONS(6506),
    [anon_sym_PERCENT_EQ] = ACTIONS(6504),
    [anon_sym_CARET] = ACTIONS(6506),
    [anon_sym_CARET_EQ] = ACTIONS(6504),
    [anon_sym_PLUS_EQ] = ACTIONS(6504),
    [anon_sym_LT] = ACTIONS(6506),
    [anon_sym_LT_LT] = ACTIONS(6506),
    [anon_sym_LT_LT_EQ] = ACTIONS(6504),
    [anon_sym_LT_EQ] = ACTIONS(6504),
    [anon_sym_EQ] = ACTIONS(6506),
    [anon_sym_EQ_EQ] = ACTIONS(6504),
    [anon_sym_GT] = ACTIONS(6506),
    [anon_sym_GT_EQ] = ACTIONS(6504),
    [anon_sym_GT_GT] = ACTIONS(6506),
    [anon_sym_GT_GT_EQ] = ACTIONS(6504),
    [anon_sym_PIPE] = ACTIONS(6506),
    [anon_sym_PIPE_EQ] = ACTIONS(6504),
    [anon_sym_PIPE_PIPE] = ACTIONS(6504),
    [anon_sym_QMARK] = ACTIONS(6504),
    [anon_sym_DOT_DOT] = ACTIONS(6506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6504),
    [anon_sym_as] = ACTIONS(6504),
    [sym_line_comment] = ACTIONS(7),
  },
  [3645] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6526),
    [anon_sym_EQ_GT] = ACTIONS(6526),
    [anon_sym_LBRACK] = ACTIONS(6526),
    [anon_sym_PLUS] = ACTIONS(6528),
    [anon_sym_STAR] = ACTIONS(6528),
    [anon_sym_AMP] = ACTIONS(6528),
    [anon_sym_DASH] = ACTIONS(6528),
    [anon_sym_DOT] = ACTIONS(6528),
    [anon_sym_DASH_EQ] = ACTIONS(6526),
    [anon_sym_BANG_EQ] = ACTIONS(6526),
    [anon_sym_STAR_EQ] = ACTIONS(6526),
    [anon_sym_SLASH] = ACTIONS(6528),
    [anon_sym_SLASH_EQ] = ACTIONS(6526),
    [anon_sym_AMP_AMP] = ACTIONS(6526),
    [anon_sym_AMP_EQ] = ACTIONS(6526),
    [anon_sym_PERCENT] = ACTIONS(6528),
    [anon_sym_PERCENT_EQ] = ACTIONS(6526),
    [anon_sym_CARET] = ACTIONS(6528),
    [anon_sym_CARET_EQ] = ACTIONS(6526),
    [anon_sym_PLUS_EQ] = ACTIONS(6526),
    [anon_sym_LT] = ACTIONS(6528),
    [anon_sym_LT_LT] = ACTIONS(6528),
    [anon_sym_LT_LT_EQ] = ACTIONS(6526),
    [anon_sym_LT_EQ] = ACTIONS(6526),
    [anon_sym_EQ] = ACTIONS(6528),
    [anon_sym_EQ_EQ] = ACTIONS(6526),
    [anon_sym_GT] = ACTIONS(6528),
    [anon_sym_GT_EQ] = ACTIONS(6526),
    [anon_sym_GT_GT] = ACTIONS(6528),
    [anon_sym_GT_GT_EQ] = ACTIONS(6526),
    [anon_sym_PIPE] = ACTIONS(6528),
    [anon_sym_PIPE_EQ] = ACTIONS(6526),
    [anon_sym_PIPE_PIPE] = ACTIONS(6526),
    [anon_sym_QMARK] = ACTIONS(6526),
    [anon_sym_DOT_DOT] = ACTIONS(6528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6526),
    [anon_sym_as] = ACTIONS(6526),
    [sym_line_comment] = ACTIONS(7),
  },
  [3646] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6530),
    [anon_sym_EQ_GT] = ACTIONS(6530),
    [anon_sym_LBRACK] = ACTIONS(6530),
    [anon_sym_PLUS] = ACTIONS(6532),
    [anon_sym_STAR] = ACTIONS(6532),
    [anon_sym_AMP] = ACTIONS(6532),
    [anon_sym_DASH] = ACTIONS(6532),
    [anon_sym_DOT] = ACTIONS(6532),
    [anon_sym_DASH_EQ] = ACTIONS(6530),
    [anon_sym_BANG_EQ] = ACTIONS(6530),
    [anon_sym_STAR_EQ] = ACTIONS(6530),
    [anon_sym_SLASH] = ACTIONS(6532),
    [anon_sym_SLASH_EQ] = ACTIONS(6530),
    [anon_sym_AMP_AMP] = ACTIONS(6530),
    [anon_sym_AMP_EQ] = ACTIONS(6530),
    [anon_sym_PERCENT] = ACTIONS(6532),
    [anon_sym_PERCENT_EQ] = ACTIONS(6530),
    [anon_sym_CARET] = ACTIONS(6532),
    [anon_sym_CARET_EQ] = ACTIONS(6530),
    [anon_sym_PLUS_EQ] = ACTIONS(6530),
    [anon_sym_LT] = ACTIONS(6532),
    [anon_sym_LT_LT] = ACTIONS(6532),
    [anon_sym_LT_LT_EQ] = ACTIONS(6530),
    [anon_sym_LT_EQ] = ACTIONS(6530),
    [anon_sym_EQ] = ACTIONS(6532),
    [anon_sym_EQ_EQ] = ACTIONS(6530),
    [anon_sym_GT] = ACTIONS(6532),
    [anon_sym_GT_EQ] = ACTIONS(6530),
    [anon_sym_GT_GT] = ACTIONS(6532),
    [anon_sym_GT_GT_EQ] = ACTIONS(6530),
    [anon_sym_PIPE] = ACTIONS(6532),
    [anon_sym_PIPE_EQ] = ACTIONS(6530),
    [anon_sym_PIPE_PIPE] = ACTIONS(6530),
    [anon_sym_QMARK] = ACTIONS(6530),
    [anon_sym_DOT_DOT] = ACTIONS(6532),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6530),
    [anon_sym_as] = ACTIONS(6530),
    [sym_line_comment] = ACTIONS(7),
  },
  [3647] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5997),
    [anon_sym_LBRACE] = ACTIONS(5997),
    [anon_sym_EQ_GT] = ACTIONS(5997),
    [anon_sym_LBRACK] = ACTIONS(5997),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_STAR] = ACTIONS(5999),
    [anon_sym_AMP] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(5999),
    [anon_sym_DOT] = ACTIONS(5999),
    [anon_sym_DASH_EQ] = ACTIONS(5997),
    [anon_sym_COLON_COLON] = ACTIONS(5997),
    [anon_sym_BANG_EQ] = ACTIONS(5997),
    [anon_sym_STAR_EQ] = ACTIONS(5997),
    [anon_sym_SLASH] = ACTIONS(5999),
    [anon_sym_SLASH_EQ] = ACTIONS(5997),
    [anon_sym_AMP_AMP] = ACTIONS(5997),
    [anon_sym_AMP_EQ] = ACTIONS(5997),
    [anon_sym_PERCENT] = ACTIONS(5999),
    [anon_sym_PERCENT_EQ] = ACTIONS(5997),
    [anon_sym_CARET] = ACTIONS(5999),
    [anon_sym_CARET_EQ] = ACTIONS(5997),
    [anon_sym_PLUS_EQ] = ACTIONS(5997),
    [anon_sym_LT] = ACTIONS(5999),
    [anon_sym_LT_LT] = ACTIONS(5999),
    [anon_sym_LT_LT_EQ] = ACTIONS(5997),
    [anon_sym_LT_EQ] = ACTIONS(5997),
    [anon_sym_EQ] = ACTIONS(5999),
    [anon_sym_EQ_EQ] = ACTIONS(5997),
    [anon_sym_GT] = ACTIONS(5999),
    [anon_sym_GT_EQ] = ACTIONS(5997),
    [anon_sym_GT_GT] = ACTIONS(5999),
    [anon_sym_GT_GT_EQ] = ACTIONS(5997),
    [anon_sym_PIPE] = ACTIONS(5999),
    [anon_sym_PIPE_EQ] = ACTIONS(5997),
    [anon_sym_PIPE_PIPE] = ACTIONS(5997),
    [anon_sym_QMARK] = ACTIONS(5997),
    [anon_sym_DOT_DOT] = ACTIONS(5999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5997),
    [anon_sym_as] = ACTIONS(5997),
    [sym_line_comment] = ACTIONS(7),
  },
  [3648] = {
    [sym_function_modifiers] = STATE(854),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2151),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(2152),
    [sym_array_type] = STATE(2151),
    [sym_function_type] = STATE(2151),
    [sym_tuple_type] = STATE(2151),
    [sym_unit_type] = STATE(2151),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2151),
    [sym_type_binding] = STATE(2153),
    [sym_reference_type] = STATE(2151),
    [sym_pointer_type] = STATE(2151),
    [sym_empty_type] = STATE(2151),
    [sym_dynamic_type] = STATE(2151),
    [sym_macro_invocation] = STATE(2151),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(858),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(1786),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(1788),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_GT] = ACTIONS(7874),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(1790),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1792),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3649] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6588),
    [anon_sym_EQ_GT] = ACTIONS(6588),
    [anon_sym_LBRACK] = ACTIONS(6588),
    [anon_sym_PLUS] = ACTIONS(6590),
    [anon_sym_STAR] = ACTIONS(6590),
    [anon_sym_AMP] = ACTIONS(6590),
    [anon_sym_DASH] = ACTIONS(6590),
    [anon_sym_DOT] = ACTIONS(6590),
    [anon_sym_DASH_EQ] = ACTIONS(6588),
    [anon_sym_BANG_EQ] = ACTIONS(6588),
    [anon_sym_STAR_EQ] = ACTIONS(6588),
    [anon_sym_SLASH] = ACTIONS(6590),
    [anon_sym_SLASH_EQ] = ACTIONS(6588),
    [anon_sym_AMP_AMP] = ACTIONS(6588),
    [anon_sym_AMP_EQ] = ACTIONS(6588),
    [anon_sym_PERCENT] = ACTIONS(6590),
    [anon_sym_PERCENT_EQ] = ACTIONS(6588),
    [anon_sym_CARET] = ACTIONS(6590),
    [anon_sym_CARET_EQ] = ACTIONS(6588),
    [anon_sym_PLUS_EQ] = ACTIONS(6588),
    [anon_sym_LT] = ACTIONS(6590),
    [anon_sym_LT_LT] = ACTIONS(6590),
    [anon_sym_LT_LT_EQ] = ACTIONS(6588),
    [anon_sym_LT_EQ] = ACTIONS(6588),
    [anon_sym_EQ] = ACTIONS(6590),
    [anon_sym_EQ_EQ] = ACTIONS(6588),
    [anon_sym_GT] = ACTIONS(6590),
    [anon_sym_GT_EQ] = ACTIONS(6588),
    [anon_sym_GT_GT] = ACTIONS(6590),
    [anon_sym_GT_GT_EQ] = ACTIONS(6588),
    [anon_sym_PIPE] = ACTIONS(6590),
    [anon_sym_PIPE_EQ] = ACTIONS(6588),
    [anon_sym_PIPE_PIPE] = ACTIONS(6588),
    [anon_sym_QMARK] = ACTIONS(6588),
    [anon_sym_DOT_DOT] = ACTIONS(6590),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6588),
    [anon_sym_as] = ACTIONS(6588),
    [sym_line_comment] = ACTIONS(7),
  },
  [3650] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(1972),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(1972),
    [sym_macro_invocation] = STATE(1972),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(1972),
    [sym_unary_expression] = STATE(1972),
    [sym_try_expression] = STATE(1972),
    [sym_reference_expression] = STATE(1972),
    [sym_binary_expression] = STATE(1972),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(1972),
    [sym_call_expression] = STATE(1972),
    [sym_array_expression] = STATE(1972),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_tuple_expression] = STATE(1972),
    [sym_unit_expression] = STATE(1972),
    [sym_struct_expression] = STATE(1972),
    [sym_if_expression] = STATE(1972),
    [sym_if_let_expression] = STATE(1972),
    [sym_match_expression] = STATE(1972),
    [sym_while_expression] = STATE(1972),
    [sym_while_let_expression] = STATE(1972),
    [sym_loop_expression] = STATE(1972),
    [sym_for_expression] = STATE(1972),
    [sym_closure_expression] = STATE(1972),
    [sym_closure_parameters] = STATE(80),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(1972),
    [sym_continue_expression] = STATE(1972),
    [sym_index_expression] = STATE(1972),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(1972),
    [sym_block] = STATE(1972),
    [sym__literal] = STATE(1972),
    [sym_string_literal] = STATE(1972),
    [sym_boolean_literal] = STATE(1972),
    [sym_raw_string_literal] = ACTIONS(4375),
    [sym_float_literal] = ACTIONS(4375),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_RPAREN] = ACTIONS(7876),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(129),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(135),
    [sym_integer_literal] = ACTIONS(4375),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(4375),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [3651] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(769),
    [sym_generic_type_with_turbofish] = STATE(51),
    [sym__expression] = STATE(769),
    [sym_macro_invocation] = STATE(769),
    [sym_scoped_identifier] = STATE(54),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(769),
    [sym_unary_expression] = STATE(769),
    [sym_try_expression] = STATE(769),
    [sym_reference_expression] = STATE(769),
    [sym_binary_expression] = STATE(769),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(769),
    [sym_call_expression] = STATE(769),
    [sym_array_expression] = STATE(769),
    [sym_parenthesized_expression] = STATE(769),
    [sym_tuple_expression] = STATE(769),
    [sym_unit_expression] = STATE(769),
    [sym_struct_expression] = STATE(769),
    [sym_if_expression] = STATE(769),
    [sym_if_let_expression] = STATE(769),
    [sym_match_expression] = STATE(769),
    [sym_while_expression] = STATE(769),
    [sym_while_let_expression] = STATE(769),
    [sym_loop_expression] = STATE(769),
    [sym_for_expression] = STATE(769),
    [sym_closure_expression] = STATE(769),
    [sym_closure_parameters] = STATE(770),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(769),
    [sym_continue_expression] = STATE(769),
    [sym_index_expression] = STATE(769),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(769),
    [sym_block] = STATE(769),
    [sym__literal] = STATE(769),
    [sym_string_literal] = STATE(769),
    [sym_boolean_literal] = STATE(769),
    [sym_raw_string_literal] = ACTIONS(1620),
    [sym_float_literal] = ACTIONS(1620),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_RBRACK] = ACTIONS(7876),
    [anon_sym_STAR] = ACTIONS(1624),
    [anon_sym_u8] = ACTIONS(23),
    [anon_sym_i8] = ACTIONS(23),
    [anon_sym_u16] = ACTIONS(23),
    [anon_sym_i16] = ACTIONS(23),
    [anon_sym_u32] = ACTIONS(23),
    [anon_sym_i32] = ACTIONS(23),
    [anon_sym_u64] = ACTIONS(23),
    [anon_sym_i64] = ACTIONS(23),
    [anon_sym_u128] = ACTIONS(23),
    [anon_sym_i128] = ACTIONS(23),
    [anon_sym_isize] = ACTIONS(23),
    [anon_sym_usize] = ACTIONS(23),
    [anon_sym_f32] = ACTIONS(23),
    [anon_sym_f64] = ACTIONS(23),
    [anon_sym_bool] = ACTIONS(23),
    [anon_sym_str] = ACTIONS(23),
    [anon_sym_char] = ACTIONS(23),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1624),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(1628),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(1630),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(1632),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(1634),
    [sym_integer_literal] = ACTIONS(1620),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(1620),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(137),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(99),
  },
  [3652] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6690),
    [anon_sym_EQ_GT] = ACTIONS(6690),
    [anon_sym_LBRACK] = ACTIONS(6690),
    [anon_sym_PLUS] = ACTIONS(6692),
    [anon_sym_STAR] = ACTIONS(6692),
    [anon_sym_AMP] = ACTIONS(6692),
    [anon_sym_DASH] = ACTIONS(6692),
    [anon_sym_DOT] = ACTIONS(6692),
    [anon_sym_DASH_EQ] = ACTIONS(6690),
    [anon_sym_BANG_EQ] = ACTIONS(6690),
    [anon_sym_STAR_EQ] = ACTIONS(6690),
    [anon_sym_SLASH] = ACTIONS(6692),
    [anon_sym_SLASH_EQ] = ACTIONS(6690),
    [anon_sym_AMP_AMP] = ACTIONS(6690),
    [anon_sym_AMP_EQ] = ACTIONS(6690),
    [anon_sym_PERCENT] = ACTIONS(6692),
    [anon_sym_PERCENT_EQ] = ACTIONS(6690),
    [anon_sym_CARET] = ACTIONS(6692),
    [anon_sym_CARET_EQ] = ACTIONS(6690),
    [anon_sym_PLUS_EQ] = ACTIONS(6690),
    [anon_sym_LT] = ACTIONS(6692),
    [anon_sym_LT_LT] = ACTIONS(6692),
    [anon_sym_LT_LT_EQ] = ACTIONS(6690),
    [anon_sym_LT_EQ] = ACTIONS(6690),
    [anon_sym_EQ] = ACTIONS(6692),
    [anon_sym_EQ_EQ] = ACTIONS(6690),
    [anon_sym_GT] = ACTIONS(6692),
    [anon_sym_GT_EQ] = ACTIONS(6690),
    [anon_sym_GT_GT] = ACTIONS(6692),
    [anon_sym_GT_GT_EQ] = ACTIONS(6690),
    [anon_sym_PIPE] = ACTIONS(6692),
    [anon_sym_PIPE_EQ] = ACTIONS(6690),
    [anon_sym_PIPE_PIPE] = ACTIONS(6690),
    [anon_sym_QMARK] = ACTIONS(6690),
    [anon_sym_DOT_DOT] = ACTIONS(6692),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6690),
    [anon_sym_as] = ACTIONS(6690),
    [sym_line_comment] = ACTIONS(7),
  },
  [3653] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(4749),
    [anon_sym_EQ_GT] = ACTIONS(4749),
    [anon_sym_LBRACK] = ACTIONS(4749),
    [anon_sym_PLUS] = ACTIONS(6704),
    [anon_sym_STAR] = ACTIONS(6704),
    [anon_sym_AMP] = ACTIONS(6704),
    [anon_sym_DASH] = ACTIONS(6704),
    [anon_sym_DOT] = ACTIONS(6704),
    [anon_sym_DASH_EQ] = ACTIONS(4749),
    [anon_sym_BANG_EQ] = ACTIONS(4749),
    [anon_sym_STAR_EQ] = ACTIONS(4749),
    [anon_sym_SLASH] = ACTIONS(6704),
    [anon_sym_SLASH_EQ] = ACTIONS(4749),
    [anon_sym_AMP_AMP] = ACTIONS(4749),
    [anon_sym_AMP_EQ] = ACTIONS(4749),
    [anon_sym_PERCENT] = ACTIONS(6704),
    [anon_sym_PERCENT_EQ] = ACTIONS(4749),
    [anon_sym_CARET] = ACTIONS(6704),
    [anon_sym_CARET_EQ] = ACTIONS(4749),
    [anon_sym_PLUS_EQ] = ACTIONS(4749),
    [anon_sym_LT] = ACTIONS(6704),
    [anon_sym_LT_LT] = ACTIONS(6704),
    [anon_sym_LT_LT_EQ] = ACTIONS(4749),
    [anon_sym_LT_EQ] = ACTIONS(4749),
    [anon_sym_EQ] = ACTIONS(6704),
    [anon_sym_EQ_EQ] = ACTIONS(4749),
    [anon_sym_GT] = ACTIONS(6704),
    [anon_sym_GT_EQ] = ACTIONS(4749),
    [anon_sym_GT_GT] = ACTIONS(6704),
    [anon_sym_GT_GT_EQ] = ACTIONS(4749),
    [anon_sym_PIPE] = ACTIONS(6704),
    [anon_sym_PIPE_EQ] = ACTIONS(4749),
    [anon_sym_PIPE_PIPE] = ACTIONS(4749),
    [anon_sym_QMARK] = ACTIONS(4749),
    [anon_sym_DOT_DOT] = ACTIONS(6704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4749),
    [anon_sym_as] = ACTIONS(4749),
    [sym_line_comment] = ACTIONS(7),
  },
  [3654] = {
    [sym_function_modifiers] = STATE(370),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(1470),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(372),
    [sym_array_type] = STATE(1470),
    [sym_function_type] = STATE(1470),
    [sym_tuple_type] = STATE(1470),
    [sym_unit_type] = STATE(1470),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(1470),
    [sym_reference_type] = STATE(1470),
    [sym_pointer_type] = STATE(1470),
    [sym_empty_type] = STATE(1470),
    [sym_dynamic_type] = STATE(1470),
    [sym_macro_invocation] = STATE(1470),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_RPAREN] = ACTIONS(7878),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(199),
    [anon_sym_i8] = ACTIONS(199),
    [anon_sym_u16] = ACTIONS(199),
    [anon_sym_i16] = ACTIONS(199),
    [anon_sym_u32] = ACTIONS(199),
    [anon_sym_i32] = ACTIONS(199),
    [anon_sym_u64] = ACTIONS(199),
    [anon_sym_i64] = ACTIONS(199),
    [anon_sym_u128] = ACTIONS(199),
    [anon_sym_i128] = ACTIONS(199),
    [anon_sym_isize] = ACTIONS(199),
    [anon_sym_usize] = ACTIONS(199),
    [anon_sym_f32] = ACTIONS(199),
    [anon_sym_f64] = ACTIONS(199),
    [anon_sym_bool] = ACTIONS(199),
    [anon_sym_str] = ACTIONS(199),
    [anon_sym_char] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(735),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(739),
    [sym_self] = ACTIONS(219),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3655] = {
    [sym_arguments] = STATE(263),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(7880),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_STAR_EQ] = ACTIONS(2563),
    [anon_sym_SLASH] = ACTIONS(2559),
    [anon_sym_SLASH_EQ] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_AMP_EQ] = ACTIONS(2563),
    [anon_sym_PERCENT] = ACTIONS(2559),
    [anon_sym_PERCENT_EQ] = ACTIONS(2563),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_CARET_EQ] = ACTIONS(2563),
    [anon_sym_PLUS_EQ] = ACTIONS(2563),
    [anon_sym_LT] = ACTIONS(2571),
    [anon_sym_LT_LT] = ACTIONS(2573),
    [anon_sym_LT_LT_EQ] = ACTIONS(2563),
    [anon_sym_LT_EQ] = ACTIONS(2565),
    [anon_sym_EQ] = ACTIONS(2575),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(2571),
    [anon_sym_GT_EQ] = ACTIONS(2565),
    [anon_sym_GT_GT] = ACTIONS(2573),
    [anon_sym_GT_GT_EQ] = ACTIONS(2563),
    [anon_sym_PIPE] = ACTIONS(2577),
    [anon_sym_PIPE_EQ] = ACTIONS(2563),
    [anon_sym_PIPE_PIPE] = ACTIONS(2579),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(2581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2583),
    [anon_sym_as] = ACTIONS(2585),
    [sym_line_comment] = ACTIONS(7),
  },
  [3656] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(4764),
    [anon_sym_EQ_GT] = ACTIONS(4764),
    [anon_sym_LBRACK] = ACTIONS(4764),
    [anon_sym_PLUS] = ACTIONS(6710),
    [anon_sym_STAR] = ACTIONS(6710),
    [anon_sym_AMP] = ACTIONS(6710),
    [anon_sym_DASH] = ACTIONS(6710),
    [anon_sym_DOT] = ACTIONS(6710),
    [anon_sym_DASH_EQ] = ACTIONS(4764),
    [anon_sym_BANG_EQ] = ACTIONS(4764),
    [anon_sym_STAR_EQ] = ACTIONS(4764),
    [anon_sym_SLASH] = ACTIONS(6710),
    [anon_sym_SLASH_EQ] = ACTIONS(4764),
    [anon_sym_AMP_AMP] = ACTIONS(4764),
    [anon_sym_AMP_EQ] = ACTIONS(4764),
    [anon_sym_PERCENT] = ACTIONS(6710),
    [anon_sym_PERCENT_EQ] = ACTIONS(4764),
    [anon_sym_CARET] = ACTIONS(6710),
    [anon_sym_CARET_EQ] = ACTIONS(4764),
    [anon_sym_PLUS_EQ] = ACTIONS(4764),
    [anon_sym_LT] = ACTIONS(6710),
    [anon_sym_LT_LT] = ACTIONS(6710),
    [anon_sym_LT_LT_EQ] = ACTIONS(4764),
    [anon_sym_LT_EQ] = ACTIONS(4764),
    [anon_sym_EQ] = ACTIONS(6710),
    [anon_sym_EQ_EQ] = ACTIONS(4764),
    [anon_sym_GT] = ACTIONS(6710),
    [anon_sym_GT_EQ] = ACTIONS(4764),
    [anon_sym_GT_GT] = ACTIONS(6710),
    [anon_sym_GT_GT_EQ] = ACTIONS(4764),
    [anon_sym_PIPE] = ACTIONS(6710),
    [anon_sym_PIPE_EQ] = ACTIONS(4764),
    [anon_sym_PIPE_PIPE] = ACTIONS(4764),
    [anon_sym_QMARK] = ACTIONS(4764),
    [anon_sym_DOT_DOT] = ACTIONS(6710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4764),
    [anon_sym_as] = ACTIONS(4764),
    [sym_line_comment] = ACTIONS(7),
  },
  [3657] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(4766),
    [anon_sym_EQ_GT] = ACTIONS(4766),
    [anon_sym_LBRACK] = ACTIONS(4766),
    [anon_sym_PLUS] = ACTIONS(6712),
    [anon_sym_STAR] = ACTIONS(6712),
    [anon_sym_AMP] = ACTIONS(6712),
    [anon_sym_DASH] = ACTIONS(6712),
    [anon_sym_DOT] = ACTIONS(6712),
    [anon_sym_DASH_EQ] = ACTIONS(4766),
    [anon_sym_DASH_GT] = ACTIONS(4766),
    [anon_sym_BANG_EQ] = ACTIONS(4766),
    [anon_sym_STAR_EQ] = ACTIONS(4766),
    [anon_sym_SLASH] = ACTIONS(6712),
    [anon_sym_SLASH_EQ] = ACTIONS(4766),
    [anon_sym_AMP_AMP] = ACTIONS(4766),
    [anon_sym_AMP_EQ] = ACTIONS(4766),
    [anon_sym_PERCENT] = ACTIONS(6712),
    [anon_sym_PERCENT_EQ] = ACTIONS(4766),
    [anon_sym_CARET] = ACTIONS(6712),
    [anon_sym_CARET_EQ] = ACTIONS(4766),
    [anon_sym_PLUS_EQ] = ACTIONS(4766),
    [anon_sym_LT] = ACTIONS(6712),
    [anon_sym_LT_LT] = ACTIONS(6712),
    [anon_sym_LT_LT_EQ] = ACTIONS(4766),
    [anon_sym_LT_EQ] = ACTIONS(4766),
    [anon_sym_EQ] = ACTIONS(6712),
    [anon_sym_EQ_EQ] = ACTIONS(4766),
    [anon_sym_GT] = ACTIONS(6712),
    [anon_sym_GT_EQ] = ACTIONS(4766),
    [anon_sym_GT_GT] = ACTIONS(6712),
    [anon_sym_GT_GT_EQ] = ACTIONS(4766),
    [anon_sym_PIPE] = ACTIONS(6712),
    [anon_sym_PIPE_EQ] = ACTIONS(4766),
    [anon_sym_PIPE_PIPE] = ACTIONS(4766),
    [anon_sym_QMARK] = ACTIONS(4766),
    [anon_sym_DOT_DOT] = ACTIONS(6712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4766),
    [anon_sym_as] = ACTIONS(4766),
    [sym_line_comment] = ACTIONS(7),
  },
  [3658] = {
    [sym_function_modifiers] = STATE(370),
    [sym_self_parameter] = STATE(2121),
    [sym_variadic_parameter] = STATE(2121),
    [sym_parameter] = STATE(2121),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2122),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(839),
    [sym_array_type] = STATE(2122),
    [sym_function_type] = STATE(2122),
    [sym_tuple_type] = STATE(2122),
    [sym_unit_type] = STATE(2122),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2122),
    [sym_reference_type] = STATE(2122),
    [sym_pointer_type] = STATE(2122),
    [sym_empty_type] = STATE(2122),
    [sym_abstract_type] = STATE(2121),
    [sym_dynamic_type] = STATE(2122),
    [sym_macro_invocation] = STATE(2122),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [sym_reference_pattern_in_parameter] = STATE(840),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_RPAREN] = ACTIONS(7882),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(1740),
    [anon_sym_i8] = ACTIONS(1740),
    [anon_sym_u16] = ACTIONS(1740),
    [anon_sym_i16] = ACTIONS(1740),
    [anon_sym_u32] = ACTIONS(1740),
    [anon_sym_i32] = ACTIONS(1740),
    [anon_sym_u64] = ACTIONS(1740),
    [anon_sym_i64] = ACTIONS(1740),
    [anon_sym_u128] = ACTIONS(1740),
    [anon_sym_i128] = ACTIONS(1740),
    [anon_sym_isize] = ACTIONS(1740),
    [anon_sym_usize] = ACTIONS(1740),
    [anon_sym_f32] = ACTIONS(1740),
    [anon_sym_f64] = ACTIONS(1740),
    [anon_sym_bool] = ACTIONS(1740),
    [anon_sym_str] = ACTIONS(1740),
    [anon_sym_char] = ACTIONS(1740),
    [anon_sym__] = ACTIONS(4770),
    [anon_sym_AMP] = ACTIONS(1744),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1746),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(1748),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_union] = ACTIONS(1752),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(1754),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1756),
    [sym_self] = ACTIONS(1758),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3659] = {
    [aux_sym_parameters_repeat1] = STATE(2124),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(7882),
    [anon_sym_COMMA] = ACTIONS(7884),
    [sym_line_comment] = ACTIONS(7),
  },
  [3660] = {
    [sym_bracketed_type] = STATE(3244),
    [sym_generic_type] = STATE(3687),
    [sym_generic_type_with_turbofish] = STATE(3250),
    [sym_scoped_identifier] = STATE(3251),
    [sym_scoped_type_identifier] = STATE(3688),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_u8] = ACTIONS(7477),
    [anon_sym_i8] = ACTIONS(7477),
    [anon_sym_u16] = ACTIONS(7477),
    [anon_sym_i16] = ACTIONS(7477),
    [anon_sym_u32] = ACTIONS(7477),
    [anon_sym_i32] = ACTIONS(7477),
    [anon_sym_u64] = ACTIONS(7477),
    [anon_sym_i64] = ACTIONS(7477),
    [anon_sym_u128] = ACTIONS(7477),
    [anon_sym_i128] = ACTIONS(7477),
    [anon_sym_isize] = ACTIONS(7477),
    [anon_sym_usize] = ACTIONS(7477),
    [anon_sym_f32] = ACTIONS(7477),
    [anon_sym_f64] = ACTIONS(7477),
    [anon_sym_bool] = ACTIONS(7477),
    [anon_sym_str] = ACTIONS(7477),
    [anon_sym_char] = ACTIONS(7477),
    [anon_sym_COLON_COLON] = ACTIONS(7069),
    [anon_sym_LT] = ACTIONS(31),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7886),
    [sym_self] = ACTIONS(7079),
    [sym_super] = ACTIONS(7079),
    [sym_crate] = ACTIONS(7079),
    [sym_metavariable] = ACTIONS(7481),
  },
  [3661] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(4810),
    [anon_sym_EQ_GT] = ACTIONS(4810),
    [anon_sym_LBRACK] = ACTIONS(4810),
    [anon_sym_PLUS] = ACTIONS(6720),
    [anon_sym_STAR] = ACTIONS(6720),
    [anon_sym_AMP] = ACTIONS(6720),
    [anon_sym_DASH] = ACTIONS(6720),
    [anon_sym_DOT] = ACTIONS(6720),
    [anon_sym_DASH_EQ] = ACTIONS(4810),
    [anon_sym_BANG_EQ] = ACTIONS(4810),
    [anon_sym_STAR_EQ] = ACTIONS(4810),
    [anon_sym_SLASH] = ACTIONS(6720),
    [anon_sym_SLASH_EQ] = ACTIONS(4810),
    [anon_sym_AMP_AMP] = ACTIONS(4810),
    [anon_sym_AMP_EQ] = ACTIONS(4810),
    [anon_sym_PERCENT] = ACTIONS(6720),
    [anon_sym_PERCENT_EQ] = ACTIONS(4810),
    [anon_sym_CARET] = ACTIONS(6720),
    [anon_sym_CARET_EQ] = ACTIONS(4810),
    [anon_sym_PLUS_EQ] = ACTIONS(4810),
    [anon_sym_LT] = ACTIONS(6720),
    [anon_sym_LT_LT] = ACTIONS(6720),
    [anon_sym_LT_LT_EQ] = ACTIONS(4810),
    [anon_sym_LT_EQ] = ACTIONS(4810),
    [anon_sym_EQ] = ACTIONS(6720),
    [anon_sym_EQ_EQ] = ACTIONS(4810),
    [anon_sym_GT] = ACTIONS(6720),
    [anon_sym_GT_EQ] = ACTIONS(4810),
    [anon_sym_GT_GT] = ACTIONS(6720),
    [anon_sym_GT_GT_EQ] = ACTIONS(4810),
    [anon_sym_PIPE] = ACTIONS(6720),
    [anon_sym_PIPE_EQ] = ACTIONS(4810),
    [anon_sym_PIPE_PIPE] = ACTIONS(4810),
    [anon_sym_QMARK] = ACTIONS(4810),
    [anon_sym_DOT_DOT] = ACTIONS(6720),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4810),
    [anon_sym_as] = ACTIONS(4810),
    [sym_line_comment] = ACTIONS(7),
  },
  [3662] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(4810),
    [anon_sym_EQ_GT] = ACTIONS(4810),
    [anon_sym_LBRACK] = ACTIONS(4810),
    [anon_sym_PLUS] = ACTIONS(6720),
    [anon_sym_STAR] = ACTIONS(6720),
    [anon_sym_AMP] = ACTIONS(6720),
    [anon_sym_DASH] = ACTIONS(6720),
    [anon_sym_DOT] = ACTIONS(6720),
    [anon_sym_DASH_EQ] = ACTIONS(4810),
    [anon_sym_BANG_EQ] = ACTIONS(4810),
    [anon_sym_STAR_EQ] = ACTIONS(4810),
    [anon_sym_SLASH] = ACTIONS(6720),
    [anon_sym_SLASH_EQ] = ACTIONS(4810),
    [anon_sym_AMP_AMP] = ACTIONS(4810),
    [anon_sym_AMP_EQ] = ACTIONS(4810),
    [anon_sym_PERCENT] = ACTIONS(6720),
    [anon_sym_PERCENT_EQ] = ACTIONS(4810),
    [anon_sym_CARET] = ACTIONS(6720),
    [anon_sym_CARET_EQ] = ACTIONS(4810),
    [anon_sym_PLUS_EQ] = ACTIONS(4810),
    [anon_sym_LT] = ACTIONS(6720),
    [anon_sym_LT_LT] = ACTIONS(6720),
    [anon_sym_LT_LT_EQ] = ACTIONS(4810),
    [anon_sym_LT_EQ] = ACTIONS(4810),
    [anon_sym_EQ] = ACTIONS(6720),
    [anon_sym_EQ_EQ] = ACTIONS(4810),
    [anon_sym_GT] = ACTIONS(6720),
    [anon_sym_GT_EQ] = ACTIONS(4810),
    [anon_sym_GT_GT] = ACTIONS(6720),
    [anon_sym_GT_GT_EQ] = ACTIONS(4810),
    [anon_sym_PIPE] = ACTIONS(6720),
    [anon_sym_PIPE_EQ] = ACTIONS(4810),
    [anon_sym_PIPE_PIPE] = ACTIONS(4810),
    [anon_sym_QMARK] = ACTIONS(4810),
    [anon_sym_DOT_DOT] = ACTIONS(6720),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4810),
    [anon_sym_as] = ACTIONS(4810),
    [sym_line_comment] = ACTIONS(7),
  },
  [3663] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(4836),
    [anon_sym_EQ_GT] = ACTIONS(4836),
    [anon_sym_LBRACK] = ACTIONS(4836),
    [anon_sym_PLUS] = ACTIONS(6722),
    [anon_sym_STAR] = ACTIONS(6722),
    [anon_sym_AMP] = ACTIONS(6722),
    [anon_sym_DASH] = ACTIONS(6722),
    [anon_sym_DOT] = ACTIONS(6722),
    [anon_sym_DASH_EQ] = ACTIONS(4836),
    [anon_sym_BANG_EQ] = ACTIONS(4836),
    [anon_sym_STAR_EQ] = ACTIONS(4836),
    [anon_sym_SLASH] = ACTIONS(6722),
    [anon_sym_SLASH_EQ] = ACTIONS(4836),
    [anon_sym_AMP_AMP] = ACTIONS(4836),
    [anon_sym_AMP_EQ] = ACTIONS(4836),
    [anon_sym_PERCENT] = ACTIONS(6722),
    [anon_sym_PERCENT_EQ] = ACTIONS(4836),
    [anon_sym_CARET] = ACTIONS(6722),
    [anon_sym_CARET_EQ] = ACTIONS(4836),
    [anon_sym_PLUS_EQ] = ACTIONS(4836),
    [anon_sym_LT] = ACTIONS(6722),
    [anon_sym_LT_LT] = ACTIONS(6722),
    [anon_sym_LT_LT_EQ] = ACTIONS(4836),
    [anon_sym_LT_EQ] = ACTIONS(4836),
    [anon_sym_EQ] = ACTIONS(6722),
    [anon_sym_EQ_EQ] = ACTIONS(4836),
    [anon_sym_GT] = ACTIONS(6722),
    [anon_sym_GT_EQ] = ACTIONS(4836),
    [anon_sym_GT_GT] = ACTIONS(6722),
    [anon_sym_GT_GT_EQ] = ACTIONS(4836),
    [anon_sym_PIPE] = ACTIONS(6722),
    [anon_sym_PIPE_EQ] = ACTIONS(4836),
    [anon_sym_PIPE_PIPE] = ACTIONS(4836),
    [anon_sym_QMARK] = ACTIONS(4836),
    [anon_sym_DOT_DOT] = ACTIONS(6722),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4836),
    [anon_sym_as] = ACTIONS(4836),
    [sym_line_comment] = ACTIONS(7),
  },
  [3664] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(4836),
    [anon_sym_EQ_GT] = ACTIONS(4836),
    [anon_sym_LBRACK] = ACTIONS(4836),
    [anon_sym_PLUS] = ACTIONS(6722),
    [anon_sym_STAR] = ACTIONS(6722),
    [anon_sym_AMP] = ACTIONS(6722),
    [anon_sym_DASH] = ACTIONS(6722),
    [anon_sym_DOT] = ACTIONS(6722),
    [anon_sym_DASH_EQ] = ACTIONS(4836),
    [anon_sym_BANG_EQ] = ACTIONS(4836),
    [anon_sym_STAR_EQ] = ACTIONS(4836),
    [anon_sym_SLASH] = ACTIONS(6722),
    [anon_sym_SLASH_EQ] = ACTIONS(4836),
    [anon_sym_AMP_AMP] = ACTIONS(4836),
    [anon_sym_AMP_EQ] = ACTIONS(4836),
    [anon_sym_PERCENT] = ACTIONS(6722),
    [anon_sym_PERCENT_EQ] = ACTIONS(4836),
    [anon_sym_CARET] = ACTIONS(6722),
    [anon_sym_CARET_EQ] = ACTIONS(4836),
    [anon_sym_PLUS_EQ] = ACTIONS(4836),
    [anon_sym_LT] = ACTIONS(6722),
    [anon_sym_LT_LT] = ACTIONS(6722),
    [anon_sym_LT_LT_EQ] = ACTIONS(4836),
    [anon_sym_LT_EQ] = ACTIONS(4836),
    [anon_sym_EQ] = ACTIONS(6722),
    [anon_sym_EQ_EQ] = ACTIONS(4836),
    [anon_sym_GT] = ACTIONS(6722),
    [anon_sym_GT_EQ] = ACTIONS(4836),
    [anon_sym_GT_GT] = ACTIONS(6722),
    [anon_sym_GT_GT_EQ] = ACTIONS(4836),
    [anon_sym_PIPE] = ACTIONS(6722),
    [anon_sym_PIPE_EQ] = ACTIONS(4836),
    [anon_sym_PIPE_PIPE] = ACTIONS(4836),
    [anon_sym_QMARK] = ACTIONS(4836),
    [anon_sym_DOT_DOT] = ACTIONS(6722),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4836),
    [anon_sym_as] = ACTIONS(4836),
    [sym_line_comment] = ACTIONS(7),
  },
  [3665] = {
    [sym_function_modifiers] = STATE(3246),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3689),
    [sym_bracketed_type] = STATE(3244),
    [sym_lifetime] = STATE(3248),
    [sym_array_type] = STATE(3689),
    [sym_function_type] = STATE(3689),
    [sym_tuple_type] = STATE(3689),
    [sym_unit_type] = STATE(3689),
    [sym_generic_type] = STATE(3249),
    [sym_generic_type_with_turbofish] = STATE(3250),
    [sym_bounded_type] = STATE(3689),
    [sym_reference_type] = STATE(3689),
    [sym_pointer_type] = STATE(3689),
    [sym_empty_type] = STATE(3689),
    [sym_abstract_type] = STATE(3690),
    [sym_dynamic_type] = STATE(3689),
    [sym_macro_invocation] = STATE(3689),
    [sym_scoped_identifier] = STATE(3251),
    [sym_scoped_type_identifier] = STATE(3252),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7059),
    [anon_sym_LBRACK] = ACTIONS(7061),
    [anon_sym_STAR] = ACTIONS(7063),
    [anon_sym_u8] = ACTIONS(7065),
    [anon_sym_i8] = ACTIONS(7065),
    [anon_sym_u16] = ACTIONS(7065),
    [anon_sym_i16] = ACTIONS(7065),
    [anon_sym_u32] = ACTIONS(7065),
    [anon_sym_i32] = ACTIONS(7065),
    [anon_sym_u64] = ACTIONS(7065),
    [anon_sym_i64] = ACTIONS(7065),
    [anon_sym_u128] = ACTIONS(7065),
    [anon_sym_i128] = ACTIONS(7065),
    [anon_sym_isize] = ACTIONS(7065),
    [anon_sym_usize] = ACTIONS(7065),
    [anon_sym_f32] = ACTIONS(7065),
    [anon_sym_f64] = ACTIONS(7065),
    [anon_sym_bool] = ACTIONS(7065),
    [anon_sym_str] = ACTIONS(7065),
    [anon_sym_char] = ACTIONS(7065),
    [anon_sym_AMP] = ACTIONS(7067),
    [anon_sym_COLON_COLON] = ACTIONS(7069),
    [anon_sym_BANG] = ACTIONS(7071),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(7073),
    [anon_sym_impl] = ACTIONS(7844),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(7075),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7077),
    [sym_self] = ACTIONS(7079),
    [sym_super] = ACTIONS(7079),
    [sym_crate] = ACTIONS(7079),
    [sym_metavariable] = ACTIONS(7081),
  },
  [3666] = {
    [sym_function_modifiers] = STATE(3246),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(3691),
    [sym_bracketed_type] = STATE(3244),
    [sym_lifetime] = STATE(3248),
    [sym_array_type] = STATE(3691),
    [sym_function_type] = STATE(3691),
    [sym_tuple_type] = STATE(3691),
    [sym_unit_type] = STATE(3691),
    [sym_generic_type] = STATE(3249),
    [sym_generic_type_with_turbofish] = STATE(3250),
    [sym_bounded_type] = STATE(3691),
    [sym_reference_type] = STATE(3691),
    [sym_pointer_type] = STATE(3691),
    [sym_empty_type] = STATE(3691),
    [sym_abstract_type] = STATE(3692),
    [sym_dynamic_type] = STATE(3691),
    [sym_macro_invocation] = STATE(3691),
    [sym_scoped_identifier] = STATE(3251),
    [sym_scoped_type_identifier] = STATE(3252),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7059),
    [anon_sym_LBRACK] = ACTIONS(7061),
    [anon_sym_STAR] = ACTIONS(7063),
    [anon_sym_u8] = ACTIONS(7065),
    [anon_sym_i8] = ACTIONS(7065),
    [anon_sym_u16] = ACTIONS(7065),
    [anon_sym_i16] = ACTIONS(7065),
    [anon_sym_u32] = ACTIONS(7065),
    [anon_sym_i32] = ACTIONS(7065),
    [anon_sym_u64] = ACTIONS(7065),
    [anon_sym_i64] = ACTIONS(7065),
    [anon_sym_u128] = ACTIONS(7065),
    [anon_sym_i128] = ACTIONS(7065),
    [anon_sym_isize] = ACTIONS(7065),
    [anon_sym_usize] = ACTIONS(7065),
    [anon_sym_f32] = ACTIONS(7065),
    [anon_sym_f64] = ACTIONS(7065),
    [anon_sym_bool] = ACTIONS(7065),
    [anon_sym_str] = ACTIONS(7065),
    [anon_sym_char] = ACTIONS(7065),
    [anon_sym_AMP] = ACTIONS(7067),
    [anon_sym_COLON_COLON] = ACTIONS(7069),
    [anon_sym_BANG] = ACTIONS(7071),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_fn] = ACTIONS(7073),
    [anon_sym_impl] = ACTIONS(7844),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(7075),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7077),
    [sym_self] = ACTIONS(7079),
    [sym_super] = ACTIONS(7079),
    [sym_crate] = ACTIONS(7079),
    [sym_metavariable] = ACTIONS(7081),
  },
  [3667] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(1732),
    [anon_sym_EQ_GT] = ACTIONS(1732),
    [anon_sym_LBRACK] = ACTIONS(1732),
    [anon_sym_PLUS] = ACTIONS(1734),
    [anon_sym_STAR] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(1734),
    [anon_sym_DASH] = ACTIONS(1734),
    [anon_sym_DOT] = ACTIONS(1734),
    [anon_sym_DASH_EQ] = ACTIONS(1732),
    [anon_sym_BANG_EQ] = ACTIONS(1732),
    [anon_sym_STAR_EQ] = ACTIONS(1732),
    [anon_sym_SLASH] = ACTIONS(1734),
    [anon_sym_SLASH_EQ] = ACTIONS(1732),
    [anon_sym_AMP_AMP] = ACTIONS(1732),
    [anon_sym_AMP_EQ] = ACTIONS(1732),
    [anon_sym_PERCENT] = ACTIONS(1734),
    [anon_sym_PERCENT_EQ] = ACTIONS(1732),
    [anon_sym_CARET] = ACTIONS(1734),
    [anon_sym_CARET_EQ] = ACTIONS(1732),
    [anon_sym_PLUS_EQ] = ACTIONS(1732),
    [anon_sym_LT] = ACTIONS(1734),
    [anon_sym_LT_LT] = ACTIONS(1734),
    [anon_sym_LT_LT_EQ] = ACTIONS(1732),
    [anon_sym_LT_EQ] = ACTIONS(1732),
    [anon_sym_EQ] = ACTIONS(1734),
    [anon_sym_EQ_EQ] = ACTIONS(1732),
    [anon_sym_GT] = ACTIONS(1734),
    [anon_sym_GT_EQ] = ACTIONS(1732),
    [anon_sym_GT_GT] = ACTIONS(1734),
    [anon_sym_GT_GT_EQ] = ACTIONS(1732),
    [anon_sym_PIPE] = ACTIONS(1734),
    [anon_sym_PIPE_EQ] = ACTIONS(1732),
    [anon_sym_PIPE_PIPE] = ACTIONS(1732),
    [anon_sym_QMARK] = ACTIONS(1732),
    [anon_sym_DOT_DOT] = ACTIONS(1734),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1732),
    [anon_sym_as] = ACTIONS(1732),
    [sym_line_comment] = ACTIONS(7),
  },
  [3668] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(3693),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [3669] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3694),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(3694),
    [sym_macro_invocation] = STATE(3694),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3694),
    [sym_unary_expression] = STATE(3694),
    [sym_try_expression] = STATE(3694),
    [sym_reference_expression] = STATE(3694),
    [sym_binary_expression] = STATE(3694),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3694),
    [sym_call_expression] = STATE(3694),
    [sym_array_expression] = STATE(3694),
    [sym_parenthesized_expression] = STATE(3694),
    [sym_tuple_expression] = STATE(3694),
    [sym_unit_expression] = STATE(3694),
    [sym_struct_expression] = STATE(3694),
    [sym_if_expression] = STATE(3694),
    [sym_if_let_expression] = STATE(3694),
    [sym_match_expression] = STATE(3694),
    [sym_while_expression] = STATE(3694),
    [sym_while_let_expression] = STATE(3694),
    [sym_loop_expression] = STATE(3694),
    [sym_for_expression] = STATE(3694),
    [sym_closure_expression] = STATE(3694),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3694),
    [sym_continue_expression] = STATE(3694),
    [sym_index_expression] = STATE(3694),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3694),
    [sym_block] = STATE(3694),
    [sym__literal] = STATE(3694),
    [sym_string_literal] = STATE(3694),
    [sym_boolean_literal] = STATE(3694),
    [sym_raw_string_literal] = ACTIONS(7888),
    [sym_float_literal] = ACTIONS(7888),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(7888),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7888),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [3670] = {
    [sym_bracketed_type] = STATE(50),
    [sym_generic_function] = STATE(3695),
    [sym_generic_type_with_turbofish] = STATE(179),
    [sym__expression] = STATE(3695),
    [sym_macro_invocation] = STATE(3695),
    [sym_scoped_identifier] = STATE(181),
    [sym_scoped_type_identifier_in_expression_position] = STATE(55),
    [sym_range_expression] = STATE(3695),
    [sym_unary_expression] = STATE(3695),
    [sym_try_expression] = STATE(3695),
    [sym_reference_expression] = STATE(3695),
    [sym_binary_expression] = STATE(3695),
    [sym_assignment_expression] = STATE(56),
    [sym_compound_assignment_expr] = STATE(56),
    [sym_type_cast_expression] = STATE(56),
    [sym_return_expression] = STATE(3695),
    [sym_call_expression] = STATE(3695),
    [sym_array_expression] = STATE(3695),
    [sym_parenthesized_expression] = STATE(3695),
    [sym_tuple_expression] = STATE(3695),
    [sym_unit_expression] = STATE(3695),
    [sym_struct_expression] = STATE(3695),
    [sym_if_expression] = STATE(3695),
    [sym_if_let_expression] = STATE(3695),
    [sym_match_expression] = STATE(3695),
    [sym_while_expression] = STATE(3695),
    [sym_while_let_expression] = STATE(3695),
    [sym_loop_expression] = STATE(3695),
    [sym_for_expression] = STATE(3695),
    [sym_closure_expression] = STATE(3695),
    [sym_closure_parameters] = STATE(182),
    [sym_loop_label] = STATE(81),
    [sym_break_expression] = STATE(3695),
    [sym_continue_expression] = STATE(3695),
    [sym_index_expression] = STATE(3695),
    [sym_field_expression] = STATE(60),
    [sym_unsafe_block] = STATE(3695),
    [sym_block] = STATE(3695),
    [sym__literal] = STATE(3695),
    [sym_string_literal] = STATE(3695),
    [sym_boolean_literal] = STATE(3695),
    [sym_raw_string_literal] = ACTIONS(7890),
    [sym_float_literal] = ACTIONS(7890),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(303),
    [anon_sym_u8] = ACTIONS(305),
    [anon_sym_i8] = ACTIONS(305),
    [anon_sym_u16] = ACTIONS(305),
    [anon_sym_i16] = ACTIONS(305),
    [anon_sym_u32] = ACTIONS(305),
    [anon_sym_i32] = ACTIONS(305),
    [anon_sym_u64] = ACTIONS(305),
    [anon_sym_i64] = ACTIONS(305),
    [anon_sym_u128] = ACTIONS(305),
    [anon_sym_i128] = ACTIONS(305),
    [anon_sym_isize] = ACTIONS(305),
    [anon_sym_usize] = ACTIONS(305),
    [anon_sym_f32] = ACTIONS(305),
    [anon_sym_f64] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_str] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(307),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_SQUOTE] = ACTIONS(35),
    [anon_sym_DOT_DOT] = ACTIONS(311),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(43),
    [anon_sym_default] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(313),
    [anon_sym_loop] = ACTIONS(125),
    [anon_sym_match] = ACTIONS(127),
    [anon_sym_return] = ACTIONS(317),
    [anon_sym_union] = ACTIONS(119),
    [anon_sym_unsafe] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(133),
    [anon_sym_move] = ACTIONS(319),
    [sym_integer_literal] = ACTIONS(7890),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(89),
    [sym_char_literal] = ACTIONS(7890),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(321),
    [sym_self] = ACTIONS(323),
    [sym_super] = ACTIONS(325),
    [sym_crate] = ACTIONS(325),
    [sym_metavariable] = ACTIONS(327),
  },
  [3671] = {
    [sym_if_expression] = STATE(3554),
    [sym_if_let_expression] = STATE(3554),
    [sym_block] = STATE(3554),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(5136),
    [anon_sym_if] = ACTIONS(7892),
    [sym_line_comment] = ACTIONS(7),
  },
  [3672] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7772),
    [anon_sym_macro_rules_BANG] = ACTIONS(7772),
    [anon_sym_RBRACE] = ACTIONS(7772),
    [anon_sym_POUND] = ACTIONS(7772),
    [anon_sym_const] = ACTIONS(7774),
    [anon_sym_default] = ACTIONS(7774),
    [anon_sym_enum] = ACTIONS(7774),
    [anon_sym_fn] = ACTIONS(7774),
    [anon_sym_impl] = ACTIONS(7774),
    [anon_sym_let] = ACTIONS(7774),
    [anon_sym_mod] = ACTIONS(7774),
    [anon_sym_pub] = ACTIONS(7774),
    [anon_sym_static] = ACTIONS(7774),
    [anon_sym_struct] = ACTIONS(7774),
    [anon_sym_trait] = ACTIONS(7774),
    [anon_sym_type] = ACTIONS(7774),
    [anon_sym_union] = ACTIONS(7774),
    [anon_sym_unsafe] = ACTIONS(7774),
    [anon_sym_use] = ACTIONS(7774),
    [anon_sym_extern] = ACTIONS(7774),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7774),
  },
  [3673] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7776),
    [anon_sym_macro_rules_BANG] = ACTIONS(7776),
    [anon_sym_RBRACE] = ACTIONS(7776),
    [anon_sym_POUND] = ACTIONS(7776),
    [anon_sym_const] = ACTIONS(7778),
    [anon_sym_default] = ACTIONS(7778),
    [anon_sym_enum] = ACTIONS(7778),
    [anon_sym_fn] = ACTIONS(7778),
    [anon_sym_impl] = ACTIONS(7778),
    [anon_sym_let] = ACTIONS(7778),
    [anon_sym_mod] = ACTIONS(7778),
    [anon_sym_pub] = ACTIONS(7778),
    [anon_sym_static] = ACTIONS(7778),
    [anon_sym_struct] = ACTIONS(7778),
    [anon_sym_trait] = ACTIONS(7778),
    [anon_sym_type] = ACTIONS(7778),
    [anon_sym_union] = ACTIONS(7778),
    [anon_sym_unsafe] = ACTIONS(7778),
    [anon_sym_use] = ACTIONS(7778),
    [anon_sym_extern] = ACTIONS(7778),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7778),
  },
  [3674] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7794),
    [anon_sym_macro_rules_BANG] = ACTIONS(7794),
    [anon_sym_RBRACE] = ACTIONS(7794),
    [anon_sym_POUND] = ACTIONS(7794),
    [anon_sym_const] = ACTIONS(7796),
    [anon_sym_default] = ACTIONS(7796),
    [anon_sym_enum] = ACTIONS(7796),
    [anon_sym_fn] = ACTIONS(7796),
    [anon_sym_impl] = ACTIONS(7796),
    [anon_sym_let] = ACTIONS(7796),
    [anon_sym_mod] = ACTIONS(7796),
    [anon_sym_pub] = ACTIONS(7796),
    [anon_sym_static] = ACTIONS(7796),
    [anon_sym_struct] = ACTIONS(7796),
    [anon_sym_trait] = ACTIONS(7796),
    [anon_sym_type] = ACTIONS(7796),
    [anon_sym_union] = ACTIONS(7796),
    [anon_sym_unsafe] = ACTIONS(7796),
    [anon_sym_use] = ACTIONS(7796),
    [anon_sym_extern] = ACTIONS(7796),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7796),
  },
  [3675] = {
    [sym_block] = STATE(3697),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7894),
    [anon_sym_LBRACE] = ACTIONS(111),
    [sym_line_comment] = ACTIONS(7),
  },
  [3676] = {
    [sym_raw_string_literal] = ACTIONS(6898),
    [sym_float_literal] = ACTIONS(6898),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6898),
    [anon_sym_RBRACE] = ACTIONS(6898),
    [anon_sym_LBRACK] = ACTIONS(6898),
    [anon_sym_PLUS] = ACTIONS(6900),
    [anon_sym_STAR] = ACTIONS(6900),
    [anon_sym_COMMA] = ACTIONS(6898),
    [anon_sym_u8] = ACTIONS(6900),
    [anon_sym_i8] = ACTIONS(6900),
    [anon_sym_u16] = ACTIONS(6900),
    [anon_sym_i16] = ACTIONS(6900),
    [anon_sym_u32] = ACTIONS(6900),
    [anon_sym_i32] = ACTIONS(6900),
    [anon_sym_u64] = ACTIONS(6900),
    [anon_sym_i64] = ACTIONS(6900),
    [anon_sym_u128] = ACTIONS(6900),
    [anon_sym_i128] = ACTIONS(6900),
    [anon_sym_isize] = ACTIONS(6900),
    [anon_sym_usize] = ACTIONS(6900),
    [anon_sym_f32] = ACTIONS(6900),
    [anon_sym_f64] = ACTIONS(6900),
    [anon_sym_bool] = ACTIONS(6900),
    [anon_sym_str] = ACTIONS(6900),
    [anon_sym_char] = ACTIONS(6900),
    [anon_sym__] = ACTIONS(6900),
    [anon_sym_AMP] = ACTIONS(6900),
    [anon_sym_DASH] = ACTIONS(6900),
    [anon_sym_DOT] = ACTIONS(6900),
    [anon_sym_DASH_EQ] = ACTIONS(6898),
    [anon_sym_COLON_COLON] = ACTIONS(6898),
    [anon_sym_BANG_EQ] = ACTIONS(6898),
    [anon_sym_STAR_EQ] = ACTIONS(6898),
    [anon_sym_SLASH] = ACTIONS(6900),
    [anon_sym_SLASH_EQ] = ACTIONS(6898),
    [anon_sym_AMP_AMP] = ACTIONS(6898),
    [anon_sym_AMP_EQ] = ACTIONS(6898),
    [anon_sym_POUND] = ACTIONS(6898),
    [anon_sym_PERCENT] = ACTIONS(6900),
    [anon_sym_PERCENT_EQ] = ACTIONS(6898),
    [anon_sym_CARET] = ACTIONS(6900),
    [anon_sym_CARET_EQ] = ACTIONS(6898),
    [anon_sym_PLUS_EQ] = ACTIONS(6898),
    [anon_sym_LT] = ACTIONS(6900),
    [anon_sym_LT_LT] = ACTIONS(6900),
    [anon_sym_LT_LT_EQ] = ACTIONS(6898),
    [anon_sym_LT_EQ] = ACTIONS(6898),
    [anon_sym_EQ] = ACTIONS(6900),
    [anon_sym_EQ_EQ] = ACTIONS(6898),
    [anon_sym_GT] = ACTIONS(6900),
    [anon_sym_GT_EQ] = ACTIONS(6898),
    [anon_sym_GT_GT] = ACTIONS(6900),
    [anon_sym_GT_GT_EQ] = ACTIONS(6898),
    [anon_sym_PIPE] = ACTIONS(6900),
    [anon_sym_PIPE_EQ] = ACTIONS(6898),
    [anon_sym_PIPE_PIPE] = ACTIONS(6898),
    [anon_sym_QMARK] = ACTIONS(6898),
    [anon_sym_DOT_DOT] = ACTIONS(6900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6898),
    [anon_sym_as] = ACTIONS(6900),
    [sym_mutable_specifier] = ACTIONS(6900),
    [anon_sym_ref] = ACTIONS(6900),
    [sym_integer_literal] = ACTIONS(6898),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6898),
    [sym_char_literal] = ACTIONS(6898),
    [anon_sym_true] = ACTIONS(6900),
    [anon_sym_false] = ACTIONS(6900),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6900),
    [sym_self] = ACTIONS(6900),
    [sym_super] = ACTIONS(6900),
    [sym_crate] = ACTIONS(6900),
    [sym_metavariable] = ACTIONS(6898),
  },
  [3677] = {
    [sym_raw_string_literal] = ACTIONS(7316),
    [sym_float_literal] = ACTIONS(7316),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7316),
    [anon_sym_RBRACE] = ACTIONS(7316),
    [anon_sym_LBRACK] = ACTIONS(7316),
    [anon_sym_PLUS] = ACTIONS(7318),
    [anon_sym_STAR] = ACTIONS(7318),
    [anon_sym_COMMA] = ACTIONS(7316),
    [anon_sym_u8] = ACTIONS(7318),
    [anon_sym_i8] = ACTIONS(7318),
    [anon_sym_u16] = ACTIONS(7318),
    [anon_sym_i16] = ACTIONS(7318),
    [anon_sym_u32] = ACTIONS(7318),
    [anon_sym_i32] = ACTIONS(7318),
    [anon_sym_u64] = ACTIONS(7318),
    [anon_sym_i64] = ACTIONS(7318),
    [anon_sym_u128] = ACTIONS(7318),
    [anon_sym_i128] = ACTIONS(7318),
    [anon_sym_isize] = ACTIONS(7318),
    [anon_sym_usize] = ACTIONS(7318),
    [anon_sym_f32] = ACTIONS(7318),
    [anon_sym_f64] = ACTIONS(7318),
    [anon_sym_bool] = ACTIONS(7318),
    [anon_sym_str] = ACTIONS(7318),
    [anon_sym_char] = ACTIONS(7318),
    [anon_sym__] = ACTIONS(7318),
    [anon_sym_AMP] = ACTIONS(7318),
    [anon_sym_DASH] = ACTIONS(7318),
    [anon_sym_DOT] = ACTIONS(7318),
    [anon_sym_DASH_EQ] = ACTIONS(7316),
    [anon_sym_COLON_COLON] = ACTIONS(7316),
    [anon_sym_BANG_EQ] = ACTIONS(7316),
    [anon_sym_STAR_EQ] = ACTIONS(7316),
    [anon_sym_SLASH] = ACTIONS(7318),
    [anon_sym_SLASH_EQ] = ACTIONS(7316),
    [anon_sym_AMP_AMP] = ACTIONS(7316),
    [anon_sym_AMP_EQ] = ACTIONS(7316),
    [anon_sym_POUND] = ACTIONS(7316),
    [anon_sym_PERCENT] = ACTIONS(7318),
    [anon_sym_PERCENT_EQ] = ACTIONS(7316),
    [anon_sym_CARET] = ACTIONS(7318),
    [anon_sym_CARET_EQ] = ACTIONS(7316),
    [anon_sym_PLUS_EQ] = ACTIONS(7316),
    [anon_sym_LT] = ACTIONS(7318),
    [anon_sym_LT_LT] = ACTIONS(7318),
    [anon_sym_LT_LT_EQ] = ACTIONS(7316),
    [anon_sym_LT_EQ] = ACTIONS(7316),
    [anon_sym_EQ] = ACTIONS(7318),
    [anon_sym_EQ_EQ] = ACTIONS(7316),
    [anon_sym_GT] = ACTIONS(7318),
    [anon_sym_GT_EQ] = ACTIONS(7316),
    [anon_sym_GT_GT] = ACTIONS(7318),
    [anon_sym_GT_GT_EQ] = ACTIONS(7316),
    [anon_sym_PIPE] = ACTIONS(7318),
    [anon_sym_PIPE_EQ] = ACTIONS(7316),
    [anon_sym_PIPE_PIPE] = ACTIONS(7316),
    [anon_sym_QMARK] = ACTIONS(7316),
    [anon_sym_DOT_DOT] = ACTIONS(7318),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7316),
    [anon_sym_as] = ACTIONS(7318),
    [sym_mutable_specifier] = ACTIONS(7318),
    [anon_sym_ref] = ACTIONS(7318),
    [sym_integer_literal] = ACTIONS(7316),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7316),
    [sym_char_literal] = ACTIONS(7316),
    [anon_sym_true] = ACTIONS(7318),
    [anon_sym_false] = ACTIONS(7318),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7318),
    [sym_self] = ACTIONS(7318),
    [sym_super] = ACTIONS(7318),
    [sym_crate] = ACTIONS(7318),
    [sym_metavariable] = ACTIONS(7316),
  },
  [3678] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(3698),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(5136),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [3679] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6898),
    [anon_sym_EQ_GT] = ACTIONS(6898),
    [anon_sym_LBRACK] = ACTIONS(6898),
    [anon_sym_PLUS] = ACTIONS(6900),
    [anon_sym_STAR] = ACTIONS(6900),
    [anon_sym_AMP] = ACTIONS(6900),
    [anon_sym_DASH] = ACTIONS(6900),
    [anon_sym_DOT] = ACTIONS(6900),
    [anon_sym_DASH_EQ] = ACTIONS(6898),
    [anon_sym_BANG_EQ] = ACTIONS(6898),
    [anon_sym_STAR_EQ] = ACTIONS(6898),
    [anon_sym_SLASH] = ACTIONS(6900),
    [anon_sym_SLASH_EQ] = ACTIONS(6898),
    [anon_sym_AMP_AMP] = ACTIONS(6898),
    [anon_sym_AMP_EQ] = ACTIONS(6898),
    [anon_sym_PERCENT] = ACTIONS(6900),
    [anon_sym_PERCENT_EQ] = ACTIONS(6898),
    [anon_sym_CARET] = ACTIONS(6900),
    [anon_sym_CARET_EQ] = ACTIONS(6898),
    [anon_sym_PLUS_EQ] = ACTIONS(6898),
    [anon_sym_LT] = ACTIONS(6900),
    [anon_sym_LT_LT] = ACTIONS(6900),
    [anon_sym_LT_LT_EQ] = ACTIONS(6898),
    [anon_sym_LT_EQ] = ACTIONS(6898),
    [anon_sym_EQ] = ACTIONS(6900),
    [anon_sym_EQ_EQ] = ACTIONS(6898),
    [anon_sym_GT] = ACTIONS(6900),
    [anon_sym_GT_EQ] = ACTIONS(6898),
    [anon_sym_GT_GT] = ACTIONS(6900),
    [anon_sym_GT_GT_EQ] = ACTIONS(6898),
    [anon_sym_PIPE] = ACTIONS(6900),
    [anon_sym_PIPE_EQ] = ACTIONS(6898),
    [anon_sym_PIPE_PIPE] = ACTIONS(6898),
    [anon_sym_QMARK] = ACTIONS(6898),
    [anon_sym_DOT_DOT] = ACTIONS(6900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6898),
    [anon_sym_as] = ACTIONS(6898),
    [sym_line_comment] = ACTIONS(7),
  },
  [3680] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6815),
    [anon_sym_LBRACE] = ACTIONS(6815),
    [anon_sym_EQ_GT] = ACTIONS(6815),
    [anon_sym_LBRACK] = ACTIONS(6815),
    [anon_sym_PLUS] = ACTIONS(6817),
    [anon_sym_STAR] = ACTIONS(6817),
    [anon_sym_AMP] = ACTIONS(6817),
    [anon_sym_DASH] = ACTIONS(6817),
    [anon_sym_DOT] = ACTIONS(6817),
    [anon_sym_DASH_EQ] = ACTIONS(6815),
    [anon_sym_COLON_COLON] = ACTIONS(6815),
    [anon_sym_BANG_EQ] = ACTIONS(6815),
    [anon_sym_STAR_EQ] = ACTIONS(6815),
    [anon_sym_SLASH] = ACTIONS(6817),
    [anon_sym_SLASH_EQ] = ACTIONS(6815),
    [anon_sym_AMP_AMP] = ACTIONS(6815),
    [anon_sym_AMP_EQ] = ACTIONS(6815),
    [anon_sym_PERCENT] = ACTIONS(6817),
    [anon_sym_PERCENT_EQ] = ACTIONS(6815),
    [anon_sym_CARET] = ACTIONS(6817),
    [anon_sym_CARET_EQ] = ACTIONS(6815),
    [anon_sym_PLUS_EQ] = ACTIONS(6815),
    [anon_sym_LT] = ACTIONS(6817),
    [anon_sym_LT_LT] = ACTIONS(6817),
    [anon_sym_LT_LT_EQ] = ACTIONS(6815),
    [anon_sym_LT_EQ] = ACTIONS(6815),
    [anon_sym_EQ] = ACTIONS(6817),
    [anon_sym_EQ_EQ] = ACTIONS(6815),
    [anon_sym_GT] = ACTIONS(6817),
    [anon_sym_GT_EQ] = ACTIONS(6815),
    [anon_sym_GT_GT] = ACTIONS(6817),
    [anon_sym_GT_GT_EQ] = ACTIONS(6815),
    [anon_sym_PIPE] = ACTIONS(6817),
    [anon_sym_PIPE_EQ] = ACTIONS(6815),
    [anon_sym_PIPE_PIPE] = ACTIONS(6815),
    [anon_sym_QMARK] = ACTIONS(6815),
    [anon_sym_DOT_DOT] = ACTIONS(6817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6815),
    [anon_sym_as] = ACTIONS(6815),
    [sym_line_comment] = ACTIONS(7),
  },
  [3681] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7226),
    [anon_sym_EQ_GT] = ACTIONS(7226),
    [anon_sym_LBRACK] = ACTIONS(7226),
    [anon_sym_PLUS] = ACTIONS(7228),
    [anon_sym_STAR] = ACTIONS(7228),
    [anon_sym_AMP] = ACTIONS(7228),
    [anon_sym_DASH] = ACTIONS(7228),
    [anon_sym_DOT] = ACTIONS(7228),
    [anon_sym_DASH_EQ] = ACTIONS(7226),
    [anon_sym_BANG_EQ] = ACTIONS(7226),
    [anon_sym_STAR_EQ] = ACTIONS(7226),
    [anon_sym_SLASH] = ACTIONS(7228),
    [anon_sym_SLASH_EQ] = ACTIONS(7226),
    [anon_sym_AMP_AMP] = ACTIONS(7226),
    [anon_sym_AMP_EQ] = ACTIONS(7226),
    [anon_sym_PERCENT] = ACTIONS(7228),
    [anon_sym_PERCENT_EQ] = ACTIONS(7226),
    [anon_sym_CARET] = ACTIONS(7228),
    [anon_sym_CARET_EQ] = ACTIONS(7226),
    [anon_sym_PLUS_EQ] = ACTIONS(7226),
    [anon_sym_LT] = ACTIONS(7228),
    [anon_sym_LT_LT] = ACTIONS(7228),
    [anon_sym_LT_LT_EQ] = ACTIONS(7226),
    [anon_sym_LT_EQ] = ACTIONS(7226),
    [anon_sym_EQ] = ACTIONS(7228),
    [anon_sym_EQ_EQ] = ACTIONS(7226),
    [anon_sym_GT] = ACTIONS(7228),
    [anon_sym_GT_EQ] = ACTIONS(7226),
    [anon_sym_GT_GT] = ACTIONS(7228),
    [anon_sym_GT_GT_EQ] = ACTIONS(7226),
    [anon_sym_PIPE] = ACTIONS(7228),
    [anon_sym_PIPE_EQ] = ACTIONS(7226),
    [anon_sym_PIPE_PIPE] = ACTIONS(7226),
    [anon_sym_QMARK] = ACTIONS(7226),
    [anon_sym_DOT_DOT] = ACTIONS(7228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7226),
    [anon_sym_as] = ACTIONS(7226),
    [sym_line_comment] = ACTIONS(7),
  },
  [3682] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5958),
    [anon_sym_EQ_GT] = ACTIONS(5958),
    [anon_sym_LBRACK] = ACTIONS(5958),
    [anon_sym_PLUS] = ACTIONS(7304),
    [anon_sym_STAR] = ACTIONS(7304),
    [anon_sym_AMP] = ACTIONS(7304),
    [anon_sym_DASH] = ACTIONS(7304),
    [anon_sym_DOT] = ACTIONS(7304),
    [anon_sym_DASH_EQ] = ACTIONS(5958),
    [anon_sym_BANG_EQ] = ACTIONS(5958),
    [anon_sym_STAR_EQ] = ACTIONS(5958),
    [anon_sym_SLASH] = ACTIONS(7304),
    [anon_sym_SLASH_EQ] = ACTIONS(5958),
    [anon_sym_AMP_AMP] = ACTIONS(5958),
    [anon_sym_AMP_EQ] = ACTIONS(5958),
    [anon_sym_PERCENT] = ACTIONS(7304),
    [anon_sym_PERCENT_EQ] = ACTIONS(5958),
    [anon_sym_CARET] = ACTIONS(7304),
    [anon_sym_CARET_EQ] = ACTIONS(5958),
    [anon_sym_PLUS_EQ] = ACTIONS(5958),
    [anon_sym_LT] = ACTIONS(7304),
    [anon_sym_LT_LT] = ACTIONS(7304),
    [anon_sym_LT_LT_EQ] = ACTIONS(5958),
    [anon_sym_LT_EQ] = ACTIONS(5958),
    [anon_sym_EQ] = ACTIONS(7304),
    [anon_sym_EQ_EQ] = ACTIONS(5958),
    [anon_sym_GT] = ACTIONS(7304),
    [anon_sym_GT_EQ] = ACTIONS(5958),
    [anon_sym_GT_GT] = ACTIONS(7304),
    [anon_sym_GT_GT_EQ] = ACTIONS(5958),
    [anon_sym_PIPE] = ACTIONS(7304),
    [anon_sym_PIPE_EQ] = ACTIONS(5958),
    [anon_sym_PIPE_PIPE] = ACTIONS(5958),
    [anon_sym_QMARK] = ACTIONS(5958),
    [anon_sym_DOT_DOT] = ACTIONS(7304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5958),
    [anon_sym_as] = ACTIONS(5958),
    [sym_line_comment] = ACTIONS(7),
  },
  [3683] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5960),
    [anon_sym_EQ_GT] = ACTIONS(5960),
    [anon_sym_LBRACK] = ACTIONS(5960),
    [anon_sym_PLUS] = ACTIONS(7306),
    [anon_sym_STAR] = ACTIONS(7306),
    [anon_sym_AMP] = ACTIONS(7306),
    [anon_sym_DASH] = ACTIONS(7306),
    [anon_sym_DOT] = ACTIONS(7306),
    [anon_sym_DASH_EQ] = ACTIONS(5960),
    [anon_sym_BANG_EQ] = ACTIONS(5960),
    [anon_sym_STAR_EQ] = ACTIONS(5960),
    [anon_sym_SLASH] = ACTIONS(7306),
    [anon_sym_SLASH_EQ] = ACTIONS(5960),
    [anon_sym_AMP_AMP] = ACTIONS(5960),
    [anon_sym_AMP_EQ] = ACTIONS(5960),
    [anon_sym_PERCENT] = ACTIONS(7306),
    [anon_sym_PERCENT_EQ] = ACTIONS(5960),
    [anon_sym_CARET] = ACTIONS(7306),
    [anon_sym_CARET_EQ] = ACTIONS(5960),
    [anon_sym_PLUS_EQ] = ACTIONS(5960),
    [anon_sym_LT] = ACTIONS(7306),
    [anon_sym_LT_LT] = ACTIONS(7306),
    [anon_sym_LT_LT_EQ] = ACTIONS(5960),
    [anon_sym_LT_EQ] = ACTIONS(5960),
    [anon_sym_EQ] = ACTIONS(7306),
    [anon_sym_EQ_EQ] = ACTIONS(5960),
    [anon_sym_GT] = ACTIONS(7306),
    [anon_sym_GT_EQ] = ACTIONS(5960),
    [anon_sym_GT_GT] = ACTIONS(7306),
    [anon_sym_GT_GT_EQ] = ACTIONS(5960),
    [anon_sym_PIPE] = ACTIONS(7306),
    [anon_sym_PIPE_EQ] = ACTIONS(5960),
    [anon_sym_PIPE_PIPE] = ACTIONS(5960),
    [anon_sym_QMARK] = ACTIONS(5960),
    [anon_sym_DOT_DOT] = ACTIONS(7306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5960),
    [anon_sym_as] = ACTIONS(5960),
    [sym_line_comment] = ACTIONS(7),
  },
  [3684] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(5962),
    [anon_sym_EQ_GT] = ACTIONS(5962),
    [anon_sym_LBRACK] = ACTIONS(5962),
    [anon_sym_PLUS] = ACTIONS(7308),
    [anon_sym_STAR] = ACTIONS(7308),
    [anon_sym_AMP] = ACTIONS(7308),
    [anon_sym_DASH] = ACTIONS(7308),
    [anon_sym_DOT] = ACTIONS(7308),
    [anon_sym_DASH_EQ] = ACTIONS(5962),
    [anon_sym_DASH_GT] = ACTIONS(5962),
    [anon_sym_BANG_EQ] = ACTIONS(5962),
    [anon_sym_STAR_EQ] = ACTIONS(5962),
    [anon_sym_SLASH] = ACTIONS(7308),
    [anon_sym_SLASH_EQ] = ACTIONS(5962),
    [anon_sym_AMP_AMP] = ACTIONS(5962),
    [anon_sym_AMP_EQ] = ACTIONS(5962),
    [anon_sym_PERCENT] = ACTIONS(7308),
    [anon_sym_PERCENT_EQ] = ACTIONS(5962),
    [anon_sym_CARET] = ACTIONS(7308),
    [anon_sym_CARET_EQ] = ACTIONS(5962),
    [anon_sym_PLUS_EQ] = ACTIONS(5962),
    [anon_sym_LT] = ACTIONS(7308),
    [anon_sym_LT_LT] = ACTIONS(7308),
    [anon_sym_LT_LT_EQ] = ACTIONS(5962),
    [anon_sym_LT_EQ] = ACTIONS(5962),
    [anon_sym_EQ] = ACTIONS(7308),
    [anon_sym_EQ_EQ] = ACTIONS(5962),
    [anon_sym_GT] = ACTIONS(7308),
    [anon_sym_GT_EQ] = ACTIONS(5962),
    [anon_sym_GT_GT] = ACTIONS(7308),
    [anon_sym_GT_GT_EQ] = ACTIONS(5962),
    [anon_sym_PIPE] = ACTIONS(7308),
    [anon_sym_PIPE_EQ] = ACTIONS(5962),
    [anon_sym_PIPE_PIPE] = ACTIONS(5962),
    [anon_sym_QMARK] = ACTIONS(5962),
    [anon_sym_DOT_DOT] = ACTIONS(7308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5962),
    [anon_sym_as] = ACTIONS(5962),
    [sym_line_comment] = ACTIONS(7),
  },
  [3685] = {
    [sym_function_modifiers] = STATE(370),
    [sym_self_parameter] = STATE(2121),
    [sym_variadic_parameter] = STATE(2121),
    [sym_parameter] = STATE(2121),
    [sym_extern_modifier] = STATE(132),
    [sym__type] = STATE(2122),
    [sym_bracketed_type] = STATE(122),
    [sym_lifetime] = STATE(839),
    [sym_array_type] = STATE(2122),
    [sym_function_type] = STATE(2122),
    [sym_tuple_type] = STATE(2122),
    [sym_unit_type] = STATE(2122),
    [sym_generic_type] = STATE(128),
    [sym_generic_type_with_turbofish] = STATE(129),
    [sym_bounded_type] = STATE(2122),
    [sym_reference_type] = STATE(2122),
    [sym_pointer_type] = STATE(2122),
    [sym_empty_type] = STATE(2122),
    [sym_abstract_type] = STATE(2121),
    [sym_dynamic_type] = STATE(2122),
    [sym_macro_invocation] = STATE(2122),
    [sym_scoped_identifier] = STATE(130),
    [sym_scoped_type_identifier] = STATE(373),
    [sym_reference_pattern_in_parameter] = STATE(840),
    [aux_sym_function_modifiers_repeat1] = STATE(132),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_RPAREN] = ACTIONS(7896),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_u8] = ACTIONS(1740),
    [anon_sym_i8] = ACTIONS(1740),
    [anon_sym_u16] = ACTIONS(1740),
    [anon_sym_i16] = ACTIONS(1740),
    [anon_sym_u32] = ACTIONS(1740),
    [anon_sym_i32] = ACTIONS(1740),
    [anon_sym_u64] = ACTIONS(1740),
    [anon_sym_i64] = ACTIONS(1740),
    [anon_sym_u128] = ACTIONS(1740),
    [anon_sym_i128] = ACTIONS(1740),
    [anon_sym_isize] = ACTIONS(1740),
    [anon_sym_usize] = ACTIONS(1740),
    [anon_sym_f32] = ACTIONS(1740),
    [anon_sym_f64] = ACTIONS(1740),
    [anon_sym_bool] = ACTIONS(1740),
    [anon_sym_str] = ACTIONS(1740),
    [anon_sym_char] = ACTIONS(1740),
    [anon_sym__] = ACTIONS(4770),
    [anon_sym_AMP] = ACTIONS(1744),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_LT] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1746),
    [anon_sym_const] = ACTIONS(209),
    [anon_sym_default] = ACTIONS(1748),
    [anon_sym_fn] = ACTIONS(737),
    [anon_sym_impl] = ACTIONS(1750),
    [anon_sym_union] = ACTIONS(1752),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_dyn] = ACTIONS(215),
    [sym_mutable_specifier] = ACTIONS(1754),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(1756),
    [sym_self] = ACTIONS(1758),
    [sym_super] = ACTIONS(219),
    [sym_crate] = ACTIONS(219),
    [sym_metavariable] = ACTIONS(221),
  },
  [3686] = {
    [sym_type_arguments] = STATE(3473),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(4790),
    [anon_sym_EQ_GT] = ACTIONS(4790),
    [anon_sym_LBRACK] = ACTIONS(4790),
    [anon_sym_PLUS] = ACTIONS(4792),
    [anon_sym_STAR] = ACTIONS(4792),
    [anon_sym_AMP] = ACTIONS(4792),
    [anon_sym_DASH] = ACTIONS(4792),
    [anon_sym_DOT] = ACTIONS(4792),
    [anon_sym_DASH_EQ] = ACTIONS(4790),
    [anon_sym_COLON_COLON] = ACTIONS(7483),
    [anon_sym_BANG_EQ] = ACTIONS(4790),
    [anon_sym_STAR_EQ] = ACTIONS(4790),
    [anon_sym_SLASH] = ACTIONS(4792),
    [anon_sym_SLASH_EQ] = ACTIONS(4790),
    [anon_sym_AMP_AMP] = ACTIONS(4790),
    [anon_sym_AMP_EQ] = ACTIONS(4790),
    [anon_sym_PERCENT] = ACTIONS(4792),
    [anon_sym_PERCENT_EQ] = ACTIONS(4790),
    [anon_sym_CARET] = ACTIONS(4792),
    [anon_sym_CARET_EQ] = ACTIONS(4790),
    [anon_sym_PLUS_EQ] = ACTIONS(4790),
    [anon_sym_LT] = ACTIONS(7485),
    [anon_sym_LT_LT] = ACTIONS(4792),
    [anon_sym_LT_LT_EQ] = ACTIONS(4790),
    [anon_sym_LT_EQ] = ACTIONS(4790),
    [anon_sym_EQ] = ACTIONS(4792),
    [anon_sym_EQ_EQ] = ACTIONS(4790),
    [anon_sym_GT] = ACTIONS(4792),
    [anon_sym_GT_EQ] = ACTIONS(4790),
    [anon_sym_GT_GT] = ACTIONS(4792),
    [anon_sym_GT_GT_EQ] = ACTIONS(4790),
    [anon_sym_PIPE] = ACTIONS(4792),
    [anon_sym_PIPE_EQ] = ACTIONS(4790),
    [anon_sym_PIPE_PIPE] = ACTIONS(4790),
    [anon_sym_QMARK] = ACTIONS(4790),
    [anon_sym_DOT_DOT] = ACTIONS(4792),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4790),
    [anon_sym_as] = ACTIONS(4790),
    [sym_line_comment] = ACTIONS(7),
  },
  [3687] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(4794),
    [anon_sym_EQ_GT] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4794),
    [anon_sym_PLUS] = ACTIONS(4796),
    [anon_sym_STAR] = ACTIONS(4796),
    [anon_sym_AMP] = ACTIONS(4796),
    [anon_sym_DASH] = ACTIONS(4796),
    [anon_sym_DOT] = ACTIONS(4796),
    [anon_sym_DASH_EQ] = ACTIONS(4794),
    [anon_sym_COLON_COLON] = ACTIONS(7495),
    [anon_sym_BANG_EQ] = ACTIONS(4794),
    [anon_sym_STAR_EQ] = ACTIONS(4794),
    [anon_sym_SLASH] = ACTIONS(4796),
    [anon_sym_SLASH_EQ] = ACTIONS(4794),
    [anon_sym_AMP_AMP] = ACTIONS(4794),
    [anon_sym_AMP_EQ] = ACTIONS(4794),
    [anon_sym_PERCENT] = ACTIONS(4796),
    [anon_sym_PERCENT_EQ] = ACTIONS(4794),
    [anon_sym_CARET] = ACTIONS(4796),
    [anon_sym_CARET_EQ] = ACTIONS(4794),
    [anon_sym_PLUS_EQ] = ACTIONS(4794),
    [anon_sym_LT] = ACTIONS(4796),
    [anon_sym_LT_LT] = ACTIONS(4796),
    [anon_sym_LT_LT_EQ] = ACTIONS(4794),
    [anon_sym_LT_EQ] = ACTIONS(4794),
    [anon_sym_EQ] = ACTIONS(4796),
    [anon_sym_EQ_EQ] = ACTIONS(4794),
    [anon_sym_GT] = ACTIONS(4796),
    [anon_sym_GT_EQ] = ACTIONS(4794),
    [anon_sym_GT_GT] = ACTIONS(4796),
    [anon_sym_GT_GT_EQ] = ACTIONS(4794),
    [anon_sym_PIPE] = ACTIONS(4796),
    [anon_sym_PIPE_EQ] = ACTIONS(4794),
    [anon_sym_PIPE_PIPE] = ACTIONS(4794),
    [anon_sym_QMARK] = ACTIONS(4794),
    [anon_sym_DOT_DOT] = ACTIONS(4796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4794),
    [anon_sym_as] = ACTIONS(4794),
    [sym_line_comment] = ACTIONS(7),
  },
  [3688] = {
    [sym_type_arguments] = STATE(3483),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(4794),
    [anon_sym_EQ_GT] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4794),
    [anon_sym_PLUS] = ACTIONS(4796),
    [anon_sym_STAR] = ACTIONS(4796),
    [anon_sym_AMP] = ACTIONS(4796),
    [anon_sym_DASH] = ACTIONS(4796),
    [anon_sym_DOT] = ACTIONS(4796),
    [anon_sym_DASH_EQ] = ACTIONS(4794),
    [anon_sym_BANG_EQ] = ACTIONS(4794),
    [anon_sym_STAR_EQ] = ACTIONS(4794),
    [anon_sym_SLASH] = ACTIONS(4796),
    [anon_sym_SLASH_EQ] = ACTIONS(4794),
    [anon_sym_AMP_AMP] = ACTIONS(4794),
    [anon_sym_AMP_EQ] = ACTIONS(4794),
    [anon_sym_PERCENT] = ACTIONS(4796),
    [anon_sym_PERCENT_EQ] = ACTIONS(4794),
    [anon_sym_CARET] = ACTIONS(4796),
    [anon_sym_CARET_EQ] = ACTIONS(4794),
    [anon_sym_PLUS_EQ] = ACTIONS(4794),
    [anon_sym_LT] = ACTIONS(7485),
    [anon_sym_LT_LT] = ACTIONS(4796),
    [anon_sym_LT_LT_EQ] = ACTIONS(4794),
    [anon_sym_LT_EQ] = ACTIONS(4794),
    [anon_sym_EQ] = ACTIONS(4796),
    [anon_sym_EQ_EQ] = ACTIONS(4794),
    [anon_sym_GT] = ACTIONS(4796),
    [anon_sym_GT_EQ] = ACTIONS(4794),
    [anon_sym_GT_GT] = ACTIONS(4796),
    [anon_sym_GT_GT_EQ] = ACTIONS(4794),
    [anon_sym_PIPE] = ACTIONS(4796),
    [anon_sym_PIPE_EQ] = ACTIONS(4794),
    [anon_sym_PIPE_PIPE] = ACTIONS(4794),
    [anon_sym_QMARK] = ACTIONS(4794),
    [anon_sym_DOT_DOT] = ACTIONS(4796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4794),
    [anon_sym_as] = ACTIONS(4794),
    [sym_line_comment] = ACTIONS(7),
  },
  [3689] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_EQ_GT] = ACTIONS(6008),
    [anon_sym_LBRACK] = ACTIONS(6008),
    [anon_sym_PLUS] = ACTIONS(7312),
    [anon_sym_STAR] = ACTIONS(7312),
    [anon_sym_AMP] = ACTIONS(7312),
    [anon_sym_DASH] = ACTIONS(7312),
    [anon_sym_DOT] = ACTIONS(7312),
    [anon_sym_DASH_EQ] = ACTIONS(6008),
    [anon_sym_BANG_EQ] = ACTIONS(6008),
    [anon_sym_STAR_EQ] = ACTIONS(6008),
    [anon_sym_SLASH] = ACTIONS(7312),
    [anon_sym_SLASH_EQ] = ACTIONS(6008),
    [anon_sym_AMP_AMP] = ACTIONS(6008),
    [anon_sym_AMP_EQ] = ACTIONS(6008),
    [anon_sym_PERCENT] = ACTIONS(7312),
    [anon_sym_PERCENT_EQ] = ACTIONS(6008),
    [anon_sym_CARET] = ACTIONS(7312),
    [anon_sym_CARET_EQ] = ACTIONS(6008),
    [anon_sym_PLUS_EQ] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(7312),
    [anon_sym_LT_LT] = ACTIONS(7312),
    [anon_sym_LT_LT_EQ] = ACTIONS(6008),
    [anon_sym_LT_EQ] = ACTIONS(6008),
    [anon_sym_EQ] = ACTIONS(7312),
    [anon_sym_EQ_EQ] = ACTIONS(6008),
    [anon_sym_GT] = ACTIONS(7312),
    [anon_sym_GT_EQ] = ACTIONS(6008),
    [anon_sym_GT_GT] = ACTIONS(7312),
    [anon_sym_GT_GT_EQ] = ACTIONS(6008),
    [anon_sym_PIPE] = ACTIONS(7312),
    [anon_sym_PIPE_EQ] = ACTIONS(6008),
    [anon_sym_PIPE_PIPE] = ACTIONS(6008),
    [anon_sym_QMARK] = ACTIONS(6008),
    [anon_sym_DOT_DOT] = ACTIONS(7312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6008),
    [anon_sym_as] = ACTIONS(6008),
    [sym_line_comment] = ACTIONS(7),
  },
  [3690] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6008),
    [anon_sym_EQ_GT] = ACTIONS(6008),
    [anon_sym_LBRACK] = ACTIONS(6008),
    [anon_sym_PLUS] = ACTIONS(7312),
    [anon_sym_STAR] = ACTIONS(7312),
    [anon_sym_AMP] = ACTIONS(7312),
    [anon_sym_DASH] = ACTIONS(7312),
    [anon_sym_DOT] = ACTIONS(7312),
    [anon_sym_DASH_EQ] = ACTIONS(6008),
    [anon_sym_BANG_EQ] = ACTIONS(6008),
    [anon_sym_STAR_EQ] = ACTIONS(6008),
    [anon_sym_SLASH] = ACTIONS(7312),
    [anon_sym_SLASH_EQ] = ACTIONS(6008),
    [anon_sym_AMP_AMP] = ACTIONS(6008),
    [anon_sym_AMP_EQ] = ACTIONS(6008),
    [anon_sym_PERCENT] = ACTIONS(7312),
    [anon_sym_PERCENT_EQ] = ACTIONS(6008),
    [anon_sym_CARET] = ACTIONS(7312),
    [anon_sym_CARET_EQ] = ACTIONS(6008),
    [anon_sym_PLUS_EQ] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(7312),
    [anon_sym_LT_LT] = ACTIONS(7312),
    [anon_sym_LT_LT_EQ] = ACTIONS(6008),
    [anon_sym_LT_EQ] = ACTIONS(6008),
    [anon_sym_EQ] = ACTIONS(7312),
    [anon_sym_EQ_EQ] = ACTIONS(6008),
    [anon_sym_GT] = ACTIONS(7312),
    [anon_sym_GT_EQ] = ACTIONS(6008),
    [anon_sym_GT_GT] = ACTIONS(7312),
    [anon_sym_GT_GT_EQ] = ACTIONS(6008),
    [anon_sym_PIPE] = ACTIONS(7312),
    [anon_sym_PIPE_EQ] = ACTIONS(6008),
    [anon_sym_PIPE_PIPE] = ACTIONS(6008),
    [anon_sym_QMARK] = ACTIONS(6008),
    [anon_sym_DOT_DOT] = ACTIONS(7312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6008),
    [anon_sym_as] = ACTIONS(6008),
    [sym_line_comment] = ACTIONS(7),
  },
  [3691] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6010),
    [anon_sym_EQ_GT] = ACTIONS(6010),
    [anon_sym_LBRACK] = ACTIONS(6010),
    [anon_sym_PLUS] = ACTIONS(7314),
    [anon_sym_STAR] = ACTIONS(7314),
    [anon_sym_AMP] = ACTIONS(7314),
    [anon_sym_DASH] = ACTIONS(7314),
    [anon_sym_DOT] = ACTIONS(7314),
    [anon_sym_DASH_EQ] = ACTIONS(6010),
    [anon_sym_BANG_EQ] = ACTIONS(6010),
    [anon_sym_STAR_EQ] = ACTIONS(6010),
    [anon_sym_SLASH] = ACTIONS(7314),
    [anon_sym_SLASH_EQ] = ACTIONS(6010),
    [anon_sym_AMP_AMP] = ACTIONS(6010),
    [anon_sym_AMP_EQ] = ACTIONS(6010),
    [anon_sym_PERCENT] = ACTIONS(7314),
    [anon_sym_PERCENT_EQ] = ACTIONS(6010),
    [anon_sym_CARET] = ACTIONS(7314),
    [anon_sym_CARET_EQ] = ACTIONS(6010),
    [anon_sym_PLUS_EQ] = ACTIONS(6010),
    [anon_sym_LT] = ACTIONS(7314),
    [anon_sym_LT_LT] = ACTIONS(7314),
    [anon_sym_LT_LT_EQ] = ACTIONS(6010),
    [anon_sym_LT_EQ] = ACTIONS(6010),
    [anon_sym_EQ] = ACTIONS(7314),
    [anon_sym_EQ_EQ] = ACTIONS(6010),
    [anon_sym_GT] = ACTIONS(7314),
    [anon_sym_GT_EQ] = ACTIONS(6010),
    [anon_sym_GT_GT] = ACTIONS(7314),
    [anon_sym_GT_GT_EQ] = ACTIONS(6010),
    [anon_sym_PIPE] = ACTIONS(7314),
    [anon_sym_PIPE_EQ] = ACTIONS(6010),
    [anon_sym_PIPE_PIPE] = ACTIONS(6010),
    [anon_sym_QMARK] = ACTIONS(6010),
    [anon_sym_DOT_DOT] = ACTIONS(7314),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6010),
    [anon_sym_as] = ACTIONS(6010),
    [sym_line_comment] = ACTIONS(7),
  },
  [3692] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6010),
    [anon_sym_EQ_GT] = ACTIONS(6010),
    [anon_sym_LBRACK] = ACTIONS(6010),
    [anon_sym_PLUS] = ACTIONS(7314),
    [anon_sym_STAR] = ACTIONS(7314),
    [anon_sym_AMP] = ACTIONS(7314),
    [anon_sym_DASH] = ACTIONS(7314),
    [anon_sym_DOT] = ACTIONS(7314),
    [anon_sym_DASH_EQ] = ACTIONS(6010),
    [anon_sym_BANG_EQ] = ACTIONS(6010),
    [anon_sym_STAR_EQ] = ACTIONS(6010),
    [anon_sym_SLASH] = ACTIONS(7314),
    [anon_sym_SLASH_EQ] = ACTIONS(6010),
    [anon_sym_AMP_AMP] = ACTIONS(6010),
    [anon_sym_AMP_EQ] = ACTIONS(6010),
    [anon_sym_PERCENT] = ACTIONS(7314),
    [anon_sym_PERCENT_EQ] = ACTIONS(6010),
    [anon_sym_CARET] = ACTIONS(7314),
    [anon_sym_CARET_EQ] = ACTIONS(6010),
    [anon_sym_PLUS_EQ] = ACTIONS(6010),
    [anon_sym_LT] = ACTIONS(7314),
    [anon_sym_LT_LT] = ACTIONS(7314),
    [anon_sym_LT_LT_EQ] = ACTIONS(6010),
    [anon_sym_LT_EQ] = ACTIONS(6010),
    [anon_sym_EQ] = ACTIONS(7314),
    [anon_sym_EQ_EQ] = ACTIONS(6010),
    [anon_sym_GT] = ACTIONS(7314),
    [anon_sym_GT_EQ] = ACTIONS(6010),
    [anon_sym_GT_GT] = ACTIONS(7314),
    [anon_sym_GT_GT_EQ] = ACTIONS(6010),
    [anon_sym_PIPE] = ACTIONS(7314),
    [anon_sym_PIPE_EQ] = ACTIONS(6010),
    [anon_sym_PIPE_PIPE] = ACTIONS(6010),
    [anon_sym_QMARK] = ACTIONS(6010),
    [anon_sym_DOT_DOT] = ACTIONS(7314),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6010),
    [anon_sym_as] = ACTIONS(6010),
    [sym_line_comment] = ACTIONS(7),
  },
  [3693] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7316),
    [anon_sym_EQ_GT] = ACTIONS(7316),
    [anon_sym_LBRACK] = ACTIONS(7316),
    [anon_sym_PLUS] = ACTIONS(7318),
    [anon_sym_STAR] = ACTIONS(7318),
    [anon_sym_AMP] = ACTIONS(7318),
    [anon_sym_DASH] = ACTIONS(7318),
    [anon_sym_DOT] = ACTIONS(7318),
    [anon_sym_DASH_EQ] = ACTIONS(7316),
    [anon_sym_BANG_EQ] = ACTIONS(7316),
    [anon_sym_STAR_EQ] = ACTIONS(7316),
    [anon_sym_SLASH] = ACTIONS(7318),
    [anon_sym_SLASH_EQ] = ACTIONS(7316),
    [anon_sym_AMP_AMP] = ACTIONS(7316),
    [anon_sym_AMP_EQ] = ACTIONS(7316),
    [anon_sym_PERCENT] = ACTIONS(7318),
    [anon_sym_PERCENT_EQ] = ACTIONS(7316),
    [anon_sym_CARET] = ACTIONS(7318),
    [anon_sym_CARET_EQ] = ACTIONS(7316),
    [anon_sym_PLUS_EQ] = ACTIONS(7316),
    [anon_sym_LT] = ACTIONS(7318),
    [anon_sym_LT_LT] = ACTIONS(7318),
    [anon_sym_LT_LT_EQ] = ACTIONS(7316),
    [anon_sym_LT_EQ] = ACTIONS(7316),
    [anon_sym_EQ] = ACTIONS(7318),
    [anon_sym_EQ_EQ] = ACTIONS(7316),
    [anon_sym_GT] = ACTIONS(7318),
    [anon_sym_GT_EQ] = ACTIONS(7316),
    [anon_sym_GT_GT] = ACTIONS(7318),
    [anon_sym_GT_GT_EQ] = ACTIONS(7316),
    [anon_sym_PIPE] = ACTIONS(7318),
    [anon_sym_PIPE_EQ] = ACTIONS(7316),
    [anon_sym_PIPE_PIPE] = ACTIONS(7316),
    [anon_sym_QMARK] = ACTIONS(7316),
    [anon_sym_DOT_DOT] = ACTIONS(7318),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7316),
    [anon_sym_as] = ACTIONS(7316),
    [sym_line_comment] = ACTIONS(7),
  },
  [3694] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(3700),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [3695] = {
    [sym_arguments] = STATE(263),
    [sym_block] = STATE(3701),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(5136),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(979),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(999),
    [sym_line_comment] = ACTIONS(7),
  },
  [3696] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7864),
    [anon_sym_macro_rules_BANG] = ACTIONS(7864),
    [anon_sym_RBRACE] = ACTIONS(7864),
    [anon_sym_POUND] = ACTIONS(7864),
    [anon_sym_const] = ACTIONS(7866),
    [anon_sym_default] = ACTIONS(7866),
    [anon_sym_enum] = ACTIONS(7866),
    [anon_sym_fn] = ACTIONS(7866),
    [anon_sym_impl] = ACTIONS(7866),
    [anon_sym_let] = ACTIONS(7866),
    [anon_sym_mod] = ACTIONS(7866),
    [anon_sym_pub] = ACTIONS(7866),
    [anon_sym_static] = ACTIONS(7866),
    [anon_sym_struct] = ACTIONS(7866),
    [anon_sym_trait] = ACTIONS(7866),
    [anon_sym_type] = ACTIONS(7866),
    [anon_sym_union] = ACTIONS(7866),
    [anon_sym_unsafe] = ACTIONS(7866),
    [anon_sym_use] = ACTIONS(7866),
    [anon_sym_extern] = ACTIONS(7866),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7866),
  },
  [3697] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7868),
    [anon_sym_macro_rules_BANG] = ACTIONS(7868),
    [anon_sym_RBRACE] = ACTIONS(7868),
    [anon_sym_POUND] = ACTIONS(7868),
    [anon_sym_const] = ACTIONS(7870),
    [anon_sym_default] = ACTIONS(7870),
    [anon_sym_enum] = ACTIONS(7870),
    [anon_sym_fn] = ACTIONS(7870),
    [anon_sym_impl] = ACTIONS(7870),
    [anon_sym_let] = ACTIONS(7870),
    [anon_sym_mod] = ACTIONS(7870),
    [anon_sym_pub] = ACTIONS(7870),
    [anon_sym_static] = ACTIONS(7870),
    [anon_sym_struct] = ACTIONS(7870),
    [anon_sym_trait] = ACTIONS(7870),
    [anon_sym_type] = ACTIONS(7870),
    [anon_sym_union] = ACTIONS(7870),
    [anon_sym_unsafe] = ACTIONS(7870),
    [anon_sym_use] = ACTIONS(7870),
    [anon_sym_extern] = ACTIONS(7870),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7870),
  },
  [3698] = {
    [sym_raw_string_literal] = ACTIONS(7634),
    [sym_float_literal] = ACTIONS(7634),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7634),
    [anon_sym_RBRACE] = ACTIONS(7634),
    [anon_sym_LBRACK] = ACTIONS(7634),
    [anon_sym_PLUS] = ACTIONS(7636),
    [anon_sym_STAR] = ACTIONS(7636),
    [anon_sym_COMMA] = ACTIONS(7634),
    [anon_sym_u8] = ACTIONS(7636),
    [anon_sym_i8] = ACTIONS(7636),
    [anon_sym_u16] = ACTIONS(7636),
    [anon_sym_i16] = ACTIONS(7636),
    [anon_sym_u32] = ACTIONS(7636),
    [anon_sym_i32] = ACTIONS(7636),
    [anon_sym_u64] = ACTIONS(7636),
    [anon_sym_i64] = ACTIONS(7636),
    [anon_sym_u128] = ACTIONS(7636),
    [anon_sym_i128] = ACTIONS(7636),
    [anon_sym_isize] = ACTIONS(7636),
    [anon_sym_usize] = ACTIONS(7636),
    [anon_sym_f32] = ACTIONS(7636),
    [anon_sym_f64] = ACTIONS(7636),
    [anon_sym_bool] = ACTIONS(7636),
    [anon_sym_str] = ACTIONS(7636),
    [anon_sym_char] = ACTIONS(7636),
    [anon_sym__] = ACTIONS(7636),
    [anon_sym_AMP] = ACTIONS(7636),
    [anon_sym_DASH] = ACTIONS(7636),
    [anon_sym_DOT] = ACTIONS(7636),
    [anon_sym_DASH_EQ] = ACTIONS(7634),
    [anon_sym_COLON_COLON] = ACTIONS(7634),
    [anon_sym_BANG_EQ] = ACTIONS(7634),
    [anon_sym_STAR_EQ] = ACTIONS(7634),
    [anon_sym_SLASH] = ACTIONS(7636),
    [anon_sym_SLASH_EQ] = ACTIONS(7634),
    [anon_sym_AMP_AMP] = ACTIONS(7634),
    [anon_sym_AMP_EQ] = ACTIONS(7634),
    [anon_sym_POUND] = ACTIONS(7634),
    [anon_sym_PERCENT] = ACTIONS(7636),
    [anon_sym_PERCENT_EQ] = ACTIONS(7634),
    [anon_sym_CARET] = ACTIONS(7636),
    [anon_sym_CARET_EQ] = ACTIONS(7634),
    [anon_sym_PLUS_EQ] = ACTIONS(7634),
    [anon_sym_LT] = ACTIONS(7636),
    [anon_sym_LT_LT] = ACTIONS(7636),
    [anon_sym_LT_LT_EQ] = ACTIONS(7634),
    [anon_sym_LT_EQ] = ACTIONS(7634),
    [anon_sym_EQ] = ACTIONS(7636),
    [anon_sym_EQ_EQ] = ACTIONS(7634),
    [anon_sym_GT] = ACTIONS(7636),
    [anon_sym_GT_EQ] = ACTIONS(7634),
    [anon_sym_GT_GT] = ACTIONS(7636),
    [anon_sym_GT_GT_EQ] = ACTIONS(7634),
    [anon_sym_PIPE] = ACTIONS(7636),
    [anon_sym_PIPE_EQ] = ACTIONS(7634),
    [anon_sym_PIPE_PIPE] = ACTIONS(7634),
    [anon_sym_QMARK] = ACTIONS(7634),
    [anon_sym_DOT_DOT] = ACTIONS(7636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7634),
    [anon_sym_as] = ACTIONS(7636),
    [sym_mutable_specifier] = ACTIONS(7636),
    [anon_sym_ref] = ACTIONS(7636),
    [sym_integer_literal] = ACTIONS(7634),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(7634),
    [sym_char_literal] = ACTIONS(7634),
    [anon_sym_true] = ACTIONS(7636),
    [anon_sym_false] = ACTIONS(7636),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(7636),
    [sym_self] = ACTIONS(7636),
    [sym_super] = ACTIONS(7636),
    [sym_crate] = ACTIONS(7636),
    [sym_metavariable] = ACTIONS(7634),
  },
  [3699] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6805),
    [anon_sym_EQ_GT] = ACTIONS(6805),
    [anon_sym_LBRACK] = ACTIONS(6805),
    [anon_sym_PLUS] = ACTIONS(7632),
    [anon_sym_STAR] = ACTIONS(7632),
    [anon_sym_AMP] = ACTIONS(7632),
    [anon_sym_DASH] = ACTIONS(7632),
    [anon_sym_DOT] = ACTIONS(7632),
    [anon_sym_DASH_EQ] = ACTIONS(6805),
    [anon_sym_DASH_GT] = ACTIONS(6805),
    [anon_sym_BANG_EQ] = ACTIONS(6805),
    [anon_sym_STAR_EQ] = ACTIONS(6805),
    [anon_sym_SLASH] = ACTIONS(7632),
    [anon_sym_SLASH_EQ] = ACTIONS(6805),
    [anon_sym_AMP_AMP] = ACTIONS(6805),
    [anon_sym_AMP_EQ] = ACTIONS(6805),
    [anon_sym_PERCENT] = ACTIONS(7632),
    [anon_sym_PERCENT_EQ] = ACTIONS(6805),
    [anon_sym_CARET] = ACTIONS(7632),
    [anon_sym_CARET_EQ] = ACTIONS(6805),
    [anon_sym_PLUS_EQ] = ACTIONS(6805),
    [anon_sym_LT] = ACTIONS(7632),
    [anon_sym_LT_LT] = ACTIONS(7632),
    [anon_sym_LT_LT_EQ] = ACTIONS(6805),
    [anon_sym_LT_EQ] = ACTIONS(6805),
    [anon_sym_EQ] = ACTIONS(7632),
    [anon_sym_EQ_EQ] = ACTIONS(6805),
    [anon_sym_GT] = ACTIONS(7632),
    [anon_sym_GT_EQ] = ACTIONS(6805),
    [anon_sym_GT_GT] = ACTIONS(7632),
    [anon_sym_GT_GT_EQ] = ACTIONS(6805),
    [anon_sym_PIPE] = ACTIONS(7632),
    [anon_sym_PIPE_EQ] = ACTIONS(6805),
    [anon_sym_PIPE_PIPE] = ACTIONS(6805),
    [anon_sym_QMARK] = ACTIONS(6805),
    [anon_sym_DOT_DOT] = ACTIONS(7632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6805),
    [anon_sym_as] = ACTIONS(6805),
    [sym_line_comment] = ACTIONS(7),
  },
  [3700] = {
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(7634),
    [anon_sym_EQ_GT] = ACTIONS(7634),
    [anon_sym_LBRACK] = ACTIONS(7634),
    [anon_sym_PLUS] = ACTIONS(7636),
    [anon_sym_STAR] = ACTIONS(7636),
    [anon_sym_AMP] = ACTIONS(7636),
    [anon_sym_DASH] = ACTIONS(7636),
    [anon_sym_DOT] = ACTIONS(7636),
    [anon_sym_DASH_EQ] = ACTIONS(7634),
    [anon_sym_BANG_EQ] = ACTIONS(7634),
    [anon_sym_STAR_EQ] = ACTIONS(7634),
    [anon_sym_SLASH] = ACTIONS(7636),
    [anon_sym_SLASH_EQ] = ACTIONS(7634),
    [anon_sym_AMP_AMP] = ACTIONS(7634),
    [anon_sym_AMP_EQ] = ACTIONS(7634),
    [anon_sym_PERCENT] = ACTIONS(7636),
    [anon_sym_PERCENT_EQ] = ACTIONS(7634),
    [anon_sym_CARET] = ACTIONS(7636),
    [anon_sym_CARET_EQ] = ACTIONS(7634),
    [anon_sym_PLUS_EQ] = ACTIONS(7634),
    [anon_sym_LT] = ACTIONS(7636),
    [anon_sym_LT_LT] = ACTIONS(7636),
    [anon_sym_LT_LT_EQ] = ACTIONS(7634),
    [anon_sym_LT_EQ] = ACTIONS(7634),
    [anon_sym_EQ] = ACTIONS(7636),
    [anon_sym_EQ_EQ] = ACTIONS(7634),
    [anon_sym_GT] = ACTIONS(7636),
    [anon_sym_GT_EQ] = ACTIONS(7634),
    [anon_sym_GT_GT] = ACTIONS(7636),
    [anon_sym_GT_GT_EQ] = ACTIONS(7634),
    [anon_sym_PIPE] = ACTIONS(7636),
    [anon_sym_PIPE_EQ] = ACTIONS(7634),
    [anon_sym_PIPE_PIPE] = ACTIONS(7634),
    [anon_sym_QMARK] = ACTIONS(7634),
    [anon_sym_DOT_DOT] = ACTIONS(7636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7634),
    [anon_sym_as] = ACTIONS(7634),
    [sym_line_comment] = ACTIONS(7),
  },
  [3701] = {
    [sym_else_tail] = STATE(3676),
    [sym_raw_string_literal] = ACTIONS(6158),
    [sym_float_literal] = ACTIONS(6158),
    [sym_block_comment] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(6158),
    [anon_sym_LBRACK] = ACTIONS(6158),
    [anon_sym_PLUS] = ACTIONS(6160),
    [anon_sym_STAR] = ACTIONS(6160),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_u8] = ACTIONS(6160),
    [anon_sym_i8] = ACTIONS(6160),
    [anon_sym_u16] = ACTIONS(6160),
    [anon_sym_i16] = ACTIONS(6160),
    [anon_sym_u32] = ACTIONS(6160),
    [anon_sym_i32] = ACTIONS(6160),
    [anon_sym_u64] = ACTIONS(6160),
    [anon_sym_i64] = ACTIONS(6160),
    [anon_sym_u128] = ACTIONS(6160),
    [anon_sym_i128] = ACTIONS(6160),
    [anon_sym_isize] = ACTIONS(6160),
    [anon_sym_usize] = ACTIONS(6160),
    [anon_sym_f32] = ACTIONS(6160),
    [anon_sym_f64] = ACTIONS(6160),
    [anon_sym_bool] = ACTIONS(6160),
    [anon_sym_str] = ACTIONS(6160),
    [anon_sym_char] = ACTIONS(6160),
    [anon_sym__] = ACTIONS(6160),
    [anon_sym_AMP] = ACTIONS(6160),
    [anon_sym_DASH] = ACTIONS(6160),
    [anon_sym_DOT] = ACTIONS(6160),
    [anon_sym_DASH_EQ] = ACTIONS(6158),
    [anon_sym_COLON_COLON] = ACTIONS(6158),
    [anon_sym_BANG_EQ] = ACTIONS(6158),
    [anon_sym_STAR_EQ] = ACTIONS(6158),
    [anon_sym_SLASH] = ACTIONS(6160),
    [anon_sym_SLASH_EQ] = ACTIONS(6158),
    [anon_sym_AMP_AMP] = ACTIONS(6158),
    [anon_sym_AMP_EQ] = ACTIONS(6158),
    [anon_sym_POUND] = ACTIONS(6158),
    [anon_sym_PERCENT] = ACTIONS(6160),
    [anon_sym_PERCENT_EQ] = ACTIONS(6158),
    [anon_sym_CARET] = ACTIONS(6160),
    [anon_sym_CARET_EQ] = ACTIONS(6158),
    [anon_sym_PLUS_EQ] = ACTIONS(6158),
    [anon_sym_LT] = ACTIONS(6160),
    [anon_sym_LT_LT] = ACTIONS(6160),
    [anon_sym_LT_LT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_EQ] = ACTIONS(6160),
    [anon_sym_EQ_EQ] = ACTIONS(6158),
    [anon_sym_GT] = ACTIONS(6160),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_GT_GT] = ACTIONS(6160),
    [anon_sym_GT_GT_EQ] = ACTIONS(6158),
    [anon_sym_PIPE] = ACTIONS(6160),
    [anon_sym_PIPE_EQ] = ACTIONS(6158),
    [anon_sym_PIPE_PIPE] = ACTIONS(6158),
    [anon_sym_QMARK] = ACTIONS(6158),
    [anon_sym_DOT_DOT] = ACTIONS(6160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6158),
    [anon_sym_as] = ACTIONS(6160),
    [sym_mutable_specifier] = ACTIONS(6160),
    [anon_sym_else] = ACTIONS(7858),
    [anon_sym_ref] = ACTIONS(6160),
    [sym_integer_literal] = ACTIONS(6158),
    [aux_sym_SLASHb_QMARK_DQUOTE_SLASH] = ACTIONS(6158),
    [sym_char_literal] = ACTIONS(6158),
    [anon_sym_true] = ACTIONS(6160),
    [anon_sym_false] = ACTIONS(6160),
    [sym_line_comment] = ACTIONS(7),
    [sym_identifier] = ACTIONS(6160),
    [sym_self] = ACTIONS(6160),
    [sym_super] = ACTIONS(6160),
    [sym_crate] = ACTIONS(6160),
    [sym_metavariable] = ACTIONS(6158),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = true}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, RECOVER(),
  [5] = {.count = 1, .reusable = true}, SHIFT(52),
  [7] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [9] = {.count = 1, .reusable = true}, REDUCE(sym_source_file, 0),
  [11] = {.count = 1, .reusable = true}, SHIFT(2),
  [13] = {.count = 1, .reusable = true}, SHIFT(3),
  [15] = {.count = 1, .reusable = true}, SHIFT(4),
  [17] = {.count = 1, .reusable = true}, SHIFT(5),
  [19] = {.count = 1, .reusable = true}, SHIFT(6),
  [21] = {.count = 1, .reusable = true}, SHIFT(7),
  [23] = {.count = 1, .reusable = false}, SHIFT(8),
  [25] = {.count = 1, .reusable = true}, SHIFT(9),
  [27] = {.count = 1, .reusable = true}, SHIFT(10),
  [29] = {.count = 1, .reusable = true}, SHIFT(11),
  [31] = {.count = 1, .reusable = true}, SHIFT(12),
  [33] = {.count = 1, .reusable = true}, SHIFT(13),
  [35] = {.count = 1, .reusable = false}, SHIFT(14),
  [37] = {.count = 1, .reusable = true}, SHIFT(15),
  [39] = {.count = 1, .reusable = false}, SHIFT(16),
  [41] = {.count = 1, .reusable = false}, SHIFT(17),
  [43] = {.count = 1, .reusable = false}, SHIFT(18),
  [45] = {.count = 1, .reusable = false}, SHIFT(19),
  [47] = {.count = 1, .reusable = false}, SHIFT(20),
  [49] = {.count = 1, .reusable = false}, SHIFT(21),
  [51] = {.count = 1, .reusable = false}, SHIFT(22),
  [53] = {.count = 1, .reusable = false}, SHIFT(23),
  [55] = {.count = 1, .reusable = false}, SHIFT(24),
  [57] = {.count = 1, .reusable = false}, SHIFT(25),
  [59] = {.count = 1, .reusable = false}, SHIFT(26),
  [61] = {.count = 1, .reusable = false}, SHIFT(27),
  [63] = {.count = 1, .reusable = false}, SHIFT(28),
  [65] = {.count = 1, .reusable = false}, SHIFT(29),
  [67] = {.count = 1, .reusable = false}, SHIFT(30),
  [69] = {.count = 1, .reusable = false}, SHIFT(31),
  [71] = {.count = 1, .reusable = false}, SHIFT(32),
  [73] = {.count = 1, .reusable = false}, SHIFT(33),
  [75] = {.count = 1, .reusable = false}, SHIFT(34),
  [77] = {.count = 1, .reusable = false}, SHIFT(35),
  [79] = {.count = 1, .reusable = false}, SHIFT(36),
  [81] = {.count = 1, .reusable = false}, SHIFT(37),
  [83] = {.count = 1, .reusable = false}, SHIFT(38),
  [85] = {.count = 1, .reusable = false}, SHIFT(39),
  [87] = {.count = 1, .reusable = false}, SHIFT(40),
  [89] = {.count = 1, .reusable = true}, SHIFT(41),
  [91] = {.count = 1, .reusable = false}, SHIFT(42),
  [93] = {.count = 1, .reusable = false}, SHIFT(43),
  [95] = {.count = 1, .reusable = false}, SHIFT(44),
  [97] = {.count = 1, .reusable = false}, SHIFT(45),
  [99] = {.count = 1, .reusable = true}, SHIFT(44),
  [101] = {.count = 1, .reusable = true}, REDUCE(sym_empty_statement, 1),
  [103] = {.count = 1, .reusable = false}, REDUCE(sym_empty_statement, 1),
  [105] = {.count = 1, .reusable = true}, SHIFT(63),
  [107] = {.count = 1, .reusable = true}, SHIFT(79),
  [109] = {.count = 1, .reusable = true}, SHIFT(64),
  [111] = {.count = 1, .reusable = true}, SHIFT(65),
  [113] = {.count = 1, .reusable = true}, SHIFT(66),
  [115] = {.count = 1, .reusable = true}, SHIFT(67),
  [117] = {.count = 1, .reusable = true}, SHIFT(68),
  [119] = {.count = 1, .reusable = false}, SHIFT(69),
  [121] = {.count = 1, .reusable = false}, SHIFT(70),
  [123] = {.count = 1, .reusable = false}, SHIFT(71),
  [125] = {.count = 1, .reusable = false}, SHIFT(72),
  [127] = {.count = 1, .reusable = false}, SHIFT(73),
  [129] = {.count = 1, .reusable = false}, SHIFT(74),
  [131] = {.count = 1, .reusable = false}, SHIFT(75),
  [133] = {.count = 1, .reusable = false}, SHIFT(76),
  [135] = {.count = 1, .reusable = false}, SHIFT(77),
  [137] = {.count = 1, .reusable = false}, SHIFT(78),
  [139] = {.count = 1, .reusable = true}, SHIFT(89),
  [141] = {.count = 1, .reusable = true}, SHIFT(82),
  [143] = {.count = 1, .reusable = true}, SHIFT(83),
  [145] = {.count = 1, .reusable = true}, SHIFT(84),
  [147] = {.count = 1, .reusable = true}, SHIFT(85),
  [149] = {.count = 1, .reusable = false}, SHIFT(86),
  [151] = {.count = 1, .reusable = false}, SHIFT(87),
  [153] = {.count = 1, .reusable = false}, SHIFT(88),
  [155] = {.count = 1, .reusable = true}, SHIFT(100),
  [157] = {.count = 1, .reusable = true}, SHIFT(92),
  [159] = {.count = 1, .reusable = true}, SHIFT(93),
  [161] = {.count = 1, .reusable = true}, SHIFT(94),
  [163] = {.count = 1, .reusable = true}, SHIFT(95),
  [165] = {.count = 1, .reusable = true}, SHIFT(96),
  [167] = {.count = 1, .reusable = false}, SHIFT(97),
  [169] = {.count = 1, .reusable = false}, SHIFT(98),
  [171] = {.count = 1, .reusable = false}, SHIFT(99),
  [173] = {.count = 1, .reusable = true}, SHIFT(103),
  [175] = {.count = 1, .reusable = false}, SHIFT(102),
  [177] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1),
  [179] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1, .alias_sequence_id = 1),
  [181] = {.count = 1, .reusable = true}, SHIFT(104),
  [183] = {.count = 1, .reusable = true}, SHIFT(106),
  [185] = {.count = 1, .reusable = false}, SHIFT(105),
  [187] = {.count = 1, .reusable = true}, SHIFT(107),
  [189] = {.count = 1, .reusable = true}, SHIFT(108),
  [191] = {.count = 1, .reusable = true}, SHIFT(109),
  [193] = {.count = 1, .reusable = true}, SHIFT(110),
  [195] = {.count = 1, .reusable = true}, SHIFT(111),
  [197] = {.count = 1, .reusable = true}, SHIFT(112),
  [199] = {.count = 1, .reusable = false}, SHIFT(113),
  [201] = {.count = 1, .reusable = true}, SHIFT(114),
  [203] = {.count = 1, .reusable = true}, SHIFT(115),
  [205] = {.count = 1, .reusable = true}, SHIFT(116),
  [207] = {.count = 1, .reusable = true}, SHIFT(117),
  [209] = {.count = 1, .reusable = false}, SHIFT(132),
  [211] = {.count = 1, .reusable = false}, SHIFT(118),
  [213] = {.count = 1, .reusable = false}, SHIFT(119),
  [215] = {.count = 1, .reusable = false}, SHIFT(120),
  [217] = {.count = 1, .reusable = false}, SHIFT(121),
  [219] = {.count = 1, .reusable = false}, SHIFT(122),
  [221] = {.count = 1, .reusable = true}, SHIFT(123),
  [223] = {.count = 1, .reusable = true}, SHIFT(148),
  [225] = {.count = 1, .reusable = true}, SHIFT(133),
  [227] = {.count = 1, .reusable = false}, SHIFT(134),
  [229] = {.count = 1, .reusable = false}, SHIFT(135),
  [231] = {.count = 1, .reusable = true}, SHIFT(136),
  [233] = {.count = 1, .reusable = true}, SHIFT(137),
  [235] = {.count = 1, .reusable = true}, SHIFT(138),
  [237] = {.count = 1, .reusable = true}, SHIFT(139),
  [239] = {.count = 1, .reusable = false}, SHIFT(140),
  [241] = {.count = 1, .reusable = false}, SHIFT(141),
  [243] = {.count = 1, .reusable = false}, SHIFT(142),
  [245] = {.count = 1, .reusable = true}, SHIFT(143),
  [247] = {.count = 1, .reusable = false}, SHIFT(144),
  [249] = {.count = 1, .reusable = false}, SHIFT(145),
  [251] = {.count = 1, .reusable = false}, SHIFT(146),
  [253] = {.count = 1, .reusable = false}, SHIFT(147),
  [255] = {.count = 1, .reusable = true}, SHIFT(147),
  [257] = {.count = 1, .reusable = true}, SHIFT(154),
  [259] = {.count = 1, .reusable = true}, SHIFT(155),
  [261] = {.count = 1, .reusable = true}, REDUCE(sym_range_expression, 1),
  [263] = {.count = 1, .reusable = false}, REDUCE(sym_range_expression, 1),
  [265] = {.count = 1, .reusable = false}, SHIFT(7),
  [267] = {.count = 1, .reusable = true}, REDUCE(sym_break_expression, 1),
  [269] = {.count = 1, .reusable = false}, REDUCE(sym_break_expression, 1),
  [271] = {.count = 1, .reusable = true}, SHIFT(14),
  [273] = {.count = 1, .reusable = false}, REDUCE(aux_sym_function_modifiers_repeat1, 1),
  [275] = {.count = 1, .reusable = false}, SHIFT(157),
  [277] = {.count = 1, .reusable = true}, REDUCE(sym_continue_expression, 1),
  [279] = {.count = 1, .reusable = false}, REDUCE(sym_continue_expression, 1),
  [281] = {.count = 1, .reusable = true}, REDUCE(aux_sym_function_modifiers_repeat1, 1),
  [283] = {.count = 1, .reusable = true}, SHIFT(159),
  [285] = {.count = 1, .reusable = true}, SHIFT(160),
  [287] = {.count = 1, .reusable = true}, SHIFT(166),
  [289] = {.count = 1, .reusable = false}, SHIFT(161),
  [291] = {.count = 1, .reusable = false}, SHIFT(166),
  [293] = {.count = 1, .reusable = true}, SHIFT(162),
  [295] = {.count = 1, .reusable = false}, SHIFT(163),
  [297] = {.count = 1, .reusable = false}, SHIFT(164),
  [299] = {.count = 1, .reusable = false}, SHIFT(165),
  [301] = {.count = 1, .reusable = true}, SHIFT(180),
  [303] = {.count = 1, .reusable = true}, SHIFT(167),
  [305] = {.count = 1, .reusable = false}, SHIFT(168),
  [307] = {.count = 1, .reusable = true}, SHIFT(169),
  [309] = {.count = 1, .reusable = true}, SHIFT(170),
  [311] = {.count = 1, .reusable = true}, SHIFT(171),
  [313] = {.count = 1, .reusable = false}, SHIFT(172),
  [315] = {.count = 1, .reusable = false}, SHIFT(173),
  [317] = {.count = 1, .reusable = false}, SHIFT(174),
  [319] = {.count = 1, .reusable = false}, SHIFT(175),
  [321] = {.count = 1, .reusable = false}, SHIFT(176),
  [323] = {.count = 1, .reusable = false}, SHIFT(177),
  [325] = {.count = 1, .reusable = false}, SHIFT(178),
  [327] = {.count = 1, .reusable = true}, SHIFT(177),
  [329] = {.count = 1, .reusable = false}, SHIFT(183),
  [331] = {.count = 1, .reusable = true}, SHIFT(184),
  [333] = {.count = 1, .reusable = false}, SHIFT(185),
  [335] = {.count = 1, .reusable = true}, SHIFT(122),
  [337] = {.count = 1, .reusable = true}, SHIFT(192),
  [339] = {.count = 1, .reusable = false}, SHIFT(192),
  [341] = {.count = 1, .reusable = true}, SHIFT(188),
  [343] = {.count = 1, .reusable = false}, SHIFT(189),
  [345] = {.count = 1, .reusable = false}, SHIFT(190),
  [347] = {.count = 1, .reusable = false}, SHIFT(191),
  [349] = {.count = 1, .reusable = true}, SHIFT(194),
  [351] = {.count = 1, .reusable = true}, SHIFT(195),
  [353] = {.count = 1, .reusable = true}, SHIFT(196),
  [355] = {.count = 1, .reusable = true}, REDUCE(sym_visibility_modifier, 1),
  [357] = {.count = 1, .reusable = true}, SHIFT(197),
  [359] = {.count = 1, .reusable = true}, REDUCE(sym_return_expression, 1),
  [361] = {.count = 1, .reusable = false}, REDUCE(sym_return_expression, 1),
  [363] = {.count = 1, .reusable = false}, SHIFT(198),
  [365] = {.count = 1, .reusable = false}, SHIFT(199),
  [367] = {.count = 1, .reusable = true}, SHIFT(200),
  [369] = {.count = 1, .reusable = true}, SHIFT(201),
  [371] = {.count = 1, .reusable = true}, SHIFT(202),
  [373] = {.count = 1, .reusable = false}, SHIFT(203),
  [375] = {.count = 1, .reusable = true}, SHIFT(204),
  [377] = {.count = 1, .reusable = true}, SHIFT(206),
  [379] = {.count = 1, .reusable = false}, SHIFT(207),
  [381] = {.count = 1, .reusable = true}, SHIFT(208),
  [383] = {.count = 1, .reusable = false}, SHIFT(209),
  [385] = {.count = 1, .reusable = false}, SHIFT(210),
  [387] = {.count = 1, .reusable = true}, SHIFT(210),
  [389] = {.count = 1, .reusable = true}, SHIFT(215),
  [391] = {.count = 1, .reusable = false}, SHIFT(214),
  [393] = {.count = 1, .reusable = true}, REDUCE(sym_extern_modifier, 1),
  [395] = {.count = 1, .reusable = true}, SHIFT(216),
  [397] = {.count = 1, .reusable = true}, SHIFT(220),
  [399] = {.count = 1, .reusable = true}, SHIFT(219),
  [401] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [403] = {.count = 1, .reusable = true}, REDUCE(sym_boolean_literal, 1),
  [405] = {.count = 1, .reusable = false}, REDUCE(sym_boolean_literal, 1),
  [407] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [409] = {.count = 1, .reusable = true}, SHIFT(221),
  [411] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [413] = {.count = 1, .reusable = true}, SHIFT(222),
  [415] = {.count = 1, .reusable = false}, SHIFT(223),
  [417] = {.count = 1, .reusable = true}, SHIFT(225),
  [419] = {.count = 1, .reusable = true}, ACCEPT_INPUT(),
  [421] = {.count = 1, .reusable = true}, SHIFT(226),
  [423] = {.count = 1, .reusable = true}, SHIFT(227),
  [425] = {.count = 1, .reusable = true}, SHIFT(228),
  [427] = {.count = 1, .reusable = true}, SHIFT(229),
  [429] = {.count = 1, .reusable = true}, SHIFT(62),
  [431] = {.count = 1, .reusable = true}, SHIFT(230),
  [433] = {.count = 1, .reusable = true}, SHIFT(231),
  [435] = {.count = 1, .reusable = true}, SHIFT(232),
  [437] = {.count = 1, .reusable = true}, SHIFT(233),
  [439] = {.count = 1, .reusable = true}, SHIFT(234),
  [441] = {.count = 1, .reusable = true}, SHIFT(235),
  [443] = {.count = 1, .reusable = true}, SHIFT(236),
  [445] = {.count = 1, .reusable = true}, SHIFT(237),
  [447] = {.count = 1, .reusable = true}, SHIFT(238),
  [449] = {.count = 1, .reusable = true}, SHIFT(241),
  [451] = {.count = 1, .reusable = true}, SHIFT(242),
  [453] = {.count = 1, .reusable = true}, SHIFT(244),
  [455] = {.count = 1, .reusable = true}, SHIFT(245),
  [457] = {.count = 1, .reusable = true}, SHIFT(246),
  [459] = {.count = 1, .reusable = false}, SHIFT(247),
  [461] = {.count = 1, .reusable = false}, SHIFT(248),
  [463] = {.count = 1, .reusable = false}, SHIFT(249),
  [465] = {.count = 1, .reusable = false}, SHIFT(250),
  [467] = {.count = 1, .reusable = true}, SHIFT(251),
  [469] = {.count = 1, .reusable = true}, SHIFT(252),
  [471] = {.count = 1, .reusable = true}, SHIFT(253),
  [473] = {.count = 1, .reusable = false}, SHIFT(254),
  [475] = {.count = 1, .reusable = false}, SHIFT(252),
  [477] = {.count = 1, .reusable = false}, SHIFT(255),
  [479] = {.count = 1, .reusable = false}, SHIFT(256),
  [481] = {.count = 1, .reusable = false}, SHIFT(257),
  [483] = {.count = 1, .reusable = true}, SHIFT(258),
  [485] = {.count = 1, .reusable = true}, SHIFT(259),
  [487] = {.count = 1, .reusable = false}, SHIFT(260),
  [489] = {.count = 1, .reusable = true}, SHIFT(261),
  [491] = {.count = 1, .reusable = true}, SHIFT(262),
  [493] = {.count = 1, .reusable = true}, REDUCE(sym__statement, 1),
  [495] = {.count = 1, .reusable = false}, REDUCE(sym__statement, 1),
  [497] = {.count = 1, .reusable = true}, SHIFT(264),
  [499] = {.count = 1, .reusable = true}, REDUCE(sym_binary_expression, 1),
  [501] = {.count = 1, .reusable = false}, REDUCE(sym_binary_expression, 1),
  [503] = {.count = 1, .reusable = true}, REDUCE(sym__expression_statement, 1),
  [505] = {.count = 1, .reusable = false}, REDUCE(sym__expression_statement, 1),
  [507] = {.count = 1, .reusable = true}, SHIFT(266),
  [509] = {.count = 1, .reusable = true}, SHIFT(265),
  [511] = {.count = 1, .reusable = true}, SHIFT(267),
  [513] = {.count = 1, .reusable = true}, SHIFT(268),
  [515] = {.count = 1, .reusable = true}, REDUCE(sym_source_file, 1),
  [517] = {.count = 1, .reusable = true}, SHIFT(271),
  [519] = {.count = 1, .reusable = true}, REDUCE(sym_function_modifiers, 1),
  [521] = {.count = 1, .reusable = true}, SHIFT(270),
  [523] = {.count = 1, .reusable = true}, SHIFT(272),
  [525] = {.count = 1, .reusable = true}, SHIFT(273),
  [527] = {.count = 1, .reusable = true}, REDUCE(sym_unit_expression, 2),
  [529] = {.count = 1, .reusable = false}, REDUCE(sym_unit_expression, 2),
  [531] = {.count = 1, .reusable = true}, SHIFT(275),
  [533] = {.count = 1, .reusable = true}, SHIFT(274),
  [535] = {.count = 1, .reusable = false}, SHIFT(277),
  [537] = {.count = 1, .reusable = true}, SHIFT(278),
  [539] = {.count = 1, .reusable = false}, SHIFT(66),
  [541] = {.count = 1, .reusable = true}, SHIFT(279),
  [543] = {.count = 1, .reusable = false}, SHIFT(279),
  [545] = {.count = 1, .reusable = true}, SHIFT(281),
  [547] = {.count = 1, .reusable = false}, SHIFT(280),
  [549] = {.count = 1, .reusable = true}, SHIFT(283),
  [551] = {.count = 1, .reusable = true}, SHIFT(284),
  [553] = {.count = 1, .reusable = true}, SHIFT(287),
  [555] = {.count = 1, .reusable = false}, SHIFT(286),
  [557] = {.count = 1, .reusable = false}, SHIFT(289),
  [559] = {.count = 1, .reusable = true}, SHIFT(290),
  [561] = {.count = 1, .reusable = false}, SHIFT(291),
  [563] = {.count = 1, .reusable = false}, SHIFT(292),
  [565] = {.count = 1, .reusable = true}, SHIFT(293),
  [567] = {.count = 1, .reusable = false}, SHIFT(294),
  [569] = {.count = 1, .reusable = true}, SHIFT(295),
  [571] = {.count = 1, .reusable = true}, SHIFT(296),
  [573] = {.count = 1, .reusable = true}, SHIFT(297),
  [575] = {.count = 1, .reusable = false}, SHIFT(298),
  [577] = {.count = 1, .reusable = false}, SHIFT(296),
  [579] = {.count = 1, .reusable = false}, SHIFT(299),
  [581] = {.count = 1, .reusable = false}, SHIFT(300),
  [583] = {.count = 1, .reusable = false}, SHIFT(301),
  [585] = {.count = 1, .reusable = true}, SHIFT(302),
  [587] = {.count = 1, .reusable = false}, SHIFT(303),
  [589] = {.count = 1, .reusable = true}, SHIFT(304),
  [591] = {.count = 1, .reusable = true}, SHIFT(305),
  [593] = {.count = 1, .reusable = true}, SHIFT(306),
  [595] = {.count = 1, .reusable = true}, SHIFT(307),
  [597] = {.count = 1, .reusable = true}, REDUCE(sym_block, 2),
  [599] = {.count = 1, .reusable = false}, REDUCE(sym_block, 2),
  [601] = {.count = 1, .reusable = false}, SHIFT(308),
  [603] = {.count = 1, .reusable = false}, SHIFT(309),
  [605] = {.count = 1, .reusable = true}, SHIFT(310),
  [607] = {.count = 1, .reusable = false}, SHIFT(83),
  [609] = {.count = 1, .reusable = true}, SHIFT(312),
  [611] = {.count = 1, .reusable = false}, SHIFT(311),
  [613] = {.count = 1, .reusable = true}, SHIFT(313),
  [615] = {.count = 1, .reusable = true}, SHIFT(315),
  [617] = {.count = 1, .reusable = false}, SHIFT(316),
  [619] = {.count = 1, .reusable = false}, SHIFT(317),
  [621] = {.count = 1, .reusable = false}, SHIFT(318),
  [623] = {.count = 1, .reusable = true}, SHIFT(319),
  [625] = {.count = 1, .reusable = true}, SHIFT(320),
  [627] = {.count = 1, .reusable = true}, SHIFT(321),
  [629] = {.count = 1, .reusable = false}, SHIFT(322),
  [631] = {.count = 1, .reusable = false}, SHIFT(320),
  [633] = {.count = 1, .reusable = false}, SHIFT(323),
  [635] = {.count = 1, .reusable = false}, SHIFT(324),
  [637] = {.count = 1, .reusable = false}, SHIFT(325),
  [639] = {.count = 1, .reusable = true}, SHIFT(326),
  [641] = {.count = 1, .reusable = false}, SHIFT(327),
  [643] = {.count = 1, .reusable = true}, SHIFT(328),
  [645] = {.count = 1, .reusable = true}, SHIFT(329),
  [647] = {.count = 1, .reusable = true}, SHIFT(330),
  [649] = {.count = 1, .reusable = true}, SHIFT(331),
  [651] = {.count = 1, .reusable = true}, REDUCE(sym_array_expression, 2),
  [653] = {.count = 1, .reusable = false}, REDUCE(sym_array_expression, 2),
  [655] = {.count = 1, .reusable = true}, SHIFT(333),
  [657] = {.count = 1, .reusable = false}, SHIFT(334),
  [659] = {.count = 1, .reusable = true}, SHIFT(335),
  [661] = {.count = 1, .reusable = false}, SHIFT(93),
  [663] = {.count = 1, .reusable = true}, SHIFT(337),
  [665] = {.count = 1, .reusable = false}, SHIFT(336),
  [667] = {.count = 1, .reusable = true}, SHIFT(338),
  [669] = {.count = 1, .reusable = true}, SHIFT(340),
  [671] = {.count = 1, .reusable = false}, SHIFT(341),
  [673] = {.count = 1, .reusable = false}, SHIFT(342),
  [675] = {.count = 1, .reusable = true}, SHIFT(343),
  [677] = {.count = 1, .reusable = false}, SHIFT(344),
  [679] = {.count = 1, .reusable = true}, SHIFT(345),
  [681] = {.count = 1, .reusable = true}, SHIFT(346),
  [683] = {.count = 1, .reusable = true}, SHIFT(347),
  [685] = {.count = 1, .reusable = false}, SHIFT(348),
  [687] = {.count = 1, .reusable = false}, SHIFT(346),
  [689] = {.count = 1, .reusable = false}, SHIFT(349),
  [691] = {.count = 1, .reusable = false}, SHIFT(350),
  [693] = {.count = 1, .reusable = false}, SHIFT(351),
  [695] = {.count = 1, .reusable = true}, SHIFT(352),
  [697] = {.count = 1, .reusable = false}, SHIFT(353),
  [699] = {.count = 1, .reusable = true}, SHIFT(354),
  [701] = {.count = 1, .reusable = true}, SHIFT(355),
  [703] = {.count = 1, .reusable = true}, SHIFT(357),
  [705] = {.count = 1, .reusable = true}, SHIFT(359),
  [707] = {.count = 1, .reusable = false}, SHIFT(358),
  [709] = {.count = 1, .reusable = true}, REDUCE(sym_unary_expression, 2),
  [711] = {.count = 1, .reusable = false}, REDUCE(sym_unary_expression, 2),
  [713] = {.count = 1, .reusable = true}, SHIFT(360),
  [715] = {.count = 1, .reusable = true}, SHIFT(361),
  [717] = {.count = 1, .reusable = true}, REDUCE(sym_reference_expression, 2),
  [719] = {.count = 1, .reusable = false}, REDUCE(sym_reference_expression, 2),
  [721] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_identifier, 2),
  [723] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_type_identifier_in_expression_position, 2, .alias_sequence_id = 2),
  [725] = {.count = 1, .reusable = false}, REDUCE(sym_scoped_identifier, 2),
  [727] = {.count = 1, .reusable = true}, SHIFT(362),
  [729] = {.count = 1, .reusable = true}, SHIFT(364),
  [731] = {.count = 1, .reusable = true}, SHIFT(365),
  [733] = {.count = 1, .reusable = true}, SHIFT(366),
  [735] = {.count = 1, .reusable = true}, SHIFT(367),
  [737] = {.count = 1, .reusable = false}, SHIFT(368),
  [739] = {.count = 1, .reusable = false}, SHIFT(369),
  [741] = {.count = 1, .reusable = true}, SHIFT(374),
  [743] = {.count = 1, .reusable = true}, SHIFT(375),
  [745] = {.count = 1, .reusable = false}, SHIFT(376),
  [747] = {.count = 1, .reusable = false}, SHIFT(377),
  [749] = {.count = 1, .reusable = true}, SHIFT(382),
  [751] = {.count = 1, .reusable = true}, REDUCE(sym__type, 1, .alias_sequence_id = 3),
  [753] = {.count = 1, .reusable = false}, REDUCE(sym__type, 1, .alias_sequence_id = 3),
  [755] = {.count = 1, .reusable = true}, SHIFT(383),
  [757] = {.count = 1, .reusable = false}, SHIFT(384),
  [759] = {.count = 1, .reusable = true}, SHIFT(387),
  [761] = {.count = 1, .reusable = true}, REDUCE(sym_empty_type, 1),
  [763] = {.count = 1, .reusable = true}, SHIFT(388),
  [765] = {.count = 1, .reusable = true}, SHIFT(389),
  [767] = {.count = 1, .reusable = false}, REDUCE(sym_extern_modifier, 1),
  [769] = {.count = 1, .reusable = true}, SHIFT(391),
  [771] = {.count = 1, .reusable = false}, SHIFT(393),
  [773] = {.count = 1, .reusable = true}, REDUCE(sym__type, 1, .alias_sequence_id = 4),
  [775] = {.count = 1, .reusable = true}, SHIFT(396),
  [777] = {.count = 1, .reusable = true}, SHIFT(397),
  [779] = {.count = 1, .reusable = true}, SHIFT(398),
  [781] = {.count = 1, .reusable = true}, SHIFT(401),
  [783] = {.count = 1, .reusable = true}, REDUCE(sym__type, 1),
  [785] = {.count = 1, .reusable = false}, REDUCE(sym__type, 1),
  [787] = {.count = 1, .reusable = false}, SHIFT(402),
  [789] = {.count = 1, .reusable = false}, SHIFT(403),
  [791] = {.count = 1, .reusable = true}, SHIFT(405),
  [793] = {.count = 1, .reusable = true}, SHIFT(406),
  [795] = {.count = 1, .reusable = true}, SHIFT(407),
  [797] = {.count = 1, .reusable = true}, SHIFT(408),
  [799] = {.count = 1, .reusable = true}, SHIFT(409),
  [801] = {.count = 1, .reusable = true}, SHIFT(410),
  [803] = {.count = 1, .reusable = true}, SHIFT(411),
  [805] = {.count = 1, .reusable = false}, REDUCE(sym_function_modifiers, 1),
  [807] = {.count = 1, .reusable = false}, SHIFT(413),
  [809] = {.count = 1, .reusable = true}, SHIFT(420),
  [811] = {.count = 1, .reusable = true}, SHIFT(414),
  [813] = {.count = 1, .reusable = true}, SHIFT(415),
  [815] = {.count = 1, .reusable = false}, SHIFT(420),
  [817] = {.count = 1, .reusable = true}, SHIFT(416),
  [819] = {.count = 1, .reusable = false}, SHIFT(417),
  [821] = {.count = 1, .reusable = false}, SHIFT(418),
  [823] = {.count = 1, .reusable = false}, SHIFT(419),
  [825] = {.count = 1, .reusable = false}, SHIFT(421),
  [827] = {.count = 1, .reusable = true}, SHIFT(422),
  [829] = {.count = 1, .reusable = true}, SHIFT(423),
  [831] = {.count = 1, .reusable = true}, REDUCE(sym__pattern, 1),
  [833] = {.count = 1, .reusable = true}, SHIFT(428),
  [835] = {.count = 1, .reusable = true}, SHIFT(424),
  [837] = {.count = 1, .reusable = false}, SHIFT(428),
  [839] = {.count = 1, .reusable = true}, SHIFT(425),
  [841] = {.count = 1, .reusable = false}, SHIFT(426),
  [843] = {.count = 1, .reusable = false}, SHIFT(427),
  [845] = {.count = 1, .reusable = true}, SHIFT(430),
  [847] = {.count = 1, .reusable = true}, REDUCE(sym_closure_parameters, 2),
  [849] = {.count = 1, .reusable = false}, REDUCE(sym_closure_parameters, 2),
  [851] = {.count = 1, .reusable = true}, REDUCE(sym_remaining_field_pattern, 1),
  [853] = {.count = 1, .reusable = true}, SHIFT(421),
  [855] = {.count = 1, .reusable = true}, SHIFT(438),
  [857] = {.count = 1, .reusable = false}, SHIFT(431),
  [859] = {.count = 1, .reusable = false}, SHIFT(432),
  [861] = {.count = 1, .reusable = true}, SHIFT(433),
  [863] = {.count = 1, .reusable = false}, SHIFT(434),
  [865] = {.count = 1, .reusable = false}, SHIFT(435),
  [867] = {.count = 1, .reusable = false}, SHIFT(436),
  [869] = {.count = 1, .reusable = false}, SHIFT(437),
  [871] = {.count = 1, .reusable = true}, SHIFT(441),
  [873] = {.count = 1, .reusable = false}, SHIFT(441),
  [875] = {.count = 1, .reusable = false}, SHIFT(440),
  [877] = {.count = 1, .reusable = true}, SHIFT(443),
  [879] = {.count = 1, .reusable = true}, SHIFT(442),
  [881] = {.count = 1, .reusable = true}, SHIFT(444),
  [883] = {.count = 1, .reusable = true}, SHIFT(445),
  [885] = {.count = 1, .reusable = false}, SHIFT(423),
  [887] = {.count = 1, .reusable = true}, SHIFT(446),
  [889] = {.count = 1, .reusable = true}, SHIFT(447),
  [891] = {.count = 1, .reusable = true}, SHIFT(448),
  [893] = {.count = 1, .reusable = true}, SHIFT(449),
  [895] = {.count = 1, .reusable = true}, SHIFT(450),
  [897] = {.count = 1, .reusable = true}, SHIFT(452),
  [899] = {.count = 1, .reusable = false}, REDUCE(sym__pattern, 1),
  [901] = {.count = 1, .reusable = true}, SHIFT(453),
  [903] = {.count = 1, .reusable = true}, SHIFT(454),
  [905] = {.count = 1, .reusable = true}, REDUCE(sym_loop_label, 2),
  [907] = {.count = 1, .reusable = false}, REDUCE(sym_loop_label, 2),
  [909] = {.count = 1, .reusable = true}, REDUCE(sym_range_expression, 2),
  [911] = {.count = 1, .reusable = false}, REDUCE(sym_range_expression, 2),
  [913] = {.count = 1, .reusable = true}, REDUCE(sym_break_expression, 2),
  [915] = {.count = 1, .reusable = false}, REDUCE(sym_break_expression, 2),
  [917] = {.count = 1, .reusable = true}, SHIFT(455),
  [919] = {.count = 1, .reusable = true}, REDUCE(sym_continue_expression, 2),
  [921] = {.count = 1, .reusable = false}, REDUCE(sym_continue_expression, 2),
  [923] = {.count = 1, .reusable = true}, SHIFT(456),
  [925] = {.count = 1, .reusable = true}, SHIFT(457),
  [927] = {.count = 1, .reusable = true}, SHIFT(458),
  [929] = {.count = 1, .reusable = false}, SHIFT(464),
  [931] = {.count = 1, .reusable = false}, SHIFT(438),
  [933] = {.count = 1, .reusable = true}, SHIFT(465),
  [935] = {.count = 1, .reusable = true}, SHIFT(466),
  [937] = {.count = 1, .reusable = true}, SHIFT(467),
  [939] = {.count = 1, .reusable = false}, SHIFT(468),
  [941] = {.count = 1, .reusable = true}, SHIFT(469),
  [943] = {.count = 1, .reusable = true}, SHIFT(470),
  [945] = {.count = 1, .reusable = false}, SHIFT(167),
  [947] = {.count = 1, .reusable = true}, SHIFT(472),
  [949] = {.count = 1, .reusable = false}, SHIFT(471),
  [951] = {.count = 1, .reusable = true}, SHIFT(477),
  [953] = {.count = 1, .reusable = false}, SHIFT(477),
  [955] = {.count = 1, .reusable = true}, SHIFT(473),
  [957] = {.count = 1, .reusable = false}, SHIFT(474),
  [959] = {.count = 1, .reusable = false}, SHIFT(475),
  [961] = {.count = 1, .reusable = false}, SHIFT(476),
  [963] = {.count = 1, .reusable = true}, SHIFT(478),
  [965] = {.count = 1, .reusable = true}, SHIFT(480),
  [967] = {.count = 1, .reusable = true}, SHIFT(481),
  [969] = {.count = 1, .reusable = true}, SHIFT(482),
  [971] = {.count = 1, .reusable = false}, SHIFT(483),
  [973] = {.count = 1, .reusable = false}, SHIFT(484),
  [975] = {.count = 1, .reusable = false}, SHIFT(485),
  [977] = {.count = 1, .reusable = true}, SHIFT(486),
  [979] = {.count = 1, .reusable = true}, SHIFT(487),
  [981] = {.count = 1, .reusable = true}, SHIFT(488),
  [983] = {.count = 1, .reusable = false}, SHIFT(489),
  [985] = {.count = 1, .reusable = false}, SHIFT(487),
  [987] = {.count = 1, .reusable = false}, SHIFT(490),
  [989] = {.count = 1, .reusable = false}, SHIFT(491),
  [991] = {.count = 1, .reusable = false}, SHIFT(492),
  [993] = {.count = 1, .reusable = true}, SHIFT(493),
  [995] = {.count = 1, .reusable = false}, SHIFT(494),
  [997] = {.count = 1, .reusable = true}, SHIFT(495),
  [999] = {.count = 1, .reusable = true}, SHIFT(496),
  [1001] = {.count = 1, .reusable = true}, SHIFT(498),
  [1003] = {.count = 1, .reusable = true}, SHIFT(499),
  [1005] = {.count = 1, .reusable = true}, SHIFT(500),
  [1007] = {.count = 1, .reusable = false}, SHIFT(501),
  [1009] = {.count = 1, .reusable = true}, SHIFT(502),
  [1011] = {.count = 1, .reusable = true}, SHIFT(506),
  [1013] = {.count = 1, .reusable = false}, SHIFT(511),
  [1015] = {.count = 1, .reusable = false}, SHIFT(517),
  [1017] = {.count = 1, .reusable = true}, SHIFT(519),
  [1019] = {.count = 1, .reusable = false}, SHIFT(519),
  [1021] = {.count = 1, .reusable = false}, SHIFT(518),
  [1023] = {.count = 1, .reusable = true}, SHIFT(520),
  [1025] = {.count = 1, .reusable = true}, SHIFT(521),
  [1027] = {.count = 1, .reusable = true}, SHIFT(522),
  [1029] = {.count = 1, .reusable = true}, SHIFT(523),
  [1031] = {.count = 1, .reusable = true}, REDUCE(sym_loop_expression, 2),
  [1033] = {.count = 1, .reusable = false}, REDUCE(sym_loop_expression, 2),
  [1035] = {.count = 1, .reusable = true}, SHIFT(524),
  [1037] = {.count = 1, .reusable = true}, SHIFT(525),
  [1039] = {.count = 1, .reusable = true}, SHIFT(526),
  [1041] = {.count = 1, .reusable = true}, SHIFT(527),
  [1043] = {.count = 1, .reusable = true}, REDUCE(sym_return_expression, 2),
  [1045] = {.count = 1, .reusable = false}, REDUCE(sym_return_expression, 2),
  [1047] = {.count = 1, .reusable = true}, SHIFT(528),
  [1049] = {.count = 1, .reusable = true}, SHIFT(529),
  [1051] = {.count = 1, .reusable = true}, SHIFT(530),
  [1053] = {.count = 1, .reusable = true}, SHIFT(531),
  [1055] = {.count = 1, .reusable = true}, SHIFT(532),
  [1057] = {.count = 1, .reusable = true}, SHIFT(533),
  [1059] = {.count = 1, .reusable = true}, SHIFT(537),
  [1061] = {.count = 1, .reusable = true}, SHIFT(538),
  [1063] = {.count = 1, .reusable = true}, SHIFT(542),
  [1065] = {.count = 1, .reusable = true}, SHIFT(543),
  [1067] = {.count = 1, .reusable = true}, SHIFT(544),
  [1069] = {.count = 1, .reusable = true}, SHIFT(547),
  [1071] = {.count = 1, .reusable = true}, REDUCE(sym_unsafe_block, 2),
  [1073] = {.count = 1, .reusable = false}, REDUCE(sym_unsafe_block, 2),
  [1075] = {.count = 1, .reusable = true}, SHIFT(552),
  [1077] = {.count = 1, .reusable = true}, SHIFT(553),
  [1079] = {.count = 1, .reusable = false}, SHIFT(554),
  [1081] = {.count = 1, .reusable = true}, SHIFT(555),
  [1083] = {.count = 1, .reusable = false}, SHIFT(556),
  [1085] = {.count = 1, .reusable = false}, SHIFT(557),
  [1087] = {.count = 1, .reusable = true}, SHIFT(557),
  [1089] = {.count = 1, .reusable = true}, REDUCE(sym__use_clause, 1, .alias_sequence_id = 1),
  [1091] = {.count = 1, .reusable = true}, SHIFT(560),
  [1093] = {.count = 1, .reusable = true}, SHIFT(561),
  [1095] = {.count = 1, .reusable = true}, REDUCE(sym__use_clause, 1),
  [1097] = {.count = 1, .reusable = true}, SHIFT(563),
  [1099] = {.count = 1, .reusable = true}, SHIFT(564),
  [1101] = {.count = 1, .reusable = true}, SHIFT(565),
  [1103] = {.count = 1, .reusable = true}, SHIFT(566),
  [1105] = {.count = 1, .reusable = true}, SHIFT(567),
  [1107] = {.count = 1, .reusable = true}, SHIFT(568),
  [1109] = {.count = 1, .reusable = true}, SHIFT(569),
  [1111] = {.count = 1, .reusable = false}, SHIFT(569),
  [1113] = {.count = 1, .reusable = true}, SHIFT(571),
  [1115] = {.count = 1, .reusable = true}, REDUCE(sym_extern_modifier, 2),
  [1117] = {.count = 1, .reusable = true}, SHIFT(573),
  [1119] = {.count = 1, .reusable = true}, SHIFT(572),
  [1121] = {.count = 1, .reusable = true}, REDUCE(sym_string_literal, 2),
  [1123] = {.count = 1, .reusable = false}, REDUCE(sym_string_literal, 2),
  [1125] = {.count = 1, .reusable = true}, SHIFT(575),
  [1127] = {.count = 1, .reusable = true}, SHIFT(574),
  [1129] = {.count = 1, .reusable = true}, SHIFT(576),
  [1131] = {.count = 1, .reusable = true}, SHIFT(577),
  [1133] = {.count = 1, .reusable = true}, SHIFT(578),
  [1135] = {.count = 1, .reusable = true}, SHIFT(579),
  [1137] = {.count = 1, .reusable = true}, SHIFT(580),
  [1139] = {.count = 1, .reusable = true}, SHIFT(583),
  [1141] = {.count = 1, .reusable = true}, SHIFT(584),
  [1143] = {.count = 1, .reusable = true}, SHIFT(586),
  [1145] = {.count = 1, .reusable = true}, SHIFT(587),
  [1147] = {.count = 1, .reusable = true}, SHIFT(588),
  [1149] = {.count = 1, .reusable = true}, REDUCE(sym_struct_expression, 2, .alias_sequence_id = 4),
  [1151] = {.count = 1, .reusable = false}, REDUCE(sym_struct_expression, 2, .alias_sequence_id = 4),
  [1153] = {.count = 1, .reusable = true}, SHIFT(590),
  [1155] = {.count = 1, .reusable = true}, REDUCE(sym_foreign_mod_item, 2),
  [1157] = {.count = 1, .reusable = false}, REDUCE(sym_foreign_mod_item, 2),
  [1159] = {.count = 1, .reusable = true}, SHIFT(591),
  [1161] = {.count = 1, .reusable = true}, SHIFT(592),
  [1163] = {.count = 1, .reusable = true}, SHIFT(593),
  [1165] = {.count = 1, .reusable = true}, SHIFT(594),
  [1167] = {.count = 1, .reusable = false}, SHIFT(595),
  [1169] = {.count = 1, .reusable = false}, SHIFT(62),
  [1171] = {.count = 1, .reusable = false}, SHIFT(596),
  [1173] = {.count = 1, .reusable = false}, SHIFT(597),
  [1175] = {.count = 1, .reusable = false}, SHIFT(598),
  [1177] = {.count = 1, .reusable = false}, SHIFT(599),
  [1179] = {.count = 1, .reusable = false}, SHIFT(600),
  [1181] = {.count = 1, .reusable = false}, SHIFT(601),
  [1183] = {.count = 1, .reusable = false}, SHIFT(602),
  [1185] = {.count = 1, .reusable = false}, SHIFT(603),
  [1187] = {.count = 1, .reusable = false}, SHIFT(604),
  [1189] = {.count = 1, .reusable = false}, SHIFT(605),
  [1191] = {.count = 1, .reusable = false}, SHIFT(606),
  [1193] = {.count = 1, .reusable = false}, SHIFT(607),
  [1195] = {.count = 1, .reusable = false}, SHIFT(608),
  [1197] = {.count = 1, .reusable = false}, SHIFT(609),
  [1199] = {.count = 1, .reusable = false}, SHIFT(614),
  [1201] = {.count = 1, .reusable = true}, SHIFT(615),
  [1203] = {.count = 1, .reusable = true}, SHIFT(616),
  [1205] = {.count = 1, .reusable = false}, SHIFT(617),
  [1207] = {.count = 1, .reusable = false}, SHIFT(528),
  [1209] = {.count = 1, .reusable = true}, SHIFT(618),
  [1211] = {.count = 1, .reusable = true}, SHIFT(619),
  [1213] = {.count = 1, .reusable = true}, SHIFT(620),
  [1215] = {.count = 1, .reusable = true}, SHIFT(621),
  [1217] = {.count = 1, .reusable = true}, SHIFT(623),
  [1219] = {.count = 1, .reusable = true}, SHIFT(624),
  [1221] = {.count = 1, .reusable = true}, SHIFT(625),
  [1223] = {.count = 1, .reusable = true}, SHIFT(626),
  [1225] = {.count = 1, .reusable = true}, SHIFT(627),
  [1227] = {.count = 1, .reusable = true}, REDUCE(sym_struct_expression, 2),
  [1229] = {.count = 1, .reusable = false}, REDUCE(sym_struct_expression, 2),
  [1231] = {.count = 1, .reusable = true}, REDUCE(sym__expression_statement, 2),
  [1233] = {.count = 1, .reusable = false}, REDUCE(sym__expression_statement, 2),
  [1235] = {.count = 1, .reusable = true}, SHIFT(630),
  [1237] = {.count = 1, .reusable = true}, SHIFT(628),
  [1239] = {.count = 1, .reusable = true}, SHIFT(629),
  [1241] = {.count = 1, .reusable = true}, SHIFT(637),
  [1243] = {.count = 1, .reusable = true}, SHIFT(631),
  [1245] = {.count = 1, .reusable = true}, SHIFT(632),
  [1247] = {.count = 1, .reusable = true}, SHIFT(633),
  [1249] = {.count = 1, .reusable = false}, SHIFT(634),
  [1251] = {.count = 1, .reusable = false}, SHIFT(635),
  [1253] = {.count = 1, .reusable = false}, SHIFT(636),
  [1255] = {.count = 1, .reusable = true}, SHIFT(639),
  [1257] = {.count = 1, .reusable = true}, SHIFT(640),
  [1259] = {.count = 1, .reusable = true}, SHIFT(641),
  [1261] = {.count = 1, .reusable = true}, SHIFT(642),
  [1263] = {.count = 1, .reusable = true}, SHIFT(643),
  [1265] = {.count = 1, .reusable = true}, SHIFT(644),
  [1267] = {.count = 1, .reusable = true}, SHIFT(645),
  [1269] = {.count = 1, .reusable = true}, SHIFT(646),
  [1271] = {.count = 1, .reusable = true}, SHIFT(647),
  [1273] = {.count = 1, .reusable = true}, SHIFT(648),
  [1275] = {.count = 1, .reusable = true}, SHIFT(649),
  [1277] = {.count = 1, .reusable = true}, SHIFT(650),
  [1279] = {.count = 1, .reusable = true}, SHIFT(651),
  [1281] = {.count = 1, .reusable = true}, REDUCE(sym_try_expression, 2),
  [1283] = {.count = 1, .reusable = false}, REDUCE(sym_try_expression, 2),
  [1285] = {.count = 1, .reusable = true}, SHIFT(652),
  [1287] = {.count = 1, .reusable = true}, SHIFT(653),
  [1289] = {.count = 1, .reusable = true}, SHIFT(654),
  [1291] = {.count = 1, .reusable = true}, SHIFT(655),
  [1293] = {.count = 1, .reusable = false}, SHIFT(656),
  [1295] = {.count = 1, .reusable = true}, SHIFT(657),
  [1297] = {.count = 1, .reusable = true}, SHIFT(658),
  [1299] = {.count = 1, .reusable = true}, SHIFT(659),
  [1301] = {.count = 1, .reusable = false}, SHIFT(660),
  [1303] = {.count = 1, .reusable = false}, SHIFT(661),
  [1305] = {.count = 1, .reusable = false}, SHIFT(662),
  [1307] = {.count = 1, .reusable = false}, SHIFT(663),
  [1309] = {.count = 1, .reusable = true}, SHIFT(664),
  [1311] = {.count = 1, .reusable = true}, REDUCE(sym_call_expression, 2),
  [1313] = {.count = 1, .reusable = false}, REDUCE(sym_call_expression, 2),
  [1315] = {.count = 1, .reusable = true}, SHIFT(673),
  [1317] = {.count = 1, .reusable = true}, SHIFT(674),
  [1319] = {.count = 1, .reusable = false}, SHIFT(675),
  [1321] = {.count = 1, .reusable = false}, SHIFT(676),
  [1323] = {.count = 1, .reusable = true}, REDUCE(sym_closure_expression, 2),
  [1325] = {.count = 1, .reusable = true}, SHIFT(681),
  [1327] = {.count = 1, .reusable = true}, SHIFT(682),
  [1329] = {.count = 1, .reusable = true}, SHIFT(683),
  [1331] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(52),
  [1334] = {.count = 1, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2),
  [1336] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2),
  [1339] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(3),
  [1342] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(4),
  [1345] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(5),
  [1348] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(6),
  [1351] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(7),
  [1354] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(8),
  [1357] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(9),
  [1360] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(10),
  [1363] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(11),
  [1366] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(12),
  [1369] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(13),
  [1372] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(14),
  [1375] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(15),
  [1378] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(16),
  [1381] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(17),
  [1384] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(18),
  [1387] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(19),
  [1390] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(20),
  [1393] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(21),
  [1396] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(22),
  [1399] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(23),
  [1402] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(24),
  [1405] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(25),
  [1408] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(26),
  [1411] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(27),
  [1414] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(28),
  [1417] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(29),
  [1420] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(30),
  [1423] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(31),
  [1426] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(32),
  [1429] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(33),
  [1432] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(34),
  [1435] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(35),
  [1438] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(36),
  [1441] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(37),
  [1444] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(38),
  [1447] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(39),
  [1450] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(40),
  [1453] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(41),
  [1456] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(42),
  [1459] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(43),
  [1462] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(44),
  [1465] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(45),
  [1468] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(44),
  [1471] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_modifiers_repeat1, 2), SHIFT_REPEAT(271),
  [1474] = {.count = 1, .reusable = true}, REDUCE(aux_sym_function_modifiers_repeat1, 2),
  [1476] = {.count = 2, .reusable = true}, REDUCE(aux_sym_function_modifiers_repeat1, 2), SHIFT_REPEAT(270),
  [1479] = {.count = 1, .reusable = true}, SHIFT(685),
  [1481] = {.count = 1, .reusable = true}, SHIFT(686),
  [1483] = {.count = 1, .reusable = true}, SHIFT(687),
  [1485] = {.count = 1, .reusable = true}, SHIFT(688),
  [1487] = {.count = 1, .reusable = true}, SHIFT(692),
  [1489] = {.count = 1, .reusable = true}, SHIFT(695),
  [1491] = {.count = 1, .reusable = true}, SHIFT(696),
  [1493] = {.count = 1, .reusable = true}, SHIFT(697),
  [1495] = {.count = 1, .reusable = true}, SHIFT(698),
  [1497] = {.count = 1, .reusable = false}, SHIFT(698),
  [1499] = {.count = 1, .reusable = true}, SHIFT(700),
  [1501] = {.count = 1, .reusable = true}, SHIFT(701),
  [1503] = {.count = 1, .reusable = false}, SHIFT(701),
  [1505] = {.count = 1, .reusable = true}, SHIFT(703),
  [1507] = {.count = 1, .reusable = true}, SHIFT(704),
  [1509] = {.count = 1, .reusable = true}, SHIFT(705),
  [1511] = {.count = 1, .reusable = true}, SHIFT(706),
  [1513] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [1515] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [1517] = {.count = 1, .reusable = true}, SHIFT(708),
  [1519] = {.count = 1, .reusable = true}, SHIFT(710),
  [1521] = {.count = 1, .reusable = true}, SHIFT(709),
  [1523] = {.count = 1, .reusable = true}, SHIFT(712),
  [1525] = {.count = 1, .reusable = true}, SHIFT(713),
  [1527] = {.count = 1, .reusable = true}, SHIFT(714),
  [1529] = {.count = 1, .reusable = true}, SHIFT(715),
  [1531] = {.count = 1, .reusable = true}, SHIFT(716),
  [1533] = {.count = 1, .reusable = true}, SHIFT(717),
  [1535] = {.count = 1, .reusable = true}, SHIFT(718),
  [1537] = {.count = 1, .reusable = true}, SHIFT(719),
  [1539] = {.count = 1, .reusable = true}, SHIFT(720),
  [1541] = {.count = 1, .reusable = true}, SHIFT(721),
  [1543] = {.count = 1, .reusable = true}, SHIFT(722),
  [1545] = {.count = 1, .reusable = true}, SHIFT(723),
  [1547] = {.count = 1, .reusable = false}, SHIFT(724),
  [1549] = {.count = 1, .reusable = false}, SHIFT(725),
  [1551] = {.count = 1, .reusable = true}, SHIFT(729),
  [1553] = {.count = 1, .reusable = true}, SHIFT(730),
  [1555] = {.count = 1, .reusable = true}, SHIFT(731),
  [1557] = {.count = 1, .reusable = true}, SHIFT(733),
  [1559] = {.count = 1, .reusable = false}, SHIFT(732),
  [1561] = {.count = 1, .reusable = true}, SHIFT(734),
  [1563] = {.count = 1, .reusable = false}, SHIFT(734),
  [1565] = {.count = 1, .reusable = true}, SHIFT(736),
  [1567] = {.count = 1, .reusable = true}, REDUCE(sym_block, 3),
  [1569] = {.count = 1, .reusable = false}, REDUCE(sym_block, 3),
  [1571] = {.count = 1, .reusable = true}, SHIFT(737),
  [1573] = {.count = 1, .reusable = true}, SHIFT(738),
  [1575] = {.count = 1, .reusable = true}, SHIFT(739),
  [1577] = {.count = 1, .reusable = true}, SHIFT(740),
  [1579] = {.count = 1, .reusable = true}, SHIFT(741),
  [1581] = {.count = 1, .reusable = true}, SHIFT(742),
  [1583] = {.count = 1, .reusable = true}, SHIFT(743),
  [1585] = {.count = 1, .reusable = true}, SHIFT(744),
  [1587] = {.count = 1, .reusable = true}, SHIFT(745),
  [1589] = {.count = 1, .reusable = true}, SHIFT(746),
  [1591] = {.count = 1, .reusable = true}, SHIFT(747),
  [1593] = {.count = 1, .reusable = true}, SHIFT(748),
  [1595] = {.count = 1, .reusable = true}, SHIFT(749),
  [1597] = {.count = 1, .reusable = false}, SHIFT(750),
  [1599] = {.count = 1, .reusable = false}, SHIFT(751),
  [1601] = {.count = 1, .reusable = true}, SHIFT(755),
  [1603] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(86),
  [1606] = {.count = 1, .reusable = true}, REDUCE(sym_array_expression, 3),
  [1608] = {.count = 1, .reusable = false}, REDUCE(sym_array_expression, 3),
  [1610] = {.count = 1, .reusable = true}, SHIFT(757),
  [1612] = {.count = 1, .reusable = false}, SHIFT(757),
  [1614] = {.count = 1, .reusable = true}, SHIFT(759),
  [1616] = {.count = 1, .reusable = true}, SHIFT(760),
  [1618] = {.count = 1, .reusable = true}, SHIFT(761),
  [1620] = {.count = 1, .reusable = true}, SHIFT(769),
  [1622] = {.count = 1, .reusable = true}, SHIFT(762),
  [1624] = {.count = 1, .reusable = true}, SHIFT(763),
  [1626] = {.count = 1, .reusable = true}, SHIFT(764),
  [1628] = {.count = 1, .reusable = true}, SHIFT(765),
  [1630] = {.count = 1, .reusable = false}, SHIFT(766),
  [1632] = {.count = 1, .reusable = false}, SHIFT(767),
  [1634] = {.count = 1, .reusable = false}, SHIFT(768),
  [1636] = {.count = 1, .reusable = true}, SHIFT(771),
  [1638] = {.count = 1, .reusable = true}, SHIFT(772),
  [1640] = {.count = 1, .reusable = true}, SHIFT(773),
  [1642] = {.count = 1, .reusable = true}, SHIFT(774),
  [1644] = {.count = 1, .reusable = true}, SHIFT(775),
  [1646] = {.count = 1, .reusable = true}, SHIFT(776),
  [1648] = {.count = 1, .reusable = true}, SHIFT(777),
  [1650] = {.count = 1, .reusable = true}, SHIFT(778),
  [1652] = {.count = 1, .reusable = true}, SHIFT(779),
  [1654] = {.count = 1, .reusable = true}, SHIFT(780),
  [1656] = {.count = 1, .reusable = true}, SHIFT(781),
  [1658] = {.count = 1, .reusable = true}, SHIFT(782),
  [1660] = {.count = 1, .reusable = false}, SHIFT(783),
  [1662] = {.count = 1, .reusable = false}, SHIFT(784),
  [1664] = {.count = 1, .reusable = true}, SHIFT(788),
  [1666] = {.count = 1, .reusable = true}, SHIFT(790),
  [1668] = {.count = 1, .reusable = false}, SHIFT(790),
  [1670] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_identifier, 3, .alias_sequence_id = 1),
  [1672] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_type_identifier_in_expression_position, 3, .alias_sequence_id = 5),
  [1674] = {.count = 1, .reusable = false}, REDUCE(sym_scoped_identifier, 3, .alias_sequence_id = 1),
  [1676] = {.count = 1, .reusable = true}, REDUCE(sym_reference_expression, 3),
  [1678] = {.count = 1, .reusable = false}, REDUCE(sym_reference_expression, 3),
  [1680] = {.count = 1, .reusable = true}, SHIFT(792),
  [1682] = {.count = 1, .reusable = true}, REDUCE(sym_meta_item, 1),
  [1684] = {.count = 1, .reusable = true}, SHIFT(793),
  [1686] = {.count = 1, .reusable = true}, SHIFT(794),
  [1688] = {.count = 1, .reusable = true}, REDUCE(sym_unit_type, 2),
  [1690] = {.count = 1, .reusable = true}, SHIFT(796),
  [1692] = {.count = 1, .reusable = false}, SHIFT(797),
  [1694] = {.count = 1, .reusable = false}, SHIFT(801),
  [1696] = {.count = 1, .reusable = false}, SHIFT(802),
  [1698] = {.count = 1, .reusable = true}, SHIFT(804),
  [1700] = {.count = 1, .reusable = true}, SHIFT(805),
  [1702] = {.count = 1, .reusable = true}, SHIFT(806),
  [1704] = {.count = 1, .reusable = true}, SHIFT(808),
  [1706] = {.count = 1, .reusable = true}, SHIFT(809),
  [1708] = {.count = 1, .reusable = false}, SHIFT(810),
  [1710] = {.count = 1, .reusable = false}, SHIFT(814),
  [1712] = {.count = 1, .reusable = false}, SHIFT(815),
  [1714] = {.count = 1, .reusable = true}, SHIFT(817),
  [1716] = {.count = 1, .reusable = true}, SHIFT(818),
  [1718] = {.count = 1, .reusable = true}, SHIFT(819),
  [1720] = {.count = 1, .reusable = true}, SHIFT(820),
  [1722] = {.count = 1, .reusable = true}, SHIFT(822),
  [1724] = {.count = 1, .reusable = true}, REDUCE(sym_reference_type, 2),
  [1726] = {.count = 1, .reusable = false}, SHIFT(824),
  [1728] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_type_identifier, 2, .alias_sequence_id = 2),
  [1730] = {.count = 1, .reusable = false}, REDUCE(sym_scoped_type_identifier, 2, .alias_sequence_id = 2),
  [1732] = {.count = 1, .reusable = true}, REDUCE(sym_lifetime, 2),
  [1734] = {.count = 1, .reusable = false}, REDUCE(sym_lifetime, 2),
  [1736] = {.count = 1, .reusable = true}, SHIFT(825),
  [1738] = {.count = 1, .reusable = true}, SHIFT(826),
  [1740] = {.count = 1, .reusable = false}, SHIFT(827),
  [1742] = {.count = 1, .reusable = false}, SHIFT(828),
  [1744] = {.count = 1, .reusable = true}, SHIFT(829),
  [1746] = {.count = 1, .reusable = true}, SHIFT(830),
  [1748] = {.count = 1, .reusable = false}, SHIFT(831),
  [1750] = {.count = 1, .reusable = false}, SHIFT(832),
  [1752] = {.count = 1, .reusable = false}, SHIFT(833),
  [1754] = {.count = 1, .reusable = false}, SHIFT(834),
  [1756] = {.count = 1, .reusable = false}, SHIFT(835),
  [1758] = {.count = 1, .reusable = false}, SHIFT(836),
  [1760] = {.count = 1, .reusable = true}, REDUCE(sym_function_type, 2),
  [1762] = {.count = 1, .reusable = true}, SHIFT(841),
  [1764] = {.count = 1, .reusable = true}, SHIFT(843),
  [1766] = {.count = 1, .reusable = true}, SHIFT(842),
  [1768] = {.count = 1, .reusable = false}, REDUCE(sym_extern_modifier, 2),
  [1770] = {.count = 1, .reusable = true}, REDUCE(sym_dynamic_type, 2, .alias_sequence_id = 2),
  [1772] = {.count = 1, .reusable = false}, REDUCE(sym_dynamic_type, 2, .alias_sequence_id = 2),
  [1774] = {.count = 1, .reusable = true}, REDUCE(sym_dynamic_type, 2),
  [1776] = {.count = 1, .reusable = false}, REDUCE(sym_dynamic_type, 2),
  [1778] = {.count = 1, .reusable = true}, SHIFT(844),
  [1780] = {.count = 1, .reusable = true}, SHIFT(846),
  [1782] = {.count = 1, .reusable = true}, SHIFT(847),
  [1784] = {.count = 1, .reusable = true}, SHIFT(848),
  [1786] = {.count = 1, .reusable = true}, SHIFT(850),
  [1788] = {.count = 1, .reusable = true}, SHIFT(851),
  [1790] = {.count = 1, .reusable = false}, SHIFT(852),
  [1792] = {.count = 1, .reusable = false}, SHIFT(853),
  [1794] = {.count = 1, .reusable = true}, REDUCE(sym_function_type, 2, .alias_sequence_id = 4),
  [1796] = {.count = 1, .reusable = true}, SHIFT(859),
  [1798] = {.count = 1, .reusable = true}, REDUCE(sym_generic_type, 2, .alias_sequence_id = 4),
  [1800] = {.count = 1, .reusable = false}, REDUCE(sym_generic_type, 2, .alias_sequence_id = 4),
  [1802] = {.count = 1, .reusable = true}, REDUCE(sym_bracketed_type, 3),
  [1804] = {.count = 1, .reusable = true}, SHIFT(863),
  [1806] = {.count = 1, .reusable = true}, SHIFT(864),
  [1808] = {.count = 1, .reusable = false}, SHIFT(865),
  [1810] = {.count = 1, .reusable = false}, SHIFT(866),
  [1812] = {.count = 1, .reusable = true}, SHIFT(871),
  [1814] = {.count = 1, .reusable = true}, SHIFT(872),
  [1816] = {.count = 1, .reusable = true}, REDUCE(sym_generic_type, 2),
  [1818] = {.count = 1, .reusable = false}, REDUCE(sym_generic_type, 2),
  [1820] = {.count = 1, .reusable = false}, REDUCE(aux_sym_function_modifiers_repeat1, 2),
  [1822] = {.count = 2, .reusable = false}, REDUCE(aux_sym_function_modifiers_repeat1, 2), SHIFT_REPEAT(413),
  [1825] = {.count = 2, .reusable = false}, REDUCE(aux_sym_function_modifiers_repeat1, 2), SHIFT_REPEAT(119),
  [1828] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_pattern, 2),
  [1830] = {.count = 1, .reusable = true}, SHIFT(874),
  [1832] = {.count = 1, .reusable = false}, SHIFT(875),
  [1834] = {.count = 1, .reusable = true}, SHIFT(876),
  [1836] = {.count = 1, .reusable = true}, SHIFT(877),
  [1838] = {.count = 1, .reusable = true}, SHIFT(879),
  [1840] = {.count = 1, .reusable = true}, SHIFT(880),
  [1842] = {.count = 1, .reusable = false}, SHIFT(881),
  [1844] = {.count = 1, .reusable = false}, SHIFT(882),
  [1846] = {.count = 1, .reusable = true}, SHIFT(888),
  [1848] = {.count = 1, .reusable = true}, SHIFT(891),
  [1850] = {.count = 1, .reusable = true}, SHIFT(892),
  [1852] = {.count = 1, .reusable = true}, SHIFT(893),
  [1854] = {.count = 1, .reusable = false}, SHIFT(894),
  [1856] = {.count = 1, .reusable = false}, SHIFT(896),
  [1858] = {.count = 1, .reusable = true}, SHIFT(898),
  [1860] = {.count = 1, .reusable = false}, SHIFT(898),
  [1862] = {.count = 1, .reusable = false}, SHIFT(897),
  [1864] = {.count = 1, .reusable = false}, REDUCE(sym_reference_pattern_in_parameter, 2),
  [1866] = {.count = 1, .reusable = true}, REDUCE(sym_reference_pattern_in_parameter, 2),
  [1868] = {.count = 1, .reusable = true}, REDUCE(sym_reference_pattern, 2),
  [1870] = {.count = 1, .reusable = false}, SHIFT(900),
  [1872] = {.count = 1, .reusable = true}, SHIFT(901),
  [1874] = {.count = 1, .reusable = true}, SHIFT(902),
  [1876] = {.count = 1, .reusable = false}, SHIFT(903),
  [1878] = {.count = 1, .reusable = false}, SHIFT(904),
  [1880] = {.count = 1, .reusable = true}, SHIFT(900),
  [1882] = {.count = 1, .reusable = false}, SHIFT(901),
  [1884] = {.count = 1, .reusable = true}, REDUCE(sym_mut_pattern, 2),
  [1886] = {.count = 1, .reusable = true}, REDUCE(sym_ref_pattern, 2),
  [1888] = {.count = 1, .reusable = true}, SHIFT(905),
  [1890] = {.count = 1, .reusable = true}, SHIFT(908),
  [1892] = {.count = 1, .reusable = true}, SHIFT(906),
  [1894] = {.count = 1, .reusable = true}, SHIFT(907),
  [1896] = {.count = 1, .reusable = false}, SHIFT(908),
  [1898] = {.count = 1, .reusable = true}, SHIFT(909),
  [1900] = {.count = 1, .reusable = true}, SHIFT(910),
  [1902] = {.count = 1, .reusable = false}, SHIFT(911),
  [1904] = {.count = 1, .reusable = false}, SHIFT(912),
  [1906] = {.count = 1, .reusable = false}, SHIFT(913),
  [1908] = {.count = 1, .reusable = true}, SHIFT(915),
  [1910] = {.count = 1, .reusable = true}, SHIFT(916),
  [1912] = {.count = 1, .reusable = false}, SHIFT(916),
  [1914] = {.count = 1, .reusable = true}, SHIFT(917),
  [1916] = {.count = 1, .reusable = true}, REDUCE(sym_closure_parameters, 3),
  [1918] = {.count = 1, .reusable = false}, REDUCE(sym_closure_parameters, 3),
  [1920] = {.count = 1, .reusable = true}, SHIFT(919),
  [1922] = {.count = 1, .reusable = true}, SHIFT(921),
  [1924] = {.count = 1, .reusable = true}, SHIFT(922),
  [1926] = {.count = 1, .reusable = true}, SHIFT(923),
  [1928] = {.count = 1, .reusable = true}, SHIFT(925),
  [1930] = {.count = 1, .reusable = true}, SHIFT(926),
  [1932] = {.count = 1, .reusable = false}, SHIFT(927),
  [1934] = {.count = 1, .reusable = false}, SHIFT(928),
  [1936] = {.count = 1, .reusable = true}, SHIFT(933),
  [1938] = {.count = 1, .reusable = true}, SHIFT(934),
  [1940] = {.count = 1, .reusable = false}, SHIFT(935),
  [1942] = {.count = 1, .reusable = false}, SHIFT(936),
  [1944] = {.count = 1, .reusable = true}, SHIFT(940),
  [1946] = {.count = 1, .reusable = true}, SHIFT(504),
  [1948] = {.count = 1, .reusable = true}, SHIFT(942),
  [1950] = {.count = 1, .reusable = false}, SHIFT(943),
  [1952] = {.count = 1, .reusable = true}, REDUCE(sym_enum_item, 3, .alias_sequence_id = 2),
  [1954] = {.count = 1, .reusable = false}, REDUCE(sym_enum_item, 3, .alias_sequence_id = 2),
  [1956] = {.count = 1, .reusable = true}, SHIFT(951),
  [1958] = {.count = 1, .reusable = true}, SHIFT(952),
  [1960] = {.count = 1, .reusable = true}, SHIFT(953),
  [1962] = {.count = 1, .reusable = true}, SHIFT(954),
  [1964] = {.count = 1, .reusable = true}, SHIFT(957),
  [1966] = {.count = 1, .reusable = true}, SHIFT(958),
  [1968] = {.count = 1, .reusable = true}, SHIFT(959),
  [1970] = {.count = 1, .reusable = false}, SHIFT(959),
  [1972] = {.count = 1, .reusable = false}, SHIFT(961),
  [1974] = {.count = 1, .reusable = true}, SHIFT(962),
  [1976] = {.count = 1, .reusable = true}, SHIFT(963),
  [1978] = {.count = 1, .reusable = true}, SHIFT(964),
  [1980] = {.count = 1, .reusable = true}, SHIFT(966),
  [1982] = {.count = 1, .reusable = true}, SHIFT(967),
  [1984] = {.count = 1, .reusable = true}, SHIFT(968),
  [1986] = {.count = 1, .reusable = true}, SHIFT(969),
  [1988] = {.count = 1, .reusable = true}, SHIFT(970),
  [1990] = {.count = 1, .reusable = true}, SHIFT(971),
  [1992] = {.count = 1, .reusable = true}, SHIFT(972),
  [1994] = {.count = 1, .reusable = true}, SHIFT(973),
  [1996] = {.count = 1, .reusable = true}, SHIFT(974),
  [1998] = {.count = 1, .reusable = true}, SHIFT(975),
  [2000] = {.count = 1, .reusable = true}, SHIFT(976),
  [2002] = {.count = 1, .reusable = true}, SHIFT(977),
  [2004] = {.count = 1, .reusable = true}, SHIFT(978),
  [2006] = {.count = 1, .reusable = true}, SHIFT(979),
  [2008] = {.count = 1, .reusable = false}, SHIFT(980),
  [2010] = {.count = 1, .reusable = false}, SHIFT(981),
  [2012] = {.count = 1, .reusable = true}, REDUCE(sym_if_expression, 3),
  [2014] = {.count = 1, .reusable = false}, REDUCE(sym_if_expression, 3),
  [2016] = {.count = 1, .reusable = false}, SHIFT(985),
  [2018] = {.count = 1, .reusable = true}, SHIFT(988),
  [2020] = {.count = 1, .reusable = false}, SHIFT(989),
  [2022] = {.count = 1, .reusable = true}, SHIFT(990),
  [2024] = {.count = 1, .reusable = true}, SHIFT(991),
  [2026] = {.count = 1, .reusable = true}, SHIFT(992),
  [2028] = {.count = 1, .reusable = true}, SHIFT(995),
  [2030] = {.count = 1, .reusable = true}, SHIFT(997),
  [2032] = {.count = 1, .reusable = true}, SHIFT(989),
  [2034] = {.count = 1, .reusable = true}, SHIFT(999),
  [2036] = {.count = 1, .reusable = true}, SHIFT(1000),
  [2038] = {.count = 1, .reusable = false}, SHIFT(1001),
  [2040] = {.count = 1, .reusable = false}, SHIFT(1002),
  [2042] = {.count = 1, .reusable = true}, REDUCE(sym_impl_item, 3, .alias_sequence_id = 2),
  [2044] = {.count = 1, .reusable = false}, REDUCE(sym_impl_item, 3, .alias_sequence_id = 2),
  [2046] = {.count = 1, .reusable = true}, REDUCE(sym_impl_item, 3),
  [2048] = {.count = 1, .reusable = false}, REDUCE(sym_impl_item, 3),
  [2050] = {.count = 1, .reusable = true}, SHIFT(1018),
  [2052] = {.count = 1, .reusable = true}, SHIFT(1019),
  [2054] = {.count = 1, .reusable = true}, SHIFT(1020),
  [2056] = {.count = 1, .reusable = true}, REDUCE(sym_let_declaration, 3),
  [2058] = {.count = 1, .reusable = false}, REDUCE(sym_let_declaration, 3),
  [2060] = {.count = 1, .reusable = true}, SHIFT(1021),
  [2062] = {.count = 1, .reusable = true}, SHIFT(1022),
  [2064] = {.count = 1, .reusable = false}, SHIFT(1023),
  [2066] = {.count = 1, .reusable = false}, SHIFT(1024),
  [2068] = {.count = 1, .reusable = true}, SHIFT(1029),
  [2070] = {.count = 1, .reusable = true}, SHIFT(1048),
  [2072] = {.count = 1, .reusable = true}, SHIFT(1030),
  [2074] = {.count = 1, .reusable = true}, SHIFT(1031),
  [2076] = {.count = 1, .reusable = false}, SHIFT(1032),
  [2078] = {.count = 1, .reusable = false}, SHIFT(1047),
  [2080] = {.count = 1, .reusable = true}, SHIFT(1033),
  [2082] = {.count = 1, .reusable = true}, SHIFT(1034),
  [2084] = {.count = 1, .reusable = true}, SHIFT(1035),
  [2086] = {.count = 1, .reusable = true}, SHIFT(1036),
  [2088] = {.count = 1, .reusable = false}, SHIFT(1037),
  [2090] = {.count = 1, .reusable = false}, SHIFT(1038),
  [2092] = {.count = 1, .reusable = false}, SHIFT(1039),
  [2094] = {.count = 1, .reusable = false}, SHIFT(1040),
  [2096] = {.count = 1, .reusable = false}, SHIFT(1041),
  [2098] = {.count = 1, .reusable = true}, SHIFT(1041),
  [2100] = {.count = 1, .reusable = true}, REDUCE(sym_mod_item, 3),
  [2102] = {.count = 1, .reusable = false}, REDUCE(sym_mod_item, 3),
  [2104] = {.count = 1, .reusable = false}, SHIFT(1051),
  [2106] = {.count = 1, .reusable = false}, SHIFT(1052),
  [2108] = {.count = 1, .reusable = false}, SHIFT(1053),
  [2110] = {.count = 1, .reusable = true}, SHIFT(1053),
  [2112] = {.count = 1, .reusable = true}, SHIFT(1055),
  [2114] = {.count = 1, .reusable = true}, SHIFT(1056),
  [2116] = {.count = 1, .reusable = true}, REDUCE(sym_struct_item, 3, .alias_sequence_id = 2),
  [2118] = {.count = 1, .reusable = false}, REDUCE(sym_struct_item, 3, .alias_sequence_id = 2),
  [2120] = {.count = 1, .reusable = true}, SHIFT(1058),
  [2122] = {.count = 1, .reusable = true}, SHIFT(1059),
  [2124] = {.count = 1, .reusable = true}, SHIFT(1060),
  [2126] = {.count = 1, .reusable = false}, SHIFT(1061),
  [2128] = {.count = 1, .reusable = true}, SHIFT(1065),
  [2130] = {.count = 1, .reusable = true}, SHIFT(1066),
  [2132] = {.count = 1, .reusable = false}, SHIFT(1067),
  [2134] = {.count = 1, .reusable = false}, SHIFT(1071),
  [2136] = {.count = 1, .reusable = true}, SHIFT(1076),
  [2138] = {.count = 1, .reusable = true}, SHIFT(1077),
  [2140] = {.count = 1, .reusable = true}, SHIFT(1081),
  [2142] = {.count = 1, .reusable = false}, SHIFT(1082),
  [2144] = {.count = 1, .reusable = true}, SHIFT(1085),
  [2146] = {.count = 1, .reusable = true}, SHIFT(1086),
  [2148] = {.count = 1, .reusable = true}, REDUCE(sym_trait_item, 3, .alias_sequence_id = 2),
  [2150] = {.count = 1, .reusable = false}, REDUCE(sym_trait_item, 3, .alias_sequence_id = 2),
  [2152] = {.count = 1, .reusable = true}, REDUCE(sym_associated_type, 3, .alias_sequence_id = 2),
  [2154] = {.count = 1, .reusable = false}, REDUCE(sym_associated_type, 3, .alias_sequence_id = 2),
  [2156] = {.count = 1, .reusable = true}, SHIFT(1091),
  [2158] = {.count = 1, .reusable = true}, SHIFT(1092),
  [2160] = {.count = 1, .reusable = true}, SHIFT(1093),
  [2162] = {.count = 1, .reusable = false}, SHIFT(1094),
  [2164] = {.count = 1, .reusable = false}, SHIFT(1095),
  [2166] = {.count = 1, .reusable = false}, SHIFT(1096),
  [2168] = {.count = 1, .reusable = true}, SHIFT(1103),
  [2170] = {.count = 1, .reusable = true}, SHIFT(1104),
  [2172] = {.count = 1, .reusable = true}, REDUCE(sym_union_item, 3, .alias_sequence_id = 2),
  [2174] = {.count = 1, .reusable = false}, REDUCE(sym_union_item, 3, .alias_sequence_id = 2),
  [2176] = {.count = 1, .reusable = true}, SHIFT(1105),
  [2178] = {.count = 1, .reusable = false}, SHIFT(1108),
  [2180] = {.count = 1, .reusable = true}, REDUCE(sym_use_list, 2),
  [2182] = {.count = 1, .reusable = true}, SHIFT(1110),
  [2184] = {.count = 1, .reusable = true}, SHIFT(1111),
  [2186] = {.count = 1, .reusable = true}, SHIFT(1112),
  [2188] = {.count = 1, .reusable = true}, SHIFT(1113),
  [2190] = {.count = 1, .reusable = true}, SHIFT(1115),
  [2192] = {.count = 1, .reusable = true}, SHIFT(1116),
  [2194] = {.count = 1, .reusable = true}, SHIFT(1118),
  [2196] = {.count = 1, .reusable = true}, SHIFT(1119),
  [2198] = {.count = 1, .reusable = true}, SHIFT(1121),
  [2200] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_use_list, 2),
  [2202] = {.count = 1, .reusable = true}, SHIFT(1122),
  [2204] = {.count = 1, .reusable = true}, SHIFT(1124),
  [2206] = {.count = 1, .reusable = true}, REDUCE(sym_use_declaration, 3),
  [2208] = {.count = 1, .reusable = false}, REDUCE(sym_use_declaration, 3),
  [2210] = {.count = 1, .reusable = true}, SHIFT(1125),
  [2212] = {.count = 1, .reusable = true}, REDUCE(sym_while_expression, 3),
  [2214] = {.count = 1, .reusable = false}, REDUCE(sym_while_expression, 3),
  [2216] = {.count = 1, .reusable = true}, SHIFT(1126),
  [2218] = {.count = 1, .reusable = true}, SHIFT(1127),
  [2220] = {.count = 1, .reusable = true}, REDUCE(sym_closure_expression, 3),
  [2222] = {.count = 1, .reusable = true}, REDUCE(sym_string_literal, 3),
  [2224] = {.count = 1, .reusable = false}, REDUCE(sym_string_literal, 3),
  [2226] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(575),
  [2229] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_literal_repeat1, 2),
  [2231] = {.count = 1, .reusable = true}, REDUCE(sym_field_initializer_list, 2),
  [2233] = {.count = 1, .reusable = false}, REDUCE(sym_field_initializer_list, 2),
  [2235] = {.count = 1, .reusable = true}, SHIFT(1129),
  [2237] = {.count = 1, .reusable = true}, SHIFT(1130),
  [2239] = {.count = 1, .reusable = true}, SHIFT(1137),
  [2241] = {.count = 1, .reusable = true}, SHIFT(1131),
  [2243] = {.count = 1, .reusable = true}, SHIFT(1132),
  [2245] = {.count = 1, .reusable = true}, SHIFT(1133),
  [2247] = {.count = 1, .reusable = false}, SHIFT(1134),
  [2249] = {.count = 1, .reusable = false}, SHIFT(1135),
  [2251] = {.count = 1, .reusable = false}, SHIFT(1136),
  [2253] = {.count = 1, .reusable = true}, SHIFT(1139),
  [2255] = {.count = 1, .reusable = true}, SHIFT(1140),
  [2257] = {.count = 1, .reusable = true}, SHIFT(1141),
  [2259] = {.count = 1, .reusable = true}, SHIFT(1143),
  [2261] = {.count = 1, .reusable = true}, SHIFT(1145),
  [2263] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_identifier, 3),
  [2265] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_type_identifier_in_expression_position, 3, .alias_sequence_id = 6),
  [2267] = {.count = 1, .reusable = false}, REDUCE(sym_scoped_identifier, 3),
  [2269] = {.count = 1, .reusable = true}, REDUCE(sym_generic_function, 3),
  [2271] = {.count = 1, .reusable = true}, REDUCE(sym_generic_type_with_turbofish, 3, .alias_sequence_id = 4),
  [2273] = {.count = 1, .reusable = false}, REDUCE(sym_generic_function, 3),
  [2275] = {.count = 1, .reusable = true}, SHIFT(1178),
  [2277] = {.count = 1, .reusable = true}, SHIFT(1179),
  [2279] = {.count = 1, .reusable = true}, SHIFT(1150),
  [2281] = {.count = 1, .reusable = true}, SHIFT(1151),
  [2283] = {.count = 1, .reusable = true}, SHIFT(1152),
  [2285] = {.count = 1, .reusable = true}, SHIFT(1153),
  [2287] = {.count = 1, .reusable = false}, SHIFT(1179),
  [2289] = {.count = 1, .reusable = false}, SHIFT(1154),
  [2291] = {.count = 1, .reusable = false}, SHIFT(1155),
  [2293] = {.count = 1, .reusable = false}, SHIFT(1156),
  [2295] = {.count = 1, .reusable = false}, SHIFT(1157),
  [2297] = {.count = 1, .reusable = false}, SHIFT(1158),
  [2299] = {.count = 1, .reusable = false}, SHIFT(1159),
  [2301] = {.count = 1, .reusable = false}, SHIFT(1160),
  [2303] = {.count = 1, .reusable = false}, SHIFT(1161),
  [2305] = {.count = 1, .reusable = false}, SHIFT(1162),
  [2307] = {.count = 1, .reusable = false}, SHIFT(1163),
  [2309] = {.count = 1, .reusable = false}, SHIFT(1164),
  [2311] = {.count = 1, .reusable = false}, SHIFT(1165),
  [2313] = {.count = 1, .reusable = false}, SHIFT(1166),
  [2315] = {.count = 1, .reusable = false}, SHIFT(1167),
  [2317] = {.count = 1, .reusable = false}, SHIFT(1168),
  [2319] = {.count = 1, .reusable = false}, SHIFT(1169),
  [2321] = {.count = 1, .reusable = false}, SHIFT(1170),
  [2323] = {.count = 1, .reusable = false}, SHIFT(1171),
  [2325] = {.count = 1, .reusable = false}, SHIFT(1172),
  [2327] = {.count = 1, .reusable = true}, SHIFT(1173),
  [2329] = {.count = 1, .reusable = false}, SHIFT(1174),
  [2331] = {.count = 1, .reusable = false}, SHIFT(1175),
  [2333] = {.count = 1, .reusable = false}, SHIFT(1176),
  [2335] = {.count = 1, .reusable = true}, SHIFT(1176),
  [2337] = {.count = 1, .reusable = true}, SHIFT(1216),
  [2339] = {.count = 1, .reusable = true}, SHIFT(1180),
  [2341] = {.count = 1, .reusable = true}, SHIFT(1181),
  [2343] = {.count = 1, .reusable = true}, SHIFT(1182),
  [2345] = {.count = 1, .reusable = true}, SHIFT(1218),
  [2347] = {.count = 1, .reusable = true}, SHIFT(1183),
  [2349] = {.count = 1, .reusable = false}, SHIFT(1218),
  [2351] = {.count = 1, .reusable = false}, SHIFT(1184),
  [2353] = {.count = 1, .reusable = false}, SHIFT(1185),
  [2355] = {.count = 1, .reusable = false}, SHIFT(1186),
  [2357] = {.count = 1, .reusable = false}, SHIFT(1187),
  [2359] = {.count = 1, .reusable = true}, SHIFT(1188),
  [2361] = {.count = 1, .reusable = false}, SHIFT(1189),
  [2363] = {.count = 1, .reusable = false}, SHIFT(1190),
  [2365] = {.count = 1, .reusable = false}, SHIFT(1191),
  [2367] = {.count = 1, .reusable = false}, SHIFT(1192),
  [2369] = {.count = 1, .reusable = false}, SHIFT(1193),
  [2371] = {.count = 1, .reusable = false}, SHIFT(1194),
  [2373] = {.count = 1, .reusable = false}, SHIFT(1195),
  [2375] = {.count = 1, .reusable = false}, SHIFT(1196),
  [2377] = {.count = 1, .reusable = false}, SHIFT(1197),
  [2379] = {.count = 1, .reusable = false}, SHIFT(1198),
  [2381] = {.count = 1, .reusable = false}, SHIFT(1199),
  [2383] = {.count = 1, .reusable = false}, SHIFT(1200),
  [2385] = {.count = 1, .reusable = false}, SHIFT(1201),
  [2387] = {.count = 1, .reusable = false}, SHIFT(1202),
  [2389] = {.count = 1, .reusable = false}, SHIFT(1203),
  [2391] = {.count = 1, .reusable = false}, SHIFT(1204),
  [2393] = {.count = 1, .reusable = false}, SHIFT(1205),
  [2395] = {.count = 1, .reusable = false}, SHIFT(1206),
  [2397] = {.count = 1, .reusable = false}, SHIFT(1207),
  [2399] = {.count = 1, .reusable = false}, SHIFT(1208),
  [2401] = {.count = 1, .reusable = false}, SHIFT(1209),
  [2403] = {.count = 1, .reusable = false}, SHIFT(1210),
  [2405] = {.count = 1, .reusable = false}, SHIFT(1211),
  [2407] = {.count = 1, .reusable = false}, SHIFT(1212),
  [2409] = {.count = 1, .reusable = false}, SHIFT(1213),
  [2411] = {.count = 1, .reusable = false}, SHIFT(1214),
  [2413] = {.count = 1, .reusable = true}, SHIFT(1214),
  [2415] = {.count = 1, .reusable = true}, SHIFT(1226),
  [2417] = {.count = 1, .reusable = false}, SHIFT(1226),
  [2419] = {.count = 1, .reusable = false}, SHIFT(1219),
  [2421] = {.count = 1, .reusable = false}, SHIFT(1220),
  [2423] = {.count = 1, .reusable = false}, SHIFT(1221),
  [2425] = {.count = 1, .reusable = false}, SHIFT(1222),
  [2427] = {.count = 1, .reusable = false}, SHIFT(1223),
  [2429] = {.count = 1, .reusable = false}, SHIFT(1224),
  [2431] = {.count = 1, .reusable = true}, REDUCE(sym_macro_invocation, 3),
  [2433] = {.count = 1, .reusable = false}, REDUCE(sym_macro_invocation, 3),
  [2435] = {.count = 1, .reusable = true}, SHIFT(1228),
  [2437] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_list, 2),
  [2439] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_list, 2),
  [2441] = {.count = 1, .reusable = true}, SHIFT(1229),
  [2443] = {.count = 1, .reusable = true}, SHIFT(1230),
  [2445] = {.count = 1, .reusable = false}, SHIFT(1231),
  [2447] = {.count = 1, .reusable = true}, SHIFT(1232),
  [2449] = {.count = 1, .reusable = true}, SHIFT(1233),
  [2451] = {.count = 1, .reusable = false}, SHIFT(1234),
  [2453] = {.count = 1, .reusable = true}, SHIFT(1238),
  [2455] = {.count = 1, .reusable = false}, SHIFT(1238),
  [2457] = {.count = 1, .reusable = false}, SHIFT(1237),
  [2459] = {.count = 1, .reusable = true}, SHIFT(1239),
  [2461] = {.count = 1, .reusable = false}, SHIFT(1240),
  [2463] = {.count = 1, .reusable = false}, SHIFT(1241),
  [2465] = {.count = 1, .reusable = true}, SHIFT(1242),
  [2467] = {.count = 1, .reusable = true}, SHIFT(1243),
  [2469] = {.count = 1, .reusable = true}, SHIFT(1244),
  [2471] = {.count = 1, .reusable = true}, SHIFT(1245),
  [2473] = {.count = 1, .reusable = true}, SHIFT(1246),
  [2475] = {.count = 1, .reusable = true}, SHIFT(1248),
  [2477] = {.count = 1, .reusable = true}, SHIFT(289),
  [2479] = {.count = 1, .reusable = true}, SHIFT(1249),
  [2481] = {.count = 1, .reusable = true}, SHIFT(1250),
  [2483] = {.count = 1, .reusable = true}, SHIFT(1251),
  [2485] = {.count = 1, .reusable = true}, SHIFT(1252),
  [2487] = {.count = 1, .reusable = true}, SHIFT(1253),
  [2489] = {.count = 1, .reusable = true}, SHIFT(1254),
  [2491] = {.count = 1, .reusable = true}, SHIFT(1255),
  [2493] = {.count = 1, .reusable = true}, SHIFT(1256),
  [2495] = {.count = 1, .reusable = true}, SHIFT(1257),
  [2497] = {.count = 1, .reusable = true}, SHIFT(1258),
  [2499] = {.count = 1, .reusable = true}, SHIFT(1259),
  [2501] = {.count = 1, .reusable = true}, SHIFT(1260),
  [2503] = {.count = 1, .reusable = true}, SHIFT(1261),
  [2505] = {.count = 1, .reusable = true}, SHIFT(1264),
  [2507] = {.count = 1, .reusable = true}, SHIFT(1266),
  [2509] = {.count = 1, .reusable = true}, SHIFT(1270),
  [2511] = {.count = 1, .reusable = true}, SHIFT(1271),
  [2513] = {.count = 1, .reusable = true}, SHIFT(1272),
  [2515] = {.count = 1, .reusable = true}, SHIFT(1279),
  [2517] = {.count = 1, .reusable = true}, SHIFT(1281),
  [2519] = {.count = 1, .reusable = true}, SHIFT(1285),
  [2521] = {.count = 1, .reusable = true}, SHIFT(1286),
  [2523] = {.count = 1, .reusable = true}, SHIFT(1287),
  [2525] = {.count = 1, .reusable = true}, REDUCE(sym_foreign_mod_item, 3),
  [2527] = {.count = 1, .reusable = false}, REDUCE(sym_foreign_mod_item, 3),
  [2529] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_identifier, 3, .alias_sequence_id = 7),
  [2531] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_type_identifier_in_expression_position, 3, .alias_sequence_id = 8),
  [2533] = {.count = 1, .reusable = false}, REDUCE(sym_scoped_identifier, 3, .alias_sequence_id = 7),
  [2535] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 2),
  [2537] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 2),
  [2539] = {.count = 1, .reusable = true}, SHIFT(1288),
  [2541] = {.count = 1, .reusable = true}, SHIFT(1289),
  [2543] = {.count = 1, .reusable = false}, SHIFT(1291),
  [2545] = {.count = 1, .reusable = true}, SHIFT(1292),
  [2547] = {.count = 1, .reusable = false}, SHIFT(631),
  [2549] = {.count = 1, .reusable = true}, SHIFT(1294),
  [2551] = {.count = 1, .reusable = false}, SHIFT(1293),
  [2553] = {.count = 1, .reusable = true}, SHIFT(1295),
  [2555] = {.count = 1, .reusable = true}, SHIFT(1297),
  [2557] = {.count = 1, .reusable = false}, SHIFT(1298),
  [2559] = {.count = 1, .reusable = false}, SHIFT(1299),
  [2561] = {.count = 1, .reusable = false}, SHIFT(1300),
  [2563] = {.count = 1, .reusable = true}, SHIFT(1301),
  [2565] = {.count = 1, .reusable = true}, SHIFT(1302),
  [2567] = {.count = 1, .reusable = true}, SHIFT(1303),
  [2569] = {.count = 1, .reusable = false}, SHIFT(1304),
  [2571] = {.count = 1, .reusable = false}, SHIFT(1302),
  [2573] = {.count = 1, .reusable = false}, SHIFT(1305),
  [2575] = {.count = 1, .reusable = false}, SHIFT(1306),
  [2577] = {.count = 1, .reusable = false}, SHIFT(1307),
  [2579] = {.count = 1, .reusable = true}, SHIFT(1308),
  [2581] = {.count = 1, .reusable = false}, SHIFT(1309),
  [2583] = {.count = 1, .reusable = true}, SHIFT(1310),
  [2585] = {.count = 1, .reusable = true}, SHIFT(1311),
  [2587] = {.count = 1, .reusable = true}, SHIFT(1312),
  [2589] = {.count = 1, .reusable = true}, REDUCE(sym_binary_expression, 3),
  [2591] = {.count = 1, .reusable = false}, REDUCE(sym_binary_expression, 3),
  [2593] = {.count = 1, .reusable = true}, REDUCE(sym_field_expression, 3),
  [2595] = {.count = 1, .reusable = false}, REDUCE(sym_field_expression, 3),
  [2597] = {.count = 1, .reusable = true}, REDUCE(sym_field_expression, 3, .alias_sequence_id = 9),
  [2599] = {.count = 1, .reusable = false}, REDUCE(sym_field_expression, 3, .alias_sequence_id = 9),
  [2601] = {.count = 1, .reusable = true}, REDUCE(sym_compound_assignment_expr, 3),
  [2603] = {.count = 1, .reusable = false}, REDUCE(sym_compound_assignment_expr, 3),
  [2605] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3),
  [2607] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 3),
  [2609] = {.count = 1, .reusable = true}, REDUCE(sym_range_expression, 3),
  [2611] = {.count = 1, .reusable = false}, REDUCE(sym_range_expression, 3),
  [2613] = {.count = 1, .reusable = true}, SHIFT(1313),
  [2615] = {.count = 1, .reusable = true}, SHIFT(1316),
  [2617] = {.count = 1, .reusable = true}, SHIFT(1317),
  [2619] = {.count = 1, .reusable = false}, SHIFT(1318),
  [2621] = {.count = 1, .reusable = true}, SHIFT(1321),
  [2623] = {.count = 1, .reusable = false}, REDUCE(sym_empty_type, 1),
  [2625] = {.count = 1, .reusable = true}, SHIFT(1322),
  [2627] = {.count = 1, .reusable = false}, SHIFT(1324),
  [2629] = {.count = 1, .reusable = false}, SHIFT(1325),
  [2631] = {.count = 1, .reusable = true}, SHIFT(663),
  [2633] = {.count = 1, .reusable = false}, REDUCE(sym__type, 1, .alias_sequence_id = 4),
  [2635] = {.count = 1, .reusable = true}, SHIFT(1328),
  [2637] = {.count = 1, .reusable = false}, SHIFT(583),
  [2639] = {.count = 1, .reusable = true}, SHIFT(1331),
  [2641] = {.count = 1, .reusable = false}, SHIFT(1332),
  [2643] = {.count = 1, .reusable = false}, SHIFT(1333),
  [2645] = {.count = 1, .reusable = true}, REDUCE(sym_type_cast_expression, 3),
  [2647] = {.count = 1, .reusable = false}, REDUCE(sym_type_cast_expression, 3),
  [2649] = {.count = 1, .reusable = true}, SHIFT(1336),
  [2651] = {.count = 1, .reusable = true}, SHIFT(1337),
  [2653] = {.count = 1, .reusable = true}, SHIFT(1338),
  [2655] = {.count = 1, .reusable = true}, SHIFT(1339),
  [2657] = {.count = 1, .reusable = true}, REDUCE(sym_generic_type_with_turbofish, 3),
  [2659] = {.count = 1, .reusable = true}, SHIFT(1341),
  [2661] = {.count = 1, .reusable = false}, SHIFT(1342),
  [2663] = {.count = 1, .reusable = false}, SHIFT(1346),
  [2665] = {.count = 1, .reusable = false}, SHIFT(1347),
  [2667] = {.count = 1, .reusable = true}, SHIFT(1349),
  [2669] = {.count = 1, .reusable = true}, SHIFT(1351),
  [2671] = {.count = 1, .reusable = true}, SHIFT(1352),
  [2673] = {.count = 1, .reusable = false}, SHIFT(1352),
  [2675] = {.count = 1, .reusable = true}, SHIFT(1355),
  [2677] = {.count = 1, .reusable = false}, SHIFT(1354),
  [2679] = {.count = 1, .reusable = true}, SHIFT(1363),
  [2681] = {.count = 1, .reusable = true}, SHIFT(1356),
  [2683] = {.count = 1, .reusable = true}, SHIFT(1357),
  [2685] = {.count = 1, .reusable = true}, SHIFT(1358),
  [2687] = {.count = 1, .reusable = true}, SHIFT(1359),
  [2689] = {.count = 1, .reusable = false}, SHIFT(1363),
  [2691] = {.count = 1, .reusable = false}, SHIFT(1360),
  [2693] = {.count = 1, .reusable = false}, SHIFT(1361),
  [2695] = {.count = 1, .reusable = true}, SHIFT(1362),
  [2697] = {.count = 1, .reusable = true}, SHIFT(1364),
  [2699] = {.count = 1, .reusable = true}, SHIFT(1365),
  [2701] = {.count = 1, .reusable = false}, SHIFT(1365),
  [2703] = {.count = 1, .reusable = true}, SHIFT(1366),
  [2705] = {.count = 1, .reusable = false}, SHIFT(1366),
  [2707] = {.count = 1, .reusable = true}, SHIFT(1367),
  [2709] = {.count = 1, .reusable = true}, SHIFT(1368),
  [2711] = {.count = 1, .reusable = true}, SHIFT(1369),
  [2713] = {.count = 1, .reusable = true}, REDUCE(sym_macro_definition, 4),
  [2715] = {.count = 1, .reusable = false}, REDUCE(sym_macro_definition, 4),
  [2717] = {.count = 1, .reusable = true}, SHIFT(1374),
  [2719] = {.count = 1, .reusable = true}, SHIFT(1375),
  [2721] = {.count = 1, .reusable = true}, SHIFT(1376),
  [2723] = {.count = 1, .reusable = true}, SHIFT(1377),
  [2725] = {.count = 1, .reusable = true}, SHIFT(1379),
  [2727] = {.count = 1, .reusable = true}, SHIFT(1382),
  [2729] = {.count = 1, .reusable = true}, SHIFT(1385),
  [2731] = {.count = 1, .reusable = true}, SHIFT(1383),
  [2733] = {.count = 1, .reusable = false}, SHIFT(1385),
  [2735] = {.count = 1, .reusable = true}, SHIFT(1388),
  [2737] = {.count = 1, .reusable = false}, SHIFT(1388),
  [2739] = {.count = 1, .reusable = true}, SHIFT(1390),
  [2741] = {.count = 1, .reusable = false}, SHIFT(1390),
  [2743] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_expression, 4),
  [2745] = {.count = 1, .reusable = false}, REDUCE(sym_tuple_expression, 4),
  [2747] = {.count = 1, .reusable = true}, SHIFT(1391),
  [2749] = {.count = 1, .reusable = true}, SHIFT(1392),
  [2751] = {.count = 1, .reusable = true}, SHIFT(1393),
  [2753] = {.count = 1, .reusable = true}, SHIFT(1395),
  [2755] = {.count = 1, .reusable = false}, SHIFT(1396),
  [2757] = {.count = 1, .reusable = false}, SHIFT(1400),
  [2759] = {.count = 1, .reusable = false}, SHIFT(1401),
  [2761] = {.count = 1, .reusable = true}, SHIFT(1404),
  [2763] = {.count = 1, .reusable = true}, SHIFT(1405),
  [2765] = {.count = 1, .reusable = false}, SHIFT(1405),
  [2767] = {.count = 1, .reusable = true}, SHIFT(1408),
  [2769] = {.count = 1, .reusable = false}, SHIFT(1407),
  [2771] = {.count = 1, .reusable = true}, SHIFT(1409),
  [2773] = {.count = 1, .reusable = false}, SHIFT(1409),
  [2775] = {.count = 1, .reusable = true}, SHIFT(1411),
  [2777] = {.count = 1, .reusable = false}, SHIFT(1412),
  [2779] = {.count = 1, .reusable = true}, SHIFT(1413),
  [2781] = {.count = 1, .reusable = false}, SHIFT(1414),
  [2783] = {.count = 1, .reusable = false}, SHIFT(1418),
  [2785] = {.count = 1, .reusable = false}, SHIFT(1419),
  [2787] = {.count = 1, .reusable = true}, SHIFT(1422),
  [2789] = {.count = 1, .reusable = true}, REDUCE(sym_block, 4),
  [2791] = {.count = 1, .reusable = false}, REDUCE(sym_block, 4),
  [2793] = {.count = 1, .reusable = true}, SHIFT(1423),
  [2795] = {.count = 1, .reusable = true}, SHIFT(1424),
  [2797] = {.count = 1, .reusable = true}, SHIFT(1425),
  [2799] = {.count = 1, .reusable = true}, REDUCE(sym_array_expression, 4),
  [2801] = {.count = 1, .reusable = false}, REDUCE(sym_array_expression, 4),
  [2803] = {.count = 1, .reusable = false}, SHIFT(1426),
  [2805] = {.count = 1, .reusable = true}, SHIFT(1427),
  [2807] = {.count = 1, .reusable = false}, SHIFT(763),
  [2809] = {.count = 1, .reusable = true}, SHIFT(1429),
  [2811] = {.count = 1, .reusable = false}, SHIFT(1428),
  [2813] = {.count = 1, .reusable = true}, SHIFT(1430),
  [2815] = {.count = 1, .reusable = true}, REDUCE(aux_sym_token_tree_repeat2, 2),
  [2817] = {.count = 1, .reusable = false}, SHIFT(1432),
  [2819] = {.count = 1, .reusable = false}, SHIFT(1433),
  [2821] = {.count = 1, .reusable = false}, SHIFT(1434),
  [2823] = {.count = 1, .reusable = true}, SHIFT(1435),
  [2825] = {.count = 1, .reusable = true}, SHIFT(1436),
  [2827] = {.count = 1, .reusable = true}, SHIFT(1437),
  [2829] = {.count = 1, .reusable = false}, SHIFT(1438),
  [2831] = {.count = 1, .reusable = false}, SHIFT(1436),
  [2833] = {.count = 1, .reusable = false}, SHIFT(1439),
  [2835] = {.count = 1, .reusable = false}, SHIFT(1440),
  [2837] = {.count = 1, .reusable = false}, SHIFT(1441),
  [2839] = {.count = 1, .reusable = true}, SHIFT(1442),
  [2841] = {.count = 1, .reusable = false}, SHIFT(1443),
  [2843] = {.count = 1, .reusable = true}, SHIFT(1444),
  [2845] = {.count = 1, .reusable = true}, SHIFT(1445),
  [2847] = {.count = 1, .reusable = true}, SHIFT(1446),
  [2849] = {.count = 1, .reusable = true}, SHIFT(1447),
  [2851] = {.count = 1, .reusable = false}, SHIFT(1448),
  [2853] = {.count = 1, .reusable = false}, SHIFT(1452),
  [2855] = {.count = 1, .reusable = false}, SHIFT(1453),
  [2857] = {.count = 1, .reusable = true}, SHIFT(1456),
  [2859] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat2, 2), SHIFT_REPEAT(1457),
  [2862] = {.count = 1, .reusable = true}, SHIFT(1458),
  [2864] = {.count = 1, .reusable = true}, SHIFT(1459),
  [2866] = {.count = 1, .reusable = true}, SHIFT(1460),
  [2868] = {.count = 1, .reusable = true}, SHIFT(1461),
  [2870] = {.count = 1, .reusable = true}, SHIFT(42),
  [2872] = {.count = 1, .reusable = true}, REDUCE(sym_attribute_item, 4),
  [2874] = {.count = 1, .reusable = false}, REDUCE(sym_attribute_item, 4),
  [2876] = {.count = 1, .reusable = true}, SHIFT(1463),
  [2878] = {.count = 1, .reusable = false}, SHIFT(1464),
  [2880] = {.count = 1, .reusable = true}, SHIFT(1465),
  [2882] = {.count = 1, .reusable = true}, SHIFT(1466),
  [2884] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_type, 3),
  [2886] = {.count = 1, .reusable = true}, SHIFT(1469),
  [2888] = {.count = 1, .reusable = true}, SHIFT(1471),
  [2890] = {.count = 1, .reusable = false}, SHIFT(1473),
  [2892] = {.count = 1, .reusable = true}, SHIFT(1474),
  [2894] = {.count = 1, .reusable = true}, SHIFT(1475),
  [2896] = {.count = 1, .reusable = true}, SHIFT(1478),
  [2898] = {.count = 1, .reusable = true}, REDUCE(sym_array_type, 3),
  [2900] = {.count = 1, .reusable = true}, REDUCE(sym_pointer_type, 3),
  [2902] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 5),
  [2904] = {.count = 1, .reusable = false}, REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 5),
  [2906] = {.count = 1, .reusable = true}, REDUCE(sym_reference_type, 3),
  [2908] = {.count = 1, .reusable = true}, REDUCE(sym_parameters, 2),
  [2910] = {.count = 1, .reusable = true}, SHIFT(1480),
  [2912] = {.count = 1, .reusable = false}, SHIFT(1481),
  [2914] = {.count = 1, .reusable = true}, SHIFT(1482),
  [2916] = {.count = 1, .reusable = true}, SHIFT(1483),
  [2918] = {.count = 1, .reusable = true}, SHIFT(1485),
  [2920] = {.count = 1, .reusable = false}, SHIFT(1486),
  [2922] = {.count = 1, .reusable = false}, SHIFT(1487),
  [2924] = {.count = 1, .reusable = false}, SHIFT(1488),
  [2926] = {.count = 1, .reusable = true}, REDUCE(sym_variadic_parameter, 1),
  [2928] = {.count = 1, .reusable = false}, SHIFT(1490),
  [2930] = {.count = 1, .reusable = true}, SHIFT(1481),
  [2932] = {.count = 1, .reusable = false}, SHIFT(1493),
  [2934] = {.count = 1, .reusable = false}, SHIFT(1494),
  [2936] = {.count = 1, .reusable = true}, SHIFT(1495),
  [2938] = {.count = 1, .reusable = false}, SHIFT(1496),
  [2940] = {.count = 1, .reusable = false}, SHIFT(1482),
  [2942] = {.count = 1, .reusable = true}, REDUCE(sym_self_parameter, 1),
  [2944] = {.count = 1, .reusable = true}, SHIFT(1497),
  [2946] = {.count = 1, .reusable = true}, SHIFT(1498),
  [2948] = {.count = 1, .reusable = true}, SHIFT(1501),
  [2950] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 6),
  [2952] = {.count = 1, .reusable = false}, REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 6),
  [2954] = {.count = 1, .reusable = true}, SHIFT(1504),
  [2956] = {.count = 1, .reusable = true}, SHIFT(1502),
  [2958] = {.count = 1, .reusable = false}, SHIFT(1504),
  [2960] = {.count = 1, .reusable = true}, SHIFT(1507),
  [2962] = {.count = 1, .reusable = false}, SHIFT(1507),
  [2964] = {.count = 1, .reusable = true}, SHIFT(1509),
  [2966] = {.count = 1, .reusable = false}, SHIFT(1509),
  [2968] = {.count = 1, .reusable = true}, SHIFT(1510),
  [2970] = {.count = 1, .reusable = false}, SHIFT(1511),
  [2972] = {.count = 1, .reusable = false}, SHIFT(1512),
  [2974] = {.count = 1, .reusable = true}, SHIFT(1515),
  [2976] = {.count = 1, .reusable = false}, SHIFT(1517),
  [2978] = {.count = 1, .reusable = false}, SHIFT(1518),
  [2980] = {.count = 1, .reusable = true}, SHIFT(1520),
  [2982] = {.count = 1, .reusable = true}, SHIFT(1521),
  [2984] = {.count = 1, .reusable = true}, SHIFT(1522),
  [2986] = {.count = 1, .reusable = true}, SHIFT(1524),
  [2988] = {.count = 1, .reusable = true}, REDUCE(sym_function_type, 3),
  [2990] = {.count = 1, .reusable = true}, SHIFT(1527),
  [2992] = {.count = 1, .reusable = true}, REDUCE(sym_function_type, 3, .alias_sequence_id = 2),
  [2994] = {.count = 1, .reusable = true}, SHIFT(1528),
  [2996] = {.count = 1, .reusable = true}, REDUCE(sym_bounded_type, 3),
  [2998] = {.count = 1, .reusable = true}, SHIFT(1529),
  [3000] = {.count = 1, .reusable = false}, SHIFT(1530),
  [3002] = {.count = 1, .reusable = false}, SHIFT(1534),
  [3004] = {.count = 1, .reusable = false}, SHIFT(1535),
  [3006] = {.count = 1, .reusable = true}, SHIFT(1537),
  [3008] = {.count = 1, .reusable = true}, REDUCE(sym_qualified_type, 3),
  [3010] = {.count = 1, .reusable = true}, SHIFT(1538),
  [3012] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 8),
  [3014] = {.count = 1, .reusable = false}, REDUCE(sym_scoped_type_identifier, 3, .alias_sequence_id = 8),
  [3016] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_pattern, 3),
  [3018] = {.count = 1, .reusable = true}, SHIFT(1540),
  [3020] = {.count = 1, .reusable = true}, SHIFT(1539),
  [3022] = {.count = 1, .reusable = false}, SHIFT(1540),
  [3024] = {.count = 1, .reusable = true}, SHIFT(1541),
  [3026] = {.count = 1, .reusable = true}, SHIFT(1543),
  [3028] = {.count = 1, .reusable = false}, SHIFT(1544),
  [3030] = {.count = 1, .reusable = false}, SHIFT(1548),
  [3032] = {.count = 1, .reusable = false}, SHIFT(1549),
  [3034] = {.count = 1, .reusable = true}, SHIFT(1551),
  [3036] = {.count = 1, .reusable = true}, REDUCE(sym_parameter, 3, .alias_sequence_id = 1),
  [3038] = {.count = 1, .reusable = true}, SHIFT(1552),
  [3040] = {.count = 1, .reusable = true}, REDUCE(sym_parameter, 3),
  [3042] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_pattern_in_parameter, 2),
  [3044] = {.count = 1, .reusable = true}, SHIFT(1553),
  [3046] = {.count = 1, .reusable = false}, SHIFT(1554),
  [3048] = {.count = 1, .reusable = false}, SHIFT(1555),
  [3050] = {.count = 1, .reusable = true}, SHIFT(1556),
  [3052] = {.count = 1, .reusable = false}, REDUCE(sym_reference_pattern_in_parameter, 3),
  [3054] = {.count = 1, .reusable = true}, REDUCE(sym_reference_pattern_in_parameter, 3),
  [3056] = {.count = 1, .reusable = true}, REDUCE(sym_reference_pattern, 3),
  [3058] = {.count = 1, .reusable = true}, SHIFT(1562),
  [3060] = {.count = 1, .reusable = true}, SHIFT(1563),
  [3062] = {.count = 1, .reusable = false}, SHIFT(1564),
  [3064] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_struct_pattern, 3),
  [3066] = {.count = 1, .reusable = true}, SHIFT(1565),
  [3068] = {.count = 1, .reusable = true}, SHIFT(1566),
  [3070] = {.count = 1, .reusable = true}, REDUCE(sym_struct_pattern, 3, .alias_sequence_id = 4),
  [3072] = {.count = 1, .reusable = true}, SHIFT(1568),
  [3074] = {.count = 1, .reusable = true}, SHIFT(1569),
  [3076] = {.count = 1, .reusable = false}, SHIFT(1570),
  [3078] = {.count = 1, .reusable = false}, SHIFT(1569),
  [3080] = {.count = 1, .reusable = true}, REDUCE(sym_field_pattern, 1, .alias_sequence_id = 10),
  [3082] = {.count = 1, .reusable = true}, SHIFT(1571),
  [3084] = {.count = 1, .reusable = true}, SHIFT(1572),
  [3086] = {.count = 1, .reusable = true}, REDUCE(sym_captured_pattern, 3),
  [3088] = {.count = 1, .reusable = true}, REDUCE(aux_sym_closure_parameters_repeat1, 2),
  [3090] = {.count = 1, .reusable = true}, REDUCE(sym_closure_parameters, 4),
  [3092] = {.count = 1, .reusable = false}, REDUCE(sym_closure_parameters, 4),
  [3094] = {.count = 2, .reusable = true}, REDUCE(aux_sym_closure_parameters_repeat1, 2), SHIFT_REPEAT(449),
  [3097] = {.count = 1, .reusable = true}, REDUCE(sym_struct_pattern, 3),
  [3099] = {.count = 1, .reusable = true}, SHIFT(1574),
  [3101] = {.count = 1, .reusable = true}, SHIFT(1575),
  [3103] = {.count = 1, .reusable = true}, SHIFT(1577),
  [3105] = {.count = 1, .reusable = false}, SHIFT(1578),
  [3107] = {.count = 1, .reusable = false}, SHIFT(1582),
  [3109] = {.count = 1, .reusable = false}, SHIFT(1583),
  [3111] = {.count = 1, .reusable = true}, SHIFT(1585),
  [3113] = {.count = 1, .reusable = true}, SHIFT(1586),
  [3115] = {.count = 1, .reusable = true}, SHIFT(1587),
  [3117] = {.count = 1, .reusable = true}, REDUCE(sym_enum_variant_list, 2),
  [3119] = {.count = 1, .reusable = false}, REDUCE(sym_enum_variant_list, 2),
  [3121] = {.count = 1, .reusable = true}, SHIFT(1588),
  [3123] = {.count = 1, .reusable = true}, SHIFT(1589),
  [3125] = {.count = 1, .reusable = true}, SHIFT(1590),
  [3127] = {.count = 1, .reusable = true}, REDUCE(sym_enum_variant, 1),
  [3129] = {.count = 1, .reusable = true}, SHIFT(1591),
  [3131] = {.count = 1, .reusable = true}, SHIFT(1593),
  [3133] = {.count = 1, .reusable = true}, SHIFT(1595),
  [3135] = {.count = 1, .reusable = true}, SHIFT(1598),
  [3137] = {.count = 1, .reusable = true}, SHIFT(1599),
  [3139] = {.count = 1, .reusable = false}, SHIFT(1600),
  [3141] = {.count = 1, .reusable = false}, SHIFT(1601),
  [3143] = {.count = 1, .reusable = false}, SHIFT(1602),
  [3145] = {.count = 1, .reusable = false}, SHIFT(1607),
  [3147] = {.count = 1, .reusable = true}, REDUCE(sym_where_clause, 2),
  [3149] = {.count = 1, .reusable = true}, SHIFT(1609),
  [3151] = {.count = 1, .reusable = true}, SHIFT(1607),
  [3153] = {.count = 1, .reusable = true}, REDUCE(sym_enum_item, 4, .alias_sequence_id = 2),
  [3155] = {.count = 1, .reusable = false}, REDUCE(sym_enum_item, 4, .alias_sequence_id = 2),
  [3157] = {.count = 1, .reusable = true}, SHIFT(1613),
  [3159] = {.count = 1, .reusable = true}, SHIFT(1614),
  [3161] = {.count = 1, .reusable = true}, REDUCE(sym_function_signature_item, 4),
  [3163] = {.count = 1, .reusable = false}, REDUCE(sym_function_signature_item, 4),
  [3165] = {.count = 1, .reusable = true}, SHIFT(1618),
  [3167] = {.count = 1, .reusable = true}, SHIFT(1617),
  [3169] = {.count = 1, .reusable = true}, SHIFT(1620),
  [3171] = {.count = 1, .reusable = true}, SHIFT(1621),
  [3173] = {.count = 1, .reusable = false}, SHIFT(1622),
  [3175] = {.count = 1, .reusable = false}, SHIFT(1623),
  [3177] = {.count = 1, .reusable = false}, SHIFT(1629),
  [3179] = {.count = 1, .reusable = true}, REDUCE(sym_function_item, 4),
  [3181] = {.count = 1, .reusable = false}, REDUCE(sym_function_item, 4),
  [3183] = {.count = 1, .reusable = true}, SHIFT(1635),
  [3185] = {.count = 1, .reusable = true}, SHIFT(1636),
  [3187] = {.count = 1, .reusable = true}, SHIFT(1637),
  [3189] = {.count = 1, .reusable = true}, SHIFT(1638),
  [3191] = {.count = 1, .reusable = false}, SHIFT(1639),
  [3193] = {.count = 1, .reusable = false}, SHIFT(1643),
  [3195] = {.count = 1, .reusable = false}, SHIFT(1644),
  [3197] = {.count = 1, .reusable = true}, SHIFT(1647),
  [3199] = {.count = 1, .reusable = true}, SHIFT(23),
  [3201] = {.count = 1, .reusable = true}, REDUCE(sym_if_expression, 4),
  [3203] = {.count = 1, .reusable = false}, REDUCE(sym_if_expression, 4),
  [3205] = {.count = 1, .reusable = true}, SHIFT(1649),
  [3207] = {.count = 1, .reusable = true}, SHIFT(1650),
  [3209] = {.count = 1, .reusable = true}, SHIFT(1651),
  [3211] = {.count = 1, .reusable = false}, SHIFT(1652),
  [3213] = {.count = 1, .reusable = false}, SHIFT(1653),
  [3215] = {.count = 1, .reusable = false}, SHIFT(1654),
  [3217] = {.count = 1, .reusable = true}, SHIFT(1659),
  [3219] = {.count = 1, .reusable = true}, SHIFT(1660),
  [3221] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 3, .alias_sequence_id = 2),
  [3223] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 3, .alias_sequence_id = 2),
  [3225] = {.count = 1, .reusable = true}, REDUCE(sym_constrained_type_parameter, 2, .alias_sequence_id = 4),
  [3227] = {.count = 1, .reusable = true}, SHIFT(1665),
  [3229] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 3),
  [3231] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 3),
  [3233] = {.count = 1, .reusable = true}, SHIFT(1667),
  [3235] = {.count = 1, .reusable = true}, REDUCE(sym_constrained_type_parameter, 2),
  [3237] = {.count = 1, .reusable = true}, SHIFT(1669),
  [3239] = {.count = 1, .reusable = false}, SHIFT(1670),
  [3241] = {.count = 1, .reusable = false}, SHIFT(1674),
  [3243] = {.count = 1, .reusable = false}, SHIFT(1675),
  [3245] = {.count = 1, .reusable = true}, REDUCE(sym_impl_for_clause, 2),
  [3247] = {.count = 1, .reusable = true}, SHIFT(1677),
  [3249] = {.count = 1, .reusable = true}, SHIFT(1678),
  [3251] = {.count = 1, .reusable = true}, REDUCE(sym_impl_item, 4, .alias_sequence_id = 2),
  [3253] = {.count = 1, .reusable = false}, REDUCE(sym_impl_item, 4, .alias_sequence_id = 2),
  [3255] = {.count = 1, .reusable = true}, REDUCE(sym_impl_item, 4, .alias_sequence_id = 6),
  [3257] = {.count = 1, .reusable = false}, REDUCE(sym_impl_item, 4, .alias_sequence_id = 6),
  [3259] = {.count = 1, .reusable = true}, REDUCE(sym_impl_item, 4),
  [3261] = {.count = 1, .reusable = false}, REDUCE(sym_impl_item, 4),
  [3263] = {.count = 1, .reusable = true}, REDUCE(sym_let_declaration, 4),
  [3265] = {.count = 1, .reusable = false}, REDUCE(sym_let_declaration, 4),
  [3267] = {.count = 1, .reusable = true}, SHIFT(1688),
  [3269] = {.count = 1, .reusable = true}, SHIFT(1689),
  [3271] = {.count = 1, .reusable = false}, SHIFT(1690),
  [3273] = {.count = 1, .reusable = false}, SHIFT(1694),
  [3275] = {.count = 1, .reusable = false}, SHIFT(1695),
  [3277] = {.count = 1, .reusable = true}, SHIFT(1697),
  [3279] = {.count = 1, .reusable = true}, SHIFT(1698),
  [3281] = {.count = 1, .reusable = true}, SHIFT(1699),
  [3283] = {.count = 1, .reusable = true}, SHIFT(1700),
  [3285] = {.count = 1, .reusable = true}, SHIFT(1703),
  [3287] = {.count = 1, .reusable = true}, SHIFT(1701),
  [3289] = {.count = 1, .reusable = true}, SHIFT(1702),
  [3291] = {.count = 1, .reusable = false}, SHIFT(1703),
  [3293] = {.count = 1, .reusable = true}, REDUCE(sym_match_expression, 4),
  [3295] = {.count = 1, .reusable = false}, REDUCE(sym_match_expression, 4),
  [3297] = {.count = 1, .reusable = true}, SHIFT(1704),
  [3299] = {.count = 1, .reusable = true}, SHIFT(1706),
  [3301] = {.count = 1, .reusable = false}, SHIFT(1706),
  [3303] = {.count = 1, .reusable = false}, SHIFT(1705),
  [3305] = {.count = 1, .reusable = true}, SHIFT(1707),
  [3307] = {.count = 1, .reusable = true}, SHIFT(1708),
  [3309] = {.count = 1, .reusable = true}, SHIFT(1709),
  [3311] = {.count = 1, .reusable = false}, SHIFT(1709),
  [3313] = {.count = 1, .reusable = true}, SHIFT(1710),
  [3315] = {.count = 1, .reusable = false}, SHIFT(1710),
  [3317] = {.count = 1, .reusable = true}, SHIFT(1711),
  [3319] = {.count = 1, .reusable = true}, SHIFT(1712),
  [3321] = {.count = 1, .reusable = true}, SHIFT(1713),
  [3323] = {.count = 1, .reusable = true}, SHIFT(1714),
  [3325] = {.count = 1, .reusable = true}, SHIFT(1715),
  [3327] = {.count = 1, .reusable = true}, SHIFT(1716),
  [3329] = {.count = 1, .reusable = true}, SHIFT(1717),
  [3331] = {.count = 1, .reusable = true}, SHIFT(1718),
  [3333] = {.count = 1, .reusable = true}, SHIFT(1719),
  [3335] = {.count = 1, .reusable = true}, SHIFT(1720),
  [3337] = {.count = 1, .reusable = true}, REDUCE(sym_match_pattern, 1),
  [3339] = {.count = 1, .reusable = true}, SHIFT(1721),
  [3341] = {.count = 1, .reusable = true}, SHIFT(1722),
  [3343] = {.count = 1, .reusable = true}, SHIFT(1724),
  [3345] = {.count = 1, .reusable = true}, SHIFT(1729),
  [3347] = {.count = 1, .reusable = true}, SHIFT(1730),
  [3349] = {.count = 1, .reusable = true}, REDUCE(sym_visibility_modifier, 4),
  [3351] = {.count = 1, .reusable = true}, SHIFT(1732),
  [3353] = {.count = 1, .reusable = true}, SHIFT(1733),
  [3355] = {.count = 1, .reusable = true}, REDUCE(sym_ordered_field_declaration_list, 2),
  [3357] = {.count = 1, .reusable = true}, SHIFT(1734),
  [3359] = {.count = 1, .reusable = true}, SHIFT(1735),
  [3361] = {.count = 1, .reusable = true}, SHIFT(1736),
  [3363] = {.count = 1, .reusable = false}, REDUCE(sym_visibility_modifier, 1),
  [3365] = {.count = 1, .reusable = true}, SHIFT(1738),
  [3367] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration_list, 2),
  [3369] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration_list, 2),
  [3371] = {.count = 1, .reusable = true}, SHIFT(1742),
  [3373] = {.count = 1, .reusable = true}, SHIFT(1743),
  [3375] = {.count = 1, .reusable = true}, SHIFT(1744),
  [3377] = {.count = 1, .reusable = true}, SHIFT(1746),
  [3379] = {.count = 1, .reusable = false}, SHIFT(1748),
  [3381] = {.count = 1, .reusable = true}, SHIFT(1749),
  [3383] = {.count = 1, .reusable = true}, SHIFT(1748),
  [3385] = {.count = 1, .reusable = true}, REDUCE(sym_struct_item, 4, .alias_sequence_id = 2),
  [3387] = {.count = 1, .reusable = false}, REDUCE(sym_struct_item, 4, .alias_sequence_id = 2),
  [3389] = {.count = 1, .reusable = false}, SHIFT(1751),
  [3391] = {.count = 1, .reusable = true}, SHIFT(1756),
  [3393] = {.count = 1, .reusable = true}, SHIFT(1760),
  [3395] = {.count = 1, .reusable = true}, REDUCE(sym_trait_bounds, 2),
  [3397] = {.count = 1, .reusable = true}, SHIFT(1762),
  [3399] = {.count = 1, .reusable = true}, SHIFT(1764),
  [3401] = {.count = 1, .reusable = true}, SHIFT(1765),
  [3403] = {.count = 1, .reusable = true}, SHIFT(1767),
  [3405] = {.count = 1, .reusable = true}, REDUCE(sym_trait_item, 4, .alias_sequence_id = 2),
  [3407] = {.count = 1, .reusable = false}, REDUCE(sym_trait_item, 4, .alias_sequence_id = 2),
  [3409] = {.count = 1, .reusable = true}, SHIFT(1770),
  [3411] = {.count = 1, .reusable = false}, SHIFT(1771),
  [3413] = {.count = 1, .reusable = false}, SHIFT(1776),
  [3415] = {.count = 1, .reusable = false}, SHIFT(1777),
  [3417] = {.count = 1, .reusable = true}, SHIFT(1779),
  [3419] = {.count = 1, .reusable = true}, SHIFT(1781),
  [3421] = {.count = 1, .reusable = true}, SHIFT(1782),
  [3423] = {.count = 1, .reusable = true}, SHIFT(1783),
  [3425] = {.count = 1, .reusable = true}, SHIFT(1784),
  [3427] = {.count = 1, .reusable = true}, REDUCE(sym_associated_type, 4, .alias_sequence_id = 2),
  [3429] = {.count = 1, .reusable = false}, REDUCE(sym_associated_type, 4, .alias_sequence_id = 2),
  [3431] = {.count = 1, .reusable = true}, REDUCE(sym_union_item, 4, .alias_sequence_id = 2),
  [3433] = {.count = 1, .reusable = false}, REDUCE(sym_union_item, 4, .alias_sequence_id = 2),
  [3435] = {.count = 1, .reusable = true}, SHIFT(1786),
  [3437] = {.count = 1, .reusable = true}, REDUCE(sym_use_list, 3),
  [3439] = {.count = 1, .reusable = true}, REDUCE(sym_use_list, 3, .alias_sequence_id = 11),
  [3441] = {.count = 1, .reusable = true}, SHIFT(1793),
  [3443] = {.count = 1, .reusable = false}, SHIFT(1794),
  [3445] = {.count = 1, .reusable = false}, SHIFT(1795),
  [3447] = {.count = 1, .reusable = false}, SHIFT(1796),
  [3449] = {.count = 1, .reusable = true}, SHIFT(1796),
  [3451] = {.count = 1, .reusable = true}, SHIFT(1799),
  [3453] = {.count = 1, .reusable = true}, SHIFT(1801),
  [3455] = {.count = 1, .reusable = true}, SHIFT(1802),
  [3457] = {.count = 1, .reusable = true}, REDUCE(sym_use_wildcard, 3, .alias_sequence_id = 1),
  [3459] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_use_list, 3, .alias_sequence_id = 1),
  [3461] = {.count = 1, .reusable = true}, REDUCE(sym_use_as_clause, 3, .alias_sequence_id = 1),
  [3463] = {.count = 1, .reusable = true}, REDUCE(sym_use_wildcard, 3),
  [3465] = {.count = 1, .reusable = true}, REDUCE(sym_scoped_use_list, 3),
  [3467] = {.count = 1, .reusable = true}, REDUCE(sym_use_as_clause, 3),
  [3469] = {.count = 1, .reusable = true}, SHIFT(1803),
  [3471] = {.count = 1, .reusable = true}, REDUCE(sym_extern_crate_declaration, 4),
  [3473] = {.count = 1, .reusable = false}, REDUCE(sym_extern_crate_declaration, 4),
  [3475] = {.count = 1, .reusable = true}, SHIFT(1804),
  [3477] = {.count = 1, .reusable = true}, REDUCE(sym_field_initializer_list, 3),
  [3479] = {.count = 1, .reusable = false}, REDUCE(sym_field_initializer_list, 3),
  [3481] = {.count = 1, .reusable = false}, SHIFT(1807),
  [3483] = {.count = 1, .reusable = true}, SHIFT(1808),
  [3485] = {.count = 1, .reusable = false}, SHIFT(1131),
  [3487] = {.count = 1, .reusable = true}, SHIFT(1810),
  [3489] = {.count = 1, .reusable = false}, SHIFT(1809),
  [3491] = {.count = 1, .reusable = true}, SHIFT(1811),
  [3493] = {.count = 1, .reusable = true}, REDUCE(sym_base_field_initializer, 2),
  [3495] = {.count = 1, .reusable = false}, SHIFT(1813),
  [3497] = {.count = 1, .reusable = false}, SHIFT(1814),
  [3499] = {.count = 1, .reusable = false}, SHIFT(1815),
  [3501] = {.count = 1, .reusable = true}, SHIFT(1816),
  [3503] = {.count = 1, .reusable = true}, SHIFT(1817),
  [3505] = {.count = 1, .reusable = true}, SHIFT(1818),
  [3507] = {.count = 1, .reusable = false}, SHIFT(1819),
  [3509] = {.count = 1, .reusable = false}, SHIFT(1817),
  [3511] = {.count = 1, .reusable = false}, SHIFT(1820),
  [3513] = {.count = 1, .reusable = false}, SHIFT(1821),
  [3515] = {.count = 1, .reusable = false}, SHIFT(1822),
  [3517] = {.count = 1, .reusable = true}, SHIFT(1823),
  [3519] = {.count = 1, .reusable = false}, SHIFT(1824),
  [3521] = {.count = 1, .reusable = true}, SHIFT(1825),
  [3523] = {.count = 1, .reusable = true}, SHIFT(1826),
  [3525] = {.count = 1, .reusable = true}, SHIFT(1827),
  [3527] = {.count = 1, .reusable = true}, REDUCE(sym_field_initializer_list, 3, .alias_sequence_id = 12),
  [3529] = {.count = 1, .reusable = false}, REDUCE(sym_field_initializer_list, 3, .alias_sequence_id = 12),
  [3531] = {.count = 1, .reusable = true}, SHIFT(1828),
  [3533] = {.count = 1, .reusable = true}, SHIFT(1829),
  [3535] = {.count = 1, .reusable = true}, SHIFT(1830),
  [3537] = {.count = 1, .reusable = true}, SHIFT(1832),
  [3539] = {.count = 1, .reusable = true}, SHIFT(1834),
  [3541] = {.count = 1, .reusable = true}, SHIFT(1835),
  [3543] = {.count = 1, .reusable = true}, SHIFT(1836),
  [3545] = {.count = 2, .reusable = true}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT_REPEAT(578),
  [3548] = {.count = 1, .reusable = true}, REDUCE(aux_sym_enum_variant_list_repeat1, 2),
  [3550] = {.count = 1, .reusable = true}, SHIFT(1837),
  [3552] = {.count = 1, .reusable = true}, SHIFT(1838),
  [3554] = {.count = 1, .reusable = true}, SHIFT(1842),
  [3556] = {.count = 1, .reusable = true}, SHIFT(1840),
  [3558] = {.count = 1, .reusable = false}, SHIFT(1842),
  [3560] = {.count = 1, .reusable = true}, REDUCE(sym_token_tree, 2),
  [3562] = {.count = 1, .reusable = false}, REDUCE(sym_token_tree, 2),
  [3564] = {.count = 1, .reusable = true}, SHIFT(1843),
  [3566] = {.count = 1, .reusable = true}, SHIFT(1846),
  [3568] = {.count = 1, .reusable = false}, SHIFT(1846),
  [3570] = {.count = 1, .reusable = true}, SHIFT(1865),
  [3572] = {.count = 1, .reusable = true}, SHIFT(1866),
  [3574] = {.count = 1, .reusable = true}, SHIFT(1847),
  [3576] = {.count = 1, .reusable = true}, SHIFT(1848),
  [3578] = {.count = 1, .reusable = true}, SHIFT(1849),
  [3580] = {.count = 1, .reusable = true}, SHIFT(1850),
  [3582] = {.count = 1, .reusable = false}, SHIFT(1866),
  [3584] = {.count = 1, .reusable = false}, SHIFT(1851),
  [3586] = {.count = 1, .reusable = true}, SHIFT(1852),
  [3588] = {.count = 1, .reusable = false}, SHIFT(1853),
  [3590] = {.count = 1, .reusable = false}, SHIFT(1854),
  [3592] = {.count = 1, .reusable = false}, SHIFT(1855),
  [3594] = {.count = 1, .reusable = false}, SHIFT(1856),
  [3596] = {.count = 1, .reusable = false}, SHIFT(1857),
  [3598] = {.count = 1, .reusable = false}, SHIFT(1858),
  [3600] = {.count = 1, .reusable = false}, SHIFT(1859),
  [3602] = {.count = 1, .reusable = false}, SHIFT(1860),
  [3604] = {.count = 1, .reusable = false}, SHIFT(1861),
  [3606] = {.count = 1, .reusable = false}, SHIFT(1862),
  [3608] = {.count = 1, .reusable = false}, SHIFT(1863),
  [3610] = {.count = 1, .reusable = true}, SHIFT(1863),
  [3612] = {.count = 1, .reusable = true}, SHIFT(1867),
  [3614] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(103),
  [3617] = {.count = 1, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1),
  [3619] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(4),
  [3622] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(65),
  [3625] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(6),
  [3628] = {.count = 1, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1),
  [3630] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(66),
  [3633] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(8),
  [3636] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(67),
  [3639] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(10),
  [3642] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(12),
  [3645] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(13),
  [3648] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(14),
  [3651] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(68),
  [3654] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(16),
  [3657] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(18),
  [3660] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(69),
  [3663] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(70),
  [3666] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(71),
  [3669] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(72),
  [3672] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(73),
  [3675] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(74),
  [3678] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(75),
  [3681] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(76),
  [3684] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(41),
  [3687] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(42),
  [3690] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(78),
  [3693] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(44),
  [3696] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(45),
  [3699] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(44),
  [3702] = {.count = 1, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1, .alias_sequence_id = 3),
  [3704] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), REDUCE(aux_sym_token_tree_repeat1, 1, .alias_sequence_id = 3),
  [3707] = {.count = 1, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1, .alias_sequence_id = 3),
  [3709] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), REDUCE(aux_sym_token_tree_repeat1, 1, .alias_sequence_id = 3),
  [3712] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(106),
  [3715] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(277),
  [3718] = {.count = 1, .reusable = false}, SHIFT(67),
  [3720] = {.count = 1, .reusable = false}, SHIFT(12),
  [3722] = {.count = 1, .reusable = false}, SHIFT(13),
  [3724] = {.count = 1, .reusable = false}, SHIFT(68),
  [3726] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(110),
  [3729] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(111),
  [3732] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(112),
  [3735] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(113),
  [3738] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(114),
  [3741] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(115),
  [3744] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(116),
  [3747] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(117),
  [3750] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(132),
  [3753] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(118),
  [3756] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(121),
  [3759] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(122),
  [3762] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(123),
  [3765] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(148),
  [3768] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(133),
  [3771] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(134),
  [3774] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(135),
  [3777] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(136),
  [3780] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(137),
  [3783] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(138),
  [3786] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(139),
  [3789] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(140),
  [3792] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(141),
  [3795] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(143),
  [3798] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(144),
  [3801] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(145),
  [3804] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(146),
  [3807] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(147),
  [3810] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(147),
  [3813] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(154),
  [3816] = {.count = 2, .reusable = true}, REDUCE(sym_break_expression, 1), REDUCE(aux_sym_token_tree_repeat1, 1),
  [3819] = {.count = 2, .reusable = false}, REDUCE(sym_break_expression, 1), REDUCE(aux_sym_token_tree_repeat1, 1),
  [3822] = {.count = 2, .reusable = true}, REDUCE(sym_continue_expression, 1), REDUCE(aux_sym_token_tree_repeat1, 1),
  [3825] = {.count = 2, .reusable = false}, REDUCE(sym_continue_expression, 1), REDUCE(aux_sym_token_tree_repeat1, 1),
  [3828] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), REDUCE(aux_sym_token_tree_repeat1, 1),
  [3831] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), REDUCE(aux_sym_token_tree_repeat1, 1),
  [3834] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(279),
  [3837] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(161),
  [3840] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(279),
  [3843] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(162),
  [3846] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(163),
  [3849] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(165),
  [3852] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(281),
  [3855] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(167),
  [3858] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(168),
  [3861] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(169),
  [3864] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(170),
  [3867] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(171),
  [3870] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(172),
  [3873] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(280),
  [3876] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(174),
  [3879] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(176),
  [3882] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(177),
  [3885] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(178),
  [3888] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(177),
  [3891] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(283),
  [3894] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(284),
  [3897] = {.count = 3, .reusable = true}, REDUCE(sym_return_expression, 1), REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(4),
  [3901] = {.count = 2, .reusable = true}, REDUCE(sym_return_expression, 1), REDUCE(aux_sym_token_tree_repeat1, 1),
  [3904] = {.count = 3, .reusable = true}, REDUCE(sym_return_expression, 1), REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(6),
  [3908] = {.count = 2, .reusable = false}, REDUCE(sym_return_expression, 1), REDUCE(aux_sym_token_tree_repeat1, 1),
  [3911] = {.count = 3, .reusable = false}, REDUCE(sym_return_expression, 1), REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(66),
  [3915] = {.count = 3, .reusable = false}, REDUCE(sym_return_expression, 1), REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(67),
  [3919] = {.count = 3, .reusable = false}, REDUCE(sym_return_expression, 1), REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(12),
  [3923] = {.count = 3, .reusable = false}, REDUCE(sym_return_expression, 1), REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(13),
  [3927] = {.count = 3, .reusable = false}, REDUCE(sym_return_expression, 1), REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(68),
  [3931] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(287),
  [3934] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(286),
  [3937] = {.count = 1, .reusable = true}, SHIFT(1869),
  [3939] = {.count = 1, .reusable = true}, SHIFT(1868),
  [3941] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(aux_sym_token_tree_repeat1, 1),
  [3944] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(221),
  [3947] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(aux_sym_token_tree_repeat1, 1),
  [3950] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(222),
  [3953] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(289),
  [3956] = {.count = 1, .reusable = true}, SHIFT(1870),
  [3958] = {.count = 1, .reusable = true}, SHIFT(1871),
  [3960] = {.count = 1, .reusable = true}, SHIFT(1878),
  [3962] = {.count = 1, .reusable = true}, SHIFT(1873),
  [3964] = {.count = 1, .reusable = true}, SHIFT(1874),
  [3966] = {.count = 1, .reusable = true}, SHIFT(1875),
  [3968] = {.count = 1, .reusable = true}, SHIFT(1876),
  [3970] = {.count = 1, .reusable = false}, SHIFT(1878),
  [3972] = {.count = 1, .reusable = false}, SHIFT(1877),
  [3974] = {.count = 2, .reusable = true}, REDUCE(sym_empty_statement, 1), REDUCE(aux_sym_token_tree_repeat1, 1),
  [3977] = {.count = 2, .reusable = false}, REDUCE(sym_empty_statement, 1), REDUCE(aux_sym_token_tree_repeat1, 1),
  [3980] = {.count = 1, .reusable = true}, SHIFT(1879),
  [3982] = {.count = 1, .reusable = true}, SHIFT(1881),
  [3984] = {.count = 1, .reusable = true}, SHIFT(1884),
  [3986] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(83),
  [3989] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(84),
  [3992] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(85),
  [3995] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(308),
  [3998] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(87),
  [4001] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(309),
  [4004] = {.count = 1, .reusable = false}, SHIFT(84),
  [4006] = {.count = 1, .reusable = false}, SHIFT(85),
  [4008] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(108),
  [4011] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(109),
  [4014] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), REDUCE(aux_sym_function_modifiers_repeat1, 1),
  [4017] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(157),
  [4020] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(159),
  [4023] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(160),
  [4026] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(160),
  [4029] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(166),
  [4032] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(166),
  [4035] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(312),
  [4038] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(311),
  [4041] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(183),
  [4044] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(184),
  [4047] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(185),
  [4050] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(122),
  [4053] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(192),
  [4056] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(192),
  [4059] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(188),
  [4062] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(189),
  [4065] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(191),
  [4068] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(5),
  [4071] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(194),
  [4074] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(195),
  [4077] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(196),
  [4080] = {.count = 2, .reusable = false}, REDUCE(sym_visibility_modifier, 1), REDUCE(aux_sym_token_tree_repeat1, 1),
  [4083] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(313),
  [4086] = {.count = 3, .reusable = false}, REDUCE(sym_return_expression, 1), REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(83),
  [4090] = {.count = 3, .reusable = false}, REDUCE(sym_return_expression, 1), REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(84),
  [4094] = {.count = 3, .reusable = false}, REDUCE(sym_return_expression, 1), REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(85),
  [4098] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(198),
  [4101] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(199),
  [4104] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(200),
  [4107] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(201),
  [4110] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(202),
  [4113] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(203),
  [4116] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(204),
  [4119] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(206),
  [4122] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(207),
  [4125] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(208),
  [4128] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(209),
  [4131] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(210),
  [4134] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(210),
  [4137] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(215),
  [4140] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(214),
  [4143] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(223),
  [4146] = {.count = 1, .reusable = true}, SHIFT(1886),
  [4148] = {.count = 1, .reusable = true}, SHIFT(1887),
  [4150] = {.count = 1, .reusable = false}, SHIFT(1887),
  [4152] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(763),
  [4155] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(764),
  [4158] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(765),
  [4161] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(766),
  [4164] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(767),
  [4167] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(1426),
  [4170] = {.count = 1, .reusable = false}, SHIFT(764),
  [4172] = {.count = 1, .reusable = false}, SHIFT(765),
  [4174] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(1429),
  [4177] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(1428),
  [4180] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(1430),
  [4183] = {.count = 3, .reusable = false}, REDUCE(sym_return_expression, 1), REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(763),
  [4187] = {.count = 3, .reusable = false}, REDUCE(sym_return_expression, 1), REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(764),
  [4191] = {.count = 3, .reusable = false}, REDUCE(sym_return_expression, 1), REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(765),
  [4195] = {.count = 1, .reusable = true}, SHIFT(1888),
  [4197] = {.count = 1, .reusable = true}, SHIFT(1890),
  [4199] = {.count = 1, .reusable = false}, SHIFT(1890),
  [4201] = {.count = 1, .reusable = true}, SHIFT(1892),
  [4203] = {.count = 1, .reusable = true}, SHIFT(1893),
  [4205] = {.count = 1, .reusable = true}, SHIFT(1895),
  [4207] = {.count = 1, .reusable = true}, SHIFT(1896),
  [4209] = {.count = 1, .reusable = true}, SHIFT(1897),
  [4211] = {.count = 1, .reusable = false}, SHIFT(1907),
  [4213] = {.count = 1, .reusable = true}, SHIFT(1913),
  [4215] = {.count = 1, .reusable = false}, SHIFT(1913),
  [4217] = {.count = 1, .reusable = true}, SHIFT(1914),
  [4219] = {.count = 1, .reusable = true}, SHIFT(1915),
  [4221] = {.count = 1, .reusable = true}, SHIFT(1916),
  [4223] = {.count = 1, .reusable = true}, SHIFT(1917),
  [4225] = {.count = 1, .reusable = true}, SHIFT(1918),
  [4227] = {.count = 1, .reusable = true}, SHIFT(1919),
  [4229] = {.count = 1, .reusable = true}, SHIFT(1920),
  [4231] = {.count = 1, .reusable = true}, SHIFT(1927),
  [4233] = {.count = 1, .reusable = true}, SHIFT(1928),
  [4235] = {.count = 1, .reusable = true}, SHIFT(1931),
  [4237] = {.count = 1, .reusable = true}, SHIFT(1936),
  [4239] = {.count = 1, .reusable = true}, SHIFT(1937),
  [4241] = {.count = 1, .reusable = true}, SHIFT(1938),
  [4243] = {.count = 1, .reusable = true}, SHIFT(1939),
  [4245] = {.count = 1, .reusable = false}, SHIFT(1941),
  [4247] = {.count = 1, .reusable = true}, SHIFT(1942),
  [4249] = {.count = 1, .reusable = true}, SHIFT(1943),
  [4251] = {.count = 1, .reusable = false}, SHIFT(1944),
  [4253] = {.count = 1, .reusable = false}, SHIFT(1918),
  [4255] = {.count = 1, .reusable = true}, SHIFT(1945),
  [4257] = {.count = 1, .reusable = true}, SHIFT(1946),
  [4259] = {.count = 1, .reusable = true}, SHIFT(1947),
  [4261] = {.count = 1, .reusable = true}, SHIFT(1948),
  [4263] = {.count = 1, .reusable = true}, SHIFT(1950),
  [4265] = {.count = 1, .reusable = true}, SHIFT(1951),
  [4267] = {.count = 1, .reusable = true}, SHIFT(1952),
  [4269] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_list, 3),
  [4271] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_list, 3),
  [4273] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(591),
  [4276] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(592),
  [4279] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_list_repeat1, 2),
  [4281] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(594),
  [4284] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(595),
  [4287] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(62),
  [4290] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(596),
  [4293] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(597),
  [4296] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(598),
  [4299] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(599),
  [4302] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(600),
  [4305] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(29),
  [4308] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(601),
  [4311] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(602),
  [4314] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(603),
  [4317] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(604),
  [4320] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(605),
  [4323] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(606),
  [4326] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(607),
  [4329] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(608),
  [4332] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(609),
  [4335] = {.count = 1, .reusable = true}, REDUCE(sym_enum_item, 4, .alias_sequence_id = 6),
  [4337] = {.count = 1, .reusable = false}, REDUCE(sym_enum_item, 4, .alias_sequence_id = 6),
  [4339] = {.count = 1, .reusable = true}, REDUCE(sym_mod_item, 4),
  [4341] = {.count = 1, .reusable = false}, REDUCE(sym_mod_item, 4),
  [4343] = {.count = 1, .reusable = true}, SHIFT(1956),
  [4345] = {.count = 1, .reusable = true}, REDUCE(sym_struct_item, 4, .alias_sequence_id = 6),
  [4347] = {.count = 1, .reusable = false}, REDUCE(sym_struct_item, 4, .alias_sequence_id = 6),
  [4349] = {.count = 1, .reusable = true}, SHIFT(1957),
  [4351] = {.count = 1, .reusable = true}, REDUCE(sym_trait_item, 4, .alias_sequence_id = 6),
  [4353] = {.count = 1, .reusable = false}, REDUCE(sym_trait_item, 4, .alias_sequence_id = 6),
  [4355] = {.count = 1, .reusable = true}, SHIFT(1964),
  [4357] = {.count = 1, .reusable = true}, REDUCE(sym_union_item, 4, .alias_sequence_id = 6),
  [4359] = {.count = 1, .reusable = false}, REDUCE(sym_union_item, 4, .alias_sequence_id = 6),
  [4361] = {.count = 1, .reusable = true}, SHIFT(1965),
  [4363] = {.count = 1, .reusable = true}, REDUCE(sym_use_declaration, 4),
  [4365] = {.count = 1, .reusable = false}, REDUCE(sym_use_declaration, 4),
  [4367] = {.count = 1, .reusable = true}, SHIFT(1968),
  [4369] = {.count = 1, .reusable = true}, SHIFT(1969),
  [4371] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 3),
  [4373] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 3),
  [4375] = {.count = 1, .reusable = true}, SHIFT(1972),
  [4377] = {.count = 1, .reusable = true}, SHIFT(1971),
  [4379] = {.count = 1, .reusable = true}, SHIFT(1973),
  [4381] = {.count = 1, .reusable = true}, SHIFT(1975),
  [4383] = {.count = 1, .reusable = false}, SHIFT(1975),
  [4385] = {.count = 1, .reusable = true}, SHIFT(1977),
  [4387] = {.count = 1, .reusable = true}, REDUCE(sym_index_expression, 4),
  [4389] = {.count = 1, .reusable = false}, REDUCE(sym_index_expression, 4),
  [4391] = {.count = 1, .reusable = true}, SHIFT(1978),
  [4393] = {.count = 1, .reusable = true}, SHIFT(1979),
  [4395] = {.count = 1, .reusable = true}, SHIFT(1980),
  [4397] = {.count = 1, .reusable = true}, SHIFT(1981),
  [4399] = {.count = 1, .reusable = true}, SHIFT(1982),
  [4401] = {.count = 1, .reusable = true}, SHIFT(1983),
  [4403] = {.count = 1, .reusable = true}, SHIFT(1984),
  [4405] = {.count = 1, .reusable = true}, SHIFT(1985),
  [4407] = {.count = 1, .reusable = true}, SHIFT(1986),
  [4409] = {.count = 1, .reusable = true}, SHIFT(1987),
  [4411] = {.count = 1, .reusable = true}, SHIFT(1988),
  [4413] = {.count = 1, .reusable = true}, SHIFT(1989),
  [4415] = {.count = 1, .reusable = true}, SHIFT(1990),
  [4417] = {.count = 1, .reusable = false}, SHIFT(1991),
  [4419] = {.count = 1, .reusable = false}, SHIFT(1992),
  [4421] = {.count = 1, .reusable = false}, REDUCE(sym_unit_type, 2),
  [4423] = {.count = 1, .reusable = true}, SHIFT(1996),
  [4425] = {.count = 1, .reusable = true}, SHIFT(1997),
  [4427] = {.count = 1, .reusable = true}, SHIFT(1999),
  [4429] = {.count = 1, .reusable = true}, SHIFT(2000),
  [4431] = {.count = 1, .reusable = true}, SHIFT(2002),
  [4433] = {.count = 1, .reusable = false}, REDUCE(sym_reference_type, 2),
  [4435] = {.count = 1, .reusable = false}, SHIFT(2004),
  [4437] = {.count = 1, .reusable = true}, SHIFT(2005),
  [4439] = {.count = 1, .reusable = true}, SHIFT(2006),
  [4441] = {.count = 1, .reusable = false}, SHIFT(2007),
  [4443] = {.count = 1, .reusable = false}, REDUCE(sym_function_type, 2),
  [4445] = {.count = 1, .reusable = true}, SHIFT(2010),
  [4447] = {.count = 1, .reusable = true}, SHIFT(2011),
  [4449] = {.count = 1, .reusable = false}, REDUCE(sym_function_type, 2, .alias_sequence_id = 4),
  [4451] = {.count = 1, .reusable = true}, SHIFT(2012),
  [4453] = {.count = 1, .reusable = true}, SHIFT(2015),
  [4455] = {.count = 1, .reusable = true}, SHIFT(2017),
  [4457] = {.count = 1, .reusable = true}, SHIFT(2018),
  [4459] = {.count = 1, .reusable = false}, SHIFT(2019),
  [4461] = {.count = 1, .reusable = true}, SHIFT(2020),
  [4463] = {.count = 1, .reusable = true}, SHIFT(2021),
  [4465] = {.count = 1, .reusable = true}, REDUCE(sym_closure_expression, 4),
  [4467] = {.count = 1, .reusable = false}, REDUCE(sym_closure_expression, 4),
  [4469] = {.count = 1, .reusable = true}, SHIFT(2024),
  [4471] = {.count = 1, .reusable = true}, REDUCE(sym_loop_expression, 4),
  [4473] = {.count = 1, .reusable = false}, REDUCE(sym_loop_expression, 4),
  [4475] = {.count = 1, .reusable = true}, SHIFT(2025),
  [4477] = {.count = 1, .reusable = false}, SHIFT(2025),
  [4479] = {.count = 1, .reusable = true}, SHIFT(2028),
  [4481] = {.count = 1, .reusable = true}, SHIFT(2027),
  [4483] = {.count = 1, .reusable = false}, SHIFT(2028),
  [4485] = {.count = 1, .reusable = true}, REDUCE(sym_token_tree_pattern, 2),
  [4487] = {.count = 1, .reusable = true}, SHIFT(2029),
  [4489] = {.count = 1, .reusable = false}, SHIFT(2029),
  [4491] = {.count = 1, .reusable = true}, SHIFT(2030),
  [4493] = {.count = 1, .reusable = false}, SHIFT(2030),
  [4495] = {.count = 1, .reusable = true}, SHIFT(2031),
  [4497] = {.count = 1, .reusable = true}, REDUCE(sym__token_pattern, 1, .alias_sequence_id = 3),
  [4499] = {.count = 1, .reusable = false}, REDUCE(sym__token_pattern, 1, .alias_sequence_id = 3),
  [4501] = {.count = 1, .reusable = true}, REDUCE(sym__token_pattern, 1),
  [4503] = {.count = 1, .reusable = false}, SHIFT(2032),
  [4505] = {.count = 1, .reusable = false}, REDUCE(sym__token_pattern, 1),
  [4507] = {.count = 1, .reusable = true}, SHIFT(2034),
  [4509] = {.count = 1, .reusable = true}, SHIFT(2033),
  [4511] = {.count = 1, .reusable = false}, SHIFT(2034),
  [4513] = {.count = 1, .reusable = true}, REDUCE(sym_macro_definition, 5),
  [4515] = {.count = 1, .reusable = false}, REDUCE(sym_macro_definition, 5),
  [4517] = {.count = 1, .reusable = true}, SHIFT(2035),
  [4519] = {.count = 1, .reusable = false}, SHIFT(2035),
  [4521] = {.count = 1, .reusable = true}, SHIFT(2036),
  [4523] = {.count = 1, .reusable = false}, SHIFT(2036),
  [4525] = {.count = 1, .reusable = true}, REDUCE(aux_sym_macro_definition_repeat1, 2),
  [4527] = {.count = 1, .reusable = true}, SHIFT(2037),
  [4529] = {.count = 1, .reusable = true}, SHIFT(2039),
  [4531] = {.count = 2, .reusable = true}, REDUCE(aux_sym_macro_definition_repeat1, 2), SHIFT_REPEAT(685),
  [4534] = {.count = 2, .reusable = true}, REDUCE(aux_sym_macro_definition_repeat1, 2), SHIFT_REPEAT(687),
  [4537] = {.count = 2, .reusable = true}, REDUCE(aux_sym_macro_definition_repeat1, 2), SHIFT_REPEAT(688),
  [4540] = {.count = 1, .reusable = true}, SHIFT(2042),
  [4542] = {.count = 1, .reusable = true}, SHIFT(71),
  [4544] = {.count = 1, .reusable = true}, SHIFT(2044),
  [4546] = {.count = 1, .reusable = true}, SHIFT(2046),
  [4548] = {.count = 1, .reusable = true}, SHIFT(2047),
  [4550] = {.count = 1, .reusable = true}, SHIFT(2048),
  [4552] = {.count = 1, .reusable = true}, SHIFT(2050),
  [4554] = {.count = 1, .reusable = true}, SHIFT(2051),
  [4556] = {.count = 1, .reusable = true}, SHIFT(2052),
  [4558] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_expression, 5),
  [4560] = {.count = 1, .reusable = false}, REDUCE(sym_tuple_expression, 5),
  [4562] = {.count = 1, .reusable = true}, REDUCE(aux_sym_tuple_expression_repeat1, 2),
  [4564] = {.count = 1, .reusable = false}, REDUCE(aux_sym_tuple_expression_repeat1, 2),
  [4566] = {.count = 1, .reusable = true}, SHIFT(2054),
  [4568] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(2061),
  [4571] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(4),
  [4574] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(65),
  [4577] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(6),
  [4580] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(2055),
  [4583] = {.count = 2, .reusable = false}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(8),
  [4586] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(2056),
  [4589] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(10),
  [4592] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(12),
  [4595] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(13),
  [4598] = {.count = 2, .reusable = false}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(14),
  [4601] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(2057),
  [4604] = {.count = 2, .reusable = false}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(16),
  [4607] = {.count = 2, .reusable = false}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(18),
  [4610] = {.count = 2, .reusable = false}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(69),
  [4613] = {.count = 2, .reusable = false}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(70),
  [4616] = {.count = 2, .reusable = false}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(2058),
  [4619] = {.count = 2, .reusable = false}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(72),
  [4622] = {.count = 2, .reusable = false}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(73),
  [4625] = {.count = 2, .reusable = false}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(2059),
  [4628] = {.count = 2, .reusable = false}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(75),
  [4631] = {.count = 2, .reusable = false}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(76),
  [4634] = {.count = 2, .reusable = false}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(2060),
  [4637] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(41),
  [4640] = {.count = 2, .reusable = false}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(42),
  [4643] = {.count = 2, .reusable = false}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(78),
  [4646] = {.count = 2, .reusable = false}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(44),
  [4649] = {.count = 2, .reusable = false}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(45),
  [4652] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(44),
  [4655] = {.count = 1, .reusable = false}, SHIFT(2063),
  [4657] = {.count = 1, .reusable = true}, SHIFT(2064),
  [4659] = {.count = 1, .reusable = true}, SHIFT(2065),
  [4661] = {.count = 1, .reusable = true}, SHIFT(2068),
  [4663] = {.count = 1, .reusable = true}, SHIFT(2069),
  [4665] = {.count = 1, .reusable = false}, SHIFT(2069),
  [4667] = {.count = 1, .reusable = true}, SHIFT(2071),
  [4669] = {.count = 1, .reusable = true}, SHIFT(2072),
  [4671] = {.count = 1, .reusable = true}, SHIFT(2073),
  [4673] = {.count = 1, .reusable = true}, SHIFT(86),
  [4675] = {.count = 1, .reusable = false}, SHIFT(2074),
  [4677] = {.count = 1, .reusable = true}, SHIFT(2075),
  [4679] = {.count = 1, .reusable = true}, SHIFT(2076),
  [4681] = {.count = 1, .reusable = true}, SHIFT(2079),
  [4683] = {.count = 1, .reusable = true}, SHIFT(97),
  [4685] = {.count = 1, .reusable = true}, REDUCE(sym_array_expression, 5),
  [4687] = {.count = 1, .reusable = false}, REDUCE(sym_array_expression, 5),
  [4689] = {.count = 1, .reusable = true}, SHIFT(2080),
  [4691] = {.count = 1, .reusable = false}, SHIFT(2080),
  [4693] = {.count = 1, .reusable = true}, SHIFT(2082),
  [4695] = {.count = 1, .reusable = true}, SHIFT(2083),
  [4697] = {.count = 1, .reusable = true}, SHIFT(2084),
  [4699] = {.count = 1, .reusable = true}, SHIFT(2085),
  [4701] = {.count = 1, .reusable = true}, SHIFT(2086),
  [4703] = {.count = 1, .reusable = true}, SHIFT(2087),
  [4705] = {.count = 1, .reusable = true}, SHIFT(2088),
  [4707] = {.count = 1, .reusable = true}, SHIFT(2089),
  [4709] = {.count = 1, .reusable = true}, SHIFT(2090),
  [4711] = {.count = 1, .reusable = true}, SHIFT(2091),
  [4713] = {.count = 1, .reusable = true}, SHIFT(2092),
  [4715] = {.count = 1, .reusable = true}, SHIFT(2093),
  [4717] = {.count = 1, .reusable = true}, SHIFT(2094),
  [4719] = {.count = 1, .reusable = true}, SHIFT(2095),
  [4721] = {.count = 1, .reusable = false}, SHIFT(2096),
  [4723] = {.count = 1, .reusable = false}, SHIFT(2097),
  [4725] = {.count = 1, .reusable = false}, SHIFT(2101),
  [4727] = {.count = 1, .reusable = true}, SHIFT(2102),
  [4729] = {.count = 1, .reusable = true}, SHIFT(2103),
  [4731] = {.count = 1, .reusable = true}, SHIFT(2106),
  [4733] = {.count = 1, .reusable = true}, SHIFT(102),
  [4735] = {.count = 1, .reusable = true}, REDUCE(sym_meta_item, 3),
  [4737] = {.count = 1, .reusable = true}, SHIFT(2107),
  [4739] = {.count = 1, .reusable = true}, SHIFT(2108),
  [4741] = {.count = 1, .reusable = true}, REDUCE(sym_inner_attribute_item, 5),
  [4743] = {.count = 1, .reusable = false}, REDUCE(sym_inner_attribute_item, 5),
  [4745] = {.count = 1, .reusable = true}, SHIFT(2110),
  [4747] = {.count = 1, .reusable = true}, SHIFT(2111),
  [4749] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_type, 4),
  [4751] = {.count = 1, .reusable = true}, REDUCE(aux_sym_tuple_type_repeat1, 2),
  [4753] = {.count = 1, .reusable = true}, SHIFT(2112),
  [4755] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_type_repeat1, 2), SHIFT_REPEAT(2113),
  [4758] = {.count = 1, .reusable = true}, SHIFT(2114),
  [4760] = {.count = 1, .reusable = true}, SHIFT(2115),
  [4762] = {.count = 1, .reusable = true}, SHIFT(2116),
  [4764] = {.count = 1, .reusable = true}, REDUCE(sym_reference_type, 4),
  [4766] = {.count = 1, .reusable = true}, REDUCE(sym_parameters, 3),
  [4768] = {.count = 1, .reusable = true}, SHIFT(2119),
  [4770] = {.count = 1, .reusable = false}, SHIFT(2120),
  [4772] = {.count = 1, .reusable = true}, SHIFT(2123),
  [4774] = {.count = 1, .reusable = true}, SHIFT(2125),
  [4776] = {.count = 1, .reusable = true}, SHIFT(2126),
  [4778] = {.count = 1, .reusable = true}, SHIFT(2127),
  [4780] = {.count = 1, .reusable = false}, SHIFT(2128),
  [4782] = {.count = 1, .reusable = false}, SHIFT(2129),
  [4784] = {.count = 1, .reusable = false}, SHIFT(2130),
  [4786] = {.count = 1, .reusable = true}, REDUCE(sym_self_parameter, 2),
  [4788] = {.count = 1, .reusable = false}, SHIFT(2131),
  [4790] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_type, 2, .alias_sequence_id = 2),
  [4792] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_type, 2, .alias_sequence_id = 2),
  [4794] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_type, 2),
  [4796] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_type, 2),
  [4798] = {.count = 1, .reusable = true}, SHIFT(2132),
  [4800] = {.count = 1, .reusable = true}, SHIFT(2133),
  [4802] = {.count = 1, .reusable = true}, SHIFT(2134),
  [4804] = {.count = 1, .reusable = false}, SHIFT(2135),
  [4806] = {.count = 1, .reusable = false}, SHIFT(429),
  [4808] = {.count = 1, .reusable = true}, SHIFT(2136),
  [4810] = {.count = 1, .reusable = true}, REDUCE(sym_function_type, 4),
  [4812] = {.count = 1, .reusable = true}, SHIFT(2137),
  [4814] = {.count = 1, .reusable = true}, SHIFT(2138),
  [4816] = {.count = 1, .reusable = true}, SHIFT(2140),
  [4818] = {.count = 1, .reusable = true}, SHIFT(2141),
  [4820] = {.count = 1, .reusable = true}, SHIFT(2142),
  [4822] = {.count = 1, .reusable = false}, SHIFT(2144),
  [4824] = {.count = 1, .reusable = true}, SHIFT(2145),
  [4826] = {.count = 1, .reusable = true}, SHIFT(2147),
  [4828] = {.count = 1, .reusable = true}, SHIFT(2150),
  [4830] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 3),
  [4832] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 3),
  [4834] = {.count = 1, .reusable = true}, SHIFT(2154),
  [4836] = {.count = 1, .reusable = true}, REDUCE(sym_function_type, 4, .alias_sequence_id = 4),
  [4838] = {.count = 1, .reusable = false}, SHIFT(2160),
  [4840] = {.count = 1, .reusable = true}, SHIFT(2161),
  [4842] = {.count = 1, .reusable = true}, SHIFT(2162),
  [4844] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_pattern, 4),
  [4846] = {.count = 1, .reusable = true}, REDUCE(aux_sym_tuple_pattern_repeat1, 2),
  [4848] = {.count = 1, .reusable = true}, SHIFT(2165),
  [4850] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_pattern_repeat1, 2), SHIFT_REPEAT(2166),
  [4853] = {.count = 1, .reusable = false}, SHIFT(2167),
  [4855] = {.count = 1, .reusable = true}, SHIFT(2168),
  [4857] = {.count = 1, .reusable = true}, SHIFT(2169),
  [4859] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_pattern_in_parameter, 3),
  [4861] = {.count = 1, .reusable = false}, SHIFT(2172),
  [4863] = {.count = 1, .reusable = true}, SHIFT(2173),
  [4865] = {.count = 1, .reusable = false}, SHIFT(2174),
  [4867] = {.count = 1, .reusable = true}, SHIFT(2175),
  [4869] = {.count = 1, .reusable = true}, REDUCE(sym_parameter, 4, .alias_sequence_id = 11),
  [4871] = {.count = 1, .reusable = true}, REDUCE(sym_parameter, 4),
  [4873] = {.count = 1, .reusable = true}, SHIFT(2177),
  [4875] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_struct_pattern, 4),
  [4877] = {.count = 1, .reusable = true}, SHIFT(2178),
  [4879] = {.count = 1, .reusable = true}, SHIFT(2179),
  [4881] = {.count = 1, .reusable = true}, REDUCE(sym_struct_pattern, 4, .alias_sequence_id = 4),
  [4883] = {.count = 1, .reusable = true}, REDUCE(sym_field_pattern, 2, .alias_sequence_id = 12),
  [4885] = {.count = 1, .reusable = true}, SHIFT(2180),
  [4887] = {.count = 1, .reusable = true}, SHIFT(2181),
  [4889] = {.count = 1, .reusable = true}, SHIFT(2186),
  [4891] = {.count = 1, .reusable = false}, SHIFT(2186),
  [4893] = {.count = 1, .reusable = true}, SHIFT(2182),
  [4895] = {.count = 1, .reusable = false}, SHIFT(2183),
  [4897] = {.count = 1, .reusable = false}, SHIFT(2184),
  [4899] = {.count = 1, .reusable = false}, SHIFT(2185),
  [4901] = {.count = 1, .reusable = true}, SHIFT(2187),
  [4903] = {.count = 1, .reusable = true}, SHIFT(2189),
  [4905] = {.count = 1, .reusable = true}, REDUCE(sym_struct_pattern, 4),
  [4907] = {.count = 1, .reusable = true}, SHIFT(2191),
  [4909] = {.count = 1, .reusable = true}, SHIFT(2192),
  [4911] = {.count = 1, .reusable = false}, SHIFT(2193),
  [4913] = {.count = 1, .reusable = true}, SHIFT(2194),
  [4915] = {.count = 1, .reusable = true}, SHIFT(2195),
  [4917] = {.count = 1, .reusable = true}, SHIFT(2198),
  [4919] = {.count = 1, .reusable = true}, REDUCE(sym_enum_variant_list, 3),
  [4921] = {.count = 1, .reusable = false}, REDUCE(sym_enum_variant_list, 3),
  [4923] = {.count = 1, .reusable = true}, SHIFT(2199),
  [4925] = {.count = 1, .reusable = true}, SHIFT(2200),
  [4927] = {.count = 1, .reusable = true}, SHIFT(2201),
  [4929] = {.count = 1, .reusable = true}, SHIFT(2202),
  [4931] = {.count = 1, .reusable = true}, SHIFT(2205),
  [4933] = {.count = 1, .reusable = true}, REDUCE(sym_enum_variant, 2),
  [4935] = {.count = 1, .reusable = true}, SHIFT(2206),
  [4937] = {.count = 1, .reusable = true}, SHIFT(2207),
  [4939] = {.count = 1, .reusable = true}, SHIFT(2210),
  [4941] = {.count = 1, .reusable = false}, REDUCE(aux_sym_enum_variant_list_repeat1, 2),
  [4943] = {.count = 1, .reusable = true}, SHIFT(2214),
  [4945] = {.count = 1, .reusable = false}, SHIFT(2215),
  [4947] = {.count = 1, .reusable = false}, SHIFT(2221),
  [4949] = {.count = 1, .reusable = false}, SHIFT(2222),
  [4951] = {.count = 1, .reusable = true}, SHIFT(2224),
  [4953] = {.count = 1, .reusable = true}, SHIFT(2225),
  [4955] = {.count = 1, .reusable = false}, SHIFT(2226),
  [4957] = {.count = 1, .reusable = true}, SHIFT(2227),
  [4959] = {.count = 1, .reusable = true}, SHIFT(2228),
  [4961] = {.count = 1, .reusable = true}, SHIFT(2229),
  [4963] = {.count = 1, .reusable = false}, SHIFT(2230),
  [4965] = {.count = 1, .reusable = false}, SHIFT(2231),
  [4967] = {.count = 1, .reusable = false}, SHIFT(2232),
  [4969] = {.count = 1, .reusable = true}, REDUCE(sym_where_predicate, 2, .alias_sequence_id = 4),
  [4971] = {.count = 1, .reusable = true}, REDUCE(sym_where_clause, 3),
  [4973] = {.count = 1, .reusable = true}, SHIFT(2238),
  [4975] = {.count = 1, .reusable = true}, REDUCE(sym_where_predicate, 2),
  [4977] = {.count = 1, .reusable = true}, REDUCE(sym_enum_item, 5, .alias_sequence_id = 2),
  [4979] = {.count = 1, .reusable = false}, REDUCE(sym_enum_item, 5, .alias_sequence_id = 2),
  [4981] = {.count = 1, .reusable = true}, REDUCE(sym_function_signature_item, 5),
  [4983] = {.count = 1, .reusable = false}, REDUCE(sym_function_signature_item, 5),
  [4985] = {.count = 1, .reusable = true}, SHIFT(2242),
  [4987] = {.count = 1, .reusable = true}, REDUCE(sym_function_item, 5),
  [4989] = {.count = 1, .reusable = false}, REDUCE(sym_function_item, 5),
  [4991] = {.count = 1, .reusable = true}, SHIFT(2244),
  [4993] = {.count = 1, .reusable = true}, SHIFT(2245),
  [4995] = {.count = 1, .reusable = true}, SHIFT(2246),
  [4997] = {.count = 1, .reusable = false}, SHIFT(2247),
  [4999] = {.count = 1, .reusable = false}, SHIFT(2251),
  [5001] = {.count = 1, .reusable = false}, SHIFT(2252),
  [5003] = {.count = 1, .reusable = true}, SHIFT(2254),
  [5005] = {.count = 1, .reusable = true}, SHIFT(2256),
  [5007] = {.count = 1, .reusable = false}, SHIFT(2257),
  [5009] = {.count = 1, .reusable = true}, SHIFT(2258),
  [5011] = {.count = 1, .reusable = true}, SHIFT(2257),
  [5013] = {.count = 1, .reusable = true}, REDUCE(sym_for_expression, 5),
  [5015] = {.count = 1, .reusable = false}, REDUCE(sym_for_expression, 5),
  [5017] = {.count = 1, .reusable = true}, SHIFT(2260),
  [5019] = {.count = 1, .reusable = true}, SHIFT(172),
  [5021] = {.count = 1, .reusable = false}, SHIFT(2262),
  [5023] = {.count = 1, .reusable = true}, SHIFT(2263),
  [5025] = {.count = 1, .reusable = true}, SHIFT(2264),
  [5027] = {.count = 1, .reusable = true}, REDUCE(sym_else_tail, 2),
  [5029] = {.count = 1, .reusable = false}, REDUCE(sym_else_tail, 2),
  [5031] = {.count = 1, .reusable = true}, SHIFT(2267),
  [5033] = {.count = 1, .reusable = false}, SHIFT(2268),
  [5035] = {.count = 1, .reusable = false}, SHIFT(2274),
  [5037] = {.count = 1, .reusable = false}, SHIFT(2275),
  [5039] = {.count = 1, .reusable = true}, SHIFT(2277),
  [5041] = {.count = 1, .reusable = true}, SHIFT(2279),
  [5043] = {.count = 1, .reusable = true}, REDUCE(aux_sym_type_parameters_repeat1, 2, .alias_sequence_id = 2),
  [5045] = {.count = 1, .reusable = true}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [5047] = {.count = 1, .reusable = true}, REDUCE(sym_optional_type_parameter, 3, .alias_sequence_id = 4),
  [5049] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 4, .alias_sequence_id = 2),
  [5051] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 4, .alias_sequence_id = 2),
  [5053] = {.count = 2, .reusable = true}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(990),
  [5056] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 4),
  [5058] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 4),
  [5060] = {.count = 1, .reusable = true}, REDUCE(sym_optional_type_parameter, 3),
  [5062] = {.count = 1, .reusable = false}, SHIFT(2280),
  [5064] = {.count = 1, .reusable = true}, SHIFT(2281),
  [5066] = {.count = 1, .reusable = true}, SHIFT(2282),
  [5068] = {.count = 1, .reusable = true}, REDUCE(sym_impl_item, 5, .alias_sequence_id = 2),
  [5070] = {.count = 1, .reusable = false}, REDUCE(sym_impl_item, 5, .alias_sequence_id = 2),
  [5072] = {.count = 1, .reusable = true}, REDUCE(sym_impl_item, 5, .alias_sequence_id = 6),
  [5074] = {.count = 1, .reusable = false}, REDUCE(sym_impl_item, 5, .alias_sequence_id = 6),
  [5076] = {.count = 1, .reusable = true}, REDUCE(sym_impl_item, 5),
  [5078] = {.count = 1, .reusable = false}, REDUCE(sym_impl_item, 5),
  [5080] = {.count = 1, .reusable = true}, SHIFT(2290),
  [5082] = {.count = 1, .reusable = true}, SHIFT(2291),
  [5084] = {.count = 1, .reusable = false}, SHIFT(2292),
  [5086] = {.count = 1, .reusable = true}, SHIFT(2293),
  [5088] = {.count = 1, .reusable = true}, SHIFT(2294),
  [5090] = {.count = 1, .reusable = true}, REDUCE(sym_let_declaration, 5),
  [5092] = {.count = 1, .reusable = false}, REDUCE(sym_let_declaration, 5),
  [5094] = {.count = 1, .reusable = true}, SHIFT(2297),
  [5096] = {.count = 1, .reusable = true}, SHIFT(2298),
  [5098] = {.count = 1, .reusable = true}, SHIFT(2299),
  [5100] = {.count = 1, .reusable = true}, SHIFT(2301),
  [5102] = {.count = 1, .reusable = true}, SHIFT(2302),
  [5104] = {.count = 1, .reusable = false}, SHIFT(2302),
  [5106] = {.count = 1, .reusable = true}, SHIFT(2306),
  [5108] = {.count = 1, .reusable = true}, SHIFT(2304),
  [5110] = {.count = 1, .reusable = true}, SHIFT(2305),
  [5112] = {.count = 1, .reusable = false}, SHIFT(2306),
  [5114] = {.count = 1, .reusable = true}, SHIFT(2307),
  [5116] = {.count = 1, .reusable = true}, SHIFT(2308),
  [5118] = {.count = 1, .reusable = true}, SHIFT(2310),
  [5120] = {.count = 1, .reusable = true}, SHIFT(2311),
  [5122] = {.count = 1, .reusable = false}, SHIFT(2311),
  [5124] = {.count = 1, .reusable = true}, SHIFT(2312),
  [5126] = {.count = 1, .reusable = true}, SHIFT(2313),
  [5128] = {.count = 1, .reusable = true}, SHIFT(2314),
  [5130] = {.count = 1, .reusable = true}, REDUCE(sym_match_expression, 5),
  [5132] = {.count = 1, .reusable = false}, REDUCE(sym_match_expression, 5),
  [5134] = {.count = 1, .reusable = true}, SHIFT(2323),
  [5136] = {.count = 1, .reusable = true}, SHIFT(2316),
  [5138] = {.count = 1, .reusable = false}, SHIFT(2317),
  [5140] = {.count = 1, .reusable = false}, SHIFT(2318),
  [5142] = {.count = 1, .reusable = false}, SHIFT(2319),
  [5144] = {.count = 1, .reusable = false}, SHIFT(2320),
  [5146] = {.count = 1, .reusable = false}, SHIFT(2321),
  [5148] = {.count = 1, .reusable = false}, SHIFT(2322),
  [5150] = {.count = 1, .reusable = false}, SHIFT(2326),
  [5152] = {.count = 1, .reusable = true}, SHIFT(2353),
  [5154] = {.count = 1, .reusable = true}, SHIFT(2327),
  [5156] = {.count = 1, .reusable = true}, SHIFT(2328),
  [5158] = {.count = 1, .reusable = true}, SHIFT(2329),
  [5160] = {.count = 1, .reusable = true}, SHIFT(2330),
  [5162] = {.count = 1, .reusable = false}, SHIFT(2331),
  [5164] = {.count = 1, .reusable = true}, SHIFT(2332),
  [5166] = {.count = 1, .reusable = true}, SHIFT(2333),
  [5168] = {.count = 1, .reusable = true}, SHIFT(2334),
  [5170] = {.count = 1, .reusable = false}, SHIFT(2335),
  [5172] = {.count = 1, .reusable = false}, SHIFT(2336),
  [5174] = {.count = 1, .reusable = false}, SHIFT(2337),
  [5176] = {.count = 1, .reusable = false}, SHIFT(2338),
  [5178] = {.count = 1, .reusable = false}, SHIFT(2339),
  [5180] = {.count = 1, .reusable = false}, SHIFT(2340),
  [5182] = {.count = 1, .reusable = false}, SHIFT(2341),
  [5184] = {.count = 1, .reusable = false}, SHIFT(2342),
  [5186] = {.count = 1, .reusable = false}, SHIFT(2343),
  [5188] = {.count = 1, .reusable = false}, SHIFT(2344),
  [5190] = {.count = 1, .reusable = false}, SHIFT(2345),
  [5192] = {.count = 1, .reusable = true}, SHIFT(2346),
  [5194] = {.count = 1, .reusable = false}, SHIFT(2347),
  [5196] = {.count = 1, .reusable = false}, SHIFT(2348),
  [5198] = {.count = 1, .reusable = false}, SHIFT(2349),
  [5200] = {.count = 1, .reusable = false}, SHIFT(2350),
  [5202] = {.count = 1, .reusable = true}, SHIFT(2349),
  [5204] = {.count = 1, .reusable = true}, REDUCE(sym_match_pattern, 2),
  [5206] = {.count = 1, .reusable = true}, SHIFT(2360),
  [5208] = {.count = 1, .reusable = true}, SHIFT(2362),
  [5210] = {.count = 1, .reusable = true}, SHIFT(1039),
  [5212] = {.count = 1, .reusable = true}, SHIFT(2363),
  [5214] = {.count = 2, .reusable = true}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT_REPEAT(1035),
  [5217] = {.count = 1, .reusable = true}, SHIFT(2364),
  [5219] = {.count = 2, .reusable = true}, REDUCE(aux_sym_match_expression_repeat1, 2), SHIFT_REPEAT(1048),
  [5222] = {.count = 2, .reusable = true}, REDUCE(aux_sym_match_expression_repeat1, 2), SHIFT_REPEAT(1030),
  [5225] = {.count = 2, .reusable = false}, REDUCE(aux_sym_match_expression_repeat1, 2), SHIFT_REPEAT(1032),
  [5228] = {.count = 2, .reusable = false}, REDUCE(aux_sym_match_expression_repeat1, 2), SHIFT_REPEAT(1047),
  [5231] = {.count = 2, .reusable = true}, REDUCE(aux_sym_match_expression_repeat1, 2), SHIFT_REPEAT(1033),
  [5234] = {.count = 2, .reusable = true}, REDUCE(aux_sym_match_expression_repeat1, 2), SHIFT_REPEAT(1034),
  [5237] = {.count = 2, .reusable = true}, REDUCE(aux_sym_match_expression_repeat1, 2), SHIFT_REPEAT(1035),
  [5240] = {.count = 2, .reusable = true}, REDUCE(aux_sym_match_expression_repeat1, 2), SHIFT_REPEAT(12),
  [5243] = {.count = 2, .reusable = true}, REDUCE(aux_sym_match_expression_repeat1, 2), SHIFT_REPEAT(1036),
  [5246] = {.count = 2, .reusable = false}, REDUCE(aux_sym_match_expression_repeat1, 2), SHIFT_REPEAT(1037),
  [5249] = {.count = 2, .reusable = false}, REDUCE(aux_sym_match_expression_repeat1, 2), SHIFT_REPEAT(1038),
  [5252] = {.count = 2, .reusable = true}, REDUCE(aux_sym_match_expression_repeat1, 2), SHIFT_REPEAT(391),
  [5255] = {.count = 2, .reusable = false}, REDUCE(aux_sym_match_expression_repeat1, 2), SHIFT_REPEAT(1039),
  [5258] = {.count = 2, .reusable = false}, REDUCE(aux_sym_match_expression_repeat1, 2), SHIFT_REPEAT(1040),
  [5261] = {.count = 2, .reusable = false}, REDUCE(aux_sym_match_expression_repeat1, 2), SHIFT_REPEAT(1041),
  [5264] = {.count = 2, .reusable = true}, REDUCE(aux_sym_match_expression_repeat1, 2), SHIFT_REPEAT(1041),
  [5267] = {.count = 1, .reusable = true}, REDUCE(sym_visibility_modifier, 5, .alias_sequence_id = 13),
  [5269] = {.count = 1, .reusable = true}, REDUCE(sym_visibility_modifier, 5),
  [5271] = {.count = 1, .reusable = true}, SHIFT(2367),
  [5273] = {.count = 1, .reusable = true}, SHIFT(2368),
  [5275] = {.count = 1, .reusable = true}, REDUCE(sym_static_item, 5),
  [5277] = {.count = 1, .reusable = false}, REDUCE(sym_static_item, 5),
  [5279] = {.count = 1, .reusable = true}, SHIFT(2369),
  [5281] = {.count = 1, .reusable = true}, REDUCE(sym_ordered_field_declaration_list, 3),
  [5283] = {.count = 1, .reusable = true}, SHIFT(2371),
  [5285] = {.count = 1, .reusable = true}, SHIFT(2372),
  [5287] = {.count = 1, .reusable = true}, SHIFT(2373),
  [5289] = {.count = 1, .reusable = true}, SHIFT(2374),
  [5291] = {.count = 2, .reusable = true}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT_REPEAT(1060),
  [5294] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration_list, 3),
  [5296] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration_list, 3),
  [5298] = {.count = 1, .reusable = true}, SHIFT(2381),
  [5300] = {.count = 1, .reusable = true}, SHIFT(2382),
  [5302] = {.count = 1, .reusable = false}, SHIFT(2383),
  [5304] = {.count = 1, .reusable = false}, SHIFT(2384),
  [5306] = {.count = 1, .reusable = true}, SHIFT(2389),
  [5308] = {.count = 1, .reusable = true}, SHIFT(2392),
  [5310] = {.count = 1, .reusable = true}, SHIFT(2394),
  [5312] = {.count = 1, .reusable = true}, SHIFT(2396),
  [5314] = {.count = 1, .reusable = true}, SHIFT(2397),
  [5316] = {.count = 1, .reusable = true}, SHIFT(2398),
  [5318] = {.count = 1, .reusable = false}, SHIFT(2399),
  [5320] = {.count = 1, .reusable = false}, SHIFT(2400),
  [5322] = {.count = 1, .reusable = false}, SHIFT(2401),
  [5324] = {.count = 1, .reusable = true}, SHIFT(2406),
  [5326] = {.count = 1, .reusable = false}, SHIFT(2408),
  [5328] = {.count = 1, .reusable = true}, SHIFT(2409),
  [5330] = {.count = 1, .reusable = true}, SHIFT(2408),
  [5332] = {.count = 1, .reusable = true}, REDUCE(sym_struct_item, 5, .alias_sequence_id = 2),
  [5334] = {.count = 1, .reusable = false}, REDUCE(sym_struct_item, 5, .alias_sequence_id = 2),
  [5336] = {.count = 1, .reusable = true}, SHIFT(2411),
  [5338] = {.count = 1, .reusable = true}, REDUCE(sym_removed_trait_bound, 2),
  [5340] = {.count = 1, .reusable = true}, SHIFT(2413),
  [5342] = {.count = 1, .reusable = true}, SHIFT(2414),
  [5344] = {.count = 1, .reusable = true}, REDUCE(sym_trait_bounds, 3),
  [5346] = {.count = 1, .reusable = true}, SHIFT(2421),
  [5348] = {.count = 1, .reusable = true}, SHIFT(2422),
  [5350] = {.count = 1, .reusable = true}, REDUCE(sym_trait_item, 5, .alias_sequence_id = 2),
  [5352] = {.count = 1, .reusable = false}, REDUCE(sym_trait_item, 5, .alias_sequence_id = 2),
  [5354] = {.count = 1, .reusable = false}, SHIFT(2423),
  [5356] = {.count = 1, .reusable = true}, SHIFT(2424),
  [5358] = {.count = 1, .reusable = true}, SHIFT(2425),
  [5360] = {.count = 1, .reusable = true}, REDUCE(sym_type_item, 5, .alias_sequence_id = 2),
  [5362] = {.count = 1, .reusable = false}, REDUCE(sym_type_item, 5, .alias_sequence_id = 2),
  [5364] = {.count = 1, .reusable = true}, SHIFT(2429),
  [5366] = {.count = 1, .reusable = true}, REDUCE(sym_union_item, 5, .alias_sequence_id = 2),
  [5368] = {.count = 1, .reusable = false}, REDUCE(sym_union_item, 5, .alias_sequence_id = 2),
  [5370] = {.count = 1, .reusable = true}, SHIFT(2430),
  [5372] = {.count = 1, .reusable = true}, REDUCE(sym_impl_item, 5, .alias_sequence_id = 14),
  [5374] = {.count = 1, .reusable = false}, REDUCE(sym_impl_item, 5, .alias_sequence_id = 14),
  [5376] = {.count = 1, .reusable = true}, REDUCE(sym_use_list, 4, .alias_sequence_id = 11),
  [5378] = {.count = 1, .reusable = true}, REDUCE(aux_sym_use_list_repeat1, 2, .alias_sequence_id = 11),
  [5380] = {.count = 1, .reusable = true}, REDUCE(aux_sym_use_list_repeat1, 2),
  [5382] = {.count = 1, .reusable = true}, SHIFT(2435),
  [5384] = {.count = 2, .reusable = true}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(2436),
  [5387] = {.count = 1, .reusable = true}, REDUCE(sym_use_list, 4),
  [5389] = {.count = 1, .reusable = true}, SHIFT(2437),
  [5391] = {.count = 1, .reusable = true}, SHIFT(2439),
  [5393] = {.count = 1, .reusable = true}, REDUCE(sym_closure_expression, 5),
  [5395] = {.count = 1, .reusable = false}, REDUCE(sym_closure_expression, 5),
  [5397] = {.count = 1, .reusable = true}, SHIFT(2440),
  [5399] = {.count = 1, .reusable = true}, SHIFT(2441),
  [5401] = {.count = 1, .reusable = false}, SHIFT(2441),
  [5403] = {.count = 1, .reusable = true}, SHIFT(2443),
  [5405] = {.count = 1, .reusable = true}, SHIFT(2444),
  [5407] = {.count = 1, .reusable = true}, SHIFT(2445),
  [5409] = {.count = 1, .reusable = true}, SHIFT(2446),
  [5411] = {.count = 1, .reusable = true}, SHIFT(2447),
  [5413] = {.count = 1, .reusable = true}, SHIFT(2448),
  [5415] = {.count = 1, .reusable = true}, SHIFT(2449),
  [5417] = {.count = 1, .reusable = true}, SHIFT(2450),
  [5419] = {.count = 1, .reusable = true}, SHIFT(2451),
  [5421] = {.count = 1, .reusable = true}, SHIFT(2452),
  [5423] = {.count = 1, .reusable = true}, SHIFT(2453),
  [5425] = {.count = 1, .reusable = true}, SHIFT(2454),
  [5427] = {.count = 1, .reusable = true}, SHIFT(2455),
  [5429] = {.count = 1, .reusable = true}, SHIFT(2456),
  [5431] = {.count = 1, .reusable = false}, SHIFT(2457),
  [5433] = {.count = 1, .reusable = false}, SHIFT(2458),
  [5435] = {.count = 1, .reusable = true}, REDUCE(sym_field_initializer, 3, .alias_sequence_id = 15),
  [5437] = {.count = 1, .reusable = true}, REDUCE(sym_field_initializer_list, 4, .alias_sequence_id = 12),
  [5439] = {.count = 1, .reusable = false}, REDUCE(sym_field_initializer_list, 4, .alias_sequence_id = 12),
  [5441] = {.count = 1, .reusable = true}, REDUCE(aux_sym_field_initializer_list_repeat1, 2, .alias_sequence_id = 12),
  [5443] = {.count = 1, .reusable = true}, REDUCE(aux_sym_field_initializer_list_repeat1, 2),
  [5445] = {.count = 1, .reusable = true}, SHIFT(2462),
  [5447] = {.count = 2, .reusable = true}, REDUCE(aux_sym_field_initializer_list_repeat1, 2), SHIFT_REPEAT(2463),
  [5450] = {.count = 1, .reusable = true}, REDUCE(sym_field_initializer_list, 4),
  [5452] = {.count = 1, .reusable = false}, REDUCE(sym_field_initializer_list, 4),
  [5454] = {.count = 1, .reusable = true}, SHIFT(2464),
  [5456] = {.count = 1, .reusable = true}, SHIFT(2465),
  [5458] = {.count = 1, .reusable = true}, SHIFT(2466),
  [5460] = {.count = 1, .reusable = true}, SHIFT(2467),
  [5462] = {.count = 2, .reusable = true}, REDUCE(sym_token_tree, 2), REDUCE(sym_unit_expression, 2),
  [5465] = {.count = 2, .reusable = false}, REDUCE(sym_token_tree, 2), REDUCE(sym_unit_expression, 2),
  [5468] = {.count = 1, .reusable = true}, SHIFT(2468),
  [5470] = {.count = 1, .reusable = true}, SHIFT(2469),
  [5472] = {.count = 1, .reusable = true}, SHIFT(2471),
  [5474] = {.count = 2, .reusable = true}, REDUCE(sym_token_tree, 2), REDUCE(sym_block, 2),
  [5477] = {.count = 2, .reusable = false}, REDUCE(sym_token_tree, 2), REDUCE(sym_block, 2),
  [5480] = {.count = 1, .reusable = true}, SHIFT(2472),
  [5482] = {.count = 1, .reusable = true}, SHIFT(2473),
  [5484] = {.count = 1, .reusable = true}, SHIFT(2474),
  [5486] = {.count = 1, .reusable = true}, SHIFT(2476),
  [5488] = {.count = 1, .reusable = true}, SHIFT(2479),
  [5490] = {.count = 2, .reusable = true}, REDUCE(sym_token_tree, 2), REDUCE(sym_array_expression, 2),
  [5493] = {.count = 2, .reusable = false}, REDUCE(sym_token_tree, 2), REDUCE(sym_array_expression, 2),
  [5496] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(93),
  [5499] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(95),
  [5502] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(96),
  [5505] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(97),
  [5508] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(98),
  [5511] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(333),
  [5514] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(334),
  [5517] = {.count = 1, .reusable = false}, SHIFT(95),
  [5519] = {.count = 1, .reusable = false}, SHIFT(96),
  [5521] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(337),
  [5524] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(336),
  [5527] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(338),
  [5530] = {.count = 3, .reusable = false}, REDUCE(sym_return_expression, 1), REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(93),
  [5534] = {.count = 3, .reusable = false}, REDUCE(sym_return_expression, 1), REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(95),
  [5538] = {.count = 3, .reusable = false}, REDUCE(sym_return_expression, 1), REDUCE(aux_sym_token_tree_repeat1, 1), SHIFT(96),
  [5542] = {.count = 1, .reusable = true}, SHIFT(2481),
  [5544] = {.count = 1, .reusable = true}, SHIFT(2482),
  [5546] = {.count = 1, .reusable = true}, SHIFT(2485),
  [5548] = {.count = 1, .reusable = true}, SHIFT(2484),
  [5550] = {.count = 1, .reusable = false}, SHIFT(2485),
  [5552] = {.count = 1, .reusable = true}, SHIFT(2486),
  [5554] = {.count = 1, .reusable = true}, REDUCE(sym_token_tree, 3),
  [5556] = {.count = 1, .reusable = false}, REDUCE(sym_token_tree, 3),
  [5558] = {.count = 1, .reusable = true}, SHIFT(2487),
  [5560] = {.count = 1, .reusable = true}, SHIFT(2488),
  [5562] = {.count = 1, .reusable = true}, SHIFT(2489),
  [5564] = {.count = 1, .reusable = true}, REDUCE(sym_token_tree, 3, .dynamic_precedence = -1),
  [5566] = {.count = 1, .reusable = false}, REDUCE(sym_token_tree, 3, .dynamic_precedence = -1),
  [5568] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 2), SHIFT_REPEAT(1878),
  [5571] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 2), SHIFT_REPEAT(1873),
  [5574] = {.count = 1, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 2),
  [5576] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 2), SHIFT_REPEAT(1875),
  [5579] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 2), SHIFT_REPEAT(1876),
  [5582] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 2), SHIFT_REPEAT(1878),
  [5585] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 2), SHIFT_REPEAT(1154),
  [5588] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 2), SHIFT_REPEAT(1877),
  [5591] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 2), SHIFT_REPEAT(1173),
  [5594] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 2), SHIFT_REPEAT(1174),
  [5597] = {.count = 1, .reusable = true}, SHIFT(2494),
  [5599] = {.count = 1, .reusable = true}, SHIFT(2495),
  [5601] = {.count = 1, .reusable = true}, SHIFT(2496),
  [5603] = {.count = 1, .reusable = true}, SHIFT(2497),
  [5605] = {.count = 1, .reusable = true}, SHIFT(2498),
  [5607] = {.count = 1, .reusable = true}, SHIFT(2499),
  [5609] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 2), SHIFT_REPEAT(1887),
  [5612] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 2), SHIFT_REPEAT(1887),
  [5615] = {.count = 1, .reusable = true}, SHIFT(2501),
  [5617] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat1, 2), SHIFT_REPEAT(1890),
  [5620] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_repeat1, 2), SHIFT_REPEAT(1890),
  [5623] = {.count = 1, .reusable = true}, SHIFT(2502),
  [5625] = {.count = 1, .reusable = true}, SHIFT(2503),
  [5627] = {.count = 1, .reusable = true}, SHIFT(2506),
  [5629] = {.count = 1, .reusable = true}, SHIFT(2509),
  [5631] = {.count = 1, .reusable = true}, SHIFT(2512),
  [5633] = {.count = 1, .reusable = true}, SHIFT(2513),
  [5635] = {.count = 1, .reusable = true}, SHIFT(2519),
  [5637] = {.count = 1, .reusable = true}, SHIFT(2520),
  [5639] = {.count = 1, .reusable = true}, SHIFT(2534),
  [5641] = {.count = 1, .reusable = true}, SHIFT(2535),
  [5643] = {.count = 1, .reusable = true}, SHIFT(2536),
  [5645] = {.count = 1, .reusable = true}, SHIFT(2538),
  [5647] = {.count = 1, .reusable = true}, SHIFT(2539),
  [5649] = {.count = 1, .reusable = true}, SHIFT(2541),
  [5651] = {.count = 1, .reusable = true}, SHIFT(2548),
  [5653] = {.count = 1, .reusable = true}, SHIFT(2549),
  [5655] = {.count = 1, .reusable = true}, SHIFT(2550),
  [5657] = {.count = 1, .reusable = false}, SHIFT(2553),
  [5659] = {.count = 1, .reusable = true}, SHIFT(2555),
  [5661] = {.count = 1, .reusable = true}, SHIFT(2556),
  [5663] = {.count = 1, .reusable = true}, SHIFT(2558),
  [5665] = {.count = 1, .reusable = true}, SHIFT(2559),
  [5667] = {.count = 1, .reusable = true}, SHIFT(2563),
  [5669] = {.count = 1, .reusable = true}, SHIFT(2564),
  [5671] = {.count = 1, .reusable = true}, SHIFT(2565),
  [5673] = {.count = 1, .reusable = true}, SHIFT(2572),
  [5675] = {.count = 1, .reusable = true}, SHIFT(2574),
  [5677] = {.count = 1, .reusable = true}, SHIFT(2578),
  [5679] = {.count = 1, .reusable = true}, SHIFT(2579),
  [5681] = {.count = 1, .reusable = true}, SHIFT(2580),
  [5683] = {.count = 1, .reusable = true}, SHIFT(2581),
  [5685] = {.count = 1, .reusable = true}, REDUCE(sym_enum_item, 5, .alias_sequence_id = 6),
  [5687] = {.count = 1, .reusable = false}, REDUCE(sym_enum_item, 5, .alias_sequence_id = 6),
  [5689] = {.count = 1, .reusable = true}, REDUCE(sym_struct_item, 5, .alias_sequence_id = 6),
  [5691] = {.count = 1, .reusable = false}, REDUCE(sym_struct_item, 5, .alias_sequence_id = 6),
  [5693] = {.count = 1, .reusable = true}, SHIFT(2584),
  [5695] = {.count = 1, .reusable = true}, REDUCE(sym_trait_item, 5, .alias_sequence_id = 6),
  [5697] = {.count = 1, .reusable = false}, REDUCE(sym_trait_item, 5, .alias_sequence_id = 6),
  [5699] = {.count = 1, .reusable = true}, SHIFT(2588),
  [5701] = {.count = 1, .reusable = true}, REDUCE(sym_union_item, 5, .alias_sequence_id = 6),
  [5703] = {.count = 1, .reusable = false}, REDUCE(sym_union_item, 5, .alias_sequence_id = 6),
  [5705] = {.count = 1, .reusable = true}, SHIFT(2590),
  [5707] = {.count = 1, .reusable = true}, REDUCE(sym_extern_crate_declaration, 5),
  [5709] = {.count = 1, .reusable = false}, REDUCE(sym_extern_crate_declaration, 5),
  [5711] = {.count = 1, .reusable = true}, SHIFT(2592),
  [5713] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 4),
  [5715] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 4),
  [5717] = {.count = 1, .reusable = true}, SHIFT(2594),
  [5719] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat2, 2), SHIFT_REPEAT(2595),
  [5722] = {.count = 1, .reusable = true}, SHIFT(2596),
  [5724] = {.count = 1, .reusable = true}, SHIFT(2597),
  [5726] = {.count = 1, .reusable = true}, SHIFT(2598),
  [5728] = {.count = 1, .reusable = false}, SHIFT(2599),
  [5730] = {.count = 1, .reusable = false}, SHIFT(2603),
  [5732] = {.count = 1, .reusable = false}, SHIFT(2604),
  [5734] = {.count = 1, .reusable = true}, SHIFT(2607),
  [5736] = {.count = 1, .reusable = false}, REDUCE(sym_tuple_type, 3),
  [5738] = {.count = 1, .reusable = true}, SHIFT(2608),
  [5740] = {.count = 1, .reusable = true}, SHIFT(2609),
  [5742] = {.count = 1, .reusable = true}, SHIFT(2610),
  [5744] = {.count = 1, .reusable = false}, REDUCE(sym_array_type, 3),
  [5746] = {.count = 1, .reusable = false}, REDUCE(sym_pointer_type, 3),
  [5748] = {.count = 1, .reusable = false}, REDUCE(sym_reference_type, 3),
  [5750] = {.count = 1, .reusable = false}, REDUCE(sym_parameters, 2),
  [5752] = {.count = 1, .reusable = true}, SHIFT(2612),
  [5754] = {.count = 1, .reusable = true}, SHIFT(2613),
  [5756] = {.count = 1, .reusable = false}, SHIFT(2615),
  [5758] = {.count = 1, .reusable = false}, REDUCE(sym_function_type, 3),
  [5760] = {.count = 1, .reusable = true}, SHIFT(2620),
  [5762] = {.count = 1, .reusable = false}, REDUCE(sym_function_type, 3, .alias_sequence_id = 2),
  [5764] = {.count = 1, .reusable = true}, SHIFT(2621),
  [5766] = {.count = 1, .reusable = true}, SHIFT(2622),
  [5768] = {.count = 1, .reusable = false}, REDUCE(sym_bounded_type, 3),
  [5770] = {.count = 1, .reusable = true}, SHIFT(2623),
  [5772] = {.count = 1, .reusable = true}, SHIFT(2624),
  [5774] = {.count = 1, .reusable = true}, SHIFT(2625),
  [5776] = {.count = 1, .reusable = true}, SHIFT(2626),
  [5778] = {.count = 1, .reusable = true}, REDUCE(sym_while_expression, 5),
  [5780] = {.count = 1, .reusable = false}, REDUCE(sym_while_expression, 5),
  [5782] = {.count = 1, .reusable = false}, REDUCE(sym_token_tree_pattern, 2),
  [5784] = {.count = 1, .reusable = true}, SHIFT(2627),
  [5786] = {.count = 1, .reusable = true}, SHIFT(2629),
  [5788] = {.count = 1, .reusable = true}, SHIFT(2628),
  [5790] = {.count = 1, .reusable = false}, SHIFT(2629),
  [5792] = {.count = 1, .reusable = true}, SHIFT(2630),
  [5794] = {.count = 1, .reusable = false}, SHIFT(2630),
  [5796] = {.count = 1, .reusable = true}, REDUCE(sym_token_tree_pattern, 3),
  [5798] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(2034),
  [5801] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(1356),
  [5804] = {.count = 1, .reusable = true}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2),
  [5806] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(1358),
  [5809] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(1359),
  [5812] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(2034),
  [5815] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(1360),
  [5818] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(1361),
  [5821] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(1173),
  [5824] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(1174),
  [5827] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(1362),
  [5830] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(2035),
  [5833] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(2035),
  [5836] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(2036),
  [5839] = {.count = 2, .reusable = false}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(2036),
  [5842] = {.count = 1, .reusable = true}, REDUCE(sym_macro_definition, 6),
  [5844] = {.count = 1, .reusable = false}, REDUCE(sym_macro_definition, 6),
  [5846] = {.count = 1, .reusable = true}, REDUCE(sym_macro_rule, 3),
  [5848] = {.count = 1, .reusable = true}, SHIFT(2632),
  [5850] = {.count = 1, .reusable = true}, SHIFT(2634),
  [5852] = {.count = 1, .reusable = true}, SHIFT(2636),
  [5854] = {.count = 1, .reusable = true}, SHIFT(2637),
  [5856] = {.count = 1, .reusable = true}, SHIFT(2638),
  [5858] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_expression, 6),
  [5860] = {.count = 1, .reusable = false}, REDUCE(sym_tuple_expression, 6),
  [5862] = {.count = 1, .reusable = true}, SHIFT(2055),
  [5864] = {.count = 1, .reusable = true}, SHIFT(2056),
  [5866] = {.count = 1, .reusable = true}, SHIFT(2057),
  [5868] = {.count = 1, .reusable = false}, SHIFT(2058),
  [5870] = {.count = 1, .reusable = false}, SHIFT(2059),
  [5872] = {.count = 1, .reusable = false}, SHIFT(2060),
  [5874] = {.count = 1, .reusable = false}, SHIFT(2639),
  [5876] = {.count = 1, .reusable = true}, SHIFT(2640),
  [5878] = {.count = 1, .reusable = false}, SHIFT(2055),
  [5880] = {.count = 1, .reusable = true}, SHIFT(2642),
  [5882] = {.count = 1, .reusable = false}, SHIFT(2641),
  [5884] = {.count = 1, .reusable = true}, SHIFT(2643),
  [5886] = {.count = 1, .reusable = false}, SHIFT(2645),
  [5888] = {.count = 1, .reusable = false}, SHIFT(2646),
  [5890] = {.count = 1, .reusable = false}, SHIFT(2647),
  [5892] = {.count = 1, .reusable = true}, SHIFT(2648),
  [5894] = {.count = 1, .reusable = true}, SHIFT(2649),
  [5896] = {.count = 1, .reusable = true}, SHIFT(2650),
  [5898] = {.count = 1, .reusable = false}, SHIFT(2651),
  [5900] = {.count = 1, .reusable = false}, SHIFT(2649),
  [5902] = {.count = 1, .reusable = false}, SHIFT(2652),
  [5904] = {.count = 1, .reusable = false}, SHIFT(2653),
  [5906] = {.count = 1, .reusable = false}, SHIFT(2654),
  [5908] = {.count = 1, .reusable = true}, SHIFT(2655),
  [5910] = {.count = 1, .reusable = false}, SHIFT(2656),
  [5912] = {.count = 1, .reusable = true}, SHIFT(2657),
  [5914] = {.count = 1, .reusable = true}, SHIFT(2658),
  [5916] = {.count = 1, .reusable = true}, SHIFT(2659),
  [5918] = {.count = 1, .reusable = true}, SHIFT(2660),
  [5920] = {.count = 1, .reusable = true}, SHIFT(2661),
  [5922] = {.count = 1, .reusable = true}, SHIFT(2662),
  [5924] = {.count = 1, .reusable = true}, SHIFT(2663),
  [5926] = {.count = 1, .reusable = true}, SHIFT(2664),
  [5928] = {.count = 1, .reusable = true}, SHIFT(308),
  [5930] = {.count = 1, .reusable = true}, SHIFT(2666),
  [5932] = {.count = 1, .reusable = true}, SHIFT(2667),
  [5934] = {.count = 1, .reusable = true}, SHIFT(2669),
  [5936] = {.count = 1, .reusable = true}, SHIFT(2670),
  [5938] = {.count = 1, .reusable = true}, SHIFT(2671),
  [5940] = {.count = 1, .reusable = false}, SHIFT(2672),
  [5942] = {.count = 1, .reusable = false}, SHIFT(2676),
  [5944] = {.count = 1, .reusable = false}, SHIFT(2677),
  [5946] = {.count = 1, .reusable = true}, SHIFT(2680),
  [5948] = {.count = 1, .reusable = true}, SHIFT(2681),
  [5950] = {.count = 1, .reusable = true}, SHIFT(2682),
  [5952] = {.count = 1, .reusable = true}, REDUCE(sym_meta_item, 4),
  [5954] = {.count = 1, .reusable = true}, SHIFT(2684),
  [5956] = {.count = 1, .reusable = true}, SHIFT(2686),
  [5958] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_type, 5),
  [5960] = {.count = 1, .reusable = true}, REDUCE(sym_array_type, 5),
  [5962] = {.count = 1, .reusable = true}, REDUCE(sym_parameters, 4),
  [5964] = {.count = 1, .reusable = true}, REDUCE(aux_sym_parameters_repeat1, 2),
  [5966] = {.count = 1, .reusable = true}, SHIFT(2688),
  [5968] = {.count = 2, .reusable = true}, REDUCE(aux_sym_parameters_repeat1, 2), SHIFT_REPEAT(2689),
  [5971] = {.count = 1, .reusable = true}, SHIFT(2690),
  [5973] = {.count = 1, .reusable = false}, SHIFT(2691),
  [5975] = {.count = 1, .reusable = false}, SHIFT(2692),
  [5977] = {.count = 1, .reusable = true}, REDUCE(sym_self_parameter, 3),
  [5979] = {.count = 1, .reusable = false}, SHIFT(2693),
  [5981] = {.count = 1, .reusable = false}, SHIFT(895),
  [5983] = {.count = 1, .reusable = true}, SHIFT(899),
  [5985] = {.count = 1, .reusable = true}, SHIFT(2696),
  [5987] = {.count = 1, .reusable = true}, SHIFT(2697),
  [5989] = {.count = 1, .reusable = true}, SHIFT(2698),
  [5991] = {.count = 1, .reusable = true}, REDUCE(sym_type_binding, 3, .alias_sequence_id = 4),
  [5993] = {.count = 1, .reusable = true}, SHIFT(2699),
  [5995] = {.count = 1, .reusable = true}, SHIFT(2700),
  [5997] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 4),
  [5999] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 4),
  [6001] = {.count = 1, .reusable = true}, REDUCE(aux_sym_type_arguments_repeat1, 2),
  [6003] = {.count = 1, .reusable = true}, SHIFT(2701),
  [6005] = {.count = 2, .reusable = true}, REDUCE(aux_sym_type_arguments_repeat1, 2), SHIFT_REPEAT(2702),
  [6008] = {.count = 1, .reusable = true}, REDUCE(sym_function_type, 5),
  [6010] = {.count = 1, .reusable = true}, REDUCE(sym_function_type, 5, .alias_sequence_id = 2),
  [6012] = {.count = 1, .reusable = true}, SHIFT(2703),
  [6014] = {.count = 1, .reusable = true}, SHIFT(2704),
  [6016] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_pattern, 5),
  [6018] = {.count = 1, .reusable = true}, SHIFT(2705),
  [6020] = {.count = 1, .reusable = true}, SHIFT(2706),
  [6022] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_pattern_in_parameter, 4),
  [6024] = {.count = 1, .reusable = true}, REDUCE(aux_sym_tuple_pattern_in_parameter_repeat1, 2),
  [6026] = {.count = 1, .reusable = true}, SHIFT(2707),
  [6028] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_pattern_in_parameter_repeat1, 2), SHIFT_REPEAT(2708),
  [6031] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_struct_pattern, 5),
  [6033] = {.count = 1, .reusable = true}, SHIFT(2709),
  [6035] = {.count = 1, .reusable = true}, SHIFT(2710),
  [6037] = {.count = 1, .reusable = false}, SHIFT(2710),
  [6039] = {.count = 1, .reusable = true}, REDUCE(sym_field_pattern, 3, .alias_sequence_id = 16),
  [6041] = {.count = 1, .reusable = true}, SHIFT(2711),
  [6043] = {.count = 1, .reusable = false}, SHIFT(2712),
  [6045] = {.count = 1, .reusable = true}, SHIFT(2713),
  [6047] = {.count = 1, .reusable = true}, REDUCE(sym_field_pattern, 3, .alias_sequence_id = 15),
  [6049] = {.count = 1, .reusable = true}, REDUCE(sym_struct_pattern, 5, .alias_sequence_id = 4),
  [6051] = {.count = 1, .reusable = true}, REDUCE(aux_sym_struct_pattern_repeat1, 2),
  [6053] = {.count = 1, .reusable = true}, SHIFT(2714),
  [6055] = {.count = 2, .reusable = true}, REDUCE(aux_sym_struct_pattern_repeat1, 2), SHIFT_REPEAT(2715),
  [6058] = {.count = 1, .reusable = true}, REDUCE(sym_struct_pattern, 5),
  [6060] = {.count = 1, .reusable = true}, SHIFT(2716),
  [6062] = {.count = 1, .reusable = true}, SHIFT(2717),
  [6064] = {.count = 1, .reusable = true}, SHIFT(2718),
  [6066] = {.count = 1, .reusable = true}, SHIFT(2719),
  [6068] = {.count = 1, .reusable = false}, SHIFT(2720),
  [6070] = {.count = 1, .reusable = false}, SHIFT(2721),
  [6072] = {.count = 1, .reusable = false}, SHIFT(2722),
  [6074] = {.count = 1, .reusable = true}, SHIFT(2722),
  [6076] = {.count = 1, .reusable = true}, SHIFT(2724),
  [6078] = {.count = 1, .reusable = true}, SHIFT(2725),
  [6080] = {.count = 1, .reusable = true}, SHIFT(2726),
  [6082] = {.count = 1, .reusable = true}, REDUCE(sym_enum_variant, 3),
  [6084] = {.count = 1, .reusable = true}, SHIFT(2729),
  [6086] = {.count = 1, .reusable = true}, REDUCE(sym_enum_variant_list, 4),
  [6088] = {.count = 1, .reusable = false}, REDUCE(sym_enum_variant_list, 4),
  [6090] = {.count = 1, .reusable = true}, REDUCE(aux_sym_enum_variant_list_repeat2, 2),
  [6092] = {.count = 1, .reusable = true}, SHIFT(2731),
  [6094] = {.count = 2, .reusable = true}, REDUCE(aux_sym_enum_variant_list_repeat2, 2), SHIFT_REPEAT(2732),
  [6097] = {.count = 1, .reusable = true}, SHIFT(2733),
  [6099] = {.count = 1, .reusable = true}, SHIFT(2734),
  [6101] = {.count = 1, .reusable = false}, SHIFT(2735),
  [6103] = {.count = 1, .reusable = true}, SHIFT(2736),
  [6105] = {.count = 1, .reusable = true}, SHIFT(2737),
  [6107] = {.count = 1, .reusable = true}, SHIFT(2741),
  [6109] = {.count = 1, .reusable = false}, SHIFT(2742),
  [6111] = {.count = 1, .reusable = false}, SHIFT(2748),
  [6113] = {.count = 1, .reusable = false}, SHIFT(2749),
  [6115] = {.count = 1, .reusable = true}, SHIFT(2751),
  [6117] = {.count = 1, .reusable = true}, SHIFT(2753),
  [6119] = {.count = 1, .reusable = true}, REDUCE(aux_sym_where_clause_repeat1, 2),
  [6121] = {.count = 1, .reusable = true}, REDUCE(sym_where_clause, 4),
  [6123] = {.count = 2, .reusable = true}, REDUCE(aux_sym_where_clause_repeat1, 2), SHIFT_REPEAT(2754),
  [6126] = {.count = 1, .reusable = true}, SHIFT(2755),
  [6128] = {.count = 1, .reusable = true}, REDUCE(sym_function_signature_item, 6),
  [6130] = {.count = 1, .reusable = false}, REDUCE(sym_function_signature_item, 6),
  [6132] = {.count = 1, .reusable = true}, REDUCE(sym_function_item, 6),
  [6134] = {.count = 1, .reusable = false}, REDUCE(sym_function_item, 6),
  [6136] = {.count = 1, .reusable = true}, SHIFT(2758),
  [6138] = {.count = 1, .reusable = false}, SHIFT(2759),
  [6140] = {.count = 1, .reusable = true}, SHIFT(2760),
  [6142] = {.count = 1, .reusable = true}, SHIFT(2761),
  [6144] = {.count = 1, .reusable = true}, SHIFT(2764),
  [6146] = {.count = 1, .reusable = true}, SHIFT(2765),
  [6148] = {.count = 1, .reusable = true}, SHIFT(2766),
  [6150] = {.count = 1, .reusable = false}, SHIFT(2767),
  [6152] = {.count = 1, .reusable = false}, SHIFT(2768),
  [6154] = {.count = 1, .reusable = false}, SHIFT(2769),
  [6156] = {.count = 1, .reusable = true}, SHIFT(2774),
  [6158] = {.count = 1, .reusable = true}, REDUCE(sym_if_let_expression, 6),
  [6160] = {.count = 1, .reusable = false}, REDUCE(sym_if_let_expression, 6),
  [6162] = {.count = 1, .reusable = true}, SHIFT(2778),
  [6164] = {.count = 1, .reusable = true}, SHIFT(2779),
  [6166] = {.count = 1, .reusable = true}, SHIFT(2781),
  [6168] = {.count = 1, .reusable = false}, SHIFT(2782),
  [6170] = {.count = 1, .reusable = true}, SHIFT(2783),
  [6172] = {.count = 1, .reusable = true}, SHIFT(2784),
  [6174] = {.count = 1, .reusable = true}, SHIFT(2788),
  [6176] = {.count = 1, .reusable = true}, SHIFT(2789),
  [6178] = {.count = 1, .reusable = true}, REDUCE(sym_impl_item, 6, .alias_sequence_id = 2),
  [6180] = {.count = 1, .reusable = false}, REDUCE(sym_impl_item, 6, .alias_sequence_id = 2),
  [6182] = {.count = 1, .reusable = true}, REDUCE(sym_impl_item, 6, .alias_sequence_id = 6),
  [6184] = {.count = 1, .reusable = false}, REDUCE(sym_impl_item, 6, .alias_sequence_id = 6),
  [6186] = {.count = 1, .reusable = true}, REDUCE(sym_impl_item, 6),
  [6188] = {.count = 1, .reusable = false}, REDUCE(sym_impl_item, 6),
  [6190] = {.count = 1, .reusable = true}, REDUCE(sym_let_declaration, 6),
  [6192] = {.count = 1, .reusable = false}, REDUCE(sym_let_declaration, 6),
  [6194] = {.count = 1, .reusable = true}, SHIFT(2792),
  [6196] = {.count = 1, .reusable = true}, SHIFT(2793),
  [6198] = {.count = 1, .reusable = true}, SHIFT(2794),
  [6200] = {.count = 1, .reusable = true}, SHIFT(2795),
  [6202] = {.count = 1, .reusable = true}, SHIFT(2796),
  [6204] = {.count = 1, .reusable = true}, SHIFT(2797),
  [6206] = {.count = 1, .reusable = true}, SHIFT(2798),
  [6208] = {.count = 1, .reusable = true}, SHIFT(2799),
  [6210] = {.count = 1, .reusable = true}, SHIFT(2800),
  [6212] = {.count = 1, .reusable = true}, SHIFT(2802),
  [6214] = {.count = 1, .reusable = true}, SHIFT(2803),
  [6216] = {.count = 1, .reusable = true}, SHIFT(2805),
  [6218] = {.count = 1, .reusable = true}, SHIFT(2806),
  [6220] = {.count = 1, .reusable = true}, SHIFT(2809),
  [6222] = {.count = 1, .reusable = true}, SHIFT(2808),
  [6224] = {.count = 1, .reusable = true}, SHIFT(2811),
  [6226] = {.count = 1, .reusable = false}, SHIFT(2811),
  [6228] = {.count = 1, .reusable = true}, SHIFT(2813),
  [6230] = {.count = 1, .reusable = false}, SHIFT(2812),
  [6232] = {.count = 1, .reusable = true}, SHIFT(2815),
  [6234] = {.count = 1, .reusable = true}, SHIFT(2818),
  [6236] = {.count = 1, .reusable = false}, SHIFT(2817),
  [6238] = {.count = 1, .reusable = true}, REDUCE(sym_last_match_arm, 3),
  [6240] = {.count = 1, .reusable = true}, SHIFT(2819),
  [6242] = {.count = 1, .reusable = true}, REDUCE(sym_match_arm, 3),
  [6244] = {.count = 1, .reusable = false}, REDUCE(sym_match_arm, 3),
  [6246] = {.count = 1, .reusable = true}, SHIFT(2820),
  [6248] = {.count = 1, .reusable = true}, REDUCE(aux_sym_match_pattern_repeat1, 2),
  [6250] = {.count = 1, .reusable = true}, SHIFT(2822),
  [6252] = {.count = 1, .reusable = true}, SHIFT(2821),
  [6254] = {.count = 1, .reusable = true}, SHIFT(2824),
  [6256] = {.count = 1, .reusable = true}, SHIFT(2823),
  [6258] = {.count = 1, .reusable = true}, SHIFT(2828),
  [6260] = {.count = 1, .reusable = true}, SHIFT(2826),
  [6262] = {.count = 1, .reusable = true}, SHIFT(2827),
  [6264] = {.count = 1, .reusable = true}, SHIFT(2829),
  [6266] = {.count = 1, .reusable = true}, SHIFT(2830),
  [6268] = {.count = 1, .reusable = true}, SHIFT(2832),
  [6270] = {.count = 1, .reusable = false}, SHIFT(2831),
  [6272] = {.count = 1, .reusable = true}, SHIFT(2833),
  [6274] = {.count = 1, .reusable = true}, SHIFT(2834),
  [6276] = {.count = 1, .reusable = false}, SHIFT(2330),
  [6278] = {.count = 1, .reusable = true}, SHIFT(2835),
  [6280] = {.count = 1, .reusable = true}, SHIFT(2838),
  [6282] = {.count = 1, .reusable = false}, SHIFT(2838),
  [6284] = {.count = 1, .reusable = true}, SHIFT(2840),
  [6286] = {.count = 1, .reusable = false}, SHIFT(2839),
  [6288] = {.count = 1, .reusable = true}, SHIFT(2842),
  [6290] = {.count = 1, .reusable = true}, SHIFT(2843),
  [6292] = {.count = 1, .reusable = true}, SHIFT(2846),
  [6294] = {.count = 1, .reusable = false}, SHIFT(2845),
  [6296] = {.count = 1, .reusable = true}, SHIFT(2849),
  [6298] = {.count = 1, .reusable = true}, SHIFT(2848),
  [6300] = {.count = 1, .reusable = true}, SHIFT(2850),
  [6302] = {.count = 1, .reusable = true}, SHIFT(2851),
  [6304] = {.count = 1, .reusable = false}, SHIFT(2852),
  [6306] = {.count = 1, .reusable = true}, SHIFT(2854),
  [6308] = {.count = 1, .reusable = true}, SHIFT(2855),
  [6310] = {.count = 1, .reusable = true}, SHIFT(2856),
  [6312] = {.count = 1, .reusable = true}, SHIFT(2858),
  [6314] = {.count = 1, .reusable = true}, REDUCE(sym_match_pattern, 3),
  [6316] = {.count = 1, .reusable = true}, SHIFT(2859),
  [6318] = {.count = 1, .reusable = false}, SHIFT(2860),
  [6320] = {.count = 1, .reusable = false}, SHIFT(2861),
  [6322] = {.count = 1, .reusable = false}, SHIFT(2862),
  [6324] = {.count = 1, .reusable = false}, SHIFT(2863),
  [6326] = {.count = 1, .reusable = true}, SHIFT(2864),
  [6328] = {.count = 1, .reusable = true}, SHIFT(2865),
  [6330] = {.count = 1, .reusable = true}, SHIFT(2866),
  [6332] = {.count = 1, .reusable = false}, SHIFT(2867),
  [6334] = {.count = 1, .reusable = false}, SHIFT(2865),
  [6336] = {.count = 1, .reusable = false}, SHIFT(2868),
  [6338] = {.count = 1, .reusable = false}, SHIFT(2869),
  [6340] = {.count = 1, .reusable = false}, SHIFT(2870),
  [6342] = {.count = 1, .reusable = true}, SHIFT(2871),
  [6344] = {.count = 1, .reusable = true}, SHIFT(2872),
  [6346] = {.count = 1, .reusable = false}, SHIFT(2873),
  [6348] = {.count = 1, .reusable = true}, SHIFT(2874),
  [6350] = {.count = 1, .reusable = true}, SHIFT(2875),
  [6352] = {.count = 1, .reusable = true}, SHIFT(2877),
  [6354] = {.count = 1, .reusable = true}, SHIFT(2879),
  [6356] = {.count = 1, .reusable = true}, SHIFT(2878),
  [6358] = {.count = 1, .reusable = true}, SHIFT(2880),
  [6360] = {.count = 1, .reusable = true}, SHIFT(2881),
  [6362] = {.count = 1, .reusable = true}, SHIFT(2882),
  [6364] = {.count = 2, .reusable = true}, REDUCE(aux_sym_match_pattern_repeat1, 2), SHIFT_REPEAT(1721),
  [6367] = {.count = 1, .reusable = true}, REDUCE(sym_range_pattern, 3),
  [6369] = {.count = 1, .reusable = true}, SHIFT(2883),
  [6371] = {.count = 1, .reusable = true}, REDUCE(sym_match_expression, 6),
  [6373] = {.count = 1, .reusable = false}, REDUCE(sym_match_expression, 6),
  [6375] = {.count = 1, .reusable = true}, SHIFT(2885),
  [6377] = {.count = 1, .reusable = true}, REDUCE(sym_static_item, 6),
  [6379] = {.count = 1, .reusable = false}, REDUCE(sym_static_item, 6),
  [6381] = {.count = 1, .reusable = true}, SHIFT(2887),
  [6383] = {.count = 1, .reusable = true}, SHIFT(2888),
  [6385] = {.count = 1, .reusable = true}, SHIFT(2889),
  [6387] = {.count = 1, .reusable = false}, SHIFT(2890),
  [6389] = {.count = 1, .reusable = false}, SHIFT(2891),
  [6391] = {.count = 1, .reusable = false}, SHIFT(2892),
  [6393] = {.count = 1, .reusable = true}, SHIFT(2892),
  [6395] = {.count = 1, .reusable = true}, SHIFT(2894),
  [6397] = {.count = 1, .reusable = true}, REDUCE(sym_ordered_field_declaration_list, 4),
  [6399] = {.count = 1, .reusable = true}, SHIFT(2895),
  [6401] = {.count = 1, .reusable = true}, SHIFT(2896),
  [6403] = {.count = 1, .reusable = true}, REDUCE(aux_sym_ordered_field_declaration_list_repeat1, 2),
  [6405] = {.count = 2, .reusable = true}, REDUCE(aux_sym_ordered_field_declaration_list_repeat1, 2), SHIFT_REPEAT(2899),
  [6408] = {.count = 1, .reusable = true}, SHIFT(2901),
  [6410] = {.count = 1, .reusable = false}, SHIFT(2902),
  [6412] = {.count = 1, .reusable = false}, SHIFT(2906),
  [6414] = {.count = 1, .reusable = false}, SHIFT(2907),
  [6416] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration, 3, .alias_sequence_id = 15),
  [6418] = {.count = 1, .reusable = true}, SHIFT(2909),
  [6420] = {.count = 1, .reusable = true}, SHIFT(2910),
  [6422] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration_list, 4),
  [6424] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration_list, 4),
  [6426] = {.count = 1, .reusable = true}, REDUCE(aux_sym_field_declaration_list_repeat1, 2),
  [6428] = {.count = 1, .reusable = true}, SHIFT(2912),
  [6430] = {.count = 2, .reusable = true}, REDUCE(aux_sym_field_declaration_list_repeat1, 2), SHIFT_REPEAT(2913),
  [6433] = {.count = 1, .reusable = true}, SHIFT(2915),
  [6435] = {.count = 1, .reusable = true}, SHIFT(2916),
  [6437] = {.count = 1, .reusable = false}, SHIFT(2917),
  [6439] = {.count = 1, .reusable = false}, SHIFT(2923),
  [6441] = {.count = 1, .reusable = false}, SHIFT(2924),
  [6443] = {.count = 1, .reusable = true}, SHIFT(2926),
  [6445] = {.count = 1, .reusable = true}, SHIFT(2928),
  [6447] = {.count = 2, .reusable = true}, REDUCE(aux_sym_where_clause_repeat1, 2), SHIFT_REPEAT(2929),
  [6450] = {.count = 1, .reusable = true}, SHIFT(2930),
  [6452] = {.count = 1, .reusable = true}, SHIFT(2931),
  [6454] = {.count = 1, .reusable = true}, SHIFT(2932),
  [6456] = {.count = 1, .reusable = false}, SHIFT(2933),
  [6458] = {.count = 1, .reusable = false}, SHIFT(2934),
  [6460] = {.count = 1, .reusable = false}, SHIFT(2935),
  [6462] = {.count = 1, .reusable = true}, SHIFT(2940),
  [6464] = {.count = 1, .reusable = true}, REDUCE(sym_struct_item, 6, .alias_sequence_id = 2),
  [6466] = {.count = 1, .reusable = false}, REDUCE(sym_struct_item, 6, .alias_sequence_id = 2),
  [6468] = {.count = 1, .reusable = true}, SHIFT(2942),
  [6470] = {.count = 1, .reusable = true}, SHIFT(2943),
  [6472] = {.count = 1, .reusable = true}, SHIFT(2945),
  [6474] = {.count = 1, .reusable = true}, REDUCE(sym_higher_ranked_trait_bound, 3),
  [6476] = {.count = 1, .reusable = true}, REDUCE(aux_sym_trait_bounds_repeat1, 2),
  [6478] = {.count = 2, .reusable = true}, REDUCE(aux_sym_trait_bounds_repeat1, 2), SHIFT_REPEAT(1762),
  [6481] = {.count = 1, .reusable = true}, SHIFT(2947),
  [6483] = {.count = 1, .reusable = true}, SHIFT(2948),
  [6485] = {.count = 2, .reusable = true}, REDUCE(aux_sym_trait_bounds_repeat1, 2), SHIFT_REPEAT(1779),
  [6488] = {.count = 1, .reusable = true}, REDUCE(sym_type_item, 6, .alias_sequence_id = 2),
  [6490] = {.count = 1, .reusable = false}, REDUCE(sym_type_item, 6, .alias_sequence_id = 2),
  [6492] = {.count = 1, .reusable = true}, REDUCE(sym_union_item, 6, .alias_sequence_id = 2),
  [6494] = {.count = 1, .reusable = false}, REDUCE(sym_union_item, 6, .alias_sequence_id = 2),
  [6496] = {.count = 1, .reusable = true}, REDUCE(sym_impl_item, 6, .alias_sequence_id = 14),
  [6498] = {.count = 1, .reusable = false}, REDUCE(sym_impl_item, 6, .alias_sequence_id = 14),
  [6500] = {.count = 1, .reusable = true}, REDUCE(sym_use_list, 5, .alias_sequence_id = 11),
  [6502] = {.count = 1, .reusable = true}, REDUCE(sym_use_list, 5),
  [6504] = {.count = 1, .reusable = true}, REDUCE(sym_while_let_expression, 6),
  [6506] = {.count = 1, .reusable = false}, REDUCE(sym_while_let_expression, 6),
  [6508] = {.count = 1, .reusable = true}, REDUCE(sym_extern_crate_declaration, 6),
  [6510] = {.count = 1, .reusable = false}, REDUCE(sym_extern_crate_declaration, 6),
  [6512] = {.count = 1, .reusable = true}, SHIFT(2952),
  [6514] = {.count = 1, .reusable = true}, SHIFT(2953),
  [6516] = {.count = 1, .reusable = true}, SHIFT(2954),
  [6518] = {.count = 1, .reusable = false}, SHIFT(2955),
  [6520] = {.count = 1, .reusable = false}, SHIFT(2959),
  [6522] = {.count = 1, .reusable = false}, SHIFT(2960),
  [6524] = {.count = 1, .reusable = true}, SHIFT(2963),
  [6526] = {.count = 1, .reusable = true}, REDUCE(sym_field_initializer_list, 5, .alias_sequence_id = 12),
  [6528] = {.count = 1, .reusable = false}, REDUCE(sym_field_initializer_list, 5, .alias_sequence_id = 12),
  [6530] = {.count = 1, .reusable = true}, REDUCE(sym_field_initializer_list, 5),
  [6532] = {.count = 1, .reusable = false}, REDUCE(sym_field_initializer_list, 5),
  [6534] = {.count = 1, .reusable = true}, REDUCE(sym_field_initializer, 4, .alias_sequence_id = 17),
  [6536] = {.count = 1, .reusable = true}, SHIFT(2964),
  [6538] = {.count = 2, .reusable = true}, REDUCE(sym_token_tree, 3), REDUCE(sym_parenthesized_expression, 3),
  [6541] = {.count = 2, .reusable = false}, REDUCE(sym_token_tree, 3), REDUCE(sym_parenthesized_expression, 3),
  [6544] = {.count = 1, .reusable = true}, SHIFT(2966),
  [6546] = {.count = 1, .reusable = true}, SHIFT(2965),
  [6548] = {.count = 1, .reusable = true}, SHIFT(2967),
  [6550] = {.count = 1, .reusable = true}, SHIFT(2968),
  [6552] = {.count = 2, .reusable = true}, REDUCE(sym_token_tree, 3), REDUCE(sym_block, 3),
  [6555] = {.count = 2, .reusable = false}, REDUCE(sym_token_tree, 3), REDUCE(sym_block, 3),
  [6558] = {.count = 1, .reusable = true}, SHIFT(2969),
  [6560] = {.count = 1, .reusable = true}, SHIFT(2970),
  [6562] = {.count = 1, .reusable = true}, SHIFT(2971),
  [6564] = {.count = 1, .reusable = true}, SHIFT(2972),
  [6566] = {.count = 1, .reusable = true}, SHIFT(2973),
  [6568] = {.count = 1, .reusable = true}, SHIFT(2974),
  [6570] = {.count = 1, .reusable = true}, SHIFT(2975),
  [6572] = {.count = 2, .reusable = true}, REDUCE(sym_token_tree, 3), REDUCE(sym_array_expression, 3),
  [6575] = {.count = 2, .reusable = false}, REDUCE(sym_token_tree, 3), REDUCE(sym_array_expression, 3),
  [6578] = {.count = 1, .reusable = true}, SHIFT(2977),
  [6580] = {.count = 1, .reusable = true}, SHIFT(2978),
  [6582] = {.count = 1, .reusable = false}, SHIFT(2979),
  [6584] = {.count = 1, .reusable = false}, SHIFT(2980),
  [6586] = {.count = 1, .reusable = true}, SHIFT(2981),
  [6588] = {.count = 1, .reusable = true}, REDUCE(sym_token_tree, 4),
  [6590] = {.count = 1, .reusable = false}, REDUCE(sym_token_tree, 4),
  [6592] = {.count = 1, .reusable = true}, SHIFT(2982),
  [6594] = {.count = 1, .reusable = true}, SHIFT(2983),
  [6596] = {.count = 1, .reusable = true}, SHIFT(2984),
  [6598] = {.count = 1, .reusable = true}, SHIFT(2985),
  [6600] = {.count = 1, .reusable = true}, SHIFT(2986),
  [6602] = {.count = 1, .reusable = true}, SHIFT(2988),
  [6604] = {.count = 1, .reusable = true}, SHIFT(2989),
  [6606] = {.count = 1, .reusable = true}, SHIFT(2990),
  [6608] = {.count = 1, .reusable = true}, SHIFT(2991),
  [6610] = {.count = 1, .reusable = true}, SHIFT(2994),
  [6612] = {.count = 1, .reusable = true}, SHIFT(2995),
  [6614] = {.count = 1, .reusable = true}, SHIFT(2998),
  [6616] = {.count = 1, .reusable = true}, SHIFT(2999),
  [6618] = {.count = 1, .reusable = true}, SHIFT(3000),
  [6620] = {.count = 1, .reusable = true}, SHIFT(3001),
  [6622] = {.count = 1, .reusable = true}, SHIFT(3005),
  [6624] = {.count = 1, .reusable = true}, SHIFT(3006),
  [6626] = {.count = 1, .reusable = true}, SHIFT(3020),
  [6628] = {.count = 1, .reusable = true}, SHIFT(3021),
  [6630] = {.count = 1, .reusable = true}, SHIFT(3022),
  [6632] = {.count = 1, .reusable = true}, SHIFT(3024),
  [6634] = {.count = 1, .reusable = true}, SHIFT(3025),
  [6636] = {.count = 1, .reusable = true}, SHIFT(3026),
  [6638] = {.count = 1, .reusable = true}, SHIFT(3030),
  [6640] = {.count = 1, .reusable = true}, SHIFT(3032),
  [6642] = {.count = 1, .reusable = true}, SHIFT(3039),
  [6644] = {.count = 1, .reusable = true}, SHIFT(3044),
  [6646] = {.count = 1, .reusable = true}, SHIFT(3045),
  [6648] = {.count = 1, .reusable = true}, SHIFT(3052),
  [6650] = {.count = 1, .reusable = true}, SHIFT(3053),
  [6652] = {.count = 1, .reusable = true}, SHIFT(3056),
  [6654] = {.count = 1, .reusable = true}, SHIFT(3057),
  [6656] = {.count = 1, .reusable = true}, SHIFT(3059),
  [6658] = {.count = 1, .reusable = true}, REDUCE(sym_enum_item, 6, .alias_sequence_id = 6),
  [6660] = {.count = 1, .reusable = false}, REDUCE(sym_enum_item, 6, .alias_sequence_id = 6),
  [6662] = {.count = 1, .reusable = true}, SHIFT(3060),
  [6664] = {.count = 1, .reusable = true}, REDUCE(sym_struct_item, 6, .alias_sequence_id = 6),
  [6666] = {.count = 1, .reusable = false}, REDUCE(sym_struct_item, 6, .alias_sequence_id = 6),
  [6668] = {.count = 1, .reusable = true}, SHIFT(3061),
  [6670] = {.count = 1, .reusable = true}, REDUCE(sym_trait_item, 6, .alias_sequence_id = 6),
  [6672] = {.count = 1, .reusable = false}, REDUCE(sym_trait_item, 6, .alias_sequence_id = 6),
  [6674] = {.count = 1, .reusable = true}, REDUCE(sym_type_item, 6, .alias_sequence_id = 6),
  [6676] = {.count = 1, .reusable = false}, REDUCE(sym_type_item, 6, .alias_sequence_id = 6),
  [6678] = {.count = 1, .reusable = true}, SHIFT(3063),
  [6680] = {.count = 1, .reusable = true}, REDUCE(sym_union_item, 6, .alias_sequence_id = 6),
  [6682] = {.count = 1, .reusable = false}, REDUCE(sym_union_item, 6, .alias_sequence_id = 6),
  [6684] = {.count = 1, .reusable = true}, SHIFT(3064),
  [6686] = {.count = 1, .reusable = true}, SHIFT(3065),
  [6688] = {.count = 1, .reusable = true}, SHIFT(3066),
  [6690] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 5),
  [6692] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 5),
  [6694] = {.count = 1, .reusable = true}, SHIFT(3067),
  [6696] = {.count = 1, .reusable = true}, SHIFT(634),
  [6698] = {.count = 1, .reusable = false}, SHIFT(3068),
  [6700] = {.count = 1, .reusable = true}, SHIFT(3069),
  [6702] = {.count = 1, .reusable = true}, SHIFT(3070),
  [6704] = {.count = 1, .reusable = false}, REDUCE(sym_tuple_type, 4),
  [6706] = {.count = 1, .reusable = true}, SHIFT(3073),
  [6708] = {.count = 1, .reusable = true}, SHIFT(3074),
  [6710] = {.count = 1, .reusable = false}, REDUCE(sym_reference_type, 4),
  [6712] = {.count = 1, .reusable = false}, REDUCE(sym_parameters, 3),
  [6714] = {.count = 1, .reusable = true}, SHIFT(3075),
  [6716] = {.count = 1, .reusable = true}, SHIFT(3076),
  [6718] = {.count = 1, .reusable = false}, SHIFT(3077),
  [6720] = {.count = 1, .reusable = false}, REDUCE(sym_function_type, 4),
  [6722] = {.count = 1, .reusable = false}, REDUCE(sym_function_type, 4, .alias_sequence_id = 4),
  [6724] = {.count = 1, .reusable = true}, SHIFT(3085),
  [6726] = {.count = 1, .reusable = false}, REDUCE(sym_token_tree_pattern, 3),
  [6728] = {.count = 1, .reusable = false}, SHIFT(3086),
  [6730] = {.count = 1, .reusable = false}, SHIFT(3087),
  [6732] = {.count = 1, .reusable = true}, SHIFT(3088),
  [6734] = {.count = 1, .reusable = true}, REDUCE(sym_fragment_specifier, 1),
  [6736] = {.count = 1, .reusable = false}, REDUCE(sym_fragment_specifier, 1),
  [6738] = {.count = 1, .reusable = true}, REDUCE(sym_token_binding_pattern, 3),
  [6740] = {.count = 1, .reusable = false}, REDUCE(sym_token_binding_pattern, 3),
  [6742] = {.count = 1, .reusable = true}, REDUCE(sym_macro_definition, 7),
  [6744] = {.count = 1, .reusable = false}, REDUCE(sym_macro_definition, 7),
  [6746] = {.count = 1, .reusable = true}, SHIFT(3090),
  [6748] = {.count = 1, .reusable = true}, SHIFT(3091),
  [6750] = {.count = 1, .reusable = false}, SHIFT(3091),
  [6752] = {.count = 1, .reusable = true}, SHIFT(3093),
  [6754] = {.count = 1, .reusable = true}, SHIFT(3094),
  [6756] = {.count = 1, .reusable = true}, SHIFT(3095),
  [6758] = {.count = 1, .reusable = true}, SHIFT(3096),
  [6760] = {.count = 1, .reusable = true}, SHIFT(3097),
  [6762] = {.count = 1, .reusable = true}, SHIFT(3098),
  [6764] = {.count = 1, .reusable = true}, SHIFT(3099),
  [6766] = {.count = 1, .reusable = true}, SHIFT(3100),
  [6768] = {.count = 1, .reusable = true}, SHIFT(3101),
  [6770] = {.count = 1, .reusable = true}, SHIFT(3102),
  [6772] = {.count = 1, .reusable = true}, SHIFT(3103),
  [6774] = {.count = 1, .reusable = true}, SHIFT(3104),
  [6776] = {.count = 1, .reusable = true}, SHIFT(3105),
  [6778] = {.count = 1, .reusable = true}, SHIFT(3106),
  [6780] = {.count = 1, .reusable = false}, SHIFT(3107),
  [6782] = {.count = 1, .reusable = false}, SHIFT(3108),
  [6784] = {.count = 1, .reusable = true}, SHIFT(3113),
  [6786] = {.count = 1, .reusable = true}, SHIFT(3115),
  [6788] = {.count = 1, .reusable = true}, SHIFT(766),
  [6790] = {.count = 1, .reusable = false}, SHIFT(3116),
  [6792] = {.count = 1, .reusable = true}, SHIFT(3117),
  [6794] = {.count = 1, .reusable = true}, SHIFT(3118),
  [6796] = {.count = 1, .reusable = true}, REDUCE(sym_meta_item, 5),
  [6798] = {.count = 1, .reusable = true}, REDUCE(aux_sym_meta_item_repeat1, 2),
  [6800] = {.count = 1, .reusable = true}, SHIFT(3121),
  [6802] = {.count = 2, .reusable = true}, REDUCE(aux_sym_meta_item_repeat1, 2), SHIFT_REPEAT(3122),
  [6805] = {.count = 1, .reusable = true}, REDUCE(sym_parameters, 5),
  [6807] = {.count = 1, .reusable = true}, SHIFT(3123),
  [6809] = {.count = 1, .reusable = false}, SHIFT(3124),
  [6811] = {.count = 1, .reusable = true}, REDUCE(sym_self_parameter, 4),
  [6813] = {.count = 1, .reusable = true}, SHIFT(3125),
  [6815] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 5),
  [6817] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 5),
  [6819] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_pattern_in_parameter, 5),
  [6821] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_struct_pattern, 6),
  [6823] = {.count = 1, .reusable = true}, REDUCE(sym_field_pattern, 4, .alias_sequence_id = 17),
  [6825] = {.count = 1, .reusable = true}, SHIFT(3126),
  [6827] = {.count = 1, .reusable = false}, SHIFT(3126),
  [6829] = {.count = 1, .reusable = true}, REDUCE(sym_struct_pattern, 6, .alias_sequence_id = 4),
  [6831] = {.count = 1, .reusable = true}, REDUCE(sym_struct_pattern, 6),
  [6833] = {.count = 1, .reusable = true}, REDUCE(sym_const_item, 7),
  [6835] = {.count = 1, .reusable = false}, REDUCE(sym_const_item, 7),
  [6837] = {.count = 1, .reusable = true}, SHIFT(3127),
  [6839] = {.count = 1, .reusable = true}, SHIFT(3128),
  [6841] = {.count = 1, .reusable = true}, SHIFT(3129),
  [6843] = {.count = 1, .reusable = true}, SHIFT(3130),
  [6845] = {.count = 1, .reusable = true}, REDUCE(sym_enum_variant, 4),
  [6847] = {.count = 1, .reusable = true}, REDUCE(aux_sym_enum_variant_list_repeat2, 3),
  [6849] = {.count = 1, .reusable = true}, REDUCE(sym_enum_variant_list, 5),
  [6851] = {.count = 1, .reusable = false}, REDUCE(sym_enum_variant_list, 5),
  [6853] = {.count = 1, .reusable = true}, SHIFT(3132),
  [6855] = {.count = 1, .reusable = true}, SHIFT(3133),
  [6857] = {.count = 1, .reusable = true}, SHIFT(3134),
  [6859] = {.count = 1, .reusable = true}, SHIFT(3135),
  [6861] = {.count = 1, .reusable = true}, SHIFT(3137),
  [6863] = {.count = 1, .reusable = false}, SHIFT(3138),
  [6865] = {.count = 1, .reusable = true}, SHIFT(3139),
  [6867] = {.count = 1, .reusable = true}, SHIFT(3140),
  [6869] = {.count = 1, .reusable = true}, REDUCE(sym_function_signature_item, 7),
  [6871] = {.count = 1, .reusable = false}, REDUCE(sym_function_signature_item, 7),
  [6873] = {.count = 1, .reusable = true}, SHIFT(3144),
  [6875] = {.count = 1, .reusable = true}, REDUCE(sym_function_item, 7),
  [6877] = {.count = 1, .reusable = false}, REDUCE(sym_function_item, 7),
  [6879] = {.count = 1, .reusable = true}, SHIFT(3146),
  [6881] = {.count = 1, .reusable = true}, SHIFT(3147),
  [6883] = {.count = 1, .reusable = true}, SHIFT(3148),
  [6885] = {.count = 1, .reusable = false}, SHIFT(3149),
  [6887] = {.count = 1, .reusable = false}, SHIFT(3155),
  [6889] = {.count = 1, .reusable = false}, SHIFT(3156),
  [6891] = {.count = 1, .reusable = true}, SHIFT(3158),
  [6893] = {.count = 1, .reusable = true}, SHIFT(3160),
  [6895] = {.count = 2, .reusable = true}, REDUCE(aux_sym_where_clause_repeat1, 2), SHIFT_REPEAT(3161),
  [6898] = {.count = 1, .reusable = true}, REDUCE(sym_if_let_expression, 7),
  [6900] = {.count = 1, .reusable = false}, REDUCE(sym_if_let_expression, 7),
  [6902] = {.count = 1, .reusable = true}, SHIFT(3162),
  [6904] = {.count = 1, .reusable = true}, SHIFT(3163),
  [6906] = {.count = 2, .reusable = true}, REDUCE(aux_sym_trait_bounds_repeat1, 2), SHIFT_REPEAT(2277),
  [6909] = {.count = 1, .reusable = true}, REDUCE(sym_impl_item, 7, .alias_sequence_id = 6),
  [6911] = {.count = 1, .reusable = false}, REDUCE(sym_impl_item, 7, .alias_sequence_id = 6),
  [6913] = {.count = 1, .reusable = true}, REDUCE(sym_impl_item, 7),
  [6915] = {.count = 1, .reusable = false}, REDUCE(sym_impl_item, 7),
  [6917] = {.count = 1, .reusable = true}, SHIFT(3164),
  [6919] = {.count = 1, .reusable = true}, REDUCE(sym_let_declaration, 7),
  [6921] = {.count = 1, .reusable = false}, REDUCE(sym_let_declaration, 7),
  [6923] = {.count = 1, .reusable = true}, SHIFT(3165),
  [6925] = {.count = 1, .reusable = true}, SHIFT(3166),
  [6927] = {.count = 1, .reusable = true}, SHIFT(3167),
  [6929] = {.count = 1, .reusable = true}, SHIFT(3168),
  [6931] = {.count = 1, .reusable = true}, SHIFT(3169),
  [6933] = {.count = 1, .reusable = true}, SHIFT(3170),
  [6935] = {.count = 1, .reusable = true}, SHIFT(3171),
  [6937] = {.count = 1, .reusable = true}, SHIFT(3172),
  [6939] = {.count = 1, .reusable = true}, SHIFT(3173),
  [6941] = {.count = 1, .reusable = true}, SHIFT(3174),
  [6943] = {.count = 1, .reusable = true}, SHIFT(3175),
  [6945] = {.count = 1, .reusable = false}, SHIFT(3175),
  [6947] = {.count = 1, .reusable = true}, SHIFT(3177),
  [6949] = {.count = 1, .reusable = true}, SHIFT(3178),
  [6951] = {.count = 1, .reusable = false}, SHIFT(3178),
  [6953] = {.count = 1, .reusable = true}, REDUCE(sym_match_arm, 4),
  [6955] = {.count = 1, .reusable = true}, REDUCE(sym_last_match_arm, 4),
  [6957] = {.count = 1, .reusable = false}, REDUCE(sym_match_arm, 4),
  [6959] = {.count = 1, .reusable = true}, SHIFT(3180),
  [6961] = {.count = 1, .reusable = true}, SHIFT(3181),
  [6963] = {.count = 1, .reusable = true}, SHIFT(3182),
  [6965] = {.count = 1, .reusable = true}, SHIFT(3183),
  [6967] = {.count = 1, .reusable = true}, SHIFT(3184),
  [6969] = {.count = 1, .reusable = true}, SHIFT(3185),
  [6971] = {.count = 1, .reusable = true}, SHIFT(3186),
  [6973] = {.count = 1, .reusable = true}, SHIFT(3187),
  [6975] = {.count = 1, .reusable = true}, SHIFT(3188),
  [6977] = {.count = 1, .reusable = true}, SHIFT(3189),
  [6979] = {.count = 1, .reusable = true}, SHIFT(3191),
  [6981] = {.count = 1, .reusable = true}, SHIFT(3192),
  [6983] = {.count = 1, .reusable = true}, SHIFT(3193),
  [6985] = {.count = 1, .reusable = true}, SHIFT(3194),
  [6987] = {.count = 1, .reusable = true}, SHIFT(3195),
  [6989] = {.count = 1, .reusable = false}, SHIFT(3195),
  [6991] = {.count = 1, .reusable = true}, SHIFT(3197),
  [6993] = {.count = 1, .reusable = true}, SHIFT(3198),
  [6995] = {.count = 1, .reusable = false}, SHIFT(3198),
  [6997] = {.count = 1, .reusable = true}, SHIFT(3201),
  [6999] = {.count = 1, .reusable = true}, SHIFT(3200),
  [7001] = {.count = 1, .reusable = true}, SHIFT(3202),
  [7003] = {.count = 1, .reusable = true}, SHIFT(3203),
  [7005] = {.count = 1, .reusable = true}, SHIFT(3204),
  [7007] = {.count = 1, .reusable = true}, SHIFT(3205),
  [7009] = {.count = 1, .reusable = true}, SHIFT(3207),
  [7011] = {.count = 1, .reusable = true}, SHIFT(3208),
  [7013] = {.count = 1, .reusable = true}, SHIFT(3210),
  [7015] = {.count = 1, .reusable = true}, SHIFT(3211),
  [7017] = {.count = 1, .reusable = true}, SHIFT(3212),
  [7019] = {.count = 1, .reusable = true}, SHIFT(3214),
  [7021] = {.count = 1, .reusable = true}, SHIFT(3215),
  [7023] = {.count = 1, .reusable = true}, SHIFT(3218),
  [7025] = {.count = 1, .reusable = true}, SHIFT(3216),
  [7027] = {.count = 1, .reusable = true}, SHIFT(3217),
  [7029] = {.count = 1, .reusable = true}, SHIFT(3219),
  [7031] = {.count = 1, .reusable = true}, SHIFT(3220),
  [7033] = {.count = 1, .reusable = true}, SHIFT(3221),
  [7035] = {.count = 1, .reusable = true}, SHIFT(3222),
  [7037] = {.count = 1, .reusable = true}, SHIFT(3223),
  [7039] = {.count = 1, .reusable = true}, SHIFT(3224),
  [7041] = {.count = 1, .reusable = true}, SHIFT(3225),
  [7043] = {.count = 1, .reusable = true}, SHIFT(3226),
  [7045] = {.count = 1, .reusable = true}, SHIFT(3227),
  [7047] = {.count = 1, .reusable = true}, SHIFT(3228),
  [7049] = {.count = 1, .reusable = true}, SHIFT(3229),
  [7051] = {.count = 1, .reusable = true}, SHIFT(3230),
  [7053] = {.count = 1, .reusable = true}, SHIFT(3231),
  [7055] = {.count = 1, .reusable = true}, SHIFT(3232),
  [7057] = {.count = 1, .reusable = true}, SHIFT(3233),
  [7059] = {.count = 1, .reusable = true}, SHIFT(3234),
  [7061] = {.count = 1, .reusable = true}, SHIFT(3235),
  [7063] = {.count = 1, .reusable = true}, SHIFT(3236),
  [7065] = {.count = 1, .reusable = false}, SHIFT(3237),
  [7067] = {.count = 1, .reusable = true}, SHIFT(3238),
  [7069] = {.count = 1, .reusable = true}, SHIFT(3239),
  [7071] = {.count = 1, .reusable = true}, SHIFT(3240),
  [7073] = {.count = 1, .reusable = false}, SHIFT(3241),
  [7075] = {.count = 1, .reusable = false}, SHIFT(3242),
  [7077] = {.count = 1, .reusable = false}, SHIFT(3243),
  [7079] = {.count = 1, .reusable = false}, SHIFT(3244),
  [7081] = {.count = 1, .reusable = true}, SHIFT(3245),
  [7083] = {.count = 1, .reusable = true}, SHIFT(3255),
  [7085] = {.count = 1, .reusable = true}, SHIFT(3256),
  [7087] = {.count = 1, .reusable = true}, SHIFT(3257),
  [7089] = {.count = 1, .reusable = true}, REDUCE(sym_match_pattern, 4),
  [7091] = {.count = 1, .reusable = true}, SHIFT(3259),
  [7093] = {.count = 1, .reusable = true}, SHIFT(3261),
  [7095] = {.count = 1, .reusable = false}, SHIFT(3260),
  [7097] = {.count = 1, .reusable = true}, SHIFT(3262),
  [7099] = {.count = 1, .reusable = true}, SHIFT(3263),
  [7101] = {.count = 1, .reusable = true}, REDUCE(sym_static_item, 7),
  [7103] = {.count = 1, .reusable = false}, REDUCE(sym_static_item, 7),
  [7105] = {.count = 1, .reusable = true}, SHIFT(3264),
  [7107] = {.count = 1, .reusable = true}, SHIFT(3265),
  [7109] = {.count = 1, .reusable = false}, REDUCE(sym_visibility_modifier, 4),
  [7111] = {.count = 1, .reusable = true}, REDUCE(sym_ordered_field_declaration_list, 5),
  [7113] = {.count = 1, .reusable = true}, SHIFT(3266),
  [7115] = {.count = 1, .reusable = true}, REDUCE(aux_sym_ordered_field_declaration_list_repeat1, 3),
  [7117] = {.count = 1, .reusable = true}, SHIFT(3268),
  [7119] = {.count = 1, .reusable = false}, SHIFT(3269),
  [7121] = {.count = 1, .reusable = true}, SHIFT(3270),
  [7123] = {.count = 1, .reusable = true}, SHIFT(3271),
  [7125] = {.count = 1, .reusable = true}, REDUCE(aux_sym_field_declaration_list_repeat1, 3),
  [7127] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration_list, 5),
  [7129] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration_list, 5),
  [7131] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration, 4, .alias_sequence_id = 17),
  [7133] = {.count = 1, .reusable = true}, SHIFT(3274),
  [7135] = {.count = 1, .reusable = true}, SHIFT(3276),
  [7137] = {.count = 1, .reusable = false}, SHIFT(3277),
  [7139] = {.count = 1, .reusable = true}, SHIFT(3278),
  [7141] = {.count = 1, .reusable = true}, SHIFT(3279),
  [7143] = {.count = 1, .reusable = true}, SHIFT(3283),
  [7145] = {.count = 1, .reusable = false}, SHIFT(3284),
  [7147] = {.count = 1, .reusable = false}, SHIFT(3290),
  [7149] = {.count = 1, .reusable = false}, SHIFT(3291),
  [7151] = {.count = 1, .reusable = true}, SHIFT(3293),
  [7153] = {.count = 1, .reusable = true}, SHIFT(3295),
  [7155] = {.count = 2, .reusable = true}, REDUCE(aux_sym_where_clause_repeat1, 2), SHIFT_REPEAT(3296),
  [7158] = {.count = 1, .reusable = true}, REDUCE(sym_struct_item, 7, .alias_sequence_id = 2),
  [7160] = {.count = 1, .reusable = false}, REDUCE(sym_struct_item, 7, .alias_sequence_id = 2),
  [7162] = {.count = 1, .reusable = true}, SHIFT(3297),
  [7164] = {.count = 1, .reusable = true}, SHIFT(3298),
  [7166] = {.count = 1, .reusable = true}, REDUCE(sym_impl_item, 7, .alias_sequence_id = 14),
  [7168] = {.count = 1, .reusable = false}, REDUCE(sym_impl_item, 7, .alias_sequence_id = 14),
  [7170] = {.count = 1, .reusable = true}, SHIFT(3301),
  [7172] = {.count = 1, .reusable = true}, SHIFT(1134),
  [7174] = {.count = 1, .reusable = false}, SHIFT(3302),
  [7176] = {.count = 1, .reusable = true}, SHIFT(3303),
  [7178] = {.count = 1, .reusable = true}, SHIFT(3304),
  [7180] = {.count = 2, .reusable = true}, REDUCE(sym_token_tree, 4), REDUCE(sym_tuple_expression, 4),
  [7183] = {.count = 2, .reusable = false}, REDUCE(sym_token_tree, 4), REDUCE(sym_tuple_expression, 4),
  [7186] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat2, 2), SHIFT(1391),
  [7189] = {.count = 2, .reusable = true}, REDUCE(aux_sym_token_tree_repeat2, 2), SHIFT(1392),
  [7192] = {.count = 1, .reusable = true}, SHIFT(3307),
  [7194] = {.count = 2, .reusable = true}, REDUCE(sym_token_tree, 4), REDUCE(sym_block, 4),
  [7197] = {.count = 2, .reusable = false}, REDUCE(sym_token_tree, 4), REDUCE(sym_block, 4),
  [7200] = {.count = 1, .reusable = true}, SHIFT(3308),
  [7202] = {.count = 1, .reusable = true}, SHIFT(3309),
  [7204] = {.count = 1, .reusable = true}, SHIFT(3310),
  [7206] = {.count = 1, .reusable = true}, SHIFT(3311),
  [7208] = {.count = 2, .reusable = true}, REDUCE(sym_token_tree, 4), REDUCE(sym_array_expression, 4),
  [7211] = {.count = 2, .reusable = false}, REDUCE(sym_token_tree, 4), REDUCE(sym_array_expression, 4),
  [7214] = {.count = 1, .reusable = true}, SHIFT(3312),
  [7216] = {.count = 1, .reusable = true}, SHIFT(3313),
  [7218] = {.count = 1, .reusable = true}, REDUCE(sym_token_repetition, 4),
  [7220] = {.count = 1, .reusable = false}, REDUCE(sym_token_repetition, 4),
  [7222] = {.count = 1, .reusable = false}, SHIFT(3314),
  [7224] = {.count = 1, .reusable = false}, SHIFT(3313),
  [7226] = {.count = 1, .reusable = true}, REDUCE(sym_token_tree, 5),
  [7228] = {.count = 1, .reusable = false}, REDUCE(sym_token_tree, 5),
  [7230] = {.count = 1, .reusable = true}, SHIFT(3315),
  [7232] = {.count = 1, .reusable = true}, SHIFT(3316),
  [7234] = {.count = 1, .reusable = true}, SHIFT(3318),
  [7236] = {.count = 1, .reusable = true}, SHIFT(3319),
  [7238] = {.count = 1, .reusable = true}, SHIFT(3320),
  [7240] = {.count = 1, .reusable = true}, SHIFT(3321),
  [7242] = {.count = 1, .reusable = true}, SHIFT(3322),
  [7244] = {.count = 1, .reusable = true}, SHIFT(3326),
  [7246] = {.count = 1, .reusable = true}, SHIFT(3334),
  [7248] = {.count = 1, .reusable = true}, SHIFT(3335),
  [7250] = {.count = 1, .reusable = true}, SHIFT(3336),
  [7252] = {.count = 1, .reusable = true}, SHIFT(3337),
  [7254] = {.count = 1, .reusable = true}, SHIFT(3338),
  [7256] = {.count = 1, .reusable = true}, SHIFT(3339),
  [7258] = {.count = 1, .reusable = true}, SHIFT(3340),
  [7260] = {.count = 1, .reusable = true}, SHIFT(3342),
  [7262] = {.count = 1, .reusable = true}, SHIFT(3343),
  [7264] = {.count = 1, .reusable = true}, SHIFT(3348),
  [7266] = {.count = 1, .reusable = true}, SHIFT(3349),
  [7268] = {.count = 1, .reusable = true}, SHIFT(3350),
  [7270] = {.count = 1, .reusable = true}, SHIFT(3353),
  [7272] = {.count = 1, .reusable = true}, SHIFT(3357),
  [7274] = {.count = 1, .reusable = true}, SHIFT(3359),
  [7276] = {.count = 1, .reusable = true}, SHIFT(3361),
  [7278] = {.count = 1, .reusable = true}, SHIFT(3363),
  [7280] = {.count = 1, .reusable = true}, SHIFT(3364),
  [7282] = {.count = 1, .reusable = true}, REDUCE(sym_struct_item, 7, .alias_sequence_id = 6),
  [7284] = {.count = 1, .reusable = false}, REDUCE(sym_struct_item, 7, .alias_sequence_id = 6),
  [7286] = {.count = 1, .reusable = true}, SHIFT(3365),
  [7288] = {.count = 1, .reusable = true}, REDUCE(sym_type_item, 7, .alias_sequence_id = 6),
  [7290] = {.count = 1, .reusable = false}, REDUCE(sym_type_item, 7, .alias_sequence_id = 6),
  [7292] = {.count = 1, .reusable = true}, REDUCE(sym_union_item, 7, .alias_sequence_id = 6),
  [7294] = {.count = 1, .reusable = false}, REDUCE(sym_union_item, 7, .alias_sequence_id = 6),
  [7296] = {.count = 1, .reusable = true}, REDUCE(sym_extern_crate_declaration, 7),
  [7298] = {.count = 1, .reusable = false}, REDUCE(sym_extern_crate_declaration, 7),
  [7300] = {.count = 1, .reusable = true}, SHIFT(3369),
  [7302] = {.count = 1, .reusable = true}, SHIFT(3370),
  [7304] = {.count = 1, .reusable = false}, REDUCE(sym_tuple_type, 5),
  [7306] = {.count = 1, .reusable = false}, REDUCE(sym_array_type, 5),
  [7308] = {.count = 1, .reusable = false}, REDUCE(sym_parameters, 4),
  [7310] = {.count = 1, .reusable = true}, SHIFT(3371),
  [7312] = {.count = 1, .reusable = false}, REDUCE(sym_function_type, 5),
  [7314] = {.count = 1, .reusable = false}, REDUCE(sym_function_type, 5, .alias_sequence_id = 2),
  [7316] = {.count = 1, .reusable = true}, REDUCE(sym_for_expression, 7),
  [7318] = {.count = 1, .reusable = false}, REDUCE(sym_for_expression, 7),
  [7320] = {.count = 1, .reusable = true}, SHIFT(3373),
  [7322] = {.count = 1, .reusable = true}, REDUCE(sym_token_repetition_pattern, 4),
  [7324] = {.count = 1, .reusable = false}, REDUCE(sym_token_repetition_pattern, 4),
  [7326] = {.count = 1, .reusable = false}, SHIFT(3374),
  [7328] = {.count = 1, .reusable = false}, SHIFT(3373),
  [7330] = {.count = 1, .reusable = true}, SHIFT(3375),
  [7332] = {.count = 1, .reusable = true}, SHIFT(3376),
  [7334] = {.count = 1, .reusable = true}, SHIFT(3377),
  [7336] = {.count = 1, .reusable = false}, SHIFT(3378),
  [7338] = {.count = 1, .reusable = false}, SHIFT(3382),
  [7340] = {.count = 1, .reusable = false}, SHIFT(3383),
  [7342] = {.count = 1, .reusable = true}, SHIFT(3386),
  [7344] = {.count = 1, .reusable = true}, SHIFT(3389),
  [7346] = {.count = 1, .reusable = true}, SHIFT(3390),
  [7348] = {.count = 1, .reusable = true}, REDUCE(sym_meta_item, 6),
  [7350] = {.count = 1, .reusable = true}, REDUCE(sym_field_pattern, 5, .alias_sequence_id = 9),
  [7352] = {.count = 1, .reusable = true}, SHIFT(3391),
  [7354] = {.count = 1, .reusable = true}, SHIFT(3392),
  [7356] = {.count = 1, .reusable = true}, REDUCE(sym_enum_variant, 5),
  [7358] = {.count = 1, .reusable = true}, REDUCE(sym_enum_variant_list, 6),
  [7360] = {.count = 1, .reusable = false}, REDUCE(sym_enum_variant_list, 6),
  [7362] = {.count = 1, .reusable = true}, SHIFT(3393),
  [7364] = {.count = 1, .reusable = true}, SHIFT(3394),
  [7366] = {.count = 2, .reusable = true}, REDUCE(aux_sym_trait_bounds_repeat1, 2), SHIFT_REPEAT(2751),
  [7369] = {.count = 1, .reusable = true}, REDUCE(sym_function_signature_item, 8),
  [7371] = {.count = 1, .reusable = false}, REDUCE(sym_function_signature_item, 8),
  [7373] = {.count = 1, .reusable = true}, REDUCE(sym_function_item, 8),
  [7375] = {.count = 1, .reusable = false}, REDUCE(sym_function_item, 8),
  [7377] = {.count = 1, .reusable = true}, SHIFT(3396),
  [7379] = {.count = 1, .reusable = false}, SHIFT(3397),
  [7381] = {.count = 1, .reusable = true}, SHIFT(3398),
  [7383] = {.count = 1, .reusable = true}, SHIFT(3399),
  [7385] = {.count = 1, .reusable = true}, REDUCE(sym_let_declaration, 8),
  [7387] = {.count = 1, .reusable = false}, REDUCE(sym_let_declaration, 8),
  [7389] = {.count = 1, .reusable = true}, SHIFT(3403),
  [7391] = {.count = 1, .reusable = true}, SHIFT(3404),
  [7393] = {.count = 1, .reusable = true}, SHIFT(3405),
  [7395] = {.count = 1, .reusable = true}, SHIFT(3406),
  [7397] = {.count = 1, .reusable = true}, SHIFT(3407),
  [7399] = {.count = 1, .reusable = true}, SHIFT(3408),
  [7401] = {.count = 1, .reusable = false}, SHIFT(3409),
  [7403] = {.count = 1, .reusable = true}, SHIFT(3411),
  [7405] = {.count = 1, .reusable = true}, SHIFT(3414),
  [7407] = {.count = 1, .reusable = true}, SHIFT(3415),
  [7409] = {.count = 1, .reusable = false}, SHIFT(3415),
  [7411] = {.count = 1, .reusable = true}, SHIFT(3418),
  [7413] = {.count = 1, .reusable = false}, SHIFT(3417),
  [7415] = {.count = 1, .reusable = true}, SHIFT(3420),
  [7417] = {.count = 1, .reusable = true}, SHIFT(3419),
  [7419] = {.count = 1, .reusable = true}, SHIFT(3422),
  [7421] = {.count = 1, .reusable = true}, SHIFT(3423),
  [7423] = {.count = 1, .reusable = true}, SHIFT(3424),
  [7425] = {.count = 1, .reusable = true}, SHIFT(3425),
  [7427] = {.count = 1, .reusable = true}, SHIFT(3426),
  [7429] = {.count = 1, .reusable = true}, SHIFT(3427),
  [7431] = {.count = 1, .reusable = true}, SHIFT(3428),
  [7433] = {.count = 1, .reusable = true}, SHIFT(3430),
  [7435] = {.count = 1, .reusable = true}, SHIFT(3433),
  [7437] = {.count = 1, .reusable = true}, SHIFT(3435),
  [7439] = {.count = 1, .reusable = true}, SHIFT(3436),
  [7441] = {.count = 1, .reusable = true}, SHIFT(3437),
  [7443] = {.count = 1, .reusable = true}, SHIFT(3439),
  [7445] = {.count = 1, .reusable = true}, SHIFT(3446),
  [7447] = {.count = 1, .reusable = true}, SHIFT(3444),
  [7449] = {.count = 1, .reusable = false}, SHIFT(3446),
  [7451] = {.count = 1, .reusable = true}, SHIFT(3449),
  [7453] = {.count = 1, .reusable = false}, SHIFT(3449),
  [7455] = {.count = 1, .reusable = true}, SHIFT(3451),
  [7457] = {.count = 1, .reusable = false}, SHIFT(3451),
  [7459] = {.count = 1, .reusable = true}, SHIFT(3452),
  [7461] = {.count = 1, .reusable = true}, SHIFT(3453),
  [7463] = {.count = 1, .reusable = true}, SHIFT(3455),
  [7465] = {.count = 1, .reusable = true}, SHIFT(3456),
  [7467] = {.count = 1, .reusable = true}, SHIFT(3459),
  [7469] = {.count = 1, .reusable = true}, SHIFT(3460),
  [7471] = {.count = 1, .reusable = false}, SHIFT(3461),
  [7473] = {.count = 1, .reusable = true}, SHIFT(3464),
  [7475] = {.count = 1, .reusable = true}, SHIFT(3465),
  [7477] = {.count = 1, .reusable = false}, SHIFT(3467),
  [7479] = {.count = 1, .reusable = false}, SHIFT(3468),
  [7481] = {.count = 1, .reusable = true}, SHIFT(3244),
  [7483] = {.count = 1, .reusable = true}, SHIFT(3471),
  [7485] = {.count = 1, .reusable = false}, SHIFT(3207),
  [7487] = {.count = 1, .reusable = true}, SHIFT(3474),
  [7489] = {.count = 1, .reusable = false}, SHIFT(3475),
  [7491] = {.count = 1, .reusable = false}, SHIFT(3476),
  [7493] = {.count = 1, .reusable = true}, SHIFT(3479),
  [7495] = {.count = 1, .reusable = true}, SHIFT(3480),
  [7497] = {.count = 1, .reusable = true}, SHIFT(3481),
  [7499] = {.count = 1, .reusable = true}, SHIFT(3482),
  [7501] = {.count = 1, .reusable = true}, SHIFT(3485),
  [7503] = {.count = 1, .reusable = false}, SHIFT(3485),
  [7505] = {.count = 1, .reusable = true}, SHIFT(3488),
  [7507] = {.count = 1, .reusable = false}, SHIFT(3487),
  [7509] = {.count = 1, .reusable = true}, REDUCE(sym_match_arm, 5),
  [7511] = {.count = 1, .reusable = true}, REDUCE(sym_last_match_arm, 5),
  [7513] = {.count = 1, .reusable = false}, REDUCE(sym_match_arm, 5),
  [7515] = {.count = 1, .reusable = true}, SHIFT(3490),
  [7517] = {.count = 1, .reusable = false}, SHIFT(3489),
  [7519] = {.count = 1, .reusable = true}, SHIFT(3491),
  [7521] = {.count = 1, .reusable = true}, SHIFT(3492),
  [7523] = {.count = 1, .reusable = true}, REDUCE(sym_static_item, 8),
  [7525] = {.count = 1, .reusable = false}, REDUCE(sym_static_item, 8),
  [7527] = {.count = 1, .reusable = false}, REDUCE(sym_visibility_modifier, 5, .alias_sequence_id = 13),
  [7529] = {.count = 1, .reusable = false}, REDUCE(sym_visibility_modifier, 5),
  [7531] = {.count = 1, .reusable = true}, REDUCE(sym_ordered_field_declaration_list, 6),
  [7533] = {.count = 1, .reusable = true}, REDUCE(aux_sym_ordered_field_declaration_list_repeat1, 4),
  [7535] = {.count = 1, .reusable = true}, SHIFT(3493),
  [7537] = {.count = 1, .reusable = true}, SHIFT(3494),
  [7539] = {.count = 1, .reusable = true}, SHIFT(3495),
  [7541] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration_list, 6),
  [7543] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration_list, 6),
  [7545] = {.count = 1, .reusable = true}, SHIFT(3496),
  [7547] = {.count = 1, .reusable = true}, SHIFT(3497),
  [7549] = {.count = 2, .reusable = true}, REDUCE(aux_sym_trait_bounds_repeat1, 2), SHIFT_REPEAT(2926),
  [7552] = {.count = 1, .reusable = true}, SHIFT(3499),
  [7554] = {.count = 1, .reusable = false}, SHIFT(3500),
  [7556] = {.count = 1, .reusable = true}, SHIFT(3501),
  [7558] = {.count = 1, .reusable = true}, SHIFT(3502),
  [7560] = {.count = 1, .reusable = true}, REDUCE(sym_impl_item, 8, .alias_sequence_id = 14),
  [7562] = {.count = 1, .reusable = false}, REDUCE(sym_impl_item, 8, .alias_sequence_id = 14),
  [7564] = {.count = 1, .reusable = true}, REDUCE(sym_impl_item, 8),
  [7566] = {.count = 1, .reusable = false}, REDUCE(sym_impl_item, 8),
  [7568] = {.count = 1, .reusable = true}, SHIFT(3507),
  [7570] = {.count = 1, .reusable = true}, SHIFT(3508),
  [7572] = {.count = 1, .reusable = true}, SHIFT(3509),
  [7574] = {.count = 2, .reusable = true}, REDUCE(sym_token_tree, 5), REDUCE(sym_array_expression, 5),
  [7577] = {.count = 2, .reusable = false}, REDUCE(sym_token_tree, 5), REDUCE(sym_array_expression, 5),
  [7580] = {.count = 1, .reusable = true}, REDUCE(sym_token_repetition, 5),
  [7582] = {.count = 1, .reusable = false}, REDUCE(sym_token_repetition, 5),
  [7584] = {.count = 1, .reusable = true}, SHIFT(3510),
  [7586] = {.count = 1, .reusable = true}, SHIFT(3511),
  [7588] = {.count = 1, .reusable = true}, SHIFT(3513),
  [7590] = {.count = 1, .reusable = true}, SHIFT(3514),
  [7592] = {.count = 1, .reusable = true}, SHIFT(3515),
  [7594] = {.count = 1, .reusable = true}, SHIFT(3516),
  [7596] = {.count = 1, .reusable = true}, SHIFT(3517),
  [7598] = {.count = 1, .reusable = true}, SHIFT(3522),
  [7600] = {.count = 1, .reusable = true}, SHIFT(3523),
  [7602] = {.count = 1, .reusable = true}, SHIFT(3524),
  [7604] = {.count = 1, .reusable = true}, SHIFT(3525),
  [7606] = {.count = 1, .reusable = true}, SHIFT(3526),
  [7608] = {.count = 1, .reusable = true}, SHIFT(3532),
  [7610] = {.count = 1, .reusable = true}, SHIFT(3533),
  [7612] = {.count = 1, .reusable = true}, SHIFT(3534),
  [7614] = {.count = 1, .reusable = true}, SHIFT(3536),
  [7616] = {.count = 1, .reusable = true}, SHIFT(3537),
  [7618] = {.count = 1, .reusable = true}, SHIFT(3538),
  [7620] = {.count = 1, .reusable = true}, SHIFT(3539),
  [7622] = {.count = 1, .reusable = true}, REDUCE(sym_const_item, 8),
  [7624] = {.count = 1, .reusable = false}, REDUCE(sym_const_item, 8),
  [7626] = {.count = 1, .reusable = true}, SHIFT(3540),
  [7628] = {.count = 1, .reusable = true}, REDUCE(sym_struct_item, 8, .alias_sequence_id = 6),
  [7630] = {.count = 1, .reusable = false}, REDUCE(sym_struct_item, 8, .alias_sequence_id = 6),
  [7632] = {.count = 1, .reusable = false}, REDUCE(sym_parameters, 5),
  [7634] = {.count = 1, .reusable = true}, REDUCE(sym_while_let_expression, 8),
  [7636] = {.count = 1, .reusable = false}, REDUCE(sym_while_let_expression, 8),
  [7638] = {.count = 1, .reusable = true}, REDUCE(sym_token_repetition_pattern, 5),
  [7640] = {.count = 1, .reusable = false}, REDUCE(sym_token_repetition_pattern, 5),
  [7642] = {.count = 1, .reusable = true}, SHIFT(3542),
  [7644] = {.count = 1, .reusable = true}, SHIFT(3543),
  [7646] = {.count = 1, .reusable = true}, SHIFT(2058),
  [7648] = {.count = 1, .reusable = false}, SHIFT(3544),
  [7650] = {.count = 1, .reusable = true}, SHIFT(3545),
  [7652] = {.count = 1, .reusable = true}, SHIFT(3546),
  [7654] = {.count = 1, .reusable = true}, SHIFT(3549),
  [7656] = {.count = 1, .reusable = true}, SHIFT(3550),
  [7658] = {.count = 1, .reusable = true}, SHIFT(3551),
  [7660] = {.count = 2, .reusable = true}, REDUCE(aux_sym_trait_bounds_repeat1, 2), SHIFT_REPEAT(3158),
  [7663] = {.count = 1, .reusable = true}, SHIFT(3553),
  [7665] = {.count = 1, .reusable = true}, SHIFT(2318),
  [7667] = {.count = 1, .reusable = true}, SHIFT(3555),
  [7669] = {.count = 1, .reusable = true}, SHIFT(3557),
  [7671] = {.count = 1, .reusable = true}, SHIFT(3558),
  [7673] = {.count = 1, .reusable = true}, SHIFT(3559),
  [7675] = {.count = 1, .reusable = false}, SHIFT(3559),
  [7677] = {.count = 1, .reusable = true}, SHIFT(3561),
  [7679] = {.count = 1, .reusable = true}, SHIFT(3562),
  [7681] = {.count = 1, .reusable = true}, SHIFT(3563),
  [7683] = {.count = 1, .reusable = true}, SHIFT(3565),
  [7685] = {.count = 1, .reusable = true}, SHIFT(2339),
  [7687] = {.count = 1, .reusable = true}, SHIFT(3567),
  [7689] = {.count = 1, .reusable = true}, SHIFT(3569),
  [7691] = {.count = 1, .reusable = true}, SHIFT(3571),
  [7693] = {.count = 1, .reusable = true}, SHIFT(3572),
  [7695] = {.count = 1, .reusable = true}, SHIFT(3573),
  [7697] = {.count = 1, .reusable = true}, SHIFT(3574),
  [7699] = {.count = 1, .reusable = true}, SHIFT(3575),
  [7701] = {.count = 1, .reusable = true}, SHIFT(3576),
  [7703] = {.count = 1, .reusable = true}, SHIFT(3578),
  [7705] = {.count = 1, .reusable = true}, SHIFT(3579),
  [7707] = {.count = 1, .reusable = true}, SHIFT(3581),
  [7709] = {.count = 1, .reusable = true}, SHIFT(3582),
  [7711] = {.count = 1, .reusable = true}, SHIFT(3583),
  [7713] = {.count = 1, .reusable = true}, SHIFT(3585),
  [7715] = {.count = 1, .reusable = true}, SHIFT(3586),
  [7717] = {.count = 1, .reusable = true}, SHIFT(3587),
  [7719] = {.count = 1, .reusable = true}, SHIFT(3588),
  [7721] = {.count = 1, .reusable = true}, SHIFT(3590),
  [7723] = {.count = 1, .reusable = true}, SHIFT(3591),
  [7725] = {.count = 1, .reusable = true}, SHIFT(3593),
  [7727] = {.count = 1, .reusable = false}, SHIFT(3595),
  [7729] = {.count = 1, .reusable = true}, SHIFT(3596),
  [7731] = {.count = 1, .reusable = true}, SHIFT(3597),
  [7733] = {.count = 1, .reusable = false}, SHIFT(3598),
  [7735] = {.count = 1, .reusable = true}, SHIFT(3601),
  [7737] = {.count = 1, .reusable = true}, SHIFT(3602),
  [7739] = {.count = 1, .reusable = true}, SHIFT(3603),
  [7741] = {.count = 1, .reusable = true}, SHIFT(3606),
  [7743] = {.count = 1, .reusable = true}, SHIFT(3608),
  [7745] = {.count = 1, .reusable = true}, SHIFT(3609),
  [7747] = {.count = 1, .reusable = true}, SHIFT(3610),
  [7749] = {.count = 1, .reusable = true}, SHIFT(3611),
  [7751] = {.count = 1, .reusable = false}, SHIFT(3611),
  [7753] = {.count = 1, .reusable = true}, SHIFT(3613),
  [7755] = {.count = 1, .reusable = false}, SHIFT(3613),
  [7757] = {.count = 1, .reusable = true}, SHIFT(3615),
  [7759] = {.count = 1, .reusable = true}, REDUCE(sym_ordered_field_declaration_list, 7),
  [7761] = {.count = 1, .reusable = true}, SHIFT(3616),
  [7763] = {.count = 1, .reusable = true}, SHIFT(3617),
  [7765] = {.count = 2, .reusable = true}, REDUCE(aux_sym_trait_bounds_repeat1, 2), SHIFT_REPEAT(3293),
  [7768] = {.count = 1, .reusable = true}, REDUCE(sym_token_repetition, 6),
  [7770] = {.count = 1, .reusable = false}, REDUCE(sym_token_repetition, 6),
  [7772] = {.count = 1, .reusable = true}, REDUCE(sym_function_signature_item, 9),
  [7774] = {.count = 1, .reusable = false}, REDUCE(sym_function_signature_item, 9),
  [7776] = {.count = 1, .reusable = true}, REDUCE(sym_function_item, 9),
  [7778] = {.count = 1, .reusable = false}, REDUCE(sym_function_item, 9),
  [7780] = {.count = 1, .reusable = true}, SHIFT(3618),
  [7782] = {.count = 1, .reusable = true}, SHIFT(3619),
  [7784] = {.count = 1, .reusable = true}, SHIFT(3621),
  [7786] = {.count = 1, .reusable = true}, SHIFT(3622),
  [7788] = {.count = 1, .reusable = true}, SHIFT(3626),
  [7790] = {.count = 1, .reusable = true}, SHIFT(3627),
  [7792] = {.count = 1, .reusable = true}, SHIFT(3628),
  [7794] = {.count = 1, .reusable = true}, REDUCE(sym_static_item, 9),
  [7796] = {.count = 1, .reusable = false}, REDUCE(sym_static_item, 9),
  [7798] = {.count = 1, .reusable = true}, SHIFT(3631),
  [7800] = {.count = 1, .reusable = true}, REDUCE(sym_token_repetition_pattern, 6),
  [7802] = {.count = 1, .reusable = false}, REDUCE(sym_token_repetition_pattern, 6),
  [7804] = {.count = 1, .reusable = true}, SHIFT(3634),
  [7806] = {.count = 1, .reusable = true}, SHIFT(3635),
  [7808] = {.count = 1, .reusable = true}, SHIFT(3637),
  [7810] = {.count = 1, .reusable = true}, SHIFT(3639),
  [7812] = {.count = 1, .reusable = true}, SHIFT(3640),
  [7814] = {.count = 1, .reusable = true}, SHIFT(3641),
  [7816] = {.count = 1, .reusable = true}, SHIFT(3643),
  [7818] = {.count = 1, .reusable = true}, SHIFT(3645),
  [7820] = {.count = 1, .reusable = true}, SHIFT(3646),
  [7822] = {.count = 1, .reusable = true}, SHIFT(3647),
  [7824] = {.count = 1, .reusable = true}, SHIFT(3648),
  [7826] = {.count = 1, .reusable = true}, SHIFT(3649),
  [7828] = {.count = 1, .reusable = true}, SHIFT(3650),
  [7830] = {.count = 1, .reusable = true}, SHIFT(3651),
  [7832] = {.count = 1, .reusable = true}, SHIFT(3652),
  [7834] = {.count = 1, .reusable = true}, SHIFT(3653),
  [7836] = {.count = 1, .reusable = true}, SHIFT(3654),
  [7838] = {.count = 1, .reusable = true}, SHIFT(3655),
  [7840] = {.count = 1, .reusable = true}, SHIFT(3657),
  [7842] = {.count = 1, .reusable = true}, SHIFT(3658),
  [7844] = {.count = 1, .reusable = false}, SHIFT(3660),
  [7846] = {.count = 1, .reusable = true}, SHIFT(3665),
  [7848] = {.count = 1, .reusable = true}, SHIFT(3666),
  [7850] = {.count = 1, .reusable = true}, SHIFT(3667),
  [7852] = {.count = 1, .reusable = true}, SHIFT(3668),
  [7854] = {.count = 1, .reusable = true}, SHIFT(3669),
  [7856] = {.count = 1, .reusable = true}, SHIFT(3670),
  [7858] = {.count = 1, .reusable = false}, SHIFT(3671),
  [7860] = {.count = 1, .reusable = true}, SHIFT(3672),
  [7862] = {.count = 1, .reusable = true}, SHIFT(3674),
  [7864] = {.count = 1, .reusable = true}, REDUCE(sym_function_signature_item, 10),
  [7866] = {.count = 1, .reusable = false}, REDUCE(sym_function_signature_item, 10),
  [7868] = {.count = 1, .reusable = true}, REDUCE(sym_function_item, 10),
  [7870] = {.count = 1, .reusable = false}, REDUCE(sym_function_item, 10),
  [7872] = {.count = 1, .reusable = true}, SHIFT(3678),
  [7874] = {.count = 1, .reusable = true}, SHIFT(3680),
  [7876] = {.count = 1, .reusable = true}, SHIFT(3681),
  [7878] = {.count = 1, .reusable = true}, SHIFT(3682),
  [7880] = {.count = 1, .reusable = true}, SHIFT(3683),
  [7882] = {.count = 1, .reusable = true}, SHIFT(3684),
  [7884] = {.count = 1, .reusable = true}, SHIFT(3685),
  [7886] = {.count = 1, .reusable = false}, SHIFT(3686),
  [7888] = {.count = 1, .reusable = true}, SHIFT(3694),
  [7890] = {.count = 1, .reusable = true}, SHIFT(3695),
  [7892] = {.count = 1, .reusable = true}, SHIFT(3260),
  [7894] = {.count = 1, .reusable = true}, SHIFT(3696),
  [7896] = {.count = 1, .reusable = true}, SHIFT(3699),
};

void *tree_sitter_rust_external_scanner_create();
void tree_sitter_rust_external_scanner_destroy(void *);
bool tree_sitter_rust_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_rust_external_scanner_serialize(void *, char *);
void tree_sitter_rust_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_rust() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_rust_external_scanner_create,
      tree_sitter_rust_external_scanner_destroy,
      tree_sitter_rust_external_scanner_scan,
      tree_sitter_rust_external_scanner_serialize,
      tree_sitter_rust_external_scanner_deserialize,
    },
  };
  return &language;
}
